// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley;

import android.os.Process;
import java.util.concurrent.BlockingQueue;

public class CacheDispatcher extends Thread {
    private static final boolean DEBUG;
    private final Cache mCache;
    private final BlockingQueue mCacheQueue;
    private final ResponseDelivery mDelivery;
    private final BlockingQueue mNetworkQueue;
    private volatile boolean mQuit;

    static {
        CacheDispatcher.DEBUG = VolleyLog.DEBUG;
    }

    public CacheDispatcher(BlockingQueue arg2, BlockingQueue arg3, Cache arg4, ResponseDelivery arg5) {
        super();
        this.mQuit = false;
        this.mCacheQueue = arg2;
        this.mNetworkQueue = arg3;
        this.mCache = arg4;
        this.mDelivery = arg5;
    }

    static BlockingQueue access$000(CacheDispatcher arg1) {
        return arg1.mNetworkQueue;
    }

    public void quit() {
        this.mQuit = true;
        this.interrupt();
    }

    public void run() {
        if(CacheDispatcher.DEBUG) {
            VolleyLog.v("start new dispatcher", new Object[0]);
        }

        Process.setThreadPriority(10);
        this.mCache.initialize();
        try {
            do {
            label_10:
                Object v0_1 = this.mCacheQueue.take();
                ((Request)v0_1).addMarker("cache-queue-take");
                if(((Request)v0_1).isCanceled()) {
                    ((Request)v0_1).finish("cache-discard-canceled");
                    continue;
                }

                Cache$Entry v1 = this.mCache.get(((Request)v0_1).getCacheKey());
                if(v1 == null) {
                    ((Request)v0_1).addMarker("cache-miss");
                    this.mNetworkQueue.put(v0_1);
                    continue;
                }

                if(v1.isExpired()) {
                    ((Request)v0_1).addMarker("cache-hit-expired");
                    ((Request)v0_1).setCacheEntry(v1);
                    this.mNetworkQueue.put(v0_1);
                    continue;
                }

                ((Request)v0_1).addMarker("cache-hit");
                Response v2 = ((Request)v0_1).parseNetworkResponse(new NetworkResponse(v1.data, v1.responseHeaders));
                ((Request)v0_1).addMarker("cache-hit-parsed");
                if(!v1.refreshNeeded()) {
                    this.mDelivery.postResponse(((Request)v0_1), v2);
                    continue;
                }

                ((Request)v0_1).addMarker("cache-hit-refresh-needed");
                ((Request)v0_1).setCacheEntry(v1);
                v2.intermediate = true;
                this.mDelivery.postResponse(((Request)v0_1), v2, new CacheDispatcher$1(this, ((Request)v0_1)));
            }
            while(true);
        }
        catch(InterruptedException v0) {
            if(!this.mQuit) {
                goto label_10;
            }

            return;
        }
    }
}

