// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley;

import android.net.Uri;
import android.os.Handler;
import android.os.Looper;
import android.os.SystemClock;
import android.text.TextUtils;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Collections;
import java.util.Iterator;
import java.util.Map;
import java.util.Map$Entry;

public abstract class Request implements Comparable {
    private static final String DEFAULT_PARAMS_ENCODING = "UTF-8";
    private static final long SLOW_REQUEST_THRESHOLD_MS = 3000;
    private Cache$Entry mCacheEntry;
    private boolean mCanceled;
    private final int mDefaultTrafficStatsTag;
    private final Response$ErrorListener mErrorListener;
    private final VolleyLog$MarkerLog mEventLog;
    private final int mMethod;
    private long mRequestBirthTime;
    private RequestQueue mRequestQueue;
    private boolean mResponseDelivered;
    private RetryPolicy mRetryPolicy;
    private Integer mSequence;
    private boolean mShouldCache;
    private Object mTag;
    private final String mUrl;

    public Request(int arg5, String arg6, Response$ErrorListener arg7) {
        Cache$Entry v1 = null;
        super();
        VolleyLog$MarkerLog v0 = VolleyLog$MarkerLog.ENABLED ? new VolleyLog$MarkerLog() : ((VolleyLog$MarkerLog)v1);
        this.mEventLog = v0;
        this.mShouldCache = true;
        this.mCanceled = false;
        this.mResponseDelivered = false;
        this.mRequestBirthTime = 0;
        this.mCacheEntry = v1;
        this.mMethod = arg5;
        this.mUrl = arg6;
        this.mErrorListener = arg7;
        this.setRetryPolicy(new DefaultRetryPolicy());
        this.mDefaultTrafficStatsTag = Request.findDefaultTrafficStatsTag(arg6);
    }

    @Deprecated public Request(String arg2, Response$ErrorListener arg3) {
        this(-1, arg2, arg3);
    }

    static VolleyLog$MarkerLog access$000(Request arg1) {
        return arg1.mEventLog;
    }

    public void addMarker(String arg5) {
        if(VolleyLog$MarkerLog.ENABLED) {
            this.mEventLog.add(arg5, Thread.currentThread().getId());
        }
        else if(this.mRequestBirthTime == 0) {
            this.mRequestBirthTime = SystemClock.elapsedRealtime();
        }
    }

    public void cancel() {
        this.mCanceled = true;
    }

    public int compareTo(Request arg3) {
        Request$Priority v0 = this.getPriority();
        Request$Priority v1 = arg3.getPriority();
        int v0_1 = v0 == v1 ? this.mSequence.intValue() - arg3.mSequence.intValue() : v1.ordinal() - v0.ordinal();
        return v0_1;
    }

    public int compareTo(Object arg2) {
        return this.compareTo(((Request)arg2));
    }

    public void deliverError(VolleyError arg2) {
        if(this.mErrorListener != null) {
            this.mErrorListener.onErrorResponse(arg2);
        }
    }

    public abstract void deliverResponse(Object arg1);

    private byte[] encodeParameters(Map arg5, String arg6) {
        StringBuilder v2 = new StringBuilder();
        try {
            Iterator v3 = arg5.entrySet().iterator();
            while(v3.hasNext()) {
                Object v0_1 = v3.next();
                v2.append(URLEncoder.encode(((Map$Entry)v0_1).getKey(), arg6));
                v2.append('=');
                v2.append(URLEncoder.encode(((Map$Entry)v0_1).getValue(), arg6));
                v2.append('&');
            }

            return v2.toString().getBytes(arg6);
        }
        catch(UnsupportedEncodingException v0) {
            throw new RuntimeException("Encoding not supported: " + arg6, ((Throwable)v0));
        }
    }

    private static int findDefaultTrafficStatsTag(String arg1) {
        int v0_2;
        if(!TextUtils.isEmpty(((CharSequence)arg1))) {
            Uri v0 = Uri.parse(arg1);
            if(v0 != null) {
                String v0_1 = v0.getHost();
                if(v0_1 != null) {
                    v0_2 = v0_1.hashCode();
                }
                else {
                    goto label_8;
                }
            }
            else {
                goto label_8;
            }
        }
        else {
        label_8:
            v0_2 = 0;
        }

        return v0_2;
    }

    void finish(String arg6) {
        long v0;
        if(this.mRequestQueue != null) {
            this.mRequestQueue.finish(this);
        }

        if(VolleyLog$MarkerLog.ENABLED) {
            v0 = Thread.currentThread().getId();
            if(Looper.myLooper() != Looper.getMainLooper()) {
                new Handler(Looper.getMainLooper()).post(new Request$1(this, arg6, v0));
            }
            else {
                this.mEventLog.add(arg6, v0);
                this.mEventLog.finish(this.toString());
            }
        }
        else {
            v0 = SystemClock.elapsedRealtime() - this.mRequestBirthTime;
            if(v0 >= 3000) {
                VolleyLog.d("%d ms: %s", new Object[]{Long.valueOf(v0), this.toString()});
            }
        }
    }

    public byte[] getBody() {
        Map v0 = this.getParams();
        byte[] v0_1 = v0 == null || v0.size() <= 0 ? null : this.encodeParameters(v0, this.getParamsEncoding());
        return v0_1;
    }

    public String getBodyContentType() {
        return "application/x-www-form-urlencoded; charset=" + this.getParamsEncoding();
    }

    public Cache$Entry getCacheEntry() {
        return this.mCacheEntry;
    }

    public String getCacheKey() {
        return this.getUrl();
    }

    public Response$ErrorListener getErrorListener() {
        return this.mErrorListener;
    }

    public Map getHeaders() {
        return Collections.emptyMap();
    }

    public int getMethod() {
        return this.mMethod;
    }

    public Map getParams() {
        return null;
    }

    protected String getParamsEncoding() {
        return "UTF-8";
    }

    @Deprecated public byte[] getPostBody() {
        Map v0 = this.getPostParams();
        byte[] v0_1 = v0 == null || v0.size() <= 0 ? null : this.encodeParameters(v0, this.getPostParamsEncoding());
        return v0_1;
    }

    @Deprecated public String getPostBodyContentType() {
        return this.getBodyContentType();
    }

    @Deprecated protected Map getPostParams() {
        return this.getParams();
    }

    @Deprecated protected String getPostParamsEncoding() {
        return this.getParamsEncoding();
    }

    public Request$Priority getPriority() {
        return Request$Priority.NORMAL;
    }

    public RetryPolicy getRetryPolicy() {
        return this.mRetryPolicy;
    }

    public final int getSequence() {
        if(this.mSequence == null) {
            throw new IllegalStateException("getSequence called before setSequence");
        }

        return this.mSequence.intValue();
    }

    public Object getTag() {
        return this.mTag;
    }

    public final int getTimeoutMs() {
        return this.mRetryPolicy.getCurrentTimeout();
    }

    public int getTrafficStatsTag() {
        return this.mDefaultTrafficStatsTag;
    }

    public String getUrl() {
        return this.mUrl;
    }

    public boolean hasHadResponseDelivered() {
        return this.mResponseDelivered;
    }

    public boolean isCanceled() {
        return this.mCanceled;
    }

    public void markDelivered() {
        this.mResponseDelivered = true;
    }

    protected VolleyError parseNetworkError(VolleyError arg1) {
        return arg1;
    }

    public abstract Response parseNetworkResponse(NetworkResponse arg1);

    public Request setCacheEntry(Cache$Entry arg1) {
        this.mCacheEntry = arg1;
        return this;
    }

    public Request setRequestQueue(RequestQueue arg1) {
        this.mRequestQueue = arg1;
        return this;
    }

    public Request setRetryPolicy(RetryPolicy arg1) {
        this.mRetryPolicy = arg1;
        return this;
    }

    public final Request setSequence(int arg2) {
        this.mSequence = Integer.valueOf(arg2);
        return this;
    }

    public final Request setShouldCache(boolean arg1) {
        this.mShouldCache = arg1;
        return this;
    }

    public Request setTag(Object arg1) {
        this.mTag = arg1;
        return this;
    }

    public final boolean shouldCache() {
        return this.mShouldCache;
    }

    public String toString() {
        String v1 = "0x" + Integer.toHexString(this.getTrafficStatsTag());
        StringBuilder v2 = new StringBuilder();
        String v0 = this.mCanceled ? "[X] " : "[ ] ";
        return v2.append(v0).append(this.getUrl()).append(" ").append(v1).append(" ").append(this.getPriority()).append(" ").append(this.mSequence).toString();
    }
}

