// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley;

import android.os.Handler;
import android.os.Looper;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.Set;
import java.util.concurrent.PriorityBlockingQueue;
import java.util.concurrent.atomic.AtomicInteger;

public class RequestQueue {
    private static final int DEFAULT_NETWORK_THREAD_POOL_SIZE = 4;
    private final Cache mCache;
    private CacheDispatcher mCacheDispatcher;
    private final PriorityBlockingQueue mCacheQueue;
    private final Set mCurrentRequests;
    private final ResponseDelivery mDelivery;
    private NetworkDispatcher[] mDispatchers;
    private final Network mNetwork;
    private final PriorityBlockingQueue mNetworkQueue;
    private AtomicInteger mSequenceGenerator;
    private final Map mWaitingRequests;

    public RequestQueue(Cache arg2, Network arg3) {
        this(arg2, arg3, 4);
    }

    public RequestQueue(Cache arg4, Network arg5, int arg6) {
        this(arg4, arg5, arg6, new ExecutorDelivery(new Handler(Looper.getMainLooper())));
    }

    public RequestQueue(Cache arg2, Network arg3, int arg4, ResponseDelivery arg5) {
        super();
        this.mSequenceGenerator = new AtomicInteger();
        this.mWaitingRequests = new HashMap();
        this.mCurrentRequests = new HashSet();
        this.mCacheQueue = new PriorityBlockingQueue();
        this.mNetworkQueue = new PriorityBlockingQueue();
        this.mCache = arg2;
        this.mNetwork = arg3;
        this.mDispatchers = new NetworkDispatcher[arg4];
        this.mDelivery = arg5;
    }

    public Request add(Request arg6) {
        arg6.setRequestQueue(this);
        Set v1 = this.mCurrentRequests;
        __monitor_enter(v1);
        try {
            this.mCurrentRequests.add(arg6);
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            try {
            label_16:
                __monitor_exit(v1);
            }
            catch(Throwable v0) {
                goto label_16;
            }

            throw v0;
        }

        arg6.setSequence(this.getSequenceNumber());
        arg6.addMarker("add-to-queue");
        if(!arg6.shouldCache()) {
            this.mNetworkQueue.add(arg6);
        }
        else {
            Map v1_1 = this.mWaitingRequests;
            __monitor_enter(v1_1);
            try {
                String v2 = arg6.getCacheKey();
                if(this.mWaitingRequests.containsKey(v2)) {
                    Object v0_1 = this.mWaitingRequests.get(v2);
                    if(v0_1 == null) {
                        LinkedList v0_2 = new LinkedList();
                    }

                    ((Queue)v0_1).add(arg6);
                    this.mWaitingRequests.put(v2, v0_1);
                    if(!VolleyLog.DEBUG) {
                        goto label_40;
                    }

                    VolleyLog.v("Request for cacheKey=%s is in flight, putting on hold.", new Object[]{v2});
                }
                else {
                    this.mWaitingRequests.put(v2, null);
                    this.mCacheQueue.add(arg6);
                }

            label_40:
                __monitor_exit(v1_1);
                return arg6;
            label_43:
                __monitor_exit(v1_1);
            }
            catch(Throwable v0) {
                goto label_43;
            }

            throw v0;
        }

        return arg6;
    }

    public void cancelAll(RequestQueue$RequestFilter arg5) {
        Set v1 = this.mCurrentRequests;
        __monitor_enter(v1);
        try {
            Iterator v2 = this.mCurrentRequests.iterator();
            while(v2.hasNext()) {
                Object v0_1 = v2.next();
                if(!arg5.apply(((Request)v0_1))) {
                    continue;
                }

                ((Request)v0_1).cancel();
            }

            __monitor_exit(v1);
            return;
        label_12:
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            goto label_12;
        }

        throw v0;
    }

    public void cancelAll(Object arg3) {
        if(arg3 == null) {
            throw new IllegalArgumentException("Cannot cancelAll with a null tag");
        }

        this.cancelAll(new RequestQueue$1(this, arg3));
    }

    void finish(Request arg8) {
        Set v1 = this.mCurrentRequests;
        __monitor_enter(v1);
        try {
            this.mCurrentRequests.remove(arg8);
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            try {
            label_30:
                __monitor_exit(v1);
            }
            catch(Throwable v0) {
                goto label_30;
            }

            throw v0;
        }

        if(arg8.shouldCache()) {
            Map v1_1 = this.mWaitingRequests;
            __monitor_enter(v1_1);
            try {
                String v2 = arg8.getCacheKey();
                Object v0_1 = this.mWaitingRequests.remove(v2);
                if(v0_1 != null) {
                    if(VolleyLog.DEBUG) {
                        VolleyLog.v("Releasing %d waiting requests for cacheKey=%s.", new Object[]{Integer.valueOf(((Queue)v0_1).size()), v2});
                    }

                    this.mCacheQueue.addAll(((Collection)v0_1));
                }

                __monitor_exit(v1_1);
            }
            catch(Throwable v0) {
                try {
                label_33:
                    __monitor_exit(v1_1);
                }
                catch(Throwable v0) {
                    goto label_33;
                }

                throw v0;
            }
        }
    }

    public Cache getCache() {
        return this.mCache;
    }

    public int getSequenceNumber() {
        return this.mSequenceGenerator.incrementAndGet();
    }

    public void start() {
        this.stop();
        this.mCacheDispatcher = new CacheDispatcher(this.mCacheQueue, this.mNetworkQueue, this.mCache, this.mDelivery);
        this.mCacheDispatcher.start();
        int v0;
        for(v0 = 0; v0 < this.mDispatchers.length; ++v0) {
            NetworkDispatcher v1 = new NetworkDispatcher(this.mNetworkQueue, this.mNetwork, this.mCache, this.mDelivery);
            this.mDispatchers[v0] = v1;
            v1.start();
        }
    }

    public void stop() {
        if(this.mCacheDispatcher != null) {
            this.mCacheDispatcher.quit();
        }

        int v0;
        for(v0 = 0; v0 < this.mDispatchers.length; ++v0) {
            if(this.mDispatchers[v0] != null) {
                this.mDispatchers[v0].quit();
            }
        }
    }
}

