// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley.toolbox;

import android.os.SystemClock;
import com.android.volley.AuthFailureError;
import com.android.volley.Cache$Entry;
import com.android.volley.Network;
import com.android.volley.NetworkError;
import com.android.volley.NetworkResponse;
import com.android.volley.NoConnectionError;
import com.android.volley.Request;
import com.android.volley.RetryPolicy;
import com.android.volley.ServerError;
import com.android.volley.TimeoutError;
import com.android.volley.VolleyError;
import com.android.volley.VolleyLog;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.SocketTimeoutException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.impl.cookie.DateUtils;

public class BasicNetwork implements Network {
    protected static final boolean DEBUG;
    private static int DEFAULT_POOL_SIZE;
    private static int SLOW_REQUEST_THRESHOLD_MS;
    protected final HttpStack mHttpStack;
    protected final ByteArrayPool mPool;

    static {
        BasicNetwork.DEBUG = VolleyLog.DEBUG;
        BasicNetwork.SLOW_REQUEST_THRESHOLD_MS = 3000;
        BasicNetwork.DEFAULT_POOL_SIZE = 4096;
    }

    public BasicNetwork(HttpStack arg3) {
        this(arg3, new ByteArrayPool(BasicNetwork.DEFAULT_POOL_SIZE));
    }

    public BasicNetwork(HttpStack arg1, ByteArrayPool arg2) {
        super();
        this.mHttpStack = arg1;
        this.mPool = arg2;
    }

    private void addCacheHeaders(Map arg5, Cache$Entry arg6) {
        if(arg6 != null) {
            if(arg6.etag != null) {
                arg5.put("If-None-Match", arg6.etag);
            }

            if(arg6.serverDate <= 0) {
                return;
            }

            arg5.put("If-Modified-Since", DateUtils.formatDate(new Date(arg6.serverDate)));
        }
    }

    private static void attemptRetryOnException(String arg6, Request arg7, VolleyError arg8) {
        int v3 = 2;
        RetryPolicy v0 = arg7.getRetryPolicy();
        int v1 = arg7.getTimeoutMs();
        try {
            v0.retry(arg8);
        }
        catch(VolleyError v0_1) {
            arg7.addMarker(String.format("%s-timeout-giveup [timeout=%s]", arg6, Integer.valueOf(v1)));
            throw v0_1;
        }

        arg7.addMarker(String.format("%s-retry [timeout=%s]", arg6, Integer.valueOf(v1)));
    }

    private static Map convertHeaders(Header[] arg4) {
        HashMap v1 = new HashMap();
        int v0;
        for(v0 = 0; v0 < arg4.length; ++v0) {
            ((Map)v1).put(arg4[v0].getName(), arg4[v0].getValue());
        }

        return ((Map)v1);
    }

    private byte[] entityToBytes(HttpEntity arg7) {
        byte[] v0_2;
        PoolingByteArrayOutputStream v2 = new PoolingByteArrayOutputStream(this.mPool, ((int)arg7.getContentLength()));
        byte[] v1 = null;
        try {
            InputStream v0_1 = arg7.getContent();
            if(v0_1 == null) {
                throw new ServerError();
            }

            v1 = this.mPool.getBuf(1024);
            while(true) {
                int v3 = v0_1.read(v1);
                if(v3 == -1) {
                    break;
                }

                v2.write(v1, 0, v3);
            }

            v0_2 = v2.toByteArray();
        }
        catch(Throwable v0) {
            goto label_13;
        }

        try {
            arg7.consumeContent();
        }
        catch(IOException v3_1) {
            VolleyLog.v("Error occured when calling consumingContent", new Object[0]);
        }

        this.mPool.returnBuf(v1);
        v2.close();
        return v0_2;
        try {
        label_13:
            arg7.consumeContent();
        }
        catch(IOException v3_1) {
            VolleyLog.v("Error occured when calling consumingContent", new Object[0]);
        }

        this.mPool.returnBuf(v1);
        v2.close();
        throw v0;
    }

    protected void logError(String arg6, String arg7, long arg8) {
        VolleyLog.v("HTTP ERROR(%s) %d ms to fetch %s", new Object[]{arg6, Long.valueOf(SystemClock.elapsedRealtime() - arg8), arg7});
    }

    private void logSlowRequests(long arg5, Request arg7, byte[] arg8, StatusLine arg9) {
        String v0_1;
        if((BasicNetwork.DEBUG) || arg5 > (((long)BasicNetwork.SLOW_REQUEST_THRESHOLD_MS))) {
            String v1 = "HTTP response for request=<%s> [lifetime=%d], [size=%s], [rc=%d], [retryCount=%s]";
            Object[] v2 = new Object[5];
            v2[0] = arg7;
            v2[1] = Long.valueOf(arg5);
            int v3 = 2;
            if(arg8 != null) {
                Integer v0 = Integer.valueOf(arg8.length);
            }
            else {
                v0_1 = "null";
            }

            v2[v3] = v0_1;
            v2[3] = Integer.valueOf(arg9.getStatusCode());
            v2[4] = Integer.valueOf(arg7.getRetryPolicy().getCurrentRetryCount());
            VolleyLog.d(v1, v2);
        }
    }

    public NetworkResponse performRequest(Request arg12) {
        NetworkResponse v3;
        Map v6;
        int v10;
        StatusLine v5;
        HttpResponse v7;
        long v8 = SystemClock.elapsedRealtime();
        while(true) {
            HttpResponse v2 = null;
            byte[] v4 = null;
            HashMap v1 = new HashMap();
            try {
                HashMap v0_4 = new HashMap();
                this.addCacheHeaders(((Map)v0_4), arg12.getCacheEntry());
                v7 = this.mHttpStack.performRequest(arg12, ((Map)v0_4));
                goto label_11;
            }
            catch(MalformedURLException v0) {
            }
            catch(ConnectTimeoutException v0_1) {
            }
            catch(SocketTimeoutException v0_2) {
            }
            catch(IOException v0_3) {
                goto label_75;
                try {
                label_11:
                    v5 = v7.getStatusLine();
                    v10 = v5.getStatusCode();
                    v6 = BasicNetwork.convertHeaders(v7.getAllHeaders());
                    if(v10 != 304) {
                        goto label_28;
                    }

                    goto label_17;
                }
                catch(MalformedURLException v0) {
                }
                catch(ConnectTimeoutException v0_1) {
                }
                catch(SocketTimeoutException v0_2) {
                }
                catch(IOException v0_3) {
                    v2 = v7;
                    goto label_75;
                    try {
                    label_17:
                        int v2_1 = 304;
                        byte[] v1_1 = arg12.getCacheEntry() == null ? null : arg12.getCacheEntry().data;
                        NetworkResponse v0_5 = new NetworkResponse(v2_1, v1_1, v6, true);
                        return v0_5;
                    label_28:
                        v4 = v7.getEntity() != null ? this.entityToBytes(v7.getEntity()) : new byte[0];
                        this.logSlowRequests(SystemClock.elapsedRealtime() - v8, arg12, v4, v5);
                        if(v10 >= 200 && v10 <= 299) {
                            return new NetworkResponse(v10, v4, v6, false);
                        }

                        throw new IOException();
                    }
                    catch(IOException v0_3) {
                        Map v1_2 = v6;
                        v2 = v7;
                    }
                    catch(MalformedURLException v0) {
                        throw new RuntimeException("Bad URL " + arg12.getUrl(), ((Throwable)v0));
                    }
                    catch(ConnectTimeoutException v0_1) {
                        BasicNetwork.attemptRetryOnException("connection", arg12, new TimeoutError());
                        continue;
                    }
                    catch(SocketTimeoutException v0_2) {
                        BasicNetwork.attemptRetryOnException("socket", arg12, new TimeoutError());
                        continue;
                    }
                }
            }

        label_75:
            v3 = null;
            if(v2 == null) {
                goto label_102;
            }

            int v0_6 = v2.getStatusLine().getStatusCode();
            VolleyLog.e("Unexpected response code %d for %s", new Object[]{Integer.valueOf(v0_6), arg12.getUrl()});
            if(v4 == null) {
                break;
            }

            NetworkResponse v2_2 = new NetworkResponse(v0_6, v4, ((Map)v1), false);
            if(v0_6 != 401 && v0_6 != 403) {
                throw new ServerError(v2_2);
            }

            BasicNetwork.attemptRetryOnException("auth", arg12, new AuthFailureError(v2_2));
        }

        throw new NetworkError(v3);
    label_102:
        throw new NoConnectionError(((Throwable)v0_3));
    }
}

