// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley.toolbox;

import android.os.SystemClock;
import com.android.volley.Cache;
import com.android.volley.Cache$Entry;
import com.android.volley.VolleyLog;
import java.io.BufferedInputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map$Entry;

public class DiskBasedCache implements Cache {
    private static final int CACHE_MAGIC = 538183203;
    private static final int DEFAULT_DISK_USAGE_BYTES = 5242880;
    private static final float HYSTERESIS_FACTOR = 0.9f;
    private final Map mEntries;
    private final int mMaxCacheSizeInBytes;
    private final File mRootDirectory;
    private long mTotalSize;

    public DiskBasedCache(File arg2) {
        this(arg2, 5242880);
    }

    public DiskBasedCache(File arg5, int arg6) {
        super();
        this.mEntries = new LinkedHashMap(16, 0.75f, true);
        this.mTotalSize = 0;
        this.mRootDirectory = arg5;
        this.mMaxCacheSizeInBytes = arg6;
    }

    public void clear() {
        int v0 = 0;
        __monitor_enter(this);
        try {
            File[] v1 = this.mRootDirectory.listFiles();
            if(v1 != null) {
                int v2 = v1.length;
                while(v0 < v2) {
                    v1[v0].delete();
                    ++v0;
                }
            }

            this.mEntries.clear();
            this.mTotalSize = 0;
            VolleyLog.d("Cache cleared.", new Object[0]);
        }
        catch(Throwable v0_1) {
            __monitor_exit(this);
            throw v0_1;
        }

        __monitor_exit(this);
    }

    public Cache$Entry get(String arg9) {
        DiskBasedCache$CountingInputStream v2;
        File v3;
        Object v0_1;
        Cache$Entry v1 = null;
        __monitor_enter(this);
        try {
            v0_1 = this.mEntries.get(arg9);
            if(v0_1 != null) {
                goto label_8;
            }
        }
        catch(Throwable v0) {
            goto label_54;
        }

        Cache$Entry v0_2 = v1;
        goto label_6;
        try {
        label_8:
            v3 = this.getFileForKey(arg9);
        }
        catch(Throwable v0) {
            goto label_54;
        }

        try {
            v2 = new DiskBasedCache$CountingInputStream(new FileInputStream(v3), null);
        }
        catch(Throwable v0) {
            v2 = ((DiskBasedCache$CountingInputStream)v1);
            goto label_50;
        }
        catch(IOException v0_3) {
            v2 = ((DiskBasedCache$CountingInputStream)v1);
            goto label_30;
        }

        try {
            DiskBasedCache$CacheHeader.readHeader(((InputStream)v2));
            v0_2 = ((DiskBasedCache$CacheHeader)v0_1).toCacheEntry(DiskBasedCache.streamToBytes(((InputStream)v2), ((int)(v3.length() - (((long)v2.bytesRead))))));
            if(v2 == null) {
                goto label_6;
            }

            goto label_23;
        }
        catch(Throwable v0) {
        }
        catch(IOException v0_3) {
            try {
            label_30:
                VolleyLog.d("%s: %s", new Object[]{v3.getAbsolutePath(), v0_3.toString()});
                this.remove(arg9);
                if(v2 != null) {
                    goto label_42;
                }

                goto label_43;
            }
            catch(Throwable v0) {
                goto label_50;
            }

            try {
            label_42:
                v2.close();
                goto label_43;
            }
            catch(Throwable v0) {
            }
            catch(IOException v0_3) {
                v0_2 = v1;
                goto label_6;
            label_43:
                v0_2 = v1;
                goto label_6;
            label_50:
                if(v2 != null) {
                    try {
                        v2.close();
                    }
                    catch(IOException v0_3) {
                        v0_2 = v1;
                        goto label_6;
                    }
                }

                try {
                    throw v0;
                }
                catch(Throwable v0) {
                    goto label_54;
                }

                try {
                label_23:
                    v2.close();
                }
                catch(Throwable v0) {
                label_54:
                    __monitor_exit(this);
                    throw v0;
                }
                catch(IOException v0_3) {
                    v0_2 = v1;
                }
            }
        }

    label_6:
        __monitor_exit(this);
        return v0_2;
    }

    public File getFileForKey(String arg4) {
        return new File(this.mRootDirectory, this.getFilenameForKey(arg4));
    }

    private String getFilenameForKey(String arg4) {
        int v0 = arg4.length() / 2;
        return String.valueOf(arg4.substring(0, v0).hashCode()) + String.valueOf(arg4.substring(v0).hashCode());
    }

    public void initialize() {
        BufferedInputStream v0_2;
        BufferedInputStream v1;
        File v5;
        int v2;
        __monitor_enter(this);
        try {
            if(!this.mRootDirectory.exists()) {
                if(this.mRootDirectory.mkdirs()) {
                    goto label_16;
                }

                VolleyLog.e("Unable to create cache dir %s", new Object[]{this.mRootDirectory.getAbsolutePath()});
                goto label_16;
            }

            File[] v3 = this.mRootDirectory.listFiles();
            if(v3 == null) {
                goto label_16;
            }

            int v4 = v3.length;
            v2 = 0;
            while(true) {
            label_23:
                if(v2 >= v4) {
                    goto label_16;
                }

                v5 = v3[v2];
                v1 = null;
                break;
            }
        }
        catch(Throwable v0) {
            goto label_54;
        }

        try {
            v0_2 = new BufferedInputStream(new FileInputStream(v5));
        }
        catch(Throwable v0) {
            goto label_50;
        }
        catch(IOException v0_1) {
            v0_2 = v1;
            goto label_42;
        }

        try {
            DiskBasedCache$CacheHeader v1_3 = DiskBasedCache$CacheHeader.readHeader(((InputStream)v0_2));
            v1_3.size = v5.length();
            this.putEntry(v1_3.key, v1_3);
            if(v0_2 == null) {
                goto label_37;
            }

            goto label_36;
        }
        catch(Throwable v1_1) {
        }
        catch(IOException v1_2) {
        label_42:
            if(v5 != null) {
                try {
                    v5.delete();
                }
                catch(Throwable v1_1) {
                    goto label_61;
                }
            }

            if(v0_2 == null) {
                goto label_37;
            }

            try {
                v0_2.close();
                goto label_37;
            }
            catch(Throwable v0) {
            }
            catch(IOException v0_1) {
                goto label_37;
            label_61:
                Throwable v8 = v1_1;
                v1 = v0_2;
                v0 = v8;
            label_50:
                if(v1 == null) {
                    goto label_52;
                }

                try {
                    v1.close();
                }
                catch(IOException v1_2) {
                }

                try {
                label_52:
                    throw v0;
                }
                catch(Throwable v0) {
                    goto label_54;
                }

                try {
                label_36:
                    v0_2.close();
                    goto label_37;
                }
                catch(Throwable v0) {
                label_54:
                    __monitor_exit(this);
                    throw v0;
                }
                catch(IOException v0_1) {
                label_37:
                    ++v2;
                    goto label_23;
                }
            }
        }

    label_16:
        __monitor_exit(this);
    }

    public void invalidate(String arg4, boolean arg5) {
        __monitor_enter(this);
        try {
            Cache$Entry v0_1 = this.get(arg4);
            if(v0_1 != null) {
                v0_1.softTtl = 0;
                if(arg5) {
                    v0_1.ttl = 0;
                }

                this.put(arg4, v0_1);
            }
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }

    private void pruneIfNeeded(int arg15) {
        int v0_1;
        int v13 = 2;
        if(this.mTotalSize + (((long)arg15)) >= (((long)this.mMaxCacheSizeInBytes))) {
            if(VolleyLog.DEBUG) {
                VolleyLog.v("Pruning old cache entries.", new Object[0]);
            }

            long v3 = this.mTotalSize;
            long v5 = SystemClock.elapsedRealtime();
            Iterator v7 = this.mEntries.entrySet().iterator();
            int v1;
            for(v1 = 0; v7.hasNext(); v1 = v0_1) {
                Object v0 = v7.next().getValue();
                if(this.getFileForKey(((DiskBasedCache$CacheHeader)v0).key).delete()) {
                    this.mTotalSize -= ((DiskBasedCache$CacheHeader)v0).size;
                }
                else {
                    Object[] v9 = new Object[v13];
                    v9[0] = ((DiskBasedCache$CacheHeader)v0).key;
                    v9[1] = this.getFilenameForKey(((DiskBasedCache$CacheHeader)v0).key);
                    VolleyLog.d("Could not delete cache entry for key=%s, filename=%s", v9);
                }

                v7.remove();
                v0_1 = v1 + 1;
                if((((float)(this.mTotalSize + (((long)arg15))))) < (((float)this.mMaxCacheSizeInBytes)) * 0.9f) {
                    goto label_44;
                }
            }

            v0_1 = v1;
        label_44:
            if(!VolleyLog.DEBUG) {
                return;
            }

            Object[] v7_1 = new Object[3];
            v7_1[0] = Integer.valueOf(v0_1);
            v7_1[1] = Long.valueOf(this.mTotalSize - v3);
            v7_1[v13] = Long.valueOf(SystemClock.elapsedRealtime() - v5);
            VolleyLog.v("pruned %d files, %d bytes, %d ms", v7_1);
        }
    }

    public void put(String arg6, Cache$Entry arg7) {
        DiskBasedCache$CacheHeader v2;
        FileOutputStream v1_1;
        File v0_1;
        __monitor_enter(this);
        try {
            this.pruneIfNeeded(arg7.data.length);
            v0_1 = this.getFileForKey(arg6);
            try {
                v1_1 = new FileOutputStream(v0_1);
                v2 = new DiskBasedCache$CacheHeader(arg6, arg7);
                if(v2.writeHeader(((OutputStream)v1_1))) {
                    goto label_34;
                }

                v1_1.close();
                VolleyLog.d("Failed to write header for %s", new Object[]{v0_1.getAbsolutePath()});
                throw new IOException();
            }
            catch(IOException v1) {
                goto label_23;
            }
        }
        catch(Throwable v0) {
            goto label_40;
        }

        try {
        label_34:
            v1_1.write(arg7.data);
            v1_1.close();
            this.putEntry(arg6, v2);
        }
        catch(Throwable v0) {
        }
        catch(IOException v1) {
            try {
            label_23:
                if(v0_1.delete()) {
                    goto label_32;
                }

                VolleyLog.d("Could not clean up file %s", new Object[]{v0_1.getAbsolutePath()});
            }
            catch(Throwable v0) {
            label_40:
                __monitor_exit(this);
                throw v0;
            }
        }

    label_32:
        __monitor_exit(this);
    }

    private void putEntry(String arg8, DiskBasedCache$CacheHeader arg9) {
        this.mTotalSize += !this.mEntries.containsKey(arg8) ? arg9.size : arg9.size - this.mEntries.get(arg8).size;
        this.mEntries.put(arg8, arg9);
    }

    private static int read(InputStream arg2) {
        int v0 = arg2.read();
        if(v0 == -1) {
            throw new EOFException();
        }

        return v0;
    }

    static int readInt(InputStream arg2) {
        return 0 | DiskBasedCache.read(arg2) << 0 | DiskBasedCache.read(arg2) << 8 | DiskBasedCache.read(arg2) << 16 | DiskBasedCache.read(arg2) << 24;
    }

    static long readLong(InputStream arg7) {
        return 0 | ((((long)DiskBasedCache.read(arg7))) & 255) << 0 | ((((long)DiskBasedCache.read(arg7))) & 255) << 8 | ((((long)DiskBasedCache.read(arg7))) & 255) << 16 | ((((long)DiskBasedCache.read(arg7))) & 255) << 24 | ((((long)DiskBasedCache.read(arg7))) & 255) << 32 | ((((long)DiskBasedCache.read(arg7))) & 255) << 40 | ((((long)DiskBasedCache.read(arg7))) & 255) << 48 | ((((long)DiskBasedCache.read(arg7))) & 255) << 56;
    }

    static String readString(InputStream arg3) {
        return new String(DiskBasedCache.streamToBytes(arg3, ((int)DiskBasedCache.readLong(arg3))), "UTF-8");
    }

    static Map readStringStringMap(InputStream arg5) {
        Map v0;
        int v2 = DiskBasedCache.readInt(arg5);
        if(v2 == 0) {
            v0 = Collections.emptyMap();
        }
        else {
            HashMap v0_1 = new HashMap(v2);
        }

        int v1;
        for(v1 = 0; v1 < v2; ++v1) {
            v0.put(DiskBasedCache.readString(arg5).intern(), DiskBasedCache.readString(arg5).intern());
        }

        return v0;
    }

    public void remove(String arg5) {
        __monitor_enter(this);
        try {
            boolean v0_1 = this.getFileForKey(arg5).delete();
            this.removeEntry(arg5);
            if(!v0_1) {
                VolleyLog.d("Could not delete cache entry for key=%s, filename=%s", new Object[]{arg5, this.getFilenameForKey(arg5)});
            }
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }

    private void removeEntry(String arg6) {
        Object v0 = this.mEntries.get(arg6);
        if(v0 != null) {
            this.mTotalSize -= ((DiskBasedCache$CacheHeader)v0).size;
            this.mEntries.remove(arg6);
        }
    }

    private static byte[] streamToBytes(InputStream arg4, int arg5) {
        byte[] v1 = new byte[arg5];
        int v0;
        for(v0 = 0; v0 < arg5; v0 += v2) {
            int v2 = arg4.read(v1, v0, arg5 - v0);
            if(v2 == -1) {
                break;
            }
        }

        if(v0 != arg5) {
            throw new IOException("Expected " + arg5 + " bytes, read " + v0 + " bytes");
        }

        return v1;
    }

    static void writeInt(OutputStream arg1, int arg2) {
        arg1.write(arg2 >> 0 & 255);
        arg1.write(arg2 >> 8 & 255);
        arg1.write(arg2 >> 16 & 255);
        arg1.write(arg2 >> 24 & 255);
    }

    static void writeLong(OutputStream arg2, long arg3) {
        arg2.write(((byte)(((int)(arg3 >>> 0)))));
        arg2.write(((byte)(((int)(arg3 >>> 8)))));
        arg2.write(((byte)(((int)(arg3 >>> 16)))));
        arg2.write(((byte)(((int)(arg3 >>> 24)))));
        arg2.write(((byte)(((int)(arg3 >>> 32)))));
        arg2.write(((byte)(((int)(arg3 >>> 40)))));
        arg2.write(((byte)(((int)(arg3 >>> 48)))));
        arg2.write(((byte)(((int)(arg3 >>> 56)))));
    }

    static void writeString(OutputStream arg3, String arg4) {
        byte[] v0 = arg4.getBytes("UTF-8");
        DiskBasedCache.writeLong(arg3, ((long)v0.length));
        arg3.write(v0, 0, v0.length);
    }

    static void writeStringStringMap(Map arg3, OutputStream arg4) {
        if(arg3 != null) {
            DiskBasedCache.writeInt(arg4, arg3.size());
            Iterator v2 = arg3.entrySet().iterator();
            while(v2.hasNext()) {
                Object v0 = v2.next();
                DiskBasedCache.writeString(arg4, ((Map$Entry)v0).getKey());
                DiskBasedCache.writeString(arg4, ((Map$Entry)v0).getValue());
            }
        }
        else {
            DiskBasedCache.writeInt(arg4, 0);
        }
    }
}

