// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley.toolbox;

import com.android.volley.Request;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map$Entry;
import javax.net.ssl.SSLSocketFactory;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.ProtocolVersion;
import org.apache.http.entity.BasicHttpEntity;
import org.apache.http.message.BasicHeader;
import org.apache.http.message.BasicHttpResponse;
import org.apache.http.message.BasicStatusLine;

public class HurlStack implements HttpStack {
    private static final String HEADER_CONTENT_TYPE = "Content-Type";
    private final SSLSocketFactory mSslSocketFactory;
    private final HurlStack$UrlRewriter mUrlRewriter;

    public HurlStack() {
        this(null);
    }

    public HurlStack(HurlStack$UrlRewriter arg2) {
        this(arg2, null);
    }

    public HurlStack(HurlStack$UrlRewriter arg1, SSLSocketFactory arg2) {
        super();
        this.mUrlRewriter = arg1;
        this.mSslSocketFactory = arg2;
    }

    private static void addBodyIfExists(HttpURLConnection arg3, Request arg4) {
        byte[] v0 = arg4.getBody();
        if(v0 != null) {
            arg3.setDoOutput(true);
            arg3.addRequestProperty("Content-Type", arg4.getBodyContentType());
            DataOutputStream v1 = new DataOutputStream(arg3.getOutputStream());
            v1.write(v0);
            v1.close();
        }
    }

    protected HttpURLConnection createConnection(URL arg2) {
        return arg2.openConnection();
    }

    private static HttpEntity entityFromConnection(HttpURLConnection arg4) {
        InputStream v0_1;
        BasicHttpEntity v1 = new BasicHttpEntity();
        try {
            v0_1 = arg4.getInputStream();
        }
        catch(IOException v0) {
            v0_1 = arg4.getErrorStream();
        }

        v1.setContent(v0_1);
        v1.setContentLength(((long)arg4.getContentLength()));
        v1.setContentEncoding(arg4.getContentEncoding());
        v1.setContentType(arg4.getContentType());
        return ((HttpEntity)v1);
    }

    private HttpURLConnection openConnection(URL arg4, Request arg5) {
        HttpURLConnection v1 = this.createConnection(arg4);
        int v0 = arg5.getTimeoutMs();
        v1.setConnectTimeout(v0);
        v1.setReadTimeout(v0);
        v1.setUseCaches(false);
        v1.setDoInput(true);
        if(("https".equals(arg4.getProtocol())) && this.mSslSocketFactory != null) {
            v1.setSSLSocketFactory(this.mSslSocketFactory);
        }

        return v1;
    }

    public HttpResponse performRequest(Request arg7, Map arg8) {
        Object v0_1;
        String v0;
        String v1 = arg7.getUrl();
        HashMap v2 = new HashMap();
        v2.putAll(arg7.getHeaders());
        v2.putAll(arg8);
        if(this.mUrlRewriter != null) {
            v0 = this.mUrlRewriter.rewriteUrl(v1);
            if(v0 == null) {
                throw new IOException("URL blocked by rewriter: " + v1);
            }
        }
        else {
            v0 = v1;
        }

        HttpURLConnection v3 = this.openConnection(new URL(v0), arg7);
        Iterator v4 = v2.keySet().iterator();
        while(v4.hasNext()) {
            v0_1 = v4.next();
            v3.addRequestProperty(((String)v0_1), v2.get(v0_1));
        }

        HurlStack.setConnectionParametersForRequest(v3, arg7);
        ProtocolVersion v0_2 = new ProtocolVersion("HTTP", 1, 1);
        if(v3.getResponseCode() == -1) {
            throw new IOException("Could not retrieve response code from HttpUrlConnection.");
        }

        BasicHttpResponse v2_1 = new BasicHttpResponse(new BasicStatusLine(v0_2, v3.getResponseCode(), v3.getResponseMessage()));
        v2_1.setEntity(HurlStack.entityFromConnection(v3));
        Iterator v3_1 = v3.getHeaderFields().entrySet().iterator();
        while(v3_1.hasNext()) {
            v0_1 = v3_1.next();
            if(((Map$Entry)v0_1).getKey() == null) {
                continue;
            }

            v2_1.addHeader(new BasicHeader(((Map$Entry)v0_1).getKey(), ((Map$Entry)v0_1).getValue().get(0)));
        }

        return ((HttpResponse)v2_1);
    }

    static void setConnectionParametersForRequest(HttpURLConnection arg3, Request arg4) {
        switch(arg4.getMethod()) {
            case -1: {
                byte[] v0 = arg4.getPostBody();
                if(v0 == null) {
                    return;
                }

                arg3.setDoOutput(true);
                arg3.setRequestMethod("POST");
                arg3.addRequestProperty("Content-Type", arg4.getPostBodyContentType());
                DataOutputStream v1 = new DataOutputStream(arg3.getOutputStream());
                v1.write(v0);
                v1.close();
                break;
            }
            case 0: {
                arg3.setRequestMethod("GET");
                break;
            }
            case 1: {
                arg3.setRequestMethod("POST");
                HurlStack.addBodyIfExists(arg3, arg4);
                break;
            }
            case 2: {
                arg3.setRequestMethod("PUT");
                HurlStack.addBodyIfExists(arg3, arg4);
                break;
            }
            case 3: {
                arg3.setRequestMethod("DELETE");
                break;
            }
            case 4: {
                arg3.setRequestMethod("HEAD");
                break;
            }
            case 5: {
                arg3.setRequestMethod("OPTIONS");
                break;
            }
            case 6: {
                arg3.setRequestMethod("TRACE");
                break;
            }
            case 7: {
                arg3.setRequestMethod("PATCH");
                HurlStack.addBodyIfExists(arg3, arg4);
                break;
            }
            default: {
                throw new IllegalStateException("Unknown method type.");
            }
        }
    }
}

