// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley.toolbox;

import android.graphics.Bitmap;
import android.graphics.Bitmap$Config;
import android.os.Handler;
import android.os.Looper;
import android.widget.ImageView;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.VolleyError;
import java.util.HashMap;

public class ImageLoader {
    private int mBatchResponseDelayMs;
    private final HashMap mBatchedResponses;
    private final ImageLoader$ImageCache mCache;
    private final Handler mHandler;
    private final HashMap mInFlightRequests;
    private final RequestQueue mRequestQueue;
    private Runnable mRunnable;

    public ImageLoader(RequestQueue arg3, ImageLoader$ImageCache arg4) {
        super();
        this.mBatchResponseDelayMs = 100;
        this.mInFlightRequests = new HashMap();
        this.mBatchedResponses = new HashMap();
        this.mHandler = new Handler(Looper.getMainLooper());
        this.mRequestQueue = arg3;
        this.mCache = arg4;
    }

    static void access$000(ImageLoader arg0, String arg1, Bitmap arg2) {
        arg0.onGetImageSuccess(arg1, arg2);
    }

    static void access$100(ImageLoader arg0, String arg1, VolleyError arg2) {
        arg0.onGetImageError(arg1, arg2);
    }

    static HashMap access$300(ImageLoader arg1) {
        return arg1.mInFlightRequests;
    }

    static HashMap access$400(ImageLoader arg1) {
        return arg1.mBatchedResponses;
    }

    static Runnable access$802(ImageLoader arg0, Runnable arg1) {
        arg0.mRunnable = arg1;
        return arg1;
    }

    private void batchResponse(String arg5, ImageLoader$BatchedImageRequest arg6) {
        this.mBatchedResponses.put(arg5, arg6);
        if(this.mRunnable == null) {
            this.mRunnable = new ImageLoader$4(this);
            this.mHandler.postDelayed(this.mRunnable, ((long)this.mBatchResponseDelayMs));
        }
    }

    public ImageLoader$ImageContainer get(String arg2, ImageLoader$ImageListener arg3) {
        return this.get(arg2, arg3, 0, 0);
    }

    public ImageLoader$ImageContainer get(String arg15, ImageLoader$ImageListener arg16, int arg17, int arg18) {
        ImageLoader$ImageContainer v2;
        this.throwIfNotOnMainThread();
        String v6 = ImageLoader.getCacheKey(arg15, arg17, arg18);
        Bitmap v4 = this.mCache.getBitmap(v6);
        if(v4 != null) {
            v2 = new ImageLoader$ImageContainer(this, v4, arg15, null, null);
            arg16.onResponse(v2, true);
        }
        else {
            v2 = new ImageLoader$ImageContainer(this, null, arg15, v6, arg16);
            arg16.onResponse(v2, true);
            Object v3 = this.mInFlightRequests.get(v6);
            if(v3 != null) {
                ((ImageLoader$BatchedImageRequest)v3).addContainer(v2);
            }
            else {
                ImageRequest v7 = new ImageRequest(arg15, new ImageLoader$2(this, v6), arg17, arg18, Bitmap$Config.RGB_565, new ImageLoader$3(this, v6));
                this.mRequestQueue.add(((Request)v7));
                this.mInFlightRequests.put(v6, new ImageLoader$BatchedImageRequest(this, ((Request)v7), v2));
            }
        }

        return v2;
    }

    private static String getCacheKey(String arg2, int arg3, int arg4) {
        return new StringBuilder(arg2.length() + 12).append("#W").append(arg3).append("#H").append(arg4).append(arg2).toString();
    }

    public static ImageLoader$ImageListener getImageListener(ImageView arg1, int arg2, int arg3) {
        return new ImageLoader$1(arg3, arg1, arg2);
    }

    public boolean isCached(String arg3, int arg4, int arg5) {
        this.throwIfNotOnMainThread();
        boolean v0 = this.mCache.getBitmap(ImageLoader.getCacheKey(arg3, arg4, arg5)) != null ? true : false;
        return v0;
    }

    private void onGetImageError(String arg2, VolleyError arg3) {
        Object v0 = this.mInFlightRequests.remove(arg2);
        if(v0 != null) {
            ((ImageLoader$BatchedImageRequest)v0).setError(arg3);
            this.batchResponse(arg2, ((ImageLoader$BatchedImageRequest)v0));
        }
    }

    private void onGetImageSuccess(String arg2, Bitmap arg3) {
        this.mCache.putBitmap(arg2, arg3);
        Object v0 = this.mInFlightRequests.remove(arg2);
        if(v0 != null) {
            ((ImageLoader$BatchedImageRequest)v0).mResponseBitmap = arg3;
            this.batchResponse(arg2, ((ImageLoader$BatchedImageRequest)v0));
        }
    }

    public void setBatchedResponseDelay(int arg1) {
        this.mBatchResponseDelayMs = arg1;
    }

    private void throwIfNotOnMainThread() {
        if(Looper.myLooper() != Looper.getMainLooper()) {
            throw new IllegalStateException("ImageLoader must be invoked from the main thread.");
        }
    }
}

