// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley.toolbox;

import android.graphics.Bitmap;
import android.graphics.Bitmap$Config;
import android.graphics.BitmapFactory;
import android.graphics.BitmapFactory$Options;
import com.android.volley.DefaultRetryPolicy;
import com.android.volley.NetworkResponse;
import com.android.volley.ParseError;
import com.android.volley.Request;
import com.android.volley.Request$Priority;
import com.android.volley.Response;
import com.android.volley.Response$ErrorListener;
import com.android.volley.Response$Listener;
import com.android.volley.VolleyLog;

public class ImageRequest extends Request {
    private static final float IMAGE_BACKOFF_MULT = 0f;
    private static final int IMAGE_MAX_RETRIES = 2;
    private static final int IMAGE_TIMEOUT_MS = 1000;
    private final Bitmap$Config mDecodeConfig;
    private final Response$Listener mListener;
    private final int mMaxHeight;
    private final int mMaxWidth;
    private static final Object sDecodeLock;

    static {
        ImageRequest.sDecodeLock = new Object();
    }

    public ImageRequest(String arg5, Response$Listener arg6, int arg7, int arg8, Bitmap$Config arg9, Response$ErrorListener arg10) {
        super(0, arg5, arg10);
        this.setRetryPolicy(new DefaultRetryPolicy(1000, 2, 2f));
        this.mListener = arg6;
        this.mDecodeConfig = arg9;
        this.mMaxWidth = arg7;
        this.mMaxHeight = arg8;
    }

    protected void deliverResponse(Bitmap arg2) {
        this.mListener.onResponse(arg2);
    }

    protected void deliverResponse(Object arg1) {
        this.deliverResponse(((Bitmap)arg1));
    }

    private Response doParse(NetworkResponse arg10) {
        Bitmap v0_1;
        byte[] v0 = arg10.data;
        BitmapFactory$Options v1 = new BitmapFactory$Options();
        if(this.mMaxWidth != 0 || this.mMaxHeight != 0) {
            v1.inJustDecodeBounds = true;
            BitmapFactory.decodeByteArray(v0, 0, v0.length, v1);
            int v2 = v1.outWidth;
            int v3 = v1.outHeight;
            int v4 = ImageRequest.getResizedDimension(this.mMaxWidth, this.mMaxHeight, v2, v3);
            int v5 = ImageRequest.getResizedDimension(this.mMaxHeight, this.mMaxWidth, v3, v2);
            v1.inJustDecodeBounds = false;
            v1.inSampleSize = ImageRequest.findBestSampleSize(v2, v3, v4, v5);
            Bitmap v1_1 = BitmapFactory.decodeByteArray(v0, 0, v0.length, v1);
            if(v1_1 != null && (v1_1.getWidth() > v4 || v1_1.getHeight() > v5)) {
                v0_1 = Bitmap.createScaledBitmap(v1_1, v4, v5, true);
                v1_1.recycle();
                goto label_13;
            }

            v0_1 = v1_1;
        }
        else {
            v1.inPreferredConfig = this.mDecodeConfig;
            v0_1 = BitmapFactory.decodeByteArray(v0, 0, v0.length, v1);
        }

    label_13:
        Response v0_2 = v0_1 == null ? Response.error(new ParseError(arg10)) : Response.success(v0_1, HttpHeaderParser.parseCacheHeaders(arg10));
        return v0_2;
    }

    static int findBestSampleSize(int arg7, int arg8, int arg9, int arg10) {
        float v6 = 2f;
        double v1 = Math.min((((double)arg7)) / (((double)arg9)), (((double)arg8)) / (((double)arg10)));
        float v0;
        for(v0 = 1f; (((double)(v0 * v6))) <= v1; v0 *= v6) {
        }

        return ((int)v0);
    }

    public Request$Priority getPriority() {
        return Request$Priority.LOW;
    }

    private static int getResizedDimension(int arg6, int arg7, int arg8, int arg9) {
        if(arg6 == 0 && arg7 == 0) {
            arg6 = arg8;
        }
        else if(arg6 == 0) {
            arg6 = ((int)((((double)arg7)) / (((double)arg9)) * (((double)arg8))));
        }
        else if(arg7 != 0) {
            double v0 = (((double)arg9)) / (((double)arg8));
            if((((double)arg6)) * v0 > (((double)arg7))) {
                arg6 = ((int)((((double)arg7)) / v0));
            }
        }

        return arg6;
    }

    protected Response parseNetworkResponse(NetworkResponse arg7) {
        Response v0_2;
        Object v1 = ImageRequest.sDecodeLock;
        __monitor_enter(v1);
        try {
            v0_2 = this.doParse(arg7);
            goto label_3;
        }
        catch(Throwable v0) {
        label_25:
            throw v0;
        }
        catch(OutOfMemoryError v0_1) {
            try {
                VolleyLog.e("Caught OOM for %d byte image, url=%s", new Object[]{Integer.valueOf(arg7.data.length), this.getUrl()});
                v0_2 = Response.error(new ParseError(((Throwable)v0_1)));
                __monitor_exit(v1);
                return v0_2;
            label_3:
                __monitor_exit(v1);
                return v0_2;
            label_24:
                __monitor_exit(v1);
                goto label_25;
            }
            catch(Throwable v0) {
                goto label_24;
            }
        }
    }
}

