// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.android.volley.toolbox;

import java.io.ByteArrayOutputStream;

public class PoolingByteArrayOutputStream extends ByteArrayOutputStream {
    private static final int DEFAULT_SIZE = 256;
    private final ByteArrayPool mPool;

    public PoolingByteArrayOutputStream(ByteArrayPool arg3, int arg4) {
        super();
        this.mPool = arg3;
        this.buf = this.mPool.getBuf(Math.max(arg4, 256));
    }

    public PoolingByteArrayOutputStream(ByteArrayPool arg2) {
        this(arg2, 256);
    }

    public void close() {
        this.mPool.returnBuf(this.buf);
        this.buf = null;
        super.close();
    }

    private void expand(int arg5) {
        if(this.count + arg5 > this.buf.length) {
            byte[] v0 = this.mPool.getBuf((this.count + arg5) * 2);
            System.arraycopy(this.buf, 0, v0, 0, this.count);
            this.mPool.returnBuf(this.buf);
            this.buf = v0;
        }
    }

    public void finalize() {
        this.mPool.returnBuf(this.buf);
    }

    public void write(byte[] arg2, int arg3, int arg4) {
        __monitor_enter(this);
        try {
            this.expand(arg4);
            super.write(arg2, arg3, arg4);
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }

    public void write(int arg2) {
        __monitor_enter(this);
        try {
            this.expand(1);
            super.write(arg2);
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }
}

