// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android;

import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import com.j256.ormlite.android.compat.ApiCompatibility;
import com.j256.ormlite.android.compat.ApiCompatibility$CancellationHook;
import com.j256.ormlite.android.compat.ApiCompatibilityUtils;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.field.SqlType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.stmt.StatementBuilder$StatementType;
import com.j256.ormlite.support.CompiledStatement;
import com.j256.ormlite.support.DatabaseResults;
import java.util.ArrayList;
import java.util.List;

public class AndroidCompiledStatement implements CompiledStatement {
    private static final String[] NO_STRING_ARGS;
    private static final ApiCompatibility apiCompatibility;
    private List args;
    private final boolean cancelQueriesEnabled;
    private ApiCompatibility$CancellationHook cancellationHook;
    private Cursor cursor;
    private final SQLiteDatabase db;
    private static Logger logger;
    private Integer max;
    private final String sql;
    private final StatementBuilder$StatementType type;

    static {
        AndroidCompiledStatement.logger = LoggerFactory.getLogger(AndroidCompiledStatement.class);
        AndroidCompiledStatement.NO_STRING_ARGS = new String[0];
        AndroidCompiledStatement.apiCompatibility = ApiCompatibilityUtils.getCompatibility();
    }

    public AndroidCompiledStatement(String arg1, SQLiteDatabase arg2, StatementBuilder$StatementType arg3, boolean arg4) {
        super();
        this.sql = arg1;
        this.db = arg2;
        this.type = arg3;
        this.cancelQueriesEnabled = arg4;
    }

    public void cancel() {
        if(this.cancellationHook != null) {
            this.cancellationHook.cancel();
        }
    }

    public void close() {
        if(this.cursor != null) {
            try {
                this.cursor.close();
            }
            catch(SQLException v0) {
                throw SqlExceptionUtil.create("Problems closing Android cursor", ((Throwable)v0));
            }
        }

        this.cancellationHook = null;
    }

    public void closeQuietly() {
        try {
            this.close();
        }
        catch(java.sql.SQLException v0) {
        }
    }

    static int execSql(SQLiteDatabase arg5, String arg6, String arg7, Object[] arg8) {
        int v0_3;
        Throwable v0_2;
        SQLiteStatement v1_2;
        SQLiteStatement v0_1;
        try {
            arg5.execSQL(arg7, arg8);
            v0_1 = null;
        }
        catch(SQLException v0) {
            throw SqlExceptionUtil.create("Problems executing " + arg6 + " Android statement: " + arg7, ((Throwable)v0));
        }

        try {
            v1_2 = arg5.compileStatement("SELECT CHANGES()");
        }
        catch(Throwable v1) {
            Throwable v4 = v1;
            v1_2 = v0_1;
            v0_2 = v4;
            goto label_35;
        }
        catch(SQLException v1_1) {
            v1_2 = v0_1;
            goto label_27;
        }

        try {
            v0_3 = ((int)v1_2.simpleQueryForLong());
            if(v1_2 == null) {
                goto label_8;
            }

            goto label_7;
        }
        catch(Throwable v0_2) {
        }
        catch(SQLException v0) {
        label_27:
            v0_3 = 1;
            if(v1_2 == null) {
                goto label_8;
            }

            v1_2.close();
            goto label_8;
        }

    label_35:
        if(v1_2 != null) {
            v1_2.close();
        }

        throw v0_2;
    label_7:
        v1_2.close();
    label_8:
        AndroidCompiledStatement.logger.trace("executing statement {} changed {} rows: {}", arg6, Integer.valueOf(v0_3), arg7);
        return v0_3;
    }

    private Object[] getArgArray() {
        String[] v0;
        if(this.args == null) {
            v0 = AndroidCompiledStatement.NO_STRING_ARGS;
        }
        else {
            Object[] v0_1 = this.args.toArray(new Object[this.args.size()]);
        }

        return ((Object[])v0);
    }

    public int getColumnCount() {
        return this.getCursor().getColumnCount();
    }

    public String getColumnName(int arg2) {
        return this.getCursor().getColumnName(arg2);
    }

    public Cursor getCursor() {
        if(this.cursor == null) {
            String v1 = null;
            try {
                v1 = this.max == null ? this.sql : this.sql + " " + this.max;
                if(this.cancelQueriesEnabled) {
                    this.cancellationHook = AndroidCompiledStatement.apiCompatibility.createCancellationHook();
                }

                this.cursor = AndroidCompiledStatement.apiCompatibility.rawQuery(this.db, v1, this.getStringArray(), this.cancellationHook);
                this.cursor.moveToFirst();
                AndroidCompiledStatement.logger.trace("{}: started rawQuery cursor for: {}", this, v1);
            }
            catch(SQLException v0) {
                throw SqlExceptionUtil.create("Problems executing Android query: " + v1, ((Throwable)v0));
            }
        }

        return this.cursor;
    }

    private String[] getStringArray() {
        Object[] v0_1;
        if(this.args == null) {
            String[] v0 = AndroidCompiledStatement.NO_STRING_ARGS;
        }
        else {
            v0_1 = this.args.toArray(new String[this.args.size()]);
        }

        return ((String[])v0_1);
    }

    private void isInPrep() {
        if(this.cursor != null) {
            throw new java.sql.SQLException("Query already run. Cannot add argument values.");
        }
    }

    public int runExecute() {
        if(!this.type.isOkForExecute()) {
            throw new IllegalArgumentException("Cannot call execute on a " + this.type + " statement");
        }

        return AndroidCompiledStatement.execSql(this.db, "runExecute", this.sql, this.getArgArray());
    }

    public DatabaseResults runQuery(ObjectCache arg4) {
        if(!this.type.isOkForQuery()) {
            throw new IllegalArgumentException("Cannot call query on a " + this.type + " statement");
        }

        return new AndroidDatabaseResults(this.getCursor(), arg4);
    }

    public int runUpdate() {
        if(!this.type.isOkForUpdate()) {
            throw new IllegalArgumentException("Cannot call update on a " + this.type + " statement");
        }

        String v0 = this.max == null ? this.sql : this.sql + " " + this.max;
        return AndroidCompiledStatement.execSql(this.db, "runUpdate", v0, this.getArgArray());
    }

    public void setMaxRows(int arg2) {
        this.isInPrep();
        this.max = Integer.valueOf(arg2);
    }

    public void setObject(int arg4, Object arg5, SqlType arg6) {
        this.isInPrep();
        if(this.args == null) {
            this.args = new ArrayList();
        }

        if(arg5 == null) {
            this.args.add(arg4, null);
        }
        else {
            switch(AndroidCompiledStatement$1.$SwitchMap$com$j256$ormlite$field$SqlType[arg6.ordinal()]) {
                case 1: 
                case 2: 
                case 3: 
                case 4: 
                case 5: 
                case 6: 
                case 7: 
                case 8: 
                case 9: 
                case 10: 
                case 11: {
                    goto label_24;
                }
                case 12: 
                case 13: {
                    goto label_28;
                }
                case 14: 
                case 15: {
                    goto label_31;
                }
            }

            throw new java.sql.SQLException("Unknown sql argument type: " + arg6);
        label_24:
            this.args.add(arg4, arg5.toString());
            return;
        label_28:
            this.args.add(arg4, arg5);
        }

        return;
    label_31:
        throw new java.sql.SQLException("Invalid Android type: " + arg6);
    }

    public void setQueryTimeout(long arg1) {
    }

    public String toString() {
        return this.getClass().getSimpleName() + "@" + Integer.toHexString(super.hashCode());
    }
}

