// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android;

import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.db.SqliteAndroidDatabaseType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.BaseConnectionSource;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseConnectionProxyFactory;

public class AndroidConnectionSource extends BaseConnectionSource implements ConnectionSource {
    private boolean cancelQueriesEnabled;
    private DatabaseConnection connection;
    private static DatabaseConnectionProxyFactory connectionProxyFactory;
    private final DatabaseType databaseType;
    private final SQLiteOpenHelper helper;
    private volatile boolean isOpen;
    private static final Logger logger;
    private final SQLiteDatabase sqliteDatabase;

    static {
        AndroidConnectionSource.logger = LoggerFactory.getLogger(AndroidConnectionSource.class);
    }

    public AndroidConnectionSource(SQLiteDatabase arg3) {
        super();
        this.connection = null;
        this.isOpen = true;
        this.databaseType = new SqliteAndroidDatabaseType();
        this.cancelQueriesEnabled = false;
        this.helper = null;
        this.sqliteDatabase = arg3;
    }

    public AndroidConnectionSource(SQLiteOpenHelper arg3) {
        super();
        this.connection = null;
        this.isOpen = true;
        this.databaseType = new SqliteAndroidDatabaseType();
        this.cancelQueriesEnabled = false;
        this.helper = arg3;
        this.sqliteDatabase = null;
    }

    public void clearSpecialConnection(DatabaseConnection arg2) {
        this.clearSpecial(arg2, AndroidConnectionSource.logger);
    }

    public void close() {
        this.isOpen = false;
    }

    public void closeQuietly() {
        this.close();
    }

    public DatabaseType getDatabaseType() {
        return this.databaseType;
    }

    public DatabaseConnection getReadOnlyConnection() {
        return this.getReadWriteConnection();
    }

    public DatabaseConnection getReadWriteConnection() {
        SQLiteDatabase v0_2;
        DatabaseConnection v0 = this.getSavedConnection();
        if(v0 == null) {
            if(this.connection == null) {
                if(this.sqliteDatabase == null) {
                    try {
                        v0_2 = this.helper.getWritableDatabase();
                    }
                    catch(SQLException v0_1) {
                        throw SqlExceptionUtil.create("Getting a writable database from helper " + this.helper + " failed", ((Throwable)v0_1));
                    }
                }
                else {
                    v0_2 = this.sqliteDatabase;
                }

                this.connection = new AndroidDatabaseConnection(v0_2, true, this.cancelQueriesEnabled);
                if(AndroidConnectionSource.connectionProxyFactory != null) {
                    this.connection = AndroidConnectionSource.connectionProxyFactory.createProxy(this.connection);
                }

                AndroidConnectionSource.logger.trace("created connection {} for db {}, helper {}", this.connection, v0_2, this.helper);
            }
            else {
                AndroidConnectionSource.logger.trace("{}: returning read-write connection {}, helper {}", this, this.connection, this.helper);
            }

            v0 = this.connection;
        }

        return v0;
    }

    public boolean isCancelQueriesEnabled() {
        return this.cancelQueriesEnabled;
    }

    public boolean isOpen() {
        return this.isOpen;
    }

    public void releaseConnection(DatabaseConnection arg1) {
    }

    public boolean saveSpecialConnection(DatabaseConnection arg2) {
        return this.saveSpecial(arg2);
    }

    public void setCancelQueriesEnabled(boolean arg1) {
        this.cancelQueriesEnabled = arg1;
    }

    public static void setDatabaseConnectionProxyFactory(DatabaseConnectionProxyFactory arg0) {
        AndroidConnectionSource.connectionProxyFactory = arg0;
    }

    public String toString() {
        return this.getClass().getSimpleName() + "@" + Integer.toHexString(super.hashCode());
    }
}

