// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.field.SqlType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.misc.VersionUtils;
import com.j256.ormlite.stmt.GenericRowMapper;
import com.j256.ormlite.stmt.StatementBuilder$StatementType;
import com.j256.ormlite.support.CompiledStatement;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseResults;
import com.j256.ormlite.support.GeneratedKeyHolder;
import java.sql.SQLException;
import java.sql.Savepoint;

public class AndroidDatabaseConnection implements DatabaseConnection {
    private static final String ANDROID_VERSION = "VERSION__4.48__";
    private static final String[] NO_STRING_ARGS;
    private final boolean cancelQueriesEnabled;
    private final SQLiteDatabase db;
    private static Logger logger;
    private final boolean readWrite;

    static {
        AndroidDatabaseConnection.logger = LoggerFactory.getLogger(AndroidDatabaseConnection.class);
        AndroidDatabaseConnection.NO_STRING_ARGS = new String[0];
        VersionUtils.checkCoreVersusAndroidVersions("VERSION__4.48__");
    }

    public AndroidDatabaseConnection(SQLiteDatabase arg4, boolean arg5, boolean arg6) {
        super();
        this.db = arg4;
        this.readWrite = arg5;
        this.cancelQueriesEnabled = arg6;
        AndroidDatabaseConnection.logger.trace("{}: db {} opened, read-write = {}", this, arg4, Boolean.valueOf(arg5));
    }

    public AndroidDatabaseConnection(SQLiteDatabase arg2, boolean arg3) {
        this(arg2, arg3, false);
    }

    private void bindArgs(SQLiteStatement arg6, Object[] arg7, FieldType[] arg8) {
        if(arg7 != null) {
            int v1;
            for(v1 = 0; v1 < arg7.length; ++v1) {
                Object v0 = arg7[v1];
                if(v0 == null) {
                    arg6.bindNull(v1 + 1);
                }
                else {
                    SqlType v2 = arg8[v1].getSqlType();
                    switch(AndroidDatabaseConnection$1.$SwitchMap$com$j256$ormlite$field$SqlType[v2.ordinal()]) {
                        case 1: 
                        case 2: 
                        case 3: {
                            goto label_28;
                        }
                        case 4: 
                        case 5: 
                        case 6: 
                        case 7: 
                        case 8: {
                            goto label_32;
                        }
                        case 9: 
                        case 10: {
                            goto label_36;
                        }
                        case 11: 
                        case 12: {
                            goto label_40;
                        }
                        case 13: 
                        case 14: 
                        case 15: {
                            goto label_43;
                        }
                    }

                    throw new SQLException("Unknown sql argument type: " + v2);
                label_40:
                    arg6.bindBlob(v1 + 1, ((byte[])v0));
                    goto label_10;
                label_36:
                    arg6.bindDouble(v1 + 1, ((Number)v0).doubleValue());
                    goto label_10;
                label_43:
                    throw new SQLException("Invalid Android type: " + v2);
                label_28:
                    arg6.bindString(v1 + 1, v0.toString());
                    goto label_10;
                label_32:
                    arg6.bindLong(v1 + 1, ((Number)v0).longValue());
                }

            label_10:
            }
        }
    }

    public void close() {
        try {
            this.db.close();
            AndroidDatabaseConnection.logger.trace("{}: db {} closed", this, this.db);
            return;
        }
        catch(android.database.SQLException v0) {
            throw SqlExceptionUtil.create("problems closing the database connection", ((Throwable)v0));
        }
    }

    public void closeQuietly() {
        try {
            this.close();
        }
        catch(SQLException v0) {
        }
    }

    public void commit(Savepoint arg4) {
        try {
            this.db.setTransactionSuccessful();
            this.db.endTransaction();
            if(arg4 == null) {
                AndroidDatabaseConnection.logger.trace("{}: transaction is successfuly ended", this);
            }
            else {
                AndroidDatabaseConnection.logger.trace("{}: transaction {} is successfuly ended", this, arg4.getSavepointName());
            }

            return;
        }
        catch(android.database.SQLException v0) {
            if(arg4 == null) {
                throw SqlExceptionUtil.create("problems commiting transaction", ((Throwable)v0));
            }

            throw SqlExceptionUtil.create("problems commiting transaction " + arg4.getSavepointName(), ((Throwable)v0));
        }
    }

    public CompiledStatement compileStatement(String arg4, StatementBuilder$StatementType arg5, FieldType[] arg6, int arg7) {
        AndroidCompiledStatement v0 = new AndroidCompiledStatement(arg4, this.db, arg5, this.cancelQueriesEnabled);
        AndroidDatabaseConnection.logger.trace("{}: compiled statement got {}: {}", this, v0, arg4);
        return ((CompiledStatement)v0);
    }

    public int delete(String arg2, Object[] arg3, FieldType[] arg4) {
        return this.update(arg2, arg3, arg4, "deleted");
    }

    public int executeStatement(String arg3, int arg4) {
        return AndroidCompiledStatement.execSql(this.db, arg3, arg3, AndroidDatabaseConnection.NO_STRING_ARGS);
    }

    public int insert(String arg6, Object[] arg7, FieldType[] arg8, GeneratedKeyHolder arg9) {
        SQLiteStatement v1;
        try {
            v1 = this.db.compileStatement(arg6);
            this.bindArgs(v1, arg7, arg8);
            long v2 = v1.executeInsert();
            if(arg9 != null) {
                arg9.addKey(Long.valueOf(v2));
            }

            AndroidDatabaseConnection.logger.trace("{}: insert statement is compiled and executed, changed {}: {}", this, Integer.valueOf(1), arg6);
            if(v1 == null) {
                return 1;
            }
        }
        catch(Throwable v0) {
        }
        catch(android.database.SQLException v0_1) {
            try {
                throw SqlExceptionUtil.create("inserting to database failed: " + arg6, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
                if(v1 != null) {
                    v1.close();
                }

                throw v0;
            }
        }

        v1.close();
        return 1;
    }

    public boolean isAutoCommit() {
        try {
            boolean v0_1 = this.db.inTransaction();
            AndroidDatabaseConnection.logger.trace("{}: in transaction is {}", this, Boolean.valueOf(v0_1));
            if(v0_1) {
                return false;
            }
        }
        catch(android.database.SQLException v0) {
            throw SqlExceptionUtil.create("problems getting auto-commit from database", ((Throwable)v0));
        }

        return true;
    }

    public boolean isAutoCommitSupported() {
        return 1;
    }

    public boolean isClosed() {
        try {
            boolean v0_1 = this.db.isOpen();
            AndroidDatabaseConnection.logger.trace("{}: db {} isOpen returned {}", this, this.db, Boolean.valueOf(v0_1));
            if(v0_1) {
                return false;
            }
        }
        catch(android.database.SQLException v0) {
            throw SqlExceptionUtil.create("problems detecting if the database is closed", ((Throwable)v0));
        }

        return true;
    }

    public boolean isReadWrite() {
        return this.readWrite;
    }

    public boolean isTableExists(String arg6) {
        boolean v0_1;
        Cursor v1 = this.db.rawQuery("SELECT DISTINCT tbl_name FROM sqlite_master WHERE tbl_name = \'" + arg6 + "\'", null);
        try {
            if(v1.getCount() > 0) {
                v0_1 = true;
            }
            else {
                goto label_20;
            }

            goto label_14;
        }
        catch(Throwable v0) {
            goto label_23;
        }

    label_20:
        v0_1 = false;
        try {
        label_14:
            AndroidDatabaseConnection.logger.trace("{}: isTableExists \'{}\' returned {}", this, arg6, Boolean.valueOf(v0_1));
        }
        catch(Throwable v0) {
        label_23:
            v1.close();
            throw v0;
        }

        v1.close();
        return v0_1;
    }

    public long queryForLong(String arg7) {
        long v2;
        SQLiteStatement v1;
        try {
            v1 = this.db.compileStatement(arg7);
            v2 = v1.simpleQueryForLong();
            AndroidDatabaseConnection.logger.trace("{}: query for long simple query returned {}: {}", this, Long.valueOf(v2), arg7);
            if(v1 == null) {
                return v2;
            }
        }
        catch(Throwable v0) {
        }
        catch(android.database.SQLException v0_1) {
            try {
                throw SqlExceptionUtil.create("queryForLong from database failed: " + arg7, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
                if(v1 != null) {
                    v1.close();
                }

                throw v0;
            }
        }

        v1.close();
        return v2;
    }

    public long queryForLong(String arg7, Object[] arg8, FieldType[] arg9) {
        long v2;
        Cursor v1;
        try {
            v1 = this.db.rawQuery(arg7, this.toStrings(arg8));
            AndroidDatabaseResults v0_2 = new AndroidDatabaseResults(v1, null);
            if(v0_2.first()) {
                v2 = v0_2.getLong(0);
            }
            else {
                goto label_18;
            }

            goto label_11;
        }
        catch(android.database.SQLException v0) {
            goto label_21;
        }
        catch(Throwable v0_1) {
            goto label_30;
        }

    label_18:
        v2 = 0;
        try {
        label_11:
            AndroidDatabaseConnection.logger.trace("{}: query for long raw query returned {}: {}", this, Long.valueOf(v2), arg7);
            if(v1 == null) {
                return v2;
            }
        }
        catch(Throwable v0_1) {
        }
        catch(android.database.SQLException v0) {
            try {
            label_21:
                throw SqlExceptionUtil.create("queryForLong from database failed: " + arg7, ((Throwable)v0));
            }
            catch(Throwable v0_1) {
            label_30:
                if(v1 != null) {
                    v1.close();
                }

                throw v0_1;
            }
        }

        v1.close();
        return v2;
    }

    public Object queryForOne(String arg7, Object[] arg8, FieldType[] arg9, GenericRowMapper arg10, ObjectCache arg11) {
        AndroidDatabaseResults v2;
        android.database.SQLException v0_1;
        Throwable v0_2;
        Cursor v1_2;
        Object v0 = null;
        try {
            v1_2 = this.db.rawQuery(arg7, this.toStrings(arg8));
        }
        catch(Throwable v1) {
            Throwable v5_1 = v1;
            v1_2 = ((Cursor)v0);
            v0_2 = v5_1;
            goto label_37;
        }
        catch(android.database.SQLException v1_1) {
            android.database.SQLException v5 = v1_1;
            v1_2 = ((Cursor)v0);
            v0_1 = v5;
            goto label_28;
        }

        try {
            v2 = new AndroidDatabaseResults(v1_2, arg11);
            AndroidDatabaseConnection.logger.trace("{}: queried for one result: {}", this, arg7);
            if(!v2.first()) {
            }
            else {
                goto label_14;
            }
        }
        catch(Throwable v0_2) {
            goto label_37;
        }
        catch(android.database.SQLException v0_1) {
            goto label_46;
        }

        if(v1_2 != null) {
            v1_2.close();
            return v0;
            try {
            label_14:
                v0 = arg10.mapRow(((DatabaseResults)v2));
                if(v2.next()) {
                    v0 = AndroidDatabaseConnection.MORE_THAN_ONE;
                    if(v1_2 == null) {
                        return v0;
                    }

                    goto label_19;
                }
                else {
                    goto label_21;
                }
            }
            catch(Throwable v0_2) {
            }
            catch(android.database.SQLException v0_1) {
            label_46:
                try {
                label_28:
                    throw SqlExceptionUtil.create("queryForOne from database failed: " + arg7, ((Throwable)v0_1));
                }
                catch(Throwable v0_2) {
                }
            }

        label_37:
            if(v1_2 != null) {
                v1_2.close();
            }

            throw v0_2;
        label_19:
            v1_2.close();
            return v0;
        label_21:
            if(v1_2 == null) {
                return v0;
            }

            v1_2.close();
        }

        return v0;
    }

    public void rollback(Savepoint arg4) {
        try {
            this.db.endTransaction();
            if(arg4 == null) {
                AndroidDatabaseConnection.logger.trace("{}: transaction is ended, unsuccessfuly", this);
            }
            else {
                AndroidDatabaseConnection.logger.trace("{}: transaction {} is ended, unsuccessfuly", this, arg4.getSavepointName());
            }

            return;
        }
        catch(android.database.SQLException v0) {
            if(arg4 == null) {
                throw SqlExceptionUtil.create("problems rolling back transaction", ((Throwable)v0));
            }

            throw SqlExceptionUtil.create("problems rolling back transaction " + arg4.getSavepointName(), ((Throwable)v0));
        }
    }

    public void setAutoCommit(boolean arg2) {
        if(arg2) {
            if(this.db.inTransaction()) {
                this.db.setTransactionSuccessful();
                this.db.endTransaction();
            }
        }
        else if(!this.db.inTransaction()) {
            this.db.beginTransaction();
        }
    }

    public Savepoint setSavePoint(String arg4) {
        try {
            this.db.beginTransaction();
            AndroidDatabaseConnection.logger.trace("{}: save-point set with name {}", this, arg4);
            return new AndroidDatabaseConnection$OurSavePoint(arg4);
        }
        catch(android.database.SQLException v0) {
            throw SqlExceptionUtil.create("problems beginning transaction " + arg4, ((Throwable)v0));
        }
    }

    public String toString() {
        return this.getClass().getSimpleName() + "@" + Integer.toHexString(super.hashCode());
    }

    private String[] toStrings(Object[] arg5) {
        String[] v0_1;
        String v2 = null;
        if(arg5 == null || arg5.length == 0) {
            v0_1 = ((String[])v2);
        }
        else {
            String[] v1 = new String[arg5.length];
            int v0;
            for(v0 = 0; v0 < arg5.length; ++v0) {
                Object v3 = arg5[v0];
                v1[v0] = v3 == null ? v2 : v3.toString();
            }

            v0_1 = v1;
        }

        return v0_1;
    }

    private int update(String arg6, Object[] arg7, FieldType[] arg8, String arg9) {
        int v0_3;
        SQLiteStatement v1;
        SQLiteStatement v2 = null;
        try {
            v1 = this.db.compileStatement(arg6);
        }
        catch(Throwable v0) {
            v1 = v2;
            goto label_31;
        }
        catch(android.database.SQLException v0_1) {
            v1 = v2;
            goto label_22;
        }

        try {
            this.bindArgs(v1, arg7, arg8);
            v1.execute();
            if(v1 == null) {
                goto label_56;
            }

            goto label_6;
        }
        catch(Throwable v0) {
        }
        catch(android.database.SQLException v0_1) {
            try {
            label_22:
                throw SqlExceptionUtil.create("updating database failed: " + arg6, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
            }
        }

    label_31:
        if(v1 != null) {
            v1.close();
        }

        throw v0;
    label_6:
        v1.close();
        SQLiteStatement v0_2 = v2;
        goto label_8;
    label_56:
        v0_2 = v1;
        try {
        label_8:
            v1 = this.db.compileStatement("SELECT CHANGES()");
        }
        catch(Throwable v1_1) {
            Throwable v4 = v1_1;
            v1 = v0_2;
            v0 = v4;
            goto label_44;
        }
        catch(android.database.SQLException v1_2) {
            v1 = v0_2;
            goto label_36;
        }

        try {
            v0_3 = ((int)v1.simpleQueryForLong());
            if(v1 == null) {
                goto label_15;
            }

            goto label_14;
        }
        catch(Throwable v0) {
        }
        catch(android.database.SQLException v0_1) {
        label_36:
            v0_3 = 1;
            if(v1 == null) {
                goto label_15;
            }

            v1.close();
            goto label_15;
        }

    label_44:
        if(v1 != null) {
            v1.close();
        }

        throw v0;
    label_14:
        v1.close();
    label_15:
        AndroidDatabaseConnection.logger.trace("{} statement is compiled and executed, changed {}: {}", arg9, Integer.valueOf(v0_3), arg6);
        return v0_3;
    }

    public int update(String arg2, Object[] arg3, FieldType[] arg4) {
        return this.update(arg2, arg3, arg4, "updated");
    }
}

