// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android;

import android.database.Cursor;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.db.SqliteAndroidDatabaseType;
import com.j256.ormlite.support.DatabaseResults;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class AndroidDatabaseResults implements DatabaseResults {
    private static final int MIN_NUM_COLUMN_NAMES_MAP = 8;
    private final Map columnNameMap;
    private final String[] columnNames;
    private final Cursor cursor;
    private static final DatabaseType databaseType;
    private final ObjectCache objectCache;

    static {
        AndroidDatabaseResults.databaseType = new SqliteAndroidDatabaseType();
    }

    public AndroidDatabaseResults(Cursor arg5, ObjectCache arg6) {
        super();
        this.cursor = arg5;
        this.columnNames = arg5.getColumnNames();
        if(this.columnNames.length >= 8) {
            this.columnNameMap = new HashMap();
            int v0;
            for(v0 = 0; v0 < this.columnNames.length; ++v0) {
                this.columnNameMap.put(this.columnNames[v0], Integer.valueOf(v0));
            }
        }
        else {
            this.columnNameMap = null;
        }

        this.objectCache = arg6;
    }

    @Deprecated public AndroidDatabaseResults(Cursor arg1, boolean arg2, ObjectCache arg3) {
        this(arg1, arg3);
    }

    public void close() {
        this.cursor.close();
    }

    public void closeQuietly() {
        this.close();
    }

    public int findColumn(String arg5) {
        int v0 = this.lookupColumn(arg5);
        if(v0 < 0) {
            StringBuilder v0_1 = new StringBuilder(arg5.length() + 4);
            AndroidDatabaseResults.databaseType.appendEscapedEntityName(v0_1, arg5);
            v0 = this.lookupColumn(v0_1.toString());
            if(v0 < 0) {
                throw new SQLException("Unknown field \'" + arg5 + "\' from the Android sqlite cursor, not in:" + Arrays.toString(this.cursor.getColumnNames()));
            }
        }

        return v0;
    }

    public boolean first() {
        return this.cursor.moveToFirst();
    }

    public BigDecimal getBigDecimal(int arg3) {
        throw new SQLException("Android does not support BigDecimal type.  Use BIG_DECIMAL or BIG_DECIMAL_STRING types");
    }

    public InputStream getBlobStream(int arg3) {
        return new ByteArrayInputStream(this.cursor.getBlob(arg3));
    }

    public boolean getBoolean(int arg2) {
        boolean v0 = (this.cursor.isNull(arg2)) || this.cursor.getShort(arg2) == 0 ? false : true;
        return v0;
    }

    public byte getByte(int arg2) {
        return ((byte)this.getShort(arg2));
    }

    public byte[] getBytes(int arg2) {
        return this.cursor.getBlob(arg2);
    }

    public char getChar(int arg5) {
        char v0 = '\u0000';
        String v1 = this.cursor.getString(arg5);
        if(v1 != null && v1.length() != 0) {
            if(v1.length() == 1) {
                v0 = v1.charAt(0);
            }
            else {
                throw new SQLException("More than 1 character stored in database column: " + arg5);
            }
        }

        return v0;
    }

    public int getColumnCount() {
        return this.cursor.getColumnCount();
    }

    public String[] getColumnNames() {
        int v1 = this.getColumnCount();
        String[] v2 = new String[v1];
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            v2[v0] = this.cursor.getColumnName(v0);
        }

        return v2;
    }

    public int getCount() {
        return this.cursor.getCount();
    }

    public double getDouble(int arg3) {
        return this.cursor.getDouble(arg3);
    }

    public float getFloat(int arg2) {
        return this.cursor.getFloat(arg2);
    }

    public int getInt(int arg2) {
        return this.cursor.getInt(arg2);
    }

    public long getLong(int arg3) {
        return this.cursor.getLong(arg3);
    }

    public ObjectCache getObjectCache() {
        return this.objectCache;
    }

    public int getPosition() {
        return this.cursor.getPosition();
    }

    public Cursor getRawCursor() {
        return this.cursor;
    }

    public short getShort(int arg2) {
        return this.cursor.getShort(arg2);
    }

    public String getString(int arg2) {
        return this.cursor.getString(arg2);
    }

    public Timestamp getTimestamp(int arg3) {
        throw new SQLException("Android does not support timestamp.  Use JAVA_DATE_LONG or JAVA_DATE_STRING types");
    }

    public boolean last() {
        return this.cursor.moveToLast();
    }

    private int lookupColumn(String arg4) {
        int v0;
        int v1 = -1;
        if(this.columnNameMap == null) {
            v0 = 0;
            while(true) {
                if(v0 >= this.columnNames.length) {
                    break;
                }
                else if(!this.columnNames[v0].equals(arg4)) {
                    ++v0;
                    continue;
                }

                return v0;
            }

            v0 = v1;
        }
        else {
            Object v0_1 = this.columnNameMap.get(arg4);
            v0 = v0_1 == null ? v1 : ((Integer)v0_1).intValue();
        }

        return v0;
    }

    public boolean moveAbsolute(int arg2) {
        return this.cursor.moveToPosition(arg2);
    }

    public boolean moveRelative(int arg2) {
        return this.cursor.move(arg2);
    }

    public boolean next() {
        return this.cursor.moveToNext();
    }

    public boolean previous() {
        return this.cursor.moveToPrevious();
    }

    public String toString() {
        return this.getClass().getSimpleName() + "@" + Integer.toHexString(super.hashCode());
    }

    public boolean wasNull(int arg2) {
        return this.cursor.isNull(arg2);
    }
}

