// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android.apptools;

import android.content.Context;
import android.content.res.Resources;
import com.j256.ormlite.dao.BaseDaoImpl;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import java.lang.reflect.Constructor;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;

public class OpenHelperManager {
    private static final String HELPER_CLASS_RESOURCE_NAME = "open_helper_classname";
    private static volatile OrmLiteSqliteOpenHelper helper;
    private static Class helperClass;
    private static int instanceCount;
    private static Logger logger;
    private static boolean wasClosed;

    static {
        OpenHelperManager.logger = LoggerFactory.getLogger(OpenHelperManager.class);
        OpenHelperManager.helperClass = null;
        OpenHelperManager.helper = null;
        OpenHelperManager.wasClosed = false;
        OpenHelperManager.instanceCount = 0;
    }

    public OpenHelperManager() {
        super();
    }

    private static OrmLiteSqliteOpenHelper constructHelper(Context arg4, Class arg5) {
        Constructor v0_1;
        try {
            v0_1 = arg5.getConstructor(Context.class);
        }
        catch(Exception v0) {
            throw new IllegalStateException("Could not find public constructor that has a single (Context) argument for helper class " + arg5, ((Throwable)v0));
        }

        try {
            return v0_1.newInstance(arg4);
        }
        catch(Exception v0) {
            throw new IllegalStateException("Could not construct instance of helper class " + arg5, ((Throwable)v0));
        }
    }

    @Deprecated public static OrmLiteSqliteOpenHelper getHelper(Context arg3) {
        OrmLiteSqliteOpenHelper v0_1;
        Class v1 = OpenHelperManager.class;
        __monitor_enter(v1);
        try {
            if(OpenHelperManager.helperClass == null) {
                if(arg3 == null) {
                    throw new IllegalArgumentException("context argument is null");
                }
                else {
                    OpenHelperManager.innerSetHelperClass(OpenHelperManager.lookupHelperClass(arg3.getApplicationContext(), arg3.getClass()));
                }
            }

            v0_1 = OpenHelperManager.loadHelper(arg3, OpenHelperManager.helperClass);
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
        return v0_1;
    }

    public static OrmLiteSqliteOpenHelper getHelper(Context arg3, Class arg4) {
        OrmLiteSqliteOpenHelper v0_1;
        Class v1 = OpenHelperManager.class;
        __monitor_enter(v1);
        if(arg4 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("openHelperClass argument is null");
        label_10:
            OpenHelperManager.innerSetHelperClass(arg4);
            v0_1 = OpenHelperManager.loadHelper(arg3, arg4);
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
        return v0_1;
    }

    private static void innerSetHelperClass(Class arg3) {
        if(arg3 == null) {
            throw new IllegalStateException("Helper class was trying to be reset to null");
        }

        if(OpenHelperManager.helperClass == null) {
            OpenHelperManager.helperClass = arg3;
        }
        else if(OpenHelperManager.helperClass != arg3) {
            throw new IllegalStateException("Helper class was " + OpenHelperManager.helperClass + " but is trying to be reset to " + arg3);
        }
    }

    private static OrmLiteSqliteOpenHelper loadHelper(Context arg4, Class arg5) {
        if(OpenHelperManager.helper == null) {
            if(OpenHelperManager.wasClosed) {
                OpenHelperManager.logger.info("helper was already closed and is being re-opened");
            }

            if(arg4 == null) {
                throw new IllegalArgumentException("context argument is null");
            }

            OpenHelperManager.helper = OpenHelperManager.constructHelper(arg4.getApplicationContext(), arg5);
            OpenHelperManager.logger.trace("zero instances, created helper {}", OpenHelperManager.helper);
            BaseDaoImpl.clearAllInternalObjectCaches();
            DaoManager.clearDaoCache();
            OpenHelperManager.instanceCount = 0;
        }

        ++OpenHelperManager.instanceCount;
        OpenHelperManager.logger.trace("returning helper {}, instance count = {} ", OpenHelperManager.helper, Integer.valueOf(OpenHelperManager.instanceCount));
        return OpenHelperManager.helper;
    }

    private static Class lookupHelperClass(Context arg6, Class arg7) {
        Type v0_3;
        Class v0_2;
        Resources v0 = arg6.getResources();
        int v1 = v0.getIdentifier("open_helper_classname", "string", arg6.getPackageName());
        if(v1 != 0) {
            String v0_1 = v0.getString(v1);
            try {
                v0_2 = Class.forName(v0_1);
            }
            catch(Exception v1_1) {
                throw new IllegalStateException("Could not create helper instance for class " + (((String)v0_2)), ((Throwable)v1_1));
            }
        }
        else {
            Class v2;
            for(v2 = arg7; v2 != null; v2 = v2.getSuperclass()) {
                v0_3 = v2.getGenericSuperclass();
                if(v0_3 != null && ((v0_3 instanceof ParameterizedType))) {
                    Type[] v3 = ((ParameterizedType)v0_3).getActualTypeArguments();
                    if(v3 != null && v3.length != 0) {
                        int v4 = v3.length;
                        for(v1 = 0; v1 < v4; ++v1) {
                            v0_3 = v3[v1];
                            if(((v0_3 instanceof Class)) && (OrmLiteSqliteOpenHelper.class.isAssignableFrom(((Class)v0_3)))) {
                                goto label_8;
                            }
                        }
                    }
                }
            }

            throw new IllegalStateException("Could not find OpenHelperClass because none of the generic parameters of class " + arg7 + " extends OrmLiteSqliteOpenHelper.  You should use getHelper(Context, Class) instead.");
        }

    label_8:
        return ((Class)v0_3);
    }

    @Deprecated public static void release() {
        OpenHelperManager.releaseHelper();
    }

    public static void releaseHelper() {
        Class v1 = OpenHelperManager.class;
        __monitor_enter(v1);
        try {
            --OpenHelperManager.instanceCount;
            OpenHelperManager.logger.trace("releasing helper {}, instance count = {}", OpenHelperManager.helper, Integer.valueOf(OpenHelperManager.instanceCount));
            if(OpenHelperManager.instanceCount <= 0) {
                if(OpenHelperManager.helper != null) {
                    OpenHelperManager.logger.trace("zero instances, closing helper {}", OpenHelperManager.helper);
                    OpenHelperManager.helper.close();
                    OpenHelperManager.helper = null;
                    OpenHelperManager.wasClosed = true;
                }

                if(OpenHelperManager.instanceCount >= 0) {
                    goto label_32;
                }

                OpenHelperManager.logger.error("too many calls to release helper, instance count = {}", Integer.valueOf(OpenHelperManager.instanceCount));
            }
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

    label_32:
        __monitor_exit(v1);
    }

    public static void setHelper(OrmLiteSqliteOpenHelper arg2) {
        Class v0 = OpenHelperManager.class;
        __monitor_enter(v0);
        try {
            OpenHelperManager.helper = arg2;
        }
        catch(Throwable v1) {
            __monitor_exit(v0);
            throw v1;
        }

        __monitor_exit(v0);
    }

    public static void setOpenHelperClass(Class arg2) {
        Class v1 = OpenHelperManager.class;
        __monitor_enter(v1);
        if(arg2 == null) {
            Class v0 = null;
            try {
                OpenHelperManager.helperClass = v0;
                goto label_5;
            label_7:
                OpenHelperManager.innerSetHelperClass(arg2);
            }
            catch(Throwable v0_1) {
                __monitor_exit(v1);
                throw v0_1;
            }
        }
        else {
            goto label_7;
        }

    label_5:
        __monitor_exit(v1);
    }
}

