// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android.apptools;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.support.ConnectionSource;

public abstract class OrmLiteBaseActivity extends Activity {
    private volatile boolean created;
    private volatile boolean destroyed;
    private volatile OrmLiteSqliteOpenHelper helper;
    private static Logger logger;

    static {
        OrmLiteBaseActivity.logger = LoggerFactory.getLogger(OrmLiteBaseActivity.class);
    }

    public OrmLiteBaseActivity() {
        super();
        this.created = false;
        this.destroyed = false;
    }

    public ConnectionSource getConnectionSource() {
        return this.getHelper().getConnectionSource();
    }

    public OrmLiteSqliteOpenHelper getHelper() {
        if(this.helper == null) {
            if(!this.created) {
                throw new IllegalStateException("A call has not been made to onCreate() yet so the helper is null");
            }

            if(this.destroyed) {
                throw new IllegalStateException("A call to onDestroy has already been made and the helper cannot be used after that point");
            }

            throw new IllegalStateException("Helper is null for some unknown reason");
        }

        return this.helper;
    }

    protected OrmLiteSqliteOpenHelper getHelperInternal(Context arg4) {
        OrmLiteSqliteOpenHelper v0 = OpenHelperManager.getHelper(arg4);
        OrmLiteBaseActivity.logger.trace("{}: got new helper {} from OpenHelperManager", this, v0);
        return v0;
    }

    protected void onCreate(Bundle arg2) {
        if(this.helper == null) {
            this.helper = this.getHelperInternal(((Context)this));
            this.created = true;
        }

        super.onCreate(arg2);
    }

    protected void onDestroy() {
        super.onDestroy();
        this.releaseHelper(this.helper);
        this.destroyed = true;
    }

    protected void releaseHelper(OrmLiteSqliteOpenHelper arg3) {
        OpenHelperManager.releaseHelper();
        OrmLiteBaseActivity.logger.trace("{}: helper {} was released, set to null", this, arg3);
        this.helper = null;
    }

    public String toString() {
        return this.getClass().getSimpleName() + "@" + Integer.toHexString(super.hashCode());
    }
}

