// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android.apptools;

import android.app.TabActivity;
import android.content.Context;
import android.os.Bundle;
import com.j256.ormlite.support.ConnectionSource;

public abstract class OrmLiteBaseTabActivity extends TabActivity {
    private volatile boolean created;
    private volatile boolean destroyed;
    private volatile OrmLiteSqliteOpenHelper helper;

    public OrmLiteBaseTabActivity() {
        super();
        this.created = false;
        this.destroyed = false;
    }

    public ConnectionSource getConnectionSource() {
        return this.getHelper().getConnectionSource();
    }

    public OrmLiteSqliteOpenHelper getHelper() {
        if(this.helper == null) {
            if(!this.created) {
                throw new IllegalStateException("A call has not been made to onCreate() yet so the helper is null");
            }

            if(this.destroyed) {
                throw new IllegalStateException("A call to onDestroy has already been made and the helper cannot be used after that point");
            }

            throw new IllegalStateException("Helper is null for some unknown reason");
        }

        return this.helper;
    }

    protected OrmLiteSqliteOpenHelper getHelperInternal(Context arg2) {
        return OpenHelperManager.getHelper(arg2);
    }

    protected void onCreate(Bundle arg2) {
        if(this.helper == null) {
            this.helper = this.getHelperInternal(((Context)this));
            this.created = true;
        }

        super.onCreate(arg2);
    }

    protected void onDestroy() {
        super.onDestroy();
        this.releaseHelper(this.helper);
        this.destroyed = true;
    }

    protected void releaseHelper(OrmLiteSqliteOpenHelper arg2) {
        OpenHelperManager.releaseHelper();
        this.helper = null;
    }
}

