// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.android.apptools;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase$CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;
import com.j256.ormlite.android.AndroidConnectionSource;
import com.j256.ormlite.android.AndroidDatabaseConnection;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.dao.RuntimeExceptionDao;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.table.DatabaseTableConfigLoader;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.sql.SQLException;

public abstract class OrmLiteSqliteOpenHelper extends SQLiteOpenHelper {
    protected boolean cancelQueriesEnabled;
    protected AndroidConnectionSource connectionSource;
    private volatile boolean isOpen;
    protected static Logger logger;

    static {
        OrmLiteSqliteOpenHelper.logger = LoggerFactory.getLogger(OrmLiteSqliteOpenHelper.class);
    }

    public OrmLiteSqliteOpenHelper(Context arg4, String arg5, SQLiteDatabase$CursorFactory arg6, int arg7) {
        super(arg4, arg5, arg6, arg7);
        this.connectionSource = new AndroidConnectionSource(((SQLiteOpenHelper)this));
        this.isOpen = true;
        OrmLiteSqliteOpenHelper.logger.trace("{}: constructed connectionSource {}", this, this.connectionSource);
    }

    public OrmLiteSqliteOpenHelper(Context arg7, String arg8, SQLiteDatabase$CursorFactory arg9, int arg10, int arg11) {
        this(arg7, arg8, arg9, arg10, OrmLiteSqliteOpenHelper.openFileId(arg7, arg11));
    }

    public OrmLiteSqliteOpenHelper(Context arg4, String arg5, SQLiteDatabase$CursorFactory arg6, int arg7, InputStream arg8) {
        super(arg4, arg5, arg6, arg7);
        this.connectionSource = new AndroidConnectionSource(((SQLiteOpenHelper)this));
        this.isOpen = true;
        if(arg8 != null) {
            try {
                DaoManager.addCachedDatabaseConfigs(DatabaseTableConfigLoader.loadDatabaseConfigFromReader(new BufferedReader(new InputStreamReader(arg8), 4096)));
            }
            catch(Throwable v0) {
            }
            catch(SQLException v0_1) {
                try {
                    throw new IllegalStateException("Could not load object config file", ((Throwable)v0_1));
                }
                catch(Throwable v0) {
                    try {
                        arg8.close();
                    }
                    catch(IOException v1) {
                    }

                    throw v0;
                }
            }

            try {
                arg8.close();
            }
            catch(IOException v0_2) {
            }
        }
    }

    public OrmLiteSqliteOpenHelper(Context arg7, String arg8, SQLiteDatabase$CursorFactory arg9, int arg10, File arg11) {
        this(arg7, arg8, arg9, arg10, OrmLiteSqliteOpenHelper.openFile(arg11));
    }

    public void close() {
        super.close();
        this.connectionSource.close();
        this.isOpen = false;
    }

    public ConnectionSource getConnectionSource() {
        if(!this.isOpen) {
            OrmLiteSqliteOpenHelper.logger.warn(new IllegalStateException(), "Getting connectionSource was called after closed");
        }

        return this.connectionSource;
    }

    public Dao getDao(Class arg2) {
        return DaoManager.createDao(this.getConnectionSource(), arg2);
    }

    public RuntimeExceptionDao getRuntimeExceptionDao(Class arg5) {
        try {
            return new RuntimeExceptionDao(this.getDao(arg5));
        }
        catch(SQLException v0) {
            throw new RuntimeException("Could not create RuntimeExcepitionDao for class " + arg5, ((Throwable)v0));
        }
    }

    public boolean isOpen() {
        return this.isOpen;
    }

    public final void onCreate(SQLiteDatabase arg5) {
        DatabaseConnection v1_1;
        int v0 = 1;
        ConnectionSource v3 = this.getConnectionSource();
        DatabaseConnection v2 = v3.getSpecialConnection();
        if(v2 == null) {
            AndroidDatabaseConnection v1 = new AndroidDatabaseConnection(arg5, true, this.cancelQueriesEnabled);
            try {
                v3.saveSpecialConnection(((DatabaseConnection)v1));
            }
            catch(SQLException v0_1) {
                throw new IllegalStateException("Could not save special connection", ((Throwable)v0_1));
            }
        }
        else {
            v0 = 0;
            v1_1 = v2;
        }

        try {
            this.onCreate(arg5, v3);
            if(v0 == 0) {
                return;
            }
        }
        catch(Throwable v2_1) {
            if(v0 != 0) {
                v3.clearSpecialConnection(v1_1);
            }

            throw v2_1;
        }

        v3.clearSpecialConnection(v1_1);
    }

    public abstract void onCreate(SQLiteDatabase arg1, ConnectionSource arg2);

    public final void onUpgrade(SQLiteDatabase arg5, int arg6, int arg7) {
        AndroidDatabaseConnection v1;
        int v0 = 1;
        ConnectionSource v3 = this.getConnectionSource();
        DatabaseConnection v2 = v3.getSpecialConnection();
        if(v2 == null) {
            v1 = new AndroidDatabaseConnection(arg5, true, this.cancelQueriesEnabled);
            try {
                v3.saveSpecialConnection(((DatabaseConnection)v1));
            }
            catch(SQLException v0_1) {
                throw new IllegalStateException("Could not save special connection", ((Throwable)v0_1));
            }
        }
        else {
            v0 = 0;
            DatabaseConnection v1_1 = v2;
        }

        try {
            this.onUpgrade(arg5, v3, arg6, arg7);
            if(v0 == 0) {
                return;
            }
        }
        catch(Throwable v2_1) {
            if(v0 != 0) {
                v3.clearSpecialConnection(((DatabaseConnection)v1));
            }

            throw v2_1;
        }

        v3.clearSpecialConnection(((DatabaseConnection)v1));
    }

    public abstract void onUpgrade(SQLiteDatabase arg1, ConnectionSource arg2, int arg3, int arg4);

    private static InputStream openFile(File arg4) {
        FileInputStream v0_2;
        if(arg4 == null) {
            InputStream v0 = null;
        }
        else {
            try {
                v0_2 = new FileInputStream(arg4);
            }
            catch(FileNotFoundException v0_1) {
                throw new IllegalArgumentException("Could not open config file " + arg4, ((Throwable)v0_1));
            }
        }

        return ((InputStream)v0_2);
    }

    private static InputStream openFileId(Context arg3, int arg4) {
        InputStream v0 = arg3.getResources().openRawResource(arg4);
        if(v0 == null) {
            throw new IllegalStateException("Could not find object config file with id " + arg4);
        }

        return v0;
    }

    public String toString() {
        return this.getClass().getSimpleName() + "@" + Integer.toHexString(super.hashCode());
    }
}

