// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.dao;

import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.DataType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.misc.BaseDaoEnabled;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.stmt.DeleteBuilder;
import com.j256.ormlite.stmt.GenericRowMapper;
import com.j256.ormlite.stmt.PreparedDelete;
import com.j256.ormlite.stmt.PreparedQuery;
import com.j256.ormlite.stmt.PreparedStmt;
import com.j256.ormlite.stmt.PreparedUpdate;
import com.j256.ormlite.stmt.QueryBuilder;
import com.j256.ormlite.stmt.SelectArg;
import com.j256.ormlite.stmt.StatementBuilder$StatementType;
import com.j256.ormlite.stmt.StatementExecutor;
import com.j256.ormlite.stmt.UpdateBuilder;
import com.j256.ormlite.stmt.Where;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseResults;
import com.j256.ormlite.table.DatabaseTableConfig;
import com.j256.ormlite.table.ObjectFactory;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map$Entry;
import java.util.concurrent.Callable;

public abstract class BaseDaoImpl implements Dao {
    protected ConnectionSource connectionSource;
    private static final ThreadLocal daoConfigLevelLocal;
    protected final Class dataClass;
    protected DatabaseType databaseType;
    private static ReferenceObjectCache defaultObjectCache;
    private boolean initialized;
    protected CloseableIterator lastIterator;
    private ObjectCache objectCache;
    protected ObjectFactory objectFactory;
    protected StatementExecutor statementExecutor;
    protected DatabaseTableConfig tableConfig;
    protected TableInfo tableInfo;

    static {
        BaseDaoImpl.daoConfigLevelLocal = new BaseDaoImpl$1();
    }

    protected BaseDaoImpl(ConnectionSource arg2, DatabaseTableConfig arg3) {
        this(arg2, arg3.getDataClass(), arg3);
    }

    private BaseDaoImpl(ConnectionSource arg1, Class arg2, DatabaseTableConfig arg3) {
        super();
        this.dataClass = arg2;
        this.tableConfig = arg3;
        if(arg1 != null) {
            this.connectionSource = arg1;
            this.initialize();
        }
    }

    public BaseDaoImpl(ConnectionSource arg2, Class arg3) {
        this(arg2, arg3, null);
    }

    protected BaseDaoImpl(Class arg2) {
        this(null, arg2, null);
    }

    static CloseableIterator access$000(BaseDaoImpl arg1, int arg2) {
        return arg1.createIterator(arg2);
    }

    static CloseableIterator access$100(BaseDaoImpl arg1, PreparedQuery arg2, int arg3) {
        return arg1.createIterator(arg2, arg3);
    }

    public void assignEmptyForeignCollection(Object arg1, String arg2) {
        this.makeEmptyForeignCollection(arg1, arg2);
    }

    public Object callBatchTasks(Callable arg4) {
        Object v0_1;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
        try {
            v0_1 = this.statementExecutor.callBatchTasks(v1, this.connectionSource.saveSpecialConnection(v1), arg4);
        }
        catch(Throwable v0) {
            this.connectionSource.clearSpecialConnection(v1);
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.clearSpecialConnection(v1);
        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    protected void checkForInitialized() {
        if(!this.initialized) {
            throw new IllegalStateException("you must call initialize() before you can use the dao");
        }
    }

    public static void clearAllInternalObjectCaches() {
        Class v1 = BaseDaoImpl.class;
        __monitor_enter(v1);
        try {
            if(BaseDaoImpl.defaultObjectCache != null) {
                BaseDaoImpl.defaultObjectCache.clearAll();
                BaseDaoImpl.defaultObjectCache = null;
            }
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
    }

    public void clearObjectCache() {
        if(this.objectCache != null) {
            this.objectCache.clear(this.dataClass);
        }
    }

    public void closeLastIterator() {
        if(this.lastIterator != null) {
            this.lastIterator.close();
            this.lastIterator = null;
        }
    }

    public CloseableIterator closeableIterator() {
        return this.iterator(-1);
    }

    public void commit(DatabaseConnection arg2) {
        arg2.commit(null);
    }

    public long countOf() {
        long v2;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v2 = this.statementExecutor.queryForCountStar(v1);
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v2;
    }

    public long countOf(PreparedQuery arg5) {
        long v2;
        this.checkForInitialized();
        if(arg5.getType() != StatementBuilder$StatementType.SELECT_LONG) {
            throw new IllegalArgumentException("Prepared query is not of type " + StatementBuilder$StatementType.SELECT_LONG + ", did you call QueryBuilder.setCountOf(true)?");
        }

        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v2 = this.statementExecutor.queryForLong(v1, ((PreparedStmt)arg5));
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v2;
    }

    public int create(Object arg4) {
        int v0;
        this.checkForInitialized();
        if(arg4 == null) {
            v0 = 0;
        }
        else {
            if((arg4 instanceof BaseDaoEnabled)) {
                arg4.setDao(((Dao)this));
            }

            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0 = this.statementExecutor.create(v1, arg4, this.objectCache);
            }
            catch(Throwable v0_1) {
                this.connectionSource.releaseConnection(v1);
                throw v0_1;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0;
    }

    static Dao createDao(ConnectionSource arg1, DatabaseTableConfig arg2) {
        return new BaseDaoImpl$5(arg1, arg2);
    }

    static Dao createDao(ConnectionSource arg1, Class arg2) {
        return new BaseDaoImpl$4(arg1, arg2);
    }

    public Object createIfNotExists(Object arg2) {
        if(arg2 == null) {
            arg2 = null;
        }
        else {
            Object v0 = this.queryForSameId(arg2);
            if(v0 == null) {
                this.create(arg2);
            }
            else {
                arg2 = v0;
            }
        }

        return arg2;
    }

    private CloseableIterator createIterator(int arg5) {
        try {
            return this.statementExecutor.buildIterator(this, this.connectionSource, arg5, this.objectCache);
        }
        catch(Exception v0) {
            throw new IllegalStateException("Could not build iterator for " + this.dataClass, ((Throwable)v0));
        }
    }

    private CloseableIterator createIterator(PreparedQuery arg7, int arg8) {
        try {
            return this.statementExecutor.buildIterator(this, this.connectionSource, arg7, this.objectCache, arg8);
        }
        catch(SQLException v0) {
            throw SqlExceptionUtil.create("Could not build prepared-query iterator for " + this.dataClass, ((Throwable)v0));
        }
    }

    public Dao$CreateOrUpdateStatus createOrUpdate(Object arg5) {
        Dao$CreateOrUpdateStatus v0;
        if(arg5 == null) {
            v0 = new Dao$CreateOrUpdateStatus(false, false, 0);
        }
        else {
            Object v0_1 = this.extractId(arg5);
            if(v0_1 != null && (this.idExists(v0_1))) {
                return new Dao$CreateOrUpdateStatus(false, true, this.update(arg5));
            }

            v0 = new Dao$CreateOrUpdateStatus(true, false, this.create(arg5));
        }

        return v0;
    }

    public int delete(PreparedDelete arg4) {
        int v0_1;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
        try {
            v0_1 = this.statementExecutor.delete(v1, arg4);
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    public int delete(Object arg4) {
        int v0;
        this.checkForInitialized();
        if(arg4 == null) {
            v0 = 0;
        }
        else {
            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0 = this.statementExecutor.delete(v1, arg4, this.objectCache);
            }
            catch(Throwable v0_1) {
                this.connectionSource.releaseConnection(v1);
                throw v0_1;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0;
    }

    public int delete(Collection arg4) {
        int v0_1;
        this.checkForInitialized();
        if(arg4 == null || (arg4.isEmpty())) {
            v0_1 = 0;
        }
        else {
            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0_1 = this.statementExecutor.deleteObjects(v1, arg4, this.objectCache);
            }
            catch(Throwable v0) {
                this.connectionSource.releaseConnection(v1);
                throw v0;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0_1;
    }

    public DeleteBuilder deleteBuilder() {
        this.checkForInitialized();
        return new DeleteBuilder(this.databaseType, this.tableInfo, ((Dao)this));
    }

    public int deleteById(Object arg4) {
        int v0;
        this.checkForInitialized();
        if(arg4 == null) {
            v0 = 0;
        }
        else {
            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0 = this.statementExecutor.deleteById(v1, arg4, this.objectCache);
            }
            catch(Throwable v0_1) {
                this.connectionSource.releaseConnection(v1);
                throw v0_1;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0;
    }

    public int deleteIds(Collection arg4) {
        int v0_1;
        this.checkForInitialized();
        if(arg4 == null || (arg4.isEmpty())) {
            v0_1 = 0;
        }
        else {
            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0_1 = this.statementExecutor.deleteIds(v1, arg4, this.objectCache);
            }
            catch(Throwable v0) {
                this.connectionSource.releaseConnection(v1);
                throw v0;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0_1;
    }

    public void endThreadConnection(DatabaseConnection arg2) {
        this.connectionSource.clearSpecialConnection(arg2);
        this.connectionSource.releaseConnection(arg2);
    }

    public int executeRaw(String arg5, String[] arg6) {
        int v0_2;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
        try {
            v0_2 = this.statementExecutor.executeRaw(v1, arg5, arg6);
        }
        catch(Throwable v0) {
        }
        catch(SQLException v0_1) {
            try {
                throw SqlExceptionUtil.create("Could not run raw execute statement " + arg5, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
                this.connectionSource.releaseConnection(v1);
                throw v0;
            }
        }

        this.connectionSource.releaseConnection(v1);
        return v0_2;
    }

    public int executeRawNoArgs(String arg5) {
        int v0_2;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
        try {
            v0_2 = this.statementExecutor.executeRawNoArgs(v1, arg5);
        }
        catch(Throwable v0) {
        }
        catch(SQLException v0_1) {
            try {
                throw SqlExceptionUtil.create("Could not run raw execute statement " + arg5, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
                this.connectionSource.releaseConnection(v1);
                throw v0;
            }
        }

        this.connectionSource.releaseConnection(v1);
        return v0_2;
    }

    public Object extractId(Object arg4) {
        this.checkForInitialized();
        FieldType v0 = this.tableInfo.getIdField();
        if(v0 == null) {
            throw new SQLException("Class " + this.dataClass + " does not have an id field");
        }

        return v0.extractJavaFieldValue(arg4);
    }

    public FieldType findForeignFieldType(Class arg6) {
        FieldType v0;
        this.checkForInitialized();
        FieldType[] v2 = this.tableInfo.getFieldTypes();
        int v3 = v2.length;
        int v1 = 0;
        while(true) {
            if(v1 < v3) {
                v0 = v2[v1];
                if(v0.getType() != arg6) {
                    ++v1;
                    continue;
                }
            }
            else {
                return null;
            }

            return v0;
        }

        return null;
    }

    public ConnectionSource getConnectionSource() {
        return this.connectionSource;
    }

    public Class getDataClass() {
        return this.dataClass;
    }

    public ForeignCollection getEmptyForeignCollection(String arg2) {
        return this.makeEmptyForeignCollection(null, arg2);
    }

    public ObjectCache getObjectCache() {
        return this.objectCache;
    }

    public ObjectFactory getObjectFactory() {
        return this.objectFactory;
    }

    public RawRowMapper getRawRowMapper() {
        return this.statementExecutor.getRawRowMapper();
    }

    public GenericRowMapper getSelectStarRowMapper() {
        return this.statementExecutor.getSelectStarRowMapper();
    }

    public DatabaseTableConfig getTableConfig() {
        return this.tableConfig;
    }

    public TableInfo getTableInfo() {
        return this.tableInfo;
    }

    public CloseableWrappedIterable getWrappedIterable() {
        this.checkForInitialized();
        return new CloseableWrappedIterableImpl(new BaseDaoImpl$2(this));
    }

    public CloseableWrappedIterable getWrappedIterable(PreparedQuery arg3) {
        this.checkForInitialized();
        return new CloseableWrappedIterableImpl(new BaseDaoImpl$3(this, arg3));
    }

    public boolean idExists(Object arg4) {
        boolean v0_1;
        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v0_1 = this.statementExecutor.ifExists(v1, arg4);
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    public void initialize() {
        Object v1_1;
        if(!this.initialized) {
            if(this.connectionSource == null) {
                throw new IllegalStateException("connectionSource was never set on " + this.getClass().getSimpleName());
            }
            else {
                this.databaseType = this.connectionSource.getDatabaseType();
                if(this.databaseType == null) {
                    throw new IllegalStateException("connectionSource is getting a null DatabaseType in " + this.getClass().getSimpleName());
                }
                else {
                    if(this.tableConfig == null) {
                        this.tableInfo = new TableInfo(this.connectionSource, this, this.dataClass);
                    }
                    else {
                        this.tableConfig.extractFieldTypes(this.connectionSource);
                        this.tableInfo = new TableInfo(this.databaseType, this, this.tableConfig);
                    }

                    this.statementExecutor = new StatementExecutor(this.databaseType, this.tableInfo, ((Dao)this));
                    Object v0 = BaseDaoImpl.daoConfigLevelLocal.get();
                    ((List)v0).add(this);
                    if(((List)v0).size() > 1) {
                        return;
                    }

                    int v4 = 0;
                    try {
                        while(true) {
                        label_52:
                            if(v4 >= ((List)v0).size()) {
                                goto label_91;
                            }

                            v1_1 = ((List)v0).get(v4);
                            DaoManager.registerDao(this.connectionSource, ((Dao)v1_1));
                            try {
                                FieldType[] v5 = ((BaseDaoImpl)v1_1).getTableInfo().getFieldTypes();
                                int v6 = v5.length;
                                int v2_1;
                                for(v2_1 = 0; v2_1 < v6; ++v2_1) {
                                    v5[v2_1].configDaoInformation(this.connectionSource, ((BaseDaoImpl)v1_1).getDataClass());
                                }
                            }
                            catch(SQLException v2) {
                                goto label_78;
                            }
                        }
                    }
                    catch(Throwable v1) {
                        goto label_82;
                    }

                    try {
                        ((BaseDaoImpl)v1_1).initialized = true;
                        ++v4;
                        goto label_52;
                    }
                    catch(Throwable v1) {
                        goto label_82;
                    }

                    try {
                    label_78:
                        DaoManager.unregisterDao(this.connectionSource, ((Dao)v1_1));
                        throw v2;
                    }
                    catch(Throwable v1) {
                    label_82:
                        ((List)v0).clear();
                        BaseDaoImpl.daoConfigLevelLocal.remove();
                        throw v1;
                    }

                label_91:
                    ((List)v0).clear();
                    BaseDaoImpl.daoConfigLevelLocal.remove();
                }
            }
        }
    }

    public boolean isAutoCommit() {
        boolean v1_1;
        DatabaseConnection v0 = this.connectionSource.getReadWriteConnection();
        try {
            v1_1 = this.isAutoCommit(v0);
        }
        catch(Throwable v1) {
            this.connectionSource.releaseConnection(v0);
            throw v1;
        }

        this.connectionSource.releaseConnection(v0);
        return v1_1;
    }

    public boolean isAutoCommit(DatabaseConnection arg2) {
        return arg2.isAutoCommit();
    }

    public boolean isTableExists() {
        boolean v0_1;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v0_1 = v1.isTableExists(this.tableInfo.getTableName());
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    public boolean isUpdatable() {
        return this.tableInfo.isUpdatable();
    }

    public CloseableIterator iterator(int arg2) {
        this.checkForInitialized();
        this.lastIterator = this.createIterator(arg2);
        return this.lastIterator;
    }

    public CloseableIterator iterator() {
        return this.iterator(-1);
    }

    public CloseableIterator iterator(PreparedQuery arg2) {
        return this.iterator(arg2, -1);
    }

    public CloseableIterator iterator(PreparedQuery arg2, int arg3) {
        this.checkForInitialized();
        this.lastIterator = this.createIterator(arg2, arg3);
        return this.lastIterator;
    }

    public Iterator iterator() {
        return this.iterator();
    }

    private ForeignCollection makeEmptyForeignCollection(Object arg8, String arg9) {
        ObjectCache v1 = null;
        this.checkForInitialized();
        Object v0 = arg8 == null ? v1 : this.extractId(arg8);
        FieldType[] v3 = this.tableInfo.getFieldTypes();
        int v4 = v3.length;
        int v2;
        for(v2 = 0; v2 < v4; ++v2) {
            FieldType v5 = v3[v2];
            if(v5.getColumnName().equals(arg9)) {
                BaseForeignCollection v0_1 = v5.buildForeignCollection(arg8, v0);
                if(arg8 != null) {
                    v5.assignField(arg8, v0_1, true, v1);
                }

                return ((ForeignCollection)v0_1);
            }
        }

        throw new IllegalArgumentException("Could not find a field named " + arg9);
    }

    public Object mapSelectStarRow(DatabaseResults arg2) {
        return this.statementExecutor.getSelectStarRowMapper().mapRow(arg2);
    }

    public String objectToString(Object arg2) {
        this.checkForInitialized();
        return this.tableInfo.objectToString(arg2);
    }

    public boolean objectsEqual(Object arg8, Object arg9) {
        boolean v0 = false;
        this.checkForInitialized();
        FieldType[] v2 = this.tableInfo.getFieldTypes();
        int v3 = v2.length;
        int v1 = 0;
        while(true) {
            if(v1 >= v3) {
                return true;
            }
            else if(v2[v1].getDataPersister().dataIsEqual(v2[v1].extractJavaFieldValue(arg8), v2[v1].extractJavaFieldValue(arg9))) {
                ++v1;
                continue;
            }

            return v0;
        }

        return true;
    }

    public List query(PreparedQuery arg4) {
        this.checkForInitialized();
        return this.statementExecutor.query(this.connectionSource, ((PreparedStmt)arg4), this.objectCache);
    }

    public QueryBuilder queryBuilder() {
        this.checkForInitialized();
        return new QueryBuilder(this.databaseType, this.tableInfo, ((Dao)this));
    }

    public List queryForAll() {
        this.checkForInitialized();
        return this.statementExecutor.queryForAll(this.connectionSource, this.objectCache);
    }

    public List queryForEq(String arg2, Object arg3) {
        return this.queryBuilder().where().eq(arg2, arg3).query();
    }

    private List queryForFieldValues(Map arg7, boolean arg8) {
        List v0_1;
        Object v1_1;
        this.checkForInitialized();
        QueryBuilder v3 = this.queryBuilder();
        Where v4 = v3.where();
        Iterator v5 = arg7.entrySet().iterator();
        while(v5.hasNext()) {
            Object v0 = v5.next();
            Object v2 = ((Map$Entry)v0).getValue();
            if(arg8) {
                SelectArg v1 = new SelectArg(v2);
            }
            else {
                v1_1 = v2;
            }

            v4.eq(((Map$Entry)v0).getKey(), v1_1);
        }

        if(arg7.size() == 0) {
            v0_1 = Collections.emptyList();
        }
        else {
            v4.and(arg7.size());
            v0_1 = v3.query();
        }

        return v0_1;
    }

    public List queryForFieldValues(Map arg2) {
        return this.queryForFieldValues(arg2, false);
    }

    public List queryForFieldValuesArgs(Map arg2) {
        return this.queryForFieldValues(arg2, true);
    }

    public Object queryForFirst(PreparedQuery arg4) {
        Object v0_1;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v0_1 = this.statementExecutor.queryForFirst(v1, ((PreparedStmt)arg4), this.objectCache);
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    public Object queryForId(Object arg4) {
        Object v0_1;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v0_1 = this.statementExecutor.queryForId(v1, arg4, this.objectCache);
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    private List queryForMatching(Object arg10, boolean arg11) {
        List v0_3;
        int v0_2;
        SelectArg v0;
        this.checkForInitialized();
        QueryBuilder v4 = this.queryBuilder();
        Where v5 = v4.where();
        FieldType[] v6 = this.tableInfo.getFieldTypes();
        int v7 = v6.length;
        int v3 = 0;
        int v2;
        for(v2 = 0; v3 < v7; v2 = v0_2) {
            FieldType v8 = v6[v3];
            Object v1 = v8.getFieldValueIfNotDefault(arg10);
            if(v1 != null) {
                if(arg11) {
                    v0 = new SelectArg(v1);
                }
                else {
                    Object v0_1 = v1;
                }

                v5.eq(v8.getColumnName(), v0);
                v0_2 = v2 + 1;
            }
            else {
                v0_2 = v2;
            }

            ++v3;
        }

        if(v2 == 0) {
            v0_3 = Collections.emptyList();
        }
        else {
            v5.and(v2);
            v0_3 = v4.query();
        }

        return v0_3;
    }

    public List queryForMatching(Object arg2) {
        return this.queryForMatching(arg2, false);
    }

    public List queryForMatchingArgs(Object arg2) {
        return this.queryForMatching(arg2, true);
    }

    public Object queryForSameId(Object arg3) {
        Object v0 = null;
        this.checkForInitialized();
        if(arg3 != null) {
            Object v1 = this.extractId(arg3);
            if(v1 != null) {
                v0 = this.queryForId(v1);
            }
        }

        return v0;
    }

    public GenericRawResults queryRaw(String arg7, RawRowMapper arg8, String[] arg9) {
        this.checkForInitialized();
        try {
            return this.statementExecutor.queryRaw(this.connectionSource, arg7, arg8, arg9, this.objectCache);
        }
        catch(SQLException v0) {
            throw SqlExceptionUtil.create("Could not perform raw query for " + arg7, ((Throwable)v0));
        }
    }

    public GenericRawResults queryRaw(String arg8, DataType[] arg9, RawRowObjectMapper arg10, String[] arg11) {
        this.checkForInitialized();
        try {
            return this.statementExecutor.queryRaw(this.connectionSource, arg8, arg9, arg10, arg11, this.objectCache);
        }
        catch(SQLException v0) {
            throw SqlExceptionUtil.create("Could not perform raw query for " + arg8, ((Throwable)v0));
        }
    }

    public GenericRawResults queryRaw(String arg7, DataType[] arg8, String[] arg9) {
        this.checkForInitialized();
        try {
            return this.statementExecutor.queryRaw(this.connectionSource, arg7, arg8, arg9, this.objectCache);
        }
        catch(SQLException v0) {
            throw SqlExceptionUtil.create("Could not perform raw query for " + arg7, ((Throwable)v0));
        }
    }

    public GenericRawResults queryRaw(String arg4, String[] arg5) {
        this.checkForInitialized();
        try {
            return this.statementExecutor.queryRaw(this.connectionSource, arg4, arg5, this.objectCache);
        }
        catch(SQLException v0) {
            throw SqlExceptionUtil.create("Could not perform raw query for " + arg4, ((Throwable)v0));
        }
    }

    public long queryRawValue(String arg5, String[] arg6) {
        long v2;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
        try {
            v2 = this.statementExecutor.queryForLong(v1, arg5, arg6);
        }
        catch(Throwable v0) {
        }
        catch(SQLException v0_1) {
            try {
                throw SqlExceptionUtil.create("Could not perform raw value query for " + arg5, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
                this.connectionSource.releaseConnection(v1);
                throw v0;
            }
        }

        this.connectionSource.releaseConnection(v1);
        return v2;
    }

    public int refresh(Object arg4) {
        int v0;
        this.checkForInitialized();
        if(arg4 == null) {
            v0 = 0;
        }
        else {
            if((arg4 instanceof BaseDaoEnabled)) {
                arg4.setDao(((Dao)this));
            }

            DatabaseConnection v1 = this.connectionSource.getReadOnlyConnection();
            try {
                v0 = this.statementExecutor.refresh(v1, arg4, this.objectCache);
            }
            catch(Throwable v0_1) {
                this.connectionSource.releaseConnection(v1);
                throw v0_1;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0;
    }

    public void rollBack(DatabaseConnection arg2) {
        arg2.rollback(null);
    }

    public void setAutoCommit(DatabaseConnection arg1, boolean arg2) {
        arg1.setAutoCommit(arg2);
    }

    public void setAutoCommit(boolean arg4) {
        DatabaseConnection v0 = this.connectionSource.getReadWriteConnection();
        try {
            this.setAutoCommit(v0, arg4);
        }
        catch(Throwable v1) {
            this.connectionSource.releaseConnection(v0);
            throw v1;
        }

        this.connectionSource.releaseConnection(v0);
    }

    public void setConnectionSource(ConnectionSource arg1) {
        this.connectionSource = arg1;
    }

    public void setObjectCache(ObjectCache arg4) {
        if(arg4 != null) {
            if(this.objectCache != null && this.objectCache != arg4) {
                this.objectCache.clear(this.dataClass);
            }

            if(this.tableInfo.getIdField() == null) {
                throw new SQLException("Class " + this.dataClass + " must have an id field to enable the object cache");
            }

            this.objectCache = arg4;
            this.objectCache.registerClass(this.dataClass);
        }
        else if(this.objectCache != null) {
            this.objectCache.clear(this.dataClass);
            this.objectCache = null;
        }
    }

    public void setObjectCache(boolean arg4) {
        if(!arg4) {
            if(this.objectCache == null) {
                return;
            }

            this.objectCache.clear(this.dataClass);
            this.objectCache = null;
        }
        else if(this.objectCache == null) {
            if(this.tableInfo.getIdField() == null) {
                throw new SQLException("Class " + this.dataClass + " must have an id field to enable the object cache");
            }
            else {
                Class v1 = BaseDaoImpl.class;
                __monitor_enter(v1);
                try {
                    if(BaseDaoImpl.defaultObjectCache == null) {
                        BaseDaoImpl.defaultObjectCache = ReferenceObjectCache.makeWeakCache();
                    }

                    this.objectCache = BaseDaoImpl.defaultObjectCache;
                    __monitor_exit(v1);
                }
                catch(Throwable v0) {
                    try {
                    label_32:
                        __monitor_exit(v1);
                    }
                    catch(Throwable v0) {
                        goto label_32;
                    }

                    throw v0;
                }

                this.objectCache.registerClass(this.dataClass);
            }
        }
    }

    public void setObjectFactory(ObjectFactory arg1) {
        this.checkForInitialized();
        this.objectFactory = arg1;
    }

    public void setTableConfig(DatabaseTableConfig arg1) {
        this.tableConfig = arg1;
    }

    public DatabaseConnection startThreadConnection() {
        DatabaseConnection v0 = this.connectionSource.getReadWriteConnection();
        this.connectionSource.saveSpecialConnection(v0);
        return v0;
    }

    public int update(Object arg4) {
        int v0;
        this.checkForInitialized();
        if(arg4 == null) {
            v0 = 0;
        }
        else {
            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0 = this.statementExecutor.update(v1, arg4, this.objectCache);
            }
            catch(Throwable v0_1) {
                this.connectionSource.releaseConnection(v1);
                throw v0_1;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0;
    }

    public int update(PreparedUpdate arg4) {
        int v0_1;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
        try {
            v0_1 = this.statementExecutor.update(v1, arg4);
        }
        catch(Throwable v0) {
            this.connectionSource.releaseConnection(v1);
            throw v0;
        }

        this.connectionSource.releaseConnection(v1);
        return v0_1;
    }

    public UpdateBuilder updateBuilder() {
        this.checkForInitialized();
        return new UpdateBuilder(this.databaseType, this.tableInfo, ((Dao)this));
    }

    public int updateId(Object arg4, Object arg5) {
        int v0;
        this.checkForInitialized();
        if(arg4 == null) {
            v0 = 0;
        }
        else {
            DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
            try {
                v0 = this.statementExecutor.updateId(v1, arg4, arg5, this.objectCache);
            }
            catch(Throwable v0_1) {
                this.connectionSource.releaseConnection(v1);
                throw v0_1;
            }

            this.connectionSource.releaseConnection(v1);
        }

        return v0;
    }

    public int updateRaw(String arg5, String[] arg6) {
        int v0_2;
        this.checkForInitialized();
        DatabaseConnection v1 = this.connectionSource.getReadWriteConnection();
        try {
            v0_2 = this.statementExecutor.updateRaw(v1, arg5, arg6);
        }
        catch(Throwable v0) {
        }
        catch(SQLException v0_1) {
            try {
                throw SqlExceptionUtil.create("Could not run raw update statement " + arg5, ((Throwable)v0_1));
            }
            catch(Throwable v0) {
                this.connectionSource.releaseConnection(v1);
                throw v0;
            }
        }

        this.connectionSource.releaseConnection(v1);
        return v0_2;
    }
}

