// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.dao;

import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.stmt.PreparedQuery;
import com.j256.ormlite.stmt.QueryBuilder;
import com.j256.ormlite.stmt.SelectArg;
import com.j256.ormlite.stmt.mapped.MappedPreparedStmt;
import java.io.Serializable;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Iterator;

public abstract class BaseForeignCollection implements ForeignCollection, Serializable {
    protected final transient Dao dao;
    private final transient FieldType foreignFieldType;
    private final transient boolean orderAscending;
    private final transient String orderColumn;
    private final transient Object parent;
    private final transient Object parentId;
    private transient PreparedQuery preparedQuery;
    private static final long serialVersionUID = -5158840898186237589L;

    protected BaseForeignCollection(Dao arg1, Object arg2, Object arg3, FieldType arg4, String arg5, boolean arg6) {
        super();
        this.dao = arg1;
        this.foreignFieldType = arg4;
        this.parentId = arg3;
        this.orderColumn = arg5;
        this.orderAscending = arg6;
        this.parent = arg2;
    }

    public boolean add(Object arg4) {
        try {
            return this.addElement(arg4);
        }
        catch(SQLException v0) {
            throw new IllegalStateException("Could not create data element in dao", ((Throwable)v0));
        }
    }

    public boolean addAll(Collection arg4) {
        boolean v0 = false;
        Iterator v1 = arg4.iterator();
        while(v1.hasNext()) {
            Object v2 = v1.next();
            try {
                if(!this.addElement(v2)) {
                    continue;
                }
            }
            catch(SQLException v0_1) {
                throw new IllegalStateException("Could not create data elements in dao", ((Throwable)v0_1));
            }

            v0 = true;
        }

        return v0;
    }

    private boolean addElement(Object arg5) {
        boolean v0 = true;
        if(this.dao == null) {
            v0 = false;
        }
        else {
            if(this.parent != null && this.foreignFieldType.getFieldValueIfNotDefault(arg5) == null) {
                this.foreignFieldType.assignField(arg5, this.parent, true, null);
            }

            this.dao.create(arg5);
        }

        return v0;
    }

    public void clear() {
        if(this.dao != null) {
            CloseableIterator v1 = this.closeableIterator();
            try {
                while(v1.hasNext()) {
                    v1.next();
                    v1.remove();
                }
            }
            catch(Throwable v0) {
                try {
                    v1.close();
                }
                catch(SQLException v1_1) {
                }

                throw v0;
            }

            try {
                v1.close();
            }
            catch(SQLException v0_1) {
            }
        }
    }

    protected PreparedQuery getPreparedQuery() {
        PreparedQuery v0;
        if(this.dao == null) {
            v0 = null;
        }
        else {
            if(this.preparedQuery == null) {
                SelectArg v0_1 = new SelectArg();
                v0_1.setValue(this.parentId);
                QueryBuilder v1 = this.dao.queryBuilder();
                if(this.orderColumn != null) {
                    v1.orderBy(this.orderColumn, this.orderAscending);
                }

                this.preparedQuery = v1.where().eq(this.foreignFieldType.getColumnName(), v0_1).prepare();
                if(!(this.preparedQuery instanceof MappedPreparedStmt)) {
                    goto label_30;
                }

                this.preparedQuery.setParentInformation(this.parent, this.parentId);
            }

        label_30:
            v0 = this.preparedQuery;
        }

        return v0;
    }

    public int refresh(Object arg2) {
        int v0 = this.dao == null ? 0 : this.dao.refresh(arg2);
        return v0;
    }

    public abstract boolean remove(Object arg1);

    public abstract boolean removeAll(Collection arg1);

    public boolean retainAll(Collection arg4) {
        boolean v0 = false;
        if(this.dao != null) {
            CloseableIterator v1 = this.closeableIterator();
            try {
                while(v1.hasNext()) {
                    if(arg4.contains(v1.next())) {
                        continue;
                    }

                    v1.remove();
                    v0 = true;
                }
            }
            catch(Throwable v0_1) {
                try {
                    v1.close();
                }
                catch(SQLException v1_1) {
                }

                throw v0_1;
            }

            try {
                v1.close();
            }
            catch(SQLException v1_1) {
            }
        }

        return v0;
    }

    public int update(Object arg2) {
        int v0 = this.dao == null ? 0 : this.dao.update(arg2);
        return v0;
    }
}

