// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.dao;

import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.DatabaseTable;
import com.j256.ormlite.table.DatabaseTableConfig;
import java.lang.annotation.Annotation;
import java.lang.reflect.Constructor;
import java.sql.SQLException;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class DaoManager {
    private static Map classMap;
    private static Map configMap;
    private static Logger logger;
    private static Map tableConfigMap;

    static {
        DaoManager.configMap = null;
        DaoManager.classMap = null;
        DaoManager.tableConfigMap = null;
        DaoManager.logger = LoggerFactory.getLogger(DaoManager.class);
    }

    public DaoManager() {
        super();
    }

    public static void addCachedDatabaseConfigs(Collection arg6) {
        Class v2 = DaoManager.class;
        __monitor_enter(v2);
        try {
            HashMap v1 = DaoManager.configMap == null ? new HashMap() : new HashMap(DaoManager.configMap);
            Iterator v3 = arg6.iterator();
            while(v3.hasNext()) {
                Object v0_1 = v3.next();
                ((Map)v1).put(((DatabaseTableConfig)v0_1).getDataClass(), v0_1);
                DaoManager.logger.info("Loaded configuration for {}", ((DatabaseTableConfig)v0_1).getDataClass());
            }

            DaoManager.configMap = ((Map)v1);
        }
        catch(Throwable v0) {
            goto label_19;
        }

        __monitor_exit(v2);
        return;
    label_19:
        __monitor_exit(v2);
        throw v0;
    }

    private static void addDaoToClassMap(DaoManager$ClassConnectionSource arg1, Dao arg2) {
        if(DaoManager.classMap == null) {
            DaoManager.classMap = new HashMap();
        }

        DaoManager.classMap.put(arg1, arg2);
    }

    private static void addDaoToTableMap(DaoManager$TableConfigConnectionSource arg1, Dao arg2) {
        if(DaoManager.tableConfigMap == null) {
            DaoManager.tableConfigMap = new HashMap();
        }

        DaoManager.tableConfigMap.put(arg1, arg2);
    }

    public static void clearCache() {
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        try {
            if(DaoManager.configMap != null) {
                DaoManager.configMap.clear();
                DaoManager.configMap = null;
            }

            DaoManager.clearDaoCache();
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
    }

    public static void clearDaoCache() {
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        try {
            if(DaoManager.classMap != null) {
                DaoManager.classMap.clear();
                DaoManager.classMap = null;
            }

            if(DaoManager.tableConfigMap != null) {
                DaoManager.tableConfigMap.clear();
                DaoManager.tableConfigMap = null;
            }
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
    }

    public static Dao createDao(ConnectionSource arg5, Class arg6) {
        Object v0_2;
        Class v2 = DaoManager.class;
        __monitor_enter(v2);
        if(arg5 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            Dao v0_1 = DaoManager.lookupDao(new DaoManager$ClassConnectionSource(arg5, arg6));
            if(v0_1 == null) {
                v0_2 = DaoManager.createDaoFromConfig(arg5, arg6);
                if(v0_2 == null) {
                    Annotation v0_3 = arg6.getAnnotation(DatabaseTable.class);
                    if(v0_3 == null) {
                        goto label_27;
                    }
                    else if(((DatabaseTable)v0_3).daoClass() == Void.class) {
                        goto label_27;
                    }
                    else if(((DatabaseTable)v0_3).daoClass() != BaseDaoImpl.class) {
                        Class v3 = ((DatabaseTable)v0_3).daoClass();
                        Object[] v1 = new Object[]{arg5, arg6};
                        Constructor v0_4 = DaoManager.findConstructor(v3, v1);
                        if(v0_4 == null) {
                            v1 = new Object[]{arg5};
                            v0_4 = DaoManager.findConstructor(v3, v1);
                            if(v0_4 == null) {
                                throw new SQLException("Could not find public constructor with ConnectionSource and optional Class parameters " + v3 + ".  Missing static on class?");
                            }
                        }

                        try {
                            v0_2 = v0_4.newInstance(v1);
                            DaoManager.logger.debug("created dao for class {} from constructor", arg6);
                            goto label_34;
                        }
                        catch(Exception v0_5) {
                            try {
                                throw SqlExceptionUtil.create("Could not call the constructor in class " + v3, ((Throwable)v0_5));
                            label_27:
                                DatabaseTableConfig v0_6 = arg5.getDatabaseType().extractDatabaseTableConfig(arg5, arg6);
                                v0_1 = v0_6 == null ? BaseDaoImpl.createDao(arg5, arg6) : BaseDaoImpl.createDao(arg5, v0_6);
                                DaoManager.logger.debug("created dao for class {} with reflection", arg6);
                            label_34:
                                DaoManager.registerDao(arg5, ((Dao)v0_2));
                                goto label_14;
                            }
                            catch(Throwable v0) {
                            label_8:
                                __monitor_exit(v2);
                                throw v0;
                            }
                        }
                    }
                    else {
                        goto label_27;
                    }

                    goto label_34;
                }
            }
        }
        catch(Throwable v0) {
            goto label_8;
        }

    label_14:
        __monitor_exit(v2);
        return ((Dao)v0_2);
    }

    public static Dao createDao(ConnectionSource arg3, DatabaseTableConfig arg4) {
        Dao v0_1;
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        if(arg3 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            v0_1 = DaoManager.doCreateDao(arg3, arg4);
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
        return v0_1;
    }

    private static Object createDaoFromConfig(ConnectionSource arg2, Class arg3) {
        Dao v0_1;
        Object v0;
        Object v1 = null;
        if(DaoManager.configMap == null) {
            v0 = v1;
        }
        else {
            v0 = DaoManager.configMap.get(arg3);
            if(v0 == null) {
                v0 = v1;
            }
            else {
                v0_1 = DaoManager.doCreateDao(arg2, ((DatabaseTableConfig)v0));
            }
        }

        return v0_1;
    }

    private static Dao doCreateDao(ConnectionSource arg6, DatabaseTableConfig arg7) {
        Object v0_4;
        DaoManager$TableConfigConnectionSource v1 = new DaoManager$TableConfigConnectionSource(arg6, arg7);
        Dao v0 = DaoManager.lookupDao(v1);
        if(v0 == null) {
            Class v2 = arg7.getDataClass();
            DaoManager$ClassConnectionSource v3 = new DaoManager$ClassConnectionSource(arg6, v2);
            v0 = DaoManager.lookupDao(v3);
            if(v0 != null) {
                DaoManager.addDaoToTableMap(v1, v0);
            }
            else {
                Annotation v0_1 = arg7.getDataClass().getAnnotation(DatabaseTable.class);
                if(v0_1 == null || ((DatabaseTable)v0_1).daoClass() == Void.class || ((DatabaseTable)v0_1).daoClass() == BaseDaoImpl.class) {
                    v0 = BaseDaoImpl.createDao(arg6, arg7);
                }
                else {
                    Class v4 = ((DatabaseTable)v0_1).daoClass();
                    Object[] v0_2 = new Object[]{arg6, arg7};
                    Constructor v5 = DaoManager.findConstructor(v4, v0_2);
                    if(v5 == null) {
                        throw new SQLException("Could not find public constructor with ConnectionSource, DatabaseTableConfig parameters in class " + v4);
                    }
                    else {
                        try {
                            v0_4 = v5.newInstance(v0_2);
                        }
                        catch(Exception v0_3) {
                            throw SqlExceptionUtil.create("Could not call the constructor in class " + v4, ((Throwable)v0_3));
                        }
                    }
                }

                DaoManager.addDaoToTableMap(v1, ((Dao)v0_4));
                DaoManager.logger.debug("created dao for class {} from table config", v2);
                if(DaoManager.lookupDao(v3) != null) {
                    goto label_4;
                }

                DaoManager.addDaoToClassMap(v3, ((Dao)v0_4));
            }
        }

    label_4:
        return ((Dao)v0_4);
    }

    private static Constructor findConstructor(Class arg10, Object[] arg11) {
        Constructor[] v5 = arg10.getConstructors();
        int v6 = v5.length;
        int v4;
        for(v4 = 0; v4 < v6; ++v4) {
            Constructor v2 = v5[v4];
            Class[] v7 = v2.getParameterTypes();
            if(v7.length == arg11.length) {
                int v0 = 0;
                while(true) {
                    if(v0 >= v7.length) {
                        break;
                    }
                    else if(!v7[v0].isAssignableFrom(arg11[v0].getClass())) {
                        v0 = 0;
                    }
                    else {
                        ++v0;
                        continue;
                    }

                    goto label_20;
                }

                v0 = 1;
            label_20:
                if(v0 == 0) {
                    goto label_25;
                }

                Constructor v0_1 = v2;
                return v0_1;
            }

        label_25:
        }

        return null;
    }

    private static Dao lookupDao(DaoManager$ClassConnectionSource arg1) {
        Dao v0_1;
        if(DaoManager.classMap == null) {
            DaoManager.classMap = new HashMap();
        }

        Object v0 = DaoManager.classMap.get(arg1);
        if(v0 == null) {
            v0_1 = null;
        }

        return v0_1;
    }

    private static Dao lookupDao(DaoManager$TableConfigConnectionSource arg1) {
        if(DaoManager.tableConfigMap == null) {
            DaoManager.tableConfigMap = new HashMap();
        }

        Object v0 = DaoManager.tableConfigMap.get(arg1);
        if(v0 == null) {
            Dao v0_1 = null;
        }

        return ((Dao)v0);
    }

    public static Dao lookupDao(ConnectionSource arg3, DatabaseTableConfig arg4) {
        Dao v0_1;
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        if(arg3 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            v0_1 = DaoManager.lookupDao(new DaoManager$TableConfigConnectionSource(arg3, arg4));
            if(v0_1 != null) {
                goto label_15;
            }
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        v0_1 = null;
    label_15:
        __monitor_exit(v1);
        return v0_1;
    }

    public static Dao lookupDao(ConnectionSource arg3, Class arg4) {
        Dao v0_1;
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        if(arg3 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            v0_1 = DaoManager.lookupDao(new DaoManager$ClassConnectionSource(arg3, arg4));
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
        return v0_1;
    }

    public static void registerDao(ConnectionSource arg3, Dao arg4) {
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        if(arg3 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            DaoManager.addDaoToClassMap(new DaoManager$ClassConnectionSource(arg3, arg4.getDataClass()), arg4);
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
    }

    public static void registerDaoWithTableConfig(ConnectionSource arg4, Dao arg5) {
        Class v2 = DaoManager.class;
        __monitor_enter(v2);
        if(arg4 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            if((arg5 instanceof BaseDaoImpl)) {
                DatabaseTableConfig v1_1 = arg5.getTableConfig();
                if(v1_1 != null) {
                    DaoManager.addDaoToTableMap(new DaoManager$TableConfigConnectionSource(arg4, v1_1), arg5);
                }
                else {
                    goto label_21;
                }
            }
            else {
            label_21:
                DaoManager.addDaoToClassMap(new DaoManager$ClassConnectionSource(arg4, arg5.getDataClass()), arg5);
            }
        }
        catch(Throwable v1) {
            __monitor_exit(v2);
            throw v1;
        }

        __monitor_exit(v2);
    }

    private static void removeDaoToClassMap(DaoManager$ClassConnectionSource arg1, Dao arg2) {
        if(DaoManager.classMap != null) {
            DaoManager.classMap.remove(arg1);
        }
    }

    public static void unregisterDao(ConnectionSource arg3, Dao arg4) {
        Class v1 = DaoManager.class;
        __monitor_enter(v1);
        if(arg3 != null) {
            goto label_10;
        }

        try {
            throw new IllegalArgumentException("connectionSource argument cannot be null");
        label_10:
            DaoManager.removeDaoToClassMap(new DaoManager$ClassConnectionSource(arg3, arg4.getDataClass()), arg4);
        }
        catch(Throwable v0) {
            __monitor_exit(v1);
            throw v0;
        }

        __monitor_exit(v1);
    }
}

