// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.dao;

import java.lang.ref.Reference;
import java.lang.ref.SoftReference;
import java.lang.ref.WeakReference;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class ReferenceObjectCache implements ObjectCache {
    private final ConcurrentHashMap classMaps;
    private final boolean useWeak;

    public ReferenceObjectCache(boolean arg2) {
        super();
        this.classMaps = new ConcurrentHashMap();
        this.useWeak = arg2;
    }

    private void cleanMap(Map arg3) {
        Iterator v1 = arg3.entrySet().iterator();
        while(v1.hasNext()) {
            if(v1.next().getValue().get() != null) {
                continue;
            }

            v1.remove();
        }
    }

    public void cleanNullReferences(Class arg2) {
        Map v0 = this.getMapForClass(arg2);
        if(v0 != null) {
            this.cleanMap(v0);
        }
    }

    public void cleanNullReferencesAll() {
        Iterator v1 = this.classMaps.values().iterator();
        while(v1.hasNext()) {
            this.cleanMap(v1.next());
        }
    }

    public void clear(Class arg2) {
        Map v0 = this.getMapForClass(arg2);
        if(v0 != null) {
            v0.clear();
        }
    }

    public void clearAll() {
        Iterator v1 = this.classMaps.values().iterator();
        while(v1.hasNext()) {
            v1.next().clear();
        }
    }

    public Object get(Class arg4, Object arg5) {
        Object v0;
        Object v1 = null;
        Map v2 = this.getMapForClass(arg4);
        if(v2 == null) {
            v0 = v1;
        }
        else {
            v0 = v2.get(arg5);
            if(v0 == null) {
                v0 = v1;
            }
            else {
                v0 = ((Reference)v0).get();
                if(v0 == null) {
                    v2.remove(arg5);
                    v0 = v1;
                }
            }
        }

        return v0;
    }

    private Map getMapForClass(Class arg2) {
        Object v0 = this.classMaps.get(arg2);
        if(v0 == null) {
            Map v0_1 = null;
        }

        return ((Map)v0);
    }

    public static ReferenceObjectCache makeSoftCache() {
        return new ReferenceObjectCache(false);
    }

    public static ReferenceObjectCache makeWeakCache() {
        return new ReferenceObjectCache(true);
    }

    public void put(Class arg3, Object arg4, Object arg5) {
        Map v0 = this.getMapForClass(arg3);
        if(v0 != null) {
            if(this.useWeak) {
                v0.put(arg4, new WeakReference(arg5));
            }
            else {
                v0.put(arg4, new SoftReference(arg5));
            }
        }
    }

    public void registerClass(Class arg3) {
        __monitor_enter(this);
        try {
            if(this.classMaps.get(arg3) == null) {
                this.classMaps.put(arg3, new ConcurrentHashMap());
            }
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }

    public void remove(Class arg2, Object arg3) {
        Map v0 = this.getMapForClass(arg2);
        if(v0 != null) {
            v0.remove(arg3);
        }
    }

    public int size(Class arg2) {
        Map v0 = this.getMapForClass(arg2);
        int v0_1 = v0 == null ? 0 : v0.size();
        return v0_1;
    }

    public int sizeAll() {
        Iterator v2 = this.classMaps.values().iterator();
        int v1;
        for(v1 = 0; v2.hasNext(); v1 = v2.next().size() + v1) {
        }

        return v1;
    }

    public Object updateId(Class arg4, Object arg5, Object arg6) {
        Object v0;
        Object v1 = null;
        Map v2 = this.getMapForClass(arg4);
        if(v2 == null) {
            v0 = v1;
        }
        else {
            v0 = v2.remove(arg5);
            if(v0 == null) {
                v0 = v1;
            }
            else {
                v2.put(arg6, v0);
                v0 = ((Reference)v0).get();
            }
        }

        return v0;
    }
}

