// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.db;

import com.j256.ormlite.field.DataPersister;
import com.j256.ormlite.field.FieldConverter;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.DatabaseTableConfig;
import java.sql.Driver;
import java.sql.SQLException;
import java.util.List;

public abstract class BaseDatabaseType implements DatabaseType {
    protected static String DEFAULT_SEQUENCE_SUFFIX;
    protected Driver driver;

    static {
        BaseDatabaseType.DEFAULT_SEQUENCE_SUFFIX = "_id_seq";
    }

    public BaseDatabaseType() {
        super();
    }

    public void addPrimaryKeySql(FieldType[] arg7, List arg8, List arg9, List arg10, List arg11) {
        int v2 = arg7.length;
        StringBuilder v0 = null;
        int v1;
        for(v1 = 0; v1 < v2; ++v1) {
            FieldType v3 = arg7[v1];
            if((!v3.isGeneratedId() || (this.generatedIdSqlAtEnd()) || (v3.isSelfGeneratedId())) && (v3.isId())) {
                if(v0 == null) {
                    v0 = new StringBuilder(48);
                    v0.append("PRIMARY KEY (");
                }
                else {
                    v0.append(',');
                }

                this.appendEscapedEntityName(v0, v3.getColumnName());
            }
        }

        if(v0 != null) {
            v0.append(") ");
            arg8.add(v0.toString());
        }
    }

    private void addSingleUnique(StringBuilder arg3, FieldType arg4, List arg5, List arg6) {
        StringBuilder v0 = new StringBuilder();
        v0.append(" UNIQUE (");
        this.appendEscapedEntityName(v0, arg4.getColumnName());
        v0.append(")");
        arg5.add(v0.toString());
    }

    public void addUniqueComboSql(FieldType[] arg7, List arg8, List arg9, List arg10, List arg11) {
        int v2 = arg7.length;
        StringBuilder v0 = null;
        int v1;
        for(v1 = 0; v1 < v2; ++v1) {
            FieldType v3 = arg7[v1];
            if(v3.isUniqueCombo()) {
                if(v0 == null) {
                    v0 = new StringBuilder(48);
                    v0.append("UNIQUE (");
                }
                else {
                    v0.append(',');
                }

                this.appendEscapedEntityName(v0, v3.getColumnName());
            }
        }

        if(v0 != null) {
            v0.append(") ");
            arg8.add(v0.toString());
        }
    }

    protected void appendBigDecimalNumericType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("NUMERIC");
    }

    protected void appendBooleanType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("BOOLEAN");
    }

    protected void appendByteArrayType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("BLOB");
    }

    protected void appendByteType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("TINYINT");
    }

    private void appendCanBeNull(StringBuilder arg1, FieldType arg2) {
    }

    protected void appendCharType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("CHAR");
    }

    public void appendColumnArg(String arg9, StringBuilder arg10, FieldType arg11, List arg12, List arg13, List arg14, List arg15) {
        this.appendEscapedEntityName(arg10, arg11.getColumnName());
        arg10.append(' ');
        DataPersister v1 = arg11.getDataPersister();
        int v0 = arg11.getWidth();
        if(v0 == 0) {
            v0 = v1.getDefaultWidth();
        }

        switch(BaseDatabaseType$1.$SwitchMap$com$j256$ormlite$field$SqlType[v1.getSqlType().ordinal()]) {
            case 1: {
                goto label_23;
            }
            case 2: {
                goto label_53;
            }
            case 3: {
                goto label_55;
            }
            case 4: {
                goto label_57;
            }
            case 5: {
                goto label_59;
            }
            case 6: {
                goto label_61;
            }
            case 7: {
                goto label_63;
            }
            case 8: {
                goto label_65;
            }
            case 9: {
                goto label_67;
            }
            case 10: {
                goto label_69;
            }
            case 11: {
                goto label_71;
            }
            case 12: {
                goto label_73;
            }
            case 13: {
                goto label_75;
            }
            case 14: {
                goto label_77;
            }
        }

        throw new IllegalArgumentException("Unknown SQL-type " + v1.getSqlType());
    label_71:
        this.appendFloatType(arg10, arg11, v0);
        goto label_24;
    label_69:
        this.appendLongType(arg10, arg11, v0);
        goto label_24;
    label_67:
        this.appendIntegerType(arg10, arg11, v0);
        goto label_24;
    label_65:
        this.appendShortType(arg10, arg11, v0);
        goto label_24;
    label_77:
        this.appendBigDecimalNumericType(arg10, arg11, v0);
        goto label_24;
    label_75:
        this.appendSerializableType(arg10, arg11, v0);
        goto label_24;
    label_73:
        this.appendDoubleType(arg10, arg11, v0);
        goto label_24;
    label_53:
        this.appendLongStringType(arg10, arg11, v0);
        goto label_24;
    label_55:
        this.appendBooleanType(arg10, arg11, v0);
        goto label_24;
    label_23:
        this.appendStringType(arg10, arg11, v0);
        goto label_24;
    label_61:
        this.appendByteType(arg10, arg11, v0);
        goto label_24;
    label_63:
        this.appendByteArrayType(arg10, arg11, v0);
        goto label_24;
    label_57:
        this.appendDateType(arg10, arg11, v0);
        goto label_24;
    label_59:
        this.appendCharType(arg10, arg11, v0);
    label_24:
        arg10.append(' ');
        if(!arg11.isGeneratedIdSequence() || (arg11.isSelfGeneratedId())) {
            if((arg11.isGeneratedId()) && !arg11.isSelfGeneratedId()) {
                this.configureGeneratedId(arg9, arg10, arg11, arg13, arg14, arg12, arg15);
                goto label_37;
            }

            if(!arg11.isId()) {
                goto label_37;
            }

            this.configureId(arg10, arg11, arg13, arg12, arg15);
        }
        else {
            this.configureGeneratedIdSequence(arg10, arg11, arg13, arg12, arg15);
        }

    label_37:
        if(!arg11.isGeneratedId()) {
            Object v0_1 = arg11.getDefaultValue();
            if(v0_1 != null) {
                arg10.append("DEFAULT ");
                this.appendDefaultValue(arg10, arg11, v0_1);
                arg10.append(' ');
            }

            if(arg11.isCanBeNull()) {
                this.appendCanBeNull(arg10, arg11);
            }
            else {
                arg10.append("NOT NULL ");
            }

            if(!arg11.isUnique()) {
                return;
            }

            this.addSingleUnique(arg10, arg11, arg12, arg14);
        }
    }

    public void appendCreateTableSuffix(StringBuilder arg1) {
    }

    protected void appendDateType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("TIMESTAMP");
    }

    private void appendDefaultValue(StringBuilder arg2, FieldType arg3, Object arg4) {
        if(arg3.isEscapedDefaultValue()) {
            this.appendEscapedWord(arg2, arg4.toString());
        }
        else {
            arg2.append(arg4);
        }
    }

    private void appendDoubleType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("DOUBLE PRECISION");
    }

    public void appendEscapedEntityName(StringBuilder arg3, String arg4) {
        arg3.append('`').append(arg4).append('`');
    }

    public void appendEscapedWord(StringBuilder arg3, String arg4) {
        arg3.append('\'').append(arg4).append('\'');
    }

    private void appendFloatType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("FLOAT");
    }

    public void appendInsertNoColumns(StringBuilder arg2) {
        arg2.append("() VALUES ()");
    }

    private void appendIntegerType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("INTEGER");
    }

    public void appendLimitValue(StringBuilder arg3, long arg4, Long arg6) {
        arg3.append("LIMIT ").append(arg4).append(' ');
    }

    protected void appendLongStringType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("TEXT");
    }

    protected void appendLongType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("BIGINT");
    }

    public void appendOffsetValue(StringBuilder arg3, long arg4) {
        arg3.append("OFFSET ").append(arg4).append(' ');
    }

    public void appendSelectNextValFromSequence(StringBuilder arg1, String arg2) {
    }

    protected void appendSerializableType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("BLOB");
    }

    protected void appendShortType(StringBuilder arg2, FieldType arg3, int arg4) {
        arg2.append("SMALLINT");
    }

    protected void appendStringType(StringBuilder arg3, FieldType arg4, int arg5) {
        if(this.isVarcharFieldWidthSupported()) {
            arg3.append("VARCHAR(").append(arg5).append(")");
        }
        else {
            arg3.append("VARCHAR");
        }
    }

    protected void configureGeneratedId(String arg4, StringBuilder arg5, FieldType arg6, List arg7, List arg8, List arg9, List arg10) {
        throw new IllegalStateException("GeneratedId is not supported by database " + this.getDatabaseName() + " for field " + arg6);
    }

    protected void configureGeneratedIdSequence(StringBuilder arg4, FieldType arg5, List arg6, List arg7, List arg8) {
        throw new SQLException("GeneratedIdSequence is not supported by database " + this.getDatabaseName() + " for field " + arg5);
    }

    protected void configureId(StringBuilder arg1, FieldType arg2, List arg3, List arg4, List arg5) {
    }

    public void dropColumnArg(FieldType arg1, List arg2, List arg3) {
    }

    public DatabaseTableConfig extractDatabaseTableConfig(ConnectionSource arg2, Class arg3) {
        return null;
    }

    public String generateIdSequenceName(String arg3, FieldType arg4) {
        String v0 = arg3 + BaseDatabaseType.DEFAULT_SEQUENCE_SUFFIX;
        if(this.isEntityNamesMustBeUpCase()) {
            v0 = v0.toUpperCase();
        }

        return v0;
    }

    protected boolean generatedIdSqlAtEnd() {
        return 1;
    }

    public String getCommentLinePrefix() {
        return "-- ";
    }

    protected abstract String getDriverClassName();

    public FieldConverter getFieldConverter(DataPersister arg1) {
        return arg1;
    }

    public String getPingStatement() {
        return "SELECT 1";
    }

    public boolean isAllowGeneratedIdInsertSupported() {
        return 1;
    }

    public boolean isBatchUseTransaction() {
        return 0;
    }

    public boolean isCreateIfNotExistsSupported() {
        return 0;
    }

    public boolean isCreateIndexIfNotExistsSupported() {
        return this.isCreateIfNotExistsSupported();
    }

    public boolean isCreateTableReturnsNegative() {
        return 0;
    }

    public boolean isCreateTableReturnsZero() {
        return 1;
    }

    public boolean isEntityNamesMustBeUpCase() {
        return 0;
    }

    public boolean isIdSequenceNeeded() {
        return 0;
    }

    public boolean isLimitAfterSelect() {
        return 0;
    }

    public boolean isLimitSqlSupported() {
        return 1;
    }

    public boolean isNestedSavePointsSupported() {
        return 1;
    }

    public boolean isOffsetLimitArgument() {
        return 0;
    }

    public boolean isOffsetSqlSupported() {
        return 1;
    }

    public boolean isSelectSequenceBeforeInsert() {
        return 0;
    }

    public boolean isTruncateSupported() {
        return 0;
    }

    public boolean isVarcharFieldWidthSupported() {
        return 1;
    }

    public void loadDriver() {
        String v0 = this.getDriverClassName();
        if(v0 != null) {
            try {
                Class.forName(v0);
            }
            catch(ClassNotFoundException v1) {
                throw SqlExceptionUtil.create("Driver class was not found for " + this.getDatabaseName() + " database.  Missing jar with class " + v0 + ".", ((Throwable)v1));
            }
        }
    }

    public void setDriver(Driver arg1) {
        this.driver = arg1;
    }
}

