// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.field;

import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.types.VoidType;
import com.j256.ormlite.misc.JavaxPersistence;
import com.j256.ormlite.table.DatabaseTableConfig;
import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

public class DatabaseFieldConfig {
    public static final boolean DEFAULT_CAN_BE_NULL = true;
    public static final DataType DEFAULT_DATA_TYPE = null;
    public static final boolean DEFAULT_FOREIGN_COLLECTION_ORDER_ASCENDING = true;
    private static final int DEFAULT_MAX_EAGER_FOREIGN_COLLECTION_LEVEL = 1;
    public static final Class DEFAULT_PERSISTER_CLASS;
    private boolean allowGeneratedIdInsert;
    private boolean canBeNull;
    private String columnDefinition;
    private String columnName;
    private DataPersister dataPersister;
    private DataType dataType;
    private String defaultValue;
    private String fieldName;
    private boolean foreign;
    private boolean foreignAutoCreate;
    private boolean foreignAutoRefresh;
    private boolean foreignCollection;
    private String foreignCollectionColumnName;
    private boolean foreignCollectionEager;
    private String foreignCollectionForeignFieldName;
    private int foreignCollectionMaxEagerLevel;
    private boolean foreignCollectionOrderAscending;
    private String foreignCollectionOrderColumnName;
    private String foreignColumnName;
    private DatabaseTableConfig foreignTableConfig;
    private String format;
    private boolean generatedId;
    private String generatedIdSequence;
    private boolean id;
    private boolean index;
    private String indexName;
    private int maxForeignAutoRefreshLevel;
    private boolean persisted;
    private Class persisterClass;
    private boolean readOnly;
    private boolean throwIfNull;
    private boolean unique;
    private boolean uniqueCombo;
    private boolean uniqueIndex;
    private String uniqueIndexName;
    private Enum unknownEnumValue;
    private boolean useGetSet;
    private boolean version;
    private int width;

    static {
        DatabaseFieldConfig.DEFAULT_PERSISTER_CLASS = VoidType.class;
        DatabaseFieldConfig.DEFAULT_DATA_TYPE = DataType.UNKNOWN;
    }

    public DatabaseFieldConfig(String arg3) {
        super();
        this.dataType = DatabaseFieldConfig.DEFAULT_DATA_TYPE;
        this.canBeNull = true;
        this.persisted = true;
        this.maxForeignAutoRefreshLevel = -1;
        this.persisterClass = DatabaseFieldConfig.DEFAULT_PERSISTER_CLASS;
        this.foreignCollectionMaxEagerLevel = 1;
        this.foreignCollectionOrderAscending = true;
        this.fieldName = arg3;
    }

    public DatabaseFieldConfig() {
        super();
        this.dataType = DatabaseFieldConfig.DEFAULT_DATA_TYPE;
        this.canBeNull = true;
        this.persisted = true;
        this.maxForeignAutoRefreshLevel = -1;
        this.persisterClass = DatabaseFieldConfig.DEFAULT_PERSISTER_CLASS;
        this.foreignCollectionMaxEagerLevel = 1;
        this.foreignCollectionOrderAscending = true;
    }

    public DatabaseFieldConfig(String arg3, String arg4, DataType arg5, String arg6, int arg7, boolean arg8, boolean arg9, boolean arg10, String arg11, boolean arg12, DatabaseTableConfig arg13, boolean arg14, Enum arg15, boolean arg16, String arg17, boolean arg18, String arg19, String arg20, boolean arg21, int arg22, int arg23) {
        super();
        this.dataType = DatabaseFieldConfig.DEFAULT_DATA_TYPE;
        this.canBeNull = true;
        this.persisted = true;
        this.maxForeignAutoRefreshLevel = -1;
        this.persisterClass = DatabaseFieldConfig.DEFAULT_PERSISTER_CLASS;
        this.foreignCollectionMaxEagerLevel = 1;
        this.foreignCollectionOrderAscending = true;
        this.fieldName = arg3;
        this.columnName = arg4;
        this.dataType = DataType.UNKNOWN;
        this.defaultValue = arg6;
        this.width = arg7;
        this.canBeNull = arg8;
        this.id = arg9;
        this.generatedId = arg10;
        this.generatedIdSequence = arg11;
        this.foreign = arg12;
        this.foreignTableConfig = arg13;
        this.useGetSet = arg14;
        this.unknownEnumValue = arg15;
        this.throwIfNull = arg16;
        this.format = arg17;
        this.unique = arg18;
        this.indexName = arg19;
        this.uniqueIndexName = arg20;
        this.foreignAutoRefresh = arg21;
        this.maxForeignAutoRefreshLevel = arg22;
        this.foreignCollectionMaxEagerLevel = arg23;
    }

    public static Method findGetMethod(Field arg5, boolean arg6) {
        Method v1_1;
        Method v0 = null;
        String v2 = DatabaseFieldConfig.methodFromField(arg5, "get");
        try {
            v1_1 = arg5.getDeclaringClass().getMethod(v2);
        }
        catch(Exception v1) {
            if(!arg6) {
                return v0;
            }

            throw new IllegalArgumentException("Could not find appropriate get method for " + arg5);
        }

        if(v1_1.getReturnType() != arg5.getType()) {
            if(!arg6) {
                return v0;
            }

            throw new IllegalArgumentException("Return type of get method " + v2 + " does not return " + arg5.getType());
        }

        return v1_1;
    }

    private String findIndexName(String arg3) {
        String v0 = this.columnName == null ? arg3 + "_" + this.fieldName + "_idx" : arg3 + "_" + this.columnName + "_idx";
        return v0;
    }

    public static Enum findMatchingEnumVal(Field arg5, String arg6) {
        Enum v0_2;
        if(arg6 == null || arg6.length() == 0) {
            v0_2 = null;
        }
        else {
            Object[] v0 = arg5.getType().getEnumConstants();
            int v3 = v0.length;
            int v2 = 0;
            while(true) {
                if(v2 < v3) {
                    Object v1 = v0[v2];
                    if(((Enum)v1).name().equals(arg6)) {
                        Object v0_1 = v1;
                    }
                    else {
                        ++v2;
                        continue;
                    }
                }
                else {
                    break;
                }

                return v0_2;
            }

            throw new IllegalArgumentException("Unknwown enum unknown name " + arg6 + " for field " + arg5);
        }

        return v0_2;
    }

    public static Method findSetMethod(Field arg6, boolean arg7) {
        Method v1_1;
        Method v0 = null;
        String v2 = DatabaseFieldConfig.methodFromField(arg6, "set");
        try {
            v1_1 = arg6.getDeclaringClass().getMethod(v2, arg6.getType());
        }
        catch(Exception v1) {
            if(!arg7) {
                return v0;
            }

            throw new IllegalArgumentException("Could not find appropriate set method for " + arg6);
        }

        if(v1_1.getReturnType() != Void.TYPE) {
            if(!arg7) {
                return v0;
            }

            throw new IllegalArgumentException("Return type of set method " + v2 + " returns " + v1_1.getReturnType() + " instead of void");
        }

        return v1_1;
    }

    public static DatabaseFieldConfig fromDatabaseField(DatabaseType arg3, String arg4, Field arg5, DatabaseField arg6) {
        DatabaseFieldConfig v0 = new DatabaseFieldConfig();
        v0.fieldName = arg5.getName();
        if(arg3.isEntityNamesMustBeUpCase()) {
            v0.fieldName = v0.fieldName.toUpperCase();
        }

        v0.columnName = DatabaseFieldConfig.valueIfNotBlank(arg6.columnName());
        v0.dataType = arg6.dataType();
        String v1 = arg6.defaultValue();
        if(!v1.equals("__ormlite__ no default value string was specified")) {
            v0.defaultValue = v1;
        }

        v0.width = arg6.width();
        v0.canBeNull = arg6.canBeNull();
        v0.id = arg6.id();
        v0.generatedId = arg6.generatedId();
        v0.generatedIdSequence = DatabaseFieldConfig.valueIfNotBlank(arg6.generatedIdSequence());
        v0.foreign = arg6.foreign();
        v0.useGetSet = arg6.useGetSet();
        v0.unknownEnumValue = DatabaseFieldConfig.findMatchingEnumVal(arg5, arg6.unknownEnumName());
        v0.throwIfNull = arg6.throwIfNull();
        v0.format = DatabaseFieldConfig.valueIfNotBlank(arg6.format());
        v0.unique = arg6.unique();
        v0.uniqueCombo = arg6.uniqueCombo();
        v0.index = arg6.index();
        v0.indexName = DatabaseFieldConfig.valueIfNotBlank(arg6.indexName());
        v0.uniqueIndex = arg6.uniqueIndex();
        v0.uniqueIndexName = DatabaseFieldConfig.valueIfNotBlank(arg6.uniqueIndexName());
        v0.foreignAutoRefresh = arg6.foreignAutoRefresh();
        v0.maxForeignAutoRefreshLevel = arg6.maxForeignAutoRefreshLevel();
        v0.persisterClass = arg6.persisterClass();
        v0.allowGeneratedIdInsert = arg6.allowGeneratedIdInsert();
        v0.columnDefinition = DatabaseFieldConfig.valueIfNotBlank(arg6.columnDefinition());
        v0.foreignAutoCreate = arg6.foreignAutoCreate();
        v0.version = arg6.version();
        v0.foreignColumnName = DatabaseFieldConfig.valueIfNotBlank(arg6.foreignColumnName());
        v0.readOnly = arg6.readOnly();
        return v0;
    }

    public static DatabaseFieldConfig fromField(DatabaseType arg2, String arg3, Field arg4) {
        DatabaseFieldConfig v0_1;
        Annotation v0 = arg4.getAnnotation(DatabaseField.class);
        if(v0 == null) {
            v0 = arg4.getAnnotation(ForeignCollectionField.class);
            v0_1 = v0 != null ? DatabaseFieldConfig.fromForeignCollection(arg2, arg4, ((ForeignCollectionField)v0)) : JavaxPersistence.createFieldConfig(arg2, arg4);
        }
        else if(((DatabaseField)v0).persisted()) {
            v0_1 = DatabaseFieldConfig.fromDatabaseField(arg2, arg3, arg4, ((DatabaseField)v0));
        }
        else {
            v0_1 = null;
        }

        return v0_1;
    }

    private static DatabaseFieldConfig fromForeignCollection(DatabaseType arg3, Field arg4, ForeignCollectionField arg5) {
        DatabaseFieldConfig v0 = new DatabaseFieldConfig();
        v0.fieldName = arg4.getName();
        if(arg5.columnName().length() > 0) {
            v0.columnName = arg5.columnName();
        }

        v0.foreignCollection = true;
        v0.foreignCollectionEager = arg5.eager();
        int v1 = arg5.maxEagerForeignCollectionLevel();
        v0.foreignCollectionMaxEagerLevel = v1 != 1 ? v1 : arg5.maxEagerLevel();
        v0.foreignCollectionOrderColumnName = DatabaseFieldConfig.valueIfNotBlank(arg5.orderColumnName());
        v0.foreignCollectionOrderAscending = arg5.orderAscending();
        v0.foreignCollectionColumnName = DatabaseFieldConfig.valueIfNotBlank(arg5.columnName());
        String v1_1 = DatabaseFieldConfig.valueIfNotBlank(arg5.foreignFieldName());
        v0.foreignCollectionForeignFieldName = v1_1 == null ? DatabaseFieldConfig.valueIfNotBlank(DatabaseFieldConfig.valueIfNotBlank(arg5.foreignColumnName())) : v1_1;
        return v0;
    }

    public String getColumnDefinition() {
        return this.columnDefinition;
    }

    public String getColumnName() {
        return this.columnName;
    }

    public DataPersister getDataPersister() {
        DataPersister v0 = this.dataPersister == null ? this.dataType.getDataPersister() : this.dataPersister;
        return v0;
    }

    public DataType getDataType() {
        return this.dataType;
    }

    public String getDefaultValue() {
        return this.defaultValue;
    }

    public String getFieldName() {
        return this.fieldName;
    }

    public String getForeignCollectionColumnName() {
        return this.foreignCollectionColumnName;
    }

    public String getForeignCollectionForeignFieldName() {
        return this.foreignCollectionForeignFieldName;
    }

    public int getForeignCollectionMaxEagerLevel() {
        return this.foreignCollectionMaxEagerLevel;
    }

    public String getForeignCollectionOrderColumnName() {
        return this.foreignCollectionOrderColumnName;
    }

    public String getForeignColumnName() {
        return this.foreignColumnName;
    }

    public DatabaseTableConfig getForeignTableConfig() {
        return this.foreignTableConfig;
    }

    public String getFormat() {
        return this.format;
    }

    public String getGeneratedIdSequence() {
        return this.generatedIdSequence;
    }

    public String getIndexName(String arg2) {
        if((this.index) && this.indexName == null) {
            this.indexName = this.findIndexName(arg2);
        }

        return this.indexName;
    }

    public int getMaxForeignAutoRefreshLevel() {
        return this.maxForeignAutoRefreshLevel;
    }

    public Class getPersisterClass() {
        return this.persisterClass;
    }

    public String getUniqueIndexName(String arg2) {
        if((this.uniqueIndex) && this.uniqueIndexName == null) {
            this.uniqueIndexName = this.findIndexName(arg2);
        }

        return this.uniqueIndexName;
    }

    public Enum getUnknownEnumValue() {
        return this.unknownEnumValue;
    }

    public int getWidth() {
        return this.width;
    }

    public boolean isAllowGeneratedIdInsert() {
        return this.allowGeneratedIdInsert;
    }

    public boolean isCanBeNull() {
        return this.canBeNull;
    }

    public boolean isForeign() {
        return this.foreign;
    }

    public boolean isForeignAutoCreate() {
        return this.foreignAutoCreate;
    }

    public boolean isForeignAutoRefresh() {
        return this.foreignAutoRefresh;
    }

    public boolean isForeignCollection() {
        return this.foreignCollection;
    }

    public boolean isForeignCollectionEager() {
        return this.foreignCollectionEager;
    }

    public boolean isForeignCollectionOrderAscending() {
        return this.foreignCollectionOrderAscending;
    }

    public boolean isGeneratedId() {
        return this.generatedId;
    }

    public boolean isId() {
        return this.id;
    }

    public boolean isIndex() {
        return this.index;
    }

    public boolean isPersisted() {
        return this.persisted;
    }

    public boolean isReadOnly() {
        return this.readOnly;
    }

    public boolean isThrowIfNull() {
        return this.throwIfNull;
    }

    public boolean isUnique() {
        return this.unique;
    }

    public boolean isUniqueCombo() {
        return this.uniqueCombo;
    }

    public boolean isUniqueIndex() {
        return this.uniqueIndex;
    }

    public boolean isUseGetSet() {
        return this.useGetSet;
    }

    public boolean isVersion() {
        return this.version;
    }

    private static String methodFromField(Field arg4, String arg5) {
        return arg5 + arg4.getName().substring(0, 1).toUpperCase() + arg4.getName().substring(1);
    }

    public void postProcess() {
        if(this.foreignColumnName != null) {
            this.foreignAutoRefresh = true;
        }

        if((this.foreignAutoRefresh) && this.maxForeignAutoRefreshLevel == -1) {
            this.maxForeignAutoRefreshLevel = 2;
        }
    }

    public void setAllowGeneratedIdInsert(boolean arg1) {
        this.allowGeneratedIdInsert = arg1;
    }

    public void setCanBeNull(boolean arg1) {
        this.canBeNull = arg1;
    }

    public void setColumnDefinition(String arg1) {
        this.columnDefinition = arg1;
    }

    public void setColumnName(String arg1) {
        this.columnName = arg1;
    }

    public void setDataPersister(DataPersister arg1) {
        this.dataPersister = arg1;
    }

    public void setDataType(DataType arg1) {
        this.dataType = arg1;
    }

    public void setDefaultValue(String arg1) {
        this.defaultValue = arg1;
    }

    public void setFieldName(String arg1) {
        this.fieldName = arg1;
    }

    public void setForeign(boolean arg1) {
        this.foreign = arg1;
    }

    public void setForeignAutoCreate(boolean arg1) {
        this.foreignAutoCreate = arg1;
    }

    public void setForeignAutoRefresh(boolean arg1) {
        this.foreignAutoRefresh = arg1;
    }

    public void setForeignCollection(boolean arg1) {
        this.foreignCollection = arg1;
    }

    public void setForeignCollectionColumnName(String arg1) {
        this.foreignCollectionColumnName = arg1;
    }

    public void setForeignCollectionEager(boolean arg1) {
        this.foreignCollectionEager = arg1;
    }

    @Deprecated public void setForeignCollectionForeignColumnName(String arg1) {
        this.foreignCollectionForeignFieldName = arg1;
    }

    public void setForeignCollectionForeignFieldName(String arg1) {
        this.foreignCollectionForeignFieldName = arg1;
    }

    @Deprecated public void setForeignCollectionMaxEagerForeignCollectionLevel(int arg1) {
        this.foreignCollectionMaxEagerLevel = arg1;
    }

    public void setForeignCollectionMaxEagerLevel(int arg1) {
        this.foreignCollectionMaxEagerLevel = arg1;
    }

    public void setForeignCollectionOrderAscending(boolean arg1) {
        this.foreignCollectionOrderAscending = arg1;
    }

    @Deprecated public void setForeignCollectionOrderColumn(String arg1) {
        this.foreignCollectionOrderColumnName = arg1;
    }

    public void setForeignCollectionOrderColumnName(String arg1) {
        this.foreignCollectionOrderColumnName = arg1;
    }

    public void setForeignColumnName(String arg1) {
        this.foreignColumnName = arg1;
    }

    public void setForeignTableConfig(DatabaseTableConfig arg1) {
        this.foreignTableConfig = arg1;
    }

    public void setFormat(String arg1) {
        this.format = arg1;
    }

    public void setGeneratedId(boolean arg1) {
        this.generatedId = arg1;
    }

    public void setGeneratedIdSequence(String arg1) {
        this.generatedIdSequence = arg1;
    }

    public void setId(boolean arg1) {
        this.id = arg1;
    }

    public void setIndex(boolean arg1) {
        this.index = arg1;
    }

    public void setIndexName(String arg1) {
        this.indexName = arg1;
    }

    @Deprecated public void setMaxEagerForeignCollectionLevel(int arg1) {
        this.foreignCollectionMaxEagerLevel = arg1;
    }

    public void setMaxForeignAutoRefreshLevel(int arg1) {
        this.maxForeignAutoRefreshLevel = arg1;
    }

    public void setPersisted(boolean arg1) {
        this.persisted = arg1;
    }

    public void setPersisterClass(Class arg1) {
        this.persisterClass = arg1;
    }

    public void setReadOnly(boolean arg1) {
        this.readOnly = arg1;
    }

    public void setThrowIfNull(boolean arg1) {
        this.throwIfNull = arg1;
    }

    public void setUnique(boolean arg1) {
        this.unique = arg1;
    }

    public void setUniqueCombo(boolean arg1) {
        this.uniqueCombo = arg1;
    }

    public void setUniqueIndex(boolean arg1) {
        this.uniqueIndex = arg1;
    }

    public void setUniqueIndexName(String arg1) {
        this.uniqueIndexName = arg1;
    }

    public void setUnknownEnumValue(Enum arg1) {
        this.unknownEnumValue = arg1;
    }

    public void setUseGetSet(boolean arg1) {
        this.useGetSet = arg1;
    }

    public void setVersion(boolean arg1) {
        this.version = arg1;
    }

    public void setWidth(int arg1) {
        this.width = arg1;
    }

    private static String valueIfNotBlank(String arg1) {
        if(arg1 == null || arg1.length() == 0) {
            arg1 = null;
        }

        return arg1;
    }
}

