// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.field;

import com.j256.ormlite.misc.SqlExceptionUtil;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.sql.SQLException;

public class DatabaseFieldConfigLoader {
    private static final String CONFIG_FILE_END_MARKER = "# --field-end--";
    private static final String CONFIG_FILE_START_MARKER = "# --field-start--";
    private static final DataPersister DEFAULT_DATA_PERSISTER = null;
    private static final int DEFAULT_MAX_EAGER_FOREIGN_COLLECTION_LEVEL = 1;
    private static final String FIELD_NAME_ALLOW_GENERATED_ID_INSERT = "allowGeneratedIdInsert";
    private static final String FIELD_NAME_CAN_BE_NULL = "canBeNull";
    private static final String FIELD_NAME_COLUMN_DEFINITION = "columnDefinition";
    private static final String FIELD_NAME_COLUMN_NAME = "columnName";
    private static final String FIELD_NAME_DATA_PERSISTER = "dataPersister";
    private static final String FIELD_NAME_DEFAULT_VALUE = "defaultValue";
    private static final String FIELD_NAME_FIELD_NAME = "fieldName";
    private static final String FIELD_NAME_FOREIGN = "foreign";
    private static final String FIELD_NAME_FOREIGN_AUTO_CREATE = "foreignAutoCreate";
    private static final String FIELD_NAME_FOREIGN_AUTO_REFRESH = "foreignAutoRefresh";
    private static final String FIELD_NAME_FOREIGN_COLLECTION = "foreignCollection";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_COLUMN_NAME = "foreignCollectionColumnName";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_EAGER = "foreignCollectionEager";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_FOREIGN_FIELD_NAME = "foreignCollectionForeignFieldName";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_FOREIGN_FIELD_NAME_OLD = "foreignCollectionForeignColumnName";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_ORDER_ASCENDING = "foreignCollectionOrderAscending";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_ORDER_COLUMN_NAME = "foreignCollectionOrderColumnName";
    private static final String FIELD_NAME_FOREIGN_COLLECTION_ORDER_COLUMN_NAME_OLD = "foreignCollectionOrderColumn";
    private static final String FIELD_NAME_FOREIGN_COLUMN_NAME = "foreignColumnName";
    private static final String FIELD_NAME_FORMAT = "format";
    private static final String FIELD_NAME_GENERATED_ID = "generatedId";
    private static final String FIELD_NAME_GENERATED_ID_SEQUENCE = "generatedIdSequence";
    private static final String FIELD_NAME_ID = "id";
    private static final String FIELD_NAME_INDEX = "index";
    private static final String FIELD_NAME_INDEX_NAME = "indexName";
    private static final String FIELD_NAME_MAX_EAGER_FOREIGN_COLLECTION_LEVEL = "foreignCollectionMaxEagerLevel";
    private static final String FIELD_NAME_MAX_EAGER_FOREIGN_COLLECTION_LEVEL_OLD = "maxEagerForeignCollectionLevel";
    private static final String FIELD_NAME_MAX_FOREIGN_AUTO_REFRESH_LEVEL = "maxForeignAutoRefreshLevel";
    private static final String FIELD_NAME_PERSISTER_CLASS = "persisterClass";
    private static final String FIELD_NAME_READ_ONLY = "readOnly";
    private static final String FIELD_NAME_THROW_IF_NULL = "throwIfNull";
    private static final String FIELD_NAME_UNIQUE = "unique";
    private static final String FIELD_NAME_UNIQUE_COMBO = "uniqueCombo";
    private static final String FIELD_NAME_UNIQUE_INDEX = "uniqueIndex";
    private static final String FIELD_NAME_UNIQUE_INDEX_NAME = "uniqueIndexName";
    private static final String FIELD_NAME_UNKNOWN_ENUM_VALUE = "unknownEnumValue";
    private static final String FIELD_NAME_USE_GET_SET = "useGetSet";
    private static final String FIELD_NAME_VERSION = "version";
    private static final String FIELD_NAME_WIDTH = "width";

    static {
        DatabaseFieldConfigLoader.DEFAULT_DATA_PERSISTER = DatabaseFieldConfig.DEFAULT_DATA_TYPE.getDataPersister();
    }

    public DatabaseFieldConfigLoader() {
        super();
    }

    public static DatabaseFieldConfig fromReader(BufferedReader arg7) {
        String v4;
        DatabaseFieldConfig v0 = new DatabaseFieldConfig();
        int v1 = 0;
        try {
            while(true) {
            label_5:
                v4 = arg7.readLine();
                if(v4 != null) {
                    break;
                }

                goto label_7;
            }
        }
        catch(IOException v0_1) {
            throw SqlExceptionUtil.create("Could not read DatabaseFieldConfig from stream", ((Throwable)v0_1));
        }

        if(!v4.equals("# --field-end--")) {
            if(v4.length() == 0) {
                goto label_5;
            }

            if(v4.startsWith("#")) {
                goto label_5;
            }

            if(v4.equals("# --field-start--")) {
                goto label_5;
            }

            String[] v1_1 = v4.split("=", -2);
            if(v1_1.length != 2) {
                throw new SQLException("DatabaseFieldConfig reading from stream cannot parse line: " + v4);
            }
            else {
                DatabaseFieldConfigLoader.readField(v0, v1_1[0], v1_1[1]);
                v1 = 1;
                goto label_5;
            }
        }

    label_7:
        if(v1 == 0) {
            v0 = null;
        }

        return v0;
    }

    private static void readField(DatabaseFieldConfig arg9, String arg10, String arg11) {
        Class v0_1;
        int v1 = 0;
        if(arg10.equals("fieldName")) {
            arg9.setFieldName(arg11);
        }
        else if(arg10.equals("columnName")) {
            arg9.setColumnName(arg11);
        }
        else if(arg10.equals("dataPersister")) {
            arg9.setDataPersister(DataType.valueOf(arg11).getDataPersister());
        }
        else if(arg10.equals("defaultValue")) {
            arg9.setDefaultValue(arg11);
        }
        else if(arg10.equals("width")) {
            arg9.setWidth(Integer.parseInt(arg11));
        }
        else if(arg10.equals("canBeNull")) {
            arg9.setCanBeNull(Boolean.parseBoolean(arg11));
        }
        else if(arg10.equals("id")) {
            arg9.setId(Boolean.parseBoolean(arg11));
        }
        else if(arg10.equals("generatedId")) {
            arg9.setGeneratedId(Boolean.parseBoolean(arg11));
        }
        else if(arg10.equals("generatedIdSequence")) {
            arg9.setGeneratedIdSequence(arg11);
        }
        else if(arg10.equals("foreign")) {
            arg9.setForeign(Boolean.parseBoolean(arg11));
        }
        else if(arg10.equals("useGetSet")) {
            arg9.setUseGetSet(Boolean.parseBoolean(arg11));
        }
        else if(arg10.equals("unknownEnumValue")) {
            String[] v4 = arg11.split("#", -2);
            if(v4.length != 2) {
                throw new IllegalArgumentException("Invalid value for unknownEnumValue which should be in class#name format: " + arg11);
            }
            else {
                try {
                    v0_1 = Class.forName(v4[0]);
                }
                catch(ClassNotFoundException v0) {
                    throw new IllegalArgumentException("Unknown class specified for unknownEnumValue: " + arg11);
                }

                Object[] v0_2 = v0_1.getEnumConstants();
                if(v0_2 == null) {
                    throw new IllegalArgumentException("Invalid class is not an Enum for unknownEnumValue: " + arg11);
                }
                else {
                    int v5 = v0_2.length;
                    int v3;
                    for(v3 = 0; v3 < v5; ++v3) {
                        Object v6 = v0_2[v3];
                        if(((Enum)v6).name().equals(v4[1])) {
                            arg9.setUnknownEnumValue(((Enum)v6));
                            v1 = 1;
                        }
                    }

                    if(v1 != 0) {
                        return;
                    }

                    throw new IllegalArgumentException("Invalid enum value name for unknownEnumvalue: " + arg11);
                }
            }
        }
        else {
            if(arg10.equals("throwIfNull")) {
                arg9.setThrowIfNull(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("format")) {
                arg9.setFormat(arg11);
                return;
            }

            if(arg10.equals("unique")) {
                arg9.setUnique(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("uniqueCombo")) {
                arg9.setUniqueCombo(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("index")) {
                arg9.setIndex(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("indexName")) {
                arg9.setIndex(true);
                arg9.setIndexName(arg11);
                return;
            }

            if(arg10.equals("uniqueIndex")) {
                arg9.setUniqueIndex(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("uniqueIndexName")) {
                arg9.setUniqueIndex(true);
                arg9.setUniqueIndexName(arg11);
                return;
            }

            if(arg10.equals("foreignAutoRefresh")) {
                arg9.setForeignAutoRefresh(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("maxForeignAutoRefreshLevel")) {
                arg9.setMaxForeignAutoRefreshLevel(Integer.parseInt(arg11));
                return;
            }

            if(arg10.equals("persisterClass")) {
                try {
                    arg9.setPersisterClass(Class.forName(arg11));
                    return;
                }
                catch(ClassNotFoundException v0) {
                    throw new IllegalArgumentException("Could not find persisterClass: " + arg11);
                }
            }

            if(arg10.equals("allowGeneratedIdInsert")) {
                arg9.setAllowGeneratedIdInsert(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("columnDefinition")) {
                arg9.setColumnDefinition(arg11);
                return;
            }

            if(arg10.equals("foreignAutoCreate")) {
                arg9.setForeignAutoCreate(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("version")) {
                arg9.setVersion(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("foreignColumnName")) {
                arg9.setForeignColumnName(arg11);
                return;
            }

            if(arg10.equals("readOnly")) {
                arg9.setReadOnly(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("foreignCollection")) {
                arg9.setForeignCollection(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("foreignCollectionEager")) {
                arg9.setForeignCollectionEager(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("maxEagerForeignCollectionLevel")) {
                arg9.setForeignCollectionMaxEagerLevel(Integer.parseInt(arg11));
                return;
            }

            if(arg10.equals("foreignCollectionMaxEagerLevel")) {
                arg9.setForeignCollectionMaxEagerLevel(Integer.parseInt(arg11));
                return;
            }

            if(arg10.equals("foreignCollectionColumnName")) {
                arg9.setForeignCollectionColumnName(arg11);
                return;
            }

            if(arg10.equals("foreignCollectionOrderColumn")) {
                arg9.setForeignCollectionOrderColumnName(arg11);
                return;
            }

            if(arg10.equals("foreignCollectionOrderColumnName")) {
                arg9.setForeignCollectionOrderColumnName(arg11);
                return;
            }

            if(arg10.equals("foreignCollectionOrderAscending")) {
                arg9.setForeignCollectionOrderAscending(Boolean.parseBoolean(arg11));
                return;
            }

            if(arg10.equals("foreignCollectionForeignColumnName")) {
                arg9.setForeignCollectionForeignFieldName(arg11);
                return;
            }

            if(!arg10.equals("foreignCollectionForeignFieldName")) {
                return;
            }

            arg9.setForeignCollectionForeignFieldName(arg11);
        }
    }

    public static void write(BufferedWriter arg2, DatabaseFieldConfig arg3, String arg4) {
        try {
            DatabaseFieldConfigLoader.writeConfig(arg2, arg3, arg4);
            return;
        }
        catch(IOException v0) {
            throw SqlExceptionUtil.create("Could not write config to writer", ((Throwable)v0));
        }
    }

    public static void writeConfig(BufferedWriter arg9, DatabaseFieldConfig arg10, String arg11) {
        int v0 = 0;
        char v8 = '=';
        arg9.append("# --field-start--");
        arg9.newLine();
        if(arg10.getFieldName() != null) {
            arg9.append("fieldName").append(v8).append(arg10.getFieldName());
            arg9.newLine();
        }

        if(arg10.getColumnName() != null) {
            arg9.append("columnName").append(v8).append(arg10.getColumnName());
            arg9.newLine();
        }

        if(arg10.getDataPersister() != DatabaseFieldConfigLoader.DEFAULT_DATA_PERSISTER) {
            DataType[] v3 = DataType.values();
            int v4 = v3.length;
            int v2 = 0;
            while(v2 < v4) {
                DataType v5 = v3[v2];
                if(v5.getDataPersister() == arg10.getDataPersister()) {
                    arg9.append("dataPersister").append(v8).append(v5.name());
                    arg9.newLine();
                    v0 = 1;
                }
                else {
                    ++v2;
                    continue;
                }

                break;
            }

            if(v0 != 0) {
                goto label_53;
            }

            throw new IllegalArgumentException("Unknown data persister field: " + arg10.getDataPersister());
        }

    label_53:
        if(arg10.getDefaultValue() != null) {
            arg9.append("defaultValue").append(v8).append(arg10.getDefaultValue());
            arg9.newLine();
        }

        if(arg10.getWidth() != 0) {
            arg9.append("width").append(v8).append(Integer.toString(arg10.getWidth()));
            arg9.newLine();
        }

        if(!arg10.isCanBeNull()) {
            arg9.append("canBeNull").append(v8).append(Boolean.toString(arg10.isCanBeNull()));
            arg9.newLine();
        }

        if(arg10.isId()) {
            arg9.append("id").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.isGeneratedId()) {
            arg9.append("generatedId").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.getGeneratedIdSequence() != null) {
            arg9.append("generatedIdSequence").append(v8).append(arg10.getGeneratedIdSequence());
            arg9.newLine();
        }

        if(arg10.isForeign()) {
            arg9.append("foreign").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.isUseGetSet()) {
            arg9.append("useGetSet").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.getUnknownEnumValue() != null) {
            arg9.append("unknownEnumValue").append(v8).append(arg10.getUnknownEnumValue().getClass().getName()).append("#").append(arg10.getUnknownEnumValue().name());
            arg9.newLine();
        }

        if(arg10.isThrowIfNull()) {
            arg9.append("throwIfNull").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.getFormat() != null) {
            arg9.append("format").append(v8).append(arg10.getFormat());
            arg9.newLine();
        }

        if(arg10.isUnique()) {
            arg9.append("unique").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.isUniqueCombo()) {
            arg9.append("uniqueCombo").append(v8).append("true");
            arg9.newLine();
        }

        String v0_1 = arg10.getIndexName(arg11);
        if(v0_1 != null) {
            arg9.append("indexName").append(v8).append(((CharSequence)v0_1));
            arg9.newLine();
        }

        v0_1 = arg10.getUniqueIndexName(arg11);
        if(v0_1 != null) {
            arg9.append("uniqueIndexName").append(v8).append(((CharSequence)v0_1));
            arg9.newLine();
        }

        if(arg10.isForeignAutoRefresh()) {
            arg9.append("foreignAutoRefresh").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.getMaxForeignAutoRefreshLevel() != -1) {
            arg9.append("maxForeignAutoRefreshLevel").append(v8).append(Integer.toString(arg10.getMaxForeignAutoRefreshLevel()));
            arg9.newLine();
        }

        if(arg10.getPersisterClass() != DatabaseFieldConfig.DEFAULT_PERSISTER_CLASS) {
            arg9.append("persisterClass").append(v8).append(arg10.getPersisterClass().getName());
            arg9.newLine();
        }

        if(arg10.isAllowGeneratedIdInsert()) {
            arg9.append("allowGeneratedIdInsert").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.getColumnDefinition() != null) {
            arg9.append("columnDefinition").append(v8).append(arg10.getColumnDefinition());
            arg9.newLine();
        }

        if(arg10.isForeignAutoCreate()) {
            arg9.append("foreignAutoCreate").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.isVersion()) {
            arg9.append("version").append(v8).append("true");
            arg9.newLine();
        }

        v0_1 = arg10.getForeignColumnName();
        if(v0_1 != null) {
            arg9.append("foreignColumnName").append(v8).append(((CharSequence)v0_1));
            arg9.newLine();
        }

        if(arg10.isReadOnly()) {
            arg9.append("readOnly").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.isForeignCollection()) {
            arg9.append("foreignCollection").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.isForeignCollectionEager()) {
            arg9.append("foreignCollectionEager").append(v8).append("true");
            arg9.newLine();
        }

        if(arg10.getForeignCollectionMaxEagerLevel() != 1) {
            arg9.append("foreignCollectionMaxEagerLevel").append(v8).append(Integer.toString(arg10.getForeignCollectionMaxEagerLevel()));
            arg9.newLine();
        }

        if(arg10.getForeignCollectionColumnName() != null) {
            arg9.append("foreignCollectionColumnName").append(v8).append(arg10.getForeignCollectionColumnName());
            arg9.newLine();
        }

        if(arg10.getForeignCollectionOrderColumnName() != null) {
            arg9.append("foreignCollectionOrderColumnName").append(v8).append(arg10.getForeignCollectionOrderColumnName());
            arg9.newLine();
        }

        if(!arg10.isForeignCollectionOrderAscending()) {
            arg9.append("foreignCollectionOrderAscending").append(v8).append(Boolean.toString(arg10.isForeignCollectionOrderAscending()));
            arg9.newLine();
        }

        if(arg10.getForeignCollectionForeignFieldName() != null) {
            arg9.append("foreignCollectionForeignFieldName").append(v8).append(arg10.getForeignCollectionForeignFieldName());
            arg9.newLine();
        }

        arg9.append("# --field-end--");
        arg9.newLine();
    }
}

