// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.field;

import com.j256.ormlite.dao.BaseDaoImpl;
import com.j256.ormlite.dao.BaseForeignCollection;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.dao.EagerForeignCollection;
import com.j256.ormlite.dao.ForeignCollection;
import com.j256.ormlite.dao.LazyForeignCollection;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.types.VoidType;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.stmt.mapped.MappedQueryForId;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseResults;
import com.j256.ormlite.table.DatabaseTableConfig;
import com.j256.ormlite.table.TableInfo;
import java.io.Serializable;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Map;

public class FieldType {
    private static boolean DEFAULT_VALUE_BOOLEAN = false;
    private static byte DEFAULT_VALUE_BYTE = 0;
    private static char DEFAULT_VALUE_CHAR = '\u0000';
    private static double DEFAULT_VALUE_DOUBLE = 0;
    private static float DEFAULT_VALUE_FLOAT = 0f;
    private static int DEFAULT_VALUE_INT = 0;
    private static long DEFAULT_VALUE_LONG = 0;
    private static short DEFAULT_VALUE_SHORT = 0;
    public static final String FOREIGN_ID_FIELD_SUFFIX = "_id";
    private final String columnName;
    private final ConnectionSource connectionSource;
    private DataPersister dataPersister;
    private Object dataTypeConfigObj;
    private Object defaultValue;
    private final Field field;
    private final DatabaseFieldConfig fieldConfig;
    private FieldConverter fieldConverter;
    private final Method fieldGetMethod;
    private final Method fieldSetMethod;
    private BaseDaoImpl foreignDao;
    private FieldType foreignFieldType;
    private FieldType foreignIdField;
    private TableInfo foreignTableInfo;
    private final String generatedIdSequence;
    private final boolean isGeneratedId;
    private final boolean isId;
    private MappedQueryForId mappedQueryForId;
    private final Class parentClass;
    private final String tableName;
    private static final ThreadLocal threadLevelCounters;

    static {
        FieldType.threadLevelCounters = new FieldType$1();
    }

    public FieldType(ConnectionSource arg10, String arg11, Field arg12, DatabaseFieldConfig arg13, Class arg14) {
        DataPersister v1_1;
        Object v0_3;
        Object v2;
        Method v0_1;
        DataPersister v0_4;
        String v7 = null;
        super();
        this.connectionSource = arg10;
        this.tableName = arg11;
        DatabaseType v3 = arg10.getDatabaseType();
        this.field = arg12;
        this.parentClass = arg14;
        arg13.postProcess();
        Class v4 = arg12.getType();
        if(arg13.getDataPersister() == null) {
            Class v1 = arg13.getPersisterClass();
            if(v1 == null || v1 == VoidType.class) {
                v0_4 = DataPersisterManager.lookupForField(arg12);
            }
            else {
                try {
                    v0_1 = v1.getDeclaredMethod("getSingleton");
                    v2 = null;
                }
                catch(Exception v0) {
                    throw SqlExceptionUtil.create("Could not find getSingleton static method on class " + v1, ((Throwable)v0));
                }

                try {
                    v0_3 = v0_1.invoke(v2);
                    if(v0_3 != null) {
                        goto label_89;
                    }
                }
                catch(Exception v0) {
                    throw SqlExceptionUtil.create("Could not run getSingleton method on class " + v1, ((Throwable)v0));
                }
                catch(InvocationTargetException v0_2) {
                    throw SqlExceptionUtil.create("Could not run getSingleton method on class " + v1, v0_2.getTargetException());
                }

                throw new SQLException("Static getSingleton method should not return null on class " + v1);
            label_89:
                goto label_18;
                throw SqlExceptionUtil.create("Could not cast result of static getSingleton method to DataPersister from class " + v1, ((Throwable)v0));
            }

        label_18:
            v1_1 = ((DataPersister)v0_3);
        }
        else {
            v0_4 = arg13.getDataPersister();
            if(!v0_4.isValidForField(arg12)) {
                StringBuilder v1_2 = new StringBuilder();
                v1_2.append("Field class ").append(v4.getName());
                v1_2.append(" for field ").append(this);
                v1_2.append(" is not valid for type ").append(v0_4);
                Class v0_5 = v0_4.getPrimaryClass();
                if(v0_5 != null) {
                    v1_2.append(", maybe should be " + v0_5);
                }

                throw new IllegalArgumentException(v1_2.toString());
            }

            v1_1 = v0_4;
        }

        String v0_6 = arg13.getForeignColumnName();
        String v2_1 = arg12.getName();
        if((arg13.isForeign()) || (arg13.isForeignAutoRefresh()) || v0_6 != null) {
            if(v1_1 != null && (v1_1.isPrimitive())) {
                throw new IllegalArgumentException("Field " + this + " is a primitive class " + v4 + " but marked as foreign");
            }

            v0_6 = v0_6 == null ? v2_1 + "_id" : v2_1 + "_" + v0_6;
            if(!ForeignCollection.class.isAssignableFrom(v4)) {
                goto label_220;
            }

            throw new SQLException("Field \'" + arg12.getName() + "\' in class " + v4 + "\' should use the @" + ForeignCollectionField.class.getSimpleName() + " annotation not foreign=true");
        }
        else if(arg13.isForeignCollection()) {
            if(v4 != Collection.class && !ForeignCollection.class.isAssignableFrom(v4)) {
                throw new SQLException("Field class for \'" + arg12.getName() + "\' must be of class " + ForeignCollection.class.getSimpleName() + " or Collection.");
            }

            Type v0_7 = arg12.getGenericType();
            if(!(v0_7 instanceof ParameterizedType)) {
                throw new SQLException("Field class for \'" + arg12.getName() + "\' must be a parameterized Collection.");
            }

            if(((ParameterizedType)v0_7).getActualTypeArguments().length == 0) {
                throw new SQLException("Field class for \'" + arg12.getName() + "\' must be a parameterized Collection with at least 1 type.");
            }

            v0_6 = v2_1;
        }
        else {
            if(v1_1 == null && !arg13.isForeignCollection()) {
                if(byte[].class.isAssignableFrom(v4)) {
                    throw new SQLException("ORMLite does not know how to store " + v4 + " for field \'" + arg12.getName() + "\'. byte[] fields must specify dataType=DataType.BYTE_ARRAY or SERIALIZABLE");
                }
                else if(Serializable.class.isAssignableFrom(v4)) {
                    throw new SQLException("ORMLite does not know how to store " + v4 + " for field \'" + arg12.getName() + "\'.  Use another class, custom persister, or to serialize it use " + "dataType=DataType.SERIALIZABLE");
                }
                else {
                    throw new IllegalArgumentException("ORMLite does not know how to store " + v4 + " for field " + arg12.getName() + ". Use another class or a custom persister.");
                }
            }

            v0_6 = v2_1;
        }

    label_220:
        this.columnName = arg13.getColumnName() == null ? v0_6 : arg13.getColumnName();
        this.fieldConfig = arg13;
        if(arg13.isId()) {
            if(!arg13.isGeneratedId() && arg13.getGeneratedIdSequence() == null) {
                this.isId = true;
                this.isGeneratedId = false;
                this.generatedIdSequence = v7;
                goto label_302;
            }

            throw new IllegalArgumentException("Must specify one of id, generatedId, and generatedIdSequence with " + arg12.getName());
        }
        else {
            if(arg13.isGeneratedId()) {
                if(arg13.getGeneratedIdSequence() != null) {
                    throw new IllegalArgumentException("Must specify one of id, generatedId, and generatedIdSequence with " + arg12.getName());
                }

                this.isId = true;
                this.isGeneratedId = true;
                if(v3.isIdSequenceNeeded()) {
                    this.generatedIdSequence = v3.generateIdSequenceName(arg11, this);
                    goto label_302;
                }

                this.generatedIdSequence = v7;
                goto label_302;
            }

            if(arg13.getGeneratedIdSequence() != null) {
                this.isId = true;
                this.isGeneratedId = true;
                v0_6 = arg13.getGeneratedIdSequence();
                if(v3.isEntityNamesMustBeUpCase()) {
                    v0_6 = v0_6.toUpperCase();
                }

                this.generatedIdSequence = v0_6;
                goto label_302;
            }

            this.isId = false;
            this.isGeneratedId = false;
            this.generatedIdSequence = v7;
        }

    label_302:
        if((this.isId) && ((arg13.isForeign()) || (arg13.isForeignAutoRefresh()))) {
            throw new IllegalArgumentException("Id field " + arg12.getName() + " cannot also be a foreign object");
        }

        if(arg13.isUseGetSet()) {
            this.fieldGetMethod = DatabaseFieldConfig.findGetMethod(arg12, true);
            this.fieldSetMethod = DatabaseFieldConfig.findSetMethod(arg12, true);
        }
        else {
            if(!arg12.isAccessible()) {
                try {
                    this.field.setAccessible(true);
                }
                catch(SecurityException v0_8) {
                    throw new IllegalArgumentException("Could not open access to field " + arg12.getName() + ".  You may have to set useGetSet=true to fix.");
                }
            }

            this.fieldGetMethod = ((Method)v7);
            this.fieldSetMethod = ((Method)v7);
        }

        if((arg13.isAllowGeneratedIdInsert()) && !arg13.isGeneratedId()) {
            throw new IllegalArgumentException("Field " + arg12.getName() + " must be a generated-id if allowGeneratedIdInsert = true");
        }

        if((arg13.isForeignAutoRefresh()) && !arg13.isForeign()) {
            throw new IllegalArgumentException("Field " + arg12.getName() + " must have foreign = true if foreignAutoRefresh = true");
        }

        if((arg13.isForeignAutoCreate()) && !arg13.isForeign()) {
            throw new IllegalArgumentException("Field " + arg12.getName() + " must have foreign = true if foreignAutoCreate = true");
        }

        if(arg13.getForeignColumnName() != null && !arg13.isForeign()) {
            throw new IllegalArgumentException("Field " + arg12.getName() + " must have foreign = true if foreignColumnName is set");
        }

        if((arg13.isVersion()) && (v1_1 == null || !v1_1.isValidForVersion())) {
            throw new IllegalArgumentException("Field " + arg12.getName() + " is not a valid type to be a version field");
        }

        if(arg13.getMaxForeignAutoRefreshLevel() > 0 && !arg13.isForeignAutoRefresh()) {
            throw new IllegalArgumentException("Field " + arg12.getName() + " has maxForeignAutoRefreshLevel set but not foreignAutoRefresh is false");
        }

        this.assignDataType(v3, v1_1);
    }

    private void assignDataType(DatabaseType arg7, DataPersister arg8) {
        this.dataPersister = arg8;
        if(arg8 != null) {
            this.fieldConverter = arg7.getFieldConverter(arg8);
            if((this.isGeneratedId) && !arg8.isValidGeneratedType()) {
                StringBuilder v1 = new StringBuilder();
                v1.append("Generated-id field \'").append(this.field.getName());
                v1.append("\' in ").append(this.field.getDeclaringClass().getSimpleName());
                v1.append(" can\'t be type ").append(this.dataPersister.getSqlType());
                v1.append(".  Must be one of: ");
                DataType[] v2 = DataType.values();
                int v3 = v2.length;
                int v0;
                for(v0 = 0; v0 < v3; ++v0) {
                    DataType v4 = v2[v0];
                    DataPersister v5 = v4.getDataPersister();
                    if(v5 != null && (v5.isValidGeneratedType())) {
                        v1.append(v4).append(' ');
                    }
                }

                throw new IllegalArgumentException(v1.toString());
            }

            if((this.fieldConfig.isThrowIfNull()) && !arg8.isPrimitive()) {
                throw new SQLException("Field " + this.field.getName() + " must be a primitive if set with throwIfNull");
            }

            if((this.isId) && !arg8.isAppropriateId()) {
                throw new SQLException("Field \'" + this.field.getName() + "\' is of data type " + arg8 + " which cannot be the ID field");
            }

            this.dataTypeConfigObj = arg8.makeConfigObject(this);
            String v0_1 = this.fieldConfig.getDefaultValue();
            if(v0_1 == null) {
                this.defaultValue = null;
                return;
            }

            if(this.isGeneratedId) {
                throw new SQLException("Field \'" + this.field.getName() + "\' cannot be a generatedId and have a default value \'" + v0_1 + "\'");
            }

            this.defaultValue = this.fieldConverter.parseDefaultString(this, v0_1);
        }
        else if(!this.fieldConfig.isForeign() && !this.fieldConfig.isForeignCollection()) {
            throw new SQLException("Data persister for field " + this + " is null but the field is not a foreign or foreignCollection");
        }
    }

    public void assignField(Object arg5, Object arg6, boolean arg7, ObjectCache arg8) {
        Object v1_1;
        DatabaseConnection v2;
        if(this.foreignIdField != null) {
            if(arg6 != null) {
                Object v0 = this.extractJavaFieldValue(arg5);
                if(v0 != null && (v0.equals(arg6))) {
                    return;
                }

                ObjectCache v0_1 = this.foreignDao.getObjectCache();
                v0 = v0_1 == null ? null : v0_1.get(this.getType(), arg6);
                if(v0 != null) {
                    arg6 = v0;
                    goto label_15;
                }

                if(arg7) {
                    goto label_15;
                }

                v0 = FieldType.threadLevelCounters.get();
                if(((FieldType$LevelCounters)v0).autoRefreshLevel == 0) {
                    ((FieldType$LevelCounters)v0).autoRefreshLevelMax = this.fieldConfig.getMaxForeignAutoRefreshLevel();
                }

                if(((FieldType$LevelCounters)v0).autoRefreshLevel >= ((FieldType$LevelCounters)v0).autoRefreshLevelMax) {
                    v0 = this.foreignTableInfo.createObject();
                    this.foreignIdField.assignField(v0, arg6, false, arg8);
                }
                else {
                    if(this.mappedQueryForId == null) {
                        this.mappedQueryForId = MappedQueryForId.build(this.connectionSource.getDatabaseType(), this.foreignDao.getTableInfo(), this.foreignIdField);
                    }

                    ++((FieldType$LevelCounters)v0).autoRefreshLevel;
                    try {
                        v2 = this.connectionSource.getReadOnlyConnection();
                    }
                    catch(Throwable v1) {
                        goto label_86;
                    }

                    try {
                        v1_1 = this.mappedQueryForId.execute(v2, arg6, arg8);
                        goto label_68;
                    }
                    catch(Throwable v1) {
                        try {
                            this.connectionSource.releaseConnection(v2);
                            throw v1;
                        label_68:
                            this.connectionSource.releaseConnection(v2);
                        }
                        catch(Throwable v1) {
                        label_86:
                            --((FieldType$LevelCounters)v0).autoRefreshLevel;
                            if(((FieldType$LevelCounters)v0).autoRefreshLevel <= 0) {
                                FieldType.threadLevelCounters.remove();
                            }

                            throw v1;
                        }
                    }

                    --((FieldType$LevelCounters)v0).autoRefreshLevel;
                    if(((FieldType$LevelCounters)v0).autoRefreshLevel <= 0) {
                        FieldType.threadLevelCounters.remove();
                        v0 = v1_1;
                        goto label_50;
                    }

                    v0 = v1_1;
                }

            label_50:
                arg6 = v0;
            }
            else {
            }

            goto label_15;
        }
        else {
        label_15:
            if(this.fieldSetMethod != null) {
                goto label_104;
            }

            try {
                this.field.set(arg5, arg6);
                return;
            }
            catch(IllegalAccessException v0_2) {
                throw SqlExceptionUtil.create("Could not assign object \'" + arg6 + "\' to field " + this, ((Throwable)v0_2));
            }
            catch(IllegalArgumentException v0_3) {
                throw SqlExceptionUtil.create("Could not assign object \'" + arg6 + "\' to field " + this, ((Throwable)v0_3));
            }

            try {
            label_104:
                this.fieldSetMethod.invoke(arg5, arg6);
            }
            catch(Exception v0_4) {
                throw SqlExceptionUtil.create("Could not call " + this.fieldSetMethod + " on object with \'" + arg6 + "\' for " + this, ((Throwable)v0_4));
            }
        }
    }

    public Object assignIdValue(Object arg4, Number arg5, ObjectCache arg6) {
        Object v0 = this.dataPersister.convertIdNumber(arg5);
        if(v0 == null) {
            throw new SQLException("Invalid class " + this.dataPersister + " for sequence-id " + this);
        }

        this.assignField(arg4, v0, false, arg6);
        return v0;
    }

    public BaseForeignCollection buildForeignCollection(Object arg9, Object arg10) {
        LazyForeignCollection v0_1;
        if(this.foreignFieldType == null) {
            BaseForeignCollection v0 = null;
        }
        else {
            BaseDaoImpl v1 = this.foreignDao;
            if(!this.fieldConfig.isForeignCollectionEager()) {
                v0_1 = new LazyForeignCollection(((Dao)v1), arg9, arg10, this.foreignFieldType, this.fieldConfig.getForeignCollectionOrderColumnName(), this.fieldConfig.isForeignCollectionOrderAscending());
            }
            else {
                Object v7 = FieldType.threadLevelCounters.get();
                if(((FieldType$LevelCounters)v7).foreignCollectionLevel == 0) {
                    ((FieldType$LevelCounters)v7).foreignCollectionLevelMax = this.fieldConfig.getForeignCollectionMaxEagerLevel();
                }

                if(((FieldType$LevelCounters)v7).foreignCollectionLevel >= ((FieldType$LevelCounters)v7).foreignCollectionLevelMax) {
                    v0_1 = new LazyForeignCollection(((Dao)v1), arg9, arg10, this.foreignFieldType, this.fieldConfig.getForeignCollectionOrderColumnName(), this.fieldConfig.isForeignCollectionOrderAscending());
                    goto label_3;
                }

                ++((FieldType$LevelCounters)v7).foreignCollectionLevel;
                try {
                    EagerForeignCollection v0_3 = new EagerForeignCollection(((Dao)v1), arg9, arg10, this.foreignFieldType, this.fieldConfig.getForeignCollectionOrderColumnName(), this.fieldConfig.isForeignCollectionOrderAscending());
                }
                catch(Throwable v0_2) {
                    --((FieldType$LevelCounters)v7).foreignCollectionLevel;
                    throw v0_2;
                }

                --((FieldType$LevelCounters)v7).foreignCollectionLevel;
            }
        }

    label_3:
        return ((BaseForeignCollection)v0_1);
    }

    public void configDaoInformation(ConnectionSource arg9, Class arg10) {
        BaseDaoImpl v1_4;
        MappedQueryForId v0_2;
        Dao v1_2;
        FieldType v3_1;
        TableInfo v4;
        Dao v0_1;
        DatabaseTableConfig v0;
        FieldType v0_5;
        Dao v3_2;
        FieldType v2 = null;
        Class v5 = this.field.getType();
        DatabaseType v6 = arg9.getDatabaseType();
        String v1 = this.fieldConfig.getForeignColumnName();
        if((this.fieldConfig.isForeignAutoRefresh()) || v1 != null) {
            v0 = this.fieldConfig.getForeignTableConfig();
            if(v0 == null) {
                v0_1 = DaoManager.createDao(arg9, v5);
                v4 = ((BaseDaoImpl)v0_1).getTableInfo();
                v3_2 = v0_1;
            }
            else {
                v0.extractFieldTypes(arg9);
                v0_1 = DaoManager.createDao(arg9, v0);
                v4 = ((BaseDaoImpl)v0_1).getTableInfo();
                v3_2 = v0_1;
            }

            if(v1 == null) {
                v0_5 = v4.getIdField();
                if(v0_5 == null) {
                    throw new IllegalArgumentException("Foreign field " + v5 + " does not have id field");
                }
            }
            else {
                v0_5 = v4.getFieldTypeByColumnName(v1);
                if(v0_5 == null) {
                    throw new IllegalArgumentException("Foreign field " + v5 + " does not have field named \'" + v1 + "\'");
                }
            }

            v1_2 = v3_2;
            v3_1 = v0_5;
            v0_2 = MappedQueryForId.build(v6, v4, v0_5);
        }
        else if(this.fieldConfig.isForeign()) {
            if(this.dataPersister != null && (this.dataPersister.isPrimitive())) {
                throw new IllegalArgumentException("Field " + this + " is a primitive class " + v5 + " but marked as foreign");
            }

            v0 = this.fieldConfig.getForeignTableConfig();
            if(v0 != null) {
                v0.extractFieldTypes(arg9);
                v0_1 = DaoManager.createDao(arg9, v0);
            }
            else {
                v0_1 = DaoManager.createDao(arg9, v5);
            }

            TableInfo v3 = ((BaseDaoImpl)v0_1).getTableInfo();
            FieldType v1_1 = v3.getIdField();
            if(v1_1 == null) {
                throw new IllegalArgumentException("Foreign field " + v5 + " does not have id field");
            }

            if((this.isForeignAutoCreate()) && !v1_1.isGeneratedId()) {
                throw new IllegalArgumentException("Field " + this.field.getName() + ", if foreignAutoCreate = true then class " + v5.getSimpleName() + " must have id field with generatedId = true");
            }

            v4 = v3;
            v3_1 = v1_1;
            v1_2 = v0_1;
            v0_2 = ((MappedQueryForId)v2);
        }
        else {
            if(this.fieldConfig.isForeignCollection()) {
                if(v5 != Collection.class && !ForeignCollection.class.isAssignableFrom(v5)) {
                    throw new SQLException("Field class for \'" + this.field.getName() + "\' must be of class " + ForeignCollection.class.getSimpleName() + " or Collection.");
                }

                Type v0_3 = this.field.getGenericType();
                if(!(v0_3 instanceof ParameterizedType)) {
                    throw new SQLException("Field class for \'" + this.field.getName() + "\' must be a parameterized Collection.");
                }

                Type[] v0_4 = ((ParameterizedType)v0_3).getActualTypeArguments();
                if(v0_4.length == 0) {
                    throw new SQLException("Field class for \'" + this.field.getName() + "\' must be a parameterized Collection with at least 1 type.");
                }

                if(!(v0_4[0] instanceof Class)) {
                    throw new SQLException("Field class for \'" + this.field.getName() + "\' must be a parameterized Collection whose generic argument is an entity class not: " + v0_4[0]);
                }

                v0_3 = v0_4[0];
                DatabaseTableConfig v1_3 = this.fieldConfig.getForeignTableConfig();
                v1_2 = v1_3 == null ? DaoManager.createDao(arg9, ((Class)v0_3)) : DaoManager.createDao(arg9, v1_3);
                v3_1 = v2;
                v4 = ((TableInfo)v2);
                MappedQueryForId v7 = ((MappedQueryForId)v2);
                v2 = this.findForeignFieldType(((Class)v0_3), arg10, ((BaseDaoImpl)v1_2));
                v0_2 = v7;
                goto label_57;
            }

            v0_2 = ((MappedQueryForId)v2);
            v1_4 = ((BaseDaoImpl)v2);
            v3_1 = v2;
            v4 = ((TableInfo)v2);
        }

    label_57:
        this.mappedQueryForId = v0_2;
        this.foreignTableInfo = v4;
        this.foreignFieldType = v2;
        this.foreignDao = v1_4;
        this.foreignIdField = v3_1;
        if(this.foreignIdField != null) {
            this.assignDataType(v6, this.foreignIdField.getDataPersister());
        }
    }

    public Object convertJavaFieldToSqlArgValue(Object arg2) {
        Object v0 = arg2 == null ? null : this.fieldConverter.javaToSqlArg(this, arg2);
        return v0;
    }

    public Object convertStringToJavaField(String arg2, int arg3) {
        Object v0 = arg2 == null ? null : this.fieldConverter.resultStringToJava(this, arg2, arg3);
        return v0;
    }

    public static FieldType createFieldType(ConnectionSource arg6, String arg7, Field arg8, Class arg9) {
        DatabaseFieldConfig v4 = DatabaseFieldConfig.fromField(arg6.getDatabaseType(), arg7, arg8);
        FieldType v0 = v4 == null ? null : new FieldType(arg6, arg7, arg8, v4, arg9);
        return v0;
    }

    public int createWithForeignDao(Object arg2) {
        return this.foreignDao.create(arg2);
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && arg4.getClass() == this.getClass() && (this.field.equals(((FieldType)arg4).field))) {
            if(this.parentClass == null) {
                if(((FieldType)arg4).parentClass != null) {
                    return v0;
                }
            }
            else if(this.parentClass.equals(((FieldType)arg4).parentClass)) {
            }
            else {
                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    public Object extractJavaFieldToSqlArgValue(Object arg2) {
        return this.convertJavaFieldToSqlArgValue(this.extractJavaFieldValue(arg2));
    }

    public Object extractJavaFieldValue(Object arg3) {
        Object v0 = this.extractRawJavaFieldValue(arg3);
        if(this.foreignIdField != null && v0 != null) {
            v0 = this.foreignIdField.extractRawJavaFieldValue(v0);
        }

        return v0;
    }

    public Object extractRawJavaFieldValue(Object arg4) {
        Object v0_1;
        if(this.fieldGetMethod == null) {
            try {
                v0_1 = this.field.get(arg4);
            }
            catch(Exception v0) {
                throw SqlExceptionUtil.create("Could not get field value for " + this, ((Throwable)v0));
            }
        }
        else {
            try {
                v0_1 = this.fieldGetMethod.invoke(arg4);
            }
            catch(Exception v0) {
                throw SqlExceptionUtil.create("Could not call " + this.fieldGetMethod + " for " + this, ((Throwable)v0));
            }
        }

        return v0_1;
    }

    private FieldType findForeignFieldType(Class arg7, Class arg8, BaseDaoImpl arg9) {
        String v1 = this.fieldConfig.getForeignCollectionForeignFieldName();
        FieldType[] v2 = arg9.getTableInfo().getFieldTypes();
        int v3 = v2.length;
        int v0;
        for(v0 = 0; v0 < v3; ++v0) {
            FieldType v4 = v2[v0];
            if(v4.getType() == arg8 && (v1 == null || (v4.getField().getName().equals(v1)))) {
                if(!v4.fieldConfig.isForeign() && !v4.fieldConfig.isForeignAutoRefresh()) {
                    throw new SQLException("Foreign collection object " + arg7 + " for field \'" + this.field.getName() + "\' contains a field of class " + arg8 + " but it\'s not foreign");
                }

                return v4;
            }
        }

        StringBuilder v0_1 = new StringBuilder();
        v0_1.append("Foreign collection class ").append(arg7.getName());
        v0_1.append(" for field \'").append(this.field.getName()).append("\' column-name does not contain a foreign field");
        if(v1 != null) {
            v0_1.append(" named \'").append(v1).append('\'');
        }

        v0_1.append(" of class ").append(arg8.getName());
        throw new SQLException(v0_1.toString());
    }

    public Object generateId() {
        return this.dataPersister.generateId();
    }

    public String getColumnDefinition() {
        return this.fieldConfig.getColumnDefinition();
    }

    public String getColumnName() {
        return this.columnName;
    }

    public DataPersister getDataPersister() {
        return this.dataPersister;
    }

    public Object getDataTypeConfigObj() {
        return this.dataTypeConfigObj;
    }

    public Object getDefaultValue() {
        return this.defaultValue;
    }

    public Field getField() {
        return this.field;
    }

    public String getFieldName() {
        return this.field.getName();
    }

    public Object getFieldValueIfNotDefault(Object arg3) {
        Object v0 = this.extractJavaFieldValue(arg3);
        if(this.isFieldValueDefault(v0)) {
            v0 = null;
        }

        return v0;
    }

    public FieldType getForeignIdField() {
        return this.foreignIdField;
    }

    public String getFormat() {
        return this.fieldConfig.getFormat();
    }

    public String getGeneratedIdSequence() {
        return this.generatedIdSequence;
    }

    public String getIndexName() {
        return this.fieldConfig.getIndexName(this.tableName);
    }

    public Object getJavaDefaultValueDefault() {
        Byte v0_8;
        if(this.field.getType() == Boolean.TYPE) {
            Boolean v0 = Boolean.valueOf(FieldType.DEFAULT_VALUE_BOOLEAN);
        }
        else {
            if(this.field.getType() != Byte.TYPE && this.field.getType() != Byte.class) {
                if(this.field.getType() != Character.TYPE && this.field.getType() != Character.class) {
                    if(this.field.getType() != Short.TYPE && this.field.getType() != Short.class) {
                        if(this.field.getType() != Integer.TYPE && this.field.getType() != Integer.class) {
                            if(this.field.getType() != Long.TYPE && this.field.getType() != Long.class) {
                                if(this.field.getType() != Float.TYPE && this.field.getType() != Float.class) {
                                    if(this.field.getType() != Double.TYPE && this.field.getType() != Double.class) {
                                        Object v0_1 = null;
                                        return v0_8;
                                    }

                                    Double v0_2 = Double.valueOf(FieldType.DEFAULT_VALUE_DOUBLE);
                                    return v0_8;
                                }

                                Float v0_3 = Float.valueOf(FieldType.DEFAULT_VALUE_FLOAT);
                                return v0_8;
                            }

                            Long v0_4 = Long.valueOf(FieldType.DEFAULT_VALUE_LONG);
                            return v0_8;
                        }

                        Integer v0_5 = Integer.valueOf(FieldType.DEFAULT_VALUE_INT);
                        return v0_8;
                    }

                    Short v0_6 = Short.valueOf(FieldType.DEFAULT_VALUE_SHORT);
                    return v0_8;
                }

                Character v0_7 = Character.valueOf(FieldType.DEFAULT_VALUE_CHAR);
                return v0_8;
            }

            v0_8 = Byte.valueOf(FieldType.DEFAULT_VALUE_BYTE);
        }

        return v0_8;
    }

    public SqlType getSqlType() {
        return this.fieldConverter.getSqlType();
    }

    public String getTableName() {
        return this.tableName;
    }

    public Class getType() {
        return this.field.getType();
    }

    public String getUniqueIndexName() {
        return this.fieldConfig.getUniqueIndexName(this.tableName);
    }

    public Enum getUnknownEnumVal() {
        return this.fieldConfig.getUnknownEnumValue();
    }

    public int getWidth() {
        return this.fieldConfig.getWidth();
    }

    public int hashCode() {
        return this.field.hashCode();
    }

    public boolean isAllowGeneratedIdInsert() {
        return this.fieldConfig.isAllowGeneratedIdInsert();
    }

    public boolean isArgumentHolderRequired() {
        return this.dataPersister.isArgumentHolderRequired();
    }

    public boolean isCanBeNull() {
        return this.fieldConfig.isCanBeNull();
    }

    public boolean isComparable() {
        boolean v0;
        if(this.fieldConfig.isForeignCollection()) {
            v0 = false;
        }
        else if(this.dataPersister == null) {
            throw new SQLException("Internal error.  Data-persister is not configured for field.  Please post _full_ exception with associated data objects to mailing list: " + this);
        }
        else {
            v0 = this.dataPersister.isComparable();
        }

        return v0;
    }

    public boolean isEscapedDefaultValue() {
        return this.dataPersister.isEscapedDefaultValue();
    }

    public boolean isEscapedValue() {
        return this.dataPersister.isEscapedValue();
    }

    private boolean isFieldValueDefault(Object arg2) {
        boolean v0 = arg2 == null ? true : arg2.equals(this.getJavaDefaultValueDefault());
        return v0;
    }

    public boolean isForeign() {
        return this.fieldConfig.isForeign();
    }

    public boolean isForeignAutoCreate() {
        return this.fieldConfig.isForeignAutoCreate();
    }

    public boolean isForeignCollection() {
        return this.fieldConfig.isForeignCollection();
    }

    public boolean isGeneratedId() {
        return this.isGeneratedId;
    }

    public boolean isGeneratedIdSequence() {
        boolean v0 = this.generatedIdSequence != null ? true : false;
        return v0;
    }

    public boolean isId() {
        return this.isId;
    }

    public boolean isObjectsFieldValueDefault(Object arg2) {
        return this.isFieldValueDefault(this.extractJavaFieldValue(arg2));
    }

    public boolean isReadOnly() {
        return this.fieldConfig.isReadOnly();
    }

    public boolean isSelfGeneratedId() {
        return this.dataPersister.isSelfGeneratedId();
    }

    public boolean isUnique() {
        return this.fieldConfig.isUnique();
    }

    public boolean isUniqueCombo() {
        return this.fieldConfig.isUniqueCombo();
    }

    public boolean isVersion() {
        return this.fieldConfig.isVersion();
    }

    public Object moveToNextValue(Object arg2) {
        Object v0 = this.dataPersister == null ? null : this.dataPersister.moveToNextValue(arg2);
        return v0;
    }

    public Object resultToJava(DatabaseResults arg5, Map arg6) {
        Object v1 = null;
        Object v0 = arg6.get(this.columnName);
        if(v0 == null) {
            Integer v0_1 = Integer.valueOf(arg5.findColumn(this.columnName));
            arg6.put(this.columnName, v0_1);
        }

        Object v2 = this.fieldConverter.resultToJava(this, arg5, ((Integer)v0).intValue());
        if(this.fieldConfig.isForeign()) {
            if(arg5.wasNull(((Integer)v0).intValue())) {
                v0 = v1;
            }
            else {
                goto label_50;
            }
        }
        else if(this.dataPersister.isPrimitive()) {
            if(!this.fieldConfig.isThrowIfNull()) {
                goto label_50;
            }
            else if(arg5.wasNull(((Integer)v0).intValue())) {
                throw new SQLException("Results value for primitive field \'" + this.field.getName() + "\' was an invalid null value");
            }
            else {
                goto label_50;
            }
        }
        else if(this.fieldConverter.isStreamType()) {
        label_50:
            v0 = v2;
        }
        else if(arg5.wasNull(((Integer)v0).intValue())) {
            v0 = v1;
        }
        else {
            goto label_50;
        }

        return v0;
    }

    public String toString() {
        return this.getClass().getSimpleName() + ":name=" + this.field.getName() + ",class=" + this.field.getDeclaringClass().getSimpleName();
    }
}

