// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.field.types;

import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.field.SqlType;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.DatabaseResults;
import java.io.UnsupportedEncodingException;
import java.sql.SQLException;

public class StringBytesType extends BaseDataType {
    private static final String DEFAULT_STRING_BYTES_CHARSET_NAME = "Unicode";
    private static final StringBytesType singleTon;

    static {
        StringBytesType.singleTon = new StringBytesType();
    }

    private StringBytesType() {
        super(SqlType.BYTE_ARRAY, new Class[0]);
    }

    protected StringBytesType(SqlType arg1, Class[] arg2) {
        super(arg1, arg2);
    }

    private String getCharsetName(FieldType arg2) {
        String v0 = arg2 == null || arg2.getFormat() == null ? "Unicode" : arg2.getFormat();
        return v0;
    }

    public Class getPrimaryClass() {
        return String.class;
    }

    public static StringBytesType getSingleton() {
        return StringBytesType.singleTon;
    }

    public boolean isAppropriateId() {
        return 0;
    }

    public boolean isArgumentHolderRequired() {
        return 1;
    }

    public Object javaToSqlArg(FieldType arg5, Object arg6) {
        byte[] v0_1;
        String v0 = this.getCharsetName(arg5);
        try {
            v0_1 = ((String)arg6).getBytes(v0);
            return v0_1;
        }
        catch(UnsupportedEncodingException v1) {
            throw SqlExceptionUtil.create("Could not convert string with charset name: " + (((String)v0_1)), ((Throwable)v1));
        }
    }

    public Object parseDefaultString(FieldType arg3, String arg4) {
        throw new SQLException("String-bytes type cannot have default values");
    }

    public Object resultStringToJava(FieldType arg3, String arg4, int arg5) {
        throw new SQLException("String-bytes type cannot be converted from string to Java");
    }

    public Object resultToSqlArg(FieldType arg2, DatabaseResults arg3, int arg4) {
        return arg3.getBytes(arg4);
    }

    public Object sqlArgToJava(FieldType arg5, Object arg6, int arg7) {
        String v1 = this.getCharsetName(arg5);
        try {
            return new String(((byte[])arg6), v1);
        }
        catch(UnsupportedEncodingException v0) {
            throw SqlExceptionUtil.create("Could not convert string with charset name: " + v1, ((Throwable)v0));
        }
    }
}

