// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.logger;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Pattern;

public class LocalLog implements Log {
    private static final Log$Level DEFAULT_LEVEL = null;
    public static final String LOCAL_LOG_FILE_PROPERTY = "com.j256.ormlite.logger.file";
    public static final String LOCAL_LOG_LEVEL_PROPERTY = "com.j256.ormlite.logger.level";
    public static final String LOCAL_LOG_PROPERTIES_FILE = "/ormliteLocalLog.properties";
    private static final List classLevels;
    private final String className;
    private static final ThreadLocal dateFormatThreadLocal;
    private final Log$Level level;
    private static PrintStream printStream;

    static {
        LocalLog.DEFAULT_LEVEL = Log$Level.DEBUG;
        LocalLog.dateFormatThreadLocal = new LocalLog$1();
        LocalLog.classLevels = LocalLog.readLevelResourceFile(LocalLog.class.getResourceAsStream("/ormliteLocalLog.properties"));
        LocalLog.openLogFile(System.getProperty("com.j256.ormlite.logger.file"));
    }

    public LocalLog(String arg6) {
        Log$Level v0_1;
        super();
        this.className = LoggerFactory.getSimpleClassName(arg6);
        Log$Level v1 = null;
        if(LocalLog.classLevels != null) {
            Iterator v2 = LocalLog.classLevels.iterator();
            while(v2.hasNext()) {
                Object v0 = v2.next();
                if(((LocalLog$PatternLevel)v0).pattern.matcher(((CharSequence)arg6)).matches()) {
                    if(v1 != null && ((LocalLog$PatternLevel)v0).level.ordinal() >= v1.ordinal()) {
                        goto label_46;
                    }

                    v0_1 = ((LocalLog$PatternLevel)v0).level;
                }
                else {
                label_46:
                    v0_1 = v1;
                }

                v1 = v0_1;
            }

            v0_1 = v1;
        }
        else {
            v0_1 = v1;
        }

        if(v0_1 == null) {
            String v1_1 = System.getProperty("com.j256.ormlite.logger.level");
            if(v1_1 == null) {
                v0_1 = LocalLog.DEFAULT_LEVEL;
            }
            else {
                try {
                    v0_1 = Log$Level.valueOf(v1_1.toUpperCase());
                }
                catch(IllegalArgumentException v0_2) {
                    throw new IllegalArgumentException("Level \'" + v1_1 + "\' was not found", ((Throwable)v0_2));
                }
            }
        }

        this.level = v0_1;
    }

    private static List configureClassLevels(InputStream arg8) {
        Log$Level v3_1;
        BufferedReader v0 = new BufferedReader(new InputStreamReader(arg8));
        ArrayList v1 = new ArrayList();
        while(true) {
            String v2 = v0.readLine();
            if(v2 == null) {
                break;
            }

            if(v2.length() == 0) {
                continue;
            }

            if(v2.charAt(0) == 35) {
                continue;
            }

            String[] v3 = v2.split("=");
            if(v3.length != 2) {
                System.err.println("Line is not in the format of \'pattern = level\': " + v2);
                continue;
            }

            Pattern v2_1 = Pattern.compile(v3[0].trim());
            try {
                v3_1 = Log$Level.valueOf(v3[1].trim());
            }
            catch(IllegalArgumentException v2_2) {
                System.err.println("Level \'" + v3_1[1] + "\' was not found");
                continue;
            }

            ((List)v1).add(new LocalLog$PatternLevel(v2_1, v3_1));
        }

        return ((List)v1);
    }

    void flush() {
        LocalLog.printStream.flush();
    }

    public boolean isLevelEnabled(Log$Level arg2) {
        return this.level.isEnabled(arg2);
    }

    public void log(Log$Level arg2, String arg3) {
        this.printMessage(arg2, arg3, null);
    }

    public void log(Log$Level arg1, String arg2, Throwable arg3) {
        this.printMessage(arg1, arg2, arg3);
    }

    public static void openLogFile(String arg4) {
        if(arg4 == null) {
            LocalLog.printStream = System.out;
        }
        else {
            try {
                LocalLog.printStream = new PrintStream(new File(arg4));
            }
            catch(FileNotFoundException v0) {
                throw new IllegalArgumentException("Log file " + arg4 + " was not found", ((Throwable)v0));
            }
        }
    }

    private void printMessage(Log$Level arg4, String arg5, Throwable arg6) {
        if(this.isLevelEnabled(arg4)) {
            StringBuilder v1 = new StringBuilder(128);
            v1.append(LocalLog.dateFormatThreadLocal.get().format(new Date()));
            v1.append(" [").append(arg4.name()).append("] ");
            v1.append(this.className).append(' ');
            v1.append(arg5);
            LocalLog.printStream.println(v1.toString());
            if(arg6 != null) {
                arg6.printStackTrace(LocalLog.printStream);
            }
        }
    }

    static List readLevelResourceFile(InputStream arg5) {
        List v0 = null;
        if(arg5 != null) {
            try {
                v0 = LocalLog.configureClassLevels(arg5);
            }
            catch(Throwable v0_1) {
                try {
                label_19:
                    arg5.close();
                }
                catch(IOException v1) {
                }

                throw v0_1;
            }
            catch(IOException v1) {
                try {
                    System.err.println("IO exception reading the log properties file \'/ormliteLocalLog.properties\': " + v1);
                }
                catch(Throwable v0_1) {
                    goto label_19;
                }

                try {
                    arg5.close();
                }
                catch(IOException v1) {
                }

                return v0;
            }

            try {
                arg5.close();
            }
            catch(IOException v1) {
            }
        }

        return v0;
    }
}

