// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.misc;

import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import java.sql.SQLException;
import java.sql.Savepoint;
import java.util.concurrent.Callable;
import java.util.concurrent.atomic.AtomicInteger;

public class TransactionManager {
    private static final String SAVE_POINT_PREFIX = "ORMLITE";
    private ConnectionSource connectionSource;
    private static final Logger logger;
    private static AtomicInteger savePointCounter;

    static {
        TransactionManager.logger = LoggerFactory.getLogger(TransactionManager.class);
        TransactionManager.savePointCounter = new AtomicInteger();
    }

    public TransactionManager() {
        super();
    }

    public TransactionManager(ConnectionSource arg1) {
        super();
        this.connectionSource = arg1;
        this.initialize();
    }

    public static Object callInTransaction(ConnectionSource arg3, Callable arg4) {
        Object v0_1;
        DatabaseConnection v1 = arg3.getReadWriteConnection();
        try {
            v0_1 = TransactionManager.callInTransaction(v1, arg3.saveSpecialConnection(v1), arg3.getDatabaseType(), arg4);
        }
        catch(Throwable v0) {
            arg3.clearSpecialConnection(v1);
            arg3.releaseConnection(v1);
            throw v0;
        }

        arg3.clearSpecialConnection(v1);
        arg3.releaseConnection(v1);
        return v0_1;
    }

    public static Object callInTransaction(DatabaseConnection arg6, boolean arg7, DatabaseType arg8, Callable arg9) {
        Object v0_4;
        int v3;
        Savepoint v2;
        boolean v1 = false;
        Savepoint v0 = null;
        if(!arg7) {
            try {
                if(!arg8.isNestedSavePointsSupported()) {
                }
                else {
                    goto label_6;
                }
            }
            catch(Throwable v0_1) {
                goto label_45;
            }

            v2 = v0;
            v3 = 0;
        }
        else {
            try {
            label_6:
                if(arg6.isAutoCommitSupported()) {
                    v1 = arg6.isAutoCommit();
                    if(v1) {
                        arg6.setAutoCommit(false);
                        TransactionManager.logger.debug("had to set auto-commit to false");
                    }
                }

                v0 = arg6.setSavePoint("ORMLITE" + TransactionManager.savePointCounter.incrementAndGet());
                if(v0 == null) {
                    TransactionManager.logger.debug("started savePoint transaction");
                }
                else {
                    TransactionManager.logger.debug("started savePoint transaction {}", v0.getSavepointName());
                }
            }
            catch(Throwable v0_1) {
                goto label_45;
            }

            v2 = v0;
            v3 = 1;
        }

        try {
            v0_4 = arg9.call();
            if(v3 != 0) {
                TransactionManager.commit(arg6, v2);
            }
        }
        catch(Throwable v0_1) {
        }
        catch(Exception v0_2) {
        }
        catch(SQLException v0_3) {
            if(v3 != 0) {
                try {
                    TransactionManager.rollBack(arg6, v2);
                    goto label_54;
                }
                catch(Throwable v0_1) {
                }
                catch(SQLException v2_1) {
                    try {
                        TransactionManager.logger.error(((Throwable)v0_3), "after commit exception, rolling back to save-point also threw exception");
                    label_54:
                        throw v0_3;
                    }
                    catch(Throwable v0_1) {
                        goto label_45;
                    }

                    if(v3 != 0) {
                        try {
                            TransactionManager.rollBack(arg6, v2);
                            goto label_63;
                        }
                        catch(Throwable v0_1) {
                        }
                        catch(SQLException v2_1) {
                            try {
                                TransactionManager.logger.error(((Throwable)v0_2), "after commit exception, rolling back to save-point also threw exception");
                            label_63:
                                throw SqlExceptionUtil.create("Transaction callable threw non-SQL exception", ((Throwable)v0_2));
                            }
                            catch(Throwable v0_1) {
                            label_45:
                                if(v1) {
                                    arg6.setAutoCommit(true);
                                    TransactionManager.logger.debug("restored auto-commit to true");
                                }

                                throw v0_1;
                            }
                        }
                    }
                    else {
                        goto label_63;
                    }
                }
            }
            else {
                goto label_54;
            }
        }

        if(v1) {
            arg6.setAutoCommit(true);
            TransactionManager.logger.debug("restored auto-commit to true");
        }

        return v0_4;
    }

    public static Object callInTransaction(DatabaseConnection arg1, DatabaseType arg2, Callable arg3) {
        return TransactionManager.callInTransaction(arg1, false, arg2, arg3);
    }

    public Object callInTransaction(Callable arg2) {
        return TransactionManager.callInTransaction(this.connectionSource, arg2);
    }

    private static void commit(DatabaseConnection arg3, Savepoint arg4) {
        String v0 = arg4 == null ? null : arg4.getSavepointName();
        arg3.commit(arg4);
        if(v0 == null) {
            TransactionManager.logger.debug("committed savePoint transaction");
        }
        else {
            TransactionManager.logger.debug("committed savePoint transaction {}", v0);
        }
    }

    public void initialize() {
        if(this.connectionSource == null) {
            throw new IllegalStateException("dataSource was not set on " + this.getClass().getSimpleName());
        }
    }

    private static void rollBack(DatabaseConnection arg3, Savepoint arg4) {
        String v0 = arg4 == null ? null : arg4.getSavepointName();
        arg3.rollback(arg4);
        if(v0 == null) {
            TransactionManager.logger.debug("rolled back savePoint transaction");
        }
        else {
            TransactionManager.logger.debug("rolled back savePoint transaction {}", v0);
        }
    }

    public void setConnectionSource(ConnectionSource arg1) {
        this.connectionSource = arg1;
    }
}

