// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.misc;

import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;

public class VersionUtils {
    private static final String CORE_VERSION = "VERSION__4.48__";
    private static String coreVersion;
    private static Logger logger;
    private static boolean thrownOnErrors;

    static {
        VersionUtils.thrownOnErrors = false;
        VersionUtils.coreVersion = "VERSION__4.48__";
    }

    private VersionUtils() {
        super();
    }

    public static final void checkCoreVersusAndroidVersions(String arg3) {
        VersionUtils.logVersionWarnings("core", VersionUtils.coreVersion, "android", arg3);
    }

    public static final void checkCoreVersusJdbcVersions(String arg3) {
        VersionUtils.logVersionWarnings("core", VersionUtils.coreVersion, "jdbc", arg3);
    }

    public static String getCoreVersion() {
        return VersionUtils.coreVersion;
    }

    private static Logger getLogger() {
        if(VersionUtils.logger == null) {
            VersionUtils.logger = LoggerFactory.getLogger(VersionUtils.class);
        }

        return VersionUtils.logger;
    }

    private static void logVersionWarnings(String arg8, String arg9, String arg10, String arg11) {
        Object[] v2;
        Throwable v7 = null;
        int v6 = 3;
        int v5 = 2;
        if(arg9 == null) {
            if(arg11 != null) {
                v2 = new Object[v6];
                v2[0] = arg8;
                v2[1] = arg10;
                v2[v5] = arg11;
                VersionUtils.warning(v7, "Unknown version", " for {}, version for {} is \'{}\'", v2);
            }
        }
        else if(arg11 == null) {
            v2 = new Object[v6];
            v2[0] = arg10;
            v2[1] = arg8;
            v2[v5] = arg9;
            VersionUtils.warning(v7, "Unknown version", " for {}, version for {} is \'{}\'", v2);
        }
        else if(!arg9.equals(arg11)) {
            v2 = new Object[4];
            v2[0] = arg8;
            v2[1] = arg9;
            v2[v5] = arg10;
            v2[v6] = arg11;
            VersionUtils.warning(v7, "Mismatched versions", ": {} is \'{}\', while {} is \'{}\'", v2);
        }
    }

    static void setThrownOnErrors(boolean arg0) {
        VersionUtils.thrownOnErrors = arg0;
    }

    private static void warning(Throwable arg3, String arg4, String arg5, Object[] arg6) {
        VersionUtils.getLogger().warn(arg3, arg4 + arg5, arg6);
        if(VersionUtils.thrownOnErrors) {
            throw new IllegalStateException("See error log for details:" + arg4);
        }
    }
}

