// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt;

import com.j256.ormlite.dao.CloseableIterator;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.GenericRawResults;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.stmt.query.OrderBy;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class QueryBuilder extends StatementBuilder {
    private boolean distinct;
    private List groupByList;
    private String groupByRaw;
    private String having;
    private final FieldType idField;
    private boolean isCountOfQuery;
    private boolean isInnerQuery;
    private List joinList;
    private Long limit;
    private Long offset;
    private ArgumentHolder[] orderByArgs;
    private List orderByList;
    private String orderByRaw;
    private FieldType[] resultFieldTypes;
    private List selectColumnList;
    private boolean selectIdColumn;
    private List selectRawList;

    public QueryBuilder(DatabaseType arg2, TableInfo arg3, Dao arg4) {
        super(arg2, arg3, arg4, StatementBuilder$StatementType.SELECT);
        this.selectIdColumn = true;
        this.idField = arg3.getIdField();
    }

    private void addJoinInfo(String arg3, QueryBuilder arg4, StatementBuilder$WhereOperation arg5) {
        QueryBuilder$JoinInfo v0 = new QueryBuilder$JoinInfo(this, arg3, arg4, arg5);
        this.matchJoinedFields(v0, arg4);
        if(this.joinList == null) {
            this.joinList = new ArrayList();
        }

        this.joinList.add(v0);
    }

    private void addSelectColumnToList(String arg2) {
        this.verifyColumnName(arg2);
        this.selectColumnList.add(arg2);
    }

    private void appendColumnName(StringBuilder arg3, String arg4) {
        if(this.addTableName) {
            this.databaseType.appendEscapedEntityName(arg3, this.tableName);
            arg3.append('.');
        }

        this.databaseType.appendEscapedEntityName(arg3, arg4);
    }

    private void appendColumns(StringBuilder arg10) {
        char v8 = ',';
        if(this.selectColumnList == null) {
            if(this.addTableName) {
                this.databaseType.appendEscapedEntityName(arg10, this.tableName);
                arg10.append('.');
            }

            arg10.append("* ");
            this.resultFieldTypes = this.tableInfo.getFieldTypes();
        }
        else {
            int v0 = this.isInnerQuery ? 1 : 0;
            ArrayList v5 = new ArrayList(this.selectColumnList.size() + 1);
            Iterator v6 = this.selectColumnList.iterator();
            int v3 = v0;
            int v4 = 1;
            while(v6.hasNext()) {
                FieldType v0_1 = this.tableInfo.getFieldTypeByColumnName(v6.next());
                if(v0_1.isForeignCollection()) {
                    ((List)v5).add(v0_1);
                    continue;
                }

                if(v4 != 0) {
                    v4 = 0;
                }
                else {
                    arg10.append(v8);
                }

                this.appendFieldColumnName(arg10, v0_1, ((List)v5));
                v0 = v0_1 == this.idField ? 1 : v3;
                v3 = v0;
            }

            if(v3 == 0 && (this.selectIdColumn)) {
                if(v4 == 0) {
                    arg10.append(v8);
                }

                this.appendFieldColumnName(arg10, this.idField, ((List)v5));
            }

            arg10.append(' ');
            this.resultFieldTypes = ((List)v5).toArray(new FieldType[((List)v5).size()]);
        }
    }

    private void appendFieldColumnName(StringBuilder arg2, FieldType arg3, List arg4) {
        this.appendColumnName(arg2, arg3.getColumnName());
        if(arg4 != null) {
            arg4.add(arg3);
        }
    }

    private void appendGroupBys(StringBuilder arg5) {
        boolean v1;
        if(this.hasGroupStuff()) {
            this.appendGroupBys(arg5, true);
            v1 = false;
        }
        else {
            v1 = true;
        }

        if(this.joinList != null) {
            Iterator v2 = this.joinList.iterator();
            while(v2.hasNext()) {
                Object v0 = v2.next();
                if(((QueryBuilder$JoinInfo)v0).queryBuilder == null) {
                    continue;
                }

                if(!((QueryBuilder$JoinInfo)v0).queryBuilder.hasGroupStuff()) {
                    continue;
                }

                ((QueryBuilder$JoinInfo)v0).queryBuilder.appendGroupBys(arg5, v1);
            }
        }
    }

    private void appendGroupBys(StringBuilder arg4, boolean arg5) {
        char v2 = ',';
        if(arg5) {
            arg4.append("GROUP BY ");
        }

        if(this.groupByRaw != null) {
            if(!arg5) {
                arg4.append(v2);
            }

            arg4.append(this.groupByRaw);
        }
        else {
            Iterator v1 = this.groupByList.iterator();
            while(v1.hasNext()) {
                Object v0 = v1.next();
                if(0 != 0) {
                }
                else {
                    arg4.append(v2);
                }

                this.appendColumnName(arg4, ((String)v0));
            }
        }

        arg4.append(' ');
    }

    private void appendHaving(StringBuilder arg3) {
        if(this.having != null) {
            arg3.append("HAVING ").append(this.having).append(' ');
        }
    }

    private void appendJoinSql(StringBuilder arg6) {
        char v4 = '.';
        Iterator v1 = this.joinList.iterator();
        while(v1.hasNext()) {
            Object v0 = v1.next();
            arg6.append(((QueryBuilder$JoinInfo)v0).type).append(" JOIN ");
            this.databaseType.appendEscapedEntityName(arg6, ((QueryBuilder$JoinInfo)v0).queryBuilder.tableName);
            arg6.append(" ON ");
            this.databaseType.appendEscapedEntityName(arg6, this.tableName);
            arg6.append(v4);
            this.databaseType.appendEscapedEntityName(arg6, ((QueryBuilder$JoinInfo)v0).localField.getColumnName());
            arg6.append(" = ");
            this.databaseType.appendEscapedEntityName(arg6, ((QueryBuilder$JoinInfo)v0).queryBuilder.tableName);
            arg6.append(v4);
            this.databaseType.appendEscapedEntityName(arg6, ((QueryBuilder$JoinInfo)v0).remoteField.getColumnName());
            arg6.append(' ');
            if(((QueryBuilder$JoinInfo)v0).queryBuilder.joinList == null) {
                continue;
            }

            ((QueryBuilder$JoinInfo)v0).queryBuilder.appendJoinSql(arg6);
        }
    }

    private void appendLimit(StringBuilder arg5) {
        if(this.limit != null && (this.databaseType.isLimitSqlSupported())) {
            this.databaseType.appendLimitValue(arg5, this.limit.longValue(), this.offset);
        }
    }

    private void appendOffset(StringBuilder arg4) {
        if(this.offset != null) {
            if(!this.databaseType.isOffsetLimitArgument()) {
                this.databaseType.appendOffsetValue(arg4, this.offset.longValue());
            }
            else if(this.limit == null) {
                throw new SQLException("If the offset is specified, limit must also be specified with this database");
            }
        }
    }

    private void appendOrderBys(StringBuilder arg5, List arg6) {
        boolean v1;
        if(this.hasOrderStuff()) {
            this.appendOrderBys(arg5, true, arg6);
            v1 = false;
        }
        else {
            v1 = true;
        }

        if(this.joinList != null) {
            Iterator v2 = this.joinList.iterator();
            while(v2.hasNext()) {
                Object v0 = v2.next();
                if(((QueryBuilder$JoinInfo)v0).queryBuilder == null) {
                    continue;
                }

                if(!((QueryBuilder$JoinInfo)v0).queryBuilder.hasOrderStuff()) {
                    continue;
                }

                ((QueryBuilder$JoinInfo)v0).queryBuilder.appendOrderBys(arg5, v1, arg6);
            }
        }
    }

    private void appendOrderBys(StringBuilder arg7, boolean arg8, List arg9) {
        char v5 = ',';
        if(arg8) {
            arg7.append("ORDER BY ");
        }

        if(this.orderByRaw != null) {
            if(!arg8) {
                arg7.append(v5);
            }

            arg7.append(this.orderByRaw);
            if(this.orderByArgs != null) {
                ArgumentHolder[] v2 = this.orderByArgs;
                int v3 = v2.length;
                int v0;
                for(v0 = 0; v0 < v3; ++v0) {
                    arg9.add(v2[v0]);
                }
            }

            arg8 = false;
        }

        if(this.orderByList != null) {
            Iterator v2_1 = this.orderByList.iterator();
            while(v2_1.hasNext()) {
                Object v0_1 = v2_1.next();
                if(arg8) {
                    arg8 = false;
                }
                else {
                    arg7.append(v5);
                }

                this.appendColumnName(arg7, ((OrderBy)v0_1).getColumnName());
                if(((OrderBy)v0_1).isAscending()) {
                    continue;
                }

                arg7.append(" DESC");
            }
        }

        arg7.append(' ');
    }

    private void appendSelectRaw(StringBuilder arg5) {
        Iterator v2 = this.selectRawList.iterator();
        int v1 = 1;
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if(v1 != 0) {
                v1 = 0;
            }
            else {
                arg5.append(", ");
            }

            arg5.append(((String)v0));
        }

        arg5.append(' ');
    }

    protected void appendStatementEnd(StringBuilder arg2, List arg3) {
        this.appendGroupBys(arg2);
        this.appendHaving(arg2);
        this.appendOrderBys(arg2, arg3);
        if(!this.databaseType.isLimitAfterSelect()) {
            this.appendLimit(arg2);
        }

        this.appendOffset(arg2);
        this.setAddTableName(false);
    }

    protected void appendStatementStart(StringBuilder arg3, List arg4) {
        if(this.joinList == null) {
            this.setAddTableName(false);
        }
        else {
            this.setAddTableName(true);
        }

        arg3.append("SELECT ");
        if(this.databaseType.isLimitAfterSelect()) {
            this.appendLimit(arg3);
        }

        if(this.distinct) {
            arg3.append("DISTINCT ");
        }

        if(this.isCountOfQuery) {
            this.type = StatementBuilder$StatementType.SELECT_LONG;
            arg3.append("COUNT(*) ");
        }
        else {
            if(this.selectRawList != null && !this.selectRawList.isEmpty()) {
                this.type = StatementBuilder$StatementType.SELECT_RAW;
                this.appendSelectRaw(arg3);
                goto label_20;
            }

            this.type = StatementBuilder$StatementType.SELECT;
            this.appendColumns(arg3);
        }

    label_20:
        arg3.append("FROM ");
        this.databaseType.appendEscapedEntityName(arg3, this.tableName);
        arg3.append(' ');
        if(this.joinList != null) {
            this.appendJoinSql(arg3);
        }
    }

    protected boolean appendWhereStatement(StringBuilder arg4, List arg5, StatementBuilder$WhereOperation arg6) {
        boolean v0 = arg6 == StatementBuilder$WhereOperation.FIRST ? true : false;
        if(this.where != null) {
            v0 = super.appendWhereStatement(arg4, arg5, arg6);
        }

        if(this.joinList != null) {
            Iterator v2 = this.joinList.iterator();
            boolean v1;
            for(v1 = v0; v2.hasNext(); v1 = ((QueryBuilder$JoinInfo)v0_1).queryBuilder.appendWhereStatement(arg4, arg5, v1_1)) {
                Object v0_1 = v2.next();
                StatementBuilder$WhereOperation v1_1 = v1 ? StatementBuilder$WhereOperation.FIRST : ((QueryBuilder$JoinInfo)v0_1).operation;
            }
        }
        else {
            v1 = v0;
        }

        return v1;
    }

    @Deprecated public void clear() {
        this.reset();
    }

    public long countOf() {
        this.setCountOf(true);
        return this.dao.countOf(this.prepare());
    }

    public QueryBuilder distinct() {
        this.distinct = true;
        this.selectIdColumn = false;
        return this;
    }

    void enableInnerQuery() {
        this.isInnerQuery = true;
    }

    protected FieldType[] getResultFieldTypes() {
        return this.resultFieldTypes;
    }

    int getSelectColumnCount() {
        int v0;
        if(this.isCountOfQuery) {
            v0 = 1;
        }
        else {
            if(this.selectRawList != null && !this.selectRawList.isEmpty()) {
                return this.selectRawList.size();
            }

            if(this.selectColumnList == null) {
                return 0;
            }

            v0 = this.selectColumnList.size();
        }

        return v0;
    }

    List getSelectColumns() {
        List v0;
        if(this.isCountOfQuery) {
            v0 = Collections.singletonList("COUNT(*)");
        }
        else {
            if(this.selectRawList != null && !this.selectRawList.isEmpty()) {
                return this.selectRawList;
            }

            if(this.selectColumnList == null) {
                return Collections.emptyList();
            }

            v0 = this.selectColumnList;
        }

        return v0;
    }

    public QueryBuilder groupBy(String arg4) {
        if(this.verifyColumnName(arg4).isForeignCollection()) {
            throw new IllegalArgumentException("Can\'t groupBy foreign colletion field: " + arg4);
        }

        if(this.groupByList == null) {
            this.groupByList = new ArrayList();
        }

        this.groupByList.add(arg4);
        this.selectIdColumn = false;
        return this;
    }

    public QueryBuilder groupByRaw(String arg1) {
        this.groupByRaw = arg1;
        return this;
    }

    private boolean hasGroupStuff() {
        boolean v0 = this.groupByList != null && !this.groupByList.isEmpty() || this.groupByRaw != null ? true : false;
        return v0;
    }

    private boolean hasOrderStuff() {
        boolean v0 = this.orderByList != null && !this.orderByList.isEmpty() || this.orderByRaw != null ? true : false;
        return v0;
    }

    public QueryBuilder having(String arg1) {
        this.having = arg1;
        return this;
    }

    public CloseableIterator iterator() {
        return this.dao.iterator(this.prepare());
    }

    public QueryBuilder join(QueryBuilder arg3) {
        this.addJoinInfo("INNER", arg3, StatementBuilder$WhereOperation.AND);
        return this;
    }

    public QueryBuilder joinOr(QueryBuilder arg3) {
        this.addJoinInfo("INNER", arg3, StatementBuilder$WhereOperation.OR);
        return this;
    }

    public QueryBuilder leftJoin(QueryBuilder arg3) {
        this.addJoinInfo("LEFT", arg3, StatementBuilder$WhereOperation.AND);
        return this;
    }

    public QueryBuilder leftJoinOr(QueryBuilder arg3) {
        this.addJoinInfo("LEFT", arg3, StatementBuilder$WhereOperation.OR);
        return this;
    }

    @Deprecated public QueryBuilder limit(int arg3) {
        return this.limit(Long.valueOf(((long)arg3)));
    }

    public QueryBuilder limit(Long arg1) {
        this.limit = arg1;
        return this;
    }

    private void matchJoinedFields(QueryBuilder$JoinInfo arg8, QueryBuilder arg9) {
        int v0 = 0;
        FieldType[] v2 = this.tableInfo.getFieldTypes();
        int v3 = v2.length;
        int v1;
        for(v1 = 0; v1 < v3; ++v1) {
            FieldType v4 = v2[v1];
            FieldType v5 = v4.getForeignIdField();
            if((v4.isForeign()) && (v5.equals(arg9.tableInfo.getIdField()))) {
                arg8.localField = v4;
                arg8.remoteField = v5;
                return;
            }
        }

        FieldType[] v1_1 = arg9.tableInfo.getFieldTypes();
        int v2_1 = v1_1.length;
        while(v0 < v2_1) {
            FieldType v3_1 = v1_1[v0];
            if((v3_1.isForeign()) && (v3_1.getForeignIdField().equals(this.idField))) {
                arg8.localField = this.idField;
                arg8.remoteField = v3_1;
                return;
            }

            ++v0;
        }

        throw new SQLException("Could not find a foreign " + this.tableInfo.getDataClass() + " field in " + arg9.tableInfo.getDataClass() + " or vice versa");
    }

    @Deprecated public QueryBuilder offset(int arg3) {
        return this.offset(Long.valueOf(((long)arg3)));
    }

    public QueryBuilder offset(Long arg3) {
        if(this.databaseType.isOffsetSqlSupported()) {
            this.offset = arg3;
            return this;
        }

        throw new SQLException("Offset is not supported by this database");
    }

    public QueryBuilder orderBy(String arg4, boolean arg5) {
        if(this.verifyColumnName(arg4).isForeignCollection()) {
            throw new IllegalArgumentException("Can\'t orderBy foreign colletion field: " + arg4);
        }

        if(this.orderByList == null) {
            this.orderByList = new ArrayList();
        }

        this.orderByList.add(new OrderBy(arg4, arg5));
        return this;
    }

    public QueryBuilder orderByRaw(String arg2) {
        return this.orderByRaw(arg2, null);
    }

    public QueryBuilder orderByRaw(String arg1, ArgumentHolder[] arg2) {
        this.orderByRaw = arg1;
        this.orderByArgs = arg2;
        return this;
    }

    public PreparedQuery prepare() {
        return super.prepareStatement(this.limit);
    }

    public List query() {
        return this.dao.query(this.prepare());
    }

    public Object queryForFirst() {
        return this.dao.queryForFirst(this.prepare());
    }

    public GenericRawResults queryRaw() {
        return this.dao.queryRaw(this.prepareStatementString(), new String[0]);
    }

    public String[] queryRawFirst() {
        return this.dao.queryRaw(this.prepareStatementString(), new String[0]).getFirstResult();
    }

    public void reset() {
        List v1 = null;
        super.reset();
        this.distinct = false;
        this.selectIdColumn = true;
        this.selectColumnList = v1;
        this.selectRawList = v1;
        this.orderByList = v1;
        this.orderByRaw = ((String)v1);
        this.groupByList = v1;
        this.groupByRaw = ((String)v1);
        this.isInnerQuery = false;
        this.isCountOfQuery = false;
        this.having = ((String)v1);
        this.limit = ((Long)v1);
        this.offset = ((Long)v1);
        if(this.joinList != null) {
            this.joinList.clear();
            this.joinList = v1;
        }

        this.addTableName = false;
    }

    public QueryBuilder selectColumns(Iterable arg3) {
        if(this.selectColumnList == null) {
            this.selectColumnList = new ArrayList();
        }

        Iterator v1 = arg3.iterator();
        while(v1.hasNext()) {
            this.addSelectColumnToList(v1.next());
        }

        return this;
    }

    public QueryBuilder selectColumns(String[] arg4) {
        if(this.selectColumnList == null) {
            this.selectColumnList = new ArrayList();
        }

        int v1 = arg4.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            this.addSelectColumnToList(arg4[v0]);
        }

        return this;
    }

    public QueryBuilder selectRaw(String[] arg5) {
        if(this.selectRawList == null) {
            this.selectRawList = new ArrayList();
        }

        int v1 = arg5.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            this.selectRawList.add(arg5[v0]);
        }

        return this;
    }

    private void setAddTableName(boolean arg3) {
        this.addTableName = arg3;
        if(this.joinList != null) {
            Iterator v1 = this.joinList.iterator();
            while(v1.hasNext()) {
                v1.next().queryBuilder.setAddTableName(arg3);
            }
        }
    }

    public QueryBuilder setCountOf(boolean arg1) {
        this.isCountOfQuery = arg1;
        return this;
    }

    protected boolean shouldPrependTableNameToColumns() {
        boolean v0 = this.joinList != null ? true : false;
        return v0;
    }
}

