// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt;

import com.j256.ormlite.dao.CloseableIterator;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.support.CompiledStatement;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseResults;
import java.sql.SQLException;

public class SelectIterator implements CloseableIterator {
    private boolean alreadyMoved;
    private final Dao classDao;
    private boolean closed;
    private final CompiledStatement compiledStmt;
    private final DatabaseConnection connection;
    private final ConnectionSource connectionSource;
    private final Class dataClass;
    private boolean first;
    private Object last;
    private static final Logger logger;
    private final DatabaseResults results;
    private int rowC;
    private final GenericRowMapper rowMapper;
    private final String statement;

    static {
        SelectIterator.logger = LoggerFactory.getLogger(SelectIterator.class);
    }

    public SelectIterator(Class arg4, Dao arg5, GenericRowMapper arg6, ConnectionSource arg7, DatabaseConnection arg8, CompiledStatement arg9, String arg10, ObjectCache arg11) {
        super();
        this.first = true;
        this.dataClass = arg4;
        this.classDao = arg5;
        this.rowMapper = arg6;
        this.connectionSource = arg7;
        this.connection = arg8;
        this.compiledStmt = arg9;
        this.results = arg9.runQuery(arg11);
        this.statement = arg10;
        if(arg10 != null) {
            SelectIterator.logger.debug("starting iterator @{} for \'{}\'", Integer.valueOf(this.hashCode()), arg10);
        }
    }

    public void close() {
        if(!this.closed) {
            this.compiledStmt.close();
            this.closed = true;
            this.last = null;
            if(this.statement != null) {
                SelectIterator.logger.debug("closed iterator @{} after {} rows", Integer.valueOf(this.hashCode()), Integer.valueOf(this.rowC));
            }

            this.connectionSource.releaseConnection(this.connection);
        }
    }

    public void closeQuietly() {
        try {
            this.close();
        }
        catch(SQLException v0) {
        }
    }

    public Object current() {
        Object v0;
        if(this.closed) {
            v0 = null;
        }
        else if(this.first) {
            v0 = this.first();
        }
        else {
            v0 = this.getCurrent();
        }

        return v0;
    }

    public Object first() {
        Object v0 = null;
        if(!this.closed) {
            this.first = false;
            if(this.results.first()) {
                v0 = this.getCurrent();
            }
        }

        return v0;
    }

    private Object getCurrent() {
        this.last = this.rowMapper.mapRow(this.results);
        this.alreadyMoved = false;
        ++this.rowC;
        return this.last;
    }

    public DatabaseResults getRawResults() {
        return this.results;
    }

    public boolean hasNext() {
        try {
            return this.hasNextThrow();
        }
        catch(SQLException v0) {
            this.last = null;
            this.closeQuietly();
            throw new IllegalStateException("Errors getting more results of " + this.dataClass, ((Throwable)v0));
        }
    }

    public boolean hasNextThrow() {
        boolean v0 = false;
        if(!this.closed) {
            if(this.alreadyMoved) {
                v0 = true;
            }
            else {
                if(this.first) {
                    this.first = false;
                    v0 = this.results.first();
                }
                else {
                    v0 = this.results.next();
                }

                if(!v0) {
                    this.close();
                }

                this.alreadyMoved = true;
            }
        }

        return v0;
    }

    public Object moveRelative(int arg3) {
        Object v0 = null;
        if(!this.closed) {
            this.first = false;
            if(this.results.moveRelative(arg3)) {
                v0 = this.getCurrent();
            }
        }

        return v0;
    }

    public void moveToNext() {
        this.last = null;
        this.first = false;
        this.alreadyMoved = false;
    }

    public Object next() {
        Object v0_1;
        Object v1 = null;
        try {
            v0_1 = this.nextThrow();
            if(v0_1 == null) {
                goto label_4;
            }
        }
        catch(SQLException v0) {
            goto label_5;
        }

        return v0_1;
    label_4:
        Throwable v0_2 = ((Throwable)v1);
    label_5:
        this.last = v1;
        this.closeQuietly();
        throw new IllegalStateException("Could not get next result for " + this.dataClass, v0_2);
    }

    public Object nextThrow() {
        boolean v1;
        Object v0 = null;
        if(!this.closed) {
            if(!this.alreadyMoved) {
                if(this.first) {
                    this.first = false;
                    v1 = this.results.first();
                }
                else {
                    v1 = this.results.next();
                }

                if(v1) {
                    goto label_18;
                }

                this.first = false;
                return v0;
            }

        label_18:
            this.first = false;
            v0 = this.getCurrent();
        }

        return v0;
    }

    public Object previous() {
        Object v0 = null;
        if(!this.closed) {
            this.first = false;
            if(this.results.previous()) {
                v0 = this.getCurrent();
            }
        }

        return v0;
    }

    public void remove() {
        try {
            this.removeThrow();
            return;
        }
        catch(SQLException v0) {
            this.closeQuietly();
            throw new IllegalStateException("Could not delete " + this.dataClass + " object " + this.last, ((Throwable)v0));
        }
    }

    public void removeThrow() {
        Object v2 = null;
        if(this.last == null) {
            throw new IllegalStateException("No last " + this.dataClass + " object to remove. Must be called after a call to next.");
        }

        if(this.classDao == null) {
            throw new IllegalStateException("Cannot remove " + this.dataClass + " object because classDao not initialized");
        }

        try {
            this.classDao.delete(this.last);
        }
        catch(Throwable v0) {
            this.last = v2;
            throw v0;
        }

        this.last = v2;
    }
}

