// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt;

import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.stmt.mapped.MappedPreparedStmt;
import com.j256.ormlite.table.TableInfo;
import java.util.ArrayList;
import java.util.List;

public abstract class StatementBuilder {
    protected boolean addTableName;
    protected final Dao dao;
    protected final DatabaseType databaseType;
    private static Logger logger;
    protected final TableInfo tableInfo;
    protected final String tableName;
    protected StatementBuilder$StatementType type;
    protected Where where;

    static {
        StatementBuilder.logger = LoggerFactory.getLogger(StatementBuilder.class);
    }

    public StatementBuilder(DatabaseType arg4, TableInfo arg5, Dao arg6, StatementBuilder$StatementType arg7) {
        super();
        this.where = null;
        this.databaseType = arg4;
        this.tableInfo = arg5;
        this.tableName = arg5.getTableName();
        this.dao = arg6;
        this.type = arg7;
        if(!arg7.isOkForStatementBuilder()) {
            throw new IllegalStateException("Building a statement from a " + arg7 + " statement is not allowed");
        }
    }

    protected abstract void appendStatementEnd(StringBuilder arg1, List arg2);

    protected abstract void appendStatementStart(StringBuilder arg1, List arg2);

    protected void appendStatementString(StringBuilder arg2, List arg3) {
        this.appendStatementStart(arg2, arg3);
        this.appendWhereStatement(arg2, arg3, StatementBuilder$WhereOperation.FIRST);
        this.appendStatementEnd(arg2, arg3);
    }

    protected boolean appendWhereStatement(StringBuilder arg4, List arg5, StatementBuilder$WhereOperation arg6) {
        boolean v0 = false;
        if(this.where != null) {
            arg6.appendBefore(arg4);
            Where v2 = this.where;
            String v1 = this.addTableName ? this.tableName : null;
            v2.appendSql(v1, arg4, arg5);
            arg6.appendAfter(arg4);
        }
        else if(arg6 == StatementBuilder$WhereOperation.FIRST) {
            v0 = true;
        }

        return v0;
    }

    protected String buildStatementString(List arg4) {
        StringBuilder v0 = new StringBuilder(128);
        this.appendStatementString(v0, arg4);
        String v0_1 = v0.toString();
        StatementBuilder.logger.debug("built statement {}", v0_1);
        return v0_1;
    }

    @Deprecated public void clear() {
        this.reset();
    }

    protected FieldType[] getResultFieldTypes() {
        return null;
    }

    StatementBuilder$StatementType getType() {
        return this.type;
    }

    protected MappedPreparedStmt prepareStatement(Long arg9) {
        ArrayList v0 = new ArrayList();
        String v2 = this.buildStatementString(((List)v0));
        Object[] v5 = ((List)v0).toArray(new ArgumentHolder[((List)v0).size()]);
        FieldType[] v4 = this.getResultFieldTypes();
        FieldType[] v3 = new FieldType[((List)v0).size()];
        int v0_1;
        for(v0_1 = 0; v0_1 < v5.length; ++v0_1) {
            v3[v0_1] = v5[v0_1].getFieldType();
        }

        if(!this.type.isOkForStatementBuilder()) {
            throw new IllegalStateException("Building a statement from a " + this.type + " statement is not allowed");
        }

        TableInfo v1 = this.tableInfo;
        Long v6 = this.databaseType.isLimitSqlSupported() ? null : arg9;
        return new MappedPreparedStmt(v1, v2, v3, v4, ((ArgumentHolder[])v5), v6, this.type);
    }

    public StatementBuilder$StatementInfo prepareStatementInfo() {
        ArrayList v0 = new ArrayList();
        return new StatementBuilder$StatementInfo(this.buildStatementString(((List)v0)), ((List)v0), null);
    }

    public String prepareStatementString() {
        return this.buildStatementString(new ArrayList());
    }

    public void reset() {
        this.where = null;
    }

    public void setWhere(Where arg1) {
        this.where = arg1;
    }

    protected boolean shouldPrependTableNameToColumns() {
        return 0;
    }

    protected FieldType verifyColumnName(String arg2) {
        return this.tableInfo.getFieldTypeByColumnName(arg2);
    }

    public Where where() {
        this.where = new Where(this.tableInfo, this, this.databaseType);
        return this.where;
    }
}

