// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt;

import com.j256.ormlite.dao.BaseDaoImpl;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.GenericRawResults;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.dao.RawRowMapper;
import com.j256.ormlite.dao.RawRowObjectMapper;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.DataType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.field.SqlType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.misc.TransactionManager;
import com.j256.ormlite.stmt.mapped.MappedCreate;
import com.j256.ormlite.stmt.mapped.MappedDelete;
import com.j256.ormlite.stmt.mapped.MappedDeleteCollection;
import com.j256.ormlite.stmt.mapped.MappedQueryForId;
import com.j256.ormlite.stmt.mapped.MappedRefresh;
import com.j256.ormlite.stmt.mapped.MappedUpdate;
import com.j256.ormlite.stmt.mapped.MappedUpdateId;
import com.j256.ormlite.support.CompiledStatement;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseResults;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.concurrent.Callable;

public class StatementExecutor implements GenericRowMapper {
    private String countStarQuery;
    private final Dao dao;
    private final DatabaseType databaseType;
    private FieldType[] ifExistsFieldTypes;
    private String ifExistsQuery;
    private static Logger logger;
    private MappedDelete mappedDelete;
    private MappedCreate mappedInsert;
    private MappedQueryForId mappedQueryForId;
    private MappedRefresh mappedRefresh;
    private MappedUpdate mappedUpdate;
    private MappedUpdateId mappedUpdateId;
    private static final FieldType[] noFieldTypes;
    private PreparedQuery preparedQueryForAll;
    private RawRowMapper rawRowMapper;
    private final TableInfo tableInfo;

    static {
        StatementExecutor.logger = LoggerFactory.getLogger(StatementExecutor.class);
        StatementExecutor.noFieldTypes = new FieldType[0];
    }

    public StatementExecutor(DatabaseType arg1, TableInfo arg2, Dao arg3) {
        super();
        this.databaseType = arg1;
        this.tableInfo = arg2;
        this.dao = arg3;
    }

    private void assignStatementArguments(CompiledStatement arg4, String[] arg5) {
        int v0;
        for(v0 = 0; v0 < arg5.length; ++v0) {
            arg4.setObject(v0, arg5[v0], SqlType.STRING);
        }
    }

    public SelectIterator buildIterator(BaseDaoImpl arg7, ConnectionSource arg8, int arg9, ObjectCache arg10) {
        this.prepareQueryForAll();
        return this.buildIterator(arg7, arg8, this.preparedQueryForAll, arg10, arg9);
    }

    public SelectIterator buildIterator(BaseDaoImpl arg11, ConnectionSource arg12, PreparedStmt arg13, ObjectCache arg14, int arg15) {
        SelectIterator v0_1;
        CompiledStatement v6;
        CompiledStatement v9 = null;
        DatabaseConnection v5 = arg12.getReadOnlyConnection();
        try {
            v6 = arg13.compile(v5, StatementBuilder$StatementType.SELECT, arg15);
        }
        catch(Throwable v0) {
            v6 = v9;
            goto label_20;
        }

        try {
            v0_1 = new SelectIterator(this.tableInfo.getDataClass(), arg11, arg13, arg12, v5, v6, arg13.getStatement(), arg14);
            if(0 == 0) {
                goto label_15;
            }

            goto label_14;
        }
        catch(Throwable v0) {
        }

    label_20:
        if(v6 != null) {
            v6.close();
        }

        if(v5 != null) {
            arg12.releaseConnection(v5);
        }

        throw v0;
    label_14:
        v9.close();
    label_15:
        if(0 != 0) {
            arg12.releaseConnection(((DatabaseConnection)v9));
        }

        return v0_1;
    }

    public Object callBatchTasks(DatabaseConnection arg6, boolean arg7, Callable arg8) {
        Object v0;
        boolean v1 = false;
        if(this.databaseType.isBatchUseTransaction()) {
            v0 = TransactionManager.callInTransaction(arg6, arg7, this.databaseType, arg8);
        }
        else {
            try {
                if(arg6.isAutoCommitSupported()) {
                    v1 = arg6.isAutoCommit();
                    if(v1) {
                        arg6.setAutoCommit(false);
                        StatementExecutor.logger.debug("disabled auto-commit on table {} before batch tasks", this.tableInfo.getTableName());
                    }
                }

                try {
                    v0 = arg8.call();
                    if(!v1) {
                        return v0;
                    }
                }
                catch(Exception v0_2) {
                    try {
                        throw SqlExceptionUtil.create("Batch tasks callable threw non-SQL exception", ((Throwable)v0_2));
                    }
                    catch(Throwable v0_1) {
                    label_31:
                        if(v1) {
                            arg6.setAutoCommit(true);
                            StatementExecutor.logger.debug("re-enabled auto-commit on table {} after batch tasks", this.tableInfo.getTableName());
                        }

                        throw v0_1;
                    }
                }
                catch(SQLException v0_3) {
                    try {
                        throw v0_3;
                    }
                    catch(Throwable v0_1) {
                        goto label_31;
                    }
                }
            }
            catch(Throwable v0_1) {
                goto label_31;
            }

            arg6.setAutoCommit(true);
            StatementExecutor.logger.debug("re-enabled auto-commit on table {} after batch tasks", this.tableInfo.getTableName());
        }

        return v0;
    }

    public int create(DatabaseConnection arg3, Object arg4, ObjectCache arg5) {
        if(this.mappedInsert == null) {
            this.mappedInsert = MappedCreate.build(this.databaseType, this.tableInfo);
        }

        return this.mappedInsert.insert(this.databaseType, arg3, arg4, arg5);
    }

    public int delete(DatabaseConnection arg3, PreparedDelete arg4) {
        int v1_1;
        CompiledStatement v0 = arg4.compile(arg3, StatementBuilder$StatementType.DELETE);
        try {
            v1_1 = v0.runUpdate();
        }
        catch(Throwable v1) {
            v0.close();
            throw v1;
        }

        v0.close();
        return v1_1;
    }

    public int delete(DatabaseConnection arg3, Object arg4, ObjectCache arg5) {
        if(this.mappedDelete == null) {
            this.mappedDelete = MappedDelete.build(this.databaseType, this.tableInfo);
        }

        return this.mappedDelete.delete(arg3, arg4, arg5);
    }

    public int deleteById(DatabaseConnection arg3, Object arg4, ObjectCache arg5) {
        if(this.mappedDelete == null) {
            this.mappedDelete = MappedDelete.build(this.databaseType, this.tableInfo);
        }

        return this.mappedDelete.deleteById(arg3, arg4, arg5);
    }

    public int deleteIds(DatabaseConnection arg3, Collection arg4, ObjectCache arg5) {
        return MappedDeleteCollection.deleteIds(this.databaseType, this.tableInfo, arg3, arg4, arg5);
    }

    public int deleteObjects(DatabaseConnection arg3, Collection arg4, ObjectCache arg5) {
        return MappedDeleteCollection.deleteObjects(this.databaseType, this.tableInfo, arg3, arg4, arg5);
    }

    public int executeRaw(DatabaseConnection arg4, String arg5, String[] arg6) {
        int v0_1;
        StatementExecutor.logger.debug("running raw execute statement: {}", arg5);
        if(arg6.length > 0) {
            StatementExecutor.logger.trace("execute arguments: {}", arg6);
        }

        CompiledStatement v1 = arg4.compileStatement(arg5, StatementBuilder$StatementType.EXECUTE, StatementExecutor.noFieldTypes, -1);
        try {
            this.assignStatementArguments(v1, arg6);
            v0_1 = v1.runExecute();
        }
        catch(Throwable v0) {
            v1.close();
            throw v0;
        }

        v1.close();
        return v0_1;
    }

    public int executeRawNoArgs(DatabaseConnection arg3, String arg4) {
        StatementExecutor.logger.debug("running raw execute statement: {}", arg4);
        return arg3.executeStatement(arg4, -1);
    }

    public RawRowMapper getRawRowMapper() {
        if(this.rawRowMapper == null) {
            this.rawRowMapper = new RawRowMapperImpl(this.tableInfo);
        }

        return this.rawRowMapper;
    }

    public GenericRowMapper getSelectStarRowMapper() {
        this.prepareQueryForAll();
        return this.preparedQueryForAll;
    }

    public boolean ifExists(DatabaseConnection arg9, Object arg10) {
        boolean v0 = true;
        if(this.ifExistsQuery == null) {
            QueryBuilder v2 = new QueryBuilder(this.databaseType, this.tableInfo, this.dao);
            v2.selectRaw(new String[]{"COUNT(*)"});
            v2.where().eq(this.tableInfo.getIdField().getColumnName(), new SelectArg());
            this.ifExistsQuery = v2.prepareStatementString();
            this.ifExistsFieldTypes = new FieldType[]{this.tableInfo.getIdField()};
        }

        long v2_1 = arg9.queryForLong(this.ifExistsQuery, new Object[]{arg10}, this.ifExistsFieldTypes);
        StatementExecutor.logger.debug("query of \'{}\' returned {}", this.ifExistsQuery, Long.valueOf(v2_1));
        if(v2_1 == 0) {
            v0 = false;
        }

        return v0;
    }

    public Object mapRow(DatabaseResults arg2) {
        return this.mapRow(arg2);
    }

    public String[] mapRow(DatabaseResults arg5) {
        int v1 = arg5.getColumnCount();
        String[] v2 = new String[v1];
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            v2[v0] = arg5.getString(v0);
        }

        return v2;
    }

    private void prepareQueryForAll() {
        if(this.preparedQueryForAll == null) {
            this.preparedQueryForAll = new QueryBuilder(this.databaseType, this.tableInfo, this.dao).prepare();
        }
    }

    public List query(ConnectionSource arg7, PreparedStmt arg8, ObjectCache arg9) {
        ArrayList v0_1;
        SelectIterator v1 = this.buildIterator(null, arg7, arg8, arg9, -1);
        try {
            v0_1 = new ArrayList();
            while(v1.hasNextThrow()) {
                ((List)v0_1).add(v1.nextThrow());
            }

            StatementExecutor.logger.debug("query of \'{}\' returned {} results", arg8.getStatement(), Integer.valueOf(((List)v0_1).size()));
        }
        catch(Throwable v0) {
            goto label_15;
        }

        v1.close();
        return ((List)v0_1);
    label_15:
        v1.close();
        throw v0;
    }

    public List queryForAll(ConnectionSource arg2, ObjectCache arg3) {
        this.prepareQueryForAll();
        return this.query(arg2, this.preparedQueryForAll, arg3);
    }

    public long queryForCountStar(DatabaseConnection arg7) {
        if(this.countStarQuery == null) {
            StringBuilder v0 = new StringBuilder(64);
            v0.append("SELECT COUNT(*) FROM ");
            this.databaseType.appendEscapedEntityName(v0, this.tableInfo.getTableName());
            this.countStarQuery = v0.toString();
        }

        long v0_1 = arg7.queryForLong(this.countStarQuery);
        StatementExecutor.logger.debug("query of \'{}\' returned {}", this.countStarQuery, Long.valueOf(v0_1));
        return v0_1;
    }

    public Object queryForFirst(DatabaseConnection arg8, PreparedStmt arg9, ObjectCache arg10) {
        Throwable v0_1;
        DatabaseResults v1_1;
        Object v0 = null;
        CompiledStatement v2 = arg9.compile(arg8, StatementBuilder$StatementType.SELECT);
        try {
            v1_1 = v2.runQuery(arg10);
        }
        catch(Throwable v1) {
            Throwable v6 = v1;
            v1_1 = ((DatabaseResults)v0);
            v0_1 = v6;
            goto label_27;
        }

        try {
            if(v1_1.first()) {
                StatementExecutor.logger.debug("query-for-first of \'{}\' returned at least 1 result", arg9.getStatement());
                v0 = arg9.mapRow(v1_1);
                if(v1_1 != null) {
                    goto label_12;
                }

                goto label_13;
            }
            else {
                goto label_15;
            }
        }
        catch(Throwable v0_1) {
            goto label_32;
        }

    label_12:
        v1_1.close();
    label_13:
        v2.close();
        return v0;
        try {
        label_15:
            StatementExecutor.logger.debug("query-for-first of \'{}\' returned at 0 results", arg9.getStatement());
            if(v1_1 == null) {
                goto label_21;
            }

            goto label_20;
        }
        catch(Throwable v0_1) {
        label_32:
        }

    label_27:
        if(v1_1 != null) {
            v1_1.close();
        }

        v2.close();
        throw v0_1;
    label_20:
        v1_1.close();
    label_21:
        v2.close();
        return v0;
    }

    public Object queryForId(DatabaseConnection arg4, Object arg5, ObjectCache arg6) {
        if(this.mappedQueryForId == null) {
            this.mappedQueryForId = MappedQueryForId.build(this.databaseType, this.tableInfo, null);
        }

        return this.mappedQueryForId.execute(arg4, arg5, arg6);
    }

    public long queryForLong(DatabaseConnection arg6, PreparedStmt arg7) {
        long v3;
        DatabaseResults v1;
        CompiledStatement v2 = arg7.compile(arg6, StatementBuilder$StatementType.SELECT_LONG);
        ObjectCache v0 = null;
        try {
            v1 = v2.runQuery(v0);
            if(!v1.first()) {
                goto label_13;
            }

            v3 = v1.getLong(0);
            if(v1 != null) {
                goto label_10;
            }

            goto label_11;
        }
        catch(Throwable v0_1) {
            goto label_24;
        }

    label_10:
        v1.close();
    label_11:
        v2.close();
        return v3;
        try {
        label_13:
            throw new SQLException("No result found in queryForLong: " + arg7.getStatement());
        }
        catch(Throwable v0_1) {
        label_24:
            if(v1 != null) {
                v1.close();
            }

            v2.close();
            throw v0_1;
        }
    }

    public long queryForLong(DatabaseConnection arg6, String arg7, String[] arg8) {
        long v3;
        CompiledStatement v2;
        DatabaseResults v1 = null;
        StatementExecutor.logger.debug("executing raw query for long: {}", arg7);
        if(arg8.length > 0) {
            StatementExecutor.logger.trace("query arguments: {}", arg8);
        }

        try {
            v2 = arg6.compileStatement(arg7, StatementBuilder$StatementType.SELECT, StatementExecutor.noFieldTypes, -1);
        }
        catch(Throwable v0) {
            v2 = ((CompiledStatement)v1);
            goto label_35;
        }

        try {
            this.assignStatementArguments(v2, arg8);
            v1 = v2.runQuery(null);
            if(!v1.first()) {
                goto label_25;
            }

            v3 = v1.getLong(0);
            if(v1 != null) {
                goto label_21;
            }

            goto label_22;
        }
        catch(Throwable v0) {
            goto label_35;
        }

    label_21:
        v1.close();
    label_22:
        if(v2 != null) {
            v2.close();
        }

        return v3;
        try {
        label_25:
            throw new SQLException("No result found in queryForLong: " + arg7);
        }
        catch(Throwable v0) {
        }

    label_35:
        if(v1 != null) {
            v1.close();
        }

        if(v2 != null) {
            v2.close();
        }

        throw v0;
    }

    public GenericRawResults queryRaw(ConnectionSource arg10, String arg11, RawRowMapper arg12, String[] arg13, ObjectCache arg14) {
        RawResultsImpl v0_1;
        CompiledStatement v5;
        CompiledStatement v8 = null;
        StatementExecutor.logger.debug("executing raw query for: {}", arg11);
        if(arg13.length > 0) {
            StatementExecutor.logger.trace("query arguments: {}", arg13);
        }

        DatabaseConnection v2 = arg10.getReadOnlyConnection();
        try {
            v5 = v2.compileStatement(arg11, StatementBuilder$StatementType.SELECT, StatementExecutor.noFieldTypes, -1);
        }
        catch(Throwable v0) {
            v5 = v8;
            goto label_30;
        }

        try {
            this.assignStatementArguments(v5, arg13);
            v0_1 = new RawResultsImpl(arg10, v2, arg11, String[].class, v5, new StatementExecutor$UserRawRowMapper(arg12, ((GenericRowMapper)this)), arg14);
            if(0 == 0) {
                goto label_25;
            }

            goto label_24;
        }
        catch(Throwable v0) {
        }

    label_30:
        if(v5 != null) {
            v5.close();
        }

        if(v2 != null) {
            arg10.releaseConnection(v2);
        }

        throw v0;
    label_24:
        v8.close();
    label_25:
        if(0 != 0) {
            arg10.releaseConnection(((DatabaseConnection)v8));
        }

        return ((GenericRawResults)v0_1);
    }

    public GenericRawResults queryRaw(ConnectionSource arg10, String arg11, DataType[] arg12, RawRowObjectMapper arg13, String[] arg14, ObjectCache arg15) {
        RawResultsImpl v0_1;
        CompiledStatement v5;
        CompiledStatement v8 = null;
        StatementExecutor.logger.debug("executing raw query for: {}", arg11);
        if(arg14.length > 0) {
            StatementExecutor.logger.trace("query arguments: {}", arg14);
        }

        DatabaseConnection v2 = arg10.getReadOnlyConnection();
        try {
            v5 = v2.compileStatement(arg11, StatementBuilder$StatementType.SELECT, StatementExecutor.noFieldTypes, -1);
        }
        catch(Throwable v0) {
            v5 = v8;
            goto label_30;
        }

        try {
            this.assignStatementArguments(v5, arg14);
            v0_1 = new RawResultsImpl(arg10, v2, arg11, String[].class, v5, new StatementExecutor$UserRawRowObjectMapper(arg13, arg12), arg15);
            if(0 == 0) {
                goto label_25;
            }

            goto label_24;
        }
        catch(Throwable v0) {
        }

    label_30:
        if(v5 != null) {
            v5.close();
        }

        if(v2 != null) {
            arg10.releaseConnection(v2);
        }

        throw v0;
    label_24:
        v8.close();
    label_25:
        if(0 != 0) {
            arg10.releaseConnection(((DatabaseConnection)v8));
        }

        return ((GenericRawResults)v0_1);
    }

    public GenericRawResults queryRaw(ConnectionSource arg10, String arg11, DataType[] arg12, String[] arg13, ObjectCache arg14) {
        RawResultsImpl v0_1;
        CompiledStatement v5;
        CompiledStatement v8 = null;
        StatementExecutor.logger.debug("executing raw query for: {}", arg11);
        if(arg13.length > 0) {
            StatementExecutor.logger.trace("query arguments: {}", arg13);
        }

        DatabaseConnection v2 = arg10.getReadOnlyConnection();
        try {
            v5 = v2.compileStatement(arg11, StatementBuilder$StatementType.SELECT, StatementExecutor.noFieldTypes, -1);
        }
        catch(Throwable v0) {
            v5 = v8;
            goto label_30;
        }

        try {
            this.assignStatementArguments(v5, arg13);
            v0_1 = new RawResultsImpl(arg10, v2, arg11, Object[].class, v5, new StatementExecutor$ObjectArrayRowMapper(arg12), arg14);
            if(0 == 0) {
                goto label_25;
            }

            goto label_24;
        }
        catch(Throwable v0) {
        }

    label_30:
        if(v5 != null) {
            v5.close();
        }

        if(v2 != null) {
            arg10.releaseConnection(v2);
        }

        throw v0;
    label_24:
        v8.close();
    label_25:
        if(0 != 0) {
            arg10.releaseConnection(((DatabaseConnection)v8));
        }

        return ((GenericRawResults)v0_1);
    }

    public GenericRawResults queryRaw(ConnectionSource arg10, String arg11, String[] arg12, ObjectCache arg13) {
        RawResultsImpl v0_1;
        CompiledStatement v5;
        CompiledStatement v8 = null;
        StatementExecutor.logger.debug("executing raw query for: {}", arg11);
        if(arg12.length > 0) {
            StatementExecutor.logger.trace("query arguments: {}", arg12);
        }

        DatabaseConnection v2 = arg10.getReadOnlyConnection();
        try {
            v5 = v2.compileStatement(arg11, StatementBuilder$StatementType.SELECT, StatementExecutor.noFieldTypes, -1);
        }
        catch(Throwable v0) {
            v5 = v8;
            goto label_29;
        }

        try {
            this.assignStatementArguments(v5, arg12);
            v0_1 = new RawResultsImpl(arg10, v2, arg11, String[].class, v5, this, arg13);
            if(0 == 0) {
                goto label_24;
            }

            goto label_23;
        }
        catch(Throwable v0) {
        }

    label_29:
        if(v5 != null) {
            v5.close();
        }

        if(v2 != null) {
            arg10.releaseConnection(v2);
        }

        throw v0;
    label_23:
        v8.close();
    label_24:
        if(0 != 0) {
            arg10.releaseConnection(((DatabaseConnection)v8));
        }

        return ((GenericRawResults)v0_1);
    }

    public int refresh(DatabaseConnection arg3, Object arg4, ObjectCache arg5) {
        if(this.mappedRefresh == null) {
            this.mappedRefresh = MappedRefresh.build(this.databaseType, this.tableInfo);
        }

        return this.mappedRefresh.executeRefresh(arg3, arg4, arg5);
    }

    public int update(DatabaseConnection arg3, PreparedUpdate arg4) {
        int v1_1;
        CompiledStatement v0 = arg4.compile(arg3, StatementBuilder$StatementType.UPDATE);
        try {
            v1_1 = v0.runUpdate();
        }
        catch(Throwable v1) {
            v0.close();
            throw v1;
        }

        v0.close();
        return v1_1;
    }

    public int update(DatabaseConnection arg3, Object arg4, ObjectCache arg5) {
        if(this.mappedUpdate == null) {
            this.mappedUpdate = MappedUpdate.build(this.databaseType, this.tableInfo);
        }

        return this.mappedUpdate.update(arg3, arg4, arg5);
    }

    public int updateId(DatabaseConnection arg3, Object arg4, Object arg5, ObjectCache arg6) {
        if(this.mappedUpdateId == null) {
            this.mappedUpdateId = MappedUpdateId.build(this.databaseType, this.tableInfo);
        }

        return this.mappedUpdateId.execute(arg3, arg4, arg5, arg6);
    }

    public int updateRaw(DatabaseConnection arg4, String arg5, String[] arg6) {
        int v0_1;
        StatementExecutor.logger.debug("running raw update statement: {}", arg5);
        if(arg6.length > 0) {
            StatementExecutor.logger.trace("update arguments: {}", arg6);
        }

        CompiledStatement v1 = arg4.compileStatement(arg5, StatementBuilder$StatementType.UPDATE, StatementExecutor.noFieldTypes, -1);
        try {
            this.assignStatementArguments(v1, arg6);
            v0_1 = v1.runUpdate();
        }
        catch(Throwable v0) {
            v1.close();
            throw v0;
        }

        v1.close();
        return v0_1;
    }
}

