// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt;

import com.j256.ormlite.dao.CloseableIterator;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.GenericRawResults;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.stmt.query.Between;
import com.j256.ormlite.stmt.query.Clause;
import com.j256.ormlite.stmt.query.Exists;
import com.j256.ormlite.stmt.query.In;
import com.j256.ormlite.stmt.query.InSubQuery;
import com.j256.ormlite.stmt.query.IsNotNull;
import com.j256.ormlite.stmt.query.IsNull;
import com.j256.ormlite.stmt.query.ManyClause;
import com.j256.ormlite.stmt.query.NeedsFutureClause;
import com.j256.ormlite.stmt.query.Not;
import com.j256.ormlite.stmt.query.Raw;
import com.j256.ormlite.stmt.query.SimpleComparison;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Where {
    private static final int CLAUSE_STACK_START_SIZE = 4;
    private Clause[] clauseStack;
    private int clauseStackLevel;
    private final DatabaseType databaseType;
    private final String idColumnName;
    private final FieldType idFieldType;
    private NeedsFutureClause needsFuture;
    private final StatementBuilder statementBuilder;
    private final TableInfo tableInfo;

    Where(TableInfo arg3, StatementBuilder arg4, DatabaseType arg5) {
        NeedsFutureClause v1 = null;
        super();
        this.clauseStack = new Clause[4];
        this.needsFuture = v1;
        this.tableInfo = arg3;
        this.statementBuilder = arg4;
        this.idFieldType = arg3.getIdField();
        this.idColumnName = this.idFieldType == null ? ((String)v1) : this.idFieldType.getColumnName();
        this.databaseType = arg5;
    }

    private void addClause(Clause arg2) {
        if(this.needsFuture == null) {
            this.push(arg2);
        }
        else {
            this.needsFuture.setMissingClause(arg2);
            this.needsFuture = null;
        }
    }

    private void addNeedsFuture(NeedsFutureClause arg4) {
        if(this.needsFuture != null) {
            throw new IllegalStateException(this.needsFuture + " is already waiting for a future clause, can\'t add: " + arg4);
        }

        this.needsFuture = arg4;
    }

    public Where and(int arg4) {
        if(arg4 == 0) {
            throw new IllegalArgumentException("Must have at least one clause in and(numClauses)");
        }

        Clause[] v1 = new Clause[arg4];
        int v0;
        for(v0 = arg4 - 1; v0 >= 0; --v0) {
            v1[v0] = this.pop("AND");
        }

        this.addClause(new ManyClause(v1, "AND"));
        return this;
    }

    public Where and() {
        ManyClause v0 = new ManyClause(this.pop("AND"), "AND");
        this.push(((Clause)v0));
        this.addNeedsFuture(((NeedsFutureClause)v0));
        return this;
    }

    public Where and(Where arg6, Where arg7, Where[] arg8) {
        this.addClause(new ManyClause(this.pop("AND"), this.pop("AND"), this.buildClauseArray(arg8, "AND"), "AND"));
        return this;
    }

    void appendSql(String arg3, StringBuilder arg4, List arg5) {
        if(this.clauseStackLevel == 0) {
            throw new IllegalStateException("No where clauses defined.  Did you miss a where operation?");
        }

        if(this.clauseStackLevel != 1) {
            throw new IllegalStateException("Both the \"left-hand\" and \"right-hand\" clauses have been defined.  Did you miss an AND or OR?");
        }

        if(this.needsFuture != null) {
            throw new IllegalStateException("The SQL statement has not been finished since there are previous operations still waiting for clauses.");
        }

        this.peek().appendSql(this.databaseType, arg3, arg4, arg5);
    }

    public Where between(String arg3, Object arg4, Object arg5) {
        this.addClause(new Between(arg3, this.findColumnFieldType(arg3), arg4, arg5));
        return this;
    }

    private Clause[] buildClauseArray(Where[] arg4, String arg5) {
        Clause[] v0;
        if(arg4.length == 0) {
            v0 = null;
        }
        else {
            v0 = new Clause[arg4.length];
            int v1;
            for(v1 = arg4.length - 1; v1 >= 0; --v1) {
                v0[v1] = this.pop(arg5);
            }
        }

        return v0;
    }

    private QueryBuilder checkQueryBuilderMethod(String arg4) {
        if((this.statementBuilder instanceof QueryBuilder)) {
            return this.statementBuilder;
        }

        throw new SQLException("Cannot call " + arg4 + " on a statement of type " + this.statementBuilder.getType());
    }

    @Deprecated public Where clear() {
        return this.reset();
    }

    public long countOf() {
        return this.checkQueryBuilderMethod("countOf()").countOf();
    }

    public Where eq(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, "="));
        return this;
    }

    public Where exists(QueryBuilder arg3) {
        arg3.enableInnerQuery();
        this.addClause(new Exists(new QueryBuilder$InternalQueryBuilderWrapper(arg3)));
        return this;
    }

    private FieldType findColumnFieldType(String arg2) {
        return this.tableInfo.getFieldTypeByColumnName(arg2);
    }

    public Where ge(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, ">="));
        return this;
    }

    public String getStatement() {
        StringBuilder v0 = new StringBuilder();
        this.appendSql(null, v0, new ArrayList());
        return v0.toString();
    }

    public Where gt(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, ">"));
        return this;
    }

    public Where idEq(Dao arg6, Object arg7) {
        if(this.idColumnName == null) {
            throw new SQLException("Object has no id column specified");
        }

        this.addClause(new SimpleComparison(this.idColumnName, this.idFieldType, arg6.extractId(arg7), "="));
        return this;
    }

    public Where idEq(Object arg5) {
        if(this.idColumnName == null) {
            throw new SQLException("Object has no id column specified");
        }

        this.addClause(new SimpleComparison(this.idColumnName, this.idFieldType, arg5, "="));
        return this;
    }

    private Where in(boolean arg5, String arg6, QueryBuilder arg7) {
        if(arg7.getSelectColumnCount() != 1) {
            if(arg7.getSelectColumnCount() == 0) {
                throw new SQLException("Inner query must have only 1 select column specified instead of *");
            }

            throw new SQLException("Inner query must have only 1 select column specified instead of " + arg7.getSelectColumnCount() + ": " + Arrays.toString(arg7.getSelectColumns().toArray(new String[0])));
        }

        arg7.enableInnerQuery();
        this.addClause(new InSubQuery(arg6, this.findColumnFieldType(arg6), new QueryBuilder$InternalQueryBuilderWrapper(arg7), arg5));
        return this;
    }

    private Where in(boolean arg4, String arg5, Object[] arg6) {
        String v0;
        StringBuilder v2;
        if(arg6.length == 1) {
            if(arg6[0].getClass().isArray()) {
                v2 = new StringBuilder().append("Object argument to ");
                v0 = arg4 ? "IN" : "notId";
                throw new IllegalArgumentException(v2.append(v0).append(" seems to be an array within an array").toString());
            }
            else {
                if((arg6[0] instanceof Where)) {
                    v2 = new StringBuilder().append("Object argument to ");
                    v0 = arg4 ? "IN" : "notId";
                    throw new IllegalArgumentException(v2.append(v0).append(" seems to be a Where object, did you mean the QueryBuilder?").toString());
                }

                if(!(arg6[0] instanceof PreparedStmt)) {
                    goto label_59;
                }

                v2 = new StringBuilder().append("Object argument to ");
                v0 = arg4 ? "IN" : "notId";
                throw new IllegalArgumentException(v2.append(v0).append(" seems to be a prepared statement, did you mean the QueryBuilder?").toString());
            }
        }

    label_59:
        this.addClause(new In(arg5, this.findColumnFieldType(arg5), arg6, arg4));
        return this;
    }

    public Where in(String arg2, QueryBuilder arg3) {
        return this.in(true, arg2, arg3);
    }

    public Where in(String arg4, Iterable arg5) {
        this.addClause(new In(arg4, this.findColumnFieldType(arg4), arg5, true));
        return this;
    }

    public Where in(String arg2, Object[] arg3) {
        return this.in(true, arg2, arg3);
    }

    public Where isNotNull(String arg3) {
        this.addClause(new IsNotNull(arg3, this.findColumnFieldType(arg3)));
        return this;
    }

    public Where isNull(String arg3) {
        this.addClause(new IsNull(arg3, this.findColumnFieldType(arg3)));
        return this;
    }

    public CloseableIterator iterator() {
        return this.checkQueryBuilderMethod("iterator()").iterator();
    }

    public Where le(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, "<="));
        return this;
    }

    public Where like(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, "LIKE"));
        return this;
    }

    public Where lt(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, "<"));
        return this;
    }

    public Where ne(String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg4, this.findColumnFieldType(arg4), arg5, "<>"));
        return this;
    }

    public Where not() {
        Not v0 = new Not();
        this.addClause(((Clause)v0));
        this.addNeedsFuture(((NeedsFutureClause)v0));
        return this;
    }

    public Where not(Where arg3) {
        this.addClause(new Not(this.pop("NOT")));
        return this;
    }

    public Where notIn(String arg2, QueryBuilder arg3) {
        return this.in(false, arg2, arg3);
    }

    public Where notIn(String arg4, Iterable arg5) {
        this.addClause(new In(arg4, this.findColumnFieldType(arg4), arg5, false));
        return this;
    }

    public Where notIn(String arg2, Object[] arg3) {
        return this.in(false, arg2, arg3);
    }

    public Where or() {
        ManyClause v0 = new ManyClause(this.pop("OR"), "OR");
        this.push(((Clause)v0));
        this.addNeedsFuture(((NeedsFutureClause)v0));
        return this;
    }

    public Where or(int arg4) {
        if(arg4 == 0) {
            throw new IllegalArgumentException("Must have at least one clause in or(numClauses)");
        }

        Clause[] v1 = new Clause[arg4];
        int v0;
        for(v0 = arg4 - 1; v0 >= 0; --v0) {
            v1[v0] = this.pop("OR");
        }

        this.addClause(new ManyClause(v1, "OR"));
        return this;
    }

    public Where or(Where arg6, Where arg7, Where[] arg8) {
        this.addClause(new ManyClause(this.pop("OR"), this.pop("OR"), this.buildClauseArray(arg8, "OR"), "OR"));
        return this;
    }

    private Clause peek() {
        return this.clauseStack[this.clauseStackLevel - 1];
    }

    private Clause pop(String arg5) {
        if(this.clauseStackLevel == 0) {
            throw new IllegalStateException("Expecting there to be a clause already defined for \'" + arg5 + "\' operation");
        }

        Clause[] v0 = this.clauseStack;
        int v1 = this.clauseStackLevel - 1;
        this.clauseStackLevel = v1;
        Clause v0_1 = v0[v1];
        this.clauseStack[this.clauseStackLevel] = null;
        return v0_1;
    }

    public PreparedQuery prepare() {
        return this.statementBuilder.prepareStatement(null);
    }

    private void push(Clause arg5) {
        if(this.clauseStackLevel == this.clauseStack.length) {
            Clause[] v1 = new Clause[this.clauseStackLevel * 2];
            int v0;
            for(v0 = 0; v0 < this.clauseStackLevel; ++v0) {
                v1[v0] = this.clauseStack[v0];
                this.clauseStack[v0] = null;
            }

            this.clauseStack = v1;
        }

        Clause[] v0_1 = this.clauseStack;
        int v1_1 = this.clauseStackLevel;
        this.clauseStackLevel = v1_1 + 1;
        v0_1[v1_1] = arg5;
    }

    public List query() {
        return this.checkQueryBuilderMethod("query()").query();
    }

    public Object queryForFirst() {
        return this.checkQueryBuilderMethod("queryForFirst()").queryForFirst();
    }

    public GenericRawResults queryRaw() {
        return this.checkQueryBuilderMethod("queryRaw()").queryRaw();
    }

    public String[] queryRawFirst() {
        return this.checkQueryBuilderMethod("queryRawFirst()").queryRawFirst();
    }

    public Where raw(String arg5, ArgumentHolder[] arg6) {
        int v1 = arg6.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            ArgumentHolder v2 = arg6[v0];
            String v3 = v2.getColumnName();
            if(v3 != null) {
                v2.setMetaInfo(this.findColumnFieldType(v3));
            }
            else if(v2.getSqlType() == null) {
                throw new IllegalArgumentException("Either the column name or SqlType must be set on each argument");
            }
        }

        this.addClause(new Raw(arg5, arg6));
        return this;
    }

    public Where rawComparison(String arg3, String arg4, Object arg5) {
        this.addClause(new SimpleComparison(arg3, this.findColumnFieldType(arg3), arg5, arg4));
        return this;
    }

    public Where reset() {
        int v0;
        for(v0 = 0; v0 < this.clauseStackLevel; ++v0) {
            this.clauseStack[v0] = null;
        }

        this.clauseStackLevel = 0;
        return this;
    }

    public String toString() {
        String v0 = this.clauseStackLevel == 0 ? "empty where clause" : "where clause: " + this.peek();
        return v0;
    }
}

