// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt.mapped;

import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.table.TableInfo;
import java.util.List;

public abstract class BaseMappedStatement {
    protected final FieldType[] argFieldTypes;
    protected final Class clazz;
    protected final FieldType idField;
    protected static Logger logger;
    protected final String statement;
    protected final TableInfo tableInfo;

    static {
        BaseMappedStatement.logger = LoggerFactory.getLogger(BaseMappedStatement.class);
    }

    protected BaseMappedStatement(TableInfo arg2, String arg3, FieldType[] arg4) {
        super();
        this.tableInfo = arg2;
        this.clazz = arg2.getDataClass();
        this.idField = arg2.getIdField();
        this.statement = arg3;
        this.argFieldTypes = arg4;
    }

    static void appendFieldColumnName(DatabaseType arg1, StringBuilder arg2, FieldType arg3, List arg4) {
        arg1.appendEscapedEntityName(arg2, arg3.getColumnName());
        if(arg4 != null) {
            arg4.add(arg3);
        }

        arg2.append(' ');
    }

    static void appendTableName(DatabaseType arg1, StringBuilder arg2, String arg3, String arg4) {
        if(arg3 != null) {
            arg2.append(arg3);
        }

        arg1.appendEscapedEntityName(arg2, arg4);
        arg2.append(' ');
    }

    static void appendWhereFieldEq(DatabaseType arg1, FieldType arg2, StringBuilder arg3, List arg4) {
        arg3.append("WHERE ");
        BaseMappedStatement.appendFieldColumnName(arg1, arg3, arg2, arg4);
        arg3.append("= ?");
    }

    protected Object convertIdToFieldObject(Object arg2) {
        return this.idField.convertJavaFieldToSqlArgValue(arg2);
    }

    protected Object[] getFieldObjects(Object arg5) {
        Object[] v1 = new Object[this.argFieldTypes.length];
        int v0;
        for(v0 = 0; v0 < this.argFieldTypes.length; ++v0) {
            FieldType v2 = this.argFieldTypes[v0];
            v1[v0] = v2.isAllowGeneratedIdInsert() ? v2.getFieldValueIfNotDefault(arg5) : v2.extractJavaFieldToSqlArgValue(arg5);
            if(v1[v0] == null && v2.getDefaultValue() != null) {
                v1[v0] = v2.getDefaultValue();
            }
        }

        return v1;
    }

    public String toString() {
        return "MappedStatement: " + this.statement;
    }
}

