// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt.mapped;

import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.logger.Log$Level;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.GeneratedKeyHolder;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;

public class MappedCreate extends BaseMappedStatement {
    private String dataClassName;
    private final String queryNextSequenceStmt;
    private int versionFieldTypeIndex;

    private MappedCreate(TableInfo arg2, String arg3, FieldType[] arg4, String arg5, int arg6) {
        super(arg2, arg3, arg4);
        this.dataClassName = arg2.getDataClass().getSimpleName();
        this.queryNextSequenceStmt = arg5;
        this.versionFieldTypeIndex = arg6;
    }

    private void assignIdValue(Object arg6, Number arg7, String arg8, ObjectCache arg9) {
        this.idField.assignIdValue(arg6, arg7, arg9);
        if(MappedCreate.logger.isLevelEnabled(Log$Level.DEBUG)) {
            MappedCreate.logger.debug("assigned id \'{}\' from {} to \'{}\' in {} object", new Object[]{arg7, arg8, this.idField.getFieldName(), this.dataClassName});
        }
    }

    private void assignSequenceId(DatabaseConnection arg7, Object arg8, ObjectCache arg9) {
        long v0 = arg7.queryForLong(this.queryNextSequenceStmt);
        MappedCreate.logger.debug("queried for sequence {} using stmt: {}", Long.valueOf(v0), this.queryNextSequenceStmt);
        if(v0 == 0) {
            throw new SQLException("Should not have returned 0 for stmt: " + this.queryNextSequenceStmt);
        }

        this.assignIdValue(arg8, Long.valueOf(v0), "sequence", arg9);
    }

    public static MappedCreate build(DatabaseType arg12, TableInfo arg13) {
        StringBuilder v8 = new StringBuilder(128);
        MappedCreate.appendTableName(arg12, v8, "INSERT INTO ", arg13.getTableName());
        int v5 = -1;
        FieldType[] v3 = arg13.getFieldTypes();
        int v4 = v3.length;
        int v2 = 0;
        int v0 = 0;
        while(v2 < v4) {
            FieldType v7 = v3[v2];
            if(MappedCreate.isFieldCreatable(arg12, v7)) {
                if(v7.isVersion()) {
                    v5 = v0;
                }

                ++v0;
            }

            ++v2;
        }

        v3 = new FieldType[v0];
        if(v0 == 0) {
            arg12.appendInsertNoColumns(v8);
        }
        else {
            v8.append('(');
            FieldType[] v9 = arg13.getFieldTypes();
            int v10 = v9.length;
            int v7_1 = 0;
            v0 = 1;
            v2 = 0;
            while(v7_1 < v10) {
                FieldType v11 = v9[v7_1];
                if(MappedCreate.isFieldCreatable(arg12, v11)) {
                    if(v0 != 0) {
                        v0 = 0;
                    }
                    else {
                        v8.append(",");
                    }

                    MappedCreate.appendFieldColumnName(arg12, v8, v11, null);
                    v3[v2] = v11;
                    ++v2;
                }

                ++v7_1;
            }

            v8.append(") VALUES (");
            FieldType[] v4_1 = arg13.getFieldTypes();
            v7_1 = v4_1.length;
            v2 = 0;
            v0 = 1;
            while(v2 < v7_1) {
                if(MappedCreate.isFieldCreatable(arg12, v4_1[v2])) {
                    if(v0 != 0) {
                        v0 = 0;
                    }
                    else {
                        v8.append(",");
                    }

                    v8.append("?");
                }

                ++v2;
            }

            v8.append(")");
        }

        return new MappedCreate(arg13, v8.toString(), v3, MappedCreate.buildQueryNextSequence(arg12, arg13.getIdField()), v5);
    }

    private static String buildQueryNextSequence(DatabaseType arg3, FieldType arg4) {
        String v0 = null;
        if(arg4 != null) {
            String v1 = arg4.getGeneratedIdSequence();
            if(v1 != null) {
                StringBuilder v0_1 = new StringBuilder(64);
                arg3.appendSelectNextValFromSequence(v0_1, v1);
                v0 = v0_1.toString();
            }
        }

        return v0;
    }

    private boolean foreignCollectionsAreAssigned(FieldType[] arg5, Object arg6) {
        boolean v0 = false;
        int v2 = arg5.length;
        int v1 = 0;
        while(true) {
            if(v1 >= v2) {
                return true;
            }
            else if(arg5[v1].extractJavaFieldValue(arg6) != null) {
                ++v1;
                continue;
            }

            return v0;
        }

        return true;
    }

    public int insert(DatabaseType arg10, DatabaseConnection arg11, Object arg12, ObjectCache arg13) {
        int v2_2;
        Object v0_3;
        Object[] v1_1;
        MappedCreate$KeyHolder v3_1;
        GeneratedKeyHolder v3;
        int v1 = 0;
        MappedCreate$1 v2 = null;
        if(this.idField != null) {
            int v0 = !this.idField.isAllowGeneratedIdInsert() || (this.idField.isObjectsFieldValueDefault(arg12)) ? 1 : 0;
            if((this.idField.isSelfGeneratedId()) && (this.idField.isGeneratedId())) {
                if(v0 != 0) {
                    this.idField.assignField(arg12, this.idField.generateId(), false, arg13);
                    v3 = ((GeneratedKeyHolder)v2);
                    goto label_23;
                }
                else {
                    goto label_152;
                }
            }

            if((this.idField.isGeneratedIdSequence()) && (arg10.isSelectSequenceBeforeInsert())) {
                if(v0 != 0) {
                    this.assignSequenceId(arg11, arg12, arg13);
                    v3 = ((GeneratedKeyHolder)v2);
                    goto label_23;
                }
                else {
                    goto label_152;
                }
            }

            if(!this.idField.isGeneratedId()) {
                goto label_152;
            }

            if(v0 == 0) {
                goto label_152;
            }

            v3_1 = new MappedCreate$KeyHolder(v2);
        }
        else {
        label_152:
            v3 = ((GeneratedKeyHolder)v2);
        }

        try {
        label_23:
            if(this.tableInfo.isForeignAutoCreate()) {
                FieldType[] v0_2 = this.tableInfo.getFieldTypes();
                int v4 = v0_2.length;
                while(true) {
                label_29:
                    if(v1 < v4) {
                        FieldType v5 = v0_2[v1];
                        if(v5.isForeignAutoCreate()) {
                            Object v6 = v5.extractRawJavaFieldValue(arg12);
                            if(v6 != null && (v5.getForeignIdField().isObjectsFieldValueDefault(v6))) {
                                v5.createWithForeignDao(v6);
                            }
                        }

                        goto label_33;
                    }

                    goto label_74;
                }
            }

            goto label_74;
        }
        catch(SQLException v0_1) {
            goto label_73;
        }

    label_33:
        ++v1;
        goto label_29;
        try {
        label_74:
            v1_1 = this.getFieldObjects(arg12);
            if(this.versionFieldTypeIndex < 0) {
                goto label_150;
            }
            else if(v1_1[this.versionFieldTypeIndex] == null) {
                FieldType v2_1 = this.argFieldTypes[this.versionFieldTypeIndex];
                v0_3 = v2_1.moveToNextValue(null);
                v1_1[this.versionFieldTypeIndex] = v2_1.convertJavaFieldToSqlArgValue(v0_3);
            }
            else {
                goto label_150;
            }

            goto label_88;
        }
        catch(SQLException v0_1) {
            goto label_73;
        }

    label_150:
        v0_3 = v2;
        try {
        label_88:
            v2_2 = arg11.insert(this.statement, v1_1, this.argFieldTypes, ((GeneratedKeyHolder)v3_1));
            goto label_91;
        }
        catch(SQLException v0_1) {
            try {
                MappedCreate.logger.debug("insert data with statement \'{}\' and {} args, threw exception: {}", this.statement, Integer.valueOf(v1_1.length), v0_1);
                if(v1_1.length > 0) {
                    MappedCreate.logger.trace("insert arguments: {}", v1_1);
                }

                throw v0_1;
            label_91:
                MappedCreate.logger.debug("insert data with statement \'{}\' and {} args, changed {} rows", this.statement, Integer.valueOf(v1_1.length), Integer.valueOf(v2_2));
                if(v1_1.length > 0) {
                    MappedCreate.logger.trace("insert arguments: {}", v1_1);
                }

                if(v2_2 > 0) {
                    if(v0_3 != null) {
                        this.argFieldTypes[this.versionFieldTypeIndex].assignField(arg12, v0_3, false, null);
                    }

                    if(v3_1 != null) {
                        Number v0_4 = v3_1.getKey();
                        if(v0_4 == null) {
                            throw new SQLException("generated-id key was not set by the update call");
                        }
                        else if(v0_4.longValue() == 0) {
                            throw new SQLException("generated-id key must not be 0 value");
                        }
                        else {
                            this.assignIdValue(arg12, v0_4, "keyholder", arg13);
                        }
                    }

                    if(arg13 == null) {
                        return v2_2;
                    }

                    if(!this.foreignCollectionsAreAssigned(this.tableInfo.getForeignCollections(), arg12)) {
                        return v2_2;
                    }

                    arg13.put(this.clazz, this.idField.extractJavaFieldValue(arg12), arg12);
                }
            }
            catch(SQLException v0_1) {
            label_73:
                throw SqlExceptionUtil.create("Unable to run insert stmt on object " + arg12 + ": " + this.statement, ((Throwable)v0_1));
            }
        }

        return v2_2;
    }

    private static boolean isFieldCreatable(DatabaseType arg3, FieldType arg4) {
        boolean v0 = false;
        if(!arg4.isForeignCollection() && !arg4.isReadOnly()) {
            if((arg3.isIdSequenceNeeded()) && (arg3.isSelectSequenceBeforeInsert())) {
                return true;
            }

            if((arg4.isGeneratedId()) && !arg4.isSelfGeneratedId() && !arg4.isAllowGeneratedIdInsert()) {
                return v0;
            }

            v0 = true;
        }

        return v0;
    }
}

