// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt.mapped;

import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.field.SqlType;
import com.j256.ormlite.logger.Log$Level;
import com.j256.ormlite.stmt.ArgumentHolder;
import com.j256.ormlite.stmt.PreparedDelete;
import com.j256.ormlite.stmt.PreparedQuery;
import com.j256.ormlite.stmt.PreparedUpdate;
import com.j256.ormlite.stmt.StatementBuilder$StatementType;
import com.j256.ormlite.support.CompiledStatement;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;

public class MappedPreparedStmt extends BaseMappedQuery implements PreparedDelete, PreparedQuery, PreparedUpdate {
    private final ArgumentHolder[] argHolders;
    private final Long limit;
    private final StatementBuilder$StatementType type;

    public MappedPreparedStmt(TableInfo arg1, String arg2, FieldType[] arg3, FieldType[] arg4, ArgumentHolder[] arg5, Long arg6, StatementBuilder$StatementType arg7) {
        super(arg1, arg2, arg3, arg4);
        this.argHolders = arg5;
        this.limit = arg6;
        this.type = arg7;
    }

    private CompiledStatement assignStatementArguments(CompiledStatement arg6) {
        try {
            if(this.limit != null) {
                arg6.setMaxRows(this.limit.intValue());
            }

            Object[] v0_1 = null;
            if((MappedPreparedStmt.logger.isLevelEnabled(Log$Level.TRACE)) && this.argHolders.length > 0) {
                v0_1 = new Object[this.argHolders.length];
            }

            int v2;
            for(v2 = 0; v2 < this.argHolders.length; ++v2) {
                Object v3 = this.argHolders[v2].getSqlArgValue();
                FieldType v1 = this.argFieldTypes[v2];
                SqlType v1_1 = v1 == null ? this.argHolders[v2].getSqlType() : v1.getSqlType();
                arg6.setObject(v2, v3, v1_1);
                if(v0_1 != null) {
                    v0_1[v2] = v3;
                }
            }

            MappedPreparedStmt.logger.debug("prepared statement \'{}\' with {} args", this.statement, Integer.valueOf(this.argHolders.length));
            if(v0_1 != null) {
                MappedPreparedStmt.logger.trace("prepared statement arguments: {}", v0_1);
            }
        }
        catch(Throwable v0) {
            goto label_51;
        }

        return arg6;
    label_51:
        arg6.close();
        throw v0;
    }

    public CompiledStatement compile(DatabaseConnection arg2, StatementBuilder$StatementType arg3) {
        return this.compile(arg2, arg3, -1);
    }

    public CompiledStatement compile(DatabaseConnection arg4, StatementBuilder$StatementType arg5, int arg6) {
        if(this.type != arg5) {
            throw new SQLException("Could not compile this " + this.type + " statement since the caller is expecting a " + arg5 + " statement.  Check your QueryBuilder methods.");
        }

        return this.assignStatementArguments(arg4.compileStatement(this.statement, arg5, this.argFieldTypes, arg6));
    }

    public String getStatement() {
        return this.statement;
    }

    public StatementBuilder$StatementType getType() {
        return this.type;
    }

    public void setArgumentHolderValue(int arg4, Object arg5) {
        if(arg4 < 0) {
            throw new SQLException("argument holder index " + arg4 + " must be >= 0");
        }

        if(this.argHolders.length <= arg4) {
            throw new SQLException("argument holder index " + arg4 + " is not valid, only " + this.argHolders.length + " in statement (index starts at 0)");
        }

        this.argHolders[arg4].setValue(arg5);
    }
}

