// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt.mapped;

import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.table.TableInfo;
import java.sql.SQLException;

public class MappedUpdate extends BaseMappedStatement {
    private final FieldType versionFieldType;
    private final int versionFieldTypeIndex;

    private MappedUpdate(TableInfo arg1, String arg2, FieldType[] arg3, FieldType arg4, int arg5) {
        super(arg1, arg2, arg3);
        this.versionFieldType = arg4;
        this.versionFieldTypeIndex = arg5;
    }

    public static MappedUpdate build(DatabaseType arg13, TableInfo arg14) {
        int v12;
        FieldType v7 = arg14.getIdField();
        if(v7 == null) {
            throw new SQLException("Cannot update " + arg14.getDataClass() + " because it doesn\'t have an id field");
        }

        StringBuilder v8 = new StringBuilder(64);
        MappedUpdate.appendTableName(arg13, v8, "UPDATE ", arg14.getTableName());
        FieldType v4 = null;
        int v5 = -1;
        FieldType[] v6 = arg14.getFieldTypes();
        int v9 = v6.length;
        int v3 = 0;
        int v0 = 0;
        while(v3 < v9) {
            FieldType v1 = v6[v3];
            if(MappedUpdate.isFieldUpdatable(v1, v7)) {
                if(v1.isVersion()) {
                    v5 = v0;
                    v4 = v1;
                }

                ++v0;
            }

            ++v3;
        }

        ++v0;
        if(v4 != null) {
            ++v0;
        }

        FieldType[] v3_1 = new FieldType[v0];
        int v1_1 = 0;
        FieldType[] v9_1 = arg14.getFieldTypes();
        int v10 = v9_1.length;
        int v6_1 = 0;
        v0 = 1;
        while(v6_1 < v10) {
            FieldType v11 = v9_1[v6_1];
            if(!MappedUpdate.isFieldUpdatable(v11, v7)) {
                v12 = v1_1;
                v1_1 = v0;
                v0 = v12;
            }
            else {
                if(v0 != 0) {
                    v8.append("SET ");
                    v0 = 0;
                }
                else {
                    v8.append(", ");
                }

                MappedUpdate.appendFieldColumnName(arg13, v8, v11, null);
                int v2 = v1_1 + 1;
                v3_1[v1_1] = v11;
                v8.append("= ?");
                v1_1 = v0;
                v0 = v2;
            }

            ++v6_1;
            v12 = v0;
            v0 = v1_1;
            v1_1 = v12;
        }

        v8.append(' ');
        MappedUpdate.appendWhereFieldEq(arg13, v7, v8, null);
        v0 = v1_1 + 1;
        v3_1[v1_1] = v7;
        if(v4 != null) {
            v8.append(" AND ");
            MappedUpdate.appendFieldColumnName(arg13, v8, v4, null);
            v8.append("= ?");
            v3_1[v0] = v4;
        }

        return new MappedUpdate(arg14, v8.toString(), v3_1, v4, v5);
    }

    private static boolean isFieldUpdatable(FieldType arg1, FieldType arg2) {
        boolean v0 = arg1 == arg2 || (arg1.isForeignCollection()) || (arg1.isReadOnly()) ? false : true;
        return v0;
    }

    public int update(DatabaseConnection arg10, Object arg11, ObjectCache arg12) {
        int v1_1;
        Object v2;
        Object[] v3;
        Object v1 = null;
        int v0 = 0;
        try {
            if(this.argFieldTypes.length > 1) {
                v3 = this.getFieldObjects(arg11);
                if(this.versionFieldType != null) {
                    v1 = this.versionFieldType.moveToNextValue(this.versionFieldType.extractJavaFieldValue(arg11));
                    v3[this.versionFieldTypeIndex] = this.versionFieldType.convertJavaFieldToSqlArgValue(v1);
                    v2 = v1;
                }
                else {
                    goto label_74;
                }

                goto label_19;
            }

            return v0;
        }
        catch(SQLException v0_1) {
            goto label_73;
        }

    label_74:
        v2 = v1;
        try {
        label_19:
            v1_1 = arg10.update(this.statement, v3, this.argFieldTypes);
            if(v1_1 > 0) {
                if(v2 != null) {
                    this.versionFieldType.assignField(arg11, v2, false, null);
                }

                if(arg12 == null) {
                    goto label_47;
                }

                v2 = arg12.get(this.clazz, this.idField.extractJavaFieldValue(arg11));
                if(v2 == null) {
                    goto label_47;
                }

                if(v2 == arg11) {
                    goto label_47;
                }

                FieldType[] v4 = this.tableInfo.getFieldTypes();
                int v5 = v4.length;
                while(v0 < v5) {
                    FieldType v6 = v4[v0];
                    if(v6 != this.idField) {
                        v6.assignField(v2, v6.extractJavaFieldValue(arg11), false, arg12);
                    }

                    ++v0;
                }
            }

        label_47:
            MappedUpdate.logger.debug("update data with statement \'{}\' and {} args, changed {} rows", this.statement, Integer.valueOf(v3.length), Integer.valueOf(v1_1));
            if(v3.length > 0) {
                MappedUpdate.logger.trace("update arguments: {}", v3);
            }
        }
        catch(SQLException v0_1) {
            goto label_73;
        }

        return v1_1;
    label_73:
        throw SqlExceptionUtil.create("Unable to run update stmt on object " + arg11 + ": " + this.statement, ((Throwable)v0_1));
    }
}

