// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.stmt.query;

import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.stmt.ArgumentHolder;
import com.j256.ormlite.stmt.ColumnArg;
import com.j256.ormlite.stmt.SelectArg;
import java.sql.SQLException;
import java.util.List;

abstract class BaseComparison implements Comparison {
    private static final String NUMBER_CHARACTERS = "0123456789.-+";
    protected final String columnName;
    protected final FieldType fieldType;
    private final Object value;

    protected BaseComparison(String arg4, FieldType arg5, Object arg6, boolean arg7) {
        super();
        if((arg7) && arg5 != null && !arg5.isComparable()) {
            throw new SQLException("Field \'" + arg4 + "\' is of data type " + arg5.getDataPersister() + " which can not be compared");
        }

        this.columnName = arg4;
        this.fieldType = arg5;
        this.value = arg6;
    }

    protected void appendArgOrValue(DatabaseType arg8, FieldType arg9, StringBuilder arg10, List arg11, Object arg12) {
        String v1;
        char v2 = '?';
        int v0 = 1;
        if(arg12 == null) {
            throw new SQLException("argument for \'" + arg9.getFieldName() + "\' is null");
        }

        if((arg12 instanceof ArgumentHolder)) {
            arg10.append(v2);
            ((ArgumentHolder)arg12).setMetaInfo(this.columnName, arg9);
            arg11.add(arg12);
        }
        else if((arg12 instanceof ColumnArg)) {
            v1 = ((ColumnArg)arg12).getTableName();
            if(v1 != null) {
                arg8.appendEscapedEntityName(arg10, v1);
                arg10.append('.');
            }

            arg8.appendEscapedEntityName(arg10, ((ColumnArg)arg12).getColumnName());
        }
        else {
            if(arg9.isArgumentHolderRequired()) {
                arg10.append(v2);
                SelectArg v1_1 = new SelectArg();
                ((ArgumentHolder)v1_1).setMetaInfo(this.columnName, arg9);
                ((ArgumentHolder)v1_1).setValue(arg12);
                arg11.add(v1_1);
                goto label_22;
            }

            if((arg9.isForeign()) && (arg9.getType().isAssignableFrom(arg12.getClass()))) {
                FieldType v2_1 = arg9.getForeignIdField();
                this.appendArgOrValue(arg8, v2_1, arg10, arg11, v2_1.extractJavaFieldValue(arg12));
                v0 = 0;
                goto label_22;
            }

            if(arg9.isEscapedValue()) {
                arg8.appendEscapedWord(arg10, arg9.convertJavaFieldToSqlArgValue(arg12).toString());
                goto label_22;
            }

            if(arg9.isForeign()) {
                v1 = arg9.convertJavaFieldToSqlArgValue(arg12).toString();
                if(v1.length() > 0 && "0123456789.-+".indexOf(v1.charAt(0)) < 0) {
                    throw new SQLException("Foreign field " + arg9 + " does not seem to be producing a numerical value \'" + v1 + "\'. Maybe you are passing the wrong object to comparison: " + this);
                }

                arg10.append(v1);
                goto label_22;
            }

            arg10.append(arg9.convertJavaFieldToSqlArgValue(arg12));
        }

    label_22:
        if(v0 != 0) {
            arg10.append(' ');
        }
    }

    public abstract void appendOperation(StringBuilder arg1);

    public void appendSql(DatabaseType arg2, String arg3, StringBuilder arg4, List arg5) {
        if(arg3 != null) {
            arg2.appendEscapedEntityName(arg4, arg3);
            arg4.append('.');
        }

        arg2.appendEscapedEntityName(arg4, this.columnName);
        arg4.append(' ');
        this.appendOperation(arg4);
        this.appendValue(arg2, arg4, arg5);
    }

    public void appendValue(DatabaseType arg7, StringBuilder arg8, List arg9) {
        this.appendArgOrValue(arg7, this.fieldType, arg8, arg9, this.value);
    }

    public String getColumnName() {
        return this.columnName;
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder();
        v0.append(this.columnName).append(' ');
        this.appendOperation(v0);
        v0.append(' ');
        v0.append(this.value);
        return v0.toString();
    }
}

