// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.table;

import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.field.DatabaseFieldConfig;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.misc.JavaxPersistence;
import com.j256.ormlite.support.ConnectionSource;
import java.lang.annotation.Annotation;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class DatabaseTableConfig {
    private Constructor constructor;
    private Class dataClass;
    private List fieldConfigs;
    private FieldType[] fieldTypes;
    private String tableName;

    public DatabaseTableConfig(Class arg1, String arg2, List arg3) {
        super();
        this.dataClass = arg1;
        this.tableName = arg2;
        this.fieldConfigs = arg3;
    }

    public DatabaseTableConfig() {
        super();
    }

    private DatabaseTableConfig(Class arg1, String arg2, FieldType[] arg3) {
        super();
        this.dataClass = arg1;
        this.tableName = arg2;
        this.fieldTypes = arg3;
    }

    public DatabaseTableConfig(Class arg2, List arg3) {
        this(arg2, DatabaseTableConfig.extractTableName(arg2), arg3);
    }

    private FieldType[] convertFieldConfigs(ConnectionSource arg9, String arg10, List arg11) {
        Field v3;
        ArrayList v6 = new ArrayList();
        Iterator v7 = arg11.iterator();
        while(v7.hasNext()) {
            Object v4 = v7.next();
            FieldType v0 = null;
            Class v1;
            for(v1 = this.dataClass; v1 != null; v1 = v1.getSuperclass()) {
                try {
                    v3 = v1.getDeclaredField(((DatabaseFieldConfig)v4).getFieldName());
                    if(v3 == null) {
                        goto label_33;
                    }
                }
                catch(NoSuchFieldException v2) {
                    goto label_33;
                }

                v0 = new FieldType(arg9, arg10, v3, ((DatabaseFieldConfig)v4), this.dataClass);
                break;
            label_33:
            }

            if(v0 == null) {
                throw new SQLException("Could not find declared field with name \'" + ((DatabaseFieldConfig)v4).getFieldName() + "\' for " + this.dataClass);
            }

            ((List)v6).add(v0);
        }

        if(((List)v6).isEmpty()) {
            throw new SQLException("No fields were configured for class " + this.dataClass);
        }

        return ((List)v6).toArray(new FieldType[((List)v6).size()]);
    }

    public void extractFieldTypes(ConnectionSource arg3) {
        if(this.fieldTypes == null) {
            this.fieldTypes = this.fieldConfigs == null ? DatabaseTableConfig.extractFieldTypes(arg3, this.dataClass, this.tableName) : this.convertFieldConfigs(arg3, this.tableName, this.fieldConfigs);
        }
    }

    private static FieldType[] extractFieldTypes(ConnectionSource arg6, Class arg7, String arg8) {
        ArrayList v2 = new ArrayList();
        Class v1;
        for(v1 = arg7; v1 != null; v1 = v1.getSuperclass()) {
            Field[] v3 = v1.getDeclaredFields();
            int v4 = v3.length;
            int v0;
            for(v0 = 0; v0 < v4; ++v0) {
                FieldType v5 = FieldType.createFieldType(arg6, arg8, v3[v0], arg7);
                if(v5 != null) {
                    ((List)v2).add(v5);
                }
            }
        }

        if(((List)v2).isEmpty()) {
            throw new IllegalArgumentException("No fields have a " + DatabaseField.class.getSimpleName() + " annotation in " + arg7);
        }

        return ((List)v2).toArray(new FieldType[((List)v2).size()]);
    }

    public static String extractTableName(Class arg2) {
        String v0_1;
        Annotation v0 = arg2.getAnnotation(DatabaseTable.class);
        if(v0 == null || ((DatabaseTable)v0).tableName() == null || ((DatabaseTable)v0).tableName().length() <= 0) {
            v0_1 = JavaxPersistence.getEntityName(arg2);
            if(v0_1 == null) {
                v0_1 = arg2.getSimpleName().toLowerCase();
            }
        }
        else {
            v0_1 = ((DatabaseTable)v0).tableName();
        }

        return v0_1;
    }

    public static Constructor findNoArgConstructor(Class arg5) {
        int v1;
        Constructor[] v0_1;
        try {
            v0_1 = arg5.getDeclaredConstructors();
            int v2 = v0_1.length;
            v1 = 0;
        }
        catch(Exception v0) {
            throw new IllegalArgumentException("Can\'t lookup declared constructors for " + arg5, ((Throwable)v0));
        }

        while(v1 < v2) {
            Constructor v3 = v0_1[v1];
            if(v3.getParameterTypes().length == 0) {
                if(!v3.isAccessible()) {
                    try {
                        v3.setAccessible(true);
                    }
                    catch(SecurityException v0_2) {
                        throw new IllegalArgumentException("Could not open access to constructor for " + arg5);
                    }
                }

                return v3;
            }

            ++v1;
        }

        if(arg5.getEnclosingClass() == null) {
            throw new IllegalArgumentException("Can\'t find a no-arg constructor for " + arg5);
        }

        throw new IllegalArgumentException("Can\'t find a no-arg constructor for " + arg5 + ".  Missing static on inner class?");
    }

    public static DatabaseTableConfig fromClass(ConnectionSource arg3, Class arg4) {
        String v0 = DatabaseTableConfig.extractTableName(arg4);
        if(arg3.getDatabaseType().isEntityNamesMustBeUpCase()) {
            v0 = v0.toUpperCase();
        }

        return new DatabaseTableConfig(arg4, v0, DatabaseTableConfig.extractFieldTypes(arg3, arg4, v0));
    }

    public Constructor getConstructor() {
        if(this.constructor == null) {
            this.constructor = DatabaseTableConfig.findNoArgConstructor(this.dataClass);
        }

        return this.constructor;
    }

    public Class getDataClass() {
        return this.dataClass;
    }

    public List getFieldConfigs() {
        return this.fieldConfigs;
    }

    public FieldType[] getFieldTypes(DatabaseType arg3) {
        if(this.fieldTypes == null) {
            throw new SQLException("Field types have not been extracted in table config");
        }

        return this.fieldTypes;
    }

    public String getTableName() {
        return this.tableName;
    }

    public void initialize() {
        if(this.dataClass == null) {
            throw new IllegalStateException("dataClass was never set on " + this.getClass().getSimpleName());
        }

        if(this.tableName == null) {
            this.tableName = DatabaseTableConfig.extractTableName(this.dataClass);
        }
    }

    public void setConstructor(Constructor arg1) {
        this.constructor = arg1;
    }

    public void setDataClass(Class arg1) {
        this.dataClass = arg1;
    }

    public void setFieldConfigs(List arg1) {
        this.fieldConfigs = arg1;
    }

    public void setTableName(String arg1) {
        this.tableName = arg1;
    }
}

