// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.table;

import com.j256.ormlite.field.DatabaseFieldConfig;
import com.j256.ormlite.field.DatabaseFieldConfigLoader;
import com.j256.ormlite.misc.SqlExceptionUtil;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class DatabaseTableConfigLoader {
    private static final String CONFIG_FILE_END_MARKER = "# --table-end--";
    private static final String CONFIG_FILE_FIELDS_END = "# --table-fields-end--";
    private static final String CONFIG_FILE_FIELDS_START = "# --table-fields-start--";
    private static final String CONFIG_FILE_START_MARKER = "# --table-start--";
    private static final String FIELD_NAME_DATA_CLASS = "dataClass";
    private static final String FIELD_NAME_TABLE_NAME = "tableName";

    public DatabaseTableConfigLoader() {
        super();
    }

    public static DatabaseTableConfig fromReader(BufferedReader arg7) {
        String v4;
        DatabaseTableConfig v0 = new DatabaseTableConfig();
        int v1 = 0;
        try {
            while(true) {
            label_5:
                v4 = arg7.readLine();
                if(v4 != null) {
                    break;
                }

                goto label_7;
            }
        }
        catch(IOException v0_1) {
            throw SqlExceptionUtil.create("Could not read DatabaseTableConfig from stream", ((Throwable)v0_1));
        }

        if(!v4.equals("# --table-end--")) {
            if(v4.equals("# --table-fields-start--")) {
                DatabaseTableConfigLoader.readFields(arg7, v0);
                goto label_5;
            }
            else {
                if(v4.length() == 0) {
                    goto label_5;
                }

                if(v4.startsWith("#")) {
                    goto label_5;
                }

                if(v4.equals("# --table-start--")) {
                    goto label_5;
                }

                String[] v1_1 = v4.split("=", -2);
                if(v1_1.length != 2) {
                    throw new SQLException("DatabaseTableConfig reading from stream cannot parse line: " + v4);
                }
                else {
                    DatabaseTableConfigLoader.readTableField(v0, v1_1[0], v1_1[1]);
                    v1 = 1;
                    goto label_5;
                }
            }
        }

    label_7:
        if(v1 == 0) {
            v0 = null;
        }

        return v0;
    }

    public static List loadDatabaseConfigFromReader(BufferedReader arg2) {
        ArrayList v0 = new ArrayList();
        while(true) {
            DatabaseTableConfig v1 = DatabaseTableConfigLoader.fromReader(arg2);
            if(v1 == null) {
                break;
            }

            ((List)v0).add(v1);
        }

        return ((List)v0);
    }

    private static void readFields(BufferedReader arg3, DatabaseTableConfig arg4) {
        ArrayList v0 = new ArrayList();
        try {
            while(true) {
            label_2:
                String v1 = arg3.readLine();
                if(v1 == null) {
                    goto label_7;
                }

                break;
            }
        }
        catch(IOException v0_1) {
            throw SqlExceptionUtil.create("Could not read next field from config file", ((Throwable)v0_1));
        }

        if(!v1.equals("# --table-fields-end--")) {
            DatabaseFieldConfig v1_1 = DatabaseFieldConfigLoader.fromReader(arg3);
            if(v1_1 != null) {
                ((List)v0).add(v1_1);
                goto label_2;
            }
        }

    label_7:
        arg4.setFieldConfigs(((List)v0));
    }

    private static void readTableField(DatabaseTableConfig arg3, String arg4, String arg5) {
        if(arg4.equals("dataClass")) {
            try {
                arg3.setDataClass(Class.forName(arg5));
            }
            catch(ClassNotFoundException v0) {
                throw new IllegalArgumentException("Unknown class specified for dataClass: " + arg5);
            }
        }
        else if(arg4.equals("tableName")) {
            arg3.setTableName(arg5);
        }
    }

    public static void write(BufferedWriter arg2, DatabaseTableConfig arg3) {
        try {
            DatabaseTableConfigLoader.writeConfig(arg2, arg3);
            return;
        }
        catch(IOException v0) {
            throw SqlExceptionUtil.create("Could not write config to writer", ((Throwable)v0));
        }
    }

    private static void writeConfig(BufferedWriter arg3, DatabaseTableConfig arg4) {
        char v2 = '=';
        arg3.append("# --table-start--");
        arg3.newLine();
        if(arg4.getDataClass() != null) {
            arg3.append("dataClass").append(v2).append(arg4.getDataClass().getName());
            arg3.newLine();
        }

        if(arg4.getTableName() != null) {
            arg3.append("tableName").append(v2).append(arg4.getTableName());
            arg3.newLine();
        }

        arg3.append("# --table-fields-start--");
        arg3.newLine();
        if(arg4.getFieldConfigs() != null) {
            Iterator v1 = arg4.getFieldConfigs().iterator();
            while(v1.hasNext()) {
                DatabaseFieldConfigLoader.write(arg3, v1.next(), arg4.getTableName());
            }
        }

        arg3.append("# --table-fields-end--");
        arg3.newLine();
        arg3.append("# --table-end--");
        arg3.newLine();
    }
}

