// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.table;

import com.j256.ormlite.dao.BaseDaoImpl;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.misc.BaseDaoEnabled;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.support.ConnectionSource;
import java.lang.reflect.Constructor;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

public class TableInfo {
    private static final FieldType[] NO_FOREIGN_COLLECTIONS;
    private final BaseDaoImpl baseDaoImpl;
    private final Constructor constructor;
    private final Class dataClass;
    private Map fieldNameMap;
    private final FieldType[] fieldTypes;
    private final boolean foreignAutoCreate;
    private final FieldType[] foreignCollections;
    private final FieldType idField;
    private final String tableName;

    static {
        TableInfo.NO_FOREIGN_COLLECTIONS = new FieldType[0];
    }

    public TableInfo(ConnectionSource arg3, BaseDaoImpl arg4, Class arg5) {
        this(arg3.getDatabaseType(), arg4, DatabaseTableConfig.fromClass(arg3, arg5));
    }

    public TableInfo(DatabaseType arg10, BaseDaoImpl arg11, DatabaseTableConfig arg12) {
        int v1_1;
        super();
        this.baseDaoImpl = arg11;
        this.dataClass = arg12.getDataClass();
        this.tableName = arg12.getTableName();
        this.fieldTypes = arg12.getFieldTypes(arg10);
        FieldType v0 = null;
        FieldType[] v6 = this.fieldTypes;
        int v7 = v6.length;
        int v5 = 0;
        int v3 = 0;
        boolean v2 = false;
        while(v5 < v7) {
            FieldType v1 = v6[v5];
            if((v1.isId()) || (v1.isGeneratedId()) || (v1.isGeneratedIdSequence())) {
                if(v0 != null) {
                    throw new SQLException("More than 1 idField configured for class " + this.dataClass + " (" + v0 + "," + v1 + ")");
                }
                else {
                    v0 = v1;
                }
            }

            if(v1.isForeignAutoCreate()) {
                v2 = true;
            }

            v1_1 = v1.isForeignCollection() ? v3 + 1 : v3;
            ++v5;
            v3 = v1_1;
        }

        this.idField = v0;
        this.constructor = arg12.getConstructor();
        this.foreignAutoCreate = v2;
        if(v3 == 0) {
            this.foreignCollections = TableInfo.NO_FOREIGN_COLLECTIONS;
        }
        else {
            this.foreignCollections = new FieldType[v3];
            FieldType[] v2_1 = this.fieldTypes;
            v3 = v2_1.length;
            v1_1 = 0;
            int v0_1 = 0;
            while(v1_1 < v3) {
                FieldType v4 = v2_1[v1_1];
                if(v4.isForeignCollection()) {
                    this.foreignCollections[v0_1] = v4;
                    ++v0_1;
                }

                ++v1_1;
            }
        }
    }

    public Object createObject() {
        ObjectFactory v0 = null;
        try {
            if(this.baseDaoImpl != null) {
                v0 = this.baseDaoImpl.getObjectFactory();
            }

            Object v0_2 = v0 == null ? this.constructor.newInstance() : v0.createObject(this.constructor, this.baseDaoImpl.getDataClass());
            TableInfo.wireNewInstance(this.baseDaoImpl, v0_2);
            return v0_2;
        }
        catch(Exception v0_1) {
            throw SqlExceptionUtil.create("Could not create object for " + this.constructor.getDeclaringClass(), ((Throwable)v0_1));
        }
    }

    public Constructor getConstructor() {
        return this.constructor;
    }

    public Class getDataClass() {
        return this.dataClass;
    }

    public FieldType getFieldTypeByColumnName(String arg8) {
        if(this.fieldNameMap == null) {
            HashMap v2 = new HashMap();
            FieldType[] v3 = this.fieldTypes;
            int v4 = v3.length;
            int v0;
            for(v0 = 0; v0 < v4; ++v0) {
                ((Map)v2).put(v3[v0].getColumnName().toLowerCase(), v3[v0]);
            }

            this.fieldNameMap = ((Map)v2);
        }

        Object v0_1 = this.fieldNameMap.get(arg8.toLowerCase());
        if(v0_1 != null) {
            return ((FieldType)v0_1);
        }

        FieldType[] v2_1 = this.fieldTypes;
        int v3_1 = v2_1.length;
        for(v0 = 0; v0 < v3_1; ++v0) {
            FieldType v1 = v2_1[v0];
            if(v1.getFieldName().equals(arg8)) {
                throw new IllegalArgumentException("You should use columnName \'" + v1.getColumnName() + "\' for table " + this.tableName + " instead of fieldName \'" + v1.getFieldName() + "\'");
            }
        }

        throw new IllegalArgumentException("Unknown column name \'" + arg8 + "\' in table " + this.tableName);
    }

    public FieldType[] getFieldTypes() {
        return this.fieldTypes;
    }

    public FieldType[] getForeignCollections() {
        return this.foreignCollections;
    }

    public FieldType getIdField() {
        return this.idField;
    }

    public String getTableName() {
        return this.tableName;
    }

    public boolean hasColumnName(String arg6) {
        boolean v0 = false;
        FieldType[] v2 = this.fieldTypes;
        int v3 = v2.length;
        int v1 = 0;
        while(v1 < v3) {
            if(v2[v1].getColumnName().equals(arg6)) {
                v0 = true;
            }
            else {
                ++v1;
                continue;
            }

            return v0;
        }

        return v0;
    }

    public boolean isForeignAutoCreate() {
        return this.foreignAutoCreate;
    }

    public boolean isUpdatable() {
        boolean v0 = true;
        if(this.idField == null || this.fieldTypes.length <= 1) {
            v0 = false;
        }

        return v0;
    }

    public String objectToString(Object arg8) {
        StringBuilder v1 = new StringBuilder(64);
        v1.append(arg8.getClass().getSimpleName());
        FieldType[] v2 = this.fieldTypes;
        int v3 = v2.length;
        int v0 = 0;
        while(v0 < v3) {
            FieldType v4 = v2[v0];
            v1.append(' ').append(v4.getColumnName()).append("=");
            try {
                v1.append(v4.extractJavaFieldValue(arg8));
                ++v0;
                continue;
            }
            catch(Exception v0_1) {
                throw new IllegalStateException("Could not generate toString of field " + v4, ((Throwable)v0_1));
            }
        }

        return v1.toString();
    }

    private static void wireNewInstance(BaseDaoImpl arg1, Object arg2) {
        if((arg2 instanceof BaseDaoEnabled)) {
            ((BaseDaoEnabled)arg2).setDao(((Dao)arg1));
        }
    }
}

