// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package com.j256.ormlite.table;

import com.j256.ormlite.dao.BaseDaoImpl;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.dao.ObjectCache;
import com.j256.ormlite.db.DatabaseType;
import com.j256.ormlite.field.FieldType;
import com.j256.ormlite.logger.Logger;
import com.j256.ormlite.logger.LoggerFactory;
import com.j256.ormlite.misc.SqlExceptionUtil;
import com.j256.ormlite.stmt.StatementBuilder$StatementType;
import com.j256.ormlite.support.CompiledStatement;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.support.DatabaseConnection;
import com.j256.ormlite.support.DatabaseResults;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map$Entry;
import java.util.Set;

public class TableUtils {
    private static Logger logger;
    private static final FieldType[] noFieldTypes;

    static {
        TableUtils.logger = LoggerFactory.getLogger(TableUtils.class);
        TableUtils.noFieldTypes = new FieldType[0];
    }

    private TableUtils() {
        super();
    }

    private static void addCreateIndexStatements(DatabaseType arg8, TableInfo arg9, List arg10, boolean arg11, boolean arg12) {
        ArrayList v0_1;
        Object v0;
        HashMap v4 = new HashMap();
        FieldType[] v5 = arg9.getFieldTypes();
        int v6 = v5.length;
        int v2;
        for(v2 = 0; v2 < v6; ++v2) {
            FieldType v7 = v5[v2];
            String v1 = arg12 ? v7.getUniqueIndexName() : v7.getIndexName();
            if(v1 != null) {
                v0 = ((Map)v4).get(v1);
                if(v0 == null) {
                    v0_1 = new ArrayList();
                    ((Map)v4).put(v1, v0_1);
                }

                ((List)v0_1).add(v7.getColumnName());
            }
        }

        StringBuilder v5_1 = new StringBuilder(128);
        Iterator v4_1 = ((Map)v4).entrySet().iterator();
        while(v4_1.hasNext()) {
            Object v1_1 = v4_1.next();
            TableUtils.logger.info("creating index \'{}\' for table \'{}", ((Map$Entry)v1_1).getKey(), arg9.getTableName());
            v5_1.append("CREATE ");
            if(arg12) {
                v5_1.append("UNIQUE ");
            }

            v5_1.append("INDEX ");
            if((arg11) && (arg8.isCreateIndexIfNotExistsSupported())) {
                v5_1.append("IF NOT EXISTS ");
            }

            arg8.appendEscapedEntityName(v5_1, ((Map$Entry)v1_1).getKey());
            v5_1.append(" ON ");
            arg8.appendEscapedEntityName(v5_1, arg9.getTableName());
            v5_1.append(" ( ");
            Iterator v6_1 = ((Map$Entry)v1_1).getValue().iterator();
            int v1_2 = 1;
            while(v6_1.hasNext()) {
                v0 = v6_1.next();
                if(v1_2 != 0) {
                    v1_2 = 0;
                }
                else {
                    v5_1.append(", ");
                }

                arg8.appendEscapedEntityName(v5_1, ((String)v0));
            }

            v5_1.append(" )");
            arg10.add(v5_1.toString());
            v5_1.setLength(0);
        }
    }

    private static List addCreateTableStatements(ConnectionSource arg3, TableInfo arg4, boolean arg5) {
        ArrayList v0 = new ArrayList();
        TableUtils.addCreateTableStatements(arg3.getDatabaseType(), arg4, ((List)v0), new ArrayList(), arg5);
        return ((List)v0);
    }

    private static void addCreateTableStatements(DatabaseType arg17, TableInfo arg18, List arg19, List arg20, boolean arg21) {
        int v12;
        StringBuilder v6 = new StringBuilder(256);
        v6.append("CREATE TABLE ");
        if((arg21) && (arg17.isCreateIfNotExistsSupported())) {
            v6.append("IF NOT EXISTS ");
        }

        arg17.appendEscapedEntityName(v6, arg18.getTableName());
        v6.append(" (");
        ArrayList v8 = new ArrayList();
        ArrayList v9 = new ArrayList();
        ArrayList v10 = new ArrayList();
        FieldType[] v14 = arg18.getFieldTypes();
        int v15 = v14.length;
        int v13 = 0;
        int v4;
        for(v4 = 1; v13 < v15; v4 = v12) {
            FieldType v7 = v14[v13];
            if(v7.isForeignCollection()) {
                v12 = v4;
            }
            else {
                if(v4 != 0) {
                    v12 = 0;
                }
                else {
                    v6.append(", ");
                    v12 = v4;
                }

                String v4_1 = v7.getColumnDefinition();
                if(v4_1 == null) {
                    arg17.appendColumnArg(arg18.getTableName(), v6, v7, ((List)v8), ((List)v9), ((List)v10), arg20);
                    goto label_32;
                }

                arg17.appendEscapedEntityName(v6, v7.getColumnName());
                v6.append(' ').append(v4_1).append(' ');
            }

        label_32:
            ++v13;
        }

        arg17.addPrimaryKeySql(arg18.getFieldTypes(), v8, v9, v10, arg20);
        arg17.addUniqueComboSql(arg18.getFieldTypes(), v8, v9, v10, arg20);
        Iterator v5 = ((List)v8).iterator();
        while(v5.hasNext()) {
            v6.append(", ").append(v5.next());
        }

        v6.append(") ");
        arg17.appendCreateTableSuffix(v6);
        arg19.addAll(((Collection)v9));
        arg19.add(v6.toString());
        arg19.addAll(((Collection)v10));
        TableUtils.addCreateIndexStatements(arg17, arg18, arg19, arg21, false);
        TableUtils.addCreateIndexStatements(arg17, arg18, arg19, arg21, true);
    }

    private static void addDropIndexStatements(DatabaseType arg7, TableInfo arg8, List arg9) {
        HashSet v2 = new HashSet();
        FieldType[] v3 = arg8.getFieldTypes();
        int v4 = v3.length;
        int v0;
        for(v0 = 0; v0 < v4; ++v0) {
            FieldType v5 = v3[v0];
            String v6 = v5.getIndexName();
            if(v6 != null) {
                ((Set)v2).add(v6);
            }

            String v5_1 = v5.getUniqueIndexName();
            if(v5_1 != null) {
                ((Set)v2).add(v5_1);
            }
        }

        StringBuilder v3_1 = new StringBuilder(48);
        Iterator v2_1 = ((Set)v2).iterator();
        while(v2_1.hasNext()) {
            Object v0_1 = v2_1.next();
            TableUtils.logger.info("dropping index \'{}\' for table \'{}", v0_1, arg8.getTableName());
            v3_1.append("DROP INDEX ");
            arg7.appendEscapedEntityName(v3_1, ((String)v0_1));
            arg9.add(v3_1.toString());
            v3_1.setLength(0);
        }
    }

    private static void addDropTableStatements(DatabaseType arg6, TableInfo arg7, List arg8) {
        ArrayList v1 = new ArrayList();
        ArrayList v2 = new ArrayList();
        FieldType[] v3 = arg7.getFieldTypes();
        int v4 = v3.length;
        int v0;
        for(v0 = 0; v0 < v4; ++v0) {
            arg6.dropColumnArg(v3[v0], ((List)v1), ((List)v2));
        }

        StringBuilder v0_1 = new StringBuilder(64);
        v0_1.append("DROP TABLE ");
        arg6.appendEscapedEntityName(v0_1, arg7.getTableName());
        v0_1.append(' ');
        arg8.addAll(((Collection)v1));
        arg8.add(v0_1.toString());
        arg8.addAll(((Collection)v2));
    }

    public static int clearTable(ConnectionSource arg1, DatabaseTableConfig arg2) {
        return TableUtils.clearTable(arg1, arg2.getTableName());
    }

    private static int clearTable(ConnectionSource arg6, String arg7) {
        int v0_3;
        CompiledStatement v1_1;
        DatabaseType v0 = arg6.getDatabaseType();
        StringBuilder v1 = new StringBuilder(48);
        if(v0.isTruncateSupported()) {
            v1.append("TRUNCATE TABLE ");
        }
        else {
            v1.append("DELETE FROM ");
        }

        v0.appendEscapedEntityName(v1, arg7);
        String v0_1 = v1.toString();
        TableUtils.logger.info("clearing table \'{}\' with \'{}", arg7, v0_1);
        DatabaseConnection v2 = arg6.getReadWriteConnection();
        try {
            v1_1 = v2.compileStatement(v0_1, StatementBuilder$StatementType.EXECUTE, TableUtils.noFieldTypes, -1);
            v0_3 = v1_1.runExecute();
            if(v1_1 == null) {
                goto label_22;
            }
        }
        catch(Throwable v0_2) {
            if(v1_1 != null) {
                v1_1.close();
            }

            arg6.releaseConnection(v2);
            throw v0_2;
        }

        v1_1.close();
    label_22:
        arg6.releaseConnection(v2);
        return v0_3;
    }

    public static int clearTable(ConnectionSource arg2, Class arg3) {
        String v0 = DatabaseTableConfig.extractTableName(arg3);
        if(arg2.getDatabaseType().isEntityNamesMustBeUpCase()) {
            v0 = v0.toUpperCase();
        }

        return TableUtils.clearTable(arg2, v0);
    }

    public static int createTable(ConnectionSource arg1, DatabaseTableConfig arg2) {
        return TableUtils.createTable(arg1, arg2, false);
    }

    private static int createTable(ConnectionSource arg3, DatabaseTableConfig arg4, boolean arg5) {
        int v0_1;
        Dao v0 = DaoManager.createDao(arg3, arg4);
        if((v0 instanceof BaseDaoImpl)) {
            v0_1 = TableUtils.doCreateTable(arg3, ((BaseDaoImpl)v0).getTableInfo(), arg5);
        }
        else {
            arg4.extractFieldTypes(arg3);
            v0_1 = TableUtils.doCreateTable(arg3, new TableInfo(arg3.getDatabaseType(), null, arg4), arg5);
        }

        return v0_1;
    }

    public static int createTable(ConnectionSource arg1, Class arg2) {
        return TableUtils.createTable(arg1, arg2, false);
    }

    private static int createTable(ConnectionSource arg2, Class arg3, boolean arg4) {
        Dao v0 = DaoManager.createDao(arg2, arg3);
        int v0_1 = (v0 instanceof BaseDaoImpl) ? TableUtils.doCreateTable(arg2, ((BaseDaoImpl)v0).getTableInfo(), arg4) : TableUtils.doCreateTable(arg2, new TableInfo(arg2, null, arg3), arg4);
        return v0_1;
    }

    public static int createTableIfNotExists(ConnectionSource arg1, DatabaseTableConfig arg2) {
        return TableUtils.createTable(arg1, arg2, true);
    }

    public static int createTableIfNotExists(ConnectionSource arg1, Class arg2) {
        return TableUtils.createTable(arg1, arg2, true);
    }

    private static int doCreateTable(ConnectionSource arg8, TableInfo arg9, boolean arg10) {
        int v2_1;
        int v1_1;
        DatabaseType v6 = arg8.getDatabaseType();
        TableUtils.logger.info("creating table \'{}\'", arg9.getTableName());
        ArrayList v2 = new ArrayList();
        ArrayList v7 = new ArrayList();
        TableUtils.addCreateTableStatements(v6, arg9, ((List)v2), ((List)v7), arg10);
        DatabaseConnection v0 = arg8.getReadWriteConnection();
        try {
            v1_1 = TableUtils.doStatements(v0, "create", ((Collection)v2), false, v6.isCreateTableReturnsNegative(), v6.isCreateTableReturnsZero());
            v2_1 = TableUtils.doCreateTestQueries(v0, v6, ((List)v7));
        }
        catch(Throwable v1) {
            arg8.releaseConnection(v0);
            throw v1;
        }

        arg8.releaseConnection(v0);
        return v1_1 + v2_1;
    }

    private static int doCreateTestQueries(DatabaseConnection arg9, DatabaseType arg10, List arg11) {
        CompiledStatement v2;
        ObjectCache v5;
        CompiledStatement v3;
        Object v0;
        CompiledStatement v4 = null;
        Iterator v7 = arg11.iterator();
        int v1;
        for(v1 = 0; true; ++v1) {
            if(!v7.hasNext()) {
                return v1;
            }

            v0 = v7.next();
            try {
                v3 = arg9.compileStatement(((String)v0), StatementBuilder$StatementType.SELECT, TableUtils.noFieldTypes, -1);
                v5 = null;
            }
            catch(Throwable v0_1) {
                v2 = v4;
                goto label_39;
            }
            catch(SQLException v1_1) {
                v2 = v4;
                goto label_30;
            }

            try {
                DatabaseResults v8 = v3.runQuery(v5);
                boolean v5_1 = v8.first();
                int v6 = 0;
                while(v5_1) {
                    ++v6;
                    v5_1 = v8.next();
                }

                TableUtils.logger.info("executing create table after-query got {} results: {}", Integer.valueOf(v6), v0);
                if(v3 != null) {
                    goto label_24;
                }

                goto label_25;
            }
            catch(SQLException v1_1) {
                break;
            }
            catch(Throwable v0_1) {
                goto label_47;
            }

        label_24:
            v3.close();
        label_25:
        }

        v2 = v3;
        try {
        label_30:
            throw SqlExceptionUtil.create("executing create table after-query failed: " + (((String)v0)), ((Throwable)v1_1));
        }
        catch(Throwable v0_1) {
            goto label_39;
        }

    label_47:
        v2 = v3;
    label_39:
        if(v2 != null) {
            v2.close();
        }

        throw v0_1;
        return v1;
    }

    private static int doDropTable(DatabaseType arg6, ConnectionSource arg7, TableInfo arg8, boolean arg9) {
        int v1_1;
        TableUtils.logger.info("dropping table \'{}\'", arg8.getTableName());
        ArrayList v2 = new ArrayList();
        TableUtils.addDropIndexStatements(arg6, arg8, ((List)v2));
        TableUtils.addDropTableStatements(arg6, arg8, ((List)v2));
        DatabaseConnection v0 = arg7.getReadWriteConnection();
        try {
            v1_1 = TableUtils.doStatements(v0, "drop", ((Collection)v2), arg9, arg6.isCreateTableReturnsNegative(), false);
        }
        catch(Throwable v1) {
            arg7.releaseConnection(v0);
            throw v1;
        }

        arg7.releaseConnection(v0);
        return v1_1;
    }

    private static int doStatements(DatabaseConnection arg9, String arg10, Collection arg11, boolean arg12, boolean arg13, boolean arg14) {
        int v5;
        CompiledStatement v4;
        Iterator v6 = arg11.iterator();
        int v1;
        for(v1 = 0; v6.hasNext(); ++v1) {
            Object v0 = v6.next();
            try {
                v4 = arg9.compileStatement(((String)v0), StatementBuilder$StatementType.EXECUTE, TableUtils.noFieldTypes, -1);
                v5 = v4.runExecute();
            }
            catch(SQLException v3) {
                v5 = 0;
                goto label_36;
            }

            try {
                TableUtils.logger.info("executed {} table statement changed {} rows: {}", arg10, Integer.valueOf(v5), v0);
                if(v4 == null) {
                    goto label_18;
                }

                goto label_17;
            }
            catch(SQLException v3) {
            }

        label_36:
            if(arg12) {
                try {
                    TableUtils.logger.info("ignoring {} error \'{}\' for statement: {}", arg10, v3, v0);
                    if(v4 == null) {
                        goto label_18;
                    }
                }
                catch(Throwable v0_1) {
                    goto label_52;
                }

                v4.close();
                goto label_18;
            }

            try {
                throw SqlExceptionUtil.create("SQL statement failed: " + (((String)v0)), ((Throwable)v3));
            }
            catch(Throwable v0_1) {
            label_52:
                if(v4 != null) {
                    v4.close();
                }

                throw v0_1;
            }

        label_17:
            v4.close();
        label_18:
            if(v5 < 0) {
                if(!arg13) {
                    throw new SQLException("SQL statement " + (((String)v0)) + " updated " + v5 + " rows, we were expecting >= 0");
                }
            }
            else if(v5 > 0 && (arg14)) {
                throw new SQLException("SQL statement updated " + v5 + " rows, we were expecting == 0: " + (((String)v0)));
            }
        }

        return v1;
    }

    public static int dropTable(ConnectionSource arg3, DatabaseTableConfig arg4, boolean arg5) {
        int v0_1;
        DatabaseType v1 = arg3.getDatabaseType();
        Dao v0 = DaoManager.createDao(arg3, arg4);
        if((v0 instanceof BaseDaoImpl)) {
            v0_1 = TableUtils.doDropTable(v1, arg3, ((BaseDaoImpl)v0).getTableInfo(), arg5);
        }
        else {
            arg4.extractFieldTypes(arg3);
            v0_1 = TableUtils.doDropTable(v1, arg3, new TableInfo(v1, null, arg4), arg5);
        }

        return v0_1;
    }

    public static int dropTable(ConnectionSource arg3, Class arg4, boolean arg5) {
        DatabaseType v1 = arg3.getDatabaseType();
        Dao v0 = DaoManager.createDao(arg3, arg4);
        int v0_1 = (v0 instanceof BaseDaoImpl) ? TableUtils.doDropTable(v1, arg3, ((BaseDaoImpl)v0).getTableInfo(), arg5) : TableUtils.doDropTable(v1, arg3, new TableInfo(arg3, null, arg4), arg5);
        return v0_1;
    }

    public static List getCreateTableStatements(ConnectionSource arg4, DatabaseTableConfig arg5) {
        List v0_1;
        Dao v0 = DaoManager.createDao(arg4, arg5);
        if((v0 instanceof BaseDaoImpl)) {
            v0_1 = TableUtils.addCreateTableStatements(arg4, ((BaseDaoImpl)v0).getTableInfo(), false);
        }
        else {
            arg5.extractFieldTypes(arg4);
            v0_1 = TableUtils.addCreateTableStatements(arg4, new TableInfo(arg4.getDatabaseType(), null, arg5), false);
        }

        return v0_1;
    }

    public static List getCreateTableStatements(ConnectionSource arg3, Class arg4) {
        Dao v0 = DaoManager.createDao(arg3, arg4);
        List v0_1 = (v0 instanceof BaseDaoImpl) ? TableUtils.addCreateTableStatements(arg3, ((BaseDaoImpl)v0).getTableInfo(), false) : TableUtils.addCreateTableStatements(arg3, new TableInfo(arg3, null, arg4), false);
        return v0_1;
    }
}

