// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.auth;

import java.util.Locale;
import org.apache.http.HttpHost;
import org.apache.http.annotation.Immutable;
import org.apache.http.util.Args;
import org.apache.http.util.LangUtils;

@Immutable public class AuthScope {
    public static final AuthScope ANY = null;
    public static final String ANY_HOST = null;
    public static final int ANY_PORT = -1;
    public static final String ANY_REALM;
    public static final String ANY_SCHEME;
    private final String host;
    private final int port;
    private final String realm;
    private final String scheme;

    static {
        AuthScope.ANY_HOST = null;
        AuthScope.ANY_REALM = null;
        AuthScope.ANY_SCHEME = null;
        AuthScope.ANY = new AuthScope(AuthScope.ANY_HOST, -1, AuthScope.ANY_REALM, AuthScope.ANY_SCHEME);
    }

    public AuthScope(String arg2, int arg3, String arg4, String arg5) {
        super();
        String v0 = arg2 == null ? AuthScope.ANY_HOST : arg2.toLowerCase(Locale.ENGLISH);
        this.host = v0;
        if(arg3 < 0) {
            arg3 = -1;
        }

        this.port = arg3;
        if(arg4 == null) {
            arg4 = AuthScope.ANY_REALM;
        }

        this.realm = arg4;
        v0 = arg5 == null ? AuthScope.ANY_SCHEME : arg5.toUpperCase(Locale.ENGLISH);
        this.scheme = v0;
    }

    public AuthScope(String arg3, int arg4) {
        this(arg3, arg4, AuthScope.ANY_REALM, AuthScope.ANY_SCHEME);
    }

    public AuthScope(String arg2, int arg3, String arg4) {
        this(arg2, arg3, arg4, AuthScope.ANY_SCHEME);
    }

    public AuthScope(HttpHost arg3) {
        this(arg3, AuthScope.ANY_REALM, AuthScope.ANY_SCHEME);
    }

    public AuthScope(HttpHost arg3, String arg4, String arg5) {
        this(arg3.getHostName(), arg3.getPort(), arg4, arg5);
    }

    public AuthScope(AuthScope arg2) {
        super();
        Args.notNull(arg2, "Scope");
        this.host = arg2.getHost();
        this.port = arg2.getPort();
        this.realm = arg2.getRealm();
        this.scheme = arg2.getScheme();
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if(arg5 == null) {
            v0 = false;
        }
        else if((((AuthScope)arg5)) != this) {
            if(!(arg5 instanceof AuthScope)) {
                v0 = super.equals(arg5);
            }
            else {
                if((LangUtils.equals(this.host, ((AuthScope)arg5).host)) && this.port == ((AuthScope)arg5).port && (LangUtils.equals(this.realm, ((AuthScope)arg5).realm)) && (LangUtils.equals(this.scheme, ((AuthScope)arg5).scheme))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public String getHost() {
        return this.host;
    }

    public int getPort() {
        return this.port;
    }

    public String getRealm() {
        return this.realm;
    }

    public String getScheme() {
        return this.scheme;
    }

    public int hashCode() {
        return LangUtils.hashCode(LangUtils.hashCode(LangUtils.hashCode(LangUtils.hashCode(17, this.host), this.port), this.realm), this.scheme);
    }

    public int match(AuthScope arg5) {
        int v1 = -1;
        int v0 = 0;
        if(LangUtils.equals(this.scheme, arg5.scheme)) {
            v0 = 1;
            goto label_7;
        }
        else if(this.scheme == AuthScope.ANY_SCHEME) {
        label_7:
            if(LangUtils.equals(this.realm, arg5.realm)) {
                v0 += 2;
            }
            else if(this.realm != AuthScope.ANY_REALM && arg5.realm != AuthScope.ANY_REALM) {
                return v1;
            }

            if(this.port == arg5.port) {
                v0 += 4;
            }
            else if(this.port != v1 && arg5.port != v1) {
                return v1;
            }

            if(LangUtils.equals(this.host, arg5.host)) {
                return 8;
            }

            if(this.host == AuthScope.ANY_HOST) {
                return v0;
            }

            if(arg5.host == AuthScope.ANY_HOST) {
                return v0;
            }

            v0 = v1;
        }
        else if(arg5.scheme != AuthScope.ANY_SCHEME) {
            v0 = v1;
        }
        else {
            goto label_7;
        }

        return v0;
    }

    public String toString() {
        char v3 = '\'';
        StringBuilder v0 = new StringBuilder();
        if(this.scheme != null) {
            v0.append(this.scheme.toUpperCase(Locale.ENGLISH));
            v0.append(' ');
        }

        if(this.realm != null) {
            v0.append(v3);
            v0.append(this.realm);
            v0.append(v3);
        }
        else {
            v0.append("<any realm>");
        }

        if(this.host != null) {
            v0.append('@');
            v0.append(this.host);
            if(this.port >= 0) {
                v0.append(':');
                v0.append(this.port);
            }
        }

        return v0.toString();
    }
}

