// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.auth;

import java.util.Collection;
import java.util.Queue;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.util.Args;

@NotThreadSafe public class AuthState {
    private Queue authOptions;
    private AuthScheme authScheme;
    private AuthScope authScope;
    private Credentials credentials;
    private AuthProtocolState state;

    public AuthState() {
        super();
        this.state = AuthProtocolState.UNCHALLENGED;
    }

    public Queue getAuthOptions() {
        return this.authOptions;
    }

    public AuthScheme getAuthScheme() {
        return this.authScheme;
    }

    @Deprecated public AuthScope getAuthScope() {
        return this.authScope;
    }

    public Credentials getCredentials() {
        return this.credentials;
    }

    public AuthProtocolState getState() {
        return this.state;
    }

    public boolean hasAuthOptions() {
        boolean v0 = this.authOptions == null || (this.authOptions.isEmpty()) ? false : true;
        return v0;
    }

    @Deprecated public void invalidate() {
        this.reset();
    }

    @Deprecated public boolean isValid() {
        boolean v0 = this.authScheme != null ? true : false;
        return v0;
    }

    public void reset() {
        this.state = AuthProtocolState.UNCHALLENGED;
        this.authOptions = null;
        this.authScheme = null;
        this.authScope = null;
        this.credentials = null;
    }

    @Deprecated public void setAuthScheme(AuthScheme arg1) {
        if(arg1 == null) {
            this.reset();
        }
        else {
            this.authScheme = arg1;
        }
    }

    @Deprecated public void setAuthScope(AuthScope arg1) {
        this.authScope = arg1;
    }

    @Deprecated public void setCredentials(Credentials arg1) {
        this.credentials = arg1;
    }

    public void setState(AuthProtocolState arg1) {
        if(arg1 == null) {
            arg1 = AuthProtocolState.UNCHALLENGED;
        }

        this.state = arg1;
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder();
        v0.append("state:").append(this.state).append(";");
        if(this.authScheme != null) {
            v0.append("auth scheme:").append(this.authScheme.getSchemeName()).append(";");
        }

        if(this.credentials != null) {
            v0.append("credentials present");
        }

        return v0.toString();
    }

    public void update(Queue arg3) {
        Args.notEmpty(((Collection)arg3), "Queue of auth options");
        this.authOptions = arg3;
        this.authScheme = null;
        this.credentials = null;
    }

    public void update(AuthScheme arg2, Credentials arg3) {
        Args.notNull(arg2, "Auth scheme");
        Args.notNull(arg3, "Credentials");
        this.authScheme = arg2;
        this.credentials = arg3;
        this.authOptions = null;
    }
}

