// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.entity;

import java.io.File;
import java.io.InputStream;
import java.io.Serializable;
import java.nio.charset.Charset;
import java.util.Arrays;
import java.util.List;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.entity.AbstractHttpEntity;
import org.apache.http.entity.BasicHttpEntity;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.FileEntity;
import org.apache.http.entity.InputStreamEntity;
import org.apache.http.entity.SerializableEntity;
import org.apache.http.entity.StringEntity;

@NotThreadSafe public class EntityBuilder {
    private byte[] binary;
    private boolean chunked;
    private String contentEncoding;
    private ContentType contentType;
    private File file;
    private boolean gzipCompress;
    private List parameters;
    private Serializable serializable;
    private InputStream stream;
    private String text;

    EntityBuilder() {
        super();
    }

    public HttpEntity build() {
        FileEntity v0_6;
        if(this.text != null) {
            StringEntity v0 = new StringEntity(this.text, this.getContentOrDefault(ContentType.DEFAULT_TEXT));
        }
        else if(this.binary != null) {
            ByteArrayEntity v0_1 = new ByteArrayEntity(this.binary, this.getContentOrDefault(ContentType.DEFAULT_BINARY));
        }
        else if(this.stream != null) {
            InputStreamEntity v0_2 = new InputStreamEntity(this.stream, 1, this.getContentOrDefault(ContentType.DEFAULT_BINARY));
        }
        else if(this.parameters != null) {
            List v2 = this.parameters;
            Charset v0_3 = this.contentType != null ? this.contentType.getCharset() : null;
            UrlEncodedFormEntity v0_4 = new UrlEncodedFormEntity(((Iterable)v2), v0_3);
        }
        else {
            if(this.serializable != null) {
                SerializableEntity v0_5 = new SerializableEntity(this.serializable);
                ((AbstractHttpEntity)v0_5).setContentType(ContentType.DEFAULT_BINARY.toString());
                goto label_7;
            }

            if(this.file != null) {
                v0_6 = new FileEntity(this.file, this.getContentOrDefault(ContentType.DEFAULT_BINARY));
                goto label_7;
            }

            BasicHttpEntity v0_7 = new BasicHttpEntity();
        }

    label_7:
        if(((AbstractHttpEntity)v0_6).getContentType() != null && this.contentType != null) {
            ((AbstractHttpEntity)v0_6).setContentType(this.contentType.toString());
        }

        ((AbstractHttpEntity)v0_6).setContentEncoding(this.contentEncoding);
        ((AbstractHttpEntity)v0_6).setChunked(this.chunked);
        if(this.gzipCompress) {
            GzipCompressingEntity v0_8 = new GzipCompressingEntity(((HttpEntity)v0_6));
        }

        return ((HttpEntity)v0_6);
    }

    public EntityBuilder chunked() {
        this.chunked = true;
        return this;
    }

    private void clearContent() {
        this.text = null;
        this.binary = null;
        this.stream = null;
        this.parameters = null;
        this.serializable = null;
        this.file = null;
    }

    public static EntityBuilder create() {
        return new EntityBuilder();
    }

    public byte[] getBinary() {
        return this.binary;
    }

    public String getContentEncoding() {
        return this.contentEncoding;
    }

    private ContentType getContentOrDefault(ContentType arg2) {
        if(this.contentType != null) {
            arg2 = this.contentType;
        }

        return arg2;
    }

    public ContentType getContentType() {
        return this.contentType;
    }

    public File getFile() {
        return this.file;
    }

    public List getParameters() {
        return this.parameters;
    }

    public Serializable getSerializable() {
        return this.serializable;
    }

    public InputStream getStream() {
        return this.stream;
    }

    public String getText() {
        return this.text;
    }

    public EntityBuilder gzipCompress() {
        this.gzipCompress = true;
        return this;
    }

    public boolean isChunked() {
        return this.chunked;
    }

    public boolean isGzipCompress() {
        return this.gzipCompress;
    }

    public EntityBuilder setBinary(byte[] arg1) {
        this.clearContent();
        this.binary = arg1;
        return this;
    }

    public EntityBuilder setContentEncoding(String arg1) {
        this.contentEncoding = arg1;
        return this;
    }

    public EntityBuilder setContentType(ContentType arg1) {
        this.contentType = arg1;
        return this;
    }

    public EntityBuilder setFile(File arg1) {
        this.clearContent();
        this.file = arg1;
        return this;
    }

    public EntityBuilder setParameters(List arg1) {
        this.clearContent();
        this.parameters = arg1;
        return this;
    }

    public EntityBuilder setParameters(NameValuePair[] arg2) {
        return this.setParameters(Arrays.asList(((Object[])arg2)));
    }

    public EntityBuilder setSerializable(Serializable arg1) {
        this.clearContent();
        this.serializable = arg1;
        return this;
    }

    public EntityBuilder setStream(InputStream arg1) {
        this.clearContent();
        this.stream = arg1;
        return this;
    }

    public EntityBuilder setText(String arg1) {
        this.clearContent();
        this.text = arg1;
        return this;
    }
}

