// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.entity;

import java.io.InputStream;
import org.apache.http.annotation.NotThreadSafe;

@NotThreadSafe class LazyDecompressingInputStream extends InputStream {
    private final DecompressingEntity decompressingEntity;
    private final InputStream wrappedStream;
    private InputStream wrapperStream;

    public LazyDecompressingInputStream(InputStream arg1, DecompressingEntity arg2) {
        super();
        this.wrappedStream = arg1;
        this.decompressingEntity = arg2;
    }

    public int available() {
        this.initWrapper();
        return this.wrapperStream.available();
    }

    public void close() {
        try {
            if(this.wrapperStream != null) {
                this.wrapperStream.close();
            }
        }
        catch(Throwable v0) {
            this.wrappedStream.close();
            throw v0;
        }

        this.wrappedStream.close();
    }

    private void initWrapper() {
        if(this.wrapperStream == null) {
            this.wrapperStream = this.decompressingEntity.decorate(this.wrappedStream);
        }
    }

    public boolean markSupported() {
        return 0;
    }

    public int read() {
        this.initWrapper();
        return this.wrapperStream.read();
    }

    public int read(byte[] arg2) {
        this.initWrapper();
        return this.wrapperStream.read(arg2);
    }

    public int read(byte[] arg2, int arg3, int arg4) {
        this.initWrapper();
        return this.wrapperStream.read(arg2, arg3, arg4);
    }

    public long skip(long arg3) {
        this.initWrapper();
        return this.wrapperStream.skip(arg3);
    }
}

