// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.methods;

import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicReference;
import org.apache.http.HttpRequest;
import org.apache.http.client.utils.CloneUtils;
import org.apache.http.concurrent.Cancellable;
import org.apache.http.conn.ClientConnectionRequest;
import org.apache.http.conn.ConnectionReleaseTrigger;
import org.apache.http.message.AbstractHttpMessage;

public abstract class AbstractExecutionAwareRequest extends AbstractHttpMessage implements Cloneable, HttpRequest, AbortableHttpRequest, HttpExecutionAware {
    private final AtomicBoolean aborted;
    private final AtomicReference cancellableRef;

    protected AbstractExecutionAwareRequest() {
        super();
        this.aborted = new AtomicBoolean(false);
        this.cancellableRef = new AtomicReference(null);
    }

    public void abort() {
        if(this.aborted.compareAndSet(false, true)) {
            Object v0 = this.cancellableRef.getAndSet(null);
            if(v0 != null) {
                ((Cancellable)v0).cancel();
            }
        }
    }

    public Object clone() {
        Object v0 = super.clone();
        ((AbstractExecutionAwareRequest)v0).headergroup = CloneUtils.cloneObject(this.headergroup);
        ((AbstractExecutionAwareRequest)v0).params = CloneUtils.cloneObject(this.params);
        return v0;
    }

    public void completed() {
        this.cancellableRef.set(null);
    }

    public boolean isAborted() {
        return this.aborted.get();
    }

    public void reset() {
        Object v0 = this.cancellableRef.getAndSet(null);
        if(v0 != null) {
            ((Cancellable)v0).cancel();
        }

        this.aborted.set(false);
    }

    public void setCancellable(Cancellable arg2) {
        if(!this.aborted.get()) {
            this.cancellableRef.set(arg2);
        }
    }

    @Deprecated public void setConnectionRequest(ClientConnectionRequest arg2) {
        this.setCancellable(new AbstractExecutionAwareRequest$1(this, arg2));
    }

    @Deprecated public void setReleaseTrigger(ConnectionReleaseTrigger arg2) {
        this.setCancellable(new AbstractExecutionAwareRequest$2(this, arg2));
    }
}

