// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.methods;

import java.net.URI;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpRequest;
import org.apache.http.ProtocolVersion;
import org.apache.http.RequestLine;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.message.AbstractHttpMessage;
import org.apache.http.message.BasicRequestLine;
import org.apache.http.params.HttpParams;

@NotThreadSafe public class HttpRequestWrapper extends AbstractHttpMessage implements HttpUriRequest {
    private final String method;
    private final HttpRequest original;
    private URI uri;
    private ProtocolVersion version;

    private HttpRequestWrapper(HttpRequest arg2) {
        super();
        this.original = arg2;
        this.version = this.original.getRequestLine().getProtocolVersion();
        this.method = this.original.getRequestLine().getMethod();
        this.uri = (arg2 instanceof HttpUriRequest) ? arg2.getURI() : null;
        this.setHeaders(arg2.getAllHeaders());
    }

    HttpRequestWrapper(HttpRequest arg1, HttpRequestWrapper$1 arg2) {
        this(arg1);
    }

    public void abort() {
        throw new UnsupportedOperationException();
    }

    public String getMethod() {
        return this.method;
    }

    public HttpRequest getOriginal() {
        return this.original;
    }

    @Deprecated public HttpParams getParams() {
        if(this.params == null) {
            this.params = this.original.getParams().copy();
        }

        return this.params;
    }

    public ProtocolVersion getProtocolVersion() {
        ProtocolVersion v0 = this.version != null ? this.version : this.original.getProtocolVersion();
        return v0;
    }

    public RequestLine getRequestLine() {
        String v0 = this.uri != null ? this.uri.toASCIIString() : this.original.getRequestLine().getUri();
        if(v0 == null || v0.length() == 0) {
            v0 = "/";
        }

        return new BasicRequestLine(this.method, v0, this.getProtocolVersion());
    }

    public URI getURI() {
        return this.uri;
    }

    public boolean isAborted() {
        return 0;
    }

    public void setProtocolVersion(ProtocolVersion arg1) {
        this.version = arg1;
    }

    public void setURI(URI arg1) {
        this.uri = arg1;
    }

    public String toString() {
        return this.getRequestLine() + " " + this.headergroup;
    }

    public static HttpRequestWrapper wrap(HttpRequest arg1) {
        HttpRequestWrapper$HttpEntityEnclosingRequestWrapper v0_1;
        HttpRequestWrapper v0;
        if(arg1 == null) {
            v0 = null;
        }
        else if((arg1 instanceof HttpEntityEnclosingRequest)) {
            v0_1 = new HttpRequestWrapper$HttpEntityEnclosingRequestWrapper(((HttpEntityEnclosingRequest)arg1));
        }
        else {
            v0 = new HttpRequestWrapper(arg1);
        }

        return ((HttpRequestWrapper)v0_1);
    }
}

