// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.methods;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import org.apache.http.Header;
import org.apache.http.HeaderIterator;
import org.apache.http.HttpEntity;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpRequest;
import org.apache.http.NameValuePair;
import org.apache.http.ProtocolVersion;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.message.BasicHeader;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.message.HeaderGroup;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.Args;

@NotThreadSafe public class RequestBuilder {
    private RequestConfig config;
    private HttpEntity entity;
    private HeaderGroup headergroup;
    private String method;
    private LinkedList parameters;
    private URI uri;
    private ProtocolVersion version;

    RequestBuilder() {
        this(null);
    }

    RequestBuilder(String arg1) {
        super();
        this.method = arg1;
    }

    public RequestBuilder addHeader(String arg3, String arg4) {
        if(this.headergroup == null) {
            this.headergroup = new HeaderGroup();
        }

        this.headergroup.addHeader(new BasicHeader(arg3, arg4));
        return this;
    }

    public RequestBuilder addHeader(Header arg2) {
        if(this.headergroup == null) {
            this.headergroup = new HeaderGroup();
        }

        this.headergroup.addHeader(arg2);
        return this;
    }

    public RequestBuilder addParameter(String arg2, String arg3) {
        return this.addParameter(new BasicNameValuePair(arg2, arg3));
    }

    public RequestBuilder addParameter(NameValuePair arg2) {
        Args.notNull(arg2, "Name value pair");
        if(this.parameters == null) {
            this.parameters = new LinkedList();
        }

        this.parameters.add(arg2);
        return this;
    }

    public RequestBuilder addParameters(NameValuePair[] arg4) {
        int v1 = arg4.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            this.addParameter(arg4[v0]);
        }

        return this;
    }

    public HttpUriRequest build() {
        RequestBuilder$InternalEntityEclosingRequest v0_2;
        URI v2;
        URI v0 = this.uri != null ? this.uri : URI.create("/");
        HttpEntity v1 = this.entity;
        if(this.parameters != null && !this.parameters.isEmpty()) {
            if(v1 == null) {
                if(!"POST".equalsIgnoreCase(this.method) && !"PUT".equalsIgnoreCase(this.method)) {
                    goto label_41;
                }

                UrlEncodedFormEntity v1_1 = new UrlEncodedFormEntity(this.parameters, HTTP.DEF_CONTENT_CHARSET);
                v2 = v0;
                goto label_23;
            }

            try {
            label_41:
                v0 = new URIBuilder(v0).addParameters(this.parameters).build();
                v2 = v0;
            }
            catch(URISyntaxException v2_1) {
                v2 = v0;
            }
        }
        else {
            v2 = v0;
        }

    label_23:
        if(v1 == null) {
            RequestBuilder$InternalRequest v0_1 = new RequestBuilder$InternalRequest(this.method);
        }
        else {
            v0_2 = new RequestBuilder$InternalEntityEclosingRequest(this.method);
            v0_2.setEntity(v1);
        }

        ((HttpRequestBase)v0_2).setProtocolVersion(this.version);
        ((HttpRequestBase)v0_2).setURI(v2);
        if(this.headergroup != null) {
            ((HttpRequestBase)v0_2).setHeaders(this.headergroup.getAllHeaders());
        }

        ((HttpRequestBase)v0_2).setConfig(this.config);
        return ((HttpUriRequest)v0_2);
    }

    public static RequestBuilder copy(HttpRequest arg1) {
        Args.notNull(arg1, "HTTP request");
        return new RequestBuilder().doCopy(arg1);
    }

    public static RequestBuilder create(String arg1) {
        Args.notBlank(((CharSequence)arg1), "HTTP method");
        return new RequestBuilder(arg1);
    }

    public static RequestBuilder delete() {
        return new RequestBuilder("DELETE");
    }

    private RequestBuilder doCopy(HttpRequest arg4) {
        LinkedList v2 = null;
        if(arg4 != null) {
            this.method = arg4.getRequestLine().getMethod();
            this.version = arg4.getRequestLine().getProtocolVersion();
            this.uri = (arg4 instanceof HttpUriRequest) ? arg4.getURI() : URI.create(arg4.getRequestLine().getUri());
            if(this.headergroup == null) {
                this.headergroup = new HeaderGroup();
            }

            this.headergroup.clear();
            this.headergroup.setHeaders(arg4.getAllHeaders());
            this.entity = (arg4 instanceof HttpEntityEnclosingRequest) ? arg4.getEntity() : ((HttpEntity)v2);
            this.config = (arg4 instanceof Configurable) ? ((Configurable)arg4).getConfig() : ((RequestConfig)v2);
            this.parameters = v2;
        }

        return this;
    }

    public static RequestBuilder get() {
        return new RequestBuilder("GET");
    }

    public RequestConfig getConfig() {
        return this.config;
    }

    public HttpEntity getEntity() {
        return this.entity;
    }

    public Header getFirstHeader(String arg2) {
        Header v0 = this.headergroup != null ? this.headergroup.getFirstHeader(arg2) : null;
        return v0;
    }

    public Header[] getHeaders(String arg2) {
        Header[] v0 = this.headergroup != null ? this.headergroup.getHeaders(arg2) : null;
        return v0;
    }

    public Header getLastHeader(String arg2) {
        Header v0 = this.headergroup != null ? this.headergroup.getLastHeader(arg2) : null;
        return v0;
    }

    public String getMethod() {
        return this.method;
    }

    public List getParameters() {
        ArrayList v0 = this.parameters != null ? new ArrayList(this.parameters) : new ArrayList();
        return ((List)v0);
    }

    public URI getUri() {
        return this.uri;
    }

    public ProtocolVersion getVersion() {
        return this.version;
    }

    public static RequestBuilder head() {
        return new RequestBuilder("HEAD");
    }

    public static RequestBuilder options() {
        return new RequestBuilder("OPTIONS");
    }

    public static RequestBuilder post() {
        return new RequestBuilder("POST");
    }

    public static RequestBuilder put() {
        return new RequestBuilder("PUT");
    }

    public RequestBuilder removeHeader(Header arg2) {
        if(this.headergroup == null) {
            this.headergroup = new HeaderGroup();
        }

        this.headergroup.removeHeader(arg2);
        return this;
    }

    public RequestBuilder removeHeaders(String arg3) {
        if(arg3 != null && this.headergroup != null) {
            HeaderIterator v0 = this.headergroup.iterator();
            while(v0.hasNext()) {
                if(!arg3.equalsIgnoreCase(v0.nextHeader().getName())) {
                    continue;
                }

                v0.remove();
            }
        }

        return this;
    }

    public RequestBuilder setConfig(RequestConfig arg1) {
        this.config = arg1;
        return this;
    }

    public RequestBuilder setEntity(HttpEntity arg1) {
        this.entity = arg1;
        return this;
    }

    public RequestBuilder setHeader(String arg3, String arg4) {
        if(this.headergroup == null) {
            this.headergroup = new HeaderGroup();
        }

        this.headergroup.updateHeader(new BasicHeader(arg3, arg4));
        return this;
    }

    public RequestBuilder setHeader(Header arg2) {
        if(this.headergroup == null) {
            this.headergroup = new HeaderGroup();
        }

        this.headergroup.updateHeader(arg2);
        return this;
    }

    public RequestBuilder setUri(String arg2) {
        URI v0 = arg2 != null ? URI.create(arg2) : null;
        this.uri = v0;
        return this;
    }

    public RequestBuilder setUri(URI arg1) {
        this.uri = arg1;
        return this;
    }

    public RequestBuilder setVersion(ProtocolVersion arg1) {
        this.version = arg1;
        return this;
    }

    public static RequestBuilder trace() {
        return new RequestBuilder("TRACE");
    }
}

