// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.protocol;

import java.util.List;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.AuthSchemeProvider;
import org.apache.http.auth.AuthState;
import org.apache.http.client.AuthCache;
import org.apache.http.client.CookieStore;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.config.Lookup;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.RouteInfo;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieSpec;
import org.apache.http.cookie.CookieSpecProvider;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpCoreContext;

@NotThreadSafe public class HttpClientContext extends HttpCoreContext {
    public static final String AUTHSCHEME_REGISTRY = "http.authscheme-registry";
    public static final String AUTH_CACHE = "http.auth.auth-cache";
    public static final String COOKIESPEC_REGISTRY = "http.cookiespec-registry";
    public static final String COOKIE_ORIGIN = "http.cookie-origin";
    public static final String COOKIE_SPEC = "http.cookie-spec";
    public static final String COOKIE_STORE = "http.cookie-store";
    public static final String CREDS_PROVIDER = "http.auth.credentials-provider";
    public static final String HTTP_ROUTE = "http.route";
    public static final String PROXY_AUTH_STATE = "http.auth.proxy-scope";
    public static final String REDIRECT_LOCATIONS = "http.protocol.redirect-locations";
    public static final String REQUEST_CONFIG = "http.request-config";
    public static final String TARGET_AUTH_STATE = "http.auth.target-scope";
    public static final String USER_TOKEN = "http.user-token";

    public HttpClientContext() {
        super();
    }

    public HttpClientContext(HttpContext arg1) {
        super(arg1);
    }

    public static HttpClientContext adapt(HttpContext arg1) {
        HttpClientContext v1;
        if(!(arg1 instanceof HttpClientContext)) {
            v1 = new HttpClientContext(arg1);
        }

        return ((HttpContext)v1);
    }

    public static HttpClientContext create() {
        return new HttpClientContext(new BasicHttpContext());
    }

    public AuthCache getAuthCache() {
        return this.getAttribute("http.auth.auth-cache", AuthCache.class);
    }

    public Lookup getAuthSchemeRegistry() {
        return this.getLookup("http.authscheme-registry", AuthSchemeProvider.class);
    }

    public CookieOrigin getCookieOrigin() {
        return this.getAttribute("http.cookie-origin", CookieOrigin.class);
    }

    public CookieSpec getCookieSpec() {
        return this.getAttribute("http.cookie-spec", CookieSpec.class);
    }

    public Lookup getCookieSpecRegistry() {
        return this.getLookup("http.cookiespec-registry", CookieSpecProvider.class);
    }

    public CookieStore getCookieStore() {
        return this.getAttribute("http.cookie-store", CookieStore.class);
    }

    public CredentialsProvider getCredentialsProvider() {
        return this.getAttribute("http.auth.credentials-provider", CredentialsProvider.class);
    }

    public RouteInfo getHttpRoute() {
        return this.getAttribute("http.route", HttpRoute.class);
    }

    private Lookup getLookup(String arg2, Class arg3) {
        return this.getAttribute(arg2, Lookup.class);
    }

    public AuthState getProxyAuthState() {
        return this.getAttribute("http.auth.proxy-scope", AuthState.class);
    }

    public List getRedirectLocations() {
        return this.getAttribute("http.protocol.redirect-locations", List.class);
    }

    public RequestConfig getRequestConfig() {
        Object v0 = this.getAttribute("http.request-config", RequestConfig.class);
        if(v0 == null) {
            RequestConfig v0_1 = RequestConfig.DEFAULT;
        }

        return ((RequestConfig)v0);
    }

    public AuthState getTargetAuthState() {
        return this.getAttribute("http.auth.target-scope", AuthState.class);
    }

    public Object getUserToken() {
        return this.getAttribute("http.user-token");
    }

    public Object getUserToken(Class arg2) {
        return this.getAttribute("http.user-token", arg2);
    }

    public void setAuthCache(AuthCache arg2) {
        this.setAttribute("http.auth.auth-cache", arg2);
    }

    public void setAuthSchemeRegistry(Lookup arg2) {
        this.setAttribute("http.authscheme-registry", arg2);
    }

    public void setCookieSpecRegistry(Lookup arg2) {
        this.setAttribute("http.cookiespec-registry", arg2);
    }

    public void setCookieStore(CookieStore arg2) {
        this.setAttribute("http.cookie-store", arg2);
    }

    public void setCredentialsProvider(CredentialsProvider arg2) {
        this.setAttribute("http.auth.credentials-provider", arg2);
    }

    public void setRequestConfig(RequestConfig arg2) {
        this.setAttribute("http.request-config", arg2);
    }

    public void setUserToken(Object arg2) {
        this.setAttribute("http.user-token", arg2);
    }
}

