// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.protocol;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.CookieStore;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.config.Lookup;
import org.apache.http.conn.routing.RouteInfo;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieSpec;
import org.apache.http.cookie.CookieSpecProvider;
import org.apache.http.cookie.SetCookie2;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.TextUtils;

@Immutable public class RequestAddCookies implements HttpRequestInterceptor {
    private final Log log;

    public RequestAddCookies() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    public void process(HttpRequest arg12, HttpContext arg13) {
        CharSequence v0_3;
        URI v0_1;
        URI v2 = null;
        int v3 = 0;
        Args.notNull(arg12, "HTTP request");
        Args.notNull(arg13, "HTTP context");
        if(!arg12.getRequestLine().getMethod().equalsIgnoreCase("CONNECT")) {
            HttpClientContext v4 = HttpClientContext.adapt(arg13);
            CookieStore v5 = v4.getCookieStore();
            if(v5 == null) {
                this.log.debug("Cookie store not specified in HTTP context");
                return;
            }

            Lookup v6 = v4.getCookieSpecRegistry();
            if(v6 == null) {
                this.log.debug("CookieSpec registry not specified in HTTP context");
                return;
            }

            HttpHost v7 = v4.getTargetHost();
            if(v7 == null) {
                this.log.debug("Target host not set in the context");
                return;
            }

            RouteInfo v8 = v4.getHttpRoute();
            if(v8 == null) {
                this.log.debug("Connection route not set in the context");
                return;
            }

            String v0 = v4.getRequestConfig().getCookieSpec();
            String v1 = v0 == null ? "best-match" : v0;
            if(this.log.isDebugEnabled()) {
                this.log.debug("CookieSpec selected: " + v1);
            }

            if((arg12 instanceof HttpUriRequest)) {
                v0_1 = arg12.getURI();
                goto label_57;
            }

            try {
                v0_1 = new URI(arg12.getRequestLine().getUri());
            }
            catch(URISyntaxException v0_2) {
                v0_1 = v2;
            }

        label_57:
            if(v0_1 != null) {
                v0 = v0_1.getPath();
            }
            else {
                v0_3 = ((CharSequence)v2);
            }

            String v9 = v7.getHostName();
            int v2_1 = v7.getPort();
            if(v2_1 < 0) {
                v2_1 = v8.getTargetHost().getPort();
            }

            if(v2_1 < 0) {
                v2_1 = 0;
            }

            if(TextUtils.isEmpty(v0_3)) {
                v0 = "/";
            }

            CookieOrigin v7_1 = new CookieOrigin(v9, v2_1, ((String)v0_3), v8.isSecure());
            Object v0_4 = v6.lookup(v1);
            if(v0_4 == null) {
                throw new HttpException("Unsupported cookie policy: " + v1);
            }

            CookieSpec v1_1 = ((CookieSpecProvider)v0_4).create(((HttpContext)v4));
            ArrayList v0_5 = new ArrayList(v5.getCookies());
            ArrayList v2_2 = new ArrayList();
            Date v4_1 = new Date();
            Iterator v5_1 = ((List)v0_5).iterator();
            while(v5_1.hasNext()) {
                v0_4 = v5_1.next();
                if(!((Cookie)v0_4).isExpired(v4_1)) {
                    if(!v1_1.match(((Cookie)v0_4), v7_1)) {
                        continue;
                    }

                    if(this.log.isDebugEnabled()) {
                        this.log.debug("Cookie " + v0_4 + " match " + v7_1);
                    }

                    ((List)v2_2).add(v0_4);
                    continue;
                }

                if(!this.log.isDebugEnabled()) {
                    continue;
                }

                this.log.debug("Cookie " + v0_4 + " expired");
            }

            if(!((List)v2_2).isEmpty()) {
                Iterator v4_2 = v1_1.formatCookies(((List)v2_2)).iterator();
                while(v4_2.hasNext()) {
                    arg12.addHeader(v4_2.next());
                }
            }

            int v4_3 = v1_1.getVersion();
            if(v4_3 > 0) {
                Iterator v2_3 = ((List)v2_2).iterator();
                while(v2_3.hasNext()) {
                    v0_4 = v2_3.next();
                    if(v4_3 == ((Cookie)v0_4).getVersion() && ((v0_4 instanceof SetCookie2))) {
                        continue;
                    }

                    v3 = 1;
                }

                if(v3 == 0) {
                    goto label_166;
                }

                Header v0_6 = v1_1.getVersionHeader();
                if(v0_6 == null) {
                    goto label_166;
                }

                arg12.addHeader(v0_6);
            }

        label_166:
            arg13.setAttribute("http.cookie-spec", v1_1);
            arg13.setAttribute("http.cookie-origin", v7_1);
        }
    }
}

