// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.protocol;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.annotation.Immutable;
import org.apache.http.auth.AuthProtocolState;
import org.apache.http.auth.AuthScheme;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.AuthState;
import org.apache.http.auth.Credentials;
import org.apache.http.client.AuthCache;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.conn.routing.RouteInfo;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Immutable public class RequestAuthCache implements HttpRequestInterceptor {
    private final Log log;

    public RequestAuthCache() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    private void doPreemptiveAuth(HttpHost arg5, AuthScheme arg6, AuthState arg7, CredentialsProvider arg8) {
        String v0 = arg6.getSchemeName();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Re-using cached \'" + v0 + "\' auth scheme for " + arg5);
        }

        Credentials v0_1 = arg8.getCredentials(new AuthScope(arg5, AuthScope.ANY_REALM, v0));
        if(v0_1 != null) {
            if("BASIC".equalsIgnoreCase(arg6.getSchemeName())) {
                arg7.setState(AuthProtocolState.CHALLENGED);
            }
            else {
                arg7.setState(AuthProtocolState.SUCCESS);
            }

            arg7.update(arg6, v0_1);
        }
        else {
            this.log.debug("No credentials for preemptive authentication");
        }
    }

    public void process(HttpRequest arg9, HttpContext arg10) {
        Args.notNull(arg9, "HTTP request");
        Args.notNull(arg10, "HTTP context");
        HttpClientContext v2 = HttpClientContext.adapt(arg10);
        AuthCache v3 = v2.getAuthCache();
        if(v3 == null) {
            this.log.debug("Auth cache not set in the context");
        }
        else {
            CredentialsProvider v4 = v2.getCredentialsProvider();
            if(v4 == null) {
                this.log.debug("Credentials provider not set in the context");
            }
            else {
                RouteInfo v5 = v2.getHttpRoute();
                if(v5 == null) {
                    this.log.debug("Route info not set in the context");
                }
                else {
                    HttpHost v1 = v2.getTargetHost();
                    if(v1 == null) {
                        this.log.debug("Target host not set in the context");
                    }
                    else {
                        HttpHost v0 = v1.getPort() < 0 ? new HttpHost(v1.getHostName(), v5.getTargetHost().getPort(), v1.getSchemeName()) : v1;
                        AuthState v1_1 = v2.getTargetAuthState();
                        if(v1_1 != null && v1_1.getState() == AuthProtocolState.UNCHALLENGED) {
                            AuthScheme v6 = v3.get(v0);
                            if(v6 != null) {
                                this.doPreemptiveAuth(v0, v6, v1_1, v4);
                            }
                        }

                        v0 = v5.getProxyHost();
                        v1_1 = v2.getProxyAuthState();
                        if(v0 == null) {
                            return;
                        }

                        if(v1_1 == null) {
                            return;
                        }

                        if(v1_1.getState() != AuthProtocolState.UNCHALLENGED) {
                            return;
                        }

                        AuthScheme v2_1 = v3.get(v0);
                        if(v2_1 == null) {
                            return;
                        }

                        this.doPreemptiveAuth(v0, v2_1, v1_1, v4);
                    }
                }
            }
        }
    }
}

