// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.protocol;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.annotation.Immutable;
import org.apache.http.conn.routing.RouteInfo;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Immutable public class RequestClientConnControl implements HttpRequestInterceptor {
    private static final String PROXY_CONN_DIRECTIVE = "Proxy-Connection";
    private final Log log;

    public RequestClientConnControl() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    public void process(HttpRequest arg4, HttpContext arg5) {
        Args.notNull(arg4, "HTTP request");
        if(arg4.getRequestLine().getMethod().equalsIgnoreCase("CONNECT")) {
            arg4.setHeader("Proxy-Connection", "Keep-Alive");
        }
        else {
            RouteInfo v0 = HttpClientContext.adapt(arg5).getHttpRoute();
            if(v0 == null) {
                this.log.debug("Connection route not set in the context");
            }
            else {
                if((v0.getHopCount() == 1 || (v0.isTunnelled())) && !arg4.containsHeader("Connection")) {
                    arg4.addHeader("Connection", "Keep-Alive");
                }

                if(v0.getHopCount() != 2) {
                    return;
                }

                if(v0.isTunnelled()) {
                    return;
                }

                if(arg4.containsHeader("Proxy-Connection")) {
                    return;
                }

                arg4.addHeader("Proxy-Connection", "Keep-Alive");
            }
        }
    }
}

