// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.protocol;

import java.util.Iterator;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HeaderIterator;
import org.apache.http.HttpResponse;
import org.apache.http.HttpResponseInterceptor;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.CookieStore;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieSpec;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Immutable public class ResponseProcessCookies implements HttpResponseInterceptor {
    private final Log log;

    public ResponseProcessCookies() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    private static String formatCooke(Cookie arg5) {
        int v4 = 100;
        StringBuilder v1 = new StringBuilder();
        v1.append(arg5.getName());
        v1.append("=\"");
        String v0 = arg5.getValue();
        if(v0.length() > v4) {
            v0 = v0.substring(0, v4) + "...";
        }

        v1.append(v0);
        v1.append("\"");
        v1.append(", version:");
        v1.append(Integer.toString(arg5.getVersion()));
        v1.append(", domain:");
        v1.append(arg5.getDomain());
        v1.append(", path:");
        v1.append(arg5.getPath());
        v1.append(", expiry:");
        v1.append(arg5.getExpiryDate());
        return v1.toString();
    }

    public void process(HttpResponse arg5, HttpContext arg6) {
        Args.notNull(arg5, "HTTP request");
        Args.notNull(arg6, "HTTP context");
        HttpClientContext v0 = HttpClientContext.adapt(arg6);
        CookieSpec v1 = v0.getCookieSpec();
        if(v1 == null) {
            this.log.debug("Cookie spec not specified in HTTP context");
        }
        else {
            CookieStore v2 = v0.getCookieStore();
            if(v2 == null) {
                this.log.debug("Cookie store not specified in HTTP context");
            }
            else {
                CookieOrigin v0_1 = v0.getCookieOrigin();
                if(v0_1 == null) {
                    this.log.debug("Cookie origin not specified in HTTP context");
                }
                else {
                    this.processCookies(arg5.headerIterator("Set-Cookie"), v1, v0_1, v2);
                    if(v1.getVersion() > 0) {
                        this.processCookies(arg5.headerIterator("Set-Cookie2"), v1, v0_1, v2);
                    }
                }
            }
        }
    }

    private void processCookies(HeaderIterator arg8, CookieSpec arg9, CookieOrigin arg10, CookieStore arg11) {
        Object v0_1;
    label_0:
        if(arg8.hasNext()) {
            Header v2 = arg8.nextHeader();
            try {
                Iterator v3 = arg9.parse(v2, arg10).iterator();
                while(true) {
                label_5:
                    if(!v3.hasNext()) {
                        goto label_0;
                    }

                    v0_1 = v3.next();
                    break;
                }
            }
            catch(MalformedCookieException v0) {
                goto label_46;
            }

            try {
                arg9.validate(((Cookie)v0_1), arg10);
            }
            catch(MalformedCookieException v0) {
                goto label_46;
            }
            catch(MalformedCookieException v1) {
                goto label_26;
            }

            try {
                arg11.addCookie(((Cookie)v0_1));
                if(!this.log.isDebugEnabled()) {
                    goto label_5;
                }

                this.log.debug("Cookie accepted [" + ResponseProcessCookies.formatCooke(((Cookie)v0_1)) + "]");
                goto label_5;
            }
            catch(MalformedCookieException v1) {
                try {
                label_26:
                    if(!this.log.isWarnEnabled()) {
                        goto label_5;
                    }

                    this.log.warn("Cookie rejected [" + ResponseProcessCookies.formatCooke(((Cookie)v0_1)) + "] " + v1.getMessage());
                    goto label_5;
                }
                catch(MalformedCookieException v0) {
                label_46:
                    if(!this.log.isWarnEnabled()) {
                        goto label_0;
                    }

                    this.log.warn("Invalid cookie header: \"" + v2 + "\". " + v0.getMessage());
                    goto label_0;
                }
            }
        }
    }
}

