// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.utils;

import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import org.apache.http.annotation.Immutable;
import org.apache.http.util.Args;

@Immutable public final class DateUtils {
    private static final String[] DEFAULT_PATTERNS = null;
    private static final Date DEFAULT_TWO_DIGIT_YEAR_START = null;
    public static final TimeZone GMT = null;
    public static final String PATTERN_ASCTIME = "EEE MMM d HH:mm:ss yyyy";
    public static final String PATTERN_RFC1036 = "EEE, dd-MMM-yy HH:mm:ss zzz";
    public static final String PATTERN_RFC1123 = "EEE, dd MMM yyyy HH:mm:ss zzz";

    static {
        DateUtils.DEFAULT_PATTERNS = new String[]{"EEE, dd MMM yyyy HH:mm:ss zzz", "EEE, dd-MMM-yy HH:mm:ss zzz", "EEE MMM d HH:mm:ss yyyy"};
        DateUtils.GMT = TimeZone.getTimeZone("GMT");
        Calendar v0 = Calendar.getInstance();
        v0.setTimeZone(DateUtils.GMT);
        v0.set(2000, 0, 1, 0, 0, 0);
        v0.set(14, 0);
        DateUtils.DEFAULT_TWO_DIGIT_YEAR_START = v0.getTime();
    }

    private DateUtils() {
        super();
    }

    public static void clearThreadLocal() {
        DateUtils$DateFormatHolder.clearThreadLocal();
    }

    public static String formatDate(Date arg1) {
        return DateUtils.formatDate(arg1, "EEE, dd MMM yyyy HH:mm:ss zzz");
    }

    public static String formatDate(Date arg1, String arg2) {
        Args.notNull(arg1, "Date");
        Args.notNull(arg2, "Pattern");
        return DateUtils$DateFormatHolder.formatFor(arg2).format(arg1);
    }

    public static Date parseDate(String arg1) {
        return DateUtils.parseDate(arg1, null, null);
    }

    public static Date parseDate(String arg5, String[] arg6, Date arg7) {
        Date v0_1;
        Args.notNull(arg5, "Date value");
        if(arg6 == null) {
            arg6 = DateUtils.DEFAULT_PATTERNS;
        }

        if(arg7 == null) {
            arg7 = DateUtils.DEFAULT_TWO_DIGIT_YEAR_START;
        }

        if(arg5.length() > 1 && (arg5.startsWith("\'")) && (arg5.endsWith("\'"))) {
            arg5 = arg5.substring(1, arg5.length() - 1);
        }

        int v3 = arg6.length;
        int v1 = 0;
        while(true) {
            if(v1 < v3) {
                SimpleDateFormat v0 = DateUtils$DateFormatHolder.formatFor(arg6[v1]);
                v0.set2DigitYearStart(arg7);
                ParsePosition v4 = new ParsePosition(0);
                v0_1 = v0.parse(arg5, v4);
                if(v4.getIndex() == 0) {
                    ++v1;
                    continue;
                }
            }
            else {
                return null;
            }

            return v0_1;
        }

        return null;
    }

    public static Date parseDate(String arg1, String[] arg2) {
        return DateUtils.parseDate(arg1, arg2, null);
    }
}

