// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.utils;

import java.net.URI;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import org.apache.http.Consts;
import org.apache.http.NameValuePair;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.conn.util.InetAddressUtils;
import org.apache.http.message.BasicNameValuePair;

@NotThreadSafe public class URIBuilder {
    private String encodedAuthority;
    private String encodedFragment;
    private String encodedPath;
    private String encodedQuery;
    private String encodedSchemeSpecificPart;
    private String encodedUserInfo;
    private String fragment;
    private String host;
    private String path;
    private int port;
    private String query;
    private List queryParams;
    private String scheme;
    private String userInfo;

    public URIBuilder(URI arg1) {
        super();
        this.digestURI(arg1);
    }

    public URIBuilder() {
        super();
        this.port = -1;
    }

    public URIBuilder(String arg2) {
        super();
        this.digestURI(new URI(arg2));
    }

    public URIBuilder addParameter(String arg4, String arg5) {
        String v2 = null;
        if(this.queryParams == null) {
            this.queryParams = new ArrayList();
        }

        this.queryParams.add(new BasicNameValuePair(arg4, arg5));
        this.encodedQuery = v2;
        this.encodedSchemeSpecificPart = v2;
        this.query = v2;
        return this;
    }

    public URIBuilder addParameters(List arg3) {
        String v1 = null;
        if(this.queryParams == null) {
            this.queryParams = new ArrayList();
        }

        this.queryParams.addAll(((Collection)arg3));
        this.encodedQuery = v1;
        this.encodedSchemeSpecificPart = v1;
        this.query = v1;
        return this;
    }

    public URI build() {
        return new URI(this.buildString());
    }

    private String buildString() {
        StringBuilder v0 = new StringBuilder();
        if(this.scheme != null) {
            v0.append(this.scheme).append(':');
        }

        if(this.encodedSchemeSpecificPart != null) {
            v0.append(this.encodedSchemeSpecificPart);
        }
        else {
            if(this.encodedAuthority != null) {
                v0.append("//").append(this.encodedAuthority);
            }
            else if(this.host != null) {
                v0.append("//");
                if(this.encodedUserInfo != null) {
                    v0.append(this.encodedUserInfo).append("@");
                }
                else if(this.userInfo != null) {
                    v0.append(this.encodeUserInfo(this.userInfo)).append("@");
                }

                if(InetAddressUtils.isIPv6Address(this.host)) {
                    v0.append("[").append(this.host).append("]");
                }
                else {
                    v0.append(this.host);
                }

                if(this.port < 0) {
                    goto label_26;
                }

                v0.append(":").append(this.port);
            }

        label_26:
            if(this.encodedPath != null) {
                v0.append(URIBuilder.normalizePath(this.encodedPath));
            }
            else if(this.path != null) {
                v0.append(this.encodePath(URIBuilder.normalizePath(this.path)));
            }

            if(this.encodedQuery != null) {
                v0.append("?").append(this.encodedQuery);
                goto label_12;
            }

            if(this.queryParams != null) {
                v0.append("?").append(this.encodeUrlForm(this.queryParams));
                goto label_12;
            }

            if(this.query == null) {
                goto label_12;
            }

            v0.append("?").append(this.encodeUric(this.query));
        }

    label_12:
        if(this.encodedFragment != null) {
            v0.append("#").append(this.encodedFragment);
        }
        else if(this.fragment != null) {
            v0.append("#").append(this.encodeUric(this.fragment));
        }

        return v0.toString();
    }

    public URIBuilder clearParameters() {
        this.queryParams = null;
        this.encodedQuery = null;
        this.encodedSchemeSpecificPart = null;
        return this;
    }

    private void digestURI(URI arg3) {
        this.scheme = arg3.getScheme();
        this.encodedSchemeSpecificPart = arg3.getRawSchemeSpecificPart();
        this.encodedAuthority = arg3.getRawAuthority();
        this.host = arg3.getHost();
        this.port = arg3.getPort();
        this.encodedUserInfo = arg3.getRawUserInfo();
        this.userInfo = arg3.getUserInfo();
        this.encodedPath = arg3.getRawPath();
        this.path = arg3.getPath();
        this.encodedQuery = arg3.getRawQuery();
        this.queryParams = this.parseQuery(arg3.getRawQuery(), Consts.UTF_8);
        this.encodedFragment = arg3.getRawFragment();
        this.fragment = arg3.getFragment();
    }

    private String encodePath(String arg2) {
        return URLEncodedUtils.encPath(arg2, Consts.UTF_8);
    }

    private String encodeUric(String arg2) {
        return URLEncodedUtils.encUric(arg2, Consts.UTF_8);
    }

    private String encodeUrlForm(List arg2) {
        return URLEncodedUtils.format(((Iterable)arg2), Consts.UTF_8);
    }

    private String encodeUserInfo(String arg2) {
        return URLEncodedUtils.encUserInfo(arg2, Consts.UTF_8);
    }

    public String getFragment() {
        return this.fragment;
    }

    public String getHost() {
        return this.host;
    }

    public String getPath() {
        return this.path;
    }

    public int getPort() {
        return this.port;
    }

    public List getQueryParams() {
        ArrayList v0 = this.queryParams != null ? new ArrayList(this.queryParams) : new ArrayList();
        return ((List)v0);
    }

    public String getScheme() {
        return this.scheme;
    }

    public String getUserInfo() {
        return this.userInfo;
    }

    public boolean isAbsolute() {
        boolean v0 = this.scheme != null ? true : false;
        return v0;
    }

    public boolean isOpaque() {
        boolean v0 = this.path == null ? true : false;
        return v0;
    }

    private static String normalizePath(String arg3) {
        if(arg3 == null) {
            arg3 = null;
        }
        else {
            int v0;
            for(v0 = 0; v0 < arg3.length(); ++v0) {
                if(arg3.charAt(v0) != 47) {
                    break;
                }
            }

            if(v0 <= 1) {
                return arg3;
            }

            arg3 = arg3.substring(v0 - 1);
        }

        return arg3;
    }

    private List parseQuery(String arg2, Charset arg3) {
        List v0 = arg2 == null || arg2.length() <= 0 ? null : URLEncodedUtils.parse(arg2, arg3);
        return v0;
    }

    public URIBuilder removeQuery() {
        this.queryParams = null;
        this.query = null;
        this.encodedQuery = null;
        this.encodedSchemeSpecificPart = null;
        return this;
    }

    public URIBuilder setCustomQuery(String arg2) {
        this.query = arg2;
        this.encodedQuery = null;
        this.encodedSchemeSpecificPart = null;
        this.queryParams = null;
        return this;
    }

    public URIBuilder setFragment(String arg2) {
        this.fragment = arg2;
        this.encodedFragment = null;
        return this;
    }

    public URIBuilder setHost(String arg2) {
        this.host = arg2;
        this.encodedSchemeSpecificPart = null;
        this.encodedAuthority = null;
        return this;
    }

    public URIBuilder setParameter(String arg4, String arg5) {
        String v2 = null;
        if(this.queryParams == null) {
            this.queryParams = new ArrayList();
        }

        if(!this.queryParams.isEmpty()) {
            Iterator v1 = this.queryParams.iterator();
            while(v1.hasNext()) {
                if(!v1.next().getName().equals(arg4)) {
                    continue;
                }

                v1.remove();
            }
        }

        this.queryParams.add(new BasicNameValuePair(arg4, arg5));
        this.encodedQuery = v2;
        this.encodedSchemeSpecificPart = v2;
        this.query = v2;
        return this;
    }

    public URIBuilder setParameters(List arg3) {
        String v1 = null;
        if(this.queryParams == null) {
            this.queryParams = new ArrayList();
        }
        else {
            this.queryParams.clear();
        }

        this.queryParams.addAll(((Collection)arg3));
        this.encodedQuery = v1;
        this.encodedSchemeSpecificPart = v1;
        this.query = v1;
        return this;
    }

    public URIBuilder setParameters(NameValuePair[] arg6) {
        String v4 = null;
        if(this.queryParams == null) {
            this.queryParams = new ArrayList();
        }
        else {
            this.queryParams.clear();
        }

        int v1 = arg6.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            this.queryParams.add(arg6[v0]);
        }

        this.encodedQuery = v4;
        this.encodedSchemeSpecificPart = v4;
        this.query = v4;
        return this;
    }

    public URIBuilder setPath(String arg2) {
        this.path = arg2;
        this.encodedSchemeSpecificPart = null;
        this.encodedPath = null;
        return this;
    }

    public URIBuilder setPort(int arg2) {
        String v0 = null;
        if(arg2 < 0) {
            arg2 = -1;
        }

        this.port = arg2;
        this.encodedSchemeSpecificPart = v0;
        this.encodedAuthority = v0;
        return this;
    }

    @Deprecated public URIBuilder setQuery(String arg3) {
        this.queryParams = this.parseQuery(arg3, Consts.UTF_8);
        this.query = null;
        this.encodedQuery = null;
        this.encodedSchemeSpecificPart = null;
        return this;
    }

    public URIBuilder setScheme(String arg1) {
        this.scheme = arg1;
        return this;
    }

    public URIBuilder setUserInfo(String arg2) {
        this.userInfo = arg2;
        this.encodedSchemeSpecificPart = null;
        this.encodedAuthority = null;
        this.encodedUserInfo = null;
        return this;
    }

    public URIBuilder setUserInfo(String arg3, String arg4) {
        return this.setUserInfo(arg3 + ':' + arg4);
    }

    public String toString() {
        return this.buildString();
    }
}

