// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.utils;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Stack;
import org.apache.http.HttpHost;
import org.apache.http.annotation.Immutable;
import org.apache.http.util.Args;
import org.apache.http.util.TextUtils;

@Immutable public class URIUtils {
    private URIUtils() {
        super();
    }

    @Deprecated public static URI createURI(String arg2, String arg3, int arg4, String arg5, String arg6, String arg7) {
        StringBuilder v0 = new StringBuilder();
        if(arg3 != null) {
            if(arg2 != null) {
                v0.append(arg2);
                v0.append("://");
            }

            v0.append(arg3);
            if(arg4 <= 0) {
                goto label_12;
            }

            v0.append(':');
            v0.append(arg4);
        }

    label_12:
        if(arg5 == null || !arg5.startsWith("/")) {
            v0.append('/');
        }

        if(arg5 != null) {
            v0.append(arg5);
        }

        if(arg6 != null) {
            v0.append('?');
            v0.append(arg6);
        }

        if(arg7 != null) {
            v0.append('#');
            v0.append(arg7);
        }

        return new URI(v0.toString());
    }

    public static HttpHost extractHost(URI arg9) {
        HttpHost v0_3;
        String v5;
        HttpHost v6 = null;
        if(arg9 != null) {
            if(arg9.isAbsolute()) {
                int v4 = arg9.getPort();
                String v0 = arg9.getHost();
                if(v0 == null) {
                    v0 = arg9.getAuthority();
                    if(v0 == null) {
                        goto label_43;
                    }

                    int v1 = v0.indexOf(64);
                    if(v1 < 0) {
                        v5 = v0;
                    }
                    else if(v0.length() > v1 + 1) {
                        v5 = v0.substring(v1 + 1);
                    }
                    else {
                        v5 = ((String)v6);
                    }

                    if(v5 != null) {
                        int v7 = v5.indexOf(58);
                        if(v7 >= 0) {
                            v1 = v7 + 1;
                            int v0_1 = v1;
                            int v2 = 0;
                            while(v0_1 < v5.length()) {
                                if(!Character.isDigit(v5.charAt(v0_1))) {
                                    break;
                                }

                                ++v2;
                                ++v0_1;
                            }

                            if(v2 > 0) {
                                v0_1 = v1 + v2;
                                try {
                                    v0_1 = Integer.parseInt(v5.substring(v1, v0_1));
                                }
                                catch(NumberFormatException v0_2) {
                                    v0_1 = v4;
                                }
                            }
                            else {
                                v0_1 = v4;
                            }

                            v4 = v0_1;
                            v0 = v5.substring(0, v7);
                            goto label_43;
                        }
                    }

                    v0 = v5;
                }

            label_43:
                String v2_1 = arg9.getScheme();
                if(TextUtils.isBlank(((CharSequence)v0))) {
                    goto label_54;
                }

                v0_3 = new HttpHost(v0, v4, v2_1);
            }
            else {
            label_54:
                v0_3 = v6;
            }

            v6 = v0_3;
        }

        return v6;
    }

    private static URI normalizeSyntax(URI arg8) {
        URI v0_2;
        char v7 = '/';
        if((arg8.isOpaque()) || arg8.getAuthority() == null) {
            v0_2 = arg8;
        }
        else {
            Args.check(arg8.isAbsolute(), "Base URI must be absolute");
            String v1 = arg8.getPath() == null ? "" : arg8.getPath();
            String[] v2 = v1.split("/");
            Stack v3 = new Stack();
            int v4 = v2.length;
            int v0;
            for(v0 = 0; v0 < v4; ++v0) {
                String v5 = v2[v0];
                if(v5.length() != 0 && !".".equals(v5)) {
                    if(!"..".equals(v5)) {
                        v3.push(v5);
                    }
                    else if(!v3.isEmpty()) {
                        v3.pop();
                    }
                }
            }

            StringBuilder v4_1 = new StringBuilder();
            Iterator v2_1 = v3.iterator();
            while(v2_1.hasNext()) {
                v4_1.append(v7).append(v2_1.next());
            }

            if(v1.lastIndexOf(v7) == v1.length() - 1) {
                v4_1.append(v7);
            }

            try {
                v0_2 = new URI(arg8.getScheme().toLowerCase(Locale.ENGLISH), arg8.getAuthority().toLowerCase(Locale.ENGLISH), v4_1.toString(), null, null);
                if(arg8.getQuery() == null && arg8.getFragment() == null) {
                    return v0_2;
                }

                StringBuilder v1_1 = new StringBuilder(v0_2.toASCIIString());
                if(arg8.getQuery() != null) {
                    v1_1.append('?').append(arg8.getRawQuery());
                }

                if(arg8.getFragment() != null) {
                    v1_1.append('#').append(arg8.getRawFragment());
                }

                v0_2 = URI.create(v1_1.toString());
            }
            catch(URISyntaxException v0_1) {
                throw new IllegalArgumentException(((Throwable)v0_1));
            }
        }

        return v0_2;
    }

    public static URI resolve(URI arg1, String arg2) {
        return URIUtils.resolve(arg1, URI.create(arg2));
    }

    public static URI resolve(URI arg3, URI arg4) {
        URI v0_1;
        Args.notNull(arg3, "Base URI");
        Args.notNull(arg4, "Reference URI");
        String v0 = arg4.toString();
        if(v0.startsWith("?")) {
            v0_1 = URIUtils.resolveReferenceStartingWithQueryString(arg3, arg4);
        }
        else {
            int v1 = v0.length() == 0 ? 1 : 0;
            if(v1 != 0) {
                arg4 = URI.create("#");
            }

            v0_1 = arg3.resolve(arg4);
            if(v1 != 0) {
                v0 = v0_1.toString();
                v0_1 = URI.create(v0.substring(0, v0.indexOf(35)));
            }

            v0_1 = URIUtils.normalizeSyntax(v0_1);
        }

        return v0_1;
    }

    public static URI resolve(URI arg5, HttpHost arg6, List arg7) {
        URIBuilder v0_1;
        Args.notNull(arg5, "Request URI");
        if(arg7 == null || (arg7.isEmpty())) {
            v0_1 = new URIBuilder(arg5);
        }
        else {
            URIBuilder v1 = new URIBuilder(arg7.get(arg7.size() - 1));
            String v0 = v1.getFragment();
            int v2 = arg7.size() - 1;
            while(v0 == null) {
                if(v2 < 0) {
                    break;
                }

                String v3 = arg7.get(v2).getFragment();
                --v2;
                v0 = v3;
            }

            v1.setFragment(v0);
            v0_1 = v1;
        }

        if(v0_1.getFragment() == null) {
            v0_1.setFragment(arg5.getFragment());
        }

        if(arg6 != null && !v0_1.isAbsolute()) {
            v0_1.setScheme(arg6.getSchemeName());
            v0_1.setHost(arg6.getHostName());
            v0_1.setPort(arg6.getPort());
        }

        return v0_1.build();
    }

    private static URI resolveReferenceStartingWithQueryString(URI arg4, URI arg5) {
        int v3 = 63;
        String v0 = arg4.toString();
        if(v0.indexOf(v3) > -1) {
            v0 = v0.substring(0, v0.indexOf(v3));
        }

        return URI.create(v0 + arg5.toString());
    }

    public static URI rewriteURI(URI arg4) {
        String v3 = null;
        Args.notNull(arg4, "URI");
        if(!arg4.isOpaque()) {
            URIBuilder v0 = new URIBuilder(arg4);
            if(v0.getUserInfo() != null) {
                v0.setUserInfo(v3);
            }

            if(TextUtils.isEmpty(v0.getPath())) {
                v0.setPath("/");
            }

            if(v0.getHost() != null) {
                v0.setHost(v0.getHost().toLowerCase(Locale.ENGLISH));
            }

            v0.setFragment(v3);
            arg4 = v0.build();
        }

        return arg4;
    }

    public static URI rewriteURI(URI arg1, HttpHost arg2) {
        return URIUtils.rewriteURI(arg1, arg2, false);
    }

    public static URI rewriteURI(URI arg3, HttpHost arg4, boolean arg5) {
        String v2 = null;
        Args.notNull(arg3, "URI");
        if(!arg3.isOpaque()) {
            URIBuilder v0 = new URIBuilder(arg3);
            if(arg4 != null) {
                v0.setScheme(arg4.getSchemeName());
                v0.setHost(arg4.getHostName());
                v0.setPort(arg4.getPort());
            }
            else {
                v0.setScheme(v2);
                v0.setHost(v2);
                v0.setPort(-1);
            }

            if(arg5) {
                v0.setFragment(v2);
            }

            if(TextUtils.isEmpty(v0.getPath())) {
                v0.setPath("/");
            }

            arg3 = v0.build();
        }

        return arg3;
    }
}

