// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.client.utils;

import java.net.URI;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;
import org.apache.http.Consts;
import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.annotation.Immutable;
import org.apache.http.entity.ContentType;
import org.apache.http.message.BasicHeaderValueParser;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.message.ParserCursor;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.CharArrayBuffer;
import org.apache.http.util.EntityUtils;

@Immutable public class URLEncodedUtils {
    public static final String CONTENT_TYPE = "application/x-www-form-urlencoded";
    private static final String NAME_VALUE_SEPARATOR = "=";
    private static final BitSet PATHSAFE = null;
    private static final BitSet PUNCT = null;
    private static final char[] QP_SEPS = null;
    private static final char QP_SEP_A = '&';
    private static final String QP_SEP_PATTERN = null;
    private static final char QP_SEP_S = ';';
    private static final int RADIX = 16;
    private static final BitSet RESERVED;
    private static final BitSet UNRESERVED;
    private static final BitSet URIC;
    private static final BitSet URLENCODER;
    private static final BitSet USERINFO;

    static {
        int v7 = 44;
        int v6 = 43;
        int v5 = 38;
        int v4 = 36;
        URLEncodedUtils.QP_SEPS = new char[]{'&', ';'};
        URLEncodedUtils.QP_SEP_PATTERN = "[" + new String(URLEncodedUtils.QP_SEPS) + "]";
        URLEncodedUtils.UNRESERVED = new BitSet(256);
        URLEncodedUtils.PUNCT = new BitSet(256);
        URLEncodedUtils.USERINFO = new BitSet(256);
        URLEncodedUtils.PATHSAFE = new BitSet(256);
        URLEncodedUtils.URIC = new BitSet(256);
        URLEncodedUtils.RESERVED = new BitSet(256);
        URLEncodedUtils.URLENCODER = new BitSet(256);
        int v0;
        for(v0 = 97; v0 <= 122; ++v0) {
            URLEncodedUtils.UNRESERVED.set(v0);
        }

        for(v0 = 65; v0 <= 90; ++v0) {
            URLEncodedUtils.UNRESERVED.set(v0);
        }

        for(v0 = 48; v0 <= 57; ++v0) {
            URLEncodedUtils.UNRESERVED.set(v0);
        }

        URLEncodedUtils.UNRESERVED.set(95);
        URLEncodedUtils.UNRESERVED.set(45);
        URLEncodedUtils.UNRESERVED.set(46);
        URLEncodedUtils.UNRESERVED.set(42);
        URLEncodedUtils.URLENCODER.or(URLEncodedUtils.UNRESERVED);
        URLEncodedUtils.UNRESERVED.set(33);
        URLEncodedUtils.UNRESERVED.set(126);
        URLEncodedUtils.UNRESERVED.set(39);
        URLEncodedUtils.UNRESERVED.set(40);
        URLEncodedUtils.UNRESERVED.set(41);
        URLEncodedUtils.PUNCT.set(v7);
        URLEncodedUtils.PUNCT.set(59);
        URLEncodedUtils.PUNCT.set(58);
        URLEncodedUtils.PUNCT.set(v4);
        URLEncodedUtils.PUNCT.set(v5);
        URLEncodedUtils.PUNCT.set(v6);
        URLEncodedUtils.PUNCT.set(61);
        URLEncodedUtils.USERINFO.or(URLEncodedUtils.UNRESERVED);
        URLEncodedUtils.USERINFO.or(URLEncodedUtils.PUNCT);
        URLEncodedUtils.PATHSAFE.or(URLEncodedUtils.UNRESERVED);
        URLEncodedUtils.PATHSAFE.set(47);
        URLEncodedUtils.PATHSAFE.set(59);
        URLEncodedUtils.PATHSAFE.set(58);
        URLEncodedUtils.PATHSAFE.set(64);
        URLEncodedUtils.PATHSAFE.set(v5);
        URLEncodedUtils.PATHSAFE.set(61);
        URLEncodedUtils.PATHSAFE.set(v6);
        URLEncodedUtils.PATHSAFE.set(v4);
        URLEncodedUtils.PATHSAFE.set(v7);
        URLEncodedUtils.RESERVED.set(59);
        URLEncodedUtils.RESERVED.set(47);
        URLEncodedUtils.RESERVED.set(63);
        URLEncodedUtils.RESERVED.set(58);
        URLEncodedUtils.RESERVED.set(64);
        URLEncodedUtils.RESERVED.set(v5);
        URLEncodedUtils.RESERVED.set(61);
        URLEncodedUtils.RESERVED.set(v6);
        URLEncodedUtils.RESERVED.set(v4);
        URLEncodedUtils.RESERVED.set(v7);
        URLEncodedUtils.RESERVED.set(91);
        URLEncodedUtils.RESERVED.set(93);
        URLEncodedUtils.URIC.or(URLEncodedUtils.RESERVED);
        URLEncodedUtils.URIC.or(URLEncodedUtils.UNRESERVED);
    }

    public URLEncodedUtils() {
        super();
    }

    private static String decodeFormFields(String arg2, String arg3) {
        String v0;
        if(arg2 == null) {
            v0 = null;
        }
        else {
            Charset v0_1 = arg3 != null ? Charset.forName(arg3) : Consts.UTF_8;
            v0 = URLEncodedUtils.urlDecode(arg2, v0_1, true);
        }

        return v0;
    }

    private static String decodeFormFields(String arg1, Charset arg2) {
        String v0;
        if(arg1 == null) {
            v0 = null;
        }
        else {
            if(arg2 == null) {
                arg2 = Consts.UTF_8;
            }

            v0 = URLEncodedUtils.urlDecode(arg1, arg2, true);
        }

        return v0;
    }

    static String encPath(String arg2, Charset arg3) {
        return URLEncodedUtils.urlEncode(arg2, arg3, URLEncodedUtils.PATHSAFE, false);
    }

    static String encUric(String arg2, Charset arg3) {
        return URLEncodedUtils.urlEncode(arg2, arg3, URLEncodedUtils.URIC, false);
    }

    static String encUserInfo(String arg2, Charset arg3) {
        return URLEncodedUtils.urlEncode(arg2, arg3, URLEncodedUtils.USERINFO, false);
    }

    private static String encodeFormFields(String arg3, String arg4) {
        String v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            Charset v0_1 = arg4 != null ? Charset.forName(arg4) : Consts.UTF_8;
            v0 = URLEncodedUtils.urlEncode(arg3, v0_1, URLEncodedUtils.URLENCODER, true);
        }

        return v0;
    }

    private static String encodeFormFields(String arg2, Charset arg3) {
        String v0;
        if(arg2 == null) {
            v0 = null;
        }
        else {
            if(arg3 == null) {
                arg3 = Consts.UTF_8;
            }

            v0 = URLEncodedUtils.urlEncode(arg2, arg3, URLEncodedUtils.URLENCODER, true);
        }

        return v0;
    }

    public static String format(Iterable arg1, Charset arg2) {
        return URLEncodedUtils.format(arg1, '&', arg2);
    }

    public static String format(List arg1, String arg2) {
        return URLEncodedUtils.format(arg1, '&', arg2);
    }

    public static String format(Iterable arg5, char arg6, Charset arg7) {
        StringBuilder v1 = new StringBuilder();
        Iterator v2 = arg5.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            String v3 = URLEncodedUtils.encodeFormFields(((NameValuePair)v0).getName(), arg7);
            String v0_1 = URLEncodedUtils.encodeFormFields(((NameValuePair)v0).getValue(), arg7);
            if(v1.length() > 0) {
                v1.append(arg6);
            }

            v1.append(v3);
            if(v0_1 == null) {
                continue;
            }

            v1.append("=");
            v1.append(v0_1);
        }

        return v1.toString();
    }

    public static String format(List arg5, char arg6, String arg7) {
        StringBuilder v1 = new StringBuilder();
        Iterator v2 = arg5.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            String v3 = URLEncodedUtils.encodeFormFields(((NameValuePair)v0).getName(), arg7);
            String v0_1 = URLEncodedUtils.encodeFormFields(((NameValuePair)v0).getValue(), arg7);
            if(v1.length() > 0) {
                v1.append(arg6);
            }

            v1.append(v3);
            if(v0_1 == null) {
                continue;
            }

            v1.append("=");
            v1.append(v0_1);
        }

        return v1.toString();
    }

    public static boolean isEncoded(HttpEntity arg3) {
        boolean v0 = false;
        Header v1 = arg3.getContentType();
        if(v1 != null) {
            HeaderElement[] v1_1 = v1.getElements();
            if(v1_1.length > 0) {
                v0 = v1_1[0].getName().equalsIgnoreCase("application/x-www-form-urlencoded");
            }
        }

        return v0;
    }

    public static List parse(String arg1, Charset arg2) {
        return URLEncodedUtils.parse(arg1, arg2, URLEncodedUtils.QP_SEPS);
    }

    public static List parse(String arg7, Charset arg8, char[] arg9) {
        ArrayList v0_1;
        if(arg7 == null) {
            List v0 = Collections.emptyList();
        }
        else {
            BasicHeaderValueParser v1 = BasicHeaderValueParser.INSTANCE;
            CharArrayBuffer v2 = new CharArrayBuffer(arg7.length());
            v2.append(arg7);
            ParserCursor v3 = new ParserCursor(0, v2.length());
            v0_1 = new ArrayList();
            while(!v3.atEnd()) {
                NameValuePair v4 = v1.parseNameValuePair(v2, v3, arg9);
                if(v4.getName().length() <= 0) {
                    continue;
                }

                ((List)v0_1).add(new BasicNameValuePair(URLEncodedUtils.decodeFormFields(v4.getName(), arg8), URLEncodedUtils.decodeFormFields(v4.getValue(), arg8)));
            }
        }

        return ((List)v0_1);
    }

    public static List parse(URI arg3, String arg4) {
        List v0_1;
        String v1 = arg3.getRawQuery();
        if(v1 == null || v1.length() <= 0) {
            v0_1 = Collections.emptyList();
        }
        else {
            ArrayList v0 = new ArrayList();
            URLEncodedUtils.parse(((List)v0), new Scanner(v1), URLEncodedUtils.QP_SEP_PATTERN, arg4);
        }

        return v0_1;
    }

    public static void parse(List arg4, Scanner arg5, String arg6, String arg7) {
        String v1;
        arg5.useDelimiter(arg6);
        while(arg5.hasNext()) {
            String v0 = null;
            String v2 = arg5.next();
            int v3 = v2.indexOf("=");
            if(v3 != -1) {
                v1 = URLEncodedUtils.decodeFormFields(v2.substring(0, v3).trim(), arg7);
                v0 = URLEncodedUtils.decodeFormFields(v2.substring(v3 + 1).trim(), arg7);
            }
            else {
                v1 = URLEncodedUtils.decodeFormFields(v2.trim(), arg7);
            }

            arg4.add(new BasicNameValuePair(v1, v0));
        }
    }

    public static List parse(HttpEntity arg3) {
        List v0_2;
        ContentType v0 = ContentType.get(arg3);
        if(v0 == null || !v0.getMimeType().equalsIgnoreCase("application/x-www-form-urlencoded")) {
        label_17:
            v0_2 = Collections.emptyList();
        }
        else {
            String v1 = EntityUtils.toString(arg3, Consts.ASCII);
            if(v1 == null) {
                goto label_17;
            }
            else if(v1.length() > 0) {
                Charset v0_1 = v0.getCharset();
                if(v0_1 == null) {
                    v0_1 = HTTP.DEF_CONTENT_CHARSET;
                }

                v0_2 = URLEncodedUtils.parse(v1, v0_1, URLEncodedUtils.QP_SEPS);
            }
            else {
                goto label_17;
            }
        }

        return v0_2;
    }

    public static void parse(List arg1, Scanner arg2, String arg3) {
        URLEncodedUtils.parse(arg1, arg2, URLEncodedUtils.QP_SEP_PATTERN, arg3);
    }

    private static String urlDecode(String arg9, Charset arg10, boolean arg11) {
        String v0;
        byte v8 = 37;
        int v7 = 16;
        int v6 = -1;
        if(arg9 == null) {
            v0 = null;
        }
        else {
            ByteBuffer v0_1 = ByteBuffer.allocate(arg9.length());
            CharBuffer v1 = CharBuffer.wrap(((CharSequence)arg9));
            while(v1.hasRemaining()) {
                int v2 = v1.get();
                if(v2 == v8 && v1.remaining() >= 2) {
                    char v2_1 = v1.get();
                    char v3 = v1.get();
                    int v4 = Character.digit(v2_1, v7);
                    int v5 = Character.digit(v3, v7);
                    if(v4 != v6 && v5 != v6) {
                        v0_1.put(((byte)((v4 << 4) + v5)));
                        continue;
                    }

                    v0_1.put(v8);
                    v0_1.put(((byte)v2_1));
                    v0_1.put(((byte)v3));
                    continue;
                }

                if((arg11) && v2 == 43) {
                    v0_1.put(32);
                    continue;
                }

                v0_1.put(((byte)v2));
            }

            v0_1.flip();
            v0 = arg10.decode(v0_1).toString();
        }

        return v0;
    }

    private static String urlEncode(String arg5, Charset arg6, BitSet arg7, boolean arg8) {
        String v0;
        int v4 = 16;
        if(arg5 == null) {
            v0 = null;
        }
        else {
            StringBuilder v0_1 = new StringBuilder();
            ByteBuffer v1 = arg6.encode(arg5);
            while(v1.hasRemaining()) {
                int v2 = v1.get() & 255;
                if(arg7.get(v2)) {
                    v0_1.append(((char)v2));
                }
                else {
                    if((arg8) && v2 == 32) {
                        v0_1.append('+');
                        continue;
                    }

                    v0_1.append("%");
                    char v3 = Character.toUpperCase(Character.forDigit(v2 >> 4 & 15, v4));
                    char v2_1 = Character.toUpperCase(Character.forDigit(v2 & 15, v4));
                    v0_1.append(v3);
                    v0_1.append(v2_1);
                }
            }

            v0 = v0_1.toString();
        }

        return v0;
    }
}

