// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn;

import java.io.IOException;
import java.io.InputStream;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.util.Args;

@NotThreadSafe public class EofSensorInputStream extends InputStream implements ConnectionReleaseTrigger {
    private final EofSensorWatcher eofWatcher;
    private boolean selfClosed;
    protected InputStream wrappedStream;

    public EofSensorInputStream(InputStream arg2, EofSensorWatcher arg3) {
        super();
        Args.notNull(arg2, "Wrapped stream");
        this.wrappedStream = arg2;
        this.selfClosed = false;
        this.eofWatcher = arg3;
    }

    public void abortConnection() {
        this.selfClosed = true;
        this.checkAbort();
    }

    public int available() {
        int v0 = 0;
        if(this.isReadAllowed()) {
            try {
                v0 = this.wrappedStream.available();
            }
            catch(IOException v0_1) {
                this.checkAbort();
                throw v0_1;
            }
        }

        return v0;
    }

    protected void checkAbort() {
        InputStream v2 = null;
        if(this.wrappedStream != null) {
            boolean v0 = true;
            try {
                if(this.eofWatcher != null) {
                    v0 = this.eofWatcher.streamAbort(this.wrappedStream);
                }

                if(v0) {
                    this.wrappedStream.close();
                }
            }
            catch(Throwable v0_1) {
                this.wrappedStream = v2;
                throw v0_1;
            }

            this.wrappedStream = v2;
        }
    }

    protected void checkClose() {
        InputStream v2 = null;
        if(this.wrappedStream != null) {
            boolean v0 = true;
            try {
                if(this.eofWatcher != null) {
                    v0 = this.eofWatcher.streamClosed(this.wrappedStream);
                }

                if(v0) {
                    this.wrappedStream.close();
                }
            }
            catch(Throwable v0_1) {
                this.wrappedStream = v2;
                throw v0_1;
            }

            this.wrappedStream = v2;
        }
    }

    protected void checkEOF(int arg4) {
        InputStream v2 = null;
        if(this.wrappedStream != null && arg4 < 0) {
            boolean v0 = true;
            try {
                if(this.eofWatcher != null) {
                    v0 = this.eofWatcher.eofDetected(this.wrappedStream);
                }

                if(v0) {
                    this.wrappedStream.close();
                }
            }
            catch(Throwable v0_1) {
                this.wrappedStream = v2;
                throw v0_1;
            }

            this.wrappedStream = v2;
        }
    }

    public void close() {
        this.selfClosed = true;
        this.checkClose();
    }

    InputStream getWrappedStream() {
        return this.wrappedStream;
    }

    protected boolean isReadAllowed() {
        if(this.selfClosed) {
            throw new IOException("Attempted read on closed stream.");
        }

        boolean v0 = this.wrappedStream != null ? true : false;
        return v0;
    }

    boolean isSelfClosed() {
        return this.selfClosed;
    }

    public int read() {
        int v0 = -1;
        if(this.isReadAllowed()) {
            try {
                v0 = this.wrappedStream.read();
                this.checkEOF(v0);
            }
            catch(IOException v0_1) {
                this.checkAbort();
                throw v0_1;
            }
        }

        return v0;
    }

    public int read(byte[] arg3) {
        return this.read(arg3, 0, arg3.length);
    }

    public int read(byte[] arg3, int arg4, int arg5) {
        int v0 = -1;
        if(this.isReadAllowed()) {
            try {
                v0 = this.wrappedStream.read(arg3, arg4, arg5);
                this.checkEOF(v0);
            }
            catch(IOException v0_1) {
                this.checkAbort();
                throw v0_1;
            }
        }

        return v0;
    }

    public void releaseConnection() {
        this.close();
    }
}

