// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.routing;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import org.apache.http.HttpHost;
import org.apache.http.annotation.Immutable;
import org.apache.http.util.Args;
import org.apache.http.util.LangUtils;

@Immutable public final class HttpRoute implements Cloneable, RouteInfo {
    private final RouteInfo$LayerType layered;
    private final InetAddress localAddress;
    private final List proxyChain;
    private final boolean secure;
    private final HttpHost targetHost;
    private final RouteInfo$TunnelType tunnelled;

    public HttpRoute(HttpHost arg8) {
        this(arg8, null, Collections.emptyList(), false, RouteInfo$TunnelType.PLAIN, RouteInfo$LayerType.PLAIN);
    }

    private HttpRoute(HttpHost arg3, InetAddress arg4, List arg5, boolean arg6, RouteInfo$TunnelType arg7, RouteInfo$LayerType arg8) {
        super();
        Args.notNull(arg3, "Target host");
        this.targetHost = arg3;
        this.localAddress = arg4;
        this.proxyChain = arg5 == null || (arg5.isEmpty()) ? null : new ArrayList(((Collection)arg5));
        if(arg7 == RouteInfo$TunnelType.TUNNELLED) {
            boolean v0 = this.proxyChain != null ? true : false;
            Args.check(v0, "Proxy required if tunnelled");
        }

        this.secure = arg6;
        if(arg7 == null) {
            arg7 = RouteInfo$TunnelType.PLAIN;
        }

        this.tunnelled = arg7;
        if(arg8 == null) {
            arg8 = RouteInfo$LayerType.PLAIN;
        }

        this.layered = arg8;
    }

    public HttpRoute(HttpHost arg8, InetAddress arg9, HttpHost arg10, boolean arg11) {
        List v3 = Collections.singletonList(Args.notNull(arg10, "Proxy host"));
        RouteInfo$TunnelType v5 = arg11 ? RouteInfo$TunnelType.TUNNELLED : RouteInfo$TunnelType.PLAIN;
        RouteInfo$LayerType v6 = arg11 ? RouteInfo$LayerType.LAYERED : RouteInfo$LayerType.PLAIN;
        this(arg8, arg9, v3, arg11, v5, v6);
    }

    public HttpRoute(HttpHost arg8, InetAddress arg9, HttpHost arg10, boolean arg11, RouteInfo$TunnelType arg12, RouteInfo$LayerType arg13) {
        List v3 = arg10 != null ? Collections.singletonList(arg10) : null;
        this(arg8, arg9, v3, arg11, arg12, arg13);
    }

    public HttpRoute(HttpHost arg8, InetAddress arg9, boolean arg10) {
        this(arg8, arg9, Collections.emptyList(), arg10, RouteInfo$TunnelType.PLAIN, RouteInfo$LayerType.PLAIN);
    }

    public HttpRoute(HttpHost arg8, InetAddress arg9, HttpHost[] arg10, boolean arg11, RouteInfo$TunnelType arg12, RouteInfo$LayerType arg13) {
        List v3 = arg10 != null ? Arrays.asList(((Object[])arg10)) : null;
        this(arg8, arg9, v3, arg11, arg12, arg13);
    }

    public HttpRoute(HttpHost arg3, HttpHost arg4) {
        this(arg3, null, arg4, false);
    }

    public Object clone() {
        return super.clone();
    }

    public final boolean equals(Object arg5) {
        boolean v0 = true;
        if(this != (((HttpRoute)arg5))) {
            if((arg5 instanceof HttpRoute)) {
                if(this.secure == ((HttpRoute)arg5).secure && this.tunnelled == ((HttpRoute)arg5).tunnelled && this.layered == ((HttpRoute)arg5).layered && (LangUtils.equals(this.targetHost, ((HttpRoute)arg5).targetHost)) && (LangUtils.equals(this.localAddress, ((HttpRoute)arg5).localAddress)) && (LangUtils.equals(this.proxyChain, ((HttpRoute)arg5).proxyChain))) {
                    return v0;
                }

                v0 = false;
            }
            else {
                v0 = false;
            }
        }

        return v0;
    }

    public final int getHopCount() {
        int v0 = this.proxyChain != null ? this.proxyChain.size() + 1 : 1;
        return v0;
    }

    public final HttpHost getHopTarget(int arg4) {
        Object v0_1;
        Args.notNegative(arg4, "Hop index");
        int v1 = this.getHopCount();
        boolean v0 = arg4 < v1 ? true : false;
        Args.check(v0, "Hop index exceeds tracked route length");
        if(arg4 < v1 - 1) {
            v0_1 = this.proxyChain.get(arg4);
        }
        else {
            HttpHost v0_2 = this.targetHost;
        }

        return ((HttpHost)v0_1);
    }

    public final RouteInfo$LayerType getLayerType() {
        return this.layered;
    }

    public final InetAddress getLocalAddress() {
        return this.localAddress;
    }

    public final InetSocketAddress getLocalSocketAddress() {
        InetSocketAddress v0 = this.localAddress != null ? new InetSocketAddress(this.localAddress, 0) : null;
        return v0;
    }

    public final HttpHost getProxyHost() {
        Object v0;
        if(this.proxyChain == null || (this.proxyChain.isEmpty())) {
            HttpHost v0_1 = null;
        }
        else {
            v0 = this.proxyChain.get(0);
        }

        return ((HttpHost)v0);
    }

    public final HttpHost getTargetHost() {
        return this.targetHost;
    }

    public final RouteInfo$TunnelType getTunnelType() {
        return this.tunnelled;
    }

    public final int hashCode() {
        int v0 = LangUtils.hashCode(LangUtils.hashCode(17, this.targetHost), this.localAddress);
        if(this.proxyChain != null) {
            Iterator v2 = this.proxyChain.iterator();
            int v1;
            for(v1 = v0; v2.hasNext(); v1 = LangUtils.hashCode(v1, v2.next())) {
            }
        }
        else {
            v1 = v0;
        }

        return LangUtils.hashCode(LangUtils.hashCode(LangUtils.hashCode(v1, this.secure), this.tunnelled), this.layered);
    }

    public final boolean isLayered() {
        boolean v0 = this.layered == RouteInfo$LayerType.LAYERED ? true : false;
        return v0;
    }

    public final boolean isSecure() {
        return this.secure;
    }

    public final boolean isTunnelled() {
        boolean v0 = this.tunnelled == RouteInfo$TunnelType.TUNNELLED ? true : false;
        return v0;
    }

    public final String toString() {
        StringBuilder v1 = new StringBuilder(this.getHopCount() * 30 + 50);
        if(this.localAddress != null) {
            v1.append(this.localAddress);
            v1.append("->");
        }

        v1.append('{');
        if(this.tunnelled == RouteInfo$TunnelType.TUNNELLED) {
            v1.append('t');
        }

        if(this.layered == RouteInfo$LayerType.LAYERED) {
            v1.append('l');
        }

        if(this.secure) {
            v1.append('s');
        }

        v1.append("}->");
        if(this.proxyChain != null) {
            Iterator v2 = this.proxyChain.iterator();
            while(v2.hasNext()) {
                v1.append(v2.next());
                v1.append("->");
            }
        }

        v1.append(this.targetHost);
        return v1.toString();
    }
}

