// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.routing;

import java.net.InetAddress;
import org.apache.http.HttpHost;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;
import org.apache.http.util.LangUtils;

@NotThreadSafe public final class RouteTracker implements Cloneable, RouteInfo {
    private boolean connected;
    private RouteInfo$LayerType layered;
    private final InetAddress localAddress;
    private HttpHost[] proxyChain;
    private boolean secure;
    private final HttpHost targetHost;
    private RouteInfo$TunnelType tunnelled;

    public RouteTracker(HttpHost arg2, InetAddress arg3) {
        super();
        Args.notNull(arg2, "Target host");
        this.targetHost = arg2;
        this.localAddress = arg3;
        this.tunnelled = RouteInfo$TunnelType.PLAIN;
        this.layered = RouteInfo$LayerType.PLAIN;
    }

    public RouteTracker(HttpRoute arg3) {
        this(arg3.getTargetHost(), arg3.getLocalAddress());
    }

    public Object clone() {
        return super.clone();
    }

    public final void connectProxy(HttpHost arg5, boolean arg6) {
        Args.notNull(arg5, "Proxy host");
        boolean v0 = !this.connected ? true : false;
        Asserts.check(v0, "Already connected");
        this.connected = true;
        this.proxyChain = new HttpHost[]{arg5};
        this.secure = arg6;
    }

    public final void connectTarget(boolean arg4) {
        boolean v0 = !this.connected ? true : false;
        Asserts.check(v0, "Already connected");
        this.connected = true;
        this.secure = arg4;
    }

    public final boolean equals(Object arg5) {
        boolean v0 = true;
        if((((RouteTracker)arg5)) != this) {
            if(!(arg5 instanceof RouteTracker)) {
                v0 = false;
            }
            else {
                if(this.connected == ((RouteTracker)arg5).connected && this.secure == ((RouteTracker)arg5).secure && this.tunnelled == ((RouteTracker)arg5).tunnelled && this.layered == ((RouteTracker)arg5).layered && (LangUtils.equals(this.targetHost, ((RouteTracker)arg5).targetHost)) && (LangUtils.equals(this.localAddress, ((RouteTracker)arg5).localAddress)) && (LangUtils.equals(this.proxyChain, ((RouteTracker)arg5).proxyChain))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public final int getHopCount() {
        int v0 = 0;
        if(this.connected) {
            v0 = this.proxyChain == null ? 1 : this.proxyChain.length + 1;
        }

        return v0;
    }

    public final HttpHost getHopTarget(int arg4) {
        Args.notNegative(arg4, "Hop index");
        int v1 = this.getHopCount();
        boolean v0 = arg4 < v1 ? true : false;
        Args.check(v0, "Hop index exceeds tracked route length");
        HttpHost v0_1 = arg4 < v1 - 1 ? this.proxyChain[arg4] : this.targetHost;
        return v0_1;
    }

    public final RouteInfo$LayerType getLayerType() {
        return this.layered;
    }

    public final InetAddress getLocalAddress() {
        return this.localAddress;
    }

    public final HttpHost getProxyHost() {
        HttpHost v0 = this.proxyChain == null ? null : this.proxyChain[0];
        return v0;
    }

    public final HttpHost getTargetHost() {
        return this.targetHost;
    }

    public final RouteInfo$TunnelType getTunnelType() {
        return this.tunnelled;
    }

    public final int hashCode() {
        int v0 = LangUtils.hashCode(LangUtils.hashCode(17, this.targetHost), this.localAddress);
        if(this.proxyChain != null) {
            HttpHost[] v3 = this.proxyChain;
            int v4 = v3.length;
            int v1 = 0;
            while(v1 < v4) {
                int v2 = LangUtils.hashCode(v0, v3[v1]);
                ++v1;
                v0 = v2;
            }
        }

        return LangUtils.hashCode(LangUtils.hashCode(LangUtils.hashCode(LangUtils.hashCode(v0, this.connected), this.secure), this.tunnelled), this.layered);
    }

    public final boolean isConnected() {
        return this.connected;
    }

    public final boolean isLayered() {
        boolean v0 = this.layered == RouteInfo$LayerType.LAYERED ? true : false;
        return v0;
    }

    public final boolean isSecure() {
        return this.secure;
    }

    public final boolean isTunnelled() {
        boolean v0 = this.tunnelled == RouteInfo$TunnelType.TUNNELLED ? true : false;
        return v0;
    }

    public final void layerProtocol(boolean arg3) {
        Asserts.check(this.connected, "No layered protocol unless connected");
        this.layered = RouteInfo$LayerType.LAYERED;
        this.secure = arg3;
    }

    public void reset() {
        this.connected = false;
        this.proxyChain = null;
        this.tunnelled = RouteInfo$TunnelType.PLAIN;
        this.layered = RouteInfo$LayerType.PLAIN;
        this.secure = false;
    }

    public final HttpRoute toRoute() {
        HttpRoute v0 = !this.connected ? null : new HttpRoute(this.targetHost, this.localAddress, this.proxyChain, this.secure, this.tunnelled, this.layered);
        return v0;
    }

    public final String toString() {
        StringBuilder v1 = new StringBuilder(this.getHopCount() * 30 + 50);
        v1.append("RouteTracker[");
        if(this.localAddress != null) {
            v1.append(this.localAddress);
            v1.append("->");
        }

        v1.append('{');
        if(this.connected) {
            v1.append('c');
        }

        if(this.tunnelled == RouteInfo$TunnelType.TUNNELLED) {
            v1.append('t');
        }

        if(this.layered == RouteInfo$LayerType.LAYERED) {
            v1.append('l');
        }

        if(this.secure) {
            v1.append('s');
        }

        v1.append("}->");
        if(this.proxyChain != null) {
            HttpHost[] v2 = this.proxyChain;
            int v3 = v2.length;
            int v0;
            for(v0 = 0; v0 < v3; ++v0) {
                v1.append(v2[v0]);
                v1.append("->");
            }
        }

        v1.append(this.targetHost);
        v1.append(']');
        return v1.toString();
    }

    public final void tunnelProxy(HttpHost arg5, boolean arg6) {
        Args.notNull(arg5, "Proxy host");
        Asserts.check(this.connected, "No tunnel unless connected");
        Asserts.notNull(this.proxyChain, "No tunnel without proxy");
        HttpHost[] v0 = new HttpHost[this.proxyChain.length + 1];
        System.arraycopy(this.proxyChain, 0, v0, 0, this.proxyChain.length);
        v0[v0.length - 1] = arg5;
        this.proxyChain = v0;
        this.secure = arg6;
    }

    public final void tunnelTarget(boolean arg3) {
        Asserts.check(this.connected, "No tunnel unless connected");
        Asserts.notNull(this.proxyChain, "No tunnel without proxy");
        this.tunnelled = RouteInfo$TunnelType.TUNNELLED;
        this.secure = arg3;
    }
}

