// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.ssl;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;
import javax.net.ssl.SSLException;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.annotation.Immutable;
import org.apache.http.conn.util.InetAddressUtils;

@Immutable public abstract class AbstractVerifier implements X509HostnameVerifier {
    private static final String[] BAD_COUNTRY_2LDS;
    private final Log log;

    static {
        AbstractVerifier.BAD_COUNTRY_2LDS = new String[]{"ac", "co", "com", "ed", "edu", "go", "gouv", "gov", "info", "lg", "ne", "net", "or", "org"};
        Arrays.sort(AbstractVerifier.BAD_COUNTRY_2LDS);
    }

    public AbstractVerifier() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    @Deprecated public static boolean acceptableCountryWildcard(String arg5) {
        int v4 = 2;
        boolean v0 = true;
        String[] v1 = arg5.split("\\.");
        if(v1.length == 3 && v1[v4].length() == v4 && Arrays.binarySearch(AbstractVerifier.BAD_COUNTRY_2LDS, v1[1]) >= 0) {
            v0 = false;
        }

        return v0;
    }

    public static int countDots(String arg4) {
        int v0 = 0;
        int v1 = 0;
        while(v0 < arg4.length()) {
            if(arg4.charAt(v0) == 46) {
                ++v1;
            }

            ++v0;
        }

        return v1;
    }

    public static String[] getCNs(X509Certificate arg6) {
        String[] v0_1;
        int v5 = 3;
        LinkedList v1 = new LinkedList();
        StringTokenizer v2 = new StringTokenizer(arg6.getSubjectX500Principal().toString(), ",+");
        while(v2.hasMoreTokens()) {
            String v0 = v2.nextToken().trim();
            if(v0.length() <= v5) {
                continue;
            }

            if(!v0.substring(0, v5).equalsIgnoreCase("CN=")) {
                continue;
            }

            v1.add(v0.substring(v5));
        }

        if(!v1.isEmpty()) {
            v0_1 = new String[v1.size()];
            v1.toArray(((Object[])v0_1));
        }
        else {
            v0_1 = null;
        }

        return v0_1;
    }

    public static String[] getDNSSubjectAlts(X509Certificate arg1) {
        return AbstractVerifier.getSubjectAlts(arg1, null);
    }

    private static String[] getSubjectAlts(X509Certificate arg6, String arg7) {
        String[] v0_3;
        Collection v0_1;
        Collection v3 = null;
        int v2 = AbstractVerifier.isIPAddress(arg7) ? 7 : 2;
        LinkedList v4 = new LinkedList();
        try {
            v0_1 = arg6.getSubjectAlternativeNames();
        }
        catch(CertificateParsingException v0) {
            v0_1 = v3;
        }

        if(v0_1 != null) {
            Iterator v5 = v0_1.iterator();
            while(v5.hasNext()) {
                Object v0_2 = v5.next();
                if(((List)v0_2).get(0).intValue() != v2) {
                    continue;
                }

                v4.add(((List)v0_2).get(1));
            }
        }

        if(!v4.isEmpty()) {
            v0_3 = new String[v4.size()];
            v4.toArray(((Object[])v0_3));
        }
        else {
            v0_3 = ((String[])v3);
        }

        return v0_3;
    }

    private static boolean isIPAddress(String arg1) {
        boolean v0;
        if(arg1 != null) {
            if(!InetAddressUtils.isIPv4Address(arg1) && !InetAddressUtils.isIPv6Address(arg1)) {
                goto label_7;
            }

            v0 = true;
        }
        else {
        label_7:
            v0 = false;
        }

        return v0;
    }

    private String normaliseIPv6Address(String arg5) {
        if(arg5 != null && (InetAddressUtils.isIPv6Address(arg5))) {
            try {
                arg5 = InetAddress.getByName(arg5).getHostAddress();
            }
            catch(UnknownHostException v0) {
                this.log.error("Unexpected error converting " + arg5, ((Throwable)v0));
            }
        }

        return arg5;
    }

    boolean validCountryWildcard(String arg6) {
        int v4 = 2;
        boolean v0 = true;
        String[] v1 = arg6.split("\\.");
        if(v1.length == 3 && v1[v4].length() == v4 && Arrays.binarySearch(AbstractVerifier.BAD_COUNTRY_2LDS, v1[1]) >= 0) {
            v0 = false;
        }

        return v0;
    }

    public final void verify(String arg3, X509Certificate arg4) {
        this.verify(arg3, AbstractVerifier.getCNs(arg4), AbstractVerifier.getSubjectAlts(arg4, arg3));
    }

    public final void verify(String arg3, SSLSocket arg4) {
        if(arg3 == null) {
            throw new NullPointerException("host to verify is null");
        }

        SSLSession v0 = arg4.getSession();
        if(v0 == null) {
            arg4.getInputStream().available();
            v0 = arg4.getSession();
            if(v0 == null) {
                arg4.startHandshake();
                v0 = arg4.getSession();
            }
        }

        this.verify(arg3, v0.getPeerCertificates()[0]);
    }

    public final void verify(String arg10, String[] arg11, String[] arg12, boolean arg13) {
        String v5;
        LinkedList v3 = new LinkedList();
        if(arg11 != null && arg11.length > 0 && arg11[0] != null) {
            v3.add(arg11[0]);
        }

        if(arg12 != null) {
            int v4 = arg12.length;
            int v0;
            for(v0 = 0; v0 < v4; ++v0) {
                v5 = arg12[v0];
                if(v5 != null) {
                    v3.add(v5);
                }
            }
        }

        if(v3.isEmpty()) {
            throw new SSLException("Certificate for <" + arg10 + "> doesn\'t contain CN or DNS subjectAlt");
        }

        StringBuilder v4_1 = new StringBuilder();
        v5 = this.normaliseIPv6Address(arg10.trim().toLowerCase(Locale.ENGLISH));
        Iterator v3_1 = v3.iterator();
        boolean v0_1 = false;
        do {
            if(!v3_1.hasNext()) {
                break;
            }

            String v6 = v3_1.next().toLowerCase(Locale.ENGLISH);
            v4_1.append(" <");
            v4_1.append(v6);
            v4_1.append('>');
            if(v3_1.hasNext()) {
                v4_1.append(" OR");
            }

            String[] v7 = v6.split("\\.");
            v0 = v7.length < 3 || !v7[0].endsWith("*") || !this.validCountryWildcard(v6) || (AbstractVerifier.isIPAddress(arg10)) ? 0 : 1;
            if(v0 != 0) {
                String v0_2 = v7[0];
                if(v0_2.length() > 1) {
                    String v7_1 = v0_2.substring(0, v0_2.length() - 1);
                    v0_2 = v6.substring(v0_2.length());
                    String v8 = v5.substring(v7_1.length());
                    if((v5.startsWith(v7_1)) && (v8.endsWith(v0_2))) {
                        v0_1 = true;
                        goto label_85;
                    }

                    v0_1 = false;
                }
                else {
                    v0_1 = v5.endsWith(v6.substring(1));
                }

            label_85:
                if(!v0_1) {
                    continue;
                }

                if(!arg13) {
                    continue;
                }

                if(AbstractVerifier.countDots(v5) == AbstractVerifier.countDots(v6)) {
                    v0_1 = true;
                    continue;
                }

                v0_1 = false;
            }
            else {
                v0_1 = v5.equals(this.normaliseIPv6Address(v6));
            }
        }
        while(!v0_1);

        if(!v0_1) {
            throw new SSLException("hostname in certificate didn\'t match: <" + arg10 + "> !=" + v4_1);
        }
    }

    public final boolean verify(String arg4, SSLSession arg5) {
        boolean v0_1;
        try {
            this.verify(arg4, arg5.getPeerCertificates()[0]);
            v0_1 = true;
        }
        catch(SSLException v0) {
            v0_1 = false;
        }

        return v0_1;
    }
}

