// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.ssl;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import javax.net.SocketFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import org.apache.http.HttpHost;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.socket.LayeredConnectionSocketFactory;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.TextUtils;

@ThreadSafe public class SSLConnectionSocketFactory implements LayeredConnectionSocketFactory {
    public static final X509HostnameVerifier ALLOW_ALL_HOSTNAME_VERIFIER = null;
    public static final X509HostnameVerifier BROWSER_COMPATIBLE_HOSTNAME_VERIFIER = null;
    public static final String SSL = "SSL";
    public static final String SSLV2 = "SSLv2";
    public static final X509HostnameVerifier STRICT_HOSTNAME_VERIFIER = null;
    public static final String TLS = "TLS";
    private final X509HostnameVerifier hostnameVerifier;
    private final SSLSocketFactory socketfactory;
    private final String[] supportedCipherSuites;
    private final String[] supportedProtocols;

    static {
        SSLConnectionSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER = new AllowAllHostnameVerifier();
        SSLConnectionSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER = new BrowserCompatHostnameVerifier();
        SSLConnectionSocketFactory.STRICT_HOSTNAME_VERIFIER = new StrictHostnameVerifier();
    }

    public SSLConnectionSocketFactory(SSLContext arg2) {
        this(arg2, SSLConnectionSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public SSLConnectionSocketFactory(SSLContext arg3, X509HostnameVerifier arg4) {
        this(Args.notNull(arg3, "SSL context").getSocketFactory(), null, null, arg4);
    }

    public SSLConnectionSocketFactory(SSLSocketFactory arg2, String[] arg3, String[] arg4, X509HostnameVerifier arg5) {
        super();
        this.socketfactory = Args.notNull(arg2, "SSL socket factory");
        this.supportedProtocols = arg3;
        this.supportedCipherSuites = arg4;
        if(arg5 == null) {
            arg5 = SSLConnectionSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER;
        }

        this.hostnameVerifier = arg5;
    }

    public SSLConnectionSocketFactory(SSLContext arg2, String[] arg3, String[] arg4, X509HostnameVerifier arg5) {
        this(Args.notNull(arg2, "SSL context").getSocketFactory(), arg3, arg4, arg5);
    }

    public SSLConnectionSocketFactory(SSLSocketFactory arg2, X509HostnameVerifier arg3) {
        this(arg2, null, null, arg3);
    }

    public Socket connectSocket(int arg4, Socket arg5, HttpHost arg6, InetSocketAddress arg7, InetSocketAddress arg8, HttpContext arg9) {
        Args.notNull(arg6, "HTTP host");
        Args.notNull(arg7, "Remote address");
        Socket v1 = arg5 != null ? arg5 : this.createSocket(arg9);
        if(arg8 != null) {
            v1.bind(((SocketAddress)arg8));
        }

        try {
            v1.connect(((SocketAddress)arg7), arg4);
        }
        catch(IOException v0) {
            try {
                v1.close();
            }
            catch(IOException v1_1) {
            }

            throw v0;
        }

        if((v1 instanceof SSLSocket)) {
            v1.startHandshake();
            this.verifyHostname(v1, arg6.getHostName());
        }
        else {
            v1 = this.createLayeredSocket(v1, arg6.getHostName(), arg7.getPort(), arg9);
        }

        return v1;
    }

    public Socket createLayeredSocket(Socket arg3, String arg4, int arg5, HttpContext arg6) {
        Socket v0 = this.socketfactory.createSocket(arg3, arg4, arg5, true);
        if(this.supportedProtocols != null) {
            ((SSLSocket)v0).setEnabledProtocols(this.supportedProtocols);
        }

        if(this.supportedCipherSuites != null) {
            ((SSLSocket)v0).setEnabledCipherSuites(this.supportedCipherSuites);
        }

        this.prepareSocket(((SSLSocket)v0));
        ((SSLSocket)v0).startHandshake();
        this.verifyHostname(((SSLSocket)v0), arg4);
        return v0;
    }

    public Socket createSocket(HttpContext arg2) {
        return SocketFactory.getDefault().createSocket();
    }

    X509HostnameVerifier getHostnameVerifier() {
        return this.hostnameVerifier;
    }

    public static SSLConnectionSocketFactory getSocketFactory() {
        return new SSLConnectionSocketFactory(SSLContexts.createDefault(), SSLConnectionSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public static SSLConnectionSocketFactory getSystemSocketFactory() {
        return new SSLConnectionSocketFactory(SSLSocketFactory.getDefault(), SSLConnectionSocketFactory.split(System.getProperty("https.protocols")), SSLConnectionSocketFactory.split(System.getProperty("https.cipherSuites")), SSLConnectionSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    protected void prepareSocket(SSLSocket arg1) {
    }

    private static String[] split(String arg1) {
        String[] v0 = TextUtils.isBlank(((CharSequence)arg1)) ? null : arg1.split(" *, *");
        return v0;
    }

    private void verifyHostname(SSLSocket arg3, String arg4) {
        try {
            this.hostnameVerifier.verify(arg4, arg3);
            return;
        }
        catch(IOException v0) {
            try {
                arg3.close();
            }
            catch(Exception v1) {
            }

            throw v0;
        }
    }
}

