// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.ssl;

import java.security.KeyStore;
import java.security.SecureRandom;
import java.util.HashSet;
import java.util.Set;
import javax.net.ssl.KeyManager;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.TrustManagerFactory;
import javax.net.ssl.X509KeyManager;
import javax.net.ssl.X509TrustManager;
import org.apache.http.annotation.NotThreadSafe;

@NotThreadSafe public class SSLContextBuilder {
    static final String SSL = "SSL";
    static final String TLS = "TLS";
    private Set keymanagers;
    private String protocol;
    private SecureRandom secureRandom;
    private Set trustmanagers;

    public SSLContextBuilder() {
        super();
        this.keymanagers = new HashSet();
        this.trustmanagers = new HashSet();
    }

    public SSLContext build() {
        TrustManager[] v0_2;
        Object[] v1;
        KeyManager[] v2 = null;
        String v0 = this.protocol != null ? this.protocol : "TLS";
        SSLContext v3 = SSLContext.getInstance(v0);
        if(!this.keymanagers.isEmpty()) {
            v1 = this.keymanagers.toArray(new KeyManager[this.keymanagers.size()]);
        }
        else {
            KeyManager[] v1_1 = v2;
        }

        if(!this.trustmanagers.isEmpty()) {
            Object[] v0_1 = this.trustmanagers.toArray(new TrustManager[this.trustmanagers.size()]);
        }
        else {
            v0_2 = ((TrustManager[])v2);
        }

        v3.init(((KeyManager[])v1), v0_2, this.secureRandom);
        return v3;
    }

    public SSLContextBuilder loadKeyMaterial(KeyStore arg2, char[] arg3) {
        this.loadKeyMaterial(arg2, arg3, null);
        return this;
    }

    public SSLContextBuilder loadKeyMaterial(KeyStore arg6, char[] arg7, PrivateKeyStrategy arg8) {
        int v2 = 0;
        KeyManagerFactory v0 = KeyManagerFactory.getInstance(KeyManagerFactory.getDefaultAlgorithm());
        v0.init(arg6, arg7);
        KeyManager[] v3 = v0.getKeyManagers();
        if(v3 != null) {
            if(arg8 != null) {
                int v1;
                for(v1 = 0; v1 < v3.length; ++v1) {
                    KeyManager v0_1 = v3[v1];
                    if((v0_1 instanceof X509KeyManager)) {
                        v3[v1] = new SSLContextBuilder$KeyManagerDelegate(((X509KeyManager)v0_1), arg8);
                    }
                }
            }

            int v0_2 = v3.length;
            while(v2 < v0_2) {
                this.keymanagers.add(v3[v2]);
                ++v2;
            }
        }

        return this;
    }

    public SSLContextBuilder loadTrustMaterial(KeyStore arg2) {
        return this.loadTrustMaterial(arg2, null);
    }

    public SSLContextBuilder loadTrustMaterial(KeyStore arg6, TrustStrategy arg7) {
        int v2 = 0;
        TrustManagerFactory v0 = TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm());
        v0.init(arg6);
        TrustManager[] v3 = v0.getTrustManagers();
        if(v3 != null) {
            if(arg7 != null) {
                int v1;
                for(v1 = 0; v1 < v3.length; ++v1) {
                    TrustManager v0_1 = v3[v1];
                    if((v0_1 instanceof X509TrustManager)) {
                        v3[v1] = new SSLContextBuilder$TrustManagerDelegate(((X509TrustManager)v0_1), arg7);
                    }
                }
            }

            int v0_2 = v3.length;
            while(v2 < v0_2) {
                this.trustmanagers.add(v3[v2]);
                ++v2;
            }
        }

        return this;
    }

    public SSLContextBuilder setSecureRandom(SecureRandom arg1) {
        this.secureRandom = arg1;
        return this;
    }

    public SSLContextBuilder useProtocol(String arg1) {
        this.protocol = arg1;
        return this;
    }

    public SSLContextBuilder useSSL() {
        this.protocol = "SSL";
        return this;
    }

    public SSLContextBuilder useTLS() {
        this.protocol = "TLS";
        return this;
    }
}

