// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.ssl;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.security.KeyStore;
import java.security.SecureRandom;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocket;
import org.apache.http.HttpHost;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.HttpInetSocketAddress;
import org.apache.http.conn.scheme.HostNameResolver;
import org.apache.http.conn.scheme.LayeredSchemeSocketFactory;
import org.apache.http.conn.scheme.LayeredSocketFactory;
import org.apache.http.conn.scheme.SchemeLayeredSocketFactory;
import org.apache.http.conn.socket.LayeredConnectionSocketFactory;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;
import org.apache.http.util.TextUtils;

@Deprecated @ThreadSafe public class SSLSocketFactory implements LayeredSchemeSocketFactory, LayeredSocketFactory, SchemeLayeredSocketFactory, LayeredConnectionSocketFactory {
    public static final X509HostnameVerifier ALLOW_ALL_HOSTNAME_VERIFIER = null;
    public static final X509HostnameVerifier BROWSER_COMPATIBLE_HOSTNAME_VERIFIER = null;
    public static final String SSL = "SSL";
    public static final String SSLV2 = "SSLv2";
    public static final X509HostnameVerifier STRICT_HOSTNAME_VERIFIER = null;
    public static final String TLS = "TLS";
    private volatile X509HostnameVerifier hostnameVerifier;
    private final HostNameResolver nameResolver;
    private final javax.net.ssl.SSLSocketFactory socketfactory;
    private final String[] supportedCipherSuites;
    private final String[] supportedProtocols;

    static {
        SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER = new AllowAllHostnameVerifier();
        SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER = new BrowserCompatHostnameVerifier();
        SSLSocketFactory.STRICT_HOSTNAME_VERIFIER = new StrictHostnameVerifier();
    }

    public SSLSocketFactory(String arg3, KeyStore arg4, String arg5, KeyStore arg6, SecureRandom arg7, HostNameResolver arg8) {
        SSLContextBuilder v1 = SSLContexts.custom().useProtocol(arg3).setSecureRandom(arg7);
        char[] v0 = arg5 != null ? arg5.toCharArray() : null;
        this(v1.loadKeyMaterial(arg4, v0).loadTrustMaterial(arg6).build(), arg8);
    }

    public SSLSocketFactory(SSLContext arg3, HostNameResolver arg4) {
        super();
        this.socketfactory = arg3.getSocketFactory();
        this.hostnameVerifier = SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER;
        this.nameResolver = arg4;
        this.supportedProtocols = null;
        this.supportedCipherSuites = null;
    }

    public SSLSocketFactory(String arg3, KeyStore arg4, String arg5, KeyStore arg6, SecureRandom arg7, TrustStrategy arg8, X509HostnameVerifier arg9) {
        SSLContextBuilder v1 = SSLContexts.custom().useProtocol(arg3).setSecureRandom(arg7);
        char[] v0 = arg5 != null ? arg5.toCharArray() : null;
        this(v1.loadKeyMaterial(arg4, v0).loadTrustMaterial(arg6, arg8).build(), arg9);
    }

    public SSLSocketFactory(SSLContext arg3, X509HostnameVerifier arg4) {
        this(Args.notNull(arg3, "SSL context").getSocketFactory(), null, null, arg4);
    }

    public SSLSocketFactory(String arg3, KeyStore arg4, String arg5, KeyStore arg6, SecureRandom arg7, X509HostnameVerifier arg8) {
        SSLContextBuilder v1 = SSLContexts.custom().useProtocol(arg3).setSecureRandom(arg7);
        char[] v0 = arg5 != null ? arg5.toCharArray() : null;
        this(v1.loadKeyMaterial(arg4, v0).loadTrustMaterial(arg6).build(), arg8);
    }

    public SSLSocketFactory(KeyStore arg3) {
        this(SSLContexts.custom().loadTrustMaterial(arg3).build(), SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public SSLSocketFactory(KeyStore arg3, String arg4) {
        SSLContextBuilder v1 = SSLContexts.custom();
        char[] v0 = arg4 != null ? arg4.toCharArray() : null;
        this(v1.loadKeyMaterial(arg3, v0).build(), SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public SSLSocketFactory(KeyStore arg3, String arg4, KeyStore arg5) {
        SSLContextBuilder v1 = SSLContexts.custom();
        char[] v0 = arg4 != null ? arg4.toCharArray() : null;
        this(v1.loadKeyMaterial(arg3, v0).loadTrustMaterial(arg5).build(), SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public SSLSocketFactory(SSLContext arg2) {
        this(arg2, SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public SSLSocketFactory(javax.net.ssl.SSLSocketFactory arg2, String[] arg3, String[] arg4, X509HostnameVerifier arg5) {
        super();
        this.socketfactory = Args.notNull(arg2, "SSL socket factory");
        this.supportedProtocols = arg3;
        this.supportedCipherSuites = arg4;
        if(arg5 == null) {
            arg5 = SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER;
        }

        this.hostnameVerifier = arg5;
        this.nameResolver = null;
    }

    public SSLSocketFactory(SSLContext arg2, String[] arg3, String[] arg4, X509HostnameVerifier arg5) {
        this(Args.notNull(arg2, "SSL context").getSocketFactory(), arg3, arg4, arg5);
    }

    public SSLSocketFactory(javax.net.ssl.SSLSocketFactory arg2, X509HostnameVerifier arg3) {
        this(arg2, null, null, arg3);
    }

    public SSLSocketFactory(TrustStrategy arg3) {
        this(SSLContexts.custom().loadTrustMaterial(null, arg3).build(), SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public SSLSocketFactory(TrustStrategy arg3, X509HostnameVerifier arg4) {
        this(SSLContexts.custom().loadTrustMaterial(null, arg3).build(), arg4);
    }

    public Socket connectSocket(int arg4, Socket arg5, HttpHost arg6, InetSocketAddress arg7, InetSocketAddress arg8, HttpContext arg9) {
        Args.notNull(arg6, "HTTP host");
        Args.notNull(arg7, "Remote address");
        Socket v1 = arg5 != null ? arg5 : this.createSocket(arg9);
        if(arg8 != null) {
            v1.bind(((SocketAddress)arg8));
        }

        try {
            v1.connect(((SocketAddress)arg7), arg4);
        }
        catch(IOException v0) {
            try {
                v1.close();
            }
            catch(IOException v1_1) {
            }

            throw v0;
        }

        if((v1 instanceof SSLSocket)) {
            v1.startHandshake();
            this.verifyHostname(v1, arg6.getHostName());
        }
        else {
            v1 = this.createLayeredSocket(v1, arg6.getHostName(), arg7.getPort(), arg9);
        }

        return v1;
    }

    public Socket connectSocket(Socket arg5, String arg6, int arg7, InetAddress arg8, int arg9, HttpParams arg10) {
        InetAddress v1 = this.nameResolver != null ? this.nameResolver.resolve(arg6) : InetAddress.getByName(arg6);
        InetSocketAddress v0 = null;
        if(arg8 != null || arg9 > 0) {
            v0 = new InetSocketAddress(arg8, 0);
        }

        return this.connectSocket(arg5, new HttpInetSocketAddress(new HttpHost(arg6, arg7), v1, arg7), v0, arg10);
    }

    public Socket connectSocket(Socket arg8, InetSocketAddress arg9, InetSocketAddress arg10, HttpParams arg11) {
        Args.notNull(arg9, "Remote address");
        Args.notNull(arg11, "HTTP parameters");
        HttpHost v3 = (arg9 instanceof HttpInetSocketAddress) ? arg9.getHttpHost() : new HttpHost(arg9.getHostName(), arg9.getPort(), "https");
        int v0 = HttpConnectionParams.getSoTimeout(arg11);
        int v1 = HttpConnectionParams.getConnectionTimeout(arg11);
        arg8.setSoTimeout(v0);
        return this.connectSocket(v1, arg8, v3, arg9, arg10, null);
    }

    public Socket createLayeredSocket(Socket arg3, String arg4, int arg5, HttpContext arg6) {
        Socket v0 = this.socketfactory.createSocket(arg3, arg4, arg5, true);
        this.internalPrepareSocket(((SSLSocket)v0));
        ((SSLSocket)v0).startHandshake();
        this.verifyHostname(((SSLSocket)v0), arg4);
        return v0;
    }

    public Socket createLayeredSocket(Socket arg2, String arg3, int arg4, HttpParams arg5) {
        return this.createLayeredSocket(arg2, arg3, arg4, null);
    }

    public Socket createLayeredSocket(Socket arg2, String arg3, int arg4, boolean arg5) {
        return this.createLayeredSocket(arg2, arg3, arg4, null);
    }

    public Socket createSocket(HttpContext arg2) {
        Socket v0 = this.socketfactory.createSocket();
        this.internalPrepareSocket(((SSLSocket)v0));
        return v0;
    }

    public Socket createSocket() {
        return this.createSocket(null);
    }

    public Socket createSocket(Socket arg2, String arg3, int arg4, boolean arg5) {
        return this.createLayeredSocket(arg2, arg3, arg4, arg5);
    }

    public Socket createSocket(HttpParams arg2) {
        return this.createSocket(null);
    }

    public X509HostnameVerifier getHostnameVerifier() {
        return this.hostnameVerifier;
    }

    public static SSLSocketFactory getSocketFactory() {
        return new SSLSocketFactory(SSLContexts.createDefault(), SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    public static SSLSocketFactory getSystemSocketFactory() {
        return new SSLSocketFactory(javax.net.ssl.SSLSocketFactory.getDefault(), SSLSocketFactory.split(System.getProperty("https.protocols")), SSLSocketFactory.split(System.getProperty("https.cipherSuites")), SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
    }

    private void internalPrepareSocket(SSLSocket arg2) {
        if(this.supportedProtocols != null) {
            arg2.setEnabledProtocols(this.supportedProtocols);
        }

        if(this.supportedCipherSuites != null) {
            arg2.setEnabledCipherSuites(this.supportedCipherSuites);
        }

        this.prepareSocket(arg2);
    }

    public boolean isSecure(Socket arg4) {
        Args.notNull(arg4, "Socket");
        Asserts.check(arg4 instanceof SSLSocket, "Socket not created by this factory");
        boolean v0 = !arg4.isClosed() ? true : false;
        Asserts.check(v0, "Socket is closed");
        return 1;
    }

    protected void prepareSocket(SSLSocket arg1) {
    }

    public void setHostnameVerifier(X509HostnameVerifier arg2) {
        Args.notNull(arg2, "Hostname verifier");
        this.hostnameVerifier = arg2;
    }

    private static String[] split(String arg1) {
        String[] v0 = TextUtils.isBlank(((CharSequence)arg1)) ? null : arg1.split(" *, *");
        return v0;
    }

    private void verifyHostname(SSLSocket arg3, String arg4) {
        try {
            this.hostnameVerifier.verify(arg4, arg3);
            return;
        }
        catch(IOException v0) {
            try {
                arg3.close();
            }
            catch(Exception v1) {
            }

            throw v0;
        }
    }
}

