// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.conn.util;

import java.util.regex.Pattern;
import org.apache.http.annotation.Immutable;

@Immutable public class InetAddressUtils {
    private static final char COLON_CHAR = ':';
    private static final String IPV4_BASIC_PATTERN_STRING = "(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])";
    private static final Pattern IPV4_MAPPED_IPV6_PATTERN = null;
    private static final Pattern IPV4_PATTERN = null;
    private static final Pattern IPV6_HEX_COMPRESSED_PATTERN = null;
    private static final Pattern IPV6_STD_PATTERN = null;
    private static final int MAX_COLON_COUNT = 7;

    static {
        InetAddressUtils.IPV4_PATTERN = Pattern.compile("^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$");
        InetAddressUtils.IPV4_MAPPED_IPV6_PATTERN = Pattern.compile("^::[fF]{4}:(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$");
        InetAddressUtils.IPV6_STD_PATTERN = Pattern.compile("^[0-9a-fA-F]{1,4}(:[0-9a-fA-F]{1,4}){7}$");
        InetAddressUtils.IPV6_HEX_COMPRESSED_PATTERN = Pattern.compile("^(([0-9A-Fa-f]{1,4}(:[0-9A-Fa-f]{1,4}){0,5})?)::(([0-9A-Fa-f]{1,4}(:[0-9A-Fa-f]{1,4}){0,5})?)$");
    }

    private InetAddressUtils() {
        super();
    }

    public static boolean isIPv4Address(String arg1) {
        return InetAddressUtils.IPV4_PATTERN.matcher(((CharSequence)arg1)).matches();
    }

    public static boolean isIPv4MappedIPv64Address(String arg1) {
        return InetAddressUtils.IPV4_MAPPED_IPV6_PATTERN.matcher(((CharSequence)arg1)).matches();
    }

    public static boolean isIPv6Address(String arg1) {
        boolean v0 = (InetAddressUtils.isIPv6StdAddress(arg1)) || (InetAddressUtils.isIPv6HexCompressedAddress(arg1)) ? true : false;
        return v0;
    }

    public static boolean isIPv6HexCompressedAddress(String arg5) {
        boolean v1 = false;
        int v0 = 0;
        int v2 = 0;
        while(v0 < arg5.length()) {
            if(arg5.charAt(v0) == 58) {
                ++v2;
            }

            ++v0;
        }

        if(v2 <= 7 && (InetAddressUtils.IPV6_HEX_COMPRESSED_PATTERN.matcher(((CharSequence)arg5)).matches())) {
            v1 = true;
        }

        return v1;
    }

    public static boolean isIPv6StdAddress(String arg1) {
        return InetAddressUtils.IPV6_STD_PATTERN.matcher(((CharSequence)arg1)).matches();
    }
}

