// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.entity.mime;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;
import org.apache.http.util.Args;
import org.apache.http.util.ByteArrayBuffer;

abstract class AbstractMultipartForm {
    private static final ByteArrayBuffer CR_LF;
    private static final ByteArrayBuffer FIELD_SEP;
    private static final ByteArrayBuffer TWO_DASHES;
    private final String boundary;
    protected final Charset charset;
    private final String subType;

    static {
        AbstractMultipartForm.FIELD_SEP = AbstractMultipartForm.encode(MIME.DEFAULT_CHARSET, ": ");
        AbstractMultipartForm.CR_LF = AbstractMultipartForm.encode(MIME.DEFAULT_CHARSET, "\r\n");
        AbstractMultipartForm.TWO_DASHES = AbstractMultipartForm.encode(MIME.DEFAULT_CHARSET, "--");
    }

    public AbstractMultipartForm(String arg2, String arg3) {
        this(arg2, null, arg3);
    }

    public AbstractMultipartForm(String arg2, Charset arg3, String arg4) {
        super();
        Args.notNull(arg2, "Multipart subtype");
        Args.notNull(arg4, "Multipart boundary");
        this.subType = arg2;
        if(arg3 == null) {
            arg3 = MIME.DEFAULT_CHARSET;
        }

        this.charset = arg3;
        this.boundary = arg4;
    }

    void doWriteTo(OutputStream arg5, boolean arg6) {
        ByteArrayBuffer v1 = AbstractMultipartForm.encode(this.charset, this.getBoundary());
        Iterator v2 = this.getBodyParts().iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            AbstractMultipartForm.writeBytes(AbstractMultipartForm.TWO_DASHES, arg5);
            AbstractMultipartForm.writeBytes(v1, arg5);
            AbstractMultipartForm.writeBytes(AbstractMultipartForm.CR_LF, arg5);
            this.formatMultipartHeader(((FormBodyPart)v0), arg5);
            AbstractMultipartForm.writeBytes(AbstractMultipartForm.CR_LF, arg5);
            if(arg6) {
                ((FormBodyPart)v0).getBody().writeTo(arg5);
            }

            AbstractMultipartForm.writeBytes(AbstractMultipartForm.CR_LF, arg5);
        }

        AbstractMultipartForm.writeBytes(AbstractMultipartForm.TWO_DASHES, arg5);
        AbstractMultipartForm.writeBytes(v1, arg5);
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.TWO_DASHES, arg5);
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.CR_LF, arg5);
    }

    private static ByteArrayBuffer encode(Charset arg4, String arg5) {
        ByteBuffer v0 = arg4.encode(CharBuffer.wrap(((CharSequence)arg5)));
        ByteArrayBuffer v1 = new ByteArrayBuffer(v0.remaining());
        v1.append(v0.array(), v0.position(), v0.remaining());
        return v1;
    }

    protected abstract void formatMultipartHeader(FormBodyPart arg1, OutputStream arg2);

    public abstract List getBodyParts();

    public String getBoundary() {
        return this.boundary;
    }

    public Charset getCharset() {
        return this.charset;
    }

    public String getSubType() {
        return this.subType;
    }

    public long getTotalLength() {
        long v3 = 0;
        long v5 = -1;
        Iterator v7 = this.getBodyParts().iterator();
        long v1;
        for(v1 = v3; true; v1 += v8) {
            if(!v7.hasNext()) {
                goto label_16;
            }

            long v8 = v7.next().getBody().getContentLength();
            if(v8 < v3) {
                break;
            }
        }

        long v0 = v5;
        return v0;
    label_16:
        ByteArrayOutputStream v0_1 = new ByteArrayOutputStream();
        try {
            this.doWriteTo(((OutputStream)v0_1), false);
            v0 = v1 + (((long)v0_1.toByteArray().length));
        }
        catch(IOException v0_2) {
            v0 = v5;
        }

        return v0;
    }

    private static void writeBytes(String arg1, OutputStream arg2) {
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.encode(MIME.DEFAULT_CHARSET, arg1), arg2);
    }

    private static void writeBytes(ByteArrayBuffer arg3, OutputStream arg4) {
        arg4.write(arg3.buffer(), 0, arg3.length());
    }

    private static void writeBytes(String arg1, Charset arg2, OutputStream arg3) {
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.encode(arg2, arg1), arg3);
    }

    protected static void writeField(MinimalField arg1, OutputStream arg2) {
        AbstractMultipartForm.writeBytes(arg1.getName(), arg2);
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.FIELD_SEP, arg2);
        AbstractMultipartForm.writeBytes(arg1.getBody(), arg2);
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.CR_LF, arg2);
    }

    protected static void writeField(MinimalField arg1, Charset arg2, OutputStream arg3) {
        AbstractMultipartForm.writeBytes(arg1.getName(), arg2, arg3);
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.FIELD_SEP, arg3);
        AbstractMultipartForm.writeBytes(arg1.getBody(), arg2, arg3);
        AbstractMultipartForm.writeBytes(AbstractMultipartForm.CR_LF, arg3);
    }

    public void writeTo(OutputStream arg2) {
        this.doWriteTo(arg2, true);
    }
}

