// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.entity.mime;

import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.content.AbstractContentBody;
import org.apache.http.entity.mime.content.ContentBody;
import org.apache.http.util.Args;

public class FormBodyPart {
    private final ContentBody body;
    private final Header header;
    private final String name;

    public FormBodyPart(String arg2, ContentBody arg3) {
        super();
        Args.notNull(arg2, "Name");
        Args.notNull(arg3, "Body");
        this.name = arg2;
        this.body = arg3;
        this.header = new Header();
        this.generateContentDisp(arg3);
        this.generateContentType(arg3);
        this.generateTransferEncoding(arg3);
    }

    public void addField(String arg3, String arg4) {
        Args.notNull(arg3, "Field name");
        this.header.addField(new MinimalField(arg3, arg4));
    }

    protected void generateContentDisp(ContentBody arg3) {
        StringBuilder v0 = new StringBuilder();
        v0.append("form-data; name=\"");
        v0.append(this.getName());
        v0.append("\"");
        if(arg3.getFilename() != null) {
            v0.append("; filename=\"");
            v0.append(arg3.getFilename());
            v0.append("\"");
        }

        this.addField("Content-Disposition", v0.toString());
    }

    protected void generateContentType(ContentBody arg3) {
        ContentType v0 = (arg3 instanceof AbstractContentBody) ? arg3.getContentType() : null;
        if(v0 != null) {
            this.addField("Content-Type", v0.toString());
        }
        else {
            StringBuilder v0_1 = new StringBuilder();
            v0_1.append(arg3.getMimeType());
            if(arg3.getCharset() != null) {
                v0_1.append("; charset=");
                v0_1.append(arg3.getCharset());
            }

            this.addField("Content-Type", v0_1.toString());
        }
    }

    protected void generateTransferEncoding(ContentBody arg3) {
        this.addField("Content-Transfer-Encoding", arg3.getTransferEncoding());
    }

    public ContentBody getBody() {
        return this.body;
    }

    public Header getHeader() {
        return this.header;
    }

    public String getName() {
        return this.name;
    }
}

