// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.entity.mime;

import java.io.File;
import java.io.InputStream;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import org.apache.http.HttpEntity;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.content.ByteArrayBody;
import org.apache.http.entity.mime.content.ContentBody;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.entity.mime.content.InputStreamBody;
import org.apache.http.entity.mime.content.StringBody;
import org.apache.http.util.Args;

public class MultipartEntityBuilder {
    private static final String DEFAULT_SUBTYPE = "form-data";
    private static final char[] MULTIPART_CHARS;
    private List bodyParts;
    private String boundary;
    private Charset charset;
    private HttpMultipartMode mode;
    private String subType;

    static {
        MultipartEntityBuilder.MULTIPART_CHARS = "-_1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
    }

    MultipartEntityBuilder() {
        super();
        this.subType = "form-data";
        this.mode = HttpMultipartMode.STRICT;
        this.boundary = null;
        this.charset = null;
        this.bodyParts = null;
    }

    public MultipartEntityBuilder addBinaryBody(String arg3, File arg4) {
        ContentType v1 = ContentType.DEFAULT_BINARY;
        String v0 = arg4 != null ? arg4.getName() : null;
        return this.addBinaryBody(arg3, arg4, v1, v0);
    }

    public MultipartEntityBuilder addBinaryBody(String arg2, File arg3, ContentType arg4, String arg5) {
        return this.addPart(arg2, new FileBody(arg3, arg4, arg5));
    }

    public MultipartEntityBuilder addBinaryBody(String arg3, InputStream arg4) {
        return this.addBinaryBody(arg3, arg4, ContentType.DEFAULT_BINARY, null);
    }

    public MultipartEntityBuilder addBinaryBody(String arg2, InputStream arg3, ContentType arg4, String arg5) {
        return this.addPart(arg2, new InputStreamBody(arg3, arg4, arg5));
    }

    public MultipartEntityBuilder addBinaryBody(String arg3, byte[] arg4) {
        return this.addBinaryBody(arg3, arg4, ContentType.DEFAULT_BINARY, null);
    }

    public MultipartEntityBuilder addBinaryBody(String arg2, byte[] arg3, ContentType arg4, String arg5) {
        return this.addPart(arg2, new ByteArrayBody(arg3, arg4, arg5));
    }

    MultipartEntityBuilder addPart(FormBodyPart arg2) {
        if(arg2 != null) {
            if(this.bodyParts == null) {
                this.bodyParts = new ArrayList();
            }

            this.bodyParts.add(arg2);
        }

        return this;
    }

    public MultipartEntityBuilder addPart(String arg2, ContentBody arg3) {
        Args.notNull(arg2, "Name");
        Args.notNull(arg3, "Content body");
        return this.addPart(new FormBodyPart(arg2, arg3));
    }

    public MultipartEntityBuilder addTextBody(String arg2, String arg3) {
        return this.addTextBody(arg2, arg3, ContentType.DEFAULT_TEXT);
    }

    public MultipartEntityBuilder addTextBody(String arg2, String arg3, ContentType arg4) {
        return this.addPart(arg2, new StringBody(arg3, arg4));
    }

    public HttpEntity build() {
        return this.buildEntity();
    }

    MultipartFormEntity buildEntity() {
        HttpBrowserCompatibleMultipart v0_3;
        ArrayList v2;
        String v0 = this.subType != null ? this.subType : "form-data";
        Charset v4 = this.charset;
        String v1 = this.boundary != null ? this.boundary : this.generateBoundary();
        if(this.bodyParts != null) {
            v2 = new ArrayList(this.bodyParts);
        }
        else {
            List v2_1 = Collections.emptyList();
        }

        HttpMultipartMode v3 = this.mode != null ? this.mode : HttpMultipartMode.STRICT;
        switch(MultipartEntityBuilder$1.$SwitchMap$org$apache$http$entity$mime$HttpMultipartMode[v3.ordinal()]) {
            case 1: {
                v0_3 = new HttpBrowserCompatibleMultipart(v0, v4, v1, ((List)v2));
                break;
            }
            case 2: {
                HttpRFC6532Multipart v0_2 = new HttpRFC6532Multipart(v0, v4, v1, ((List)v2));
                break;
            }
            default: {
                HttpStrictMultipart v0_1 = new HttpStrictMultipart(v0, v4, v1, ((List)v2));
                break;
            }
        }

        return new MultipartFormEntity(((AbstractMultipartForm)v0_3), this.generateContentType(v1, v4), ((AbstractMultipartForm)v0_3).getTotalLength());
    }

    public static MultipartEntityBuilder create() {
        return new MultipartEntityBuilder();
    }

    private String generateBoundary() {
        StringBuilder v1 = new StringBuilder();
        Random v2 = new Random();
        int v3 = v2.nextInt(11) + 30;
        int v0;
        for(v0 = 0; v0 < v3; ++v0) {
            v1.append(MultipartEntityBuilder.MULTIPART_CHARS[v2.nextInt(MultipartEntityBuilder.MULTIPART_CHARS.length)]);
        }

        return v1.toString();
    }

    private String generateContentType(String arg3, Charset arg4) {
        StringBuilder v0 = new StringBuilder();
        v0.append("multipart/form-data; boundary=");
        v0.append(arg3);
        if(arg4 != null) {
            v0.append("; charset=");
            v0.append(arg4.name());
        }

        return v0.toString();
    }

    public MultipartEntityBuilder setBoundary(String arg1) {
        this.boundary = arg1;
        return this;
    }

    public MultipartEntityBuilder setCharset(Charset arg1) {
        this.charset = arg1;
        return this;
    }

    public MultipartEntityBuilder setLaxMode() {
        this.mode = HttpMultipartMode.BROWSER_COMPATIBLE;
        return this;
    }

    public MultipartEntityBuilder setMode(HttpMultipartMode arg1) {
        this.mode = arg1;
        return this;
    }

    public MultipartEntityBuilder setStrictMode() {
        this.mode = HttpMultipartMode.STRICT;
        return this;
    }
}

