// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import java.util.Locale;
import org.apache.http.FormattedHeader;
import org.apache.http.Header;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.ChallengeState;
import org.apache.http.auth.ContextAwareAuthScheme;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.MalformedChallengeException;
import org.apache.http.protocol.HTTP;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public abstract class AuthSchemeBase implements ContextAwareAuthScheme {
    private ChallengeState challengeState;

    public AuthSchemeBase() {
        super();
    }

    @Deprecated public AuthSchemeBase(ChallengeState arg1) {
        super();
        this.challengeState = arg1;
    }

    public Header authenticate(Credentials arg2, HttpRequest arg3, HttpContext arg4) {
        return this.authenticate(arg2, arg3);
    }

    public ChallengeState getChallengeState() {
        return this.challengeState;
    }

    public boolean isProxy() {
        boolean v0 = this.challengeState == null || this.challengeState != ChallengeState.PROXY ? false : true;
        return v0;
    }

    protected abstract void parseChallenge(CharArrayBuffer arg1, int arg2, int arg3);

    public void processChallenge(Header arg5) {
        int v0_1;
        CharArrayBuffer v1;
        Args.notNull(arg5, "Header");
        String v0 = arg5.getName();
        if(v0.equalsIgnoreCase("WWW-Authenticate")) {
            this.challengeState = ChallengeState.TARGET;
        }
        else if(v0.equalsIgnoreCase("Proxy-Authenticate")) {
            this.challengeState = ChallengeState.PROXY;
        }
        else {
            goto label_26;
        }

        if((arg5 instanceof FormattedHeader)) {
            v1 = arg5.getBuffer();
            v0_1 = ((FormattedHeader)arg5).getValuePos();
        }
        else {
            v0 = arg5.getValue();
            if(v0 == null) {
                throw new MalformedChallengeException("Header value is null");
            }
            else {
                v1 = new CharArrayBuffer(v0.length());
                v1.append(v0);
                v0_1 = 0;
            }
        }

        while(v0_1 < v1.length()) {
            if(!HTTP.isWhitespace(v1.charAt(v0_1))) {
                break;
            }

            ++v0_1;
        }

        int v2;
        for(v2 = v0_1; v2 < v1.length(); ++v2) {
            if(HTTP.isWhitespace(v1.charAt(v2))) {
                break;
            }
        }

        v0 = v1.substring(v0_1, v2);
        if(!v0.equalsIgnoreCase(this.getSchemeName())) {
            throw new MalformedChallengeException("Invalid scheme identifier: " + v0);
        }

        this.parseChallenge(v1, v2, v1.length());
        return;
    label_26:
        throw new MalformedChallengeException("Unexpected header name: " + v0);
    }

    public String toString() {
        String v0 = this.getSchemeName();
        return v0 != null ? v0.toUpperCase(Locale.ENGLISH) : super.toString();
    }
}

