// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import java.nio.charset.Charset;
import org.apache.commons.codec.binary.Base64;
import org.apache.http.Consts;
import org.apache.http.Header;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.ChallengeState;
import org.apache.http.auth.Credentials;
import org.apache.http.message.BufferedHeader;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;
import org.apache.http.util.EncodingUtils;

@NotThreadSafe public class BasicScheme extends RFC2617Scheme {
    private final Base64 base64codec;
    private boolean complete;

    public BasicScheme() {
        this(Consts.ASCII);
    }

    public BasicScheme(Charset arg3) {
        super(arg3);
        this.base64codec = new Base64(0);
        this.complete = false;
    }

    @Deprecated public BasicScheme(ChallengeState arg3) {
        super(arg3);
        this.base64codec = new Base64(0);
    }

    @Deprecated public static Header authenticate(Credentials arg4, String arg5, boolean arg6) {
        Args.notNull(arg4, "Credentials");
        Args.notNull(arg5, "charset");
        StringBuilder v1 = new StringBuilder();
        v1.append(arg4.getUserPrincipal().getName());
        v1.append(":");
        String v0 = arg4.getPassword() == null ? "null" : arg4.getPassword();
        v1.append(v0);
        byte[] v0_1 = Base64.encodeBase64(EncodingUtils.getBytes(v1.toString(), arg5), false);
        CharArrayBuffer v1_1 = new CharArrayBuffer(32);
        if(arg6) {
            v1_1.append("Proxy-Authorization");
        }
        else {
            v1_1.append("Authorization");
        }

        v1_1.append(": Basic ");
        v1_1.append(v0_1, 0, v0_1.length);
        return new BufferedHeader(v1_1);
    }

    @Deprecated public Header authenticate(Credentials arg2, HttpRequest arg3) {
        return this.authenticate(arg2, arg3, new BasicHttpContext());
    }

    public Header authenticate(Credentials arg5, HttpRequest arg6, HttpContext arg7) {
        Args.notNull(arg5, "Credentials");
        Args.notNull(arg6, "HTTP request");
        StringBuilder v1 = new StringBuilder();
        v1.append(arg5.getUserPrincipal().getName());
        v1.append(":");
        String v0 = arg5.getPassword() == null ? "null" : arg5.getPassword();
        v1.append(v0);
        byte[] v0_1 = this.base64codec.encode(EncodingUtils.getBytes(v1.toString(), this.getCredentialsCharset(arg6)));
        CharArrayBuffer v1_1 = new CharArrayBuffer(32);
        if(this.isProxy()) {
            v1_1.append("Proxy-Authorization");
        }
        else {
            v1_1.append("Authorization");
        }

        v1_1.append(": Basic ");
        v1_1.append(v0_1, 0, v0_1.length);
        return new BufferedHeader(v1_1);
    }

    public String getSchemeName() {
        return "basic";
    }

    public boolean isComplete() {
        return this.complete;
    }

    public boolean isConnectionBased() {
        return 0;
    }

    public void processChallenge(Header arg2) {
        super.processChallenge(arg2);
        this.complete = true;
    }
}

