// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.Charset;
import java.security.MessageDigest;
import java.security.SecureRandom;
import java.util.ArrayList;
import java.util.Formatter;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Set;
import java.util.StringTokenizer;
import org.apache.http.Consts;
import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpRequest;
import org.apache.http.NameValuePair;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.AuthenticationException;
import org.apache.http.auth.ChallengeState;
import org.apache.http.auth.Credentials;
import org.apache.http.message.BasicHeaderValueFormatter;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.message.BufferedHeader;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;
import org.apache.http.util.EncodingUtils;

@NotThreadSafe public class DigestScheme extends RFC2617Scheme {
    private static final char[] HEXADECIMAL = null;
    private static final int QOP_AUTH = 2;
    private static final int QOP_AUTH_INT = 1;
    private static final int QOP_MISSING = 0;
    private static final int QOP_UNKNOWN = -1;
    private String a1;
    private String a2;
    private String cnonce;
    private boolean complete;
    private String lastNonce;
    private long nounceCount;

    static {
        DigestScheme.HEXADECIMAL = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
    }

    public DigestScheme() {
        this(Consts.ASCII);
    }

    public DigestScheme(Charset arg2) {
        super(arg2);
        this.complete = false;
    }

    @Deprecated public DigestScheme(ChallengeState arg1) {
        super(arg1);
    }

    @Deprecated public Header authenticate(Credentials arg2, HttpRequest arg3) {
        return this.authenticate(arg2, arg3, new BasicHttpContext());
    }

    public Header authenticate(Credentials arg4, HttpRequest arg5, HttpContext arg6) {
        Args.notNull(arg4, "Credentials");
        Args.notNull(arg5, "HTTP request");
        if(this.getParameter("realm") == null) {
            throw new AuthenticationException("missing realm in challenge");
        }

        if(this.getParameter("nonce") == null) {
            throw new AuthenticationException("missing nonce in challenge");
        }

        this.getParameters().put("methodname", arg5.getRequestLine().getMethod());
        this.getParameters().put("uri", arg5.getRequestLine().getUri());
        if(this.getParameter("charset") == null) {
            this.getParameters().put("charset", this.getCredentialsCharset(arg5));
        }

        return this.createDigestHeader(arg4, arg5);
    }

    public static String createCnonce() {
        SecureRandom v0 = new SecureRandom();
        byte[] v1 = new byte[8];
        v0.nextBytes(v1);
        return DigestScheme.encode(v1);
    }

    private Header createDigestHeader(Credentials arg22, HttpRequest arg23) {
        MessageDigest v12;
        int v4_1;
        String v6 = this.getParameter("uri");
        String v7 = this.getParameter("realm");
        String v8 = this.getParameter("nonce");
        String v9 = this.getParameter("opaque");
        String v10 = this.getParameter("methodname");
        String v2 = this.getParameter("algorithm");
        if(v2 == null) {
            v2 = "MD5";
        }

        HashSet v11 = new HashSet(8);
        int v3 = -1;
        String v5 = this.getParameter("qop");
        if(v5 != null) {
            StringTokenizer v4 = new StringTokenizer(v5, ",");
            while(v4.hasMoreTokens()) {
                ((Set)v11).add(v4.nextToken().trim().toLowerCase(Locale.ENGLISH));
            }

            if(((arg23 instanceof HttpEntityEnclosingRequest)) && (((Set)v11).contains("auth-int"))) {
                v3 = 1;
            }
            else if(((Set)v11).contains("auth")) {
                v3 = 2;
            }

            v4_1 = v3;
        }
        else {
            v4_1 = 0;
        }

        if(v4_1 == -1) {
            throw new AuthenticationException("None of the qop methods is supported: " + v5);
        }

        String v3_1 = this.getParameter("charset");
        if(v3_1 == null) {
            v3_1 = "ISO-8859-1";
        }

        v5 = v2.equalsIgnoreCase("MD5-sess") ? "MD5" : v2;
        try {
            v12 = DigestScheme.createMessageDigest(v5);
        }
        catch(UnsupportedDigestAlgorithmException v2_1) {
            throw new AuthenticationException("Unsuppported digest algorithm: " + v5);
        }

        String v13 = arg22.getUserPrincipal().getName();
        v5 = arg22.getPassword();
        if(v8.equals(this.lastNonce)) {
            ++this.nounceCount;
        }
        else {
            this.nounceCount = 1;
            this.cnonce = null;
            this.lastNonce = v8;
        }

        StringBuilder v14 = new StringBuilder(256);
        Formatter v15 = new Formatter(((Appendable)v14), Locale.US);
        v15.format("%08x", Long.valueOf(this.nounceCount));
        v15.close();
        String v15_1 = v14.toString();
        if(this.cnonce == null) {
            this.cnonce = DigestScheme.createCnonce();
        }

        this.a1 = null;
        this.a2 = null;
        if(v2.equalsIgnoreCase("MD5-sess")) {
            v14.setLength(0);
            v14.append(v13).append(':').append(v7).append(':').append(v5);
            v5 = DigestScheme.encode(v12.digest(EncodingUtils.getBytes(v14.toString(), v3_1)));
            v14.setLength(0);
            v14.append(v5).append(':').append(v8).append(':').append(this.cnonce);
            this.a1 = v14.toString();
        }
        else {
            v14.setLength(0);
            v14.append(v13).append(':').append(v7).append(':').append(v5);
            this.a1 = v14.toString();
        }

        String v16 = DigestScheme.encode(v12.digest(EncodingUtils.getBytes(this.a1, v3_1)));
        if(v4_1 == 2) {
            this.a2 = v10 + ':' + v6;
        }
        else if(v4_1 == 1) {
            HttpEntity v5_1 = null;
            if((arg23 instanceof HttpEntityEnclosingRequest)) {
                v5_1 = ((HttpEntityEnclosingRequest)arg23).getEntity();
            }

            if(v5_1 != null && !v5_1.isRepeatable()) {
                if(((Set)v11).contains("auth")) {
                    v4_1 = 2;
                    this.a2 = v10 + ':' + v6;
                    goto label_180;
                }
                else {
                    throw new AuthenticationException("Qop auth-int cannot be used with a non-repeatable entity");
                }
            }

            HttpEntityDigester v11_1 = new HttpEntityDigester(v12);
            if(v5_1 != null) {
                try {
                    v5_1.writeTo(((OutputStream)v11_1));
                label_353:
                    v11_1.close();
                    goto label_354;
                }
                catch(IOException v2_2) {
                    throw new AuthenticationException("I/O error reading entity content", ((Throwable)v2_2));
                }
            }

            goto label_353;
        label_354:
            this.a2 = v10 + ':' + v6 + ':' + DigestScheme.encode(v11_1.getDigest());
        }
        else {
            this.a2 = v10 + ':' + v6;
        }

    label_180:
        v5 = DigestScheme.encode(v12.digest(EncodingUtils.getBytes(this.a2, v3_1)));
        if(v4_1 == 0) {
            v14.setLength(0);
            v14.append(v16).append(':').append(v8).append(':').append(v5);
            v3_1 = v14.toString();
        }
        else {
            v14.setLength(0);
            StringBuilder v10_1 = v14.append(v16).append(':').append(v8).append(':').append(v15_1).append(':').append(this.cnonce).append(':');
            v3_1 = v4_1 == 1 ? "auth-int" : "auth";
            v10_1.append(v3_1).append(':').append(v5);
            v3_1 = v14.toString();
        }

        v3_1 = DigestScheme.encode(v12.digest(EncodingUtils.getAsciiBytes(v3_1)));
        CharArrayBuffer v5_2 = new CharArrayBuffer(128);
        if(this.isProxy()) {
            v5_2.append("Proxy-Authorization");
        }
        else {
            v5_2.append("Authorization");
        }

        v5_2.append(": Digest ");
        ArrayList v10_2 = new ArrayList(20);
        ((List)v10_2).add(new BasicNameValuePair("username", v13));
        ((List)v10_2).add(new BasicNameValuePair("realm", v7));
        ((List)v10_2).add(new BasicNameValuePair("nonce", v8));
        ((List)v10_2).add(new BasicNameValuePair("uri", v6));
        ((List)v10_2).add(new BasicNameValuePair("response", v3_1));
        if(v4_1 != 0) {
            v7 = "qop";
            v3_1 = v4_1 == 1 ? "auth-int" : "auth";
            ((List)v10_2).add(new BasicNameValuePair(v7, v3_1));
            ((List)v10_2).add(new BasicNameValuePair("nc", v15_1));
            ((List)v10_2).add(new BasicNameValuePair("cnonce", this.cnonce));
        }

        ((List)v10_2).add(new BasicNameValuePair("algorithm", v2));
        if(v9 != null) {
            ((List)v10_2).add(new BasicNameValuePair("opaque", v9));
        }

        for(v3 = 0; v3 < ((List)v10_2).size(); ++v3) {
            Object v2_3 = ((List)v10_2).get(v3);
            if(v3 > 0) {
                v5_2.append(", ");
            }

            String v4_2 = ((BasicNameValuePair)v2_3).getName();
            v4_1 = ("nc".equals(v4_2)) || ("qop".equals(v4_2)) || ("algorithm".equals(v4_2)) ? 1 : 0;
            BasicHeaderValueFormatter v6_1 = BasicHeaderValueFormatter.INSTANCE;
            boolean v4_3 = v4_1 == 0 ? true : false;
            v6_1.formatNameValuePair(v5_2, ((NameValuePair)v2_3), v4_3);
        }

        return new BufferedHeader(v5_2);
    }

    private static MessageDigest createMessageDigest(String arg3) {
        try {
            return MessageDigest.getInstance(arg3);
        }
        catch(Exception v0) {
            throw new UnsupportedDigestAlgorithmException("Unsupported algorithm in HTTP Digest authentication: " + arg3);
        }
    }

    static String encode(byte[] arg7) {
        int v1 = arg7.length;
        char[] v2 = new char[v1 * 2];
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            int v3 = arg7[v0] & 15;
            v2[v0 * 2] = DigestScheme.HEXADECIMAL[(arg7[v0] & 240) >> 4];
            v2[v0 * 2 + 1] = DigestScheme.HEXADECIMAL[v3];
        }

        return new String(v2);
    }

    String getA1() {
        return this.a1;
    }

    String getA2() {
        return this.a2;
    }

    String getCnonce() {
        return this.cnonce;
    }

    public String getSchemeName() {
        return "digest";
    }

    public boolean isComplete() {
        boolean v0 = "true".equalsIgnoreCase(this.getParameter("stale")) ? false : this.complete;
        return v0;
    }

    public boolean isConnectionBased() {
        return 0;
    }

    public void overrideParamter(String arg2, String arg3) {
        this.getParameters().put(arg2, arg3);
    }

    public void processChallenge(Header arg2) {
        super.processChallenge(arg2);
        this.complete = true;
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder();
        v0.append("DIGEST [complete=").append(this.complete).append(", nonce=").append(this.lastNonce).append(", nc=").append(this.nounceCount).append("]");
        return v0.toString();
    }
}

