// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.AuthenticationException;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.InvalidCredentialsException;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.message.BufferedHeader;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;
import org.ietf.jgss.GSSContext;
import org.ietf.jgss.GSSException;
import org.ietf.jgss.GSSManager;
import org.ietf.jgss.GSSName;
import org.ietf.jgss.Oid;

@NotThreadSafe public abstract class GGSSchemeBase extends AuthSchemeBase {
    private final Base64 base64codec;
    private final Log log;
    private GGSSchemeBase$State state;
    private final boolean stripPort;
    private byte[] token;

    GGSSchemeBase() {
        this(false);
    }

    GGSSchemeBase(boolean arg3) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        this.base64codec = new Base64(0);
        this.stripPort = arg3;
        this.state = GGSSchemeBase$State.UNINITIATED;
    }

    @Deprecated public Header authenticate(Credentials arg2, HttpRequest arg3) {
        return this.authenticate(arg2, arg3, null);
    }

    public Header authenticate(Credentials arg5, HttpRequest arg6, HttpContext arg7) {
        String v0_3;
        HttpHost v0_2;
        HttpHost v1;
        Object v0_1;
        Args.notNull(arg6, "HTTP request");
        switch(GGSSchemeBase$1.$SwitchMap$org$apache$http$impl$auth$GGSSchemeBase$State[this.state.ordinal()]) {
            case 1: {
                goto label_17;
            }
            case 2: {
                goto label_27;
            }
            case 3: {
                goto label_37;
            }
            case 4: {
                goto label_83;
            }
        }

        throw new IllegalStateException("Illegal state: " + this.state);
        try {
        label_37:
            v0_1 = arg7.getAttribute("http.route");
            if(v0_1 == null) {
                throw new AuthenticationException("Connection route is not available");
            }

            if(this.isProxy()) {
                v1 = ((HttpRoute)v0_1).getProxyHost();
                if(v1 == null) {
                    v0_2 = ((HttpRoute)v0_1).getTargetHost();
                }
                else {
                    goto label_145;
                }
            }
            else {
                goto label_114;
            }

            goto label_62;
        }
        catch(GSSException v0) {
            goto label_46;
        }

    label_145:
        v0_2 = v1;
        goto label_62;
        try {
        label_114:
            v0_2 = ((HttpRoute)v0_1).getTargetHost();
        label_62:
            v0_3 = (this.stripPort) || v0_2.getPort() <= 0 ? v0_2.getHostName() : v0_2.toHostString();
            if(this.log.isDebugEnabled()) {
                this.log.debug("init " + v0_3);
            }

            this.token = this.generateToken(this.token, v0_3);
            this.state = GGSSchemeBase$State.TOKEN_GENERATED;
            goto label_83;
        }
        catch(GSSException v0) {
        label_46:
            this.state = GGSSchemeBase$State.FAILED;
            if(v0.getMajor() != 9 && v0.getMajor() != 8) {
                if(v0.getMajor() == 13) {
                    throw new InvalidCredentialsException(v0.getMessage(), ((Throwable)v0));
                }
                else {
                    if(v0.getMajor() != 10 && v0.getMajor() != 19 && v0.getMajor() != 20) {
                        throw new AuthenticationException(v0.getMessage());
                    }

                    throw new AuthenticationException(v0.getMessage(), ((Throwable)v0));
                }
            }

            throw new InvalidCredentialsException(v0.getMessage(), ((Throwable)v0));
        }

    label_17:
        throw new AuthenticationException(this.getSchemeName() + " authentication has not been initiated");
    label_83:
        v0_3 = new String(this.base64codec.encode(this.token));
        if(this.log.isDebugEnabled()) {
            this.log.debug("Sending response \'" + v0_3 + "\' back to the auth server");
        }

        CharArrayBuffer v1_1 = new CharArrayBuffer(32);
        if(this.isProxy()) {
            v1_1.append("Proxy-Authorization");
        }
        else {
            v1_1.append("Authorization");
        }

        v1_1.append(": Negotiate ");
        v1_1.append(v0_3);
        return new BufferedHeader(v1_1);
    label_27:
        throw new AuthenticationException(this.getSchemeName() + " authentication has failed");
    }

    protected byte[] generateGSSToken(byte[] arg6, Oid arg7, String arg8) {
        if(arg6 == null) {
            arg6 = new byte[0];
        }

        GSSManager v0 = this.getManager();
        GSSContext v0_1 = v0.createContext(v0.createName("HTTP@" + arg8, GSSName.NT_HOSTBASED_SERVICE).canonicalize(arg7), arg7, null, 0);
        v0_1.requestMutualAuth(true);
        v0_1.requestCredDeleg(true);
        return v0_1.initSecContext(arg6, 0, arg6.length);
    }

    protected abstract byte[] generateToken(byte[] arg1, String arg2);

    protected GSSManager getManager() {
        return GSSManager.getInstance();
    }

    public boolean isComplete() {
        boolean v0 = this.state == GGSSchemeBase$State.TOKEN_GENERATED || this.state == GGSSchemeBase$State.FAILED ? true : false;
        return v0;
    }

    protected void parseChallenge(CharArrayBuffer arg5, int arg6, int arg7) {
        String v0 = arg5.substringTrimmed(arg6, arg7);
        if(this.log.isDebugEnabled()) {
            this.log.debug("Received challenge \'" + v0 + "\' from the auth server");
        }

        if(this.state == GGSSchemeBase$State.UNINITIATED) {
            this.token = Base64.decodeBase64(v0.getBytes());
            this.state = GGSSchemeBase$State.CHALLENGE_RECEIVED;
        }
        else {
            this.log.debug("Authentication already attempted");
            this.state = GGSSchemeBase$State.FAILED;
        }
    }
}

