// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import java.util.Locale;
import java.util.Map;
import java.util.Queue;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.auth.AuthOption;
import org.apache.http.auth.AuthProtocolState;
import org.apache.http.auth.AuthScheme;
import org.apache.http.auth.AuthState;
import org.apache.http.auth.AuthenticationException;
import org.apache.http.auth.ContextAwareAuthScheme;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.MalformedChallengeException;
import org.apache.http.client.AuthenticationStrategy;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Asserts;

public class HttpAuthenticator {
    private final Log log;

    public HttpAuthenticator() {
        this(null);
    }

    public HttpAuthenticator(Log arg2) {
        super();
        if(arg2 == null) {
            arg2 = LogFactory.getLog(this.getClass());
        }

        this.log = arg2;
    }

    private Header doAuth(AuthScheme arg2, Credentials arg3, HttpRequest arg4, HttpContext arg5) {
        Header v0 = (arg2 instanceof ContextAwareAuthScheme) ? ((ContextAwareAuthScheme)arg2).authenticate(arg3, arg4, arg5) : arg2.authenticate(arg3, arg4);
        return v0;
    }

    private void ensureAuthScheme(AuthScheme arg2) {
        Asserts.notNull(arg2, "Auth scheme");
    }

    public void generateAuthResponse(HttpRequest arg7, AuthState arg8, HttpContext arg9) {
        AuthScheme v1 = arg8.getAuthScheme();
        Credentials v0 = arg8.getCredentials();
        switch(HttpAuthenticator$1.$SwitchMap$org$apache$http$auth$AuthProtocolState[arg8.getState().ordinal()]) {
            case 1: {
                goto label_15;
            }
            case 3: {
                goto label_11;
            }
            case 4: {
                return;
            }
        }

        goto label_7;
    label_11:
        this.ensureAuthScheme(v1);
        if(!v1.isConnectionBased()) {
            goto label_7;
        }

        return;
    label_15:
        Queue v2 = arg8.getAuthOptions();
        if(v2 != null) {
            while(true) {
                if(v2.isEmpty()) {
                    return;
                }

                Object v0_1 = v2.remove();
                v1 = ((AuthOption)v0_1).getAuthScheme();
                v0 = ((AuthOption)v0_1).getCredentials();
                arg8.update(v1, v0);
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Generating response to an authentication challenge using " + v1.getSchemeName() + " scheme");
                }

                try {
                    arg7.addHeader(this.doAuth(v1, v0, arg7, arg9));
                    return;
                }
                catch(AuthenticationException v0_2) {
                    if(!this.log.isWarnEnabled()) {
                        continue;
                    }

                    this.log.warn(v1 + " authentication error: " + v0_2.getMessage());
                    continue;
                }
            }
        }

        this.ensureAuthScheme(v1);
    label_7:
        if(v1 != null) {
            try {
                arg7.addHeader(this.doAuth(v1, v0, arg7, arg9));
            }
            catch(AuthenticationException v0_2) {
                if(!this.log.isErrorEnabled()) {
                    return;
                }

                this.log.error(v1 + " authentication error: " + v0_2.getMessage());
            }
        }
    }

    public boolean handleAuthChallenge(HttpHost arg7, HttpResponse arg8, AuthenticationStrategy arg9, AuthState arg10, HttpContext arg11) {
        AuthScheme v4;
        Map v3;
        try {
            if(this.log.isDebugEnabled()) {
                this.log.debug(arg7.toHostString() + " requested authentication");
            }

            v3 = arg9.getChallenges(arg7, arg8, arg11);
            if(v3.isEmpty()) {
                this.log.debug("Response contains no authentication challenges");
                boolean v0_1 = false;
                return v0_1;
            }

            v4 = arg10.getAuthScheme();
            switch(HttpAuthenticator$1.$SwitchMap$org$apache$http$auth$AuthProtocolState[arg10.getState().ordinal()]) {
                case 1: 
                case 2: {
                    goto label_68;
                }
                case 3: {
                    goto label_50;
                }
                case 4: {
                    return false;
                }
                case 5: {
                    goto label_79;
                }
            }

            goto label_28;
            return false;
        label_50:
            arg10.reset();
            goto label_28;
        }
        catch(MalformedChallengeException v0) {
            goto label_55;
        }

    label_68:
        if(v4 != null) {
            goto label_79;
        }

        try {
            this.log.debug("Auth scheme is null");
            arg9.authFailed(arg7, null, arg11);
            arg10.reset();
            arg10.setState(AuthProtocolState.FAILURE);
            return false;
        label_79:
            if(v4 != null) {
                Object v0_2 = v3.get(v4.getSchemeName().toLowerCase(Locale.ENGLISH));
                if(v0_2 != null) {
                    this.log.debug("Authorization challenge processed");
                    v4.processChallenge(((Header)v0_2));
                    if(v4.isComplete()) {
                        this.log.debug("Authentication failed");
                        arg9.authFailed(arg7, arg10.getAuthScheme(), arg11);
                        arg10.reset();
                        arg10.setState(AuthProtocolState.FAILURE);
                        return false;
                    }

                    arg10.setState(AuthProtocolState.HANDSHAKE);
                    return true;
                }

                arg10.reset();
            }

        label_28:
            Queue v0_3 = arg9.select(v3, arg7, arg8, arg11);
            if(v0_3 != null && !v0_3.isEmpty()) {
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Selected authentication options: " + v0_3);
                }

                arg10.setState(AuthProtocolState.CHALLENGED);
                arg10.update(v0_3);
                return true;
            }
        }
        catch(MalformedChallengeException v0) {
            goto label_55;
        }

        return false;
    label_55:
        if(this.log.isWarnEnabled()) {
            this.log.warn("Malformed challenge: " + v0.getMessage());
        }

        arg10.reset();
        return false;
    }

    public boolean isAuthenticationRequested(HttpHost arg3, HttpResponse arg4, AuthenticationStrategy arg5, AuthState arg6, HttpContext arg7) {
        boolean v0;
        if(arg5.isAuthenticationRequested(arg3, arg4, arg7)) {
            this.log.debug("Authentication required");
            if(arg6.getState() == AuthProtocolState.SUCCESS) {
                arg5.authFailed(arg3, arg6.getAuthScheme(), arg7);
            }

            v0 = true;
        }
        else {
            switch(HttpAuthenticator$1.$SwitchMap$org$apache$http$auth$AuthProtocolState[arg6.getState().ordinal()]) {
                case 1: 
                case 2: {
                    this.log.debug("Authentication succeeded");
                    arg6.setState(AuthProtocolState.SUCCESS);
                    arg5.authSucceeded(arg3, arg6.getAuthScheme(), arg7);
                    break;
                }
                case 3: {
                    break;
                }
                default: {
                    arg6.setState(AuthProtocolState.UNCHALLENGED);
                    break;
                }
            }

            v0 = false;
        }

        return v0;
    }
}

