// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import java.io.UnsupportedEncodingException;
import java.security.Key;
import java.security.MessageDigest;
import java.security.SecureRandom;
import java.util.Locale;
import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.util.EncodingUtils;

@NotThreadSafe final class NTLMEngineImpl implements NTLMEngine {
    static final String DEFAULT_CHARSET = "ASCII";
    protected static final int FLAG_DOMAIN_PRESENT = 4096;
    protected static final int FLAG_REQUEST_128BIT_KEY_EXCH = 536870912;
    protected static final int FLAG_REQUEST_56BIT_ENCRYPTION = -2147483648;
    protected static final int FLAG_REQUEST_ALWAYS_SIGN = 32768;
    protected static final int FLAG_REQUEST_EXPLICIT_KEY_EXCH = 1073741824;
    protected static final int FLAG_REQUEST_LAN_MANAGER_KEY = 128;
    protected static final int FLAG_REQUEST_NTLM2_SESSION = 524288;
    protected static final int FLAG_REQUEST_NTLMv1 = 512;
    protected static final int FLAG_REQUEST_SEAL = 32;
    protected static final int FLAG_REQUEST_SIGN = 16;
    protected static final int FLAG_REQUEST_TARGET = 4;
    protected static final int FLAG_REQUEST_UNICODE_ENCODING = 1;
    protected static final int FLAG_REQUEST_VERSION = 33554432;
    protected static final int FLAG_TARGETINFO_PRESENT = 8388608;
    protected static final int FLAG_WORKSTATION_PRESENT = 8192;
    private static final SecureRandom RND_GEN;
    private static final byte[] SIGNATURE;
    private String credentialCharset;

    static {
        SecureRandom v0;
        try {
            v0 = SecureRandom.getInstance("SHA1PRNG");
        }
        catch(Exception v1) {
        }

        NTLMEngineImpl.RND_GEN = v0;
        byte[] v0_1 = EncodingUtils.getBytes("NTLMSSP", "ASCII");
        NTLMEngineImpl.SIGNATURE = new byte[v0_1.length + 1];
        System.arraycopy(v0_1, 0, NTLMEngineImpl.SIGNATURE, 0, v0_1.length);
        NTLMEngineImpl.SIGNATURE[v0_1.length] = 0;
    }

    NTLMEngineImpl() {
        super();
        this.credentialCharset = "ASCII";
    }

    static int F(int arg2, int arg3, int arg4) {
        return arg2 & arg3 | (arg2 ^ -1) & arg4;
    }

    static int G(int arg2, int arg3, int arg4) {
        return arg2 & arg3 | arg2 & arg4 | arg3 & arg4;
    }

    static int H(int arg1, int arg2, int arg3) {
        return arg1 ^ arg2 ^ arg3;
    }

    static byte[] RC4(byte[] arg4, byte[] arg5) {
        try {
            Cipher v0_1 = Cipher.getInstance("RC4");
            v0_1.init(1, new SecretKeySpec(arg5, "RC4"));
            return v0_1.doFinal(arg4);
        }
        catch(Exception v0) {
            throw new NTLMEngineException(v0.getMessage(), ((Throwable)v0));
        }
    }

    static byte[] access$000() {
        return NTLMEngineImpl.makeRandomChallenge();
    }

    static byte[] access$100() {
        return NTLMEngineImpl.makeSecondaryKey();
    }

    static byte[] access$1000() {
        return NTLMEngineImpl.SIGNATURE;
    }

    static int access$1100(byte[] arg1, int arg2) {
        return NTLMEngineImpl.readUShort(arg1, arg2);
    }

    static int access$1200(byte[] arg1, int arg2) {
        return NTLMEngineImpl.readULong(arg1, arg2);
    }

    static byte[] access$1300(byte[] arg1, int arg2) {
        return NTLMEngineImpl.readSecurityBuffer(arg1, arg2);
    }

    static String access$1400(String arg1) {
        return NTLMEngineImpl.convertHost(arg1);
    }

    static String access$1500(String arg1) {
        return NTLMEngineImpl.convertDomain(arg1);
    }

    static byte[] access$200(String arg1) {
        return NTLMEngineImpl.lmHash(arg1);
    }

    static byte[] access$300(byte[] arg1, byte[] arg2) {
        return NTLMEngineImpl.lmResponse(arg1, arg2);
    }

    static byte[] access$400(String arg1) {
        return NTLMEngineImpl.ntlmHash(arg1);
    }

    static byte[] access$500(String arg1, String arg2, byte[] arg3) {
        return NTLMEngineImpl.lmv2Hash(arg1, arg2, arg3);
    }

    static byte[] access$600(String arg1, String arg2, byte[] arg3) {
        return NTLMEngineImpl.ntlmv2Hash(arg1, arg2, arg3);
    }

    static byte[] access$700(byte[] arg1, byte[] arg2, byte[] arg3) {
        return NTLMEngineImpl.createBlob(arg1, arg2, arg3);
    }

    static byte[] access$800(byte[] arg1, byte[] arg2, byte[] arg3) {
        return NTLMEngineImpl.lmv2Response(arg1, arg2, arg3);
    }

    static Key access$900(byte[] arg1, int arg2) {
        return NTLMEngineImpl.createDESKey(arg1, arg2);
    }

    private static String convertDomain(String arg1) {
        return NTLMEngineImpl.stripDotSuffix(arg1);
    }

    private static String convertHost(String arg1) {
        return NTLMEngineImpl.stripDotSuffix(arg1);
    }

    private static byte[] createBlob(byte[] arg7, byte[] arg8, byte[] arg9) {
        byte[] v0 = new byte[]{1, 1, 0, 0};
        byte[] v1 = new byte[]{0, 0, 0, 0};
        byte[] v2 = new byte[]{0, 0, 0, 0};
        byte[] v3 = new byte[]{0, 0, 0, 0};
        byte[] v4 = new byte[v0.length + v1.length + arg9.length + 8 + v2.length + arg8.length + v3.length];
        System.arraycopy(v0, 0, v4, 0, v0.length);
        int v0_1 = v0.length;
        System.arraycopy(v1, 0, v4, v0_1, v1.length);
        v0_1 += v1.length;
        System.arraycopy(arg9, 0, v4, v0_1, arg9.length);
        v0_1 += arg9.length;
        System.arraycopy(arg7, 0, v4, v0_1, 8);
        v0_1 += 8;
        System.arraycopy(v2, 0, v4, v0_1, v2.length);
        v0_1 += v2.length;
        System.arraycopy(arg8, 0, v4, v0_1, arg8.length);
        System.arraycopy(v3, 0, v4, v0_1 + arg8.length, v3.length);
        return v4;
    }

    private static Key createDESKey(byte[] arg8, int arg9) {
        byte[] v0 = new byte[7];
        System.arraycopy(arg8, arg9, v0, 0, 7);
        byte[] v1 = new byte[]{v0[0], ((byte)(v0[0] << 7 | (v0[1] & 255) >>> 1)), ((byte)(v0[1] << 6 | (v0[2] & 255) >>> 2)), ((byte)(v0[2] << 5 | (v0[3] & 255) >>> 3)), ((byte)(v0[3] << 4 | (v0[4] & 255) >>> 4)), ((byte)(v0[4] << 3 | (v0[5] & 255) >>> 5)), ((byte)(v0[5] << 2 | (v0[6] & 255) >>> 6)), ((byte)(v0[6] << 1))};
        NTLMEngineImpl.oddParity(v1);
        return new SecretKeySpec(v1, "DES");
    }

    public String generateType1Msg(String arg2, String arg3) {
        return this.getType1Message(arg3, arg2);
    }

    public String generateType3Msg(String arg10, String arg11, String arg12, String arg13, String arg14) {
        NTLMEngineImpl$Type2Message v0 = new NTLMEngineImpl$Type2Message(arg14);
        return this.getType3Message(arg10, arg11, arg13, arg12, v0.getChallenge(), v0.getFlags(), v0.getTarget(), v0.getTargetInfo());
    }

    String getCredentialCharset() {
        return this.credentialCharset;
    }

    final String getResponseFor(String arg10, String arg11, String arg12, String arg13, String arg14) {
        String v0_1;
        if(arg10 == null || (arg10.trim().equals(""))) {
            v0_1 = this.getType1Message(arg13, arg14);
        }
        else {
            NTLMEngineImpl$Type2Message v0 = new NTLMEngineImpl$Type2Message(arg10);
            v0_1 = this.getType3Message(arg11, arg12, arg13, arg14, v0.getChallenge(), v0.getFlags(), v0.getTarget(), v0.getTargetInfo());
        }

        return v0_1;
    }

    String getType1Message(String arg2, String arg3) {
        return new NTLMEngineImpl$Type1Message(arg3, arg2).getResponse();
    }

    String getType3Message(String arg10, String arg11, String arg12, String arg13, byte[] arg14, int arg15, String arg16, byte[] arg17) {
        return new NTLMEngineImpl$Type3Message(arg13, arg12, arg10, arg11, arg14, arg15, arg16, arg17).getResponse();
    }

    static byte[] hmacMD5(byte[] arg1, byte[] arg2) {
        NTLMEngineImpl$HMACMD5 v0 = new NTLMEngineImpl$HMACMD5(arg2);
        v0.update(arg1);
        return v0.getOutput();
    }

    private static byte[] lmHash(String arg6) {
        try {
            byte[] v0_1 = arg6.toUpperCase(Locale.ENGLISH).getBytes("US-ASCII");
            int v1 = Math.min(v0_1.length, 14);
            byte[] v2 = new byte[14];
            System.arraycopy(v0_1, 0, v2, 0, v1);
            Key v0_2 = NTLMEngineImpl.createDESKey(v2, 0);
            Key v1_1 = NTLMEngineImpl.createDESKey(v2, 7);
            v2 = "KGS!@#$%".getBytes("US-ASCII");
            Cipher v3 = Cipher.getInstance("DES/ECB/NoPadding");
            v3.init(1, v0_2);
            v0_1 = v3.doFinal(v2);
            v3.init(1, v1_1);
            byte[] v1_2 = v3.doFinal(v2);
            v2 = new byte[16];
            System.arraycopy(v0_1, 0, v2, 0, 8);
            System.arraycopy(v1_2, 0, v2, 8, 8);
            return v2;
        }
        catch(Exception v0) {
            throw new NTLMEngineException(v0.getMessage(), ((Throwable)v0));
        }
    }

    private static byte[] lmResponse(byte[] arg7, byte[] arg8) {
        int v0 = 21;
        try {
            byte[] v0_2 = new byte[v0];
            System.arraycopy(arg7, 0, v0_2, 0, 16);
            Key v1 = NTLMEngineImpl.createDESKey(v0_2, 0);
            Key v2 = NTLMEngineImpl.createDESKey(v0_2, 7);
            Key v0_3 = NTLMEngineImpl.createDESKey(v0_2, 14);
            Cipher v3 = Cipher.getInstance("DES/ECB/NoPadding");
            v3.init(1, v1);
            byte[] v1_1 = v3.doFinal(arg8);
            v3.init(1, v2);
            byte[] v2_1 = v3.doFinal(arg8);
            v3.init(1, v0_3);
            v0_2 = v3.doFinal(arg8);
            byte[] v3_1 = new byte[24];
            System.arraycopy(v1_1, 0, v3_1, 0, 8);
            System.arraycopy(v2_1, 0, v3_1, 8, 8);
            System.arraycopy(v0_2, 0, v3_1, 16, 8);
            return v3_1;
        }
        catch(Exception v0_1) {
            throw new NTLMEngineException(v0_1.getMessage(), ((Throwable)v0_1));
        }
    }

    private static byte[] lmv2Hash(String arg4, String arg5, byte[] arg6) {
        try {
            NTLMEngineImpl$HMACMD5 v0_1 = new NTLMEngineImpl$HMACMD5(arg6);
            v0_1.update(arg5.toUpperCase(Locale.ENGLISH).getBytes("UnicodeLittleUnmarked"));
            if(arg4 != null) {
                v0_1.update(arg4.toUpperCase(Locale.ENGLISH).getBytes("UnicodeLittleUnmarked"));
            }

            return v0_1.getOutput();
        }
        catch(UnsupportedEncodingException v0) {
            throw new NTLMEngineException("Unicode not supported! " + v0.getMessage(), ((Throwable)v0));
        }
    }

    private static byte[] lmv2Response(byte[] arg4, byte[] arg5, byte[] arg6) {
        NTLMEngineImpl$HMACMD5 v0 = new NTLMEngineImpl$HMACMD5(arg4);
        v0.update(arg5);
        v0.update(arg6);
        byte[] v0_1 = v0.getOutput();
        byte[] v1 = new byte[v0_1.length + arg6.length];
        System.arraycopy(v0_1, 0, v1, 0, v0_1.length);
        System.arraycopy(arg6, 0, v1, v0_1.length, arg6.length);
        return v1;
    }

    private static byte[] makeRandomChallenge() {
        if(NTLMEngineImpl.RND_GEN == null) {
            throw new NTLMEngineException("Random generator not available");
        }

        byte[] v0 = new byte[8];
        SecureRandom v1 = NTLMEngineImpl.RND_GEN;
        __monitor_enter(v1);
        try {
            NTLMEngineImpl.RND_GEN.nextBytes(v0);
            __monitor_exit(v1);
            return v0;
        label_15:
            __monitor_exit(v1);
        }
        catch(Throwable v0_1) {
            goto label_15;
        }

        throw v0_1;
    }

    private static byte[] makeSecondaryKey() {
        if(NTLMEngineImpl.RND_GEN == null) {
            throw new NTLMEngineException("Random generator not available");
        }

        byte[] v0 = new byte[16];
        SecureRandom v1 = NTLMEngineImpl.RND_GEN;
        __monitor_enter(v1);
        try {
            NTLMEngineImpl.RND_GEN.nextBytes(v0);
            __monitor_exit(v1);
            return v0;
        label_15:
            __monitor_exit(v1);
        }
        catch(Throwable v0_1) {
            goto label_15;
        }

        throw v0_1;
    }

    static byte[] ntlm2SessionResponse(byte[] arg5, byte[] arg6, byte[] arg7) {
        try {
            MessageDigest v0_1 = MessageDigest.getInstance("MD5");
            v0_1.update(arg6);
            v0_1.update(arg7);
            byte[] v0_2 = v0_1.digest();
            byte[] v1 = new byte[8];
            System.arraycopy(v0_2, 0, v1, 0, 8);
            return NTLMEngineImpl.lmResponse(arg5, v1);
        }
        catch(Exception v0) {
            if((v0 instanceof NTLMEngineException)) {
                throw v0;
            }

            throw new NTLMEngineException(v0.getMessage(), ((Throwable)v0));
        }
    }

    private static byte[] ntlmHash(String arg4) {
        try {
            byte[] v0_1 = arg4.getBytes("UnicodeLittleUnmarked");
            NTLMEngineImpl$MD4 v1 = new NTLMEngineImpl$MD4();
            v1.update(v0_1);
            return v1.getOutput();
        }
        catch(UnsupportedEncodingException v0) {
            throw new NTLMEngineException("Unicode not supported: " + v0.getMessage(), ((Throwable)v0));
        }
    }

    private static byte[] ntlmv2Hash(String arg4, String arg5, byte[] arg6) {
        try {
            NTLMEngineImpl$HMACMD5 v0_1 = new NTLMEngineImpl$HMACMD5(arg6);
            v0_1.update(arg5.toUpperCase(Locale.ENGLISH).getBytes("UnicodeLittleUnmarked"));
            if(arg4 != null) {
                v0_1.update(arg4.getBytes("UnicodeLittleUnmarked"));
            }

            return v0_1.getOutput();
        }
        catch(UnsupportedEncodingException v0) {
            throw new NTLMEngineException("Unicode not supported! " + v0.getMessage(), ((Throwable)v0));
        }
    }

    private static void oddParity(byte[] arg5) {
        int v0;
        for(v0 = 0; v0 < arg5.length; ++v0) {
            int v2 = ((arg5[v0] >>> 1 ^ (arg5[v0] >>> 7 ^ arg5[v0] >>> 6 ^ arg5[v0] >>> 5 ^ arg5[v0] >>> 4 ^ arg5[v0] >>> 3 ^ arg5[v0] >>> 2)) & 1) == 0 ? 1 : 0;
            arg5[v0] = v2 != 0 ? ((byte)(arg5[v0] | 1)) : ((byte)(arg5[v0] & -2));
        }
    }

    private static byte[] readSecurityBuffer(byte[] arg4, int arg5) {
        int v0 = NTLMEngineImpl.readUShort(arg4, arg5);
        int v1 = NTLMEngineImpl.readULong(arg4, arg5 + 4);
        if(arg4.length < v1 + v0) {
            throw new NTLMEngineException("NTLM authentication - buffer too small for data item");
        }

        byte[] v2 = new byte[v0];
        System.arraycopy(arg4, v1, v2, 0, v0);
        return v2;
    }

    private static int readULong(byte[] arg2, int arg3) {
        if(arg2.length < arg3 + 4) {
            throw new NTLMEngineException("NTLM authentication - buffer too small for DWORD");
        }

        return arg2[arg3] & 255 | (arg2[arg3 + 1] & 255) << 8 | (arg2[arg3 + 2] & 255) << 16 | (arg2[arg3 + 3] & 255) << 24;
    }

    private static int readUShort(byte[] arg2, int arg3) {
        if(arg2.length < arg3 + 2) {
            throw new NTLMEngineException("NTLM authentication - buffer too small for WORD");
        }

        return arg2[arg3] & 255 | (arg2[arg3 + 1] & 255) << 8;
    }

    static int rotintlft(int arg2, int arg3) {
        return arg2 << arg3 | arg2 >>> 32 - arg3;
    }

    void setCredentialCharset(String arg1) {
        this.credentialCharset = arg1;
    }

    private static String stripDotSuffix(String arg2) {
        if(arg2 == null) {
            arg2 = null;
        }
        else {
            int v0 = arg2.indexOf(".");
            if(v0 != -1) {
                arg2 = arg2.substring(0, v0);
            }
        }

        return arg2;
    }

    static void writeULong(byte[] arg2, int arg3, int arg4) {
        arg2[arg4] = ((byte)(arg3 & 255));
        arg2[arg4 + 1] = ((byte)(arg3 >> 8 & 255));
        arg2[arg4 + 2] = ((byte)(arg3 >> 16 & 255));
        arg2[arg4 + 3] = ((byte)(arg3 >> 24 & 255));
    }
}

