// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import org.apache.http.Header;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.AuthenticationException;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.InvalidCredentialsException;
import org.apache.http.auth.MalformedChallengeException;
import org.apache.http.auth.NTCredentials;
import org.apache.http.message.BufferedHeader;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class NTLMScheme extends AuthSchemeBase {
    private String challenge;
    private final NTLMEngine engine;
    private NTLMScheme$State state;

    public NTLMScheme() {
        this(new NTLMEngineImpl());
    }

    public NTLMScheme(NTLMEngine arg2) {
        super();
        Args.notNull(arg2, "NTLM engine");
        this.engine = arg2;
        this.state = NTLMScheme$State.UNINITIATED;
        this.challenge = null;
    }

    public Header authenticate(Credentials arg7, HttpRequest arg8) {
        String v0_1;
        try {
            if(this.state != NTLMScheme$State.FAILED) {
                goto label_19;
            }
        }
        catch(ClassCastException v0) {
            throw new InvalidCredentialsException("Credentials cannot be used for NTLM authentication: " + arg7.getClass().getName());
        }

        throw new AuthenticationException("NTLM authentication failed");
    label_19:
        if(this.state == NTLMScheme$State.CHALLENGE_RECEIVED) {
            v0_1 = this.engine.generateType1Msg(((NTCredentials)arg7).getDomain(), ((NTCredentials)arg7).getWorkstation());
            this.state = NTLMScheme$State.MSG_TYPE1_GENERATED;
        }
        else if(this.state == NTLMScheme$State.MSG_TYPE2_RECEVIED) {
            v0_1 = this.engine.generateType3Msg(((NTCredentials)arg7).getUserName(), ((NTCredentials)arg7).getPassword(), ((NTCredentials)arg7).getDomain(), ((NTCredentials)arg7).getWorkstation(), this.challenge);
            this.state = NTLMScheme$State.MSG_TYPE3_GENERATED;
        }
        else {
            goto label_54;
        }

        CharArrayBuffer v1 = new CharArrayBuffer(32);
        if(this.isProxy()) {
            v1.append("Proxy-Authorization");
        }
        else {
            v1.append("Authorization");
        }

        v1.append(": NTLM ");
        v1.append(v0_1);
        return new BufferedHeader(v1);
    label_54:
        throw new AuthenticationException("Unexpected state: " + this.state);
    }

    public String getParameter(String arg2) {
        return null;
    }

    public String getRealm() {
        return null;
    }

    public String getSchemeName() {
        return "ntlm";
    }

    public boolean isComplete() {
        boolean v0 = this.state == NTLMScheme$State.MSG_TYPE3_GENERATED || this.state == NTLMScheme$State.FAILED ? true : false;
        return v0;
    }

    public boolean isConnectionBased() {
        return 1;
    }

    protected void parseChallenge(CharArrayBuffer arg3, int arg4, int arg5) {
        this.challenge = arg3.substringTrimmed(arg4, arg5);
        if(this.challenge.length() == 0) {
            this.state = this.state == NTLMScheme$State.UNINITIATED ? NTLMScheme$State.CHALLENGE_RECEIVED : NTLMScheme$State.FAILED;
        }
        else if(this.state.compareTo(NTLMScheme$State.MSG_TYPE1_GENERATED) < 0) {
            this.state = NTLMScheme$State.FAILED;
            throw new MalformedChallengeException("Out of sequence NTLM response message");
        }
        else if(this.state == NTLMScheme$State.MSG_TYPE1_GENERATED) {
            this.state = NTLMScheme$State.MSG_TYPE2_RECEVIED;
        }
    }
}

