// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.auth;

import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import org.apache.http.Consts;
import org.apache.http.HeaderElement;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.ChallengeState;
import org.apache.http.auth.MalformedChallengeException;
import org.apache.http.message.BasicHeaderValueParser;
import org.apache.http.message.ParserCursor;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public abstract class RFC2617Scheme extends AuthSchemeBase {
    private final Charset credentialsCharset;
    private final Map params;

    public RFC2617Scheme() {
        this(Consts.ASCII);
    }

    public RFC2617Scheme(Charset arg2) {
        super();
        this.params = new HashMap();
        if(arg2 == null) {
            arg2 = Consts.ASCII;
        }

        this.credentialsCharset = arg2;
    }

    @Deprecated public RFC2617Scheme(ChallengeState arg2) {
        super(arg2);
        this.params = new HashMap();
        this.credentialsCharset = Consts.ASCII;
    }

    String getCredentialsCharset(HttpRequest arg3) {
        Object v0 = arg3.getParams().getParameter("http.auth.credential-charset");
        if(v0 == null) {
            String v0_1 = this.getCredentialsCharset().name();
        }

        return ((String)v0);
    }

    public Charset getCredentialsCharset() {
        return this.credentialsCharset;
    }

    public String getParameter(String arg3) {
        String v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            Object v0_1 = this.params.get(arg3.toLowerCase(Locale.ENGLISH));
        }

        return v0;
    }

    protected Map getParameters() {
        return this.params;
    }

    public String getRealm() {
        return this.getParameter("realm");
    }

    protected void parseChallenge(CharArrayBuffer arg7, int arg8, int arg9) {
        HeaderElement[] v1 = BasicHeaderValueParser.INSTANCE.parseElements(arg7, new ParserCursor(arg8, arg7.length()));
        if(v1.length == 0) {
            throw new MalformedChallengeException("Authentication challenge is empty");
        }

        this.params.clear();
        int v2 = v1.length;
        int v0;
        for(v0 = 0; v0 < v2; ++v0) {
            this.params.put(v1[v0].getName(), v1[v0].getValue());
        }
    }
}

