// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.util.HashMap;
import java.util.Map;
import org.apache.http.client.BackoffManager;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.pool.ConnPoolControl;
import org.apache.http.util.Args;

public class AIMDBackoffManager implements BackoffManager {
    private double backoffFactor;
    private int cap;
    private final Clock clock;
    private final ConnPoolControl connPerRoute;
    private long coolDown;
    private final Map lastRouteBackoffs;
    private final Map lastRouteProbes;

    public AIMDBackoffManager(ConnPoolControl arg2) {
        this(arg2, new SystemClock());
    }

    AIMDBackoffManager(ConnPoolControl arg3, Clock arg4) {
        super();
        this.coolDown = 5000;
        this.backoffFactor = 0.5;
        this.cap = 2;
        this.clock = arg4;
        this.connPerRoute = arg3;
        this.lastRouteProbes = new HashMap();
        this.lastRouteBackoffs = new HashMap();
    }

    public void backOff(HttpRoute arg10) {
        ConnPoolControl v1 = this.connPerRoute;
        __monitor_enter(v1);
        try {
            int v0_1 = this.connPerRoute.getMaxPerRoute(arg10);
            Long v2 = this.getLastUpdate(this.lastRouteBackoffs, arg10);
            long v3 = this.clock.getCurrentTime();
            if(v3 - v2.longValue() < this.coolDown) {
                __monitor_exit(v1);
            }
            else {
                this.connPerRoute.setMaxPerRoute(arg10, this.getBackedOffPoolSize(v0_1));
                this.lastRouteBackoffs.put(arg10, Long.valueOf(v3));
                __monitor_exit(v1);
            }

            return;
        label_23:
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            goto label_23;
        }

        throw v0;
    }

    private int getBackedOffPoolSize(int arg5) {
        int v0 = 1;
        if(arg5 > 1) {
            v0 = ((int)Math.floor(this.backoffFactor * (((double)arg5))));
        }

        return v0;
    }

    private Long getLastUpdate(Map arg3, HttpRoute arg4) {
        Long v0_1;
        Object v0 = arg3.get(arg4);
        if(v0 == null) {
            v0_1 = Long.valueOf(0);
        }

        return v0_1;
    }

    public void probe(HttpRoute arg11) {
        ConnPoolControl v1 = this.connPerRoute;
        __monitor_enter(v1);
        try {
            int v0_1 = this.connPerRoute.getMaxPerRoute(arg11);
            if(v0_1 >= this.cap) {
                v0_1 = this.cap;
            }
            else {
                ++v0_1;
            }

            Long v2 = this.getLastUpdate(this.lastRouteProbes, arg11);
            Long v3 = this.getLastUpdate(this.lastRouteBackoffs, arg11);
            long v4 = this.clock.getCurrentTime();
            if(v4 - v2.longValue() < this.coolDown || v4 - v3.longValue() < this.coolDown) {
                __monitor_exit(v1);
            }
            else {
                this.connPerRoute.setMaxPerRoute(arg11, v0_1);
                this.lastRouteProbes.put(arg11, Long.valueOf(v4));
                __monitor_exit(v1);
            }

            return;
        label_33:
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            goto label_33;
        }

        throw v0;
    }

    public void setBackoffFactor(double arg3) {
        boolean v0 = arg3 <= 0 || arg3 >= 1 ? false : true;
        Args.check(v0, "Backoff factor must be 0.0 < f < 1.0");
        this.backoffFactor = arg3;
    }

    public void setCooldownMillis(long arg4) {
        Args.positive(this.coolDown, "Cool down");
        this.coolDown = arg4;
    }

    public void setPerHostConnectionCap(int arg2) {
        Args.positive(arg2, "Per host connection cap");
        this.cap = arg2;
    }
}

