// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Queue;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.FormattedHeader;
import org.apache.http.Header;
import org.apache.http.HttpHost;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.Immutable;
import org.apache.http.auth.AuthOption;
import org.apache.http.auth.AuthScheme;
import org.apache.http.auth.AuthSchemeProvider;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.MalformedChallengeException;
import org.apache.http.client.AuthCache;
import org.apache.http.client.AuthenticationStrategy;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.config.Lookup;
import org.apache.http.protocol.HTTP;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@Immutable abstract class AuthenticationStrategyImpl implements AuthenticationStrategy {
    private static final List DEFAULT_SCHEME_PRIORITY;
    private final int challengeCode;
    private final String headerName;
    private final Log log;

    static {
        AuthenticationStrategyImpl.DEFAULT_SCHEME_PRIORITY = Collections.unmodifiableList(Arrays.asList(new String[]{"negotiate", "Kerberos", "NTLM", "Digest", "Basic"}));
    }

    AuthenticationStrategyImpl(int arg2, String arg3) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        this.challengeCode = arg2;
        this.headerName = arg3;
    }

    public void authFailed(HttpHost arg5, AuthScheme arg6, HttpContext arg7) {
        Args.notNull(arg5, "Host");
        Args.notNull(arg7, "HTTP context");
        AuthCache v0 = HttpClientContext.adapt(arg7).getAuthCache();
        if(v0 != null) {
            if(this.log.isDebugEnabled()) {
                this.log.debug("Clearing cached auth scheme for " + arg5);
            }

            v0.remove(arg5);
        }
    }

    public void authSucceeded(HttpHost arg5, AuthScheme arg6, HttpContext arg7) {
        BasicAuthCache v0_1;
        Args.notNull(arg5, "Host");
        Args.notNull(arg6, "Auth scheme");
        Args.notNull(arg7, "HTTP context");
        HttpClientContext v1 = HttpClientContext.adapt(arg7);
        if(this.isCachable(arg6)) {
            AuthCache v0 = v1.getAuthCache();
            if(v0 == null) {
                v0_1 = new BasicAuthCache();
                v1.setAuthCache(((AuthCache)v0_1));
            }

            if(this.log.isDebugEnabled()) {
                this.log.debug("Caching \'" + arg6.getSchemeName() + "\' auth scheme for " + arg5);
            }

            ((AuthCache)v0_1).put(arg5, arg6);
        }
    }

    public Map getChallenges(HttpHost arg11, HttpResponse arg12, HttpContext arg13) {
        int v0;
        CharArrayBuffer v3;
        Args.notNull(arg12, "HTTP response");
        Header[] v6 = arg12.getHeaders(this.headerName);
        HashMap v7 = new HashMap(v6.length);
        int v8 = v6.length;
        int v5;
        for(v5 = 0; v5 < v8; ++v5) {
            Header v1 = v6[v5];
            if((v1 instanceof FormattedHeader)) {
                v3 = v1.getBuffer();
                v0 = v1.getValuePos();
            }
            else {
                String v3_1 = v1.getValue();
                if(v3_1 == null) {
                    throw new MalformedChallengeException("Header value is null");
                }
                else {
                    CharArrayBuffer v0_1 = new CharArrayBuffer(v3_1.length());
                    v0_1.append(v3_1);
                    v3 = v0_1;
                    v0 = 0;
                }
            }

            while(v0 < v3.length()) {
                if(!HTTP.isWhitespace(v3.charAt(v0))) {
                    break;
                }

                ++v0;
            }

            int v4;
            for(v4 = v0; v4 < v3.length(); ++v4) {
                if(HTTP.isWhitespace(v3.charAt(v4))) {
                    break;
                }
            }

            ((Map)v7).put(v3.substring(v0, v4).toLowerCase(Locale.ENGLISH), v1);
        }

        return ((Map)v7);
    }

    abstract Collection getPreferredAuthSchemes(RequestConfig arg1);

    public boolean isAuthenticationRequested(HttpHost arg3, HttpResponse arg4, HttpContext arg5) {
        Args.notNull(arg4, "HTTP response");
        boolean v0 = arg4.getStatusLine().getStatusCode() == this.challengeCode ? true : false;
        return v0;
    }

    protected boolean isCachable(AuthScheme arg4) {
        boolean v0 = false;
        if(arg4 != null && (arg4.isComplete())) {
            String v1 = arg4.getSchemeName();
            if(!v1.equalsIgnoreCase("Basic") && !v1.equalsIgnoreCase("Digest")) {
                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    public Queue select(Map arg11, HttpHost arg12, HttpResponse arg13, HttpContext arg14) {
        List v0_3;
        LinkedList v0_1;
        Args.notNull(arg11, "Map of auth challenges");
        Args.notNull(arg12, "Host");
        Args.notNull(arg13, "HTTP response");
        Args.notNull(arg14, "HTTP context");
        HttpClientContext v0 = HttpClientContext.adapt(arg14);
        LinkedList v3 = new LinkedList();
        Lookup v4 = v0.getAuthSchemeRegistry();
        if(v4 == null) {
            this.log.debug("Auth scheme registry not set in the context");
            v0_1 = v3;
        }
        else {
            CredentialsProvider v5 = v0.getCredentialsProvider();
            if(v5 == null) {
                this.log.debug("Credentials provider not set in the context");
                v0_1 = v3;
            }
            else {
                Collection v0_2 = this.getPreferredAuthSchemes(v0.getRequestConfig());
                if(v0_2 == null) {
                    v0_3 = AuthenticationStrategyImpl.DEFAULT_SCHEME_PRIORITY;
                }

                if(this.log.isDebugEnabled()) {
                    this.log.debug("Authentication schemes in the order of preference: " + v0_3);
                }

                Iterator v6 = ((Collection)v0_3).iterator();
                while(v6.hasNext()) {
                    Object v0_4 = v6.next();
                    Object v1 = arg11.get(((String)v0_4).toLowerCase(Locale.ENGLISH));
                    if(v1 != null) {
                        Object v2 = v4.lookup(((String)v0_4));
                        if(v2 == null) {
                            if(!this.log.isWarnEnabled()) {
                                continue;
                            }

                            this.log.warn("Authentication scheme " + (((String)v0_4)) + " not supported");
                            continue;
                        }

                        AuthScheme v0_5 = ((AuthSchemeProvider)v2).create(arg14);
                        v0_5.processChallenge(((Header)v1));
                        Credentials v1_1 = v5.getCredentials(new AuthScope(arg12.getHostName(), arg12.getPort(), v0_5.getRealm(), v0_5.getSchemeName()));
                        if(v1_1 == null) {
                            continue;
                        }

                        ((Queue)v3).add(new AuthOption(v0_5, v1_1));
                        continue;
                    }

                    if(!this.log.isDebugEnabled()) {
                        continue;
                    }

                    this.log.debug("Challenge for " + (((String)v0_4)) + " authentication scheme not available");
                }

                v0_1 = v3;
            }
        }

        return ((Queue)v0_1);
    }
}

