// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.URI;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.ServiceUnavailableRetryStrategy;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.EntityUtils;

@Deprecated @ThreadSafe public class AutoRetryHttpClient implements HttpClient {
    private final HttpClient backend;
    private final Log log;
    private final ServiceUnavailableRetryStrategy retryStrategy;

    public AutoRetryHttpClient() {
        this(new DefaultHttpClient(), new DefaultServiceUnavailableRetryStrategy());
    }

    public AutoRetryHttpClient(HttpClient arg2, ServiceUnavailableRetryStrategy arg3) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "HttpClient");
        Args.notNull(arg3, "ServiceUnavailableRetryStrategy");
        this.backend = arg2;
        this.retryStrategy = arg3;
    }

    public AutoRetryHttpClient(HttpClient arg2) {
        this(arg2, new DefaultServiceUnavailableRetryStrategy());
    }

    public AutoRetryHttpClient(ServiceUnavailableRetryStrategy arg2) {
        this(new DefaultHttpClient(), arg2);
    }

    public Object execute(HttpHost arg2, HttpRequest arg3, ResponseHandler arg4) {
        return this.execute(arg2, arg3, arg4, null);
    }

    public Object execute(HttpHost arg2, HttpRequest arg3, ResponseHandler arg4, HttpContext arg5) {
        return arg4.handleResponse(this.execute(arg2, arg3, arg5));
    }

    public HttpResponse execute(HttpHost arg8, HttpRequest arg9, HttpContext arg10) {
        HttpResponse v1;
        int v0 = 1;
        while(true) {
            v1 = this.backend.execute(arg8, arg9, arg10);
            try {
                if(!this.retryStrategy.retryRequest(v1, v0, arg10)) {
                    return v1;
                }

                EntityUtils.consume(v1.getEntity());
                long v2 = this.retryStrategy.getRetryInterval();
                try {
                    this.log.trace("Wait for " + v2);
                    Thread.sleep(v2);
                    ++v0;
                    continue;
                }
                catch(InterruptedException v0_2) {
                    try {
                        Thread.currentThread().interrupt();
                        throw new InterruptedIOException();
                    }
                    catch(RuntimeException v0_1) {
                        try {
                        label_28:
                            EntityUtils.consume(v1.getEntity());
                        }
                        catch(IOException v1_1) {
                            this.log.warn("I/O error consuming response content", ((Throwable)v1_1));
                        }

                        throw v0_1;
                    }
                }
            }
            catch(RuntimeException v0_1) {
                goto label_28;
            }
        }

        return v1;
    }

    public Object execute(HttpUriRequest arg2, ResponseHandler arg3) {
        return this.execute(arg2, arg3, null);
    }

    public Object execute(HttpUriRequest arg2, ResponseHandler arg3, HttpContext arg4) {
        return arg3.handleResponse(this.execute(arg2, arg4));
    }

    public HttpResponse execute(HttpUriRequest arg5, HttpContext arg6) {
        URI v0 = arg5.getURI();
        return this.execute(new HttpHost(v0.getHost(), v0.getPort(), v0.getScheme()), ((HttpRequest)arg5), arg6);
    }

    public HttpResponse execute(HttpHost arg2, HttpRequest arg3) {
        return this.execute(arg2, arg3, null);
    }

    public HttpResponse execute(HttpUriRequest arg2) {
        return this.execute(arg2, null);
    }

    public ClientConnectionManager getConnectionManager() {
        return this.backend.getConnectionManager();
    }

    public HttpParams getParams() {
        return this.backend.getParams();
    }
}

