// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.util.HashMap;
import org.apache.http.HttpHost;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.auth.AuthScheme;
import org.apache.http.client.AuthCache;
import org.apache.http.conn.SchemePortResolver;
import org.apache.http.conn.UnsupportedSchemeException;
import org.apache.http.impl.conn.DefaultSchemePortResolver;
import org.apache.http.util.Args;

@NotThreadSafe public class BasicAuthCache implements AuthCache {
    private final HashMap map;
    private final SchemePortResolver schemePortResolver;

    public BasicAuthCache() {
        this(null);
    }

    public BasicAuthCache(SchemePortResolver arg2) {
        DefaultSchemePortResolver v2;
        super();
        this.map = new HashMap();
        if(arg2 == null) {
            v2 = DefaultSchemePortResolver.INSTANCE;
        }

        this.schemePortResolver = ((SchemePortResolver)v2);
    }

    public void clear() {
        this.map.clear();
    }

    public AuthScheme get(HttpHost arg3) {
        Args.notNull(arg3, "HTTP host");
        return this.map.get(this.getKey(arg3));
    }

    protected HttpHost getKey(HttpHost arg5) {
        int v1;
        if(arg5.getPort() <= 0) {
            try {
                v1 = this.schemePortResolver.resolve(arg5);
            }
            catch(UnsupportedSchemeException v0) {
                return arg5;
            }

            arg5 = new HttpHost(arg5.getHostName(), v1, arg5.getSchemeName());
        }

        return arg5;
    }

    public void put(HttpHost arg3, AuthScheme arg4) {
        Args.notNull(arg3, "HTTP host");
        this.map.put(this.getKey(arg3), arg4);
    }

    public void remove(HttpHost arg3) {
        Args.notNull(arg3, "HTTP host");
        this.map.remove(this.getKey(arg3));
    }

    public String toString() {
        return this.map.toString();
    }
}

