// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;
import org.apache.http.annotation.GuardedBy;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.client.CookieStore;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieIdentityComparator;

@ThreadSafe public class BasicCookieStore implements Serializable, CookieStore {
    @GuardedBy(value="this") private final TreeSet cookies;
    private static final long serialVersionUID = -7581093305228232025L;

    public BasicCookieStore() {
        super();
        this.cookies = new TreeSet(new CookieIdentityComparator());
    }

    public void addCookie(Cookie arg2) {
        __monitor_enter(this);
        if(arg2 != null) {
            try {
                this.cookies.remove(arg2);
                if(!arg2.isExpired(new Date())) {
                    this.cookies.add(arg2);
                }
            }
            catch(Throwable v0) {
                __monitor_exit(this);
                throw v0;
            }
        }

        __monitor_exit(this);
    }

    public void addCookies(Cookie[] arg4) {
        __monitor_enter(this);
        if(arg4 != null) {
            try {
                int v1 = arg4.length;
                int v0_1;
                for(v0_1 = 0; v0_1 < v1; ++v0_1) {
                    this.addCookie(arg4[v0_1]);
                }
            }
            catch(Throwable v0) {
                __monitor_exit(this);
                throw v0;
            }
        }

        __monitor_exit(this);
    }

    public void clear() {
        __monitor_enter(this);
        try {
            this.cookies.clear();
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }

    public boolean clearExpired(Date arg4) {
        boolean v0 = false;
        __monitor_enter(this);
        if(arg4 != null) {
            try {
                Iterator v2 = this.cookies.iterator();
                boolean v1;
                for(v1 = false; v2.hasNext(); v1 = true) {
                    if(!v2.next().isExpired(arg4)) {
                        continue;
                    }

                    v2.remove();
                }
            }
            catch(Throwable v0_1) {
                goto label_19;
            }

            v0 = v1;
        }

        __monitor_exit(this);
        return v0;
    label_19:
        __monitor_exit(this);
        throw v0_1;
    }

    public List getCookies() {
        ArrayList v0_1;
        __monitor_enter(this);
        try {
            v0_1 = new ArrayList(this.cookies);
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
        return ((List)v0_1);
    }

    public String toString() {
        String v0_1;
        __monitor_enter(this);
        try {
            v0_1 = this.cookies.toString();
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
        return v0_1;
    }
}

