// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.Closeable;
import java.io.IOException;
import java.lang.reflect.UndeclaredThrowableException;
import java.net.URI;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpEntity;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.EntityUtils;

@ThreadSafe public abstract class CloseableHttpClient implements Closeable, HttpClient {
    private final Log log;

    public CloseableHttpClient() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    private static HttpHost determineTarget(HttpUriRequest arg4) {
        HttpHost v0 = null;
        URI v1 = arg4.getURI();
        if(v1.isAbsolute()) {
            v0 = URIUtils.extractHost(v1);
            if(v0 == null) {
                throw new ClientProtocolException("URI does not specify a valid host name: " + v1);
            }
        }

        return v0;
    }

    protected abstract CloseableHttpResponse doExecute(HttpHost arg1, HttpRequest arg2, HttpContext arg3);

    public Object execute(HttpHost arg2, HttpRequest arg3, ResponseHandler arg4) {
        return this.execute(arg2, arg3, arg4, null);
    }

    public Object execute(HttpHost arg5, HttpRequest arg6, ResponseHandler arg7, HttpContext arg8) {
        Object v0_1;
        Args.notNull(arg7, "Response handler");
        CloseableHttpResponse v1 = this.execute(arg5, arg6, arg8);
        try {
            v0_1 = arg7.handleResponse(((HttpResponse)v1));
        }
        catch(Exception v0) {
            HttpEntity v1_1 = ((HttpResponse)v1).getEntity();
            try {
                EntityUtils.consume(v1_1);
            }
            catch(Exception v1_2) {
                this.log.warn("Error consuming content after an exception.", ((Throwable)v1_2));
            }

            if((v0 instanceof RuntimeException)) {
                throw v0;
            }

            if((v0 instanceof IOException)) {
                throw v0;
            }

            throw new UndeclaredThrowableException(((Throwable)v0));
        }

        EntityUtils.consume(((HttpResponse)v1).getEntity());
        return v0_1;
    }

    public CloseableHttpResponse execute(HttpHost arg2, HttpRequest arg3, HttpContext arg4) {
        return this.doExecute(arg2, arg3, arg4);
    }

    public Object execute(HttpUriRequest arg2, ResponseHandler arg3) {
        return this.execute(arg2, arg3, null);
    }

    public Object execute(HttpUriRequest arg2, ResponseHandler arg3, HttpContext arg4) {
        return this.execute(CloseableHttpClient.determineTarget(arg2), ((HttpRequest)arg2), arg3, arg4);
    }

    public HttpResponse execute(HttpHost arg2, HttpRequest arg3) {
        return this.execute(arg2, arg3);
    }

    public CloseableHttpResponse execute(HttpHost arg2, HttpRequest arg3) {
        return this.doExecute(arg2, arg3, null);
    }

    public HttpResponse execute(HttpHost arg2, HttpRequest arg3, HttpContext arg4) {
        return this.execute(arg2, arg3, arg4);
    }

    public HttpResponse execute(HttpUriRequest arg2) {
        return this.execute(arg2);
    }

    public CloseableHttpResponse execute(HttpUriRequest arg2) {
        return this.execute(arg2, null);
    }

    public HttpResponse execute(HttpUriRequest arg2, HttpContext arg3) {
        return this.execute(arg2, arg3);
    }

    public CloseableHttpResponse execute(HttpUriRequest arg2, HttpContext arg3) {
        Args.notNull(arg2, "HTTP request");
        return this.doExecute(CloseableHttpClient.determineTarget(arg2), ((HttpRequest)arg2), arg3);
    }
}

