// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.ConnectException;
import java.net.UnknownHostException;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import javax.net.ssl.SSLException;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.HttpRequestRetryHandler;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Immutable public class DefaultHttpRequestRetryHandler implements HttpRequestRetryHandler {
    public static final DefaultHttpRequestRetryHandler INSTANCE;
    private final Set nonRetriableClasses;
    private final boolean requestSentRetryEnabled;
    private final int retryCount;

    static {
        DefaultHttpRequestRetryHandler.INSTANCE = new DefaultHttpRequestRetryHandler();
    }

    public DefaultHttpRequestRetryHandler() {
        this(3, false);
    }

    public DefaultHttpRequestRetryHandler(int arg4, boolean arg5) {
        this(arg4, arg5, Arrays.asList(new Class[]{InterruptedIOException.class, UnknownHostException.class, ConnectException.class, SSLException.class}));
    }

    protected DefaultHttpRequestRetryHandler(int arg4, boolean arg5, Collection arg6) {
        super();
        this.retryCount = arg4;
        this.requestSentRetryEnabled = arg5;
        this.nonRetriableClasses = new HashSet();
        Iterator v1 = arg6.iterator();
        while(v1.hasNext()) {
            this.nonRetriableClasses.add(v1.next());
        }
    }

    public int getRetryCount() {
        return this.retryCount;
    }

    protected boolean handleAsIdempotent(HttpRequest arg2) {
        boolean v0 = !(arg2 instanceof HttpEntityEnclosingRequest) ? true : false;
        return v0;
    }

    public boolean isRequestSentRetryEnabled() {
        return this.requestSentRetryEnabled;
    }

    @Deprecated protected boolean requestIsAborted(HttpRequest arg3) {
        HttpRequest v0 = (arg3 instanceof RequestWrapper) ? ((RequestWrapper)arg3).getOriginal() : arg3;
        boolean v0_1 = !(v0 instanceof HttpUriRequest) || !((HttpUriRequest)v0).isAborted() ? false : true;
        return v0_1;
    }

    public boolean retryRequest(IOException arg6, int arg7, HttpContext arg8) {
        boolean v0;
        Args.notNull(arg6, "Exception parameter");
        Args.notNull(arg8, "HTTP context");
        if(arg7 > this.retryCount) {
            v0 = false;
        }
        else if(this.nonRetriableClasses.contains(arg6.getClass())) {
            v0 = false;
        }
        else {
            Iterator v3 = this.nonRetriableClasses.iterator();
            do {
                if(v3.hasNext()) {
                    if(!v3.next().isInstance(arg6)) {
                        continue;
                    }

                    return false;
                }
                else {
                    goto label_25;
                }
            }
            while(true);

            return false;
        label_25:
            HttpClientContext v0_1 = HttpClientContext.adapt(arg8);
            HttpRequest v3_1 = v0_1.getRequest();
            if(this.requestIsAborted(v3_1)) {
                v0 = false;
            }
            else if(this.handleAsIdempotent(v3_1)) {
                v0 = true;
            }
            else {
                if((v0_1.isRequestSent()) && !this.requestSentRetryEnabled) {
                    return false;
                }

                v0 = true;
            }
        }

        return v0;
    }
}

