// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Locale;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.ProtocolException;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.CircularRedirectException;
import org.apache.http.client.RedirectStrategy;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpHead;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.methods.RequestBuilder;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;
import org.apache.http.util.TextUtils;

@Immutable public class DefaultRedirectStrategy implements RedirectStrategy {
    public static final DefaultRedirectStrategy INSTANCE = null;
    @Deprecated public static final String REDIRECT_LOCATIONS = "http.protocol.redirect-locations";
    private static final String[] REDIRECT_METHODS;
    private final Log log;

    static {
        DefaultRedirectStrategy.INSTANCE = new DefaultRedirectStrategy();
        DefaultRedirectStrategy.REDIRECT_METHODS = new String[]{"GET", "HEAD"};
    }

    public DefaultRedirectStrategy() {
        super();
        this.log = LogFactory.getLog(this.getClass());
    }

    protected URI createLocationURI(String arg5) {
        try {
            URIBuilder v0_1 = new URIBuilder(new URI(arg5).normalize());
            String v1 = v0_1.getHost();
            if(v1 != null) {
                v0_1.setHost(v1.toLowerCase(Locale.ENGLISH));
            }

            if(TextUtils.isEmpty(v0_1.getPath())) {
                v0_1.setPath("/");
            }

            return v0_1.build();
        }
        catch(URISyntaxException v0) {
            throw new ProtocolException("Invalid redirect URI: " + arg5, ((Throwable)v0));
        }
    }

    public URI getLocationURI(HttpRequest arg7, HttpResponse arg8, HttpContext arg9) {
        URI v1_1;
        Args.notNull(arg7, "HTTP request");
        Args.notNull(arg8, "HTTP response");
        Args.notNull(arg9, "HTTP context");
        HttpClientContext v2 = HttpClientContext.adapt(arg9);
        Header v0 = arg8.getFirstHeader("location");
        if(v0 == null) {
            throw new ProtocolException("Received redirect response " + arg8.getStatusLine() + " but no location header");
        }

        String v0_1 = v0.getValue();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Redirect requested to location \'" + v0_1 + "\'");
        }

        RequestConfig v3 = v2.getRequestConfig();
        URI v0_2 = this.createLocationURI(v0_1);
        try {
            if(v0_2.isAbsolute()) {
                goto label_93;
            }
            else if(!v3.isRelativeRedirectsAllowed()) {
                throw new ProtocolException("Relative redirect location \'" + v0_2 + "\' not allowed");
            }
            else {
                HttpHost v1 = v2.getTargetHost();
                Asserts.notNull(v1, "Target host");
                v1_1 = URIUtils.resolve(URIUtils.rewriteURI(new URI(arg7.getRequestLine().getUri()), v1, false), v0_2);
            }

            goto label_69;
        }
        catch(URISyntaxException v0_3) {
            throw new ProtocolException(v0_3.getMessage(), ((Throwable)v0_3));
        }

    label_93:
        v1_1 = v0_2;
    label_69:
        Object v0_4 = v2.getAttribute("http.protocol.redirect-locations");
        if(v0_4 == null) {
            RedirectLocations v0_5 = new RedirectLocations();
            arg9.setAttribute("http.protocol.redirect-locations", v0_5);
        }

        if(!v3.isCircularRedirectsAllowed() && (((RedirectLocations)v0_4).contains(v1_1))) {
            throw new CircularRedirectException("Circular redirect to \'" + v1_1 + "\'");
        }

        ((RedirectLocations)v0_4).add(v1_1);
        return v1_1;
    }

    public HttpUriRequest getRedirect(HttpRequest arg4, HttpResponse arg5, HttpContext arg6) {
        HttpUriRequest v0_3;
        HttpGet v0_2;
        URI v1 = this.getLocationURI(arg4, arg5, arg6);
        String v0 = arg4.getRequestLine().getMethod();
        if(v0.equalsIgnoreCase("HEAD")) {
            HttpHead v0_1 = new HttpHead(v1);
        }
        else if(v0.equalsIgnoreCase("GET")) {
            v0_2 = new HttpGet(v1);
        }
        else if(arg5.getStatusLine().getStatusCode() == 307) {
            v0_3 = RequestBuilder.copy(arg4).setUri(v1).build();
        }
        else {
            v0_2 = new HttpGet(v1);
        }

        return v0_3;
    }

    protected boolean isRedirectable(String arg6) {
        boolean v0 = false;
        String[] v2 = DefaultRedirectStrategy.REDIRECT_METHODS;
        int v3 = v2.length;
        int v1 = 0;
        while(v1 < v3) {
            if(v2[v1].equalsIgnoreCase(arg6)) {
                v0 = true;
            }
            else {
                ++v1;
                continue;
            }

            return v0;
        }

        return v0;
    }

    public boolean isRedirected(HttpRequest arg6, HttpResponse arg7, HttpContext arg8) {
        boolean v0 = true;
        Args.notNull(arg6, "HTTP request");
        Args.notNull(arg7, "HTTP response");
        int v2 = arg7.getStatusLine().getStatusCode();
        String v3 = arg6.getRequestLine().getMethod();
        Header v4 = arg7.getFirstHeader("location");
        switch(v2) {
            case 302: {
                if((this.isRedirectable(v3)) && v4 != null) {
                    return v0;
                }

                v0 = false;
                break;
            }
            case 303: {
                break;
            }
            case 301: 
            case 307: {
                v0 = this.isRedirectable(v3);
                break;
            }
            default: {
                v0 = false;
                break;
            }
        }

        return v0;
    }
}

