// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.Closeable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.atomic.AtomicBoolean;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.concurrent.FutureCallback;
import org.apache.http.protocol.HttpContext;

@ThreadSafe public class FutureRequestExecutionService implements Closeable {
    private final AtomicBoolean closed;
    private final ExecutorService executorService;
    private final HttpClient httpclient;
    private final FutureRequestExecutionMetrics metrics;

    public FutureRequestExecutionService(HttpClient arg3, ExecutorService arg4) {
        super();
        this.metrics = new FutureRequestExecutionMetrics();
        this.closed = new AtomicBoolean(false);
        this.httpclient = arg3;
        this.executorService = arg4;
    }

    public void close() {
        this.closed.set(true);
        this.executorService.shutdownNow();
        if((this.httpclient instanceof Closeable)) {
            this.httpclient.close();
        }
    }

    public HttpRequestFutureTask execute(HttpUriRequest arg2, HttpContext arg3, ResponseHandler arg4) {
        return this.execute(arg2, arg3, arg4, null);
    }

    public HttpRequestFutureTask execute(HttpUriRequest arg8, HttpContext arg9, ResponseHandler arg10, FutureCallback arg11) {
        if(this.closed.get()) {
            throw new IllegalStateException("Close has been called on this httpclient instance.");
        }

        this.metrics.getScheduledConnections().incrementAndGet();
        HttpRequestFutureTask v1 = new HttpRequestFutureTask(arg8, new HttpRequestTaskCallable(this.httpclient, arg8, arg9, arg10, arg11, this.metrics));
        this.executorService.execute(((Runnable)v1));
        return v1;
    }

    public FutureRequestExecutionMetrics metrics() {
        return this.metrics;
    }
}

