// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.Closeable;
import java.net.ProxySelector;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocketFactory;
import org.apache.http.ConnectionReuseStrategy;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.HttpResponseInterceptor;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.client.AuthenticationStrategy;
import org.apache.http.client.BackoffManager;
import org.apache.http.client.ConnectionBackoffStrategy;
import org.apache.http.client.CookieStore;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.HttpRequestRetryHandler;
import org.apache.http.client.RedirectStrategy;
import org.apache.http.client.ServiceUnavailableRetryStrategy;
import org.apache.http.client.UserTokenHandler;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.protocol.RequestAcceptEncoding;
import org.apache.http.client.protocol.RequestAddCookies;
import org.apache.http.client.protocol.RequestAuthCache;
import org.apache.http.client.protocol.RequestClientConnControl;
import org.apache.http.client.protocol.RequestDefaultHeaders;
import org.apache.http.client.protocol.RequestExpectContinue;
import org.apache.http.client.protocol.ResponseContentEncoding;
import org.apache.http.client.protocol.ResponseProcessCookies;
import org.apache.http.config.ConnectionConfig;
import org.apache.http.config.Lookup;
import org.apache.http.config.Registry;
import org.apache.http.config.RegistryBuilder;
import org.apache.http.config.SocketConfig;
import org.apache.http.conn.ConnectionKeepAliveStrategy;
import org.apache.http.conn.HttpClientConnectionManager;
import org.apache.http.conn.SchemePortResolver;
import org.apache.http.conn.routing.HttpRoutePlanner;
import org.apache.http.conn.socket.LayeredConnectionSocketFactory;
import org.apache.http.conn.socket.PlainConnectionSocketFactory;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.conn.ssl.SSLContexts;
import org.apache.http.conn.ssl.X509HostnameVerifier;
import org.apache.http.impl.DefaultConnectionReuseStrategy;
import org.apache.http.impl.NoConnectionReuseStrategy;
import org.apache.http.impl.auth.BasicSchemeFactory;
import org.apache.http.impl.auth.DigestSchemeFactory;
import org.apache.http.impl.auth.KerberosSchemeFactory;
import org.apache.http.impl.auth.NTLMSchemeFactory;
import org.apache.http.impl.auth.SPNegoSchemeFactory;
import org.apache.http.impl.conn.DefaultProxyRoutePlanner;
import org.apache.http.impl.conn.DefaultRoutePlanner;
import org.apache.http.impl.conn.DefaultSchemePortResolver;
import org.apache.http.impl.conn.PoolingHttpClientConnectionManager;
import org.apache.http.impl.conn.SystemDefaultRoutePlanner;
import org.apache.http.impl.cookie.BestMatchSpecFactory;
import org.apache.http.impl.cookie.BrowserCompatSpecFactory;
import org.apache.http.impl.cookie.IgnoreSpecFactory;
import org.apache.http.impl.cookie.NetscapeDraftSpecFactory;
import org.apache.http.impl.cookie.RFC2109SpecFactory;
import org.apache.http.impl.cookie.RFC2965SpecFactory;
import org.apache.http.impl.execchain.BackoffStrategyExec;
import org.apache.http.impl.execchain.ClientExecChain;
import org.apache.http.impl.execchain.MainClientExec;
import org.apache.http.impl.execchain.ProtocolExec;
import org.apache.http.impl.execchain.RedirectExec;
import org.apache.http.impl.execchain.RetryExec;
import org.apache.http.impl.execchain.ServiceUnavailableRetryExec;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.protocol.HttpProcessorBuilder;
import org.apache.http.protocol.HttpRequestExecutor;
import org.apache.http.protocol.RequestContent;
import org.apache.http.protocol.RequestTargetHost;
import org.apache.http.protocol.RequestUserAgent;
import org.apache.http.util.TextUtils;
import org.apache.http.util.VersionInfo;

@NotThreadSafe public class HttpClientBuilder {
    private boolean authCachingDisabled;
    private Lookup authSchemeRegistry;
    private boolean automaticRetriesDisabled;
    private BackoffManager backoffManager;
    private List closeables;
    private HttpClientConnectionManager connManager;
    private ConnectionBackoffStrategy connectionBackoffStrategy;
    private boolean connectionStateDisabled;
    private boolean contentCompressionDisabled;
    private boolean cookieManagementDisabled;
    private Lookup cookieSpecRegistry;
    private CookieStore cookieStore;
    private CredentialsProvider credentialsProvider;
    private ConnectionConfig defaultConnectionConfig;
    private Collection defaultHeaders;
    private RequestConfig defaultRequestConfig;
    private SocketConfig defaultSocketConfig;
    private X509HostnameVerifier hostnameVerifier;
    private HttpProcessor httpprocessor;
    private ConnectionKeepAliveStrategy keepAliveStrategy;
    private int maxConnPerRoute;
    private int maxConnTotal;
    private HttpHost proxy;
    private AuthenticationStrategy proxyAuthStrategy;
    private boolean redirectHandlingDisabled;
    private RedirectStrategy redirectStrategy;
    private HttpRequestExecutor requestExec;
    private LinkedList requestFirst;
    private LinkedList requestLast;
    private LinkedList responseFirst;
    private LinkedList responseLast;
    private HttpRequestRetryHandler retryHandler;
    private ConnectionReuseStrategy reuseStrategy;
    private HttpRoutePlanner routePlanner;
    private SchemePortResolver schemePortResolver;
    private ServiceUnavailableRetryStrategy serviceUnavailStrategy;
    private LayeredConnectionSocketFactory sslSocketFactory;
    private SSLContext sslcontext;
    private boolean systemProperties;
    private AuthenticationStrategy targetAuthStrategy;
    private String userAgent;
    private UserTokenHandler userTokenHandler;

    static {
        VersionInfo v0 = VersionInfo.loadVersionInfo("org.apache.http.client", HttpClientBuilder.class.getClassLoader());
        String v0_1 = v0 != null ? v0.getRelease() : "UNAVAILABLE";
        HttpClientBuilder.DEFAULT_USER_AGENT = "Apache-HttpClient/" + v0_1 + " (java 1.5)";
    }

    protected HttpClientBuilder() {
        super();
        this.maxConnTotal = 0;
        this.maxConnPerRoute = 0;
    }

    protected void addCloseable(Closeable arg2) {
        if(arg2 != null) {
            if(this.closeables == null) {
                this.closeables = new ArrayList();
            }

            this.closeables.add(arg2);
        }
    }

    public final HttpClientBuilder addInterceptorFirst(HttpRequestInterceptor arg2) {
        if(arg2 != null) {
            if(this.requestFirst == null) {
                this.requestFirst = new LinkedList();
            }

            this.requestFirst.addFirst(arg2);
        }

        return this;
    }

    public final HttpClientBuilder addInterceptorFirst(HttpResponseInterceptor arg2) {
        if(arg2 != null) {
            if(this.responseFirst == null) {
                this.responseFirst = new LinkedList();
            }

            this.responseFirst.addFirst(arg2);
        }

        return this;
    }

    public final HttpClientBuilder addInterceptorLast(HttpRequestInterceptor arg2) {
        if(arg2 != null) {
            if(this.requestLast == null) {
                this.requestLast = new LinkedList();
            }

            this.requestLast.addLast(arg2);
        }

        return this;
    }

    public final HttpClientBuilder addInterceptorLast(HttpResponseInterceptor arg2) {
        if(arg2 != null) {
            if(this.responseLast == null) {
                this.responseLast = new LinkedList();
            }

            this.responseLast.addLast(arg2);
        }

        return this;
    }

    public CloseableHttpClient build() {
        ArrayList v9_1;
        BasicCredentialsProvider v7_5;
        BasicCookieStore v6_3;
        Registry v5_5;
        RetryExec v1_8;
        RedirectExec v0_12;
        SystemDefaultRoutePlanner v3_6;
        DefaultSchemePortResolver v1_4;
        RetryExec v0_10;
        DefaultHttpRequestRetryHandler v0_9;
        Iterator v1_2;
        Iterator v5_2;
        String v1_1;
        ProxyAuthenticationStrategy v6_1;
        DefaultConnectionKeepAliveStrategy v4_2;
        DefaultConnectionReuseStrategy v3_2;
        NoConnectionReuseStrategy v0_5;
        PoolingHttpClientConnectionManager v2_2;
        SSLConnectionSocketFactory v0_2;
        String[] v9 = null;
        HttpRequestExecutor v1 = this.requestExec;
        if(v1 == null) {
            v1 = new HttpRequestExecutor();
        }

        HttpClientConnectionManager v2 = this.connManager;
        if(v2 == null) {
            LayeredConnectionSocketFactory v0 = this.sslSocketFactory;
            if(v0 == null) {
                String[] v2_1 = this.systemProperties ? HttpClientBuilder.split(System.getProperty("https.protocols")) : v9;
                String[] v3 = this.systemProperties ? HttpClientBuilder.split(System.getProperty("https.cipherSuites")) : v9;
                X509HostnameVerifier v0_1 = this.hostnameVerifier;
                X509HostnameVerifier v4 = v0_1 == null ? SSLConnectionSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER : v0_1;
                if(this.sslcontext != null) {
                    v0_2 = new SSLConnectionSocketFactory(this.sslcontext, v2_1, v3, v4);
                    goto label_30;
                }

                if(this.systemProperties) {
                    v0_2 = new SSLConnectionSocketFactory(SSLSocketFactory.getDefault(), v2_1, v3, v4);
                    goto label_30;
                }

                v0_2 = new SSLConnectionSocketFactory(SSLContexts.createDefault(), v4);
            }

        label_30:
            v2_2 = new PoolingHttpClientConnectionManager(RegistryBuilder.create().register("http", PlainConnectionSocketFactory.getSocketFactory()).register("https", v0_2).build());
            if(this.defaultSocketConfig != null) {
                v2_2.setDefaultSocketConfig(this.defaultSocketConfig);
            }

            if(this.defaultConnectionConfig != null) {
                v2_2.setDefaultConnectionConfig(this.defaultConnectionConfig);
            }

            if((this.systemProperties) && ("true".equalsIgnoreCase(System.getProperty("http.keepAlive", "true")))) {
                int v0_3 = Integer.parseInt(System.getProperty("http.maxConnections", "5"));
                v2_2.setDefaultMaxPerRoute(v0_3);
                v2_2.setMaxTotal(v0_3 * 2);
            }

            if(this.maxConnTotal > 0) {
                v2_2.setMaxTotal(this.maxConnTotal);
            }

            if(this.maxConnPerRoute <= 0) {
                goto label_70;
            }

            v2_2.setDefaultMaxPerRoute(this.maxConnPerRoute);
        }

    label_70:
        ConnectionReuseStrategy v3_1 = this.reuseStrategy;
        if(v3_1 == null) {
            if(this.systemProperties) {
                if("true".equalsIgnoreCase(System.getProperty("http.keepAlive", "true"))) {
                    DefaultConnectionReuseStrategy v0_4 = DefaultConnectionReuseStrategy.INSTANCE;
                }
                else {
                    v0_5 = NoConnectionReuseStrategy.INSTANCE;
                }

                v3_2 = ((DefaultConnectionReuseStrategy)v0_5);
            }
            else {
                v3_2 = DefaultConnectionReuseStrategy.INSTANCE;
            }
        }

        ConnectionKeepAliveStrategy v4_1 = this.keepAliveStrategy;
        if(v4_1 == null) {
            v4_2 = DefaultConnectionKeepAliveStrategy.INSTANCE;
        }

        AuthenticationStrategy v5 = this.targetAuthStrategy;
        if(v5 == null) {
            TargetAuthenticationStrategy v5_1 = TargetAuthenticationStrategy.INSTANCE;
        }

        AuthenticationStrategy v6 = this.proxyAuthStrategy;
        if(v6 == null) {
            v6_1 = ProxyAuthenticationStrategy.INSTANCE;
        }

        UserTokenHandler v7 = this.userTokenHandler;
        if(v7 == null) {
            if(!this.connectionStateDisabled) {
                DefaultUserTokenHandler v7_1 = DefaultUserTokenHandler.INSTANCE;
            }
            else {
                NoopUserTokenHandler v7_2 = NoopUserTokenHandler.INSTANCE;
            }
        }

        ClientExecChain v3_3 = this.decorateMainExec(new MainClientExec(v1, ((HttpClientConnectionManager)v2_2), v3_1, ((ConnectionKeepAliveStrategy)v4_2), v5, ((AuthenticationStrategy)v6_1), v7));
        HttpProcessor v0_6 = this.httpprocessor;
        if(v0_6 == null) {
            String v0_7 = this.userAgent;
            if(v0_7 == null) {
                if(this.systemProperties) {
                    v0_7 = System.getProperty("http.agent");
                }

                if(v0_7 != null) {
                    goto label_357;
                }

                v1_1 = HttpClientBuilder.DEFAULT_USER_AGENT;
            }
            else {
            label_357:
                v1_1 = v0_7;
            }

            HttpProcessorBuilder v4_3 = HttpProcessorBuilder.create();
            if(this.requestFirst != null) {
                v5_2 = this.requestFirst.iterator();
                while(v5_2.hasNext()) {
                    v4_3.addFirst(v5_2.next());
                }
            }

            if(this.responseFirst != null) {
                v5_2 = this.responseFirst.iterator();
                while(v5_2.hasNext()) {
                    v4_3.addFirst(v5_2.next());
                }
            }

            v4_3.addAll(new HttpRequestInterceptor[]{new RequestDefaultHeaders(this.defaultHeaders), new RequestContent(), new RequestTargetHost(), new RequestClientConnControl(), new RequestUserAgent(v1_1), new RequestExpectContinue()});
            if(!this.cookieManagementDisabled) {
                v4_3.add(new RequestAddCookies());
            }

            if(!this.contentCompressionDisabled) {
                v4_3.add(new RequestAcceptEncoding());
            }

            if(!this.authCachingDisabled) {
                v4_3.add(new RequestAuthCache());
            }

            if(!this.cookieManagementDisabled) {
                v4_3.add(new ResponseProcessCookies());
            }

            if(!this.contentCompressionDisabled) {
                v4_3.add(new ResponseContentEncoding());
            }

            if(this.requestLast != null) {
                v1_2 = this.requestLast.iterator();
                while(v1_2.hasNext()) {
                    v4_3.addLast(v1_2.next());
                }
            }

            if(this.responseLast != null) {
                v1_2 = this.responseLast.iterator();
                while(v1_2.hasNext()) {
                    v4_3.addLast(v1_2.next());
                }
            }

            v0_6 = v4_3.build();
        }

        v3_3 = this.decorateProtocolExec(new ProtocolExec(v3_3, v0_6));
        if(!this.automaticRetriesDisabled) {
            HttpRequestRetryHandler v0_8 = this.retryHandler;
            if(v0_8 == null) {
                v0_9 = DefaultHttpRequestRetryHandler.INSTANCE;
            }

            v0_10 = new RetryExec(v3_3, ((HttpRequestRetryHandler)v0_9));
        }
        else {
            ClientExecChain v0_11 = v3_3;
        }

        HttpRoutePlanner v3_4 = this.routePlanner;
        if(v3_4 == null) {
            SchemePortResolver v1_3 = this.schemePortResolver;
            if(v1_3 == null) {
                v1_4 = DefaultSchemePortResolver.INSTANCE;
            }

            if(this.proxy != null) {
                DefaultProxyRoutePlanner v3_5 = new DefaultProxyRoutePlanner(this.proxy, ((SchemePortResolver)v1_4));
                goto label_243;
            }

            if(this.systemProperties) {
                v3_6 = new SystemDefaultRoutePlanner(((SchemePortResolver)v1_4), ProxySelector.getDefault());
                goto label_243;
            }

            DefaultRoutePlanner v3_7 = new DefaultRoutePlanner(((SchemePortResolver)v1_4));
        }

    label_243:
        if(!this.redirectHandlingDisabled) {
            RedirectStrategy v1_5 = this.redirectStrategy;
            if(v1_5 == null) {
                DefaultRedirectStrategy v1_6 = DefaultRedirectStrategy.INSTANCE;
            }

            v0_12 = new RedirectExec(((ClientExecChain)v0_10), ((HttpRoutePlanner)v3_6), v1_5);
        }

        ServiceUnavailableRetryStrategy v4_4 = this.serviceUnavailStrategy;
        if(v4_4 != null) {
            ServiceUnavailableRetryExec v0_13 = new ServiceUnavailableRetryExec(((ClientExecChain)v0_12), v4_4);
        }

        BackoffManager v4_5 = this.backoffManager;
        ConnectionBackoffStrategy v5_3 = this.connectionBackoffStrategy;
        if(v4_5 == null || v5_3 == null) {
            v1_8 = ((RetryExec)v0_12);
        }
        else {
            BackoffStrategyExec v1_7 = new BackoffStrategyExec(((ClientExecChain)v0_12), v5_3, v4_5);
        }

        Lookup v5_4 = this.authSchemeRegistry;
        if(v5_4 == null) {
            v5_5 = RegistryBuilder.create().register("Basic", new BasicSchemeFactory()).register("Digest", new DigestSchemeFactory()).register("NTLM", new NTLMSchemeFactory()).register("negotiate", new SPNegoSchemeFactory()).register("Kerberos", new KerberosSchemeFactory()).build();
        }

        Lookup v4_6 = this.cookieSpecRegistry;
        if(v4_6 == null) {
            Registry v4_7 = RegistryBuilder.create().register("best-match", new BestMatchSpecFactory()).register("standard", new RFC2965SpecFactory()).register("compatibility", new BrowserCompatSpecFactory()).register("netscape", new NetscapeDraftSpecFactory()).register("ignoreCookies", new IgnoreSpecFactory()).register("rfc2109", new RFC2109SpecFactory()).register("rfc2965", new RFC2965SpecFactory()).build();
        }

        CookieStore v6_2 = this.cookieStore;
        if(v6_2 == null) {
            v6_3 = new BasicCookieStore();
        }

        CredentialsProvider v7_3 = this.credentialsProvider;
        if(v7_3 == null) {
            if(this.systemProperties) {
                SystemDefaultCredentialsProvider v7_4 = new SystemDefaultCredentialsProvider();
            }
            else {
                v7_5 = new BasicCredentialsProvider();
            }
        }

        RequestConfig v8 = this.defaultRequestConfig != null ? this.defaultRequestConfig : RequestConfig.DEFAULT;
        if(this.closeables != null) {
            v9_1 = new ArrayList(this.closeables);
        }

        return new InternalHttpClient(((ClientExecChain)v1_8), ((HttpClientConnectionManager)v2_2), ((HttpRoutePlanner)v3_6), v4_6, ((Lookup)v5_5), ((CookieStore)v6_3), ((CredentialsProvider)v7_5), v8, ((List)v9_1));
    }

    public static HttpClientBuilder create() {
        return new HttpClientBuilder();
    }

    protected ClientExecChain decorateMainExec(ClientExecChain arg1) {
        return arg1;
    }

    protected ClientExecChain decorateProtocolExec(ClientExecChain arg1) {
        return arg1;
    }

    public final HttpClientBuilder disableAuthCaching() {
        this.authCachingDisabled = true;
        return this;
    }

    public final HttpClientBuilder disableAutomaticRetries() {
        this.automaticRetriesDisabled = true;
        return this;
    }

    public final HttpClientBuilder disableConnectionState() {
        this.connectionStateDisabled = true;
        return this;
    }

    public final HttpClientBuilder disableContentCompression() {
        this.contentCompressionDisabled = true;
        return this;
    }

    public final HttpClientBuilder disableCookieManagement() {
        this.cookieManagementDisabled = true;
        return this;
    }

    public final HttpClientBuilder disableRedirectHandling() {
        this.redirectHandlingDisabled = true;
        return this;
    }

    public final HttpClientBuilder setBackoffManager(BackoffManager arg1) {
        this.backoffManager = arg1;
        return this;
    }

    public final HttpClientBuilder setConnectionBackoffStrategy(ConnectionBackoffStrategy arg1) {
        this.connectionBackoffStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setConnectionManager(HttpClientConnectionManager arg1) {
        this.connManager = arg1;
        return this;
    }

    public final HttpClientBuilder setConnectionReuseStrategy(ConnectionReuseStrategy arg1) {
        this.reuseStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultAuthSchemeRegistry(Lookup arg1) {
        this.authSchemeRegistry = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultConnectionConfig(ConnectionConfig arg1) {
        this.defaultConnectionConfig = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultCookieSpecRegistry(Lookup arg1) {
        this.cookieSpecRegistry = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultCookieStore(CookieStore arg1) {
        this.cookieStore = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultCredentialsProvider(CredentialsProvider arg1) {
        this.credentialsProvider = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultHeaders(Collection arg1) {
        this.defaultHeaders = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultRequestConfig(RequestConfig arg1) {
        this.defaultRequestConfig = arg1;
        return this;
    }

    public final HttpClientBuilder setDefaultSocketConfig(SocketConfig arg1) {
        this.defaultSocketConfig = arg1;
        return this;
    }

    public final HttpClientBuilder setHostnameVerifier(X509HostnameVerifier arg1) {
        this.hostnameVerifier = arg1;
        return this;
    }

    public final HttpClientBuilder setHttpProcessor(HttpProcessor arg1) {
        this.httpprocessor = arg1;
        return this;
    }

    public final HttpClientBuilder setKeepAliveStrategy(ConnectionKeepAliveStrategy arg1) {
        this.keepAliveStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setMaxConnPerRoute(int arg1) {
        this.maxConnPerRoute = arg1;
        return this;
    }

    public final HttpClientBuilder setMaxConnTotal(int arg1) {
        this.maxConnTotal = arg1;
        return this;
    }

    public final HttpClientBuilder setProxy(HttpHost arg1) {
        this.proxy = arg1;
        return this;
    }

    public final HttpClientBuilder setProxyAuthenticationStrategy(AuthenticationStrategy arg1) {
        this.proxyAuthStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setRedirectStrategy(RedirectStrategy arg1) {
        this.redirectStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setRequestExecutor(HttpRequestExecutor arg1) {
        this.requestExec = arg1;
        return this;
    }

    public final HttpClientBuilder setRetryHandler(HttpRequestRetryHandler arg1) {
        this.retryHandler = arg1;
        return this;
    }

    public final HttpClientBuilder setRoutePlanner(HttpRoutePlanner arg1) {
        this.routePlanner = arg1;
        return this;
    }

    public final HttpClientBuilder setSSLSocketFactory(LayeredConnectionSocketFactory arg1) {
        this.sslSocketFactory = arg1;
        return this;
    }

    public final HttpClientBuilder setSchemePortResolver(SchemePortResolver arg1) {
        this.schemePortResolver = arg1;
        return this;
    }

    public final HttpClientBuilder setServiceUnavailableRetryStrategy(ServiceUnavailableRetryStrategy arg1) {
        this.serviceUnavailStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setSslcontext(SSLContext arg1) {
        this.sslcontext = arg1;
        return this;
    }

    public final HttpClientBuilder setTargetAuthenticationStrategy(AuthenticationStrategy arg1) {
        this.targetAuthStrategy = arg1;
        return this;
    }

    public final HttpClientBuilder setUserAgent(String arg1) {
        this.userAgent = arg1;
        return this;
    }

    public final HttpClientBuilder setUserTokenHandler(UserTokenHandler arg1) {
        this.userTokenHandler = arg1;
        return this;
    }

    private static String[] split(String arg1) {
        String[] v0 = TextUtils.isBlank(((CharSequence)arg1)) ? null : arg1.split(" *, *");
        return v0;
    }

    public final HttpClientBuilder useSystemProperties() {
        this.systemProperties = true;
        return this;
    }
}

