// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.util.concurrent.Callable;
import java.util.concurrent.FutureTask;
import org.apache.http.client.methods.HttpUriRequest;

public class HttpRequestFutureTask extends FutureTask {
    private final HttpRequestTaskCallable callable;
    private final HttpUriRequest request;

    public HttpRequestFutureTask(HttpUriRequest arg1, HttpRequestTaskCallable arg2) {
        super(((Callable)arg2));
        this.request = arg1;
        this.callable = arg2;
    }

    public boolean cancel(boolean arg2) {
        this.callable.cancel();
        if(arg2) {
            this.request.abort();
        }

        return super.cancel(arg2);
    }

    public long endedTime() {
        if(this.isDone()) {
            return this.callable.getEnded();
        }

        throw new IllegalStateException("Task is not done yet");
    }

    public long requestDuration() {
        if(this.isDone()) {
            return this.endedTime() - this.startedTime();
        }

        throw new IllegalStateException("Task is not done yet");
    }

    public long scheduledTime() {
        return this.callable.getScheduled();
    }

    public long startedTime() {
        return this.callable.getStarted();
    }

    public long taskDuration() {
        if(this.isDone()) {
            return this.endedTime() - this.scheduledTime();
        }

        throw new IllegalStateException("Task is not done yet");
    }

    public String toString() {
        return this.request.getRequestLine().getUri();
    }
}

