// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.util.concurrent.Callable;
import java.util.concurrent.atomic.AtomicBoolean;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.concurrent.FutureCallback;
import org.apache.http.protocol.HttpContext;

class HttpRequestTaskCallable implements Callable {
    private final FutureCallback callback;
    private final AtomicBoolean cancelled;
    private final HttpContext context;
    private long ended;
    private final HttpClient httpclient;
    private final FutureRequestExecutionMetrics metrics;
    private final HttpUriRequest request;
    private final ResponseHandler responseHandler;
    private final long scheduled;
    private long started;

    HttpRequestTaskCallable(HttpClient arg5, HttpUriRequest arg6, HttpContext arg7, ResponseHandler arg8, FutureCallback arg9, FutureRequestExecutionMetrics arg10) {
        super();
        this.cancelled = new AtomicBoolean(false);
        this.scheduled = System.currentTimeMillis();
        this.started = -1;
        this.ended = -1;
        this.httpclient = arg5;
        this.responseHandler = arg8;
        this.request = arg6;
        this.context = arg7;
        this.callback = arg9;
        this.metrics = arg10;
    }

    public Object call() {
        Object v0_2;
        if(!this.cancelled.get()) {
            try {
                this.metrics.getActiveConnections().incrementAndGet();
                this.started = System.currentTimeMillis();
                try {
                    this.metrics.getScheduledConnections().decrementAndGet();
                    v0_2 = this.httpclient.execute(this.request, this.responseHandler, this.context);
                    this.ended = System.currentTimeMillis();
                    this.metrics.getSuccessfulConnections().increment(this.started);
                    if(this.callback != null) {
                        this.callback.completed(v0_2);
                    }
                }
                catch(Exception v0_1) {
                    try {
                        this.metrics.getFailedConnections().increment(this.started);
                        this.ended = System.currentTimeMillis();
                        if(this.callback != null) {
                            this.callback.failed(v0_1);
                        }

                        throw v0_1;
                    }
                    catch(Throwable v0) {
                    label_54:
                        this.metrics.getRequests().increment(this.started);
                        this.metrics.getTasks().increment(this.started);
                        this.metrics.getActiveConnections().decrementAndGet();
                        throw v0;
                    }
                }
            }
            catch(Throwable v0) {
                goto label_54;
            }

            this.metrics.getRequests().increment(this.started);
            this.metrics.getTasks().increment(this.started);
            this.metrics.getActiveConnections().decrementAndGet();
            return v0_2;
        }

        throw new IllegalStateException("call has been cancelled for request " + this.request.getURI());
    }

    public void cancel() {
        this.cancelled.set(true);
        if(this.callback != null) {
            this.callback.cancelled();
        }
    }

    public long getEnded() {
        return this.ended;
    }

    public long getScheduled() {
        return this.scheduled;
    }

    public long getStarted() {
        return this.started;
    }
}

