// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.io.Closeable;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.auth.AuthState;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.CookieStore;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.Configurable;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.params.HttpClientParamConfig;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.config.Lookup;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.HttpClientConnectionManager;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.HttpRoutePlanner;
import org.apache.http.impl.execchain.ClientExecChain;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpParamsNames;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@ThreadSafe class InternalHttpClient extends CloseableHttpClient {
    private final Lookup authSchemeRegistry;
    private final List closeables;
    private final HttpClientConnectionManager connManager;
    private final Lookup cookieSpecRegistry;
    private final CookieStore cookieStore;
    private final CredentialsProvider credentialsProvider;
    private final RequestConfig defaultConfig;
    private final ClientExecChain execChain;
    private final Log log;
    private final HttpRoutePlanner routePlanner;

    public InternalHttpClient(ClientExecChain arg2, HttpClientConnectionManager arg3, HttpRoutePlanner arg4, Lookup arg5, Lookup arg6, CookieStore arg7, CredentialsProvider arg8, RequestConfig arg9, List arg10) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "HTTP client exec chain");
        Args.notNull(arg3, "HTTP connection manager");
        Args.notNull(arg4, "HTTP route planner");
        this.execChain = arg2;
        this.connManager = arg3;
        this.routePlanner = arg4;
        this.cookieSpecRegistry = arg5;
        this.authSchemeRegistry = arg6;
        this.cookieStore = arg7;
        this.credentialsProvider = arg8;
        this.defaultConfig = arg9;
        this.closeables = arg10;
    }

    static HttpClientConnectionManager access$000(InternalHttpClient arg1) {
        return arg1.connManager;
    }

    public void close() {
        this.connManager.shutdown();
        if(this.closeables != null) {
            Iterator v1 = this.closeables.iterator();
            while(v1.hasNext()) {
                Object v0 = v1.next();
                try {
                    ((Closeable)v0).close();
                }
                catch(IOException v0_1) {
                    this.log.error(v0_1.getMessage(), ((Throwable)v0_1));
                }
            }
        }
    }

    private HttpRoute determineRoute(HttpHost arg3, HttpRequest arg4, HttpContext arg5) {
        HttpHost v0_1;
        if(arg3 == null) {
            Object v0 = arg4.getParams().getParameter("http.default-host");
        }
        else {
            v0_1 = arg3;
        }

        return this.routePlanner.determineRoute(v0_1, arg4, arg5);
    }

    protected CloseableHttpResponse doExecute(HttpHost arg8, HttpRequest arg9, HttpContext arg10) {
        RequestConfig v1_1;
        HttpClientContext v6;
        BasicHttpContext v10;
        HttpRequestWrapper v5;
        HttpExecutionAware v4_1;
        RequestConfig v3 = null;
        Args.notNull(arg9, "HTTP request");
        if((arg9 instanceof HttpExecutionAware)) {
            HttpRequest v4 = arg9;
        }
        else {
            v4_1 = ((HttpExecutionAware)v3);
        }

        try {
            v5 = HttpRequestWrapper.wrap(arg9);
            if(arg10 == null) {
                v10 = new BasicHttpContext();
            }

            v6 = HttpClientContext.adapt(((HttpContext)v10));
            if((arg9 instanceof Configurable)) {
                v3 = arg9.getConfig();
            }

            if(v3 == null) {
                HttpParams v2 = arg9.getParams();
                if(!(v2 instanceof HttpParamsNames)) {
                    v1_1 = HttpClientParamConfig.getRequestConfig(v2);
                }
                else if(!v2.getNames().isEmpty()) {
                    v1_1 = HttpClientParamConfig.getRequestConfig(v2);
                }
                else {
                    goto label_41;
                }
            }
            else {
                goto label_41;
            }

            goto label_25;
        }
        catch(HttpException v1) {
            goto label_38;
        }

    label_41:
        v1_1 = v3;
        try {
        label_25:
            if(v1_1 != null) {
                v6.setRequestConfig(v1_1);
            }

            this.setupContext(v6);
            return this.execChain.execute(this.determineRoute(arg8, ((HttpRequest)v5), ((HttpContext)v6)), v5, v6, v4_1);
        }
        catch(HttpException v1) {
        label_38:
            throw new ClientProtocolException(((Throwable)v1));
        }
    }

    public ClientConnectionManager getConnectionManager() {
        return new InternalHttpClient$1(this);
    }

    public HttpParams getParams() {
        throw new UnsupportedOperationException();
    }

    private void setupContext(HttpClientContext arg3) {
        if(arg3.getAttribute("http.auth.target-scope") == null) {
            arg3.setAttribute("http.auth.target-scope", new AuthState());
        }

        if(arg3.getAttribute("http.auth.proxy-scope") == null) {
            arg3.setAttribute("http.auth.proxy-scope", new AuthState());
        }

        if(arg3.getAttribute("http.authscheme-registry") == null) {
            arg3.setAttribute("http.authscheme-registry", this.authSchemeRegistry);
        }

        if(arg3.getAttribute("http.cookiespec-registry") == null) {
            arg3.setAttribute("http.cookiespec-registry", this.cookieSpecRegistry);
        }

        if(arg3.getAttribute("http.cookie-store") == null) {
            arg3.setAttribute("http.cookie-store", this.cookieStore);
        }

        if(arg3.getAttribute("http.auth.credentials-provider") == null) {
            arg3.setAttribute("http.auth.credentials-provider", this.credentialsProvider);
        }

        if(arg3.getAttribute("http.request-config") == null) {
            arg3.setAttribute("http.request-config", this.defaultConfig);
        }
    }
}

