// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.Configurable;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.HttpClientConnectionManager;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.impl.DefaultConnectionReuseStrategy;
import org.apache.http.impl.execchain.MinimalClientExec;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpRequestExecutor;
import org.apache.http.util.Args;

@ThreadSafe class MinimalHttpClient extends CloseableHttpClient {
    private final HttpClientConnectionManager connManager;
    private final HttpParams params;
    private final MinimalClientExec requestExecutor;

    public MinimalHttpClient(HttpClientConnectionManager arg5) {
        super();
        this.connManager = Args.notNull(arg5, "HTTP connection manager");
        this.requestExecutor = new MinimalClientExec(new HttpRequestExecutor(), arg5, DefaultConnectionReuseStrategy.INSTANCE, DefaultConnectionKeepAliveStrategy.INSTANCE);
        this.params = new BasicHttpParams();
    }

    static HttpClientConnectionManager access$000(MinimalHttpClient arg1) {
        return arg1.connManager;
    }

    public void close() {
        this.connManager.shutdown();
    }

    protected CloseableHttpResponse doExecute(HttpHost arg7, HttpRequest arg8, HttpContext arg9) {
        RequestConfig v0_1;
        HttpRoute v5;
        HttpClientContext v4;
        BasicHttpContext v9;
        HttpRequestWrapper v3;
        HttpExecutionAware v2_1;
        RequestConfig v1 = null;
        Args.notNull(arg7, "Target host");
        Args.notNull(arg8, "HTTP request");
        if((arg8 instanceof HttpExecutionAware)) {
            HttpRequest v2 = arg8;
        }
        else {
            v2_1 = ((HttpExecutionAware)v1);
        }

        try {
            v3 = HttpRequestWrapper.wrap(arg8);
            if(arg9 == null) {
                v9 = new BasicHttpContext();
            }

            v4 = HttpClientContext.adapt(((HttpContext)v9));
            v5 = new HttpRoute(arg7);
            if((arg8 instanceof Configurable)) {
                v0_1 = ((Configurable)arg8).getConfig();
            }
            else {
                goto label_29;
            }

            goto label_17;
        }
        catch(HttpException v0) {
            goto label_28;
        }

    label_29:
        v0_1 = v1;
        try {
        label_17:
            if(v0_1 != null) {
                v4.setRequestConfig(v0_1);
            }

            return this.requestExecutor.execute(v5, v3, v4, v2_1);
        }
        catch(HttpException v0) {
        label_28:
            throw new ClientProtocolException(((Throwable)v0));
        }
    }

    public ClientConnectionManager getConnectionManager() {
        return new MinimalHttpClient$1(this);
    }

    public HttpParams getParams() {
        return this.params;
    }
}

