// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.net.Socket;
import org.apache.http.ConnectionReuseStrategy;
import org.apache.http.HttpClientConnection;
import org.apache.http.HttpConnection;
import org.apache.http.HttpEntity;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.auth.AuthSchemeRegistry;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.AuthState;
import org.apache.http.auth.Credentials;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.params.HttpClientParamConfig;
import org.apache.http.client.protocol.RequestClientConnControl;
import org.apache.http.config.ConnectionConfig;
import org.apache.http.conn.HttpConnectionFactory;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.RouteInfo$LayerType;
import org.apache.http.conn.routing.RouteInfo$TunnelType;
import org.apache.http.entity.BufferedHttpEntity;
import org.apache.http.impl.DefaultConnectionReuseStrategy;
import org.apache.http.impl.auth.BasicSchemeFactory;
import org.apache.http.impl.auth.DigestSchemeFactory;
import org.apache.http.impl.auth.HttpAuthenticator;
import org.apache.http.impl.auth.KerberosSchemeFactory;
import org.apache.http.impl.auth.NTLMSchemeFactory;
import org.apache.http.impl.auth.SPNegoSchemeFactory;
import org.apache.http.impl.conn.ManagedHttpClientConnectionFactory;
import org.apache.http.impl.execchain.TunnelRefusedException;
import org.apache.http.message.BasicHttpRequest;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParamConfig;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.protocol.HttpRequestExecutor;
import org.apache.http.protocol.ImmutableHttpProcessor;
import org.apache.http.protocol.RequestTargetHost;
import org.apache.http.protocol.RequestUserAgent;
import org.apache.http.util.Args;
import org.apache.http.util.EntityUtils;

public class ProxyClient {
    private final AuthSchemeRegistry authSchemeRegistry;
    private final HttpAuthenticator authenticator;
    private final HttpConnectionFactory connFactory;
    private final ConnectionConfig connectionConfig;
    private final HttpProcessor httpProcessor;
    private final AuthState proxyAuthState;
    private final ProxyAuthenticationStrategy proxyAuthStrategy;
    private final RequestConfig requestConfig;
    private final HttpRequestExecutor requestExec;
    private final ConnectionReuseStrategy reuseStrategy;

    public ProxyClient() {
        this(null, null, null);
    }

    public ProxyClient(HttpConnectionFactory arg5, ConnectionConfig arg6, RequestConfig arg7) {
        ManagedHttpClientConnectionFactory v5;
        super();
        if(arg5 == null) {
            v5 = ManagedHttpClientConnectionFactory.INSTANCE;
        }

        this.connFactory = ((HttpConnectionFactory)v5);
        if(arg6 == null) {
            arg6 = ConnectionConfig.DEFAULT;
        }

        this.connectionConfig = arg6;
        if(arg7 == null) {
            arg7 = RequestConfig.DEFAULT;
        }

        this.requestConfig = arg7;
        this.httpProcessor = new ImmutableHttpProcessor(new HttpRequestInterceptor[]{new RequestTargetHost(), new RequestClientConnControl(), new RequestUserAgent()});
        this.requestExec = new HttpRequestExecutor();
        this.proxyAuthStrategy = new ProxyAuthenticationStrategy();
        this.authenticator = new HttpAuthenticator();
        this.proxyAuthState = new AuthState();
        this.authSchemeRegistry = new AuthSchemeRegistry();
        this.authSchemeRegistry.register("Basic", new BasicSchemeFactory());
        this.authSchemeRegistry.register("Digest", new DigestSchemeFactory());
        this.authSchemeRegistry.register("NTLM", new NTLMSchemeFactory());
        this.authSchemeRegistry.register("negotiate", new SPNegoSchemeFactory());
        this.authSchemeRegistry.register("Kerberos", new KerberosSchemeFactory());
        this.reuseStrategy = new DefaultConnectionReuseStrategy();
    }

    public ProxyClient(RequestConfig arg2) {
        this(null, null, arg2);
    }

    @Deprecated public ProxyClient(HttpParams arg4) {
        this(null, HttpParamConfig.getConnectionConfig(arg4), HttpClientParamConfig.getRequestConfig(arg4));
    }

    @Deprecated public AuthSchemeRegistry getAuthSchemeRegistry() {
        return this.authSchemeRegistry;
    }

    @Deprecated public HttpParams getParams() {
        return new BasicHttpParams();
    }

    public Socket tunnel(HttpHost arg9, HttpHost arg10, Credentials arg11) {
        HttpResponse v2;
        Args.notNull(arg9, "Proxy host");
        Args.notNull(arg10, "Target host");
        Args.notNull(arg11, "Credentials");
        HttpHost v1 = arg10.getPort() <= 0 ? new HttpHost(arg10.getHostName(), 80, arg10.getSchemeName()) : arg10;
        HttpRoute v0 = new HttpRoute(v1, this.requestConfig.getLocalAddress(), arg9, false, RouteInfo$TunnelType.TUNNELLED, RouteInfo$LayerType.PLAIN);
        HttpConnection v6 = this.connFactory.create(v0, this.connectionConfig);
        BasicHttpContext v5 = new BasicHttpContext();
        BasicHttpRequest v7 = new BasicHttpRequest("CONNECT", v1.toHostString(), HttpVersion.HTTP_1_1);
        BasicCredentialsProvider v1_1 = new BasicCredentialsProvider();
        v1_1.setCredentials(new AuthScope(arg9), arg11);
        ((HttpContext)v5).setAttribute("http.target_host", arg10);
        ((HttpContext)v5).setAttribute("http.connection", v6);
        ((HttpContext)v5).setAttribute("http.request", v7);
        ((HttpContext)v5).setAttribute("http.route", v0);
        ((HttpContext)v5).setAttribute("http.auth.proxy-scope", this.proxyAuthState);
        ((HttpContext)v5).setAttribute("http.auth.credentials-provider", v1_1);
        ((HttpContext)v5).setAttribute("http.authscheme-registry", this.authSchemeRegistry);
        ((HttpContext)v5).setAttribute("http.request-config", this.requestConfig);
        this.requestExec.preProcess(((HttpRequest)v7), this.httpProcessor, ((HttpContext)v5));
        while(true) {
            if(!((ManagedHttpClientConnection)v6).isOpen()) {
                ((ManagedHttpClientConnection)v6).bind(new Socket(arg9.getHostName(), arg9.getPort()));
            }

            this.authenticator.generateAuthResponse(((HttpRequest)v7), this.proxyAuthState, ((HttpContext)v5));
            v2 = this.requestExec.execute(((HttpRequest)v7), ((HttpClientConnection)v6), ((HttpContext)v5));
            if(v2.getStatusLine().getStatusCode() < 200) {
                throw new HttpException("Unexpected response to CONNECT request: " + v2.getStatusLine());
            }

            if((this.authenticator.isAuthenticationRequested(arg9, v2, this.proxyAuthStrategy, this.proxyAuthState, ((HttpContext)v5))) && (this.authenticator.handleAuthChallenge(arg9, v2, this.proxyAuthStrategy, this.proxyAuthState, ((HttpContext)v5)))) {
                if(this.reuseStrategy.keepAlive(v2, ((HttpContext)v5))) {
                    EntityUtils.consume(v2.getEntity());
                }
                else {
                    ((ManagedHttpClientConnection)v6).close();
                }

                ((HttpRequest)v7).removeHeaders("Proxy-Authorization");
                continue;
            }

            break;
        }

        if(v2.getStatusLine().getStatusCode() > 299) {
            HttpEntity v0_1 = v2.getEntity();
            if(v0_1 != null) {
                v2.setEntity(new BufferedHttpEntity(v0_1));
            }

            ((ManagedHttpClientConnection)v6).close();
            throw new TunnelRefusedException("CONNECT refused by proxy: " + v2.getStatusLine(), v2);
        }

        return ((ManagedHttpClientConnection)v6).getSocket();
    }
}

