// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.client;

import java.net.Authenticator;
import java.net.Authenticator$RequestorType;
import java.net.InetAddress;
import java.net.PasswordAuthentication;
import java.net.URL;
import java.util.Locale;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.Credentials;
import org.apache.http.auth.NTCredentials;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.util.Args;

@ThreadSafe public class SystemDefaultCredentialsProvider implements CredentialsProvider {
    private static final Map SCHEME_MAP;
    private final BasicCredentialsProvider internal;

    static {
        SystemDefaultCredentialsProvider.SCHEME_MAP = new ConcurrentHashMap();
        SystemDefaultCredentialsProvider.SCHEME_MAP.put("Basic".toUpperCase(Locale.ENGLISH), "Basic");
        SystemDefaultCredentialsProvider.SCHEME_MAP.put("Digest".toUpperCase(Locale.ENGLISH), "Digest");
        SystemDefaultCredentialsProvider.SCHEME_MAP.put("NTLM".toUpperCase(Locale.ENGLISH), "NTLM");
        SystemDefaultCredentialsProvider.SCHEME_MAP.put("negotiate".toUpperCase(Locale.ENGLISH), "SPNEGO");
        SystemDefaultCredentialsProvider.SCHEME_MAP.put("Kerberos".toUpperCase(Locale.ENGLISH), "Kerberos");
    }

    public SystemDefaultCredentialsProvider() {
        super();
        this.internal = new BasicCredentialsProvider();
    }

    public void clear() {
        this.internal.clear();
    }

    public Credentials getCredentials(AuthScope arg7) {
        UsernamePasswordCredentials v0_3;
        NTCredentials v0_2;
        String v1 = null;
        Args.notNull(arg7, "Auth scope");
        Credentials v0 = this.internal.getCredentials(arg7);
        if(v0 == null) {
            if(arg7.getHost() != null) {
                PasswordAuthentication v0_1 = SystemDefaultCredentialsProvider.getSystemCreds(arg7, Authenticator$RequestorType.SERVER);
                PasswordAuthentication v2 = v0_1 == null ? SystemDefaultCredentialsProvider.getSystemCreds(arg7, Authenticator$RequestorType.PROXY) : v0_1;
                if(v2 == null) {
                    goto label_44;
                }

                String v3 = System.getProperty("http.auth.ntlm.domain");
                if(v3 != null) {
                    v0_2 = new NTCredentials(v2.getUserName(), new String(v2.getPassword()), v1, v3);
                    goto label_6;
                }

                if("NTLM".equalsIgnoreCase(arg7.getScheme())) {
                    v0_2 = new NTCredentials(v2.getUserName(), new String(v2.getPassword()), v1, v1);
                    goto label_6;
                }

                v0_3 = new UsernamePasswordCredentials(v2.getUserName(), new String(v2.getPassword()));
                goto label_6;
            }

        label_44:
            v0 = ((Credentials)v1);
        }

    label_6:
        return ((Credentials)v0_3);
    }

    private static PasswordAuthentication getSystemCreds(AuthScope arg8, Authenticator$RequestorType arg9) {
        InetAddress v1 = null;
        String v0 = arg8.getHost();
        int v2 = arg8.getPort();
        String v3 = v2 == 443 ? "https" : "http";
        return Authenticator.requestPasswordAuthentication(v0, v1, v2, v3, ((String)v1), SystemDefaultCredentialsProvider.translateScheme(arg8.getScheme()), ((URL)v1), arg9);
    }

    public void setCredentials(AuthScope arg2, Credentials arg3) {
        this.internal.setCredentials(arg2, arg3);
    }

    private static String translateScheme(String arg1) {
        String v0;
        if(arg1 == null) {
            v0 = null;
        }
        else {
            Object v0_1 = SystemDefaultCredentialsProvider.SCHEME_MAP.get(arg1);
            if(v0_1 == null) {
                v0 = arg1;
            }
        }

        return v0;
    }
}

