// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.InterruptedIOException;
import org.apache.http.HttpHost;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.OperatedClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.RouteTracker;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated public abstract class AbstractPoolEntry {
    protected final ClientConnectionOperator connOperator;
    public final OperatedClientConnection connection;
    public volatile HttpRoute route;
    protected volatile Object state;
    protected volatile RouteTracker tracker;

    public AbstractPoolEntry(ClientConnectionOperator arg2, HttpRoute arg3) {
        super();
        Args.notNull(arg2, "Connection operator");
        this.connOperator = arg2;
        this.connection = arg2.createConnection();
        this.route = arg3;
        this.tracker = null;
    }

    public Object getState() {
        return this.state;
    }

    public void layerProtocol(HttpContext arg4, HttpParams arg5) {
        Args.notNull(arg5, "HTTP parameters");
        Asserts.notNull(this.tracker, "Route tracker");
        Asserts.check(this.tracker.isConnected(), "Connection not open");
        Asserts.check(this.tracker.isTunnelled(), "Protocol layering without a tunnel not supported");
        boolean v0 = !this.tracker.isLayered() ? true : false;
        Asserts.check(v0, "Multiple protocol layering not supported");
        this.connOperator.updateSecureConnection(this.connection, this.tracker.getTargetHost(), arg4, arg5);
        this.tracker.layerProtocol(this.connection.isSecure());
    }

    public void open(HttpRoute arg8, HttpContext arg9, HttpParams arg10) {
        Args.notNull(arg8, "Route");
        Args.notNull(arg10, "HTTP parameters");
        if(this.tracker != null) {
            boolean v0 = !this.tracker.isConnected() ? true : false;
            Asserts.check(v0, "Connection already open");
        }

        this.tracker = new RouteTracker(arg8);
        HttpHost v6 = arg8.getProxyHost();
        ClientConnectionOperator v0_1 = this.connOperator;
        OperatedClientConnection v1 = this.connection;
        HttpHost v2 = v6 != null ? v6 : arg8.getTargetHost();
        v0_1.openConnection(v1, v2, arg8.getLocalAddress(), arg9, arg10);
        RouteTracker v0_2 = this.tracker;
        if(v0_2 == null) {
            throw new InterruptedIOException("Request aborted");
        }

        if(v6 == null) {
            v0_2.connectTarget(this.connection.isSecure());
        }
        else {
            v0_2.connectProxy(v6, this.connection.isSecure());
        }
    }

    public void setState(Object arg1) {
        this.state = arg1;
    }

    public void shutdownEntry() {
        this.tracker = null;
        this.state = null;
    }

    public void tunnelProxy(HttpHost arg3, boolean arg4, HttpParams arg5) {
        Args.notNull(arg3, "Next proxy");
        Args.notNull(arg5, "Parameters");
        Asserts.notNull(this.tracker, "Route tracker");
        Asserts.check(this.tracker.isConnected(), "Connection not open");
        this.connection.update(null, arg3, arg4, arg5);
        this.tracker.tunnelProxy(arg3, arg4);
    }

    public void tunnelTarget(boolean arg4, HttpParams arg5) {
        Args.notNull(arg5, "HTTP parameters");
        Asserts.notNull(this.tracker, "Route tracker");
        Asserts.check(this.tracker.isConnected(), "Connection not open");
        boolean v0 = !this.tracker.isTunnelled() ? true : false;
        Asserts.check(v0, "Connection is already tunnelled");
        this.connection.update(null, this.tracker.getTargetHost(), arg4, arg5);
        this.tracker.tunnelTarget(arg4);
    }
}

