// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicLong;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpClientConnection;
import org.apache.http.annotation.GuardedBy;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ClientConnectionRequest;
import org.apache.http.conn.ManagedClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated @ThreadSafe public class BasicClientConnectionManager implements ClientConnectionManager {
    private static final AtomicLong COUNTER = null;
    public static final String MISUSE_MESSAGE = "Invalid use of BasicClientConnManager: connection still allocated.\nMake sure to release the connection before allocating another one.";
    @GuardedBy(value="this") private ManagedClientConnectionImpl conn;
    private final ClientConnectionOperator connOperator;
    private final Log log;
    @GuardedBy(value="this") private HttpPoolEntry poolEntry;
    private final SchemeRegistry schemeRegistry;
    @GuardedBy(value="this") private volatile boolean shutdown;

    static {
        BasicClientConnectionManager.COUNTER = new AtomicLong();
    }

    public BasicClientConnectionManager(SchemeRegistry arg2) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "Scheme registry");
        this.schemeRegistry = arg2;
        this.connOperator = this.createConnectionOperator(arg2);
    }

    public BasicClientConnectionManager() {
        this(SchemeRegistryFactory.createDefault());
    }

    private void assertNotShutdown() {
        boolean v0 = !this.shutdown ? true : false;
        Asserts.check(v0, "Connection manager has been shut down");
    }

    public void closeExpiredConnections() {
        __monitor_enter(this);
        try {
            this.assertNotShutdown();
            long v0_1 = System.currentTimeMillis();
            if(this.poolEntry != null && (this.poolEntry.isExpired(v0_1))) {
                this.poolEntry.close();
                this.poolEntry.getTracker().reset();
            }

            __monitor_exit(this);
            return;
        label_16:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_16;
        }

        throw v0;
    }

    public void closeIdleConnections(long arg6, TimeUnit arg8) {
        long v2;
        long v0 = 0;
        Args.notNull(arg8, "Time unit");
        __monitor_enter(this);
        try {
            this.assertNotShutdown();
            v2 = arg8.toMillis(arg6);
            if(v2 >= v0) {
                goto label_24;
            }

            goto label_7;
        }
        catch(Throwable v0_1) {
            goto label_22;
        }

    label_24:
        v0 = v2;
        try {
        label_7:
            v0 = System.currentTimeMillis() - v0;
            if(this.poolEntry != null && this.poolEntry.getUpdated() <= v0) {
                this.poolEntry.close();
                this.poolEntry.getTracker().reset();
            }

            __monitor_exit(this);
            return;
        label_22:
            __monitor_exit(this);
        }
        catch(Throwable v0_1) {
            goto label_22;
        }

        throw v0_1;
    }

    protected ClientConnectionOperator createConnectionOperator(SchemeRegistry arg2) {
        return new DefaultClientConnectionOperator(arg2);
    }

    protected void finalize() {
        try {
            this.shutdown();
            super.finalize();
            return;
        }
        catch(Throwable v0) {
            super.finalize();
            throw v0;
        }
    }

    ManagedClientConnection getConnection(HttpRoute arg9, Object arg10) {
        Args.notNull(arg9, "Route");
        __monitor_enter(this);
        try {
            this.assertNotShutdown();
            if(this.log.isDebugEnabled()) {
                this.log.debug("Get connection for route " + arg9);
            }

            boolean v0_1 = this.conn == null ? true : false;
            Asserts.check(v0_1, "Invalid use of BasicClientConnManager: connection still allocated.\nMake sure to release the connection before allocating another one.");
            if(this.poolEntry != null && !this.poolEntry.getPlannedRoute().equals(arg9)) {
                this.poolEntry.close();
                this.poolEntry = null;
            }

            if(this.poolEntry == null) {
                this.poolEntry = new HttpPoolEntry(this.log, Long.toString(BasicClientConnectionManager.COUNTER.getAndIncrement()), arg9, this.connOperator.createConnection(), 0, TimeUnit.MILLISECONDS);
            }

            if(this.poolEntry.isExpired(System.currentTimeMillis())) {
                this.poolEntry.close();
                this.poolEntry.getTracker().reset();
            }

            this.conn = new ManagedClientConnectionImpl(((ClientConnectionManager)this), this.connOperator, this.poolEntry);
            __monitor_exit(this);
            return this.conn;
        label_64:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_64;
        }

        throw v0;
    }

    public SchemeRegistry getSchemeRegistry() {
        return this.schemeRegistry;
    }

    public void releaseConnection(ManagedClientConnection arg6, long arg7, TimeUnit arg9) {
        boolean v1_1;
        Args.check(arg6 instanceof ManagedClientConnectionImpl, "Connection class mismatch, connection not obtained from this manager");
        ManagedClientConnection v0 = arg6;
        __monitor_enter(v0);
        try {
            if(this.log.isDebugEnabled()) {
                this.log.debug("Releasing connection " + arg6);
            }

            if(((ManagedClientConnectionImpl)v0).getPoolEntry() == null) {
                __monitor_exit(v0);
            }
            else {
                if(((ManagedClientConnectionImpl)v0).getManager() == this) {
                    v1_1 = true;
                }
                else {
                    goto label_35;
                }

                goto label_23;
            }

            return;
        }
        catch(Throwable v1) {
            goto label_33;
        }

    label_35:
        v1_1 = false;
        try {
        label_23:
            Asserts.check(v1_1, "Connection not obtained from this manager");
            __monitor_enter(this);
        }
        catch(Throwable v1) {
            goto label_33;
        }

        try {
            if(!this.shutdown) {
                goto label_37;
            }

            this.shutdownConnection(((HttpClientConnection)v0));
            __monitor_exit(this);
        }
        catch(Throwable v1) {
            goto label_96;
        }

        try {
            __monitor_exit(v0);
            return;
        }
        catch(Throwable v1) {
            goto label_33;
        }

        try {
        label_37:
            if((((ManagedClientConnectionImpl)v0).isOpen()) && !((ManagedClientConnectionImpl)v0).isMarkedReusable()) {
                this.shutdownConnection(((HttpClientConnection)v0));
            }

            if(((ManagedClientConnectionImpl)v0).isMarkedReusable()) {
                HttpPoolEntry v2 = this.poolEntry;
                TimeUnit v1_2 = arg9 != null ? arg9 : TimeUnit.MILLISECONDS;
                v2.updateExpiry(arg7, v1_2);
                if(!this.log.isDebugEnabled()) {
                    goto label_70;
                }

                String v1_3 = arg7 > 0 ? "for " + arg7 + " " + arg9 : "indefinitely";
                this.log.debug("Connection can be kept alive " + v1_3);
            }

            goto label_70;
        }
        catch(Throwable v1) {
            try {
                ((ManagedClientConnectionImpl)v0).detach();
                this.conn = null;
                if(this.poolEntry.isClosed()) {
                    this.poolEntry = null;
                }

                throw v1;
            label_70:
                ((ManagedClientConnectionImpl)v0).detach();
                this.conn = null;
                if(this.poolEntry.isClosed()) {
                    this.poolEntry = null;
                }

                __monitor_exit(this);
                goto label_79;
            label_96:
                __monitor_exit(this);
            }
            catch(Throwable v1) {
                goto label_96;
            }
        }

        try {
            throw v1;
        label_79:
            __monitor_exit(v0);
            return;
        label_33:
            __monitor_exit(v0);
        }
        catch(Throwable v1) {
            goto label_33;
        }

        throw v1;
    }

    public final ClientConnectionRequest requestConnection(HttpRoute arg2, Object arg3) {
        return new BasicClientConnectionManager$1(this, arg2, arg3);
    }

    public void shutdown() {
        __monitor_enter(this);
        try {
            this.shutdown = true;
        }
        catch(Throwable v0) {
            goto label_20;
        }

        try {
            if(this.poolEntry != null) {
                this.poolEntry.close();
            }
        }
        catch(Throwable v0) {
            try {
                this.poolEntry = null;
                this.conn = null;
                throw v0;
            }
            catch(Throwable v0) {
                goto label_20;
            }
        }

        HttpPoolEntry v0_1 = null;
        try {
            this.poolEntry = v0_1;
            this.conn = null;
            __monitor_exit(this);
            return;
        label_20:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_20;
        }

        throw v0;
    }

    private void shutdownConnection(HttpClientConnection arg4) {
        try {
            arg4.shutdown();
        }
        catch(IOException v0) {
            if(!this.log.isDebugEnabled()) {
                return;
            }

            this.log.debug("I/O exception shutting down connection", ((Throwable)v0));
        }
    }
}

