// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.net.InetAddress;
import java.net.Socket;
import javax.net.ssl.SSLSession;
import org.apache.http.HttpClientConnection;
import org.apache.http.HttpConnectionMetrics;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.protocol.HttpContext;

@NotThreadSafe class CPoolProxy implements ManagedHttpClientConnection, HttpContext {
    private volatile CPoolEntry poolEntry;

    CPoolProxy(CPoolEntry arg1) {
        super();
        this.poolEntry = arg1;
    }

    public void bind(Socket arg2) {
        this.getValidConnection().bind(arg2);
    }

    public void close() {
        CPoolEntry v0 = this.poolEntry;
        if(v0 != null) {
            v0.closeConnection();
        }
    }

    public static CPoolEntry detach(HttpClientConnection arg1) {
        return CPoolProxy.getProxy(arg1).detach();
    }

    CPoolEntry detach() {
        CPoolEntry v0 = this.poolEntry;
        this.poolEntry = null;
        return v0;
    }

    public void flush() {
        this.getValidConnection().flush();
    }

    public Object getAttribute(String arg3) {
        ManagedHttpClientConnection v0 = this.getValidConnection();
        Object v0_1 = (v0 instanceof HttpContext) ? ((HttpContext)v0).getAttribute(arg3) : null;
        return v0_1;
    }

    ManagedHttpClientConnection getConnection() {
        ManagedHttpClientConnection v0_1;
        CPoolEntry v0 = this.poolEntry;
        if(v0 == null) {
            v0_1 = null;
        }
        else {
            Object v0_2 = v0.getConnection();
        }

        return v0_1;
    }

    public String getId() {
        return this.getValidConnection().getId();
    }

    public InetAddress getLocalAddress() {
        return this.getValidConnection().getLocalAddress();
    }

    public int getLocalPort() {
        return this.getValidConnection().getLocalPort();
    }

    public HttpConnectionMetrics getMetrics() {
        return this.getValidConnection().getMetrics();
    }

    public static CPoolEntry getPoolEntry(HttpClientConnection arg1) {
        CPoolEntry v0 = CPoolProxy.getProxy(arg1).getPoolEntry();
        if(v0 == null) {
            throw new ConnectionShutdownException();
        }

        return v0;
    }

    CPoolEntry getPoolEntry() {
        return this.poolEntry;
    }

    private static CPoolProxy getProxy(HttpClientConnection arg3) {
        if(!CPoolProxy.class.isInstance(arg3)) {
            throw new IllegalStateException("Unexpected connection proxy class: " + arg3.getClass());
        }

        return CPoolProxy.class.cast(arg3);
    }

    public InetAddress getRemoteAddress() {
        return this.getValidConnection().getRemoteAddress();
    }

    public int getRemotePort() {
        return this.getValidConnection().getRemotePort();
    }

    public SSLSession getSSLSession() {
        return this.getValidConnection().getSSLSession();
    }

    public Socket getSocket() {
        return this.getValidConnection().getSocket();
    }

    public int getSocketTimeout() {
        return this.getValidConnection().getSocketTimeout();
    }

    ManagedHttpClientConnection getValidConnection() {
        ManagedHttpClientConnection v0 = this.getConnection();
        if(v0 == null) {
            throw new ConnectionShutdownException();
        }

        return v0;
    }

    public boolean isOpen() {
        boolean v0 = false;
        CPoolEntry v1 = this.poolEntry;
        if(v1 != null && !v1.isClosed()) {
            v0 = true;
        }

        return v0;
    }

    public boolean isResponseAvailable(int arg2) {
        return this.getValidConnection().isResponseAvailable(arg2);
    }

    public boolean isStale() {
        ManagedHttpClientConnection v0 = this.getConnection();
        boolean v0_1 = v0 != null ? ((HttpClientConnection)v0).isStale() : true;
        return v0_1;
    }

    public static HttpClientConnection newProxy(CPoolEntry arg1) {
        return new CPoolProxy(arg1);
    }

    public void receiveResponseEntity(HttpResponse arg2) {
        this.getValidConnection().receiveResponseEntity(arg2);
    }

    public HttpResponse receiveResponseHeader() {
        return this.getValidConnection().receiveResponseHeader();
    }

    public Object removeAttribute(String arg3) {
        ManagedHttpClientConnection v0 = this.getValidConnection();
        Object v0_1 = (v0 instanceof HttpContext) ? ((HttpContext)v0).removeAttribute(arg3) : null;
        return v0_1;
    }

    public void sendRequestEntity(HttpEntityEnclosingRequest arg2) {
        this.getValidConnection().sendRequestEntity(arg2);
    }

    public void sendRequestHeader(HttpRequest arg2) {
        this.getValidConnection().sendRequestHeader(arg2);
    }

    public void setAttribute(String arg3, Object arg4) {
        ManagedHttpClientConnection v0 = this.getValidConnection();
        if((v0 instanceof HttpContext)) {
            ((HttpContext)v0).setAttribute(arg3, arg4);
        }
    }

    public void setSocketTimeout(int arg2) {
        this.getValidConnection().setSocketTimeout(arg2);
    }

    public void shutdown() {
        CPoolEntry v0 = this.poolEntry;
        if(v0 != null) {
            v0.shutdownConnection();
        }
    }

    public String toString() {
        StringBuilder v0 = new StringBuilder("CPoolProxy{");
        ManagedHttpClientConnection v1 = this.getConnection();
        if(v1 != null) {
            v0.append(v1);
        }
        else {
            v0.append("detached");
        }

        v0.append('}');
        return v0.toString();
    }
}

