// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.Socket;
import java.util.HashMap;
import java.util.Map;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.HttpResponseFactory;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.conn.OperatedClientConnection;
import org.apache.http.impl.SocketHttpClientConnection;
import org.apache.http.io.HttpMessageParser;
import org.apache.http.io.SessionInputBuffer;
import org.apache.http.io.SessionOutputBuffer;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Deprecated @NotThreadSafe public class DefaultClientConnection extends SocketHttpClientConnection implements ManagedHttpClientConnection, OperatedClientConnection, HttpContext {
    private final Map attributes;
    private boolean connSecure;
    private final Log headerLog;
    private final Log log;
    private volatile boolean shutdown;
    private volatile Socket socket;
    private HttpHost targetHost;
    private final Log wireLog;

    public DefaultClientConnection() {
        super();
        this.log = LogFactory.getLog(this.getClass());
        this.headerLog = LogFactory.getLog("org.apache.http.headers");
        this.wireLog = LogFactory.getLog("org.apache.http.wire");
        this.attributes = new HashMap();
    }

    public void bind(Socket arg2) {
        this.bind(arg2, new BasicHttpParams());
    }

    public void close() {
        try {
            super.close();
            if(!this.log.isDebugEnabled()) {
                return;
            }

            this.log.debug("Connection " + this + " closed");
        }
        catch(IOException v0) {
            this.log.debug("I/O error closing connection", ((Throwable)v0));
        }
    }

    protected HttpMessageParser createResponseParser(SessionInputBuffer arg3, HttpResponseFactory arg4, HttpParams arg5) {
        return new DefaultHttpResponseParser(arg3, null, arg4, arg5);
    }

    protected SessionInputBuffer createSessionInputBuffer(Socket arg5, int arg6, HttpParams arg7) {
        SessionInputBuffer v0_1;
        if(arg6 <= 0) {
            arg6 = 8192;
        }

        SessionInputBuffer v1 = super.createSessionInputBuffer(arg5, arg6, arg7);
        if(this.wireLog.isDebugEnabled()) {
            LoggingSessionInputBuffer v0 = new LoggingSessionInputBuffer(v1, new Wire(this.wireLog), HttpProtocolParams.getHttpElementCharset(arg7));
        }
        else {
            v0_1 = v1;
        }

        return v0_1;
    }

    protected SessionOutputBuffer createSessionOutputBuffer(Socket arg5, int arg6, HttpParams arg7) {
        SessionOutputBuffer v0_1;
        if(arg6 <= 0) {
            arg6 = 8192;
        }

        SessionOutputBuffer v1 = super.createSessionOutputBuffer(arg5, arg6, arg7);
        if(this.wireLog.isDebugEnabled()) {
            LoggingSessionOutputBuffer v0 = new LoggingSessionOutputBuffer(v1, new Wire(this.wireLog), HttpProtocolParams.getHttpElementCharset(arg7));
        }
        else {
            v0_1 = v1;
        }

        return v0_1;
    }

    public Object getAttribute(String arg2) {
        return this.attributes.get(arg2);
    }

    public String getId() {
        return null;
    }

    public SSLSession getSSLSession() {
        SSLSession v0 = (this.socket instanceof SSLSocket) ? this.socket.getSession() : null;
        return v0;
    }

    public final Socket getSocket() {
        return this.socket;
    }

    public final HttpHost getTargetHost() {
        return this.targetHost;
    }

    public final boolean isSecure() {
        return this.connSecure;
    }

    public void openCompleted(boolean arg2, HttpParams arg3) {
        Args.notNull(arg3, "Parameters");
        this.assertNotOpen();
        this.connSecure = arg2;
        this.bind(this.socket, arg3);
    }

    public void opening(Socket arg3, HttpHost arg4) {
        this.assertNotOpen();
        this.socket = arg3;
        this.targetHost = arg4;
        if(this.shutdown) {
            arg3.close();
            throw new InterruptedIOException("Connection already shutdown");
        }
    }

    public HttpResponse receiveResponseHeader() {
        HttpResponse v1 = super.receiveResponseHeader();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Receiving response: " + v1.getStatusLine());
        }

        if(this.headerLog.isDebugEnabled()) {
            this.headerLog.debug("<< " + v1.getStatusLine().toString());
            Header[] v2 = v1.getAllHeaders();
            int v3 = v2.length;
            int v0;
            for(v0 = 0; v0 < v3; ++v0) {
                this.headerLog.debug("<< " + v2[v0].toString());
            }
        }

        return v1;
    }

    public Object removeAttribute(String arg2) {
        return this.attributes.remove(arg2);
    }

    public void sendRequestHeader(HttpRequest arg8) {
        if(this.log.isDebugEnabled()) {
            this.log.debug("Sending request: " + arg8.getRequestLine());
        }

        super.sendRequestHeader(arg8);
        if(this.headerLog.isDebugEnabled()) {
            this.headerLog.debug(">> " + arg8.getRequestLine().toString());
            Header[] v1 = arg8.getAllHeaders();
            int v2 = v1.length;
            int v0;
            for(v0 = 0; v0 < v2; ++v0) {
                this.headerLog.debug(">> " + v1[v0].toString());
            }
        }
    }

    public void setAttribute(String arg2, Object arg3) {
        this.attributes.put(arg2, arg3);
    }

    public void shutdown() {
        this.shutdown = true;
        try {
            super.shutdown();
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connection " + this + " shut down");
            }

            Socket v0_1 = this.socket;
            if(v0_1 == null) {
                return;
            }

            v0_1.close();
        }
        catch(IOException v0) {
            this.log.debug("I/O error shutting down connection", ((Throwable)v0));
        }
    }

    public void update(Socket arg2, HttpHost arg3, boolean arg4, HttpParams arg5) {
        this.assertOpen();
        Args.notNull(arg3, "Target host");
        Args.notNull(arg5, "Parameters");
        if(arg2 != null) {
            this.socket = arg2;
            this.bind(arg2, arg5);
        }

        this.targetHost = arg3;
        this.connSecure = arg4;
    }
}

