// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.net.ConnectException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpHost;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.conn.DnsResolver;
import org.apache.http.conn.HttpInetSocketAddress;
import org.apache.http.conn.OperatedClientConnection;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeLayeredSocketFactory;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.scheme.SchemeSocketFactory;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated @ThreadSafe public class DefaultClientConnectionOperator implements ClientConnectionOperator {
    protected final DnsResolver dnsResolver;
    private final Log log;
    protected final SchemeRegistry schemeRegistry;

    public DefaultClientConnectionOperator(SchemeRegistry arg2) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "Scheme registry");
        this.schemeRegistry = arg2;
        this.dnsResolver = new SystemDefaultDnsResolver();
    }

    public DefaultClientConnectionOperator(SchemeRegistry arg2, DnsResolver arg3) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "Scheme registry");
        Args.notNull(arg3, "DNS resolver");
        this.schemeRegistry = arg2;
        this.dnsResolver = arg3;
    }

    public OperatedClientConnection createConnection() {
        return new DefaultClientConnection();
    }

    private SchemeRegistry getSchemeRegistry(HttpContext arg2) {
        Object v0 = arg2.getAttribute("http.scheme-registry");
        if(v0 == null) {
            SchemeRegistry v0_1 = this.schemeRegistry;
        }

        return ((SchemeRegistry)v0);
    }

    public void openConnection(OperatedClientConnection arg14, HttpHost arg15, InetAddress arg16, HttpContext arg17, HttpParams arg18) {
        Socket v4_4;
        Args.notNull(arg14, "Connection");
        Args.notNull(arg15, "Target host");
        Args.notNull(arg18, "HTTP parameters");
        boolean v2 = !arg14.isOpen() ? true : false;
        Asserts.check(v2, "Connection must not be open");
        Scheme v2_1 = this.getSchemeRegistry(arg17).getScheme(arg15.getSchemeName());
        SchemeSocketFactory v6 = v2_1.getSchemeSocketFactory();
        InetAddress[] v7 = this.resolveHostname(arg15.getHostName());
        int v8 = v2_1.resolvePort(arg15.getPort());
        int v2_2;
        for(v2_2 = 0; v2_2 < v7.length; ++v2_2) {
            InetAddress v4 = v7[v2_2];
            int v3 = v2_2 == v7.length - 1 ? 1 : 0;
            Socket v5 = v6.createSocket(arg18);
            arg14.opening(v5, arg15);
            HttpInetSocketAddress v9 = new HttpInetSocketAddress(arg15, v4, v8);
            InetSocketAddress v4_1 = null;
            if(arg16 != null) {
                v4_1 = new InetSocketAddress(arg16, 0);
            }

            if(this.log.isDebugEnabled()) {
                this.log.debug("Connecting to " + v9);
            }

            try {
                v4_4 = v6.connectSocket(v5, ((InetSocketAddress)v9), v4_1, arg18);
                if(v5 != v4_4) {
                    arg14.opening(v4_4, arg15);
                }
                else {
                    goto label_89;
                }

                goto label_55;
            }
            catch(ConnectTimeoutException v4_2) {
                goto label_70;
            }
            catch(ConnectException v4_3) {
                goto label_67;
            }

        label_89:
            v4_4 = v5;
            try {
            label_55:
                this.prepareSocket(v4_4, arg17, arg18);
                arg14.openCompleted(v6.isSecure(v4_4), arg18);
                return;
            }
            catch(ConnectTimeoutException v4_2) {
            label_70:
                if(v3 == 0) {
                    goto label_72;
                }

                throw v4_2;
            }
            catch(ConnectException v4_3) {
            label_67:
                if(v3 == 0) {
                    goto label_72;
                }

                throw v4_3;
            }

        label_72:
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connect to " + v9 + " timed out. " + "Connection will be retried using another IP address");
            }
        }
    }

    protected void prepareSocket(Socket arg3, HttpContext arg4, HttpParams arg5) {
        arg3.setTcpNoDelay(HttpConnectionParams.getTcpNoDelay(arg5));
        arg3.setSoTimeout(HttpConnectionParams.getSoTimeout(arg5));
        int v1 = HttpConnectionParams.getLinger(arg5);
        if(v1 >= 0) {
            boolean v0 = v1 > 0 ? true : false;
            arg3.setSoLinger(v0, v1);
        }
    }

    protected InetAddress[] resolveHostname(String arg2) {
        return this.dnsResolver.resolve(arg2);
    }

    public void updateSecureConnection(OperatedClientConnection arg6, HttpHost arg7, HttpContext arg8, HttpParams arg9) {
        Args.notNull(arg6, "Connection");
        Args.notNull(arg7, "Target host");
        Args.notNull(arg9, "Parameters");
        Asserts.check(arg6.isOpen(), "Connection must be open");
        Scheme v1 = this.getSchemeRegistry(arg8).getScheme(arg7.getSchemeName());
        Asserts.check(v1.getSchemeSocketFactory() instanceof SchemeLayeredSocketFactory, "Socket factory must implement SchemeLayeredSocketFactory");
        SchemeSocketFactory v0 = v1.getSchemeSocketFactory();
        Socket v1_1 = ((SchemeLayeredSocketFactory)v0).createLayeredSocket(arg6.getSocket(), arg7.getHostName(), v1.resolvePort(arg7.getPort()), arg9);
        this.prepareSocket(v1_1, arg8, arg9);
        arg6.update(v1_1, arg7, ((SchemeLayeredSocketFactory)v0).isSecure(v1_1), arg9);
    }
}

