// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpMessage;
import org.apache.http.HttpResponse;
import org.apache.http.HttpResponseFactory;
import org.apache.http.NoHttpResponseException;
import org.apache.http.ProtocolException;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.config.MessageConstraints;
import org.apache.http.impl.DefaultHttpResponseFactory;
import org.apache.http.impl.io.AbstractMessageParser;
import org.apache.http.io.SessionInputBuffer;
import org.apache.http.message.LineParser;
import org.apache.http.message.ParserCursor;
import org.apache.http.params.HttpParams;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class DefaultHttpResponseParser extends AbstractMessageParser {
    private final CharArrayBuffer lineBuf;
    private final Log log;
    private final HttpResponseFactory responseFactory;

    @Deprecated public DefaultHttpResponseParser(SessionInputBuffer arg3, LineParser arg4, HttpResponseFactory arg5, HttpParams arg6) {
        super(arg3, arg4, arg6);
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg5, "Response factory");
        this.responseFactory = arg5;
        this.lineBuf = new CharArrayBuffer(128);
    }

    public DefaultHttpResponseParser(SessionInputBuffer arg3) {
        this(arg3, null, null, MessageConstraints.DEFAULT);
    }

    public DefaultHttpResponseParser(SessionInputBuffer arg3, LineParser arg4, HttpResponseFactory arg5, MessageConstraints arg6) {
        DefaultHttpResponseFactory v5;
        super(arg3, arg4, arg6);
        this.log = LogFactory.getLog(this.getClass());
        if(arg5 == null) {
            v5 = DefaultHttpResponseFactory.INSTANCE;
        }

        this.responseFactory = ((HttpResponseFactory)v5);
        this.lineBuf = new CharArrayBuffer(128);
    }

    public DefaultHttpResponseParser(SessionInputBuffer arg2, MessageConstraints arg3) {
        this(arg2, null, null, arg3);
    }

    protected HttpMessage parseHead(SessionInputBuffer arg2) {
        return this.parseHead(arg2);
    }

    protected HttpResponse parseHead(SessionInputBuffer arg8) {
        int v6 = -1;
        int v0 = 0;
        while(true) {
            this.lineBuf.clear();
            int v2 = arg8.readLine(this.lineBuf);
            if(v2 == v6 && v0 == 0) {
                throw new NoHttpResponseException("The target server failed to respond");
            }

            ParserCursor v3 = new ParserCursor(0, this.lineBuf.length());
            if(this.lineParser.hasProtocolVersion(this.lineBuf, v3)) {
                return this.responseFactory.newHttpResponse(this.lineParser.parseStatusLine(this.lineBuf, v3), null);
            }

            if(v2 != v6 && !this.reject(this.lineBuf, v0)) {
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Garbage in response: " + this.lineBuf.toString());
                }

                ++v0;
                continue;
            }

            break;
        }

        throw new ProtocolException("The server failed to respond with a valid HTTP response");
    }

    protected boolean reject(CharArrayBuffer arg2, int arg3) {
        return 0;
    }
}

