// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.InterruptedIOException;
import java.net.Socket;
import java.nio.charset.CharsetDecoder;
import java.nio.charset.CharsetEncoder;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.config.MessageConstraints;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.entity.ContentLengthStrategy;
import org.apache.http.impl.DefaultBHttpClientConnection;
import org.apache.http.io.HttpMessageParserFactory;
import org.apache.http.io.HttpMessageWriterFactory;
import org.apache.http.protocol.HttpContext;

@NotThreadSafe public class DefaultManagedHttpClientConnection extends DefaultBHttpClientConnection implements ManagedHttpClientConnection, HttpContext {
    private final Map attributes;
    private final String id;
    private volatile boolean shutdown;

    public DefaultManagedHttpClientConnection(String arg12, int arg13) {
        this(arg12, arg13, arg13, null, null, null, null, null, null, null);
    }

    public DefaultManagedHttpClientConnection(String arg11, int arg12, int arg13, CharsetDecoder arg14, CharsetEncoder arg15, MessageConstraints arg16, ContentLengthStrategy arg17, ContentLengthStrategy arg18, HttpMessageWriterFactory arg19, HttpMessageParserFactory arg20) {
        super(arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20);
        this.id = arg11;
        this.attributes = new ConcurrentHashMap();
    }

    public void bind(Socket arg3) {
        if(this.shutdown) {
            arg3.close();
            throw new InterruptedIOException("Connection already shutdown");
        }

        super.bind(arg3);
    }

    public Object getAttribute(String arg2) {
        return this.attributes.get(arg2);
    }

    public String getId() {
        return this.id;
    }

    public SSLSession getSSLSession() {
        Socket v0 = super.getSocket();
        SSLSession v0_1 = (v0 instanceof SSLSocket) ? ((SSLSocket)v0).getSession() : null;
        return v0_1;
    }

    public Socket getSocket() {
        return super.getSocket();
    }

    public Object removeAttribute(String arg2) {
        return this.attributes.remove(arg2);
    }

    public void setAttribute(String arg2, Object arg3) {
        this.attributes.put(arg2, arg3);
    }

    public void shutdown() {
        this.shutdown = true;
        super.shutdown();
    }
}

