// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.net.ConnectException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketTimeoutException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpHost;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.config.Lookup;
import org.apache.http.config.SocketConfig;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.conn.DnsResolver;
import org.apache.http.conn.HttpHostConnectException;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.conn.SchemePortResolver;
import org.apache.http.conn.UnsupportedSchemeException;
import org.apache.http.conn.socket.ConnectionSocketFactory;
import org.apache.http.conn.socket.LayeredConnectionSocketFactory;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Immutable class HttpClientConnectionOperator {
    static final String SOCKET_FACTORY_REGISTRY = "http.socket-factory-registry";
    private final DnsResolver dnsResolver;
    private final Log log;
    private final SchemePortResolver schemePortResolver;
    private final Lookup socketFactoryRegistry;

    HttpClientConnectionOperator(Lookup arg2, SchemePortResolver arg3, DnsResolver arg4) {
        SystemDefaultDnsResolver v4;
        DefaultSchemePortResolver v3;
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "Socket factory registry");
        this.socketFactoryRegistry = arg2;
        if(arg3 == null) {
            v3 = DefaultSchemePortResolver.INSTANCE;
        }

        this.schemePortResolver = ((SchemePortResolver)v3);
        if(arg4 == null) {
            v4 = SystemDefaultDnsResolver.INSTANCE;
        }

        this.dnsResolver = ((DnsResolver)v4);
    }

    public void connect(ManagedHttpClientConnection arg13, HttpHost arg14, InetSocketAddress arg15, int arg16, SocketConfig arg17, HttpContext arg18) {
        Object v1 = this.getSocketFactoryRegistry(arg18).lookup(arg14.getSchemeName());
        if(v1 == null) {
            throw new UnsupportedSchemeException(arg14.getSchemeName() + " protocol is not supported");
        }

        InetAddress[] v10 = this.dnsResolver.resolve(arg14.getHostName());
        int v11 = this.schemePortResolver.resolve(arg14);
        int v8;
        for(v8 = 0; v8 < v10.length; ++v8) {
            InetAddress v4 = v10[v8];
            int v9 = v8 == v10.length - 1 ? 1 : 0;
            Socket v3 = ((ConnectionSocketFactory)v1).createSocket(arg18);
            v3.setSoTimeout(arg17.getSoTimeout());
            v3.setReuseAddress(arg17.isSoReuseAddress());
            v3.setTcpNoDelay(arg17.isTcpNoDelay());
            v3.setKeepAlive(arg17.isSoKeepAlive());
            int v5 = arg17.getSoLinger();
            if(v5 >= 0) {
                boolean v2 = v5 > 0 ? true : false;
                v3.setSoLinger(v2, v5);
            }

            arg13.bind(v3);
            InetSocketAddress v5_1 = new InetSocketAddress(v4, v11);
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connecting to " + v5_1);
            }

            int v2_1 = arg16;
            HttpHost v4_1 = arg14;
            InetSocketAddress v6 = arg15;
            HttpContext v7 = arg18;
            try {
                arg13.bind(((ConnectionSocketFactory)v1).connectSocket(v2_1, v3, v4_1, v5_1, v6, v7));
                if(!this.log.isDebugEnabled()) {
                    return;
                }

                this.log.debug("Connection established " + arg13);
                return;
            }
            catch(ConnectException v2_2) {
                if(v9 == 0) {
                    goto label_99;
                }

                if("Connection timed out".equals(v2_2.getMessage())) {
                    throw new ConnectTimeoutException(((IOException)v2_2), arg14, v10);
                }

                throw new HttpHostConnectException(((IOException)v2_2), arg14, v10);
            }
            catch(SocketTimeoutException v2_3) {
                if(v9 == 0) {
                    goto label_99;
                }

                throw new ConnectTimeoutException(((IOException)v2_3), arg14, v10);
            }

        label_99:
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connect to " + v5_1 + " timed out. " + "Connection will be retried using another IP address");
            }
        }
    }

    private Lookup getSocketFactoryRegistry(HttpContext arg2) {
        Object v0 = arg2.getAttribute("http.socket-factory-registry");
        if(v0 == null) {
            Lookup v0_1 = this.socketFactoryRegistry;
        }

        return ((Lookup)v0);
    }

    public void upgrade(ManagedHttpClientConnection arg5, HttpHost arg6, HttpContext arg7) {
        Object v0 = this.getSocketFactoryRegistry(HttpClientContext.adapt(arg7)).lookup(arg6.getSchemeName());
        if(v0 == null) {
            throw new UnsupportedSchemeException(arg6.getSchemeName() + " protocol is not supported");
        }

        if(!(v0 instanceof LayeredConnectionSocketFactory)) {
            throw new UnsupportedSchemeException(arg6.getSchemeName() + " protocol does not support connection upgrade");
        }

        arg5.bind(((LayeredConnectionSocketFactory)v0).createLayeredSocket(arg5.getSocket(), arg6.getHostName(), this.schemePortResolver.resolve(arg6), arg7));
    }
}

