// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Arrays;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.conn.DnsResolver;
import org.apache.http.util.Args;

public class InMemoryDnsResolver implements DnsResolver {
    private final Map dnsMap;
    private final Log log;

    public InMemoryDnsResolver() {
        super();
        this.log = LogFactory.getLog(InMemoryDnsResolver.class);
        this.dnsMap = new ConcurrentHashMap();
    }

    public void add(String arg2, InetAddress[] arg3) {
        Args.notNull(arg2, "Host name");
        Args.notNull(arg3, "Array of IP addresses");
        this.dnsMap.put(arg2, arg3);
    }

    public InetAddress[] resolve(String arg5) {
        Object v0 = this.dnsMap.get(arg5);
        if(this.log.isInfoEnabled()) {
            this.log.info("Resolving " + arg5 + " to " + Arrays.deepToString(((Object[])v0)));
        }

        if(v0 == null) {
            throw new UnknownHostException(arg5 + " cannot be resolved");
        }

        return ((InetAddress[])v0);
    }
}

