// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.io.InputStream;
import org.apache.http.annotation.NotThreadSafe;

@NotThreadSafe class LoggingInputStream extends InputStream {
    private final InputStream in;
    private final Wire wire;

    public LoggingInputStream(InputStream arg1, Wire arg2) {
        super();
        this.in = arg1;
        this.wire = arg2;
    }

    public int available() {
        try {
            return this.in.available();
        }
        catch(IOException v0) {
            this.wire.input("[available] I/O error : " + v0.getMessage());
            throw v0;
        }
    }

    public void close() {
        try {
            this.in.close();
            return;
        }
        catch(IOException v0) {
            this.wire.input("[close] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public void mark(int arg1) {
        super.mark(arg1);
    }

    public boolean markSupported() {
        return 0;
    }

    public int read() {
        try {
            int v0_1 = this.in.read();
            if(v0_1 == -1) {
                this.wire.input("end of stream");
            }
            else {
                this.wire.input(v0_1);
            }

            return v0_1;
        }
        catch(IOException v0) {
            this.wire.input("[read] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public int read(byte[] arg5) {
        try {
            int v0_1 = this.in.read(arg5);
            if(v0_1 == -1) {
                this.wire.input("end of stream");
            }
            else if(v0_1 > 0) {
                this.wire.input(arg5, 0, v0_1);
            }

            return v0_1;
        }
        catch(IOException v0) {
            this.wire.input("[read] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public int read(byte[] arg5, int arg6, int arg7) {
        try {
            int v0_1 = this.in.read(arg5, arg6, arg7);
            if(v0_1 == -1) {
                this.wire.input("end of stream");
            }
            else if(v0_1 > 0) {
                this.wire.input(arg5, arg6, v0_1);
            }

            return v0_1;
        }
        catch(IOException v0) {
            this.wire.input("[read] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public void reset() {
        super.reset();
    }

    public long skip(long arg5) {
        try {
            return super.skip(arg5);
        }
        catch(IOException v0) {
            this.wire.input("[skip] I/O error: " + v0.getMessage());
            throw v0;
        }
    }
}

