// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.nio.charset.CharsetDecoder;
import java.nio.charset.CharsetEncoder;
import org.apache.commons.logging.Log;
import org.apache.http.Header;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.config.MessageConstraints;
import org.apache.http.entity.ContentLengthStrategy;
import org.apache.http.io.HttpMessageParserFactory;
import org.apache.http.io.HttpMessageWriterFactory;

@NotThreadSafe class LoggingManagedHttpClientConnection extends DefaultManagedHttpClientConnection {
    private final Log headerlog;
    private final Log log;
    private final Wire wire;

    public LoggingManagedHttpClientConnection(String arg12, Log arg13, Log arg14, Log arg15, int arg16, int arg17, CharsetDecoder arg18, CharsetEncoder arg19, MessageConstraints arg20, ContentLengthStrategy arg21, ContentLengthStrategy arg22, HttpMessageWriterFactory arg23, HttpMessageParserFactory arg24) {
        super(arg12, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24);
        this.log = arg13;
        this.headerlog = arg14;
        this.wire = new Wire(arg15, arg12);
    }

    public void close() {
        if(this.log.isDebugEnabled()) {
            this.log.debug(this.getId() + ": Close connection");
        }

        super.close();
    }

    protected InputStream getSocketInputStream(Socket arg4) {
        LoggingInputStream v0;
        InputStream v1 = super.getSocketInputStream(arg4);
        if(this.wire.enabled()) {
            v0 = new LoggingInputStream(v1, this.wire);
        }
        else {
            InputStream v0_1 = v1;
        }

        return ((InputStream)v0);
    }

    protected OutputStream getSocketOutputStream(Socket arg4) {
        LoggingOutputStream v0;
        OutputStream v1 = super.getSocketOutputStream(arg4);
        if(this.wire.enabled()) {
            v0 = new LoggingOutputStream(v1, this.wire);
        }
        else {
            OutputStream v0_1 = v1;
        }

        return ((OutputStream)v0);
    }

    protected void onRequestSubmitted(HttpRequest arg8) {
        if(arg8 != null && (this.headerlog.isDebugEnabled())) {
            this.headerlog.debug(this.getId() + " >> " + arg8.getRequestLine().toString());
            Header[] v1 = arg8.getAllHeaders();
            int v2 = v1.length;
            int v0;
            for(v0 = 0; v0 < v2; ++v0) {
                this.headerlog.debug(this.getId() + " >> " + v1[v0].toString());
            }
        }
    }

    protected void onResponseReceived(HttpResponse arg8) {
        if(arg8 != null && (this.headerlog.isDebugEnabled())) {
            this.headerlog.debug(this.getId() + " << " + arg8.getStatusLine().toString());
            Header[] v1 = arg8.getAllHeaders();
            int v2 = v1.length;
            int v0;
            for(v0 = 0; v0 < v2; ++v0) {
                this.headerlog.debug(this.getId() + " << " + v1[v0].toString());
            }
        }
    }

    public void shutdown() {
        if(this.log.isDebugEnabled()) {
            this.log.debug(this.getId() + ": Shutdown connection");
        }

        super.shutdown();
    }
}

