// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.io.OutputStream;
import org.apache.http.annotation.NotThreadSafe;

@NotThreadSafe class LoggingOutputStream extends OutputStream {
    private final OutputStream out;
    private final Wire wire;

    public LoggingOutputStream(OutputStream arg1, Wire arg2) {
        super();
        this.out = arg1;
        this.wire = arg2;
    }

    public void close() {
        try {
            this.out.close();
            return;
        }
        catch(IOException v0) {
            this.wire.output("[close] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public void flush() {
        try {
            this.out.flush();
            return;
        }
        catch(IOException v0) {
            this.wire.output("[flush] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public void write(int arg5) {
        try {
            this.wire.output(arg5);
            return;
        }
        catch(IOException v0) {
            this.wire.output("[write] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public void write(byte[] arg5) {
        try {
            this.wire.output(arg5);
            this.out.write(arg5);
            return;
        }
        catch(IOException v0) {
            this.wire.output("[write] I/O error: " + v0.getMessage());
            throw v0;
        }
    }

    public void write(byte[] arg5, int arg6, int arg7) {
        try {
            this.wire.output(arg5, arg6, arg7);
            this.out.write(arg5, arg6, arg7);
            return;
        }
        catch(IOException v0) {
            this.wire.output("[write] I/O error: " + v0.getMessage());
            throw v0;
        }
    }
}

