// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.InetAddress;
import java.net.Socket;
import java.util.concurrent.TimeUnit;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;
import org.apache.http.HttpConnectionMetrics;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ManagedClientConnection;
import org.apache.http.conn.OperatedClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.RouteTracker;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated @NotThreadSafe class ManagedClientConnectionImpl implements ManagedClientConnection {
    private volatile long duration;
    private final ClientConnectionManager manager;
    private final ClientConnectionOperator operator;
    private volatile HttpPoolEntry poolEntry;
    private volatile boolean reusable;

    ManagedClientConnectionImpl(ClientConnectionManager arg3, ClientConnectionOperator arg4, HttpPoolEntry arg5) {
        super();
        Args.notNull(arg3, "Connection manager");
        Args.notNull(arg4, "Connection operator");
        Args.notNull(arg5, "HTTP pool entry");
        this.manager = arg3;
        this.operator = arg4;
        this.poolEntry = arg5;
        this.reusable = false;
        this.duration = 9223372036854775807L;
    }

    public void abortConnection() {
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                __monitor_exit(this);
                return;
            }

            this.reusable = false;
            Object v0_1 = this.poolEntry.getConnection();
            try {
                ((OperatedClientConnection)v0_1).shutdown();
            }
            catch(IOException v0_2) {
            }
        }
        catch(Throwable v0) {
            goto label_19;
        }

        try {
            this.manager.releaseConnection(((ManagedClientConnection)this), this.duration, TimeUnit.MILLISECONDS);
            this.poolEntry = null;
            __monitor_exit(this);
            return;
        label_19:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_19;
        }

        throw v0;
    }

    public void bind(Socket arg2) {
        throw new UnsupportedOperationException();
    }

    public void close() {
        HttpPoolEntry v1 = this.poolEntry;
        if(v1 != null) {
            Object v0 = v1.getConnection();
            v1.getTracker().reset();
            ((OperatedClientConnection)v0).close();
        }
    }

    HttpPoolEntry detach() {
        HttpPoolEntry v0 = this.poolEntry;
        this.poolEntry = null;
        return v0;
    }

    private OperatedClientConnection ensureConnection() {
        HttpPoolEntry v0 = this.poolEntry;
        if(v0 == null) {
            throw new ConnectionShutdownException();
        }

        return v0.getConnection();
    }

    private HttpPoolEntry ensurePoolEntry() {
        HttpPoolEntry v0 = this.poolEntry;
        if(v0 == null) {
            throw new ConnectionShutdownException();
        }

        return v0;
    }

    public void flush() {
        this.ensureConnection().flush();
    }

    public Object getAttribute(String arg3) {
        OperatedClientConnection v0 = this.ensureConnection();
        Object v0_1 = (v0 instanceof HttpContext) ? ((HttpContext)v0).getAttribute(arg3) : null;
        return v0_1;
    }

    private OperatedClientConnection getConnection() {
        OperatedClientConnection v0_1;
        HttpPoolEntry v0 = this.poolEntry;
        if(v0 == null) {
            v0_1 = null;
        }
        else {
            Object v0_2 = v0.getConnection();
        }

        return v0_1;
    }

    public String getId() {
        return null;
    }

    public InetAddress getLocalAddress() {
        return this.ensureConnection().getLocalAddress();
    }

    public int getLocalPort() {
        return this.ensureConnection().getLocalPort();
    }

    public ClientConnectionManager getManager() {
        return this.manager;
    }

    public HttpConnectionMetrics getMetrics() {
        return this.ensureConnection().getMetrics();
    }

    HttpPoolEntry getPoolEntry() {
        return this.poolEntry;
    }

    public InetAddress getRemoteAddress() {
        return this.ensureConnection().getRemoteAddress();
    }

    public int getRemotePort() {
        return this.ensureConnection().getRemotePort();
    }

    public HttpRoute getRoute() {
        return this.ensurePoolEntry().getEffectiveRoute();
    }

    public SSLSession getSSLSession() {
        SSLSession v1 = null;
        Socket v0 = this.ensureConnection().getSocket();
        SSLSession v0_1 = (v0 instanceof SSLSocket) ? ((SSLSocket)v0).getSession() : v1;
        return v0_1;
    }

    public Socket getSocket() {
        return this.ensureConnection().getSocket();
    }

    public int getSocketTimeout() {
        return this.ensureConnection().getSocketTimeout();
    }

    public Object getState() {
        return this.ensurePoolEntry().getState();
    }

    public boolean isMarkedReusable() {
        return this.reusable;
    }

    public boolean isOpen() {
        OperatedClientConnection v0 = this.getConnection();
        boolean v0_1 = v0 != null ? v0.isOpen() : false;
        return v0_1;
    }

    public boolean isResponseAvailable(int arg2) {
        return this.ensureConnection().isResponseAvailable(arg2);
    }

    public boolean isSecure() {
        return this.ensureConnection().isSecure();
    }

    public boolean isStale() {
        OperatedClientConnection v0 = this.getConnection();
        boolean v0_1 = v0 != null ? v0.isStale() : true;
        return v0_1;
    }

    public void layerProtocol(HttpContext arg4, HttpParams arg5) {
        Object v0_2;
        HttpHost v1_1;
        boolean v0_1;
        RouteTracker v1;
        Args.notNull(arg5, "HTTP parameters");
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new ConnectionShutdownException();
            }

            v1 = this.poolEntry.getTracker();
            Asserts.notNull(v1, "Route tracker");
            Asserts.check(v1.isConnected(), "Connection not open");
            Asserts.check(v1.isTunnelled(), "Protocol layering without a tunnel not supported");
            if(!v1.isLayered()) {
                v0_1 = true;
            }
            else {
                goto label_41;
            }

            goto label_24;
        }
        catch(Throwable v0) {
            goto label_9;
        }

    label_41:
        v0_1 = false;
        try {
        label_24:
            Asserts.check(v0_1, "Multiple protocol layering not supported");
            v1_1 = v1.getTargetHost();
            v0_2 = this.poolEntry.getConnection();
            __monitor_exit(this);
            goto label_30;
        label_9:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_9;
        }

        throw v0;
    label_30:
        this.operator.updateSecureConnection(((OperatedClientConnection)v0_2), v1_1, arg4, arg5);
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new InterruptedIOException();
            }

            this.poolEntry.getTracker().layerProtocol(((OperatedClientConnection)v0_2).isSecure());
            __monitor_exit(this);
            return;
        label_39:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_39;
        }

        throw v0;
    }

    public void markReusable() {
        this.reusable = true;
    }

    public void open(HttpRoute arg8, HttpContext arg9, HttpParams arg10) {
        Object v1;
        boolean v0_2;
        RouteTracker v0_1;
        Args.notNull(arg8, "Route");
        Args.notNull(arg10, "HTTP parameters");
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new ConnectionShutdownException();
            }

            v0_1 = this.poolEntry.getTracker();
            Asserts.notNull(v0_1, "Route tracker");
            if(!v0_1.isConnected()) {
                v0_2 = true;
            }
            else {
                goto label_42;
            }

            goto label_20;
        }
        catch(Throwable v0) {
            goto label_11;
        }

    label_42:
        v0_2 = false;
        try {
        label_20:
            Asserts.check(v0_2, "Connection already open");
            v1 = this.poolEntry.getConnection();
            __monitor_exit(this);
            goto label_25;
        label_11:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_11;
        }

        throw v0;
    label_25:
        HttpHost v6 = arg8.getProxyHost();
        ClientConnectionOperator v0_3 = this.operator;
        HttpHost v2 = v6 != null ? v6 : arg8.getTargetHost();
        v0_3.openConnection(((OperatedClientConnection)v1), v2, arg8.getLocalAddress(), arg9, arg10);
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new InterruptedIOException();
            }

            v0_1 = this.poolEntry.getTracker();
            if(v6 == null) {
                v0_1.connectTarget(((OperatedClientConnection)v1).isSecure());
            }
            else {
                v0_1.connectProxy(v6, ((OperatedClientConnection)v1).isSecure());
            }

            __monitor_exit(this);
            return;
        label_40:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_40;
        }

        throw v0;
    }

    public void receiveResponseEntity(HttpResponse arg2) {
        this.ensureConnection().receiveResponseEntity(arg2);
    }

    public HttpResponse receiveResponseHeader() {
        return this.ensureConnection().receiveResponseHeader();
    }

    public void releaseConnection() {
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                __monitor_exit(this);
            }
            else {
                this.manager.releaseConnection(((ManagedClientConnection)this), this.duration, TimeUnit.MILLISECONDS);
                this.poolEntry = null;
                __monitor_exit(this);
            }

            return;
        label_14:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_14;
        }

        throw v0;
    }

    public Object removeAttribute(String arg3) {
        OperatedClientConnection v0 = this.ensureConnection();
        Object v0_1 = (v0 instanceof HttpContext) ? ((HttpContext)v0).removeAttribute(arg3) : null;
        return v0_1;
    }

    public void sendRequestEntity(HttpEntityEnclosingRequest arg2) {
        this.ensureConnection().sendRequestEntity(arg2);
    }

    public void sendRequestHeader(HttpRequest arg2) {
        this.ensureConnection().sendRequestHeader(arg2);
    }

    public void setAttribute(String arg3, Object arg4) {
        OperatedClientConnection v0 = this.ensureConnection();
        if((v0 instanceof HttpContext)) {
            ((HttpContext)v0).setAttribute(arg3, arg4);
        }
    }

    public void setIdleDuration(long arg3, TimeUnit arg5) {
        this.duration = arg3 > 0 ? arg5.toMillis(arg3) : -1;
    }

    public void setSocketTimeout(int arg2) {
        this.ensureConnection().setSocketTimeout(arg2);
    }

    public void setState(Object arg2) {
        this.ensurePoolEntry().setState(arg2);
    }

    public void shutdown() {
        HttpPoolEntry v1 = this.poolEntry;
        if(v1 != null) {
            Object v0 = v1.getConnection();
            v1.getTracker().reset();
            ((OperatedClientConnection)v0).shutdown();
        }
    }

    public void tunnelProxy(HttpHost arg3, boolean arg4, HttpParams arg5) {
        Object v0_2;
        Args.notNull(arg3, "Next proxy");
        Args.notNull(arg5, "HTTP parameters");
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new ConnectionShutdownException();
            }

            RouteTracker v0_1 = this.poolEntry.getTracker();
            Asserts.notNull(v0_1, "Route tracker");
            Asserts.check(v0_1.isConnected(), "Connection not open");
            v0_2 = this.poolEntry.getConnection();
            __monitor_exit(this);
            goto label_23;
        label_11:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_11;
        }

        throw v0;
    label_23:
        ((OperatedClientConnection)v0_2).update(null, arg3, arg4, arg5);
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new InterruptedIOException();
            }

            this.poolEntry.getTracker().tunnelProxy(arg3, arg4);
            __monitor_exit(this);
            return;
        label_32:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_32;
        }

        throw v0;
    }

    public void tunnelTarget(boolean arg4, HttpParams arg5) {
        Object v0_2;
        HttpHost v1_1;
        boolean v0_1;
        RouteTracker v1;
        Args.notNull(arg5, "HTTP parameters");
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new ConnectionShutdownException();
            }

            v1 = this.poolEntry.getTracker();
            Asserts.notNull(v1, "Route tracker");
            Asserts.check(v1.isConnected(), "Connection not open");
            if(!v1.isTunnelled()) {
                v0_1 = true;
            }
            else {
                goto label_38;
            }

            goto label_21;
        }
        catch(Throwable v0) {
            goto label_9;
        }

    label_38:
        v0_1 = false;
        try {
        label_21:
            Asserts.check(v0_1, "Connection is already tunnelled");
            v1_1 = v1.getTargetHost();
            v0_2 = this.poolEntry.getConnection();
            __monitor_exit(this);
            goto label_27;
        label_9:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_9;
        }

        throw v0;
    label_27:
        ((OperatedClientConnection)v0_2).update(null, v1_1, arg4, arg5);
        __monitor_enter(this);
        try {
            if(this.poolEntry == null) {
                throw new InterruptedIOException();
            }

            this.poolEntry.getTracker().tunnelTarget(arg4);
            __monitor_exit(this);
            return;
        label_36:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_36;
        }

        throw v0;
    }

    public void unmarkReusable() {
        this.reusable = false;
    }
}

