// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;
import java.nio.charset.CharsetEncoder;
import java.nio.charset.CodingErrorAction;
import java.util.concurrent.atomic.AtomicLong;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpConnection;
import org.apache.http.annotation.Immutable;
import org.apache.http.config.ConnectionConfig;
import org.apache.http.conn.HttpConnectionFactory;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.impl.io.DefaultHttpRequestWriterFactory;
import org.apache.http.io.HttpMessageParserFactory;
import org.apache.http.io.HttpMessageWriterFactory;

@Immutable public class ManagedHttpClientConnectionFactory implements HttpConnectionFactory {
    private static final AtomicLong COUNTER;
    private final Log headerlog;
    private final Log log;
    private final HttpMessageWriterFactory requestWriterFactory;
    private final HttpMessageParserFactory responseParserFactory;
    private final Log wirelog;

    static {
        ManagedHttpClientConnectionFactory.COUNTER = new AtomicLong();
        ManagedHttpClientConnectionFactory.INSTANCE = new ManagedHttpClientConnectionFactory();
    }

    public ManagedHttpClientConnectionFactory() {
        this(null, null);
    }

    public ManagedHttpClientConnectionFactory(HttpMessageWriterFactory arg2, HttpMessageParserFactory arg3) {
        DefaultHttpResponseParserFactory v3;
        DefaultHttpRequestWriterFactory v2;
        super();
        this.log = LogFactory.getLog(DefaultManagedHttpClientConnection.class);
        this.headerlog = LogFactory.getLog("org.apache.http.headers");
        this.wirelog = LogFactory.getLog("org.apache.http.wire");
        if(arg2 == null) {
            v2 = DefaultHttpRequestWriterFactory.INSTANCE;
        }

        this.requestWriterFactory = ((HttpMessageWriterFactory)v2);
        if(arg3 == null) {
            v3 = DefaultHttpResponseParserFactory.INSTANCE;
        }

        this.responseParserFactory = ((HttpMessageParserFactory)v3);
    }

    public ManagedHttpClientConnectionFactory(HttpMessageParserFactory arg2) {
        this(null, arg2);
    }

    public HttpConnection create(Object arg2, ConnectionConfig arg3) {
        return this.create(((HttpRoute)arg2), arg3);
    }

    public ManagedHttpClientConnection create(HttpRoute arg15, ConnectionConfig arg16) {
        if(arg16 == null) {
            arg16 = ConnectionConfig.DEFAULT;
        }

        CharsetDecoder v7 = null;
        CharsetEncoder v8 = null;
        Charset v2 = arg16.getCharset();
        CodingErrorAction v0 = arg16.getMalformedInputAction() != null ? arg16.getMalformedInputAction() : CodingErrorAction.REPORT;
        CodingErrorAction v1 = arg16.getUnmappableInputAction() != null ? arg16.getUnmappableInputAction() : CodingErrorAction.REPORT;
        if(v2 != null) {
            v7 = v2.newDecoder();
            v7.onMalformedInput(v0);
            v7.onUnmappableCharacter(v1);
            v8 = v2.newEncoder();
            v8.onMalformedInput(v0);
            v8.onUnmappableCharacter(v1);
        }

        return new LoggingManagedHttpClientConnection("http-outgoing-" + Long.toString(ManagedHttpClientConnectionFactory.COUNTER.getAndIncrement()), this.log, this.headerlog, this.wirelog, arg16.getBufferSize(), arg16.getFragmentSizeHint(), v7, v8, arg16.getMessageConstraints(), null, null, this.requestWriterFactory, this.responseParserFactory);
    }
}

