// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ClientConnectionRequest;
import org.apache.http.conn.ConnectionPoolTimeoutException;
import org.apache.http.conn.DnsResolver;
import org.apache.http.conn.ManagedClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.pool.ConnPoolControl;
import org.apache.http.pool.PoolEntry;
import org.apache.http.pool.PoolStats;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated @ThreadSafe public class PoolingClientConnectionManager implements ClientConnectionManager, ConnPoolControl {
    private final DnsResolver dnsResolver;
    private final Log log;
    private final ClientConnectionOperator operator;
    private final HttpConnPool pool;
    private final SchemeRegistry schemeRegistry;

    public PoolingClientConnectionManager(SchemeRegistry arg4) {
        this(arg4, -1, TimeUnit.MILLISECONDS);
    }

    public PoolingClientConnectionManager() {
        this(SchemeRegistryFactory.createDefault());
    }

    public PoolingClientConnectionManager(SchemeRegistry arg7, long arg8, TimeUnit arg10) {
        this(arg7, arg8, arg10, new SystemDefaultDnsResolver());
    }

    public PoolingClientConnectionManager(SchemeRegistry arg9, long arg10, TimeUnit arg12, DnsResolver arg13) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg9, "Scheme registry");
        Args.notNull(arg13, "DNS resolver");
        this.schemeRegistry = arg9;
        this.dnsResolver = arg13;
        this.operator = this.createConnectionOperator(arg9);
        this.pool = new HttpConnPool(this.log, this.operator, 2, 20, arg10, arg12);
    }

    public PoolingClientConnectionManager(SchemeRegistry arg7, DnsResolver arg8) {
        this(arg7, -1, TimeUnit.MILLISECONDS, arg8);
    }

    public void closeExpiredConnections() {
        this.log.debug("Closing expired connections");
        this.pool.closeExpired();
    }

    public void closeIdleConnections(long arg4, TimeUnit arg6) {
        if(this.log.isDebugEnabled()) {
            this.log.debug("Closing connections idle longer than " + arg4 + " " + arg6);
        }

        this.pool.closeIdle(arg4, arg6);
    }

    protected ClientConnectionOperator createConnectionOperator(SchemeRegistry arg3) {
        return new DefaultClientConnectionOperator(arg3, this.dnsResolver);
    }

    protected void finalize() {
        try {
            this.shutdown();
            super.finalize();
            return;
        }
        catch(Throwable v0) {
            super.finalize();
            throw v0;
        }
    }

    private String format(HttpRoute arg4, Object arg5) {
        StringBuilder v0 = new StringBuilder();
        v0.append("[route: ").append(arg4).append("]");
        if(arg5 != null) {
            v0.append("[state: ").append(arg5).append("]");
        }

        return v0.toString();
    }

    private String format(HttpPoolEntry arg4) {
        StringBuilder v0 = new StringBuilder();
        v0.append("[id: ").append(arg4.getId()).append("]");
        v0.append("[route: ").append(arg4.getRoute()).append("]");
        Object v1 = arg4.getState();
        if(v1 != null) {
            v0.append("[state: ").append(v1).append("]");
        }

        return v0.toString();
    }

    private String formatStats(HttpRoute arg7) {
        StringBuilder v0 = new StringBuilder();
        PoolStats v1 = this.pool.getTotalStats();
        PoolStats v2 = this.pool.getStats(arg7);
        v0.append("[total kept alive: ").append(v1.getAvailable()).append("; ");
        v0.append("route allocated: ").append(v2.getLeased() + v2.getAvailable());
        v0.append(" of ").append(v2.getMax()).append("; ");
        v0.append("total allocated: ").append(v1.getLeased() + v1.getAvailable());
        v0.append(" of ").append(v1.getMax()).append("]");
        return v0.toString();
    }

    public int getDefaultMaxPerRoute() {
        return this.pool.getDefaultMaxPerRoute();
    }

    public int getMaxPerRoute(Object arg2) {
        return this.getMaxPerRoute(((HttpRoute)arg2));
    }

    public int getMaxPerRoute(HttpRoute arg2) {
        return this.pool.getMaxPerRoute(arg2);
    }

    public int getMaxTotal() {
        return this.pool.getMaxTotal();
    }

    public SchemeRegistry getSchemeRegistry() {
        return this.schemeRegistry;
    }

    public PoolStats getStats(Object arg2) {
        return this.getStats(((HttpRoute)arg2));
    }

    public PoolStats getStats(HttpRoute arg2) {
        return this.pool.getStats(arg2);
    }

    public PoolStats getTotalStats() {
        return this.pool.getTotalStats();
    }

    ManagedClientConnection leaseConnection(Future arg5, long arg6, TimeUnit arg8) {
        Throwable v0_3;
        boolean v1;
        Object v0_2;
        try {
            v0_2 = arg5.get(arg6, arg8);
            if(v0_2 != null && !arg5.isCancelled()) {
                if(((HttpPoolEntry)v0_2).getConnection() != null) {
                    v1 = true;
                }
                else {
                    goto label_40;
                }

                goto label_19;
            }

            goto label_4;
        }
        catch(ExecutionException v0) {
            goto label_8;
        }
        catch(TimeoutException v0_1) {
            goto label_46;
        }

    label_40:
        v1 = false;
        try {
        label_19:
            Asserts.check(v1, "Pool entry with no connection");
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connection leased: " + this.format(((HttpPoolEntry)v0_2)) + this.formatStats(((HttpPoolEntry)v0_2).getRoute()));
            }

            return new ManagedClientConnectionImpl(((ClientConnectionManager)this), this.operator, ((HttpPoolEntry)v0_2));
        label_4:
            throw new InterruptedException();
        }
        catch(TimeoutException v0_1) {
        label_46:
            throw new ConnectionPoolTimeoutException("Timeout waiting for connection from pool");
        }
        catch(ExecutionException v0) {
        label_8:
            Throwable v1_1 = v0.getCause();
            if(v1_1 != null) {
                v0_3 = v1_1;
            }

            this.log.error("Unexpected exception leasing connection from pool", v0_3);
            throw new InterruptedException();
        }
    }

    public void releaseConnection(ManagedClientConnection arg6, long arg7, TimeUnit arg9) {
        HttpPoolEntry v1;
        Args.check(arg6 instanceof ManagedClientConnectionImpl, "Connection class mismatch, connection not obtained from this manager");
        boolean v0 = ((ManagedClientConnectionImpl)arg6).getManager() == this ? true : false;
        Asserts.check(v0, "Connection not obtained from this manager");
        __monitor_enter(arg6);
        try {
            v1 = ((ManagedClientConnectionImpl)arg6).detach();
            if(v1 != null) {
                goto label_15;
            }

            __monitor_exit(arg6);
            return;
        }
        catch(Throwable v0_1) {
            goto label_72;
        }

        try {
        label_15:
            if(!((ManagedClientConnectionImpl)arg6).isOpen()) {
                goto label_20;
            }

            if(((ManagedClientConnectionImpl)arg6).isMarkedReusable()) {
                goto label_20;
            }

            try {
                ((ManagedClientConnectionImpl)arg6).shutdown();
                goto label_20;
            }
            catch(IOException v0_2) {
                try {
                    if(this.log.isDebugEnabled()) {
                        this.log.debug("I/O exception shutting down released connection", ((Throwable)v0_2));
                    }

                label_20:
                    if(((ManagedClientConnectionImpl)arg6).isMarkedReusable()) {
                        TimeUnit v0_3 = arg9 != null ? arg9 : TimeUnit.MILLISECONDS;
                        v1.updateExpiry(arg7, v0_3);
                        if(!this.log.isDebugEnabled()) {
                            goto label_51;
                        }

                        String v0_4 = arg7 > 0 ? "for " + arg7 + " " + arg9 : "indefinitely";
                        this.log.debug("Connection " + this.format(v1) + " can be kept alive " + v0_4);
                    }

                    goto label_51;
                }
                catch(Throwable v0_1) {
                    try {
                    label_83:
                        this.pool.release(((PoolEntry)v1), ((ManagedClientConnectionImpl)arg6).isMarkedReusable());
                        throw v0_1;
                    label_51:
                        this.pool.release(((PoolEntry)v1), ((ManagedClientConnectionImpl)arg6).isMarkedReusable());
                        if(this.log.isDebugEnabled()) {
                            this.log.debug("Connection released: " + this.format(v1) + this.formatStats(v1.getRoute()));
                        }

                        __monitor_exit(arg6);
                        return;
                    label_72:
                        __monitor_exit(arg6);
                    }
                    catch(Throwable v0_1) {
                        goto label_72;
                    }
                }
            }
        }
        catch(Throwable v0_1) {
            goto label_83;
        }

        throw v0_1;
    }

    public ClientConnectionRequest requestConnection(HttpRoute arg4, Object arg5) {
        Args.notNull(arg4, "HTTP route");
        if(this.log.isDebugEnabled()) {
            this.log.debug("Connection request: " + this.format(arg4, arg5) + this.formatStats(arg4));
        }

        return new PoolingClientConnectionManager$1(this, this.pool.lease(arg4, arg5));
    }

    public void setDefaultMaxPerRoute(int arg2) {
        this.pool.setDefaultMaxPerRoute(arg2);
    }

    public void setMaxPerRoute(Object arg1, int arg2) {
        this.setMaxPerRoute(((HttpRoute)arg1), arg2);
    }

    public void setMaxPerRoute(HttpRoute arg2, int arg3) {
        this.pool.setMaxPerRoute(arg2, arg3);
    }

    public void setMaxTotal(int arg2) {
        this.pool.setMaxTotal(arg2);
    }

    public void shutdown() {
        this.log.debug("Connection manager is shutting down");
        try {
            this.pool.shutdown();
        }
        catch(IOException v0) {
            this.log.debug("I/O exception shutting down connection manager", ((Throwable)v0));
        }

        this.log.debug("Connection manager shut down");
    }
}

