// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.Closeable;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import java.util.concurrent.atomic.AtomicBoolean;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpClientConnection;
import org.apache.http.HttpHost;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.config.ConnectionConfig;
import org.apache.http.config.Lookup;
import org.apache.http.config.Registry;
import org.apache.http.config.RegistryBuilder;
import org.apache.http.config.SocketConfig;
import org.apache.http.conn.ConnectionPoolTimeoutException;
import org.apache.http.conn.ConnectionRequest;
import org.apache.http.conn.DnsResolver;
import org.apache.http.conn.HttpClientConnectionManager;
import org.apache.http.conn.HttpConnectionFactory;
import org.apache.http.conn.ManagedHttpClientConnection;
import org.apache.http.conn.SchemePortResolver;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.socket.PlainConnectionSocketFactory;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.pool.ConnPoolControl;
import org.apache.http.pool.PoolEntry;
import org.apache.http.pool.PoolStats;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@ThreadSafe public class PoolingHttpClientConnectionManager implements Closeable, HttpClientConnectionManager, ConnPoolControl {
    private final PoolingHttpClientConnectionManager$ConfigData configData;
    private final HttpClientConnectionOperator connectionOperator;
    private final AtomicBoolean isShutDown;
    private final Log log;
    private final CPool pool;

    public PoolingHttpClientConnectionManager(Registry arg2) {
        this(arg2, null, null);
    }

    public PoolingHttpClientConnectionManager() {
        this(PoolingHttpClientConnectionManager.getDefaultRegistry());
    }

    public PoolingHttpClientConnectionManager(long arg9, TimeUnit arg11) {
        this(PoolingHttpClientConnectionManager.getDefaultRegistry(), null, null, null, arg9, arg11);
    }

    public PoolingHttpClientConnectionManager(Registry arg8, HttpConnectionFactory arg9, SchemePortResolver arg10, DnsResolver arg11, long arg12, TimeUnit arg14) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        this.configData = new PoolingHttpClientConnectionManager$ConfigData();
        this.pool = new CPool(new PoolingHttpClientConnectionManager$InternalConnectionFactory(this.configData, arg9), 2, 20, arg12, arg14);
        this.connectionOperator = new HttpClientConnectionOperator(((Lookup)arg8), arg10, arg11);
        this.isShutDown = new AtomicBoolean(false);
    }

    public PoolingHttpClientConnectionManager(Registry arg9, HttpConnectionFactory arg10, DnsResolver arg11) {
        this(arg9, arg10, null, arg11, -1, TimeUnit.MILLISECONDS);
    }

    public PoolingHttpClientConnectionManager(Registry arg2, DnsResolver arg3) {
        this(arg2, null, arg3);
    }

    public PoolingHttpClientConnectionManager(Registry arg2, HttpConnectionFactory arg3) {
        this(arg2, arg3, null);
    }

    public PoolingHttpClientConnectionManager(HttpConnectionFactory arg3) {
        this(PoolingHttpClientConnectionManager.getDefaultRegistry(), arg3, null);
    }

    PoolingHttpClientConnectionManager(CPool arg3, Lookup arg4, SchemePortResolver arg5, DnsResolver arg6) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        this.configData = new PoolingHttpClientConnectionManager$ConfigData();
        this.pool = arg3;
        this.connectionOperator = new HttpClientConnectionOperator(arg4, arg5, arg6);
        this.isShutDown = new AtomicBoolean(false);
    }

    public void close() {
        this.shutdown();
    }

    public void closeExpiredConnections() {
        this.log.debug("Closing expired connections");
        this.pool.closeExpired();
    }

    public void closeIdleConnections(long arg4, TimeUnit arg6) {
        if(this.log.isDebugEnabled()) {
            this.log.debug("Closing connections idle longer than " + arg4 + " " + arg6);
        }

        this.pool.closeIdle(arg4, arg6);
    }

    public void connect(HttpClientConnection arg8, HttpRoute arg9, int arg10, HttpContext arg11) {
        Object v1;
        Args.notNull(arg8, "Managed Connection");
        Args.notNull(arg9, "HTTP route");
        __monitor_enter(arg8);
        try {
            v1 = CPoolProxy.getPoolEntry(arg8).getConnection();
            __monitor_exit(arg8);
        }
        catch(Throwable v0) {
            try {
            label_25:
                __monitor_exit(arg8);
            }
            catch(Throwable v0) {
                goto label_25;
            }

            throw v0;
        }

        HttpHost v2 = arg9.getProxyHost() != null ? arg9.getProxyHost() : arg9.getTargetHost();
        InetSocketAddress v3 = arg9.getLocalSocketAddress();
        SocketConfig v5 = this.configData.getSocketConfig(v2);
        if(v5 == null) {
            v5 = this.configData.getDefaultSocketConfig();
        }

        if(v5 == null) {
            v5 = SocketConfig.DEFAULT;
        }

        this.connectionOperator.connect(((ManagedHttpClientConnection)v1), v2, v3, arg10, v5, arg11);
    }

    protected void finalize() {
        try {
            this.shutdown();
            super.finalize();
            return;
        }
        catch(Throwable v0) {
            super.finalize();
            throw v0;
        }
    }

    private String format(HttpRoute arg4, Object arg5) {
        StringBuilder v0 = new StringBuilder();
        v0.append("[route: ").append(arg4).append("]");
        if(arg5 != null) {
            v0.append("[state: ").append(arg5).append("]");
        }

        return v0.toString();
    }

    private String format(CPoolEntry arg4) {
        StringBuilder v0 = new StringBuilder();
        v0.append("[id: ").append(arg4.getId()).append("]");
        v0.append("[route: ").append(arg4.getRoute()).append("]");
        Object v1 = arg4.getState();
        if(v1 != null) {
            v0.append("[state: ").append(v1).append("]");
        }

        return v0.toString();
    }

    private String formatStats(HttpRoute arg7) {
        StringBuilder v0 = new StringBuilder();
        PoolStats v1 = this.pool.getTotalStats();
        PoolStats v2 = this.pool.getStats(arg7);
        v0.append("[total kept alive: ").append(v1.getAvailable()).append("; ");
        v0.append("route allocated: ").append(v2.getLeased() + v2.getAvailable());
        v0.append(" of ").append(v2.getMax()).append("; ");
        v0.append("total allocated: ").append(v1.getLeased() + v1.getAvailable());
        v0.append(" of ").append(v1.getMax()).append("]");
        return v0.toString();
    }

    public ConnectionConfig getConnectionConfig(HttpHost arg2) {
        return this.configData.getConnectionConfig(arg2);
    }

    public ConnectionConfig getDefaultConnectionConfig() {
        return this.configData.getDefaultConnectionConfig();
    }

    public int getDefaultMaxPerRoute() {
        return this.pool.getDefaultMaxPerRoute();
    }

    private static Registry getDefaultRegistry() {
        return RegistryBuilder.create().register("http", PlainConnectionSocketFactory.getSocketFactory()).register("https", SSLConnectionSocketFactory.getSocketFactory()).build();
    }

    public SocketConfig getDefaultSocketConfig() {
        return this.configData.getDefaultSocketConfig();
    }

    public int getMaxPerRoute(Object arg2) {
        return this.getMaxPerRoute(((HttpRoute)arg2));
    }

    public int getMaxPerRoute(HttpRoute arg2) {
        return this.pool.getMaxPerRoute(arg2);
    }

    public int getMaxTotal() {
        return this.pool.getMaxTotal();
    }

    public SocketConfig getSocketConfig(HttpHost arg2) {
        return this.configData.getSocketConfig(arg2);
    }

    public PoolStats getStats(Object arg2) {
        return this.getStats(((HttpRoute)arg2));
    }

    public PoolStats getStats(HttpRoute arg2) {
        return this.pool.getStats(arg2);
    }

    public PoolStats getTotalStats() {
        return this.pool.getTotalStats();
    }

    protected HttpClientConnection leaseConnection(Future arg5, long arg6, TimeUnit arg8) {
        boolean v1;
        Object v0_1;
        try {
            v0_1 = arg5.get(arg6, arg8);
            if(v0_1 != null && !arg5.isCancelled()) {
                if(((CPoolEntry)v0_1).getConnection() != null) {
                    v1 = true;
                }
                else {
                    goto label_34;
                }

                goto label_15;
            }

            goto label_4;
        }
        catch(TimeoutException v0) {
            goto label_11;
        }

    label_34:
        v1 = false;
        try {
        label_15:
            Asserts.check(v1, "Pool entry with no connection");
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connection leased: " + this.format(((CPoolEntry)v0_1)) + this.formatStats(((CPoolEntry)v0_1).getRoute()));
            }

            return CPoolProxy.newProxy(((CPoolEntry)v0_1));
        label_4:
            throw new InterruptedException();
        }
        catch(TimeoutException v0) {
        label_11:
            throw new ConnectionPoolTimeoutException("Timeout waiting for connection from pool");
        }
    }

    public void releaseConnection(HttpClientConnection arg10, Object arg11, long arg12, TimeUnit arg14) {
        CPool v1_3;
        boolean v0_2;
        CPool v5;
        Object v0_1;
        CPoolEntry v4;
        boolean v2 = true;
        Args.notNull(arg10, "Managed connection");
        __monitor_enter(arg10);
        try {
            v4 = CPoolProxy.detach(arg10);
            if(v4 == null) {
                __monitor_exit(arg10);
            }
            else {
                v0_1 = v4.getConnection();
                goto label_10;
            }

            return;
        }
        catch(Throwable v0) {
            goto label_67;
        }

        try {
        label_10:
            boolean v1_1 = ((ManagedHttpClientConnection)v0_1).isOpen();
        }
        catch(Throwable v0) {
            goto label_67;
        }
        catch(Throwable v1) {
            goto label_76;
        }

        try {
            if(v1_1) {
                v4.setState(arg11);
                if(arg14 == null) {
                    arg14 = TimeUnit.MILLISECONDS;
                }

                v4.updateExpiry(arg12, arg14);
                if(!this.log.isDebugEnabled()) {
                    goto label_43;
                }

                String v1_2 = arg12 > 0 ? "for " + (((double)arg12)) / 1000 + " seconds" : "indefinitely";
                this.log.debug("Connection " + this.format(v4) + " can be kept alive " + v1_2);
            }

            goto label_43;
        }
        catch(Throwable v1) {
            try {
            label_76:
                v5 = this.pool;
                if(!((ManagedHttpClientConnection)v0_1).isOpen()) {
                    goto label_99;
                }
                else if(v4.isRouteComplete()) {
                    v0_2 = true;
                }
                else {
                    goto label_99;
                }

                goto label_82;
            }
            catch(Throwable v0) {
                goto label_67;
            }

        label_99:
            v0_2 = false;
            try {
            label_82:
                v5.release(((PoolEntry)v4), v0_2);
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Connection released: " + this.format(v4) + this.formatStats(v4.getRoute()));
                }

                throw v1;
            label_43:
                v1_3 = this.pool;
                if(!((ManagedHttpClientConnection)v0_1).isOpen()) {
                    goto label_73;
                }
                else if(!v4.isRouteComplete()) {
                    goto label_73;
                }

                goto label_48;
            }
            catch(Throwable v0) {
                goto label_67;
            }
        }

    label_73:
        v2 = false;
        try {
        label_48:
            v1_3.release(((PoolEntry)v4), v2);
            if(this.log.isDebugEnabled()) {
                this.log.debug("Connection released: " + this.format(v4) + this.formatStats(v4.getRoute()));
            }

            __monitor_exit(arg10);
            return;
        label_67:
            __monitor_exit(arg10);
        }
        catch(Throwable v0) {
            goto label_67;
        }

        throw v0;
    }

    public ConnectionRequest requestConnection(HttpRoute arg4, Object arg5) {
        Args.notNull(arg4, "HTTP route");
        if(this.log.isDebugEnabled()) {
            this.log.debug("Connection request: " + this.format(arg4, arg5) + this.formatStats(arg4));
        }

        return new PoolingHttpClientConnectionManager$1(this, this.pool.lease(arg4, arg5, null));
    }

    public void routeComplete(HttpClientConnection arg2, HttpRoute arg3, HttpContext arg4) {
        Args.notNull(arg2, "Managed Connection");
        Args.notNull(arg3, "HTTP route");
        __monitor_enter(arg2);
        try {
            CPoolProxy.getPoolEntry(arg2).markRouteComplete();
            __monitor_exit(arg2);
            return;
        label_10:
            __monitor_exit(arg2);
        }
        catch(Throwable v0) {
            goto label_10;
        }

        throw v0;
    }

    public void setConnectionConfig(HttpHost arg2, ConnectionConfig arg3) {
        this.configData.setConnectionConfig(arg2, arg3);
    }

    public void setDefaultConnectionConfig(ConnectionConfig arg2) {
        this.configData.setDefaultConnectionConfig(arg2);
    }

    public void setDefaultMaxPerRoute(int arg2) {
        this.pool.setDefaultMaxPerRoute(arg2);
    }

    public void setDefaultSocketConfig(SocketConfig arg2) {
        this.configData.setDefaultSocketConfig(arg2);
    }

    public void setMaxPerRoute(Object arg1, int arg2) {
        this.setMaxPerRoute(((HttpRoute)arg1), arg2);
    }

    public void setMaxPerRoute(HttpRoute arg2, int arg3) {
        this.pool.setMaxPerRoute(arg2, arg3);
    }

    public void setMaxTotal(int arg2) {
        this.pool.setMaxTotal(arg2);
    }

    public void setSocketConfig(HttpHost arg2, SocketConfig arg3) {
        this.configData.setSocketConfig(arg2, arg3);
    }

    public void shutdown() {
        if(this.isShutDown.compareAndSet(false, true)) {
            this.log.debug("Connection manager is shutting down");
            try {
                this.pool.shutdown();
            }
            catch(IOException v0) {
                this.log.debug("I/O exception shutting down connection manager", ((Throwable)v0));
            }

            this.log.debug("Connection manager shut down");
        }
    }

    public void upgrade(HttpClientConnection arg4, HttpRoute arg5, HttpContext arg6) {
        Object v0_1;
        Args.notNull(arg4, "Managed Connection");
        Args.notNull(arg5, "HTTP route");
        __monitor_enter(arg4);
        try {
            v0_1 = CPoolProxy.getPoolEntry(arg4).getConnection();
            __monitor_exit(arg4);
        }
        catch(Throwable v0) {
            try {
            label_13:
                __monitor_exit(arg4);
            }
            catch(Throwable v0) {
                goto label_13;
            }

            throw v0;
        }

        this.connectionOperator.upgrade(((ManagedHttpClientConnection)v0_1), arg5.getTargetHost(), arg6);
    }
}

