// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.IOException;
import java.util.concurrent.TimeUnit;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.annotation.GuardedBy;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ClientConnectionRequest;
import org.apache.http.conn.ManagedClientConnection;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.RouteTracker;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.params.HttpParams;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated @ThreadSafe public class SingleClientConnManager implements ClientConnectionManager {
    public static final String MISUSE_MESSAGE = "Invalid use of SingleClientConnManager: connection still allocated.\nMake sure to release the connection before allocating another one.";
    protected final boolean alwaysShutDown;
    protected final ClientConnectionOperator connOperator;
    @GuardedBy(value="this") protected volatile long connectionExpiresTime;
    protected volatile boolean isShutDown;
    @GuardedBy(value="this") protected volatile long lastReleaseTime;
    private final Log log;
    @GuardedBy(value="this") protected volatile SingleClientConnManager$ConnAdapter managedConn;
    protected final SchemeRegistry schemeRegistry;
    @GuardedBy(value="this") protected volatile SingleClientConnManager$PoolEntry uniquePoolEntry;

    public SingleClientConnManager() {
        this(SchemeRegistryFactory.createDefault());
    }

    public SingleClientConnManager(SchemeRegistry arg4) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg4, "Scheme registry");
        this.schemeRegistry = arg4;
        this.connOperator = this.createConnectionOperator(arg4);
        this.uniquePoolEntry = new SingleClientConnManager$PoolEntry(this);
        this.managedConn = null;
        this.lastReleaseTime = -1;
        this.alwaysShutDown = false;
        this.isShutDown = false;
    }

    @Deprecated public SingleClientConnManager(HttpParams arg1, SchemeRegistry arg2) {
        this(arg2);
    }

    protected final void assertStillUp() {
        boolean v0 = !this.isShutDown ? true : false;
        Asserts.check(v0, "Manager is shut down");
    }

    public void closeExpiredConnections() {
        if(System.currentTimeMillis() >= this.connectionExpiresTime) {
            this.closeIdleConnections(0, TimeUnit.MILLISECONDS);
        }
    }

    public void closeIdleConnections(long arg5, TimeUnit arg7) {
        this.assertStillUp();
        Args.notNull(arg7, "Time unit");
        __monitor_enter(this);
        try {
            if(this.managedConn == null && (this.uniquePoolEntry.connection.isOpen()) && this.lastReleaseTime <= System.currentTimeMillis() - arg7.toMillis(arg5)) {
                try {
                    this.uniquePoolEntry.close();
                }
                catch(IOException v0_1) {
                    this.log.debug("Problem closing idle connection.", ((Throwable)v0_1));
                }
            }

            __monitor_exit(this);
            return;
        label_25:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_25;
        }

        throw v0;
    }

    protected ClientConnectionOperator createConnectionOperator(SchemeRegistry arg2) {
        return new DefaultClientConnectionOperator(arg2);
    }

    protected void finalize() {
        try {
            this.shutdown();
            super.finalize();
            return;
        }
        catch(Throwable v0) {
            super.finalize();
            throw v0;
        }
    }

    public ManagedClientConnection getConnection(HttpRoute arg7, Object arg8) {
        int v0_3;
        int v2 = 1;
        int v1 = 0;
        Args.notNull(arg7, "Route");
        this.assertStillUp();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Get connection for route " + arg7);
        }

        __monitor_enter(this);
        try {
            boolean v0_1 = this.managedConn == null ? true : false;
            Asserts.check(v0_1, "Invalid use of SingleClientConnManager: connection still allocated.\nMake sure to release the connection before allocating another one.");
            this.closeExpiredConnections();
            if(this.uniquePoolEntry.connection.isOpen()) {
                RouteTracker v0_2 = this.uniquePoolEntry.tracker;
                if(v0_2 == null) {
                    goto label_33;
                }
                else if(v0_2.toRoute().equals(arg7)) {
                    v0_3 = 0;
                }
                else {
                    goto label_33;
                }

                goto label_34;
            }
            else {
                goto label_55;
            }
        }
        catch(Throwable v0) {
            goto label_63;
        }

    label_33:
        v0_3 = 1;
    label_34:
        int v5 = v0_3;
        v0_3 = 0;
        v1 = v5;
        goto label_37;
    label_55:
        v0_3 = 1;
    label_37:
        if(v1 == 0) {
            goto label_65;
        }

        try {
            this.uniquePoolEntry.shutdown();
            goto label_40;
        }
        catch(Throwable v0) {
        label_64:
            throw v0;
        }
        catch(IOException v0_4) {
            try {
                this.log.debug("Problem shutting down connection.", ((Throwable)v0_4));
                goto label_40;
            }
            catch(Throwable v0) {
                goto label_63;
            }

        label_65:
            v2 = v0_3;
        label_40:
            if(v2 != 0) {
                try {
                    this.uniquePoolEntry = new SingleClientConnManager$PoolEntry(this);
                label_44:
                    this.managedConn = new SingleClientConnManager$ConnAdapter(this, this.uniquePoolEntry, arg7);
                    __monitor_exit(this);
                    return this.managedConn;
                label_63:
                    __monitor_exit(this);
                    goto label_64;
                }
                catch(Throwable v0) {
                    goto label_63;
                }
            }

            goto label_44;
        }
    }

    public SchemeRegistry getSchemeRegistry() {
        return this.schemeRegistry;
    }

    public void releaseConnection(ManagedClientConnection arg6, long arg7, TimeUnit arg9) {
        long v0_4;
        SingleClientConnManager$ConnAdapter v0_3;
        SingleClientConnManager$ConnAdapter v1;
        boolean v0_1;
        long v3 = 0;
        Args.check(arg6 instanceof SingleClientConnManager$ConnAdapter, "Connection class mismatch, connection not obtained from this manager");
        this.assertStillUp();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Releasing connection " + arg6);
        }

        __monitor_enter(arg6);
        try {
            if(((SingleClientConnManager$ConnAdapter)arg6).poolEntry == null) {
                __monitor_exit(arg6);
                return;
            }

            if(((SingleClientConnManager$ConnAdapter)arg6).getManager() == this) {
                v0_1 = true;
            }
            else {
                goto label_56;
            }

            goto label_24;
        }
        catch(Throwable v0) {
            goto label_54;
        }

    label_56:
        v0_1 = false;
        try {
        label_24:
            Asserts.check(v0_1, "Connection not obtained from this manager");
        }
        catch(Throwable v0) {
            goto label_54;
        }

        try {
            if(((SingleClientConnManager$ConnAdapter)arg6).isOpen()) {
                if(!this.alwaysShutDown && (((SingleClientConnManager$ConnAdapter)arg6).isMarkedReusable())) {
                    goto label_39;
                }

                if(this.log.isDebugEnabled()) {
                    this.log.debug("Released connection open but not reusable.");
                }

                ((SingleClientConnManager$ConnAdapter)arg6).shutdown();
            }

            goto label_39;
        }
        catch(Throwable v0) {
            try {
            label_91:
                ((SingleClientConnManager$ConnAdapter)arg6).detach();
                __monitor_enter(this);
                v1 = null;
            }
            catch(Throwable v0) {
                goto label_54;
            }

            try {
                this.managedConn = v1;
                this.lastReleaseTime = System.currentTimeMillis();
                if(arg7 > v3) {
                    this.connectionExpiresTime = arg9.toMillis(arg7) + this.lastReleaseTime;
                }
                else {
                    goto label_104;
                }

                goto label_102;
            }
            catch(Throwable v0) {
                goto label_108;
            }

        label_104:
            long v1_1 = 9223372036854775807L;
            try {
                this.connectionExpiresTime = v1_1;
            label_102:
                __monitor_exit(this);
                goto label_103;
            label_108:
                __monitor_exit(this);
            }
            catch(Throwable v0) {
                goto label_108;
            }

            try {
                throw v0;
            label_103:
                throw v0;
            label_39:
                ((SingleClientConnManager$ConnAdapter)arg6).detach();
                __monitor_enter(this);
                v0_3 = null;
            }
            catch(Throwable v0) {
                goto label_54;
            }
        }
        catch(IOException v0_2) {
            try {
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Exception shutting down released connection.", ((Throwable)v0_2));
                }
            }
            catch(Throwable v0) {
                goto label_91;
            }

            try {
                ((SingleClientConnManager$ConnAdapter)arg6).detach();
                __monitor_enter(this);
                v0_3 = null;
            }
            catch(Throwable v0) {
                goto label_54;
            }

            try {
                this.managedConn = v0_3;
                this.lastReleaseTime = System.currentTimeMillis();
                if(arg7 > v3) {
                    this.connectionExpiresTime = arg9.toMillis(arg7) + this.lastReleaseTime;
                }
                else {
                    goto label_87;
                }

                goto label_82;
            }
            catch(Throwable v0) {
                goto label_85;
            }

        label_87:
            v0_4 = 9223372036854775807L;
            try {
                this.connectionExpiresTime = v0_4;
            label_82:
                __monitor_exit(this);
                goto label_51;
            label_85:
                __monitor_exit(this);
            }
            catch(Throwable v0) {
                goto label_85;
            }

            try {
                throw v0;
            }
            catch(Throwable v0) {
                goto label_54;
            }
        }

        try {
            this.managedConn = v0_3;
            this.lastReleaseTime = System.currentTimeMillis();
            if(arg7 > v3) {
                this.connectionExpiresTime = arg9.toMillis(arg7) + this.lastReleaseTime;
            }
            else {
                goto label_58;
            }

            goto label_50;
        }
        catch(Throwable v0) {
            goto label_62;
        }

    label_58:
        v0_4 = 9223372036854775807L;
        try {
            this.connectionExpiresTime = v0_4;
        label_50:
            __monitor_exit(this);
            goto label_51;
        label_62:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_62;
        }

        try {
            throw v0;
        label_51:
            __monitor_exit(arg6);
            return;
        label_54:
            __monitor_exit(arg6);
        }
        catch(Throwable v0) {
            goto label_54;
        }

        throw v0;
    }

    public final ClientConnectionRequest requestConnection(HttpRoute arg2, Object arg3) {
        return new SingleClientConnManager$1(this, arg2, arg3);
    }

    protected void revokeConnection() {
        SingleClientConnManager$ConnAdapter v0 = this.managedConn;
        if(v0 != null) {
            v0.detach();
            __monitor_enter(this);
            try {
                this.uniquePoolEntry.shutdown();
                goto label_7;
            }
            catch(IOException v0_1) {
                try {
                    this.log.debug("Problem while shutting down connection.", ((Throwable)v0_1));
                label_7:
                    __monitor_exit(this);
                    return;
                label_10:
                    __monitor_exit(this);
                }
                catch(Throwable v0_2) {
                    goto label_10;
                }
            }

            throw v0_2;
        }
    }

    public void shutdown() {
        SingleClientConnManager$PoolEntry v0_2;
        this.isShutDown = true;
        __monitor_enter(this);
        try {
            if(this.uniquePoolEntry != null) {
                this.uniquePoolEntry.shutdown();
            }
        }
        catch(Throwable v0) {
        label_26:
            SingleClientConnManager$PoolEntry v1 = null;
            try {
                this.uniquePoolEntry = v1;
                this.managedConn = null;
                throw v0;
            }
            catch(Throwable v0) {
                goto label_23;
            }
        }
        catch(IOException v0_1) {
            try {
                this.log.debug("Problem while shutting down manager.", ((Throwable)v0_1));
                v0_2 = null;
            }
            catch(Throwable v0) {
                goto label_26;
            }

            try {
                this.uniquePoolEntry = v0_2;
                this.managedConn = null;
                goto label_11;
            }
            catch(Throwable v0) {
                goto label_23;
            }
        }

        v0_2 = null;
        try {
            this.uniquePoolEntry = v0_2;
            this.managedConn = null;
        label_11:
            __monitor_exit(this);
            return;
        label_23:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_23;
        }

        throw v0;
    }
}

