// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import org.apache.commons.logging.Log;
import org.apache.http.annotation.Immutable;
import org.apache.http.util.Args;

@Immutable public class Wire {
    private final String id;
    private final Log log;

    public Wire(Log arg2) {
        this(arg2, "");
    }

    public Wire(Log arg1, String arg2) {
        super();
        this.log = arg1;
        this.id = arg2;
    }

    public boolean enabled() {
        return this.log.isDebugEnabled();
    }

    public void input(String arg2) {
        Args.notNull(arg2, "Input");
        this.input(arg2.getBytes());
    }

    public void input(int arg4) {
        this.input(new byte[]{((byte)arg4)});
    }

    public void input(byte[] arg3, int arg4, int arg5) {
        Args.notNull(arg3, "Input");
        this.wire("<< ", new ByteArrayInputStream(arg3, arg4, arg5));
    }

    public void input(byte[] arg3) {
        Args.notNull(arg3, "Input");
        this.wire("<< ", new ByteArrayInputStream(arg3));
    }

    public void input(InputStream arg2) {
        Args.notNull(arg2, "Input");
        this.wire("<< ", arg2);
    }

    public void output(String arg2) {
        Args.notNull(arg2, "Output");
        this.output(arg2.getBytes());
    }

    public void output(int arg4) {
        this.output(new byte[]{((byte)arg4)});
    }

    public void output(byte[] arg3) {
        Args.notNull(arg3, "Output");
        this.wire(">> ", new ByteArrayInputStream(arg3));
    }

    public void output(byte[] arg3, int arg4, int arg5) {
        Args.notNull(arg3, "Output");
        this.wire(">> ", new ByteArrayInputStream(arg3, arg4, arg5));
    }

    public void output(InputStream arg2) {
        Args.notNull(arg2, "Output");
        this.wire(">> ", arg2);
    }

    private void wire(String arg7, InputStream arg8) {
        char v5 = '\"';
        StringBuilder v0 = new StringBuilder();
        while(true) {
            int v1 = arg8.read();
            if(v1 == -1) {
                break;
            }

            if(v1 == 13) {
                v0.append("[\\r]");
                continue;
            }

            if(v1 == 10) {
                v0.append("[\\n]\"");
                v0.insert(0, "\"");
                v0.insert(0, arg7);
                this.log.debug(this.id + " " + v0.toString());
                v0.setLength(0);
                continue;
            }

            if(v1 >= 32 && v1 <= 127) {
                v0.append(((char)v1));
                continue;
            }

            v0.append("[0x");
            v0.append(Integer.toHexString(v1));
            v0.append("]");
        }

        if(v0.length() > 0) {
            v0.append(v5);
            v0.insert(0, v5);
            v0.insert(0, arg7);
            this.log.debug(this.id + " " + v0.toString());
        }
    }
}

