// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn.tsccm;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.Set;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ConnectionPoolTimeoutException;
import org.apache.http.conn.OperatedClientConnection;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.params.ConnPerRoute;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.params.HttpParams;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated public class ConnPoolByRoute extends AbstractConnPool {
    protected final ConnPerRoute connPerRoute;
    private final long connTTL;
    private final TimeUnit connTTLTimeUnit;
    protected final Queue freeConnections;
    protected final Set leasedConnections;
    private final Log log;
    protected volatile int maxTotalConnections;
    protected volatile int numConnections;
    protected final ClientConnectionOperator operator;
    private final Lock poolLock;
    protected final Map routeToPool;
    protected volatile boolean shutdown;
    protected final Queue waitingThreads;

    public ConnPoolByRoute(ClientConnectionOperator arg8, ConnPerRoute arg9, int arg10) {
        this(arg8, arg9, arg10, -1, TimeUnit.MILLISECONDS);
    }

    public ConnPoolByRoute(ClientConnectionOperator arg2, ConnPerRoute arg3, int arg4, long arg5, TimeUnit arg7) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "Connection operator");
        Args.notNull(arg3, "Connections per route");
        this.poolLock = ((AbstractConnPool)this).poolLock;
        this.leasedConnections = ((AbstractConnPool)this).leasedConnections;
        this.operator = arg2;
        this.connPerRoute = arg3;
        this.maxTotalConnections = arg4;
        this.freeConnections = this.createFreeConnQueue();
        this.waitingThreads = this.createWaitingThreadQueue();
        this.routeToPool = this.createRouteToPoolMap();
        this.connTTL = arg5;
        this.connTTLTimeUnit = arg7;
    }

    @Deprecated public ConnPoolByRoute(ClientConnectionOperator arg3, HttpParams arg4) {
        this(arg3, ConnManagerParams.getMaxConnectionsPerRoute(arg4), ConnManagerParams.getMaxTotalConnections(arg4));
    }

    static Lock access$000(ConnPoolByRoute arg1) {
        return arg1.poolLock;
    }

    private void closeConnection(BasicPoolEntry arg4) {
        OperatedClientConnection v0 = arg4.getConnection();
        if(v0 != null) {
            try {
                v0.close();
            }
            catch(IOException v0_1) {
                this.log.debug("I/O error closing connection", ((Throwable)v0_1));
            }
        }
    }

    public void closeExpiredConnections() {
        this.log.debug("Closing expired connections");
        long v1 = System.currentTimeMillis();
        this.poolLock.lock();
        try {
            Iterator v3 = this.freeConnections.iterator();
            while(v3.hasNext()) {
                Object v0_1 = v3.next();
                if(!((BasicPoolEntry)v0_1).isExpired(v1)) {
                    continue;
                }

                if(this.log.isDebugEnabled()) {
                    this.log.debug("Closing connection expired @ " + new Date(((BasicPoolEntry)v0_1).getExpiry()));
                }

                v3.remove();
                this.deleteEntry(((BasicPoolEntry)v0_1));
            }
        }
        catch(Throwable v0) {
            goto label_32;
        }

        this.poolLock.unlock();
        return;
    label_32:
        this.poolLock.unlock();
        throw v0;
    }

    public void closeIdleConnections(long arg10, TimeUnit arg12) {
        long v0 = 0;
        Args.notNull(arg12, "Time unit");
        if(arg10 <= v0) {
            arg10 = v0;
        }

        if(this.log.isDebugEnabled()) {
            this.log.debug("Closing connections idle longer than " + arg10 + " " + arg12);
        }

        long v1 = System.currentTimeMillis() - arg12.toMillis(arg10);
        this.poolLock.lock();
        try {
            Iterator v3 = this.freeConnections.iterator();
            while(v3.hasNext()) {
                Object v0_2 = v3.next();
                if(((BasicPoolEntry)v0_2).getUpdated() > v1) {
                    continue;
                }

                if(this.log.isDebugEnabled()) {
                    this.log.debug("Closing connection last used @ " + new Date(((BasicPoolEntry)v0_2).getUpdated()));
                }

                v3.remove();
                this.deleteEntry(((BasicPoolEntry)v0_2));
            }
        }
        catch(Throwable v0_1) {
            goto label_49;
        }

        this.poolLock.unlock();
        return;
    label_49:
        this.poolLock.unlock();
        throw v0_1;
    }

    protected BasicPoolEntry createEntry(RouteSpecificPool arg7, ClientConnectionOperator arg8) {
        if(this.log.isDebugEnabled()) {
            this.log.debug("Creating new connection [" + arg7.getRoute() + "]");
        }

        BasicPoolEntry v0 = new BasicPoolEntry(arg8, arg7.getRoute(), this.connTTL, this.connTTLTimeUnit);
        this.poolLock.lock();
        try {
            arg7.createdEntry(v0);
            ++this.numConnections;
            this.leasedConnections.add(v0);
        }
        catch(Throwable v0_1) {
            this.poolLock.unlock();
            throw v0_1;
        }

        this.poolLock.unlock();
        return v0;
    }

    protected Queue createFreeConnQueue() {
        return new LinkedList();
    }

    protected Map createRouteToPoolMap() {
        return new HashMap();
    }

    protected Queue createWaitingThreadQueue() {
        return new LinkedList();
    }

    public void deleteClosedConnections() {
        this.poolLock.lock();
        try {
            Iterator v1 = this.freeConnections.iterator();
            while(v1.hasNext()) {
                Object v0_1 = v1.next();
                if(((BasicPoolEntry)v0_1).getConnection().isOpen()) {
                    continue;
                }

                v1.remove();
                this.deleteEntry(((BasicPoolEntry)v0_1));
            }
        }
        catch(Throwable v0) {
            goto label_15;
        }

        this.poolLock.unlock();
        return;
    label_15:
        this.poolLock.unlock();
        throw v0;
    }

    protected void deleteEntry(BasicPoolEntry arg5) {
        HttpRoute v0 = arg5.getPlannedRoute();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Deleting connection [" + v0 + "][" + arg5.getState() + "]");
        }

        this.poolLock.lock();
        try {
            this.closeConnection(arg5);
            RouteSpecificPool v1 = this.getRoutePool(v0, true);
            v1.deleteEntry(arg5);
            --this.numConnections;
            if(v1.isUnused()) {
                this.routeToPool.remove(v0);
            }
        }
        catch(Throwable v0_1) {
            this.poolLock.unlock();
            throw v0_1;
        }

        this.poolLock.unlock();
    }

    protected void deleteLeastUsedEntry() {
        this.poolLock.lock();
        try {
            Object v0_1 = this.freeConnections.remove();
            if(v0_1 != null) {
                this.deleteEntry(((BasicPoolEntry)v0_1));
            }
            else if(this.log.isDebugEnabled()) {
                this.log.debug("No free connection to delete");
            }
        }
        catch(Throwable v0) {
            this.poolLock.unlock();
            throw v0;
        }

        this.poolLock.unlock();
    }

    public void freeEntry(BasicPoolEntry arg7, boolean arg8, long arg9, TimeUnit arg11) {
        HttpRoute v1 = arg7.getPlannedRoute();
        if(this.log.isDebugEnabled()) {
            this.log.debug("Releasing connection [" + v1 + "][" + arg7.getState() + "]");
        }

        this.poolLock.lock();
        try {
            if(this.shutdown) {
                this.closeConnection(arg7);
            }
            else {
                goto label_26;
            }
        }
        catch(Throwable v0) {
            goto label_80;
        }

        this.poolLock.unlock();
        return;
        try {
        label_26:
            this.leasedConnections.remove(arg7);
            RouteSpecificPool v2 = this.getRoutePool(v1, true);
            if(!arg8 || v2.getCapacity() < 0) {
                this.closeConnection(arg7);
                v2.dropEntry();
                --this.numConnections;
            }
            else {
                if(this.log.isDebugEnabled()) {
                    String v0_1 = arg9 > 0 ? "for " + arg9 + " " + arg11 : "indefinitely";
                    this.log.debug("Pooling connection [" + v1 + "][" + arg7.getState() + "]; keep alive " + v0_1);
                }

                v2.freeEntry(arg7);
                arg7.updateExpiry(arg9, arg11);
                this.freeConnections.add(arg7);
            }

            this.notifyWaitingThread(v2);
        }
        catch(Throwable v0) {
        label_80:
            this.poolLock.unlock();
            throw v0;
        }

        this.poolLock.unlock();
    }

    public int getConnectionsInPool() {
        int v0_1;
        this.poolLock.lock();
        try {
            v0_1 = this.numConnections;
        }
        catch(Throwable v0) {
            this.poolLock.unlock();
            throw v0;
        }

        this.poolLock.unlock();
        return v0_1;
    }

    public int getConnectionsInPool(HttpRoute arg3) {
        int v0 = 0;
        this.poolLock.lock();
        try {
            RouteSpecificPool v1 = this.getRoutePool(arg3, false);
            if(v1 != null) {
                v0 = v1.getEntryCount();
            }
        }
        catch(Throwable v0_1) {
            this.poolLock.unlock();
            throw v0_1;
        }

        this.poolLock.unlock();
        return v0;
    }

    protected BasicPoolEntry getEntryBlocking(HttpRoute arg9, Object arg10, long arg11, TimeUnit arg13, WaitingThreadAborter arg14) {
        boolean v3_1;
        WaitingThread v1;
        RouteSpecificPool v2;
        Date v0 = null;
        if(arg11 > 0) {
            v0 = new Date(System.currentTimeMillis() + arg13.toMillis(arg11));
        }

        BasicPoolEntry v3 = null;
        this.poolLock.lock();
        try {
            v2 = this.getRoutePool(arg9, true);
            v1 = null;
            do {
            label_14:
                if(v3 == null) {
                    if(!this.shutdown) {
                        v3_1 = true;
                    }
                    else {
                        break;
                    }

                    goto label_18;
                }

                goto label_51;
            }
            while(true);
        }
        catch(Throwable v0_1) {
            goto label_141;
        }

        v3_1 = false;
        try {
        label_18:
            Asserts.check(v3_1, "Connection pool shut down");
            if(this.log.isDebugEnabled()) {
                this.log.debug("[" + arg9 + "] total kept alive: " + this.freeConnections.size() + ", total issued: " + this.leasedConnections.size() + ", total allocated: " + this.numConnections + " out of " + this.maxTotalConnections);
            }

            v3 = this.getFreeEntry(v2, arg10);
            if(v3 != null) {
                goto label_51;
            }

            int v4 = v2.getCapacity() > 0 ? 1 : 0;
            if(this.log.isDebugEnabled()) {
                this.log.debug("Available capacity: " + v2.getCapacity() + " out of " + v2.getMaxEntries() + " [" + arg9 + "][" + arg10 + "]");
            }

            if(v4 != 0 && this.numConnections < this.maxTotalConnections) {
                v3 = this.createEntry(v2, this.operator);
                goto label_14;
            }

            if(v4 != 0 && !this.freeConnections.isEmpty()) {
                this.deleteLeastUsedEntry();
                v2 = this.getRoutePool(arg9, true);
                v3 = this.createEntry(v2, this.operator);
                goto label_14;
            }

            if(this.log.isDebugEnabled()) {
                this.log.debug("Need to wait for connection [" + arg9 + "][" + arg10 + "]");
            }

            if(v1 == null) {
                v1 = this.newWaitingThread(this.poolLock.newCondition(), v2);
                arg14.setWaitingThread(v1);
            }
        }
        catch(Throwable v0_1) {
            goto label_141;
        }

        try {
            v2.queueThread(v1);
            this.waitingThreads.add(v1);
            boolean v4_1 = v1.await(v0);
            goto label_127;
        }
        catch(Throwable v0_1) {
            try {
                v2.removeThread(v1);
                this.waitingThreads.remove(v1);
                throw v0_1;
            label_127:
                v2.removeThread(v1);
                this.waitingThreads.remove(v1);
                if(v4_1) {
                    goto label_14;
                }

                if(v0 == null) {
                    goto label_14;
                }

                if(v0.getTime() > System.currentTimeMillis()) {
                    goto label_14;
                }

                throw new ConnectionPoolTimeoutException("Timeout waiting for connection from pool");
            }
            catch(Throwable v0_1) {
                goto label_141;
            }
        }

    label_51:
        this.poolLock.unlock();
        return v3;
    label_141:
        this.poolLock.unlock();
        throw v0_1;
    }

    protected BasicPoolEntry getFreeEntry(RouteSpecificPool arg7, Object arg8) {
        BasicPoolEntry v2 = null;
        this.poolLock.lock();
        int v0;
        for(v0 = 0; v0 == 0; v0 = 1) {
            try {
                v2 = arg7.allocEntry(arg8);
                if(v2 != null) {
                    if(this.log.isDebugEnabled()) {
                        this.log.debug("Getting free connection [" + arg7.getRoute() + "][" + arg8 + "]");
                    }

                    this.freeConnections.remove(v2);
                    if(v2.isExpired(System.currentTimeMillis())) {
                        if(this.log.isDebugEnabled()) {
                            this.log.debug("Closing expired free connection [" + arg7.getRoute() + "][" + arg8 + "]");
                        }

                        this.closeConnection(v2);
                        arg7.dropEntry();
                        --this.numConnections;
                        continue;
                    }

                    this.leasedConnections.add(v2);
                    v0 = 1;
                    continue;
                }

                if(!this.log.isDebugEnabled()) {
                    goto label_83;
                }

                this.log.debug("No free connections [" + arg7.getRoute() + "][" + arg8 + "]");
                v0 = 1;
                continue;
            }
            catch(Throwable v0_1) {
                this.poolLock.unlock();
                throw v0_1;
            }

        label_83:
        }

        this.poolLock.unlock();
        return v2;
    }

    protected Lock getLock() {
        return this.poolLock;
    }

    public int getMaxTotalConnections() {
        return this.maxTotalConnections;
    }

    protected RouteSpecificPool getRoutePool(HttpRoute arg3, boolean arg4) {
        RouteSpecificPool v0_2;
        this.poolLock.lock();
        try {
            Object v0_1 = this.routeToPool.get(arg3);
            if(v0_1 == null && (arg4)) {
                v0_2 = this.newRouteSpecificPool(arg3);
                this.routeToPool.put(arg3, v0_2);
            }
        }
        catch(Throwable v0) {
            this.poolLock.unlock();
            throw v0;
        }

        this.poolLock.unlock();
        return v0_2;
    }

    protected void handleLostEntry(HttpRoute arg3) {
        this.poolLock.lock();
        try {
            RouteSpecificPool v0_1 = this.getRoutePool(arg3, true);
            v0_1.dropEntry();
            if(v0_1.isUnused()) {
                this.routeToPool.remove(arg3);
            }

            --this.numConnections;
            this.notifyWaitingThread(v0_1);
        }
        catch(Throwable v0) {
            this.poolLock.unlock();
            throw v0;
        }

        this.poolLock.unlock();
    }

    protected RouteSpecificPool newRouteSpecificPool(HttpRoute arg3) {
        return new RouteSpecificPool(arg3, this.connPerRoute);
    }

    protected WaitingThread newWaitingThread(Condition arg2, RouteSpecificPool arg3) {
        return new WaitingThread(arg2, arg3);
    }

    protected void notifyWaitingThread(RouteSpecificPool arg4) {
        WaitingThread v0 = null;
        this.poolLock.lock();
        if(arg4 != null) {
            try {
                if(arg4.hasThread()) {
                    if(this.log.isDebugEnabled()) {
                        this.log.debug("Notifying thread waiting on pool [" + arg4.getRoute() + "]");
                    }

                    v0 = arg4.nextThread();
                }
                else {
                label_26:
                    if(!this.waitingThreads.isEmpty()) {
                        if(this.log.isDebugEnabled()) {
                            this.log.debug("Notifying thread waiting on any pool");
                        }

                        Object v0_2 = this.waitingThreads.remove();
                        goto label_21;
                    }

                    if(!this.log.isDebugEnabled()) {
                        goto label_21;
                    }

                    this.log.debug("Notifying no-one, there are no waiting threads");
                }

            label_21:
                if(v0 != null) {
                    v0.wakeup();
                }

                goto label_23;
            }
            catch(Throwable v0_1) {
                this.poolLock.unlock();
                throw v0_1;
            }
        }
        else {
            goto label_26;
        }

        goto label_21;
    label_23:
        this.poolLock.unlock();
    }

    public PoolEntryRequest requestPoolEntry(HttpRoute arg3, Object arg4) {
        return new ConnPoolByRoute$1(this, new WaitingThreadAborter(), arg3, arg4);
    }

    public void setMaxTotalConnections(int arg3) {
        this.poolLock.lock();
        try {
            this.maxTotalConnections = arg3;
        }
        catch(Throwable v0) {
            this.poolLock.unlock();
            throw v0;
        }

        this.poolLock.unlock();
    }

    public void shutdown() {
        Object v0_1;
        this.poolLock.lock();
        try {
            if(this.shutdown) {
            }
            else {
                goto label_8;
            }
        }
        catch(Throwable v0) {
            goto label_19;
        }

        this.poolLock.unlock();
        return;
        try {
        label_8:
            this.shutdown = true;
            Iterator v1 = this.leasedConnections.iterator();
            while(v1.hasNext()) {
                v0_1 = v1.next();
                v1.remove();
                this.closeConnection(((BasicPoolEntry)v0_1));
            }

            v1 = this.freeConnections.iterator();
            while(v1.hasNext()) {
                v0_1 = v1.next();
                v1.remove();
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Closing connection [" + ((BasicPoolEntry)v0_1).getPlannedRoute() + "][" + ((BasicPoolEntry)v0_1).getState() + "]");
                }

                this.closeConnection(((BasicPoolEntry)v0_1));
            }

            v1 = this.waitingThreads.iterator();
            while(v1.hasNext()) {
                v0_1 = v1.next();
                v1.remove();
                ((WaitingThread)v0_1).wakeup();
            }

            this.routeToPool.clear();
        }
        catch(Throwable v0) {
            goto label_19;
        }

        this.poolLock.unlock();
        return;
    label_19:
        this.poolLock.unlock();
        throw v0;
    }
}

