// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.conn.tsccm;

import java.io.IOException;
import java.util.concurrent.TimeUnit;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ClientConnectionOperator;
import org.apache.http.conn.ClientConnectionRequest;
import org.apache.http.conn.ManagedClientConnection;
import org.apache.http.conn.params.ConnPerRouteBean;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.impl.conn.AbstractPoolEntry;
import org.apache.http.impl.conn.DefaultClientConnectionOperator;
import org.apache.http.impl.conn.SchemeRegistryFactory;
import org.apache.http.params.HttpParams;
import org.apache.http.util.Args;
import org.apache.http.util.Asserts;

@Deprecated @ThreadSafe public class ThreadSafeClientConnManager implements ClientConnectionManager {
    protected final ClientConnectionOperator connOperator;
    protected final ConnPerRouteBean connPerRoute;
    protected final AbstractConnPool connectionPool;
    private final Log log;
    protected final ConnPoolByRoute pool;
    protected final SchemeRegistry schemeRegistry;

    public ThreadSafeClientConnManager() {
        this(SchemeRegistryFactory.createDefault());
    }

    public ThreadSafeClientConnManager(SchemeRegistry arg4) {
        this(arg4, -1, TimeUnit.MILLISECONDS);
    }

    public ThreadSafeClientConnManager(SchemeRegistry arg7, long arg8, TimeUnit arg10) {
        this(arg7, arg8, arg10, new ConnPerRouteBean());
    }

    public ThreadSafeClientConnManager(SchemeRegistry arg2, long arg3, TimeUnit arg5, ConnPerRouteBean arg6) {
        super();
        Args.notNull(arg2, "Scheme registry");
        this.log = LogFactory.getLog(this.getClass());
        this.schemeRegistry = arg2;
        this.connPerRoute = arg6;
        this.connOperator = this.createConnectionOperator(arg2);
        this.pool = this.createConnectionPool(arg3, arg5);
        this.connectionPool = this.pool;
    }

    @Deprecated public ThreadSafeClientConnManager(HttpParams arg2, SchemeRegistry arg3) {
        super();
        Args.notNull(arg3, "Scheme registry");
        this.log = LogFactory.getLog(this.getClass());
        this.schemeRegistry = arg3;
        this.connPerRoute = new ConnPerRouteBean();
        this.connOperator = this.createConnectionOperator(arg3);
        this.pool = this.createConnectionPool(arg2);
        this.connectionPool = this.pool;
    }

    static Log access$000(ThreadSafeClientConnManager arg1) {
        return arg1.log;
    }

    public void closeExpiredConnections() {
        this.log.debug("Closing expired connections");
        this.pool.closeExpiredConnections();
    }

    public void closeIdleConnections(long arg4, TimeUnit arg6) {
        if(this.log.isDebugEnabled()) {
            this.log.debug("Closing connections idle longer than " + arg4 + " " + arg6);
        }

        this.pool.closeIdleConnections(arg4, arg6);
    }

    protected ClientConnectionOperator createConnectionOperator(SchemeRegistry arg2) {
        return new DefaultClientConnectionOperator(arg2);
    }

    protected ConnPoolByRoute createConnectionPool(long arg8, TimeUnit arg10) {
        return new ConnPoolByRoute(this.connOperator, this.connPerRoute, 20, arg8, arg10);
    }

    @Deprecated protected AbstractConnPool createConnectionPool(HttpParams arg3) {
        return new ConnPoolByRoute(this.connOperator, arg3);
    }

    protected void finalize() {
        try {
            this.shutdown();
            super.finalize();
            return;
        }
        catch(Throwable v0) {
            super.finalize();
            throw v0;
        }
    }

    public int getConnectionsInPool() {
        return this.pool.getConnectionsInPool();
    }

    public int getConnectionsInPool(HttpRoute arg2) {
        return this.pool.getConnectionsInPool(arg2);
    }

    public int getDefaultMaxPerRoute() {
        return this.connPerRoute.getDefaultMaxPerRoute();
    }

    public int getMaxForRoute(HttpRoute arg2) {
        return this.connPerRoute.getMaxForRoute(arg2);
    }

    public int getMaxTotal() {
        return this.pool.getMaxTotalConnections();
    }

    public SchemeRegistry getSchemeRegistry() {
        return this.schemeRegistry;
    }

    public void releaseConnection(ManagedClientConnection arg8, long arg9, TimeUnit arg11) {
        AbstractPoolEntry v1;
        Args.check(arg8 instanceof BasicPooledConnAdapter, "Connection class mismatch, connection not obtained from this manager");
        if(((BasicPooledConnAdapter)arg8).getPoolEntry() != null) {
            boolean v0 = ((BasicPooledConnAdapter)arg8).getManager() == this ? true : false;
            Asserts.check(v0, "Connection not obtained from this manager");
        }

        __monitor_enter(arg8);
        try {
            v1 = ((BasicPooledConnAdapter)arg8).getPoolEntry();
            if(v1 != null) {
                goto label_17;
            }

            __monitor_exit(arg8);
            return;
        }
        catch(Throwable v0_1) {
            goto label_38;
        }

        try {
        label_17:
            if((((BasicPooledConnAdapter)arg8).isOpen()) && !((BasicPooledConnAdapter)arg8).isMarkedReusable()) {
                ((BasicPooledConnAdapter)arg8).shutdown();
            }

            goto label_22;
        }
        catch(Throwable v0_1) {
        }
        catch(IOException v0_2) {
            try {
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Exception shutting down released connection.", ((Throwable)v0_2));
                }
            }
            catch(Throwable v0_1) {
                goto label_70;
            }

            try {
                boolean v2 = ((BasicPooledConnAdapter)arg8).isMarkedReusable();
                if(this.log.isDebugEnabled()) {
                    if(v2) {
                        this.log.debug("Released connection is reusable.");
                    }
                    else {
                        this.log.debug("Released connection is not reusable.");
                    }
                }

                ((BasicPooledConnAdapter)arg8).detach();
                this.pool.freeEntry(((BasicPoolEntry)v1), v2, arg9, arg11);
                goto label_35;
            label_70:
                Throwable v6 = v0_1;
                v2 = ((BasicPooledConnAdapter)arg8).isMarkedReusable();
                if(this.log.isDebugEnabled()) {
                    if(v2) {
                        this.log.debug("Released connection is reusable.");
                    }
                    else {
                        this.log.debug("Released connection is not reusable.");
                    }
                }

                ((BasicPooledConnAdapter)arg8).detach();
                this.pool.freeEntry(((BasicPoolEntry)v1), v2, arg9, arg11);
                throw v6;
            label_22:
                v2 = ((BasicPooledConnAdapter)arg8).isMarkedReusable();
                if(this.log.isDebugEnabled()) {
                    if(v2) {
                        this.log.debug("Released connection is reusable.");
                    }
                    else {
                        this.log.debug("Released connection is not reusable.");
                    }
                }

                ((BasicPooledConnAdapter)arg8).detach();
                this.pool.freeEntry(((BasicPoolEntry)v1), v2, arg9, arg11);
            label_35:
                __monitor_exit(arg8);
                return;
            label_38:
                __monitor_exit(arg8);
            }
            catch(Throwable v0_1) {
                goto label_38;
            }
        }

        throw v0_1;
    }

    public ClientConnectionRequest requestConnection(HttpRoute arg3, Object arg4) {
        return new ThreadSafeClientConnManager$1(this, this.pool.requestPoolEntry(arg3, arg4), arg3);
    }

    public void setDefaultMaxPerRoute(int arg2) {
        this.connPerRoute.setDefaultMaxPerRoute(arg2);
    }

    public void setMaxForRoute(HttpRoute arg2, int arg3) {
        this.connPerRoute.setMaxForRoute(arg2, arg3);
    }

    public void setMaxTotal(int arg2) {
        this.pool.setMaxTotalConnections(arg2);
    }

    public void shutdown() {
        this.log.debug("Shutting down");
        this.pool.shutdown();
    }
}

