// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieSpec;
import org.apache.http.util.Args;

@NotThreadSafe public abstract class AbstractCookieSpec implements CookieSpec {
    private final Map attribHandlerMap;

    public AbstractCookieSpec() {
        super();
        this.attribHandlerMap = new HashMap(10);
    }

    protected CookieAttributeHandler findAttribHandler(String arg2) {
        return this.attribHandlerMap.get(arg2);
    }

    protected CookieAttributeHandler getAttribHandler(String arg4) {
        CookieAttributeHandler v0 = this.findAttribHandler(arg4);
        if(v0 == null) {
            throw new IllegalStateException("Handler not registered for " + arg4 + " attribute.");
        }

        return v0;
    }

    protected Collection getAttribHandlers() {
        return this.attribHandlerMap.values();
    }

    public void registerAttribHandler(String arg2, CookieAttributeHandler arg3) {
        Args.notNull(arg2, "Attribute name");
        Args.notNull(arg3, "Attribute handler");
        this.attribHandlerMap.put(arg2, arg3);
    }
}

