// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import org.apache.http.annotation.Immutable;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.util.Args;

@Immutable public class BasicDomainHandler implements CookieAttributeHandler {
    public BasicDomainHandler() {
        super();
    }

    public boolean match(Cookie arg7, CookieOrigin arg8) {
        boolean v1 = false;
        Args.notNull(arg7, "Cookie");
        Args.notNull(arg8, "Cookie origin");
        String v3 = arg8.getHost();
        String v0 = arg7.getDomain();
        if(v0 != null) {
            if(v3.equals(v0)) {
                v1 = true;
            }
            else {
                if(!v0.startsWith(".")) {
                    v0 = '.' + v0;
                }

                boolean v0_1 = (v3.endsWith(v0)) || (v3.equals(v0.substring(1))) ? true : false;
                v1 = v0_1;
            }
        }

        return v1;
    }

    public void parse(SetCookie arg3, String arg4) {
        Args.notNull(arg3, "Cookie");
        if(arg4 == null) {
            throw new MalformedCookieException("Missing value for domain attribute");
        }

        if(arg4.trim().length() == 0) {
            throw new MalformedCookieException("Blank value for domain attribute");
        }

        arg3.setDomain(arg4);
    }

    public void validate(Cookie arg6, CookieOrigin arg7) {
        Args.notNull(arg6, "Cookie");
        Args.notNull(arg7, "Cookie origin");
        String v1 = arg7.getHost();
        String v0 = arg6.getDomain();
        if(v0 == null) {
            throw new CookieRestrictionViolationException("Cookie domain may not be null");
        }

        if(!v1.contains(".")) {
            if(v1.equals(v0)) {
                return;
            }

            throw new CookieRestrictionViolationException("Illegal domain attribute \"" + v0 + "\". Domain of origin: \"" + v1 + "\"");
        }
        else if(!v1.endsWith(v0)) {
            if(v0.startsWith(".")) {
                v0 = v0.substring(1, v0.length());
            }

            if(v1.equals(v0)) {
                return;
            }

            throw new CookieRestrictionViolationException("Illegal domain attribute \"" + v0 + "\". Domain of origin: \"" + v1 + "\"");
        }
    }
}

