// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.Iterator;
import java.util.List;
import org.apache.http.FormattedHeader;
import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieSpec;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie2;
import org.apache.http.message.ParserCursor;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class BestMatchSpec implements CookieSpec {
    private BrowserCompatSpec compat;
    private final String[] datepatterns;
    private RFC2109Spec obsoleteStrict;
    private final boolean oneHeader;
    private RFC2965Spec strict;

    public BestMatchSpec() {
        this(null, false);
    }

    public BestMatchSpec(String[] arg2, boolean arg3) {
        Object v0_1;
        super();
        if(arg2 == null) {
            String[] v0 = null;
        }
        else {
            v0_1 = arg2.clone();
        }

        this.datepatterns = ((String[])v0_1);
        this.oneHeader = arg3;
    }

    public List formatCookies(List arg6) {
        List v0_2;
        Args.notNull(arg6, "List of cookies");
        Iterator v3 = arg6.iterator();
        int v2 = 2147483647;
        int v1 = 1;
        while(v3.hasNext()) {
            Object v0 = v3.next();
            if(!(v0 instanceof SetCookie2)) {
                v1 = 0;
            }

            int v0_1 = ((Cookie)v0).getVersion() < v2 ? ((Cookie)v0).getVersion() : v2;
            v2 = v0_1;
        }

        if(v2 <= 0) {
            v0_2 = this.getCompat().formatCookies(arg6);
        }
        else if(v1 != 0) {
            v0_2 = this.getStrict().formatCookies(arg6);
        }
        else {
            v0_2 = this.getObsoleteStrict().formatCookies(arg6);
        }

        return v0_2;
    }

    private BrowserCompatSpec getCompat() {
        if(this.compat == null) {
            this.compat = new BrowserCompatSpec(this.datepatterns);
        }

        return this.compat;
    }

    private RFC2109Spec getObsoleteStrict() {
        if(this.obsoleteStrict == null) {
            this.obsoleteStrict = new RFC2109Spec(this.datepatterns, this.oneHeader);
        }

        return this.obsoleteStrict;
    }

    private RFC2965Spec getStrict() {
        if(this.strict == null) {
            this.strict = new RFC2965Spec(this.datepatterns, this.oneHeader);
        }

        return this.strict;
    }

    public int getVersion() {
        return this.getStrict().getVersion();
    }

    public Header getVersionHeader() {
        return this.getStrict().getVersionHeader();
    }

    public boolean match(Cookie arg2, CookieOrigin arg3) {
        boolean v0;
        Args.notNull(arg2, "Cookie");
        Args.notNull(arg3, "Cookie origin");
        if(arg2.getVersion() <= 0) {
            v0 = this.getCompat().match(arg2, arg3);
        }
        else if((arg2 instanceof SetCookie2)) {
            v0 = this.getStrict().match(arg2, arg3);
        }
        else {
            v0 = this.getObsoleteStrict().match(arg2, arg3);
        }

        return v0;
    }

    public List parse(Header arg10, CookieOrigin arg11) {
        List v0_1;
        ParserCursor v0_2;
        CharArrayBuffer v2_1;
        Args.notNull(arg10, "Header");
        Args.notNull(arg11, "Cookie origin");
        HeaderElement[] v5 = arg10.getElements();
        int v6 = v5.length;
        int v3 = 0;
        int v2 = 0;
        int v0 = 0;
        while(v3 < v6) {
            HeaderElement v7 = v5[v3];
            if(v7.getParameterByName("version") != null) {
                v0 = 1;
            }

            if(v7.getParameterByName("expires") != null) {
                v2 = 1;
            }

            ++v3;
        }

        if(v2 != 0 || v0 == 0) {
            NetscapeDraftHeaderParser v3_1 = NetscapeDraftHeaderParser.DEFAULT;
            if((arg10 instanceof FormattedHeader)) {
                v2_1 = arg10.getBuffer();
                v0_2 = new ParserCursor(((FormattedHeader)arg10).getValuePos(), v2_1.length());
            }
            else {
                String v0_3 = arg10.getValue();
                if(v0_3 == null) {
                    throw new MalformedCookieException("Header value is null");
                }
                else {
                    v2_1 = new CharArrayBuffer(v0_3.length());
                    v2_1.append(v0_3);
                    v0_2 = new ParserCursor(0, v2_1.length());
                }
            }

            v0_1 = this.getCompat().parse(new HeaderElement[]{v3_1.parseHeader(v2_1, v0_2)}, arg11);
        }
        else if("Set-Cookie2".equals(arg10.getName())) {
            v0_1 = this.getStrict().parse(v5, arg11);
        }
        else {
            v0_1 = this.getObsoleteStrict().parse(v5, arg11);
        }

        return v0_1;
    }

    public String toString() {
        return "best-match";
    }

    public void validate(Cookie arg2, CookieOrigin arg3) {
        Args.notNull(arg2, "Cookie");
        Args.notNull(arg3, "Cookie origin");
        if(arg2.getVersion() <= 0) {
            this.getCompat().validate(arg2, arg3);
        }
        else if((arg2 instanceof SetCookie2)) {
            this.getStrict().validate(arg2, arg3);
        }
        else {
            this.getObsoleteStrict().validate(arg2, arg3);
        }
    }
}

