// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import org.apache.http.FormattedHeader;
import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.message.BasicHeaderElement;
import org.apache.http.message.BasicHeaderValueFormatter;
import org.apache.http.message.BufferedHeader;
import org.apache.http.message.ParserCursor;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class BrowserCompatSpec extends CookieSpecBase {
    private static final String[] DEFAULT_DATE_PATTERNS;
    private final String[] datepatterns;

    static {
        BrowserCompatSpec.DEFAULT_DATE_PATTERNS = new String[]{"EEE, dd MMM yyyy HH:mm:ss zzz", "EEE, dd-MMM-yy HH:mm:ss zzz", "EEE MMM d HH:mm:ss yyyy", "EEE, dd-MMM-yyyy HH:mm:ss z", "EEE, dd-MMM-yyyy HH-mm-ss z", "EEE, dd MMM yy HH:mm:ss z", "EEE dd-MMM-yyyy HH:mm:ss z", "EEE dd MMM yyyy HH:mm:ss z", "EEE dd-MMM-yyyy HH-mm-ss z", "EEE dd-MMM-yy HH:mm:ss z", "EEE dd MMM yy HH:mm:ss z", "EEE,dd-MMM-yy HH:mm:ss z", "EEE,dd-MMM-yyyy HH:mm:ss z", "EEE, dd-MM-yyyy HH:mm:ss z"};
    }

    public BrowserCompatSpec(String[] arg2) {
        this(arg2, BrowserCompatSpecFactory$SecurityLevel.SECURITYLEVEL_DEFAULT);
    }

    public BrowserCompatSpec() {
        this(null, BrowserCompatSpecFactory$SecurityLevel.SECURITYLEVEL_DEFAULT);
    }

    public BrowserCompatSpec(String[] arg4, BrowserCompatSpecFactory$SecurityLevel arg5) {
        super();
        this.datepatterns = arg4 != null ? arg4.clone() : BrowserCompatSpec.DEFAULT_DATE_PATTERNS;
        switch(BrowserCompatSpec$2.$SwitchMap$org$apache$http$impl$cookie$BrowserCompatSpecFactory$SecurityLevel[arg5.ordinal()]) {
            case 1: {
                goto label_15;
            }
            case 2: {
                goto label_45;
            }
        }

        throw new RuntimeException("Unknown security level");
    label_45:
        this.registerAttribHandler("path", new BrowserCompatSpec$1(this));
        goto label_19;
    label_15:
        this.registerAttribHandler("path", new BasicPathHandler());
    label_19:
        this.registerAttribHandler("domain", new BasicDomainHandler());
        this.registerAttribHandler("max-age", new BasicMaxAgeHandler());
        this.registerAttribHandler("secure", new BasicSecureHandler());
        this.registerAttribHandler("comment", new BasicCommentHandler());
        this.registerAttribHandler("expires", new BasicExpiresHandler(this.datepatterns));
        this.registerAttribHandler("version", new BrowserCompatVersionAttributeHandler());
    }

    public List formatCookies(List arg8) {
        Args.notEmpty(((Collection)arg8), "List of cookies");
        CharArrayBuffer v3 = new CharArrayBuffer(arg8.size() * 20);
        v3.append("Cookie");
        v3.append(": ");
        int v1;
        for(v1 = 0; v1 < arg8.size(); ++v1) {
            Object v0 = arg8.get(v1);
            if(v1 > 0) {
                v3.append("; ");
            }

            String v4 = ((Cookie)v0).getName();
            String v5 = ((Cookie)v0).getValue();
            if(((Cookie)v0).getVersion() <= 0 || (BrowserCompatSpec.isQuoteEnclosed(v5))) {
                v3.append(v4);
                v3.append("=");
                if(v5 != null) {
                    v3.append(v5);
                }
            }
            else {
                BasicHeaderValueFormatter.INSTANCE.formatHeaderElement(v3, new BasicHeaderElement(v4, v5), false);
            }
        }

        ArrayList v0_1 = new ArrayList(1);
        ((List)v0_1).add(new BufferedHeader(v3));
        return ((List)v0_1);
    }

    public int getVersion() {
        return 0;
    }

    public Header getVersionHeader() {
        return null;
    }

    private static boolean isQuoteEnclosed(String arg1) {
        boolean v0 = arg1 == null || !arg1.startsWith("\"") || !arg1.endsWith("\"") ? false : true;
        return v0;
    }

    public List parse(Header arg10, CookieOrigin arg11) {
        HeaderElement[] v0_1;
        ParserCursor v0_2;
        CharArrayBuffer v2_1;
        Args.notNull(arg10, "Header");
        Args.notNull(arg11, "Cookie origin");
        if(!arg10.getName().equalsIgnoreCase("Set-Cookie")) {
            throw new MalformedCookieException("Unrecognized cookie header \'" + arg10.toString() + "\'");
        }

        HeaderElement[] v3 = arg10.getElements();
        int v6 = v3.length;
        int v4 = 0;
        int v2 = 0;
        int v0 = 0;
        while(v4 < v6) {
            HeaderElement v7 = v3[v4];
            if(v7.getParameterByName("version") != null) {
                v0 = 1;
            }

            if(v7.getParameterByName("expires") != null) {
                v2 = 1;
            }

            ++v4;
        }

        if(v2 != 0 || v0 == 0) {
            NetscapeDraftHeaderParser v3_1 = NetscapeDraftHeaderParser.DEFAULT;
            if((arg10 instanceof FormattedHeader)) {
                v2_1 = arg10.getBuffer();
                v0_2 = new ParserCursor(((FormattedHeader)arg10).getValuePos(), v2_1.length());
            }
            else {
                String v0_3 = arg10.getValue();
                if(v0_3 == null) {
                    throw new MalformedCookieException("Header value is null");
                }
                else {
                    v2_1 = new CharArrayBuffer(v0_3.length());
                    v2_1.append(v0_3);
                    v0_2 = new ParserCursor(0, v2_1.length());
                }
            }

            v0_1 = new HeaderElement[]{v3_1.parseHeader(v2_1, v0_2)};
        }
        else {
            v0_1 = v3;
        }

        return this.parse(v0_1, arg11);
    }

    public String toString() {
        return "compatibility";
    }
}

