// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import org.apache.http.FormattedHeader;
import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.message.BufferedHeader;
import org.apache.http.message.ParserCursor;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class NetscapeDraftSpec extends CookieSpecBase {
    protected static final String EXPIRES_PATTERN = "EEE, dd-MMM-yy HH:mm:ss z";
    private final String[] datepatterns;

    public NetscapeDraftSpec() {
        this(null);
    }

    public NetscapeDraftSpec(String[] arg4) {
        super();
        this.datepatterns = arg4 != null ? arg4.clone() : new String[]{"EEE, dd-MMM-yy HH:mm:ss z"};
        this.registerAttribHandler("path", new BasicPathHandler());
        this.registerAttribHandler("domain", new NetscapeDomainHandler());
        this.registerAttribHandler("max-age", new BasicMaxAgeHandler());
        this.registerAttribHandler("secure", new BasicSecureHandler());
        this.registerAttribHandler("comment", new BasicCommentHandler());
        this.registerAttribHandler("expires", new BasicExpiresHandler(this.datepatterns));
    }

    public List formatCookies(List arg5) {
        Args.notEmpty(((Collection)arg5), "List of cookies");
        CharArrayBuffer v2 = new CharArrayBuffer(arg5.size() * 20);
        v2.append("Cookie");
        v2.append(": ");
        int v1;
        for(v1 = 0; v1 < arg5.size(); ++v1) {
            Object v0 = arg5.get(v1);
            if(v1 > 0) {
                v2.append("; ");
            }

            v2.append(((Cookie)v0).getName());
            String v0_1 = ((Cookie)v0).getValue();
            if(v0_1 != null) {
                v2.append("=");
                v2.append(v0_1);
            }
        }

        ArrayList v0_2 = new ArrayList(1);
        ((List)v0_2).add(new BufferedHeader(v2));
        return ((List)v0_2);
    }

    public int getVersion() {
        return 0;
    }

    public Header getVersionHeader() {
        return null;
    }

    public List parse(Header arg7, CookieOrigin arg8) {
        ParserCursor v0;
        CharArrayBuffer v1;
        Args.notNull(arg7, "Header");
        Args.notNull(arg8, "Cookie origin");
        if(!arg7.getName().equalsIgnoreCase("Set-Cookie")) {
            throw new MalformedCookieException("Unrecognized cookie header \'" + arg7.toString() + "\'");
        }

        NetscapeDraftHeaderParser v2 = NetscapeDraftHeaderParser.DEFAULT;
        if((arg7 instanceof FormattedHeader)) {
            v1 = arg7.getBuffer();
            v0 = new ParserCursor(((FormattedHeader)arg7).getValuePos(), v1.length());
        }
        else {
            String v0_1 = arg7.getValue();
            if(v0_1 == null) {
                throw new MalformedCookieException("Header value is null");
            }
            else {
                v1 = new CharArrayBuffer(v0_1.length());
                v1.append(v0_1);
                v0 = new ParserCursor(0, v1.length());
            }
        }

        return this.parse(new HeaderElement[]{v2.parseHeader(v1, v0)}, arg8);
    }

    public String toString() {
        return "netscape";
    }
}

