// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.Locale;
import org.apache.http.annotation.Immutable;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.util.Args;

@Immutable public class RFC2109DomainHandler implements CookieAttributeHandler {
    public RFC2109DomainHandler() {
        super();
    }

    public boolean match(Cookie arg5, CookieOrigin arg6) {
        boolean v0 = false;
        Args.notNull(arg5, "Cookie");
        Args.notNull(arg6, "Cookie origin");
        String v1 = arg6.getHost();
        String v2 = arg5.getDomain();
        if(v2 != null) {
            if(!v1.equals(v2)) {
                if(!v2.startsWith(".")) {
                }
                else if(v1.endsWith(v2)) {
                    goto label_16;
                }

                return v0;
            }

        label_16:
            v0 = true;
        }

        return v0;
    }

    public void parse(SetCookie arg3, String arg4) {
        Args.notNull(arg3, "Cookie");
        if(arg4 == null) {
            throw new MalformedCookieException("Missing value for domain attribute");
        }

        if(arg4.trim().length() == 0) {
            throw new MalformedCookieException("Blank value for domain attribute");
        }

        arg3.setDomain(arg4);
    }

    public void validate(Cookie arg8, CookieOrigin arg9) {
        int v6 = -1;
        int v5 = 46;
        Args.notNull(arg8, "Cookie");
        Args.notNull(arg9, "Cookie origin");
        String v0 = arg9.getHost();
        String v1 = arg8.getDomain();
        if(v1 == null) {
            throw new CookieRestrictionViolationException("Cookie domain may not be null");
        }

        if(!v1.equals(v0)) {
            if(v1.indexOf(v5) == v6) {
                throw new CookieRestrictionViolationException("Domain attribute \"" + v1 + "\" does not match the host \"" + v0 + "\"");
            }
            else if(!v1.startsWith(".")) {
                throw new CookieRestrictionViolationException("Domain attribute \"" + v1 + "\" violates RFC 2109: domain must start with a dot");
            }
            else {
                int v2 = v1.indexOf(v5, 1);
                if(v2 >= 0 && v2 != v1.length() - 1) {
                    v0 = v0.toLowerCase(Locale.ENGLISH);
                    if(!v0.endsWith(v1)) {
                        throw new CookieRestrictionViolationException("Illegal domain attribute \"" + v1 + "\". Domain of origin: \"" + v0 + "\"");
                    }
                    else if(v0.substring(0, v0.length() - v1.length()).indexOf(v5) != v6) {
                        throw new CookieRestrictionViolationException("Domain attribute \"" + v1 + "\" violates RFC 2109: host minus domain may not contain any dots");
                    }
                    else {
                        return;
                    }
                }

                throw new CookieRestrictionViolationException("Domain attribute \"" + v1 + "\" violates RFC 2109: domain must contain an embedded dot");
            }
        }
    }
}

