// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import org.apache.http.Header;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.cookie.ClientCookie;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookiePathComparator;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.message.BufferedHeader;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class RFC2109Spec extends CookieSpecBase {
    private static final String[] DATE_PATTERNS;
    private static final CookiePathComparator PATH_COMPARATOR;
    private final String[] datepatterns;
    private final boolean oneHeader;

    static {
        RFC2109Spec.PATH_COMPARATOR = new CookiePathComparator();
        RFC2109Spec.DATE_PATTERNS = new String[]{"EEE, dd MMM yyyy HH:mm:ss zzz", "EEE, dd-MMM-yy HH:mm:ss zzz", "EEE MMM d HH:mm:ss yyyy"};
    }

    public RFC2109Spec(String[] arg4, boolean arg5) {
        super();
        this.datepatterns = arg4 != null ? arg4.clone() : RFC2109Spec.DATE_PATTERNS;
        this.oneHeader = arg5;
        this.registerAttribHandler("version", new RFC2109VersionHandler());
        this.registerAttribHandler("path", new BasicPathHandler());
        this.registerAttribHandler("domain", new RFC2109DomainHandler());
        this.registerAttribHandler("max-age", new BasicMaxAgeHandler());
        this.registerAttribHandler("secure", new BasicSecureHandler());
        this.registerAttribHandler("comment", new BasicCommentHandler());
        this.registerAttribHandler("expires", new BasicExpiresHandler(this.datepatterns));
    }

    public RFC2109Spec() {
        this(null, false);
    }

    private List doFormatManyHeaders(List arg7) {
        ArrayList v1 = new ArrayList(arg7.size());
        Iterator v2 = arg7.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            int v3 = ((Cookie)v0).getVersion();
            CharArrayBuffer v4 = new CharArrayBuffer(40);
            v4.append("Cookie: ");
            v4.append("$Version=");
            v4.append(Integer.toString(v3));
            v4.append("; ");
            this.formatCookieAsVer(v4, ((Cookie)v0), v3);
            ((List)v1).add(new BufferedHeader(v4));
        }

        return ((List)v1);
    }

    private List doFormatOneHeader(List arg6) {
        Object v0;
        Iterator v2 = arg6.iterator();
        int v1;
        for(v1 = 2147483647; v2.hasNext(); v1 = v0_1) {
            v0 = v2.next();
            int v0_1 = ((Cookie)v0).getVersion() < v1 ? ((Cookie)v0).getVersion() : v1;
        }

        CharArrayBuffer v2_1 = new CharArrayBuffer(arg6.size() * 40);
        v2_1.append("Cookie");
        v2_1.append(": ");
        v2_1.append("$Version=");
        v2_1.append(Integer.toString(v1));
        Iterator v3 = arg6.iterator();
        while(v3.hasNext()) {
            v0 = v3.next();
            v2_1.append("; ");
            this.formatCookieAsVer(v2_1, ((Cookie)v0), v1);
        }

        ArrayList v0_2 = new ArrayList(1);
        ((List)v0_2).add(new BufferedHeader(v2_1));
        return ((List)v0_2);
    }

    protected void formatCookieAsVer(CharArrayBuffer arg3, Cookie arg4, int arg5) {
        this.formatParamAsVer(arg3, arg4.getName(), arg4.getValue(), arg5);
        if(arg4.getPath() != null && ((arg4 instanceof ClientCookie)) && (arg4.containsAttribute("path"))) {
            arg3.append("; ");
            this.formatParamAsVer(arg3, "$Path", arg4.getPath(), arg5);
        }

        if(arg4.getDomain() != null && ((arg4 instanceof ClientCookie)) && (arg4.containsAttribute("domain"))) {
            arg3.append("; ");
            this.formatParamAsVer(arg3, "$Domain", arg4.getDomain(), arg5);
        }
    }

    public List formatCookies(List arg3) {
        ArrayList v3;
        Args.notEmpty(((Collection)arg3), "List of cookies");
        if(arg3.size() > 1) {
            ArrayList v0 = new ArrayList(((Collection)arg3));
            Collections.sort(((List)v0), RFC2109Spec.PATH_COMPARATOR);
            v3 = v0;
        }

        List v0_1 = this.oneHeader ? this.doFormatOneHeader(((List)v3)) : this.doFormatManyHeaders(((List)v3));
        return v0_1;
    }

    protected void formatParamAsVer(CharArrayBuffer arg3, String arg4, String arg5, int arg6) {
        char v1 = '\"';
        arg3.append(arg4);
        arg3.append("=");
        if(arg5 != null) {
            if(arg6 > 0) {
                arg3.append(v1);
                arg3.append(arg5);
                arg3.append(v1);
            }
            else {
                arg3.append(arg5);
            }
        }
    }

    public int getVersion() {
        return 1;
    }

    public Header getVersionHeader() {
        return null;
    }

    public List parse(Header arg4, CookieOrigin arg5) {
        Args.notNull(arg4, "Header");
        Args.notNull(arg5, "Cookie origin");
        if(!arg4.getName().equalsIgnoreCase("Set-Cookie")) {
            throw new MalformedCookieException("Unrecognized cookie header \'" + arg4.toString() + "\'");
        }

        return this.parse(arg4.getElements(), arg5);
    }

    public String toString() {
        return "rfc2109";
    }

    public void validate(Cookie arg4, CookieOrigin arg5) {
        Args.notNull(arg4, "Cookie");
        String v0 = arg4.getName();
        if(v0.indexOf(32) != -1) {
            throw new CookieRestrictionViolationException("Cookie name may not contain blanks");
        }

        if(v0.startsWith("$")) {
            throw new CookieRestrictionViolationException("Cookie name may not start with $");
        }

        super.validate(arg4, arg5);
    }
}

