// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import org.apache.http.annotation.Immutable;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.util.Args;

@Immutable public class RFC2109VersionHandler extends AbstractCookieAttributeHandler {
    public RFC2109VersionHandler() {
        super();
    }

    public void parse(SetCookie arg5, String arg6) {
        Args.notNull(arg5, "Cookie");
        if(arg6 == null) {
            throw new MalformedCookieException("Missing value for version attribute");
        }

        if(arg6.trim().length() == 0) {
            throw new MalformedCookieException("Blank value for version attribute");
        }

        try {
            arg5.setVersion(Integer.parseInt(arg6));
            return;
        }
        catch(NumberFormatException v0) {
            throw new MalformedCookieException("Invalid version: " + v0.getMessage());
        }
    }

    public void validate(Cookie arg3, CookieOrigin arg4) {
        Args.notNull(arg3, "Cookie");
        if(arg3.getVersion() < 0) {
            throw new CookieRestrictionViolationException("Cookie version may not be negative");
        }
    }
}

