// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.Locale;
import org.apache.http.annotation.Immutable;
import org.apache.http.cookie.ClientCookie;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.util.Args;

@Immutable public class RFC2965DomainAttributeHandler implements CookieAttributeHandler {
    public RFC2965DomainAttributeHandler() {
        super();
    }

    public boolean domainMatch(String arg2, String arg3) {
        boolean v0;
        if(!arg2.equals(arg3)) {
            if((arg3.startsWith(".")) && (arg2.endsWith(arg3))) {
                goto label_7;
            }

            v0 = false;
        }
        else {
        label_7:
            v0 = true;
        }

        return v0;
    }

    public boolean match(Cookie arg5, CookieOrigin arg6) {
        boolean v0 = false;
        Args.notNull(arg5, "Cookie");
        Args.notNull(arg6, "Cookie origin");
        String v1 = arg6.getHost().toLowerCase(Locale.ENGLISH);
        String v2 = arg5.getDomain();
        if((this.domainMatch(v1, v2)) && v1.substring(0, v1.length() - v2.length()).indexOf(46) == -1) {
            v0 = true;
        }

        return v0;
    }

    public void parse(SetCookie arg4, String arg5) {
        Args.notNull(arg4, "Cookie");
        if(arg5 == null) {
            throw new MalformedCookieException("Missing value for domain attribute");
        }

        if(arg5.trim().length() == 0) {
            throw new MalformedCookieException("Blank value for domain attribute");
        }

        String v0 = arg5.toLowerCase(Locale.ENGLISH);
        if(!arg5.startsWith(".")) {
            v0 = '.' + v0;
        }

        arg4.setDomain(v0);
    }

    public void validate(Cookie arg6, CookieOrigin arg7) {
        int v4 = 46;
        Args.notNull(arg6, "Cookie");
        Args.notNull(arg7, "Cookie origin");
        String v1 = arg7.getHost().toLowerCase(Locale.ENGLISH);
        if(arg6.getDomain() == null) {
            throw new CookieRestrictionViolationException("Invalid cookie state: domain not specified");
        }

        String v2 = arg6.getDomain().toLowerCase(Locale.ENGLISH);
        if(!(arg6 instanceof ClientCookie) || !arg6.containsAttribute("domain")) {
            if(arg6.getDomain().equals(v1)) {
                return;
            }

            throw new CookieRestrictionViolationException("Illegal domain attribute: \"" + arg6.getDomain() + "\"." + "Domain of origin: \"" + v1 + "\"");
        }
        else if(!v2.startsWith(".")) {
            throw new CookieRestrictionViolationException("Domain attribute \"" + arg6.getDomain() + "\" violates RFC 2109: domain must start with a dot");
        }
        else {
            int v0 = v2.indexOf(v4, 1);
            if((v0 < 0 || v0 == v2.length() - 1) && !v2.equals(".local")) {
                throw new CookieRestrictionViolationException("Domain attribute \"" + arg6.getDomain() + "\" violates RFC 2965: the value contains no embedded dots " + "and the value is not .local");
            }

            if(!this.domainMatch(v1, v2)) {
                throw new CookieRestrictionViolationException("Domain attribute \"" + arg6.getDomain() + "\" violates RFC 2965: effective host name does not " + "domain-match domain attribute.");
            }

            if(v1.substring(0, v1.length() - v2.length()).indexOf(v4) == -1) {
                return;
            }

            throw new CookieRestrictionViolationException("Domain attribute \"" + arg6.getDomain() + "\" violates RFC 2965: " + "effective host minus domain may not contain any dots");
        }
    }
}

