// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.StringTokenizer;
import org.apache.http.annotation.Immutable;
import org.apache.http.cookie.ClientCookie;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.cookie.SetCookie2;
import org.apache.http.util.Args;

@Immutable public class RFC2965PortAttributeHandler implements CookieAttributeHandler {
    public RFC2965PortAttributeHandler() {
        super();
    }

    public boolean match(Cookie arg5, CookieOrigin arg6) {
        boolean v0;
        Args.notNull(arg5, "Cookie");
        Args.notNull(arg6, "Cookie origin");
        int v2 = arg6.getPort();
        if(!(arg5 instanceof ClientCookie) || !arg5.containsAttribute("port")) {
        label_21:
            v0 = true;
        }
        else if(arg5.getPorts() == null) {
            v0 = false;
        }
        else if(!RFC2965PortAttributeHandler.portMatch(v2, arg5.getPorts())) {
            v0 = false;
        }
        else {
            goto label_21;
        }

        return v0;
    }

    public void parse(SetCookie arg2, String arg3) {
        Args.notNull(arg2, "Cookie");
        if(((arg2 instanceof SetCookie2)) && arg3 != null && arg3.trim().length() > 0) {
            ((SetCookie2)arg2).setPorts(RFC2965PortAttributeHandler.parsePortAttribute(arg3));
        }
    }

    private static int[] parsePortAttribute(String arg4) {
        StringTokenizer v1 = new StringTokenizer(arg4, ",");
        int[] v2 = new int[v1.countTokens()];
        int v0 = 0;
        try {
            while(true) {
            label_6:
                if(!v1.hasMoreTokens()) {
                    return v2;
                }

                v2[v0] = Integer.parseInt(v1.nextToken().trim());
                if(v2[v0] >= 0) {
                    break;
                }

                throw new MalformedCookieException("Invalid Port attribute.");
            }
        }
        catch(NumberFormatException v0_1) {
            throw new MalformedCookieException("Invalid Port attribute: " + v0_1.getMessage());
        }

        ++v0;
        goto label_6;
        return v2;
    }

    private static boolean portMatch(int arg4, int[] arg5) {
        boolean v0 = false;
        int v2 = arg5.length;
        int v1 = 0;
        while(v1 < v2) {
            if(arg4 == arg5[v1]) {
                v0 = true;
            }
            else {
                ++v1;
                continue;
            }

            return v0;
        }

        return v0;
    }

    public void validate(Cookie arg4, CookieOrigin arg5) {
        Args.notNull(arg4, "Cookie");
        Args.notNull(arg5, "Cookie origin");
        int v1 = arg5.getPort();
        if(((arg4 instanceof ClientCookie)) && (arg4.containsAttribute("port")) && !RFC2965PortAttributeHandler.portMatch(v1, arg4.getPorts())) {
            throw new CookieRestrictionViolationException("Port attribute violates RFC 2965: Request port not found in cookie\'s port list.");
        }
    }
}

