// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.NameValuePair;
import org.apache.http.annotation.NotThreadSafe;
import org.apache.http.cookie.ClientCookie;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.message.BufferedHeader;
import org.apache.http.util.Args;
import org.apache.http.util.CharArrayBuffer;

@NotThreadSafe public class RFC2965Spec extends RFC2109Spec {
    public RFC2965Spec(String[] arg3, boolean arg4) {
        super(arg3, arg4);
        this.registerAttribHandler("domain", new RFC2965DomainAttributeHandler());
        this.registerAttribHandler("port", new RFC2965PortAttributeHandler());
        this.registerAttribHandler("commenturl", new RFC2965CommentUrlAttributeHandler());
        this.registerAttribHandler("discard", new RFC2965DiscardAttributeHandler());
        this.registerAttribHandler("version", new RFC2965VersionAttributeHandler());
    }

    public RFC2965Spec() {
        this(null, false);
    }

    private static CookieOrigin adjustEffectiveHost(CookieOrigin arg6) {
        int v1 = 0;
        String v3 = arg6.getHost();
        int v0 = 0;
        while(true) {
            if(v0 < v3.length()) {
                int v4 = v3.charAt(v0);
                if(v4 != 46 && v4 != 58) {
                    ++v0;
                    continue;
                }
            }
            else {
                break;
            }

            goto label_11;
        }

        v1 = 1;
    label_11:
        if(v1 != 0) {
            arg6 = new CookieOrigin(v3 + ".local", arg6.getPort(), arg6.getPath(), arg6.isSecure());
        }

        return arg6;
    }

    private List createCookies(HeaderElement[] arg12, CookieOrigin arg13) {
        ArrayList v3 = new ArrayList(arg12.length);
        int v4 = arg12.length;
        int v1 = 0;
        while(true) {
            if(v1 >= v4) {
                goto label_62;
            }

            HeaderElement v0 = arg12[v1];
            String v5 = v0.getName();
            String v6 = v0.getValue();
            if(v5 != null && v5.length() != 0) {
                BasicClientCookie2 v7 = new BasicClientCookie2(v5, v6);
                v7.setPath(RFC2965Spec.getDefaultPath(arg13));
                v7.setDomain(RFC2965Spec.getDefaultDomain(arg13));
                v7.setPorts(new int[]{arg13.getPort()});
                NameValuePair[] v5_1 = v0.getParameters();
                HashMap v6_1 = new HashMap(v5_1.length);
                int v0_1;
                for(v0_1 = v5_1.length - 1; v0_1 >= 0; --v0_1) {
                    ((Map)v6_1).put(v5_1[v0_1].getName().toLowerCase(Locale.ENGLISH), v5_1[v0_1]);
                }

                Iterator v5_2 = ((Map)v6_1).entrySet().iterator();
                while(v5_2.hasNext()) {
                    Object v0_2 = v5_2.next().getValue();
                    v6 = ((NameValuePair)v0_2).getName().toLowerCase(Locale.ENGLISH);
                    v7.setAttribute(v6, ((NameValuePair)v0_2).getValue());
                    CookieAttributeHandler v6_2 = this.findAttribHandler(v6);
                    if(v6_2 == null) {
                        continue;
                    }

                    v6_2.parse(((SetCookie)v7), ((NameValuePair)v0_2).getValue());
                }

                ((List)v3).add(v7);
                ++v1;
                continue;
            }

            break;
        }

        throw new MalformedCookieException("Cookie name may not be empty");
    label_62:
        return ((List)v3);
    }

    protected void formatCookieAsVer(CharArrayBuffer arg5, Cookie arg6, int arg7) {
        super.formatCookieAsVer(arg5, arg6, arg7);
        if((arg6 instanceof ClientCookie)) {
            String v0 = arg6.getAttribute("port");
            if(v0 != null) {
                arg5.append("; $Port");
                arg5.append("=\"");
                if(v0.trim().length() > 0) {
                    int[] v1 = arg6.getPorts();
                    if(v1 != null) {
                        int v2 = v1.length;
                        int v0_1;
                        for(v0_1 = 0; v0_1 < v2; ++v0_1) {
                            if(v0_1 > 0) {
                                arg5.append(",");
                            }

                            arg5.append(Integer.toString(v1[v0_1]));
                        }
                    }
                }

                arg5.append("\"");
            }
        }
    }

    public int getVersion() {
        return 1;
    }

    public Header getVersionHeader() {
        CharArrayBuffer v0 = new CharArrayBuffer(40);
        v0.append("Cookie2");
        v0.append(": ");
        v0.append("$Version=");
        v0.append(Integer.toString(this.getVersion()));
        return new BufferedHeader(v0);
    }

    public boolean match(Cookie arg2, CookieOrigin arg3) {
        Args.notNull(arg2, "Cookie");
        Args.notNull(arg3, "Cookie origin");
        return super.match(arg2, RFC2965Spec.adjustEffectiveHost(arg3));
    }

    protected List parse(HeaderElement[] arg2, CookieOrigin arg3) {
        return this.createCookies(arg2, RFC2965Spec.adjustEffectiveHost(arg3));
    }

    public List parse(Header arg4, CookieOrigin arg5) {
        Args.notNull(arg4, "Header");
        Args.notNull(arg5, "Cookie origin");
        if(!arg4.getName().equalsIgnoreCase("Set-Cookie2")) {
            throw new MalformedCookieException("Unrecognized cookie header \'" + arg4.toString() + "\'");
        }

        return this.createCookies(arg4.getElements(), RFC2965Spec.adjustEffectiveHost(arg5));
    }

    public String toString() {
        return "rfc2965";
    }

    public void validate(Cookie arg2, CookieOrigin arg3) {
        Args.notNull(arg2, "Cookie");
        Args.notNull(arg3, "Cookie origin");
        super.validate(arg2, RFC2965Spec.adjustEffectiveHost(arg3));
    }
}

