// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.cookie;

import org.apache.http.annotation.Immutable;
import org.apache.http.cookie.ClientCookie;
import org.apache.http.cookie.Cookie;
import org.apache.http.cookie.CookieAttributeHandler;
import org.apache.http.cookie.CookieOrigin;
import org.apache.http.cookie.CookieRestrictionViolationException;
import org.apache.http.cookie.MalformedCookieException;
import org.apache.http.cookie.SetCookie;
import org.apache.http.cookie.SetCookie2;
import org.apache.http.util.Args;

@Immutable public class RFC2965VersionAttributeHandler implements CookieAttributeHandler {
    public RFC2965VersionAttributeHandler() {
        super();
    }

    public boolean match(Cookie arg2, CookieOrigin arg3) {
        return 1;
    }

    public void parse(SetCookie arg3, String arg4) {
        int v0_1;
        Args.notNull(arg3, "Cookie");
        if(arg4 == null) {
            throw new MalformedCookieException("Missing value for version attribute");
        }

        try {
            v0_1 = Integer.parseInt(arg4);
        }
        catch(NumberFormatException v0) {
            v0_1 = -1;
        }

        if(v0_1 < 0) {
            throw new MalformedCookieException("Invalid cookie version.");
        }

        arg3.setVersion(v0_1);
    }

    public void validate(Cookie arg3, CookieOrigin arg4) {
        Args.notNull(arg3, "Cookie");
        if(((arg3 instanceof SetCookie2)) && ((arg3 instanceof ClientCookie)) && !((ClientCookie)arg3).containsAttribute("version")) {
            throw new CookieRestrictionViolationException("Violates RFC 2965. Version attribute is required.");
        }
    }
}

