// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.IOException;
import java.lang.reflect.UndeclaredThrowableException;
import org.apache.http.HttpException;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.BackoffManager;
import org.apache.http.client.ConnectionBackoffStrategy;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.util.Args;

@Immutable public class BackoffStrategyExec implements ClientExecChain {
    private final BackoffManager backoffManager;
    private final ConnectionBackoffStrategy connectionBackoffStrategy;
    private final ClientExecChain requestExecutor;

    public BackoffStrategyExec(ClientExecChain arg2, ConnectionBackoffStrategy arg3, BackoffManager arg4) {
        super();
        Args.notNull(arg2, "HTTP client request executor");
        Args.notNull(arg3, "Connection backoff strategy");
        Args.notNull(arg4, "Backoff manager");
        this.requestExecutor = arg2;
        this.connectionBackoffStrategy = arg3;
        this.backoffManager = arg4;
    }

    public CloseableHttpResponse execute(HttpRoute arg3, HttpRequestWrapper arg4, HttpClientContext arg5, HttpExecutionAware arg6) {
        CloseableHttpResponse v0_1;
        Args.notNull(arg3, "HTTP route");
        Args.notNull(arg4, "HTTP request");
        Args.notNull(arg5, "HTTP context");
        CloseableHttpResponse v1 = null;
        try {
            v0_1 = this.requestExecutor.execute(arg3, arg4, arg5, arg6);
        }
        catch(Exception v0) {
            if(0 != 0) {
                v1.close();
            }

            if(this.connectionBackoffStrategy.shouldBackoff(((Throwable)v0))) {
                this.backoffManager.backOff(arg3);
            }

            if((v0 instanceof RuntimeException)) {
                throw v0;
            }

            if((v0 instanceof HttpException)) {
                throw v0;
            }

            if((v0 instanceof IOException)) {
                throw v0;
            }

            throw new UndeclaredThrowableException(((Throwable)v0));
        }

        if(this.connectionBackoffStrategy.shouldBackoff(((HttpResponse)v0_1))) {
            this.backoffManager.backOff(arg3);
        }
        else {
            this.backoffManager.probe(arg3);
        }

        return v0_1;
    }
}

