// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.Closeable;
import java.io.IOException;
import java.util.concurrent.TimeUnit;
import org.apache.commons.logging.Log;
import org.apache.http.HttpClientConnection;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.concurrent.Cancellable;
import org.apache.http.conn.ConnectionReleaseTrigger;
import org.apache.http.conn.HttpClientConnectionManager;

@ThreadSafe class ConnectionHolder implements Closeable, Cancellable, ConnectionReleaseTrigger {
    private final Log log;
    private final HttpClientConnection managedConn;
    private final HttpClientConnectionManager manager;
    private volatile boolean released;
    private volatile boolean reusable;
    private volatile Object state;
    private volatile TimeUnit tunit;
    private volatile long validDuration;

    public ConnectionHolder(Log arg1, HttpClientConnectionManager arg2, HttpClientConnection arg3) {
        super();
        this.log = arg1;
        this.manager = arg2;
        this.managedConn = arg3;
    }

    public void abortConnection() {
        HttpClientConnection v7 = this.managedConn;
        __monitor_enter(v7);
        try {
            if(this.released) {
                __monitor_exit(v7);
                return;
            }

            this.released = true;
        }
        catch(Throwable v0) {
            goto label_22;
        }

        try {
            this.managedConn.shutdown();
            this.log.debug("Connection discarded");
            goto label_13;
        }
        catch(Throwable v0) {
        }
        catch(IOException v0_1) {
            try {
                if(this.log.isDebugEnabled()) {
                    this.log.debug(v0_1.getMessage(), ((Throwable)v0_1));
                }
            }
            catch(Throwable v0) {
                goto label_45;
            }

            try {
                this.manager.releaseConnection(this.managedConn, null, 0, TimeUnit.MILLISECONDS);
                goto label_19;
            label_45:
                this.manager.releaseConnection(this.managedConn, null, 0, TimeUnit.MILLISECONDS);
                throw v0;
            label_13:
                this.manager.releaseConnection(this.managedConn, null, 0, TimeUnit.MILLISECONDS);
            label_19:
                __monitor_exit(v7);
                return;
            label_22:
                __monitor_exit(v7);
            }
            catch(Throwable v0) {
                goto label_22;
            }
        }

        throw v0;
    }

    public boolean cancel() {
        boolean v0 = this.released;
        this.log.debug("Cancelling request execution");
        this.abortConnection();
        return !v0 ? true : false;
    }

    public void close() {
        this.abortConnection();
    }

    public boolean isReleased() {
        return this.released;
    }

    public boolean isReusable() {
        return this.reusable;
    }

    public void markNonReusable() {
        this.reusable = false;
    }

    public void markReusable() {
        this.reusable = true;
    }

    public void releaseConnection() {
        HttpClientConnection v7 = this.managedConn;
        __monitor_enter(v7);
        try {
            if(this.released) {
                __monitor_exit(v7);
                return;
            }

            this.released = true;
            if(!this.reusable) {
                goto label_21;
            }

            this.manager.releaseConnection(this.managedConn, this.state, this.validDuration, this.tunit);
            goto label_16;
        }
        catch(Throwable v0) {
            goto label_19;
        }

        try {
        label_21:
            this.managedConn.close();
            this.log.debug("Connection discarded");
            goto label_26;
        }
        catch(Throwable v0) {
        }
        catch(IOException v0_1) {
            try {
                if(this.log.isDebugEnabled()) {
                    this.log.debug(v0_1.getMessage(), ((Throwable)v0_1));
                }
            }
            catch(Throwable v0) {
                goto label_54;
            }

            try {
                this.manager.releaseConnection(this.managedConn, null, 0, TimeUnit.MILLISECONDS);
                goto label_16;
            label_54:
                this.manager.releaseConnection(this.managedConn, null, 0, TimeUnit.MILLISECONDS);
                throw v0;
            label_26:
                this.manager.releaseConnection(this.managedConn, null, 0, TimeUnit.MILLISECONDS);
            label_16:
                __monitor_exit(v7);
                return;
            label_19:
                __monitor_exit(v7);
            }
            catch(Throwable v0) {
                goto label_19;
            }
        }

        throw v0;
    }

    public void setState(Object arg1) {
        this.state = arg1;
    }

    public void setValidFor(long arg3, TimeUnit arg5) {
        HttpClientConnection v1 = this.managedConn;
        __monitor_enter(v1);
        try {
            this.validDuration = arg3;
            this.tunit = arg5;
            __monitor_exit(v1);
            return;
        label_7:
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            goto label_7;
        }

        throw v0;
    }
}

