// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.ConnectionReuseStrategy;
import org.apache.http.HttpClientConnection;
import org.apache.http.HttpEntity;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.Immutable;
import org.apache.http.auth.AuthProtocolState;
import org.apache.http.auth.AuthState;
import org.apache.http.client.AuthenticationStrategy;
import org.apache.http.client.NonRepeatableRequestException;
import org.apache.http.client.UserTokenHandler;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.client.protocol.RequestClientConnControl;
import org.apache.http.concurrent.Cancellable;
import org.apache.http.conn.ConnectionKeepAliveStrategy;
import org.apache.http.conn.ConnectionRequest;
import org.apache.http.conn.HttpClientConnectionManager;
import org.apache.http.conn.routing.BasicRouteDirector;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.HttpRouteDirector;
import org.apache.http.conn.routing.RouteInfo;
import org.apache.http.conn.routing.RouteTracker;
import org.apache.http.entity.BufferedHttpEntity;
import org.apache.http.impl.auth.HttpAuthenticator;
import org.apache.http.impl.conn.ConnectionShutdownException;
import org.apache.http.message.BasicHttpRequest;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.protocol.HttpRequestExecutor;
import org.apache.http.protocol.ImmutableHttpProcessor;
import org.apache.http.protocol.RequestTargetHost;
import org.apache.http.util.Args;
import org.apache.http.util.EntityUtils;

@Immutable public class MainClientExec implements ClientExecChain {
    private final HttpAuthenticator authenticator;
    private final HttpClientConnectionManager connManager;
    private final ConnectionKeepAliveStrategy keepAliveStrategy;
    private final Log log;
    private final AuthenticationStrategy proxyAuthStrategy;
    private final HttpProcessor proxyHttpProcessor;
    private final HttpRequestExecutor requestExecutor;
    private final ConnectionReuseStrategy reuseStrategy;
    private final HttpRouteDirector routeDirector;
    private final AuthenticationStrategy targetAuthStrategy;
    private final UserTokenHandler userTokenHandler;

    public MainClientExec(HttpRequestExecutor arg5, HttpClientConnectionManager arg6, ConnectionReuseStrategy arg7, ConnectionKeepAliveStrategy arg8, AuthenticationStrategy arg9, AuthenticationStrategy arg10, UserTokenHandler arg11) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg5, "HTTP request executor");
        Args.notNull(arg6, "Client connection manager");
        Args.notNull(arg7, "Connection reuse strategy");
        Args.notNull(arg8, "Connection keep alive strategy");
        Args.notNull(arg9, "Target authentication strategy");
        Args.notNull(arg10, "Proxy authentication strategy");
        Args.notNull(arg11, "User token handler");
        this.authenticator = new HttpAuthenticator();
        this.proxyHttpProcessor = new ImmutableHttpProcessor(new HttpRequestInterceptor[]{new RequestTargetHost(), new RequestClientConnControl()});
        this.routeDirector = new BasicRouteDirector();
        this.requestExecutor = arg5;
        this.connManager = arg6;
        this.reuseStrategy = arg7;
        this.keepAliveStrategy = arg8;
        this.targetAuthStrategy = arg9;
        this.proxyAuthStrategy = arg10;
        this.userTokenHandler = arg11;
    }

    private boolean createTunnelToProxy(HttpRoute arg3, int arg4, HttpClientContext arg5) {
        throw new HttpException("Proxy chains are not supported.");
    }

    private boolean createTunnelToTarget(AuthState arg11, HttpClientConnection arg12, HttpRoute arg13, HttpRequest arg14, HttpClientContext arg15) {
        HttpResponse v2_1;
        RequestConfig v8 = arg15.getRequestConfig();
        int v6 = v8.getConnectTimeout();
        HttpHost v0 = arg13.getTargetHost();
        HttpHost v1 = arg13.getProxyHost();
        BasicHttpRequest v9 = new BasicHttpRequest("CONNECT", v0.toHostString(), arg14.getProtocolVersion());
        this.requestExecutor.preProcess(((HttpRequest)v9), this.proxyHttpProcessor, ((HttpContext)arg15));
        while(true) {
            if(!arg12.isOpen()) {
                HttpClientConnectionManager v2 = this.connManager;
                int v0_1 = v6 > 0 ? v6 : 0;
                v2.connect(arg12, arg13, v0_1, ((HttpContext)arg15));
            }

            ((HttpRequest)v9).removeHeaders("Proxy-Authorization");
            this.authenticator.generateAuthResponse(((HttpRequest)v9), arg11, ((HttpContext)arg15));
            v2_1 = this.requestExecutor.execute(((HttpRequest)v9), arg12, ((HttpContext)arg15));
            if(v2_1.getStatusLine().getStatusCode() < 200) {
                throw new HttpException("Unexpected response to CONNECT request: " + v2_1.getStatusLine());
            }

            if(!v8.isAuthenticationEnabled()) {
                continue;
            }

            if((this.authenticator.isAuthenticationRequested(v1, v2_1, this.proxyAuthStrategy, arg11, arg15)) && (this.authenticator.handleAuthChallenge(v1, v2_1, this.proxyAuthStrategy, arg11, arg15))) {
                if(this.reuseStrategy.keepAlive(v2_1, ((HttpContext)arg15))) {
                    this.log.debug("Connection kept alive");
                    EntityUtils.consume(v2_1.getEntity());
                }
                else {
                    arg12.close();
                }

                continue;
            }

            break;
        }

        if(v2_1.getStatusLine().getStatusCode() > 299) {
            HttpEntity v0_2 = v2_1.getEntity();
            if(v0_2 != null) {
                v2_1.setEntity(new BufferedHttpEntity(v0_2));
            }

            arg12.close();
            throw new TunnelRefusedException("CONNECT refused by proxy: " + v2_1.getStatusLine(), v2_1);
        }

        return 0;
    }

    void establishRoute(AuthState arg9, HttpClientConnection arg10, HttpRoute arg11, HttpRequest arg12, HttpClientContext arg13) {
        HttpRoute v0;
        int v1 = arg13.getRequestConfig().getConnectTimeout();
        RouteTracker v3 = new RouteTracker(arg11);
        do {
            v0 = v3.toRoute();
            int v4 = this.routeDirector.nextStep(((RouteInfo)arg11), ((RouteInfo)v0));
            switch(v4) {
                case -1: {
                    goto label_59;
                }
                case 0: {
                    goto label_71;
                }
                case 1: {
                    goto label_20;
                }
                case 2: {
                    goto label_30;
                }
                case 3: {
                    goto label_39;
                }
                case 4: {
                    goto label_45;
                }
                case 5: {
                    goto label_54;
                }
            }

            throw new IllegalStateException("Unknown step indicator " + v4 + " from RouteDirector.");
        label_54:
            this.connManager.upgrade(arg10, arg11, ((HttpContext)arg13));
            v3.layerProtocol(arg11.isSecure());
            continue;
        label_20:
            HttpClientConnectionManager v5 = this.connManager;
            int v0_1 = v1 > 0 ? v1 : 0;
            v5.connect(arg10, arg11, v0_1, ((HttpContext)arg13));
            v3.connectTarget(arg11.isSecure());
            continue;
        label_71:
            this.connManager.routeComplete(arg10, arg11, ((HttpContext)arg13));
            continue;
        label_39:
            boolean v0_2 = this.createTunnelToTarget(arg9, arg10, arg11, arg12, arg13);
            this.log.debug("Tunnel to target created.");
            v3.tunnelTarget(v0_2);
            continue;
        label_45:
            v0_1 = v0.getHopCount() - 1;
            boolean v5_1 = this.createTunnelToProxy(arg11, v0_1, arg13);
            this.log.debug("Tunnel to proxy created.");
            v3.tunnelProxy(arg11.getHopTarget(v0_1), v5_1);
            continue;
        label_30:
            v5 = this.connManager;
            v0_1 = v1 > 0 ? v1 : 0;
            v5.connect(arg10, arg11, v0_1, ((HttpContext)arg13));
            v3.connectProxy(arg11.getProxyHost(), false);
        }
        while(v4 > 0);

        return;
    label_59:
        throw new HttpException("Unable to establish route: planned = " + arg11 + "; current = " + v0);
    }

    public CloseableHttpResponse execute(HttpRoute arg17, HttpRequestWrapper arg18, HttpClientContext arg19, HttpExecutionAware arg20) {
        HttpResponseProxy v2_16;
        Object v2_15;
        HttpEntity v2_13;
        HttpResponse v9;
        int v13;
        HttpClientConnection v4_2;
        long v4_1;
        AuthState v11;
        Args.notNull(arg17, "HTTP route");
        Args.notNull(arg18, "HTTP request");
        Args.notNull(arg19, "HTTP context");
        AuthState v2 = arg19.getTargetAuthState();
        if(v2 == null) {
            v2 = new AuthState();
            arg19.setAttribute("http.auth.target-scope", v2);
            v11 = v2;
        }
        else {
            v11 = v2;
        }

        AuthState v3 = arg19.getProxyAuthState();
        if(v3 == null) {
            v3 = new AuthState();
            arg19.setAttribute("http.auth.proxy-scope", v3);
        }

        if((arg18 instanceof HttpEntityEnclosingRequest)) {
            RequestEntityProxy.enhance(arg18);
        }

        Object v12 = arg19.getUserToken();
        ConnectionRequest v2_1 = this.connManager.requestConnection(arg17, v12);
        if(arg20 != null) {
            if(arg20.isAborted()) {
                v2_1.cancel();
                throw new RequestAbortedException("Request aborted");
            }
            else {
                arg20.setCancellable(((Cancellable)v2_1));
            }
        }

        RequestConfig v14 = arg19.getRequestConfig();
        try {
            int v4 = v14.getConnectionRequestTimeout();
            if(v4 > 0) {
                v4_1 = ((long)v4);
            }
            else {
                goto label_93;
            }

            goto label_48;
        }
        catch(ExecutionException v2_2) {
            goto label_103;
        }
        catch(InterruptedException v2_3) {
            goto label_97;
        }

    label_93:
        v4_1 = 0;
        try {
        label_48:
            v4_2 = v2_1.get(v4_1, TimeUnit.MILLISECONDS);
        }
        catch(ExecutionException v2_2) {
        label_103:
            Throwable v3_1 = v2_2.getCause();
            if(v3_1 != null) {
                Throwable v2_4 = v3_1;
            }

            throw new RequestAbortedException("Request execution failed", ((Throwable)v2_2));
        }
        catch(InterruptedException v2_3) {
        label_97:
            Thread.currentThread().interrupt();
            throw new RequestAbortedException("Request aborted", ((Throwable)v2_3));
        }

        arg19.setAttribute("http.connection", v4_2);
        if((v14.isStaleConnectionCheckEnabled()) && (v4_2.isOpen())) {
            this.log.debug("Stale connection check");
            if(v4_2.isStale()) {
                this.log.debug("Stale connection detected");
                v4_2.close();
            }
        }

        ConnectionHolder v15 = new ConnectionHolder(this.log, this.connManager, v4_2);
        if(arg20 != null) {
            try {
                arg20.setCancellable(((Cancellable)v15));
            label_77:
                v13 = 1;
                while(true) {
                label_79:
                    if(v13 > 1 && !RequestEntityProxy.isRepeatable(((HttpRequest)arg18))) {
                        throw new NonRepeatableRequestException("Cannot retry request with a non-repeatable request entity.");
                    }

                    goto label_109;
                }
            }
            catch(ConnectionShutdownException v2_5) {
                goto label_90;
            }
            catch(HttpException v2_6) {
                goto label_117;
            }
            catch(RuntimeException v2_7) {
                goto label_314;
            }
            catch(IOException v2_8) {
                goto label_147;
            }
        }

        goto label_77;
    label_109:
        if(arg20 != null) {
            try {
                if(arg20.isAborted()) {
                    throw new RequestAbortedException("Request aborted");
                }

            label_119:
                if(!v4_2.isOpen()) {
                    this.log.debug("Opening connection " + arg17);
                    MainClientExec v2_9 = this;
                    HttpRoute v5 = arg17;
                    HttpRequestWrapper v6 = arg18;
                    HttpClientContext v7 = arg19;
                    try {
                        v2_9.establishRoute(v3, v4_2, v5, ((HttpRequest)v6), v7);
                        goto label_136;
                    }
                    catch(TunnelRefusedException v2_10) {
                        try {
                            if(this.log.isDebugEnabled()) {
                                this.log.debug(v2_10.getMessage());
                            }

                            v9 = v2_10.getResponse();
                            goto label_159;
                        label_136:
                            int v2_11 = v14.getSocketTimeout();
                            if(v2_11 >= 0) {
                                v4_2.setSocketTimeout(v2_11);
                            }

                            if(arg20 != null && (arg20.isAborted())) {
                                throw new RequestAbortedException("Request aborted");
                            }

                            if(this.log.isDebugEnabled()) {
                                this.log.debug("Executing request " + arg18.getRequestLine());
                            }

                            if(!arg18.containsHeader("Authorization")) {
                                if(this.log.isDebugEnabled()) {
                                    this.log.debug("Target auth state: " + v11.getState());
                                }

                                this.authenticator.generateAuthResponse(arg18, v11, arg19);
                            }

                            if(!arg18.containsHeader("Proxy-Authorization") && !arg17.isTunnelled()) {
                                if(this.log.isDebugEnabled()) {
                                    this.log.debug("Proxy auth state: " + v3.getState());
                                }

                                this.authenticator.generateAuthResponse(arg18, v3, arg19);
                            }

                            v9 = this.requestExecutor.execute(arg18, v4_2, arg19);
                            if(this.reuseStrategy.keepAlive(v9, arg19)) {
                                long v5_1 = this.keepAliveStrategy.getKeepAliveDuration(v9, arg19);
                                if(this.log.isDebugEnabled()) {
                                    String v2_12 = v5_1 > 0 ? "for " + v5_1 + " " + TimeUnit.MILLISECONDS : "indefinitely";
                                    this.log.debug("Connection can be kept alive " + v2_12);
                                }

                                v15.setValidFor(v5_1, TimeUnit.MILLISECONDS);
                                v15.markReusable();
                            }
                            else {
                                v15.markNonReusable();
                            }

                            if(this.needAuthentication(v11, v3, arg17, v9, arg19)) {
                                v2_13 = v9.getEntity();
                                if(v15.isReusable()) {
                                    EntityUtils.consume(v2_13);
                                }
                                else {
                                    v4_2.close();
                                    if(v3.getState() == AuthProtocolState.SUCCESS && v3.getAuthScheme() != null && (v3.getAuthScheme().isConnectionBased())) {
                                        this.log.debug("Resetting proxy auth state");
                                        v3.reset();
                                    }

                                    if(v11.getState() != AuthProtocolState.SUCCESS) {
                                        goto label_293;
                                    }

                                    if(v11.getAuthScheme() == null) {
                                        goto label_293;
                                    }

                                    if(!v11.getAuthScheme().isConnectionBased()) {
                                        goto label_293;
                                    }

                                    this.log.debug("Resetting target auth state");
                                    v11.reset();
                                }

                            label_293:
                                HttpRequest v2_14 = arg18.getOriginal();
                                if(!v2_14.containsHeader("Authorization")) {
                                    arg18.removeHeaders("Authorization");
                                }

                                if(!v2_14.containsHeader("Proxy-Authorization")) {
                                    arg18.removeHeaders("Proxy-Authorization");
                                }

                                ++v13;
                                goto label_79;
                            }

                        label_159:
                            if(v12 == null) {
                                v2_15 = this.userTokenHandler.getUserToken(arg19);
                                arg19.setAttribute("http.user-token", v2_15);
                            }
                            else {
                                goto label_347;
                            }

                            goto label_167;
                        }
                        catch(ConnectionShutdownException v2_5) {
                            goto label_90;
                        }
                        catch(HttpException v2_6) {
                            goto label_117;
                        }
                        catch(RuntimeException v2_7) {
                            goto label_314;
                        }
                        catch(IOException v2_8) {
                            goto label_147;
                        }
                    }
                }

                goto label_136;
            }
            catch(ConnectionShutdownException v2_5) {
                goto label_90;
            }
            catch(HttpException v2_6) {
                goto label_117;
            }
            catch(RuntimeException v2_7) {
                goto label_314;
            }
            catch(IOException v2_8) {
                goto label_147;
            }
        }

        goto label_119;
    label_347:
        v2_15 = v12;
        try {
        label_167:
            if(v2_15 != null) {
                v15.setState(v2_15);
            }

            v2_13 = v9.getEntity();
            if(v2_13 == null || !v2_13.isStreaming()) {
                v15.releaseConnection();
                v2_16 = new HttpResponseProxy(v9, null);
            }
            else {
                v2_16 = new HttpResponseProxy(v9, v15);
            }

            return ((CloseableHttpResponse)v2_16);
        }
        catch(RuntimeException v2_7) {
        label_314:
            v15.abortConnection();
            throw v2_7;
        }
        catch(IOException v2_8) {
        label_147:
            v15.abortConnection();
            throw v2_8;
        }
        catch(HttpException v2_6) {
        label_117:
            v15.abortConnection();
            throw v2_6;
        }
        catch(ConnectionShutdownException v2_5) {
        label_90:
            InterruptedIOException v3_2 = new InterruptedIOException("Connection has been shut down");
            v3_2.initCause(((Throwable)v2_5));
            throw v3_2;
        }
    }

    private boolean needAuthentication(AuthState arg9, AuthState arg10, HttpRoute arg11, HttpResponse arg12, HttpClientContext arg13) {
        boolean v0_1;
        if(arg13.getRequestConfig().isAuthenticationEnabled()) {
            HttpHost v0 = arg13.getTargetHost();
            if(v0 == null) {
                v0 = arg11.getTargetHost();
            }

            HttpHost v1 = v0.getPort() < 0 ? new HttpHost(v0.getHostName(), arg11.getTargetHost().getPort(), v0.getSchemeName()) : v0;
            v0_1 = this.authenticator.isAuthenticationRequested(v1, arg12, this.targetAuthStrategy, arg9, arg13);
            HttpHost v3 = arg11.getProxyHost();
            if(v3 == null) {
                v3 = arg11.getTargetHost();
            }

            boolean v2 = this.authenticator.isAuthenticationRequested(v3, arg12, this.proxyAuthStrategy, arg10, arg13);
            if(v0_1) {
                return this.authenticator.handleAuthChallenge(v1, arg12, this.targetAuthStrategy, arg9, arg13);
            }

            if(!v2) {
                goto label_45;
            }

            v0_1 = this.authenticator.handleAuthChallenge(v3, arg12, this.proxyAuthStrategy, arg10, arg13);
        }
        else {
        label_45:
            v0_1 = false;
        }

        return v0_1;
    }
}

