// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.ConnectionReuseStrategy;
import org.apache.http.HttpClientConnection;
import org.apache.http.HttpEntity;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.HttpResponse;
import org.apache.http.ProtocolException;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.client.protocol.RequestClientConnControl;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.concurrent.Cancellable;
import org.apache.http.conn.ConnectionKeepAliveStrategy;
import org.apache.http.conn.ConnectionRequest;
import org.apache.http.conn.HttpClientConnectionManager;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.impl.conn.ConnectionShutdownException;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.protocol.HttpRequestExecutor;
import org.apache.http.protocol.ImmutableHttpProcessor;
import org.apache.http.protocol.RequestContent;
import org.apache.http.protocol.RequestTargetHost;
import org.apache.http.protocol.RequestUserAgent;
import org.apache.http.util.Args;
import org.apache.http.util.VersionInfo;

@Immutable public class MinimalClientExec implements ClientExecChain {
    private final HttpClientConnectionManager connManager;
    private final HttpProcessor httpProcessor;
    private final ConnectionKeepAliveStrategy keepAliveStrategy;
    private final Log log;
    private final HttpRequestExecutor requestExecutor;
    private final ConnectionReuseStrategy reuseStrategy;

    public MinimalClientExec(HttpRequestExecutor arg8, HttpClientConnectionManager arg9, ConnectionReuseStrategy arg10, ConnectionKeepAliveStrategy arg11) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg8, "HTTP request executor");
        Args.notNull(arg9, "Client connection manager");
        Args.notNull(arg10, "Connection reuse strategy");
        Args.notNull(arg11, "Connection keep alive strategy");
        this.httpProcessor = new ImmutableHttpProcessor(new HttpRequestInterceptor[]{new RequestContent(), new RequestTargetHost(), new RequestClientConnControl(), new RequestUserAgent(VersionInfo.getUserAgent("Apache-HttpClient", "org.apache.http.client", this.getClass()))});
        this.requestExecutor = arg8;
        this.connManager = arg9;
        this.reuseStrategy = arg10;
        this.keepAliveStrategy = arg11;
    }

    public CloseableHttpResponse execute(HttpRoute arg7, HttpRequestWrapper arg8, HttpClientContext arg9, HttpExecutionAware arg10) {
        HttpResponseProxy v0_12;
        HttpHost v0_10;
        int v0_8;
        Throwable v0_3;
        HttpClientConnection v2_2;
        long v2_1;
        Object v1 = null;
        Args.notNull(arg7, "HTTP route");
        Args.notNull(arg8, "HTTP request");
        Args.notNull(arg9, "HTTP context");
        MinimalClientExec.rewriteRequestURI(arg8, arg7);
        ConnectionRequest v0 = this.connManager.requestConnection(arg7, v1);
        if(arg10 != null) {
            if(arg10.isAborted()) {
                v0.cancel();
                throw new RequestAbortedException("Request aborted");
            }
            else {
                arg10.setCancellable(((Cancellable)v0));
            }
        }

        RequestConfig v4 = arg9.getRequestConfig();
        try {
            int v2 = v4.getConnectionRequestTimeout();
            if(v2 > 0) {
                v2_1 = ((long)v2);
            }
            else {
                goto label_43;
            }

            goto label_23;
        }
        catch(ExecutionException v0_1) {
            goto label_53;
        }
        catch(InterruptedException v0_2) {
            goto label_47;
        }

    label_43:
        v2_1 = 0;
        try {
        label_23:
            v2_2 = v0.get(v2_1, TimeUnit.MILLISECONDS);
        }
        catch(ExecutionException v0_1) {
        label_53:
            Throwable v1_1 = v0_1.getCause();
            if(v1_1 != null) {
                v0_3 = v1_1;
            }

            throw new RequestAbortedException("Request execution failed", v0_3);
        }
        catch(InterruptedException v0_2) {
        label_47:
            Thread.currentThread().interrupt();
            throw new RequestAbortedException("Request aborted", ((Throwable)v0_2));
        }

        ConnectionHolder v3 = new ConnectionHolder(this.log, this.connManager, v2_2);
        if(arg10 != null) {
            try {
                if(arg10.isAborted()) {
                    v3.close();
                    throw new RequestAbortedException("Request aborted");
                }
                else {
                    arg10.setCancellable(((Cancellable)v3));
                }

            label_60:
                if(!v2_2.isOpen()) {
                    v0_8 = v4.getConnectTimeout();
                    HttpClientConnectionManager v5 = this.connManager;
                    if(v0_8 <= 0) {
                        v0_8 = 0;
                    }

                    v5.connect(v2_2, arg7, v0_8, ((HttpContext)arg9));
                    this.connManager.routeComplete(v2_2, arg7, ((HttpContext)arg9));
                }

                v0_8 = v4.getSocketTimeout();
                if(v0_8 >= 0) {
                    v2_2.setSocketTimeout(v0_8);
                }

                HttpRequest v0_9 = arg8.getOriginal();
                if((v0_9 instanceof HttpUriRequest)) {
                    URI v4_1 = ((HttpUriRequest)v0_9).getURI();
                    if(v4_1.isAbsolute()) {
                        v0_10 = new HttpHost(v4_1.getHost(), v4_1.getPort(), v4_1.getScheme());
                    }
                    else {
                        goto label_131;
                    }
                }
                else {
                    goto label_131;
                }

                goto label_82;
            }
            catch(HttpException v0_4) {
                goto label_120;
            }
            catch(ConnectionShutdownException v0_5) {
                goto label_40;
            }
            catch(RuntimeException v0_6) {
                goto label_129;
            }
            catch(IOException v0_7) {
                goto label_126;
            }
        }

        goto label_60;
    label_131:
        v0_10 = ((HttpHost)v1);
        try {
        label_82:
            if(v0_10 == null) {
                v0_10 = arg7.getTargetHost();
            }

            arg9.setAttribute("http.target_host", v0_10);
            arg9.setAttribute("http.request", arg8);
            arg9.setAttribute("http.connection", v2_2);
            arg9.setAttribute("http.route", arg7);
            this.httpProcessor.process(((HttpRequest)arg8), ((HttpContext)arg9));
            HttpResponse v1_2 = this.requestExecutor.execute(((HttpRequest)arg8), v2_2, ((HttpContext)arg9));
            this.httpProcessor.process(v1_2, ((HttpContext)arg9));
            if(this.reuseStrategy.keepAlive(v1_2, ((HttpContext)arg9))) {
                v3.setValidFor(this.keepAliveStrategy.getKeepAliveDuration(v1_2, ((HttpContext)arg9)), TimeUnit.MILLISECONDS);
                v3.markReusable();
            }
            else {
                v3.markNonReusable();
            }

            HttpEntity v0_11 = v1_2.getEntity();
            if(v0_11 == null || !v0_11.isStreaming()) {
                v3.releaseConnection();
                v0_12 = new HttpResponseProxy(v1_2, null);
            }
            else {
                v0_12 = new HttpResponseProxy(v1_2, v3);
            }

            return ((CloseableHttpResponse)v0_12);
        }
        catch(RuntimeException v0_6) {
        label_129:
            v3.abortConnection();
            throw v0_6;
        }
        catch(IOException v0_7) {
        label_126:
            v3.abortConnection();
            throw v0_7;
        }
        catch(HttpException v0_4) {
        label_120:
            v3.abortConnection();
            throw v0_4;
        }
        catch(ConnectionShutdownException v0_5) {
        label_40:
            InterruptedIOException v1_3 = new InterruptedIOException("Connection has been shut down");
            v1_3.initCause(((Throwable)v0_5));
            throw v1_3;
        }
    }

    static void rewriteRequestURI(HttpRequestWrapper arg4, HttpRoute arg5) {
        try {
            URI v0_1 = arg4.getURI();
            if(v0_1 != null) {
                v0_1 = v0_1.isAbsolute() ? URIUtils.rewriteURI(v0_1, null, true) : URIUtils.rewriteURI(v0_1);
                arg4.setURI(v0_1);
            }

            return;
        }
        catch(URISyntaxException v0) {
            throw new ProtocolException("Invalid URI: " + arg4.getRequestLine().getUri(), ((Throwable)v0));
        }
    }
}

