// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.ProtocolException;
import org.apache.http.annotation.Immutable;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.util.Args;

@Immutable public class ProtocolExec implements ClientExecChain {
    private final HttpProcessor httpProcessor;
    private final Log log;
    private final ClientExecChain requestExecutor;

    public ProtocolExec(ClientExecChain arg2, HttpProcessor arg3) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "HTTP client request executor");
        Args.notNull(arg3, "HTTP protocol processor");
        this.requestExecutor = arg2;
        this.httpProcessor = arg3;
    }

    public CloseableHttpResponse execute(HttpRoute arg8, HttpRequestWrapper arg9, HttpClientContext arg10, HttpExecutionAware arg11) {
        BasicCredentialsProvider v0_6;
        Object v2_2;
        HttpHost v0_4;
        URI v0_2;
        URI v1;
        URI v2 = null;
        int v6 = -1;
        Args.notNull(arg8, "HTTP route");
        Args.notNull(arg9, "HTTP request");
        Args.notNull(arg10, "HTTP context");
        HttpRequest v0 = arg9.getOriginal();
        if((v0 instanceof HttpUriRequest)) {
            v1 = ((HttpUriRequest)v0).getURI();
            goto label_13;
        }

        String v0_1 = v0.getRequestLine().getUri();
        try {
            v0_2 = URI.create(v0_1);
            v1 = v0_2;
        }
        catch(IllegalArgumentException v1_1) {
            if(this.log.isDebugEnabled()) {
                this.log.debug("Unable to parse \'" + (((String)v0_2)) + "\' as a valid URI; " + "request URI and Host header may be inconsistent", ((Throwable)v1_1));
            }

            v1 = v2;
        }

    label_13:
        arg9.setURI(v1);
        this.rewriteRequestURI(arg9, arg8);
        Object v0_3 = arg9.getParams().getParameter("http.virtual-host");
        if(v0_3 != null && ((HttpHost)v0_3).getPort() == v6) {
            int v4 = arg8.getTargetHost().getPort();
            if(v4 != v6) {
                v0_4 = new HttpHost(((HttpHost)v0_3).getHostName(), v4, ((HttpHost)v0_3).getSchemeName());
            }

            if(!this.log.isDebugEnabled()) {
                goto label_40;
            }

            this.log.debug("Using virtual host" + v0_4);
        }

    label_40:
        if(v0_4 == null) {
            if(v1 != null && (v1.isAbsolute()) && v1.getHost() != null) {
                v0_4 = new HttpHost(v1.getHost(), v1.getPort(), v1.getScheme());
                goto label_41;
            }

            v0_3 = v2;
        }

    label_41:
        if(v0_4 == null) {
            HttpHost v2_1 = arg8.getTargetHost();
        }
        else {
            v2_2 = v0_4;
        }

        if(v1 != null) {
            String v1_2 = v1.getUserInfo();
            if(v1_2 != null) {
                CredentialsProvider v0_5 = arg10.getCredentialsProvider();
                if(v0_5 == null) {
                    v0_6 = new BasicCredentialsProvider();
                    arg10.setCredentialsProvider(((CredentialsProvider)v0_6));
                }

                ((CredentialsProvider)v0_6).setCredentials(new AuthScope(((HttpHost)v2_2)), new UsernamePasswordCredentials(v1_2));
            }
        }

        arg10.setAttribute("http.target_host", v2_2);
        arg10.setAttribute("http.route", arg8);
        arg10.setAttribute("http.request", arg9);
        this.httpProcessor.process(((HttpRequest)arg9), ((HttpContext)arg10));
        CloseableHttpResponse v1_3 = this.requestExecutor.execute(arg8, arg9, arg10, arg11);
        try {
            arg10.setAttribute("http.response", v1_3);
            this.httpProcessor.process(((HttpResponse)v1_3), ((HttpContext)arg10));
            return v1_3;
        }
        catch(HttpException v0_7) {
            v1_3.close();
            throw v0_7;
        }
        catch(IOException v0_8) {
            v1_3.close();
            throw v0_8;
        }
        catch(RuntimeException v0_9) {
            v1_3.close();
            throw v0_9;
        }
    }

    void rewriteRequestURI(HttpRequestWrapper arg5, HttpRoute arg6) {
        try {
            URI v0_1 = arg5.getURI();
            if(v0_1 != null) {
                if(arg6.getProxyHost() == null || (arg6.isTunnelled())) {
                    v0_1 = v0_1.isAbsolute() ? URIUtils.rewriteURI(v0_1, null, true) : URIUtils.rewriteURI(v0_1);
                }
                else if(!v0_1.isAbsolute()) {
                    v0_1 = URIUtils.rewriteURI(v0_1, arg6.getTargetHost(), true);
                }
                else {
                    v0_1 = URIUtils.rewriteURI(v0_1);
                }

                arg5.setURI(v0_1);
            }

            return;
        }
        catch(URISyntaxException v0) {
            throw new ProtocolException("Invalid URI: " + arg5.getRequestLine().getUri(), ((Throwable)v0));
        }
    }
}

