// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.IOException;
import java.net.URI;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.ProtocolException;
import org.apache.http.annotation.ThreadSafe;
import org.apache.http.auth.AuthScheme;
import org.apache.http.auth.AuthState;
import org.apache.http.client.RedirectException;
import org.apache.http.client.RedirectStrategy;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.conn.routing.HttpRoutePlanner;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;
import org.apache.http.util.EntityUtils;

@ThreadSafe public class RedirectExec implements ClientExecChain {
    private final Log log;
    private final RedirectStrategy redirectStrategy;
    private final ClientExecChain requestExecutor;
    private final HttpRoutePlanner routePlanner;

    public RedirectExec(ClientExecChain arg2, HttpRoutePlanner arg3, RedirectStrategy arg4) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "HTTP client request executor");
        Args.notNull(arg3, "HTTP route planner");
        Args.notNull(arg4, "HTTP redirect strategy");
        this.requestExecutor = arg2;
        this.routePlanner = arg3;
        this.redirectStrategy = arg4;
    }

    public CloseableHttpResponse execute(HttpRoute arg12, HttpRequestWrapper arg13, HttpClientContext arg14, HttpExecutionAware arg15) {
        CloseableHttpResponse v6;
        Args.notNull(arg12, "HTTP route");
        Args.notNull(arg13, "HTTP request");
        Args.notNull(arg14, "HTTP context");
        List v1 = arg14.getRedirectLocations();
        if(v1 != null) {
            v1.clear();
        }

        RequestConfig v5 = arg14.getRequestConfig();
        int v3 = v5.getMaxRedirects() > 0 ? v5.getMaxRedirects() : 50;
        int v1_1 = 0;
        HttpRequestWrapper v2 = arg13;
        while(true) {
            v6 = this.requestExecutor.execute(arg12, v2, arg14, arg15);
            try {
                if((v5.isRedirectsEnabled()) && (this.redirectStrategy.isRedirected(((HttpRequest)v2), ((HttpResponse)v6), ((HttpContext)arg14)))) {
                    if(v1_1 >= v3) {
                        throw new RedirectException("Maximum redirects (" + v3 + ") exceeded");
                    }
                    else {
                        goto label_41;
                    }
                }

                return v6;
            }
            catch(IOException v1_2) {
                goto label_69;
            }
            catch(RuntimeException v1_3) {
                goto label_36;
            }
            catch(HttpException v1_4) {
                goto label_112;
            }

        label_41:
            int v4 = v1_1 + 1;
            try {
                HttpUriRequest v1_5 = this.redirectStrategy.getRedirect(((HttpRequest)v2), ((HttpResponse)v6), ((HttpContext)arg14));
                if(!((HttpRequest)v1_5).headerIterator().hasNext()) {
                    ((HttpRequest)v1_5).setHeaders(arg13.getOriginal().getAllHeaders());
                }

                v2 = HttpRequestWrapper.wrap(((HttpRequest)v1_5));
                if((v2 instanceof HttpEntityEnclosingRequest)) {
                    RequestEntityProxy.enhance(v2);
                }

                URI v1_6 = v2.getURI();
                HttpHost v7 = URIUtils.extractHost(v1_6);
                if(v7 == null) {
                    throw new ProtocolException("Redirect URI does not specify a valid host name: " + v1_6);
                }

                if(!arg12.getTargetHost().equals(v7)) {
                    AuthState v8 = arg14.getTargetAuthState();
                    if(v8 != null) {
                        this.log.debug("Resetting target auth state");
                        v8.reset();
                    }

                    v8 = arg14.getProxyAuthState();
                    if(v8 == null) {
                        goto label_90;
                    }

                    AuthScheme v9 = v8.getAuthScheme();
                    if(v9 == null) {
                        goto label_90;
                    }

                    if(!v9.isConnectionBased()) {
                        goto label_90;
                    }

                    this.log.debug("Resetting proxy auth state");
                    v8.reset();
                }

            label_90:
                arg12 = this.routePlanner.determineRoute(v7, ((HttpRequest)v2), ((HttpContext)arg14));
                if(this.log.isDebugEnabled()) {
                    this.log.debug("Redirecting to \'" + v1_6 + "\' via " + arg12);
                }

                EntityUtils.consume(v6.getEntity());
                v6.close();
                v1_1 = v4;
                continue;
            }
            catch(HttpException v1_4) {
                try {
                label_112:
                    EntityUtils.consume(v6.getEntity());
                }
                catch(Throwable v1_7) {
                label_123:
                    v6.close();
                    throw v1_7;
                }
                catch(IOException v2_1) {
                    try {
                        this.log.debug("I/O error while releasing connection", ((Throwable)v2_1));
                    }
                    catch(Throwable v1_7) {
                        goto label_123;
                    }

                    v6.close();
                    goto label_115;
                }

                v6.close();
            label_115:
                throw v1_4;
            }
            catch(IOException v1_2) {
            label_69:
                v6.close();
                throw v1_2;
            }
            catch(RuntimeException v1_3) {
            label_36:
                v6.close();
                throw v1_3;
            }
        }

        return v6;
    }
}

