// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.apache.http.impl.execchain;

import java.io.InterruptedIOException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.annotation.Immutable;
import org.apache.http.client.ServiceUnavailableRetryStrategy;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpExecutionAware;
import org.apache.http.client.methods.HttpRequestWrapper;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.Args;

@Immutable public class ServiceUnavailableRetryExec implements ClientExecChain {
    private final Log log;
    private final ClientExecChain requestExecutor;
    private final ServiceUnavailableRetryStrategy retryStrategy;

    public ServiceUnavailableRetryExec(ClientExecChain arg2, ServiceUnavailableRetryStrategy arg3) {
        super();
        this.log = LogFactory.getLog(this.getClass());
        Args.notNull(arg2, "HTTP request executor");
        Args.notNull(arg3, "Retry strategy");
        this.requestExecutor = arg2;
        this.retryStrategy = arg3;
    }

    public CloseableHttpResponse execute(HttpRoute arg9, HttpRequestWrapper arg10, HttpClientContext arg11, HttpExecutionAware arg12) {
        CloseableHttpResponse v2;
        Header[] v1 = arg10.getAllHeaders();
        int v0 = 1;
        while(true) {
            v2 = this.requestExecutor.execute(arg9, arg10, arg11, arg12);
            try {
                if(!this.retryStrategy.retryRequest(((HttpResponse)v2), v0, ((HttpContext)arg11))) {
                    return v2;
                }

                v2.close();
                long v3 = this.retryStrategy.getRetryInterval();
                if(v3 > 0) {
                    try {
                        this.log.trace("Wait for " + v3);
                        Thread.sleep(v3);
                    }
                    catch(InterruptedException v0_2) {
                        Thread.currentThread().interrupt();
                        throw new InterruptedIOException();
                    }
                }

                arg10.setHeaders(v1);
                ++v0;
                continue;
            }
            catch(RuntimeException v0_1) {
                v2.close();
                throw v0_1;
            }
        }

        return v2;
    }
}

