// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayInputStream;
import java.io.EOFException;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import org.bouncycastle.util.io.Streams;

public class ASN1InputStream extends FilterInputStream implements BERTags {
    private final boolean lazyEvaluate;
    private final int limit;
    private final byte[][] tmpBuffers;

    public ASN1InputStream(byte[] arg3) {
        this(new ByteArrayInputStream(arg3), arg3.length);
    }

    public ASN1InputStream(InputStream arg2) {
        this(arg2, StreamUtil.findLimit(arg2));
    }

    public ASN1InputStream(InputStream arg2, int arg3) {
        this(arg2, arg3, false);
    }

    public ASN1InputStream(InputStream arg2, int arg3, boolean arg4) {
        super(arg2);
        this.limit = arg3;
        this.lazyEvaluate = arg4;
        this.tmpBuffers = new byte[11][];
    }

    public ASN1InputStream(InputStream arg2, boolean arg3) {
        this(arg2, StreamUtil.findLimit(arg2), arg3);
    }

    public ASN1InputStream(byte[] arg3, boolean arg4) {
        this(new ByteArrayInputStream(arg3), arg3.length, arg4);
    }

    ASN1EncodableVector buildDEREncodableVector(DefiniteLengthInputStream arg2) {
        return new ASN1InputStream(((InputStream)arg2)).buildEncodableVector();
    }

    ASN1EncodableVector buildEncodableVector() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        while(true) {
            ASN1Primitive v1 = this.readObject();
            if(v1 == null) {
                return v0;
            }

            v0.add(((ASN1Encodable)v1));
        }

        return v0;
    }

    protected ASN1Primitive buildObject(int arg5, int arg6, int arg7) {
        DERExternal v0_7;
        ASN1Primitive v0_2;
        int v1 = 0;
        boolean v0 = (arg5 & 32) != 0 ? true : false;
        DefiniteLengthInputStream v2 = new DefiniteLengthInputStream(((InputStream)this), arg7);
        if((arg5 & 64) != 0) {
            DERApplicationSpecific v0_1 = new DERApplicationSpecific(v0, arg6, v2.toByteArray());
        }
        else if((arg5 & 128) != 0) {
            v0_2 = new ASN1StreamParser(((InputStream)v2)).readTaggedObject(v0, arg6);
        }
        else if(v0) {
            switch(arg6) {
                case 4: {
                    goto label_34;
                }
                case 8: {
                    goto label_58;
                }
                case 16: {
                    goto label_46;
                }
                case 17: {
                    goto label_55;
                }
            }

            throw new IOException("unknown tag " + arg6 + " encountered");
        label_55:
            ASN1Set v0_3 = DERFactory.createSet(this.buildDEREncodableVector(v2));
            goto label_12;
        label_34:
            ASN1EncodableVector v2_1 = this.buildDEREncodableVector(v2);
            ASN1OctetString[] v3 = new ASN1OctetString[v2_1.size()];
            while(v1 != v3.length) {
                v3[v1] = v2_1.get(v1);
                ++v1;
            }

            BEROctetString v0_4 = new BEROctetString(v3);
            goto label_12;
        label_46:
            if(this.lazyEvaluate) {
                LazyEncodedSequence v0_5 = new LazyEncodedSequence(v2.toByteArray());
            }
            else {
                ASN1Sequence v0_6 = DERFactory.createSequence(this.buildDEREncodableVector(v2));
                goto label_12;
            label_58:
                v0_7 = new DERExternal(this.buildDEREncodableVector(v2));
            }
        }
        else {
            v0_2 = ASN1InputStream.createPrimitiveDERObject(arg6, v2, this.tmpBuffers);
        }

    label_12:
        return ((ASN1Primitive)v0_7);
    }

    static ASN1Primitive createPrimitiveDERObject(int arg3, DefiniteLengthInputStream arg4, byte[][] arg5) {
        switch(arg3) {
            case 1: {
                goto label_19;
            }
            case 2: {
                goto label_37;
            }
            case 3: {
                goto label_12;
            }
            case 4: {
                goto label_50;
            }
            case 5: {
                goto label_41;
            }
            case 6: {
                goto label_47;
            }
            case 10: {
                goto label_22;
            }
            case 12: {
                goto label_70;
            }
            case 18: {
                goto label_43;
            }
            case 19: {
                goto label_54;
            }
            case 20: {
                goto label_58;
            }
            case 22: {
                goto label_33;
            }
            case 23: {
                goto label_66;
            }
            case 24: {
                goto label_25;
            }
            case 26: {
                goto label_74;
            }
            case 27: {
                goto label_29;
            }
            case 28: {
                goto label_62;
            }
            case 30: {
                goto label_15;
            }
        }

        throw new IOException("unknown tag " + arg3 + " encountered");
    label_37:
        ASN1Integer v0 = new ASN1Integer(arg4.toByteArray());
        goto label_14;
    label_70:
        DERUTF8String v0_1 = new DERUTF8String(arg4.toByteArray());
        goto label_14;
    label_33:
        DERIA5String v0_2 = new DERIA5String(arg4.toByteArray());
        goto label_14;
    label_66:
        ASN1UTCTime v0_3 = new ASN1UTCTime(arg4.toByteArray());
        goto label_14;
    label_12:
        DERBitString v0_4 = DERBitString.fromInputStream(arg4.getRemaining(), ((InputStream)arg4));
        goto label_14;
    label_47:
        ASN1ObjectIdentifier v0_5 = ASN1ObjectIdentifier.fromOctetString(ASN1InputStream.getBuffer(arg4, arg5));
        goto label_14;
    label_15:
        DERBMPString v0_6 = new DERBMPString(ASN1InputStream.getBMPCharBuffer(arg4));
        goto label_14;
    label_41:
        DERNull v0_7 = DERNull.INSTANCE;
        goto label_14;
    label_43:
        DERNumericString v0_8 = new DERNumericString(arg4.toByteArray());
        goto label_14;
    label_74:
        DERVisibleString v0_9 = new DERVisibleString(arg4.toByteArray());
        goto label_14;
    label_54:
        DERPrintableString v0_10 = new DERPrintableString(arg4.toByteArray());
        goto label_14;
    label_19:
        ASN1Boolean v0_11 = ASN1Boolean.fromOctetString(ASN1InputStream.getBuffer(arg4, arg5));
        goto label_14;
    label_50:
        DEROctetString v0_12 = new DEROctetString(arg4.toByteArray());
        goto label_14;
    label_22:
        ASN1Enumerated v0_13 = ASN1Enumerated.fromOctetString(ASN1InputStream.getBuffer(arg4, arg5));
        goto label_14;
    label_62:
        DERUniversalString v0_14 = new DERUniversalString(arg4.toByteArray());
        goto label_14;
    label_25:
        ASN1GeneralizedTime v0_15 = new ASN1GeneralizedTime(arg4.toByteArray());
        goto label_14;
    label_58:
        DERT61String v0_16 = new DERT61String(arg4.toByteArray());
        goto label_14;
    label_29:
        DERGeneralString v0_17 = new DERGeneralString(arg4.toByteArray());
    label_14:
        return ((ASN1Primitive)v0_16);
    }

    private static char[] getBMPCharBuffer(DefiniteLengthInputStream arg6) {
        int v2 = arg6.getRemaining() / 2;
        char[] v3 = new char[v2];
        int v0;
        for(v0 = 0; v0 < v2; ++v0) {
            int v4 = arg6.read();
            if(v4 < 0) {
                return v3;
            }

            int v5 = arg6.read();
            if(v5 < 0) {
                return v3;
            }

            v3[v0] = ((char)(v4 << 8 | v5 & 255));
        }

        return v3;
    }

    private static byte[] getBuffer(DefiniteLengthInputStream arg3, byte[][] arg4) {
        byte[] v0;
        int v1 = arg3.getRemaining();
        if(arg3.getRemaining() < arg4.length) {
            v0 = arg4[v1];
            if(v0 == null) {
                v0 = new byte[v1];
                arg4[v1] = v0;
            }

            Streams.readFully(((InputStream)arg3), v0);
        }
        else {
            v0 = arg3.toByteArray();
        }

        return v0;
    }

    int getLimit() {
        return this.limit;
    }

    protected void readFully(byte[] arg3) {
        if(Streams.readFully(((InputStream)this), arg3) != arg3.length) {
            throw new EOFException("EOF encountered in middle of object");
        }
    }

    static int readLength(InputStream arg4, int arg5) {
        int v1 = 0;
        int v0 = arg4.read();
        if(v0 < 0) {
            throw new EOFException("EOF found when length expected");
        }

        if(v0 == 128) {
            v0 = -1;
        }
        else if(v0 > 127) {
            int v3 = v0 & 127;
            if(v3 > 4) {
                throw new IOException("DER length more than 4 bytes: " + v3);
            }
            else {
                v0 = 0;
                while(true) {
                    if(v1 < v3) {
                        int v2 = arg4.read();
                        if(v2 < 0) {
                            throw new EOFException("EOF found reading length");
                        }
                        else {
                            ++v1;
                            v0 = v2 + (v0 << 8);
                            continue;
                        }
                    }
                    else {
                        break;
                    }

                    return v0;
                }

                if(v0 < 0) {
                    throw new IOException("corrupted stream - negative length found");
                }
                else if(v0 >= arg5) {
                    throw new IOException("corrupted stream - out of bounds length found");
                }
            }
        }

        return v0;
    }

    protected int readLength() {
        return ASN1InputStream.readLength(((InputStream)this), this.limit);
    }

    public ASN1Primitive readObject() {
        ASN1Primitive v0;
        int v2 = this.read();
        if(v2 > 0) {
            int v3 = ASN1InputStream.readTagNumber(((InputStream)this), v2);
            int v0_1 = (v2 & 32) != 0 ? 1 : 0;
            int v4 = this.readLength();
            if(v4 >= 0) {
                goto label_62;
            }

            if(v0_1 == 0) {
                throw new IOException("indefinite length primitive encoding encountered");
            }

            ASN1StreamParser v4_1 = new ASN1StreamParser(new IndefiniteLengthInputStream(((InputStream)this), this.limit), this.limit);
            if((v2 & 64) != 0) {
                return new BERApplicationSpecificParser(v3, v4_1).getLoadedObject();
            }

            if((v2 & 128) != 0) {
                return new BERTaggedObjectParser(true, v3, v4_1).getLoadedObject();
            }

            switch(v3) {
                case 4: {
                    goto label_46;
                }
                case 8: {
                    goto label_58;
                }
                case 16: {
                    goto label_50;
                }
                case 17: {
                    goto label_54;
                }
            }

            throw new IOException("unknown BER object encountered");
        label_54:
            return new BERSetParser(v4_1).getLoadedObject();
        label_50:
            return new BERSequenceParser(v4_1).getLoadedObject();
        label_46:
            return new BEROctetStringParser(v4_1).getLoadedObject();
        label_58:
            return new DERExternalParser(v4_1).getLoadedObject();
            try {
            label_62:
                v0 = this.buildObject(v2, v3, v4);
            }
            catch(IllegalArgumentException v0_2) {
                throw new ASN1Exception("corrupted stream detected", ((Throwable)v0_2));
            }
        }
        else if(v2 == 0) {
            throw new IOException("unexpected end-of-contents marker");
        }
        else {
            v0 = null;
        }

        return v0;
    }

    static int readTagNumber(InputStream arg3, int arg4) {
        int v0 = arg4 & 31;
        if(v0 == 31) {
            int v1 = 0;
            v0 = arg3.read();
            if((v0 & 127) == 0) {
                throw new IOException("corrupted stream - invalid high tag number found");
            }

            while(v0 >= 0) {
                if((v0 & 128) == 0) {
                    break;
                }

                v1 = (v0 & 127 | v1) << 7;
                v0 = arg3.read();
            }

            if(v0 < 0) {
                throw new EOFException("EOF found inside tag value.");
            }

            v0 = v0 & 127 | v1;
        }

        return v0;
    }
}

