// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.encoders.Hex;

public abstract class ASN1OctetString extends ASN1Primitive implements ASN1OctetStringParser {
    byte[] string;

    public ASN1OctetString(byte[] arg3) {
        super();
        if(arg3 == null) {
            throw new NullPointerException("string cannot be null");
        }

        this.string = arg3;
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof ASN1OctetString) ? false : Arrays.areEqual(this.string, ((ASN1OctetString)arg3).string);
        return v0;
    }

    abstract void encode(ASN1OutputStream arg1);

    public static ASN1OctetString getInstance(Object arg4) {
        Object v0_3;
        if(arg4 == null || ((arg4 instanceof ASN1OctetString))) {
            v0_3 = arg4;
        }
        else if((arg4 instanceof byte[])) {
            try {
                ASN1OctetString v0_1 = ASN1OctetString.getInstance(ASN1Primitive.fromByteArray(((byte[])arg4)));
            }
            catch(IOException v0) {
                throw new IllegalArgumentException("failed to construct OCTET STRING from byte[]: " + v0.getMessage());
            }
        }
        else {
            if((arg4 instanceof ASN1Encodable)) {
                ASN1Primitive v0_2 = arg4.toASN1Primitive();
                if((v0_2 instanceof ASN1OctetString)) {
                    goto label_4;
                }
            }

            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

    label_4:
        return ((ASN1OctetString)v0_3);
    }

    public static ASN1OctetString getInstance(ASN1TaggedObject arg2, boolean arg3) {
        BEROctetString v0_1;
        ASN1Primitive v0 = arg2.getObject();
        if((arg3) || ((v0 instanceof ASN1OctetString))) {
            ASN1OctetString v0_2 = ASN1OctetString.getInstance(v0);
        }
        else {
            v0_1 = BEROctetString.fromSequence(ASN1Sequence.getInstance(v0));
        }

        return ((ASN1OctetString)v0_1);
    }

    public ASN1Primitive getLoadedObject() {
        return this.toASN1Primitive();
    }

    public InputStream getOctetStream() {
        return new ByteArrayInputStream(this.string);
    }

    public byte[] getOctets() {
        return this.string;
    }

    public int hashCode() {
        return Arrays.hashCode(this.getOctets());
    }

    public ASN1OctetStringParser parser() {
        return this;
    }

    ASN1Primitive toDERObject() {
        return new DEROctetString(this.string);
    }

    ASN1Primitive toDLObject() {
        return new DEROctetString(this.string);
    }

    public String toString() {
        return "#" + new String(Hex.encode(this.string));
    }
}

