// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.IOException;
import java.io.OutputStream;

public class ASN1OutputStream {
    private OutputStream os;

    public ASN1OutputStream(OutputStream arg1) {
        super();
        this.os = arg1;
    }

    public void close() {
        this.os.close();
    }

    public void flush() {
        this.os.flush();
    }

    ASN1OutputStream getDERSubStream() {
        return new DEROutputStream(this.os);
    }

    ASN1OutputStream getDLSubStream() {
        return new DLOutputStream(this.os);
    }

    void write(int arg2) {
        this.os.write(arg2);
    }

    void write(byte[] arg2) {
        this.os.write(arg2);
    }

    void write(byte[] arg2, int arg3, int arg4) {
        this.os.write(arg2, arg3, arg4);
    }

    void writeEncoded(int arg2, byte[] arg3) {
        this.write(arg2);
        this.writeLength(arg3.length);
        this.write(arg3);
    }

    void writeEncoded(int arg2, int arg3, byte[] arg4) {
        this.writeTag(arg2, arg3);
        this.writeLength(arg4.length);
        this.write(arg4);
    }

    void writeImplicitObject(ASN1Primitive arg3) {
        if(arg3 != null) {
            arg3.encode(new ASN1OutputStream$ImplicitOutputStream(this, this.os));
            return;
        }

        throw new IOException("null object detected");
    }

    void writeLength(int arg3) {
        if(arg3 > 127) {
            int v1 = 1;
            int v0 = arg3;
            while(true) {
                v0 >>>= 8;
                if(v0 == 0) {
                    break;
                }

                ++v1;
            }

            this.write(((byte)(v1 | 128)));
            for(v0 = (v1 - 1) * 8; v0 >= 0; v0 += -8) {
                this.write(((byte)(arg3 >> v0)));
            }
        }
        else {
            this.write(((byte)arg3));
        }
    }

    protected void writeNull() {
        this.os.write(5);
        this.os.write(0);
    }

    public void writeObject(ASN1Encodable arg3) {
        if(arg3 != null) {
            arg3.toASN1Primitive().encode(this);
            return;
        }

        throw new IOException("null object detected");
    }

    void writeTag(int arg4, int arg5) {
        if(arg5 < 31) {
            this.write(arg4 | arg5);
        }
        else {
            this.write(arg4 | 31);
            if(arg5 < 128) {
                this.write(arg5);
            }
            else {
                byte[] v1 = new byte[5];
                int v0 = v1.length - 1;
                v1[v0] = ((byte)(arg5 & 127));
                do {
                    arg5 >>= 7;
                    --v0;
                    v1[v0] = ((byte)(arg5 & 127 | 128));
                }
                while(arg5 > 127);

                this.write(v1, v0, v1.length - v0);
            }
        }
    }
}

