// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public abstract class ASN1Sequence extends ASN1Primitive {
    protected Vector seq;

    protected ASN1Sequence() {
        super();
        this.seq = new Vector();
    }

    protected ASN1Sequence(ASN1Encodable arg2) {
        super();
        this.seq = new Vector();
        this.seq.addElement(arg2);
    }

    protected ASN1Sequence(ASN1EncodableVector arg4) {
        super();
        this.seq = new Vector();
        int v0;
        for(v0 = 0; v0 != arg4.size(); ++v0) {
            this.seq.addElement(arg4.get(v0));
        }
    }

    protected ASN1Sequence(ASN1Encodable[] arg4) {
        super();
        this.seq = new Vector();
        int v0;
        for(v0 = 0; v0 != arg4.length; ++v0) {
            this.seq.addElement(arg4[v0]);
        }
    }

    boolean asn1Equals(ASN1Primitive arg6) {
        boolean v0 = false;
        if(((arg6 instanceof ASN1Sequence)) && this.size() == ((ASN1Sequence)arg6).size()) {
            Enumeration v1 = this.getObjects();
            Enumeration v2 = ((ASN1Sequence)arg6).getObjects();
            while(true) {
                if(v1.hasMoreElements()) {
                    ASN1Encodable v3 = this.getNext(v1);
                    ASN1Encodable v4 = this.getNext(v2);
                    ASN1Primitive v3_1 = v3.toASN1Primitive();
                    ASN1Primitive v4_1 = v4.toASN1Primitive();
                    if(v3_1 == v4_1) {
                        continue;
                    }

                    if(v3_1.equals(v4_1)) {
                        continue;
                    }
                }
                else {
                    break;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    abstract void encode(ASN1OutputStream arg1);

    public static ASN1Sequence getInstance(Object arg4) {
        ASN1Sequence v0;
        Object v0_3;
        if(arg4 == null || ((arg4 instanceof ASN1Sequence))) {
            v0_3 = arg4;
        }
        else if((arg4 instanceof ASN1SequenceParser)) {
            v0 = ASN1Sequence.getInstance(((ASN1SequenceParser)arg4).toASN1Primitive());
        }
        else if((arg4 instanceof byte[])) {
            try {
                v0 = ASN1Sequence.getInstance(ASN1Sequence.fromByteArray(((byte[])arg4)));
            }
            catch(IOException v0_1) {
                throw new IllegalArgumentException("failed to construct sequence from byte[]: " + v0_1.getMessage());
            }
        }
        else {
            if((arg4 instanceof ASN1Encodable)) {
                ASN1Primitive v0_2 = arg4.toASN1Primitive();
                if((v0_2 instanceof ASN1Sequence)) {
                    goto label_4;
                }
            }

            throw new IllegalArgumentException("unknown object in getInstance: " + arg4.getClass().getName());
        }

    label_4:
        return ((ASN1Sequence)v0_3);
    }

    public static ASN1Sequence getInstance(ASN1TaggedObject arg3, boolean arg4) {
        DLSequence v0_2;
        if(arg4) {
            if(!arg3.isExplicit()) {
                throw new IllegalArgumentException("object implicit - explicit expected.");
            }
            else {
                ASN1Sequence v0 = ASN1Sequence.getInstance(arg3.getObject().toASN1Primitive());
            }
        }
        else if(arg3.isExplicit()) {
            if((arg3 instanceof BERTaggedObject)) {
                BERSequence v0_1 = new BERSequence(arg3.getObject());
            }
            else {
                v0_2 = new DLSequence(arg3.getObject());
            }
        }
        else if((arg3.getObject() instanceof ASN1Sequence)) {
            ASN1Primitive v0_3 = arg3.getObject();
        }
        else {
            goto label_28;
        }

        return ((ASN1Sequence)v0_2);
    label_28:
        throw new IllegalArgumentException("unknown object in getInstance: " + arg3.getClass().getName());
    }

    private ASN1Encodable getNext(Enumeration arg2) {
        return arg2.nextElement();
    }

    public ASN1Encodable getObjectAt(int arg2) {
        return this.seq.elementAt(arg2);
    }

    public Enumeration getObjects() {
        return this.seq.elements();
    }

    public int hashCode() {
        Enumeration v1 = this.getObjects();
        int v0;
        for(v0 = this.size(); v1.hasMoreElements(); v0 = v0 * 17 ^ this.getNext(v1).hashCode()) {
        }

        return v0;
    }

    boolean isConstructed() {
        return 1;
    }

    public ASN1SequenceParser parser() {
        return new ASN1Sequence$1(this, this);
    }

    public int size() {
        return this.seq.size();
    }

    public ASN1Encodable[] toArray() {
        ASN1Encodable[] v1 = new ASN1Encodable[this.size()];
        int v0;
        for(v0 = 0; v0 != this.size(); ++v0) {
            v1[v0] = this.getObjectAt(v0);
        }

        return v1;
    }

    ASN1Primitive toDERObject() {
        DERSequence v0 = new DERSequence();
        ((ASN1Sequence)v0).seq = this.seq;
        return ((ASN1Primitive)v0);
    }

    ASN1Primitive toDLObject() {
        DLSequence v0 = new DLSequence();
        ((ASN1Sequence)v0).seq = this.seq;
        return ((ASN1Primitive)v0);
    }

    public String toString() {
        return this.seq.toString();
    }
}

