// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.Vector;

public abstract class ASN1Set extends ASN1Primitive {
    private boolean isSorted;
    private Vector set;

    protected ASN1Set() {
        super();
        this.set = new Vector();
        this.isSorted = false;
    }

    protected ASN1Set(ASN1Encodable arg2) {
        super();
        this.set = new Vector();
        this.isSorted = false;
        this.set.addElement(arg2);
    }

    protected ASN1Set(ASN1EncodableVector arg4, boolean arg5) {
        int v0 = 0;
        super();
        this.set = new Vector();
        this.isSorted = false;
        while(v0 != arg4.size()) {
            this.set.addElement(arg4.get(v0));
            ++v0;
        }

        if(arg5) {
            this.sort();
        }
    }

    protected ASN1Set(ASN1Encodable[] arg4, boolean arg5) {
        int v0 = 0;
        super();
        this.set = new Vector();
        this.isSorted = false;
        while(v0 != arg4.length) {
            this.set.addElement(arg4[v0]);
            ++v0;
        }

        if(arg5) {
            this.sort();
        }
    }

    boolean asn1Equals(ASN1Primitive arg6) {
        boolean v0 = false;
        if(((arg6 instanceof ASN1Set)) && this.size() == ((ASN1Set)arg6).size()) {
            Enumeration v1 = this.getObjects();
            Enumeration v2 = ((ASN1Set)arg6).getObjects();
            while(true) {
                if(v1.hasMoreElements()) {
                    ASN1Encodable v3 = this.getNext(v1);
                    ASN1Encodable v4 = this.getNext(v2);
                    ASN1Primitive v3_1 = v3.toASN1Primitive();
                    ASN1Primitive v4_1 = v4.toASN1Primitive();
                    if(v3_1 == v4_1) {
                        continue;
                    }

                    if(v3_1.equals(v4_1)) {
                        continue;
                    }
                }
                else {
                    break;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    abstract void encode(ASN1OutputStream arg1);

    private byte[] getEncoded(ASN1Encodable arg3) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        ASN1OutputStream v1 = new ASN1OutputStream(((OutputStream)v0));
        try {
            v1.writeObject(arg3);
        }
        catch(IOException v0_1) {
            throw new IllegalArgumentException("cannot encode object added to SET");
        }

        return v0.toByteArray();
    }

    public static ASN1Set getInstance(Object arg4) {
        ASN1Set v0;
        if(arg4 == null || ((arg4 instanceof ASN1Set))) {
            Object v0_3 = arg4;
        }
        else if((arg4 instanceof ASN1SetParser)) {
            v0 = ASN1Set.getInstance(((ASN1SetParser)arg4).toASN1Primitive());
        }
        else if((arg4 instanceof byte[])) {
            try {
                v0 = ASN1Set.getInstance(ASN1Primitive.fromByteArray(((byte[])arg4)));
            }
            catch(IOException v0_1) {
                throw new IllegalArgumentException("failed to construct set from byte[]: " + v0_1.getMessage());
            }
        }
        else {
            if((arg4 instanceof ASN1Encodable)) {
                ASN1Primitive v0_2 = arg4.toASN1Primitive();
                if((v0_2 instanceof ASN1Set)) {
                    return v0;
                }
            }

            throw new IllegalArgumentException("unknown object in getInstance: " + arg4.getClass().getName());
        }

        return v0;
    }

    public static ASN1Set getInstance(ASN1TaggedObject arg3, boolean arg4) {
        DLSet v0_2;
        BERSet v0_1;
        ASN1Primitive v0;
        if(arg4) {
            if(!arg3.isExplicit()) {
                throw new IllegalArgumentException("object implicit - explicit expected.");
            }
            else {
                v0 = arg3.getObject();
            }
        }
        else if(arg3.isExplicit()) {
            if((arg3 instanceof BERTaggedObject)) {
                v0_1 = new BERSet(arg3.getObject());
            }
            else {
                v0_2 = new DLSet(arg3.getObject());
            }
        }
        else if((arg3.getObject() instanceof ASN1Set)) {
            v0 = arg3.getObject();
        }
        else if((arg3.getObject() instanceof ASN1Sequence)) {
            v0 = arg3.getObject();
            if((arg3 instanceof BERTaggedObject)) {
                v0_1 = new BERSet(((ASN1Sequence)v0).toArray());
            }
            else {
                v0_2 = new DLSet(((ASN1Sequence)v0).toArray());
            }
        }
        else {
            goto label_42;
        }

        return ((ASN1Set)v0_1);
    label_42:
        throw new IllegalArgumentException("unknown object in getInstance: " + arg3.getClass().getName());
    }

    private ASN1Encodable getNext(Enumeration arg2) {
        DERNull v0_1;
        Object v0 = arg2.nextElement();
        if(v0 == null) {
            v0_1 = DERNull.INSTANCE;
        }

        return ((ASN1Encodable)v0_1);
    }

    public ASN1Encodable getObjectAt(int arg2) {
        return this.set.elementAt(arg2);
    }

    public Enumeration getObjects() {
        return this.set.elements();
    }

    public int hashCode() {
        Enumeration v1 = this.getObjects();
        int v0;
        for(v0 = this.size(); v1.hasMoreElements(); v0 = v0 * 17 ^ this.getNext(v1).hashCode()) {
        }

        return v0;
    }

    boolean isConstructed() {
        return 1;
    }

    private boolean lessThanOrEqual(byte[] arg7, byte[] arg8) {
        boolean v0 = true;
        int v3 = Math.min(arg7.length, arg8.length);
        int v2 = 0;
        while(true) {
            if(v2 == v3) {
                break;
            }
            else if(arg7[v2] == arg8[v2]) {
                ++v2;
                continue;
            }
            else if((arg7[v2] & 255) >= (arg8[v2] & 255)) {
                v0 = false;
            }

            return v0;
        }

        if(v3 != arg7.length) {
            v0 = false;
        }

        return v0;
    }

    public ASN1SetParser parser() {
        return new ASN1Set$1(this, this);
    }

    public int size() {
        return this.set.size();
    }

    protected void sort() {
        int v1_1;
        if(!this.isSorted) {
            this.isSorted = true;
            if(this.set.size() > 1) {
                int v7 = this.set.size() - 1;
                int v4 = 1;
                while(v4 != 0) {
                    byte[] v1 = this.getEncoded(this.set.elementAt(0));
                    int v2 = 0;
                    int v3 = 0;
                    v4 = 0;
                    while(v3 != v7) {
                        byte[] v0 = this.getEncoded(this.set.elementAt(v3 + 1));
                        if(this.lessThanOrEqual(v1, v0)) {
                            v1_1 = v2;
                            v2 = v4;
                        }
                        else {
                            Object v0_1 = this.set.elementAt(v3);
                            this.set.setElementAt(this.set.elementAt(v3 + 1), v3);
                            this.set.setElementAt(v0_1, v3 + 1);
                            v0 = v1;
                            v2 = 1;
                            v1_1 = v3;
                        }

                        ++v3;
                        v4 = v2;
                        v2 = v1_1;
                        v1 = v0;
                    }

                    v7 = v2;
                }
            }
        }
    }

    public ASN1Encodable[] toArray() {
        ASN1Encodable[] v1 = new ASN1Encodable[this.size()];
        int v0;
        for(v0 = 0; v0 != this.size(); ++v0) {
            v1[v0] = this.getObjectAt(v0);
        }

        return v1;
    }

    ASN1Primitive toDERObject() {
        DERSet v0;
        if(this.isSorted) {
            v0 = new DERSet();
            ((ASN1Set)v0).set = this.set;
        }
        else {
            Vector v1 = new Vector();
            int v0_1;
            for(v0_1 = 0; v0_1 != this.set.size(); ++v0_1) {
                v1.addElement(this.set.elementAt(v0_1));
            }

            v0 = new DERSet();
            ((ASN1Set)v0).set = v1;
            ((ASN1Set)v0).sort();
        }

        return ((ASN1Primitive)v0);
    }

    ASN1Primitive toDLObject() {
        DLSet v0 = new DLSet();
        ((ASN1Set)v0).set = this.set;
        return ((ASN1Primitive)v0);
    }

    public String toString() {
        return this.set.toString();
    }
}

