// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

public class ASN1StreamParser {
    private final InputStream _in;
    private final int _limit;
    private final byte[][] tmpBuffers;

    public ASN1StreamParser(InputStream arg2) {
        this(arg2, StreamUtil.findLimit(arg2));
    }

    public ASN1StreamParser(InputStream arg2, int arg3) {
        super();
        this._in = arg2;
        this._limit = arg3;
        this.tmpBuffers = new byte[11][];
    }

    public ASN1StreamParser(byte[] arg3) {
        this(new ByteArrayInputStream(arg3), arg3.length);
    }

    ASN1Encodable readImplicit(boolean arg3, int arg4) {
        DEROctetStringParser v0_4;
        if(!(this._in instanceof IndefiniteLengthInputStream)) {
            if(arg3) {
                switch(arg4) {
                    case 4: {
                        goto label_22;
                    }
                    case 16: {
                        goto label_19;
                    }
                    case 17: {
                        goto label_16;
                    }
                }

                goto label_12;
            label_19:
                DERSequenceParser v0_1 = new DERSequenceParser(this);
                goto label_9;
            label_22:
                BEROctetStringParser v0_2 = new BEROctetStringParser(this);
                goto label_9;
            label_16:
                DERSetParser v0_3 = new DERSetParser(this);
                goto label_9;
            }
            else {
                switch(arg4) {
                    case 4: {
                        goto label_27;
                    }
                    case 16: {
                        goto label_36;
                    }
                    case 17: {
                        goto label_32;
                    }
                }
            }

        label_12:
            throw new RuntimeException("implicit tagging not implemented");
        label_36:
            throw new ASN1Exception("sets must use constructed encoding (see X.690 8.11.1/8.12.1)");
        label_27:
            v0_4 = new DEROctetStringParser(this._in);
        }
        else if(!arg3) {
            throw new IOException("indefinite length primitive encoding encountered");
        }
        else {
            ASN1Encodable v0 = this.readIndef(arg4);
        }

    label_9:
        return ((ASN1Encodable)v0_4);
    label_32:
        throw new ASN1Exception("sequences must use constructed encoding (see X.690 8.9.1/8.10.1)");
    }

    ASN1Encodable readIndef(int arg4) {
        switch(arg4) {
            case 4: {
                goto label_14;
            }
            case 8: {
                goto label_11;
            }
            case 16: {
                goto label_17;
            }
            case 17: {
                goto label_20;
            }
        }

        throw new ASN1Exception("unknown BER object encountered: 0x" + Integer.toHexString(arg4));
    label_20:
        BERSetParser v0 = new BERSetParser(this);
        goto label_13;
    label_17:
        BERSequenceParser v0_1 = new BERSequenceParser(this);
        goto label_13;
    label_11:
        DERExternalParser v0_2 = new DERExternalParser(this);
        goto label_13;
    label_14:
        BEROctetStringParser v0_3 = new BEROctetStringParser(this);
    label_13:
        return ((ASN1Encodable)v0_3);
    }

    public ASN1Encodable readObject() {
        BERTaggedObjectParser v0_3;
        ASN1Encodable v0_1;
        boolean v0 = false;
        int v2 = this._in.read();
        if(v2 == -1) {
            v0_1 = null;
        }
        else {
            this.set00Check(false);
            int v3 = ASN1InputStream.readTagNumber(this._in, v2);
            if((v2 & 32) != 0) {
                v0 = true;
            }

            int v4 = ASN1InputStream.readLength(this._in, this._limit);
            if(v4 < 0) {
                if(!v0) {
                    throw new IOException("indefinite length primitive encoding encountered");
                }

                ASN1StreamParser v4_1 = new ASN1StreamParser(new IndefiniteLengthInputStream(this._in, this._limit), this._limit);
                if((v2 & 64) != 0) {
                    BERApplicationSpecificParser v0_2 = new BERApplicationSpecificParser(v3, v4_1);
                    return v0_1;
                }

                if((v2 & 128) != 0) {
                    v0_3 = new BERTaggedObjectParser(true, v3, v4_1);
                    return v0_1;
                }

                return v4_1.readIndef(v3);
            }

            DefiniteLengthInputStream v5 = new DefiniteLengthInputStream(this._in, v4);
            if((v2 & 64) != 0) {
                DERApplicationSpecific v0_4 = new DERApplicationSpecific(v0, v3, v5.toByteArray());
                return v0_1;
            }

            if((v2 & 128) != 0) {
                v0_3 = new BERTaggedObjectParser(v0, v3, new ASN1StreamParser(((InputStream)v5)));
                return v0_1;
            }

            if(!v0) {
                goto label_93;
            }

            switch(v3) {
                case 4: {
                    goto label_73;
                }
                case 8: {
                    goto label_88;
                }
                case 16: {
                    goto label_78;
                }
                case 17: {
                    goto label_83;
                }
            }

            throw new IOException("unknown tag " + v3 + " encountered");
        label_88:
            DERExternalParser v0_5 = new DERExternalParser(new ASN1StreamParser(((InputStream)v5)));
            return v0_1;
        label_83:
            DERSetParser v0_6 = new DERSetParser(new ASN1StreamParser(((InputStream)v5)));
            return v0_1;
        label_78:
            DERSequenceParser v0_7 = new DERSequenceParser(new ASN1StreamParser(((InputStream)v5)));
            return v0_1;
        label_73:
            BEROctetStringParser v0_8 = new BEROctetStringParser(new ASN1StreamParser(((InputStream)v5)));
            return v0_1;
        label_93:
            switch(v3) {
                case 4: {
                    goto label_97;
                }
            }

            try {
                ASN1Primitive v0_10 = ASN1InputStream.createPrimitiveDERObject(v3, v5, this.tmpBuffers);
                return v0_1;
            }
            catch(IllegalArgumentException v0_9) {
                throw new ASN1Exception("corrupted stream detected", ((Throwable)v0_9));
            }

        label_97:
            DEROctetStringParser v0_11 = new DEROctetStringParser(v5);
        }

        return v0_1;
    }

    ASN1Primitive readTaggedObject(boolean arg5, int arg6) {
        BERTaggedObject v0_1;
        DERTaggedObject v0;
        if(!arg5) {
            v0 = new DERTaggedObject(false, arg6, new DEROctetString(this._in.toByteArray()));
        }
        else {
            ASN1EncodableVector v1 = this.readVector();
            if((this._in instanceof IndefiniteLengthInputStream)) {
                v0_1 = v1.size() == 1 ? new BERTaggedObject(true, arg6, v1.get(0)) : new BERTaggedObject(false, arg6, BERFactory.createSequence(v1));
            }
            else if(v1.size() == 1) {
                v0 = new DERTaggedObject(true, arg6, v1.get(0));
            }
            else {
                v0 = new DERTaggedObject(false, arg6, DERFactory.createSequence(v1));
            }
        }

        return ((ASN1Primitive)v0_1);
    }

    ASN1EncodableVector readVector() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        while(true) {
            ASN1Encodable v0 = this.readObject();
            if(v0 == null) {
                return v1;
            }

            if((v0 instanceof InMemoryRepresentable)) {
                v1.add(((InMemoryRepresentable)v0).getLoadedObject());
                continue;
            }

            v1.add(v0.toASN1Primitive());
        }

        return v1;
    }

    private void set00Check(boolean arg2) {
        if((this._in instanceof IndefiniteLengthInputStream)) {
            this._in.setEofOn00(arg2);
        }
    }
}

