// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.IOException;

public abstract class ASN1TaggedObject extends ASN1Primitive implements ASN1TaggedObjectParser {
    boolean empty;
    boolean explicit;
    ASN1Encodable obj;
    int tagNo;

    public ASN1TaggedObject(boolean arg3, int arg4, ASN1Encodable arg5) {
        super();
        this.empty = false;
        this.explicit = true;
        this.obj = null;
        this.explicit = (arg5 instanceof ASN1Choice) ? true : arg3;
        this.tagNo = arg4;
        if(this.explicit) {
            this.obj = arg5;
        }
        else {
            arg5.toASN1Primitive();
            this.obj = arg5;
        }
    }

    boolean asn1Equals(ASN1Primitive arg4) {
        boolean v0 = false;
        if(((arg4 instanceof ASN1TaggedObject)) && this.tagNo == ((ASN1TaggedObject)arg4).tagNo && this.empty == ((ASN1TaggedObject)arg4).empty && this.explicit == ((ASN1TaggedObject)arg4).explicit) {
            if(this.obj == null) {
                if(((ASN1TaggedObject)arg4).obj != null) {
                    return v0;
                }
            }
            else if(!this.obj.toASN1Primitive().equals(((ASN1TaggedObject)arg4).obj.toASN1Primitive())) {
                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    abstract void encode(ASN1OutputStream arg1);

    public static ASN1TaggedObject getInstance(Object arg4) {
        ASN1TaggedObject v4;
        if(arg4 != null && !(arg4 instanceof ASN1TaggedObject)) {
            if((arg4 instanceof byte[])) {
                try {
                    v4 = ASN1TaggedObject.getInstance(ASN1TaggedObject.fromByteArray(((byte[])arg4)));
                }
                catch(IOException v0) {
                    throw new IllegalArgumentException("failed to construct tagged object from byte[]: " + v0.getMessage());
                }
            }
            else {
                throw new IllegalArgumentException("unknown object in getInstance: " + arg4.getClass().getName());
            }
        }

        return v4;
    }

    public static ASN1TaggedObject getInstance(ASN1TaggedObject arg2, boolean arg3) {
        if(arg3) {
            return arg2.getObject();
        }

        throw new IllegalArgumentException("implicitly tagged tagged object");
    }

    public ASN1Primitive getLoadedObject() {
        return this.toASN1Primitive();
    }

    public ASN1Primitive getObject() {
        ASN1Primitive v0 = this.obj != null ? this.obj.toASN1Primitive() : null;
        return v0;
    }

    public ASN1Encodable getObjectParser(int arg4, boolean arg5) {
        ASN1SequenceParser v0_2;
        switch(arg4) {
            case 4: {
                ASN1OctetStringParser v0_3 = ASN1OctetString.getInstance(this, arg5).parser();
                break;
            }
            case 16: {
                v0_2 = ASN1Sequence.getInstance(this, arg5).parser();
                break;
            }
            case 17: {
                ASN1SetParser v0_1 = ASN1Set.getInstance(this, arg5).parser();
                break;
            }
            default: {
                if(arg5) {
                    ASN1Primitive v0 = this.getObject();
                    goto label_3;
                }

                throw new RuntimeException("implicit tagging not implemented for tag: " + arg4);
            }
        }

    label_3:
        return ((ASN1Encodable)v0_2);
    }

    public int getTagNo() {
        return this.tagNo;
    }

    public int hashCode() {
        int v0 = this.tagNo;
        if(this.obj != null) {
            v0 ^= this.obj.hashCode();
        }

        return v0;
    }

    public boolean isEmpty() {
        return this.empty;
    }

    public boolean isExplicit() {
        return this.explicit;
    }

    ASN1Primitive toDERObject() {
        return new DERTaggedObject(this.explicit, this.tagNo, this.obj);
    }

    ASN1Primitive toDLObject() {
        return new DLTaggedObject(this.explicit, this.tagNo, this.obj);
    }

    public String toString() {
        return "[" + this.tagNo + "]" + this.obj;
    }
}

