// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import org.bouncycastle.util.Arrays;

public class DERApplicationSpecific extends ASN1Primitive {
    private final boolean isConstructed;
    private final byte[] octets;
    private final int tag;

    DERApplicationSpecific(boolean arg1, int arg2, byte[] arg3) {
        super();
        this.isConstructed = arg1;
        this.tag = arg2;
        this.octets = arg3;
    }

    public DERApplicationSpecific(int arg2, ASN1Encodable arg3) {
        this(true, arg2, arg3);
    }

    public DERApplicationSpecific(boolean arg6, int arg7, ASN1Encodable arg8) {
        super();
        ASN1Primitive v0 = arg8.toASN1Primitive();
        byte[] v2 = v0.getEncoded("DER");
        boolean v0_1 = (arg6) || ((v0 instanceof ASN1Set)) || ((v0 instanceof ASN1Sequence)) ? true : false;
        this.isConstructed = v0_1;
        this.tag = arg7;
        if(arg6) {
            this.octets = v2;
        }
        else {
            int v0_2 = this.getLengthOfHeader(v2);
            byte[] v3 = new byte[v2.length - v0_2];
            System.arraycopy(v2, v0_2, v3, 0, v3.length);
            this.octets = v3;
        }
    }

    public DERApplicationSpecific(int arg5, ASN1EncodableVector arg6) {
        super();
        this.tag = arg5;
        this.isConstructed = true;
        ByteArrayOutputStream v2 = new ByteArrayOutputStream();
        int v1 = 0;
        while(v1 != arg6.size()) {
            try {
                v2.write(arg6.get(v1).getEncoded("DER"));
                ++v1;
                continue;
            }
            catch(IOException v0) {
                throw new ASN1ParsingException("malformed object: " + v0, ((Throwable)v0));
            }
        }

        this.octets = v2.toByteArray();
    }

    public DERApplicationSpecific(int arg2, byte[] arg3) {
        this(false, arg2, arg3);
    }

    boolean asn1Equals(ASN1Primitive arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DERApplicationSpecific)) && this.isConstructed == ((DERApplicationSpecific)arg4).isConstructed && this.tag == ((DERApplicationSpecific)arg4).tag && (Arrays.areEqual(this.octets, ((DERApplicationSpecific)arg4).octets))) {
            v0 = true;
        }

        return v0;
    }

    void encode(ASN1OutputStream arg4) {
        int v0 = 64;
        if(this.isConstructed) {
            v0 = 96;
        }

        arg4.writeEncoded(v0, this.tag, this.octets);
    }

    int encodedLength() {
        return StreamUtil.calculateTagLength(this.tag) + StreamUtil.calculateBodyLength(this.octets.length) + this.octets.length;
    }

    public int getApplicationTag() {
        return this.tag;
    }

    public byte[] getContents() {
        return this.octets;
    }

    public static DERApplicationSpecific getInstance(Object arg4) {
        DERApplicationSpecific v0_1;
        if(arg4 == null || ((arg4 instanceof DERApplicationSpecific))) {
            Object v0_3 = arg4;
        }
        else if((arg4 instanceof byte[])) {
            try {
                v0_1 = DERApplicationSpecific.getInstance(ASN1Primitive.fromByteArray(((byte[])arg4)));
            }
            catch(IOException v0) {
                throw new IllegalArgumentException("failed to construct object from byte[]: " + v0.getMessage());
            }
        }
        else {
            if((arg4 instanceof ASN1Encodable)) {
                ASN1Primitive v0_2 = arg4.toASN1Primitive();
                if((v0_2 instanceof ASN1Sequence)) {
                    return v0_1;
                }
            }

            throw new IllegalArgumentException("unknown object in getInstance: " + arg4.getClass().getName());
        }

        return v0_1;
    }

    private int getLengthOfHeader(byte[] arg5) {
        int v0 = 2;
        int v1 = arg5[1] & 255;
        if(v1 != 128 && v1 > 127) {
            v0 = v1 & 127;
            if(v0 > 4) {
                throw new IllegalStateException("DER length more than 4 bytes: " + v0);
            }
            else {
                v0 += 2;
            }
        }

        return v0;
    }

    public ASN1Primitive getObject() {
        return new ASN1InputStream(this.getContents()).readObject();
    }

    public ASN1Primitive getObject(int arg4) {
        if(arg4 >= 31) {
            throw new IOException("unsupported tag number");
        }

        byte[] v0 = this.getEncoded();
        byte[] v1 = this.replaceTagNumber(arg4, v0);
        if((v0[0] & 32) != 0) {
            v1[0] = ((byte)(v1[0] | 32));
        }

        return new ASN1InputStream(v1).readObject();
    }

    public int hashCode() {
        int v0 = this.isConstructed ? 1 : 0;
        return v0 ^ this.tag ^ Arrays.hashCode(this.octets);
    }

    public boolean isConstructed() {
        return this.isConstructed;
    }

    private byte[] replaceTagNumber(int arg8, byte[] arg9) {
        int v0;
        if((arg9[0] & 31) == 31) {
            int v2 = 2;
            v0 = arg9[1] & 255;
            if((v0 & 127) == 0) {
                throw new ASN1ParsingException("corrupted stream - invalid high tag number found");
            }
            else {
                int v3 = 0;
                int v6 = v2;
                v2 = v0;
                v0 = v6;
                while(v2 >= 0) {
                    if((v2 & 128) == 0) {
                        break;
                    }

                    v3 = (v2 & 127 | v3) << 7;
                    v6 = arg9[v0] & 255;
                    ++v0;
                    v2 = v6;
                }
            }
        }
        else {
            v0 = 1;
        }

        byte[] v2_1 = new byte[arg9.length - v0 + 1];
        System.arraycopy(arg9, v0, v2_1, 1, v2_1.length - 1);
        v2_1[0] = ((byte)arg8);
        return v2_1;
    }
}

