// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.io.Streams;

public class DERBitString extends ASN1Primitive implements ASN1String {
    public byte[] data;
    protected int padBits;
    private static final char[] table;

    static {
        DERBitString.table = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
    }

    protected DERBitString(byte arg3, int arg4) {
        super();
        this.data = new byte[1];
        this.data[0] = arg3;
        this.padBits = arg4;
    }

    public DERBitString(int arg2) {
        super();
        this.data = DERBitString.getBytes(arg2);
        this.padBits = DERBitString.getPadBits(arg2);
    }

    public DERBitString(ASN1Encodable arg3) {
        super();
        this.data = arg3.toASN1Primitive().getEncoded("DER");
        this.padBits = 0;
    }

    public DERBitString(byte[] arg2) {
        this(arg2, 0);
    }

    public DERBitString(byte[] arg1, int arg2) {
        super();
        this.data = arg1;
        this.padBits = arg2;
    }

    protected boolean asn1Equals(ASN1Primitive arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DERBitString)) && this.padBits == ((DERBitString)arg4).padBits && (Arrays.areEqual(this.data, ((DERBitString)arg4).data))) {
            v0 = true;
        }

        return v0;
    }

    void encode(ASN1OutputStream arg6) {
        byte[] v0 = new byte[this.getBytes().length + 1];
        v0[0] = ((byte)this.getPadBits());
        System.arraycopy(this.getBytes(), 0, v0, 1, v0.length - 1);
        arg6.writeEncoded(3, v0);
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.data.length + 1) + 1 + this.data.length + 1;
    }

    static DERBitString fromInputStream(int arg4, InputStream arg5) {
        if(arg4 < 1) {
            throw new IllegalArgumentException("truncated BIT STRING detected");
        }

        int v0 = arg5.read();
        byte[] v1 = new byte[arg4 - 1];
        if(v1.length != 0 && Streams.readFully(arg5, v1) != v1.length) {
            throw new EOFException("EOF encountered in middle of BIT STRING");
        }

        return new DERBitString(v1, v0);
    }

    static DERBitString fromOctetString(byte[] arg5) {
        if(arg5.length < 1) {
            throw new IllegalArgumentException("truncated BIT STRING detected");
        }

        int v0 = arg5[0];
        byte[] v1 = new byte[arg5.length - 1];
        if(v1.length != 0) {
            System.arraycopy(arg5, 1, v1, 0, arg5.length - 1);
        }

        return new DERBitString(v1, v0);
    }

    public static byte[] getBytes(int arg4) {
        int v1 = 4;
        int v0;
        for(v0 = 3; v0 >= 1; --v0) {
            if((255 << v0 * 8 & arg4) != 0) {
                break;
            }

            --v1;
        }

        byte[] v2 = new byte[v1];
        for(v0 = 0; v0 < v1; ++v0) {
            v2[v0] = ((byte)(arg4 >> v0 * 8 & 255));
        }

        return v2;
    }

    public byte[] getBytes() {
        return this.data;
    }

    public static DERBitString getInstance(Object arg3) {
        if(arg3 != null && !(arg3 instanceof DERBitString)) {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
        }

        return arg3;
    }

    public static DERBitString getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        DERBitString v0_1 = (arg3) || ((v0 instanceof DERBitString)) ? DERBitString.getInstance(v0) : DERBitString.fromOctetString(((ASN1OctetString)v0).getOctets());
        return v0_1;
    }

    public static int getPadBits(int arg3) {
        int v1 = 0;
        int v0;
        for(v0 = 3; v0 >= 0; --v0) {
            if(v0 != 0) {
                if(arg3 >> v0 * 8 != 0) {
                    v1 = arg3 >> v0 * 8 & 255;
                    break;
                }
            }
            else if(arg3 != 0) {
                v1 = arg3 & 255;
                break;
            }
        }

        if(v1 == 0) {
            v0 = 7;
        }
        else {
            for(v0 = 1; true; ++v0) {
                v1 <<= 1;
                if((v1 & 255) == 0) {
                    break;
                }
            }

            v0 = 8 - v0;
        }

        return v0;
    }

    public int getPadBits() {
        return this.padBits;
    }

    public String getString() {
        StringBuffer v1 = new StringBuffer("#");
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        ASN1OutputStream v2 = new ASN1OutputStream(((OutputStream)v0));
        try {
            v2.writeObject(((ASN1Encodable)this));
        }
        catch(IOException v0_1) {
            throw new RuntimeException("internal error encoding BitString");
        }

        byte[] v2_1 = v0.toByteArray();
        int v0_2;
        for(v0_2 = 0; v0_2 != v2_1.length; ++v0_2) {
            v1.append(DERBitString.table[v2_1[v0_2] >>> 4 & 15]);
            v1.append(DERBitString.table[v2_1[v0_2] & 15]);
        }

        return v1.toString();
    }

    public int hashCode() {
        return this.padBits ^ Arrays.hashCode(this.data);
    }

    public int intValue() {
        int v0 = 0;
        int v1 = 0;
        while(v0 != this.data.length) {
            if(v0 == 4) {
                return v1;
            }

            v1 |= (this.data[v0] & 255) << v0 * 8;
            ++v0;
        }

        return v1;
    }

    boolean isConstructed() {
        return 0;
    }

    public String toString() {
        return this.getString();
    }
}

