// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import org.bouncycastle.util.Arrays;

public class DERBoolean extends ASN1Primitive {
    public static final ASN1Boolean FALSE;
    private static final byte[] FALSE_VALUE;
    public static final ASN1Boolean TRUE;
    private static final byte[] TRUE_VALUE;
    private byte[] value;

    static {
        DERBoolean.TRUE_VALUE = new byte[]{-1};
        DERBoolean.FALSE_VALUE = new byte[]{0};
        DERBoolean.FALSE = new ASN1Boolean(false);
        DERBoolean.TRUE = new ASN1Boolean(true);
    }

    public DERBoolean(boolean arg2) {
        super();
        byte[] v0 = arg2 ? DERBoolean.TRUE_VALUE : DERBoolean.FALSE_VALUE;
        this.value = v0;
    }

    DERBoolean(byte[] arg4) {
        super();
        if(arg4.length != 1) {
            throw new IllegalArgumentException("byte value should have 1 byte in it");
        }

        if(arg4[0] == 0) {
            this.value = DERBoolean.FALSE_VALUE;
        }
        else if(arg4[0] == 255) {
            this.value = DERBoolean.TRUE_VALUE;
        }
        else {
            this.value = Arrays.clone(arg4);
        }
    }

    protected boolean asn1Equals(ASN1Primitive arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof DERBoolean)) && this.value[0] == ((DERBoolean)arg4).value[0]) {
            v0 = true;
        }

        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(1, this.value);
    }

    int encodedLength() {
        return 3;
    }

    static ASN1Boolean fromOctetString(byte[] arg3) {
        ASN1Boolean v0;
        if(arg3.length != 1) {
            throw new IllegalArgumentException("byte value should have 1 byte in it");
        }

        if(arg3[0] == 0) {
            v0 = DERBoolean.FALSE;
        }
        else if(arg3[0] == 255) {
            v0 = DERBoolean.TRUE;
        }
        else {
            v0 = new ASN1Boolean(arg3);
        }

        return v0;
    }

    public static ASN1Boolean getInstance(int arg1) {
        ASN1Boolean v0 = arg1 != 0 ? DERBoolean.TRUE : DERBoolean.FALSE;
        return v0;
    }

    public static ASN1Boolean getInstance(Object arg3) {
        ASN1Boolean v0;
        if(arg3 == null || ((arg3 instanceof ASN1Boolean))) {
            Object v0_1 = arg3;
        }
        else if(!(arg3 instanceof DERBoolean)) {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
        }
        else if(((DERBoolean)arg3).isTrue()) {
            v0 = DERBoolean.TRUE;
        }
        else {
            v0 = DERBoolean.FALSE;
        }

        return v0;
    }

    public static ASN1Boolean getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        ASN1Boolean v0_1 = (arg3) || ((v0 instanceof DERBoolean)) ? DERBoolean.getInstance(v0) : ASN1Boolean.fromOctetString(((ASN1OctetString)v0).getOctets());
        return v0_1;
    }

    public static ASN1Boolean getInstance(boolean arg1) {
        ASN1Boolean v0 = arg1 ? DERBoolean.TRUE : DERBoolean.FALSE;
        return v0;
    }

    public int hashCode() {
        return this.value[0];
    }

    boolean isConstructed() {
        return 0;
    }

    public boolean isTrue() {
        boolean v0 = false;
        if(this.value[0] != 0) {
            v0 = true;
        }

        return v0;
    }

    public String toString() {
        String v0 = this.value[0] != 0 ? "TRUE" : "FALSE";
        return v0;
    }
}

