// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.math.BigInteger;
import org.bouncycastle.util.Arrays;

public class DEREnumerated extends ASN1Primitive {
    byte[] bytes;
    private static ASN1Enumerated[] cache;

    static {
        DEREnumerated.cache = new ASN1Enumerated[12];
    }

    public DEREnumerated(int arg3) {
        super();
        this.bytes = BigInteger.valueOf(((long)arg3)).toByteArray();
    }

    public DEREnumerated(BigInteger arg2) {
        super();
        this.bytes = arg2.toByteArray();
    }

    public DEREnumerated(byte[] arg1) {
        super();
        this.bytes = arg1;
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DEREnumerated) ? false : Arrays.areEqual(this.bytes, ((DEREnumerated)arg3).bytes);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(10, this.bytes);
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.bytes.length) + 1 + this.bytes.length;
    }

    static ASN1Enumerated fromOctetString(byte[] arg4) {
        ASN1Enumerated v0;
        if(arg4.length > 1) {
            v0 = new ASN1Enumerated(Arrays.clone(arg4));
        }
        else if(arg4.length == 0) {
            throw new IllegalArgumentException("ENUMERATED has zero length");
        }
        else {
            int v1 = arg4[0] & 255;
            if(v1 >= DEREnumerated.cache.length) {
                v0 = new ASN1Enumerated(Arrays.clone(arg4));
            }
            else {
                v0 = DEREnumerated.cache[v1];
                if(v0 == null) {
                    ASN1Enumerated[] v2 = DEREnumerated.cache;
                    v0 = new ASN1Enumerated(Arrays.clone(arg4));
                    v2[v1] = v0;
                }
            }
        }

        return v0;
    }

    public static ASN1Enumerated getInstance(Object arg4) {
        ASN1Enumerated v0;
        if(arg4 == null || ((arg4 instanceof ASN1Enumerated))) {
            Object v0_3 = arg4;
        }
        else if((arg4 instanceof DEREnumerated)) {
            v0 = new ASN1Enumerated(((DEREnumerated)arg4).getValue());
        }
        else if((arg4 instanceof byte[])) {
            try {
                ASN1Primitive v0_2 = DEREnumerated.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0_1) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0_1.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return v0;
    }

    public static DEREnumerated getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        ASN1Enumerated v0_1 = (arg3) || ((v0 instanceof DEREnumerated)) ? DEREnumerated.getInstance(v0) : DEREnumerated.fromOctetString(((ASN1OctetString)v0).getOctets());
        return ((DEREnumerated)v0_1);
    }

    public BigInteger getValue() {
        return new BigInteger(this.bytes);
    }

    public int hashCode() {
        return Arrays.hashCode(this.bytes);
    }

    boolean isConstructed() {
        return 0;
    }
}

