// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;

public class DERExternal extends ASN1Primitive {
    private ASN1Primitive dataValueDescriptor;
    private ASN1ObjectIdentifier directReference;
    private int encoding;
    private ASN1Primitive externalContent;
    private ASN1Integer indirectReference;

    public DERExternal(ASN1EncodableVector arg4) {
        super();
        int v1 = 0;
        ASN1Primitive v0 = this.getObjFromVector(arg4, 0);
        if((v0 instanceof ASN1ObjectIdentifier)) {
            this.directReference = ((ASN1ObjectIdentifier)v0);
            v1 = 1;
            v0 = this.getObjFromVector(arg4, 1);
        }

        if((v0 instanceof ASN1Integer)) {
            this.indirectReference = ((ASN1Integer)v0);
            ++v1;
            v0 = this.getObjFromVector(arg4, v1);
        }

        if(!(v0 instanceof DERTaggedObject)) {
            this.dataValueDescriptor = v0;
            ++v1;
            v0 = this.getObjFromVector(arg4, v1);
        }

        if(arg4.size() != v1 + 1) {
            throw new IllegalArgumentException("input vector too large");
        }

        if(!(v0 instanceof DERTaggedObject)) {
            throw new IllegalArgumentException("No tagged object found in vector. Structure doesn\'t seem to be of type External");
        }

        this.setEncoding(((DERTaggedObject)v0).getTagNo());
        this.externalContent = ((DERTaggedObject)v0).getObject();
    }

    public DERExternal(ASN1ObjectIdentifier arg2, ASN1Integer arg3, ASN1Primitive arg4, int arg5, ASN1Primitive arg6) {
        super();
        this.setDirectReference(arg2);
        this.setIndirectReference(arg3);
        this.setDataValueDescriptor(arg4);
        this.setEncoding(arg5);
        this.setExternalContent(arg6.toASN1Primitive());
    }

    public DERExternal(ASN1ObjectIdentifier arg7, ASN1Integer arg8, ASN1Primitive arg9, DERTaggedObject arg10) {
        this(arg7, arg8, arg9, arg10.getTagNo(), arg10.toASN1Primitive());
    }

    boolean asn1Equals(ASN1Primitive arg4) {
        boolean v0 = false;
        if((arg4 instanceof DERExternal)) {
            if(this == (((DERExternal)arg4))) {
                v0 = true;
            }
            else {
                if(this.directReference != null) {
                    if(((DERExternal)arg4).directReference == null) {
                    }
                    else if(((DERExternal)arg4).directReference.equals(this.directReference)) {
                        goto label_15;
                    }

                    return v0;
                }

            label_15:
                if(this.indirectReference != null) {
                    if(((DERExternal)arg4).indirectReference == null) {
                    }
                    else if(((DERExternal)arg4).indirectReference.equals(this.indirectReference)) {
                        goto label_23;
                    }

                    return v0;
                }

            label_23:
                if(this.dataValueDescriptor != null) {
                    if(((DERExternal)arg4).dataValueDescriptor == null) {
                    }
                    else if(((DERExternal)arg4).dataValueDescriptor.equals(this.dataValueDescriptor)) {
                        goto label_31;
                    }

                    return v0;
                }

            label_31:
                v0 = this.externalContent.equals(((DERExternal)arg4).externalContent);
            }
        }

        return v0;
    }

    void encode(ASN1OutputStream arg6) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        if(this.directReference != null) {
            v0.write(this.directReference.getEncoded("DER"));
        }

        if(this.indirectReference != null) {
            v0.write(this.indirectReference.getEncoded("DER"));
        }

        if(this.dataValueDescriptor != null) {
            v0.write(this.dataValueDescriptor.getEncoded("DER"));
        }

        v0.write(new DERTaggedObject(true, this.encoding, this.externalContent).getEncoded("DER"));
        arg6.writeEncoded(32, 8, v0.toByteArray());
    }

    int encodedLength() {
        return this.getEncoded().length;
    }

    public ASN1Primitive getDataValueDescriptor() {
        return this.dataValueDescriptor;
    }

    public ASN1ObjectIdentifier getDirectReference() {
        return this.directReference;
    }

    public int getEncoding() {
        return this.encoding;
    }

    public ASN1Primitive getExternalContent() {
        return this.externalContent;
    }

    public ASN1Integer getIndirectReference() {
        return this.indirectReference;
    }

    private ASN1Primitive getObjFromVector(ASN1EncodableVector arg3, int arg4) {
        if(arg3.size() <= arg4) {
            throw new IllegalArgumentException("too few objects in input vector");
        }

        return arg3.get(arg4).toASN1Primitive();
    }

    public int hashCode() {
        int v0 = 0;
        if(this.directReference != null) {
            v0 = this.directReference.hashCode();
        }

        if(this.indirectReference != null) {
            v0 ^= this.indirectReference.hashCode();
        }

        if(this.dataValueDescriptor != null) {
            v0 ^= this.dataValueDescriptor.hashCode();
        }

        return v0 ^ this.externalContent.hashCode();
    }

    boolean isConstructed() {
        return 1;
    }

    private void setDataValueDescriptor(ASN1Primitive arg1) {
        this.dataValueDescriptor = arg1;
    }

    private void setDirectReference(ASN1ObjectIdentifier arg1) {
        this.directReference = arg1;
    }

    private void setEncoding(int arg4) {
        if(arg4 >= 0 && arg4 <= 2) {
            this.encoding = arg4;
            return;
        }

        throw new IllegalArgumentException("invalid encoding value: " + arg4);
    }

    private void setExternalContent(ASN1Primitive arg1) {
        this.externalContent = arg1;
    }

    private void setIndirectReference(ASN1Integer arg1) {
        this.indirectReference = arg1;
    }
}

