// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.SimpleTimeZone;
import java.util.TimeZone;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Strings;

public class DERGeneralizedTime extends ASN1Primitive {
    private byte[] time;

    public DERGeneralizedTime(String arg5) {
        super();
        this.time = Strings.toByteArray(arg5);
        try {
            this.getDate();
            return;
        }
        catch(ParseException v0) {
            throw new IllegalArgumentException("invalid date string: " + v0.getMessage());
        }
    }

    public DERGeneralizedTime(Date arg5) {
        super();
        SimpleDateFormat v0 = new SimpleDateFormat("yyyyMMddHHmmss\'Z\'");
        v0.setTimeZone(new SimpleTimeZone(0, "Z"));
        this.time = Strings.toByteArray(v0.format(arg5));
    }

    DERGeneralizedTime(byte[] arg1) {
        super();
        this.time = arg1;
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERGeneralizedTime) ? false : Arrays.areEqual(this.time, ((DERGeneralizedTime)arg3).time);
        return v0;
    }

    private String calculateGMTOffset() {
        String v1 = "+";
        TimeZone v3 = TimeZone.getDefault();
        int v0 = v3.getRawOffset();
        if(v0 < 0) {
            v1 = "-";
            v0 = -v0;
        }

        int v2 = v0 / 3600000;
        int v4 = (v0 - v2 * 60 * 60 * 1000) / 60000;
        try {
            if((v3.useDaylightTime()) && (v3.inDaylightTime(this.getDate()))) {
                if(!v1.equals("+")) {
                    goto label_37;
                }

                goto label_22;
            }

            goto label_42;
        }
        catch(ParseException v0_1) {
            v0 = v2;
            goto label_24;
        }

    label_22:
        v0 = 1;
        goto label_23;
    label_37:
        v0 = -1;
    label_23:
        v0 += v2;
        goto label_24;
    label_42:
        v0 = v2;
    label_24:
        return "GMT" + v1 + this.convert(v0) + ":" + this.convert(v4);
    }

    private String convert(int arg3) {
        String v0 = arg3 < 10 ? "0" + arg3 : Integer.toString(arg3);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(24, this.time);
    }

    int encodedLength() {
        return this.time.length + (StreamUtil.calculateBodyLength(this.time.length) + 1);
    }

    public Date getDate() {
        String v0_1;
        SimpleDateFormat v1_1;
        String v9;
        SimpleDateFormat v0;
        int v8 = 14;
        String v1 = Strings.fromByteArray(this.time);
        if(v1.endsWith("Z")) {
            v0 = this.hasFractionalSeconds() ? new SimpleDateFormat("yyyyMMddHHmmss.SSS\'Z\'") : new SimpleDateFormat("yyyyMMddHHmmss\'Z\'");
            v0.setTimeZone(new SimpleTimeZone(0, "Z"));
            v9 = v1;
            v1_1 = v0;
            v0_1 = v9;
        }
        else {
            if(v1.indexOf(45) <= 0 && v1.indexOf(43) <= 0) {
                v0 = this.hasFractionalSeconds() ? new SimpleDateFormat("yyyyMMddHHmmss.SSS") : new SimpleDateFormat("yyyyMMddHHmmss");
                v0.setTimeZone(new SimpleTimeZone(0, TimeZone.getDefault().getID()));
                v9 = v1;
                v1_1 = v0;
                v0_1 = v9;
                goto label_20;
            }

            v1 = this.getTime();
            v0 = this.hasFractionalSeconds() ? new SimpleDateFormat("yyyyMMddHHmmss.SSSz") : new SimpleDateFormat("yyyyMMddHHmmssz");
            v0.setTimeZone(new SimpleTimeZone(0, "Z"));
            v9 = v1;
            v1_1 = v0;
            v0_1 = v9;
        }

    label_20:
        if(this.hasFractionalSeconds()) {
            String v4 = v0_1.substring(v8);
            int v2;
            for(v2 = 1; v2 < v4.length(); ++v2) {
                int v5 = v4.charAt(v2);
                if(48 > v5) {
                    break;
                }

                if(v5 > 57) {
                    break;
                }
            }

            if(v2 - 1 > 3) {
                v0_1 = v0_1.substring(0, v8) + (v4.substring(0, 4) + v4.substring(v2));
                goto label_48;
            }

            if(v2 - 1 == 1) {
                v0_1 = v0_1.substring(0, v8) + (v4.substring(0, v2) + "00" + v4.substring(v2));
                goto label_48;
            }

            if(v2 - 1 != 2) {
                goto label_48;
            }

            v0_1 = v0_1.substring(0, v8) + (v4.substring(0, v2) + "0" + v4.substring(v2));
        }

    label_48:
        return v1_1.parse(v0_1);
    }

    public static ASN1GeneralizedTime getInstance(Object arg4) {
        ASN1GeneralizedTime v0;
        if(arg4 == null || ((arg4 instanceof ASN1GeneralizedTime))) {
            Object v0_3 = arg4;
        }
        else if((arg4 instanceof DERGeneralizedTime)) {
            v0 = new ASN1GeneralizedTime(((DERGeneralizedTime)arg4).time);
        }
        else if((arg4 instanceof byte[])) {
            try {
                ASN1Primitive v0_2 = DERGeneralizedTime.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0_1) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0_1.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return v0;
    }

    public static ASN1GeneralizedTime getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        ASN1GeneralizedTime v0_1 = (arg3) || ((v0 instanceof DERGeneralizedTime)) ? DERGeneralizedTime.getInstance(v0) : new ASN1GeneralizedTime(((ASN1OctetString)v0).getOctets());
        return v0_1;
    }

    public String getTime() {
        int v5 = 45;
        int v4 = 43;
        String v0 = Strings.fromByteArray(this.time);
        if(v0.charAt(v0.length() - 1) == 90) {
            v0 = v0.substring(0, v0.length() - 1) + "GMT+00:00";
        }
        else {
            int v1 = v0.length() - 5;
            int v2 = v0.charAt(v1);
            if(v2 != v5 && v2 != v4) {
                v1 = v0.length() - 3;
                v2 = v0.charAt(v1);
                if(v2 != v5 && v2 != v4) {
                    return v0 + this.calculateGMTOffset();
                }

                return v0.substring(0, v1) + "GMT" + v0.substring(v1) + ":00";
            }

            v0 = v0.substring(0, v1) + "GMT" + v0.substring(v1, v1 + 3) + ":" + v0.substring(v1 + 3);
        }

        return v0;
    }

    public String getTimeString() {
        return Strings.fromByteArray(this.time);
    }

    private boolean hasFractionalSeconds() {
        boolean v1 = false;
        int v0;
        for(v0 = 0; v0 != this.time.length; ++v0) {
            if(this.time[v0] == 46 && v0 == 14) {
                return true;
            }
        }

        return v1;
    }

    public int hashCode() {
        return Arrays.hashCode(this.time);
    }

    boolean isConstructed() {
        return 0;
    }
}

