// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Strings;

public class DERIA5String extends ASN1Primitive implements ASN1String {
    private byte[] string;

    DERIA5String(byte[] arg1) {
        super();
        this.string = arg1;
    }

    public DERIA5String(String arg2) {
        this(arg2, false);
    }

    public DERIA5String(String arg3, boolean arg4) {
        super();
        if(arg3 == null) {
            throw new NullPointerException("string cannot be null");
        }

        if((arg4) && !DERIA5String.isIA5String(arg3)) {
            throw new IllegalArgumentException("string contains illegal characters");
        }

        this.string = Strings.toByteArray(arg3);
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERIA5String) ? false : Arrays.areEqual(this.string, ((DERIA5String)arg3).string);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(22, this.string);
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.string.length) + 1 + this.string.length;
    }

    public static DERIA5String getInstance(Object arg4) {
        ASN1Primitive v0_1;
        if(arg4 == null || ((arg4 instanceof DERIA5String))) {
            Object v0_2 = arg4;
        }
        else if((arg4 instanceof byte[])) {
            try {
                v0_1 = DERIA5String.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return ((DERIA5String)v0_1);
    }

    public static DERIA5String getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        DERIA5String v0_1 = (arg3) || ((v0 instanceof DERIA5String)) ? DERIA5String.getInstance(v0) : new DERIA5String(((ASN1OctetString)v0).getOctets());
        return v0_1;
    }

    public byte[] getOctets() {
        return Arrays.clone(this.string);
    }

    public String getString() {
        return Strings.fromByteArray(this.string);
    }

    public int hashCode() {
        return Arrays.hashCode(this.string);
    }

    boolean isConstructed() {
        return 0;
    }

    public static boolean isIA5String(String arg3) {
        boolean v0_1;
        int v0 = arg3.length() - 1;
        while(true) {
            if(v0 < 0) {
                return true;
            }
            else if(arg3.charAt(v0) > 127) {
                v0_1 = false;
            }
            else {
                --v0;
                continue;
            }

            return v0_1;
        }

        return true;
    }

    public String toString() {
        return this.getString();
    }
}

