// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.math.BigInteger;
import org.bouncycastle.util.Arrays;

public class DERInteger extends ASN1Primitive {
    byte[] bytes;

    public DERInteger(long arg2) {
        super();
        this.bytes = BigInteger.valueOf(arg2).toByteArray();
    }

    public DERInteger(BigInteger arg2) {
        super();
        this.bytes = arg2.toByteArray();
    }

    public DERInteger(byte[] arg1) {
        super();
        this.bytes = arg1;
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERInteger) ? false : Arrays.areEqual(this.bytes, ((DERInteger)arg3).bytes);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(2, this.bytes);
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.bytes.length) + 1 + this.bytes.length;
    }

    public static ASN1Integer getInstance(Object arg4) {
        ASN1Primitive v0_2;
        if(arg4 == null || ((arg4 instanceof ASN1Integer))) {
            Object v0_3 = arg4;
        }
        else if((arg4 instanceof DERInteger)) {
            ASN1Integer v0 = new ASN1Integer(((DERInteger)arg4).getValue());
        }
        else if((arg4 instanceof byte[])) {
            try {
                v0_2 = DERInteger.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0_1) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0_1.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return ((ASN1Integer)v0_2);
    }

    public static ASN1Integer getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        ASN1Integer v0_1 = (arg3) || ((v0 instanceof DERInteger)) ? DERInteger.getInstance(v0) : new ASN1Integer(ASN1OctetString.getInstance(arg2.getObject()).getOctets());
        return v0_1;
    }

    public BigInteger getPositiveValue() {
        return new BigInteger(1, this.bytes);
    }

    public BigInteger getValue() {
        return new BigInteger(this.bytes);
    }

    public int hashCode() {
        int v0 = 0;
        int v1 = 0;
        while(v0 != this.bytes.length) {
            v1 ^= (this.bytes[v0] & 255) << v0 % 4;
            ++v0;
        }

        return v1;
    }

    boolean isConstructed() {
        return 0;
    }

    public String toString() {
        return this.getValue().toString();
    }
}

