// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Strings;

public class DERNumericString extends ASN1Primitive implements ASN1String {
    private byte[] string;

    DERNumericString(byte[] arg1) {
        super();
        this.string = arg1;
    }

    public DERNumericString(String arg2) {
        this(arg2, false);
    }

    public DERNumericString(String arg3, boolean arg4) {
        super();
        if((arg4) && !DERNumericString.isNumericString(arg3)) {
            throw new IllegalArgumentException("string contains illegal characters");
        }

        this.string = Strings.toByteArray(arg3);
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERNumericString) ? false : Arrays.areEqual(this.string, ((DERNumericString)arg3).string);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(18, this.string);
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.string.length) + 1 + this.string.length;
    }

    public static DERNumericString getInstance(Object arg4) {
        Object v0_2;
        if(arg4 == null || ((arg4 instanceof DERNumericString))) {
            v0_2 = arg4;
        }
        else if((arg4 instanceof byte[])) {
            try {
                ASN1Primitive v0_1 = DERNumericString.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return ((DERNumericString)v0_2);
    }

    public static DERNumericString getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v1 = arg2.getObject();
        DERNumericString v0 = (arg3) || ((v1 instanceof DERNumericString)) ? DERNumericString.getInstance(v1) : new DERNumericString(ASN1OctetString.getInstance(v1).getOctets());
        return v0;
    }

    public byte[] getOctets() {
        return Arrays.clone(this.string);
    }

    public String getString() {
        return Strings.fromByteArray(this.string);
    }

    public int hashCode() {
        return Arrays.hashCode(this.string);
    }

    boolean isConstructed() {
        return 0;
    }

    public static boolean isNumericString(String arg4) {
        boolean v0 = false;
        int v1 = arg4.length() - 1;
        while(true) {
            if(v1 >= 0) {
                int v2 = arg4.charAt(v1);
                if(v2 <= 127) {
                    if((48 > v2 || v2 > 57) && v2 != 32) {
                        return v0;
                    }

                    --v1;
                    continue;
                }
            }
            else {
                return true;
            }

            return v0;
        }

        return true;
    }

    public String toString() {
        return this.getString();
    }
}

