// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.math.BigInteger;
import org.bouncycastle.util.Arrays;

public class DERObjectIdentifier extends ASN1Primitive {
    private static final long LONG_LIMIT = 72057594037927808L;
    private byte[] body;
    private static ASN1ObjectIdentifier[][] cache;
    String identifier;

    static {
        DERObjectIdentifier.cache = new ASN1ObjectIdentifier[256][];
    }

    public DERObjectIdentifier(String arg4) {
        super();
        if(arg4 == null) {
            throw new IllegalArgumentException("\'identifier\' cannot be null");
        }

        if(!DERObjectIdentifier.isValidIdentifier(arg4)) {
            throw new IllegalArgumentException("string " + arg4 + " not an OID");
        }

        this.identifier = arg4;
    }

    DERObjectIdentifier(DERObjectIdentifier arg4, String arg5) {
        super();
        if(!DERObjectIdentifier.isValidBranchID(arg5, 0)) {
            throw new IllegalArgumentException("string " + arg5 + " not a valid OID branch");
        }

        this.identifier = arg4.getId() + "." + arg5;
    }

    DERObjectIdentifier(byte[] arg13) {
        int v9;
        int v0_1;
        BigInteger v1_2;
        long v1_1;
        super();
        StringBuffer v5 = new StringBuffer();
        int v1 = 1;
        BigInteger v0 = null;
        long v2 = 0;
        int v4;
        for(v4 = 0; v4 != arg13.length; ++v4) {
            int v6 = arg13[v4] & 255;
            if(v2 <= 72057594037927808L) {
                v2 += ((long)(v6 & 127));
                if((v6 & 128) == 0) {
                    if(v1 != 0) {
                        if(v2 < 40) {
                            v5.append('0');
                            v1_1 = v2;
                        }
                        else if(v2 < 80) {
                            v5.append('1');
                            v1_1 = v2 - 40;
                        }
                        else {
                            v5.append('2');
                            v1_1 = v2 - 80;
                        }

                        v2 = v1_1;
                        v1 = 0;
                    }

                    v5.append('.');
                    v5.append(v2);
                    v2 = 0;
                }
                else {
                    v2 <<= 7;
                }
            }
            else {
                if(v0 == null) {
                    v0 = BigInteger.valueOf(v2);
                }

                v0 = v0.or(BigInteger.valueOf(((long)(v6 & 127))));
                if((v6 & 128) == 0) {
                    if(v1 != 0) {
                        v5.append('2');
                        v1_2 = v0.subtract(BigInteger.valueOf(80));
                        v0_1 = 0;
                    }
                    else {
                        v9 = v1;
                        v1_2 = v0;
                        v0_1 = v9;
                    }

                    v5.append('.');
                    v5.append(v1_2);
                    v2 = 0;
                    v9 = v0_1;
                    v0 = null;
                    v1 = v9;
                    goto label_38;
                }

                v0 = v0.shiftLeft(7);
            }

        label_38:
        }

        this.identifier = v5.toString();
        this.body = Arrays.clone(arg13);
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERObjectIdentifier) ? false : this.identifier.equals(((DERObjectIdentifier)arg3).identifier);
        return v0;
    }

    private void doOutput(ByteArrayOutputStream arg7) {
        int v5 = 18;
        OIDTokenizer v0 = new OIDTokenizer(this.identifier);
        int v1 = Integer.parseInt(v0.nextToken()) * 40;
        String v2 = v0.nextToken();
        if(v2.length() <= v5) {
            this.writeField(arg7, Long.parseLong(v2) + (((long)v1)));
        }
        else {
            this.writeField(arg7, new BigInteger(v2).add(BigInteger.valueOf(((long)v1))));
        }

        while(v0.hasMoreTokens()) {
            String v1_1 = v0.nextToken();
            if(v1_1.length() <= v5) {
                this.writeField(arg7, Long.parseLong(v1_1));
                continue;
            }

            this.writeField(arg7, new BigInteger(v1_1));
        }
    }

    void encode(ASN1OutputStream arg3) {
        byte[] v0 = this.getBody();
        arg3.write(6);
        arg3.writeLength(v0.length);
        arg3.write(v0);
    }

    int encodedLength() {
        int v0 = this.getBody().length;
        return v0 + (StreamUtil.calculateBodyLength(v0) + 1);
    }

    static ASN1ObjectIdentifier fromOctetString(byte[] arg5) {
        ASN1ObjectIdentifier[] v1_1;
        ASN1ObjectIdentifier[] v0_2;
        ASN1ObjectIdentifier v0;
        if(arg5.length < 3) {
            v0 = new ASN1ObjectIdentifier(arg5);
        }
        else {
            int v2 = arg5[arg5.length - 2] & 255;
            int v3 = arg5[arg5.length - 1] & 127;
            ASN1ObjectIdentifier[][] v4 = DERObjectIdentifier.cache;
            __monitor_enter(v4);
            try {
                v0_2 = DERObjectIdentifier.cache[v2];
                if(v0_2 == null) {
                    ASN1ObjectIdentifier[][] v1 = DERObjectIdentifier.cache;
                    v0_2 = new ASN1ObjectIdentifier[128];
                    v1[v2] = v0_2;
                    v1_1 = v0_2;
                }
                else {
                    goto label_79;
                }

                goto label_24;
            }
            catch(Throwable v0_1) {
                goto label_32;
            }

        label_79:
            v1_1 = v0_2;
            try {
            label_24:
                v0 = v1_1[v3];
                if(v0 == null) {
                    v0 = new ASN1ObjectIdentifier(arg5);
                    v1_1[v3] = v0;
                    __monitor_exit(v4);
                    return v0;
                }

                if(Arrays.areEqual(arg5, v0.getBody())) {
                    __monitor_exit(v4);
                    return v0;
                }

                int v1_2 = v2 + 1 & 255;
                v0_2 = DERObjectIdentifier.cache[v1_2];
                if(v0_2 == null) {
                    ASN1ObjectIdentifier[][] v2_1 = DERObjectIdentifier.cache;
                    v0_2 = new ASN1ObjectIdentifier[128];
                    v2_1[v1_2] = v0_2;
                    v1_1 = v0_2;
                }
                else {
                    goto label_77;
                }

                goto label_49;
            }
            catch(Throwable v0_1) {
                goto label_32;
            }

        label_77:
            v1_1 = v0_2;
            try {
            label_49:
                v0 = v1_1[v3];
                if(v0 == null) {
                    v0 = new ASN1ObjectIdentifier(arg5);
                    v1_1[v3] = v0;
                    __monitor_exit(v4);
                    return v0;
                }

                if(Arrays.areEqual(arg5, v0.getBody())) {
                    __monitor_exit(v4);
                    return v0;
                }

                v2 = v3 + 1 & 127;
                v0 = v1_1[v2];
                if(v0 == null) {
                    v0 = new ASN1ObjectIdentifier(arg5);
                    v1_1[v2] = v0;
                    __monitor_exit(v4);
                    return v0;
                }

                __monitor_exit(v4);
                goto label_71;
            label_32:
                __monitor_exit(v4);
            }
            catch(Throwable v0_1) {
                goto label_32;
            }

            throw v0_1;
        label_71:
            if(Arrays.areEqual(arg5, v0.getBody())) {
                return v0;
            }

            v0 = new ASN1ObjectIdentifier(arg5);
        }

        return v0;
    }

    protected byte[] getBody() {
        byte[] v0_2;
        __monitor_enter(this);
        try {
            if(this.body == null) {
                ByteArrayOutputStream v0_1 = new ByteArrayOutputStream();
                this.doOutput(v0_1);
                this.body = v0_1.toByteArray();
            }

            v0_2 = this.body;
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
        return v0_2;
    }

    public String getId() {
        return this.identifier;
    }

    public static ASN1ObjectIdentifier getInstance(Object arg3) {
        ASN1ObjectIdentifier v0;
        if(arg3 == null || ((arg3 instanceof ASN1ObjectIdentifier))) {
            Object v0_2 = arg3;
        }
        else if((arg3 instanceof DERObjectIdentifier)) {
            v0 = new ASN1ObjectIdentifier(((DERObjectIdentifier)arg3).getId());
        }
        else {
            if(((arg3 instanceof ASN1Encodable)) && ((arg3.toASN1Primitive() instanceof ASN1ObjectIdentifier))) {
                ASN1Primitive v0_1 = ((ASN1Encodable)arg3).toASN1Primitive();
                return v0;
            }

            if((arg3 instanceof byte[])) {
                return ASN1ObjectIdentifier.fromOctetString(((byte[])arg3));
            }

            throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
        }

        return v0;
    }

    public static ASN1ObjectIdentifier getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        ASN1ObjectIdentifier v0_1 = (arg3) || ((v0 instanceof DERObjectIdentifier)) ? DERObjectIdentifier.getInstance(v0) : ASN1ObjectIdentifier.fromOctetString(ASN1OctetString.getInstance(arg2.getObject()).getOctets());
        return v0_1;
    }

    public int hashCode() {
        return this.identifier.hashCode();
    }

    boolean isConstructed() {
        return 0;
    }

    private static boolean isValidBranchID(String arg5, int arg6) {
        boolean v0 = false;
        int v2 = arg5.length();
        boolean v1;
        for(v1 = false; true; v1 = false) {
        label_4:
            --v2;
            if(v2 < arg6) {
                return v1;
            }

            int v3 = arg5.charAt(v2);
            if(48 <= v3 && v3 <= 57) {
                v1 = true;
                goto label_4;
            }

            if(v3 != 46) {
                return v0;
            }

            if(!v1) {
                return v0;
            }
        }

        return v1;
    }

    private static boolean isValidIdentifier(String arg3) {
        boolean v0 = false;
        if(arg3.length() >= 3 && arg3.charAt(1) == 46) {
            int v1 = arg3.charAt(0);
            if(v1 >= 48 && v1 <= 50) {
                v0 = DERObjectIdentifier.isValidBranchID(arg3, 2);
            }
        }

        return v0;
    }

    public String toString() {
        return this.getId();
    }

    private void writeField(ByteArrayOutputStream arg5, long arg6) {
        byte[] v1 = new byte[9];
        int v0 = 8;
        v1[v0] = ((byte)((((int)arg6)) & 127));
        while(arg6 >= 128) {
            arg6 >>= 7;
            --v0;
            v1[v0] = ((byte)((((int)arg6)) & 127 | 128));
        }

        arg5.write(v1, v0, 9 - v0);
    }

    private void writeField(ByteArrayOutputStream arg6, BigInteger arg7) {
        int v1 = (arg7.bitLength() + 6) / 7;
        if(v1 == 0) {
            arg6.write(0);
        }
        else {
            byte[] v2 = new byte[v1];
            int v0;
            for(v0 = v1 - 1; v0 >= 0; --v0) {
                v2[v0] = ((byte)(arg7.intValue() & 127 | 128));
                arg7 = arg7.shiftRight(7);
            }

            v0 = v1 - 1;
            v2[v0] = ((byte)(v2[v0] & 127));
            arg6.write(v2, 0, v2.length);
        }
    }
}

