// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Strings;

public class DERPrintableString extends ASN1Primitive implements ASN1String {
    private byte[] string;

    DERPrintableString(byte[] arg1) {
        super();
        this.string = arg1;
    }

    public DERPrintableString(String arg2) {
        this(arg2, false);
    }

    public DERPrintableString(String arg3, boolean arg4) {
        super();
        if((arg4) && !DERPrintableString.isPrintableString(arg3)) {
            throw new IllegalArgumentException("string contains illegal characters");
        }

        this.string = Strings.toByteArray(arg3);
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERPrintableString) ? false : Arrays.areEqual(this.string, ((DERPrintableString)arg3).string);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(19, this.string);
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.string.length) + 1 + this.string.length;
    }

    public static DERPrintableString getInstance(Object arg4) {
        Object v0_2;
        if(arg4 == null || ((arg4 instanceof DERPrintableString))) {
            v0_2 = arg4;
        }
        else if((arg4 instanceof byte[])) {
            try {
                ASN1Primitive v0_1 = DERPrintableString.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return ((DERPrintableString)v0_2);
    }

    public static DERPrintableString getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v1 = arg2.getObject();
        DERPrintableString v0 = (arg3) || ((v1 instanceof DERPrintableString)) ? DERPrintableString.getInstance(v1) : new DERPrintableString(ASN1OctetString.getInstance(v1).getOctets());
        return v0;
    }

    public byte[] getOctets() {
        return Arrays.clone(this.string);
    }

    public String getString() {
        return Strings.fromByteArray(this.string);
    }

    public int hashCode() {
        return Arrays.hashCode(this.string);
    }

    boolean isConstructed() {
        return 0;
    }

    public static boolean isPrintableString(String arg4) {
        boolean v0 = false;
        int v1 = arg4.length() - 1;
        while(true) {
            if(v1 >= 0) {
                int v2 = arg4.charAt(v1);
                if(v2 <= 127) {
                    if((97 > v2 || v2 > 122) && (65 > v2 || v2 > 90) && (48 > v2 || v2 > 57)) {
                        switch(v2) {
                            case 32: 
                            case 39: 
                            case 40: 
                            case 41: 
                            case 43: 
                            case 44: 
                            case 45: 
                            case 46: 
                            case 47: 
                            case 58: 
                            case 61: 
                            case 63: {
                                goto label_12;
                            }
                        }

                        return v0;
                    }

                label_12:
                    --v1;
                    continue;
                }
            }
            else {
                return true;
            }

            return v0;
        }

        return true;
    }

    public String toString() {
        return this.getString();
    }
}

