// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.SimpleTimeZone;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Strings;

public class DERUTCTime extends ASN1Primitive {
    private byte[] time;

    public DERUTCTime(String arg5) {
        super();
        this.time = Strings.toByteArray(arg5);
        try {
            this.getDate();
            return;
        }
        catch(ParseException v0) {
            throw new IllegalArgumentException("invalid date string: " + v0.getMessage());
        }
    }

    public DERUTCTime(Date arg5) {
        super();
        SimpleDateFormat v0 = new SimpleDateFormat("yyMMddHHmmss\'Z\'");
        v0.setTimeZone(new SimpleTimeZone(0, "Z"));
        this.time = Strings.toByteArray(v0.format(arg5));
    }

    DERUTCTime(byte[] arg1) {
        super();
        this.time = arg1;
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERUTCTime) ? false : Arrays.areEqual(this.time, ((DERUTCTime)arg3).time);
        return v0;
    }

    void encode(ASN1OutputStream arg4) {
        arg4.write(23);
        int v1 = this.time.length;
        arg4.writeLength(v1);
        int v0;
        for(v0 = 0; v0 != v1; ++v0) {
            arg4.write(this.time[v0]);
        }
    }

    int encodedLength() {
        return this.time.length + (StreamUtil.calculateBodyLength(this.time.length) + 1);
    }

    public Date getAdjustedDate() {
        SimpleDateFormat v0 = new SimpleDateFormat("yyyyMMddHHmmssz");
        v0.setTimeZone(new SimpleTimeZone(0, "Z"));
        return v0.parse(this.getAdjustedTime());
    }

    public String getAdjustedTime() {
        String v0 = this.getTime();
        return v0.charAt(0) < 53 ? "20" + v0 : "19" + v0;
    }

    public Date getDate() {
        return new SimpleDateFormat("yyMMddHHmmssz").parse(this.getTime());
    }

    public static ASN1UTCTime getInstance(Object arg4) {
        Object v0_3;
        if(arg4 == null || ((arg4 instanceof ASN1UTCTime))) {
            v0_3 = arg4;
        }
        else if((arg4 instanceof DERUTCTime)) {
            ASN1UTCTime v0 = new ASN1UTCTime(((DERUTCTime)arg4).time);
        }
        else if((arg4 instanceof byte[])) {
            try {
                ASN1Primitive v0_2 = DERUTCTime.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0_1) {
                throw new IllegalArgumentException("encoding error in getInstance: " + v0_1.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return ((ASN1UTCTime)v0_3);
    }

    public static ASN1UTCTime getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        ASN1UTCTime v0_1 = (arg3) || ((v0 instanceof ASN1UTCTime)) ? DERUTCTime.getInstance(v0) : new ASN1UTCTime(((ASN1OctetString)v0).getOctets());
        return v0_1;
    }

    public String getTime() {
        String v0;
        int v7 = 13;
        int v6 = 15;
        int v5 = 12;
        int v4 = 10;
        String v1 = Strings.fromByteArray(this.time);
        if(v1.indexOf(45) >= 0 || v1.indexOf(43) >= 0) {
            int v0_1 = v1.indexOf(45);
            if(v0_1 < 0) {
                v0_1 = v1.indexOf(43);
            }

            if(v0_1 == v1.length() - 3) {
                v1 += "00";
            }

            if(v0_1 == v4) {
                return v1.substring(0, v4) + "00GMT" + v1.substring(v4, v7) + ":" + v1.substring(v7, v6);
            }

            v0 = v1.substring(0, v5) + "GMT" + v1.substring(v5, v6) + ":" + v1.substring(v6, 17);
        }
        else if(v1.length() == 11) {
            v0 = v1.substring(0, v4) + "00GMT+00:00";
        }
        else {
            v0 = v1.substring(0, v5) + "GMT+00:00";
        }

        return v0;
    }

    public int hashCode() {
        return Arrays.hashCode(this.time);
    }

    boolean isConstructed() {
        return 0;
    }

    public String toString() {
        return Strings.fromByteArray(this.time);
    }
}

