// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import org.bouncycastle.util.Arrays;

public class DERUniversalString extends ASN1Primitive implements ASN1String {
    private byte[] string;
    private static final char[] table;

    static {
        DERUniversalString.table = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
    }

    public DERUniversalString(byte[] arg1) {
        super();
        this.string = arg1;
    }

    boolean asn1Equals(ASN1Primitive arg3) {
        boolean v0 = !(arg3 instanceof DERUniversalString) ? false : Arrays.areEqual(this.string, ((DERUniversalString)arg3).string);
        return v0;
    }

    void encode(ASN1OutputStream arg3) {
        arg3.writeEncoded(28, this.getOctets());
    }

    int encodedLength() {
        return StreamUtil.calculateBodyLength(this.string.length) + 1 + this.string.length;
    }

    public static DERUniversalString getInstance(Object arg4) {
        ASN1Primitive v0_1;
        if(arg4 == null || ((arg4 instanceof DERUniversalString))) {
            Object v0_2 = arg4;
        }
        else if((arg4 instanceof byte[])) {
            try {
                v0_1 = DERUniversalString.fromByteArray(((byte[])arg4));
            }
            catch(Exception v0) {
                throw new IllegalArgumentException("encoding error getInstance: " + v0.toString());
            }
        }
        else {
            throw new IllegalArgumentException("illegal object in getInstance: " + arg4.getClass().getName());
        }

        return ((DERUniversalString)v0_1);
    }

    public static DERUniversalString getInstance(ASN1TaggedObject arg2, boolean arg3) {
        ASN1Primitive v0 = arg2.getObject();
        DERUniversalString v0_1 = (arg3) || ((v0 instanceof DERUniversalString)) ? DERUniversalString.getInstance(v0) : new DERUniversalString(((ASN1OctetString)v0).getOctets());
        return v0_1;
    }

    public byte[] getOctets() {
        return this.string;
    }

    public String getString() {
        StringBuffer v1 = new StringBuffer("#");
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        ASN1OutputStream v2 = new ASN1OutputStream(((OutputStream)v0));
        try {
            v2.writeObject(((ASN1Encodable)this));
        }
        catch(IOException v0_1) {
            throw new RuntimeException("internal error encoding BitString");
        }

        byte[] v2_1 = v0.toByteArray();
        int v0_2;
        for(v0_2 = 0; v0_2 != v2_1.length; ++v0_2) {
            v1.append(DERUniversalString.table[v2_1[v0_2] >>> 4 & 15]);
            v1.append(DERUniversalString.table[v2_1[v0_2] & 15]);
        }

        return v1.toString();
    }

    public int hashCode() {
        return Arrays.hashCode(this.string);
    }

    boolean isConstructed() {
        return 0;
    }

    public String toString() {
        return this.getString();
    }
}

