// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1;

import java.io.EOFException;
import java.io.InputStream;
import org.bouncycastle.util.io.Streams;

class DefiniteLengthInputStream extends LimitedInputStream {
    private static final byte[] EMPTY_BYTES;
    private final int _originalLength;
    private int _remaining;

    static {
        DefiniteLengthInputStream.EMPTY_BYTES = new byte[0];
    }

    DefiniteLengthInputStream(InputStream arg3, int arg4) {
        super(arg3, arg4);
        if(arg4 < 0) {
            throw new IllegalArgumentException("negative lengths not allowed");
        }

        this._originalLength = arg4;
        this._remaining = arg4;
        if(arg4 == 0) {
            this.setParentEofDetect(true);
        }
    }

    int getRemaining() {
        return this._remaining;
    }

    public int read() {
        int v0;
        if(this._remaining == 0) {
            v0 = -1;
        }
        else {
            v0 = this._in.read();
            if(v0 < 0) {
                throw new EOFException("DEF length " + this._originalLength + " object truncated by " + this._remaining);
            }
            else {
                int v1 = this._remaining - 1;
                this._remaining = v1;
                if(v1 == 0) {
                    this.setParentEofDetect(true);
                }
            }
        }

        return v0;
    }

    public int read(byte[] arg4, int arg5, int arg6) {
        int v0;
        if(this._remaining == 0) {
            v0 = -1;
        }
        else {
            v0 = this._in.read(arg4, arg5, Math.min(arg6, this._remaining));
            if(v0 < 0) {
                throw new EOFException("DEF length " + this._originalLength + " object truncated by " + this._remaining);
            }
            else {
                int v1 = this._remaining - v0;
                this._remaining = v1;
                if(v1 == 0) {
                    this.setParentEofDetect(true);
                }
            }
        }

        return v0;
    }

    byte[] toByteArray() {
        byte[] v0;
        if(this._remaining == 0) {
            v0 = DefiniteLengthInputStream.EMPTY_BYTES;
        }
        else {
            v0 = new byte[this._remaining];
            int v1 = this._remaining - Streams.readFully(this._in, v0);
            this._remaining = v1;
            if(v1 != 0) {
                throw new EOFException("DEF length " + this._originalLength + " object truncated by " + this._remaining);
            }
            else {
                this.setParentEofDetect(true);
            }
        }

        return v0;
    }
}

