// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AttributeCertificate;
import org.bouncycastle.asn1.x509.Certificate;

public class CMPCertificate extends ASN1Object implements ASN1Choice {
    private AttributeCertificate x509v2AttrCert;
    private Certificate x509v3PKCert;

    public CMPCertificate(AttributeCertificate arg1) {
        super();
        this.x509v2AttrCert = arg1;
    }

    public CMPCertificate(Certificate arg3) {
        super();
        if(arg3.getVersionNumber() != 3) {
            throw new IllegalArgumentException("only version 3 certificates allowed");
        }

        this.x509v3PKCert = arg3;
    }

    public static CMPCertificate getInstance(Object arg3) {
        CMPCertificate v3;
        if(arg3 != null && !(arg3 instanceof CMPCertificate)) {
            if(!(arg3 instanceof ASN1Sequence) && !(arg3 instanceof byte[])) {
                if((arg3 instanceof ASN1TaggedObject)) {
                    v3 = new CMPCertificate(AttributeCertificate.getInstance(((ASN1TaggedObject)arg3).getObject()));
                    return v3;
                }
                else {
                    throw new IllegalArgumentException("Invalid object: " + arg3.getClass().getName());
                }
            }

            v3 = new CMPCertificate(Certificate.getInstance(arg3));
        }

        return v3;
    }

    public AttributeCertificate getX509v2AttrCert() {
        return this.x509v2AttrCert;
    }

    public Certificate getX509v3PKCert() {
        return this.x509v3PKCert;
    }

    public boolean isX509v3PKCert() {
        boolean v0 = this.x509v3PKCert != null ? true : false;
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1Primitive v0_1;
        if(this.x509v2AttrCert != null) {
            DERTaggedObject v0 = new DERTaggedObject(true, 1, this.x509v2AttrCert);
        }
        else {
            v0_1 = this.x509v3PKCert.toASN1Primitive();
        }

        return v0_1;
    }
}

