// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class CertRepMessage extends ASN1Object {
    private ASN1Sequence caPubs;
    private ASN1Sequence response;

    private CertRepMessage(ASN1Sequence arg4) {
        super();
        int v0 = 0;
        if(arg4.size() > 1) {
            this.caPubs = ASN1Sequence.getInstance(arg4.getObjectAt(0), true);
            v0 = 1;
        }

        this.response = ASN1Sequence.getInstance(arg4.getObjectAt(v0));
    }

    public CertRepMessage(CMPCertificate[] arg5, CertResponse[] arg6) {
        int v1 = 0;
        super();
        if(arg6 == null) {
            throw new IllegalArgumentException("\'response\' cannot be null");
        }

        if(arg5 != null) {
            ASN1EncodableVector v2 = new ASN1EncodableVector();
            int v0;
            for(v0 = 0; v0 < arg5.length; ++v0) {
                v2.add(arg5[v0]);
            }

            this.caPubs = new DERSequence(v2);
        }

        ASN1EncodableVector v0_1 = new ASN1EncodableVector();
        while(v1 < arg6.length) {
            v0_1.add(arg6[v1]);
            ++v1;
        }

        this.response = new DERSequence(v0_1);
    }

    public CMPCertificate[] getCaPubs() {
        CMPCertificate[] v0;
        if(this.caPubs == null) {
            v0 = null;
        }
        else {
            CMPCertificate[] v1 = new CMPCertificate[this.caPubs.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v1.length; ++v0_1) {
                v1[v0_1] = CMPCertificate.getInstance(this.caPubs.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public static CertRepMessage getInstance(Object arg2) {
        CertRepMessage v2;
        if(!(arg2 instanceof CertRepMessage)) {
            if(arg2 != null) {
                v2 = new CertRepMessage(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public CertResponse[] getResponse() {
        CertResponse[] v1 = new CertResponse[this.response.size()];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = CertResponse.getInstance(this.response.getObjectAt(v0));
        }

        return v1;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.caPubs != null) {
            v0.add(new DERTaggedObject(true, 1, this.caPubs));
        }

        v0.add(this.response);
        return new DERSequence(v0);
    }
}

