// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class CertResponse extends ASN1Object {
    private ASN1Integer certReqId;
    private CertifiedKeyPair certifiedKeyPair;
    private ASN1OctetString rspInfo;
    private PKIStatusInfo status;

    public CertResponse(ASN1Integer arg2, PKIStatusInfo arg3) {
        this(arg2, arg3, null, null);
    }

    public CertResponse(ASN1Integer arg3, PKIStatusInfo arg4, CertifiedKeyPair arg5, ASN1OctetString arg6) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'certReqId\' cannot be null");
        }

        if(arg4 == null) {
            throw new IllegalArgumentException("\'status\' cannot be null");
        }

        this.certReqId = arg3;
        this.status = arg4;
        this.certifiedKeyPair = arg5;
        this.rspInfo = arg6;
    }

    private CertResponse(ASN1Sequence arg4) {
        int v2 = 2;
        int v1 = 3;
        super();
        this.certReqId = ASN1Integer.getInstance(arg4.getObjectAt(0));
        this.status = PKIStatusInfo.getInstance(arg4.getObjectAt(1));
        if(arg4.size() >= v1) {
            if(arg4.size() == v1) {
                ASN1Encodable v0 = arg4.getObjectAt(v2);
                if((v0 instanceof ASN1OctetString)) {
                    this.rspInfo = ASN1OctetString.getInstance(v0);
                }
                else {
                    this.certifiedKeyPair = CertifiedKeyPair.getInstance(v0);
                }
            }
            else {
                this.certifiedKeyPair = CertifiedKeyPair.getInstance(arg4.getObjectAt(v2));
                this.rspInfo = ASN1OctetString.getInstance(arg4.getObjectAt(v1));
            }
        }
    }

    public ASN1Integer getCertReqId() {
        return this.certReqId;
    }

    public CertifiedKeyPair getCertifiedKeyPair() {
        return this.certifiedKeyPair;
    }

    public static CertResponse getInstance(Object arg2) {
        if(!(arg2 instanceof CertResponse)) {
            if(arg2 != null) {
                CertResponse v2 = new CertResponse(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public PKIStatusInfo getStatus() {
        return this.status;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certReqId);
        v0.add(this.status);
        if(this.certifiedKeyPair != null) {
            v0.add(this.certifiedKeyPair);
        }

        if(this.rspInfo != null) {
            v0.add(this.rspInfo);
        }

        return new DERSequence(v0);
    }
}

