// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class CertStatus extends ASN1Object {
    private ASN1OctetString certHash;
    private ASN1Integer certReqId;
    private PKIStatusInfo statusInfo;

    private CertStatus(ASN1Sequence arg3) {
        int v1 = 2;
        super();
        this.certHash = ASN1OctetString.getInstance(arg3.getObjectAt(0));
        this.certReqId = ASN1Integer.getInstance(arg3.getObjectAt(1));
        if(arg3.size() > v1) {
            this.statusInfo = PKIStatusInfo.getInstance(arg3.getObjectAt(v1));
        }
    }

    public CertStatus(byte[] arg2, BigInteger arg3) {
        super();
        this.certHash = new DEROctetString(arg2);
        this.certReqId = new ASN1Integer(arg3);
    }

    public CertStatus(byte[] arg2, BigInteger arg3, PKIStatusInfo arg4) {
        super();
        this.certHash = new DEROctetString(arg2);
        this.certReqId = new ASN1Integer(arg3);
        this.statusInfo = arg4;
    }

    public ASN1OctetString getCertHash() {
        return this.certHash;
    }

    public ASN1Integer getCertReqId() {
        return this.certReqId;
    }

    public static CertStatus getInstance(Object arg2) {
        CertStatus v2;
        if(!(arg2 instanceof CertStatus)) {
            if(arg2 != null) {
                v2 = new CertStatus(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public PKIStatusInfo getStatusInfo() {
        return this.statusInfo;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certHash);
        v0.add(this.certReqId);
        if(this.statusInfo != null) {
            v0.add(this.statusInfo);
        }

        return new DERSequence(v0);
    }
}

