// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.crmf.EncryptedValue;
import org.bouncycastle.asn1.crmf.PKIPublicationInfo;

public class CertifiedKeyPair extends ASN1Object {
    private CertOrEncCert certOrEncCert;
    private EncryptedValue privateKey;
    private PKIPublicationInfo publicationInfo;

    private CertifiedKeyPair(ASN1Sequence arg4) {
        int v1 = 2;
        super();
        this.certOrEncCert = CertOrEncCert.getInstance(arg4.getObjectAt(0));
        if(arg4.size() >= v1) {
            if(arg4.size() == v1) {
                ASN1TaggedObject v0 = ASN1TaggedObject.getInstance(arg4.getObjectAt(1));
                if(v0.getTagNo() == 0) {
                    this.privateKey = EncryptedValue.getInstance(v0.getObject());
                }
                else {
                    this.publicationInfo = PKIPublicationInfo.getInstance(v0.getObject());
                }
            }
            else {
                this.privateKey = EncryptedValue.getInstance(ASN1TaggedObject.getInstance(arg4.getObjectAt(1)));
                this.publicationInfo = PKIPublicationInfo.getInstance(ASN1TaggedObject.getInstance(arg4.getObjectAt(v1)));
            }
        }
    }

    public CertifiedKeyPair(CertOrEncCert arg2) {
        this(arg2, null, null);
    }

    public CertifiedKeyPair(CertOrEncCert arg3, EncryptedValue arg4, PKIPublicationInfo arg5) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'certOrEncCert\' cannot be null");
        }

        this.certOrEncCert = arg3;
        this.privateKey = arg4;
        this.publicationInfo = arg5;
    }

    public CertOrEncCert getCertOrEncCert() {
        return this.certOrEncCert;
    }

    public static CertifiedKeyPair getInstance(Object arg2) {
        if(!(arg2 instanceof CertifiedKeyPair)) {
            if(arg2 != null) {
                CertifiedKeyPair v2 = new CertifiedKeyPair(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public EncryptedValue getPrivateKey() {
        return this.privateKey;
    }

    public PKIPublicationInfo getPublicationInfo() {
        return this.publicationInfo;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certOrEncCert);
        if(this.privateKey != null) {
            v0.add(new DERTaggedObject(true, 0, this.privateKey));
        }

        if(this.publicationInfo != null) {
            v0.add(new DERTaggedObject(true, 1, this.publicationInfo));
        }

        return new DERSequence(v0);
    }
}

