// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class Challenge extends ASN1Object {
    private ASN1OctetString challenge;
    private AlgorithmIdentifier owf;
    private ASN1OctetString witness;

    private Challenge(ASN1Sequence arg4) {
        int v0;
        super();
        if(arg4.size() == 3) {
            v0 = 1;
            this.owf = AlgorithmIdentifier.getInstance(arg4.getObjectAt(0));
        }
        else {
            v0 = 0;
        }

        this.witness = ASN1OctetString.getInstance(arg4.getObjectAt(v0));
        this.challenge = ASN1OctetString.getInstance(arg4.getObjectAt(v0 + 1));
    }

    public Challenge(AlgorithmIdentifier arg2, byte[] arg3, byte[] arg4) {
        super();
        this.owf = arg2;
        this.witness = new DEROctetString(arg3);
        this.challenge = new DEROctetString(arg4);
    }

    public Challenge(byte[] arg2, byte[] arg3) {
        this(null, arg2, arg3);
    }

    private void addOptional(ASN1EncodableVector arg1, ASN1Encodable arg2) {
        if(arg2 != null) {
            arg1.add(arg2);
        }
    }

    public byte[] getChallenge() {
        return this.challenge.getOctets();
    }

    public static Challenge getInstance(Object arg2) {
        if(!(arg2 instanceof Challenge)) {
            if(arg2 != null) {
                Challenge v2 = new Challenge(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public AlgorithmIdentifier getOwf() {
        return this.owf;
    }

    public byte[] getWitness() {
        return this.witness.getOctets();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        this.addOptional(v0, this.owf);
        v0.add(this.witness);
        v0.add(this.challenge);
        return new DERSequence(v0);
    }
}

