// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class ErrorMsgContent extends ASN1Object {
    private ASN1Integer errorCode;
    private PKIFreeText errorDetails;
    private PKIStatusInfo pkiStatusInfo;

    private ErrorMsgContent(ASN1Sequence arg4) {
        super();
        Enumeration v0 = arg4.getObjects();
        this.pkiStatusInfo = PKIStatusInfo.getInstance(v0.nextElement());
        while(v0.hasMoreElements()) {
            Object v1 = v0.nextElement();
            if((v1 instanceof ASN1Integer)) {
                this.errorCode = ASN1Integer.getInstance(v1);
                continue;
            }

            this.errorDetails = PKIFreeText.getInstance(v1);
        }
    }

    public ErrorMsgContent(PKIStatusInfo arg2) {
        this(arg2, null, null);
    }

    public ErrorMsgContent(PKIStatusInfo arg3, ASN1Integer arg4, PKIFreeText arg5) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'pkiStatusInfo\' cannot be null");
        }

        this.pkiStatusInfo = arg3;
        this.errorCode = arg4;
        this.errorDetails = arg5;
    }

    private void addOptional(ASN1EncodableVector arg1, ASN1Encodable arg2) {
        if(arg2 != null) {
            arg1.add(arg2);
        }
    }

    public ASN1Integer getErrorCode() {
        return this.errorCode;
    }

    public PKIFreeText getErrorDetails() {
        return this.errorDetails;
    }

    public static ErrorMsgContent getInstance(Object arg2) {
        if(!(arg2 instanceof ErrorMsgContent)) {
            if(arg2 != null) {
                ErrorMsgContent v2 = new ErrorMsgContent(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public PKIStatusInfo getPKIStatusInfo() {
        return this.pkiStatusInfo;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.pkiStatusInfo);
        this.addOptional(v0, this.errorCode);
        this.addOptional(v0, this.errorDetails);
        return new DERSequence(v0);
    }
}

