// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class InfoTypeAndValue extends ASN1Object {
    private ASN1ObjectIdentifier infoType;
    private ASN1Encodable infoValue;

    public InfoTypeAndValue(ASN1ObjectIdentifier arg2) {
        super();
        this.infoType = arg2;
        this.infoValue = null;
    }

    public InfoTypeAndValue(ASN1ObjectIdentifier arg1, ASN1Encodable arg2) {
        super();
        this.infoType = arg1;
        this.infoValue = arg2;
    }

    private InfoTypeAndValue(ASN1Sequence arg3) {
        super();
        this.infoType = ASN1ObjectIdentifier.getInstance(arg3.getObjectAt(0));
        if(arg3.size() > 1) {
            this.infoValue = arg3.getObjectAt(1);
        }
    }

    public ASN1ObjectIdentifier getInfoType() {
        return this.infoType;
    }

    public ASN1Encodable getInfoValue() {
        return this.infoValue;
    }

    public static InfoTypeAndValue getInstance(Object arg2) {
        InfoTypeAndValue v2;
        if(!(arg2 instanceof InfoTypeAndValue)) {
            if(arg2 != null) {
                v2 = new InfoTypeAndValue(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.infoType);
        if(this.infoValue != null) {
            v0.add(this.infoValue);
        }

        return new DERSequence(v0);
    }
}

