// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class KeyRecRepContent extends ASN1Object {
    private ASN1Sequence caCerts;
    private ASN1Sequence keyPairHist;
    private CMPCertificate newSigCert;
    private PKIStatusInfo status;

    private KeyRecRepContent(ASN1Sequence arg5) {
        super();
        Enumeration v0 = arg5.getObjects();
        this.status = PKIStatusInfo.getInstance(v0.nextElement());
        while(v0.hasMoreElements()) {
            ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0.nextElement());
            switch(v1.getTagNo()) {
                case 0: {
                    goto label_21;
                }
                case 1: {
                    goto label_25;
                }
                case 2: {
                    goto label_29;
                }
            }

            throw new IllegalArgumentException("unknown tag number: " + v1.getTagNo());
        label_21:
            this.newSigCert = CMPCertificate.getInstance(v1.getObject());
            continue;
        label_25:
            this.caCerts = ASN1Sequence.getInstance(v1.getObject());
            continue;
        label_29:
            this.keyPairHist = ASN1Sequence.getInstance(v1.getObject());
        }
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(true, arg4, arg5));
        }
    }

    public CMPCertificate[] getCaCerts() {
        CMPCertificate[] v0;
        if(this.caCerts == null) {
            v0 = null;
        }
        else {
            CMPCertificate[] v1 = new CMPCertificate[this.caCerts.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v1.length; ++v0_1) {
                v1[v0_1] = CMPCertificate.getInstance(this.caCerts.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public static KeyRecRepContent getInstance(Object arg2) {
        KeyRecRepContent v2;
        if(!(arg2 instanceof KeyRecRepContent)) {
            if(arg2 != null) {
                v2 = new KeyRecRepContent(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public CertifiedKeyPair[] getKeyPairHist() {
        CertifiedKeyPair[] v0;
        if(this.keyPairHist == null) {
            v0 = null;
        }
        else {
            CertifiedKeyPair[] v1 = new CertifiedKeyPair[this.keyPairHist.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v1.length; ++v0_1) {
                v1[v0_1] = CertifiedKeyPair.getInstance(this.keyPairHist.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public CMPCertificate getNewSigCert() {
        return this.newSigCert;
    }

    public PKIStatusInfo getStatus() {
        return this.status;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.status);
        this.addOptional(v0, 0, this.newSigCert);
        this.addOptional(v0, 1, this.caCerts);
        this.addOptional(v0, 2, this.keyPairHist);
        return new DERSequence(v0);
    }
}

