// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.crmf.CertId;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class OOBCertHash extends ASN1Object {
    private CertId certId;
    private AlgorithmIdentifier hashAlg;
    private DERBitString hashVal;

    private OOBCertHash(ASN1Sequence arg5) {
        super();
        int v1 = arg5.size() - 1;
        this.hashVal = DERBitString.getInstance(arg5.getObjectAt(v1));
        --v1;
        while(v1 >= 0) {
            ASN1Encodable v0 = arg5.getObjectAt(v1);
            if(((ASN1TaggedObject)v0).getTagNo() == 0) {
                this.hashAlg = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
            }
            else {
                this.certId = CertId.getInstance(((ASN1TaggedObject)v0), true);
            }

            --v1;
        }
    }

    public OOBCertHash(AlgorithmIdentifier arg1, CertId arg2, DERBitString arg3) {
        super();
        this.hashAlg = arg1;
        this.certId = arg2;
        this.hashVal = arg3;
    }

    public OOBCertHash(AlgorithmIdentifier arg2, CertId arg3, byte[] arg4) {
        this(arg2, arg3, new DERBitString(arg4));
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(true, arg4, arg5));
        }
    }

    public CertId getCertId() {
        return this.certId;
    }

    public AlgorithmIdentifier getHashAlg() {
        return this.hashAlg;
    }

    public DERBitString getHashVal() {
        return this.hashVal;
    }

    public static OOBCertHash getInstance(Object arg2) {
        OOBCertHash v2;
        if(!(arg2 instanceof OOBCertHash)) {
            if(arg2 != null) {
                v2 = new OOBCertHash(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        this.addOptional(v0, 0, this.hashAlg);
        this.addOptional(v0, 1, this.certId);
        v0.add(this.hashVal);
        return new DERSequence(v0);
    }
}

