// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.crmf.CertReqMessages;
import org.bouncycastle.asn1.pkcs.CertificationRequest;

public class PKIBody extends ASN1Object implements ASN1Choice {
    public static final int TYPE_CA_KEY_UPDATE_ANN = 15;
    public static final int TYPE_CERT_ANN = 16;
    public static final int TYPE_CERT_CONFIRM = 24;
    public static final int TYPE_CERT_REP = 3;
    public static final int TYPE_CERT_REQ = 2;
    public static final int TYPE_CONFIRM = 19;
    public static final int TYPE_CRL_ANN = 18;
    public static final int TYPE_CROSS_CERT_REP = 14;
    public static final int TYPE_CROSS_CERT_REQ = 13;
    public static final int TYPE_ERROR = 23;
    public static final int TYPE_GEN_MSG = 21;
    public static final int TYPE_GEN_REP = 22;
    public static final int TYPE_INIT_REP = 1;
    public static final int TYPE_INIT_REQ = 0;
    public static final int TYPE_KEY_RECOVERY_REP = 10;
    public static final int TYPE_KEY_RECOVERY_REQ = 9;
    public static final int TYPE_KEY_UPDATE_REP = 8;
    public static final int TYPE_KEY_UPDATE_REQ = 7;
    public static final int TYPE_NESTED = 20;
    public static final int TYPE_P10_CERT_REQ = 4;
    public static final int TYPE_POLL_REP = 26;
    public static final int TYPE_POLL_REQ = 25;
    public static final int TYPE_POPO_CHALL = 5;
    public static final int TYPE_POPO_REP = 6;
    public static final int TYPE_REVOCATION_ANN = 17;
    public static final int TYPE_REVOCATION_REP = 12;
    public static final int TYPE_REVOCATION_REQ = 11;
    private ASN1Encodable body;
    private int tagNo;

    public PKIBody(int arg2, ASN1Encodable arg3) {
        super();
        this.tagNo = arg2;
        this.body = PKIBody.getBodyForType(arg2, arg3);
    }

    private PKIBody(ASN1TaggedObject arg3) {
        super();
        this.tagNo = arg3.getTagNo();
        this.body = PKIBody.getBodyForType(this.tagNo, arg3.getObject());
    }

    private static ASN1Encodable getBodyForType(int arg3, ASN1Encodable arg4) {
        switch(arg3) {
            case 0: {
                goto label_10;
            }
            case 1: {
                goto label_12;
            }
            case 2: {
                goto label_14;
            }
            case 3: {
                goto label_16;
            }
            case 4: {
                goto label_18;
            }
            case 5: {
                goto label_20;
            }
            case 6: {
                goto label_22;
            }
            case 7: {
                goto label_24;
            }
            case 8: {
                goto label_26;
            }
            case 9: {
                goto label_28;
            }
            case 10: {
                goto label_30;
            }
            case 11: {
                goto label_32;
            }
            case 12: {
                goto label_34;
            }
            case 13: {
                goto label_36;
            }
            case 14: {
                goto label_38;
            }
            case 15: {
                goto label_40;
            }
            case 16: {
                goto label_42;
            }
            case 17: {
                goto label_44;
            }
            case 18: {
                goto label_46;
            }
            case 19: {
                goto label_48;
            }
            case 20: {
                goto label_50;
            }
            case 21: {
                goto label_52;
            }
            case 22: {
                goto label_54;
            }
            case 23: {
                goto label_56;
            }
            case 24: {
                goto label_58;
            }
            case 25: {
                goto label_60;
            }
            case 26: {
                goto label_62;
            }
        }

        throw new IllegalArgumentException("unknown tag number: " + arg3);
    label_38:
        CertRepMessage v0 = CertRepMessage.getInstance(arg4);
        goto label_11;
    label_40:
        CAKeyUpdAnnContent v0_1 = CAKeyUpdAnnContent.getInstance(arg4);
        goto label_11;
    label_34:
        RevRepContent v0_2 = RevRepContent.getInstance(arg4);
        goto label_11;
    label_36:
        CertReqMessages v0_3 = CertReqMessages.getInstance(arg4);
        goto label_11;
    label_46:
        CRLAnnContent v0_4 = CRLAnnContent.getInstance(arg4);
        goto label_11;
    label_48:
        PKIConfirmContent v0_5 = PKIConfirmContent.getInstance(arg4);
        goto label_11;
    label_42:
        CMPCertificate v0_6 = CMPCertificate.getInstance(arg4);
        goto label_11;
    label_44:
        RevAnnContent v0_7 = RevAnnContent.getInstance(arg4);
        goto label_11;
    label_54:
        GenRepContent v0_8 = GenRepContent.getInstance(arg4);
        goto label_11;
    label_56:
        ErrorMsgContent v0_9 = ErrorMsgContent.getInstance(arg4);
        goto label_11;
    label_50:
        PKIMessages v0_10 = PKIMessages.getInstance(arg4);
        goto label_11;
    label_52:
        GenMsgContent v0_11 = GenMsgContent.getInstance(arg4);
        goto label_11;
    label_62:
        PollRepContent v0_12 = PollRepContent.getInstance(arg4);
        goto label_11;
    label_58:
        CertConfirmContent v0_13 = CertConfirmContent.getInstance(arg4);
        goto label_11;
    label_60:
        PollReqContent v0_14 = PollReqContent.getInstance(arg4);
        goto label_11;
    label_12:
        v0 = CertRepMessage.getInstance(arg4);
        goto label_11;
    label_10:
        v0_3 = CertReqMessages.getInstance(arg4);
        goto label_11;
    label_16:
        v0 = CertRepMessage.getInstance(arg4);
        goto label_11;
    label_14:
        v0_3 = CertReqMessages.getInstance(arg4);
        goto label_11;
    label_20:
        POPODecKeyChallContent v0_15 = POPODecKeyChallContent.getInstance(arg4);
        goto label_11;
    label_18:
        CertificationRequest v0_16 = CertificationRequest.getInstance(arg4);
        goto label_11;
    label_24:
        v0_3 = CertReqMessages.getInstance(arg4);
        goto label_11;
    label_22:
        POPODecKeyRespContent v0_17 = POPODecKeyRespContent.getInstance(arg4);
        goto label_11;
    label_28:
        v0_3 = CertReqMessages.getInstance(arg4);
        goto label_11;
    label_26:
        v0 = CertRepMessage.getInstance(arg4);
        goto label_11;
    label_32:
        RevReqContent v0_18 = RevReqContent.getInstance(arg4);
        goto label_11;
    label_30:
        KeyRecRepContent v0_19 = KeyRecRepContent.getInstance(arg4);
    label_11:
        return ((ASN1Encodable)v0_10);
    }

    public ASN1Encodable getContent() {
        return this.body;
    }

    public static PKIBody getInstance(Object arg3) {
        PKIBody v3;
        if(arg3 != null && !(arg3 instanceof PKIBody)) {
            if((arg3 instanceof ASN1TaggedObject)) {
                v3 = new PKIBody(((ASN1TaggedObject)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid object: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public int getType() {
        return this.tagNo;
    }

    public ASN1Primitive toASN1Primitive() {
        return new DERTaggedObject(true, this.tagNo, this.body);
    }
}

