// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.GeneralName;

public class PKIHeader extends ASN1Object {
    public static final int CMP_1999 = 1;
    public static final int CMP_2000 = 2;
    public static final GeneralName NULL_NAME;
    private PKIFreeText freeText;
    private ASN1Sequence generalInfo;
    private DERGeneralizedTime messageTime;
    private AlgorithmIdentifier protectionAlg;
    private ASN1Integer pvno;
    private ASN1OctetString recipKID;
    private ASN1OctetString recipNonce;
    private GeneralName recipient;
    private GeneralName sender;
    private ASN1OctetString senderKID;
    private ASN1OctetString senderNonce;
    private ASN1OctetString transactionID;

    static {
        PKIHeader.NULL_NAME = new GeneralName(X500Name.getInstance(new DERSequence()));
    }

    public PKIHeader(int arg4, GeneralName arg5, GeneralName arg6) {
        this(new ASN1Integer(((long)arg4)), arg5, arg6);
    }

    private PKIHeader(ASN1Integer arg1, GeneralName arg2, GeneralName arg3) {
        super();
        this.pvno = arg1;
        this.sender = arg2;
        this.recipient = arg3;
    }

    private PKIHeader(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        this.pvno = ASN1Integer.getInstance(v1.nextElement());
        this.sender = GeneralName.getInstance(v1.nextElement());
        this.recipient = GeneralName.getInstance(v1.nextElement());
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_27;
                }
                case 1: {
                    goto label_30;
                }
                case 2: {
                    goto label_33;
                }
                case 3: {
                    goto label_36;
                }
                case 4: {
                    goto label_39;
                }
                case 5: {
                    goto label_42;
                }
                case 6: {
                    goto label_45;
                }
                case 7: {
                    goto label_48;
                }
                case 8: {
                    goto label_51;
                }
            }

            throw new IllegalArgumentException("unknown tag number: " + ((ASN1TaggedObject)v0).getTagNo());
        label_39:
            this.transactionID = ASN1OctetString.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_33:
            this.senderKID = ASN1OctetString.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_51:
            this.generalInfo = ASN1Sequence.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_36:
            this.recipKID = ASN1OctetString.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_45:
            this.recipNonce = ASN1OctetString.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_27:
            this.messageTime = DERGeneralizedTime.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_48:
            this.freeText = PKIFreeText.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_42:
            this.senderNonce = ASN1OctetString.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_30:
            this.protectionAlg = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
        }
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(true, arg4, arg5));
        }
    }

    public PKIFreeText getFreeText() {
        return this.freeText;
    }

    public InfoTypeAndValue[] getGeneralInfo() {
        InfoTypeAndValue[] v0;
        if(this.generalInfo == null) {
            v0 = null;
        }
        else {
            InfoTypeAndValue[] v1 = new InfoTypeAndValue[this.generalInfo.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 < v1.length; ++v0_1) {
                v1[v0_1] = InfoTypeAndValue.getInstance(this.generalInfo.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public static PKIHeader getInstance(Object arg2) {
        PKIHeader v2;
        if(!(arg2 instanceof PKIHeader)) {
            if(arg2 != null) {
                v2 = new PKIHeader(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public DERGeneralizedTime getMessageTime() {
        return this.messageTime;
    }

    public AlgorithmIdentifier getProtectionAlg() {
        return this.protectionAlg;
    }

    public ASN1Integer getPvno() {
        return this.pvno;
    }

    public ASN1OctetString getRecipKID() {
        return this.recipKID;
    }

    public ASN1OctetString getRecipNonce() {
        return this.recipNonce;
    }

    public GeneralName getRecipient() {
        return this.recipient;
    }

    public GeneralName getSender() {
        return this.sender;
    }

    public ASN1OctetString getSenderKID() {
        return this.senderKID;
    }

    public ASN1OctetString getSenderNonce() {
        return this.senderNonce;
    }

    public ASN1OctetString getTransactionID() {
        return this.transactionID;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.pvno);
        v0.add(this.sender);
        v0.add(this.recipient);
        this.addOptional(v0, 0, this.messageTime);
        this.addOptional(v0, 1, this.protectionAlg);
        this.addOptional(v0, 2, this.senderKID);
        this.addOptional(v0, 3, this.recipKID);
        this.addOptional(v0, 4, this.transactionID);
        this.addOptional(v0, 5, this.senderNonce);
        this.addOptional(v0, 6, this.recipNonce);
        this.addOptional(v0, 7, this.freeText);
        this.addOptional(v0, 8, this.generalInfo);
        return new DERSequence(v0);
    }
}

