// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.GeneralName;

public class PKIHeaderBuilder {
    private PKIFreeText freeText;
    private ASN1Sequence generalInfo;
    private ASN1GeneralizedTime messageTime;
    private AlgorithmIdentifier protectionAlg;
    private ASN1Integer pvno;
    private ASN1OctetString recipKID;
    private ASN1OctetString recipNonce;
    private GeneralName recipient;
    private GeneralName sender;
    private ASN1OctetString senderKID;
    private ASN1OctetString senderNonce;
    private ASN1OctetString transactionID;

    public PKIHeaderBuilder(int arg4, GeneralName arg5, GeneralName arg6) {
        this(new ASN1Integer(((long)arg4)), arg5, arg6);
    }

    private PKIHeaderBuilder(ASN1Integer arg1, GeneralName arg2, GeneralName arg3) {
        super();
        this.pvno = arg1;
        this.sender = arg2;
        this.recipient = arg3;
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(true, arg4, arg5));
        }
    }

    public PKIHeader build() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.pvno);
        v0.add(this.sender);
        v0.add(this.recipient);
        this.addOptional(v0, 0, this.messageTime);
        this.addOptional(v0, 1, this.protectionAlg);
        this.addOptional(v0, 2, this.senderKID);
        this.addOptional(v0, 3, this.recipKID);
        this.addOptional(v0, 4, this.transactionID);
        this.addOptional(v0, 5, this.senderNonce);
        this.addOptional(v0, 6, this.recipNonce);
        this.addOptional(v0, 7, this.freeText);
        this.addOptional(v0, 8, this.generalInfo);
        this.messageTime = null;
        this.protectionAlg = null;
        this.senderKID = null;
        this.recipKID = null;
        this.transactionID = null;
        this.senderNonce = null;
        this.recipNonce = null;
        this.freeText = null;
        this.generalInfo = null;
        return PKIHeader.getInstance(new DERSequence(v0));
    }

    private static ASN1Sequence makeGeneralInfoSeq(InfoTypeAndValue arg1) {
        return new DERSequence(((ASN1Encodable)arg1));
    }

    private static ASN1Sequence makeGeneralInfoSeq(InfoTypeAndValue[] arg3) {
        ASN1Sequence v0 = null;
        if(arg3 != null) {
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            int v0_1;
            for(v0_1 = 0; v0_1 < arg3.length; ++v0_1) {
                v1.add(arg3[v0_1]);
            }

            DERSequence v0_2 = new DERSequence(v1);
        }

        return v0;
    }

    public PKIHeaderBuilder setFreeText(PKIFreeText arg1) {
        this.freeText = arg1;
        return this;
    }

    public PKIHeaderBuilder setGeneralInfo(ASN1Sequence arg1) {
        this.generalInfo = arg1;
        return this;
    }

    public PKIHeaderBuilder setGeneralInfo(InfoTypeAndValue arg2) {
        return this.setGeneralInfo(PKIHeaderBuilder.makeGeneralInfoSeq(arg2));
    }

    public PKIHeaderBuilder setGeneralInfo(InfoTypeAndValue[] arg2) {
        return this.setGeneralInfo(PKIHeaderBuilder.makeGeneralInfoSeq(arg2));
    }

    public PKIHeaderBuilder setMessageTime(ASN1GeneralizedTime arg1) {
        this.messageTime = arg1;
        return this;
    }

    public PKIHeaderBuilder setMessageTime(DERGeneralizedTime arg2) {
        this.messageTime = ASN1GeneralizedTime.getInstance(arg2);
        return this;
    }

    public PKIHeaderBuilder setProtectionAlg(AlgorithmIdentifier arg1) {
        this.protectionAlg = arg1;
        return this;
    }

    public PKIHeaderBuilder setRecipKID(DEROctetString arg1) {
        this.recipKID = ((ASN1OctetString)arg1);
        return this;
    }

    public PKIHeaderBuilder setRecipKID(byte[] arg2) {
        DEROctetString v0 = arg2 == null ? null : new DEROctetString(arg2);
        return this.setRecipKID(v0);
    }

    public PKIHeaderBuilder setRecipNonce(ASN1OctetString arg1) {
        this.recipNonce = arg1;
        return this;
    }

    public PKIHeaderBuilder setRecipNonce(byte[] arg2) {
        DEROctetString v0_1;
        if(arg2 == null) {
            ASN1OctetString v0 = null;
        }
        else {
            v0_1 = new DEROctetString(arg2);
        }

        return this.setRecipNonce(((ASN1OctetString)v0_1));
    }

    public PKIHeaderBuilder setSenderKID(ASN1OctetString arg1) {
        this.senderKID = arg1;
        return this;
    }

    public PKIHeaderBuilder setSenderKID(byte[] arg2) {
        ASN1OctetString v0;
        if(arg2 == null) {
            v0 = null;
        }
        else {
            DEROctetString v0_1 = new DEROctetString(arg2);
        }

        return this.setSenderKID(v0);
    }

    public PKIHeaderBuilder setSenderNonce(ASN1OctetString arg1) {
        this.senderNonce = arg1;
        return this;
    }

    public PKIHeaderBuilder setSenderNonce(byte[] arg2) {
        ASN1OctetString v0;
        if(arg2 == null) {
            v0 = null;
        }
        else {
            DEROctetString v0_1 = new DEROctetString(arg2);
        }

        return this.setSenderNonce(v0);
    }

    public PKIHeaderBuilder setTransactionID(ASN1OctetString arg1) {
        this.transactionID = arg1;
        return this;
    }

    public PKIHeaderBuilder setTransactionID(byte[] arg2) {
        DEROctetString v0_1;
        if(arg2 == null) {
            ASN1OctetString v0 = null;
        }
        else {
            v0_1 = new DEROctetString(arg2);
        }

        return this.setTransactionID(((ASN1OctetString)v0_1));
    }
}

