// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class PKIMessage extends ASN1Object {
    private PKIBody body;
    private ASN1Sequence extraCerts;
    private PKIHeader header;
    private DERBitString protection;

    private PKIMessage(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        this.header = PKIHeader.getInstance(v1.nextElement());
        this.body = PKIBody.getInstance(v1.nextElement());
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            if(((ASN1TaggedObject)v0).getTagNo() == 0) {
                this.protection = DERBitString.getInstance(((ASN1TaggedObject)v0), true);
                continue;
            }

            this.extraCerts = ASN1Sequence.getInstance(((ASN1TaggedObject)v0), true);
        }
    }

    public PKIMessage(PKIHeader arg2, PKIBody arg3) {
        this(arg2, arg3, null, null);
    }

    public PKIMessage(PKIHeader arg4, PKIBody arg5, DERBitString arg6, CMPCertificate[] arg7) {
        super();
        this.header = arg4;
        this.body = arg5;
        this.protection = arg6;
        if(arg7 != null) {
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            int v0;
            for(v0 = 0; v0 < arg7.length; ++v0) {
                v1.add(arg7[v0]);
            }

            this.extraCerts = new DERSequence(v1);
        }
    }

    public PKIMessage(PKIHeader arg2, PKIBody arg3, DERBitString arg4) {
        this(arg2, arg3, arg4, null);
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(true, arg4, arg5));
        }
    }

    public PKIBody getBody() {
        return this.body;
    }

    public CMPCertificate[] getExtraCerts() {
        CMPCertificate[] v0;
        if(this.extraCerts == null) {
            v0 = null;
        }
        else {
            CMPCertificate[] v1 = new CMPCertificate[this.extraCerts.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 < v1.length; ++v0_1) {
                v1[v0_1] = CMPCertificate.getInstance(this.extraCerts.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public PKIHeader getHeader() {
        return this.header;
    }

    public static PKIMessage getInstance(Object arg2) {
        if(!(arg2 instanceof PKIMessage)) {
            if(arg2 != null) {
                PKIMessage v2 = new PKIMessage(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public DERBitString getProtection() {
        return this.protection;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.header);
        v0.add(this.body);
        this.addOptional(v0, 0, this.protection);
        this.addOptional(v0, 1, this.extraCerts);
        return new DERSequence(v0);
    }
}

