// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class PKIStatusInfo extends ASN1Object {
    DERBitString failInfo;
    ASN1Integer status;
    PKIFreeText statusString;

    private PKIStatusInfo(ASN1Sequence arg5) {
        int v2 = 2;
        super();
        this.status = ASN1Integer.getInstance(arg5.getObjectAt(0));
        this.statusString = null;
        this.failInfo = null;
        if(arg5.size() > v2) {
            this.statusString = PKIFreeText.getInstance(arg5.getObjectAt(1));
            this.failInfo = DERBitString.getInstance(arg5.getObjectAt(v2));
        }
        else if(arg5.size() > 1) {
            ASN1Encodable v0 = arg5.getObjectAt(1);
            if((v0 instanceof DERBitString)) {
                this.failInfo = DERBitString.getInstance(v0);
            }
            else {
                this.statusString = PKIFreeText.getInstance(v0);
            }
        }
    }

    public PKIStatusInfo(PKIStatus arg2) {
        super();
        this.status = ASN1Integer.getInstance(arg2.toASN1Primitive());
    }

    public PKIStatusInfo(PKIStatus arg2, PKIFreeText arg3) {
        super();
        this.status = ASN1Integer.getInstance(arg2.toASN1Primitive());
        this.statusString = arg3;
    }

    public PKIStatusInfo(PKIStatus arg2, PKIFreeText arg3, PKIFailureInfo arg4) {
        super();
        this.status = ASN1Integer.getInstance(arg2.toASN1Primitive());
        this.statusString = arg3;
        this.failInfo = ((DERBitString)arg4);
    }

    public DERBitString getFailInfo() {
        return this.failInfo;
    }

    public static PKIStatusInfo getInstance(Object arg2) {
        PKIStatusInfo v2;
        if(!(arg2 instanceof PKIStatusInfo)) {
            if(arg2 != null) {
                v2 = new PKIStatusInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static PKIStatusInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return PKIStatusInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public BigInteger getStatus() {
        return this.status.getValue();
    }

    public PKIFreeText getStatusString() {
        return this.statusString;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.status);
        if(this.statusString != null) {
            v0.add(this.statusString);
        }

        if(this.failInfo != null) {
            v0.add(this.failInfo);
        }

        return new DERSequence(v0);
    }
}

