// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.crmf.CertId;
import org.bouncycastle.asn1.x509.Extensions;

public class RevAnnContent extends ASN1Object {
    private ASN1GeneralizedTime badSinceDate;
    private CertId certId;
    private Extensions crlDetails;
    private PKIStatus status;
    private ASN1GeneralizedTime willBeRevokedAt;

    private RevAnnContent(ASN1Sequence arg3) {
        int v1 = 4;
        super();
        this.status = PKIStatus.getInstance(arg3.getObjectAt(0));
        this.certId = CertId.getInstance(arg3.getObjectAt(1));
        this.willBeRevokedAt = ASN1GeneralizedTime.getInstance(arg3.getObjectAt(2));
        this.badSinceDate = ASN1GeneralizedTime.getInstance(arg3.getObjectAt(3));
        if(arg3.size() > v1) {
            this.crlDetails = Extensions.getInstance(arg3.getObjectAt(v1));
        }
    }

    public ASN1GeneralizedTime getBadSinceDate() {
        return this.badSinceDate;
    }

    public CertId getCertId() {
        return this.certId;
    }

    public Extensions getCrlDetails() {
        return this.crlDetails;
    }

    public static RevAnnContent getInstance(Object arg2) {
        RevAnnContent v2;
        if(!(arg2 instanceof RevAnnContent)) {
            if(arg2 != null) {
                v2 = new RevAnnContent(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public PKIStatus getStatus() {
        return this.status;
    }

    public ASN1GeneralizedTime getWillBeRevokedAt() {
        return this.willBeRevokedAt;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.status);
        v0.add(this.certId);
        v0.add(this.willBeRevokedAt);
        v0.add(this.badSinceDate);
        if(this.crlDetails != null) {
            v0.add(this.crlDetails);
        }

        return new DERSequence(v0);
    }
}

