// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.crmf.CertTemplate;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.X509Extensions;

public class RevDetails extends ASN1Object {
    private CertTemplate certDetails;
    private Extensions crlEntryDetails;

    private RevDetails(ASN1Sequence arg3) {
        super();
        this.certDetails = CertTemplate.getInstance(arg3.getObjectAt(0));
        if(arg3.size() > 1) {
            this.crlEntryDetails = Extensions.getInstance(arg3.getObjectAt(1));
        }
    }

    public RevDetails(CertTemplate arg1) {
        super();
        this.certDetails = arg1;
    }

    public RevDetails(CertTemplate arg1, Extensions arg2) {
        super();
        this.certDetails = arg1;
        this.crlEntryDetails = arg2;
    }

    public RevDetails(CertTemplate arg2, X509Extensions arg3) {
        super();
        this.certDetails = arg2;
        this.crlEntryDetails = Extensions.getInstance(arg3.toASN1Primitive());
    }

    public CertTemplate getCertDetails() {
        return this.certDetails;
    }

    public Extensions getCrlEntryDetails() {
        return this.crlEntryDetails;
    }

    public static RevDetails getInstance(Object arg2) {
        if(!(arg2 instanceof RevDetails)) {
            if(arg2 != null) {
                RevDetails v2 = new RevDetails(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certDetails);
        if(this.crlEntryDetails != null) {
            v0.add(this.crlEntryDetails);
        }

        return new DERSequence(v0);
    }
}

