// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cmp;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.crmf.CertId;
import org.bouncycastle.asn1.x509.CertificateList;

public class RevRepContent extends ASN1Object {
    private ASN1Sequence crls;
    private ASN1Sequence revCerts;
    private ASN1Sequence status;

    private RevRepContent(ASN1Sequence arg5) {
        super();
        Enumeration v0 = arg5.getObjects();
        this.status = ASN1Sequence.getInstance(v0.nextElement());
        while(v0.hasMoreElements()) {
            ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0.nextElement());
            if(v1.getTagNo() == 0) {
                this.revCerts = ASN1Sequence.getInstance(v1, true);
                continue;
            }

            this.crls = ASN1Sequence.getInstance(v1, true);
        }
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(true, arg4, arg5));
        }
    }

    public CertificateList[] getCrls() {
        CertificateList[] v0;
        if(this.crls == null) {
            v0 = null;
        }
        else {
            CertificateList[] v1 = new CertificateList[this.crls.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v1.length; ++v0_1) {
                v1[v0_1] = CertificateList.getInstance(this.crls.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public static RevRepContent getInstance(Object arg2) {
        RevRepContent v2;
        if(!(arg2 instanceof RevRepContent)) {
            if(arg2 != null) {
                v2 = new RevRepContent(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public CertId[] getRevCerts() {
        CertId[] v0;
        if(this.revCerts == null) {
            v0 = null;
        }
        else {
            CertId[] v1 = new CertId[this.revCerts.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v1.length; ++v0_1) {
                v1[v0_1] = CertId.getInstance(this.revCerts.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public PKIStatusInfo[] getStatus() {
        PKIStatusInfo[] v1 = new PKIStatusInfo[this.status.size()];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = PKIStatusInfo.getInstance(this.status.getObjectAt(v0));
        }

        return v1;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.status);
        this.addOptional(v0, 0, this.revCerts);
        this.addOptional(v0, 1, this.crls);
        return new DERSequence(v0);
    }
}

