// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSet;

public class AttributeTable {
    private Hashtable attributes;

    public AttributeTable(Hashtable arg2) {
        super();
        this.attributes = new Hashtable();
        this.attributes = this.copyTable(arg2);
    }

    public AttributeTable(ASN1EncodableVector arg4) {
        super();
        this.attributes = new Hashtable();
        int v0;
        for(v0 = 0; v0 != arg4.size(); ++v0) {
            Attribute v1 = Attribute.getInstance(arg4.get(v0));
            this.addAttribute(v1.getAttrType(), v1);
        }
    }

    public AttributeTable(ASN1Set arg4) {
        super();
        this.attributes = new Hashtable();
        int v0;
        for(v0 = 0; v0 != arg4.size(); ++v0) {
            Attribute v1 = Attribute.getInstance(arg4.getObjectAt(v0));
            this.addAttribute(v1.getAttrType(), v1);
        }
    }

    public AttributeTable(Attribute arg2) {
        super();
        this.attributes = new Hashtable();
        this.addAttribute(arg2.getAttrType(), arg2);
    }

    public AttributeTable(Attributes arg2) {
        this(ASN1Set.getInstance(arg2.toASN1Primitive()));
    }

    public AttributeTable add(ASN1ObjectIdentifier arg4, ASN1Encodable arg5) {
        AttributeTable v0 = new AttributeTable(this.attributes);
        v0.addAttribute(arg4, new Attribute(arg4, new DERSet(arg5)));
        return v0;
    }

    private void addAttribute(ASN1ObjectIdentifier arg3, Attribute arg4) {
        Object v0 = this.attributes.get(arg3);
        if(v0 == null) {
            this.attributes.put(arg3, arg4);
        }
        else {
            if((v0 instanceof Attribute)) {
                Vector v1 = new Vector();
                v1.addElement(v0);
                v1.addElement(arg4);
                Vector v0_1 = v1;
            }
            else {
                ((Vector)v0).addElement(arg4);
            }

            this.attributes.put(arg3, v0);
        }
    }

    private Hashtable copyTable(Hashtable arg5) {
        Hashtable v0 = new Hashtable();
        Enumeration v1 = arg5.keys();
        while(v1.hasMoreElements()) {
            Object v2 = v1.nextElement();
            v0.put(v2, arg5.get(v2));
        }

        return v0;
    }

    public Attribute get(ASN1ObjectIdentifier arg3) {
        Object v0 = this.attributes.get(arg3);
        if((v0 instanceof Vector)) {
            v0 = ((Vector)v0).elementAt(0);
        }

        return ((Attribute)v0);
    }

    public Attribute get(DERObjectIdentifier arg3) {
        return this.get(new ASN1ObjectIdentifier(arg3.getId()));
    }

    public ASN1EncodableVector getAll(ASN1ObjectIdentifier arg4) {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        Object v0 = this.attributes.get(arg4);
        if((v0 instanceof Vector)) {
            Enumeration v2 = ((Vector)v0).elements();
            while(v2.hasMoreElements()) {
                v1.add(v2.nextElement());
            }
        }
        else if(v0 != null) {
            v1.add(((ASN1Encodable)v0));
        }

        return v1;
    }

    public ASN1EncodableVector getAll(DERObjectIdentifier arg3) {
        return this.getAll(new ASN1ObjectIdentifier(arg3.getId()));
    }

    public AttributeTable remove(ASN1ObjectIdentifier arg3) {
        AttributeTable v0 = new AttributeTable(this.attributes);
        v0.attributes.remove(arg3);
        return v0;
    }

    public int size() {
        Enumeration v2 = this.attributes.elements();
        int v1;
        for(v1 = 0; v2.hasMoreElements(); v1 = v0_1) {
            Object v0 = v2.nextElement();
            int v0_1 = (v0 instanceof Vector) ? ((Vector)v0).size() + v1 : v1 + 1;
        }

        return v1;
    }

    public ASN1EncodableVector toASN1EncodableVector() {
        Enumeration v0_1;
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        Enumeration v2 = this.attributes.elements();
    label_4:
        while(v2.hasMoreElements()) {
            Object v0 = v2.nextElement();
            if((v0 instanceof Vector)) {
                v0_1 = ((Vector)v0).elements();
                goto label_10;
            }

            v1.add(Attribute.getInstance(v0));
        }

        return v1;
        while(true) {
        label_10:
            if(!v0_1.hasMoreElements()) {
                goto label_4;
            }

            v1.add(Attribute.getInstance(v0_1.nextElement()));
        }
    }

    public Attributes toASN1Structure() {
        return new Attributes(this.toASN1EncodableVector());
    }

    public Hashtable toHashtable() {
        return this.copyTable(this.attributes);
    }
}

