// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class AuthEnvelopedData extends ASN1Object {
    private ASN1Set authAttrs;
    private EncryptedContentInfo authEncryptedContentInfo;
    private ASN1OctetString mac;
    private OriginatorInfo originatorInfo;
    private ASN1Set recipientInfos;
    private ASN1Set unauthAttrs;
    private ASN1Integer version;

    public AuthEnvelopedData(ASN1Sequence arg5) {
        int v1;
        super();
        this.version = arg5.getObjectAt(0).toASN1Primitive();
        int v2 = 2;
        ASN1Primitive v0 = arg5.getObjectAt(1).toASN1Primitive();
        if((v0 instanceof ASN1TaggedObject)) {
            this.originatorInfo = OriginatorInfo.getInstance(((ASN1TaggedObject)v0), false);
            v1 = 3;
            v0 = arg5.getObjectAt(v2).toASN1Primitive();
        }
        else {
            v1 = v2;
        }

        this.recipientInfos = ASN1Set.getInstance(v0);
        int v0_1 = v1 + 1;
        this.authEncryptedContentInfo = EncryptedContentInfo.getInstance(arg5.getObjectAt(v1).toASN1Primitive());
        v2 = v0_1 + 1;
        v0 = arg5.getObjectAt(v0_1).toASN1Primitive();
        if((v0 instanceof ASN1TaggedObject)) {
            this.authAttrs = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            v1 = v2 + 1;
            v0 = arg5.getObjectAt(v2).toASN1Primitive();
        }
        else {
            v1 = v2;
        }

        this.mac = ASN1OctetString.getInstance(v0);
        if(arg5.size() > v1) {
            this.unauthAttrs = ASN1Set.getInstance(arg5.getObjectAt(v1).toASN1Primitive(), false);
        }
    }

    public AuthEnvelopedData(OriginatorInfo arg4, ASN1Set arg5, EncryptedContentInfo arg6, ASN1Set arg7, ASN1OctetString arg8, ASN1Set arg9) {
        super();
        this.version = new ASN1Integer(0);
        this.originatorInfo = arg4;
        this.recipientInfos = arg5;
        this.authEncryptedContentInfo = arg6;
        this.authAttrs = arg7;
        this.mac = arg8;
        this.unauthAttrs = arg9;
    }

    public ASN1Set getAuthAttrs() {
        return this.authAttrs;
    }

    public EncryptedContentInfo getAuthEncryptedContentInfo() {
        return this.authEncryptedContentInfo;
    }

    public static AuthEnvelopedData getInstance(Object arg3) {
        AuthEnvelopedData v3;
        if(arg3 != null && !(arg3 instanceof AuthEnvelopedData)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new AuthEnvelopedData(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid AuthEnvelopedData: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static AuthEnvelopedData getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return AuthEnvelopedData.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1OctetString getMac() {
        return this.mac;
    }

    public OriginatorInfo getOriginatorInfo() {
        return this.originatorInfo;
    }

    public ASN1Set getRecipientInfos() {
        return this.recipientInfos;
    }

    public ASN1Set getUnauthAttrs() {
        return this.unauthAttrs;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        if(this.originatorInfo != null) {
            v0.add(new DERTaggedObject(false, 0, this.originatorInfo));
        }

        v0.add(this.recipientInfos);
        v0.add(this.authEncryptedContentInfo);
        if(this.authAttrs != null) {
            v0.add(new DERTaggedObject(false, 1, this.authAttrs));
        }

        v0.add(this.mac);
        if(this.unauthAttrs != null) {
            v0.add(new DERTaggedObject(false, 2, this.unauthAttrs));
        }

        return new BERSequence(v0);
    }
}

