// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class AuthenticatedData extends ASN1Object {
    private ASN1Set authAttrs;
    private AlgorithmIdentifier digestAlgorithm;
    private ContentInfo encapsulatedContentInfo;
    private ASN1OctetString mac;
    private AlgorithmIdentifier macAlgorithm;
    private OriginatorInfo originatorInfo;
    private ASN1Set recipientInfos;
    private ASN1Set unauthAttrs;
    private ASN1Integer version;

    public AuthenticatedData(ASN1Sequence arg5) {
        int v1;
        super();
        this.version = arg5.getObjectAt(0);
        int v2 = 2;
        ASN1Encodable v0 = arg5.getObjectAt(1);
        if((v0 instanceof ASN1TaggedObject)) {
            this.originatorInfo = OriginatorInfo.getInstance(((ASN1TaggedObject)v0), false);
            v1 = 3;
            v0 = arg5.getObjectAt(v2);
        }
        else {
            v1 = v2;
        }

        this.recipientInfos = ASN1Set.getInstance(v0);
        int v0_1 = v1 + 1;
        this.macAlgorithm = AlgorithmIdentifier.getInstance(arg5.getObjectAt(v1));
        v2 = v0_1 + 1;
        v0 = arg5.getObjectAt(v0_1);
        if((v0 instanceof ASN1TaggedObject)) {
            this.digestAlgorithm = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), false);
            v1 = v2 + 1;
            v0 = arg5.getObjectAt(v2);
        }
        else {
            v1 = v2;
        }

        this.encapsulatedContentInfo = ContentInfo.getInstance(v0);
        v2 = v1 + 1;
        v0 = arg5.getObjectAt(v1);
        if((v0 instanceof ASN1TaggedObject)) {
            this.authAttrs = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            v1 = v2 + 1;
            v0 = arg5.getObjectAt(v2);
        }
        else {
            v1 = v2;
        }

        this.mac = ASN1OctetString.getInstance(v0);
        if(arg5.size() > v1) {
            this.unauthAttrs = ASN1Set.getInstance(arg5.getObjectAt(v1), false);
        }
    }

    public AuthenticatedData(OriginatorInfo arg4, ASN1Set arg5, AlgorithmIdentifier arg6, AlgorithmIdentifier arg7, ContentInfo arg8, ASN1Set arg9, ASN1OctetString arg10, ASN1Set arg11) {
        super();
        if(arg7 == null && arg9 == null || arg7 != null && arg9 != null) {
            this.version = new ASN1Integer(((long)AuthenticatedData.calculateVersion(arg4)));
            this.originatorInfo = arg4;
            this.macAlgorithm = arg6;
            this.digestAlgorithm = arg7;
            this.recipientInfos = arg5;
            this.encapsulatedContentInfo = arg8;
            this.authAttrs = arg9;
            this.mac = arg10;
            this.unauthAttrs = arg11;
            return;
        }

        throw new IllegalArgumentException("digestAlgorithm and authAttrs must be set together");
    }

    public static int calculateVersion(OriginatorInfo arg7) {
        Object v0_1;
        int v0 = 0;
        int v3 = 3;
        if(arg7 != null) {
            Enumeration v4 = arg7.getCertificates().getObjects();
            int v1;
            for(v1 = 0; v4.hasMoreElements(); v1 = v0) {
                v0_1 = v4.nextElement();
                if(!(v0_1 instanceof ASN1TaggedObject)) {
                label_36:
                    v0 = v1;
                }
                else if(((ASN1TaggedObject)v0_1).getTagNo() == 2) {
                    v0 = 1;
                }
                else if(((ASN1TaggedObject)v0_1).getTagNo() == v3) {
                    v1 = v3;
                    break;
                }
                else {
                    goto label_36;
                }
            }

            if(arg7.getCRLs() != null) {
                v4 = arg7.getCRLs().getObjects();
                do {
                    if(v4.hasMoreElements()) {
                        v0_1 = v4.nextElement();
                        if(!(v0_1 instanceof ASN1TaggedObject)) {
                            continue;
                        }

                        if(((ASN1TaggedObject)v0_1).getTagNo() != 1) {
                            continue;
                        }

                        break;
                    }

                    goto label_34;
                }
                while(true);

                v1 = v3;
            }

        label_34:
            v0 = v1;
        }

        return v0;
    }

    public ASN1Set getAuthAttrs() {
        return this.authAttrs;
    }

    public AlgorithmIdentifier getDigestAlgorithm() {
        return this.digestAlgorithm;
    }

    public ContentInfo getEncapsulatedContentInfo() {
        return this.encapsulatedContentInfo;
    }

    public static AuthenticatedData getInstance(Object arg3) {
        AuthenticatedData v3;
        if(arg3 != null && !(arg3 instanceof AuthenticatedData)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new AuthenticatedData(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid AuthenticatedData: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static AuthenticatedData getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return AuthenticatedData.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1OctetString getMac() {
        return this.mac;
    }

    public AlgorithmIdentifier getMacAlgorithm() {
        return this.macAlgorithm;
    }

    public OriginatorInfo getOriginatorInfo() {
        return this.originatorInfo;
    }

    public ASN1Set getRecipientInfos() {
        return this.recipientInfos;
    }

    public ASN1Set getUnauthAttrs() {
        return this.unauthAttrs;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        if(this.originatorInfo != null) {
            v0.add(new DERTaggedObject(false, 0, this.originatorInfo));
        }

        v0.add(this.recipientInfos);
        v0.add(this.macAlgorithm);
        if(this.digestAlgorithm != null) {
            v0.add(new DERTaggedObject(false, 1, this.digestAlgorithm));
        }

        v0.add(this.encapsulatedContentInfo);
        if(this.authAttrs != null) {
            v0.add(new DERTaggedObject(false, 2, this.authAttrs));
        }

        v0.add(this.mac);
        if(this.unauthAttrs != null) {
            v0.add(new DERTaggedObject(false, 3, this.unauthAttrs));
        }

        return new BERSequence(v0);
    }
}

