// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class CompressedData extends ASN1Object {
    private AlgorithmIdentifier compressionAlgorithm;
    private ContentInfo encapContentInfo;
    private ASN1Integer version;

    private CompressedData(ASN1Sequence arg2) {
        super();
        this.version = arg2.getObjectAt(0);
        this.compressionAlgorithm = AlgorithmIdentifier.getInstance(arg2.getObjectAt(1));
        this.encapContentInfo = ContentInfo.getInstance(arg2.getObjectAt(2));
    }

    public CompressedData(AlgorithmIdentifier arg4, ContentInfo arg5) {
        super();
        this.version = new ASN1Integer(0);
        this.compressionAlgorithm = arg4;
        this.encapContentInfo = arg5;
    }

    public AlgorithmIdentifier getCompressionAlgorithmIdentifier() {
        return this.compressionAlgorithm;
    }

    public ContentInfo getEncapContentInfo() {
        return this.encapContentInfo;
    }

    public static CompressedData getInstance(Object arg2) {
        if(!(arg2 instanceof CompressedData)) {
            if(arg2 != null) {
                CompressedData v2 = new CompressedData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static CompressedData getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return CompressedData.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.compressionAlgorithm);
        v0.add(this.encapContentInfo);
        return new BERSequence(v0);
    }
}

