// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.BERTaggedObject;

public class ContentInfo extends ASN1Object implements CMSObjectIdentifiers {
    private ASN1Encodable content;
    private ASN1ObjectIdentifier contentType;

    public ContentInfo(ASN1ObjectIdentifier arg1, ASN1Encodable arg2) {
        super();
        this.contentType = arg1;
        this.content = arg2;
    }

    public ContentInfo(ASN1Sequence arg4) {
        super();
        if(arg4.size() >= 1 && arg4.size() <= 2) {
            this.contentType = arg4.getObjectAt(0);
            if(arg4.size() > 1) {
                ASN1Encodable v0 = arg4.getObjectAt(1);
                if((((ASN1TaggedObject)v0).isExplicit()) && ((ASN1TaggedObject)v0).getTagNo() == 0) {
                    this.content = ((ASN1TaggedObject)v0).getObject();
                    return;
                }

                throw new IllegalArgumentException("Bad tag for \'content\'");
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public ASN1Encodable getContent() {
        return this.content;
    }

    public ASN1ObjectIdentifier getContentType() {
        return this.contentType;
    }

    public static ContentInfo getInstance(Object arg2) {
        if(!(arg2 instanceof ContentInfo)) {
            if(arg2 != null) {
                ContentInfo v2 = new ContentInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static ContentInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return ContentInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.contentType);
        if(this.content != null) {
            v0.add(new BERTaggedObject(0, this.content));
        }

        return new BERSequence(v0);
    }
}

