// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class EnvelopedData extends ASN1Object {
    private EncryptedContentInfo encryptedContentInfo;
    private OriginatorInfo originatorInfo;
    private ASN1Set recipientInfos;
    private ASN1Set unprotectedAttrs;
    private ASN1Integer version;

    public EnvelopedData(ASN1Sequence arg5) {
        int v1;
        super();
        this.version = arg5.getObjectAt(0);
        int v2 = 2;
        ASN1Encodable v0 = arg5.getObjectAt(1);
        if((v0 instanceof ASN1TaggedObject)) {
            this.originatorInfo = OriginatorInfo.getInstance(((ASN1TaggedObject)v0), false);
            v1 = 3;
            v0 = arg5.getObjectAt(v2);
        }
        else {
            v1 = v2;
        }

        this.recipientInfos = ASN1Set.getInstance(v0);
        int v0_1 = v1 + 1;
        this.encryptedContentInfo = EncryptedContentInfo.getInstance(arg5.getObjectAt(v1));
        if(arg5.size() > v0_1) {
            this.unprotectedAttrs = ASN1Set.getInstance(arg5.getObjectAt(v0_1), false);
        }
    }

    public EnvelopedData(OriginatorInfo arg4, ASN1Set arg5, EncryptedContentInfo arg6, ASN1Set arg7) {
        super();
        this.version = new ASN1Integer(((long)EnvelopedData.calculateVersion(arg4, arg5, arg7)));
        this.originatorInfo = arg4;
        this.recipientInfos = arg5;
        this.encryptedContentInfo = arg6;
        this.unprotectedAttrs = arg7;
    }

    public EnvelopedData(OriginatorInfo arg4, ASN1Set arg5, EncryptedContentInfo arg6, Attributes arg7) {
        super();
        this.version = new ASN1Integer(((long)EnvelopedData.calculateVersion(arg4, arg5, ASN1Set.getInstance(arg7))));
        this.originatorInfo = arg4;
        this.recipientInfos = arg5;
        this.encryptedContentInfo = arg6;
        this.unprotectedAttrs = ASN1Set.getInstance(arg7);
    }

    public static int calculateVersion(OriginatorInfo arg4, ASN1Set arg5, ASN1Set arg6) {
        int v0 = 2;
        if(arg4 == null && arg6 == null) {
            Enumeration v2 = arg5.getObjects();
            do {
                if(v2.hasMoreElements()) {
                    if(RecipientInfo.getInstance(v2.nextElement()).getVersion().getValue().intValue() == 0) {
                        continue;
                    }

                    return v0;
                }
                else {
                    goto label_15;
                }
            }
            while(true);

            return v0;
        label_15:
            v0 = 0;
        }

        return v0;
    }

    public EncryptedContentInfo getEncryptedContentInfo() {
        return this.encryptedContentInfo;
    }

    public static EnvelopedData getInstance(Object arg2) {
        if(!(arg2 instanceof EnvelopedData)) {
            if(arg2 != null) {
                EnvelopedData v2 = new EnvelopedData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static EnvelopedData getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return EnvelopedData.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public OriginatorInfo getOriginatorInfo() {
        return this.originatorInfo;
    }

    public ASN1Set getRecipientInfos() {
        return this.recipientInfos;
    }

    public ASN1Set getUnprotectedAttrs() {
        return this.unprotectedAttrs;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        if(this.originatorInfo != null) {
            v0.add(new DERTaggedObject(false, 0, this.originatorInfo));
        }

        v0.add(this.recipientInfos);
        v0.add(this.encryptedContentInfo);
        if(this.unprotectedAttrs != null) {
            v0.add(new DERTaggedObject(false, 1, this.unprotectedAttrs));
        }

        return new BERSequence(v0);
    }
}

