// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.Certificate;
import org.bouncycastle.asn1.x509.X509CertificateStructure;
import org.bouncycastle.asn1.x509.X509Name;

public class IssuerAndSerialNumber extends ASN1Object {
    private X500Name name;
    private ASN1Integer serialNumber;

    public IssuerAndSerialNumber(ASN1Sequence arg2) {
        super();
        this.name = X500Name.getInstance(arg2.getObjectAt(0));
        this.serialNumber = arg2.getObjectAt(1);
    }

    public IssuerAndSerialNumber(X500Name arg2, BigInteger arg3) {
        super();
        this.name = arg2;
        this.serialNumber = new ASN1Integer(arg3);
    }

    public IssuerAndSerialNumber(Certificate arg2) {
        super();
        this.name = arg2.getIssuer();
        this.serialNumber = arg2.getSerialNumber();
    }

    public IssuerAndSerialNumber(X509CertificateStructure arg2) {
        super();
        this.name = arg2.getIssuer();
        this.serialNumber = arg2.getSerialNumber();
    }

    public IssuerAndSerialNumber(X509Name arg2, BigInteger arg3) {
        super();
        this.name = X500Name.getInstance(arg2);
        this.serialNumber = new ASN1Integer(arg3);
    }

    public IssuerAndSerialNumber(X509Name arg2, ASN1Integer arg3) {
        super();
        this.name = X500Name.getInstance(arg2);
        this.serialNumber = arg3;
    }

    public static IssuerAndSerialNumber getInstance(Object arg2) {
        if(!(arg2 instanceof IssuerAndSerialNumber)) {
            if(arg2 != null) {
                IssuerAndSerialNumber v2 = new IssuerAndSerialNumber(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public X500Name getName() {
        return this.name;
    }

    public ASN1Integer getSerialNumber() {
        return this.serialNumber;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.name);
        v0.add(this.serialNumber);
        return new DERSequence(v0);
    }
}

