// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class KEKIdentifier extends ASN1Object {
    private ASN1GeneralizedTime date;
    private ASN1OctetString keyIdentifier;
    private OtherKeyAttribute other;

    private KEKIdentifier(ASN1Sequence arg3) {
        super();
        this.keyIdentifier = arg3.getObjectAt(0);
        switch(arg3.size()) {
            case 1: {
                break;
            }
            case 2: {
                if((arg3.getObjectAt(1) instanceof ASN1GeneralizedTime)) {
                    this.date = arg3.getObjectAt(1);
                    return;
                }

                this.other = OtherKeyAttribute.getInstance(arg3.getObjectAt(1));
                break;
            }
            case 3: {
                this.date = arg3.getObjectAt(1);
                this.other = OtherKeyAttribute.getInstance(arg3.getObjectAt(2));
                break;
            }
            default: {
                throw new IllegalArgumentException("Invalid KEKIdentifier");
            }
        }
    }

    public KEKIdentifier(byte[] arg2, ASN1GeneralizedTime arg3, OtherKeyAttribute arg4) {
        super();
        this.keyIdentifier = new DEROctetString(arg2);
        this.date = arg3;
        this.other = arg4;
    }

    public ASN1GeneralizedTime getDate() {
        return this.date;
    }

    public static KEKIdentifier getInstance(Object arg3) {
        KEKIdentifier v3;
        if(arg3 != null && !(arg3 instanceof KEKIdentifier)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new KEKIdentifier(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid KEKIdentifier: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static KEKIdentifier getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return KEKIdentifier.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1OctetString getKeyIdentifier() {
        return this.keyIdentifier;
    }

    public OtherKeyAttribute getOther() {
        return this.other;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.keyIdentifier);
        if(this.date != null) {
            v0.add(this.date);
        }

        if(this.other != null) {
            v0.add(this.other);
        }

        return new DERSequence(v0);
    }
}

