// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class KEKRecipientInfo extends ASN1Object {
    private ASN1OctetString encryptedKey;
    private KEKIdentifier kekid;
    private AlgorithmIdentifier keyEncryptionAlgorithm;
    private ASN1Integer version;

    public KEKRecipientInfo(ASN1Sequence arg2) {
        super();
        this.version = arg2.getObjectAt(0);
        this.kekid = KEKIdentifier.getInstance(arg2.getObjectAt(1));
        this.keyEncryptionAlgorithm = AlgorithmIdentifier.getInstance(arg2.getObjectAt(2));
        this.encryptedKey = arg2.getObjectAt(3);
    }

    public KEKRecipientInfo(KEKIdentifier arg4, AlgorithmIdentifier arg5, ASN1OctetString arg6) {
        super();
        this.version = new ASN1Integer(4);
        this.kekid = arg4;
        this.keyEncryptionAlgorithm = arg5;
        this.encryptedKey = arg6;
    }

    public ASN1OctetString getEncryptedKey() {
        return this.encryptedKey;
    }

    public static KEKRecipientInfo getInstance(Object arg3) {
        KEKRecipientInfo v3;
        if(arg3 != null && !(arg3 instanceof KEKRecipientInfo)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new KEKRecipientInfo(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid KEKRecipientInfo: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static KEKRecipientInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return KEKRecipientInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public KEKIdentifier getKekid() {
        return this.kekid;
    }

    public AlgorithmIdentifier getKeyEncryptionAlgorithm() {
        return this.keyEncryptionAlgorithm;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.kekid);
        v0.add(this.keyEncryptionAlgorithm);
        v0.add(this.encryptedKey);
        return new DERSequence(v0);
    }
}

