// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class KeyAgreeRecipientInfo extends ASN1Object {
    private AlgorithmIdentifier keyEncryptionAlgorithm;
    private OriginatorIdentifierOrKey originator;
    private ASN1Sequence recipientEncryptedKeys;
    private ASN1OctetString ukm;
    private ASN1Integer version;

    public KeyAgreeRecipientInfo(ASN1Sequence arg5) {
        int v0;
        super();
        this.version = arg5.getObjectAt(0);
        int v2 = 2;
        this.originator = OriginatorIdentifierOrKey.getInstance(arg5.getObjectAt(1), true);
        if((arg5.getObjectAt(v2) instanceof ASN1TaggedObject)) {
            this.ukm = ASN1OctetString.getInstance(arg5.getObjectAt(v2), true);
            v0 = 3;
        }
        else {
            v0 = v2;
        }

        this.keyEncryptionAlgorithm = AlgorithmIdentifier.getInstance(arg5.getObjectAt(v0));
        this.recipientEncryptedKeys = arg5.getObjectAt(v0 + 1);
    }

    public KeyAgreeRecipientInfo(OriginatorIdentifierOrKey arg4, ASN1OctetString arg5, AlgorithmIdentifier arg6, ASN1Sequence arg7) {
        super();
        this.version = new ASN1Integer(3);
        this.originator = arg4;
        this.ukm = arg5;
        this.keyEncryptionAlgorithm = arg6;
        this.recipientEncryptedKeys = arg7;
    }

    public static KeyAgreeRecipientInfo getInstance(Object arg3) {
        KeyAgreeRecipientInfo v3;
        if(arg3 != null && !(arg3 instanceof KeyAgreeRecipientInfo)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new KeyAgreeRecipientInfo(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Illegal object in KeyAgreeRecipientInfo: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static KeyAgreeRecipientInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return KeyAgreeRecipientInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public AlgorithmIdentifier getKeyEncryptionAlgorithm() {
        return this.keyEncryptionAlgorithm;
    }

    public OriginatorIdentifierOrKey getOriginator() {
        return this.originator;
    }

    public ASN1Sequence getRecipientEncryptedKeys() {
        return this.recipientEncryptedKeys;
    }

    public ASN1OctetString getUserKeyingMaterial() {
        return this.ukm;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(new DERTaggedObject(true, 0, this.originator));
        if(this.ukm != null) {
            v0.add(new DERTaggedObject(true, 1, this.ukm));
        }

        v0.add(this.keyEncryptionAlgorithm);
        v0.add(this.recipientEncryptedKeys);
        return new DERSequence(v0);
    }
}

