// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERUTF8String;

public class MetaData extends ASN1Object {
    private DERUTF8String fileName;
    private ASN1Boolean hashProtected;
    private DERIA5String mediaType;
    private Attributes otherMetaData;

    public MetaData(ASN1Boolean arg1, DERUTF8String arg2, DERIA5String arg3, Attributes arg4) {
        super();
        this.hashProtected = arg1;
        this.fileName = arg2;
        this.mediaType = arg3;
        this.otherMetaData = arg4;
    }

    private MetaData(ASN1Sequence arg3) {
        int v0;
        super();
        this.hashProtected = ASN1Boolean.getInstance(arg3.getObjectAt(0));
        if(1 >= arg3.size() || !(arg3.getObjectAt(1) instanceof DERUTF8String)) {
            v0 = 1;
        }
        else {
            v0 = 2;
            this.fileName = DERUTF8String.getInstance(arg3.getObjectAt(1));
        }

        if(v0 < arg3.size() && ((arg3.getObjectAt(v0) instanceof DERIA5String))) {
            this.mediaType = DERIA5String.getInstance(arg3.getObjectAt(v0));
            ++v0;
        }

        if(v0 < arg3.size()) {
            this.otherMetaData = Attributes.getInstance(arg3.getObjectAt(v0));
        }
    }

    public DERUTF8String getFileName() {
        return this.fileName;
    }

    public static MetaData getInstance(Object arg2) {
        MetaData v2;
        if(!(arg2 instanceof MetaData)) {
            if(arg2 != null) {
                v2 = new MetaData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public DERIA5String getMediaType() {
        return this.mediaType;
    }

    public Attributes getOtherMetaData() {
        return this.otherMetaData;
    }

    public boolean isHashProtected() {
        return this.hashProtected.isTrue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.hashProtected);
        if(this.fileName != null) {
            v0.add(this.fileName);
        }

        if(this.mediaType != null) {
            v0.add(this.mediaType);
        }

        if(this.otherMetaData != null) {
            v0.add(this.otherMetaData);
        }

        return new DERSequence(v0);
    }
}

