// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class OriginatorInfo extends ASN1Object {
    private ASN1Set certs;
    private ASN1Set crls;

    private OriginatorInfo(ASN1Sequence arg5) {
        super();
        switch(arg5.size()) {
            case 0: {
                break;
            }
            case 1: {
                ASN1Encodable v0 = arg5.getObjectAt(0);
                switch(((ASN1TaggedObject)v0).getTagNo()) {
                    case 0: {
                        this.certs = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
                        return;
                    label_27:
                        this.certs = ASN1Set.getInstance(arg5.getObjectAt(0), false);
                        this.crls = ASN1Set.getInstance(arg5.getObjectAt(1), false);
                        return;
                    }
                    case 1: {
                        this.crls = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
                        return;
                    }
                    default: {
                        throw new IllegalArgumentException("Bad tag in OriginatorInfo: " + ((ASN1TaggedObject)v0).getTagNo());
                    }
                }
            }
            case 2: {
                goto label_27;
            }
            default: {
                throw new IllegalArgumentException("OriginatorInfo too big");
            }
        }
    }

    public OriginatorInfo(ASN1Set arg1, ASN1Set arg2) {
        super();
        this.certs = arg1;
        this.crls = arg2;
    }

    public ASN1Set getCRLs() {
        return this.crls;
    }

    public ASN1Set getCertificates() {
        return this.certs;
    }

    public static OriginatorInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return OriginatorInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public static OriginatorInfo getInstance(Object arg2) {
        if(!(arg2 instanceof OriginatorInfo)) {
            if(arg2 != null) {
                OriginatorInfo v2 = new OriginatorInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.certs != null) {
            v0.add(new DERTaggedObject(false, 0, this.certs));
        }

        if(this.crls != null) {
            v0.add(new DERTaggedObject(false, 1, this.crls));
        }

        return new DERSequence(v0);
    }
}

