// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class PasswordRecipientInfo extends ASN1Object {
    private ASN1OctetString encryptedKey;
    private AlgorithmIdentifier keyDerivationAlgorithm;
    private AlgorithmIdentifier keyEncryptionAlgorithm;
    private ASN1Integer version;

    public PasswordRecipientInfo(ASN1Sequence arg5) {
        int v3 = 2;
        super();
        this.version = arg5.getObjectAt(0);
        if((arg5.getObjectAt(1) instanceof ASN1TaggedObject)) {
            this.keyDerivationAlgorithm = AlgorithmIdentifier.getInstance(arg5.getObjectAt(1), false);
            this.keyEncryptionAlgorithm = AlgorithmIdentifier.getInstance(arg5.getObjectAt(v3));
            this.encryptedKey = arg5.getObjectAt(3);
        }
        else {
            this.keyEncryptionAlgorithm = AlgorithmIdentifier.getInstance(arg5.getObjectAt(1));
            this.encryptedKey = arg5.getObjectAt(v3);
        }
    }

    public PasswordRecipientInfo(AlgorithmIdentifier arg4, ASN1OctetString arg5) {
        super();
        this.version = new ASN1Integer(0);
        this.keyEncryptionAlgorithm = arg4;
        this.encryptedKey = arg5;
    }

    public PasswordRecipientInfo(AlgorithmIdentifier arg4, AlgorithmIdentifier arg5, ASN1OctetString arg6) {
        super();
        this.version = new ASN1Integer(0);
        this.keyDerivationAlgorithm = arg4;
        this.keyEncryptionAlgorithm = arg5;
        this.encryptedKey = arg6;
    }

    public ASN1OctetString getEncryptedKey() {
        return this.encryptedKey;
    }

    public static PasswordRecipientInfo getInstance(Object arg3) {
        PasswordRecipientInfo v3;
        if(arg3 != null && !(arg3 instanceof PasswordRecipientInfo)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new PasswordRecipientInfo(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid PasswordRecipientInfo: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static PasswordRecipientInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return PasswordRecipientInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public AlgorithmIdentifier getKeyDerivationAlgorithm() {
        return this.keyDerivationAlgorithm;
    }

    public AlgorithmIdentifier getKeyEncryptionAlgorithm() {
        return this.keyEncryptionAlgorithm;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        if(this.keyDerivationAlgorithm != null) {
            v0.add(new DERTaggedObject(false, 0, this.keyDerivationAlgorithm));
        }

        v0.add(this.keyEncryptionAlgorithm);
        v0.add(this.encryptedKey);
        return new DERSequence(v0);
    }
}

