// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class RecipientKeyIdentifier extends ASN1Object {
    private DERGeneralizedTime date;
    private OtherKeyAttribute other;
    private ASN1OctetString subjectKeyIdentifier;

    public RecipientKeyIdentifier(ASN1OctetString arg1, DERGeneralizedTime arg2, OtherKeyAttribute arg3) {
        super();
        this.subjectKeyIdentifier = arg1;
        this.date = arg2;
        this.other = arg3;
    }

    public RecipientKeyIdentifier(ASN1Sequence arg4) {
        int v2 = 2;
        super();
        this.subjectKeyIdentifier = ASN1OctetString.getInstance(arg4.getObjectAt(0));
        switch(arg4.size()) {
            case 1: {
                break;
            }
            case 2: {
                if((arg4.getObjectAt(1) instanceof DERGeneralizedTime)) {
                    this.date = arg4.getObjectAt(1);
                    return;
                }

                this.other = OtherKeyAttribute.getInstance(arg4.getObjectAt(v2));
                break;
            }
            case 3: {
                this.date = arg4.getObjectAt(1);
                this.other = OtherKeyAttribute.getInstance(arg4.getObjectAt(v2));
                break;
            }
            default: {
                throw new IllegalArgumentException("Invalid RecipientKeyIdentifier");
            }
        }
    }

    public RecipientKeyIdentifier(byte[] arg2) {
        this(arg2, null, null);
    }

    public RecipientKeyIdentifier(byte[] arg2, DERGeneralizedTime arg3, OtherKeyAttribute arg4) {
        super();
        this.subjectKeyIdentifier = new DEROctetString(arg2);
        this.date = arg3;
        this.other = arg4;
    }

    public DERGeneralizedTime getDate() {
        return this.date;
    }

    public static RecipientKeyIdentifier getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return RecipientKeyIdentifier.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public static RecipientKeyIdentifier getInstance(Object arg3) {
        RecipientKeyIdentifier v3;
        if(arg3 != null && !(arg3 instanceof RecipientKeyIdentifier)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new RecipientKeyIdentifier(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid RecipientKeyIdentifier: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public OtherKeyAttribute getOtherKeyAttribute() {
        return this.other;
    }

    public ASN1OctetString getSubjectKeyIdentifier() {
        return this.subjectKeyIdentifier;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.subjectKeyIdentifier);
        if(this.date != null) {
            v0.add(this.date);
        }

        if(this.other != null) {
            v0.add(this.other);
        }

        return new DERSequence(v0);
    }
}

