// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.BERSet;
import org.bouncycastle.asn1.BERTaggedObject;
import org.bouncycastle.asn1.DERTaggedObject;

public class SignedData extends ASN1Object {
    private static final ASN1Integer VERSION_1;
    private static final ASN1Integer VERSION_3;
    private static final ASN1Integer VERSION_4;
    private static final ASN1Integer VERSION_5;
    private ASN1Set certificates;
    private boolean certsBer;
    private ContentInfo contentInfo;
    private ASN1Set crls;
    private boolean crlsBer;
    private ASN1Set digestAlgorithms;
    private ASN1Set signerInfos;
    private ASN1Integer version;

    static {
        SignedData.VERSION_1 = new ASN1Integer(1);
        SignedData.VERSION_3 = new ASN1Integer(3);
        SignedData.VERSION_4 = new ASN1Integer(4);
        SignedData.VERSION_5 = new ASN1Integer(5);
    }

    private SignedData(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        this.version = ASN1Integer.getInstance(v1.nextElement());
        this.digestAlgorithms = v1.nextElement();
        this.contentInfo = ContentInfo.getInstance(v1.nextElement());
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            if(!(v0 instanceof ASN1TaggedObject)) {
                goto label_38;
            }

            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_28;
                }
                case 1: {
                    goto label_33;
                }
            }

            throw new IllegalArgumentException("unknown tag value " + ((ASN1TaggedObject)v0).getTagNo());
        label_33:
            this.crlsBer = v0 instanceof BERTaggedObject;
            this.crls = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_28:
            this.certsBer = v0 instanceof BERTaggedObject;
            this.certificates = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_38:
            this.signerInfos = ((ASN1Set)v0);
        }
    }

    public SignedData(ASN1Set arg2, ContentInfo arg3, ASN1Set arg4, ASN1Set arg5, ASN1Set arg6) {
        super();
        this.version = this.calculateVersion(arg3.getContentType(), arg4, arg5, arg6);
        this.digestAlgorithms = arg2;
        this.contentInfo = arg3;
        this.certificates = arg4;
        this.crls = arg5;
        this.signerInfos = arg6;
        this.crlsBer = arg5 instanceof BERSet;
        this.certsBer = arg4 instanceof BERSet;
    }

    private ASN1Integer calculateVersion(ASN1ObjectIdentifier arg10, ASN1Set arg11, ASN1Set arg12, ASN1Set arg13) {
        ASN1Integer v0_1;
        int v3;
        int v2;
        int v0;
        int v1 = 0;
        if(arg11 != null) {
            Enumeration v5 = arg11.getObjects();
            v0 = 0;
            v2 = 0;
            v3 = 0;
            while(v5.hasMoreElements()) {
                Object v6 = v5.nextElement();
                if(!(v6 instanceof ASN1TaggedObject)) {
                    continue;
                }

                ASN1TaggedObject v6_1 = ASN1TaggedObject.getInstance(v6);
                if(v6_1.getTagNo() == 1) {
                    v2 = 1;
                }
                else if(v6_1.getTagNo() == 2) {
                    v0 = 1;
                }
                else {
                    if(v6_1.getTagNo() != 3) {
                        continue;
                    }

                    v3 = 1;
                }
            }
        }
        else {
            v0 = 0;
            v2 = 0;
            v3 = 0;
        }

        if(v3 != 0) {
            v0_1 = new ASN1Integer(5);
        }
        else {
            if(arg12 != null) {
                Enumeration v3_1 = arg12.getObjects();
                while(v3_1.hasMoreElements()) {
                    if(!(v3_1.nextElement() instanceof ASN1TaggedObject)) {
                        continue;
                    }

                    v1 = 1;
                }
            }

            if(v1 != 0) {
                return SignedData.VERSION_5;
            }

            if(v0 != 0) {
                return SignedData.VERSION_4;
            }

            if(v2 != 0) {
                return SignedData.VERSION_3;
            }

            if(this.checkForVersion3(arg13)) {
                return SignedData.VERSION_3;
            }

            if(!CMSObjectIdentifiers.data.equals(arg10)) {
                return SignedData.VERSION_3;
            }

            v0_1 = SignedData.VERSION_1;
        }

        return v0_1;
    }

    private boolean checkForVersion3(ASN1Set arg4) {
        Enumeration v0 = arg4.getObjects();
        do {
            if(v0.hasMoreElements()) {
                if(SignerInfo.getInstance(v0.nextElement()).getVersion().getValue().intValue() != 3) {
                    continue;
                }

                break;
            }
            else {
                return false;
            }
        }
        while(true);

        boolean v0_1 = true;
        return v0_1;
    }

    public ASN1Set getCRLs() {
        return this.crls;
    }

    public ASN1Set getCertificates() {
        return this.certificates;
    }

    public ASN1Set getDigestAlgorithms() {
        return this.digestAlgorithms;
    }

    public ContentInfo getEncapContentInfo() {
        return this.contentInfo;
    }

    public static SignedData getInstance(Object arg2) {
        if(!(arg2 instanceof SignedData)) {
            if(arg2 != null) {
                SignedData v2 = new SignedData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Set getSignerInfos() {
        return this.signerInfos;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.digestAlgorithms);
        v0.add(this.contentInfo);
        if(this.certificates != null) {
            if(this.certsBer) {
                v0.add(new BERTaggedObject(false, 0, this.certificates));
            }
            else {
                v0.add(new DERTaggedObject(false, 0, this.certificates));
            }
        }

        if(this.crls != null) {
            if(this.crlsBer) {
                v0.add(new BERTaggedObject(false, 1, this.crls));
            }
            else {
                v0.add(new DERTaggedObject(false, 1, this.crls));
            }
        }

        v0.add(this.signerInfos);
        return new BERSequence(v0);
    }
}

