// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1SequenceParser;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1SetParser;
import org.bouncycastle.asn1.ASN1TaggedObjectParser;

public class SignedDataParser {
    private boolean _certsCalled;
    private boolean _crlsCalled;
    private Object _nextObject;
    private ASN1SequenceParser _seq;
    private ASN1Integer _version;

    private SignedDataParser(ASN1SequenceParser arg2) {
        super();
        this._seq = arg2;
        this._version = arg2.readObject();
    }

    public ASN1SetParser getCertificates() {
        ASN1SetParser v0_1;
        Object v1 = null;
        this._certsCalled = true;
        this._nextObject = this._seq.readObject();
        if(!(this._nextObject instanceof ASN1TaggedObjectParser) || this._nextObject.getTagNo() != 0) {
            v0_1 = ((ASN1SetParser)v1);
        }
        else {
            ASN1Encodable v0 = this._nextObject.getObjectParser(17, false);
            this._nextObject = v1;
        }

        return v0_1;
    }

    public ASN1SetParser getCrls() {
        ASN1SetParser v0_1;
        Object v1 = null;
        if(!this._certsCalled) {
            throw new IOException("getCerts() has not been called.");
        }

        this._crlsCalled = true;
        if(this._nextObject == null) {
            this._nextObject = this._seq.readObject();
        }

        if(!(this._nextObject instanceof ASN1TaggedObjectParser) || this._nextObject.getTagNo() != 1) {
            v0_1 = ((ASN1SetParser)v1);
        }
        else {
            ASN1Encodable v0 = this._nextObject.getObjectParser(17, false);
            this._nextObject = v1;
        }

        return v0_1;
    }

    public ASN1SetParser getDigestAlgorithms() {
        ASN1SetParser v0_1;
        ASN1Encodable v0 = this._seq.readObject();
        if((v0 instanceof ASN1Set)) {
            v0_1 = ((ASN1Set)v0).parser();
        }

        return v0_1;
    }

    public ContentInfoParser getEncapContentInfo() {
        return new ContentInfoParser(this._seq.readObject());
    }

    public static SignedDataParser getInstance(Object arg3) {
        SignedDataParser v0;
        if((arg3 instanceof ASN1Sequence)) {
            v0 = new SignedDataParser(((ASN1Sequence)arg3).parser());
        }
        else if((arg3 instanceof ASN1SequenceParser)) {
            v0 = new SignedDataParser(((ASN1SequenceParser)arg3));
        }
        else {
            goto label_11;
        }

        return v0;
    label_11:
        throw new IOException("unknown object encountered: " + arg3.getClass().getName());
    }

    public ASN1SetParser getSignerInfos() {
        if((this._certsCalled) && (this._crlsCalled)) {
            if(this._nextObject == null) {
                this._nextObject = this._seq.readObject();
            }

            return this._nextObject;
        }

        throw new IOException("getCerts() and/or getCrls() has not been called.");
    }

    public ASN1Integer getVersion() {
        return this._version;
    }
}

