// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class SignerInfo extends ASN1Object {
    private ASN1Set authenticatedAttributes;
    private AlgorithmIdentifier digAlgorithm;
    private AlgorithmIdentifier digEncryptionAlgorithm;
    private ASN1OctetString encryptedDigest;
    private SignerIdentifier sid;
    private ASN1Set unauthenticatedAttributes;
    private ASN1Integer version;

    public SignerInfo(ASN1Sequence arg6) {
        ASN1Set v4 = null;
        super();
        Enumeration v1 = arg6.getObjects();
        this.version = v1.nextElement();
        this.sid = SignerIdentifier.getInstance(v1.nextElement());
        this.digAlgorithm = AlgorithmIdentifier.getInstance(v1.nextElement());
        Object v0 = v1.nextElement();
        if((v0 instanceof ASN1TaggedObject)) {
            this.authenticatedAttributes = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            this.digEncryptionAlgorithm = AlgorithmIdentifier.getInstance(v1.nextElement());
        }
        else {
            this.authenticatedAttributes = v4;
            this.digEncryptionAlgorithm = AlgorithmIdentifier.getInstance(v0);
        }

        this.encryptedDigest = DEROctetString.getInstance(v1.nextElement());
        this.unauthenticatedAttributes = v1.hasMoreElements() ? ASN1Set.getInstance(v1.nextElement(), false) : v4;
    }

    public SignerInfo(SignerIdentifier arg4, AlgorithmIdentifier arg5, ASN1Set arg6, AlgorithmIdentifier arg7, ASN1OctetString arg8, ASN1Set arg9) {
        super();
        this.version = arg4.isTagged() ? new ASN1Integer(3) : new ASN1Integer(1);
        this.sid = arg4;
        this.digAlgorithm = arg5;
        this.authenticatedAttributes = arg6;
        this.digEncryptionAlgorithm = arg7;
        this.encryptedDigest = arg8;
        this.unauthenticatedAttributes = arg9;
    }

    public SignerInfo(SignerIdentifier arg4, AlgorithmIdentifier arg5, Attributes arg6, AlgorithmIdentifier arg7, ASN1OctetString arg8, Attributes arg9) {
        super();
        this.version = arg4.isTagged() ? new ASN1Integer(3) : new ASN1Integer(1);
        this.sid = arg4;
        this.digAlgorithm = arg5;
        this.authenticatedAttributes = ASN1Set.getInstance(arg6);
        this.digEncryptionAlgorithm = arg7;
        this.encryptedDigest = arg8;
        this.unauthenticatedAttributes = ASN1Set.getInstance(arg9);
    }

    public ASN1Set getAuthenticatedAttributes() {
        return this.authenticatedAttributes;
    }

    public AlgorithmIdentifier getDigestAlgorithm() {
        return this.digAlgorithm;
    }

    public AlgorithmIdentifier getDigestEncryptionAlgorithm() {
        return this.digEncryptionAlgorithm;
    }

    public ASN1OctetString getEncryptedDigest() {
        return this.encryptedDigest;
    }

    public static SignerInfo getInstance(Object arg3) {
        SignerInfo v3;
        if(arg3 != null && !(arg3 instanceof SignerInfo)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new SignerInfo(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("unknown object in factory: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public SignerIdentifier getSID() {
        return this.sid;
    }

    public ASN1Set getUnauthenticatedAttributes() {
        return this.unauthenticatedAttributes;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.sid);
        v0.add(this.digAlgorithm);
        if(this.authenticatedAttributes != null) {
            v0.add(new DERTaggedObject(false, 0, this.authenticatedAttributes));
        }

        v0.add(this.digEncryptionAlgorithm);
        v0.add(this.encryptedDigest);
        if(this.unauthenticatedAttributes != null) {
            v0.add(new DERTaggedObject(false, 1, this.unauthenticatedAttributes));
        }

        return new DERSequence(v0);
    }
}

