// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.DERIA5String;

public class TimeStampedData extends ASN1Object {
    private ASN1OctetString content;
    private DERIA5String dataUri;
    private MetaData metaData;
    private Evidence temporalEvidence;
    private ASN1Integer version;

    private TimeStampedData(ASN1Sequence arg3) {
        int v0;
        super();
        this.version = ASN1Integer.getInstance(arg3.getObjectAt(0));
        if((arg3.getObjectAt(1) instanceof DERIA5String)) {
            v0 = 2;
            this.dataUri = DERIA5String.getInstance(arg3.getObjectAt(1));
        }
        else {
            v0 = 1;
        }

        if(((arg3.getObjectAt(v0) instanceof MetaData)) || ((arg3.getObjectAt(v0) instanceof ASN1Sequence))) {
            this.metaData = MetaData.getInstance(arg3.getObjectAt(v0));
            ++v0;
        }

        if((arg3.getObjectAt(v0) instanceof ASN1OctetString)) {
            this.content = ASN1OctetString.getInstance(arg3.getObjectAt(v0));
            ++v0;
        }

        this.temporalEvidence = Evidence.getInstance(arg3.getObjectAt(v0));
    }

    public TimeStampedData(DERIA5String arg4, MetaData arg5, ASN1OctetString arg6, Evidence arg7) {
        super();
        this.version = new ASN1Integer(1);
        this.dataUri = arg4;
        this.metaData = arg5;
        this.content = arg6;
        this.temporalEvidence = arg7;
    }

    public ASN1OctetString getContent() {
        return this.content;
    }

    public DERIA5String getDataUri() {
        return this.dataUri;
    }

    public static TimeStampedData getInstance(Object arg2) {
        TimeStampedData v2;
        if(!(arg2 instanceof TimeStampedData)) {
            if(arg2 != null) {
                v2 = new TimeStampedData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public MetaData getMetaData() {
        return this.metaData;
    }

    public Evidence getTemporalEvidence() {
        return this.temporalEvidence;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        if(this.dataUri != null) {
            v0.add(this.dataUri);
        }

        if(this.metaData != null) {
            v0.add(this.metaData);
        }

        if(this.content != null) {
            v0.add(this.content);
        }

        v0.add(this.temporalEvidence);
        return new BERSequence(v0);
    }
}

