// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cms;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1OctetStringParser;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1SequenceParser;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.DERIA5String;

public class TimeStampedDataParser {
    private ASN1OctetStringParser content;
    private DERIA5String dataUri;
    private MetaData metaData;
    private ASN1SequenceParser parser;
    private Evidence temporalEvidence;
    private ASN1Integer version;

    private TimeStampedDataParser(ASN1SequenceParser arg3) {
        super();
        this.parser = arg3;
        this.version = ASN1Integer.getInstance(arg3.readObject());
        ASN1Encodable v0 = arg3.readObject();
        if((v0 instanceof DERIA5String)) {
            this.dataUri = DERIA5String.getInstance(v0);
            v0 = arg3.readObject();
        }

        if(((v0 instanceof MetaData)) || ((v0 instanceof ASN1SequenceParser))) {
            this.metaData = MetaData.getInstance(v0.toASN1Primitive());
            v0 = arg3.readObject();
        }

        if((v0 instanceof ASN1OctetStringParser)) {
            this.content = ((ASN1OctetStringParser)v0);
        }
    }

    public ASN1OctetStringParser getContent() {
        return this.content;
    }

    public DERIA5String getDataUri() {
        return this.dataUri;
    }

    public static TimeStampedDataParser getInstance(Object arg2) {
        TimeStampedDataParser v0;
        if((arg2 instanceof ASN1Sequence)) {
            v0 = new TimeStampedDataParser(((ASN1Sequence)arg2).parser());
        }
        else if((arg2 instanceof ASN1SequenceParser)) {
            v0 = new TimeStampedDataParser(((ASN1SequenceParser)arg2));
        }
        else {
            v0 = null;
        }

        return v0;
    }

    public MetaData getMetaData() {
        return this.metaData;
    }

    public Evidence getTemporalEvidence() {
        if(this.temporalEvidence == null) {
            this.temporalEvidence = Evidence.getInstance(this.parser.readObject().toASN1Primitive());
        }

        return this.temporalEvidence;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        if(this.dataUri != null) {
            v0.add(this.dataUri);
        }

        if(this.metaData != null) {
            v0.add(this.metaData);
        }

        if(this.content != null) {
            v0.add(this.content);
        }

        v0.add(this.temporalEvidence);
        return new BERSequence(v0);
    }
}

