// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;

public class CertTemplate extends ASN1Object {
    private Extensions extensions;
    private X500Name issuer;
    private DERBitString issuerUID;
    private SubjectPublicKeyInfo publicKey;
    private ASN1Sequence seq;
    private ASN1Integer serialNumber;
    private AlgorithmIdentifier signingAlg;
    private X500Name subject;
    private DERBitString subjectUID;
    private OptionalValidity validity;
    private ASN1Integer version;

    private CertTemplate(ASN1Sequence arg6) {
        super();
        this.seq = arg6;
        Enumeration v1 = arg6.getObjects();
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_20;
                }
                case 1: {
                    goto label_23;
                }
                case 2: {
                    goto label_26;
                }
                case 3: {
                    goto label_29;
                }
                case 4: {
                    goto label_32;
                }
                case 5: {
                    goto label_36;
                }
                case 6: {
                    goto label_39;
                }
                case 7: {
                    goto label_42;
                }
                case 8: {
                    goto label_45;
                }
                case 9: {
                    goto label_48;
                }
            }

            throw new IllegalArgumentException("unknown tag: " + ((ASN1TaggedObject)v0).getTagNo());
        label_20:
            this.version = ASN1Integer.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_39:
            this.publicKey = SubjectPublicKeyInfo.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_23:
            this.serialNumber = ASN1Integer.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_36:
            this.subject = X500Name.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_45:
            this.subjectUID = DERBitString.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_26:
            this.signingAlg = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_48:
            this.extensions = Extensions.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_32:
            this.validity = OptionalValidity.getInstance(ASN1Sequence.getInstance(((ASN1TaggedObject)v0), false));
            continue;
        label_42:
            this.issuerUID = DERBitString.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_29:
            this.issuer = X500Name.getInstance(((ASN1TaggedObject)v0), true);
        }
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public static CertTemplate getInstance(Object arg2) {
        CertTemplate v2;
        if(!(arg2 instanceof CertTemplate)) {
            if(arg2 != null) {
                v2 = new CertTemplate(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public X500Name getIssuer() {
        return this.issuer;
    }

    public DERBitString getIssuerUID() {
        return this.issuerUID;
    }

    public SubjectPublicKeyInfo getPublicKey() {
        return this.publicKey;
    }

    public ASN1Integer getSerialNumber() {
        return this.serialNumber;
    }

    public AlgorithmIdentifier getSigningAlg() {
        return this.signingAlg;
    }

    public X500Name getSubject() {
        return this.subject;
    }

    public DERBitString getSubjectUID() {
        return this.subjectUID;
    }

    public OptionalValidity getValidity() {
        return this.validity;
    }

    public int getVersion() {
        return this.version.getValue().intValue();
    }

    public ASN1Primitive toASN1Primitive() {
        return this.seq;
    }
}

