// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERUTF8String;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.GeneralName;

public class EncKeyWithID extends ASN1Object {
    private final ASN1Encodable identifier;
    private final PrivateKeyInfo privKeyInfo;

    private EncKeyWithID(ASN1Sequence arg3) {
        super();
        this.privKeyInfo = PrivateKeyInfo.getInstance(arg3.getObjectAt(0));
        if(arg3.size() <= 1) {
            this.identifier = null;
        }
        else if(!(arg3.getObjectAt(1) instanceof DERUTF8String)) {
            this.identifier = GeneralName.getInstance(arg3.getObjectAt(1));
        }
        else {
            this.identifier = arg3.getObjectAt(1);
        }
    }

    public EncKeyWithID(PrivateKeyInfo arg2) {
        super();
        this.privKeyInfo = arg2;
        this.identifier = null;
    }

    public EncKeyWithID(PrivateKeyInfo arg1, DERUTF8String arg2) {
        super();
        this.privKeyInfo = arg1;
        this.identifier = ((ASN1Encodable)arg2);
    }

    public EncKeyWithID(PrivateKeyInfo arg1, GeneralName arg2) {
        super();
        this.privKeyInfo = arg1;
        this.identifier = ((ASN1Encodable)arg2);
    }

    public ASN1Encodable getIdentifier() {
        return this.identifier;
    }

    public static EncKeyWithID getInstance(Object arg2) {
        EncKeyWithID v2;
        if(!(arg2 instanceof EncKeyWithID)) {
            if(arg2 != null) {
                v2 = new EncKeyWithID(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public PrivateKeyInfo getPrivateKey() {
        return this.privKeyInfo;
    }

    public boolean hasIdentifier() {
        boolean v0 = this.identifier != null ? true : false;
        return v0;
    }

    public boolean isIdentifierUTF8String() {
        return this.identifier instanceof DERUTF8String;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.privKeyInfo);
        if(this.identifier != null) {
            v0.add(this.identifier);
        }

        return new DERSequence(v0);
    }
}

