// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class EncryptedValue extends ASN1Object {
    private DERBitString encSymmKey;
    private DERBitString encValue;
    private AlgorithmIdentifier intendedAlg;
    private AlgorithmIdentifier keyAlg;
    private AlgorithmIdentifier symmAlg;
    private ASN1OctetString valueHint;

    private EncryptedValue(ASN1Sequence arg5) {
        super();
        int v1;
        for(v1 = 0; (arg5.getObjectAt(v1) instanceof ASN1TaggedObject); ++v1) {
            ASN1Encodable v0 = arg5.getObjectAt(v1);
            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    this.intendedAlg = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
                case 1: {
                    this.symmAlg = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
                case 2: {
                    this.encSymmKey = DERBitString.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
                case 3: {
                    this.keyAlg = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
                case 4: {
                    this.valueHint = ASN1OctetString.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
            }
        }

        this.encValue = DERBitString.getInstance(arg5.getObjectAt(v1));
    }

    public EncryptedValue(AlgorithmIdentifier arg3, AlgorithmIdentifier arg4, DERBitString arg5, AlgorithmIdentifier arg6, ASN1OctetString arg7, DERBitString arg8) {
        super();
        if(arg8 == null) {
            throw new IllegalArgumentException("\'encValue\' cannot be null");
        }

        this.intendedAlg = arg3;
        this.symmAlg = arg4;
        this.encSymmKey = arg5;
        this.keyAlg = arg6;
        this.valueHint = arg7;
        this.encValue = arg8;
    }

    private void addOptional(ASN1EncodableVector arg3, int arg4, ASN1Encodable arg5) {
        if(arg5 != null) {
            arg3.add(new DERTaggedObject(false, arg4, arg5));
        }
    }

    public DERBitString getEncSymmKey() {
        return this.encSymmKey;
    }

    public DERBitString getEncValue() {
        return this.encValue;
    }

    public static EncryptedValue getInstance(Object arg2) {
        if(!(arg2 instanceof EncryptedValue)) {
            if(arg2 != null) {
                EncryptedValue v2 = new EncryptedValue(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public AlgorithmIdentifier getIntendedAlg() {
        return this.intendedAlg;
    }

    public AlgorithmIdentifier getKeyAlg() {
        return this.keyAlg;
    }

    public AlgorithmIdentifier getSymmAlg() {
        return this.symmAlg;
    }

    public ASN1OctetString getValueHint() {
        return this.valueHint;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        this.addOptional(v0, 0, this.intendedAlg);
        this.addOptional(v0, 1, this.symmAlg);
        this.addOptional(v0, 2, this.encSymmKey);
        this.addOptional(v0, 3, this.keyAlg);
        this.addOptional(v0, 4, this.valueHint);
        v0.add(this.encValue);
        return new DERSequence(v0);
    }
}

