// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Time;

public class OptionalValidity extends ASN1Object {
    private Time notAfter;
    private Time notBefore;

    private OptionalValidity(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            if(((ASN1TaggedObject)v0).getTagNo() == 0) {
                this.notBefore = Time.getInstance(((ASN1TaggedObject)v0), true);
                continue;
            }

            this.notAfter = Time.getInstance(((ASN1TaggedObject)v0), true);
        }
    }

    public OptionalValidity(Time arg3, Time arg4) {
        super();
        if(arg3 == null && arg4 == null) {
            throw new IllegalArgumentException("at least one of notBefore/notAfter must not be null.");
        }

        this.notBefore = arg3;
        this.notAfter = arg4;
    }

    public static OptionalValidity getInstance(Object arg2) {
        OptionalValidity v2;
        if(!(arg2 instanceof OptionalValidity)) {
            if(arg2 != null) {
                v2 = new OptionalValidity(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public Time getNotAfter() {
        return this.notAfter;
    }

    public Time getNotBefore() {
        return this.notBefore;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.notBefore != null) {
            v0.add(new DERTaggedObject(true, 0, this.notBefore));
        }

        if(this.notAfter != null) {
            v0.add(new DERTaggedObject(true, 1, this.notAfter));
        }

        return new DERSequence(v0);
    }
}

