// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.cmp.CMPObjectIdentifiers;
import org.bouncycastle.asn1.cmp.PBMParameter;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class PKMACValue extends ASN1Object {
    private AlgorithmIdentifier algId;
    private DERBitString value;

    private PKMACValue(ASN1Sequence arg2) {
        super();
        this.algId = AlgorithmIdentifier.getInstance(arg2.getObjectAt(0));
        this.value = DERBitString.getInstance(arg2.getObjectAt(1));
    }

    public PKMACValue(PBMParameter arg3, DERBitString arg4) {
        this(new AlgorithmIdentifier(CMPObjectIdentifiers.passwordBasedMac, ((ASN1Encodable)arg3)), arg4);
    }

    public PKMACValue(AlgorithmIdentifier arg1, DERBitString arg2) {
        super();
        this.algId = arg1;
        this.value = arg2;
    }

    public AlgorithmIdentifier getAlgId() {
        return this.algId;
    }

    public static PKMACValue getInstance(Object arg2) {
        if(!(arg2 instanceof PKMACValue)) {
            if(arg2 != null) {
                PKMACValue v2 = new PKMACValue(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static PKMACValue getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return PKMACValue.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public DERBitString getValue() {
        return this.value;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.algId);
        v0.add(this.value);
        return new DERSequence(v0);
    }
}

