// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class POPOSigningKey extends ASN1Object {
    private AlgorithmIdentifier algorithmIdentifier;
    private POPOSigningKeyInput poposkInput;
    private DERBitString signature;

    private POPOSigningKey(ASN1Sequence arg5) {
        super();
        int v0 = 0;
        if((arg5.getObjectAt(0) instanceof ASN1TaggedObject)) {
            ASN1Encodable v0_1 = arg5.getObjectAt(0);
            if(((ASN1TaggedObject)v0_1).getTagNo() != 0) {
                throw new IllegalArgumentException("Unknown POPOSigningKeyInput tag: " + ((ASN1TaggedObject)v0_1).getTagNo());
            }
            else {
                this.poposkInput = POPOSigningKeyInput.getInstance(((ASN1TaggedObject)v0_1).getObject());
                v0 = 1;
            }
        }

        this.algorithmIdentifier = AlgorithmIdentifier.getInstance(arg5.getObjectAt(v0));
        this.signature = DERBitString.getInstance(arg5.getObjectAt(v0 + 1));
    }

    public POPOSigningKey(POPOSigningKeyInput arg1, AlgorithmIdentifier arg2, DERBitString arg3) {
        super();
        this.poposkInput = arg1;
        this.algorithmIdentifier = arg2;
        this.signature = arg3;
    }

    public AlgorithmIdentifier getAlgorithmIdentifier() {
        return this.algorithmIdentifier;
    }

    public static POPOSigningKey getInstance(Object arg2) {
        POPOSigningKey v2;
        if(!(arg2 instanceof POPOSigningKey)) {
            if(arg2 != null) {
                v2 = new POPOSigningKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static POPOSigningKey getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return POPOSigningKey.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public POPOSigningKeyInput getPoposkInput() {
        return this.poposkInput;
    }

    public DERBitString getSignature() {
        return this.signature;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.poposkInput != null) {
            v0.add(new DERTaggedObject(false, 0, this.poposkInput));
        }

        v0.add(this.algorithmIdentifier);
        v0.add(this.signature);
        return new DERSequence(v0);
    }
}

