// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;

public class POPOSigningKeyInput extends ASN1Object {
    private SubjectPublicKeyInfo publicKey;
    private PKMACValue publicKeyMAC;
    private GeneralName sender;

    private POPOSigningKeyInput(ASN1Sequence arg5) {
        super();
        ASN1Encodable v0 = arg5.getObjectAt(0);
        if(!(v0 instanceof ASN1TaggedObject)) {
            this.publicKeyMAC = PKMACValue.getInstance(v0);
        }
        else if(((ASN1TaggedObject)v0).getTagNo() != 0) {
            throw new IllegalArgumentException("Unknown authInfo tag: " + ((ASN1TaggedObject)v0).getTagNo());
        }
        else {
            this.sender = GeneralName.getInstance(((ASN1TaggedObject)v0).getObject());
        }

        this.publicKey = SubjectPublicKeyInfo.getInstance(arg5.getObjectAt(1));
    }

    public POPOSigningKeyInput(PKMACValue arg1, SubjectPublicKeyInfo arg2) {
        super();
        this.publicKeyMAC = arg1;
        this.publicKey = arg2;
    }

    public POPOSigningKeyInput(GeneralName arg1, SubjectPublicKeyInfo arg2) {
        super();
        this.sender = arg1;
        this.publicKey = arg2;
    }

    public static POPOSigningKeyInput getInstance(Object arg2) {
        if(!(arg2 instanceof POPOSigningKeyInput)) {
            if(arg2 != null) {
                POPOSigningKeyInput v2 = new POPOSigningKeyInput(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public SubjectPublicKeyInfo getPublicKey() {
        return this.publicKey;
    }

    public PKMACValue getPublicKeyMAC() {
        return this.publicKeyMAC;
    }

    public GeneralName getSender() {
        return this.sender;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.sender != null) {
            v0.add(new DERTaggedObject(false, 0, this.sender));
        }
        else {
            v0.add(this.publicKeyMAC);
        }

        v0.add(this.publicKey);
        return new DERSequence(v0);
    }
}

