// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.crmf;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERTaggedObject;

public class ProofOfPossession extends ASN1Object implements ASN1Choice {
    public static final int TYPE_KEY_AGREEMENT = 3;
    public static final int TYPE_KEY_ENCIPHERMENT = 2;
    public static final int TYPE_RA_VERIFIED = 0;
    public static final int TYPE_SIGNING_KEY = 1;
    private ASN1Encodable obj;
    private int tagNo;

    public ProofOfPossession() {
        super();
        this.tagNo = 0;
        this.obj = DERNull.INSTANCE;
    }

    public ProofOfPossession(int arg1, POPOPrivKey arg2) {
        super();
        this.tagNo = arg1;
        this.obj = ((ASN1Encodable)arg2);
    }

    private ProofOfPossession(ASN1TaggedObject arg4) {
        super();
        this.tagNo = arg4.getTagNo();
        switch(this.tagNo) {
            case 0: {
                goto label_15;
            }
            case 1: {
                goto label_18;
            }
            case 2: 
            case 3: {
                goto label_22;
            }
        }

        throw new IllegalArgumentException("unknown tag: " + this.tagNo);
    label_18:
        this.obj = POPOSigningKey.getInstance(arg4, false);
        return;
    label_22:
        this.obj = POPOPrivKey.getInstance(arg4, true);
        return;
    label_15:
        this.obj = DERNull.INSTANCE;
    }

    public ProofOfPossession(POPOSigningKey arg2) {
        super();
        this.tagNo = 1;
        this.obj = ((ASN1Encodable)arg2);
    }

    public static ProofOfPossession getInstance(Object arg3) {
        ProofOfPossession v3;
        if(arg3 != null && !(arg3 instanceof ProofOfPossession)) {
            if((arg3 instanceof ASN1TaggedObject)) {
                v3 = new ProofOfPossession(((ASN1TaggedObject)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid object: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public ASN1Encodable getObject() {
        return this.obj;
    }

    public int getType() {
        return this.tagNo;
    }

    public ASN1Primitive toASN1Primitive() {
        return new DERTaggedObject(false, this.tagNo, this.obj);
    }
}

