// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cryptopro;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class GOST3410ParamSetParameters extends ASN1Object {
    ASN1Integer a;
    int keySize;
    ASN1Integer p;
    ASN1Integer q;

    public GOST3410ParamSetParameters(int arg2, BigInteger arg3, BigInteger arg4, BigInteger arg5) {
        super();
        this.keySize = arg2;
        this.p = new ASN1Integer(arg3);
        this.q = new ASN1Integer(arg4);
        this.a = new ASN1Integer(arg5);
    }

    public GOST3410ParamSetParameters(ASN1Sequence arg3) {
        super();
        Enumeration v1 = arg3.getObjects();
        this.keySize = v1.nextElement().getValue().intValue();
        this.p = v1.nextElement();
        this.q = v1.nextElement();
        this.a = v1.nextElement();
    }

    public BigInteger getA() {
        return this.a.getPositiveValue();
    }

    public static GOST3410ParamSetParameters getInstance(Object arg3) {
        GOST3410ParamSetParameters v3;
        if(arg3 != null && !(arg3 instanceof GOST3410ParamSetParameters)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new GOST3410ParamSetParameters(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid GOST3410Parameter: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static GOST3410ParamSetParameters getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return GOST3410ParamSetParameters.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public int getKeySize() {
        return this.keySize;
    }

    public int getLKeySize() {
        return this.keySize;
    }

    public BigInteger getP() {
        return this.p.getPositiveValue();
    }

    public BigInteger getQ() {
        return this.q.getPositiveValue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(((long)this.keySize)));
        v0.add(this.p);
        v0.add(this.q);
        v0.add(this.a);
        return new DERSequence(v0);
    }
}

