// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.cryptopro;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class GOST3410PublicKeyAlgParameters extends ASN1Object {
    private ASN1ObjectIdentifier digestParamSet;
    private ASN1ObjectIdentifier encryptionParamSet;
    private ASN1ObjectIdentifier publicKeyParamSet;

    public GOST3410PublicKeyAlgParameters(ASN1ObjectIdentifier arg2, ASN1ObjectIdentifier arg3) {
        super();
        this.publicKeyParamSet = arg2;
        this.digestParamSet = arg3;
        this.encryptionParamSet = null;
    }

    public GOST3410PublicKeyAlgParameters(ASN1ObjectIdentifier arg1, ASN1ObjectIdentifier arg2, ASN1ObjectIdentifier arg3) {
        super();
        this.publicKeyParamSet = arg1;
        this.digestParamSet = arg2;
        this.encryptionParamSet = arg3;
    }

    public GOST3410PublicKeyAlgParameters(ASN1Sequence arg3) {
        int v1 = 2;
        super();
        this.publicKeyParamSet = arg3.getObjectAt(0);
        this.digestParamSet = arg3.getObjectAt(1);
        if(arg3.size() > v1) {
            this.encryptionParamSet = arg3.getObjectAt(v1);
        }
    }

    public ASN1ObjectIdentifier getDigestParamSet() {
        return this.digestParamSet;
    }

    public ASN1ObjectIdentifier getEncryptionParamSet() {
        return this.encryptionParamSet;
    }

    public static GOST3410PublicKeyAlgParameters getInstance(Object arg2) {
        if(!(arg2 instanceof GOST3410PublicKeyAlgParameters)) {
            if(arg2 != null) {
                GOST3410PublicKeyAlgParameters v2 = new GOST3410PublicKeyAlgParameters(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static GOST3410PublicKeyAlgParameters getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return GOST3410PublicKeyAlgParameters.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1ObjectIdentifier getPublicKeyParamSet() {
        return this.publicKeyParamSet;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.publicKeyParamSet);
        v0.add(this.digestParamSet);
        if(this.encryptionParamSet != null) {
            v0.add(this.encryptionParamSet);
        }

        return new DERSequence(v0);
    }
}

