// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.cmp.PKIStatusInfo;
import org.bouncycastle.asn1.cms.ContentInfo;
import org.bouncycastle.asn1.ess.ESSCertID;
import org.bouncycastle.asn1.ocsp.CertID;
import org.bouncycastle.asn1.ocsp.CertStatus;
import org.bouncycastle.asn1.ocsp.OCSPResponse;
import org.bouncycastle.asn1.smime.SMIMECapabilities;
import org.bouncycastle.asn1.x509.Certificate;
import org.bouncycastle.asn1.x509.CertificateList;
import org.bouncycastle.asn1.x509.Extension;

public class CertEtcToken extends ASN1Object implements ASN1Choice {
    public static final int TAG_ASSERTION = 3;
    public static final int TAG_CAPABILITIES = 8;
    public static final int TAG_CERTIFICATE = 0;
    public static final int TAG_CRL = 4;
    public static final int TAG_ESSCERTID = 1;
    public static final int TAG_OCSPCERTID = 6;
    public static final int TAG_OCSPCERTSTATUS = 5;
    public static final int TAG_OCSPRESPONSE = 7;
    public static final int TAG_PKISTATUS = 2;
    private static final boolean[] explicit;
    private Extension extension;
    private int tagNo;
    private ASN1Encodable value;

    static {
        CertEtcToken.explicit = new boolean[]{false, true, false, true, false, true, false, false, true};
    }

    public CertEtcToken(int arg1, ASN1Encodable arg2) {
        super();
        this.tagNo = arg1;
        this.value = arg2;
    }

    private CertEtcToken(ASN1TaggedObject arg4) {
        super();
        this.tagNo = arg4.getTagNo();
        switch(this.tagNo) {
            case 0: {
                goto label_16;
            }
            case 1: {
                goto label_19;
            }
            case 2: {
                goto label_23;
            }
            case 3: {
                goto label_26;
            }
            case 4: {
                goto label_30;
            }
            case 5: {
                goto label_33;
            }
            case 6: {
                goto label_37;
            }
            case 7: {
                goto label_40;
            }
            case 8: {
                goto label_43;
            }
        }

        throw new IllegalArgumentException("Unknown tag: " + this.tagNo);
    label_37:
        this.value = CertID.getInstance(arg4, false);
        return;
    label_19:
        this.value = ESSCertID.getInstance(arg4.getObject());
        return;
    label_40:
        this.value = OCSPResponse.getInstance(arg4, false);
        return;
    label_33:
        this.value = CertStatus.getInstance(arg4.getObject());
        return;
    label_23:
        this.value = PKIStatusInfo.getInstance(arg4, false);
        return;
    label_26:
        this.value = ContentInfo.getInstance(arg4.getObject());
        return;
    label_16:
        this.value = Certificate.getInstance(arg4, false);
        return;
    label_43:
        this.value = SMIMECapabilities.getInstance(arg4.getObject());
        return;
    label_30:
        this.value = CertificateList.getInstance(arg4, false);
    }

    public CertEtcToken(Extension arg2) {
        super();
        this.tagNo = -1;
        this.extension = arg2;
    }

    public static CertEtcToken[] arrayFromSequence(ASN1Sequence arg3) {
        CertEtcToken[] v1 = new CertEtcToken[arg3.size()];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = CertEtcToken.getInstance(arg3.getObjectAt(v0));
        }

        return v1;
    }

    public Extension getExtension() {
        return this.extension;
    }

    public static CertEtcToken getInstance(Object arg2) {
        CertEtcToken v2;
        if(!(arg2 instanceof CertEtcToken)) {
            if((arg2 instanceof ASN1TaggedObject)) {
                v2 = new CertEtcToken(((ASN1TaggedObject)arg2));
            }
            else if(arg2 != null) {
                v2 = new CertEtcToken(Extension.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public int getTagNo() {
        return this.tagNo;
    }

    public ASN1Encodable getValue() {
        return this.value;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1Primitive v0_1;
        if(this.extension == null) {
            DERTaggedObject v0 = new DERTaggedObject(CertEtcToken.explicit[this.tagNo], this.tagNo, this.value);
        }
        else {
            v0_1 = this.extension.toASN1Primitive();
        }

        return v0_1;
    }

    public String toString() {
        return "CertEtcToken {\n" + this.value + "}\n";
    }
}

