// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.cmp.PKIStatusInfo;
import org.bouncycastle.asn1.x509.DigestInfo;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.PolicyInformation;

public class DVCSCertInfo extends ASN1Object {
    private static final int DEFAULT_VERSION = 1;
    private static final int TAG_CERTS = 3;
    private static final int TAG_DV_STATUS = 0;
    private static final int TAG_POLICY = 1;
    private static final int TAG_REQ_SIGNATURE = 2;
    private ASN1Sequence certs;
    private DVCSRequestInformation dvReqInfo;
    private PKIStatusInfo dvStatus;
    private Extensions extensions;
    private DigestInfo messageImprint;
    private PolicyInformation policy;
    private ASN1Set reqSignature;
    private DVCSTime responseTime;
    private ASN1Integer serialNumber;
    private int version;

    private DVCSCertInfo(ASN1Sequence arg5) {
        int v1;
        super();
        this.version = 1;
        ASN1Encodable v0 = arg5.getObjectAt(0);
        try {
            this.version = ASN1Integer.getInstance(v0).getValue().intValue();
            v1 = 2;
            v0 = arg5.getObjectAt(1);
        }
        catch(IllegalArgumentException v2) {
        }

        this.dvReqInfo = DVCSRequestInformation.getInstance(v0);
        int v0_1 = v1 + 1;
        this.messageImprint = DigestInfo.getInstance(arg5.getObjectAt(v1));
        v1 = v0_1 + 1;
        this.serialNumber = ASN1Integer.getInstance(arg5.getObjectAt(v0_1));
        v0_1 = v1 + 1;
        this.responseTime = DVCSTime.getInstance(arg5.getObjectAt(v1));
        while(v0_1 < arg5.size()) {
            v1 = v0_1 + 1;
            v0 = arg5.getObjectAt(v0_1);
            try {
                ASN1TaggedObject v2_1 = ASN1TaggedObject.getInstance(v0);
                switch(v2_1.getTagNo()) {
                    case 0: {
                        this.dvStatus = PKIStatusInfo.getInstance(v2_1, false);
                        break;
                    }
                    case 1: {
                        this.policy = PolicyInformation.getInstance(ASN1Sequence.getInstance(v2_1, false));
                        break;
                    }
                    case 2: {
                        this.reqSignature = ASN1Set.getInstance(v2_1, false);
                        break;
                    }
                    case 3: {
                        this.certs = ASN1Sequence.getInstance(v2_1, false);
                        break;
                    }
                }

                v0_1 = v1;
            }
            catch(IllegalArgumentException v2) {
                try {
                    this.extensions = Extensions.getInstance(v0);
                    v0_1 = v1;
                }
                catch(IllegalArgumentException v0_2) {
                    v0_1 = v1;
                }
            }
        }
    }

    public DVCSCertInfo(DVCSRequestInformation arg2, DigestInfo arg3, ASN1Integer arg4, DVCSTime arg5) {
        super();
        this.version = 1;
        this.dvReqInfo = arg2;
        this.messageImprint = arg3;
        this.serialNumber = arg4;
        this.responseTime = arg5;
    }

    public TargetEtcChain[] getCerts() {
        TargetEtcChain[] v0 = this.certs != null ? TargetEtcChain.arrayFromSequence(this.certs) : null;
        return v0;
    }

    public DVCSRequestInformation getDvReqInfo() {
        return this.dvReqInfo;
    }

    public PKIStatusInfo getDvStatus() {
        return this.dvStatus;
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public static DVCSCertInfo getInstance(Object arg2) {
        if(!(arg2 instanceof DVCSCertInfo)) {
            if(arg2 != null) {
                DVCSCertInfo v2 = new DVCSCertInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static DVCSCertInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DVCSCertInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public DigestInfo getMessageImprint() {
        return this.messageImprint;
    }

    public PolicyInformation getPolicy() {
        return this.policy;
    }

    public ASN1Set getReqSignature() {
        return this.reqSignature;
    }

    public DVCSTime getResponseTime() {
        return this.responseTime;
    }

    public ASN1Integer getSerialNumber() {
        return this.serialNumber;
    }

    public int getVersion() {
        return this.version;
    }

    private void setDvReqInfo(DVCSRequestInformation arg1) {
        this.dvReqInfo = arg1;
    }

    private void setMessageImprint(DigestInfo arg1) {
        this.messageImprint = arg1;
    }

    private void setVersion(int arg1) {
        this.version = arg1;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.version != 1) {
            v0.add(new ASN1Integer(((long)this.version)));
        }

        v0.add(this.dvReqInfo);
        v0.add(this.messageImprint);
        v0.add(this.serialNumber);
        v0.add(this.responseTime);
        if(this.dvStatus != null) {
            v0.add(new DERTaggedObject(false, 0, this.dvStatus));
        }

        if(this.policy != null) {
            v0.add(new DERTaggedObject(false, 1, this.policy));
        }

        if(this.reqSignature != null) {
            v0.add(new DERTaggedObject(false, 2, this.reqSignature));
        }

        if(this.certs != null) {
            v0.add(new DERTaggedObject(false, 3, this.certs));
        }

        if(this.extensions != null) {
            v0.add(this.extensions);
        }

        return new DERSequence(v0);
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        v0.append("DVCSCertInfo {\n");
        if(this.version != 1) {
            v0.append("version: " + this.version + "\n");
        }

        v0.append("dvReqInfo: " + this.dvReqInfo + "\n");
        v0.append("messageImprint: " + this.messageImprint + "\n");
        v0.append("serialNumber: " + this.serialNumber + "\n");
        v0.append("responseTime: " + this.responseTime + "\n");
        if(this.dvStatus != null) {
            v0.append("dvStatus: " + this.dvStatus + "\n");
        }

        if(this.policy != null) {
            v0.append("policy: " + this.policy + "\n");
        }

        if(this.reqSignature != null) {
            v0.append("reqSignature: " + this.reqSignature + "\n");
        }

        if(this.certs != null) {
            v0.append("certs: " + this.certs + "\n");
        }

        if(this.extensions != null) {
            v0.append("extensions: " + this.extensions + "\n");
        }

        v0.append("}\n");
        return v0.toString();
    }
}

