// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.cmp.PKIStatusInfo;
import org.bouncycastle.asn1.x509.GeneralName;

public class DVCSErrorNotice extends ASN1Object {
    private GeneralName transactionIdentifier;
    private PKIStatusInfo transactionStatus;

    private DVCSErrorNotice(ASN1Sequence arg3) {
        super();
        this.transactionStatus = PKIStatusInfo.getInstance(arg3.getObjectAt(0));
        if(arg3.size() > 1) {
            this.transactionIdentifier = GeneralName.getInstance(arg3.getObjectAt(1));
        }
    }

    public DVCSErrorNotice(PKIStatusInfo arg2) {
        this(arg2, null);
    }

    public DVCSErrorNotice(PKIStatusInfo arg1, GeneralName arg2) {
        super();
        this.transactionStatus = arg1;
        this.transactionIdentifier = arg2;
    }

    public static DVCSErrorNotice getInstance(Object arg2) {
        if(!(arg2 instanceof DVCSErrorNotice)) {
            if(arg2 != null) {
                DVCSErrorNotice v2 = new DVCSErrorNotice(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static DVCSErrorNotice getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DVCSErrorNotice.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public GeneralName getTransactionIdentifier() {
        return this.transactionIdentifier;
    }

    public PKIStatusInfo getTransactionStatus() {
        return this.transactionStatus;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.transactionStatus);
        if(this.transactionIdentifier != null) {
            v0.add(this.transactionIdentifier);
        }

        return new DERSequence(v0);
    }

    public String toString() {
        StringBuilder v1 = new StringBuilder().append("DVCSErrorNotice {\ntransactionStatus: ").append(this.transactionStatus).append("\n");
        String v0 = this.transactionIdentifier != null ? "transactionIdentifier: " + this.transactionIdentifier + "\n" : "";
        return v1.append(v0).append("}\n").toString();
    }
}

