// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.GeneralName;

public class DVCSRequest extends ASN1Object {
    private Data data;
    private DVCSRequestInformation requestInformation;
    private GeneralName transactionIdentifier;

    private DVCSRequest(ASN1Sequence arg3) {
        int v1 = 2;
        super();
        this.requestInformation = DVCSRequestInformation.getInstance(arg3.getObjectAt(0));
        this.data = Data.getInstance(arg3.getObjectAt(1));
        if(arg3.size() > v1) {
            this.transactionIdentifier = GeneralName.getInstance(arg3.getObjectAt(v1));
        }
    }

    public DVCSRequest(DVCSRequestInformation arg2, Data arg3) {
        this(arg2, arg3, null);
    }

    public DVCSRequest(DVCSRequestInformation arg1, Data arg2, GeneralName arg3) {
        super();
        this.requestInformation = arg1;
        this.data = arg2;
        this.transactionIdentifier = arg3;
    }

    public Data getData() {
        return this.data;
    }

    public static DVCSRequest getInstance(Object arg2) {
        if(!(arg2 instanceof DVCSRequest)) {
            if(arg2 != null) {
                DVCSRequest v2 = new DVCSRequest(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static DVCSRequest getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DVCSRequest.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public DVCSRequestInformation getRequestInformation() {
        return this.requestInformation;
    }

    public GeneralName getTransactionIdentifier() {
        return this.transactionIdentifier;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.requestInformation);
        v0.add(this.data);
        if(this.transactionIdentifier != null) {
            v0.add(this.transactionIdentifier);
        }

        return new DERSequence(v0);
    }

    public String toString() {
        StringBuilder v1 = new StringBuilder().append("DVCSRequest {\nrequestInformation: ").append(this.requestInformation).append("\n").append("data: ").append(this.data).append("\n");
        String v0 = this.transactionIdentifier != null ? "transactionIdentifier: " + this.transactionIdentifier + "\n" : "";
        return v1.append(v0).append("}\n").toString();
    }
}

