// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.PolicyInformation;

public class DVCSRequestInformation extends ASN1Object {
    private static final int DEFAULT_VERSION = 1;
    private static final int TAG_DATA_LOCATIONS = 3;
    private static final int TAG_DVCS = 2;
    private static final int TAG_EXTENSIONS = 4;
    private static final int TAG_REQUESTER = 0;
    private static final int TAG_REQUEST_POLICY = 1;
    private GeneralNames dataLocations;
    private GeneralNames dvcs;
    private Extensions extensions;
    private BigInteger nonce;
    private PolicyInformation requestPolicy;
    private DVCSTime requestTime;
    private GeneralNames requester;
    private ServiceType service;
    private int version;

    private DVCSRequestInformation(ASN1Sequence arg5) {
        int v0 = 1;
        super();
        this.version = 1;
        if((arg5.getObjectAt(0) instanceof ASN1Integer)) {
            this.version = ASN1Integer.getInstance(arg5.getObjectAt(0)).getValue().intValue();
        }
        else {
            this.version = 1;
            v0 = 0;
        }

        this.service = ServiceType.getInstance(arg5.getObjectAt(v0));
        ++v0;
        while(v0 < arg5.size()) {
            ASN1Encodable v2 = arg5.getObjectAt(v0);
            if((v2 instanceof ASN1Integer)) {
                this.nonce = ASN1Integer.getInstance(v2).getValue();
            }
            else if((v2 instanceof ASN1GeneralizedTime)) {
                this.requestTime = DVCSTime.getInstance(v2);
            }
            else if((v2 instanceof ASN1TaggedObject)) {
                ASN1TaggedObject v2_1 = ASN1TaggedObject.getInstance(v2);
                switch(v2_1.getTagNo()) {
                    case 0: {
                        goto label_41;
                    }
                    case 1: {
                        goto label_44;
                    }
                    case 2: {
                        goto label_48;
                    }
                    case 3: {
                        goto label_51;
                    }
                    case 4: {
                        goto label_54;
                    }
                }

                goto label_25;
            label_54:
                this.extensions = Extensions.getInstance(v2_1, false);
                goto label_25;
            label_51:
                this.dataLocations = GeneralNames.getInstance(v2_1, false);
                goto label_25;
            label_48:
                this.dvcs = GeneralNames.getInstance(v2_1, false);
                goto label_25;
            label_41:
                this.requester = GeneralNames.getInstance(v2_1, false);
                goto label_25;
            label_44:
                this.requestPolicy = PolicyInformation.getInstance(ASN1Sequence.getInstance(v2_1, false));
            }
            else {
                this.requestTime = DVCSTime.getInstance(v2);
            }

        label_25:
            ++v0;
        }
    }

    public GeneralNames getDVCS() {
        return this.dvcs;
    }

    public GeneralNames getDataLocations() {
        return this.dataLocations;
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public static DVCSRequestInformation getInstance(Object arg2) {
        DVCSRequestInformation v2;
        if(!(arg2 instanceof DVCSRequestInformation)) {
            if(arg2 != null) {
                v2 = new DVCSRequestInformation(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static DVCSRequestInformation getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DVCSRequestInformation.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public BigInteger getNonce() {
        return this.nonce;
    }

    public PolicyInformation getRequestPolicy() {
        return this.requestPolicy;
    }

    public DVCSTime getRequestTime() {
        return this.requestTime;
    }

    public GeneralNames getRequester() {
        return this.requester;
    }

    public ServiceType getService() {
        return this.service;
    }

    public int getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        int v6 = 5;
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        if(this.version != 1) {
            v2.add(new ASN1Integer(((long)this.version)));
        }

        v2.add(this.service);
        if(this.nonce != null) {
            v2.add(new ASN1Integer(this.nonce));
        }

        if(this.requestTime != null) {
            v2.add(this.requestTime);
        }

        int[] v3 = new int[]{0, 1, 2, 3, 4};
        ASN1Encodable[] v4 = new ASN1Encodable[v6];
        v4[0] = this.requester;
        v4[1] = this.requestPolicy;
        v4[2] = this.dvcs;
        v4[3] = this.dataLocations;
        v4[4] = this.extensions;
        int v0;
        for(v0 = 0; v0 < v3.length; ++v0) {
            int v5 = v3[v0];
            ASN1Encodable v6_1 = v4[v0];
            if(v6_1 != null) {
                v2.add(new DERTaggedObject(false, v5, v6_1));
            }
        }

        return new DERSequence(v2);
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        v0.append("DVCSRequestInformation {\n");
        if(this.version != 1) {
            v0.append("version: " + this.version + "\n");
        }

        v0.append("service: " + this.service + "\n");
        if(this.nonce != null) {
            v0.append("nonce: " + this.nonce + "\n");
        }

        if(this.requestTime != null) {
            v0.append("requestTime: " + this.requestTime + "\n");
        }

        if(this.requester != null) {
            v0.append("requester: " + this.requester + "\n");
        }

        if(this.requestPolicy != null) {
            v0.append("requestPolicy: " + this.requestPolicy + "\n");
        }

        if(this.dvcs != null) {
            v0.append("dvcs: " + this.dvcs + "\n");
        }

        if(this.dataLocations != null) {
            v0.append("dataLocations: " + this.dataLocations + "\n");
        }

        if(this.extensions != null) {
            v0.append("extensions: " + this.extensions + "\n");
        }

        v0.append("}\n");
        return v0.toString();
    }
}

