// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.PolicyInformation;
import org.bouncycastle.util.BigIntegers;

public class DVCSRequestInformationBuilder {
    private static final int DEFAULT_VERSION = 1;
    private static final int TAG_DATA_LOCATIONS = 3;
    private static final int TAG_DVCS = 2;
    private static final int TAG_EXTENSIONS = 4;
    private static final int TAG_REQUESTER = 0;
    private static final int TAG_REQUEST_POLICY = 1;
    private GeneralNames dataLocations;
    private GeneralNames dvcs;
    private Extensions extensions;
    private DVCSRequestInformation initialInfo;
    private BigInteger nonce;
    private PolicyInformation requestPolicy;
    private DVCSTime requestTime;
    private GeneralNames requester;
    private final ServiceType service;
    private int version;

    public DVCSRequestInformationBuilder(DVCSRequestInformation arg2) {
        super();
        this.version = 1;
        this.initialInfo = arg2;
        this.service = arg2.getService();
        this.version = arg2.getVersion();
        this.nonce = arg2.getNonce();
        this.requestTime = arg2.getRequestTime();
        this.requestPolicy = arg2.getRequestPolicy();
        this.dvcs = arg2.getDVCS();
        this.dataLocations = arg2.getDataLocations();
    }

    public DVCSRequestInformationBuilder(ServiceType arg2) {
        super();
        this.version = 1;
        this.service = arg2;
    }

    public DVCSRequestInformation build() {
        int v6 = 5;
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        if(this.version != 1) {
            v2.add(new ASN1Integer(((long)this.version)));
        }

        v2.add(this.service);
        if(this.nonce != null) {
            v2.add(new ASN1Integer(this.nonce));
        }

        if(this.requestTime != null) {
            v2.add(this.requestTime);
        }

        int[] v3 = new int[]{0, 1, 2, 3, 4};
        ASN1Encodable[] v4 = new ASN1Encodable[v6];
        v4[0] = this.requester;
        v4[1] = this.requestPolicy;
        v4[2] = this.dvcs;
        v4[3] = this.dataLocations;
        v4[4] = this.extensions;
        int v0;
        for(v0 = 0; v0 < v3.length; ++v0) {
            int v5 = v3[v0];
            ASN1Encodable v6_1 = v4[v0];
            if(v6_1 != null) {
                v2.add(new DERTaggedObject(false, v5, v6_1));
            }
        }

        return DVCSRequestInformation.getInstance(new DERSequence(v2));
    }

    public void setDVCS(GeneralName arg2) {
        this.setDVCS(new GeneralNames(arg2));
    }

    public void setDVCS(GeneralNames arg1) {
        this.dvcs = arg1;
    }

    public void setDataLocations(GeneralName arg2) {
        this.setDataLocations(new GeneralNames(arg2));
    }

    public void setDataLocations(GeneralNames arg1) {
        this.dataLocations = arg1;
    }

    public void setExtensions(Extensions arg3) {
        if(this.initialInfo != null) {
            throw new IllegalStateException("cannot change extensions in existing DVCSRequestInformation");
        }

        this.extensions = arg3;
    }

    public void setNonce(BigInteger arg6) {
        if(this.initialInfo != null) {
            if(this.initialInfo.getNonce() == null) {
                this.nonce = arg6;
            }
            else {
                byte[] v0 = this.initialInfo.getNonce().toByteArray();
                byte[] v1 = BigIntegers.asUnsignedByteArray(arg6);
                byte[] v2 = new byte[v0.length + v1.length];
                System.arraycopy(v0, 0, v2, 0, v0.length);
                System.arraycopy(v1, 0, v2, v0.length, v1.length);
                this.nonce = new BigInteger(v2);
            }
        }

        this.nonce = arg6;
    }

    public void setRequestPolicy(PolicyInformation arg3) {
        if(this.initialInfo != null) {
            throw new IllegalStateException("cannot change request policy in existing DVCSRequestInformation");
        }

        this.requestPolicy = arg3;
    }

    public void setRequestTime(DVCSTime arg3) {
        if(this.initialInfo != null) {
            throw new IllegalStateException("cannot change request time in existing DVCSRequestInformation");
        }

        this.requestTime = arg3;
    }

    public void setRequester(GeneralName arg2) {
        this.setRequester(new GeneralNames(arg2));
    }

    public void setRequester(GeneralNames arg1) {
        this.requester = arg1;
    }

    public void setVersion(int arg3) {
        if(this.initialInfo != null) {
            throw new IllegalStateException("cannot change version in existing DVCSRequestInformation");
        }

        this.version = arg3;
    }
}

