// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERTaggedObject;

public class DVCSResponse extends ASN1Object implements ASN1Choice {
    private DVCSCertInfo dvCertInfo;
    private DVCSErrorNotice dvErrorNote;

    public DVCSResponse(DVCSCertInfo arg1) {
        super();
        this.dvCertInfo = arg1;
    }

    public DVCSResponse(DVCSErrorNotice arg1) {
        super();
        this.dvErrorNote = arg1;
    }

    public DVCSCertInfo getCertInfo() {
        return this.dvCertInfo;
    }

    public DVCSErrorNotice getErrorNotice() {
        return this.dvErrorNote;
    }

    public static DVCSResponse getInstance(Object arg4) {
        DVCSResponse v4;
        if(arg4 != null && !(arg4 instanceof DVCSResponse)) {
            if((arg4 instanceof byte[])) {
                try {
                    v4 = DVCSResponse.getInstance(ASN1Primitive.fromByteArray(((byte[])arg4)));
                }
                catch(IOException v0) {
                    throw new IllegalArgumentException("failed to construct sequence from byte[]: " + v0.getMessage());
                }
            }
            else if((arg4 instanceof ASN1Sequence)) {
                v4 = new DVCSResponse(DVCSCertInfo.getInstance(arg4));
            }
            else if((arg4 instanceof ASN1TaggedObject)) {
                v4 = new DVCSResponse(DVCSErrorNotice.getInstance(ASN1TaggedObject.getInstance(arg4), false));
            }
            else {
                throw new IllegalArgumentException("Couldn\'t convert from object to DVCSResponse: " + arg4.getClass().getName());
            }
        }

        return v4;
    }

    public static DVCSResponse getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DVCSResponse.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Primitive toASN1Primitive() {
        DERTaggedObject v0_1;
        if(this.dvCertInfo != null) {
            ASN1Primitive v0 = this.dvCertInfo.toASN1Primitive();
        }
        else {
            v0_1 = new DERTaggedObject(0, this.dvErrorNote);
        }

        return ((ASN1Primitive)v0_1);
    }

    public String toString() {
        String v0;
        if(this.dvCertInfo != null) {
            v0 = "DVCSResponse {\ndvCertInfo: " + this.dvCertInfo.toString() + "}\n";
        }
        else if(this.dvErrorNote != null) {
            v0 = "DVCSResponse {\ndvErrorNote: " + this.dvErrorNote.toString() + "}\n";
        }
        else {
            v0 = null;
        }

        return v0;
    }
}

