// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.DigestInfo;

public class Data extends ASN1Object implements ASN1Choice {
    private ASN1Sequence certs;
    private ASN1OctetString message;
    private DigestInfo messageImprint;

    public Data(ASN1OctetString arg1) {
        super();
        this.message = arg1;
    }

    private Data(ASN1Sequence arg1) {
        super();
        this.certs = arg1;
    }

    public Data(TargetEtcChain arg2) {
        super();
        this.certs = new DERSequence(((ASN1Encodable)arg2));
    }

    public Data(DigestInfo arg1) {
        super();
        this.messageImprint = arg1;
    }

    public Data(byte[] arg2) {
        super();
        this.message = new DEROctetString(arg2);
    }

    public Data(TargetEtcChain[] arg2) {
        super();
        this.certs = new DERSequence(((ASN1Encodable[])arg2));
    }

    public TargetEtcChain[] getCerts() {
        TargetEtcChain[] v0;
        if(this.certs == null) {
            v0 = null;
        }
        else {
            TargetEtcChain[] v1 = new TargetEtcChain[this.certs.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v1.length; ++v0_1) {
                v1[v0_1] = TargetEtcChain.getInstance(this.certs.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public static Data getInstance(Object arg3) {
        Data v3;
        if(!(arg3 instanceof Data)) {
            if((arg3 instanceof ASN1OctetString)) {
                v3 = new Data(((ASN1OctetString)arg3));
            }
            else if((arg3 instanceof ASN1Sequence)) {
                v3 = new Data(DigestInfo.getInstance(arg3));
            }
            else if((arg3 instanceof ASN1TaggedObject)) {
                v3 = new Data(ASN1Sequence.getInstance(((ASN1TaggedObject)arg3), false));
            }
            else {
                goto label_24;
            }
        }

        return v3;
    label_24:
        throw new IllegalArgumentException("Unknown object submitted to getInstance: " + arg3.getClass().getName());
    }

    public static Data getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return Data.getInstance(arg1.getObject());
    }

    public ASN1OctetString getMessage() {
        return this.message;
    }

    public DigestInfo getMessageImprint() {
        return this.messageImprint;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1Primitive v0;
        if(this.message != null) {
            v0 = this.message.toASN1Primitive();
        }
        else if(this.messageImprint != null) {
            v0 = this.messageImprint.toASN1Primitive();
        }
        else {
            DERTaggedObject v0_1 = new DERTaggedObject(false, 0, this.certs);
        }

        return v0;
    }

    public String toString() {
        String v0;
        if(this.message != null) {
            v0 = "Data {\n" + this.message + "}\n";
        }
        else if(this.messageImprint != null) {
            v0 = "Data {\n" + this.messageImprint + "}\n";
        }
        else {
            v0 = "Data {\n" + this.certs + "}\n";
        }

        return v0;
    }
}

