// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.dvcs;

import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.PolicyInformation;

public class PathProcInput extends ASN1Object {
    private PolicyInformation[] acceptablePolicySet;
    private boolean explicitPolicyReqd;
    private boolean inhibitAnyPolicy;
    private boolean inhibitPolicyMapping;

    public PathProcInput(PolicyInformation[] arg2) {
        super();
        this.inhibitPolicyMapping = false;
        this.explicitPolicyReqd = false;
        this.inhibitAnyPolicy = false;
        this.acceptablePolicySet = arg2;
    }

    public PathProcInput(PolicyInformation[] arg2, boolean arg3, boolean arg4, boolean arg5) {
        super();
        this.inhibitPolicyMapping = false;
        this.explicitPolicyReqd = false;
        this.inhibitAnyPolicy = false;
        this.acceptablePolicySet = arg2;
        this.inhibitPolicyMapping = arg3;
        this.explicitPolicyReqd = arg4;
        this.inhibitAnyPolicy = arg5;
    }

    private static PolicyInformation[] fromSequence(ASN1Sequence arg3) {
        PolicyInformation[] v1 = new PolicyInformation[arg3.size()];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = PolicyInformation.getInstance(arg3.getObjectAt(v0));
        }

        return v1;
    }

    public PolicyInformation[] getAcceptablePolicySet() {
        return this.acceptablePolicySet;
    }

    public static PathProcInput getInstance(Object arg5) {
        if(!(arg5 instanceof PathProcInput)) {
            if(arg5 != null) {
                ASN1Sequence v1 = ASN1Sequence.getInstance(arg5);
                PathProcInput v5 = new PathProcInput(PathProcInput.fromSequence(ASN1Sequence.getInstance(v1.getObjectAt(0))));
                int v0;
                for(v0 = 1; v0 < v1.size(); ++v0) {
                    ASN1Encodable v2 = v1.getObjectAt(v0);
                    if((v2 instanceof ASN1Boolean)) {
                        v5.setInhibitPolicyMapping(ASN1Boolean.getInstance(v2).isTrue());
                    }
                    else if((v2 instanceof ASN1TaggedObject)) {
                        ASN1TaggedObject v2_1 = ASN1TaggedObject.getInstance(v2);
                        switch(v2_1.getTagNo()) {
                            case 0: {
                                goto label_28;
                            }
                            case 1: {
                                goto label_32;
                            }
                        }

                        goto label_20;
                    label_28:
                        v5.setExplicitPolicyReqd(ASN1Boolean.getInstance(v2_1, false).isTrue());
                        goto label_20;
                    label_32:
                        v5.setInhibitAnyPolicy(ASN1Boolean.getInstance(v2_1, false).isTrue());
                    }

                label_20:
                }
            }
            else {
                arg5 = null;
            }
        }

        return arg5;
    }

    public static PathProcInput getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return PathProcInput.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public boolean isExplicitPolicyReqd() {
        return this.explicitPolicyReqd;
    }

    public boolean isInhibitAnyPolicy() {
        return this.inhibitAnyPolicy;
    }

    public boolean isInhibitPolicyMapping() {
        return this.inhibitPolicyMapping;
    }

    private void setExplicitPolicyReqd(boolean arg1) {
        this.explicitPolicyReqd = arg1;
    }

    private void setInhibitAnyPolicy(boolean arg1) {
        this.inhibitAnyPolicy = arg1;
    }

    private void setInhibitPolicyMapping(boolean arg1) {
        this.inhibitPolicyMapping = arg1;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        ASN1EncodableVector v3 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 != this.acceptablePolicySet.length; ++v0) {
            v3.add(this.acceptablePolicySet[v0]);
        }

        v2.add(new DERSequence(v3));
        if(this.inhibitPolicyMapping) {
            v2.add(new ASN1Boolean(this.inhibitPolicyMapping));
        }

        if(this.explicitPolicyReqd) {
            v2.add(new DERTaggedObject(false, 0, new ASN1Boolean(this.explicitPolicyReqd)));
        }

        if(this.inhibitAnyPolicy) {
            v2.add(new DERTaggedObject(false, 1, new ASN1Boolean(this.inhibitAnyPolicy)));
        }

        return new DERSequence(v2);
    }

    public String toString() {
        return "PathProcInput: {\nacceptablePolicySet: " + this.acceptablePolicySet + "\n" + "inhibitPolicyMapping: " + this.inhibitPolicyMapping + "\n" + "explicitPolicyReqd: " + this.explicitPolicyReqd + "\n" + "inhibitAnyPolicy: " + this.inhibitAnyPolicy + "\n" + "}\n";
    }
}

