// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1ParsingException;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERApplicationSpecific;
import org.bouncycastle.asn1.DEROctetString;

public class CVCertificate extends ASN1Object {
    public static String ReferenceEncoding;
    private static int bodyValid;
    private CertificateBody certificateBody;
    private static int signValid;
    private byte[] signature;
    private int valid;
    public static final byte version_1;

    static {
        CVCertificate.bodyValid = 1;
        CVCertificate.signValid = 2;
        CVCertificate.ReferenceEncoding = "ISO-8859-1";
    }

    public CVCertificate(ASN1InputStream arg1) {
        super();
        this.initFrom(arg1);
    }

    private CVCertificate(DERApplicationSpecific arg1) {
        super();
        this.setPrivateData(arg1);
    }

    public CVCertificate(CertificateBody arg3, byte[] arg4) {
        super();
        this.certificateBody = arg3;
        this.signature = arg4;
        this.valid |= CVCertificate.bodyValid;
        this.valid |= CVCertificate.signValid;
    }

    public CertificationAuthorityReference getAuthorityReference() {
        return this.certificateBody.getCertificationAuthorityReference();
    }

    public CertificateBody getBody() {
        return this.certificateBody;
    }

    public int getCertificateType() {
        return this.certificateBody.getCertificateType();
    }

    public PackedDate getEffectiveDate() {
        return this.certificateBody.getCertificateEffectiveDate();
    }

    public PackedDate getExpirationDate() {
        return this.certificateBody.getCertificateExpirationDate();
    }

    public ASN1ObjectIdentifier getHolderAuthorization() {
        return this.certificateBody.getCertificateHolderAuthorization().getOid();
    }

    public Flags getHolderAuthorizationRights() {
        return new Flags(this.certificateBody.getCertificateHolderAuthorization().getAccessRights() & 31);
    }

    public int getHolderAuthorizationRole() {
        return this.certificateBody.getCertificateHolderAuthorization().getAccessRights() & 192;
    }

    public CertificateHolderReference getHolderReference() {
        return this.certificateBody.getCertificateHolderReference();
    }

    public static CVCertificate getInstance(Object arg4) {
        if(!(arg4 instanceof CVCertificate)) {
            if(arg4 != null) {
                try {
                    CVCertificate v4 = new CVCertificate(DERApplicationSpecific.getInstance(arg4));
                }
                catch(IOException v0) {
                    throw new ASN1ParsingException("unable to parse data: " + v0.getMessage(), ((Throwable)v0));
                }
            }
            else {
                arg4 = null;
            }
        }

        return arg4;
    }

    public int getRole() {
        return this.certificateBody.getCertificateHolderAuthorization().getAccessRights();
    }

    public byte[] getSignature() {
        return this.signature;
    }

    private void initFrom(ASN1InputStream arg3) {
        while(true) {
            ASN1Primitive v0 = arg3.readObject();
            if(v0 == null) {
                return;
            }

            if(!(v0 instanceof DERApplicationSpecific)) {
                break;
            }

            this.setPrivateData(((DERApplicationSpecific)v0));
        }

        throw new IOException("Invalid Input Stream for creating an Iso7816CertificateStructure");
    }

    private void setPrivateData(DERApplicationSpecific arg5) {
        this.valid = 0;
        if(arg5.getApplicationTag() != 33) {
            goto label_42;
        }

        ASN1InputStream v1 = new ASN1InputStream(arg5.getContents());
        while(true) {
            ASN1Primitive v0 = v1.readObject();
            if(v0 == null) {
                return;
            }

            if(!(v0 instanceof DERApplicationSpecific)) {
                break;
            }

            switch(((DERApplicationSpecific)v0).getApplicationTag()) {
                case 55: {
                    goto label_31;
                }
                case 78: {
                    goto label_24;
                }
            }

            throw new IOException("Invalid tag, not an Iso7816CertificateStructure :" + ((DERApplicationSpecific)v0).getApplicationTag());
        label_24:
            this.certificateBody = CertificateBody.getInstance(v0);
            this.valid |= CVCertificate.bodyValid;
            continue;
        label_31:
            this.signature = ((DERApplicationSpecific)v0).getContents();
            this.valid |= CVCertificate.signValid;
        }

        throw new IOException("Invalid Object, not an Iso7816CertificateStructure");
        return;
    label_42:
        throw new IOException("not a CARDHOLDER_CERTIFICATE :" + arg5.getApplicationTag());
    }

    public ASN1Primitive toASN1Primitive() {
        DERApplicationSpecific v0_2;
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        if(this.valid != (CVCertificate.signValid | CVCertificate.bodyValid)) {
            ASN1Primitive v0 = null;
        }
        else {
            v1.add(this.certificateBody);
            try {
                v1.add(new DERApplicationSpecific(false, 55, new DEROctetString(this.signature)));
            }
            catch(IOException v0_1) {
                throw new IllegalStateException("unable to convert signature!");
            }

            v0_2 = new DERApplicationSpecific(33, v1);
        }

        return ((ASN1Primitive)v0_2);
    }
}

