// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.io.IOException;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1ParsingException;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERApplicationSpecific;
import org.bouncycastle.asn1.DEROctetString;

public class CVCertificateRequest extends ASN1Object {
    int ProfileId;
    public static byte[] ZeroArray;
    private static int bodyValid;
    byte[] certificate;
    private CertificateBody certificateBody;
    byte[] encoded;
    byte[] encodedAuthorityReference;
    private byte[] innerSignature;
    PublicKeyDataObject iso7816PubKey;
    ASN1ObjectIdentifier keyOid;
    private byte[] outerSignature;
    protected String overSignerReference;
    ASN1ObjectIdentifier signOid;
    private static int signValid;
    String strCertificateHolderReference;
    private int valid;

    static {
        CVCertificateRequest.bodyValid = 1;
        CVCertificateRequest.signValid = 2;
        CVCertificateRequest.ZeroArray = new byte[]{0};
    }

    private CVCertificateRequest(DERApplicationSpecific arg3) {
        super();
        this.innerSignature = null;
        this.outerSignature = null;
        this.signOid = null;
        this.keyOid = null;
        this.certificate = null;
        this.overSignerReference = null;
        this.iso7816PubKey = null;
        if(arg3.getApplicationTag() == 103) {
            ASN1Sequence v0 = ASN1Sequence.getInstance(arg3.getObject(16));
            this.initCertBody(DERApplicationSpecific.getInstance(v0.getObjectAt(0)));
            this.outerSignature = DERApplicationSpecific.getInstance(v0.getObjectAt(v0.size() - 1)).getContents();
        }
        else {
            this.initCertBody(arg3);
        }
    }

    public CertificateBody getCertificateBody() {
        return this.certificateBody;
    }

    public byte[] getInnerSignature() {
        return this.innerSignature;
    }

    public static CVCertificateRequest getInstance(Object arg4) {
        if(!(arg4 instanceof CVCertificateRequest)) {
            if(arg4 != null) {
                try {
                    CVCertificateRequest v4 = new CVCertificateRequest(DERApplicationSpecific.getInstance(arg4));
                }
                catch(IOException v0) {
                    throw new ASN1ParsingException("unable to parse data: " + v0.getMessage(), ((Throwable)v0));
                }
            }
            else {
                arg4 = null;
            }
        }

        return arg4;
    }

    public byte[] getOuterSignature() {
        return this.outerSignature;
    }

    public PublicKeyDataObject getPublicKey() {
        return this.certificateBody.getPublicKey();
    }

    public boolean hasOuterSignature() {
        boolean v0 = this.outerSignature != null ? true : false;
        return v0;
    }

    private void initCertBody(DERApplicationSpecific arg5) {
        if(arg5.getApplicationTag() == 33) {
            Enumeration v0 = ASN1Sequence.getInstance(arg5.getObject(16)).getObjects();
            while(v0.hasMoreElements()) {
                DERApplicationSpecific v1 = DERApplicationSpecific.getInstance(v0.nextElement());
                switch(v1.getApplicationTag()) {
                    case 55: {
                        goto label_30;
                    }
                    case 78: {
                        goto label_23;
                    }
                }

                throw new IOException("Invalid tag, not an CV Certificate Request element:" + v1.getApplicationTag());
            label_23:
                this.certificateBody = CertificateBody.getInstance(v1);
                this.valid |= CVCertificateRequest.bodyValid;
                continue;
            label_30:
                this.innerSignature = v1.getContents();
                this.valid |= CVCertificateRequest.signValid;
            }

            return;
        }

        throw new IOException("not a CARDHOLDER_CERTIFICATE in request:" + arg5.getApplicationTag());
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certificateBody);
        try {
            v0.add(new DERApplicationSpecific(false, 55, new DEROctetString(this.innerSignature)));
        }
        catch(IOException v0_1) {
            throw new IllegalStateException("unable to convert signature!");
        }

        return new DERApplicationSpecific(33, v0);
    }
}

