// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERApplicationSpecific;
import org.bouncycastle.asn1.DEROctetString;

public class CertificateBody extends ASN1Object {
    private static final int CAR = 2;
    private static final int CEfD = 32;
    private static final int CExD = 64;
    private static final int CHA = 16;
    private static final int CHR = 8;
    private static final int CPI = 1;
    private static final int PK = 4;
    private DERApplicationSpecific certificateEffectiveDate;
    private DERApplicationSpecific certificateExpirationDate;
    private CertificateHolderAuthorization certificateHolderAuthorization;
    private DERApplicationSpecific certificateHolderReference;
    private DERApplicationSpecific certificateProfileIdentifier;
    private int certificateType;
    private DERApplicationSpecific certificationAuthorityReference;
    public static final int profileType = 127;
    private PublicKeyDataObject publicKey;
    public static final int requestType = 13;
    ASN1InputStream seq;

    private CertificateBody(DERApplicationSpecific arg2) {
        super();
        this.certificateType = 0;
        this.setIso7816CertificateBody(arg2);
    }

    public CertificateBody(DERApplicationSpecific arg6, CertificationAuthorityReference arg7, PublicKeyDataObject arg8, CertificateHolderReference arg9, CertificateHolderAuthorization arg10, PackedDate arg11, PackedDate arg12) {
        super();
        this.certificateType = 0;
        this.setCertificateProfileIdentifier(arg6);
        this.setCertificationAuthorityReference(new DERApplicationSpecific(2, arg7.getEncoded()));
        this.setPublicKey(arg8);
        this.setCertificateHolderReference(new DERApplicationSpecific(32, arg9.getEncoded()));
        this.setCertificateHolderAuthorization(arg10);
        try {
            this.setCertificateEffectiveDate(new DERApplicationSpecific(false, 37, new DEROctetString(arg11.getEncoding())));
            this.setCertificateExpirationDate(new DERApplicationSpecific(false, 36, new DEROctetString(arg12.getEncoding())));
            return;
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("unable to encode dates: " + v0.getMessage());
        }
    }

    public PackedDate getCertificateEffectiveDate() {
        PackedDate v0 = (this.certificateType & 32) == 32 ? new PackedDate(this.certificateEffectiveDate.getContents()) : null;
        return v0;
    }

    public PackedDate getCertificateExpirationDate() {
        if((this.certificateType & 64) == 64) {
            return new PackedDate(this.certificateExpirationDate.getContents());
        }

        throw new IOException("certificate Expiration Date not set");
    }

    public CertificateHolderAuthorization getCertificateHolderAuthorization() {
        if((this.certificateType & 16) == 16) {
            return this.certificateHolderAuthorization;
        }

        throw new IOException("Certificate Holder Authorisation not set");
    }

    public CertificateHolderReference getCertificateHolderReference() {
        return new CertificateHolderReference(this.certificateHolderReference.getContents());
    }

    public DERApplicationSpecific getCertificateProfileIdentifier() {
        return this.certificateProfileIdentifier;
    }

    public int getCertificateType() {
        return this.certificateType;
    }

    public CertificationAuthorityReference getCertificationAuthorityReference() {
        if((this.certificateType & 2) == 2) {
            return new CertificationAuthorityReference(this.certificationAuthorityReference.getContents());
        }

        throw new IOException("Certification authority reference not set");
    }

    public static CertificateBody getInstance(Object arg2) {
        CertificateBody v2;
        if(!(arg2 instanceof CertificateBody)) {
            if(arg2 != null) {
                v2 = new CertificateBody(DERApplicationSpecific.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public PublicKeyDataObject getPublicKey() {
        return this.publicKey;
    }

    private ASN1Primitive profileToASN1Object() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certificateProfileIdentifier);
        v0.add(this.certificationAuthorityReference);
        v0.add(new DERApplicationSpecific(false, 73, this.publicKey));
        v0.add(this.certificateHolderReference);
        v0.add(this.certificateHolderAuthorization);
        v0.add(this.certificateEffectiveDate);
        v0.add(this.certificateExpirationDate);
        return new DERApplicationSpecific(78, v0);
    }

    private ASN1Primitive requestToASN1Object() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certificateProfileIdentifier);
        v0.add(new DERApplicationSpecific(false, 73, this.publicKey));
        v0.add(this.certificateHolderReference);
        return new DERApplicationSpecific(78, v0);
    }

    private void setCertificateEffectiveDate(DERApplicationSpecific arg4) {
        if(arg4.getApplicationTag() == 37) {
            this.certificateEffectiveDate = arg4;
            this.certificateType |= 32;
            return;
        }

        throw new IllegalArgumentException("Not an Iso7816Tags.APPLICATION_EFFECTIVE_DATE tag :" + EACTags.encodeTag(arg4));
    }

    private void setCertificateExpirationDate(DERApplicationSpecific arg3) {
        if(arg3.getApplicationTag() == 36) {
            this.certificateExpirationDate = arg3;
            this.certificateType |= 64;
            return;
        }

        throw new IllegalArgumentException("Not an Iso7816Tags.APPLICATION_EXPIRATION_DATE tag");
    }

    private void setCertificateHolderAuthorization(CertificateHolderAuthorization arg2) {
        this.certificateHolderAuthorization = arg2;
        this.certificateType |= 16;
    }

    private void setCertificateHolderReference(DERApplicationSpecific arg3) {
        if(arg3.getApplicationTag() == 32) {
            this.certificateHolderReference = arg3;
            this.certificateType |= 8;
            return;
        }

        throw new IllegalArgumentException("Not an Iso7816Tags.CARDHOLDER_NAME tag");
    }

    private void setCertificateProfileIdentifier(DERApplicationSpecific arg4) {
        if(arg4.getApplicationTag() == 41) {
            this.certificateProfileIdentifier = arg4;
            this.certificateType |= 1;
            return;
        }

        throw new IllegalArgumentException("Not an Iso7816Tags.INTERCHANGE_PROFILE tag :" + EACTags.encodeTag(arg4));
    }

    private void setCertificationAuthorityReference(DERApplicationSpecific arg3) {
        if(arg3.getApplicationTag() == 2) {
            this.certificationAuthorityReference = arg3;
            this.certificateType |= 2;
            return;
        }

        throw new IllegalArgumentException("Not an Iso7816Tags.ISSUER_IDENTIFICATION_NUMBER tag");
    }

    private void setIso7816CertificateBody(DERApplicationSpecific arg5) {
        ASN1Primitive v0;
        if(arg5.getApplicationTag() != 78) {
            goto label_24;
        }

        ASN1InputStream v1 = new ASN1InputStream(arg5.getContents());
        while(true) {
            v0 = v1.readObject();
            if(v0 == null) {
                return;
            }

            if(!(v0 instanceof DERApplicationSpecific)) {
                break;
            }

            switch(((DERApplicationSpecific)v0).getApplicationTag()) {
                case 2: {
                    goto label_42;
                }
                case 32: {
                    goto label_49;
                }
                case 36: {
                    goto label_57;
                }
                case 37: {
                    goto label_55;
                }
                case 41: {
                    goto label_40;
                }
                case 73: {
                    goto label_44;
                }
                case 76: {
                    goto label_51;
                }
            }

            this.certificateType = 0;
            throw new IOException("Not a valid iso7816 DERApplicationSpecific tag " + ((DERApplicationSpecific)v0).getApplicationTag());
        label_40:
            this.setCertificateProfileIdentifier(((DERApplicationSpecific)v0));
            continue;
        label_55:
            this.setCertificateEffectiveDate(((DERApplicationSpecific)v0));
            continue;
        label_49:
            this.setCertificateHolderReference(((DERApplicationSpecific)v0));
            continue;
        label_51:
            this.setCertificateHolderAuthorization(new CertificateHolderAuthorization(((DERApplicationSpecific)v0)));
            continue;
        label_57:
            this.setCertificateExpirationDate(((DERApplicationSpecific)v0));
            continue;
        label_42:
            this.setCertificationAuthorityReference(((DERApplicationSpecific)v0));
            continue;
        label_44:
            this.setPublicKey(PublicKeyDataObject.getInstance(((DERApplicationSpecific)v0).getObject(16)));
        }

        throw new IOException("Not a valid iso7816 content : not a DERApplicationSpecific Object :" + EACTags.encodeTag(arg5) + v0.getClass());
        return;
    label_24:
        throw new IOException("Bad tag : not an iso7816 CERTIFICATE_CONTENT_TEMPLATE");
    }

    private void setPublicKey(PublicKeyDataObject arg2) {
        this.publicKey = PublicKeyDataObject.getInstance(arg2);
        this.certificateType |= 4;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1Primitive v0 = null;
        try {
            if(this.certificateType == 127) {
                return this.profileToASN1Object();
            }

            if(this.certificateType != 13) {
                return v0;
            }

            v0 = this.requestToASN1Object();
        }
        catch(IOException v1) {
        }

        return v0;
    }
}

