// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.util.Hashtable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERApplicationSpecific;
import org.bouncycastle.util.Integers;

public class CertificateHolderAuthorization extends ASN1Object {
    static BidirectionalMap AuthorizationRole = null;
    public static final int CVCA = 192;
    public static final int DV_DOMESTIC = 128;
    public static final int DV_FOREIGN = 64;
    public static final int IS = 0;
    public static final int RADG3 = 1;
    public static final int RADG4 = 2;
    static Hashtable ReverseMap;
    static Hashtable RightsDecodeMap;
    DERApplicationSpecific accessRights;
    public static final ASN1ObjectIdentifier id_role_EAC;
    ASN1ObjectIdentifier oid;

    static {
        CertificateHolderAuthorization.id_role_EAC = EACObjectIdentifiers.bsi_de.branch("3.1.2.1");
        CertificateHolderAuthorization.RightsDecodeMap = new Hashtable();
        CertificateHolderAuthorization.AuthorizationRole = new BidirectionalMap();
        CertificateHolderAuthorization.ReverseMap = new Hashtable();
        CertificateHolderAuthorization.RightsDecodeMap.put(Integers.valueOf(2), "RADG4");
        CertificateHolderAuthorization.RightsDecodeMap.put(Integers.valueOf(1), "RADG3");
        CertificateHolderAuthorization.AuthorizationRole.put(Integers.valueOf(192), "CVCA");
        CertificateHolderAuthorization.AuthorizationRole.put(Integers.valueOf(128), "DV_DOMESTIC");
        CertificateHolderAuthorization.AuthorizationRole.put(Integers.valueOf(64), "DV_FOREIGN");
        CertificateHolderAuthorization.AuthorizationRole.put(Integers.valueOf(0), "IS");
    }

    public CertificateHolderAuthorization(DERApplicationSpecific arg3) {
        super();
        if(arg3.getApplicationTag() == 76) {
            this.setPrivateData(new ASN1InputStream(arg3.getContents()));
        }
    }

    public CertificateHolderAuthorization(ASN1ObjectIdentifier arg2, int arg3) {
        super();
        this.setOid(arg2);
        this.setAccessRights(((byte)arg3));
    }

    public static int GetFlag(String arg3) {
        Object v0 = CertificateHolderAuthorization.AuthorizationRole.getReverse(arg3);
        if(v0 == null) {
            throw new IllegalArgumentException("Unknown value " + arg3);
        }

        return ((Integer)v0).intValue();
    }

    public static String GetRoleDescription(int arg2) {
        return CertificateHolderAuthorization.AuthorizationRole.get(Integers.valueOf(arg2));
    }

    public int getAccessRights() {
        return this.accessRights.getContents()[0] & 255;
    }

    public ASN1ObjectIdentifier getOid() {
        return this.oid;
    }

    private void setAccessRights(byte arg4) {
        this.accessRights = new DERApplicationSpecific(EACTags.getTag(83), new byte[]{arg4});
    }

    private void setOid(ASN1ObjectIdentifier arg1) {
        this.oid = arg1;
    }

    private void setPrivateData(ASN1InputStream arg3) {
        ASN1Primitive v0 = arg3.readObject();
        if((v0 instanceof ASN1ObjectIdentifier)) {
            this.oid = ((ASN1ObjectIdentifier)v0);
            v0 = arg3.readObject();
            if((v0 instanceof DERApplicationSpecific)) {
                this.accessRights = ((DERApplicationSpecific)v0);
                return;
            }

            throw new IllegalArgumentException("No access rights in CerticateHolderAuthorization");
        }

        throw new IllegalArgumentException("no Oid in CerticateHolderAuthorization");
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.oid);
        v0.add(this.accessRights);
        return new DERApplicationSpecific(76, v0);
    }
}

