// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class ECDSAPublicKey extends PublicKeyDataObject {
    private static final int A = 2;
    private static final int B = 4;
    private static final int F = 64;
    private static final int G = 8;
    private static final int P = 1;
    private static final int R = 16;
    private static final int Y = 32;
    private byte[] basePointG;
    private BigInteger cofactorF;
    private BigInteger firstCoefA;
    private int options;
    private BigInteger orderOfBasePointR;
    private BigInteger primeModulusP;
    private byte[] publicPointY;
    private BigInteger secondCoefB;
    private ASN1ObjectIdentifier usage;

    ECDSAPublicKey(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        this.usage = ASN1ObjectIdentifier.getInstance(v1.nextElement());
        this.options = 0;
        while(true) {
            if(!v1.hasMoreElements()) {
                goto label_49;
            }

            Object v0 = v1.nextElement();
            if(!(v0 instanceof ASN1TaggedObject)) {
                break;
            }

            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 1: {
                    goto label_19;
                }
                case 2: {
                    goto label_23;
                }
                case 3: {
                    goto label_27;
                }
                case 4: {
                    goto label_31;
                }
                case 5: {
                    goto label_34;
                }
                case 6: {
                    goto label_38;
                }
                case 7: {
                    goto label_41;
                }
            }

            this.options = 0;
            throw new IllegalArgumentException("Unknown Object Identifier!");
        label_38:
            this.setPublicPointY(ASN1OctetString.getInstance(((ASN1TaggedObject)v0), false));
            continue;
        label_19:
            this.setPrimeModulusP(UnsignedInteger.getInstance(v0).getValue());
            continue;
        label_34:
            this.setOrderOfBasePointR(UnsignedInteger.getInstance(v0).getValue());
            continue;
        label_23:
            this.setFirstCoefA(UnsignedInteger.getInstance(v0).getValue());
            continue;
        label_27:
            this.setSecondCoefB(UnsignedInteger.getInstance(v0).getValue());
            continue;
        label_41:
            this.setCofactorF(UnsignedInteger.getInstance(v0).getValue());
            continue;
        label_31:
            this.setBasePointG(ASN1OctetString.getInstance(((ASN1TaggedObject)v0), false));
        }

        throw new IllegalArgumentException("Unknown Object Identifier!");
    label_49:
        if(this.options != 32 && this.options != 127) {
            throw new IllegalArgumentException("All options must be either present or absent!");
        }
    }

    public ECDSAPublicKey(ASN1ObjectIdentifier arg3, BigInteger arg4, BigInteger arg5, BigInteger arg6, byte[] arg7, BigInteger arg8, byte[] arg9, int arg10) {
        super();
        this.usage = arg3;
        this.setPrimeModulusP(arg4);
        this.setFirstCoefA(arg5);
        this.setSecondCoefB(arg6);
        this.setBasePointG(new DEROctetString(arg7));
        this.setOrderOfBasePointR(arg8);
        this.setPublicPointY(new DEROctetString(arg9));
        this.setCofactorF(BigInteger.valueOf(((long)arg10)));
    }

    public ECDSAPublicKey(ASN1ObjectIdentifier arg2, byte[] arg3) {
        super();
        this.usage = arg2;
        this.setPublicPointY(new DEROctetString(arg3));
    }

    public ASN1EncodableVector getASN1EncodableVector(ASN1ObjectIdentifier arg7, boolean arg8) {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(((ASN1Encodable)arg7));
        if(!arg8) {
            v0.add(new UnsignedInteger(1, this.getPrimeModulusP()));
            v0.add(new UnsignedInteger(2, this.getFirstCoefA()));
            v0.add(new UnsignedInteger(3, this.getSecondCoefB()));
            v0.add(new DERTaggedObject(false, 4, new DEROctetString(this.getBasePointG())));
            v0.add(new UnsignedInteger(5, this.getOrderOfBasePointR()));
        }

        v0.add(new DERTaggedObject(false, 6, new DEROctetString(this.getPublicPointY())));
        if(!arg8) {
            v0.add(new UnsignedInteger(7, this.getCofactorF()));
        }

        return v0;
    }

    public byte[] getBasePointG() {
        byte[] v0 = (this.options & 8) != 0 ? this.basePointG : null;
        return v0;
    }

    public BigInteger getCofactorF() {
        BigInteger v0 = (this.options & 64) != 0 ? this.cofactorF : null;
        return v0;
    }

    public BigInteger getFirstCoefA() {
        BigInteger v0 = (this.options & 2) != 0 ? this.firstCoefA : null;
        return v0;
    }

    public BigInteger getOrderOfBasePointR() {
        BigInteger v0 = (this.options & 16) != 0 ? this.orderOfBasePointR : null;
        return v0;
    }

    public BigInteger getPrimeModulusP() {
        BigInteger v0 = (this.options & 1) != 0 ? this.primeModulusP : null;
        return v0;
    }

    public byte[] getPublicPointY() {
        byte[] v0 = (this.options & 32) != 0 ? this.publicPointY : null;
        return v0;
    }

    public BigInteger getSecondCoefB() {
        BigInteger v0 = (this.options & 4) != 0 ? this.secondCoefB : null;
        return v0;
    }

    public ASN1ObjectIdentifier getUsage() {
        return this.usage;
    }

    public boolean hasParameters() {
        boolean v0 = this.primeModulusP != null ? true : false;
        return v0;
    }

    private void setBasePointG(ASN1OctetString arg3) {
        if((this.options & 8) == 0) {
            this.options |= 8;
            this.basePointG = arg3.getOctets();
            return;
        }

        throw new IllegalArgumentException("Base Point G already set");
    }

    private void setCofactorF(BigInteger arg3) {
        if((this.options & 64) == 0) {
            this.options |= 64;
            this.cofactorF = arg3;
            return;
        }

        throw new IllegalArgumentException("Cofactor F already set");
    }

    private void setFirstCoefA(BigInteger arg3) {
        if((this.options & 2) == 0) {
            this.options |= 2;
            this.firstCoefA = arg3;
            return;
        }

        throw new IllegalArgumentException("First Coef A already set");
    }

    private void setOrderOfBasePointR(BigInteger arg3) {
        if((this.options & 16) == 0) {
            this.options |= 16;
            this.orderOfBasePointR = arg3;
            return;
        }

        throw new IllegalArgumentException("Order of base point R already set");
    }

    private void setPrimeModulusP(BigInteger arg3) {
        if((this.options & 1) == 0) {
            this.options |= 1;
            this.primeModulusP = arg3;
            return;
        }

        throw new IllegalArgumentException("Prime Modulus P already set");
    }

    private void setPublicPointY(ASN1OctetString arg3) {
        if((this.options & 32) == 0) {
            this.options |= 32;
            this.publicPointY = arg3.getOctets();
            return;
        }

        throw new IllegalArgumentException("Public Point Y already set");
    }

    private void setSecondCoefB(BigInteger arg3) {
        if((this.options & 4) == 0) {
            this.options |= 4;
            this.secondCoefB = arg3;
            return;
        }

        throw new IllegalArgumentException("Second Coef B already set");
    }

    public ASN1Primitive toASN1Primitive() {
        return new DERSequence(this.getASN1EncodableVector(this.usage, false));
    }
}

