// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class RSAPublicKey extends PublicKeyDataObject {
    private BigInteger exponent;
    private static int exponentValid;
    private BigInteger modulus;
    private static int modulusValid;
    private ASN1ObjectIdentifier usage;
    private int valid;

    static {
        RSAPublicKey.modulusValid = 1;
        RSAPublicKey.exponentValid = 2;
    }

    RSAPublicKey(ASN1Sequence arg5) {
        super();
        this.valid = 0;
        Enumeration v0 = arg5.getObjects();
        this.usage = ASN1ObjectIdentifier.getInstance(v0.nextElement());
        while(v0.hasMoreElements()) {
            UnsignedInteger v1 = UnsignedInteger.getInstance(v0.nextElement());
            switch(v1.getTagNo()) {
                case 1: {
                    goto label_25;
                }
                case 2: {
                    goto label_27;
                }
            }

            throw new IllegalArgumentException("Unknown DERTaggedObject :" + v1.getTagNo() + "-> not an Iso7816RSAPublicKeyStructure");
        label_27:
            this.setExponent(v1);
            continue;
        label_25:
            this.setModulus(v1);
        }

        if(this.valid != 3) {
            throw new IllegalArgumentException("missing argument -> not an Iso7816RSAPublicKeyStructure");
        }
    }

    public RSAPublicKey(ASN1ObjectIdentifier arg2, BigInteger arg3, BigInteger arg4) {
        super();
        this.valid = 0;
        this.usage = arg2;
        this.modulus = arg3;
        this.exponent = arg4;
    }

    public BigInteger getModulus() {
        return this.modulus;
    }

    public BigInteger getPublicExponent() {
        return this.exponent;
    }

    public ASN1ObjectIdentifier getUsage() {
        return this.usage;
    }

    private void setExponent(UnsignedInteger arg3) {
        if((this.valid & RSAPublicKey.exponentValid) == 0) {
            this.valid |= RSAPublicKey.exponentValid;
            this.exponent = arg3.getValue();
            return;
        }

        throw new IllegalArgumentException("Exponent already set");
    }

    private void setModulus(UnsignedInteger arg3) {
        if((this.valid & RSAPublicKey.modulusValid) == 0) {
            this.valid |= RSAPublicKey.modulusValid;
            this.modulus = arg3.getValue();
            return;
        }

        throw new IllegalArgumentException("Modulus already set");
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.usage);
        v0.add(new UnsignedInteger(1, this.getModulus()));
        v0.add(new UnsignedInteger(2, this.getPublicExponent()));
        return new DERSequence(v0);
    }
}

