// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.eac;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERTaggedObject;

public class UnsignedInteger extends ASN1Object {
    private int tagNo;
    private BigInteger value;

    public UnsignedInteger(int arg1, BigInteger arg2) {
        super();
        this.tagNo = arg1;
        this.value = arg2;
    }

    private UnsignedInteger(ASN1TaggedObject arg4) {
        super();
        this.tagNo = arg4.getTagNo();
        this.value = new BigInteger(1, ASN1OctetString.getInstance(arg4, false).getOctets());
    }

    private byte[] convertValue() {
        byte[] v0;
        byte[] v1 = this.value.toByteArray();
        if(v1[0] == 0) {
            v0 = new byte[v1.length - 1];
            System.arraycopy(v1, 1, v0, 0, v0.length);
        }
        else {
            v0 = v1;
        }

        return v0;
    }

    public static UnsignedInteger getInstance(Object arg2) {
        if(!(arg2 instanceof UnsignedInteger)) {
            if(arg2 != null) {
                UnsignedInteger v2 = new UnsignedInteger(ASN1TaggedObject.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public int getTagNo() {
        return this.tagNo;
    }

    public BigInteger getValue() {
        return this.value;
    }

    public ASN1Primitive toASN1Primitive() {
        return new DERTaggedObject(false, this.tagNo, new DEROctetString(this.convertValue()));
    }
}

