// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.esf;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1UTCTime;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.X500Name;

public class CrlIdentifier extends ASN1Object {
    private ASN1UTCTime crlIssuedTime;
    private X500Name crlIssuer;
    private ASN1Integer crlNumber;

    private CrlIdentifier(ASN1Sequence arg4) {
        int v2 = 2;
        super();
        if(arg4.size() >= v2 && arg4.size() <= 3) {
            this.crlIssuer = X500Name.getInstance(arg4.getObjectAt(0));
            this.crlIssuedTime = ASN1UTCTime.getInstance(arg4.getObjectAt(1));
            if(arg4.size() > v2) {
                this.crlNumber = ASN1Integer.getInstance(arg4.getObjectAt(v2));
            }

            return;
        }

        throw new IllegalArgumentException();
    }

    public CrlIdentifier(X500Name arg2, ASN1UTCTime arg3) {
        this(arg2, arg3, null);
    }

    public CrlIdentifier(X500Name arg2, ASN1UTCTime arg3, BigInteger arg4) {
        super();
        this.crlIssuer = arg2;
        this.crlIssuedTime = arg3;
        if(arg4 != null) {
            this.crlNumber = new ASN1Integer(arg4);
        }
    }

    public ASN1UTCTime getCrlIssuedTime() {
        return this.crlIssuedTime;
    }

    public X500Name getCrlIssuer() {
        return this.crlIssuer;
    }

    public BigInteger getCrlNumber() {
        BigInteger v0 = this.crlNumber == null ? null : this.crlNumber.getValue();
        return v0;
    }

    public static CrlIdentifier getInstance(Object arg2) {
        if(!(arg2 instanceof CrlIdentifier)) {
            if(arg2 != null) {
                CrlIdentifier v2 = new CrlIdentifier(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.crlIssuer.toASN1Primitive());
        v0.add(this.crlIssuedTime);
        if(this.crlNumber != null) {
            v0.add(this.crlNumber);
        }

        return new DERSequence(v0);
    }
}

