// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.esf;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.ocsp.ResponderID;

public class OcspIdentifier extends ASN1Object {
    private ResponderID ocspResponderID;
    private ASN1GeneralizedTime producedAt;

    private OcspIdentifier(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.ocspResponderID = ResponderID.getInstance(arg4.getObjectAt(0));
        this.producedAt = arg4.getObjectAt(1);
    }

    public OcspIdentifier(ResponderID arg1, ASN1GeneralizedTime arg2) {
        super();
        this.ocspResponderID = arg1;
        this.producedAt = arg2;
    }

    public static OcspIdentifier getInstance(Object arg2) {
        if(!(arg2 instanceof OcspIdentifier)) {
            if(arg2 != null) {
                OcspIdentifier v2 = new OcspIdentifier(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ResponderID getOcspResponderID() {
        return this.ocspResponderID;
    }

    public ASN1GeneralizedTime getProducedAt() {
        return this.producedAt;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.ocspResponderID);
        v0.add(this.producedAt);
        return new DERSequence(v0);
    }
}

