// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.esf;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.ocsp.BasicOCSPResponse;
import org.bouncycastle.asn1.x509.CertificateList;

public class RevocationValues extends ASN1Object {
    private ASN1Sequence crlVals;
    private ASN1Sequence ocspVals;
    private OtherRevVals otherRevVals;

    private RevocationValues(ASN1Sequence arg5) {
        Enumeration v2;
        ASN1Primitive v0_1;
        Object v0;
        super();
        if(arg5.size() > 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
        }

        Enumeration v1 = arg5.getObjects();
        while(true) {
        label_15:
            if(!v1.hasMoreElements()) {
                return;
            }

            v0 = v1.nextElement();
            switch(((DERTaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_30;
                }
                case 1: {
                    goto label_39;
                }
                case 2: {
                    goto label_48;
                }
            }

            throw new IllegalArgumentException("invalid tag: " + ((DERTaggedObject)v0).getTagNo());
        label_39:
            v0_1 = ((DERTaggedObject)v0).getObject();
            v2 = ((ASN1Sequence)v0_1).getObjects();
            goto label_41;
        label_48:
            this.otherRevVals = OtherRevVals.getInstance(((DERTaggedObject)v0).getObject());
        }

    label_30:
        v0_1 = ((DERTaggedObject)v0).getObject();
        v2 = ((ASN1Sequence)v0_1).getObjects();
        goto label_32;
        return;
    label_41:
        while(v2.hasMoreElements()) {
            BasicOCSPResponse.getInstance(v2.nextElement());
        }

        this.ocspVals = ((ASN1Sequence)v0_1);
        goto label_15;
    label_32:
        while(v2.hasMoreElements()) {
            CertificateList.getInstance(v2.nextElement());
        }

        this.crlVals = ((ASN1Sequence)v0_1);
        goto label_15;
    }

    public RevocationValues(CertificateList[] arg2, BasicOCSPResponse[] arg3, OtherRevVals arg4) {
        super();
        if(arg2 != null) {
            this.crlVals = new DERSequence(((ASN1Encodable[])arg2));
        }

        if(arg3 != null) {
            this.ocspVals = new DERSequence(((ASN1Encodable[])arg3));
        }

        this.otherRevVals = arg4;
    }

    public CertificateList[] getCrlVals() {
        CertificateList[] v0_1;
        int v0 = 0;
        if(this.crlVals == null) {
            v0_1 = new CertificateList[0];
        }
        else {
            CertificateList[] v1 = new CertificateList[this.crlVals.size()];
            while(v0 < v1.length) {
                v1[v0] = CertificateList.getInstance(this.crlVals.getObjectAt(v0));
                ++v0;
            }

            v0_1 = v1;
        }

        return v0_1;
    }

    public static RevocationValues getInstance(Object arg2) {
        RevocationValues v2;
        if(!(arg2 instanceof RevocationValues)) {
            if(arg2 != null) {
                v2 = new RevocationValues(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public BasicOCSPResponse[] getOcspVals() {
        BasicOCSPResponse[] v0_1;
        int v0 = 0;
        if(this.ocspVals == null) {
            v0_1 = new BasicOCSPResponse[0];
        }
        else {
            BasicOCSPResponse[] v1 = new BasicOCSPResponse[this.ocspVals.size()];
            while(v0 < v1.length) {
                v1[v0] = BasicOCSPResponse.getInstance(this.ocspVals.getObjectAt(v0));
                ++v0;
            }

            v0_1 = v1;
        }

        return v0_1;
    }

    public OtherRevVals getOtherRevVals() {
        return this.otherRevVals;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.crlVals != null) {
            v0.add(new DERTaggedObject(true, 0, this.crlVals));
        }

        if(this.ocspVals != null) {
            v0.add(new DERTaggedObject(true, 1, this.ocspVals));
        }

        if(this.otherRevVals != null) {
            v0.add(new DERTaggedObject(true, 2, this.otherRevVals.toASN1Primitive()));
        }

        return new DERSequence(v0);
    }
}

