// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.esf;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class SignaturePolicyId extends ASN1Object {
    private OtherHashAlgAndValue sigPolicyHash;
    private ASN1ObjectIdentifier sigPolicyId;
    private SigPolicyQualifiers sigPolicyQualifiers;

    public SignaturePolicyId(ASN1ObjectIdentifier arg2, OtherHashAlgAndValue arg3) {
        this(arg2, arg3, null);
    }

    public SignaturePolicyId(ASN1ObjectIdentifier arg1, OtherHashAlgAndValue arg2, SigPolicyQualifiers arg3) {
        super();
        this.sigPolicyId = arg1;
        this.sigPolicyHash = arg2;
        this.sigPolicyQualifiers = arg3;
    }

    private SignaturePolicyId(ASN1Sequence arg4) {
        int v2 = 3;
        int v1 = 2;
        super();
        if(arg4.size() != v1 && arg4.size() != v2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.sigPolicyId = ASN1ObjectIdentifier.getInstance(arg4.getObjectAt(0));
        this.sigPolicyHash = OtherHashAlgAndValue.getInstance(arg4.getObjectAt(1));
        if(arg4.size() == v2) {
            this.sigPolicyQualifiers = SigPolicyQualifiers.getInstance(arg4.getObjectAt(v1));
        }
    }

    public static SignaturePolicyId getInstance(Object arg2) {
        SignaturePolicyId v2;
        if(!(arg2 instanceof SignaturePolicyId)) {
            if(arg2 != null) {
                v2 = new SignaturePolicyId(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public OtherHashAlgAndValue getSigPolicyHash() {
        return this.sigPolicyHash;
    }

    public ASN1ObjectIdentifier getSigPolicyId() {
        return new ASN1ObjectIdentifier(this.sigPolicyId.getId());
    }

    public SigPolicyQualifiers getSigPolicyQualifiers() {
        return this.sigPolicyQualifiers;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.sigPolicyId);
        v0.add(this.sigPolicyHash);
        if(this.sigPolicyQualifiers != null) {
            v0.add(this.sigPolicyQualifiers);
        }

        return new DERSequence(v0);
    }
}

