// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.esf;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.DERUTF8String;
import org.bouncycastle.asn1.x500.DirectoryString;

public class SignerLocation extends ASN1Object {
    private DERUTF8String countryName;
    private DERUTF8String localityName;
    private ASN1Sequence postalAddress;

    private SignerLocation(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            switch(((DERTaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_12;
                }
                case 1: {
                    goto label_18;
                }
                case 2: {
                    goto label_24;
                }
            }

            throw new IllegalArgumentException("illegal tag");
        label_18:
            this.localityName = new DERUTF8String(DirectoryString.getInstance(((ASN1TaggedObject)v0), true).getString());
            continue;
        label_24:
            this.postalAddress = ((DERTaggedObject)v0).isExplicit() ? ASN1Sequence.getInstance(((ASN1TaggedObject)v0), true) : ASN1Sequence.getInstance(((ASN1TaggedObject)v0), false);
            if(this.postalAddress == null) {
                continue;
            }

            if(this.postalAddress.size() <= 6) {
                continue;
            }

            throw new IllegalArgumentException("postal address must contain less than 6 strings");
        label_12:
            this.countryName = new DERUTF8String(DirectoryString.getInstance(((ASN1TaggedObject)v0), true).getString());
        }
    }

    public SignerLocation(DERUTF8String arg3, DERUTF8String arg4, ASN1Sequence arg5) {
        super();
        if(arg5 != null && arg5.size() > 6) {
            throw new IllegalArgumentException("postal address must contain less than 6 strings");
        }

        if(arg3 != null) {
            this.countryName = DERUTF8String.getInstance(arg3.toASN1Primitive());
        }

        if(arg4 != null) {
            this.localityName = DERUTF8String.getInstance(arg4.toASN1Primitive());
        }

        if(arg5 != null) {
            this.postalAddress = ASN1Sequence.getInstance(arg5.toASN1Primitive());
        }
    }

    public DERUTF8String getCountryName() {
        return this.countryName;
    }

    public static SignerLocation getInstance(Object arg2) {
        SignerLocation v2;
        if(arg2 != null && !(arg2 instanceof SignerLocation)) {
            v2 = new SignerLocation(ASN1Sequence.getInstance(arg2));
        }

        return v2;
    }

    public DERUTF8String getLocalityName() {
        return this.localityName;
    }

    public ASN1Sequence getPostalAddress() {
        return this.postalAddress;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.countryName != null) {
            v0.add(new DERTaggedObject(true, 0, this.countryName));
        }

        if(this.localityName != null) {
            v0.add(new DERTaggedObject(true, 1, this.localityName));
        }

        if(this.postalAddress != null) {
            v0.add(new DERTaggedObject(true, 2, this.postalAddress));
        }

        return new DERSequence(v0);
    }
}

