// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ess;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERUTF8String;

public class ContentHints extends ASN1Object {
    private DERUTF8String contentDescription;
    private ASN1ObjectIdentifier contentType;

    public ContentHints(ASN1ObjectIdentifier arg2) {
        super();
        this.contentType = arg2;
        this.contentDescription = null;
    }

    public ContentHints(ASN1ObjectIdentifier arg1, DERUTF8String arg2) {
        super();
        this.contentType = arg1;
        this.contentDescription = arg2;
    }

    private ContentHints(ASN1Sequence arg4) {
        super();
        ASN1Encodable v0 = arg4.getObjectAt(0);
        if((v0.toASN1Primitive() instanceof DERUTF8String)) {
            this.contentDescription = DERUTF8String.getInstance(v0);
            this.contentType = ASN1ObjectIdentifier.getInstance(arg4.getObjectAt(1));
        }
        else {
            this.contentType = ASN1ObjectIdentifier.getInstance(arg4.getObjectAt(0));
        }
    }

    public ContentHints(DERObjectIdentifier arg3) {
        this(new ASN1ObjectIdentifier(arg3.getId()));
    }

    public ContentHints(DERObjectIdentifier arg3, DERUTF8String arg4) {
        this(new ASN1ObjectIdentifier(arg3.getId()), arg4);
    }

    public DERUTF8String getContentDescription() {
        return this.contentDescription;
    }

    public ASN1ObjectIdentifier getContentType() {
        return this.contentType;
    }

    public static ContentHints getInstance(Object arg2) {
        if(!(arg2 instanceof ContentHints)) {
            if(arg2 != null) {
                ContentHints v2 = new ContentHints(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.contentDescription != null) {
            v0.add(this.contentDescription);
        }

        v0.add(this.contentType);
        return new DERSequence(v0);
    }
}

