// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ess;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.IssuerSerial;

public class ESSCertID extends ASN1Object {
    private ASN1OctetString certHash;
    private IssuerSerial issuerSerial;

    private ESSCertID(ASN1Sequence arg4) {
        super();
        if(arg4.size() >= 1 && arg4.size() <= 2) {
            this.certHash = ASN1OctetString.getInstance(arg4.getObjectAt(0));
            if(arg4.size() > 1) {
                this.issuerSerial = IssuerSerial.getInstance(arg4.getObjectAt(1));
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public ESSCertID(byte[] arg2) {
        super();
        this.certHash = new DEROctetString(arg2);
    }

    public ESSCertID(byte[] arg2, IssuerSerial arg3) {
        super();
        this.certHash = new DEROctetString(arg2);
        this.issuerSerial = arg3;
    }

    public byte[] getCertHash() {
        return this.certHash.getOctets();
    }

    public static ESSCertID getInstance(Object arg2) {
        ESSCertID v2;
        if(!(arg2 instanceof ESSCertID)) {
            if(arg2 != null) {
                v2 = new ESSCertID(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public IssuerSerial getIssuerSerial() {
        return this.issuerSerial;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certHash);
        if(this.issuerSerial != null) {
            v0.add(this.issuerSerial);
        }

        return new DERSequence(v0);
    }
}

