// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ess;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.nist.NISTObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.IssuerSerial;

public class ESSCertIDv2 extends ASN1Object {
    private static final AlgorithmIdentifier DEFAULT_ALG_ID;
    private byte[] certHash;
    private AlgorithmIdentifier hashAlgorithm;
    private IssuerSerial issuerSerial;

    static {
        ESSCertIDv2.DEFAULT_ALG_ID = new AlgorithmIdentifier(NISTObjectIdentifiers.id_sha256);
    }

    private ESSCertIDv2(ASN1Sequence arg4) {
        int v0 = 0;
        super();
        if(arg4.size() > 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        if((arg4.getObjectAt(0) instanceof ASN1OctetString)) {
            this.hashAlgorithm = ESSCertIDv2.DEFAULT_ALG_ID;
        }
        else {
            this.hashAlgorithm = AlgorithmIdentifier.getInstance(arg4.getObjectAt(0).toASN1Primitive());
            v0 = 1;
        }

        int v1 = v0 + 1;
        this.certHash = ASN1OctetString.getInstance(arg4.getObjectAt(v0).toASN1Primitive()).getOctets();
        if(arg4.size() > v1) {
            this.issuerSerial = IssuerSerial.getInstance(arg4.getObjectAt(v1));
        }
    }

    public ESSCertIDv2(AlgorithmIdentifier arg2, byte[] arg3) {
        this(arg2, arg3, null);
    }

    public ESSCertIDv2(AlgorithmIdentifier arg2, byte[] arg3, IssuerSerial arg4) {
        super();
        this.hashAlgorithm = arg2 == null ? ESSCertIDv2.DEFAULT_ALG_ID : arg2;
        this.certHash = arg3;
        this.issuerSerial = arg4;
    }

    public ESSCertIDv2(byte[] arg2) {
        this(null, arg2, null);
    }

    public ESSCertIDv2(byte[] arg2, IssuerSerial arg3) {
        this(null, arg2, arg3);
    }

    public byte[] getCertHash() {
        return this.certHash;
    }

    public AlgorithmIdentifier getHashAlgorithm() {
        return this.hashAlgorithm;
    }

    public static ESSCertIDv2 getInstance(Object arg2) {
        ESSCertIDv2 v2;
        if(!(arg2 instanceof ESSCertIDv2)) {
            if(arg2 != null) {
                v2 = new ESSCertIDv2(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public IssuerSerial getIssuerSerial() {
        return this.issuerSerial;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(!this.hashAlgorithm.equals(ESSCertIDv2.DEFAULT_ALG_ID)) {
            v0.add(this.hashAlgorithm);
        }

        v0.add(new DEROctetString(this.certHash).toASN1Primitive());
        if(this.issuerSerial != null) {
            v0.add(this.issuerSerial);
        }

        return new DERSequence(v0);
    }
}

