// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ess;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DigestInfo;
import org.bouncycastle.asn1.x509.IssuerSerial;

public class OtherCertID extends ASN1Object {
    private IssuerSerial issuerSerial;
    private ASN1Encodable otherCertHash;

    private OtherCertID(ASN1Sequence arg5) {
        super();
        if(arg5.size() >= 1 && arg5.size() <= 2) {
            this.otherCertHash = (arg5.getObjectAt(0).toASN1Primitive() instanceof ASN1OctetString) ? ASN1OctetString.getInstance(arg5.getObjectAt(0)) : DigestInfo.getInstance(arg5.getObjectAt(0));
            if(arg5.size() > 1) {
                this.issuerSerial = IssuerSerial.getInstance(arg5.getObjectAt(1));
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
    }

    public OtherCertID(AlgorithmIdentifier arg2, byte[] arg3) {
        super();
        this.otherCertHash = new DigestInfo(arg2, arg3);
    }

    public OtherCertID(AlgorithmIdentifier arg2, byte[] arg3, IssuerSerial arg4) {
        super();
        this.otherCertHash = new DigestInfo(arg2, arg3);
        this.issuerSerial = arg4;
    }

    public AlgorithmIdentifier getAlgorithmHash() {
        AlgorithmIdentifier v0 = (this.otherCertHash.toASN1Primitive() instanceof ASN1OctetString) ? new AlgorithmIdentifier("1.3.14.3.2.26") : DigestInfo.getInstance(this.otherCertHash).getAlgorithmId();
        return v0;
    }

    public byte[] getCertHash() {
        byte[] v0 = (this.otherCertHash.toASN1Primitive() instanceof ASN1OctetString) ? this.otherCertHash.toASN1Primitive().getOctets() : DigestInfo.getInstance(this.otherCertHash).getDigest();
        return v0;
    }

    public static OtherCertID getInstance(Object arg2) {
        if(!(arg2 instanceof OtherCertID)) {
            if(arg2 != null) {
                OtherCertID v2 = new OtherCertID(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public IssuerSerial getIssuerSerial() {
        return this.issuerSerial;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.otherCertHash);
        if(this.issuerSerial != null) {
            v0.add(this.issuerSerial);
        }

        return new DERSequence(v0);
    }
}

