// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ess;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.PolicyInformation;

public class SigningCertificate extends ASN1Object {
    ASN1Sequence certs;
    ASN1Sequence policies;

    private SigningCertificate(ASN1Sequence arg4) {
        super();
        if(arg4.size() >= 1 && arg4.size() <= 2) {
            this.certs = ASN1Sequence.getInstance(arg4.getObjectAt(0));
            if(arg4.size() > 1) {
                this.policies = ASN1Sequence.getInstance(arg4.getObjectAt(1));
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public SigningCertificate(ESSCertID arg2) {
        super();
        this.certs = new DERSequence(((ASN1Encodable)arg2));
    }

    public ESSCertID[] getCerts() {
        ESSCertID[] v1 = new ESSCertID[this.certs.size()];
        int v0;
        for(v0 = 0; v0 != this.certs.size(); ++v0) {
            v1[v0] = ESSCertID.getInstance(this.certs.getObjectAt(v0));
        }

        return v1;
    }

    public static SigningCertificate getInstance(Object arg2) {
        SigningCertificate v2;
        if(!(arg2 instanceof SigningCertificate)) {
            if(arg2 != null) {
                v2 = new SigningCertificate(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public PolicyInformation[] getPolicies() {
        PolicyInformation[] v0;
        if(this.policies == null) {
            v0 = null;
        }
        else {
            PolicyInformation[] v1 = new PolicyInformation[this.policies.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != this.policies.size(); ++v0_1) {
                v1[v0_1] = PolicyInformation.getInstance(this.policies.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certs);
        if(this.policies != null) {
            v0.add(this.policies);
        }

        return new DERSequence(v0);
    }
}

