// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ess;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.PolicyInformation;

public class SigningCertificateV2 extends ASN1Object {
    ASN1Sequence certs;
    ASN1Sequence policies;

    private SigningCertificateV2(ASN1Sequence arg4) {
        super();
        if(arg4.size() >= 1 && arg4.size() <= 2) {
            this.certs = ASN1Sequence.getInstance(arg4.getObjectAt(0));
            if(arg4.size() > 1) {
                this.policies = ASN1Sequence.getInstance(arg4.getObjectAt(1));
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public SigningCertificateV2(ESSCertIDv2 arg2) {
        super();
        this.certs = new DERSequence(((ASN1Encodable)arg2));
    }

    public SigningCertificateV2(ESSCertIDv2[] arg4) {
        super();
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < arg4.length; ++v0) {
            v1.add(arg4[v0]);
        }

        this.certs = new DERSequence(v1);
    }

    public SigningCertificateV2(ESSCertIDv2[] arg5, PolicyInformation[] arg6) {
        int v1 = 0;
        super();
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < arg5.length; ++v0) {
            v2.add(arg5[v0]);
        }

        this.certs = new DERSequence(v2);
        if(arg6 != null) {
            ASN1EncodableVector v0_1 = new ASN1EncodableVector();
            while(v1 < arg6.length) {
                v0_1.add(arg6[v1]);
                ++v1;
            }

            this.policies = new DERSequence(v0_1);
        }
    }

    public ESSCertIDv2[] getCerts() {
        ESSCertIDv2[] v1 = new ESSCertIDv2[this.certs.size()];
        int v0;
        for(v0 = 0; v0 != this.certs.size(); ++v0) {
            v1[v0] = ESSCertIDv2.getInstance(this.certs.getObjectAt(v0));
        }

        return v1;
    }

    public static SigningCertificateV2 getInstance(Object arg1) {
        if(arg1 != null && !(arg1 instanceof SigningCertificateV2)) {
            if((arg1 instanceof ASN1Sequence)) {
                SigningCertificateV2 v1 = new SigningCertificateV2(((ASN1Sequence)arg1));
            }
            else {
                arg1 = null;
            }
        }

        return arg1;
    }

    public PolicyInformation[] getPolicies() {
        PolicyInformation[] v0;
        if(this.policies == null) {
            v0 = null;
        }
        else {
            PolicyInformation[] v1 = new PolicyInformation[this.policies.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 != this.policies.size(); ++v0_1) {
                v1[v0_1] = PolicyInformation.getInstance(this.policies.getObjectAt(v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certs);
        if(this.policies != null) {
            v0.add(this.policies);
        }

        return new DERSequence(v0);
    }
}

