// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.icao;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERSet;
import org.bouncycastle.asn1.x509.Certificate;

public class CscaMasterList extends ASN1Object {
    private Certificate[] certList;
    private ASN1Integer version;

    private CscaMasterList(ASN1Sequence arg5) {
        int v0 = 0;
        super();
        this.version = new ASN1Integer(0);
        if(arg5 != null && arg5.size() != 0) {
            if(arg5.size() != 2) {
                throw new IllegalArgumentException("Incorrect sequence size: " + arg5.size());
            }
            else {
                this.version = ASN1Integer.getInstance(arg5.getObjectAt(0));
                ASN1Set v1 = ASN1Set.getInstance(arg5.getObjectAt(1));
                this.certList = new Certificate[v1.size()];
                while(v0 < this.certList.length) {
                    this.certList[v0] = Certificate.getInstance(v1.getObjectAt(v0));
                    ++v0;
                }

                return;
            }
        }

        throw new IllegalArgumentException("null or empty sequence passed.");
    }

    public CscaMasterList(Certificate[] arg4) {
        super();
        this.version = new ASN1Integer(0);
        this.certList = this.copyCertList(arg4);
    }

    private Certificate[] copyCertList(Certificate[] arg4) {
        Certificate[] v1 = new Certificate[arg4.length];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = arg4[v0];
        }

        return v1;
    }

    public Certificate[] getCertStructs() {
        return this.copyCertList(this.certList);
    }

    public static CscaMasterList getInstance(Object arg2) {
        CscaMasterList v2;
        if(!(arg2 instanceof CscaMasterList)) {
            if(arg2 != null) {
                v2 = new CscaMasterList(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public int getVersion() {
        return this.version.getValue().intValue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(this.version);
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < this.certList.length; ++v0) {
            v2.add(this.certList[v0]);
        }

        v1.add(new DERSet(v2));
        return new DERSequence(v1);
    }
}

