// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.icao;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class LDSSecurityObject extends ASN1Object implements ICAOObjectIdentifiers {
    private DataGroupHash[] datagroupHash;
    private AlgorithmIdentifier digestAlgorithmIdentifier;
    public static final int ub_DataGroups = 16;
    private ASN1Integer version;
    private LDSVersionInfo versionInfo;

    private LDSSecurityObject(ASN1Sequence arg5) {
        super();
        this.version = new ASN1Integer(0);
        if(arg5 != null && arg5.size() != 0) {
            Enumeration v0 = arg5.getObjects();
            this.version = ASN1Integer.getInstance(v0.nextElement());
            this.digestAlgorithmIdentifier = AlgorithmIdentifier.getInstance(v0.nextElement());
            ASN1Sequence v1 = ASN1Sequence.getInstance(v0.nextElement());
            if(this.version.getValue().intValue() == 1) {
                this.versionInfo = LDSVersionInfo.getInstance(v0.nextElement());
            }

            this.checkDatagroupHashSeqSize(v1.size());
            this.datagroupHash = new DataGroupHash[v1.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 < v1.size(); ++v0_1) {
                this.datagroupHash[v0_1] = DataGroupHash.getInstance(v1.getObjectAt(v0_1));
            }

            return;
        }

        throw new IllegalArgumentException("null or empty sequence passed.");
    }

    public LDSSecurityObject(AlgorithmIdentifier arg4, DataGroupHash[] arg5) {
        super();
        this.version = new ASN1Integer(0);
        this.version = new ASN1Integer(0);
        this.digestAlgorithmIdentifier = arg4;
        this.datagroupHash = arg5;
        this.checkDatagroupHashSeqSize(arg5.length);
    }

    public LDSSecurityObject(AlgorithmIdentifier arg4, DataGroupHash[] arg5, LDSVersionInfo arg6) {
        super();
        this.version = new ASN1Integer(0);
        this.version = new ASN1Integer(1);
        this.digestAlgorithmIdentifier = arg4;
        this.datagroupHash = arg5;
        this.versionInfo = arg6;
        this.checkDatagroupHashSeqSize(arg5.length);
    }

    private void checkDatagroupHashSeqSize(int arg3) {
        if(arg3 >= 2 && arg3 <= 16) {
            return;
        }

        throw new IllegalArgumentException("wrong size in DataGroupHashValues : not in (2..16)");
    }

    public DataGroupHash[] getDatagroupHash() {
        return this.datagroupHash;
    }

    public AlgorithmIdentifier getDigestAlgorithmIdentifier() {
        return this.digestAlgorithmIdentifier;
    }

    public static LDSSecurityObject getInstance(Object arg2) {
        if(!(arg2 instanceof LDSSecurityObject)) {
            if(arg2 != null) {
                LDSSecurityObject v2 = new LDSSecurityObject(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public int getVersion() {
        return this.version.getValue().intValue();
    }

    public LDSVersionInfo getVersionInfo() {
        return this.versionInfo;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(this.version);
        v1.add(this.digestAlgorithmIdentifier);
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < this.datagroupHash.length; ++v0) {
            v2.add(this.datagroupHash[v0]);
        }

        v1.add(new DERSequence(v2));
        if(this.versionInfo != null) {
            v1.add(this.versionInfo);
        }

        return new DERSequence(v1);
    }
}

