// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.icao;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERSequence;

public class LDSVersionInfo extends ASN1Object {
    private DERPrintableString ldsVersion;
    private DERPrintableString unicodeVersion;

    public LDSVersionInfo(String arg2, String arg3) {
        super();
        this.ldsVersion = new DERPrintableString(arg2);
        this.unicodeVersion = new DERPrintableString(arg3);
    }

    private LDSVersionInfo(ASN1Sequence arg3) {
        super();
        if(arg3.size() != 2) {
            throw new IllegalArgumentException("sequence wrong size for LDSVersionInfo");
        }

        this.ldsVersion = DERPrintableString.getInstance(arg3.getObjectAt(0));
        this.unicodeVersion = DERPrintableString.getInstance(arg3.getObjectAt(1));
    }

    public static LDSVersionInfo getInstance(Object arg2) {
        if(!(arg2 instanceof LDSVersionInfo)) {
            if(arg2 != null) {
                LDSVersionInfo v2 = new LDSVersionInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public String getLdsVersion() {
        return this.ldsVersion.getString();
    }

    public String getUnicodeVersion() {
        return this.unicodeVersion.getString();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.ldsVersion);
        v0.add(this.unicodeVersion);
        return new DERSequence(v0);
    }
}

