// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.ocsp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class CertHash extends ASN1Object {
    private byte[] certificateHash;
    private AlgorithmIdentifier hashAlgorithm;

    private CertHash(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.hashAlgorithm = AlgorithmIdentifier.getInstance(arg4.getObjectAt(0));
        this.certificateHash = DEROctetString.getInstance(arg4.getObjectAt(1)).getOctets();
    }

    public CertHash(AlgorithmIdentifier arg4, byte[] arg5) {
        super();
        this.hashAlgorithm = arg4;
        this.certificateHash = new byte[arg5.length];
        System.arraycopy(arg5, 0, this.certificateHash, 0, arg5.length);
    }

    public byte[] getCertificateHash() {
        return this.certificateHash;
    }

    public AlgorithmIdentifier getHashAlgorithm() {
        return this.hashAlgorithm;
    }

    public static CertHash getInstance(Object arg3) {
        CertHash v3;
        if(arg3 != null && !(arg3 instanceof CertHash)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new CertHash(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.hashAlgorithm);
        v0.add(new DEROctetString(this.certificateHash));
        return new DERSequence(v0);
    }
}

