// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.ocsp;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Certificate;

public class RequestedCertificate extends ASN1Object implements ASN1Choice {
    private byte[] attributeCert;
    public static final int attributeCertificate = 1;
    private Certificate cert;
    public static final int certificate = -1;
    private byte[] publicKeyCert;
    public static final int publicKeyCertificate;

    public RequestedCertificate(int arg3, byte[] arg4) {
        this(new DERTaggedObject(arg3, new DEROctetString(arg4)));
    }

    private RequestedCertificate(ASN1TaggedObject arg4) {
        super();
        if(arg4.getTagNo() == 0) {
            this.publicKeyCert = ASN1OctetString.getInstance(arg4, true).getOctets();
        }
        else if(arg4.getTagNo() == 1) {
            this.attributeCert = ASN1OctetString.getInstance(arg4, true).getOctets();
        }
        else {
            goto label_14;
        }

        return;
    label_14:
        throw new IllegalArgumentException("unknown tag number: " + arg4.getTagNo());
    }

    public RequestedCertificate(Certificate arg1) {
        super();
        this.cert = arg1;
    }

    public byte[] getCertificateBytes() {
        byte[] v0_1;
        if(this.cert != null) {
            try {
                v0_1 = this.cert.getEncoded();
            }
            catch(IOException v0) {
                throw new IllegalStateException("can\'t decode certificate: " + v0);
            }
        }
        else if(this.publicKeyCert != null) {
            v0_1 = this.publicKeyCert;
        }
        else {
            v0_1 = this.attributeCert;
        }

        return v0_1;
    }

    public static RequestedCertificate getInstance(Object arg3) {
        RequestedCertificate v3;
        if(arg3 != null && !(arg3 instanceof RequestedCertificate)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new RequestedCertificate(Certificate.getInstance(arg3));
            }
            else if((arg3 instanceof ASN1TaggedObject)) {
                v3 = new RequestedCertificate(((ASN1TaggedObject)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static RequestedCertificate getInstance(ASN1TaggedObject arg2, boolean arg3) {
        if(!arg3) {
            throw new IllegalArgumentException("choice item must be explicitly tagged");
        }

        return RequestedCertificate.getInstance(arg2.getObject());
    }

    public int getType() {
        int v0;
        if(this.cert != null) {
            v0 = -1;
        }
        else if(this.publicKeyCert != null) {
            v0 = 0;
        }
        else {
            v0 = 1;
        }

        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        DERTaggedObject v0;
        if(this.publicKeyCert != null) {
            v0 = new DERTaggedObject(0, new DEROctetString(this.publicKeyCert));
        }
        else if(this.attributeCert != null) {
            v0 = new DERTaggedObject(1, new DEROctetString(this.attributeCert));
        }
        else {
            ASN1Primitive v0_1 = this.cert.toASN1Primitive();
        }

        return ((ASN1Primitive)v0);
    }
}

