// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.GeneralName;

public class Admissions extends ASN1Object {
    private GeneralName admissionAuthority;
    private NamingAuthority namingAuthority;
    private ASN1Sequence professionInfos;

    private Admissions(ASN1Sequence arg5) {
        Object v1;
        super();
        if(arg5.size() > 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
        }

        Enumeration v2 = arg5.getObjects();
        Object v0 = v2.nextElement();
        if((v0 instanceof ASN1TaggedObject)) {
            switch(v0.getTagNo()) {
                case 0: {
                    goto label_32;
                }
                case 1: {
                    goto label_51;
                }
            }

            throw new IllegalArgumentException("Bad tag number: " + ((ASN1TaggedObject)v0).getTagNo());
        label_51:
            this.namingAuthority = NamingAuthority.getInstance(((ASN1TaggedObject)v0), true);
            goto label_34;
        label_32:
            this.admissionAuthority = GeneralName.getInstance(((ASN1TaggedObject)v0), true);
        label_34:
            v1 = v2.nextElement();
        }
        else {
            v1 = v0;
        }

        if((v1 instanceof ASN1TaggedObject)) {
            switch(v1.getTagNo()) {
                case 1: {
                    this.namingAuthority = NamingAuthority.getInstance(((ASN1TaggedObject)v1), true);
                    v0 = v2.nextElement();
                    goto label_57;
                label_73:
                    v0 = v1;
                    goto label_57;
                }
                default: {
                    throw new IllegalArgumentException("Bad tag number: " + ((ASN1TaggedObject)v1).getTagNo());
                }
            }
        }
        else {
            goto label_73;
        }

    label_57:
        this.professionInfos = ASN1Sequence.getInstance(v0);
        if(v2.hasMoreElements()) {
            throw new IllegalArgumentException("Bad object encountered: " + v2.nextElement().getClass());
        }
    }

    public Admissions(GeneralName arg2, NamingAuthority arg3, ProfessionInfo[] arg4) {
        super();
        this.admissionAuthority = arg2;
        this.namingAuthority = arg3;
        this.professionInfos = new DERSequence(((ASN1Encodable[])arg4));
    }

    public GeneralName getAdmissionAuthority() {
        return this.admissionAuthority;
    }

    public static Admissions getInstance(Object arg3) {
        Admissions v3;
        if(arg3 != null && !(arg3 instanceof Admissions)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new Admissions(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public NamingAuthority getNamingAuthority() {
        return this.namingAuthority;
    }

    public ProfessionInfo[] getProfessionInfos() {
        ProfessionInfo[] v2 = new ProfessionInfo[this.professionInfos.size()];
        int v0 = 0;
        Enumeration v3 = this.professionInfos.getObjects();
        while(v3.hasMoreElements()) {
            v2[v0] = ProfessionInfo.getInstance(v3.nextElement());
            ++v0;
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.admissionAuthority != null) {
            v0.add(new DERTaggedObject(true, 0, this.admissionAuthority));
        }

        if(this.namingAuthority != null) {
            v0.add(new DERTaggedObject(true, 1, this.namingAuthority));
        }

        v0.add(this.professionInfos);
        return new DERSequence(v0);
    }
}

