// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.x509;

import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class DeclarationOfMajority extends ASN1Object implements ASN1Choice {
    public static final int dateOfBirth = 2;
    private ASN1TaggedObject declaration;
    public static final int fullAgeAtCountry = 1;
    public static final int notYoungerThan;

    public DeclarationOfMajority(int arg6) {
        super();
        this.declaration = new DERTaggedObject(false, 0, new ASN1Integer(((long)arg6)));
    }

    public DeclarationOfMajority(ASN1GeneralizedTime arg4) {
        super();
        this.declaration = new DERTaggedObject(false, 2, ((ASN1Encodable)arg4));
    }

    private DeclarationOfMajority(ASN1TaggedObject arg4) {
        super();
        if(arg4.getTagNo() > 2) {
            throw new IllegalArgumentException("Bad tag number: " + arg4.getTagNo());
        }

        this.declaration = arg4;
    }

    public DeclarationOfMajority(boolean arg6, String arg7) {
        super();
        if(arg7.length() > 2) {
            throw new IllegalArgumentException("country can only be 2 characters");
        }

        if(arg6) {
            this.declaration = new DERTaggedObject(false, 1, new DERSequence(new DERPrintableString(arg7, true)));
        }
        else {
            ASN1EncodableVector v0 = new ASN1EncodableVector();
            v0.add(ASN1Boolean.FALSE);
            v0.add(new DERPrintableString(arg7, true));
            this.declaration = new DERTaggedObject(false, 1, new DERSequence(v0));
        }
    }

    public ASN1Sequence fullAgeAtCountry() {
        ASN1Sequence v0 = this.declaration.getTagNo() != 1 ? null : ASN1Sequence.getInstance(this.declaration, false);
        return v0;
    }

    public ASN1GeneralizedTime getDateOfBirth() {
        ASN1GeneralizedTime v0 = this.declaration.getTagNo() != 2 ? null : ASN1GeneralizedTime.getInstance(this.declaration, false);
        return v0;
    }

    public static DeclarationOfMajority getInstance(Object arg3) {
        DeclarationOfMajority v3;
        if(arg3 != null && !(arg3 instanceof DeclarationOfMajority)) {
            if((arg3 instanceof ASN1TaggedObject)) {
                v3 = new DeclarationOfMajority(((ASN1TaggedObject)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public int getType() {
        return this.declaration.getTagNo();
    }

    public int notYoungerThan() {
        int v0 = this.declaration.getTagNo() != 0 ? -1 : ASN1Integer.getInstance(this.declaration, false).getValue().intValue();
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        return this.declaration;
    }
}

