// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.x509;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERSequence;

public class MonetaryLimit extends ASN1Object {
    ASN1Integer amount;
    DERPrintableString currency;
    ASN1Integer exponent;

    public MonetaryLimit(String arg4, int arg5, int arg6) {
        super();
        this.currency = new DERPrintableString(arg4, true);
        this.amount = new ASN1Integer(((long)arg5));
        this.exponent = new ASN1Integer(((long)arg6));
    }

    private MonetaryLimit(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        Enumeration v0 = arg4.getObjects();
        this.currency = DERPrintableString.getInstance(v0.nextElement());
        this.amount = ASN1Integer.getInstance(v0.nextElement());
        this.exponent = ASN1Integer.getInstance(v0.nextElement());
    }

    public BigInteger getAmount() {
        return this.amount.getValue();
    }

    public String getCurrency() {
        return this.currency.getString();
    }

    public BigInteger getExponent() {
        return this.exponent.getValue();
    }

    public static MonetaryLimit getInstance(Object arg2) {
        MonetaryLimit v2;
        if(arg2 != null && !(arg2 instanceof MonetaryLimit)) {
            if((arg2 instanceof ASN1Sequence)) {
                v2 = new MonetaryLimit(ASN1Sequence.getInstance(arg2));
            }
            else {
                throw new IllegalArgumentException("unknown object in getInstance");
            }
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.currency);
        v0.add(this.amount);
        v0.add(this.exponent);
        return new DERSequence(v0);
    }
}

