// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1String;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.isismtt.ISISMTTObjectIdentifiers;
import org.bouncycastle.asn1.x500.DirectoryString;

public class NamingAuthority extends ASN1Object {
    public static final ASN1ObjectIdentifier id_isismtt_at_namingAuthorities_RechtWirtschaftSteuern;
    private ASN1ObjectIdentifier namingAuthorityId;
    private DirectoryString namingAuthorityText;
    private String namingAuthorityUrl;

    static {
        NamingAuthority.id_isismtt_at_namingAuthorities_RechtWirtschaftSteuern = new ASN1ObjectIdentifier(ISISMTTObjectIdentifiers.id_isismtt_at_namingAuthorities + ".1");
    }

    public NamingAuthority(ASN1ObjectIdentifier arg1, String arg2, DirectoryString arg3) {
        super();
        this.namingAuthorityId = arg1;
        this.namingAuthorityUrl = arg2;
        this.namingAuthorityText = arg3;
    }

    private NamingAuthority(ASN1Sequence arg5) {
        Object v0;
        super();
        if(arg5.size() > 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
        }

        Enumeration v1 = arg5.getObjects();
        if(v1.hasMoreElements()) {
            v0 = v1.nextElement();
            if((v0 instanceof ASN1ObjectIdentifier)) {
                this.namingAuthorityId = ((ASN1ObjectIdentifier)v0);
            }
            else if((v0 instanceof DERIA5String)) {
                this.namingAuthorityUrl = DERIA5String.getInstance(v0).getString();
            }
            else if((v0 instanceof ASN1String)) {
                this.namingAuthorityText = DirectoryString.getInstance(v0);
            }
            else {
                throw new IllegalArgumentException("Bad object encountered: " + v0.getClass());
            }
        }

        if(v1.hasMoreElements()) {
            v0 = v1.nextElement();
            if((v0 instanceof DERIA5String)) {
                this.namingAuthorityUrl = DERIA5String.getInstance(v0).getString();
            }
            else if((v0 instanceof ASN1String)) {
                this.namingAuthorityText = DirectoryString.getInstance(v0);
            }
            else {
                throw new IllegalArgumentException("Bad object encountered: " + v0.getClass());
            }
        }

        if(v1.hasMoreElements()) {
            v0 = v1.nextElement();
            if((v0 instanceof ASN1String)) {
                this.namingAuthorityText = DirectoryString.getInstance(v0);
            }
            else {
                throw new IllegalArgumentException("Bad object encountered: " + v0.getClass());
            }
        }
    }

    public NamingAuthority(DERObjectIdentifier arg3, String arg4, DirectoryString arg5) {
        super();
        this.namingAuthorityId = new ASN1ObjectIdentifier(arg3.getId());
        this.namingAuthorityUrl = arg4;
        this.namingAuthorityText = arg5;
    }

    public static NamingAuthority getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return NamingAuthority.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public static NamingAuthority getInstance(Object arg3) {
        NamingAuthority v3;
        if(arg3 != null && !(arg3 instanceof NamingAuthority)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new NamingAuthority(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public ASN1ObjectIdentifier getNamingAuthorityId() {
        return this.namingAuthorityId;
    }

    public DirectoryString getNamingAuthorityText() {
        return this.namingAuthorityText;
    }

    public String getNamingAuthorityUrl() {
        return this.namingAuthorityUrl;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.namingAuthorityId != null) {
            v0.add(this.namingAuthorityId);
        }

        if(this.namingAuthorityUrl != null) {
            v0.add(new DERIA5String(this.namingAuthorityUrl, true));
        }

        if(this.namingAuthorityText != null) {
            v0.add(this.namingAuthorityText);
        }

        return new DERSequence(v0);
    }
}

