// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.isismtt.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.DirectoryString;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.IssuerSerial;

public class ProcurationSyntax extends ASN1Object {
    private IssuerSerial certRef;
    private String country;
    private GeneralName thirdPerson;
    private DirectoryString typeOfSubstitution;

    public ProcurationSyntax(String arg2, DirectoryString arg3, GeneralName arg4) {
        super();
        this.country = arg2;
        this.typeOfSubstitution = arg3;
        this.thirdPerson = arg4;
        this.certRef = null;
    }

    public ProcurationSyntax(String arg2, DirectoryString arg3, IssuerSerial arg4) {
        super();
        this.country = arg2;
        this.typeOfSubstitution = arg3;
        this.thirdPerson = null;
        this.certRef = arg4;
    }

    private ProcurationSyntax(ASN1Sequence arg5) {
        super();
        if(arg5.size() >= 1 && arg5.size() <= 3) {
            Enumeration v0 = arg5.getObjects();
            while(v0.hasMoreElements()) {
                ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0.nextElement());
                switch(v1.getTagNo()) {
                    case 1: {
                        goto label_34;
                    }
                    case 2: {
                        goto label_38;
                    }
                    case 3: {
                        goto label_41;
                    }
                }

                throw new IllegalArgumentException("Bad tag number: " + v1.getTagNo());
            label_38:
                this.typeOfSubstitution = DirectoryString.getInstance(v1, true);
                continue;
            label_34:
                this.country = DERPrintableString.getInstance(v1, true).getString();
                continue;
            label_41:
                ASN1Primitive v1_1 = v1.getObject();
                if((v1_1 instanceof ASN1TaggedObject)) {
                    this.thirdPerson = GeneralName.getInstance(v1_1);
                }
                else {
                    this.certRef = IssuerSerial.getInstance(v1_1);
                }
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
    }

    public IssuerSerial getCertRef() {
        return this.certRef;
    }

    public String getCountry() {
        return this.country;
    }

    public static ProcurationSyntax getInstance(Object arg3) {
        ProcurationSyntax v3;
        if(arg3 != null && !(arg3 instanceof ProcurationSyntax)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new ProcurationSyntax(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public GeneralName getThirdPerson() {
        return this.thirdPerson;
    }

    public DirectoryString getTypeOfSubstitution() {
        return this.typeOfSubstitution;
    }

    public ASN1Primitive toASN1Primitive() {
        int v5 = 3;
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.country != null) {
            v0.add(new DERTaggedObject(true, 1, new DERPrintableString(this.country, true)));
        }

        if(this.typeOfSubstitution != null) {
            v0.add(new DERTaggedObject(true, 2, this.typeOfSubstitution));
        }

        if(this.thirdPerson != null) {
            v0.add(new DERTaggedObject(true, v5, this.thirdPerson));
        }
        else {
            v0.add(new DERTaggedObject(true, v5, this.certRef));
        }

        return new DERSequence(v0);
    }
}

