// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ocsp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class OCSPRequest extends ASN1Object {
    Signature optionalSignature;
    TBSRequest tbsRequest;

    private OCSPRequest(ASN1Sequence arg4) {
        super();
        this.tbsRequest = TBSRequest.getInstance(arg4.getObjectAt(0));
        if(arg4.size() == 2) {
            this.optionalSignature = Signature.getInstance(arg4.getObjectAt(1), true);
        }
    }

    public OCSPRequest(TBSRequest arg1, Signature arg2) {
        super();
        this.tbsRequest = arg1;
        this.optionalSignature = arg2;
    }

    public static OCSPRequest getInstance(Object arg2) {
        if(!(arg2 instanceof OCSPRequest)) {
            if(arg2 != null) {
                OCSPRequest v2 = new OCSPRequest(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static OCSPRequest getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return OCSPRequest.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public Signature getOptionalSignature() {
        return this.optionalSignature;
    }

    public TBSRequest getTbsRequest() {
        return this.tbsRequest;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.tbsRequest);
        if(this.optionalSignature != null) {
            v0.add(new DERTaggedObject(true, 0, this.optionalSignature));
        }

        return new DERSequence(v0);
    }
}

