// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ocsp;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class OCSPResponse extends ASN1Object {
    ResponseBytes responseBytes;
    OCSPResponseStatus responseStatus;

    private OCSPResponse(ASN1Sequence arg4) {
        super();
        this.responseStatus = OCSPResponseStatus.getInstance(arg4.getObjectAt(0));
        if(arg4.size() == 2) {
            this.responseBytes = ResponseBytes.getInstance(arg4.getObjectAt(1), true);
        }
    }

    public OCSPResponse(OCSPResponseStatus arg1, ResponseBytes arg2) {
        super();
        this.responseStatus = arg1;
        this.responseBytes = arg2;
    }

    public static OCSPResponse getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return OCSPResponse.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public static OCSPResponse getInstance(Object arg2) {
        OCSPResponse v2;
        if(!(arg2 instanceof OCSPResponse)) {
            if(arg2 != null) {
                v2 = new OCSPResponse(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ResponseBytes getResponseBytes() {
        return this.responseBytes;
    }

    public OCSPResponseStatus getResponseStatus() {
        return this.responseStatus;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.responseStatus);
        if(this.responseBytes != null) {
            v0.add(new DERTaggedObject(true, 0, this.responseBytes));
        }

        return new DERSequence(v0);
    }
}

