// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ocsp;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.X509Extensions;

public class SingleResponse extends ASN1Object {
    private CertID certID;
    private CertStatus certStatus;
    private ASN1GeneralizedTime nextUpdate;
    private Extensions singleExtensions;
    private ASN1GeneralizedTime thisUpdate;

    private SingleResponse(ASN1Sequence arg5) {
        int v3 = 4;
        int v1 = 3;
        super();
        this.certID = CertID.getInstance(arg5.getObjectAt(0));
        this.certStatus = CertStatus.getInstance(arg5.getObjectAt(1));
        this.thisUpdate = ASN1GeneralizedTime.getInstance(arg5.getObjectAt(2));
        if(arg5.size() > v3) {
            this.nextUpdate = ASN1GeneralizedTime.getInstance(arg5.getObjectAt(v1), true);
            this.singleExtensions = Extensions.getInstance(arg5.getObjectAt(v3), true);
        }
        else if(arg5.size() > v1) {
            ASN1Encodable v0 = arg5.getObjectAt(v1);
            if(((ASN1TaggedObject)v0).getTagNo() == 0) {
                this.nextUpdate = ASN1GeneralizedTime.getInstance(((ASN1TaggedObject)v0), true);
            }
            else {
                this.singleExtensions = Extensions.getInstance(((ASN1TaggedObject)v0), true);
            }
        }
    }

    public SingleResponse(CertID arg1, CertStatus arg2, ASN1GeneralizedTime arg3, ASN1GeneralizedTime arg4, Extensions arg5) {
        super();
        this.certID = arg1;
        this.certStatus = arg2;
        this.thisUpdate = arg3;
        this.nextUpdate = arg4;
        this.singleExtensions = arg5;
    }

    public SingleResponse(CertID arg7, CertStatus arg8, DERGeneralizedTime arg9, DERGeneralizedTime arg10, Extensions arg11) {
        this(arg7, arg8, ASN1GeneralizedTime.getInstance(arg9), ASN1GeneralizedTime.getInstance(arg10), Extensions.getInstance(arg11));
    }

    public SingleResponse(CertID arg7, CertStatus arg8, DERGeneralizedTime arg9, DERGeneralizedTime arg10, X509Extensions arg11) {
        this(arg7, arg8, arg9, arg10, Extensions.getInstance(arg11));
    }

    public CertID getCertID() {
        return this.certID;
    }

    public CertStatus getCertStatus() {
        return this.certStatus;
    }

    public static SingleResponse getInstance(Object arg2) {
        SingleResponse v2;
        if(!(arg2 instanceof SingleResponse)) {
            if(arg2 != null) {
                v2 = new SingleResponse(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static SingleResponse getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return SingleResponse.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1GeneralizedTime getNextUpdate() {
        return this.nextUpdate;
    }

    public Extensions getSingleExtensions() {
        return this.singleExtensions;
    }

    public ASN1GeneralizedTime getThisUpdate() {
        return this.thisUpdate;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.certID);
        v0.add(this.certStatus);
        v0.add(this.thisUpdate);
        if(this.nextUpdate != null) {
            v0.add(new DERTaggedObject(true, 0, this.nextUpdate));
        }

        if(this.singleExtensions != null) {
            v0.add(new DERTaggedObject(true, 1, this.singleExtensions));
        }

        return new DERSequence(v0);
    }
}

