// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509Name;

public class CertificationRequestInfo extends ASN1Object {
    ASN1Set attributes;
    X500Name subject;
    SubjectPublicKeyInfo subjectPKInfo;
    ASN1Integer version;

    public CertificationRequestInfo(ASN1Sequence arg6) {
        int v4 = 3;
        super();
        this.version = new ASN1Integer(0);
        this.attributes = null;
        this.version = arg6.getObjectAt(0);
        this.subject = X500Name.getInstance(arg6.getObjectAt(1));
        this.subjectPKInfo = SubjectPublicKeyInfo.getInstance(arg6.getObjectAt(2));
        if(arg6.size() > v4) {
            this.attributes = ASN1Set.getInstance(arg6.getObjectAt(v4), false);
        }

        if(this.subject != null && this.version != null && this.subjectPKInfo != null) {
            return;
        }

        throw new IllegalArgumentException("Not all mandatory fields set in CertificationRequestInfo generator.");
    }

    public CertificationRequestInfo(X500Name arg4, SubjectPublicKeyInfo arg5, ASN1Set arg6) {
        super();
        this.version = new ASN1Integer(0);
        this.attributes = null;
        this.subject = arg4;
        this.subjectPKInfo = arg5;
        this.attributes = arg6;
        if(arg4 != null && this.version != null && this.subjectPKInfo != null) {
            return;
        }

        throw new IllegalArgumentException("Not all mandatory fields set in CertificationRequestInfo generator.");
    }

    public CertificationRequestInfo(X509Name arg4, SubjectPublicKeyInfo arg5, ASN1Set arg6) {
        super();
        this.version = new ASN1Integer(0);
        this.attributes = null;
        this.subject = X500Name.getInstance(arg4.toASN1Primitive());
        this.subjectPKInfo = arg5;
        this.attributes = arg6;
        if(arg4 != null && this.version != null && this.subjectPKInfo != null) {
            return;
        }

        throw new IllegalArgumentException("Not all mandatory fields set in CertificationRequestInfo generator.");
    }

    public ASN1Set getAttributes() {
        return this.attributes;
    }

    public static CertificationRequestInfo getInstance(Object arg2) {
        CertificationRequestInfo v2;
        if(!(arg2 instanceof CertificationRequestInfo)) {
            if(arg2 != null) {
                v2 = new CertificationRequestInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public X500Name getSubject() {
        return this.subject;
    }

    public SubjectPublicKeyInfo getSubjectPublicKeyInfo() {
        return this.subjectPKInfo;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.subject);
        v0.add(this.subjectPKInfo);
        if(this.attributes != null) {
            v0.add(new DERTaggedObject(false, 0, this.attributes));
        }

        return new DERSequence(v0);
    }
}

