// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.BERTaggedObject;
import org.bouncycastle.asn1.DLSequence;

public class ContentInfo extends ASN1Object implements PKCSObjectIdentifiers {
    private ASN1Encodable content;
    private ASN1ObjectIdentifier contentType;
    private boolean isBer;

    public ContentInfo(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        super();
        this.isBer = true;
        this.contentType = arg2;
        this.content = arg3;
    }

    private ContentInfo(ASN1Sequence arg3) {
        super();
        this.isBer = true;
        Enumeration v1 = arg3.getObjects();
        this.contentType = v1.nextElement();
        if(v1.hasMoreElements()) {
            this.content = v1.nextElement().getObject();
        }

        this.isBer = arg3 instanceof BERSequence;
    }

    public ASN1Encodable getContent() {
        return this.content;
    }

    public ASN1ObjectIdentifier getContentType() {
        return this.contentType;
    }

    public static ContentInfo getInstance(Object arg2) {
        ContentInfo v2;
        if(!(arg2 instanceof ContentInfo)) {
            if(arg2 != null) {
                v2 = new ContentInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        DLSequence v0_1;
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(this.contentType);
        if(this.content != null) {
            v1.add(new BERTaggedObject(true, 0, this.content));
        }

        if(this.isBer) {
            BERSequence v0 = new BERSequence(v1);
        }
        else {
            v0_1 = new DLSequence(v1);
        }

        return ((ASN1Primitive)v0_1);
    }
}

