// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class DHParameter extends ASN1Object {
    ASN1Integer g;
    ASN1Integer l;
    ASN1Integer p;

    public DHParameter(BigInteger arg4, BigInteger arg5, int arg6) {
        super();
        this.p = new ASN1Integer(arg4);
        this.g = new ASN1Integer(arg5);
        this.l = arg6 != 0 ? new ASN1Integer(((long)arg6)) : null;
    }

    private DHParameter(ASN1Sequence arg3) {
        super();
        Enumeration v0 = arg3.getObjects();
        this.p = ASN1Integer.getInstance(v0.nextElement());
        this.g = ASN1Integer.getInstance(v0.nextElement());
        this.l = v0.hasMoreElements() ? v0.nextElement() : null;
    }

    public BigInteger getG() {
        return this.g.getPositiveValue();
    }

    public static DHParameter getInstance(Object arg2) {
        DHParameter v2;
        if(!(arg2 instanceof DHParameter)) {
            if(arg2 != null) {
                v2 = new DHParameter(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public BigInteger getL() {
        BigInteger v0 = this.l == null ? null : this.l.getPositiveValue();
        return v0;
    }

    public BigInteger getP() {
        return this.p.getPositiveValue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.p);
        v0.add(this.g);
        if(this.getL() != null) {
            v0.add(this.l);
        }

        return new DERSequence(v0);
    }
}

