// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.BERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class EncryptedData extends ASN1Object {
    ASN1ObjectIdentifier bagId;
    ASN1Primitive bagValue;
    ASN1Sequence data;

    public EncryptedData(ASN1ObjectIdentifier arg4, AlgorithmIdentifier arg5, ASN1Encodable arg6) {
        super();
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(((ASN1Encodable)arg4));
        v0.add(arg5.toASN1Primitive());
        v0.add(new BERTaggedObject(false, 0, arg6));
        this.data = new BERSequence(v0);
    }

    private EncryptedData(ASN1Sequence arg3) {
        super();
        if(arg3.getObjectAt(0).getValue().intValue() != 0) {
            throw new IllegalArgumentException("sequence not version 0");
        }

        this.data = ASN1Sequence.getInstance(arg3.getObjectAt(1));
    }

    public ASN1OctetString getContent() {
        ASN1OctetString v0 = this.data.size() == 3 ? ASN1OctetString.getInstance(ASN1TaggedObject.getInstance(this.data.getObjectAt(2)), false) : null;
        return v0;
    }

    public ASN1ObjectIdentifier getContentType() {
        return ASN1ObjectIdentifier.getInstance(this.data.getObjectAt(0));
    }

    public AlgorithmIdentifier getEncryptionAlgorithm() {
        return AlgorithmIdentifier.getInstance(this.data.getObjectAt(1));
    }

    public static EncryptedData getInstance(Object arg2) {
        if(!(arg2 instanceof EncryptedData)) {
            if(arg2 != null) {
                EncryptedData v2 = new EncryptedData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(0));
        v0.add(this.data);
        return new BERSequence(v0);
    }
}

