// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class EncryptedPrivateKeyInfo extends ASN1Object {
    private AlgorithmIdentifier algId;
    private ASN1OctetString data;

    private EncryptedPrivateKeyInfo(ASN1Sequence arg3) {
        super();
        Enumeration v0 = arg3.getObjects();
        this.algId = AlgorithmIdentifier.getInstance(v0.nextElement());
        this.data = ASN1OctetString.getInstance(v0.nextElement());
    }

    public EncryptedPrivateKeyInfo(AlgorithmIdentifier arg2, byte[] arg3) {
        super();
        this.algId = arg2;
        this.data = new DEROctetString(arg3);
    }

    public byte[] getEncryptedData() {
        return this.data.getOctets();
    }

    public AlgorithmIdentifier getEncryptionAlgorithm() {
        return this.algId;
    }

    public static EncryptedPrivateKeyInfo getInstance(Object arg2) {
        EncryptedPrivateKeyInfo v2;
        if(!(arg2 instanceof EncryptedPrivateKeyInfo)) {
            if(arg2 != null) {
                v2 = new EncryptedPrivateKeyInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.algId);
        v0.add(this.data);
        return new DERSequence(v0);
    }
}

