// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.X509Name;

public class IssuerAndSerialNumber extends ASN1Object {
    ASN1Integer certSerialNumber;
    X500Name name;

    private IssuerAndSerialNumber(ASN1Sequence arg2) {
        super();
        this.name = X500Name.getInstance(arg2.getObjectAt(0));
        this.certSerialNumber = arg2.getObjectAt(1);
    }

    public IssuerAndSerialNumber(X500Name arg2, BigInteger arg3) {
        super();
        this.name = arg2;
        this.certSerialNumber = new ASN1Integer(arg3);
    }

    public IssuerAndSerialNumber(X509Name arg2, BigInteger arg3) {
        super();
        this.name = X500Name.getInstance(arg2.toASN1Primitive());
        this.certSerialNumber = new ASN1Integer(arg3);
    }

    public IssuerAndSerialNumber(X509Name arg2, ASN1Integer arg3) {
        super();
        this.name = X500Name.getInstance(arg2.toASN1Primitive());
        this.certSerialNumber = arg3;
    }

    public ASN1Integer getCertificateSerialNumber() {
        return this.certSerialNumber;
    }

    public static IssuerAndSerialNumber getInstance(Object arg2) {
        IssuerAndSerialNumber v2;
        if(!(arg2 instanceof IssuerAndSerialNumber)) {
            if(arg2 != null) {
                v2 = new IssuerAndSerialNumber(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public X500Name getName() {
        return this.name;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.name);
        v0.add(this.certSerialNumber);
        return new DERSequence(v0);
    }
}

