// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.DigestInfo;

public class MacData extends ASN1Object {
    private static final BigInteger ONE;
    DigestInfo digInfo;
    BigInteger iterationCount;
    byte[] salt;

    static {
        MacData.ONE = BigInteger.valueOf(1);
    }

    private MacData(ASN1Sequence arg3) {
        super();
        this.digInfo = DigestInfo.getInstance(arg3.getObjectAt(0));
        this.salt = arg3.getObjectAt(1).getOctets();
        this.iterationCount = arg3.size() == 3 ? arg3.getObjectAt(2).getValue() : MacData.ONE;
    }

    public MacData(DigestInfo arg3, byte[] arg4, int arg5) {
        super();
        this.digInfo = arg3;
        this.salt = arg4;
        this.iterationCount = BigInteger.valueOf(((long)arg5));
    }

    public static MacData getInstance(Object arg2) {
        if(!(arg2 instanceof MacData)) {
            if(arg2 != null) {
                MacData v2 = new MacData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public BigInteger getIterationCount() {
        return this.iterationCount;
    }

    public DigestInfo getMac() {
        return this.digInfo;
    }

    public byte[] getSalt() {
        return this.salt;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.digInfo);
        v0.add(new DEROctetString(this.salt));
        if(!this.iterationCount.equals(MacData.ONE)) {
            v0.add(new ASN1Integer(this.iterationCount));
        }

        return new DERSequence(v0);
    }
}

