// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class PBEParameter extends ASN1Object {
    ASN1Integer iterations;
    ASN1OctetString salt;

    private PBEParameter(ASN1Sequence arg2) {
        super();
        this.salt = arg2.getObjectAt(0);
        this.iterations = arg2.getObjectAt(1);
    }

    public PBEParameter(byte[] arg4, int arg5) {
        super();
        if(arg4.length != 8) {
            throw new IllegalArgumentException("salt length must be 8");
        }

        this.salt = new DEROctetString(arg4);
        this.iterations = new ASN1Integer(((long)arg5));
    }

    public static PBEParameter getInstance(Object arg2) {
        if(!(arg2 instanceof PBEParameter)) {
            if(arg2 != null) {
                PBEParameter v2 = new PBEParameter(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public BigInteger getIterationCount() {
        return this.iterations.getValue();
    }

    public byte[] getSalt() {
        return this.salt.getOctets();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.salt);
        v0.add(this.iterations);
        return new DERSequence(v0);
    }
}

