// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class PBES2Algorithms extends AlgorithmIdentifier implements PKCSObjectIdentifiers {
    private KeyDerivationFunc func;
    private ASN1ObjectIdentifier objectId;
    private EncryptionScheme scheme;

    public PBES2Algorithms(ASN1Sequence arg6) {
        super(arg6);
        Enumeration v1 = arg6.getObjects();
        this.objectId = v1.nextElement();
        v1 = v1.nextElement().getObjects();
        Object v0 = v1.nextElement();
        this.func = ((ASN1Sequence)v0).getObjectAt(0).equals(PBES2Algorithms.id_PBKDF2) ? new KeyDerivationFunc(PBES2Algorithms.id_PBKDF2, PBKDF2Params.getInstance(((ASN1Sequence)v0).getObjectAt(1))) : KeyDerivationFunc.getInstance(v0);
        this.scheme = EncryptionScheme.getInstance(v1.nextElement());
    }

    public ASN1Primitive getASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v0.add(this.objectId);
        v1.add(this.func);
        v1.add(this.scheme);
        v0.add(new DERSequence(v1));
        return new DERSequence(v0);
    }

    public EncryptionScheme getEncryptionScheme() {
        return this.scheme;
    }

    public KeyDerivationFunc getKeyDerivationFunc() {
        return this.func;
    }

    public ASN1ObjectIdentifier getObjectId() {
        return this.objectId;
    }
}

