// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class PBES2Parameters extends ASN1Object implements PKCSObjectIdentifiers {
    private KeyDerivationFunc func;
    private EncryptionScheme scheme;

    private PBES2Parameters(ASN1Sequence arg6) {
        super();
        Enumeration v1 = arg6.getObjects();
        ASN1Sequence v0 = ASN1Sequence.getInstance(v1.nextElement().toASN1Primitive());
        this.func = v0.getObjectAt(0).equals(PBES2Parameters.id_PBKDF2) ? new KeyDerivationFunc(PBES2Parameters.id_PBKDF2, PBKDF2Params.getInstance(v0.getObjectAt(1))) : KeyDerivationFunc.getInstance(v0);
        this.scheme = EncryptionScheme.getInstance(v1.nextElement());
    }

    public PBES2Parameters(KeyDerivationFunc arg1, EncryptionScheme arg2) {
        super();
        this.func = arg1;
        this.scheme = arg2;
    }

    public EncryptionScheme getEncryptionScheme() {
        return this.scheme;
    }

    public static PBES2Parameters getInstance(Object arg2) {
        PBES2Parameters v2;
        if(!(arg2 instanceof PBES2Parameters)) {
            if(arg2 != null) {
                v2 = new PBES2Parameters(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public KeyDerivationFunc getKeyDerivationFunc() {
        return this.func;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.func);
        v0.add(this.scheme);
        return new DERSequence(v0);
    }
}

