// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class PBKDF2Params extends ASN1Object {
    private ASN1Integer iterationCount;
    private ASN1Integer keyLength;
    private ASN1OctetString octStr;

    private PBKDF2Params(ASN1Sequence arg3) {
        super();
        Enumeration v1 = arg3.getObjects();
        this.octStr = v1.nextElement();
        this.iterationCount = v1.nextElement();
        this.keyLength = v1.hasMoreElements() ? v1.nextElement() : null;
    }

    public PBKDF2Params(byte[] arg4, int arg5) {
        super();
        this.octStr = new DEROctetString(arg4);
        this.iterationCount = new ASN1Integer(((long)arg5));
    }

    public PBKDF2Params(byte[] arg4, int arg5, int arg6) {
        this(arg4, arg5);
        this.keyLength = new ASN1Integer(((long)arg6));
    }

    public static PBKDF2Params getInstance(Object arg2) {
        PBKDF2Params v2;
        if(!(arg2 instanceof PBKDF2Params)) {
            if(arg2 != null) {
                v2 = new PBKDF2Params(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public BigInteger getIterationCount() {
        return this.iterationCount.getValue();
    }

    public BigInteger getKeyLength() {
        BigInteger v0 = this.keyLength != null ? this.keyLength.getValue() : null;
        return v0;
    }

    public byte[] getSalt() {
        return this.octStr.getOctets();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.octStr);
        v0.add(this.iterationCount);
        if(this.keyLength != null) {
            v0.add(this.keyLength);
        }

        return new DERSequence(v0);
    }
}

