// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.BERSequence;

public class Pfx extends ASN1Object implements PKCSObjectIdentifiers {
    private ContentInfo contentInfo;
    private MacData macData;

    private Pfx(ASN1Sequence arg3) {
        int v1 = 3;
        super();
        this.macData = null;
        if(arg3.getObjectAt(0).getValue().intValue() != v1) {
            throw new IllegalArgumentException("wrong version for PFX PDU");
        }

        this.contentInfo = ContentInfo.getInstance(arg3.getObjectAt(1));
        if(arg3.size() == v1) {
            this.macData = MacData.getInstance(arg3.getObjectAt(2));
        }
    }

    public Pfx(ContentInfo arg2, MacData arg3) {
        super();
        this.macData = null;
        this.contentInfo = arg2;
        this.macData = arg3;
    }

    public ContentInfo getAuthSafe() {
        return this.contentInfo;
    }

    public static Pfx getInstance(Object arg2) {
        if(!(arg2 instanceof Pfx)) {
            if(arg2 != null) {
                Pfx v2 = new Pfx(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public MacData getMacData() {
        return this.macData;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(3));
        v0.add(this.contentInfo);
        if(this.macData != null) {
            v0.add(this.macData);
        }

        return new BERSequence(v0);
    }
}

