// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.io.IOException;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class PrivateKeyInfo extends ASN1Object {
    private AlgorithmIdentifier algId;
    private ASN1Set attributes;
    private ASN1OctetString privKey;

    public PrivateKeyInfo(ASN1Sequence arg3) {
        super();
        Enumeration v1 = arg3.getObjects();
        if(v1.nextElement().getValue().intValue() != 0) {
            throw new IllegalArgumentException("wrong version for private key info");
        }

        this.algId = AlgorithmIdentifier.getInstance(v1.nextElement());
        this.privKey = ASN1OctetString.getInstance(v1.nextElement());
        if(v1.hasMoreElements()) {
            this.attributes = ASN1Set.getInstance(v1.nextElement(), false);
        }
    }

    public PrivateKeyInfo(AlgorithmIdentifier arg2, ASN1Encodable arg3) {
        this(arg2, arg3, null);
    }

    public PrivateKeyInfo(AlgorithmIdentifier arg4, ASN1Encodable arg5, ASN1Set arg6) {
        super();
        this.privKey = new DEROctetString(arg5.toASN1Primitive().getEncoded("DER"));
        this.algId = arg4;
        this.attributes = arg6;
    }

    public AlgorithmIdentifier getAlgorithmId() {
        return this.algId;
    }

    public ASN1Set getAttributes() {
        return this.attributes;
    }

    public static PrivateKeyInfo getInstance(Object arg2) {
        if(!(arg2 instanceof PrivateKeyInfo)) {
            if(arg2 != null) {
                PrivateKeyInfo v2 = new PrivateKeyInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static PrivateKeyInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return PrivateKeyInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Primitive getPrivateKey() {
        try {
            return this.parsePrivateKey().toASN1Primitive();
        }
        catch(IOException v0) {
            throw new IllegalStateException("unable to parse private key");
        }
    }

    public AlgorithmIdentifier getPrivateKeyAlgorithm() {
        return this.algId;
    }

    public ASN1Encodable parsePrivateKey() {
        return ASN1Primitive.fromByteArray(this.privKey.getOctets());
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(0));
        v0.add(this.algId);
        v0.add(this.privKey);
        if(this.attributes != null) {
            v0.add(new DERTaggedObject(false, 0, this.attributes));
        }

        return new DERSequence(v0);
    }
}

