// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class RC2CBCParameter extends ASN1Object {
    ASN1OctetString iv;
    ASN1Integer version;

    public RC2CBCParameter(int arg4, byte[] arg5) {
        super();
        this.version = new ASN1Integer(((long)arg4));
        this.iv = new DEROctetString(arg5);
    }

    private RC2CBCParameter(ASN1Sequence arg4) {
        super();
        if(arg4.size() == 1) {
            this.version = null;
            this.iv = arg4.getObjectAt(0);
        }
        else {
            this.version = arg4.getObjectAt(0);
            this.iv = arg4.getObjectAt(1);
        }
    }

    public RC2CBCParameter(byte[] arg2) {
        super();
        this.version = null;
        this.iv = new DEROctetString(arg2);
    }

    public byte[] getIV() {
        return this.iv.getOctets();
    }

    public static RC2CBCParameter getInstance(Object arg2) {
        if(!(arg2 instanceof RC2CBCParameter)) {
            if(arg2 != null) {
                RC2CBCParameter v2 = new RC2CBCParameter(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public BigInteger getRC2ParameterVersion() {
        BigInteger v0 = this.version == null ? null : this.version.getValue();
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.version != null) {
            v0.add(this.version);
        }

        v0.add(this.iv);
        return new DERSequence(v0);
    }
}

