// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class RSAESOAEPparams extends ASN1Object {
    public static final AlgorithmIdentifier DEFAULT_HASH_ALGORITHM;
    public static final AlgorithmIdentifier DEFAULT_MASK_GEN_FUNCTION;
    public static final AlgorithmIdentifier DEFAULT_P_SOURCE_ALGORITHM;
    private AlgorithmIdentifier hashAlgorithm;
    private AlgorithmIdentifier maskGenAlgorithm;
    private AlgorithmIdentifier pSourceAlgorithm;

    static {
        RSAESOAEPparams.DEFAULT_HASH_ALGORITHM = new AlgorithmIdentifier(OIWObjectIdentifiers.idSHA1, DERNull.INSTANCE);
        RSAESOAEPparams.DEFAULT_MASK_GEN_FUNCTION = new AlgorithmIdentifier(PKCSObjectIdentifiers.id_mgf1, RSAESOAEPparams.DEFAULT_HASH_ALGORITHM);
        RSAESOAEPparams.DEFAULT_P_SOURCE_ALGORITHM = new AlgorithmIdentifier(PKCSObjectIdentifiers.id_pSpecified, new DEROctetString(new byte[0]));
    }

    public RSAESOAEPparams() {
        super();
        this.hashAlgorithm = RSAESOAEPparams.DEFAULT_HASH_ALGORITHM;
        this.maskGenAlgorithm = RSAESOAEPparams.DEFAULT_MASK_GEN_FUNCTION;
        this.pSourceAlgorithm = RSAESOAEPparams.DEFAULT_P_SOURCE_ALGORITHM;
    }

    public RSAESOAEPparams(ASN1Sequence arg5) {
        super();
        this.hashAlgorithm = RSAESOAEPparams.DEFAULT_HASH_ALGORITHM;
        this.maskGenAlgorithm = RSAESOAEPparams.DEFAULT_MASK_GEN_FUNCTION;
        this.pSourceAlgorithm = RSAESOAEPparams.DEFAULT_P_SOURCE_ALGORITHM;
        int v1;
        for(v1 = 0; v1 != arg5.size(); ++v1) {
            ASN1Encodable v0 = arg5.getObjectAt(v1);
            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_19;
                }
                case 1: {
                    goto label_24;
                }
                case 2: {
                    goto label_27;
                }
            }

            throw new IllegalArgumentException("unknown tag");
        label_19:
            this.hashAlgorithm = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
            goto label_21;
        label_24:
            this.maskGenAlgorithm = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
            goto label_21;
        label_27:
            this.pSourceAlgorithm = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
        label_21:
        }
    }

    public RSAESOAEPparams(AlgorithmIdentifier arg1, AlgorithmIdentifier arg2, AlgorithmIdentifier arg3) {
        super();
        this.hashAlgorithm = arg1;
        this.maskGenAlgorithm = arg2;
        this.pSourceAlgorithm = arg3;
    }

    public AlgorithmIdentifier getHashAlgorithm() {
        return this.hashAlgorithm;
    }

    public static RSAESOAEPparams getInstance(Object arg2) {
        if(!(arg2 instanceof RSAESOAEPparams)) {
            if(arg2 != null) {
                RSAESOAEPparams v2 = new RSAESOAEPparams(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public AlgorithmIdentifier getMaskGenAlgorithm() {
        return this.maskGenAlgorithm;
    }

    public AlgorithmIdentifier getPSourceAlgorithm() {
        return this.pSourceAlgorithm;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(!this.hashAlgorithm.equals(RSAESOAEPparams.DEFAULT_HASH_ALGORITHM)) {
            v0.add(new DERTaggedObject(true, 0, this.hashAlgorithm));
        }

        if(!this.maskGenAlgorithm.equals(RSAESOAEPparams.DEFAULT_MASK_GEN_FUNCTION)) {
            v0.add(new DERTaggedObject(true, 1, this.maskGenAlgorithm));
        }

        if(!this.pSourceAlgorithm.equals(RSAESOAEPparams.DEFAULT_P_SOURCE_ALGORITHM)) {
            v0.add(new DERTaggedObject(true, 2, this.pSourceAlgorithm));
        }

        return new DERSequence(v0);
    }
}

