// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class RSAPrivateKey extends ASN1Object {
    private BigInteger coefficient;
    private BigInteger exponent1;
    private BigInteger exponent2;
    private BigInteger modulus;
    private ASN1Sequence otherPrimeInfos;
    private BigInteger prime1;
    private BigInteger prime2;
    private BigInteger privateExponent;
    private BigInteger publicExponent;
    private BigInteger version;

    public RSAPrivateKey(BigInteger arg3, BigInteger arg4, BigInteger arg5, BigInteger arg6, BigInteger arg7, BigInteger arg8, BigInteger arg9, BigInteger arg10) {
        super();
        this.otherPrimeInfos = null;
        this.version = BigInteger.valueOf(0);
        this.modulus = arg3;
        this.publicExponent = arg4;
        this.privateExponent = arg5;
        this.prime1 = arg6;
        this.prime2 = arg7;
        this.exponent1 = arg8;
        this.exponent2 = arg9;
        this.coefficient = arg10;
    }

    private RSAPrivateKey(ASN1Sequence arg5) {
        super();
        this.otherPrimeInfos = null;
        Enumeration v1 = arg5.getObjects();
        BigInteger v0 = v1.nextElement().getValue();
        if(v0.intValue() != 0 && v0.intValue() != 1) {
            throw new IllegalArgumentException("wrong version for RSA private key");
        }

        this.version = v0;
        this.modulus = v1.nextElement().getValue();
        this.publicExponent = v1.nextElement().getValue();
        this.privateExponent = v1.nextElement().getValue();
        this.prime1 = v1.nextElement().getValue();
        this.prime2 = v1.nextElement().getValue();
        this.exponent1 = v1.nextElement().getValue();
        this.exponent2 = v1.nextElement().getValue();
        this.coefficient = v1.nextElement().getValue();
        if(v1.hasMoreElements()) {
            this.otherPrimeInfos = v1.nextElement();
        }
    }

    public BigInteger getCoefficient() {
        return this.coefficient;
    }

    public BigInteger getExponent1() {
        return this.exponent1;
    }

    public BigInteger getExponent2() {
        return this.exponent2;
    }

    public static RSAPrivateKey getInstance(Object arg2) {
        if(!(arg2 instanceof RSAPrivateKey)) {
            if(arg2 != null) {
                RSAPrivateKey v2 = new RSAPrivateKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static RSAPrivateKey getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return RSAPrivateKey.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public BigInteger getModulus() {
        return this.modulus;
    }

    public BigInteger getPrime1() {
        return this.prime1;
    }

    public BigInteger getPrime2() {
        return this.prime2;
    }

    public BigInteger getPrivateExponent() {
        return this.privateExponent;
    }

    public BigInteger getPublicExponent() {
        return this.publicExponent;
    }

    public BigInteger getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(this.version));
        v0.add(new ASN1Integer(this.getModulus()));
        v0.add(new ASN1Integer(this.getPublicExponent()));
        v0.add(new ASN1Integer(this.getPrivateExponent()));
        v0.add(new ASN1Integer(this.getPrime1()));
        v0.add(new ASN1Integer(this.getPrime2()));
        v0.add(new ASN1Integer(this.getExponent1()));
        v0.add(new ASN1Integer(this.getExponent2()));
        v0.add(new ASN1Integer(this.getCoefficient()));
        if(this.otherPrimeInfos != null) {
            v0.add(this.otherPrimeInfos);
        }

        return new DERSequence(v0);
    }
}

