// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class RSASSAPSSparams extends ASN1Object {
    public static final AlgorithmIdentifier DEFAULT_HASH_ALGORITHM;
    public static final AlgorithmIdentifier DEFAULT_MASK_GEN_FUNCTION;
    public static final ASN1Integer DEFAULT_SALT_LENGTH;
    public static final ASN1Integer DEFAULT_TRAILER_FIELD;
    private AlgorithmIdentifier hashAlgorithm;
    private AlgorithmIdentifier maskGenAlgorithm;
    private ASN1Integer saltLength;
    private ASN1Integer trailerField;

    static {
        RSASSAPSSparams.DEFAULT_HASH_ALGORITHM = new AlgorithmIdentifier(OIWObjectIdentifiers.idSHA1, DERNull.INSTANCE);
        RSASSAPSSparams.DEFAULT_MASK_GEN_FUNCTION = new AlgorithmIdentifier(PKCSObjectIdentifiers.id_mgf1, RSASSAPSSparams.DEFAULT_HASH_ALGORITHM);
        RSASSAPSSparams.DEFAULT_SALT_LENGTH = new ASN1Integer(20);
        RSASSAPSSparams.DEFAULT_TRAILER_FIELD = new ASN1Integer(1);
    }

    public RSASSAPSSparams() {
        super();
        this.hashAlgorithm = RSASSAPSSparams.DEFAULT_HASH_ALGORITHM;
        this.maskGenAlgorithm = RSASSAPSSparams.DEFAULT_MASK_GEN_FUNCTION;
        this.saltLength = RSASSAPSSparams.DEFAULT_SALT_LENGTH;
        this.trailerField = RSASSAPSSparams.DEFAULT_TRAILER_FIELD;
    }

    private RSASSAPSSparams(ASN1Sequence arg5) {
        super();
        this.hashAlgorithm = RSASSAPSSparams.DEFAULT_HASH_ALGORITHM;
        this.maskGenAlgorithm = RSASSAPSSparams.DEFAULT_MASK_GEN_FUNCTION;
        this.saltLength = RSASSAPSSparams.DEFAULT_SALT_LENGTH;
        this.trailerField = RSASSAPSSparams.DEFAULT_TRAILER_FIELD;
        int v1;
        for(v1 = 0; v1 != arg5.size(); ++v1) {
            ASN1Encodable v0 = arg5.getObjectAt(v1);
            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_21;
                }
                case 1: {
                    goto label_26;
                }
                case 2: {
                    goto label_29;
                }
                case 3: {
                    goto label_32;
                }
            }

            throw new IllegalArgumentException("unknown tag");
        label_21:
            this.hashAlgorithm = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
            goto label_23;
        label_26:
            this.maskGenAlgorithm = AlgorithmIdentifier.getInstance(((ASN1TaggedObject)v0), true);
            goto label_23;
        label_32:
            this.trailerField = ASN1Integer.getInstance(((ASN1TaggedObject)v0), true);
            goto label_23;
        label_29:
            this.saltLength = ASN1Integer.getInstance(((ASN1TaggedObject)v0), true);
        label_23:
        }
    }

    public RSASSAPSSparams(AlgorithmIdentifier arg1, AlgorithmIdentifier arg2, ASN1Integer arg3, ASN1Integer arg4) {
        super();
        this.hashAlgorithm = arg1;
        this.maskGenAlgorithm = arg2;
        this.saltLength = arg3;
        this.trailerField = arg4;
    }

    public AlgorithmIdentifier getHashAlgorithm() {
        return this.hashAlgorithm;
    }

    public static RSASSAPSSparams getInstance(Object arg2) {
        RSASSAPSSparams v2;
        if(!(arg2 instanceof RSASSAPSSparams)) {
            if(arg2 != null) {
                v2 = new RSASSAPSSparams(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public AlgorithmIdentifier getMaskGenAlgorithm() {
        return this.maskGenAlgorithm;
    }

    public BigInteger getSaltLength() {
        return this.saltLength.getValue();
    }

    public BigInteger getTrailerField() {
        return this.trailerField.getValue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(!this.hashAlgorithm.equals(RSASSAPSSparams.DEFAULT_HASH_ALGORITHM)) {
            v0.add(new DERTaggedObject(true, 0, this.hashAlgorithm));
        }

        if(!this.maskGenAlgorithm.equals(RSASSAPSSparams.DEFAULT_MASK_GEN_FUNCTION)) {
            v0.add(new DERTaggedObject(true, 1, this.maskGenAlgorithm));
        }

        if(!this.saltLength.equals(RSASSAPSSparams.DEFAULT_SALT_LENGTH)) {
            v0.add(new DERTaggedObject(true, 2, this.saltLength));
        }

        if(!this.trailerField.equals(RSASSAPSSparams.DEFAULT_TRAILER_FIELD)) {
            v0.add(new DERTaggedObject(true, 3, this.trailerField));
        }

        return new DERSequence(v0);
    }
}

