// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DLSequence;
import org.bouncycastle.asn1.DLTaggedObject;

public class SafeBag extends ASN1Object {
    private ASN1Set bagAttributes;
    private ASN1ObjectIdentifier bagId;
    private ASN1Encodable bagValue;

    public SafeBag(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        super();
        this.bagId = arg2;
        this.bagValue = arg3;
        this.bagAttributes = null;
    }

    public SafeBag(ASN1ObjectIdentifier arg1, ASN1Encodable arg2, ASN1Set arg3) {
        super();
        this.bagId = arg1;
        this.bagValue = arg2;
        this.bagAttributes = arg3;
    }

    private SafeBag(ASN1Sequence arg3) {
        super();
        this.bagId = arg3.getObjectAt(0);
        this.bagValue = arg3.getObjectAt(1).getObject();
        if(arg3.size() == 3) {
            this.bagAttributes = arg3.getObjectAt(2);
        }
    }

    public ASN1Set getBagAttributes() {
        return this.bagAttributes;
    }

    public ASN1ObjectIdentifier getBagId() {
        return this.bagId;
    }

    public ASN1Encodable getBagValue() {
        return this.bagValue;
    }

    public static SafeBag getInstance(Object arg2) {
        if(!(arg2 instanceof SafeBag)) {
            if(arg2 != null) {
                SafeBag v2 = new SafeBag(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.bagId);
        v0.add(new DLTaggedObject(true, 0, this.bagValue));
        if(this.bagAttributes != null) {
            v0.add(this.bagAttributes);
        }

        return new DLSequence(v0);
    }
}

