// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.pkcs;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class SignedData extends ASN1Object implements PKCSObjectIdentifiers {
    private ASN1Set certificates;
    private ContentInfo contentInfo;
    private ASN1Set crls;
    private ASN1Set digestAlgorithms;
    private ASN1Set signerInfos;
    private ASN1Integer version;

    public SignedData(ASN1Integer arg1, ASN1Set arg2, ContentInfo arg3, ASN1Set arg4, ASN1Set arg5, ASN1Set arg6) {
        super();
        this.version = arg1;
        this.digestAlgorithms = arg2;
        this.contentInfo = arg3;
        this.certificates = arg4;
        this.crls = arg5;
        this.signerInfos = arg6;
    }

    public SignedData(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        this.version = v1.nextElement();
        this.digestAlgorithms = v1.nextElement();
        this.contentInfo = ContentInfo.getInstance(v1.nextElement());
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            if(!(v0 instanceof ASN1TaggedObject)) {
                goto label_33;
            }

            switch(((ASN1TaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_27;
                }
                case 1: {
                    goto label_30;
                }
            }

            throw new IllegalArgumentException("unknown tag value " + ((ASN1TaggedObject)v0).getTagNo());
        label_27:
            this.certificates = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_30:
            this.crls = ASN1Set.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_33:
            this.signerInfos = ((ASN1Set)v0);
        }
    }

    public ASN1Set getCRLs() {
        return this.crls;
    }

    public ASN1Set getCertificates() {
        return this.certificates;
    }

    public ContentInfo getContentInfo() {
        return this.contentInfo;
    }

    public ASN1Set getDigestAlgorithms() {
        return this.digestAlgorithms;
    }

    public static SignedData getInstance(Object arg2) {
        if(!(arg2 instanceof SignedData)) {
            if(arg2 != null) {
                SignedData v2 = new SignedData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Set getSignerInfos() {
        return this.signerInfos;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.digestAlgorithms);
        v0.add(this.contentInfo);
        if(this.certificates != null) {
            v0.add(new DERTaggedObject(false, 0, this.certificates));
        }

        if(this.crls != null) {
            v0.add(new DERTaggedObject(false, 1, this.crls));
        }

        v0.add(this.signerInfos);
        return new BERSequence(v0);
    }
}

