// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.sec;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.util.BigIntegers;

public class ECPrivateKey extends ASN1Object {
    private ASN1Sequence seq;

    public ECPrivateKey(BigInteger arg6) {
        super();
        byte[] v0 = BigIntegers.asUnsignedByteArray(arg6);
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(new ASN1Integer(1));
        v1.add(new DEROctetString(v0));
        this.seq = new DERSequence(v1);
    }

    public ECPrivateKey(BigInteger arg2, ASN1Object arg3) {
        this(arg2, null, arg3);
    }

    public ECPrivateKey(BigInteger arg7, DERBitString arg8, ASN1Object arg9) {
        super();
        byte[] v0 = BigIntegers.asUnsignedByteArray(arg7);
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(new ASN1Integer(1));
        v1.add(new DEROctetString(v0));
        if(arg9 != null) {
            v1.add(new DERTaggedObject(true, 0, ((ASN1Encodable)arg9)));
        }

        if(arg8 != null) {
            v1.add(new DERTaggedObject(true, 1, ((ASN1Encodable)arg8)));
        }

        this.seq = new DERSequence(v1);
    }

    private ECPrivateKey(ASN1Sequence arg1) {
        super();
        this.seq = arg1;
    }

    public static ECPrivateKey getInstance(Object arg2) {
        if(!(arg2 instanceof ECPrivateKey)) {
            if(arg2 != null) {
                ECPrivateKey v2 = new ECPrivateKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public BigInteger getKey() {
        return new BigInteger(1, this.seq.getObjectAt(1).getOctets());
    }

    private ASN1Primitive getObjectInTag(int arg4) {
        Object v0;
        Enumeration v1 = this.seq.getObjects();
        do {
            if(v1.hasMoreElements()) {
                v0 = v1.nextElement();
                if(!(v0 instanceof ASN1TaggedObject)) {
                    continue;
                }

                if(((ASN1TaggedObject)v0).getTagNo() != arg4) {
                    continue;
                }

                break;
            }
            else {
                return null;
            }
        }
        while(true);

        ASN1Primitive v0_1 = ((ASN1TaggedObject)v0).getObject().toASN1Primitive();
        return v0_1;
    }

    public ASN1Primitive getParameters() {
        return this.getObjectInTag(0);
    }

    public DERBitString getPublicKey() {
        return this.getObjectInTag(1);
    }

    public ASN1Primitive toASN1Primitive() {
        return this.seq;
    }
}

