// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.sec;

import java.math.BigInteger;
import java.util.Enumeration;
import java.util.Hashtable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ECParametersHolder;
import org.bouncycastle.util.Strings;
import org.bouncycastle.util.encoders.Hex;

public class SECNamedCurves {
    static final Hashtable curves;
    static final Hashtable names;
    static final Hashtable objIds;
    static X9ECParametersHolder secp112r1;
    static X9ECParametersHolder secp112r2;
    static X9ECParametersHolder secp128r1;
    static X9ECParametersHolder secp128r2;
    static X9ECParametersHolder secp160k1;
    static X9ECParametersHolder secp160r1;
    static X9ECParametersHolder secp160r2;
    static X9ECParametersHolder secp192k1;
    static X9ECParametersHolder secp192r1;
    static X9ECParametersHolder secp224k1;
    static X9ECParametersHolder secp224r1;
    static X9ECParametersHolder secp256k1;
    static X9ECParametersHolder secp256r1;
    static X9ECParametersHolder secp384r1;
    static X9ECParametersHolder secp521r1;
    static X9ECParametersHolder sect113r1;
    static X9ECParametersHolder sect113r2;
    static X9ECParametersHolder sect131r1;
    static X9ECParametersHolder sect131r2;
    static X9ECParametersHolder sect163k1;
    static X9ECParametersHolder sect163r1;
    static X9ECParametersHolder sect163r2;
    static X9ECParametersHolder sect193r1;
    static X9ECParametersHolder sect193r2;
    static X9ECParametersHolder sect233k1;
    static X9ECParametersHolder sect233r1;
    static X9ECParametersHolder sect239k1;
    static X9ECParametersHolder sect283k1;
    static X9ECParametersHolder sect283r1;
    static X9ECParametersHolder sect409k1;
    static X9ECParametersHolder sect409r1;
    static X9ECParametersHolder sect571k1;
    static X9ECParametersHolder sect571r1;

    static {
        SECNamedCurves.secp112r1 = new SECNamedCurves$1();
        SECNamedCurves.secp112r2 = new SECNamedCurves$2();
        SECNamedCurves.secp128r1 = new SECNamedCurves$3();
        SECNamedCurves.secp128r2 = new SECNamedCurves$4();
        SECNamedCurves.secp160k1 = new SECNamedCurves$5();
        SECNamedCurves.secp160r1 = new SECNamedCurves$6();
        SECNamedCurves.secp160r2 = new SECNamedCurves$7();
        SECNamedCurves.secp192k1 = new SECNamedCurves$8();
        SECNamedCurves.secp192r1 = new SECNamedCurves$9();
        SECNamedCurves.secp224k1 = new SECNamedCurves$10();
        SECNamedCurves.secp224r1 = new SECNamedCurves$11();
        SECNamedCurves.secp256k1 = new SECNamedCurves$12();
        SECNamedCurves.secp256r1 = new SECNamedCurves$13();
        SECNamedCurves.secp384r1 = new SECNamedCurves$14();
        SECNamedCurves.secp521r1 = new SECNamedCurves$15();
        SECNamedCurves.sect113r1 = new SECNamedCurves$16();
        SECNamedCurves.sect113r2 = new SECNamedCurves$17();
        SECNamedCurves.sect131r1 = new SECNamedCurves$18();
        SECNamedCurves.sect131r2 = new SECNamedCurves$19();
        SECNamedCurves.sect163k1 = new SECNamedCurves$20();
        SECNamedCurves.sect163r1 = new SECNamedCurves$21();
        SECNamedCurves.sect163r2 = new SECNamedCurves$22();
        SECNamedCurves.sect193r1 = new SECNamedCurves$23();
        SECNamedCurves.sect193r2 = new SECNamedCurves$24();
        SECNamedCurves.sect233k1 = new SECNamedCurves$25();
        SECNamedCurves.sect233r1 = new SECNamedCurves$26();
        SECNamedCurves.sect239k1 = new SECNamedCurves$27();
        SECNamedCurves.sect283k1 = new SECNamedCurves$28();
        SECNamedCurves.sect283r1 = new SECNamedCurves$29();
        SECNamedCurves.sect409k1 = new SECNamedCurves$30();
        SECNamedCurves.sect409r1 = new SECNamedCurves$31();
        SECNamedCurves.sect571k1 = new SECNamedCurves$32();
        SECNamedCurves.sect571r1 = new SECNamedCurves$33();
        SECNamedCurves.objIds = new Hashtable();
        SECNamedCurves.curves = new Hashtable();
        SECNamedCurves.names = new Hashtable();
        SECNamedCurves.defineCurve("secp112r1", SECObjectIdentifiers.secp112r1, SECNamedCurves.secp112r1);
        SECNamedCurves.defineCurve("secp112r2", SECObjectIdentifiers.secp112r2, SECNamedCurves.secp112r2);
        SECNamedCurves.defineCurve("secp128r1", SECObjectIdentifiers.secp128r1, SECNamedCurves.secp128r1);
        SECNamedCurves.defineCurve("secp128r2", SECObjectIdentifiers.secp128r2, SECNamedCurves.secp128r2);
        SECNamedCurves.defineCurve("secp160k1", SECObjectIdentifiers.secp160k1, SECNamedCurves.secp160k1);
        SECNamedCurves.defineCurve("secp160r1", SECObjectIdentifiers.secp160r1, SECNamedCurves.secp160r1);
        SECNamedCurves.defineCurve("secp160r2", SECObjectIdentifiers.secp160r2, SECNamedCurves.secp160r2);
        SECNamedCurves.defineCurve("secp192k1", SECObjectIdentifiers.secp192k1, SECNamedCurves.secp192k1);
        SECNamedCurves.defineCurve("secp192r1", SECObjectIdentifiers.secp192r1, SECNamedCurves.secp192r1);
        SECNamedCurves.defineCurve("secp224k1", SECObjectIdentifiers.secp224k1, SECNamedCurves.secp224k1);
        SECNamedCurves.defineCurve("secp224r1", SECObjectIdentifiers.secp224r1, SECNamedCurves.secp224r1);
        SECNamedCurves.defineCurve("secp256k1", SECObjectIdentifiers.secp256k1, SECNamedCurves.secp256k1);
        SECNamedCurves.defineCurve("secp256r1", SECObjectIdentifiers.secp256r1, SECNamedCurves.secp256r1);
        SECNamedCurves.defineCurve("secp384r1", SECObjectIdentifiers.secp384r1, SECNamedCurves.secp384r1);
        SECNamedCurves.defineCurve("secp521r1", SECObjectIdentifiers.secp521r1, SECNamedCurves.secp521r1);
        SECNamedCurves.defineCurve("sect113r1", SECObjectIdentifiers.sect113r1, SECNamedCurves.sect113r1);
        SECNamedCurves.defineCurve("sect113r2", SECObjectIdentifiers.sect113r2, SECNamedCurves.sect113r2);
        SECNamedCurves.defineCurve("sect131r1", SECObjectIdentifiers.sect131r1, SECNamedCurves.sect131r1);
        SECNamedCurves.defineCurve("sect131r2", SECObjectIdentifiers.sect131r2, SECNamedCurves.sect131r2);
        SECNamedCurves.defineCurve("sect163k1", SECObjectIdentifiers.sect163k1, SECNamedCurves.sect163k1);
        SECNamedCurves.defineCurve("sect163r1", SECObjectIdentifiers.sect163r1, SECNamedCurves.sect163r1);
        SECNamedCurves.defineCurve("sect163r2", SECObjectIdentifiers.sect163r2, SECNamedCurves.sect163r2);
        SECNamedCurves.defineCurve("sect193r1", SECObjectIdentifiers.sect193r1, SECNamedCurves.sect193r1);
        SECNamedCurves.defineCurve("sect193r2", SECObjectIdentifiers.sect193r2, SECNamedCurves.sect193r2);
        SECNamedCurves.defineCurve("sect233k1", SECObjectIdentifiers.sect233k1, SECNamedCurves.sect233k1);
        SECNamedCurves.defineCurve("sect233r1", SECObjectIdentifiers.sect233r1, SECNamedCurves.sect233r1);
        SECNamedCurves.defineCurve("sect239k1", SECObjectIdentifiers.sect239k1, SECNamedCurves.sect239k1);
        SECNamedCurves.defineCurve("sect283k1", SECObjectIdentifiers.sect283k1, SECNamedCurves.sect283k1);
        SECNamedCurves.defineCurve("sect283r1", SECObjectIdentifiers.sect283r1, SECNamedCurves.sect283r1);
        SECNamedCurves.defineCurve("sect409k1", SECObjectIdentifiers.sect409k1, SECNamedCurves.sect409k1);
        SECNamedCurves.defineCurve("sect409r1", SECObjectIdentifiers.sect409r1, SECNamedCurves.sect409r1);
        SECNamedCurves.defineCurve("sect571k1", SECObjectIdentifiers.sect571k1, SECNamedCurves.sect571k1);
        SECNamedCurves.defineCurve("sect571r1", SECObjectIdentifiers.sect571r1, SECNamedCurves.sect571r1);
    }

    public SECNamedCurves() {
        super();
    }

    static BigInteger access$000(String arg1) {
        return SECNamedCurves.fromHex(arg1);
    }

    static void defineCurve(String arg1, ASN1ObjectIdentifier arg2, X9ECParametersHolder arg3) {
        SECNamedCurves.objIds.put(arg1, arg2);
        SECNamedCurves.names.put(arg2, arg1);
        SECNamedCurves.curves.put(arg2, arg3);
    }

    private static BigInteger fromHex(String arg3) {
        return new BigInteger(1, Hex.decode(arg3));
    }

    public static X9ECParameters getByName(String arg2) {
        Object v0 = SECNamedCurves.objIds.get(Strings.toLowerCase(arg2));
        X9ECParameters v0_1 = v0 != null ? SECNamedCurves.getByOID(((ASN1ObjectIdentifier)v0)) : null;
        return v0_1;
    }

    public static X9ECParameters getByOID(ASN1ObjectIdentifier arg1) {
        Object v0 = SECNamedCurves.curves.get(arg1);
        X9ECParameters v0_1 = v0 != null ? ((X9ECParametersHolder)v0).getParameters() : null;
        return v0_1;
    }

    public static String getName(ASN1ObjectIdentifier arg1) {
        return SECNamedCurves.names.get(arg1);
    }

    public static Enumeration getNames() {
        return SECNamedCurves.objIds.keys();
    }

    public static ASN1ObjectIdentifier getOID(String arg2) {
        return SECNamedCurves.objIds.get(Strings.toLowerCase(arg2));
    }
}

