// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.smime;

import java.util.Enumeration;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.cms.Attribute;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;

public class SMIMECapabilities extends ASN1Object {
    public static final ASN1ObjectIdentifier canNotDecryptAny;
    private ASN1Sequence capabilities;
    public static final ASN1ObjectIdentifier dES_CBC;
    public static final ASN1ObjectIdentifier dES_EDE3_CBC;
    public static final ASN1ObjectIdentifier preferSignedData;
    public static final ASN1ObjectIdentifier rC2_CBC;
    public static final ASN1ObjectIdentifier sMIMECapabilitesVersions;

    static {
        SMIMECapabilities.preferSignedData = PKCSObjectIdentifiers.preferSignedData;
        SMIMECapabilities.canNotDecryptAny = PKCSObjectIdentifiers.canNotDecryptAny;
        SMIMECapabilities.sMIMECapabilitesVersions = PKCSObjectIdentifiers.sMIMECapabilitiesVersions;
        SMIMECapabilities.dES_CBC = new ASN1ObjectIdentifier("1.3.14.3.2.7");
        SMIMECapabilities.dES_EDE3_CBC = PKCSObjectIdentifiers.des_EDE3_CBC;
        SMIMECapabilities.rC2_CBC = PKCSObjectIdentifiers.RC2_CBC;
    }

    public SMIMECapabilities(ASN1Sequence arg1) {
        super();
        this.capabilities = arg1;
    }

    public Vector getCapabilities(ASN1ObjectIdentifier arg5) {
        Enumeration v0 = this.capabilities.getObjects();
        Vector v1 = new Vector();
        if(arg5 == null) {
            while(v0.hasMoreElements()) {
                v1.addElement(SMIMECapability.getInstance(v0.nextElement()));
            }
        }
        else {
            while(v0.hasMoreElements()) {
                SMIMECapability v2 = SMIMECapability.getInstance(v0.nextElement());
                if(!arg5.equals(v2.getCapabilityID())) {
                    continue;
                }

                v1.addElement(v2);
            }
        }

        return v1;
    }

    public static SMIMECapabilities getInstance(Object arg3) {
        SMIMECapabilities v3;
        if(arg3 != null && !(arg3 instanceof SMIMECapabilities)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new SMIMECapabilities(((ASN1Sequence)arg3));
            }
            else if((arg3 instanceof Attribute)) {
                v3 = new SMIMECapabilities(((Attribute)arg3).getAttrValues().getObjectAt(0));
            }
            else {
                throw new IllegalArgumentException("unknown object in factory: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public ASN1Primitive toASN1Primitive() {
        return this.capabilities;
    }
}

