// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.smime;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.nist.NISTObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;

public class SMIMECapability extends ASN1Object {
    public static final ASN1ObjectIdentifier aES128_CBC;
    public static final ASN1ObjectIdentifier aES192_CBC;
    public static final ASN1ObjectIdentifier aES256_CBC;
    public static final ASN1ObjectIdentifier canNotDecryptAny;
    private ASN1ObjectIdentifier capabilityID;
    public static final ASN1ObjectIdentifier dES_CBC;
    public static final ASN1ObjectIdentifier dES_EDE3_CBC;
    private ASN1Encodable parameters;
    public static final ASN1ObjectIdentifier preferSignedData;
    public static final ASN1ObjectIdentifier rC2_CBC;
    public static final ASN1ObjectIdentifier sMIMECapabilitiesVersions;

    static {
        SMIMECapability.preferSignedData = PKCSObjectIdentifiers.preferSignedData;
        SMIMECapability.canNotDecryptAny = PKCSObjectIdentifiers.canNotDecryptAny;
        SMIMECapability.sMIMECapabilitiesVersions = PKCSObjectIdentifiers.sMIMECapabilitiesVersions;
        SMIMECapability.dES_CBC = new ASN1ObjectIdentifier("1.3.14.3.2.7");
        SMIMECapability.dES_EDE3_CBC = PKCSObjectIdentifiers.des_EDE3_CBC;
        SMIMECapability.rC2_CBC = PKCSObjectIdentifiers.RC2_CBC;
        SMIMECapability.aES128_CBC = NISTObjectIdentifiers.id_aes128_CBC;
        SMIMECapability.aES192_CBC = NISTObjectIdentifiers.id_aes192_CBC;
        SMIMECapability.aES256_CBC = NISTObjectIdentifiers.id_aes256_CBC;
    }

    public SMIMECapability(ASN1ObjectIdentifier arg1, ASN1Encodable arg2) {
        super();
        this.capabilityID = arg1;
        this.parameters = arg2;
    }

    public SMIMECapability(ASN1Sequence arg3) {
        super();
        this.capabilityID = arg3.getObjectAt(0);
        if(arg3.size() > 1) {
            this.parameters = arg3.getObjectAt(1);
        }
    }

    public ASN1ObjectIdentifier getCapabilityID() {
        return this.capabilityID;
    }

    public static SMIMECapability getInstance(Object arg2) {
        SMIMECapability v2;
        if(arg2 != null && !(arg2 instanceof SMIMECapability)) {
            if((arg2 instanceof ASN1Sequence)) {
                v2 = new SMIMECapability(((ASN1Sequence)arg2));
            }
            else {
                throw new IllegalArgumentException("Invalid SMIMECapability");
            }
        }

        return v2;
    }

    public ASN1Encodable getParameters() {
        return this.parameters;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.capabilityID);
        if(this.parameters != null) {
            v0.add(this.parameters);
        }

        return new DERSequence(v0);
    }
}

