// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.tsp;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.GeneralName;

public class TSTInfo extends ASN1Object {
    private Accuracy accuracy;
    private Extensions extensions;
    private ASN1GeneralizedTime genTime;
    private MessageImprint messageImprint;
    private ASN1Integer nonce;
    private ASN1Boolean ordering;
    private ASN1Integer serialNumber;
    private GeneralName tsa;
    private ASN1ObjectIdentifier tsaPolicyId;
    private ASN1Integer version;

    public TSTInfo(ASN1ObjectIdentifier arg4, MessageImprint arg5, ASN1Integer arg6, ASN1GeneralizedTime arg7, Accuracy arg8, ASN1Boolean arg9, ASN1Integer arg10, GeneralName arg11, Extensions arg12) {
        super();
        this.version = new ASN1Integer(1);
        this.tsaPolicyId = arg4;
        this.messageImprint = arg5;
        this.serialNumber = arg6;
        this.genTime = arg7;
        this.accuracy = arg8;
        this.ordering = arg9;
        this.nonce = arg10;
        this.tsa = arg11;
        this.extensions = arg12;
    }

    private TSTInfo(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        this.version = ASN1Integer.getInstance(v1.nextElement());
        this.tsaPolicyId = ASN1ObjectIdentifier.getInstance(v1.nextElement());
        this.messageImprint = MessageImprint.getInstance(v1.nextElement());
        this.serialNumber = ASN1Integer.getInstance(v1.nextElement());
        this.genTime = ASN1GeneralizedTime.getInstance(v1.nextElement());
        this.ordering = ASN1Boolean.getInstance(false);
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            if(!(v0 instanceof ASN1TaggedObject)) {
                goto label_44;
            }

            switch(((DERTaggedObject)v0).getTagNo()) {
                case 0: {
                    goto label_37;
                }
                case 1: {
                    goto label_41;
                }
            }

            throw new IllegalArgumentException("Unknown tag value " + ((DERTaggedObject)v0).getTagNo());
        label_37:
            this.tsa = GeneralName.getInstance(((ASN1TaggedObject)v0), true);
            continue;
        label_41:
            this.extensions = Extensions.getInstance(((ASN1TaggedObject)v0), false);
            continue;
        label_44:
            if(!(v0 instanceof ASN1Sequence) && !(v0 instanceof Accuracy)) {
                if((v0 instanceof ASN1Boolean)) {
                    this.ordering = ASN1Boolean.getInstance(v0);
                }
                else {
                    if(!(v0 instanceof ASN1Integer)) {
                        continue;
                    }

                    this.nonce = ASN1Integer.getInstance(v0);
                }

                continue;
            }

            this.accuracy = Accuracy.getInstance(v0);
        }
    }

    public Accuracy getAccuracy() {
        return this.accuracy;
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public ASN1GeneralizedTime getGenTime() {
        return this.genTime;
    }

    public static TSTInfo getInstance(Object arg2) {
        if(!(arg2 instanceof TSTInfo)) {
            if(arg2 != null) {
                TSTInfo v2 = new TSTInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public MessageImprint getMessageImprint() {
        return this.messageImprint;
    }

    public ASN1Integer getNonce() {
        return this.nonce;
    }

    public ASN1Boolean getOrdering() {
        return this.ordering;
    }

    public ASN1ObjectIdentifier getPolicy() {
        return this.tsaPolicyId;
    }

    public ASN1Integer getSerialNumber() {
        return this.serialNumber;
    }

    public GeneralName getTsa() {
        return this.tsa;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.tsaPolicyId);
        v0.add(this.messageImprint);
        v0.add(this.serialNumber);
        v0.add(this.genTime);
        if(this.accuracy != null) {
            v0.add(this.accuracy);
        }

        if(this.ordering != null && (this.ordering.isTrue())) {
            v0.add(this.ordering);
        }

        if(this.nonce != null) {
            v0.add(this.nonce);
        }

        if(this.tsa != null) {
            v0.add(new DERTaggedObject(true, 0, this.tsa));
        }

        if(this.extensions != null) {
            v0.add(new DERTaggedObject(false, 1, this.extensions));
        }

        return new DERSequence(v0);
    }
}

