// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.tsp;

import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.Extensions;

public class TimeStampReq extends ASN1Object {
    ASN1Boolean certReq;
    Extensions extensions;
    MessageImprint messageImprint;
    ASN1Integer nonce;
    ASN1ObjectIdentifier tsaPolicy;
    ASN1Integer version;

    private TimeStampReq(ASN1Sequence arg6) {
        super();
        int v2 = arg6.size();
        this.version = ASN1Integer.getInstance(arg6.getObjectAt(0));
        this.messageImprint = MessageImprint.getInstance(arg6.getObjectAt(1));
        int v1;
        for(v1 = 2; v1 < v2; ++v1) {
            if((arg6.getObjectAt(v1) instanceof ASN1ObjectIdentifier)) {
                this.tsaPolicy = ASN1ObjectIdentifier.getInstance(arg6.getObjectAt(v1));
            }
            else if((arg6.getObjectAt(v1) instanceof ASN1Integer)) {
                this.nonce = ASN1Integer.getInstance(arg6.getObjectAt(v1));
            }
            else if((arg6.getObjectAt(v1) instanceof ASN1Boolean)) {
                this.certReq = ASN1Boolean.getInstance(arg6.getObjectAt(v1));
            }
            else if((arg6.getObjectAt(v1) instanceof ASN1TaggedObject)) {
                ASN1Encodable v0 = arg6.getObjectAt(v1);
                if(((ASN1TaggedObject)v0).getTagNo() == 0) {
                    this.extensions = Extensions.getInstance(((ASN1TaggedObject)v0), false);
                }
            }
        }
    }

    public TimeStampReq(MessageImprint arg4, ASN1ObjectIdentifier arg5, ASN1Integer arg6, ASN1Boolean arg7, Extensions arg8) {
        super();
        this.version = new ASN1Integer(1);
        this.messageImprint = arg4;
        this.tsaPolicy = arg5;
        this.nonce = arg6;
        this.certReq = arg7;
        this.extensions = arg8;
    }

    public ASN1Boolean getCertReq() {
        return this.certReq;
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public static TimeStampReq getInstance(Object arg2) {
        if(!(arg2 instanceof TimeStampReq)) {
            if(arg2 != null) {
                TimeStampReq v2 = new TimeStampReq(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public MessageImprint getMessageImprint() {
        return this.messageImprint;
    }

    public ASN1Integer getNonce() {
        return this.nonce;
    }

    public ASN1ObjectIdentifier getReqPolicy() {
        return this.tsaPolicy;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.messageImprint);
        if(this.tsaPolicy != null) {
            v0.add(this.tsaPolicy);
        }

        if(this.nonce != null) {
            v0.add(this.nonce);
        }

        if(this.certReq != null && (this.certReq.isTrue())) {
            v0.add(this.certReq);
        }

        if(this.extensions != null) {
            v0.add(new DERTaggedObject(false, 0, this.extensions));
        }

        return new DERSequence(v0);
    }
}

