// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ua;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x9.X9IntegerConverter;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECCurve$F2m;
import org.bouncycastle.util.Arrays;

public class DSTU4145ECBinary extends ASN1Object {
    ASN1Integer a;
    ASN1OctetString b;
    ASN1OctetString bp;
    DSTU4145BinaryField f;
    ASN1Integer n;
    BigInteger version;

    private DSTU4145ECBinary(ASN1Sequence arg3) {
        super();
        this.version = BigInteger.valueOf(0);
        int v0 = 0;
        if((arg3.getObjectAt(0) instanceof ASN1TaggedObject)) {
            ASN1Encodable v0_1 = arg3.getObjectAt(0);
            if((((ASN1TaggedObject)v0_1).isExplicit()) && ((ASN1TaggedObject)v0_1).getTagNo() == 0) {
                this.version = ASN1Integer.getInstance(((ASN1TaggedObject)v0_1).getLoadedObject()).getValue();
                v0 = 1;
                goto label_18;
            }

            throw new IllegalArgumentException("object parse error");
        }

    label_18:
        this.f = DSTU4145BinaryField.getInstance(arg3.getObjectAt(v0));
        ++v0;
        this.a = ASN1Integer.getInstance(arg3.getObjectAt(v0));
        ++v0;
        this.b = ASN1OctetString.getInstance(arg3.getObjectAt(v0));
        ++v0;
        this.n = ASN1Integer.getInstance(arg3.getObjectAt(v0));
        this.bp = ASN1OctetString.getInstance(arg3.getObjectAt(v0 + 1));
    }

    public DSTU4145ECBinary(ECDomainParameters arg7) {
        super();
        this.version = BigInteger.valueOf(0);
        if(!(arg7.getCurve() instanceof ECCurve$F2m)) {
            throw new IllegalArgumentException("only binary domain is possible");
        }

        ECCurve v0 = arg7.getCurve();
        this.f = new DSTU4145BinaryField(((ECCurve$F2m)v0).getM(), ((ECCurve$F2m)v0).getK1(), ((ECCurve$F2m)v0).getK2(), ((ECCurve$F2m)v0).getK3());
        this.a = new ASN1Integer(((ECCurve$F2m)v0).getA().toBigInteger());
        X9IntegerConverter v1 = new X9IntegerConverter();
        this.b = new DEROctetString(v1.integerToBytes(((ECCurve$F2m)v0).getB().toBigInteger(), v1.getByteLength(v0)));
        this.n = new ASN1Integer(arg7.getN());
        this.bp = new DEROctetString(DSTU4145PointEncoder.encodePoint(arg7.getG()));
    }

    public BigInteger getA() {
        return this.a.getValue();
    }

    public byte[] getB() {
        return Arrays.clone(this.b.getOctets());
    }

    public DSTU4145BinaryField getField() {
        return this.f;
    }

    public byte[] getG() {
        return Arrays.clone(this.bp.getOctets());
    }

    public static DSTU4145ECBinary getInstance(Object arg2) {
        if(!(arg2 instanceof DSTU4145ECBinary)) {
            if(arg2 != null) {
                DSTU4145ECBinary v2 = new DSTU4145ECBinary(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public BigInteger getN() {
        return this.n.getValue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.version.compareTo(BigInteger.valueOf(0)) != 0) {
            v0.add(new DERTaggedObject(true, 0, new ASN1Integer(this.version)));
        }

        v0.add(this.f);
        v0.add(this.a);
        v0.add(this.b);
        v0.add(this.n);
        v0.add(this.bp);
        return new DERSequence(v0);
    }
}

