// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ua;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.util.Arrays;

public class DSTU4145Params extends ASN1Object {
    private static final byte[] DEFAULT_DKE;
    private byte[] dke;
    private DSTU4145ECBinary ecbinary;
    private ASN1ObjectIdentifier namedCurve;

    static {
        DSTU4145Params.DEFAULT_DKE = new byte[]{-87, -42, -21, 69, -15, 60, 112, -126, -128, -60, -106, 123, 35, 31, 94, -83, -10, 88, -21, -92, -64, 55, 41, 29, 56, -39, 107, -16, 37, -54, 78, 23, -8, -23, 114, 13, -58, 21, -76, 58, 40, -105, 95, 11, -63, -34, -93, 100, 56, -75, 100, -22, 44, 23, -97, -48, 18, 62, 109, -72, -6, -59, 121, 4};
    }

    public DSTU4145Params(ASN1ObjectIdentifier arg2) {
        super();
        this.dke = DSTU4145Params.DEFAULT_DKE;
        this.namedCurve = arg2;
    }

    public DSTU4145Params(DSTU4145ECBinary arg2) {
        super();
        this.dke = DSTU4145Params.DEFAULT_DKE;
        this.ecbinary = arg2;
    }

    public byte[] getDKE() {
        return this.dke;
    }

    public static byte[] getDefaultDKE() {
        return DSTU4145Params.DEFAULT_DKE;
    }

    public DSTU4145ECBinary getECBinary() {
        return this.ecbinary;
    }

    public static DSTU4145Params getInstance(Object arg4) {
        DSTU4145Params v4;
        if(!(arg4 instanceof DSTU4145Params)) {
            if(arg4 != null) {
                ASN1Sequence v1 = ASN1Sequence.getInstance(arg4);
                DSTU4145Params v0 = (v1.getObjectAt(0) instanceof ASN1ObjectIdentifier) ? new DSTU4145Params(ASN1ObjectIdentifier.getInstance(v1.getObjectAt(0))) : new DSTU4145Params(DSTU4145ECBinary.getInstance(v1.getObjectAt(0)));
                if(v1.size() == 2) {
                    v0.dke = ASN1OctetString.getInstance(v1.getObjectAt(1)).getOctets();
                    if(v0.dke.length != DSTU4145Params.DEFAULT_DKE.length) {
                        throw new IllegalArgumentException("object parse error");
                    }
                }

                v4 = v0;
            }
            else {
                goto label_37;
            }
        }

        return v4;
    label_37:
        throw new IllegalArgumentException("object parse error");
    }

    public ASN1ObjectIdentifier getNamedCurve() {
        return this.namedCurve;
    }

    public boolean isNamedCurve() {
        boolean v0 = this.namedCurve != null ? true : false;
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.namedCurve != null) {
            v0.add(this.namedCurve);
        }
        else {
            v0.add(this.ecbinary);
        }

        if(!Arrays.areEqual(this.dke, DSTU4145Params.DEFAULT_DKE)) {
            v0.add(new DEROctetString(this.dke));
        }

        return new DERSequence(v0);
    }
}

