// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.ua;

import java.math.BigInteger;
import java.util.Random;
import org.bouncycastle.asn1.x9.X9IntegerConverter;
import org.bouncycastle.math.ec.ECConstants;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECCurve$F2m;
import org.bouncycastle.math.ec.ECFieldElement;
import org.bouncycastle.math.ec.ECFieldElement$F2m;
import org.bouncycastle.math.ec.ECPoint;
import org.bouncycastle.math.ec.ECPoint$F2m;
import org.bouncycastle.util.Arrays;

public abstract class DSTU4145PointEncoder {
    private static X9IntegerConverter converter;

    static {
        DSTU4145PointEncoder.converter = new X9IntegerConverter();
    }

    public DSTU4145PointEncoder() {
        super();
    }

    public static ECPoint decodePoint(ECCurve arg6, byte[] arg7) {
        ECFieldElement v2;
        BigInteger v1 = BigInteger.valueOf(((long)(arg7[arg7.length - 1] & 1)));
        if(!DSTU4145PointEncoder.trace(arg6.fromBigInteger(new BigInteger(1, arg7))).equals(arg6.getA().toBigInteger())) {
            arg7 = Arrays.clone(arg7);
            int v0 = arg7.length - 1;
            arg7[v0] = ((byte)(arg7[v0] ^ 1));
        }

        ECCurve v0_1 = arg6;
        ECFieldElement v3 = arg6.fromBigInteger(new BigInteger(1, arg7));
        if(v3.toBigInteger().equals(ECConstants.ZERO)) {
            v2 = arg6.getB();
            int v1_1;
            for(v1_1 = 0; v1_1 < ((ECCurve$F2m)v0_1).getM() - 1; ++v1_1) {
                v2 = v2.square();
            }
        }
        else {
            ECFieldElement v0_2 = DSTU4145PointEncoder.solveQuadradicEquation(v3.add(arg6.getA()).add(arg6.getB().multiply(v3.square().invert())));
            if(v0_2 == null) {
                throw new RuntimeException("Invalid point compression");
            }
            else {
                if(!DSTU4145PointEncoder.trace(v0_2).equals(v1)) {
                    v0_2 = v0_2.add(arg6.fromBigInteger(ECConstants.ONE));
                }

                v2 = v3.multiply(v0_2);
            }
        }

        return new ECPoint$F2m(arg6, v3, v2);
    }

    public static byte[] encodePoint(ECPoint arg3) {
        int v1;
        byte[] v0 = DSTU4145PointEncoder.converter.integerToBytes(arg3.getX().toBigInteger(), DSTU4145PointEncoder.converter.getByteLength(arg3.getX()));
        if(!arg3.getX().toBigInteger().equals(ECConstants.ZERO)) {
            if(DSTU4145PointEncoder.trace(arg3.getY().multiply(arg3.getX().invert())).equals(ECConstants.ONE)) {
                v1 = v0.length - 1;
                v0[v1] = ((byte)(v0[v1] | 1));
            }
            else {
                v1 = v0.length - 1;
                v0[v1] = ((byte)(v0[v1] & 254));
            }
        }

        return v0;
    }

    private static ECFieldElement solveQuadradicEquation(ECFieldElement arg10) {
        ECFieldElement v2_1;
        ECFieldElement v7 = arg10;
        ECFieldElement$F2m v0 = new ECFieldElement$F2m(((ECFieldElement$F2m)v7).getM(), ((ECFieldElement$F2m)v7).getK1(), ((ECFieldElement$F2m)v7).getK2(), ((ECFieldElement$F2m)v7).getK3(), ECConstants.ZERO);
        if(!arg10.toBigInteger().equals(ECConstants.ZERO)) {
            Random v8 = new Random();
            int v9 = ((ECFieldElement$F2m)v7).getM();
            do {
                ECFieldElement$F2m v1 = new ECFieldElement$F2m(((ECFieldElement$F2m)v7).getM(), ((ECFieldElement$F2m)v7).getK1(), ((ECFieldElement$F2m)v7).getK2(), ((ECFieldElement$F2m)v7).getK3(), new BigInteger(v9, v8));
                int v3 = 1;
                ECFieldElement v4 = arg10;
                ECFieldElement$F2m v2 = v0;
                while(v3 <= v9 - 1) {
                    v4 = v4.square();
                    ECFieldElement v5 = ((ECFieldElement)v2).square().add(v4.multiply(((ECFieldElement)v1)));
                    v4 = v4.add(arg10);
                    ++v3;
                    v2_1 = v5;
                }

                if(!v4.toBigInteger().equals(ECConstants.ZERO)) {
                    ECFieldElement v0_1 = null;
                }
                else {
                    if(v2_1.square().add(v2_1).toBigInteger().equals(ECConstants.ZERO)) {
                        continue;
                    }

                    break;
                }

                goto label_12;
            }
            while(true);

            v0 = ((ECFieldElement$F2m)v2_1);
        }

    label_12:
        return ((ECFieldElement)v0);
    }

    private static BigInteger trace(ECFieldElement arg3) {
        int v0 = 0;
        ECFieldElement v1 = arg3;
        while(v0 < arg3.getFieldSize() - 1) {
            v1 = v1.square().add(arg3);
            ++v0;
        }

        return v1.toBigInteger();
    }
}

