// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.util;

import java.io.IOException;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.BERApplicationSpecific;
import org.bouncycastle.asn1.BERConstructedOctetString;
import org.bouncycastle.asn1.BEROctetString;
import org.bouncycastle.asn1.BERSequence;
import org.bouncycastle.asn1.BERSet;
import org.bouncycastle.asn1.BERTaggedObject;
import org.bouncycastle.asn1.DERApplicationSpecific;
import org.bouncycastle.asn1.DERBMPString;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERBoolean;
import org.bouncycastle.asn1.DEREnumerated;
import org.bouncycastle.asn1.DERExternal;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERT61String;
import org.bouncycastle.asn1.DERUTCTime;
import org.bouncycastle.asn1.DERUTF8String;
import org.bouncycastle.asn1.DERVisibleString;
import org.bouncycastle.util.encoders.Hex;

public class ASN1Dump {
    private static final int SAMPLE_SIZE = 32;
    private static final String TAB = "    ";

    public ASN1Dump() {
        super();
    }

    static void _dumpAsString(String arg5, boolean arg6, ASN1Primitive arg7, StringBuffer arg8) {
        String v0_1;
        Object v0;
        String v3;
        Enumeration v2;
        String v1 = System.getProperty("line.separator");
        if((arg7 instanceof ASN1Sequence)) {
            v2 = arg7.getObjects();
            v3 = arg5 + "    ";
            arg8.append(arg5);
            if((arg7 instanceof BERSequence)) {
                arg8.append("BER Sequence");
            }
            else if((arg7 instanceof DERSequence)) {
                arg8.append("DER Sequence");
            }
            else {
                arg8.append("Sequence");
            }

            arg8.append(v1);
            while(v2.hasMoreElements()) {
                v0 = v2.nextElement();
                if(v0 != null && !v0.equals(DERNull.INSTANCE)) {
                    if((v0 instanceof ASN1Primitive)) {
                        ASN1Dump._dumpAsString(v3, arg6, ((ASN1Primitive)v0), arg8);
                    }
                    else {
                        ASN1Dump._dumpAsString(v3, arg6, ((ASN1Encodable)v0).toASN1Primitive(), arg8);
                    }

                    continue;
                }

                arg8.append(v3);
                arg8.append("NULL");
                arg8.append(v1);
            }
        }
        else {
            if((arg7 instanceof ASN1TaggedObject)) {
                v0_1 = arg5 + "    ";
                arg8.append(arg5);
                if((arg7 instanceof BERTaggedObject)) {
                    arg8.append("BER Tagged [");
                }
                else {
                    arg8.append("Tagged [");
                }

                arg8.append(Integer.toString(((ASN1TaggedObject)arg7).getTagNo()));
                arg8.append(']');
                if(!((ASN1TaggedObject)arg7).isExplicit()) {
                    arg8.append(" IMPLICIT ");
                }

                arg8.append(v1);
                if(((ASN1TaggedObject)arg7).isEmpty()) {
                    arg8.append(v0_1);
                    arg8.append("EMPTY");
                    arg8.append(v1);
                    return;
                }

                ASN1Dump._dumpAsString(v0_1, arg6, ((ASN1TaggedObject)arg7).getObject(), arg8);
                return;
            }

            if((arg7 instanceof ASN1Set)) {
                v2 = arg7.getObjects();
                v3 = arg5 + "    ";
                arg8.append(arg5);
                if((arg7 instanceof BERSet)) {
                    arg8.append("BER Set");
                }
                else {
                    arg8.append("DER Set");
                }

                arg8.append(v1);
                while(true) {
                    if(!v2.hasMoreElements()) {
                        return;
                    }

                    v0 = v2.nextElement();
                    if(v0 == null) {
                        arg8.append(v3);
                        arg8.append("NULL");
                        arg8.append(v1);
                        continue;
                    }

                    if((v0 instanceof ASN1Primitive)) {
                        ASN1Dump._dumpAsString(v3, arg6, ((ASN1Primitive)v0), arg8);
                        continue;
                    }

                    ASN1Dump._dumpAsString(v3, arg6, ((ASN1Encodable)v0).toASN1Primitive(), arg8);
                }
            }

            if((arg7 instanceof ASN1OctetString)) {
                ASN1Primitive v0_2 = arg7;
                if(((arg7 instanceof BEROctetString)) || ((arg7 instanceof BERConstructedOctetString))) {
                    arg8.append(arg5 + "BER Constructed Octet String" + "[" + ((ASN1OctetString)v0_2).getOctets().length + "] ");
                }
                else {
                    arg8.append(arg5 + "DER Octet String" + "[" + ((ASN1OctetString)v0_2).getOctets().length + "] ");
                }

                if(arg6) {
                    arg8.append(ASN1Dump.dumpBinaryDataAsString(arg5, ((ASN1OctetString)v0_2).getOctets()));
                    return;
                }

                arg8.append(v1);
                return;
            }

            if((arg7 instanceof ASN1ObjectIdentifier)) {
                arg8.append(arg5 + "ObjectIdentifier(" + ((ASN1ObjectIdentifier)arg7).getId() + ")" + v1);
                return;
            }

            if((arg7 instanceof DERBoolean)) {
                arg8.append(arg5 + "Boolean(" + ((DERBoolean)arg7).isTrue() + ")" + v1);
                return;
            }

            if((arg7 instanceof ASN1Integer)) {
                arg8.append(arg5 + "Integer(" + ((ASN1Integer)arg7).getValue() + ")" + v1);
                return;
            }

            if((arg7 instanceof DERBitString)) {
                arg8.append(arg5 + "DER Bit String" + "[" + ((DERBitString)arg7).getBytes().length + ", " + ((DERBitString)arg7).getPadBits() + "] ");
                if(arg6) {
                    arg8.append(ASN1Dump.dumpBinaryDataAsString(arg5, ((DERBitString)arg7).getBytes()));
                    return;
                }

                arg8.append(v1);
                return;
            }

            if((arg7 instanceof DERIA5String)) {
                arg8.append(arg5 + "IA5String(" + ((DERIA5String)arg7).getString() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERUTF8String)) {
                arg8.append(arg5 + "UTF8String(" + ((DERUTF8String)arg7).getString() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERPrintableString)) {
                arg8.append(arg5 + "PrintableString(" + ((DERPrintableString)arg7).getString() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERVisibleString)) {
                arg8.append(arg5 + "VisibleString(" + ((DERVisibleString)arg7).getString() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERBMPString)) {
                arg8.append(arg5 + "BMPString(" + ((DERBMPString)arg7).getString() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERT61String)) {
                arg8.append(arg5 + "T61String(" + ((DERT61String)arg7).getString() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERUTCTime)) {
                arg8.append(arg5 + "UTCTime(" + ((DERUTCTime)arg7).getTime() + ") " + v1);
                return;
            }

            if((arg7 instanceof DERGeneralizedTime)) {
                arg8.append(arg5 + "GeneralizedTime(" + ((DERGeneralizedTime)arg7).getTime() + ") " + v1);
                return;
            }

            if((arg7 instanceof BERApplicationSpecific)) {
                arg8.append(ASN1Dump.outputApplicationSpecific("BER", arg5, arg6, arg7, v1));
                return;
            }

            if((arg7 instanceof DERApplicationSpecific)) {
                arg8.append(ASN1Dump.outputApplicationSpecific("DER", arg5, arg6, arg7, v1));
                return;
            }

            if((arg7 instanceof DEREnumerated)) {
                arg8.append(arg5 + "DER Enumerated(" + ((DEREnumerated)arg7).getValue() + ")" + v1);
                return;
            }

            if((arg7 instanceof DERExternal)) {
                arg8.append(arg5 + "External " + v1);
                v0_1 = arg5 + "    ";
                if(((DERExternal)arg7).getDirectReference() != null) {
                    arg8.append(v0_1 + "Direct Reference: " + ((DERExternal)arg7).getDirectReference().getId() + v1);
                }

                if(((DERExternal)arg7).getIndirectReference() != null) {
                    arg8.append(v0_1 + "Indirect Reference: " + ((DERExternal)arg7).getIndirectReference().toString() + v1);
                }

                if(((DERExternal)arg7).getDataValueDescriptor() != null) {
                    ASN1Dump._dumpAsString(v0_1, arg6, ((DERExternal)arg7).getDataValueDescriptor(), arg8);
                }

                arg8.append(v0_1 + "Encoding: " + ((DERExternal)arg7).getEncoding() + v1);
                ASN1Dump._dumpAsString(v0_1, arg6, ((DERExternal)arg7).getExternalContent(), arg8);
                return;
            }

            arg8.append(arg5 + arg7.toString() + v1);
        }
    }

    private static String calculateAscString(byte[] arg4, int arg5, int arg6) {
        StringBuffer v1 = new StringBuffer();
        int v0;
        for(v0 = arg5; v0 != arg5 + arg6; ++v0) {
            if(arg4[v0] >= 32 && arg4[v0] <= 126) {
                v1.append(((char)arg4[v0]));
            }
        }

        return v1.toString();
    }

    public static String dumpAsString(Object arg1) {
        return ASN1Dump.dumpAsString(arg1, false);
    }

    public static String dumpAsString(Object arg3, boolean arg4) {
        String v0_1;
        StringBuffer v0 = new StringBuffer();
        if((arg3 instanceof ASN1Primitive)) {
            ASN1Dump._dumpAsString("", arg4, ((ASN1Primitive)arg3), v0);
            goto label_6;
        }
        else if((arg3 instanceof ASN1Encodable)) {
            ASN1Dump._dumpAsString("", arg4, ((ASN1Encodable)arg3).toASN1Primitive(), v0);
        label_6:
            v0_1 = v0.toString();
        }
        else {
            v0_1 = "unknown object type " + arg3.toString();
        }

        return v0_1;
    }

    private static String dumpBinaryDataAsString(String arg7, byte[] arg8) {
        int v6 = 32;
        String v2 = System.getProperty("line.separator");
        StringBuffer v3 = new StringBuffer();
        String v4 = arg7 + "    ";
        v3.append(v2);
        int v0;
        for(v0 = 0; v0 < arg8.length; v0 += 32) {
            if(arg8.length - v0 > v6) {
                v3.append(v4);
                v3.append(new String(Hex.encode(arg8, v0, v6)));
                v3.append("    ");
                v3.append(ASN1Dump.calculateAscString(arg8, v0, v6));
                v3.append(v2);
            }
            else {
                v3.append(v4);
                v3.append(new String(Hex.encode(arg8, v0, arg8.length - v0)));
                int v1;
                for(v1 = arg8.length - v0; v1 != v6; ++v1) {
                    v3.append("  ");
                }

                v3.append("    ");
                v3.append(ASN1Dump.calculateAscString(arg8, v0, arg8.length - v0));
                v3.append(v2);
            }
        }

        return v3.toString();
    }

    private static String outputApplicationSpecific(String arg4, String arg5, boolean arg6, ASN1Primitive arg7, String arg8) {
        String v0_3;
        StringBuffer v1 = new StringBuffer();
        if(((DERApplicationSpecific)arg7).isConstructed()) {
            int v0 = 16;
            try {
                ASN1Sequence v0_2 = ASN1Sequence.getInstance(((DERApplicationSpecific)arg7).getObject(v0));
                v1.append(arg5 + arg4 + " ApplicationSpecific[" + ((DERApplicationSpecific)arg7).getApplicationTag() + "]" + arg8);
                Enumeration v2 = v0_2.getObjects();
                while(v2.hasMoreElements()) {
                    ASN1Dump._dumpAsString(arg5 + "    ", arg6, v2.nextElement(), v1);
                }
            }
            catch(IOException v0_1) {
                v1.append(v0_1);
            }

            v0_3 = v1.toString();
        }
        else {
            v0_3 = arg5 + arg4 + " ApplicationSpecific[" + ((DERApplicationSpecific)arg7).getApplicationTag() + "] (" + new String(Hex.encode(((DERApplicationSpecific)arg7).getContents())) + ")" + arg8;
        }

        return v0_3;
    }
}

