// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x500;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.style.BCStyle;

public class X500Name extends ASN1Object implements ASN1Choice {
    private static X500NameStyle defaultStyle;
    private int hashCodeValue;
    private boolean isHashCodeCalculated;
    private RDN[] rdns;
    private X500NameStyle style;

    static {
        X500Name.defaultStyle = BCStyle.INSTANCE;
    }

    public X500Name(String arg2) {
        this(X500Name.defaultStyle, arg2);
    }

    public X500Name(X500NameStyle arg2, String arg3) {
        this(arg2.fromString(arg3));
        this.style = arg2;
    }

    private X500Name(ASN1Sequence arg2) {
        this(X500Name.defaultStyle, arg2);
    }

    private X500Name(X500NameStyle arg6, ASN1Sequence arg7) {
        super();
        this.style = arg6;
        this.rdns = new RDN[arg7.size()];
        int v0 = 0;
        Enumeration v2 = arg7.getObjects();
        while(v2.hasMoreElements()) {
            this.rdns[v0] = RDN.getInstance(v2.nextElement());
            ++v0;
        }
    }

    public X500Name(RDN[] arg2) {
        this(X500Name.defaultStyle, arg2);
    }

    public X500Name(X500NameStyle arg2, X500Name arg3) {
        super();
        this.rdns = arg3.rdns;
        this.style = arg2;
    }

    public X500Name(X500NameStyle arg1, RDN[] arg2) {
        super();
        this.rdns = arg2;
        this.style = arg1;
    }

    public boolean equals(Object arg5) {
        boolean v0;
        if((((X500Name)arg5)) == this) {
            v0 = true;
            return v0;
        }

        if(!(arg5 instanceof X500Name) && !(arg5 instanceof ASN1Sequence)) {
            return false;
        }

        if(this.toASN1Primitive().equals(arg5.toASN1Primitive())) {
            return true;
        }

        try {
            v0 = this.style.areEqual(this, new X500Name(ASN1Sequence.getInstance(((ASN1Encodable)arg5).toASN1Primitive())));
        }
        catch(Exception v0_1) {
            v0 = false;
        }

        return v0;
    }

    public ASN1ObjectIdentifier[] getAttributeTypes() {
        int v0 = 0;
        int v2 = 0;
        while(v0 != this.rdns.length) {
            v2 += this.rdns[v0].size();
            ++v0;
        }

        ASN1ObjectIdentifier[] v5 = new ASN1ObjectIdentifier[v2];
        v0 = 0;
        v2 = 0;
        while(v0 != this.rdns.length) {
            RDN v4 = this.rdns[v0];
            if(v4.isMultiValued()) {
                AttributeTypeAndValue[] v6 = v4.getTypesAndValues();
                int v3 = v2;
                v2 = 0;
                while(v2 != v6.length) {
                    v5[v3] = v6[v2].getType();
                    ++v2;
                    ++v3;
                }

                v2 = v3;
            }
            else if(v4.size() != 0) {
                v5[v2] = v4.getFirst().getType();
                ++v2;
            }

            ++v0;
        }

        return v5;
    }

    public static X500NameStyle getDefaultStyle() {
        return X500Name.defaultStyle;
    }

    public static X500Name getInstance(Object arg2) {
        if(!(arg2 instanceof X500Name)) {
            if(arg2 != null) {
                X500Name v2 = new X500Name(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static X500Name getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return X500Name.getInstance(ASN1Sequence.getInstance(arg1, true));
    }

    public static X500Name getInstance(X500NameStyle arg2, Object arg3) {
        X500Name v0;
        if((arg3 instanceof X500Name)) {
            v0 = X500Name.getInstance(arg2, ((X500Name)arg3).toASN1Primitive());
        }
        else if(arg3 != null) {
            v0 = new X500Name(arg2, ASN1Sequence.getInstance(arg3));
        }
        else {
            v0 = null;
        }

        return v0;
    }

    public RDN[] getRDNs() {
        RDN[] v0 = new RDN[this.rdns.length];
        System.arraycopy(this.rdns, 0, v0, 0, v0.length);
        return v0;
    }

    public RDN[] getRDNs(ASN1ObjectIdentifier arg9) {
        RDN[] v4 = new RDN[this.rdns.length];
        int v0 = 0;
        int v2 = 0;
        while(v0 != this.rdns.length) {
            RDN v5 = this.rdns[v0];
            if(v5.isMultiValued()) {
                AttributeTypeAndValue[] v6 = v5.getTypesAndValues();
                int v3 = 0;
                while(v3 != v6.length) {
                    if(v6[v3].getType().equals(arg9)) {
                        v4[v2] = v5;
                        ++v2;
                    }
                    else {
                        ++v3;
                        continue;
                    }

                    break;
                }
            }
            else if(v5.getFirst().getType().equals(arg9)) {
                v4[v2] = v5;
                ++v2;
            }

            ++v0;
        }

        RDN[] v0_1 = new RDN[v2];
        System.arraycopy(v4, 0, v0_1, 0, v0_1.length);
        return v0_1;
    }

    public int hashCode() {
        int v0;
        if(this.isHashCodeCalculated) {
            v0 = this.hashCodeValue;
        }
        else {
            this.isHashCodeCalculated = true;
            this.hashCodeValue = this.style.calculateHashCode(this);
            v0 = this.hashCodeValue;
        }

        return v0;
    }

    public static void setDefaultStyle(X500NameStyle arg2) {
        if(arg2 == null) {
            throw new NullPointerException("cannot set style to null");
        }

        X500Name.defaultStyle = arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        return new DERSequence(this.rdns);
    }

    public String toString() {
        return this.style.toString(this);
    }
}

