// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x500;

import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.x500.style.BCStyle;

public class X500NameBuilder {
    private Vector rdns;
    private X500NameStyle template;

    public X500NameBuilder() {
        this(BCStyle.INSTANCE);
    }

    public X500NameBuilder(X500NameStyle arg2) {
        super();
        this.rdns = new Vector();
        this.template = arg2;
    }

    public X500NameBuilder addMultiValuedRDN(ASN1ObjectIdentifier[] arg6, String[] arg7) {
        ASN1Encodable[] v1 = new ASN1Encodable[arg7.length];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = this.template.stringToValue(arg6[v0], arg7[v0]);
        }

        return this.addMultiValuedRDN(arg6, v1);
    }

    public X500NameBuilder addMultiValuedRDN(ASN1ObjectIdentifier[] arg6, ASN1Encodable[] arg7) {
        AttributeTypeAndValue[] v1 = new AttributeTypeAndValue[arg6.length];
        int v0;
        for(v0 = 0; v0 != arg6.length; ++v0) {
            v1[v0] = new AttributeTypeAndValue(arg6[v0], arg7[v0]);
        }

        return this.addMultiValuedRDN(v1);
    }

    public X500NameBuilder addMultiValuedRDN(AttributeTypeAndValue[] arg3) {
        this.rdns.addElement(new RDN(arg3));
        return this;
    }

    public X500NameBuilder addRDN(ASN1ObjectIdentifier arg2, String arg3) {
        this.addRDN(arg2, this.template.stringToValue(arg2, arg3));
        return this;
    }

    public X500NameBuilder addRDN(ASN1ObjectIdentifier arg3, ASN1Encodable arg4) {
        this.rdns.addElement(new RDN(arg3, arg4));
        return this;
    }

    public X500NameBuilder addRDN(AttributeTypeAndValue arg3) {
        this.rdns.addElement(new RDN(arg3));
        return this;
    }

    public X500Name build() {
        RDN[] v2 = new RDN[this.rdns.size()];
        int v1;
        for(v1 = 0; v1 != v2.length; ++v1) {
            v2[v1] = this.rdns.elementAt(v1);
        }

        return new X500Name(this.template, v2);
    }
}

