// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x500.style;

import java.io.IOException;
import java.util.Hashtable;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERUTF8String;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x500.AttributeTypeAndValue;
import org.bouncycastle.asn1.x500.RDN;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x500.X500NameStyle;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;

public class BCStyle implements X500NameStyle {
    public static final ASN1ObjectIdentifier BUSINESS_CATEGORY;
    public static final ASN1ObjectIdentifier C;
    public static final ASN1ObjectIdentifier CN;
    public static final ASN1ObjectIdentifier COUNTRY_OF_CITIZENSHIP;
    public static final ASN1ObjectIdentifier COUNTRY_OF_RESIDENCE;
    public static final ASN1ObjectIdentifier DATE_OF_BIRTH;
    public static final ASN1ObjectIdentifier DC;
    public static final ASN1ObjectIdentifier DMD_NAME;
    public static final ASN1ObjectIdentifier DN_QUALIFIER;
    private static final Hashtable DefaultLookUp;
    private static final Hashtable DefaultSymbols;
    public static final ASN1ObjectIdentifier E;
    public static final ASN1ObjectIdentifier EmailAddress;
    public static final ASN1ObjectIdentifier GENDER;
    public static final ASN1ObjectIdentifier GENERATION;
    public static final ASN1ObjectIdentifier GIVENNAME;
    public static final ASN1ObjectIdentifier INITIALS;
    public static final ASN1ObjectIdentifier L;
    public static final ASN1ObjectIdentifier NAME;
    public static final ASN1ObjectIdentifier NAME_AT_BIRTH;
    public static final ASN1ObjectIdentifier O;
    public static final ASN1ObjectIdentifier OU;
    public static final ASN1ObjectIdentifier PLACE_OF_BIRTH;
    public static final ASN1ObjectIdentifier POSTAL_ADDRESS;
    public static final ASN1ObjectIdentifier POSTAL_CODE;
    public static final ASN1ObjectIdentifier PSEUDONYM;
    public static final ASN1ObjectIdentifier SERIALNUMBER;
    public static final ASN1ObjectIdentifier SN;
    public static final ASN1ObjectIdentifier ST;
    public static final ASN1ObjectIdentifier STREET;
    public static final ASN1ObjectIdentifier SURNAME;
    public static final ASN1ObjectIdentifier T;
    public static final ASN1ObjectIdentifier TELEPHONE_NUMBER;
    public static final ASN1ObjectIdentifier UID;
    public static final ASN1ObjectIdentifier UNIQUE_IDENTIFIER;
    public static final ASN1ObjectIdentifier UnstructuredAddress;
    public static final ASN1ObjectIdentifier UnstructuredName;

    static {
        BCStyle.INSTANCE = new BCStyle();
        BCStyle.C = new ASN1ObjectIdentifier("2.5.4.6");
        BCStyle.O = new ASN1ObjectIdentifier("2.5.4.10");
        BCStyle.OU = new ASN1ObjectIdentifier("2.5.4.11");
        BCStyle.T = new ASN1ObjectIdentifier("2.5.4.12");
        BCStyle.CN = new ASN1ObjectIdentifier("2.5.4.3");
        BCStyle.SN = new ASN1ObjectIdentifier("2.5.4.5");
        BCStyle.STREET = new ASN1ObjectIdentifier("2.5.4.9");
        BCStyle.SERIALNUMBER = BCStyle.SN;
        BCStyle.L = new ASN1ObjectIdentifier("2.5.4.7");
        BCStyle.ST = new ASN1ObjectIdentifier("2.5.4.8");
        BCStyle.SURNAME = new ASN1ObjectIdentifier("2.5.4.4");
        BCStyle.GIVENNAME = new ASN1ObjectIdentifier("2.5.4.42");
        BCStyle.INITIALS = new ASN1ObjectIdentifier("2.5.4.43");
        BCStyle.GENERATION = new ASN1ObjectIdentifier("2.5.4.44");
        BCStyle.UNIQUE_IDENTIFIER = new ASN1ObjectIdentifier("2.5.4.45");
        BCStyle.BUSINESS_CATEGORY = new ASN1ObjectIdentifier("2.5.4.15");
        BCStyle.POSTAL_CODE = new ASN1ObjectIdentifier("2.5.4.17");
        BCStyle.DN_QUALIFIER = new ASN1ObjectIdentifier("2.5.4.46");
        BCStyle.PSEUDONYM = new ASN1ObjectIdentifier("2.5.4.65");
        BCStyle.DATE_OF_BIRTH = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.1");
        BCStyle.PLACE_OF_BIRTH = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.2");
        BCStyle.GENDER = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.3");
        BCStyle.COUNTRY_OF_CITIZENSHIP = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.4");
        BCStyle.COUNTRY_OF_RESIDENCE = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.5");
        BCStyle.NAME_AT_BIRTH = new ASN1ObjectIdentifier("1.3.36.8.3.14");
        BCStyle.POSTAL_ADDRESS = new ASN1ObjectIdentifier("2.5.4.16");
        BCStyle.DMD_NAME = new ASN1ObjectIdentifier("2.5.4.54");
        BCStyle.TELEPHONE_NUMBER = X509ObjectIdentifiers.id_at_telephoneNumber;
        BCStyle.NAME = X509ObjectIdentifiers.id_at_name;
        BCStyle.EmailAddress = PKCSObjectIdentifiers.pkcs_9_at_emailAddress;
        BCStyle.UnstructuredName = PKCSObjectIdentifiers.pkcs_9_at_unstructuredName;
        BCStyle.UnstructuredAddress = PKCSObjectIdentifiers.pkcs_9_at_unstructuredAddress;
        BCStyle.E = BCStyle.EmailAddress;
        BCStyle.DC = new ASN1ObjectIdentifier("0.9.2342.19200300.100.1.25");
        BCStyle.UID = new ASN1ObjectIdentifier("0.9.2342.19200300.100.1.1");
        BCStyle.DefaultSymbols = new Hashtable();
        BCStyle.DefaultLookUp = new Hashtable();
        BCStyle.DefaultSymbols.put(BCStyle.C, "C");
        BCStyle.DefaultSymbols.put(BCStyle.O, "O");
        BCStyle.DefaultSymbols.put(BCStyle.T, "T");
        BCStyle.DefaultSymbols.put(BCStyle.OU, "OU");
        BCStyle.DefaultSymbols.put(BCStyle.CN, "CN");
        BCStyle.DefaultSymbols.put(BCStyle.L, "L");
        BCStyle.DefaultSymbols.put(BCStyle.ST, "ST");
        BCStyle.DefaultSymbols.put(BCStyle.SN, "SERIALNUMBER");
        BCStyle.DefaultSymbols.put(BCStyle.EmailAddress, "E");
        BCStyle.DefaultSymbols.put(BCStyle.DC, "DC");
        BCStyle.DefaultSymbols.put(BCStyle.UID, "UID");
        BCStyle.DefaultSymbols.put(BCStyle.STREET, "STREET");
        BCStyle.DefaultSymbols.put(BCStyle.SURNAME, "SURNAME");
        BCStyle.DefaultSymbols.put(BCStyle.GIVENNAME, "GIVENNAME");
        BCStyle.DefaultSymbols.put(BCStyle.INITIALS, "INITIALS");
        BCStyle.DefaultSymbols.put(BCStyle.GENERATION, "GENERATION");
        BCStyle.DefaultSymbols.put(BCStyle.UnstructuredAddress, "unstructuredAddress");
        BCStyle.DefaultSymbols.put(BCStyle.UnstructuredName, "unstructuredName");
        BCStyle.DefaultSymbols.put(BCStyle.UNIQUE_IDENTIFIER, "UniqueIdentifier");
        BCStyle.DefaultSymbols.put(BCStyle.DN_QUALIFIER, "DN");
        BCStyle.DefaultSymbols.put(BCStyle.PSEUDONYM, "Pseudonym");
        BCStyle.DefaultSymbols.put(BCStyle.POSTAL_ADDRESS, "PostalAddress");
        BCStyle.DefaultSymbols.put(BCStyle.NAME_AT_BIRTH, "NameAtBirth");
        BCStyle.DefaultSymbols.put(BCStyle.COUNTRY_OF_CITIZENSHIP, "CountryOfCitizenship");
        BCStyle.DefaultSymbols.put(BCStyle.COUNTRY_OF_RESIDENCE, "CountryOfResidence");
        BCStyle.DefaultSymbols.put(BCStyle.GENDER, "Gender");
        BCStyle.DefaultSymbols.put(BCStyle.PLACE_OF_BIRTH, "PlaceOfBirth");
        BCStyle.DefaultSymbols.put(BCStyle.DATE_OF_BIRTH, "DateOfBirth");
        BCStyle.DefaultSymbols.put(BCStyle.POSTAL_CODE, "PostalCode");
        BCStyle.DefaultSymbols.put(BCStyle.BUSINESS_CATEGORY, "BusinessCategory");
        BCStyle.DefaultSymbols.put(BCStyle.TELEPHONE_NUMBER, "TelephoneNumber");
        BCStyle.DefaultSymbols.put(BCStyle.NAME, "Name");
        BCStyle.DefaultLookUp.put("c", BCStyle.C);
        BCStyle.DefaultLookUp.put("o", BCStyle.O);
        BCStyle.DefaultLookUp.put("t", BCStyle.T);
        BCStyle.DefaultLookUp.put("ou", BCStyle.OU);
        BCStyle.DefaultLookUp.put("cn", BCStyle.CN);
        BCStyle.DefaultLookUp.put("l", BCStyle.L);
        BCStyle.DefaultLookUp.put("st", BCStyle.ST);
        BCStyle.DefaultLookUp.put("sn", BCStyle.SN);
        BCStyle.DefaultLookUp.put("serialnumber", BCStyle.SN);
        BCStyle.DefaultLookUp.put("street", BCStyle.STREET);
        BCStyle.DefaultLookUp.put("emailaddress", BCStyle.E);
        BCStyle.DefaultLookUp.put("dc", BCStyle.DC);
        BCStyle.DefaultLookUp.put("e", BCStyle.E);
        BCStyle.DefaultLookUp.put("uid", BCStyle.UID);
        BCStyle.DefaultLookUp.put("surname", BCStyle.SURNAME);
        BCStyle.DefaultLookUp.put("givenname", BCStyle.GIVENNAME);
        BCStyle.DefaultLookUp.put("initials", BCStyle.INITIALS);
        BCStyle.DefaultLookUp.put("generation", BCStyle.GENERATION);
        BCStyle.DefaultLookUp.put("unstructuredaddress", BCStyle.UnstructuredAddress);
        BCStyle.DefaultLookUp.put("unstructuredname", BCStyle.UnstructuredName);
        BCStyle.DefaultLookUp.put("uniqueidentifier", BCStyle.UNIQUE_IDENTIFIER);
        BCStyle.DefaultLookUp.put("dn", BCStyle.DN_QUALIFIER);
        BCStyle.DefaultLookUp.put("pseudonym", BCStyle.PSEUDONYM);
        BCStyle.DefaultLookUp.put("postaladdress", BCStyle.POSTAL_ADDRESS);
        BCStyle.DefaultLookUp.put("nameofbirth", BCStyle.NAME_AT_BIRTH);
        BCStyle.DefaultLookUp.put("countryofcitizenship", BCStyle.COUNTRY_OF_CITIZENSHIP);
        BCStyle.DefaultLookUp.put("countryofresidence", BCStyle.COUNTRY_OF_RESIDENCE);
        BCStyle.DefaultLookUp.put("gender", BCStyle.GENDER);
        BCStyle.DefaultLookUp.put("placeofbirth", BCStyle.PLACE_OF_BIRTH);
        BCStyle.DefaultLookUp.put("dateofbirth", BCStyle.DATE_OF_BIRTH);
        BCStyle.DefaultLookUp.put("postalcode", BCStyle.POSTAL_CODE);
        BCStyle.DefaultLookUp.put("businesscategory", BCStyle.BUSINESS_CATEGORY);
        BCStyle.DefaultLookUp.put("telephonenumber", BCStyle.TELEPHONE_NUMBER);
        BCStyle.DefaultLookUp.put("name", BCStyle.NAME);
    }

    protected BCStyle() {
        super();
    }

    public boolean areEqual(X500Name arg8, X500Name arg9) {
        boolean v0;
        boolean v2 = false;
        RDN[] v4 = arg8.getRDNs();
        RDN[] v5 = arg9.getRDNs();
        if(v4.length == v5.length) {
            if(v4[0].getFirst() == null || v5[0].getFirst() == null) {
                v0 = false;
            }
            else if(!v4[0].getFirst().getType().equals(v5[0].getFirst().getType())) {
                v0 = true;
            }
            else {
                v0 = false;
            }

            int v3;
            for(v3 = 0; v3 != v4.length; ++v3) {
                if(!this.foundMatch(v0, v4[v3], v5)) {
                    return v2;
                }
            }

            v2 = true;
        }

        return v2;
    }

    public ASN1ObjectIdentifier attrNameToOID(String arg2) {
        return IETFUtils.decodeAttrName(arg2, BCStyle.DefaultLookUp);
    }

    private int calcHashCode(ASN1Encodable arg2) {
        return IETFUtils.canonicalize(IETFUtils.valueToString(arg2)).hashCode();
    }

    public int calculateHashCode(X500Name arg8) {
        RDN[] v4 = arg8.getRDNs();
        int v0 = 0;
        int v2 = 0;
        while(v0 != v4.length) {
            if(v4[v0].isMultiValued()) {
                AttributeTypeAndValue[] v5 = v4[v0].getTypesAndValues();
                int v3 = v2;
                for(v2 = 0; v2 != v5.length; ++v2) {
                    v3 = v3 ^ v5[v2].getType().hashCode() ^ this.calcHashCode(v5[v2].getValue());
                }

                v2 = v3;
            }
            else {
                v2 = v2 ^ v4[v0].getFirst().getType().hashCode() ^ this.calcHashCode(v4[v0].getFirst().getValue());
            }

            ++v0;
        }

        return v2;
    }

    private boolean foundMatch(boolean arg6, RDN arg7, RDN[] arg8) {
        RDN v4 = null;
        boolean v1 = false;
        if(arg6) {
            int v0;
            for(v0 = arg8.length - 1; v0 >= 0; --v0) {
                if(arg8[v0] != null && (this.rdnAreEqual(arg7, arg8[v0]))) {
                    arg8[v0] = v4;
                    return true;
                }
            }
        }
        else {
            for(v0 = 0; v0 != arg8.length; ++v0) {
                if(arg8[v0] != null && (this.rdnAreEqual(arg7, arg8[v0]))) {
                    arg8[v0] = v4;
                    return true;
                }
            }
        }

        return v1;
    }

    public RDN[] fromString(String arg2) {
        return IETFUtils.rDNsFromString(arg2, ((X500NameStyle)this));
    }

    public String[] oidToAttrNames(ASN1ObjectIdentifier arg2) {
        return IETFUtils.findAttrNamesForOID(arg2, BCStyle.DefaultLookUp);
    }

    public String oidToDisplayName(ASN1ObjectIdentifier arg2) {
        return BCStyle.DefaultSymbols.get(arg2);
    }

    protected boolean rdnAreEqual(RDN arg2, RDN arg3) {
        return IETFUtils.rDNAreEqual(arg2, arg3);
    }

    public ASN1Encodable stringToValue(ASN1ObjectIdentifier arg5, String arg6) {
        DERUTF8String v0_3;
        if(arg6.length() == 0 || arg6.charAt(0) != 35) {
            if(arg6.length() != 0 && arg6.charAt(0) == 92) {
                arg6 = arg6.substring(1);
            }

            if(!arg5.equals(BCStyle.EmailAddress) && !arg5.equals(BCStyle.DC)) {
                if(arg5.equals(BCStyle.DATE_OF_BIRTH)) {
                    ASN1GeneralizedTime v0_2 = new ASN1GeneralizedTime(arg6);
                }
                else {
                    if(!arg5.equals(BCStyle.C) && !arg5.equals(BCStyle.SN) && !arg5.equals(BCStyle.DN_QUALIFIER) && !arg5.equals(BCStyle.TELEPHONE_NUMBER)) {
                        v0_3 = new DERUTF8String(arg6);
                        goto label_9;
                    }

                    DERPrintableString v0_4 = new DERPrintableString(arg6);
                }

                goto label_9;
            }

            DERIA5String v0_5 = new DERIA5String(arg6);
        }
        else {
            try {
                ASN1Encodable v0_1 = IETFUtils.valueFromHexString(arg6, 1);
            }
            catch(IOException v0) {
                throw new RuntimeException("can\'t recode value for oid " + arg5.getId());
            }
        }

    label_9:
        return ((ASN1Encodable)v0_3);
    }

    public String toString(X500Name arg8) {
        StringBuffer v3 = new StringBuffer();
        RDN[] v4 = arg8.getRDNs();
        int v2 = 1;
        int v0;
        for(v0 = 0; v0 < v4.length; ++v0) {
            if(v2 != 0) {
                v2 = 0;
            }
            else {
                v3.append(',');
            }

            IETFUtils.appendRDN(v3, v4[v0], BCStyle.DefaultSymbols);
        }

        return v3.toString();
    }
}

