// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x500.style;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1String;
import org.bouncycastle.asn1.DERUniversalString;
import org.bouncycastle.asn1.x500.AttributeTypeAndValue;
import org.bouncycastle.asn1.x500.RDN;
import org.bouncycastle.asn1.x500.X500NameBuilder;
import org.bouncycastle.asn1.x500.X500NameStyle;
import org.bouncycastle.util.Strings;
import org.bouncycastle.util.encoders.Hex;

public class IETFUtils {
    public IETFUtils() {
        super();
    }

    public static void appendRDN(StringBuffer arg5, RDN arg6, Hashtable arg7) {
        if(arg6.isMultiValued()) {
            AttributeTypeAndValue[] v3 = arg6.getTypesAndValues();
            int v2 = 1;
            int v0;
            for(v0 = 0; v0 != v3.length; ++v0) {
                if(v2 != 0) {
                    v2 = 0;
                }
                else {
                    arg5.append('+');
                }

                IETFUtils.appendTypeAndValue(arg5, v3[v0], arg7);
            }
        }
        else {
            IETFUtils.appendTypeAndValue(arg5, arg6.getFirst(), arg7);
        }
    }

    public static void appendTypeAndValue(StringBuffer arg1, AttributeTypeAndValue arg2, Hashtable arg3) {
        Object v0 = arg3.get(arg2.getType());
        if(v0 != null) {
            arg1.append(((String)v0));
        }
        else {
            arg1.append(arg2.getType().getId());
        }

        arg1.append('=');
        arg1.append(IETFUtils.valueToString(arg2.getValue()));
    }

    private static boolean atvAreEqual(AttributeTypeAndValue arg4, AttributeTypeAndValue arg5) {
        boolean v0 = true;
        if(arg4 != arg5) {
            if(arg4 == null) {
                v0 = false;
            }
            else if(arg5 == null) {
                v0 = false;
            }
            else if(!arg4.getType().equals(arg5.getType())) {
                v0 = false;
            }
            else if(!IETFUtils.canonicalize(IETFUtils.valueToString(arg4.getValue())).equals(IETFUtils.canonicalize(IETFUtils.valueToString(arg5.getValue())))) {
                v0 = false;
            }
        }

        return v0;
    }

    private static String bytesToString(byte[] arg3) {
        char[] v1 = new char[arg3.length];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = ((char)(arg3[v0] & 255));
        }

        return new String(v1);
    }

    public static String canonicalize(String arg3) {
        String v0_1;
        String v1 = Strings.toLowerCase(arg3.trim());
        if(v1.length() <= 0 || v1.charAt(0) != 35) {
        label_16:
            v0_1 = v1;
        }
        else {
            ASN1Primitive v0 = IETFUtils.decodeObject(v1);
            if((v0 instanceof ASN1String)) {
                v0_1 = Strings.toLowerCase(((ASN1String)v0).getString().trim());
            }
            else {
                goto label_16;
            }
        }

        return IETFUtils.stripInternalSpaces(v0_1);
    }

    private static int convertHex(char arg1) {
        int v0;
        if(48 > arg1 || arg1 > 57) {
            if(97 <= arg1 && arg1 <= 102) {
                return arg1 - 87;
            }

            v0 = arg1 - 55;
        }
        else {
            v0 = arg1 - 48;
        }

        return v0;
    }

    public static ASN1ObjectIdentifier decodeAttrName(String arg3, Hashtable arg4) {
        ASN1ObjectIdentifier v0;
        if(Strings.toUpperCase(arg3).startsWith("OID.")) {
            v0 = new ASN1ObjectIdentifier(arg3.substring(4));
        }
        else {
            if(arg3.charAt(0) >= 48 && arg3.charAt(0) <= 57) {
                return new ASN1ObjectIdentifier(arg3);
            }

            Object v0_1 = arg4.get(Strings.toLowerCase(arg3));
            if(v0_1 != null) {
                return v0;
            }

            throw new IllegalArgumentException("Unknown object id - " + arg3 + " - passed to distinguished name");
        }

        return v0;
    }

    private static ASN1Primitive decodeObject(String arg4) {
        try {
            return ASN1Primitive.fromByteArray(Hex.decode(arg4.substring(1)));
        }
        catch(IOException v0) {
            throw new IllegalStateException("unknown encoding in name: " + v0);
        }
    }

    public static String[] findAttrNamesForOID(ASN1ObjectIdentifier arg5, Hashtable arg6) {
        int v1 = 0;
        Enumeration v2 = arg6.elements();
        int v0;
        for(v0 = 0; v2.hasMoreElements(); ++v0) {
            if(!arg5.equals(v2.nextElement())) {
                continue;
            }
        }

        String[] v3 = new String[v0];
        Enumeration v4 = arg6.keys();
        while(v4.hasMoreElements()) {
            Object v0_1 = v4.nextElement();
            if(!arg5.equals(arg6.get(v0_1))) {
                continue;
            }

            v3[v1] = ((String)v0_1);
            ++v1;
        }

        return v3;
    }

    private static boolean isHexDigit(char arg1) {
        boolean v0;
        if(48 > arg1 || arg1 > 57) {
            if(97 <= arg1 && arg1 <= 102) {
                goto label_12;
            }

            if(65 <= arg1 && arg1 <= 70) {
            label_12:
                v0 = true;
                return v0;
            }

            v0 = false;
        }
        else {
            goto label_12;
        }

        return v0;
    }

    public static boolean rDNAreEqual(RDN arg6, RDN arg7) {
        boolean v1 = false;
        if(arg6.isMultiValued()) {
            if(arg7.isMultiValued()) {
                AttributeTypeAndValue[] v2 = arg6.getTypesAndValues();
                AttributeTypeAndValue[] v3 = arg7.getTypesAndValues();
                if(v2.length == v3.length) {
                    int v0 = 0;
                    while(true) {
                        if(v0 == v2.length) {
                            break;
                        }
                        else if(IETFUtils.atvAreEqual(v2[v0], v3[v0])) {
                            ++v0;
                            continue;
                        }

                        return v1;
                    }

                    v1 = true;
                }
            }
        }
        else if(!arg7.isMultiValued()) {
            v1 = IETFUtils.atvAreEqual(arg6.getFirst(), arg7.getFirst());
        }

        return v1;
    }

    public static RDN[] rDNsFromString(String arg10, X500NameStyle arg11) {
        Vector v6;
        Vector v5;
        String v4;
        X500NameTokenizer v2_1;
        X500NameTokenizer v3;
        String v2;
        char v9 = '+';
        char v8 = '=';
        X500NameTokenizer v0 = new X500NameTokenizer(arg10);
        X500NameBuilder v1 = new X500NameBuilder(arg11);
    label_6:
        while(v0.hasMoreTokens()) {
            v2 = v0.nextToken();
            if(v2.indexOf(v9) > 0) {
                v3 = new X500NameTokenizer(v2, v9);
                v2_1 = new X500NameTokenizer(v3.nextToken(), v8);
                v4 = v2_1.nextToken();
                if(!v2_1.hasMoreTokens()) {
                    throw new IllegalArgumentException("badly formatted directory string");
                }

                v2 = v2_1.nextToken();
                ASN1ObjectIdentifier v4_1 = arg11.attrNameToOID(v4.trim());
                if(v3.hasMoreTokens()) {
                    v5 = new Vector();
                    v6 = new Vector();
                    v5.addElement(v4_1);
                    v6.addElement(IETFUtils.unescape(v2));
                    goto label_35;
                }

                v1.addRDN(v4_1, IETFUtils.unescape(v2));
                continue;
            }

            v3 = new X500NameTokenizer(v2, v8);
            v2 = v3.nextToken();
            if(!v3.hasMoreTokens()) {
                throw new IllegalArgumentException("badly formatted directory string");
            }

            v1.addRDN(arg11.attrNameToOID(v2.trim()), IETFUtils.unescape(v3.nextToken()));
        }

        return v1.build().getRDNs();
    label_35:
        while(v3.hasMoreTokens()) {
            v2_1 = new X500NameTokenizer(v3.nextToken(), v8);
            v4 = v2_1.nextToken();
            if(!v2_1.hasMoreTokens()) {
                throw new IllegalArgumentException("badly formatted directory string");
            }

            v2 = v2_1.nextToken();
            v5.addElement(arg11.attrNameToOID(v4.trim()));
            v6.addElement(IETFUtils.unescape(v2));
        }

        v1.addMultiValuedRDN(IETFUtils.toOIDArray(v5), IETFUtils.toValueArray(v6));
        goto label_6;
    }

    public static String stripInternalSpaces(String arg5) {
        int v4 = 32;
        StringBuffer v3 = new StringBuffer();
        if(arg5.length() != 0) {
            char v1 = arg5.charAt(0);
            v3.append(v1);
            int v0 = 1;
            while(v0 < arg5.length()) {
                char v2 = arg5.charAt(v0);
                if(v1 != v4 || v2 != v4) {
                    v3.append(v2);
                }

                ++v0;
                int v1_1 = v2;
            }
        }

        return v3.toString();
    }

    private static ASN1ObjectIdentifier[] toOIDArray(Vector arg3) {
        ASN1ObjectIdentifier[] v2 = new ASN1ObjectIdentifier[arg3.size()];
        int v1;
        for(v1 = 0; v1 != v2.length; ++v1) {
            v2[v1] = arg3.elementAt(v1);
        }

        return v2;
    }

    private static String[] toValueArray(Vector arg3) {
        String[] v2 = new String[arg3.size()];
        int v1;
        for(v1 = 0; v1 != v2.length; ++v1) {
            v2[v1] = arg3.elementAt(v1);
        }

        return v2;
    }

    private static String unescape(String arg15) {
        String v0_1;
        int v0;
        int v14 = 34;
        int v13 = 92;
        int v12 = 32;
        if(arg15.length() != 0) {
            if(arg15.indexOf(v13) < 0 && arg15.indexOf(v14) < 0) {
                goto label_11;
            }

            char[] v9 = arg15.toCharArray();
            StringBuffer v10 = new StringBuffer(arg15.length());
            if(v9[0] != v13 || v9[1] != 35) {
                v0 = 0;
            }
            else {
                v0 = 2;
                v10.append("\\#");
            }

            char v2 = '\u0000';
            int v3 = 0;
            int v4 = 0;
            int v5 = 0;
            int v6 = 0;
            while(v0 != v9.length) {
                char v8 = v9[v0];
                if(v8 != v12) {
                    v4 = 1;
                }

                if(v8 == v14) {
                    if(v6 != 0) {
                        v10.append(v8);
                    }
                    else if(v5 == 0) {
                        v5 = 1;
                    }
                    else {
                        v5 = 0;
                    }

                    v6 = 0;
                }
                else {
                    if(v8 == v13 && v6 == 0 && v5 == 0) {
                        v3 = v10.length();
                        v6 = 1;
                        goto label_40;
                    }

                    if(v8 == v12 && v6 == 0 && v4 == 0) {
                        goto label_40;
                    }

                    if(v6 != 0 && (IETFUtils.isHexDigit(v8))) {
                        if(v2 != 0) {
                            v10.append(((char)(IETFUtils.convertHex(v2) * 16 + IETFUtils.convertHex(v8))));
                            v2 = '\u0000';
                            v6 = 0;
                        }
                        else {
                            v2 = v8;
                        }

                        goto label_40;
                    }

                    v10.append(v8);
                    v6 = 0;
                }

            label_40:
                ++v0;
            }

            if(v10.length() > 0) {
                while(v10.charAt(v10.length() - 1) == v12) {
                    if(v3 == v10.length() - 1) {
                        break;
                    }

                    v10.setLength(v10.length() - 1);
                }
            }

            v0_1 = v10.toString();
        }
        else {
        label_11:
            v0_1 = arg15.trim();
        }

        return v0_1;
    }

    public static ASN1Encodable valueFromHexString(String arg4, int arg5) {
        byte[] v1 = new byte[(arg4.length() - arg5) / 2];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = ((byte)(IETFUtils.convertHex(arg4.charAt(v0 * 2 + arg5)) << 4 | IETFUtils.convertHex(arg4.charAt(v0 * 2 + arg5 + 1))));
        }

        return ASN1Primitive.fromByteArray(v1);
    }

    public static String valueToString(ASN1Encodable arg9) {
        int v8 = 35;
        int v7 = 32;
        int v0 = 2;
        char v6 = '\\';
        StringBuffer v3 = new StringBuffer();
        if(!(arg9 instanceof ASN1String) || ((arg9 instanceof DERUniversalString))) {
            try {
                v3.append("#" + IETFUtils.bytesToString(Hex.encode(arg9.toASN1Primitive().getEncoded("DER"))));
            }
            catch(IOException v0_1) {
                throw new IllegalArgumentException("Other value has no encoded form");
            }
        }
        else {
            String v1 = ((ASN1String)arg9).getString();
            if(v1.length() > 0 && v1.charAt(0) == v8) {
                v3.append("\\" + v1);
                goto label_23;
            }

            v3.append(v1);
        }

    label_23:
        int v1_1 = v3.length();
        if(v3.length() < v0 || v3.charAt(0) != v6 || v3.charAt(1) != v8) {
            v0 = 0;
        }

        while(v0 != v1_1) {
            if(v3.charAt(v0) == 44 || v3.charAt(v0) == 34 || v3.charAt(v0) == v6 || v3.charAt(v0) == 43 || v3.charAt(v0) == 61 || v3.charAt(v0) == 60 || v3.charAt(v0) == 62 || v3.charAt(v0) == 59) {
                v3.insert(v0, "\\");
                ++v0;
                ++v1_1;
            }

            ++v0;
        }

        if(v3.length() > 0) {
            for(v0 = 0; v3.charAt(v0) == v7; v0 += 2) {
                v3.insert(v0, "\\");
            }
        }

        for(v0 = v3.length() - 1; v0 >= 0; --v0) {
            if(v3.charAt(v0) != v7) {
                break;
            }

            v3.insert(v0, v6);
        }

        return v3.toString();
    }
}

