// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class AccessDescription extends ASN1Object {
    GeneralName accessLocation;
    ASN1ObjectIdentifier accessMethod;
    public static final ASN1ObjectIdentifier id_ad_caIssuers;
    public static final ASN1ObjectIdentifier id_ad_ocsp;

    static {
        AccessDescription.id_ad_caIssuers = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.48.2");
        AccessDescription.id_ad_ocsp = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.48.1");
    }

    public AccessDescription(ASN1ObjectIdentifier arg2, GeneralName arg3) {
        super();
        this.accessMethod = null;
        this.accessLocation = null;
        this.accessMethod = arg2;
        this.accessLocation = arg3;
    }

    private AccessDescription(ASN1Sequence arg3) {
        super();
        this.accessMethod = null;
        this.accessLocation = null;
        if(arg3.size() != 2) {
            throw new IllegalArgumentException("wrong number of elements in sequence");
        }

        this.accessMethod = ASN1ObjectIdentifier.getInstance(arg3.getObjectAt(0));
        this.accessLocation = GeneralName.getInstance(arg3.getObjectAt(1));
    }

    public GeneralName getAccessLocation() {
        return this.accessLocation;
    }

    public ASN1ObjectIdentifier getAccessMethod() {
        return this.accessMethod;
    }

    public static AccessDescription getInstance(Object arg2) {
        AccessDescription v2;
        if(!(arg2 instanceof AccessDescription)) {
            if(arg2 != null) {
                v2 = new AccessDescription(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.accessMethod);
        v0.add(this.accessLocation);
        return new DERSequence(v0);
    }

    public String toString() {
        return "AccessDescription: Oid(" + this.accessMethod.getId() + ")";
    }
}

