// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;

public class AlgorithmIdentifier extends ASN1Object {
    private ASN1ObjectIdentifier objectId;
    private ASN1Encodable parameters;
    private boolean parametersDefined;

    public AlgorithmIdentifier(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        super();
        this.parametersDefined = false;
        this.parametersDefined = true;
        this.objectId = arg2;
        this.parameters = arg3;
    }

    public AlgorithmIdentifier(ASN1ObjectIdentifier arg2) {
        super();
        this.parametersDefined = false;
        this.objectId = arg2;
    }

    public AlgorithmIdentifier(String arg2) {
        super();
        this.parametersDefined = false;
        this.objectId = new ASN1ObjectIdentifier(arg2);
    }

    public AlgorithmIdentifier(ASN1Sequence arg5) {
        int v3 = 2;
        super();
        this.parametersDefined = false;
        if(arg5.size() >= 1 && arg5.size() <= v3) {
            this.objectId = ASN1ObjectIdentifier.getInstance(arg5.getObjectAt(0));
            if(arg5.size() == v3) {
                this.parametersDefined = true;
                this.parameters = arg5.getObjectAt(1);
            }
            else {
                this.parameters = null;
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
    }

    public AlgorithmIdentifier(DERObjectIdentifier arg3) {
        super();
        this.parametersDefined = false;
        this.objectId = new ASN1ObjectIdentifier(arg3.getId());
    }

    public AlgorithmIdentifier(DERObjectIdentifier arg3, ASN1Encodable arg4) {
        super();
        this.parametersDefined = false;
        this.parametersDefined = true;
        this.objectId = new ASN1ObjectIdentifier(arg3.getId());
        this.parameters = arg4;
    }

    public ASN1ObjectIdentifier getAlgorithm() {
        return new ASN1ObjectIdentifier(this.objectId.getId());
    }

    public static AlgorithmIdentifier getInstance(Object arg2) {
        AlgorithmIdentifier v2;
        if(arg2 != null && !(arg2 instanceof AlgorithmIdentifier)) {
            if((arg2 instanceof ASN1ObjectIdentifier)) {
                v2 = new AlgorithmIdentifier(((ASN1ObjectIdentifier)arg2));
            }
            else if((arg2 instanceof String)) {
                v2 = new AlgorithmIdentifier(((String)arg2));
            }
            else {
                v2 = new AlgorithmIdentifier(ASN1Sequence.getInstance(arg2));
            }
        }

        return v2;
    }

    public static AlgorithmIdentifier getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return AlgorithmIdentifier.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1ObjectIdentifier getObjectId() {
        return this.objectId;
    }

    public ASN1Encodable getParameters() {
        return this.parameters;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.objectId);
        if(this.parametersDefined) {
            if(this.parameters != null) {
                v0.add(this.parameters);
            }
            else {
                v0.add(DERNull.INSTANCE);
            }
        }

        return new DERSequence(v0);
    }
}

