// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class AttCertValidityPeriod extends ASN1Object {
    ASN1GeneralizedTime notAfterTime;
    ASN1GeneralizedTime notBeforeTime;

    public AttCertValidityPeriod(ASN1GeneralizedTime arg1, ASN1GeneralizedTime arg2) {
        super();
        this.notBeforeTime = arg1;
        this.notAfterTime = arg2;
    }

    private AttCertValidityPeriod(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.notBeforeTime = ASN1GeneralizedTime.getInstance(arg4.getObjectAt(0));
        this.notAfterTime = ASN1GeneralizedTime.getInstance(arg4.getObjectAt(1));
    }

    public static AttCertValidityPeriod getInstance(Object arg2) {
        AttCertValidityPeriod v2;
        if(!(arg2 instanceof AttCertValidityPeriod)) {
            if(arg2 != null) {
                v2 = new AttCertValidityPeriod(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ASN1GeneralizedTime getNotAfterTime() {
        return this.notAfterTime;
    }

    public ASN1GeneralizedTime getNotBeforeTime() {
        return this.notBeforeTime;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.notBeforeTime);
        v0.add(this.notAfterTime);
        return new DERSequence(v0);
    }
}

