// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERSequence;

public class Attribute extends ASN1Object {
    private ASN1ObjectIdentifier attrType;
    private ASN1Set attrValues;

    public Attribute(ASN1ObjectIdentifier arg1, ASN1Set arg2) {
        super();
        this.attrType = arg1;
        this.attrValues = arg2;
    }

    private Attribute(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.attrType = ASN1ObjectIdentifier.getInstance(arg4.getObjectAt(0));
        this.attrValues = ASN1Set.getInstance(arg4.getObjectAt(1));
    }

    public ASN1ObjectIdentifier getAttrType() {
        return new ASN1ObjectIdentifier(this.attrType.getId());
    }

    public ASN1Set getAttrValues() {
        return this.attrValues;
    }

    public ASN1Encodable[] getAttributeValues() {
        return this.attrValues.toArray();
    }

    public static Attribute getInstance(Object arg2) {
        if(!(arg2 instanceof Attribute)) {
            if(arg2 != null) {
                Attribute v2 = new Attribute(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.attrType);
        v0.add(this.attrValues);
        return new DERSequence(v0);
    }
}

