// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class AttributeCertificate extends ASN1Object {
    AttributeCertificateInfo acinfo;
    AlgorithmIdentifier signatureAlgorithm;
    DERBitString signatureValue;

    public AttributeCertificate(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.acinfo = AttributeCertificateInfo.getInstance(arg4.getObjectAt(0));
        this.signatureAlgorithm = AlgorithmIdentifier.getInstance(arg4.getObjectAt(1));
        this.signatureValue = DERBitString.getInstance(arg4.getObjectAt(2));
    }

    public AttributeCertificate(AttributeCertificateInfo arg1, AlgorithmIdentifier arg2, DERBitString arg3) {
        super();
        this.acinfo = arg1;
        this.signatureAlgorithm = arg2;
        this.signatureValue = arg3;
    }

    public AttributeCertificateInfo getAcinfo() {
        return this.acinfo;
    }

    public static AttributeCertificate getInstance(Object arg2) {
        if(!(arg2 instanceof AttributeCertificate)) {
            if(arg2 != null) {
                AttributeCertificate v2 = new AttributeCertificate(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public AlgorithmIdentifier getSignatureAlgorithm() {
        return this.signatureAlgorithm;
    }

    public DERBitString getSignatureValue() {
        return this.signatureValue;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.acinfo);
        v0.add(this.signatureAlgorithm);
        v0.add(this.signatureValue);
        return new DERSequence(v0);
    }
}

