// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class AttributeCertificateInfo extends ASN1Object {
    private AttCertValidityPeriod attrCertValidityPeriod;
    private ASN1Sequence attributes;
    private Extensions extensions;
    private Holder holder;
    private AttCertIssuer issuer;
    private DERBitString issuerUniqueID;
    private ASN1Integer serialNumber;
    private AlgorithmIdentifier signature;
    private ASN1Integer version;

    private AttributeCertificateInfo(ASN1Sequence arg4) {
        int v0 = 7;
        super();
        if(arg4.size() >= v0 && arg4.size() <= 9) {
            this.version = ASN1Integer.getInstance(arg4.getObjectAt(0));
            this.holder = Holder.getInstance(arg4.getObjectAt(1));
            this.issuer = AttCertIssuer.getInstance(arg4.getObjectAt(2));
            this.signature = AlgorithmIdentifier.getInstance(arg4.getObjectAt(3));
            this.serialNumber = ASN1Integer.getInstance(arg4.getObjectAt(4));
            this.attrCertValidityPeriod = AttCertValidityPeriod.getInstance(arg4.getObjectAt(5));
            this.attributes = ASN1Sequence.getInstance(arg4.getObjectAt(6));
            while(v0 < arg4.size()) {
                ASN1Encodable v1 = arg4.getObjectAt(v0);
                if((v1 instanceof DERBitString)) {
                    this.issuerUniqueID = DERBitString.getInstance(arg4.getObjectAt(v0));
                }
                else {
                    if(!(v1 instanceof ASN1Sequence) && !(v1 instanceof Extensions)) {
                        goto label_53;
                    }

                    this.extensions = Extensions.getInstance(arg4.getObjectAt(v0));
                }

            label_53:
                ++v0;
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public AttCertValidityPeriod getAttrCertValidityPeriod() {
        return this.attrCertValidityPeriod;
    }

    public ASN1Sequence getAttributes() {
        return this.attributes;
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public Holder getHolder() {
        return this.holder;
    }

    public static AttributeCertificateInfo getInstance(Object arg2) {
        if(!(arg2 instanceof AttributeCertificateInfo)) {
            if(arg2 != null) {
                AttributeCertificateInfo v2 = new AttributeCertificateInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static AttributeCertificateInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return AttributeCertificateInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public AttCertIssuer getIssuer() {
        return this.issuer;
    }

    public DERBitString getIssuerUniqueID() {
        return this.issuerUniqueID;
    }

    public ASN1Integer getSerialNumber() {
        return this.serialNumber;
    }

    public AlgorithmIdentifier getSignature() {
        return this.signature;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(this.holder);
        v0.add(this.issuer);
        v0.add(this.signature);
        v0.add(this.serialNumber);
        v0.add(this.attrCertValidityPeriod);
        v0.add(this.attributes);
        if(this.issuerUniqueID != null) {
            v0.add(this.issuerUniqueID);
        }

        if(this.extensions != null) {
            v0.add(this.extensions);
        }

        return new DERSequence(v0);
    }
}

