// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class AuthorityInformationAccess extends ASN1Object {
    private AccessDescription[] descriptions;

    public AuthorityInformationAccess(ASN1ObjectIdentifier arg4, GeneralName arg5) {
        super();
        this.descriptions = new AccessDescription[1];
        this.descriptions[0] = new AccessDescription(arg4, arg5);
    }

    private AuthorityInformationAccess(ASN1Sequence arg4) {
        super();
        if(arg4.size() < 1) {
            throw new IllegalArgumentException("sequence may not be empty");
        }

        this.descriptions = new AccessDescription[arg4.size()];
        int v0;
        for(v0 = 0; v0 != arg4.size(); ++v0) {
            this.descriptions[v0] = AccessDescription.getInstance(arg4.getObjectAt(v0));
        }
    }

    public AccessDescription[] getAccessDescriptions() {
        return this.descriptions;
    }

    public static AuthorityInformationAccess getInstance(Object arg2) {
        if(!(arg2 instanceof AuthorityInformationAccess)) {
            if(arg2 != null) {
                AuthorityInformationAccess v2 = new AuthorityInformationAccess(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 != this.descriptions.length; ++v0) {
            v1.add(this.descriptions[v0]);
        }

        return new DERSequence(v1);
    }

    public String toString() {
        return "AuthorityInformationAccess: Oid(" + this.descriptions[0].getAccessMethod().getId() + ")";
    }
}

