// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;

public class AuthorityKeyIdentifier extends ASN1Object {
    GeneralNames certissuer;
    ASN1Integer certserno;
    ASN1OctetString keyidentifier;

    public AuthorityKeyIdentifier(ASN1Sequence arg5) {
        super();
        this.keyidentifier = null;
        this.certissuer = null;
        this.certserno = null;
        Enumeration v0 = arg5.getObjects();
        while(v0.hasMoreElements()) {
            ASN1TaggedObject v1 = DERTaggedObject.getInstance(v0.nextElement());
            switch(v1.getTagNo()) {
                case 0: {
                    goto label_17;
                }
                case 1: {
                    goto label_20;
                }
                case 2: {
                    goto label_23;
                }
            }

            throw new IllegalArgumentException("illegal tag");
        label_20:
            this.certissuer = GeneralNames.getInstance(v1, false);
            continue;
        label_17:
            this.keyidentifier = ASN1OctetString.getInstance(v1, false);
            continue;
        label_23:
            this.certserno = ASN1Integer.getInstance(v1, false);
        }
    }

    public AuthorityKeyIdentifier(GeneralNames arg2, BigInteger arg3) {
        super();
        this.keyidentifier = null;
        this.certissuer = null;
        this.certserno = null;
        this.keyidentifier = null;
        this.certissuer = GeneralNames.getInstance(arg2.toASN1Primitive());
        this.certserno = new ASN1Integer(arg3);
    }

    public AuthorityKeyIdentifier(SubjectPublicKeyInfo arg6) {
        super();
        this.keyidentifier = null;
        this.certissuer = null;
        this.certserno = null;
        SHA1Digest v0 = new SHA1Digest();
        byte[] v1 = new byte[((Digest)v0).getDigestSize()];
        byte[] v2 = arg6.getPublicKeyData().getBytes();
        ((Digest)v0).update(v2, 0, v2.length);
        ((Digest)v0).doFinal(v1, 0);
        this.keyidentifier = new DEROctetString(v1);
    }

    public AuthorityKeyIdentifier(SubjectPublicKeyInfo arg6, GeneralNames arg7, BigInteger arg8) {
        super();
        this.keyidentifier = null;
        this.certissuer = null;
        this.certserno = null;
        SHA1Digest v0 = new SHA1Digest();
        byte[] v1 = new byte[((Digest)v0).getDigestSize()];
        byte[] v2 = arg6.getPublicKeyData().getBytes();
        ((Digest)v0).update(v2, 0, v2.length);
        ((Digest)v0).doFinal(v1, 0);
        this.keyidentifier = new DEROctetString(v1);
        this.certissuer = GeneralNames.getInstance(arg7.toASN1Primitive());
        this.certserno = new ASN1Integer(arg8);
    }

    public AuthorityKeyIdentifier(byte[] arg3) {
        super();
        this.keyidentifier = null;
        this.certissuer = null;
        this.certserno = null;
        this.keyidentifier = new DEROctetString(arg3);
        this.certissuer = null;
        this.certserno = null;
    }

    public AuthorityKeyIdentifier(byte[] arg2, GeneralNames arg3, BigInteger arg4) {
        super();
        this.keyidentifier = null;
        this.certissuer = null;
        this.certserno = null;
        this.keyidentifier = new DEROctetString(arg2);
        this.certissuer = GeneralNames.getInstance(arg3.toASN1Primitive());
        this.certserno = new ASN1Integer(arg4);
    }

    public static AuthorityKeyIdentifier fromExtensions(Extensions arg1) {
        return AuthorityKeyIdentifier.getInstance(arg1.getExtensionParsedValue(Extension.authorityKeyIdentifier));
    }

    public GeneralNames getAuthorityCertIssuer() {
        return this.certissuer;
    }

    public BigInteger getAuthorityCertSerialNumber() {
        BigInteger v0 = this.certserno != null ? this.certserno.getValue() : null;
        return v0;
    }

    public static AuthorityKeyIdentifier getInstance(Object arg2) {
        AuthorityKeyIdentifier v2;
        if(!(arg2 instanceof AuthorityKeyIdentifier)) {
            if(arg2 != null) {
                v2 = new AuthorityKeyIdentifier(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static AuthorityKeyIdentifier getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return AuthorityKeyIdentifier.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public byte[] getKeyIdentifier() {
        byte[] v0 = this.keyidentifier != null ? this.keyidentifier.getOctets() : null;
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.keyidentifier != null) {
            v0.add(new DERTaggedObject(false, 0, this.keyidentifier));
        }

        if(this.certissuer != null) {
            v0.add(new DERTaggedObject(false, 1, this.certissuer));
        }

        if(this.certserno != null) {
            v0.add(new DERTaggedObject(false, 2, this.certserno));
        }

        return new DERSequence(v0);
    }

    public String toString() {
        return "AuthorityKeyIdentifier: KeyID(" + this.keyidentifier.getOctets() + ")";
    }
}

