// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBoolean;
import org.bouncycastle.asn1.DERSequence;

public class BasicConstraints extends ASN1Object {
    ASN1Boolean cA;
    ASN1Integer pathLenConstraint;

    public BasicConstraints(int arg4) {
        super();
        this.cA = ASN1Boolean.getInstance(false);
        this.pathLenConstraint = null;
        this.cA = ASN1Boolean.getInstance(true);
        this.pathLenConstraint = new ASN1Integer(((long)arg4));
    }

    private BasicConstraints(ASN1Sequence arg5) {
        ASN1Integer v2 = null;
        super();
        this.cA = ASN1Boolean.getInstance(false);
        this.pathLenConstraint = v2;
        if(arg5.size() == 0) {
            this.cA = ((ASN1Boolean)v2);
            this.pathLenConstraint = v2;
        }
        else {
            if((arg5.getObjectAt(0) instanceof DERBoolean)) {
                this.cA = DERBoolean.getInstance(arg5.getObjectAt(0));
            }
            else {
                this.cA = ((ASN1Boolean)v2);
                this.pathLenConstraint = ASN1Integer.getInstance(arg5.getObjectAt(0));
            }

            if(arg5.size() <= 1) {
                return;
            }

            if(this.cA != null) {
                this.pathLenConstraint = ASN1Integer.getInstance(arg5.getObjectAt(1));
                return;
            }

            throw new IllegalArgumentException("wrong sequence in constructor");
        }
    }

    public BasicConstraints(boolean arg3) {
        ASN1Integer v1 = null;
        super();
        this.cA = ASN1Boolean.getInstance(false);
        this.pathLenConstraint = v1;
        this.cA = arg3 ? ASN1Boolean.getInstance(true) : ((ASN1Boolean)v1);
        this.pathLenConstraint = v1;
    }

    public static BasicConstraints fromExtensions(Extensions arg1) {
        return BasicConstraints.getInstance(arg1.getExtensionParsedValue(Extension.basicConstraints));
    }

    public static BasicConstraints getInstance(Object arg2) {
        BasicConstraints v2;
        if(!(arg2 instanceof BasicConstraints)) {
            if((arg2 instanceof X509Extension)) {
                v2 = BasicConstraints.getInstance(X509Extension.convertValueToObject(((X509Extension)arg2)));
            }
            else if(arg2 != null) {
                v2 = new BasicConstraints(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static BasicConstraints getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return BasicConstraints.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public BigInteger getPathLenConstraint() {
        BigInteger v0 = this.pathLenConstraint != null ? this.pathLenConstraint.getValue() : null;
        return v0;
    }

    public boolean isCA() {
        boolean v0 = this.cA == null || !this.cA.isTrue() ? false : true;
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.cA != null) {
            v0.add(this.cA);
        }

        if(this.pathLenConstraint != null) {
            v0.add(this.pathLenConstraint);
        }

        return new DERSequence(v0);
    }

    public String toString() {
        String v0;
        if(this.pathLenConstraint != null) {
            v0 = "BasicConstraints: isCa(" + this.isCA() + "), pathLenConstraint = " + this.pathLenConstraint.getValue();
        }
        else if(this.cA == null) {
            v0 = "BasicConstraints: isCa(false)";
        }
        else {
            v0 = "BasicConstraints: isCa(" + this.isCA() + ")";
        }

        return v0;
    }
}

