// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import java.util.Hashtable;
import org.bouncycastle.asn1.ASN1Enumerated;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.util.Integers;

public class CRLReason extends ASN1Object {
    public static final int AA_COMPROMISE = 10;
    public static final int AFFILIATION_CHANGED = 3;
    public static final int CA_COMPROMISE = 2;
    public static final int CERTIFICATE_HOLD = 6;
    public static final int CESSATION_OF_OPERATION = 5;
    public static final int KEY_COMPROMISE = 1;
    public static final int PRIVILEGE_WITHDRAWN = 9;
    public static final int REMOVE_FROM_CRL = 8;
    public static final int SUPERSEDED = 4;
    public static final int UNSPECIFIED = 0;
    public static final int aACompromise = 10;
    public static final int affiliationChanged = 3;
    public static final int cACompromise = 2;
    public static final int certificateHold = 6;
    public static final int cessationOfOperation = 5;
    public static final int keyCompromise = 1;
    public static final int privilegeWithdrawn = 9;
    private static final String[] reasonString = null;
    public static final int removeFromCRL = 8;
    public static final int superseded = 4;
    private static final Hashtable table;
    public static final int unspecified;
    private ASN1Enumerated value;

    static {
        CRLReason.reasonString = new String[]{"unspecified", "keyCompromise", "cACompromise", "affiliationChanged", "superseded", "cessationOfOperation", "certificateHold", "unknown", "removeFromCRL", "privilegeWithdrawn", "aACompromise"};
        CRLReason.table = new Hashtable();
    }

    private CRLReason(int arg2) {
        super();
        this.value = new ASN1Enumerated(arg2);
    }

    public static CRLReason getInstance(Object arg1) {
        CRLReason v1;
        if(!(arg1 instanceof CRLReason)) {
            if(arg1 != null) {
                v1 = CRLReason.lookup(ASN1Enumerated.getInstance(arg1).getValue().intValue());
            }
            else {
                arg1 = null;
            }
        }

        return v1;
    }

    public BigInteger getValue() {
        return this.value.getValue();
    }

    public static CRLReason lookup(int arg3) {
        Integer v0 = Integers.valueOf(arg3);
        if(!CRLReason.table.containsKey(v0)) {
            CRLReason.table.put(v0, new CRLReason(arg3));
        }

        return CRLReason.table.get(v0);
    }

    public ASN1Primitive toASN1Primitive() {
        return this.value;
    }

    public String toString() {
        int v0 = this.getValue().intValue();
        String v0_1 = v0 < 0 || v0 > 10 ? "invalid" : CRLReason.reasonString[v0];
        return "CRLReason: " + v0_1;
    }
}

