// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.x500.X500Name;

public class Certificate extends ASN1Object {
    ASN1Sequence seq;
    DERBitString sig;
    AlgorithmIdentifier sigAlgId;
    TBSCertificate tbsCert;

    private Certificate(ASN1Sequence arg3) {
        super();
        this.seq = arg3;
        if(arg3.size() == 3) {
            this.tbsCert = TBSCertificate.getInstance(arg3.getObjectAt(0));
            this.sigAlgId = AlgorithmIdentifier.getInstance(arg3.getObjectAt(1));
            this.sig = DERBitString.getInstance(arg3.getObjectAt(2));
            return;
        }

        throw new IllegalArgumentException("sequence wrong size for a certificate");
    }

    public Time getEndDate() {
        return this.tbsCert.getEndDate();
    }

    public static Certificate getInstance(Object arg2) {
        Certificate v2;
        if(!(arg2 instanceof Certificate)) {
            if(arg2 != null) {
                v2 = new Certificate(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static Certificate getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return Certificate.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public X500Name getIssuer() {
        return this.tbsCert.getIssuer();
    }

    public ASN1Integer getSerialNumber() {
        return this.tbsCert.getSerialNumber();
    }

    public DERBitString getSignature() {
        return this.sig;
    }

    public AlgorithmIdentifier getSignatureAlgorithm() {
        return this.sigAlgId;
    }

    public Time getStartDate() {
        return this.tbsCert.getStartDate();
    }

    public X500Name getSubject() {
        return this.tbsCert.getSubject();
    }

    public SubjectPublicKeyInfo getSubjectPublicKeyInfo() {
        return this.tbsCert.getSubjectPublicKeyInfo();
    }

    public TBSCertificate getTBSCertificate() {
        return this.tbsCert;
    }

    public ASN1Integer getVersion() {
        return this.tbsCert.getVersion();
    }

    public int getVersionNumber() {
        return this.tbsCert.getVersionNumber();
    }

    public ASN1Primitive toASN1Primitive() {
        return this.seq;
    }
}

