// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class CertificatePair extends ASN1Object {
    private Certificate forward;
    private Certificate reverse;

    private CertificatePair(ASN1Sequence arg5) {
        ASN1TaggedObject v1;
        super();
        if(arg5.size() != 1 && arg5.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
        }

        Enumeration v0 = arg5.getObjects();
        while(true) {
            if(!v0.hasMoreElements()) {
                return;
            }

            v1 = ASN1TaggedObject.getInstance(v0.nextElement());
            if(v1.getTagNo() == 0) {
                this.forward = Certificate.getInstance(v1, true);
                continue;
            }

            if(v1.getTagNo() != 1) {
                break;
            }

            this.reverse = Certificate.getInstance(v1, true);
        }

        throw new IllegalArgumentException("Bad tag number: " + v1.getTagNo());
    }

    public CertificatePair(Certificate arg1, Certificate arg2) {
        super();
        this.forward = arg1;
        this.reverse = arg2;
    }

    public Certificate getForward() {
        return this.forward;
    }

    public static CertificatePair getInstance(Object arg3) {
        CertificatePair v3;
        if(arg3 != null && !(arg3 instanceof CertificatePair)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new CertificatePair(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public Certificate getReverse() {
        return this.reverse;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.forward != null) {
            v0.add(new DERTaggedObject(0, this.forward));
        }

        if(this.reverse != null) {
            v0.add(new DERTaggedObject(1, this.reverse));
        }

        return new DERSequence(v0);
    }
}

