// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class DSAParameter extends ASN1Object {
    ASN1Integer g;
    ASN1Integer p;
    ASN1Integer q;

    public DSAParameter(BigInteger arg2, BigInteger arg3, BigInteger arg4) {
        super();
        this.p = new ASN1Integer(arg2);
        this.q = new ASN1Integer(arg3);
        this.g = new ASN1Integer(arg4);
    }

    private DSAParameter(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        Enumeration v0 = arg4.getObjects();
        this.p = ASN1Integer.getInstance(v0.nextElement());
        this.q = ASN1Integer.getInstance(v0.nextElement());
        this.g = ASN1Integer.getInstance(v0.nextElement());
    }

    public BigInteger getG() {
        return this.g.getPositiveValue();
    }

    public static DSAParameter getInstance(Object arg2) {
        if(!(arg2 instanceof DSAParameter)) {
            if(arg2 != null) {
                DSAParameter v2 = new DSAParameter(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static DSAParameter getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DSAParameter.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public BigInteger getP() {
        return this.p.getPositiveValue();
    }

    public BigInteger getQ() {
        return this.q.getPositiveValue();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.p);
        v0.add(this.q);
        v0.add(this.g);
        return new DERSequence(v0);
    }
}

