// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class DigestInfo extends ASN1Object {
    private AlgorithmIdentifier algId;
    private byte[] digest;

    public DigestInfo(AlgorithmIdentifier arg1, byte[] arg2) {
        super();
        this.digest = arg2;
        this.algId = arg1;
    }

    public DigestInfo(ASN1Sequence arg3) {
        super();
        Enumeration v0 = arg3.getObjects();
        this.algId = AlgorithmIdentifier.getInstance(v0.nextElement());
        this.digest = ASN1OctetString.getInstance(v0.nextElement()).getOctets();
    }

    public AlgorithmIdentifier getAlgorithmId() {
        return this.algId;
    }

    public byte[] getDigest() {
        return this.digest;
    }

    public static DigestInfo getInstance(Object arg2) {
        if(!(arg2 instanceof DigestInfo)) {
            if(arg2 != null) {
                DigestInfo v2 = new DigestInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static DigestInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DigestInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.algId);
        v0.add(new DEROctetString(this.digest));
        return new DERSequence(v0);
    }
}

