// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class DistributionPoint extends ASN1Object {
    GeneralNames cRLIssuer;
    DistributionPointName distributionPoint;
    ReasonFlags reasons;

    public DistributionPoint(ASN1Sequence arg5) {
        super();
        int v0;
        for(v0 = 0; v0 != arg5.size(); ++v0) {
            ASN1TaggedObject v2 = ASN1TaggedObject.getInstance(arg5.getObjectAt(v0));
            switch(v2.getTagNo()) {
                case 0: {
                    this.distributionPoint = DistributionPointName.getInstance(v2, true);
                    break;
                }
                case 1: {
                    this.reasons = new ReasonFlags(DERBitString.getInstance(v2, false));
                    break;
                }
                case 2: {
                    this.cRLIssuer = GeneralNames.getInstance(v2, false);
                    break;
                }
            }
        }
    }

    public DistributionPoint(DistributionPointName arg1, ReasonFlags arg2, GeneralNames arg3) {
        super();
        this.distributionPoint = arg1;
        this.reasons = arg2;
        this.cRLIssuer = arg3;
    }

    private void appendObject(StringBuffer arg3, String arg4, String arg5, String arg6) {
        arg3.append("    ");
        arg3.append(arg5);
        arg3.append(":");
        arg3.append(arg4);
        arg3.append("    ");
        arg3.append("    ");
        arg3.append(arg6);
        arg3.append(arg4);
    }

    public GeneralNames getCRLIssuer() {
        return this.cRLIssuer;
    }

    public DistributionPointName getDistributionPoint() {
        return this.distributionPoint;
    }

    public static DistributionPoint getInstance(Object arg3) {
        DistributionPoint v3;
        if(arg3 != null && !(arg3 instanceof DistributionPoint)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new DistributionPoint(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid DistributionPoint: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static DistributionPoint getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DistributionPoint.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ReasonFlags getReasons() {
        return this.reasons;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.distributionPoint != null) {
            v0.add(new DERTaggedObject(0, this.distributionPoint));
        }

        if(this.reasons != null) {
            v0.add(new DERTaggedObject(false, 1, this.reasons));
        }

        if(this.cRLIssuer != null) {
            v0.add(new DERTaggedObject(false, 2, this.cRLIssuer));
        }

        return new DERSequence(v0);
    }

    public String toString() {
        String v0 = System.getProperty("line.separator");
        StringBuffer v1 = new StringBuffer();
        v1.append("DistributionPoint: [");
        v1.append(v0);
        if(this.distributionPoint != null) {
            this.appendObject(v1, v0, "distributionPoint", this.distributionPoint.toString());
        }

        if(this.reasons != null) {
            this.appendObject(v1, v0, "reasons", this.reasons.toString());
        }

        if(this.cRLIssuer != null) {
            this.appendObject(v1, v0, "cRLIssuer", this.cRLIssuer.toString());
        }

        v1.append("]");
        v1.append(v0);
        return v1.toString();
    }
}

