// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERTaggedObject;

public class DistributionPointName extends ASN1Object implements ASN1Choice {
    public static final int FULL_NAME = 0;
    public static final int NAME_RELATIVE_TO_CRL_ISSUER = 1;
    ASN1Encodable name;
    int type;

    public DistributionPointName(int arg1, ASN1Encodable arg2) {
        super();
        this.type = arg1;
        this.name = arg2;
    }

    public DistributionPointName(ASN1TaggedObject arg3) {
        super();
        this.type = arg3.getTagNo();
        this.name = this.type == 0 ? GeneralNames.getInstance(arg3, false) : ASN1Set.getInstance(arg3, false);
    }

    public DistributionPointName(GeneralNames arg2) {
        this(0, ((ASN1Encodable)arg2));
    }

    private void appendObject(StringBuffer arg3, String arg4, String arg5, String arg6) {
        arg3.append("    ");
        arg3.append(arg5);
        arg3.append(":");
        arg3.append(arg4);
        arg3.append("    ");
        arg3.append("    ");
        arg3.append(arg6);
        arg3.append(arg4);
    }

    public static DistributionPointName getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DistributionPointName.getInstance(ASN1TaggedObject.getInstance(arg1, true));
    }

    public static DistributionPointName getInstance(Object arg3) {
        DistributionPointName v3;
        if(arg3 != null && !(arg3 instanceof DistributionPointName)) {
            if((arg3 instanceof ASN1TaggedObject)) {
                v3 = new DistributionPointName(((ASN1TaggedObject)arg3));
            }
            else {
                throw new IllegalArgumentException("unknown object in factory: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public ASN1Encodable getName() {
        return this.name;
    }

    public int getType() {
        return this.type;
    }

    public ASN1Primitive toASN1Primitive() {
        return new DERTaggedObject(false, this.type, this.name);
    }

    public String toString() {
        String v0 = System.getProperty("line.separator");
        StringBuffer v1 = new StringBuffer();
        v1.append("DistributionPointName: [");
        v1.append(v0);
        if(this.type == 0) {
            this.appendObject(v1, v0, "fullName", this.name.toString());
        }
        else {
            this.appendObject(v1, v0, "nameRelativeToCRLIssuer", this.name.toString());
        }

        v1.append("]");
        v1.append(v0);
        return v1.toString();
    }
}

