// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class ExtendedKeyUsage extends ASN1Object {
    ASN1Sequence seq;
    Hashtable usageTable;

    public ExtendedKeyUsage(Vector arg5) {
        super();
        this.usageTable = new Hashtable();
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        Enumeration v2 = arg5.elements();
        while(v2.hasMoreElements()) {
            Object v0 = v2.nextElement();
            v1.add(((ASN1Encodable)v0));
            this.usageTable.put(v0, v0);
        }

        this.seq = new DERSequence(v1);
    }

    private ExtendedKeyUsage(ASN1Sequence arg4) {
        super();
        this.usageTable = new Hashtable();
        this.seq = arg4;
        Enumeration v1 = arg4.getObjects();
        while(v1.hasMoreElements()) {
            Object v0 = v1.nextElement();
            if(!(((ASN1Encodable)v0).toASN1Primitive() instanceof ASN1ObjectIdentifier)) {
                throw new IllegalArgumentException("Only ASN1ObjectIdentifiers allowed in ExtendedKeyUsage.");
            }

            this.usageTable.put(v0, v0);
        }
    }

    public ExtendedKeyUsage(KeyPurposeId arg2) {
        super();
        this.usageTable = new Hashtable();
        this.seq = new DERSequence(((ASN1Encodable)arg2));
        this.usageTable.put(arg2, arg2);
    }

    public ExtendedKeyUsage(KeyPurposeId[] arg6) {
        super();
        this.usageTable = new Hashtable();
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 != arg6.length; ++v0) {
            v1.add(arg6[v0]);
            this.usageTable.put(arg6[v0], arg6[v0]);
        }

        this.seq = new DERSequence(v1);
    }

    public static ExtendedKeyUsage fromExtensions(Extensions arg1) {
        return ExtendedKeyUsage.getInstance(arg1.getExtensionParsedValue(Extension.extendedKeyUsage));
    }

    public static ExtendedKeyUsage getInstance(Object arg2) {
        if(!(arg2 instanceof ExtendedKeyUsage)) {
            if(arg2 != null) {
                ExtendedKeyUsage v2 = new ExtendedKeyUsage(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static ExtendedKeyUsage getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return ExtendedKeyUsage.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public KeyPurposeId[] getUsages() {
        KeyPurposeId[] v2 = new KeyPurposeId[this.seq.size()];
        int v0 = 0;
        Enumeration v3 = this.seq.getObjects();
        while(v3.hasMoreElements()) {
            v2[v0] = KeyPurposeId.getInstance(v3.nextElement());
            ++v0;
        }

        return v2;
    }

    public boolean hasKeyPurposeId(KeyPurposeId arg2) {
        boolean v0 = this.usageTable.get(arg2) != null ? true : false;
        return v0;
    }

    public int size() {
        return this.usageTable.size();
    }

    public ASN1Primitive toASN1Primitive() {
        return this.seq;
    }
}

