// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;

public class Extension extends ASN1Object {
    public static final ASN1ObjectIdentifier auditIdentity;
    public static final ASN1ObjectIdentifier authorityInfoAccess;
    public static final ASN1ObjectIdentifier authorityKeyIdentifier;
    public static final ASN1ObjectIdentifier basicConstraints;
    public static final ASN1ObjectIdentifier biometricInfo;
    public static final ASN1ObjectIdentifier cRLDistributionPoints;
    public static final ASN1ObjectIdentifier cRLNumber;
    public static final ASN1ObjectIdentifier certificateIssuer;
    public static final ASN1ObjectIdentifier certificatePolicies;
    private boolean critical;
    public static final ASN1ObjectIdentifier deltaCRLIndicator;
    public static final ASN1ObjectIdentifier extendedKeyUsage;
    private ASN1ObjectIdentifier extnId;
    public static final ASN1ObjectIdentifier freshestCRL;
    public static final ASN1ObjectIdentifier inhibitAnyPolicy;
    public static final ASN1ObjectIdentifier instructionCode;
    public static final ASN1ObjectIdentifier invalidityDate;
    public static final ASN1ObjectIdentifier issuerAlternativeName;
    public static final ASN1ObjectIdentifier issuingDistributionPoint;
    public static final ASN1ObjectIdentifier keyUsage;
    public static final ASN1ObjectIdentifier logoType;
    public static final ASN1ObjectIdentifier nameConstraints;
    public static final ASN1ObjectIdentifier noRevAvail;
    public static final ASN1ObjectIdentifier policyConstraints;
    public static final ASN1ObjectIdentifier policyMappings;
    public static final ASN1ObjectIdentifier privateKeyUsagePeriod;
    public static final ASN1ObjectIdentifier qCStatements;
    public static final ASN1ObjectIdentifier reasonCode;
    public static final ASN1ObjectIdentifier subjectAlternativeName;
    public static final ASN1ObjectIdentifier subjectDirectoryAttributes;
    public static final ASN1ObjectIdentifier subjectInfoAccess;
    public static final ASN1ObjectIdentifier subjectKeyIdentifier;
    public static final ASN1ObjectIdentifier targetInformation;
    private ASN1OctetString value;

    static {
        Extension.subjectDirectoryAttributes = new ASN1ObjectIdentifier("2.5.29.9");
        Extension.subjectKeyIdentifier = new ASN1ObjectIdentifier("2.5.29.14");
        Extension.keyUsage = new ASN1ObjectIdentifier("2.5.29.15");
        Extension.privateKeyUsagePeriod = new ASN1ObjectIdentifier("2.5.29.16");
        Extension.subjectAlternativeName = new ASN1ObjectIdentifier("2.5.29.17");
        Extension.issuerAlternativeName = new ASN1ObjectIdentifier("2.5.29.18");
        Extension.basicConstraints = new ASN1ObjectIdentifier("2.5.29.19");
        Extension.cRLNumber = new ASN1ObjectIdentifier("2.5.29.20");
        Extension.reasonCode = new ASN1ObjectIdentifier("2.5.29.21");
        Extension.instructionCode = new ASN1ObjectIdentifier("2.5.29.23");
        Extension.invalidityDate = new ASN1ObjectIdentifier("2.5.29.24");
        Extension.deltaCRLIndicator = new ASN1ObjectIdentifier("2.5.29.27");
        Extension.issuingDistributionPoint = new ASN1ObjectIdentifier("2.5.29.28");
        Extension.certificateIssuer = new ASN1ObjectIdentifier("2.5.29.29");
        Extension.nameConstraints = new ASN1ObjectIdentifier("2.5.29.30");
        Extension.cRLDistributionPoints = new ASN1ObjectIdentifier("2.5.29.31");
        Extension.certificatePolicies = new ASN1ObjectIdentifier("2.5.29.32");
        Extension.policyMappings = new ASN1ObjectIdentifier("2.5.29.33");
        Extension.authorityKeyIdentifier = new ASN1ObjectIdentifier("2.5.29.35");
        Extension.policyConstraints = new ASN1ObjectIdentifier("2.5.29.36");
        Extension.extendedKeyUsage = new ASN1ObjectIdentifier("2.5.29.37");
        Extension.freshestCRL = new ASN1ObjectIdentifier("2.5.29.46");
        Extension.inhibitAnyPolicy = new ASN1ObjectIdentifier("2.5.29.54");
        Extension.authorityInfoAccess = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.1");
        Extension.subjectInfoAccess = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.11");
        Extension.logoType = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.12");
        Extension.biometricInfo = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.2");
        Extension.qCStatements = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.3");
        Extension.auditIdentity = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.4");
        Extension.noRevAvail = new ASN1ObjectIdentifier("2.5.29.56");
        Extension.targetInformation = new ASN1ObjectIdentifier("2.5.29.55");
    }

    public Extension(ASN1ObjectIdentifier arg2, ASN1Boolean arg3, ASN1OctetString arg4) {
        this(arg2, arg3.isTrue(), arg4);
    }

    public Extension(ASN1ObjectIdentifier arg1, boolean arg2, ASN1OctetString arg3) {
        super();
        this.extnId = arg1;
        this.critical = arg2;
        this.value = arg3;
    }

    public Extension(ASN1ObjectIdentifier arg2, boolean arg3, byte[] arg4) {
        this(arg2, arg3, new DEROctetString(arg4));
    }

    private Extension(ASN1Sequence arg6) {
        int v4 = 2;
        super();
        if(arg6.size() == v4) {
            this.extnId = ASN1ObjectIdentifier.getInstance(arg6.getObjectAt(0));
            this.critical = false;
            this.value = ASN1OctetString.getInstance(arg6.getObjectAt(1));
        }
        else if(arg6.size() == 3) {
            this.extnId = ASN1ObjectIdentifier.getInstance(arg6.getObjectAt(0));
            this.critical = ASN1Boolean.getInstance(arg6.getObjectAt(1)).isTrue();
            this.value = ASN1OctetString.getInstance(arg6.getObjectAt(v4));
        }
        else {
            goto label_28;
        }

        return;
    label_28:
        throw new IllegalArgumentException("Bad sequence size: " + arg6.size());
    }

    private static ASN1Primitive convertValueToObject(Extension arg4) {
        try {
            return ASN1Primitive.fromByteArray(arg4.getExtnValue().getOctets());
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("can\'t convert extension: " + v0);
        }
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof Extension)) && (((Extension)arg4).getExtnId().equals(this.getExtnId())) && (((Extension)arg4).getExtnValue().equals(this.getExtnValue())) && ((Extension)arg4).isCritical() == this.isCritical()) {
            v0 = true;
        }

        return v0;
    }

    public ASN1ObjectIdentifier getExtnId() {
        return this.extnId;
    }

    public ASN1OctetString getExtnValue() {
        return this.value;
    }

    public static Extension getInstance(Object arg2) {
        if(!(arg2 instanceof Extension)) {
            if(arg2 != null) {
                Extension v2 = new Extension(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Encodable getParsedValue() {
        return Extension.convertValueToObject(this);
    }

    public int hashCode() {
        int v0 = this.isCritical() ? this.getExtnValue().hashCode() ^ this.getExtnId().hashCode() : this.getExtnValue().hashCode() ^ this.getExtnId().hashCode() ^ -1;
        return v0;
    }

    public boolean isCritical() {
        return this.critical;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.extnId);
        if(this.critical) {
            v0.add(ASN1Boolean.getInstance(true));
        }

        v0.add(this.value);
        return new DERSequence(v0);
    }
}

