// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class Extensions extends ASN1Object {
    private Hashtable extensions;
    private Vector ordering;

    private Extensions(ASN1Sequence arg5) {
        super();
        this.extensions = new Hashtable();
        this.ordering = new Vector();
        Enumeration v0 = arg5.getObjects();
        while(v0.hasMoreElements()) {
            Extension v1 = Extension.getInstance(v0.nextElement());
            this.extensions.put(v1.getExtnId(), v1);
            this.ordering.addElement(v1.getExtnId());
        }
    }

    public Extensions(Extension arg3) {
        super();
        this.extensions = new Hashtable();
        this.ordering = new Vector();
        this.ordering.addElement(arg3.getExtnId());
        this.extensions.put(arg3.getExtnId(), arg3);
    }

    public Extensions(Extension[] arg5) {
        super();
        this.extensions = new Hashtable();
        this.ordering = new Vector();
        int v0;
        for(v0 = 0; v0 != arg5.length; ++v0) {
            Extension v1 = arg5[v0];
            this.ordering.addElement(v1.getExtnId());
            this.extensions.put(v1.getExtnId(), v1);
        }
    }

    public boolean equivalent(Extensions arg6) {
        boolean v0 = false;
        if(this.extensions.size() == arg6.extensions.size()) {
            Enumeration v1 = this.extensions.keys();
            do {
                if(v1.hasMoreElements()) {
                    Object v2 = v1.nextElement();
                    if(this.extensions.get(v2).equals(arg6.extensions.get(v2))) {
                        continue;
                    }

                    return v0;
                }
                else {
                    goto label_19;
                }
            }
            while(true);

            return v0;
        label_19:
            v0 = true;
        }

        return v0;
    }

    public ASN1ObjectIdentifier[] getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    public Extension getExtension(ASN1ObjectIdentifier arg2) {
        return this.extensions.get(arg2);
    }

    private ASN1ObjectIdentifier[] getExtensionOIDs(boolean arg5) {
        Vector v2 = new Vector();
        int v1;
        for(v1 = 0; v1 != this.ordering.size(); ++v1) {
            Object v3 = this.ordering.elementAt(v1);
            if(this.extensions.get(v3).isCritical() == arg5) {
                v2.addElement(v3);
            }
        }

        return this.toOidArray(v2);
    }

    public ASN1ObjectIdentifier[] getExtensionOIDs() {
        return this.toOidArray(this.ordering);
    }

    public ASN1Encodable getExtensionParsedValue(ASN1ObjectIdentifier arg2) {
        Extension v0 = this.getExtension(arg2);
        ASN1Encodable v0_1 = v0 != null ? v0.getParsedValue() : null;
        return v0_1;
    }

    public static Extensions getInstance(Object arg2) {
        if(!(arg2 instanceof Extensions)) {
            if(arg2 != null) {
                Extensions v2 = new Extensions(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static Extensions getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return Extensions.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1ObjectIdentifier[] getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public Enumeration oids() {
        return this.ordering.elements();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        Enumeration v2 = this.ordering.elements();
        while(v2.hasMoreElements()) {
            v1.add(this.extensions.get(v2.nextElement()));
        }

        return new DERSequence(v1);
    }

    private ASN1ObjectIdentifier[] toOidArray(Vector arg4) {
        ASN1ObjectIdentifier[] v2 = new ASN1ObjectIdentifier[arg4.size()];
        int v1;
        for(v1 = 0; v1 != v2.length; ++v1) {
            v2[v1] = arg4.elementAt(v1);
        }

        return v2;
    }
}

