// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.io.IOException;
import java.util.StringTokenizer;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.util.IPAddress;

public class GeneralName extends ASN1Object implements ASN1Choice {
    public static final int dNSName = 2;
    public static final int directoryName = 4;
    public static final int ediPartyName = 5;
    public static final int iPAddress = 7;
    private ASN1Encodable obj;
    public static final int otherName = 0;
    public static final int registeredID = 8;
    public static final int rfc822Name = 1;
    private int tag;
    public static final int uniformResourceIdentifier = 6;
    public static final int x400Address = 3;

    public GeneralName(X500Name arg2) {
        super();
        this.obj = ((ASN1Encodable)arg2);
        this.tag = 4;
    }

    public GeneralName(int arg4, String arg5) {
        super();
        this.tag = arg4;
        if(arg4 == 1 || arg4 == 2 || arg4 == 6) {
            this.obj = new DERIA5String(arg5);
        }
        else if(arg4 == 8) {
            this.obj = new ASN1ObjectIdentifier(arg5);
        }
        else if(arg4 == 4) {
            this.obj = new X500Name(arg5);
        }
        else if(arg4 == 7) {
            byte[] v0 = this.toGeneralNameEncoding(arg5);
            if(v0 != null) {
                this.obj = new DEROctetString(v0);
            }
            else {
                throw new IllegalArgumentException("IP Address is invalid");
            }
        }
        else {
            throw new IllegalArgumentException("can\'t process String for tag: " + arg4);
        }
    }

    public GeneralName(int arg1, ASN1Encodable arg2) {
        super();
        this.obj = arg2;
        this.tag = arg1;
    }

    public GeneralName(X509Name arg2) {
        super();
        this.obj = X500Name.getInstance(arg2);
        this.tag = 4;
    }

    private void copyInts(int[] arg4, byte[] arg5, int arg6) {
        int v0;
        for(v0 = 0; v0 != arg4.length; ++v0) {
            arg5[v0 * 2 + arg6] = ((byte)(arg4[v0] >> 8));
            arg5[v0 * 2 + 1 + arg6] = ((byte)arg4[v0]);
        }
    }

    public static GeneralName getInstance(Object arg4) {
        GeneralName v4;
        if(arg4 != null && !(arg4 instanceof GeneralName)) {
            if((arg4 instanceof ASN1TaggedObject)) {
                Object v0 = arg4;
                int v1 = ((ASN1TaggedObject)v0).getTagNo();
                switch(v1) {
                    case 0: {
                        goto label_15;
                    }
                    case 1: {
                        goto label_19;
                    }
                    case 2: {
                        goto label_23;
                    }
                    case 3: {
                        goto label_27;
                    }
                    case 4: {
                        goto label_36;
                    }
                    case 5: {
                        goto label_41;
                    }
                    case 6: {
                        goto label_45;
                    }
                    case 7: {
                        goto label_49;
                    }
                    case 8: {
                        goto label_53;
                    }
                }

                goto label_10;
            label_53:
                v4 = new GeneralName(v1, ASN1ObjectIdentifier.getInstance(((ASN1TaggedObject)v0), false));
                return v4;
            label_19:
                return new GeneralName(v1, DERIA5String.getInstance(((ASN1TaggedObject)v0), false));
            label_49:
                return new GeneralName(v1, ASN1OctetString.getInstance(((ASN1TaggedObject)v0), false));
            label_23:
                return new GeneralName(v1, DERIA5String.getInstance(((ASN1TaggedObject)v0), false));
            label_36:
                return new GeneralName(v1, X500Name.getInstance(((ASN1TaggedObject)v0), true));
            label_45:
                return new GeneralName(v1, DERIA5String.getInstance(((ASN1TaggedObject)v0), false));
            label_27:
                throw new IllegalArgumentException("unknown tag: " + v1);
            label_41:
                return new GeneralName(v1, ASN1Sequence.getInstance(((ASN1TaggedObject)v0), false));
            label_15:
                return new GeneralName(v1, ASN1Sequence.getInstance(((ASN1TaggedObject)v0), false));
            }

        label_10:
            if((arg4 instanceof byte[])) {
                try {
                    return GeneralName.getInstance(ASN1Primitive.fromByteArray(((byte[])arg4)));
                }
                catch(IOException v0_1) {
                    throw new IllegalArgumentException("unable to parse encoded general name");
                }
            }

            throw new IllegalArgumentException("unknown object in getInstance: " + arg4.getClass().getName());
        }

        return v4;
    }

    public static GeneralName getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return GeneralName.getInstance(ASN1TaggedObject.getInstance(arg1, true));
    }

    public ASN1Encodable getName() {
        return this.obj;
    }

    public int getTagNo() {
        return this.tag;
    }

    private void parseIPv4(String arg5, byte[] arg6, int arg7) {
        StringTokenizer v2 = new StringTokenizer(arg5, "./");
        int v0;
        for(v0 = 0; v2.hasMoreTokens(); ++v0) {
            arg6[v0 + arg7] = ((byte)Integer.parseInt(v2.nextToken()));
        }
    }

    private void parseIPv4Mask(String arg7, byte[] arg8, int arg9) {
        int v1 = Integer.parseInt(arg7);
        int v0;
        for(v0 = 0; v0 != v1; ++v0) {
            int v2 = v0 / 8 + arg9;
            arg8[v2] = ((byte)(arg8[v2] | 1 << 7 - v0 % 8));
        }
    }

    private int[] parseIPv6(String arg11) {
        int v3 = 58;
        StringTokenizer v4 = new StringTokenizer(arg11, ":", true);
        int[] v5 = new int[8];
        if(arg11.charAt(0) == v3 && arg11.charAt(1) == v3) {
            v4.nextToken();
        }

        int v0 = -1;
        int v1 = 0;
        while(v4.hasMoreTokens()) {
            String v6 = v4.nextToken();
            if(v6.equals(":")) {
                v5[v1] = 0;
                int v9 = v1;
                ++v1;
                v0 = v9;
                continue;
            }

            if(v6.indexOf(46) < 0) {
                v3 = v1 + 1;
                v5[v1] = Integer.parseInt(v6, 16);
                if(v4.hasMoreTokens()) {
                    v4.nextToken();
                    v1 = v3;
                    continue;
                }

                v1 = v3;
                continue;
            }

            StringTokenizer v3_1 = new StringTokenizer(v6, ".");
            int v6_1 = v1 + 1;
            v5[v1] = Integer.parseInt(v3_1.nextToken()) << 8 | Integer.parseInt(v3_1.nextToken());
            v1 = v6_1 + 1;
            v5[v6_1] = Integer.parseInt(v3_1.nextToken()) | Integer.parseInt(v3_1.nextToken()) << 8;
        }

        if(v1 != v5.length) {
            System.arraycopy(v5, v0, v5, v5.length - (v1 - v0), v1 - v0);
            for(v3 = v0; v3 != v5.length - (v1 - v0); ++v3) {
                v5[v3] = 0;
            }
        }

        return v5;
    }

    private int[] parseMask(String arg8) {
        int[] v1 = new int[8];
        int v2 = Integer.parseInt(arg8);
        int v0;
        for(v0 = 0; v0 != v2; ++v0) {
            int v3 = v0 / 16;
            v1[v3] |= 1 << 15 - v0 % 16;
        }

        return v1;
    }

    public ASN1Primitive toASN1Primitive() {
        DERTaggedObject v0 = this.tag == 4 ? new DERTaggedObject(true, this.tag, this.obj) : new DERTaggedObject(false, this.tag, this.obj);
        return ((ASN1Primitive)v0);
    }

    private byte[] toGeneralNameEncoding(String arg7) {
        byte[] v0;
        int v1 = 47;
        int v5 = 16;
        int v4 = 4;
        if((IPAddress.isValidIPv6WithNetmask(arg7)) || (IPAddress.isValidIPv6(arg7))) {
            int v0_1 = arg7.indexOf(v1);
            if(v0_1 < 0) {
                v0 = new byte[v5];
                this.copyInts(this.parseIPv6(arg7), v0, 0);
                return v0;
            }

            byte[] v1_2 = new byte[32];
            this.copyInts(this.parseIPv6(arg7.substring(0, v0_1)), v1_2, 0);
            String v0_2 = arg7.substring(v0_1 + 1);
            int[] v0_3 = v0_2.indexOf(58) > 0 ? this.parseIPv6(v0_2) : this.parseMask(v0_2);
            this.copyInts(v0_3, v1_2, v5);
            v0 = v1_2;
        }
        else {
            if(!IPAddress.isValidIPv4WithNetmask(arg7) && !IPAddress.isValidIPv4(arg7)) {
                v0 = null;
                return v0;
            }

            v1 = arg7.indexOf(v1);
            if(v1 < 0) {
                v0 = new byte[v4];
                this.parseIPv4(arg7, v0, 0);
                return v0;
            }

            v0 = new byte[8];
            this.parseIPv4(arg7.substring(0, v1), v0, 0);
            String v1_1 = arg7.substring(v1 + 1);
            if(v1_1.indexOf(46) > 0) {
                this.parseIPv4(v1_1, v0, v4);
                return v0;
            }

            this.parseIPv4Mask(v1_1, v0, v4);
        }

        return v0;
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        v0.append(this.tag);
        v0.append(": ");
        switch(this.tag) {
            case 4: {
                v0.append(X500Name.getInstance(this.obj).toString());
                break;
            }
            case 1: 
            case 2: 
            case 6: {
                v0.append(DERIA5String.getInstance(this.obj).getString());
                break;
            }
            default: {
                v0.append(this.obj.toString());
                break;
            }
        }

        return v0.toString();
    }
}

