// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class GeneralSubtree extends ASN1Object {
    private static final BigInteger ZERO;
    private GeneralName base;
    private ASN1Integer maximum;
    private ASN1Integer minimum;

    static {
        GeneralSubtree.ZERO = BigInteger.valueOf(0);
    }

    private GeneralSubtree(ASN1Sequence arg5) {
        ASN1TaggedObject v0;
        super();
        this.base = GeneralName.getInstance(arg5.getObjectAt(0));
        switch(arg5.size()) {
            case 1: {
                break;
            }
            case 2: {
                v0 = ASN1TaggedObject.getInstance(arg5.getObjectAt(1));
                switch(v0.getTagNo()) {
                    case 0: {
                        this.minimum = ASN1Integer.getInstance(v0, false);
                        return;
                    }
                    case 1: {
                        this.maximum = ASN1Integer.getInstance(v0, false);
                        return;
                    }
                    default: {
                        throw new IllegalArgumentException("Bad tag number: " + v0.getTagNo());
                    }
                }
            }
            case 3: {
                v0 = ASN1TaggedObject.getInstance(arg5.getObjectAt(1));
                if(v0.getTagNo() != 0) {
                    throw new IllegalArgumentException("Bad tag number for \'minimum\': " + v0.getTagNo());
                }

                this.minimum = ASN1Integer.getInstance(v0, false);
                v0 = ASN1TaggedObject.getInstance(arg5.getObjectAt(2));
                if(v0.getTagNo() != 1) {
                    throw new IllegalArgumentException("Bad tag number for \'maximum\': " + v0.getTagNo());
                }

                this.maximum = ASN1Integer.getInstance(v0, false);
                break;
            }
            default: {
                throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
            }
        }
    }

    public GeneralSubtree(GeneralName arg2) {
        this(arg2, null, null);
    }

    public GeneralSubtree(GeneralName arg2, BigInteger arg3, BigInteger arg4) {
        super();
        this.base = arg2;
        if(arg4 != null) {
            this.maximum = new ASN1Integer(arg4);
        }

        this.minimum = arg3 == null ? null : new ASN1Integer(arg3);
    }

    public GeneralName getBase() {
        return this.base;
    }

    public static GeneralSubtree getInstance(Object arg2) {
        GeneralSubtree v2;
        if(arg2 == null) {
            arg2 = null;
        }
        else if((arg2 instanceof GeneralSubtree)) {
        }
        else {
            v2 = new GeneralSubtree(ASN1Sequence.getInstance(arg2));
        }

        return v2;
    }

    public static GeneralSubtree getInstance(ASN1TaggedObject arg2, boolean arg3) {
        return new GeneralSubtree(ASN1Sequence.getInstance(arg2, arg3));
    }

    public BigInteger getMaximum() {
        BigInteger v0 = this.maximum == null ? null : this.maximum.getValue();
        return v0;
    }

    public BigInteger getMinimum() {
        BigInteger v0 = this.minimum == null ? GeneralSubtree.ZERO : this.minimum.getValue();
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.base);
        if(this.minimum != null && !this.minimum.getValue().equals(GeneralSubtree.ZERO)) {
            v0.add(new DERTaggedObject(false, 0, this.minimum));
        }

        if(this.maximum != null) {
            v0.add(new DERTaggedObject(false, 1, this.maximum));
        }

        return new DERSequence(v0);
    }
}

