// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class Holder extends ASN1Object {
    public static final int V1_CERTIFICATE_HOLDER = 0;
    public static final int V2_CERTIFICATE_HOLDER = 1;
    IssuerSerial baseCertificateID;
    GeneralNames entityName;
    ObjectDigestInfo objectDigestInfo;
    private int version;

    private Holder(ASN1Sequence arg6) {
        super();
        this.version = 1;
        if(arg6.size() > 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg6.size());
        }

        int v0;
        for(v0 = 0; v0 != arg6.size(); ++v0) {
            ASN1TaggedObject v2 = ASN1TaggedObject.getInstance(arg6.getObjectAt(v0));
            switch(v2.getTagNo()) {
                case 0: {
                    goto label_28;
                }
                case 1: {
                    goto label_32;
                }
                case 2: {
                    goto label_35;
                }
            }

            throw new IllegalArgumentException("unknown tag in Holder");
        label_35:
            this.objectDigestInfo = ObjectDigestInfo.getInstance(v2, false);
            goto label_30;
        label_28:
            this.baseCertificateID = IssuerSerial.getInstance(v2, false);
            goto label_30;
        label_32:
            this.entityName = GeneralNames.getInstance(v2, false);
        label_30:
        }

        this.version = 1;
    }

    private Holder(ASN1TaggedObject arg3) {
        super();
        this.version = 1;
        switch(arg3.getTagNo()) {
            case 0: {
                goto label_10;
            }
            case 1: {
                goto label_14;
            }
        }

        throw new IllegalArgumentException("unknown tag in Holder");
    label_10:
        this.baseCertificateID = IssuerSerial.getInstance(arg3, false);
        goto label_12;
    label_14:
        this.entityName = GeneralNames.getInstance(arg3, false);
    label_12:
        this.version = 0;
    }

    public Holder(GeneralNames arg2) {
        this(arg2, 1);
    }

    public Holder(GeneralNames arg2, int arg3) {
        super();
        this.version = 1;
        this.entityName = arg2;
        this.version = arg3;
    }

    public Holder(IssuerSerial arg2) {
        this(arg2, 1);
    }

    public Holder(IssuerSerial arg2, int arg3) {
        super();
        this.version = 1;
        this.baseCertificateID = arg2;
        this.version = arg3;
    }

    public Holder(ObjectDigestInfo arg2) {
        super();
        this.version = 1;
        this.objectDigestInfo = arg2;
    }

    public IssuerSerial getBaseCertificateID() {
        return this.baseCertificateID;
    }

    public GeneralNames getEntityName() {
        return this.entityName;
    }

    public static Holder getInstance(Object arg2) {
        Holder v2;
        if(!(arg2 instanceof Holder)) {
            if((arg2 instanceof ASN1TaggedObject)) {
                v2 = new Holder(ASN1TaggedObject.getInstance(arg2));
            }
            else if(arg2 != null) {
                v2 = new Holder(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public ObjectDigestInfo getObjectDigestInfo() {
        return this.objectDigestInfo;
    }

    public int getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        DERTaggedObject v0_1;
        DERSequence v0;
        if(this.version == 1) {
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            if(this.baseCertificateID != null) {
                v1.add(new DERTaggedObject(false, 0, this.baseCertificateID));
            }

            if(this.entityName != null) {
                v1.add(new DERTaggedObject(false, 1, this.entityName));
            }

            if(this.objectDigestInfo != null) {
                v1.add(new DERTaggedObject(false, 2, this.objectDigestInfo));
            }

            v0 = new DERSequence(v1);
        }
        else {
            if(this.entityName != null) {
                v0_1 = new DERTaggedObject(false, 1, this.entityName);
                goto label_27;
            }

            v0_1 = new DERTaggedObject(false, 0, this.baseCertificateID);
        }

    label_27:
        return ((ASN1Primitive)v0);
    }
}

