// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.DERUTF8String;

public class IetfAttrSyntax extends ASN1Object {
    public static final int VALUE_OCTETS = 1;
    public static final int VALUE_OID = 2;
    public static final int VALUE_UTF8 = 3;
    GeneralNames policyAuthority;
    int valueChoice;
    Vector values;

    private IetfAttrSyntax(ASN1Sequence arg7) {
        int v2;
        int v0;
        int v3 = 2;
        super();
        this.policyAuthority = null;
        this.values = new Vector();
        this.valueChoice = -1;
        if((arg7.getObjectAt(0) instanceof ASN1TaggedObject)) {
            this.policyAuthority = GeneralNames.getInstance(arg7.getObjectAt(0), false);
            v0 = 1;
        }
        else if(arg7.size() == v3) {
            this.policyAuthority = GeneralNames.getInstance(arg7.getObjectAt(0));
            v0 = 1;
        }
        else {
            v0 = 0;
        }

        if(!(arg7.getObjectAt(v0) instanceof ASN1Sequence)) {
            throw new IllegalArgumentException("Non-IetfAttrSyntax encoding");
        }

        Enumeration v4 = arg7.getObjectAt(v0).getObjects();
        while(true) {
            if(!v4.hasMoreElements()) {
                return;
            }

            Object v0_1 = v4.nextElement();
            if((v0_1 instanceof ASN1ObjectIdentifier)) {
                v2 = v3;
            }
            else if((v0_1 instanceof DERUTF8String)) {
                v2 = 3;
            }
            else if((v0_1 instanceof DEROctetString)) {
                v2 = 1;
            }
            else {
                break;
            }

            if(this.valueChoice < 0) {
                this.valueChoice = v2;
            }

            if(v2 != this.valueChoice) {
                throw new IllegalArgumentException("Mix of value types in IetfAttrSyntax");
            }

            this.values.addElement(v0_1);
        }

        throw new IllegalArgumentException("Bad value type encoding IetfAttrSyntax");
    }

    public static IetfAttrSyntax getInstance(Object arg2) {
        IetfAttrSyntax v2;
        if(!(arg2 instanceof IetfAttrSyntax)) {
            if(arg2 != null) {
                v2 = new IetfAttrSyntax(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public GeneralNames getPolicyAuthority() {
        return this.policyAuthority;
    }

    public int getValueType() {
        return this.valueChoice;
    }

    public Object[] getValues() {
        ASN1OctetString[] v0;
        if(this.getValueType() == 1) {
            ASN1OctetString[] v2 = new ASN1OctetString[this.values.size()];
            int v1;
            for(v1 = 0; v1 != v2.length; ++v1) {
                v2[v1] = this.values.elementAt(v1);
            }

            v0 = v2;
        }
        else if(this.getValueType() == 2) {
            ASN1ObjectIdentifier[] v2_1 = new ASN1ObjectIdentifier[this.values.size()];
            for(v1 = 0; v1 != v2_1.length; ++v1) {
                v2_1[v1] = this.values.elementAt(v1);
            }

            ASN1ObjectIdentifier[] v0_1 = v2_1;
        }
        else {
            DERUTF8String[] v2_2 = new DERUTF8String[this.values.size()];
            for(v1 = 0; v1 != v2_2.length; ++v1) {
                v2_2[v1] = this.values.elementAt(v1);
            }

            DERUTF8String[] v0_2 = v2_2;
        }

        return ((Object[])v0);
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        if(this.policyAuthority != null) {
            v1.add(new DERTaggedObject(0, this.policyAuthority));
        }

        ASN1EncodableVector v2 = new ASN1EncodableVector();
        Enumeration v3 = this.values.elements();
        while(v3.hasMoreElements()) {
            v2.add(v3.nextElement());
        }

        v1.add(new DERSequence(v2));
        return new DERSequence(v1);
    }
}

