// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class IssuerSerial extends ASN1Object {
    GeneralNames issuer;
    DERBitString issuerUID;
    ASN1Integer serial;

    private IssuerSerial(ASN1Sequence arg4) {
        int v2 = 3;
        int v1 = 2;
        super();
        if(arg4.size() != v1 && arg4.size() != v2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.issuer = GeneralNames.getInstance(arg4.getObjectAt(0));
        this.serial = ASN1Integer.getInstance(arg4.getObjectAt(1));
        if(arg4.size() == v2) {
            this.issuerUID = DERBitString.getInstance(arg4.getObjectAt(v1));
        }
    }

    public IssuerSerial(GeneralNames arg2, BigInteger arg3) {
        this(arg2, new ASN1Integer(arg3));
    }

    public IssuerSerial(GeneralNames arg1, ASN1Integer arg2) {
        super();
        this.issuer = arg1;
        this.serial = arg2;
    }

    public static IssuerSerial getInstance(Object arg2) {
        if(!(arg2 instanceof IssuerSerial)) {
            if(arg2 != null) {
                IssuerSerial v2 = new IssuerSerial(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static IssuerSerial getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return IssuerSerial.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public GeneralNames getIssuer() {
        return this.issuer;
    }

    public DERBitString getIssuerUID() {
        return this.issuerUID;
    }

    public ASN1Integer getSerial() {
        return this.serial;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.issuer);
        v0.add(this.serial);
        if(this.issuerUID != null) {
            v0.add(this.issuerUID);
        }

        return new DERSequence(v0);
    }
}

