// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Boolean;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class IssuingDistributionPoint extends ASN1Object {
    private DistributionPointName distributionPoint;
    private boolean indirectCRL;
    private boolean onlyContainsAttributeCerts;
    private boolean onlyContainsCACerts;
    private boolean onlyContainsUserCerts;
    private ReasonFlags onlySomeReasons;
    private ASN1Sequence seq;

    private IssuingDistributionPoint(ASN1Sequence arg5) {
        super();
        this.seq = arg5;
        int v0;
        for(v0 = 0; v0 != arg5.size(); ++v0) {
            ASN1TaggedObject v2 = ASN1TaggedObject.getInstance(arg5.getObjectAt(v0));
            switch(v2.getTagNo()) {
                case 0: {
                    goto label_14;
                }
                case 1: {
                    goto label_19;
                }
                case 2: {
                    goto label_23;
                }
                case 3: {
                    goto label_27;
                }
                case 4: {
                    goto label_32;
                }
                case 5: {
                    goto label_36;
                }
            }

            throw new IllegalArgumentException("unknown tag in IssuingDistributionPoint");
        label_19:
            this.onlyContainsUserCerts = ASN1Boolean.getInstance(v2, false).isTrue();
            goto label_17;
        label_23:
            this.onlyContainsCACerts = ASN1Boolean.getInstance(v2, false).isTrue();
            goto label_17;
        label_36:
            this.onlyContainsAttributeCerts = ASN1Boolean.getInstance(v2, false).isTrue();
            goto label_17;
        label_27:
            this.onlySomeReasons = new ReasonFlags(ReasonFlags.getInstance(v2, false));
            goto label_17;
        label_32:
            this.indirectCRL = ASN1Boolean.getInstance(v2, false).isTrue();
            goto label_17;
        label_14:
            this.distributionPoint = DistributionPointName.getInstance(v2, true);
        label_17:
        }
    }

    public IssuingDistributionPoint(DistributionPointName arg8, boolean arg9, boolean arg10) {
        this(arg8, false, false, null, arg9, arg10);
    }

    public IssuingDistributionPoint(DistributionPointName arg7, boolean arg8, boolean arg9, ReasonFlags arg10, boolean arg11, boolean arg12) {
        super();
        this.distributionPoint = arg7;
        this.indirectCRL = arg11;
        this.onlyContainsAttributeCerts = arg12;
        this.onlyContainsCACerts = arg9;
        this.onlyContainsUserCerts = arg8;
        this.onlySomeReasons = arg10;
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(arg7 != null) {
            v0.add(new DERTaggedObject(true, 0, ((ASN1Encodable)arg7)));
        }

        if(arg8) {
            v0.add(new DERTaggedObject(false, 1, ASN1Boolean.getInstance(true)));
        }

        if(arg9) {
            v0.add(new DERTaggedObject(false, 2, ASN1Boolean.getInstance(true)));
        }

        if(arg10 != null) {
            v0.add(new DERTaggedObject(false, 3, ((ASN1Encodable)arg10)));
        }

        if(arg11) {
            v0.add(new DERTaggedObject(false, 4, ASN1Boolean.getInstance(true)));
        }

        if(arg12) {
            v0.add(new DERTaggedObject(false, 5, ASN1Boolean.getInstance(true)));
        }

        this.seq = new DERSequence(v0);
    }

    private void appendObject(StringBuffer arg3, String arg4, String arg5, String arg6) {
        arg3.append("    ");
        arg3.append(arg5);
        arg3.append(":");
        arg3.append(arg4);
        arg3.append("    ");
        arg3.append("    ");
        arg3.append(arg6);
        arg3.append(arg4);
    }

    private String booleanToString(boolean arg2) {
        String v0 = arg2 ? "true" : "false";
        return v0;
    }

    public DistributionPointName getDistributionPoint() {
        return this.distributionPoint;
    }

    public static IssuingDistributionPoint getInstance(Object arg2) {
        if(!(arg2 instanceof IssuingDistributionPoint)) {
            if(arg2 != null) {
                IssuingDistributionPoint v2 = new IssuingDistributionPoint(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static IssuingDistributionPoint getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return IssuingDistributionPoint.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ReasonFlags getOnlySomeReasons() {
        return this.onlySomeReasons;
    }

    public boolean isIndirectCRL() {
        return this.indirectCRL;
    }

    public boolean onlyContainsAttributeCerts() {
        return this.onlyContainsAttributeCerts;
    }

    public boolean onlyContainsCACerts() {
        return this.onlyContainsCACerts;
    }

    public boolean onlyContainsUserCerts() {
        return this.onlyContainsUserCerts;
    }

    public ASN1Primitive toASN1Primitive() {
        return this.seq;
    }

    public String toString() {
        String v0 = System.getProperty("line.separator");
        StringBuffer v1 = new StringBuffer();
        v1.append("IssuingDistributionPoint: [");
        v1.append(v0);
        if(this.distributionPoint != null) {
            this.appendObject(v1, v0, "distributionPoint", this.distributionPoint.toString());
        }

        if(this.onlyContainsUserCerts) {
            this.appendObject(v1, v0, "onlyContainsUserCerts", this.booleanToString(this.onlyContainsUserCerts));
        }

        if(this.onlyContainsCACerts) {
            this.appendObject(v1, v0, "onlyContainsCACerts", this.booleanToString(this.onlyContainsCACerts));
        }

        if(this.onlySomeReasons != null) {
            this.appendObject(v1, v0, "onlySomeReasons", this.onlySomeReasons.toString());
        }

        if(this.onlyContainsAttributeCerts) {
            this.appendObject(v1, v0, "onlyContainsAttributeCerts", this.booleanToString(this.onlyContainsAttributeCerts));
        }

        if(this.indirectCRL) {
            this.appendObject(v1, v0, "indirectCRL", this.booleanToString(this.indirectCRL));
        }

        v1.append("]");
        v1.append(v0);
        return v1.toString();
    }
}

