// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBitString;

public class KeyUsage extends ASN1Object {
    private DERBitString bitString;
    public static final int cRLSign = 2;
    public static final int dataEncipherment = 16;
    public static final int decipherOnly = 32768;
    public static final int digitalSignature = 128;
    public static final int encipherOnly = 1;
    public static final int keyAgreement = 8;
    public static final int keyCertSign = 4;
    public static final int keyEncipherment = 32;
    public static final int nonRepudiation = 64;

    public KeyUsage(int arg2) {
        super();
        this.bitString = new DERBitString(arg2);
    }

    private KeyUsage(DERBitString arg1) {
        super();
        this.bitString = arg1;
    }

    public static KeyUsage fromExtensions(Extensions arg1) {
        return KeyUsage.getInstance(arg1.getExtensionParsedValue(Extension.keyUsage));
    }

    public byte[] getBytes() {
        return this.bitString.getBytes();
    }

    public static KeyUsage getInstance(Object arg2) {
        if(!(arg2 instanceof KeyUsage)) {
            if(arg2 != null) {
                KeyUsage v2 = new KeyUsage(DERBitString.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public int getPadBits() {
        return this.bitString.getPadBits();
    }

    public ASN1Primitive toASN1Primitive() {
        return this.bitString;
    }

    public String toString() {
        byte[] v0 = this.bitString.getBytes();
        String v0_1 = v0.length == 1 ? "KeyUsage: 0x" + Integer.toHexString(v0[0] & 255) : "KeyUsage: 0x" + Integer.toHexString(v0[0] & 255 | (v0[1] & 255) << 8);
        return v0_1;
    }
}

