// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class NameConstraints extends ASN1Object {
    private GeneralSubtree[] excluded;
    private GeneralSubtree[] permitted;

    private NameConstraints(ASN1Sequence arg5) {
        super();
        Enumeration v0 = arg5.getObjects();
        while(v0.hasMoreElements()) {
            ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0.nextElement());
            switch(v1.getTagNo()) {
                case 0: {
                    goto label_10;
                }
                case 1: {
                    goto label_14;
                }
            }

            continue;
        label_10:
            this.permitted = this.createArray(ASN1Sequence.getInstance(v1, false));
            continue;
        label_14:
            this.excluded = this.createArray(ASN1Sequence.getInstance(v1, false));
        }
    }

    public NameConstraints(GeneralSubtree[] arg1, GeneralSubtree[] arg2) {
        super();
        if(arg1 != null) {
            this.permitted = arg1;
        }

        if(arg2 != null) {
            this.excluded = arg2;
        }
    }

    private GeneralSubtree[] createArray(ASN1Sequence arg4) {
        GeneralSubtree[] v1 = new GeneralSubtree[arg4.size()];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = GeneralSubtree.getInstance(arg4.getObjectAt(v0));
        }

        return v1;
    }

    public GeneralSubtree[] getExcludedSubtrees() {
        return this.excluded;
    }

    public static NameConstraints getInstance(Object arg2) {
        NameConstraints v2;
        if(!(arg2 instanceof NameConstraints)) {
            if(arg2 != null) {
                v2 = new NameConstraints(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public GeneralSubtree[] getPermittedSubtrees() {
        return this.permitted;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.permitted != null) {
            v0.add(new DERTaggedObject(false, 0, new DERSequence(this.permitted)));
        }

        if(this.excluded != null) {
            v0.add(new DERTaggedObject(false, 1, new DERSequence(this.excluded)));
        }

        return new DERSequence(v0);
    }
}

