// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import java.util.Enumeration;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class NoticeReference extends ASN1Object {
    private ASN1Sequence noticeNumbers;
    private DisplayText organization;

    public NoticeReference(String arg2, Vector arg3) {
        this(arg2, NoticeReference.convertVector(arg3));
    }

    public NoticeReference(String arg2, ASN1EncodableVector arg3) {
        this(new DisplayText(arg2), arg3);
    }

    public NoticeReference(DisplayText arg2, ASN1EncodableVector arg3) {
        super();
        this.organization = arg2;
        this.noticeNumbers = new DERSequence(arg3);
    }

    private NoticeReference(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.organization = DisplayText.getInstance(arg4.getObjectAt(0));
        this.noticeNumbers = ASN1Sequence.getInstance(arg4.getObjectAt(1));
    }

    private static ASN1EncodableVector convertVector(Vector arg6) {
        ASN1Integer v0_1;
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        Enumeration v3 = arg6.elements();
        while(true) {
            if(!v3.hasMoreElements()) {
                return v2;
            }

            Object v0 = v3.nextElement();
            if((v0 instanceof BigInteger)) {
                v0_1 = new ASN1Integer(((BigInteger)v0));
            }
            else if((v0 instanceof Integer)) {
                v0_1 = new ASN1Integer(((long)((Integer)v0).intValue()));
            }
            else {
                break;
            }

            v2.add(((ASN1Encodable)v0_1));
        }

        throw new IllegalArgumentException();
        return v2;
    }

    public static NoticeReference getInstance(Object arg2) {
        if(!(arg2 instanceof NoticeReference)) {
            if(arg2 != null) {
                NoticeReference v2 = new NoticeReference(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Integer[] getNoticeNumbers() {
        ASN1Integer[] v1 = new ASN1Integer[this.noticeNumbers.size()];
        int v0;
        for(v0 = 0; v0 != this.noticeNumbers.size(); ++v0) {
            v1[v0] = ASN1Integer.getInstance(this.noticeNumbers.getObjectAt(v0));
        }

        return v1;
    }

    public DisplayText getOrganization() {
        return this.organization;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.organization);
        v0.add(this.noticeNumbers);
        return new DERSequence(v0);
    }
}

