// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Enumerated;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class ObjectDigestInfo extends ASN1Object {
    AlgorithmIdentifier digestAlgorithm;
    ASN1Enumerated digestedObjectType;
    DERBitString objectDigest;
    public static final int otherObjectDigest = 2;
    ASN1ObjectIdentifier otherObjectTypeID;
    public static final int publicKey = 0;
    public static final int publicKeyCert = 1;

    public ObjectDigestInfo(int arg2, ASN1ObjectIdentifier arg3, AlgorithmIdentifier arg4, byte[] arg5) {
        super();
        this.digestedObjectType = new ASN1Enumerated(arg2);
        if(arg2 == 2) {
            this.otherObjectTypeID = arg3;
        }

        this.digestAlgorithm = arg4;
        this.objectDigest = new DERBitString(arg5);
    }

    private ObjectDigestInfo(ASN1Sequence arg6) {
        int v4 = 4;
        int v0 = 1;
        super();
        if(arg6.size() <= v4 && arg6.size() >= 3) {
            this.digestedObjectType = ASN1Enumerated.getInstance(arg6.getObjectAt(0));
            if(arg6.size() == v4) {
                this.otherObjectTypeID = ASN1ObjectIdentifier.getInstance(arg6.getObjectAt(1));
            }
            else {
                v0 = 0;
            }

            this.digestAlgorithm = AlgorithmIdentifier.getInstance(arg6.getObjectAt(v0 + 1));
            this.objectDigest = DERBitString.getInstance(arg6.getObjectAt(v0 + 2));
            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg6.size());
    }

    public AlgorithmIdentifier getDigestAlgorithm() {
        return this.digestAlgorithm;
    }

    public ASN1Enumerated getDigestedObjectType() {
        return this.digestedObjectType;
    }

    public static ObjectDigestInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return ObjectDigestInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public static ObjectDigestInfo getInstance(Object arg2) {
        ObjectDigestInfo v2;
        if(!(arg2 instanceof ObjectDigestInfo)) {
            if(arg2 != null) {
                v2 = new ObjectDigestInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public DERBitString getObjectDigest() {
        return this.objectDigest;
    }

    public ASN1ObjectIdentifier getOtherObjectTypeID() {
        return this.otherObjectTypeID;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.digestedObjectType);
        if(this.otherObjectTypeID != null) {
            v0.add(this.otherObjectTypeID);
        }

        v0.add(this.digestAlgorithm);
        v0.add(this.objectDigest);
        return new DERSequence(v0);
    }
}

