// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class PolicyInformation extends ASN1Object {
    private ASN1ObjectIdentifier policyIdentifier;
    private ASN1Sequence policyQualifiers;

    public PolicyInformation(ASN1ObjectIdentifier arg1) {
        super();
        this.policyIdentifier = arg1;
    }

    public PolicyInformation(ASN1ObjectIdentifier arg1, ASN1Sequence arg2) {
        super();
        this.policyIdentifier = arg1;
        this.policyQualifiers = arg2;
    }

    private PolicyInformation(ASN1Sequence arg4) {
        super();
        if(arg4.size() >= 1 && arg4.size() <= 2) {
            this.policyIdentifier = ASN1ObjectIdentifier.getInstance(arg4.getObjectAt(0));
            if(arg4.size() > 1) {
                this.policyQualifiers = ASN1Sequence.getInstance(arg4.getObjectAt(1));
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public static PolicyInformation getInstance(Object arg2) {
        PolicyInformation v2;
        if(arg2 != null && !(arg2 instanceof PolicyInformation)) {
            v2 = new PolicyInformation(ASN1Sequence.getInstance(arg2));
        }

        return v2;
    }

    public ASN1ObjectIdentifier getPolicyIdentifier() {
        return this.policyIdentifier;
    }

    public ASN1Sequence getPolicyQualifiers() {
        return this.policyQualifiers;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.policyIdentifier);
        if(this.policyQualifiers != null) {
            v0.add(this.policyQualifiers);
        }

        return new DERSequence(v0);
    }
}

