// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERSequence;

public class PolicyQualifierInfo extends ASN1Object {
    private ASN1ObjectIdentifier policyQualifierId;
    private ASN1Encodable qualifier;

    public PolicyQualifierInfo(String arg2) {
        super();
        this.policyQualifierId = PolicyQualifierId.id_qt_cps;
        this.qualifier = new DERIA5String(arg2);
    }

    public PolicyQualifierInfo(ASN1ObjectIdentifier arg1, ASN1Encodable arg2) {
        super();
        this.policyQualifierId = arg1;
        this.qualifier = arg2;
    }

    public PolicyQualifierInfo(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.policyQualifierId = ASN1ObjectIdentifier.getInstance(arg4.getObjectAt(0));
        this.qualifier = arg4.getObjectAt(1);
    }

    public static PolicyQualifierInfo getInstance(Object arg2) {
        if(!(arg2 instanceof PolicyQualifierInfo)) {
            if(arg2 != null) {
                PolicyQualifierInfo v2 = new PolicyQualifierInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1ObjectIdentifier getPolicyQualifierId() {
        return this.policyQualifierId;
    }

    public ASN1Encodable getQualifier() {
        return this.qualifier;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.policyQualifierId);
        v0.add(this.qualifier);
        return new DERSequence(v0);
    }
}

