// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class RSAPublicKeyStructure extends ASN1Object {
    private BigInteger modulus;
    private BigInteger publicExponent;

    public RSAPublicKeyStructure(BigInteger arg1, BigInteger arg2) {
        super();
        this.modulus = arg1;
        this.publicExponent = arg2;
    }

    public RSAPublicKeyStructure(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        Enumeration v0 = arg4.getObjects();
        this.modulus = ASN1Integer.getInstance(v0.nextElement()).getPositiveValue();
        this.publicExponent = ASN1Integer.getInstance(v0.nextElement()).getPositiveValue();
    }

    public static RSAPublicKeyStructure getInstance(Object arg3) {
        RSAPublicKeyStructure v3;
        if(arg3 != null && !(arg3 instanceof RSAPublicKeyStructure)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new RSAPublicKeyStructure(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid RSAPublicKeyStructure: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static RSAPublicKeyStructure getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return RSAPublicKeyStructure.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public BigInteger getModulus() {
        return this.modulus;
    }

    public BigInteger getPublicExponent() {
        return this.publicExponent;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(this.getModulus()));
        v0.add(new ASN1Integer(this.getPublicExponent()));
        return new DERSequence(v0);
    }
}

