// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1String;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class RoleSyntax extends ASN1Object {
    private GeneralNames roleAuthority;
    private GeneralName roleName;

    public RoleSyntax(String arg3) {
        int v1 = 6;
        if(arg3 == null) {
            arg3 = "";
        }

        this(new GeneralName(v1, arg3));
    }

    public RoleSyntax(GeneralName arg2) {
        this(null, arg2);
    }

    private RoleSyntax(ASN1Sequence arg6) {
        super();
        if(arg6.size() >= 1 && arg6.size() <= 2) {
            int v0;
            for(v0 = 0; v0 != arg6.size(); ++v0) {
                ASN1TaggedObject v2 = ASN1TaggedObject.getInstance(arg6.getObjectAt(v0));
                switch(v2.getTagNo()) {
                    case 0: {
                        goto label_29;
                    }
                    case 1: {
                        goto label_33;
                    }
                }

                throw new IllegalArgumentException("Unknown tag in RoleSyntax");
            label_33:
                this.roleName = GeneralName.getInstance(v2, true);
                goto label_31;
            label_29:
                this.roleAuthority = GeneralNames.getInstance(v2, false);
            label_31:
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg6.size());
    }

    public RoleSyntax(GeneralNames arg3, GeneralName arg4) {
        super();
        if(arg4 != null && arg4.getTagNo() == 6 && !arg4.getName().getString().equals("")) {
            this.roleAuthority = arg3;
            this.roleName = arg4;
            return;
        }

        throw new IllegalArgumentException("the role name MUST be non empty and MUST use the URI option of GeneralName");
    }

    public static RoleSyntax getInstance(Object arg2) {
        if(!(arg2 instanceof RoleSyntax)) {
            if(arg2 != null) {
                RoleSyntax v2 = new RoleSyntax(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public GeneralNames getRoleAuthority() {
        return this.roleAuthority;
    }

    public String[] getRoleAuthorityAsString() {
        String[] v0;
        if(this.roleAuthority == null) {
            v0 = new String[0];
        }
        else {
            GeneralName[] v3 = this.roleAuthority.getNames();
            String[] v2 = new String[v3.length];
            int v1;
            for(v1 = 0; v1 < v3.length; ++v1) {
                ASN1Encodable v0_1 = v3[v1].getName();
                v2[v1] = (v0_1 instanceof ASN1String) ? ((ASN1String)v0_1).getString() : v0_1.toString();
            }

            v0 = v2;
        }

        return v0;
    }

    public GeneralName getRoleName() {
        return this.roleName;
    }

    public String getRoleNameAsString() {
        return this.roleName.getName().getString();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.roleAuthority != null) {
            v0.add(new DERTaggedObject(false, 0, this.roleAuthority));
        }

        v0.add(new DERTaggedObject(true, 1, this.roleName));
        return new DERSequence(v0);
    }

    public String toString() {
        StringBuffer v1 = new StringBuffer("Name: " + this.getRoleNameAsString() + " - Auth: ");
        if(this.roleAuthority == null || this.roleAuthority.getNames().length == 0) {
            v1.append("N/A");
        }
        else {
            String[] v2 = this.getRoleAuthorityAsString();
            v1.append('[').append(v2[0]);
            int v0;
            for(v0 = 1; v0 < v2.length; ++v0) {
                v1.append(", ").append(v2[v0]);
            }

            v1.append(']');
        }

        return v1.toString();
    }
}

