// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;

public class SubjectKeyIdentifier extends ASN1Object {
    private byte[] keyidentifier;

    public SubjectKeyIdentifier(byte[] arg1) {
        super();
        this.keyidentifier = arg1;
    }

    public SubjectKeyIdentifier(ASN1OctetString arg2) {
        super();
        this.keyidentifier = arg2.getOctets();
    }

    public SubjectKeyIdentifier(SubjectPublicKeyInfo arg2) {
        super();
        this.keyidentifier = SubjectKeyIdentifier.getDigest(arg2);
    }

    public static SubjectKeyIdentifier createSHA1KeyIdentifier(SubjectPublicKeyInfo arg1) {
        return new SubjectKeyIdentifier(arg1);
    }

    public static SubjectKeyIdentifier createTruncatedSHA1KeyIdentifier(SubjectPublicKeyInfo arg5) {
        byte[] v0 = SubjectKeyIdentifier.getDigest(arg5);
        byte[] v1 = new byte[8];
        System.arraycopy(v0, v0.length - 8, v1, 0, v1.length);
        v1[0] = ((byte)(v1[0] & 15));
        v1[0] = ((byte)(v1[0] | 64));
        return new SubjectKeyIdentifier(v1);
    }

    public static SubjectKeyIdentifier fromExtensions(Extensions arg1) {
        return SubjectKeyIdentifier.getInstance(arg1.getExtensionParsedValue(Extension.subjectKeyIdentifier));
    }

    private static byte[] getDigest(SubjectPublicKeyInfo arg5) {
        SHA1Digest v0 = new SHA1Digest();
        byte[] v1 = new byte[((Digest)v0).getDigestSize()];
        byte[] v2 = arg5.getPublicKeyData().getBytes();
        ((Digest)v0).update(v2, 0, v2.length);
        ((Digest)v0).doFinal(v1, 0);
        return v1;
    }

    public static SubjectKeyIdentifier getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return SubjectKeyIdentifier.getInstance(ASN1OctetString.getInstance(arg1, arg2));
    }

    public static SubjectKeyIdentifier getInstance(Object arg2) {
        SubjectKeyIdentifier v2;
        if(!(arg2 instanceof SubjectKeyIdentifier)) {
            if(arg2 != null) {
                v2 = new SubjectKeyIdentifier(ASN1OctetString.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public byte[] getKeyIdentifier() {
        return this.keyidentifier;
    }

    public ASN1Primitive toASN1Primitive() {
        return new DEROctetString(this.keyidentifier);
    }
}

