// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class SubjectPublicKeyInfo extends ASN1Object {
    private AlgorithmIdentifier algId;
    private DERBitString keyData;

    public SubjectPublicKeyInfo(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        Enumeration v0 = arg4.getObjects();
        this.algId = AlgorithmIdentifier.getInstance(v0.nextElement());
        this.keyData = DERBitString.getInstance(v0.nextElement());
    }

    public SubjectPublicKeyInfo(AlgorithmIdentifier arg2, ASN1Encodable arg3) {
        super();
        this.keyData = new DERBitString(arg3);
        this.algId = arg2;
    }

    public SubjectPublicKeyInfo(AlgorithmIdentifier arg2, byte[] arg3) {
        super();
        this.keyData = new DERBitString(arg3);
        this.algId = arg2;
    }

    public AlgorithmIdentifier getAlgorithm() {
        return this.algId;
    }

    public AlgorithmIdentifier getAlgorithmId() {
        return this.algId;
    }

    public static SubjectPublicKeyInfo getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return SubjectPublicKeyInfo.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public static SubjectPublicKeyInfo getInstance(Object arg2) {
        if(!(arg2 instanceof SubjectPublicKeyInfo)) {
            if(arg2 != null) {
                SubjectPublicKeyInfo v2 = new SubjectPublicKeyInfo(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive getPublicKey() {
        return new ASN1InputStream(this.keyData.getBytes()).readObject();
    }

    public DERBitString getPublicKeyData() {
        return this.keyData;
    }

    public ASN1Primitive parsePublicKey() {
        return new ASN1InputStream(this.keyData.getBytes()).readObject();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.algId);
        v0.add(this.keyData);
        return new DERSequence(v0);
    }
}

