// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.DERUTCTime;
import org.bouncycastle.asn1.x500.X500Name;

public class TBSCertList extends ASN1Object {
    Extensions crlExtensions;
    X500Name issuer;
    Time nextUpdate;
    ASN1Sequence revokedCertificates;
    AlgorithmIdentifier signature;
    Time thisUpdate;
    ASN1Integer version;

    public TBSCertList(ASN1Sequence arg5) {
        super();
        if(arg5.size() >= 3 && arg5.size() <= 7) {
            int v0 = 0;
            if((arg5.getObjectAt(0) instanceof ASN1Integer)) {
                this.version = ASN1Integer.getInstance(arg5.getObjectAt(0));
                v0 = 1;
            }
            else {
                this.version = null;
            }

            int v2 = v0 + 1;
            this.signature = AlgorithmIdentifier.getInstance(arg5.getObjectAt(v0));
            int v3 = v2 + 1;
            this.issuer = X500Name.getInstance(arg5.getObjectAt(v2));
            v0 = v3 + 1;
            this.thisUpdate = Time.getInstance(arg5.getObjectAt(v3));
            if(v0 < arg5.size() && (((arg5.getObjectAt(v0) instanceof DERUTCTime)) || ((arg5.getObjectAt(v0) instanceof DERGeneralizedTime)) || ((arg5.getObjectAt(v0) instanceof Time)))) {
                this.nextUpdate = Time.getInstance(arg5.getObjectAt(v0));
                ++v0;
            }

            if(v0 < arg5.size() && !(arg5.getObjectAt(v0) instanceof DERTaggedObject)) {
                this.revokedCertificates = ASN1Sequence.getInstance(arg5.getObjectAt(v0));
                ++v0;
            }

            if(v0 < arg5.size() && ((arg5.getObjectAt(v0) instanceof DERTaggedObject))) {
                this.crlExtensions = Extensions.getInstance(ASN1Sequence.getInstance(arg5.getObjectAt(v0), true));
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
    }

    public Extensions getExtensions() {
        return this.crlExtensions;
    }

    public static TBSCertList getInstance(Object arg2) {
        if(!(arg2 instanceof TBSCertList)) {
            if(arg2 != null) {
                TBSCertList v2 = new TBSCertList(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static TBSCertList getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return TBSCertList.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public X500Name getIssuer() {
        return this.issuer;
    }

    public Time getNextUpdate() {
        return this.nextUpdate;
    }

    public Enumeration getRevokedCertificateEnumeration() {
        TBSCertList$EmptyEnumeration v0;
        if(this.revokedCertificates == null) {
            v0 = new TBSCertList$EmptyEnumeration(this, null);
        }
        else {
            TBSCertList$RevokedCertificatesEnumeration v0_1 = new TBSCertList$RevokedCertificatesEnumeration(this, this.revokedCertificates.getObjects());
        }

        return ((Enumeration)v0);
    }

    public TBSCertList$CRLEntry[] getRevokedCertificates() {
        TBSCertList$CRLEntry[] v0_1;
        int v0 = 0;
        if(this.revokedCertificates == null) {
            v0_1 = new TBSCertList$CRLEntry[0];
        }
        else {
            TBSCertList$CRLEntry[] v1 = new TBSCertList$CRLEntry[this.revokedCertificates.size()];
            while(v0 < v1.length) {
                v1[v0] = TBSCertList$CRLEntry.getInstance(this.revokedCertificates.getObjectAt(v0));
                ++v0;
            }

            v0_1 = v1;
        }

        return v0_1;
    }

    public AlgorithmIdentifier getSignature() {
        return this.signature;
    }

    public Time getThisUpdate() {
        return this.thisUpdate;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public int getVersionNumber() {
        int v0 = this.version == null ? 1 : this.version.getValue().intValue() + 1;
        return v0;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.version != null) {
            v0.add(this.version);
        }

        v0.add(this.signature);
        v0.add(this.issuer);
        v0.add(this.thisUpdate);
        if(this.nextUpdate != null) {
            v0.add(this.nextUpdate);
        }

        if(this.revokedCertificates != null) {
            v0.add(this.revokedCertificates);
        }

        if(this.crlExtensions != null) {
            v0.add(new DERTaggedObject(0, this.crlExtensions));
        }

        return new DERSequence(v0);
    }
}

