// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.X500Name;

public class TBSCertificate extends ASN1Object {
    Time endDate;
    Extensions extensions;
    X500Name issuer;
    DERBitString issuerUniqueId;
    ASN1Sequence seq;
    ASN1Integer serialNumber;
    AlgorithmIdentifier signature;
    Time startDate;
    X500Name subject;
    SubjectPublicKeyInfo subjectPublicKeyInfo;
    DERBitString subjectUniqueId;
    ASN1Integer version;

    private TBSCertificate(ASN1Sequence arg7) {
        int v1;
        super();
        this.seq = arg7;
        if((arg7.getObjectAt(0) instanceof DERTaggedObject)) {
            this.version = ASN1Integer.getInstance(arg7.getObjectAt(0), true);
            v1 = 0;
        }
        else {
            this.version = new ASN1Integer(0);
            v1 = -1;
        }

        this.serialNumber = ASN1Integer.getInstance(arg7.getObjectAt(v1 + 1));
        this.signature = AlgorithmIdentifier.getInstance(arg7.getObjectAt(v1 + 2));
        this.issuer = X500Name.getInstance(arg7.getObjectAt(v1 + 3));
        ASN1Encodable v0 = arg7.getObjectAt(v1 + 4);
        this.startDate = Time.getInstance(((ASN1Sequence)v0).getObjectAt(0));
        this.endDate = Time.getInstance(((ASN1Sequence)v0).getObjectAt(1));
        this.subject = X500Name.getInstance(arg7.getObjectAt(v1 + 5));
        this.subjectPublicKeyInfo = SubjectPublicKeyInfo.getInstance(arg7.getObjectAt(v1 + 6));
        int v3;
        for(v3 = arg7.size() - (v1 + 6) - 1; v3 > 0; --v3) {
            v0 = arg7.getObjectAt(v1 + 6 + v3);
            switch(((DERTaggedObject)v0).getTagNo()) {
                case 1: {
                    this.issuerUniqueId = DERBitString.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
                case 2: {
                    this.subjectUniqueId = DERBitString.getInstance(((ASN1TaggedObject)v0), false);
                    break;
                }
                case 3: {
                    this.extensions = Extensions.getInstance(ASN1Sequence.getInstance(((ASN1TaggedObject)v0), true));
                    break;
                }
            }
        }
    }

    public Time getEndDate() {
        return this.endDate;
    }

    public Extensions getExtensions() {
        return this.extensions;
    }

    public static TBSCertificate getInstance(Object arg2) {
        TBSCertificate v2;
        if(!(arg2 instanceof TBSCertificate)) {
            if(arg2 != null) {
                v2 = new TBSCertificate(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public static TBSCertificate getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return TBSCertificate.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public X500Name getIssuer() {
        return this.issuer;
    }

    public DERBitString getIssuerUniqueId() {
        return this.issuerUniqueId;
    }

    public ASN1Integer getSerialNumber() {
        return this.serialNumber;
    }

    public AlgorithmIdentifier getSignature() {
        return this.signature;
    }

    public Time getStartDate() {
        return this.startDate;
    }

    public X500Name getSubject() {
        return this.subject;
    }

    public SubjectPublicKeyInfo getSubjectPublicKeyInfo() {
        return this.subjectPublicKeyInfo;
    }

    public DERBitString getSubjectUniqueId() {
        return this.subjectUniqueId;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public int getVersionNumber() {
        return this.version.getValue().intValue() + 1;
    }

    public ASN1Primitive toASN1Primitive() {
        return this.seq;
    }
}

