// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1UTCTime;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.X500Name;

public class V1TBSCertificateGenerator {
    Time endDate;
    X500Name issuer;
    ASN1Integer serialNumber;
    AlgorithmIdentifier signature;
    Time startDate;
    X500Name subject;
    SubjectPublicKeyInfo subjectPublicKeyInfo;
    DERTaggedObject version;

    public V1TBSCertificateGenerator() {
        super();
        this.version = new DERTaggedObject(true, 0, new ASN1Integer(0));
    }

    public TBSCertificate generateTBSCertificate() {
        if(this.serialNumber != null && this.signature != null && this.issuer != null && this.startDate != null && this.endDate != null && this.subject != null && this.subjectPublicKeyInfo != null) {
            ASN1EncodableVector v0 = new ASN1EncodableVector();
            v0.add(this.serialNumber);
            v0.add(this.signature);
            v0.add(this.issuer);
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            v1.add(this.startDate);
            v1.add(this.endDate);
            v0.add(new DERSequence(v1));
            v0.add(this.subject);
            v0.add(this.subjectPublicKeyInfo);
            return TBSCertificate.getInstance(new DERSequence(v0));
        }

        throw new IllegalStateException("not all mandatory fields set in V1 TBScertificate generator");
    }

    public void setEndDate(ASN1UTCTime arg2) {
        this.endDate = new Time(((ASN1Primitive)arg2));
    }

    public void setEndDate(Time arg1) {
        this.endDate = arg1;
    }

    public void setIssuer(X500Name arg1) {
        this.issuer = arg1;
    }

    public void setIssuer(X509Name arg2) {
        this.issuer = X500Name.getInstance(arg2.toASN1Primitive());
    }

    public void setSerialNumber(ASN1Integer arg1) {
        this.serialNumber = arg1;
    }

    public void setSignature(AlgorithmIdentifier arg1) {
        this.signature = arg1;
    }

    public void setStartDate(ASN1UTCTime arg2) {
        this.startDate = new Time(((ASN1Primitive)arg2));
    }

    public void setStartDate(Time arg1) {
        this.startDate = arg1;
    }

    public void setSubject(X500Name arg1) {
        this.subject = arg1;
    }

    public void setSubject(X509Name arg2) {
        this.subject = X500Name.getInstance(arg2.toASN1Primitive());
    }

    public void setSubjectPublicKeyInfo(SubjectPublicKeyInfo arg1) {
        this.subjectPublicKeyInfo = arg1;
    }
}

