// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERSet;

public class V2AttributeCertificateInfoGenerator {
    private ASN1EncodableVector attributes;
    private ASN1GeneralizedTime endDate;
    private Extensions extensions;
    private Holder holder;
    private AttCertIssuer issuer;
    private DERBitString issuerUniqueID;
    private ASN1Integer serialNumber;
    private AlgorithmIdentifier signature;
    private ASN1GeneralizedTime startDate;
    private ASN1Integer version;

    public V2AttributeCertificateInfoGenerator() {
        super();
        this.version = new ASN1Integer(1);
        this.attributes = new ASN1EncodableVector();
    }

    public void addAttribute(String arg5, ASN1Encodable arg6) {
        this.attributes.add(new Attribute(new ASN1ObjectIdentifier(arg5), new DERSet(arg6)));
    }

    public void addAttribute(Attribute arg2) {
        this.attributes.add(((ASN1Encodable)arg2));
    }

    public AttributeCertificateInfo generateAttributeCertificateInfo() {
        if(this.serialNumber != null && this.signature != null && this.issuer != null && this.startDate != null && this.endDate != null && this.holder != null && this.attributes != null) {
            ASN1EncodableVector v0 = new ASN1EncodableVector();
            v0.add(this.version);
            v0.add(this.holder);
            v0.add(this.issuer);
            v0.add(this.signature);
            v0.add(this.serialNumber);
            v0.add(new AttCertValidityPeriod(this.startDate, this.endDate));
            v0.add(new DERSequence(this.attributes));
            if(this.issuerUniqueID != null) {
                v0.add(this.issuerUniqueID);
            }

            if(this.extensions != null) {
                v0.add(this.extensions);
            }

            return AttributeCertificateInfo.getInstance(new DERSequence(v0));
        }

        throw new IllegalStateException("not all mandatory fields set in V2 AttributeCertificateInfo generator");
    }

    public void setEndDate(ASN1GeneralizedTime arg1) {
        this.endDate = arg1;
    }

    public void setExtensions(Extensions arg1) {
        this.extensions = arg1;
    }

    public void setExtensions(X509Extensions arg2) {
        this.extensions = Extensions.getInstance(arg2.toASN1Primitive());
    }

    public void setHolder(Holder arg1) {
        this.holder = arg1;
    }

    public void setIssuer(AttCertIssuer arg1) {
        this.issuer = arg1;
    }

    public void setIssuerUniqueID(DERBitString arg1) {
        this.issuerUniqueID = arg1;
    }

    public void setSerialNumber(ASN1Integer arg1) {
        this.serialNumber = arg1;
    }

    public void setSignature(AlgorithmIdentifier arg1) {
        this.signature = arg1;
    }

    public void setStartDate(ASN1GeneralizedTime arg1) {
        this.startDate = arg1;
    }
}

