// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;

public class V2Form extends ASN1Object {
    IssuerSerial baseCertificateID;
    GeneralNames issuerName;
    ObjectDigestInfo objectDigestInfo;

    public V2Form(ASN1Sequence arg6) {
        ASN1TaggedObject v3;
        int v0;
        super();
        if(arg6.size() > 3) {
            throw new IllegalArgumentException("Bad sequence size: " + arg6.size());
        }

        if(!(arg6.getObjectAt(0) instanceof ASN1TaggedObject)) {
            this.issuerName = GeneralNames.getInstance(arg6.getObjectAt(0));
            v0 = 1;
        }
        else {
            v0 = 0;
        }

        while(true) {
            if(v0 == arg6.size()) {
                return;
            }

            v3 = ASN1TaggedObject.getInstance(arg6.getObjectAt(v0));
            if(v3.getTagNo() == 0) {
                this.baseCertificateID = IssuerSerial.getInstance(v3, false);
            }
            else if(v3.getTagNo() == 1) {
                this.objectDigestInfo = ObjectDigestInfo.getInstance(v3, false);
            }
            else {
                break;
            }

            ++v0;
        }

        throw new IllegalArgumentException("Bad tag number: " + v3.getTagNo());
    }

    public V2Form(GeneralNames arg2) {
        this(arg2, null, null);
    }

    public V2Form(GeneralNames arg1, IssuerSerial arg2, ObjectDigestInfo arg3) {
        super();
        this.issuerName = arg1;
        this.baseCertificateID = arg2;
        this.objectDigestInfo = arg3;
    }

    public V2Form(GeneralNames arg2, IssuerSerial arg3) {
        this(arg2, arg3, null);
    }

    public V2Form(GeneralNames arg2, ObjectDigestInfo arg3) {
        this(arg2, null, arg3);
    }

    public IssuerSerial getBaseCertificateID() {
        return this.baseCertificateID;
    }

    public static V2Form getInstance(Object arg2) {
        if(!(arg2 instanceof V2Form)) {
            if(arg2 != null) {
                V2Form v2 = new V2Form(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static V2Form getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return V2Form.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public GeneralNames getIssuerName() {
        return this.issuerName;
    }

    public ObjectDigestInfo getObjectDigestInfo() {
        return this.objectDigestInfo;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.issuerName != null) {
            v0.add(this.issuerName);
        }

        if(this.baseCertificateID != null) {
            v0.add(new DERTaggedObject(false, 0, this.baseCertificateID));
        }

        if(this.objectDigestInfo != null) {
            v0.add(new DERTaggedObject(false, 1, this.objectDigestInfo));
        }

        return new DERSequence(v0);
    }
}

