// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.DERUTCTime;
import org.bouncycastle.asn1.x500.X500Name;

public class V3TBSCertificateGenerator {
    private boolean altNamePresentAndCritical;
    Time endDate;
    Extensions extensions;
    X500Name issuer;
    private DERBitString issuerUniqueID;
    ASN1Integer serialNumber;
    AlgorithmIdentifier signature;
    Time startDate;
    X500Name subject;
    SubjectPublicKeyInfo subjectPublicKeyInfo;
    private DERBitString subjectUniqueID;
    DERTaggedObject version;

    public V3TBSCertificateGenerator() {
        super();
        this.version = new DERTaggedObject(true, 0, new ASN1Integer(2));
    }

    public TBSCertificate generateTBSCertificate() {
        if(this.serialNumber != null && this.signature != null && this.issuer != null && this.startDate != null && this.endDate != null && (this.subject != null || (this.altNamePresentAndCritical)) && this.subjectPublicKeyInfo != null) {
            ASN1EncodableVector v0 = new ASN1EncodableVector();
            v0.add(this.version);
            v0.add(this.serialNumber);
            v0.add(this.signature);
            v0.add(this.issuer);
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            v1.add(this.startDate);
            v1.add(this.endDate);
            v0.add(new DERSequence(v1));
            if(this.subject != null) {
                v0.add(this.subject);
            }
            else {
                v0.add(new DERSequence());
            }

            v0.add(this.subjectPublicKeyInfo);
            if(this.issuerUniqueID != null) {
                v0.add(new DERTaggedObject(false, 1, this.issuerUniqueID));
            }

            if(this.subjectUniqueID != null) {
                v0.add(new DERTaggedObject(false, 2, this.subjectUniqueID));
            }

            if(this.extensions != null) {
                v0.add(new DERTaggedObject(true, 3, this.extensions));
            }

            return TBSCertificate.getInstance(new DERSequence(v0));
        }

        throw new IllegalStateException("not all mandatory fields set in V3 TBScertificate generator");
    }

    public void setEndDate(DERUTCTime arg2) {
        this.endDate = new Time(((ASN1Primitive)arg2));
    }

    public void setEndDate(Time arg1) {
        this.endDate = arg1;
    }

    public void setExtensions(Extensions arg2) {
        this.extensions = arg2;
        if(arg2 != null) {
            Extension v0 = arg2.getExtension(Extension.subjectAlternativeName);
            if(v0 != null && (v0.isCritical())) {
                this.altNamePresentAndCritical = true;
            }
        }
    }

    public void setExtensions(X509Extensions arg2) {
        this.setExtensions(Extensions.getInstance(arg2));
    }

    public void setIssuer(X500Name arg1) {
        this.issuer = arg1;
    }

    public void setIssuer(X509Name arg2) {
        this.issuer = X500Name.getInstance(arg2);
    }

    public void setIssuerUniqueID(DERBitString arg1) {
        this.issuerUniqueID = arg1;
    }

    public void setSerialNumber(ASN1Integer arg1) {
        this.serialNumber = arg1;
    }

    public void setSignature(AlgorithmIdentifier arg1) {
        this.signature = arg1;
    }

    public void setStartDate(DERUTCTime arg2) {
        this.startDate = new Time(((ASN1Primitive)arg2));
    }

    public void setStartDate(Time arg1) {
        this.startDate = arg1;
    }

    public void setSubject(X500Name arg1) {
        this.subject = arg1;
    }

    public void setSubject(X509Name arg2) {
        this.subject = X500Name.getInstance(arg2.toASN1Primitive());
    }

    public void setSubjectPublicKeyInfo(SubjectPublicKeyInfo arg1) {
        this.subjectPublicKeyInfo = arg1;
    }

    public void setSubjectUniqueID(DERBitString arg1) {
        this.subjectUniqueID = arg1;
    }
}

