// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBoolean;

public class X509Extension {
    public static final ASN1ObjectIdentifier auditIdentity;
    public static final ASN1ObjectIdentifier authorityInfoAccess;
    public static final ASN1ObjectIdentifier authorityKeyIdentifier;
    public static final ASN1ObjectIdentifier basicConstraints;
    public static final ASN1ObjectIdentifier biometricInfo;
    public static final ASN1ObjectIdentifier cRLDistributionPoints;
    public static final ASN1ObjectIdentifier cRLNumber;
    public static final ASN1ObjectIdentifier certificateIssuer;
    public static final ASN1ObjectIdentifier certificatePolicies;
    boolean critical;
    public static final ASN1ObjectIdentifier deltaCRLIndicator;
    public static final ASN1ObjectIdentifier extendedKeyUsage;
    public static final ASN1ObjectIdentifier freshestCRL;
    public static final ASN1ObjectIdentifier inhibitAnyPolicy;
    public static final ASN1ObjectIdentifier instructionCode;
    public static final ASN1ObjectIdentifier invalidityDate;
    public static final ASN1ObjectIdentifier issuerAlternativeName;
    public static final ASN1ObjectIdentifier issuingDistributionPoint;
    public static final ASN1ObjectIdentifier keyUsage;
    public static final ASN1ObjectIdentifier logoType;
    public static final ASN1ObjectIdentifier nameConstraints;
    public static final ASN1ObjectIdentifier noRevAvail;
    public static final ASN1ObjectIdentifier policyConstraints;
    public static final ASN1ObjectIdentifier policyMappings;
    public static final ASN1ObjectIdentifier privateKeyUsagePeriod;
    public static final ASN1ObjectIdentifier qCStatements;
    public static final ASN1ObjectIdentifier reasonCode;
    public static final ASN1ObjectIdentifier subjectAlternativeName;
    public static final ASN1ObjectIdentifier subjectDirectoryAttributes;
    public static final ASN1ObjectIdentifier subjectInfoAccess;
    public static final ASN1ObjectIdentifier subjectKeyIdentifier;
    public static final ASN1ObjectIdentifier targetInformation;
    ASN1OctetString value;

    static {
        X509Extension.subjectDirectoryAttributes = new ASN1ObjectIdentifier("2.5.29.9");
        X509Extension.subjectKeyIdentifier = new ASN1ObjectIdentifier("2.5.29.14");
        X509Extension.keyUsage = new ASN1ObjectIdentifier("2.5.29.15");
        X509Extension.privateKeyUsagePeriod = new ASN1ObjectIdentifier("2.5.29.16");
        X509Extension.subjectAlternativeName = new ASN1ObjectIdentifier("2.5.29.17");
        X509Extension.issuerAlternativeName = new ASN1ObjectIdentifier("2.5.29.18");
        X509Extension.basicConstraints = new ASN1ObjectIdentifier("2.5.29.19");
        X509Extension.cRLNumber = new ASN1ObjectIdentifier("2.5.29.20");
        X509Extension.reasonCode = new ASN1ObjectIdentifier("2.5.29.21");
        X509Extension.instructionCode = new ASN1ObjectIdentifier("2.5.29.23");
        X509Extension.invalidityDate = new ASN1ObjectIdentifier("2.5.29.24");
        X509Extension.deltaCRLIndicator = new ASN1ObjectIdentifier("2.5.29.27");
        X509Extension.issuingDistributionPoint = new ASN1ObjectIdentifier("2.5.29.28");
        X509Extension.certificateIssuer = new ASN1ObjectIdentifier("2.5.29.29");
        X509Extension.nameConstraints = new ASN1ObjectIdentifier("2.5.29.30");
        X509Extension.cRLDistributionPoints = new ASN1ObjectIdentifier("2.5.29.31");
        X509Extension.certificatePolicies = new ASN1ObjectIdentifier("2.5.29.32");
        X509Extension.policyMappings = new ASN1ObjectIdentifier("2.5.29.33");
        X509Extension.authorityKeyIdentifier = new ASN1ObjectIdentifier("2.5.29.35");
        X509Extension.policyConstraints = new ASN1ObjectIdentifier("2.5.29.36");
        X509Extension.extendedKeyUsage = new ASN1ObjectIdentifier("2.5.29.37");
        X509Extension.freshestCRL = new ASN1ObjectIdentifier("2.5.29.46");
        X509Extension.inhibitAnyPolicy = new ASN1ObjectIdentifier("2.5.29.54");
        X509Extension.authorityInfoAccess = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.1");
        X509Extension.subjectInfoAccess = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.11");
        X509Extension.logoType = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.12");
        X509Extension.biometricInfo = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.2");
        X509Extension.qCStatements = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.3");
        X509Extension.auditIdentity = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.4");
        X509Extension.noRevAvail = new ASN1ObjectIdentifier("2.5.29.56");
        X509Extension.targetInformation = new ASN1ObjectIdentifier("2.5.29.55");
    }

    public X509Extension(DERBoolean arg2, ASN1OctetString arg3) {
        super();
        this.critical = arg2.isTrue();
        this.value = arg3;
    }

    public X509Extension(boolean arg1, ASN1OctetString arg2) {
        super();
        this.critical = arg1;
        this.value = arg2;
    }

    public static ASN1Primitive convertValueToObject(X509Extension arg4) {
        try {
            return ASN1Primitive.fromByteArray(arg4.getValue().getOctets());
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("can\'t convert extension: " + v0);
        }
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof X509Extension)) && (((X509Extension)arg4).getValue().equals(this.getValue())) && ((X509Extension)arg4).isCritical() == this.isCritical()) {
            v0 = true;
        }

        return v0;
    }

    public ASN1Encodable getParsedValue() {
        return X509Extension.convertValueToObject(this);
    }

    public ASN1OctetString getValue() {
        return this.value;
    }

    public int hashCode() {
        int v0 = this.isCritical() ? this.getValue().hashCode() : this.getValue().hashCode() ^ -1;
        return v0;
    }

    public boolean isCritical() {
        return this.critical;
    }
}

