// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBoolean;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;

public class X509Extensions extends ASN1Object {
    public static final ASN1ObjectIdentifier AuditIdentity;
    public static final ASN1ObjectIdentifier AuthorityInfoAccess;
    public static final ASN1ObjectIdentifier AuthorityKeyIdentifier;
    public static final ASN1ObjectIdentifier BasicConstraints;
    public static final ASN1ObjectIdentifier BiometricInfo;
    public static final ASN1ObjectIdentifier CRLDistributionPoints;
    public static final ASN1ObjectIdentifier CRLNumber;
    public static final ASN1ObjectIdentifier CertificateIssuer;
    public static final ASN1ObjectIdentifier CertificatePolicies;
    public static final ASN1ObjectIdentifier DeltaCRLIndicator;
    public static final ASN1ObjectIdentifier ExtendedKeyUsage;
    public static final ASN1ObjectIdentifier FreshestCRL;
    public static final ASN1ObjectIdentifier InhibitAnyPolicy;
    public static final ASN1ObjectIdentifier InstructionCode;
    public static final ASN1ObjectIdentifier InvalidityDate;
    public static final ASN1ObjectIdentifier IssuerAlternativeName;
    public static final ASN1ObjectIdentifier IssuingDistributionPoint;
    public static final ASN1ObjectIdentifier KeyUsage;
    public static final ASN1ObjectIdentifier LogoType;
    public static final ASN1ObjectIdentifier NameConstraints;
    public static final ASN1ObjectIdentifier NoRevAvail;
    public static final ASN1ObjectIdentifier PolicyConstraints;
    public static final ASN1ObjectIdentifier PolicyMappings;
    public static final ASN1ObjectIdentifier PrivateKeyUsagePeriod;
    public static final ASN1ObjectIdentifier QCStatements;
    public static final ASN1ObjectIdentifier ReasonCode;
    public static final ASN1ObjectIdentifier SubjectAlternativeName;
    public static final ASN1ObjectIdentifier SubjectDirectoryAttributes;
    public static final ASN1ObjectIdentifier SubjectInfoAccess;
    public static final ASN1ObjectIdentifier SubjectKeyIdentifier;
    public static final ASN1ObjectIdentifier TargetInformation;
    private Hashtable extensions;
    private Vector ordering;

    static {
        X509Extensions.SubjectDirectoryAttributes = new ASN1ObjectIdentifier("2.5.29.9");
        X509Extensions.SubjectKeyIdentifier = new ASN1ObjectIdentifier("2.5.29.14");
        X509Extensions.KeyUsage = new ASN1ObjectIdentifier("2.5.29.15");
        X509Extensions.PrivateKeyUsagePeriod = new ASN1ObjectIdentifier("2.5.29.16");
        X509Extensions.SubjectAlternativeName = new ASN1ObjectIdentifier("2.5.29.17");
        X509Extensions.IssuerAlternativeName = new ASN1ObjectIdentifier("2.5.29.18");
        X509Extensions.BasicConstraints = new ASN1ObjectIdentifier("2.5.29.19");
        X509Extensions.CRLNumber = new ASN1ObjectIdentifier("2.5.29.20");
        X509Extensions.ReasonCode = new ASN1ObjectIdentifier("2.5.29.21");
        X509Extensions.InstructionCode = new ASN1ObjectIdentifier("2.5.29.23");
        X509Extensions.InvalidityDate = new ASN1ObjectIdentifier("2.5.29.24");
        X509Extensions.DeltaCRLIndicator = new ASN1ObjectIdentifier("2.5.29.27");
        X509Extensions.IssuingDistributionPoint = new ASN1ObjectIdentifier("2.5.29.28");
        X509Extensions.CertificateIssuer = new ASN1ObjectIdentifier("2.5.29.29");
        X509Extensions.NameConstraints = new ASN1ObjectIdentifier("2.5.29.30");
        X509Extensions.CRLDistributionPoints = new ASN1ObjectIdentifier("2.5.29.31");
        X509Extensions.CertificatePolicies = new ASN1ObjectIdentifier("2.5.29.32");
        X509Extensions.PolicyMappings = new ASN1ObjectIdentifier("2.5.29.33");
        X509Extensions.AuthorityKeyIdentifier = new ASN1ObjectIdentifier("2.5.29.35");
        X509Extensions.PolicyConstraints = new ASN1ObjectIdentifier("2.5.29.36");
        X509Extensions.ExtendedKeyUsage = new ASN1ObjectIdentifier("2.5.29.37");
        X509Extensions.FreshestCRL = new ASN1ObjectIdentifier("2.5.29.46");
        X509Extensions.InhibitAnyPolicy = new ASN1ObjectIdentifier("2.5.29.54");
        X509Extensions.AuthorityInfoAccess = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.1");
        X509Extensions.SubjectInfoAccess = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.11");
        X509Extensions.LogoType = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.12");
        X509Extensions.BiometricInfo = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.2");
        X509Extensions.QCStatements = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.3");
        X509Extensions.AuditIdentity = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.4");
        X509Extensions.NoRevAvail = new ASN1ObjectIdentifier("2.5.29.56");
        X509Extensions.TargetInformation = new ASN1ObjectIdentifier("2.5.29.55");
    }

    public X509Extensions(Hashtable arg2) {
        this(null, arg2);
    }

    public X509Extensions(Vector arg5, Hashtable arg6) {
        super();
        this.extensions = new Hashtable();
        this.ordering = new Vector();
        Enumeration v0 = arg5 == null ? arg6.keys() : arg5.elements();
        while(v0.hasMoreElements()) {
            this.ordering.addElement(ASN1ObjectIdentifier.getInstance(v0.nextElement()));
        }

        Enumeration v1 = this.ordering.elements();
        while(v1.hasMoreElements()) {
            ASN1ObjectIdentifier v2 = ASN1ObjectIdentifier.getInstance(v1.nextElement());
            this.extensions.put(v2, arg6.get(v2));
        }
    }

    public X509Extensions(Vector arg6, Vector arg7) {
        super();
        this.extensions = new Hashtable();
        this.ordering = new Vector();
        Enumeration v0 = arg6.elements();
        while(v0.hasMoreElements()) {
            this.ordering.addElement(v0.nextElement());
        }

        Enumeration v3 = this.ordering.elements();
        int v2;
        for(v2 = 0; v3.hasMoreElements(); ++v2) {
            this.extensions.put(v3.nextElement(), arg7.elementAt(v2));
        }
    }

    public X509Extensions(ASN1Sequence arg11) {
        ASN1Sequence v1;
        int v9 = 2;
        super();
        this.extensions = new Hashtable();
        this.ordering = new Vector();
        Enumeration v0 = arg11.getObjects();
        while(true) {
            if(!v0.hasMoreElements()) {
                return;
            }

            v1 = ASN1Sequence.getInstance(v0.nextElement());
            if(v1.size() == 3) {
                this.extensions.put(v1.getObjectAt(0), new X509Extension(DERBoolean.getInstance(v1.getObjectAt(1)), ASN1OctetString.getInstance(v1.getObjectAt(v9))));
            }
            else if(v1.size() == v9) {
                this.extensions.put(v1.getObjectAt(0), new X509Extension(false, ASN1OctetString.getInstance(v1.getObjectAt(1))));
            }
            else {
                break;
            }

            this.ordering.addElement(v1.getObjectAt(0));
        }

        throw new IllegalArgumentException("Bad sequence size: " + v1.size());
    }

    public boolean equivalent(X509Extensions arg6) {
        boolean v0 = false;
        if(this.extensions.size() == arg6.extensions.size()) {
            Enumeration v1 = this.extensions.keys();
            do {
                if(v1.hasMoreElements()) {
                    Object v2 = v1.nextElement();
                    if(this.extensions.get(v2).equals(arg6.extensions.get(v2))) {
                        continue;
                    }

                    return v0;
                }
                else {
                    goto label_19;
                }
            }
            while(true);

            return v0;
        label_19:
            v0 = true;
        }

        return v0;
    }

    public ASN1ObjectIdentifier[] getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    public X509Extension getExtension(ASN1ObjectIdentifier arg2) {
        return this.extensions.get(arg2);
    }

    public X509Extension getExtension(DERObjectIdentifier arg2) {
        return this.extensions.get(arg2);
    }

    private ASN1ObjectIdentifier[] getExtensionOIDs(boolean arg5) {
        Vector v2 = new Vector();
        int v1;
        for(v1 = 0; v1 != this.ordering.size(); ++v1) {
            Object v3 = this.ordering.elementAt(v1);
            if(this.extensions.get(v3).isCritical() == arg5) {
                v2.addElement(v3);
            }
        }

        return this.toOidArray(v2);
    }

    public ASN1ObjectIdentifier[] getExtensionOIDs() {
        return this.toOidArray(this.ordering);
    }

    public static X509Extensions getInstance(Object arg3) {
        X509Extensions v3;
        if(arg3 != null && !(arg3 instanceof X509Extensions)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new X509Extensions(((ASN1Sequence)arg3));
            }
            else if((arg3 instanceof Extensions)) {
                v3 = new X509Extensions(((Extensions)arg3).toASN1Primitive());
            }
            else if((arg3 instanceof ASN1TaggedObject)) {
                v3 = X509Extensions.getInstance(((ASN1TaggedObject)arg3).getObject());
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static X509Extensions getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return X509Extensions.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1ObjectIdentifier[] getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public Enumeration oids() {
        return this.ordering.elements();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        Enumeration v3 = this.ordering.elements();
        while(v3.hasMoreElements()) {
            Object v0 = v3.nextElement();
            Object v1 = this.extensions.get(v0);
            ASN1EncodableVector v4 = new ASN1EncodableVector();
            v4.add(((ASN1Encodable)v0));
            if(((X509Extension)v1).isCritical()) {
                v4.add(DERBoolean.TRUE);
            }

            v4.add(((X509Extension)v1).getValue());
            v2.add(new DERSequence(v4));
        }

        return new DERSequence(v2);
    }

    private ASN1ObjectIdentifier[] toOidArray(Vector arg4) {
        ASN1ObjectIdentifier[] v2 = new ASN1ObjectIdentifier[arg4.size()];
        int v1;
        for(v1 = 0; v1 != v2.length; ++v1) {
            v2[v1] = arg4.elementAt(v1);
        }

        return v2;
    }
}

