// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DEROctetString;

public class X509ExtensionsGenerator {
    private Vector extOrdering;
    private Hashtable extensions;

    public X509ExtensionsGenerator() {
        super();
        this.extensions = new Hashtable();
        this.extOrdering = new Vector();
    }

    public void addExtension(ASN1ObjectIdentifier arg5, boolean arg6, ASN1Encodable arg7) {
        try {
            this.addExtension(arg5, arg6, arg7.toASN1Primitive().getEncoded("DER"));
            return;
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("error encoding value: " + v0);
        }
    }

    public void addExtension(ASN1ObjectIdentifier arg4, boolean arg5, byte[] arg6) {
        if(this.extensions.containsKey(arg4)) {
            throw new IllegalArgumentException("extension " + arg4 + " already added");
        }

        this.extOrdering.addElement(arg4);
        this.extensions.put(arg4, new X509Extension(arg5, new DEROctetString(arg6)));
    }

    public void addExtension(DERObjectIdentifier arg3, boolean arg4, ASN1Encodable arg5) {
        this.addExtension(new ASN1ObjectIdentifier(arg3.getId()), arg4, arg5);
    }

    public void addExtension(DERObjectIdentifier arg3, boolean arg4, byte[] arg5) {
        this.addExtension(new ASN1ObjectIdentifier(arg3.getId()), arg4, arg5);
    }

    public X509Extensions generate() {
        return new X509Extensions(this.extOrdering, this.extensions);
    }

    public boolean isEmpty() {
        return this.extOrdering.isEmpty();
    }

    public void reset() {
        this.extensions = new Hashtable();
        this.extOrdering = new Vector();
    }
}

