// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1String;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERSet;
import org.bouncycastle.asn1.DERUniversalString;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.util.Strings;
import org.bouncycastle.util.encoders.Hex;

public class X509Name extends ASN1Object {
    public static final ASN1ObjectIdentifier BUSINESS_CATEGORY;
    public static final ASN1ObjectIdentifier C;
    public static final ASN1ObjectIdentifier CN;
    public static final ASN1ObjectIdentifier COUNTRY_OF_CITIZENSHIP;
    public static final ASN1ObjectIdentifier COUNTRY_OF_RESIDENCE;
    public static final ASN1ObjectIdentifier DATE_OF_BIRTH;
    public static final ASN1ObjectIdentifier DC;
    public static final ASN1ObjectIdentifier DMD_NAME;
    public static final ASN1ObjectIdentifier DN_QUALIFIER;
    public static final Hashtable DefaultLookUp;
    public static boolean DefaultReverse;
    public static final Hashtable DefaultSymbols;
    public static final ASN1ObjectIdentifier E;
    public static final ASN1ObjectIdentifier EmailAddress;
    private static final Boolean FALSE;
    public static final ASN1ObjectIdentifier GENDER;
    public static final ASN1ObjectIdentifier GENERATION;
    public static final ASN1ObjectIdentifier GIVENNAME;
    public static final ASN1ObjectIdentifier INITIALS;
    public static final ASN1ObjectIdentifier L;
    public static final ASN1ObjectIdentifier NAME;
    public static final ASN1ObjectIdentifier NAME_AT_BIRTH;
    public static final ASN1ObjectIdentifier O;
    public static final Hashtable OIDLookUp;
    public static final ASN1ObjectIdentifier OU;
    public static final ASN1ObjectIdentifier PLACE_OF_BIRTH;
    public static final ASN1ObjectIdentifier POSTAL_ADDRESS;
    public static final ASN1ObjectIdentifier POSTAL_CODE;
    public static final ASN1ObjectIdentifier PSEUDONYM;
    public static final Hashtable RFC1779Symbols;
    public static final Hashtable RFC2253Symbols;
    public static final ASN1ObjectIdentifier SERIALNUMBER;
    public static final ASN1ObjectIdentifier SN;
    public static final ASN1ObjectIdentifier ST;
    public static final ASN1ObjectIdentifier STREET;
    public static final ASN1ObjectIdentifier SURNAME;
    public static final Hashtable SymbolLookUp;
    public static final ASN1ObjectIdentifier T;
    public static final ASN1ObjectIdentifier TELEPHONE_NUMBER;
    private static final Boolean TRUE;
    public static final ASN1ObjectIdentifier UID;
    public static final ASN1ObjectIdentifier UNIQUE_IDENTIFIER;
    public static final ASN1ObjectIdentifier UnstructuredAddress;
    public static final ASN1ObjectIdentifier UnstructuredName;
    private Vector added;
    private X509NameEntryConverter converter;
    private int hashCodeValue;
    private boolean isHashCodeCalculated;
    private Vector ordering;
    private ASN1Sequence seq;
    private Vector values;

    static {
        X509Name.C = new ASN1ObjectIdentifier("2.5.4.6");
        X509Name.O = new ASN1ObjectIdentifier("2.5.4.10");
        X509Name.OU = new ASN1ObjectIdentifier("2.5.4.11");
        X509Name.T = new ASN1ObjectIdentifier("2.5.4.12");
        X509Name.CN = new ASN1ObjectIdentifier("2.5.4.3");
        X509Name.SN = new ASN1ObjectIdentifier("2.5.4.5");
        X509Name.STREET = new ASN1ObjectIdentifier("2.5.4.9");
        X509Name.SERIALNUMBER = X509Name.SN;
        X509Name.L = new ASN1ObjectIdentifier("2.5.4.7");
        X509Name.ST = new ASN1ObjectIdentifier("2.5.4.8");
        X509Name.SURNAME = new ASN1ObjectIdentifier("2.5.4.4");
        X509Name.GIVENNAME = new ASN1ObjectIdentifier("2.5.4.42");
        X509Name.INITIALS = new ASN1ObjectIdentifier("2.5.4.43");
        X509Name.GENERATION = new ASN1ObjectIdentifier("2.5.4.44");
        X509Name.UNIQUE_IDENTIFIER = new ASN1ObjectIdentifier("2.5.4.45");
        X509Name.BUSINESS_CATEGORY = new ASN1ObjectIdentifier("2.5.4.15");
        X509Name.POSTAL_CODE = new ASN1ObjectIdentifier("2.5.4.17");
        X509Name.DN_QUALIFIER = new ASN1ObjectIdentifier("2.5.4.46");
        X509Name.PSEUDONYM = new ASN1ObjectIdentifier("2.5.4.65");
        X509Name.DATE_OF_BIRTH = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.1");
        X509Name.PLACE_OF_BIRTH = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.2");
        X509Name.GENDER = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.3");
        X509Name.COUNTRY_OF_CITIZENSHIP = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.4");
        X509Name.COUNTRY_OF_RESIDENCE = new ASN1ObjectIdentifier("1.3.6.1.5.5.7.9.5");
        X509Name.NAME_AT_BIRTH = new ASN1ObjectIdentifier("1.3.36.8.3.14");
        X509Name.POSTAL_ADDRESS = new ASN1ObjectIdentifier("2.5.4.16");
        X509Name.DMD_NAME = new ASN1ObjectIdentifier("2.5.4.54");
        X509Name.TELEPHONE_NUMBER = X509ObjectIdentifiers.id_at_telephoneNumber;
        X509Name.NAME = X509ObjectIdentifiers.id_at_name;
        X509Name.EmailAddress = PKCSObjectIdentifiers.pkcs_9_at_emailAddress;
        X509Name.UnstructuredName = PKCSObjectIdentifiers.pkcs_9_at_unstructuredName;
        X509Name.UnstructuredAddress = PKCSObjectIdentifiers.pkcs_9_at_unstructuredAddress;
        X509Name.E = X509Name.EmailAddress;
        X509Name.DC = new ASN1ObjectIdentifier("0.9.2342.19200300.100.1.25");
        X509Name.UID = new ASN1ObjectIdentifier("0.9.2342.19200300.100.1.1");
        X509Name.DefaultReverse = false;
        X509Name.DefaultSymbols = new Hashtable();
        X509Name.RFC2253Symbols = new Hashtable();
        X509Name.RFC1779Symbols = new Hashtable();
        X509Name.DefaultLookUp = new Hashtable();
        X509Name.OIDLookUp = X509Name.DefaultSymbols;
        X509Name.SymbolLookUp = X509Name.DefaultLookUp;
        X509Name.TRUE = new Boolean(true);
        X509Name.FALSE = new Boolean(false);
        X509Name.DefaultSymbols.put(X509Name.C, "C");
        X509Name.DefaultSymbols.put(X509Name.O, "O");
        X509Name.DefaultSymbols.put(X509Name.T, "T");
        X509Name.DefaultSymbols.put(X509Name.OU, "OU");
        X509Name.DefaultSymbols.put(X509Name.CN, "CN");
        X509Name.DefaultSymbols.put(X509Name.L, "L");
        X509Name.DefaultSymbols.put(X509Name.ST, "ST");
        X509Name.DefaultSymbols.put(X509Name.SN, "SERIALNUMBER");
        X509Name.DefaultSymbols.put(X509Name.EmailAddress, "E");
        X509Name.DefaultSymbols.put(X509Name.DC, "DC");
        X509Name.DefaultSymbols.put(X509Name.UID, "UID");
        X509Name.DefaultSymbols.put(X509Name.STREET, "STREET");
        X509Name.DefaultSymbols.put(X509Name.SURNAME, "SURNAME");
        X509Name.DefaultSymbols.put(X509Name.GIVENNAME, "GIVENNAME");
        X509Name.DefaultSymbols.put(X509Name.INITIALS, "INITIALS");
        X509Name.DefaultSymbols.put(X509Name.GENERATION, "GENERATION");
        X509Name.DefaultSymbols.put(X509Name.UnstructuredAddress, "unstructuredAddress");
        X509Name.DefaultSymbols.put(X509Name.UnstructuredName, "unstructuredName");
        X509Name.DefaultSymbols.put(X509Name.UNIQUE_IDENTIFIER, "UniqueIdentifier");
        X509Name.DefaultSymbols.put(X509Name.DN_QUALIFIER, "DN");
        X509Name.DefaultSymbols.put(X509Name.PSEUDONYM, "Pseudonym");
        X509Name.DefaultSymbols.put(X509Name.POSTAL_ADDRESS, "PostalAddress");
        X509Name.DefaultSymbols.put(X509Name.NAME_AT_BIRTH, "NameAtBirth");
        X509Name.DefaultSymbols.put(X509Name.COUNTRY_OF_CITIZENSHIP, "CountryOfCitizenship");
        X509Name.DefaultSymbols.put(X509Name.COUNTRY_OF_RESIDENCE, "CountryOfResidence");
        X509Name.DefaultSymbols.put(X509Name.GENDER, "Gender");
        X509Name.DefaultSymbols.put(X509Name.PLACE_OF_BIRTH, "PlaceOfBirth");
        X509Name.DefaultSymbols.put(X509Name.DATE_OF_BIRTH, "DateOfBirth");
        X509Name.DefaultSymbols.put(X509Name.POSTAL_CODE, "PostalCode");
        X509Name.DefaultSymbols.put(X509Name.BUSINESS_CATEGORY, "BusinessCategory");
        X509Name.DefaultSymbols.put(X509Name.TELEPHONE_NUMBER, "TelephoneNumber");
        X509Name.DefaultSymbols.put(X509Name.NAME, "Name");
        X509Name.RFC2253Symbols.put(X509Name.C, "C");
        X509Name.RFC2253Symbols.put(X509Name.O, "O");
        X509Name.RFC2253Symbols.put(X509Name.OU, "OU");
        X509Name.RFC2253Symbols.put(X509Name.CN, "CN");
        X509Name.RFC2253Symbols.put(X509Name.L, "L");
        X509Name.RFC2253Symbols.put(X509Name.ST, "ST");
        X509Name.RFC2253Symbols.put(X509Name.STREET, "STREET");
        X509Name.RFC2253Symbols.put(X509Name.DC, "DC");
        X509Name.RFC2253Symbols.put(X509Name.UID, "UID");
        X509Name.RFC1779Symbols.put(X509Name.C, "C");
        X509Name.RFC1779Symbols.put(X509Name.O, "O");
        X509Name.RFC1779Symbols.put(X509Name.OU, "OU");
        X509Name.RFC1779Symbols.put(X509Name.CN, "CN");
        X509Name.RFC1779Symbols.put(X509Name.L, "L");
        X509Name.RFC1779Symbols.put(X509Name.ST, "ST");
        X509Name.RFC1779Symbols.put(X509Name.STREET, "STREET");
        X509Name.DefaultLookUp.put("c", X509Name.C);
        X509Name.DefaultLookUp.put("o", X509Name.O);
        X509Name.DefaultLookUp.put("t", X509Name.T);
        X509Name.DefaultLookUp.put("ou", X509Name.OU);
        X509Name.DefaultLookUp.put("cn", X509Name.CN);
        X509Name.DefaultLookUp.put("l", X509Name.L);
        X509Name.DefaultLookUp.put("st", X509Name.ST);
        X509Name.DefaultLookUp.put("sn", X509Name.SN);
        X509Name.DefaultLookUp.put("serialnumber", X509Name.SN);
        X509Name.DefaultLookUp.put("street", X509Name.STREET);
        X509Name.DefaultLookUp.put("emailaddress", X509Name.E);
        X509Name.DefaultLookUp.put("dc", X509Name.DC);
        X509Name.DefaultLookUp.put("e", X509Name.E);
        X509Name.DefaultLookUp.put("uid", X509Name.UID);
        X509Name.DefaultLookUp.put("surname", X509Name.SURNAME);
        X509Name.DefaultLookUp.put("givenname", X509Name.GIVENNAME);
        X509Name.DefaultLookUp.put("initials", X509Name.INITIALS);
        X509Name.DefaultLookUp.put("generation", X509Name.GENERATION);
        X509Name.DefaultLookUp.put("unstructuredaddress", X509Name.UnstructuredAddress);
        X509Name.DefaultLookUp.put("unstructuredname", X509Name.UnstructuredName);
        X509Name.DefaultLookUp.put("uniqueidentifier", X509Name.UNIQUE_IDENTIFIER);
        X509Name.DefaultLookUp.put("dn", X509Name.DN_QUALIFIER);
        X509Name.DefaultLookUp.put("pseudonym", X509Name.PSEUDONYM);
        X509Name.DefaultLookUp.put("postaladdress", X509Name.POSTAL_ADDRESS);
        X509Name.DefaultLookUp.put("nameofbirth", X509Name.NAME_AT_BIRTH);
        X509Name.DefaultLookUp.put("countryofcitizenship", X509Name.COUNTRY_OF_CITIZENSHIP);
        X509Name.DefaultLookUp.put("countryofresidence", X509Name.COUNTRY_OF_RESIDENCE);
        X509Name.DefaultLookUp.put("gender", X509Name.GENDER);
        X509Name.DefaultLookUp.put("placeofbirth", X509Name.PLACE_OF_BIRTH);
        X509Name.DefaultLookUp.put("dateofbirth", X509Name.DATE_OF_BIRTH);
        X509Name.DefaultLookUp.put("postalcode", X509Name.POSTAL_CODE);
        X509Name.DefaultLookUp.put("businesscategory", X509Name.BUSINESS_CATEGORY);
        X509Name.DefaultLookUp.put("telephonenumber", X509Name.TELEPHONE_NUMBER);
        X509Name.DefaultLookUp.put("name", X509Name.NAME);
    }

    protected X509Name() {
        super();
        this.converter = null;
        this.ordering = new Vector();
        this.values = new Vector();
        this.added = new Vector();
    }

    public X509Name(String arg3) {
        this(X509Name.DefaultReverse, X509Name.DefaultLookUp, arg3);
    }

    public X509Name(boolean arg2, Hashtable arg3, String arg4) {
        this(arg2, arg3, arg4, new X509DefaultEntryConverter());
    }

    public X509Name(String arg3, X509NameEntryConverter arg4) {
        this(X509Name.DefaultReverse, X509Name.DefaultLookUp, arg3, arg4);
    }

    public X509Name(boolean arg9, Hashtable arg10, String arg11, X509NameEntryConverter arg12) {
        X509NameTokenizer v3;
        char v6 = '+';
        super();
        this.converter = null;
        this.ordering = new Vector();
        this.values = new Vector();
        this.added = new Vector();
        this.converter = arg12;
        X509NameTokenizer v0 = new X509NameTokenizer(arg11);
    label_18:
        while(v0.hasMoreTokens()) {
            String v1 = v0.nextToken();
            if(v1.indexOf(v6) > 0) {
                v3 = new X509NameTokenizer(v1, v6);
                this.addEntry(arg10, v3.nextToken(), X509Name.FALSE);
                goto label_28;
            }

            this.addEntry(arg10, v1, X509Name.FALSE);
        }

        if(arg9) {
            Vector v5 = new Vector();
            Vector v6_1 = new Vector();
            Vector v7 = new Vector();
            int v1_1 = 0;
            int v3_1 = 1;
            while(v1_1 < this.ordering.size()) {
                if(this.added.elementAt(v1_1).booleanValue()) {
                    v5.insertElementAt(this.ordering.elementAt(v1_1), v3_1);
                    v6_1.insertElementAt(this.values.elementAt(v1_1), v3_1);
                    v7.insertElementAt(this.added.elementAt(v1_1), v3_1);
                    ++v3_1;
                }
                else {
                    v5.insertElementAt(this.ordering.elementAt(v1_1), 0);
                    v6_1.insertElementAt(this.values.elementAt(v1_1), 0);
                    v7.insertElementAt(this.added.elementAt(v1_1), 0);
                    v3_1 = 1;
                }

                ++v1_1;
            }

            this.ordering = v5;
            this.values = v6_1;
            this.added = v7;
        }

        return;
        while(true) {
        label_28:
            if(!v3.hasMoreTokens()) {
                goto label_18;
            }

            this.addEntry(arg10, v3.nextToken(), X509Name.TRUE);
        }
    }

    public X509Name(Hashtable arg2) {
        this(null, arg2);
    }

    public X509Name(Vector arg2, Hashtable arg3) {
        this(arg2, arg3, new X509DefaultEntryConverter());
    }

    public X509Name(Vector arg5, Hashtable arg6, X509NameEntryConverter arg7) {
        int v1 = 0;
        super();
        this.converter = null;
        this.ordering = new Vector();
        this.values = new Vector();
        this.added = new Vector();
        this.converter = arg7;
        if(arg5 != null) {
            int v0;
            for(v0 = 0; v0 != arg5.size(); ++v0) {
                this.ordering.addElement(arg5.elementAt(v0));
                this.added.addElement(X509Name.FALSE);
            }
        }
        else {
            Enumeration v0_1 = arg6.keys();
            while(v0_1.hasMoreElements()) {
                this.ordering.addElement(v0_1.nextElement());
                this.added.addElement(X509Name.FALSE);
            }
        }

        while(v1 != this.ordering.size()) {
            Object v0_2 = this.ordering.elementAt(v1);
            if(arg6.get(v0_2) == null) {
                throw new IllegalArgumentException("No attribute for object id - " + ((ASN1ObjectIdentifier)v0_2).getId() + " - passed to distinguished name");
            }

            this.values.addElement(arg6.get(v0_2));
            ++v1;
        }
    }

    public X509Name(Vector arg2, Vector arg3) {
        this(arg2, arg3, new X509DefaultEntryConverter());
    }

    public X509Name(Vector arg4, Vector arg5, X509NameEntryConverter arg6) {
        super();
        this.converter = null;
        this.ordering = new Vector();
        this.values = new Vector();
        this.added = new Vector();
        this.converter = arg6;
        if(arg4.size() != arg5.size()) {
            throw new IllegalArgumentException("oids vector must be same length as values.");
        }

        int v0;
        for(v0 = 0; v0 < arg4.size(); ++v0) {
            this.ordering.addElement(arg4.elementAt(v0));
            this.values.addElement(arg5.elementAt(v0));
            this.added.addElement(X509Name.FALSE);
        }
    }

    public X509Name(ASN1Sequence arg9) {
        super();
        this.converter = null;
        this.ordering = new Vector();
        this.values = new Vector();
        this.added = new Vector();
        this.seq = arg9;
        Enumeration v3 = arg9.getObjects();
    label_15:
        if(v3.hasMoreElements()) {
            ASN1Set v4 = ASN1Set.getInstance(v3.nextElement().toASN1Primitive());
            int v1;
            for(v1 = 0; true; ++v1) {
                if(v1 >= v4.size()) {
                    goto label_15;
                }

                ASN1Sequence v0 = ASN1Sequence.getInstance(v4.getObjectAt(v1).toASN1Primitive());
                if(v0.size() != 2) {
                    throw new IllegalArgumentException("badly sized pair");
                }

                this.ordering.addElement(ASN1ObjectIdentifier.getInstance(v0.getObjectAt(0)));
                ASN1Encodable v0_1 = v0.getObjectAt(1);
                if(!(v0_1 instanceof ASN1String) || ((v0_1 instanceof DERUniversalString))) {
                    try {
                        this.values.addElement("#" + this.bytesToString(Hex.encode(v0_1.toASN1Primitive().getEncoded("DER"))));
                    }
                    catch(IOException v0_3) {
                        throw new IllegalArgumentException("cannot encode value");
                    }
                }
                else {
                    String v0_2 = ((ASN1String)v0_1).getString();
                    if(v0_2.length() > 0 && v0_2.charAt(0) == 35) {
                        this.values.addElement("\\" + v0_2);
                        goto label_57;
                    }

                    this.values.addElement(v0_2);
                }

            label_57:
                Vector v5 = this.added;
                Boolean v0_4 = v1 != 0 ? X509Name.TRUE : X509Name.FALSE;
                v5.addElement(v0_4);
            }
        }
    }

    public X509Name(boolean arg2, String arg3) {
        this(arg2, X509Name.DefaultLookUp, arg3);
    }

    public X509Name(boolean arg2, String arg3, X509NameEntryConverter arg4) {
        this(arg2, X509Name.DefaultLookUp, arg3, arg4);
    }

    private void addEntry(Hashtable arg4, String arg5, Boolean arg6) {
        X509NameTokenizer v0 = new X509NameTokenizer(arg5, '=');
        String v1 = v0.nextToken();
        if(!v0.hasMoreTokens()) {
            throw new IllegalArgumentException("badly formatted directory string");
        }

        String v0_1 = v0.nextToken();
        this.ordering.addElement(this.decodeOID(v1, arg4));
        this.values.addElement(this.unescape(v0_1));
        this.added.addElement(arg6);
    }

    private void appendValue(StringBuffer arg9, Hashtable arg10, ASN1ObjectIdentifier arg11, String arg12) {
        char v7 = '=';
        int v6 = 32;
        char v5 = '\\';
        Object v0 = arg10.get(arg11);
        if(v0 != null) {
            arg9.append(((String)v0));
        }
        else {
            arg9.append(arg11.getId());
        }

        arg9.append(v7);
        int v2 = arg9.length();
        arg9.append(arg12);
        int v0_1 = arg9.length();
        int v1;
        for(v1 = arg12.length() < 2 || arg12.charAt(0) != v5 || arg12.charAt(1) != 35 ? v2 : v2 + 2; v1 != v0_1; ++v1) {
            if(arg9.charAt(v1) == 44 || arg9.charAt(v1) == 34 || arg9.charAt(v1) == v5 || arg9.charAt(v1) == 43 || arg9.charAt(v1) == v7 || arg9.charAt(v1) == 60 || arg9.charAt(v1) == 62 || arg9.charAt(v1) == 59) {
                arg9.insert(v1, "\\");
                ++v1;
                ++v0_1;
            }
        }

        for(v0_1 = v2; arg9.charAt(v0_1) == v6; v0_1 += 2) {
            arg9.insert(v0_1, "\\");
        }

        for(v0_1 = arg9.length() - 1; v0_1 >= 0; --v0_1) {
            if(arg9.charAt(v0_1) != v6) {
                return;
            }

            arg9.insert(v0_1, v5);
        }
    }

    private String bytesToString(byte[] arg4) {
        char[] v1 = new char[arg4.length];
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            v1[v0] = ((char)(arg4[v0] & 255));
        }

        return new String(v1);
    }

    private String canonicalize(String arg4) {
        String v0_1;
        String v1 = Strings.toLowerCase(arg4.trim());
        if(v1.length() <= 0 || v1.charAt(0) != 35) {
        label_15:
            v0_1 = v1;
        }
        else {
            ASN1Primitive v0 = this.decodeObject(v1);
            if((v0 instanceof ASN1String)) {
                v0_1 = Strings.toLowerCase(((ASN1String)v0).getString().trim());
            }
            else {
                goto label_15;
            }
        }

        return v0_1;
    }

    private ASN1ObjectIdentifier decodeOID(String arg5, Hashtable arg6) {
        ASN1ObjectIdentifier v0;
        String v1 = arg5.trim();
        if(Strings.toUpperCase(v1).startsWith("OID.")) {
            v0 = new ASN1ObjectIdentifier(v1.substring(4));
        }
        else {
            if(v1.charAt(0) >= 48 && v1.charAt(0) <= 57) {
                return new ASN1ObjectIdentifier(v1);
            }

            Object v0_1 = arg6.get(Strings.toLowerCase(v1));
            if(v0_1 != null) {
                return v0;
            }

            throw new IllegalArgumentException("Unknown object id - " + v1 + " - passed to distinguished name");
        }

        return v0;
    }

    private ASN1Primitive decodeObject(String arg5) {
        try {
            return ASN1Primitive.fromByteArray(Hex.decode(arg5.substring(1)));
        }
        catch(IOException v0) {
            throw new IllegalStateException("unknown encoding in name: " + v0);
        }
    }

    public boolean equals(Object arg13) {
        int v0_1;
        int v5;
        int v3;
        int v1 = -1;
        boolean v7 = false;
        if((((X509Name)arg13)) == this) {
            return true;
        }

        if(((arg13 instanceof X509Name)) || ((arg13 instanceof ASN1Sequence))) {
            if(this.toASN1Primitive().equals(arg13.toASN1Primitive())) {
                return true;
            }

            try {
                X509Name v10 = X509Name.getInstance(arg13);
            }
            catch(IllegalArgumentException v0) {
                return v7;
            }

            int v6 = this.ordering.size();
            if(v6 == v10.ordering.size()) {
                boolean[] v11 = new boolean[v6];
                if(this.ordering.elementAt(0).equals(v10.ordering.elementAt(0))) {
                    v3 = 1;
                    v5 = v6;
                    v0_1 = 0;
                }
                else {
                    v0_1 = v6 - 1;
                    v3 = v1;
                    v5 = v1;
                }

                int v9;
                for(v9 = v0_1; v9 != v5; v9 += v3) {
                    Object v0_2 = this.ordering.elementAt(v9);
                    Object v1_1 = this.values.elementAt(v9);
                    int v8;
                    for(v8 = 0; v8 < v6; ++v8) {
                        if(!v11[v8] && (((ASN1ObjectIdentifier)v0_2).equals(v10.ordering.elementAt(v8))) && (this.equivalentStrings(((String)v1_1), v10.values.elementAt(v8)))) {
                            v11[v8] = true;
                            v0_1 = 1;
                            goto label_60;
                        }
                    }

                    v0_1 = 0;
                label_60:
                    if(v0_1 == 0) {
                        return v7;
                    }
                }

                v7 = true;
            }
        }

        return v7;
    }

    public boolean equals(Object arg8, boolean arg9) {
        if(!arg9) {
            boolean v0 = this.equals(arg8);
            return v0;
        }

        if((((X509Name)arg8)) == this) {
            return true;
        }

        if(!(arg8 instanceof X509Name) && !(arg8 instanceof ASN1Sequence)) {
            return false;
        }

        if(this.toASN1Primitive().equals(arg8.toASN1Primitive())) {
            return true;
        }

        try {
            X509Name v5 = X509Name.getInstance(arg8);
        }
        catch(IllegalArgumentException v0_1) {
            return false;
        }

        int v6 = this.ordering.size();
        if(v6 != v5.ordering.size()) {
            return false;
        }

        int v4;
        for(v4 = 0; true; ++v4) {
            if(v4 >= v6) {
                return true;
            }

            if(!this.ordering.elementAt(v4).equals(v5.ordering.elementAt(v4))) {
                return false;
            }

            if(!this.equivalentStrings(this.values.elementAt(v4), v5.values.elementAt(v4))) {
                return false;
            }
        }

        return false;
    }

    private boolean equivalentStrings(String arg4, String arg5) {
        String v0 = this.canonicalize(arg4);
        String v1 = this.canonicalize(arg5);
        boolean v0_1 = (v0.equals(v1)) || (this.stripInternalSpaces(v0).equals(this.stripInternalSpaces(v1))) ? true : false;
        return v0_1;
    }

    public static X509Name getInstance(Object arg2) {
        X509Name v2;
        if(arg2 != null && !(arg2 instanceof X509Name)) {
            if((arg2 instanceof X500Name)) {
                v2 = new X509Name(ASN1Sequence.getInstance(((X500Name)arg2).toASN1Primitive()));
            }
            else if(arg2 != null) {
                v2 = new X509Name(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public static X509Name getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return X509Name.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public Vector getOIDs() {
        Vector v1 = new Vector();
        int v0;
        for(v0 = 0; v0 != this.ordering.size(); ++v0) {
            v1.addElement(this.ordering.elementAt(v0));
        }

        return v1;
    }

    public Vector getValues() {
        Vector v1 = new Vector();
        int v0;
        for(v0 = 0; v0 != this.values.size(); ++v0) {
            v1.addElement(this.values.elementAt(v0));
        }

        return v1;
    }

    public Vector getValues(ASN1ObjectIdentifier arg8) {
        Vector v3 = new Vector();
        int v1;
        for(v1 = 0; v1 != this.values.size(); ++v1) {
            if(this.ordering.elementAt(v1).equals(arg8)) {
                Object v0 = this.values.elementAt(v1);
                if(((String)v0).length() > 2 && ((String)v0).charAt(0) == 92 && ((String)v0).charAt(1) == 35) {
                    v3.addElement(((String)v0).substring(1));
                    goto label_25;
                }

                v3.addElement(v0);
            }

        label_25:
        }

        return v3;
    }

    public int hashCode() {
        int v0;
        if(this.isHashCodeCalculated) {
            v0 = this.hashCodeValue;
        }
        else {
            this.isHashCodeCalculated = true;
            int v1;
            for(v1 = 0; v1 != this.ordering.size(); ++v1) {
                String v0_1 = this.stripInternalSpaces(this.canonicalize(this.values.elementAt(v1)));
                this.hashCodeValue ^= this.ordering.elementAt(v1).hashCode();
                this.hashCodeValue ^= v0_1.hashCode();
            }

            v0 = this.hashCodeValue;
        }

        return v0;
    }

    private String stripInternalSpaces(String arg6) {
        int v4 = 32;
        StringBuffer v3 = new StringBuffer();
        if(arg6.length() != 0) {
            char v1 = arg6.charAt(0);
            v3.append(v1);
            int v0 = 1;
            while(v0 < arg6.length()) {
                char v2 = arg6.charAt(v0);
                if(v1 != v4 || v2 != v4) {
                    v3.append(v2);
                }

                ++v0;
                int v1_1 = v2;
            }
        }

        return v3.toString();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v3_1;
        if(this.seq == null) {
            ASN1EncodableVector v5 = new ASN1EncodableVector();
            Object v3 = null;
            ASN1EncodableVector v4 = new ASN1EncodableVector();
            int v2 = 0;
            while(v2 != this.ordering.size()) {
                ASN1EncodableVector v6 = new ASN1EncodableVector();
                Object v0 = this.ordering.elementAt(v2);
                v6.add(((ASN1Encodable)v0));
                v6.add(this.converter.getConvertedValue(((ASN1ObjectIdentifier)v0), this.values.elementAt(v2)));
                if(v3 == null || (this.added.elementAt(v2).booleanValue())) {
                    v4.add(new DERSequence(v6));
                    v3_1 = v4;
                }
                else {
                    v5.add(new DERSet(v4));
                    v3_1 = new ASN1EncodableVector();
                    v3_1.add(new DERSequence(v6));
                }

                ++v2;
                v4 = v3_1;
                v3 = v0;
            }

            v5.add(new DERSet(v4));
            this.seq = new DERSequence(v5);
        }

        return this.seq;
    }

    public String toString() {
        return this.toString(X509Name.DefaultReverse, X509Name.DefaultSymbols);
    }

    public String toString(boolean arg10, Hashtable arg11) {
        int v0_1;
        int v1;
        StringBuffer v0;
        char v8 = ',';
        StringBuffer v6 = new StringBuffer();
        Vector v7 = new Vector();
        StringBuffer v2 = null;
        int v3 = 0;
        while(v3 < this.ordering.size()) {
            if(this.added.elementAt(v3).booleanValue()) {
                v2.append('+');
                this.appendValue(v2, arg11, this.ordering.elementAt(v3), this.values.elementAt(v3));
                v0 = v2;
            }
            else {
                v2 = new StringBuffer();
                this.appendValue(v2, arg11, this.ordering.elementAt(v3), this.values.elementAt(v3));
                v7.addElement(v2);
                v0 = v2;
            }

            ++v3;
            v2 = v0;
        }

        if(arg10) {
            v1 = v7.size() - 1;
            v0_1 = 1;
            goto label_43;
        }
        else {
            v0_1 = 0;
            v1 = 1;
            while(true) {
                if(v0_1 < v7.size()) {
                    if(v1 != 0) {
                        v1 = 0;
                    }
                    else {
                        v6.append(v8);
                    }

                    v6.append(v7.elementAt(v0_1).toString());
                    ++v0_1;
                    continue;
                }

                goto label_66;
            }

        label_43:
            while(v1 >= 0) {
                if(v0_1 != 0) {
                    v0_1 = 0;
                }
                else {
                    v6.append(v8);
                }

                v6.append(v7.elementAt(v1).toString());
                --v1;
            }
        }

    label_66:
        return v6.toString();
    }

    private String unescape(String arg14) {
        String v0_1;
        int v0;
        int v12 = 34;
        int v11 = 92;
        int v10 = 32;
        if(arg14.length() != 0) {
            if(arg14.indexOf(v11) < 0 && arg14.indexOf(v12) < 0) {
                goto label_11;
            }

            char[] v7 = arg14.toCharArray();
            StringBuffer v8 = new StringBuffer(arg14.length());
            if(v7[0] != v11 || v7[1] != 35) {
                v0 = 0;
            }
            else {
                v0 = 2;
                v8.append("\\#");
            }

            int v2 = 0;
            int v3 = 0;
            int v4 = 0;
            int v5 = 0;
            while(v0 != v7.length) {
                char v9 = v7[v0];
                if(v9 != v10) {
                    v3 = 1;
                }

                if(v9 == v12) {
                    if(v5 != 0) {
                        v8.append(v9);
                    }
                    else if(v4 == 0) {
                        v4 = 1;
                    }
                    else {
                        v4 = 0;
                    }

                    v5 = 0;
                }
                else {
                    if(v9 == v11 && v5 == 0 && v4 == 0) {
                        v2 = v8.length();
                        v5 = 1;
                        goto label_39;
                    }

                    if(v9 == v10 && v5 == 0 && v3 == 0) {
                        goto label_39;
                    }

                    v8.append(v9);
                    v5 = 0;
                }

            label_39:
                ++v0;
            }

            if(v8.length() > 0) {
                while(v8.charAt(v8.length() - 1) == v10) {
                    if(v2 == v8.length() - 1) {
                        break;
                    }

                    v8.setLength(v8.length() - 1);
                }
            }

            v0_1 = v8.toString();
        }
        else {
        label_11:
            v0_1 = arg14.trim();
        }

        return v0_1;
    }
}

