// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509.qualified;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;

public class BiometricData extends ASN1Object {
    private ASN1OctetString biometricDataHash;
    private AlgorithmIdentifier hashAlgorithm;
    private DERIA5String sourceDataUri;
    private TypeOfBiometricData typeOfBiometricData;

    private BiometricData(ASN1Sequence arg3) {
        super();
        Enumeration v0 = arg3.getObjects();
        this.typeOfBiometricData = TypeOfBiometricData.getInstance(v0.nextElement());
        this.hashAlgorithm = AlgorithmIdentifier.getInstance(v0.nextElement());
        this.biometricDataHash = ASN1OctetString.getInstance(v0.nextElement());
        if(v0.hasMoreElements()) {
            this.sourceDataUri = DERIA5String.getInstance(v0.nextElement());
        }
    }

    public BiometricData(TypeOfBiometricData arg2, AlgorithmIdentifier arg3, ASN1OctetString arg4) {
        super();
        this.typeOfBiometricData = arg2;
        this.hashAlgorithm = arg3;
        this.biometricDataHash = arg4;
        this.sourceDataUri = null;
    }

    public BiometricData(TypeOfBiometricData arg1, AlgorithmIdentifier arg2, ASN1OctetString arg3, DERIA5String arg4) {
        super();
        this.typeOfBiometricData = arg1;
        this.hashAlgorithm = arg2;
        this.biometricDataHash = arg3;
        this.sourceDataUri = arg4;
    }

    public ASN1OctetString getBiometricDataHash() {
        return this.biometricDataHash;
    }

    public AlgorithmIdentifier getHashAlgorithm() {
        return this.hashAlgorithm;
    }

    public static BiometricData getInstance(Object arg2) {
        BiometricData v2;
        if(!(arg2 instanceof BiometricData)) {
            if(arg2 != null) {
                v2 = new BiometricData(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public DERIA5String getSourceDataUri() {
        return this.sourceDataUri;
    }

    public TypeOfBiometricData getTypeOfBiometricData() {
        return this.typeOfBiometricData;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.typeOfBiometricData);
        v0.add(this.hashAlgorithm);
        v0.add(this.biometricDataHash);
        if(this.sourceDataUri != null) {
            v0.add(this.sourceDataUri);
        }

        return new DERSequence(v0);
    }
}

