// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509.qualified;

import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERPrintableString;

public class Iso4217CurrencyCode extends ASN1Object implements ASN1Choice {
    final int ALPHABETIC_MAXSIZE;
    final int NUMERIC_MAXSIZE;
    final int NUMERIC_MINSIZE;
    int numeric;
    ASN1Encodable obj;

    public Iso4217CurrencyCode(int arg4) {
        super();
        this.ALPHABETIC_MAXSIZE = 3;
        this.NUMERIC_MINSIZE = 1;
        this.NUMERIC_MAXSIZE = 999;
        if(arg4 <= 999 && arg4 >= 1) {
            this.obj = new ASN1Integer(((long)arg4));
            return;
        }

        throw new IllegalArgumentException("wrong size in numeric code : not in (1..999)");
    }

    public Iso4217CurrencyCode(String arg3) {
        super();
        this.ALPHABETIC_MAXSIZE = 3;
        this.NUMERIC_MINSIZE = 1;
        this.NUMERIC_MAXSIZE = 999;
        if(arg3.length() > 3) {
            throw new IllegalArgumentException("wrong size in alphabetic code : max size is 3");
        }

        this.obj = new DERPrintableString(arg3);
    }

    public String getAlphabetic() {
        return this.obj.getString();
    }

    public static Iso4217CurrencyCode getInstance(Object arg2) {
        Iso4217CurrencyCode v2;
        if(arg2 != null && !(arg2 instanceof Iso4217CurrencyCode)) {
            if((arg2 instanceof ASN1Integer)) {
                v2 = new Iso4217CurrencyCode(ASN1Integer.getInstance(arg2).getValue().intValue());
            }
            else if((arg2 instanceof DERPrintableString)) {
                v2 = new Iso4217CurrencyCode(DERPrintableString.getInstance(arg2).getString());
            }
            else {
                throw new IllegalArgumentException("unknown object in getInstance");
            }
        }

        return v2;
    }

    public int getNumeric() {
        return this.obj.getValue().intValue();
    }

    public boolean isAlphabetic() {
        return this.obj instanceof DERPrintableString;
    }

    public ASN1Primitive toASN1Primitive() {
        return this.obj.toASN1Primitive();
    }
}

