// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509.qualified;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class MonetaryValue extends ASN1Object {
    private ASN1Integer amount;
    private Iso4217CurrencyCode currency;
    private ASN1Integer exponent;

    private MonetaryValue(ASN1Sequence arg3) {
        super();
        Enumeration v0 = arg3.getObjects();
        this.currency = Iso4217CurrencyCode.getInstance(v0.nextElement());
        this.amount = ASN1Integer.getInstance(v0.nextElement());
        this.exponent = ASN1Integer.getInstance(v0.nextElement());
    }

    public MonetaryValue(Iso4217CurrencyCode arg4, int arg5, int arg6) {
        super();
        this.currency = arg4;
        this.amount = new ASN1Integer(((long)arg5));
        this.exponent = new ASN1Integer(((long)arg6));
    }

    public BigInteger getAmount() {
        return this.amount.getValue();
    }

    public Iso4217CurrencyCode getCurrency() {
        return this.currency;
    }

    public BigInteger getExponent() {
        return this.exponent.getValue();
    }

    public static MonetaryValue getInstance(Object arg2) {
        if(!(arg2 instanceof MonetaryValue)) {
            if(arg2 != null) {
                MonetaryValue v2 = new MonetaryValue(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.currency);
        v0.add(this.amount);
        v0.add(this.exponent);
        return new DERSequence(v0);
    }
}

