// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509.qualified;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.GeneralName;

public class SemanticsInformation extends ASN1Object {
    private GeneralName[] nameRegistrationAuthorities;
    private ASN1ObjectIdentifier semanticsIdentifier;

    public SemanticsInformation(ASN1ObjectIdentifier arg2) {
        super();
        this.semanticsIdentifier = arg2;
        this.nameRegistrationAuthorities = null;
    }

    public SemanticsInformation(ASN1ObjectIdentifier arg1, GeneralName[] arg2) {
        super();
        this.semanticsIdentifier = arg1;
        this.nameRegistrationAuthorities = arg2;
    }

    private SemanticsInformation(ASN1Sequence arg5) {
        super();
        Enumeration v1 = arg5.getObjects();
        if(arg5.size() < 1) {
            throw new IllegalArgumentException("no objects in SemanticsInformation");
        }

        Object v0 = v1.nextElement();
        if((v0 instanceof ASN1ObjectIdentifier)) {
            this.semanticsIdentifier = ASN1ObjectIdentifier.getInstance(v0);
            v0 = v1.hasMoreElements() ? v1.nextElement() : null;
        }

        if(v0 != null) {
            ASN1Sequence v1_1 = ASN1Sequence.getInstance(v0);
            this.nameRegistrationAuthorities = new GeneralName[v1_1.size()];
            int v0_1;
            for(v0_1 = 0; v0_1 < v1_1.size(); ++v0_1) {
                this.nameRegistrationAuthorities[v0_1] = GeneralName.getInstance(v1_1.getObjectAt(v0_1));
            }
        }
    }

    public SemanticsInformation(GeneralName[] arg2) {
        super();
        this.semanticsIdentifier = null;
        this.nameRegistrationAuthorities = arg2;
    }

    public static SemanticsInformation getInstance(Object arg2) {
        if(!(arg2 instanceof SemanticsInformation)) {
            if(arg2 != null) {
                SemanticsInformation v2 = new SemanticsInformation(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public GeneralName[] getNameRegistrationAuthorities() {
        return this.nameRegistrationAuthorities;
    }

    public ASN1ObjectIdentifier getSemanticsIdentifier() {
        return this.semanticsIdentifier;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        if(this.semanticsIdentifier != null) {
            v1.add(this.semanticsIdentifier);
        }

        if(this.nameRegistrationAuthorities != null) {
            ASN1EncodableVector v2 = new ASN1EncodableVector();
            int v0;
            for(v0 = 0; v0 < this.nameRegistrationAuthorities.length; ++v0) {
                v2.add(this.nameRegistrationAuthorities[v0]);
            }

            v1.add(new DERSequence(v2));
        }

        return new DERSequence(v1);
    }
}

