// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509.sigi;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1String;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.DirectoryString;

public class NameOrPseudonym extends ASN1Object implements ASN1Choice {
    private ASN1Sequence givenName;
    private DirectoryString pseudonym;
    private DirectoryString surname;

    public NameOrPseudonym(String arg2) {
        this(new DirectoryString(arg2));
    }

    public NameOrPseudonym(DirectoryString arg1) {
        super();
        this.pseudonym = arg1;
    }

    private NameOrPseudonym(ASN1Sequence arg5) {
        super();
        if(arg5.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg5.size());
        }

        if(!(arg5.getObjectAt(0) instanceof ASN1String)) {
            throw new IllegalArgumentException("Bad object encountered: " + arg5.getObjectAt(0).getClass());
        }

        this.surname = DirectoryString.getInstance(arg5.getObjectAt(0));
        this.givenName = ASN1Sequence.getInstance(arg5.getObjectAt(1));
    }

    public NameOrPseudonym(DirectoryString arg1, ASN1Sequence arg2) {
        super();
        this.surname = arg1;
        this.givenName = arg2;
    }

    public DirectoryString[] getGivenName() {
        DirectoryString[] v2 = new DirectoryString[this.givenName.size()];
        int v0 = 0;
        Enumeration v3 = this.givenName.getObjects();
        while(v3.hasMoreElements()) {
            v2[v0] = DirectoryString.getInstance(v3.nextElement());
            ++v0;
        }

        return v2;
    }

    public static NameOrPseudonym getInstance(Object arg3) {
        NameOrPseudonym v3;
        if(arg3 != null && !(arg3 instanceof NameOrPseudonym)) {
            if((arg3 instanceof ASN1String)) {
                v3 = new NameOrPseudonym(DirectoryString.getInstance(arg3));
            }
            else if((arg3 instanceof ASN1Sequence)) {
                v3 = new NameOrPseudonym(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public DirectoryString getPseudonym() {
        return this.pseudonym;
    }

    public DirectoryString getSurname() {
        return this.surname;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1Primitive v0;
        if(this.pseudonym != null) {
            v0 = this.pseudonym.toASN1Primitive();
        }
        else {
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            v1.add(this.surname);
            v1.add(this.givenName);
            DERSequence v0_1 = new DERSequence(v1);
        }

        return v0;
    }
}

