// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x509.sigi;

import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x500.DirectoryString;

public class PersonalData extends ASN1Object {
    private ASN1GeneralizedTime dateOfBirth;
    private String gender;
    private BigInteger nameDistinguisher;
    private NameOrPseudonym nameOrPseudonym;
    private DirectoryString placeOfBirth;
    private DirectoryString postalAddress;

    private PersonalData(ASN1Sequence arg6) {
        super();
        if(arg6.size() < 1) {
            throw new IllegalArgumentException("Bad sequence size: " + arg6.size());
        }

        Enumeration v0 = arg6.getObjects();
        this.nameOrPseudonym = NameOrPseudonym.getInstance(v0.nextElement());
        while(v0.hasMoreElements()) {
            ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0.nextElement());
            switch(v1.getTagNo()) {
                case 0: {
                    goto label_35;
                }
                case 1: {
                    goto label_39;
                }
                case 2: {
                    goto label_42;
                }
                case 3: {
                    goto label_45;
                }
                case 4: {
                    goto label_49;
                }
            }

            throw new IllegalArgumentException("Bad tag number: " + v1.getTagNo());
        label_39:
            this.dateOfBirth = ASN1GeneralizedTime.getInstance(v1, false);
            continue;
        label_49:
            this.postalAddress = DirectoryString.getInstance(v1, true);
            continue;
        label_35:
            this.nameDistinguisher = ASN1Integer.getInstance(v1, false).getValue();
            continue;
        label_45:
            this.gender = DERPrintableString.getInstance(v1, false).getString();
            continue;
        label_42:
            this.placeOfBirth = DirectoryString.getInstance(v1, true);
        }
    }

    public PersonalData(NameOrPseudonym arg1, BigInteger arg2, ASN1GeneralizedTime arg3, DirectoryString arg4, String arg5, DirectoryString arg6) {
        super();
        this.nameOrPseudonym = arg1;
        this.dateOfBirth = arg3;
        this.gender = arg5;
        this.nameDistinguisher = arg2;
        this.postalAddress = arg6;
        this.placeOfBirth = arg4;
    }

    public ASN1GeneralizedTime getDateOfBirth() {
        return this.dateOfBirth;
    }

    public String getGender() {
        return this.gender;
    }

    public static PersonalData getInstance(Object arg3) {
        PersonalData v3;
        if(arg3 != null && !(arg3 instanceof PersonalData)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new PersonalData(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("illegal object in getInstance: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public BigInteger getNameDistinguisher() {
        return this.nameDistinguisher;
    }

    public NameOrPseudonym getNameOrPseudonym() {
        return this.nameOrPseudonym;
    }

    public DirectoryString getPlaceOfBirth() {
        return this.placeOfBirth;
    }

    public DirectoryString getPostalAddress() {
        return this.postalAddress;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.nameOrPseudonym);
        if(this.nameDistinguisher != null) {
            v0.add(new DERTaggedObject(false, 0, new ASN1Integer(this.nameDistinguisher)));
        }

        if(this.dateOfBirth != null) {
            v0.add(new DERTaggedObject(false, 1, this.dateOfBirth));
        }

        if(this.placeOfBirth != null) {
            v0.add(new DERTaggedObject(true, 2, this.placeOfBirth));
        }

        if(this.gender != null) {
            v0.add(new DERTaggedObject(false, 3, new DERPrintableString(this.gender, true)));
        }

        if(this.postalAddress != null) {
            v0.add(new DERTaggedObject(true, 4, this.postalAddress));
        }

        return new DERSequence(v0);
    }
}

