// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x9;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERSequence;

public class DHDomainParameters extends ASN1Object {
    private ASN1Integer g;
    private ASN1Integer j;
    private ASN1Integer p;
    private ASN1Integer q;
    private DHValidationParms validationParms;

    public DHDomainParameters(ASN1Integer arg3, ASN1Integer arg4, ASN1Integer arg5, ASN1Integer arg6, DHValidationParms arg7) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'p\' cannot be null");
        }

        if(arg4 == null) {
            throw new IllegalArgumentException("\'g\' cannot be null");
        }

        if(arg5 == null) {
            throw new IllegalArgumentException("\'q\' cannot be null");
        }

        this.p = arg3;
        this.g = arg4;
        this.q = arg5;
        this.j = arg6;
        this.validationParms = arg7;
    }

    private DHDomainParameters(ASN1Sequence arg4) {
        super();
        if(arg4.size() >= 3 && arg4.size() <= 5) {
            Enumeration v1 = arg4.getObjects();
            this.p = ASN1Integer.getInstance(v1.nextElement());
            this.g = ASN1Integer.getInstance(v1.nextElement());
            this.q = ASN1Integer.getInstance(v1.nextElement());
            ASN1Encodable v0 = DHDomainParameters.getNext(v1);
            if(v0 != null && ((v0 instanceof ASN1Integer))) {
                this.j = ASN1Integer.getInstance(v0);
                v0 = DHDomainParameters.getNext(v1);
            }

            if(v0 != null) {
                this.validationParms = DHValidationParms.getInstance(v0.toASN1Primitive());
            }

            return;
        }

        throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
    }

    public ASN1Integer getG() {
        return this.g;
    }

    public static DHDomainParameters getInstance(Object arg3) {
        DHDomainParameters v3;
        if(arg3 != null && !(arg3 instanceof DHDomainParameters)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new DHDomainParameters(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid DHDomainParameters: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static DHDomainParameters getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DHDomainParameters.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Integer getJ() {
        return this.j;
    }

    private static ASN1Encodable getNext(Enumeration arg1) {
        ASN1Encodable v0_1;
        if(arg1.hasMoreElements()) {
            Object v0 = arg1.nextElement();
        }
        else {
            v0_1 = null;
        }

        return v0_1;
    }

    public ASN1Integer getP() {
        return this.p;
    }

    public ASN1Integer getQ() {
        return this.q;
    }

    public DHValidationParms getValidationParms() {
        return this.validationParms;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.p);
        v0.add(this.g);
        v0.add(this.q);
        if(this.j != null) {
            v0.add(this.j);
        }

        if(this.validationParms != null) {
            v0.add(this.validationParms);
        }

        return new DERSequence(v0);
    }
}

