// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x9;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;

public class DHValidationParms extends ASN1Object {
    private ASN1Integer pgenCounter;
    private DERBitString seed;

    private DHValidationParms(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("Bad sequence size: " + arg4.size());
        }

        this.seed = DERBitString.getInstance(arg4.getObjectAt(0));
        this.pgenCounter = ASN1Integer.getInstance(arg4.getObjectAt(1));
    }

    public DHValidationParms(DERBitString arg3, ASN1Integer arg4) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'seed\' cannot be null");
        }

        if(arg4 == null) {
            throw new IllegalArgumentException("\'pgenCounter\' cannot be null");
        }

        this.seed = arg3;
        this.pgenCounter = arg4;
    }

    public static DHValidationParms getInstance(Object arg3) {
        DHValidationParms v3;
        if(arg3 != null && !(arg3 instanceof DHDomainParameters)) {
            if((arg3 instanceof ASN1Sequence)) {
                v3 = new DHValidationParms(((ASN1Sequence)arg3));
            }
            else {
                throw new IllegalArgumentException("Invalid DHValidationParms: " + arg3.getClass().getName());
            }
        }

        return v3;
    }

    public static DHValidationParms getInstance(ASN1TaggedObject arg1, boolean arg2) {
        return DHValidationParms.getInstance(ASN1Sequence.getInstance(arg1, arg2));
    }

    public ASN1Integer getPgenCounter() {
        return this.pgenCounter;
    }

    public DERBitString getSeed() {
        return this.seed;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.seed);
        v0.add(this.pgenCounter);
        return new DERSequence(v0);
    }
}

