// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x9;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECCurve$F2m;
import org.bouncycastle.math.ec.ECCurve$Fp;

public class X9Curve extends ASN1Object implements X9ObjectIdentifiers {
    private ECCurve curve;
    private ASN1ObjectIdentifier fieldIdentifier;
    private byte[] seed;

    public X9Curve(X9FieldID arg13, ASN1Sequence arg14) {
        int v3;
        int v4;
        int v2_1;
        int v11 = 2;
        super();
        this.fieldIdentifier = null;
        this.fieldIdentifier = arg13.getIdentifier();
        if(this.fieldIdentifier.equals(X9Curve.prime_field)) {
            BigInteger v1 = arg13.getParameters().getValue();
            this.curve = new ECCurve$Fp(v1, new X9FieldElement(v1, arg14.getObjectAt(0)).getValue().toBigInteger(), new X9FieldElement(v1, arg14.getObjectAt(1)).getValue().toBigInteger());
        }
        else if(this.fieldIdentifier.equals(X9Curve.characteristic_two_field)) {
            ASN1Sequence v2 = ASN1Sequence.getInstance(arg13.getParameters());
            int v1_1 = v2.getObjectAt(0).getValue().intValue();
            ASN1Encodable v0 = v2.getObjectAt(1);
            if(((ASN1ObjectIdentifier)v0).equals(X9Curve.tpBasis)) {
                v2_1 = ASN1Integer.getInstance(v2.getObjectAt(v11)).getValue().intValue();
                v4 = 0;
                v3 = 0;
            }
            else if(((ASN1ObjectIdentifier)v0).equals(X9Curve.ppBasis)) {
                ASN1Sequence v0_1 = ASN1Sequence.getInstance(v2.getObjectAt(v11));
                v2_1 = ASN1Integer.getInstance(v0_1.getObjectAt(0)).getValue().intValue();
                v3 = ASN1Integer.getInstance(v0_1.getObjectAt(1)).getValue().intValue();
                v4 = ASN1Integer.getInstance(v0_1.getObjectAt(v11)).getValue().intValue();
            }
            else {
                goto label_92;
            }

            this.curve = new ECCurve$F2m(v1_1, v2_1, v3, v4, new X9FieldElement(v1_1, v2_1, v3, v4, arg14.getObjectAt(0)).getValue().toBigInteger(), new X9FieldElement(v1_1, v2_1, v3, v4, arg14.getObjectAt(1)).getValue().toBigInteger());
        }
        else {
            goto label_96;
        }

        if(arg14.size() == 3) {
            this.seed = arg14.getObjectAt(v11).getBytes();
        }

        return;
    label_92:
        throw new IllegalArgumentException("This type of EC basis is not implemented");
    label_96:
        throw new IllegalArgumentException("This type of ECCurve is not implemented");
    }

    public X9Curve(ECCurve arg2) {
        super();
        this.fieldIdentifier = null;
        this.curve = arg2;
        this.seed = null;
        this.setFieldIdentifier();
    }

    public X9Curve(ECCurve arg2, byte[] arg3) {
        super();
        this.fieldIdentifier = null;
        this.curve = arg2;
        this.seed = arg3;
        this.setFieldIdentifier();
    }

    public ECCurve getCurve() {
        return this.curve;
    }

    public byte[] getSeed() {
        return this.seed;
    }

    private void setFieldIdentifier() {
        if((this.curve instanceof ECCurve$Fp)) {
            this.fieldIdentifier = X9Curve.prime_field;
        }
        else if((this.curve instanceof ECCurve$F2m)) {
            this.fieldIdentifier = X9Curve.characteristic_two_field;
        }
        else {
            goto label_12;
        }

        return;
    label_12:
        throw new IllegalArgumentException("This type of ECCurve is not implemented");
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        if(this.fieldIdentifier.equals(X9Curve.prime_field)) {
            v0.add(new X9FieldElement(this.curve.getA()).toASN1Primitive());
            v0.add(new X9FieldElement(this.curve.getB()).toASN1Primitive());
        }
        else if(this.fieldIdentifier.equals(X9Curve.characteristic_two_field)) {
            v0.add(new X9FieldElement(this.curve.getA()).toASN1Primitive());
            v0.add(new X9FieldElement(this.curve.getB()).toASN1Primitive());
        }

        if(this.seed != null) {
            v0.add(new DERBitString(this.seed));
        }

        return new DERSequence(v0);
    }
}

