// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x9;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECCurve$F2m;
import org.bouncycastle.math.ec.ECCurve$Fp;
import org.bouncycastle.math.ec.ECPoint;

public class X9ECParameters extends ASN1Object implements X9ObjectIdentifiers {
    private static final BigInteger ONE;
    private ECCurve curve;
    private X9FieldID fieldID;
    private ECPoint g;
    private BigInteger h;
    private BigInteger n;
    private byte[] seed;

    static {
        X9ECParameters.ONE = BigInteger.valueOf(1);
    }

    public X9ECParameters(ECCurve arg6, ECPoint arg7, BigInteger arg8, BigInteger arg9, byte[] arg10) {
        super();
        this.curve = arg6;
        this.g = arg7;
        this.n = arg8;
        this.h = arg9;
        this.seed = arg10;
        if((arg6 instanceof ECCurve$Fp)) {
            this.fieldID = new X9FieldID(((ECCurve$Fp)arg6).getQ());
        }
        else if((arg6 instanceof ECCurve$F2m)) {
            this.fieldID = new X9FieldID(((ECCurve$F2m)arg6).getM(), ((ECCurve$F2m)arg6).getK1(), ((ECCurve$F2m)arg6).getK2(), ((ECCurve$F2m)arg6).getK3());
        }
    }

    public X9ECParameters(ECCurve arg7, ECPoint arg8, BigInteger arg9, BigInteger arg10) {
        this(arg7, arg8, arg9, arg10, null);
    }

    private X9ECParameters(ASN1Sequence arg5) {
        super();
        if(((arg5.getObjectAt(0) instanceof ASN1Integer)) && (arg5.getObjectAt(0).getValue().equals(X9ECParameters.ONE))) {
            X9Curve v1 = new X9Curve(new X9FieldID(arg5.getObjectAt(1)), arg5.getObjectAt(2));
            this.curve = v1.getCurve();
            this.g = new X9ECPoint(this.curve, arg5.getObjectAt(3)).getPoint();
            this.n = arg5.getObjectAt(4).getValue();
            this.seed = v1.getSeed();
            if(arg5.size() == 6) {
                this.h = arg5.getObjectAt(5).getValue();
            }

            return;
        }

        throw new IllegalArgumentException("bad version in X9ECParameters");
    }

    public X9ECParameters(ECCurve arg7, ECPoint arg8, BigInteger arg9) {
        this(arg7, arg8, arg9, X9ECParameters.ONE, null);
    }

    public ECCurve getCurve() {
        return this.curve;
    }

    public ECPoint getG() {
        return this.g;
    }

    public BigInteger getH() {
        BigInteger v0 = this.h == null ? X9ECParameters.ONE : this.h;
        return v0;
    }

    public static X9ECParameters getInstance(Object arg2) {
        if(!(arg2 instanceof X9ECParameters)) {
            if(arg2 != null) {
                X9ECParameters v2 = new X9ECParameters(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public BigInteger getN() {
        return this.n;
    }

    public byte[] getSeed() {
        return this.seed;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(1));
        v0.add(this.fieldID);
        v0.add(new X9Curve(this.curve, this.seed));
        v0.add(new X9ECPoint(this.g));
        v0.add(new ASN1Integer(this.n));
        if(this.h != null) {
            v0.add(new ASN1Integer(this.h));
        }

        return new DERSequence(v0);
    }
}

