// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.asn1.x9;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;

public class X9FieldID extends ASN1Object implements X9ObjectIdentifiers {
    private ASN1ObjectIdentifier id;
    private ASN1Primitive parameters;

    public X9FieldID(ASN1Sequence arg2) {
        super();
        this.id = arg2.getObjectAt(0);
        this.parameters = arg2.getObjectAt(1);
    }

    public X9FieldID(BigInteger arg2) {
        super();
        this.id = X9FieldID.prime_field;
        this.parameters = new ASN1Integer(arg2);
    }

    public X9FieldID(int arg6, int arg7, int arg8, int arg9) {
        super();
        this.id = X9FieldID.characteristic_two_field;
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new ASN1Integer(((long)arg6)));
        if(arg8 == 0) {
            v0.add(X9FieldID.tpBasis);
            v0.add(new ASN1Integer(((long)arg7)));
        }
        else {
            v0.add(X9FieldID.ppBasis);
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            v1.add(new ASN1Integer(((long)arg7)));
            v1.add(new ASN1Integer(((long)arg8)));
            v1.add(new ASN1Integer(((long)arg9)));
            v0.add(new DERSequence(v1));
        }

        this.parameters = new DERSequence(v0);
    }

    public ASN1ObjectIdentifier getIdentifier() {
        return this.id;
    }

    public ASN1Primitive getParameters() {
        return this.parameters;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.id);
        v0.add(this.parameters);
        return new DERSequence(v0);
    }
}

