// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto;

public class BufferedAsymmetricBlockCipher {
    protected byte[] buf;
    protected int bufOff;
    private final AsymmetricBlockCipher cipher;

    public BufferedAsymmetricBlockCipher(AsymmetricBlockCipher arg1) {
        super();
        this.cipher = arg1;
    }

    public byte[] doFinal() {
        byte[] v0 = this.cipher.processBlock(this.buf, 0, this.bufOff);
        this.reset();
        return v0;
    }

    public int getBufferPosition() {
        return this.bufOff;
    }

    public int getInputBlockSize() {
        return this.cipher.getInputBlockSize();
    }

    public int getOutputBlockSize() {
        return this.cipher.getOutputBlockSize();
    }

    public AsymmetricBlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg4, CipherParameters arg5) {
        this.reset();
        this.cipher.init(arg4, arg5);
        int v2 = this.cipher.getInputBlockSize();
        int v0 = arg4 ? 1 : 0;
        this.buf = new byte[v0 + v2];
        this.bufOff = 0;
    }

    public void processByte(byte arg4) {
        if(this.bufOff >= this.buf.length) {
            throw new DataLengthException("attempt to process message too long for cipher");
        }

        byte[] v0 = this.buf;
        int v1 = this.bufOff;
        this.bufOff = v1 + 1;
        v0[v1] = arg4;
    }

    public void processBytes(byte[] arg3, int arg4, int arg5) {
        if(arg5 != 0) {
            if(arg5 < 0) {
                throw new IllegalArgumentException("Can\'t have a negative input length!");
            }
            else if(this.bufOff + arg5 > this.buf.length) {
                throw new DataLengthException("attempt to process message too long for cipher");
            }
            else {
                System.arraycopy(arg3, arg4, this.buf, this.bufOff, arg5);
                this.bufOff += arg5;
            }
        }
    }

    public void reset() {
        if(this.buf != null) {
            int v0;
            for(v0 = 0; v0 < this.buf.length; ++v0) {
                this.buf[v0] = 0;
            }
        }

        this.bufOff = 0;
    }
}

