// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto;

public class BufferedBlockCipher {
    public byte[] buf;
    public int bufOff;
    public BlockCipher cipher;
    public boolean forEncryption;
    protected boolean partialBlockOkay;
    protected boolean pgpCFB;

    public BufferedBlockCipher() {
        super();
    }

    public BufferedBlockCipher(BlockCipher arg6) {
        boolean v1 = true;
        super();
        this.cipher = arg6;
        this.buf = new byte[arg6.getBlockSize()];
        this.bufOff = 0;
        String v3 = arg6.getAlgorithmName();
        int v4 = v3.indexOf(47) + 1;
        boolean v0 = v4 <= 0 || !v3.startsWith("PGP", v4) ? false : true;
        this.pgpCFB = v0;
        if(this.pgpCFB) {
            this.partialBlockOkay = true;
        }
        else {
            if(v4 <= 0 || !v3.startsWith("CFB", v4) && !v3.startsWith("OFB", v4) && !v3.startsWith("OpenPGP", v4) && !v3.startsWith("SIC", v4) && !v3.startsWith("GCTR", v4)) {
                v1 = false;
            }

            this.partialBlockOkay = v1;
        }
    }

    public int doFinal(byte[] arg6, int arg7) {
        int v0 = 0;
        try {
            if(this.bufOff + arg7 > arg6.length) {
                throw new OutputLengthException("output buffer too short for doFinal()");
            }

            if(this.bufOff != 0) {
                if(!this.partialBlockOkay) {
                    throw new DataLengthException("data not block size aligned");
                }
                else {
                    this.cipher.processBlock(this.buf, 0, this.buf, 0);
                    v0 = this.bufOff;
                    this.bufOff = 0;
                    System.arraycopy(this.buf, 0, arg6, arg7, v0);
                }
            }
        }
        catch(Throwable v0_1) {
            this.reset();
            throw v0_1;
        }

        this.reset();
        return v0;
    }

    public int getBlockSize() {
        return this.cipher.getBlockSize();
    }

    public int getOutputSize(int arg2) {
        return this.bufOff + arg2;
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public int getUpdateOutputSize(int arg4) {
        int v1 = arg4 + this.bufOff;
        int v0 = this.pgpCFB ? v1 % this.buf.length - (this.cipher.getBlockSize() + 2) : v1 % this.buf.length;
        return v1 - v0;
    }

    public void init(boolean arg2, CipherParameters arg3) {
        this.forEncryption = arg2;
        this.reset();
        this.cipher.init(arg2, arg3);
    }

    public int processByte(byte arg5, byte[] arg6, int arg7) {
        int v0_1;
        byte[] v0 = this.buf;
        int v2 = this.bufOff;
        this.bufOff = v2 + 1;
        v0[v2] = arg5;
        if(this.bufOff == this.buf.length) {
            v0_1 = this.cipher.processBlock(this.buf, 0, arg6, arg7);
            this.bufOff = 0;
        }
        else {
            v0_1 = 0;
        }

        return v0_1;
    }

    public int processBytes(byte[] arg8, int arg9, int arg10, byte[] arg11, int arg12) {
        int v1;
        if(arg10 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v4 = this.getBlockSize();
        int v0 = this.getUpdateOutputSize(arg10);
        if(v0 > 0 && v0 + arg12 > arg11.length) {
            throw new OutputLengthException("output buffer too short");
        }

        int v2 = this.buf.length - this.bufOff;
        if(arg10 > v2) {
            System.arraycopy(arg8, arg9, this.buf, this.bufOff, v2);
            v0 = this.cipher.processBlock(this.buf, 0, arg11, arg12);
            this.bufOff = 0;
            v1 = arg10 - v2;
            v2 += arg9;
            while(v1 > this.buf.length) {
                v0 += this.cipher.processBlock(arg8, v2, arg11, arg12 + v0);
                v1 -= v4;
                v2 += v4;
            }
        }
        else {
            v0 = 0;
            v1 = arg10;
            v2 = arg9;
        }

        System.arraycopy(arg8, v2, this.buf, this.bufOff, v1);
        this.bufOff = v1 + this.bufOff;
        if(this.bufOff == this.buf.length) {
            v0 += this.cipher.processBlock(this.buf, 0, arg11, arg12 + v0);
            this.bufOff = 0;
        }

        return v0;
    }

    public void reset() {
        int v0;
        for(v0 = 0; v0 < this.buf.length; ++v0) {
            this.buf[v0] = 0;
        }

        this.bufOff = 0;
        this.cipher.reset();
    }
}

