// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.generators.DHKeyPairGenerator;
import org.bouncycastle.crypto.params.DHKeyGenerationParameters;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;

public class DHAgreement {
    private DHParameters dhParams;
    private DHPrivateKeyParameters key;
    private BigInteger privateValue;
    private SecureRandom random;

    public DHAgreement() {
        super();
    }

    public BigInteger calculateAgreement(DHPublicKeyParameters arg5, BigInteger arg6) {
        if(!arg5.getParameters().equals(this.dhParams)) {
            throw new IllegalArgumentException("Diffie-Hellman public key has wrong parameters.");
        }

        BigInteger v0 = this.dhParams.getP();
        return arg6.modPow(this.key.getX(), v0).multiply(arg5.getY().modPow(this.privateValue, v0)).mod(v0);
    }

    public BigInteger calculateMessage() {
        DHKeyPairGenerator v0 = new DHKeyPairGenerator();
        v0.init(new DHKeyGenerationParameters(this.random, this.dhParams));
        AsymmetricCipherKeyPair v1 = v0.generateKeyPair();
        this.privateValue = v1.getPrivate().getX();
        return v1.getPublic().getY();
    }

    public void init(CipherParameters arg3) {
        CipherParameters v0;
        if((arg3 instanceof ParametersWithRandom)) {
            this.random = ((ParametersWithRandom)arg3).getRandom();
            v0 = ((ParametersWithRandom)arg3).getParameters();
        }
        else {
            this.random = new SecureRandom();
            v0 = arg3;
        }

        if(!(v0 instanceof DHPrivateKeyParameters)) {
            throw new IllegalArgumentException("DHEngine expects DHPrivateKeyParameters");
        }

        this.key = ((DHPrivateKeyParameters)v0);
        this.dhParams = this.key.getParameters();
    }
}

