// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement;

import java.math.BigInteger;
import org.bouncycastle.crypto.BasicAgreement;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;

public class DHBasicAgreement implements BasicAgreement {
    private DHParameters dhParams;
    private DHPrivateKeyParameters key;

    public DHBasicAgreement() {
        super();
    }

    public BigInteger calculateAgreement(CipherParameters arg4) {
        if(!((DHPublicKeyParameters)arg4).getParameters().equals(this.dhParams)) {
            throw new IllegalArgumentException("Diffie-Hellman public key has wrong parameters.");
        }

        return ((DHPublicKeyParameters)arg4).getY().modPow(this.key.getX(), this.dhParams.getP());
    }

    public int getFieldSize() {
        return (this.key.getParameters().getP().bitLength() + 7) / 8;
    }

    public void init(CipherParameters arg3) {
        CipherParameters v0 = (arg3 instanceof ParametersWithRandom) ? ((ParametersWithRandom)arg3).getParameters() : arg3;
        if(!(v0 instanceof DHPrivateKeyParameters)) {
            throw new IllegalArgumentException("DHEngine expects DHPrivateKeyParameters");
        }

        this.key = ((DHPrivateKeyParameters)v0);
        this.dhParams = this.key.getParameters();
    }
}

