// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement;

import java.math.BigInteger;
import org.bouncycastle.crypto.BasicAgreement;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.MQVPrivateParameters;
import org.bouncycastle.crypto.params.MQVPublicParameters;
import org.bouncycastle.math.ec.ECAlgorithms;
import org.bouncycastle.math.ec.ECConstants;
import org.bouncycastle.math.ec.ECPoint;

public class ECMQVBasicAgreement implements BasicAgreement {
    MQVPrivateParameters privParams;

    public ECMQVBasicAgreement() {
        super();
    }

    public BigInteger calculateAgreement(CipherParameters arg8) {
        ECPrivateKeyParameters v2 = this.privParams.getStaticPrivateKey();
        return this.calculateMqvAgreement(v2.getParameters(), v2, this.privParams.getEphemeralPrivateKey(), this.privParams.getEphemeralPublicKey(), ((MQVPublicParameters)arg8).getStaticPublicKey(), ((MQVPublicParameters)arg8).getEphemeralPublicKey()).getX().toBigInteger();
    }

    private ECPoint calculateMqvAgreement(ECDomainParameters arg6, ECPrivateKeyParameters arg7, ECPrivateKeyParameters arg8, ECPublicKeyParameters arg9, ECPublicKeyParameters arg10, ECPublicKeyParameters arg11) {
        BigInteger v1 = arg6.getN();
        int v2 = (v1.bitLength() + 1) / 2;
        BigInteger v3 = ECConstants.ONE.shiftLeft(v2);
        ECPoint v0 = arg9 == null ? arg6.getG().multiply(arg8.getD()) : arg9.getQ();
        BigInteger v0_1 = arg7.getD().multiply(v0.getX().toBigInteger().mod(v3).setBit(v2)).mod(v1).add(arg8.getD()).mod(v1);
        BigInteger v2_1 = arg11.getQ().getX().toBigInteger().mod(v3).setBit(v2);
        v0_1 = arg6.getH().multiply(v0_1).mod(v1);
        v0 = ECAlgorithms.sumOfTwoMultiplies(arg10.getQ(), v2_1.multiply(v0_1).mod(v1), arg11.getQ(), v0_1);
        if(v0.isInfinity()) {
            throw new IllegalStateException("Infinity is not a valid agreement value for MQV");
        }

        return v0;
    }

    public int getFieldSize() {
        return (this.privParams.getStaticPrivateKey().getParameters().getCurve().getFieldSize() + 7) / 8;
    }

    public void init(CipherParameters arg1) {
        this.privParams = ((MQVPrivateParameters)arg1);
    }
}

