// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement.jpake;

import java.math.BigInteger;

public class JPAKEPrimeOrderGroup {
    private final BigInteger g;
    private final BigInteger p;
    private final BigInteger q;

    public JPAKEPrimeOrderGroup(BigInteger arg2, BigInteger arg3, BigInteger arg4) {
        this(arg2, arg3, arg4, false);
    }

    JPAKEPrimeOrderGroup(BigInteger arg4, BigInteger arg5, BigInteger arg6, boolean arg7) {
        int v2 = 20;
        super();
        JPAKEUtil.validateNotNull(arg4, "p");
        JPAKEUtil.validateNotNull(arg5, "q");
        JPAKEUtil.validateNotNull(arg6, "g");
        if(!arg7) {
            if(!arg4.subtract(JPAKEUtil.ONE).mod(arg5).equals(JPAKEUtil.ZERO)) {
                throw new IllegalArgumentException("p-1 must be evenly divisible by q");
            }
            else {
                if(arg6.compareTo(BigInteger.valueOf(2)) != -1 && arg6.compareTo(arg4.subtract(JPAKEUtil.ONE)) != 1) {
                    if(!arg6.modPow(arg5, arg4).equals(JPAKEUtil.ONE)) {
                        throw new IllegalArgumentException("g^q mod p must equal 1");
                    }
                    else if(!arg4.isProbablePrime(v2)) {
                        throw new IllegalArgumentException("p must be prime");
                    }
                    else if(!arg5.isProbablePrime(v2)) {
                        throw new IllegalArgumentException("q must be prime");
                    }
                    else {
                        goto label_53;
                    }
                }

                throw new IllegalArgumentException("g must be in [2, p-1]");
            }
        }

    label_53:
        this.p = arg4;
        this.q = arg5;
        this.g = arg6;
    }

    public BigInteger getG() {
        return this.g;
    }

    public BigInteger getP() {
        return this.p;
    }

    public BigInteger getQ() {
        return this.q;
    }
}

