// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement.kdf;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.DerivationParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.util.Pack;

public class DHKEKGenerator implements DerivationFunction {
    private DERObjectIdentifier algorithm;
    private final Digest digest;
    private int keySize;
    private byte[] partyAInfo;
    private byte[] z;

    public DHKEKGenerator(Digest arg1) {
        super();
        this.digest = arg1;
    }

    public int generateBytes(byte[] arg17, int arg18, int arg19) {
        if(arg17.length - arg19 < arg18) {
            throw new DataLengthException("output buffer too small");
        }

        long v5 = ((long)arg19);
        int v7 = this.digest.getDigestSize();
        if(v5 > 8589934591L) {
            throw new IllegalArgumentException("Output length too large");
        }

        int v8 = ((int)(((((long)v7)) + v5 - 1) / (((long)v7))));
        byte[] v9 = new byte[this.digest.getDigestSize()];
        int v3 = 0;
        int v4 = 1;
        int v1 = arg19;
        int v2 = arg18;
        while(v3 < v8) {
            this.digest.update(this.z, 0, this.z.length);
            ASN1EncodableVector v10 = new ASN1EncodableVector();
            ASN1EncodableVector v11 = new ASN1EncodableVector();
            v11.add(this.algorithm);
            v11.add(new DEROctetString(Pack.intToBigEndian(v4)));
            v10.add(new DERSequence(v11));
            if(this.partyAInfo != null) {
                v10.add(new DERTaggedObject(true, 0, new DEROctetString(this.partyAInfo)));
            }

            v10.add(new DERTaggedObject(true, 2, new DEROctetString(Pack.intToBigEndian(this.keySize))));
            try {
                byte[] v10_1 = new DERSequence(v10).getEncoded("DER");
                this.digest.update(v10_1, 0, v10_1.length);
            }
            catch(IOException v1_1) {
                throw new IllegalArgumentException("unable to encode parameter info: " + v1_1.getMessage());
            }

            this.digest.doFinal(v9, 0);
            if(v1 > v7) {
                System.arraycopy(v9, 0, arg17, v2, v7);
                v2 += v7;
                v1 -= v7;
            }
            else {
                System.arraycopy(v9, 0, arg17, v2, v1);
            }

            ++v4;
            ++v3;
        }

        this.digest.reset();
        return ((int)v5);
    }

    public Digest getDigest() {
        return this.digest;
    }

    public void init(DerivationParameters arg2) {
        this.algorithm = ((DHKDFParameters)arg2).getAlgorithm();
        this.keySize = ((DHKDFParameters)arg2).getKeySize();
        this.z = ((DHKDFParameters)arg2).getZ();
        this.partyAInfo = ((DHKDFParameters)arg2).getExtraInfo();
    }
}

