// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement.kdf;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERTaggedObject;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.DerivationParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.generators.KDF2BytesGenerator;
import org.bouncycastle.crypto.params.KDFParameters;
import org.bouncycastle.crypto.util.Pack;

public class ECDHKEKGenerator implements DerivationFunction {
    private ASN1ObjectIdentifier algorithm;
    private DerivationFunction kdf;
    private int keySize;
    private byte[] z;

    public ECDHKEKGenerator(Digest arg2) {
        super();
        this.kdf = new KDF2BytesGenerator(arg2);
    }

    public int generateBytes(byte[] arg7, int arg8, int arg9) {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(new AlgorithmIdentifier(this.algorithm, DERNull.INSTANCE));
        v0.add(new DERTaggedObject(true, 2, new DEROctetString(Pack.intToBigEndian(this.keySize))));
        try {
            this.kdf.init(new KDFParameters(this.z, new DERSequence(v0).getEncoded("DER")));
        }
        catch(IOException v0_1) {
            throw new IllegalArgumentException("unable to initialise kdf: " + v0_1.getMessage());
        }

        return this.kdf.generateBytes(arg7, arg8, arg9);
    }

    public Digest getDigest() {
        return this.kdf.getDigest();
    }

    public void init(DerivationParameters arg2) {
        this.algorithm = ((DHKDFParameters)arg2).getAlgorithm();
        this.keySize = ((DHKDFParameters)arg2).getKeySize();
        this.z = ((DHKDFParameters)arg2).getZ();
    }
}

