// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.agreement.srp;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CryptoException;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.util.BigIntegers;

public class SRP6Util {
    private static BigInteger ONE;
    private static BigInteger ZERO;

    static {
        SRP6Util.ZERO = BigInteger.valueOf(0);
        SRP6Util.ONE = BigInteger.valueOf(1);
    }

    public SRP6Util() {
        super();
    }

    public static BigInteger calculateK(Digest arg1, BigInteger arg2, BigInteger arg3) {
        return SRP6Util.hashPaddedPair(arg1, arg2, arg2, arg3);
    }

    public static BigInteger calculateU(Digest arg1, BigInteger arg2, BigInteger arg3, BigInteger arg4) {
        return SRP6Util.hashPaddedPair(arg1, arg2, arg3, arg4);
    }

    public static BigInteger calculateX(Digest arg3, BigInteger arg4, byte[] arg5, byte[] arg6, byte[] arg7) {
        byte[] v0 = new byte[arg3.getDigestSize()];
        arg3.update(arg6, 0, arg6.length);
        arg3.update(58);
        arg3.update(arg7, 0, arg7.length);
        arg3.doFinal(v0, 0);
        arg3.update(arg5, 0, arg5.length);
        arg3.update(v0, 0, v0.length);
        arg3.doFinal(v0, 0);
        return new BigInteger(1, v0);
    }

    public static BigInteger generatePrivateValue(Digest arg2, BigInteger arg3, BigInteger arg4, SecureRandom arg5) {
        return BigIntegers.createRandomInRange(SRP6Util.ONE.shiftLeft(Math.min(256, arg3.bitLength() / 2) - 1), arg3.subtract(SRP6Util.ONE), arg5);
    }

    private static byte[] getPadded(BigInteger arg5, int arg6) {
        byte[] v0;
        byte[] v1 = BigIntegers.asUnsignedByteArray(arg5);
        if(v1.length < arg6) {
            v0 = new byte[arg6];
            System.arraycopy(v1, 0, v0, arg6 - v1.length, v1.length);
        }
        else {
            v0 = v1;
        }

        return v0;
    }

    private static BigInteger hashPaddedPair(Digest arg4, BigInteger arg5, BigInteger arg6, BigInteger arg7) {
        int v0 = (arg5.bitLength() + 7) / 8;
        byte[] v1 = SRP6Util.getPadded(arg6, v0);
        byte[] v0_1 = SRP6Util.getPadded(arg7, v0);
        arg4.update(v1, 0, v1.length);
        arg4.update(v0_1, 0, v0_1.length);
        v0_1 = new byte[arg4.getDigestSize()];
        arg4.doFinal(v0_1, 0);
        return new BigInteger(1, v0_1);
    }

    public static BigInteger validatePublicValue(BigInteger arg2, BigInteger arg3) {
        BigInteger v0 = arg3.mod(arg2);
        if(v0.equals(SRP6Util.ZERO)) {
            throw new CryptoException("Invalid public value: 0");
        }

        return v0;
    }
}

