// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.commitments;

import java.security.SecureRandom;
import org.bouncycastle.crypto.Commitment;
import org.bouncycastle.crypto.Committer;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.util.Arrays;

public class HashCommitter implements Committer {
    private final int byteLength;
    private final Digest digest;
    private final SecureRandom random;

    public HashCommitter(ExtendedDigest arg2, SecureRandom arg3) {
        super();
        this.digest = ((Digest)arg2);
        this.byteLength = arg2.getByteLength();
        this.random = arg3;
    }

    private byte[] calculateCommitment(byte[] arg5, byte[] arg6) {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.update(arg5, 0, arg5.length);
        this.digest.update(arg6, 0, arg6.length);
        this.digest.doFinal(v0, 0);
        return v0;
    }

    public Commitment commit(byte[] arg4) {
        if(arg4.length > this.byteLength / 2) {
            throw new DataLengthException("Message to be committed to too large for digest.");
        }

        byte[] v0 = new byte[this.byteLength - arg4.length];
        this.random.nextBytes(v0);
        return new Commitment(v0, this.calculateCommitment(v0, arg4));
    }

    public boolean isRevealed(Commitment arg3, byte[] arg4) {
        return Arrays.constantTimeAreEqual(arg3.getCommitment(), this.calculateCommitment(arg3.getSecret(), arg4));
    }
}

