// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.crypto.engines.GOST28147Engine;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithSBox;
import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Memoable;

public class GOST3411Digest implements ExtendedDigest, Memoable {
    private byte[][] C;
    private static final byte[] C2 = null;
    private static final int DIGEST_LENGTH = 32;
    private byte[] H;
    private byte[] K;
    private byte[] L;
    private byte[] M;
    byte[] S;
    private byte[] Sum;
    byte[] U;
    byte[] V;
    byte[] W;
    byte[] a;
    private long byteCount;
    private BlockCipher cipher;
    private byte[] sBox;
    short[] wS;
    short[] w_S;
    private byte[] xBuf;
    private int xBufOff;

    static {
        GOST3411Digest.C2 = new byte[]{0, -1, 0, -1, 0, -1, 0, -1, -1, 0, -1, 0, -1, 0, -1, 0, 0, -1, -1, 0, -1, 0, 0, -1, -1, 0, 0, 0, -1, -1, 0, -1};
    }

    public GOST3411Digest() {
        super();
        this.H = new byte[32];
        this.L = new byte[32];
        this.M = new byte[32];
        this.Sum = new byte[32];
        this.C = new byte[4][32];
        this.xBuf = new byte[32];
        this.cipher = new GOST28147Engine();
        this.K = new byte[32];
        this.a = new byte[8];
        this.wS = new short[16];
        this.w_S = new short[16];
        this.S = new byte[32];
        this.U = new byte[32];
        this.V = new byte[32];
        this.W = new byte[32];
        this.sBox = GOST28147Engine.getSBox("D-A");
        this.cipher.init(true, new ParametersWithSBox(null, this.sBox));
        this.reset();
    }

    public GOST3411Digest(GOST3411Digest arg5) {
        super();
        this.H = new byte[32];
        this.L = new byte[32];
        this.M = new byte[32];
        this.Sum = new byte[32];
        this.C = new byte[4][32];
        this.xBuf = new byte[32];
        this.cipher = new GOST28147Engine();
        this.K = new byte[32];
        this.a = new byte[8];
        this.wS = new short[16];
        this.w_S = new short[16];
        this.S = new byte[32];
        this.U = new byte[32];
        this.V = new byte[32];
        this.W = new byte[32];
        this.reset(((Memoable)arg5));
    }

    public GOST3411Digest(byte[] arg6) {
        super();
        this.H = new byte[32];
        this.L = new byte[32];
        this.M = new byte[32];
        this.Sum = new byte[32];
        this.C = new byte[4][32];
        this.xBuf = new byte[32];
        this.cipher = new GOST28147Engine();
        this.K = new byte[32];
        this.a = new byte[8];
        this.wS = new short[16];
        this.w_S = new short[16];
        this.S = new byte[32];
        this.U = new byte[32];
        this.V = new byte[32];
        this.W = new byte[32];
        this.sBox = Arrays.clone(arg6);
        this.cipher.init(true, new ParametersWithSBox(null, this.sBox));
        this.reset();
    }

    private byte[] A(byte[] arg8) {
        int v6 = 24;
        int v5 = 8;
        int v0;
        for(v0 = 0; v0 < v5; ++v0) {
            this.a[v0] = ((byte)(arg8[v0] ^ arg8[v0 + 8]));
        }

        System.arraycopy(arg8, v5, arg8, 0, v6);
        System.arraycopy(this.a, 0, arg8, v6, v5);
        return arg8;
    }

    private void E(byte[] arg4, byte[] arg5, int arg6, byte[] arg7, int arg8) {
        this.cipher.init(true, new KeyParameter(arg4));
        this.cipher.processBlock(arg7, arg8, arg5, arg6);
    }

    private byte[] P(byte[] arg5) {
        int v0;
        for(v0 = 0; v0 < 8; ++v0) {
            this.K[v0 * 4] = arg5[v0];
            this.K[v0 * 4 + 1] = arg5[v0 + 8];
            this.K[v0 * 4 + 2] = arg5[v0 + 16];
            this.K[v0 * 4 + 3] = arg5[v0 + 24];
        }

        return this.K;
    }

    public Memoable copy() {
        return new GOST3411Digest(this);
    }

    private void cpyBytesToShort(byte[] arg4, short[] arg5) {
        int v0;
        for(v0 = 0; v0 < arg4.length / 2; ++v0) {
            arg5[v0] = ((short)(arg4[v0 * 2 + 1] << 8 & 65280 | arg4[v0 * 2] & 255));
        }
    }

    private void cpyShortToBytes(short[] arg4, byte[] arg5) {
        int v0;
        for(v0 = 0; v0 < arg5.length / 2; ++v0) {
            arg5[v0 * 2 + 1] = ((byte)(arg4[v0] >> 8));
            arg5[v0 * 2] = ((byte)arg4[v0]);
        }
    }

    public int doFinal(byte[] arg4, int arg5) {
        this.finish();
        System.arraycopy(this.H, 0, arg4, arg5, this.H.length);
        this.reset();
        return 32;
    }

    private void finish() {
        Pack.longToLittleEndian(this.byteCount * 8, this.L, 0);
        while(this.xBufOff != 0) {
            this.update(0);
        }

        this.processBlock(this.L, 0);
        this.processBlock(this.Sum, 0);
    }

    private void fw(byte[] arg8) {
        this.cpyBytesToShort(arg8, this.wS);
        this.w_S[15] = ((short)(this.wS[0] ^ this.wS[1] ^ this.wS[2] ^ this.wS[3] ^ this.wS[12] ^ this.wS[15]));
        System.arraycopy(this.wS, 1, this.w_S, 0, 15);
        this.cpyShortToBytes(this.w_S, arg8);
    }

    public String getAlgorithmName() {
        return "GOST3411";
    }

    public int getByteLength() {
        return 32;
    }

    public int getDigestSize() {
        return 32;
    }

    protected void processBlock(byte[] arg12, int arg13) {
        int v10 = 32;
        System.arraycopy(arg12, arg13, this.M, 0, v10);
        System.arraycopy(this.H, 0, this.U, 0, v10);
        System.arraycopy(this.M, 0, this.V, 0, v10);
        int v0;
        for(v0 = 0; v0 < v10; ++v0) {
            this.W[v0] = ((byte)(this.U[v0] ^ this.V[v0]));
        }

        this.E(this.P(this.W), this.S, 0, this.H, 0);
        int v1;
        for(v1 = 1; v1 < 4; ++v1) {
            byte[] v2 = this.A(this.U);
            for(v0 = 0; v0 < v10; ++v0) {
                this.U[v0] = ((byte)(v2[v0] ^ this.C[v1][v0]));
            }

            this.V = this.A(this.A(this.V));
            for(v0 = 0; v0 < v10; ++v0) {
                this.W[v0] = ((byte)(this.U[v0] ^ this.V[v0]));
            }

            this.E(this.P(this.W), this.S, v1 * 8, this.H, v1 * 8);
        }

        for(v0 = 0; v0 < 12; ++v0) {
            this.fw(this.S);
        }

        for(v0 = 0; v0 < v10; ++v0) {
            this.S[v0] = ((byte)(this.S[v0] ^ this.M[v0]));
        }

        this.fw(this.S);
        for(v0 = 0; v0 < v10; ++v0) {
            this.S[v0] = ((byte)(this.H[v0] ^ this.S[v0]));
        }

        for(v0 = 0; v0 < 61; ++v0) {
            this.fw(this.S);
        }

        System.arraycopy(this.S, 0, this.H, 0, this.H.length);
    }

    public void reset() {
        int v5 = 3;
        this.byteCount = 0;
        this.xBufOff = 0;
        int v0;
        for(v0 = 0; v0 < this.H.length; ++v0) {
            this.H[v0] = 0;
        }

        for(v0 = 0; v0 < this.L.length; ++v0) {
            this.L[v0] = 0;
        }

        for(v0 = 0; v0 < this.M.length; ++v0) {
            this.M[v0] = 0;
        }

        for(v0 = 0; v0 < this.C[1].length; ++v0) {
            this.C[1][v0] = 0;
        }

        for(v0 = 0; v0 < this.C[v5].length; ++v0) {
            this.C[v5][v0] = 0;
        }

        for(v0 = 0; v0 < this.Sum.length; ++v0) {
            this.Sum[v0] = 0;
        }

        for(v0 = 0; v0 < this.xBuf.length; ++v0) {
            this.xBuf[v0] = 0;
        }

        System.arraycopy(GOST3411Digest.C2, 0, this.C[2], 0, GOST3411Digest.C2.length);
    }

    public void reset(Memoable arg9) {
        this.sBox = ((GOST3411Digest)arg9).sBox;
        this.cipher.init(true, new ParametersWithSBox(null, this.sBox));
        this.reset();
        System.arraycopy(((GOST3411Digest)arg9).H, 0, this.H, 0, ((GOST3411Digest)arg9).H.length);
        System.arraycopy(((GOST3411Digest)arg9).L, 0, this.L, 0, ((GOST3411Digest)arg9).L.length);
        System.arraycopy(((GOST3411Digest)arg9).M, 0, this.M, 0, ((GOST3411Digest)arg9).M.length);
        System.arraycopy(((GOST3411Digest)arg9).Sum, 0, this.Sum, 0, ((GOST3411Digest)arg9).Sum.length);
        System.arraycopy(((GOST3411Digest)arg9).C[1], 0, this.C[1], 0, ((GOST3411Digest)arg9).C[1].length);
        System.arraycopy(((GOST3411Digest)arg9).C[2], 0, this.C[2], 0, ((GOST3411Digest)arg9).C[2].length);
        System.arraycopy(((GOST3411Digest)arg9).C[3], 0, this.C[3], 0, ((GOST3411Digest)arg9).C[3].length);
        System.arraycopy(((GOST3411Digest)arg9).xBuf, 0, this.xBuf, 0, ((GOST3411Digest)arg9).xBuf.length);
        this.xBufOff = ((GOST3411Digest)arg9).xBufOff;
        this.byteCount = ((GOST3411Digest)arg9).byteCount;
    }

    private void sumByteArray(byte[] arg5) {
        int v0 = 0;
        int v1 = 0;
        while(v0 != this.Sum.length) {
            v1 += (this.Sum[v0] & 255) + (arg5[v0] & 255);
            this.Sum[v0] = ((byte)v1);
            v1 >>>= 8;
            ++v0;
        }
    }

    public void update(byte arg5) {
        byte[] v0 = this.xBuf;
        int v1 = this.xBufOff;
        this.xBufOff = v1 + 1;
        v0[v1] = arg5;
        if(this.xBufOff == this.xBuf.length) {
            this.sumByteArray(this.xBuf);
            this.processBlock(this.xBuf, 0);
            this.xBufOff = 0;
        }

        ++this.byteCount;
    }

    public void update(byte[] arg6, int arg7, int arg8) {
        while(this.xBufOff != 0) {
            if(arg8 <= 0) {
                break;
            }

            this.update(arg6[arg7]);
            ++arg7;
            --arg8;
        }

        while(arg8 > this.xBuf.length) {
            System.arraycopy(arg6, arg7, this.xBuf, 0, this.xBuf.length);
            this.sumByteArray(this.xBuf);
            this.processBlock(this.xBuf, 0);
            arg7 += this.xBuf.length;
            arg8 -= this.xBuf.length;
            this.byteCount += ((long)this.xBuf.length);
        }

        while(arg8 > 0) {
            this.update(arg6[arg7]);
            ++arg7;
            --arg8;
        }
    }
}

