// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.util.Memoable;

public abstract class GeneralDigest implements ExtendedDigest, Memoable {
    private static final int BYTE_LENGTH = 64;
    private long byteCount;
    private byte[] xBuf;
    private int xBufOff;

    protected GeneralDigest() {
        super();
        this.xBuf = new byte[4];
        this.xBufOff = 0;
    }

    protected GeneralDigest(GeneralDigest arg2) {
        super();
        this.xBuf = new byte[arg2.xBuf.length];
        this.copyIn(arg2);
    }

    protected void copyIn(GeneralDigest arg5) {
        System.arraycopy(arg5.xBuf, 0, this.xBuf, 0, arg5.xBuf.length);
        this.xBufOff = arg5.xBufOff;
        this.byteCount = arg5.byteCount;
    }

    public void finish() {
        long v0 = this.byteCount << 3;
        this.update(-128);
        while(this.xBufOff != 0) {
            this.update(0);
        }

        this.processLength(v0);
        this.processBlock();
    }

    public int getByteLength() {
        return 64;
    }

    protected abstract void processBlock();

    protected abstract void processLength(long arg1);

    protected abstract void processWord(byte[] arg1, int arg2);

    public void reset() {
        this.byteCount = 0;
        this.xBufOff = 0;
        int v0;
        for(v0 = 0; v0 < this.xBuf.length; ++v0) {
            this.xBuf[v0] = 0;
        }
    }

    public void update(byte arg5) {
        byte[] v0 = this.xBuf;
        int v1 = this.xBufOff;
        this.xBufOff = v1 + 1;
        v0[v1] = arg5;
        if(this.xBufOff == this.xBuf.length) {
            this.processWord(this.xBuf, 0);
            this.xBufOff = 0;
        }

        ++this.byteCount;
    }

    public void update(byte[] arg5, int arg6, int arg7) {
        while(this.xBufOff != 0) {
            if(arg7 <= 0) {
                break;
            }

            this.update(arg5[arg6]);
            ++arg6;
            --arg7;
        }

        while(arg7 > this.xBuf.length) {
            this.processWord(arg5, arg6);
            arg6 += this.xBuf.length;
            arg7 -= this.xBuf.length;
            this.byteCount += ((long)this.xBuf.length);
        }

        while(arg7 > 0) {
            this.update(arg5[arg6]);
            ++arg6;
            --arg7;
        }
    }
}

