// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.util.Memoable;

public class MD2Digest implements ExtendedDigest, Memoable {
    private byte[] C;
    private int COff;
    private static final int DIGEST_LENGTH = 16;
    private byte[] M;
    private static final byte[] S;
    private byte[] X;
    private int mOff;
    private int xOff;

    static {
        MD2Digest.S = new byte[]{41, 46, 67, -55, -94, -40, 124, 1, 61, 54, 84, -95, -20, -16, 6, 19, 98, -89, 5, -13, -64, -57, 115, -116, -104, -109, 43, -39, -68, 76, -126, -54, 30, -101, 87, 60, -3, -44, -32, 22, 103, 66, 111, 24, -118, 23, -27, 18, -66, 78, -60, -42, -38, -98, -34, 73, -96, -5, -11, -114, -69, 47, -18, 122, -87, 104, 121, -111, 21, -78, 7, 63, -108, -62, 16, -119, 11, 34, 95, 33, -128, 127, 93, -102, 90, -112, 50, 39, 53, 62, -52, -25, -65, -9, -105, 3, -1, 25, 48, -77, 72, -91, -75, -47, -41, 94, -110, 42, -84, 86, -86, -58, 79, -72, 56, -46, -106, -92, 125, -74, 118, -4, 107, -30, -100, 116, 4, -15, 69, -99, 112, 89, 100, 113, -121, 32, -122, 91, -49, 101, -26, 45, -88, 2, 27, 96, 37, -83, -82, -80, -71, -10, 28, 70, 97, 105, 52, 64, 126, 15, 85, 71, -93, 35, -35, 81, -81, 58, -61, 92, -7, -50, -70, -59, -22, 38, 44, 83, 13, 110, -123, 40, -124, 9, -45, -33, -51, -12, 65, -127, 77, 82, 106, -36, 55, -56, 108, -63, -85, -6, 36, -31, 123, 8, 12, -67, -79, 74, 120, -120, -107, -117, -29, 99, -24, 109, -23, -53, -43, -2, 59, 0, 29, 57, -14, -17, -73, 14, 102, 88, -48, -28, -90, 119, 114, -8, -21, 117, 75, 10, 49, 68, 80, -76, -113, -19, 31, 26, -37, -103, -115, 51, -97, 17, -125, 20};
    }

    public MD2Digest() {
        super();
        this.X = new byte[48];
        this.M = new byte[16];
        this.C = new byte[16];
        this.reset();
    }

    public MD2Digest(MD2Digest arg3) {
        super();
        this.X = new byte[48];
        this.M = new byte[16];
        this.C = new byte[16];
        this.copyIn(arg3);
    }

    public Memoable copy() {
        return new MD2Digest(this);
    }

    private void copyIn(MD2Digest arg5) {
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
        System.arraycopy(arg5.M, 0, this.M, 0, arg5.M.length);
        this.mOff = arg5.mOff;
        System.arraycopy(arg5.C, 0, this.C, 0, arg5.C.length);
        this.COff = arg5.COff;
    }

    public int doFinal(byte[] arg5, int arg6) {
        int v3 = 16;
        byte v1 = ((byte)(this.M.length - this.mOff));
        int v0;
        for(v0 = this.mOff; v0 < this.M.length; ++v0) {
            this.M[v0] = v1;
        }

        this.processCheckSum(this.M);
        this.processBlock(this.M);
        this.processBlock(this.C);
        System.arraycopy(this.X, this.xOff, arg5, arg6, v3);
        this.reset();
        return v3;
    }

    public String getAlgorithmName() {
        return "MD2";
    }

    public int getByteLength() {
        return 16;
    }

    public int getDigestSize() {
        return 16;
    }

    protected void processBlock(byte[] arg8) {
        int v0;
        for(v0 = 0; v0 < 16; ++v0) {
            this.X[v0 + 16] = arg8[v0];
            this.X[v0 + 32] = ((byte)(arg8[v0] ^ this.X[v0]));
        }

        int v3 = 0;
        for(v0 = 0; v3 < 18; v0 = v2) {
            int v2 = v0;
            for(v0 = 0; v0 < 48; ++v0) {
                byte[] v4 = this.X;
                byte v2_1 = ((byte)(MD2Digest.S[v2] ^ v4[v0]));
                v4[v0] = v2_1;
                v2 = v2_1 & 255;
            }

            v2 = (v2 + v3) % 256;
            ++v3;
        }
    }

    protected void processCheckSum(byte[] arg7) {
        int v1 = this.C[15];
        int v0;
        for(v0 = 0; v0 < 16; ++v0) {
            this.C[v0] = ((byte)(MD2Digest.S[(v1 ^ arg7[v0]) & 255] ^ this.C[v0]));
            v1 = this.C[v0];
        }
    }

    public void reset() {
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }

        this.mOff = 0;
        for(v0 = 0; v0 != this.M.length; ++v0) {
            this.M[v0] = 0;
        }

        this.COff = 0;
        for(v0 = 0; v0 != this.C.length; ++v0) {
            this.C[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        this.copyIn(((MD2Digest)arg1));
    }

    public void update(byte arg4) {
        byte[] v0 = this.M;
        int v1 = this.mOff;
        this.mOff = v1 + 1;
        v0[v1] = arg4;
        if(this.mOff == 16) {
            this.processCheckSum(this.M);
            this.processBlock(this.M);
            this.mOff = 0;
        }
    }

    public void update(byte[] arg6, int arg7, int arg8) {
        int v4 = 16;
        while(this.mOff != 0) {
            if(arg8 <= 0) {
                break;
            }

            this.update(arg6[arg7]);
            ++arg7;
            --arg8;
        }

        int v0 = arg8;
        int v1;
        for(v1 = arg7; v0 > v4; v1 += 16) {
            System.arraycopy(arg6, v1, this.M, 0, v4);
            this.processCheckSum(this.M);
            this.processBlock(this.M);
            v0 += -16;
        }

        while(v0 > 0) {
            this.update(arg6[v1]);
            ++v1;
            --v0;
        }
    }
}

