// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.util.Memoable;

public class MD4Digest extends GeneralDigest {
    private static final int DIGEST_LENGTH = 16;
    private int H1;
    private int H2;
    private int H3;
    private int H4;
    private static final int S11 = 3;
    private static final int S12 = 7;
    private static final int S13 = 11;
    private static final int S14 = 19;
    private static final int S21 = 3;
    private static final int S22 = 5;
    private static final int S23 = 9;
    private static final int S24 = 13;
    private static final int S31 = 3;
    private static final int S32 = 9;
    private static final int S33 = 11;
    private static final int S34 = 15;
    private int[] X;
    private int xOff;

    public MD4Digest() {
        super();
        this.X = new int[16];
        this.reset();
    }

    public MD4Digest(MD4Digest arg2) {
        super(((GeneralDigest)arg2));
        this.X = new int[16];
        this.copyIn(arg2);
    }

    private int F(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | (arg3 ^ -1) & arg5;
    }

    private int G(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | arg3 & arg5 | arg4 & arg5;
    }

    private int H(int arg2, int arg3, int arg4) {
        return arg2 ^ arg3 ^ arg4;
    }

    public Memoable copy() {
        return new MD4Digest(this);
    }

    private void copyIn(MD4Digest arg5) {
        super.copyIn(((GeneralDigest)arg5));
        this.H1 = arg5.H1;
        this.H2 = arg5.H2;
        this.H3 = arg5.H3;
        this.H4 = arg5.H4;
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.finish();
        this.unpackWord(this.H1, arg3, arg4);
        this.unpackWord(this.H2, arg3, arg4 + 4);
        this.unpackWord(this.H3, arg3, arg4 + 8);
        this.unpackWord(this.H4, arg3, arg4 + 12);
        this.reset();
        return 16;
    }

    public String getAlgorithmName() {
        return "MD4";
    }

    public int getDigestSize() {
        return 16;
    }

    protected void processBlock() {
        int v0 = this.H1;
        int v1 = this.H2;
        int v2 = this.H3;
        int v3 = this.H4;
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[0], 3);
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[1], 7);
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[2], 11);
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[3], 19);
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[4], 3);
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[5], 7);
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[6], 11);
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[7], 19);
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[8], 3);
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[9], 7);
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[10], 11);
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[11], 19);
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[12], 3);
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[13], 7);
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[14], 11);
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[15], 19);
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[0] + 1518500249, 3);
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[4] + 1518500249, 5);
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[8] + 1518500249, 9);
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[12] + 1518500249, 13);
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[1] + 1518500249, 3);
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[5] + 1518500249, 5);
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[9] + 1518500249, 9);
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[13] + 1518500249, 13);
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[2] + 1518500249, 3);
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[6] + 1518500249, 5);
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[10] + 1518500249, 9);
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[14] + 1518500249, 13);
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[3] + 1518500249, 3);
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[7] + 1518500249, 5);
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[11] + 1518500249, 9);
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[15] + 1518500249, 13);
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[0] + 1859775393, 3);
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[8] + 1859775393, 9);
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[4] + 1859775393, 11);
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[12] + 1859775393, 15);
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[2] + 1859775393, 3);
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[10] + 1859775393, 9);
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[6] + 1859775393, 11);
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[14] + 1859775393, 15);
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[1] + 1859775393, 3);
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[9] + 1859775393, 9);
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[5] + 1859775393, 11);
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[13] + 1859775393, 15);
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[3] + 1859775393, 3);
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[11] + 1859775393, 9);
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[7] + 1859775393, 11);
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[15] + 1859775393, 15);
        this.H1 = v0 + this.H1;
        this.H2 += v1;
        this.H3 += v2;
        this.H4 += v3;
        this.xOff = 0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    protected void processLength(long arg5) {
        int v3 = 14;
        if(this.xOff > v3) {
            this.processBlock();
        }

        this.X[v3] = ((int)(-1 & arg5));
        this.X[15] = ((int)(arg5 >>> 32));
    }

    protected void processWord(byte[] arg5, int arg6) {
        int[] v0 = this.X;
        int v1 = this.xOff;
        this.xOff = v1 + 1;
        v0[v1] = arg5[arg6] & 255 | (arg5[arg6 + 1] & 255) << 8 | (arg5[arg6 + 2] & 255) << 16 | (arg5[arg6 + 3] & 255) << 24;
        if(this.xOff == 16) {
            this.processBlock();
        }
    }

    public void reset() {
        super.reset();
        this.H1 = 1732584193;
        this.H2 = -271733879;
        this.H3 = -1732584194;
        this.H4 = 271733878;
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        this.copyIn(((MD4Digest)arg1));
    }

    private int rotateLeft(int arg3, int arg4) {
        return arg3 << arg4 | arg3 >>> 32 - arg4;
    }

    private void unpackWord(int arg3, byte[] arg4, int arg5) {
        arg4[arg5] = ((byte)arg3);
        arg4[arg5 + 1] = ((byte)(arg3 >>> 8));
        arg4[arg5 + 2] = ((byte)(arg3 >>> 16));
        arg4[arg5 + 3] = ((byte)(arg3 >>> 24));
    }
}

