// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.util.Memoable;

public class MD5Digest extends GeneralDigest {
    private static final int DIGEST_LENGTH = 16;
    private int H1;
    private int H2;
    private int H3;
    private int H4;
    private static final int S11 = 7;
    private static final int S12 = 12;
    private static final int S13 = 17;
    private static final int S14 = 22;
    private static final int S21 = 5;
    private static final int S22 = 9;
    private static final int S23 = 14;
    private static final int S24 = 20;
    private static final int S31 = 4;
    private static final int S32 = 11;
    private static final int S33 = 16;
    private static final int S34 = 23;
    private static final int S41 = 6;
    private static final int S42 = 10;
    private static final int S43 = 15;
    private static final int S44 = 21;
    private int[] X;
    private int xOff;

    public MD5Digest() {
        super();
        this.X = new int[16];
        this.reset();
    }

    public MD5Digest(MD5Digest arg2) {
        super(((GeneralDigest)arg2));
        this.X = new int[16];
        this.copyIn(arg2);
    }

    private int F(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | (arg3 ^ -1) & arg5;
    }

    private int G(int arg3, int arg4, int arg5) {
        return arg3 & arg5 | (arg5 ^ -1) & arg4;
    }

    private int H(int arg2, int arg3, int arg4) {
        return arg2 ^ arg3 ^ arg4;
    }

    private int K(int arg2, int arg3, int arg4) {
        return (arg4 ^ -1 | arg2) ^ arg3;
    }

    public Memoable copy() {
        return new MD5Digest(this);
    }

    private void copyIn(MD5Digest arg5) {
        super.copyIn(((GeneralDigest)arg5));
        this.H1 = arg5.H1;
        this.H2 = arg5.H2;
        this.H3 = arg5.H3;
        this.H4 = arg5.H4;
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.finish();
        this.unpackWord(this.H1, arg3, arg4);
        this.unpackWord(this.H2, arg3, arg4 + 4);
        this.unpackWord(this.H3, arg3, arg4 + 8);
        this.unpackWord(this.H4, arg3, arg4 + 12);
        this.reset();
        return 16;
    }

    public String getAlgorithmName() {
        return "MD5";
    }

    public int getDigestSize() {
        return 16;
    }

    protected void processBlock() {
        int v0 = this.H1;
        int v1 = this.H2;
        int v2 = this.H3;
        int v3 = this.H4;
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[0] - 680876936, 7) + v1;
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[1] - 389564586, 12) + v0;
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[2] + 606105819, 17) + v3;
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[3] - 1044525330, 22) + v2;
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[4] - 176418897, 7) + v1;
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[5] + 1200080426, 12) + v0;
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[6] - 1473231341, 17) + v3;
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[7] - 45705983, 22) + v2;
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[8] + 1770035416, 7) + v1;
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[9] - 1958414417, 12) + v0;
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[10] - 42063, 17) + v3;
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[11] - 1990404162, 22) + v2;
        v0 = this.rotateLeft(v0 + this.F(v1, v2, v3) + this.X[12] + 1804603682, 7) + v1;
        v3 = this.rotateLeft(v3 + this.F(v0, v1, v2) + this.X[13] - 40341101, 12) + v0;
        v2 = this.rotateLeft(v2 + this.F(v3, v0, v1) + this.X[14] - 1502002290, 17) + v3;
        v1 = this.rotateLeft(v1 + this.F(v2, v3, v0) + this.X[15] + 1236535329, 22) + v2;
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[1] - 165796510, 5) + v1;
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[6] - 1069501632, 9) + v0;
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[11] + 643717713, 14) + v3;
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[0] - 373897302, 20) + v2;
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[5] - 701558691, 5) + v1;
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[10] + 38016083, 9) + v0;
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[15] - 660478335, 14) + v3;
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[4] - 405537848, 20) + v2;
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[9] + 568446438, 5) + v1;
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[14] - 1019803690, 9) + v0;
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[3] - 187363961, 14) + v3;
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[8] + 1163531501, 20) + v2;
        v0 = this.rotateLeft(v0 + this.G(v1, v2, v3) + this.X[13] - 1444681467, 5) + v1;
        v3 = this.rotateLeft(v3 + this.G(v0, v1, v2) + this.X[2] - 51403784, 9) + v0;
        v2 = this.rotateLeft(v2 + this.G(v3, v0, v1) + this.X[7] + 1735328473, 14) + v3;
        v1 = this.rotateLeft(v1 + this.G(v2, v3, v0) + this.X[12] - 1926607734, 20) + v2;
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[5] - 378558, 4) + v1;
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[8] - 2022574463, 11) + v0;
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[11] + 1839030562, 16) + v3;
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[14] - 35309556, 23) + v2;
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[1] - 1530992060, 4) + v1;
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[4] + 1272893353, 11) + v0;
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[7] - 155497632, 16) + v3;
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[10] - 1094730640, 23) + v2;
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[13] + 681279174, 4) + v1;
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[0] - 358537222, 11) + v0;
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[3] - 722521979, 16) + v3;
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[6] + 76029189, 23) + v2;
        v0 = this.rotateLeft(v0 + this.H(v1, v2, v3) + this.X[9] - 640364487, 4) + v1;
        v3 = this.rotateLeft(v3 + this.H(v0, v1, v2) + this.X[12] - 421815835, 11) + v0;
        v2 = this.rotateLeft(v2 + this.H(v3, v0, v1) + this.X[15] + 530742520, 16) + v3;
        v1 = this.rotateLeft(v1 + this.H(v2, v3, v0) + this.X[2] - 995338651, 23) + v2;
        v0 = this.rotateLeft(v0 + this.K(v1, v2, v3) + this.X[0] - 198630844, 6) + v1;
        v3 = this.rotateLeft(v3 + this.K(v0, v1, v2) + this.X[7] + 1126891415, 10) + v0;
        v2 = this.rotateLeft(v2 + this.K(v3, v0, v1) + this.X[14] - 1416354905, 15) + v3;
        v1 = this.rotateLeft(v1 + this.K(v2, v3, v0) + this.X[5] - 57434055, 21) + v2;
        v0 = this.rotateLeft(v0 + this.K(v1, v2, v3) + this.X[12] + 1700485571, 6) + v1;
        v3 = this.rotateLeft(v3 + this.K(v0, v1, v2) + this.X[3] - 1894986606, 10) + v0;
        v2 = this.rotateLeft(v2 + this.K(v3, v0, v1) + this.X[10] - 1051523, 15) + v3;
        v1 = this.rotateLeft(v1 + this.K(v2, v3, v0) + this.X[1] - 2054922799, 21) + v2;
        v0 = this.rotateLeft(v0 + this.K(v1, v2, v3) + this.X[8] + 1873313359, 6) + v1;
        v3 = this.rotateLeft(v3 + this.K(v0, v1, v2) + this.X[15] - 30611744, 10) + v0;
        v2 = this.rotateLeft(v2 + this.K(v3, v0, v1) + this.X[6] - 1560198380, 15) + v3;
        v1 = this.rotateLeft(v1 + this.K(v2, v3, v0) + this.X[13] + 1309151649, 21) + v2;
        v0 = this.rotateLeft(v0 + this.K(v1, v2, v3) + this.X[4] - 145523070, 6) + v1;
        v3 = this.rotateLeft(v3 + this.K(v0, v1, v2) + this.X[11] - 1120210379, 10) + v0;
        v2 = this.rotateLeft(v2 + this.K(v3, v0, v1) + this.X[2] + 718787259, 15) + v3;
        v1 = this.rotateLeft(v1 + this.K(v2, v3, v0) + this.X[9] - 343485551, 21) + v2;
        this.H1 = v0 + this.H1;
        this.H2 += v1;
        this.H3 += v2;
        this.H4 += v3;
        this.xOff = 0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    protected void processLength(long arg5) {
        int v3 = 14;
        if(this.xOff > v3) {
            this.processBlock();
        }

        this.X[v3] = ((int)(-1 & arg5));
        this.X[15] = ((int)(arg5 >>> 32));
    }

    protected void processWord(byte[] arg5, int arg6) {
        int[] v0 = this.X;
        int v1 = this.xOff;
        this.xOff = v1 + 1;
        v0[v1] = arg5[arg6] & 255 | (arg5[arg6 + 1] & 255) << 8 | (arg5[arg6 + 2] & 255) << 16 | (arg5[arg6 + 3] & 255) << 24;
        if(this.xOff == 16) {
            this.processBlock();
        }
    }

    public void reset() {
        super.reset();
        this.H1 = 1732584193;
        this.H2 = -271733879;
        this.H3 = -1732584194;
        this.H4 = 271733878;
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        this.copyIn(((MD5Digest)arg1));
    }

    private int rotateLeft(int arg3, int arg4) {
        return arg3 << arg4 | arg3 >>> 32 - arg4;
    }

    private void unpackWord(int arg3, byte[] arg4, int arg5) {
        arg4[arg5] = ((byte)arg3);
        arg4[arg5 + 1] = ((byte)(arg3 >>> 8));
        arg4[arg5 + 2] = ((byte)(arg3 >>> 16));
        arg4[arg5 + 3] = ((byte)(arg3 >>> 24));
    }
}

