// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.util.Memoable;

public class RIPEMD128Digest extends GeneralDigest {
    private static final int DIGEST_LENGTH = 16;
    private int H0;
    private int H1;
    private int H2;
    private int H3;
    private int[] X;
    private int xOff;

    public RIPEMD128Digest() {
        super();
        this.X = new int[16];
        this.reset();
    }

    public RIPEMD128Digest(RIPEMD128Digest arg2) {
        super(((GeneralDigest)arg2));
        this.X = new int[16];
        this.copyIn(arg2);
    }

    private int F1(int arg2, int arg3, int arg4, int arg5, int arg6, int arg7) {
        return this.RL(this.f1(arg3, arg4, arg5) + arg2 + arg6, arg7);
    }

    private int F2(int arg3, int arg4, int arg5, int arg6, int arg7, int arg8) {
        return this.RL(this.f2(arg4, arg5, arg6) + arg3 + arg7 + 1518500249, arg8);
    }

    private int F3(int arg3, int arg4, int arg5, int arg6, int arg7, int arg8) {
        return this.RL(this.f3(arg4, arg5, arg6) + arg3 + arg7 + 1859775393, arg8);
    }

    private int F4(int arg3, int arg4, int arg5, int arg6, int arg7, int arg8) {
        return this.RL(this.f4(arg4, arg5, arg6) + arg3 + arg7 - 1894007588, arg8);
    }

    private int FF1(int arg2, int arg3, int arg4, int arg5, int arg6, int arg7) {
        return this.RL(this.f1(arg3, arg4, arg5) + arg2 + arg6, arg7);
    }

    private int FF2(int arg3, int arg4, int arg5, int arg6, int arg7, int arg8) {
        return this.RL(this.f2(arg4, arg5, arg6) + arg3 + arg7 + 1836072691, arg8);
    }

    private int FF3(int arg3, int arg4, int arg5, int arg6, int arg7, int arg8) {
        return this.RL(this.f3(arg4, arg5, arg6) + arg3 + arg7 + 1548603684, arg8);
    }

    private int FF4(int arg3, int arg4, int arg5, int arg6, int arg7, int arg8) {
        return this.RL(this.f4(arg4, arg5, arg6) + arg3 + arg7 + 1352829926, arg8);
    }

    private int RL(int arg3, int arg4) {
        return arg3 << arg4 | arg3 >>> 32 - arg4;
    }

    public Memoable copy() {
        return new RIPEMD128Digest(this);
    }

    private void copyIn(RIPEMD128Digest arg5) {
        super.copyIn(((GeneralDigest)arg5));
        this.H0 = arg5.H0;
        this.H1 = arg5.H1;
        this.H2 = arg5.H2;
        this.H3 = arg5.H3;
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.finish();
        this.unpackWord(this.H0, arg3, arg4);
        this.unpackWord(this.H1, arg3, arg4 + 4);
        this.unpackWord(this.H2, arg3, arg4 + 8);
        this.unpackWord(this.H3, arg3, arg4 + 12);
        this.reset();
        return 16;
    }

    private int f1(int arg2, int arg3, int arg4) {
        return arg2 ^ arg3 ^ arg4;
    }

    private int f2(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | (arg3 ^ -1) & arg5;
    }

    private int f3(int arg2, int arg3, int arg4) {
        return (arg3 ^ -1 | arg2) ^ arg4;
    }

    private int f4(int arg3, int arg4, int arg5) {
        return arg3 & arg5 | (arg5 ^ -1) & arg4;
    }

    public String getAlgorithmName() {
        return "RIPEMD128";
    }

    public int getDigestSize() {
        return 16;
    }

    protected void processBlock() {
        int v2 = this.H0;
        int v3 = this.H1;
        int v4 = this.H2;
        int v5 = this.H3;
        int v8 = this.F1(v2, v3, v4, v5, this.X[0], 11);
        int v11 = this.F1(v5, v8, v3, v4, this.X[1], 14);
        int v14 = this.F1(v4, v11, v8, v3, this.X[2], 15);
        int v9 = this.F1(v3, v14, v11, v8, this.X[3], 12);
        int v12 = this.F1(v8, v9, v14, v11, this.X[4], 5);
        int v15 = this.F1(v11, v12, v9, v14, this.X[5], 8);
        int v10 = this.F1(v14, v15, v12, v9, this.X[6], 7);
        int v13 = this.F1(v9, v10, v15, v12, this.X[7], 9);
        int v16 = this.F1(v12, v13, v10, v15, this.X[8], 11);
        v11 = this.F1(v15, v16, v13, v10, this.X[9], 13);
        v14 = this.F1(v10, v11, v16, v13, this.X[10], 14);
        int v17 = this.F1(v13, v14, v11, v16, this.X[11], 15);
        v12 = this.F1(v16, v17, v14, v11, this.X[12], 6);
        v15 = this.F1(v11, v12, v17, v14, this.X[13], 7);
        int v18 = this.F1(v14, v15, v12, v17, this.X[14], 9);
        v13 = this.F1(v17, v18, v15, v12, this.X[15], 8);
        v16 = this.F2(v12, v13, v18, v15, this.X[7], 7);
        int v19 = this.F2(v15, v16, v13, v18, this.X[4], 6);
        v14 = this.F2(v18, v19, v16, v13, this.X[13], 8);
        v17 = this.F2(v13, v14, v19, v16, this.X[1], 13);
        int v20 = this.F2(v16, v17, v14, v19, this.X[10], 11);
        v15 = this.F2(v19, v20, v17, v14, this.X[6], 9);
        v18 = this.F2(v14, v15, v20, v17, this.X[15], 7);
        int v21 = this.F2(v17, v18, v15, v20, this.X[3], 15);
        v16 = this.F2(v20, v21, v18, v15, this.X[12], 7);
        v19 = this.F2(v15, v16, v21, v18, this.X[0], 12);
        int v22 = this.F2(v18, v19, v16, v21, this.X[9], 15);
        v17 = this.F2(v21, v22, v19, v16, this.X[5], 9);
        v20 = this.F2(v16, v17, v22, v19, this.X[2], 11);
        int v23 = this.F2(v19, v20, v17, v22, this.X[14], 7);
        v18 = this.F2(v22, v23, v20, v17, this.X[11], 13);
        v21 = this.F2(v17, v18, v23, v20, this.X[8], 12);
        int v24 = this.F3(v20, v21, v18, v23, this.X[3], 11);
        v19 = this.F3(v23, v24, v21, v18, this.X[10], 13);
        v22 = this.F3(v18, v19, v24, v21, this.X[14], 6);
        int v25 = this.F3(v21, v22, v19, v24, this.X[4], 7);
        v20 = this.F3(v24, v25, v22, v19, this.X[9], 14);
        v23 = this.F3(v19, v20, v25, v22, this.X[15], 9);
        int v26 = this.F3(v22, v23, v20, v25, this.X[8], 13);
        v21 = this.F3(v25, v26, v23, v20, this.X[1], 15);
        v24 = this.F3(v20, v21, v26, v23, this.X[2], 14);
        int v27 = this.F3(v23, v24, v21, v26, this.X[7], 8);
        v22 = this.F3(v26, v27, v24, v21, this.X[0], 13);
        v25 = this.F3(v21, v22, v27, v24, this.X[6], 6);
        int v28 = this.F3(v24, v25, v22, v27, this.X[13], 5);
        v23 = this.F3(v27, v28, v25, v22, this.X[11], 12);
        v26 = this.F3(v22, v23, v28, v25, this.X[5], 7);
        int v29 = this.F3(v25, v26, v23, v28, this.X[12], 5);
        v24 = this.F4(v28, v29, v26, v23, this.X[1], 11);
        v27 = this.F4(v23, v24, v29, v26, this.X[9], 12);
        int v30 = this.F4(v26, v27, v24, v29, this.X[11], 14);
        v25 = this.F4(v29, v30, v27, v24, this.X[10], 15);
        v28 = this.F4(v24, v25, v30, v27, this.X[0], 14);
        int v31 = this.F4(v27, v28, v25, v30, this.X[8], 15);
        v26 = this.F4(v30, v31, v28, v25, this.X[12], 9);
        v29 = this.F4(v25, v26, v31, v28, this.X[4], 8);
        int v32 = this.F4(v28, v29, v26, v31, this.X[13], 9);
        v27 = this.F4(v31, v32, v29, v26, this.X[3], 14);
        v30 = this.F4(v26, v27, v32, v29, this.X[7], 5);
        int v33 = this.F4(v29, v30, v27, v32, this.X[15], 6);
        v28 = this.F4(v32, v33, v30, v27, this.X[14], 8);
        v31 = this.F4(v27, v28, v33, v30, this.X[5], 6);
        int v34 = this.F4(v30, v31, v28, v33, this.X[6], 5);
        v29 = this.F4(v33, v34, v31, v28, this.X[2], 12);
        v8 = this.FF4(v2, v3, v4, v5, this.X[5], 8);
        int v7 = this.FF4(v5, v8, v3, v4, this.X[14], 9);
        int v6 = this.FF4(v4, v7, v8, v3, this.X[7], 9);
        v11 = this.FF4(v3, v6, v7, v8, this.X[0], 11);
        v10 = this.FF4(v8, v11, v6, v7, this.X[9], 13);
        v9 = this.FF4(v7, v10, v11, v6, this.X[2], 15);
        v3 = this.FF4(v6, v9, v10, v11, this.X[11], 15);
        v13 = this.FF4(v11, v3, v9, v10, this.X[4], 5);
        v12 = this.FF4(v10, v13, v3, v9, this.X[13], 7);
        v11 = this.FF4(v9, v12, v13, v3, this.X[6], 7);
        v3 = this.FF4(v3, v11, v12, v13, this.X[15], 8);
        v6 = this.FF4(v13, v3, v11, v12, this.X[8], 11);
        v12 = this.FF4(v12, v6, v3, v11, this.X[1], 14);
        v4 = this.FF4(v11, v12, v6, v3, this.X[10], 14);
        v7 = this.FF4(v3, v4, v12, v6, this.X[3], 12);
        v13 = this.FF4(v6, v7, v4, v12, this.X[12], 6);
        v5 = this.FF3(v12, v13, v7, v4, this.X[6], 9);
        v8 = this.FF3(v4, v5, v13, v7, this.X[11], 13);
        v14 = this.FF3(v7, v8, v5, v13, this.X[3], 15);
        v6 = this.FF3(v13, v14, v8, v5, this.X[7], 7);
        v9 = this.FF3(v5, v6, v14, v8, this.X[0], 12);
        v15 = this.FF3(v8, v9, v6, v14, this.X[13], 8);
        v7 = this.FF3(v14, v15, v9, v6, this.X[5], 9);
        v10 = this.FF3(v6, v7, v15, v9, this.X[10], 11);
        v16 = this.FF3(v9, v10, v7, v15, this.X[14], 7);
        v8 = this.FF3(v15, v16, v10, v7, this.X[15], 7);
        v11 = this.FF3(v7, v8, v16, v10, this.X[8], 12);
        v17 = this.FF3(v10, v11, v8, v16, this.X[12], 7);
        v9 = this.FF3(v16, v17, v11, v8, this.X[4], 6);
        v12 = this.FF3(v8, v9, v17, v11, this.X[9], 15);
        v18 = this.FF3(v11, v12, v9, v17, this.X[1], 13);
        v10 = this.FF3(v17, v18, v12, v9, this.X[2], 11);
        v13 = this.FF2(v9, v10, v18, v12, this.X[15], 9);
        v19 = this.FF2(v12, v13, v10, v18, this.X[5], 7);
        v11 = this.FF2(v18, v19, v13, v10, this.X[1], 15);
        v14 = this.FF2(v10, v11, v19, v13, this.X[3], 11);
        v20 = this.FF2(v13, v14, v11, v19, this.X[7], 8);
        v12 = this.FF2(v19, v20, v14, v11, this.X[14], 6);
        v15 = this.FF2(v11, v12, v20, v14, this.X[6], 6);
        v21 = this.FF2(v14, v15, v12, v20, this.X[9], 14);
        v13 = this.FF2(v20, v21, v15, v12, this.X[11], 12);
        v16 = this.FF2(v12, v13, v21, v15, this.X[8], 13);
        v22 = this.FF2(v15, v16, v13, v21, this.X[12], 5);
        v14 = this.FF2(v21, v22, v16, v13, this.X[2], 14);
        v17 = this.FF2(v13, v14, v22, v16, this.X[10], 13);
        v23 = this.FF2(v16, v17, v14, v22, this.X[0], 13);
        v15 = this.FF2(v22, v23, v17, v14, this.X[4], 7);
        v18 = this.FF2(v14, v15, v23, v17, this.X[13], 5);
        v13 = this.FF1(v17, v18, v15, v23, this.X[8], 15);
        v16 = this.FF1(v23, v13, v18, v15, this.X[6], 5);
        v19 = this.FF1(v15, v16, v13, v18, this.X[4], 8);
        v14 = this.FF1(v18, v19, v16, v13, this.X[1], 11);
        v17 = this.FF1(v13, v14, v19, v16, this.X[3], 14);
        v20 = this.FF1(v16, v17, v14, v19, this.X[11], 14);
        v15 = this.FF1(v19, v20, v17, v14, this.X[15], 6);
        v18 = this.FF1(v14, v15, v20, v17, this.X[0], 14);
        v21 = this.FF1(v17, v18, v15, v20, this.X[5], 6);
        v16 = this.FF1(v20, v21, v18, v15, this.X[12], 9);
        v19 = this.FF1(v15, v16, v21, v18, this.X[2], 12);
        v22 = this.FF1(v18, v19, v16, v21, this.X[13], 9);
        v17 = this.FF1(v21, v22, v19, v16, this.X[9], 12);
        v20 = this.FF1(v16, v17, v22, v19, this.X[7], 5);
        v23 = this.FF1(v19, v20, v17, v22, this.X[10], 15);
        int v1 = this.FF1(v22, v23, v20, v17, this.X[14], 8);
        v2 = this.H1 + v34 + v20;
        this.H1 = this.H2 + v31 + v17;
        this.H2 = v1 + (this.H3 + v28);
        this.H3 = this.H0 + v29 + v23;
        this.H0 = v2;
        this.xOff = 0;
        for(v1 = 0; v1 != this.X.length; ++v1) {
            this.X[v1] = 0;
        }
    }

    protected void processLength(long arg5) {
        int v3 = 14;
        if(this.xOff > v3) {
            this.processBlock();
        }

        this.X[v3] = ((int)(-1 & arg5));
        this.X[15] = ((int)(arg5 >>> 32));
    }

    protected void processWord(byte[] arg5, int arg6) {
        int[] v0 = this.X;
        int v1 = this.xOff;
        this.xOff = v1 + 1;
        v0[v1] = arg5[arg6] & 255 | (arg5[arg6 + 1] & 255) << 8 | (arg5[arg6 + 2] & 255) << 16 | (arg5[arg6 + 3] & 255) << 24;
        if(this.xOff == 16) {
            this.processBlock();
        }
    }

    public void reset() {
        super.reset();
        this.H0 = 1732584193;
        this.H1 = -271733879;
        this.H2 = -1732584194;
        this.H3 = 271733878;
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        this.copyIn(((RIPEMD128Digest)arg1));
    }

    private void unpackWord(int arg3, byte[] arg4, int arg5) {
        arg4[arg5] = ((byte)arg3);
        arg4[arg5 + 1] = ((byte)(arg3 >>> 8));
        arg4[arg5 + 2] = ((byte)(arg3 >>> 16));
        arg4[arg5 + 3] = ((byte)(arg3 >>> 24));
    }
}

