// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.util.Memoable;

public class RIPEMD320Digest extends GeneralDigest {
    private static final int DIGEST_LENGTH = 40;
    private int H0;
    private int H1;
    private int H2;
    private int H3;
    private int H4;
    private int H5;
    private int H6;
    private int H7;
    private int H8;
    private int H9;
    private int[] X;
    private int xOff;

    public RIPEMD320Digest() {
        super();
        this.X = new int[16];
        this.reset();
    }

    public RIPEMD320Digest(RIPEMD320Digest arg2) {
        super(((GeneralDigest)arg2));
        this.X = new int[16];
        this.doCopy(arg2);
    }

    private int RL(int arg3, int arg4) {
        return arg3 << arg4 | arg3 >>> 32 - arg4;
    }

    public Memoable copy() {
        return new RIPEMD320Digest(this);
    }

    private void doCopy(RIPEMD320Digest arg5) {
        super.copyIn(((GeneralDigest)arg5));
        this.H0 = arg5.H0;
        this.H1 = arg5.H1;
        this.H2 = arg5.H2;
        this.H3 = arg5.H3;
        this.H4 = arg5.H4;
        this.H5 = arg5.H5;
        this.H6 = arg5.H6;
        this.H7 = arg5.H7;
        this.H8 = arg5.H8;
        this.H9 = arg5.H9;
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.finish();
        this.unpackWord(this.H0, arg3, arg4);
        this.unpackWord(this.H1, arg3, arg4 + 4);
        this.unpackWord(this.H2, arg3, arg4 + 8);
        this.unpackWord(this.H3, arg3, arg4 + 12);
        this.unpackWord(this.H4, arg3, arg4 + 16);
        this.unpackWord(this.H5, arg3, arg4 + 20);
        this.unpackWord(this.H6, arg3, arg4 + 24);
        this.unpackWord(this.H7, arg3, arg4 + 28);
        this.unpackWord(this.H8, arg3, arg4 + 32);
        this.unpackWord(this.H9, arg3, arg4 + 36);
        this.reset();
        return 40;
    }

    private int f1(int arg2, int arg3, int arg4) {
        return arg2 ^ arg3 ^ arg4;
    }

    private int f2(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | (arg3 ^ -1) & arg5;
    }

    private int f3(int arg2, int arg3, int arg4) {
        return (arg3 ^ -1 | arg2) ^ arg4;
    }

    private int f4(int arg3, int arg4, int arg5) {
        return arg3 & arg5 | (arg5 ^ -1) & arg4;
    }

    private int f5(int arg2, int arg3, int arg4) {
        return (arg4 ^ -1 | arg3) ^ arg2;
    }

    public String getAlgorithmName() {
        return "RIPEMD320";
    }

    public int getDigestSize() {
        return 40;
    }

    protected void processBlock() {
        int v0 = this.H0;
        int v1 = this.H1;
        int v2 = this.H2;
        int v3 = this.H3;
        int v4 = this.H4;
        int v5 = this.H5;
        int v6 = this.H6;
        int v7 = this.H7;
        int v8 = this.H8;
        int v9 = this.H9;
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[0], 11) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f1(v0, v1, v2) + this.X[1], 14) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f1(v4, v0, v1) + this.X[2], 15) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f1(v3, v4, v0) + this.X[3], 12) + v1;
        v4 = this.RL(v4, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v4) + this.X[4], 5) + v0;
        v3 = this.RL(v3, 10);
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[5], 8) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f1(v0, v1, v2) + this.X[6], 7) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f1(v4, v0, v1) + this.X[7], 9) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f1(v3, v4, v0) + this.X[8], 11) + v1;
        v4 = this.RL(v4, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v4) + this.X[9], 13) + v0;
        v3 = this.RL(v3, 10);
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[10], 14) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f1(v0, v1, v2) + this.X[11], 15) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f1(v4, v0, v1) + this.X[12], 6) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f1(v3, v4, v0) + this.X[13], 7) + v1;
        v4 = this.RL(v4, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v4) + this.X[14], 9) + v0;
        v3 = this.RL(v3, 10);
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[15], 8) + v4;
        v2 = this.RL(v2, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[5] + 1352829926, 8) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f5(v5, v6, v7) + this.X[14] + 1352829926, 9) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f5(v9, v5, v6) + this.X[7] + 1352829926, 9) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f5(v8, v9, v5) + this.X[0] + 1352829926, 11) + v6;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v9) + this.X[9] + 1352829926, 13) + v5;
        v8 = this.RL(v8, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[2] + 1352829926, 15) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f5(v5, v6, v7) + this.X[11] + 1352829926, 15) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f5(v9, v5, v6) + this.X[4] + 1352829926, 5) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f5(v8, v9, v5) + this.X[13] + 1352829926, 7) + v6;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v9) + this.X[6] + 1352829926, 7) + v5;
        v8 = this.RL(v8, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[15] + 1352829926, 8) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f5(v5, v6, v7) + this.X[8] + 1352829926, 11) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f5(v9, v5, v6) + this.X[1] + 1352829926, 14) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f5(v8, v9, v5) + this.X[10] + 1352829926, 14) + v6;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v9) + this.X[3] + 1352829926, 12) + v5;
        v8 = this.RL(v8, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[12] + 1352829926, 6) + v9;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f2(v5, v1, v2) + this.X[7] + 1518500249, 7) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f2(v4, v5, v1) + this.X[4] + 1518500249, 6) + v2;
        v5 = this.RL(v5, 10);
        v2 = this.RL(v2 + this.f2(v3, v4, v5) + this.X[13] + 1518500249, 8) + v1;
        v4 = this.RL(v4, 10);
        v1 = this.RL(v1 + this.f2(v2, v3, v4) + this.X[1] + 1518500249, 13) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f2(v1, v2, v3) + this.X[10] + 1518500249, 11) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f2(v5, v1, v2) + this.X[6] + 1518500249, 9) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f2(v4, v5, v1) + this.X[15] + 1518500249, 7) + v2;
        v5 = this.RL(v5, 10);
        v2 = this.RL(v2 + this.f2(v3, v4, v5) + this.X[3] + 1518500249, 15) + v1;
        v4 = this.RL(v4, 10);
        v1 = this.RL(v1 + this.f2(v2, v3, v4) + this.X[12] + 1518500249, 7) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f2(v1, v2, v3) + this.X[0] + 1518500249, 12) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f2(v5, v1, v2) + this.X[9] + 1518500249, 15) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f2(v4, v5, v1) + this.X[5] + 1518500249, 9) + v2;
        v5 = this.RL(v5, 10);
        v2 = this.RL(v2 + this.f2(v3, v4, v5) + this.X[2] + 1518500249, 11) + v1;
        v4 = this.RL(v4, 10);
        v1 = this.RL(v1 + this.f2(v2, v3, v4) + this.X[14] + 1518500249, 7) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f2(v1, v2, v3) + this.X[11] + 1518500249, 13) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f2(v5, v1, v2) + this.X[8] + 1518500249, 12) + v3;
        v1 = this.RL(v1, 10);
        v9 = this.RL(v9 + this.f4(v0, v6, v7) + this.X[6] + 1548603684, 9) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f4(v9, v0, v6) + this.X[11] + 1548603684, 13) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f4(v8, v9, v0) + this.X[3] + 1548603684, 15) + v6;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f4(v7, v8, v9) + this.X[7] + 1548603684, 7) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f4(v6, v7, v8) + this.X[0] + 1548603684, 12) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f4(v0, v6, v7) + this.X[13] + 1548603684, 8) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f4(v9, v0, v6) + this.X[5] + 1548603684, 9) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f4(v8, v9, v0) + this.X[10] + 1548603684, 11) + v6;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f4(v7, v8, v9) + this.X[14] + 1548603684, 7) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f4(v6, v7, v8) + this.X[15] + 1548603684, 7) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f4(v0, v6, v7) + this.X[8] + 1548603684, 12) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f4(v9, v0, v6) + this.X[12] + 1548603684, 7) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f4(v8, v9, v0) + this.X[4] + 1548603684, 6) + v6;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f4(v7, v8, v9) + this.X[9] + 1548603684, 15) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f4(v6, v7, v8) + this.X[1] + 1548603684, 13) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f4(v0, v6, v7) + this.X[2] + 1548603684, 11) + v8;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f3(v4, v5, v6) + this.X[3] + 1859775393, 11) + v2;
        v5 = this.RL(v5, 10);
        v2 = this.RL(v2 + this.f3(v3, v4, v5) + this.X[10] + 1859775393, 13) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f3(v2, v3, v4) + this.X[14] + 1859775393, 6) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f3(v6, v2, v3) + this.X[4] + 1859775393, 7) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f3(v5, v6, v2) + this.X[9] + 1859775393, 14) + v3;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f3(v4, v5, v6) + this.X[15] + 1859775393, 9) + v2;
        v5 = this.RL(v5, 10);
        v2 = this.RL(v2 + this.f3(v3, v4, v5) + this.X[8] + 1859775393, 13) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f3(v2, v3, v4) + this.X[1] + 1859775393, 15) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f3(v6, v2, v3) + this.X[2] + 1859775393, 14) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f3(v5, v6, v2) + this.X[7] + 1859775393, 8) + v3;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f3(v4, v5, v6) + this.X[0] + 1859775393, 13) + v2;
        v5 = this.RL(v5, 10);
        v2 = this.RL(v2 + this.f3(v3, v4, v5) + this.X[6] + 1859775393, 6) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f3(v2, v3, v4) + this.X[13] + 1859775393, 5) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f3(v6, v2, v3) + this.X[11] + 1859775393, 12) + v4;
        v2 = this.RL(v2, 10);
        v4 = this.RL(v4 + this.f3(v5, v6, v2) + this.X[5] + 1859775393, 7) + v3;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f3(v4, v5, v6) + this.X[12] + 1859775393, 5) + v2;
        v5 = this.RL(v5, 10);
        v8 = this.RL(v8 + this.f3(v9, v0, v1) + this.X[15] + 1836072691, 9) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f3(v8, v9, v0) + this.X[5] + 1836072691, 7) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f3(v7, v8, v9) + this.X[1] + 1836072691, 15) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f3(v1, v7, v8) + this.X[3] + 1836072691, 11) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f3(v0, v1, v7) + this.X[7] + 1836072691, 8) + v8;
        v1 = this.RL(v1, 10);
        v8 = this.RL(v8 + this.f3(v9, v0, v1) + this.X[14] + 1836072691, 6) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f3(v8, v9, v0) + this.X[6] + 1836072691, 6) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f3(v7, v8, v9) + this.X[9] + 1836072691, 14) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f3(v1, v7, v8) + this.X[11] + 1836072691, 12) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f3(v0, v1, v7) + this.X[8] + 1836072691, 13) + v8;
        v1 = this.RL(v1, 10);
        v8 = this.RL(v8 + this.f3(v9, v0, v1) + this.X[12] + 1836072691, 5) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f3(v8, v9, v0) + this.X[2] + 1836072691, 14) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f3(v7, v8, v9) + this.X[10] + 1836072691, 13) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f3(v1, v7, v8) + this.X[0] + 1836072691, 13) + v9;
        v7 = this.RL(v7, 10);
        v9 = this.RL(v9 + this.f3(v0, v1, v7) + this.X[4] + 1836072691, 7) + v8;
        v1 = this.RL(v1, 10);
        v8 = this.RL(v8 + this.f3(v9, v0, v1) + this.X[13] + 1836072691, 5) + v7;
        v0 = this.RL(v0, 10);
        v7 = this.RL(v7 + this.f4(v3, v4, v5) + this.X[1] - 1894007588, 11) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f4(v7, v3, v4) + this.X[9] - 1894007588, 12) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f4(v6, v7, v3) + this.X[11] - 1894007588, 14) + v4;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f4(v5, v6, v7) + this.X[10] - 1894007588, 15) + v3;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f4(v4, v5, v6) + this.X[0] - 1894007588, 14) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f4(v3, v4, v5) + this.X[8] - 1894007588, 15) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f4(v7, v3, v4) + this.X[12] - 1894007588, 9) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f4(v6, v7, v3) + this.X[4] - 1894007588, 8) + v4;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f4(v5, v6, v7) + this.X[13] - 1894007588, 9) + v3;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f4(v4, v5, v6) + this.X[3] - 1894007588, 14) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f4(v3, v4, v5) + this.X[7] - 1894007588, 5) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f4(v7, v3, v4) + this.X[15] - 1894007588, 6) + v5;
        v3 = this.RL(v3, 10);
        v5 = this.RL(v5 + this.f4(v6, v7, v3) + this.X[14] - 1894007588, 8) + v4;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f4(v5, v6, v7) + this.X[5] - 1894007588, 6) + v3;
        v6 = this.RL(v6, 10);
        v3 = this.RL(v3 + this.f4(v4, v5, v6) + this.X[6] - 1894007588, 5) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f4(v3, v4, v5) + this.X[2] - 1894007588, 12) + v6;
        v4 = this.RL(v4, 10);
        v2 = this.RL(v2 + this.f2(v8, v9, v0) + this.X[8] + 2053994217, 15) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f2(v2, v8, v9) + this.X[6] + 2053994217, 5) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f2(v1, v2, v8) + this.X[4] + 2053994217, 8) + v9;
        v2 = this.RL(v2, 10);
        v9 = this.RL(v9 + this.f2(v0, v1, v2) + this.X[1] + 2053994217, 11) + v8;
        v1 = this.RL(v1, 10);
        v8 = this.RL(v8 + this.f2(v9, v0, v1) + this.X[3] + 2053994217, 14) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f2(v8, v9, v0) + this.X[11] + 2053994217, 14) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f2(v2, v8, v9) + this.X[15] + 2053994217, 6) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f2(v1, v2, v8) + this.X[0] + 2053994217, 14) + v9;
        v2 = this.RL(v2, 10);
        v9 = this.RL(v9 + this.f2(v0, v1, v2) + this.X[5] + 2053994217, 6) + v8;
        v1 = this.RL(v1, 10);
        v8 = this.RL(v8 + this.f2(v9, v0, v1) + this.X[12] + 2053994217, 9) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f2(v8, v9, v0) + this.X[2] + 2053994217, 12) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f2(v2, v8, v9) + this.X[13] + 2053994217, 9) + v0;
        v8 = this.RL(v8, 10);
        v0 = this.RL(v0 + this.f2(v1, v2, v8) + this.X[9] + 2053994217, 12) + v9;
        v2 = this.RL(v2, 10);
        v9 = this.RL(v9 + this.f2(v0, v1, v2) + this.X[7] + 2053994217, 5) + v8;
        v1 = this.RL(v1, 10);
        v8 = this.RL(v8 + this.f2(v9, v0, v1) + this.X[10] + 2053994217, 15) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f2(v8, v9, v0) + this.X[14] + 2053994217, 8) + v1;
        v9 = this.RL(v9, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v4) + this.X[4] - 1454113458, 9) + v5;
        v8 = this.RL(v8, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[0] - 1454113458, 15) + v4;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f5(v5, v6, v7) + this.X[5] - 1454113458, 5) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f5(v4, v5, v6) + this.X[9] - 1454113458, 11) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f5(v8, v4, v5) + this.X[7] - 1454113458, 6) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v4) + this.X[12] - 1454113458, 8) + v5;
        v8 = this.RL(v8, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[2] - 1454113458, 13) + v4;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f5(v5, v6, v7) + this.X[10] - 1454113458, 12) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f5(v4, v5, v6) + this.X[14] - 1454113458, 5) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f5(v8, v4, v5) + this.X[1] - 1454113458, 12) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v4) + this.X[3] - 1454113458, 13) + v5;
        v8 = this.RL(v8, 10);
        v5 = this.RL(v5 + this.f5(v6, v7, v8) + this.X[8] - 1454113458, 14) + v4;
        v7 = this.RL(v7, 10);
        v4 = this.RL(v4 + this.f5(v5, v6, v7) + this.X[11] - 1454113458, 11) + v8;
        v6 = this.RL(v6, 10);
        v8 = this.RL(v8 + this.f5(v4, v5, v6) + this.X[6] - 1454113458, 8) + v7;
        v5 = this.RL(v5, 10);
        v7 = this.RL(v7 + this.f5(v8, v4, v5) + this.X[15] - 1454113458, 5) + v6;
        v4 = this.RL(v4, 10);
        v6 = this.RL(v6 + this.f5(v7, v8, v4) + this.X[13] - 1454113458, 6) + v5;
        v8 = this.RL(v8, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v9) + this.X[12], 8) + v0;
        v3 = this.RL(v3, 10);
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[15], 5) + v9;
        v2 = this.RL(v2, 10);
        v9 = this.RL(v9 + this.f1(v0, v1, v2) + this.X[10], 12) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f1(v9, v0, v1) + this.X[4], 9) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f1(v3, v9, v0) + this.X[1], 12) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v9) + this.X[5], 5) + v0;
        v3 = this.RL(v3, 10);
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[8], 14) + v9;
        v2 = this.RL(v2, 10);
        v9 = this.RL(v9 + this.f1(v0, v1, v2) + this.X[7], 6) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f1(v9, v0, v1) + this.X[6], 8) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f1(v3, v9, v0) + this.X[2], 13) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v9) + this.X[13], 6) + v0;
        v3 = this.RL(v3, 10);
        v0 = this.RL(v0 + this.f1(v1, v2, v3) + this.X[14], 5) + v9;
        v2 = this.RL(v2, 10);
        v9 = this.RL(v9 + this.f1(v0, v1, v2) + this.X[0], 15) + v3;
        v1 = this.RL(v1, 10);
        v3 = this.RL(v3 + this.f1(v9, v0, v1) + this.X[3], 13) + v2;
        v0 = this.RL(v0, 10);
        v2 = this.RL(v2 + this.f1(v3, v9, v0) + this.X[9], 11) + v1;
        v9 = this.RL(v9, 10);
        v1 = this.RL(v1 + this.f1(v2, v3, v9) + this.X[11], 11) + v0;
        v3 = this.RL(v3, 10);
        this.H0 = v5 + this.H0;
        this.H1 += v6;
        this.H2 += v7;
        this.H3 += v8;
        this.H4 += v9;
        this.H5 = v0 + this.H5;
        this.H6 += v1;
        this.H7 += v2;
        this.H8 += v3;
        this.H9 += v4;
        this.xOff = 0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    protected void processLength(long arg5) {
        int v3 = 14;
        if(this.xOff > v3) {
            this.processBlock();
        }

        this.X[v3] = ((int)(-1 & arg5));
        this.X[15] = ((int)(arg5 >>> 32));
    }

    protected void processWord(byte[] arg5, int arg6) {
        int[] v0 = this.X;
        int v1 = this.xOff;
        this.xOff = v1 + 1;
        v0[v1] = arg5[arg6] & 255 | (arg5[arg6 + 1] & 255) << 8 | (arg5[arg6 + 2] & 255) << 16 | (arg5[arg6 + 3] & 255) << 24;
        if(this.xOff == 16) {
            this.processBlock();
        }
    }

    public void reset() {
        super.reset();
        this.H0 = 1732584193;
        this.H1 = -271733879;
        this.H2 = -1732584194;
        this.H3 = 271733878;
        this.H4 = -1009589776;
        this.H5 = 1985229328;
        this.H6 = -19088744;
        this.H7 = -1985229329;
        this.H8 = 19088743;
        this.H9 = 1009589775;
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        this.doCopy(((RIPEMD320Digest)arg1));
    }

    private void unpackWord(int arg3, byte[] arg4, int arg5) {
        arg4[arg5] = ((byte)arg3);
        arg4[arg5 + 1] = ((byte)(arg3 >>> 8));
        arg4[arg5 + 2] = ((byte)(arg3 >>> 16));
        arg4[arg5 + 3] = ((byte)(arg3 >>> 24));
    }
}

