// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Memoable;

public class SHA1Digest extends GeneralDigest {
    private static final int DIGEST_LENGTH = 20;
    private int H1;
    private int H2;
    private int H3;
    private int H4;
    private int H5;
    private int[] X;
    private static final int Y1 = 1518500249;
    private static final int Y2 = 1859775393;
    private static final int Y3 = -1894007588;
    private static final int Y4 = -899497514;
    private int xOff;

    public SHA1Digest() {
        super();
        this.X = new int[80];
        this.reset();
    }

    public SHA1Digest(SHA1Digest arg2) {
        super(((GeneralDigest)arg2));
        this.X = new int[80];
        this.copyIn(arg2);
    }

    public Memoable copy() {
        return new SHA1Digest(this);
    }

    private void copyIn(SHA1Digest arg5) {
        this.H1 = arg5.H1;
        this.H2 = arg5.H2;
        this.H3 = arg5.H3;
        this.H4 = arg5.H4;
        this.H5 = arg5.H5;
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.finish();
        Pack.intToBigEndian(this.H1, arg3, arg4);
        Pack.intToBigEndian(this.H2, arg3, arg4 + 4);
        Pack.intToBigEndian(this.H3, arg3, arg4 + 8);
        Pack.intToBigEndian(this.H4, arg3, arg4 + 12);
        Pack.intToBigEndian(this.H5, arg3, arg4 + 16);
        this.reset();
        return 20;
    }

    private int f(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | (arg3 ^ -1) & arg5;
    }

    private int g(int arg3, int arg4, int arg5) {
        return arg3 & arg4 | arg3 & arg5 | arg4 & arg5;
    }

    public String getAlgorithmName() {
        return "SHA-1";
    }

    public int getDigestSize() {
        return 20;
    }

    private int h(int arg2, int arg3, int arg4) {
        return arg2 ^ arg3 ^ arg4;
    }

    protected void processBlock() {
        int v8;
        int v9;
        int v1;
        int v0;
        for(v0 = 16; v0 < 80; ++v0) {
            v1 = this.X[v0 - 3] ^ this.X[v0 - 8] ^ this.X[v0 - 14] ^ this.X[v0 - 16];
            this.X[v0] = v1 >>> 31 | v1 << 1;
        }

        int v6 = this.H1;
        int v5 = this.H2;
        int v4 = this.H3;
        int v3 = this.H4;
        int v2 = this.H5;
        v1 = 0;
        for(v0 = 0; v0 < 4; ++v0) {
            v9 = v1 + 1;
            v1 = this.X[v1] + ((v6 << 5 | v6 >>> 27) + this.f(v5, v4, v3)) + 1518500249 + v2;
            v5 = v5 >>> 2 | v5 << 30;
            v8 = v9 + 1;
            v3 += (v1 << 5 | v1 >>> 27) + this.f(v6, v5, v4) + this.X[v9] + 1518500249;
            v6 = v6 >>> 2 | v6 << 30;
            v9 = v8 + 1;
            v4 += (v3 << 5 | v3 >>> 27) + this.f(v1, v6, v5) + this.X[v8] + 1518500249;
            v2 = v1 << 30 | v1 >>> 2;
            v8 = v9 + 1;
            v5 += (v4 << 5 | v4 >>> 27) + this.f(v3, v2, v6) + this.X[v9] + 1518500249;
            v3 = v3 >>> 2 | v3 << 30;
            v1 = v8 + 1;
            v6 += this.f(v4, v3, v2) + (v5 << 5 | v5 >>> 27) + this.X[v8] + 1518500249;
            v4 = v4 >>> 2 | v4 << 30;
        }

        for(v0 = 0; v0 < 4; ++v0) {
            v9 = v1 + 1;
            v1 = this.X[v1] + ((v6 << 5 | v6 >>> 27) + this.h(v5, v4, v3)) + 1859775393 + v2;
            v5 = v5 >>> 2 | v5 << 30;
            v8 = v9 + 1;
            v3 += (v1 << 5 | v1 >>> 27) + this.h(v6, v5, v4) + this.X[v9] + 1859775393;
            v6 = v6 >>> 2 | v6 << 30;
            v9 = v8 + 1;
            v4 += (v3 << 5 | v3 >>> 27) + this.h(v1, v6, v5) + this.X[v8] + 1859775393;
            v2 = v1 << 30 | v1 >>> 2;
            v8 = v9 + 1;
            v5 += (v4 << 5 | v4 >>> 27) + this.h(v3, v2, v6) + this.X[v9] + 1859775393;
            v3 = v3 >>> 2 | v3 << 30;
            v1 = v8 + 1;
            v6 += this.h(v4, v3, v2) + (v5 << 5 | v5 >>> 27) + this.X[v8] + 1859775393;
            v4 = v4 >>> 2 | v4 << 30;
        }

        for(v0 = 0; v0 < 4; ++v0) {
            v9 = v1 + 1;
            v1 = this.X[v1] + ((v6 << 5 | v6 >>> 27) + this.g(v5, v4, v3)) - 1894007588 + v2;
            v5 = v5 >>> 2 | v5 << 30;
            v8 = v9 + 1;
            v3 += (v1 << 5 | v1 >>> 27) + this.g(v6, v5, v4) + this.X[v9] - 1894007588;
            v6 = v6 >>> 2 | v6 << 30;
            v9 = v8 + 1;
            v4 += (v3 << 5 | v3 >>> 27) + this.g(v1, v6, v5) + this.X[v8] - 1894007588;
            v2 = v1 << 30 | v1 >>> 2;
            v8 = v9 + 1;
            v5 += (v4 << 5 | v4 >>> 27) + this.g(v3, v2, v6) + this.X[v9] - 1894007588;
            v3 = v3 >>> 2 | v3 << 30;
            v1 = v8 + 1;
            v6 += this.g(v4, v3, v2) + (v5 << 5 | v5 >>> 27) + this.X[v8] - 1894007588;
            v4 = v4 >>> 2 | v4 << 30;
        }

        for(v0 = 0; v0 <= 3; ++v0) {
            v9 = v1 + 1;
            v1 = this.X[v1] + ((v6 << 5 | v6 >>> 27) + this.h(v5, v4, v3)) - 899497514 + v2;
            v5 = v5 >>> 2 | v5 << 30;
            v8 = v9 + 1;
            v3 += (v1 << 5 | v1 >>> 27) + this.h(v6, v5, v4) + this.X[v9] - 899497514;
            v6 = v6 >>> 2 | v6 << 30;
            v9 = v8 + 1;
            v4 += (v3 << 5 | v3 >>> 27) + this.h(v1, v6, v5) + this.X[v8] - 899497514;
            v2 = v1 << 30 | v1 >>> 2;
            v8 = v9 + 1;
            v5 += (v4 << 5 | v4 >>> 27) + this.h(v3, v2, v6) + this.X[v9] - 899497514;
            v3 = v3 >>> 2 | v3 << 30;
            v1 = v8 + 1;
            v6 += this.h(v4, v3, v2) + (v5 << 5 | v5 >>> 27) + this.X[v8] - 899497514;
            v4 = v4 >>> 2 | v4 << 30;
        }

        this.H1 += v6;
        this.H2 += v5;
        this.H3 += v4;
        this.H4 += v3;
        this.H5 += v2;
        this.xOff = 0;
        for(v0 = 0; v0 < 16; ++v0) {
            this.X[v0] = 0;
        }
    }

    protected void processLength(long arg5) {
        int v3 = 14;
        if(this.xOff > v3) {
            this.processBlock();
        }

        this.X[v3] = ((int)(arg5 >>> 32));
        this.X[15] = ((int)(-1 & arg5));
    }

    protected void processWord(byte[] arg4, int arg5) {
        int v1 = arg5 + 1;
        int v0 = arg4[arg5] << 24 | (arg4[v1] & 255) << 16;
        ++v1;
        this.X[this.xOff] = v0 | (arg4[v1] & 255) << 8 | arg4[v1 + 1] & 255;
        v0 = this.xOff + 1;
        this.xOff = v0;
        if(v0 == 16) {
            this.processBlock();
        }
    }

    public void reset() {
        super.reset();
        this.H1 = 1732584193;
        this.H2 = -271733879;
        this.H3 = -1732584194;
        this.H4 = 271733878;
        this.H5 = -1009589776;
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        super.copyIn(((GeneralDigest)arg1));
        this.copyIn(((SHA1Digest)arg1));
    }
}

