// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Memoable;

public class SHA224Digest extends GeneralDigest {
    private static final int DIGEST_LENGTH = 28;
    private int H1;
    private int H2;
    private int H3;
    private int H4;
    private int H5;
    private int H6;
    private int H7;
    private int H8;
    static final int[] K;
    private int[] X;
    private int xOff;

    static {
        SHA224Digest.K = new int[]{1116352408, 1899447441, -1245643825, -373957723, 961987163, 1508970993, -1841331548, -1424204075, -670586216, 310598401, 607225278, 1426881987, 1925078388, -2132889090, -1680079193, -1046744716, -459576895, -272742522, 264347078, 604807628, 770255983, 1249150122, 1555081692, 1996064986, -1740746414, -1473132947, -1341970488, -1084653625, -958395405, -710438585, 113926993, 338241895, 666307205, 773529912, 1294757372, 1396182291, 1695183700, 1986661051, -2117940946, -1838011259, -1564481375, -1474664885, -1035236496, -949202525, -778901479, -694614492, -200395387, 275423344, 430227734, 506948616, 659060556, 883997877, 958139571, 1322822218, 1537002063, 1747873779, 1955562222, 2024104815, -2067236844, -1933114872, -1866530822, -1538233109, -1090935817, -965641998};
    }

    public SHA224Digest() {
        super();
        this.X = new int[64];
        this.reset();
    }

    public SHA224Digest(SHA224Digest arg2) {
        super(((GeneralDigest)arg2));
        this.X = new int[64];
        this.doCopy(arg2);
    }

    private int Ch(int arg3, int arg4, int arg5) {
        return arg3 & arg4 ^ (arg3 ^ -1) & arg5;
    }

    private int Maj(int arg3, int arg4, int arg5) {
        return arg3 & arg4 ^ arg3 & arg5 ^ arg4 & arg5;
    }

    private int Sum0(int arg4) {
        return (arg4 >>> 2 | arg4 << 30) ^ (arg4 >>> 13 | arg4 << 19) ^ (arg4 >>> 22 | arg4 << 10);
    }

    private int Sum1(int arg4) {
        return (arg4 >>> 6 | arg4 << 26) ^ (arg4 >>> 11 | arg4 << 21) ^ (arg4 >>> 25 | arg4 << 7);
    }

    private int Theta0(int arg4) {
        return (arg4 >>> 7 | arg4 << 25) ^ (arg4 >>> 18 | arg4 << 14) ^ arg4 >>> 3;
    }

    private int Theta1(int arg4) {
        return (arg4 >>> 17 | arg4 << 15) ^ (arg4 >>> 19 | arg4 << 13) ^ arg4 >>> 10;
    }

    public Memoable copy() {
        return new SHA224Digest(this);
    }

    private void doCopy(SHA224Digest arg5) {
        super.copyIn(((GeneralDigest)arg5));
        this.H1 = arg5.H1;
        this.H2 = arg5.H2;
        this.H3 = arg5.H3;
        this.H4 = arg5.H4;
        this.H5 = arg5.H5;
        this.H6 = arg5.H6;
        this.H7 = arg5.H7;
        this.H8 = arg5.H8;
        System.arraycopy(arg5.X, 0, this.X, 0, arg5.X.length);
        this.xOff = arg5.xOff;
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.finish();
        Pack.intToBigEndian(this.H1, arg3, arg4);
        Pack.intToBigEndian(this.H2, arg3, arg4 + 4);
        Pack.intToBigEndian(this.H3, arg3, arg4 + 8);
        Pack.intToBigEndian(this.H4, arg3, arg4 + 12);
        Pack.intToBigEndian(this.H5, arg3, arg4 + 16);
        Pack.intToBigEndian(this.H6, arg3, arg4 + 20);
        Pack.intToBigEndian(this.H7, arg3, arg4 + 24);
        this.reset();
        return 28;
    }

    public String getAlgorithmName() {
        return "SHA-224";
    }

    public int getDigestSize() {
        return 28;
    }

    protected void processBlock() {
        int v11 = 16;
        int v0;
        for(v0 = v11; v0 <= 63; ++v0) {
            this.X[v0] = this.Theta1(this.X[v0 - 2]) + this.X[v0 - 7] + this.Theta0(this.X[v0 - 15]) + this.X[v0 - 16];
        }

        int v8 = this.H1;
        int v7 = this.H2;
        int v6 = this.H3;
        int v5 = this.H4;
        int v4 = this.H5;
        int v3 = this.H6;
        int v2 = this.H7;
        int v9 = v7;
        int v10 = v8;
        v7 = v5;
        v8 = v6;
        v5 = v3;
        v6 = v4;
        v3 = this.H8;
        v4 = v2;
        v0 = 0;
        v2 = 0;
        while(v0 < 8) {
            v3 += this.Sum1(v6) + this.Ch(v6, v5, v4) + SHA224Digest.K[v2] + this.X[v2];
            v7 += v3;
            v3 += this.Sum0(v10) + this.Maj(v10, v9, v8);
            ++v2;
            v4 += this.Sum1(v7) + this.Ch(v7, v6, v5) + SHA224Digest.K[v2] + this.X[v2];
            v8 += v4;
            v4 += this.Sum0(v3) + this.Maj(v3, v10, v9);
            ++v2;
            v5 += this.Sum1(v8) + this.Ch(v8, v7, v6) + SHA224Digest.K[v2] + this.X[v2];
            v9 += v5;
            v5 += this.Sum0(v4) + this.Maj(v4, v3, v10);
            ++v2;
            v6 += this.Sum1(v9) + this.Ch(v9, v8, v7) + SHA224Digest.K[v2] + this.X[v2];
            v10 += v6;
            v6 += this.Sum0(v5) + this.Maj(v5, v4, v3);
            ++v2;
            v7 += this.Sum1(v10) + this.Ch(v10, v9, v8) + SHA224Digest.K[v2] + this.X[v2];
            v3 += v7;
            v7 += this.Sum0(v6) + this.Maj(v6, v5, v4);
            ++v2;
            v8 += this.Sum1(v3) + this.Ch(v3, v10, v9) + SHA224Digest.K[v2] + this.X[v2];
            v4 += v8;
            v8 += this.Sum0(v7) + this.Maj(v7, v6, v5);
            ++v2;
            v9 += this.Sum1(v4) + this.Ch(v4, v3, v10) + SHA224Digest.K[v2] + this.X[v2];
            v5 += v9;
            v9 += this.Sum0(v8) + this.Maj(v8, v7, v6);
            ++v2;
            v10 += this.Sum1(v5) + this.Ch(v5, v4, v3) + SHA224Digest.K[v2] + this.X[v2];
            v6 += v10;
            v10 += this.Sum0(v9) + this.Maj(v9, v8, v7);
            ++v2;
            ++v0;
        }

        this.H1 += v10;
        this.H2 += v9;
        this.H3 += v8;
        this.H4 += v7;
        this.H5 += v6;
        this.H6 += v5;
        this.H7 += v4;
        this.H8 += v3;
        this.xOff = 0;
        for(v0 = 0; v0 < v11; ++v0) {
            this.X[v0] = 0;
        }
    }

    protected void processLength(long arg5) {
        int v3 = 14;
        if(this.xOff > v3) {
            this.processBlock();
        }

        this.X[v3] = ((int)(arg5 >>> 32));
        this.X[15] = ((int)(-1 & arg5));
    }

    protected void processWord(byte[] arg4, int arg5) {
        int v1 = arg5 + 1;
        int v0 = arg4[arg5] << 24 | (arg4[v1] & 255) << 16;
        ++v1;
        this.X[this.xOff] = v0 | (arg4[v1] & 255) << 8 | arg4[v1 + 1] & 255;
        v0 = this.xOff + 1;
        this.xOff = v0;
        if(v0 == 16) {
            this.processBlock();
        }
    }

    public void reset() {
        super.reset();
        this.H1 = -1056596264;
        this.H2 = 914150663;
        this.H3 = 812702999;
        this.H4 = -150054599;
        this.H5 = -4191439;
        this.H6 = 1750603025;
        this.H7 = 1694076839;
        this.H8 = -1090891868;
        this.xOff = 0;
        int v0;
        for(v0 = 0; v0 != this.X.length; ++v0) {
            this.X[v0] = 0;
        }
    }

    public void reset(Memoable arg1) {
        this.doCopy(((SHA224Digest)arg1));
    }
}

