// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.util.Arrays;

public class SHA3Digest implements ExtendedDigest {
    long[] C;
    private static int[] KeccakRhoOffsets;
    private static long[] KeccakRoundConstants;
    private int bitsAvailableForSqueezing;
    private int bitsInQueue;
    long[] chiC;
    private byte[] chunk;
    private byte[] dataQueue;
    private int fixedOutputLength;
    private byte[] oneByte;
    private int rate;
    private boolean squeezing;
    private byte[] state;
    long[] tempA;

    static {
        SHA3Digest.KeccakRoundConstants = SHA3Digest.keccakInitializeRoundConstants();
        SHA3Digest.KeccakRhoOffsets = SHA3Digest.keccakInitializeRhoOffsets();
    }

    public SHA3Digest() {
        super();
        this.state = new byte[200];
        this.dataQueue = new byte[192];
        this.C = new long[5];
        this.tempA = new long[25];
        this.chiC = new long[5];
        this.init(0);
    }

    public SHA3Digest(int arg3) {
        super();
        this.state = new byte[200];
        this.dataQueue = new byte[192];
        this.C = new long[5];
        this.tempA = new long[25];
        this.chiC = new long[5];
        this.init(arg3);
    }

    public SHA3Digest(SHA3Digest arg5) {
        super();
        this.state = new byte[200];
        this.dataQueue = new byte[192];
        this.C = new long[5];
        this.tempA = new long[25];
        this.chiC = new long[5];
        System.arraycopy(arg5.state, 0, this.state, 0, arg5.state.length);
        System.arraycopy(arg5.dataQueue, 0, this.dataQueue, 0, arg5.dataQueue.length);
        this.rate = arg5.rate;
        this.bitsInQueue = arg5.bitsInQueue;
        this.fixedOutputLength = arg5.fixedOutputLength;
        this.squeezing = arg5.squeezing;
        this.bitsAvailableForSqueezing = arg5.bitsAvailableForSqueezing;
        this.chunk = Arrays.clone(arg5.chunk);
        this.oneByte = Arrays.clone(arg5.oneByte);
    }

    private void KeccakAbsorb(byte[] arg1, byte[] arg2, int arg3) {
        this.keccakPermutationAfterXor(arg1, arg2, arg3);
    }

    private void KeccakExtract(byte[] arg3, byte[] arg4, int arg5) {
        System.arraycopy(arg3, 0, arg4, 0, arg5 * 8);
    }

    private void KeccakExtract1024bits(byte[] arg3, byte[] arg4) {
        System.arraycopy(arg3, 0, arg4, 0, 128);
    }

    private static boolean LFSR86540(byte[] arg3) {
        boolean v0 = (arg3[0] & 1) != 0 ? true : false;
        arg3[0] = (arg3[0] & 128) != 0 ? ((byte)(arg3[0] << 1 ^ 113)) : ((byte)(arg3[0] << 1));
        return v0;
    }

    private void absorb(byte[] arg11, int arg12, long arg13) {
        long v0;
        long v4;
        if(this.bitsInQueue % 8 != 0) {
            throw new IllegalStateException("attempt to absorb with odd length queue.");
        }

        if(this.squeezing) {
            throw new IllegalStateException("attempt to absorb while squeezing.");
        }

        long v2 = 0;
    label_15:
        while(v2 < arg13) {
            if(this.bitsInQueue == 0 && arg13 >= (((long)this.rate)) && v2 <= arg13 - (((long)this.rate))) {
                v4 = (arg13 - v2) / (((long)this.rate));
                v0 = 0;
                goto label_30;
            }

            int v0_1 = ((int)(arg13 - v2));
            if(this.bitsInQueue + v0_1 > this.rate) {
                v0_1 = this.rate - this.bitsInQueue;
            }

            int v4_1 = v0_1 % 8;
            v0_1 -= v4_1;
            System.arraycopy(arg11, (((int)(v2 / 8))) + arg12, this.dataQueue, this.bitsInQueue / 8, v0_1 / 8);
            this.bitsInQueue += v0_1;
            v0 = (((long)v0_1)) + v2;
            if(this.bitsInQueue == this.rate) {
                this.absorbQueue();
            }

            if(v4_1 > 0) {
                this.dataQueue[this.bitsInQueue / 8] = ((byte)((1 << v4_1) - 1 & arg11[(((int)(v0 / 8))) + arg12]));
                this.bitsInQueue += v4_1;
                v0 += ((long)v4_1);
            }

            v2 = v0;
        }

        return;
    label_30:
        while(v0 < v4) {
            System.arraycopy(arg11, ((int)((((long)arg12)) + v2 / 8 + (((long)this.chunk.length)) * v0)), this.chunk, 0, this.chunk.length);
            this.KeccakAbsorb(this.state, this.chunk, this.chunk.length);
            ++v0;
        }

        v2 = (((long)this.rate)) * v4 + v2;
        goto label_15;
    }

    private void absorbQueue() {
        this.KeccakAbsorb(this.state, this.dataQueue, this.rate / 8);
        this.bitsInQueue = 0;
    }

    private void chi(long[] arg12) {
        int v10 = 5;
        int v2;
        for(v2 = 0; v2 < v10; ++v2) {
            int v0;
            for(v0 = 0; v0 < v10; ++v0) {
                this.chiC[v0] = arg12[v2 * 5 + v0] ^ (arg12[(v0 + 1) % 5 + v2 * 5] ^ -1) & arg12[(v0 + 2) % 5 + v2 * 5];
            }

            for(v0 = 0; v0 < v10; ++v0) {
                arg12[v2 * 5 + v0] = this.chiC[v0];
            }
        }
    }

    private void clearDataQueueSection(int arg4, int arg5) {
        int v0;
        for(v0 = arg4; v0 != arg4 + arg5; ++v0) {
            this.dataQueue[v0] = 0;
        }
    }

    public int doFinal(byte[] arg3, int arg4) {
        this.squeeze(arg3, arg4, ((long)this.fixedOutputLength));
        this.reset();
        return this.getDigestSize();
    }

    private void doUpdate(byte[] arg8, int arg9, long arg10) {
        long v5 = 8;
        if(arg10 % v5 == 0) {
            this.absorb(arg8, arg9, arg10);
        }
        else {
            this.absorb(arg8, arg9, arg10 - arg10 % v5);
            this.absorb(new byte[]{((byte)(arg8[(((int)(arg10 / v5))) + arg9] >> (((int)(v5 - arg10 % v5)))))}, arg9, arg10 % v5);
        }
    }

    private void fromBytesToWords(long[] arg11, byte[] arg12) {
        int v2;
        for(v2 = 0; v2 < 25; ++v2) {
            arg11[v2] = 0;
            int v3 = v2 * 8;
            int v0;
            for(v0 = 0; v0 < 8; ++v0) {
                arg11[v2] |= ((((long)arg12[v3 + v0])) & 255) << v0 * 8;
            }
        }
    }

    private void fromWordsToBytes(byte[] arg10, long[] arg11) {
        int v2;
        for(v2 = 0; v2 < 25; ++v2) {
            int v3 = v2 * 8;
            int v0;
            for(v0 = 0; v0 < 8; ++v0) {
                arg10[v3 + v0] = ((byte)(((int)(arg11[v2] >>> v0 * 8 & 255))));
            }
        }
    }

    public String getAlgorithmName() {
        return "SHA3-" + this.fixedOutputLength;
    }

    public int getByteLength() {
        return this.rate / 8;
    }

    public int getDigestSize() {
        return this.fixedOutputLength / 8;
    }

    private void init(int arg3) {
        int v1 = 1024;
        int v0 = 576;
        switch(arg3) {
            case 224: {
                goto label_9;
            }
            case 256: {
                goto label_13;
            }
            case 0: 
            case 288: {
                goto label_7;
            }
            case 384: {
                goto label_17;
            }
            case 512: {
                goto label_21;
            }
        }

        throw new IllegalArgumentException("bitLength must be one of 224, 256, 384, or 512.");
    label_17:
        this.initSponge(832, 768);
        return;
    label_7:
        this.initSponge(v1, v0);
        return;
    label_21:
        this.initSponge(v0, v1);
        return;
    label_9:
        this.initSponge(1152, 448);
        return;
    label_13:
        this.initSponge(1088, 512);
    }

    private void initSponge(int arg4, int arg5) {
        int v2 = 1600;
        if(arg4 + arg5 != v2) {
            throw new IllegalStateException("rate + capacity != 1600");
        }

        if(arg4 > 0 && arg4 < v2 && arg4 % 64 == 0) {
            this.rate = arg4;
            this.fixedOutputLength = 0;
            Arrays.fill(this.state, 0);
            Arrays.fill(this.dataQueue, 0);
            this.bitsInQueue = 0;
            this.squeezing = false;
            this.bitsAvailableForSqueezing = 0;
            this.fixedOutputLength = arg5 / 2;
            this.chunk = new byte[arg4 / 8];
            this.oneByte = new byte[1];
            return;
        }

        throw new IllegalStateException("invalid rate value");
    }

    private void iota(long[] arg6, int arg7) {
        arg6[0] ^= SHA3Digest.KeccakRoundConstants[arg7];
    }

    private static int[] keccakInitializeRhoOffsets() {
        int v0 = 0;
        int[] v4 = new int[25];
        v4[0] = 0;
        int v2 = 1;
        int v1 = 0;
        while(v0 < 24) {
            v4[v2 % 5 + v1 % 5 * 5] = (v0 + 1) * (v0 + 2) / 2 % 64;
            int v3 = v1 % 5;
            v1 = (v1 * 3 + v2 * 2) % 5;
            ++v0;
            v2 = v3;
        }

        return v4;
    }

    private static long[] keccakInitializeRoundConstants() {
        int v11 = 24;
        long[] v3 = new long[v11];
        byte[] v4 = new byte[]{1};
        int v2;
        for(v2 = 0; v2 < v11; ++v2) {
            v3[v2] = 0;
            int v0;
            for(v0 = 0; v0 < 7; ++v0) {
                int v5 = (1 << v0) - 1;
                if(SHA3Digest.LFSR86540(v4)) {
                    v3[v2] ^= 1 << v5;
                }
            }
        }

        return v3;
    }

    private void keccakPermutation(byte[] arg2) {
        long[] v0 = new long[arg2.length / 8];
        this.fromBytesToWords(v0, arg2);
        this.keccakPermutationOnWords(v0);
        this.fromWordsToBytes(arg2, v0);
    }

    private void keccakPermutationAfterXor(byte[] arg4, byte[] arg5, int arg6) {
        int v0;
        for(v0 = 0; v0 < arg6; ++v0) {
            arg4[v0] = ((byte)(arg4[v0] ^ arg5[v0]));
        }

        this.keccakPermutation(arg4);
    }

    private void keccakPermutationOnWords(long[] arg3) {
        int v0;
        for(v0 = 0; v0 < 24; ++v0) {
            this.theta(arg3);
            this.rho(arg3);
            this.pi(arg3);
            this.chi(arg3);
            this.iota(arg3, v0);
        }
    }

    private void padAndSwitchToSqueezingPhase() {
        int v1;
        byte[] v0;
        int v5 = 1024;
        if(this.bitsInQueue + 1 == this.rate) {
            v0 = this.dataQueue;
            v1 = this.bitsInQueue / 8;
            v0[v1] = ((byte)(v0[v1] | 1 << this.bitsInQueue % 8));
            this.absorbQueue();
            this.clearDataQueueSection(0, this.rate / 8);
        }
        else {
            this.clearDataQueueSection((this.bitsInQueue + 7) / 8, this.rate / 8 - (this.bitsInQueue + 7) / 8);
            v0 = this.dataQueue;
            v1 = this.bitsInQueue / 8;
            v0[v1] = ((byte)(v0[v1] | 1 << this.bitsInQueue % 8));
        }

        v0 = this.dataQueue;
        v1 = (this.rate - 1) / 8;
        v0[v1] = ((byte)(v0[v1] | 1 << (this.rate - 1) % 8));
        this.absorbQueue();
        if(this.rate == v5) {
            this.KeccakExtract1024bits(this.state, this.dataQueue);
            this.bitsAvailableForSqueezing = v5;
        }
        else {
            this.KeccakExtract(this.state, this.dataQueue, this.rate / 64);
            this.bitsAvailableForSqueezing = this.rate;
        }

        this.squeezing = true;
    }

    private void pi(long[] arg8) {
        int v6 = 5;
        System.arraycopy(arg8, 0, this.tempA, 0, this.tempA.length);
        int v2;
        for(v2 = 0; v2 < v6; ++v2) {
            int v0;
            for(v0 = 0; v0 < v6; ++v0) {
                arg8[(v2 * 2 + v0 * 3) % 5 * 5 + v0] = this.tempA[v0 * 5 + v2];
            }
        }
    }

    public void reset() {
        this.init(this.fixedOutputLength);
    }

    private void rho(long[] arg11) {
        int v9 = 5;
        int v4;
        for(v4 = 0; v4 < v9; ++v4) {
            int v2;
            for(v2 = 0; v2 < v9; ++v2) {
                int v5 = v4 + v2 * 5;
                long v0 = SHA3Digest.KeccakRhoOffsets[v5] != 0 ? arg11[v5] << SHA3Digest.KeccakRhoOffsets[v5] ^ arg11[v5] >>> 64 - SHA3Digest.KeccakRhoOffsets[v5] : arg11[v5];
                arg11[v5] = v0;
            }
        }
    }

    private void squeeze(byte[] arg11, int arg12, long arg13) {
        long v8 = 8;
        long v0 = 0;
        int v7 = 1024;
        if(!this.squeezing) {
            this.padAndSwitchToSqueezingPhase();
        }

        if(arg13 % v8 != v0) {
            throw new IllegalStateException("outputLength not a multiple of 8");
        }

        long v1;
        for(v1 = v0; v1 < arg13; v1 += ((long)v0_1)) {
            if(this.bitsAvailableForSqueezing == 0) {
                this.keccakPermutation(this.state);
                if(this.rate == v7) {
                    this.KeccakExtract1024bits(this.state, this.dataQueue);
                    this.bitsAvailableForSqueezing = v7;
                }
                else {
                    this.KeccakExtract(this.state, this.dataQueue, this.rate / 64);
                    this.bitsAvailableForSqueezing = this.rate;
                }
            }

            int v0_1 = this.bitsAvailableForSqueezing;
            if((((long)v0_1)) > arg13 - v1) {
                v0_1 = ((int)(arg13 - v1));
            }

            System.arraycopy(this.dataQueue, (this.rate - this.bitsAvailableForSqueezing) / 8, arg11, (((int)(v1 / v8))) + arg12, v0_1 / 8);
            this.bitsAvailableForSqueezing -= v0_1;
        }
    }

    private void theta(long[] arg10) {
        int v8 = 5;
        int v2;
        for(v2 = 0; v2 < v8; ++v2) {
            this.C[v2] = 0;
            int v0;
            for(v0 = 0; v0 < v8; ++v0) {
                this.C[v2] ^= arg10[v0 * 5 + v2];
            }
        }

        for(v2 = 0; v2 < v8; ++v2) {
            long v3 = this.C[(v2 + 1) % 5] << 1 ^ this.C[(v2 + 1) % 5] >>> 63 ^ this.C[(v2 + 4) % 5];
            for(v0 = 0; v0 < v8; ++v0) {
                int v5 = v0 * 5 + v2;
                arg10[v5] ^= v3;
            }
        }
    }

    public void update(byte arg5) {
        this.oneByte[0] = arg5;
        this.doUpdate(this.oneByte, 0, 8);
    }

    public void update(byte[] arg5, int arg6, int arg7) {
        this.doUpdate(arg5, arg6, (((long)arg7)) * 8);
    }
}

