// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.util.Memoable;
import org.bouncycastle.util.MemoableResetException;

public class SHA512tDigest extends LongDigest {
    private long H1t;
    private long H2t;
    private long H3t;
    private long H4t;
    private long H5t;
    private long H6t;
    private long H7t;
    private long H8t;
    private final int digestLength;

    public SHA512tDigest(int arg3) {
        super();
        if(arg3 >= 512) {
            throw new IllegalArgumentException("bitLength cannot be >= 512");
        }

        if(arg3 % 8 != 0) {
            throw new IllegalArgumentException("bitLength needs to be a multiple of 8");
        }

        if(arg3 == 384) {
            throw new IllegalArgumentException("bitLength cannot be 384 use SHA384 instead");
        }

        this.digestLength = arg3 / 8;
        this.tIvGenerate(this.digestLength * 8);
        this.reset();
    }

    public SHA512tDigest(SHA512tDigest arg2) {
        super(((LongDigest)arg2));
        this.digestLength = arg2.digestLength;
        this.reset(((Memoable)arg2));
    }

    public Memoable copy() {
        return new SHA512tDigest(this);
    }

    public int doFinal(byte[] arg5, int arg6) {
        this.finish();
        SHA512tDigest.longToBigEndian(this.H1, arg5, arg6, this.digestLength);
        SHA512tDigest.longToBigEndian(this.H2, arg5, arg6 + 8, this.digestLength - 8);
        SHA512tDigest.longToBigEndian(this.H3, arg5, arg6 + 16, this.digestLength - 16);
        SHA512tDigest.longToBigEndian(this.H4, arg5, arg6 + 24, this.digestLength - 24);
        SHA512tDigest.longToBigEndian(this.H5, arg5, arg6 + 32, this.digestLength - 32);
        SHA512tDigest.longToBigEndian(this.H6, arg5, arg6 + 40, this.digestLength - 40);
        SHA512tDigest.longToBigEndian(this.H7, arg5, arg6 + 48, this.digestLength - 48);
        SHA512tDigest.longToBigEndian(this.H8, arg5, arg6 + 56, this.digestLength - 56);
        this.reset();
        return this.digestLength;
    }

    public String getAlgorithmName() {
        return "SHA-512/" + Integer.toString(this.digestLength * 8);
    }

    public int getDigestSize() {
        return this.digestLength;
    }

    private static void intToBigEndian(int arg3, byte[] arg4, int arg5, int arg6) {
        int v0 = Math.min(4, arg6);
        while(true) {
            --v0;
            if(v0 < 0) {
                return;
            }

            arg4[arg5 + v0] = ((byte)(arg3 >>> (3 - v0) * 8));
        }
    }

    private static void longToBigEndian(long arg3, byte[] arg5, int arg6, int arg7) {
        if(arg7 > 0) {
            SHA512tDigest.intToBigEndian(((int)(arg3 >>> 32)), arg5, arg6, arg7);
            if(arg7 > 4) {
                SHA512tDigest.intToBigEndian(((int)(4294967295L & arg3)), arg5, arg6 + 4, arg7 - 4);
            }
        }
    }

    public void reset() {
        super.reset();
        this.H1 = this.H1t;
        this.H2 = this.H2t;
        this.H3 = this.H3t;
        this.H4 = this.H4t;
        this.H5 = this.H5t;
        this.H6 = this.H6t;
        this.H7 = this.H7t;
        this.H8 = this.H8t;
    }

    public void reset(Memoable arg3) {
        if(this.digestLength != ((SHA512tDigest)arg3).digestLength) {
            throw new MemoableResetException("digestLength inappropriate in other");
        }

        super.copyIn(((LongDigest)arg3));
        this.H1t = ((SHA512tDigest)arg3).H1t;
        this.H2t = ((SHA512tDigest)arg3).H2t;
        this.H3t = ((SHA512tDigest)arg3).H3t;
        this.H4t = ((SHA512tDigest)arg3).H4t;
        this.H5t = ((SHA512tDigest)arg3).H5t;
        this.H6t = ((SHA512tDigest)arg3).H6t;
        this.H7t = ((SHA512tDigest)arg3).H7t;
        this.H8t = ((SHA512tDigest)arg3).H8t;
    }

    private void tIvGenerate(int arg3) {
        this.H1 = -3482333909917012819L;
        this.H2 = 2216346199247487646L;
        this.H3 = -7364697282686394994L;
        this.H4 = 65953792586715988L;
        this.H5 = -816286391624063116L;
        this.H6 = 4512832404995164602L;
        this.H7 = -5033199132376557362L;
        this.H8 = -124578254951840548L;
        this.update(83);
        this.update(72);
        this.update(65);
        this.update(45);
        this.update(53);
        this.update(49);
        this.update(50);
        this.update(47);
        if(arg3 > 100) {
            this.update(((byte)(arg3 / 100 + 48)));
            int v0 = arg3 % 100;
            this.update(((byte)(v0 / 10 + 48)));
            this.update(((byte)(v0 % 10 + 48)));
        }
        else if(arg3 > 10) {
            this.update(((byte)(arg3 / 10 + 48)));
            this.update(((byte)(arg3 % 10 + 48)));
        }
        else {
            this.update(((byte)(arg3 + 48)));
        }

        this.finish();
        this.H1t = this.H1;
        this.H2t = this.H2;
        this.H3t = this.H3;
        this.H4t = this.H4;
        this.H5t = this.H5;
        this.H6t = this.H6;
        this.H7t = this.H7;
        this.H8t = this.H8;
    }
}

