// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.ExtendedDigest;

public class ShortenedDigest implements ExtendedDigest {
    private ExtendedDigest baseDigest;
    private int length;

    public ShortenedDigest(ExtendedDigest arg3, int arg4) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("baseDigest must not be null");
        }

        if(arg4 > arg3.getDigestSize()) {
            throw new IllegalArgumentException("baseDigest output not large enough to support length");
        }

        this.baseDigest = arg3;
        this.length = arg4;
    }

    public int doFinal(byte[] arg4, int arg5) {
        byte[] v0 = new byte[this.baseDigest.getDigestSize()];
        this.baseDigest.doFinal(v0, 0);
        System.arraycopy(v0, 0, arg4, arg5, this.length);
        return this.length;
    }

    public String getAlgorithmName() {
        return this.baseDigest.getAlgorithmName() + "(" + this.length * 8 + ")";
    }

    public int getByteLength() {
        return this.baseDigest.getByteLength();
    }

    public int getDigestSize() {
        return this.length;
    }

    public void reset() {
        this.baseDigest.reset();
    }

    public void update(byte arg2) {
        this.baseDigest.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.baseDigest.update(arg2, arg3, arg4);
    }
}

