// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.digests;

import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Memoable;

public final class WhirlpoolDigest implements ExtendedDigest, Memoable {
    private static final int BITCOUNT_ARRAY_SIZE = 32;
    private static final int BYTE_LENGTH = 64;
    private static final long[] C0 = null;
    private static final long[] C1 = null;
    private static final long[] C2 = null;
    private static final long[] C3 = null;
    private static final long[] C4 = null;
    private static final long[] C5 = null;
    private static final long[] C6 = null;
    private static final long[] C7 = null;
    private static final int DIGEST_LENGTH_BYTES = 64;
    private static final short[] EIGHT = null;
    private static final int REDUCTION_POLYNOMIAL = 285;
    private static final int ROUNDS = 10;
    private static final int[] SBOX;
    private long[] _K;
    private long[] _L;
    private short[] _bitCount;
    private long[] _block;
    private byte[] _buffer;
    private int _bufferPos;
    private long[] _hash;
    private final long[] _rc;
    private long[] _state;

    static {
        WhirlpoolDigest.SBOX = new int[]{24, 35, 198, 232, 135, 184, 1, 79, 54, 166, 210, 245, 121, 111, 145, 82, 96, 188, 155, 142, 163, 12, 123, 53, 29, 224, 215, 194, 46, 75, 254, 87, 21, 119, 55, 229, 159, 240, 74, 218, 88, 201, 41, 10, 177, 160, 107, 133, 189, 93, 16, 244, 203, 62, 5, 103, 228, 39, 65, 139, 167, 125, 149, 216, 251, 238, 124, 102, 221, 23, 71, 158, 202, 45, 191, 7, 173, 90, 131, 51, 99, 2, 170, 113, 200, 25, 73, 217, 242, 227, 91, 136, 154, 38, 50, 176, 233, 15, 213, 128, 190, 205, 52, 72, 255, 122, 144, 95, 32, 104, 26, 174, 180, 84, 147, 34, 100, 241, 115, 18, 64, 8, 195, 236, 219, 161, 141, 61, 151, 0, 207, 43, 118, 130, 214, 27, 181, 175, 106, 80, 69, 243, 48, 239, 63, 85, 162, 234, 101, 186, 47, 192, 222, 28, 253, 77, 146, 117, 6, 138, 178, 230, 14, 31, 98, 212, 168, 150, 249, 197, 37, 89, 132, 114, 57, 76, 94, 120, 56, 140, 209, 165, 226, 97, 179, 33, 156, 30, 67, 199, 252, 4, 81, 153, 109, 13, 250, 223, 126, 36, 59, 171, 206, 17, 143, 78, 183, 235, 60, 129, 148, 247, 185, 19, 44, 211, 231, 110, 196, 3, 86, 68, 127, 169, 42, 187, 193, 83, 220, 11, 157, 108, 49, 116, 246, 70, 172, 137, 20, 225, 22, 58, 105, 9, 112, 182, 208, 237, 204, 66, 152, 164, 40, 92, 248, 134};
        WhirlpoolDigest.C0 = new long[256];
        WhirlpoolDigest.C1 = new long[256];
        WhirlpoolDigest.C2 = new long[256];
        WhirlpoolDigest.C3 = new long[256];
        WhirlpoolDigest.C4 = new long[256];
        WhirlpoolDigest.C5 = new long[256];
        WhirlpoolDigest.C6 = new long[256];
        WhirlpoolDigest.C7 = new long[256];
        WhirlpoolDigest.EIGHT = new short[32];
        WhirlpoolDigest.EIGHT[31] = 8;
    }

    public WhirlpoolDigest() {
        int v2;
        super();
        this._rc = new long[11];
        this._buffer = new byte[64];
        this._bufferPos = 0;
        this._bitCount = new short[32];
        this._hash = new long[8];
        this._K = new long[8];
        this._L = new long[8];
        this._block = new long[8];
        this._state = new long[8];
        int v19;
        for(v19 = 0; v19 < 256; ++v19) {
            v2 = WhirlpoolDigest.SBOX[v19];
            int v8 = this.maskWithReductionPolynomial(v2 << 1);
            int v4 = this.maskWithReductionPolynomial(v8 << 1);
            int v7 = v4 ^ v2;
            int v6 = this.maskWithReductionPolynomial(v4 << 1);
            int v9 = v6 ^ v2;
            WhirlpoolDigest.C0[v19] = this.packIntoLong(v2, v2, v4, v2, v6, v7, v8, v9);
            WhirlpoolDigest.C1[v19] = this.packIntoLong(v9, v2, v2, v4, v2, v6, v7, v8);
            WhirlpoolDigest.C2[v19] = this.packIntoLong(v8, v9, v2, v2, v4, v2, v6, v7);
            WhirlpoolDigest.C3[v19] = this.packIntoLong(v7, v8, v9, v2, v2, v4, v2, v6);
            WhirlpoolDigest.C4[v19] = this.packIntoLong(v6, v7, v8, v9, v2, v2, v4, v2);
            WhirlpoolDigest.C5[v19] = this.packIntoLong(v2, v6, v7, v8, v9, v2, v2, v4);
            WhirlpoolDigest.C6[v19] = this.packIntoLong(v4, v2, v6, v7, v8, v9, v2, v2);
            WhirlpoolDigest.C7[v19] = this.packIntoLong(v2, v4, v2, v6, v7, v8, v9, v2);
        }

        this._rc[0] = 0;
        int v1;
        for(v1 = 1; v1 <= 10; ++v1) {
            v2 = (v1 - 1) * 8;
            this._rc[v1] = WhirlpoolDigest.C0[v2] & -72057594037927936L ^ WhirlpoolDigest.C1[v2 + 1] & 71776119061217280L ^ WhirlpoolDigest.C2[v2 + 2] & 280375465082880L ^ WhirlpoolDigest.C3[v2 + 3] & 1095216660480L ^ WhirlpoolDigest.C4[v2 + 4] & 4278190080L ^ WhirlpoolDigest.C5[v2 + 5] & 16711680 ^ WhirlpoolDigest.C6[v2 + 6] & 65280 ^ WhirlpoolDigest.C7[v2 + 7] & 255;
        }
    }

    public WhirlpoolDigest(WhirlpoolDigest arg3) {
        super();
        this._rc = new long[11];
        this._buffer = new byte[64];
        this._bufferPos = 0;
        this._bitCount = new short[32];
        this._hash = new long[8];
        this._K = new long[8];
        this._L = new long[8];
        this._block = new long[8];
        this._state = new long[8];
        this.reset(((Memoable)arg3));
    }

    private long bytesToLongFromBuffer(byte[] arg8, int arg9) {
        return ((((long)arg8[arg9])) & 255) << 56 | ((((long)arg8[arg9 + 1])) & 255) << 48 | ((((long)arg8[arg9 + 2])) & 255) << 40 | ((((long)arg8[arg9 + 3])) & 255) << 32 | ((((long)arg8[arg9 + 4])) & 255) << 24 | ((((long)arg8[arg9 + 5])) & 255) << 16 | ((((long)arg8[arg9 + 6])) & 255) << 8 | (((long)arg8[arg9 + 7])) & 255;
    }

    private void convertLongToByteArray(long arg7, byte[] arg9, int arg10) {
        int v0;
        for(v0 = 0; v0 < 8; ++v0) {
            arg9[arg10 + v0] = ((byte)(((int)(arg7 >> 56 - v0 * 8 & 255))));
        }
    }

    public Memoable copy() {
        return new WhirlpoolDigest(this);
    }

    private byte[] copyBitLength() {
        byte[] v1 = new byte[32];
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            v1[v0] = ((byte)(this._bitCount[v0] & 255));
        }

        return v1;
    }

    public int doFinal(byte[] arg5, int arg6) {
        this.finish();
        int v0;
        for(v0 = 0; v0 < 8; ++v0) {
            this.convertLongToByteArray(this._hash[v0], arg5, v0 * 8 + arg6);
        }

        this.reset();
        return this.getDigestSize();
    }

    private void finish() {
        int v5 = 32;
        byte[] v0 = this.copyBitLength();
        byte[] v1 = this._buffer;
        int v2 = this._bufferPos;
        this._bufferPos = v2 + 1;
        v1[v2] = ((byte)(v1[v2] | 128));
        if(this._bufferPos == this._buffer.length) {
            this.processFilledBuffer(this._buffer, 0);
        }

        if(this._bufferPos > v5) {
            while(this._bufferPos != 0) {
                this.update(0);
            }
        }

        while(this._bufferPos <= v5) {
            this.update(0);
        }

        System.arraycopy(v0, 0, this._buffer, v5, v0.length);
        this.processFilledBuffer(this._buffer, 0);
    }

    public String getAlgorithmName() {
        return "Whirlpool";
    }

    public int getByteLength() {
        return 64;
    }

    public int getDigestSize() {
        return 64;
    }

    private void increment() {
        int v1 = 0;
        int v0;
        for(v0 = this._bitCount.length - 1; v0 >= 0; --v0) {
            int v2 = (this._bitCount[v0] & 255) + WhirlpoolDigest.EIGHT[v0] + v1;
            v1 = v2 >>> 8;
            this._bitCount[v0] = ((short)(v2 & 255));
        }
    }

    private int maskWithReductionPolynomial(int arg5) {
        if((((long)arg5)) >= 256) {
            arg5 ^= 285;
        }

        return arg5;
    }

    private long packIntoLong(int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12, int arg13) {
        return (((long)arg6)) << 56 ^ (((long)arg7)) << 48 ^ (((long)arg8)) << 40 ^ (((long)arg9)) << 32 ^ (((long)arg10)) << 24 ^ (((long)arg11)) << 16 ^ (((long)arg12)) << 8 ^ (((long)arg13));
    }

    protected void processBlock() {
        int v13 = 32;
        int v12 = 24;
        int v11 = 16;
        int v10 = 8;
        int v0 = 0;
        int v1;
        for(v1 = 0; v1 < v10; ++v1) {
            long[] v2 = this._state;
            long v3 = this._block[v1];
            long[] v5 = this._K;
            long v6 = this._hash[v1];
            v5[v1] = v6;
            v2[v1] = v3 ^ v6;
        }

        int v2_1;
        for(v2_1 = 1; v2_1 <= 10; ++v2_1) {
            for(v1 = 0; v1 < v10; ++v1) {
                this._L[v1] = 0;
                this._L[v1] ^= WhirlpoolDigest.C0[(((int)(this._K[v1 & 7] >>> 56))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C1[(((int)(this._K[v1 - 1 & 7] >>> 48))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C2[(((int)(this._K[v1 - 2 & 7] >>> 40))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C3[(((int)(this._K[v1 - 3 & 7] >>> v13))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C4[(((int)(this._K[v1 - 4 & 7] >>> v12))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C5[(((int)(this._K[v1 - 5 & 7] >>> v11))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C6[(((int)(this._K[v1 - 6 & 7] >>> v10))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C7[(((int)this._K[v1 - 7 & 7])) & 255];
            }

            System.arraycopy(this._L, 0, this._K, 0, this._K.length);
            this._K[0] ^= this._rc[v2_1];
            for(v1 = 0; v1 < v10; ++v1) {
                this._L[v1] = this._K[v1];
                this._L[v1] ^= WhirlpoolDigest.C0[(((int)(this._state[v1 & 7] >>> 56))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C1[(((int)(this._state[v1 - 1 & 7] >>> 48))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C2[(((int)(this._state[v1 - 2 & 7] >>> 40))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C3[(((int)(this._state[v1 - 3 & 7] >>> v13))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C4[(((int)(this._state[v1 - 4 & 7] >>> v12))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C5[(((int)(this._state[v1 - 5 & 7] >>> v11))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C6[(((int)(this._state[v1 - 6 & 7] >>> v10))) & 255];
                this._L[v1] ^= WhirlpoolDigest.C7[(((int)this._state[v1 - 7 & 7])) & 255];
            }

            System.arraycopy(this._L, 0, this._state, 0, this._state.length);
        }

        while(v0 < v10) {
            this._hash[v0] ^= this._state[v0] ^ this._block[v0];
            ++v0;
        }
    }

    private void processFilledBuffer(byte[] arg6, int arg7) {
        int v0;
        for(v0 = 0; v0 < this._state.length; ++v0) {
            this._block[v0] = this.bytesToLongFromBuffer(this._buffer, v0 * 8);
        }

        this.processBlock();
        this._bufferPos = 0;
        Arrays.fill(this._buffer, 0);
    }

    public void reset(Memoable arg5) {
        System.arraycopy(((WhirlpoolDigest)arg5)._rc, 0, this._rc, 0, this._rc.length);
        System.arraycopy(((WhirlpoolDigest)arg5)._buffer, 0, this._buffer, 0, this._buffer.length);
        this._bufferPos = ((WhirlpoolDigest)arg5)._bufferPos;
        System.arraycopy(((WhirlpoolDigest)arg5)._bitCount, 0, this._bitCount, 0, this._bitCount.length);
        System.arraycopy(((WhirlpoolDigest)arg5)._hash, 0, this._hash, 0, this._hash.length);
        System.arraycopy(((WhirlpoolDigest)arg5)._K, 0, this._K, 0, this._K.length);
        System.arraycopy(((WhirlpoolDigest)arg5)._L, 0, this._L, 0, this._L.length);
        System.arraycopy(((WhirlpoolDigest)arg5)._block, 0, this._block, 0, this._block.length);
        System.arraycopy(((WhirlpoolDigest)arg5)._state, 0, this._state, 0, this._state.length);
    }

    public void reset() {
        this._bufferPos = 0;
        Arrays.fill(this._bitCount, 0);
        Arrays.fill(this._buffer, 0);
        Arrays.fill(this._hash, 0);
        Arrays.fill(this._K, 0);
        Arrays.fill(this._L, 0);
        Arrays.fill(this._block, 0);
        Arrays.fill(this._state, 0);
    }

    public void update(byte arg3) {
        this._buffer[this._bufferPos] = arg3;
        ++this._bufferPos;
        if(this._bufferPos == this._buffer.length) {
            this.processFilledBuffer(this._buffer, 0);
        }

        this.increment();
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        while(arg4 > 0) {
            this.update(arg2[arg3]);
            ++arg3;
            --arg4;
        }
    }
}

