// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.ec;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.math.ec.ECPoint;

public class ECElGamalEncryptor implements ECEncryptor {
    private ECPublicKeyParameters key;
    private SecureRandom random;

    public ECElGamalEncryptor() {
        super();
    }

    public ECPair encrypt(ECPoint arg4) {
        if(this.key == null) {
            throw new IllegalStateException("ECElGamalEncryptor not initialised");
        }

        BigInteger v0 = ECUtil.generateK(this.key.getParameters().getN(), this.random);
        return new ECPair(this.key.getParameters().getG().multiply(v0), this.key.getQ().multiply(v0).add(arg4));
    }

    public void init(CipherParameters arg3) {
        if((arg3 instanceof ParametersWithRandom)) {
            if(!(((ParametersWithRandom)arg3).getParameters() instanceof ECPublicKeyParameters)) {
                throw new IllegalArgumentException("ECPublicKeyParameters are required for encryption.");
            }
            else {
                this.key = ((ParametersWithRandom)arg3).getParameters();
                this.random = ((ParametersWithRandom)arg3).getRandom();
            }
        }
        else if(!(arg3 instanceof ECPublicKeyParameters)) {
            throw new IllegalArgumentException("ECPublicKeyParameters are required for encryption.");
        }
        else {
            this.key = ((ECPublicKeyParameters)arg3);
            this.random = new SecureRandom();
        }
    }
}

