// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.encodings;

import java.math.BigInteger;
import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class ISO9796d1Encoding implements AsymmetricBlockCipher {
    private static final BigInteger SIX;
    private static final BigInteger SIXTEEN;
    private int bitSize;
    private AsymmetricBlockCipher engine;
    private boolean forEncryption;
    private static byte[] inverse;
    private BigInteger modulus;
    private int padBits;
    private static byte[] shadows;

    static {
        ISO9796d1Encoding.SIXTEEN = BigInteger.valueOf(16);
        ISO9796d1Encoding.SIX = BigInteger.valueOf(6);
        ISO9796d1Encoding.shadows = new byte[]{14, 3, 5, 8, 9, 4, 2, 15, 0, 13, 11, 6, 7, 10, 12, 1};
        ISO9796d1Encoding.inverse = new byte[]{8, 15, 6, 1, 5, 2, 11, 12, 3, 4, 13, 10, 14, 9, 0, 7};
    }

    public ISO9796d1Encoding(AsymmetricBlockCipher arg2) {
        super();
        this.padBits = 0;
        this.engine = arg2;
    }

    private static byte[] convertOutputDecryptOnly(BigInteger arg5) {
        byte[] v0;
        byte[] v1 = arg5.toByteArray();
        if(v1[0] == 0) {
            v0 = new byte[v1.length - 1];
            System.arraycopy(v1, 1, v0, 0, v0.length);
        }
        else {
            v0 = v1;
        }

        return v0;
    }

    private byte[] decodeBlock(byte[] arg12, int arg13, int arg14) {
        int v2 = 0;
        byte[] v1 = this.engine.processBlock(arg12, arg13, arg14);
        int v6 = (this.bitSize + 13) / 16;
        BigInteger v0 = new BigInteger(1, v1);
        if(!v0.mod(ISO9796d1Encoding.SIXTEEN).equals(ISO9796d1Encoding.SIX)) {
            if(this.modulus.subtract(v0).mod(ISO9796d1Encoding.SIXTEEN).equals(ISO9796d1Encoding.SIX)) {
                v0 = this.modulus.subtract(v0);
            }
            else {
                goto label_35;
            }
        }

        byte[] v7 = ISO9796d1Encoding.convertOutputDecryptOnly(v0);
        if((v7[v7.length - 1] & 15) != 6) {
            throw new InvalidCipherTextException("invalid forcing byte in block");
        }

        v7[v7.length - 1] = ((byte)((v7[v7.length - 1] & 255) >>> 4 | ISO9796d1Encoding.inverse[(v7[v7.length - 2] & 255) >> 4] << 4));
        v7[0] = ((byte)(ISO9796d1Encoding.shadows[(v7[1] & 255) >>> 4] << 4 | ISO9796d1Encoding.shadows[v7[1] & 15]));
        int v0_1 = v7.length - 1;
        int v1_1 = 0;
        int v3 = 0;
        int v4 = 1;
        while(v0_1 >= v7.length - v6 * 2) {
            int v8 = ISO9796d1Encoding.shadows[(v7[v0_1] & 255) >>> 4] << 4 | ISO9796d1Encoding.shadows[v7[v0_1] & 15];
            if(((v7[v0_1 - 1] ^ v8) & 255) != 0) {
                if(v3 == 0) {
                    v4 = (v7[v0_1 - 1] ^ v8) & 255;
                    v1_1 = v0_1 - 1;
                    v3 = 1;
                }
                else {
                    throw new InvalidCipherTextException("invalid tsums in block");
                }
            }

            v0_1 += -2;
        }

        v7[v1_1] = 0;
        byte[] v0_2 = new byte[(v7.length - v1_1) / 2];
        while(v2 < v0_2.length) {
            v0_2[v2] = v7[v2 * 2 + v1_1 + 1];
            ++v2;
        }

        this.padBits = v4 - 1;
        return v0_2;
    label_35:
        throw new InvalidCipherTextException("resulting integer iS or (modulus - iS) is not congruent to 6 mod 16");
    }

    private byte[] encodeBlock(byte[] arg11, int arg12, int arg13) {
        byte[] v3 = new byte[(this.bitSize + 7) / 8];
        int v4 = this.padBits + 1;
        int v5 = (this.bitSize + 13) / 16;
        int v0;
        for(v0 = 0; v0 < v5; v0 += arg13) {
            if(v0 > v5 - arg13) {
                System.arraycopy(arg11, arg12 + arg13 - (v5 - v0), v3, v3.length - v5, v5 - v0);
            }
            else {
                System.arraycopy(arg11, arg12, v3, v3.length - (v0 + arg13), arg13);
            }
        }

        for(v0 = v3.length - v5 * 2; v0 != v3.length; v0 += 2) {
            byte v6 = v3[v3.length - v5 + v0 / 2];
            v3[v0] = ((byte)(ISO9796d1Encoding.shadows[(v6 & 255) >>> 4] << 4 | ISO9796d1Encoding.shadows[v6 & 15]));
            v3[v0 + 1] = v6;
        }

        v0 = v3.length - arg13 * 2;
        v3[v0] = ((byte)(v4 ^ v3[v0]));
        v3[v3.length - 1] = ((byte)(v3[v3.length - 1] << 4 | 6));
        v0 = 8 - (this.bitSize - 1) % 8;
        if(v0 != 8) {
            v3[0] = ((byte)(v3[0] & 255 >>> v0));
            v3[0] = ((byte)(128 >>> v0 | v3[0]));
            v0 = 0;
        }
        else {
            v3[0] = 0;
            v3[1] = ((byte)(v3[1] | 128));
            v0 = 1;
        }

        return this.engine.processBlock(v3, v0, v3.length - v0);
    }

    public int getInputBlockSize() {
        int v0 = this.engine.getInputBlockSize();
        if(this.forEncryption) {
            v0 = (v0 + 1) / 2;
        }

        return v0;
    }

    public int getOutputBlockSize() {
        int v0 = this.engine.getOutputBlockSize();
        if(!this.forEncryption) {
            v0 = (v0 + 1) / 2;
        }

        return v0;
    }

    public int getPadBits() {
        return this.padBits;
    }

    public AsymmetricBlockCipher getUnderlyingCipher() {
        return this.engine;
    }

    public void init(boolean arg3, CipherParameters arg4) {
        CipherParameters v0 = (arg4 instanceof ParametersWithRandom) ? arg4.getParameters() : arg4;
        this.engine.init(arg3, arg4);
        this.modulus = ((RSAKeyParameters)v0).getModulus();
        this.bitSize = this.modulus.bitLength();
        this.forEncryption = arg3;
    }

    public byte[] processBlock(byte[] arg2, int arg3, int arg4) {
        byte[] v0 = this.forEncryption ? this.encodeBlock(arg2, arg3, arg4) : this.decodeBlock(arg2, arg3, arg4);
        return v0;
    }

    public void setPadBits(int arg3) {
        if(arg3 > 7) {
            throw new IllegalArgumentException("padBits > 7");
        }

        this.padBits = arg3;
    }
}

