// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

public final class CAST6Engine extends CAST5Engine {
    protected static final int BLOCK_SIZE = 16;
    protected static final int ROUNDS = 12;
    protected int[] _Km;
    protected int[] _Kr;
    protected int[] _Tm;
    protected int[] _Tr;
    private int[] _workingKey;

    public CAST6Engine() {
        super();
        this._Kr = new int[48];
        this._Km = new int[48];
        this._Tr = new int[192];
        this._Tm = new int[192];
        this._workingKey = new int[8];
    }

    protected final void CAST_Decipher(int arg10, int arg11, int arg12, int arg13, int[] arg14) {
        int v5;
        int v0 = 0;
        int v1 = arg13;
        int v2 = arg12;
        int v3 = arg11;
        int v4 = arg10;
        while(v0 < 6) {
            v5 = (11 - v0) * 4;
            v2 ^= this.F1(v1, this._Km[v5], this._Kr[v5]);
            v3 ^= this.F2(v2, this._Km[v5 + 1], this._Kr[v5 + 1]);
            v4 ^= this.F3(v3, this._Km[v5 + 2], this._Kr[v5 + 2]);
            v1 ^= this.F1(v4, this._Km[v5 + 3], this._Kr[v5 + 3]);
            ++v0;
        }

        for(v0 = 6; v0 < 12; ++v0) {
            v5 = (11 - v0) * 4;
            v1 ^= this.F1(v4, this._Km[v5 + 3], this._Kr[v5 + 3]);
            v4 ^= this.F3(v3, this._Km[v5 + 2], this._Kr[v5 + 2]);
            v3 ^= this.F2(v2, this._Km[v5 + 1], this._Kr[v5 + 1]);
            v2 ^= this.F1(v1, this._Km[v5], this._Kr[v5]);
        }

        arg14[0] = v4;
        arg14[1] = v3;
        arg14[2] = v2;
        arg14[3] = v1;
    }

    protected final void CAST_Encipher(int arg10, int arg11, int arg12, int arg13, int[] arg14) {
        int v5;
        int v0 = 0;
        int v1 = arg13;
        int v2 = arg12;
        int v3 = arg11;
        int v4 = arg10;
        while(v0 < 6) {
            v5 = v0 * 4;
            v2 ^= this.F1(v1, this._Km[v5], this._Kr[v5]);
            v3 ^= this.F2(v2, this._Km[v5 + 1], this._Kr[v5 + 1]);
            v4 ^= this.F3(v3, this._Km[v5 + 2], this._Kr[v5 + 2]);
            v1 ^= this.F1(v4, this._Km[v5 + 3], this._Kr[v5 + 3]);
            ++v0;
        }

        for(v0 = 6; v0 < 12; ++v0) {
            v5 = v0 * 4;
            v1 ^= this.F1(v4, this._Km[v5 + 3], this._Kr[v5 + 3]);
            v4 ^= this.F3(v3, this._Km[v5 + 2], this._Kr[v5 + 2]);
            v3 ^= this.F2(v2, this._Km[v5 + 1], this._Kr[v5 + 1]);
            v2 ^= this.F1(v1, this._Km[v5], this._Kr[v5]);
        }

        arg14[0] = v4;
        arg14[1] = v3;
        arg14[2] = v2;
        arg14[3] = v1;
    }

    protected int decryptBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        int[] v5 = new int[4];
        this.CAST_Decipher(this.BytesTo32bits(arg7, arg8), this.BytesTo32bits(arg7, arg8 + 4), this.BytesTo32bits(arg7, arg8 + 8), this.BytesTo32bits(arg7, arg8 + 12), v5);
        this.Bits32ToBytes(v5[0], arg9, arg10);
        this.Bits32ToBytes(v5[1], arg9, arg10 + 4);
        this.Bits32ToBytes(v5[2], arg9, arg10 + 8);
        this.Bits32ToBytes(v5[3], arg9, arg10 + 12);
        return 16;
    }

    protected int encryptBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        int[] v5 = new int[4];
        this.CAST_Encipher(this.BytesTo32bits(arg7, arg8), this.BytesTo32bits(arg7, arg8 + 4), this.BytesTo32bits(arg7, arg8 + 8), this.BytesTo32bits(arg7, arg8 + 12), v5);
        this.Bits32ToBytes(v5[0], arg9, arg10);
        this.Bits32ToBytes(v5[1], arg9, arg10 + 4);
        this.Bits32ToBytes(v5[2], arg9, arg10 + 8);
        this.Bits32ToBytes(v5[3], arg9, arg10 + 12);
        return 16;
    }

    public String getAlgorithmName() {
        return "CAST6";
    }

    public int getBlockSize() {
        return 16;
    }

    public void reset() {
    }

    protected void setKey(byte[] arg15) {
        int v13 = 4;
        int v12 = 3;
        int v11 = 2;
        int v2 = 1518500249;
        int v5 = 1859775393;
        int v0 = 19;
        int v6 = 17;
        int v4 = 0;
        while(v4 < 24) {
            int v3 = v2;
            v2 = v0;
            for(v0 = 0; v0 < 8; ++v0) {
                this._Tm[v4 * 8 + v0] = v3;
                v3 += v5;
                this._Tr[v4 * 8 + v0] = v2;
                v2 = v2 + v6 & 31;
            }

            ++v4;
            v0 = v2;
            v2 = v3;
        }

        byte[] v2_1 = new byte[64];
        System.arraycopy(arg15, 0, v2_1, 0, arg15.length);
        for(v0 = 0; v0 < 8; ++v0) {
            this._workingKey[v0] = this.BytesTo32bits(v2_1, v0 * 4);
        }

        for(v0 = 0; v0 < 12; ++v0) {
            v2 = v0 * 2 * 8;
            this._workingKey[6] ^= this.F1(this._workingKey[7], this._Tm[v2], this._Tr[v2]);
            this._workingKey[5] ^= this.F2(this._workingKey[6], this._Tm[v2 + 1], this._Tr[v2 + 1]);
            this._workingKey[v13] ^= this.F3(this._workingKey[5], this._Tm[v2 + 2], this._Tr[v2 + 2]);
            this._workingKey[v12] ^= this.F1(this._workingKey[v13], this._Tm[v2 + 3], this._Tr[v2 + 3]);
            this._workingKey[v11] ^= this.F2(this._workingKey[v12], this._Tm[v2 + 4], this._Tr[v2 + 4]);
            this._workingKey[1] ^= this.F3(this._workingKey[v11], this._Tm[v2 + 5], this._Tr[v2 + 5]);
            this._workingKey[0] ^= this.F1(this._workingKey[1], this._Tm[v2 + 6], this._Tr[v2 + 6]);
            this._workingKey[7] ^= this.F2(this._workingKey[0], this._Tm[v2 + 7], this._Tr[v2 + 7]);
            v2 = (v0 * 2 + 1) * 8;
            this._workingKey[6] ^= this.F1(this._workingKey[7], this._Tm[v2], this._Tr[v2]);
            this._workingKey[5] ^= this.F2(this._workingKey[6], this._Tm[v2 + 1], this._Tr[v2 + 1]);
            this._workingKey[v13] ^= this.F3(this._workingKey[5], this._Tm[v2 + 2], this._Tr[v2 + 2]);
            this._workingKey[v12] ^= this.F1(this._workingKey[v13], this._Tm[v2 + 3], this._Tr[v2 + 3]);
            this._workingKey[v11] ^= this.F2(this._workingKey[v12], this._Tm[v2 + 4], this._Tr[v2 + 4]);
            this._workingKey[1] ^= this.F3(this._workingKey[v11], this._Tm[v2 + 5], this._Tr[v2 + 5]);
            this._workingKey[0] ^= this.F1(this._workingKey[1], this._Tm[v2 + 6], this._Tr[v2 + 6]);
            this._workingKey[7] ^= this.F2(this._workingKey[0], this._Tm[v2 + 7], this._Tr[v2 + 7]);
            this._Kr[v0 * 4] = this._workingKey[0] & 31;
            this._Kr[v0 * 4 + 1] = this._workingKey[v11] & 31;
            this._Kr[v0 * 4 + 2] = this._workingKey[v13] & 31;
            this._Kr[v0 * 4 + 3] = this._workingKey[6] & 31;
            this._Km[v0 * 4] = this._workingKey[7];
            this._Km[v0 * 4 + 1] = this._workingKey[5];
            this._Km[v0 * 4 + 2] = this._workingKey[v12];
            this._Km[v0 * 4 + 3] = this._workingKey[1];
        }
    }
}

