// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.params.KeyParameter;

public class DESedeEngine extends DESEngine {
    protected static final int BLOCK_SIZE = 8;
    private boolean forEncryption;
    private int[] workingKey1;
    private int[] workingKey2;
    private int[] workingKey3;

    public DESedeEngine() {
        super();
        this.workingKey1 = null;
        this.workingKey2 = null;
        this.workingKey3 = null;
    }

    public String getAlgorithmName() {
        return "DESede";
    }

    public int getBlockSize() {
        return 8;
    }

    public void init(boolean arg8, CipherParameters arg9) {
        int v6 = 24;
        int v5 = 16;
        int v4 = 8;
        if(!(arg9 instanceof KeyParameter)) {
            throw new IllegalArgumentException("invalid parameter passed to DESede init - " + arg9.getClass().getName());
        }

        byte[] v2 = ((KeyParameter)arg9).getKey();
        if(v2.length != v6 && v2.length != v5) {
            throw new IllegalArgumentException("key size must be 16 or 24 bytes.");
        }

        this.forEncryption = arg8;
        byte[] v0 = new byte[v4];
        System.arraycopy(v2, 0, v0, 0, v0.length);
        this.workingKey1 = this.generateWorkingKey(arg8, v0);
        byte[] v3 = new byte[v4];
        System.arraycopy(v2, v4, v3, 0, v3.length);
        boolean v0_1 = !arg8 ? true : false;
        this.workingKey2 = this.generateWorkingKey(v0_1, v3);
        if(v2.length == v6) {
            v0 = new byte[v4];
            System.arraycopy(v2, v5, v0, 0, v0.length);
            this.workingKey3 = this.generateWorkingKey(arg8, v0);
        }
        else {
            this.workingKey3 = this.workingKey1;
        }
    }

    public int processBlock(byte[] arg10, int arg11, byte[] arg12, int arg13) {
        int v8 = 8;
        if(this.workingKey1 == null) {
            throw new IllegalStateException("DESede engine not initialised");
        }

        if(arg11 + 8 > arg10.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg13 + 8 > arg12.length) {
            throw new OutputLengthException("output buffer too short");
        }

        byte[] v4 = new byte[v8];
        if(this.forEncryption) {
            this.desFunc(this.workingKey1, arg10, arg11, v4, 0);
            this.desFunc(this.workingKey2, v4, 0, v4, 0);
            this.desFunc(this.workingKey3, v4, 0, arg12, arg13);
        }
        else {
            this.desFunc(this.workingKey3, arg10, arg11, v4, 0);
            this.desFunc(this.workingKey2, v4, 0, v4, 0);
            this.desFunc(this.workingKey1, v4, 0, arg12, arg13);
        }

        return v8;
    }

    public void reset() {
    }
}

