// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import org.bouncycastle.crypto.BasicAgreement;
import org.bouncycastle.crypto.BufferedBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.EphemeralKeyPair;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.KeyParser;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.generators.EphemeralKeyPairGenerator;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.IESParameters;
import org.bouncycastle.crypto.params.KDFParameters;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.BigIntegers;

public class IESEngine {
    byte[] V;
    BasicAgreement agree;
    BufferedBlockCipher cipher;
    boolean forEncryption;
    DerivationFunction kdf;
    private EphemeralKeyPairGenerator keyPairGenerator;
    private KeyParser keyParser;
    Mac mac;
    byte[] macBuf;
    IESParameters param;
    CipherParameters privParam;
    CipherParameters pubParam;

    public IESEngine(BasicAgreement arg2, DerivationFunction arg3, Mac arg4) {
        super();
        this.agree = arg2;
        this.kdf = arg3;
        this.mac = arg4;
        this.macBuf = new byte[arg4.getMacSize()];
        this.cipher = null;
    }

    public IESEngine(BasicAgreement arg2, DerivationFunction arg3, Mac arg4, BufferedBlockCipher arg5) {
        super();
        this.agree = arg2;
        this.kdf = arg3;
        this.mac = arg4;
        this.macBuf = new byte[arg4.getMacSize()];
        this.cipher = arg5;
    }

    private byte[] decryptBlock(byte[] arg12, int arg13, int arg14) {
        byte[] v6;
        byte[] v4;
        byte[] v0;
        byte[] v1;
        byte[] v2;
        if(this.cipher == null) {
            v2 = new byte[arg14 - this.V.length - this.mac.getMacSize()];
            v1 = new byte[this.param.getMacKeySize() / 8];
            v0 = new byte[v2.length + v1.length];
            this.kdf.generateBytes(v0, 0, v0.length);
            if(this.V.length != 0) {
                System.arraycopy(v0, 0, v1, 0, v1.length);
                System.arraycopy(v0, v1.length, v2, 0, v2.length);
            }
            else {
                System.arraycopy(v0, 0, v2, 0, v2.length);
                System.arraycopy(v0, v2.length, v1, 0, v1.length);
            }

            v4 = new byte[v2.length];
            int v0_1;
            for(v0_1 = 0; v0_1 != v2.length; ++v0_1) {
                v4[v0_1] = ((byte)(arg12[this.V.length + arg13 + v0_1] ^ v2[v0_1]));
            }

            v0_1 = v2.length;
        }
        else {
            v0 = new byte[this.param.getCipherKeySize() / 8];
            v6 = new byte[this.param.getMacKeySize() / 8];
            v1 = new byte[v0.length + v6.length];
            this.kdf.generateBytes(v1, 0, v1.length);
            System.arraycopy(v1, 0, v0, 0, v0.length);
            System.arraycopy(v1, v0.length, v6, 0, v6.length);
            this.cipher.init(false, new KeyParameter(v0));
            v4 = new byte[this.cipher.getOutputSize(arg14 - this.V.length - this.mac.getMacSize())];
            v0_1 = this.cipher.processBytes(arg12, arg13 + this.V.length, arg14 - this.V.length - this.mac.getMacSize(), v4, 0);
            v0_1 += this.cipher.doFinal(v4, v0_1);
            v1 = v6;
        }

        v2 = this.param.getEncodingV();
        byte[] v3 = new byte[4];
        if(this.V.length != 0 && v2 != null) {
            Pack.intToBigEndian(v2.length * 8, v3, 0);
        }

        int v6_1 = arg13 + arg14;
        v6 = Arrays.copyOfRange(arg12, v6_1 - this.mac.getMacSize(), v6_1);
        byte[] v7 = new byte[v6.length];
        this.mac.init(new KeyParameter(v1));
        this.mac.update(arg12, this.V.length + arg13, arg14 - this.V.length - v7.length);
        if(v2 != null) {
            this.mac.update(v2, 0, v2.length);
        }

        if(this.V.length != 0) {
            this.mac.update(v3, 0, v3.length);
        }

        this.mac.doFinal(v7, 0);
        if(!Arrays.constantTimeAreEqual(v6, v7)) {
            throw new InvalidCipherTextException("Invalid MAC.");
        }

        return Arrays.copyOfRange(v4, 0, v0_1);
    }

    private byte[] encryptBlock(byte[] arg9, int arg10, int arg11) {
        byte[] v4;
        byte[] v1;
        byte[] v0;
        byte[] v2;
        if(this.cipher == null) {
            v2 = new byte[arg11];
            v0 = new byte[this.param.getMacKeySize() / 8];
            v1 = new byte[v2.length + v0.length];
            this.kdf.generateBytes(v1, 0, v1.length);
            if(this.V.length != 0) {
                System.arraycopy(v1, 0, v0, 0, v0.length);
                System.arraycopy(v1, v0.length, v2, 0, v2.length);
            }
            else {
                System.arraycopy(v1, 0, v2, 0, v2.length);
                System.arraycopy(v1, arg11, v0, 0, v0.length);
            }

            v4 = new byte[arg11];
            int v1_1;
            for(v1_1 = 0; v1_1 != arg11; ++v1_1) {
                v4[v1_1] = ((byte)(arg9[arg10 + v1_1] ^ v2[v1_1]));
            }
        }
        else {
            v0 = new byte[this.param.getCipherKeySize() / 8];
            byte[] v6 = new byte[this.param.getMacKeySize() / 8];
            v1 = new byte[v0.length + v6.length];
            this.kdf.generateBytes(v1, 0, v1.length);
            System.arraycopy(v1, 0, v0, 0, v0.length);
            System.arraycopy(v1, v0.length, v6, 0, v6.length);
            this.cipher.init(true, new KeyParameter(v0));
            v4 = new byte[this.cipher.getOutputSize(arg11)];
            int v0_1 = this.cipher.processBytes(arg9, arg10, arg11, v4, 0);
            arg11 = v0_1 + this.cipher.doFinal(v4, v0_1);
            v0 = v6;
        }

        v1 = this.param.getEncodingV();
        v2 = new byte[4];
        if(this.V.length != 0 && v1 != null) {
            Pack.intToBigEndian(v1.length * 8, v2, 0);
        }

        byte[] v3 = new byte[this.mac.getMacSize()];
        this.mac.init(new KeyParameter(v0));
        this.mac.update(v4, 0, v4.length);
        if(v1 != null) {
            this.mac.update(v1, 0, v1.length);
        }

        if(this.V.length != 0) {
            this.mac.update(v2, 0, v2.length);
        }

        this.mac.doFinal(v3, 0);
        v0 = new byte[this.V.length + arg11 + v3.length];
        System.arraycopy(this.V, 0, v0, 0, this.V.length);
        System.arraycopy(v4, 0, v0, this.V.length, arg11);
        System.arraycopy(v3, 0, v0, this.V.length + arg11, v3.length);
        return v0;
    }

    public BufferedBlockCipher getCipher() {
        return this.cipher;
    }

    public Mac getMac() {
        return this.mac;
    }

    public void init(AsymmetricKeyParameter arg2, CipherParameters arg3, KeyParser arg4) {
        this.forEncryption = false;
        this.privParam = ((CipherParameters)arg2);
        this.param = ((IESParameters)arg3);
        this.keyParser = arg4;
    }

    public void init(AsymmetricKeyParameter arg2, CipherParameters arg3, EphemeralKeyPairGenerator arg4) {
        this.forEncryption = true;
        this.pubParam = ((CipherParameters)arg2);
        this.param = ((IESParameters)arg3);
        this.keyPairGenerator = arg4;
    }

    public void init(boolean arg2, CipherParameters arg3, CipherParameters arg4, CipherParameters arg5) {
        this.forEncryption = arg2;
        this.privParam = arg3;
        this.pubParam = arg4;
        this.param = ((IESParameters)arg5);
        this.V = new byte[0];
    }

    public byte[] processBlock(byte[] arg6, int arg7, int arg8) {
        byte[] v0_3;
        if(this.forEncryption) {
            if(this.keyPairGenerator != null) {
                EphemeralKeyPair v0 = this.keyPairGenerator.generate();
                this.privParam = v0.getKeyPair().getPrivate();
                this.V = v0.getEncodedPublicKey();
            }
        }
        else if(this.keyParser != null) {
            ByteArrayInputStream v0_1 = new ByteArrayInputStream(arg6, arg7, arg8);
            try {
                this.pubParam = this.keyParser.readKey(((InputStream)v0_1));
            }
            catch(IOException v0_2) {
                throw new InvalidCipherTextException("unable to recover ephemeral public key: " + v0_2.getMessage(), ((Throwable)v0_2));
            }

            this.V = Arrays.copyOfRange(arg6, arg7, arg8 - v0_1.available() + arg7);
        }

        this.agree.init(this.privParam);
        byte[] v1 = BigIntegers.asUnsignedByteArray(this.agree.getFieldSize(), this.agree.calculateAgreement(this.pubParam));
        if(this.V.length != 0) {
            v0_3 = new byte[this.V.length + v1.length];
            System.arraycopy(this.V, 0, v0_3, 0, this.V.length);
            System.arraycopy(v1, 0, v0_3, this.V.length, v1.length);
        }
        else {
            v0_3 = v1;
        }

        this.kdf.init(new KDFParameters(v0_3, this.param.getDerivationV()));
        return this.forEncryption ? this.encryptBlock(arg6, arg7, arg8) : this.decryptBlock(arg6, arg7, arg8);
    }
}

