// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;

public class NullEngine implements BlockCipher {
    protected static final int BLOCK_SIZE = 1;
    private boolean initialised;

    public NullEngine() {
        super();
    }

    public String getAlgorithmName() {
        return "Null";
    }

    public int getBlockSize() {
        return 1;
    }

    public void init(boolean arg2, CipherParameters arg3) {
        this.initialised = true;
    }

    public int processBlock(byte[] arg5, int arg6, byte[] arg7, int arg8) {
        if(!this.initialised) {
            throw new IllegalStateException("Null engine not initialised");
        }

        if(arg6 + 1 > arg5.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg8 + 1 > arg7.length) {
            throw new OutputLengthException("output buffer too short");
        }

        int v0;
        for(v0 = 0; v0 < 1; ++v0) {
            arg7[arg8 + v0] = arg5[arg6 + v0];
        }

        return 1;
    }

    public void reset() {
    }
}

