// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.RC2Parameters;

public class RC2Engine implements BlockCipher {
    private static final int BLOCK_SIZE = 8;
    private boolean encrypting;
    private static byte[] piTable;
    private int[] workingKey;

    static {
        RC2Engine.piTable = new byte[]{-39, 120, -7, -60, 25, -35, -75, -19, 40, -23, -3, 121, 74, -96, -40, -99, -58, 126, 55, -125, 43, 118, 83, -114, 98, 76, 100, -120, 68, -117, -5, -94, 23, -102, 89, -11, -121, -77, 79, 19, 97, 69, 109, -115, 9, -127, 125, 50, -67, -113, 64, -21, -122, -73, 123, 11, -16, -107, 33, 34, 92, 107, 78, -126, 84, -42, 101, -109, -50, 96, -78, 28, 115, 86, -64, 20, -89, -116, -15, -36, 18, 117, -54, 31, 59, -66, -28, -47, 66, 61, -44, 48, -93, 60, -74, 38, 111, -65, 14, -38, 70, 105, 7, 87, 39, -14, 29, -101, -68, -108, 67, 3, -8, 17, -57, -10, -112, -17, 62, -25, 6, -61, -43, 47, -56, 102, 30, -41, 8, -24, -22, -34, -128, 82, -18, -9, -124, -86, 114, -84, 53, 77, 106, 42, -106, 26, -46, 113, 90, 21, 73, 116, 75, -97, -48, 94, 4, 24, -92, -20, -62, -32, 65, 110, 15, 81, -53, -52, 36, -111, -81, 80, -95, -12, 112, 57, -103, 124, 58, -123, 35, -72, -76, 122, -4, 2, 54, 91, 37, 85, -105, 49, 45, 93, -6, -104, -29, -118, -110, -82, 5, -33, 41, 16, 103, 108, -70, -55, -45, 0, -26, -49, -31, -98, -88, 44, 99, 22, 1, 63, 88, -30, -119, -87, 13, 56, 52, 27, -85, 51, -1, -80, -69, 72, 12, 95, -71, -79, -51, 46, -59, -13, -37, 71, -27, -91, -100, 119, 10, -90, 32, 104, -2, 127, -63, -83};
    }

    public RC2Engine() {
        super();
    }

    private void decryptBlock(byte[] arg9, int arg10, byte[] arg11, int arg12) {
        int v4 = ((arg9[arg10 + 7] & 255) << 8) + (arg9[arg10 + 6] & 255);
        int v3 = ((arg9[arg10 + 5] & 255) << 8) + (arg9[arg10 + 4] & 255);
        int v2 = ((arg9[arg10 + 3] & 255) << 8) + (arg9[arg10 + 2] & 255);
        int v1 = (arg9[arg10] & 255) + ((arg9[arg10 + 1] & 255) << 8);
        int v0;
        for(v0 = 60; v0 >= 44; v0 += -4) {
            v4 = this.rotateWordLeft(v4, 11) - (((v3 ^ -1) & v1) + (v2 & v3) + this.workingKey[v0 + 3]);
            v3 = this.rotateWordLeft(v3, 13) - (((v2 ^ -1) & v4) + (v1 & v2) + this.workingKey[v0 + 2]);
            v2 = this.rotateWordLeft(v2, 14) - (((v1 ^ -1) & v3) + (v4 & v1) + this.workingKey[v0 + 1]);
            v1 = this.rotateWordLeft(v1, 15) - (((v4 ^ -1) & v2) + (v3 & v4) + this.workingKey[v0]);
        }

        v4 -= this.workingKey[v3 & 63];
        v3 -= this.workingKey[v2 & 63];
        v2 -= this.workingKey[v1 & 63];
        v1 -= this.workingKey[v4 & 63];
        for(v0 = 40; v0 >= 20; v0 += -4) {
            v4 = this.rotateWordLeft(v4, 11) - (((v3 ^ -1) & v1) + (v2 & v3) + this.workingKey[v0 + 3]);
            v3 = this.rotateWordLeft(v3, 13) - (((v2 ^ -1) & v4) + (v1 & v2) + this.workingKey[v0 + 2]);
            v2 = this.rotateWordLeft(v2, 14) - (((v1 ^ -1) & v3) + (v4 & v1) + this.workingKey[v0 + 1]);
            v1 = this.rotateWordLeft(v1, 15) - (((v4 ^ -1) & v2) + (v3 & v4) + this.workingKey[v0]);
        }

        v4 -= this.workingKey[v3 & 63];
        v3 -= this.workingKey[v2 & 63];
        v2 -= this.workingKey[v1 & 63];
        v1 -= this.workingKey[v4 & 63];
        for(v0 = 16; v0 >= 0; v0 += -4) {
            v4 = this.rotateWordLeft(v4, 11) - (((v3 ^ -1) & v1) + (v2 & v3) + this.workingKey[v0 + 3]);
            v3 = this.rotateWordLeft(v3, 13) - (((v2 ^ -1) & v4) + (v1 & v2) + this.workingKey[v0 + 2]);
            v2 = this.rotateWordLeft(v2, 14) - (((v1 ^ -1) & v3) + (v4 & v1) + this.workingKey[v0 + 1]);
            v1 = this.rotateWordLeft(v1, 15) - (((v4 ^ -1) & v2) + (v3 & v4) + this.workingKey[v0]);
        }

        arg11[arg12] = ((byte)v1);
        arg11[arg12 + 1] = ((byte)(v1 >> 8));
        arg11[arg12 + 2] = ((byte)v2);
        arg11[arg12 + 3] = ((byte)(v2 >> 8));
        arg11[arg12 + 4] = ((byte)v3);
        arg11[arg12 + 5] = ((byte)(v3 >> 8));
        arg11[arg12 + 6] = ((byte)v4);
        arg11[arg12 + 7] = ((byte)(v4 >> 8));
    }

    private void encryptBlock(byte[] arg12, int arg13, byte[] arg14, int arg15) {
        int v10 = 5;
        int v9 = 3;
        int v8 = 2;
        int v4 = ((arg12[arg13 + 7] & 255) << 8) + (arg12[arg13 + 6] & 255);
        int v3 = ((arg12[arg13 + 5] & 255) << 8) + (arg12[arg13 + 4] & 255);
        int v2 = ((arg12[arg13 + 3] & 255) << 8) + (arg12[arg13 + 2] & 255);
        int v1 = (arg12[arg13] & 255) + ((arg12[arg13 + 1] & 255) << 8);
        int v0;
        for(v0 = 0; v0 <= 16; v0 += 4) {
            v1 = this.rotateWordLeft(v1 + ((v4 ^ -1) & v2) + (v3 & v4) + this.workingKey[v0], 1);
            v2 = this.rotateWordLeft(v2 + ((v1 ^ -1) & v3) + (v4 & v1) + this.workingKey[v0 + 1], v8);
            v3 = this.rotateWordLeft(v3 + ((v2 ^ -1) & v4) + (v1 & v2) + this.workingKey[v0 + 2], v9);
            v4 = this.rotateWordLeft(v4 + ((v3 ^ -1) & v1) + (v2 & v3) + this.workingKey[v0 + 3], v10);
        }

        v1 += this.workingKey[v4 & 63];
        v2 += this.workingKey[v1 & 63];
        v3 += this.workingKey[v2 & 63];
        v4 += this.workingKey[v3 & 63];
        for(v0 = 20; v0 <= 40; v0 += 4) {
            v1 = this.rotateWordLeft(v1 + ((v4 ^ -1) & v2) + (v3 & v4) + this.workingKey[v0], 1);
            v2 = this.rotateWordLeft(v2 + ((v1 ^ -1) & v3) + (v4 & v1) + this.workingKey[v0 + 1], v8);
            v3 = this.rotateWordLeft(v3 + ((v2 ^ -1) & v4) + (v1 & v2) + this.workingKey[v0 + 2], v9);
            v4 = this.rotateWordLeft(v4 + ((v3 ^ -1) & v1) + (v2 & v3) + this.workingKey[v0 + 3], v10);
        }

        v1 += this.workingKey[v4 & 63];
        v2 += this.workingKey[v1 & 63];
        v3 += this.workingKey[v2 & 63];
        v4 += this.workingKey[v3 & 63];
        for(v0 = 44; v0 < 64; v0 += 4) {
            v1 = this.rotateWordLeft(v1 + ((v4 ^ -1) & v2) + (v3 & v4) + this.workingKey[v0], 1);
            v2 = this.rotateWordLeft(v2 + ((v1 ^ -1) & v3) + (v4 & v1) + this.workingKey[v0 + 1], v8);
            v3 = this.rotateWordLeft(v3 + ((v2 ^ -1) & v4) + (v1 & v2) + this.workingKey[v0 + 2], v9);
            v4 = this.rotateWordLeft(v4 + ((v3 ^ -1) & v1) + (v2 & v3) + this.workingKey[v0 + 3], v10);
        }

        arg14[arg15] = ((byte)v1);
        arg14[arg15 + 1] = ((byte)(v1 >> 8));
        arg14[arg15 + 2] = ((byte)v2);
        arg14[arg15 + 3] = ((byte)(v2 >> 8));
        arg14[arg15 + 4] = ((byte)v3);
        arg14[arg15 + 5] = ((byte)(v3 >> 8));
        arg14[arg15 + 6] = ((byte)v4);
        arg14[arg15 + 7] = ((byte)(v4 >> 8));
    }

    private int[] generateWorkingKey(byte[] arg9, int arg10) {
        int v2;
        int v3;
        int v7 = 128;
        int v1 = 0;
        int[] v5 = new int[v7];
        int v0;
        for(v0 = 0; v0 != arg9.length; ++v0) {
            v5[v0] = arg9[v0] & 255;
        }

        v0 = arg9.length;
        if(v0 < v7) {
            v3 = v0;
            int v4 = v5[v0 - 1];
            v0 = 0;
            while(true) {
                v2 = v0 + 1;
                v4 = RC2Engine.piTable[v5[v0] + v4 & 255] & 255;
                v0 = v3 + 1;
                v5[v3] = v4;
                if(v0 < v7) {
                    v3 = v0;
                    v0 = v2;
                    continue;
                }

                break;
            }
        }

        v3 = arg10 + 7 >> 3;
        v2 = RC2Engine.piTable[v5[128 - v3] & 255 >> (-arg10 & 7)] & 255;
        v5[128 - v3] = v2;
        for(v0 = 128 - v3 - 1; v0 >= 0; --v0) {
            v2 = RC2Engine.piTable[v2 ^ v5[v0 + v3]] & 255;
            v5[v0] = v2;
        }

        int[] v0_1 = new int[64];
        while(v1 != v0_1.length) {
            v0_1[v1] = v5[v1 * 2] + (v5[v1 * 2 + 1] << 8);
            ++v1;
        }

        return v0_1;
    }

    public String getAlgorithmName() {
        return "RC2";
    }

    public int getBlockSize() {
        return 8;
    }

    public void init(boolean arg4, CipherParameters arg5) {
        this.encrypting = arg4;
        if((arg5 instanceof RC2Parameters)) {
            this.workingKey = this.generateWorkingKey(((RC2Parameters)arg5).getKey(), ((RC2Parameters)arg5).getEffectiveKeyBits());
        }
        else if((arg5 instanceof KeyParameter)) {
            byte[] v0 = ((KeyParameter)arg5).getKey();
            this.workingKey = this.generateWorkingKey(v0, v0.length * 8);
        }
        else {
            goto label_16;
        }

        return;
    label_16:
        throw new IllegalArgumentException("invalid parameter passed to RC2 init - " + arg5.getClass().getName());
    }

    public final int processBlock(byte[] arg3, int arg4, byte[] arg5, int arg6) {
        if(this.workingKey == null) {
            throw new IllegalStateException("RC2 engine not initialised");
        }

        if(arg4 + 8 > arg3.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg6 + 8 > arg5.length) {
            throw new OutputLengthException("output buffer too short");
        }

        if(this.encrypting) {
            this.encryptBlock(arg3, arg4, arg5, arg6);
        }
        else {
            this.decryptBlock(arg3, arg4, arg5, arg6);
        }

        return 8;
    }

    public void reset() {
    }

    private int rotateWordLeft(int arg4, int arg5) {
        int v0 = 65535 & arg4;
        return v0 >> 16 - arg5 | v0 << arg5;
    }
}

