// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.StreamCipher;
import org.bouncycastle.crypto.params.KeyParameter;

public class RC4Engine implements StreamCipher {
    private static final int STATE_LENGTH = 256;
    private byte[] engineState;
    private byte[] workingKey;
    private int x;
    private int y;

    public RC4Engine() {
        super();
        this.engineState = null;
        this.x = 0;
        this.y = 0;
        this.workingKey = null;
    }

    public String getAlgorithmName() {
        return "RC4";
    }

    public void init(boolean arg4, CipherParameters arg5) {
        if((arg5 instanceof KeyParameter)) {
            this.workingKey = ((KeyParameter)arg5).getKey();
            this.setKey(this.workingKey);
            return;
        }

        throw new IllegalArgumentException("invalid parameter passed to RC4 init - " + arg5.getClass().getName());
    }

    public void processBytes(byte[] arg8, int arg9, int arg10, byte[] arg11, int arg12) {
        if(arg9 + arg10 > arg8.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg12 + arg10 > arg11.length) {
            throw new OutputLengthException("output buffer too short");
        }

        int v0;
        for(v0 = 0; v0 < arg10; ++v0) {
            this.x = this.x + 1 & 255;
            this.y = this.engineState[this.x] + this.y & 255;
            byte v1 = this.engineState[this.x];
            this.engineState[this.x] = this.engineState[this.y];
            this.engineState[this.y] = v1;
            arg11[v0 + arg12] = ((byte)(arg8[v0 + arg9] ^ this.engineState[this.engineState[this.x] + this.engineState[this.y] & 255]));
        }
    }

    public void reset() {
        this.setKey(this.workingKey);
    }

    public byte returnByte(byte arg6) {
        this.x = this.x + 1 & 255;
        this.y = this.engineState[this.x] + this.y & 255;
        byte v0 = this.engineState[this.x];
        this.engineState[this.x] = this.engineState[this.y];
        this.engineState[this.y] = v0;
        return ((byte)(this.engineState[this.engineState[this.x] + this.engineState[this.y] & 255] ^ arg6));
    }

    private void setKey(byte[] arg8) {
        int v6 = 256;
        int v0 = 0;
        this.workingKey = arg8;
        this.x = 0;
        this.y = 0;
        if(this.engineState == null) {
            this.engineState = new byte[v6];
        }

        int v1;
        for(v1 = 0; v1 < v6; ++v1) {
            this.engineState[v1] = ((byte)v1);
        }

        v1 = 0;
        int v2 = 0;
        while(v0 < v6) {
            v1 = v1 + ((arg8[v2] & 255) + this.engineState[v0]) & 255;
            byte v3 = this.engineState[v0];
            this.engineState[v0] = this.engineState[v1];
            this.engineState[v1] = v3;
            v2 = (v2 + 1) % arg8.length;
            ++v0;
        }
    }
}

