// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.Wrapper;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.util.Arrays;

public class RFC3394WrapEngine implements Wrapper {
    private BlockCipher engine;
    private boolean forWrapping;
    private byte[] iv;
    private KeyParameter param;

    public RFC3394WrapEngine(BlockCipher arg2) {
        super();
        this.iv = new byte[]{-90, -90, -90, -90, -90, -90, -90, -90};
        this.engine = arg2;
    }

    public String getAlgorithmName() {
        return this.engine.getAlgorithmName();
    }

    public void init(boolean arg3, CipherParameters arg4) {
        this.forWrapping = arg3;
        CipherParameters v0 = (arg4 instanceof ParametersWithRandom) ? ((ParametersWithRandom)arg4).getParameters() : arg4;
        if((v0 instanceof KeyParameter)) {
            this.param = ((KeyParameter)v0);
        }
        else if((v0 instanceof ParametersWithIV)) {
            this.iv = v0.getIV();
            this.param = ((ParametersWithIV)v0).getParameters();
            if(this.iv.length != 8) {
                throw new IllegalArgumentException("IV not equal to 8");
            }
        }
    }

    public byte[] unwrap(byte[] arg12, int arg13, int arg14) {
        if(this.forWrapping) {
            throw new IllegalStateException("not set for unwrapping");
        }

        int v0 = arg14 / 8;
        if(v0 * 8 != arg14) {
            throw new InvalidCipherTextException("unwrap data must be a multiple of 8 bytes");
        }

        byte[] v5 = new byte[arg14 - this.iv.length];
        byte[] v6 = new byte[this.iv.length];
        byte[] v7 = new byte[this.iv.length + 8];
        System.arraycopy(arg12, 0, v6, 0, this.iv.length);
        System.arraycopy(arg12, this.iv.length, v5, 0, arg14 - this.iv.length);
        this.engine.init(false, this.param);
        int v3 = v0 - 1;
        int v4;
        for(v4 = 5; v4 >= 0; --v4) {
            int v2;
            for(v2 = v3; v2 >= 1; --v2) {
                System.arraycopy(v6, 0, v7, 0, this.iv.length);
                System.arraycopy(v5, (v2 - 1) * 8, v7, this.iv.length, 8);
                int v1 = v3 * v4 + v2;
                for(v0 = 1; v1 != 0; ++v0) {
                    int v9 = this.iv.length - v0;
                    v7[v9] = ((byte)((((byte)v1)) ^ v7[v9]));
                    v1 >>>= 8;
                }

                this.engine.processBlock(v7, 0, v7, 0);
                System.arraycopy(v7, 0, v6, 0, 8);
                System.arraycopy(v7, 8, v5, (v2 - 1) * 8, 8);
            }
        }

        if(!Arrays.constantTimeAreEqual(v6, this.iv)) {
            throw new InvalidCipherTextException("checksum failed");
        }

        return v5;
    }

    public byte[] wrap(byte[] arg11, int arg12, int arg13) {
        if(!this.forWrapping) {
            throw new IllegalStateException("not set for wrapping");
        }

        int v4 = arg13 / 8;
        if(v4 * 8 != arg13) {
            throw new DataLengthException("wrap data must be a multiple of 8 bytes");
        }

        byte[] v5 = new byte[this.iv.length + arg13];
        byte[] v6 = new byte[this.iv.length + 8];
        System.arraycopy(this.iv, 0, v5, 0, this.iv.length);
        System.arraycopy(arg11, 0, v5, this.iv.length, arg13);
        this.engine.init(true, this.param);
        int v3;
        for(v3 = 0; v3 != 6; ++v3) {
            int v2;
            for(v2 = 1; v2 <= v4; ++v2) {
                System.arraycopy(v5, 0, v6, 0, this.iv.length);
                System.arraycopy(v5, v2 * 8, v6, this.iv.length, 8);
                this.engine.processBlock(v6, 0, v6, 0);
                int v1 = v4 * v3 + v2;
                int v0;
                for(v0 = 1; v1 != 0; ++v0) {
                    int v8 = this.iv.length - v0;
                    v6[v8] = ((byte)((((byte)v1)) ^ v6[v8]));
                    v1 >>>= 8;
                }

                System.arraycopy(v6, 0, v5, 0, 8);
                System.arraycopy(v6, 8, v5, v2 * 8, 8);
            }
        }

        return v5;
    }
}

