// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;
import org.bouncycastle.util.BigIntegers;

public class RSABlindedEngine implements AsymmetricBlockCipher {
    private static BigInteger ONE;
    private RSACoreEngine core;
    private RSAKeyParameters key;
    private SecureRandom random;

    static {
        RSABlindedEngine.ONE = BigInteger.valueOf(1);
    }

    public RSABlindedEngine() {
        super();
        this.core = new RSACoreEngine();
    }

    public int getInputBlockSize() {
        return this.core.getInputBlockSize();
    }

    public int getOutputBlockSize() {
        return this.core.getOutputBlockSize();
    }

    public void init(boolean arg2, CipherParameters arg3) {
        this.core.init(arg2, arg3);
        if((arg3 instanceof ParametersWithRandom)) {
            this.key = ((ParametersWithRandom)arg3).getParameters();
            this.random = ((ParametersWithRandom)arg3).getRandom();
        }
        else {
            this.key = ((RSAKeyParameters)arg3);
            this.random = new SecureRandom();
        }
    }

    public byte[] processBlock(byte[] arg7, int arg8, int arg9) {
        BigInteger v0_1;
        if(this.key == null) {
            throw new IllegalStateException("RSA engine not initialised");
        }

        BigInteger v1 = this.core.convertInput(arg7, arg8, arg9);
        if((this.key instanceof RSAPrivateCrtKeyParameters)) {
            RSAKeyParameters v0 = this.key;
            BigInteger v2 = ((RSAPrivateCrtKeyParameters)v0).getPublicExponent();
            if(v2 != null) {
                v0_1 = ((RSAPrivateCrtKeyParameters)v0).getModulus();
                BigInteger v3 = BigIntegers.createRandomInRange(RSABlindedEngine.ONE, v0_1.subtract(RSABlindedEngine.ONE), this.random);
                v0_1 = this.core.processBlock(v3.modPow(v2, v0_1).multiply(v1).mod(v0_1)).multiply(v3.modInverse(v0_1)).mod(v0_1);
            }
            else {
                v0_1 = this.core.processBlock(v1);
            }
        }
        else {
            v0_1 = this.core.processBlock(v1);
        }

        return this.core.convertOutput(v0_1);
    }
}

