// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import java.math.BigInteger;
import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSABlindingParameters;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class RSABlindingEngine implements AsymmetricBlockCipher {
    private BigInteger blindingFactor;
    private RSACoreEngine core;
    private boolean forEncryption;
    private RSAKeyParameters key;

    public RSABlindingEngine() {
        super();
        this.core = new RSACoreEngine();
    }

    private BigInteger blindMessage(BigInteger arg4) {
        return arg4.multiply(this.blindingFactor.modPow(this.key.getExponent(), this.key.getModulus())).mod(this.key.getModulus());
    }

    public int getInputBlockSize() {
        return this.core.getInputBlockSize();
    }

    public int getOutputBlockSize() {
        return this.core.getOutputBlockSize();
    }

    public void init(boolean arg4, CipherParameters arg5) {
        CipherParameters v0 = (arg5 instanceof ParametersWithRandom) ? ((ParametersWithRandom)arg5).getParameters() : arg5;
        this.core.init(arg4, ((RSABlindingParameters)v0).getPublicKey());
        this.forEncryption = arg4;
        this.key = ((RSABlindingParameters)v0).getPublicKey();
        this.blindingFactor = ((RSABlindingParameters)v0).getBlindingFactor();
    }

    public byte[] processBlock(byte[] arg3, int arg4, int arg5) {
        BigInteger v0 = this.core.convertInput(arg3, arg4, arg5);
        v0 = this.forEncryption ? this.blindMessage(v0) : this.unblindMessage(v0);
        return this.core.convertOutput(v0);
    }

    private BigInteger unblindMessage(BigInteger arg3) {
        BigInteger v0 = this.key.getModulus();
        return arg3.multiply(this.blindingFactor.modInverse(v0)).mod(v0);
    }
}

