// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import java.math.BigInteger;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;

class RSACoreEngine {
    private boolean forEncryption;
    private RSAKeyParameters key;

    RSACoreEngine() {
        super();
    }

    public BigInteger convertInput(byte[] arg3, int arg4, int arg5) {
        if(arg5 > this.getInputBlockSize() + 1) {
            throw new DataLengthException("input too large for RSA cipher.");
        }

        if(arg5 == this.getInputBlockSize() + 1 && !this.forEncryption) {
            throw new DataLengthException("input too large for RSA cipher.");
        }

        if(arg4 != 0 || arg5 != arg3.length) {
            byte[] v0 = new byte[arg5];
            System.arraycopy(arg3, arg4, v0, 0, arg5);
            arg3 = v0;
        }

        BigInteger v0_1 = new BigInteger(1, arg3);
        if(v0_1.compareTo(this.key.getModulus()) >= 0) {
            throw new DataLengthException("input too large for RSA cipher.");
        }

        return v0_1;
    }

    public byte[] convertOutput(BigInteger arg6) {
        byte[] v0;
        byte[] v1 = arg6.toByteArray();
        if(this.forEncryption) {
            if(v1[0] == 0 && v1.length > this.getOutputBlockSize()) {
                v0 = new byte[v1.length - 1];
                System.arraycopy(v1, 1, v0, 0, v0.length);
                return v0;
            }

            if(v1.length >= this.getOutputBlockSize()) {
                goto label_35;
            }

            v0 = new byte[this.getOutputBlockSize()];
            System.arraycopy(v1, 0, v0, v0.length - v1.length, v1.length);
        }
        else {
            if(v1[0] == 0) {
                v0 = new byte[v1.length - 1];
                System.arraycopy(v1, 1, v0, 0, v0.length);
                return v0;
            }

        label_35:
            v0 = v1;
        }

        return v0;
    }

    public int getInputBlockSize() {
        int v0 = this.key.getModulus().bitLength();
        return this.forEncryption ? (v0 + 7) / 8 - 1 : (v0 + 7) / 8;
    }

    public int getOutputBlockSize() {
        int v0 = this.key.getModulus().bitLength();
        return this.forEncryption ? (v0 + 7) / 8 : (v0 + 7) / 8 - 1;
    }

    public void init(boolean arg2, CipherParameters arg3) {
        this.key = (arg3 instanceof ParametersWithRandom) ? ((ParametersWithRandom)arg3).getParameters() : ((RSAKeyParameters)arg3);
        this.forEncryption = arg2;
    }

    public BigInteger processBlock(BigInteger arg7) {
        BigInteger v0_1;
        if((this.key instanceof RSAPrivateCrtKeyParameters)) {
            RSAKeyParameters v0 = this.key;
            BigInteger v1 = ((RSAPrivateCrtKeyParameters)v0).getP();
            BigInteger v2 = ((RSAPrivateCrtKeyParameters)v0).getQ();
            BigInteger v3 = ((RSAPrivateCrtKeyParameters)v0).getDP();
            BigInteger v4 = ((RSAPrivateCrtKeyParameters)v0).getDQ();
            v0_1 = ((RSAPrivateCrtKeyParameters)v0).getQInv();
            v3 = arg7.remainder(v1).modPow(v3, v1);
            v4 = arg7.remainder(v2).modPow(v4, v2);
            v0_1 = v3.subtract(v4).multiply(v0_1).mod(v1).multiply(v2).add(v4);
        }
        else {
            v0_1 = arg7.modPow(this.key.getExponent(), this.key.getModulus());
        }

        return v0_1;
    }
}

