// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.params.KeyParameter;

public class SerpentEngine implements BlockCipher {
    private static final int BLOCK_SIZE = 16;
    static final int PHI = -1640531527;
    static final int ROUNDS = 32;
    private int X0;
    private int X1;
    private int X2;
    private int X3;
    private boolean encrypting;
    private int[] wKey;

    public SerpentEngine() {
        super();
    }

    private void LT() {
        int v0 = this.rotateLeft(this.X0, 13);
        int v1 = this.rotateLeft(this.X2, 3);
        int v2 = this.X1 ^ v0 ^ v1;
        int v3 = this.X3 ^ v1 ^ v0 << 3;
        this.X1 = this.rotateLeft(v2, 1);
        this.X3 = this.rotateLeft(v3, 7);
        this.X0 = this.rotateLeft(v0 ^ this.X1 ^ this.X3, 5);
        this.X2 = this.rotateLeft(this.X3 ^ v1 ^ this.X1 << 7, 22);
    }

    private int bytesToWord(byte[] arg3, int arg4) {
        return (arg3[arg4] & 255) << 24 | (arg3[arg4 + 1] & 255) << 16 | (arg3[arg4 + 2] & 255) << 8 | arg3[arg4 + 3] & 255;
    }

    private void decryptBlock(byte[] arg5, int arg6, byte[] arg7, int arg8) {
        this.X3 = this.wKey[131] ^ this.bytesToWord(arg5, arg6);
        this.X2 = this.wKey[130] ^ this.bytesToWord(arg5, arg6 + 4);
        this.X1 = this.wKey[129] ^ this.bytesToWord(arg5, arg6 + 8);
        this.X0 = this.wKey[128] ^ this.bytesToWord(arg5, arg6 + 12);
        this.ib7(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[124];
        this.X1 ^= this.wKey[125];
        this.X2 ^= this.wKey[126];
        this.X3 ^= this.wKey[127];
        this.inverseLT();
        this.ib6(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[120];
        this.X1 ^= this.wKey[121];
        this.X2 ^= this.wKey[122];
        this.X3 ^= this.wKey[123];
        this.inverseLT();
        this.ib5(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[116];
        this.X1 ^= this.wKey[117];
        this.X2 ^= this.wKey[118];
        this.X3 ^= this.wKey[119];
        this.inverseLT();
        this.ib4(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[112];
        this.X1 ^= this.wKey[113];
        this.X2 ^= this.wKey[114];
        this.X3 ^= this.wKey[115];
        this.inverseLT();
        this.ib3(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[108];
        this.X1 ^= this.wKey[109];
        this.X2 ^= this.wKey[110];
        this.X3 ^= this.wKey[111];
        this.inverseLT();
        this.ib2(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[104];
        this.X1 ^= this.wKey[105];
        this.X2 ^= this.wKey[106];
        this.X3 ^= this.wKey[107];
        this.inverseLT();
        this.ib1(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[100];
        this.X1 ^= this.wKey[101];
        this.X2 ^= this.wKey[102];
        this.X3 ^= this.wKey[103];
        this.inverseLT();
        this.ib0(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[96];
        this.X1 ^= this.wKey[97];
        this.X2 ^= this.wKey[98];
        this.X3 ^= this.wKey[99];
        this.inverseLT();
        this.ib7(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[92];
        this.X1 ^= this.wKey[93];
        this.X2 ^= this.wKey[94];
        this.X3 ^= this.wKey[95];
        this.inverseLT();
        this.ib6(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[88];
        this.X1 ^= this.wKey[89];
        this.X2 ^= this.wKey[90];
        this.X3 ^= this.wKey[91];
        this.inverseLT();
        this.ib5(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[84];
        this.X1 ^= this.wKey[85];
        this.X2 ^= this.wKey[86];
        this.X3 ^= this.wKey[87];
        this.inverseLT();
        this.ib4(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[80];
        this.X1 ^= this.wKey[81];
        this.X2 ^= this.wKey[82];
        this.X3 ^= this.wKey[83];
        this.inverseLT();
        this.ib3(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[76];
        this.X1 ^= this.wKey[77];
        this.X2 ^= this.wKey[78];
        this.X3 ^= this.wKey[79];
        this.inverseLT();
        this.ib2(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[72];
        this.X1 ^= this.wKey[73];
        this.X2 ^= this.wKey[74];
        this.X3 ^= this.wKey[75];
        this.inverseLT();
        this.ib1(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[68];
        this.X1 ^= this.wKey[69];
        this.X2 ^= this.wKey[70];
        this.X3 ^= this.wKey[71];
        this.inverseLT();
        this.ib0(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[64];
        this.X1 ^= this.wKey[65];
        this.X2 ^= this.wKey[66];
        this.X3 ^= this.wKey[67];
        this.inverseLT();
        this.ib7(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[60];
        this.X1 ^= this.wKey[61];
        this.X2 ^= this.wKey[62];
        this.X3 ^= this.wKey[63];
        this.inverseLT();
        this.ib6(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[56];
        this.X1 ^= this.wKey[57];
        this.X2 ^= this.wKey[58];
        this.X3 ^= this.wKey[59];
        this.inverseLT();
        this.ib5(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[52];
        this.X1 ^= this.wKey[53];
        this.X2 ^= this.wKey[54];
        this.X3 ^= this.wKey[55];
        this.inverseLT();
        this.ib4(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[48];
        this.X1 ^= this.wKey[49];
        this.X2 ^= this.wKey[50];
        this.X3 ^= this.wKey[51];
        this.inverseLT();
        this.ib3(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[44];
        this.X1 ^= this.wKey[45];
        this.X2 ^= this.wKey[46];
        this.X3 ^= this.wKey[47];
        this.inverseLT();
        this.ib2(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[40];
        this.X1 ^= this.wKey[41];
        this.X2 ^= this.wKey[42];
        this.X3 ^= this.wKey[43];
        this.inverseLT();
        this.ib1(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[36];
        this.X1 ^= this.wKey[37];
        this.X2 ^= this.wKey[38];
        this.X3 ^= this.wKey[39];
        this.inverseLT();
        this.ib0(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[32];
        this.X1 ^= this.wKey[33];
        this.X2 ^= this.wKey[34];
        this.X3 ^= this.wKey[35];
        this.inverseLT();
        this.ib7(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[28];
        this.X1 ^= this.wKey[29];
        this.X2 ^= this.wKey[30];
        this.X3 ^= this.wKey[31];
        this.inverseLT();
        this.ib6(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[24];
        this.X1 ^= this.wKey[25];
        this.X2 ^= this.wKey[26];
        this.X3 ^= this.wKey[27];
        this.inverseLT();
        this.ib5(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[20];
        this.X1 ^= this.wKey[21];
        this.X2 ^= this.wKey[22];
        this.X3 ^= this.wKey[23];
        this.inverseLT();
        this.ib4(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[16];
        this.X1 ^= this.wKey[17];
        this.X2 ^= this.wKey[18];
        this.X3 ^= this.wKey[19];
        this.inverseLT();
        this.ib3(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[12];
        this.X1 ^= this.wKey[13];
        this.X2 ^= this.wKey[14];
        this.X3 ^= this.wKey[15];
        this.inverseLT();
        this.ib2(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[8];
        this.X1 ^= this.wKey[9];
        this.X2 ^= this.wKey[10];
        this.X3 ^= this.wKey[11];
        this.inverseLT();
        this.ib1(this.X0, this.X1, this.X2, this.X3);
        this.X0 ^= this.wKey[4];
        this.X1 ^= this.wKey[5];
        this.X2 ^= this.wKey[6];
        this.X3 ^= this.wKey[7];
        this.inverseLT();
        this.ib0(this.X0, this.X1, this.X2, this.X3);
        this.wordToBytes(this.X3 ^ this.wKey[3], arg7, arg8);
        this.wordToBytes(this.X2 ^ this.wKey[2], arg7, arg8 + 4);
        this.wordToBytes(this.X1 ^ this.wKey[1], arg7, arg8 + 8);
        this.wordToBytes(this.X0 ^ this.wKey[0], arg7, arg8 + 12);
    }

    private void encryptBlock(byte[] arg6, int arg7, byte[] arg8, int arg9) {
        this.X3 = this.bytesToWord(arg6, arg7);
        this.X2 = this.bytesToWord(arg6, arg7 + 4);
        this.X1 = this.bytesToWord(arg6, arg7 + 8);
        this.X0 = this.bytesToWord(arg6, arg7 + 12);
        this.sb0(this.wKey[0] ^ this.X0, this.wKey[1] ^ this.X1, this.wKey[2] ^ this.X2, this.wKey[3] ^ this.X3);
        this.LT();
        this.sb1(this.wKey[4] ^ this.X0, this.wKey[5] ^ this.X1, this.wKey[6] ^ this.X2, this.wKey[7] ^ this.X3);
        this.LT();
        this.sb2(this.wKey[8] ^ this.X0, this.wKey[9] ^ this.X1, this.wKey[10] ^ this.X2, this.wKey[11] ^ this.X3);
        this.LT();
        this.sb3(this.wKey[12] ^ this.X0, this.wKey[13] ^ this.X1, this.wKey[14] ^ this.X2, this.wKey[15] ^ this.X3);
        this.LT();
        this.sb4(this.wKey[16] ^ this.X0, this.wKey[17] ^ this.X1, this.wKey[18] ^ this.X2, this.wKey[19] ^ this.X3);
        this.LT();
        this.sb5(this.wKey[20] ^ this.X0, this.wKey[21] ^ this.X1, this.wKey[22] ^ this.X2, this.wKey[23] ^ this.X3);
        this.LT();
        this.sb6(this.wKey[24] ^ this.X0, this.wKey[25] ^ this.X1, this.wKey[26] ^ this.X2, this.wKey[27] ^ this.X3);
        this.LT();
        this.sb7(this.wKey[28] ^ this.X0, this.wKey[29] ^ this.X1, this.wKey[30] ^ this.X2, this.wKey[31] ^ this.X3);
        this.LT();
        this.sb0(this.wKey[32] ^ this.X0, this.wKey[33] ^ this.X1, this.wKey[34] ^ this.X2, this.wKey[35] ^ this.X3);
        this.LT();
        this.sb1(this.wKey[36] ^ this.X0, this.wKey[37] ^ this.X1, this.wKey[38] ^ this.X2, this.wKey[39] ^ this.X3);
        this.LT();
        this.sb2(this.wKey[40] ^ this.X0, this.wKey[41] ^ this.X1, this.wKey[42] ^ this.X2, this.wKey[43] ^ this.X3);
        this.LT();
        this.sb3(this.wKey[44] ^ this.X0, this.wKey[45] ^ this.X1, this.wKey[46] ^ this.X2, this.wKey[47] ^ this.X3);
        this.LT();
        this.sb4(this.wKey[48] ^ this.X0, this.wKey[49] ^ this.X1, this.wKey[50] ^ this.X2, this.wKey[51] ^ this.X3);
        this.LT();
        this.sb5(this.wKey[52] ^ this.X0, this.wKey[53] ^ this.X1, this.wKey[54] ^ this.X2, this.wKey[55] ^ this.X3);
        this.LT();
        this.sb6(this.wKey[56] ^ this.X0, this.wKey[57] ^ this.X1, this.wKey[58] ^ this.X2, this.wKey[59] ^ this.X3);
        this.LT();
        this.sb7(this.wKey[60] ^ this.X0, this.wKey[61] ^ this.X1, this.wKey[62] ^ this.X2, this.wKey[63] ^ this.X3);
        this.LT();
        this.sb0(this.wKey[64] ^ this.X0, this.wKey[65] ^ this.X1, this.wKey[66] ^ this.X2, this.wKey[67] ^ this.X3);
        this.LT();
        this.sb1(this.wKey[68] ^ this.X0, this.wKey[69] ^ this.X1, this.wKey[70] ^ this.X2, this.wKey[71] ^ this.X3);
        this.LT();
        this.sb2(this.wKey[72] ^ this.X0, this.wKey[73] ^ this.X1, this.wKey[74] ^ this.X2, this.wKey[75] ^ this.X3);
        this.LT();
        this.sb3(this.wKey[76] ^ this.X0, this.wKey[77] ^ this.X1, this.wKey[78] ^ this.X2, this.wKey[79] ^ this.X3);
        this.LT();
        this.sb4(this.wKey[80] ^ this.X0, this.wKey[81] ^ this.X1, this.wKey[82] ^ this.X2, this.wKey[83] ^ this.X3);
        this.LT();
        this.sb5(this.wKey[84] ^ this.X0, this.wKey[85] ^ this.X1, this.wKey[86] ^ this.X2, this.wKey[87] ^ this.X3);
        this.LT();
        this.sb6(this.wKey[88] ^ this.X0, this.wKey[89] ^ this.X1, this.wKey[90] ^ this.X2, this.wKey[91] ^ this.X3);
        this.LT();
        this.sb7(this.wKey[92] ^ this.X0, this.wKey[93] ^ this.X1, this.wKey[94] ^ this.X2, this.wKey[95] ^ this.X3);
        this.LT();
        this.sb0(this.wKey[96] ^ this.X0, this.wKey[97] ^ this.X1, this.wKey[98] ^ this.X2, this.wKey[99] ^ this.X3);
        this.LT();
        this.sb1(this.wKey[100] ^ this.X0, this.wKey[101] ^ this.X1, this.wKey[102] ^ this.X2, this.wKey[103] ^ this.X3);
        this.LT();
        this.sb2(this.wKey[104] ^ this.X0, this.wKey[105] ^ this.X1, this.wKey[106] ^ this.X2, this.wKey[107] ^ this.X3);
        this.LT();
        this.sb3(this.wKey[108] ^ this.X0, this.wKey[109] ^ this.X1, this.wKey[110] ^ this.X2, this.wKey[111] ^ this.X3);
        this.LT();
        this.sb4(this.wKey[112] ^ this.X0, this.wKey[113] ^ this.X1, this.wKey[114] ^ this.X2, this.wKey[115] ^ this.X3);
        this.LT();
        this.sb5(this.wKey[116] ^ this.X0, this.wKey[117] ^ this.X1, this.wKey[118] ^ this.X2, this.wKey[119] ^ this.X3);
        this.LT();
        this.sb6(this.wKey[120] ^ this.X0, this.wKey[121] ^ this.X1, this.wKey[122] ^ this.X2, this.wKey[123] ^ this.X3);
        this.LT();
        this.sb7(this.wKey[124] ^ this.X0, this.wKey[125] ^ this.X1, this.wKey[126] ^ this.X2, this.wKey[127] ^ this.X3);
        this.wordToBytes(this.wKey[131] ^ this.X3, arg8, arg9);
        this.wordToBytes(this.wKey[130] ^ this.X2, arg8, arg9 + 4);
        this.wordToBytes(this.wKey[129] ^ this.X1, arg8, arg9 + 8);
        this.wordToBytes(this.wKey[128] ^ this.X0, arg8, arg9 + 12);
    }

    public String getAlgorithmName() {
        return "Serpent";
    }

    public int getBlockSize() {
        return 16;
    }

    private void ib0(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg6 ^ -1;
        int v1 = arg6 ^ arg7;
        int v2 = (v0 | v1) ^ arg9;
        int v3 = arg8 ^ v2;
        this.X2 = v1 ^ v3;
        v0 ^= v1 & arg9;
        this.X1 = this.X2 & v0 ^ v2;
        this.X3 = arg6 & v2 ^ (this.X1 | v3);
        this.X0 = v0 ^ v3 ^ this.X3;
    }

    private void ib1(int arg5, int arg6, int arg7, int arg8) {
        int v0 = arg6 ^ arg8;
        int v1 = arg6 & v0 ^ arg5;
        int v2 = v0 ^ v1;
        this.X3 = arg7 ^ v2;
        v0 = v0 & v1 ^ arg6;
        this.X1 = v1 ^ (this.X3 | v0);
        v1 = this.X1 ^ -1;
        v0 ^= this.X3;
        this.X0 = v1 ^ v0;
        this.X2 = (v0 | v1) ^ v2;
    }

    private void ib2(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg7 ^ arg9;
        int v2 = arg6 ^ arg8;
        int v3 = arg8 ^ v0;
        this.X0 = arg7 & v3 ^ v2;
        this.X3 = v0 ^ ((v0 ^ -1 | arg6) ^ arg9 | v2);
        v0 = v3 ^ -1;
        int v1 = this.X0 | this.X3;
        this.X1 = v0 ^ v1;
        this.X2 = v0 & arg9 ^ (v1 ^ v2);
    }

    private void ib3(int arg7, int arg8, int arg9, int arg10) {
        int v1 = arg8 ^ arg9;
        int v2 = arg8 & v1 ^ arg7;
        int v4 = arg10 | v2;
        this.X0 = v1 ^ v4;
        v1 = (v1 | v4) ^ arg10;
        this.X2 = arg9 ^ v2 ^ v1;
        int v0 = (arg7 | arg8) ^ v1;
        this.X3 = this.X0 & v0 ^ v2;
        this.X1 = v0 ^ this.X0 ^ this.X3;
    }

    private void ib4(int arg5, int arg6, int arg7, int arg8) {
        int v0 = (arg7 | arg8) & arg5 ^ arg6;
        int v1 = arg5 & v0 ^ arg7;
        this.X1 = arg8 ^ v1;
        int v2 = arg5 ^ -1;
        this.X3 = v1 & this.X1 ^ v0;
        v1 = (this.X1 | v2) ^ arg8;
        this.X0 = this.X3 ^ v1;
        this.X2 = v0 & v1 ^ (this.X1 ^ v2);
    }

    private void ib5(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg8 ^ -1;
        int v1 = arg7 & v0 ^ arg9;
        int v2 = arg6 & v1;
        this.X3 = arg7 ^ v0 ^ v2;
        int v3 = this.X3 | arg7;
        this.X1 = v1 ^ arg6 & v3;
        v1 = arg6 | arg9;
        this.X0 = v0 ^ v3 ^ v1;
        this.X2 = arg7 & v1 ^ (arg6 ^ arg8 | v2);
    }

    private void ib6(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg6 ^ -1;
        int v1 = arg6 ^ arg7;
        int v2 = arg8 ^ v1;
        int v3 = (arg8 | v0) ^ arg9;
        this.X1 = v2 ^ v3;
        v1 ^= v2 & v3;
        this.X3 = v3 ^ (arg7 | v1);
        v3 = this.X3 | arg7;
        this.X0 = v1 ^ v3;
        this.X2 = v0 & arg9 ^ (v2 ^ v3);
    }

    private void ib7(int arg5, int arg6, int arg7, int arg8) {
        int v0 = arg5 & arg6 | arg7;
        int v1 = (arg5 | arg6) & arg8;
        this.X3 = v0 ^ v1;
        v1 ^= arg6;
        this.X1 = (arg8 ^ -1 ^ this.X3 | v1) ^ arg5;
        this.X0 = v1 ^ arg7 ^ (this.X1 | arg8);
        this.X2 = v0 ^ this.X1 ^ (this.X0 ^ this.X3 & arg5);
    }

    public void init(boolean arg4, CipherParameters arg5) {
        if((arg5 instanceof KeyParameter)) {
            this.encrypting = arg4;
            this.wKey = this.makeWorkingKey(((KeyParameter)arg5).getKey());
            return;
        }

        throw new IllegalArgumentException("invalid parameter passed to Serpent init - " + arg5.getClass().getName());
    }

    private void inverseLT() {
        int v0 = this.rotateRight(this.X2, 22) ^ this.X3 ^ this.X1 << 7;
        int v1 = this.rotateRight(this.X0, 5) ^ this.X1 ^ this.X3;
        int v2 = this.rotateRight(this.X3, 7);
        int v3 = this.rotateRight(this.X1, 1);
        this.X3 = v2 ^ v0 ^ v1 << 3;
        this.X1 = v3 ^ v1 ^ v0;
        this.X2 = this.rotateRight(v0, 3);
        this.X0 = this.rotateRight(v1, 13);
    }

    private int[] makeWorkingKey(byte[] arg12) {
        int[] v4_1;
        int v9 = 16;
        int v8 = 11;
        int v1 = 8;
        int[] v5 = new int[v9];
        int v4 = arg12.length - 4;
        int v0;
        for(v0 = 0; v4 > 0; ++v0) {
            v5[v0] = this.bytesToWord(arg12, v4);
            v4 += -4;
        }

        if(v4 == 0) {
            int v3 = v0 + 1;
            v5[v0] = this.bytesToWord(arg12, 0);
            if(v3 < v1) {
                v5[v3] = 1;
            }

            v3 = 132;
            v4_1 = new int[v3];
            v0 = v1;
        }
        else {
            throw new IllegalArgumentException("key must be a multiple of 4 bytes");
        }

        while(v0 < v9) {
            v5[v0] = this.rotateLeft(v5[v0 - 8] ^ v5[v0 - 5] ^ v5[v0 - 3] ^ v5[v0 - 1] ^ -1640531527 ^ v0 - 8, v8);
            ++v0;
        }

        System.arraycopy(v5, v1, v4_1, 0, v1);
        for(v0 = v1; v0 < v3; ++v0) {
            v4_1[v0] = this.rotateLeft(v4_1[v0 - 8] ^ v4_1[v0 - 5] ^ v4_1[v0 - 3] ^ v4_1[v0 - 1] ^ -1640531527 ^ v0, v8);
        }

        this.sb3(v4_1[0], v4_1[1], v4_1[2], v4_1[3]);
        v4_1[0] = this.X0;
        v4_1[1] = this.X1;
        v4_1[2] = this.X2;
        v4_1[3] = this.X3;
        this.sb2(v4_1[4], v4_1[5], v4_1[6], v4_1[7]);
        v4_1[4] = this.X0;
        v4_1[5] = this.X1;
        v4_1[6] = this.X2;
        v4_1[7] = this.X3;
        this.sb1(v4_1[v1], v4_1[9], v4_1[10], v4_1[v8]);
        v4_1[v1] = this.X0;
        v4_1[9] = this.X1;
        v4_1[10] = this.X2;
        v4_1[v8] = this.X3;
        this.sb0(v4_1[12], v4_1[13], v4_1[14], v4_1[15]);
        v4_1[12] = this.X0;
        v4_1[13] = this.X1;
        v4_1[14] = this.X2;
        v4_1[15] = this.X3;
        this.sb7(v4_1[v9], v4_1[17], v4_1[18], v4_1[19]);
        v4_1[v9] = this.X0;
        v4_1[17] = this.X1;
        v4_1[18] = this.X2;
        v4_1[19] = this.X3;
        this.sb6(v4_1[20], v4_1[21], v4_1[22], v4_1[23]);
        v4_1[20] = this.X0;
        v4_1[21] = this.X1;
        v4_1[22] = this.X2;
        v4_1[23] = this.X3;
        this.sb5(v4_1[24], v4_1[25], v4_1[26], v4_1[27]);
        v4_1[24] = this.X0;
        v4_1[25] = this.X1;
        v4_1[26] = this.X2;
        v4_1[27] = this.X3;
        this.sb4(v4_1[28], v4_1[29], v4_1[30], v4_1[31]);
        v4_1[28] = this.X0;
        v4_1[29] = this.X1;
        v4_1[30] = this.X2;
        v4_1[31] = this.X3;
        this.sb3(v4_1[32], v4_1[33], v4_1[34], v4_1[35]);
        v4_1[32] = this.X0;
        v4_1[33] = this.X1;
        v4_1[34] = this.X2;
        v4_1[35] = this.X3;
        this.sb2(v4_1[36], v4_1[37], v4_1[38], v4_1[39]);
        v4_1[36] = this.X0;
        v4_1[37] = this.X1;
        v4_1[38] = this.X2;
        v4_1[39] = this.X3;
        this.sb1(v4_1[40], v4_1[41], v4_1[42], v4_1[43]);
        v4_1[40] = this.X0;
        v4_1[41] = this.X1;
        v4_1[42] = this.X2;
        v4_1[43] = this.X3;
        this.sb0(v4_1[44], v4_1[45], v4_1[46], v4_1[47]);
        v4_1[44] = this.X0;
        v4_1[45] = this.X1;
        v4_1[46] = this.X2;
        v4_1[47] = this.X3;
        this.sb7(v4_1[48], v4_1[49], v4_1[50], v4_1[51]);
        v4_1[48] = this.X0;
        v4_1[49] = this.X1;
        v4_1[50] = this.X2;
        v4_1[51] = this.X3;
        this.sb6(v4_1[52], v4_1[53], v4_1[54], v4_1[55]);
        v4_1[52] = this.X0;
        v4_1[53] = this.X1;
        v4_1[54] = this.X2;
        v4_1[55] = this.X3;
        this.sb5(v4_1[56], v4_1[57], v4_1[58], v4_1[59]);
        v4_1[56] = this.X0;
        v4_1[57] = this.X1;
        v4_1[58] = this.X2;
        v4_1[59] = this.X3;
        this.sb4(v4_1[60], v4_1[61], v4_1[62], v4_1[63]);
        v4_1[60] = this.X0;
        v4_1[61] = this.X1;
        v4_1[62] = this.X2;
        v4_1[63] = this.X3;
        this.sb3(v4_1[64], v4_1[65], v4_1[66], v4_1[67]);
        v4_1[64] = this.X0;
        v4_1[65] = this.X1;
        v4_1[66] = this.X2;
        v4_1[67] = this.X3;
        this.sb2(v4_1[68], v4_1[69], v4_1[70], v4_1[71]);
        v4_1[68] = this.X0;
        v4_1[69] = this.X1;
        v4_1[70] = this.X2;
        v4_1[71] = this.X3;
        this.sb1(v4_1[72], v4_1[73], v4_1[74], v4_1[75]);
        v4_1[72] = this.X0;
        v4_1[73] = this.X1;
        v4_1[74] = this.X2;
        v4_1[75] = this.X3;
        this.sb0(v4_1[76], v4_1[77], v4_1[78], v4_1[79]);
        v4_1[76] = this.X0;
        v4_1[77] = this.X1;
        v4_1[78] = this.X2;
        v4_1[79] = this.X3;
        this.sb7(v4_1[80], v4_1[81], v4_1[82], v4_1[83]);
        v4_1[80] = this.X0;
        v4_1[81] = this.X1;
        v4_1[82] = this.X2;
        v4_1[83] = this.X3;
        this.sb6(v4_1[84], v4_1[85], v4_1[86], v4_1[87]);
        v4_1[84] = this.X0;
        v4_1[85] = this.X1;
        v4_1[86] = this.X2;
        v4_1[87] = this.X3;
        this.sb5(v4_1[88], v4_1[89], v4_1[90], v4_1[91]);
        v4_1[88] = this.X0;
        v4_1[89] = this.X1;
        v4_1[90] = this.X2;
        v4_1[91] = this.X3;
        this.sb4(v4_1[92], v4_1[93], v4_1[94], v4_1[95]);
        v4_1[92] = this.X0;
        v4_1[93] = this.X1;
        v4_1[94] = this.X2;
        v4_1[95] = this.X3;
        this.sb3(v4_1[96], v4_1[97], v4_1[98], v4_1[99]);
        v4_1[96] = this.X0;
        v4_1[97] = this.X1;
        v4_1[98] = this.X2;
        v4_1[99] = this.X3;
        this.sb2(v4_1[100], v4_1[101], v4_1[102], v4_1[103]);
        v4_1[100] = this.X0;
        v4_1[101] = this.X1;
        v4_1[102] = this.X2;
        v4_1[103] = this.X3;
        this.sb1(v4_1[104], v4_1[105], v4_1[106], v4_1[107]);
        v4_1[104] = this.X0;
        v4_1[105] = this.X1;
        v4_1[106] = this.X2;
        v4_1[107] = this.X3;
        this.sb0(v4_1[108], v4_1[109], v4_1[110], v4_1[111]);
        v4_1[108] = this.X0;
        v4_1[109] = this.X1;
        v4_1[110] = this.X2;
        v4_1[111] = this.X3;
        this.sb7(v4_1[112], v4_1[113], v4_1[114], v4_1[115]);
        v4_1[112] = this.X0;
        v4_1[113] = this.X1;
        v4_1[114] = this.X2;
        v4_1[115] = this.X3;
        this.sb6(v4_1[116], v4_1[117], v4_1[118], v4_1[119]);
        v4_1[116] = this.X0;
        v4_1[117] = this.X1;
        v4_1[118] = this.X2;
        v4_1[119] = this.X3;
        this.sb5(v4_1[120], v4_1[121], v4_1[122], v4_1[123]);
        v4_1[120] = this.X0;
        v4_1[121] = this.X1;
        v4_1[122] = this.X2;
        v4_1[123] = this.X3;
        this.sb4(v4_1[124], v4_1[125], v4_1[126], v4_1[127]);
        v4_1[124] = this.X0;
        v4_1[125] = this.X1;
        v4_1[126] = this.X2;
        v4_1[127] = this.X3;
        this.sb3(v4_1[128], v4_1[129], v4_1[130], v4_1[131]);
        v4_1[128] = this.X0;
        v4_1[129] = this.X1;
        v4_1[130] = this.X2;
        v4_1[131] = this.X3;
        return v4_1;
    }

    public final int processBlock(byte[] arg3, int arg4, byte[] arg5, int arg6) {
        if(this.wKey == null) {
            throw new IllegalStateException("Serpent not initialised");
        }

        if(arg4 + 16 > arg3.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg6 + 16 > arg5.length) {
            throw new OutputLengthException("output buffer too short");
        }

        if(this.encrypting) {
            this.encryptBlock(arg3, arg4, arg5, arg6);
        }
        else {
            this.decryptBlock(arg3, arg4, arg5, arg6);
        }

        return 16;
    }

    public void reset() {
    }

    private int rotateLeft(int arg3, int arg4) {
        return arg3 << arg4 | arg3 >>> -arg4;
    }

    private int rotateRight(int arg3, int arg4) {
        return arg3 >>> arg4 | arg3 << -arg4;
    }

    private void sb0(int arg5, int arg6, int arg7, int arg8) {
        int v0 = arg5 ^ arg8;
        int v1 = arg7 ^ v0;
        int v2 = arg6 ^ v1;
        this.X3 = arg5 & arg8 ^ v2;
        v0 = v0 & arg6 ^ arg5;
        this.X2 = v2 ^ (arg7 | v0);
        v2 = this.X3 & (v1 ^ v0);
        this.X1 = v1 ^ -1 ^ v2;
        this.X0 = v0 ^ -1 ^ v2;
    }

    private void sb1(int arg5, int arg6, int arg7, int arg8) {
        int v0 = arg5 ^ -1 ^ arg6;
        int v1 = (arg5 | v0) ^ arg7;
        this.X2 = arg8 ^ v1;
        int v2 = (arg8 | v0) ^ arg6;
        v0 ^= this.X2;
        this.X3 = v1 & v2 ^ v0;
        v2 ^= v1;
        this.X1 = this.X3 ^ v2;
        this.X0 = v0 & v2 ^ v1;
    }

    private void sb2(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg6 ^ -1;
        int v1 = arg7 ^ arg9;
        this.X0 = arg8 & v0 ^ v1;
        int v2 = arg8 ^ v0;
        int v3 = (this.X0 ^ arg8) & arg7;
        this.X3 = v2 ^ v3;
        this.X2 = (v2 | this.X0) & (v3 | arg9) ^ arg6;
        this.X1 = (v0 | arg9) ^ this.X2 ^ (v1 ^ this.X3);
    }

    private void sb3(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg6 ^ arg7;
        int v2 = arg6 | arg9;
        int v3 = arg8 ^ arg9;
        int v1 = arg6 & arg8 | v0 & v2;
        this.X2 = v3 ^ v1;
        v1 ^= v2 ^ arg7;
        this.X0 = v0 ^ v3 & v1;
        v0 = this.X2 & this.X0;
        this.X1 = v1 ^ v0;
        this.X3 = v0 ^ v3 ^ (arg7 | arg9);
    }

    private void sb4(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg6 ^ arg9;
        int v1 = arg9 & v0 ^ arg8;
        int v2 = arg7 | v1;
        this.X3 = v0 ^ v2;
        int v3 = arg7 ^ -1;
        this.X0 = (v0 | v3) ^ v1;
        v0 ^= v3;
        this.X2 = v2 & v0 ^ this.X0 & arg6;
        this.X1 = v0 & this.X2 ^ (v1 ^ arg6);
    }

    private void sb5(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg6 ^ -1;
        int v1 = arg6 ^ arg7;
        int v2 = arg6 ^ arg9;
        this.X0 = arg8 ^ v0 ^ (v1 | v2);
        int v3 = this.X0 & arg9;
        this.X1 = this.X0 ^ v1 ^ v3;
        v0 = (v0 | this.X0) ^ v2;
        this.X2 = (v1 | v3) ^ v0;
        this.X3 = v0 & this.X1 ^ (arg7 ^ v3);
    }

    private void sb6(int arg5, int arg6, int arg7, int arg8) {
        int v1 = arg5 ^ arg8;
        int v2 = arg6 ^ v1;
        int v0 = (arg5 ^ -1 | v1) ^ arg7;
        this.X1 = arg6 ^ v0;
        v1 = (v1 | this.X1) ^ arg8;
        this.X2 = v0 & v1 ^ v2;
        v1 ^= v0;
        this.X0 = this.X2 ^ v1;
        this.X3 = v0 ^ -1 ^ v1 & v2;
    }

    private void sb7(int arg6, int arg7, int arg8, int arg9) {
        int v0 = arg7 ^ arg8;
        int v1 = arg8 & v0 ^ arg9;
        int v2 = arg6 ^ v1;
        this.X1 = (arg9 | v0) & v2 ^ arg7;
        int v3 = this.X1 | v1;
        this.X3 = v0 ^ arg6 & v2;
        v0 = v2 ^ v3;
        this.X2 = v1 ^ this.X3 & v0;
        this.X0 = v0 ^ -1 ^ this.X3 & this.X2;
    }

    private void wordToBytes(int arg3, byte[] arg4, int arg5) {
        arg4[arg5 + 3] = ((byte)arg3);
        arg4[arg5 + 2] = ((byte)(arg3 >>> 8));
        arg4[arg5 + 1] = ((byte)(arg3 >>> 16));
        arg4[arg5] = ((byte)(arg3 >>> 24));
    }
}

