// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.params.KeyParameter;

public class SkipjackEngine implements BlockCipher {
    static final int BLOCK_SIZE = 8;
    private boolean encrypting;
    static short[] ftable;
    private int[] key0;
    private int[] key1;
    private int[] key2;
    private int[] key3;

    static {
        SkipjackEngine.ftable = new short[]{163, 215, 9, 131, 248, 72, 246, 244, 179, 33, 21, 120, 153, 177, 175, 249, 231, 45, 77, 138, 206, 76, 202, 46, 82, 149, 217, 30, 78, 56, 68, 40, 10, 223, 2, 160, 23, 241, 96, 104, 18, 183, 122, 195, 233, 250, 61, 83, 150, 132, 107, 186, 242, 99, 154, 25, 124, 174, 229, 245, 247, 22, 106, 162, 57, 182, 123, 15, 193, 147, 129, 27, 238, 180, 26, 234, 208, 145, 47, 184, 85, 185, 218, 133, 63, 65, 191, 224, 90, 88, 128, 95, 102, 11, 216, 144, 53, 213, 192, 167, 51, 6, 101, 105, 69, 0, 148, 86, 109, 152, 155, 118, 151, 252, 178, 194, 176, 254, 219, 32, 225, 235, 214, 228, 221, 71, 74, 29, 66, 237, 158, 110, 73, 60, 205, 67, 39, 210, 7, 212, 222, 199, 103, 24, 137, 203, 48, 31, 141, 198, 143, 170, 200, 116, 220, 201, 93, 92, 49, 164, 112, 136, 97, 44, 159, 13, 43, 135, 80, 130, 84, 100, 38, 125, 3, 64, 52, 75, 28, 115, 209, 196, 253, 59, 204, 251, 127, 171, 230, 62, 91, 165, 173, 4, 35, 156, 20, 81, 34, 240, 41, 121, 113, 126, 255, 140, 14, 226, 12, 239, 188, 114, 117, 111, 55, 161, 236, 211, 142, 98, 139, 134, 16, 232, 8, 119, 17, 190, 146, 79, 36, 197, 50, 54, 157, 207, 243, 166, 187, 172, 94, 108, 169, 19, 87, 37, 181, 227, 189, 168, 58, 1, 5, 89, 42, 70};
    }

    public SkipjackEngine() {
        super();
    }

    public int decryptBlock(byte[] arg12, int arg13, byte[] arg14, int arg15) {
        int v9 = 8;
        int v4 = (arg12[arg13] << 8) + (arg12[arg13 + 1] & 255);
        int v5 = (arg12[arg13 + 2] << 8) + (arg12[arg13 + 3] & 255);
        int v3 = (arg12[arg13 + 4] << 8) + (arg12[arg13 + 5] & 255);
        int v2 = (arg12[arg13 + 7] & 255) + (arg12[arg13 + 6] << 8);
        int v0 = 31;
        int v8 = 0;
        while(v8 < 2) {
            int v6 = 0;
            while(v6 < v9) {
                int v7 = this.h(v0, v5);
                v5 = v0 + 1 ^ (v3 ^ v7);
                ++v6;
                --v0;
                v3 = v2;
                v2 = v4;
                v4 = v7;
            }

            v6 = v5;
            v5 = v3;
            v3 = v2;
            v2 = v0;
            v0 = 0;
            while(v0 < v9) {
                v4 = v4 ^ v6 ^ v2 + 1;
                v6 = this.h(v2, v6);
                --v2;
                ++v0;
                int v10 = v4;
                v4 = v6;
                v6 = v5;
                v5 = v3;
                v3 = v10;
            }

            ++v8;
            v0 = v2;
            v2 = v3;
            v3 = v5;
            v5 = v6;
        }

        arg14[arg15] = ((byte)(v4 >> 8));
        arg14[arg15 + 1] = ((byte)v4);
        arg14[arg15 + 2] = ((byte)(v5 >> 8));
        arg14[arg15 + 3] = ((byte)v5);
        arg14[arg15 + 4] = ((byte)(v3 >> 8));
        arg14[arg15 + 5] = ((byte)v3);
        arg14[arg15 + 6] = ((byte)(v2 >> 8));
        arg14[arg15 + 7] = ((byte)v2);
        return v9;
    }

    public int encryptBlock(byte[] arg12, int arg13, byte[] arg14, int arg15) {
        int v9 = 8;
        int v5 = (arg12[arg13] << 8) + (arg12[arg13 + 1] & 255);
        int v3 = (arg12[arg13 + 2] << 8) + (arg12[arg13 + 3] & 255);
        int v4 = (arg12[arg13 + 4] << 8) + (arg12[arg13 + 5] & 255);
        int v2 = (arg12[arg13 + 7] & 255) + (arg12[arg13 + 6] << 8);
        int v8 = 0;
        int v0 = 0;
        while(v8 < 2) {
            int v6 = 0;
            while(v6 < v9) {
                v5 = this.g(v0, v5);
                int v7 = v0 + 1 ^ (v2 ^ v5);
                ++v6;
                ++v0;
                v2 = v4;
                v4 = v3;
                v3 = v5;
                v5 = v7;
            }

            v6 = v5;
            v5 = v3;
            v3 = v2;
            v2 = v0;
            v0 = 0;
            while(v0 < v9) {
                v5 = v5 ^ v6 ^ v2 + 1;
                v6 = this.g(v2, v6);
                ++v2;
                ++v0;
                int v10 = v4;
                v4 = v5;
                v5 = v6;
                v6 = v3;
                v3 = v10;
            }

            ++v8;
            v0 = v2;
            v2 = v3;
            v3 = v5;
            v5 = v6;
        }

        arg14[arg15] = ((byte)(v5 >> 8));
        arg14[arg15 + 1] = ((byte)v5);
        arg14[arg15 + 2] = ((byte)(v3 >> 8));
        arg14[arg15 + 3] = ((byte)v3);
        arg14[arg15 + 4] = ((byte)(v4 >> 8));
        arg14[arg15 + 5] = ((byte)v4);
        arg14[arg15 + 6] = ((byte)(v2 >> 8));
        arg14[arg15 + 7] = ((byte)v2);
        return v9;
    }

    private int g(int arg5, int arg6) {
        int v1 = arg6 & 255;
        int v0 = arg6 >> 8 & 255 ^ SkipjackEngine.ftable[this.key0[arg5] ^ v1];
        v1 ^= SkipjackEngine.ftable[this.key1[arg5] ^ v0];
        v0 ^= SkipjackEngine.ftable[this.key2[arg5] ^ v1];
        return (v0 << 8) + (v1 ^ SkipjackEngine.ftable[this.key3[arg5] ^ v0]);
    }

    public String getAlgorithmName() {
        return "SKIPJACK";
    }

    public int getBlockSize() {
        return 8;
    }

    private int h(int arg5, int arg6) {
        int v1 = arg6 >> 8 & 255;
        int v0 = arg6 & 255 ^ SkipjackEngine.ftable[this.key3[arg5] ^ v1];
        v1 ^= SkipjackEngine.ftable[this.key2[arg5] ^ v0];
        v0 ^= SkipjackEngine.ftable[this.key1[arg5] ^ v1];
        return v0 + ((v1 ^ SkipjackEngine.ftable[this.key0[arg5] ^ v0]) << 8);
    }

    public void init(boolean arg6, CipherParameters arg7) {
        int v4 = 32;
        if(!(arg7 instanceof KeyParameter)) {
            throw new IllegalArgumentException("invalid parameter passed to SKIPJACK init - " + arg7.getClass().getName());
        }

        byte[] v1 = ((KeyParameter)arg7).getKey();
        this.encrypting = arg6;
        this.key0 = new int[v4];
        this.key1 = new int[v4];
        this.key2 = new int[v4];
        this.key3 = new int[v4];
        int v0;
        for(v0 = 0; v0 < v4; ++v0) {
            this.key0[v0] = v1[v0 * 4 % 10] & 255;
            this.key1[v0] = v1[(v0 * 4 + 1) % 10] & 255;
            this.key2[v0] = v1[(v0 * 4 + 2) % 10] & 255;
            this.key3[v0] = v1[(v0 * 4 + 3) % 10] & 255;
        }
    }

    public int processBlock(byte[] arg3, int arg4, byte[] arg5, int arg6) {
        if(this.key1 == null) {
            throw new IllegalStateException("SKIPJACK engine not initialised");
        }

        if(arg4 + 8 > arg3.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg6 + 8 > arg5.length) {
            throw new OutputLengthException("output buffer too short");
        }

        if(this.encrypting) {
            this.encryptBlock(arg3, arg4, arg5, arg6);
        }
        else {
            this.decryptBlock(arg3, arg4, arg5, arg6);
        }

        return 8;
    }

    public void reset() {
    }
}

