// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.params.KeyParameter;

public class TEAEngine implements BlockCipher {
    private int _a;
    private int _b;
    private int _c;
    private int _d;
    private boolean _forEncryption;
    private boolean _initialised;
    private static final int block_size = 8;
    private static final int d_sum = -957401312;
    private static final int delta = -1640531527;
    private static final int rounds = 32;

    public TEAEngine() {
        super();
        this._initialised = false;
    }

    private int bytesToInt(byte[] arg4, int arg5) {
        int v0 = arg5 + 1;
        int v2 = v0 + 1;
        return (arg4[v0] & 255) << 16 | arg4[arg5] << 24 | (arg4[v2] & 255) << 8 | arg4[v2 + 1] & 255;
    }

    private int decryptBlock(byte[] arg8, int arg9, byte[] arg10, int arg11) {
        int v3 = this.bytesToInt(arg8, arg9);
        int v2 = this.bytesToInt(arg8, arg9 + 4);
        int v1 = -957401312;
        int v0;
        for(v0 = 0; v0 != 32; ++v0) {
            v2 -= (v3 << 4) + this._c ^ v3 + v1 ^ (v3 >>> 5) + this._d;
            v3 -= (v2 << 4) + this._a ^ v2 + v1 ^ (v2 >>> 5) + this._b;
            v1 += 1640531527;
        }

        this.unpackInt(v3, arg10, arg11);
        this.unpackInt(v2, arg10, arg11 + 4);
        return 8;
    }

    private int encryptBlock(byte[] arg8, int arg9, byte[] arg10, int arg11) {
        int v0 = 0;
        int v3 = this.bytesToInt(arg8, arg9);
        int v2 = this.bytesToInt(arg8, arg9 + 4);
        int v1 = 0;
        while(v0 != 32) {
            v1 -= 1640531527;
            v3 += (v2 << 4) + this._a ^ v2 + v1 ^ (v2 >>> 5) + this._b;
            v2 += (v3 << 4) + this._c ^ v3 + v1 ^ (v3 >>> 5) + this._d;
            ++v0;
        }

        this.unpackInt(v3, arg10, arg11);
        this.unpackInt(v2, arg10, arg11 + 4);
        return 8;
    }

    public String getAlgorithmName() {
        return "TEA";
    }

    public int getBlockSize() {
        return 8;
    }

    public void init(boolean arg4, CipherParameters arg5) {
        if(!(arg5 instanceof KeyParameter)) {
            throw new IllegalArgumentException("invalid parameter passed to TEA init - " + arg5.getClass().getName());
        }

        this._forEncryption = arg4;
        this._initialised = true;
        this.setKey(((KeyParameter)arg5).getKey());
    }

    public int processBlock(byte[] arg4, int arg5, byte[] arg6, int arg7) {
        if(!this._initialised) {
            throw new IllegalStateException(this.getAlgorithmName() + " not initialised");
        }

        if(arg5 + 8 > arg4.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg7 + 8 > arg6.length) {
            throw new OutputLengthException("output buffer too short");
        }

        int v0 = this._forEncryption ? this.encryptBlock(arg4, arg5, arg6, arg7) : this.decryptBlock(arg4, arg5, arg6, arg7);
        return v0;
    }

    public void reset() {
    }

    private void setKey(byte[] arg2) {
        this._a = this.bytesToInt(arg2, 0);
        this._b = this.bytesToInt(arg2, 4);
        this._c = this.bytesToInt(arg2, 8);
        this._d = this.bytesToInt(arg2, 12);
    }

    private void unpackInt(int arg4, byte[] arg5, int arg6) {
        int v0 = arg6 + 1;
        arg5[arg6] = ((byte)(arg4 >>> 24));
        int v1 = v0 + 1;
        arg5[v0] = ((byte)(arg4 >>> 16));
        arg5[v1] = ((byte)(arg4 >>> 8));
        arg5[v1 + 1] = ((byte)arg4);
    }
}

