// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.params.KeyParameter;

public final class TwofishEngine implements BlockCipher {
    private static final int BLOCK_SIZE = 16;
    private static final int GF256_FDBK = 361;
    private static final int GF256_FDBK_2 = 180;
    private static final int GF256_FDBK_4 = 90;
    private static final int INPUT_WHITEN = 0;
    private static final int MAX_KEY_BITS = 256;
    private static final int MAX_ROUNDS = 16;
    private static final int OUTPUT_WHITEN = 4;
    private static final byte[][] P = null;
    private static final int P_00 = 1;
    private static final int P_01 = 0;
    private static final int P_02 = 0;
    private static final int P_03 = 1;
    private static final int P_04 = 1;
    private static final int P_10 = 0;
    private static final int P_11 = 0;
    private static final int P_12 = 1;
    private static final int P_13 = 1;
    private static final int P_14 = 0;
    private static final int P_20 = 1;
    private static final int P_21 = 1;
    private static final int P_22 = 0;
    private static final int P_23 = 0;
    private static final int P_24 = 0;
    private static final int P_30 = 0;
    private static final int P_31 = 1;
    private static final int P_32 = 1;
    private static final int P_33 = 0;
    private static final int P_34 = 1;
    private static final int ROUNDS = 16;
    private static final int ROUND_SUBKEYS = 8;
    private static final int RS_GF_FDBK = 333;
    private static final int SK_BUMP = 16843009;
    private static final int SK_ROTL = 9;
    private static final int SK_STEP = 33686018;
    private static final int TOTAL_SUBKEYS = 40;
    private boolean encrypting;
    private int[] gMDS0;
    private int[] gMDS1;
    private int[] gMDS2;
    private int[] gMDS3;
    private int[] gSBox;
    private int[] gSubKeys;
    private int k64Cnt;
    private byte[] workingKey;

    static {
        TwofishEngine.P = new byte[][]{new byte[]{-87, 103, -77, -24, 4, -3, -93, 118, -102, -110, -128, 120, -28, -35, -47, 56, 13, -58, 53, -104, 24, -9, -20, 108, 67, 117, 55, 38, -6, 19, -108, 72, -14, -48, -117, 48, -124, 84, -33, 35, 25, 91, 61, 89, -13, -82, -94, -126, 99, 1, -125, 46, -39, 81, -101, 124, -90, -21, -91, -66, 22, 12, -29, 97, -64, -116, 58, -11, 115, 44, 37, 11, -69, 78, -119, 107, 83, 106, -76, -15, -31, -26, -67, 69, -30, -12, -74, 102, -52, -107, 3, 86, -44, 28, 30, -41, -5, -61, -114, -75, -23, -49, -65, -70, -22, 119, 57, -81, 51, -55, 98, 113, -127, 121, 9, -83, 36, -51, -7, -40, -27, -59, -71, 77, 68, 8, -122, -25, -95, 29, -86, -19, 6, 112, -78, -46, 65, 123, -96, 17, 49, -62, 39, -112, 32, -10, 96, -1, -106, 92, -79, -85, -98, -100, 82, 27, 95, -109, 10, -17, -111, -123, 73, -18, 45, 79, -113, 59, 71, -121, 109, 70, -42, 62, 105, 100, 42, -50, -53, 47, -4, -105, 5, 122, -84, 127, -43, 26, 75, 14, -89, 90, 40, 20, 63, 41, -120, 60, 76, 2, -72, -38, -80, 23, 85, 31, -118, 125, 87, -57, -115, 116, -73, -60, -97, 114, 126, 21, 34, 18, 88, 7, -103, 52, 110, 80, -34, 104, 101, -68, -37, -8, -56, -88, 43, 64, -36, -2, 50, -92, -54, 16, 33, -16, -45, 93, 15, 0, 111, -99, 54, 66, 74, 94, -63, -32}, new byte[]{117, -13, -58, -12, -37, 123, -5, -56, 74, -45, -26, 107, 69, 125, -24, 75, -42, 50, -40, -3, 55, 113, -15, -31, 48, 15, -8, 27, -121, -6, 6, 63, 94, -70, -82, 91, -118, 0, -68, -99, 109, -63, -79, 14, -128, 93, -46, -43, -96, -124, 7, 20, -75, -112, 44, -93, -78, 115, 76, 84, -110, 116, 54, 81, 56, -80, -67, 90, -4, 96, 98, -106, 108, 66, -9, 16, 124, 40, 39, -116, 19, -107, -100, -57, 36, 70, 59, 112, -54, -29, -123, -53, 17, -48, -109, -72, -90, -125, 32, -1, -97, 119, -61, -52, 3, 111, 8, -65, 64, -25, 43, -30, 121, 12, -86, -126, 65, 58, -22, -71, -28, -102, -92, -105, 126, -38, 122, 23, 102, -108, -95, 29, 61, -16, -34, -77, 11, 114, -89, 28, -17, -47, 83, 62, -113, 51, 38, 95, -20, 118, 42, 73, -127, -120, -18, 33, -60, 26, -21, -39, -59, 57, -103, -51, -83, 49, -117, 1, 24, 35, -35, 31, 78, 45, -7, 72, 79, -14, 101, -114, 120, 92, 88, 25, -115, -27, -104, 87, 103, 127, 5, 100, -81, 99, -74, -2, -11, -73, 60, -91, -50, -23, 104, 68, -32, 77, 67, 105, 41, 46, -84, 21, 89, -88, 10, -98, 110, 71, -33, 52, 53, 106, -49, -36, 34, -55, -64, -101, -119, -44, -19, -85, 18, -94, 13, 82, -69, 2, 47, -87, -41, 97, 30, -76, 80, 4, -10, -62, 22, 37, -122, 86, 85, 9, -66, -111}};
    }

    public TwofishEngine() {
        int v9 = 256;
        super();
        this.encrypting = false;
        this.gMDS0 = new int[v9];
        this.gMDS1 = new int[v9];
        this.gMDS2 = new int[v9];
        this.gMDS3 = new int[v9];
        this.k64Cnt = 0;
        this.workingKey = null;
        int[] v2 = new int[2];
        int[] v3 = new int[2];
        int[] v4 = new int[2];
        int v0;
        for(v0 = 0; v0 < v9; ++v0) {
            int v5 = TwofishEngine.P[0][v0] & 255;
            v2[0] = v5;
            v3[0] = this.Mx_X(v5) & 255;
            v4[0] = this.Mx_Y(v5) & 255;
            v5 = TwofishEngine.P[1][v0] & 255;
            v2[1] = v5;
            v3[1] = this.Mx_X(v5) & 255;
            v4[1] = this.Mx_Y(v5) & 255;
            this.gMDS0[v0] = v2[1] | v3[1] << 8 | v4[1] << 16 | v4[1] << 24;
            this.gMDS1[v0] = v4[0] | v4[0] << 8 | v3[0] << 16 | v2[0] << 24;
            this.gMDS2[v0] = v3[1] | v4[1] << 8 | v2[1] << 16 | v4[1] << 24;
            this.gMDS3[v0] = v3[0] | v2[0] << 8 | v4[0] << 16 | v3[0] << 24;
        }
    }

    private void Bits32ToBytes(int arg3, byte[] arg4, int arg5) {
        arg4[arg5] = ((byte)arg3);
        arg4[arg5 + 1] = ((byte)(arg3 >> 8));
        arg4[arg5 + 2] = ((byte)(arg3 >> 16));
        arg4[arg5 + 3] = ((byte)(arg3 >> 24));
    }

    private int BytesTo32Bits(byte[] arg3, int arg4) {
        return arg3[arg4] & 255 | (arg3[arg4 + 1] & 255) << 8 | (arg3[arg4 + 2] & 255) << 16 | (arg3[arg4 + 3] & 255) << 24;
    }

    private int F32(int arg12, int[] arg13) {
        int v3 = this.b0(arg12);
        int v2 = this.b1(arg12);
        int v1 = this.b2(arg12);
        int v0 = this.b3(arg12);
        int v5 = arg13[0];
        int v6 = arg13[1];
        int v7 = arg13[2];
        int v8 = arg13[3];
        switch(this.k64Cnt & 3) {
            case 0: {
                goto label_53;
            }
            case 1: {
                goto label_17;
            }
            case 2: {
                goto label_101;
            }
            case 3: {
                goto label_77;
            }
        }

        return 0;
    label_53:
        v3 = TwofishEngine.P[1][v3] & 255 ^ this.b0(v8);
        v2 = TwofishEngine.P[0][v2] & 255 ^ this.b1(v8);
        v1 = TwofishEngine.P[0][v1] & 255 ^ this.b2(v8);
        v0 = TwofishEngine.P[1][v0] & 255 ^ this.b3(v8);
        goto label_77;
    label_17:
        return this.gMDS3[TwofishEngine.P[1][v0] & 255 ^ this.b3(v5)] ^ (this.gMDS2[TwofishEngine.P[1][v1] & 255 ^ this.b2(v5)] ^ (this.gMDS1[TwofishEngine.P[0][v2] & 255 ^ this.b1(v5)] ^ this.gMDS0[TwofishEngine.P[0][v3] & 255 ^ this.b0(v5)]));
    label_77:
        v3 = TwofishEngine.P[1][v3] & 255 ^ this.b0(v7);
        v2 = TwofishEngine.P[1][v2] & 255 ^ this.b1(v7);
        v1 = TwofishEngine.P[0][v1] & 255 ^ this.b2(v7);
        v0 = TwofishEngine.P[0][v0] & 255 ^ this.b3(v7);
    label_101:
        return this.gMDS3[TwofishEngine.P[1][TwofishEngine.P[1][v0] & 255 ^ this.b3(v6)] & 255 ^ this.b3(v5)] ^ (this.gMDS2[TwofishEngine.P[1][TwofishEngine.P[0][v1] & 255 ^ this.b2(v6)] & 255 ^ this.b2(v5)] ^ (this.gMDS1[TwofishEngine.P[0][TwofishEngine.P[1][v2] & 255 ^ this.b1(v6)] & 255 ^ this.b1(v5)] ^ this.gMDS0[TwofishEngine.P[0][TwofishEngine.P[0][v3] & 255 ^ this.b0(v6)] & 255 ^ this.b0(v5)]));
    }

    private int Fe32_0(int arg4) {
        return this.gSBox[(arg4 & 255) * 2] ^ this.gSBox[(arg4 >>> 8 & 255) * 2 + 1] ^ this.gSBox[(arg4 >>> 16 & 255) * 2 + 512] ^ this.gSBox[(arg4 >>> 24 & 255) * 2 + 513];
    }

    private int Fe32_3(int arg4) {
        return this.gSBox[(arg4 >>> 24 & 255) * 2] ^ this.gSBox[(arg4 & 255) * 2 + 1] ^ this.gSBox[(arg4 >>> 8 & 255) * 2 + 512] ^ this.gSBox[(arg4 >>> 16 & 255) * 2 + 513];
    }

    private int LFSR1(int arg3) {
        int v1 = arg3 >> 1;
        int v0 = (arg3 & 1) != 0 ? 180 : 0;
        return v0 ^ v1;
    }

    private int LFSR2(int arg4) {
        int v0 = 0;
        int v2 = arg4 >> 2;
        int v1 = (arg4 & 2) != 0 ? 180 : 0;
        v1 ^= v2;
        if((arg4 & 1) != 0) {
            v0 = 90;
        }

        return v0 ^ v1;
    }

    private int Mx_X(int arg2) {
        return this.LFSR2(arg2) ^ arg2;
    }

    private int Mx_Y(int arg3) {
        return this.LFSR1(arg3) ^ arg3 ^ this.LFSR2(arg3);
    }

    private int RS_MDS_Encode(int arg4, int arg5) {
        int v2 = 4;
        int v0 = 0;
        int v1;
        for(v1 = 0; v1 < v2; ++v1) {
            arg5 = this.RS_rem(arg5);
        }

        v1 = arg5 ^ arg4;
        while(v0 < v2) {
            v1 = this.RS_rem(v1);
            ++v0;
        }

        return v1;
    }

    private int RS_rem(int arg6) {
        int v0 = 0;
        int v2 = arg6 >>> 24 & 255;
        int v3 = v2 << 1;
        int v1 = (v2 & 128) != 0 ? 333 : 0;
        v1 = (v1 ^ v3) & 255;
        v3 = v2 >>> 1;
        if((v2 & 1) != 0) {
            v0 = 166;
        }

        v0 = v0 ^ v3 ^ v1;
        return v0 << 8 ^ (v1 << 16 ^ (arg6 << 8 ^ v0 << 24)) ^ v2;
    }

    private int b0(int arg2) {
        return arg2 & 255;
    }

    private int b1(int arg2) {
        return arg2 >>> 8 & 255;
    }

    private int b2(int arg2) {
        return arg2 >>> 16 & 255;
    }

    private int b3(int arg2) {
        return arg2 >>> 24 & 255;
    }

    private void decryptBlock(byte[] arg12, int arg13, byte[] arg14, int arg15) {
        int v5 = this.BytesTo32Bits(arg12, arg13) ^ this.gSubKeys[4];
        int v4 = this.BytesTo32Bits(arg12, arg13 + 4) ^ this.gSubKeys[5];
        int v3 = this.BytesTo32Bits(arg12, arg13 + 8) ^ this.gSubKeys[6];
        int v2 = this.BytesTo32Bits(arg12, arg13 + 12) ^ this.gSubKeys[7];
        int v1 = 39;
        int v0;
        for(v0 = 0; v0 < 16; v0 += 2) {
            int v6 = this.Fe32_0(v5);
            int v7 = this.Fe32_3(v4);
            int v10 = v1 - 1;
            v1 = this.gSubKeys[v1] + (v7 * 2 + v6) ^ v2;
            v2 = v3 << 1 | v3 >>> 31;
            v3 = v6 + v7;
            v7 = v10 - 1;
            v3 = v3 + this.gSubKeys[v10] ^ v2;
            v2 = v1 >>> 1 | v1 << 31;
            v1 = this.Fe32_0(v3);
            v6 = this.Fe32_3(v2);
            v10 = v7 - 1;
            v4 ^= this.gSubKeys[v7] + (v6 * 2 + v1);
            v6 += v1;
            v1 = v10 - 1;
            v5 = (v5 >>> 31 | v5 << 1) ^ v6 + this.gSubKeys[v10];
            v4 = v4 << 31 | v4 >>> 1;
        }

        this.Bits32ToBytes(this.gSubKeys[0] ^ v3, arg14, arg15);
        this.Bits32ToBytes(this.gSubKeys[1] ^ v2, arg14, arg15 + 4);
        this.Bits32ToBytes(this.gSubKeys[2] ^ v5, arg14, arg15 + 8);
        this.Bits32ToBytes(this.gSubKeys[3] ^ v4, arg14, arg15 + 12);
    }

    private void encryptBlock(byte[] arg12, int arg13, byte[] arg14, int arg15) {
        int v0 = 0;
        int v5 = this.BytesTo32Bits(arg12, arg13) ^ this.gSubKeys[0];
        int v4 = this.BytesTo32Bits(arg12, arg13 + 4) ^ this.gSubKeys[1];
        int v3 = this.BytesTo32Bits(arg12, arg13 + 8) ^ this.gSubKeys[2];
        int v2 = this.gSubKeys[3] ^ this.BytesTo32Bits(arg12, arg13 + 12);
        int v1 = 8;
        while(v0 < 16) {
            int v6 = this.Fe32_0(v5);
            int v7 = this.Fe32_3(v4);
            int v10 = v1 + 1;
            v1 = this.gSubKeys[v1] + (v6 + v7) ^ v3;
            v3 = v1 >>> 1 | v1 << 31;
            v1 = v2 << 1 | v2 >>> 31;
            v2 = v7 * 2 + v6;
            v7 = v10 + 1;
            v2 = v2 + this.gSubKeys[v10] ^ v1;
            v1 = this.Fe32_0(v3);
            v6 = this.Fe32_3(v2);
            v10 = v7 + 1;
            v5 ^= this.gSubKeys[v7] + (v1 + v6);
            v5 = v5 << 31 | v5 >>> 1;
            v6 = v6 * 2 + v1;
            v1 = v10 + 1;
            v4 = (v4 >>> 31 | v4 << 1) ^ v6 + this.gSubKeys[v10];
            v0 += 2;
        }

        this.Bits32ToBytes(this.gSubKeys[4] ^ v3, arg14, arg15);
        this.Bits32ToBytes(this.gSubKeys[5] ^ v2, arg14, arg15 + 4);
        this.Bits32ToBytes(this.gSubKeys[6] ^ v5, arg14, arg15 + 8);
        this.Bits32ToBytes(this.gSubKeys[7] ^ v4, arg14, arg15 + 12);
    }

    public String getAlgorithmName() {
        return "Twofish";
    }

    public int getBlockSize() {
        return 16;
    }

    public void init(boolean arg4, CipherParameters arg5) {
        if((arg5 instanceof KeyParameter)) {
            this.encrypting = arg4;
            this.workingKey = ((KeyParameter)arg5).getKey();
            this.k64Cnt = this.workingKey.length / 8;
            this.setKey(this.workingKey);
            return;
        }

        throw new IllegalArgumentException("invalid parameter passed to Twofish init - " + arg5.getClass().getName());
    }

    public int processBlock(byte[] arg3, int arg4, byte[] arg5, int arg6) {
        if(this.workingKey == null) {
            throw new IllegalStateException("Twofish not initialised");
        }

        if(arg4 + 16 > arg3.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg6 + 16 > arg5.length) {
            throw new OutputLengthException("output buffer too short");
        }

        if(this.encrypting) {
            this.encryptBlock(arg3, arg4, arg5, arg6);
        }
        else {
            this.decryptBlock(arg3, arg4, arg5, arg6);
        }

        return 16;
    }

    public void reset() {
        if(this.workingKey != null) {
            this.setKey(this.workingKey);
        }
    }

    private void setKey(byte[] arg18) {
        int v7;
        int v6;
        int[] v3 = new int[4];
        int[] v4 = new int[4];
        int[] v5 = new int[4];
        this.gSubKeys = new int[40];
        if(this.k64Cnt < 1) {
            throw new IllegalArgumentException("Key size less than 64 bits");
        }

        if(this.k64Cnt > 4) {
            throw new IllegalArgumentException("Key size larger than 256 bits");
        }

        int v2;
        for(v2 = 0; v2 < this.k64Cnt; ++v2) {
            v6 = v2 * 8;
            v3[v2] = this.BytesTo32Bits(arg18, v6);
            v4[v2] = this.BytesTo32Bits(arg18, v6 + 4);
            v5[this.k64Cnt - 1 - v2] = this.RS_MDS_Encode(v3[v2], v4[v2]);
        }

        for(v2 = 0; v2 < 20; ++v2) {
            v6 = 33686018 * v2;
            v7 = this.F32(v6, v3);
            v6 = this.F32(v6 + 16843009, v4);
            v6 = v6 >>> 24 | v6 << 8;
            v7 += v6;
            this.gSubKeys[v2 * 2] = v7;
            v6 += v7;
            this.gSubKeys[v2 * 2 + 1] = v6 >>> 23 | v6 << 9;
        }

        v7 = v5[0];
        int v8 = v5[1];
        int v9 = v5[2];
        int v10 = v5[3];
        this.gSBox = new int[1024];
        int v3_1;
        for(v3_1 = 0; v3_1 < 256; ++v3_1) {
            switch(this.k64Cnt & 3) {
                case 0: {
                    goto label_166;
                }
                case 1: {
                    goto label_102;
                }
                case 2: {
                    goto label_332;
                }
                case 3: {
                    goto label_327;
                }
            }

            goto label_100;
        label_327:
            v2 = v3_1;
            int v4_1 = v3_1;
            int v5_1 = v3_1;
            v6 = v3_1;
            goto label_198;
        label_166:
            v6 = TwofishEngine.P[1][v3_1] & 255 ^ this.b0(v10);
            v5_1 = TwofishEngine.P[0][v3_1] & 255 ^ this.b1(v10);
            v4_1 = this.b2(v10) ^ TwofishEngine.P[0][v3_1] & 255;
            v2 = TwofishEngine.P[1][v3_1] & 255 ^ this.b3(v10);
        label_198:
            v6 = TwofishEngine.P[1][v6] & 255 ^ this.b0(v9);
            v5_1 = TwofishEngine.P[1][v5_1] & 255 ^ this.b1(v9);
            v4_1 = TwofishEngine.P[0][v4_1] & 255 ^ this.b2(v9);
            v2 = TwofishEngine.P[0][v2] & 255 ^ this.b3(v9);
            goto label_230;
        label_102:
            this.gSBox[v3_1 * 2] = this.gMDS0[TwofishEngine.P[0][v3_1] & 255 ^ this.b0(v7)];
            this.gSBox[v3_1 * 2 + 1] = this.gMDS1[TwofishEngine.P[0][v3_1] & 255 ^ this.b1(v7)];
            this.gSBox[v3_1 * 2 + 512] = this.gMDS2[TwofishEngine.P[1][v3_1] & 255 ^ this.b2(v7)];
            this.gSBox[v3_1 * 2 + 513] = this.gMDS3[TwofishEngine.P[1][v3_1] & 255 ^ this.b3(v7)];
            goto label_100;
        label_332:
            v2 = v3_1;
            v4_1 = v3_1;
            v5_1 = v3_1;
            v6 = v3_1;
        label_230:
            this.gSBox[v3_1 * 2] = this.gMDS0[TwofishEngine.P[0][TwofishEngine.P[0][v6] & 255 ^ this.b0(v8)] & 255 ^ this.b0(v7)];
            this.gSBox[v3_1 * 2 + 1] = this.gMDS1[TwofishEngine.P[0][TwofishEngine.P[1][v5_1] & 255 ^ this.b1(v8)] & 255 ^ this.b1(v7)];
            this.gSBox[v3_1 * 2 + 512] = this.gMDS2[TwofishEngine.P[1][TwofishEngine.P[0][v4_1] & 255 ^ this.b2(v8)] & 255 ^ this.b2(v7)];
            this.gSBox[v3_1 * 2 + 513] = this.gMDS3[TwofishEngine.P[1][TwofishEngine.P[1][v2] & 255 ^ this.b3(v8)] & 255 ^ this.b3(v7)];
        label_100:
        }
    }
}

