// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.engines;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.StreamCipher;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class VMPCEngine implements StreamCipher {
    protected byte[] P;
    protected byte n;
    protected byte s;
    protected byte[] workingIV;
    protected byte[] workingKey;

    public VMPCEngine() {
        super();
        this.n = 0;
        this.P = null;
        this.s = 0;
    }

    public String getAlgorithmName() {
        return "VMPC";
    }

    public void init(boolean arg4, CipherParameters arg5) {
        if(!(arg5 instanceof ParametersWithIV)) {
            throw new IllegalArgumentException("VMPC init parameters must include an IV");
        }

        CipherParameters v0 = ((ParametersWithIV)arg5).getParameters();
        if(!(((ParametersWithIV)arg5).getParameters() instanceof KeyParameter)) {
            throw new IllegalArgumentException("VMPC init parameters must include a key");
        }

        this.workingIV = ((ParametersWithIV)arg5).getIV();
        if(this.workingIV != null && this.workingIV.length >= 1 && this.workingIV.length <= 768) {
            this.workingKey = ((KeyParameter)v0).getKey();
            this.initKey(this.workingKey, this.workingIV);
            return;
        }

        throw new IllegalArgumentException("VMPC requires 1 to 768 bytes of IV");
    }

    protected void initKey(byte[] arg9, byte[] arg10) {
        byte v2;
        int v7 = 768;
        int v4 = 256;
        this.s = 0;
        this.P = new byte[v4];
        int v0;
        for(v0 = 0; v0 < v4; ++v0) {
            this.P[v0] = ((byte)v0);
        }

        for(v0 = 0; v0 < v7; ++v0) {
            this.s = this.P[this.s + this.P[v0 & 255] + arg9[v0 % arg9.length] & 255];
            v2 = this.P[v0 & 255];
            this.P[v0 & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
        }

        for(v0 = 0; v0 < v7; ++v0) {
            this.s = this.P[this.s + this.P[v0 & 255] + arg10[v0 % arg10.length] & 255];
            v2 = this.P[v0 & 255];
            this.P[v0 & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
        }

        this.n = 0;
    }

    public void processBytes(byte[] arg8, int arg9, int arg10, byte[] arg11, int arg12) {
        if(arg9 + arg10 > arg8.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(arg12 + arg10 > arg11.length) {
            throw new OutputLengthException("output buffer too short");
        }

        int v0;
        for(v0 = 0; v0 < arg10; ++v0) {
            this.s = this.P[this.s + this.P[this.n & 255] & 255];
            int v1 = this.P[this.P[this.P[this.s & 255] & 255] + 1 & 255];
            byte v2 = this.P[this.n & 255];
            this.P[this.n & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
            this.n = ((byte)(this.n + 1 & 255));
            arg11[v0 + arg12] = ((byte)(v1 ^ arg8[v0 + arg9]));
        }
    }

    public void reset() {
        this.initKey(this.workingKey, this.workingIV);
    }

    public byte returnByte(byte arg7) {
        this.s = this.P[this.s + this.P[this.n & 255] & 255];
        int v0 = this.P[this.P[this.P[this.s & 255] & 255] + 1 & 255];
        byte v1 = this.P[this.n & 255];
        this.P[this.n & 255] = this.P[this.s & 255];
        this.P[this.s & 255] = v1;
        this.n = ((byte)(this.n + 1 & 255));
        return ((byte)(v0 ^ arg7));
    }
}

