// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.examples;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CryptoException;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.crypto.engines.DESedeEngine;
import org.bouncycastle.crypto.generators.DESedeKeyGenerator;
import org.bouncycastle.crypto.modes.CBCBlockCipher;
import org.bouncycastle.crypto.paddings.PaddedBufferedBlockCipher;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.util.encoders.Hex;

public class DESExample {
    private PaddedBufferedBlockCipher cipher;
    private boolean encrypt;
    private BufferedInputStream in;
    private byte[] key;
    private BufferedOutputStream out;

    public DESExample() {
        super();
        this.encrypt = true;
        this.cipher = null;
        this.in = null;
        this.out = null;
        this.key = null;
    }

    public DESExample(String arg6, String arg7, String arg8, boolean arg9) {
        SecureRandom v0_3;
        PaddedBufferedBlockCipher v1 = null;
        super();
        this.encrypt = true;
        this.cipher = v1;
        this.in = ((BufferedInputStream)v1);
        this.out = ((BufferedOutputStream)v1);
        this.key = ((byte[])v1);
        this.encrypt = arg9;
        try {
            this.in = new BufferedInputStream(new FileInputStream(arg6));
        }
        catch(FileNotFoundException v0) {
            System.err.println("Input file not found [" + arg6 + "]");
            System.exit(1);
        }

        try {
            this.out = new BufferedOutputStream(new FileOutputStream(arg7));
        }
        catch(IOException v0_1) {
            System.err.println("Output file not created [" + arg7 + "]");
            System.exit(1);
        }

        if(!arg9) {
            goto label_92;
        }

        try {
            v0_3 = new SecureRandom();
            goto label_22;
        }
        catch(IOException v0_1) {
        }
        catch(Exception v0_2) {
            v0_3 = ((SecureRandom)v1);
            goto label_73;
            try {
            label_22:
                v0_3.setSeed("www.bouncycastle.org".getBytes());
                goto label_25;
            }
            catch(IOException v0_1) {
            }
            catch(Exception v1_1) {
                try {
                label_73:
                    System.err.println("Hmmm, no SHA1PRNG, you need the Sun implementation");
                    System.exit(1);
                label_25:
                    KeyGenerationParameters v1_2 = new KeyGenerationParameters(v0_3, 192);
                    DESedeKeyGenerator v0_4 = new DESedeKeyGenerator();
                    v0_4.init(v1_2);
                    this.key = v0_4.generateKey();
                    BufferedOutputStream v0_5 = new BufferedOutputStream(new FileOutputStream(arg8));
                    byte[] v1_3 = Hex.encode(this.key);
                    v0_5.write(v1_3, 0, v1_3.length);
                    v0_5.flush();
                    v0_5.close();
                }
                catch(IOException v0_1) {
                    System.err.println("Could not decryption create key file [" + arg8 + "]");
                    System.exit(1);
                }

                return;
            }
        }

        try {
        label_92:
            BufferedInputStream v0_6 = new BufferedInputStream(new FileInputStream(arg8));
            int v1_4 = v0_6.available();
            byte[] v2 = new byte[v1_4];
            v0_6.read(v2, 0, v1_4);
            this.key = Hex.decode(v2);
        }
        catch(IOException v0_1) {
            System.err.println("Decryption key file not found, or not valid [" + arg8 + "]");
            System.exit(1);
        }
    }

    public static void main(String[] arg7) {
        boolean v1 = false;
        int v6 = 2;
        if(arg7.length < v6) {
            System.err.println("Usage: java " + new DESExample().getClass().getName() + " infile outfile [keyfile]");
            System.exit(1);
        }

        String v0 = "deskey.dat";
        String v3 = arg7[0];
        String v4 = arg7[1];
        if(arg7.length > v6) {
            v0 = arg7[v6];
        }
        else {
            v1 = true;
        }

        new DESExample(v3, v4, v0, v1).process();
    }

    private void performDecrypt(byte[] arg8) {
        int v0_2;
        this.cipher.init(false, new KeyParameter(arg8));
        BufferedReader v6 = new BufferedReader(new InputStreamReader(this.in));
        byte[] v4 = null;
        try {
            while(true) {
                String v0_1 = v6.readLine();
                if(v0_1 == null) {
                    break;
                }

                byte[] v1 = Hex.decode(v0_1);
                v4 = new byte[this.cipher.getOutputSize(v1.length)];
                v0_2 = this.cipher.processBytes(v1, 0, v1.length, v4, 0);
                if(v0_2 <= 0) {
                    continue;
                }

                this.out.write(v4, 0, v0_2);
            }
        }
        catch(IOException v0) {
            goto label_29;
        }

        try {
            v0_2 = this.cipher.doFinal(v4, 0);
            if(v0_2 <= 0) {
                return;
            }

            this.out.write(v4, 0, v0_2);
        }
        catch(IOException v0) {
        label_29:
            v0.printStackTrace();
        }
        catch(CryptoException v0_3) {
        }
    }

    private void performEncrypt(byte[] arg8) {
        byte[] v0_2;
        this.cipher.init(true, new KeyParameter(arg8));
        int v6 = 47;
        int v0 = this.cipher.getOutputSize(v6);
        byte[] v1 = new byte[v6];
        byte[] v4 = new byte[v0];
        try {
            while(true) {
                int v3 = this.in.read(v1, 0, v6);
                if(v3 <= 0) {
                    break;
                }

                v0 = this.cipher.processBytes(v1, 0, v3, v4, 0);
                if(v0 <= 0) {
                    continue;
                }

                v0_2 = Hex.encode(v4, 0, v0);
                this.out.write(v0_2, 0, v0_2.length);
                this.out.write(10);
            }
        }
        catch(IOException v0_1) {
            goto label_30;
        }

        try {
            v0 = this.cipher.doFinal(v4, 0);
            if(v0 <= 0) {
                return;
            }

            v0_2 = Hex.encode(v4, 0, v0);
            this.out.write(v0_2, 0, v0_2.length);
            this.out.write(10);
        }
        catch(IOException v0_1) {
        label_30:
            v0_1.printStackTrace();
        }
        catch(CryptoException v0_3) {
        }
    }

    private void process() {
        this.cipher = new PaddedBufferedBlockCipher(new CBCBlockCipher(new DESedeEngine()));
        if(this.encrypt) {
            this.performEncrypt(this.key);
        }
        else {
            this.performDecrypt(this.key);
        }

        try {
            this.in.close();
            this.out.flush();
            this.out.close();
        }
        catch(IOException v0) {
        }
    }
}

