// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.DerivationParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.ISO18033KDFParameters;
import org.bouncycastle.crypto.params.KDFParameters;
import org.bouncycastle.crypto.util.Pack;

public class BaseKDFBytesGenerator implements DerivationFunction {
    private int counterStart;
    private Digest digest;
    private byte[] iv;
    private byte[] shared;

    protected BaseKDFBytesGenerator(int arg1, Digest arg2) {
        super();
        this.counterStart = arg1;
        this.digest = arg2;
    }

    public int generateBytes(byte[] arg16, int arg17, int arg18) {
        if(arg16.length - arg18 < arg17) {
            throw new DataLengthException("output buffer too small");
        }

        long v5 = ((long)arg18);
        int v7 = this.digest.getDigestSize();
        if(v5 > 8589934591L) {
            throw new IllegalArgumentException("Output length too large");
        }

        int v8 = ((int)(((((long)v7)) + v5 - 1) / (((long)v7))));
        byte[] v9 = new byte[this.digest.getDigestSize()];
        byte[] v10 = new byte[4];
        Pack.intToBigEndian(this.counterStart, v10, 0);
        int v3 = this.counterStart & -256;
        int v4 = 0;
        int v2 = arg17;
        int v1 = arg18;
        while(v4 < v8) {
            this.digest.update(this.shared, 0, this.shared.length);
            this.digest.update(v10, 0, v10.length);
            if(this.iv != null) {
                this.digest.update(this.iv, 0, this.iv.length);
            }

            this.digest.doFinal(v9, 0);
            if(v1 > v7) {
                System.arraycopy(v9, 0, arg16, v2, v7);
                v2 += v7;
                v1 -= v7;
            }
            else {
                System.arraycopy(v9, 0, arg16, v2, v1);
            }

            byte v12 = ((byte)(v10[3] + 1));
            v10[3] = v12;
            if(v12 == 0) {
                v3 += 256;
                Pack.intToBigEndian(v3, v10, 0);
            }

            ++v4;
        }

        this.digest.reset();
        return ((int)v5);
    }

    public Digest getDigest() {
        return this.digest;
    }

    public void init(DerivationParameters arg3) {
        if((arg3 instanceof KDFParameters)) {
            this.shared = ((KDFParameters)arg3).getSharedSecret();
            this.iv = ((KDFParameters)arg3).getIV();
        }
        else if((arg3 instanceof ISO18033KDFParameters)) {
            this.shared = ((ISO18033KDFParameters)arg3).getSeed();
            this.iv = null;
        }
        else {
            goto label_14;
        }

        return;
    label_14:
        throw new IllegalArgumentException("KDF parameters required for KDF2Generator");
    }
}

