// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.util.BigIntegers;

class DHKeyGeneratorHelper {
    private static final BigInteger ONE;
    private static final BigInteger TWO;

    static {
        DHKeyGeneratorHelper.INSTANCE = new DHKeyGeneratorHelper();
        DHKeyGeneratorHelper.ONE = BigInteger.valueOf(1);
        DHKeyGeneratorHelper.TWO = BigInteger.valueOf(2);
    }

    private DHKeyGeneratorHelper() {
        super();
    }

    BigInteger calculatePrivate(DHParameters arg4, SecureRandom arg5) {
        BigInteger v0_1;
        BigInteger v1 = arg4.getP();
        int v0 = arg4.getL();
        if(v0 != 0) {
            v0_1 = new BigInteger(v0, ((Random)arg5)).setBit(v0 - 1);
        }
        else {
            v0_1 = DHKeyGeneratorHelper.TWO;
            int v2 = arg4.getM();
            if(v2 != 0) {
                v0_1 = DHKeyGeneratorHelper.ONE.shiftLeft(v2 - 1);
            }

            v1 = v1.subtract(DHKeyGeneratorHelper.TWO);
            BigInteger v2_1 = arg4.getQ();
            if(v2_1 != null) {
                v1 = v2_1.subtract(DHKeyGeneratorHelper.TWO);
            }

            v0_1 = BigIntegers.createRandomInRange(v0_1, v1, arg5);
        }

        return v0_1;
    }

    BigInteger calculatePublic(DHParameters arg3, BigInteger arg4) {
        return arg3.getG().modPow(arg4, arg3.getP());
    }
}

