// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;
import org.bouncycastle.util.BigIntegers;

class DHParametersHelper {
    private static final BigInteger ONE;
    private static final BigInteger TWO;

    static {
        DHParametersHelper.ONE = BigInteger.valueOf(1);
        DHParametersHelper.TWO = BigInteger.valueOf(2);
    }

    DHParametersHelper() {
        super();
    }

    static BigInteger[] generateSafePrimes(int arg6, int arg7, SecureRandom arg8) {
        BigInteger v2;
        BigInteger v1;
        int v4 = 2;
        int v0 = arg6 - 1;
        do {
        label_3:
            v1 = new BigInteger(v0, v4, ((Random)arg8));
            v2 = v1.shiftLeft(1).add(DHParametersHelper.ONE);
            if(!v2.isProbablePrime(arg7)) {
                goto label_3;
            }

            if(arg7 <= v4) {
                break;
            }
        }
        while(!v1.isProbablePrime(arg7));

        BigInteger[] v0_1 = new BigInteger[v4];
        v0_1[0] = v2;
        v0_1[1] = v1;
        return v0_1;
    }

    static BigInteger selectGenerator(BigInteger arg3, BigInteger arg4, SecureRandom arg5) {
        BigInteger v1;
        BigInteger v0 = arg3.subtract(DHParametersHelper.TWO);
        do {
            v1 = BigIntegers.createRandomInRange(DHParametersHelper.TWO, v0, arg5).modPow(DHParametersHelper.TWO, arg3);
        }
        while(v1.equals(DHParametersHelper.ONE));

        return v1;
    }
}

