// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.crypto.params.DSAKeyGenerationParameters;
import org.bouncycastle.crypto.params.DSAParameters;
import org.bouncycastle.crypto.params.DSAPrivateKeyParameters;
import org.bouncycastle.crypto.params.DSAPublicKeyParameters;
import org.bouncycastle.util.BigIntegers;

public class DSAKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private static final BigInteger ONE;
    private DSAKeyGenerationParameters param;

    static {
        DSAKeyPairGenerator.ONE = BigInteger.valueOf(1);
    }

    public DSAKeyPairGenerator() {
        super();
    }

    private static BigInteger calculatePublicKey(BigInteger arg1, BigInteger arg2, BigInteger arg3) {
        return arg2.modPow(arg3, arg1);
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        DSAParameters v0 = this.param.getParameters();
        BigInteger v1 = DSAKeyPairGenerator.generatePrivateKey(v0.getQ(), this.param.getRandom());
        return new AsymmetricCipherKeyPair(new DSAPublicKeyParameters(DSAKeyPairGenerator.calculatePublicKey(v0.getP(), v0.getG(), v1), v0), new DSAPrivateKeyParameters(v1, v0));
    }

    private static BigInteger generatePrivateKey(BigInteger arg2, SecureRandom arg3) {
        return BigIntegers.createRandomInRange(DSAKeyPairGenerator.ONE, arg2.subtract(DSAKeyPairGenerator.ONE), arg3);
    }

    public void init(KeyGenerationParameters arg1) {
        this.param = ((DSAKeyGenerationParameters)arg1);
    }
}

