// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.crypto.params.GOST3410KeyGenerationParameters;
import org.bouncycastle.crypto.params.GOST3410Parameters;
import org.bouncycastle.crypto.params.GOST3410PrivateKeyParameters;
import org.bouncycastle.crypto.params.GOST3410PublicKeyParameters;

public class GOST3410KeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private static final BigInteger ZERO;
    private GOST3410KeyGenerationParameters param;

    static {
        GOST3410KeyPairGenerator.ZERO = BigInteger.valueOf(0);
    }

    public GOST3410KeyPairGenerator() {
        super();
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        BigInteger v5;
        GOST3410Parameters v0 = this.param.getParameters();
        SecureRandom v1 = this.param.getRandom();
        BigInteger v2 = v0.getQ();
        BigInteger v3 = v0.getP();
        BigInteger v4 = v0.getA();
        do {
        label_7:
            v5 = new BigInteger(256, ((Random)v1));
            if(v5.equals(GOST3410KeyPairGenerator.ZERO)) {
                goto label_7;
            }
        }
        while(v5.compareTo(v2) >= 0);

        return new AsymmetricCipherKeyPair(new GOST3410PublicKeyParameters(v4.modPow(v5, v3), v0), new GOST3410PrivateKeyParameters(v5, v0));
    }

    public void init(KeyGenerationParameters arg1) {
        this.param = ((GOST3410KeyGenerationParameters)arg1);
    }
}

