// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.params.GOST3410Parameters;
import org.bouncycastle.crypto.params.GOST3410ValidationParameters;

public class GOST3410ParametersGenerator {
    private static final BigInteger ONE;
    private static final BigInteger TWO;
    private SecureRandom init_random;
    private int size;
    private int typeproc;

    static {
        GOST3410ParametersGenerator.ONE = BigInteger.valueOf(1);
        GOST3410ParametersGenerator.TWO = BigInteger.valueOf(2);
    }

    public GOST3410ParametersGenerator() {
        super();
    }

    public GOST3410Parameters generateParameters() {
        GOST3410Parameters v0;
        int v6 = 512;
        BigInteger[] v5 = new BigInteger[2];
        if(this.typeproc == 1) {
            int v1 = this.init_random.nextInt();
            int v2 = this.init_random.nextInt();
            switch(this.size) {
                case 512: {
                    goto label_17;
                }
                case 1024: {
                    goto label_26;
                }
            }

            throw new IllegalArgumentException("Ooops! key size 512 or 1024 bit.");
        label_17:
            this.procedure_A(v1, v2, v5, v6);
            goto label_18;
        label_26:
            this.procedure_B(v1, v2, v5);
        label_18:
            v0 = new GOST3410Parameters(v5[0], v5[1], this.procedure_C(v5[0], v5[1]), new GOST3410ValidationParameters(v1, v2));
        }
        else {
            long v1_1 = this.init_random.nextLong();
            long v3 = this.init_random.nextLong();
            switch(this.size) {
                case 512: {
                    goto label_38;
                }
                case 1024: {
                    goto label_48;
                }
            }

            throw new IllegalStateException("Ooops! key size 512 or 1024 bit.");
        label_38:
            this.procedure_Aa(v1_1, v3, v5, v6);
            goto label_40;
        label_48:
            this.procedure_Bb(v1_1, v3, v5);
        label_40:
            v0 = new GOST3410Parameters(v5[0], v5[1], this.procedure_C(v5[0], v5[1]), new GOST3410ValidationParameters(v1_1, v3));
        }

        return v0;
    }

    public void init(int arg1, int arg2, SecureRandom arg3) {
        this.size = arg1;
        this.typeproc = arg2;
        this.init_random = arg3;
    }

    private int procedure_A(int arg17, int arg18, BigInteger[] arg19, int arg20) {
        int v5_2;
        int v1;
        int v2;
        int[] v3;
        BigInteger[] v5;
        BigInteger v9;
        BigInteger v8;
        while(arg17 < 0 || arg17 > 65536) {
            arg17 = this.init_random.nextInt() / 32768;
        }

        while(true) {
            if(arg18 >= 0 && arg18 <= 65536 && arg18 / 2 != 0) {
                v8 = new BigInteger(Integer.toString(arg18));
                v9 = new BigInteger("19381");
                v5 = new BigInteger[]{new BigInteger(Integer.toString(arg17))};
                v3 = new int[]{arg20};
                v2 = 0;
                v1 = 0;
                break;
            }

            arg18 = this.init_random.nextInt() / 32768 + 1;
        }

        while(v3[v1] >= 17) {
            int[] v2_1 = new int[v3.length + 1];
            System.arraycopy(v3, 0, v2_1, 0, v3.length);
            v3 = new int[v2_1.length];
            System.arraycopy(v2_1, 0, v3, 0, v2_1.length);
            v3[v1 + 1] = v3[v1] / 2;
            v2 = v1 + 1;
            ++v1;
        }

        BigInteger[] v10 = new BigInteger[v2 + 1];
        v10[v2] = new BigInteger("8003", 16);
        int v6 = 0;
        int v7 = v2 - 1;
        BigInteger[] v1_1 = v5;
        while(true) {
        label_77:
            if(v6 < v2) {
                int v11 = v3[v7] / 16;
            label_80:
                BigInteger[] v4 = new BigInteger[v1_1.length];
                System.arraycopy(v1_1, 0, v4, 0, v1_1.length);
                v1_1 = new BigInteger[v11 + 1];
                System.arraycopy(v4, 0, v1_1, 0, v4.length);
                int v4_1;
                for(v4_1 = 0; v4_1 < v11; ++v4_1) {
                    v1_1[v4_1 + 1] = v1_1[v4_1].multiply(v9).add(v8).mod(GOST3410ParametersGenerator.TWO.pow(16));
                }

                BigInteger v5_1 = new BigInteger("0");
                for(v4_1 = 0; v4_1 < v11; ++v4_1) {
                    v5_1 = v5_1.add(v1_1[v4_1].multiply(GOST3410ParametersGenerator.TWO.pow(v4_1 * 16)));
                }

                v1_1[0] = v1_1[v11];
                BigInteger v4_2 = GOST3410ParametersGenerator.TWO.pow(v3[v7] - 1).divide(v10[v7 + 1]).add(GOST3410ParametersGenerator.TWO.pow(v3[v7] - 1).multiply(v5_1).divide(v10[v7 + 1].multiply(GOST3410ParametersGenerator.TWO.pow(v11 * 16))));
                if(v4_2.mod(GOST3410ParametersGenerator.TWO).compareTo(GOST3410ParametersGenerator.ONE) == 0) {
                    v4_2 = v4_2.add(GOST3410ParametersGenerator.ONE);
                }

                v5_2 = 0;
                while(true) {
                label_149:
                    v10[v7] = v10[v7 + 1].multiply(v4_2.add(BigInteger.valueOf(((long)v5_2)))).add(GOST3410ParametersGenerator.ONE);
                    if(v10[v7].compareTo(GOST3410ParametersGenerator.TWO.pow(v3[v7])) == 1) {
                        goto label_80;
                    }

                    if(GOST3410ParametersGenerator.TWO.modPow(v10[v7 + 1].multiply(v4_2.add(BigInteger.valueOf(((long)v5_2)))), v10[v7]).compareTo(GOST3410ParametersGenerator.ONE) == 0 && GOST3410ParametersGenerator.TWO.modPow(v4_2.add(BigInteger.valueOf(((long)v5_2))), v10[v7]).compareTo(GOST3410ParametersGenerator.ONE) != 0) {
                        v5_2 = v7 - 1;
                        if(v5_2 >= 0) {
                            ++v6;
                            v7 = v5_2;
                            goto label_77;
                        }
                        else {
                            goto label_194;
                        }
                    }

                    goto label_192;
                }
            }
            else {
                goto label_206;
            }

            return v1;
        }

    label_194:
        arg19[0] = v10[0];
        arg19[1] = v10[1];
        return v1_1[0].intValue();
    label_192:
        v5_2 += 2;
        goto label_149;
    label_206:
        return v1_1[0].intValue();
    }

    private long procedure_Aa(long arg18, long arg20, BigInteger[] arg22, int arg23) {
        long v2_2;
        int v6_2;
        int v2;
        int v3;
        int[] v4;
        BigInteger[] v6;
        BigInteger v10;
        BigInteger v9;
        while(arg18 < 0 || arg18 > 4294967296L) {
            arg18 = ((long)(this.init_random.nextInt() * 2));
        }

        while(true) {
            if(arg20 >= 0 && arg20 <= 4294967296L && arg20 / 2 != 0) {
                v9 = new BigInteger(Long.toString(arg20));
                v10 = new BigInteger("97781173");
                v6 = new BigInteger[]{new BigInteger(Long.toString(arg18))};
                v4 = new int[]{arg23};
                v3 = 0;
                v2 = 0;
                break;
            }

            arg20 = ((long)(this.init_random.nextInt() * 2 + 1));
        }

        while(v4[v2] >= 33) {
            int[] v3_1 = new int[v4.length + 1];
            System.arraycopy(v4, 0, v3_1, 0, v4.length);
            v4 = new int[v3_1.length];
            System.arraycopy(v3_1, 0, v4, 0, v3_1.length);
            v4[v2 + 1] = v4[v2] / 2;
            v3 = v2 + 1;
            ++v2;
        }

        BigInteger[] v11 = new BigInteger[v3 + 1];
        v11[v3] = new BigInteger("8000000B", 16);
        int v7 = 0;
        int v8 = v3 - 1;
        BigInteger[] v2_1 = v6;
        while(true) {
        label_81:
            if(v7 < v3) {
                int v12 = v4[v8] / 32;
            label_84:
                BigInteger[] v5 = new BigInteger[v2_1.length];
                System.arraycopy(v2_1, 0, v5, 0, v2_1.length);
                v2_1 = new BigInteger[v12 + 1];
                System.arraycopy(v5, 0, v2_1, 0, v5.length);
                int v5_1;
                for(v5_1 = 0; v5_1 < v12; ++v5_1) {
                    v2_1[v5_1 + 1] = v2_1[v5_1].multiply(v10).add(v9).mod(GOST3410ParametersGenerator.TWO.pow(32));
                }

                BigInteger v6_1 = new BigInteger("0");
                for(v5_1 = 0; v5_1 < v12; ++v5_1) {
                    v6_1 = v6_1.add(v2_1[v5_1].multiply(GOST3410ParametersGenerator.TWO.pow(v5_1 * 32)));
                }

                v2_1[0] = v2_1[v12];
                BigInteger v5_2 = GOST3410ParametersGenerator.TWO.pow(v4[v8] - 1).divide(v11[v8 + 1]).add(GOST3410ParametersGenerator.TWO.pow(v4[v8] - 1).multiply(v6_1).divide(v11[v8 + 1].multiply(GOST3410ParametersGenerator.TWO.pow(v12 * 32))));
                if(v5_2.mod(GOST3410ParametersGenerator.TWO).compareTo(GOST3410ParametersGenerator.ONE) == 0) {
                    v5_2 = v5_2.add(GOST3410ParametersGenerator.ONE);
                }

                v6_2 = 0;
                while(true) {
                label_153:
                    v11[v8] = v11[v8 + 1].multiply(v5_2.add(BigInteger.valueOf(((long)v6_2)))).add(GOST3410ParametersGenerator.ONE);
                    if(v11[v8].compareTo(GOST3410ParametersGenerator.TWO.pow(v4[v8])) == 1) {
                        goto label_84;
                    }

                    if(GOST3410ParametersGenerator.TWO.modPow(v11[v8 + 1].multiply(v5_2.add(BigInteger.valueOf(((long)v6_2)))), v11[v8]).compareTo(GOST3410ParametersGenerator.ONE) == 0 && GOST3410ParametersGenerator.TWO.modPow(v5_2.add(BigInteger.valueOf(((long)v6_2))), v11[v8]).compareTo(GOST3410ParametersGenerator.ONE) != 0) {
                        v6_2 = v8 - 1;
                        if(v6_2 >= 0) {
                            ++v7;
                            v8 = v6_2;
                            goto label_81;
                        }
                        else {
                            goto label_198;
                        }
                    }

                    goto label_196;
                }
            }
            else {
                goto label_210;
            }

            return v2_2;
        }

    label_198:
        arg22[0] = v11[0];
        arg22[1] = v11[1];
        v2_2 = v2_1[0].longValue();
        return v2_2;
    label_196:
        v6_2 += 2;
        goto label_153;
    label_210:
        return v2_1[0].longValue();
    }

    private void procedure_B(int arg14, int arg15, BigInteger[] arg16) {
        BigInteger[] v6;
        BigInteger v5;
        BigInteger v4;
        int v1;
        BigInteger v3;
        BigInteger v2;
        while(arg14 < 0 || arg14 > 65536) {
            arg14 = this.init_random.nextInt() / 32768;
        }

        while(true) {
            if(arg15 >= 0 && arg15 <= 65536 && arg15 / 2 != 0) {
                BigInteger[] v0 = new BigInteger[2];
                v2 = new BigInteger(Integer.toString(arg15));
                v3 = new BigInteger("19381");
                v1 = this.procedure_A(arg14, arg15, v0, 256);
                v4 = v0[0];
                v1 = this.procedure_A(v1, arg15, v0, 512);
                v5 = v0[0];
                v6 = new BigInteger[65];
                v6[0] = new BigInteger(Integer.toString(v1));
                int v7 = 1024;
                break;
            }

            arg15 = this.init_random.nextInt() / 32768 + 1;
        }

    label_43:
        int v0_1;
        for(v0_1 = 0; v0_1 < 64; ++v0_1) {
            v6[v0_1 + 1] = v6[v0_1].multiply(v3).add(v2).mod(GOST3410ParametersGenerator.TWO.pow(16));
        }

        BigInteger v1_1 = new BigInteger("0");
        for(v0_1 = 0; v0_1 < 64; ++v0_1) {
            v1_1 = v1_1.add(v6[v0_1].multiply(GOST3410ParametersGenerator.TWO.pow(v0_1 * 16)));
        }

        v6[0] = v6[64];
        BigInteger v0_2 = GOST3410ParametersGenerator.TWO.pow(1023).divide(v4.multiply(v5)).add(GOST3410ParametersGenerator.TWO.pow(1023).multiply(v1_1).divide(v4.multiply(v5).multiply(GOST3410ParametersGenerator.TWO.pow(1024))));
        if(v0_2.mod(GOST3410ParametersGenerator.TWO).compareTo(GOST3410ParametersGenerator.ONE) == 0) {
            v0_2 = v0_2.add(GOST3410ParametersGenerator.ONE);
        }

        for(v1 = 0; true; v1 += 2) {
            BigInteger v8 = v4.multiply(v5).multiply(v0_2.add(BigInteger.valueOf(((long)v1)))).add(GOST3410ParametersGenerator.ONE);
            if(v8.compareTo(GOST3410ParametersGenerator.TWO.pow(v7)) == 1) {
                goto label_43;
            }

            if(GOST3410ParametersGenerator.TWO.modPow(v4.multiply(v5).multiply(v0_2.add(BigInteger.valueOf(((long)v1)))), v8).compareTo(GOST3410ParametersGenerator.ONE) == 0 && GOST3410ParametersGenerator.TWO.modPow(v4.multiply(v0_2.add(BigInteger.valueOf(((long)v1)))), v8).compareTo(GOST3410ParametersGenerator.ONE) != 0) {
                arg16[0] = v8;
                arg16[1] = v4;
                return;
            }
        }
    }

    private void procedure_Bb(long arg14, long arg16, BigInteger[] arg18) {
        BigInteger[] v3_1;
        BigInteger v2;
        BigInteger v9;
        BigInteger v8;
        BigInteger v7;
        long v3;
        long v1;
        for(v1 = arg14; true; v1 = ((long)(this.init_random.nextInt() * 2))) {
            if(v1 >= 0 && v1 <= 4294967296L) {
                v3 = arg16;
                break;
            }
        }

        while(true) {
            if(v3 >= 0 && v3 <= 4294967296L && v3 / 2 != 0) {
                BigInteger[] v5 = new BigInteger[2];
                v7 = new BigInteger(Long.toString(v3));
                v8 = new BigInteger("97781173");
                v1 = this.procedure_Aa(v1, v3, v5, 256);
                v9 = v5[0];
                long v0 = this.procedure_Aa(v1, v3, v5, 512);
                v2 = v5[0];
                v3_1 = new BigInteger[33];
                v3_1[0] = new BigInteger(Long.toString(v0));
                int v4 = 1024;
                break;
            }

            v3 = ((long)(this.init_random.nextInt() * 2 + 1));
        }

    label_50:
        int v0_1;
        for(v0_1 = 0; v0_1 < 32; ++v0_1) {
            v3_1[v0_1 + 1] = v3_1[v0_1].multiply(v8).add(v7).mod(GOST3410ParametersGenerator.TWO.pow(32));
        }

        BigInteger v1_1 = new BigInteger("0");
        for(v0_1 = 0; v0_1 < 32; ++v0_1) {
            v1_1 = v1_1.add(v3_1[v0_1].multiply(GOST3410ParametersGenerator.TWO.pow(v0_1 * 32)));
        }

        v3_1[0] = v3_1[32];
        BigInteger v0_2 = GOST3410ParametersGenerator.TWO.pow(1023).divide(v9.multiply(v2)).add(GOST3410ParametersGenerator.TWO.pow(1023).multiply(v1_1).divide(v9.multiply(v2).multiply(GOST3410ParametersGenerator.TWO.pow(1024))));
        if(v0_2.mod(GOST3410ParametersGenerator.TWO).compareTo(GOST3410ParametersGenerator.ONE) == 0) {
            v0_2 = v0_2.add(GOST3410ParametersGenerator.ONE);
        }

        int v1_2;
        for(v1_2 = 0; true; v1_2 += 2) {
            BigInteger v5_1 = v9.multiply(v2).multiply(v0_2.add(BigInteger.valueOf(((long)v1_2)))).add(GOST3410ParametersGenerator.ONE);
            if(v5_1.compareTo(GOST3410ParametersGenerator.TWO.pow(v4)) == 1) {
                goto label_50;
            }

            if(GOST3410ParametersGenerator.TWO.modPow(v9.multiply(v2).multiply(v0_2.add(BigInteger.valueOf(((long)v1_2)))), v5_1).compareTo(GOST3410ParametersGenerator.ONE) == 0 && GOST3410ParametersGenerator.TWO.modPow(v9.multiply(v0_2.add(BigInteger.valueOf(((long)v1_2)))), v5_1).compareTo(GOST3410ParametersGenerator.ONE) != 0) {
                arg18[0] = v5_1;
                arg18[1] = v9;
                return;
            }
        }
    }

    private BigInteger procedure_C(BigInteger arg6, BigInteger arg7) {
        BigInteger v3;
        BigInteger v0 = arg6.subtract(GOST3410ParametersGenerator.ONE);
        BigInteger v1 = v0.divide(arg7);
        int v2 = arg6.bitLength();
        do {
        label_4:
            v3 = new BigInteger(v2, this.init_random);
            if(v3.compareTo(GOST3410ParametersGenerator.ONE) <= 0) {
                goto label_4;
            }

            if(v3.compareTo(v0) >= 0) {
                goto label_4;
            }

            v3 = v3.modPow(v1, arg6);
        }
        while(v3.compareTo(GOST3410ParametersGenerator.ONE) == 0);

        return v3;
    }
}

