// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.DerivationParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.MGFParameters;

public class MGF1BytesGenerator implements DerivationFunction {
    private Digest digest;
    private int hLen;
    private byte[] seed;

    public MGF1BytesGenerator(Digest arg2) {
        super();
        this.digest = arg2;
        this.hLen = arg2.getDigestSize();
    }

    private void ItoOSP(int arg3, byte[] arg4) {
        arg4[0] = ((byte)(arg3 >>> 24));
        arg4[1] = ((byte)(arg3 >>> 16));
        arg4[2] = ((byte)(arg3 >>> 8));
        arg4[3] = ((byte)(arg3 >>> 0));
    }

    public int generateBytes(byte[] arg8, int arg9, int arg10) {
        int v0;
        if(arg8.length - arg10 < arg9) {
            throw new DataLengthException("output buffer too small");
        }

        byte[] v2 = new byte[this.hLen];
        byte[] v3 = new byte[4];
        this.digest.reset();
        if(arg10 > this.hLen) {
            v0 = 0;
            do {
                this.ItoOSP(v0, v3);
                this.digest.update(this.seed, 0, this.seed.length);
                this.digest.update(v3, 0, v3.length);
                this.digest.doFinal(v2, 0);
                System.arraycopy(v2, 0, arg8, this.hLen * v0 + arg9, this.hLen);
                ++v0;
                if(v0 < arg10 / this.hLen) {
                    continue;
                }

                break;
            }
            while(true);
        }
        else {
            v0 = 0;
        }

        if(this.hLen * v0 < arg10) {
            this.ItoOSP(v0, v3);
            this.digest.update(this.seed, 0, this.seed.length);
            this.digest.update(v3, 0, v3.length);
            this.digest.doFinal(v2, 0);
            System.arraycopy(v2, 0, arg8, this.hLen * v0 + arg9, arg10 - v0 * this.hLen);
        }

        return arg10;
    }

    public Digest getDigest() {
        return this.digest;
    }

    public void init(DerivationParameters arg3) {
        if(!(arg3 instanceof MGFParameters)) {
            throw new IllegalArgumentException("MGF parameters required for MGF1Generator");
        }

        this.seed = ((MGFParameters)arg3).getSeed();
    }
}

