// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;
import java.util.Vector;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.crypto.params.NaccacheSternKeyGenerationParameters;
import org.bouncycastle.crypto.params.NaccacheSternKeyParameters;
import org.bouncycastle.crypto.params.NaccacheSternPrivateKeyParameters;

public class NaccacheSternKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private static final BigInteger ONE;
    private NaccacheSternKeyGenerationParameters param;
    private static int[] smallPrimes;

    static {
        NaccacheSternKeyPairGenerator.smallPrimes = new int[]{3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557};
        NaccacheSternKeyPairGenerator.ONE = BigInteger.valueOf(1);
    }

    public NaccacheSternKeyPairGenerator() {
        super();
    }

    private static Vector findFirstPrimes(int arg4) {
        Vector v1 = new Vector(arg4);
        int v0;
        for(v0 = 0; v0 != arg4; ++v0) {
            v1.addElement(BigInteger.valueOf(((long)NaccacheSternKeyPairGenerator.smallPrimes[v0])));
        }

        return v1;
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        long v8;
        BigInteger v21;
        BigInteger v20;
        BigInteger v19;
        BigInteger v18;
        int v11 = this.param.getStrength();
        SecureRandom v12 = this.param.getRandom();
        int v13 = this.param.getCertainty();
        boolean v14 = this.param.isDebug();
        if(v14) {
            System.out.println("Fetching first " + this.param.getCntSmallPrimes() + " primes.");
        }

        Vector v6 = NaccacheSternKeyPairGenerator.permuteList(NaccacheSternKeyPairGenerator.findFirstPrimes(this.param.getCntSmallPrimes()), v12);
        BigInteger v3 = NaccacheSternKeyPairGenerator.ONE;
        BigInteger v5 = NaccacheSternKeyPairGenerator.ONE;
        BigInteger v4 = v3;
        int v3_1;
        for(v3_1 = 0; v3_1 < v6.size() / 2; ++v3_1) {
            v4 = v4.multiply(v6.elementAt(v3_1));
        }

        for(v3_1 = v6.size() / 2; v3_1 < v6.size(); ++v3_1) {
            v5 = v5.multiply(v6.elementAt(v3_1));
        }

        BigInteger v15 = v4.multiply(v5);
        int v2 = v11 - v15.bitLength() - 48;
        BigInteger v16 = NaccacheSternKeyPairGenerator.generatePrime(v2 / 2 + 1, v13, v12);
        BigInteger v17 = NaccacheSternKeyPairGenerator.generatePrime(v2 / 2 + 1, v13, v12);
        long v2_1 = 0;
        if(v14) {
            System.out.println("generating p and q");
        }

        v4 = v16.multiply(v4).shiftLeft(1);
        v5 = v17.multiply(v5).shiftLeft(1);
        do {
        label_77:
            ++v2_1;
            v18 = NaccacheSternKeyPairGenerator.generatePrime(24, v13, v12);
            v19 = v18.multiply(v4).add(NaccacheSternKeyPairGenerator.ONE);
        }
        while(!v19.isProbablePrime(v13));

        do {
        label_88:
            v20 = NaccacheSternKeyPairGenerator.generatePrime(24, v13, v12);
            if(v18.equals(v20)) {
                goto label_88;
            }

            v21 = v20.multiply(v5).add(NaccacheSternKeyPairGenerator.ONE);
        }
        while(!v21.isProbablePrime(v13));

        if(!v15.gcd(v18.multiply(v20)).equals(NaccacheSternKeyPairGenerator.ONE)) {
            goto label_77;
        }

        if(v19.multiply(v21).bitLength() < v11) {
            if(!v14) {
                goto label_77;
            }

            System.out.println("key size too small. Should be " + v11 + " but is actually " + v19.multiply(v21).bitLength());
            goto label_77;
        }

        if(v14) {
            System.out.println("needed " + v2_1 + " tries to generate p and q.");
        }

        v4 = v19.multiply(v21);
        BigInteger v7 = v19.subtract(NaccacheSternKeyPairGenerator.ONE).multiply(v21.subtract(NaccacheSternKeyPairGenerator.ONE));
        v2_1 = 0;
        if(v14) {
            System.out.println("generating g");
        }

        while(true) {
            Vector v22 = new Vector();
            v8 = v2_1;
            for(v3_1 = 0; v3_1 != v6.size(); ++v3_1) {
                BigInteger v2_2 = v7.divide(v6.elementAt(v3_1));
                do {
                    ++v8;
                    v5 = new BigInteger(v11, v13, ((Random)v12));
                }
                while(v5.modPow(v2_2, v4).equals(NaccacheSternKeyPairGenerator.ONE));

                v22.addElement(v5);
            }

            v3 = NaccacheSternKeyPairGenerator.ONE;
            int v10;
            for(v10 = 0; v10 < v6.size(); ++v10) {
                v3 = v3.multiply(v22.elementAt(v10).modPow(v15.divide(v6.elementAt(v10)), v4)).mod(v4);
            }

            int v5_1 = 0;
            while(true) {
                if(v5_1 >= v6.size()) {
                    break;
                }
                else if(v3.modPow(v7.divide(v6.elementAt(v5_1)), v4).equals(NaccacheSternKeyPairGenerator.ONE)) {
                    if(v14) {
                        System.out.println("g has order phi(n)/" + v6.elementAt(v5_1) + "\n g: " + v3);
                    }

                    v2 = 1;
                }
                else {
                    ++v5_1;
                    continue;
                }

                goto label_221;
            }

            v2 = 0;
        label_221:
            if(v2 != 0) {
                v2_1 = v8;
                continue;
            }

            if(v3.modPow(v7.divide(BigInteger.valueOf(4)), v4).equals(NaccacheSternKeyPairGenerator.ONE)) {
                if(v14) {
                    System.out.println("g has order phi(n)/4\n g:" + v3);
                    v2_1 = v8;
                    continue;
                }
            }
            else if(v3.modPow(v7.divide(v18), v4).equals(NaccacheSternKeyPairGenerator.ONE)) {
                if(v14) {
                    System.out.println("g has order phi(n)/p\'\n g: " + v3);
                    v2_1 = v8;
                    continue;
                }
            }
            else if(v3.modPow(v7.divide(v20), v4).equals(NaccacheSternKeyPairGenerator.ONE)) {
                if(v14) {
                    System.out.println("g has order phi(n)/q\'\n g: " + v3);
                    v2_1 = v8;
                    continue;
                }
            }
            else if(v3.modPow(v7.divide(v16), v4).equals(NaccacheSternKeyPairGenerator.ONE)) {
                if(v14) {
                    System.out.println("g has order phi(n)/a\n g: " + v3);
                    v2_1 = v8;
                    continue;
                }
            }
            else if(!v3.modPow(v7.divide(v17), v4).equals(NaccacheSternKeyPairGenerator.ONE)) {
                break;
            }
            else if(v14) {
                System.out.println("g has order phi(n)/b\n g: " + v3);
                v2_1 = v8;
                continue;
            }

            v2_1 = v8;
        }

        if(v14) {
            System.out.println("needed " + v8 + " tries to generate g");
            System.out.println();
            System.out.println("found new NaccacheStern cipher variables:");
            System.out.println("smallPrimes: " + v6);
            System.out.println("sigma:...... " + v15 + " (" + v15.bitLength() + " bits)");
            System.out.println("a:.......... " + v16);
            System.out.println("b:.......... " + v17);
            System.out.println("p\':......... " + v18);
            System.out.println("q\':......... " + v20);
            System.out.println("p:.......... " + v19);
            System.out.println("q:.......... " + v21);
            System.out.println("n:.......... " + v4);
            System.out.println("phi(n):..... " + v7);
            System.out.println("g:.......... " + v3);
            System.out.println();
        }

        return new AsymmetricCipherKeyPair(new NaccacheSternKeyParameters(false, v3, v4, v15.bitLength()), new NaccacheSternPrivateKeyParameters(v3, v4, v15.bitLength(), v6, v7));
    }

    private static BigInteger generatePrime(int arg2, int arg3, SecureRandom arg4) {
        BigInteger v0;
        for(v0 = new BigInteger(arg2, arg3, ((Random)arg4)); v0.bitLength() != arg2; v0 = new BigInteger(arg2, arg3, ((Random)arg4))) {
        }

        return v0;
    }

    private static int getInt(SecureRandom arg4, int arg5) {
        int v0;
        int v3 = 2147483647;
        if((-arg5 & arg5) == arg5) {
            v0 = ((int)((((long)arg5)) * (((long)(arg4.nextInt() & v3))) >> 31));
        }
        else {
            do {
                int v1 = arg4.nextInt() & v3;
                v0 = v1 % arg5;
            }
            while(v1 - v0 + (arg5 - 1) < 0);
        }

        return v0;
    }

    public void init(KeyGenerationParameters arg1) {
        this.param = ((NaccacheSternKeyGenerationParameters)arg1);
    }

    private static Vector permuteList(Vector arg5, SecureRandom arg6) {
        Vector v2 = new Vector();
        Vector v3 = new Vector();
        int v0;
        for(v0 = 0; v0 < arg5.size(); ++v0) {
            v3.addElement(arg5.elementAt(v0));
        }

        v2.addElement(v3.elementAt(0));
        v3.removeElementAt(0);
        while(v3.size() != 0) {
            v2.insertElementAt(v3.elementAt(0), NaccacheSternKeyPairGenerator.getInt(arg6, v2.size() + 1));
            v3.removeElementAt(0);
        }

        return v2;
    }
}

