// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.digests.MD5Digest;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class OpenSSLPBEParametersGenerator extends PBEParametersGenerator {
    private Digest digest;

    public OpenSSLPBEParametersGenerator() {
        super();
        this.digest = new MD5Digest();
    }

    private byte[] generateDerivedKey(int arg8) {
        byte[] v3 = new byte[this.digest.getDigestSize()];
        byte[] v4 = new byte[arg8];
        int v0 = 0;
        while(true) {
            this.digest.update(this.password, 0, this.password.length);
            this.digest.update(this.salt, 0, this.salt.length);
            this.digest.doFinal(v3, 0);
            int v2 = arg8 > v3.length ? v3.length : arg8;
            System.arraycopy(v3, 0, v4, v0, v2);
            v0 += v2;
            arg8 -= v2;
            if(arg8 == 0) {
                return v4;
            }

            this.digest.reset();
            this.digest.update(v3, 0, v3.length);
        }
    }

    public CipherParameters generateDerivedMacParameters(int arg2) {
        return this.generateDerivedParameters(arg2);
    }

    public CipherParameters generateDerivedParameters(int arg5) {
        int v0 = arg5 / 8;
        return new KeyParameter(this.generateDerivedKey(v0), 0, v0);
    }

    public CipherParameters generateDerivedParameters(int arg7, int arg8) {
        int v0 = arg7 / 8;
        int v1 = arg8 / 8;
        byte[] v2 = this.generateDerivedKey(v0 + v1);
        return new ParametersWithIV(new KeyParameter(v2, 0, v0), v2, v0, v1);
    }

    public void init(byte[] arg2, byte[] arg3) {
        super.init(arg2, arg3, 1);
    }
}

