// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.ExtendedDigest;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class PKCS12ParametersGenerator extends PBEParametersGenerator {
    public static final int IV_MATERIAL = 2;
    public static final int KEY_MATERIAL = 1;
    public static final int MAC_MATERIAL = 3;
    private Digest digest;
    private int u;
    private int v;

    public PKCS12ParametersGenerator(Digest arg4) {
        super();
        this.digest = arg4;
        if((arg4 instanceof ExtendedDigest)) {
            this.u = arg4.getDigestSize();
            this.v = ((ExtendedDigest)arg4).getByteLength();
            return;
        }

        throw new IllegalArgumentException("Digest " + arg4.getAlgorithmName() + " unsupported");
    }

    private void adjust(byte[] arg5, int arg6, byte[] arg7) {
        int v0 = (arg7[arg7.length - 1] & 255) + (arg5[arg7.length + arg6 - 1] & 255) + 1;
        arg5[arg7.length + arg6 - 1] = ((byte)v0);
        int v1 = v0 >>> 8;
        for(v0 = arg7.length - 2; v0 >= 0; --v0) {
            v1 += (arg7[v0] & 255) + (arg5[arg6 + v0] & 255);
            arg5[arg6 + v0] = ((byte)v1);
            v1 >>>= 8;
        }
    }

    private byte[] generateDerivedKey(int arg14, int arg15) {
        byte[] v3;
        byte[] v2;
        byte[] v0_1;
        byte[] v5 = new byte[this.v];
        byte[] v6 = new byte[arg15];
        int v0;
        for(v0 = 0; v0 != v5.length; ++v0) {
            v5[v0] = ((byte)arg14);
        }

        if(this.salt == null || this.salt.length == 0) {
            v0_1 = new byte[0];
            goto label_39;
        label_28:
            while(v0 != v2.length) {
                v2[v0] = this.salt[v0 % this.salt.length];
                ++v0;
            }

            v0_1 = v2;
        }
        else {
            v2 = new byte[this.v * ((this.salt.length + this.v - 1) / this.v)];
            v0 = 0;
            goto label_28;
        }

    label_39:
        if(this.password == null || this.password.length == 0) {
            v2 = new byte[0];
        }
        else {
            v3 = new byte[this.v * ((this.password.length + this.v - 1) / this.v)];
            int v2_1;
            for(v2_1 = 0; v2_1 != v3.length; ++v2_1) {
                v3[v2_1] = this.password[v2_1 % this.password.length];
            }

            v2 = v3;
        }

        v3 = new byte[v0_1.length + v2.length];
        System.arraycopy(v0_1, 0, v3, 0, v0_1.length);
        System.arraycopy(v2, 0, v3, v0_1.length, v2.length);
        byte[] v7 = new byte[this.v];
        int v8 = (this.u + arg15 - 1) / this.u;
        byte[] v9 = new byte[this.u];
        for(v2_1 = 1; v2_1 <= v8; ++v2_1) {
            this.digest.update(v5, 0, v5.length);
            this.digest.update(v3, 0, v3.length);
            this.digest.doFinal(v9, 0);
            for(v0 = 1; v0 < this.iterationCount; ++v0) {
                this.digest.update(v9, 0, v9.length);
                this.digest.doFinal(v9, 0);
            }

            for(v0 = 0; v0 != v7.length; ++v0) {
                v7[v0] = v9[v0 % v9.length];
            }

            for(v0 = 0; v0 != v3.length / this.v; ++v0) {
                this.adjust(v3, this.v * v0, v7);
            }

            if(v2_1 == v8) {
                System.arraycopy(v9, 0, v6, (v2_1 - 1) * this.u, v6.length - (v2_1 - 1) * this.u);
            }
            else {
                System.arraycopy(v9, 0, v6, (v2_1 - 1) * this.u, v9.length);
            }
        }

        return v6;
    }

    public CipherParameters generateDerivedMacParameters(int arg5) {
        int v0 = arg5 / 8;
        return new KeyParameter(this.generateDerivedKey(3, v0), 0, v0);
    }

    public CipherParameters generateDerivedParameters(int arg5) {
        int v0 = arg5 / 8;
        return new KeyParameter(this.generateDerivedKey(1, v0), 0, v0);
    }

    public CipherParameters generateDerivedParameters(int arg8, int arg9) {
        int v0 = arg8 / 8;
        int v1 = arg9 / 8;
        return new ParametersWithIV(new KeyParameter(this.generateDerivedKey(1, v0), 0, v0), this.generateDerivedKey(2, v1), 0, v1);
    }
}

