// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class PKCS5S1ParametersGenerator extends PBEParametersGenerator {
    private Digest digest;

    public PKCS5S1ParametersGenerator(Digest arg1) {
        super();
        this.digest = arg1;
    }

    private byte[] generateDerivedKey() {
        byte[] v1 = new byte[this.digest.getDigestSize()];
        this.digest.update(this.password, 0, this.password.length);
        this.digest.update(this.salt, 0, this.salt.length);
        this.digest.doFinal(v1, 0);
        int v0;
        for(v0 = 1; v0 < this.iterationCount; ++v0) {
            this.digest.update(v1, 0, v1.length);
            this.digest.doFinal(v1, 0);
        }

        return v1;
    }

    public CipherParameters generateDerivedMacParameters(int arg2) {
        return this.generateDerivedParameters(arg2);
    }

    public CipherParameters generateDerivedParameters(int arg5) {
        int v0 = arg5 / 8;
        if(v0 > this.digest.getDigestSize()) {
            throw new IllegalArgumentException("Can\'t generate a derived key " + v0 + " bytes long.");
        }

        return new KeyParameter(this.generateDerivedKey(), 0, v0);
    }

    public CipherParameters generateDerivedParameters(int arg7, int arg8) {
        int v0 = arg7 / 8;
        int v1 = arg8 / 8;
        if(v0 + v1 > this.digest.getDigestSize()) {
            throw new IllegalArgumentException("Can\'t generate a derived key " + (v0 + v1) + " bytes long.");
        }

        byte[] v2 = this.generateDerivedKey();
        return new ParametersWithIV(new KeyParameter(v2, 0, v0), v2, v0, v1);
    }
}

