// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.macs.HMac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class PKCS5S2ParametersGenerator extends PBEParametersGenerator {
    private Mac hMac;
    private byte[] state;

    public PKCS5S2ParametersGenerator() {
        this(new SHA1Digest());
    }

    public PKCS5S2ParametersGenerator(Digest arg2) {
        super();
        this.hMac = new HMac(arg2);
        this.state = new byte[this.hMac.getMacSize()];
    }

    private void F(byte[] arg7, int arg8, byte[] arg9, byte[] arg10, int arg11) {
        if(arg8 == 0) {
            throw new IllegalArgumentException("iteration count must be at least 1.");
        }

        if(arg7 != null) {
            this.hMac.update(arg7, 0, arg7.length);
        }

        this.hMac.update(arg9, 0, arg9.length);
        this.hMac.doFinal(this.state, 0);
        System.arraycopy(this.state, 0, arg10, arg11, this.state.length);
        int v2;
        for(v2 = 1; v2 < arg8; ++v2) {
            this.hMac.update(this.state, 0, this.state.length);
            this.hMac.doFinal(this.state, 0);
            int v0;
            for(v0 = 0; v0 != this.state.length; ++v0) {
                int v3 = arg11 + v0;
                arg10[v3] = ((byte)(arg10[v3] ^ this.state[v0]));
            }
        }
    }

    private byte[] generateDerivedKey(int arg10) {
        int v7 = this.hMac.getMacSize();
        int v8 = (arg10 + v7 - 1) / v7;
        byte[] v3 = new byte[4];
        byte[] v4 = new byte[v8 * v7];
        int v5 = 0;
        this.hMac.init(new KeyParameter(this.password));
        int v6;
        for(v6 = 1; v6 <= v8; ++v6) {
            int v0;
            for(v0 = 3; true; --v0) {
                byte v1 = ((byte)(v3[v0] + 1));
                v3[v0] = v1;
                if(v1 != 0) {
                    break;
                }
            }

            this.F(this.salt, this.iterationCount, v3, v4, v5);
            v5 += v7;
        }

        return v4;
    }

    public CipherParameters generateDerivedMacParameters(int arg2) {
        return this.generateDerivedParameters(arg2);
    }

    public CipherParameters generateDerivedParameters(int arg5) {
        int v0 = arg5 / 8;
        return new KeyParameter(this.generateDerivedKey(v0), 0, v0);
    }

    public CipherParameters generateDerivedParameters(int arg7, int arg8) {
        int v0 = arg7 / 8;
        int v1 = arg8 / 8;
        byte[] v2 = this.generateDerivedKey(v0 + v1);
        return new ParametersWithIV(new KeyParameter(v2, 0, v0), v2, v0, v1);
    }
}

