// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;

public class RSABlindingFactorGenerator {
    private static BigInteger ONE;
    private static BigInteger ZERO;
    private RSAKeyParameters key;
    private SecureRandom random;

    static {
        RSABlindingFactorGenerator.ZERO = BigInteger.valueOf(0);
        RSABlindingFactorGenerator.ONE = BigInteger.valueOf(1);
    }

    public RSABlindingFactorGenerator() {
        super();
    }

    public BigInteger generateBlindingFactor() {
        BigInteger v2;
        if(this.key == null) {
            throw new IllegalStateException("generator not initialised");
        }

        BigInteger v0 = this.key.getModulus();
        int v1 = v0.bitLength() - 1;
        do {
        label_10:
            v2 = new BigInteger(v1, this.random);
            BigInteger v3 = v2.gcd(v0);
            if(v2.equals(RSABlindingFactorGenerator.ZERO)) {
                goto label_10;
            }

            if(v2.equals(RSABlindingFactorGenerator.ONE)) {
                goto label_10;
            }
        }
        while(!v3.equals(RSABlindingFactorGenerator.ONE));

        return v2;
    }

    public void init(CipherParameters arg3) {
        if((arg3 instanceof ParametersWithRandom)) {
            this.key = ((ParametersWithRandom)arg3).getParameters();
            this.random = ((ParametersWithRandom)arg3).getRandom();
        }
        else {
            this.key = ((RSAKeyParameters)arg3);
            this.random = new SecureRandom();
        }

        if((this.key instanceof RSAPrivateCrtKeyParameters)) {
            throw new IllegalArgumentException("generator requires RSA public key");
        }
    }
}

