// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import java.math.BigInteger;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.crypto.params.RSAKeyGenerationParameters;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;

public class RSAKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private static final BigInteger ONE;
    private RSAKeyGenerationParameters param;

    static {
        RSAKeyPairGenerator.ONE = BigInteger.valueOf(1);
    }

    public RSAKeyPairGenerator() {
        super();
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        BigInteger v4_1;
        BigInteger v0_1;
        int v0 = this.param.getStrength();
        int v1 = (v0 + 1) / 2;
        int v3 = v0 - v1;
        int v4 = v0 / 3;
        BigInteger v2 = this.param.getPublicExponent();
        do {
        label_9:
            v0_1 = new BigInteger(v1, 1, this.param.getRandom());
            if(v0_1.mod(v2).equals(RSAKeyPairGenerator.ONE)) {
                goto label_9;
            }

            if(!v0_1.isProbablePrime(this.param.getCertainty())) {
                goto label_9;
            }
        }
        while(!v2.gcd(v0_1.subtract(RSAKeyPairGenerator.ONE)).equals(RSAKeyPairGenerator.ONE));

        while(true) {
            BigInteger v5 = new BigInteger(v3, 1, this.param.getRandom());
            if(v5.subtract(v0_1).abs().bitLength() < v4) {
                continue;
            }

            if(v5.mod(v2).equals(RSAKeyPairGenerator.ONE)) {
                continue;
            }

            if(!v5.isProbablePrime(this.param.getCertainty())) {
                continue;
            }

            if(!v2.gcd(v5.subtract(RSAKeyPairGenerator.ONE)).equals(RSAKeyPairGenerator.ONE)) {
                continue;
            }

            BigInteger v1_1 = v0_1.multiply(v5);
            if(v1_1.bitLength() == this.param.getStrength()) {
                if(v0_1.compareTo(v5) < 0) {
                    v4_1 = v5;
                    v5 = v0_1;
                }
                else {
                    v4_1 = v0_1;
                }

                v0_1 = v4_1.subtract(RSAKeyPairGenerator.ONE);
                BigInteger v7 = v5.subtract(RSAKeyPairGenerator.ONE);
                BigInteger v3_1 = v2.modInverse(v0_1.multiply(v7));
                return new AsymmetricCipherKeyPair(new RSAKeyParameters(false, v1_1, v2), new RSAPrivateCrtKeyParameters(v1_1, v2, v3_1, v4_1, v5, v3_1.remainder(v0_1), v3_1.remainder(v7), v5.modInverse(v4_1)));
            }

            v0_1 = v0_1.max(v5);
        }
    }

    public void init(KeyGenerationParameters arg1) {
        this.param = ((RSAKeyGenerationParameters)arg1);
    }
}

