// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.generators;

import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.digests.SHA256Digest;
import org.bouncycastle.crypto.engines.Salsa20Engine;
import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Arrays;

public class SCrypt {
    public SCrypt() {
        super();
    }

    private static void BlockMix(int[] arg7, int[] arg8, int[] arg9, int[] arg10, int arg11) {
        int v6 = 16;
        System.arraycopy(arg7, arg7.length - 16, arg8, 0, v6);
        int v4 = arg7.length >>> 1;
        int v0 = arg11 * 2;
        int v1 = 0;
        int v3 = 0;
        while(v0 > 0) {
            SCrypt.Xor(arg8, arg7, v3, arg9);
            Salsa20Engine.salsaCore(8, arg9, arg8);
            System.arraycopy(arg8, 0, arg10, v1, v6);
            v1 = v4 + v3 - v1;
            v3 += 16;
            --v0;
        }

        System.arraycopy(arg10, 0, arg7, 0, arg10.length);
    }

    private static void Clear(byte[] arg1) {
        if(arg1 != null) {
            Arrays.fill(arg1, 0);
        }
    }

    private static void Clear(int[] arg1) {
        if(arg1 != null) {
            Arrays.fill(arg1, 0);
        }
    }

    private static void ClearAll(int[][] arg2) {
        int v0;
        for(v0 = 0; v0 < arg2.length; ++v0) {
            SCrypt.Clear(arg2[v0]);
        }
    }

    private static byte[] MFcrypt(byte[] arg6, byte[] arg7, int arg8, int arg9, int arg10, int arg11) {
        byte[] v0_2;
        int[] v1;
        int v0 = 0;
        int v2 = arg9 * 128;
        byte[] v3 = SCrypt.SingleIterationPBKDF2(arg6, arg7, arg10 * v2);
        try {
            int v4 = v3.length >>> 2;
            v1 = new int[v4];
            Pack.littleEndianToInt(v3, 0, v1);
            v2 >>>= 2;
            while(v0 < v4) {
                SCrypt.SMix(v1, v0, arg8, arg9);
                v0 += v2;
            }

            Pack.intToLittleEndian(v1, v3, 0);
            v0_2 = SCrypt.SingleIterationPBKDF2(arg6, v3, arg11);
        }
        catch(Throwable v0_1) {
            goto label_22;
        }

        SCrypt.Clear(v3);
        SCrypt.Clear(v1);
        return v0_2;
    label_22:
        SCrypt.Clear(v3);
        SCrypt.Clear(v1);
        throw v0_1;
    }

    private static void SMix(int[] arg10, int arg11, int arg12, int arg13) {
        int v1 = arg13 * 32;
        int[] v2 = new int[16];
        int[] v3 = new int[16];
        int[] v4 = new int[v1];
        int[] v5 = new int[v1];
        int[][] v6 = new int[arg12][];
        try {
            System.arraycopy(arg10, arg11, v5, 0, v1);
            int v0_1;
            for(v0_1 = 0; v0_1 < arg12; ++v0_1) {
                v6[v0_1] = Arrays.clone(v5);
                SCrypt.BlockMix(v5, v2, v3, v4, arg13);
            }

            int v7 = arg12 - 1;
            for(v0_1 = 0; v0_1 < arg12; ++v0_1) {
                SCrypt.Xor(v5, v6[v5[v1 - 16] & v7], 0, v5);
                SCrypt.BlockMix(v5, v2, v3, v4, arg13);
            }

            System.arraycopy(v5, 0, arg10, arg11, v1);
        }
        catch(Throwable v0) {
            goto label_45;
        }

        SCrypt.ClearAll(v6);
        SCrypt.ClearAll(new int[][]{v5, v2, v3, v4});
        return;
    label_45:
        SCrypt.ClearAll(v6);
        SCrypt.ClearAll(new int[][]{v5, v2, v3, v4});
        throw v0;
    }

    private static byte[] SingleIterationPBKDF2(byte[] arg2, byte[] arg3, int arg4) {
        PKCS5S2ParametersGenerator v0 = new PKCS5S2ParametersGenerator(new SHA256Digest());
        ((PBEParametersGenerator)v0).init(arg2, arg3, 1);
        return ((PBEParametersGenerator)v0).generateDerivedMacParameters(arg4 * 8).getKey();
    }

    private static void Xor(int[] arg3, int[] arg4, int arg5, int[] arg6) {
        int v0;
        for(v0 = arg6.length - 1; v0 >= 0; --v0) {
            arg6[v0] = arg3[v0] ^ arg4[arg5 + v0];
        }
    }

    public static byte[] generate(byte[] arg1, byte[] arg2, int arg3, int arg4, int arg5, int arg6) {
        return SCrypt.MFcrypt(arg1, arg2, arg3, arg4, arg5, arg6);
    }
}

