// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.io;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import org.bouncycastle.crypto.BufferedBlockCipher;
import org.bouncycastle.crypto.StreamCipher;

public class CipherInputStream extends FilterInputStream {
    private static final int INPUT_BUF_SIZE = 2048;
    private byte[] buf;
    private int bufOff;
    private BufferedBlockCipher bufferedBlockCipher;
    private boolean finalized;
    private byte[] inBuf;
    private int maxBuf;
    private StreamCipher streamCipher;

    public CipherInputStream(InputStream arg3, BufferedBlockCipher arg4) {
        super(arg3);
        this.bufferedBlockCipher = arg4;
        this.buf = new byte[arg4.getOutputSize(2048)];
        this.inBuf = new byte[2048];
    }

    public CipherInputStream(InputStream arg3, StreamCipher arg4) {
        super(arg3);
        this.streamCipher = arg4;
        this.buf = new byte[2048];
        this.inBuf = new byte[2048];
    }

    public int available() {
        return this.maxBuf - this.bufOff;
    }

    public void close() {
        super.close();
    }

    public boolean markSupported() {
        return 0;
    }

    private int nextChunk() {
        int v2 = -1;
        int v0 = super.available();
        if(v0 <= 0) {
            v0 = 1;
        }

        int v3 = v0 > this.inBuf.length ? super.read(this.inBuf, 0, this.inBuf.length) : super.read(this.inBuf, 0, v0);
        if(v3 >= 0) {
            this.bufOff = 0;
            try {
                if(this.bufferedBlockCipher != null) {
                    this.maxBuf = this.bufferedBlockCipher.processBytes(this.inBuf, 0, v3, this.buf, 0);
                }
                else {
                    this.streamCipher.processBytes(this.inBuf, 0, v3, this.buf, 0);
                    this.maxBuf = v3;
                }
            }
            catch(Exception v0_1) {
                throw new IOException("error processing stream: " + v0_1.toString());
            }

            if(this.maxBuf == 0) {
                return this.nextChunk();
            }

        label_82:
            v0 = this.maxBuf;
        }
        else if(this.finalized) {
            v0 = v2;
        }
        else {
            try {
                this.maxBuf = this.bufferedBlockCipher != null ? this.bufferedBlockCipher.doFinal(this.buf, 0) : 0;
            }
            catch(Exception v0_1) {
                throw new IOException("error processing stream: " + v0_1.toString());
            }

            this.bufOff = 0;
            this.finalized = true;
            if(this.bufOff != this.maxBuf) {
                goto label_82;
            }

            v0 = v2;
        }

        return v0;
    }

    public int read() {
        int v0;
        if(this.bufOff != this.maxBuf || this.nextChunk() >= 0) {
            byte[] v0_1 = this.buf;
            int v1 = this.bufOff;
            this.bufOff = v1 + 1;
            v0 = v0_1[v1] & 255;
        }
        else {
            v0 = -1;
        }

        return v0;
    }

    public int read(byte[] arg3) {
        return this.read(arg3, 0, arg3.length);
    }

    public int read(byte[] arg4, int arg5, int arg6) {
        if(this.bufOff != this.maxBuf || this.nextChunk() >= 0) {
            int v0 = this.maxBuf - this.bufOff;
            if(arg6 > v0) {
                System.arraycopy(this.buf, this.bufOff, arg4, arg5, v0);
                this.bufOff = this.maxBuf;
                arg6 = v0;
            }
            else {
                System.arraycopy(this.buf, this.bufOff, arg4, arg5, arg6);
                this.bufOff += arg6;
            }
        }
        else {
            arg6 = -1;
        }

        return arg6;
    }

    public long skip(long arg4) {
        long v0 = 0;
        if(arg4 > v0) {
            int v0_1 = this.maxBuf - this.bufOff;
            if(arg4 > (((long)v0_1))) {
                this.bufOff = this.maxBuf;
                v0 = ((long)v0_1);
            }
            else {
                this.bufOff += ((int)arg4);
                v0 = ((long)(((int)arg4)));
            }
        }

        return v0;
    }
}

