// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.kems;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.KeyEncapsulation;
import org.bouncycastle.crypto.params.ECKeyParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.KDFParameters;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.math.ec.ECPoint;
import org.bouncycastle.util.BigIntegers;

public class ECIESKeyEncapsulation implements KeyEncapsulation {
    private boolean CofactorMode;
    private static final BigInteger ONE;
    private boolean OldCofactorMode;
    private boolean SingleHashMode;
    private DerivationFunction kdf;
    private ECKeyParameters key;
    private SecureRandom rnd;

    static {
        ECIESKeyEncapsulation.ONE = BigInteger.valueOf(1);
    }

    public ECIESKeyEncapsulation(DerivationFunction arg2, SecureRandom arg3) {
        super();
        this.kdf = arg2;
        this.rnd = arg3;
        this.CofactorMode = false;
        this.OldCofactorMode = false;
        this.SingleHashMode = false;
    }

    public ECIESKeyEncapsulation(DerivationFunction arg1, SecureRandom arg2, boolean arg3, boolean arg4, boolean arg5) {
        super();
        this.kdf = arg1;
        this.rnd = arg2;
        this.CofactorMode = arg3;
        this.OldCofactorMode = arg4;
        this.SingleHashMode = arg5;
    }

    public CipherParameters decrypt(byte[] arg3, int arg4) {
        return this.decrypt(arg3, 0, arg3.length, arg4);
    }

    public CipherParameters decrypt(byte[] arg7, int arg8, int arg9, int arg10) {
        byte[] v0_2;
        if(!(this.key instanceof ECPrivateKeyParameters)) {
            throw new IllegalArgumentException("Private key required for encryption");
        }

        BigInteger v2 = this.key.getParameters().getN();
        BigInteger v3 = this.key.getParameters().getH();
        byte[] v4 = new byte[arg9];
        System.arraycopy(arg7, arg8, v4, 0, arg9);
        ECPoint v0 = this.key.getParameters().getCurve().decodePoint(v4);
        ECPoint v1 = (this.CofactorMode) || (this.OldCofactorMode) ? v0.multiply(v3) : v0;
        BigInteger v0_1 = this.CofactorMode ? this.key.getD().multiply(v3.modInverse(v2)).mod(v2) : this.key.getD();
        byte[] v1_1 = BigIntegers.asUnsignedByteArray((this.key.getParameters().getCurve().getFieldSize() + 7) / 8, v1.multiply(v0_1).getX().toBigInteger());
        if(this.SingleHashMode) {
            v0_2 = new byte[v4.length + v1_1.length];
            System.arraycopy(v4, 0, v0_2, 0, v4.length);
            System.arraycopy(v1_1, 0, v0_2, v4.length, v1_1.length);
        }
        else {
            v0_2 = v1_1;
        }

        this.kdf.init(new KDFParameters(v0_2, null));
        v0_2 = new byte[arg10];
        this.kdf.generateBytes(v0_2, 0, v0_2.length);
        return new KeyParameter(v0_2);
    }

    public CipherParameters encrypt(byte[] arg2, int arg3) {
        return this.encrypt(arg2, 0, arg3);
    }

    public CipherParameters encrypt(byte[] arg7, int arg8, int arg9) {
        byte[] v0_1;
        if(!(this.key instanceof ECPublicKeyParameters)) {
            throw new IllegalArgumentException("Public key required for encryption");
        }

        BigInteger v1 = this.key.getParameters().getN();
        BigInteger v2 = this.key.getParameters().getH();
        BigInteger v0 = BigIntegers.createRandomInRange(ECIESKeyEncapsulation.ONE, v1, this.rnd);
        byte[] v3 = this.key.getParameters().getG().multiply(v0).getEncoded();
        System.arraycopy(v3, 0, arg7, arg8, v3.length);
        v1 = this.CofactorMode ? v0.multiply(v2).mod(v1) : v0;
        byte[] v1_1 = BigIntegers.asUnsignedByteArray((this.key.getParameters().getCurve().getFieldSize() + 7) / 8, this.key.getQ().multiply(v1).getX().toBigInteger());
        if(this.SingleHashMode) {
            v0_1 = new byte[v3.length + v1_1.length];
            System.arraycopy(v3, 0, v0_1, 0, v3.length);
            System.arraycopy(v1_1, 0, v0_1, v3.length, v1_1.length);
        }
        else {
            v0_1 = v1_1;
        }

        this.kdf.init(new KDFParameters(v0_1, null));
        v0_1 = new byte[arg9];
        this.kdf.generateBytes(v0_1, 0, v0_1.length);
        return new KeyParameter(v0_1);
    }

    public void init(CipherParameters arg3) {
        if(!(arg3 instanceof ECKeyParameters)) {
            throw new IllegalArgumentException("EC key required");
        }

        this.key = ((ECKeyParameters)arg3);
    }
}

