// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.kems;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.KeyEncapsulation;
import org.bouncycastle.crypto.params.KDFParameters;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.util.BigIntegers;

public class RSAKeyEncapsulation implements KeyEncapsulation {
    private static final BigInteger ONE;
    private static final BigInteger ZERO;
    private DerivationFunction kdf;
    private RSAKeyParameters key;
    private SecureRandom rnd;

    static {
        RSAKeyEncapsulation.ZERO = BigInteger.valueOf(0);
        RSAKeyEncapsulation.ONE = BigInteger.valueOf(1);
    }

    public RSAKeyEncapsulation(DerivationFunction arg1, SecureRandom arg2) {
        super();
        this.kdf = arg1;
        this.rnd = arg2;
    }

    public CipherParameters decrypt(byte[] arg3, int arg4) {
        return this.decrypt(arg3, 0, arg3.length, arg4);
    }

    public CipherParameters decrypt(byte[] arg7, int arg8, int arg9, int arg10) {
        if(!this.key.isPrivate()) {
            throw new IllegalArgumentException("Private key required for decryption");
        }

        BigInteger v0 = this.key.getModulus();
        BigInteger v1 = this.key.getExponent();
        byte[] v2 = new byte[arg9];
        System.arraycopy(arg7, arg8, v2, 0, v2.length);
        this.kdf.init(new KDFParameters(BigIntegers.asUnsignedByteArray((v0.bitLength() + 7) / 8, new BigInteger(1, v2).modPow(v1, v0)), null));
        byte[] v0_1 = new byte[arg10];
        this.kdf.generateBytes(v0_1, 0, v0_1.length);
        return new KeyParameter(v0_1);
    }

    public CipherParameters encrypt(byte[] arg2, int arg3) {
        return this.encrypt(arg2, 0, arg3);
    }

    public CipherParameters encrypt(byte[] arg7, int arg8, int arg9) {
        if(this.key.isPrivate()) {
            throw new IllegalArgumentException("Public key required for encryption");
        }

        BigInteger v0 = this.key.getModulus();
        BigInteger v1 = this.key.getExponent();
        BigInteger v2 = BigIntegers.createRandomInRange(RSAKeyEncapsulation.ZERO, v0.subtract(RSAKeyEncapsulation.ONE), this.rnd);
        byte[] v3 = BigIntegers.asUnsignedByteArray((v0.bitLength() + 7) / 8, v2);
        byte[] v0_1 = BigIntegers.asUnsignedByteArray((v0.bitLength() + 7) / 8, v2.modPow(v1, v0));
        System.arraycopy(v0_1, 0, arg7, arg8, v0_1.length);
        this.kdf.init(new KDFParameters(v3, null));
        v0_1 = new byte[arg9];
        this.kdf.generateBytes(v0_1, 0, v0_1.length);
        return new KeyParameter(v0_1);
    }

    public void init(CipherParameters arg3) {
        if(!(arg3 instanceof RSAKeyParameters)) {
            throw new IllegalArgumentException("RSA key required");
        }

        this.key = ((RSAKeyParameters)arg3);
    }
}

