// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.modes.CBCBlockCipher;
import org.bouncycastle.crypto.paddings.BlockCipherPadding;

public class CBCBlockCipherMac implements Mac {
    private byte[] buf;
    private int bufOff;
    private BlockCipher cipher;
    private byte[] mac;
    private int macSize;
    private BlockCipherPadding padding;

    public CBCBlockCipherMac(BlockCipher arg3) {
        this(arg3, arg3.getBlockSize() * 8 / 2, null);
    }

    public CBCBlockCipherMac(BlockCipher arg3, int arg4, BlockCipherPadding arg5) {
        super();
        if(arg4 % 8 != 0) {
            throw new IllegalArgumentException("MAC size must be multiple of 8");
        }

        this.cipher = new CBCBlockCipher(arg3);
        this.padding = arg5;
        this.macSize = arg4 / 8;
        this.mac = new byte[arg3.getBlockSize()];
        this.buf = new byte[arg3.getBlockSize()];
        this.bufOff = 0;
    }

    public CBCBlockCipherMac(BlockCipher arg2, int arg3) {
        this(arg2, arg3, null);
    }

    public CBCBlockCipherMac(BlockCipher arg2, BlockCipherPadding arg3) {
        this(arg2, arg2.getBlockSize() * 8 / 2, arg3);
    }

    public int doFinal(byte[] arg5, int arg6) {
        int v0 = this.cipher.getBlockSize();
        if(this.padding == null) {
            while(this.bufOff < v0) {
                this.buf[this.bufOff] = 0;
                ++this.bufOff;
            }
        }
        else {
            if(this.bufOff == v0) {
                this.cipher.processBlock(this.buf, 0, this.mac, 0);
                this.bufOff = 0;
            }

            this.padding.addPadding(this.buf, this.bufOff);
        }

        this.cipher.processBlock(this.buf, 0, this.mac, 0);
        System.arraycopy(this.mac, 0, arg5, arg6, this.macSize);
        this.reset();
        return this.macSize;
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName();
    }

    public int getMacSize() {
        return this.macSize;
    }

    public void init(CipherParameters arg3) {
        this.reset();
        this.cipher.init(true, arg3);
    }

    public void reset() {
        int v0;
        for(v0 = 0; v0 < this.buf.length; ++v0) {
            this.buf[v0] = 0;
        }

        this.bufOff = 0;
        this.cipher.reset();
    }

    public void update(byte arg5) {
        if(this.bufOff == this.buf.length) {
            this.cipher.processBlock(this.buf, 0, this.mac, 0);
            this.bufOff = 0;
        }

        byte[] v0 = this.buf;
        int v1 = this.bufOff;
        this.bufOff = v1 + 1;
        v0[v1] = arg5;
    }

    public void update(byte[] arg7, int arg8, int arg9) {
        if(arg9 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v0 = this.cipher.getBlockSize();
        int v1 = v0 - this.bufOff;
        if(arg9 > v1) {
            System.arraycopy(arg7, arg8, this.buf, this.bufOff, v1);
            this.cipher.processBlock(this.buf, 0, this.mac, 0);
            this.bufOff = 0;
            arg9 -= v1;
            arg8 += v1;
            while(arg9 > v0) {
                this.cipher.processBlock(arg7, arg8, this.mac, 0);
                arg9 -= v0;
                arg8 += v0;
            }
        }

        System.arraycopy(arg7, arg8, this.buf, this.bufOff, arg9);
        this.bufOff += arg9;
    }
}

