// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.paddings.BlockCipherPadding;

public class CFBBlockCipherMac implements Mac {
    private byte[] buf;
    private int bufOff;
    private MacCFBBlockCipher cipher;
    private byte[] mac;
    private int macSize;
    private BlockCipherPadding padding;

    public CFBBlockCipherMac(BlockCipher arg4) {
        this(arg4, 8, arg4.getBlockSize() * 8 / 2, null);
    }

    public CFBBlockCipherMac(BlockCipher arg3, int arg4, int arg5, BlockCipherPadding arg6) {
        super();
        this.padding = null;
        if(arg5 % 8 != 0) {
            throw new IllegalArgumentException("MAC size must be multiple of 8");
        }

        this.mac = new byte[arg3.getBlockSize()];
        this.cipher = new MacCFBBlockCipher(arg3, arg4);
        this.padding = arg6;
        this.macSize = arg5 / 8;
        this.buf = new byte[this.cipher.getBlockSize()];
        this.bufOff = 0;
    }

    public CFBBlockCipherMac(BlockCipher arg2, int arg3, int arg4) {
        this(arg2, arg3, arg4, null);
    }

    public CFBBlockCipherMac(BlockCipher arg3, BlockCipherPadding arg4) {
        this(arg3, 8, arg3.getBlockSize() * 8 / 2, arg4);
    }

    public int doFinal(byte[] arg5, int arg6) {
        int v0 = this.cipher.getBlockSize();
        if(this.padding == null) {
            while(this.bufOff < v0) {
                this.buf[this.bufOff] = 0;
                ++this.bufOff;
            }
        }
        else {
            this.padding.addPadding(this.buf, this.bufOff);
        }

        this.cipher.processBlock(this.buf, 0, this.mac, 0);
        this.cipher.getMacBlock(this.mac);
        System.arraycopy(this.mac, 0, arg5, arg6, this.macSize);
        this.reset();
        return this.macSize;
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName();
    }

    public int getMacSize() {
        return this.macSize;
    }

    public void init(CipherParameters arg2) {
        this.reset();
        this.cipher.init(arg2);
    }

    public void reset() {
        int v0;
        for(v0 = 0; v0 < this.buf.length; ++v0) {
            this.buf[v0] = 0;
        }

        this.bufOff = 0;
        this.cipher.reset();
    }

    public void update(byte arg5) {
        if(this.bufOff == this.buf.length) {
            this.cipher.processBlock(this.buf, 0, this.mac, 0);
            this.bufOff = 0;
        }

        byte[] v0 = this.buf;
        int v1 = this.bufOff;
        this.bufOff = v1 + 1;
        v0[v1] = arg5;
    }

    public void update(byte[] arg7, int arg8, int arg9) {
        if(arg9 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v1 = this.cipher.getBlockSize();
        int v2 = v1 - this.bufOff;
        if(arg9 > v2) {
            System.arraycopy(arg7, arg8, this.buf, this.bufOff, v2);
            int v0 = this.cipher.processBlock(this.buf, 0, this.mac, 0);
            this.bufOff = 0;
            arg9 -= v2;
            arg8 += v2;
            while(arg9 > v1) {
                v0 += this.cipher.processBlock(arg7, arg8, this.mac, 0);
                arg9 -= v1;
                arg8 += v1;
            }
        }

        System.arraycopy(arg7, arg8, this.buf, this.bufOff, arg9);
        this.bufOff += arg9;
    }
}

