// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.modes.GCMBlockCipher;
import org.bouncycastle.crypto.params.AEADParameters;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class GMac implements Mac {
    private final GCMBlockCipher cipher;
    private final int macSizeBits;

    public GMac(GCMBlockCipher arg2) {
        super();
        this.cipher = arg2;
        this.macSizeBits = 128;
    }

    public GMac(GCMBlockCipher arg1, int arg2) {
        super();
        this.cipher = arg1;
        this.macSizeBits = arg2;
    }

    public int doFinal(byte[] arg3, int arg4) {
        try {
            return this.cipher.doFinal(arg3, arg4);
        }
        catch(InvalidCipherTextException v0) {
            throw new IllegalStateException(v0.toString());
        }
    }

    public String getAlgorithmName() {
        return this.cipher.getUnderlyingCipher().getAlgorithmName() + "-GMAC";
    }

    public int getMacSize() {
        return this.macSizeBits / 8;
    }

    public void init(CipherParameters arg7) {
        if((arg7 instanceof ParametersWithIV)) {
            this.cipher.init(true, new AEADParameters(((ParametersWithIV)arg7).getParameters(), this.macSizeBits, ((ParametersWithIV)arg7).getIV()));
            return;
        }

        throw new IllegalArgumentException("GMAC requires ParametersWithIV");
    }

    public void reset() {
        this.cipher.reset();
    }

    public void update(byte arg2) {
        this.cipher.processAADByte(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.cipher.processAADBytes(arg2, arg3, arg4);
    }
}

