// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithSBox;

public class GOST28147Mac implements Mac {
    private byte[] S;
    private int blockSize;
    private byte[] buf;
    private int bufOff;
    private boolean firstStep;
    private byte[] mac;
    private int macSize;
    private int[] workingKey;

    public GOST28147Mac() {
        super();
        this.blockSize = 8;
        this.macSize = 4;
        this.firstStep = true;
        this.workingKey = null;
        this.S = new byte[]{9, 6, 3, 2, 8, 11, 1, 7, 10, 4, 14, 15, 12, 0, 13, 5, 3, 7, 14, 9, 8, 10, 15, 0, 5, 2, 6, 12, 11, 4, 13, 1, 14, 4, 6, 2, 11, 3, 13, 8, 12, 15, 5, 10, 0, 7, 1, 9, 14, 7, 10, 12, 13, 1, 3, 9, 0, 2, 11, 4, 15, 8, 5, 6, 11, 5, 1, 9, 8, 13, 15, 0, 14, 4, 2, 3, 12, 7, 10, 6, 3, 10, 13, 12, 1, 2, 0, 11, 7, 5, 9, 4, 8, 15, 14, 6, 1, 13, 2, 9, 7, 10, 6, 0, 8, 12, 4, 5, 15, 3, 11, 14, 11, 10, 15, 5, 0, 12, 14, 8, 6, 2, 3, 9, 1, 7, 13, 4};
        this.mac = new byte[this.blockSize];
        this.buf = new byte[this.blockSize];
        this.bufOff = 0;
    }

    private byte[] CM5func(byte[] arg5, int arg6, byte[] arg7) {
        int v0 = 0;
        byte[] v1 = new byte[arg5.length - arg6];
        System.arraycopy(arg5, arg6, v1, 0, arg7.length);
        while(v0 != arg7.length) {
            v1[v0] = ((byte)(v1[v0] ^ arg7[v0]));
            ++v0;
        }

        return v1;
    }

    private int bytesToint(byte[] arg4, int arg5) {
        return (arg4[arg5 + 3] << 24 & -16777216) + (arg4[arg5 + 2] << 16 & 16711680) + (arg4[arg5 + 1] << 8 & 65280) + (arg4[arg5] & 255);
    }

    public int doFinal(byte[] arg7, int arg8) {
        while(this.bufOff < this.blockSize) {
            this.buf[this.bufOff] = 0;
            ++this.bufOff;
        }

        byte[] v2 = new byte[this.buf.length];
        System.arraycopy(this.buf, 0, v2, 0, this.mac.length);
        if(this.firstStep) {
            this.firstStep = false;
        }
        else {
            v2 = this.CM5func(this.buf, 0, this.mac);
        }

        this.gost28147MacFunc(this.workingKey, v2, 0, this.mac, 0);
        System.arraycopy(this.mac, this.mac.length / 2 - this.macSize, arg7, arg8, this.macSize);
        this.reset();
        return this.macSize;
    }

    private int[] generateWorkingKey(byte[] arg5) {
        int v3 = 8;
        if(arg5.length != 32) {
            throw new IllegalArgumentException("Key length invalid. Key needs to be 32 byte - 256 bit!!!");
        }

        int[] v1 = new int[v3];
        int v0;
        for(v0 = 0; v0 != v3; ++v0) {
            v1[v0] = this.bytesToint(arg5, v0 * 4);
        }

        return v1;
    }

    public String getAlgorithmName() {
        return "GOST28147Mac";
    }

    public int getMacSize() {
        return this.macSize;
    }

    private void gost28147MacFunc(int[] arg8, byte[] arg9, int arg10, byte[] arg11, int arg12) {
        int v3 = this.bytesToint(arg9, arg10);
        int v0 = this.bytesToint(arg9, arg10 + 4);
        int v4 = 0;
        while(v4 < 2) {
            int v2 = v0;
            v0 = 0;
            while(v0 < 8) {
                v2 ^= this.gost28147_mainStep(v3, arg8[v0]);
                ++v0;
                int v6 = v3;
                v3 = v2;
                v2 = v6;
            }

            ++v4;
            v0 = v2;
        }

        this.intTobytes(v3, arg11, arg12);
        this.intTobytes(v0, arg11, arg12 + 4);
    }

    private int gost28147_mainStep(int arg5, int arg6) {
        int v0 = arg6 + arg5;
        v0 = (this.S[(v0 >> 28 & 15) + 112] << 28) + ((this.S[v0 >> 0 & 15] << 0) + (this.S[(v0 >> 4 & 15) + 16] << 4) + (this.S[(v0 >> 8 & 15) + 32] << 8) + (this.S[(v0 >> 12 & 15) + 48] << 12) + (this.S[(v0 >> 16 & 15) + 64] << 16) + (this.S[(v0 >> 20 & 15) + 80] << 20) + (this.S[(v0 >> 24 & 15) + 96] << 24));
        return v0 >>> 21 | v0 << 11;
    }

    public void init(CipherParameters arg5) {
        this.reset();
        this.buf = new byte[this.blockSize];
        if((arg5 instanceof ParametersWithSBox)) {
            System.arraycopy(((ParametersWithSBox)arg5).getSBox(), 0, this.S, 0, ((ParametersWithSBox)arg5).getSBox().length);
            if(((ParametersWithSBox)arg5).getParameters() != null) {
                this.workingKey = this.generateWorkingKey(((ParametersWithSBox)arg5).getParameters().getKey());
            }
        }
        else if((arg5 instanceof KeyParameter)) {
            this.workingKey = this.generateWorkingKey(((KeyParameter)arg5).getKey());
        }
        else {
            goto label_25;
        }

        return;
    label_25:
        throw new IllegalArgumentException("invalid parameter passed to GOST28147 init - " + arg5.getClass().getName());
    }

    private void intTobytes(int arg3, byte[] arg4, int arg5) {
        arg4[arg5 + 3] = ((byte)(arg3 >>> 24));
        arg4[arg5 + 2] = ((byte)(arg3 >>> 16));
        arg4[arg5 + 1] = ((byte)(arg3 >>> 8));
        arg4[arg5] = ((byte)arg3);
    }

    public void reset() {
        int v0;
        for(v0 = 0; v0 < this.buf.length; ++v0) {
            this.buf[v0] = 0;
        }

        this.bufOff = 0;
        this.firstStep = true;
    }

    public void update(byte arg7) {
        if(this.bufOff == this.buf.length) {
            byte[] v2 = new byte[this.buf.length];
            System.arraycopy(this.buf, 0, v2, 0, this.mac.length);
            if(this.firstStep) {
                this.firstStep = false;
            }
            else {
                v2 = this.CM5func(this.buf, 0, this.mac);
            }

            this.gost28147MacFunc(this.workingKey, v2, 0, this.mac, 0);
            this.bufOff = 0;
        }

        byte[] v0 = this.buf;
        int v1 = this.bufOff;
        this.bufOff = v1 + 1;
        v0[v1] = arg7;
    }

    public void update(byte[] arg9, int arg10, int arg11) {
        if(arg11 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v6 = this.blockSize - this.bufOff;
        if(arg11 > v6) {
            System.arraycopy(arg9, arg10, this.buf, this.bufOff, v6);
            byte[] v2 = new byte[this.buf.length];
            System.arraycopy(this.buf, 0, v2, 0, this.mac.length);
            if(this.firstStep) {
                this.firstStep = false;
            }
            else {
                v2 = this.CM5func(this.buf, 0, this.mac);
            }

            this.gost28147MacFunc(this.workingKey, v2, 0, this.mac, 0);
            this.bufOff = 0;
            int v1 = arg10 + v6;
            v6 = arg11 - v6;
            int v7;
            for(v7 = v1; v6 > this.blockSize; v7 = this.blockSize + v7) {
                this.gost28147MacFunc(this.workingKey, this.CM5func(arg9, v7, this.mac), 0, this.mac, 0);
                v6 -= this.blockSize;
            }
        }
        else {
            v6 = arg11;
            v7 = arg10;
        }

        System.arraycopy(arg9, v7, this.buf, this.bufOff, v6);
        this.bufOff += v6;
    }
}

