// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.engines.DESEngine;
import org.bouncycastle.crypto.modes.CBCBlockCipher;
import org.bouncycastle.crypto.paddings.BlockCipherPadding;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class ISO9797Alg3Mac implements Mac {
    private byte[] buf;
    private int bufOff;
    private BlockCipher cipher;
    private KeyParameter lastKey2;
    private KeyParameter lastKey3;
    private byte[] mac;
    private int macSize;
    private BlockCipherPadding padding;

    public ISO9797Alg3Mac(BlockCipher arg3) {
        this(arg3, arg3.getBlockSize() * 8, null);
    }

    public ISO9797Alg3Mac(BlockCipher arg3, int arg4, BlockCipherPadding arg5) {
        super();
        if(arg4 % 8 != 0) {
            throw new IllegalArgumentException("MAC size must be multiple of 8");
        }

        if(!(arg3 instanceof DESEngine)) {
            throw new IllegalArgumentException("cipher must be instance of DESEngine");
        }

        this.cipher = new CBCBlockCipher(arg3);
        this.padding = arg5;
        this.macSize = arg4 / 8;
        this.mac = new byte[arg3.getBlockSize()];
        this.buf = new byte[arg3.getBlockSize()];
        this.bufOff = 0;
    }

    public ISO9797Alg3Mac(BlockCipher arg2, int arg3) {
        this(arg2, arg3, null);
    }

    public ISO9797Alg3Mac(BlockCipher arg2, BlockCipherPadding arg3) {
        this(arg2, arg2.getBlockSize() * 8, arg3);
    }

    public int doFinal(byte[] arg5, int arg6) {
        int v0 = this.cipher.getBlockSize();
        if(this.padding == null) {
            while(this.bufOff < v0) {
                this.buf[this.bufOff] = 0;
                ++this.bufOff;
            }
        }
        else {
            if(this.bufOff == v0) {
                this.cipher.processBlock(this.buf, 0, this.mac, 0);
                this.bufOff = 0;
            }

            this.padding.addPadding(this.buf, this.bufOff);
        }

        this.cipher.processBlock(this.buf, 0, this.mac, 0);
        DESEngine v0_1 = new DESEngine();
        v0_1.init(false, this.lastKey2);
        v0_1.processBlock(this.mac, 0, this.mac, 0);
        v0_1.init(true, this.lastKey3);
        v0_1.processBlock(this.mac, 0, this.mac, 0);
        System.arraycopy(this.mac, 0, arg5, arg6, this.macSize);
        this.reset();
        return this.macSize;
    }

    public String getAlgorithmName() {
        return "ISO9797Alg3";
    }

    public int getMacSize() {
        return this.macSize;
    }

    public void init(CipherParameters arg8) {
        KeyParameter v0_1;
        int v6 = 16;
        int v3 = 8;
        this.reset();
        if(!(arg8 instanceof KeyParameter) && !(arg8 instanceof ParametersWithIV)) {
            throw new IllegalArgumentException("params must be an instance of KeyParameter or ParametersWithIV");
        }

        CipherParameters v0 = (arg8 instanceof KeyParameter) ? arg8 : arg8.getParameters();
        byte[] v1 = ((KeyParameter)v0).getKey();
        if(v1.length == v6) {
            v0_1 = new KeyParameter(v1, 0, v3);
            this.lastKey2 = new KeyParameter(v1, v3, v3);
            this.lastKey3 = v0_1;
        }
        else if(v1.length == 24) {
            v0_1 = new KeyParameter(v1, 0, v3);
            this.lastKey2 = new KeyParameter(v1, v3, v3);
            this.lastKey3 = new KeyParameter(v1, v6, v3);
        }
        else {
            goto label_48;
        }

        if((arg8 instanceof ParametersWithIV)) {
            this.cipher.init(true, new ParametersWithIV(((CipherParameters)v0_1), ((ParametersWithIV)arg8).getIV()));
        }
        else {
            this.cipher.init(true, ((CipherParameters)v0_1));
        }

        return;
    label_48:
        throw new IllegalArgumentException("Key must be either 112 or 168 bit long");
    }

    public void reset() {
        int v0;
        for(v0 = 0; v0 < this.buf.length; ++v0) {
            this.buf[v0] = 0;
        }

        this.bufOff = 0;
        this.cipher.reset();
    }

    public void update(byte arg5) {
        if(this.bufOff == this.buf.length) {
            this.cipher.processBlock(this.buf, 0, this.mac, 0);
            this.bufOff = 0;
        }

        byte[] v0 = this.buf;
        int v1 = this.bufOff;
        this.bufOff = v1 + 1;
        v0[v1] = arg5;
    }

    public void update(byte[] arg7, int arg8, int arg9) {
        if(arg9 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v1 = this.cipher.getBlockSize();
        int v2 = v1 - this.bufOff;
        if(arg9 > v2) {
            System.arraycopy(arg7, arg8, this.buf, this.bufOff, v2);
            int v0 = this.cipher.processBlock(this.buf, 0, this.mac, 0);
            this.bufOff = 0;
            arg9 -= v2;
            arg8 += v2;
            while(arg9 > v1) {
                v0 += this.cipher.processBlock(arg7, arg8, this.mac, 0);
                arg9 -= v1;
                arg8 += v1;
            }
        }

        System.arraycopy(arg7, arg8, this.buf, this.bufOff, arg9);
        this.bufOff += arg9;
    }
}

