// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithIV;

class MacCFBBlockCipher {
    private byte[] IV;
    private int blockSize;
    private byte[] cfbOutV;
    private byte[] cfbV;
    private BlockCipher cipher;

    public MacCFBBlockCipher(BlockCipher arg2, int arg3) {
        super();
        this.cipher = null;
        this.cipher = arg2;
        this.blockSize = arg3 / 8;
        this.IV = new byte[arg2.getBlockSize()];
        this.cfbV = new byte[arg2.getBlockSize()];
        this.cfbOutV = new byte[arg2.getBlockSize()];
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/CFB" + this.blockSize * 8;
    }

    public int getBlockSize() {
        return this.blockSize;
    }

    void getMacBlock(byte[] arg4) {
        this.cipher.processBlock(this.cfbV, 0, arg4, 0);
    }

    public void init(CipherParameters arg7) {
        if((arg7 instanceof ParametersWithIV)) {
            byte[] v0 = ((ParametersWithIV)arg7).getIV();
            if(v0.length < this.IV.length) {
                System.arraycopy(v0, 0, this.IV, this.IV.length - v0.length, v0.length);
            }
            else {
                System.arraycopy(v0, 0, this.IV, 0, this.IV.length);
            }

            this.reset();
            this.cipher.init(true, ((ParametersWithIV)arg7).getParameters());
        }
        else {
            this.reset();
            this.cipher.init(true, arg7);
        }
    }

    public int processBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg10 > arg9.length) {
            throw new DataLengthException("output buffer too short");
        }

        this.cipher.processBlock(this.cfbV, 0, this.cfbOutV, 0);
        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            arg9[arg10 + v0] = ((byte)(this.cfbOutV[v0] ^ arg7[arg8 + v0]));
        }

        System.arraycopy(this.cfbV, this.blockSize, this.cfbV, 0, this.cfbV.length - this.blockSize);
        System.arraycopy(arg9, arg10, this.cfbV, this.cfbV.length - this.blockSize, this.blockSize);
        return this.blockSize;
    }

    public void reset() {
        System.arraycopy(this.IV, 0, this.cfbV, 0, this.IV.length);
        this.cipher.reset();
    }
}

