// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.params.KeyParameter;

public class OldHMac implements Mac {
    private static final int BLOCK_LENGTH = 64;
    private static final byte IPAD = 54;
    private static final byte OPAD = 92;
    private Digest digest;
    private int digestSize;
    private byte[] inputPad;
    private byte[] outputPad;

    public OldHMac(Digest arg3) {
        super();
        this.inputPad = new byte[64];
        this.outputPad = new byte[64];
        this.digest = arg3;
        this.digestSize = arg3.getDigestSize();
    }

    public int doFinal(byte[] arg6, int arg7) {
        byte[] v0 = new byte[this.digestSize];
        this.digest.doFinal(v0, 0);
        this.digest.update(this.outputPad, 0, this.outputPad.length);
        this.digest.update(v0, 0, v0.length);
        int v0_1 = this.digest.doFinal(arg6, arg7);
        this.reset();
        return v0_1;
    }

    public String getAlgorithmName() {
        return this.digest.getAlgorithmName() + "/HMAC";
    }

    public int getMacSize() {
        return this.digestSize;
    }

    public Digest getUnderlyingDigest() {
        return this.digest;
    }

    public void init(CipherParameters arg5) {
        this.digest.reset();
        byte[] v0 = ((KeyParameter)arg5).getKey();
        if(v0.length > 64) {
            this.digest.update(v0, 0, v0.length);
            this.digest.doFinal(this.inputPad, 0);
            int v0_1;
            for(v0_1 = this.digestSize; v0_1 < this.inputPad.length; ++v0_1) {
                this.inputPad[v0_1] = 0;
            }
        }
        else {
            System.arraycopy(v0, 0, this.inputPad, 0, v0.length);
            for(v0_1 = v0.length; v0_1 < this.inputPad.length; ++v0_1) {
                this.inputPad[v0_1] = 0;
            }
        }

        this.outputPad = new byte[this.inputPad.length];
        System.arraycopy(this.inputPad, 0, this.outputPad, 0, this.inputPad.length);
        for(v0_1 = 0; v0_1 < this.inputPad.length; ++v0_1) {
            this.inputPad[v0_1] = ((byte)(this.inputPad[v0_1] ^ 54));
        }

        for(v0_1 = 0; v0_1 < this.outputPad.length; ++v0_1) {
            this.outputPad[v0_1] = ((byte)(this.outputPad[v0_1] ^ 92));
        }

        this.digest.update(this.inputPad, 0, this.inputPad.length);
    }

    public void reset() {
        this.digest.reset();
        this.digest.update(this.inputPad, 0, this.inputPad.length);
    }

    public void update(byte arg2) {
        this.digest.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }
}

