// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Arrays;

public class SipHash implements Mac {
    protected byte[] buf;
    protected int bufPos;
    protected final int c;
    protected final int d;
    protected long k0;
    protected long k1;
    protected long v0;
    protected long v1;
    protected long v2;
    protected long v3;
    protected long v4;
    protected int wordCount;

    public SipHash() {
        super();
        this.buf = new byte[8];
        this.bufPos = 0;
        this.wordCount = 0;
        this.c = 2;
        this.d = 4;
    }

    public SipHash(int arg3, int arg4) {
        super();
        this.buf = new byte[8];
        this.bufPos = 0;
        this.wordCount = 0;
        this.c = arg3;
        this.d = arg4;
    }

    protected void applySipRounds(int arg7) {
        int v5 = 32;
        int v0;
        for(v0 = 0; v0 < arg7; ++v0) {
            this.v0 += this.v1;
            this.v2 += this.v3;
            this.v1 = SipHash.rotateLeft(this.v1, 13);
            this.v3 = SipHash.rotateLeft(this.v3, 16);
            this.v1 ^= this.v0;
            this.v3 ^= this.v2;
            this.v0 = SipHash.rotateLeft(this.v0, v5);
            this.v2 += this.v1;
            this.v0 += this.v3;
            this.v1 = SipHash.rotateLeft(this.v1, 17);
            this.v3 = SipHash.rotateLeft(this.v3, 21);
            this.v1 ^= this.v2;
            this.v3 ^= this.v0;
            this.v2 = SipHash.rotateLeft(this.v2, v5);
        }
    }

    public int doFinal(byte[] arg3, int arg4) {
        Pack.longToLittleEndian(this.doFinal(), arg3, arg4);
        return 8;
    }

    public long doFinal() {
        int v3 = 7;
        this.buf[v3] = ((byte)((this.wordCount << 3) + this.bufPos & 255));
        while(this.bufPos < v3) {
            byte[] v0 = this.buf;
            int v1 = this.bufPos;
            this.bufPos = v1 + 1;
            v0[v1] = 0;
        }

        this.processMessageWord();
        this.v2 ^= 255;
        this.applySipRounds(this.d);
        long v0_1 = this.v0 ^ this.v1 ^ this.v2 ^ this.v3;
        this.reset();
        return v0_1;
    }

    public String getAlgorithmName() {
        return "SipHash-" + this.c + "-" + this.d;
    }

    public int getMacSize() {
        return 8;
    }

    public void init(CipherParameters arg4) {
        if(!(arg4 instanceof KeyParameter)) {
            throw new IllegalArgumentException("\'params\' must be an instance of KeyParameter");
        }

        byte[] v0 = ((KeyParameter)arg4).getKey();
        if(v0.length != 16) {
            throw new IllegalArgumentException("\'params\' must be a 128-bit key");
        }

        this.k0 = Pack.littleEndianToLong(v0, 0);
        this.k1 = Pack.littleEndianToLong(v0, 8);
        this.reset();
    }

    protected void processMessageWord() {
        ++this.wordCount;
        long v0 = Pack.littleEndianToLong(this.buf, 0);
        this.v3 ^= v0;
        this.applySipRounds(this.c);
        this.v0 ^= v0;
    }

    public void reset() {
        this.v0 = this.k0 ^ 8317987319222330741L;
        this.v1 = this.k1 ^ 7237128888997146477L;
        this.v2 = this.k0 ^ 7816392313619706465L;
        this.v3 = this.k1 ^ 8387220255154660723L;
        Arrays.fill(this.buf, 0);
        this.bufPos = 0;
        this.wordCount = 0;
    }

    protected static long rotateLeft(long arg4, int arg6) {
        return arg4 << arg6 | arg4 >>> 64 - arg6;
    }

    public void update(byte arg3) {
        this.buf[this.bufPos] = arg3;
        int v0 = this.bufPos + 1;
        this.bufPos = v0;
        if(v0 == this.buf.length) {
            this.processMessageWord();
            this.bufPos = 0;
        }
    }

    public void update(byte[] arg6, int arg7, int arg8) {
        int v0;
        for(v0 = 0; v0 < arg8; ++v0) {
            this.buf[this.bufPos] = arg6[arg7 + v0];
            int v2 = this.bufPos + 1;
            this.bufPos = v2;
            if(v2 == this.buf.length) {
                this.processMessageWord();
                this.bufPos = 0;
            }
        }
    }
}

