// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.macs;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class VMPCMac implements Mac {
    private byte[] P;
    private byte[] T;
    private byte g;
    private byte n;
    private byte s;
    private byte[] workingIV;
    private byte[] workingKey;
    private byte x1;
    private byte x2;
    private byte x3;
    private byte x4;

    public VMPCMac() {
        super();
        this.n = 0;
        this.P = null;
        this.s = 0;
    }

    public int doFinal(byte[] arg10, int arg11) {
        byte v2;
        int v8 = 20;
        int v0;
        for(v0 = 1; v0 < 25; ++v0) {
            this.s = this.P[this.s + this.P[this.n & 255] & 255];
            this.x4 = this.P[this.x4 + this.x3 + v0 & 255];
            this.x3 = this.P[this.x3 + this.x2 + v0 & 255];
            this.x2 = this.P[this.x2 + this.x1 + v0 & 255];
            this.x1 = this.P[this.x1 + this.s + v0 & 255];
            this.T[this.g & 31] = ((byte)(this.T[this.g & 31] ^ this.x1));
            this.T[this.g + 1 & 31] = ((byte)(this.T[this.g + 1 & 31] ^ this.x2));
            this.T[this.g + 2 & 31] = ((byte)(this.T[this.g + 2 & 31] ^ this.x3));
            this.T[this.g + 3 & 31] = ((byte)(this.T[this.g + 3 & 31] ^ this.x4));
            this.g = ((byte)(this.g + 4 & 31));
            v2 = this.P[this.n & 255];
            this.P[this.n & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
            this.n = ((byte)(this.n + 1 & 255));
        }

        for(v0 = 0; v0 < 768; ++v0) {
            this.s = this.P[this.s + this.P[v0 & 255] + this.T[v0 & 31] & 255];
            v2 = this.P[v0 & 255];
            this.P[v0 & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
        }

        byte[] v2_1 = new byte[v8];
        for(v0 = 0; v0 < v8; ++v0) {
            this.s = this.P[this.s + this.P[v0 & 255] & 255];
            v2_1[v0] = this.P[this.P[this.P[this.s & 255] & 255] + 1 & 255];
            byte v3 = this.P[v0 & 255];
            this.P[v0 & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v3;
        }

        System.arraycopy(v2_1, 0, arg10, arg11, v2_1.length);
        this.reset();
        return v2_1.length;
    }

    public String getAlgorithmName() {
        return "VMPC-MAC";
    }

    public int getMacSize() {
        return 20;
    }

    public void init(CipherParameters arg4) {
        if(!(arg4 instanceof ParametersWithIV)) {
            throw new IllegalArgumentException("VMPC-MAC Init parameters must include an IV");
        }

        CipherParameters v0 = ((ParametersWithIV)arg4).getParameters();
        if(!(((ParametersWithIV)arg4).getParameters() instanceof KeyParameter)) {
            throw new IllegalArgumentException("VMPC-MAC Init parameters must include a key");
        }

        this.workingIV = ((ParametersWithIV)arg4).getIV();
        if(this.workingIV != null && this.workingIV.length >= 1 && this.workingIV.length <= 768) {
            this.workingKey = ((KeyParameter)v0).getKey();
            this.reset();
            return;
        }

        throw new IllegalArgumentException("VMPC-MAC requires 1 to 768 bytes of IV");
    }

    private void initKey(byte[] arg9, byte[] arg10) {
        byte v2;
        int v7 = 768;
        int v4 = 256;
        this.s = 0;
        this.P = new byte[v4];
        int v0;
        for(v0 = 0; v0 < v4; ++v0) {
            this.P[v0] = ((byte)v0);
        }

        for(v0 = 0; v0 < v7; ++v0) {
            this.s = this.P[this.s + this.P[v0 & 255] + arg9[v0 % arg9.length] & 255];
            v2 = this.P[v0 & 255];
            this.P[v0 & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
        }

        for(v0 = 0; v0 < v7; ++v0) {
            this.s = this.P[this.s + this.P[v0 & 255] + arg10[v0 % arg10.length] & 255];
            v2 = this.P[v0 & 255];
            this.P[v0 & 255] = this.P[this.s & 255];
            this.P[this.s & 255] = v2;
        }

        this.n = 0;
    }

    public void reset() {
        int v3 = 32;
        this.initKey(this.workingKey, this.workingIV);
        this.n = 0;
        this.x4 = 0;
        this.x3 = 0;
        this.x2 = 0;
        this.x1 = 0;
        this.g = 0;
        this.T = new byte[v3];
        int v0;
        for(v0 = 0; v0 < v3; ++v0) {
            this.T[v0] = 0;
        }
    }

    public void update(byte arg6) {
        this.s = this.P[this.s + this.P[this.n & 255] & 255];
        byte v0 = ((byte)(this.P[this.P[this.P[this.s & 255] & 255] + 1 & 255] ^ arg6));
        this.x4 = this.P[this.x4 + this.x3 & 255];
        this.x3 = this.P[this.x3 + this.x2 & 255];
        this.x2 = this.P[this.x2 + this.x1 & 255];
        this.x1 = this.P[v0 + (this.x1 + this.s) & 255];
        this.T[this.g & 31] = ((byte)(this.T[this.g & 31] ^ this.x1));
        this.T[this.g + 1 & 31] = ((byte)(this.T[this.g + 1 & 31] ^ this.x2));
        this.T[this.g + 2 & 31] = ((byte)(this.T[this.g + 2 & 31] ^ this.x3));
        this.T[this.g + 3 & 31] = ((byte)(this.T[this.g + 3 & 31] ^ this.x4));
        this.g = ((byte)(this.g + 4 & 31));
        v0 = this.P[this.n & 255];
        this.P[this.n & 255] = this.P[this.s & 255];
        this.P[this.s & 255] = v0;
        this.n = ((byte)(this.n + 1 & 255));
    }

    public void update(byte[] arg3, int arg4, int arg5) {
        if(arg4 + arg5 > arg3.length) {
            throw new DataLengthException("input buffer too short");
        }

        int v0;
        for(v0 = 0; v0 < arg5; ++v0) {
            this.update(arg3[v0]);
        }
    }
}

