// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.util.Arrays;

public class CBCBlockCipher implements BlockCipher {
    private byte[] IV;
    private int blockSize;
    private byte[] cbcNextV;
    private byte[] cbcV;
    private BlockCipher cipher;
    private boolean encrypting;

    public CBCBlockCipher(BlockCipher arg2) {
        super();
        this.cipher = null;
        this.cipher = arg2;
        this.blockSize = arg2.getBlockSize();
        this.IV = new byte[this.blockSize];
        this.cbcV = new byte[this.blockSize];
        this.cbcNextV = new byte[this.blockSize];
    }

    private int decryptBlock(byte[] arg6, int arg7, byte[] arg8, int arg9) {
        int v0 = 0;
        if(this.blockSize + arg7 > arg6.length) {
            throw new DataLengthException("input buffer too short");
        }

        System.arraycopy(arg6, arg7, this.cbcNextV, 0, this.blockSize);
        int v1 = this.cipher.processBlock(arg6, arg7, arg8, arg9);
        while(v0 < this.blockSize) {
            int v2 = arg9 + v0;
            arg8[v2] = ((byte)(arg8[v2] ^ this.cbcV[v0]));
            ++v0;
        }

        byte[] v0_1 = this.cbcV;
        this.cbcV = this.cbcNextV;
        this.cbcNextV = v0_1;
        return v1;
    }

    private int encryptBlock(byte[] arg6, int arg7, byte[] arg8, int arg9) {
        if(this.blockSize + arg7 > arg6.length) {
            throw new DataLengthException("input buffer too short");
        }

        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            this.cbcV[v0] = ((byte)(this.cbcV[v0] ^ arg6[arg7 + v0]));
        }

        v0 = this.cipher.processBlock(this.cbcV, 0, arg8, arg9);
        System.arraycopy(arg8, arg9, this.cbcV, 0, this.cbcV.length);
        return v0;
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/CBC";
    }

    public int getBlockSize() {
        return this.cipher.getBlockSize();
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg6, CipherParameters arg7) {
        boolean v0 = this.encrypting;
        this.encrypting = arg6;
        if((arg7 instanceof ParametersWithIV)) {
            byte[] v1 = ((ParametersWithIV)arg7).getIV();
            if(v1.length != this.blockSize) {
                throw new IllegalArgumentException("initialisation vector must be the same length as block size");
            }
            else {
                System.arraycopy(v1, 0, this.IV, 0, v1.length);
                this.reset();
                if(((ParametersWithIV)arg7).getParameters() != null) {
                    this.cipher.init(arg6, ((ParametersWithIV)arg7).getParameters());
                }
                else if(v0 != arg6) {
                    throw new IllegalArgumentException("cannot change encrypting state without providing key.");
                }
            }
        }
        else {
            this.reset();
            if(arg7 != null) {
                this.cipher.init(arg6, arg7);
            }
            else if(v0 != arg6) {
                throw new IllegalArgumentException("cannot change encrypting state without providing key.");
            }
        }
    }

    public int processBlock(byte[] arg2, int arg3, byte[] arg4, int arg5) {
        int v0 = this.encrypting ? this.encryptBlock(arg2, arg3, arg4, arg5) : this.decryptBlock(arg2, arg3, arg4, arg5);
        return v0;
    }

    public void reset() {
        System.arraycopy(this.IV, 0, this.cbcV, 0, this.IV.length);
        Arrays.fill(this.cbcNextV, 0);
        this.cipher.reset();
    }
}

