// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import java.io.ByteArrayOutputStream;
import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.macs.CBCBlockCipherMac;
import org.bouncycastle.crypto.params.AEADParameters;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.util.Arrays;

public class CCMBlockCipher implements AEADBlockCipher {
    private ByteArrayOutputStream associatedText;
    private int blockSize;
    private BlockCipher cipher;
    private ByteArrayOutputStream data;
    private boolean forEncryption;
    private byte[] initialAssociatedText;
    private CipherParameters keyParam;
    private byte[] macBlock;
    private int macSize;
    private byte[] nonce;

    public CCMBlockCipher(BlockCipher arg3) {
        super();
        this.associatedText = new ByteArrayOutputStream();
        this.data = new ByteArrayOutputStream();
        this.cipher = arg3;
        this.blockSize = arg3.getBlockSize();
        this.macBlock = new byte[this.blockSize];
        if(this.blockSize != 16) {
            throw new IllegalArgumentException("cipher required with a block size of 16.");
        }
    }

    private int calculateMac(byte[] arg9, int arg10, int arg11, byte[] arg12) {
        int v7 = 16;
        int v0 = 1;
        CBCBlockCipherMac v2 = new CBCBlockCipherMac(this.cipher, this.macSize * 8);
        ((Mac)v2).init(this.keyParam);
        byte[] v3 = new byte[v7];
        if(this.hasAssociatedText()) {
            v3[0] = ((byte)(v3[0] | 64));
        }

        v3[0] = ((byte)(v3[0] | ((((Mac)v2).getMacSize() - 2) / 2 & 7) << 3));
        v3[0] = ((byte)(v3[0] | 15 - this.nonce.length - 1 & 7));
        System.arraycopy(this.nonce, 0, v3, 1, this.nonce.length);
        int v1 = arg11;
        while(v1 > 0) {
            v3[v3.length - v0] = ((byte)(v1 & 255));
            v1 >>>= 8;
            ++v0;
        }

        ((Mac)v2).update(v3, 0, v3.length);
        if(this.hasAssociatedText()) {
            v1 = this.getAssociatedTextLength();
            if(v1 < 65280) {
                ((Mac)v2).update(((byte)(v1 >> 8)));
                ((Mac)v2).update(((byte)v1));
                v0 = 2;
            }
            else {
                ((Mac)v2).update(-1);
                ((Mac)v2).update(-2);
                ((Mac)v2).update(((byte)(v1 >> 24)));
                ((Mac)v2).update(((byte)(v1 >> 16)));
                ((Mac)v2).update(((byte)(v1 >> 8)));
                ((Mac)v2).update(((byte)v1));
                v0 = 6;
            }

            if(this.initialAssociatedText != null) {
                ((Mac)v2).update(this.initialAssociatedText, 0, this.initialAssociatedText.length);
            }

            if(this.associatedText.size() > 0) {
                v3 = this.associatedText.toByteArray();
                ((Mac)v2).update(v3, 0, v3.length);
            }

            v0 = (v0 + v1) % 16;
            if(v0 == 0) {
                goto label_99;
            }

            while(v0 != v7) {
                ((Mac)v2).update(0);
                ++v0;
            }
        }

    label_99:
        ((Mac)v2).update(arg9, arg10, arg11);
        return ((Mac)v2).doFinal(arg12, 0);
    }

    public int doFinal(byte[] arg4, int arg5) {
        byte[] v0 = this.data.toByteArray();
        v0 = this.processPacket(v0, 0, v0.length);
        System.arraycopy(v0, 0, arg4, arg5, v0.length);
        this.reset();
        return v0.length;
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/CCM";
    }

    private int getAssociatedTextLength() {
        int v1 = this.associatedText.size();
        int v0 = this.initialAssociatedText == null ? 0 : this.initialAssociatedText.length;
        return v0 + v1;
    }

    public byte[] getMac() {
        byte[] v0 = new byte[this.macSize];
        System.arraycopy(this.macBlock, 0, v0, 0, v0.length);
        return v0;
    }

    public int getOutputSize(int arg3) {
        int v0 = this.data.size() + arg3;
        if(this.forEncryption) {
            v0 += this.macSize;
        }
        else if(v0 < this.macSize) {
            v0 = 0;
        }
        else {
            v0 -= this.macSize;
        }

        return v0;
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public int getUpdateOutputSize(int arg2) {
        return 0;
    }

    private boolean hasAssociatedText() {
        boolean v0 = this.getAssociatedTextLength() > 0 ? true : false;
        return v0;
    }

    public void init(boolean arg3, CipherParameters arg4) {
        this.forEncryption = arg3;
        if((arg4 instanceof AEADParameters)) {
            this.nonce = ((AEADParameters)arg4).getNonce();
            this.initialAssociatedText = ((AEADParameters)arg4).getAssociatedText();
            this.macSize = ((AEADParameters)arg4).getMacSize() / 8;
            this.keyParam = ((AEADParameters)arg4).getKey();
        }
        else if((arg4 instanceof ParametersWithIV)) {
            this.nonce = ((ParametersWithIV)arg4).getIV();
            this.initialAssociatedText = null;
            this.macSize = this.macBlock.length / 2;
            this.keyParam = ((ParametersWithIV)arg4).getParameters();
        }
        else {
            goto label_39;
        }

        if(this.nonce != null && this.nonce.length >= 7 && this.nonce.length <= 13) {
            return;
        }

        throw new IllegalArgumentException("nonce must have length from 7 to 13 octets");
    label_39:
        throw new IllegalArgumentException("invalid parameters passed to CCM");
    }

    public void processAADByte(byte arg2) {
        this.associatedText.write(arg2);
    }

    public void processAADBytes(byte[] arg2, int arg3, int arg4) {
        this.associatedText.write(arg2, arg3, arg4);
    }

    public int processByte(byte arg2, byte[] arg3, int arg4) {
        this.data.write(arg2);
        return 0;
    }

    public int processBytes(byte[] arg2, int arg3, int arg4, byte[] arg5, int arg6) {
        this.data.write(arg2, arg3, arg4);
        return 0;
    }

    public byte[] processPacket(byte[] arg7, int arg8, int arg9) {
        byte[] v0_1;
        byte[] v4;
        if(this.keyParam == null) {
            throw new IllegalStateException("CCM cipher unitialized.");
        }

        int v0 = 15 - this.nonce.length;
        if(v0 < 4 && arg9 >= 1 << v0 * 8) {
            throw new IllegalStateException("CCM packet too large for choice of q.");
        }

        byte[] v2 = new byte[this.blockSize];
        v2[0] = ((byte)(v0 - 1 & 7));
        System.arraycopy(this.nonce, 0, v2, 1, this.nonce.length);
        SICBlockCipher v3 = new SICBlockCipher(this.cipher);
        ((BlockCipher)v3).init(this.forEncryption, new ParametersWithIV(this.keyParam, v2));
        if(this.forEncryption) {
            v2 = new byte[this.macSize + arg9];
            this.calculateMac(arg7, arg8, arg9, this.macBlock);
            ((BlockCipher)v3).processBlock(this.macBlock, 0, this.macBlock, 0);
            v0 = 0;
            while(arg8 < arg9 - this.blockSize) {
                ((BlockCipher)v3).processBlock(arg7, arg8, v2, v0);
                v0 += this.blockSize;
                arg8 += this.blockSize;
            }

            v4 = new byte[this.blockSize];
            System.arraycopy(arg7, arg8, v4, 0, arg9 - arg8);
            ((BlockCipher)v3).processBlock(v4, 0, v4, 0);
            System.arraycopy(v4, 0, v2, v0, arg9 - arg8);
            v0 += arg9 - arg8;
            System.arraycopy(this.macBlock, 0, v2, v0, v2.length - v0);
            v0_1 = v2;
        }
        else {
            v2 = new byte[arg9 - this.macSize];
            System.arraycopy(arg7, arg8 + arg9 - this.macSize, this.macBlock, 0, this.macSize);
            ((BlockCipher)v3).processBlock(this.macBlock, 0, this.macBlock, 0);
            for(v0 = this.macSize; v0 != this.macBlock.length; ++v0) {
                this.macBlock[v0] = 0;
            }

            v0 = 0;
            while(v0 < v2.length - this.blockSize) {
                ((BlockCipher)v3).processBlock(arg7, arg8, v2, v0);
                v0 += this.blockSize;
                arg8 += this.blockSize;
            }

            v4 = new byte[this.blockSize];
            System.arraycopy(arg7, arg8, v4, 0, v2.length - v0);
            ((BlockCipher)v3).processBlock(v4, 0, v4, 0);
            System.arraycopy(v4, 0, v2, v0, v2.length - v0);
            v0_1 = new byte[this.blockSize];
            this.calculateMac(v2, 0, v2.length, v0_1);
            if(!Arrays.constantTimeAreEqual(this.macBlock, v0_1)) {
                throw new InvalidCipherTextException("mac check in CCM failed");
            }
            else {
                v0_1 = v2;
            }
        }

        return v0_1;
    }

    public void reset() {
        this.cipher.reset();
        this.associatedText.reset();
        this.data.reset();
    }
}

