// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class CFBBlockCipher implements BlockCipher {
    private byte[] IV;
    private int blockSize;
    private byte[] cfbOutV;
    private byte[] cfbV;
    private BlockCipher cipher;
    private boolean encrypting;

    public CFBBlockCipher(BlockCipher arg2, int arg3) {
        super();
        this.cipher = null;
        this.cipher = arg2;
        this.blockSize = arg3 / 8;
        this.IV = new byte[arg2.getBlockSize()];
        this.cfbV = new byte[arg2.getBlockSize()];
        this.cfbOutV = new byte[arg2.getBlockSize()];
    }

    public int decryptBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        int v0 = 0;
        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg10 > arg9.length) {
            throw new DataLengthException("output buffer too short");
        }

        this.cipher.processBlock(this.cfbV, 0, this.cfbOutV, 0);
        System.arraycopy(this.cfbV, this.blockSize, this.cfbV, 0, this.cfbV.length - this.blockSize);
        System.arraycopy(arg7, arg8, this.cfbV, this.cfbV.length - this.blockSize, this.blockSize);
        while(v0 < this.blockSize) {
            arg9[arg10 + v0] = ((byte)(this.cfbOutV[v0] ^ arg7[arg8 + v0]));
            ++v0;
        }

        return this.blockSize;
    }

    public int encryptBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg10 > arg9.length) {
            throw new DataLengthException("output buffer too short");
        }

        this.cipher.processBlock(this.cfbV, 0, this.cfbOutV, 0);
        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            arg9[arg10 + v0] = ((byte)(this.cfbOutV[v0] ^ arg7[arg8 + v0]));
        }

        System.arraycopy(this.cfbV, this.blockSize, this.cfbV, 0, this.cfbV.length - this.blockSize);
        System.arraycopy(arg9, arg10, this.cfbV, this.cfbV.length - this.blockSize, this.blockSize);
        return this.blockSize;
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/CFB" + this.blockSize * 8;
    }

    public int getBlockSize() {
        return this.blockSize;
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg7, CipherParameters arg8) {
        this.encrypting = arg7;
        if((arg8 instanceof ParametersWithIV)) {
            byte[] v2 = ((ParametersWithIV)arg8).getIV();
            if(v2.length < this.IV.length) {
                System.arraycopy(v2, 0, this.IV, this.IV.length - v2.length, v2.length);
                int v0;
                for(v0 = 0; v0 < this.IV.length - v2.length; ++v0) {
                    this.IV[v0] = 0;
                }
            }
            else {
                System.arraycopy(v2, 0, this.IV, 0, this.IV.length);
            }

            this.reset();
            if(((ParametersWithIV)arg8).getParameters() == null) {
                return;
            }

            this.cipher.init(true, ((ParametersWithIV)arg8).getParameters());
        }
        else {
            this.reset();
            if(arg8 == null) {
                return;
            }

            this.cipher.init(true, arg8);
        }
    }

    public int processBlock(byte[] arg2, int arg3, byte[] arg4, int arg5) {
        int v0 = this.encrypting ? this.encryptBlock(arg2, arg3, arg4, arg5) : this.decryptBlock(arg2, arg3, arg4, arg5);
        return v0;
    }

    public void reset() {
        System.arraycopy(this.IV, 0, this.cfbV, 0, this.IV.length);
        this.cipher.reset();
    }
}

