// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.BufferedBlockCipher;
import org.bouncycastle.crypto.DataLengthException;

public class CTSBlockCipher extends BufferedBlockCipher {
    private int blockSize;

    public CTSBlockCipher(BlockCipher arg3) {
        super();
        if(!(arg3 instanceof OFBBlockCipher) && !(arg3 instanceof CFBBlockCipher)) {
            this.cipher = arg3;
            this.blockSize = arg3.getBlockSize();
            this.buf = new byte[this.blockSize * 2];
            this.bufOff = 0;
            return;
        }

        throw new IllegalArgumentException("CTSBlockCipher can only accept ECB, or CBC ciphers");
    }

    public int doFinal(byte[] arg10, int arg11) {
        if(this.bufOff + arg11 > arg10.length) {
            throw new DataLengthException("output buffer to small in doFinal");
        }

        int v1 = this.cipher.getBlockSize();
        int v2 = this.bufOff - v1;
        byte[] v3 = new byte[v1];
        if(this.forEncryption) {
            this.cipher.processBlock(this.buf, 0, v3, 0);
            if(this.bufOff < v1) {
                throw new DataLengthException("need at least one block of input for CTS");
            }
            else {
                int v0;
                for(v0 = this.bufOff; v0 != this.buf.length; ++v0) {
                    this.buf[v0] = v3[v0 - v1];
                }

                for(v0 = v1; v0 != this.bufOff; ++v0) {
                    this.buf[v0] = ((byte)(this.buf[v0] ^ v3[v0 - v1]));
                }

                if((this.cipher instanceof CBCBlockCipher)) {
                    this.cipher.getUnderlyingCipher().processBlock(this.buf, v1, arg10, arg11);
                }
                else {
                    this.cipher.processBlock(this.buf, v1, arg10, arg11);
                }

                System.arraycopy(v3, 0, arg10, arg11 + v1, v2);
            }
        }
        else {
            byte[] v4 = new byte[v1];
            if((this.cipher instanceof CBCBlockCipher)) {
                this.cipher.getUnderlyingCipher().processBlock(this.buf, 0, v3, 0);
            }
            else {
                this.cipher.processBlock(this.buf, 0, v3, 0);
            }

            for(v0 = v1; v0 != this.bufOff; ++v0) {
                v4[v0 - v1] = ((byte)(v3[v0 - v1] ^ this.buf[v0]));
            }

            System.arraycopy(this.buf, v1, v3, 0, v2);
            this.cipher.processBlock(v3, 0, arg10, arg11);
            System.arraycopy(v4, 0, arg10, arg11 + v1, v2);
        }

        v0 = this.bufOff;
        this.reset();
        return v0;
    }

    public int getOutputSize(int arg2) {
        return this.bufOff + arg2;
    }

    public int getUpdateOutputSize(int arg3) {
        int v0 = this.bufOff + arg3;
        int v1 = v0 % this.buf.length;
        return v1 == 0 ? this.buf.length : v1;
    }

    public int processByte(byte arg7, byte[] arg8, int arg9) {
        int v0;
        if(this.bufOff == this.buf.length) {
            v0 = this.cipher.processBlock(this.buf, 0, arg8, arg9);
            System.arraycopy(this.buf, this.blockSize, this.buf, 0, this.blockSize);
            this.bufOff = this.blockSize;
        }
        else {
            v0 = 0;
        }

        byte[] v1 = this.buf;
        int v2 = this.bufOff;
        this.bufOff = v2 + 1;
        v1[v2] = arg7;
        return v0;
    }

    public int processBytes(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        if(arg9 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v2 = this.getBlockSize();
        int v0 = this.getUpdateOutputSize(arg9);
        if(v0 > 0 && v0 + arg11 > arg10.length) {
            throw new DataLengthException("output buffer too short");
        }

        int v3 = this.buf.length - this.bufOff;
        if(arg9 > v3) {
            System.arraycopy(arg7, arg8, this.buf, this.bufOff, v3);
            v0 = this.cipher.processBlock(this.buf, 0, arg10, arg11);
            System.arraycopy(this.buf, v2, this.buf, 0, v2);
            this.bufOff = v2;
            arg9 -= v3;
            arg8 += v3;
            while(arg9 > v2) {
                System.arraycopy(arg7, arg8, this.buf, this.bufOff, v2);
                v0 += this.cipher.processBlock(this.buf, 0, arg10, arg11 + v0);
                System.arraycopy(this.buf, v2, this.buf, 0, v2);
                arg9 -= v2;
                arg8 += v2;
            }
        }
        else {
            v0 = 0;
        }

        System.arraycopy(arg7, arg8, this.buf, this.bufOff, arg9);
        this.bufOff += arg9;
        return v0;
    }
}

