// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class GOFBBlockCipher implements BlockCipher {
    static final int C1 = 16843012;
    static final int C2 = 16843009;
    private byte[] IV;
    int N3;
    int N4;
    private final int blockSize;
    private final BlockCipher cipher;
    boolean firstStep;
    private byte[] ofbOutV;
    private byte[] ofbV;

    public GOFBBlockCipher(BlockCipher arg3) {
        super();
        this.firstStep = true;
        this.cipher = arg3;
        this.blockSize = arg3.getBlockSize();
        if(this.blockSize != 8) {
            throw new IllegalArgumentException("GCTR only for 64 bit block ciphers");
        }

        this.IV = new byte[arg3.getBlockSize()];
        this.ofbV = new byte[arg3.getBlockSize()];
        this.ofbOutV = new byte[arg3.getBlockSize()];
    }

    private int bytesToint(byte[] arg4, int arg5) {
        return (arg4[arg5 + 3] << 24 & -16777216) + (arg4[arg5 + 2] << 16 & 16711680) + (arg4[arg5 + 1] << 8 & 65280) + (arg4[arg5] & 255);
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/GCTR";
    }

    public int getBlockSize() {
        return this.blockSize;
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg7, CipherParameters arg8) {
        this.firstStep = true;
        this.N3 = 0;
        this.N4 = 0;
        if((arg8 instanceof ParametersWithIV)) {
            byte[] v2 = ((ParametersWithIV)arg8).getIV();
            if(v2.length < this.IV.length) {
                System.arraycopy(v2, 0, this.IV, this.IV.length - v2.length, v2.length);
                int v0;
                for(v0 = 0; v0 < this.IV.length - v2.length; ++v0) {
                    this.IV[v0] = 0;
                }
            }
            else {
                System.arraycopy(v2, 0, this.IV, 0, this.IV.length);
            }

            this.reset();
            if(((ParametersWithIV)arg8).getParameters() == null) {
                return;
            }

            this.cipher.init(true, ((ParametersWithIV)arg8).getParameters());
        }
        else {
            this.reset();
            if(arg8 == null) {
                return;
            }

            this.cipher.init(true, arg8);
        }
    }

    private void intTobytes(int arg3, byte[] arg4, int arg5) {
        arg4[arg5 + 3] = ((byte)(arg3 >>> 24));
        arg4[arg5 + 2] = ((byte)(arg3 >>> 16));
        arg4[arg5 + 1] = ((byte)(arg3 >>> 8));
        arg4[arg5] = ((byte)arg3);
    }

    public int processBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        int v4 = 4;
        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg10 > arg9.length) {
            throw new DataLengthException("output buffer too short");
        }

        if(this.firstStep) {
            this.firstStep = false;
            this.cipher.processBlock(this.ofbV, 0, this.ofbOutV, 0);
            this.N3 = this.bytesToint(this.ofbOutV, 0);
            this.N4 = this.bytesToint(this.ofbOutV, v4);
        }

        this.N3 += 16843009;
        this.N4 += 16843012;
        this.intTobytes(this.N3, this.ofbV, 0);
        this.intTobytes(this.N4, this.ofbV, v4);
        this.cipher.processBlock(this.ofbV, 0, this.ofbOutV, 0);
        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            arg9[arg10 + v0] = ((byte)(this.ofbOutV[v0] ^ arg7[arg8 + v0]));
        }

        System.arraycopy(this.ofbV, this.blockSize, this.ofbV, 0, this.ofbV.length - this.blockSize);
        System.arraycopy(this.ofbOutV, 0, this.ofbV, this.ofbV.length - this.blockSize, this.blockSize);
        return this.blockSize;
    }

    public void reset() {
        System.arraycopy(this.IV, 0, this.ofbV, 0, this.IV.length);
        this.cipher.reset();
    }
}

