// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import java.util.Vector;
import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.params.AEADParameters;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.util.Arrays;

public class OCBBlockCipher implements AEADBlockCipher {
    private static final int BLOCK_SIZE = 16;
    private byte[] Checksum;
    private Vector L;
    private byte[] L_Asterisk;
    private byte[] L_Dollar;
    private byte[] OffsetHASH;
    private byte[] OffsetMAIN;
    private byte[] OffsetMAIN_0;
    private byte[] Sum;
    private boolean forEncryption;
    private byte[] hashBlock;
    private long hashBlockCount;
    private int hashBlockPos;
    private BlockCipher hashCipher;
    private byte[] initialAssociatedText;
    private byte[] macBlock;
    private int macSize;
    private byte[] mainBlock;
    private long mainBlockCount;
    private int mainBlockPos;
    private BlockCipher mainCipher;

    public OCBBlockCipher(BlockCipher arg3, BlockCipher arg4) {
        int v1 = 16;
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'hashCipher\' cannot be null");
        }

        if(arg3.getBlockSize() != v1) {
            throw new IllegalArgumentException("\'hashCipher\' must have a block size of 16");
        }

        if(arg4 == null) {
            throw new IllegalArgumentException("\'mainCipher\' cannot be null");
        }

        if(arg4.getBlockSize() != v1) {
            throw new IllegalArgumentException("\'mainCipher\' must have a block size of 16");
        }

        if(!arg3.getAlgorithmName().equals(arg4.getAlgorithmName())) {
            throw new IllegalArgumentException("\'hashCipher\' and \'mainCipher\' must be the same algorithm");
        }

        this.hashCipher = arg3;
        this.mainCipher = arg4;
    }

    protected static byte[] OCB_double(byte[] arg5) {
        byte[] v0 = new byte[16];
        v0[15] = ((byte)(135 >>> (1 - OCBBlockCipher.shiftLeft(arg5, v0) << 3) ^ v0[15]));
        return v0;
    }

    protected static void OCB_extend(byte[] arg1, int arg2) {
        arg1[arg2] = -128;
        while(true) {
            ++arg2;
            if(arg2 >= 16) {
                return;
            }

            arg1[arg2] = 0;
        }
    }

    protected static int OCB_ntz(long arg5) {
        int v0;
        long v3 = 0;
        if(arg5 == v3) {
            v0 = 64;
        }
        else {
            v0 = 0;
            while((1 & arg5) == v3) {
                ++v0;
                arg5 >>= 1;
            }
        }

        return v0;
    }

    protected void clear(byte[] arg2) {
        if(arg2 != null) {
            Arrays.fill(arg2, 0);
        }
    }

    public int doFinal(byte[] arg6, int arg7) {
        int v0_1;
        byte[] v0 = null;
        if(!this.forEncryption) {
            if(this.mainBlockPos < this.macSize) {
                throw new InvalidCipherTextException("data too short");
            }
            else {
                this.mainBlockPos -= this.macSize;
                v0 = new byte[this.macSize];
                System.arraycopy(this.mainBlock, this.mainBlockPos, v0, 0, this.macSize);
            }
        }

        if(this.hashBlockPos > 0) {
            OCBBlockCipher.OCB_extend(this.hashBlock, this.hashBlockPos);
            this.updateHASH(this.L_Asterisk);
        }

        if(this.mainBlockPos > 0) {
            if(this.forEncryption) {
                OCBBlockCipher.OCB_extend(this.mainBlock, this.mainBlockPos);
                OCBBlockCipher.xor(this.Checksum, this.mainBlock);
            }

            OCBBlockCipher.xor(this.OffsetMAIN, this.L_Asterisk);
            byte[] v1 = new byte[16];
            this.hashCipher.processBlock(this.OffsetMAIN, 0, v1, 0);
            OCBBlockCipher.xor(this.mainBlock, v1);
            System.arraycopy(this.mainBlock, 0, arg6, arg7, this.mainBlockPos);
            if(this.forEncryption) {
                goto label_59;
            }

            OCBBlockCipher.OCB_extend(this.mainBlock, this.mainBlockPos);
            OCBBlockCipher.xor(this.Checksum, this.mainBlock);
        }

    label_59:
        OCBBlockCipher.xor(this.Checksum, this.OffsetMAIN);
        OCBBlockCipher.xor(this.Checksum, this.L_Dollar);
        this.hashCipher.processBlock(this.Checksum, 0, this.Checksum, 0);
        OCBBlockCipher.xor(this.Checksum, this.Sum);
        this.macBlock = new byte[this.macSize];
        System.arraycopy(this.Checksum, 0, this.macBlock, 0, this.macSize);
        int v1_1 = this.mainBlockPos;
        if(this.forEncryption) {
            System.arraycopy(this.macBlock, 0, arg6, arg7 + v1_1, this.macSize);
            v0_1 = this.macSize + v1_1;
        }
        else if(!Arrays.constantTimeAreEqual(this.macBlock, v0)) {
            throw new InvalidCipherTextException("mac check in OCB failed");
        }
        else {
            v0_1 = v1_1;
        }

        this.reset(false);
        return v0_1;
    }

    public String getAlgorithmName() {
        return this.mainCipher.getAlgorithmName() + "/OCB";
    }

    protected byte[] getLSub(int arg3) {
        while(arg3 >= this.L.size()) {
            this.L.addElement(OCBBlockCipher.OCB_double(this.L.lastElement()));
        }

        return this.L.elementAt(arg3);
    }

    public byte[] getMac() {
        return Arrays.clone(this.macBlock);
    }

    public int getOutputSize(int arg3) {
        int v0 = this.mainBlockPos + arg3;
        if(this.forEncryption) {
            v0 += this.macSize;
        }
        else if(v0 < this.macSize) {
            v0 = 0;
        }
        else {
            v0 -= this.macSize;
        }

        return v0;
    }

    public BlockCipher getUnderlyingCipher() {
        return this.mainCipher;
    }

    public int getUpdateOutputSize(int arg3) {
        int v0 = this.mainBlockPos + arg3;
        if(this.forEncryption) {
        label_10:
            v0 -= v0 % 16;
        }
        else if(v0 < this.macSize) {
            v0 = 0;
        }
        else {
            v0 -= this.macSize;
            goto label_10;
        }

        return v0;
    }

    public void init(boolean arg12, CipherParameters arg13) {
        byte[] v1_2;
        KeyParameter v1_1;
        int v1;
        byte[] v0;
        byte[] v2 = null;
        int v7 = 15;
        int v3 = 16;
        this.forEncryption = arg12;
        this.macBlock = v2;
        if((arg13 instanceof AEADParameters)) {
            v0 = ((AEADParameters)arg13).getNonce();
            this.initialAssociatedText = ((AEADParameters)arg13).getAssociatedText();
            v1 = ((AEADParameters)arg13).getMacSize();
            if(v1 >= 64 && v1 <= 128 && v1 % 8 == 0) {
                this.macSize = v1 / 8;
                v1_1 = ((AEADParameters)arg13).getKey();
                goto label_31;
            }

            throw new IllegalArgumentException("Invalid value for MAC size: " + v1);
        }
        else {
            if(!(arg13 instanceof ParametersWithIV)) {
                goto label_60;
            }

            v1_2 = ((ParametersWithIV)arg13).getIV();
            this.initialAssociatedText = v2;
            this.macSize = v3;
            byte[] v10 = v1_2;
            CipherParameters v1_3 = ((ParametersWithIV)arg13).getParameters();
            v0 = v10;
        }

    label_31:
        this.hashBlock = new byte[v3];
        int v2_1 = arg12 ? v3 : this.macSize + 16;
        this.mainBlock = new byte[v2_1];
        if(v0 == null) {
            v0 = new byte[0];
        }

        if(v0.length <= v3 && (v0.length != v3 || (v0[0] & 128) == 0)) {
            this.hashCipher.init(true, ((CipherParameters)v1_1));
            this.mainCipher.init(arg12, ((CipherParameters)v1_1));
            this.L_Asterisk = new byte[v3];
            this.hashCipher.processBlock(this.L_Asterisk, 0, this.L_Asterisk, 0);
            this.L_Dollar = OCBBlockCipher.OCB_double(this.L_Asterisk);
            this.L = new Vector();
            this.L.addElement(OCBBlockCipher.OCB_double(this.L_Dollar));
            v1_2 = new byte[v3];
            System.arraycopy(v0, 0, v1_2, v1_2.length - v0.length, v0.length);
            if(v0.length == v3) {
                v1_2[0] = ((byte)(v1_2[0] & 128));
            }
            else {
                v1_2[15 - v0.length] = 1;
            }

            v2_1 = v1_2[v7] & 63;
            byte[] v5 = new byte[v3];
            v1_2[v7] = ((byte)(v1_2[v7] & 192));
            this.hashCipher.processBlock(v1_2, 0, v5, 0);
            byte[] v6 = new byte[24];
            System.arraycopy(v5, 0, v6, 0, v3);
            int v0_1;
            for(v0_1 = 0; v0_1 < 8; ++v0_1) {
                v6[v0_1 + 16] = ((byte)(v5[v0_1] ^ v5[v0_1 + 1]));
            }

            this.OffsetMAIN_0 = new byte[v3];
            int v5_1 = v2_1 % 8;
            v0_1 = v2_1 / 8;
            if(v5_1 == 0) {
                System.arraycopy(v6, v0_1, this.OffsetMAIN_0, 0, v3);
            }
            else {
                v1 = v0_1;
                for(v0_1 = 0; v0_1 < v3; ++v0_1) {
                    v2_1 = v6[v1] & 255;
                    ++v1;
                    this.OffsetMAIN_0[v0_1] = ((byte)(v2_1 << v5_1 | (v6[v1] & 255) >>> 8 - v5_1));
                }
            }

            this.hashBlockPos = 0;
            this.mainBlockPos = 0;
            this.hashBlockCount = 0;
            this.mainBlockCount = 0;
            this.OffsetHASH = new byte[v3];
            this.Sum = new byte[v3];
            this.OffsetMAIN = Arrays.clone(this.OffsetMAIN_0);
            this.Checksum = new byte[v3];
            if(this.initialAssociatedText != null) {
                this.processAADBytes(this.initialAssociatedText, 0, this.initialAssociatedText.length);
            }

            return;
        }

        throw new IllegalArgumentException("IV must be no more than 127 bits");
    label_60:
        throw new IllegalArgumentException("invalid parameters passed to OCB");
    }

    public void processAADByte(byte arg3) {
        this.hashBlock[this.hashBlockPos] = arg3;
        int v0 = this.hashBlockPos + 1;
        this.hashBlockPos = v0;
        if(v0 == this.hashBlock.length) {
            this.processHashBlock();
        }
    }

    public void processAADBytes(byte[] arg5, int arg6, int arg7) {
        int v0;
        for(v0 = 0; v0 < arg7; ++v0) {
            this.hashBlock[this.hashBlockPos] = arg5[arg6 + v0];
            int v1 = this.hashBlockPos + 1;
            this.hashBlockPos = v1;
            if(v1 == this.hashBlock.length) {
                this.processHashBlock();
            }
        }
    }

    public int processByte(byte arg3, byte[] arg4, int arg5) {
        this.mainBlock[this.mainBlockPos] = arg3;
        int v0 = this.mainBlockPos + 1;
        this.mainBlockPos = v0;
        if(v0 == this.mainBlock.length) {
            this.processMainBlock(arg4, arg5);
            v0 = 16;
        }
        else {
            v0 = 0;
        }

        return v0;
    }

    public int processBytes(byte[] arg6, int arg7, int arg8, byte[] arg9, int arg10) {
        int v0 = 0;
        int v1;
        for(v1 = 0; v1 < arg8; ++v1) {
            this.mainBlock[this.mainBlockPos] = arg6[arg7 + v1];
            int v2 = this.mainBlockPos + 1;
            this.mainBlockPos = v2;
            if(v2 == this.mainBlock.length) {
                this.processMainBlock(arg9, arg10 + v0);
                v0 += 16;
            }
        }

        return v0;
    }

    protected void processHashBlock() {
        long v0 = this.hashBlockCount + 1;
        this.hashBlockCount = v0;
        this.updateHASH(this.getLSub(OCBBlockCipher.OCB_ntz(v0)));
        this.hashBlockPos = 0;
    }

    protected void processMainBlock(byte[] arg8, int arg9) {
        int v6 = 16;
        if(this.forEncryption) {
            OCBBlockCipher.xor(this.Checksum, this.mainBlock);
            this.mainBlockPos = 0;
        }

        byte[] v0 = this.OffsetMAIN;
        long v1 = this.mainBlockCount + 1;
        this.mainBlockCount = v1;
        OCBBlockCipher.xor(v0, this.getLSub(OCBBlockCipher.OCB_ntz(v1)));
        OCBBlockCipher.xor(this.mainBlock, this.OffsetMAIN);
        this.mainCipher.processBlock(this.mainBlock, 0, this.mainBlock, 0);
        OCBBlockCipher.xor(this.mainBlock, this.OffsetMAIN);
        System.arraycopy(this.mainBlock, 0, arg8, arg9, v6);
        if(!this.forEncryption) {
            OCBBlockCipher.xor(this.Checksum, this.mainBlock);
            System.arraycopy(this.mainBlock, v6, this.mainBlock, 0, this.macSize);
            this.mainBlockPos = this.macSize;
        }
    }

    protected void reset(boolean arg5) {
        this.hashCipher.reset();
        this.mainCipher.reset();
        this.clear(this.hashBlock);
        this.clear(this.mainBlock);
        this.hashBlockPos = 0;
        this.mainBlockPos = 0;
        this.hashBlockCount = 0;
        this.mainBlockCount = 0;
        this.clear(this.OffsetHASH);
        this.clear(this.Sum);
        System.arraycopy(this.OffsetMAIN_0, 0, this.OffsetMAIN, 0, 16);
        this.clear(this.Checksum);
        if(arg5) {
            this.macBlock = null;
        }

        if(this.initialAssociatedText != null) {
            this.processAADBytes(this.initialAssociatedText, 0, this.initialAssociatedText.length);
        }
    }

    public void reset() {
        this.reset(true);
    }

    protected static int shiftLeft(byte[] arg4, byte[] arg5) {
        int v1 = 16;
        int v0;
        for(v0 = 0; true; v0 = v2 >>> 7 & 1) {
            --v1;
            if(v1 < 0) {
                return v0;
            }

            int v2 = arg4[v1] & 255;
            arg5[v1] = ((byte)(v0 | v2 << 1));
        }

        return v0;
    }

    protected void updateHASH(byte[] arg5) {
        OCBBlockCipher.xor(this.OffsetHASH, arg5);
        OCBBlockCipher.xor(this.hashBlock, this.OffsetHASH);
        this.hashCipher.processBlock(this.hashBlock, 0, this.hashBlock, 0);
        OCBBlockCipher.xor(this.Sum, this.hashBlock);
    }

    protected static void xor(byte[] arg3, byte[] arg4) {
        int v0;
        for(v0 = 15; v0 >= 0; --v0) {
            arg3[v0] = ((byte)(arg3[v0] ^ arg4[v0]));
        }
    }
}

