// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class OFBBlockCipher implements BlockCipher {
    private byte[] IV;
    private final int blockSize;
    private final BlockCipher cipher;
    private byte[] ofbOutV;
    private byte[] ofbV;

    public OFBBlockCipher(BlockCipher arg2, int arg3) {
        super();
        this.cipher = arg2;
        this.blockSize = arg3 / 8;
        this.IV = new byte[arg2.getBlockSize()];
        this.ofbV = new byte[arg2.getBlockSize()];
        this.ofbOutV = new byte[arg2.getBlockSize()];
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/OFB" + this.blockSize * 8;
    }

    public int getBlockSize() {
        return this.blockSize;
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg7, CipherParameters arg8) {
        if((arg8 instanceof ParametersWithIV)) {
            byte[] v2 = ((ParametersWithIV)arg8).getIV();
            if(v2.length < this.IV.length) {
                System.arraycopy(v2, 0, this.IV, this.IV.length - v2.length, v2.length);
                int v0;
                for(v0 = 0; v0 < this.IV.length - v2.length; ++v0) {
                    this.IV[v0] = 0;
                }
            }
            else {
                System.arraycopy(v2, 0, this.IV, 0, this.IV.length);
            }

            this.reset();
            if(((ParametersWithIV)arg8).getParameters() == null) {
                return;
            }

            this.cipher.init(true, ((ParametersWithIV)arg8).getParameters());
        }
        else {
            this.reset();
            if(arg8 == null) {
                return;
            }

            this.cipher.init(true, arg8);
        }
    }

    public int processBlock(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg10 > arg9.length) {
            throw new DataLengthException("output buffer too short");
        }

        this.cipher.processBlock(this.ofbV, 0, this.ofbOutV, 0);
        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            arg9[arg10 + v0] = ((byte)(this.ofbOutV[v0] ^ arg7[arg8 + v0]));
        }

        System.arraycopy(this.ofbV, this.blockSize, this.ofbV, 0, this.ofbV.length - this.blockSize);
        System.arraycopy(this.ofbOutV, 0, this.ofbV, this.ofbV.length - this.blockSize, this.blockSize);
        return this.blockSize;
    }

    public void reset() {
        System.arraycopy(this.IV, 0, this.ofbV, 0, this.IV.length);
        this.cipher.reset();
    }
}

