// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;

public class OpenPGPCFBBlockCipher implements BlockCipher {
    private byte[] FR;
    private byte[] FRE;
    private byte[] IV;
    private int blockSize;
    private BlockCipher cipher;
    private int count;
    private boolean forEncryption;

    public OpenPGPCFBBlockCipher(BlockCipher arg2) {
        super();
        this.cipher = arg2;
        this.blockSize = arg2.getBlockSize();
        this.IV = new byte[this.blockSize];
        this.FR = new byte[this.blockSize];
        this.FRE = new byte[this.blockSize];
    }

    private int decryptBlock(byte[] arg8, int arg9, byte[] arg10, int arg11) {
        byte v1;
        byte v2;
        int v0 = 2;
        if(this.blockSize + arg9 > arg8.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg11 > arg10.length) {
            throw new DataLengthException("output buffer too short");
        }

        if(this.count > this.blockSize) {
            v2 = arg8[arg9];
            this.FR[this.blockSize - 2] = v2;
            arg10[arg11] = this.encryptByte(v2, this.blockSize - 2);
            v2 = arg8[arg9 + 1];
            this.FR[this.blockSize - 1] = v2;
            arg10[arg11 + 1] = this.encryptByte(v2, this.blockSize - 1);
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            while(v0 < this.blockSize) {
                v1 = arg8[arg9 + v0];
                this.FR[v0 - 2] = v1;
                arg10[arg11 + v0] = this.encryptByte(v1, v0 - 2);
                ++v0;
            }
        }
        else if(this.count == 0) {
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            for(v0 = 0; v0 < this.blockSize; ++v0) {
                this.FR[v0] = arg8[arg9 + v0];
                arg10[v0] = this.encryptByte(arg8[arg9 + v0], v0);
            }

            this.count += this.blockSize;
        }
        else if(this.count == this.blockSize) {
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            v2 = arg8[arg9];
            byte v3 = arg8[arg9 + 1];
            arg10[arg11] = this.encryptByte(v2, 0);
            arg10[arg11 + 1] = this.encryptByte(v3, 1);
            System.arraycopy(this.FR, v0, this.FR, 0, this.blockSize - 2);
            this.FR[this.blockSize - 2] = v2;
            this.FR[this.blockSize - 1] = v3;
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            while(v0 < this.blockSize) {
                v1 = arg8[arg9 + v0];
                this.FR[v0 - 2] = v1;
                arg10[arg11 + v0] = this.encryptByte(v1, v0 - 2);
                ++v0;
            }

            this.count += this.blockSize;
        }

        return this.blockSize;
    }

    private int encryptBlock(byte[] arg8, int arg9, byte[] arg10, int arg11) {
        byte[] v1;
        byte v4;
        int v0 = 2;
        if(this.blockSize + arg9 > arg8.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg11 > arg10.length) {
            throw new DataLengthException("output buffer too short");
        }

        if(this.count > this.blockSize) {
            byte[] v2 = this.FR;
            int v3 = this.blockSize - 2;
            v4 = this.encryptByte(arg8[arg9], this.blockSize - 2);
            arg10[arg11] = v4;
            v2[v3] = v4;
            v2 = this.FR;
            v3 = this.blockSize - 1;
            byte v5 = this.encryptByte(arg8[arg9 + 1], this.blockSize - 1);
            arg10[arg11 + 1] = v5;
            v2[v3] = v5;
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            while(v0 < this.blockSize) {
                v1 = this.FR;
                v4 = this.encryptByte(arg8[arg9 + v0], v0 - 2);
                arg10[arg11 + v0] = v4;
                v1[v0 - 2] = v4;
                ++v0;
            }
        }
        else if(this.count == 0) {
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            for(v0 = 0; v0 < this.blockSize; ++v0) {
                v1 = this.FR;
                byte v3_1 = this.encryptByte(arg8[arg9 + v0], v0);
                arg10[arg11 + v0] = v3_1;
                v1[v0] = v3_1;
            }

            this.count += this.blockSize;
        }
        else if(this.count == this.blockSize) {
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            arg10[arg11] = this.encryptByte(arg8[arg9], 0);
            arg10[arg11 + 1] = this.encryptByte(arg8[arg9 + 1], 1);
            System.arraycopy(this.FR, v0, this.FR, 0, this.blockSize - 2);
            System.arraycopy(arg10, arg11, this.FR, this.blockSize - 2, v0);
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            while(v0 < this.blockSize) {
                v1 = this.FR;
                v4 = this.encryptByte(arg8[arg9 + v0], v0 - 2);
                arg10[arg11 + v0] = v4;
                v1[v0 - 2] = v4;
                ++v0;
            }

            this.count += this.blockSize;
        }

        return this.blockSize;
    }

    private byte encryptByte(byte arg2, int arg3) {
        return ((byte)(this.FRE[arg3] ^ arg2));
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/OpenPGPCFB";
    }

    public int getBlockSize() {
        return this.cipher.getBlockSize();
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg3, CipherParameters arg4) {
        this.forEncryption = arg3;
        this.reset();
        this.cipher.init(true, arg4);
    }

    public int processBlock(byte[] arg2, int arg3, byte[] arg4, int arg5) {
        int v0 = this.forEncryption ? this.encryptBlock(arg2, arg3, arg4, arg5) : this.decryptBlock(arg2, arg3, arg4, arg5);
        return v0;
    }

    public void reset() {
        this.count = 0;
        System.arraycopy(this.IV, 0, this.FR, 0, this.FR.length);
        this.cipher.reset();
    }
}

