// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class PGPCFBBlockCipher implements BlockCipher {
    private byte[] FR;
    private byte[] FRE;
    private byte[] IV;
    private int blockSize;
    private BlockCipher cipher;
    private int count;
    private boolean forEncryption;
    private boolean inlineIv;
    private byte[] tmp;

    public PGPCFBBlockCipher(BlockCipher arg2, boolean arg3) {
        super();
        this.cipher = arg2;
        this.inlineIv = arg3;
        this.blockSize = arg2.getBlockSize();
        this.IV = new byte[this.blockSize];
        this.FR = new byte[this.blockSize];
        this.FRE = new byte[this.blockSize];
        this.tmp = new byte[this.blockSize];
    }

    private int decryptBlock(byte[] arg5, int arg6, byte[] arg7, int arg8) {
        int v1 = 0;
        if(this.blockSize + arg6 > arg5.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("output buffer too short");
        }

        this.cipher.processBlock(this.FR, 0, this.FRE, 0);
        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            arg7[arg8 + v0] = this.encryptByte(arg5[arg6 + v0], v0);
        }

        while(v1 < this.blockSize) {
            this.FR[v1] = arg5[arg6 + v1];
            ++v1;
        }

        return this.blockSize;
    }

    private int decryptBlockWithIV(byte[] arg7, int arg8, byte[] arg9, int arg10) {
        int v5 = 2;
        int v1 = 0;
        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg10 > arg9.length) {
            throw new DataLengthException("output buffer too short");
        }

        if(this.count == 0) {
            int v0;
            for(v0 = 0; v0 < this.blockSize; ++v0) {
                this.FR[v0] = arg7[arg8 + v0];
            }

            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            this.count += this.blockSize;
        }
        else if(this.count == this.blockSize) {
            System.arraycopy(arg7, arg8, this.tmp, 0, this.blockSize);
            System.arraycopy(this.FR, v5, this.FR, 0, this.blockSize - 2);
            this.FR[this.blockSize - 2] = this.tmp[0];
            this.FR[this.blockSize - 1] = this.tmp[1];
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            for(v0 = 0; v0 < this.blockSize - 2; ++v0) {
                arg9[arg10 + v0] = this.encryptByte(this.tmp[v0 + 2], v0);
            }

            System.arraycopy(this.tmp, v5, this.FR, 0, this.blockSize - 2);
            this.count += 2;
            v1 = this.blockSize - 2;
        }
        else {
            if(this.count >= this.blockSize + 2) {
                System.arraycopy(arg7, arg8, this.tmp, 0, this.blockSize);
                arg9[arg10] = this.encryptByte(this.tmp[0], this.blockSize - 2);
                arg9[arg10 + 1] = this.encryptByte(this.tmp[1], this.blockSize - 1);
                System.arraycopy(this.tmp, 0, this.FR, this.blockSize - 2, v5);
                this.cipher.processBlock(this.FR, 0, this.FRE, 0);
                for(v0 = 0; v0 < this.blockSize - 2; ++v0) {
                    arg9[arg10 + v0 + 2] = this.encryptByte(this.tmp[v0 + 2], v0);
                }

                System.arraycopy(this.tmp, v5, this.FR, 0, this.blockSize - 2);
            }

            v1 = this.blockSize;
        }

        return v1;
    }

    private int encryptBlock(byte[] arg5, int arg6, byte[] arg7, int arg8) {
        int v1 = 0;
        if(this.blockSize + arg6 > arg5.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("output buffer too short");
        }

        this.cipher.processBlock(this.FR, 0, this.FRE, 0);
        int v0;
        for(v0 = 0; v0 < this.blockSize; ++v0) {
            arg7[arg8 + v0] = this.encryptByte(arg5[arg6 + v0], v0);
        }

        while(v1 < this.blockSize) {
            this.FR[v1] = arg7[arg8 + v1];
            ++v1;
        }

        return this.blockSize;
    }

    private int encryptBlockWithIV(byte[] arg5, int arg6, byte[] arg7, int arg8) {
        if(this.blockSize + arg6 > arg5.length) {
            throw new DataLengthException("input buffer too short");
        }

        if(this.blockSize + arg8 > arg7.length) {
            throw new DataLengthException("output buffer too short");
        }

        if(this.count == 0) {
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            int v0;
            for(v0 = 0; v0 < this.blockSize; ++v0) {
                arg7[arg8 + v0] = this.encryptByte(this.IV[v0], v0);
            }

            System.arraycopy(arg7, arg8, this.FR, 0, this.blockSize);
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            arg7[this.blockSize + arg8] = this.encryptByte(this.IV[this.blockSize - 2], 0);
            arg7[this.blockSize + arg8 + 1] = this.encryptByte(this.IV[this.blockSize - 1], 1);
            System.arraycopy(arg7, arg8 + 2, this.FR, 0, this.blockSize);
            this.cipher.processBlock(this.FR, 0, this.FRE, 0);
            for(v0 = 0; v0 < this.blockSize; ++v0) {
                arg7[this.blockSize + arg8 + 2 + v0] = this.encryptByte(arg5[arg6 + v0], v0);
            }

            System.arraycopy(arg7, this.blockSize + arg8 + 2, this.FR, 0, this.blockSize);
            this.count += this.blockSize * 2 + 2;
            v0 = this.blockSize * 2 + 2;
        }
        else {
            if(this.count >= this.blockSize + 2) {
                this.cipher.processBlock(this.FR, 0, this.FRE, 0);
                for(v0 = 0; v0 < this.blockSize; ++v0) {
                    arg7[arg8 + v0] = this.encryptByte(arg5[arg6 + v0], v0);
                }

                System.arraycopy(arg7, arg8, this.FR, 0, this.blockSize);
            }

            v0 = this.blockSize;
        }

        return v0;
    }

    private byte encryptByte(byte arg2, int arg3) {
        return ((byte)(this.FRE[arg3] ^ arg2));
    }

    public String getAlgorithmName() {
        String v0 = this.inlineIv ? this.cipher.getAlgorithmName() + "/PGPCFBwithIV" : this.cipher.getAlgorithmName() + "/PGPCFB";
        return v0;
    }

    public int getBlockSize() {
        return this.cipher.getBlockSize();
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg7, CipherParameters arg8) {
        this.forEncryption = arg7;
        if((arg8 instanceof ParametersWithIV)) {
            byte[] v2 = ((ParametersWithIV)arg8).getIV();
            if(v2.length < this.IV.length) {
                System.arraycopy(v2, 0, this.IV, this.IV.length - v2.length, v2.length);
                int v0;
                for(v0 = 0; v0 < this.IV.length - v2.length; ++v0) {
                    this.IV[v0] = 0;
                }
            }
            else {
                System.arraycopy(v2, 0, this.IV, 0, this.IV.length);
            }

            this.reset();
            this.cipher.init(true, ((ParametersWithIV)arg8).getParameters());
        }
        else {
            this.reset();
            this.cipher.init(true, arg8);
        }
    }

    public int processBlock(byte[] arg2, int arg3, byte[] arg4, int arg5) {
        int v0;
        if(this.inlineIv) {
            v0 = this.forEncryption ? this.encryptBlockWithIV(arg2, arg3, arg4, arg5) : this.decryptBlockWithIV(arg2, arg3, arg4, arg5);
        }
        else if(this.forEncryption) {
            v0 = this.encryptBlock(arg2, arg3, arg4, arg5);
        }
        else {
            v0 = this.decryptBlock(arg2, arg3, arg4, arg5);
        }

        return v0;
    }

    public void reset() {
        this.count = 0;
        int v0;
        for(v0 = 0; v0 != this.FR.length; ++v0) {
            this.FR[v0] = this.inlineIv ? 0 : this.IV[v0];
        }

        this.cipher.reset();
    }
}

