// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.BufferedBlockCipher;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.InvalidCipherTextException;

public class PaddedBlockCipher extends BufferedBlockCipher {
    public PaddedBlockCipher(BlockCipher arg2) {
        super();
        this.cipher = arg2;
        this.buf = new byte[arg2.getBlockSize()];
        this.bufOff = 0;
    }

    public int doFinal(byte[] arg7, int arg8) {
        int v0;
        int v2 = this.cipher.getBlockSize();
        if(this.forEncryption) {
            if(this.bufOff != v2) {
                v0 = 0;
            }
            else if(v2 * 2 + arg8 > arg7.length) {
                throw new DataLengthException("output buffer too short");
            }
            else {
                v0 = this.cipher.processBlock(this.buf, 0, arg7, arg8);
                this.bufOff = 0;
            }

            byte v3 = ((byte)(v2 - this.bufOff));
            while(this.bufOff < v2) {
                this.buf[this.bufOff] = v3;
                ++this.bufOff;
            }

            v0 += this.cipher.processBlock(this.buf, 0, arg7, arg8 + v0);
        }
        else {
            if(this.bufOff != v2) {
                goto label_55;
            }

            v0 = this.cipher.processBlock(this.buf, 0, this.buf, 0);
            this.bufOff = 0;
            int v3_1 = this.buf[v2 - 1] & 255;
            if(v3_1 >= 0 && v3_1 <= v2) {
                v0 -= v3_1;
                System.arraycopy(this.buf, 0, arg7, arg8, v0);
                goto label_36;
            }

            goto label_51;
        }

    label_36:
        this.reset();
        return v0;
    label_51:
        throw new InvalidCipherTextException("pad block corrupted");
    label_55:
        throw new DataLengthException("last block incomplete in decryption");
    }

    public int getOutputSize(int arg3) {
        int v0 = this.bufOff + arg3;
        int v1 = v0 % this.buf.length;
        if(v1 != 0) {
            v0 = v0 - v1 + this.buf.length;
        }
        else if(this.forEncryption) {
            v0 += this.buf.length;
        }

        return v0;
    }

    public int getUpdateOutputSize(int arg3) {
        int v0 = this.bufOff + arg3;
        int v1 = v0 % this.buf.length;
        return v1 == 0 ? this.buf.length : v1;
    }

    public int processByte(byte arg5, byte[] arg6, int arg7) {
        int v0;
        if(this.bufOff == this.buf.length) {
            v0 = this.cipher.processBlock(this.buf, 0, arg6, arg7);
            this.bufOff = 0;
        }
        else {
            v0 = 0;
        }

        byte[] v1 = this.buf;
        int v2 = this.bufOff;
        this.bufOff = v2 + 1;
        v1[v2] = arg5;
        return v0;
    }

    public int processBytes(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        int v1;
        if(arg9 < 0) {
            throw new IllegalArgumentException("Can\'t have a negative input length!");
        }

        int v3 = this.getBlockSize();
        int v0 = this.getUpdateOutputSize(arg9);
        if(v0 > 0 && v0 + arg11 > arg10.length) {
            throw new DataLengthException("output buffer too short");
        }

        int v2 = this.buf.length - this.bufOff;
        if(arg9 > v2) {
            System.arraycopy(arg7, arg8, this.buf, this.bufOff, v2);
            v0 = this.cipher.processBlock(this.buf, 0, arg10, arg11);
            this.bufOff = 0;
            v1 = arg9 - v2;
            v2 += arg8;
            while(v1 > this.buf.length) {
                v0 += this.cipher.processBlock(arg7, v2, arg10, arg11 + v0);
                v1 -= v3;
                v2 += v3;
            }
        }
        else {
            v0 = 0;
            v2 = arg8;
            v1 = arg9;
        }

        System.arraycopy(arg7, v2, this.buf, this.bufOff, v1);
        this.bufOff = v1 + this.bufOff;
        return v0;
    }
}

