// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class SICBlockCipher implements BlockCipher {
    private byte[] IV;
    private final int blockSize;
    private final BlockCipher cipher;
    private byte[] counter;
    private byte[] counterOut;

    public SICBlockCipher(BlockCipher arg2) {
        super();
        this.cipher = arg2;
        this.blockSize = this.cipher.getBlockSize();
        this.IV = new byte[this.blockSize];
        this.counter = new byte[this.blockSize];
        this.counterOut = new byte[this.blockSize];
    }

    public String getAlgorithmName() {
        return this.cipher.getAlgorithmName() + "/SIC";
    }

    public int getBlockSize() {
        return this.cipher.getBlockSize();
    }

    public BlockCipher getUnderlyingCipher() {
        return this.cipher;
    }

    public void init(boolean arg5, CipherParameters arg6) {
        if((arg6 instanceof ParametersWithIV)) {
            System.arraycopy(((ParametersWithIV)arg6).getIV(), 0, this.IV, 0, this.IV.length);
            this.reset();
            if(((ParametersWithIV)arg6).getParameters() != null) {
                this.cipher.init(true, ((ParametersWithIV)arg6).getParameters());
            }

            return;
        }

        throw new IllegalArgumentException("SIC mode requires ParametersWithIV");
    }

    public int processBlock(byte[] arg5, int arg6, byte[] arg7, int arg8) {
        int v0 = 0;
        this.cipher.processBlock(this.counter, 0, this.counterOut, 0);
        while(v0 < this.counterOut.length) {
            arg7[arg8 + v0] = ((byte)(this.counterOut[v0] ^ arg5[arg6 + v0]));
            ++v0;
        }

        for(v0 = this.counter.length - 1; v0 >= 0; --v0) {
            byte[] v1 = this.counter;
            byte v2 = ((byte)(v1[v0] + 1));
            v1[v0] = v2;
            if(v2 != 0) {
                break;
            }
        }

        return this.counter.length;
    }

    public void reset() {
        System.arraycopy(this.IV, 0, this.counter, 0, this.counter.length);
        this.cipher.reset();
    }
}

