// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.modes.gcm;

import org.bouncycastle.crypto.util.Pack;
import org.bouncycastle.util.Arrays;

abstract class GCMUtil {
    GCMUtil() {
        super();
    }

    static byte[] asBytes(int[] arg2) {
        byte[] v0 = new byte[16];
        Pack.intToBigEndian(arg2, v0, 0);
        return v0;
    }

    static void asInts(byte[] arg1, int[] arg2) {
        Pack.bigEndianToInt(arg1, 0, arg2);
    }

    static int[] asInts(byte[] arg2) {
        int[] v0 = new int[4];
        Pack.bigEndianToInt(arg2, 0, v0);
        return v0;
    }

    static void multiply(byte[] arg9, byte[] arg10) {
        int v8 = 16;
        byte[] v5 = Arrays.clone(arg9);
        byte[] v6 = new byte[v8];
        int v4;
        for(v4 = 0; v4 < v8; ++v4) {
            int v7 = arg10[v4];
            int v3;
            for(v3 = 7; v3 >= 0; --v3) {
                if((1 << v3 & v7) != 0) {
                    GCMUtil.xor(v6, v5);
                }

                int v0 = (v5[15] & 1) != 0 ? 1 : 0;
                GCMUtil.shiftRight(v5);
                if(v0 != 0) {
                    v5[0] = ((byte)(v5[0] ^ -31));
                }
            }
        }

        System.arraycopy(v6, 0, arg9, 0, v8);
    }

    static void multiplyP(int[] arg3) {
        int v0 = (arg3[3] & 1) != 0 ? 1 : 0;
        GCMUtil.shiftRight(arg3);
        if(v0 != 0) {
            arg3[0] ^= -520093696;
        }
    }

    static void multiplyP(int[] arg3, int[] arg4) {
        int v0 = (arg3[3] & 1) != 0 ? 1 : 0;
        GCMUtil.shiftRight(arg3, arg4);
        if(v0 != 0) {
            arg4[0] ^= -520093696;
        }
    }

    static void multiplyP8(int[] arg6) {
        int v1 = arg6[3];
        GCMUtil.shiftRightN(arg6, 8);
        int v0;
        for(v0 = 7; v0 >= 0; --v0) {
            if((1 << v0 & v1) != 0) {
                arg6[0] ^= -520093696 >>> 7 - v0;
            }
        }
    }

    static void multiplyP8(int[] arg6, int[] arg7) {
        int v1 = arg6[3];
        GCMUtil.shiftRightN(arg6, 8, arg7);
        int v0;
        for(v0 = 7; v0 >= 0; --v0) {
            if((1 << v0 & v1) != 0) {
                arg7[0] ^= -520093696 >>> 7 - v0;
            }
        }
    }

    static byte[] oneAsBytes() {
        byte[] v0 = new byte[16];
        v0[0] = -128;
        return v0;
    }

    static int[] oneAsInts() {
        int[] v0 = new int[4];
        v0[0] = -2147483648;
        return v0;
    }

    static void shiftRight(byte[] arg4) {
        int v0 = 0;
        int v1 = 0;
        while(true) {
            int v2 = arg4[v1] & 255;
            arg4[v1] = ((byte)(v0 | v2 >>> 1));
            ++v1;
            if(v1 == 16) {
                return;
            }

            v0 = (v2 & 1) << 7;
        }
    }

    static void shiftRight(int[] arg4) {
        int v0 = 0;
        int v1 = 0;
        while(true) {
            int v2 = arg4[v1];
            arg4[v1] = v0 | v2 >>> 1;
            ++v1;
            if(v1 == 4) {
                return;
            }

            v0 = v2 << 31;
        }
    }

    static void shiftRight(int[] arg4, int[] arg5) {
        int v0 = 0;
        int v1 = 0;
        while(true) {
            int v2 = arg4[v1];
            arg5[v1] = v0 | v2 >>> 1;
            ++v1;
            if(v1 == 4) {
                return;
            }

            v0 = v2 << 31;
        }
    }

    static void shiftRight(byte[] arg4, byte[] arg5) {
        int v0 = 0;
        int v1 = 0;
        while(true) {
            int v2 = arg4[v1] & 255;
            arg5[v1] = ((byte)(v0 | v2 >>> 1));
            ++v1;
            if(v1 == 16) {
                return;
            }

            v0 = (v2 & 1) << 7;
        }
    }

    static void shiftRightN(int[] arg4, int arg5) {
        int v0 = 0;
        int v1 = 0;
        while(true) {
            int v2 = arg4[v1];
            arg4[v1] = v0 | v2 >>> arg5;
            ++v1;
            if(v1 == 4) {
                return;
            }

            v0 = v2 << 32 - arg5;
        }
    }

    static void shiftRightN(int[] arg4, int arg5, int[] arg6) {
        int v0 = 0;
        int v1 = 0;
        while(true) {
            int v2 = arg4[v1];
            arg6[v1] = v0 | v2 >>> arg5;
            ++v1;
            if(v1 == 4) {
                return;
            }

            v0 = v2 << 32 - arg5;
        }
    }

    static void xor(byte[] arg3, byte[] arg4) {
        int v0;
        for(v0 = 15; v0 >= 0; --v0) {
            arg3[v0] = ((byte)(arg3[v0] ^ arg4[v0]));
        }
    }

    static void xor(byte[] arg3, byte[] arg4, int arg5, int arg6) {
        while(true) {
            int v0 = arg6 - 1;
            if(arg6 <= 0) {
                return;
            }

            arg3[v0] = ((byte)(arg3[v0] ^ arg4[arg5 + v0]));
            arg6 = v0;
        }
    }

    static void xor(byte[] arg3, byte[] arg4, byte[] arg5) {
        int v0;
        for(v0 = 15; v0 >= 0; --v0) {
            arg5[v0] = ((byte)(arg3[v0] ^ arg4[v0]));
        }
    }

    static void xor(int[] arg3, int[] arg4) {
        int v0;
        for(v0 = 3; v0 >= 0; --v0) {
            arg3[v0] ^= arg4[v0];
        }
    }

    static void xor(int[] arg3, int[] arg4, int[] arg5) {
        int v0;
        for(v0 = 3; v0 >= 0; --v0) {
            arg5[v0] = arg3[v0] ^ arg4[v0];
        }
    }
}

