// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.params;

import java.math.BigInteger;
import org.bouncycastle.crypto.CipherParameters;

public class DHParameters implements CipherParameters {
    private static final int DEFAULT_MINIMUM_LENGTH = 160;
    private BigInteger g;
    private BigInteger j;
    private int l;
    private int m;
    private BigInteger p;
    private BigInteger q;
    private DHValidationParameters validation;

    public DHParameters(BigInteger arg3, BigInteger arg4) {
        this(arg3, arg4, null, 0);
    }

    public DHParameters(BigInteger arg2, BigInteger arg3, BigInteger arg4) {
        this(arg2, arg3, arg4, 0);
    }

    public DHParameters(BigInteger arg9, BigInteger arg10, BigInteger arg11, BigInteger arg12, DHValidationParameters arg13) {
        this(arg9, arg10, arg11, 160, 0, arg12, arg13);
    }

    public DHParameters(BigInteger arg9, BigInteger arg10, BigInteger arg11, int arg12) {
        this(arg9, arg10, arg11, DHParameters.getDefaultMParam(arg12), arg12, null, null);
    }

    public DHParameters(BigInteger arg5, BigInteger arg6, BigInteger arg7, int arg8, int arg9, BigInteger arg10, DHValidationParameters arg11) {
        super();
        if(arg9 != 0) {
            if(BigInteger.valueOf(2 ^ (((long)(arg9 - 1)))).compareTo(arg5) == 1) {
                throw new IllegalArgumentException("when l value specified, it must satisfy 2^(l-1) <= p");
            }
            else if(arg9 < arg8) {
                throw new IllegalArgumentException("when l value specified, it may not be less than m value");
            }
        }

        this.g = arg6;
        this.p = arg5;
        this.q = arg7;
        this.m = arg8;
        this.l = arg9;
        this.j = arg10;
        this.validation = arg11;
    }

    public DHParameters(BigInteger arg9, BigInteger arg10, BigInteger arg11, int arg12, int arg13) {
        this(arg9, arg10, arg11, arg12, arg13, null, null);
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if((arg4 instanceof DHParameters)) {
            if(this.getQ() != null) {
                if(!this.getQ().equals(((DHParameters)arg4).getQ())) {
                    return v0;
                }
            }
            else if(((DHParameters)arg4).getQ() != null) {
                return v0;
            }

            if(!((DHParameters)arg4).getP().equals(this.p)) {
                return v0;
            }

            if(!((DHParameters)arg4).getG().equals(this.g)) {
                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    private static int getDefaultMParam(int arg1) {
        int v0 = 160;
        if(arg1 != 0) {
            if(arg1 >= v0) {
                arg1 = v0;
            }

            v0 = arg1;
        }

        return v0;
    }

    public BigInteger getG() {
        return this.g;
    }

    public BigInteger getJ() {
        return this.j;
    }

    public int getL() {
        return this.l;
    }

    public int getM() {
        return this.m;
    }

    public BigInteger getP() {
        return this.p;
    }

    public BigInteger getQ() {
        return this.q;
    }

    public DHValidationParameters getValidationParameters() {
        return this.validation;
    }

    public int hashCode() {
        int v1 = this.getG().hashCode() ^ this.getP().hashCode();
        int v0 = this.getQ() != null ? this.getQ().hashCode() : 0;
        return v0 ^ v1;
    }
}

