// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.params;

import org.bouncycastle.crypto.DerivationParameters;
import org.bouncycastle.util.Arrays;

public class HKDFParameters implements DerivationParameters {
    private final byte[] ikm;
    private final byte[] info;
    private final byte[] salt;
    private final boolean skipExpand;

    private HKDFParameters(byte[] arg3, boolean arg4, byte[] arg5, byte[] arg6) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("IKM (input keying material) should not be null");
        }

        this.ikm = Arrays.clone(arg3);
        this.skipExpand = arg4;
        this.salt = arg5 == null || arg5.length == 0 ? null : Arrays.clone(arg5);
        this.info = arg6 == null ? new byte[0] : Arrays.clone(arg6);
    }

    public HKDFParameters(byte[] arg2, byte[] arg3, byte[] arg4) {
        this(arg2, false, arg3, arg4);
    }

    public static HKDFParameters defaultParameters(byte[] arg3) {
        return new HKDFParameters(arg3, false, null, null);
    }

    public byte[] getIKM() {
        return Arrays.clone(this.ikm);
    }

    public byte[] getInfo() {
        return Arrays.clone(this.info);
    }

    public byte[] getSalt() {
        return Arrays.clone(this.salt);
    }

    public boolean skipExtract() {
        return this.skipExpand;
    }

    public static HKDFParameters skipExtractParameters(byte[] arg3, byte[] arg4) {
        return new HKDFParameters(arg3, true, null, arg4);
    }
}

