// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.prng;

import org.bouncycastle.crypto.Digest;

public class DigestRandomGenerator implements RandomGenerator {
    private static long CYCLE_COUNT;
    private Digest digest;
    private byte[] seed;
    private long seedCounter;
    private byte[] state;
    private long stateCounter;

    static {
        DigestRandomGenerator.CYCLE_COUNT = 10;
    }

    public DigestRandomGenerator(Digest arg4) {
        super();
        this.digest = arg4;
        this.seed = new byte[arg4.getDigestSize()];
        this.seedCounter = 1;
        this.state = new byte[arg4.getDigestSize()];
        this.stateCounter = 1;
    }

    public void addSeedMaterial(long arg2) {
        __monitor_enter(this);
        try {
            this.digestAddCounter(arg2);
            this.digestUpdate(this.seed);
            this.digestDoFinal(this.seed);
            __monitor_exit(this);
            return;
        label_9:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_9;
        }

        throw v0;
    }

    public void addSeedMaterial(byte[] arg2) {
        __monitor_enter(this);
        try {
            this.digestUpdate(arg2);
            this.digestUpdate(this.seed);
            this.digestDoFinal(this.seed);
            __monitor_exit(this);
            return;
        label_9:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_9;
        }

        throw v0;
    }

    private void cycleSeed() {
        this.digestUpdate(this.seed);
        long v0 = this.seedCounter;
        this.seedCounter = 1 + v0;
        this.digestAddCounter(v0);
        this.digestDoFinal(this.seed);
    }

    private void digestAddCounter(long arg5) {
        int v3 = 8;
        int v0;
        for(v0 = 0; v0 != v3; ++v0) {
            this.digest.update(((byte)(((int)arg5))));
            arg5 >>>= v3;
        }
    }

    private void digestDoFinal(byte[] arg3) {
        this.digest.doFinal(arg3, 0);
    }

    private void digestUpdate(byte[] arg4) {
        this.digest.update(arg4, 0, arg4.length);
    }

    private void generateState() {
        long v0 = this.stateCounter;
        this.stateCounter = 1 + v0;
        this.digestAddCounter(v0);
        this.digestUpdate(this.state);
        this.digestUpdate(this.seed);
        this.digestDoFinal(this.state);
        if(this.stateCounter % DigestRandomGenerator.CYCLE_COUNT == 0) {
            this.cycleSeed();
        }
    }

    public void nextBytes(byte[] arg3) {
        this.nextBytes(arg3, 0, arg3.length);
    }

    public void nextBytes(byte[] arg6, int arg7, int arg8) {
        __monitor_enter(this);
        try {
            this.generateState();
            int v3 = arg7 + arg8;
            int v0_1;
            for(v0_1 = 0; arg7 != v3; ++v0_1) {
                if(v0_1 == this.state.length) {
                    this.generateState();
                    v0_1 = 0;
                }

                arg6[arg7] = this.state[v0_1];
                ++arg7;
            }

            __monitor_exit(this);
            return;
        label_21:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_21;
        }

        throw v0;
    }
}

