// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.prng;

public class ReversedWindowGenerator implements RandomGenerator {
    private final RandomGenerator generator;
    private byte[] window;
    private int windowCount;

    public ReversedWindowGenerator(RandomGenerator arg3, int arg4) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("generator cannot be null");
        }

        if(arg4 < 2) {
            throw new IllegalArgumentException("windowSize must be at least 2");
        }

        this.generator = arg3;
        this.window = new byte[arg4];
    }

    public void addSeedMaterial(long arg2) {
        __monitor_enter(this);
        try {
            this.windowCount = 0;
            this.generator.addSeedMaterial(arg2);
            __monitor_exit(this);
            return;
        label_8:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_8;
        }

        throw v0;
    }

    public void addSeedMaterial(byte[] arg2) {
        __monitor_enter(this);
        try {
            this.windowCount = 0;
            this.generator.addSeedMaterial(arg2);
            __monitor_exit(this);
            return;
        label_8:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_8;
        }

        throw v0;
    }

    private void doNextBytes(byte[] arg6, int arg7, int arg8) {
        int v0 = 0;
        __monitor_enter(this);
        while(true) {
            if(v0 >= arg8) {
                goto label_25;
            }

            try {
                if(this.windowCount < 1) {
                    this.generator.nextBytes(this.window, 0, this.window.length);
                    this.windowCount = this.window.length;
                }

                byte[] v2 = this.window;
                int v3 = this.windowCount - 1;
                this.windowCount = v3;
                arg6[v0 + arg7] = v2[v3];
                ++v0;
                continue;
            label_25:
                __monitor_exit(this);
                return;
            label_28:
                __monitor_exit(this);
                break;
            }
            catch(Throwable v0_1) {
                goto label_28;
            }
        }

        throw v0_1;
    }

    public void nextBytes(byte[] arg3) {
        this.doNextBytes(arg3, 0, arg3.length);
    }

    public void nextBytes(byte[] arg1, int arg2, int arg3) {
        this.doNextBytes(arg1, arg2, arg3);
    }
}

