// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.prng;

import java.security.SecureRandom;
import org.bouncycastle.crypto.prng.drbg.SP80090DRBG;

public class SP800SecureRandom extends SecureRandom {
    private SP80090DRBG drbg;
    private final DRBGProvider drbgProvider;
    private final EntropySource entropySource;
    private final boolean predictionResistant;
    private final SecureRandom randomSource;

    SP800SecureRandom(SecureRandom arg1, EntropySource arg2, DRBGProvider arg3, boolean arg4) {
        super();
        this.randomSource = arg1;
        this.entropySource = arg2;
        this.drbgProvider = arg3;
        this.predictionResistant = arg4;
    }

    public byte[] generateSeed(int arg2) {
        byte[] v0 = new byte[arg2];
        this.nextBytes(v0);
        return v0;
    }

    public void nextBytes(byte[] arg4) {
        __monitor_enter(this);
        try {
            if(this.drbg == null) {
                this.drbg = this.drbgProvider.get(this.entropySource);
            }

            if(this.drbg.generate(arg4, null, this.predictionResistant) < 0) {
                this.drbg.reseed(this.entropySource.getEntropy());
                this.drbg.generate(arg4, null, this.predictionResistant);
            }

            __monitor_exit(this);
            return;
        label_23:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_23;
        }

        throw v0;
    }

    public void setSeed(long arg2) {
        __monitor_enter(this);
        try {
            if(this.randomSource != null) {
                this.randomSource.setSeed(arg2);
            }

            __monitor_exit(this);
            return;
        label_8:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_8;
        }

        throw v0;
    }

    public void setSeed(byte[] arg2) {
        __monitor_enter(this);
        try {
            if(this.randomSource != null) {
                this.randomSource.setSeed(arg2);
            }

            __monitor_exit(this);
            return;
        label_8:
            __monitor_exit(this);
        }
        catch(Throwable v0) {
            goto label_8;
        }

        throw v0;
    }
}

