// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.prng;

import java.security.SecureRandom;
import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Mac;

public class SP800SecureRandomBuilder {
    private int entropyBitsRequired;
    private final EntropySourceProvider entropySourceProvider;
    private byte[] personalizationString;
    private final SecureRandom random;
    private int securityStrength;

    public SP800SecureRandomBuilder() {
        this(new SecureRandom(), false);
    }

    public SP800SecureRandomBuilder(SecureRandom arg3, boolean arg4) {
        super();
        this.securityStrength = 256;
        this.entropyBitsRequired = 256;
        this.random = arg3;
        this.entropySourceProvider = new BasicEntropySourceProvider(this.random, arg4);
    }

    public SP800SecureRandomBuilder(EntropySourceProvider arg2) {
        super();
        this.securityStrength = 256;
        this.entropyBitsRequired = 256;
        this.random = null;
        this.entropySourceProvider = arg2;
    }

    public SP800SecureRandom buildCTR(BlockCipher arg10, int arg11, byte[] arg12, boolean arg13) {
        return new SP800SecureRandom(this.random, this.entropySourceProvider.get(this.entropyBitsRequired), new SP800SecureRandomBuilder$CTRDRBGProvider(arg10, arg11, arg12, this.personalizationString, this.securityStrength), arg13);
    }

    public SP800SecureRandom buildDualEC(Digest arg7, byte[] arg8, boolean arg9) {
        return new SP800SecureRandom(this.random, this.entropySourceProvider.get(this.entropyBitsRequired), new SP800SecureRandomBuilder$DualECDRBGProvider(arg7, arg8, this.personalizationString, this.securityStrength), arg9);
    }

    public SP800SecureRandom buildHMAC(Mac arg7, byte[] arg8, boolean arg9) {
        return new SP800SecureRandom(this.random, this.entropySourceProvider.get(this.entropyBitsRequired), new SP800SecureRandomBuilder$HMacDRBGProvider(arg7, arg8, this.personalizationString, this.securityStrength), arg9);
    }

    public SP800SecureRandom buildHash(Digest arg7, byte[] arg8, boolean arg9) {
        return new SP800SecureRandom(this.random, this.entropySourceProvider.get(this.entropyBitsRequired), new SP800SecureRandomBuilder$HashDRBGProvider(arg7, arg8, this.personalizationString, this.securityStrength), arg9);
    }

    public SP800SecureRandomBuilder setEntropyBitsRequired(int arg1) {
        this.entropyBitsRequired = arg1;
        return this;
    }

    public SP800SecureRandomBuilder setPersonalizationString(byte[] arg1) {
        this.personalizationString = arg1;
        return this;
    }

    public SP800SecureRandomBuilder setSecurityStrength(int arg1) {
        this.securityStrength = arg1;
        return this;
    }
}

