// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.prng.drbg;

import java.util.Hashtable;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.util.Integers;

class Utils {
    static final Hashtable maxSecurityStrengths;

    static {
        Utils.maxSecurityStrengths = new Hashtable();
        Utils.maxSecurityStrengths.put("SHA-1", Integers.valueOf(128));
        Utils.maxSecurityStrengths.put("SHA-224", Integers.valueOf(192));
        Utils.maxSecurityStrengths.put("SHA-256", Integers.valueOf(256));
        Utils.maxSecurityStrengths.put("SHA-384", Integers.valueOf(256));
        Utils.maxSecurityStrengths.put("SHA-512", Integers.valueOf(256));
        Utils.maxSecurityStrengths.put("SHA-512/224", Integers.valueOf(192));
        Utils.maxSecurityStrengths.put("SHA-512/256", Integers.valueOf(256));
    }

    Utils() {
        super();
    }

    static int getMaxSecurityStrength(Digest arg2) {
        return Utils.maxSecurityStrengths.get(arg2.getAlgorithmName()).intValue();
    }

    static int getMaxSecurityStrength(Mac arg4) {
        String v0 = arg4.getAlgorithmName();
        return Utils.maxSecurityStrengths.get(v0.substring(0, v0.indexOf("/"))).intValue();
    }

    static byte[] hash_df(Digest arg8, byte[] arg9, int arg10) {
        int v0;
        int v1 = 0;
        byte[] v4 = new byte[(arg10 + 7) / 8];
        int v5 = v4.length / arg8.getDigestSize();
        byte[] v6 = new byte[arg8.getDigestSize()];
        int v2 = 0;
        int v3 = 1;
        while(v2 <= v5) {
            arg8.update(((byte)v3));
            arg8.update(((byte)(arg10 >> 24)));
            arg8.update(((byte)(arg10 >> 16)));
            arg8.update(((byte)(arg10 >> 8)));
            arg8.update(((byte)arg10));
            arg8.update(arg9, 0, arg9.length);
            arg8.doFinal(v6, 0);
            v0 = v4.length - v6.length * v2 > v6.length ? v6.length : v4.length - v6.length * v2;
            System.arraycopy(v6, 0, v4, v6.length * v2, v0);
            ++v3;
            ++v2;
        }

        if(arg10 % 8 != 0) {
            v3 = 8 - arg10 % 8;
            v0 = 0;
            while(v0 != v4.length) {
                v2 = v4[v0] & 255;
                v4[v0] = ((byte)(v1 << 8 - v3 | v2 >>> v3));
                ++v0;
                v1 = v2;
            }
        }

        return v4;
    }

    static boolean isTooLarge(byte[] arg1, int arg2) {
        boolean v0 = arg1 == null || arg1.length <= arg2 ? false : true;
        return v0;
    }
}

