// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.signers;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.params.DSAKeyParameters;
import org.bouncycastle.crypto.params.DSAParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;

public class DSASigner implements DSA {
    DSAKeyParameters key;
    SecureRandom random;

    public DSASigner() {
        super();
    }

    private BigInteger calculateE(BigInteger arg5, byte[] arg6) {
        BigInteger v0;
        if(arg5.bitLength() >= arg6.length * 8) {
            v0 = new BigInteger(1, arg6);
        }
        else {
            byte[] v1 = new byte[arg5.bitLength() / 8];
            System.arraycopy(arg6, 0, v1, 0, v1.length);
            v0 = new BigInteger(1, v1);
        }

        return v0;
    }

    public BigInteger[] generateSignature(byte[] arg6) {
        BigInteger v3;
        DSAParameters v1 = this.key.getParameters();
        BigInteger v2 = this.calculateE(v1.getQ(), arg6);
        int v0 = v1.getQ().bitLength();
        do {
            v3 = new BigInteger(v0, this.random);
        }
        while(v3.compareTo(v1.getQ()) >= 0);

        BigInteger v4 = v1.getG().modPow(v3, v1.getP()).mod(v1.getQ());
        return new BigInteger[]{v4, v3.modInverse(v1.getQ()).multiply(v2.add(this.key.getX().multiply(v4))).mod(v1.getQ())};
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((DSAKeyParameters)arg3);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.random = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
        }
        else {
            this.random = new SecureRandom();
            this.key = ((DSAKeyParameters)arg3);
        }
    }

    public boolean verifySignature(byte[] arg6, BigInteger arg7, BigInteger arg8) {
        boolean v0 = false;
        DSAParameters v1 = this.key.getParameters();
        BigInteger v2 = this.calculateE(v1.getQ(), arg6);
        BigInteger v3 = BigInteger.valueOf(0);
        if(v3.compareTo(arg7) < 0 && v1.getQ().compareTo(arg7) > 0 && v3.compareTo(arg8) < 0 && v1.getQ().compareTo(arg8) > 0) {
            BigInteger v0_1 = arg8.modInverse(v1.getQ());
            v0 = v1.getG().modPow(v2.multiply(v0_1).mod(v1.getQ()), v1.getP()).multiply(this.key.getY().modPow(arg7.multiply(v0_1).mod(v1.getQ()), v1.getP())).mod(v1.getP()).mod(v1.getQ()).equals(arg7);
        }

        return v0;
    }
}

