// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.signers;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.params.ECKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.math.ec.ECAlgorithms;
import org.bouncycastle.math.ec.ECConstants;
import org.bouncycastle.math.ec.ECPoint;

public class ECDSASigner implements DSA, ECConstants {
    ECKeyParameters key;
    SecureRandom random;

    public ECDSASigner() {
        super();
    }

    private BigInteger calculateE(BigInteger arg5, byte[] arg6) {
        int v0 = arg5.bitLength();
        int v1 = arg6.length * 8;
        BigInteger v0_1 = v0 >= v1 ? new BigInteger(1, arg6) : new BigInteger(1, arg6).shiftRight(v1 - v0);
        return v0_1;
    }

    public BigInteger[] generateSignature(byte[] arg7) {
        BigInteger v0_1;
        BigInteger v4;
        BigInteger v3;
        BigInteger v1 = this.key.getParameters().getN();
        BigInteger v2 = this.calculateE(v1, arg7);
        do {
            int v0 = v1.bitLength();
            do {
            label_5:
                v3 = new BigInteger(v0, this.random);
                if(v3.equals(ECDSASigner.ZERO)) {
                    goto label_5;
                }

                if(v3.compareTo(v1) >= 0) {
                    goto label_5;
                }

                v4 = this.key.getParameters().getG().multiply(v3).getX().toBigInteger().mod(v1);
            }
            while(v4.equals(ECDSASigner.ZERO));

            v0_1 = v3.modInverse(v1).multiply(v2.add(this.key.getD().multiply(v4))).mod(v1);
        }
        while(v0_1.equals(ECDSASigner.ZERO));

        return new BigInteger[]{v4, v0_1};
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((ECKeyParameters)arg3);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.random = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
        }
        else {
            this.random = new SecureRandom();
            this.key = ((ECKeyParameters)arg3);
        }
    }

    public boolean verifySignature(byte[] arg7, BigInteger arg8, BigInteger arg9) {
        boolean v0_2;
        BigInteger v2 = this.key.getParameters().getN();
        BigInteger v0 = this.calculateE(v2, arg7);
        if(arg8.compareTo(ECDSASigner.ONE) < 0 || arg8.compareTo(v2) >= 0) {
            v0_2 = false;
        }
        else {
            if(arg9.compareTo(ECDSASigner.ONE) >= 0 && arg9.compareTo(v2) < 0) {
                BigInteger v3 = arg9.modInverse(v2);
                ECPoint v0_1 = ECAlgorithms.sumOfTwoMultiplies(this.key.getParameters().getG(), v0.multiply(v3).mod(v2), this.key.getQ(), arg8.multiply(v3).mod(v2));
                v0_2 = v0_1.isInfinity() ? false : v0_1.getX().toBigInteger().mod(v2).equals(arg8);
                return v0_2;
            }

            v0_2 = false;
        }

        return v0_2;
    }
}

