// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.signers;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.params.ECKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.math.ec.ECAlgorithms;
import org.bouncycastle.math.ec.ECConstants;
import org.bouncycastle.math.ec.ECPoint;

public class ECGOST3410Signer implements DSA {
    ECKeyParameters key;
    SecureRandom random;

    public ECGOST3410Signer() {
        super();
    }

    public BigInteger[] generateSignature(byte[] arg8) {
        BigInteger v0_1;
        BigInteger v5;
        byte[] v2 = new byte[arg8.length];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = arg8[v2.length - 1 - v0];
        }

        BigInteger v3 = new BigInteger(1, v2);
        BigInteger v2_1 = this.key.getParameters().getN();
        do {
        label_19:
            BigInteger v4 = new BigInteger(v2_1.bitLength(), this.random);
            if(v4.equals(ECConstants.ZERO)) {
                goto label_19;
            }

            v5 = this.key.getParameters().getG().multiply(v4).getX().toBigInteger().mod(v2_1);
            if(v5.equals(ECConstants.ZERO)) {
                goto label_19;
            }

            v0_1 = v4.multiply(v3).add(this.key.getD().multiply(v5)).mod(v2_1);
        }
        while(v0_1.equals(ECConstants.ZERO));

        return new BigInteger[]{v5, v0_1};
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((ECKeyParameters)arg3);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.random = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
        }
        else {
            this.random = new SecureRandom();
            this.key = ((ECKeyParameters)arg3);
        }
    }

    public boolean verifySignature(byte[] arg7, BigInteger arg8, BigInteger arg9) {
        boolean v1 = false;
        byte[] v2 = new byte[arg7.length];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = arg7[v2.length - 1 - v0];
        }

        BigInteger v0_1 = new BigInteger(1, v2);
        BigInteger v2_1 = this.key.getParameters().getN();
        if(arg8.compareTo(ECConstants.ONE) >= 0 && arg8.compareTo(v2_1) < 0 && arg9.compareTo(ECConstants.ONE) >= 0 && arg9.compareTo(v2_1) < 0) {
            v0_1 = v0_1.modInverse(v2_1);
            ECPoint v0_2 = ECAlgorithms.sumOfTwoMultiplies(this.key.getParameters().getG(), arg9.multiply(v0_1).mod(v2_1), this.key.getQ(), v2_1.subtract(arg8).multiply(v0_1).mod(v2_1));
            if(!v0_2.isInfinity()) {
                v1 = v0_2.getX().toBigInteger().mod(v2_1).equals(arg8);
            }
        }

        return v1;
    }
}

