// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.signers;

import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.params.GOST3410KeyParameters;
import org.bouncycastle.crypto.params.GOST3410Parameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;

public class GOST3410Signer implements DSA {
    GOST3410KeyParameters key;
    SecureRandom random;

    public GOST3410Signer() {
        super();
    }

    public BigInteger[] generateSignature(byte[] arg8) {
        BigInteger v3;
        byte[] v2 = new byte[arg8.length];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = arg8[v2.length - 1 - v0];
        }

        BigInteger v0_1 = new BigInteger(1, v2);
        GOST3410Parameters v2_1 = this.key.getParameters();
        do {
            v3 = new BigInteger(v2_1.getQ().bitLength(), this.random);
        }
        while(v3.compareTo(v2_1.getQ()) >= 0);

        BigInteger v4 = v2_1.getA().modPow(v3, v2_1.getP()).mod(v2_1.getQ());
        return new BigInteger[]{v4, v3.multiply(v0_1).add(this.key.getX().multiply(v4)).mod(v2_1.getQ())};
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((GOST3410KeyParameters)arg3);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.random = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
        }
        else {
            this.random = new SecureRandom();
            this.key = ((GOST3410KeyParameters)arg3);
        }
    }

    public boolean verifySignature(byte[] arg6, BigInteger arg7, BigInteger arg8) {
        boolean v1 = false;
        byte[] v2 = new byte[arg6.length];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = arg6[v2.length - 1 - v0];
        }

        BigInteger v0_1 = new BigInteger(1, v2);
        GOST3410Parameters v2_1 = this.key.getParameters();
        BigInteger v3 = BigInteger.valueOf(0);
        if(v3.compareTo(arg7) < 0 && v2_1.getQ().compareTo(arg7) > 0 && v3.compareTo(arg8) < 0 && v2_1.getQ().compareTo(arg8) > 0) {
            v0_1 = v0_1.modPow(v2_1.getQ().subtract(new BigInteger("2")), v2_1.getQ());
            v1 = v2_1.getA().modPow(arg8.multiply(v0_1).mod(v2_1.getQ()), v2_1.getP()).multiply(this.key.getY().modPow(v2_1.getQ().subtract(arg7).multiply(v0_1).mod(v2_1.getQ()), v2_1.getP())).mod(v2_1.getP()).mod(v2_1.getQ()).equals(arg7);
        }

        return v1;
    }
}

