// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.signers;

import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.util.Arrays;

public class GenericSigner implements Signer {
    private final Digest digest;
    private final AsymmetricBlockCipher engine;
    private boolean forSigning;

    public GenericSigner(AsymmetricBlockCipher arg1, Digest arg2) {
        super();
        this.engine = arg1;
        this.digest = arg2;
    }

    public byte[] generateSignature() {
        if(!this.forSigning) {
            throw new IllegalStateException("GenericSigner not initialised for signature generation.");
        }

        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        return this.engine.processBlock(v0, 0, v0.length);
    }

    public void init(boolean arg3, CipherParameters arg4) {
        this.forSigning = arg3;
        CipherParameters v0 = (arg4 instanceof ParametersWithRandom) ? arg4.getParameters() : arg4;
        if((arg3) && !((AsymmetricKeyParameter)v0).isPrivate()) {
            throw new IllegalArgumentException("signing requires private key");
        }

        if(!arg3 && (((AsymmetricKeyParameter)v0).isPrivate())) {
            throw new IllegalArgumentException("verification requires public key");
        }

        this.reset();
        this.engine.init(arg3, arg4);
    }

    public void reset() {
        this.digest.reset();
    }

    public void update(byte arg2) {
        this.digest.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    public boolean verifySignature(byte[] arg6) {
        boolean v0;
        if(this.forSigning) {
            throw new IllegalStateException("GenericSigner not initialised for verification");
        }

        byte[] v1 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v1, 0);
        try {
            v0 = Arrays.constantTimeAreEqual(this.engine.processBlock(arg6, 0, arg6.length), v1);
        }
        catch(Exception v1_1) {
        }

        return v0;
    }
}

