// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.util.Hashtable;
import java.util.Vector;

public abstract class AbstractTlsClient extends AbstractTlsPeer implements TlsClient {
    protected TlsCipherFactory cipherFactory;
    protected TlsClientContext context;
    protected int selectedCipherSuite;
    protected short selectedCompressionMethod;
    protected Vector supportedSignatureAlgorithms;

    public AbstractTlsClient() {
        this(new DefaultTlsCipherFactory());
    }

    public AbstractTlsClient(TlsCipherFactory arg1) {
        super();
        this.cipherFactory = arg1;
    }

    public Hashtable getClientExtensions() {
        Hashtable v0_1;
        short v10 = 2;
        Hashtable v3 = null;
        if(TlsUtils.isSignatureAlgorithmsExtensionAllowed(this.context.getClientVersion())) {
            short[] v4 = new short[]{6, 5, 4, 3, 2};
            short[] v5 = new short[]{1};
            this.supportedSignatureAlgorithms = new Vector();
            int v0;
            for(v0 = 0; v0 < v4.length; ++v0) {
                int v2;
                for(v2 = 0; v2 < v5.length; ++v2) {
                    this.supportedSignatureAlgorithms.addElement(new SignatureAndHashAlgorithm(v4[v0], v5[v2]));
                }
            }

            this.supportedSignatureAlgorithms.addElement(new SignatureAndHashAlgorithm(v10, v10));
            v0_1 = 0 == 0 ? new Hashtable() : v3;
            TlsUtils.addSignatureAlgorithmsExtension(v0_1, this.supportedSignatureAlgorithms);
        }
        else {
            v0_1 = v3;
        }

        return v0_1;
    }

    public ProtocolVersion getClientHelloRecordLayerVersion() {
        return this.getClientVersion();
    }

    public Vector getClientSupplementalData() {
        return null;
    }

    public ProtocolVersion getClientVersion() {
        return ProtocolVersion.TLSv11;
    }

    public TlsCompression getCompression() {
        switch(this.selectedCompressionMethod) {
            case 0: {
                goto label_6;
            }
        }

        throw new TlsFatalAlert(80);
    label_6:
        return new TlsNullCompression();
    }

    public short[] getCompressionMethods() {
        return new short[]{0};
    }

    public ProtocolVersion getMinimumVersion() {
        return ProtocolVersion.TLSv10;
    }

    public void init(TlsClientContext arg1) {
        this.context = arg1;
    }

    public void notifyHandshakeComplete() {
    }

    public void notifyNewSessionTicket(NewSessionTicket arg1) {
    }

    public void notifySecureRenegotiation(boolean arg1) {
    }

    public void notifySelectedCipherSuite(int arg1) {
        this.selectedCipherSuite = arg1;
    }

    public void notifySelectedCompressionMethod(short arg1) {
        this.selectedCompressionMethod = arg1;
    }

    public void notifyServerVersion(ProtocolVersion arg3) {
        if(!this.getMinimumVersion().isEqualOrEarlierVersionOf(arg3)) {
            throw new TlsFatalAlert(70);
        }
    }

    public void notifySessionID(byte[] arg1) {
    }

    public void processServerExtensions(Hashtable arg3) {
        if(arg3 != null && (arg3.containsKey(TlsUtils.EXT_signature_algorithms))) {
            throw new TlsFatalAlert(47);
        }
    }

    public void processServerSupplementalData(Vector arg3) {
        if(arg3 != null) {
            throw new TlsFatalAlert(10);
        }
    }
}

