// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.security.SecureRandom;

abstract class AbstractTlsContext implements TlsContext {
    private ProtocolVersion clientVersion;
    private SecureRandom secureRandom;
    private SecurityParameters securityParameters;
    private ProtocolVersion serverVersion;
    private Object userObject;

    AbstractTlsContext(SecureRandom arg2, SecurityParameters arg3) {
        super();
        this.clientVersion = null;
        this.serverVersion = null;
        this.userObject = null;
        this.secureRandom = arg2;
        this.securityParameters = arg3;
    }

    public byte[] exportKeyingMaterial(String arg8, byte[] arg9, int arg10) {
        SecurityParameters v2 = this.getSecurityParameters();
        byte[] v1 = v2.getClientRandom();
        byte[] v3 = v2.getServerRandom();
        int v0 = v1.length + v3.length;
        if(arg9 != null) {
            v0 += arg9.length + 2;
        }

        byte[] v4 = new byte[v0];
        System.arraycopy(v1, 0, v4, 0, v1.length);
        int v1_1 = v1.length;
        System.arraycopy(v3, 0, v4, v1_1, v3.length);
        v1_1 += v3.length;
        if(arg9 != null) {
            TlsUtils.writeUint16(arg9.length, v4, v1_1);
            v1_1 += 2;
            System.arraycopy(arg9, 0, v4, v1_1, arg9.length);
            v1_1 += arg9.length;
        }

        if(v1_1 != v0) {
            throw new IllegalStateException("error in calculation of seed for export");
        }

        return TlsUtils.PRF(((TlsContext)this), v2.getMasterSecret(), arg8, v4, arg10);
    }

    public ProtocolVersion getClientVersion() {
        return this.clientVersion;
    }

    public SecureRandom getSecureRandom() {
        return this.secureRandom;
    }

    public SecurityParameters getSecurityParameters() {
        return this.securityParameters;
    }

    public ProtocolVersion getServerVersion() {
        return this.serverVersion;
    }

    public Object getUserObject() {
        return this.userObject;
    }

    public void setClientVersion(ProtocolVersion arg1) {
        this.clientVersion = arg1;
    }

    public void setServerVersion(ProtocolVersion arg1) {
        this.serverVersion = arg1;
    }

    public void setUserObject(Object arg1) {
        this.userObject = arg1;
    }
}

