// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.InputStream;
import java.util.Vector;

public abstract class AbstractTlsKeyExchange implements TlsKeyExchange {
    protected TlsContext context;
    protected int keyExchange;
    protected Vector supportedSignatureAlgorithms;

    protected AbstractTlsKeyExchange(int arg1, Vector arg2) {
        super();
        this.keyExchange = arg1;
        this.supportedSignatureAlgorithms = arg2;
    }

    public byte[] generateServerKeyExchange() {
        if(this.requiresServerKeyExchange()) {
            throw new TlsFatalAlert(80);
        }

        return null;
    }

    public void init(TlsContext arg5) {
        this.context = arg5;
        ProtocolVersion v0 = arg5.getClientVersion();
        if(TlsUtils.isSignatureAlgorithmsExtensionAllowed(v0)) {
            if(this.supportedSignatureAlgorithms == null) {
                switch(this.keyExchange) {
                    case 16: 
                    case 17: {
                        goto label_15;
                    }
                    case 3: 
                    case 7: 
                    case 22: {
                        goto label_12;
                    }
                    case 1: 
                    case 5: 
                    case 9: 
                    case 15: 
                    case 18: 
                    case 19: 
                    case 23: {
                        goto label_18;
                    }
                }

                throw new IllegalStateException("unsupported key exchange algorithm");
            label_12:
                this.supportedSignatureAlgorithms = TlsUtils.getDefaultDSSSignatureAlgorithms();
                return;
            label_15:
                this.supportedSignatureAlgorithms = TlsUtils.getDefaultECDSASignatureAlgorithms();
                return;
            label_18:
                this.supportedSignatureAlgorithms = TlsUtils.getDefaultRSASignatureAlgorithms();
            }
        }
        else if(this.supportedSignatureAlgorithms != null) {
            throw new IllegalStateException("supported_signature_algorithms not allowed for " + v0);
        }
    }

    public void processClientCertificate(Certificate arg1) {
    }

    public void processClientKeyExchange(InputStream arg3) {
        throw new TlsFatalAlert(80);
    }

    public void processServerCertificate(Certificate arg2) {
    }

    public void processServerCredentials(TlsCredentials arg2) {
        this.processServerCertificate(arg2.getCertificate());
    }

    public void processServerKeyExchange(InputStream arg3) {
        if(!this.requiresServerKeyExchange()) {
            throw new TlsFatalAlert(10);
        }
    }

    public boolean requiresServerKeyExchange() {
        return 0;
    }

    public void skipClientCredentials() {
    }

    public void skipServerKeyExchange() {
        if(this.requiresServerKeyExchange()) {
            throw new TlsFatalAlert(10);
        }
    }
}

