// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.util.Hashtable;
import java.util.Vector;

public abstract class AbstractTlsServer extends AbstractTlsPeer implements TlsServer {
    protected TlsCipherFactory cipherFactory;
    protected short[] clientECPointFormats;
    protected Hashtable clientExtensions;
    protected ProtocolVersion clientVersion;
    protected TlsServerContext context;
    protected boolean eccCipherSuitesOffered;
    protected int[] namedCurves;
    protected int[] offeredCipherSuites;
    protected short[] offeredCompressionMethods;
    protected int selectedCipherSuite;
    protected short selectedCompressionMethod;
    protected short[] serverECPointFormats;
    protected Hashtable serverExtensions;
    protected ProtocolVersion serverVersion;
    protected Vector supportedSignatureAlgorithms;

    public AbstractTlsServer() {
        this(new DefaultTlsCipherFactory());
    }

    public AbstractTlsServer(TlsCipherFactory arg1) {
        super();
        this.cipherFactory = arg1;
    }

    public CertificateRequest getCertificateRequest() {
        return null;
    }

    protected abstract int[] getCipherSuites();

    public TlsCompression getCompression() {
        switch(this.selectedCompressionMethod) {
            case 0: {
                goto label_6;
            }
        }

        throw new TlsFatalAlert(80);
    label_6:
        return new TlsNullCompression();
    }

    protected short[] getCompressionMethods() {
        return new short[]{0};
    }

    protected ProtocolVersion getMaximumVersion() {
        return ProtocolVersion.TLSv11;
    }

    protected ProtocolVersion getMinimumVersion() {
        return ProtocolVersion.TLSv10;
    }

    public NewSessionTicket getNewSessionTicket() {
        return new NewSessionTicket(0, TlsUtils.EMPTY_BYTES);
    }

    public int getSelectedCipherSuite() {
        boolean v1 = this.supportsClientECCCapabilities(this.namedCurves, this.clientECPointFormats);
        int[] v2 = this.getCipherSuites();
        int v0;
        for(v0 = 0; v0 < v2.length; ++v0) {
            int v3 = v2[v0];
            if((TlsProtocol.arrayContains(this.offeredCipherSuites, v3)) && ((v1) || !TlsECCUtils.isECCCipherSuite(v3))) {
                this.selectedCipherSuite = v3;
                return v3;
            }
        }

        throw new TlsFatalAlert(40);
    }

    public short getSelectedCompressionMethod() {
        short[] v1 = this.getCompressionMethods();
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            if(TlsProtocol.arrayContains(this.offeredCompressionMethods, v1[v0])) {
                short v0_1 = v1[v0];
                this.selectedCompressionMethod = v0_1;
                return v0_1;
            }
        }

        throw new TlsFatalAlert(40);
    }

    public Hashtable getServerExtensions() {
        Hashtable v0;
        if(this.clientECPointFormats == null || !TlsECCUtils.isECCCipherSuite(this.selectedCipherSuite)) {
            v0 = null;
        }
        else {
            this.serverECPointFormats = new short[]{2, 1, 0};
            this.serverExtensions = new Hashtable();
            TlsECCUtils.addSupportedPointFormatsExtension(this.serverExtensions, this.serverECPointFormats);
            v0 = this.serverExtensions;
        }

        return v0;
    }

    public Vector getServerSupplementalData() {
        return null;
    }

    public ProtocolVersion getServerVersion() {
        if(this.getMinimumVersion().isEqualOrEarlierVersionOf(this.clientVersion)) {
            ProtocolVersion v0 = this.getMaximumVersion();
            if(this.clientVersion.isEqualOrEarlierVersionOf(v0)) {
                v0 = this.clientVersion;
                this.serverVersion = v0;
            }
            else if(this.clientVersion.isLaterVersionOf(v0)) {
                this.serverVersion = v0;
            }
            else {
                goto label_16;
            }

            return v0;
        }

    label_16:
        throw new TlsFatalAlert(70);
    }

    public void init(TlsServerContext arg1) {
        this.context = arg1;
    }

    public void notifyClientCertificate(Certificate arg3) {
        throw new TlsFatalAlert(80);
    }

    public void notifyClientVersion(ProtocolVersion arg1) {
        this.clientVersion = arg1;
    }

    public void notifyHandshakeComplete() {
    }

    public void notifyOfferedCipherSuites(int[] arg2) {
        this.offeredCipherSuites = arg2;
        this.eccCipherSuitesOffered = TlsECCUtils.containsECCCipherSuites(this.offeredCipherSuites);
    }

    public void notifyOfferedCompressionMethods(short[] arg1) {
        this.offeredCompressionMethods = arg1;
    }

    public void notifySecureRenegotiation(boolean arg3) {
        if(!arg3) {
            throw new TlsFatalAlert(40);
        }
    }

    public void processClientExtensions(Hashtable arg3) {
        short v1 = 47;
        this.clientExtensions = arg3;
        if(arg3 != null) {
            this.supportedSignatureAlgorithms = TlsUtils.getSignatureAlgorithmsExtension(arg3);
            if(this.supportedSignatureAlgorithms != null && !TlsUtils.isSignatureAlgorithmsExtensionAllowed(this.clientVersion)) {
                throw new TlsFatalAlert(v1);
            }

            this.namedCurves = TlsECCUtils.getSupportedEllipticCurvesExtension(arg3);
            this.clientECPointFormats = TlsECCUtils.getSupportedPointFormatsExtension(arg3);
        }

        if(!this.eccCipherSuitesOffered && (this.namedCurves != null || this.clientECPointFormats != null)) {
            throw new TlsFatalAlert(v1);
        }
    }

    public void processClientSupplementalData(Vector arg3) {
        if(arg3 != null) {
            throw new TlsFatalAlert(10);
        }
    }

    protected boolean supportsClientECCCapabilities(int[] arg5, short[] arg6) {
        boolean v1 = false;
        if(arg5 == null) {
            v1 = TlsECCUtils.hasAnySupportedNamedCurves();
        }
        else {
            int v0 = 0;
            while(true) {
                if(v0 < arg5.length) {
                    int v2 = arg5[v0];
                    if((NamedCurve.refersToASpecificNamedCurve(v2)) && !TlsECCUtils.isSupportedNamedCurve(v2)) {
                        ++v0;
                        continue;
                    }

                    break;
                }

                return v1;
            }

            v1 = true;
        }

        return v1;
    }
}

