// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

public class ByteQueue {
    private static final int INITBUFSIZE = 1024;
    private int available;
    private byte[] databuf;
    private int skipped;

    public ByteQueue() {
        super();
        this.databuf = new byte[1024];
        this.skipped = 0;
        this.available = 0;
    }

    public void addData(byte[] arg6, int arg7, int arg8) {
        if(this.skipped + this.available + arg8 > this.databuf.length) {
            byte[] v0 = new byte[ByteQueue.nextTwoPow(arg6.length)];
            System.arraycopy(this.databuf, this.skipped, v0, 0, this.available);
            this.skipped = 0;
            this.databuf = v0;
        }

        System.arraycopy(arg6, arg7, this.databuf, this.skipped + this.available, arg8);
        this.available += arg8;
    }

    public static final int nextTwoPow(int arg2) {
        int v0 = arg2 >> 1 | arg2;
        v0 |= v0 >> 2;
        v0 |= v0 >> 4;
        v0 |= v0 >> 8;
        return (v0 | v0 >> 16) + 1;
    }

    public void read(byte[] arg4, int arg5, int arg6, int arg7) {
        if(this.available - arg7 < arg6) {
            throw new TlsRuntimeException("Not enough data to read");
        }

        if(arg4.length - arg5 < arg6) {
            throw new TlsRuntimeException("Buffer size of " + arg4.length + " is too small for a read of " + arg6 + " bytes");
        }

        System.arraycopy(this.databuf, this.skipped + arg7, arg4, arg5, arg6);
    }

    public void removeData(int arg6) {
        if(arg6 > this.available) {
            throw new TlsRuntimeException("Cannot remove " + arg6 + " bytes, only got " + this.available);
        }

        this.available -= arg6;
        this.skipped += arg6;
        if(this.skipped > this.databuf.length / 2) {
            System.arraycopy(this.databuf, this.skipped, this.databuf, 0, this.available);
            this.skipped = 0;
        }
    }

    public int size() {
        return this.available;
    }
}

