// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;

public class Certificate {
    public static final Certificate EMPTY_CHAIN;
    protected org.bouncycastle.asn1.x509.Certificate[] certificateList;

    static {
        Certificate.EMPTY_CHAIN = new Certificate(new org.bouncycastle.asn1.x509.Certificate[0]);
    }

    public Certificate(org.bouncycastle.asn1.x509.Certificate[] arg3) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'certificateList\' cannot be null");
        }

        this.certificateList = arg3;
    }

    private org.bouncycastle.asn1.x509.Certificate[] clone(org.bouncycastle.asn1.x509.Certificate[] arg4) {
        org.bouncycastle.asn1.x509.Certificate[] v0 = new org.bouncycastle.asn1.x509.Certificate[arg4.length];
        System.arraycopy(arg4, 0, v0, 0, v0.length);
        return v0;
    }

    public void encode(OutputStream arg7) {
        int v1 = 0;
        Vector v3 = new Vector(this.certificateList.length);
        int v0 = 0;
        int v2 = 0;
        while(v0 < this.certificateList.length) {
            byte[] v4 = this.certificateList[v0].getEncoded("DER");
            v3.addElement(v4);
            v2 += v4.length + 3;
            ++v0;
        }

        TlsUtils.writeUint24(v2, arg7);
        while(v1 < v3.size()) {
            TlsUtils.writeOpaque24(v3.elementAt(v1), arg7);
            ++v1;
        }
    }

    public org.bouncycastle.asn1.x509.Certificate getCertificateAt(int arg2) {
        return this.certificateList[arg2];
    }

    public org.bouncycastle.asn1.x509.Certificate[] getCertificateList() {
        return this.clone(this.certificateList);
    }

    public org.bouncycastle.asn1.x509.Certificate[] getCerts() {
        return this.clone(this.certificateList);
    }

    public int getLength() {
        return this.certificateList.length;
    }

    public boolean isEmpty() {
        boolean v0 = this.certificateList.length == 0 ? true : false;
        return v0;
    }

    public static Certificate parse(InputStream arg4) {
        int v1;
        Certificate v0_1;
        int v0 = TlsUtils.readUint24(arg4);
        if(v0 == 0) {
            v0_1 = Certificate.EMPTY_CHAIN;
        }
        else {
            Vector v2 = new Vector();
            while(v0 > 0) {
                v1 = TlsUtils.readUint24(arg4);
                v0 -= v1 + 3;
                ByteArrayInputStream v3 = new ByteArrayInputStream(TlsUtils.readFully(v1, arg4));
                ASN1Primitive v1_1 = new ASN1InputStream(((InputStream)v3)).readObject();
                TlsProtocol.assertEmpty(v3);
                v2.addElement(org.bouncycastle.asn1.x509.Certificate.getInstance(v1_1));
            }

            org.bouncycastle.asn1.x509.Certificate[] v3_1 = new org.bouncycastle.asn1.x509.Certificate[v2.size()];
            for(v1 = 0; v1 < v2.size(); ++v1) {
                v3_1[v1] = v2.elementAt(v1);
            }

            v0_1 = new Certificate(v3_1);
        }

        return v0_1;
    }
}

