// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.x500.X500Name;

public class CertificateRequest {
    private Vector certificateAuthorities;
    private short[] certificateTypes;

    public CertificateRequest(short[] arg1, Vector arg2) {
        super();
        this.certificateTypes = arg1;
        this.certificateAuthorities = arg2;
    }

    public void encode(OutputStream arg7) {
        int v2 = 0;
        if(this.certificateTypes == null || this.certificateTypes.length == 0) {
            TlsUtils.writeUint8(0, arg7);
        }
        else {
            TlsUtils.writeUint8(((short)this.certificateTypes.length), arg7);
            TlsUtils.writeUint8Array(this.certificateTypes, arg7);
        }

        if(this.certificateAuthorities == null || (this.certificateAuthorities.isEmpty())) {
            TlsUtils.writeUint16(0, arg7);
        }
        else {
            Vector v4 = new Vector(this.certificateAuthorities.size());
            int v1 = 0;
            int v3 = 0;
            while(v1 < this.certificateAuthorities.size()) {
                byte[] v0 = this.certificateAuthorities.elementAt(v1).getEncoded("DER");
                v4.addElement(v0);
                v3 += v0.length;
                ++v1;
            }

            TlsUtils.writeUint16(v3, arg7);
            while(v2 < v4.size()) {
                arg7.write(v4.elementAt(v2));
                ++v2;
            }
        }
    }

    public Vector getCertificateAuthorities() {
        return this.certificateAuthorities;
    }

    public short[] getCertificateTypes() {
        return this.certificateTypes;
    }

    public static CertificateRequest parse(InputStream arg4) {
        int v1 = TlsUtils.readUint8(arg4);
        short[] v2 = new short[v1];
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            v2[v0] = TlsUtils.readUint8(arg4);
        }

        byte[] v0_1 = TlsUtils.readOpaque16(arg4);
        Vector v1_1 = new Vector();
        ByteArrayInputStream v3 = new ByteArrayInputStream(v0_1);
        while(v3.available() > 0) {
            v1_1.addElement(X500Name.getInstance(ASN1Primitive.fromByteArray(TlsUtils.readOpaque16(((InputStream)v3)))));
        }

        return new CertificateRequest(v2, v1_1);
    }
}

