// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.Digest;

class CombinedHash implements TlsHandshakeHash {
    protected TlsContext context;
    protected Digest md5;
    protected Digest sha1;

    CombinedHash() {
        super();
        this.md5 = TlsUtils.createHash(1);
        this.sha1 = TlsUtils.createHash(2);
    }

    CombinedHash(CombinedHash arg3) {
        super();
        this.context = arg3.context;
        this.md5 = TlsUtils.cloneHash(1, arg3.md5);
        this.sha1 = TlsUtils.cloneHash(2, arg3.sha1);
    }

    public TlsHandshakeHash commit() {
        return this;
    }

    public int doFinal(byte[] arg5, int arg6) {
        if(this.context != null && (this.context.getServerVersion().isSSL())) {
            this.ssl3Complete(this.md5, SSL3Mac.IPAD, SSL3Mac.OPAD, 48);
            this.ssl3Complete(this.sha1, SSL3Mac.IPAD, SSL3Mac.OPAD, 40);
        }

        int v0 = this.md5.doFinal(arg5, arg6);
        return v0 + this.sha1.doFinal(arg5, arg6 + v0);
    }

    public TlsHandshakeHash fork() {
        return new CombinedHash(this);
    }

    public String getAlgorithmName() {
        return this.md5.getAlgorithmName() + " and " + this.sha1.getAlgorithmName();
    }

    public int getDigestSize() {
        return this.md5.getDigestSize() + this.sha1.getDigestSize();
    }

    public void init(TlsContext arg1) {
        this.context = arg1;
    }

    public void reset() {
        this.md5.reset();
        this.sha1.reset();
    }

    protected void ssl3Complete(Digest arg5, byte[] arg6, byte[] arg7, int arg8) {
        byte[] v0 = this.context.getSecurityParameters().masterSecret;
        arg5.update(v0, 0, v0.length);
        arg5.update(arg6, 0, arg8);
        byte[] v1 = new byte[arg5.getDigestSize()];
        arg5.doFinal(v1, 0);
        arg5.update(v0, 0, v0.length);
        arg5.update(arg7, 0, arg8);
        arg5.update(v1, 0, v1.length);
    }

    public void update(byte arg2) {
        this.md5.update(arg2);
        this.sha1.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.md5.update(arg2, arg3, arg4);
        this.sha1.update(arg2, arg3, arg4);
    }
}

