// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.SecureRandom;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.util.Arrays;

public class DTLSClientProtocol extends DTLSProtocol {
    public DTLSClientProtocol(SecureRandom arg1) {
        super(arg1);
    }

    protected DTLSTransport clientHandshake(DTLSClientProtocol$ClientHandshakeState arg12, DTLSRecordLayer arg13) {
        byte[] v0_1;
        short v10 = 20;
        int v9 = 12;
        short v8 = 11;
        short v6 = 10;
        SecurityParameters v1 = arg12.clientContext.getSecurityParameters();
        DTLSReliableHandshake v2 = new DTLSReliableHandshake(arg12.clientContext, arg13);
        byte[] v3 = this.generateClientHello(arg12, arg12.client);
        v2.sendMessage(1, v3);
        DTLSReliableHandshake$Message v0 = v2.receiveMessage();
        ProtocolVersion v4 = arg13.getDiscoveredPeerVersion();
        if(!v4.isEqualOrEarlierVersionOf(arg12.clientContext.getClientVersion())) {
            throw new TlsFatalAlert(47);
        }

        arg12.clientContext.setServerVersion(v4);
        arg12.client.notifyServerVersion(v4);
        while(v0.getType() == 3) {
            v0_1 = DTLSClientProtocol.patchClientHelloWithCookie(v3, DTLSClientProtocol.parseHelloVerifyRequest(arg12.clientContext, v0.getBody()));
            v2.resetHandshakeMessagesDigest();
            v2.sendMessage(1, v0_1);
            v0 = v2.receiveMessage();
        }

        if(v0.getType() == 2) {
            this.processServerHello(arg12, v0.getBody());
            v0 = v2.receiveMessage();
            v1.prfAlgorithm = TlsProtocol.getPRFAlgorithm(arg12.selectedCipherSuite);
            v1.compressionAlgorithm = arg12.selectedCompressionMethod;
            v1.verifyDataLength = v9;
            v2.notifyHelloComplete();
            if(v0.getType() == 23) {
                this.processServerSupplementalData(arg12, v0.getBody());
                v0 = v2.receiveMessage();
            }
            else {
                arg12.client.processServerSupplementalData(null);
            }

            arg12.keyExchange = arg12.client.getKeyExchange();
            arg12.keyExchange.init(arg12.clientContext);
            if(v0.getType() == v8) {
                this.processServerCertificate(arg12, v0.getBody());
                v0 = v2.receiveMessage();
            }
            else {
                arg12.keyExchange.skipServerCredentials();
            }

            if(v0.getType() == v9) {
                this.processServerKeyExchange(arg12, v0.getBody());
                v0 = v2.receiveMessage();
            }
            else {
                arg12.keyExchange.skipServerKeyExchange();
            }

            if(v0.getType() == 13) {
                this.processCertificateRequest(arg12, v0.getBody());
                v0 = v2.receiveMessage();
            }

            if(v0.getType() == 14) {
                if(v0.getBody().length != 0) {
                    throw new TlsFatalAlert(50);
                }

                Vector v0_2 = arg12.client.getClientSupplementalData();
                if(v0_2 != null) {
                    v2.sendMessage(23, DTLSClientProtocol.generateSupplementalData(v0_2));
                }

                if(arg12.certificateRequest != null) {
                    arg12.clientCredentials = arg12.authentication.getClientCredentials(arg12.certificateRequest);
                    Certificate v0_3 = null;
                    if(arg12.clientCredentials != null) {
                        v0_3 = arg12.clientCredentials.getCertificate();
                    }

                    if(v0_3 == null) {
                        v0_3 = Certificate.EMPTY_CHAIN;
                    }

                    v2.sendMessage(v8, DTLSClientProtocol.generateCertificate(v0_3));
                }

                if(arg12.clientCredentials != null) {
                    arg12.keyExchange.processClientCredentials(arg12.clientCredentials);
                }
                else {
                    arg12.keyExchange.skipClientCredentials();
                }

                v2.sendMessage(16, this.generateClientKeyExchange(arg12));
                TlsProtocol.establishMasterSecret(arg12.clientContext, arg12.keyExchange);
                if((arg12.clientCredentials instanceof TlsSignerCredentials)) {
                    v2.sendMessage(15, this.generateCertificateVerify(arg12, arg12.clientCredentials.generateCertificateSignature(v2.getCurrentHash())));
                }

                arg13.initPendingEpoch(arg12.client.getCipher());
                v2.sendMessage(v10, TlsUtils.calculateVerifyData(arg12.clientContext, "client finished", v2.getCurrentHash()));
                if(arg12.expectSessionTicket) {
                    v0 = v2.receiveMessage();
                    if(v0.getType() == 4) {
                        this.processNewSessionTicket(arg12, v0.getBody());
                    }
                    else {
                        throw new TlsFatalAlert(v6);
                    }
                }

                v0_1 = TlsUtils.calculateVerifyData(arg12.clientContext, "server finished", v2.getCurrentHash());
                DTLSReliableHandshake$Message v1_1 = v2.receiveMessage();
                if(v1_1.getType() == v10) {
                    this.processFinished(v1_1.getBody(), v0_1);
                    v2.finish();
                    arg12.client.notifyHandshakeComplete();
                    return new DTLSTransport(arg13);
                }

                throw new TlsFatalAlert(v6);
            }

            throw new TlsFatalAlert(v6);
        }

        throw new TlsFatalAlert(v6);
    }

    public DTLSTransport connect(TlsClient arg6, DatagramTransport arg7) {
        DTLSTransport v0_2;
        short v4 = 80;
        if(arg6 == null) {
            throw new IllegalArgumentException("\'client\' cannot be null");
        }

        if(arg7 == null) {
            throw new IllegalArgumentException("\'transport\' cannot be null");
        }

        SecurityParameters v0 = new SecurityParameters();
        v0.entity = 1;
        v0.clientRandom = TlsProtocol.createRandomBlock(this.secureRandom);
        DTLSClientProtocol$ClientHandshakeState v1 = new DTLSClientProtocol$ClientHandshakeState();
        v1.client = arg6;
        v1.clientContext = new TlsClientContextImpl(this.secureRandom, v0);
        arg6.init(v1.clientContext);
        DTLSRecordLayer v0_1 = new DTLSRecordLayer(arg7, v1.clientContext, ((TlsPeer)arg6), 22);
        try {
            v0_2 = this.clientHandshake(v1, v0_1);
            return v0_2;
        }
        catch(RuntimeException v1_1) {
            ((DTLSRecordLayer)v0_2).fail(v4);
            throw new TlsFatalAlert(v4);
        }
        catch(IOException v1_2) {
            ((DTLSRecordLayer)v0_2).fail(v4);
            throw v1_2;
        }
        catch(TlsFatalAlert v1_3) {
            ((DTLSRecordLayer)v0_2).fail(v1_3.getAlertDescription());
            throw v1_3;
        }
    }

    protected byte[] generateCertificateVerify(DTLSClientProtocol$ClientHandshakeState arg2, byte[] arg3) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        TlsUtils.writeOpaque16(arg3, ((OutputStream)v0));
        return v0.toByteArray();
    }

    protected byte[] generateClientHello(DTLSClientProtocol$ClientHandshakeState arg6, TlsClient arg7) {
        ByteArrayOutputStream v4 = new ByteArrayOutputStream();
        ProtocolVersion v0 = arg7.getClientVersion();
        if(!v0.isDTLS()) {
            throw new TlsFatalAlert(80);
        }

        arg6.clientContext.setClientVersion(v0);
        TlsUtils.writeVersion(v0, ((OutputStream)v4));
        v4.write(arg6.clientContext.getSecurityParameters().getClientRandom());
        TlsUtils.writeOpaque8(TlsUtils.EMPTY_BYTES, ((OutputStream)v4));
        TlsUtils.writeOpaque8(TlsUtils.EMPTY_BYTES, ((OutputStream)v4));
        arg6.offeredCipherSuites = arg7.getCipherSuites();
        arg6.clientExtensions = arg7.getClientExtensions();
        int v0_1 = arg6.clientExtensions == null || arg6.clientExtensions.get(TlsProtocol.EXT_RenegotiationInfo) == null ? 1 : 0;
        int v3 = arg6.offeredCipherSuites.length;
        if(v0_1 != 0) {
            ++v3;
        }

        TlsUtils.writeUint16(v3 * 2, ((OutputStream)v4));
        TlsUtils.writeUint16Array(arg6.offeredCipherSuites, ((OutputStream)v4));
        if(v0_1 != 0) {
            TlsUtils.writeUint16(255, ((OutputStream)v4));
        }

        arg6.offeredCompressionMethods = new short[]{0};
        TlsUtils.writeUint8(((short)arg6.offeredCompressionMethods.length), ((OutputStream)v4));
        TlsUtils.writeUint8Array(arg6.offeredCompressionMethods, ((OutputStream)v4));
        if(arg6.clientExtensions != null) {
            TlsProtocol.writeExtensions(((OutputStream)v4), arg6.clientExtensions);
        }

        return v4.toByteArray();
    }

    protected byte[] generateClientKeyExchange(DTLSClientProtocol$ClientHandshakeState arg3) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        arg3.keyExchange.generateClientKeyExchange(((OutputStream)v0));
        return v0.toByteArray();
    }

    protected static byte[] parseHelloVerifyRequest(TlsContext arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        if(!TlsUtils.readVersion(((InputStream)v0)).equals(arg3.getServerVersion())) {
            throw new TlsFatalAlert(47);
        }

        byte[] v1 = TlsUtils.readOpaque8(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        return v1;
    }

    protected static byte[] patchClientHelloWithCookie(byte[] arg5, byte[] arg6) {
        int v0 = TlsUtils.readUint8(arg5, 34) + 35;
        int v1 = v0 + 1;
        byte[] v2 = new byte[arg5.length + arg6.length];
        System.arraycopy(arg5, 0, v2, 0, v0);
        TlsUtils.writeUint8(((short)arg6.length), v2, v0);
        System.arraycopy(arg6, 0, v2, v1, arg6.length);
        System.arraycopy(arg5, v1, v2, arg6.length + v1, arg5.length - v1);
        return v2;
    }

    protected void processCertificateRequest(DTLSClientProtocol$ClientHandshakeState arg3, byte[] arg4) {
        if(arg3.authentication == null) {
            throw new TlsFatalAlert(40);
        }

        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        arg3.certificateRequest = CertificateRequest.parse(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        arg3.keyExchange.validateCertificateRequest(arg3.certificateRequest);
    }

    protected void processNewSessionTicket(DTLSClientProtocol$ClientHandshakeState arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        NewSessionTicket v1 = NewSessionTicket.parse(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        arg3.client.notifyNewSessionTicket(v1);
    }

    protected void processServerCertificate(DTLSClientProtocol$ClientHandshakeState arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        Certificate v1 = Certificate.parse(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        arg3.keyExchange.processServerCertificate(v1);
        arg3.authentication = arg3.client.getAuthentication();
        arg3.authentication.notifyServerCertificate(v1);
    }

    protected void processServerHello(DTLSClientProtocol$ClientHandshakeState arg7, byte[] arg8) {
        Object v0_2;
        int v5 = 32;
        short v4 = 47;
        SecurityParameters v0 = arg7.clientContext.getSecurityParameters();
        ByteArrayInputStream v1 = new ByteArrayInputStream(arg8);
        if(!TlsUtils.readVersion(((InputStream)v1)).equals(arg7.clientContext.getServerVersion())) {
            throw new TlsFatalAlert(v4);
        }

        v0.serverRandom = TlsUtils.readFully(v5, ((InputStream)v1));
        byte[] v0_1 = TlsUtils.readOpaque8(((InputStream)v1));
        if(v0_1.length > v5) {
            throw new TlsFatalAlert(v4);
        }

        arg7.client.notifySessionID(v0_1);
        arg7.selectedCipherSuite = TlsUtils.readUint16(((InputStream)v1));
        if((TlsProtocol.arrayContains(arg7.offeredCipherSuites, arg7.selectedCipherSuite)) && arg7.selectedCipherSuite != 0 && arg7.selectedCipherSuite != 255) {
            DTLSClientProtocol.validateSelectedCipherSuite(arg7.selectedCipherSuite, v4);
            arg7.client.notifySelectedCipherSuite(arg7.selectedCipherSuite);
            arg7.selectedCompressionMethod = TlsUtils.readUint8(((InputStream)v1));
            if(!TlsProtocol.arrayContains(arg7.offeredCompressionMethods, arg7.selectedCompressionMethod)) {
                throw new TlsFatalAlert(v4);
            }
            else {
                arg7.client.notifySelectedCompressionMethod(arg7.selectedCompressionMethod);
                Hashtable v1_1 = TlsProtocol.readExtensions(v1);
                if(v1_1 != null) {
                    Enumeration v2 = v1_1.keys();
                    do {
                        if(v2.hasMoreElements()) {
                            v0_2 = v2.nextElement();
                            if(((Integer)v0_2).equals(TlsProtocol.EXT_RenegotiationInfo)) {
                                continue;
                            }

                            if(arg7.clientExtensions != null && arg7.clientExtensions.get(v0_2) != null) {
                                continue;
                            }

                            break;
                        }
                        else {
                            goto label_73;
                        }
                    }
                    while(true);

                    throw new TlsFatalAlert(110);
                label_73:
                    v0_2 = v1_1.get(TlsProtocol.EXT_RenegotiationInfo);
                    if(v0_2 != null) {
                        arg7.secure_renegotiation = true;
                        if(!Arrays.constantTimeAreEqual(((byte[])v0_2), TlsProtocol.createRenegotiationInfo(TlsUtils.EMPTY_BYTES))) {
                            throw new TlsFatalAlert(40);
                        }
                    }

                    arg7.expectSessionTicket = v1_1.containsKey(TlsProtocol.EXT_SessionTicket);
                }

                arg7.client.notifySecureRenegotiation(arg7.secure_renegotiation);
                if(arg7.clientExtensions != null) {
                    arg7.client.processServerExtensions(v1_1);
                }

                return;
            }
        }

        throw new TlsFatalAlert(v4);
    }

    protected void processServerKeyExchange(DTLSClientProtocol$ClientHandshakeState arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        arg3.keyExchange.processServerKeyExchange(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
    }

    protected void processServerSupplementalData(DTLSClientProtocol$ClientHandshakeState arg3, byte[] arg4) {
        arg3.client.processServerSupplementalData(TlsProtocol.readSupplementalDataMessage(new ByteArrayInputStream(arg4)));
    }
}

