// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.SecureRandom;
import java.util.Vector;
import org.bouncycastle.util.Arrays;

public abstract class DTLSProtocol {
    protected final SecureRandom secureRandom;

    protected DTLSProtocol(SecureRandom arg3) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'secureRandom\' cannot be null");
        }

        this.secureRandom = arg3;
    }

    protected static byte[] generateCertificate(Certificate arg1) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        arg1.encode(((OutputStream)v0));
        return v0.toByteArray();
    }

    protected static byte[] generateSupplementalData(Vector arg1) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        TlsProtocol.writeSupplementalData(((OutputStream)v0), arg1);
        return v0.toByteArray();
    }

    protected void processFinished(byte[] arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg3);
        byte[] v1 = TlsUtils.readFully(arg4.length, ((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        if(!Arrays.constantTimeAreEqual(arg4, v1)) {
            throw new TlsFatalAlert(40);
        }
    }

    protected static void validateSelectedCipherSuite(int arg2, short arg3) {
        switch(arg2) {
            case 3: 
            case 4: 
            case 5: 
            case 23: 
            case 24: 
            case 138: 
            case 142: 
            case 146: 
            case 49154: 
            case 49159: 
            case 49164: 
            case 49169: 
            case 49174: {
                goto label_2;
            }
        }

        return;
    label_2:
        throw new IllegalStateException("RC4 MUST NOT be used with DTLS");
    }
}

