// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.util.Integers;

class DTLSReliableHandshake {
    private static final int MAX_RECEIVE_AHEAD = 10;
    private Hashtable currentInboundFlight;
    private TlsHandshakeHash hash;
    private int message_seq;
    private int next_receive_seq;
    private Vector outboundFlight;
    private Hashtable previousInboundFlight;
    private final DTLSRecordLayer recordLayer;
    private boolean sending;

    DTLSReliableHandshake(TlsContext arg3, DTLSRecordLayer arg4) {
        super();
        this.hash = new DeferredHash();
        this.currentInboundFlight = new Hashtable();
        this.previousInboundFlight = null;
        this.outboundFlight = new Vector();
        this.sending = true;
        this.message_seq = 0;
        this.next_receive_seq = 0;
        this.recordLayer = arg4;
        this.hash.init(arg3);
    }

    static int access$100(DTLSReliableHandshake arg1) {
        return arg1.next_receive_seq;
    }

    static Hashtable access$200(DTLSReliableHandshake arg1) {
        return arg1.currentInboundFlight;
    }

    static boolean access$300(Hashtable arg1) {
        return DTLSReliableHandshake.checkAll(arg1);
    }

    static void access$400(DTLSReliableHandshake arg0) {
        arg0.resendOutboundFlight();
    }

    static void access$500(Hashtable arg0) {
        DTLSReliableHandshake.resetAll(arg0);
    }

    private static boolean checkAll(Hashtable arg2) {
        Enumeration v1 = arg2.elements();
        do {
            if(v1.hasMoreElements()) {
                if(v1.nextElement().getBodyIfComplete() != null) {
                    continue;
                }

                break;
            }
            else {
                return true;
            }
        }
        while(true);

        boolean v0 = false;
        return v0;
    }

    private void checkInboundFlight() {
        Enumeration v1 = this.currentInboundFlight.keys();
        while(v1.hasMoreElements()) {
        }
    }

    void finish() {
        DTLSReliableHandshake$1 v0_1;
        DTLSHandshakeRetransmit v0 = null;
        if(!this.sending) {
            this.checkInboundFlight();
        }
        else if(this.currentInboundFlight != null) {
            v0_1 = new DTLSReliableHandshake$1(this);
        }

        this.recordLayer.handshakeSuccessful(((DTLSHandshakeRetransmit)v0_1));
    }

    byte[] getCurrentHash() {
        TlsHandshakeHash v0 = this.hash.fork();
        byte[] v1 = new byte[v0.getDigestSize()];
        v0.doFinal(v1, 0);
        return v1;
    }

    void notifyHelloComplete() {
        this.hash = this.hash.commit();
    }

    private void prepareInboundFlight() {
        DTLSReliableHandshake.resetAll(this.currentInboundFlight);
        this.previousInboundFlight = this.currentInboundFlight;
        this.currentInboundFlight = new Hashtable();
    }

    DTLSReliableHandshake$Message receiveMessage() {
        DTLSReassembler v0_4;
        int v5;
        int v2;
        short v1_2;
        int v9;
        int v6;
        int v7;
        DTLSReliableHandshake$Message v0_1;
        int v4;
        byte[] v1;
        int v12 = 60000;
        int v11 = 12;
        Hashtable v3 = null;
        if(this.sending) {
            this.sending = false;
            this.prepareInboundFlight();
        }

        Object v0 = this.currentInboundFlight.get(Integers.valueOf(this.next_receive_seq));
        if(v0 != null) {
            v1 = ((DTLSReassembler)v0).getBodyIfComplete();
            if(v1 != null) {
                this.previousInboundFlight = v3;
                v4 = this.next_receive_seq;
                this.next_receive_seq = v4 + 1;
                v0_1 = this.updateHandshakeMessagesDigest(new DTLSReliableHandshake$Message(v4, ((DTLSReassembler)v0).getType(), v1, ((DTLSReliableHandshake$1)v3)));
                return v0_1;
            }
        }

        int v0_2;
        for(v0_2 = 1000; true; v0_2 = Math.min(v7 * 2, v12)) {
            int v8 = this.recordLayer.getReceiveLimit();
            if((((byte[])v3)) == null || ((byte[])v3).length < v8) {
                byte[] v3_1 = new byte[v8];
                v7 = v0_2;
            }
            else {
                v7 = v0_2;
            }

            try {
                do {
                label_32:
                    v0_2 = this.recordLayer.receive(((byte[])v3), 0, v8, v7);
                    if(v0_2 >= 0) {
                        break;
                    }

                    goto label_36;
                }
                while(true);
            }
            catch(IOException v0_3) {
                goto label_106;
            }

            if(v0_2 < v11) {
                goto label_32;
            }

            int v1_1 = 9;
            try {
                v6 = TlsUtils.readUint24(((byte[])v3), v1_1);
                if(v0_2 != v6 + 12) {
                    goto label_32;
                }

                v9 = TlsUtils.readUint16(((byte[])v3), 4);
                if(v9 > this.next_receive_seq + 10) {
                    goto label_32;
                }

                v1_2 = TlsUtils.readUint8(((byte[])v3), 0);
                v2 = TlsUtils.readUint24(((byte[])v3), 1);
                v5 = TlsUtils.readUint24(((byte[])v3), 6);
                if(v5 + v6 > v2) {
                    goto label_32;
                }

                if(v9 >= this.next_receive_seq) {
                    goto label_79;
                }

                if(this.previousInboundFlight == null) {
                    goto label_32;
                }

                v0 = this.previousInboundFlight.get(Integers.valueOf(v9));
                if(v0 != null) {
                    ((DTLSReassembler)v0).contributeFragment(v1_2, v2, ((byte[])v3), 12, v5, v6);
                    if(DTLSReliableHandshake.checkAll(this.previousInboundFlight)) {
                        this.resendOutboundFlight();
                        v0_2 = Math.min(v7 * 2, 60000);
                        goto label_75;
                    }
                    else {
                        goto label_112;
                    }
                }
                else {
                    goto label_112;
                }

                goto label_77;
            }
            catch(IOException v0_3) {
                goto label_106;
            }

            try {
            label_75:
                DTLSReliableHandshake.resetAll(this.previousInboundFlight);
                goto label_77;
            }
            catch(IOException v1_3) {
                v7 = v0_2;
                goto label_36;
            }

        label_112:
            v0_2 = v7;
        label_77:
            v7 = v0_2;
            goto label_32;
            try {
            label_79:
                v0 = this.currentInboundFlight.get(Integers.valueOf(v9));
                if(v0 == null) {
                    v0_4 = new DTLSReassembler(v1_2, v2);
                    this.currentInboundFlight.put(Integers.valueOf(v9), v0_4);
                }

                v0_4.contributeFragment(v1_2, v2, ((byte[])v3), 12, v5, v6);
                if(v9 != this.next_receive_seq) {
                    goto label_32;
                }

                v1 = v0_4.getBodyIfComplete();
                if(v1 == null) {
                    goto label_32;
                }

                this.previousInboundFlight = null;
                v4 = this.next_receive_seq;
                this.next_receive_seq = v4 + 1;
                return this.updateHandshakeMessagesDigest(new DTLSReliableHandshake$Message(v4, v0_4.getType(), v1, null));
            }
            catch(IOException v0_3) {
            label_106:
            }

        label_36:
            this.resendOutboundFlight();
        }

        return v0_1;
    }

    private void resendOutboundFlight() {
        this.recordLayer.resetWriteEpoch();
        int v1;
        for(v1 = 0; v1 < this.outboundFlight.size(); ++v1) {
            this.writeMessage(this.outboundFlight.elementAt(v1));
        }
    }

    private static void resetAll(Hashtable arg2) {
        Enumeration v1 = arg2.elements();
        while(v1.hasMoreElements()) {
            v1.nextElement().reset();
        }
    }

    void resetHandshakeMessagesDigest() {
        this.hash.reset();
    }

    void sendMessage(short arg4, byte[] arg5) {
        if(!this.sending) {
            this.checkInboundFlight();
            this.sending = true;
            this.outboundFlight.removeAllElements();
        }

        int v1 = this.message_seq;
        this.message_seq = v1 + 1;
        DTLSReliableHandshake$Message v0 = new DTLSReliableHandshake$Message(v1, arg4, arg5, null);
        this.outboundFlight.addElement(v0);
        this.writeMessage(v0);
        this.updateHandshakeMessagesDigest(v0);
    }

    private DTLSReliableHandshake$Message updateHandshakeMessagesDigest(DTLSReliableHandshake$Message arg6) {
        if(arg6.getType() != 0) {
            byte[] v0 = arg6.getBody();
            byte[] v1 = new byte[12];
            TlsUtils.writeUint8(arg6.getType(), v1, 0);
            TlsUtils.writeUint24(v0.length, v1, 1);
            TlsUtils.writeUint16(arg6.getSeq(), v1, 4);
            TlsUtils.writeUint24(0, v1, 6);
            TlsUtils.writeUint24(v0.length, v1, 9);
            this.hash.update(v1, 0, v1.length);
            this.hash.update(v0, 0, v0.length);
        }

        return arg6;
    }

    private void writeHandshakeFragment(DTLSReliableHandshake$Message arg5, int arg6, int arg7) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        TlsUtils.writeUint8(arg5.getType(), ((OutputStream)v0));
        TlsUtils.writeUint24(arg5.getBody().length, ((OutputStream)v0));
        TlsUtils.writeUint16(arg5.getSeq(), ((OutputStream)v0));
        TlsUtils.writeUint24(arg6, ((OutputStream)v0));
        TlsUtils.writeUint24(arg7, ((OutputStream)v0));
        v0.write(arg5.getBody(), arg6, arg7);
        byte[] v0_1 = v0.toByteArray();
        this.recordLayer.send(v0_1, 0, v0_1.length);
    }

    private void writeMessage(DTLSReliableHandshake$Message arg5) {
        int v1 = this.recordLayer.getSendLimit() - 12;
        if(v1 < 1) {
            throw new TlsFatalAlert(80);
        }

        int v2 = arg5.getBody().length;
        int v0 = 0;
        do {
            int v3 = Math.min(v2 - v0, v1);
            this.writeHandshakeFragment(arg5, v0, v3);
            v0 += v3;
        }
        while(v0 < v2);
    }
}

