// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.SecureRandom;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.crypto.util.PublicKeyFactory;
import org.bouncycastle.util.Arrays;

public class DTLSServerProtocol extends DTLSProtocol {
    protected boolean verifyRequests;

    public DTLSServerProtocol(SecureRandom arg2) {
        super(arg2);
        this.verifyRequests = true;
    }

    public DTLSTransport accept(TlsServer arg6, DatagramTransport arg7) {
        DTLSTransport v0_2;
        short v4 = 80;
        if(arg6 == null) {
            throw new IllegalArgumentException("\'server\' cannot be null");
        }

        if(arg7 == null) {
            throw new IllegalArgumentException("\'transport\' cannot be null");
        }

        SecurityParameters v0 = new SecurityParameters();
        v0.entity = 0;
        v0.serverRandom = TlsProtocol.createRandomBlock(this.secureRandom);
        DTLSServerProtocol$ServerHandshakeState v1 = new DTLSServerProtocol$ServerHandshakeState();
        v1.server = arg6;
        v1.serverContext = new TlsServerContextImpl(this.secureRandom, v0);
        arg6.init(v1.serverContext);
        DTLSRecordLayer v0_1 = new DTLSRecordLayer(arg7, v1.serverContext, ((TlsPeer)arg6), 22);
        try {
            v0_2 = this.serverHandshake(v1, v0_1);
            return v0_2;
        }
        catch(RuntimeException v1_1) {
            ((DTLSRecordLayer)v0_2).fail(v4);
            throw new TlsFatalAlert(v4);
        }
        catch(IOException v1_2) {
            ((DTLSRecordLayer)v0_2).fail(v4);
            throw v1_2;
        }
        catch(TlsFatalAlert v1_3) {
            ((DTLSRecordLayer)v0_2).fail(v1_3.getAlertDescription());
            throw v1_3;
        }
    }

    protected boolean expectCertificateVerifyMessage(DTLSServerProtocol$ServerHandshakeState arg2) {
        boolean v0 = arg2.clientCertificateType < 0 || !TlsUtils.hasSigningCapability(arg2.clientCertificateType) ? false : true;
        return v0;
    }

    protected byte[] generateCertificateRequest(DTLSServerProtocol$ServerHandshakeState arg2, CertificateRequest arg3) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        arg3.encode(((OutputStream)v0));
        return v0.toByteArray();
    }

    protected byte[] generateNewSessionTicket(DTLSServerProtocol$ServerHandshakeState arg2, NewSessionTicket arg3) {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        arg3.encode(((OutputStream)v0));
        return v0.toByteArray();
    }

    protected byte[] generateServerHello(DTLSServerProtocol$ServerHandshakeState arg5) {
        short v3 = 80;
        ByteArrayOutputStream v1 = new ByteArrayOutputStream();
        ProtocolVersion v0 = arg5.server.getServerVersion();
        if(!v0.isEqualOrEarlierVersionOf(arg5.serverContext.getClientVersion())) {
            throw new TlsFatalAlert(v3);
        }

        arg5.serverContext.setServerVersion(v0);
        TlsUtils.writeVersion(arg5.serverContext.getServerVersion(), ((OutputStream)v1));
        v1.write(arg5.serverContext.getSecurityParameters().serverRandom);
        TlsUtils.writeOpaque8(TlsUtils.EMPTY_BYTES, ((OutputStream)v1));
        arg5.selectedCipherSuite = arg5.server.getSelectedCipherSuite();
        if((TlsProtocol.arrayContains(arg5.offeredCipherSuites, arg5.selectedCipherSuite)) && arg5.selectedCipherSuite != 0 && arg5.selectedCipherSuite != 255) {
            DTLSServerProtocol.validateSelectedCipherSuite(arg5.selectedCipherSuite, v3);
            arg5.selectedCompressionMethod = arg5.server.getSelectedCompressionMethod();
            if(!TlsProtocol.arrayContains(arg5.offeredCompressionMethods, arg5.selectedCompressionMethod)) {
                throw new TlsFatalAlert(v3);
            }
            else {
                TlsUtils.writeUint16(arg5.selectedCipherSuite, ((OutputStream)v1));
                TlsUtils.writeUint8(arg5.selectedCompressionMethod, ((OutputStream)v1));
                arg5.serverExtensions = arg5.server.getServerExtensions();
                if(arg5.secure_renegotiation) {
                    int v0_1 = arg5.serverExtensions == null || !arg5.serverExtensions.containsKey(TlsProtocol.EXT_RenegotiationInfo) ? 1 : 0;
                    if(v0_1 == 0) {
                        goto label_77;
                    }

                    if(arg5.serverExtensions == null) {
                        arg5.serverExtensions = new Hashtable();
                    }

                    arg5.serverExtensions.put(TlsProtocol.EXT_RenegotiationInfo, TlsProtocol.createRenegotiationInfo(TlsUtils.EMPTY_BYTES));
                }

            label_77:
                if(arg5.serverExtensions != null) {
                    arg5.expectSessionTicket = arg5.serverExtensions.containsKey(TlsProtocol.EXT_SessionTicket);
                    TlsProtocol.writeExtensions(((OutputStream)v1), arg5.serverExtensions);
                }

                return v1.toByteArray();
            }
        }

        throw new TlsFatalAlert(v3);
    }

    public boolean getVerifyRequests() {
        return this.verifyRequests;
    }

    protected void notifyClientCertificate(DTLSServerProtocol$ServerHandshakeState arg3, Certificate arg4) {
        if(arg3.certificateRequest == null) {
            throw new IllegalStateException();
        }

        if(arg3.clientCertificate != null) {
            throw new TlsFatalAlert(10);
        }

        arg3.clientCertificate = arg4;
        if(arg4.isEmpty()) {
            arg3.keyExchange.skipClientCredentials();
        }
        else {
            arg3.clientCertificateType = TlsUtils.getClientCertificateType(arg4, arg3.serverCredentials.getCertificate());
            arg3.keyExchange.processClientCertificate(arg4);
        }

        arg3.server.notifyClientCertificate(arg4);
    }

    protected void processCertificateVerify(DTLSServerProtocol$ServerHandshakeState arg5, byte[] arg6, byte[] arg7) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg6);
        byte[] v1 = TlsUtils.readOpaque16(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        try {
            TlsSigner v0_2 = TlsUtils.createTlsSigner(arg5.clientCertificateType);
            v0_2.init(arg5.serverContext);
            v0_2.verifyRawSignature(v1, PublicKeyFactory.createKey(arg5.clientCertificate.getCertificateAt(0).getSubjectPublicKeyInfo()), arg7);
            return;
        }
        catch(Exception v0_1) {
            throw new TlsFatalAlert(51);
        }
    }

    protected void processClientCertificate(DTLSServerProtocol$ServerHandshakeState arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        Certificate v1 = Certificate.parse(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        this.notifyClientCertificate(arg3, v1);
    }

    protected void processClientHello(DTLSServerProtocol$ServerHandshakeState arg8, byte[] arg9) {
        int v4 = 32;
        short v6 = 47;
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg9);
        ProtocolVersion v1 = TlsUtils.readVersion(((InputStream)v0));
        if(!v1.isDTLS()) {
            throw new TlsFatalAlert(v6);
        }

        byte[] v2 = TlsUtils.readFully(v4, ((InputStream)v0));
        if(TlsUtils.readOpaque8(((InputStream)v0)).length > v4) {
            throw new TlsFatalAlert(v6);
        }

        TlsUtils.readOpaque8(((InputStream)v0));
        int v3 = TlsUtils.readUint16(((InputStream)v0));
        if(v3 >= 2 && (v3 & 1) == 0) {
            arg8.offeredCipherSuites = TlsUtils.readUint16Array(v3 / 2, ((InputStream)v0));
            v3 = TlsUtils.readUint8(((InputStream)v0));
            if(v3 < 1) {
                throw new TlsFatalAlert(v6);
            }
            else {
                arg8.offeredCompressionMethods = TlsUtils.readUint8Array(v3, ((InputStream)v0));
                arg8.clientExtensions = TlsProtocol.readExtensions(v0);
                arg8.serverContext.setClientVersion(v1);
                arg8.server.notifyClientVersion(v1);
                arg8.serverContext.getSecurityParameters().clientRandom = v2;
                arg8.server.notifyOfferedCipherSuites(arg8.offeredCipherSuites);
                arg8.server.notifyOfferedCompressionMethods(arg8.offeredCompressionMethods);
                if(TlsProtocol.arrayContains(arg8.offeredCipherSuites, 255)) {
                    arg8.secure_renegotiation = true;
                }

                if(arg8.clientExtensions != null) {
                    Object v0_1 = arg8.clientExtensions.get(TlsProtocol.EXT_RenegotiationInfo);
                    if(v0_1 != null) {
                        arg8.secure_renegotiation = true;
                        if(!Arrays.constantTimeAreEqual(((byte[])v0_1), TlsProtocol.createRenegotiationInfo(TlsUtils.EMPTY_BYTES))) {
                            throw new TlsFatalAlert(40);
                        }
                    }
                }

                arg8.server.notifySecureRenegotiation(arg8.secure_renegotiation);
                if(arg8.clientExtensions != null) {
                    arg8.server.processClientExtensions(arg8.clientExtensions);
                }

                return;
            }
        }

        throw new TlsFatalAlert(50);
    }

    protected void processClientKeyExchange(DTLSServerProtocol$ServerHandshakeState arg3, byte[] arg4) {
        ByteArrayInputStream v0 = new ByteArrayInputStream(arg4);
        arg3.keyExchange.processClientKeyExchange(((InputStream)v0));
        TlsProtocol.assertEmpty(v0);
        TlsProtocol.establishMasterSecret(arg3.serverContext, arg3.keyExchange);
    }

    protected void processClientSupplementalData(DTLSServerProtocol$ServerHandshakeState arg3, byte[] arg4) {
        arg3.server.processClientSupplementalData(TlsProtocol.readSupplementalDataMessage(new ByteArrayInputStream(arg4)));
    }

    public DTLSTransport serverHandshake(DTLSServerProtocol$ServerHandshakeState arg11, DTLSRecordLayer arg12) {
        short v9 = 23;
        short v8 = 20;
        short v7 = 12;
        short v6 = 11;
        short v5 = 10;
        SecurityParameters v0 = arg11.serverContext.getSecurityParameters();
        DTLSReliableHandshake v1 = new DTLSReliableHandshake(arg11.serverContext, arg12);
        DTLSReliableHandshake$Message v2 = v1.receiveMessage();
        arg11.serverContext.setClientVersion(arg12.getDiscoveredPeerVersion());
        if(v2.getType() == 1) {
            this.processClientHello(arg11, v2.getBody());
            v1.sendMessage(2, this.generateServerHello(arg11));
            v0.prfAlgorithm = TlsProtocol.getPRFAlgorithm(arg11.selectedCipherSuite);
            v0.compressionAlgorithm = arg11.selectedCompressionMethod;
            v0.verifyDataLength = v7;
            v1.notifyHelloComplete();
            Vector v0_1 = arg11.server.getServerSupplementalData();
            if(v0_1 != null) {
                v1.sendMessage(v9, DTLSServerProtocol.generateSupplementalData(v0_1));
            }

            arg11.keyExchange = arg11.server.getKeyExchange();
            arg11.keyExchange.init(arg11.serverContext);
            arg11.serverCredentials = arg11.server.getCredentials();
            if(arg11.serverCredentials == null) {
                arg11.keyExchange.skipServerCredentials();
            }
            else {
                arg11.keyExchange.processServerCredentials(arg11.serverCredentials);
                v1.sendMessage(v6, DTLSServerProtocol.generateCertificate(arg11.serverCredentials.getCertificate()));
            }

            byte[] v0_2 = arg11.keyExchange.generateServerKeyExchange();
            if(v0_2 != null) {
                v1.sendMessage(v7, v0_2);
            }

            if(arg11.serverCredentials != null) {
                arg11.certificateRequest = arg11.server.getCertificateRequest();
                if(arg11.certificateRequest != null) {
                    arg11.keyExchange.validateCertificateRequest(arg11.certificateRequest);
                    v1.sendMessage(13, this.generateCertificateRequest(arg11, arg11.certificateRequest));
                }
            }

            v1.sendMessage(14, TlsUtils.EMPTY_BYTES);
            DTLSReliableHandshake$Message v0_3 = v1.receiveMessage();
            if(v0_3.getType() == v9) {
                this.processClientSupplementalData(arg11, v0_3.getBody());
                v0_3 = v1.receiveMessage();
            }
            else {
                arg11.server.processClientSupplementalData(null);
            }

            if(arg11.certificateRequest == null) {
                arg11.keyExchange.skipClientCredentials();
            }
            else if(v0_3.getType() == v6) {
                this.processClientCertificate(arg11, v0_3.getBody());
                v0_3 = v1.receiveMessage();
            }
            else if(ProtocolVersion.TLSv12.isEqualOrEarlierVersionOf(arg11.serverContext.getServerVersion().getEquivalentTLSVersion())) {
                throw new TlsFatalAlert(v5);
            }
            else {
                this.notifyClientCertificate(arg11, Certificate.EMPTY_CHAIN);
            }

            if(v0_3.getType() == 16) {
                this.processClientKeyExchange(arg11, v0_3.getBody());
                arg12.initPendingEpoch(arg11.server.getCipher());
                if(this.expectCertificateVerifyMessage(arg11)) {
                    v0_2 = v1.getCurrentHash();
                    v2 = v1.receiveMessage();
                    if(v2.getType() == 15) {
                        this.processCertificateVerify(arg11, v2.getBody(), v0_2);
                    }
                    else {
                        throw new TlsFatalAlert(v5);
                    }
                }

                v0_2 = v1.getCurrentHash();
                v2 = v1.receiveMessage();
                if(v2.getType() == v8) {
                    this.processFinished(v2.getBody(), TlsUtils.calculateVerifyData(arg11.serverContext, "client finished", v0_2));
                    if(arg11.expectSessionTicket) {
                        v1.sendMessage(4, this.generateNewSessionTicket(arg11, arg11.server.getNewSessionTicket()));
                    }

                    v1.sendMessage(v8, TlsUtils.calculateVerifyData(arg11.serverContext, "server finished", v1.getCurrentHash()));
                    v1.finish();
                    arg11.server.notifyHandshakeComplete();
                    return new DTLSTransport(arg12);
                }

                throw new TlsFatalAlert(v5);
            }

            throw new TlsFatalAlert(v5);
        }

        throw new TlsFatalAlert(v5);
    }

    public void setVerifyRequests(boolean arg1) {
        this.verifyRequests = arg1;
    }
}

