// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.math.BigInteger;
import org.bouncycastle.crypto.BasicAgreement;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.agreement.DHBasicAgreement;
import org.bouncycastle.crypto.agreement.ECDHBasicAgreement;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.util.BigIntegers;

public class DefaultTlsAgreementCredentials implements TlsAgreementCredentials {
    protected BasicAgreement basicAgreement;
    protected Certificate certificate;
    protected AsymmetricKeyParameter privateKey;
    protected boolean truncateAgreement;

    public DefaultTlsAgreementCredentials(Certificate arg4, AsymmetricKeyParameter arg5) {
        super();
        if(arg4 == null) {
            throw new IllegalArgumentException("\'certificate\' cannot be null");
        }

        if(arg4.isEmpty()) {
            throw new IllegalArgumentException("\'certificate\' cannot be empty");
        }

        if(arg5 == null) {
            throw new IllegalArgumentException("\'privateKey\' cannot be null");
        }

        if(!arg5.isPrivate()) {
            throw new IllegalArgumentException("\'privateKey\' must be private");
        }

        if((arg5 instanceof DHPrivateKeyParameters)) {
            this.basicAgreement = new DHBasicAgreement();
            this.truncateAgreement = true;
        }
        else if((arg5 instanceof ECPrivateKeyParameters)) {
            this.basicAgreement = new ECDHBasicAgreement();
            this.truncateAgreement = false;
        }
        else {
            goto label_41;
        }

        this.certificate = arg4;
        this.privateKey = arg5;
        return;
    label_41:
        throw new IllegalArgumentException("\'privateKey\' type not supported: " + arg5.getClass().getName());
    }

    public byte[] generateAgreement(AsymmetricKeyParameter arg3) {
        this.basicAgreement.init(this.privateKey);
        BigInteger v0 = this.basicAgreement.calculateAgreement(((CipherParameters)arg3));
        byte[] v0_1 = this.truncateAgreement ? BigIntegers.asUnsignedByteArray(v0) : BigIntegers.asUnsignedByteArray(this.basicAgreement.getFieldSize(), v0);
        return v0_1;
    }

    public Certificate getCertificate() {
        return this.certificate;
    }
}

