// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.StreamCipher;
import org.bouncycastle.crypto.digests.MD5Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.digests.SHA256Digest;
import org.bouncycastle.crypto.digests.SHA384Digest;
import org.bouncycastle.crypto.digests.SHA512Digest;
import org.bouncycastle.crypto.engines.AESFastEngine;
import org.bouncycastle.crypto.engines.CamelliaEngine;
import org.bouncycastle.crypto.engines.DESedeEngine;
import org.bouncycastle.crypto.engines.RC4Engine;
import org.bouncycastle.crypto.engines.SEEDEngine;
import org.bouncycastle.crypto.modes.AEADBlockCipher;
import org.bouncycastle.crypto.modes.CBCBlockCipher;
import org.bouncycastle.crypto.modes.GCMBlockCipher;

public class DefaultTlsCipherFactory extends AbstractTlsCipherFactory {
    public DefaultTlsCipherFactory() {
        super();
    }

    protected AEADBlockCipher createAEADBlockCipher_AES_GCM() {
        return new GCMBlockCipher(new AESFastEngine());
    }

    protected BlockCipher createAESBlockCipher() {
        return new CBCBlockCipher(new AESFastEngine());
    }

    protected TlsBlockCipher createAESCipher(TlsContext arg8, int arg9, int arg10) {
        return new TlsBlockCipher(arg8, this.createAESBlockCipher(), this.createAESBlockCipher(), this.createHMACDigest(arg10), this.createHMACDigest(arg10), arg9);
    }

    protected BlockCipher createCamelliaBlockCipher() {
        return new CBCBlockCipher(new CamelliaEngine());
    }

    protected TlsBlockCipher createCamelliaCipher(TlsContext arg8, int arg9, int arg10) {
        return new TlsBlockCipher(arg8, this.createCamelliaBlockCipher(), this.createCamelliaBlockCipher(), this.createHMACDigest(arg10), this.createHMACDigest(arg10), arg9);
    }

    public TlsCipher createCipher(TlsContext arg3, int arg4, int arg5) {
        int v1 = 32;
        int v0 = 16;
        switch(arg4) {
            case 0: {
                goto label_21;
            }
            case 2: {
                goto label_23;
            }
            case 7: {
                goto label_7;
            }
            case 8: {
                goto label_9;
            }
            case 9: {
                goto label_13;
            }
            case 10: {
                goto label_11;
            }
            case 11: {
                goto label_15;
            }
            case 12: {
                goto label_17;
            }
            case 13: {
                goto label_19;
            }
            case 14: {
                goto label_25;
            }
        }

        throw new TlsFatalAlert(80);
    label_19:
        TlsBlockCipher v0_1 = this.createCamelliaCipher(arg3, v1, arg5);
        goto label_8;
    label_17:
        v0_1 = this.createCamelliaCipher(arg3, v0, arg5);
        goto label_8;
    label_7:
        v0_1 = this.createDESedeCipher(arg3, arg5);
        goto label_8;
    label_23:
        TlsStreamCipher v0_2 = this.createRC4Cipher(arg3, v0, arg5);
        goto label_8;
    label_21:
        TlsNullCipher v0_3 = this.createNullCipher(arg3, arg5);
        goto label_8;
    label_11:
        TlsAEADCipher v0_4 = this.createCipher_AES_GCM(arg3, v0, v0);
        goto label_8;
    label_9:
        v0_1 = this.createAESCipher(arg3, v0, arg5);
        goto label_8;
    label_25:
        v0_1 = this.createSEEDCipher(arg3, arg5);
        goto label_8;
    label_15:
        v0_4 = this.createCipher_AES_GCM(arg3, v1, v0);
        goto label_8;
    label_13:
        v0_1 = this.createAESCipher(arg3, v1, arg5);
    label_8:
        return ((TlsCipher)v0_4);
    }

    protected TlsAEADCipher createCipher_AES_GCM(TlsContext arg7, int arg8, int arg9) {
        return new TlsAEADCipher(arg7, this.createAEADBlockCipher_AES_GCM(), this.createAEADBlockCipher_AES_GCM(), arg8, arg9);
    }

    protected BlockCipher createDESedeBlockCipher() {
        return new CBCBlockCipher(new DESedeEngine());
    }

    protected TlsBlockCipher createDESedeCipher(TlsContext arg8, int arg9) {
        return new TlsBlockCipher(arg8, this.createDESedeBlockCipher(), this.createDESedeBlockCipher(), this.createHMACDigest(arg9), this.createHMACDigest(arg9), 24);
    }

    protected Digest createHMACDigest(int arg3) {
        switch(arg3) {
            case 0: {
                goto label_5;
            }
            case 1: {
                goto label_7;
            }
            case 2: {
                goto label_10;
            }
            case 3: {
                goto label_13;
            }
            case 4: {
                goto label_16;
            }
            case 5: {
                goto label_19;
            }
        }

        throw new TlsFatalAlert(80);
    label_19:
        SHA512Digest v0 = new SHA512Digest();
        goto label_6;
    label_7:
        MD5Digest v0_1 = new MD5Digest();
        goto label_6;
    label_5:
        Digest v0_2 = null;
        goto label_6;
    label_10:
        SHA1Digest v0_3 = new SHA1Digest();
        goto label_6;
    label_16:
        SHA384Digest v0_4 = new SHA384Digest();
        goto label_6;
    label_13:
        SHA256Digest v0_5 = new SHA256Digest();
    label_6:
        return ((Digest)v0);
    }

    protected TlsNullCipher createNullCipher(TlsContext arg4, int arg5) {
        return new TlsNullCipher(arg4, this.createHMACDigest(arg5), this.createHMACDigest(arg5));
    }

    protected TlsStreamCipher createRC4Cipher(TlsContext arg8, int arg9, int arg10) {
        return new TlsStreamCipher(arg8, this.createRC4StreamCipher(), this.createRC4StreamCipher(), this.createHMACDigest(arg10), this.createHMACDigest(arg10), arg9);
    }

    protected StreamCipher createRC4StreamCipher() {
        return new RC4Engine();
    }

    protected BlockCipher createSEEDBlockCipher() {
        return new CBCBlockCipher(new SEEDEngine());
    }

    protected TlsBlockCipher createSEEDCipher(TlsContext arg8, int arg9) {
        return new TlsBlockCipher(arg8, this.createSEEDBlockCipher(), this.createSEEDBlockCipher(), this.createHMACDigest(arg9), this.createHMACDigest(arg9), 16);
    }
}

