// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.util.Hashtable;

public abstract class DefaultTlsClient extends AbstractTlsClient {
    protected short[] clientECPointFormats;
    protected int[] namedCurves;
    protected short[] serverECPointFormats;

    public DefaultTlsClient() {
        super();
    }

    public DefaultTlsClient(TlsCipherFactory arg1) {
        super(arg1);
    }

    protected TlsKeyExchange createDHEKeyExchange(int arg4) {
        return new TlsDHEKeyExchange(arg4, this.supportedSignatureAlgorithms, null);
    }

    protected TlsKeyExchange createDHKeyExchange(int arg4) {
        return new TlsDHKeyExchange(arg4, this.supportedSignatureAlgorithms, null);
    }

    protected TlsKeyExchange createECDHEKeyExchange(int arg7) {
        return new TlsECDHEKeyExchange(arg7, this.supportedSignatureAlgorithms, this.namedCurves, this.clientECPointFormats, this.serverECPointFormats);
    }

    protected TlsKeyExchange createECDHKeyExchange(int arg7) {
        return new TlsECDHKeyExchange(arg7, this.supportedSignatureAlgorithms, this.namedCurves, this.clientECPointFormats, this.serverECPointFormats);
    }

    protected TlsKeyExchange createRSAKeyExchange() {
        return new TlsRSAKeyExchange(this.supportedSignatureAlgorithms);
    }

    public TlsCipher getCipher() {
        int v6 = 9;
        int v5 = 3;
        int v3 = 2;
        switch(this.selectedCipherSuite) {
            case 1: {
                goto label_59;
            }
            case 4: {
                goto label_71;
            }
            case 59: {
                goto label_67;
            }
            case 65: 
            case 66: 
            case 67: 
            case 68: 
            case 69: {
                goto label_49;
            }
            case 61: 
            case 104: 
            case 105: 
            case 106: 
            case 107: {
                goto label_35;
            }
            case 132: 
            case 133: 
            case 134: 
            case 135: 
            case 136: {
                goto label_54;
            }
            case 150: 
            case 151: 
            case 152: 
            case 153: 
            case 154: {
                goto label_79;
            }
            case 2: 
            case 49153: 
            case 49158: 
            case 49163: 
            case 49168: {
                goto label_63;
            }
            case 5: 
            case 49154: 
            case 49159: 
            case 49164: 
            case 49169: {
                goto label_75;
            }
            case 10: 
            case 13: 
            case 16: 
            case 19: 
            case 22: 
            case 49155: 
            case 49160: 
            case 49165: 
            case 49170: {
                goto label_11;
            }
            case 47: 
            case 48: 
            case 49: 
            case 50: 
            case 51: 
            case 49156: 
            case 49161: 
            case 49166: 
            case 49171: {
                goto label_16;
            }
            case 53: 
            case 54: 
            case 55: 
            case 56: 
            case 57: 
            case 49157: 
            case 49162: 
            case 49167: 
            case 49172: {
                goto label_31;
            }
            case 60: 
            case 62: 
            case 63: 
            case 64: 
            case 103: 
            case 49187: 
            case 49189: 
            case 49191: 
            case 49193: {
                goto label_21;
            }
            case 49188: 
            case 49190: 
            case 49192: 
            case 49194: {
                goto label_39;
            }
            case 156: 
            case 158: 
            case 160: 
            case 162: 
            case 164: 
            case 49195: 
            case 49197: 
            case 49199: 
            case 49201: {
                goto label_26;
            }
            case 157: 
            case 159: 
            case 161: 
            case 163: 
            case 165: 
            case 49196: 
            case 49198: 
            case 49200: 
            case 49202: {
                goto label_44;
            }
        }

        throw new TlsFatalAlert(80);
    label_11:
        TlsCipher v0 = this.cipherFactory.createCipher(this.context, 7, v3);
        return v0;
    label_16:
        return this.cipherFactory.createCipher(this.context, 8, v3);
    label_21:
        return this.cipherFactory.createCipher(this.context, 8, v5);
    label_26:
        return this.cipherFactory.createCipher(this.context, 10, 0);
    label_31:
        return this.cipherFactory.createCipher(this.context, v6, v3);
    label_39:
        return this.cipherFactory.createCipher(this.context, v6, 4);
    label_35:
        return this.cipherFactory.createCipher(this.context, v6, v5);
    label_44:
        return this.cipherFactory.createCipher(this.context, 11, 0);
    label_54:
        return this.cipherFactory.createCipher(this.context, 13, v3);
    label_49:
        return this.cipherFactory.createCipher(this.context, 12, v3);
    label_63:
        return this.cipherFactory.createCipher(this.context, 0, v3);
    label_59:
        return this.cipherFactory.createCipher(this.context, 0, 1);
    label_71:
        return this.cipherFactory.createCipher(this.context, v3, 1);
    label_67:
        return this.cipherFactory.createCipher(this.context, 0, v5);
    label_79:
        return this.cipherFactory.createCipher(this.context, 14, v3);
    label_75:
        return this.cipherFactory.createCipher(this.context, v3, v3);
    }

    public int[] getCipherSuites() {
        return new int[]{49172, 49171, 49170, 57, 51, 22, 53, 47, 10};
    }

    public Hashtable getClientExtensions() {
        Hashtable v0 = super.getClientExtensions();
        if(TlsECCUtils.containsECCCipherSuites(this.getCipherSuites())) {
            this.namedCurves = new int[]{23, 7, 21, 4, 19, 65282, 65281};
            this.clientECPointFormats = new short[]{2, 1, 0};
            if(v0 == null) {
                v0 = new Hashtable();
            }

            TlsECCUtils.addSupportedEllipticCurvesExtension(v0, this.namedCurves);
            TlsECCUtils.addSupportedPointFormatsExtension(v0, this.clientECPointFormats);
        }

        return v0;
    }

    public TlsKeyExchange getKeyExchange() {
        switch(this.selectedCipherSuite) {
            case 1: 
            case 2: 
            case 4: 
            case 5: 
            case 10: 
            case 47: 
            case 53: 
            case 59: 
            case 60: 
            case 61: 
            case 65: 
            case 132: 
            case 150: 
            case 156: 
            case 157: {
                goto label_30;
            }
            case 22: 
            case 51: 
            case 57: 
            case 69: 
            case 103: 
            case 107: 
            case 136: 
            case 154: 
            case 158: 
            case 159: {
                goto label_15;
            }
            case 16: 
            case 49: 
            case 55: 
            case 63: 
            case 67: 
            case 105: 
            case 134: 
            case 152: 
            case 160: 
            case 161: {
                goto label_9;
            }
            case 19: 
            case 50: 
            case 56: 
            case 64: 
            case 68: 
            case 106: 
            case 135: 
            case 153: 
            case 162: 
            case 163: {
                goto label_12;
            }
            case 13: 
            case 48: 
            case 54: 
            case 62: 
            case 66: 
            case 104: 
            case 133: 
            case 151: 
            case 164: 
            case 165: {
                goto label_6;
            }
            case 49158: 
            case 49159: 
            case 49160: 
            case 49161: 
            case 49162: 
            case 49187: 
            case 49188: 
            case 49195: 
            case 49196: {
                goto label_24;
            }
            case 49153: 
            case 49154: 
            case 49155: 
            case 49156: 
            case 49157: 
            case 49189: 
            case 49190: 
            case 49197: 
            case 49198: {
                goto label_18;
            }
            case 49168: 
            case 49169: 
            case 49170: 
            case 49171: 
            case 49172: 
            case 49191: 
            case 49192: 
            case 49199: 
            case 49200: {
                goto label_27;
            }
            case 49163: 
            case 49164: 
            case 49165: 
            case 49166: 
            case 49167: 
            case 49193: 
            case 49194: 
            case 49201: 
            case 49202: {
                goto label_21;
            }
        }

        throw new TlsFatalAlert(80);
    label_6:
        TlsKeyExchange v0 = this.createDHKeyExchange(7);
        return v0;
    label_12:
        return this.createDHEKeyExchange(3);
    label_9:
        return this.createDHKeyExchange(9);
    label_15:
        return this.createDHEKeyExchange(5);
    label_18:
        return this.createECDHKeyExchange(16);
    label_24:
        return this.createECDHEKeyExchange(17);
    label_21:
        return this.createECDHKeyExchange(18);
    label_27:
        return this.createECDHEKeyExchange(19);
    label_30:
        return this.createRSAKeyExchange();
    }

    public void processServerExtensions(Hashtable arg3) {
        short v1 = 47;
        super.processServerExtensions(arg3);
        if(arg3 != null) {
            if(TlsECCUtils.getSupportedEllipticCurvesExtension(arg3) != null) {
                throw new TlsFatalAlert(v1);
            }
            else {
                this.serverECPointFormats = TlsECCUtils.getSupportedPointFormatsExtension(arg3);
                if(this.serverECPointFormats != null && !TlsECCUtils.isECCCipherSuite(this.selectedCipherSuite)) {
                    throw new TlsFatalAlert(v1);
                }
            }
        }
    }
}

