// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.encodings.PKCS1Encoding;
import org.bouncycastle.crypto.engines.RSABlindedEngine;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class DefaultTlsEncryptionCredentials implements TlsEncryptionCredentials {
    protected Certificate certificate;
    protected TlsContext context;
    protected AsymmetricKeyParameter privateKey;

    public DefaultTlsEncryptionCredentials(TlsContext arg4, Certificate arg5, AsymmetricKeyParameter arg6) {
        super();
        if(arg5 == null) {
            throw new IllegalArgumentException("\'certificate\' cannot be null");
        }

        if(arg5.isEmpty()) {
            throw new IllegalArgumentException("\'certificate\' cannot be empty");
        }

        if(arg6 == null) {
            throw new IllegalArgumentException("\'privateKey\' cannot be null");
        }

        if(!arg6.isPrivate()) {
            throw new IllegalArgumentException("\'privateKey\' must be private");
        }

        if((arg6 instanceof RSAKeyParameters)) {
            this.context = arg4;
            this.certificate = arg5;
            this.privateKey = arg6;
            return;
        }

        throw new IllegalArgumentException("\'privateKey\' type not supported: " + arg6.getClass().getName());
    }

    public byte[] decryptPreMasterSecret(byte[] arg6) {
        PKCS1Encoding v0 = new PKCS1Encoding(new RSABlindedEngine());
        v0.init(false, new ParametersWithRandom(this.privateKey, this.context.getSecureRandom()));
        try {
            return v0.processBlock(arg6, 0, arg6.length);
        }
        catch(InvalidCipherTextException v0_1) {
            throw new TlsFatalAlert(47);
        }
    }

    public Certificate getCertificate() {
        return this.certificate;
    }
}

