// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.CryptoException;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DSAPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class DefaultTlsSignerCredentials implements TlsSignerCredentials {
    protected Certificate certificate;
    protected TlsContext context;
    protected AsymmetricKeyParameter privateKey;
    protected TlsSigner signer;

    public DefaultTlsSignerCredentials(TlsContext arg4, Certificate arg5, AsymmetricKeyParameter arg6) {
        super();
        if(arg5 == null) {
            throw new IllegalArgumentException("\'certificate\' cannot be null");
        }

        if(arg5.isEmpty()) {
            throw new IllegalArgumentException("\'certificate\' cannot be empty");
        }

        if(arg6 == null) {
            throw new IllegalArgumentException("\'privateKey\' cannot be null");
        }

        if(!arg6.isPrivate()) {
            throw new IllegalArgumentException("\'privateKey\' must be private");
        }

        if((arg6 instanceof RSAKeyParameters)) {
            this.signer = new TlsRSASigner();
        }
        else if((arg6 instanceof DSAPrivateKeyParameters)) {
            this.signer = new TlsDSSSigner();
        }
        else if((arg6 instanceof ECPrivateKeyParameters)) {
            this.signer = new TlsECDSASigner();
        }
        else {
            goto label_46;
        }

        this.signer.init(arg4);
        this.context = arg4;
        this.certificate = arg5;
        this.privateKey = arg6;
        return;
    label_46:
        throw new IllegalArgumentException("\'privateKey\' type not supported: " + arg6.getClass().getName());
    }

    public byte[] generateCertificateSignature(byte[] arg3) {
        try {
            return this.signer.generateRawSignature(this.privateKey, arg3);
        }
        catch(CryptoException v0) {
            throw new TlsFatalAlert(80);
        }
    }

    public Certificate getCertificate() {
        return this.certificate;
    }
}

