// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import org.bouncycastle.crypto.Digest;

class DeferredHash implements TlsHandshakeHash {
    private ByteArrayOutputStream buf;
    protected TlsContext context;
    private Digest hash;
    private int prfAlgorithm;

    DeferredHash() {
        super();
        this.buf = new ByteArrayOutputStream();
        this.prfAlgorithm = -1;
        this.hash = null;
        this.buf = new ByteArrayOutputStream();
        this.hash = null;
    }

    private DeferredHash(Digest arg3) {
        super();
        this.buf = new ByteArrayOutputStream();
        this.prfAlgorithm = -1;
        this.hash = null;
        this.buf = null;
        this.hash = arg3;
    }

    protected void checkHash() {
        if(this.hash == null) {
            throw new IllegalStateException("No hash algorithm has been set");
        }
    }

    public TlsHandshakeHash commit() {
        TlsHandshakeHash v5;
        int v1 = this.context.getSecurityParameters().getPrfAlgorithm();
        Digest v0 = TlsUtils.createPRFHash(v1);
        byte[] v2 = this.buf.toByteArray();
        v0.update(v2, 0, v2.length);
        if((v0 instanceof TlsHandshakeHash)) {
            ((TlsHandshakeHash)v0).init(this.context);
            v5 = ((TlsHandshakeHash)v0).commit();
        }
        else {
            this.prfAlgorithm = v1;
            this.hash = v0;
            this.buf = null;
        }

        return ((DeferredHash)v5);
    }

    public int doFinal(byte[] arg2, int arg3) {
        this.checkHash();
        return this.hash.doFinal(arg2, arg3);
    }

    public TlsHandshakeHash fork() {
        this.checkHash();
        return new DeferredHash(TlsUtils.clonePRFHash(this.prfAlgorithm, this.hash));
    }

    public String getAlgorithmName() {
        this.checkHash();
        return this.hash.getAlgorithmName();
    }

    public int getDigestSize() {
        this.checkHash();
        return this.hash.getDigestSize();
    }

    public void init(TlsContext arg1) {
        this.context = arg1;
    }

    public void reset() {
        if(this.hash == null) {
            this.buf.reset();
        }
        else {
            this.hash.reset();
        }
    }

    public void update(byte arg2) {
        if(this.hash == null) {
            this.buf.write(arg2);
        }
        else {
            this.hash.update(arg2);
        }
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        if(this.hash == null) {
            this.buf.write(arg2, arg3, arg4);
        }
        else {
            this.hash.update(arg2, arg3, arg4);
        }
    }
}

