// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

public final class ProtocolVersion {
    public static final ProtocolVersion DTLSv10;
    public static final ProtocolVersion DTLSv12;
    public static final ProtocolVersion SSLv3;
    public static final ProtocolVersion TLSv12;
    private String name;
    private int version;

    static {
        ProtocolVersion.SSLv3 = new ProtocolVersion(768, "SSL 3.0");
        ProtocolVersion.TLSv10 = new ProtocolVersion(769, "TLS 1.0");
        ProtocolVersion.TLSv11 = new ProtocolVersion(770, "TLS 1.1");
        ProtocolVersion.TLSv12 = new ProtocolVersion(771, "TLS 1.2");
        ProtocolVersion.DTLSv10 = new ProtocolVersion(65279, "DTLS 1.0");
        ProtocolVersion.DTLSv12 = new ProtocolVersion(65277, "DTLS 1.2");
    }

    private ProtocolVersion(int arg2, String arg3) {
        super();
        this.version = 65535 & arg2;
        this.name = arg3;
    }

    public boolean equals(Object arg2) {
        boolean v0 = this == (((ProtocolVersion)arg2)) ? true : false;
        return v0;
    }

    public static ProtocolVersion get(int arg2, int arg3) {
        ProtocolVersion v0;
        switch(arg2) {
            case 3: {
                switch(arg3) {
                    case 0: {
                        return ProtocolVersion.SSLv3;
                    }
                    case 1: {
                        v0 = ProtocolVersion.TLSv10;
                        return v0;
                    }
                    case 2: {
                        return ProtocolVersion.TLSv11;
                    }
                    case 3: {
                        return ProtocolVersion.TLSv12;
                    }
                    default: {
                    label_6:
                        switch(arg3) {
                            case 253: {
                                return ProtocolVersion.DTLSv12;
                            }
                            case 255: {
                                return ProtocolVersion.DTLSv10;
                            }
                            default: {
                                throw new TlsFatalAlert(47);
                            }
                        }
                    }
                }
            }
            case 254: {
                goto label_6;
            }
            default: {
            }
        }

        return v0;
    }

    public ProtocolVersion getEquivalentTLSVersion() {
        if(this.isDTLS()) {
            this = this == ProtocolVersion.DTLSv10 ? ProtocolVersion.TLSv11 : ProtocolVersion.TLSv12;
        }

        return this;
    }

    public int getFullVersion() {
        return this.version;
    }

    public int getMajorVersion() {
        return this.version >> 8;
    }

    public int getMinorVersion() {
        return this.version & 255;
    }

    public int hashCode() {
        return this.version;
    }

    public boolean isDTLS() {
        boolean v0 = this.getMajorVersion() == 254 ? true : false;
        return v0;
    }

    public boolean isEqualOrEarlierVersionOf(ProtocolVersion arg5) {
        boolean v0 = true;
        boolean v1 = false;
        if(this.getMajorVersion() == arg5.getMajorVersion()) {
            int v2 = arg5.getMinorVersion() - this.getMinorVersion();
            if(this.isDTLS()) {
                if(v2 > 0) {
                    v0 = false;
                }
            }
            else if(v2 < 0) {
                v0 = false;
            }

            v1 = v0;
        }

        return v1;
    }

    public boolean isLaterVersionOf(ProtocolVersion arg5) {
        boolean v0 = true;
        boolean v1 = false;
        if(this.getMajorVersion() == arg5.getMajorVersion()) {
            int v2 = arg5.getMinorVersion() - this.getMinorVersion();
            if(this.isDTLS()) {
                if(v2 <= 0) {
                    v0 = false;
                }
            }
            else if(v2 >= 0) {
                v0 = false;
            }

            v1 = v0;
        }

        return v1;
    }

    public boolean isSSL() {
        boolean v0 = this == ProtocolVersion.SSLv3 ? true : false;
        return v0;
    }

    public String toString() {
        return this.name;
    }
}

