// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.util.Hashtable;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Integers;

public abstract class SRPTlsClient extends AbstractTlsClient {
    public static final Integer EXT_SRP;
    protected byte[] identity;
    protected byte[] password;

    static {
        SRPTlsClient.EXT_SRP = Integers.valueOf(12);
    }

    public SRPTlsClient(TlsCipherFactory arg2, byte[] arg3, byte[] arg4) {
        super(arg2);
        this.identity = Arrays.clone(arg3);
        this.password = Arrays.clone(arg4);
    }

    public SRPTlsClient(byte[] arg2, byte[] arg3) {
        super();
        this.identity = Arrays.clone(arg2);
        this.password = Arrays.clone(arg3);
    }

    protected TlsKeyExchange createSRPKeyExchange(int arg5) {
        return new TlsSRPKeyExchange(arg5, this.supportedSignatureAlgorithms, this.identity, this.password);
    }

    public TlsCipher getCipher() {
        int v3 = 2;
        switch(this.selectedCipherSuite) {
            case 49178: 
            case 49179: 
            case 49180: {
                goto label_7;
            }
            case 49181: 
            case 49182: 
            case 49183: {
                goto label_12;
            }
            case 49184: 
            case 49185: 
            case 49186: {
                goto label_17;
            }
        }

        throw new TlsFatalAlert(80);
    label_17:
        TlsCipher v0 = this.cipherFactory.createCipher(this.context, 9, v3);
        return v0;
    label_7:
        return this.cipherFactory.createCipher(this.context, 7, v3);
    label_12:
        return this.cipherFactory.createCipher(this.context, 8, v3);
    }

    public int[] getCipherSuites() {
        return new int[]{49185, 49182, 49179, 49184, 49181, 49178};
    }

    public Hashtable getClientExtensions() {
        Hashtable v0 = super.getClientExtensions();
        if(v0 == null) {
            v0 = new Hashtable();
        }

        ByteArrayOutputStream v1 = new ByteArrayOutputStream();
        TlsUtils.writeOpaque8(this.identity, ((OutputStream)v1));
        v0.put(SRPTlsClient.EXT_SRP, v1.toByteArray());
        return v0;
    }

    public TlsKeyExchange getKeyExchange() {
        switch(this.selectedCipherSuite) {
            case 49178: 
            case 49181: 
            case 49184: {
                goto label_6;
            }
            case 49179: 
            case 49182: 
            case 49185: {
                goto label_9;
            }
            case 49180: 
            case 49183: 
            case 49186: {
                goto label_12;
            }
        }

        throw new TlsFatalAlert(80);
    label_6:
        TlsKeyExchange v0 = this.createSRPKeyExchange(21);
        return v0;
    label_12:
        return this.createSRPKeyExchange(22);
    label_9:
        return this.createSRPKeyExchange(23);
    }

    public void processServerExtensions(Hashtable arg3) {
        if(arg3 != null) {
            Object v0 = arg3.get(SRPTlsClient.EXT_SRP);
            if(v0 != null && v0.length > 0) {
                throw new TlsFatalAlert(47);
            }
        }
    }
}

