// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.util.Arrays;

public class SSL3Mac implements Mac {
    private static final byte IPAD_BYTE = 54;
    private static final byte OPAD_BYTE = 92;
    private Digest digest;
    private int padLength;
    private byte[] secret;

    static {
        SSL3Mac.IPAD = SSL3Mac.genPad(54, 48);
        SSL3Mac.OPAD = SSL3Mac.genPad(92, 48);
    }

    public SSL3Mac(Digest arg3) {
        super();
        this.digest = arg3;
        this.padLength = arg3.getDigestSize() == 20 ? 40 : 48;
    }

    public int doFinal(byte[] arg6, int arg7) {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        this.digest.update(this.secret, 0, this.secret.length);
        this.digest.update(SSL3Mac.OPAD, 0, this.padLength);
        this.digest.update(v0, 0, v0.length);
        int v0_1 = this.digest.doFinal(arg6, arg7);
        this.reset();
        return v0_1;
    }

    private static byte[] genPad(byte arg1, int arg2) {
        byte[] v0 = new byte[arg2];
        Arrays.fill(v0, arg1);
        return v0;
    }

    public String getAlgorithmName() {
        return this.digest.getAlgorithmName() + "/SSL3MAC";
    }

    public int getMacSize() {
        return this.digest.getDigestSize();
    }

    public Digest getUnderlyingDigest() {
        return this.digest;
    }

    public void init(CipherParameters arg2) {
        this.secret = Arrays.clone(((KeyParameter)arg2).getKey());
        this.reset();
    }

    public void reset() {
        this.digest.reset();
        this.digest.update(this.secret, 0, this.secret.length);
        this.digest.update(SSL3Mac.IPAD, 0, this.padLength);
    }

    public void update(byte arg2) {
        this.digest.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }
}

