// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.Vector;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.generators.DHKeyPairGenerator;
import org.bouncycastle.crypto.io.SignerInputStream;
import org.bouncycastle.crypto.params.DHKeyGenerationParameters;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;

public class TlsDHEKeyExchange extends TlsDHKeyExchange {
    protected TlsSignerCredentials serverCredentials;

    public TlsDHEKeyExchange(int arg2, Vector arg3, DHParameters arg4) {
        super(arg2, arg3, arg4);
        this.serverCredentials = null;
    }

    public byte[] generateServerKeyExchange() {
        if(this.dhParameters == null) {
            throw new TlsFatalAlert(80);
        }

        ByteArrayOutputStream v1 = new ByteArrayOutputStream();
        DHKeyPairGenerator v0 = new DHKeyPairGenerator();
        v0.init(new DHKeyGenerationParameters(this.context.getSecureRandom(), this.dhParameters));
        BigInteger v0_1 = v0.generateKeyPair().getPublic().getY();
        TlsDHUtils.writeDHParameter(this.dhParameters.getP(), ((OutputStream)v1));
        TlsDHUtils.writeDHParameter(this.dhParameters.getG(), ((OutputStream)v1));
        TlsDHUtils.writeDHParameter(v0_1, ((OutputStream)v1));
        byte[] v0_2 = v1.toByteArray();
        CombinedHash v2 = new CombinedHash();
        SecurityParameters v3 = this.context.getSecurityParameters();
        ((Digest)v2).update(v3.clientRandom, 0, v3.clientRandom.length);
        ((Digest)v2).update(v3.serverRandom, 0, v3.serverRandom.length);
        ((Digest)v2).update(v0_2, 0, v0_2.length);
        v0_2 = new byte[((Digest)v2).getDigestSize()];
        ((Digest)v2).doFinal(v0_2, 0);
        TlsUtils.writeOpaque16(this.serverCredentials.generateCertificateSignature(v0_2), ((OutputStream)v1));
        return v1.toByteArray();
    }

    protected Signer initVerifyer(TlsSigner arg5, SecurityParameters arg6) {
        Signer v0 = arg5.createVerifyer(this.serverPublicKey);
        v0.update(arg6.clientRandom, 0, arg6.clientRandom.length);
        v0.update(arg6.serverRandom, 0, arg6.serverRandom.length);
        return v0;
    }

    public void processServerCredentials(TlsCredentials arg3) {
        if(!(arg3 instanceof TlsSignerCredentials)) {
            throw new TlsFatalAlert(80);
        }

        this.processServerCertificate(arg3.getCertificate());
        this.serverCredentials = ((TlsSignerCredentials)arg3);
    }

    public void processServerKeyExchange(InputStream arg6) {
        Signer v0 = this.initVerifyer(this.tlsSigner, this.context.getSecurityParameters());
        SignerInputStream v1 = new SignerInputStream(arg6, v0);
        BigInteger v2 = TlsDHUtils.readDHParameter(((InputStream)v1));
        BigInteger v3 = TlsDHUtils.readDHParameter(((InputStream)v1));
        BigInteger v1_1 = TlsDHUtils.readDHParameter(((InputStream)v1));
        if(!v0.verifySignature(TlsUtils.readOpaque16(arg6))) {
            throw new TlsFatalAlert(51);
        }

        this.dhAgreeServerPublicKey = this.validateDHPublicKey(new DHPublicKeyParameters(v1_1, new DHParameters(v2, v3)));
    }
}

