// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.OutputStream;
import java.math.BigInteger;
import java.util.Vector;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;
import org.bouncycastle.crypto.util.PublicKeyFactory;

public class TlsDHKeyExchange extends AbstractTlsKeyExchange {
    protected static final BigInteger ONE;
    protected static final BigInteger TWO;
    protected TlsAgreementCredentials agreementCredentials;
    protected DHPrivateKeyParameters dhAgreeClientPrivateKey;
    protected DHPublicKeyParameters dhAgreeClientPublicKey;
    protected DHPublicKeyParameters dhAgreeServerPublicKey;
    protected DHParameters dhParameters;
    protected AsymmetricKeyParameter serverPublicKey;
    protected TlsSigner tlsSigner;

    static {
        TlsDHKeyExchange.ONE = BigInteger.valueOf(1);
        TlsDHKeyExchange.TWO = BigInteger.valueOf(2);
    }

    public TlsDHKeyExchange(int arg3, Vector arg4, DHParameters arg5) {
        super(arg3, arg4);
        switch(arg3) {
            case 3: {
                goto label_14;
            }
            case 5: {
                goto label_10;
            }
            case 7: 
            case 9: {
                goto label_6;
            }
        }

        throw new IllegalArgumentException("unsupported key exchange algorithm");
    label_6:
        this.tlsSigner = null;
        goto label_8;
    label_10:
        this.tlsSigner = new TlsRSASigner();
        goto label_8;
    label_14:
        this.tlsSigner = new TlsDSSSigner();
    label_8:
        this.dhParameters = arg5;
    }

    protected boolean areCompatibleParameters(DHParameters arg3, DHParameters arg4) {
        boolean v0 = !arg3.getP().equals(arg4.getP()) || !arg3.getG().equals(arg4.getG()) ? false : true;
        return v0;
    }

    protected byte[] calculateDHBasicAgreement(DHPublicKeyParameters arg2, DHPrivateKeyParameters arg3) {
        return TlsDHUtils.calculateDHBasicAgreement(arg2, arg3);
    }

    public void generateClientKeyExchange(OutputStream arg3) {
        if(this.agreementCredentials == null) {
            this.dhAgreeClientPrivateKey = TlsDHUtils.generateEphemeralClientKeyExchange(this.context.getSecureRandom(), this.dhAgreeServerPublicKey.getParameters(), arg3);
        }
    }

    protected AsymmetricCipherKeyPair generateDHKeyPair(DHParameters arg2) {
        return TlsDHUtils.generateDHKeyPair(this.context.getSecureRandom(), arg2);
    }

    public byte[] generatePremasterSecret() {
        byte[] v0 = this.agreementCredentials != null ? this.agreementCredentials.generateAgreement(this.dhAgreeServerPublicKey) : this.calculateDHBasicAgreement(this.dhAgreeServerPublicKey, this.dhAgreeClientPrivateKey);
        return v0;
    }

    public void init(TlsContext arg2) {
        super.init(arg2);
        if(this.tlsSigner != null) {
            this.tlsSigner.init(arg2);
        }
    }

    public void processClientCredentials(TlsCredentials arg3) {
        if((arg3 instanceof TlsAgreementCredentials)) {
            this.agreementCredentials = ((TlsAgreementCredentials)arg3);
        }
        else if(!(arg3 instanceof TlsSignerCredentials)) {
            throw new TlsFatalAlert(80);
        }
    }

    public void processServerCertificate(Certificate arg5) {
        short v3 = 46;
        if(arg5.isEmpty()) {
            throw new TlsFatalAlert(42);
        }

        org.bouncycastle.asn1.x509.Certificate v1 = arg5.getCertificateAt(0);
        SubjectPublicKeyInfo v0 = v1.getSubjectPublicKeyInfo();
        try {
            this.serverPublicKey = PublicKeyFactory.createKey(v0);
        }
        catch(RuntimeException v0_1) {
            throw new TlsFatalAlert(43);
        }

        if(this.tlsSigner == null) {
            try {
                this.dhAgreeServerPublicKey = this.validateDHPublicKey(this.serverPublicKey);
            }
            catch(ClassCastException v0_2) {
                throw new TlsFatalAlert(v3);
            }

            TlsUtils.validateKeyUsage(v1, 8);
        }
        else if(!this.tlsSigner.isValidPublicKey(this.serverPublicKey)) {
            throw new TlsFatalAlert(v3);
        }
        else {
            TlsUtils.validateKeyUsage(v1, 128);
        }

        super.processServerCertificate(arg5);
    }

    public boolean requiresServerKeyExchange() {
        boolean v0;
        switch(this.keyExchange) {
            case 3: 
            case 5: 
            case 11: {
                v0 = true;
                break;
            }
            default: {
                v0 = false;
                break;
            }
        }

        return v0;
    }

    public void skipServerCredentials() {
        throw new TlsFatalAlert(10);
    }

    public void validateCertificateRequest(CertificateRequest arg4) {
        short[] v1 = arg4.getCertificateTypes();
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            switch(v1[v0]) {
                case 1: 
                case 2: 
                case 3: 
                case 4: 
                case 64: {
                    goto label_10;
                }
            }

            throw new TlsFatalAlert(47);
        label_10:
        }
    }

    protected DHPublicKeyParameters validateDHPublicKey(DHPublicKeyParameters arg2) {
        return TlsDHUtils.validateDHPublicKey(arg2);
    }
}

