// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;
import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.agreement.DHBasicAgreement;
import org.bouncycastle.crypto.generators.DHBasicKeyPairGenerator;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHKeyGenerationParameters;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;
import org.bouncycastle.util.BigIntegers;

public class TlsDHUtils {
    static final BigInteger ONE;
    static final BigInteger TWO;

    static {
        TlsDHUtils.ONE = BigInteger.valueOf(1);
        TlsDHUtils.TWO = BigInteger.valueOf(2);
    }

    public TlsDHUtils() {
        super();
    }

    public static byte[] calculateDHBasicAgreement(DHPublicKeyParameters arg1, DHPrivateKeyParameters arg2) {
        DHBasicAgreement v0 = new DHBasicAgreement();
        v0.init(((CipherParameters)arg2));
        return BigIntegers.asUnsignedByteArray(v0.calculateAgreement(((CipherParameters)arg1)));
    }

    public static AsymmetricCipherKeyPair generateDHKeyPair(SecureRandom arg2, DHParameters arg3) {
        DHBasicKeyPairGenerator v0 = new DHBasicKeyPairGenerator();
        v0.init(new DHKeyGenerationParameters(arg2, arg3));
        return v0.generateKeyPair();
    }

    public static DHPrivateKeyParameters generateEphemeralClientKeyExchange(SecureRandom arg2, DHParameters arg3, OutputStream arg4) {
        AsymmetricCipherKeyPair v1 = TlsDHUtils.generateDHKeyPair(arg2, arg3);
        AsymmetricKeyParameter v0 = v1.getPrivate();
        TlsUtils.writeOpaque16(BigIntegers.asUnsignedByteArray(v1.getPublic().getY()), arg4);
        return ((DHPrivateKeyParameters)v0);
    }

    public static BigInteger readDHParameter(InputStream arg3) {
        return new BigInteger(1, TlsUtils.readOpaque16(arg3));
    }

    public static DHPublicKeyParameters validateDHPublicKey(DHPublicKeyParameters arg5) {
        short v4 = 47;
        BigInteger v0 = arg5.getY();
        DHParameters v1 = arg5.getParameters();
        BigInteger v2 = v1.getP();
        BigInteger v1_1 = v1.getG();
        if(!v2.isProbablePrime(2)) {
            throw new TlsFatalAlert(v4);
        }

        if(v1_1.compareTo(TlsDHUtils.TWO) >= 0 && v1_1.compareTo(v2.subtract(TlsDHUtils.TWO)) <= 0) {
            if(v0.compareTo(TlsDHUtils.TWO) >= 0 && v0.compareTo(v2.subtract(TlsDHUtils.ONE)) <= 0) {
                return arg5;
            }

            throw new TlsFatalAlert(v4);
        }

        throw new TlsFatalAlert(v4);
    }

    public static void writeDHParameter(BigInteger arg1, OutputStream arg2) {
        TlsUtils.writeOpaque16(BigIntegers.asUnsignedByteArray(arg1), arg2);
    }
}

