// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.digests.NullDigest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.signers.DSADigestSigner;

public abstract class TlsDSASigner extends AbstractTlsSigner {
    public TlsDSASigner() {
        super();
    }

    protected abstract DSA createDSAImpl();

    public Signer createSigner(AsymmetricKeyParameter arg5) {
        return this.makeSigner(new SHA1Digest(), true, new ParametersWithRandom(((CipherParameters)arg5), this.context.getSecureRandom()));
    }

    public Signer createVerifyer(AsymmetricKeyParameter arg3) {
        return this.makeSigner(new SHA1Digest(), false, ((CipherParameters)arg3));
    }

    public byte[] generateRawSignature(AsymmetricKeyParameter arg5, byte[] arg6) {
        Signer v0 = this.makeSigner(new NullDigest(), true, new ParametersWithRandom(((CipherParameters)arg5), this.context.getSecureRandom()));
        v0.update(arg6, 16, 20);
        return v0.generateSignature();
    }

    protected Signer makeSigner(Digest arg3, boolean arg4, CipherParameters arg5) {
        DSADigestSigner v0 = new DSADigestSigner(this.createDSAImpl(), arg3);
        ((Signer)v0).init(arg4, arg5);
        return ((Signer)v0);
    }

    public boolean verifyRawSignature(byte[] arg4, AsymmetricKeyParameter arg5, byte[] arg6) {
        Signer v0 = this.makeSigner(new NullDigest(), false, ((CipherParameters)arg5));
        v0.update(arg6, 16, 20);
        return v0.verifySignature(arg4);
    }
}

