// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.io.SignerInputStream;
import org.bouncycastle.crypto.params.ECDomainParameters;

public class TlsECDHEKeyExchange extends TlsECDHKeyExchange {
    protected TlsSignerCredentials serverCredentials;

    public TlsECDHEKeyExchange(int arg2, Vector arg3, int[] arg4, short[] arg5, short[] arg6) {
        super(arg2, arg3, arg4, arg5, arg6);
        this.serverCredentials = null;
    }

    public byte[] generateServerKeyExchange() {
        ECDomainParameters v2_1;
        int v3;
        int v2 = 23;
        int v4 = -1;
        if(this.namedCurves == null) {
            v3 = v2;
        }
        else {
            int v0 = 0;
            while(true) {
                if(v0 < this.namedCurves.length) {
                    v3 = this.namedCurves[v0];
                    if(!TlsECCUtils.isSupportedNamedCurve(v3)) {
                        ++v0;
                        continue;
                    }
                }
                else {
                    break;
                }

                goto label_6;
            }

            v3 = v4;
        }

    label_6:
        ECDomainParameters v0_1 = null;
        if(v3 >= 0) {
            v2_1 = TlsECCUtils.getParametersForNamedCurve(v3);
        }
        else if(TlsProtocol.arrayContains(this.namedCurves, 65281)) {
            v2_1 = TlsECCUtils.getParametersForNamedCurve(v2);
        }
        else if(TlsProtocol.arrayContains(this.namedCurves, 65282)) {
            v2_1 = TlsECCUtils.getParametersForNamedCurve(7);
        }
        else {
            v2_1 = v0_1;
        }

        if(v2_1 == null) {
            throw new TlsFatalAlert(80);
        }

        AsymmetricCipherKeyPair v4_1 = TlsECCUtils.generateECKeyPair(this.context.getSecureRandom(), v2_1);
        this.ecAgreeServerPrivateKey = v4_1.getPrivate();
        byte[] v0_2 = TlsECCUtils.serializeECPublicKey(this.clientECPointFormats, v4_1.getPublic());
        ByteArrayOutputStream v4_2 = new ByteArrayOutputStream();
        if(v3 < 0) {
            TlsECCUtils.writeExplicitECParameters(this.clientECPointFormats, v2_1, ((OutputStream)v4_2));
        }
        else {
            TlsECCUtils.writeNamedECParameters(v3, ((OutputStream)v4_2));
        }

        TlsUtils.writeOpaque8(v0_2, ((OutputStream)v4_2));
        v0_2 = v4_2.toByteArray();
        CombinedHash v2_2 = new CombinedHash();
        SecurityParameters v3_1 = this.context.getSecurityParameters();
        ((Digest)v2_2).update(v3_1.clientRandom, 0, v3_1.clientRandom.length);
        ((Digest)v2_2).update(v3_1.serverRandom, 0, v3_1.serverRandom.length);
        ((Digest)v2_2).update(v0_2, 0, v0_2.length);
        v0_2 = new byte[((Digest)v2_2).getDigestSize()];
        ((Digest)v2_2).doFinal(v0_2, 0);
        TlsUtils.writeOpaque16(this.serverCredentials.generateCertificateSignature(v0_2), ((OutputStream)v4_2));
        return v4_2.toByteArray();
    }

    protected Signer initVerifyer(TlsSigner arg5, SecurityParameters arg6) {
        Signer v0 = arg5.createVerifyer(this.serverPublicKey);
        v0.update(arg6.clientRandom, 0, arg6.clientRandom.length);
        v0.update(arg6.serverRandom, 0, arg6.serverRandom.length);
        return v0;
    }

    public void processClientCredentials(TlsCredentials arg3) {
        if((arg3 instanceof TlsSignerCredentials)) {
            return;
        }

        throw new TlsFatalAlert(80);
    }

    public void processServerCredentials(TlsCredentials arg3) {
        if(!(arg3 instanceof TlsSignerCredentials)) {
            throw new TlsFatalAlert(80);
        }

        this.processServerCertificate(arg3.getCertificate());
        this.serverCredentials = ((TlsSignerCredentials)arg3);
    }

    public void processServerKeyExchange(InputStream arg5) {
        Signer v0 = this.initVerifyer(this.tlsSigner, this.context.getSecurityParameters());
        SignerInputStream v1 = new SignerInputStream(arg5, v0);
        ECDomainParameters v2 = TlsECCUtils.readECParameters(this.namedCurves, this.clientECPointFormats, ((InputStream)v1));
        byte[] v1_1 = TlsUtils.readOpaque8(((InputStream)v1));
        if(!v0.verifySignature(TlsUtils.readOpaque16(arg5))) {
            throw new TlsFatalAlert(51);
        }

        this.ecAgreeServerPublicKey = TlsECCUtils.validateECPublicKey(TlsECCUtils.deserializeECPublicKey(this.clientECPointFormats, v2, v1_1));
    }

    public void validateCertificateRequest(CertificateRequest arg4) {
        short[] v1 = arg4.getCertificateTypes();
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            switch(v1[v0]) {
                case 1: 
                case 2: 
                case 64: {
                    goto label_10;
                }
            }

            throw new TlsFatalAlert(47);
        label_10:
        }
    }
}

