// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.util.PublicKeyFactory;

public class TlsECDHKeyExchange extends AbstractTlsKeyExchange {
    protected TlsAgreementCredentials agreementCredentials;
    protected short[] clientECPointFormats;
    protected ECPrivateKeyParameters ecAgreeClientPrivateKey;
    protected ECPublicKeyParameters ecAgreeClientPublicKey;
    protected ECPrivateKeyParameters ecAgreeServerPrivateKey;
    protected ECPublicKeyParameters ecAgreeServerPublicKey;
    protected int[] namedCurves;
    protected short[] serverECPointFormats;
    protected AsymmetricKeyParameter serverPublicKey;
    protected TlsSigner tlsSigner;

    public TlsECDHKeyExchange(int arg3, Vector arg4, int[] arg5, short[] arg6, short[] arg7) {
        super(arg3, arg4);
        switch(arg3) {
            case 17: {
                goto label_14;
            }
            case 16: 
            case 18: {
                goto label_18;
            }
            case 19: {
                goto label_6;
            }
        }

        throw new IllegalArgumentException("unsupported key exchange algorithm");
    label_18:
        this.tlsSigner = null;
        goto label_9;
    label_6:
        this.tlsSigner = new TlsRSASigner();
        goto label_9;
    label_14:
        this.tlsSigner = new TlsECDSASigner();
    label_9:
        this.keyExchange = arg3;
        this.namedCurves = arg5;
        this.clientECPointFormats = arg6;
        this.serverECPointFormats = arg7;
    }

    public void generateClientKeyExchange(OutputStream arg4) {
        if(this.agreementCredentials == null) {
            AsymmetricCipherKeyPair v1 = TlsECCUtils.generateECKeyPair(this.context.getSecureRandom(), this.ecAgreeServerPublicKey.getParameters());
            this.ecAgreeClientPrivateKey = v1.getPrivate();
            TlsUtils.writeOpaque8(TlsECCUtils.serializeECPublicKey(this.serverECPointFormats, v1.getPublic()), arg4);
        }
    }

    public byte[] generatePremasterSecret() {
        byte[] v0;
        if(this.agreementCredentials != null) {
            v0 = this.agreementCredentials.generateAgreement(this.ecAgreeServerPublicKey);
        }
        else if(this.ecAgreeServerPrivateKey != null) {
            v0 = TlsECCUtils.calculateECDHBasicAgreement(this.ecAgreeClientPublicKey, this.ecAgreeServerPrivateKey);
        }
        else if(this.ecAgreeClientPrivateKey != null) {
            v0 = TlsECCUtils.calculateECDHBasicAgreement(this.ecAgreeServerPublicKey, this.ecAgreeClientPrivateKey);
        }
        else {
            goto label_18;
        }

        return v0;
    label_18:
        throw new TlsFatalAlert(80);
    }

    public void init(TlsContext arg2) {
        super.init(arg2);
        if(this.tlsSigner != null) {
            this.tlsSigner.init(arg2);
        }
    }

    public void processClientCertificate(Certificate arg1) {
    }

    public void processClientCredentials(TlsCredentials arg3) {
        if((arg3 instanceof TlsAgreementCredentials)) {
            this.agreementCredentials = ((TlsAgreementCredentials)arg3);
        }
        else if(!(arg3 instanceof TlsSignerCredentials)) {
            throw new TlsFatalAlert(80);
        }
    }

    public void processClientKeyExchange(InputStream arg4) {
        if(this.ecAgreeClientPublicKey == null) {
            this.ecAgreeClientPublicKey = TlsECCUtils.validateECPublicKey(TlsECCUtils.deserializeECPublicKey(this.serverECPointFormats, this.ecAgreeServerPrivateKey.getParameters(), TlsUtils.readOpaque8(arg4)));
        }
    }

    public void processServerCertificate(Certificate arg5) {
        short v3 = 46;
        if(arg5.isEmpty()) {
            throw new TlsFatalAlert(42);
        }

        org.bouncycastle.asn1.x509.Certificate v1 = arg5.getCertificateAt(0);
        SubjectPublicKeyInfo v0 = v1.getSubjectPublicKeyInfo();
        try {
            this.serverPublicKey = PublicKeyFactory.createKey(v0);
        }
        catch(RuntimeException v0_1) {
            throw new TlsFatalAlert(43);
        }

        if(this.tlsSigner == null) {
            try {
                this.ecAgreeServerPublicKey = TlsECCUtils.validateECPublicKey(this.serverPublicKey);
            }
            catch(ClassCastException v0_2) {
                throw new TlsFatalAlert(v3);
            }

            TlsUtils.validateKeyUsage(v1, 8);
        }
        else if(!this.tlsSigner.isValidPublicKey(this.serverPublicKey)) {
            throw new TlsFatalAlert(v3);
        }
        else {
            TlsUtils.validateKeyUsage(v1, 128);
        }

        super.processServerCertificate(arg5);
    }

    public boolean requiresServerKeyExchange() {
        boolean v0;
        switch(this.keyExchange) {
            case 17: 
            case 19: 
            case 20: {
                v0 = true;
                break;
            }
            default: {
                v0 = false;
                break;
            }
        }

        return v0;
    }

    public void skipServerCredentials() {
        throw new TlsFatalAlert(10);
    }

    public void validateCertificateRequest(CertificateRequest arg4) {
        short[] v1 = arg4.getCertificateTypes();
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            switch(v1[v0]) {
                case 1: 
                case 2: 
                case 64: 
                case 65: 
                case 66: {
                    goto label_10;
                }
            }

            throw new TlsFatalAlert(47);
        label_10:
        }
    }
}

