// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.digests.LongDigest;
import org.bouncycastle.crypto.macs.HMac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.util.Arrays;

public class TlsMac {
    protected TlsContext context;
    protected int digestBlockSize;
    protected int digestOverhead;
    protected Mac mac;
    protected byte[] secret;

    public TlsMac(TlsContext arg4, Digest arg5, byte[] arg6, int arg7, int arg8) {
        super();
        this.context = arg4;
        KeyParameter v0 = new KeyParameter(arg6, arg7, arg8);
        this.secret = Arrays.clone(v0.getKey());
        if((arg5 instanceof LongDigest)) {
            this.digestBlockSize = 128;
            this.digestOverhead = 16;
        }
        else {
            this.digestBlockSize = 64;
            this.digestOverhead = 8;
        }

        if(arg4.getServerVersion().isSSL()) {
            this.mac = new SSL3Mac(arg5);
            if(arg5.getDigestSize() == 20) {
                this.digestOverhead = 4;
            }
        }
        else {
            this.mac = new HMac(arg5);
        }

        this.mac.init(((CipherParameters)v0));
    }

    public byte[] calculateMac(long arg6, short arg8, byte[] arg9, int arg10, int arg11) {
        ProtocolVersion v1 = this.context.getServerVersion();
        boolean v2 = v1.isSSL();
        int v0 = v2 ? 11 : 13;
        ByteArrayOutputStream v3 = new ByteArrayOutputStream(v0);
        try {
            TlsUtils.writeUint64(arg6, ((OutputStream)v3));
            TlsUtils.writeUint8(arg8, ((OutputStream)v3));
            if(!v2) {
                TlsUtils.writeVersion(v1, ((OutputStream)v3));
            }

            TlsUtils.writeUint16(arg11, ((OutputStream)v3));
        }
        catch(IOException v0_1) {
            throw new IllegalStateException("Internal error during mac calculation");
        }

        byte[] v0_2 = v3.toByteArray();
        this.mac.update(v0_2, 0, v0_2.length);
        this.mac.update(arg9, arg10, arg11);
        v0_2 = new byte[this.mac.getMacSize()];
        this.mac.doFinal(v0_2, 0);
        return v0_2;
    }

    public byte[] calculateMacConstantTime(long arg6, short arg8, byte[] arg9, int arg10, int arg11, int arg12, byte[] arg13) {
        byte[] v1 = this.calculateMac(arg6, arg8, arg9, arg10, arg11);
        int v0 = this.context.getServerVersion().isSSL() ? 11 : 13;
        v0 = this.getDigestBlockCount(v0 + arg12) - this.getDigestBlockCount(v0 + arg11);
        while(true) {
            --v0;
            if(v0 < 0) {
                break;
            }

            this.mac.update(arg13, 0, this.digestBlockSize);
        }

        this.mac.update(arg13[0]);
        this.mac.reset();
        return v1;
    }

    private int getDigestBlockCount(int arg3) {
        return (this.digestOverhead + arg3) / this.digestBlockSize;
    }

    public byte[] getMACSecret() {
        return this.secret;
    }

    public int getSize() {
        return this.mac.getMacSize();
    }
}

