// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.Digest;
import org.bouncycastle.util.Arrays;

public class TlsNullCipher implements TlsCipher {
    protected TlsContext context;
    protected TlsMac readMac;
    protected TlsMac writeMac;

    public TlsNullCipher(TlsContext arg2) {
        super();
        this.context = arg2;
        this.writeMac = null;
        this.readMac = null;
    }

    public TlsNullCipher(TlsContext arg13, Digest arg14, Digest arg15) {
        TlsMac v4;
        TlsMac v0 = null;
        short v11 = 80;
        int v1 = 1;
        super();
        int v2 = arg14 == null ? 1 : 0;
        if(arg15 != null) {
            v1 = 0;
        }

        if(v2 != v1) {
            throw new TlsFatalAlert(v11);
        }

        this.context = arg13;
        if(arg14 != null) {
            int v10 = arg14.getDigestSize() + arg15.getDigestSize();
            byte[] v3 = TlsUtils.calculateKeyBlock(arg13, v10);
            v0 = new TlsMac(arg13, arg14, v3, 0, arg14.getDigestSize());
            int v8 = arg14.getDigestSize();
            v4 = new TlsMac(arg13, arg15, v3, v8, arg15.getDigestSize());
            if(arg15.getDigestSize() + v8 != v10) {
                throw new TlsFatalAlert(v11);
            }
        }
        else {
            v4 = v0;
        }

        if(arg13.isServer()) {
            this.writeMac = v4;
            this.readMac = v0;
        }
        else {
            this.writeMac = v0;
            this.readMac = v4;
        }
    }

    public byte[] decodeCiphertext(long arg9, short arg11, byte[] arg12, int arg13, int arg14) {
        byte[] v0;
        if(this.readMac == null) {
            v0 = Arrays.copyOfRange(arg12, arg13, arg13 + arg14);
        }
        else {
            int v0_1 = this.readMac.getSize();
            if(arg14 < v0_1) {
                throw new TlsFatalAlert(50);
            }
            else {
                int v6 = arg14 - v0_1;
                if(!Arrays.constantTimeAreEqual(Arrays.copyOfRange(arg12, arg13 + v6, arg13 + arg14), this.readMac.calculateMac(arg9, arg11, arg12, arg13, v6))) {
                    throw new TlsFatalAlert(20);
                }
                else {
                    v0 = Arrays.copyOfRange(arg12, arg13, arg13 + v6);
                }
            }
        }

        return v0;
    }

    public byte[] encodePlaintext(long arg9, short arg11, byte[] arg12, int arg13, int arg14) {
        byte[] v0;
        if(this.writeMac == null) {
            v0 = Arrays.copyOfRange(arg12, arg13, arg13 + arg14);
        }
        else {
            byte[] v1 = this.writeMac.calculateMac(arg9, arg11, arg12, arg13, arg14);
            v0 = new byte[v1.length + arg14];
            System.arraycopy(arg12, arg13, v0, 0, arg14);
            System.arraycopy(v1, 0, v0, arg14, v1.length);
        }

        return v0;
    }

    public int getPlaintextLimit(int arg2) {
        if(this.writeMac != null) {
            arg2 -= this.writeMac.getSize();
        }

        return arg2;
    }
}

