// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.Vector;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.util.PublicKeyFactory;

public class TlsPSKKeyExchange extends AbstractTlsKeyExchange {
    protected DHPrivateKeyParameters dhAgreeClientPrivateKey;
    protected DHPublicKeyParameters dhAgreeServerPublicKey;
    protected byte[] premasterSecret;
    protected TlsPSKIdentity pskIdentity;
    protected byte[] psk_identity_hint;
    protected RSAKeyParameters rsaServerPublicKey;
    protected AsymmetricKeyParameter serverPublicKey;

    public TlsPSKKeyExchange(int arg3, Vector arg4, TlsPSKIdentity arg5) {
        super(arg3, arg4);
        this.psk_identity_hint = null;
        this.dhAgreeServerPublicKey = null;
        this.dhAgreeClientPrivateKey = null;
        this.serverPublicKey = null;
        this.rsaServerPublicKey = null;
        switch(arg3) {
            case 13: 
            case 14: 
            case 15: {
                goto label_12;
            }
        }

        throw new IllegalArgumentException("unsupported key exchange algorithm");
    label_12:
        this.pskIdentity = arg5;
    }

    public void generateClientKeyExchange(OutputStream arg3) {
        if(this.psk_identity_hint == null) {
            this.pskIdentity.skipIdentityHint();
        }
        else {
            this.pskIdentity.notifyIdentityHint(this.psk_identity_hint);
        }

        TlsUtils.writeOpaque16(this.pskIdentity.getPSKIdentity(), arg3);
        if(this.keyExchange == 15) {
            this.premasterSecret = TlsRSAUtils.generateEncryptedPreMasterSecret(this.context, this.rsaServerPublicKey, arg3);
        }
        else if(this.keyExchange == 14) {
            this.dhAgreeClientPrivateKey = TlsDHUtils.generateEphemeralClientKeyExchange(this.context.getSecureRandom(), this.dhAgreeServerPublicKey.getParameters(), arg3);
        }
    }

    protected byte[] generateOtherSecret(int arg3) {
        byte[] v0;
        if(this.keyExchange == 14) {
            v0 = TlsDHUtils.calculateDHBasicAgreement(this.dhAgreeServerPublicKey, this.dhAgreeClientPrivateKey);
        }
        else if(this.keyExchange == 15) {
            v0 = this.premasterSecret;
        }
        else {
            v0 = new byte[arg3];
        }

        return v0;
    }

    public byte[] generatePremasterSecret() {
        byte[] v0 = this.pskIdentity.getPSK();
        byte[] v1 = this.generateOtherSecret(v0.length);
        ByteArrayOutputStream v2 = new ByteArrayOutputStream(v1.length + 4 + v0.length);
        TlsUtils.writeOpaque16(v1, ((OutputStream)v2));
        TlsUtils.writeOpaque16(v0, ((OutputStream)v2));
        return v2.toByteArray();
    }

    public void processClientCredentials(TlsCredentials arg3) {
        throw new TlsFatalAlert(80);
    }

    public void processServerCertificate(Certificate arg3) {
        if(this.keyExchange != 15) {
            throw new TlsFatalAlert(10);
        }

        if(arg3.isEmpty()) {
            throw new TlsFatalAlert(42);
        }

        org.bouncycastle.asn1.x509.Certificate v1 = arg3.getCertificateAt(0);
        SubjectPublicKeyInfo v0 = v1.getSubjectPublicKeyInfo();
        try {
            this.serverPublicKey = PublicKeyFactory.createKey(v0);
        }
        catch(RuntimeException v0_1) {
            throw new TlsFatalAlert(43);
        }

        if(this.serverPublicKey.isPrivate()) {
            throw new TlsFatalAlert(80);
        }

        this.rsaServerPublicKey = this.validateRSAPublicKey(this.serverPublicKey);
        TlsUtils.validateKeyUsage(v1, 32);
        super.processServerCertificate(arg3);
    }

    public void processServerKeyExchange(InputStream arg6) {
        this.psk_identity_hint = TlsUtils.readOpaque16(arg6);
        if(this.keyExchange == 14) {
            this.dhAgreeServerPublicKey = TlsDHUtils.validateDHPublicKey(new DHPublicKeyParameters(new BigInteger(1, TlsUtils.readOpaque16(arg6)), new DHParameters(new BigInteger(1, TlsUtils.readOpaque16(arg6)), new BigInteger(1, TlsUtils.readOpaque16(arg6)))));
        }
    }

    public boolean requiresServerKeyExchange() {
        boolean v0 = this.keyExchange == 14 ? true : false;
        return v0;
    }

    public void skipServerCredentials() {
        if(this.keyExchange == 15) {
            throw new TlsFatalAlert(10);
        }
    }

    public void validateCertificateRequest(CertificateRequest arg3) {
        throw new TlsFatalAlert(10);
    }

    protected RSAKeyParameters validateRSAPublicKey(RSAKeyParameters arg3) {
        if(!arg3.getExponent().isProbablePrime(2)) {
            throw new TlsFatalAlert(47);
        }

        return arg3;
    }
}

