// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.util.PublicKeyFactory;
import org.bouncycastle.util.io.Streams;

public class TlsRSAKeyExchange extends AbstractTlsKeyExchange {
    protected byte[] premasterSecret;
    protected RSAKeyParameters rsaServerPublicKey;
    protected TlsEncryptionCredentials serverCredentials;
    protected AsymmetricKeyParameter serverPublicKey;

    public TlsRSAKeyExchange(Vector arg3) {
        super(1, arg3);
        this.serverPublicKey = null;
        this.rsaServerPublicKey = null;
        this.serverCredentials = null;
    }

    public void generateClientKeyExchange(OutputStream arg3) {
        this.premasterSecret = TlsRSAUtils.generateEncryptedPreMasterSecret(this.context, this.rsaServerPublicKey, arg3);
    }

    public byte[] generatePremasterSecret() {
        if(this.premasterSecret == null) {
            throw new TlsFatalAlert(80);
        }

        byte[] v0 = this.premasterSecret;
        this.premasterSecret = null;
        return v0;
    }

    public void processClientCredentials(TlsCredentials arg3) {
        if(!(arg3 instanceof TlsSignerCredentials)) {
            throw new TlsFatalAlert(80);
        }
    }

    public void processClientKeyExchange(InputStream arg8) {
        int v6 = 48;
        byte[] v0 = this.context.getServerVersion().isSSL() ? Streams.readAll(arg8) : TlsUtils.readOpaque16(arg8);
        ProtocolVersion v2 = this.context.getClientVersion();
        byte[] v3 = new byte[v6];
        this.context.getSecureRandom().nextBytes(v3);
        byte[] v1 = TlsUtils.EMPTY_BYTES;
        try {
            v0 = this.serverCredentials.decryptPreMasterSecret(v0);
        }
        catch(Exception v0_1) {
            v0 = v1;
        }

        if(v0.length != v6) {
            TlsUtils.writeVersion(v2, v3, 0);
            this.premasterSecret = v3;
        }
        else {
            TlsUtils.writeVersion(v2, v0, 0);
            this.premasterSecret = v0;
        }
    }

    public void processServerCertificate(Certificate arg3) {
        if(arg3.isEmpty()) {
            throw new TlsFatalAlert(42);
        }

        org.bouncycastle.asn1.x509.Certificate v1 = arg3.getCertificateAt(0);
        SubjectPublicKeyInfo v0 = v1.getSubjectPublicKeyInfo();
        try {
            this.serverPublicKey = PublicKeyFactory.createKey(v0);
        }
        catch(RuntimeException v0_1) {
            throw new TlsFatalAlert(43);
        }

        if(this.serverPublicKey.isPrivate()) {
            throw new TlsFatalAlert(80);
        }

        this.rsaServerPublicKey = this.validateRSAPublicKey(this.serverPublicKey);
        TlsUtils.validateKeyUsage(v1, 32);
        super.processServerCertificate(arg3);
    }

    public void processServerCredentials(TlsCredentials arg3) {
        if(!(arg3 instanceof TlsEncryptionCredentials)) {
            throw new TlsFatalAlert(80);
        }

        this.processServerCertificate(arg3.getCertificate());
        this.serverCredentials = ((TlsEncryptionCredentials)arg3);
    }

    public void skipServerCredentials() {
        throw new TlsFatalAlert(10);
    }

    public void validateCertificateRequest(CertificateRequest arg4) {
        short[] v1 = arg4.getCertificateTypes();
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            switch(v1[v0]) {
                case 1: 
                case 2: 
                case 64: {
                    goto label_10;
                }
            }

            throw new TlsFatalAlert(47);
        label_10:
        }
    }

    protected RSAKeyParameters validateRSAPublicKey(RSAKeyParameters arg3) {
        if(!arg3.getExponent().isProbablePrime(2)) {
            throw new TlsFatalAlert(47);
        }

        return arg3;
    }
}

