// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.encodings.PKCS1Encoding;
import org.bouncycastle.crypto.engines.RSABlindedEngine;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.signers.GenericSigner;
import org.bouncycastle.crypto.signers.RSADigestSigner;
import org.bouncycastle.util.Arrays;

public class TlsRSASigner extends AbstractTlsSigner {
    public TlsRSASigner() {
        super();
    }

    protected AsymmetricBlockCipher createRSAImpl() {
        return new PKCS1Encoding(new RSABlindedEngine());
    }

    public Signer createSigner(AsymmetricKeyParameter arg5) {
        return this.makeSigner(new CombinedHash(), true, new ParametersWithRandom(((CipherParameters)arg5), this.context.getSecureRandom()));
    }

    public Signer createVerifyer(AsymmetricKeyParameter arg3) {
        return this.makeSigner(new CombinedHash(), false, ((CipherParameters)arg3));
    }

    public byte[] generateRawSignature(AsymmetricKeyParameter arg5, byte[] arg6) {
        AsymmetricBlockCipher v0 = this.createRSAImpl();
        v0.init(true, new ParametersWithRandom(((CipherParameters)arg5), this.context.getSecureRandom()));
        return v0.processBlock(arg6, 0, arg6.length);
    }

    public boolean isValidPublicKey(AsymmetricKeyParameter arg2) {
        boolean v0 = !(arg2 instanceof RSAKeyParameters) || (arg2.isPrivate()) ? false : true;
        return v0;
    }

    protected Signer makeSigner(Digest arg3, boolean arg4, CipherParameters arg5) {
        GenericSigner v0_1;
        if(ProtocolVersion.TLSv12.isEqualOrEarlierVersionOf(this.context.getServerVersion().getEquivalentTLSVersion())) {
            RSADigestSigner v0 = new RSADigestSigner(arg3);
        }
        else {
            v0_1 = new GenericSigner(this.createRSAImpl(), arg3);
        }

        ((Signer)v0_1).init(arg4, arg5);
        return ((Signer)v0_1);
    }

    public boolean verifyRawSignature(byte[] arg4, AsymmetricKeyParameter arg5, byte[] arg6) {
        AsymmetricBlockCipher v0 = this.createRSAImpl();
        v0.init(false, ((CipherParameters)arg5));
        return Arrays.constantTimeAreEqual(v0.processBlock(arg4, 0, arg4.length), arg6);
    }
}

