// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.Vector;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.CryptoException;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.agreement.srp.SRP6Client;
import org.bouncycastle.crypto.agreement.srp.SRP6Util;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.io.SignerInputStream;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.util.PublicKeyFactory;
import org.bouncycastle.util.BigIntegers;

public class TlsSRPKeyExchange extends AbstractTlsKeyExchange {
    protected BigInteger B;
    protected byte[] identity;
    protected byte[] password;
    protected byte[] s;
    protected AsymmetricKeyParameter serverPublicKey;
    protected SRP6Client srpClient;
    protected TlsSigner tlsSigner;

    public TlsSRPKeyExchange(int arg3, Vector arg4, byte[] arg5, byte[] arg6) {
        AsymmetricKeyParameter v1 = null;
        super(arg3, arg4);
        this.serverPublicKey = v1;
        this.s = ((byte[])v1);
        this.B = ((BigInteger)v1);
        this.srpClient = new SRP6Client();
        switch(arg3) {
            case 21: {
                goto label_13;
            }
            case 22: {
                goto label_22;
            }
            case 23: {
                goto label_18;
            }
        }

        throw new IllegalArgumentException("unsupported key exchange algorithm");
    label_18:
        this.tlsSigner = new TlsRSASigner();
        goto label_14;
    label_22:
        this.tlsSigner = new TlsDSSSigner();
        goto label_14;
    label_13:
        this.tlsSigner = ((TlsSigner)v1);
    label_14:
        this.keyExchange = arg3;
        this.identity = arg5;
        this.password = arg6;
    }

    public void generateClientKeyExchange(OutputStream arg5) {
        TlsUtils.writeOpaque16(BigIntegers.asUnsignedByteArray(this.srpClient.generateClientCredentials(this.s, this.identity, this.password)), arg5);
    }

    public byte[] generatePremasterSecret() {
        try {
            return BigIntegers.asUnsignedByteArray(this.srpClient.calculateSecret(this.B));
        }
        catch(CryptoException v0) {
            throw new TlsFatalAlert(47);
        }
    }

    public void init(TlsContext arg2) {
        super.init(arg2);
        if(this.tlsSigner != null) {
            this.tlsSigner.init(arg2);
        }
    }

    protected Signer initVerifyer(TlsSigner arg5, SecurityParameters arg6) {
        Signer v0 = arg5.createVerifyer(this.serverPublicKey);
        v0.update(arg6.clientRandom, 0, arg6.clientRandom.length);
        v0.update(arg6.serverRandom, 0, arg6.serverRandom.length);
        return v0;
    }

    public void processClientCredentials(TlsCredentials arg3) {
        throw new TlsFatalAlert(80);
    }

    public void processServerCertificate(Certificate arg4) {
        if(this.tlsSigner == null) {
            throw new TlsFatalAlert(10);
        }

        if(arg4.isEmpty()) {
            throw new TlsFatalAlert(42);
        }

        org.bouncycastle.asn1.x509.Certificate v0 = arg4.getCertificateAt(0);
        SubjectPublicKeyInfo v1 = v0.getSubjectPublicKeyInfo();
        try {
            this.serverPublicKey = PublicKeyFactory.createKey(v1);
        }
        catch(RuntimeException v0_1) {
            throw new TlsFatalAlert(43);
        }

        if(!this.tlsSigner.isValidPublicKey(this.serverPublicKey)) {
            throw new TlsFatalAlert(46);
        }

        TlsUtils.validateKeyUsage(v0, 128);
        super.processServerCertificate(arg4);
    }

    public void processServerKeyExchange(InputStream arg8) {
        InputStream v1_2;
        SecurityParameters v1 = this.context.getSecurityParameters();
        Signer v0 = null;
        if(this.tlsSigner != null) {
            v0 = this.initVerifyer(this.tlsSigner, v1);
            SignerInputStream v1_1 = new SignerInputStream(arg8, v0);
        }
        else {
            v1_2 = arg8;
        }

        byte[] v2 = TlsUtils.readOpaque16(v1_2);
        byte[] v3 = TlsUtils.readOpaque16(v1_2);
        byte[] v4 = TlsUtils.readOpaque8(v1_2);
        byte[] v1_3 = TlsUtils.readOpaque16(v1_2);
        if(v0 != null && !v0.verifySignature(TlsUtils.readOpaque16(arg8))) {
            throw new TlsFatalAlert(51);
        }

        BigInteger v0_1 = new BigInteger(1, v2);
        BigInteger v2_1 = new BigInteger(1, v3);
        this.s = v4;
        try {
            this.B = SRP6Util.validatePublicValue(v0_1, new BigInteger(1, v1_3));
        }
        catch(CryptoException v0_2) {
            throw new TlsFatalAlert(47);
        }

        this.srpClient.init(v0_1, v2_1, new SHA1Digest(), this.context.getSecureRandom());
    }

    public boolean requiresServerKeyExchange() {
        return 1;
    }

    public void skipServerCredentials() {
        if(this.tlsSigner != null) {
            throw new TlsFatalAlert(10);
        }
    }

    public void validateCertificateRequest(CertificateRequest arg3) {
        throw new TlsFatalAlert(10);
    }
}

