// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Hashtable;
import org.bouncycastle.util.Integers;

public class TlsSRTPUtils {
    public static final Integer EXT_use_srtp;

    static {
        TlsSRTPUtils.EXT_use_srtp = Integers.valueOf(14);
    }

    public TlsSRTPUtils() {
        super();
    }

    public static void addUseSRTPExtension(Hashtable arg2, UseSRTPData arg3) {
        arg2.put(TlsSRTPUtils.EXT_use_srtp, TlsSRTPUtils.createUseSRTPExtension(arg3));
    }

    public static byte[] createUseSRTPExtension(UseSRTPData arg3) {
        if(arg3 == null) {
            throw new IllegalArgumentException("\'useSRTPData\' cannot be null");
        }

        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        int[] v1 = arg3.getProtectionProfiles();
        TlsUtils.writeUint16(v1.length * 2, ((OutputStream)v0));
        TlsUtils.writeUint16Array(v1, ((OutputStream)v0));
        TlsUtils.writeOpaque8(arg3.getMki(), ((OutputStream)v0));
        return v0.toByteArray();
    }

    public static UseSRTPData getUseSRTPExtension(Hashtable arg2) {
        UseSRTPData v0;
        UseSRTPData v1 = null;
        if(arg2 == null) {
            v0 = v1;
        }
        else {
            Object v0_1 = arg2.get(TlsSRTPUtils.EXT_use_srtp);
            v0 = v0_1 == null ? v1 : TlsSRTPUtils.readUseSRTPExtension(((byte[])v0_1));
        }

        return v0;
    }

    public static UseSRTPData readUseSRTPExtension(byte[] arg3) {
        if(arg3 == null) {
            throw new IllegalArgumentException("\'extensionValue\' cannot be null");
        }

        ByteArrayInputStream v0 = new ByteArrayInputStream(arg3);
        int v1 = TlsUtils.readUint16(((InputStream)v0));
        if(v1 >= 2 && (v1 & 1) == 0) {
            int[] v1_1 = TlsUtils.readUint16Array(v1 / 2, ((InputStream)v0));
            byte[] v2 = TlsUtils.readOpaque8(((InputStream)v0));
            TlsProtocol.assertEmpty(v0);
            return new UseSRTPData(v1_1, v2);
        }

        throw new TlsFatalAlert(50);
    }
}

