// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.tls;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.StreamCipher;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.util.Arrays;

public class TlsStreamCipher implements TlsCipher {
    protected TlsContext context;
    protected StreamCipher decryptCipher;
    protected StreamCipher encryptCipher;
    protected TlsMac readMac;
    protected TlsMac writeMac;

    public TlsStreamCipher(TlsContext arg14, StreamCipher arg15, StreamCipher arg16, Digest arg17, Digest arg18, int arg19) {
        KeyParameter v1_1;
        super();
        boolean v11 = arg14.isServer();
        this.context = arg14;
        this.encryptCipher = arg15;
        this.decryptCipher = arg16;
        int v12 = arg19 * 2 + arg17.getDigestSize() + arg18.getDigestSize();
        byte[] v4 = TlsUtils.calculateKeyBlock(arg14, v12);
        TlsMac v1 = new TlsMac(arg14, arg17, v4, 0, arg17.getDigestSize());
        int v9 = arg17.getDigestSize();
        TlsMac v5 = new TlsMac(arg14, arg18, v4, v9, arg18.getDigestSize());
        int v3 = v9 + arg18.getDigestSize();
        KeyParameter v2 = new KeyParameter(v4, v3, arg19);
        int v6 = v3 + arg19;
        KeyParameter v3_1 = new KeyParameter(v4, v6, arg19);
        if(v6 + arg19 != v12) {
            throw new TlsFatalAlert(80);
        }

        if(v11) {
            this.writeMac = v5;
            this.readMac = v1;
            this.encryptCipher = arg16;
            this.decryptCipher = arg15;
            v1_1 = v2;
        }
        else {
            this.writeMac = v1;
            this.readMac = v5;
            this.encryptCipher = arg15;
            this.decryptCipher = arg16;
            v1_1 = v3_1;
            v3_1 = v2;
        }

        this.encryptCipher.init(true, ((CipherParameters)v3_1));
        this.decryptCipher.init(false, ((CipherParameters)v1_1));
    }

    public byte[] decodeCiphertext(long arg9, short arg11, byte[] arg12, int arg13, int arg14) {
        int v6 = this.readMac.getSize();
        if(arg14 < v6) {
            throw new TlsFatalAlert(50);
        }

        byte[] v4 = new byte[arg14];
        this.decryptCipher.processBytes(arg12, arg13, arg14, v4, 0);
        v6 = arg14 - v6;
        if(!Arrays.constantTimeAreEqual(Arrays.copyOfRange(v4, v6, arg14), this.readMac.calculateMac(arg9, arg11, v4, 0, v6))) {
            throw new TlsFatalAlert(20);
        }

        return Arrays.copyOfRange(v4, 0, v6);
    }

    public byte[] encodePlaintext(long arg9, short arg11, byte[] arg12, int arg13, int arg14) {
        byte[] v6 = this.writeMac.calculateMac(arg9, arg11, arg12, arg13, arg14);
        byte[] v4 = new byte[v6.length + arg14];
        this.encryptCipher.processBytes(arg12, arg13, arg14, v4, 0);
        this.encryptCipher.processBytes(v6, 0, v6.length, v4, arg14);
        return v4;
    }

    public int getPlaintextLimit(int arg2) {
        return arg2 - this.writeMac.getSize();
    }
}

