// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.util;

import java.io.InputStream;
import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.nist.NISTNamedCurves;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.DHParameter;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.pkcs.RSAPrivateKey;
import org.bouncycastle.asn1.sec.ECPrivateKey;
import org.bouncycastle.asn1.sec.SECNamedCurves;
import org.bouncycastle.asn1.teletrust.TeleTrusTNamedCurves;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DSAParameter;
import org.bouncycastle.asn1.x9.X962NamedCurves;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.crypto.params.DSAParameters;
import org.bouncycastle.crypto.params.DSAPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ElGamalParameters;
import org.bouncycastle.crypto.params.ElGamalPrivateKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;

public class PrivateKeyFactory {
    public PrivateKeyFactory() {
        super();
    }

    public static AsymmetricKeyParameter createKey(InputStream arg1) {
        return PrivateKeyFactory.createKey(PrivateKeyInfo.getInstance(new ASN1InputStream(arg1).readObject()));
    }

    public static AsymmetricKeyParameter createKey(PrivateKeyInfo arg9) {
        X9ECParameters v5;
        DSAPrivateKeyParameters v0_4;
        DSAParameters v1_4;
        ASN1Encodable v0_1;
        BigInteger v2 = null;
        AlgorithmIdentifier v1 = arg9.getPrivateKeyAlgorithm();
        if(v1.getAlgorithm().equals(PKCSObjectIdentifiers.rsaEncryption)) {
            RSAPrivateKey v8 = RSAPrivateKey.getInstance(arg9.parsePrivateKey());
            RSAPrivateCrtKeyParameters v0 = new RSAPrivateCrtKeyParameters(v8.getModulus(), v8.getPublicExponent(), v8.getPrivateExponent(), v8.getPrime1(), v8.getPrime2(), v8.getExponent1(), v8.getExponent2(), v8.getCoefficient());
        }
        else if(v1.getAlgorithm().equals(PKCSObjectIdentifiers.dhKeyAgreement)) {
            DHParameter v3 = DHParameter.getInstance(v1.getParameters());
            v0_1 = arg9.parsePrivateKey();
            BigInteger v1_1 = v3.getL();
            int v1_2 = v1_1 == null ? 0 : v1_1.intValue();
            DHPrivateKeyParameters v0_2 = new DHPrivateKeyParameters(((ASN1Integer)v0_1).getValue(), new DHParameters(v3.getP(), v3.getG(), v2, v1_2));
        }
        else {
            if(v1.getAlgorithm().equals(OIWObjectIdentifiers.elGamalAlgorithm)) {
                ElGamalParameter v2_1 = new ElGamalParameter(v1.getParameters());
                ElGamalPrivateKeyParameters v0_3 = new ElGamalPrivateKeyParameters(arg9.parsePrivateKey().getValue(), new ElGamalParameters(v2_1.getP(), v2_1.getG()));
                goto label_18;
            }

            if(v1.getAlgorithm().equals(X9ObjectIdentifiers.id_dsa)) {
                v0_1 = arg9.parsePrivateKey();
                ASN1Encodable v1_3 = v1.getParameters();
                if(v1_3 != null) {
                    DSAParameter v2_2 = DSAParameter.getInstance(v1_3.toASN1Primitive());
                    v1_4 = new DSAParameters(v2_2.getP(), v2_2.getQ(), v2_2.getG());
                }
                else {
                    v1_4 = ((DSAParameters)v2);
                }

                v0_4 = new DSAPrivateKeyParameters(((ASN1Integer)v0_1).getValue(), v1_4);
                goto label_18;
            }

            if(!v1.getAlgorithm().equals(X9ObjectIdentifiers.id_ecPublicKey)) {
                goto label_113;
            }

            X962Parameters v2_3 = new X962Parameters(v1.getParameters());
            if(v2_3.isNamedCurve()) {
                ASN1ObjectIdentifier v1_5 = ASN1ObjectIdentifier.getInstance(v2_3.getParameters());
                X9ECParameters v0_5 = X962NamedCurves.getByOID(v1_5);
                if(v0_5 == null) {
                    v0_5 = SECNamedCurves.getByOID(v1_5);
                    if(v0_5 == null) {
                        v0_5 = NISTNamedCurves.getByOID(v1_5);
                        if(v0_5 == null) {
                            v0_5 = TeleTrusTNamedCurves.getByOID(v1_5);
                        }
                    }
                }

                v5 = v0_5;
            }
            else {
                v5 = X9ECParameters.getInstance(v2_3.getParameters());
            }

            ECPrivateKeyParameters v0_6 = new ECPrivateKeyParameters(ECPrivateKey.getInstance(arg9.parsePrivateKey()).getKey(), new ECDomainParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
        }

    label_18:
        return ((AsymmetricKeyParameter)v0_4);
    label_113:
        throw new RuntimeException("algorithm identifier in key not recognised");
    }

    public static AsymmetricKeyParameter createKey(byte[] arg1) {
        return PrivateKeyFactory.createKey(PrivateKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg1)));
    }
}

