// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.util;

import java.io.InputStream;
import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.nist.NISTNamedCurves;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.DHParameter;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.RSAPublicKey;
import org.bouncycastle.asn1.sec.SECNamedCurves;
import org.bouncycastle.asn1.teletrust.TeleTrusTNamedCurves;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DSAParameter;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.asn1.x9.DHDomainParameters;
import org.bouncycastle.asn1.x9.DHPublicKey;
import org.bouncycastle.asn1.x9.DHValidationParms;
import org.bouncycastle.asn1.x9.X962NamedCurves;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ECPoint;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.DHPublicKeyParameters;
import org.bouncycastle.crypto.params.DHValidationParameters;
import org.bouncycastle.crypto.params.DSAParameters;
import org.bouncycastle.crypto.params.DSAPublicKeyParameters;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.ElGamalParameters;
import org.bouncycastle.crypto.params.ElGamalPublicKeyParameters;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class PublicKeyFactory {
    public PublicKeyFactory() {
        super();
    }

    public static AsymmetricKeyParameter createKey(SubjectPublicKeyInfo arg8) {
        DSAParameters v5_2;
        X9ECParameters v5_1;
        X9ECParameters v0_5;
        ASN1Primitive v0_3;
        DHPublicKeyParameters v0_2;
        BigInteger v3;
        int v1 = 0;
        DHValidationParameters v5 = null;
        AlgorithmIdentifier v2 = arg8.getAlgorithm();
        if((v2.getAlgorithm().equals(PKCSObjectIdentifiers.rsaEncryption)) || (v2.getAlgorithm().equals(X509ObjectIdentifiers.id_ea_rsa))) {
            RSAPublicKey v2_3 = RSAPublicKey.getInstance(arg8.parsePublicKey());
            RSAKeyParameters v0_8 = new RSAKeyParameters(false, v2_3.getModulus(), v2_3.getPublicExponent());
        }
        else if(v2.getAlgorithm().equals(X9ObjectIdentifiers.dhpublicnumber)) {
            BigInteger v7 = DHPublicKey.getInstance(arg8.parsePublicKey()).getY().getValue();
            DHDomainParameters v0 = DHDomainParameters.getInstance(v2.getParameters());
            BigInteger v1_1 = v0.getP().getValue();
            BigInteger v2_1 = v0.getG().getValue();
            v3 = v0.getQ().getValue();
            BigInteger v4 = v0.getJ() != null ? v0.getJ().getValue() : ((BigInteger)v5);
            DHValidationParms v0_1 = v0.getValidationParms();
            if(v0_1 != null) {
                v5 = new DHValidationParameters(v0_1.getSeed().getBytes(), v0_1.getPgenCounter().getValue().intValue());
            }

            v0_2 = new DHPublicKeyParameters(v7, new DHParameters(v1_1, v2_1, v3, v4, v5));
        }
        else {
            if(v2.getAlgorithm().equals(PKCSObjectIdentifiers.dhKeyAgreement)) {
                DHParameter v2_2 = DHParameter.getInstance(v2.getParameters());
                v0_3 = arg8.parsePublicKey();
                v3 = v2_2.getL();
                if(v3 != null) {
                    v1 = v3.intValue();
                }

                v0_2 = new DHPublicKeyParameters(((ASN1Integer)v0_3).getValue(), new DHParameters(v2_2.getP(), v2_2.getG(), ((BigInteger)v5), v1));
                goto label_17;
            }

            if(v2.getAlgorithm().equals(OIWObjectIdentifiers.elGamalAlgorithm)) {
                ElGamalParameter v3_1 = new ElGamalParameter(v2.getParameters());
                ElGamalPublicKeyParameters v0_4 = new ElGamalPublicKeyParameters(arg8.parsePublicKey().getValue(), new ElGamalParameters(v3_1.getP(), v3_1.getG()));
                goto label_17;
            }

            if(!v2.getAlgorithm().equals(X9ObjectIdentifiers.id_dsa) && !v2.getAlgorithm().equals(OIWObjectIdentifiers.dsaWithSHA1)) {
                if(v2.getAlgorithm().equals(X9ObjectIdentifiers.id_ecPublicKey)) {
                    X962Parameters v1_2 = new X962Parameters(v2.getParameters());
                    if(v1_2.isNamedCurve()) {
                        v0_3 = v1_2.getParameters();
                        X9ECParameters v1_3 = X962NamedCurves.getByOID(((ASN1ObjectIdentifier)v0_3));
                        if(v1_3 == null) {
                            v1_3 = SECNamedCurves.getByOID(((ASN1ObjectIdentifier)v0_3));
                            if(v1_3 == null) {
                                v1_3 = NISTNamedCurves.getByOID(((ASN1ObjectIdentifier)v0_3));
                                if(v1_3 == null) {
                                    v0_5 = TeleTrusTNamedCurves.getByOID(((ASN1ObjectIdentifier)v0_3));
                                }
                                else {
                                    goto label_158;
                                }
                            }
                            else {
                                goto label_158;
                            }
                        }
                        else {
                        label_158:
                            v0_5 = v1_3;
                        }

                        v5_1 = v0_5;
                    }
                    else {
                        v5_1 = X9ECParameters.getInstance(v1_2.getParameters());
                    }

                    ECPublicKeyParameters v0_6 = new ECPublicKeyParameters(new X9ECPoint(v5_1.getCurve(), new DEROctetString(arg8.getPublicKeyData().getBytes())).getPoint(), new ECDomainParameters(v5_1.getCurve(), v5_1.getG(), v5_1.getN(), v5_1.getH(), v5_1.getSeed()));
                    goto label_17;
                }
                else {
                    throw new RuntimeException("algorithm identifier in key not recognised");
                }
            }

            v0_3 = arg8.parsePublicKey();
            ASN1Encodable v1_4 = v2.getParameters();
            if(v1_4 != null) {
                DSAParameter v1_5 = DSAParameter.getInstance(v1_4.toASN1Primitive());
                v5_2 = new DSAParameters(v1_5.getP(), v1_5.getQ(), v1_5.getG());
            }

            DSAPublicKeyParameters v0_7 = new DSAPublicKeyParameters(((ASN1Integer)v0_3).getValue(), v5_2);
        }

    label_17:
        return ((AsymmetricKeyParameter)v0_2);
    }

    public static AsymmetricKeyParameter createKey(InputStream arg1) {
        return PublicKeyFactory.createKey(SubjectPublicKeyInfo.getInstance(new ASN1InputStream(arg1).readObject()));
    }

    public static AsymmetricKeyParameter createKey(byte[] arg1) {
        return PublicKeyFactory.createKey(SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg1)));
    }
}

