// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.crypto.util;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.RSAPublicKey;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ECPoint;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DSAPublicKeyParameters;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class SubjectPublicKeyInfoFactory {
    public SubjectPublicKeyInfoFactory() {
        super();
    }

    public static SubjectPublicKeyInfo createSubjectPublicKeyInfo(AsymmetricKeyParameter arg6) {
        SubjectPublicKeyInfo v0;
        if((arg6 instanceof RSAKeyParameters)) {
            v0 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(PKCSObjectIdentifiers.rsaEncryption, DERNull.INSTANCE), new RSAPublicKey(((RSAKeyParameters)arg6).getModulus(), ((RSAKeyParameters)arg6).getExponent()));
        }
        else if((arg6 instanceof DSAPublicKeyParameters)) {
            v0 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_dsa), new ASN1Integer(((DSAPublicKeyParameters)arg6).getY()));
        }
        else if((arg6 instanceof ECPublicKeyParameters)) {
            ECDomainParameters v5 = ((ECPublicKeyParameters)arg6).getParameters();
            X962Parameters v1 = v5 == null ? new X962Parameters(DERNull.INSTANCE) : new X962Parameters(new X9ECParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
            v0 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, ((ASN1Encodable)v1)), new X9ECPoint(((ECPublicKeyParameters)arg6).getQ()).toASN1Primitive().getOctets());
        }
        else {
            goto label_54;
        }

        return v0;
    label_54:
        throw new IOException("key parameters not recognised.");
    }
}

