// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dh;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.util.Enumeration;
import javax.crypto.interfaces.DHPrivateKey;
import javax.crypto.spec.DHParameterSpec;
import javax.crypto.spec.DHPrivateKeySpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.pkcs.DHParameter;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x9.DHDomainParameters;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.DHPrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;

public class BCDHPrivateKey implements DHPrivateKey, PKCS12BagAttributeCarrier {
    private transient PKCS12BagAttributeCarrierImpl attrCarrier;
    private transient DHParameterSpec dhSpec;
    private transient PrivateKeyInfo info;
    static final long serialVersionUID = 311058815616901812L;
    private BigInteger x;

    protected BCDHPrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    BCDHPrivateKey(DHPrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg2.getX();
        this.dhSpec = arg2.getParams();
    }

    BCDHPrivateKey(DHPrivateKeySpec arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.dhSpec = new DHParameterSpec(arg4.getP(), arg4.getG());
    }

    public BCDHPrivateKey(PrivateKeyInfo arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        ASN1Sequence v1 = ASN1Sequence.getInstance(arg5.getPrivateKeyAlgorithm().getParameters());
        ASN1Encodable v0 = arg5.parsePrivateKey();
        ASN1ObjectIdentifier v2 = arg5.getPrivateKeyAlgorithm().getAlgorithm();
        this.info = arg5;
        this.x = ((ASN1Integer)v0).getValue();
        if(v2.equals(PKCSObjectIdentifiers.dhKeyAgreement)) {
            DHParameter v0_1 = DHParameter.getInstance(v1);
            this.dhSpec = v0_1.getL() != null ? new DHParameterSpec(v0_1.getP(), v0_1.getG(), v0_1.getL().intValue()) : new DHParameterSpec(v0_1.getP(), v0_1.getG());
        }
        else if(v2.equals(X9ObjectIdentifiers.dhpublicnumber)) {
            DHDomainParameters v0_2 = DHDomainParameters.getInstance(v1);
            this.dhSpec = new DHParameterSpec(v0_2.getP().getValue(), v0_2.getG().getValue());
        }
        else {
            goto label_45;
        }

        return;
    label_45:
        throw new IllegalArgumentException("unknown algorithm type: " + v2);
    }

    BCDHPrivateKey(DHPrivateKeyParameters arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg5.getX();
        this.dhSpec = new DHParameterSpec(arg5.getParameters().getP(), arg5.getParameters().getG(), arg5.getParameters().getL());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DHPrivateKey)) && (this.getX().equals(((DHPrivateKey)arg4).getX())) && (this.getParams().getG().equals(((DHPrivateKey)arg4).getParams().getG())) && (this.getParams().getP().equals(((DHPrivateKey)arg4).getParams().getP())) && this.getParams().getL() == ((DHPrivateKey)arg4).getParams().getL()) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "DH";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        byte[] v0_1;
        try {
            if(this.info != null) {
                v0_1 = this.info.getEncoded("DER");
                return v0_1;
            }

            v0_1 = new PrivateKeyInfo(new AlgorithmIdentifier(PKCSObjectIdentifiers.dhKeyAgreement, new DHParameter(this.dhSpec.getP(), this.dhSpec.getG(), this.dhSpec.getL()).toASN1Primitive()), new ASN1Integer(this.getX())).getEncoded("DER");
        }
        catch(Exception v0) {
            v0_1 = null;
        }

        return v0_1;
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public DHParameterSpec getParams() {
        return this.dhSpec;
    }

    public BigInteger getX() {
        return this.x;
    }

    public int hashCode() {
        return this.getX().hashCode() ^ this.getParams().getG().hashCode() ^ this.getParams().getP().hashCode() ^ this.getParams().getL();
    }

    private void readObject(ObjectInputStream arg5) {
        arg5.defaultReadObject();
        this.dhSpec = new DHParameterSpec(arg5.readObject(), arg5.readObject(), arg5.readInt());
        this.info = null;
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.dhSpec.getP());
        arg2.writeObject(this.dhSpec.getG());
        arg2.writeInt(this.dhSpec.getL());
    }
}

