// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dh;

import java.io.ByteArrayOutputStream;
import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.BadPaddingException;
import javax.crypto.CipherSpi;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.interfaces.DHKey;
import javax.crypto.interfaces.DHPrivateKey;
import javax.crypto.interfaces.DHPublicKey;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.engines.IESEngine;
import org.bouncycastle.crypto.generators.DHKeyPairGenerator;
import org.bouncycastle.crypto.generators.EphemeralKeyPairGenerator;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DHKeyGenerationParameters;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.crypto.params.IESWithCipherParameters;
import org.bouncycastle.crypto.parsers.DHIESPublicKeyParser;
import org.bouncycastle.jcajce.provider.asymmetric.util.DHUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.IESUtil;
import org.bouncycastle.jce.interfaces.IESKey;
import org.bouncycastle.jce.spec.IESParameterSpec;
import org.bouncycastle.util.Strings;

public class IESCipher extends CipherSpi {
    private ByteArrayOutputStream buffer;
    private boolean dhaesMode;
    private IESEngine engine;
    private AlgorithmParameters engineParam;
    private IESParameterSpec engineSpec;
    private AsymmetricKeyParameter key;
    private AsymmetricKeyParameter otherKeyParameter;
    private SecureRandom random;
    private int state;

    public IESCipher(IESEngine arg3) {
        super();
        this.state = -1;
        this.buffer = new ByteArrayOutputStream();
        this.engineParam = null;
        this.engineSpec = null;
        this.dhaesMode = false;
        this.otherKeyParameter = null;
        this.engine = arg3;
    }

    public int engineDoFinal(byte[] arg4, int arg5, int arg6, byte[] arg7, int arg8) {
        byte[] v0 = this.engineDoFinal(arg4, arg5, arg6);
        System.arraycopy(v0, 0, arg7, arg8, v0.length);
        return v0.length;
    }

    public byte[] engineDoFinal(byte[] arg9, int arg10, int arg11) {
        byte[] v0_2;
        int v7 = 3;
        if(arg11 != 0) {
            this.buffer.write(arg9, arg10, arg11);
        }

        byte[] v1 = this.buffer.toByteArray();
        this.buffer.reset();
        IESWithCipherParameters v2 = new IESWithCipherParameters(this.engineSpec.getDerivationV(), this.engineSpec.getEncodingV(), this.engineSpec.getMacKeySize(), this.engineSpec.getCipherKeySize());
        DHParameters v0 = this.key.getParameters();
        if(this.otherKeyParameter != null) {
            try {
                if(this.state == 1 || this.state == v7) {
                    this.engine.init(true, this.otherKeyParameter, this.key, ((CipherParameters)v2));
                }
                else {
                    this.engine.init(false, this.key, this.otherKeyParameter, ((CipherParameters)v2));
                }

                v0_2 = this.engine.processBlock(v1, 0, v1.length);
            }
            catch(Exception v0_1) {
                goto label_47;
            }
        }
        else {
            if(this.state != 1 && this.state != v7) {
                if(this.state != 2 && this.state != 4) {
                    throw new IllegalStateException("IESCipher not initialised");
                }

                try {
                    this.engine.init(this.key, ((CipherParameters)v2), new DHIESPublicKeyParser(this.key.getParameters()));
                    return this.engine.processBlock(v1, 0, v1.length);
                }
                catch(InvalidCipherTextException v0_3) {
                    throw new BadPaddingException(v0_3.getMessage());
                }
            }

            DHKeyPairGenerator v3 = new DHKeyPairGenerator();
            v3.init(new DHKeyGenerationParameters(this.random, v0));
            EphemeralKeyPairGenerator v0_4 = new EphemeralKeyPairGenerator(((AsymmetricCipherKeyPairGenerator)v3), new IESCipher$1(this));
            try {
                this.engine.init(this.key, ((CipherParameters)v2), v0_4);
                v0_2 = this.engine.processBlock(v1, 0, v1.length);
            }
            catch(Exception v0_1) {
                throw new BadPaddingException(v0_1.getMessage());
            }
        }

        return v0_2;
    label_47:
        throw new BadPaddingException(v0_1.getMessage());
    }

    public int engineGetBlockSize() {
        int v0 = this.engine.getCipher() != null ? this.engine.getCipher().getBlockSize() : 0;
        return v0;
    }

    public byte[] engineGetIV() {
        return null;
    }

    public int engineGetKeySize(Key arg3) {
        if((arg3 instanceof DHKey)) {
            return ((DHKey)arg3).getParams().getP().bitLength();
        }

        throw new IllegalArgumentException("not a DH key");
    }

    public int engineGetOutputSize(int arg9) {
        int v7 = 4;
        int v6 = 3;
        int v5 = 2;
        int v1 = this.engine.getMac().getMacSize();
        if(this.key != null) {
            int v0 = this.key.getParams().getP().bitLength() / 8 + 1;
            if(this.engine.getCipher() != null) {
                if(this.state != 1 && this.state != v6) {
                    if(this.state != v5 && this.state != v7) {
                        throw new IllegalStateException("cipher not initialised");
                    }

                    arg9 = this.engine.getCipher().getOutputSize(arg9 - v1 - v0);
                    goto label_18;
                }

                arg9 = this.engine.getCipher().getOutputSize(arg9);
            }

        label_18:
            if(this.state == 1 || this.state == v6) {
                v0 = v0 + (v1 + this.buffer.size()) + arg9;
            }
            else {
                if(this.state != v5 && this.state != v7) {
                    throw new IllegalStateException("IESCipher not initialised");
                }

                v0 = this.buffer.size() - v1 - v0 + arg9;
            }

            return v0;
        }

        throw new IllegalStateException("cipher not initialised");
    }

    public AlgorithmParameters engineGetParameters() {
        if(this.engineParam == null && this.engineSpec != null) {
            try {
                this.engineParam = AlgorithmParameters.getInstance("IES", "BC");
                this.engineParam.init(this.engineSpec);
            }
            catch(Exception v0) {
                throw new RuntimeException(v0.toString());
            }
        }

        return this.engineParam;
    }

    public void engineInit(int arg5, Key arg6, AlgorithmParameters arg7, SecureRandom arg8) {
        AlgorithmParameterSpec v0 = null;
        if(arg7 != null) {
            try {
                v0 = arg7.getParameterSpec(IESParameterSpec.class);
            }
            catch(Exception v0_1) {
                throw new InvalidAlgorithmParameterException("cannot recognise parameters: " + v0_1.toString());
            }
        }

        this.engineParam = arg7;
        this.engineInit(arg5, arg6, v0, arg8);
    }

    public void engineInit(int arg3, Key arg4, AlgorithmParameterSpec arg5, SecureRandom arg6) {
        if(arg5 == null) {
            this.engineSpec = IESUtil.guessParameterSpec(this.engine);
        }
        else if((arg5 instanceof IESParameterSpec)) {
            this.engineSpec = ((IESParameterSpec)arg5);
        }
        else {
            goto label_21;
        }

        if(arg3 == 1 || arg3 == 3) {
            if((arg4 instanceof DHPublicKey)) {
                this.key = DHUtil.generatePublicKeyParameter(((PublicKey)arg4));
                goto label_12;
            }

            if(!(arg4 instanceof IESKey)) {
                goto label_34;
            }

            this.key = DHUtil.generatePublicKeyParameter(((IESKey)arg4).getPublic());
            this.otherKeyParameter = DHUtil.generatePrivateKeyParameter(((IESKey)arg4).getPrivate());
        }
        else {
            if(arg3 != 2 && arg3 != 4) {
                throw new InvalidKeyException("must be passed EC key");
            }

            if((arg4 instanceof DHPrivateKey)) {
                this.key = DHUtil.generatePrivateKeyParameter(((PrivateKey)arg4));
                goto label_12;
            }

            if((arg4 instanceof IESKey)) {
                this.otherKeyParameter = DHUtil.generatePublicKeyParameter(((IESKey)arg4).getPublic());
                this.key = DHUtil.generatePrivateKeyParameter(((IESKey)arg4).getPrivate());
                goto label_12;
            }

            throw new InvalidKeyException("must be passed recipient\'s private DH key for decryption");
        }

    label_12:
        this.random = arg6;
        this.state = arg3;
        this.buffer.reset();
        return;
    label_34:
        throw new InvalidKeyException("must be passed recipient\'s public DH key for encryption");
    label_21:
        throw new InvalidAlgorithmParameterException("must be passed IES parameters");
    }

    public void engineInit(int arg3, Key arg4, SecureRandom arg5) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.engineInit(arg3, arg4, v0, arg5);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new IllegalArgumentException("can\'t handle supplied parameter spec");
        }
    }

    public void engineSetMode(String arg4) {
        String v0 = Strings.toUpperCase(arg4);
        if(v0.equals("NONE")) {
            this.dhaesMode = false;
        }
        else if(v0.equals("DHAES")) {
            this.dhaesMode = true;
        }
        else {
            goto label_13;
        }

        return;
    label_13:
        throw new IllegalArgumentException("can\'t support mode " + arg4);
    }

    public void engineSetPadding(String arg3) {
        String v0 = Strings.toUpperCase(arg3);
        if(!v0.equals("NOPADDING") && !v0.equals("PKCS5PADDING") && !v0.equals("PKCS7PADDING")) {
            throw new NoSuchPaddingException("padding not available with IESCipher");
        }
    }

    public int engineUpdate(byte[] arg2, int arg3, int arg4, byte[] arg5, int arg6) {
        this.buffer.write(arg2, arg3, arg4);
        return 0;
    }

    public byte[] engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.buffer.write(arg2, arg3, arg4);
        return null;
    }
}

