// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dh;

import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.util.Hashtable;
import javax.crypto.spec.DHParameterSpec;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.DHBasicKeyPairGenerator;
import org.bouncycastle.crypto.generators.DHParametersGenerator;
import org.bouncycastle.crypto.params.DHKeyGenerationParameters;
import org.bouncycastle.crypto.params.DHParameters;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.util.Integers;

public class KeyPairGeneratorSpi extends KeyPairGenerator {
    int certainty;
    DHBasicKeyPairGenerator engine;
    boolean initialised;
    private static Object lock;
    DHKeyGenerationParameters param;
    private static Hashtable params;
    SecureRandom random;
    int strength;

    static {
        KeyPairGeneratorSpi.params = new Hashtable();
        KeyPairGeneratorSpi.lock = new Object();
    }

    public KeyPairGeneratorSpi() {
        super("DH");
        this.engine = new DHBasicKeyPairGenerator();
        this.strength = 1024;
        this.certainty = 20;
        this.random = new SecureRandom();
        this.initialised = false;
    }

    public KeyPair generateKeyPair() {
        if(!this.initialised) {
            Integer v0 = Integers.valueOf(this.strength);
            if(KeyPairGeneratorSpi.params.containsKey(v0)) {
                this.param = KeyPairGeneratorSpi.params.get(v0);
            }
            else {
                DHParameterSpec v1 = BouncyCastleProvider.CONFIGURATION.getDHDefaultParameters(this.strength);
                if(v1 != null) {
                    this.param = new DHKeyGenerationParameters(this.random, new DHParameters(v1.getP(), v1.getG(), null, v1.getL()));
                }
                else {
                    Object v1_1 = KeyPairGeneratorSpi.lock;
                    __monitor_enter(v1_1);
                    try {
                        if(KeyPairGeneratorSpi.params.containsKey(v0)) {
                            this.param = KeyPairGeneratorSpi.params.get(v0);
                        }
                        else {
                            DHParametersGenerator v2 = new DHParametersGenerator();
                            v2.init(this.strength, this.certainty, this.random);
                            this.param = new DHKeyGenerationParameters(this.random, v2.generateParameters());
                            KeyPairGeneratorSpi.params.put(v0, this.param);
                        }

                        __monitor_exit(v1_1);
                        goto label_10;
                    label_52:
                        __monitor_exit(v1_1);
                    }
                    catch(Throwable v0_1) {
                        goto label_52;
                    }

                    throw v0_1;
                }
            }

        label_10:
            this.engine.init(this.param);
            this.initialised = true;
        }

        AsymmetricCipherKeyPair v1_2 = this.engine.generateKeyPair();
        return new KeyPair(new BCDHPublicKey(v1_2.getPublic()), new BCDHPrivateKey(v1_2.getPrivate()));
    }

    public void initialize(int arg1, SecureRandom arg2) {
        this.strength = arg1;
        this.random = arg2;
    }

    public void initialize(AlgorithmParameterSpec arg7, SecureRandom arg8) {
        if(!(arg7 instanceof DHParameterSpec)) {
            throw new InvalidAlgorithmParameterException("parameter object not a DHParameterSpec");
        }

        this.param = new DHKeyGenerationParameters(arg8, new DHParameters(((DHParameterSpec)arg7).getP(), ((DHParameterSpec)arg7).getG(), null, ((DHParameterSpec)arg7).getL()));
        this.engine.init(this.param);
        this.initialised = true;
    }
}

