// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidParameterException;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.DSAParameterSpec;
import org.bouncycastle.crypto.digests.SHA256Digest;
import org.bouncycastle.crypto.generators.DSAParametersGenerator;
import org.bouncycastle.crypto.params.DSAParameterGenerationParameters;
import org.bouncycastle.crypto.params.DSAParameters;

public class AlgorithmParameterGeneratorSpi extends java.security.AlgorithmParameterGeneratorSpi {
    protected DSAParameterGenerationParameters params;
    protected SecureRandom random;
    protected int strength;

    public AlgorithmParameterGeneratorSpi() {
        super();
        this.strength = 1024;
    }

    protected AlgorithmParameters engineGenerateParameters() {
        int v5 = 80;
        int v4 = 1024;
        DSAParametersGenerator v0 = this.strength <= v4 ? new DSAParametersGenerator() : new DSAParametersGenerator(new SHA256Digest());
        if(this.random == null) {
            this.random = new SecureRandom();
        }

        if(this.strength == v4) {
            this.params = new DSAParameterGenerationParameters(v4, 160, v5, this.random);
            v0.init(this.params);
        }
        else if(this.strength > v4) {
            this.params = new DSAParameterGenerationParameters(this.strength, 256, v5, this.random);
            v0.init(this.params);
        }
        else {
            v0.init(this.strength, 20, this.random);
        }

        DSAParameters v0_1 = v0.generateParameters();
        try {
            AlgorithmParameters v1 = AlgorithmParameters.getInstance("DSA", "BC");
            v1.init(new DSAParameterSpec(v0_1.getP(), v0_1.getQ(), v0_1.getG()));
            return v1;
        }
        catch(Exception v0_2) {
            throw new RuntimeException(v0_2.getMessage());
        }
    }

    protected void engineInit(int arg3, SecureRandom arg4) {
        int v1 = 1024;
        if(arg3 >= 512 && arg3 <= 3072) {
            if(arg3 <= v1 && arg3 % 64 != 0) {
                throw new InvalidParameterException("strength must be a multiple of 64 below 1024 bits.");
            }

            if(arg3 > v1 && arg3 % 1024 != 0) {
                throw new InvalidParameterException("strength must be a multiple of 1024 above 1024 bits.");
            }

            this.strength = arg3;
            this.random = arg4;
            return;
        }

        throw new InvalidParameterException("strength must be from 512 - 3072");
    }

    protected void engineInit(AlgorithmParameterSpec arg3, SecureRandom arg4) {
        throw new InvalidAlgorithmParameterException("No supported AlgorithmParameterSpec for DSA parameter generation.");
    }
}

