// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.DSAParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.x509.DSAParameter;

public class AlgorithmParametersSpi extends java.security.AlgorithmParametersSpi {
    DSAParameterSpec currentSpec;

    public AlgorithmParametersSpi() {
        super();
    }

    protected byte[] engineGetEncoded() {
        DSAParameter v0 = new DSAParameter(this.currentSpec.getP(), this.currentSpec.getQ(), this.currentSpec.getG());
        try {
            return v0.getEncoded("DER");
        }
        catch(IOException v0_1) {
            throw new RuntimeException("Error encoding DSAParameters");
        }
    }

    protected byte[] engineGetEncoded(String arg2) {
        byte[] v0 = this.isASN1FormatString(arg2) ? this.engineGetEncoded() : null;
        return v0;
    }

    protected AlgorithmParameterSpec engineGetParameterSpec(Class arg3) {
        if(arg3 == null) {
            throw new NullPointerException("argument to getParameterSpec must not be null");
        }

        return this.localEngineGetParameterSpec(arg3);
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if(!(arg3 instanceof DSAParameterSpec)) {
            throw new InvalidParameterSpecException("DSAParameterSpec required to initialise a DSA algorithm parameters object");
        }

        this.currentSpec = ((DSAParameterSpec)arg3);
    }

    protected void engineInit(byte[] arg5) {
        try {
            DSAParameter v0_2 = DSAParameter.getInstance(ASN1Primitive.fromByteArray(arg5));
            this.currentSpec = new DSAParameterSpec(v0_2.getP(), v0_2.getQ(), v0_2.getG());
            return;
        }
        catch(ArrayIndexOutOfBoundsException v0) {
            throw new IOException("Not a valid DSA Parameter encoding.");
        }
        catch(ClassCastException v0_1) {
            throw new IOException("Not a valid DSA Parameter encoding.");
        }
    }

    protected void engineInit(byte[] arg4, String arg5) {
        if(!this.isASN1FormatString(arg5) && !arg5.equalsIgnoreCase("X.509")) {
            throw new IOException("Unknown parameter format " + arg5);
        }

        this.engineInit(arg4);
    }

    protected String engineToString() {
        return "DSA Parameters";
    }

    protected boolean isASN1FormatString(String arg2) {
        boolean v0 = arg2 == null || (arg2.equals("ASN.1")) ? true : false;
        return v0;
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == DSAParameterSpec.class) {
            return this.currentSpec;
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to DSA parameters object.");
    }
}

