// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.DSAParams;
import java.security.interfaces.DSAPrivateKey;
import java.security.spec.DSAParameterSpec;
import java.security.spec.DSAPrivateKeySpec;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DSAParameter;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.DSAPrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;

public class BCDSAPrivateKey implements DSAPrivateKey, PKCS12BagAttributeCarrier {
    private transient PKCS12BagAttributeCarrierImpl attrCarrier;
    private transient DSAParams dsaSpec;
    private static final long serialVersionUID = -4677259546958385734L;
    private BigInteger x;

    protected BCDSAPrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    BCDSAPrivateKey(DSAPrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg2.getX();
        this.dsaSpec = arg2.getParams();
    }

    BCDSAPrivateKey(DSAPrivateKeySpec arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg5.getX();
        this.dsaSpec = new DSAParameterSpec(arg5.getP(), arg5.getQ(), arg5.getG());
    }

    public BCDSAPrivateKey(PrivateKeyInfo arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        DSAParameter v1 = DSAParameter.getInstance(arg5.getPrivateKeyAlgorithm().getParameters());
        this.x = arg5.parsePrivateKey().getValue();
        this.dsaSpec = new DSAParameterSpec(v1.getP(), v1.getQ(), v1.getG());
    }

    BCDSAPrivateKey(DSAPrivateKeyParameters arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg5.getX();
        this.dsaSpec = new DSAParameterSpec(arg5.getParameters().getP(), arg5.getParameters().getQ(), arg5.getParameters().getG());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DSAPrivateKey)) && (this.getX().equals(((DSAPrivateKey)arg4).getX())) && (this.getParams().getG().equals(((DSAPrivateKey)arg4).getParams().getG())) && (this.getParams().getP().equals(((DSAPrivateKey)arg4).getParams().getP())) && (this.getParams().getQ().equals(((DSAPrivateKey)arg4).getParams().getQ()))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "DSA";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedPrivateKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_dsa, new DSAParameter(this.dsaSpec.getP(), this.dsaSpec.getQ(), this.dsaSpec.getG()).toASN1Primitive()), new ASN1Integer(this.getX()));
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public DSAParams getParams() {
        return this.dsaSpec;
    }

    public BigInteger getX() {
        return this.x;
    }

    public int hashCode() {
        return this.getX().hashCode() ^ this.getParams().getG().hashCode() ^ this.getParams().getP().hashCode() ^ this.getParams().getQ().hashCode();
    }

    private void readObject(ObjectInputStream arg5) {
        arg5.defaultReadObject();
        this.dsaSpec = new DSAParameterSpec(arg5.readObject(), arg5.readObject(), arg5.readObject());
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.dsaSpec.getP());
        arg2.writeObject(this.dsaSpec.getQ());
        arg2.writeObject(this.dsaSpec.getG());
    }
}

