// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.DSAParams;
import java.security.interfaces.DSAPublicKey;
import java.security.spec.DSAParameterSpec;
import java.security.spec.DSAPublicKeySpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DSAParameter;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.DSAPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;

public class BCDSAPublicKey implements DSAPublicKey {
    private transient DSAParams dsaSpec;
    private static final long serialVersionUID = 1752452449903495175L;
    private BigInteger y;

    BCDSAPublicKey(BigInteger arg1, DSAParameterSpec arg2) {
        super();
        this.y = arg1;
        this.dsaSpec = ((DSAParams)arg2);
    }

    BCDSAPublicKey(DSAPublicKey arg2) {
        super();
        this.y = arg2.getY();
        this.dsaSpec = arg2.getParams();
    }

    BCDSAPublicKey(DSAPublicKeySpec arg5) {
        super();
        this.y = arg5.getY();
        this.dsaSpec = new DSAParameterSpec(arg5.getP(), arg5.getQ(), arg5.getG());
    }

    public BCDSAPublicKey(SubjectPublicKeyInfo arg5) {
        BigInteger v0_1;
        super();
        try {
            v0_1 = arg5.parsePublicKey().getValue();
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("invalid info structure in DSA public key");
        }

        this.y = v0_1;
        if(this.isNotNull(arg5.getAlgorithm().getParameters())) {
            DSAParameter v0_2 = DSAParameter.getInstance(arg5.getAlgorithm().getParameters());
            this.dsaSpec = new DSAParameterSpec(v0_2.getP(), v0_2.getQ(), v0_2.getG());
        }
    }

    BCDSAPublicKey(DSAPublicKeyParameters arg5) {
        super();
        this.y = arg5.getY();
        this.dsaSpec = new DSAParameterSpec(arg5.getParameters().getP(), arg5.getParameters().getQ(), arg5.getParameters().getG());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DSAPublicKey)) && (this.getY().equals(((DSAPublicKey)arg4).getY())) && (this.getParams().getG().equals(((DSAPublicKey)arg4).getParams().getG())) && (this.getParams().getP().equals(((DSAPublicKey)arg4).getParams().getP())) && (this.getParams().getQ().equals(((DSAPublicKey)arg4).getParams().getQ()))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "DSA";
    }

    public byte[] getEncoded() {
        byte[] v0 = this.dsaSpec == null ? KeyUtil.getEncodedSubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_dsa), new ASN1Integer(this.y)) : KeyUtil.getEncodedSubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_dsa, new DSAParameter(this.dsaSpec.getP(), this.dsaSpec.getQ(), this.dsaSpec.getG()).toASN1Primitive()), new ASN1Integer(this.y));
        return v0;
    }

    public String getFormat() {
        return "X.509";
    }

    public DSAParams getParams() {
        return this.dsaSpec;
    }

    public BigInteger getY() {
        return this.y;
    }

    public int hashCode() {
        return this.getY().hashCode() ^ this.getParams().getG().hashCode() ^ this.getParams().getP().hashCode() ^ this.getParams().getQ().hashCode();
    }

    private boolean isNotNull(ASN1Encodable arg3) {
        boolean v0 = arg3 == null || (DERNull.INSTANCE.equals(arg3.toASN1Primitive())) ? false : true;
        return v0;
    }

    private void readObject(ObjectInputStream arg5) {
        arg5.defaultReadObject();
        this.dsaSpec = new DSAParameterSpec(arg5.readObject(), arg5.readObject(), arg5.readObject());
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("DSA Public Key").append(v1);
        v0.append("            y: ").append(this.getY().toString(16)).append(v1);
        return v0.toString();
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.dsaSpec.getP());
        arg2.writeObject(this.dsaSpec.getQ());
        arg2.writeObject(this.dsaSpec.getG());
    }
}

