// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.math.BigInteger;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.SignatureException;
import java.security.SignatureSpi;
import java.security.interfaces.DSAKey;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;

public class DSASigner extends SignatureSpi implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    private Digest digest;
    private SecureRandom random;
    private DSA signer;

    protected DSASigner(Digest arg1, DSA arg2) {
        super();
        this.digest = arg1;
        this.signer = arg2;
    }

    private BigInteger[] derDecode(byte[] arg6) {
        ASN1Primitive v0 = ASN1Primitive.fromByteArray(arg6);
        return new BigInteger[]{((ASN1Sequence)v0).getObjectAt(0).getValue(), ((ASN1Sequence)v0).getObjectAt(1).getValue()};
    }

    private byte[] derEncode(BigInteger arg4, BigInteger arg5) {
        return new DERSequence(new ASN1Integer[]{new ASN1Integer(arg4), new ASN1Integer(arg5)}).getEncoded("DER");
    }

    protected Object engineGetParameter(String arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineInitSign(PrivateKey arg4) {
        AsymmetricKeyParameter v0_1;
        AsymmetricKeyParameter v1 = DSAUtil.generatePrivateKeyParameter(arg4);
        if(this.random != null) {
            ParametersWithRandom v0 = new ParametersWithRandom(((CipherParameters)v1), this.random);
        }
        else {
            v0_1 = v1;
        }

        this.digest.reset();
        this.signer.init(true, ((CipherParameters)v0_1));
    }

    protected void engineInitSign(PrivateKey arg1, SecureRandom arg2) {
        this.random = arg2;
        this.engineInitSign(arg1);
    }

    protected void engineInitVerify(PublicKey arg4) {
        AsymmetricKeyParameter v0;
        if((arg4 instanceof DSAKey)) {
            v0 = DSAUtil.generatePublicKeyParameter(arg4);
        }
        else {
            try {
                BCDSAPublicKey v1 = new BCDSAPublicKey(SubjectPublicKeyInfo.getInstance(arg4.getEncoded()));
                if((v1 instanceof DSAKey)) {
                    v0 = DSAUtil.generatePublicKeyParameter(((PublicKey)v1));
                }
                else {
                    goto label_17;
                }
            }
            catch(Exception v0_1) {
                goto label_25;
            }
        }

        this.digest.reset();
        this.signer.init(false, ((CipherParameters)v0));
        return;
        try {
        label_17:
            throw new InvalidKeyException("can\'t recognise key type in DSA based signer");
        }
        catch(Exception v0_1) {
        label_25:
            throw new InvalidKeyException("can\'t recognise key type in DSA based signer");
        }
    }

    protected void engineSetParameter(String arg3, Object arg4) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(AlgorithmParameterSpec arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected byte[] engineSign() {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            BigInteger[] v0_2 = this.signer.generateSignature(v0);
            return this.derEncode(v0_2[0], v0_2[1]);
        }
        catch(Exception v0_1) {
            throw new SignatureException(v0_1.toString());
        }
    }

    protected void engineUpdate(byte arg2) {
        this.digest.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    protected boolean engineVerify(byte[] arg6) {
        BigInteger[] v1;
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            v1 = this.derDecode(arg6);
        }
        catch(Exception v0_1) {
            throw new SignatureException("error decoding signature bytes.");
        }

        return this.signer.verifySignature(v0, v1[0], v1[1]);
    }
}

