// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.interfaces.DSAPrivateKey;
import java.security.interfaces.DSAPublicKey;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.DSAParameters;
import org.bouncycastle.crypto.params.DSAPrivateKeyParameters;
import org.bouncycastle.crypto.params.DSAPublicKeyParameters;

public class DSAUtil {
    static {
        DSAUtil.dsaOids = new ASN1ObjectIdentifier[]{X9ObjectIdentifiers.id_dsa, OIWObjectIdentifiers.dsaWithSHA1};
    }

    public DSAUtil() {
        super();
    }

    public static AsymmetricKeyParameter generatePrivateKeyParameter(PrivateKey arg6) {
        if((arg6 instanceof DSAPrivateKey)) {
            return new DSAPrivateKeyParameters(((DSAPrivateKey)arg6).getX(), new DSAParameters(((DSAPrivateKey)arg6).getParams().getP(), ((DSAPrivateKey)arg6).getParams().getQ(), ((DSAPrivateKey)arg6).getParams().getG()));
        }

        throw new InvalidKeyException("can\'t identify DSA private key.");
    }

    public static AsymmetricKeyParameter generatePublicKeyParameter(PublicKey arg6) {
        if((arg6 instanceof DSAPublicKey)) {
            return new DSAPublicKeyParameters(((DSAPublicKey)arg6).getY(), new DSAParameters(((DSAPublicKey)arg6).getParams().getP(), ((DSAPublicKey)arg6).getParams().getQ(), ((DSAPublicKey)arg6).getParams().getG()));
        }

        throw new InvalidKeyException("can\'t identify DSA public key: " + arg6.getClass().getName());
    }

    public static boolean isDsaOid(ASN1ObjectIdentifier arg3) {
        boolean v1 = false;
        int v0 = 0;
        while(v0 != DSAUtil.dsaOids.length) {
            if(arg3.equals(DSAUtil.dsaOids[v0])) {
                v1 = true;
            }
            else {
                ++v0;
                continue;
            }

            return v1;
        }

        return v1;
    }
}

