// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.interfaces.DSAPrivateKey;
import java.security.interfaces.DSAPublicKey;
import java.security.spec.DSAPrivateKeySpec;
import java.security.spec.DSAPublicKeySpec;
import java.security.spec.KeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseKeyFactorySpi;

public class KeyFactorySpi extends BaseKeyFactorySpi {
    public KeyFactorySpi() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg2) {
        BCDSAPrivateKey v0;
        if((arg2 instanceof DSAPrivateKeySpec)) {
            v0 = new BCDSAPrivateKey(((DSAPrivateKeySpec)arg2));
        }
        else {
            PrivateKey v0_1 = super.engineGeneratePrivate(arg2);
        }

        return ((PrivateKey)v0);
    }

    protected PublicKey engineGeneratePublic(KeySpec arg2) {
        PublicKey v0_1;
        if((arg2 instanceof DSAPublicKeySpec)) {
            BCDSAPublicKey v0 = new BCDSAPublicKey(((DSAPublicKeySpec)arg2));
        }
        else {
            v0_1 = super.engineGeneratePublic(arg2);
        }

        return v0_1;
    }

    protected KeySpec engineGetKeySpec(Key arg6, Class arg7) {
        KeySpec v0_2;
        if(!arg7.isAssignableFrom(DSAPublicKeySpec.class) || !(arg6 instanceof DSAPublicKey)) {
            if((arg7.isAssignableFrom(DSAPrivateKeySpec.class)) && ((arg6 instanceof DSAPrivateKey))) {
                DSAPrivateKeySpec v0_1 = new DSAPrivateKeySpec(((DSAPrivateKey)arg6).getX(), ((DSAPrivateKey)arg6).getParams().getP(), ((DSAPrivateKey)arg6).getParams().getQ(), ((DSAPrivateKey)arg6).getParams().getG());
                return v0_2;
            }

            v0_2 = super.engineGetKeySpec(arg6, arg7);
        }
        else {
            DSAPublicKeySpec v0 = new DSAPublicKeySpec(((DSAPublicKey)arg6).getY(), ((DSAPublicKey)arg6).getParams().getP(), ((DSAPublicKey)arg6).getParams().getQ(), ((DSAPublicKey)arg6).getParams().getG());
        }

        return v0_2;
    }

    protected Key engineTranslateKey(Key arg3) {
        BCDSAPublicKey v0;
        if((arg3 instanceof DSAPublicKey)) {
            v0 = new BCDSAPublicKey(((DSAPublicKey)arg3));
        }
        else if((arg3 instanceof DSAPrivateKey)) {
            BCDSAPrivateKey v0_1 = new BCDSAPrivateKey(((DSAPrivateKey)arg3));
        }
        else {
            goto label_10;
        }

        return ((Key)v0);
    label_10:
        throw new InvalidKeyException("key type unknown");
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getPrivateKeyAlgorithm().getAlgorithm();
        if(DSAUtil.isDsaOid(v0)) {
            return new BCDSAPrivateKey(arg5);
        }

        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getAlgorithm().getAlgorithm();
        if(DSAUtil.isDsaOid(v0)) {
            return new BCDSAPublicKey(arg5);
        }

        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }
}

