// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dsa;

import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.DSAParameterSpec;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.DSAKeyPairGenerator;
import org.bouncycastle.crypto.generators.DSAParametersGenerator;
import org.bouncycastle.crypto.params.DSAKeyGenerationParameters;
import org.bouncycastle.crypto.params.DSAParameters;

public class KeyPairGeneratorSpi extends KeyPairGenerator {
    int certainty;
    DSAKeyPairGenerator engine;
    boolean initialised;
    DSAKeyGenerationParameters param;
    SecureRandom random;
    int strength;

    public KeyPairGeneratorSpi() {
        super("DSA");
        this.engine = new DSAKeyPairGenerator();
        this.strength = 1024;
        this.certainty = 20;
        this.random = new SecureRandom();
        this.initialised = false;
    }

    public KeyPair generateKeyPair() {
        if(!this.initialised) {
            DSAParametersGenerator v0 = new DSAParametersGenerator();
            v0.init(this.strength, this.certainty, this.random);
            this.param = new DSAKeyGenerationParameters(this.random, v0.generateParameters());
            this.engine.init(this.param);
            this.initialised = true;
        }

        AsymmetricCipherKeyPair v1 = this.engine.generateKeyPair();
        return new KeyPair(new BCDSAPublicKey(v1.getPublic()), new BCDSAPrivateKey(v1.getPrivate()));
    }

    public void initialize(int arg3, SecureRandom arg4) {
        if(arg3 >= 512 && arg3 <= 1024 && arg3 % 64 == 0) {
            this.strength = arg3;
            this.random = arg4;
            return;
        }

        throw new InvalidParameterException("strength must be from 512 - 1024 and a multiple of 64");
    }

    public void initialize(AlgorithmParameterSpec arg6, SecureRandom arg7) {
        if(!(arg6 instanceof DSAParameterSpec)) {
            throw new InvalidAlgorithmParameterException("parameter object not a DSAParameterSpec");
        }

        this.param = new DSAKeyGenerationParameters(arg7, new DSAParameters(((DSAParameterSpec)arg6).getP(), ((DSAParameterSpec)arg6).getQ(), ((DSAParameterSpec)arg6).getG()));
        this.engine.init(this.param);
        this.initialised = true;
    }
}

