// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dstu;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.ECPublicKey;
import java.security.spec.ECParameterSpec;
import java.security.spec.ECPublicKeySpec;
import java.security.spec.EllipticCurve;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.ua.DSTU4145BinaryField;
import org.bouncycastle.asn1.ua.DSTU4145ECBinary;
import org.bouncycastle.asn1.ua.DSTU4145NamedCurves;
import org.bouncycastle.asn1.ua.DSTU4145Params;
import org.bouncycastle.asn1.ua.DSTU4145PointEncoder;
import org.bouncycastle.asn1.ua.UAObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ECPoint;
import org.bouncycastle.asn1.x9.X9IntegerConverter;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jce.interfaces.ECPointEncoder;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECNamedCurveParameterSpec;
import org.bouncycastle.jce.spec.ECNamedCurveSpec;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECCurve$F2m;
import org.bouncycastle.math.ec.ECPoint;
import org.bouncycastle.math.ec.ECPoint$F2m;
import org.bouncycastle.math.ec.ECPoint$Fp;

public class BCDSTU4145PublicKey implements ECPublicKey, ECPointEncoder, org.bouncycastle.jce.interfaces.ECPublicKey {
    private String algorithm;
    private transient DSTU4145Params dstuParams;
    private transient ECParameterSpec ecSpec;
    private transient ECPoint q;
    static final long serialVersionUID = 7026240464295649314L;
    private boolean withCompression;

    public BCDSTU4145PublicKey(String arg2, ECPublicKeyParameters arg3) {
        super();
        this.algorithm = "DSTU4145";
        this.algorithm = arg2;
        this.q = arg3.getQ();
        this.ecSpec = null;
    }

    public BCDSTU4145PublicKey(String arg4, ECPublicKeyParameters arg5, ECParameterSpec arg6) {
        super();
        this.algorithm = "DSTU4145";
        ECDomainParameters v0 = arg5.getParameters();
        this.algorithm = arg4;
        this.q = arg5.getQ();
        this.ecSpec = arg6 == null ? this.createSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), v0) : arg6;
    }

    public BCDSTU4145PublicKey(String arg4, ECPublicKeyParameters arg5, org.bouncycastle.jce.spec.ECParameterSpec arg6) {
        super();
        this.algorithm = "DSTU4145";
        ECDomainParameters v0 = arg5.getParameters();
        this.algorithm = arg4;
        this.q = arg5.getQ();
        this.ecSpec = arg6 == null ? this.createSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), v0) : EC5Util.convertSpec(EC5Util.convertCurve(arg6.getCurve(), arg6.getSeed()), arg6);
    }

    public BCDSTU4145PublicKey(ECPublicKey arg4) {
        super();
        this.algorithm = "DSTU4145";
        this.algorithm = arg4.getAlgorithm();
        this.ecSpec = arg4.getParams();
        this.q = EC5Util.convertPoint(this.ecSpec, arg4.getW(), false);
    }

    public BCDSTU4145PublicKey(ECPublicKeySpec arg4) {
        super();
        this.algorithm = "DSTU4145";
        this.ecSpec = arg4.getParams();
        this.q = EC5Util.convertPoint(this.ecSpec, arg4.getW(), false);
    }

    BCDSTU4145PublicKey(SubjectPublicKeyInfo arg2) {
        super();
        this.algorithm = "DSTU4145";
        this.populateFromPubKeyInfo(arg2);
    }

    public BCDSTU4145PublicKey(BCDSTU4145PublicKey arg2) {
        super();
        this.algorithm = "DSTU4145";
        this.q = arg2.q;
        this.ecSpec = arg2.ecSpec;
        this.withCompression = arg2.withCompression;
        this.dstuParams = arg2.dstuParams;
    }

    public BCDSTU4145PublicKey(org.bouncycastle.jce.spec.ECPublicKeySpec arg5) {
        super();
        this.algorithm = "DSTU4145";
        this.q = arg5.getQ();
        if(arg5.getParams() != null) {
            this.ecSpec = EC5Util.convertSpec(EC5Util.convertCurve(arg5.getParams().getCurve(), arg5.getParams().getSeed()), arg5.getParams());
        }
        else {
            if(this.q.getCurve() == null) {
                this.q = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getCurve().createPoint(this.q.getX().toBigInteger(), this.q.getY().toBigInteger(), false);
            }

            this.ecSpec = null;
        }
    }

    private ECParameterSpec createSpec(EllipticCurve arg5, ECDomainParameters arg6) {
        return new ECParameterSpec(arg5, new java.security.spec.ECPoint(arg6.getG().getX().toBigInteger(), arg6.getG().getY().toBigInteger()), arg6.getN(), arg6.getH().intValue());
    }

    public ECPoint engineGetQ() {
        return this.q;
    }

    org.bouncycastle.jce.spec.ECParameterSpec engineGetSpec() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec != null ? EC5Util.convertSpec(this.ecSpec, this.withCompression) : BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa();
        return v0;
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof BCDSTU4145PublicKey)) && (this.engineGetQ().equals(((BCDSTU4145PublicKey)arg4).engineGetQ())) && (this.engineGetSpec().equals(((BCDSTU4145PublicKey)arg4).engineGetSpec()))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return this.algorithm;
    }

    public byte[] getEncoded() {
        X962Parameters v1_1;
        SubjectPublicKeyInfo v0_3;
        X962Parameters v0_1;
        ECCurve v1;
        DSTU4145Params v0;
        if(this.algorithm.equals("DSTU4145")) {
            if(this.dstuParams != null) {
                v0 = this.dstuParams;
            }
            else if((this.ecSpec instanceof ECNamedCurveSpec)) {
                v0 = new DSTU4145Params(new ASN1ObjectIdentifier(this.ecSpec.getName()));
            }
            else {
                v1 = EC5Util.convertCurve(this.ecSpec.getCurve());
                v0_1 = new X962Parameters(new X9ECParameters(v1, EC5Util.convertPoint(v1, this.ecSpec.getGenerator(), this.withCompression), this.ecSpec.getOrder(), BigInteger.valueOf(((long)this.ecSpec.getCofactor())), this.ecSpec.getCurve().getSeed()));
            }

            byte[] v2 = DSTU4145PointEncoder.encodePoint(this.q);
            try {
                v0_3 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(UAObjectIdentifiers.dstu4145be, ((ASN1Encodable)v0_1)), new DEROctetString(v2));
            }
            catch(IOException v0_2) {
                byte[] v0_4 = null;
                return v0_4;
            }
        }
        else {
            if((this.ecSpec instanceof ECNamedCurveSpec)) {
                ASN1ObjectIdentifier v0_5 = ECUtil.getNamedCurveOid(this.ecSpec.getName());
                if(v0_5 == null) {
                    v0_5 = new ASN1ObjectIdentifier(this.ecSpec.getName());
                }

                v1_1 = new X962Parameters(v0_5);
            }
            else {
                if(this.ecSpec == null) {
                    v1_1 = new X962Parameters(DERNull.INSTANCE);
                    goto label_69;
                }

                v1 = EC5Util.convertCurve(this.ecSpec.getCurve());
                v1_1 = new X962Parameters(new X9ECParameters(v1, EC5Util.convertPoint(v1, this.ecSpec.getGenerator(), this.withCompression), this.ecSpec.getOrder(), BigInteger.valueOf(((long)this.ecSpec.getCofactor())), this.ecSpec.getCurve().getSeed()));
            }

        label_69:
            v0_3 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, ((ASN1Encodable)v1_1)), new X9ECPoint(this.engineGetQ().getCurve().createPoint(this.getQ().getX().toBigInteger(), this.getQ().getY().toBigInteger(), this.withCompression)).toASN1Primitive().getOctets());
        }

        return KeyUtil.getEncodedSubjectPublicKeyInfo(v0_3);
    }

    public String getFormat() {
        return "X.509";
    }

    public org.bouncycastle.jce.spec.ECParameterSpec getParameters() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec == null ? null : EC5Util.convertSpec(this.ecSpec, this.withCompression);
        return v0;
    }

    public ECParameterSpec getParams() {
        return this.ecSpec;
    }

    public ECPoint getQ() {
        ECPoint$F2m v0_1;
        ECCurve v3 = null;
        if(this.ecSpec != null) {
            ECPoint v0_2 = this.q;
        }
        else if((this.q instanceof ECPoint$Fp)) {
            ECPoint$Fp v0 = new ECPoint$Fp(v3, this.q.getX(), this.q.getY());
        }
        else {
            v0_1 = new ECPoint$F2m(v3, this.q.getX(), this.q.getY());
        }

        return ((ECPoint)v0_1);
    }

    public byte[] getSbox() {
        byte[] v0 = this.dstuParams != null ? this.dstuParams.getDKE() : DSTU4145Params.getDefaultDKE();
        return v0;
    }

    public java.security.spec.ECPoint getW() {
        return new java.security.spec.ECPoint(this.q.getX().toBigInteger(), this.q.getY().toBigInteger());
    }

    public int hashCode() {
        return this.engineGetQ().hashCode() ^ this.engineGetSpec().hashCode();
    }

    private void populateFromPubKeyInfo(SubjectPublicKeyInfo arg12) {
        byte[] v2;
        ECCurve v0;
        ECCurve v1_2;
        ECNamedCurveParameterSpec v5_1;
        byte[] v7;
        int v8 = 2;
        if((arg12.getAlgorithm().getAlgorithm().equals(UAObjectIdentifiers.dstu4145be)) || (arg12.getAlgorithm().getAlgorithm().equals(UAObjectIdentifiers.dstu4145le))) {
            DERBitString v0_4 = arg12.getPublicKeyData();
            this.algorithm = "DSTU4145";
            try {
                v7 = ASN1Primitive.fromByteArray(v0_4.getBytes()).getOctets();
            }
            catch(IOException v0_2) {
                throw new IllegalArgumentException("error recovering public key");
            }

            if(arg12.getAlgorithm().getAlgorithm().equals(UAObjectIdentifiers.dstu4145le)) {
                this.reverseBytes(v7);
            }

            this.dstuParams = DSTU4145Params.getInstance(arg12.getAlgorithm().getParameters());
            if(this.dstuParams.isNamedCurve()) {
                ASN1ObjectIdentifier v1_4 = this.dstuParams.getNamedCurve();
                ECDomainParameters v6_1 = DSTU4145NamedCurves.getByOID(v1_4);
                v5_1 = new ECNamedCurveParameterSpec(v1_4.getId(), v6_1.getCurve(), v6_1.getG(), v6_1.getN(), v6_1.getH(), v6_1.getSeed());
            }
            else {
                DSTU4145ECBinary v8_1 = this.dstuParams.getECBinary();
                byte[] v9 = v8_1.getB();
                if(arg12.getAlgorithm().getAlgorithm().equals(UAObjectIdentifiers.dstu4145le)) {
                    this.reverseBytes(v9);
                }

                DSTU4145BinaryField v4 = v8_1.getField();
                ECCurve$F2m v0_5 = new ECCurve$F2m(v4.getM(), v4.getK1(), v4.getK2(), v4.getK3(), v8_1.getA(), new BigInteger(1, v9));
                v2 = v8_1.getG();
                if(arg12.getAlgorithm().getAlgorithm().equals(UAObjectIdentifiers.dstu4145le)) {
                    this.reverseBytes(v2);
                }

                org.bouncycastle.jce.spec.ECParameterSpec v5_2 = new org.bouncycastle.jce.spec.ECParameterSpec(((ECCurve)v0_5), DSTU4145PointEncoder.decodePoint(((ECCurve)v0_5), v2), v8_1.getN());
            }

            v0 = ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getCurve();
            EllipticCurve v2_1 = EC5Util.convertCurve(v0, ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getSeed());
            this.q = DSTU4145PointEncoder.decodePoint(v0, v7);
            if(this.dstuParams.isNamedCurve()) {
                this.ecSpec = new ECNamedCurveSpec(this.dstuParams.getNamedCurve().getId(), v2_1, new java.security.spec.ECPoint(((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getG().getX().toBigInteger(), ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getG().getY().toBigInteger()), ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getN(), ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getH());
                return;
            }

            this.ecSpec = new ECParameterSpec(v2_1, new java.security.spec.ECPoint(((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getG().getX().toBigInteger(), ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getG().getY().toBigInteger()), ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getN(), ((org.bouncycastle.jce.spec.ECParameterSpec)v5_1).getH().intValue());
        }
        else {
            X962Parameters v1 = new X962Parameters(arg12.getAlgorithm().getParameters());
            if(v1.isNamedCurve()) {
                ASN1Primitive v1_1 = v1.getParameters();
                X9ECParameters v5 = ECUtil.getNamedCurveByOid(((ASN1ObjectIdentifier)v1_1));
                ECCurve v6 = v5.getCurve();
                this.ecSpec = new ECNamedCurveSpec(ECUtil.getCurveName(((ASN1ObjectIdentifier)v1_1)), EC5Util.convertCurve(v6, v5.getSeed()), new java.security.spec.ECPoint(v5.getG().getX().toBigInteger(), v5.getG().getY().toBigInteger()), v5.getN(), v5.getH());
                v1_2 = v6;
            }
            else if(v1.isImplicitlyCA()) {
                this.ecSpec = null;
                v1_2 = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getCurve();
            }
            else {
                X9ECParameters v1_3 = X9ECParameters.getInstance(v1.getParameters());
                v0 = v1_3.getCurve();
                this.ecSpec = new ECParameterSpec(EC5Util.convertCurve(v0, v1_3.getSeed()), new java.security.spec.ECPoint(v1_3.getG().getX().toBigInteger(), v1_3.getG().getY().toBigInteger()), v1_3.getN(), v1_3.getH().intValue());
                v1_2 = v0;
            }

            v2 = arg12.getPublicKeyData().getBytes();
            DEROctetString v0_1 = new DEROctetString(v2);
            if(v2[0] == 4 && v2[1] == v2.length - 2) {
                if(v2[v8] != v8 && v2[v8] != 3) {
                    goto label_171;
                }

                if(new X9IntegerConverter().getByteLength(v1_2) < v2.length - 3) {
                    goto label_171;
                }

                try {
                    ASN1Primitive v0_3 = ASN1Primitive.fromByteArray(v2);
                label_171:
                    goto label_172;
                }
                catch(IOException v0_2) {
                    throw new IllegalArgumentException("error recovering public key");
                }
            }

            goto label_171;
        label_172:
            this.q = new X9ECPoint(v1_2, ((ASN1OctetString)v0_1)).getPoint();
        }
    }

    private void readObject(ObjectInputStream arg2) {
        arg2.defaultReadObject();
        this.populateFromPubKeyInfo(SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg2.readObject())));
    }

    private void reverseBytes(byte[] arg4) {
        int v0;
        for(v0 = 0; v0 < arg4.length / 2; ++v0) {
            byte v1 = arg4[v0];
            arg4[v0] = arg4[arg4.length - 1 - v0];
            arg4[arg4.length - 1 - v0] = v1;
        }
    }

    public void setPointFormat(String arg2) {
        boolean v0 = !"UNCOMPRESSED".equalsIgnoreCase(arg2) ? true : false;
        this.withCompression = v0;
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("EC Public Key").append(v1);
        v0.append("            X: ").append(this.q.getX().toBigInteger().toString(16)).append(v1);
        v0.append("            Y: ").append(this.q.getY().toBigInteger().toString(16)).append(v1);
        return v0.toString();
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.getEncoded());
    }
}

