// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dstu;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.interfaces.ECPrivateKey;
import java.security.interfaces.ECPublicKey;
import java.security.spec.KeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.ua.UAObjectIdentifiers;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseKeyFactorySpi;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECParameterSpec;
import org.bouncycastle.jce.spec.ECPrivateKeySpec;
import org.bouncycastle.jce.spec.ECPublicKeySpec;

public class KeyFactorySpi extends BaseKeyFactorySpi {
    public KeyFactorySpi() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg2) {
        PrivateKey v0_1;
        BCDSTU4145PrivateKey v0;
        if((arg2 instanceof ECPrivateKeySpec)) {
            v0 = new BCDSTU4145PrivateKey(((ECPrivateKeySpec)arg2));
        }
        else if((arg2 instanceof java.security.spec.ECPrivateKeySpec)) {
            v0 = new BCDSTU4145PrivateKey(((java.security.spec.ECPrivateKeySpec)arg2));
        }
        else {
            v0_1 = super.engineGeneratePrivate(arg2);
        }

        return v0_1;
    }

    protected PublicKey engineGeneratePublic(KeySpec arg2) {
        BCDSTU4145PublicKey v0;
        if((arg2 instanceof ECPublicKeySpec)) {
            v0 = new BCDSTU4145PublicKey(((ECPublicKeySpec)arg2));
        }
        else if((arg2 instanceof java.security.spec.ECPublicKeySpec)) {
            v0 = new BCDSTU4145PublicKey(((java.security.spec.ECPublicKeySpec)arg2));
        }
        else {
            PublicKey v0_1 = super.engineGeneratePublic(arg2);
        }

        return ((PublicKey)v0);
    }

    protected KeySpec engineGetKeySpec(Key arg6, Class arg7) {
        ECParameterSpec v1;
        java.security.spec.ECPublicKeySpec v0;
        ECPrivateKeySpec v0_3;
        java.security.spec.ECPrivateKeySpec v0_1;
        if(!arg7.isAssignableFrom(java.security.spec.ECPublicKeySpec.class) || !(arg6 instanceof ECPublicKey)) {
            if((arg7.isAssignableFrom(java.security.spec.ECPrivateKeySpec.class)) && ((arg6 instanceof ECPrivateKey))) {
                if(((ECPrivateKey)arg6).getParams() != null) {
                    v0_1 = new java.security.spec.ECPrivateKeySpec(((ECPrivateKey)arg6).getS(), ((ECPrivateKey)arg6).getParams());
                }
                else {
                    v1 = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa();
                    v0_1 = new java.security.spec.ECPrivateKeySpec(((ECPrivateKey)arg6).getS(), EC5Util.convertSpec(EC5Util.convertCurve(v1.getCurve(), v1.getSeed()), v1));
                }

                goto label_12;
            }

            if((arg7.isAssignableFrom(ECPublicKeySpec.class)) && ((arg6 instanceof ECPublicKey))) {
                ECPublicKeySpec v0_2 = ((ECPublicKey)arg6).getParams() != null ? new ECPublicKeySpec(EC5Util.convertPoint(((ECPublicKey)arg6).getParams(), ((ECPublicKey)arg6).getW(), false), EC5Util.convertSpec(((ECPublicKey)arg6).getParams(), false)) : new ECPublicKeySpec(EC5Util.convertPoint(((ECPublicKey)arg6).getParams(), ((ECPublicKey)arg6).getW(), false), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa());
                goto label_12;
            }

            if((arg7.isAssignableFrom(ECPrivateKeySpec.class)) && ((arg6 instanceof ECPrivateKey))) {
                v0_3 = ((ECPrivateKey)arg6).getParams() != null ? new ECPrivateKeySpec(((ECPrivateKey)arg6).getS(), EC5Util.convertSpec(((ECPrivateKey)arg6).getParams(), false)) : new ECPrivateKeySpec(((ECPrivateKey)arg6).getS(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa());
                goto label_12;
            }

            KeySpec v0_4 = super.engineGetKeySpec(arg6, arg7);
        }
        else if(((ECPublicKey)arg6).getParams() != null) {
            v0 = new java.security.spec.ECPublicKeySpec(((ECPublicKey)arg6).getW(), ((ECPublicKey)arg6).getParams());
        }
        else {
            v1 = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa();
            v0 = new java.security.spec.ECPublicKeySpec(((ECPublicKey)arg6).getW(), EC5Util.convertSpec(EC5Util.convertCurve(v1.getCurve(), v1.getSeed()), v1));
        }

    label_12:
        return ((KeySpec)v0_3);
    }

    protected Key engineTranslateKey(Key arg3) {
        throw new InvalidKeyException("key type unknown");
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getPrivateKeyAlgorithm().getAlgorithm();
        if(!v0.equals(UAObjectIdentifiers.dstu4145le) && !v0.equals(UAObjectIdentifiers.dstu4145be)) {
            throw new IOException("algorithm identifier " + v0 + " in key not recognised");
        }

        return new BCDSTU4145PrivateKey(arg5);
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getAlgorithm().getAlgorithm();
        if(!v0.equals(UAObjectIdentifiers.dstu4145le) && !v0.equals(UAObjectIdentifiers.dstu4145be)) {
            throw new IOException("algorithm identifier " + v0 + " in key not recognised");
        }

        return new BCDSTU4145PublicKey(arg5);
    }
}

