// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.dstu;

import java.math.BigInteger;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SignatureException;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.GOST3411Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.signers.DSTU4145Signer;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jce.interfaces.ECKey;
import org.bouncycastle.jce.interfaces.ECPublicKey;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class SignatureSpi extends java.security.SignatureSpi implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    private static byte[] DEFAULT_SBOX;
    private Digest digest;
    private DSA signer;

    static {
        SignatureSpi.DEFAULT_SBOX = new byte[]{10, 9, 13, 6, 14, 11, 4, 5, 15, 1, 3, 12, 7, 0, 8, 2, 8, 0, 12, 4, 9, 6, 7, 11, 2, 3, 1, 15, 5, 14, 10, 13, 15, 6, 5, 8, 14, 11, 10, 4, 12, 0, 3, 7, 2, 9, 1, 13, 3, 8, 13, 9, 6, 11, 15, 0, 2, 5, 12, 10, 4, 14, 1, 7, 15, 8, 14, 9, 7, 2, 0, 13, 12, 6, 1, 5, 11, 4, 3, 10, 2, 8, 9, 7, 5, 15, 0, 11, 12, 1, 13, 14, 10, 3, 6, 4, 3, 8, 11, 5, 6, 4, 14, 10, 2, 12, 1, 7, 9, 15, 13, 0, 1, 2, 3, 14, 6, 13, 11, 8, 15, 10, 12, 5, 7, 9, 0, 4};
    }

    public SignatureSpi() {
        super();
        this.signer = new DSTU4145Signer();
    }

    protected Object engineGetParameter(String arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineInitSign(PrivateKey arg6) {
        CipherParameters v0 = null;
        if((arg6 instanceof ECKey)) {
            AsymmetricKeyParameter v0_1 = ECUtil.generatePrivateKeyParameter(arg6);
        }

        this.digest = new GOST3411Digest(SignatureSpi.DEFAULT_SBOX);
        if(this.appRandom != null) {
            this.signer.init(true, new ParametersWithRandom(v0, this.appRandom));
        }
        else {
            this.signer.init(true, v0);
        }
    }

    protected void engineInitVerify(PublicKey arg4) {
        PublicKey v0;
        AsymmetricKeyParameter v1;
        if((arg4 instanceof ECPublicKey)) {
            v1 = ECUtil.generatePublicKeyParameter(arg4);
            v0 = arg4;
        }
        else {
            try {
                arg4 = BouncyCastleProvider.getPublicKey(SubjectPublicKeyInfo.getInstance(arg4.getEncoded()));
                if((arg4 instanceof ECPublicKey)) {
                    v1 = ECUtil.generatePublicKeyParameter(arg4);
                    v0 = arg4;
                }
                else {
                    goto label_23;
                }
            }
            catch(Exception v0_1) {
                goto label_31;
            }
        }

        this.digest = new GOST3411Digest(this.expandSbox(((BCDSTU4145PublicKey)v0).getSbox()));
        this.signer.init(false, ((CipherParameters)v1));
        return;
        try {
        label_23:
            throw new InvalidKeyException("can\'t recognise key type in DSA based signer");
        }
        catch(Exception v0_1) {
        label_31:
            throw new InvalidKeyException("can\'t recognise key type in DSA based signer");
        }
    }

    protected void engineSetParameter(String arg3, Object arg4) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(AlgorithmParameterSpec arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected byte[] engineSign() {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            BigInteger[] v0_2 = this.signer.generateSignature(v0);
            byte[] v1 = v0_2[0].toByteArray();
            byte[] v2 = v0_2[1].toByteArray();
            int v0_3 = v1.length > v2.length ? v1.length * 2 : v2.length * 2;
            v0 = new byte[v0_3];
            System.arraycopy(v2, 0, v0, v0.length / 2 - v2.length, v2.length);
            System.arraycopy(v1, 0, v0, v0.length - v1.length, v1.length);
            return new DEROctetString(v0).getEncoded();
        }
        catch(Exception v0_1) {
            throw new SignatureException(v0_1.toString());
        }
    }

    protected void engineUpdate(byte arg2) {
        this.digest.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    protected boolean engineVerify(byte[] arg10) {
        BigInteger[] v0_2;
        byte[] v1 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v1, 0);
        try {
            byte[] v0_1 = ASN1OctetString.fromByteArray(arg10).getOctets();
            byte[] v2 = new byte[v0_1.length / 2];
            byte[] v3 = new byte[v0_1.length / 2];
            System.arraycopy(v0_1, 0, v3, 0, v0_1.length / 2);
            System.arraycopy(v0_1, v0_1.length / 2, v2, 0, v0_1.length / 2);
            v0_2 = new BigInteger[]{new BigInteger(1, v2), new BigInteger(1, v3)};
        }
        catch(Exception v0) {
            throw new SignatureException("error decoding signature bytes.");
        }

        return this.signer.verifySignature(v1, v0_2[0], v0_2[1]);
    }

    byte[] expandSbox(byte[] arg5) {
        byte[] v1 = new byte[128];
        int v0;
        for(v0 = 0; v0 < arg5.length; ++v0) {
            v1[v0 * 2] = ((byte)(arg5[v0] >> 4 & 15));
            v1[v0 * 2 + 1] = ((byte)(arg5[v0] & 15));
        }

        return v1;
    }
}

