// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ec;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.ECPrivateKey;
import java.security.spec.ECParameterSpec;
import java.security.spec.ECPoint;
import java.security.spec.ECPrivateKeySpec;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.cryptopro.ECGOST3410NamedCurves;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jcajce.provider.config.ProviderConfiguration;
import org.bouncycastle.jce.interfaces.ECPointEncoder;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECNamedCurveSpec;
import org.bouncycastle.math.ec.ECCurve;

public class BCECPrivateKey implements ECPrivateKey, ECPointEncoder, org.bouncycastle.jce.interfaces.ECPrivateKey, PKCS12BagAttributeCarrier {
    private String algorithm;
    private transient PKCS12BagAttributeCarrierImpl attrCarrier;
    private transient ProviderConfiguration configuration;
    private transient BigInteger d;
    private transient ECParameterSpec ecSpec;
    private transient DERBitString publicKey;
    static final long serialVersionUID = 994553197664784084L;
    private boolean withCompression;

    protected BCECPrivateKey() {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public BCECPrivateKey(String arg2, ECPrivateKeySpec arg3, ProviderConfiguration arg4) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.algorithm = arg2;
        this.d = arg3.getS();
        this.ecSpec = arg3.getParams();
        this.configuration = arg4;
    }

    BCECPrivateKey(String arg2, PrivateKeyInfo arg3, ProviderConfiguration arg4) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.algorithm = arg2;
        this.configuration = arg4;
        this.populateFromPrivKeyInfo(arg3);
    }

    public BCECPrivateKey(String arg7, ECPrivateKeyParameters arg8, BCECPublicKey arg9, ECParameterSpec arg10, ProviderConfiguration arg11) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        ECDomainParameters v0 = arg8.getParameters();
        this.algorithm = arg7;
        this.d = arg8.getD();
        this.configuration = arg11;
        this.ecSpec = arg10 == null ? new ECParameterSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), new ECPoint(v0.getG().getX().toBigInteger(), v0.getG().getY().toBigInteger()), v0.getN(), v0.getH().intValue()) : arg10;
        this.publicKey = this.getPublicKeyDetails(arg9);
    }

    public BCECPrivateKey(String arg7, ECPrivateKeyParameters arg8, BCECPublicKey arg9, org.bouncycastle.jce.spec.ECParameterSpec arg10, ProviderConfiguration arg11) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        ECDomainParameters v0 = arg8.getParameters();
        this.algorithm = arg7;
        this.d = arg8.getD();
        this.configuration = arg11;
        this.ecSpec = arg10 == null ? new ECParameterSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), new ECPoint(v0.getG().getX().toBigInteger(), v0.getG().getY().toBigInteger()), v0.getN(), v0.getH().intValue()) : new ECParameterSpec(EC5Util.convertCurve(arg10.getCurve(), arg10.getSeed()), new ECPoint(arg10.getG().getX().toBigInteger(), arg10.getG().getY().toBigInteger()), arg10.getN(), arg10.getH().intValue());
        this.publicKey = this.getPublicKeyDetails(arg9);
    }

    public BCECPrivateKey(String arg2, ECPrivateKeyParameters arg3, ProviderConfiguration arg4) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.algorithm = arg2;
        this.d = arg3.getD();
        this.ecSpec = null;
        this.configuration = arg4;
    }

    public BCECPrivateKey(String arg2, BCECPrivateKey arg3) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.algorithm = arg2;
        this.d = arg3.d;
        this.ecSpec = arg3.ecSpec;
        this.withCompression = arg3.withCompression;
        this.attrCarrier = arg3.attrCarrier;
        this.publicKey = arg3.publicKey;
        this.configuration = arg3.configuration;
    }

    public BCECPrivateKey(String arg3, org.bouncycastle.jce.spec.ECPrivateKeySpec arg4, ProviderConfiguration arg5) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.algorithm = arg3;
        this.d = arg4.getD();
        this.ecSpec = arg4.getParams() != null ? EC5Util.convertSpec(EC5Util.convertCurve(arg4.getParams().getCurve(), arg4.getParams().getSeed()), arg4.getParams()) : null;
        this.configuration = arg5;
    }

    public BCECPrivateKey(ECPrivateKey arg2, ProviderConfiguration arg3) {
        super();
        this.algorithm = "EC";
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.d = arg2.getS();
        this.algorithm = arg2.getAlgorithm();
        this.ecSpec = arg2.getParams();
        this.configuration = arg3;
    }

    org.bouncycastle.jce.spec.ECParameterSpec engineGetSpec() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec != null ? EC5Util.convertSpec(this.ecSpec, this.withCompression) : this.configuration.getEcImplicitlyCa();
        return v0;
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof BCECPrivateKey)) && (this.getD().equals(((BCECPrivateKey)arg4).getD())) && (this.engineGetSpec().equals(((BCECPrivateKey)arg4).engineGetSpec()))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return this.algorithm;
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public BigInteger getD() {
        return this.d;
    }

    public byte[] getEncoded() {
        byte[] v0_5;
        X962Parameters v0_2;
        if((this.ecSpec instanceof ECNamedCurveSpec)) {
            ASN1ObjectIdentifier v0 = ECUtil.getNamedCurveOid(this.ecSpec.getName());
            if(v0 == null) {
                DERObjectIdentifier v0_1 = new DERObjectIdentifier(this.ecSpec.getName());
            }

            v0_2 = new X962Parameters(((ASN1Primitive)v0));
        }
        else {
            if(this.ecSpec == null) {
                v0_2 = new X962Parameters(DERNull.INSTANCE);
                goto label_15;
            }

            ECCurve v1 = EC5Util.convertCurve(this.ecSpec.getCurve());
            v0_2 = new X962Parameters(new X9ECParameters(v1, EC5Util.convertPoint(v1, this.ecSpec.getGenerator(), this.withCompression), this.ecSpec.getOrder(), BigInteger.valueOf(((long)this.ecSpec.getCofactor())), this.ecSpec.getCurve().getSeed()));
        }

    label_15:
        org.bouncycastle.asn1.sec.ECPrivateKey v2 = this.publicKey != null ? new org.bouncycastle.asn1.sec.ECPrivateKey(this.getS(), this.publicKey, ((ASN1Object)v0_2)) : new org.bouncycastle.asn1.sec.ECPrivateKey(this.getS(), ((ASN1Object)v0_2));
        try {
            PrivateKeyInfo v0_4 = this.algorithm.equals("ECGOST3410") ? new PrivateKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_2001, v0_2.toASN1Primitive()), v2.toASN1Primitive()) : new PrivateKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, v0_2.toASN1Primitive()), v2.toASN1Primitive());
            v0_5 = v0_4.getEncoded("DER");
        }
        catch(IOException v0_3) {
            v0_5 = null;
        }

        return v0_5;
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public org.bouncycastle.jce.spec.ECParameterSpec getParameters() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec == null ? null : EC5Util.convertSpec(this.ecSpec, this.withCompression);
        return v0;
    }

    public ECParameterSpec getParams() {
        return this.ecSpec;
    }

    private DERBitString getPublicKeyDetails(BCECPublicKey arg2) {
        DERBitString v0_1;
        try {
            v0_1 = SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg2.getEncoded())).getPublicKeyData();
        }
        catch(IOException v0) {
            v0_1 = null;
        }

        return v0_1;
    }

    public BigInteger getS() {
        return this.d;
    }

    public int hashCode() {
        return this.getD().hashCode() ^ this.engineGetSpec().hashCode();
    }

    private void populateFromPrivKeyInfo(PrivateKeyInfo arg8) {
        X962Parameters v0 = X962Parameters.getInstance(arg8.getPrivateKeyAlgorithm().getParameters());
        if(v0.isNamedCurve()) {
            ASN1ObjectIdentifier v1 = ASN1ObjectIdentifier.getInstance(v0.getParameters());
            X9ECParameters v5 = ECUtil.getNamedCurveByOid(v1);
            if(v5 == null) {
                ECDomainParameters v5_1 = ECGOST3410NamedCurves.getByOID(v1);
                this.ecSpec = new ECNamedCurveSpec(ECGOST3410NamedCurves.getName(v1), EC5Util.convertCurve(v5_1.getCurve(), v5_1.getSeed()), new ECPoint(v5_1.getG().getX().toBigInteger(), v5_1.getG().getY().toBigInteger()), v5_1.getN(), v5_1.getH());
            }
            else {
                this.ecSpec = new ECNamedCurveSpec(ECUtil.getCurveName(v1), EC5Util.convertCurve(v5.getCurve(), v5.getSeed()), new ECPoint(v5.getG().getX().toBigInteger(), v5.getG().getY().toBigInteger()), v5.getN(), v5.getH());
            }
        }
        else if(v0.isImplicitlyCA()) {
            this.ecSpec = null;
        }
        else {
            X9ECParameters v0_1 = X9ECParameters.getInstance(v0.getParameters());
            this.ecSpec = new ECParameterSpec(EC5Util.convertCurve(v0_1.getCurve(), v0_1.getSeed()), new ECPoint(v0_1.getG().getX().toBigInteger(), v0_1.getG().getY().toBigInteger()), v0_1.getN(), v0_1.getH().intValue());
        }

        ASN1Encodable v0_2 = arg8.parsePrivateKey();
        if((v0_2 instanceof DERInteger)) {
            this.d = DERInteger.getInstance(v0_2).getValue();
        }
        else {
            org.bouncycastle.asn1.sec.ECPrivateKey v0_3 = org.bouncycastle.asn1.sec.ECPrivateKey.getInstance(v0_2);
            this.d = v0_3.getKey();
            this.publicKey = v0_3.getPublicKey();
        }
    }

    private void readObject(ObjectInputStream arg2) {
        arg2.defaultReadObject();
        this.populateFromPrivKeyInfo(PrivateKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg2.readObject())));
        this.configuration = BouncyCastleProvider.CONFIGURATION;
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    public void setPointFormat(String arg2) {
        boolean v0 = !"UNCOMPRESSED".equalsIgnoreCase(arg2) ? true : false;
        this.withCompression = v0;
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("EC Private Key").append(v1);
        v0.append("             S: ").append(this.d.toString(16)).append(v1);
        return v0.toString();
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.getEncoded());
    }
}

