// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ec;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.ECPublicKey;
import java.security.spec.ECParameterSpec;
import java.security.spec.ECPublicKeySpec;
import java.security.spec.EllipticCurve;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ECPoint;
import org.bouncycastle.asn1.x9.X9IntegerConverter;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jcajce.provider.config.ProviderConfiguration;
import org.bouncycastle.jce.interfaces.ECPointEncoder;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECNamedCurveSpec;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECPoint;
import org.bouncycastle.math.ec.ECPoint$F2m;
import org.bouncycastle.math.ec.ECPoint$Fp;

public class BCECPublicKey implements ECPublicKey, ECPointEncoder, org.bouncycastle.jce.interfaces.ECPublicKey {
    private String algorithm;
    private transient ProviderConfiguration configuration;
    private transient ECParameterSpec ecSpec;
    private transient ECPoint q;
    static final long serialVersionUID = 2422789860422731812L;
    private boolean withCompression;

    public BCECPublicKey(String arg4, ECPublicKeySpec arg5, ProviderConfiguration arg6) {
        super();
        this.algorithm = "EC";
        this.algorithm = arg4;
        this.ecSpec = arg5.getParams();
        this.q = EC5Util.convertPoint(this.ecSpec, arg5.getW(), false);
        this.configuration = arg6;
    }

    BCECPublicKey(String arg2, SubjectPublicKeyInfo arg3, ProviderConfiguration arg4) {
        super();
        this.algorithm = "EC";
        this.algorithm = arg2;
        this.configuration = arg4;
        this.populateFromPubKeyInfo(arg3);
    }

    public BCECPublicKey(String arg4, ECPublicKeyParameters arg5, ECParameterSpec arg6, ProviderConfiguration arg7) {
        super();
        this.algorithm = "EC";
        ECDomainParameters v0 = arg5.getParameters();
        this.algorithm = arg4;
        this.q = arg5.getQ();
        this.ecSpec = arg6 == null ? this.createSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), v0) : arg6;
        this.configuration = arg7;
    }

    public BCECPublicKey(String arg2, ECPublicKeyParameters arg3, ProviderConfiguration arg4) {
        super();
        this.algorithm = "EC";
        this.algorithm = arg2;
        this.q = arg3.getQ();
        this.ecSpec = null;
        this.configuration = arg4;
    }

    public BCECPublicKey(String arg4, ECPublicKeyParameters arg5, org.bouncycastle.jce.spec.ECParameterSpec arg6, ProviderConfiguration arg7) {
        super();
        this.algorithm = "EC";
        ECDomainParameters v0 = arg5.getParameters();
        this.algorithm = arg4;
        this.q = arg5.getQ();
        this.ecSpec = arg6 == null ? this.createSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), v0) : EC5Util.convertSpec(EC5Util.convertCurve(arg6.getCurve(), arg6.getSeed()), arg6);
        this.configuration = arg7;
    }

    public BCECPublicKey(String arg2, BCECPublicKey arg3) {
        super();
        this.algorithm = "EC";
        this.algorithm = arg2;
        this.q = arg3.q;
        this.ecSpec = arg3.ecSpec;
        this.withCompression = arg3.withCompression;
        this.configuration = arg3.configuration;
    }

    public BCECPublicKey(String arg5, org.bouncycastle.jce.spec.ECPublicKeySpec arg6, ProviderConfiguration arg7) {
        super();
        this.algorithm = "EC";
        this.algorithm = arg5;
        this.q = arg6.getQ();
        if(arg6.getParams() != null) {
            this.ecSpec = EC5Util.convertSpec(EC5Util.convertCurve(arg6.getParams().getCurve(), arg6.getParams().getSeed()), arg6.getParams());
        }
        else {
            if(this.q.getCurve() == null) {
                this.q = arg7.getEcImplicitlyCa().getCurve().createPoint(this.q.getX().toBigInteger(), this.q.getY().toBigInteger(), false);
            }

            this.ecSpec = null;
        }

        this.configuration = arg7;
    }

    public BCECPublicKey(ECPublicKey arg4, ProviderConfiguration arg5) {
        super();
        this.algorithm = "EC";
        this.algorithm = arg4.getAlgorithm();
        this.ecSpec = arg4.getParams();
        this.q = EC5Util.convertPoint(this.ecSpec, arg4.getW(), false);
    }

    private ECParameterSpec createSpec(EllipticCurve arg5, ECDomainParameters arg6) {
        return new ECParameterSpec(arg5, new java.security.spec.ECPoint(arg6.getG().getX().toBigInteger(), arg6.getG().getY().toBigInteger()), arg6.getN(), arg6.getH().intValue());
    }

    public ECPoint engineGetQ() {
        return this.q;
    }

    org.bouncycastle.jce.spec.ECParameterSpec engineGetSpec() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec != null ? EC5Util.convertSpec(this.ecSpec, this.withCompression) : this.configuration.getEcImplicitlyCa();
        return v0;
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof BCECPublicKey)) && (this.engineGetQ().equals(((BCECPublicKey)arg4).engineGetQ())) && (this.engineGetSpec().equals(((BCECPublicKey)arg4).engineGetSpec()))) {
            v0 = true;
        }

        return v0;
    }

    private void extractBytes(byte[] arg7, int arg8, BigInteger arg9) {
        byte[] v0;
        int v5 = 32;
        byte[] v1 = arg9.toByteArray();
        if(v1.length < v5) {
            v0 = new byte[v5];
            System.arraycopy(v1, 0, v0, v0.length - v1.length, v1.length);
        }
        else {
            v0 = v1;
        }

        int v1_1;
        for(v1_1 = 0; v1_1 != v5; ++v1_1) {
            arg7[arg8 + v1_1] = v0[v0.length - 1 - v1_1];
        }
    }

    public String getAlgorithm() {
        return this.algorithm;
    }

    public byte[] getEncoded() {
        X962Parameters v1;
        if((this.ecSpec instanceof ECNamedCurveSpec)) {
            ASN1ObjectIdentifier v0 = ECUtil.getNamedCurveOid(this.ecSpec.getName());
            if(v0 == null) {
                v0 = new ASN1ObjectIdentifier(this.ecSpec.getName());
            }

            v1 = new X962Parameters(v0);
        }
        else {
            if(this.ecSpec == null) {
                v1 = new X962Parameters(DERNull.INSTANCE);
                goto label_14;
            }

            ECCurve v1_1 = EC5Util.convertCurve(this.ecSpec.getCurve());
            v1 = new X962Parameters(new X9ECParameters(v1_1, EC5Util.convertPoint(v1_1, this.ecSpec.getGenerator(), this.withCompression), this.ecSpec.getOrder(), BigInteger.valueOf(((long)this.ecSpec.getCofactor())), this.ecSpec.getCurve().getSeed()));
        }

    label_14:
        return KeyUtil.getEncodedSubjectPublicKeyInfo(new SubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, ((ASN1Encodable)v1)), new X9ECPoint(this.engineGetQ().getCurve().createPoint(this.getQ().getX().toBigInteger(), this.getQ().getY().toBigInteger(), this.withCompression)).toASN1Primitive().getOctets()));
    }

    public String getFormat() {
        return "X.509";
    }

    public org.bouncycastle.jce.spec.ECParameterSpec getParameters() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec == null ? null : EC5Util.convertSpec(this.ecSpec, this.withCompression);
        return v0;
    }

    public ECParameterSpec getParams() {
        return this.ecSpec;
    }

    public ECPoint getQ() {
        ECPoint v0_2;
        ECCurve v3 = null;
        if(this.ecSpec != null) {
            v0_2 = this.q;
        }
        else if((this.q instanceof ECPoint$Fp)) {
            ECPoint$Fp v0 = new ECPoint$Fp(v3, this.q.getX(), this.q.getY());
        }
        else {
            ECPoint$F2m v0_1 = new ECPoint$F2m(v3, this.q.getX(), this.q.getY());
        }

        return v0_2;
    }

    public java.security.spec.ECPoint getW() {
        return new java.security.spec.ECPoint(this.q.getX().toBigInteger(), this.q.getY().toBigInteger());
    }

    public int hashCode() {
        return this.engineGetQ().hashCode() ^ this.engineGetSpec().hashCode();
    }

    private void populateFromPubKeyInfo(SubjectPublicKeyInfo arg10) {
        ECCurve v1_2;
        int v8 = 2;
        X962Parameters v1 = new X962Parameters(arg10.getAlgorithm().getParameters());
        if(v1.isNamedCurve()) {
            ASN1Primitive v1_1 = v1.getParameters();
            X9ECParameters v5 = ECUtil.getNamedCurveByOid(((ASN1ObjectIdentifier)v1_1));
            ECCurve v6 = v5.getCurve();
            this.ecSpec = new ECNamedCurveSpec(ECUtil.getCurveName(((ASN1ObjectIdentifier)v1_1)), EC5Util.convertCurve(v6, v5.getSeed()), new java.security.spec.ECPoint(v5.getG().getX().toBigInteger(), v5.getG().getY().toBigInteger()), v5.getN(), v5.getH());
            v1_2 = v6;
        }
        else if(v1.isImplicitlyCA()) {
            this.ecSpec = null;
            v1_2 = this.configuration.getEcImplicitlyCa().getCurve();
        }
        else {
            X9ECParameters v1_3 = X9ECParameters.getInstance(v1.getParameters());
            ECCurve v0 = v1_3.getCurve();
            this.ecSpec = new ECParameterSpec(EC5Util.convertCurve(v0, v1_3.getSeed()), new java.security.spec.ECPoint(v1_3.getG().getX().toBigInteger(), v1_3.getG().getY().toBigInteger()), v1_3.getN(), v1_3.getH().intValue());
            v1_2 = v0;
        }

        byte[] v2 = arg10.getPublicKeyData().getBytes();
        DEROctetString v0_1 = new DEROctetString(v2);
        if(v2[0] == 4 && v2[1] == v2.length - 2) {
            if(v2[v8] != v8 && v2[v8] != 3) {
                goto label_53;
            }

            if(new X9IntegerConverter().getByteLength(v1_2) < v2.length - 3) {
                goto label_53;
            }

            try {
                ASN1Primitive v0_3 = ASN1Primitive.fromByteArray(v2);
            label_53:
                goto label_54;
            }
            catch(IOException v0_2) {
                throw new IllegalArgumentException("error recovering public key");
            }
        }

        goto label_53;
    label_54:
        this.q = new X9ECPoint(v1_2, ((ASN1OctetString)v0_1)).getPoint();
    }

    private void readObject(ObjectInputStream arg2) {
        arg2.defaultReadObject();
        this.populateFromPubKeyInfo(SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg2.readObject())));
        this.configuration = BouncyCastleProvider.CONFIGURATION;
    }

    public void setPointFormat(String arg2) {
        boolean v0 = !"UNCOMPRESSED".equalsIgnoreCase(arg2) ? true : false;
        this.withCompression = v0;
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("EC Public Key").append(v1);
        v0.append("            X: ").append(this.q.getX().toBigInteger().toString(16)).append(v1);
        v0.append("            Y: ").append(this.q.getY().toBigInteger().toString(16)).append(v1);
        return v0.toString();
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.getEncoded());
    }
}

