// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ec;

import java.math.BigInteger;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidParameterException;
import java.security.KeyPair;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.ECGenParameterSpec;
import java.util.Hashtable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.nist.NISTNamedCurves;
import org.bouncycastle.asn1.sec.SECNamedCurves;
import org.bouncycastle.asn1.teletrust.TeleTrusTNamedCurves;
import org.bouncycastle.asn1.x9.X962NamedCurves;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.ECKeyPairGenerator;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECKeyGenerationParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jcajce.provider.config.ProviderConfiguration;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECNamedCurveGenParameterSpec;
import org.bouncycastle.jce.spec.ECNamedCurveSpec;
import org.bouncycastle.jce.spec.ECParameterSpec;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.util.Integers;

public class KeyPairGeneratorSpi$EC extends KeyPairGeneratorSpi {
    String algorithm;
    int certainty;
    ProviderConfiguration configuration;
    private static Hashtable ecParameters;
    Object ecParams;
    ECKeyPairGenerator engine;
    boolean initialised;
    ECKeyGenerationParameters param;
    SecureRandom random;
    int strength;

    static {
        KeyPairGeneratorSpi$EC.ecParameters = new Hashtable();
        KeyPairGeneratorSpi$EC.ecParameters.put(Integers.valueOf(192), new ECGenParameterSpec("prime192v1"));
        KeyPairGeneratorSpi$EC.ecParameters.put(Integers.valueOf(239), new ECGenParameterSpec("prime239v1"));
        KeyPairGeneratorSpi$EC.ecParameters.put(Integers.valueOf(256), new ECGenParameterSpec("prime256v1"));
        KeyPairGeneratorSpi$EC.ecParameters.put(Integers.valueOf(224), new ECGenParameterSpec("P-224"));
        KeyPairGeneratorSpi$EC.ecParameters.put(Integers.valueOf(384), new ECGenParameterSpec("P-384"));
        KeyPairGeneratorSpi$EC.ecParameters.put(Integers.valueOf(521), new ECGenParameterSpec("P-521"));
    }

    public KeyPairGeneratorSpi$EC() {
        super("EC");
        this.engine = new ECKeyPairGenerator();
        this.ecParams = null;
        this.strength = 239;
        this.certainty = 50;
        this.random = new SecureRandom();
        this.initialised = false;
        this.algorithm = "EC";
        this.configuration = BouncyCastleProvider.CONFIGURATION;
    }

    public KeyPairGeneratorSpi$EC(String arg2, ProviderConfiguration arg3) {
        super(arg2);
        this.engine = new ECKeyPairGenerator();
        this.ecParams = null;
        this.strength = 239;
        this.certainty = 50;
        this.random = new SecureRandom();
        this.initialised = false;
        this.algorithm = arg2;
        this.configuration = arg3;
    }

    public KeyPair generateKeyPair() {
        KeyPair v0_1;
        BCECPublicKey v3;
        Object v4;
        if(!this.initialised) {
            this.initialize(this.strength, new SecureRandom());
        }

        AsymmetricCipherKeyPair v1 = this.engine.generateKeyPair();
        AsymmetricKeyParameter v0 = v1.getPublic();
        AsymmetricKeyParameter v2 = v1.getPrivate();
        if((this.ecParams instanceof ECParameterSpec)) {
            v4 = this.ecParams;
            v3 = new BCECPublicKey(this.algorithm, ((ECPublicKeyParameters)v0), ((ECParameterSpec)v4), this.configuration);
            v0_1 = new KeyPair(((PublicKey)v3), new BCECPrivateKey(this.algorithm, ((ECPrivateKeyParameters)v2), v3, ((ECParameterSpec)v4), this.configuration));
        }
        else if(this.ecParams == null) {
            v0_1 = new KeyPair(new BCECPublicKey(this.algorithm, ((ECPublicKeyParameters)v0), this.configuration), new BCECPrivateKey(this.algorithm, ((ECPrivateKeyParameters)v2), this.configuration));
        }
        else {
            v4 = this.ecParams;
            v3 = new BCECPublicKey(this.algorithm, ((ECPublicKeyParameters)v0), ((java.security.spec.ECParameterSpec)v4), this.configuration);
            v0_1 = new KeyPair(((PublicKey)v3), new BCECPrivateKey(this.algorithm, ((ECPrivateKeyParameters)v2), v3, ((java.security.spec.ECParameterSpec)v4), this.configuration));
        }

        return v0_1;
    }

    public void initialize(int arg3, SecureRandom arg4) {
        this.strength = arg3;
        this.random = arg4;
        Object v0 = KeyPairGeneratorSpi$EC.ecParameters.get(Integers.valueOf(arg3));
        if(v0 != null) {
            try {
                this.initialize(((AlgorithmParameterSpec)v0), arg4);
                return;
            }
            catch(InvalidAlgorithmParameterException v0_1) {
                throw new InvalidParameterException("key size not configurable.");
            }
        }

        throw new InvalidParameterException("unknown key size.");
    }

    public void initialize(AlgorithmParameterSpec arg10, SecureRandom arg11) {
        X9ECParameters v5;
        ECCurve v1;
        if((arg10 instanceof ECParameterSpec)) {
            this.ecParams = arg10;
            this.param = new ECKeyGenerationParameters(new ECDomainParameters(arg10.getCurve(), arg10.getG(), arg10.getN()), arg11);
            this.engine.init(this.param);
            this.initialised = true;
        }
        else if((arg10 instanceof java.security.spec.ECParameterSpec)) {
            this.ecParams = arg10;
            v1 = EC5Util.convertCurve(arg10.getCurve());
            this.param = new ECKeyGenerationParameters(new ECDomainParameters(v1, EC5Util.convertPoint(v1, arg10.getGenerator(), false), arg10.getOrder(), BigInteger.valueOf(((long)arg10.getCofactor()))), arg11);
            this.engine.init(this.param);
            this.initialised = true;
        }
        else {
            if(!(arg10 instanceof ECGenParameterSpec) && !(arg10 instanceof ECNamedCurveGenParameterSpec)) {
                if(arg10 == null && this.configuration.getEcImplicitlyCa() != null) {
                    ECParameterSpec v0 = this.configuration.getEcImplicitlyCa();
                    this.ecParams = arg10;
                    this.param = new ECKeyGenerationParameters(new ECDomainParameters(v0.getCurve(), v0.getG(), v0.getN()), arg11);
                    this.engine.init(this.param);
                    this.initialised = true;
                    return;
                }

                if(arg10 == null && this.configuration.getEcImplicitlyCa() == null) {
                    throw new InvalidAlgorithmParameterException("null parameter passed but no implicitCA set");
                }

                throw new InvalidAlgorithmParameterException("parameter object not a ECParameterSpec");
            }

            String v1_1 = (arg10 instanceof ECGenParameterSpec) ? ((ECGenParameterSpec)arg10).getName() : ((ECNamedCurveGenParameterSpec)arg10).getName();
            X9ECParameters v0_1 = X962NamedCurves.getByName(v1_1);
            if(v0_1 == null) {
                v0_1 = SECNamedCurves.getByName(v1_1);
                if(v0_1 == null) {
                    v0_1 = NISTNamedCurves.getByName(v1_1);
                }

                if(v0_1 == null) {
                    v0_1 = TeleTrusTNamedCurves.getByName(v1_1);
                }

                if(v0_1 != null) {
                    goto label_147;
                }

                try {
                    ASN1ObjectIdentifier v2 = new ASN1ObjectIdentifier(v1_1);
                    v0_1 = X962NamedCurves.getByOID(v2);
                    if(v0_1 == null) {
                        v0_1 = SECNamedCurves.getByOID(v2);
                    }

                    if(v0_1 == null) {
                        v0_1 = NISTNamedCurves.getByOID(v2);
                    }

                    if(v0_1 == null) {
                        v0_1 = TeleTrusTNamedCurves.getByOID(v2);
                    }

                    if(v0_1 != null) {
                        goto label_87;
                    }

                    throw new InvalidAlgorithmParameterException("unknown curve OID: " + v1_1);
                }
                catch(IllegalArgumentException v0_2) {
                    throw new InvalidAlgorithmParameterException("unknown curve name: " + v1_1);
                }

            label_87:
                v5 = v0_1;
            }
            else {
            label_147:
                v5 = v0_1;
            }

            this.ecParams = new ECNamedCurveSpec(v1_1, v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), null);
            Object v0_3 = this.ecParams;
            v1 = EC5Util.convertCurve(((java.security.spec.ECParameterSpec)v0_3).getCurve());
            this.param = new ECKeyGenerationParameters(new ECDomainParameters(v1, EC5Util.convertPoint(v1, ((java.security.spec.ECParameterSpec)v0_3).getGenerator(), false), ((java.security.spec.ECParameterSpec)v0_3).getOrder(), BigInteger.valueOf(((long)((java.security.spec.ECParameterSpec)v0_3).getCofactor()))), arg11);
            this.engine.init(this.param);
            this.initialised = true;
        }
    }
}

