// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ecgost;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.ECPublicKey;
import java.security.spec.ECParameterSpec;
import java.security.spec.ECPublicKeySpec;
import java.security.spec.EllipticCurve;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.cryptopro.ECGOST3410NamedCurves;
import org.bouncycastle.asn1.cryptopro.GOST3410PublicKeyAlgParameters;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ECPoint;
import org.bouncycastle.asn1.x9.X9IntegerConverter;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jce.ECGOST3410NamedCurveTable;
import org.bouncycastle.jce.interfaces.ECPointEncoder;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECNamedCurveParameterSpec;
import org.bouncycastle.jce.spec.ECNamedCurveSpec;
import org.bouncycastle.math.ec.ECCurve;
import org.bouncycastle.math.ec.ECPoint;
import org.bouncycastle.math.ec.ECPoint$F2m;
import org.bouncycastle.math.ec.ECPoint$Fp;

public class BCECGOST3410PublicKey implements ECPublicKey, ECPointEncoder, org.bouncycastle.jce.interfaces.ECPublicKey {
    private String algorithm;
    private transient ECParameterSpec ecSpec;
    private transient GOST3410PublicKeyAlgParameters gostParams;
    private transient ECPoint q;
    static final long serialVersionUID = 7026240464295649314L;
    private boolean withCompression;

    public BCECGOST3410PublicKey(String arg2, ECPublicKeyParameters arg3) {
        super();
        this.algorithm = "ECGOST3410";
        this.algorithm = arg2;
        this.q = arg3.getQ();
        this.ecSpec = null;
    }

    public BCECGOST3410PublicKey(String arg4, ECPublicKeyParameters arg5, ECParameterSpec arg6) {
        super();
        this.algorithm = "ECGOST3410";
        ECDomainParameters v0 = arg5.getParameters();
        this.algorithm = arg4;
        this.q = arg5.getQ();
        this.ecSpec = arg6 == null ? this.createSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), v0) : arg6;
    }

    public BCECGOST3410PublicKey(String arg4, ECPublicKeyParameters arg5, org.bouncycastle.jce.spec.ECParameterSpec arg6) {
        super();
        this.algorithm = "ECGOST3410";
        ECDomainParameters v0 = arg5.getParameters();
        this.algorithm = arg4;
        this.q = arg5.getQ();
        this.ecSpec = arg6 == null ? this.createSpec(EC5Util.convertCurve(v0.getCurve(), v0.getSeed()), v0) : EC5Util.convertSpec(EC5Util.convertCurve(arg6.getCurve(), arg6.getSeed()), arg6);
    }

    public BCECGOST3410PublicKey(ECPublicKey arg4) {
        super();
        this.algorithm = "ECGOST3410";
        this.algorithm = arg4.getAlgorithm();
        this.ecSpec = arg4.getParams();
        this.q = EC5Util.convertPoint(this.ecSpec, arg4.getW(), false);
    }

    public BCECGOST3410PublicKey(ECPublicKeySpec arg4) {
        super();
        this.algorithm = "ECGOST3410";
        this.ecSpec = arg4.getParams();
        this.q = EC5Util.convertPoint(this.ecSpec, arg4.getW(), false);
    }

    BCECGOST3410PublicKey(SubjectPublicKeyInfo arg2) {
        super();
        this.algorithm = "ECGOST3410";
        this.populateFromPubKeyInfo(arg2);
    }

    public BCECGOST3410PublicKey(BCECGOST3410PublicKey arg2) {
        super();
        this.algorithm = "ECGOST3410";
        this.q = arg2.q;
        this.ecSpec = arg2.ecSpec;
        this.withCompression = arg2.withCompression;
        this.gostParams = arg2.gostParams;
    }

    public BCECGOST3410PublicKey(org.bouncycastle.jce.spec.ECPublicKeySpec arg5) {
        super();
        this.algorithm = "ECGOST3410";
        this.q = arg5.getQ();
        if(arg5.getParams() != null) {
            this.ecSpec = EC5Util.convertSpec(EC5Util.convertCurve(arg5.getParams().getCurve(), arg5.getParams().getSeed()), arg5.getParams());
        }
        else {
            if(this.q.getCurve() == null) {
                this.q = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getCurve().createPoint(this.q.getX().toBigInteger(), this.q.getY().toBigInteger(), false);
            }

            this.ecSpec = null;
        }
    }

    private ECParameterSpec createSpec(EllipticCurve arg5, ECDomainParameters arg6) {
        return new ECParameterSpec(arg5, new java.security.spec.ECPoint(arg6.getG().getX().toBigInteger(), arg6.getG().getY().toBigInteger()), arg6.getN(), arg6.getH().intValue());
    }

    public ECPoint engineGetQ() {
        return this.q;
    }

    org.bouncycastle.jce.spec.ECParameterSpec engineGetSpec() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec != null ? EC5Util.convertSpec(this.ecSpec, this.withCompression) : BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa();
        return v0;
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof BCECGOST3410PublicKey)) && (this.engineGetQ().equals(((BCECGOST3410PublicKey)arg4).engineGetQ())) && (this.engineGetSpec().equals(((BCECGOST3410PublicKey)arg4).engineGetSpec()))) {
            v0 = true;
        }

        return v0;
    }

    private void extractBytes(byte[] arg7, int arg8, BigInteger arg9) {
        byte[] v0;
        int v5 = 32;
        byte[] v1 = arg9.toByteArray();
        if(v1.length < v5) {
            v0 = new byte[v5];
            System.arraycopy(v1, 0, v0, v0.length - v1.length, v1.length);
        }
        else {
            v0 = v1;
        }

        int v1_1;
        for(v1_1 = 0; v1_1 != v5; ++v1_1) {
            arg7[arg8 + v1_1] = v0[v0.length - 1 - v1_1];
        }
    }

    public String getAlgorithm() {
        return this.algorithm;
    }

    public byte[] getEncoded() {
        X962Parameters v1_2;
        SubjectPublicKeyInfo v0_3;
        ECCurve v1;
        GOST3410PublicKeyAlgParameters v0;
        if(this.algorithm.equals("ECGOST3410")) {
            if(this.gostParams != null) {
                v0 = this.gostParams;
            }
            else if((this.ecSpec instanceof ECNamedCurveSpec)) {
                v0 = new GOST3410PublicKeyAlgParameters(ECGOST3410NamedCurves.getOID(this.ecSpec.getName()), CryptoProObjectIdentifiers.gostR3411_94_CryptoProParamSet);
            }
            else {
                v1 = EC5Util.convertCurve(this.ecSpec.getCurve());
                X962Parameters v0_1 = new X962Parameters(new X9ECParameters(v1, EC5Util.convertPoint(v1, this.ecSpec.getGenerator(), this.withCompression), this.ecSpec.getOrder(), BigInteger.valueOf(((long)this.ecSpec.getCofactor())), this.ecSpec.getCurve().getSeed()));
            }

            BigInteger v1_1 = this.q.getX().toBigInteger();
            BigInteger v2 = this.q.getY().toBigInteger();
            byte[] v3 = new byte[64];
            this.extractBytes(v3, 0, v1_1);
            this.extractBytes(v3, 32, v2);
            try {
                v0_3 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_2001, ((ASN1Encodable)v0)), new DEROctetString(v3));
            }
            catch(IOException v0_2) {
                byte[] v0_4 = null;
                return v0_4;
            }
        }
        else {
            if((this.ecSpec instanceof ECNamedCurveSpec)) {
                ASN1ObjectIdentifier v0_5 = ECUtil.getNamedCurveOid(this.ecSpec.getName());
                if(v0_5 == null) {
                    v0_5 = new ASN1ObjectIdentifier(this.ecSpec.getName());
                }

                v1_2 = new X962Parameters(v0_5);
            }
            else {
                if(this.ecSpec == null) {
                    v1_2 = new X962Parameters(DERNull.INSTANCE);
                    goto label_79;
                }

                v1 = EC5Util.convertCurve(this.ecSpec.getCurve());
                v1_2 = new X962Parameters(new X9ECParameters(v1, EC5Util.convertPoint(v1, this.ecSpec.getGenerator(), this.withCompression), this.ecSpec.getOrder(), BigInteger.valueOf(((long)this.ecSpec.getCofactor())), this.ecSpec.getCurve().getSeed()));
            }

        label_79:
            v0_3 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, ((ASN1Encodable)v1_2)), new X9ECPoint(this.engineGetQ().getCurve().createPoint(this.getQ().getX().toBigInteger(), this.getQ().getY().toBigInteger(), this.withCompression)).toASN1Primitive().getOctets());
        }

        return KeyUtil.getEncodedSubjectPublicKeyInfo(v0_3);
    }

    public String getFormat() {
        return "X.509";
    }

    public org.bouncycastle.jce.spec.ECParameterSpec getParameters() {
        org.bouncycastle.jce.spec.ECParameterSpec v0 = this.ecSpec == null ? null : EC5Util.convertSpec(this.ecSpec, this.withCompression);
        return v0;
    }

    public ECParameterSpec getParams() {
        return this.ecSpec;
    }

    public ECPoint getQ() {
        ECPoint$F2m v0_1;
        ECCurve v3 = null;
        if(this.ecSpec != null) {
            ECPoint v0_2 = this.q;
        }
        else if((this.q instanceof ECPoint$Fp)) {
            ECPoint$Fp v0 = new ECPoint$Fp(v3, this.q.getX(), this.q.getY());
        }
        else {
            v0_1 = new ECPoint$F2m(v3, this.q.getX(), this.q.getY());
        }

        return ((ECPoint)v0_1);
    }

    public java.security.spec.ECPoint getW() {
        return new java.security.spec.ECPoint(this.q.getX().toBigInteger(), this.q.getY().toBigInteger());
    }

    public int hashCode() {
        return this.engineGetQ().hashCode() ^ this.engineGetSpec().hashCode();
    }

    private void populateFromPubKeyInfo(SubjectPublicKeyInfo arg12) {
        ECCurve v1_3;
        ECCurve v0_3;
        byte[] v1;
        int v2 = 32;
        int v10 = 2;
        if(arg12.getAlgorithm().getAlgorithm().equals(CryptoProObjectIdentifiers.gostR3410_2001)) {
            DERBitString v0 = arg12.getPublicKeyData();
            this.algorithm = "ECGOST3410";
            try {
                v1 = ASN1Primitive.fromByteArray(v0.getBytes()).getOctets();
            }
            catch(IOException v0_1) {
                throw new IllegalArgumentException("error recovering public key");
            }

            byte[] v3 = new byte[v2];
            byte[] v4 = new byte[v2];
            int v0_2;
            for(v0_2 = 0; v0_2 != v3.length; ++v0_2) {
                v3[v0_2] = v1[31 - v0_2];
            }

            for(v0_2 = 0; v0_2 != v4.length; ++v0_2) {
                v4[v0_2] = v1[63 - v0_2];
            }

            this.gostParams = new GOST3410PublicKeyAlgParameters(arg12.getAlgorithm().getParameters());
            ECNamedCurveParameterSpec v5 = ECGOST3410NamedCurveTable.getParameterSpec(ECGOST3410NamedCurves.getName(this.gostParams.getPublicKeyParamSet()));
            v0_3 = v5.getCurve();
            EllipticCurve v2_1 = EC5Util.convertCurve(v0_3, v5.getSeed());
            this.q = v0_3.createPoint(new BigInteger(1, v3), new BigInteger(1, v4), false);
            this.ecSpec = new ECNamedCurveSpec(ECGOST3410NamedCurves.getName(this.gostParams.getPublicKeyParamSet()), v2_1, new java.security.spec.ECPoint(v5.getG().getX().toBigInteger(), v5.getG().getY().toBigInteger()), v5.getN(), v5.getH());
        }
        else {
            X962Parameters v1_1 = new X962Parameters(arg12.getAlgorithm().getParameters());
            if(v1_1.isNamedCurve()) {
                ASN1Primitive v1_2 = v1_1.getParameters();
                X9ECParameters v5_1 = ECUtil.getNamedCurveByOid(((ASN1ObjectIdentifier)v1_2));
                ECCurve v7 = v5_1.getCurve();
                this.ecSpec = new ECNamedCurveSpec(ECUtil.getCurveName(((ASN1ObjectIdentifier)v1_2)), EC5Util.convertCurve(v7, v5_1.getSeed()), new java.security.spec.ECPoint(v5_1.getG().getX().toBigInteger(), v5_1.getG().getY().toBigInteger()), v5_1.getN(), v5_1.getH());
                v1_3 = v7;
            }
            else if(v1_1.isImplicitlyCA()) {
                this.ecSpec = null;
                v1_3 = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getCurve();
            }
            else {
                X9ECParameters v1_4 = X9ECParameters.getInstance(v1_1.getParameters());
                v0_3 = v1_4.getCurve();
                this.ecSpec = new ECParameterSpec(EC5Util.convertCurve(v0_3, v1_4.getSeed()), new java.security.spec.ECPoint(v1_4.getG().getX().toBigInteger(), v1_4.getG().getY().toBigInteger()), v1_4.getN(), v1_4.getH().intValue());
                v1_3 = v0_3;
            }

            byte[] v2_2 = arg12.getPublicKeyData().getBytes();
            DEROctetString v0_4 = new DEROctetString(v2_2);
            if(v2_2[0] == 4 && v2_2[1] == v2_2.length - 2) {
                if(v2_2[v10] != v10 && v2_2[v10] != 3) {
                    goto label_123;
                }

                if(new X9IntegerConverter().getByteLength(v1_3) < v2_2.length - 3) {
                    goto label_123;
                }

                try {
                    ASN1Primitive v0_5 = ASN1Primitive.fromByteArray(v2_2);
                label_123:
                    goto label_124;
                }
                catch(IOException v0_1) {
                    throw new IllegalArgumentException("error recovering public key");
                }
            }

            goto label_123;
        label_124:
            this.q = new X9ECPoint(v1_3, ((ASN1OctetString)v0_4)).getPoint();
        }
    }

    private void readObject(ObjectInputStream arg2) {
        arg2.defaultReadObject();
        this.populateFromPubKeyInfo(SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg2.readObject())));
    }

    public void setPointFormat(String arg2) {
        boolean v0 = !"UNCOMPRESSED".equalsIgnoreCase(arg2) ? true : false;
        this.withCompression = v0;
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("EC Public Key").append(v1);
        v0.append("            X: ").append(this.q.getX().toBigInteger().toString(16)).append(v1);
        v0.append("            Y: ").append(this.q.getY().toBigInteger().toString(16)).append(v1);
        return v0.toString();
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.getEncoded());
    }
}

