// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ecgost;

import java.math.BigInteger;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SignatureException;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.GOST3411Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.signers.ECGOST3410Signer;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.GOST3410Util;
import org.bouncycastle.jce.interfaces.ECKey;
import org.bouncycastle.jce.interfaces.ECPublicKey;
import org.bouncycastle.jce.interfaces.GOST3410Key;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class SignatureSpi extends java.security.SignatureSpi implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    private Digest digest;
    private DSA signer;

    public SignatureSpi() {
        super();
        this.digest = new GOST3411Digest();
        this.signer = new ECGOST3410Signer();
    }

    protected Object engineGetParameter(String arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineInitSign(PrivateKey arg6) {
        AsymmetricKeyParameter v0 = (arg6 instanceof ECKey) ? ECUtil.generatePrivateKeyParameter(arg6) : GOST3410Util.generatePrivateKeyParameter(arg6);
        this.digest.reset();
        if(this.appRandom != null) {
            this.signer.init(true, new ParametersWithRandom(((CipherParameters)v0), this.appRandom));
        }
        else {
            this.signer.init(true, ((CipherParameters)v0));
        }
    }

    protected void engineInitVerify(PublicKey arg4) {
        AsymmetricKeyParameter v0;
        if((arg4 instanceof ECPublicKey)) {
            v0 = ECUtil.generatePublicKeyParameter(arg4);
        }
        else if((arg4 instanceof GOST3410Key)) {
            v0 = GOST3410Util.generatePublicKeyParameter(arg4);
        }
        else {
            try {
                PublicKey v0_2 = BouncyCastleProvider.getPublicKey(SubjectPublicKeyInfo.getInstance(arg4.getEncoded()));
                if((v0_2 instanceof ECPublicKey)) {
                    v0 = ECUtil.generatePublicKeyParameter(v0_2);
                }
                else {
                    goto label_20;
                }
            }
            catch(Exception v0_1) {
                goto label_28;
            }
        }

        this.digest.reset();
        this.signer.init(false, ((CipherParameters)v0));
        return;
        try {
        label_20:
            throw new InvalidKeyException("can\'t recognise key type in DSA based signer");
        }
        catch(Exception v0_1) {
        label_28:
            throw new InvalidKeyException("can\'t recognise key type in DSA based signer");
        }
    }

    protected void engineSetParameter(String arg3, Object arg4) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(AlgorithmParameterSpec arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected byte[] engineSign() {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        int v1 = 64;
        try {
            byte[] v1_1 = new byte[v1];
            BigInteger[] v0_2 = this.signer.generateSignature(v0);
            byte[] v2 = v0_2[0].toByteArray();
            v0 = v0_2[1].toByteArray();
            if(v0[0] != 0) {
                System.arraycopy(v0, 0, v1_1, 32 - v0.length, v0.length);
            }
            else {
                System.arraycopy(v0, 1, v1_1, 32 - (v0.length - 1), v0.length - 1);
            }

            if(v2[0] != 0) {
                System.arraycopy(v2, 0, v1_1, 64 - v2.length, v2.length);
            }
            else {
                System.arraycopy(v2, 1, v1_1, 64 - (v2.length - 1), v2.length - 1);
            }

            return v1_1;
        }
        catch(Exception v0_1) {
            throw new SignatureException(v0_1.toString());
        }
    }

    protected void engineUpdate(byte arg2) {
        this.digest.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    protected boolean engineVerify(byte[] arg10) {
        BigInteger[] v3;
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        int v1 = 32;
        try {
            byte[] v1_1 = new byte[v1];
            byte[] v2 = new byte[32];
            System.arraycopy(arg10, 0, v2, 0, 32);
            System.arraycopy(arg10, 32, v1_1, 0, 32);
            v3 = new BigInteger[]{new BigInteger(1, v1_1), new BigInteger(1, v2)};
        }
        catch(Exception v0_1) {
            throw new SignatureException("error decoding signature bytes.");
        }

        return this.signer.verifySignature(v0, v3[0], v3[1]);
    }
}

