// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.elgamal;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import javax.crypto.spec.DHParameterSpec;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.jcajce.provider.symmetric.util.BaseAlgorithmParameters;
import org.bouncycastle.jce.spec.ElGamalParameterSpec;

public class AlgorithmParametersSpi extends BaseAlgorithmParameters {
    ElGamalParameterSpec currentSpec;

    public AlgorithmParametersSpi() {
        super();
    }

    protected byte[] engineGetEncoded() {
        ElGamalParameter v0 = new ElGamalParameter(this.currentSpec.getP(), this.currentSpec.getG());
        try {
            return v0.getEncoded("DER");
        }
        catch(IOException v0_1) {
            throw new RuntimeException("Error encoding ElGamalParameters");
        }
    }

    protected byte[] engineGetEncoded(String arg2) {
        byte[] v0 = (this.isASN1FormatString(arg2)) || (arg2.equalsIgnoreCase("X.509")) ? this.engineGetEncoded() : null;
        return v0;
    }

    protected void engineInit(AlgorithmParameterSpec arg4) {
        if(!(arg4 instanceof ElGamalParameterSpec) && !(arg4 instanceof DHParameterSpec)) {
            throw new InvalidParameterSpecException("DHParameterSpec required to initialise a ElGamal algorithm parameters object");
        }

        this.currentSpec = (arg4 instanceof ElGamalParameterSpec) ? ((ElGamalParameterSpec)arg4) : new ElGamalParameterSpec(((DHParameterSpec)arg4).getP(), ((DHParameterSpec)arg4).getG());
    }

    protected void engineInit(byte[] arg4) {
        try {
            ElGamalParameter v1 = new ElGamalParameter(ASN1Primitive.fromByteArray(arg4));
            this.currentSpec = new ElGamalParameterSpec(v1.getP(), v1.getG());
            return;
        }
        catch(ArrayIndexOutOfBoundsException v0) {
            throw new IOException("Not a valid ElGamal Parameter encoding.");
        }
        catch(ClassCastException v0_1) {
            throw new IOException("Not a valid ElGamal Parameter encoding.");
        }
    }

    protected void engineInit(byte[] arg4, String arg5) {
        if(!this.isASN1FormatString(arg5) && !arg5.equalsIgnoreCase("X.509")) {
            throw new IOException("Unknown parameter format " + arg5);
        }

        this.engineInit(arg4);
    }

    protected String engineToString() {
        return "ElGamal Parameters";
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg4) {
        DHParameterSpec v0_1;
        if(arg4 == ElGamalParameterSpec.class) {
            ElGamalParameterSpec v0 = this.currentSpec;
        }
        else if(arg4 == DHParameterSpec.class) {
            v0_1 = new DHParameterSpec(this.currentSpec.getP(), this.currentSpec.getG());
        }
        else {
            goto label_13;
        }

        return ((AlgorithmParameterSpec)v0_1);
    label_13:
        throw new InvalidParameterSpecException("unknown parameter spec passed to ElGamal parameters object.");
    }
}

