// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.elgamal;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.util.Enumeration;
import javax.crypto.interfaces.DHPrivateKey;
import javax.crypto.spec.DHParameterSpec;
import javax.crypto.spec.DHPrivateKeySpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.params.ElGamalPrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.ElGamalPrivateKey;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;
import org.bouncycastle.jce.spec.ElGamalParameterSpec;
import org.bouncycastle.jce.spec.ElGamalPrivateKeySpec;

public class BCElGamalPrivateKey implements DHPrivateKey, ElGamalPrivateKey, PKCS12BagAttributeCarrier {
    private transient PKCS12BagAttributeCarrierImpl attrCarrier;
    private transient ElGamalParameterSpec elSpec;
    static final long serialVersionUID = 4819350091141529678L;
    private BigInteger x;

    protected BCElGamalPrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    BCElGamalPrivateKey(DHPrivateKey arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    BCElGamalPrivateKey(DHPrivateKeySpec arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getP(), arg4.getG());
    }

    BCElGamalPrivateKey(PrivateKeyInfo arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        ElGamalParameter v1 = new ElGamalParameter(arg4.getAlgorithmId().getParameters());
        this.x = ASN1Integer.getInstance(arg4.parsePrivateKey()).getValue();
        this.elSpec = new ElGamalParameterSpec(v1.getP(), v1.getG());
    }

    BCElGamalPrivateKey(ElGamalPrivateKeyParameters arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getParameters().getP(), arg4.getParameters().getG());
    }

    BCElGamalPrivateKey(ElGamalPrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg2.getX();
        this.elSpec = arg2.getParameters();
    }

    BCElGamalPrivateKey(ElGamalPrivateKeySpec arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DHPrivateKey)) && (this.getX().equals(((DHPrivateKey)arg4).getX())) && (this.getParams().getG().equals(((DHPrivateKey)arg4).getParams().getG())) && (this.getParams().getP().equals(((DHPrivateKey)arg4).getParams().getP())) && this.getParams().getL() == ((DHPrivateKey)arg4).getParams().getL()) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "ElGamal";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        byte[] v0_1;
        try {
            v0_1 = new PrivateKeyInfo(new AlgorithmIdentifier(OIWObjectIdentifiers.elGamalAlgorithm, new ElGamalParameter(this.elSpec.getP(), this.elSpec.getG())), new DERInteger(this.getX())).getEncoded("DER");
        }
        catch(IOException v0) {
            v0_1 = null;
        }

        return v0_1;
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public ElGamalParameterSpec getParameters() {
        return this.elSpec;
    }

    public DHParameterSpec getParams() {
        return new DHParameterSpec(this.elSpec.getP(), this.elSpec.getG());
    }

    public BigInteger getX() {
        return this.x;
    }

    public int hashCode() {
        return this.getX().hashCode() ^ this.getParams().getG().hashCode() ^ this.getParams().getP().hashCode() ^ this.getParams().getL();
    }

    private void readObject(ObjectInputStream arg4) {
        arg4.defaultReadObject();
        this.elSpec = new ElGamalParameterSpec(arg4.readObject(), arg4.readObject());
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.elSpec.getP());
        arg2.writeObject(this.elSpec.getG());
    }
}

