// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.elgamal;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import javax.crypto.interfaces.DHPublicKey;
import javax.crypto.spec.DHParameterSpec;
import javax.crypto.spec.DHPublicKeySpec;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.params.ElGamalPublicKeyParameters;
import org.bouncycastle.jce.interfaces.ElGamalPublicKey;
import org.bouncycastle.jce.spec.ElGamalParameterSpec;
import org.bouncycastle.jce.spec.ElGamalPublicKeySpec;

public class BCElGamalPublicKey implements DHPublicKey, ElGamalPublicKey {
    private transient ElGamalParameterSpec elSpec;
    static final long serialVersionUID = 8712728417091216948L;
    private BigInteger y;

    BCElGamalPublicKey(BigInteger arg1, ElGamalParameterSpec arg2) {
        super();
        this.y = arg1;
        this.elSpec = arg2;
    }

    BCElGamalPublicKey(DHPublicKey arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    BCElGamalPublicKey(DHPublicKeySpec arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getP(), arg4.getG());
    }

    BCElGamalPublicKey(SubjectPublicKeyInfo arg4) {
        BigInteger v0_1;
        super();
        ElGamalParameter v1 = new ElGamalParameter(arg4.getAlgorithmId().getParameters());
        try {
            v0_1 = arg4.parsePublicKey().getValue();
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("invalid info structure in DSA public key");
        }

        this.y = v0_1;
        this.elSpec = new ElGamalParameterSpec(v1.getP(), v1.getG());
    }

    BCElGamalPublicKey(ElGamalPublicKeyParameters arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getParameters().getP(), arg4.getParameters().getG());
    }

    BCElGamalPublicKey(ElGamalPublicKey arg2) {
        super();
        this.y = arg2.getY();
        this.elSpec = arg2.getParameters();
    }

    BCElGamalPublicKey(ElGamalPublicKeySpec arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DHPublicKey)) && (this.getY().equals(((DHPublicKey)arg4).getY())) && (this.getParams().getG().equals(((DHPublicKey)arg4).getParams().getG())) && (this.getParams().getP().equals(((DHPublicKey)arg4).getParams().getP())) && this.getParams().getL() == ((DHPublicKey)arg4).getParams().getL()) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "ElGamal";
    }

    public byte[] getEncoded() {
        byte[] v0_1;
        try {
            v0_1 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(OIWObjectIdentifiers.elGamalAlgorithm, new ElGamalParameter(this.elSpec.getP(), this.elSpec.getG())), new DERInteger(this.y)).getEncoded("DER");
        }
        catch(IOException v0) {
            v0_1 = null;
        }

        return v0_1;
    }

    public String getFormat() {
        return "X.509";
    }

    public ElGamalParameterSpec getParameters() {
        return this.elSpec;
    }

    public DHParameterSpec getParams() {
        return new DHParameterSpec(this.elSpec.getP(), this.elSpec.getG());
    }

    public BigInteger getY() {
        return this.y;
    }

    public int hashCode() {
        return this.getY().hashCode() ^ this.getParams().getG().hashCode() ^ this.getParams().getP().hashCode() ^ this.getParams().getL();
    }

    private void readObject(ObjectInputStream arg4) {
        arg4.defaultReadObject();
        this.elSpec = new ElGamalParameterSpec(arg4.readObject(), arg4.readObject());
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        arg2.writeObject(this.elSpec.getP());
        arg2.writeObject(this.elSpec.getG());
    }
}

