// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.elgamal;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.InvalidParameterException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.MGF1ParameterSpec;
import javax.crypto.BadPaddingException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.interfaces.DHKey;
import javax.crypto.spec.OAEPParameterSpec;
import javax.crypto.spec.PSource$PSpecified;
import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.BufferedAsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.encodings.ISO9796d1Encoding;
import org.bouncycastle.crypto.encodings.OAEPEncoding;
import org.bouncycastle.crypto.encodings.PKCS1Encoding;
import org.bouncycastle.crypto.engines.ElGamalEngine;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseCipherSpi;
import org.bouncycastle.jcajce.provider.util.DigestFactory;
import org.bouncycastle.jce.interfaces.ElGamalKey;
import org.bouncycastle.jce.interfaces.ElGamalPrivateKey;
import org.bouncycastle.jce.interfaces.ElGamalPublicKey;
import org.bouncycastle.util.Strings;

public class CipherSpi extends BaseCipherSpi {
    private BufferedAsymmetricBlockCipher cipher;
    private AlgorithmParameters engineParams;
    private AlgorithmParameterSpec paramSpec;

    public CipherSpi(AsymmetricBlockCipher arg2) {
        super();
        this.cipher = new BufferedAsymmetricBlockCipher(arg2);
    }

    protected int engineDoFinal(byte[] arg5, int arg6, int arg7, byte[] arg8, int arg9) {
        int v0_1;
        byte[] v1;
        this.cipher.processBytes(arg5, arg6, arg7);
        try {
            v1 = this.cipher.doFinal();
            v0_1 = 0;
        }
        catch(InvalidCipherTextException v0) {
            throw new BadPaddingException(v0.getMessage());
        }

        while(v0_1 != v1.length) {
            arg8[arg9 + v0_1] = v1[v0_1];
            ++v0_1;
        }

        return v1.length;
    }

    protected byte[] engineDoFinal(byte[] arg3, int arg4, int arg5) {
        this.cipher.processBytes(arg3, arg4, arg5);
        try {
            return this.cipher.doFinal();
        }
        catch(InvalidCipherTextException v0) {
            throw new BadPaddingException(v0.getMessage());
        }
    }

    protected int engineGetBlockSize() {
        return this.cipher.getInputBlockSize();
    }

    protected int engineGetKeySize(Key arg3) {
        int v0;
        if((arg3 instanceof ElGamalKey)) {
            v0 = ((ElGamalKey)arg3).getParameters().getP().bitLength();
        }
        else if((arg3 instanceof DHKey)) {
            v0 = ((DHKey)arg3).getParams().getP().bitLength();
        }
        else {
            goto label_12;
        }

        return v0;
    label_12:
        throw new IllegalArgumentException("not an ElGamal key!");
    }

    protected int engineGetOutputSize(int arg2) {
        return this.cipher.getOutputBlockSize();
    }

    protected AlgorithmParameters engineGetParameters() {
        if(this.engineParams == null && this.paramSpec != null) {
            try {
                this.engineParams = AlgorithmParameters.getInstance("OAEP", "BC");
                this.engineParams.init(this.paramSpec);
            }
            catch(Exception v0) {
                throw new RuntimeException(v0.toString());
            }
        }

        return this.engineParams;
    }

    protected void engineInit(int arg3, Key arg4, AlgorithmParameters arg5, SecureRandom arg6) {
        throw new InvalidAlgorithmParameterException("can\'t handle parameters in ElGamal");
    }

    protected void engineInit(int arg2, Key arg3, SecureRandom arg4) {
        this.engineInit(arg2, arg3, null, arg4);
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameterSpec arg6, SecureRandom arg7) {
        ParametersWithRandom v0;
        AsymmetricKeyParameter v1;
        if(arg6 != null) {
            goto label_27;
        }

        if((arg5 instanceof ElGamalPublicKey)) {
            v1 = ElGamalUtil.generatePublicKeyParameter(((PublicKey)arg5));
        }
        else if((arg5 instanceof ElGamalPrivateKey)) {
            v1 = ElGamalUtil.generatePrivateKeyParameter(((PrivateKey)arg5));
        }
        else {
            goto label_23;
        }

        if(arg7 != null) {
            v0 = new ParametersWithRandom(((CipherParameters)v1), arg7);
        }
        else {
            AsymmetricKeyParameter v0_1 = v1;
        }

        switch(arg4) {
            case 1: 
            case 3: {
                goto label_31;
            }
            case 2: 
            case 4: {
                goto label_35;
            }
        }

        throw new InvalidParameterException("unknown opmode " + arg4 + " passed to ElGamal");
    label_35:
        this.cipher.init(false, ((CipherParameters)v0));
        return;
    label_31:
        this.cipher.init(true, ((CipherParameters)v0));
        return;
    label_23:
        throw new InvalidKeyException("unknown key type passed to ElGamal");
    label_27:
        throw new IllegalArgumentException("unknown parameter type.");
    }

    protected void engineSetMode(String arg4) {
        String v0 = Strings.toUpperCase(arg4);
        if(!v0.equals("NONE") && !v0.equals("ECB")) {
            throw new NoSuchAlgorithmException("can\'t support mode " + arg4);
        }
    }

    protected void engineSetPadding(String arg6) {
        String v0 = Strings.toUpperCase(arg6);
        if(v0.equals("NOPADDING")) {
            this.cipher = new BufferedAsymmetricBlockCipher(new ElGamalEngine());
        }
        else if(v0.equals("PKCS1PADDING")) {
            this.cipher = new BufferedAsymmetricBlockCipher(new PKCS1Encoding(new ElGamalEngine()));
        }
        else if(v0.equals("ISO9796-1PADDING")) {
            this.cipher = new BufferedAsymmetricBlockCipher(new ISO9796d1Encoding(new ElGamalEngine()));
        }
        else if(v0.equals("OAEPPADDING")) {
            this.initFromSpec(OAEPParameterSpec.DEFAULT);
        }
        else if(v0.equals("OAEPWITHMD5ANDMGF1PADDING")) {
            this.initFromSpec(new OAEPParameterSpec("MD5", "MGF1", new MGF1ParameterSpec("MD5"), PSource$PSpecified.DEFAULT));
        }
        else if(v0.equals("OAEPWITHSHA1ANDMGF1PADDING")) {
            this.initFromSpec(OAEPParameterSpec.DEFAULT);
        }
        else if(v0.equals("OAEPWITHSHA224ANDMGF1PADDING")) {
            this.initFromSpec(new OAEPParameterSpec("SHA-224", "MGF1", new MGF1ParameterSpec("SHA-224"), PSource$PSpecified.DEFAULT));
        }
        else if(v0.equals("OAEPWITHSHA256ANDMGF1PADDING")) {
            this.initFromSpec(new OAEPParameterSpec("SHA-256", "MGF1", MGF1ParameterSpec.SHA256, PSource$PSpecified.DEFAULT));
        }
        else if(v0.equals("OAEPWITHSHA384ANDMGF1PADDING")) {
            this.initFromSpec(new OAEPParameterSpec("SHA-384", "MGF1", MGF1ParameterSpec.SHA384, PSource$PSpecified.DEFAULT));
        }
        else if(v0.equals("OAEPWITHSHA512ANDMGF1PADDING")) {
            this.initFromSpec(new OAEPParameterSpec("SHA-512", "MGF1", MGF1ParameterSpec.SHA512, PSource$PSpecified.DEFAULT));
        }
        else {
            goto label_103;
        }

        return;
    label_103:
        throw new NoSuchPaddingException(arg6 + " unavailable with ElGamal.");
    }

    protected int engineUpdate(byte[] arg2, int arg3, int arg4, byte[] arg5, int arg6) {
        this.cipher.processBytes(arg2, arg3, arg4);
        return 0;
    }

    protected byte[] engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.cipher.processBytes(arg2, arg3, arg4);
        return null;
    }

    private void initFromSpec(OAEPParameterSpec arg6) {
        AlgorithmParameterSpec v0 = arg6.getMGFParameters();
        Digest v1 = DigestFactory.getDigest(((MGF1ParameterSpec)v0).getDigestAlgorithm());
        if(v1 == null) {
            throw new NoSuchPaddingException("no match on OAEP constructor for digest algorithm: " + ((MGF1ParameterSpec)v0).getDigestAlgorithm());
        }

        this.cipher = new BufferedAsymmetricBlockCipher(new OAEPEncoding(new ElGamalEngine(), v1, arg6.getPSource().getValue()));
        this.paramSpec = ((AlgorithmParameterSpec)arg6);
    }
}

