// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.elgamal;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.KeySpec;
import javax.crypto.interfaces.DHPrivateKey;
import javax.crypto.interfaces.DHPublicKey;
import javax.crypto.spec.DHPrivateKeySpec;
import javax.crypto.spec.DHPublicKeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseKeyFactorySpi;
import org.bouncycastle.jce.interfaces.ElGamalPrivateKey;
import org.bouncycastle.jce.interfaces.ElGamalPublicKey;
import org.bouncycastle.jce.spec.ElGamalPrivateKeySpec;
import org.bouncycastle.jce.spec.ElGamalPublicKeySpec;

public class KeyFactorySpi extends BaseKeyFactorySpi {
    public KeyFactorySpi() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg2) {
        BCElGamalPrivateKey v0;
        if((arg2 instanceof ElGamalPrivateKeySpec)) {
            v0 = new BCElGamalPrivateKey(((ElGamalPrivateKeySpec)arg2));
        }
        else if((arg2 instanceof DHPrivateKeySpec)) {
            v0 = new BCElGamalPrivateKey(((DHPrivateKeySpec)arg2));
        }
        else {
            PrivateKey v0_1 = super.engineGeneratePrivate(arg2);
        }

        return ((PrivateKey)v0);
    }

    protected PublicKey engineGeneratePublic(KeySpec arg2) {
        PublicKey v0_1;
        BCElGamalPublicKey v0;
        if((arg2 instanceof ElGamalPublicKeySpec)) {
            v0 = new BCElGamalPublicKey(((ElGamalPublicKeySpec)arg2));
        }
        else if((arg2 instanceof DHPublicKeySpec)) {
            v0 = new BCElGamalPublicKey(((DHPublicKeySpec)arg2));
        }
        else {
            v0_1 = super.engineGeneratePublic(arg2);
        }

        return v0_1;
    }

    protected KeySpec engineGetKeySpec(Key arg5, Class arg6) {
        DHPrivateKeySpec v0;
        if(!arg6.isAssignableFrom(DHPrivateKeySpec.class) || !(arg5 instanceof DHPrivateKey)) {
            if((arg6.isAssignableFrom(DHPublicKeySpec.class)) && ((arg5 instanceof DHPublicKey))) {
                DHPublicKeySpec v0_1 = new DHPublicKeySpec(((DHPublicKey)arg5).getY(), ((DHPublicKey)arg5).getParams().getP(), ((DHPublicKey)arg5).getParams().getG());
                goto label_12;
            }

            KeySpec v0_2 = super.engineGetKeySpec(arg5, arg6);
        }
        else {
            v0 = new DHPrivateKeySpec(((DHPrivateKey)arg5).getX(), ((DHPrivateKey)arg5).getParams().getP(), ((DHPrivateKey)arg5).getParams().getG());
        }

    label_12:
        return ((KeySpec)v0);
    }

    protected Key engineTranslateKey(Key arg3) {
        BCElGamalPrivateKey v0_1;
        BCElGamalPublicKey v0;
        if((arg3 instanceof DHPublicKey)) {
            v0 = new BCElGamalPublicKey(((DHPublicKey)arg3));
        }
        else if((arg3 instanceof DHPrivateKey)) {
            v0_1 = new BCElGamalPrivateKey(((DHPrivateKey)arg3));
        }
        else if((arg3 instanceof ElGamalPublicKey)) {
            v0 = new BCElGamalPublicKey(((ElGamalPublicKey)arg3));
        }
        else if((arg3 instanceof ElGamalPrivateKey)) {
            v0_1 = new BCElGamalPrivateKey(((ElGamalPrivateKey)arg3));
        }
        else {
            goto label_20;
        }

        return ((Key)v0);
    label_20:
        throw new InvalidKeyException("key type unknown");
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg5) {
        BCElGamalPrivateKey v0_1;
        ASN1ObjectIdentifier v0 = arg5.getPrivateKeyAlgorithm().getAlgorithm();
        if(v0.equals(PKCSObjectIdentifiers.dhKeyAgreement)) {
            v0_1 = new BCElGamalPrivateKey(arg5);
        }
        else if(v0.equals(X9ObjectIdentifiers.dhpublicnumber)) {
            v0_1 = new BCElGamalPrivateKey(arg5);
        }
        else if(v0.equals(OIWObjectIdentifiers.elGamalAlgorithm)) {
            v0_1 = new BCElGamalPrivateKey(arg5);
        }
        else {
            goto label_20;
        }

        return ((PrivateKey)v0_1);
    label_20:
        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg5) {
        BCElGamalPublicKey v0_1;
        ASN1ObjectIdentifier v0 = arg5.getAlgorithm().getAlgorithm();
        if(v0.equals(PKCSObjectIdentifiers.dhKeyAgreement)) {
            v0_1 = new BCElGamalPublicKey(arg5);
        }
        else if(v0.equals(X9ObjectIdentifiers.dhpublicnumber)) {
            v0_1 = new BCElGamalPublicKey(arg5);
        }
        else if(v0.equals(OIWObjectIdentifiers.elGamalAlgorithm)) {
            v0_1 = new BCElGamalPublicKey(arg5);
        }
        else {
            goto label_20;
        }

        return ((PublicKey)v0_1);
    label_20:
        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }
}

