// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.elgamal;

import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.spec.DHParameterSpec;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.ElGamalKeyPairGenerator;
import org.bouncycastle.crypto.generators.ElGamalParametersGenerator;
import org.bouncycastle.crypto.params.ElGamalKeyGenerationParameters;
import org.bouncycastle.crypto.params.ElGamalParameters;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ElGamalParameterSpec;

public class KeyPairGeneratorSpi extends KeyPairGenerator {
    int certainty;
    ElGamalKeyPairGenerator engine;
    boolean initialised;
    ElGamalKeyGenerationParameters param;
    SecureRandom random;
    int strength;

    public KeyPairGeneratorSpi() {
        super("ElGamal");
        this.engine = new ElGamalKeyPairGenerator();
        this.strength = 1024;
        this.certainty = 20;
        this.random = new SecureRandom();
        this.initialised = false;
    }

    public KeyPair generateKeyPair() {
        if(!this.initialised) {
            DHParameterSpec v0 = BouncyCastleProvider.CONFIGURATION.getDHDefaultParameters(this.strength);
            if(v0 != null) {
                this.param = new ElGamalKeyGenerationParameters(this.random, new ElGamalParameters(v0.getP(), v0.getG(), v0.getL()));
            }
            else {
                ElGamalParametersGenerator v0_1 = new ElGamalParametersGenerator();
                v0_1.init(this.strength, this.certainty, this.random);
                this.param = new ElGamalKeyGenerationParameters(this.random, v0_1.generateParameters());
            }

            this.engine.init(this.param);
            this.initialised = true;
        }

        AsymmetricCipherKeyPair v1 = this.engine.generateKeyPair();
        return new KeyPair(new BCElGamalPublicKey(v1.getPublic()), new BCElGamalPrivateKey(v1.getPrivate()));
    }

    public void initialize(int arg1, SecureRandom arg2) {
        this.strength = arg1;
        this.random = arg2;
    }

    public void initialize(AlgorithmParameterSpec arg6, SecureRandom arg7) {
        if(!(arg6 instanceof ElGamalParameterSpec) && !(arg6 instanceof DHParameterSpec)) {
            throw new InvalidAlgorithmParameterException("parameter object not a DHParameterSpec or an ElGamalParameterSpec");
        }

        this.param = (arg6 instanceof ElGamalParameterSpec) ? new ElGamalKeyGenerationParameters(arg7, new ElGamalParameters(((ElGamalParameterSpec)arg6).getP(), ((ElGamalParameterSpec)arg6).getG())) : new ElGamalKeyGenerationParameters(arg7, new ElGamalParameters(((DHParameterSpec)arg6).getP(), ((DHParameterSpec)arg6).getG(), ((DHParameterSpec)arg6).getL()));
        this.engine.init(this.param);
        this.initialised = true;
    }
}

