// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.gost;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.crypto.generators.GOST3410ParametersGenerator;
import org.bouncycastle.crypto.params.GOST3410Parameters;
import org.bouncycastle.jce.spec.GOST3410ParameterSpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeyParameterSetSpec;

public abstract class AlgorithmParameterGeneratorSpi extends java.security.AlgorithmParameterGeneratorSpi {
    protected SecureRandom random;
    protected int strength;

    public AlgorithmParameterGeneratorSpi() {
        super();
        this.strength = 1024;
    }

    protected AlgorithmParameters engineGenerateParameters() {
        int v3 = 2;
        GOST3410ParametersGenerator v0 = new GOST3410ParametersGenerator();
        if(this.random != null) {
            v0.init(this.strength, v3, this.random);
        }
        else {
            v0.init(this.strength, v3, new SecureRandom());
        }

        GOST3410Parameters v0_1 = v0.generateParameters();
        try {
            AlgorithmParameters v1 = AlgorithmParameters.getInstance("GOST3410", "BC");
            v1.init(new GOST3410ParameterSpec(new GOST3410PublicKeyParameterSetSpec(v0_1.getP(), v0_1.getQ(), v0_1.getA())));
            return v1;
        }
        catch(Exception v0_2) {
            throw new RuntimeException(v0_2.getMessage());
        }
    }

    protected void engineInit(int arg1, SecureRandom arg2) {
        this.strength = arg1;
        this.random = arg2;
    }

    protected void engineInit(AlgorithmParameterSpec arg3, SecureRandom arg4) {
        throw new InvalidAlgorithmParameterException("No supported AlgorithmParameterSpec for GOST3410 parameter generation.");
    }
}

