// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.gost;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.cryptopro.GOST3410PublicKeyAlgParameters;
import org.bouncycastle.jce.spec.GOST3410ParameterSpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeyParameterSetSpec;

public class AlgorithmParametersSpi extends java.security.AlgorithmParametersSpi {
    GOST3410ParameterSpec currentSpec;

    public AlgorithmParametersSpi() {
        super();
    }

    protected byte[] engineGetEncoded() {
        GOST3410PublicKeyAlgParameters v0 = new GOST3410PublicKeyAlgParameters(new ASN1ObjectIdentifier(this.currentSpec.getPublicKeyParamSetOID()), new ASN1ObjectIdentifier(this.currentSpec.getDigestParamSetOID()), new ASN1ObjectIdentifier(this.currentSpec.getEncryptionParamSetOID()));
        try {
            return v0.getEncoded("DER");
        }
        catch(IOException v0_1) {
            throw new RuntimeException("Error encoding GOST3410Parameters");
        }
    }

    protected byte[] engineGetEncoded(String arg2) {
        byte[] v0 = (this.isASN1FormatString(arg2)) || (arg2.equalsIgnoreCase("X.509")) ? this.engineGetEncoded() : null;
        return v0;
    }

    protected AlgorithmParameterSpec engineGetParameterSpec(Class arg3) {
        if(arg3 == null) {
            throw new NullPointerException("argument to getParameterSpec must not be null");
        }

        return this.localEngineGetParameterSpec(arg3);
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if(!(arg3 instanceof GOST3410ParameterSpec)) {
            throw new InvalidParameterSpecException("GOST3410ParameterSpec required to initialise a GOST3410 algorithm parameters object");
        }

        this.currentSpec = ((GOST3410ParameterSpec)arg3);
    }

    protected void engineInit(byte[] arg3) {
        try {
            this.currentSpec = GOST3410ParameterSpec.fromPublicKeyAlg(new GOST3410PublicKeyAlgParameters(ASN1Primitive.fromByteArray(arg3)));
            return;
        }
        catch(ArrayIndexOutOfBoundsException v0) {
            throw new IOException("Not a valid GOST3410 Parameter encoding.");
        }
        catch(ClassCastException v0_1) {
            throw new IOException("Not a valid GOST3410 Parameter encoding.");
        }
    }

    protected void engineInit(byte[] arg4, String arg5) {
        if(!this.isASN1FormatString(arg5) && !arg5.equalsIgnoreCase("X.509")) {
            throw new IOException("Unknown parameter format " + arg5);
        }

        this.engineInit(arg4);
    }

    protected String engineToString() {
        return "GOST3410 Parameters";
    }

    protected boolean isASN1FormatString(String arg2) {
        boolean v0 = arg2 == null || (arg2.equals("ASN.1")) ? true : false;
        return v0;
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == GOST3410PublicKeyParameterSetSpec.class) {
            return this.currentSpec;
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to GOST3410 parameters object.");
    }
}

