// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.gost;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.cryptopro.GOST3410PublicKeyAlgParameters;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.params.GOST3410PrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.GOST3410Params;
import org.bouncycastle.jce.interfaces.GOST3410PrivateKey;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;
import org.bouncycastle.jce.spec.GOST3410ParameterSpec;
import org.bouncycastle.jce.spec.GOST3410PrivateKeySpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeyParameterSetSpec;

public class BCGOST3410PrivateKey implements GOST3410PrivateKey, PKCS12BagAttributeCarrier {
    private transient PKCS12BagAttributeCarrier attrCarrier;
    private transient GOST3410Params gost3410Spec;
    static final long serialVersionUID = 8581661527592305464L;
    private BigInteger x;

    protected BCGOST3410PrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    BCGOST3410PrivateKey(PrivateKeyInfo arg6) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        GOST3410PublicKeyAlgParameters v1 = new GOST3410PublicKeyAlgParameters(arg6.getAlgorithmId().getParameters());
        byte[] v2 = ASN1OctetString.getInstance(arg6.parsePrivateKey()).getOctets();
        byte[] v3 = new byte[v2.length];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v3[v0] = v2[v2.length - 1 - v0];
        }

        this.x = new BigInteger(1, v3);
        this.gost3410Spec = GOST3410ParameterSpec.fromPublicKeyAlg(v1);
    }

    BCGOST3410PrivateKey(GOST3410PrivateKeyParameters arg3, GOST3410ParameterSpec arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg3.getX();
        this.gost3410Spec = ((GOST3410Params)arg4);
        if(arg4 == null) {
            throw new IllegalArgumentException("spec is null");
        }
    }

    BCGOST3410PrivateKey(GOST3410PrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg2.getX();
        this.gost3410Spec = arg2.getParameters();
    }

    BCGOST3410PrivateKey(GOST3410PrivateKeySpec arg6) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg6.getX();
        this.gost3410Spec = new GOST3410ParameterSpec(new GOST3410PublicKeyParameterSetSpec(arg6.getP(), arg6.getQ(), arg6.getA()));
    }

    private boolean compareObj(Object arg2, Object arg3) {
        boolean v0;
        if(arg2 == arg3) {
            v0 = true;
        }
        else if(arg2 == null) {
            v0 = false;
        }
        else {
            v0 = arg2.equals(arg3);
        }

        return v0;
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof GOST3410PrivateKey)) && (this.getX().equals(((GOST3410PrivateKey)arg4).getX())) && (this.getParameters().getPublicKeyParameters().equals(((GOST3410PrivateKey)arg4).getParameters().getPublicKeyParameters())) && (this.getParameters().getDigestParamSetOID().equals(((GOST3410PrivateKey)arg4).getParameters().getDigestParamSetOID())) && (this.compareObj(this.getParameters().getEncryptionParamSetOID(), ((GOST3410PrivateKey)arg4).getParameters().getEncryptionParamSetOID()))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "GOST3410";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        int v1 = 0;
        byte[] v2 = this.getX().toByteArray();
        byte[] v0 = v2[0] == 0 ? new byte[v2.length - 1] : new byte[v2.length];
        while(v1 != v0.length) {
            v0[v1] = v2[v2.length - 1 - v1];
            ++v1;
        }

        try {
            PrivateKeyInfo v0_2 = (this.gost3410Spec instanceof GOST3410ParameterSpec) ? new PrivateKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_94, new GOST3410PublicKeyAlgParameters(new ASN1ObjectIdentifier(this.gost3410Spec.getPublicKeyParamSetOID()), new ASN1ObjectIdentifier(this.gost3410Spec.getDigestParamSetOID()))), new DEROctetString(v0)) : new PrivateKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_94), new DEROctetString(v0));
            return v0_2.getEncoded("DER");
        }
        catch(IOException v0_1) {
            return null;
        }
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public GOST3410Params getParameters() {
        return this.gost3410Spec;
    }

    public BigInteger getX() {
        return this.x;
    }

    public int hashCode() {
        return this.getX().hashCode() ^ this.gost3410Spec.hashCode();
    }

    private void readObject(ObjectInputStream arg6) {
        arg6.defaultReadObject();
        Object v0 = arg6.readObject();
        if(v0 != null) {
            this.gost3410Spec = new GOST3410ParameterSpec(((String)v0), arg6.readObject(), arg6.readObject());
        }
        else {
            this.gost3410Spec = new GOST3410ParameterSpec(new GOST3410PublicKeyParameterSetSpec(arg6.readObject(), arg6.readObject(), arg6.readObject()));
            arg6.readObject();
            arg6.readObject();
        }

        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        if(this.gost3410Spec.getPublicKeyParamSetOID() != null) {
            arg2.writeObject(this.gost3410Spec.getPublicKeyParamSetOID());
            arg2.writeObject(this.gost3410Spec.getDigestParamSetOID());
            arg2.writeObject(this.gost3410Spec.getEncryptionParamSetOID());
        }
        else {
            arg2.writeObject(null);
            arg2.writeObject(this.gost3410Spec.getPublicKeyParameters().getP());
            arg2.writeObject(this.gost3410Spec.getPublicKeyParameters().getQ());
            arg2.writeObject(this.gost3410Spec.getPublicKeyParameters().getA());
            arg2.writeObject(this.gost3410Spec.getDigestParamSetOID());
            arg2.writeObject(this.gost3410Spec.getEncryptionParamSetOID());
        }
    }
}

