// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.gost;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.cryptopro.GOST3410PublicKeyAlgParameters;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.params.GOST3410PublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jce.interfaces.GOST3410Params;
import org.bouncycastle.jce.interfaces.GOST3410PublicKey;
import org.bouncycastle.jce.spec.GOST3410ParameterSpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeyParameterSetSpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeySpec;

public class BCGOST3410PublicKey implements GOST3410PublicKey {
    private transient GOST3410Params gost3410Spec;
    static final long serialVersionUID = -6251023343619275990L;
    private BigInteger y;

    BCGOST3410PublicKey(BigInteger arg1, GOST3410ParameterSpec arg2) {
        super();
        this.y = arg1;
        this.gost3410Spec = ((GOST3410Params)arg2);
    }

    BCGOST3410PublicKey(SubjectPublicKeyInfo arg6) {
        super();
        GOST3410PublicKeyAlgParameters v1 = new GOST3410PublicKeyAlgParameters(arg6.getAlgorithmId().getParameters());
        try {
            byte[] v2 = arg6.parsePublicKey().getOctets();
            byte[] v3 = new byte[v2.length];
            int v0_1;
            for(v0_1 = 0; v0_1 != v2.length; ++v0_1) {
                v3[v0_1] = v2[v2.length - 1 - v0_1];
            }

            this.y = new BigInteger(1, v3);
        }
        catch(IOException v0) {
            goto label_30;
        }

        this.gost3410Spec = GOST3410ParameterSpec.fromPublicKeyAlg(v1);
        return;
    label_30:
        throw new IllegalArgumentException("invalid info structure in GOST3410 public key");
    }

    BCGOST3410PublicKey(GOST3410PublicKeyParameters arg2, GOST3410ParameterSpec arg3) {
        super();
        this.y = arg2.getY();
        this.gost3410Spec = ((GOST3410Params)arg3);
    }

    BCGOST3410PublicKey(GOST3410PublicKey arg2) {
        super();
        this.y = arg2.getY();
        this.gost3410Spec = arg2.getParameters();
    }

    BCGOST3410PublicKey(GOST3410PublicKeySpec arg6) {
        super();
        this.y = arg6.getY();
        this.gost3410Spec = new GOST3410ParameterSpec(new GOST3410PublicKeyParameterSetSpec(arg6.getP(), arg6.getQ(), arg6.getA()));
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof BCGOST3410PublicKey)) && (this.y.equals(((BCGOST3410PublicKey)arg4).y)) && (this.gost3410Spec.equals(((BCGOST3410PublicKey)arg4).gost3410Spec))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "GOST3410";
    }

    public byte[] getEncoded() {
        SubjectPublicKeyInfo v0_2;
        int v1 = 0;
        byte[] v2 = this.getY().toByteArray();
        byte[] v0 = v2[0] == 0 ? new byte[v2.length - 1] : new byte[v2.length];
        while(v1 != v0.length) {
            v0[v1] = v2[v2.length - 1 - v1];
            ++v1;
        }

        try {
            if(!(this.gost3410Spec instanceof GOST3410ParameterSpec)) {
                v0_2 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_94), new DEROctetString(v0));
            }
            else if(this.gost3410Spec.getEncryptionParamSetOID() != null) {
                v0_2 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_94, new GOST3410PublicKeyAlgParameters(new ASN1ObjectIdentifier(this.gost3410Spec.getPublicKeyParamSetOID()), new ASN1ObjectIdentifier(this.gost3410Spec.getDigestParamSetOID()), new ASN1ObjectIdentifier(this.gost3410Spec.getEncryptionParamSetOID()))), new DEROctetString(v0));
            }
            else {
                v0_2 = new SubjectPublicKeyInfo(new AlgorithmIdentifier(CryptoProObjectIdentifiers.gostR3410_94, new GOST3410PublicKeyAlgParameters(new ASN1ObjectIdentifier(this.gost3410Spec.getPublicKeyParamSetOID()), new ASN1ObjectIdentifier(this.gost3410Spec.getDigestParamSetOID()))), new DEROctetString(v0));
            }

            return KeyUtil.getEncodedSubjectPublicKeyInfo(v0_2);
        }
        catch(IOException v0_1) {
            return null;
        }
    }

    public String getFormat() {
        return "X.509";
    }

    public GOST3410Params getParameters() {
        return this.gost3410Spec;
    }

    public BigInteger getY() {
        return this.y;
    }

    public int hashCode() {
        return this.y.hashCode() ^ this.gost3410Spec.hashCode();
    }

    private void readObject(ObjectInputStream arg6) {
        arg6.defaultReadObject();
        Object v0 = arg6.readObject();
        if(v0 != null) {
            this.gost3410Spec = new GOST3410ParameterSpec(((String)v0), arg6.readObject(), arg6.readObject());
        }
        else {
            this.gost3410Spec = new GOST3410ParameterSpec(new GOST3410PublicKeyParameterSetSpec(arg6.readObject(), arg6.readObject(), arg6.readObject()));
            arg6.readObject();
            arg6.readObject();
        }
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("GOST3410 Public Key").append(v1);
        v0.append("            y: ").append(this.getY().toString(16)).append(v1);
        return v0.toString();
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.defaultWriteObject();
        if(this.gost3410Spec.getPublicKeyParamSetOID() != null) {
            arg2.writeObject(this.gost3410Spec.getPublicKeyParamSetOID());
            arg2.writeObject(this.gost3410Spec.getDigestParamSetOID());
            arg2.writeObject(this.gost3410Spec.getEncryptionParamSetOID());
        }
        else {
            arg2.writeObject(null);
            arg2.writeObject(this.gost3410Spec.getPublicKeyParameters().getP());
            arg2.writeObject(this.gost3410Spec.getPublicKeyParameters().getQ());
            arg2.writeObject(this.gost3410Spec.getPublicKeyParameters().getA());
            arg2.writeObject(this.gost3410Spec.getDigestParamSetOID());
            arg2.writeObject(this.gost3410Spec.getEncryptionParamSetOID());
        }
    }
}

