// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.gost;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.KeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseKeyFactorySpi;
import org.bouncycastle.jce.interfaces.GOST3410PrivateKey;
import org.bouncycastle.jce.interfaces.GOST3410PublicKey;
import org.bouncycastle.jce.spec.GOST3410PrivateKeySpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeyParameterSetSpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeySpec;

public class KeyFactorySpi extends BaseKeyFactorySpi {
    public KeyFactorySpi() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg2) {
        BCGOST3410PrivateKey v0;
        if((arg2 instanceof GOST3410PrivateKeySpec)) {
            v0 = new BCGOST3410PrivateKey(((GOST3410PrivateKeySpec)arg2));
        }
        else {
            PrivateKey v0_1 = super.engineGeneratePrivate(arg2);
        }

        return ((PrivateKey)v0);
    }

    protected PublicKey engineGeneratePublic(KeySpec arg2) {
        BCGOST3410PublicKey v0;
        if((arg2 instanceof GOST3410PublicKeySpec)) {
            v0 = new BCGOST3410PublicKey(((GOST3410PublicKeySpec)arg2));
        }
        else {
            PublicKey v0_1 = super.engineGeneratePublic(arg2);
        }

        return ((PublicKey)v0);
    }

    protected KeySpec engineGetKeySpec(Key arg6, Class arg7) {
        GOST3410PublicKeyParameterSetSpec v1;
        GOST3410PrivateKeySpec v0_1;
        if(!arg7.isAssignableFrom(GOST3410PublicKeySpec.class) || !(arg6 instanceof GOST3410PublicKey)) {
            if((arg7.isAssignableFrom(GOST3410PrivateKeySpec.class)) && ((arg6 instanceof GOST3410PrivateKey))) {
                v1 = ((GOST3410PrivateKey)arg6).getParameters().getPublicKeyParameters();
                v0_1 = new GOST3410PrivateKeySpec(((GOST3410PrivateKey)arg6).getX(), v1.getP(), v1.getQ(), v1.getA());
                goto label_13;
            }

            KeySpec v0_2 = super.engineGetKeySpec(arg6, arg7);
        }
        else {
            v1 = ((GOST3410PublicKey)arg6).getParameters().getPublicKeyParameters();
            GOST3410PublicKeySpec v0 = new GOST3410PublicKeySpec(((GOST3410PublicKey)arg6).getY(), v1.getP(), v1.getQ(), v1.getA());
        }

    label_13:
        return ((KeySpec)v0_1);
    }

    protected Key engineTranslateKey(Key arg3) {
        BCGOST3410PrivateKey v0_1;
        if((arg3 instanceof GOST3410PublicKey)) {
            BCGOST3410PublicKey v0 = new BCGOST3410PublicKey(((GOST3410PublicKey)arg3));
        }
        else if((arg3 instanceof GOST3410PrivateKey)) {
            v0_1 = new BCGOST3410PrivateKey(((GOST3410PrivateKey)arg3));
        }
        else {
            goto label_10;
        }

        return ((Key)v0_1);
    label_10:
        throw new InvalidKeyException("key type unknown");
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getPrivateKeyAlgorithm().getAlgorithm();
        if(v0.equals(CryptoProObjectIdentifiers.gostR3410_94)) {
            return new BCGOST3410PrivateKey(arg5);
        }

        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getAlgorithm().getAlgorithm();
        if(v0.equals(CryptoProObjectIdentifiers.gostR3410_94)) {
            return new BCGOST3410PublicKey(arg5);
        }

        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }
}

