// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.gost;

import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.GOST3410KeyPairGenerator;
import org.bouncycastle.crypto.params.GOST3410KeyGenerationParameters;
import org.bouncycastle.crypto.params.GOST3410Parameters;
import org.bouncycastle.jce.spec.GOST3410ParameterSpec;
import org.bouncycastle.jce.spec.GOST3410PublicKeyParameterSetSpec;

public class KeyPairGeneratorSpi extends KeyPairGenerator {
    GOST3410KeyPairGenerator engine;
    GOST3410ParameterSpec gost3410Params;
    boolean initialised;
    GOST3410KeyGenerationParameters param;
    SecureRandom random;
    int strength;

    public KeyPairGeneratorSpi() {
        super("GOST3410");
        this.engine = new GOST3410KeyPairGenerator();
        this.strength = 1024;
        this.random = null;
        this.initialised = false;
    }

    public KeyPair generateKeyPair() {
        if(!this.initialised) {
            this.init(new GOST3410ParameterSpec(CryptoProObjectIdentifiers.gostR3410_94_CryptoPro_A.getId()), new SecureRandom());
        }

        AsymmetricCipherKeyPair v1 = this.engine.generateKeyPair();
        return new KeyPair(new BCGOST3410PublicKey(v1.getPublic(), this.gost3410Params), new BCGOST3410PrivateKey(v1.getPrivate(), this.gost3410Params));
    }

    private void init(GOST3410ParameterSpec arg6, SecureRandom arg7) {
        GOST3410PublicKeyParameterSetSpec v0 = arg6.getPublicKeyParameters();
        this.param = new GOST3410KeyGenerationParameters(arg7, new GOST3410Parameters(v0.getP(), v0.getQ(), v0.getA()));
        this.engine.init(this.param);
        this.initialised = true;
        this.gost3410Params = arg6;
    }

    public void initialize(int arg1, SecureRandom arg2) {
        this.strength = arg1;
        this.random = arg2;
    }

    public void initialize(AlgorithmParameterSpec arg3, SecureRandom arg4) {
        if(!(arg3 instanceof GOST3410ParameterSpec)) {
            throw new InvalidAlgorithmParameterException("parameter object not a GOST3410ParameterSpec");
        }

        this.init(((GOST3410ParameterSpec)arg3), arg4);
    }
}

