// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ies;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.jce.spec.IESParameterSpec;

public class AlgorithmParametersSpi extends java.security.AlgorithmParametersSpi {
    IESParameterSpec currentSpec;

    public AlgorithmParametersSpi() {
        super();
    }

    protected byte[] engineGetEncoded() {
        try {
            ASN1EncodableVector v0_1 = new ASN1EncodableVector();
            v0_1.add(new DEROctetString(this.currentSpec.getDerivationV()));
            v0_1.add(new DEROctetString(this.currentSpec.getEncodingV()));
            v0_1.add(new DERInteger(((long)this.currentSpec.getMacKeySize())));
            return new DERSequence(v0_1).getEncoded("DER");
        }
        catch(IOException v0) {
            throw new RuntimeException("Error encoding IESParameters");
        }
    }

    protected byte[] engineGetEncoded(String arg2) {
        byte[] v0 = (this.isASN1FormatString(arg2)) || (arg2.equalsIgnoreCase("X.509")) ? this.engineGetEncoded() : null;
        return v0;
    }

    protected AlgorithmParameterSpec engineGetParameterSpec(Class arg3) {
        if(arg3 == null) {
            throw new NullPointerException("argument to getParameterSpec must not be null");
        }

        return this.localEngineGetParameterSpec(arg3);
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if(!(arg3 instanceof IESParameterSpec)) {
            throw new InvalidParameterSpecException("IESParameterSpec required to initialise a IES algorithm parameters object");
        }

        this.currentSpec = ((IESParameterSpec)arg3);
    }

    protected void engineInit(byte[] arg6) {
        try {
            ASN1Primitive v0_2 = ASN1Primitive.fromByteArray(arg6);
            this.currentSpec = new IESParameterSpec(((ASN1Sequence)v0_2).getObjectAt(0).getOctets(), ((ASN1Sequence)v0_2).getObjectAt(0).getOctets(), ((ASN1Sequence)v0_2).getObjectAt(0).getValue().intValue());
            return;
        }
        catch(ArrayIndexOutOfBoundsException v0) {
            throw new IOException("Not a valid IES Parameter encoding.");
        }
        catch(ClassCastException v0_1) {
            throw new IOException("Not a valid IES Parameter encoding.");
        }
    }

    protected void engineInit(byte[] arg4, String arg5) {
        if(!this.isASN1FormatString(arg5) && !arg5.equalsIgnoreCase("X.509")) {
            throw new IOException("Unknown parameter format " + arg5);
        }

        this.engineInit(arg4);
    }

    protected String engineToString() {
        return "IES Parameters";
    }

    protected boolean isASN1FormatString(String arg2) {
        boolean v0 = arg2 == null || (arg2.equals("ASN.1")) ? true : false;
        return v0;
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == IESParameterSpec.class) {
            return this.currentSpec;
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to ElGamal parameters object.");
    }
}

