// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.ies;

import java.io.ByteArrayOutputStream;
import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.BadPaddingException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.interfaces.DHPrivateKey;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.engines.IESEngine;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.IESParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.DHUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jce.interfaces.ECPrivateKey;
import org.bouncycastle.jce.interfaces.ECPublicKey;
import org.bouncycastle.jce.interfaces.IESKey;
import org.bouncycastle.jce.spec.IESParameterSpec;

public class CipherSpi extends javax.crypto.CipherSpi {
    private Class[] availableSpecs;
    private ByteArrayOutputStream buffer;
    private IESEngine cipher;
    private AlgorithmParameters engineParam;
    private IESParameterSpec engineParams;
    private int state;

    public CipherSpi(IESEngine arg4) {
        super();
        this.state = -1;
        this.buffer = new ByteArrayOutputStream();
        this.engineParam = null;
        this.engineParams = null;
        this.availableSpecs = new Class[]{IESParameterSpec.class};
        this.cipher = arg4;
    }

    protected int engineDoFinal(byte[] arg5, int arg6, int arg7, byte[] arg8, int arg9) {
        if(arg7 != 0) {
            this.buffer.write(arg5, arg6, arg7);
        }

        try {
            byte[] v0_1 = this.buffer.toByteArray();
            this.buffer.reset();
            v0_1 = this.cipher.processBlock(v0_1, 0, v0_1.length);
            System.arraycopy(v0_1, 0, arg8, arg9, v0_1.length);
            return v0_1.length;
        }
        catch(InvalidCipherTextException v0) {
            throw new BadPaddingException(v0.getMessage());
        }
    }

    protected byte[] engineDoFinal(byte[] arg5, int arg6, int arg7) {
        if(arg7 != 0) {
            this.buffer.write(arg5, arg6, arg7);
        }

        try {
            byte[] v0_1 = this.buffer.toByteArray();
            this.buffer.reset();
            return this.cipher.processBlock(v0_1, 0, v0_1.length);
        }
        catch(InvalidCipherTextException v0) {
            throw new BadPaddingException(v0.getMessage());
        }
    }

    protected int engineGetBlockSize() {
        return 0;
    }

    protected byte[] engineGetIV() {
        return null;
    }

    protected int engineGetKeySize(Key arg3) {
        int v0;
        if(!(arg3 instanceof IESKey)) {
            throw new IllegalArgumentException("must be passed IE key");
        }

        if((((IESKey)arg3).getPrivate() instanceof DHPrivateKey)) {
            v0 = ((IESKey)arg3).getPrivate().getX().bitLength();
        }
        else if((((IESKey)arg3).getPrivate() instanceof ECPrivateKey)) {
            v0 = ((IESKey)arg3).getPrivate().getD().bitLength();
        }
        else {
            goto label_20;
        }

        return v0;
    label_20:
        throw new IllegalArgumentException("not an IE key!");
    }

    protected int engineGetOutputSize(int arg3) {
        int v0;
        if(this.state == 1 || this.state == 3) {
            v0 = this.buffer.size() + arg3 + 20;
        }
        else {
            if(this.state != 2 && this.state != 4) {
                throw new IllegalStateException("cipher not initialised");
            }

            v0 = this.buffer.size() + arg3 - 20;
        }

        return v0;
    }

    protected AlgorithmParameters engineGetParameters() {
        if(this.engineParam == null && this.engineParams != null) {
            String v0 = "IES";
            try {
                this.engineParam = AlgorithmParameters.getInstance(v0, "BC");
                this.engineParam.init(this.engineParams);
            }
            catch(Exception v0_1) {
                throw new RuntimeException(v0_1.toString());
            }
        }

        return this.engineParam;
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameters arg6, SecureRandom arg7) {
        AlgorithmParameterSpec v0_1;
        AlgorithmParameterSpec v1 = null;
        if(arg6 != null) {
            int v0 = 0;
            while(true) {
                if(v0 != this.availableSpecs.length) {
                    try {
                        v0_1 = arg6.getParameterSpec(this.availableSpecs[((int)v0_1)]);
                        goto label_9;
                    }
                    catch(Exception v2) {
                        v0 = (((int)v0_1)) + 1;
                        continue;
                    }
                }
                else {
                    break;
                }

                goto label_9;
            }

            v0_1 = v1;
        label_9:
            if(v0_1 != null) {
                goto label_24;
            }

            throw new InvalidAlgorithmParameterException("can\'t handle parameter " + arg6.toString());
        }

        v0_1 = v1;
    label_24:
        this.engineParam = arg6;
        this.engineInit(arg4, arg5, v0_1, arg7);
    }

    protected void engineInit(int arg8, Key arg9, AlgorithmParameterSpec arg10, SecureRandom arg11) {
        AsymmetricKeyParameter v1_1;
        AsymmetricKeyParameter v2_2;
        AlgorithmParameterSpec v0_1;
        int v2 = 16;
        if(!(arg9 instanceof IESKey)) {
            throw new InvalidKeyException("must be passed IES key");
        }

        if(arg10 == null) {
            if(arg8 != 1 && arg8 != 3) {
                goto label_46;
            }

            byte[] v1 = new byte[v2];
            byte[] v2_1 = new byte[v2];
            if(arg11 == null) {
                arg11 = new SecureRandom();
            }

            arg11.nextBytes(v1);
            arg11.nextBytes(v2_1);
            IESParameterSpec v0 = new IESParameterSpec(v1, v2_1, 128);
        }
        else {
        label_46:
            if(!(arg10 instanceof IESParameterSpec)) {
                throw new InvalidAlgorithmParameterException("must be passed IES parameters");
            }

            v0_1 = arg10;
        }

        if((((IESKey)arg9).getPublic() instanceof ECPublicKey)) {
            v2_2 = ECUtil.generatePublicKeyParameter(((IESKey)arg9).getPublic());
            v1_1 = ECUtil.generatePrivateKeyParameter(((IESKey)arg9).getPrivate());
        }
        else {
            v2_2 = DHUtil.generatePublicKeyParameter(((IESKey)arg9).getPublic());
            v1_1 = DHUtil.generatePrivateKeyParameter(((IESKey)arg9).getPrivate());
        }

        this.engineParams = ((IESParameterSpec)v0_1);
        IESParameters v0_2 = new IESParameters(this.engineParams.getDerivationV(), this.engineParams.getEncodingV(), this.engineParams.getMacKeySize());
        this.state = arg8;
        this.buffer.reset();
        switch(arg8) {
            case 1: 
            case 3: {
                this.cipher.init(true, ((CipherParameters)v1_1), ((CipherParameters)v2_2), ((CipherParameters)v0_2));
                break;
            }
            case 2: 
            case 4: {
                this.cipher.init(false, ((CipherParameters)v1_1), ((CipherParameters)v2_2), ((CipherParameters)v0_2));
                break;
            }
            default: {
                System.out.println("eeek!");
                break;
            }
        }
    }

    protected void engineInit(int arg3, Key arg4, SecureRandom arg5) {
        if(arg3 == 1 || arg3 == 3) {
            AlgorithmParameterSpec v0 = null;
            try {
                this.engineInit(arg3, arg4, v0, arg5);
                return;
            }
            catch(InvalidAlgorithmParameterException v0_1) {
            }
        }

        throw new IllegalArgumentException("can\'t handle null parameter spec in IES");
    }

    protected void engineSetMode(String arg4) {
        throw new IllegalArgumentException("can\'t support mode " + arg4);
    }

    protected void engineSetPadding(String arg4) {
        throw new NoSuchPaddingException(arg4 + " unavailable with RSA.");
    }

    protected int engineUpdate(byte[] arg2, int arg3, int arg4, byte[] arg5, int arg6) {
        this.buffer.write(arg2, arg3, arg4);
        return 0;
    }

    protected byte[] engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.buffer.write(arg2, arg3, arg4);
        return null;
    }
}

