// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import java.security.spec.MGF1ParameterSpec;
import javax.crypto.spec.OAEPParameterSpec;
import javax.crypto.spec.PSource$PSpecified;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.RSAESOAEPparams;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.jcajce.provider.util.DigestFactory;

public class AlgorithmParametersSpi$OAEP extends AlgorithmParametersSpi {
    OAEPParameterSpec currentSpec;

    public AlgorithmParametersSpi$OAEP() {
        super();
    }

    protected byte[] engineGetEncoded() {
        RSAESOAEPparams v0 = new RSAESOAEPparams(new AlgorithmIdentifier(DigestFactory.getOID(this.currentSpec.getDigestAlgorithm()), DERNull.INSTANCE), new AlgorithmIdentifier(PKCSObjectIdentifiers.id_mgf1, new AlgorithmIdentifier(DigestFactory.getOID(this.currentSpec.getMGFParameters().getDigestAlgorithm()), DERNull.INSTANCE)), new AlgorithmIdentifier(PKCSObjectIdentifiers.id_pSpecified, new DEROctetString(this.currentSpec.getPSource().getValue())));
        try {
            return v0.getEncoded("DER");
        }
        catch(IOException v0_1) {
            throw new RuntimeException("Error encoding OAEPParameters");
        }
    }

    protected byte[] engineGetEncoded(String arg2) {
        byte[] v0 = (this.isASN1FormatString(arg2)) || (arg2.equalsIgnoreCase("X.509")) ? this.engineGetEncoded() : null;
        return v0;
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if(!(arg3 instanceof OAEPParameterSpec)) {
            throw new InvalidParameterSpecException("OAEPParameterSpec required to initialise an OAEP algorithm parameters object");
        }

        this.currentSpec = ((OAEPParameterSpec)arg3);
    }

    protected void engineInit(byte[] arg7) {
        try {
            RSAESOAEPparams v0_2 = RSAESOAEPparams.getInstance(arg7);
            this.currentSpec = new OAEPParameterSpec(v0_2.getHashAlgorithm().getAlgorithm().getId(), v0_2.getMaskGenAlgorithm().getAlgorithm().getId(), new MGF1ParameterSpec(AlgorithmIdentifier.getInstance(v0_2.getMaskGenAlgorithm().getParameters()).getAlgorithm().getId()), new PSource$PSpecified(ASN1OctetString.getInstance(v0_2.getPSourceAlgorithm().getParameters()).getOctets()));
            return;
        }
        catch(ArrayIndexOutOfBoundsException v0) {
            throw new IOException("Not a valid OAEP Parameter encoding.");
        }
        catch(ClassCastException v0_1) {
            throw new IOException("Not a valid OAEP Parameter encoding.");
        }
    }

    protected void engineInit(byte[] arg4, String arg5) {
        if(!arg5.equalsIgnoreCase("X.509") && !arg5.equalsIgnoreCase("ASN.1")) {
            throw new IOException("Unknown parameter format " + arg5);
        }

        this.engineInit(arg4);
    }

    protected String engineToString() {
        return "OAEP Parameters";
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == OAEPParameterSpec.class && this.currentSpec != null) {
            return this.currentSpec;
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to OAEP parameters object.");
    }
}

