// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import java.security.spec.MGF1ParameterSpec;
import java.security.spec.PSSParameterSpec;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.RSASSAPSSparams;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.jcajce.provider.util.DigestFactory;

public class AlgorithmParametersSpi$PSS extends AlgorithmParametersSpi {
    PSSParameterSpec currentSpec;

    public AlgorithmParametersSpi$PSS() {
        super();
    }

    protected byte[] engineGetEncoded() {
        return new RSASSAPSSparams(new AlgorithmIdentifier(DigestFactory.getOID(this.currentSpec.getDigestAlgorithm()), DERNull.INSTANCE), new AlgorithmIdentifier(PKCSObjectIdentifiers.id_mgf1, new AlgorithmIdentifier(DigestFactory.getOID(this.currentSpec.getMGFParameters().getDigestAlgorithm()), DERNull.INSTANCE)), new ASN1Integer(((long)this.currentSpec.getSaltLength())), new ASN1Integer(((long)this.currentSpec.getTrailerField()))).getEncoded("DER");
    }

    protected byte[] engineGetEncoded(String arg2) {
        byte[] v0 = (arg2.equalsIgnoreCase("X.509")) || (arg2.equalsIgnoreCase("ASN.1")) ? this.engineGetEncoded() : null;
        return v0;
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if(!(arg3 instanceof PSSParameterSpec)) {
            throw new InvalidParameterSpecException("PSSParameterSpec required to initialise an PSS algorithm parameters object");
        }

        this.currentSpec = ((PSSParameterSpec)arg3);
    }

    protected void engineInit(byte[] arg7) {
        try {
            RSASSAPSSparams v5 = RSASSAPSSparams.getInstance(arg7);
            this.currentSpec = new PSSParameterSpec(v5.getHashAlgorithm().getAlgorithm().getId(), v5.getMaskGenAlgorithm().getAlgorithm().getId(), new MGF1ParameterSpec(AlgorithmIdentifier.getInstance(v5.getMaskGenAlgorithm().getParameters()).getAlgorithm().getId()), v5.getSaltLength().intValue(), v5.getTrailerField().intValue());
            return;
        }
        catch(ArrayIndexOutOfBoundsException v0) {
            throw new IOException("Not a valid PSS Parameter encoding.");
        }
        catch(ClassCastException v0_1) {
            throw new IOException("Not a valid PSS Parameter encoding.");
        }
    }

    protected void engineInit(byte[] arg4, String arg5) {
        if(!this.isASN1FormatString(arg5) && !arg5.equalsIgnoreCase("X.509")) {
            throw new IOException("Unknown parameter format " + arg5);
        }

        this.engineInit(arg4);
    }

    protected String engineToString() {
        return "PSS Parameters";
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == PSSParameterSpec.class && this.currentSpec != null) {
            return this.currentSpec;
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to PSS parameters object.");
    }
}

