// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.math.BigInteger;
import java.security.interfaces.RSAPrivateCrtKey;
import java.security.spec.RSAPrivateCrtKeySpec;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.pkcs.RSAPrivateKey;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;

public class BCRSAPrivateCrtKey extends BCRSAPrivateKey implements RSAPrivateCrtKey {
    private BigInteger crtCoefficient;
    private BigInteger primeExponentP;
    private BigInteger primeExponentQ;
    private BigInteger primeP;
    private BigInteger primeQ;
    private BigInteger publicExponent;
    static final long serialVersionUID = 7834723820638524718L;

    BCRSAPrivateCrtKey(RSAPrivateCrtKey arg2) {
        super();
        this.modulus = arg2.getModulus();
        this.publicExponent = arg2.getPublicExponent();
        this.privateExponent = arg2.getPrivateExponent();
        this.primeP = arg2.getPrimeP();
        this.primeQ = arg2.getPrimeQ();
        this.primeExponentP = arg2.getPrimeExponentP();
        this.primeExponentQ = arg2.getPrimeExponentQ();
        this.crtCoefficient = arg2.getCrtCoefficient();
    }

    BCRSAPrivateCrtKey(RSAPrivateCrtKeySpec arg2) {
        super();
        this.modulus = arg2.getModulus();
        this.publicExponent = arg2.getPublicExponent();
        this.privateExponent = arg2.getPrivateExponent();
        this.primeP = arg2.getPrimeP();
        this.primeQ = arg2.getPrimeQ();
        this.primeExponentP = arg2.getPrimeExponentP();
        this.primeExponentQ = arg2.getPrimeExponentQ();
        this.crtCoefficient = arg2.getCrtCoefficient();
    }

    BCRSAPrivateCrtKey(PrivateKeyInfo arg2) {
        this(RSAPrivateKey.getInstance(arg2.parsePrivateKey()));
    }

    BCRSAPrivateCrtKey(RSAPrivateKey arg2) {
        super();
        this.modulus = arg2.getModulus();
        this.publicExponent = arg2.getPublicExponent();
        this.privateExponent = arg2.getPrivateExponent();
        this.primeP = arg2.getPrime1();
        this.primeQ = arg2.getPrime2();
        this.primeExponentP = arg2.getExponent1();
        this.primeExponentQ = arg2.getExponent2();
        this.crtCoefficient = arg2.getCoefficient();
    }

    BCRSAPrivateCrtKey(RSAPrivateCrtKeyParameters arg2) {
        super(((RSAKeyParameters)arg2));
        this.publicExponent = arg2.getPublicExponent();
        this.primeP = arg2.getP();
        this.primeQ = arg2.getQ();
        this.primeExponentP = arg2.getDP();
        this.primeExponentQ = arg2.getDQ();
        this.crtCoefficient = arg2.getQInv();
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if((((BCRSAPrivateCrtKey)arg5)) != this) {
            if(!(arg5 instanceof RSAPrivateCrtKey)) {
                v0 = false;
            }
            else {
                if((this.getModulus().equals(((RSAPrivateCrtKey)arg5).getModulus())) && (this.getPublicExponent().equals(((RSAPrivateCrtKey)arg5).getPublicExponent())) && (this.getPrivateExponent().equals(((RSAPrivateCrtKey)arg5).getPrivateExponent())) && (this.getPrimeP().equals(((RSAPrivateCrtKey)arg5).getPrimeP())) && (this.getPrimeQ().equals(((RSAPrivateCrtKey)arg5).getPrimeQ())) && (this.getPrimeExponentP().equals(((RSAPrivateCrtKey)arg5).getPrimeExponentP())) && (this.getPrimeExponentQ().equals(((RSAPrivateCrtKey)arg5).getPrimeExponentQ())) && (this.getCrtCoefficient().equals(((RSAPrivateCrtKey)arg5).getCrtCoefficient()))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public BigInteger getCrtCoefficient() {
        return this.crtCoefficient;
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedPrivateKeyInfo(new AlgorithmIdentifier(PKCSObjectIdentifiers.rsaEncryption, DERNull.INSTANCE), new RSAPrivateKey(this.getModulus(), this.getPublicExponent(), this.getPrivateExponent(), this.getPrimeP(), this.getPrimeQ(), this.getPrimeExponentP(), this.getPrimeExponentQ(), this.getCrtCoefficient()));
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public BigInteger getPrimeExponentP() {
        return this.primeExponentP;
    }

    public BigInteger getPrimeExponentQ() {
        return this.primeExponentQ;
    }

    public BigInteger getPrimeP() {
        return this.primeP;
    }

    public BigInteger getPrimeQ() {
        return this.primeQ;
    }

    public BigInteger getPublicExponent() {
        return this.publicExponent;
    }

    public int hashCode() {
        return this.getModulus().hashCode() ^ this.getPublicExponent().hashCode() ^ this.getPrivateExponent().hashCode();
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("RSA Private CRT Key").append(v1);
        v0.append("            modulus: ").append(this.getModulus().toString(16)).append(v1);
        v0.append("    public exponent: ").append(this.getPublicExponent().toString(16)).append(v1);
        v0.append("   private exponent: ").append(this.getPrivateExponent().toString(16)).append(v1);
        v0.append("             primeP: ").append(this.getPrimeP().toString(16)).append(v1);
        v0.append("             primeQ: ").append(this.getPrimeQ().toString(16)).append(v1);
        v0.append("     primeExponentP: ").append(this.getPrimeExponentP().toString(16)).append(v1);
        v0.append("     primeExponentQ: ").append(this.getPrimeExponentQ().toString(16)).append(v1);
        v0.append("     crtCoefficient: ").append(this.getCrtCoefficient().toString(16)).append(v1);
        return v0.toString();
    }
}

