// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.RSAPrivateKey;
import java.security.spec.RSAPrivateKeySpec;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;

public class BCRSAPrivateKey implements RSAPrivateKey, PKCS12BagAttributeCarrier {
    private static BigInteger ZERO = null;
    private transient PKCS12BagAttributeCarrierImpl attrCarrier;
    protected BigInteger modulus;
    protected BigInteger privateExponent;
    static final long serialVersionUID = 5110188922551353628L;

    static {
        BCRSAPrivateKey.ZERO = BigInteger.valueOf(0);
    }

    protected BCRSAPrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    BCRSAPrivateKey(RSAPrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.modulus = arg2.getModulus();
        this.privateExponent = arg2.getPrivateExponent();
    }

    BCRSAPrivateKey(RSAPrivateKeySpec arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.modulus = arg2.getModulus();
        this.privateExponent = arg2.getPrivateExponent();
    }

    BCRSAPrivateKey(RSAKeyParameters arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.modulus = arg2.getModulus();
        this.privateExponent = arg2.getExponent();
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if(!(arg5 instanceof RSAPrivateKey)) {
            v0 = false;
        }
        else if((((BCRSAPrivateKey)arg5)) != this) {
            if((this.getModulus().equals(((RSAPrivateKey)arg5).getModulus())) && (this.getPrivateExponent().equals(((RSAPrivateKey)arg5).getPrivateExponent()))) {
                return v0;
            }

            v0 = false;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "RSA";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedPrivateKeyInfo(new AlgorithmIdentifier(PKCSObjectIdentifiers.rsaEncryption, DERNull.INSTANCE), new org.bouncycastle.asn1.pkcs.RSAPrivateKey(this.getModulus(), BCRSAPrivateKey.ZERO, this.getPrivateExponent(), BCRSAPrivateKey.ZERO, BCRSAPrivateKey.ZERO, BCRSAPrivateKey.ZERO, BCRSAPrivateKey.ZERO, BCRSAPrivateKey.ZERO));
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public BigInteger getModulus() {
        return this.modulus;
    }

    public BigInteger getPrivateExponent() {
        return this.privateExponent;
    }

    public int hashCode() {
        return this.getModulus().hashCode() ^ this.getPrivateExponent().hashCode();
    }

    private void readObject(ObjectInputStream arg2) {
        arg2.defaultReadObject();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg1) {
        arg1.defaultWriteObject();
    }
}

