// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.io.IOException;
import java.math.BigInteger;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.RSAPublicKeySpec;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;

public class BCRSAPublicKey implements RSAPublicKey {
    private BigInteger modulus;
    private BigInteger publicExponent;
    static final long serialVersionUID = 2675817738516720772L;

    BCRSAPublicKey(RSAPublicKey arg2) {
        super();
        this.modulus = arg2.getModulus();
        this.publicExponent = arg2.getPublicExponent();
    }

    BCRSAPublicKey(RSAPublicKeySpec arg2) {
        super();
        this.modulus = arg2.getModulus();
        this.publicExponent = arg2.getPublicExponent();
    }

    BCRSAPublicKey(SubjectPublicKeyInfo arg3) {
        super();
        try {
            org.bouncycastle.asn1.pkcs.RSAPublicKey v0_1 = org.bouncycastle.asn1.pkcs.RSAPublicKey.getInstance(arg3.parsePublicKey());
            this.modulus = v0_1.getModulus();
            this.publicExponent = v0_1.getPublicExponent();
            return;
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("invalid info structure in RSA public key");
        }
    }

    BCRSAPublicKey(RSAKeyParameters arg2) {
        super();
        this.modulus = arg2.getModulus();
        this.publicExponent = arg2.getExponent();
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if((((BCRSAPublicKey)arg5)) != this) {
            if(!(arg5 instanceof RSAPublicKey)) {
                v0 = false;
            }
            else {
                if((this.getModulus().equals(((RSAPublicKey)arg5).getModulus())) && (this.getPublicExponent().equals(((RSAPublicKey)arg5).getPublicExponent()))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public String getAlgorithm() {
        return "RSA";
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedSubjectPublicKeyInfo(new AlgorithmIdentifier(PKCSObjectIdentifiers.rsaEncryption, DERNull.INSTANCE), new org.bouncycastle.asn1.pkcs.RSAPublicKey(this.getModulus(), this.getPublicExponent()));
    }

    public String getFormat() {
        return "X.509";
    }

    public BigInteger getModulus() {
        return this.modulus;
    }

    public BigInteger getPublicExponent() {
        return this.publicExponent;
    }

    public int hashCode() {
        return this.getModulus().hashCode() ^ this.getPublicExponent().hashCode();
    }

    public String toString() {
        StringBuffer v0 = new StringBuffer();
        String v1 = System.getProperty("line.separator");
        v0.append("RSA Public Key").append(v1);
        v0.append("            modulus: ").append(this.getModulus().toString(16)).append(v1);
        v0.append("    public exponent: ").append(this.getPublicExponent().toString(16)).append(v1);
        return v0.toString();
    }
}

