// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.io.ByteArrayOutputStream;
import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.InvalidParameterException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import java.security.spec.MGF1ParameterSpec;
import javax.crypto.BadPaddingException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.OAEPParameterSpec;
import javax.crypto.spec.PSource$PSpecified;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.encodings.ISO9796d1Encoding;
import org.bouncycastle.crypto.encodings.OAEPEncoding;
import org.bouncycastle.crypto.encodings.PKCS1Encoding;
import org.bouncycastle.crypto.engines.RSABlindedEngine;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseCipherSpi;
import org.bouncycastle.jcajce.provider.util.DigestFactory;
import org.bouncycastle.util.Strings;

public class CipherSpi extends BaseCipherSpi {
    private ByteArrayOutputStream bOut;
    private AsymmetricBlockCipher cipher;
    private AlgorithmParameters engineParams;
    private AlgorithmParameterSpec paramSpec;
    private boolean privateKeyOnly;
    private boolean publicKeyOnly;

    public CipherSpi(OAEPParameterSpec arg3) {
        super();
        this.publicKeyOnly = false;
        this.privateKeyOnly = false;
        this.bOut = new ByteArrayOutputStream();
        try {
            this.initFromSpec(arg3);
            return;
        }
        catch(NoSuchPaddingException v0) {
            throw new IllegalArgumentException(v0.getMessage());
        }
    }

    public CipherSpi(AsymmetricBlockCipher arg2) {
        super();
        this.publicKeyOnly = false;
        this.privateKeyOnly = false;
        this.bOut = new ByteArrayOutputStream();
        this.cipher = arg2;
    }

    public CipherSpi(boolean arg2, boolean arg3, AsymmetricBlockCipher arg4) {
        super();
        this.publicKeyOnly = false;
        this.privateKeyOnly = false;
        this.bOut = new ByteArrayOutputStream();
        this.publicKeyOnly = arg2;
        this.privateKeyOnly = arg3;
        this.cipher = arg4;
    }

    protected int engineDoFinal(byte[] arg6, int arg7, int arg8, byte[] arg9, int arg10) {
        byte[] v1;
        int v0 = 0;
        if(arg6 != null) {
            this.bOut.write(arg6, arg7, arg8);
        }

        if((this.cipher instanceof RSABlindedEngine)) {
            if(this.bOut.size() > this.cipher.getInputBlockSize() + 1) {
                throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
            }
        }
        else if(this.bOut.size() > this.cipher.getInputBlockSize()) {
            throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
        }

        try {
            v1 = this.bOut.toByteArray();
            v1 = this.cipher.processBlock(v1, 0, v1.length);
        }
        catch(Throwable v0_1) {
        }
        catch(InvalidCipherTextException v0_2) {
            try {
                throw new BadPaddingException(v0_2.getMessage());
            }
            catch(Throwable v0_1) {
                this.bOut.reset();
                throw v0_1;
            }
        }

        this.bOut.reset();
        while(v0 != v1.length) {
            arg9[arg10 + v0] = v1[v0];
            ++v0;
        }

        return v1.length;
    }

    protected byte[] engineDoFinal(byte[] arg5, int arg6, int arg7) {
        if(arg5 != null) {
            this.bOut.write(arg5, arg6, arg7);
        }

        if((this.cipher instanceof RSABlindedEngine)) {
            if(this.bOut.size() > this.cipher.getInputBlockSize() + 1) {
                throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
            }
        }
        else if(this.bOut.size() > this.cipher.getInputBlockSize()) {
            throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
        }

        try {
            byte[] v0_1 = this.bOut.toByteArray();
            this.bOut.reset();
            return this.cipher.processBlock(v0_1, 0, v0_1.length);
        }
        catch(InvalidCipherTextException v0) {
            throw new BadPaddingException(v0.getMessage());
        }
    }

    protected int engineGetBlockSize() {
        try {
            return this.cipher.getInputBlockSize();
        }
        catch(NullPointerException v0) {
            throw new IllegalStateException("RSA Cipher not initialised");
        }
    }

    protected int engineGetKeySize(Key arg3) {
        int v0;
        if((arg3 instanceof RSAPrivateKey)) {
            v0 = ((RSAPrivateKey)arg3).getModulus().bitLength();
        }
        else if((arg3 instanceof RSAPublicKey)) {
            v0 = ((RSAPublicKey)arg3).getModulus().bitLength();
        }
        else {
            goto label_10;
        }

        return v0;
    label_10:
        throw new IllegalArgumentException("not an RSA key!");
    }

    protected int engineGetOutputSize(int arg3) {
        try {
            return this.cipher.getOutputBlockSize();
        }
        catch(NullPointerException v0) {
            throw new IllegalStateException("RSA Cipher not initialised");
        }
    }

    protected AlgorithmParameters engineGetParameters() {
        if(this.engineParams == null && this.paramSpec != null) {
            try {
                this.engineParams = AlgorithmParameters.getInstance("OAEP", "BC");
                this.engineParams.init(this.paramSpec);
            }
            catch(Exception v0) {
                throw new RuntimeException(v0.toString());
            }
        }

        return this.engineParams;
    }

    protected void engineInit(int arg5, Key arg6, AlgorithmParameters arg7, SecureRandom arg8) {
        AlgorithmParameterSpec v0 = null;
        if(arg7 != null) {
            try {
                v0 = arg7.getParameterSpec(OAEPParameterSpec.class);
            }
            catch(InvalidParameterSpecException v0_1) {
                throw new InvalidAlgorithmParameterException("cannot recognise parameters: " + v0_1.toString(), ((Throwable)v0_1));
            }
        }

        this.engineParams = arg7;
        this.engineInit(arg5, arg6, v0, arg8);
    }

    protected void engineInit(int arg8, Key arg9, AlgorithmParameterSpec arg10, SecureRandom arg11) {
        ParametersWithRandom v0_1;
        RSAKeyParameters v2;
        if(arg10 != null && !(arg10 instanceof OAEPParameterSpec)) {
            throw new IllegalArgumentException("unknown parameter type.");
        }

        if((arg9 instanceof RSAPublicKey)) {
            if((this.privateKeyOnly) && arg8 == 1) {
                throw new InvalidKeyException("mode 1 requires RSAPrivateKey");
            }

            v2 = RSAUtil.generatePublicKeyParameter(((RSAPublicKey)arg9));
        }
        else {
            if(!(arg9 instanceof RSAPrivateKey)) {
                goto label_41;
            }

            if((this.publicKeyOnly) && arg8 == 1) {
                throw new InvalidKeyException("mode 2 requires RSAPublicKey");
            }

            v2 = RSAUtil.generatePrivateKeyParameter(((RSAPrivateKey)arg9));
        }

        if(arg10 != null) {
            AlgorithmParameterSpec v0 = arg10;
            this.paramSpec = arg10;
            if(!((OAEPParameterSpec)v0).getMGFAlgorithm().equalsIgnoreCase("MGF1") && !((OAEPParameterSpec)v0).getMGFAlgorithm().equals(PKCSObjectIdentifiers.id_mgf1.getId())) {
                throw new InvalidAlgorithmParameterException("unknown mask generation function specified");
            }

            if(!(((OAEPParameterSpec)v0).getMGFParameters() instanceof MGF1ParameterSpec)) {
                throw new InvalidAlgorithmParameterException("unkown MGF parameters");
            }

            Digest v3 = DigestFactory.getDigest(((OAEPParameterSpec)v0).getDigestAlgorithm());
            if(v3 == null) {
                throw new InvalidAlgorithmParameterException("no match on digest algorithm: " + ((OAEPParameterSpec)v0).getDigestAlgorithm());
            }

            AlgorithmParameterSpec v1 = ((OAEPParameterSpec)v0).getMGFParameters();
            Digest v4 = DigestFactory.getDigest(((MGF1ParameterSpec)v1).getDigestAlgorithm());
            if(v4 == null) {
                throw new InvalidAlgorithmParameterException("no match on MGF digest algorithm: " + ((MGF1ParameterSpec)v1).getDigestAlgorithm());
            }

            this.cipher = new OAEPEncoding(new RSABlindedEngine(), v3, v4, ((OAEPParameterSpec)v0).getPSource().getValue());
        }

        if((this.cipher instanceof RSABlindedEngine)) {
            RSAKeyParameters v0_2 = v2;
        }
        else if(arg11 != null) {
            v0_1 = new ParametersWithRandom(((CipherParameters)v2), arg11);
        }
        else {
            v0_1 = new ParametersWithRandom(((CipherParameters)v2), new SecureRandom());
        }

        this.bOut.reset();
        switch(arg8) {
            case 1: 
            case 3: {
                goto label_115;
            }
            case 2: 
            case 4: {
                goto label_118;
            }
        }

        throw new InvalidParameterException("unknown opmode " + arg8 + " passed to RSA");
    label_115:
        this.cipher.init(true, ((CipherParameters)v0_1));
        return;
    label_118:
        this.cipher.init(false, ((CipherParameters)v0_1));
        return;
    label_41:
        throw new InvalidKeyException("unknown key type passed to RSA");
    }

    protected void engineInit(int arg5, Key arg6, SecureRandom arg7) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.engineInit(arg5, arg6, v0, arg7);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidKeyException("Eeeek! " + v0_1.toString(), ((Throwable)v0_1));
        }
    }

    protected void engineSetMode(String arg5) {
        String v0 = Strings.toUpperCase(arg5);
        if(!v0.equals("NONE") && !v0.equals("ECB")) {
            if(v0.equals("1")) {
                this.privateKeyOnly = true;
                this.publicKeyOnly = false;
            }
            else if(v0.equals("2")) {
                this.privateKeyOnly = false;
                this.publicKeyOnly = true;
            }
            else {
                throw new NoSuchAlgorithmException("can\'t support mode " + arg5);
            }
        }
    }

    protected void engineSetPadding(String arg6) {
        String v0 = Strings.toUpperCase(arg6);
        if(v0.equals("NOPADDING")) {
            this.cipher = new RSABlindedEngine();
        }
        else if(v0.equals("PKCS1PADDING")) {
            this.cipher = new PKCS1Encoding(new RSABlindedEngine());
        }
        else if(v0.equals("ISO9796-1PADDING")) {
            this.cipher = new ISO9796d1Encoding(new RSABlindedEngine());
        }
        else if(v0.equals("OAEPWITHMD5ANDMGF1PADDING")) {
            this.initFromSpec(new OAEPParameterSpec("MD5", "MGF1", new MGF1ParameterSpec("MD5"), PSource$PSpecified.DEFAULT));
        }
        else if(v0.equals("OAEPPADDING")) {
            this.initFromSpec(OAEPParameterSpec.DEFAULT);
        }
        else {
            if(!v0.equals("OAEPWITHSHA1ANDMGF1PADDING") && !v0.equals("OAEPWITHSHA-1ANDMGF1PADDING")) {
                if(!v0.equals("OAEPWITHSHA224ANDMGF1PADDING") && !v0.equals("OAEPWITHSHA-224ANDMGF1PADDING")) {
                    if(!v0.equals("OAEPWITHSHA256ANDMGF1PADDING") && !v0.equals("OAEPWITHSHA-256ANDMGF1PADDING")) {
                        if(!v0.equals("OAEPWITHSHA384ANDMGF1PADDING") && !v0.equals("OAEPWITHSHA-384ANDMGF1PADDING")) {
                            if(!v0.equals("OAEPWITHSHA512ANDMGF1PADDING") && !v0.equals("OAEPWITHSHA-512ANDMGF1PADDING")) {
                                throw new NoSuchPaddingException(arg6 + " unavailable with RSA.");
                            }

                            this.initFromSpec(new OAEPParameterSpec("SHA-512", "MGF1", MGF1ParameterSpec.SHA512, PSource$PSpecified.DEFAULT));
                            return;
                        }

                        this.initFromSpec(new OAEPParameterSpec("SHA-384", "MGF1", MGF1ParameterSpec.SHA384, PSource$PSpecified.DEFAULT));
                        return;
                    }

                    this.initFromSpec(new OAEPParameterSpec("SHA-256", "MGF1", MGF1ParameterSpec.SHA256, PSource$PSpecified.DEFAULT));
                    return;
                }

                this.initFromSpec(new OAEPParameterSpec("SHA-224", "MGF1", new MGF1ParameterSpec("SHA-224"), PSource$PSpecified.DEFAULT));
                return;
            }

            this.initFromSpec(OAEPParameterSpec.DEFAULT);
        }
    }

    protected int engineUpdate(byte[] arg3, int arg4, int arg5, byte[] arg6, int arg7) {
        this.bOut.write(arg3, arg4, arg5);
        if((this.cipher instanceof RSABlindedEngine)) {
            if(this.bOut.size() > this.cipher.getInputBlockSize() + 1) {
                throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
            }
        }
        else if(this.bOut.size() > this.cipher.getInputBlockSize()) {
            throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
        }

        return 0;
    }

    protected byte[] engineUpdate(byte[] arg3, int arg4, int arg5) {
        this.bOut.write(arg3, arg4, arg5);
        if((this.cipher instanceof RSABlindedEngine)) {
            if(this.bOut.size() > this.cipher.getInputBlockSize() + 1) {
                throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
            }
        }
        else if(this.bOut.size() > this.cipher.getInputBlockSize()) {
            throw new ArrayIndexOutOfBoundsException("too much data for RSA block");
        }

        return null;
    }

    private void initFromSpec(OAEPParameterSpec arg5) {
        AlgorithmParameterSpec v0 = arg5.getMGFParameters();
        Digest v1 = DigestFactory.getDigest(((MGF1ParameterSpec)v0).getDigestAlgorithm());
        if(v1 == null) {
            throw new NoSuchPaddingException("no match on OAEP constructor for digest algorithm: " + ((MGF1ParameterSpec)v0).getDigestAlgorithm());
        }

        this.cipher = new OAEPEncoding(new RSABlindedEngine(), v1, arg5.getPSource().getValue());
        this.paramSpec = ((AlgorithmParameterSpec)arg5);
    }
}

