// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.security.AlgorithmParameters;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SignatureException;
import java.security.SignatureSpi;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DigestInfo;
import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.RSAKeyParameters;

public class DigestSignatureSpi extends SignatureSpi {
    private AlgorithmIdentifier algId;
    private AsymmetricBlockCipher cipher;
    private Digest digest;

    protected DigestSignatureSpi(ASN1ObjectIdentifier arg3, Digest arg4, AsymmetricBlockCipher arg5) {
        super();
        this.digest = arg4;
        this.cipher = arg5;
        this.algId = new AlgorithmIdentifier(arg3, DERNull.INSTANCE);
    }

    protected DigestSignatureSpi(Digest arg2, AsymmetricBlockCipher arg3) {
        super();
        this.digest = arg2;
        this.cipher = arg3;
        this.algId = null;
    }

    private byte[] derEncode(byte[] arg3) {
        if(this.algId != null) {
            arg3 = new DigestInfo(this.algId, arg3).getEncoded("DER");
        }

        return arg3;
    }

    protected Object engineGetParameter(String arg2) {
        return null;
    }

    protected AlgorithmParameters engineGetParameters() {
        return null;
    }

    protected void engineInitSign(PrivateKey arg4) {
        if(!(arg4 instanceof RSAPrivateKey)) {
            throw new InvalidKeyException("Supplied key (" + this.getType(arg4) + ") is not a RSAPrivateKey instance");
        }

        RSAKeyParameters v0 = RSAUtil.generatePrivateKeyParameter(((RSAPrivateKey)arg4));
        this.digest.reset();
        this.cipher.init(true, ((CipherParameters)v0));
    }

    protected void engineInitVerify(PublicKey arg4) {
        if(!(arg4 instanceof RSAPublicKey)) {
            throw new InvalidKeyException("Supplied key (" + this.getType(arg4) + ") is not a RSAPublicKey instance");
        }

        RSAKeyParameters v0 = RSAUtil.generatePublicKeyParameter(((RSAPublicKey)arg4));
        this.digest.reset();
        this.cipher.init(false, ((CipherParameters)v0));
    }

    protected void engineSetParameter(String arg3, Object arg4) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(AlgorithmParameterSpec arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected byte[] engineSign() {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            v0 = this.derEncode(v0);
            return this.cipher.processBlock(v0, 0, v0.length);
        }
        catch(Exception v0_1) {
            throw new SignatureException(v0_1.toString());
        }
        catch(ArrayIndexOutOfBoundsException v0_2) {
            throw new SignatureException("key too small for signature type");
        }
    }

    protected void engineUpdate(byte arg2) {
        this.digest.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    protected boolean engineVerify(byte[] arg11) {
        int v0_1;
        byte[] v5;
        byte[] v4;
        boolean v1 = false;
        byte[] v3 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v3, 0);
        try {
            v4 = this.cipher.processBlock(arg11, 0, arg11.length);
            v5 = this.derEncode(v3);
        }
        catch(Exception v0) {
            return v1;
        }

        if(v4.length == v5.length) {
            v0_1 = 0;
            while(v0_1 < v4.length) {
                if(v4[v0_1] == v5[v0_1]) {
                    ++v0_1;
                    continue;
                }
                else {
                    return v1;
                }
            }
        }
        else if(v4.length == v5.length - 2) {
            int v6 = v4.length - v3.length - 2;
            int v7 = v5.length - v3.length - 2;
            v5[1] = ((byte)(v5[1] - 2));
            v5[3] = ((byte)(v5[3] - 2));
            v0_1 = 0;
            while(true) {
                if(v0_1 >= v3.length) {
                    break;
                }
                else if(v4[v6 + v0_1] == v5[v7 + v0_1]) {
                    ++v0_1;
                    continue;
                }
                else {
                    return v1;
                }
            }

            v0_1 = 0;
            while(v0_1 < v6) {
                if(v4[v0_1] == v5[v0_1]) {
                    ++v0_1;
                    continue;
                }
                else {
                    return v1;
                }
            }
        }
        else {
            return v1;
        }

        return true;
    }

    private String getType(Object arg2) {
        String v0 = arg2 == null ? null : arg2.getClass().getName();
        return v0;
    }
}

