// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.interfaces.RSAPrivateCrtKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.RSAPrivateCrtKeySpec;
import java.security.spec.RSAPrivateKeySpec;
import java.security.spec.RSAPublicKeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.pkcs.RSAPrivateKey;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.asymmetric.util.BaseKeyFactorySpi;
import org.bouncycastle.jcajce.provider.asymmetric.util.ExtendedInvalidKeySpecException;

public class KeyFactorySpi extends BaseKeyFactorySpi {
    public KeyFactorySpi() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg6) {
        BCRSAPrivateCrtKey v1_2;
        if((arg6 instanceof PKCS8EncodedKeySpec)) {
            try {
                PrivateKey v1_1 = this.generatePrivate(PrivateKeyInfo.getInstance(arg6.getEncoded()));
                goto label_7;
            }
            catch(Exception v1) {
                Exception v2 = v1;
                try {
                    v1_2 = new BCRSAPrivateCrtKey(RSAPrivateKey.getInstance(((PKCS8EncodedKeySpec)arg6).getEncoded()));
                    goto label_7;
                }
                catch(Exception v1) {
                    throw new ExtendedInvalidKeySpecException("unable to process key spec: " + v2.toString(), ((Throwable)v2));
                }
            }
        }

        if((arg6 instanceof RSAPrivateCrtKeySpec)) {
            v1_2 = new BCRSAPrivateCrtKey(((RSAPrivateCrtKeySpec)arg6));
            goto label_7;
        }

        if((arg6 instanceof RSAPrivateKeySpec)) {
            BCRSAPrivateKey v1_3 = new BCRSAPrivateKey(((RSAPrivateKeySpec)arg6));
        label_7:
            return ((PrivateKey)v1_2);
        }

        throw new InvalidKeySpecException("Unknown KeySpec type: " + arg6.getClass().getName());
    }

    protected PublicKey engineGeneratePublic(KeySpec arg2) {
        BCRSAPublicKey v0;
        if((arg2 instanceof RSAPublicKeySpec)) {
            v0 = new BCRSAPublicKey(((RSAPublicKeySpec)arg2));
        }
        else {
            PublicKey v0_1 = super.engineGeneratePublic(arg2);
        }

        return ((PublicKey)v0);
    }

    protected KeySpec engineGetKeySpec(Key arg10, Class arg11) {
        RSAPrivateCrtKeySpec v0_2;
        if(!arg11.isAssignableFrom(RSAPublicKeySpec.class) || !(arg10 instanceof RSAPublicKey)) {
            if((arg11.isAssignableFrom(RSAPrivateKeySpec.class)) && ((arg10 instanceof java.security.interfaces.RSAPrivateKey))) {
                RSAPrivateKeySpec v0_1 = new RSAPrivateKeySpec(((java.security.interfaces.RSAPrivateKey)arg10).getModulus(), ((java.security.interfaces.RSAPrivateKey)arg10).getPrivateExponent());
                goto label_9;
            }

            if((arg11.isAssignableFrom(RSAPrivateCrtKeySpec.class)) && ((arg10 instanceof RSAPrivateCrtKey))) {
                v0_2 = new RSAPrivateCrtKeySpec(((RSAPrivateCrtKey)arg10).getModulus(), ((RSAPrivateCrtKey)arg10).getPublicExponent(), ((RSAPrivateCrtKey)arg10).getPrivateExponent(), ((RSAPrivateCrtKey)arg10).getPrimeP(), ((RSAPrivateCrtKey)arg10).getPrimeQ(), ((RSAPrivateCrtKey)arg10).getPrimeExponentP(), ((RSAPrivateCrtKey)arg10).getPrimeExponentQ(), ((RSAPrivateCrtKey)arg10).getCrtCoefficient());
                goto label_9;
            }

            KeySpec v0_3 = super.engineGetKeySpec(arg10, arg11);
        }
        else {
            RSAPublicKeySpec v0 = new RSAPublicKeySpec(((RSAPublicKey)arg10).getModulus(), ((RSAPublicKey)arg10).getPublicExponent());
        }

    label_9:
        return ((KeySpec)v0_2);
    }

    protected Key engineTranslateKey(Key arg3) {
        BCRSAPrivateCrtKey v0_1;
        if((arg3 instanceof RSAPublicKey)) {
            BCRSAPublicKey v0 = new BCRSAPublicKey(((RSAPublicKey)arg3));
        }
        else if((arg3 instanceof RSAPrivateCrtKey)) {
            v0_1 = new BCRSAPrivateCrtKey(((RSAPrivateCrtKey)arg3));
        }
        else if((arg3 instanceof java.security.interfaces.RSAPrivateKey)) {
            BCRSAPrivateKey v0_2 = new BCRSAPrivateKey(((java.security.interfaces.RSAPrivateKey)arg3));
        }
        else {
            goto label_15;
        }

        return ((Key)v0_1);
    label_15:
        throw new InvalidKeyException("key type unknown");
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getPrivateKeyAlgorithm().getAlgorithm();
        if(RSAUtil.isRsaOid(v0)) {
            return new BCRSAPrivateCrtKey(arg5);
        }

        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg5) {
        ASN1ObjectIdentifier v0 = arg5.getAlgorithm().getAlgorithm();
        if(RSAUtil.isRsaOid(v0)) {
            return new BCRSAPublicKey(arg5);
        }

        throw new IOException("algorithm identifier " + v0 + " in key not recognised");
    }
}

