// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.math.BigInteger;
import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.RSAKeyGenParameterSpec;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.RSAKeyPairGenerator;
import org.bouncycastle.crypto.params.RSAKeyGenerationParameters;

public class KeyPairGeneratorSpi extends KeyPairGenerator {
    static final BigInteger defaultPublicExponent = null;
    static final int defaultTests = 12;
    RSAKeyPairGenerator engine;
    RSAKeyGenerationParameters param;

    static {
        KeyPairGeneratorSpi.defaultPublicExponent = BigInteger.valueOf(65537);
    }

    public KeyPairGeneratorSpi() {
        super("RSA");
        this.engine = new RSAKeyPairGenerator();
        this.param = new RSAKeyGenerationParameters(KeyPairGeneratorSpi.defaultPublicExponent, new SecureRandom(), 2048, 12);
        this.engine.init(this.param);
    }

    public KeyPairGeneratorSpi(String arg1) {
        super(arg1);
    }

    public KeyPair generateKeyPair() {
        AsymmetricCipherKeyPair v1 = this.engine.generateKeyPair();
        return new KeyPair(new BCRSAPublicKey(v1.getPublic()), new BCRSAPrivateCrtKey(v1.getPrivate()));
    }

    public void initialize(int arg4, SecureRandom arg5) {
        this.param = new RSAKeyGenerationParameters(KeyPairGeneratorSpi.defaultPublicExponent, arg5, arg4, 12);
        this.engine.init(this.param);
    }

    public void initialize(AlgorithmParameterSpec arg5, SecureRandom arg6) {
        if(!(arg5 instanceof RSAKeyGenParameterSpec)) {
            throw new InvalidAlgorithmParameterException("parameter object not a RSAKeyGenParameterSpec");
        }

        this.param = new RSAKeyGenerationParameters(((RSAKeyGenParameterSpec)arg5).getPublicExponent(), arg6, ((RSAKeyGenParameterSpec)arg5).getKeysize(), 12);
        this.engine.init(this.param);
    }
}

