// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.rsa;

import java.security.interfaces.RSAPrivateCrtKey;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;

public class RSAUtil {
    public static final ASN1ObjectIdentifier[] rsaOids;

    static {
        RSAUtil.rsaOids = new ASN1ObjectIdentifier[]{PKCSObjectIdentifiers.rsaEncryption, X509ObjectIdentifiers.id_ea_rsa, PKCSObjectIdentifiers.id_RSAES_OAEP, PKCSObjectIdentifiers.id_RSASSA_PSS};
    }

    public RSAUtil() {
        super();
    }

    static RSAKeyParameters generatePrivateKeyParameter(RSAPrivateKey arg9) {
        RSAKeyParameters v0_1;
        if((arg9 instanceof RSAPrivateCrtKey)) {
            RSAPrivateCrtKeyParameters v0 = new RSAPrivateCrtKeyParameters(((RSAPrivateCrtKey)arg9).getModulus(), ((RSAPrivateCrtKey)arg9).getPublicExponent(), ((RSAPrivateCrtKey)arg9).getPrivateExponent(), ((RSAPrivateCrtKey)arg9).getPrimeP(), ((RSAPrivateCrtKey)arg9).getPrimeQ(), ((RSAPrivateCrtKey)arg9).getPrimeExponentP(), ((RSAPrivateCrtKey)arg9).getPrimeExponentQ(), ((RSAPrivateCrtKey)arg9).getCrtCoefficient());
        }
        else {
            v0_1 = new RSAKeyParameters(true, arg9.getModulus(), arg9.getPrivateExponent());
        }

        return v0_1;
    }

    static RSAKeyParameters generatePublicKeyParameter(RSAPublicKey arg4) {
        return new RSAKeyParameters(false, arg4.getModulus(), arg4.getPublicExponent());
    }

    public static boolean isRsaOid(ASN1ObjectIdentifier arg3) {
        boolean v1 = false;
        int v0 = 0;
        while(v0 != RSAUtil.rsaOids.length) {
            if(arg3.equals(RSAUtil.rsaOids[v0])) {
                v1 = true;
            }
            else {
                ++v0;
                continue;
            }

            return v1;
        }

        return v1;
    }
}

