// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.util;

import java.security.AlgorithmParameters;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import javax.crypto.BadPaddingException;
import javax.crypto.CipherSpi;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.RC2ParameterSpec;
import javax.crypto.spec.RC5ParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.Wrapper;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public abstract class BaseCipherSpi extends CipherSpi {
    private Class[] availableSpecs;
    protected AlgorithmParameters engineParams;
    private byte[] iv;
    private int ivSize;
    protected Wrapper wrapEngine;

    public BaseCipherSpi() {
        super();
        this.availableSpecs = new Class[]{IvParameterSpec.class, PBEParameterSpec.class, RC2ParameterSpec.class, RC5ParameterSpec.class};
        this.engineParams = null;
        this.wrapEngine = null;
    }

    public int engineGetBlockSize() {
        return 0;
    }

    protected byte[] engineGetIV() {
        return null;
    }

    public int engineGetKeySize(Key arg2) {
        return arg2.getEncoded().length;
    }

    public int engineGetOutputSize(int arg2) {
        return -1;
    }

    public AlgorithmParameters engineGetParameters() {
        return null;
    }

    public void engineSetMode(String arg4) {
        throw new NoSuchAlgorithmException("can\'t support mode " + arg4);
    }

    public void engineSetPadding(String arg4) {
        throw new NoSuchPaddingException("Padding " + arg4 + " unknown.");
    }

    protected Key engineUnwrap(byte[] arg5, String arg6, int arg7) {
        PrivateKey v0_6;
        byte[] v0_3;
        int v3 = 2;
        try {
            v0_3 = this.wrapEngine == null ? this.engineDoFinal(arg5, 0, arg5.length) : this.wrapEngine.unwrap(arg5, 0, arg5.length);
        }
        catch(IllegalBlockSizeException v0) {
            throw new InvalidKeyException(v0.getMessage());
        }
        catch(BadPaddingException v0_1) {
            throw new InvalidKeyException(v0_1.getMessage());
        }
        catch(InvalidCipherTextException v0_2) {
            throw new InvalidKeyException(v0_2.getMessage());
        }

        if(arg7 == 3) {
            SecretKeySpec v0_4 = new SecretKeySpec(v0_3, arg6);
        }
        else {
            if((arg6.equals("")) && arg7 == v3) {
                try {
                    PrivateKeyInfo v1 = PrivateKeyInfo.getInstance(v0_3);
                    v0_6 = BouncyCastleProvider.getPrivateKey(v1);
                    if(v0_6 == null) {
                        throw new InvalidKeyException("algorithm " + v1.getPrivateKeyAlgorithm().getAlgorithm() + " not supported");
                    }
                    else {
                        goto label_11;
                    }
                }
                catch(Exception v0_5) {
                    throw new InvalidKeyException("Invalid key encoding.");
                }
            }

            try {
                KeyFactory v1_1 = KeyFactory.getInstance(arg6, "BC");
                if(arg7 == 1) {
                    PublicKey v0_10 = v1_1.generatePublic(new X509EncodedKeySpec(v0_3));
                    goto label_11;
                }

                if(arg7 != v3) {
                    goto label_103;
                }

                v0_6 = v1_1.generatePrivate(new PKCS8EncodedKeySpec(v0_3));
            }
            catch(InvalidKeySpecException v0_7) {
                throw new InvalidKeyException("Unknown key type " + v0_7.getMessage());
            }
            catch(NoSuchAlgorithmException v0_8) {
                throw new InvalidKeyException("Unknown key type " + v0_8.getMessage());
            }
            catch(NoSuchProviderException v0_9) {
                throw new InvalidKeyException("Unknown key type " + v0_9.getMessage());
            }
        }

    label_11:
        return ((Key)v0_6);
    label_103:
        throw new InvalidKeyException("Unknown key type " + arg7);
    }

    protected byte[] engineWrap(Key arg5) {
        byte[] v0 = arg5.getEncoded();
        if(v0 == null) {
            throw new InvalidKeyException("Cannot wrap key, null encoding.");
        }

        try {
            return this.wrapEngine == null ? this.engineDoFinal(v0, 0, v0.length) : this.wrapEngine.wrap(v0, 0, v0.length);
        }
        catch(BadPaddingException v0_1) {
            throw new IllegalBlockSizeException(v0_1.getMessage());
        }
    }
}

