// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.util;

import java.security.Key;
import java.security.KeyFactorySpi;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.util.AsymmetricKeyInfoConverter;

public abstract class BaseKeyFactorySpi extends KeyFactorySpi implements AsymmetricKeyInfoConverter {
    public BaseKeyFactorySpi() {
        super();
    }

    public PrivateKey engineGeneratePrivate(KeySpec arg3) {
        if((arg3 instanceof PKCS8EncodedKeySpec)) {
            try {
                return this.generatePrivate(PrivateKeyInfo.getInstance(((PKCS8EncodedKeySpec)arg3).getEncoded()));
            }
            catch(Exception v0) {
                throw new InvalidKeySpecException("encoded key spec not recognised");
            }
        }

        throw new InvalidKeySpecException("key spec not recognised");
    }

    public PublicKey engineGeneratePublic(KeySpec arg3) {
        if((arg3 instanceof X509EncodedKeySpec)) {
            try {
                return this.generatePublic(SubjectPublicKeyInfo.getInstance(((X509EncodedKeySpec)arg3).getEncoded()));
            }
            catch(Exception v0) {
                throw new InvalidKeySpecException("encoded key spec not recognised");
            }
        }

        throw new InvalidKeySpecException("key spec not recognised");
    }

    public KeySpec engineGetKeySpec(Key arg4, Class arg5) {
        PKCS8EncodedKeySpec v0;
        if(!arg5.isAssignableFrom(PKCS8EncodedKeySpec.class) || !arg4.getFormat().equals("PKCS#8")) {
            if((arg5.isAssignableFrom(X509EncodedKeySpec.class)) && (arg4.getFormat().equals("X.509"))) {
                X509EncodedKeySpec v0_1 = new X509EncodedKeySpec(arg4.getEncoded());
                goto label_10;
            }

            goto label_22;
        }
        else {
            v0 = new PKCS8EncodedKeySpec(arg4.getEncoded());
        }

    label_10:
        return ((KeySpec)v0);
    label_22:
        throw new InvalidKeySpecException("not implemented yet " + arg4 + " " + arg5);
    }
}

