// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.util;

import java.math.BigInteger;
import java.security.SignatureException;
import java.security.SignatureSpi;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.DSA;
import org.bouncycastle.crypto.Digest;

public abstract class DSABase extends SignatureSpi implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    public Digest digest;
    protected DSAEncoder encoder;
    public DSA signer;

    public DSABase(Digest arg1, DSA arg2, DSAEncoder arg3) {
        super();
        this.digest = arg1;
        this.signer = arg2;
        this.encoder = arg3;
    }

    protected Object engineGetParameter(String arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(String arg3, Object arg4) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(AlgorithmParameterSpec arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected byte[] engineSign() {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            BigInteger[] v0_2 = this.signer.generateSignature(v0);
            return this.encoder.encode(v0_2[0], v0_2[1]);
        }
        catch(Exception v0_1) {
            throw new SignatureException(v0_1.toString());
        }
    }

    protected void engineUpdate(byte arg2) {
        this.digest.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    protected boolean engineVerify(byte[] arg6) {
        BigInteger[] v1;
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            v1 = this.encoder.decode(arg6);
        }
        catch(Exception v0_1) {
            throw new SignatureException("error decoding signature bytes.");
        }

        return this.signer.verifySignature(v0, v1[0], v1[1]);
    }
}

