// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.util;

import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.cryptopro.ECGOST3410NamedCurves;
import org.bouncycastle.asn1.nist.NISTNamedCurves;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.sec.SECNamedCurves;
import org.bouncycastle.asn1.teletrust.TeleTrusTNamedCurves;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962NamedCurves;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.ec.BCECPublicKey;
import org.bouncycastle.jce.interfaces.ECPrivateKey;
import org.bouncycastle.jce.interfaces.ECPublicKey;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECParameterSpec;

public class ECUtil {
    public ECUtil() {
        super();
    }

    static int[] convertMidTerms(int[] arg6) {
        int v2 = 3;
        int v4 = 2;
        int[] v0 = new int[v2];
        if(arg6.length == 1) {
            v0[0] = arg6[0];
        }
        else if(arg6.length != v2) {
            throw new IllegalArgumentException("Only Trinomials and pentanomials supported");
        }
        else {
            if(arg6[0] < arg6[1] && arg6[0] < arg6[v4]) {
                v0[0] = arg6[0];
                if(arg6[1] < arg6[v4]) {
                    v0[1] = arg6[1];
                    v0[v4] = arg6[v4];
                }
                else {
                    v0[1] = arg6[v4];
                    v0[v4] = arg6[1];
                }

                return v0;
            }

            if(arg6[1] < arg6[v4]) {
                v0[0] = arg6[1];
                if(arg6[0] < arg6[v4]) {
                    v0[1] = arg6[0];
                    v0[v4] = arg6[v4];
                    return v0;
                }

                v0[1] = arg6[v4];
                v0[v4] = arg6[0];
                return v0;
            }

            v0[0] = arg6[v4];
            if(arg6[0] < arg6[1]) {
                v0[1] = arg6[0];
                v0[v4] = arg6[1];
                return v0;
            }

            v0[1] = arg6[1];
            v0[v4] = arg6[0];
        }

        return v0;
    }

    public static AsymmetricKeyParameter generatePrivateKeyParameter(PrivateKey arg8) {
        ECPrivateKeyParameters v0_1;
        ECParameterSpec v5;
        if((arg8 instanceof ECPrivateKey)) {
            ECParameterSpec v0 = ((ECPrivateKey)arg8).getParameters();
            v5 = v0 == null ? BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa() : v0;
            v0_1 = new ECPrivateKeyParameters(((ECPrivateKey)arg8).getD(), new ECDomainParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
        }
        else {
            if((arg8 instanceof java.security.interfaces.ECPrivateKey)) {
                v5 = EC5Util.convertSpec(((java.security.interfaces.ECPrivateKey)arg8).getParams(), false);
                v0_1 = new ECPrivateKeyParameters(((java.security.interfaces.ECPrivateKey)arg8).getS(), new ECDomainParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
                goto label_18;
            }

            try {
                byte[] v0_3 = arg8.getEncoded();
                if(v0_3 == null) {
                    throw new InvalidKeyException("no encoding for EC private key");
                }

                PrivateKey v0_4 = BouncyCastleProvider.getPrivateKey(PrivateKeyInfo.getInstance(v0_3));
                if(!(v0_4 instanceof java.security.interfaces.ECPrivateKey)) {
                    goto label_59;
                }

                AsymmetricKeyParameter v0_5 = ECUtil.generatePrivateKeyParameter(v0_4);
            }
            catch(Exception v0_2) {
                throw new InvalidKeyException("cannot identify EC private key: " + v0_2.toString());
            }
        }

    label_18:
        return ((AsymmetricKeyParameter)v0_1);
    label_59:
        throw new InvalidKeyException("can\'t identify EC private key.");
    }

    public static AsymmetricKeyParameter generatePublicKeyParameter(PublicKey arg8) {
        AsymmetricKeyParameter v0_4;
        ECPublicKeyParameters v0;
        ECParameterSpec v5;
        if((arg8 instanceof ECPublicKey)) {
            v5 = ((ECPublicKey)arg8).getParameters();
            if(v5 == null) {
                v5 = BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa();
                v0 = new ECPublicKeyParameters(((BCECPublicKey)arg8).engineGetQ(), new ECDomainParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
            }
            else {
                v0 = new ECPublicKeyParameters(((ECPublicKey)arg8).getQ(), new ECDomainParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
            }
        }
        else if((arg8 instanceof java.security.interfaces.ECPublicKey)) {
            v5 = EC5Util.convertSpec(((java.security.interfaces.ECPublicKey)arg8).getParams(), false);
            v0 = new ECPublicKeyParameters(EC5Util.convertPoint(((java.security.interfaces.ECPublicKey)arg8).getParams(), ((java.security.interfaces.ECPublicKey)arg8).getW(), false), new ECDomainParameters(v5.getCurve(), v5.getG(), v5.getN(), v5.getH(), v5.getSeed()));
        }
        else {
            try {
                byte[] v0_2 = arg8.getEncoded();
                if(v0_2 == null) {
                    throw new InvalidKeyException("no encoding for EC public key");
                }
                else {
                    PublicKey v0_3 = BouncyCastleProvider.getPublicKey(SubjectPublicKeyInfo.getInstance(v0_2));
                    if((v0_3 instanceof java.security.interfaces.ECPublicKey)) {
                        v0_4 = ECUtil.generatePublicKeyParameter(v0_3);
                    }
                    else {
                        goto label_72;
                    }
                }
            }
            catch(Exception v0_1) {
                throw new InvalidKeyException("cannot identify EC public key: " + v0_1.toString());
            }
        }

        return v0_4;
    label_72:
        throw new InvalidKeyException("cannot identify EC public key.");
    }

    public static String getCurveName(ASN1ObjectIdentifier arg1) {
        String v0 = X962NamedCurves.getName(arg1);
        if(v0 == null) {
            v0 = SECNamedCurves.getName(arg1);
            if(v0 == null) {
                v0 = NISTNamedCurves.getName(arg1);
            }

            if(v0 == null) {
                v0 = TeleTrusTNamedCurves.getName(arg1);
            }

            if(v0 != null) {
                return v0;
            }

            v0 = ECGOST3410NamedCurves.getName(arg1);
        }

        return v0;
    }

    public static X9ECParameters getNamedCurveByOid(ASN1ObjectIdentifier arg1) {
        X9ECParameters v0 = X962NamedCurves.getByOID(arg1);
        if(v0 == null) {
            v0 = SECNamedCurves.getByOID(arg1);
            if(v0 == null) {
                v0 = NISTNamedCurves.getByOID(arg1);
            }

            if(v0 != null) {
                return v0;
            }

            v0 = TeleTrusTNamedCurves.getByOID(arg1);
        }

        return v0;
    }

    public static ASN1ObjectIdentifier getNamedCurveOid(String arg1) {
        ASN1ObjectIdentifier v0 = X962NamedCurves.getOID(arg1);
        if(v0 == null) {
            v0 = SECNamedCurves.getOID(arg1);
            if(v0 == null) {
                v0 = NISTNamedCurves.getOID(arg1);
            }

            if(v0 == null) {
                v0 = TeleTrusTNamedCurves.getOID(arg1);
            }

            if(v0 != null) {
                return v0;
            }

            v0 = ECGOST3410NamedCurves.getOID(arg1);
        }

        return v0;
    }
}

