// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.util;

import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OutputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;

public class PKCS12BagAttributeCarrierImpl implements PKCS12BagAttributeCarrier {
    private Hashtable pkcs12Attributes;
    private Vector pkcs12Ordering;

    public PKCS12BagAttributeCarrierImpl() {
        this(new Hashtable(), new Vector());
    }

    PKCS12BagAttributeCarrierImpl(Hashtable arg1, Vector arg2) {
        super();
        this.pkcs12Attributes = arg1;
        this.pkcs12Ordering = arg2;
    }

    Hashtable getAttributes() {
        return this.pkcs12Attributes;
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.pkcs12Attributes.get(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.pkcs12Ordering.elements();
    }

    Vector getOrdering() {
        return this.pkcs12Ordering;
    }

    public void readObject(ObjectInputStream arg4) {
        Object v0 = arg4.readObject();
        if((v0 instanceof Hashtable)) {
            this.pkcs12Attributes = ((Hashtable)v0);
            this.pkcs12Ordering = arg4.readObject();
        }
        else {
            ASN1InputStream v1 = new ASN1InputStream(((byte[])v0));
            while(true) {
                ASN1Primitive v0_1 = v1.readObject();
                if(v0_1 != null) {
                    this.setBagAttribute(((ASN1ObjectIdentifier)v0_1), v1.readObject());
                    continue;
                }

                return;
            }
        }
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        if(this.pkcs12Attributes.containsKey(arg2)) {
            this.pkcs12Attributes.put(arg2, arg3);
        }
        else {
            this.pkcs12Attributes.put(arg2, arg3);
            this.pkcs12Ordering.addElement(arg2);
        }
    }

    int size() {
        return this.pkcs12Ordering.size();
    }

    public void writeObject(ObjectOutputStream arg6) {
        if(this.pkcs12Ordering.size() == 0) {
            arg6.writeObject(new Hashtable());
            arg6.writeObject(new Vector());
        }
        else {
            ByteArrayOutputStream v1 = new ByteArrayOutputStream();
            ASN1OutputStream v2 = new ASN1OutputStream(((OutputStream)v1));
            Enumeration v3 = this.getBagAttributeKeys();
            while(v3.hasMoreElements()) {
                Object v0 = v3.nextElement();
                v2.writeObject(((ASN1Encodable)v0));
                v2.writeObject(this.pkcs12Attributes.get(v0));
            }

            arg6.writeObject(v1.toByteArray());
        }
    }
}

