// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.x509;

import java.io.InputStream;
import java.io.PushbackInputStream;
import java.security.cert.CRL;
import java.security.cert.CRLException;
import java.security.cert.CertPath;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactorySpi;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.SignedData;
import org.bouncycastle.asn1.x509.CertificateList;

public class CertificateFactory extends CertificateFactorySpi {
    private static final PEMUtil PEM_CERT_PARSER;
    private static final PEMUtil PEM_CRL_PARSER;
    private InputStream currentCrlStream;
    private InputStream currentStream;
    private ASN1Set sCrlData;
    private int sCrlDataObjectCount;
    private ASN1Set sData;
    private int sDataObjectCount;

    static {
        CertificateFactory.PEM_CERT_PARSER = new PEMUtil("CERTIFICATE");
        CertificateFactory.PEM_CRL_PARSER = new PEMUtil("CRL");
    }

    public CertificateFactory() {
        super();
        this.sData = null;
        this.sDataObjectCount = 0;
        this.currentStream = null;
        this.sCrlData = null;
        this.sCrlDataObjectCount = 0;
        this.currentCrlStream = null;
    }

    protected CRL createCRL(CertificateList arg2) {
        return new X509CRLObject(arg2);
    }

    public CRL engineGenerateCRL(InputStream arg5) {
        CRL v0_3;
        ASN1Set v0 = null;
        if(this.currentCrlStream == null) {
            this.currentCrlStream = arg5;
            this.sCrlData = v0;
            this.sCrlDataObjectCount = 0;
        }
        else if(this.currentCrlStream != arg5) {
            this.currentCrlStream = arg5;
            this.sCrlData = v0;
            this.sCrlDataObjectCount = 0;
        }

        try {
            if(this.sCrlData == null) {
                goto label_28;
            }
            else if(this.sCrlDataObjectCount != this.sCrlData.size()) {
                v0_3 = this.getCRL();
            }
            else {
                goto label_21;
            }

            return v0_3;
        }
        catch(Exception v0_1) {
            goto label_47;
        }
        catch(CRLException v0_2) {
            goto label_27;
        }

    label_21:
        ASN1Set v1 = null;
        try {
            this.sCrlData = v1;
            this.sCrlDataObjectCount = 0;
            return v0_3;
        label_28:
            PushbackInputStream v1_1 = new PushbackInputStream(arg5);
            int v2 = v1_1.read();
            if(v2 != -1) {
                v1_1.unread(v2);
                v0_3 = v2 != 48 ? this.readPEMCRL(((InputStream)v1_1)) : this.readDERCRL(new ASN1InputStream(((InputStream)v1_1), true));
            }
        }
        catch(Exception v0_1) {
        label_47:
            throw new CRLException(v0_1.toString());
        }
        catch(CRLException v0_2) {
        label_27:
            throw v0_2;
        }

        return v0_3;
    }

    public Collection engineGenerateCRLs(InputStream arg3) {
        ArrayList v0 = new ArrayList();
        while(true) {
            CRL v1 = this.engineGenerateCRL(arg3);
            if(v1 == null) {
                break;
            }

            ((List)v0).add(v1);
        }

        return ((Collection)v0);
    }

    public CertPath engineGenerateCertPath(InputStream arg2) {
        return this.engineGenerateCertPath(arg2, "PkiPath");
    }

    public CertPath engineGenerateCertPath(InputStream arg2, String arg3) {
        return new PKIXCertPath(arg2, arg3);
    }

    public CertPath engineGenerateCertPath(List arg5) {
        Object v1;
        Iterator v0 = arg5.iterator();
        do {
        label_1:
            if(!v0.hasNext()) {
                goto label_17;
            }

            v1 = v0.next();
            if(v1 == null) {
                goto label_1;
            }
        }
        while((v1 instanceof X509Certificate));

        throw new CertificateException("list contains non X509Certificate object while creating CertPath\n" + v1.toString());
    label_17:
        return new PKIXCertPath(arg5);
    }

    public Certificate engineGenerateCertificate(InputStream arg5) {
        Certificate v0_2;
        ASN1Set v0 = null;
        if(this.currentStream == null) {
            this.currentStream = arg5;
            this.sData = v0;
            this.sDataObjectCount = 0;
        }
        else if(this.currentStream != arg5) {
            this.currentStream = arg5;
            this.sData = v0;
            this.sDataObjectCount = 0;
        }

        try {
            if(this.sData == null) {
                goto label_30;
            }
            else if(this.sDataObjectCount != this.sData.size()) {
                v0_2 = this.getCertificate();
            }
            else {
                goto label_21;
            }

            goto label_14;
        }
        catch(Exception v0_1) {
            goto label_29;
        }

    label_21:
        ASN1Set v1 = null;
        try {
            this.sData = v1;
            this.sDataObjectCount = 0;
            goto label_14;
        label_30:
            PushbackInputStream v1_1 = new PushbackInputStream(arg5);
            int v2 = v1_1.read();
            if(v2 != -1) {
                v1_1.unread(v2);
                v0_2 = v2 != 48 ? this.readPEMCertificate(((InputStream)v1_1)) : this.readDERCertificate(new ASN1InputStream(((InputStream)v1_1)));
            }
        }
        catch(Exception v0_1) {
        label_29:
            throw new CertificateFactory$ExCertificateException(this, ((Throwable)v0_1));
        }

    label_14:
        return ((Certificate)v0);
    }

    public Collection engineGenerateCertificates(InputStream arg3) {
        ArrayList v0 = new ArrayList();
        while(true) {
            Certificate v1 = this.engineGenerateCertificate(arg3);
            if(v1 == null) {
                break;
            }

            ((List)v0).add(v1);
        }

        return ((Collection)v0);
    }

    public Iterator engineGetCertPathEncodings() {
        return PKIXCertPath.certPathEncodings.iterator();
    }

    private CRL getCRL() {
        CRL v0_1;
        if(this.sCrlData == null || this.sCrlDataObjectCount >= this.sCrlData.size()) {
            v0_1 = null;
        }
        else {
            ASN1Set v0 = this.sCrlData;
            int v1 = this.sCrlDataObjectCount;
            this.sCrlDataObjectCount = v1 + 1;
            v0_1 = this.createCRL(CertificateList.getInstance(v0.getObjectAt(v1)));
        }

        return v0_1;
    }

    private Certificate getCertificate() {
        Certificate v0_2;
        ASN1Encodable v1_1;
        if(this.sData != null) {
            do {
                if(this.sDataObjectCount < this.sData.size()) {
                    ASN1Set v0 = this.sData;
                    int v1 = this.sDataObjectCount;
                    this.sDataObjectCount = v1 + 1;
                    v1_1 = v0.getObjectAt(v1);
                    if(!(v1_1 instanceof ASN1Sequence)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_17;
                }
            }
            while(true);

            X509CertificateObject v0_1 = new X509CertificateObject(org.bouncycastle.asn1.x509.Certificate.getInstance(v1_1));
        }
        else {
        label_17:
            v0_2 = null;
        }

        return v0_2;
    }

    private CRL readDERCRL(ASN1InputStream arg5) {
        CRL v0_1;
        ASN1Primitive v0 = arg5.readObject();
        if(((ASN1Sequence)v0).size() <= 1 || !(((ASN1Sequence)v0).getObjectAt(0) instanceof ASN1ObjectIdentifier) || !((ASN1Sequence)v0).getObjectAt(0).equals(PKCSObjectIdentifiers.signedData)) {
            v0_1 = this.createCRL(CertificateList.getInstance(v0));
        }
        else {
            this.sCrlData = SignedData.getInstance(ASN1Sequence.getInstance(((ASN1Sequence)v0).getObjectAt(1), true)).getCRLs();
            v0_1 = this.getCRL();
        }

        return v0_1;
    }

    private Certificate readDERCertificate(ASN1InputStream arg5) {
        X509CertificateObject v0_2;
        ASN1Primitive v0 = arg5.readObject();
        if(((ASN1Sequence)v0).size() <= 1 || !(((ASN1Sequence)v0).getObjectAt(0) instanceof ASN1ObjectIdentifier) || !((ASN1Sequence)v0).getObjectAt(0).equals(PKCSObjectIdentifiers.signedData)) {
            v0_2 = new X509CertificateObject(org.bouncycastle.asn1.x509.Certificate.getInstance(v0));
        }
        else {
            this.sData = SignedData.getInstance(ASN1Sequence.getInstance(((ASN1Sequence)v0).getObjectAt(1), true)).getCertificates();
            Certificate v0_1 = this.getCertificate();
        }

        return ((Certificate)v0_2);
    }

    private CRL readPEMCRL(InputStream arg2) {
        ASN1Sequence v0 = CertificateFactory.PEM_CRL_PARSER.readPEMObject(arg2);
        CRL v0_1 = v0 != null ? this.createCRL(CertificateList.getInstance(v0)) : null;
        return v0_1;
    }

    private Certificate readPEMCertificate(InputStream arg3) {
        Certificate v0_1;
        ASN1Sequence v1 = CertificateFactory.PEM_CERT_PARSER.readPEMObject(arg3);
        if(v1 != null) {
            X509CertificateObject v0 = new X509CertificateObject(org.bouncycastle.asn1.x509.Certificate.getInstance(v1));
        }
        else {
            v0_1 = null;
        }

        return v0_1;
    }
}

