// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.x509;

import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactorySpi;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class KeyFactory extends KeyFactorySpi {
    public KeyFactory() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg5) {
        if((arg5 instanceof PKCS8EncodedKeySpec)) {
            try {
                PrivateKeyInfo v0_1 = PrivateKeyInfo.getInstance(((PKCS8EncodedKeySpec)arg5).getEncoded());
                PrivateKey v1 = BouncyCastleProvider.getPrivateKey(v0_1);
                if(v1 != null) {
                    return v1;
                }

                throw new InvalidKeySpecException("no factory found for OID: " + v0_1.getPrivateKeyAlgorithm().getAlgorithm());
            }
            catch(Exception v0) {
                throw new InvalidKeySpecException(v0.toString());
            }
        }

        throw new InvalidKeySpecException("Unknown KeySpec type: " + arg5.getClass().getName());
    }

    protected PublicKey engineGeneratePublic(KeySpec arg5) {
        if((arg5 instanceof X509EncodedKeySpec)) {
            try {
                SubjectPublicKeyInfo v0_1 = SubjectPublicKeyInfo.getInstance(((X509EncodedKeySpec)arg5).getEncoded());
                PublicKey v1 = BouncyCastleProvider.getPublicKey(v0_1);
                if(v1 != null) {
                    return v1;
                }

                throw new InvalidKeySpecException("no factory found for OID: " + v0_1.getAlgorithm().getAlgorithm());
            }
            catch(Exception v0) {
                throw new InvalidKeySpecException(v0.toString());
            }
        }

        throw new InvalidKeySpecException("Unknown KeySpec type: " + arg5.getClass().getName());
    }

    protected KeySpec engineGetKeySpec(Key arg4, Class arg5) {
        PKCS8EncodedKeySpec v0;
        if(!arg5.isAssignableFrom(PKCS8EncodedKeySpec.class) || !arg4.getFormat().equals("PKCS#8")) {
            if((arg5.isAssignableFrom(X509EncodedKeySpec.class)) && (arg4.getFormat().equals("X.509"))) {
                X509EncodedKeySpec v0_1 = new X509EncodedKeySpec(arg4.getEncoded());
                goto label_10;
            }

            goto label_22;
        }
        else {
            v0 = new PKCS8EncodedKeySpec(arg4.getEncoded());
        }

    label_10:
        return ((KeySpec)v0);
    label_22:
        throw new InvalidKeySpecException("not implemented yet " + arg4 + " " + arg5);
    }

    protected Key engineTranslateKey(Key arg4) {
        throw new InvalidKeyException("not implemented yet " + arg4);
    }
}

