// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.x509;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.security.NoSuchProviderException;
import java.security.cert.CertPath;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERSet;
import org.bouncycastle.asn1.pkcs.ContentInfo;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.SignedData;
import org.bouncycastle.util.io.pem.PemObject;
import org.bouncycastle.util.io.pem.PemWriter;

public class PKIXCertPath extends CertPath {
    static final List certPathEncodings;
    private List certificates;

    static {
        ArrayList v0 = new ArrayList();
        ((List)v0).add("PkiPath");
        ((List)v0).add("PEM");
        ((List)v0).add("PKCS7");
        PKIXCertPath.certPathEncodings = Collections.unmodifiableList(((List)v0));
    }

    PKIXCertPath(InputStream arg7, String arg8) {
        super("X.509");
        try {
            if(arg8.equalsIgnoreCase("PkiPath")) {
                ASN1Primitive v0_2 = new ASN1InputStream(arg7).readObject();
                if(!(v0_2 instanceof ASN1Sequence)) {
                    throw new CertificateException("input stream does not contain a ASN1 SEQUENCE while reading PkiPath encoded data to load CertPath");
                }
                else {
                    Enumeration v1 = ((ASN1Sequence)v0_2).getObjects();
                    this.certificates = new ArrayList();
                    CertificateFactory v2 = CertificateFactory.getInstance("X.509", "BC");
                    while(v1.hasMoreElements()) {
                        this.certificates.add(0, v2.generateCertificate(new ByteArrayInputStream(v1.nextElement().toASN1Primitive().getEncoded("DER"))));
                    }
                }
            }
            else {
                if(!arg8.equalsIgnoreCase("PKCS7") && !arg8.equalsIgnoreCase("PEM")) {
                    throw new CertificateException("unsupported encoding: " + arg8);
                }

                BufferedInputStream v0_3 = new BufferedInputStream(arg7);
                this.certificates = new ArrayList();
                CertificateFactory v1_1 = CertificateFactory.getInstance("X.509", "BC");
                while(true) {
                    Certificate v2_1 = v1_1.generateCertificate(((InputStream)v0_3));
                    if(v2_1 == null) {
                        break;
                    }

                    this.certificates.add(v2_1);
                }
            }
        }
        catch(NoSuchProviderException v0) {
            throw new CertificateException("BouncyCastle provider not found while trying to get a CertificateFactory:\n" + v0.toString());
        }
        catch(IOException v0_1) {
            throw new CertificateException("IOException throw while decoding CertPath:\n" + v0_1.toString());
        }

        this.certificates = this.sortCerts(this.certificates);
    }

    PKIXCertPath(List arg2) {
        super("X.509");
        this.certificates = this.sortCerts(new ArrayList(((Collection)arg2)));
    }

    public List getCertificates() {
        return Collections.unmodifiableList(new ArrayList(this.certificates));
    }

    public byte[] getEncoded() {
        byte[] v0_2;
        Iterator v0 = this.getEncodings();
        if(v0.hasNext()) {
            Object v0_1 = v0.next();
            if((v0_1 instanceof String)) {
                v0_2 = this.getEncoded(((String)v0_1));
            }
            else {
                goto label_8;
            }
        }
        else {
        label_8:
            v0_2 = null;
        }

        return v0_2;
    }

    public byte[] getEncoded(String arg10) {
        byte[] v0;
        ASN1Encodable v5 = null;
        if(arg10.equalsIgnoreCase("PkiPath")) {
            ASN1EncodableVector v1 = new ASN1EncodableVector();
            ListIterator v2 = this.certificates.listIterator(this.certificates.size());
            while(v2.hasPrevious()) {
                v1.add(this.toASN1Object(v2.previous()));
            }

            v0 = this.toDEREncoded(new DERSequence(v1));
        }
        else if(arg10.equalsIgnoreCase("PKCS7")) {
            ContentInfo v3 = new ContentInfo(PKCSObjectIdentifiers.data, v5);
            ASN1EncodableVector v6 = new ASN1EncodableVector();
            int v1_1;
            for(v1_1 = 0; v1_1 != this.certificates.size(); ++v1_1) {
                v6.add(this.toASN1Object(this.certificates.get(v1_1)));
            }

            v0 = this.toDEREncoded(new ContentInfo(PKCSObjectIdentifiers.signedData, new SignedData(new ASN1Integer(1), new DERSet(), v3, new DERSet(v6), ((ASN1Set)v5), new DERSet())));
        }
        else if(arg10.equalsIgnoreCase("PEM")) {
            ByteArrayOutputStream v2_1 = new ByteArrayOutputStream();
            PemWriter v3_1 = new PemWriter(new OutputStreamWriter(((OutputStream)v2_1)));
            v1_1 = 0;
            try {
                while(v1_1 != this.certificates.size()) {
                    v3_1.writeObject(new PemObject("CERTIFICATE", this.certificates.get(v1_1).getEncoded()));
                    ++v1_1;
                }

                v3_1.close();
            }
            catch(Exception v0_1) {
                throw new CertificateEncodingException("can\'t encode certificate for PEM encoded path");
            }

            v0 = v2_1.toByteArray();
        }
        else {
            goto label_87;
        }

        return v0;
    label_87:
        throw new CertificateEncodingException("unsupported encoding: " + arg10);
    }

    public Iterator getEncodings() {
        return PKIXCertPath.certPathEncodings.iterator();
    }

    private List sortCerts(List arg10) {
        ArrayList v10;
        Object v0_1;
        if(arg10.size() >= 2) {
            int v1 = 1;
            X500Principal v3 = arg10.get(0).getIssuerX500Principal();
            while(true) {
                if(v1 == arg10.size()) {
                    goto label_82;
                }
                else if(v3.equals(arg10.get(v1).getSubjectX500Principal())) {
                    v3 = arg10.get(v1).getIssuerX500Principal();
                    ++v1;
                    continue;
                }
                else {
                    break;
                }
            }

            int v0 = 0;
            goto label_22;
        label_82:
            v0 = 1;
        label_22:
            if(v0 != 0) {
                goto label_5;
            }

            ArrayList v7 = new ArrayList(arg10.size());
            ArrayList v6 = new ArrayList(((Collection)arg10));
            int v3_1;
            for(v3_1 = 0; v3_1 < arg10.size(); ++v3_1) {
                v0_1 = arg10.get(v3_1);
                X500Principal v8 = ((X509Certificate)v0_1).getSubjectX500Principal();
                int v5 = 0;
                while(true) {
                    if(v5 == arg10.size()) {
                        break;
                    }
                    else if(arg10.get(v5).getIssuerX500Principal().equals(v8)) {
                        v1 = 1;
                    }
                    else {
                        ++v5;
                        continue;
                    }

                    goto label_41;
                }

                v1 = 0;
            label_41:
                if(v1 == 0) {
                    ((List)v7).add(v0_1);
                    arg10.remove(v3_1);
                }
            }

            if(((List)v7).size() > 1) {
                v10 = v6;
                goto label_5;
            }

            for(v1 = 0; v1 != ((List)v7).size(); ++v1) {
                v3 = ((List)v7).get(v1).getIssuerX500Principal();
                int v2 = 0;
                while(v2 < arg10.size()) {
                    v0_1 = arg10.get(v2);
                    if(v3.equals(((X509Certificate)v0_1).getSubjectX500Principal())) {
                        ((List)v7).add(v0_1);
                        arg10.remove(v2);
                    }
                    else {
                        ++v2;
                        continue;
                    }

                    break;
                }
            }

            if(arg10.size() > 0) {
                v10 = v6;
                goto label_5;
            }

            v10 = v7;
        }

    label_5:
        return ((List)v10);
    }

    private ASN1Primitive toASN1Object(X509Certificate arg5) {
        try {
            return new ASN1InputStream(arg5.getEncoded()).readObject();
        }
        catch(Exception v0) {
            throw new CertificateEncodingException("Exception while encoding certificate: " + v0.toString());
        }
    }

    private byte[] toDEREncoded(ASN1Encodable arg5) {
        try {
            return arg5.toASN1Primitive().getEncoded("DER");
        }
        catch(IOException v0) {
            throw new CertificateEncodingException("Exception thrown: " + v0);
        }
    }
}

