// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.x509;

import java.io.IOException;
import java.math.BigInteger;
import java.security.Principal;
import java.security.PublicKey;
import java.security.Signature;
import java.security.SignatureException;
import java.security.cert.CRLException;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;
import java.security.cert.X509CRL;
import java.security.cert.X509CRLEntry;
import java.security.cert.X509Certificate;
import java.util.Collections;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.util.ASN1Dump;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.CRLDistPoint;
import org.bouncycastle.asn1.x509.CRLNumber;
import org.bouncycastle.asn1.x509.CertificateList;
import org.bouncycastle.asn1.x509.Extension;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.IssuingDistributionPoint;
import org.bouncycastle.asn1.x509.TBSCertList$CRLEntry;
import org.bouncycastle.jce.X509Principal;
import org.bouncycastle.jce.provider.RFC3280CertPathUtilities;
import org.bouncycastle.util.encoders.Hex;

class X509CRLObject extends X509CRL {
    private CertificateList c;
    private boolean isIndirect;
    private String sigAlgName;
    private byte[] sigAlgParams;

    public X509CRLObject(CertificateList arg5) {
        super();
        this.c = arg5;
        try {
            this.sigAlgName = X509SignatureUtil.getSignatureName(arg5.getSignatureAlgorithm());
            this.sigAlgParams = arg5.getSignatureAlgorithm().getParameters() != null ? arg5.getSignatureAlgorithm().getParameters().toASN1Primitive().getEncoded("DER") : null;
            this.isIndirect = X509CRLObject.isIndirectCRL(((X509CRL)this));
            return;
        }
        catch(Exception v0) {
            throw new CRLException("CRL contents invalid: " + v0);
        }
    }

    public Set getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    public byte[] getEncoded() {
        try {
            return this.c.getEncoded("DER");
        }
        catch(IOException v0) {
            throw new CRLException(v0.toString());
        }
    }

    private Set getExtensionOIDs(boolean arg6) {
        Set v0_2;
        if(this.getVersion() == 2) {
            Extensions v2 = this.c.getTBSCertList().getExtensions();
            if(v2 != null) {
                HashSet v1 = new HashSet();
                Enumeration v3 = v2.oids();
                while(v3.hasMoreElements()) {
                    Object v0 = v3.nextElement();
                    if(arg6 != v2.getExtension(((ASN1ObjectIdentifier)v0)).isCritical()) {
                        continue;
                    }

                    ((Set)v1).add(((ASN1ObjectIdentifier)v0).getId());
                }

                HashSet v0_1 = v1;
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            v0_2 = null;
        }

        return v0_2;
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_3;
        Extensions v0 = this.c.getTBSCertList().getExtensions();
        if(v0 != null) {
            Extension v0_1 = v0.getExtension(new ASN1ObjectIdentifier(arg5));
            if(v0_1 != null) {
                try {
                    v0_3 = v0_1.getExtnValue().getEncoded();
                }
                catch(Exception v0_2) {
                    throw new IllegalStateException("error parsing " + v0_2.toString());
                }
            }
            else {
                goto label_22;
            }
        }
        else {
        label_22:
            v0_3 = null;
        }

        return v0_3;
    }

    public Principal getIssuerDN() {
        return new X509Principal(X500Name.getInstance(this.c.getIssuer().toASN1Primitive()));
    }

    public X500Principal getIssuerX500Principal() {
        try {
            return new X500Principal(this.c.getIssuer().getEncoded());
        }
        catch(IOException v0) {
            throw new IllegalStateException("can\'t encode issuer DN");
        }
    }

    public Date getNextUpdate() {
        Date v0 = this.c.getNextUpdate() != null ? this.c.getNextUpdate().getDate() : null;
        return v0;
    }

    public Set getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public X509CRLEntry getRevokedCertificate(BigInteger arg6) {
        X500Name v0_2;
        X509CRLEntryObject v2_1;
        X509CRLEntry v2 = null;
        Enumeration v3 = this.c.getRevokedCertificateEnumeration();
        X500Name v1 = ((X500Name)v2);
        while(v3.hasMoreElements()) {
            Object v0 = v3.nextElement();
            if(arg6.equals(((TBSCertList$CRLEntry)v0).getUserCertificate().getValue())) {
                v2_1 = new X509CRLEntryObject(((TBSCertList$CRLEntry)v0), this.isIndirect, v1);
            }
            else {
                if(!this.isIndirect || !((TBSCertList$CRLEntry)v0).hasExtensions()) {
                label_32:
                    v0_2 = v1;
                }
                else {
                    Extension v0_1 = ((TBSCertList$CRLEntry)v0).getExtensions().getExtension(Extension.certificateIssuer);
                    if(v0_1 != null) {
                        v0_2 = X500Name.getInstance(GeneralNames.getInstance(v0_1.getParsedValue()).getNames()[0].getName());
                    }
                    else {
                        goto label_32;
                    }
                }

                v1 = v0_2;
                continue;
            }

            break;
        }

        return ((X509CRLEntry)v2_1);
    }

    public Set getRevokedCertificates() {
        Set v0 = this.loadCRLEntries();
        return !v0.isEmpty() ? Collections.unmodifiableSet(v0) : null;
    }

    public String getSigAlgName() {
        return this.sigAlgName;
    }

    public String getSigAlgOID() {
        return this.c.getSignatureAlgorithm().getAlgorithm().getId();
    }

    public byte[] getSigAlgParams() {
        byte[] v0;
        if(this.sigAlgParams != null) {
            v0 = new byte[this.sigAlgParams.length];
            System.arraycopy(this.sigAlgParams, 0, v0, 0, v0.length);
        }
        else {
            v0 = null;
        }

        return v0;
    }

    public byte[] getSignature() {
        return this.c.getSignature().getBytes();
    }

    public byte[] getTBSCertList() {
        try {
            return this.c.getTBSCertList().getEncoded("DER");
        }
        catch(IOException v0) {
            throw new CRLException(v0.toString());
        }
    }

    public Date getThisUpdate() {
        return this.c.getThisUpdate().getDate();
    }

    public int getVersion() {
        return this.c.getVersionNumber();
    }

    public boolean hasUnsupportedCriticalExtension() {
        boolean v0 = false;
        Set v1 = this.getCriticalExtensionOIDs();
        if(v1 != null) {
            v1.remove(RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT);
            v1.remove(RFC3280CertPathUtilities.DELTA_CRL_INDICATOR);
            if(!v1.isEmpty()) {
                v0 = true;
            }
        }

        return v0;
    }

    static boolean isIndirectCRL(X509CRL arg3) {
        try {
            byte[] v0_1 = arg3.getExtensionValue(Extension.issuingDistributionPoint.getId());
            if(v0_1 == null) {
                return false;
            }
            else if(!IssuingDistributionPoint.getInstance(ASN1OctetString.getInstance(v0_1).getOctets()).isIndirectCRL()) {
                return false;
            }
        }
        catch(Exception v0) {
            throw new ExtCRLException("Exception reading IssuingDistributionPoint", ((Throwable)v0));
        }

        boolean v0_2 = true;
        return v0_2;
    }

    public boolean isRevoked(Certificate arg8) {
        X500Name v0_1;
        boolean v1 = false;
        if(!arg8.getType().equals("X.509")) {
            throw new RuntimeException("X.509 CRL used with non X.509 Cert");
        }

        TBSCertList$CRLEntry[] v3 = this.c.getRevokedCertificates();
        X500Name v2 = this.c.getIssuer();
        if(v3 != null) {
            BigInteger v4 = arg8.getSerialNumber();
            int v0;
            for(v0 = 0; v0 < v3.length; ++v0) {
                if((this.isIndirect) && (v3[v0].hasExtensions())) {
                    Extension v5 = v3[v0].getExtensions().getExtension(Extension.certificateIssuer);
                    if(v5 != null) {
                        v2 = X500Name.getInstance(GeneralNames.getInstance(v5.getParsedValue()).getNames()[0].getName());
                    }
                }

                if(v3[v0].getUserCertificate().getValue().equals(v4)) {
                    if((arg8 instanceof X509Certificate)) {
                        v0_1 = X500Name.getInstance(((X509Certificate)arg8).getIssuerX500Principal().getEncoded());
                    }
                    else {
                        try {
                            v0_1 = org.bouncycastle.asn1.x509.Certificate.getInstance(arg8.getEncoded()).getIssuer();
                        }
                        catch(CertificateEncodingException v0_2) {
                            throw new RuntimeException("Cannot process certificate");
                        }
                    }

                    if(!v2.equals(v0_1)) {
                        return v1;
                    }

                    return true;
                }
            }
        }

        return v1;
    }

    private Set loadCRLEntries() {
        X500Name v0_2;
        HashSet v2 = new HashSet();
        Enumeration v3 = this.c.getRevokedCertificateEnumeration();
        X500Name v1;
        for(v1 = null; v3.hasMoreElements(); v1 = v0_2) {
            Object v0 = v3.nextElement();
            ((Set)v2).add(new X509CRLEntryObject(((TBSCertList$CRLEntry)v0), this.isIndirect, v1));
            if(!this.isIndirect || !((TBSCertList$CRLEntry)v0).hasExtensions()) {
            label_30:
                v0_2 = v1;
            }
            else {
                Extension v0_1 = ((TBSCertList$CRLEntry)v0).getExtensions().getExtension(Extension.certificateIssuer);
                if(v0_1 != null) {
                    v0_2 = X500Name.getInstance(GeneralNames.getInstance(v0_1.getParsedValue()).getNames()[0].getName());
                }
                else {
                    goto label_30;
                }
            }
        }

        return ((Set)v2);
    }

    public String toString() {
        int v1 = 20;
        StringBuffer v2 = new StringBuffer();
        String v3 = System.getProperty("line.separator");
        v2.append("              Version: ").append(this.getVersion()).append(v3);
        v2.append("             IssuerDN: ").append(this.getIssuerDN()).append(v3);
        v2.append("          This update: ").append(this.getThisUpdate()).append(v3);
        v2.append("          Next update: ").append(this.getNextUpdate()).append(v3);
        v2.append("  Signature Algorithm: ").append(this.getSigAlgName()).append(v3);
        byte[] v4 = this.getSignature();
        v2.append("            Signature: ").append(new String(Hex.encode(v4, 0, v1))).append(v3);
        int v0;
        for(v0 = v1; v0 < v4.length; v0 += 20) {
            if(v0 < v4.length - 20) {
                v2.append("                       ").append(new String(Hex.encode(v4, v0, v1))).append(v3);
            }
            else {
                v2.append("                       ").append(new String(Hex.encode(v4, v0, v4.length - v0))).append(v3);
            }
        }

        Extensions v1_1 = this.c.getTBSCertList().getExtensions();
        if(v1_1 != null) {
            Enumeration v4_1 = v1_1.oids();
            if(v4_1.hasMoreElements()) {
                v2.append("           Extensions: ").append(v3);
            }

            while(v4_1.hasMoreElements()) {
                Object v0_1 = v4_1.nextElement();
                Extension v5 = v1_1.getExtension(((ASN1ObjectIdentifier)v0_1));
                if(v5.getExtnValue() != null) {
                    ASN1InputStream v7 = new ASN1InputStream(v5.getExtnValue().getOctets());
                    v2.append("                       critical(").append(v5.isCritical()).append(") ");
                    try {
                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.cRLNumber)) {
                            v2.append(new CRLNumber(ASN1Integer.getInstance(v7.readObject()).getPositiveValue())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.deltaCRLIndicator)) {
                            v2.append("Base CRL: " + new CRLNumber(ASN1Integer.getInstance(v7.readObject()).getPositiveValue())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.issuingDistributionPoint)) {
                            v2.append(IssuingDistributionPoint.getInstance(v7.readObject())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.cRLDistributionPoints)) {
                            v2.append(CRLDistPoint.getInstance(v7.readObject())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.freshestCRL)) {
                            v2.append(CRLDistPoint.getInstance(v7.readObject())).append(v3);
                            continue;
                        }

                        v2.append(((ASN1ObjectIdentifier)v0_1).getId());
                        v2.append(" value = ").append(ASN1Dump.dumpAsString(v7.readObject())).append(v3);
                    }
                    catch(Exception v5_1) {
                        v2.append(((ASN1ObjectIdentifier)v0_1).getId());
                        v2.append(" value = ").append("*****").append(v3);
                    }

                    continue;
                }

                v2.append(v3);
            }
        }

        Set v0_2 = this.getRevokedCertificates();
        if(v0_2 != null) {
            Iterator v0_3 = v0_2.iterator();
            while(v0_3.hasNext()) {
                v2.append(v0_3.next());
                v2.append(v3);
            }
        }

        return v2.toString();
    }

    public void verify(PublicKey arg2) {
        this.verify(arg2, "BC");
    }

    public void verify(PublicKey arg3, String arg4) {
        if(!this.c.getSignatureAlgorithm().equals(this.c.getTBSCertList().getSignature())) {
            throw new CRLException("Signature algorithm on CertificateList does not match TBSCertList.");
        }

        Signature v0 = arg4 != null ? Signature.getInstance(this.getSigAlgName(), arg4) : Signature.getInstance(this.getSigAlgName());
        v0.initVerify(arg3);
        v0.update(this.getTBSCertList());
        if(!v0.verify(this.getSignature())) {
            throw new SignatureException("CRL does not verify with supplied public key.");
        }
    }
}

