// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.asymmetric.x509;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.Principal;
import java.security.Provider;
import java.security.PublicKey;
import java.security.Security;
import java.security.Signature;
import java.security.SignatureException;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OutputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.misc.MiscObjectIdentifiers;
import org.bouncycastle.asn1.misc.NetscapeCertType;
import org.bouncycastle.asn1.misc.NetscapeRevocationURL;
import org.bouncycastle.asn1.misc.VerisignCzagExtension;
import org.bouncycastle.asn1.util.ASN1Dump;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x500.style.RFC4519Style;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.BasicConstraints;
import org.bouncycastle.asn1.x509.Certificate;
import org.bouncycastle.asn1.x509.Extension;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.KeyUsage;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.X509Principal;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.provider.RFC3280CertPathUtilities;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Integers;
import org.bouncycastle.util.encoders.Hex;

class X509CertificateObject extends X509Certificate implements PKCS12BagAttributeCarrier {
    private PKCS12BagAttributeCarrier attrCarrier;
    private BasicConstraints basicConstraints;
    private Certificate c;
    private int hashValue;
    private boolean hashValueSet;
    private boolean[] keyUsage;

    public X509CertificateObject(Certificate arg9) {
        boolean v0_2;
        boolean[] v5;
        int v2_2;
        int v3;
        byte[] v2;
        int v0 = 9;
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.c = arg9;
        try {
            v2 = this.getExtensionBytes("2.5.29.19");
            if(v2 != null) {
                this.basicConstraints = BasicConstraints.getInstance(ASN1Primitive.fromByteArray(v2));
            }
        }
        catch(Exception v0_1) {
            throw new CertificateParsingException("cannot construct BasicConstraints: " + v0_1);
        }

        try {
            v2 = this.getExtensionBytes("2.5.29.15");
            if(v2 != null) {
                DERBitString v2_1 = DERBitString.getInstance(ASN1Primitive.fromByteArray(v2));
                byte[] v4 = v2_1.getBytes();
                v3 = v4.length * 8 - v2_1.getPadBits();
                if(v3 >= v0) {
                    goto label_51;
                }

                goto label_24;
            }
            else {
                goto label_55;
            }
        }
        catch(Exception v0_1) {
            goto label_67;
        }

    label_51:
        v0 = v3;
        try {
        label_24:
            this.keyUsage = new boolean[v0];
            v2_2 = 0;
            while(true) {
            label_27:
                if(v2_2 == v3) {
                    return;
                }

                v5 = this.keyUsage;
                if((v4[v2_2 / 8] & 128 >>> v2_2 % 8) != 0) {
                    v0_2 = true;
                }
                else {
                    break;
                }

                goto label_37;
            }
        }
        catch(Exception v0_1) {
            goto label_67;
        }

        v0_2 = false;
        try {
        label_37:
            v5[v2_2] = v0_2;
            ++v2_2;
            goto label_27;
        }
        catch(Exception v0_1) {
            goto label_67;
        }

    label_55:
        boolean[] v0_3 = null;
        try {
            this.keyUsage = v0_3;
        }
        catch(Exception v0_1) {
        label_67:
            throw new CertificateParsingException("cannot construct KeyUsage: " + v0_1);
        }
    }

    private int calculateHashCode() {
        try {
            byte[] v4 = this.getEncoded();
            int v2 = 1;
            int v0_1;
            for(v0_1 = 0; v2 < v4.length; v0_1 = v3) {
                int v3 = v4[v2] * v2 + v0_1;
                ++v2;
            }
        }
        catch(CertificateEncodingException v0) {
            v0_1 = 0;
        }

        return v0_1;
    }

    private void checkSignature(PublicKey arg3, Signature arg4) {
        if(!this.isAlgIdEqual(this.c.getSignatureAlgorithm(), this.c.getTBSCertificate().getSignature())) {
            throw new CertificateException("signature algorithm in TBS cert not same as outer cert");
        }

        X509SignatureUtil.setSignatureParameters(arg4, this.c.getSignatureAlgorithm().getParameters());
        arg4.initVerify(arg3);
        arg4.update(this.getTBSCertificate());
        if(!arg4.verify(this.getSignature())) {
            throw new SignatureException("certificate does not verify with supplied key");
        }
    }

    public void checkValidity() {
        this.checkValidity(new Date());
    }

    public void checkValidity(Date arg5) {
        if(arg5.getTime() > this.getNotAfter().getTime()) {
            throw new CertificateExpiredException("certificate expired on " + this.c.getEndDate().getTime());
        }

        if(arg5.getTime() < this.getNotBefore().getTime()) {
            throw new CertificateNotYetValidException("certificate not valid till " + this.c.getStartDate().getTime());
        }
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if((((X509CertificateObject)arg4)) == this) {
            return true;
        }

        if((arg4 instanceof java.security.cert.Certificate)) {
            try {
                v0 = Arrays.areEqual(this.getEncoded(), ((java.security.cert.Certificate)arg4).getEncoded());
            }
            catch(CertificateEncodingException v1) {
            }
        }

        return v0;
    }

    private static Collection getAlternativeNames(byte[] arg6) {
        String v0_5;
        ArrayList v4;
        GeneralName v0_2;
        ArrayList v2;
        Collection v0;
        Collection v1 = null;
        if(arg6 == null) {
            v0 = v1;
            return v0;
        }

        try {
            v2 = new ArrayList();
            Enumeration v3 = ASN1Sequence.getInstance(arg6).getObjects();
            while(true) {
            label_8:
                if(!v3.hasMoreElements()) {
                    goto label_61;
                }

                v0_2 = GeneralName.getInstance(v3.nextElement());
                v4 = new ArrayList();
                ((List)v4).add(Integers.valueOf(v0_2.getTagNo()));
                switch(v0_2.getTagNo()) {
                    case 4: {
                        goto label_39;
                    }
                    case 0: 
                    case 3: 
                    case 5: {
                        goto label_34;
                    }
                    case 1: 
                    case 2: 
                    case 6: {
                        goto label_45;
                    }
                    case 7: {
                        goto label_54;
                    }
                    case 8: {
                        goto label_49;
                    }
                }

                throw new IOException("Bad tag number: " + v0_2.getTagNo());
            label_54:
                byte[] v0_3 = DEROctetString.getInstance(v0_2.getName()).getOctets();
                try {
                    v0_5 = InetAddress.getByAddress(v0_3).getHostAddress();
                    break;
                }
                catch(UnknownHostException v0_4) {
                    continue;
                }
            }
        }
        catch(Exception v0_1) {
            goto label_33;
        }

        try {
            ((List)v4).add(v0_5);
            goto label_36;
        label_39:
            ((List)v4).add(X500Name.getInstance(RFC4519Style.INSTANCE, v0_2.getName()).toString());
            goto label_36;
        label_49:
            ((List)v4).add(ASN1ObjectIdentifier.getInstance(v0_2.getName()).getId());
            goto label_36;
        label_34:
            ((List)v4).add(v0_2.getEncoded());
            goto label_36;
        label_45:
            ((List)v4).add(v0_2.getName().getString());
        label_36:
            ((Collection)v2).add(Collections.unmodifiableList(((List)v4)));
            goto label_8;
        label_61:
            if(((Collection)v2).size() == 0) {
                return v1;
            }

            v0 = Collections.unmodifiableCollection(((Collection)v2));
        }
        catch(Exception v0_1) {
            goto label_33;
        }

        return v0;
    label_33:
        throw new CertificateParsingException(v0_1.getMessage());
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public int getBasicConstraints() {
        int v0 = -1;
        if(this.basicConstraints != null && (this.basicConstraints.isCA())) {
            v0 = this.basicConstraints.getPathLenConstraint() == null ? 2147483647 : this.basicConstraints.getPathLenConstraint().intValue();
        }

        return v0;
    }

    public Set getCriticalExtensionOIDs() {
        Set v0_2;
        if(this.getVersion() == 3) {
            HashSet v1 = new HashSet();
            Extensions v2 = this.c.getTBSCertificate().getExtensions();
            if(v2 != null) {
                Enumeration v3 = v2.oids();
                while(v3.hasMoreElements()) {
                    Object v0 = v3.nextElement();
                    if(!v2.getExtension(((ASN1ObjectIdentifier)v0)).isCritical()) {
                        continue;
                    }

                    ((Set)v1).add(((ASN1ObjectIdentifier)v0).getId());
                }

                HashSet v0_1 = v1;
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            v0_2 = null;
        }

        return v0_2;
    }

    public byte[] getEncoded() {
        try {
            return this.c.getEncoded("DER");
        }
        catch(IOException v0) {
            throw new CertificateEncodingException(v0.toString());
        }
    }

    public List getExtendedKeyUsage() {
        List v0_3;
        byte[] v0 = this.getExtensionBytes("2.5.29.37");
        if(v0 != null) {
            try {
                ASN1Primitive v0_2 = new ASN1InputStream(v0).readObject();
                ArrayList v3 = new ArrayList();
                int v2;
                for(v2 = 0; v2 != ((ASN1Sequence)v0_2).size(); ++v2) {
                    ((List)v3).add(((ASN1Sequence)v0_2).getObjectAt(v2).getId());
                }

                v0_3 = Collections.unmodifiableList(((List)v3));
            }
            catch(Exception v0_1) {
                throw new CertificateParsingException("error processing extended key usage extension");
            }
        }
        else {
            v0_3 = null;
        }

        return v0_3;
    }

    private byte[] getExtensionBytes(String arg3) {
        byte[] v0_2;
        Extensions v0 = this.c.getTBSCertificate().getExtensions();
        if(v0 != null) {
            Extension v0_1 = v0.getExtension(new ASN1ObjectIdentifier(arg3));
            if(v0_1 != null) {
                v0_2 = v0_1.getExtnValue().getOctets();
            }
            else {
                goto label_11;
            }
        }
        else {
        label_11:
            v0_2 = null;
        }

        return v0_2;
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_3;
        Extensions v0 = this.c.getTBSCertificate().getExtensions();
        if(v0 != null) {
            Extension v0_1 = v0.getExtension(new ASN1ObjectIdentifier(arg5));
            if(v0_1 != null) {
                try {
                    v0_3 = v0_1.getExtnValue().getEncoded();
                }
                catch(Exception v0_2) {
                    throw new IllegalStateException("error parsing " + v0_2.toString());
                }
            }
            else {
                goto label_22;
            }
        }
        else {
        label_22:
            v0_3 = null;
        }

        return v0_3;
    }

    public Collection getIssuerAlternativeNames() {
        return X509CertificateObject.getAlternativeNames(this.getExtensionBytes(Extension.issuerAlternativeName.getId()));
    }

    public Principal getIssuerDN() {
        Principal v0_2;
        try {
            X509Principal v0_1 = new X509Principal(X500Name.getInstance(this.c.getIssuer().getEncoded()));
        }
        catch(IOException v0) {
            v0_2 = null;
        }

        return v0_2;
    }

    public boolean[] getIssuerUniqueID() {
        boolean[] v0_2;
        DERBitString v0 = this.c.getTBSCertificate().getIssuerUniqueId();
        if(v0 != null) {
            byte[] v4 = v0.getBytes();
            boolean[] v3 = new boolean[v4.length * 8 - v0.getPadBits()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v3.length; ++v0_1) {
                boolean v2 = (v4[v0_1 / 8] & 128 >>> v0_1 % 8) != 0 ? true : false;
                v3[v0_1] = v2;
            }

            v0_2 = v3;
        }
        else {
            v0_2 = null;
        }

        return v0_2;
    }

    public X500Principal getIssuerX500Principal() {
        try {
            ByteArrayOutputStream v0_1 = new ByteArrayOutputStream();
            new ASN1OutputStream(((OutputStream)v0_1)).writeObject(this.c.getIssuer());
            return new X500Principal(v0_1.toByteArray());
        }
        catch(IOException v0) {
            throw new IllegalStateException("can\'t encode issuer DN");
        }
    }

    public boolean[] getKeyUsage() {
        return this.keyUsage;
    }

    public Set getNonCriticalExtensionOIDs() {
        HashSet v0_1;
        if(this.getVersion() == 3) {
            HashSet v1 = new HashSet();
            Extensions v2 = this.c.getTBSCertificate().getExtensions();
            if(v2 != null) {
                Enumeration v3 = v2.oids();
                while(v3.hasMoreElements()) {
                    Object v0 = v3.nextElement();
                    if(v2.getExtension(((ASN1ObjectIdentifier)v0)).isCritical()) {
                        continue;
                    }

                    ((Set)v1).add(((ASN1ObjectIdentifier)v0).getId());
                }

                v0_1 = v1;
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            Set v0_2 = null;
        }

        return ((Set)v0_1);
    }

    public Date getNotAfter() {
        return this.c.getEndDate().getDate();
    }

    public Date getNotBefore() {
        return this.c.getStartDate().getDate();
    }

    public PublicKey getPublicKey() {
        PublicKey v0_1;
        try {
            v0_1 = BouncyCastleProvider.getPublicKey(this.c.getSubjectPublicKeyInfo());
        }
        catch(IOException v0) {
            v0_1 = null;
        }

        return v0_1;
    }

    public BigInteger getSerialNumber() {
        return this.c.getSerialNumber().getValue();
    }

    public String getSigAlgName() {
        String v0_1;
        Provider v0 = Security.getProvider("BC");
        if(v0 != null) {
            v0_1 = v0.getProperty("Alg.Alias.Signature." + this.getSigAlgOID());
            if(v0_1 == null) {
                goto label_13;
            }
        }
        else {
        label_13:
            Provider[] v2 = Security.getProviders();
            int v0_2 = 0;
            while(true) {
                if(v0_2 != v2.length) {
                    String v1 = v2[v0_2].getProperty("Alg.Alias.Signature." + this.getSigAlgOID());
                    if(v1 != null) {
                        v0_1 = v1;
                    }
                    else {
                        ++v0_2;
                        continue;
                    }
                }
                else {
                    break;
                }

                return v0_1;
            }

            v0_1 = this.getSigAlgOID();
        }

        return v0_1;
    }

    public String getSigAlgOID() {
        return this.c.getSignatureAlgorithm().getAlgorithm().getId();
    }

    public byte[] getSigAlgParams() {
        byte[] v0 = null;
        if(this.c.getSignatureAlgorithm().getParameters() != null) {
            try {
                v0 = this.c.getSignatureAlgorithm().getParameters().toASN1Primitive().getEncoded("DER");
            }
            catch(IOException v1) {
            }
        }

        return v0;
    }

    public byte[] getSignature() {
        return this.c.getSignature().getBytes();
    }

    public Collection getSubjectAlternativeNames() {
        return X509CertificateObject.getAlternativeNames(this.getExtensionBytes(Extension.subjectAlternativeName.getId()));
    }

    public Principal getSubjectDN() {
        return new X509Principal(X500Name.getInstance(this.c.getSubject().toASN1Primitive()));
    }

    public boolean[] getSubjectUniqueID() {
        boolean[] v0_2;
        DERBitString v0 = this.c.getTBSCertificate().getSubjectUniqueId();
        if(v0 != null) {
            byte[] v4 = v0.getBytes();
            boolean[] v3 = new boolean[v4.length * 8 - v0.getPadBits()];
            int v0_1;
            for(v0_1 = 0; v0_1 != v3.length; ++v0_1) {
                boolean v2 = (v4[v0_1 / 8] & 128 >>> v0_1 % 8) != 0 ? true : false;
                v3[v0_1] = v2;
            }

            v0_2 = v3;
        }
        else {
            v0_2 = null;
        }

        return v0_2;
    }

    public X500Principal getSubjectX500Principal() {
        try {
            ByteArrayOutputStream v0_1 = new ByteArrayOutputStream();
            new ASN1OutputStream(((OutputStream)v0_1)).writeObject(this.c.getSubject());
            return new X500Principal(v0_1.toByteArray());
        }
        catch(IOException v0) {
            throw new IllegalStateException("can\'t encode issuer DN");
        }
    }

    public byte[] getTBSCertificate() {
        try {
            return this.c.getTBSCertificate().getEncoded("DER");
        }
        catch(IOException v0) {
            throw new CertificateEncodingException(v0.toString());
        }
    }

    public int getVersion() {
        return this.c.getVersionNumber();
    }

    public boolean hasUnsupportedCriticalExtension() {
        boolean v0_1;
        if(this.getVersion() == 3) {
            Extensions v1 = this.c.getTBSCertificate().getExtensions();
            if(v1 != null) {
                Enumeration v2 = v1.oids();
                do {
                    if(v2.hasMoreElements()) {
                        Object v0 = v2.nextElement();
                        String v3 = ((ASN1ObjectIdentifier)v0).getId();
                        if(v3.equals(RFC3280CertPathUtilities.KEY_USAGE)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.CERTIFICATE_POLICIES)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.POLICY_MAPPINGS)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.INHIBIT_ANY_POLICY)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.CRL_DISTRIBUTION_POINTS)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.DELTA_CRL_INDICATOR)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.POLICY_CONSTRAINTS)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.BASIC_CONSTRAINTS)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.SUBJECT_ALTERNATIVE_NAME)) {
                            continue;
                        }

                        if(v3.equals(RFC3280CertPathUtilities.NAME_CONSTRAINTS)) {
                            continue;
                        }

                        if(!v1.getExtension(((ASN1ObjectIdentifier)v0)).isCritical()) {
                            continue;
                        }

                        break;
                    }
                    else {
                        goto label_50;
                    }
                }
                while(true);

                v0_1 = true;
            }
            else {
                goto label_50;
            }
        }
        else {
        label_50:
            v0_1 = false;
        }

        return v0_1;
    }

    public int hashCode() {
        int v0_1;
        __monitor_enter(this);
        try {
            if(!this.hashValueSet) {
                this.hashValue = this.calculateHashCode();
                this.hashValueSet = true;
            }

            v0_1 = this.hashValue;
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
        return v0_1;
    }

    private boolean isAlgIdEqual(AlgorithmIdentifier arg5, AlgorithmIdentifier arg6) {
        boolean v0 = false;
        if(arg5.getAlgorithm().equals(arg6.getAlgorithm())) {
            if(arg5.getParameters() == null) {
                if(arg6.getParameters() != null && !arg6.getParameters().equals(DERNull.INSTANCE)) {
                    return v0;
                }

                v0 = true;
            }
            else {
                if(arg6.getParameters() == null) {
                    if(arg5.getParameters() != null && !arg5.getParameters().equals(DERNull.INSTANCE)) {
                        return v0;
                    }

                    return true;
                }

                v0 = arg5.getParameters().equals(arg6.getParameters());
            }
        }

        return v0;
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    public String toString() {
        int v1 = 20;
        StringBuffer v2 = new StringBuffer();
        String v3 = System.getProperty("line.separator");
        v2.append("  [0]         Version: ").append(this.getVersion()).append(v3);
        v2.append("         SerialNumber: ").append(this.getSerialNumber()).append(v3);
        v2.append("             IssuerDN: ").append(this.getIssuerDN()).append(v3);
        v2.append("           Start Date: ").append(this.getNotBefore()).append(v3);
        v2.append("           Final Date: ").append(this.getNotAfter()).append(v3);
        v2.append("            SubjectDN: ").append(this.getSubjectDN()).append(v3);
        v2.append("           Public Key: ").append(this.getPublicKey()).append(v3);
        v2.append("  Signature Algorithm: ").append(this.getSigAlgName()).append(v3);
        byte[] v4 = this.getSignature();
        v2.append("            Signature: ").append(new String(Hex.encode(v4, 0, v1))).append(v3);
        int v0;
        for(v0 = v1; v0 < v4.length; v0 += 20) {
            if(v0 < v4.length - 20) {
                v2.append("                       ").append(new String(Hex.encode(v4, v0, v1))).append(v3);
            }
            else {
                v2.append("                       ").append(new String(Hex.encode(v4, v0, v4.length - v0))).append(v3);
            }
        }

        Extensions v4_1 = this.c.getTBSCertificate().getExtensions();
        if(v4_1 != null) {
            Enumeration v5 = v4_1.oids();
            if(v5.hasMoreElements()) {
                v2.append("       Extensions: \n");
            }

            while(v5.hasMoreElements()) {
                Object v0_1 = v5.nextElement();
                Extension v1_1 = v4_1.getExtension(((ASN1ObjectIdentifier)v0_1));
                if(v1_1.getExtnValue() != null) {
                    ASN1InputStream v7 = new ASN1InputStream(v1_1.getExtnValue().getOctets());
                    v2.append("                       critical(").append(v1_1.isCritical()).append(") ");
                    try {
                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.basicConstraints)) {
                            v2.append(BasicConstraints.getInstance(v7.readObject())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(Extension.keyUsage)) {
                            v2.append(KeyUsage.getInstance(v7.readObject())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(MiscObjectIdentifiers.netscapeCertType)) {
                            v2.append(new NetscapeCertType(v7.readObject())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(MiscObjectIdentifiers.netscapeRevocationURL)) {
                            v2.append(new NetscapeRevocationURL(v7.readObject())).append(v3);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0_1).equals(MiscObjectIdentifiers.verisignCzagExtension)) {
                            v2.append(new VerisignCzagExtension(v7.readObject())).append(v3);
                            continue;
                        }

                        v2.append(((ASN1ObjectIdentifier)v0_1).getId());
                        v2.append(" value = ").append(ASN1Dump.dumpAsString(v7.readObject())).append(v3);
                    }
                    catch(Exception v1_2) {
                        v2.append(((ASN1ObjectIdentifier)v0_1).getId());
                        v2.append(" value = ").append("*****").append(v3);
                    }

                    continue;
                }

                v2.append(v3);
            }
        }

        return v2.toString();
    }

    public final void verify(PublicKey arg3) {
        Signature v0_1;
        String v0 = X509SignatureUtil.getSignatureName(this.c.getSignatureAlgorithm());
        try {
            v0_1 = Signature.getInstance(v0, "BC");
        }
        catch(Exception v1) {
            v0_1 = Signature.getInstance(((String)v0_1));
        }

        this.checkSignature(arg3, v0_1);
    }

    public final void verify(PublicKey arg2, String arg3) {
        this.checkSignature(arg2, Signature.getInstance(X509SignatureUtil.getSignatureName(this.c.getSignatureAlgorithm()), arg3));
    }
}

