// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.digest;

import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import javax.crypto.SecretKey;
import javax.crypto.spec.PBEKeySpec;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.jcajce.provider.symmetric.util.BCPBEKey;
import org.bouncycastle.jcajce.provider.symmetric.util.BaseSecretKeyFactory;
import org.bouncycastle.jcajce.provider.symmetric.util.PBE$Util;

public class SHA1$BasePBKDF2WithHmacSHA1 extends BaseSecretKeyFactory {
    private int scheme;

    public SHA1$BasePBKDF2WithHmacSHA1(String arg2, int arg3) {
        super(arg2, PKCSObjectIdentifiers.id_PBKDF2);
        this.scheme = arg3;
    }

    protected SecretKey engineGenerateSecret(KeySpec arg10) {
        if((arg10 instanceof PBEKeySpec)) {
            KeySpec v7 = arg10;
            if(((PBEKeySpec)v7).getSalt() == null) {
                throw new InvalidKeySpecException("missing required salt");
            }

            if(((PBEKeySpec)v7).getIterationCount() <= 0) {
                throw new InvalidKeySpecException("positive iteration count required: " + ((PBEKeySpec)v7).getIterationCount());
            }

            if(((PBEKeySpec)v7).getKeyLength() <= 0) {
                throw new InvalidKeySpecException("positive key length required: " + ((PBEKeySpec)v7).getKeyLength());
            }

            if(((PBEKeySpec)v7).getPassword().length == 0) {
                throw new IllegalArgumentException("password empty");
            }

            int v5 = ((PBEKeySpec)v7).getKeyLength();
            return new BCPBEKey(this.algName, this.algOid, this.scheme, 1, v5, -1, ((PBEKeySpec)v7), PBE$Util.makePBEMacParameters(((PBEKeySpec)v7), this.scheme, 1, v5));
        }

        throw new InvalidKeySpecException("Invalid KeySpec");
    }
}

