// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.keystore.bc;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.Key;
import java.security.KeyFactory;
import java.security.KeyStoreException;
import java.security.KeyStoreSpi;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.generators.PKCS12ParametersGenerator;
import org.bouncycastle.crypto.io.MacInputStream;
import org.bouncycastle.crypto.io.MacOutputStream;
import org.bouncycastle.crypto.macs.HMac;
import org.bouncycastle.jce.interfaces.BCKeyStore;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.io.TeeOutputStream;

public class BcKeyStoreSpi extends KeyStoreSpi implements BCKeyStore {
    static final int CERTIFICATE = 1;
    static final int KEY = 2;
    private static final String KEY_CIPHER = "PBEWithSHAAnd3-KeyTripleDES-CBC";
    static final int KEY_PRIVATE = 0;
    static final int KEY_PUBLIC = 1;
    private static final int KEY_SALT_SIZE = 20;
    static final int KEY_SECRET = 2;
    private static final int MIN_ITERATIONS = 1024;
    static final int NULL = 0;
    static final int SEALED = 4;
    static final int SECRET = 3;
    private static final String STORE_CIPHER = "PBEWithSHAAndTwofish-CBC";
    private static final int STORE_SALT_SIZE = 20;
    private static final int STORE_VERSION = 2;
    protected SecureRandom random;
    protected Hashtable table;
    protected int version;

    public BcKeyStoreSpi(int arg2) {
        super();
        this.table = new Hashtable();
        this.random = new SecureRandom();
        this.version = arg2;
    }

    static void access$000(BcKeyStoreSpi arg0, Key arg1, DataOutputStream arg2) {
        arg0.encodeKey(arg1, arg2);
    }

    static Key access$100(BcKeyStoreSpi arg1, DataInputStream arg2) {
        return arg1.decodeKey(arg2);
    }

    private Certificate decodeCertificate(DataInputStream arg4) {
        String v0 = arg4.readUTF();
        byte[] v1 = new byte[arg4.readInt()];
        arg4.readFully(v1);
        try {
            return CertificateFactory.getInstance(v0, "BC").generateCertificate(new ByteArrayInputStream(v1));
        }
        catch(CertificateException v0_1) {
            throw new IOException(v0_1.toString());
        }
        catch(NoSuchProviderException v0_2) {
            throw new IOException(v0_2.toString());
        }
    }

    private Key decodeKey(DataInputStream arg6) {
        X509EncodedKeySpec v0_2;
        SecretKeySpec v0_1;
        int v1 = arg6.read();
        String v0 = arg6.readUTF();
        String v2 = arg6.readUTF();
        byte[] v3 = new byte[arg6.readInt()];
        arg6.readFully(v3);
        if((v0.equals("PKCS#8")) || (v0.equals("PKCS8"))) {
            PKCS8EncodedKeySpec v0_3 = new PKCS8EncodedKeySpec(v3);
        label_14:
            switch(v1) {
                case 0: {
                    goto label_63;
                }
                case 1: {
                    goto label_67;
                }
                case 2: {
                    goto label_71;
                }
            }

            try {
                throw new IOException("Key type " + v1 + " not recognised!");
            label_71:
                SecretKey v0_5 = SecretKeyFactory.getInstance(v2, "BC").generateSecret(((KeySpec)v0_2));
                goto label_51;
            label_67:
                PublicKey v0_6 = KeyFactory.getInstance(v2, "BC").generatePublic(((KeySpec)v0_2));
                goto label_51;
            label_63:
                PrivateKey v0_7 = KeyFactory.getInstance(v2, "BC").generatePrivate(((KeySpec)v0_2));
            }
            catch(Exception v0_4) {
                throw new IOException("Exception creating key: " + v0_4.toString());
            }
        }
        else {
            if(!v0.equals("X.509") && !v0.equals("X509")) {
                if(v0.equals("RAW")) {
                    v0_1 = new SecretKeySpec(v3, v2);
                    goto label_51;
                }
                else {
                    throw new IOException("Key format " + v0 + " not recognised!");
                }
            }

            v0_2 = new X509EncodedKeySpec(v3);
            goto label_14;
        }

    label_51:
        return ((Key)v0_1);
    }

    private void encodeCertificate(Certificate arg3, DataOutputStream arg4) {
        try {
            byte[] v0_1 = arg3.getEncoded();
            arg4.writeUTF(arg3.getType());
            arg4.writeInt(v0_1.length);
            arg4.write(v0_1);
            return;
        }
        catch(CertificateEncodingException v0) {
            throw new IOException(v0.toString());
        }
    }

    private void encodeKey(Key arg3, DataOutputStream arg4) {
        byte[] v0 = arg3.getEncoded();
        if((arg3 instanceof PrivateKey)) {
            arg4.write(0);
        }
        else if((arg3 instanceof PublicKey)) {
            arg4.write(1);
        }
        else {
            arg4.write(2);
        }

        arg4.writeUTF(arg3.getFormat());
        arg4.writeUTF(arg3.getAlgorithm());
        arg4.writeInt(v0.length);
        arg4.write(v0);
    }

    public Enumeration engineAliases() {
        return this.table.keys();
    }

    public boolean engineContainsAlias(String arg2) {
        boolean v0 = this.table.get(arg2) != null ? true : false;
        return v0;
    }

    public void engineDeleteEntry(String arg2) {
        if(this.table.get(arg2) != null) {
            this.table.remove(arg2);
        }
    }

    public Certificate engineGetCertificate(String arg4) {
        Certificate v0_2;
        Object v0 = this.table.get(arg4);
        if(v0 == null) {
        label_13:
            v0_2 = null;
        }
        else if(((BcKeyStoreSpi$StoreEntry)v0).getType() == 1) {
            v0 = ((BcKeyStoreSpi$StoreEntry)v0).getObject();
        }
        else {
            Certificate[] v0_1 = ((BcKeyStoreSpi$StoreEntry)v0).getCertificateChain();
            if(v0_1 != null) {
                v0_2 = v0_1[0];
            }
            else {
                goto label_13;
            }
        }

        return ((Certificate)v0);
    }

    public String engineGetCertificateAlias(Certificate arg5) {
        String v0_1;
        Object v0;
        Enumeration v2 = this.table.elements();
        do {
            if(v2.hasMoreElements()) {
                v0 = v2.nextElement();
                if((((BcKeyStoreSpi$StoreEntry)v0).getObject() instanceof Certificate)) {
                    if(!((BcKeyStoreSpi$StoreEntry)v0).getObject().equals(arg5)) {
                        continue;
                    }

                    v0_1 = ((BcKeyStoreSpi$StoreEntry)v0).getAlias();
                }
                else {
                    Certificate[] v1 = ((BcKeyStoreSpi$StoreEntry)v0).getCertificateChain();
                    if(v1 == null) {
                        continue;
                    }

                    if(!v1[0].equals(arg5)) {
                        continue;
                    }

                    break;
                }
            }
            else {
                return null;
            }

            return v0_1;
        }
        while(true);

        return ((BcKeyStoreSpi$StoreEntry)v0).getAlias();
    }

    public Certificate[] engineGetCertificateChain(String arg2) {
        Object v0 = this.table.get(arg2);
        Certificate[] v0_1 = v0 != null ? ((BcKeyStoreSpi$StoreEntry)v0).getCertificateChain() : null;
        return v0_1;
    }

    public Date engineGetCreationDate(String arg2) {
        Object v0 = this.table.get(arg2);
        Date v0_1 = v0 != null ? ((BcKeyStoreSpi$StoreEntry)v0).getDate() : null;
        return v0_1;
    }

    public Key engineGetKey(String arg4, char[] arg5) {
        Key v0_1;
        Object v0 = this.table.get(arg4);
        if(v0 == null || ((BcKeyStoreSpi$StoreEntry)v0).getType() == 1) {
            v0_1 = null;
        }
        else {
            v0 = ((BcKeyStoreSpi$StoreEntry)v0).getObject(arg5);
        }

        return v0_1;
    }

    public boolean engineIsCertificateEntry(String arg3) {
        Object v0 = this.table.get(arg3);
        boolean v0_1 = v0 == null || ((BcKeyStoreSpi$StoreEntry)v0).getType() != 1 ? false : true;
        return v0_1;
    }

    public boolean engineIsKeyEntry(String arg3) {
        Object v0 = this.table.get(arg3);
        boolean v0_1 = v0 == null || ((BcKeyStoreSpi$StoreEntry)v0).getType() == 1 ? false : true;
        return v0_1;
    }

    public void engineLoad(InputStream arg11, char[] arg12) {
        int v9 = 2;
        this.table.clear();
        if(arg11 != null) {
            DataInputStream v1 = new DataInputStream(arg11);
            int v0 = v1.readInt();
            if(v0 != v9 && v0 != 0 && v0 != 1) {
                throw new IOException("Wrong version of key store.");
            }

            int v2 = v1.readInt();
            if(v2 <= 0) {
                throw new IOException("Invalid salt detected");
            }

            byte[] v2_1 = new byte[v2];
            v1.readFully(v2_1);
            int v3 = v1.readInt();
            HMac v4 = new HMac(new SHA1Digest());
            if(arg12 != null && arg12.length != 0) {
                byte[] v5 = PBEParametersGenerator.PKCS12PasswordToBytes(arg12);
                PKCS12ParametersGenerator v6 = new PKCS12ParametersGenerator(new SHA1Digest());
                ((PBEParametersGenerator)v6).init(v5, v2_1, v3);
                CipherParameters v0_1 = v0 != v9 ? ((PBEParametersGenerator)v6).generateDerivedMacParameters(v4.getMacSize()) : ((PBEParametersGenerator)v6).generateDerivedMacParameters(v4.getMacSize() * 8);
                Arrays.fill(v5, 0);
                v4.init(v0_1);
                this.loadStore(new MacInputStream(((InputStream)v1), ((Mac)v4)));
                byte[] v0_2 = new byte[v4.getMacSize()];
                v4.doFinal(v0_2, 0);
                v2_1 = new byte[v4.getMacSize()];
                v1.readFully(v2_1);
                if(Arrays.constantTimeAreEqual(v0_2, v2_1)) {
                    return;
                }

                this.table.clear();
                throw new IOException("KeyStore integrity check failed.");
            }

            this.loadStore(((InputStream)v1));
            v1.readFully(new byte[v4.getMacSize()]);
        }
    }

    public void engineSetCertificateEntry(String arg4, Certificate arg5) {
        Object v0 = this.table.get(arg4);
        if(v0 != null && ((BcKeyStoreSpi$StoreEntry)v0).getType() != 1) {
            throw new KeyStoreException("key store already has a key entry with alias " + arg4);
        }

        this.table.put(arg4, new BcKeyStoreSpi$StoreEntry(this, arg4, arg5));
    }

    public void engineSetKeyEntry(String arg8, Key arg9, char[] arg10, Certificate[] arg11) {
        if(((arg9 instanceof PrivateKey)) && arg11 == null) {
            throw new KeyStoreException("no certificate chain for private key");
        }

        try {
            this.table.put(arg8, new BcKeyStoreSpi$StoreEntry(this, arg8, arg9, arg10, arg11));
            return;
        }
        catch(Exception v0) {
            throw new KeyStoreException(v0.toString());
        }
    }

    public void engineSetKeyEntry(String arg3, byte[] arg4, Certificate[] arg5) {
        this.table.put(arg3, new BcKeyStoreSpi$StoreEntry(this, arg3, arg4, arg5));
    }

    public int engineSize() {
        return this.table.size();
    }

    public void engineStore(OutputStream arg9, char[] arg10) {
        DataOutputStream v2 = new DataOutputStream(arg9);
        byte[] v0 = new byte[20];
        int v3 = (this.random.nextInt() & 1023) + 1024;
        this.random.nextBytes(v0);
        v2.writeInt(this.version);
        v2.writeInt(v0.length);
        v2.write(v0);
        v2.writeInt(v3);
        HMac v4 = new HMac(new SHA1Digest());
        MacOutputStream v5 = new MacOutputStream(((Mac)v4));
        PKCS12ParametersGenerator v6 = new PKCS12ParametersGenerator(new SHA1Digest());
        byte[] v7 = PBEParametersGenerator.PKCS12PasswordToBytes(arg10);
        ((PBEParametersGenerator)v6).init(v7, v0, v3);
        if(this.version < 2) {
            v4.init(((PBEParametersGenerator)v6).generateDerivedMacParameters(v4.getMacSize()));
        }
        else {
            v4.init(((PBEParametersGenerator)v6).generateDerivedMacParameters(v4.getMacSize() * 8));
        }

        int v0_1;
        for(v0_1 = 0; v0_1 != v7.length; ++v0_1) {
            v7[v0_1] = 0;
        }

        this.saveStore(new TeeOutputStream(((OutputStream)v2), ((OutputStream)v5)));
        v0 = new byte[v4.getMacSize()];
        v4.doFinal(v0, 0);
        v2.write(v0);
        v2.close();
    }

    protected void loadStore(InputStream arg10) {
        DataInputStream v7 = new DataInputStream(arg10);
        int v4;
        for(v4 = v7.read(); v4 > 0; v4 = v7.read()) {
            String v2 = v7.readUTF();
            Date v3 = new Date(v7.readLong());
            int v1 = v7.readInt();
            Certificate[] v6 = null;
            if(v1 != 0) {
                v6 = new Certificate[v1];
                int v0;
                for(v0 = 0; v0 != v1; ++v0) {
                    v6[v0] = this.decodeCertificate(v7);
                }
            }

            switch(v4) {
                case 1: {
                    goto label_23;
                }
                case 2: {
                    goto label_32;
                }
                case 3: 
                case 4: {
                    goto label_40;
                }
            }

            throw new RuntimeException("Unknown object type in store.");
        label_40:
            byte[] v5 = new byte[v7.readInt()];
            v7.readFully(v5);
            this.table.put(v2, new BcKeyStoreSpi$StoreEntry(this, v2, v3, v4, v5, v6));
            goto label_30;
        label_23:
            this.table.put(v2, new BcKeyStoreSpi$StoreEntry(this, v2, v3, 1, this.decodeCertificate(v7)));
            goto label_30;
        label_32:
            this.table.put(v2, new BcKeyStoreSpi$StoreEntry(this, v2, v3, 2, this.decodeKey(v7), v6));
        label_30:
        }
    }

    protected Cipher makePBECipher(String arg5, int arg6, char[] arg7, byte[] arg8, int arg9) {
        try {
            PBEKeySpec v0_1 = new PBEKeySpec(arg7);
            SecretKeyFactory v1 = SecretKeyFactory.getInstance(arg5, "BC");
            PBEParameterSpec v2 = new PBEParameterSpec(arg8, arg9);
            Cipher v3 = Cipher.getInstance(arg5, "BC");
            v3.init(arg6, v1.generateSecret(((KeySpec)v0_1)), ((AlgorithmParameterSpec)v2));
            return v3;
        }
        catch(Exception v0) {
            throw new IOException("Error initialising store of key store: " + v0);
        }
    }

    protected void saveStore(OutputStream arg8) {
        Enumeration v3 = this.table.elements();
        DataOutputStream v4 = new DataOutputStream(arg8);
        while(v3.hasMoreElements()) {
            Object v0 = v3.nextElement();
            v4.write(((BcKeyStoreSpi$StoreEntry)v0).getType());
            v4.writeUTF(((BcKeyStoreSpi$StoreEntry)v0).getAlias());
            v4.writeLong(((BcKeyStoreSpi$StoreEntry)v0).getDate().getTime());
            Certificate[] v5 = ((BcKeyStoreSpi$StoreEntry)v0).getCertificateChain();
            if(v5 == null) {
                v4.writeInt(0);
            }
            else {
                v4.writeInt(v5.length);
                int v1;
                for(v1 = 0; v1 != v5.length; ++v1) {
                    this.encodeCertificate(v5[v1], v4);
                }
            }

            switch(((BcKeyStoreSpi$StoreEntry)v0).getType()) {
                case 1: {
                    goto label_33;
                }
                case 2: {
                    goto label_36;
                }
                case 3: 
                case 4: {
                    goto label_39;
                }
            }

            throw new RuntimeException("Unknown object type in store.");
        label_39:
            v0 = ((BcKeyStoreSpi$StoreEntry)v0).getObject();
            v4.writeInt(v0.length);
            v4.write(((byte[])v0));
            continue;
        label_33:
            this.encodeCertificate(((BcKeyStoreSpi$StoreEntry)v0).getObject(), v4);
            continue;
        label_36:
            this.encodeKey(((BcKeyStoreSpi$StoreEntry)v0).getObject(), v4);
        }

        v4.write(0);
    }

    public void setRandom(SecureRandom arg1) {
        this.random = arg1;
    }
}

