// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.keystore.pkcs12;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.Key;
import java.security.KeyStore$LoadStoreParameter;
import java.security.KeyStore$PasswordProtection;
import java.security.KeyStore$ProtectionParameter;
import java.security.KeyStoreException;
import java.security.KeyStoreSpi;
import java.security.Principal;
import java.security.PrivateKey;
import java.security.Provider;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.KeySpec;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import javax.crypto.Cipher;
import javax.crypto.Mac;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.BEROctetString;
import org.bouncycastle.asn1.BEROutputStream;
import org.bouncycastle.asn1.DERBMPString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DEROutputStream;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.DERSet;
import org.bouncycastle.asn1.pkcs.AuthenticatedSafe;
import org.bouncycastle.asn1.pkcs.CertBag;
import org.bouncycastle.asn1.pkcs.ContentInfo;
import org.bouncycastle.asn1.pkcs.EncryptedData;
import org.bouncycastle.asn1.pkcs.EncryptedPrivateKeyInfo;
import org.bouncycastle.asn1.pkcs.MacData;
import org.bouncycastle.asn1.pkcs.PBES2Parameters;
import org.bouncycastle.asn1.pkcs.PBKDF2Params;
import org.bouncycastle.asn1.pkcs.PKCS12PBEParams;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.Pfx;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.pkcs.SafeBag;
import org.bouncycastle.asn1.util.ASN1Dump;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.AuthorityKeyIdentifier;
import org.bouncycastle.asn1.x509.DigestInfo;
import org.bouncycastle.asn1.x509.Extension;
import org.bouncycastle.asn1.x509.SubjectKeyIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.jcajce.provider.config.PKCS12StoreParameter;
import org.bouncycastle.jcajce.provider.symmetric.util.BCPBEKey;
import org.bouncycastle.jcajce.provider.util.SecretKeyUtil;
import org.bouncycastle.jce.interfaces.BCKeyStore;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.provider.JDKPKCS12StoreParameter;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.encoders.Hex;

public class PKCS12KeyStoreSpi extends KeyStoreSpi implements PKCSObjectIdentifiers, X509ObjectIdentifiers, BCKeyStore {
    static final int CERTIFICATE = 1;
    static final int KEY = 2;
    static final int KEY_PRIVATE = 0;
    static final int KEY_PUBLIC = 1;
    static final int KEY_SECRET = 2;
    private static final int MIN_ITERATIONS = 1024;
    static final int NULL = 0;
    private static final int SALT_SIZE = 20;
    static final int SEALED = 4;
    static final int SECRET = 3;
    private static final Provider bcProvider;
    private ASN1ObjectIdentifier certAlgorithm;
    private CertificateFactory certFact;
    private PKCS12KeyStoreSpi$IgnoresCaseHashtable certs;
    private Hashtable chainCerts;
    private ASN1ObjectIdentifier keyAlgorithm;
    private Hashtable keyCerts;
    private PKCS12KeyStoreSpi$IgnoresCaseHashtable keys;
    private Hashtable localIds;
    protected SecureRandom random;

    static {
        PKCS12KeyStoreSpi.bcProvider = new BouncyCastleProvider();
    }

    public PKCS12KeyStoreSpi(Provider arg5, ASN1ObjectIdentifier arg6, ASN1ObjectIdentifier arg7) {
        super();
        this.keys = new PKCS12KeyStoreSpi$IgnoresCaseHashtable(null);
        this.localIds = new Hashtable();
        this.certs = new PKCS12KeyStoreSpi$IgnoresCaseHashtable(null);
        this.chainCerts = new Hashtable();
        this.keyCerts = new Hashtable();
        this.random = new SecureRandom();
        this.keyAlgorithm = arg6;
        this.certAlgorithm = arg7;
        if(arg5 != null) {
            try {
                this.certFact = CertificateFactory.getInstance("X.509", arg5);
                return;
            label_27:
                this.certFact = CertificateFactory.getInstance("X.509");
                return;
            }
            catch(Exception v0) {
                throw new IllegalArgumentException("can\'t create cert factory - " + v0.toString());
            }
        }
        else {
            goto label_27;
        }
    }

    static SubjectKeyIdentifier access$100(PKCS12KeyStoreSpi arg1, PublicKey arg2) {
        return arg1.createSubjectKeyId(arg2);
    }

    static Provider access$200() {
        return PKCS12KeyStoreSpi.bcProvider;
    }

    private static byte[] calculatePbeMac(ASN1ObjectIdentifier arg4, byte[] arg5, int arg6, char[] arg7, boolean arg8, byte[] arg9) {
        SecretKeyFactory v0 = SecretKeyFactory.getInstance(arg4.getId(), PKCS12KeyStoreSpi.bcProvider);
        PBEParameterSpec v1 = new PBEParameterSpec(arg5, arg6);
        SecretKey v0_1 = v0.generateSecret(new PBEKeySpec(arg7));
        ((BCPBEKey)v0_1).setTryWrongPKCS12Zero(arg8);
        Mac v2 = Mac.getInstance(arg4.getId(), PKCS12KeyStoreSpi.bcProvider);
        v2.init(((Key)v0_1), ((AlgorithmParameterSpec)v1));
        v2.update(arg9);
        return v2.doFinal();
    }

    private SubjectKeyIdentifier createSubjectKeyId(PublicKey arg3) {
        try {
            return new SubjectKeyIdentifier(new SubjectPublicKeyInfo(ASN1Primitive.fromByteArray(arg3.getEncoded())));
        }
        catch(Exception v0) {
            throw new RuntimeException("error creating key");
        }
    }

    protected byte[] cryptData(boolean arg7, AlgorithmIdentifier arg8, char[] arg9, boolean arg10, byte[] arg11) {
        int v1_1;
        Cipher v2_1;
        SecretKey v0_2;
        PBEParameterSpec v4;
        String v1 = arg8.getAlgorithm().getId();
        PKCS12PBEParams v0 = PKCS12PBEParams.getInstance(arg8.getParameters());
        PBEKeySpec v2 = new PBEKeySpec(arg9);
        try {
            SecretKeyFactory v3 = SecretKeyFactory.getInstance(v1, PKCS12KeyStoreSpi.bcProvider);
            v4 = new PBEParameterSpec(v0.getIV(), v0.getIterations().intValue());
            v0_2 = v3.generateSecret(((KeySpec)v2));
            ((BCPBEKey)v0_2).setTryWrongPKCS12Zero(arg10);
            v2_1 = Cipher.getInstance(v1, PKCS12KeyStoreSpi.bcProvider);
            if(arg7) {
                v1_1 = 1;
            }
            else {
                goto label_22;
            }

            goto label_19;
        }
        catch(Exception v0_1) {
            goto label_34;
        }

    label_22:
        v1_1 = 2;
        try {
        label_19:
            v2_1.init(v1_1, ((Key)v0_2), ((AlgorithmParameterSpec)v4));
            return v2_1.doFinal(arg11);
        }
        catch(Exception v0_1) {
        label_34:
            throw new IOException("exception decrypting data - " + v0_1.toString());
        }
    }

    private void doStore(OutputStream arg16, char[] arg17, boolean arg18) {
        MacData v1_6;
        BEROutputStream v1_4;
        DEROutputStream v1_3;
        CertBag v5_4;
        Object v4_3;
        int v6_2;
        int v2_3;
        ASN1EncodableVector v6_1;
        Object v5_3;
        Enumeration v13;
        ASN1Encodable v5_1;
        ASN1EncodableVector v12;
        CertBag v11;
        Certificate v4_2;
        ASN1EncodableVector v2_1;
        ASN1EncodableVector v4_1;
        int v3_2;
        Object v2;
        Object v1;
        if(arg17 == null) {
            throw new NullPointerException("No password supplied for PKCS#12 KeyStore.");
        }

        ASN1EncodableVector v5 = new ASN1EncodableVector();
        Enumeration v6 = this.keys.keys();
        while(v6.hasMoreElements()) {
            byte[] v3 = new byte[20];
            this.random.nextBytes(v3);
            v1 = v6.nextElement();
            v2 = this.keys.get(((String)v1));
            PKCS12PBEParams v4 = new PKCS12PBEParams(v3, 1024);
            EncryptedPrivateKeyInfo v8 = new EncryptedPrivateKeyInfo(new AlgorithmIdentifier(this.keyAlgorithm, v4.toASN1Primitive()), this.wrapKey(this.keyAlgorithm.getId(), ((Key)v2), v4, arg17));
            ASN1EncodableVector v7 = new ASN1EncodableVector();
            if((v2 instanceof PKCS12BagAttributeCarrier)) {
                ASN1Encodable v3_1 = ((PKCS12BagAttributeCarrier)v2).getBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName);
                if(v3_1 == null || !((DERBMPString)v3_1).getString().equals(v1)) {
                    ((PKCS12BagAttributeCarrier)v2).setBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName, new DERBMPString(((String)v1)));
                }

                if(((PKCS12BagAttributeCarrier)v2).getBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId) == null) {
                    ((PKCS12BagAttributeCarrier)v2).setBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId, this.createSubjectKeyId(this.engineGetCertificate(((String)v1)).getPublicKey()));
                }

                Enumeration v9 = ((PKCS12BagAttributeCarrier)v2).getBagAttributeKeys();
                v3_2 = 0;
                while(v9.hasMoreElements()) {
                    Object v3_3 = v9.nextElement();
                    v4_1 = new ASN1EncodableVector();
                    v4_1.add(((ASN1Encodable)v3_3));
                    v4_1.add(new DERSet(((PKCS12BagAttributeCarrier)v2).getBagAttribute(((ASN1ObjectIdentifier)v3_3))));
                    v3_2 = 1;
                    v7.add(new DERSequence(v4_1));
                }
            }
            else {
                v3_2 = 0;
            }

            if(v3_2 == 0) {
                v2_1 = new ASN1EncodableVector();
                Certificate v3_4 = this.engineGetCertificate(((String)v1));
                v2_1.add(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId);
                v2_1.add(new DERSet(this.createSubjectKeyId(v3_4.getPublicKey())));
                v7.add(new DERSequence(v2_1));
                v2_1 = new ASN1EncodableVector();
                v2_1.add(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName);
                v2_1.add(new DERSet(new DERBMPString(((String)v1))));
                v7.add(new DERSequence(v2_1));
            }

            v5.add(new SafeBag(PKCS12KeyStoreSpi.pkcs8ShroudedKeyBag, v8.toASN1Primitive(), new DERSet(v7)));
        }

        BEROctetString v7_1 = new BEROctetString(new DERSequence(v5).getEncoded("DER"));
        byte[] v1_1 = new byte[20];
        this.random.nextBytes(v1_1);
        ASN1EncodableVector v8_1 = new ASN1EncodableVector();
        AlgorithmIdentifier v3_5 = new AlgorithmIdentifier(this.certAlgorithm, new PKCS12PBEParams(v1_1, 1024).toASN1Primitive());
        Hashtable v9_1 = new Hashtable();
        Enumeration v10 = this.keys.keys();
        while(v10.hasMoreElements()) {
            try {
                v1 = v10.nextElement();
                v4_2 = this.engineGetCertificate(((String)v1));
                v11 = new CertBag(PKCS12KeyStoreSpi.x509Certificate, new DEROctetString(v4_2.getEncoded()));
                v12 = new ASN1EncodableVector();
                if((v4_2 instanceof PKCS12BagAttributeCarrier)) {
                    Certificate v2_2 = v4_2;
                    v5_1 = ((PKCS12BagAttributeCarrier)v2_2).getBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName);
                    if(v5_1 == null || !((DERBMPString)v5_1).getString().equals(v1)) {
                        ((PKCS12BagAttributeCarrier)v2_2).setBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName, new DERBMPString(((String)v1)));
                    }

                    if(((PKCS12BagAttributeCarrier)v2_2).getBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId) == null) {
                        ((PKCS12BagAttributeCarrier)v2_2).setBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId, this.createSubjectKeyId(v4_2.getPublicKey()));
                    }

                    v13 = ((PKCS12BagAttributeCarrier)v2_2).getBagAttributeKeys();
                    int v5_2;
                    for(v5_2 = 0; v13.hasMoreElements(); v5_2 = 1) {
                        v5_3 = v13.nextElement();
                        v6_1 = new ASN1EncodableVector();
                        v6_1.add(((ASN1Encodable)v5_3));
                        v6_1.add(new DERSet(((PKCS12BagAttributeCarrier)v2_2).getBagAttribute(((ASN1ObjectIdentifier)v5_3))));
                        v12.add(new DERSequence(v6_1));
                    }

                    v2_3 = v5_2;
                }
                else {
                    goto label_454;
                }

                goto label_181;
            }
            catch(CertificateEncodingException v1_2) {
                goto label_225;
            }

        label_454:
            v2_3 = 0;
            try {
            label_181:
                if(v2_3 == 0) {
                    v2_1 = new ASN1EncodableVector();
                    v2_1.add(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId);
                    v2_1.add(new DERSet(this.createSubjectKeyId(v4_2.getPublicKey())));
                    v12.add(new DERSequence(v2_1));
                    v2_1 = new ASN1EncodableVector();
                    v2_1.add(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName);
                    v2_1.add(new DERSet(new DERBMPString(((String)v1))));
                    v12.add(new DERSequence(v2_1));
                }

                v8_1.add(new SafeBag(PKCS12KeyStoreSpi.certBag, v11.toASN1Primitive(), new DERSet(v12)));
                v9_1.put(v4_2, v4_2);
                continue;
            }
            catch(CertificateEncodingException v1_2) {
            label_225:
                throw new IOException("Error encoding certificate: " + v1_2.toString());
            }
        }

        v10 = this.certs.keys();
        do {
        label_228:
            if(!v10.hasMoreElements()) {
                break;
            }

            try {
                v1 = v10.nextElement();
                v2 = this.certs.get(((String)v1));
                v6_2 = 0;
                if(this.keys.get(((String)v1)) != null) {
                    continue;
                }

                v11 = new CertBag(PKCS12KeyStoreSpi.x509Certificate, new DEROctetString(((Certificate)v2).getEncoded()));
                v12 = new ASN1EncodableVector();
                if((v2 instanceof PKCS12BagAttributeCarrier)) {
                    v4_3 = v2;
                    v5_1 = ((PKCS12BagAttributeCarrier)v4_3).getBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName);
                    if(v5_1 == null || !((DERBMPString)v5_1).getString().equals(v1)) {
                        ((PKCS12BagAttributeCarrier)v4_3).setBagAttribute(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName, new DERBMPString(((String)v1)));
                    }

                    v13 = ((PKCS12BagAttributeCarrier)v4_3).getBagAttributeKeys();
                    goto label_260;
                }

                goto label_278;
            }
            catch(CertificateEncodingException v1_2) {
                goto label_311;
            }
        }
        while(true);

        Enumeration v4_4 = this.chainCerts.keys();
        goto label_314;
        try {
        label_260:
            while(v13.hasMoreElements()) {
                v5_3 = v13.nextElement();
                if(((ASN1ObjectIdentifier)v5_3).equals(PKCSObjectIdentifiers.pkcs_9_at_localKeyId)) {
                    continue;
                }

                v6_1 = new ASN1EncodableVector();
                v6_1.add(((ASN1Encodable)v5_3));
                v6_1.add(new DERSet(((PKCS12BagAttributeCarrier)v4_3).getBagAttribute(((ASN1ObjectIdentifier)v5_3))));
                v12.add(new DERSequence(v6_1));
                v6_2 = 1;
            }

        label_278:
            if(v6_2 == 0) {
                v4_1 = new ASN1EncodableVector();
                v4_1.add(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName);
                v4_1.add(new DERSet(new DERBMPString(((String)v1))));
                v12.add(new DERSequence(v4_1));
            }

            v8_1.add(new SafeBag(PKCS12KeyStoreSpi.certBag, v11.toASN1Primitive(), new DERSet(v12)));
            v9_1.put(v2, v2);
            goto label_228;
        }
        catch(CertificateEncodingException v1_2) {
        label_311:
            throw new IOException("Error encoding certificate: " + v1_2.toString());
        }

        do {
        label_314:
            if(!v4_4.hasMoreElements()) {
                break;
            }

            try {
                v1 = this.chainCerts.get(v4_4.nextElement());
                if(v9_1.get(v1) != null) {
                    continue;
                }

                v5_4 = new CertBag(PKCS12KeyStoreSpi.x509Certificate, new DEROctetString(((Certificate)v1).getEncoded()));
                v6_1 = new ASN1EncodableVector();
                if((v1 instanceof PKCS12BagAttributeCarrier)) {
                    v10 = ((PKCS12BagAttributeCarrier)v1).getBagAttributeKeys();
                    goto label_332;
                }

                goto label_360;
            }
            catch(CertificateEncodingException v1_2) {
                goto label_359;
            }
        }
        while(true);

        AuthenticatedSafe v2_4 = new AuthenticatedSafe(new ContentInfo[]{new ContentInfo(PKCS12KeyStoreSpi.data, ((ASN1Encodable)v7_1)), new ContentInfo(PKCS12KeyStoreSpi.encryptedData, new EncryptedData(PKCS12KeyStoreSpi.data, v3_5, new BEROctetString(this.cryptData(true, v3_5, arg17, false, new DERSequence(v8_1).getEncoded("DER")))).toASN1Primitive())});
        ByteArrayOutputStream v3_6 = new ByteArrayOutputStream();
        if(arg18) {
            v1_3 = new DEROutputStream(((OutputStream)v3_6));
        }
        else {
            v1_4 = new BEROutputStream(((OutputStream)v3_6));
        }

        ((DEROutputStream)v1_4).writeObject(((ASN1Encodable)v2_4));
        ContentInfo v7_2 = new ContentInfo(PKCS12KeyStoreSpi.data, new BEROctetString(v3_6.toByteArray()));
        byte[] v2_5 = new byte[20];
        v3_2 = 1024;
        this.random.nextBytes(v2_5);
        byte[] v6_3 = v7_2.getContent().getOctets();
        try {
            v1_6 = new MacData(new DigestInfo(new AlgorithmIdentifier(PKCS12KeyStoreSpi.id_SHA1, DERNull.INSTANCE), PKCS12KeyStoreSpi.calculatePbeMac(PKCS12KeyStoreSpi.id_SHA1, v2_5, v3_2, arg17, false, v6_3)), v2_5, v3_2);
        }
        catch(Exception v1_5) {
            throw new IOException("error constructing MAC: " + v1_5.toString());
        }

        Pfx v2_6 = new Pfx(v7_2, v1_6);
        if(arg18) {
            v1_3 = new DEROutputStream(arg16);
        }
        else {
            v1_4 = new BEROutputStream(arg16);
        }

        ((DEROutputStream)v1_4).writeObject(((ASN1Encodable)v2_6));
        return;
        try {
        label_332:
            while(v10.hasMoreElements()) {
                v2 = v10.nextElement();
                if(((ASN1ObjectIdentifier)v2).equals(PKCSObjectIdentifiers.pkcs_9_at_localKeyId)) {
                    continue;
                }

                ASN1EncodableVector v11_1 = new ASN1EncodableVector();
                v11_1.add(((ASN1Encodable)v2));
                v11_1.add(new DERSet(((PKCS12BagAttributeCarrier)v1).getBagAttribute(((ASN1ObjectIdentifier)v2))));
                v6_1.add(new DERSequence(v11_1));
            }

        label_360:
            v8_1.add(new SafeBag(PKCS12KeyStoreSpi.certBag, v5_4.toASN1Primitive(), new DERSet(v6_1)));
            goto label_314;
        }
        catch(CertificateEncodingException v1_2) {
        label_359:
            throw new IOException("Error encoding certificate: " + v1_2.toString());
        }
    }

    public Enumeration engineAliases() {
        Hashtable v1 = new Hashtable();
        Enumeration v0 = this.certs.keys();
        while(v0.hasMoreElements()) {
            v1.put(v0.nextElement(), "cert");
        }

        Enumeration v2 = this.keys.keys();
        while(v2.hasMoreElements()) {
            Object v0_1 = v2.nextElement();
            if(v1.get(v0_1) != null) {
                continue;
            }

            v1.put(v0_1, "key");
        }

        return v1.keys();
    }

    public boolean engineContainsAlias(String arg2) {
        boolean v0 = this.certs.get(arg2) != null || this.keys.get(arg2) != null ? true : false;
        return v0;
    }

    public void engineDeleteEntry(String arg6) {
        Object v0 = this.keys.remove(arg6);
        Object v1 = this.certs.remove(arg6);
        if(v1 != null) {
            this.chainCerts.remove(new PKCS12KeyStoreSpi$CertId(this, ((Certificate)v1).getPublicKey()));
        }

        if(v0 != null) {
            v0 = this.localIds.remove(arg6);
            v0 = v0 != null ? this.keyCerts.remove(v0) : v1;
            if(v0 == null) {
                return;
            }

            this.chainCerts.remove(new PKCS12KeyStoreSpi$CertId(this, ((Certificate)v0).getPublicKey()));
        }
    }

    public Certificate engineGetCertificate(String arg3) {
        if(arg3 == null) {
            throw new IllegalArgumentException("null alias passed to getCertificate.");
        }

        Object v0 = this.certs.get(arg3);
        if(v0 == null) {
            v0 = this.localIds.get(arg3);
            v0 = v0 != null ? this.keyCerts.get(v0) : this.keyCerts.get(arg3);
        }

        return ((Certificate)v0);
    }

    public String engineGetCertificateAlias(Certificate arg5) {
        String v1_1;
        Object v1;
        Object v0;
        Enumeration v2 = this.certs.elements();
        Enumeration v3 = this.certs.keys();
        do {
            if(v2.hasMoreElements()) {
                v0 = v2.nextElement();
                v1 = v3.nextElement();
                if(!((Certificate)v0).equals(arg5)) {
                    continue;
                }
            }
            else {
                break;
            }

            return v1_1;
        }
        while(true);

        v2 = this.keyCerts.elements();
        v3 = this.keyCerts.keys();
        do {
            if(v2.hasMoreElements()) {
                v0 = v2.nextElement();
                v1 = v3.nextElement();
                if(!((Certificate)v0).equals(arg5)) {
                    continue;
                }

                return v1_1;
            }
            else {
                goto label_22;
            }
        }
        while(true);

        return v1_1;
    label_22:
        v1_1 = null;
        return v1_1;
    }

    public Certificate[] engineGetCertificateChain(String arg10) {
        Object v0_2;
        Object v4;
        Object v2_2;
        Certificate[] v3 = null;
        if(arg10 == null) {
            throw new IllegalArgumentException("null alias passed to getCertificateChain.");
        }

        if(this.engineIsKeyEntry(arg10)) {
            Certificate v1 = this.engineGetCertificate(arg10);
            if(v1 == null) {
                return v3;
            }

            Vector v5 = new Vector();
            while(v1 != null) {
                Certificate v0 = v1;
                byte[] v2 = ((X509Certificate)v0).getExtensionValue(Extension.authorityKeyIdentifier.getId());
                if(v2 != null) {
                    try {
                        AuthorityKeyIdentifier v2_1 = AuthorityKeyIdentifier.getInstance(new ASN1InputStream(new ASN1InputStream(v2).readObject().getOctets()).readObject());
                        if(v2_1.getKeyIdentifier() != null) {
                            v2_2 = this.chainCerts.get(new PKCS12KeyStoreSpi$CertId(this, v2_1.getKeyIdentifier()));
                        }
                        else {
                            goto label_79;
                        }

                        goto label_34;
                    }
                    catch(IOException v0_1) {
                        goto label_61;
                    }

                label_79:
                    v2_2 = v3;
                label_34:
                    v4 = v2_2;
                    goto label_35;
                label_61:
                    throw new RuntimeException(v0_1.toString());
                }
                else {
                    v4 = v3;
                }

            label_35:
                if(v4 == null) {
                    Principal v6 = ((X509Certificate)v0).getIssuerDN();
                    if(v6.equals(((X509Certificate)v0).getSubjectDN())) {
                        goto label_77;
                    }

                    Enumeration v7 = this.chainCerts.keys();
                    while(v7.hasMoreElements()) {
                        v2_2 = this.chainCerts.get(v7.nextElement());
                        if(!((X509Certificate)v2_2).getSubjectDN().equals(v6)) {
                            continue;
                        }

                        try {
                            ((X509Certificate)v0).verify(((X509Certificate)v2_2).getPublicKey());
                            v0_2 = v2_2;
                            goto label_53;
                        }
                        catch(Exception v2_3) {
                            continue;
                        }
                    }
                }

            label_77:
                v0_2 = v4;
            label_53:
                v5.addElement(v1);
                if((((Certificate)v0_2)) == v1) {
                    v0_2 = v3;
                }

                Object v1_1 = v0_2;
            }

            v3 = new Certificate[v5.size()];
            int v1_2;
            for(v1_2 = 0; v1_2 != v3.length; ++v1_2) {
                v3[v1_2] = v5.elementAt(v1_2);
            }
        }

        return v3;
    }

    public Date engineGetCreationDate(String arg3) {
        if(arg3 == null) {
            throw new NullPointerException("alias == null");
        }

        Date v0 = this.keys.get(arg3) != null || this.certs.get(arg3) != null ? new Date() : null;
        return v0;
    }

    public Key engineGetKey(String arg3, char[] arg4) {
        if(arg3 == null) {
            throw new IllegalArgumentException("null alias passed to getKey.");
        }

        return this.keys.get(arg3);
    }

    public boolean engineIsCertificateEntry(String arg2) {
        boolean v0 = this.certs.get(arg2) == null || this.keys.get(arg2) != null ? false : true;
        return v0;
    }

    public boolean engineIsKeyEntry(String arg2) {
        boolean v0 = this.keys.get(arg2) != null ? true : false;
        return v0;
    }

    public void engineLoad(InputStream arg19, char[] arg20) {
        ASN1Encodable v8_2;
        String v2_11;
        Certificate v5_5;
        int v3_4;
        String v3_3;
        String v7_2;
        String v5_4;
        DERBMPString v5_3;
        ASN1Encodable v13_1;
        DERBMPString v13;
        ASN1Encodable v5_2;
        ASN1Encodable v7_1;
        Object v5_1;
        Enumeration v16;
        ASN1Encodable v11_2;
        String v12_1;
        PrivateKey v3_2;
        PrivateKey v4_1;
        EncryptedPrivateKeyInfo v3_1;
        SafeBag v5;
        int v10_1;
        ASN1Primitive v2_7;
        boolean v6;
        int v4;
        if(arg19 != null) {
            if(arg20 == null) {
                throw new NullPointerException("No password supplied for PKCS#12 KeyStore.");
            }
            else {
                BufferedInputStream v2 = new BufferedInputStream(arg19);
                v2.mark(10);
                if(v2.read() != 48) {
                    throw new IOException("stream does not represent a PKCS12 key store");
                }
                else {
                    v2.reset();
                    Pfx v2_1 = Pfx.getInstance(new ASN1InputStream(((InputStream)v2)).readObject());
                    ContentInfo v10 = v2_1.getAuthSafe();
                    Vector v14 = new Vector();
                    int v9 = 0;
                    if(v2_1.getMacData() != null) {
                        MacData v2_2 = v2_1.getMacData();
                        DigestInfo v11 = v2_2.getMac();
                        AlgorithmIdentifier v12 = v11.getAlgorithmId();
                        byte[] v3 = v2_2.getSalt();
                        v4 = v2_2.getIterationCount().intValue();
                        byte[] v7 = v10.getContent().getOctets();
                        try {
                            byte[] v2_5 = PKCS12KeyStoreSpi.calculatePbeMac(v12.getAlgorithm(), v3, v4, arg20, false, v7);
                            byte[] v11_1 = v11.getDigest();
                            if(Arrays.constantTimeAreEqual(v2_5, v11_1)) {
                                goto label_579;
                            }
                            else if(arg20.length > 0) {
                                throw new IOException("PKCS12 key store mac invalid - wrong password or corrupted file.");
                            }
                            else if(!Arrays.constantTimeAreEqual(PKCS12KeyStoreSpi.calculatePbeMac(v12.getAlgorithm(), v3, v4, arg20, true, v7), v11_1)) {
                                throw new IOException("PKCS12 key store mac invalid - wrong password or corrupted file.");
                            }
                            else {
                                goto label_76;
                            }

                            goto label_77;
                        }
                        catch(Exception v2_3) {
                            throw new IOException("error constructing MAC: " + v2_3.toString());
                        }
                        catch(IOException v2_4) {
                            throw v2_4;
                        }

                    label_76:
                        boolean v2_6 = true;
                        goto label_77;
                    label_579:
                        v2_6 = false;
                    label_77:
                        v6 = v2_6;
                    }
                    else {
                        v6 = false;
                    }

                    this.keys = new PKCS12KeyStoreSpi$IgnoresCaseHashtable(null);
                    this.localIds = new Hashtable();
                    if(v10.getContentType().equals(PKCS12KeyStoreSpi.data)) {
                        ContentInfo[] v15 = AuthenticatedSafe.getInstance(new ASN1InputStream(v10.getContent().getOctets()).readObject()).getContentInfo();
                        int v8 = 0;
                        while(v8 != v15.length) {
                            if(v15[v8].getContentType().equals(PKCS12KeyStoreSpi.data)) {
                                v2_7 = new ASN1InputStream(v15[v8].getContent().getOctets()).readObject();
                                v10_1 = v9;
                                v9 = 0;
                                while(v9 != ((ASN1Sequence)v2_7).size()) {
                                    v5 = SafeBag.getInstance(((ASN1Sequence)v2_7).getObjectAt(v9));
                                    if(v5.getBagId().equals(PKCS12KeyStoreSpi.pkcs8ShroudedKeyBag)) {
                                        v3_1 = EncryptedPrivateKeyInfo.getInstance(v5.getBagValue());
                                        v4_1 = this.unwrapKey(v3_1.getEncryptionAlgorithm(), v3_1.getEncryptedData(), arg20, v6);
                                        v3_2 = v4_1;
                                        v12_1 = null;
                                        v11_2 = null;
                                        if(v5.getBagAttributes() != null) {
                                            v16 = v5.getBagAttributes().getObjects();
                                            while(v16.hasMoreElements()) {
                                                v5_1 = v16.nextElement();
                                                v7_1 = ((ASN1Sequence)v5_1).getObjectAt(0);
                                                v5_2 = ((ASN1Sequence)v5_1).getObjectAt(1);
                                                v13 = null;
                                                if(((ASN1Set)v5_2).size() > 0) {
                                                    v5_2 = ((ASN1Set)v5_2).getObjectAt(0);
                                                    v13_1 = ((PKCS12BagAttributeCarrier)v3_2).getBagAttribute(((ASN1ObjectIdentifier)v7_1));
                                                    if(v13_1 == null) {
                                                        ((PKCS12BagAttributeCarrier)v3_2).setBagAttribute(((ASN1ObjectIdentifier)v7_1), v5_2);
                                                    }
                                                    else if(!v13_1.toASN1Primitive().equals(v5_2)) {
                                                        throw new IOException("attempt to add existing attribute with different value");
                                                    }
                                                }
                                                else {
                                                    v5_3 = v13;
                                                }

                                                if(((ASN1ObjectIdentifier)v7_1).equals(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName)) {
                                                    v5_4 = ((DERBMPString)v5_2).getString();
                                                    this.keys.put(v5_4, v4_1);
                                                    v7_2 = v5_4;
                                                    v5_2 = v11_2;
                                                }
                                                else if(((ASN1ObjectIdentifier)v7_1).equals(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId)) {
                                                    v7_2 = v12_1;
                                                }
                                                else {
                                                    v5_2 = v11_2;
                                                    v7_2 = v12_1;
                                                }

                                                v11_2 = v5_2;
                                                v12_1 = v7_2;
                                            }
                                        }

                                        if(v11_2 != null) {
                                            v3_3 = new String(Hex.encode(((ASN1OctetString)v11_2).getOctets()));
                                            if(v12_1 == null) {
                                                this.keys.put(v3_3, v4_1);
                                            }
                                            else {
                                                this.localIds.put(v12_1, v3_3);
                                            }
                                        }
                                        else {
                                            v10_1 = 1;
                                            this.keys.put("unmarked", v4_1);
                                        }

                                        v4 = v10_1;
                                    }
                                    else {
                                        if(v5.getBagId().equals(PKCS12KeyStoreSpi.certBag)) {
                                            v14.addElement(v5);
                                            v4 = v10_1;
                                            goto label_187;
                                        }

                                        System.out.println("extra in data " + v5.getBagId());
                                        System.out.println(ASN1Dump.dumpAsString(v5));
                                        v4 = v10_1;
                                    }

                                label_187:
                                    ++v9;
                                    v10_1 = v4;
                                }

                                v3_4 = v10_1;
                            }
                            else {
                                if(v15[v8].getContentType().equals(PKCS12KeyStoreSpi.encryptedData)) {
                                    EncryptedData v2_8 = EncryptedData.getInstance(v15[v8].getContent());
                                    v2_7 = ASN1Primitive.fromByteArray(this.cryptData(false, v2_8.getEncryptionAlgorithm(), arg20, v6, v2_8.getContent().getOctets()));
                                    for(v10_1 = 0; v10_1 != ((ASN1Sequence)v2_7).size(); ++v10_1) {
                                        v5 = SafeBag.getInstance(((ASN1Sequence)v2_7).getObjectAt(v10_1));
                                        if(v5.getBagId().equals(PKCS12KeyStoreSpi.certBag)) {
                                            v14.addElement(v5);
                                        }
                                        else if(v5.getBagId().equals(PKCS12KeyStoreSpi.pkcs8ShroudedKeyBag)) {
                                            v3_1 = EncryptedPrivateKeyInfo.getInstance(v5.getBagValue());
                                            v4_1 = this.unwrapKey(v3_1.getEncryptionAlgorithm(), v3_1.getEncryptedData(), arg20, v6);
                                            v3_2 = v4_1;
                                            v12_1 = null;
                                            v11_2 = null;
                                            v16 = v5.getBagAttributes().getObjects();
                                            while(v16.hasMoreElements()) {
                                                v5_1 = v16.nextElement();
                                                v7_1 = ((ASN1Sequence)v5_1).getObjectAt(0);
                                                v5_2 = ((ASN1Sequence)v5_1).getObjectAt(1);
                                                v13 = null;
                                                if(((ASN1Set)v5_2).size() > 0) {
                                                    v5_2 = ((ASN1Set)v5_2).getObjectAt(0);
                                                    v13_1 = ((PKCS12BagAttributeCarrier)v3_2).getBagAttribute(((ASN1ObjectIdentifier)v7_1));
                                                    if(v13_1 == null) {
                                                        ((PKCS12BagAttributeCarrier)v3_2).setBagAttribute(((ASN1ObjectIdentifier)v7_1), v5_2);
                                                    }
                                                    else if(!v13_1.toASN1Primitive().equals(v5_2)) {
                                                        throw new IOException("attempt to add existing attribute with different value");
                                                    }
                                                }
                                                else {
                                                    v5_3 = v13;
                                                }

                                                if(((ASN1ObjectIdentifier)v7_1).equals(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName)) {
                                                    v5_4 = ((DERBMPString)v5_2).getString();
                                                    this.keys.put(v5_4, v4_1);
                                                    v7_2 = v5_4;
                                                    v5_2 = v11_2;
                                                }
                                                else if(((ASN1ObjectIdentifier)v7_1).equals(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId)) {
                                                    v7_2 = v12_1;
                                                }
                                                else {
                                                    v5_2 = v11_2;
                                                    v7_2 = v12_1;
                                                }

                                                v11_2 = v5_2;
                                                v12_1 = v7_2;
                                            }

                                            v3_3 = new String(Hex.encode(((ASN1OctetString)v11_2).getOctets()));
                                            if(v12_1 == null) {
                                                this.keys.put(v3_3, v4_1);
                                                goto label_254;
                                            }

                                            this.localIds.put(v12_1, v3_3);
                                        }
                                        else {
                                            if(v5.getBagId().equals(PKCS12KeyStoreSpi.keyBag)) {
                                                v4_1 = BouncyCastleProvider.getPrivateKey(PrivateKeyInfo.getInstance(v5.getBagValue()));
                                                v3_2 = v4_1;
                                                v12_1 = null;
                                                v11_2 = null;
                                                v16 = v5.getBagAttributes().getObjects();
                                                while(v16.hasMoreElements()) {
                                                    v5_1 = v16.nextElement();
                                                    v7_1 = ((ASN1Sequence)v5_1).getObjectAt(0);
                                                    v5_2 = ((ASN1Sequence)v5_1).getObjectAt(1);
                                                    v13 = null;
                                                    if(((ASN1Set)v5_2).size() > 0) {
                                                        v5_2 = ((ASN1Set)v5_2).getObjectAt(0);
                                                        v13_1 = ((PKCS12BagAttributeCarrier)v3_2).getBagAttribute(((ASN1ObjectIdentifier)v7_1));
                                                        if(v13_1 == null) {
                                                            ((PKCS12BagAttributeCarrier)v3_2).setBagAttribute(((ASN1ObjectIdentifier)v7_1), v5_2);
                                                        }
                                                        else if(!v13_1.toASN1Primitive().equals(v5_2)) {
                                                            throw new IOException("attempt to add existing attribute with different value");
                                                        }
                                                    }
                                                    else {
                                                        v5_3 = v13;
                                                    }

                                                    if(((ASN1ObjectIdentifier)v7_1).equals(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName)) {
                                                        v5_4 = ((DERBMPString)v5_2).getString();
                                                        this.keys.put(v5_4, v4_1);
                                                        v7_2 = v5_4;
                                                        v5_2 = v11_2;
                                                    }
                                                    else if(((ASN1ObjectIdentifier)v7_1).equals(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId)) {
                                                        v7_2 = v12_1;
                                                    }
                                                    else {
                                                        v5_2 = v11_2;
                                                        v7_2 = v12_1;
                                                    }

                                                    v11_2 = v5_2;
                                                    v12_1 = v7_2;
                                                }

                                                v3_3 = new String(Hex.encode(((ASN1OctetString)v11_2).getOctets()));
                                                if(v12_1 == null) {
                                                    this.keys.put(v3_3, v4_1);
                                                    goto label_254;
                                                }

                                                this.localIds.put(v12_1, v3_3);
                                                goto label_254;
                                            }

                                            System.out.println("extra in encryptedData " + v5.getBagId());
                                            System.out.println(ASN1Dump.dumpAsString(v5));
                                        }

                                    label_254:
                                    }

                                    v3_4 = v9;
                                    goto label_223;
                                }

                                System.out.println("extra " + v15[v8].getContentType().getId());
                                System.out.println("extra " + ASN1Dump.dumpAsString(v15[v8].getContent()));
                                v3_4 = v9;
                            }

                        label_223:
                            ++v8;
                            v9 = v3_4;
                        }
                    }

                    this.certs = new PKCS12KeyStoreSpi$IgnoresCaseHashtable(null);
                    this.chainCerts = new Hashtable();
                    this.keyCerts = new Hashtable();
                    int v6_1;
                    for(v6_1 = 0; v6_1 != v14.size(); ++v6_1) {
                        Object v2_9 = v14.elementAt(v6_1);
                        CertBag v3_5 = CertBag.getInstance(((SafeBag)v2_9).getBagValue());
                        if(!v3_5.getCertId().equals(PKCS12KeyStoreSpi.x509Certificate)) {
                            throw new RuntimeException("Unsupported certificate type: " + v3_5.getCertId());
                        }

                        try {
                            v5_5 = this.certFact.generateCertificate(new ByteArrayInputStream(v3_5.getCertValue().getOctets()));
                        }
                        catch(Exception v2_3) {
                            throw new RuntimeException(v2_3.toString());
                        }

                        ASN1OctetString v8_1 = null;
                        v7_2 = null;
                        if(((SafeBag)v2_9).getBagAttributes() != null) {
                            Enumeration v10_2 = ((SafeBag)v2_9).getBagAttributes().getObjects();
                            while(v10_2.hasMoreElements()) {
                                v2_9 = v10_2.nextElement();
                                ASN1Encodable v3_6 = ((ASN1Sequence)v2_9).getObjectAt(0);
                                ASN1Encodable v2_10 = ((ASN1Sequence)v2_9).getObjectAt(1).getObjectAt(0);
                                if((v5_5 instanceof PKCS12BagAttributeCarrier)) {
                                    Certificate v4_2 = v5_5;
                                    v11_2 = ((PKCS12BagAttributeCarrier)v4_2).getBagAttribute(((ASN1ObjectIdentifier)v3_6));
                                    if(v11_2 == null) {
                                        ((PKCS12BagAttributeCarrier)v4_2).setBagAttribute(((ASN1ObjectIdentifier)v3_6), v2_10);
                                    }
                                    else if(!v11_2.toASN1Primitive().equals(v2_10)) {
                                        throw new IOException("attempt to add existing attribute with different value");
                                    }
                                }

                                if(((ASN1ObjectIdentifier)v3_6).equals(PKCS12KeyStoreSpi.pkcs_9_at_friendlyName)) {
                                    v2_11 = ((DERBMPString)v2_10).getString();
                                    v3_6 = ((ASN1Encodable)v8_1);
                                }
                                else if(((ASN1ObjectIdentifier)v3_6).equals(PKCS12KeyStoreSpi.pkcs_9_at_localKeyId)) {
                                    v3_6 = v2_10;
                                    v2_11 = v7_2;
                                }
                                else {
                                    v2_11 = v7_2;
                                    v3_6 = ((ASN1Encodable)v8_1);
                                }

                                v7_2 = v2_11;
                                v8_2 = v3_6;
                            }
                        }

                        this.chainCerts.put(new PKCS12KeyStoreSpi$CertId(this, v5_5.getPublicKey()), v5_5);
                        if(v9 == 0) {
                            if((((ASN1OctetString)v8_2)) != null) {
                                this.keyCerts.put(new String(Hex.encode(((ASN1OctetString)v8_2).getOctets())), v5_5);
                            }

                            if(v7_2 == null) {
                                goto label_545;
                            }

                            this.certs.put(v7_2, v5_5);
                        }
                        else if(this.keyCerts.isEmpty()) {
                            v2_11 = new String(Hex.encode(this.createSubjectKeyId(v5_5.getPublicKey()).getKeyIdentifier()));
                            this.keyCerts.put(v2_11, v5_5);
                            this.keys.put(v2_11, this.keys.remove("unmarked"));
                        }

                    label_545:
                    }
                }
            }
        }
    }

    public void engineSetCertificateEntry(String arg4, Certificate arg5) {
        if(this.keys.get(arg4) != null) {
            throw new KeyStoreException("There is a key entry with the name " + arg4 + ".");
        }

        this.certs.put(arg4, arg5);
        this.chainCerts.put(new PKCS12KeyStoreSpi$CertId(this, arg5.getPublicKey()), arg5);
    }

    public void engineSetKeyEntry(String arg5, Key arg6, char[] arg7, Certificate[] arg8) {
        int v0 = 0;
        if(!(arg6 instanceof PrivateKey)) {
            throw new KeyStoreException("PKCS12 does not support non-PrivateKeys");
        }

        if(((arg6 instanceof PrivateKey)) && arg8 == null) {
            throw new KeyStoreException("no certificate chain for private key");
        }

        if(this.keys.get(arg5) != null) {
            this.engineDeleteEntry(arg5);
        }

        this.keys.put(arg5, arg6);
        if(arg8 != null) {
            this.certs.put(arg5, arg8[0]);
            while(v0 != arg8.length) {
                this.chainCerts.put(new PKCS12KeyStoreSpi$CertId(this, arg8[v0].getPublicKey()), arg8[v0]);
                ++v0;
            }
        }
    }

    public void engineSetKeyEntry(String arg3, byte[] arg4, Certificate[] arg5) {
        throw new RuntimeException("operation not supported");
    }

    public int engineSize() {
        Hashtable v1 = new Hashtable();
        Enumeration v0 = this.certs.keys();
        while(v0.hasMoreElements()) {
            v1.put(v0.nextElement(), "cert");
        }

        Enumeration v2 = this.keys.keys();
        while(v2.hasMoreElements()) {
            Object v0_1 = v2.nextElement();
            if(v1.get(v0_1) != null) {
                continue;
            }

            v1.put(v0_1, "key");
        }

        return v1.size();
    }

    public void engineStore(OutputStream arg2, char[] arg3) {
        this.doStore(arg2, arg3, false);
    }

    public void engineStore(KeyStore$LoadStoreParameter arg5) {
        char[] v0_1;
        KeyStore$LoadStoreParameter v1;
        if(arg5 == null) {
            throw new IllegalArgumentException("\'param\' arg cannot be null");
        }

        if(!(arg5 instanceof PKCS12StoreParameter) && !(arg5 instanceof JDKPKCS12StoreParameter)) {
            throw new IllegalArgumentException("No support for \'param\' of type " + arg5.getClass().getName());
        }

        if((arg5 instanceof PKCS12StoreParameter)) {
            v1 = arg5;
        }
        else {
            PKCS12StoreParameter v1_1 = new PKCS12StoreParameter(arg5.getOutputStream(), arg5.getProtectionParameter(), arg5.isUseDEREncoding());
        }

        KeyStore$ProtectionParameter v0 = arg5.getProtectionParameter();
        if(v0 == null) {
            v0_1 = null;
        }
        else if((v0 instanceof KeyStore$PasswordProtection)) {
            v0_1 = ((KeyStore$PasswordProtection)v0).getPassword();
        }
        else {
            goto label_43;
        }

        this.doStore(((PKCS12StoreParameter)v1).getOutputStream(), v0_1, ((PKCS12StoreParameter)v1).isForDEREncoding());
        return;
    label_43:
        throw new IllegalArgumentException("No support for protection parameter of type " + v0.getClass().getName());
    }

    public void setRandom(SecureRandom arg1) {
        this.random = arg1;
    }

    protected PrivateKey unwrapKey(AlgorithmIdentifier arg8, byte[] arg9, char[] arg10, boolean arg11) {
        Key v1_3;
        SecretKey v2_1;
        ASN1ObjectIdentifier v3 = arg8.getAlgorithm();
        try {
            if(v3.on(PKCSObjectIdentifiers.pkcs_12PbeIds)) {
                PKCS12PBEParams v1_1 = PKCS12PBEParams.getInstance(arg8.getParameters());
                PBEKeySpec v2 = new PBEKeySpec(arg10);
                SecretKeyFactory v4 = SecretKeyFactory.getInstance(v3.getId(), PKCS12KeyStoreSpi.bcProvider);
                PBEParameterSpec v5 = new PBEParameterSpec(v1_1.getIV(), v1_1.getIterations().intValue());
                v2_1 = v4.generateSecret(((KeySpec)v2));
                v2_1.setTryWrongPKCS12Zero(arg11);
                Cipher v1_2 = Cipher.getInstance(v3.getId(), PKCS12KeyStoreSpi.bcProvider);
                v1_2.init(4, ((Key)v2_1), ((AlgorithmParameterSpec)v5));
                v1_3 = v1_2.unwrap(arg9, "", 2);
            }
            else if(v3.equals(PKCSObjectIdentifiers.id_PBES2)) {
                PBES2Parameters v1_4 = PBES2Parameters.getInstance(arg8.getParameters());
                PBKDF2Params v2_2 = PBKDF2Params.getInstance(v1_4.getKeyDerivationFunc().getParameters());
                v2_1 = SecretKeyFactory.getInstance(v1_4.getKeyDerivationFunc().getAlgorithm().getId(), PKCS12KeyStoreSpi.bcProvider).generateSecret(new PBEKeySpec(arg10, v2_2.getSalt(), v2_2.getIterationCount().intValue(), SecretKeyUtil.getKeySize(v1_4.getEncryptionScheme().getAlgorithm())));
                Cipher v3_1 = Cipher.getInstance(v1_4.getEncryptionScheme().getAlgorithm().getId(), PKCS12KeyStoreSpi.bcProvider);
                v3_1.init(4, ((Key)v2_1), new IvParameterSpec(ASN1OctetString.getInstance(v1_4.getEncryptionScheme().getParameters()).getOctets()));
                v1_3 = v3_1.unwrap(arg9, "", 2);
            }
            else {
                goto label_79;
            }

            return ((PrivateKey)v1_3);
        }
        catch(Exception v1) {
            throw new IOException("exception unwrapping private key - " + v1.toString());
        }

    label_79:
        throw new IOException("exception unwrapping private key - cannot recognise: " + v3);
    }

    protected byte[] wrapKey(String arg6, Key arg7, PKCS12PBEParams arg8, char[] arg9) {
        PBEKeySpec v0 = new PBEKeySpec(arg9);
        try {
            SecretKeyFactory v1 = SecretKeyFactory.getInstance(arg6, PKCS12KeyStoreSpi.bcProvider);
            PBEParameterSpec v2 = new PBEParameterSpec(arg8.getIV(), arg8.getIterations().intValue());
            Cipher v3 = Cipher.getInstance(arg6, PKCS12KeyStoreSpi.bcProvider);
            v3.init(3, v1.generateSecret(((KeySpec)v0)), ((AlgorithmParameterSpec)v2));
            return v3.wrap(arg7);
        }
        catch(Exception v0_1) {
            throw new IOException("exception encrypting data - " + v0_1.toString());
        }
    }
}

