// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import javax.crypto.spec.IvParameterSpec;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.misc.CAST5CBCParameters;
import org.bouncycastle.jcajce.provider.symmetric.util.BaseAlgorithmParameters;

public class CAST5$AlgParams extends BaseAlgorithmParameters {
    private byte[] iv;
    private int keyLength;

    public CAST5$AlgParams() {
        super();
        this.keyLength = 128;
    }

    protected byte[] engineGetEncoded() {
        byte[] v0 = new byte[this.iv.length];
        System.arraycopy(this.iv, 0, v0, 0, this.iv.length);
        return v0;
    }

    protected byte[] engineGetEncoded(String arg4) {
        byte[] v0;
        if(this.isASN1FormatString(arg4)) {
            v0 = new CAST5CBCParameters(this.engineGetEncoded(), this.keyLength).getEncoded();
        }
        else if(arg4.equals("RAW")) {
            v0 = this.engineGetEncoded();
        }
        else {
            v0 = null;
        }

        return v0;
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if((arg3 instanceof IvParameterSpec)) {
            this.iv = ((IvParameterSpec)arg3).getIV();
            return;
        }

        throw new InvalidParameterSpecException("IvParameterSpec required to initialise a CAST5 parameters algorithm parameters object");
    }

    protected void engineInit(byte[] arg4) {
        this.iv = new byte[arg4.length];
        System.arraycopy(arg4, 0, this.iv, 0, this.iv.length);
    }

    protected void engineInit(byte[] arg3, String arg4) {
        if(this.isASN1FormatString(arg4)) {
            CAST5CBCParameters v0 = CAST5CBCParameters.getInstance(new ASN1InputStream(arg3).readObject());
            this.keyLength = v0.getKeyLength();
            this.iv = v0.getIV();
        }
        else if(arg4.equals("RAW")) {
            this.engineInit(arg3);
        }
        else {
            goto label_16;
        }

        return;
    label_16:
        throw new IOException("Unknown parameters format in IV parameters object");
    }

    protected String engineToString() {
        return "CAST5 Parameters";
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == IvParameterSpec.class) {
            return new IvParameterSpec(this.iv);
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to CAST5 parameters object.");
    }
}

