// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import javax.crypto.interfaces.PBEKey;
import javax.crypto.spec.PBEKeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class BCPBEKey implements PBEKey {
    String algorithm;
    int digest;
    int ivSize;
    int keySize;
    ASN1ObjectIdentifier oid;
    CipherParameters param;
    PBEKeySpec pbeKeySpec;
    boolean tryWrong;
    int type;

    public BCPBEKey(String arg2, ASN1ObjectIdentifier arg3, int arg4, int arg5, int arg6, int arg7, PBEKeySpec arg8, CipherParameters arg9) {
        super();
        this.tryWrong = false;
        this.algorithm = arg2;
        this.oid = arg3;
        this.type = arg4;
        this.digest = arg5;
        this.keySize = arg6;
        this.ivSize = arg7;
        this.pbeKeySpec = arg8;
        this.param = arg9;
    }

    public String getAlgorithm() {
        return this.algorithm;
    }

    int getDigest() {
        return this.digest;
    }

    public byte[] getEncoded() {
        byte[] v0_1;
        if(this.param != null) {
            CipherParameters v0 = (this.param instanceof ParametersWithIV) ? this.param.getParameters() : this.param;
            v0_1 = ((KeyParameter)v0).getKey();
        }
        else {
            if(this.type == 2) {
                return PBEParametersGenerator.PKCS12PasswordToBytes(this.pbeKeySpec.getPassword());
            }

            if(this.type == 5) {
                return PBEParametersGenerator.PKCS5PasswordToUTF8Bytes(this.pbeKeySpec.getPassword());
            }

            v0_1 = PBEParametersGenerator.PKCS5PasswordToBytes(this.pbeKeySpec.getPassword());
        }

        return v0_1;
    }

    public String getFormat() {
        return "RAW";
    }

    public int getIterationCount() {
        return this.pbeKeySpec.getIterationCount();
    }

    public int getIvSize() {
        return this.ivSize;
    }

    int getKeySize() {
        return this.keySize;
    }

    public ASN1ObjectIdentifier getOID() {
        return this.oid;
    }

    public CipherParameters getParam() {
        return this.param;
    }

    public char[] getPassword() {
        return this.pbeKeySpec.getPassword();
    }

    public byte[] getSalt() {
        return this.pbeKeySpec.getSalt();
    }

    int getType() {
        return this.type;
    }

    public void setTryWrongPKCS12Zero(boolean arg1) {
        this.tryWrong = arg1;
    }

    boolean shouldTryWrongPKCS12() {
        return this.tryWrong;
    }
}

