// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.InvalidParameterException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.ShortBufferException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.RC2ParameterSpec;
import javax.crypto.spec.RC5ParameterSpec;
import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.BufferedBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.OutputLengthException;
import org.bouncycastle.crypto.modes.CBCBlockCipher;
import org.bouncycastle.crypto.modes.CCMBlockCipher;
import org.bouncycastle.crypto.modes.CFBBlockCipher;
import org.bouncycastle.crypto.modes.CTSBlockCipher;
import org.bouncycastle.crypto.modes.EAXBlockCipher;
import org.bouncycastle.crypto.modes.GCMBlockCipher;
import org.bouncycastle.crypto.modes.GOFBBlockCipher;
import org.bouncycastle.crypto.modes.OCBBlockCipher;
import org.bouncycastle.crypto.modes.OFBBlockCipher;
import org.bouncycastle.crypto.modes.OpenPGPCFBBlockCipher;
import org.bouncycastle.crypto.modes.PGPCFBBlockCipher;
import org.bouncycastle.crypto.modes.SICBlockCipher;
import org.bouncycastle.crypto.paddings.ISO10126d2Padding;
import org.bouncycastle.crypto.paddings.ISO7816d4Padding;
import org.bouncycastle.crypto.paddings.TBCPadding;
import org.bouncycastle.crypto.paddings.X923Padding;
import org.bouncycastle.crypto.paddings.ZeroBytePadding;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.params.ParametersWithSBox;
import org.bouncycastle.crypto.params.RC2Parameters;
import org.bouncycastle.crypto.params.RC5Parameters;
import org.bouncycastle.jce.spec.GOST28147ParameterSpec;
import org.bouncycastle.jce.spec.RepeatedSecretKeySpec;
import org.bouncycastle.util.Strings;

public class BaseBlockCipher extends BaseWrapCipher implements PBE {
    private Class[] availableSpecs;
    private BlockCipher baseEngine;
    private BaseBlockCipher$GenericBlockCipher cipher;
    private BlockCipherProvider engineProvider;
    private int ivLength;
    private ParametersWithIV ivParam;
    private String modeName;
    private boolean padded;
    private String pbeAlgorithm;
    private PBEParameterSpec pbeSpec;

    public BaseBlockCipher(BlockCipher arg6) {
        super();
        this.availableSpecs = new Class[]{RC2ParameterSpec.class, RC5ParameterSpec.class, IvParameterSpec.class, PBEParameterSpec.class, GOST28147ParameterSpec.class};
        this.ivLength = 0;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.modeName = null;
        this.baseEngine = arg6;
        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(arg6);
    }

    public BaseBlockCipher(BlockCipher arg6, int arg7) {
        super();
        this.availableSpecs = new Class[]{RC2ParameterSpec.class, RC5ParameterSpec.class, IvParameterSpec.class, PBEParameterSpec.class, GOST28147ParameterSpec.class};
        this.ivLength = 0;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.modeName = null;
        this.baseEngine = arg6;
        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(arg6);
        this.ivLength = arg7 / 8;
    }

    public BaseBlockCipher(BufferedBlockCipher arg6, int arg7) {
        super();
        this.availableSpecs = new Class[]{RC2ParameterSpec.class, RC5ParameterSpec.class, IvParameterSpec.class, PBEParameterSpec.class, GOST28147ParameterSpec.class};
        this.ivLength = 0;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.modeName = null;
        this.baseEngine = arg6.getUnderlyingCipher();
        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(arg6);
        this.ivLength = arg7 / 8;
    }

    public BaseBlockCipher(BlockCipherProvider arg6) {
        super();
        this.availableSpecs = new Class[]{RC2ParameterSpec.class, RC5ParameterSpec.class, IvParameterSpec.class, PBEParameterSpec.class, GOST28147ParameterSpec.class};
        this.ivLength = 0;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.modeName = null;
        this.baseEngine = arg6.get();
        this.engineProvider = arg6;
        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(arg6.get());
    }

    protected int engineDoFinal(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        int v0 = 0;
        if(arg9 != 0) {
            try {
                v0 = this.cipher.processBytes(arg7, arg8, arg9, arg10, arg11);
            label_9:
                return v0 + this.cipher.doFinal(arg10, arg11 + v0);
            }
            catch(InvalidCipherTextException v0_1) {
                throw new BadPaddingException(v0_1.getMessage());
            }
            catch(DataLengthException v0_2) {
                throw new IllegalBlockSizeException(v0_2.getMessage());
            }
            catch(OutputLengthException v0_3) {
                throw new ShortBufferException(v0_3.getMessage());
            }
        }

        goto label_9;
    }

    protected byte[] engineDoFinal(byte[] arg7, int arg8, int arg9) {
        int v1;
        byte[] v4 = new byte[this.engineGetOutputSize(arg9)];
        int v0 = arg9 != 0 ? this.cipher.processBytes(arg7, arg8, arg9, v4, 0) : 0;
        try {
            v1 = this.cipher.doFinal(v4, v0);
        }
        catch(InvalidCipherTextException v0_1) {
            throw new BadPaddingException(v0_1.getMessage());
        }
        catch(DataLengthException v0_2) {
            throw new IllegalBlockSizeException(v0_2.getMessage());
        }

        v1 += v0;
        if(v1 != v4.length) {
            byte[] v0_3 = new byte[v1];
            System.arraycopy(v4, 0, v0_3, 0, v1);
            v4 = v0_3;
        }

        return v4;
    }

    protected int engineGetBlockSize() {
        return this.baseEngine.getBlockSize();
    }

    protected byte[] engineGetIV() {
        byte[] v0 = this.ivParam != null ? this.ivParam.getIV() : null;
        return v0;
    }

    protected int engineGetKeySize(Key arg2) {
        return arg2.getEncoded().length * 8;
    }

    protected int engineGetOutputSize(int arg2) {
        return this.cipher.getOutputSize(arg2);
    }

    protected AlgorithmParameters engineGetParameters() {
        int v2 = 47;
        if(this.engineParams == null) {
            if(this.pbeSpec != null) {
                try {
                    this.engineParams = AlgorithmParameters.getInstance(this.pbeAlgorithm, "BC");
                    this.engineParams.init(this.pbeSpec);
                }
                catch(Exception v0) {
                    AlgorithmParameters v0_1 = null;
                    return v0_1;
                }
            }
            else if(this.ivParam != null) {
                String v0_2 = this.cipher.getUnderlyingCipher().getAlgorithmName();
                if(v0_2.indexOf(v2) >= 0) {
                    v0_2 = v0_2.substring(0, v0_2.indexOf(v2));
                }

                try {
                    this.engineParams = AlgorithmParameters.getInstance(v0_2, "BC");
                    this.engineParams.init(this.ivParam.getIV());
                }
                catch(Exception v0) {
                    throw new RuntimeException(v0.toString());
                }
            }
        }

        return this.engineParams;
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameters arg6, SecureRandom arg7) {
        AlgorithmParameterSpec v0_1;
        AlgorithmParameterSpec v1 = null;
        if(arg6 != null) {
            int v0 = 0;
            while(true) {
                if(v0 != this.availableSpecs.length) {
                    try {
                        v0_1 = arg6.getParameterSpec(this.availableSpecs[((int)v0_1)]);
                        goto label_9;
                    }
                    catch(Exception v2) {
                        v0 = (((int)v0_1)) + 1;
                        continue;
                    }
                }
                else {
                    break;
                }

                goto label_9;
            }

            v0_1 = v1;
        label_9:
            if(v0_1 != null) {
                goto label_24;
            }

            throw new InvalidAlgorithmParameterException("can\'t handle parameter " + arg6.toString());
        }

        v0_1 = v1;
    label_24:
        this.engineInit(arg4, arg5, v0_1, arg7);
        this.engineParams = arg6;
    }

    protected void engineInit(int arg6, Key arg7, AlgorithmParameterSpec arg8, SecureRandom arg9) {
        RC5Parameters v1_4;
        RC2Parameters v1_3;
        ParametersWithSBox v1_2;
        AlgorithmParameterSpec v0_3;
        KeyParameter v0_2;
        ParametersWithIV v0_1;
        CipherParameters v1_1;
        ParametersWithIV v1;
        PBEParameterSpec v2 = null;
        this.pbeSpec = v2;
        this.pbeAlgorithm = ((String)v2);
        this.engineParams = ((AlgorithmParameters)v2);
        if(!(arg7 instanceof SecretKey)) {
            throw new InvalidKeyException("Key for algorithm " + arg7.getAlgorithm() + " not suitable for symmetric enryption.");
        }

        if(arg8 == null && (this.baseEngine.getAlgorithmName().startsWith("RC5-64"))) {
            throw new InvalidAlgorithmParameterException("RC5 requires an RC5ParametersSpec to be passed in.");
        }

        if((arg7 instanceof BCPBEKey)) {
            this.pbeAlgorithm = ((BCPBEKey)arg7).getOID() != null ? ((BCPBEKey)arg7).getOID().getId() : ((BCPBEKey)arg7).getAlgorithm();
            if(((BCPBEKey)arg7).getParam() != null) {
                CipherParameters v0 = ((BCPBEKey)arg7).getParam();
                if((arg8 instanceof IvParameterSpec)) {
                    v1 = new ParametersWithIV(v0, ((IvParameterSpec)arg8).getIV());
                }
                else {
                    v1_1 = v0;
                }
            }
            else if((arg8 instanceof PBEParameterSpec)) {
                this.pbeSpec = arg8;
                v1_1 = PBE$Util.makePBEParameters(((BCPBEKey)arg7), arg8, this.cipher.getUnderlyingCipher().getAlgorithmName());
            }
            else {
                goto label_100;
            }

            if((v1 instanceof ParametersWithIV)) {
                this.ivParam = v1;
            }

            v0_1 = v1;
            goto label_49;
        label_100:
            throw new InvalidAlgorithmParameterException("PBE requires PBE parameters to be set.");
        }
        else {
            if(arg8 == null) {
                v0_2 = new KeyParameter(arg7.getEncoded());
                goto label_49;
            }

            if((arg8 instanceof IvParameterSpec)) {
                if(this.ivLength != 0) {
                    if(((IvParameterSpec)arg8).getIV().length != this.ivLength && !this.isAEADModeName(this.modeName)) {
                        throw new InvalidAlgorithmParameterException("IV must be " + this.ivLength + " bytes long.");
                    }

                    if((arg7 instanceof RepeatedSecretKeySpec)) {
                        v1 = new ParametersWithIV(((CipherParameters)v2), ((IvParameterSpec)arg8).getIV());
                        this.ivParam = v1;
                    }
                    else {
                        v1 = new ParametersWithIV(new KeyParameter(arg7.getEncoded()), ((IvParameterSpec)arg8).getIV());
                        this.ivParam = v1;
                    }

                    v0_1 = v1;
                    goto label_49;
                }

                if(this.modeName != null && (this.modeName.equals("ECB"))) {
                    throw new InvalidAlgorithmParameterException("ECB mode does not use an IV");
                }

                v0_2 = new KeyParameter(arg7.getEncoded());
                goto label_49;
            }

            if((arg8 instanceof GOST28147ParameterSpec)) {
                v0_3 = arg8;
                ParametersWithSBox v2_1 = new ParametersWithSBox(new KeyParameter(arg7.getEncoded()), ((GOST28147ParameterSpec)arg8).getSbox());
                if(((GOST28147ParameterSpec)v0_3).getIV() == null || this.ivLength == 0) {
                    v1_2 = v2_1;
                }
                else {
                    v1 = new ParametersWithIV(((CipherParameters)v2_1), ((GOST28147ParameterSpec)v0_3).getIV());
                    this.ivParam = v1;
                }

                v0_1 = ((ParametersWithIV)v1_2);
                goto label_49;
            }

            if((arg8 instanceof RC2ParameterSpec)) {
                v0_3 = arg8;
                RC2Parameters v2_2 = new RC2Parameters(arg7.getEncoded(), ((RC2ParameterSpec)arg8).getEffectiveKeyBits());
                if(((RC2ParameterSpec)v0_3).getIV() == null || this.ivLength == 0) {
                    v1_3 = v2_2;
                }
                else {
                    v1 = new ParametersWithIV(((CipherParameters)v2_2), ((RC2ParameterSpec)v0_3).getIV());
                    this.ivParam = v1;
                }

                v0_1 = ((ParametersWithIV)v1_3);
                goto label_49;
            }

            if(!(arg8 instanceof RC5ParameterSpec)) {
                goto label_271;
            }

            v0_3 = arg8;
            RC5Parameters v2_3 = new RC5Parameters(arg7.getEncoded(), ((RC5ParameterSpec)arg8).getRounds());
            if(!this.baseEngine.getAlgorithmName().startsWith("RC5")) {
                goto label_256;
            }

            if(this.baseEngine.getAlgorithmName().equals("RC5-32")) {
                if(((RC5ParameterSpec)v0_3).getWordSize() != 32) {
                    throw new InvalidAlgorithmParameterException("RC5 already set up for a word size of 32 not " + ((RC5ParameterSpec)v0_3).getWordSize() + ".");
                }
            }
            else if((this.baseEngine.getAlgorithmName().equals("RC5-64")) && ((RC5ParameterSpec)v0_3).getWordSize() != 64) {
                throw new InvalidAlgorithmParameterException("RC5 already set up for a word size of 64 not " + ((RC5ParameterSpec)v0_3).getWordSize() + ".");
            }

            if(((RC5ParameterSpec)v0_3).getIV() == null || this.ivLength == 0) {
                v1_4 = v2_3;
            }
            else {
                v1 = new ParametersWithIV(((CipherParameters)v2_3), ((RC5ParameterSpec)v0_3).getIV());
                this.ivParam = v1;
            }

            v0_1 = ((ParametersWithIV)v1_4);
        }

    label_49:
        if(this.ivLength == 0 || (((((ParametersWithIV)v0_2)) instanceof ParametersWithIV))) {
        label_295:
            v1 = ((ParametersWithIV)v0_2);
        }
        else {
            SecureRandom v1_5 = arg9 == null ? new SecureRandom() : arg9;
            if(arg6 != 1 && arg6 != 3) {
                if(this.cipher.getUnderlyingCipher().getAlgorithmName().indexOf("PGPCFB") < 0) {
                    throw new InvalidAlgorithmParameterException("no IV set when one expected");
                }
                else {
                    goto label_295;
                }
            }

            byte[] v2_4 = new byte[this.ivLength];
            v1_5.nextBytes(v2_4);
            v1 = new ParametersWithIV(((CipherParameters)v0_2), v2_4);
            this.ivParam = v1;
        }

        if(arg9 == null || !this.padded) {
            v0_1 = v1;
        }
        else {
            ParametersWithRandom v0_4 = new ParametersWithRandom(((CipherParameters)v1), arg9);
        }

        switch(arg6) {
            case 1: 
            case 3: {
                goto label_285;
            }
            case 2: 
            case 4: {
                goto label_289;
            }
        }

        try {
            throw new InvalidParameterException("unknown opmode " + arg6 + " passed");
        label_289:
            this.cipher.init(false, ((CipherParameters)v0_1));
            return;
        label_285:
            this.cipher.init(true, ((CipherParameters)v0_1));
            return;
        }
        catch(Exception v0_5) {
            throw new InvalidKeyException(v0_5.getMessage());
        }

    label_256:
        throw new InvalidAlgorithmParameterException("RC5 parameters passed to a cipher that is not RC5.");
    label_271:
        throw new InvalidAlgorithmParameterException("unknown parameter type.");
    }

    protected void engineInit(int arg3, Key arg4, SecureRandom arg5) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.engineInit(arg3, arg4, v0, arg5);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidKeyException(v0_1.getMessage());
        }
    }

    protected void engineSetMode(String arg5) {
        int v2 = 3;
        this.modeName = Strings.toUpperCase(arg5);
        if(this.modeName.equals("ECB")) {
            this.ivLength = 0;
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.baseEngine);
        }
        else if(this.modeName.equals("CBC")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new CBCBlockCipher(this.baseEngine));
        }
        else if(this.modeName.startsWith("OFB")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = this.modeName.length() != v2 ? new BaseBlockCipher$BufferedGenericBlockCipher(new OFBBlockCipher(this.baseEngine, Integer.parseInt(this.modeName.substring(v2)))) : new BaseBlockCipher$BufferedGenericBlockCipher(new OFBBlockCipher(this.baseEngine, this.baseEngine.getBlockSize() * 8));
        }
        else if(this.modeName.startsWith("CFB")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = this.modeName.length() != v2 ? new BaseBlockCipher$BufferedGenericBlockCipher(new CFBBlockCipher(this.baseEngine, Integer.parseInt(this.modeName.substring(v2)))) : new BaseBlockCipher$BufferedGenericBlockCipher(new CFBBlockCipher(this.baseEngine, this.baseEngine.getBlockSize() * 8));
        }
        else if(this.modeName.startsWith("PGP")) {
            boolean v0 = this.modeName.equalsIgnoreCase("PGPCFBwithIV");
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new PGPCFBBlockCipher(this.baseEngine, v0));
        }
        else if(this.modeName.equalsIgnoreCase("OpenPGPCFB")) {
            this.ivLength = 0;
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new OpenPGPCFBBlockCipher(this.baseEngine));
        }
        else if(this.modeName.startsWith("SIC")) {
            this.ivLength = this.baseEngine.getBlockSize();
            if(this.ivLength < 16) {
                throw new IllegalArgumentException("Warning: SIC-Mode can become a twotime-pad if the blocksize of the cipher is too small. Use a cipher with a block size of at least 128 bits (e.g. AES)");
            }
            else {
                this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new BufferedBlockCipher(new SICBlockCipher(this.baseEngine)));
            }
        }
        else if(this.modeName.startsWith("CTR")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new BufferedBlockCipher(new SICBlockCipher(this.baseEngine)));
        }
        else if(this.modeName.startsWith("GOFB")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new BufferedBlockCipher(new GOFBBlockCipher(this.baseEngine)));
        }
        else if(this.modeName.startsWith("CTS")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new CTSBlockCipher(new CBCBlockCipher(this.baseEngine)));
        }
        else if(this.modeName.startsWith("CCM")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$AEADGenericBlockCipher(new CCMBlockCipher(this.baseEngine));
        }
        else if(this.modeName.startsWith("OCB")) {
            if(this.engineProvider != null) {
                this.ivLength = this.baseEngine.getBlockSize();
                this.cipher = new BaseBlockCipher$AEADGenericBlockCipher(new OCBBlockCipher(this.baseEngine, this.engineProvider.get()));
            }
            else {
                throw new NoSuchAlgorithmException("can\'t support mode " + arg5);
            }
        }
        else if(this.modeName.startsWith("EAX")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$AEADGenericBlockCipher(new EAXBlockCipher(this.baseEngine));
        }
        else if(this.modeName.startsWith("GCM")) {
            this.ivLength = this.baseEngine.getBlockSize();
            this.cipher = new BaseBlockCipher$AEADGenericBlockCipher(new GCMBlockCipher(this.baseEngine));
        }
        else {
            goto label_257;
        }

        return;
    label_257:
        throw new NoSuchAlgorithmException("can\'t support mode " + arg5);
    }

    protected void engineSetPadding(String arg4) {
        String v0 = Strings.toUpperCase(arg4);
        if(v0.equals("NOPADDING")) {
            if(this.cipher.wrapOnNoPadding()) {
                this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new BufferedBlockCipher(this.cipher.getUnderlyingCipher()));
            }
        }
        else if(v0.equals("WITHCTS")) {
            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(new CTSBlockCipher(this.cipher.getUnderlyingCipher()));
        }
        else {
            this.padded = true;
            if(this.isAEADModeName(this.modeName)) {
                throw new NoSuchPaddingException("Only NoPadding can be used with AEAD modes.");
            }
            else {
                if(!v0.equals("PKCS5PADDING") && !v0.equals("PKCS7PADDING")) {
                    if(v0.equals("ZEROBYTEPADDING")) {
                        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.cipher.getUnderlyingCipher(), new ZeroBytePadding());
                    }
                    else {
                        if(!v0.equals("ISO10126PADDING") && !v0.equals("ISO10126-2PADDING")) {
                            if(!v0.equals("X9.23PADDING") && !v0.equals("X923PADDING")) {
                                if(!v0.equals("ISO7816-4PADDING") && !v0.equals("ISO9797-1PADDING")) {
                                    if(v0.equals("TBCPADDING")) {
                                        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.cipher.getUnderlyingCipher(), new TBCPadding());
                                        return;
                                    }
                                    else {
                                        throw new NoSuchPaddingException("Padding " + arg4 + " unknown.");
                                    }
                                }

                                this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.cipher.getUnderlyingCipher(), new ISO7816d4Padding());
                                return;
                            }

                            this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.cipher.getUnderlyingCipher(), new X923Padding());
                            return;
                        }

                        this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.cipher.getUnderlyingCipher(), new ISO10126d2Padding());
                    }

                    return;
                }

                this.cipher = new BaseBlockCipher$BufferedGenericBlockCipher(this.cipher.getUnderlyingCipher());
            }
        }
    }

    protected int engineUpdate(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        try {
            return this.cipher.processBytes(arg7, arg8, arg9, arg10, arg11);
        }
        catch(DataLengthException v0) {
            throw new ShortBufferException(v0.getMessage());
        }
    }

    protected byte[] engineUpdate(byte[] arg8, int arg9, int arg10) {
        byte[] v4;
        byte[] v6 = null;
        int v0 = this.cipher.getUpdateOutputSize(arg10);
        if(v0 > 0) {
            v4 = new byte[v0];
            int v1 = this.cipher.processBytes(arg8, arg9, arg10, v4, 0);
            if(v1 == 0) {
                v4 = v6;
            }
            else if(v1 != v4.length) {
                byte[] v0_1 = new byte[v1];
                System.arraycopy(v4, 0, v0_1, 0, v1);
                v4 = v0_1;
            }
        }
        else {
            this.cipher.processBytes(arg8, arg9, arg10, v6, 0);
            v4 = v6;
        }

        return v4;
    }

    private boolean isAEADModeName(String arg2) {
        boolean v0 = ("CCM".equals(arg2)) || ("EAX".equals(arg2)) || ("GCM".equals(arg2)) || ("OCB".equals(arg2)) ? true : false;
        return v0;
    }
}

