// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.MacSpi;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Mac;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class BaseMac extends MacSpi implements PBE {
    private int keySize;
    private Mac macEngine;
    private int pbeHash;
    private int pbeType;

    public BaseMac(Mac arg2) {
        super();
        this.pbeType = 2;
        this.pbeHash = 1;
        this.keySize = 160;
        this.macEngine = arg2;
    }

    public BaseMac(Mac arg2, int arg3, int arg4, int arg5) {
        super();
        this.pbeType = 2;
        this.pbeHash = 1;
        this.keySize = 160;
        this.macEngine = arg2;
        this.pbeType = arg3;
        this.pbeHash = arg4;
        this.keySize = arg5;
    }

    protected byte[] engineDoFinal() {
        byte[] v0 = new byte[this.engineGetMacLength()];
        this.macEngine.doFinal(v0, 0);
        return v0;
    }

    protected int engineGetMacLength() {
        return this.macEngine.getMacSize();
    }

    protected void engineInit(Key arg4, AlgorithmParameterSpec arg5) {
        CipherParameters v0;
        if(arg4 == null) {
            throw new InvalidKeyException("key is null");
        }

        if((arg4 instanceof BCPBEKey)) {
            if(((BCPBEKey)arg4).getParam() != null) {
                v0 = ((BCPBEKey)arg4).getParam();
            }
            else if((arg5 instanceof PBEParameterSpec)) {
                v0 = PBE$Util.makePBEMacParameters(((BCPBEKey)arg4), arg5);
            }
            else {
                throw new InvalidAlgorithmParameterException("PBE requires PBE parameters to be set.");
            }
        }
        else if((arg5 instanceof IvParameterSpec)) {
            ParametersWithIV v0_1 = new ParametersWithIV(new KeyParameter(arg4.getEncoded()), ((IvParameterSpec)arg5).getIV());
        }
        else if(arg5 == null) {
            KeyParameter v0_2 = new KeyParameter(arg4.getEncoded());
        }
        else {
            goto label_35;
        }

        this.macEngine.init(v0);
        return;
    label_35:
        throw new InvalidAlgorithmParameterException("unknown parameter type.");
    }

    protected void engineReset() {
        this.macEngine.reset();
    }

    protected void engineUpdate(byte arg2) {
        this.macEngine.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.macEngine.update(arg2, arg3, arg4);
    }
}

