// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.security.InvalidKeyException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactorySpi;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;

public class BaseSecretKeyFactory extends SecretKeyFactorySpi implements PBE {
    public String algName;
    public ASN1ObjectIdentifier algOid;

    public BaseSecretKeyFactory(String arg1, ASN1ObjectIdentifier arg2) {
        super();
        this.algName = arg1;
        this.algOid = arg2;
    }

    public SecretKey engineGenerateSecret(KeySpec arg3) {
        if((arg3 instanceof SecretKeySpec)) {
            return arg3;
        }

        throw new InvalidKeySpecException("Invalid KeySpec");
    }

    public KeySpec engineGetKeySpec(SecretKey arg5, Class arg6) {
        SecretKeySpec v0;
        if(arg6 == null) {
            throw new InvalidKeySpecException("keySpec parameter is null");
        }

        if(arg5 == null) {
            throw new InvalidKeySpecException("key parameter is null");
        }

        if(SecretKeySpec.class.isAssignableFrom(arg6)) {
            v0 = new SecretKeySpec(arg5.getEncoded(), this.algName);
        }
        else {
            try {
                Object v0_2 = arg6.getConstructor(byte[].class).newInstance(arg5.getEncoded());
            }
            catch(Exception v0_1) {
                throw new InvalidKeySpecException(v0_1.toString());
            }
        }

        return ((KeySpec)v0);
    }

    protected SecretKey engineTranslateKey(SecretKey arg4) {
        if(arg4 == null) {
            throw new InvalidKeyException("key parameter is null");
        }

        if(!arg4.getAlgorithm().equalsIgnoreCase(this.algName)) {
            throw new InvalidKeyException("Key not of type " + this.algName + ".");
        }

        return new SecretKeySpec(arg4.getEncoded(), this.algName);
    }
}

