// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import javax.crypto.BadPaddingException;
import javax.crypto.CipherSpi;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.RC2ParameterSpec;
import javax.crypto.spec.RC5ParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.Wrapper;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public abstract class BaseWrapCipher extends CipherSpi implements PBE {
    private Class[] availableSpecs;
    protected AlgorithmParameters engineParams;
    private byte[] iv;
    private int ivSize;
    protected int pbeHash;
    protected int pbeIvSize;
    protected int pbeKeySize;
    protected int pbeType;
    protected Wrapper wrapEngine;

    protected BaseWrapCipher() {
        super();
        this.availableSpecs = new Class[]{IvParameterSpec.class, PBEParameterSpec.class, RC2ParameterSpec.class, RC5ParameterSpec.class};
        this.pbeType = 2;
        this.pbeHash = 1;
        this.engineParams = null;
        this.wrapEngine = null;
    }

    public BaseWrapCipher(Wrapper arg2) {
        this(arg2, 0);
    }

    public BaseWrapCipher(Wrapper arg7, int arg8) {
        super();
        this.availableSpecs = new Class[]{IvParameterSpec.class, PBEParameterSpec.class, RC2ParameterSpec.class, RC5ParameterSpec.class};
        this.pbeType = 2;
        this.pbeHash = 1;
        this.engineParams = null;
        this.wrapEngine = null;
        this.wrapEngine = arg7;
        this.ivSize = arg8;
    }

    protected int engineDoFinal(byte[] arg2, int arg3, int arg4, byte[] arg5, int arg6) {
        return 0;
    }

    protected byte[] engineDoFinal(byte[] arg2, int arg3, int arg4) {
        return null;
    }

    protected int engineGetBlockSize() {
        return 0;
    }

    protected byte[] engineGetIV() {
        return this.iv.clone();
    }

    protected int engineGetKeySize(Key arg2) {
        return arg2.getEncoded().length;
    }

    protected int engineGetOutputSize(int arg2) {
        return -1;
    }

    protected AlgorithmParameters engineGetParameters() {
        return null;
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameters arg6, SecureRandom arg7) {
        AlgorithmParameterSpec v0_1;
        AlgorithmParameterSpec v1 = null;
        if(arg6 != null) {
            int v0 = 0;
            while(true) {
                if(v0 != this.availableSpecs.length) {
                    try {
                        v0_1 = arg6.getParameterSpec(this.availableSpecs[v0]);
                        goto label_9;
                    }
                    catch(Exception v2) {
                        v0 = (((int)v0_1)) + 1;
                        continue;
                    }
                }
                else {
                    break;
                }

                goto label_9;
            }

            v0_1 = v1;
        label_9:
            if(v0_1 != null) {
                goto label_24;
            }

            throw new InvalidAlgorithmParameterException("can\'t handle parameter " + arg6.toString());
        }

        v0_1 = v1;
    label_24:
        this.engineParams = arg6;
        this.engineInit(arg4, arg5, v0_1, arg7);
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameterSpec arg6, SecureRandom arg7) {
        ParametersWithIV v0_2;
        CipherParameters v0;
        KeyParameter v0_1;
        if(!(arg5 instanceof BCPBEKey)) {
            v0_1 = new KeyParameter(arg5.getEncoded());
        }
        else if((arg6 instanceof PBEParameterSpec)) {
            v0 = PBE$Util.makePBEParameters(((BCPBEKey)arg5), arg6, this.wrapEngine.getAlgorithmName());
        }
        else if(((BCPBEKey)arg5).getParam() != null) {
            v0 = ((BCPBEKey)arg5).getParam();
        }
        else {
            throw new InvalidAlgorithmParameterException("PBE requires PBE parameters to be set.");
        }

        if((arg6 instanceof IvParameterSpec)) {
            v0_2 = new ParametersWithIV(((CipherParameters)v0_1), ((IvParameterSpec)arg6).getIV());
        }

        if((((((CipherParameters)v0_1)) instanceof KeyParameter)) && this.ivSize != 0) {
            this.iv = new byte[this.ivSize];
            arg7.nextBytes(this.iv);
            v0_2 = new ParametersWithIV(((CipherParameters)v0_1), this.iv);
        }

        switch(arg4) {
            case 1: 
            case 2: {
                goto label_51;
            }
            case 3: {
                goto label_43;
            }
            case 4: {
                goto label_47;
            }
        }

        System.out.println("eeek!");
        return;
    label_51:
        throw new IllegalArgumentException("engine only valid for wrapping");
    label_47:
        this.wrapEngine.init(false, ((CipherParameters)v0_1));
        return;
    label_43:
        this.wrapEngine.init(true, ((CipherParameters)v0_1));
    }

    protected void engineInit(int arg3, Key arg4, SecureRandom arg5) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.engineInit(arg3, arg4, v0, arg5);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new IllegalArgumentException(v0_1.getMessage());
        }
    }

    protected void engineSetMode(String arg4) {
        throw new NoSuchAlgorithmException("can\'t support mode " + arg4);
    }

    protected void engineSetPadding(String arg4) {
        throw new NoSuchPaddingException("Padding " + arg4 + " unknown.");
    }

    protected Key engineUnwrap(byte[] arg5, String arg6, int arg7) {
        PrivateKey v0_6;
        SecretKeySpec v0_4;
        byte[] v0_3;
        int v3 = 2;
        try {
            v0_3 = this.wrapEngine == null ? this.engineDoFinal(arg5, 0, arg5.length) : this.wrapEngine.unwrap(arg5, 0, arg5.length);
        }
        catch(IllegalBlockSizeException v0) {
            throw new InvalidKeyException(v0.getMessage());
        }
        catch(BadPaddingException v0_1) {
            throw new InvalidKeyException(v0_1.getMessage());
        }
        catch(InvalidCipherTextException v0_2) {
            throw new InvalidKeyException(v0_2.getMessage());
        }

        if(arg7 == 3) {
            v0_4 = new SecretKeySpec(v0_3, arg6);
        }
        else {
            if((arg6.equals("")) && arg7 == v3) {
                try {
                    PrivateKeyInfo v1 = PrivateKeyInfo.getInstance(v0_3);
                    v0_6 = BouncyCastleProvider.getPrivateKey(v1);
                    if(v0_6 == null) {
                        throw new InvalidKeyException("algorithm " + v1.getPrivateKeyAlgorithm().getAlgorithm() + " not supported");
                    }
                    else {
                        goto label_11;
                    }
                }
                catch(Exception v0_5) {
                    throw new InvalidKeyException("Invalid key encoding.");
                }
            }

            try {
                KeyFactory v1_1 = KeyFactory.getInstance(arg6, "BC");
                if(arg7 == 1) {
                    PublicKey v0_9 = v1_1.generatePublic(new X509EncodedKeySpec(v0_3));
                    goto label_11;
                }

                if(arg7 != v3) {
                    goto label_92;
                }

                v0_6 = v1_1.generatePrivate(new PKCS8EncodedKeySpec(v0_3));
            }
            catch(InvalidKeySpecException v0_7) {
                throw new InvalidKeyException("Unknown key type " + v0_7.getMessage());
            }
            catch(NoSuchProviderException v0_8) {
                throw new InvalidKeyException("Unknown key type " + v0_8.getMessage());
            }
        }

    label_11:
        return ((Key)v0_4);
    label_92:
        throw new InvalidKeyException("Unknown key type " + arg7);
    }

    protected int engineUpdate(byte[] arg3, int arg4, int arg5, byte[] arg6, int arg7) {
        throw new RuntimeException("not supported for wrapping");
    }

    protected byte[] engineUpdate(byte[] arg3, int arg4, int arg5) {
        throw new RuntimeException("not supported for wrapping");
    }

    protected byte[] engineWrap(Key arg5) {
        byte[] v0 = arg5.getEncoded();
        if(v0 == null) {
            throw new InvalidKeyException("Cannot wrap key, null encoding.");
        }

        try {
            return this.wrapEngine == null ? this.engineDoFinal(v0, 0, v0.length) : this.wrapEngine.wrap(v0, 0, v0.length);
        }
        catch(BadPaddingException v0_1) {
            throw new IllegalBlockSizeException(v0_1.getMessage());
        }
    }
}

