// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidParameterSpecException;
import javax.crypto.spec.IvParameterSpec;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.util.Arrays;

public class IvAlgorithmParameters extends BaseAlgorithmParameters {
    private byte[] iv;

    public IvAlgorithmParameters() {
        super();
    }

    protected byte[] engineGetEncoded() {
        return this.engineGetEncoded("ASN.1");
    }

    protected byte[] engineGetEncoded(String arg3) {
        byte[] v0;
        if(this.isASN1FormatString(arg3)) {
            v0 = new DEROctetString(this.engineGetEncoded("RAW")).getEncoded();
        }
        else if(arg3.equals("RAW")) {
            v0 = Arrays.clone(this.iv);
        }
        else {
            v0 = null;
        }

        return v0;
    }

    protected void engineInit(AlgorithmParameterSpec arg3) {
        if(!(arg3 instanceof IvParameterSpec)) {
            throw new InvalidParameterSpecException("IvParameterSpec required to initialise a IV parameters algorithm parameters object");
        }

        this.iv = ((IvParameterSpec)arg3).getIV();
    }

    protected void engineInit(byte[] arg3) {
        if(arg3.length % 8 != 0 && arg3[0] == 4 && arg3[1] == arg3.length - 2) {
            arg3 = ASN1Primitive.fromByteArray(arg3).getOctets();
        }

        this.iv = Arrays.clone(arg3);
    }

    protected void engineInit(byte[] arg5, String arg6) {
        if(this.isASN1FormatString(arg6)) {
            try {
                this.engineInit(ASN1Primitive.fromByteArray(arg5).getOctets());
            }
            catch(Exception v0) {
                throw new IOException("Exception decoding: " + v0);
            }
        }
        else if(arg6.equals("RAW")) {
            this.engineInit(arg5);
        }
        else {
            goto label_21;
        }

        return;
    label_21:
        throw new IOException("Unknown parameters format in IV parameters object");
    }

    public String engineToString() {
        return "IV Parameters";
    }

    protected AlgorithmParameterSpec localEngineGetParameterSpec(Class arg3) {
        if(arg3 == IvParameterSpec.class) {
            return new IvParameterSpec(this.iv);
        }

        throw new InvalidParameterSpecException("unknown parameter spec passed to IV parameters object.");
    }
}

