// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.digests.GOST3411Digest;
import org.bouncycastle.crypto.digests.MD2Digest;
import org.bouncycastle.crypto.digests.MD5Digest;
import org.bouncycastle.crypto.digests.RIPEMD160Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.digests.SHA256Digest;
import org.bouncycastle.crypto.digests.TigerDigest;
import org.bouncycastle.crypto.generators.OpenSSLPBEParametersGenerator;
import org.bouncycastle.crypto.generators.PKCS12ParametersGenerator;
import org.bouncycastle.crypto.generators.PKCS5S1ParametersGenerator;
import org.bouncycastle.crypto.generators.PKCS5S2ParametersGenerator;
import org.bouncycastle.crypto.params.DESParameters;
import org.bouncycastle.crypto.params.ParametersWithIV;

public class PBE$Util {
    public PBE$Util() {
        super();
    }

    private static byte[] convertPassword(int arg1, PBEKeySpec arg2) {
        byte[] v0;
        if(arg1 == 2) {
            v0 = PBEParametersGenerator.PKCS12PasswordToBytes(arg2.getPassword());
        }
        else {
            if(arg1 != 5 && arg1 != 4) {
                return PBEParametersGenerator.PKCS5PasswordToBytes(arg2.getPassword());
            }

            v0 = PBEParametersGenerator.PKCS5PasswordToUTF8Bytes(arg2.getPassword());
        }

        return v0;
    }

    private static PBEParametersGenerator makePBEGenerator(int arg2, int arg3) {
        OpenSSLPBEParametersGenerator v0_1;
        if(arg2 == 0 || arg2 == 4) {
            switch(arg3) {
                case 0: {
                    goto label_13;
                }
                case 1: {
                    goto label_18;
                }
                case 5: {
                    goto label_8;
                }
            }

            throw new IllegalStateException("PKCS5 scheme 1 only supports MD2, MD5 and SHA1.");
        label_18:
            PKCS5S1ParametersGenerator v0_3 = new PKCS5S1ParametersGenerator(new SHA1Digest());
            goto label_12;
        label_8:
            v0_3 = new PKCS5S1ParametersGenerator(new MD2Digest());
            goto label_12;
        label_13:
            v0_3 = new PKCS5S1ParametersGenerator(new MD5Digest());
        }
        else {
            if(arg2 != 1 && arg2 != 5) {
                if(arg2 == 2) {
                    switch(arg3) {
                        case 0: {
                            goto label_42;
                        }
                        case 1: {
                            goto label_47;
                        }
                        case 2: {
                            goto label_52;
                        }
                        case 3: {
                            goto label_57;
                        }
                        case 4: {
                            goto label_62;
                        }
                        case 5: {
                            goto label_37;
                        }
                        case 6: {
                            goto label_67;
                        }
                    }

                    throw new IllegalStateException("unknown digest scheme for PBE encryption.");
                label_37:
                    PKCS12ParametersGenerator v0 = new PKCS12ParametersGenerator(new MD2Digest());
                    goto label_12;
                label_67:
                    v0 = new PKCS12ParametersGenerator(new GOST3411Digest());
                    goto label_12;
                label_52:
                    v0 = new PKCS12ParametersGenerator(new RIPEMD160Digest());
                    goto label_12;
                label_62:
                    v0 = new PKCS12ParametersGenerator(new SHA256Digest());
                    goto label_12;
                label_47:
                    v0 = new PKCS12ParametersGenerator(new SHA1Digest());
                    goto label_12;
                label_57:
                    v0 = new PKCS12ParametersGenerator(new TigerDigest());
                    goto label_12;
                label_42:
                    v0 = new PKCS12ParametersGenerator(new MD5Digest());
                }
                else {
                    v0_1 = new OpenSSLPBEParametersGenerator();
                }

                goto label_12;
            }

            PKCS5S2ParametersGenerator v0_2 = new PKCS5S2ParametersGenerator();
        }

    label_12:
        return ((PBEParametersGenerator)v0_1);
    }

    public static CipherParameters makePBEMacParameters(BCPBEKey arg5, AlgorithmParameterSpec arg6) {
        if(arg6 != null && ((arg6 instanceof PBEParameterSpec))) {
            PBEParametersGenerator v1 = PBE$Util.makePBEGenerator(arg5.getType(), arg5.getDigest());
            byte[] v0 = arg5.getEncoded();
            if(arg5.shouldTryWrongPKCS12()) {
                v0 = new byte[2];
            }

            v1.init(v0, ((PBEParameterSpec)arg6).getSalt(), ((PBEParameterSpec)arg6).getIterationCount());
            CipherParameters v3 = v1.generateDerivedMacParameters(arg5.getKeySize());
            int v1_1;
            for(v1_1 = 0; v1_1 != v0.length; ++v1_1) {
                v0[v1_1] = 0;
            }

            return v3;
        }

        throw new IllegalArgumentException("Need a PBEParameter spec with a PBE key.");
    }

    public static CipherParameters makePBEMacParameters(PBEKeySpec arg5, int arg6, int arg7, int arg8) {
        PBEParametersGenerator v0 = PBE$Util.makePBEGenerator(arg6, arg7);
        byte[] v2 = PBE$Util.convertPassword(arg6, arg5);
        v0.init(v2, arg5.getSalt(), arg5.getIterationCount());
        CipherParameters v3 = v0.generateDerivedMacParameters(arg8);
        int v0_1;
        for(v0_1 = 0; v0_1 != v2.length; ++v0_1) {
            v2[v0_1] = 0;
        }

        return v3;
    }

    public static CipherParameters makePBEParameters(PBEKeySpec arg5, int arg6, int arg7, int arg8, int arg9) {
        PBEParametersGenerator v0 = PBE$Util.makePBEGenerator(arg6, arg7);
        byte[] v3 = PBE$Util.convertPassword(arg6, arg5);
        v0.init(v3, arg5.getSalt(), arg5.getIterationCount());
        CipherParameters v0_1 = arg9 != 0 ? v0.generateDerivedParameters(arg8, arg9) : v0.generateDerivedParameters(arg8);
        int v1;
        for(v1 = 0; v1 != v3.length; ++v1) {
            v3[v1] = 0;
        }

        return v0_1;
    }

    public static CipherParameters makePBEParameters(BCPBEKey arg5, AlgorithmParameterSpec arg6, String arg7) {
        if(arg6 != null && ((arg6 instanceof PBEParameterSpec))) {
            PBEParametersGenerator v1 = PBE$Util.makePBEGenerator(arg5.getType(), arg5.getDigest());
            byte[] v0 = arg5.getEncoded();
            byte[] v2 = arg5.shouldTryWrongPKCS12() ? new byte[2] : v0;
            v1.init(v2, ((PBEParameterSpec)arg6).getSalt(), ((PBEParameterSpec)arg6).getIterationCount());
            CipherParameters v1_1 = arg5.getIvSize() != 0 ? v1.generateDerivedParameters(arg5.getKeySize(), arg5.getIvSize()) : v1.generateDerivedParameters(arg5.getKeySize());
            if(arg7.startsWith("DES")) {
                if((v1_1 instanceof ParametersWithIV)) {
                    DESParameters.setOddParity(v1_1.getParameters().getKey());
                }
                else {
                    DESParameters.setOddParity(v1_1.getKey());
                }
            }

            int v0_1;
            for(v0_1 = 0; v0_1 != v2.length; ++v0_1) {
                v2[v0_1] = 0;
            }

            return v1_1;
        }

        throw new IllegalArgumentException("Need a PBEParameter spec with a PBE key.");
    }
}

