// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.symmetric.util;

import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import javax.crypto.SecretKey;
import javax.crypto.spec.PBEKeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.crypto.CipherParameters;

public class PBESecretKeyFactory extends BaseSecretKeyFactory implements PBE {
    private int digest;
    private boolean forCipher;
    private int ivSize;
    private int keySize;
    private int scheme;

    public PBESecretKeyFactory(String arg1, ASN1ObjectIdentifier arg2, boolean arg3, int arg4, int arg5, int arg6, int arg7) {
        super(arg1, arg2);
        this.forCipher = arg3;
        this.scheme = arg4;
        this.digest = arg5;
        this.keySize = arg6;
        this.ivSize = arg7;
    }

    protected SecretKey engineGenerateSecret(KeySpec arg10) {
        BCPBEKey v0;
        if((arg10 instanceof PBEKeySpec)) {
            KeySpec v7 = arg10;
            if(((PBEKeySpec)v7).getSalt() == null) {
                v0 = new BCPBEKey(this.algName, this.algOid, this.scheme, this.digest, this.keySize, this.ivSize, ((PBEKeySpec)v7), null);
            }
            else {
                CipherParameters v8 = this.forCipher ? PBE$Util.makePBEParameters(((PBEKeySpec)v7), this.scheme, this.digest, this.keySize, this.ivSize) : PBE$Util.makePBEMacParameters(((PBEKeySpec)v7), this.scheme, this.digest, this.keySize);
                v0 = new BCPBEKey(this.algName, this.algOid, this.scheme, this.digest, this.keySize, this.ivSize, ((PBEKeySpec)v7), v8);
            }

            return ((SecretKey)v0);
        }

        throw new InvalidKeySpecException("Invalid KeySpec");
    }
}

