// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jcajce.provider.util;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.nist.NISTObjectIdentifiers;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.MD5Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.digests.SHA224Digest;
import org.bouncycastle.crypto.digests.SHA256Digest;
import org.bouncycastle.crypto.digests.SHA384Digest;
import org.bouncycastle.crypto.digests.SHA512Digest;
import org.bouncycastle.util.Strings;

public class DigestFactory {
    private static Set md5;
    private static Map oids;
    private static Set sha1;
    private static Set sha224;
    private static Set sha256;
    private static Set sha384;
    private static Set sha512;

    static {
        DigestFactory.md5 = new HashSet();
        DigestFactory.sha1 = new HashSet();
        DigestFactory.sha224 = new HashSet();
        DigestFactory.sha256 = new HashSet();
        DigestFactory.sha384 = new HashSet();
        DigestFactory.sha512 = new HashSet();
        DigestFactory.oids = new HashMap();
        DigestFactory.md5.add("MD5");
        DigestFactory.md5.add(PKCSObjectIdentifiers.md5.getId());
        DigestFactory.sha1.add("SHA1");
        DigestFactory.sha1.add("SHA-1");
        DigestFactory.sha1.add(OIWObjectIdentifiers.idSHA1.getId());
        DigestFactory.sha224.add("SHA224");
        DigestFactory.sha224.add("SHA-224");
        DigestFactory.sha224.add(NISTObjectIdentifiers.id_sha224.getId());
        DigestFactory.sha256.add("SHA256");
        DigestFactory.sha256.add("SHA-256");
        DigestFactory.sha256.add(NISTObjectIdentifiers.id_sha256.getId());
        DigestFactory.sha384.add("SHA384");
        DigestFactory.sha384.add("SHA-384");
        DigestFactory.sha384.add(NISTObjectIdentifiers.id_sha384.getId());
        DigestFactory.sha512.add("SHA512");
        DigestFactory.sha512.add("SHA-512");
        DigestFactory.sha512.add(NISTObjectIdentifiers.id_sha512.getId());
        DigestFactory.oids.put("MD5", PKCSObjectIdentifiers.md5);
        DigestFactory.oids.put(PKCSObjectIdentifiers.md5.getId(), PKCSObjectIdentifiers.md5);
        DigestFactory.oids.put("SHA1", OIWObjectIdentifiers.idSHA1);
        DigestFactory.oids.put("SHA-1", OIWObjectIdentifiers.idSHA1);
        DigestFactory.oids.put(OIWObjectIdentifiers.idSHA1.getId(), OIWObjectIdentifiers.idSHA1);
        DigestFactory.oids.put("SHA224", NISTObjectIdentifiers.id_sha224);
        DigestFactory.oids.put("SHA-224", NISTObjectIdentifiers.id_sha224);
        DigestFactory.oids.put(NISTObjectIdentifiers.id_sha224.getId(), NISTObjectIdentifiers.id_sha224);
        DigestFactory.oids.put("SHA256", NISTObjectIdentifiers.id_sha256);
        DigestFactory.oids.put("SHA-256", NISTObjectIdentifiers.id_sha256);
        DigestFactory.oids.put(NISTObjectIdentifiers.id_sha256.getId(), NISTObjectIdentifiers.id_sha256);
        DigestFactory.oids.put("SHA384", NISTObjectIdentifiers.id_sha384);
        DigestFactory.oids.put("SHA-384", NISTObjectIdentifiers.id_sha384);
        DigestFactory.oids.put(NISTObjectIdentifiers.id_sha384.getId(), NISTObjectIdentifiers.id_sha384);
        DigestFactory.oids.put("SHA512", NISTObjectIdentifiers.id_sha512);
        DigestFactory.oids.put("SHA-512", NISTObjectIdentifiers.id_sha512);
        DigestFactory.oids.put(NISTObjectIdentifiers.id_sha512.getId(), NISTObjectIdentifiers.id_sha512);
    }

    public DigestFactory() {
        super();
    }

    public static Digest getDigest(String arg2) {
        SHA1Digest v0_1;
        String v0 = Strings.toUpperCase(arg2);
        if(DigestFactory.sha1.contains(v0)) {
            v0_1 = new SHA1Digest();
        }
        else if(DigestFactory.md5.contains(v0)) {
            MD5Digest v0_2 = new MD5Digest();
        }
        else if(DigestFactory.sha224.contains(v0)) {
            SHA224Digest v0_3 = new SHA224Digest();
        }
        else if(DigestFactory.sha256.contains(v0)) {
            SHA256Digest v0_4 = new SHA256Digest();
        }
        else if(DigestFactory.sha384.contains(v0)) {
            SHA384Digest v0_5 = new SHA384Digest();
        }
        else if(DigestFactory.sha512.contains(v0)) {
            SHA512Digest v0_6 = new SHA512Digest();
        }
        else {
            Digest v0_7 = null;
        }

        return ((Digest)v0_1);
    }

    public static ASN1ObjectIdentifier getOID(String arg1) {
        return DigestFactory.oids.get(arg1);
    }

    public static boolean isSameDigest(String arg1, String arg2) {
        boolean v0;
        if(!DigestFactory.sha1.contains(arg1) || !DigestFactory.sha1.contains(arg2)) {
            if((DigestFactory.sha224.contains(arg1)) && (DigestFactory.sha224.contains(arg2))) {
                goto label_36;
            }

            if((DigestFactory.sha256.contains(arg1)) && (DigestFactory.sha256.contains(arg2))) {
                goto label_36;
            }

            if((DigestFactory.sha384.contains(arg1)) && (DigestFactory.sha384.contains(arg2))) {
                goto label_36;
            }

            if((DigestFactory.sha512.contains(arg1)) && (DigestFactory.sha512.contains(arg2))) {
                goto label_36;
            }

            if((DigestFactory.md5.contains(arg1)) && (DigestFactory.md5.contains(arg2))) {
            label_36:
                v0 = true;
                return v0;
            }

            v0 = false;
        }
        else {
            goto label_36;
        }

        return v0;
    }
}

