// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce;

import java.io.UnsupportedEncodingException;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.Provider;
import java.security.PublicKey;
import java.security.Security;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x9.X962Parameters;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.jcajce.provider.asymmetric.util.ECUtil;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class ECKeyUtil {
    public ECKeyUtil() {
        super();
    }

    public static PrivateKey privateToExplicitParameters(PrivateKey arg3, String arg4) {
        Provider v0 = Security.getProvider(arg4);
        if(v0 == null) {
            throw new NoSuchProviderException("cannot find provider: " + arg4);
        }

        return ECKeyUtil.privateToExplicitParameters(arg3, v0);
    }

    public static PrivateKey privateToExplicitParameters(PrivateKey arg6, Provider arg7) {
        X9ECParameters v0_4;
        try {
            PrivateKeyInfo v1 = PrivateKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg6.getEncoded()));
            if(v1.getAlgorithmId().getObjectId().equals(CryptoProObjectIdentifiers.gostR3410_2001)) {
                throw new UnsupportedEncodingException("cannot convert GOST key to explicit parameters.");
            }

            X962Parameters v0_3 = X962Parameters.getInstance(v1.getAlgorithmId().getParameters());
            if(v0_3.isNamedCurve()) {
                X9ECParameters v2 = ECUtil.getNamedCurveByOid(ASN1ObjectIdentifier.getInstance(v0_3.getParameters()));
                v0_4 = new X9ECParameters(v2.getCurve(), v2.getG(), v2.getN(), v2.getH());
                goto label_28;
            }
            else if(v0_3.isImplicitlyCA()) {
                v0_4 = new X9ECParameters(BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getCurve(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getG(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getN(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getH());
            label_28:
                arg6 = KeyFactory.getInstance(arg6.getAlgorithm(), arg7).generatePrivate(new PKCS8EncodedKeySpec(new PrivateKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, new X962Parameters(v0_4)), v1.parsePrivateKey()).getEncoded()));
            }

            return arg6;
        }
        catch(Exception v0) {
            throw new ECKeyUtil$UnexpectedException(((Throwable)v0));
        }
        catch(NoSuchAlgorithmException v0_1) {
            throw v0_1;
        }
        catch(IllegalArgumentException v0_2) {
            throw v0_2;
        }
    }

    public static PublicKey publicToExplicitParameters(PublicKey arg3, String arg4) {
        Provider v0 = Security.getProvider(arg4);
        if(v0 == null) {
            throw new NoSuchProviderException("cannot find provider: " + arg4);
        }

        return ECKeyUtil.publicToExplicitParameters(arg3, v0);
    }

    public static PublicKey publicToExplicitParameters(PublicKey arg6, Provider arg7) {
        X9ECParameters v0_4;
        try {
            SubjectPublicKeyInfo v1 = SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(arg6.getEncoded()));
            if(v1.getAlgorithmId().getObjectId().equals(CryptoProObjectIdentifiers.gostR3410_2001)) {
                throw new IllegalArgumentException("cannot convert GOST key to explicit parameters.");
            }

            X962Parameters v0_3 = X962Parameters.getInstance(v1.getAlgorithmId().getParameters());
            if(v0_3.isNamedCurve()) {
                X9ECParameters v2 = ECUtil.getNamedCurveByOid(ASN1ObjectIdentifier.getInstance(v0_3.getParameters()));
                v0_4 = new X9ECParameters(v2.getCurve(), v2.getG(), v2.getN(), v2.getH());
                goto label_28;
            }
            else if(v0_3.isImplicitlyCA()) {
                v0_4 = new X9ECParameters(BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getCurve(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getG(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getN(), BouncyCastleProvider.CONFIGURATION.getEcImplicitlyCa().getH());
            label_28:
                arg6 = KeyFactory.getInstance(arg6.getAlgorithm(), arg7).generatePublic(new X509EncodedKeySpec(new SubjectPublicKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_ecPublicKey, new X962Parameters(v0_4)), v1.getPublicKeyData().getBytes()).getEncoded()));
            }

            return arg6;
        }
        catch(Exception v0) {
            throw new ECKeyUtil$UnexpectedException(((Throwable)v0));
        }
        catch(NoSuchAlgorithmException v0_1) {
            throw v0_1;
        }
        catch(IllegalArgumentException v0_2) {
            throw v0_2;
        }
    }
}

