// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce;

import java.io.IOException;
import java.security.AlgorithmParameters;
import java.security.GeneralSecurityException;
import java.security.InvalidKeyException;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.SignatureException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PSSParameterSpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.nist.NISTObjectIdentifiers;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.CertificationRequest;
import org.bouncycastle.asn1.pkcs.CertificationRequestInfo;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.RSASSAPSSparams;
import org.bouncycastle.asn1.teletrust.TeleTrusTObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509Name;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.util.Strings;

public class PKCS10CertificationRequest extends CertificationRequest {
    private static Hashtable algorithms;
    private static Hashtable keyAlgorithms;
    private static Set noParams;
    private static Hashtable oids;
    private static Hashtable params;

    static {
        PKCS10CertificationRequest.algorithms = new Hashtable();
        PKCS10CertificationRequest.params = new Hashtable();
        PKCS10CertificationRequest.keyAlgorithms = new Hashtable();
        PKCS10CertificationRequest.oids = new Hashtable();
        PKCS10CertificationRequest.noParams = new HashSet();
        PKCS10CertificationRequest.algorithms.put("MD2WITHRSAENCRYPTION", new DERObjectIdentifier("1.2.840.113549.1.1.2"));
        PKCS10CertificationRequest.algorithms.put("MD2WITHRSA", new DERObjectIdentifier("1.2.840.113549.1.1.2"));
        PKCS10CertificationRequest.algorithms.put("MD5WITHRSAENCRYPTION", new DERObjectIdentifier("1.2.840.113549.1.1.4"));
        PKCS10CertificationRequest.algorithms.put("MD5WITHRSA", new DERObjectIdentifier("1.2.840.113549.1.1.4"));
        PKCS10CertificationRequest.algorithms.put("RSAWITHMD5", new DERObjectIdentifier("1.2.840.113549.1.1.4"));
        PKCS10CertificationRequest.algorithms.put("SHA1WITHRSAENCRYPTION", new DERObjectIdentifier("1.2.840.113549.1.1.5"));
        PKCS10CertificationRequest.algorithms.put("SHA1WITHRSA", new DERObjectIdentifier("1.2.840.113549.1.1.5"));
        PKCS10CertificationRequest.algorithms.put("SHA224WITHRSAENCRYPTION", PKCSObjectIdentifiers.sha224WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA224WITHRSA", PKCSObjectIdentifiers.sha224WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA256WITHRSAENCRYPTION", PKCSObjectIdentifiers.sha256WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA256WITHRSA", PKCSObjectIdentifiers.sha256WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA384WITHRSAENCRYPTION", PKCSObjectIdentifiers.sha384WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA384WITHRSA", PKCSObjectIdentifiers.sha384WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA512WITHRSAENCRYPTION", PKCSObjectIdentifiers.sha512WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA512WITHRSA", PKCSObjectIdentifiers.sha512WithRSAEncryption);
        PKCS10CertificationRequest.algorithms.put("SHA1WITHRSAANDMGF1", PKCSObjectIdentifiers.id_RSASSA_PSS);
        PKCS10CertificationRequest.algorithms.put("SHA224WITHRSAANDMGF1", PKCSObjectIdentifiers.id_RSASSA_PSS);
        PKCS10CertificationRequest.algorithms.put("SHA256WITHRSAANDMGF1", PKCSObjectIdentifiers.id_RSASSA_PSS);
        PKCS10CertificationRequest.algorithms.put("SHA384WITHRSAANDMGF1", PKCSObjectIdentifiers.id_RSASSA_PSS);
        PKCS10CertificationRequest.algorithms.put("SHA512WITHRSAANDMGF1", PKCSObjectIdentifiers.id_RSASSA_PSS);
        PKCS10CertificationRequest.algorithms.put("RSAWITHSHA1", new DERObjectIdentifier("1.2.840.113549.1.1.5"));
        PKCS10CertificationRequest.algorithms.put("RIPEMD128WITHRSAENCRYPTION", TeleTrusTObjectIdentifiers.rsaSignatureWithripemd128);
        PKCS10CertificationRequest.algorithms.put("RIPEMD128WITHRSA", TeleTrusTObjectIdentifiers.rsaSignatureWithripemd128);
        PKCS10CertificationRequest.algorithms.put("RIPEMD160WITHRSAENCRYPTION", TeleTrusTObjectIdentifiers.rsaSignatureWithripemd160);
        PKCS10CertificationRequest.algorithms.put("RIPEMD160WITHRSA", TeleTrusTObjectIdentifiers.rsaSignatureWithripemd160);
        PKCS10CertificationRequest.algorithms.put("RIPEMD256WITHRSAENCRYPTION", TeleTrusTObjectIdentifiers.rsaSignatureWithripemd256);
        PKCS10CertificationRequest.algorithms.put("RIPEMD256WITHRSA", TeleTrusTObjectIdentifiers.rsaSignatureWithripemd256);
        PKCS10CertificationRequest.algorithms.put("SHA1WITHDSA", new DERObjectIdentifier("1.2.840.10040.4.3"));
        PKCS10CertificationRequest.algorithms.put("DSAWITHSHA1", new DERObjectIdentifier("1.2.840.10040.4.3"));
        PKCS10CertificationRequest.algorithms.put("SHA224WITHDSA", NISTObjectIdentifiers.dsa_with_sha224);
        PKCS10CertificationRequest.algorithms.put("SHA256WITHDSA", NISTObjectIdentifiers.dsa_with_sha256);
        PKCS10CertificationRequest.algorithms.put("SHA384WITHDSA", NISTObjectIdentifiers.dsa_with_sha384);
        PKCS10CertificationRequest.algorithms.put("SHA512WITHDSA", NISTObjectIdentifiers.dsa_with_sha512);
        PKCS10CertificationRequest.algorithms.put("SHA1WITHECDSA", X9ObjectIdentifiers.ecdsa_with_SHA1);
        PKCS10CertificationRequest.algorithms.put("SHA224WITHECDSA", X9ObjectIdentifiers.ecdsa_with_SHA224);
        PKCS10CertificationRequest.algorithms.put("SHA256WITHECDSA", X9ObjectIdentifiers.ecdsa_with_SHA256);
        PKCS10CertificationRequest.algorithms.put("SHA384WITHECDSA", X9ObjectIdentifiers.ecdsa_with_SHA384);
        PKCS10CertificationRequest.algorithms.put("SHA512WITHECDSA", X9ObjectIdentifiers.ecdsa_with_SHA512);
        PKCS10CertificationRequest.algorithms.put("ECDSAWITHSHA1", X9ObjectIdentifiers.ecdsa_with_SHA1);
        PKCS10CertificationRequest.algorithms.put("GOST3411WITHGOST3410", CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_94);
        PKCS10CertificationRequest.algorithms.put("GOST3410WITHGOST3411", CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_94);
        PKCS10CertificationRequest.algorithms.put("GOST3411WITHECGOST3410", CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_2001);
        PKCS10CertificationRequest.algorithms.put("GOST3411WITHECGOST3410-2001", CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_2001);
        PKCS10CertificationRequest.algorithms.put("GOST3411WITHGOST3410-2001", CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_2001);
        PKCS10CertificationRequest.oids.put(new DERObjectIdentifier("1.2.840.113549.1.1.5"), "SHA1WITHRSA");
        PKCS10CertificationRequest.oids.put(PKCSObjectIdentifiers.sha224WithRSAEncryption, "SHA224WITHRSA");
        PKCS10CertificationRequest.oids.put(PKCSObjectIdentifiers.sha256WithRSAEncryption, "SHA256WITHRSA");
        PKCS10CertificationRequest.oids.put(PKCSObjectIdentifiers.sha384WithRSAEncryption, "SHA384WITHRSA");
        PKCS10CertificationRequest.oids.put(PKCSObjectIdentifiers.sha512WithRSAEncryption, "SHA512WITHRSA");
        PKCS10CertificationRequest.oids.put(CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_94, "GOST3411WITHGOST3410");
        PKCS10CertificationRequest.oids.put(CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_2001, "GOST3411WITHECGOST3410");
        PKCS10CertificationRequest.oids.put(new DERObjectIdentifier("1.2.840.113549.1.1.4"), "MD5WITHRSA");
        PKCS10CertificationRequest.oids.put(new DERObjectIdentifier("1.2.840.113549.1.1.2"), "MD2WITHRSA");
        PKCS10CertificationRequest.oids.put(new DERObjectIdentifier("1.2.840.10040.4.3"), "SHA1WITHDSA");
        PKCS10CertificationRequest.oids.put(X9ObjectIdentifiers.ecdsa_with_SHA1, "SHA1WITHECDSA");
        PKCS10CertificationRequest.oids.put(X9ObjectIdentifiers.ecdsa_with_SHA224, "SHA224WITHECDSA");
        PKCS10CertificationRequest.oids.put(X9ObjectIdentifiers.ecdsa_with_SHA256, "SHA256WITHECDSA");
        PKCS10CertificationRequest.oids.put(X9ObjectIdentifiers.ecdsa_with_SHA384, "SHA384WITHECDSA");
        PKCS10CertificationRequest.oids.put(X9ObjectIdentifiers.ecdsa_with_SHA512, "SHA512WITHECDSA");
        PKCS10CertificationRequest.oids.put(OIWObjectIdentifiers.sha1WithRSA, "SHA1WITHRSA");
        PKCS10CertificationRequest.oids.put(OIWObjectIdentifiers.dsaWithSHA1, "SHA1WITHDSA");
        PKCS10CertificationRequest.oids.put(NISTObjectIdentifiers.dsa_with_sha224, "SHA224WITHDSA");
        PKCS10CertificationRequest.oids.put(NISTObjectIdentifiers.dsa_with_sha256, "SHA256WITHDSA");
        PKCS10CertificationRequest.keyAlgorithms.put(PKCSObjectIdentifiers.rsaEncryption, "RSA");
        PKCS10CertificationRequest.keyAlgorithms.put(X9ObjectIdentifiers.id_dsa, "DSA");
        PKCS10CertificationRequest.noParams.add(X9ObjectIdentifiers.ecdsa_with_SHA1);
        PKCS10CertificationRequest.noParams.add(X9ObjectIdentifiers.ecdsa_with_SHA224);
        PKCS10CertificationRequest.noParams.add(X9ObjectIdentifiers.ecdsa_with_SHA256);
        PKCS10CertificationRequest.noParams.add(X9ObjectIdentifiers.ecdsa_with_SHA384);
        PKCS10CertificationRequest.noParams.add(X9ObjectIdentifiers.ecdsa_with_SHA512);
        PKCS10CertificationRequest.noParams.add(X9ObjectIdentifiers.id_dsa_with_sha1);
        PKCS10CertificationRequest.noParams.add(NISTObjectIdentifiers.dsa_with_sha224);
        PKCS10CertificationRequest.noParams.add(NISTObjectIdentifiers.dsa_with_sha256);
        PKCS10CertificationRequest.noParams.add(CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_94);
        PKCS10CertificationRequest.noParams.add(CryptoProObjectIdentifiers.gostR3411_94_with_gostR3410_2001);
        PKCS10CertificationRequest.params.put("SHA1WITHRSAANDMGF1", PKCS10CertificationRequest.creatPSSParams(new AlgorithmIdentifier(OIWObjectIdentifiers.idSHA1, DERNull.INSTANCE), 20));
        PKCS10CertificationRequest.params.put("SHA224WITHRSAANDMGF1", PKCS10CertificationRequest.creatPSSParams(new AlgorithmIdentifier(NISTObjectIdentifiers.id_sha224, DERNull.INSTANCE), 28));
        PKCS10CertificationRequest.params.put("SHA256WITHRSAANDMGF1", PKCS10CertificationRequest.creatPSSParams(new AlgorithmIdentifier(NISTObjectIdentifiers.id_sha256, DERNull.INSTANCE), 32));
        PKCS10CertificationRequest.params.put("SHA384WITHRSAANDMGF1", PKCS10CertificationRequest.creatPSSParams(new AlgorithmIdentifier(NISTObjectIdentifiers.id_sha384, DERNull.INSTANCE), 48));
        PKCS10CertificationRequest.params.put("SHA512WITHRSAANDMGF1", PKCS10CertificationRequest.creatPSSParams(new AlgorithmIdentifier(NISTObjectIdentifiers.id_sha512, DERNull.INSTANCE), 64));
    }

    public PKCS10CertificationRequest(String arg8, X500Principal arg9, PublicKey arg10, ASN1Set arg11, PrivateKey arg12) {
        this(arg8, PKCS10CertificationRequest.convertName(arg9), arg10, arg11, arg12, "BC");
    }

    public PKCS10CertificationRequest(String arg5, X509Name arg6, PublicKey arg7, ASN1Set arg8, PrivateKey arg9, String arg10) {
        Object v1_1;
        super();
        String v2 = Strings.toUpperCase(arg5);
        Object v0 = PKCS10CertificationRequest.algorithms.get(v2);
        if(v0 == null) {
            try {
                DERObjectIdentifier v1 = new DERObjectIdentifier(v2);
            }
            catch(Exception v0_1) {
                throw new IllegalArgumentException("Unknown signature type requested");
            }
        }
        else {
            v1_1 = v0;
        }

        if(arg6 == null) {
            throw new IllegalArgumentException("subject must not be null");
        }

        if(arg7 == null) {
            throw new IllegalArgumentException("public key must not be null");
        }

        if(PKCS10CertificationRequest.noParams.contains(v1_1)) {
            this.sigAlgId = new AlgorithmIdentifier(((DERObjectIdentifier)v1_1));
        }
        else if(PKCS10CertificationRequest.params.containsKey(v2)) {
            this.sigAlgId = new AlgorithmIdentifier(((DERObjectIdentifier)v1_1), PKCS10CertificationRequest.params.get(v2));
        }
        else {
            this.sigAlgId = new AlgorithmIdentifier(((DERObjectIdentifier)v1_1), DERNull.INSTANCE);
        }

        try {
            this.reqInfo = new CertificationRequestInfo(arg6, new SubjectPublicKeyInfo(ASN1Primitive.fromByteArray(arg7.getEncoded())), arg8);
            if(arg10 != null) {
                goto label_67;
            }
        }
        catch(IOException v0_2) {
            throw new IllegalArgumentException("can\'t encode public key");
        }

        Signature v0_3 = Signature.getInstance(arg5);
        goto label_38;
    label_67:
        v0_3 = Signature.getInstance(arg5, arg10);
    label_38:
        v0_3.initSign(arg9);
        try {
            v0_3.update(this.reqInfo.getEncoded("DER"));
        }
        catch(Exception v0_1) {
            throw new IllegalArgumentException("exception encoding TBS cert request - " + v0_1);
        }

        this.sigBits = new DERBitString(v0_3.sign());
    }

    public PKCS10CertificationRequest(String arg8, X500Principal arg9, PublicKey arg10, ASN1Set arg11, PrivateKey arg12, String arg13) {
        this(arg8, PKCS10CertificationRequest.convertName(arg9), arg10, arg11, arg12, arg13);
    }

    public PKCS10CertificationRequest(String arg8, X509Name arg9, PublicKey arg10, ASN1Set arg11, PrivateKey arg12) {
        this(arg8, arg9, arg10, arg11, arg12, "BC");
    }

    public PKCS10CertificationRequest(ASN1Sequence arg1) {
        super(arg1);
    }

    public PKCS10CertificationRequest(byte[] arg2) {
        super(PKCS10CertificationRequest.toDERSequence(arg2));
    }

    private static X509Name convertName(X500Principal arg2) {
        try {
            return new X509Principal(arg2.getEncoded());
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("can\'t convert name");
        }
    }

    private static RSASSAPSSparams creatPSSParams(AlgorithmIdentifier arg6, int arg7) {
        return new RSASSAPSSparams(arg6, new AlgorithmIdentifier(PKCSObjectIdentifiers.id_mgf1, ((ASN1Encodable)arg6)), new ASN1Integer(((long)arg7)), new ASN1Integer(1));
    }

    private static String getDigestAlgName(DERObjectIdentifier arg1) {
        String v0;
        if(PKCSObjectIdentifiers.md5.equals(arg1)) {
            v0 = "MD5";
        }
        else if(OIWObjectIdentifiers.idSHA1.equals(arg1)) {
            v0 = "SHA1";
        }
        else if(NISTObjectIdentifiers.id_sha224.equals(arg1)) {
            v0 = "SHA224";
        }
        else if(NISTObjectIdentifiers.id_sha256.equals(arg1)) {
            v0 = "SHA256";
        }
        else if(NISTObjectIdentifiers.id_sha384.equals(arg1)) {
            v0 = "SHA384";
        }
        else if(NISTObjectIdentifiers.id_sha512.equals(arg1)) {
            v0 = "SHA512";
        }
        else if(TeleTrusTObjectIdentifiers.ripemd128.equals(arg1)) {
            v0 = "RIPEMD128";
        }
        else if(TeleTrusTObjectIdentifiers.ripemd160.equals(arg1)) {
            v0 = "RIPEMD160";
        }
        else if(TeleTrusTObjectIdentifiers.ripemd256.equals(arg1)) {
            v0 = "RIPEMD256";
        }
        else if(CryptoProObjectIdentifiers.gostR3411.equals(arg1)) {
            v0 = "GOST3411";
        }
        else {
            v0 = arg1.getId();
        }

        return v0;
    }

    public byte[] getEncoded() {
        try {
            return this.getEncoded("DER");
        }
        catch(IOException v0) {
            throw new RuntimeException(v0.toString());
        }
    }

    public PublicKey getPublicKey() {
        return this.getPublicKey("BC");
    }

    public PublicKey getPublicKey(String arg6) {
        PublicKey v0_4;
        AlgorithmIdentifier v2;
        X509EncodedKeySpec v1;
        SubjectPublicKeyInfo v0 = this.reqInfo.getSubjectPublicKeyInfo();
        try {
            v1 = new X509EncodedKeySpec(new DERBitString(((ASN1Encodable)v0)).getBytes());
            v2 = v0.getAlgorithm();
            if(arg6 != null) {
                goto label_14;
            }

            try {
                v0_4 = KeyFactory.getInstance(v2.getAlgorithm().getId()).generatePublic(((KeySpec)v1));
                return v0_4;
            label_14:
                return KeyFactory.getInstance(v2.getAlgorithm().getId(), arg6).generatePublic(((KeySpec)v1));
            }
            catch(NoSuchAlgorithmException v0_3) {
            }
        }
        catch(InvalidKeySpecException v0_1) {
        label_39:
            throw new InvalidKeyException("error decoding public key");
        }
        catch(IOException v0_2) {
        label_44:
            throw new InvalidKeyException("error decoding public key");
        }

        try {
            if(PKCS10CertificationRequest.keyAlgorithms.get(v2.getObjectId()) != null) {
                Hashtable v0_5 = PKCS10CertificationRequest.keyAlgorithms;
                ASN1ObjectIdentifier v2_1 = v2.getObjectId();
                Object v0_6 = v0_5.get(v2_1);
                if(arg6 == null) {
                    return KeyFactory.getInstance(((String)v0_6)).generatePublic(((KeySpec)v1));
                }

                return KeyFactory.getInstance(((String)v0_6), arg6).generatePublic(((KeySpec)v1));
            }

            throw v0_3;
        }
        catch(InvalidKeySpecException v0_1) {
            goto label_39;
        }
        catch(IOException v0_2) {
            goto label_44;
        }

        return v0_4;
    }

    static String getSignatureName(AlgorithmIdentifier arg3) {
        ASN1Encodable v0 = arg3.getParameters();
        String v0_1 = v0 == null || (DERNull.INSTANCE.equals(v0)) || !arg3.getObjectId().equals(PKCSObjectIdentifiers.id_RSASSA_PSS) ? arg3.getObjectId().getId() : PKCS10CertificationRequest.getDigestAlgName(RSASSAPSSparams.getInstance(v0).getHashAlgorithm().getObjectId()) + "withRSAandMGF1";
        return v0_1;
    }

    private void setSignatureParameters(Signature arg5, ASN1Encodable arg6) {
        if(arg6 != null && !DERNull.INSTANCE.equals(arg6)) {
            AlgorithmParameters v0 = AlgorithmParameters.getInstance(arg5.getAlgorithm(), arg5.getProvider());
            try {
                v0.init(arg6.toASN1Primitive().getEncoded("DER"));
            }
            catch(IOException v0_1) {
                throw new SignatureException("IOException decoding parameters: " + v0_1.getMessage());
            }

            if(arg5.getAlgorithm().endsWith("MGF1")) {
                try {
                    arg5.setParameter(v0.getParameterSpec(PSSParameterSpec.class));
                }
                catch(GeneralSecurityException v0_2) {
                    throw new SignatureException("Exception extracting parameters: " + v0_2.getMessage());
                }
            }
        }
    }

    private static ASN1Sequence toDERSequence(byte[] arg2) {
        try {
            return new ASN1InputStream(arg2).readObject();
        }
        catch(Exception v0) {
            throw new IllegalArgumentException("badly encoded request");
        }
    }

    public boolean verify() {
        return this.verify("BC");
    }

    public boolean verify(String arg2) {
        return this.verify(this.getPublicKey(arg2), arg2);
    }

    public boolean verify(PublicKey arg5, String arg6) {
        Signature v0_1;
        if(arg6 != null) {
            goto label_16;
        }

        try {
            v0_1 = Signature.getInstance(PKCS10CertificationRequest.getSignatureName(this.sigAlgId));
            goto label_4;
        label_16:
            v0_1 = Signature.getInstance(PKCS10CertificationRequest.getSignatureName(this.sigAlgId), arg6);
        }
        catch(NoSuchAlgorithmException v0) {
            if(PKCS10CertificationRequest.oids.get(this.sigAlgId.getObjectId()) != null) {
                Object v0_2 = PKCS10CertificationRequest.oids.get(this.sigAlgId.getObjectId());
                if(arg6 == null) {
                    v0_1 = Signature.getInstance(((String)v0_2));
                    goto label_4;
                }

                v0_1 = Signature.getInstance(((String)v0_2), arg6);
                goto label_4;
            }

            throw v0;
        }

    label_4:
        this.setSignatureParameters(v0_1, this.sigAlgId.getParameters());
        v0_1.initVerify(arg5);
        try {
            v0_1.update(this.reqInfo.getEncoded("DER"));
        }
        catch(Exception v0_3) {
            throw new SignatureException("exception encoding TBS cert request - " + v0_3);
        }

        return v0_1.verify(this.sigBits.getBytes());
    }
}

