// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.netscape;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.security.KeyFactory;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Signature;
import java.security.SignatureException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.X509EncodedKeySpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;

public class NetscapeCertRequest extends ASN1Object {
    String challenge;
    DERBitString content;
    AlgorithmIdentifier keyAlg;
    PublicKey pubkey;
    AlgorithmIdentifier sigAlg;
    byte[] sigBits;

    public NetscapeCertRequest(String arg5, AlgorithmIdentifier arg6, PublicKey arg7) {
        super();
        this.challenge = arg5;
        this.sigAlg = arg6;
        this.pubkey = arg7;
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.getKeySpec());
        v0.add(new DERIA5String(arg5));
        try {
            this.content = new DERBitString(new DERSequence(v0));
            return;
        }
        catch(IOException v0_1) {
            throw new InvalidKeySpecException("exception encoding key: " + v0_1.toString());
        }
    }

    public NetscapeCertRequest(ASN1Sequence arg5) {
        int v2 = 2;
        super();
        try {
            if(arg5.size() != 3) {
                throw new IllegalArgumentException("invalid SPKAC (size):" + arg5.size());
            }

            this.sigAlg = new AlgorithmIdentifier(arg5.getObjectAt(1));
            this.sigBits = arg5.getObjectAt(2).getBytes();
            ASN1Encodable v0_1 = arg5.getObjectAt(0);
            if(((ASN1Sequence)v0_1).size() != v2) {
                throw new IllegalArgumentException("invalid PKAC (len): " + ((ASN1Sequence)v0_1).size());
            }

            this.challenge = ((ASN1Sequence)v0_1).getObjectAt(1).getString();
            this.content = new DERBitString(v0_1);
            SubjectPublicKeyInfo v1 = new SubjectPublicKeyInfo(((ASN1Sequence)v0_1).getObjectAt(0));
            X509EncodedKeySpec v0_2 = new X509EncodedKeySpec(new DERBitString(((ASN1Encodable)v1)).getBytes());
            this.keyAlg = v1.getAlgorithmId();
            this.pubkey = KeyFactory.getInstance(this.keyAlg.getObjectId().getId(), "BC").generatePublic(((KeySpec)v0_2));
            return;
        }
        catch(Exception v0) {
            throw new IllegalArgumentException(v0.toString());
        }
    }

    public NetscapeCertRequest(byte[] arg2) {
        this(NetscapeCertRequest.getReq(arg2));
    }

    public String getChallenge() {
        return this.challenge;
    }

    public AlgorithmIdentifier getKeyAlgorithm() {
        return this.keyAlg;
    }

    private ASN1Primitive getKeySpec() {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        try {
            v0.write(this.pubkey.getEncoded());
            v0.close();
            return new ASN1InputStream(new ByteArrayInputStream(v0.toByteArray())).readObject();
        }
        catch(IOException v0_1) {
            throw new InvalidKeySpecException(v0_1.getMessage());
        }
    }

    public PublicKey getPublicKey() {
        return this.pubkey;
    }

    private static ASN1Sequence getReq(byte[] arg2) {
        return ASN1Sequence.getInstance(new ASN1InputStream(new ByteArrayInputStream(arg2)).readObject());
    }

    public AlgorithmIdentifier getSigningAlgorithm() {
        return this.sigAlg;
    }

    public void setChallenge(String arg1) {
        this.challenge = arg1;
    }

    public void setKeyAlgorithm(AlgorithmIdentifier arg1) {
        this.keyAlg = arg1;
    }

    public void setPublicKey(PublicKey arg1) {
        this.pubkey = arg1;
    }

    public void setSigningAlgorithm(AlgorithmIdentifier arg1) {
        this.sigAlg = arg1;
    }

    public void sign(PrivateKey arg2) {
        this.sign(arg2, null);
    }

    public void sign(PrivateKey arg5, SecureRandom arg6) {
        Signature v0 = Signature.getInstance(this.sigAlg.getAlgorithm().getId(), "BC");
        if(arg6 != null) {
            v0.initSign(arg5, arg6);
        }
        else {
            v0.initSign(arg5);
        }

        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(this.getKeySpec());
        v1.add(new DERIA5String(this.challenge));
        try {
            v0.update(new DERSequence(v1).getEncoded("DER"));
        }
        catch(IOException v0_1) {
            throw new SignatureException(v0_1.getMessage());
        }

        this.sigBits = v0.sign();
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        try {
            v1.add(this.getKeySpec());
        }
        catch(Exception v2) {
        }

        v1.add(new DERIA5String(this.challenge));
        v0.add(new DERSequence(v1));
        v0.add(this.sigAlg);
        v0.add(new DERBitString(this.sigBits));
        return new DERSequence(v0);
    }

    public boolean verify(String arg3) {
        boolean v0;
        if(!arg3.equals(this.challenge)) {
            v0 = false;
        }
        else {
            Signature v0_1 = Signature.getInstance(this.sigAlg.getObjectId().getId(), "BC");
            v0_1.initVerify(this.pubkey);
            v0_1.update(this.content.getBytes());
            v0 = v0_1.verify(this.sigBits);
        }

        return v0;
    }
}

