// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.AccessController;
import java.security.PrivateKey;
import java.security.Provider;
import java.security.PublicKey;
import java.util.HashMap;
import java.util.Map;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.config.ConfigurableProvider;
import org.bouncycastle.jcajce.provider.config.ProviderConfiguration;
import org.bouncycastle.jcajce.provider.util.AsymmetricKeyInfoConverter;

public final class BouncyCastleProvider extends Provider implements ConfigurableProvider {
    private static final String[] ASYMMETRIC_CIPHERS = null;
    private static final String[] ASYMMETRIC_GENERIC = null;
    private static final String ASYMMETRIC_PACKAGE = "org.bouncycastle.jcajce.provider.asymmetric.";
    public static final ProviderConfiguration CONFIGURATION = null;
    private static final String[] DIGESTS = null;
    private static final String DIGEST_PACKAGE = "org.bouncycastle.jcajce.provider.digest.";
    private static final String[] KEYSTORES = null;
    private static final String KEYSTORE_PACKAGE = "org.bouncycastle.jcajce.provider.keystore.";
    public static final String PROVIDER_NAME = "BC";
    private static final String[] SYMMETRIC_CIPHERS = null;
    private static final String[] SYMMETRIC_GENERIC = null;
    private static final String[] SYMMETRIC_MACS = null;
    private static final String SYMMETRIC_PACKAGE = "org.bouncycastle.jcajce.provider.symmetric.";
    private static String info;
    private static final Map keyInfoConverters;

    static {
        BouncyCastleProvider.info = "BouncyCastle Security Provider v1.49";
        BouncyCastleProvider.CONFIGURATION = new BouncyCastleProviderConfiguration();
        BouncyCastleProvider.keyInfoConverters = new HashMap();
        BouncyCastleProvider.SYMMETRIC_GENERIC = new String[]{"PBEPBKDF2", "PBEPKCS12"};
        BouncyCastleProvider.SYMMETRIC_MACS = new String[]{"SipHash"};
        BouncyCastleProvider.SYMMETRIC_CIPHERS = new String[]{"AES", "ARC4", "Blowfish", "Camellia", "CAST5", "CAST6", "DES", "DESede", "GOST28147", "Grainv1", "Grain128", "HC128", "HC256", "IDEA", "Noekeon", "RC2", "RC5", "RC6", "Rijndael", "Salsa20", "SEED", "Serpent", "Skipjack", "TEA", "Twofish", "VMPC", "VMPCKSA3", "XTEA"};
        BouncyCastleProvider.ASYMMETRIC_GENERIC = new String[]{"X509", "IES"};
        BouncyCastleProvider.ASYMMETRIC_CIPHERS = new String[]{"DSA", "DH", "EC", "RSA", "GOST", "ECGOST", "ElGamal", "DSTU4145"};
        BouncyCastleProvider.DIGESTS = new String[]{"GOST3411", "MD2", "MD4", "MD5", "SHA1", "RIPEMD128", "RIPEMD160", "RIPEMD256", "RIPEMD320", "SHA224", "SHA256", "SHA384", "SHA512", "SHA3", "Tiger", "Whirlpool"};
        BouncyCastleProvider.KEYSTORES = new String[]{"BC", "PKCS12"};
    }

    public BouncyCastleProvider() {
        super("BC", 1.49, BouncyCastleProvider.info);
        AccessController.doPrivileged(new BouncyCastleProvider$1(this));
    }

    static void access$000(BouncyCastleProvider arg0) {
        arg0.setup();
    }

    public void addAlgorithm(String arg4, String arg5) {
        if(this.containsKey(arg4)) {
            throw new IllegalStateException("duplicate provider key (" + arg4 + ") found");
        }

        this.put(arg4, arg5);
    }

    public void addKeyInfoConverter(ASN1ObjectIdentifier arg2, AsymmetricKeyInfoConverter arg3) {
        BouncyCastleProvider.keyInfoConverters.put(arg2, arg3);
    }

    public static PrivateKey getPrivateKey(PrivateKeyInfo arg2) {
        Object v0 = BouncyCastleProvider.keyInfoConverters.get(arg2.getPrivateKeyAlgorithm().getAlgorithm());
        PrivateKey v0_1 = v0 == null ? null : ((AsymmetricKeyInfoConverter)v0).generatePrivate(arg2);
        return v0_1;
    }

    public static PublicKey getPublicKey(SubjectPublicKeyInfo arg2) {
        Object v0 = BouncyCastleProvider.keyInfoConverters.get(arg2.getAlgorithm().getAlgorithm());
        PublicKey v0_1 = v0 == null ? null : ((AsymmetricKeyInfoConverter)v0).generatePublic(arg2);
        return v0_1;
    }

    public boolean hasAlgorithm(String arg3, String arg4) {
        boolean v0 = (this.containsKey(arg3 + "." + arg4)) || (this.containsKey("Alg.Alias." + arg3 + "." + arg4)) ? true : false;
        return v0;
    }

    private void loadAlgorithms(String arg6, String[] arg7) {
        int v1;
        for(v1 = 0; v1 != arg7.length; ++v1) {
            Class v0 = null;
            try {
                ClassLoader v2_1 = this.getClass().getClassLoader();
                if(v2_1 != null) {
                    v0 = v2_1.loadClass(arg6 + arg7[v1] + "$Mappings");
                    goto label_17;
                }

                v0 = Class.forName(arg6 + arg7[v1] + "$Mappings");
            }
            catch(ClassNotFoundException v2) {
            }

        label_17:
            if(v0 != null) {
                try {
                    v0.newInstance().configure(((ConfigurableProvider)this));
                }
                catch(Exception v0_1) {
                    throw new InternalError("cannot create instance of " + arg6 + arg7[v1] + "$Mappings : " + v0_1);
                }
            }
        }
    }

    public void setParameter(String arg3, Object arg4) {
        ProviderConfiguration v1 = BouncyCastleProvider.CONFIGURATION;
        __monitor_enter(v1);
        try {
            BouncyCastleProvider.CONFIGURATION.setParameter(arg3, arg4);
            __monitor_exit(v1);
            return;
        label_7:
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            goto label_7;
        }

        throw v0;
    }

    private void setup() {
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.digest.", BouncyCastleProvider.DIGESTS);
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.symmetric.", BouncyCastleProvider.SYMMETRIC_GENERIC);
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.symmetric.", BouncyCastleProvider.SYMMETRIC_MACS);
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.symmetric.", BouncyCastleProvider.SYMMETRIC_CIPHERS);
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.asymmetric.", BouncyCastleProvider.ASYMMETRIC_GENERIC);
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.asymmetric.", BouncyCastleProvider.ASYMMETRIC_CIPHERS);
        this.loadAlgorithms("org.bouncycastle.jcajce.provider.keystore.", BouncyCastleProvider.KEYSTORES);
        this.put("X509Store.CERTIFICATE/COLLECTION", "org.bouncycastle.jce.provider.X509StoreCertCollection");
        this.put("X509Store.ATTRIBUTECERTIFICATE/COLLECTION", "org.bouncycastle.jce.provider.X509StoreAttrCertCollection");
        this.put("X509Store.CRL/COLLECTION", "org.bouncycastle.jce.provider.X509StoreCRLCollection");
        this.put("X509Store.CERTIFICATEPAIR/COLLECTION", "org.bouncycastle.jce.provider.X509StoreCertPairCollection");
        this.put("X509Store.CERTIFICATE/LDAP", "org.bouncycastle.jce.provider.X509StoreLDAPCerts");
        this.put("X509Store.CRL/LDAP", "org.bouncycastle.jce.provider.X509StoreLDAPCRLs");
        this.put("X509Store.ATTRIBUTECERTIFICATE/LDAP", "org.bouncycastle.jce.provider.X509StoreLDAPAttrCerts");
        this.put("X509Store.CERTIFICATEPAIR/LDAP", "org.bouncycastle.jce.provider.X509StoreLDAPCertPairs");
        this.put("X509StreamParser.CERTIFICATE", "org.bouncycastle.jce.provider.X509CertParser");
        this.put("X509StreamParser.ATTRIBUTECERTIFICATE", "org.bouncycastle.jce.provider.X509AttrCertParser");
        this.put("X509StreamParser.CRL", "org.bouncycastle.jce.provider.X509CRLParser");
        this.put("X509StreamParser.CERTIFICATEPAIR", "org.bouncycastle.jce.provider.X509CertPairParser");
        this.put("Cipher.BROKENPBEWITHMD5ANDDES", "org.bouncycastle.jce.provider.BrokenJCEBlockCipher$BrokePBEWithMD5AndDES");
        this.put("Cipher.BROKENPBEWITHSHA1ANDDES", "org.bouncycastle.jce.provider.BrokenJCEBlockCipher$BrokePBEWithSHA1AndDES");
        this.put("Cipher.OLDPBEWITHSHAANDTWOFISH-CBC", "org.bouncycastle.jce.provider.BrokenJCEBlockCipher$OldPBEWithSHAAndTwofish");
        this.put("CertPathValidator.RFC3281", "org.bouncycastle.jce.provider.PKIXAttrCertPathValidatorSpi");
        this.put("CertPathBuilder.RFC3281", "org.bouncycastle.jce.provider.PKIXAttrCertPathBuilderSpi");
        this.put("CertPathValidator.RFC3280", "org.bouncycastle.jce.provider.PKIXCertPathValidatorSpi");
        this.put("CertPathBuilder.RFC3280", "org.bouncycastle.jce.provider.PKIXCertPathBuilderSpi");
        this.put("CertPathValidator.PKIX", "org.bouncycastle.jce.provider.PKIXCertPathValidatorSpi");
        this.put("CertPathBuilder.PKIX", "org.bouncycastle.jce.provider.PKIXCertPathBuilderSpi");
        this.put("CertStore.Collection", "org.bouncycastle.jce.provider.CertStoreCollectionSpi");
        this.put("CertStore.LDAP", "org.bouncycastle.jce.provider.X509LDAPCertStoreSpi");
        this.put("CertStore.Multi", "org.bouncycastle.jce.provider.MultiCertStoreSpi");
        this.put("Alg.Alias.CertStore.X509LDAP", "LDAP");
    }
}

