// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.Permission;
import javax.crypto.spec.DHParameterSpec;
import org.bouncycastle.jcajce.provider.asymmetric.util.EC5Util;
import org.bouncycastle.jcajce.provider.config.ProviderConfiguration;
import org.bouncycastle.jcajce.provider.config.ProviderConfigurationPermission;
import org.bouncycastle.jce.spec.ECParameterSpec;

class BouncyCastleProviderConfiguration implements ProviderConfiguration {
    private static Permission BC_DH_LOCAL_PERMISSION;
    private static Permission BC_DH_PERMISSION;
    private static Permission BC_EC_LOCAL_PERMISSION;
    private static Permission BC_EC_PERMISSION;
    private volatile Object dhDefaultParams;
    private ThreadLocal dhThreadSpec;
    private volatile ECParameterSpec ecImplicitCaParams;
    private ThreadLocal ecThreadSpec;

    static {
        BouncyCastleProviderConfiguration.BC_EC_LOCAL_PERMISSION = new ProviderConfigurationPermission("BC", "threadLocalEcImplicitlyCa");
        BouncyCastleProviderConfiguration.BC_EC_PERMISSION = new ProviderConfigurationPermission("BC", "ecImplicitlyCa");
        BouncyCastleProviderConfiguration.BC_DH_LOCAL_PERMISSION = new ProviderConfigurationPermission("BC", "threadLocalDhDefaultParams");
        BouncyCastleProviderConfiguration.BC_DH_PERMISSION = new ProviderConfigurationPermission("BC", "DhDefaultParams");
    }

    BouncyCastleProviderConfiguration() {
        super();
        this.ecThreadSpec = new ThreadLocal();
        this.dhThreadSpec = new ThreadLocal();
    }

    public DHParameterSpec getDHDefaultParameters(int arg4) {
        DHParameterSpec v0_1;
        Object v0 = this.dhThreadSpec.get();
        if(v0 == null) {
            v0 = this.dhDefaultParams;
        }

        if((v0 instanceof DHParameterSpec)) {
            if(((DHParameterSpec)v0).getP().bitLength() != arg4) {
                goto label_23;
            }
        }
        else if((v0 instanceof DHParameterSpec[])) {
            int v1 = 0;
            while(true) {
                if(v1 == v0.length) {
                    goto label_23;
                }
                else if(v0[v1].getP().bitLength() == arg4) {
                    v0_1 = v0[v1];
                }
                else {
                    ++v1;
                    continue;
                }

                return v0_1;
            }
        }
        else {
        label_23:
            v0_1 = null;
        }

        return v0_1;
    }

    public ECParameterSpec getEcImplicitlyCa() {
        ECParameterSpec v0_1;
        Object v0 = this.ecThreadSpec.get();
        if(v0 == null) {
            v0_1 = this.ecImplicitCaParams;
        }

        return v0_1;
    }

    void setParameter(String arg4, Object arg5) {
        ECParameterSpec v5;
        SecurityManager v0 = System.getSecurityManager();
        if(arg4.equals("threadLocalEcImplicitlyCa")) {
            if(v0 != null) {
                v0.checkPermission(BouncyCastleProviderConfiguration.BC_EC_LOCAL_PERMISSION);
            }

            if(!(arg5 instanceof ECParameterSpec) && arg5 != null) {
                v5 = EC5Util.convertSpec(((java.security.spec.ECParameterSpec)arg5), false);
            }

            if(v5 == null) {
                this.ecThreadSpec.remove();
                return;
            }

            this.ecThreadSpec.set(v5);
        }
        else {
            if(arg4.equals("ecImplicitlyCa")) {
                if(v0 != null) {
                    v0.checkPermission(BouncyCastleProviderConfiguration.BC_EC_PERMISSION);
                }

                if(!(arg5 instanceof ECParameterSpec) && arg5 != null) {
                    this.ecImplicitCaParams = EC5Util.convertSpec(((java.security.spec.ECParameterSpec)arg5), false);
                    return;
                }

                this.ecImplicitCaParams = ((ECParameterSpec)arg5);
                return;
            }

            if(arg4.equals("threadLocalDhDefaultParams")) {
                if(v0 != null) {
                    v0.checkPermission(BouncyCastleProviderConfiguration.BC_DH_LOCAL_PERMISSION);
                }

                if(!(arg5 instanceof DHParameterSpec) && !(arg5 instanceof DHParameterSpec[]) && arg5 != null) {
                    throw new IllegalArgumentException("not a valid DHParameterSpec");
                }

                if(arg5 == null) {
                    this.dhThreadSpec.remove();
                    return;
                }

                this.dhThreadSpec.set(arg5);
                return;
            }

            if(!arg4.equals("DhDefaultParams")) {
                return;
            }

            if(v0 != null) {
                v0.checkPermission(BouncyCastleProviderConfiguration.BC_DH_PERMISSION);
            }

            if(!(arg5 instanceof DHParameterSpec) && !(arg5 instanceof DHParameterSpec[]) && arg5 != null) {
                throw new IllegalArgumentException("not a valid DHParameterSpec or DHParameterSpec[]");
            }

            this.dhDefaultParams = arg5;
        }
    }
}

