// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.RC2ParameterSpec;
import javax.crypto.spec.RC5ParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.BufferedBlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.modes.CBCBlockCipher;
import org.bouncycastle.crypto.modes.CFBBlockCipher;
import org.bouncycastle.crypto.modes.CTSBlockCipher;
import org.bouncycastle.crypto.modes.OFBBlockCipher;
import org.bouncycastle.crypto.paddings.PaddedBufferedBlockCipher;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.crypto.params.RC2Parameters;
import org.bouncycastle.crypto.params.RC5Parameters;
import org.bouncycastle.jcajce.provider.symmetric.util.BCPBEKey;
import org.bouncycastle.util.Strings;

public class BrokenJCEBlockCipher implements BrokenPBE {
    private Class[] availableSpecs;
    private BufferedBlockCipher cipher;
    private AlgorithmParameters engineParams;
    private int ivLength;
    private ParametersWithIV ivParam;
    private int pbeHash;
    private int pbeIvSize;
    private int pbeKeySize;
    private int pbeType;

    protected BrokenJCEBlockCipher(BlockCipher arg7) {
        super();
        this.availableSpecs = new Class[]{IvParameterSpec.class, PBEParameterSpec.class, RC2ParameterSpec.class, RC5ParameterSpec.class};
        this.pbeType = 2;
        this.pbeHash = 1;
        this.ivLength = 0;
        this.engineParams = null;
        this.cipher = new PaddedBufferedBlockCipher(arg7);
    }

    protected BrokenJCEBlockCipher(BlockCipher arg7, int arg8, int arg9, int arg10, int arg11) {
        super();
        this.availableSpecs = new Class[]{IvParameterSpec.class, PBEParameterSpec.class, RC2ParameterSpec.class, RC5ParameterSpec.class};
        this.pbeType = 2;
        this.pbeHash = 1;
        this.ivLength = 0;
        this.engineParams = null;
        this.cipher = new PaddedBufferedBlockCipher(arg7);
        this.pbeType = arg8;
        this.pbeHash = arg9;
        this.pbeKeySize = arg10;
        this.pbeIvSize = arg11;
    }

    protected int engineDoFinal(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        int v0 = 0;
        if(arg9 != 0) {
            v0 = this.cipher.processBytes(arg7, arg8, arg9, arg10, arg11);
        }

        try {
            return v0 + this.cipher.doFinal(arg10, arg11 + v0);
        }
        catch(InvalidCipherTextException v0_1) {
            throw new BadPaddingException(v0_1.getMessage());
        }
        catch(DataLengthException v0_2) {
            throw new IllegalBlockSizeException(v0_2.getMessage());
        }
    }

    protected byte[] engineDoFinal(byte[] arg7, int arg8, int arg9) {
        int v1;
        byte[] v4 = new byte[this.engineGetOutputSize(arg9)];
        int v0 = arg9 != 0 ? this.cipher.processBytes(arg7, arg8, arg9, v4, 0) : 0;
        try {
            v1 = this.cipher.doFinal(v4, v0);
        }
        catch(InvalidCipherTextException v0_1) {
            throw new BadPaddingException(v0_1.getMessage());
        }
        catch(DataLengthException v0_2) {
            throw new IllegalBlockSizeException(v0_2.getMessage());
        }

        v0 += v1;
        byte[] v1_1 = new byte[v0];
        System.arraycopy(v4, 0, v1_1, 0, v0);
        return v1_1;
    }

    protected int engineGetBlockSize() {
        return this.cipher.getBlockSize();
    }

    protected byte[] engineGetIV() {
        byte[] v0 = this.ivParam != null ? this.ivParam.getIV() : null;
        return v0;
    }

    protected int engineGetKeySize(Key arg2) {
        return arg2.getEncoded().length;
    }

    protected int engineGetOutputSize(int arg2) {
        return this.cipher.getOutputSize(arg2);
    }

    protected AlgorithmParameters engineGetParameters() {
        int v2 = 47;
        if(this.engineParams == null && this.ivParam != null) {
            String v0 = this.cipher.getUnderlyingCipher().getAlgorithmName();
            if(v0.indexOf(v2) >= 0) {
                v0 = v0.substring(0, v0.indexOf(v2));
            }

            try {
                this.engineParams = AlgorithmParameters.getInstance(v0, "BC");
                this.engineParams.init(this.ivParam.getIV());
            }
            catch(Exception v0_1) {
                throw new RuntimeException(v0_1.toString());
            }
        }

        return this.engineParams;
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameters arg6, SecureRandom arg7) {
        AlgorithmParameterSpec v0_1;
        AlgorithmParameterSpec v1 = null;
        if(arg6 != null) {
            int v0 = 0;
            while(true) {
                if(v0 != this.availableSpecs.length) {
                    try {
                        v0_1 = arg6.getParameterSpec(this.availableSpecs[((int)v0_1)]);
                        goto label_9;
                    }
                    catch(Exception v2) {
                        v0 = (((int)v0_1)) + 1;
                        continue;
                    }
                }
                else {
                    break;
                }

                goto label_9;
            }

            v0_1 = v1;
        label_9:
            if(v0_1 != null) {
                goto label_24;
            }

            throw new InvalidAlgorithmParameterException("can\'t handle parameter " + arg6.toString());
        }

        v0_1 = v1;
    label_24:
        this.engineParams = arg6;
        this.engineInit(arg4, arg5, v0_1, arg7);
    }

    protected void engineInit(int arg9, Key arg10, AlgorithmParameterSpec arg11, SecureRandom arg12) {
        RC5Parameters v1_3;
        RC2Parameters v1_2;
        AlgorithmParameterSpec v0_3;
        ParametersWithIV v0_2;
        ParametersWithIV v1_1;
        KeyParameter v0_1;
        CipherParameters v0;
        if((arg10 instanceof BCPBEKey)) {
            CipherParameters v1 = BrokenPBE$Util.makePBEParameters(arg10, arg11, this.pbeType, this.pbeHash, this.cipher.getUnderlyingCipher().getAlgorithmName(), this.pbeKeySize, this.pbeIvSize);
            if(this.pbeIvSize != 0) {
                this.ivParam = v1;
                v0 = v1;
            }
            else {
                v0 = v1;
            }
        }
        else if(arg11 == null) {
            v0_1 = new KeyParameter(arg10.getEncoded());
        }
        else if((arg11 instanceof IvParameterSpec)) {
            if(this.ivLength != 0) {
                v1_1 = new ParametersWithIV(new KeyParameter(arg10.getEncoded()), ((IvParameterSpec)arg11).getIV());
                this.ivParam = v1_1;
                v0_2 = v1_1;
            }
            else {
                v0_1 = new KeyParameter(arg10.getEncoded());
            }
        }
        else if((arg11 instanceof RC2ParameterSpec)) {
            v0_3 = arg11;
            RC2Parameters v2 = new RC2Parameters(arg10.getEncoded(), ((RC2ParameterSpec)arg11).getEffectiveKeyBits());
            if(((RC2ParameterSpec)v0_3).getIV() == null || this.ivLength == 0) {
                v1_2 = v2;
            }
            else {
                v1_1 = new ParametersWithIV(((CipherParameters)v2), ((RC2ParameterSpec)v0_3).getIV());
                this.ivParam = v1_1;
            }

            v0_2 = ((ParametersWithIV)v1_2);
        }
        else {
            if(!(arg11 instanceof RC5ParameterSpec)) {
                goto label_109;
            }

            v0_3 = arg11;
            RC5Parameters v2_1 = new RC5Parameters(arg10.getEncoded(), ((RC5ParameterSpec)arg11).getRounds());
            if(((RC5ParameterSpec)v0_3).getWordSize() != 32) {
                throw new IllegalArgumentException("can only accept RC5 word size 32 (at the moment...)");
            }

            if(((RC5ParameterSpec)v0_3).getIV() == null || this.ivLength == 0) {
                v1_3 = v2_1;
            }
            else {
                v1_1 = new ParametersWithIV(((CipherParameters)v2_1), ((RC5ParameterSpec)v0_3).getIV());
                this.ivParam = v1_1;
            }

            v0_2 = ((ParametersWithIV)v1_3);
        }

        if(this.ivLength != 0 && !((((CipherParameters)v0_1)) instanceof ParametersWithIV)) {
            if(arg12 == null) {
                arg12 = new SecureRandom();
            }

            if(arg9 != 1 && arg9 != 3) {
                throw new InvalidAlgorithmParameterException("no IV set when one expected");
            }

            byte[] v2_2 = new byte[this.ivLength];
            arg12.nextBytes(v2_2);
            v1_1 = new ParametersWithIV(((CipherParameters)v0_1), v2_2);
            this.ivParam = v1_1;
            v0_2 = v1_1;
        }

        switch(arg9) {
            case 1: 
            case 3: {
                this.cipher.init(true, ((CipherParameters)v0_1));
                break;
            }
            case 2: 
            case 4: {
                this.cipher.init(false, ((CipherParameters)v0_1));
                break;
            }
            default: {
                System.out.println("eeek!");
                break;
            }
        }

        return;
    label_109:
        throw new InvalidAlgorithmParameterException("unknown parameter type.");
    }

    protected void engineInit(int arg3, Key arg4, SecureRandom arg5) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.engineInit(arg3, arg4, v0, arg5);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new IllegalArgumentException(v0_1.getMessage());
        }
    }

    protected void engineSetMode(String arg5) {
        int v2 = 3;
        String v0 = Strings.toUpperCase(arg5);
        if(v0.equals("ECB")) {
            this.ivLength = 0;
            this.cipher = new PaddedBufferedBlockCipher(this.cipher.getUnderlyingCipher());
        }
        else if(v0.equals("CBC")) {
            this.ivLength = this.cipher.getUnderlyingCipher().getBlockSize();
            this.cipher = new PaddedBufferedBlockCipher(new CBCBlockCipher(this.cipher.getUnderlyingCipher()));
        }
        else if(v0.startsWith("OFB")) {
            this.ivLength = this.cipher.getUnderlyingCipher().getBlockSize();
            this.cipher = v0.length() != v2 ? new PaddedBufferedBlockCipher(new OFBBlockCipher(this.cipher.getUnderlyingCipher(), Integer.parseInt(v0.substring(v2)))) : new PaddedBufferedBlockCipher(new OFBBlockCipher(this.cipher.getUnderlyingCipher(), this.cipher.getBlockSize() * 8));
        }
        else if(v0.startsWith("CFB")) {
            this.ivLength = this.cipher.getUnderlyingCipher().getBlockSize();
            this.cipher = v0.length() != v2 ? new PaddedBufferedBlockCipher(new CFBBlockCipher(this.cipher.getUnderlyingCipher(), Integer.parseInt(v0.substring(v2)))) : new PaddedBufferedBlockCipher(new CFBBlockCipher(this.cipher.getUnderlyingCipher(), this.cipher.getBlockSize() * 8));
        }
        else {
            goto label_88;
        }

        return;
    label_88:
        throw new IllegalArgumentException("can\'t support mode " + arg5);
    }

    protected void engineSetPadding(String arg4) {
        String v0 = Strings.toUpperCase(arg4);
        if(v0.equals("NOPADDING")) {
            this.cipher = new BufferedBlockCipher(this.cipher.getUnderlyingCipher());
        }
        else {
            if(!v0.equals("PKCS5PADDING") && !v0.equals("PKCS7PADDING") && !v0.equals("ISO10126PADDING")) {
                if(v0.equals("WITHCTS")) {
                    this.cipher = new CTSBlockCipher(this.cipher.getUnderlyingCipher());
                    return;
                }
                else {
                    throw new NoSuchPaddingException("Padding " + arg4 + " unknown.");
                }
            }

            this.cipher = new PaddedBufferedBlockCipher(this.cipher.getUnderlyingCipher());
        }
    }

    protected Key engineUnwrap(byte[] arg5, String arg6, int arg7) {
        PublicKey v0_7;
        byte[] v1;
        try {
            v1 = this.engineDoFinal(arg5, 0, arg5.length);
            if(arg7 != 3) {
                goto label_18;
            }
        }
        catch(IllegalBlockSizeException v0) {
            throw new InvalidKeyException(v0.getMessage());
        }
        catch(BadPaddingException v0_1) {
            throw new InvalidKeyException(v0_1.getMessage());
        }

        SecretKeySpec v0_2 = new SecretKeySpec(v1, arg6);
        goto label_7;
        try {
        label_18:
            KeyFactory v0_6 = KeyFactory.getInstance(arg6, "BC");
            if(arg7 == 1) {
                v0_7 = v0_6.generatePublic(new X509EncodedKeySpec(v1));
            }
            else if(arg7 == 2) {
                PrivateKey v0_8 = v0_6.generatePrivate(new PKCS8EncodedKeySpec(v1));
            }
            else {
                goto label_65;
            }
        }
        catch(InvalidKeySpecException v0_3) {
            throw new InvalidKeyException("Unknown key type " + v0_3.getMessage());
        }
        catch(NoSuchAlgorithmException v0_4) {
            throw new InvalidKeyException("Unknown key type " + v0_4.getMessage());
        }
        catch(NoSuchProviderException v0_5) {
            throw new InvalidKeyException("Unknown key type " + v0_5.getMessage());
        }

    label_7:
        return ((Key)v0_7);
    label_65:
        throw new InvalidKeyException("Unknown key type " + arg7);
    }

    protected int engineUpdate(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        return this.cipher.processBytes(arg7, arg8, arg9, arg10, arg11);
    }

    protected byte[] engineUpdate(byte[] arg7, int arg8, int arg9) {
        byte[] v4 = null;
        int v0 = this.cipher.getUpdateOutputSize(arg9);
        if(v0 > 0) {
            v4 = new byte[v0];
            this.cipher.processBytes(arg7, arg8, arg9, v4, 0);
        }
        else {
            this.cipher.processBytes(arg7, arg8, arg9, v4, 0);
        }

        return v4;
    }

    protected byte[] engineWrap(Key arg4) {
        byte[] v0 = arg4.getEncoded();
        if(v0 == null) {
            throw new InvalidKeyException("Cannot wrap key, null encoding.");
        }

        try {
            return this.engineDoFinal(v0, 0, v0.length);
        }
        catch(BadPaddingException v0_1) {
            throw new IllegalBlockSizeException(v0_1.getMessage());
        }
    }
}

