// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.DerivationFunction;
import org.bouncycastle.crypto.DerivationParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.KDFParameters;

public class BrokenKDF2BytesGenerator implements DerivationFunction {
    private Digest digest;
    private byte[] iv;
    private byte[] shared;

    public BrokenKDF2BytesGenerator(Digest arg1) {
        super();
        this.digest = arg1;
    }

    public int generateBytes(byte[] arg9, int arg10, int arg11) {
        if(arg9.length - arg11 < arg10) {
            throw new DataLengthException("output buffer too small");
        }

        long v0 = ((long)(arg11 * 8));
        if(v0 > (((long)(this.digest.getDigestSize() * 8))) * 29) {
            new IllegalArgumentException("Output length to large");
        }

        int v2 = ((int)(v0 / (((long)this.digest.getDigestSize()))));
        byte[] v3 = new byte[this.digest.getDigestSize()];
        int v1 = 1;
        int v0_1 = arg10;
        while(v1 <= v2) {
            this.digest.update(this.shared, 0, this.shared.length);
            this.digest.update(((byte)(v1 & 255)));
            this.digest.update(((byte)(v1 >> 8 & 255)));
            this.digest.update(((byte)(v1 >> 16 & 255)));
            this.digest.update(((byte)(v1 >> 24 & 255)));
            this.digest.update(this.iv, 0, this.iv.length);
            this.digest.doFinal(v3, 0);
            if(arg11 - v0_1 > v3.length) {
                System.arraycopy(v3, 0, arg9, v0_1, v3.length);
                v0_1 += v3.length;
            }
            else {
                System.arraycopy(v3, 0, arg9, v0_1, arg11 - v0_1);
            }

            ++v1;
        }

        this.digest.reset();
        return arg11;
    }

    public Digest getDigest() {
        return this.digest;
    }

    public void init(DerivationParameters arg3) {
        if(!(arg3 instanceof KDFParameters)) {
            throw new IllegalArgumentException("KDF parameters required for KDF2Generator");
        }

        this.shared = ((KDFParameters)arg3).getSharedSecret();
        this.iv = ((KDFParameters)arg3).getIV();
    }
}

