// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.PBEParametersGenerator;
import org.bouncycastle.crypto.digests.MD5Digest;
import org.bouncycastle.crypto.digests.RIPEMD160Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.generators.PKCS12ParametersGenerator;
import org.bouncycastle.crypto.generators.PKCS5S1ParametersGenerator;
import org.bouncycastle.crypto.generators.PKCS5S2ParametersGenerator;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.jcajce.provider.symmetric.util.BCPBEKey;

public class BrokenPBE$Util {
    public BrokenPBE$Util() {
        super();
    }

    private static PBEParametersGenerator makePBEGenerator(int arg2, int arg3) {
        PKCS5S2ParametersGenerator v0_1;
        if(arg2 == 0) {
            switch(arg3) {
                case 0: {
                    goto label_6;
                }
                case 1: {
                    goto label_11;
                }
            }

            throw new IllegalStateException("PKCS5 scheme 1 only supports only MD5 and SHA1.");
        label_6:
            PKCS5S1ParametersGenerator v0 = new PKCS5S1ParametersGenerator(new MD5Digest());
            goto label_10;
        label_11:
            v0 = new PKCS5S1ParametersGenerator(new SHA1Digest());
        }
        else if(arg2 == 1) {
            v0_1 = new PKCS5S2ParametersGenerator();
        }
        else if(arg2 == 3) {
            switch(arg3) {
                case 0: {
                    goto label_28;
                }
                case 1: {
                    goto label_33;
                }
                case 2: {
                    goto label_38;
                }
            }

            throw new IllegalStateException("unknown digest scheme for PBE encryption.");
        label_38:
            OldPKCS12ParametersGenerator v0_2 = new OldPKCS12ParametersGenerator(new RIPEMD160Digest());
            goto label_10;
        label_33:
            v0_2 = new OldPKCS12ParametersGenerator(new SHA1Digest());
            goto label_10;
        label_28:
            v0_2 = new OldPKCS12ParametersGenerator(new MD5Digest());
        }
        else {
            switch(arg3) {
                case 0: {
                    goto label_48;
                }
                case 1: {
                    goto label_53;
                }
                case 2: {
                    goto label_58;
                }
            }

            throw new IllegalStateException("unknown digest scheme for PBE encryption.");
        label_53:
            PKCS12ParametersGenerator v0_3 = new PKCS12ParametersGenerator(new SHA1Digest());
            goto label_10;
        label_48:
            v0_3 = new PKCS12ParametersGenerator(new MD5Digest());
            goto label_10;
        label_58:
            v0_3 = new PKCS12ParametersGenerator(new RIPEMD160Digest());
        }

    label_10:
        return ((PBEParametersGenerator)v0_1);
    }

    static CipherParameters makePBEMacParameters(BCPBEKey arg5, AlgorithmParameterSpec arg6, int arg7, int arg8, int arg9) {
        if(arg6 != null && ((arg6 instanceof PBEParameterSpec))) {
            PBEParametersGenerator v0 = BrokenPBE$Util.makePBEGenerator(arg7, arg8);
            byte[] v2 = arg5.getEncoded();
            v0.init(v2, ((PBEParameterSpec)arg6).getSalt(), ((PBEParameterSpec)arg6).getIterationCount());
            CipherParameters v3 = v0.generateDerivedMacParameters(arg9);
            int v0_1;
            for(v0_1 = 0; v0_1 != v2.length; ++v0_1) {
                v2[v0_1] = 0;
            }

            return v3;
        }

        throw new IllegalArgumentException("Need a PBEParameter spec with a PBE key.");
    }

    static CipherParameters makePBEParameters(BCPBEKey arg5, AlgorithmParameterSpec arg6, int arg7, int arg8, String arg9, int arg10, int arg11) {
        if(arg6 != null && ((arg6 instanceof PBEParameterSpec))) {
            PBEParametersGenerator v0 = BrokenPBE$Util.makePBEGenerator(arg7, arg8);
            byte[] v3 = arg5.getEncoded();
            v0.init(v3, ((PBEParameterSpec)arg6).getSalt(), ((PBEParameterSpec)arg6).getIterationCount());
            CipherParameters v1 = arg11 != 0 ? v0.generateDerivedParameters(arg10, arg11) : v0.generateDerivedParameters(arg10);
            if(arg9.startsWith("DES")) {
                if((v1 instanceof ParametersWithIV)) {
                    BrokenPBE$Util.setOddParity(v1.getParameters().getKey());
                }
                else {
                    BrokenPBE$Util.setOddParity(v1.getKey());
                }
            }

            int v0_1;
            for(v0_1 = 0; v0_1 != v3.length; ++v0_1) {
                v3[v0_1] = 0;
            }

            return v1;
        }

        throw new IllegalArgumentException("Need a PBEParameter spec with a PBE key.");
    }

    private static void setOddParity(byte[] arg5) {
        int v0;
        for(v0 = 0; v0 < arg5.length; ++v0) {
            arg5[v0] = ((byte)(arg5[v0] >> 7 ^ (arg5[v0] >> 1 ^ arg5[v0] >> 2 ^ arg5[v0] >> 3 ^ arg5[v0] >> 4 ^ arg5[v0] >> 5 ^ arg5[v0] >> 6) ^ 1 | arg5[v0] & 254));
        }
    }
}

