// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;
import java.security.KeyFactory;
import java.security.Principal;
import java.security.PublicKey;
import java.security.cert.CRLException;
import java.security.cert.CertPath;
import java.security.cert.CertPathValidatorException;
import java.security.cert.CertSelector;
import java.security.cert.CertStore;
import java.security.cert.CertStoreException;
import java.security.cert.PKIXParameters;
import java.security.cert.PolicyNode;
import java.security.cert.PolicyQualifierInfo;
import java.security.cert.TrustAnchor;
import java.security.cert.X509CRL;
import java.security.cert.X509CRLEntry;
import java.security.cert.X509CRLSelector;
import java.security.cert.X509CertSelector;
import java.security.cert.X509Certificate;
import java.security.cert.X509Extension;
import java.security.interfaces.DSAParams;
import java.security.interfaces.DSAPublicKey;
import java.security.spec.DSAPublicKeySpec;
import java.security.spec.KeySpec;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Enumerated;
import org.bouncycastle.asn1.ASN1GeneralizedTime;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1OutputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEREnumerated;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.isismtt.ISISMTTObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.CRLDistPoint;
import org.bouncycastle.asn1.x509.DistributionPoint;
import org.bouncycastle.asn1.x509.DistributionPointName;
import org.bouncycastle.asn1.x509.Extension;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.PolicyInformation;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jce.X509LDAPCertStoreParameters;
import org.bouncycastle.jce.X509LDAPCertStoreParameters$Builder;
import org.bouncycastle.jce.exception.ExtCertPathValidatorException;
import org.bouncycastle.util.Integers;
import org.bouncycastle.util.Selector;
import org.bouncycastle.util.StoreException;
import org.bouncycastle.x509.ExtendedPKIXBuilderParameters;
import org.bouncycastle.x509.ExtendedPKIXParameters;
import org.bouncycastle.x509.X509AttributeCertStoreSelector;
import org.bouncycastle.x509.X509AttributeCertificate;
import org.bouncycastle.x509.X509CRLStoreSelector;
import org.bouncycastle.x509.X509CertStoreSelector;
import org.bouncycastle.x509.X509Store;
import org.bouncycastle.x509.X509StoreParameters;

public class CertPathValidatorUtilities {
    protected static final String ANY_POLICY = "2.5.29.32.0";
    protected static final String AUTHORITY_KEY_IDENTIFIER = null;
    public static final String BASIC_CONSTRAINTS = null;
    public static final String CERTIFICATE_POLICIES = null;
    protected static final String CRL_DISTRIBUTION_POINTS = null;
    public static final String CRL_NUMBER = null;
    protected static final int CRL_SIGN = 6;
    public static final PKIXCRLUtil CRL_UTIL = null;
    public static final String DELTA_CRL_INDICATOR = null;
    protected static final String FRESHEST_CRL = null;
    public static final String INHIBIT_ANY_POLICY = null;
    public static final String ISSUING_DISTRIBUTION_POINT = null;
    protected static final int KEY_CERT_SIGN = 5;
    public static final String KEY_USAGE;
    public static final String NAME_CONSTRAINTS;
    public static final String POLICY_CONSTRAINTS;
    public static final String POLICY_MAPPINGS;
    public static final String SUBJECT_ALTERNATIVE_NAME;
    public static final String[] crlReasons;

    static {
        CertPathValidatorUtilities.CRL_UTIL = new PKIXCRLUtil();
        CertPathValidatorUtilities.CERTIFICATE_POLICIES = Extension.certificatePolicies.getId();
        CertPathValidatorUtilities.BASIC_CONSTRAINTS = Extension.basicConstraints.getId();
        CertPathValidatorUtilities.POLICY_MAPPINGS = Extension.policyMappings.getId();
        CertPathValidatorUtilities.SUBJECT_ALTERNATIVE_NAME = Extension.subjectAlternativeName.getId();
        CertPathValidatorUtilities.NAME_CONSTRAINTS = Extension.nameConstraints.getId();
        CertPathValidatorUtilities.KEY_USAGE = Extension.keyUsage.getId();
        CertPathValidatorUtilities.INHIBIT_ANY_POLICY = Extension.inhibitAnyPolicy.getId();
        CertPathValidatorUtilities.ISSUING_DISTRIBUTION_POINT = Extension.issuingDistributionPoint.getId();
        CertPathValidatorUtilities.DELTA_CRL_INDICATOR = Extension.deltaCRLIndicator.getId();
        CertPathValidatorUtilities.POLICY_CONSTRAINTS = Extension.policyConstraints.getId();
        CertPathValidatorUtilities.FRESHEST_CRL = Extension.freshestCRL.getId();
        CertPathValidatorUtilities.CRL_DISTRIBUTION_POINTS = Extension.cRLDistributionPoints.getId();
        CertPathValidatorUtilities.AUTHORITY_KEY_IDENTIFIER = Extension.authorityKeyIdentifier.getId();
        CertPathValidatorUtilities.CRL_NUMBER = Extension.cRLNumber.getId();
        CertPathValidatorUtilities.crlReasons = new String[]{"unspecified", "keyCompromise", "cACompromise", "affiliationChanged", "superseded", "cessationOfOperation", "certificateHold", "unknown", "removeFromCRL", "privilegeWithdrawn", "aACompromise"};
    }

    public CertPathValidatorUtilities() {
        super();
    }

    protected static void addAdditionalStoreFromLocation(String arg5, ExtendedPKIXParameters arg6) {
        if(arg6.isAdditionalLocationsEnabled()) {
            try {
                if(arg5.startsWith("ldap://")) {
                    String v0_1 = arg5.substring(7);
                    String v1 = null;
                    if(v0_1.indexOf("/") != -1) {
                        v1 = v0_1.substring(v0_1.indexOf("/"));
                        v0_1 = "ldap://" + v0_1.substring(0, v0_1.indexOf("/"));
                    }
                    else {
                        v0_1 = "ldap://" + v0_1;
                    }

                    X509LDAPCertStoreParameters v0_2 = new X509LDAPCertStoreParameters$Builder(v0_1, v1).build();
                    arg6.addAdditionalStore(X509Store.getInstance("CERTIFICATE/LDAP", ((X509StoreParameters)v0_2), "BC"));
                    arg6.addAdditionalStore(X509Store.getInstance("CRL/LDAP", ((X509StoreParameters)v0_2), "BC"));
                    arg6.addAdditionalStore(X509Store.getInstance("ATTRIBUTECERTIFICATE/LDAP", ((X509StoreParameters)v0_2), "BC"));
                    arg6.addAdditionalStore(X509Store.getInstance("CERTIFICATEPAIR/LDAP", ((X509StoreParameters)v0_2), "BC"));
                }

                return;
            }
            catch(Exception v0) {
                throw new RuntimeException("Exception adding X.509 stores.");
            }
        }
    }

    protected static void addAdditionalStoresFromAltNames(X509Certificate arg4, ExtendedPKIXParameters arg5) {
        if(arg4.getIssuerAlternativeNames() != null) {
            Iterator v1 = arg4.getIssuerAlternativeNames().iterator();
            while(v1.hasNext()) {
                Object v0 = v1.next();
                if(!((List)v0).get(0).equals(Integers.valueOf(6))) {
                    continue;
                }

                CertPathValidatorUtilities.addAdditionalStoreFromLocation(((List)v0).get(1), arg5);
            }
        }
    }

    protected static void addAdditionalStoresFromCRLDistributionPoint(CRLDistPoint arg7, ExtendedPKIXParameters arg8) {
        int v0_1;
        DistributionPoint[] v3;
        if(arg7 != null) {
            try {
                v3 = arg7.getDistributionPoints();
                v0_1 = 0;
            }
            catch(Exception v0) {
                throw new AnnotatedException("Distribution points could not be read.", ((Throwable)v0));
            }

            while(v0_1 < v3.length) {
                DistributionPointName v2 = v3[v0_1].getDistributionPoint();
                if(v2 != null && v2.getType() == 0) {
                    GeneralName[] v4 = GeneralNames.getInstance(v2.getName()).getNames();
                    int v2_1;
                    for(v2_1 = 0; v2_1 < v4.length; ++v2_1) {
                        if(v4[v2_1].getTagNo() == 6) {
                            CertPathValidatorUtilities.addAdditionalStoreFromLocation(DERIA5String.getInstance(v4[v2_1].getName()).getString(), arg8);
                        }
                    }
                }

                ++v0_1;
            }
        }
    }

    protected static Collection findCertificates(X509AttributeCertStoreSelector arg4, List arg5) {
        HashSet v1 = new HashSet();
        Iterator v2 = arg5.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if(!(v0 instanceof X509Store)) {
                continue;
            }

            try {
                ((Set)v1).addAll(((X509Store)v0).getMatches(((Selector)arg4)));
                continue;
            }
            catch(StoreException v0_1) {
                throw new AnnotatedException("Problem while picking certificates from X.509 store.", ((Throwable)v0_1));
            }
        }

        return ((Collection)v1);
    }

    protected static Collection findCertificates(X509CertStoreSelector arg4, List arg5) {
        HashSet v1 = new HashSet();
        Iterator v2 = arg5.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if(!(v0 instanceof X509Store)) {
                goto label_16;
            }

            try {
                ((Set)v1).addAll(((X509Store)v0).getMatches(((Selector)arg4)));
                continue;
            }
            catch(StoreException v0_1) {
                throw new AnnotatedException("Problem while picking certificates from X.509 store.", ((Throwable)v0_1));
            }

            try {
            label_16:
                ((Set)v1).addAll(((CertStore)v0).getCertificates(((CertSelector)arg4)));
                continue;
            }
            catch(CertStoreException v0_2) {
                throw new AnnotatedException("Problem while picking certificates from certificate store.", ((Throwable)v0_2));
            }
        }

        return ((Collection)v1);
    }

    protected static Collection findIssuerCerts(X509Certificate arg4, ExtendedPKIXBuilderParameters arg5) {
        Iterator v2_1;
        X509CertStoreSelector v0 = new X509CertStoreSelector();
        HashSet v1 = new HashSet();
        try {
            v0.setSubject(arg4.getIssuerX500Principal().getEncoded());
        }
        catch(IOException v0_1) {
            throw new AnnotatedException("Subject criteria for certificate selector to find issuer certificate could not be set.", ((Throwable)v0_1));
        }

        try {
            ArrayList v2 = new ArrayList();
            ((List)v2).addAll(CertPathValidatorUtilities.findCertificates(v0, arg5.getCertStores()));
            ((List)v2).addAll(CertPathValidatorUtilities.findCertificates(v0, arg5.getStores()));
            ((List)v2).addAll(CertPathValidatorUtilities.findCertificates(v0, arg5.getAdditionalStores()));
            v2_1 = ((List)v2).iterator();
        }
        catch(AnnotatedException v0_2) {
            throw new AnnotatedException("Issuer certificate cannot be searched.", ((Throwable)v0_2));
        }

        while(v2_1.hasNext()) {
            ((Set)v1).add(v2_1.next());
        }

        return ((Collection)v1);
    }

    protected static TrustAnchor findTrustAnchor(X509Certificate arg1, Set arg2) {
        return CertPathValidatorUtilities.findTrustAnchor(arg1, arg2, null);
    }

    protected static TrustAnchor findTrustAnchor(X509Certificate arg10, Set arg11, String arg12) {
        PublicKey v9;
        PublicKey v0_2;
        Object v3_1;
        Object v2 = null;
        X509CertSelector v4 = new X509CertSelector();
        X500Principal v5 = CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg10);
        try {
            v4.setSubject(v5.getEncoded());
        }
        catch(IOException v0) {
            throw new AnnotatedException("Cannot set subject search criteria for trust anchor.", ((Throwable)v0));
        }

        Iterator v6 = arg11.iterator();
        Exception v1 = ((Exception)v2);
        PublicKey v3 = ((PublicKey)v2);
        Object v0_1 = v2;
        while(v6.hasNext()) {
            if(v0_1 != null) {
                break;
            }

            v0_1 = v6.next();
            if(((TrustAnchor)v0_1).getTrustedCert() != null) {
                if(v4.match(((TrustAnchor)v0_1).getTrustedCert())) {
                    v3_1 = v0_1;
                    v0_2 = ((TrustAnchor)v0_1).getTrustedCert().getPublicKey();
                }
                else {
                    v0_2 = v3;
                    v3_1 = v2;
                }

                goto label_24;
            }
            else {
                if(((TrustAnchor)v0_1).getCAName() != null && ((TrustAnchor)v0_1).getCAPublicKey() != null) {
                    try {
                        if(v5.equals(new X500Principal(((TrustAnchor)v0_1).getCAName()))) {
                            v3 = ((TrustAnchor)v0_1).getCAPublicKey();
                        }
                        else {
                            goto label_52;
                        }

                        goto label_48;
                    }
                    catch(IllegalArgumentException v0_3) {
                        v0_2 = v3;
                        v3_1 = v2;
                        goto label_24;
                    }

                label_52:
                    v0_1 = v2;
                label_48:
                    v9 = v3;
                    v3_1 = v0_1;
                    v0_2 = v9;
                }
                else {
                    v0_2 = v3;
                    v3_1 = v2;
                }

            label_24:
                if(v0_2 != null) {
                    try {
                        CertPathValidatorUtilities.verifyX509Certificate(arg10, v0_2, arg12);
                        v9 = v0_2;
                        v0_1 = v3_1;
                        v3 = v9;
                    }
                    catch(Exception v0_4) {
                        v1 = v0_4;
                        v3 = ((PublicKey)v2);
                        v0_1 = v2;
                    }

                    continue;
                }

                v9 = v0_2;
                v0_1 = v3_1;
                v3 = v9;
                continue;
            }
        }

        if(v0_1 == null && v1 != null) {
            throw new AnnotatedException("TrustAnchor found but certificate validation failed.", ((Throwable)v1));
        }

        return ((TrustAnchor)v0_1);
    }

    public static AlgorithmIdentifier getAlgorithmIdentifier(PublicKey arg3) {
        try {
            return SubjectPublicKeyInfo.getInstance(new ASN1InputStream(arg3.getEncoded()).readObject()).getAlgorithmId();
        }
        catch(Exception v0) {
            throw new ExtCertPathValidatorException("Subject public key cannot be decoded.", ((Throwable)v0));
        }
    }

    protected static void getCRLIssuersFromDistributionPoint(DistributionPoint arg5, Collection arg6, X509CRLSelector arg7, ExtendedPKIXParameters arg8) {
        ArrayList v1 = new ArrayList();
        if(arg5.getCRLIssuer() != null) {
            GeneralName[] v2 = arg5.getCRLIssuer().getNames();
            int v0;
            for(v0 = 0; v0 < v2.length; ++v0) {
                if(v2[v0].getTagNo() == 4) {
                    try {
                        ((List)v1).add(new X500Principal(v2[v0].getName().toASN1Primitive().getEncoded()));
                    }
                    catch(IOException v0_1) {
                        throw new AnnotatedException("CRL issuer information from distribution point cannot be decoded.", ((Throwable)v0_1));
                    }
                }
            }
        }
        else {
            if(arg5.getDistributionPoint() == null) {
                throw new AnnotatedException("CRL issuer is omitted from distribution point but no distributionPoint field present.");
            }

            Iterator v2_1 = arg6.iterator();
            while(v2_1.hasNext()) {
                ((List)v1).add(v2_1.next());
            }
        }

        Iterator v1_1 = ((List)v1).iterator();
        while(v1_1.hasNext()) {
            try {
                arg7.addIssuerName(v1_1.next().getEncoded());
                continue;
            }
            catch(IOException v0_1) {
                throw new AnnotatedException("Cannot decode CRL issuer information.", ((Throwable)v0_1));
            }
        }
    }

    protected static void getCertStatus(Date arg6, X509CRL arg7, Object arg8, CertStatus arg9) {
        try {
            if(!X509CRLObject.isIndirectCRL(arg7)) {
                goto label_52;
            }
        }
        catch(CRLException v0) {
            throw new AnnotatedException("Failed check for indirect CRL.", ((Throwable)v0));
        }

        X509CRLEntry v1 = arg7.getRevokedCertificate(CertPathValidatorUtilities.getSerialNumber(arg8));
        if(v1 != null) {
            X500Principal v0_1 = v1.getCertificateIssuer();
            if(v0_1 == null) {
                v0_1 = CertPathValidatorUtilities.getIssuerPrincipal(arg7);
            }

            if(!CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg8).equals(v0_1)) {
                return;
            }

            X509CRLEntry v0_2 = v1;
            goto label_18;
        label_52:
            if(!CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg8).equals(CertPathValidatorUtilities.getIssuerPrincipal(arg7))) {
                return;
            }

            v0_2 = arg7.getRevokedCertificate(CertPathValidatorUtilities.getSerialNumber(arg8));
            if(v0_2 == null) {
                return;
            }

        label_18:
            ASN1Enumerated v1_1 = null;
            if(v0_2.hasExtensions()) {
                try {
                    v1_1 = DEREnumerated.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0_2), org.bouncycastle.asn1.x509.X509Extension.reasonCode.getId()));
                }
                catch(Exception v0_3) {
                    throw new AnnotatedException("Reason code CRL entry extension could not be decoded.", ((Throwable)v0_3));
                }
            }

            if(arg6.getTime() < v0_2.getRevocationDate().getTime() && v1_1 != null && ((DEREnumerated)v1_1).getValue().intValue() != 0 && ((DEREnumerated)v1_1).getValue().intValue() != 1 && ((DEREnumerated)v1_1).getValue().intValue() != 2 && ((DEREnumerated)v1_1).getValue().intValue() != 8) {
                return;
            }

            if(v1_1 != null) {
                arg9.setCertStatus(((DEREnumerated)v1_1).getValue().intValue());
            }
            else {
                arg9.setCertStatus(0);
            }

            arg9.setRevocationDate(v0_2.getRevocationDate());
        }
    }

    protected static Set getCompleteCRLs(DistributionPoint arg6, Object arg7, Date arg8, ExtendedPKIXParameters arg9) {
        X509CRLStoreSelector v2 = new X509CRLStoreSelector();
        try {
            HashSet v3 = new HashSet();
            if((arg7 instanceof X509AttributeCertificate)) {
                ((Set)v3).add(arg7.getIssuer().getPrincipals()[0]);
            }
            else {
                ((Set)v3).add(CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg7));
            }

            CertPathValidatorUtilities.getCRLIssuersFromDistributionPoint(arg6, ((Collection)v3), ((X509CRLSelector)v2), arg9);
        }
        catch(AnnotatedException v1) {
            throw new AnnotatedException("Could not get issuer information from distribution point.", ((Throwable)v1));
        }

        if((arg7 instanceof X509Certificate)) {
            v2.setCertificateChecking(arg7);
        }
        else if((arg7 instanceof X509AttributeCertificate)) {
            v2.setAttrCertificateChecking(arg7);
        }

        v2.setCompleteCRLEnabled(true);
        Set v1_1 = CertPathValidatorUtilities.CRL_UTIL.findCRLs(v2, arg9, arg8);
        if(v1_1.isEmpty()) {
            if((arg7 instanceof X509AttributeCertificate)) {
                throw new AnnotatedException("No CRLs found for issuer \"" + ((X509AttributeCertificate)arg7).getIssuer().getPrincipals()[0] + "\"");
            }

            throw new AnnotatedException("No CRLs found for issuer \"" + ((X509Certificate)arg7).getIssuerX500Principal() + "\"");
        }

        return v1_1;
    }

    protected static Set getDeltaCRLs(Date arg6, ExtendedPKIXParameters arg7, X509CRL arg8) {
        byte[] v3;
        BigInteger v0_3;
        BigInteger v1 = null;
        X509CRLStoreSelector v2 = new X509CRLStoreSelector();
        try {
            v2.addIssuerName(CertPathValidatorUtilities.getIssuerPrincipal(arg8).getEncoded());
        }
        catch(IOException v0) {
            throw new AnnotatedException("Cannot extract issuer from CRL.", ((Throwable)v0));
        }

        try {
            ASN1Primitive v0_2 = CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg8), CertPathValidatorUtilities.CRL_NUMBER);
            if(v0_2 != null) {
                v0_3 = ASN1Integer.getInstance(v0_2).getPositiveValue();
            }
            else {
                goto label_51;
            }

            goto label_11;
        }
        catch(Exception v0_1) {
            throw new AnnotatedException("CRL number extension could not be extracted from CRL.", ((Throwable)v0_1));
        }

    label_51:
        v0_3 = v1;
        try {
        label_11:
            v3 = arg8.getExtensionValue(CertPathValidatorUtilities.ISSUING_DISTRIBUTION_POINT);
            if(v0_3 != null) {
                goto label_46;
            }

            goto label_14;
        }
        catch(Exception v0_1) {
            throw new AnnotatedException("Issuing distribution point extension value could not be read.", ((Throwable)v0_1));
        }

    label_46:
        v1 = v0_3.add(BigInteger.valueOf(1));
    label_14:
        v2.setMinCRLNumber(v1);
        v2.setIssuingDistributionPoint(v3);
        v2.setIssuingDistributionPointEnabled(true);
        v2.setMaxBaseCRLNumber(v0_3);
        Set v0_4 = CertPathValidatorUtilities.CRL_UTIL.findCRLs(v2, arg7, arg6);
        HashSet v1_1 = new HashSet();
        Iterator v2_1 = v0_4.iterator();
        while(v2_1.hasNext()) {
            Object v0_5 = v2_1.next();
            if(!CertPathValidatorUtilities.isDeltaCRL(((X509CRL)v0_5))) {
                continue;
            }

            ((Set)v1_1).add(v0_5);
        }

        return ((Set)v1_1);
    }

    public static X500Principal getEncodedIssuerPrincipal(Object arg2) {
        X500Principal v0;
        if((arg2 instanceof X509Certificate)) {
            v0 = ((X509Certificate)arg2).getIssuerX500Principal();
        }
        else {
            Principal v0_1 = ((X509AttributeCertificate)arg2).getIssuer().getPrincipals()[0];
        }

        return v0;
    }

    public static ASN1Primitive getExtensionValue(X509Extension arg1, String arg2) {
        byte[] v0 = arg1.getExtensionValue(arg2);
        ASN1Primitive v0_1 = v0 == null ? null : CertPathValidatorUtilities.getObject(arg2, v0);
        return v0_1;
    }

    public static X500Principal getIssuerPrincipal(X509CRL arg1) {
        return arg1.getIssuerX500Principal();
    }

    public static PublicKey getNextWorkingKey(List arg5, int arg6) {
        PublicKey v1;
        PublicKey v0 = arg5.get(arg6).getPublicKey();
        if(((v0 instanceof DSAPublicKey)) && ((DSAPublicKey)v0).getParams() == null) {
            int v2 = arg6 + 1;
            while(true) {
                if(v2 < arg5.size()) {
                    v1 = arg5.get(v2).getPublicKey();
                    if(!(v1 instanceof DSAPublicKey)) {
                        throw new CertPathValidatorException("DSA parameters cannot be inherited from previous certificate.");
                    }
                    else if(((DSAPublicKey)v1).getParams() == null) {
                        ++v2;
                        continue;
                    }
                    else {
                        break;
                    }
                }
                else {
                    goto label_41;
                }

                return v0;
            }

            DSAParams v1_1 = ((DSAPublicKey)v1).getParams();
            DSAPublicKeySpec v2_1 = new DSAPublicKeySpec(((DSAPublicKey)v0).getY(), v1_1.getP(), v1_1.getQ(), v1_1.getG());
            try {
                return KeyFactory.getInstance("DSA", "BC").generatePublic(((KeySpec)v2_1));
            }
            catch(Exception v0_1) {
                throw new RuntimeException(v0_1.getMessage());
            }

        label_41:
            throw new CertPathValidatorException("DSA parameters cannot be inherited from previous certificate.");
        }

        return v0;
    }

    private static ASN1Primitive getObject(String arg4, byte[] arg5) {
        try {
            return new ASN1InputStream(new ASN1InputStream(arg5).readObject().getOctets()).readObject();
        }
        catch(Exception v0) {
            throw new AnnotatedException("exception processing extension " + arg4, ((Throwable)v0));
        }
    }

    public static final Set getQualifierSet(ASN1Sequence arg6) {
        HashSet v0;
        HashSet v1 = new HashSet();
        if(arg6 == null) {
            v0 = v1;
        }
        else {
            ByteArrayOutputStream v2 = new ByteArrayOutputStream();
            ASN1OutputStream v3 = new ASN1OutputStream(((OutputStream)v2));
            Enumeration v4 = arg6.getObjects();
            while(v4.hasMoreElements()) {
                try {
                    v3.writeObject(v4.nextElement());
                    ((Set)v1).add(new PolicyQualifierInfo(v2.toByteArray()));
                }
                catch(IOException v0_1) {
                    throw new ExtCertPathValidatorException("Policy qualifier info cannot be decoded.", ((Throwable)v0_1));
                }

                v2.reset();
            }

            v0 = v1;
        }

        return ((Set)v0);
    }

    private static BigInteger getSerialNumber(Object arg1) {
        BigInteger v0 = (arg1 instanceof X509Certificate) ? ((X509Certificate)arg1).getSerialNumber() : ((X509AttributeCertificate)arg1).getSerialNumber();
        return v0;
    }

    public static X500Principal getSubjectPrincipal(X509Certificate arg1) {
        return arg1.getSubjectX500Principal();
    }

    protected static Date getValidCertDateFromValidityModel(ExtendedPKIXParameters arg3, CertPath arg4, int arg5) {
        ASN1GeneralizedTime v0_4;
        Date v0;
        if(arg3.getValidityModel() != 1) {
            v0 = CertPathValidatorUtilities.getValidDate(((PKIXParameters)arg3));
        }
        else if(arg5 <= 0) {
            v0 = CertPathValidatorUtilities.getValidDate(((PKIXParameters)arg3));
        }
        else if(arg5 - 1 == 0) {
            ASN1GeneralizedTime v1 = null;
            try {
                byte[] v0_3 = arg4.getCertificates().get(arg5 - 1).getExtensionValue(ISISMTTObjectIdentifiers.id_isismtt_at_dateOfCertGen.getId());
                if(v0_3 != null) {
                    v0_4 = DERGeneralizedTime.getInstance(ASN1Primitive.fromByteArray(v0_3));
                }
                else {
                    goto label_48;
                }

                goto label_18;
            }
            catch(IllegalArgumentException v0_1) {
                throw new AnnotatedException("Date of cert gen extension could not be read.");
            }
            catch(IOException v0_2) {
                throw new AnnotatedException("Date of cert gen extension could not be read.");
            }

        label_48:
            v0_4 = v1;
        label_18:
            if(v0_4 != null) {
                try {
                    return ((DERGeneralizedTime)v0_4).getDate();
                }
                catch(ParseException v0_5) {
                    throw new AnnotatedException("Date from date of cert gen extension could not be parsed.", ((Throwable)v0_5));
                }
            }

            v0 = arg4.getCertificates().get(arg5 - 1).getNotBefore();
        }
        else {
            v0 = arg4.getCertificates().get(arg5 - 1).getNotBefore();
        }

        return v0;
    }

    public static Date getValidDate(PKIXParameters arg1) {
        Date v0 = arg1.getDate();
        if(v0 == null) {
            v0 = new Date();
        }

        return v0;
    }

    public static boolean isAnyPolicy(Set arg1) {
        boolean v0 = arg1 == null || (arg1.contains("2.5.29.32.0")) || (arg1.isEmpty()) ? true : false;
        return v0;
    }

    private static boolean isDeltaCRL(X509CRL arg2) {
        Set v0 = arg2.getCriticalExtensionOIDs();
        boolean v0_1 = v0 == null ? false : v0.contains(RFC3280CertPathUtilities.DELTA_CRL_INDICATOR);
        return v0_1;
    }

    public static boolean isSelfIssued(X509Certificate arg2) {
        return arg2.getSubjectDN().equals(arg2.getIssuerDN());
    }

    public static void prepareNextCertB1(int arg8, List[] arg9, String arg10, Map arg11, X509Certificate arg12) {
        PolicyInformation v2;
        ASN1Sequence v1_1;
        Object v0;
        boolean v7 = false;
        Iterator v1 = arg9[arg8].iterator();
        do {
            if(v1.hasNext()) {
                v0 = v1.next();
                if(!((PKIXPolicyNode)v0).getValidPolicy().equals(arg10)) {
                    continue;
                }

                break;
            }
            else {
                goto label_75;
            }
        }
        while(true);

        ((PKIXPolicyNode)v0).expectedPolicies = arg11.get(arg10);
        int v0_1 = 1;
        goto label_13;
    label_75:
        v0_1 = 0;
    label_13:
        if(v0_1 == 0) {
            v1 = arg9[arg8].iterator();
            do {
                if(v1.hasNext()) {
                    v0 = v1.next();
                    if(!"2.5.29.32.0".equals(((PKIXPolicyNode)v0).getValidPolicy())) {
                        continue;
                    }

                    break;
                }

                return;
            }
            while(true);

            Set v5 = null;
            try {
                v1_1 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg12), CertPathValidatorUtilities.CERTIFICATE_POLICIES));
            }
            catch(Exception v0_2) {
                throw new AnnotatedException("Certificate policies cannot be decoded.", ((Throwable)v0_2));
            }

            Enumeration v1_2 = v1_1.getObjects();
            do {
                if(v1_2.hasMoreElements()) {
                    try {
                        v2 = PolicyInformation.getInstance(v1_2.nextElement());
                    }
                    catch(Exception v0_2) {
                        throw new AnnotatedException("Policy information cannot be decoded.", ((Throwable)v0_2));
                    }

                    if(!"2.5.29.32.0".equals(v2.getPolicyIdentifier().getId())) {
                        continue;
                    }

                    break;
                }

                goto label_39;
            }
            while(true);

            try {
                v5 = CertPathValidatorUtilities.getQualifierSet(v2.getPolicyQualifiers());
            }
            catch(CertPathValidatorException v0_3) {
                throw new ExtCertPathValidatorException("Policy qualifier info set could not be built.", ((Throwable)v0_3));
            }

        label_39:
            if(arg12.getCriticalExtensionOIDs() != null) {
                v7 = arg12.getCriticalExtensionOIDs().contains(CertPathValidatorUtilities.CERTIFICATE_POLICIES);
            }

            PolicyNode v4 = ((PKIXPolicyNode)v0).getParent();
            if(!"2.5.29.32.0".equals(((PKIXPolicyNode)v4).getValidPolicy())) {
                return;
            }

            PKIXPolicyNode v0_4 = new PKIXPolicyNode(new ArrayList(), arg8, arg11.get(arg10), v4, v5, arg10, v7);
            ((PKIXPolicyNode)v4).addChild(v0_4);
            arg9[arg8].add(v0_4);
        }
    }

    public static PKIXPolicyNode prepareNextCertB2(int arg7, List[] arg8, String arg9, PKIXPolicyNode arg10) {
        Object v0;
        Iterator v4 = arg8[arg7].iterator();
        do {
        label_2:
            if(!v4.hasNext()) {
                return arg10;
            }

            v0 = v4.next();
        }
        while(!((PKIXPolicyNode)v0).getValidPolicy().equals(arg9));

        ((PKIXPolicyNode)v0).getParent().removeChild(((PKIXPolicyNode)v0));
        v4.remove();
        int v3 = arg7 - 1;
        PKIXPolicyNode v1 = arg10;
        goto label_14;
        return arg10;
    label_14:
        while(v3 >= 0) {
            List v5 = arg8[v3];
            PKIXPolicyNode v2 = v1;
            int v1_1;
            for(v1_1 = 0; v1_1 < v5.size(); ++v1_1) {
                v0 = v5.get(v1_1);
                if(!((PKIXPolicyNode)v0).hasChildren()) {
                    v2 = CertPathValidatorUtilities.removePolicyNode(v2, arg8, ((PKIXPolicyNode)v0));
                    if(v2 != null) {
                        goto label_30;
                    }

                    break;
                }

            label_30:
            }

            --v3;
            v1 = v2;
        }

        arg10 = v1;
        goto label_2;
    }

    public static boolean processCertD1i(int arg8, List[] arg9, DERObjectIdentifier arg10, Set arg11) {
        boolean v7 = false;
        List v1 = arg9[arg8 - 1];
        int v0 = 0;
        while(v0 < v1.size()) {
            Object v4 = v1.get(v0);
            if(((PKIXPolicyNode)v4).getExpectedPolicies().contains(arg10.getId())) {
                HashSet v3 = new HashSet();
                ((Set)v3).add(arg10.getId());
                PKIXPolicyNode v0_1 = new PKIXPolicyNode(new ArrayList(), arg8, ((Set)v3), ((PolicyNode)v4), arg11, arg10.getId(), false);
                ((PKIXPolicyNode)v4).addChild(v0_1);
                arg9[arg8].add(v0_1);
                v7 = true;
            }
            else {
                ++v0;
                continue;
            }

            return v7;
        }

        return v7;
    }

    public static void processCertD1ii(int arg8, List[] arg9, DERObjectIdentifier arg10, Set arg11) {
        List v1 = arg9[arg8 - 1];
        int v0 = 0;
        while(v0 < v1.size()) {
            Object v4 = v1.get(v0);
            if("2.5.29.32.0".equals(((PKIXPolicyNode)v4).getValidPolicy())) {
                HashSet v3 = new HashSet();
                ((Set)v3).add(arg10.getId());
                PKIXPolicyNode v0_1 = new PKIXPolicyNode(new ArrayList(), arg8, ((Set)v3), ((PolicyNode)v4), arg11, arg10.getId(), false);
                ((PKIXPolicyNode)v4).addChild(v0_1);
                arg9[arg8].add(v0_1);
            }
            else {
                ++v0;
                continue;
            }

            return;
        }
    }

    public static PKIXPolicyNode removePolicyNode(PKIXPolicyNode arg3, List[] arg4, PKIXPolicyNode arg5) {
        PKIXPolicyNode v1 = null;
        PolicyNode v0 = arg5.getParent();
        if(arg3 == null) {
            arg3 = v1;
        }
        else if(v0 == null) {
            int v0_1;
            for(v0_1 = 0; v0_1 < arg4.length; ++v0_1) {
                arg4[v0_1] = new ArrayList();
            }

            arg3 = v1;
        }
        else {
            ((PKIXPolicyNode)v0).removeChild(arg5);
            CertPathValidatorUtilities.removePolicyNodeRecurse(arg4, arg5);
        }

        return arg3;
    }

    private static void removePolicyNodeRecurse(List[] arg2, PKIXPolicyNode arg3) {
        arg2[arg3.getDepth()].remove(arg3);
        if(arg3.hasChildren()) {
            Iterator v1 = arg3.getChildren();
            while(v1.hasNext()) {
                CertPathValidatorUtilities.removePolicyNodeRecurse(arg2, v1.next());
            }
        }
    }

    public static void verifyX509Certificate(X509Certificate arg0, PublicKey arg1, String arg2) {
        if(arg2 == null) {
            arg0.verify(arg1);
        }
        else {
            arg0.verify(arg1, arg2);
        }
    }
}

