// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.util.Enumeration;
import javax.crypto.interfaces.DHPrivateKey;
import javax.crypto.spec.DHParameterSpec;
import javax.crypto.spec.DHPrivateKeySpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.params.ElGamalPrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.ElGamalPrivateKey;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;
import org.bouncycastle.jce.spec.ElGamalParameterSpec;
import org.bouncycastle.jce.spec.ElGamalPrivateKeySpec;

public class JCEElGamalPrivateKey implements DHPrivateKey, ElGamalPrivateKey, PKCS12BagAttributeCarrier {
    private PKCS12BagAttributeCarrierImpl attrCarrier;
    ElGamalParameterSpec elSpec;
    static final long serialVersionUID = 4819350091141529678L;
    BigInteger x;

    protected JCEElGamalPrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    JCEElGamalPrivateKey(DHPrivateKey arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    JCEElGamalPrivateKey(DHPrivateKeySpec arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getP(), arg4.getG());
    }

    JCEElGamalPrivateKey(PrivateKeyInfo arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        ElGamalParameter v1 = new ElGamalParameter(arg4.getAlgorithmId().getParameters());
        this.x = ASN1Integer.getInstance(arg4.parsePrivateKey()).getValue();
        this.elSpec = new ElGamalParameterSpec(v1.getP(), v1.getG());
    }

    JCEElGamalPrivateKey(ElGamalPrivateKeyParameters arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getParameters().getP(), arg4.getParameters().getG());
    }

    JCEElGamalPrivateKey(ElGamalPrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg2.getX();
        this.elSpec = arg2.getParameters();
    }

    JCEElGamalPrivateKey(ElGamalPrivateKeySpec arg4) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg4.getX();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    public String getAlgorithm() {
        return "ElGamal";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedPrivateKeyInfo(new AlgorithmIdentifier(OIWObjectIdentifiers.elGamalAlgorithm, new ElGamalParameter(this.elSpec.getP(), this.elSpec.getG())), new DERInteger(this.getX()));
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public ElGamalParameterSpec getParameters() {
        return this.elSpec;
    }

    public DHParameterSpec getParams() {
        return new DHParameterSpec(this.elSpec.getP(), this.elSpec.getG());
    }

    public BigInteger getX() {
        return this.x;
    }

    private void readObject(ObjectInputStream arg4) {
        this.x = arg4.readObject();
        this.elSpec = new ElGamalParameterSpec(arg4.readObject(), arg4.readObject());
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.writeObject(this.getX());
        arg2.writeObject(this.elSpec.getP());
        arg2.writeObject(this.elSpec.getG());
    }
}

