// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import javax.crypto.interfaces.DHPublicKey;
import javax.crypto.spec.DHParameterSpec;
import javax.crypto.spec.DHPublicKeySpec;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.oiw.ElGamalParameter;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.params.ElGamalPublicKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.KeyUtil;
import org.bouncycastle.jce.interfaces.ElGamalPublicKey;
import org.bouncycastle.jce.spec.ElGamalParameterSpec;
import org.bouncycastle.jce.spec.ElGamalPublicKeySpec;

public class JCEElGamalPublicKey implements DHPublicKey, ElGamalPublicKey {
    private ElGamalParameterSpec elSpec;
    static final long serialVersionUID = 8712728417091216948L;
    private BigInteger y;

    JCEElGamalPublicKey(BigInteger arg1, ElGamalParameterSpec arg2) {
        super();
        this.y = arg1;
        this.elSpec = arg2;
    }

    JCEElGamalPublicKey(DHPublicKey arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    JCEElGamalPublicKey(DHPublicKeySpec arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getP(), arg4.getG());
    }

    JCEElGamalPublicKey(SubjectPublicKeyInfo arg4) {
        BigInteger v0_1;
        super();
        ElGamalParameter v1 = new ElGamalParameter(arg4.getAlgorithmId().getParameters());
        try {
            v0_1 = arg4.parsePublicKey().getValue();
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("invalid info structure in DSA public key");
        }

        this.y = v0_1;
        this.elSpec = new ElGamalParameterSpec(v1.getP(), v1.getG());
    }

    JCEElGamalPublicKey(ElGamalPublicKeyParameters arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getParameters().getP(), arg4.getParameters().getG());
    }

    JCEElGamalPublicKey(ElGamalPublicKey arg2) {
        super();
        this.y = arg2.getY();
        this.elSpec = arg2.getParameters();
    }

    JCEElGamalPublicKey(ElGamalPublicKeySpec arg4) {
        super();
        this.y = arg4.getY();
        this.elSpec = new ElGamalParameterSpec(arg4.getParams().getP(), arg4.getParams().getG());
    }

    public String getAlgorithm() {
        return "ElGamal";
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedSubjectPublicKeyInfo(new AlgorithmIdentifier(OIWObjectIdentifiers.elGamalAlgorithm, new ElGamalParameter(this.elSpec.getP(), this.elSpec.getG())), new DERInteger(this.y));
    }

    public String getFormat() {
        return "X.509";
    }

    public ElGamalParameterSpec getParameters() {
        return this.elSpec;
    }

    public DHParameterSpec getParams() {
        return new DHParameterSpec(this.elSpec.getP(), this.elSpec.getG());
    }

    public BigInteger getY() {
        return this.y;
    }

    private void readObject(ObjectInputStream arg4) {
        this.y = arg4.readObject();
        this.elSpec = new ElGamalParameterSpec(arg4.readObject(), arg4.readObject());
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.writeObject(this.getY());
        arg2.writeObject(this.elSpec.getP());
        arg2.writeObject(this.elSpec.getG());
    }
}

