// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import javax.crypto.BadPaddingException;
import javax.crypto.CipherSpi;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.ShortBufferException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.RC2ParameterSpec;
import javax.crypto.spec.RC5ParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.crypto.BlockCipher;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.DataLengthException;
import org.bouncycastle.crypto.StreamBlockCipher;
import org.bouncycastle.crypto.StreamCipher;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.params.ParametersWithIV;
import org.bouncycastle.jcajce.provider.symmetric.util.BCPBEKey;
import org.bouncycastle.jcajce.provider.symmetric.util.PBE;
import org.bouncycastle.jcajce.provider.symmetric.util.PBE$Util;

public class JCEStreamCipher extends CipherSpi implements PBE {
    private Class[] availableSpecs;
    private StreamCipher cipher;
    private AlgorithmParameters engineParams;
    private int ivLength;
    private ParametersWithIV ivParam;
    private String pbeAlgorithm;
    private PBEParameterSpec pbeSpec;

    protected JCEStreamCipher(BlockCipher arg6, int arg7) {
        super();
        this.availableSpecs = new Class[]{RC2ParameterSpec.class, RC5ParameterSpec.class, IvParameterSpec.class, PBEParameterSpec.class};
        this.ivLength = 0;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.ivLength = arg7;
        this.cipher = new StreamBlockCipher(arg6);
    }

    protected JCEStreamCipher(StreamCipher arg6, int arg7) {
        super();
        this.availableSpecs = new Class[]{RC2ParameterSpec.class, RC5ParameterSpec.class, IvParameterSpec.class, PBEParameterSpec.class};
        this.ivLength = 0;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.cipher = arg6;
        this.ivLength = arg7;
    }

    protected int engineDoFinal(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        if(arg9 != 0) {
            this.cipher.processBytes(arg7, arg8, arg9, arg10, arg11);
        }

        this.cipher.reset();
        return arg9;
    }

    protected byte[] engineDoFinal(byte[] arg3, int arg4, int arg5) {
        byte[] v0;
        if(arg5 != 0) {
            v0 = this.engineUpdate(arg3, arg4, arg5);
            this.cipher.reset();
        }
        else {
            this.cipher.reset();
            v0 = new byte[0];
        }

        return v0;
    }

    protected int engineGetBlockSize() {
        return 0;
    }

    protected byte[] engineGetIV() {
        byte[] v0 = this.ivParam != null ? this.ivParam.getIV() : null;
        return v0;
    }

    protected int engineGetKeySize(Key arg2) {
        return arg2.getEncoded().length * 8;
    }

    protected int engineGetOutputSize(int arg1) {
        return arg1;
    }

    protected AlgorithmParameters engineGetParameters() {
        AlgorithmParameters v0_1;
        if(this.engineParams == null && this.pbeSpec != null) {
            try {
                v0_1 = AlgorithmParameters.getInstance(this.pbeAlgorithm, "BC");
                v0_1.init(this.pbeSpec);
            }
            catch(Exception v0) {
                v0_1 = null;
            }
        }
        else {
            v0_1 = this.engineParams;
        }

        return v0_1;
    }

    protected void engineInit(int arg4, Key arg5, AlgorithmParameters arg6, SecureRandom arg7) {
        AlgorithmParameterSpec v0_1;
        AlgorithmParameterSpec v1 = null;
        if(arg6 != null) {
            int v0 = 0;
            while(true) {
                if(v0 != this.availableSpecs.length) {
                    try {
                        v0_1 = arg6.getParameterSpec(this.availableSpecs[v0]);
                        goto label_9;
                    }
                    catch(Exception v2) {
                        v0 = (((int)v0_1)) + 1;
                        continue;
                    }
                }
                else {
                    break;
                }

                goto label_9;
            }

            v0_1 = v1;
        label_9:
            if(v0_1 != null) {
                goto label_24;
            }

            throw new InvalidAlgorithmParameterException("can\'t handle parameter " + arg6.toString());
        }

        v0_1 = v1;
    label_24:
        this.engineInit(arg4, arg5, v0_1, arg7);
        this.engineParams = arg6;
    }

    protected void engineInit(int arg6, Key arg7, AlgorithmParameterSpec arg8, SecureRandom arg9) {
        ParametersWithIV v0_2;
        ParametersWithIV v1_1;
        KeyParameter v0_1;
        CipherParameters v1;
        this.pbeSpec = null;
        this.pbeAlgorithm = null;
        this.engineParams = null;
        if(!(arg7 instanceof SecretKey)) {
            throw new InvalidKeyException("Key for algorithm " + arg7.getAlgorithm() + " not suitable for symmetric enryption.");
        }

        if((arg7 instanceof BCPBEKey)) {
            this.pbeAlgorithm = ((BCPBEKey)arg7).getOID() != null ? ((BCPBEKey)arg7).getOID().getId() : ((BCPBEKey)arg7).getAlgorithm();
            if(((BCPBEKey)arg7).getParam() != null) {
                v1 = ((BCPBEKey)arg7).getParam();
                this.pbeSpec = new PBEParameterSpec(((BCPBEKey)arg7).getSalt(), ((BCPBEKey)arg7).getIterationCount());
            }
            else if((arg8 instanceof PBEParameterSpec)) {
                v1 = PBE$Util.makePBEParameters(((BCPBEKey)arg7), arg8, this.cipher.getAlgorithmName());
                this.pbeSpec = ((PBEParameterSpec)arg8);
            }
            else {
                goto label_72;
            }

            if(((BCPBEKey)arg7).getIvSize() != 0) {
                this.ivParam = v1;
            }

            CipherParameters v0 = v1;
            goto label_39;
        label_72:
            throw new InvalidAlgorithmParameterException("PBE requires PBE parameters to be set.");
        }
        else {
            if(arg8 == null) {
                v0_1 = new KeyParameter(arg7.getEncoded());
                goto label_39;
            }

            if(!(arg8 instanceof IvParameterSpec)) {
                goto label_94;
            }

            v1_1 = new ParametersWithIV(new KeyParameter(arg7.getEncoded()), ((IvParameterSpec)arg8).getIV());
            this.ivParam = v1_1;
            v0_2 = v1_1;
        }

    label_39:
        if(this.ivLength != 0 && !((((CipherParameters)v0_1)) instanceof ParametersWithIV)) {
            if(arg9 == null) {
                arg9 = new SecureRandom();
            }

            if(arg6 != 1 && arg6 != 3) {
                throw new InvalidAlgorithmParameterException("no IV set when one expected");
            }

            byte[] v2 = new byte[this.ivLength];
            arg9.nextBytes(v2);
            v1_1 = new ParametersWithIV(((CipherParameters)v0_1), v2);
            this.ivParam = v1_1;
            v0_2 = v1_1;
        }

        switch(arg6) {
            case 1: 
            case 3: {
                this.cipher.init(true, ((CipherParameters)v0_1));
                break;
            }
            case 2: 
            case 4: {
                this.cipher.init(false, ((CipherParameters)v0_1));
                break;
            }
            default: {
                System.out.println("eeek!");
                break;
            }
        }

        return;
    label_94:
        throw new IllegalArgumentException("unknown parameter type.");
    }

    protected void engineInit(int arg3, Key arg4, SecureRandom arg5) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.engineInit(arg3, arg4, v0, arg5);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidKeyException(v0_1.getMessage());
        }
    }

    protected void engineSetMode(String arg4) {
        if(!arg4.equalsIgnoreCase("ECB")) {
            throw new IllegalArgumentException("can\'t support mode " + arg4);
        }
    }

    protected void engineSetPadding(String arg4) {
        if(!arg4.equalsIgnoreCase("NoPadding")) {
            throw new NoSuchPaddingException("Padding " + arg4 + " unknown.");
        }
    }

    protected Key engineUnwrap(byte[] arg5, String arg6, int arg7) {
        PublicKey v0_9;
        PrivateKey v0_4;
        byte[] v1;
        int v3 = 2;
        try {
            v1 = this.engineDoFinal(arg5, 0, arg5.length);
            if(arg7 != 3) {
                goto label_19;
            }
        }
        catch(IllegalBlockSizeException v0) {
            throw new InvalidKeyException(v0.getMessage());
        }
        catch(BadPaddingException v0_1) {
            throw new InvalidKeyException(v0_1.getMessage());
        }

        SecretKeySpec v0_2 = new SecretKeySpec(v1, arg6);
        goto label_8;
    label_19:
        if((arg6.equals("")) && arg7 == v3) {
            try {
                PrivateKeyInfo v1_1 = PrivateKeyInfo.getInstance(v1);
                v0_4 = BouncyCastleProvider.getPrivateKey(v1_1);
                if(v0_4 == null) {
                    throw new InvalidKeyException("algorithm " + v1_1.getPrivateKeyAlgorithm().getAlgorithm() + " not supported");
                }
                else {
                    goto label_8;
                }
            }
            catch(Exception v0_3) {
                throw new InvalidKeyException("Invalid key encoding.");
            }
        }

        try {
            KeyFactory v0_8 = KeyFactory.getInstance(arg6, "BC");
            if(arg7 == 1) {
                v0_9 = v0_8.generatePublic(new X509EncodedKeySpec(v1));
                goto label_8;
            }

            if(arg7 != v3) {
                goto label_90;
            }

            v0_4 = v0_8.generatePrivate(new PKCS8EncodedKeySpec(v1));
        }
        catch(InvalidKeySpecException v0_5) {
            throw new InvalidKeyException("Unknown key type " + v0_5.getMessage());
        }
        catch(NoSuchAlgorithmException v0_6) {
            throw new InvalidKeyException("Unknown key type " + v0_6.getMessage());
        }
        catch(NoSuchProviderException v0_7) {
            throw new InvalidKeyException("Unknown key type " + v0_7.getMessage());
        }

    label_8:
        return ((Key)v0_9);
    label_90:
        throw new InvalidKeyException("Unknown key type " + arg7);
    }

    protected byte[] engineUpdate(byte[] arg7, int arg8, int arg9) {
        byte[] v4 = new byte[arg9];
        this.cipher.processBytes(arg7, arg8, arg9, v4, 0);
        return v4;
    }

    protected int engineUpdate(byte[] arg7, int arg8, int arg9, byte[] arg10, int arg11) {
        try {
            this.cipher.processBytes(arg7, arg8, arg9, arg10, arg11);
            return arg9;
        }
        catch(DataLengthException v0) {
            throw new ShortBufferException(v0.getMessage());
        }
    }

    protected byte[] engineWrap(Key arg4) {
        byte[] v0 = arg4.getEncoded();
        if(v0 == null) {
            throw new InvalidKeyException("Cannot wrap key, null encoding.");
        }

        try {
            return this.engineDoFinal(v0, 0, v0.length);
        }
        catch(BadPaddingException v0_1) {
            throw new IllegalBlockSizeException(v0_1.getMessage());
        }
    }
}

