// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.interfaces.DSAParams;
import java.security.interfaces.DSAPrivateKey;
import java.security.spec.DSAParameterSpec;
import java.security.spec.DSAPrivateKeySpec;
import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.DSAParameter;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;
import org.bouncycastle.crypto.params.DSAPrivateKeyParameters;
import org.bouncycastle.jcajce.provider.asymmetric.util.PKCS12BagAttributeCarrierImpl;
import org.bouncycastle.jce.interfaces.PKCS12BagAttributeCarrier;

public class JDKDSAPrivateKey implements DSAPrivateKey, PKCS12BagAttributeCarrier {
    private PKCS12BagAttributeCarrierImpl attrCarrier;
    DSAParams dsaSpec;
    private static final long serialVersionUID = -4677259546958385734L;
    BigInteger x;

    protected JDKDSAPrivateKey() {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
    }

    JDKDSAPrivateKey(DSAPrivateKey arg2) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg2.getX();
        this.dsaSpec = arg2.getParams();
    }

    JDKDSAPrivateKey(DSAPrivateKeySpec arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg5.getX();
        this.dsaSpec = new DSAParameterSpec(arg5.getP(), arg5.getQ(), arg5.getG());
    }

    JDKDSAPrivateKey(PrivateKeyInfo arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        DSAParameter v0 = DSAParameter.getInstance(arg5.getPrivateKeyAlgorithm().getParameters());
        this.x = ASN1Integer.getInstance(arg5.parsePrivateKey()).getValue();
        this.dsaSpec = new DSAParameterSpec(v0.getP(), v0.getQ(), v0.getG());
    }

    JDKDSAPrivateKey(DSAPrivateKeyParameters arg5) {
        super();
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.x = arg5.getX();
        this.dsaSpec = new DSAParameterSpec(arg5.getParameters().getP(), arg5.getParameters().getQ(), arg5.getParameters().getG());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof DSAPrivateKey)) && (this.getX().equals(((DSAPrivateKey)arg4).getX())) && (this.getParams().getG().equals(((DSAPrivateKey)arg4).getParams().getG())) && (this.getParams().getP().equals(((DSAPrivateKey)arg4).getParams().getP())) && (this.getParams().getQ().equals(((DSAPrivateKey)arg4).getParams().getQ()))) {
            v0 = true;
        }

        return v0;
    }

    public String getAlgorithm() {
        return "DSA";
    }

    public ASN1Encodable getBagAttribute(ASN1ObjectIdentifier arg2) {
        return this.attrCarrier.getBagAttribute(arg2);
    }

    public Enumeration getBagAttributeKeys() {
        return this.attrCarrier.getBagAttributeKeys();
    }

    public byte[] getEncoded() {
        byte[] v0_1;
        try {
            v0_1 = new PrivateKeyInfo(new AlgorithmIdentifier(X9ObjectIdentifiers.id_dsa, new DSAParameter(this.dsaSpec.getP(), this.dsaSpec.getQ(), this.dsaSpec.getG())), new DERInteger(this.getX())).getEncoded("DER");
        }
        catch(IOException v0) {
            v0_1 = null;
        }

        return v0_1;
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public DSAParams getParams() {
        return this.dsaSpec;
    }

    public BigInteger getX() {
        return this.x;
    }

    public int hashCode() {
        return this.getX().hashCode() ^ this.getParams().getG().hashCode() ^ this.getParams().getP().hashCode() ^ this.getParams().getQ().hashCode();
    }

    private void readObject(ObjectInputStream arg5) {
        this.x = arg5.readObject();
        this.dsaSpec = new DSAParameterSpec(arg5.readObject(), arg5.readObject(), arg5.readObject());
        this.attrCarrier = new PKCS12BagAttributeCarrierImpl();
        this.attrCarrier.readObject(arg5);
    }

    public void setBagAttribute(ASN1ObjectIdentifier arg2, ASN1Encodable arg3) {
        this.attrCarrier.setBagAttribute(arg2, arg3);
    }

    private void writeObject(ObjectOutputStream arg2) {
        arg2.writeObject(this.x);
        arg2.writeObject(this.dsaSpec.getP());
        arg2.writeObject(this.dsaSpec.getQ());
        arg2.writeObject(this.dsaSpec.getG());
        this.attrCarrier.writeObject(arg2);
    }
}

