// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.security.InvalidAlgorithmParameterException;
import java.security.Principal;
import java.security.cert.CertPath;
import java.security.cert.CertPathBuilderException;
import java.security.cert.CertPathBuilderResult;
import java.security.cert.CertPathBuilderSpi;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidator;
import java.security.cert.CertPathValidatorResult;
import java.security.cert.CertificateFactory;
import java.security.cert.CertificateParsingException;
import java.security.cert.PKIXBuilderParameters;
import java.security.cert.PKIXCertPathBuilderResult;
import java.security.cert.PKIXCertPathValidatorResult;
import java.security.cert.PKIXParameters;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.jce.exception.ExtCertPathBuilderException;
import org.bouncycastle.util.Selector;
import org.bouncycastle.x509.ExtendedPKIXBuilderParameters;
import org.bouncycastle.x509.ExtendedPKIXParameters;
import org.bouncycastle.x509.X509AttributeCertStoreSelector;
import org.bouncycastle.x509.X509AttributeCertificate;
import org.bouncycastle.x509.X509CertStoreSelector;

public class PKIXAttrCertPathBuilderSpi extends CertPathBuilderSpi {
    private Exception certPathException;

    public PKIXAttrCertPathBuilderSpi() {
        super();
    }

    private CertPathBuilderResult build(X509AttributeCertificate arg7, X509Certificate arg8, ExtendedPKIXBuilderParameters arg9, List arg10) {
        HashSet v0_7;
        PKIXCertPathBuilderResult v0_5;
        CertPathValidatorResult v0_4;
        CertPath v3;
        CertPathValidator v2;
        CertificateFactory v0_2;
        CertPathBuilderResult v0;
        CertPathBuilderResult v1 = null;
        if(arg10.contains(arg8)) {
            v0 = v1;
            goto label_4;
        }

        if(arg9.getExcludedCerts().contains(arg8)) {
            v0 = v1;
            goto label_4;
        }

        if(arg9.getMaxPathLength() != -1 && arg10.size() - 1 > arg9.getMaxPathLength()) {
            v0 = v1;
            goto label_4;
        }

        arg10.add(arg8);
        try {
            v0_2 = CertificateFactory.getInstance("X.509", "BC");
            v2 = CertPathValidator.getInstance("RFC3281", "BC");
        }
        catch(Exception v0_1) {
            throw new RuntimeException("Exception creating support classes.");
        }

        try {
            if(CertPathValidatorUtilities.findTrustAnchor(arg8, arg9.getTrustAnchors(), arg9.getSigProvider()) == null) {
                goto label_63;
            }

            try {
                v3 = v0_2.generateCertPath(arg10);
            }
            catch(Exception v0_1) {
                try {
                    throw new AnnotatedException("Certification path could not be constructed from certificate list.", ((Throwable)v0_1));
                }
                catch(AnnotatedException v0_3) {
                    goto label_53;
                }
            }
        }
        catch(AnnotatedException v0_3) {
            goto label_53;
        }

        try {
            v0_4 = v2.validate(v3, ((CertPathParameters)arg9));
            goto label_33;
        }
        catch(Exception v0_1) {
            try {
                throw new AnnotatedException("Certification path could not be validated.", ((Throwable)v0_1));
            label_33:
                v0_5 = new PKIXCertPathBuilderResult(v3, ((PKIXCertPathValidatorResult)v0_4).getTrustAnchor(), ((PKIXCertPathValidatorResult)v0_4).getPolicyTree(), ((PKIXCertPathValidatorResult)v0_4).getPublicKey());
                goto label_4;
            }
            catch(AnnotatedException v0_3) {
                goto label_53;
            }
        }

        try {
        label_63:
            CertPathValidatorUtilities.addAdditionalStoresFromAltNames(arg8, ((ExtendedPKIXParameters)arg9));
            goto label_64;
        }
        catch(CertificateParsingException v0_6) {
            try {
                throw new AnnotatedException("No additional X.509 stores can be added from certificate locations.", ((Throwable)v0_6));
            label_64:
                v0_7 = new HashSet();
            }
            catch(AnnotatedException v0_3) {
                goto label_53;
            }
        }

        try {
            ((Collection)v0_7).addAll(CertPathValidatorUtilities.findIssuerCerts(arg8, arg9));
            goto label_68;
        }
        catch(AnnotatedException v0_3) {
            try {
                throw new AnnotatedException("Cannot find issuer certificate for certificate in certification path.", ((Throwable)v0_3));
            label_68:
                if(((Collection)v0_7).isEmpty()) {
                    throw new AnnotatedException("No issuer certificate for certificate in certification path found.");
                }

                Iterator v2_1 = ((Collection)v0_7).iterator();
                while(v2_1.hasNext()) {
                    if(v1 != null) {
                        break;
                    }

                    Object v0_8 = v2_1.next();
                    if(((X509Certificate)v0_8).getIssuerX500Principal().equals(((X509Certificate)v0_8).getSubjectX500Principal())) {
                        continue;
                    }

                    v1 = this.build(arg7, ((X509Certificate)v0_8), arg9, arg10);
                }
            }
            catch(AnnotatedException v0_3) {
                goto label_53;
            }
        }

        v0 = v1;
        goto label_55;
    label_53:
        this.certPathException = new AnnotatedException("No valid certification path could be build.", ((Throwable)v0_3));
        v0 = v1;
    label_55:
        if(v0 == null) {
            arg10.remove(arg8);
        }

    label_4:
        return ((CertPathBuilderResult)v0_5);
    }

    public CertPathBuilderResult engineBuild(CertPathParameters arg10) {
        Collection v0_2;
        ExtendedPKIXParameters v10;
        if(!(arg10 instanceof PKIXBuilderParameters) && !(arg10 instanceof ExtendedPKIXBuilderParameters)) {
            throw new InvalidAlgorithmParameterException("Parameters must be an instance of " + PKIXBuilderParameters.class.getName() + " or " + ExtendedPKIXBuilderParameters.class.getName() + ".");
        }

        if(!(arg10 instanceof ExtendedPKIXBuilderParameters)) {
            v10 = ExtendedPKIXBuilderParameters.getInstance(((PKIXParameters)arg10));
        }

        ArrayList v4 = new ArrayList();
        Selector v0 = ((ExtendedPKIXBuilderParameters)v10).getTargetConstraints();
        if(!(v0 instanceof X509AttributeCertStoreSelector)) {
            throw new CertPathBuilderException("TargetConstraints must be an instance of " + X509AttributeCertStoreSelector.class.getName() + " for " + this.getClass().getName() + " class.");
        }

        try {
            v0_2 = CertPathValidatorUtilities.findCertificates(((X509AttributeCertStoreSelector)v0), ((ExtendedPKIXBuilderParameters)v10).getStores());
        }
        catch(AnnotatedException v0_1) {
            throw new ExtCertPathBuilderException("Error finding target attribute certificate.", ((Throwable)v0_1));
        }

        if(v0_2.isEmpty()) {
            throw new CertPathBuilderException("No attribute certificate found matching targetContraints.");
        }

        CertPathBuilderResult v2 = null;
        Iterator v5 = v0_2.iterator();
        while(v5.hasNext()) {
            if(v2 != null) {
                break;
            }

            Object v1 = v5.next();
            X509CertStoreSelector v6 = new X509CertStoreSelector();
            Principal[] v7 = ((X509AttributeCertificate)v1).getIssuer().getPrincipals();
            HashSet v8 = new HashSet();
            int v3 = 0;
            while(true) {
                if(v3 < v7.length) {
                    try {
                        if((v7[v3] instanceof X500Principal)) {
                            v6.setSubject(v7[v3].getEncoded());
                        }

                        ((Set)v8).addAll(CertPathValidatorUtilities.findCertificates(v6, ((ExtendedPKIXBuilderParameters)v10).getStores()));
                        ((Set)v8).addAll(CertPathValidatorUtilities.findCertificates(v6, ((ExtendedPKIXBuilderParameters)v10).getCertStores()));
                        ++v3;
                        continue;
                    }
                    catch(IOException v0_3) {
                        throw new ExtCertPathBuilderException("cannot encode X500Principal.", ((Throwable)v0_3));
                    }
                    catch(AnnotatedException v0_1) {
                        throw new ExtCertPathBuilderException("Public key certificate for attribute certificate cannot be searched.", ((Throwable)v0_1));
                    }
                }
                else {
                    break;
                }

                goto label_121;
            }

            if(((Set)v8).isEmpty()) {
                throw new CertPathBuilderException("Public key certificate for attribute certificate cannot be found.");
            }

            Iterator v3_1 = ((Set)v8).iterator();
            CertPathBuilderResult v0_4;
            for(v0_4 = v2; v3_1.hasNext(); v0_4 = this.build(((X509AttributeCertificate)v1), v3_1.next(), ((ExtendedPKIXBuilderParameters)v10), ((List)v4))) {
                if(v0_4 != null) {
                    break;
                }
            }

            v2 = v0_4;
        }

    label_121:
        if(v2 == null && this.certPathException != null) {
            throw new ExtCertPathBuilderException("Possible certificate chain could not be validated.", this.certPathException);
        }

        if(v2 == null && this.certPathException == null) {
            throw new CertPathBuilderException("Unable to find certificate chain.");
        }

        return v2;
    }
}

