// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CertPath;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidatorResult;
import java.security.cert.CertPathValidatorSpi;
import java.security.cert.X509Certificate;
import java.util.Date;
import org.bouncycastle.jce.exception.ExtCertPathValidatorException;
import org.bouncycastle.util.Selector;
import org.bouncycastle.x509.ExtendedPKIXParameters;
import org.bouncycastle.x509.X509AttributeCertStoreSelector;
import org.bouncycastle.x509.X509AttributeCertificate;

public class PKIXAttrCertPathValidatorSpi extends CertPathValidatorSpi {
    public PKIXAttrCertPathValidatorSpi() {
        super();
    }

    public CertPathValidatorResult engineValidate(CertPath arg6, CertPathParameters arg7) {
        Date v2_1;
        if(!(arg7 instanceof ExtendedPKIXParameters)) {
            throw new InvalidAlgorithmParameterException("Parameters must be a " + ExtendedPKIXParameters.class.getName() + " instance.");
        }

        Selector v0 = ((ExtendedPKIXParameters)arg7).getTargetConstraints();
        if(!(v0 instanceof X509AttributeCertStoreSelector)) {
            throw new InvalidAlgorithmParameterException("TargetConstraints must be an instance of " + X509AttributeCertStoreSelector.class.getName() + " for " + this.getClass().getName() + " class.");
        }

        X509AttributeCertificate v1 = ((X509AttributeCertStoreSelector)v0).getAttributeCert();
        CertPath v2 = RFC3281CertPathUtilities.processAttrCert1(v1, ((ExtendedPKIXParameters)arg7));
        CertPathValidatorResult v3 = RFC3281CertPathUtilities.processAttrCert2(arg6, ((ExtendedPKIXParameters)arg7));
        Object v0_1 = arg6.getCertificates().get(0);
        RFC3281CertPathUtilities.processAttrCert3(((X509Certificate)v0_1), ((ExtendedPKIXParameters)arg7));
        RFC3281CertPathUtilities.processAttrCert4(((X509Certificate)v0_1), ((ExtendedPKIXParameters)arg7));
        RFC3281CertPathUtilities.processAttrCert5(v1, ((ExtendedPKIXParameters)arg7));
        RFC3281CertPathUtilities.processAttrCert7(v1, arg6, v2, ((ExtendedPKIXParameters)arg7));
        RFC3281CertPathUtilities.additionalChecks(v1, ((ExtendedPKIXParameters)arg7));
        v2 = null;
        int v4 = -1;
        try {
            v2_1 = CertPathValidatorUtilities.getValidCertDateFromValidityModel(((ExtendedPKIXParameters)arg7), v2, v4);
        }
        catch(AnnotatedException v0_2) {
            throw new ExtCertPathValidatorException("Could not get validity date from attribute certificate.", ((Throwable)v0_2));
        }

        RFC3281CertPathUtilities.checkCRLs(v1, ((ExtendedPKIXParameters)arg7), ((X509Certificate)v0_1), v2_1, arg6.getCertificates());
        return v3;
    }
}

