// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CertPath;
import java.security.cert.CertPathBuilderException;
import java.security.cert.CertPathBuilderResult;
import java.security.cert.CertPathBuilderSpi;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidator;
import java.security.cert.CertPathValidatorResult;
import java.security.cert.CertificateFactory;
import java.security.cert.CertificateParsingException;
import java.security.cert.PKIXBuilderParameters;
import java.security.cert.PKIXCertPathBuilderResult;
import java.security.cert.PKIXCertPathValidatorResult;
import java.security.cert.PKIXParameters;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import org.bouncycastle.jce.exception.ExtCertPathBuilderException;
import org.bouncycastle.util.Selector;
import org.bouncycastle.x509.ExtendedPKIXBuilderParameters;
import org.bouncycastle.x509.ExtendedPKIXParameters;
import org.bouncycastle.x509.X509CertStoreSelector;

public class PKIXCertPathBuilderSpi extends CertPathBuilderSpi {
    private Exception certPathException;

    public PKIXCertPathBuilderSpi() {
        super();
    }

    protected CertPathBuilderResult build(X509Certificate arg7, ExtendedPKIXBuilderParameters arg8, List arg9) {
        HashSet v0_7;
        PKIXCertPathBuilderResult v0_5;
        CertPathValidatorResult v0_4;
        CertPath v3;
        CertPathValidator v2;
        CertificateFactory v0_2;
        CertPathBuilderResult v0;
        CertPathBuilderResult v1 = null;
        if(arg9.contains(arg7)) {
            v0 = v1;
            goto label_4;
        }

        if(arg8.getExcludedCerts().contains(arg7)) {
            v0 = v1;
            goto label_4;
        }

        if(arg8.getMaxPathLength() != -1 && arg9.size() - 1 > arg8.getMaxPathLength()) {
            v0 = v1;
            goto label_4;
        }

        arg9.add(arg7);
        try {
            v0_2 = CertificateFactory.getInstance("X.509", "BC");
            v2 = CertPathValidator.getInstance("PKIX", "BC");
        }
        catch(Exception v0_1) {
            throw new RuntimeException("Exception creating support classes.");
        }

        try {
            if(CertPathValidatorUtilities.findTrustAnchor(arg7, arg8.getTrustAnchors(), arg8.getSigProvider()) == null) {
                goto label_60;
            }

            try {
                v3 = v0_2.generateCertPath(arg9);
            }
            catch(Exception v0_1) {
                try {
                    throw new AnnotatedException("Certification path could not be constructed from certificate list.", ((Throwable)v0_1));
                }
                catch(AnnotatedException v0_3) {
                    goto label_50;
                }
            }
        }
        catch(AnnotatedException v0_3) {
            goto label_50;
        }

        try {
            v0_4 = v2.validate(v3, ((CertPathParameters)arg8));
            goto label_33;
        }
        catch(Exception v0_1) {
            try {
                throw new AnnotatedException("Certification path could not be validated.", ((Throwable)v0_1));
            label_33:
                v0_5 = new PKIXCertPathBuilderResult(v3, ((PKIXCertPathValidatorResult)v0_4).getTrustAnchor(), ((PKIXCertPathValidatorResult)v0_4).getPolicyTree(), ((PKIXCertPathValidatorResult)v0_4).getPublicKey());
                goto label_4;
            }
            catch(AnnotatedException v0_3) {
                goto label_50;
            }
        }

        try {
        label_60:
            CertPathValidatorUtilities.addAdditionalStoresFromAltNames(arg7, ((ExtendedPKIXParameters)arg8));
            goto label_61;
        }
        catch(CertificateParsingException v0_6) {
            try {
                throw new AnnotatedException("No additiontal X.509 stores can be added from certificate locations.", ((Throwable)v0_6));
            label_61:
                v0_7 = new HashSet();
            }
            catch(AnnotatedException v0_3) {
                goto label_50;
            }
        }

        try {
            ((Collection)v0_7).addAll(CertPathValidatorUtilities.findIssuerCerts(arg7, arg8));
            goto label_65;
        }
        catch(AnnotatedException v0_3) {
            try {
                throw new AnnotatedException("Cannot find issuer certificate for certificate in certification path.", ((Throwable)v0_3));
            label_65:
                if(((Collection)v0_7).isEmpty()) {
                    throw new AnnotatedException("No issuer certificate for certificate in certification path found.");
                }

                Iterator v2_1 = ((Collection)v0_7).iterator();
                while(v2_1.hasNext()) {
                    if(v1 != null) {
                        break;
                    }

                    v1 = this.build(v2_1.next(), arg8, arg9);
                }
            }
            catch(AnnotatedException v0_3) {
                goto label_50;
            }
        }

        v0 = v1;
        goto label_52;
    label_50:
        this.certPathException = ((Exception)v0_3);
        v0 = v1;
    label_52:
        if(v0 == null) {
            arg9.remove(arg7);
        }

    label_4:
        return ((CertPathBuilderResult)v0_5);
    }

    public CertPathBuilderResult engineBuild(CertPathParameters arg6) {
        Collection v4;
        ExtendedPKIXParameters v6;
        if(!(arg6 instanceof PKIXBuilderParameters) && !(arg6 instanceof ExtendedPKIXBuilderParameters)) {
            throw new InvalidAlgorithmParameterException("Parameters must be an instance of " + PKIXBuilderParameters.class.getName() + " or " + ExtendedPKIXBuilderParameters.class.getName() + ".");
        }

        if(!(arg6 instanceof ExtendedPKIXBuilderParameters)) {
            v6 = ExtendedPKIXBuilderParameters.getInstance(((PKIXParameters)arg6));
        }

        ArrayList v3 = new ArrayList();
        Selector v2 = ((ExtendedPKIXBuilderParameters)v6).getTargetConstraints();
        if(!(v2 instanceof X509CertStoreSelector)) {
            throw new CertPathBuilderException("TargetConstraints must be an instance of " + X509CertStoreSelector.class.getName() + " for " + this.getClass().getName() + " class.");
        }

        try {
            v4 = CertPathValidatorUtilities.findCertificates(v2, ((ExtendedPKIXBuilderParameters)v6).getStores());
            v4.addAll(CertPathValidatorUtilities.findCertificates(((X509CertStoreSelector)v2), ((ExtendedPKIXBuilderParameters)v6).getCertStores()));
        }
        catch(AnnotatedException v1) {
            throw new ExtCertPathBuilderException("Error finding target certificate.", ((Throwable)v1));
        }

        if(v4.isEmpty()) {
            throw new CertPathBuilderException("No certificate found matching targetContraints.");
        }

        CertPathBuilderResult v1_1 = null;
        Iterator v2_1 = v4.iterator();
        while(v2_1.hasNext()) {
            if(v1_1 != null) {
                break;
            }

            v1_1 = this.build(v2_1.next(), ((ExtendedPKIXBuilderParameters)v6), ((List)v3));
        }

        if(v1_1 == null && this.certPathException != null) {
            if((this.certPathException instanceof AnnotatedException)) {
                throw new CertPathBuilderException(this.certPathException.getMessage(), this.certPathException.getCause());
            }
            else {
                throw new CertPathBuilderException("Possible certificate chain could not be validated.", this.certPathException);
            }
        }

        if(v1_1 == null && this.certPathException == null) {
            throw new CertPathBuilderException("Unable to find certificate chain.");
        }

        return v1_1;
    }
}

