// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.security.InvalidAlgorithmParameterException;
import java.security.PublicKey;
import java.security.cert.CertPath;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidatorException;
import java.security.cert.CertPathValidatorResult;
import java.security.cert.CertPathValidatorSpi;
import java.security.cert.PKIXCertPathValidatorResult;
import java.security.cert.PKIXParameters;
import java.security.cert.PolicyNode;
import java.security.cert.TrustAnchor;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.jce.exception.ExtCertPathValidatorException;
import org.bouncycastle.x509.ExtendedPKIXParameters;

public class PKIXCertPathValidatorSpi extends CertPathValidatorSpi {
    public PKIXCertPathValidatorSpi() {
        super();
    }

    public CertPathValidatorResult engineValidate(CertPath arg27, CertPathParameters arg28) {
        HashSet v2_5;
        Set v5_3;
        int v3_2;
        PKIXPolicyNode v9_1;
        AlgorithmIdentifier v3_1;
        X500Principal v7;
        PublicKey v8;
        TrustAnchor v22;
        ExtendedPKIXParameters v28;
        if(!(arg28 instanceof PKIXParameters)) {
            throw new InvalidAlgorithmParameterException("Parameters must be a " + PKIXParameters.class.getName() + " instance.");
        }

        if(!(arg28 instanceof ExtendedPKIXParameters)) {
            v28 = ExtendedPKIXParameters.getInstance(((PKIXParameters)arg28));
        }

        if(v28.getTrustAnchors() == null) {
            throw new InvalidAlgorithmParameterException("trustAnchors is null, this is not allowed for certification path validation.");
        }

        List v20 = arg27.getCertificates();
        int v19 = v20.size();
        if(v20.isEmpty()) {
            throw new CertPathValidatorException("Certification path is empty.", null, arg27, 0);
        }

        Set v21 = v28.getInitialPolicies();
        try {
            v22 = CertPathValidatorUtilities.findTrustAnchor(v20.get(v20.size() - 1), v28.getTrustAnchors(), v28.getSigProvider());
            if(v22 != null) {
                goto label_62;
            }
        }
        catch(AnnotatedException v2) {
            throw new CertPathValidatorException(v2.getMessage(), ((Throwable)v2), arg27, v20.size() - 1);
        }

        throw new CertPathValidatorException("Trust anchor for certification path not found.", null, arg27, -1);
    label_62:
        ArrayList[] v13 = new ArrayList[v19 + 1];
        int v2_1;
        for(v2_1 = 0; v2_1 < v13.length; ++v2_1) {
            v13[v2_1] = new ArrayList();
        }

        HashSet v5 = new HashSet();
        ((Set)v5).add("2.5.29.32.0");
        PKIXPolicyNode v2_2 = new PKIXPolicyNode(new ArrayList(), 0, ((Set)v5), null, new HashSet(), "2.5.29.32.0", false);
        v13[0].add(v2_2);
        PKIXNameConstraintValidator v23 = new PKIXNameConstraintValidator();
        HashSet v11 = new HashSet();
        int v4 = v28.isExplicitPolicyRequired() ? 0 : v19 + 1;
        int v5_1 = v28.isAnyPolicyInhibited() ? 0 : v19 + 1;
        int v6 = v28.isPolicyMappingInhibited() ? 0 : v19 + 1;
        X509Certificate v9 = v22.getTrustedCert();
        if(v9 != null) {
            try {
                X500Principal v3 = CertPathValidatorUtilities.getSubjectPrincipal(v9);
                v8 = v9.getPublicKey();
                v7 = v3;
                goto label_111;
            label_138:
                v3 = new X500Principal(v22.getCAName());
                v8 = v22.getCAPublicKey();
                v7 = v3;
            }
            catch(IllegalArgumentException v2_3) {
                throw new ExtCertPathValidatorException("Subject of trust anchor could not be (re)encoded.", ((Throwable)v2_3), arg27, -1);
            }
        }
        else {
            goto label_138;
        }

        try {
        label_111:
            v3_1 = CertPathValidatorUtilities.getAlgorithmIdentifier(v8);
        }
        catch(CertPathValidatorException v2_4) {
            throw new ExtCertPathValidatorException("Algorithm identifier of public key of trust anchor could not be read.", ((Throwable)v2_4), arg27, -1);
        }

        v3_1.getObjectId();
        v3_1.getParameters();
        if(v28.getTargetConstraints() != null && !v28.getTargetConstraints().match(v20.get(0))) {
            throw new ExtCertPathValidatorException("Target certificate in certification path does not match targetConstraints.", null, arg27, 0);
        }

        List v24 = v28.getCertPathCheckers();
        Iterator v10 = v24.iterator();
        while(v10.hasNext()) {
            v10.next().init(false);
        }

        X509Certificate v15 = null;
        int v16 = v19;
        int v17 = v6;
        int v14 = v5_1;
        int v18 = v4;
        PKIXPolicyNode v12 = v2_2;
        PublicKey v5_2 = v8;
        v4 = v20.size() - 1;
        X509Certificate v8_1 = v9;
        while(v4 >= 0) {
            int v25 = v19 - v4;
            Object v15_1 = v20.get(v4);
            boolean v6_1 = v4 == v20.size() - 1 ? true : false;
            RFC3280CertPathUtilities.processCertA(arg27, ((CertPathParameters)v28), v4, v5_2, v6_1, v7, v8_1);
            RFC3280CertPathUtilities.processCertBC(arg27, v4, v23);
            v2_2 = RFC3280CertPathUtilities.processCertE(arg27, v4, RFC3280CertPathUtilities.processCertD(arg27, v4, ((Set)v11), v12, ((List[])v13), v14));
            RFC3280CertPathUtilities.processCertF(arg27, v4, v2_2, v18);
            if(v25 != v19) {
                if(v15_1 != null && ((X509Certificate)v15_1).getVersion() == 1) {
                    throw new CertPathValidatorException("Version 1 certificates can\'t be used as CA ones.", null, arg27, v4);
                }

                RFC3280CertPathUtilities.prepareNextCertA(arg27, v4);
                v9_1 = RFC3280CertPathUtilities.prepareCertB(arg27, v4, ((List[])v13), v2_2, v17);
                RFC3280CertPathUtilities.prepareNextCertG(arg27, v4, v23);
                v2_1 = RFC3280CertPathUtilities.prepareNextCertH1(arg27, v4, v18);
                v3_2 = RFC3280CertPathUtilities.prepareNextCertH2(arg27, v4, v17);
                v5_1 = RFC3280CertPathUtilities.prepareNextCertH3(arg27, v4, v14);
                int v8_2 = RFC3280CertPathUtilities.prepareNextCertI1(arg27, v4, v2_1);
                v6 = RFC3280CertPathUtilities.prepareNextCertI2(arg27, v4, v3_2);
                v14 = RFC3280CertPathUtilities.prepareNextCertJ(arg27, v4, v5_1);
                RFC3280CertPathUtilities.prepareNextCertK(arg27, v4);
                v3_2 = RFC3280CertPathUtilities.prepareNextCertM(arg27, v4, RFC3280CertPathUtilities.prepareNextCertL(arg27, v4, v16));
                RFC3280CertPathUtilities.prepareNextCertN(arg27, v4);
                v5_3 = ((X509Certificate)v15_1).getCriticalExtensionOIDs();
                if(v5_3 != null) {
                    v2_5 = new HashSet(((Collection)v5_3));
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.KEY_USAGE);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.CERTIFICATE_POLICIES);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.POLICY_MAPPINGS);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.INHIBIT_ANY_POLICY);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.DELTA_CRL_INDICATOR);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.POLICY_CONSTRAINTS);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.BASIC_CONSTRAINTS);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.SUBJECT_ALTERNATIVE_NAME);
                    ((Set)v2_5).remove(RFC3280CertPathUtilities.NAME_CONSTRAINTS);
                }
                else {
                    v2_5 = new HashSet();
                }

                RFC3280CertPathUtilities.prepareNextCertO(arg27, v4, ((Set)v2_5), v24);
                v7 = CertPathValidatorUtilities.getSubjectPrincipal(((X509Certificate)v15_1));
                try {
                    v5_2 = CertPathValidatorUtilities.getNextWorkingKey(arg27.getCertificates(), v4);
                }
                catch(CertPathValidatorException v2_4) {
                    throw new CertPathValidatorException("Next working key could not be retrieved.", ((Throwable)v2_4), arg27, v4);
                }

                AlgorithmIdentifier v2_6 = CertPathValidatorUtilities.getAlgorithmIdentifier(v5_2);
                v2_6.getObjectId();
                v2_6.getParameters();
                v2_1 = v3_2;
                v3_2 = v6;
                v6 = v8_2;
                Object v8_3 = v15_1;
            }
            else {
                v3_2 = v17;
                v6 = v18;
                v9_1 = v2_2;
                v2_1 = v16;
            }

            --v4;
            v16 = v2_1;
            v17 = v3_2;
            v18 = v6;
            v12 = v9_1;
        }

        v3_2 = RFC3280CertPathUtilities.wrapupCertB(arg27, v4 + 1, RFC3280CertPathUtilities.wrapupCertA(v18, v15));
        v5_3 = v15.getCriticalExtensionOIDs();
        if(v5_3 != null) {
            v2_5 = new HashSet(((Collection)v5_3));
            ((Set)v2_5).remove(RFC3280CertPathUtilities.KEY_USAGE);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.CERTIFICATE_POLICIES);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.POLICY_MAPPINGS);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.INHIBIT_ANY_POLICY);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.DELTA_CRL_INDICATOR);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.POLICY_CONSTRAINTS);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.BASIC_CONSTRAINTS);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.SUBJECT_ALTERNATIVE_NAME);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.NAME_CONSTRAINTS);
            ((Set)v2_5).remove(RFC3280CertPathUtilities.CRL_DISTRIBUTION_POINTS);
        }
        else {
            v2_5 = new HashSet();
        }

        RFC3280CertPathUtilities.wrapupCertF(arg27, v4 + 1, v24, ((Set)v2_5));
        v2_2 = RFC3280CertPathUtilities.wrapupCertG(arg27, ((CertPathParameters)v28), v21, v4 + 1, v13, v12, ((Set)v11));
        if(v3_2 <= 0 && v2_2 == null) {
            throw new CertPathValidatorException("Path processing failed on policy.", null, arg27, v4);
        }

        return new PKIXCertPathValidatorResult(v22, ((PolicyNode)v2_2), v15.getPublicKey());
    }
}

