// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.math.BigInteger;
import java.security.GeneralSecurityException;
import java.security.PublicKey;
import java.security.cert.CertPath;
import java.security.cert.CertPathBuilder;
import java.security.cert.CertPathBuilderException;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidatorException;
import java.security.cert.CertSelector;
import java.security.cert.Certificate;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.PKIXParameters;
import java.security.cert.PolicyNode;
import java.security.cert.X509CRL;
import java.security.cert.X509Certificate;
import java.security.cert.X509Extension;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.BasicConstraints;
import org.bouncycastle.asn1.x509.CRLDistPoint;
import org.bouncycastle.asn1.x509.DistributionPoint;
import org.bouncycastle.asn1.x509.DistributionPointName;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.GeneralSubtree;
import org.bouncycastle.asn1.x509.IssuingDistributionPoint;
import org.bouncycastle.asn1.x509.NameConstraints;
import org.bouncycastle.asn1.x509.PolicyInformation;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.asn1.x509.X509Name;
import org.bouncycastle.jce.exception.ExtCertPathValidatorException;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.x509.ExtendedPKIXBuilderParameters;
import org.bouncycastle.x509.ExtendedPKIXParameters;
import org.bouncycastle.x509.X509CRLStoreSelector;
import org.bouncycastle.x509.X509CertStoreSelector;

public class RFC3280CertPathUtilities {
    public static final String ANY_POLICY = "2.5.29.32.0";
    public static final String AUTHORITY_KEY_IDENTIFIER = null;
    public static final String CRL_NUMBER = null;
    protected static final int CRL_SIGN = 6;
    private static final PKIXCRLUtil CRL_UTIL = null;
    public static final String FRESHEST_CRL = null;
    protected static final int KEY_CERT_SIGN = 5;
    protected static final String[] crlReasons;

    static {
        RFC3280CertPathUtilities.CRL_UTIL = new PKIXCRLUtil();
        RFC3280CertPathUtilities.CERTIFICATE_POLICIES = X509Extensions.CertificatePolicies.getId();
        RFC3280CertPathUtilities.POLICY_MAPPINGS = X509Extensions.PolicyMappings.getId();
        RFC3280CertPathUtilities.INHIBIT_ANY_POLICY = X509Extensions.InhibitAnyPolicy.getId();
        RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT = X509Extensions.IssuingDistributionPoint.getId();
        RFC3280CertPathUtilities.FRESHEST_CRL = X509Extensions.FreshestCRL.getId();
        RFC3280CertPathUtilities.DELTA_CRL_INDICATOR = X509Extensions.DeltaCRLIndicator.getId();
        RFC3280CertPathUtilities.POLICY_CONSTRAINTS = X509Extensions.PolicyConstraints.getId();
        RFC3280CertPathUtilities.BASIC_CONSTRAINTS = X509Extensions.BasicConstraints.getId();
        RFC3280CertPathUtilities.CRL_DISTRIBUTION_POINTS = X509Extensions.CRLDistributionPoints.getId();
        RFC3280CertPathUtilities.SUBJECT_ALTERNATIVE_NAME = X509Extensions.SubjectAlternativeName.getId();
        RFC3280CertPathUtilities.NAME_CONSTRAINTS = X509Extensions.NameConstraints.getId();
        RFC3280CertPathUtilities.AUTHORITY_KEY_IDENTIFIER = X509Extensions.AuthorityKeyIdentifier.getId();
        RFC3280CertPathUtilities.KEY_USAGE = X509Extensions.KeyUsage.getId();
        RFC3280CertPathUtilities.CRL_NUMBER = X509Extensions.CRLNumber.getId();
        RFC3280CertPathUtilities.crlReasons = new String[]{"unspecified", "keyCompromise", "cACompromise", "affiliationChanged", "superseded", "cessationOfOperation", "certificateHold", "unknown", "removeFromCRL", "privilegeWithdrawn", "aACompromise"};
    }

    public RFC3280CertPathUtilities() {
        super();
    }

    private static void checkCRL(DistributionPoint arg12, ExtendedPKIXParameters arg13, X509Certificate arg14, Date arg15, X509Certificate arg16, PublicKey arg17, CertStatus arg18, ReasonsMask arg19, List arg20) {
        Date v9 = new Date(System.currentTimeMillis());
        if(arg15.getTime() > v9.getTime()) {
            throw new AnnotatedException("Validation time is in future.");
        }

        Iterator v10 = CertPathValidatorUtilities.getCompleteCRLs(arg12, arg14, v9, arg13).iterator();
        AnnotatedException v7 = null;
        int v8 = 0;
    label_16:
        while(v10.hasNext()) {
            if(arg18.getCertStatus() != 11) {
                break;
            }

            if(arg19.isAllReasons()) {
                break;
            }

            try {
                Object v1_1 = v10.next();
                ReasonsMask v11 = RFC3280CertPathUtilities.processCRLD(((X509CRL)v1_1), arg12);
                if(!v11.hasNewReasons(arg19)) {
                    continue;
                }

                PublicKey v3 = RFC3280CertPathUtilities.processCRLG(((X509CRL)v1_1), RFC3280CertPathUtilities.processCRLF(((X509CRL)v1_1), arg14, arg16, arg17, arg13, arg20));
                X509CRL v2 = null;
                if(arg13.isUseDeltasEnabled()) {
                    v2 = RFC3280CertPathUtilities.processCRLH(CertPathValidatorUtilities.getDeltaCRLs(v9, arg13, ((X509CRL)v1_1)), v3);
                }

                if(arg13.getValidityModel() != 1 && arg14.getNotAfter().getTime() < ((X509CRL)v1_1).getThisUpdate().getTime()) {
                    throw new AnnotatedException("No valid CRL for current time found.");
                }

                RFC3280CertPathUtilities.processCRLB1(arg12, arg14, ((X509CRL)v1_1));
                RFC3280CertPathUtilities.processCRLB2(arg12, arg14, ((X509CRL)v1_1));
                RFC3280CertPathUtilities.processCRLC(v2, ((X509CRL)v1_1), arg13);
                RFC3280CertPathUtilities.processCRLI(arg15, v2, arg14, arg18, arg13);
                RFC3280CertPathUtilities.processCRLJ(arg15, ((X509CRL)v1_1), arg14, arg18);
                if(arg18.getCertStatus() == 8) {
                    arg18.setCertStatus(11);
                }

                arg19.addReasons(v11);
                Set v1_2 = ((X509CRL)v1_1).getCriticalExtensionOIDs();
                if(v1_2 != null) {
                    HashSet v3_1 = new HashSet(((Collection)v1_2));
                    ((Set)v3_1).remove(X509Extensions.IssuingDistributionPoint.getId());
                    ((Set)v3_1).remove(X509Extensions.DeltaCRLIndicator.getId());
                    if(!((Set)v3_1).isEmpty()) {
                        throw new AnnotatedException("CRL contains unsupported critical extensions.");
                    }
                }

                if(v2 != null) {
                    v1_2 = v2.getCriticalExtensionOIDs();
                    if(v1_2 != null) {
                        HashSet v2_1 = new HashSet(((Collection)v1_2));
                        ((Set)v2_1).remove(X509Extensions.IssuingDistributionPoint.getId());
                        ((Set)v2_1).remove(X509Extensions.DeltaCRLIndicator.getId());
                        if(!((Set)v2_1).isEmpty()) {
                            throw new AnnotatedException("Delta CRL contains unsupported critical extension.");
                        }
                    }
                }
            }
            catch(AnnotatedException v1) {
                goto label_53;
            }

            v8 = 1;
        }

        if(v8 == 0) {
            throw v7;
        }

        return;
    label_53:
        v7 = v1;
        goto label_16;
    }

    protected static void checkCRLs(ExtendedPKIXParameters arg13, X509Certificate arg14, Date arg15, X509Certificate arg16, PublicKey arg17, List arg18) {
        ASN1Primitive v1_2;
        AnnotatedException v1_1;
        int v0_3;
        DistributionPoint[] v12;
        CRLDistPoint v0_1;
        AnnotatedException v10 = null;
        try {
            v0_1 = CRLDistPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg14), RFC3280CertPathUtilities.CRL_DISTRIBUTION_POINTS));
        }
        catch(Exception v0) {
            throw new AnnotatedException("CRL distribution point extension could not be read.", ((Throwable)v0));
        }

        try {
            CertPathValidatorUtilities.addAdditionalStoresFromCRLDistributionPoint(v0_1, arg13);
        }
        catch(AnnotatedException v0_2) {
            throw new AnnotatedException("No additional CRL locations could be decoded from CRL distribution point extension.", ((Throwable)v0_2));
        }

        CertStatus v6 = new CertStatus();
        ReasonsMask v7 = new ReasonsMask();
        int v9 = 0;
        if(v0_1 != null) {
            try {
                v12 = v0_1.getDistributionPoints();
                if(v12 == null) {
                    goto label_56;
                }
            }
            catch(Exception v0) {
                throw new AnnotatedException("Distribution points could not be read.", ((Throwable)v0));
            }

            int v11 = 0;
            while(v11 < v12.length) {
                if(v6.getCertStatus() != 11) {
                    break;
                }

                if(v7.isAllReasons()) {
                    break;
                }

                Object v1 = arg13.clone();
                try {
                    RFC3280CertPathUtilities.checkCRL(v12[v11], ((ExtendedPKIXParameters)v1), arg14, arg15, arg16, arg17, v6, v7, arg18);
                    v0_3 = 1;
                    v1_1 = v10;
                }
                catch(AnnotatedException v0_2) {
                    v1_1 = v0_2;
                    v0_3 = v9;
                }

                ++v11;
                v9 = v0_3;
                v10 = v1_1;
            }
        }

    label_56:
        if(v6.getCertStatus() == 11 && !v7.isAllReasons()) {
            try {
                v1_2 = new ASN1InputStream(CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg14).getEncoded()).readObject();
                goto label_66;
            }
            catch(Exception v0) {
                try {
                    throw new AnnotatedException("Issuer from certificate for CRL could not be reencoded.", ((Throwable)v0));
                label_66:
                    RFC3280CertPathUtilities.checkCRL(new DistributionPoint(new DistributionPointName(0, new GeneralNames(new GeneralName(4, ((ASN1Encodable)v1_2)))), null, null), arg13.clone(), arg14, arg15, arg16, arg17, v6, v7, arg18);
                    v9 = 1;
                }
                catch(AnnotatedException v0_2) {
                    v10 = v0_2;
                }
            }
        }

        if(v9 == 0) {
            if((v10 instanceof AnnotatedException)) {
                throw v10;
            }

            throw new AnnotatedException("No valid CRL found.", ((Throwable)v10));
        }

        if(v6.getCertStatus() != 11) {
            throw new AnnotatedException("Certificate revocation after " + v6.getRevocationDate() + ", reason: " + RFC3280CertPathUtilities.crlReasons[v6.getCertStatus()]);
        }

        if(!v7.isAllReasons() && v6.getCertStatus() == 11) {
            v6.setCertStatus(12);
        }

        if(v6.getCertStatus() == 12) {
            throw new AnnotatedException("Certificate status could not be determined.");
        }
    }

    protected static PKIXPolicyNode prepareCertB(CertPath arg12, int arg13, List[] arg14, PKIXPolicyNode arg15, int arg16) {
        PolicyInformation v3_2;
        Enumeration v1_3;
        Object v0_3;
        Iterator v3_1;
        Object v6_1;
        ASN1Sequence v4;
        List v1 = arg12.getCertificates();
        Object v8 = v1.get(arg13);
        int v2 = v1.size() - arg13;
        try {
            v4 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v8), RFC3280CertPathUtilities.POLICY_MAPPINGS));
            if(v4 == null) {
                return arg15;
            }
        }
        catch(AnnotatedException v0) {
            throw new ExtCertPathValidatorException("Policy mappings extension could not be decoded.", ((Throwable)v0), arg12, arg13);
        }

        HashMap v9 = new HashMap();
        HashSet v5 = new HashSet();
        int v3;
        for(v3 = 0; v3 < v4.size(); ++v3) {
            ASN1Encodable v0_1 = v4.getObjectAt(v3);
            String v1_1 = ((ASN1Sequence)v0_1).getObjectAt(0).getId();
            String v6 = ((ASN1Sequence)v0_1).getObjectAt(1).getId();
            if(!((Map)v9).containsKey(v1_1)) {
                HashSet v0_2 = new HashSet();
                ((Set)v0_2).add(v6);
                ((Map)v9).put(v1_1, v0_2);
                ((Set)v5).add(v1_1);
            }
            else {
                ((Map)v9).get(v1_1).add(v6);
            }
        }

        Iterator v10 = ((Set)v5).iterator();
        do {
        label_43:
            if(!v10.hasNext()) {
                return arg15;
            }

            v6_1 = v10.next();
            if(arg16 > 0) {
                v3_1 = arg14[v2].iterator();
                goto label_50;
            }
        }
        while(arg16 > 0);

        Iterator v5_1 = arg14[v2].iterator();
        goto label_123;
        do {
        label_50:
            if(v3_1.hasNext()) {
                v0_3 = v3_1.next();
                if(!((PKIXPolicyNode)v0_3).getValidPolicy().equals(v6_1)) {
                    continue;
                }

                break;
            }
            else {
                goto label_157;
            }
        }
        while(true);

        ((PKIXPolicyNode)v0_3).expectedPolicies = ((Map)v9).get(v6_1);
        int v0_4 = 1;
        goto label_60;
    label_157:
        v0_4 = 0;
    label_60:
        if(v0_4 != 0) {
            goto label_43;
        }

        Iterator v1_2 = arg14[v2].iterator();
        do {
            if(!v1_2.hasNext()) {
                goto label_43;
            }

            v0_3 = v1_2.next();
        }
        while(!"2.5.29.32.0".equals(((PKIXPolicyNode)v0_3).getValidPolicy()));

        Set v5_2 = null;
        try {
            v1_3 = CertPathValidatorUtilities.getExtensionValue(((X509Extension)v8), RFC3280CertPathUtilities.CERTIFICATE_POLICIES).getObjects();
        }
        catch(AnnotatedException v0) {
            throw new ExtCertPathValidatorException("Certificate policies extension could not be decoded.", ((Throwable)v0), arg12, arg13);
        }

        do {
            if(v1_3.hasMoreElements()) {
                try {
                    v3_2 = PolicyInformation.getInstance(v1_3.nextElement());
                }
                catch(Exception v0_5) {
                    throw new CertPathValidatorException("Policy information could not be decoded.", ((Throwable)v0_5), arg12, arg13);
                }

                if(!"2.5.29.32.0".equals(v3_2.getPolicyIdentifier().getId())) {
                    continue;
                }

                break;
            }

            goto label_85;
        }
        while(true);

        try {
            v5_2 = CertPathValidatorUtilities.getQualifierSet(v3_2.getPolicyQualifiers());
        }
        catch(CertPathValidatorException v0_6) {
            throw new ExtCertPathValidatorException("Policy qualifier info set could not be decoded.", ((Throwable)v0_6), arg12, arg13);
        }

    label_85:
        boolean v7 = false;
        if(((X509Certificate)v8).getCriticalExtensionOIDs() != null) {
            v7 = ((X509Certificate)v8).getCriticalExtensionOIDs().contains(RFC3280CertPathUtilities.CERTIFICATE_POLICIES);
        }

        PolicyNode v4_1 = ((PKIXPolicyNode)v0_3).getParent();
        if(!"2.5.29.32.0".equals(((PKIXPolicyNode)v4_1).getValidPolicy())) {
            goto label_43;
        }

        PKIXPolicyNode v0_7 = new PKIXPolicyNode(new ArrayList(), v2, ((Map)v9).get(v6_1), v4_1, v5_2, ((String)v6_1), v7);
        ((PKIXPolicyNode)v4_1).addChild(v0_7);
        arg14[v2].add(v0_7);
        goto label_43;
        do {
        label_123:
            if(!v5_1.hasNext()) {
                goto label_43;
            }

            v0_3 = v5_1.next();
        }
        while(!((PKIXPolicyNode)v0_3).getValidPolicy().equals(v6_1));

        ((PKIXPolicyNode)v0_3).getParent().removeChild(((PKIXPolicyNode)v0_3));
        v5_1.remove();
        int v4_2 = v2 - 1;
        PKIXPolicyNode v1_4;
        for(v1_4 = arg15; v4_2 >= 0; v1_4 = v3_3) {
            List v7_1 = arg14[v4_2];
            PKIXPolicyNode v3_3 = v1_4;
            int v1_5;
            for(v1_5 = 0; v1_5 < v7_1.size(); ++v1_5) {
                v0_3 = v7_1.get(v1_5);
                if(!((PKIXPolicyNode)v0_3).hasChildren()) {
                    v3_3 = CertPathValidatorUtilities.removePolicyNode(v3_3, arg14, ((PKIXPolicyNode)v0_3));
                    if(v3_3 != null) {
                        goto label_151;
                    }

                    break;
                }

            label_151:
            }

            --v4_2;
        }

        arg15 = v1_4;
        goto label_123;
        return arg15;
    }

    protected static void prepareNextCertA(CertPath arg6, int arg7) {
        ASN1Sequence v2;
        Throwable v5 = null;
        Object v0 = arg6.getCertificates().get(arg7);
        try {
            v2 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.POLICY_MAPPINGS));
            if(v2 == null) {
                return;
            }
        }
        catch(AnnotatedException v0_1) {
            throw new ExtCertPathValidatorException("Policy mappings extension could not be decoded.", ((Throwable)v0_1), arg6, arg7);
        }

        int v0_2 = 0;
        while(v0_2 < v2.size()) {
            try {
                ASN1Sequence v1 = DERSequence.getInstance(v2.getObjectAt(v0_2));
                ASN1ObjectIdentifier v3 = DERObjectIdentifier.getInstance(v1.getObjectAt(0));
                ASN1ObjectIdentifier v1_1 = DERObjectIdentifier.getInstance(v1.getObjectAt(1));
            }
            catch(Exception v0_3) {
                throw new ExtCertPathValidatorException("Policy mappings extension contents could not be decoded.", ((Throwable)v0_3), arg6, arg7);
            }

            if("2.5.29.32.0".equals(((DERObjectIdentifier)v3).getId())) {
                throw new CertPathValidatorException("IssuerDomainPolicy is anyPolicy", v5, arg6, arg7);
            }
            else if("2.5.29.32.0".equals(((DERObjectIdentifier)v1_1).getId())) {
                throw new CertPathValidatorException("SubjectDomainPolicy is anyPolicy,", v5, arg6, arg7);
            }
            else {
                ++v0_2;
                continue;
            }

            return;
        }
    }

    protected static void prepareNextCertG(CertPath arg3, int arg4, PKIXNameConstraintValidator arg5) {
        NameConstraints v0_3;
        Object v0 = arg3.getCertificates().get(arg4);
        NameConstraints v1 = null;
        try {
            ASN1Sequence v0_2 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.NAME_CONSTRAINTS));
            if(v0_2 != null) {
                v0_3 = NameConstraints.getInstance(v0_2);
            }
            else {
                goto label_37;
            }

            goto label_8;
        }
        catch(Exception v0_1) {
            throw new ExtCertPathValidatorException("Name constraints extension could not be decoded.", ((Throwable)v0_1), arg3, arg4);
        }

    label_37:
        v0_3 = v1;
    label_8:
        if(v0_3 != null) {
            GeneralSubtree[] v1_1 = v0_3.getPermittedSubtrees();
            if(v1_1 != null) {
                try {
                    arg5.intersectPermittedSubtree(v1_1);
                }
                catch(Exception v0_1) {
                    throw new ExtCertPathValidatorException("Permitted subtrees cannot be build from name constraints extension.", ((Throwable)v0_1), arg3, arg4);
                }
            }

            v1_1 = v0_3.getExcludedSubtrees();
            if(v1_1 == null) {
                return;
            }

            int v0_4 = 0;
            while(v0_4 != v1_1.length) {
                try {
                    arg5.addExcludedSubtree(v1_1[v0_4]);
                    ++v0_4;
                    continue;
                }
                catch(Exception v0_1) {
                    throw new ExtCertPathValidatorException("Excluded subtrees cannot be build from name constraints extension.", ((Throwable)v0_1), arg3, arg4);
                }
            }
        }
    }

    protected static int prepareNextCertH1(CertPath arg1, int arg2, int arg3) {
        if(!CertPathValidatorUtilities.isSelfIssued(arg1.getCertificates().get(arg2)) && arg3 != 0) {
            --arg3;
        }

        return arg3;
    }

    protected static int prepareNextCertH2(CertPath arg1, int arg2, int arg3) {
        if(!CertPathValidatorUtilities.isSelfIssued(arg1.getCertificates().get(arg2)) && arg3 != 0) {
            --arg3;
        }

        return arg3;
    }

    protected static int prepareNextCertH3(CertPath arg1, int arg2, int arg3) {
        if(!CertPathValidatorUtilities.isSelfIssued(arg1.getCertificates().get(arg2)) && arg3 != 0) {
            --arg3;
        }

        return arg3;
    }

    protected static int prepareNextCertI1(CertPath arg3, int arg4, int arg5) {
        int v0_5;
        ASN1Sequence v0_2;
        Object v0 = arg3.getCertificates().get(arg4);
        try {
            v0_2 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.POLICY_CONSTRAINTS));
            if(v0_2 == null) {
                return arg5;
            }
        }
        catch(Exception v0_1) {
            throw new ExtCertPathValidatorException("Policy constraints extension cannot be decoded.", ((Throwable)v0_1), arg3, arg4);
        }

        Enumeration v0_3 = v0_2.getObjects();
        do {
            if(v0_3.hasMoreElements()) {
                try {
                    ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0_3.nextElement());
                    if(v1.getTagNo() != 0) {
                        continue;
                    }

                    v0_5 = DERInteger.getInstance(v1, false).getValue().intValue();
                    if(v0_5 >= arg5) {
                        return arg5;
                    }

                    return v0_5;
                }
                catch(IllegalArgumentException v0_4) {
                    throw new ExtCertPathValidatorException("Policy constraints extension contents cannot be decoded.", ((Throwable)v0_4), arg3, arg4);
                }
            }

            return arg5;
        }
        while(true);

        return v0_5;
    }

    protected static int prepareNextCertI2(CertPath arg4, int arg5, int arg6) {
        int v0_5;
        ASN1Sequence v0_2;
        Object v0 = arg4.getCertificates().get(arg5);
        try {
            v0_2 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.POLICY_CONSTRAINTS));
            if(v0_2 == null) {
                return arg6;
            }
        }
        catch(Exception v0_1) {
            throw new ExtCertPathValidatorException("Policy constraints extension cannot be decoded.", ((Throwable)v0_1), arg4, arg5);
        }

        Enumeration v0_3 = v0_2.getObjects();
        do {
            if(v0_3.hasMoreElements()) {
                try {
                    ASN1TaggedObject v1 = ASN1TaggedObject.getInstance(v0_3.nextElement());
                    if(v1.getTagNo() != 1) {
                        continue;
                    }

                    v0_5 = DERInteger.getInstance(v1, false).getValue().intValue();
                    if(v0_5 >= arg6) {
                        return arg6;
                    }

                    return v0_5;
                }
                catch(IllegalArgumentException v0_4) {
                    throw new ExtCertPathValidatorException("Policy constraints extension contents cannot be decoded.", ((Throwable)v0_4), arg4, arg5);
                }
            }

            return arg6;
        }
        while(true);

        return v0_5;
    }

    protected static int prepareNextCertJ(CertPath arg3, int arg4, int arg5) {
        ASN1Integer v0_2;
        Object v0 = arg3.getCertificates().get(arg4);
        try {
            v0_2 = DERInteger.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.INHIBIT_ANY_POLICY));
            if(v0_2 == null) {
                return arg5;
            }
        }
        catch(Exception v0_1) {
            throw new ExtCertPathValidatorException("Inhibit any-policy extension cannot be decoded.", ((Throwable)v0_1), arg3, arg4);
        }

        int v0_3 = ((DERInteger)v0_2).getValue().intValue();
        if(v0_3 < arg5) {
            arg5 = v0_3;
        }

        return arg5;
    }

    protected static void prepareNextCertK(CertPath arg3, int arg4) {
        Object v0 = arg3.getCertificates().get(arg4);
        try {
            BasicConstraints v0_2 = BasicConstraints.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.BASIC_CONSTRAINTS));
            if(v0_2 == null) {
                goto label_17;
            }
        }
        catch(Exception v0_1) {
            throw new ExtCertPathValidatorException("Basic constraints extension cannot be decoded.", ((Throwable)v0_1), arg3, arg4);
        }

        if(!v0_2.isCA()) {
            throw new CertPathValidatorException("Not a CA certificate");
        }

        return;
    label_17:
        throw new CertPathValidatorException("Intermediate certificate lacks BasicConstraints");
    }

    protected static int prepareNextCertL(CertPath arg3, int arg4, int arg5) {
        if(!CertPathValidatorUtilities.isSelfIssued(arg3.getCertificates().get(arg4))) {
            if(arg5 <= 0) {
                throw new ExtCertPathValidatorException("Max path length not greater than zero", null, arg3, arg4);
            }
            else {
                --arg5;
            }
        }

        return arg5;
    }

    protected static int prepareNextCertM(CertPath arg3, int arg4, int arg5) {
        BasicConstraints v0_2;
        Object v0 = arg3.getCertificates().get(arg4);
        try {
            v0_2 = BasicConstraints.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.BASIC_CONSTRAINTS));
            if(v0_2 == null) {
                return arg5;
            }
        }
        catch(Exception v0_1) {
            throw new ExtCertPathValidatorException("Basic constraints extension cannot be decoded.", ((Throwable)v0_1), arg3, arg4);
        }

        BigInteger v0_3 = v0_2.getPathLenConstraint();
        if(v0_3 != null) {
            int v0_4 = v0_3.intValue();
            if(v0_4 < arg5) {
                arg5 = v0_4;
            }
        }

        return arg5;
    }

    protected static void prepareNextCertN(CertPath arg3, int arg4) {
        boolean[] v0 = arg3.getCertificates().get(arg4).getKeyUsage();
        if(v0 != null && !v0[5]) {
            throw new ExtCertPathValidatorException("Issuer certificate keyusage extension is critical and does not permit key signing.", null, arg3, arg4);
        }
    }

    protected static void prepareNextCertO(CertPath arg3, int arg4, Set arg5, List arg6) {
        Object v0 = arg3.getCertificates().get(arg4);
        Iterator v2 = arg6.iterator();
        while(v2.hasNext()) {
            try {
                v2.next().check(((Certificate)v0), ((Collection)arg5));
                continue;
            }
            catch(CertPathValidatorException v0_1) {
                throw new CertPathValidatorException(v0_1.getMessage(), v0_1.getCause(), arg3, arg4);
            }
        }

        if(!arg5.isEmpty()) {
            throw new ExtCertPathValidatorException("Certificate has unsupported critical extension: " + arg5, null, arg3, arg4);
        }
    }

    protected static Set processCRLA1i(Date arg3, ExtendedPKIXParameters arg4, X509Certificate arg5, X509CRL arg6) {
        CRLDistPoint v0_1;
        HashSet v1 = new HashSet();
        if(arg4.isUseDeltasEnabled()) {
            try {
                v0_1 = CRLDistPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg5), RFC3280CertPathUtilities.FRESHEST_CRL));
                if(v0_1 != null) {
                    goto label_11;
                }
            }
            catch(AnnotatedException v0) {
                throw new AnnotatedException("Freshest CRL extension could not be decoded from certificate.", ((Throwable)v0));
            }

            try {
                v0_1 = CRLDistPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg6), RFC3280CertPathUtilities.FRESHEST_CRL));
            }
            catch(AnnotatedException v0) {
                throw new AnnotatedException("Freshest CRL extension could not be decoded from CRL.", ((Throwable)v0));
            }

        label_11:
            if(v0_1 == null) {
                goto label_15;
            }

            try {
                CertPathValidatorUtilities.addAdditionalStoresFromCRLDistributionPoint(v0_1, arg4);
            }
            catch(AnnotatedException v0) {
                throw new AnnotatedException("No new delta CRL locations could be added from Freshest CRL extension.", ((Throwable)v0));
            }

            try {
                ((Set)v1).addAll(CertPathValidatorUtilities.getDeltaCRLs(arg3, arg4, arg6));
            }
            catch(AnnotatedException v0) {
                throw new AnnotatedException("Exception obtaining delta CRLs.", ((Throwable)v0));
            }
        }

    label_15:
        return ((Set)v1);
    }

    protected static Set[] processCRLA1ii(Date arg5, ExtendedPKIXParameters arg6, X509Certificate arg7, X509CRL arg8) {
        HashSet v0 = new HashSet();
        X509CRLStoreSelector v1 = new X509CRLStoreSelector();
        v1.setCertificateChecking(arg7);
        try {
            v1.addIssuerName(arg8.getIssuerX500Principal().getEncoded());
        }
        catch(IOException v0_1) {
            throw new AnnotatedException("Cannot extract issuer from CRL." + v0_1, ((Throwable)v0_1));
        }

        v1.setCompleteCRLEnabled(true);
        Set v1_1 = RFC3280CertPathUtilities.CRL_UTIL.findCRLs(v1, arg6, arg5);
        if(arg6.isUseDeltasEnabled()) {
            try {
                ((Set)v0).addAll(CertPathValidatorUtilities.getDeltaCRLs(arg5, arg6, arg8));
            }
            catch(AnnotatedException v0_2) {
                throw new AnnotatedException("Exception obtaining delta CRLs.", ((Throwable)v0_2));
            }
        }

        return new Set[]{v1_1, v0};
    }

    protected static void processCRLB1(DistributionPoint arg8, Object arg9, X509CRL arg10) {
        int v3;
        int v2 = 0;
        ASN1Primitive v0 = CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg10), RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT);
        int v0_1 = v0 == null || !IssuingDistributionPoint.getInstance(v0).isIndirectCRL() ? 0 : 1;
        byte[] v4 = CertPathValidatorUtilities.getIssuerPrincipal(arg10).getEncoded();
        if(arg8.getCRLIssuer() != null) {
            GeneralName[] v5 = arg8.getCRLIssuer().getNames();
            v3 = 0;
            while(v2 < v5.length) {
                if(v5[v2].getTagNo() == 4) {
                    try {
                        if(!Arrays.areEqual(v5[v2].getName().toASN1Primitive().getEncoded(), v4)) {
                            goto label_29;
                        }
                    }
                    catch(IOException v0_2) {
                        throw new AnnotatedException("CRL issuer information from distribution point cannot be decoded.", ((Throwable)v0_2));
                    }

                    v3 = 1;
                }

            label_29:
                ++v2;
            }

            if(v3 != 0 && v0_1 == 0) {
                throw new AnnotatedException("Distribution point contains cRLIssuer field but CRL is not indirect.");
            }

            if(v3 != 0) {
                goto label_52;
            }

            throw new AnnotatedException("CRL issuer of CRL does not match CRL issuer of distribution point.");
        }
        else {
            if(CertPathValidatorUtilities.getIssuerPrincipal(arg10).equals(CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg9))) {
                v3 = 1;
                goto label_52;
            }

            v3 = 0;
        }

    label_52:
        if(v3 == 0) {
            throw new AnnotatedException("Cannot find matching CRL issuer for certificate.");
        }
    }

    protected static void processCRLB2(DistributionPoint arg12, Object arg13, X509CRL arg14) {
        GeneralName[] v3_1;
        IssuingDistributionPoint v6;
        int v2 = 0;
        try {
            v6 = IssuingDistributionPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg14), RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT));
            if(v6 == null) {
                return;
            }
        }
        catch(Exception v1) {
            throw new AnnotatedException("Issuing distribution point extension could not be decoded.", ((Throwable)v1));
        }

        if(v6.getDistributionPoint() != null) {
            DistributionPointName v3 = IssuingDistributionPoint.getInstance(v6).getDistributionPoint();
            ArrayList v7 = new ArrayList();
            if(v3.getType() == 0) {
                GeneralName[] v4 = GeneralNames.getInstance(v3.getName()).getNames();
                int v1_1;
                for(v1_1 = 0; v1_1 < v4.length; ++v1_1) {
                    ((List)v7).add(v4[v1_1]);
                }
            }

            if(v3.getType() == 1) {
                ASN1EncodableVector v4_1 = new ASN1EncodableVector();
                try {
                    Enumeration v8 = ASN1Sequence.getInstance(ASN1Sequence.fromByteArray(CertPathValidatorUtilities.getIssuerPrincipal(arg14).getEncoded())).getObjects();
                    while(v8.hasMoreElements()) {
                        v4_1.add(v8.nextElement());
                    }
                }
                catch(IOException v1_2) {
                    goto label_47;
                }

                v4_1.add(v3.getName());
                ((List)v7).add(new GeneralName(X509Name.getInstance(new DERSequence(v4_1))));
                goto label_56;
            label_47:
                throw new AnnotatedException("Could not read CRL issuer.", ((Throwable)v1_2));
            }

        label_56:
            if(arg12.getDistributionPoint() != null) {
                DistributionPointName v8_1 = arg12.getDistributionPoint();
                GeneralName[] v1_3 = null;
                if(v8_1.getType() == 0) {
                    v1_3 = GeneralNames.getInstance(v8_1.getName()).getNames();
                }

                if(v8_1.getType() == 1) {
                    if(arg12.getCRLIssuer() != null) {
                        v3_1 = arg12.getCRLIssuer().getNames();
                    }
                    else {
                        v3_1 = new GeneralName[1];
                        try {
                            v3_1[0] = new GeneralName(new X509Name(ASN1Sequence.fromByteArray(CertPathValidatorUtilities.getEncodedIssuerPrincipal(arg13).getEncoded())));
                        }
                        catch(IOException v1_2) {
                            throw new AnnotatedException("Could not read certificate issuer.", ((Throwable)v1_2));
                        }
                    }

                    int v4_2;
                    for(v4_2 = 0; v4_2 < v3_1.length; ++v4_2) {
                        Enumeration v9 = ASN1Sequence.getInstance(v3_1[v4_2].getName().toASN1Primitive()).getObjects();
                        ASN1EncodableVector v10 = new ASN1EncodableVector();
                        while(v9.hasMoreElements()) {
                            v10.add(v9.nextElement());
                        }

                        v10.add(v8_1.getName());
                        v3_1[v4_2] = new GeneralName(new X509Name(new DERSequence(v10)));
                    }
                }
                else {
                    v3_1 = v1_3;
                }

                if(v3_1 != null) {
                    v1_1 = 0;
                    while(v1_1 < v3_1.length) {
                        if(((List)v7).contains(v3_1[v1_1])) {
                            v2 = 1;
                        }
                        else {
                            ++v1_1;
                            continue;
                        }

                        break;
                    }
                }

                if(v2 != 0) {
                    goto label_153;
                }

                throw new AnnotatedException("No match for certificate CRL issuing distribution point name to cRLIssuer CRL distribution point.");
            }

            if(arg12.getCRLIssuer() == null) {
                throw new AnnotatedException("Either the cRLIssuer or the distributionPoint field must be contained in DistributionPoint.");
            }

            v3_1 = arg12.getCRLIssuer().getNames();
            v1_1 = 0;
            while(v1_1 < v3_1.length) {
                if(((List)v7).contains(v3_1[v1_1])) {
                    v2 = 1;
                }
                else {
                    ++v1_1;
                    continue;
                }

                break;
            }

            if(v2 != 0) {
                goto label_153;
            }

            throw new AnnotatedException("No match for certificate CRL issuing distribution point name to cRLIssuer CRL distribution point.");
        }

        try {
        label_153:
            BasicConstraints v1_4 = BasicConstraints.getInstance(CertPathValidatorUtilities.getExtensionValue(arg13, RFC3280CertPathUtilities.BASIC_CONSTRAINTS));
        }
        catch(Exception v1) {
            throw new AnnotatedException("Basic constraints extension could not be decoded.", ((Throwable)v1));
        }

        if((arg13 instanceof X509Certificate)) {
            if((v6.onlyContainsUserCerts()) && v1_4 != null && (v1_4.isCA())) {
                throw new AnnotatedException("CA Cert CRL only contains user certificates.");
            }

            if(!v6.onlyContainsCACerts()) {
                goto label_183;
            }

            if(v1_4 != null && (v1_4.isCA())) {
                goto label_183;
            }

            throw new AnnotatedException("End CRL only contains CA certificates.");
        }

    label_183:
        if(v6.onlyContainsAttributeCerts()) {
            throw new AnnotatedException("onlyContainsAttributeCerts boolean is asserted.");
        }
    }

    protected static void processCRLC(X509CRL arg4, X509CRL arg5, ExtendedPKIXParameters arg6) {
        int v0 = 1;
        if(arg4 != null) {
            try {
                IssuingDistributionPoint v2 = IssuingDistributionPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg5), RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT));
            }
            catch(Exception v0_1) {
                throw new AnnotatedException("Issuing distribution point extension could not be decoded.", ((Throwable)v0_1));
            }

            if(arg6.isUseDeltasEnabled()) {
                if(!arg4.getIssuerX500Principal().equals(arg5.getIssuerX500Principal())) {
                    throw new AnnotatedException("Complete CRL issuer does not match delta CRL issuer.");
                }
                else {
                    try {
                        IssuingDistributionPoint v3 = IssuingDistributionPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg4), RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT));
                        if(v2 != null) {
                            goto label_37;
                        }
                    }
                    catch(Exception v0_1) {
                        throw new AnnotatedException("Issuing distribution point extension from delta CRL could not be decoded.", ((Throwable)v0_1));
                    }

                    if(v3 != null) {
                        goto label_39;
                    }

                    goto label_27;
                label_37:
                    if(!v2.equals(v3)) {
                    label_39:
                        v0 = 0;
                    }

                label_27:
                    if(v0 == 0) {
                        throw new AnnotatedException("Issuing distribution point extension from delta CRL and complete CRL does not match.");
                    }

                    try {
                        ASN1Primitive v0_3 = CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg5), RFC3280CertPathUtilities.AUTHORITY_KEY_IDENTIFIER);
                    }
                    catch(AnnotatedException v0_2) {
                        throw new AnnotatedException("Authority key identifier extension could not be extracted from complete CRL.", ((Throwable)v0_2));
                    }

                    try {
                        ASN1Primitive v1 = CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg4), RFC3280CertPathUtilities.AUTHORITY_KEY_IDENTIFIER);
                        if(v0_3 != null) {
                            goto label_60;
                        }
                    }
                    catch(AnnotatedException v0_2) {
                        throw new AnnotatedException("Authority key identifier extension could not be extracted from delta CRL.", ((Throwable)v0_2));
                    }

                    throw new AnnotatedException("CRL authority key identifier is null.");
                label_60:
                    if(v1 == null) {
                        throw new AnnotatedException("Delta CRL authority key identifier is null.");
                    }

                    if(v0_3.equals(v1)) {
                        return;
                    }

                    throw new AnnotatedException("Delta CRL authority key identifier does not match complete CRL authority key identifier.");
                }
            }
        }
    }

    protected static ReasonsMask processCRLD(X509CRL arg3, DistributionPoint arg4) {
        ReasonsMask v0_1;
        IssuingDistributionPoint v2;
        try {
            v2 = IssuingDistributionPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg3), RFC3280CertPathUtilities.ISSUING_DISTRIBUTION_POINT));
            if(v2 == null) {
                goto label_21;
            }
        }
        catch(Exception v0) {
            throw new AnnotatedException("Issuing distribution point extension could not be decoded.", ((Throwable)v0));
        }

        if(v2.getOnlySomeReasons() == null || arg4.getReasons() == null) {
        label_21:
            if((v2 == null || v2.getOnlySomeReasons() == null) && arg4.getReasons() == null) {
                return ReasonsMask.allReasons;
            }

            ReasonsMask v1 = arg4.getReasons() == null ? ReasonsMask.allReasons : new ReasonsMask(arg4.getReasons());
            v0_1 = v2 == null ? ReasonsMask.allReasons : new ReasonsMask(v2.getOnlySomeReasons());
            v0_1 = v1.intersect(v0_1);
        }
        else {
            v0_1 = new ReasonsMask(arg4.getReasons()).intersect(new ReasonsMask(v2.getOnlySomeReasons()));
        }

        return v0_1;
    }

    protected static Set processCRLF(X509CRL arg8, Object arg9, X509Certificate arg10, PublicKey arg11, ExtendedPKIXParameters arg12, List arg13) {
        Collection v1;
        int v2 = 0;
        X509CertStoreSelector v0 = new X509CertStoreSelector();
        try {
            v0.setSubject(CertPathValidatorUtilities.getIssuerPrincipal(arg8).getEncoded());
        }
        catch(IOException v0_1) {
            throw new AnnotatedException("Subject criteria for certificate selector to find issuer certificate for CRL could not be set.", ((Throwable)v0_1));
        }

        try {
            v1 = CertPathValidatorUtilities.findCertificates(v0, arg12.getStores());
            v1.addAll(CertPathValidatorUtilities.findCertificates(v0, arg12.getAdditionalStores()));
            v1.addAll(CertPathValidatorUtilities.findCertificates(v0, arg12.getCertStores()));
        }
        catch(AnnotatedException v0_2) {
            throw new AnnotatedException("Issuer certificate for CRL cannot be searched.", ((Throwable)v0_2));
        }

        v1.add(arg10);
        Iterator v3 = v1.iterator();
        ArrayList v4 = new ArrayList();
        ArrayList v5 = new ArrayList();
        while(v3.hasNext()) {
            Object v0_3 = v3.next();
            if(((X509Certificate)v0_3).equals(arg10)) {
                ((List)v4).add(v0_3);
                ((List)v5).add(arg11);
                continue;
            }

            try {
                CertPathBuilder v6 = CertPathBuilder.getInstance("PKIX", "BC");
                X509CertStoreSelector v7 = new X509CertStoreSelector();
                v7.setCertificate(((X509Certificate)v0_3));
                Object v1_1 = arg12.clone();
                ((ExtendedPKIXParameters)v1_1).setTargetCertConstraints(((CertSelector)v7));
                ExtendedPKIXParameters v1_2 = ExtendedPKIXBuilderParameters.getInstance(((PKIXParameters)v1_1));
                if(arg13.contains(v0_3)) {
                    ((ExtendedPKIXBuilderParameters)v1_2).setRevocationEnabled(false);
                }
                else {
                    ((ExtendedPKIXBuilderParameters)v1_2).setRevocationEnabled(true);
                }

                List v1_3 = v6.build(((CertPathParameters)v1_2)).getCertPath().getCertificates();
                ((List)v4).add(v0_3);
                ((List)v5).add(CertPathValidatorUtilities.getNextWorkingKey(v1_3, 0));
                continue;
            }
            catch(Exception v0_4) {
                throw new RuntimeException(v0_4.getMessage());
            }
            catch(CertPathValidatorException v0_5) {
                throw new AnnotatedException("Public key of issuer certificate of CRL could not be retrieved.", ((Throwable)v0_5));
            }
            catch(CertPathBuilderException v0_6) {
                throw new AnnotatedException("Internal error.", ((Throwable)v0_6));
            }
        }

        HashSet v3_1 = new HashSet();
        AnnotatedException v1_4;
        for(v1_4 = null; v2 < ((List)v4).size(); v1_4 = v0_2) {
            boolean[] v0_7 = ((List)v4).get(v2).getKeyUsage();
            if(v0_7 != null) {
                if(v0_7.length >= 7 && (v0_7[6])) {
                    goto label_98;
                }

                v0_2 = new AnnotatedException("Issuer certificate key usage extension does not permit CRL signing.");
            }
            else {
            label_98:
                ((Set)v3_1).add(((List)v5).get(v2));
                v0_2 = v1_4;
            }

            ++v2;
        }

        if((((Set)v3_1).isEmpty()) && v1_4 == null) {
            throw new AnnotatedException("Cannot find a valid issuer certificate.");
        }

        if((((Set)v3_1).isEmpty()) && v1_4 != null) {
            throw v1_4;
        }

        return ((Set)v3_1);
    }

    protected static PublicKey processCRLG(X509CRL arg3, Set arg4) {
        Throwable v0 = null;
        Iterator v1 = arg4.iterator();
        while(v1.hasNext()) {
            Object v0_1 = v1.next();
            try {
                arg3.verify(((PublicKey)v0_1));
                return ((PublicKey)v0_1);
            }
            catch(Exception v0_2) {
                continue;
            }
        }

        throw new AnnotatedException("Cannot verify CRL.", v0);
    }

    protected static X509CRL processCRLH(Set arg4, PublicKey arg5) {
        Object v0_1;
        X509CRL v1 = null;
        Iterator v2 = arg4.iterator();
        Exception v0 = ((Exception)v1);
        while(true) {
            if(v2.hasNext()) {
                v0_1 = v2.next();
                try {
                    ((X509CRL)v0_1).verify(arg5);
                    goto label_7;
                }
                catch(Exception v0) {
                    continue;
                }
            }
            else {
                break;
            }

            goto label_7;
        }

        if(v0 != null) {
            throw new AnnotatedException("Cannot verify delta CRL.", ((Throwable)v0));
        }
        else {
            X509CRL v0_2 = v1;
        }

    label_7:
        return ((X509CRL)v0_1);
    }

    protected static void processCRLI(Date arg1, X509CRL arg2, Object arg3, CertStatus arg4, ExtendedPKIXParameters arg5) {
        if((arg5.isUseDeltasEnabled()) && arg2 != null) {
            CertPathValidatorUtilities.getCertStatus(arg1, arg2, arg3, arg4);
        }
    }

    protected static void processCRLJ(Date arg2, X509CRL arg3, Object arg4, CertStatus arg5) {
        if(arg5.getCertStatus() == 11) {
            CertPathValidatorUtilities.getCertStatus(arg2, arg3, arg4, arg5);
        }
    }

    protected static void processCertA(CertPath arg6, ExtendedPKIXParameters arg7, int arg8, PublicKey arg9, boolean arg10, X500Principal arg11, X509Certificate arg12) {
        List v5 = arg6.getCertificates();
        Object v1 = v5.get(arg8);
        if(!arg10) {
            try {
                CertPathValidatorUtilities.verifyX509Certificate(((X509Certificate)v1), arg9, arg7.getSigProvider());
            }
            catch(GeneralSecurityException v0) {
                throw new ExtCertPathValidatorException("Could not validate certificate signature.", ((Throwable)v0), arg6, arg8);
            }
        }

        try {
            ((X509Certificate)v1).checkValidity(CertPathValidatorUtilities.getValidCertDateFromValidityModel(arg7, arg6, arg8));
        }
        catch(AnnotatedException v0_1) {
            throw new ExtCertPathValidatorException("Could not validate time of certificate.", ((Throwable)v0_1), arg6, arg8);
        }
        catch(CertificateNotYetValidException v0_2) {
            throw new ExtCertPathValidatorException("Could not validate certificate: " + v0_2.getMessage(), ((Throwable)v0_2), arg6, arg8);
        }
        catch(CertificateExpiredException v0_3) {
            throw new ExtCertPathValidatorException("Could not validate certificate: " + v0_3.getMessage(), ((Throwable)v0_3), arg6, arg8);
        }

        if(arg7.isRevocationEnabled()) {
            try {
                RFC3280CertPathUtilities.checkCRLs(arg7, ((X509Certificate)v1), CertPathValidatorUtilities.getValidCertDateFromValidityModel(arg7, arg6, arg8), arg12, arg9, v5);
            }
            catch(AnnotatedException v1_1) {
                if(v1_1.getCause() != null) {
                    Throwable v0_4 = v1_1.getCause();
                }
                else {
                    v0_1 = v1_1;
                }

                throw new ExtCertPathValidatorException(v1_1.getMessage(), ((Throwable)v0_1), arg6, arg8);
            }
        }

        if(!CertPathValidatorUtilities.getEncodedIssuerPrincipal(v1).equals(arg11)) {
            throw new ExtCertPathValidatorException("IssuerName(" + CertPathValidatorUtilities.getEncodedIssuerPrincipal(v1) + ") does not match SubjectName(" + arg11 + ") of signing certificate.", null, arg6, arg8);
        }
    }

    protected static void processCertBC(CertPath arg5, int arg6, PKIXNameConstraintValidator arg7) {
        int v0_3;
        GeneralName[] v1_4;
        GeneralNames v2_2;
        ASN1Sequence v1_2;
        List v1 = arg5.getCertificates();
        Object v0 = v1.get(arg6);
        int v1_1 = v1.size();
        int v2 = v1_1 - arg6;
        if(!CertPathValidatorUtilities.isSelfIssued(((X509Certificate)v0)) || v2 >= v1_1) {
            ASN1InputStream v2_1 = new ASN1InputStream(CertPathValidatorUtilities.getSubjectPrincipal(((X509Certificate)v0)).getEncoded());
            try {
                v1_2 = DERSequence.getInstance(v2_1.readObject());
            }
            catch(Exception v0_1) {
                throw new CertPathValidatorException("Exception extracting subject name when checking subtrees.", ((Throwable)v0_1), arg5, arg6);
            }

            try {
                arg7.checkPermittedDN(v1_2);
                arg7.checkExcludedDN(v1_2);
            }
            catch(PKIXNameConstraintValidatorException v0_2) {
                throw new CertPathValidatorException("Subtree check for certificate subject failed.", ((Throwable)v0_2), arg5, arg6);
            }

            try {
                v2_2 = GeneralNames.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.SUBJECT_ALTERNATIVE_NAME));
            }
            catch(Exception v0_1) {
                throw new CertPathValidatorException("Subject alternative name extension could not be decoded.", ((Throwable)v0_1), arg5, arg6);
            }

            Enumeration v1_3 = new X509Name(v1_2).getValues(X509Name.EmailAddress).elements();
            while(true) {
                if(v1_3.hasMoreElements()) {
                    GeneralName v3 = new GeneralName(1, v1_3.nextElement());
                    try {
                        arg7.checkPermitted(v3);
                        arg7.checkExcluded(v3);
                        continue;
                    }
                    catch(PKIXNameConstraintValidatorException v0_2) {
                        throw new CertPathValidatorException("Subtree check for certificate subject alternative email failed.", ((Throwable)v0_2), arg5, arg6);
                    }
                }
                else {
                    break;
                }

                return;
            }

            if(v2_2 != null) {
                try {
                    v1_4 = v2_2.getNames();
                    v0_3 = 0;
                }
                catch(Exception v0_1) {
                    throw new CertPathValidatorException("Subject alternative name contents could not be decoded.", ((Throwable)v0_1), arg5, arg6);
                }

                while(v0_3 < v1_4.length) {
                    try {
                        arg7.checkPermitted(v1_4[v0_3]);
                        arg7.checkExcluded(v1_4[v0_3]);
                        ++v0_3;
                        continue;
                    }
                    catch(PKIXNameConstraintValidatorException v0_2) {
                        throw new CertPathValidatorException("Subtree check for certificate subject alternative name failed.", ((Throwable)v0_2), arg5, arg6);
                    }

                    return;
                }
            }
        }
    }

    protected static PKIXPolicyNode processCertD(CertPath arg13, int arg14, Set arg15, PKIXPolicyNode arg16, List[] arg17, int arg18) {
        int v2_3;
        Object v1_4;
        Object v5_1;
        PolicyInformation v2_2;
        HashSet v6_2;
        Iterator v4_1;
        Object v7_1;
        Set v6_1;
        ASN1Sequence v2_1;
        List v2 = arg13.getCertificates();
        Object v9 = v2.get(arg14);
        int v1 = v2.size();
        int v3 = v1 - arg14;
        try {
            v2_1 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v9), RFC3280CertPathUtilities.CERTIFICATE_POLICIES));
            if(v2_1 == null) {
                goto label_162;
            }
        }
        catch(AnnotatedException v1_1) {
            throw new ExtCertPathValidatorException("Could not read certificate policies extension from certificate.", ((Throwable)v1_1), arg13, arg14);
        }

        if(arg16 != null) {
            Enumeration v4 = v2_1.getObjects();
            HashSet v5 = new HashSet();
            while(true) {
                if(v4.hasMoreElements()) {
                    PolicyInformation v6 = PolicyInformation.getInstance(v4.nextElement());
                    ASN1ObjectIdentifier v7 = v6.getPolicyIdentifier();
                    ((Set)v5).add(((DERObjectIdentifier)v7).getId());
                    if(!"2.5.29.32.0".equals(((DERObjectIdentifier)v7).getId())) {
                        goto label_24;
                    }
                    else {
                        continue;
                        try {
                        label_24:
                            v6_1 = CertPathValidatorUtilities.getQualifierSet(v6.getPolicyQualifiers());
                        }
                        catch(CertPathValidatorException v1_2) {
                            throw new ExtCertPathValidatorException("Policy qualifier info set could not be build.", ((Throwable)v1_2), arg13, arg14);
                        }

                        if(CertPathValidatorUtilities.processCertD1i(v3, arg17, ((DERObjectIdentifier)v7), v6_1)) {
                            continue;
                        }

                        CertPathValidatorUtilities.processCertD1ii(v3, arg17, ((DERObjectIdentifier)v7), v6_1);
                        continue;
                    }
                }
                else {
                    break;
                }

                return v2_4;
            }

            if((arg15.isEmpty()) || (arg15.contains("2.5.29.32.0"))) {
                arg15.clear();
                arg15.addAll(((Collection)v5));
                goto label_49;
            label_95:
                while(v4_1.hasNext()) {
                    v7_1 = v4_1.next();
                    if(!((Set)v5).contains(v7_1)) {
                        continue;
                    }

                    ((Set)v6_2).add(v7_1);
                }

                arg15.clear();
                arg15.addAll(((Collection)v6_2));
            }
            else {
                v4_1 = arg15.iterator();
                v6_2 = new HashSet();
                goto label_95;
            }

        label_49:
            if(arg18 > 0 || v3 < v1 && (CertPathValidatorUtilities.isSelfIssued(((X509Certificate)v9)))) {
                Enumeration v1_3 = v2_1.getObjects();
                do {
                    if(v1_3.hasMoreElements()) {
                        v2_2 = PolicyInformation.getInstance(v1_3.nextElement());
                        if(!"2.5.29.32.0".equals(v2_2.getPolicyIdentifier().getId())) {
                            continue;
                        }

                        break;
                    }

                    goto label_125;
                }
                while(true);

                v6_1 = CertPathValidatorUtilities.getQualifierSet(v2_2.getPolicyQualifiers());
                List v11 = arg17[v3 - 1];
                int v10 = 0;
                while(true) {
                    if(v10 < v11.size()) {
                        v5_1 = v11.get(v10);
                        Iterator v12 = ((PKIXPolicyNode)v5_1).getExpectedPolicies().iterator();
                        do {
                        label_74:
                            if(v12.hasNext()) {
                                v1_4 = v12.next();
                                if((v1_4 instanceof String)) {
                                    v7_1 = v1_4;
                                }
                                else {
                                    if(!(v1_4 instanceof DERObjectIdentifier)) {
                                        continue;
                                    }

                                    break;
                                }

                                goto label_80;
                            }
                            else {
                                goto label_122;
                            }
                        }
                        while(true);

                        String v7_2 = ((DERObjectIdentifier)v1_4).getId();
                    label_80:
                        v4_1 = ((PKIXPolicyNode)v5_1).getChildren();
                        v2_3 = 0;
                        break;
                    label_122:
                        ++v10;
                        continue;
                    }

                    goto label_125;
                }

                while(v4_1.hasNext()) {
                    v1 = ((String)v7_1).equals(v4_1.next().getValidPolicy()) ? 1 : v2_3;
                    v2_3 = v1;
                }

                if(v2_3 != 0) {
                    goto label_74;
                }

                HashSet v4_2 = new HashSet();
                ((Set)v4_2).add(v7_1);
                PKIXPolicyNode v1_5 = new PKIXPolicyNode(new ArrayList(), v3, ((Set)v4_2), ((PolicyNode)v5_1), v6_1, ((String)v7_1), false);
                ((PKIXPolicyNode)v5_1).addChild(v1_5);
                arg17[v3].add(v1_5);
                goto label_74;
            }

        label_125:
            int v5_2 = v3 - 1;
            PKIXPolicyNode v2_4;
            for(v2_4 = arg16; v5_2 >= 0; v2_4 = v4_3) {
                List v6_3 = arg17[v5_2];
                PKIXPolicyNode v4_3 = v2_4;
                for(v2_3 = 0; v2_3 < v6_3.size(); ++v2_3) {
                    v1_4 = v6_3.get(v2_3);
                    if(!((PKIXPolicyNode)v1_4).hasChildren()) {
                        v4_3 = CertPathValidatorUtilities.removePolicyNode(v4_3, arg17, ((PKIXPolicyNode)v1_4));
                        if(v4_3 != null) {
                            goto label_145;
                        }

                        break;
                    }

                label_145:
                }

                --v5_2;
            }

            Set v1_6 = ((X509Certificate)v9).getCriticalExtensionOIDs();
            if(v1_6 == null) {
                return v2_4;
            }

            boolean v4_4 = v1_6.contains(RFC3280CertPathUtilities.CERTIFICATE_POLICIES);
            List v5_3 = arg17[v3];
            for(v3 = 0; v3 < v5_3.size(); ++v3) {
                v5_3.get(v3).setCritical(v4_4);
            }
        }
        else {
        label_162:
            v2_4 = null;
        }

        return v2_4;
    }

    protected static PKIXPolicyNode processCertE(CertPath arg3, int arg4, PKIXPolicyNode arg5) {
        Object v0 = arg3.getCertificates().get(arg4);
        try {
            if(DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.CERTIFICATE_POLICIES)) != null) {
                return arg5;
            }
        }
        catch(AnnotatedException v0_1) {
            throw new ExtCertPathValidatorException("Could not read certificate policies extension from certificate.", ((Throwable)v0_1), arg3, arg4);
        }

        return null;
    }

    protected static void processCertF(CertPath arg3, int arg4, PKIXPolicyNode arg5, int arg6) {
        if(arg6 <= 0 && arg5 == null) {
            throw new ExtCertPathValidatorException("No valid policy tree found when one expected.", null, arg3, arg4);
        }
    }

    protected static int wrapupCertA(int arg1, X509Certificate arg2) {
        if(!CertPathValidatorUtilities.isSelfIssued(arg2) && arg1 != 0) {
            --arg1;
        }

        return arg1;
    }

    protected static int wrapupCertB(CertPath arg4, int arg5, int arg6) {
        ASN1Sequence v0_2;
        Object v0 = arg4.getCertificates().get(arg5);
        try {
            v0_2 = DERSequence.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)v0), RFC3280CertPathUtilities.POLICY_CONSTRAINTS));
            if(v0_2 == null) {
                return 0;
            }
        }
        catch(AnnotatedException v0_1) {
            throw new ExtCertPathValidatorException("Policy constraints could not be decoded.", ((Throwable)v0_1), arg4, arg5);
        }

        Enumeration v2 = v0_2.getObjects();
        do {
            if(!v2.hasMoreElements()) {
                return 0;
            }

            v0 = v2.nextElement();
            if(((ASN1TaggedObject)v0).getTagNo() != 0) {
                continue;
            }
            else {
                try {
                    if(DERInteger.getInstance(((ASN1TaggedObject)v0), false).getValue().intValue() != 0) {
                        continue;
                    }

                    return 0;
                }
                catch(Exception v0_3) {
                    throw new ExtCertPathValidatorException("Policy constraints requireExplicitPolicy field could not be decoded.", ((Throwable)v0_3), arg4, arg5);
                }
            }

            return 0;
        }
        while(true);

        return 0;
    }

    protected static void wrapupCertF(CertPath arg3, int arg4, List arg5, Set arg6) {
        Object v0 = arg3.getCertificates().get(arg4);
        Iterator v2 = arg5.iterator();
        while(v2.hasNext()) {
            try {
                v2.next().check(((Certificate)v0), ((Collection)arg6));
                continue;
            }
            catch(CertPathValidatorException v0_1) {
                throw new ExtCertPathValidatorException("Additional certificate path checker failed.", ((Throwable)v0_1), arg3, arg4);
            }
        }

        if(!arg6.isEmpty()) {
            throw new ExtCertPathValidatorException("Certificate has unsupported critical extension: " + arg6, null, arg3, arg4);
        }
    }

    protected static PKIXPolicyNode wrapupCertG(CertPath arg9, ExtendedPKIXParameters arg10, Set arg11, int arg12, List[] arg13, PKIXPolicyNode arg14, Set arg15) {
        PKIXPolicyNode v2_1;
        List v4_1;
        Iterator v1_1;
        Object v0;
        List v5;
        HashSet v4;
        int v3 = arg9.getCertificates().size();
        if(arg14 == null) {
            if(arg10.isExplicitPolicyRequired()) {
                throw new ExtCertPathValidatorException("Explicit policy requested but none available.", null, arg9, arg12);
            }
            else {
                arg14 = null;
            }
        }
        else if(!CertPathValidatorUtilities.isAnyPolicy(arg11)) {
            v4 = new HashSet();
            for(v1 = 0; v1 < arg13.length; ++v1) {
                v5 = arg13[v1];
                for(v2 = 0; v2 < v5.size(); ++v2) {
                    v0 = v5.get(v2);
                    if("2.5.29.32.0".equals(((PKIXPolicyNode)v0).getValidPolicy())) {
                        Iterator v6 = ((PKIXPolicyNode)v0).getChildren();
                        while(v6.hasNext()) {
                            v0 = v6.next();
                            if("2.5.29.32.0".equals(((PKIXPolicyNode)v0).getValidPolicy())) {
                                continue;
                            }

                            ((Set)v4).add(v0);
                        }
                    }
                }
            }

            v1_1 = ((Set)v4).iterator();
            while(v1_1.hasNext()) {
                v0 = v1_1.next();
                if(arg11.contains(((PKIXPolicyNode)v0).getValidPolicy())) {
                    continue;
                }

                arg14 = CertPathValidatorUtilities.removePolicyNode(arg14, arg13, ((PKIXPolicyNode)v0));
            }

            if(arg14 != null) {
                --v3;
                v1_2 = arg14;
                goto label_126;
            }
            else {
                v1_2 = arg14;
                goto label_145;
            label_126:
                while(v3 >= 0) {
                    v4_1 = arg13[v3];
                    v2_1 = v1_2;
                    for(v1 = 0; v1 < v4_1.size(); ++v1) {
                        v0 = v4_1.get(v1);
                        if(!((PKIXPolicyNode)v0).hasChildren()) {
                            v2_1 = CertPathValidatorUtilities.removePolicyNode(v2_1, arg13, ((PKIXPolicyNode)v0));
                        }
                    }

                    --v3;
                    v1_2 = v2_1;
                }
            }

        label_145:
            arg14 = v1_2;
        }
        else if(arg10.isExplicitPolicyRequired()) {
            if(arg15.isEmpty()) {
                throw new ExtCertPathValidatorException("Explicit policy requested but none available.", null, arg9, arg12);
            }
            else {
                v4 = new HashSet();
                int v1;
                for(v1 = 0; v1 < arg13.length; ++v1) {
                    v5 = arg13[v1];
                    int v2;
                    for(v2 = 0; v2 < v5.size(); ++v2) {
                        v0 = v5.get(v2);
                        if("2.5.29.32.0".equals(((PKIXPolicyNode)v0).getValidPolicy())) {
                            Iterator v0_1 = ((PKIXPolicyNode)v0).getChildren();
                            while(v0_1.hasNext()) {
                                ((Set)v4).add(v0_1.next());
                            }
                        }
                    }
                }

                v1_1 = ((Set)v4).iterator();
                while(v1_1.hasNext()) {
                }

                if(arg14 == null) {
                    return arg14;
                }

                --v3;
                PKIXPolicyNode v1_2;
                for(v1_2 = arg14; v3 >= 0; v1_2 = v2_1) {
                    v4_1 = arg13[v3];
                    v2_1 = v1_2;
                    for(v1 = 0; v1 < v4_1.size(); ++v1) {
                        v0 = v4_1.get(v1);
                        if(!((PKIXPolicyNode)v0).hasChildren()) {
                            v2_1 = CertPathValidatorUtilities.removePolicyNode(v2_1, arg13, ((PKIXPolicyNode)v0));
                        }
                    }

                    --v3;
                }

                arg14 = v1_2;
            }
        }

        return arg14;
    }
}

