// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.Principal;
import java.security.PublicKey;
import java.security.cert.CertPath;
import java.security.cert.CertPathBuilder;
import java.security.cert.CertPathBuilderException;
import java.security.cert.CertPathBuilderResult;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidator;
import java.security.cert.CertPathValidatorException;
import java.security.cert.CertPathValidatorResult;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.PKIXParameters;
import java.security.cert.TrustAnchor;
import java.security.cert.X509CRL;
import java.security.cert.X509Certificate;
import java.security.cert.X509Extension;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.x509.CRLDistPoint;
import org.bouncycastle.asn1.x509.DistributionPoint;
import org.bouncycastle.asn1.x509.DistributionPointName;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.TargetInformation;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.jce.exception.ExtCertPathValidatorException;
import org.bouncycastle.util.Selector;
import org.bouncycastle.x509.ExtendedPKIXBuilderParameters;
import org.bouncycastle.x509.ExtendedPKIXParameters;
import org.bouncycastle.x509.X509AttributeCertificate;
import org.bouncycastle.x509.X509CertStoreSelector;

class RFC3281CertPathUtilities {
    private static final String AUTHORITY_INFO_ACCESS;
    private static final String CRL_DISTRIBUTION_POINTS;
    private static final String NO_REV_AVAIL;
    private static final String TARGET_INFORMATION;

    static {
        RFC3281CertPathUtilities.TARGET_INFORMATION = X509Extensions.TargetInformation.getId();
        RFC3281CertPathUtilities.NO_REV_AVAIL = X509Extensions.NoRevAvail.getId();
        RFC3281CertPathUtilities.CRL_DISTRIBUTION_POINTS = X509Extensions.CRLDistributionPoints.getId();
        RFC3281CertPathUtilities.AUTHORITY_INFO_ACCESS = X509Extensions.AuthorityInfoAccess.getId();
    }

    RFC3281CertPathUtilities() {
        super();
    }

    protected static void additionalChecks(X509AttributeCertificate arg4, ExtendedPKIXParameters arg5) {
        Object v0;
        Iterator v1 = arg5.getProhibitedACAttributes().iterator();
        do {
            if(!v1.hasNext()) {
                goto label_18;
            }

            v0 = v1.next();
        }
        while(arg4.getAttributes(((String)v0)) == null);

        throw new CertPathValidatorException("Attribute certificate contains prohibited attribute: " + (((String)v0)) + ".");
    label_18:
        v1 = arg5.getNecessaryACAttributes().iterator();
        do {
            if(!v1.hasNext()) {
                return;
            }

            v0 = v1.next();
        }
        while(arg4.getAttributes(((String)v0)) != null);

        throw new CertPathValidatorException("Attribute certificate does not contain necessary attribute: " + (((String)v0)) + ".");
    }

    private static void checkCRL(DistributionPoint arg12, X509AttributeCertificate arg13, ExtendedPKIXParameters arg14, Date arg15, X509Certificate arg16, CertStatus arg17, ReasonsMask arg18, List arg19) {
        if(arg13.getExtensionValue(X509Extensions.NoRevAvail.getId()) == null) {
            Date v9 = new Date(System.currentTimeMillis());
            if(arg15.getTime() > v9.getTime()) {
                throw new AnnotatedException("Validation time is in future.");
            }

            Iterator v10 = CertPathValidatorUtilities.getCompleteCRLs(arg12, arg13, v9, arg14).iterator();
            AnnotatedException v7 = null;
            int v8 = 0;
        label_21:
            while(v10.hasNext()) {
                if(arg17.getCertStatus() != 11) {
                    break;
                }

                if(arg18.isAllReasons()) {
                    break;
                }

                try {
                    Object v1_1 = v10.next();
                    ReasonsMask v11 = RFC3280CertPathUtilities.processCRLD(((X509CRL)v1_1), arg12);
                    if(!v11.hasNewReasons(arg18)) {
                        continue;
                    }

                    PublicKey v3 = RFC3280CertPathUtilities.processCRLG(((X509CRL)v1_1), RFC3280CertPathUtilities.processCRLF(((X509CRL)v1_1), arg13, null, null, arg14, arg19));
                    X509CRL v2 = null;
                    if(arg14.isUseDeltasEnabled()) {
                        v2 = RFC3280CertPathUtilities.processCRLH(CertPathValidatorUtilities.getDeltaCRLs(v9, arg14, ((X509CRL)v1_1)), v3);
                    }

                    if(arg14.getValidityModel() != 1 && arg13.getNotAfter().getTime() < ((X509CRL)v1_1).getThisUpdate().getTime()) {
                        throw new AnnotatedException("No valid CRL for current time found.");
                    }

                    RFC3280CertPathUtilities.processCRLB1(arg12, arg13, ((X509CRL)v1_1));
                    RFC3280CertPathUtilities.processCRLB2(arg12, arg13, ((X509CRL)v1_1));
                    RFC3280CertPathUtilities.processCRLC(v2, ((X509CRL)v1_1), arg14);
                    RFC3280CertPathUtilities.processCRLI(arg15, v2, arg13, arg17, arg14);
                    RFC3280CertPathUtilities.processCRLJ(arg15, ((X509CRL)v1_1), arg13, arg17);
                    if(arg17.getCertStatus() == 8) {
                        arg17.setCertStatus(11);
                    }

                    arg18.addReasons(v11);
                    v8 = 1;
                    continue;
                }
                catch(AnnotatedException v1) {
                    goto label_58;
                }

                break;
            }

            if(v8 != 0) {
            }
            else {
                throw v7;
            label_58:
                v7 = v1;
                goto label_21;
            }
        }
    }

    protected static void checkCRLs(X509AttributeCertificate arg12, ExtendedPKIXParameters arg13, X509Certificate arg14, Date arg15, List arg16) {
        ASN1Primitive v1_1;
        AnnotatedException v9_1;
        int v8;
        int v10;
        DistributionPoint[] v11;
        CRLDistPoint v1;
        if(arg13.isRevocationEnabled()) {
            if(arg12.getExtensionValue(RFC3281CertPathUtilities.NO_REV_AVAIL) == null) {
                try {
                    v1 = CRLDistPoint.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg12), RFC3281CertPathUtilities.CRL_DISTRIBUTION_POINTS));
                }
                catch(AnnotatedException v0) {
                    throw new CertPathValidatorException("CRL distribution point extension could not be read.", ((Throwable)v0));
                }

                try {
                    CertPathValidatorUtilities.addAdditionalStoresFromCRLDistributionPoint(v1, arg13);
                }
                catch(AnnotatedException v0) {
                    throw new CertPathValidatorException("No additional CRL locations could be decoded from CRL distribution point extension.", ((Throwable)v0));
                }

                CertStatus v5 = new CertStatus();
                ReasonsMask v6 = new ReasonsMask();
                Throwable v9 = null;
                if(v1 != null) {
                    try {
                        v11 = v1.getDistributionPoints();
                        v10 = 0;
                        v8 = 0;
                    }
                    catch(Exception v0_1) {
                        throw new ExtCertPathValidatorException("Distribution points could not be read.", ((Throwable)v0_1));
                    }

                    try {
                        while(true) {
                            if(v10 >= v11.length) {
                                goto label_59;
                            }

                            if(v5.getCertStatus() != 11) {
                                goto label_59;
                            }

                            if(v6.isAllReasons()) {
                                goto label_59;
                            }

                            RFC3281CertPathUtilities.checkCRL(v11[v10], arg12, arg13.clone(), arg15, arg14, v5, v6, arg16);
                            v8 = 1;
                            ++v10;
                        }
                    }
                    catch(AnnotatedException v0) {
                        v9_1 = new AnnotatedException("No valid CRL for distribution point found.", v0);
                        goto label_59;
                    }
                }

                v8 = 0;
            label_59:
                if(v5.getCertStatus() == 11 && !v6.isAllReasons()) {
                    try {
                        v1_1 = new ASN1InputStream(arg12.getIssuer().getPrincipals()[0].getEncoded()).readObject();
                        goto label_72;
                    }
                    catch(Exception v0_1) {
                        try {
                            throw new AnnotatedException("Issuer from certificate for CRL could not be reencoded.", ((Throwable)v0_1));
                        label_72:
                            RFC3281CertPathUtilities.checkCRL(new DistributionPoint(new DistributionPointName(0, new GeneralNames(new GeneralName(4, ((ASN1Encodable)v1_1)))), null, null), arg12, arg13.clone(), arg15, arg14, v5, v6, arg16);
                            v8 = 1;
                        }
                        catch(AnnotatedException v0) {
                            v9_1 = new AnnotatedException("No valid CRL for distribution point found.", ((Throwable)v0));
                        }
                    }
                }

                if(v8 == 0) {
                    throw new ExtCertPathValidatorException("No valid CRL found.", ((Throwable)v9_1));
                }

                if(v5.getCertStatus() != 11) {
                    throw new CertPathValidatorException("Attribute certificate revocation after " + v5.getRevocationDate() + ", reason: " + RFC3280CertPathUtilities.crlReasons[v5.getCertStatus()]);
                }

                if(!v6.isAllReasons() && v5.getCertStatus() == 11) {
                    v5.setCertStatus(12);
                }

                if(v5.getCertStatus() != 12) {
                    return;
                }

                throw new CertPathValidatorException("Attribute certificate status could not be determined.");
            }

            if(arg12.getExtensionValue(RFC3281CertPathUtilities.CRL_DISTRIBUTION_POINTS) != null || arg12.getExtensionValue(RFC3281CertPathUtilities.AUTHORITY_INFO_ACCESS) != null) {
                throw new CertPathValidatorException("No rev avail extension is set, but also an AC revocation pointer.");
            }
        }
    }

    protected static CertPath processAttrCert1(X509AttributeCertificate arg8, ExtendedPKIXParameters arg9) {
        ExtCertPathValidatorException v1_4;
        CertPathBuilder v1_2;
        X509CertStoreSelector v5;
        CertPathBuilderResult v3 = null;
        int v2 = 0;
        HashSet v4 = new HashSet();
        if(arg8.getHolder().getIssuer() != null) {
            v5 = new X509CertStoreSelector();
            v5.setSerialNumber(arg8.getHolder().getSerialNumber());
            Principal[] v6 = arg8.getHolder().getIssuer();
            int v1 = 0;
            while(true) {
                if(v1 < v6.length) {
                    try {
                        if((v6[v1] instanceof X500Principal)) {
                            v5.setIssuer(v6[v1].getEncoded());
                        }

                        ((Set)v4).addAll(CertPathValidatorUtilities.findCertificates(v5, arg9.getStores()));
                        ++v1;
                        continue;
                    }
                    catch(IOException v0) {
                        throw new ExtCertPathValidatorException("Unable to encode X500 principal.", ((Throwable)v0));
                    }
                    catch(AnnotatedException v0_1) {
                        throw new ExtCertPathValidatorException("Public key certificate for attribute certificate cannot be searched.", ((Throwable)v0_1));
                    }
                }
                else {
                    break;
                }

                goto label_45;
            }

            if(!((Set)v4).isEmpty()) {
                goto label_45;
            }

            throw new CertPathValidatorException("Public key certificate specified in base certificate ID for attribute certificate cannot be found.");
        }

    label_45:
        if(arg8.getHolder().getEntityNames() != null) {
            X509CertStoreSelector v1_1 = new X509CertStoreSelector();
            Principal[] v5_1 = arg8.getHolder().getEntityNames();
            while(true) {
                if(v2 < v5_1.length) {
                    try {
                        if((v5_1[v2] instanceof X500Principal)) {
                            v1_1.setIssuer(v5_1[v2].getEncoded());
                        }

                        ((Set)v4).addAll(CertPathValidatorUtilities.findCertificates(v1_1, arg9.getStores()));
                        ++v2;
                        continue;
                    }
                    catch(IOException v0) {
                        throw new ExtCertPathValidatorException("Unable to encode X500 principal.", ((Throwable)v0));
                    }
                    catch(AnnotatedException v0_1) {
                        throw new ExtCertPathValidatorException("Public key certificate for attribute certificate cannot be searched.", ((Throwable)v0_1));
                    }
                }
                else {
                    break;
                }

                goto label_81;
            }

            if(!((Set)v4).isEmpty()) {
                goto label_81;
            }

            throw new CertPathValidatorException("Public key certificate specified in entity name for attribute certificate cannot be found.");
        }

    label_81:
        ExtendedPKIXParameters v0_2 = ExtendedPKIXBuilderParameters.getInstance(((PKIXParameters)arg9));
        Iterator v4_1 = ((Set)v4).iterator();
        CertPathBuilderResult v2_1 = v3;
        while(v4_1.hasNext()) {
            v5 = new X509CertStoreSelector();
            v5.setCertificate(v4_1.next());
            ((ExtendedPKIXBuilderParameters)v0_2).setTargetConstraints(((Selector)v5));
            try {
                v1_2 = CertPathBuilder.getInstance("PKIX", "BC");
            }
            catch(NoSuchAlgorithmException v0_3) {
                throw new ExtCertPathValidatorException("Support class could not be created.", ((Throwable)v0_3));
            }
            catch(NoSuchProviderException v0_4) {
                throw new ExtCertPathValidatorException("Support class could not be created.", ((Throwable)v0_4));
            }

            try {
                ExtCertPathValidatorException v7 = ((ExtCertPathValidatorException)v2_1);
                v2_1 = v1_2.build(ExtendedPKIXBuilderParameters.getInstance(((PKIXParameters)v0_2)));
                v1_4 = v7;
            }
            catch(InvalidAlgorithmParameterException v0_5) {
                throw new RuntimeException(v0_5.getMessage());
            }
            catch(CertPathBuilderException v1_3) {
                v1_4 = new ExtCertPathValidatorException("Certification path for public key certificate of attribute certificate could not be build.", v1_3);
                v2_1 = v3;
            }

            v3 = v2_1;
            ExtCertPathValidatorException v2_2 = v1_4;
        }

        if((((ExtCertPathValidatorException)v2_1)) != null) {
            throw ((ExtCertPathValidatorException)v2_1);
        }

        return v3.getCertPath();
    }

    protected static CertPathValidatorResult processAttrCert2(CertPath arg3, ExtendedPKIXParameters arg4) {
        CertPathValidator v0_2;
        try {
            v0_2 = CertPathValidator.getInstance("PKIX", "BC");
        }
        catch(NoSuchAlgorithmException v0) {
            throw new ExtCertPathValidatorException("Support class could not be created.", ((Throwable)v0));
        }
        catch(NoSuchProviderException v0_1) {
            throw new ExtCertPathValidatorException("Support class could not be created.", ((Throwable)v0_1));
        }

        try {
            return v0_2.validate(arg3, ((CertPathParameters)arg4));
        }
        catch(InvalidAlgorithmParameterException v0_3) {
            throw new RuntimeException(v0_3.getMessage());
        }
        catch(CertPathValidatorException v0_4) {
            throw new ExtCertPathValidatorException("Certification path for issuer certificate of attribute certificate could not be validated.", ((Throwable)v0_4));
        }
    }

    protected static void processAttrCert3(X509Certificate arg2, ExtendedPKIXParameters arg3) {
        if(arg2.getKeyUsage() != null && !arg2.getKeyUsage()[0] && !arg2.getKeyUsage()[1]) {
            throw new CertPathValidatorException("Attribute certificate issuer public key cannot be used to validate digital signatures.");
        }

        if(arg2.getBasicConstraints() != -1) {
            throw new CertPathValidatorException("Attribute certificate issuer is also a public key certificate issuer.");
        }
    }

    protected static void processAttrCert4(X509Certificate arg5, ExtendedPKIXParameters arg6) {
        Iterator v2 = arg6.getTrustedACIssuers().iterator();
        int v1;
        for(v1 = 0; v2.hasNext(); v1 = v0_1) {
            Object v0 = v2.next();
            int v0_1 = (arg5.getSubjectX500Principal().getName("RFC2253").equals(((TrustAnchor)v0).getCAName())) || (arg5.equals(((TrustAnchor)v0).getTrustedCert())) ? 1 : v1;
        }

        if(v1 == 0) {
            throw new CertPathValidatorException("Attribute certificate issuer is not directly trusted.");
        }
    }

    protected static void processAttrCert5(X509AttributeCertificate arg3, ExtendedPKIXParameters arg4) {
        try {
            arg3.checkValidity(CertPathValidatorUtilities.getValidDate(((PKIXParameters)arg4)));
            return;
        }
        catch(CertificateNotYetValidException v0) {
            throw new ExtCertPathValidatorException("Attribute certificate is not valid.", ((Throwable)v0));
        }
        catch(CertificateExpiredException v0_1) {
            throw new ExtCertPathValidatorException("Attribute certificate is not valid.", ((Throwable)v0_1));
        }
    }

    protected static void processAttrCert7(X509AttributeCertificate arg4, CertPath arg5, CertPath arg6, ExtendedPKIXParameters arg7) {
        Set v1 = arg4.getCriticalExtensionOIDs();
        if(v1.contains(RFC3281CertPathUtilities.TARGET_INFORMATION)) {
            try {
                TargetInformation.getInstance(CertPathValidatorUtilities.getExtensionValue(((X509Extension)arg4), RFC3281CertPathUtilities.TARGET_INFORMATION));
            }
            catch(IllegalArgumentException v0) {
                throw new ExtCertPathValidatorException("Target information extension could not be read.", ((Throwable)v0));
            }
            catch(AnnotatedException v0_1) {
                throw new ExtCertPathValidatorException("Target information extension could not be read.", ((Throwable)v0_1));
            }
        }

        v1.remove(RFC3281CertPathUtilities.TARGET_INFORMATION);
        Iterator v2 = arg7.getAttrCertCheckers().iterator();
        while(v2.hasNext()) {
            v2.next().check(arg4, arg5, arg6, ((Collection)v1));
        }

        if(!v1.isEmpty()) {
            throw new CertPathValidatorException("Attribute certificate contains unsupported critical extensions: " + v1);
        }
    }
}

