// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.SignedData;
import org.bouncycastle.x509.X509AttributeCertificate;
import org.bouncycastle.x509.X509StreamParserSpi;
import org.bouncycastle.x509.X509V2AttributeCertificate;
import org.bouncycastle.x509.util.StreamParsingException;

public class X509AttrCertParser extends X509StreamParserSpi {
    private static final PEMUtil PEM_PARSER;
    private InputStream currentStream;
    private ASN1Set sData;
    private int sDataObjectCount;

    static {
        X509AttrCertParser.PEM_PARSER = new PEMUtil("ATTRIBUTE CERTIFICATE");
    }

    public X509AttrCertParser() {
        super();
        this.sData = null;
        this.sDataObjectCount = 0;
        this.currentStream = null;
    }

    public void engineInit(InputStream arg3) {
        this.currentStream = arg3;
        this.sData = null;
        this.sDataObjectCount = 0;
        if(!this.currentStream.markSupported()) {
            this.currentStream = new BufferedInputStream(this.currentStream);
        }
    }

    public Object engineRead() {
        X509AttributeCertificate v0_2;
        Object v0 = null;
        try {
            if(this.sData == null) {
                this.currentStream.mark(10);
                int v1 = this.currentStream.read();
                if(v1 != -1) {
                    if(v1 != 48) {
                        this.currentStream.reset();
                        v0_2 = this.readPEMCertificate(this.currentStream);
                    }
                    else {
                        this.currentStream.reset();
                        v0_2 = this.readDERCertificate(this.currentStream);
                    }
                }
            }
            else if(this.sDataObjectCount != this.sData.size()) {
                v0_2 = this.getCertificate();
            }
            else {
                this.sData = null;
                this.sDataObjectCount = 0;
            }

            return v0_2;
        }
        catch(Exception v0_1) {
            throw new StreamParsingException(v0_1.toString(), ((Throwable)v0_1));
        }
    }

    public Collection engineReadAll() {
        ArrayList v1 = new ArrayList();
        while(true) {
            Object v0 = this.engineRead();
            if(v0 == null) {
                break;
            }

            ((List)v1).add(v0);
        }

        return ((Collection)v1);
    }

    private X509AttributeCertificate getCertificate() {
        X509V2AttributeCertificate v0_1;
        ASN1Encodable v1_1;
        if(this.sData != null) {
            do {
                if(this.sDataObjectCount < this.sData.size()) {
                    ASN1Set v0 = this.sData;
                    int v1 = this.sDataObjectCount;
                    this.sDataObjectCount = v1 + 1;
                    v1_1 = v0.getObjectAt(v1);
                    if(!(v1_1 instanceof ASN1TaggedObject)) {
                        continue;
                    }

                    if(v1_1.getTagNo() != 2) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_23;
                }
            }
            while(true);

            v0_1 = new X509V2AttributeCertificate(ASN1Sequence.getInstance(((ASN1TaggedObject)v1_1), false).getEncoded());
        }
        else {
        label_23:
            X509AttributeCertificate v0_2 = null;
        }

        return ((X509AttributeCertificate)v0_1);
    }

    private X509AttributeCertificate readDERCertificate(InputStream arg5) {
        X509V2AttributeCertificate v0_2;
        ASN1Primitive v0 = new ASN1InputStream(arg5).readObject();
        if(((ASN1Sequence)v0).size() <= 1 || !(((ASN1Sequence)v0).getObjectAt(0) instanceof DERObjectIdentifier) || !((ASN1Sequence)v0).getObjectAt(0).equals(PKCSObjectIdentifiers.signedData)) {
            v0_2 = new X509V2AttributeCertificate(((ASN1Sequence)v0).getEncoded());
        }
        else {
            this.sData = new SignedData(ASN1Sequence.getInstance(((ASN1Sequence)v0).getObjectAt(1), true)).getCertificates();
            X509AttributeCertificate v0_1 = this.getCertificate();
        }

        return ((X509AttributeCertificate)v0_2);
    }

    private X509AttributeCertificate readPEMCertificate(InputStream arg3) {
        X509V2AttributeCertificate v0;
        ASN1Sequence v1 = X509AttrCertParser.PEM_PARSER.readPEMObject(arg3);
        if(v1 != null) {
            v0 = new X509V2AttributeCertificate(v1.getEncoded());
        }
        else {
            X509AttributeCertificate v0_1 = null;
        }

        return ((X509AttributeCertificate)v0);
    }
}

