// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.math.BigInteger;
import java.security.cert.CRLException;
import java.security.cert.X509CRLEntry;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Set;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Enumerated;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.util.ASN1Dump;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.CRLReason;
import org.bouncycastle.asn1.x509.Extension;
import org.bouncycastle.asn1.x509.Extensions;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.TBSCertList$CRLEntry;
import org.bouncycastle.asn1.x509.X509Extension;

public class X509CRLEntryObject extends X509CRLEntry {
    private TBSCertList$CRLEntry c;
    private X500Name certificateIssuer;
    private int hashValue;
    private boolean isHashValueSet;

    public X509CRLEntryObject(TBSCertList$CRLEntry arg2) {
        super();
        this.c = arg2;
        this.certificateIssuer = null;
    }

    public X509CRLEntryObject(TBSCertList$CRLEntry arg2, boolean arg3, X500Name arg4) {
        super();
        this.c = arg2;
        this.certificateIssuer = this.loadCertificateIssuer(arg3, arg4);
    }

    public X500Principal getCertificateIssuer() {
        X500Principal v0 = null;
        if(this.certificateIssuer != null) {
            try {
                v0 = new X500Principal(this.certificateIssuer.getEncoded());
            }
            catch(IOException v1) {
            }
        }

        return v0;
    }

    public Set getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    public byte[] getEncoded() {
        try {
            return this.c.getEncoded("DER");
        }
        catch(IOException v0) {
            throw new CRLException(v0.toString());
        }
    }

    private Extension getExtension(ASN1ObjectIdentifier arg2) {
        Extensions v0 = this.c.getExtensions();
        Extension v0_1 = v0 != null ? v0.getExtension(arg2) : null;
        return v0_1;
    }

    private Set getExtensionOIDs(boolean arg6) {
        Set v0_2;
        Extensions v2 = this.c.getExtensions();
        if(v2 != null) {
            HashSet v1 = new HashSet();
            Enumeration v3 = v2.oids();
            while(v3.hasMoreElements()) {
                Object v0 = v3.nextElement();
                if(arg6 != v2.getExtension(((ASN1ObjectIdentifier)v0)).isCritical()) {
                    continue;
                }

                ((Set)v1).add(((ASN1ObjectIdentifier)v0).getId());
            }

            HashSet v0_1 = v1;
        }
        else {
            v0_2 = null;
        }

        return v0_2;
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_2;
        Extension v0 = this.getExtension(new ASN1ObjectIdentifier(arg5));
        if(v0 != null) {
            try {
                v0_2 = v0.getExtnValue().getEncoded();
            }
            catch(Exception v0_1) {
                throw new RuntimeException("error encoding " + v0_1.toString());
            }
        }
        else {
            v0_2 = null;
        }

        return v0_2;
    }

    public Set getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public Date getRevocationDate() {
        return this.c.getRevocationDate().getDate();
    }

    public BigInteger getSerialNumber() {
        return this.c.getUserCertificate().getValue();
    }

    public boolean hasExtensions() {
        boolean v0 = this.c.getExtensions() != null ? true : false;
        return v0;
    }

    public boolean hasUnsupportedCriticalExtension() {
        Set v0 = this.getCriticalExtensionOIDs();
        boolean v0_1 = v0 == null || (v0.isEmpty()) ? false : true;
        return v0_1;
    }

    public int hashCode() {
        if(!this.isHashValueSet) {
            this.hashValue = super.hashCode();
            this.isHashValueSet = true;
        }

        return this.hashValue;
    }

    private X500Name loadCertificateIssuer(boolean arg6, X500Name arg7) {
        int v1_2;
        X500Name v0 = null;
        if(!arg6) {
            return v0;
        }

        Extension v1 = this.getExtension(Extension.certificateIssuer);
        if(v1 == null) {
            return arg7;
        }

        try {
            GeneralName[] v2 = GeneralNames.getInstance(v1.getParsedValue()).getNames();
            v1_2 = 0;
            while(true) {
            label_11:
                if(v1_2 >= v2.length) {
                    return v0;
                }

                if(v2[v1_2].getTagNo() != 4) {
                    break;
                }

                return X500Name.getInstance(v2[v1_2].getName());
            }
        }
        catch(Exception v1_1) {
            return v0;
        }

        ++v1_2;
        goto label_11;
        return v0;
    }

    public String toString() {
        StringBuffer v1 = new StringBuffer();
        String v2 = System.getProperty("line.separator");
        v1.append("      userCertificate: ").append(this.getSerialNumber()).append(v2);
        v1.append("       revocationDate: ").append(this.getRevocationDate()).append(v2);
        v1.append("       certificateIssuer: ").append(this.getCertificateIssuer()).append(v2);
        Extensions v3 = this.c.getExtensions();
        if(v3 != null) {
            Enumeration v4 = v3.oids();
            if(!v4.hasMoreElements()) {
                goto label_83;
            }

            v1.append("   crlEntryExtensions:").append(v2);
            while(v4.hasMoreElements()) {
                Object v0 = v4.nextElement();
                Extension v5 = v3.getExtension(((ASN1ObjectIdentifier)v0));
                if(v5.getExtnValue() != null) {
                    ASN1InputStream v7 = new ASN1InputStream(v5.getExtnValue().getOctets());
                    v1.append("                       critical(").append(v5.isCritical()).append(") ");
                    try {
                        if(((ASN1ObjectIdentifier)v0).equals(X509Extension.reasonCode)) {
                            v1.append(CRLReason.getInstance(ASN1Enumerated.getInstance(v7.readObject()))).append(v2);
                            continue;
                        }

                        if(((ASN1ObjectIdentifier)v0).equals(X509Extension.certificateIssuer)) {
                            v1.append("Certificate issuer: ").append(GeneralNames.getInstance(v7.readObject())).append(v2);
                            continue;
                        }

                        v1.append(((ASN1ObjectIdentifier)v0).getId());
                        v1.append(" value = ").append(ASN1Dump.dumpAsString(v7.readObject())).append(v2);
                    }
                    catch(Exception v5_1) {
                        v1.append(((ASN1ObjectIdentifier)v0).getId());
                        v1.append(" value = ").append("*****").append(v2);
                    }

                    continue;
                }

                v1.append(v2);
            }
        }

    label_83:
        return v1.toString();
    }
}

