// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.security.cert.CRL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.SignedData;
import org.bouncycastle.asn1.x509.CertificateList;
import org.bouncycastle.x509.X509StreamParserSpi;
import org.bouncycastle.x509.util.StreamParsingException;

public class X509CRLParser extends X509StreamParserSpi {
    private static final PEMUtil PEM_PARSER;
    private InputStream currentStream;
    private ASN1Set sData;
    private int sDataObjectCount;

    static {
        X509CRLParser.PEM_PARSER = new PEMUtil("CRL");
    }

    public X509CRLParser() {
        super();
        this.sData = null;
        this.sDataObjectCount = 0;
        this.currentStream = null;
    }

    public void engineInit(InputStream arg3) {
        this.currentStream = arg3;
        this.sData = null;
        this.sDataObjectCount = 0;
        if(!this.currentStream.markSupported()) {
            this.currentStream = new BufferedInputStream(this.currentStream);
        }
    }

    public Object engineRead() {
        CRL v0_2;
        Object v0 = null;
        try {
            if(this.sData == null) {
                this.currentStream.mark(10);
                int v1 = this.currentStream.read();
                if(v1 != -1) {
                    if(v1 != 48) {
                        this.currentStream.reset();
                        v0_2 = this.readPEMCRL(this.currentStream);
                    }
                    else {
                        this.currentStream.reset();
                        v0_2 = this.readDERCRL(this.currentStream);
                    }
                }
            }
            else if(this.sDataObjectCount != this.sData.size()) {
                v0_2 = this.getCRL();
            }
            else {
                this.sData = null;
                this.sDataObjectCount = 0;
            }

            return v0;
        }
        catch(Exception v0_1) {
            throw new StreamParsingException(v0_1.toString(), ((Throwable)v0_1));
        }
    }

    public Collection engineReadAll() {
        ArrayList v1 = new ArrayList();
        while(true) {
            Object v0 = this.engineRead();
            if(v0 == null) {
                break;
            }

            ((List)v1).add(v0);
        }

        return ((Collection)v1);
    }

    private CRL getCRL() {
        CRL v0_1;
        if(this.sData == null || this.sDataObjectCount >= this.sData.size()) {
            v0_1 = null;
        }
        else {
            ASN1Set v1 = this.sData;
            int v2 = this.sDataObjectCount;
            this.sDataObjectCount = v2 + 1;
            X509CRLObject v0 = new X509CRLObject(CertificateList.getInstance(v1.getObjectAt(v2)));
        }

        return v0_1;
    }

    private CRL readDERCRL(InputStream arg5) {
        CRL v0_1;
        ASN1Primitive v0 = new ASN1InputStream(arg5).readObject();
        if(((ASN1Sequence)v0).size() <= 1 || !(((ASN1Sequence)v0).getObjectAt(0) instanceof DERObjectIdentifier) || !((ASN1Sequence)v0).getObjectAt(0).equals(PKCSObjectIdentifiers.signedData)) {
            X509CRLObject v0_2 = new X509CRLObject(CertificateList.getInstance(v0));
        }
        else {
            this.sData = new SignedData(ASN1Sequence.getInstance(((ASN1Sequence)v0).getObjectAt(1), true)).getCRLs();
            v0_1 = this.getCRL();
        }

        return v0_1;
    }

    private CRL readPEMCRL(InputStream arg3) {
        X509CRLObject v0;
        ASN1Sequence v1 = X509CRLParser.PEM_PARSER.readPEMObject(arg3);
        if(v1 != null) {
            v0 = new X509CRLObject(CertificateList.getInstance(v1));
        }
        else {
            CRL v0_1 = null;
        }

        return ((CRL)v0);
    }
}

