// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.security.cert.Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.SignedData;
import org.bouncycastle.x509.X509StreamParserSpi;
import org.bouncycastle.x509.util.StreamParsingException;

public class X509CertParser extends X509StreamParserSpi {
    private static final PEMUtil PEM_PARSER;
    private InputStream currentStream;
    private ASN1Set sData;
    private int sDataObjectCount;

    static {
        X509CertParser.PEM_PARSER = new PEMUtil("CERTIFICATE");
    }

    public X509CertParser() {
        super();
        this.sData = null;
        this.sDataObjectCount = 0;
        this.currentStream = null;
    }

    public void engineInit(InputStream arg3) {
        this.currentStream = arg3;
        this.sData = null;
        this.sDataObjectCount = 0;
        if(!this.currentStream.markSupported()) {
            this.currentStream = new BufferedInputStream(this.currentStream);
        }
    }

    public Object engineRead() {
        Certificate v0_2;
        Object v0 = null;
        try {
            if(this.sData == null) {
                this.currentStream.mark(10);
                int v1 = this.currentStream.read();
                if(v1 != -1) {
                    if(v1 != 48) {
                        this.currentStream.reset();
                        v0_2 = this.readPEMCertificate(this.currentStream);
                    }
                    else {
                        this.currentStream.reset();
                        v0_2 = this.readDERCertificate(this.currentStream);
                    }
                }
            }
            else if(this.sDataObjectCount != this.sData.size()) {
                v0_2 = this.getCertificate();
            }
            else {
                this.sData = null;
                this.sDataObjectCount = 0;
            }

            return v0_2;
        }
        catch(Exception v0_1) {
            throw new StreamParsingException(v0_1.toString(), ((Throwable)v0_1));
        }
    }

    public Collection engineReadAll() {
        ArrayList v1 = new ArrayList();
        while(true) {
            Object v0 = this.engineRead();
            if(v0 == null) {
                break;
            }

            ((List)v1).add(v0);
        }

        return ((Collection)v1);
    }

    private Certificate getCertificate() {
        X509CertificateObject v0_1;
        ASN1Encodable v1_1;
        if(this.sData != null) {
            do {
                if(this.sDataObjectCount < this.sData.size()) {
                    ASN1Set v0 = this.sData;
                    int v1 = this.sDataObjectCount;
                    this.sDataObjectCount = v1 + 1;
                    v1_1 = v0.getObjectAt(v1);
                    if(!(v1_1 instanceof ASN1Sequence)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_17;
                }
            }
            while(true);

            v0_1 = new X509CertificateObject(org.bouncycastle.asn1.x509.Certificate.getInstance(v1_1));
        }
        else {
        label_17:
            Certificate v0_2 = null;
        }

        return ((Certificate)v0_1);
    }

    private Certificate readDERCertificate(InputStream arg5) {
        X509CertificateObject v0_2;
        ASN1Primitive v0 = new ASN1InputStream(arg5).readObject();
        if(((ASN1Sequence)v0).size() <= 1 || !(((ASN1Sequence)v0).getObjectAt(0) instanceof DERObjectIdentifier) || !((ASN1Sequence)v0).getObjectAt(0).equals(PKCSObjectIdentifiers.signedData)) {
            v0_2 = new X509CertificateObject(org.bouncycastle.asn1.x509.Certificate.getInstance(v0));
        }
        else {
            this.sData = new SignedData(ASN1Sequence.getInstance(((ASN1Sequence)v0).getObjectAt(1), true)).getCertificates();
            Certificate v0_1 = this.getCertificate();
        }

        return ((Certificate)v0_2);
    }

    private Certificate readPEMCertificate(InputStream arg3) {
        Certificate v0_1;
        ASN1Sequence v1 = X509CertParser.PEM_PARSER.readPEMObject(arg3);
        if(v1 != null) {
            X509CertificateObject v0 = new X509CertificateObject(org.bouncycastle.asn1.x509.Certificate.getInstance(v1));
        }
        else {
            v0_1 = null;
        }

        return v0_1;
    }
}

