// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CRL;
import java.security.cert.CRLSelector;
import java.security.cert.CertSelector;
import java.security.cert.CertStoreException;
import java.security.cert.CertStoreParameters;
import java.security.cert.CertStoreSpi;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.security.cert.X509CRLSelector;
import java.security.cert.X509CertSelector;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Set;
import javax.naming.NamingEnumeration;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.x509.CertificatePair;
import org.bouncycastle.jce.X509LDAPCertStoreParameters;

public class X509LDAPCertStoreSpi extends CertStoreSpi {
    private static String LDAP_PROVIDER = null;
    private static String REFERRALS_IGNORE = null;
    private static final String SEARCH_SECURITY_LEVEL = "none";
    private static final String URL_CONTEXT_PREFIX = "com.sun.jndi.url";
    private X509LDAPCertStoreParameters params;

    static {
        X509LDAPCertStoreSpi.LDAP_PROVIDER = "com.sun.jndi.ldap.LdapCtxFactory";
        X509LDAPCertStoreSpi.REFERRALS_IGNORE = "ignore";
    }

    public X509LDAPCertStoreSpi(CertStoreParameters arg4) {
        super(arg4);
        if(!(arg4 instanceof X509LDAPCertStoreParameters)) {
            throw new InvalidAlgorithmParameterException(X509LDAPCertStoreSpi.class.getName() + ": parameter must be a " + X509LDAPCertStoreParameters.class.getName() + " object\n" + arg4.toString());
        }

        this.params = ((X509LDAPCertStoreParameters)arg4);
    }

    private Set certSubjectSerialSearch(X509CertSelector arg6, String[] arg7, String arg8, String arg9) {
        String v1;
        HashSet v2 = new HashSet();
        try {
            if(arg6.getSubjectAsBytes() != null || arg6.getSubjectAsString() != null || arg6.getCertificate() != null) {
                String v0_1 = null;
                if(arg6.getCertificate() != null) {
                    v1 = arg6.getCertificate().getSubjectX500Principal().getName("RFC1779");
                    v0_1 = arg6.getCertificate().getSerialNumber().toString();
                }
                else if(arg6.getSubjectAsBytes() != null) {
                    v1 = new X500Principal(arg6.getSubjectAsBytes()).getName("RFC1779");
                }
                else {
                    v1 = arg6.getSubjectAsString();
                }

                ((Set)v2).addAll(this.search(arg8, "*" + this.parseDN(v1, arg9) + "*", arg7));
                if(v0_1 == null) {
                    goto label_45;
                }

                if(this.params.getSearchForSerialNumberIn() == null) {
                    goto label_45;
                }

                ((Set)v2).addAll(this.search(this.params.getSearchForSerialNumberIn(), "*" + v0_1 + "*", arg7));
            }
            else {
                ((Set)v2).addAll(this.search(arg8, "*", arg7));
            }

        label_45:
            return ((Set)v2);
        }
        catch(IOException v0) {
            throw new CertStoreException("exception processing selector: " + v0);
        }
    }

    private DirContext connectLDAP() {
        Properties v0 = new Properties();
        v0.setProperty("java.naming.factory.initial", X509LDAPCertStoreSpi.LDAP_PROVIDER);
        v0.setProperty("java.naming.batchsize", "0");
        v0.setProperty("java.naming.provider.url", this.params.getLdapURL());
        v0.setProperty("java.naming.factory.url.pkgs", "com.sun.jndi.url");
        v0.setProperty("java.naming.referral", X509LDAPCertStoreSpi.REFERRALS_IGNORE);
        v0.setProperty("java.naming.security.authentication", "none");
        return new InitialDirContext(((Hashtable)v0));
    }

    public Collection engineGetCRLs(CRLSelector arg9) {
        String[] v1 = new String[]{this.params.getCertificateRevocationListAttribute()};
        if(!(arg9 instanceof X509CRLSelector)) {
            throw new CertStoreException("selector is not a X509CRLSelector");
        }

        HashSet v2 = new HashSet();
        String v3 = this.params.getLdapCertificateRevocationListAttributeName();
        HashSet v4 = new HashSet();
        if(((X509CRLSelector)arg9).getIssuerNames() != null) {
            Iterator v5 = ((X509CRLSelector)arg9).getIssuerNames().iterator();
            while(v5.hasNext()) {
                Object v0 = v5.next();
                String v0_1 = (v0 instanceof String) ? this.parseDN(((String)v0), this.params.getCertificateRevocationListIssuerAttributeName()) : this.parseDN(new X500Principal(((byte[])v0)).getName("RFC1779"), this.params.getCertificateRevocationListIssuerAttributeName());
                ((Set)v4).addAll(this.search(v3, "*" + v0_1 + "*", v1));
            }
        }
        else {
            ((Set)v4).addAll(this.search(v3, "*", v1));
        }

        ((Set)v4).addAll(this.search(null, "*", v1));
        Iterator v1_1 = ((Set)v4).iterator();
        try {
            CertificateFactory v3_1 = CertificateFactory.getInstance("X.509", "BC");
            while(v1_1.hasNext()) {
                CRL v0_3 = v3_1.generateCRL(new ByteArrayInputStream(v1_1.next()));
                if(!((X509CRLSelector)arg9).match(v0_3)) {
                    continue;
                }

                ((Set)v2).add(v0_3);
            }
        }
        catch(Exception v0_2) {
            goto label_79;
        }

        return ((Collection)v2);
    label_79:
        throw new CertStoreException("CRL cannot be constructed from LDAP result " + v0_2);
    }

    public Collection engineGetCertificates(CertSelector arg7) {
        ByteArrayInputStream v5;
        Iterator v4_1;
        ArrayList v4;
        Object v0_2;
        CertificateFactory v3;
        if(!(arg7 instanceof X509CertSelector)) {
            throw new CertStoreException("selector is not a X509CertSelector");
        }

        HashSet v1 = new HashSet();
        Set v0 = this.getEndCertificates(((X509CertSelector)arg7));
        v0.addAll(this.getCACertificates(((X509CertSelector)arg7)));
        v0.addAll(this.getCrossCertificates(((X509CertSelector)arg7)));
        Iterator v2 = v0.iterator();
        try {
            v3 = CertificateFactory.getInstance("X.509", "BC");
            do {
            label_17:
                if(!v2.hasNext()) {
                    goto label_64;
                }

                v0_2 = v2.next();
                if(v0_2 == null) {
                    goto label_17;
                }
            }
            while(v0_2.length == 0);

            v4 = new ArrayList();
            ((List)v4).add(v0_2);
            try {
                CertificatePair v0_5 = CertificatePair.getInstance(new ASN1InputStream(((byte[])v0_2)).readObject());
                ((List)v4).clear();
                if(v0_5.getForward() != null) {
                    ((List)v4).add(v0_5.getForward().getEncoded());
                }

                if(v0_5.getReverse() == null) {
                    goto label_41;
                }

                ((List)v4).add(v0_5.getReverse().getEncoded());
            }
            catch(IllegalArgumentException v0_3) {
            }
            catch(IOException v0_4) {
            }
        }
        catch(Exception v0_1) {
            goto label_63;
        }

        try {
        label_41:
            v4_1 = ((List)v4).iterator();
            goto label_42;
        }
        catch(Exception v0_1) {
            goto label_63;
        }

    label_64:
        return ((Collection)v1);
        try {
            while(true) {
            label_42:
                if(!v4_1.hasNext()) {
                    goto label_17;
                }

                v5 = new ByteArrayInputStream(v4_1.next());
                break;
            }
        }
        catch(Exception v0_1) {
            goto label_63;
        }

        try {
            Certificate v0_6 = v3.generateCertificate(((InputStream)v5));
            if(!((X509CertSelector)arg7).match(v0_6)) {
                goto label_42;
            }

            ((Set)v1).add(v0_6);
        }
        catch(Exception v0_1) {
        }

        goto label_42;
    label_63:
        throw new CertStoreException("certificate cannot be constructed from LDAP result: " + v0_1);
    }

    private Set getCACertificates(X509CertSelector arg5) {
        String[] v0 = new String[]{this.params.getCACertificateAttribute()};
        Set v1 = this.certSubjectSerialSearch(arg5, v0, this.params.getLdapCACertificateAttributeName(), this.params.getCACertificateSubjectAttributeName());
        if(v1.isEmpty()) {
            v1.addAll(this.search(null, "*", v0));
        }

        return v1;
    }

    private Set getCrossCertificates(X509CertSelector arg5) {
        String[] v0 = new String[]{this.params.getCrossCertificateAttribute()};
        Set v1 = this.certSubjectSerialSearch(arg5, v0, this.params.getLdapCrossCertificateAttributeName(), this.params.getCrossCertificateSubjectAttributeName());
        if(v1.isEmpty()) {
            v1.addAll(this.search(null, "*", v0));
        }

        return v1;
    }

    private Set getEndCertificates(X509CertSelector arg4) {
        return this.certSubjectSerialSearch(arg4, new String[]{this.params.getUserCertificateAttribute()}, this.params.getLdapUserCertificateAttributeName(), this.params.getUserCertificateSubjectAttributeName());
    }

    private String parseDN(String arg9, String arg10) {
        int v7 = 44;
        int v5 = -1;
        String v1 = arg9.substring(arg9.toLowerCase().indexOf(arg10.toLowerCase()) + arg10.length());
        int v0 = v1.indexOf(v7);
        if(v0 == v5) {
            v0 = v1.length();
        }

        while(v1.charAt(v0 - 1) == 92) {
            v0 = v1.indexOf(v7, v0 + 1);
            if(v0 != v5) {
                continue;
            }

            v0 = v1.length();
        }

        String v0_1 = v1.substring(0, v0);
        v0_1 = v0_1.substring(v0_1.indexOf(61) + 1);
        if(v0_1.charAt(0) == 32) {
            v0_1 = v0_1.substring(1);
        }

        if(v0_1.startsWith("\"")) {
            v0_1 = v0_1.substring(1);
        }

        if(v0_1.endsWith("\"")) {
            v0_1 = v0_1.substring(0, v0_1.length() - 1);
        }

        return v0_1;
    }

    private Set search(String arg10, String arg11, String[] arg12) {
        Exception v0_1;
        DirContext v1_3;
        Throwable v0_2;
        DirContext v2;
        DirContext v0 = null;
        int v3 = 0;
        String v1 = arg10 + "=" + arg11;
        if(arg10 == null) {
            v1 = ((String)v0);
        }

        HashSet v4 = new HashSet();
        try {
            v2 = this.connectLDAP();
        }
        catch(Throwable v1_1) {
            v2 = v0;
            v0_2 = v1_1;
            goto label_80;
        }
        catch(Exception v1_2) {
            Exception v8 = v1_2;
            v1_3 = v0;
            v0_1 = v8;
            goto label_69;
        }

        try {
            SearchControls v5 = new SearchControls();
            v5.setSearchScope(2);
            v5.setCountLimit(0);
            while(true) {
            label_20:
                if(v3 >= arg12.length) {
                    goto label_86;
                }

                String[] v6 = new String[]{arg12[v3]};
                v5.setReturningAttributes(v6);
                String v0_3 = "(&(" + v1 + ")(" + v6[0] + "=*))";
                if(v1 == null) {
                    v0_3 = "(" + v6[0] + "=*)";
                }

                NamingEnumeration v6_1 = v2.search(this.params.getBaseDN(), v0_3, v5);
            label_55:
                if(!v6_1.hasMoreElements()) {
                    break;
                }

                NamingEnumeration v0_4 = v6_1.next().getAttributes().getAll().next().getAll();
                while(true) {
                    if(!v0_4.hasMore()) {
                        goto label_55;
                    }

                    ((Set)v4).add(v0_4.next());
                }
            }
        }
        catch(Throwable v0_2) {
            goto label_80;
        }
        catch(Exception v0_1) {
            goto label_68;
        }

        ++v3;
        goto label_20;
    label_86:
        if(v2 != null) {
            try {
                v2.close();
            }
            catch(Exception v0_1) {
            }
        }

        return ((Set)v4);
    label_68:
        v1_3 = v2;
        try {
        label_69:
            throw new CertStoreException("Error getting results from LDAP directory " + v0_1);
        }
        catch(Throwable v0_2) {
            v2 = v1_3;
        }

    label_80:
        if(v2 != null) {
            try {
                v2.close();
            }
            catch(Exception v1_2) {
            }
        }

        throw v0_2;
    }
}

