// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.provider;

import java.io.IOException;
import java.security.AlgorithmParameters;
import java.security.GeneralSecurityException;
import java.security.Signature;
import java.security.SignatureException;
import java.security.spec.PSSParameterSpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Null;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.nist.NISTObjectIdentifiers;
import org.bouncycastle.asn1.oiw.OIWObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.pkcs.RSASSAPSSparams;
import org.bouncycastle.asn1.teletrust.TeleTrusTObjectIdentifiers;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x9.X9ObjectIdentifiers;

class X509SignatureUtil {
    private static final ASN1Null derNull;

    static {
        X509SignatureUtil.derNull = DERNull.INSTANCE;
    }

    X509SignatureUtil() {
        super();
    }

    private static String getDigestAlgName(DERObjectIdentifier arg1) {
        String v0;
        if(PKCSObjectIdentifiers.md5.equals(arg1)) {
            v0 = "MD5";
        }
        else if(OIWObjectIdentifiers.idSHA1.equals(arg1)) {
            v0 = "SHA1";
        }
        else if(NISTObjectIdentifiers.id_sha224.equals(arg1)) {
            v0 = "SHA224";
        }
        else if(NISTObjectIdentifiers.id_sha256.equals(arg1)) {
            v0 = "SHA256";
        }
        else if(NISTObjectIdentifiers.id_sha384.equals(arg1)) {
            v0 = "SHA384";
        }
        else if(NISTObjectIdentifiers.id_sha512.equals(arg1)) {
            v0 = "SHA512";
        }
        else if(TeleTrusTObjectIdentifiers.ripemd128.equals(arg1)) {
            v0 = "RIPEMD128";
        }
        else if(TeleTrusTObjectIdentifiers.ripemd160.equals(arg1)) {
            v0 = "RIPEMD160";
        }
        else if(TeleTrusTObjectIdentifiers.ripemd256.equals(arg1)) {
            v0 = "RIPEMD256";
        }
        else if(CryptoProObjectIdentifiers.gostR3411.equals(arg1)) {
            v0 = "GOST3411";
        }
        else {
            v0 = arg1.getId();
        }

        return v0;
    }

    static String getSignatureName(AlgorithmIdentifier arg3) {
        String v0_1;
        ASN1Encodable v0 = arg3.getParameters();
        if(v0 == null || (X509SignatureUtil.derNull.equals(v0))) {
        label_35:
            v0_1 = arg3.getObjectId().getId();
        }
        else if(arg3.getObjectId().equals(PKCSObjectIdentifiers.id_RSASSA_PSS)) {
            v0_1 = X509SignatureUtil.getDigestAlgName(RSASSAPSSparams.getInstance(v0).getHashAlgorithm().getObjectId()) + "withRSAandMGF1";
        }
        else if(arg3.getObjectId().equals(X9ObjectIdentifiers.ecdsa_with_SHA2)) {
            v0_1 = X509SignatureUtil.getDigestAlgName(ASN1Sequence.getInstance(v0).getObjectAt(0)) + "withECDSA";
        }
        else {
            goto label_35;
        }

        return v0_1;
    }

    static void setSignatureParameters(Signature arg4, ASN1Encodable arg5) {
        if(arg5 != null && !X509SignatureUtil.derNull.equals(arg5)) {
            AlgorithmParameters v0 = AlgorithmParameters.getInstance(arg4.getAlgorithm(), arg4.getProvider());
            try {
                v0.init(arg5.toASN1Primitive().getEncoded());
            }
            catch(IOException v0_1) {
                throw new SignatureException("IOException decoding parameters: " + v0_1.getMessage());
            }

            if(arg4.getAlgorithm().endsWith("MGF1")) {
                try {
                    arg4.setParameter(v0.getParameterSpec(PSSParameterSpec.class));
                }
                catch(GeneralSecurityException v0_2) {
                    throw new SignatureException("Exception extracting parameters: " + v0_2.getMessage());
                }
            }
        }
    }
}

