// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.jce.spec;

import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.cryptopro.CryptoProObjectIdentifiers;
import org.bouncycastle.asn1.cryptopro.GOST3410NamedParameters;
import org.bouncycastle.asn1.cryptopro.GOST3410ParamSetParameters;
import org.bouncycastle.asn1.cryptopro.GOST3410PublicKeyAlgParameters;
import org.bouncycastle.jce.interfaces.GOST3410Params;

public class GOST3410ParameterSpec implements AlgorithmParameterSpec, GOST3410Params {
    private String digestParamSetOID;
    private String encryptionParamSetOID;
    private String keyParamSetOID;
    private GOST3410PublicKeyParameterSetSpec keyParameters;

    public GOST3410ParameterSpec(GOST3410PublicKeyParameterSetSpec arg2) {
        super();
        this.keyParameters = arg2;
        this.digestParamSetOID = CryptoProObjectIdentifiers.gostR3411_94_CryptoProParamSet.getId();
        this.encryptionParamSetOID = null;
    }

    public GOST3410ParameterSpec(String arg5, String arg6, String arg7) {
        GOST3410ParamSetParameters v0;
        super();
        try {
            v0 = GOST3410NamedParameters.getByOID(new ASN1ObjectIdentifier(arg5));
        }
        catch(IllegalArgumentException v1) {
            ASN1ObjectIdentifier v1_1 = GOST3410NamedParameters.getOID(arg5);
            if(v1_1 == null) {
                goto label_5;
            }

            arg5 = v1_1.getId();
            v0 = GOST3410NamedParameters.getByOID(v1_1);
        }

    label_5:
        if(v0 == null) {
            throw new IllegalArgumentException("no key parameter set for passed in name/OID.");
        }

        this.keyParameters = new GOST3410PublicKeyParameterSetSpec(v0.getP(), v0.getQ(), v0.getA());
        this.keyParamSetOID = arg5;
        this.digestParamSetOID = arg6;
        this.encryptionParamSetOID = arg7;
    }

    public GOST3410ParameterSpec(String arg3) {
        this(arg3, CryptoProObjectIdentifiers.gostR3411_94_CryptoProParamSet.getId(), null);
    }

    public GOST3410ParameterSpec(String arg2, String arg3) {
        this(arg2, arg3, null);
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof GOST3410ParameterSpec)) && (this.keyParameters.equals(((GOST3410ParameterSpec)arg4).keyParameters)) && (this.digestParamSetOID.equals(((GOST3410ParameterSpec)arg4).digestParamSetOID))) {
            if(this.encryptionParamSetOID != ((GOST3410ParameterSpec)arg4).encryptionParamSetOID) {
                if(this.encryptionParamSetOID == null) {
                }
                else if(this.encryptionParamSetOID.equals(((GOST3410ParameterSpec)arg4).encryptionParamSetOID)) {
                    goto label_20;
                }

                return v0;
            }

        label_20:
            v0 = true;
        }

        return v0;
    }

    public static GOST3410ParameterSpec fromPublicKeyAlg(GOST3410PublicKeyAlgParameters arg4) {
        GOST3410ParameterSpec v0 = arg4.getEncryptionParamSet() != null ? new GOST3410ParameterSpec(arg4.getPublicKeyParamSet().getId(), arg4.getDigestParamSet().getId(), arg4.getEncryptionParamSet().getId()) : new GOST3410ParameterSpec(arg4.getPublicKeyParamSet().getId(), arg4.getDigestParamSet().getId());
        return v0;
    }

    public String getDigestParamSetOID() {
        return this.digestParamSetOID;
    }

    public String getEncryptionParamSetOID() {
        return this.encryptionParamSetOID;
    }

    public String getPublicKeyParamSetOID() {
        return this.keyParamSetOID;
    }

    public GOST3410PublicKeyParameterSetSpec getPublicKeyParameters() {
        return this.keyParameters;
    }

    public int hashCode() {
        int v1 = this.digestParamSetOID.hashCode() ^ this.keyParameters.hashCode();
        int v0 = this.encryptionParamSetOID != null ? this.encryptionParamSetOID.hashCode() : 0;
        return v0 ^ v1;
    }
}

