// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;

public class ECAlgorithms {
    public ECAlgorithms() {
        super();
    }

    private static ECPoint implShamirsTrick(ECPoint arg5, BigInteger arg6, ECPoint arg7, BigInteger arg8) {
        int v0 = Math.max(arg6.bitLength(), arg8.bitLength());
        ECPoint v2 = arg5.add(arg7);
        int v4 = v0 - 1;
        ECPoint v0_1 = arg5.getCurve().getInfinity();
        int v1;
        for(v1 = v4; v1 >= 0; --v1) {
            v0_1 = v0_1.twice();
            if(arg6.testBit(v1)) {
                v0_1 = arg8.testBit(v1) ? v0_1.add(v2) : v0_1.add(arg5);
            }
            else if(arg8.testBit(v1)) {
                v0_1 = v0_1.add(arg7);
            }
        }

        return v0_1;
    }

    public static ECPoint shamirsTrick(ECPoint arg2, BigInteger arg3, ECPoint arg4, BigInteger arg5) {
        if(!arg2.getCurve().equals(arg4.getCurve())) {
            throw new IllegalArgumentException("P and Q must be on same curve");
        }

        return ECAlgorithms.implShamirsTrick(arg2, arg3, arg4, arg5);
    }

    public static ECPoint sumOfTwoMultiplies(ECPoint arg2, BigInteger arg3, ECPoint arg4, BigInteger arg5) {
        ECCurve v0 = arg2.getCurve();
        if(!v0.equals(arg4.getCurve())) {
            throw new IllegalArgumentException("P and Q must be on same curve");
        }

        ECPoint v0_1 = !(v0 instanceof ECCurve$F2m) || !((ECCurve$F2m)v0).isKoblitz() ? ECAlgorithms.implShamirsTrick(arg2, arg3, arg4, arg5) : arg2.multiply(arg3).add(arg4.multiply(arg5));
        return v0_1;
    }
}

