// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;
import java.util.Random;

public class ECCurve$F2m extends ECCurve {
    private BigInteger h;
    private ECPoint$F2m infinity;
    private int k1;
    private int k2;
    private int k3;
    private int m;
    private byte mu;
    private BigInteger n;
    private BigInteger[] si;

    public ECCurve$F2m(int arg10, int arg11, BigInteger arg12, BigInteger arg13, BigInteger arg14, BigInteger arg15) {
        this(arg10, arg11, 0, 0, arg12, arg13, arg14, arg15);
    }

    public ECCurve$F2m(int arg3, int arg4, int arg5, int arg6, BigInteger arg7, BigInteger arg8, BigInteger arg9, BigInteger arg10) {
        BigInteger[] v1 = null;
        super();
        this.mu = 0;
        this.si = v1;
        this.m = arg3;
        this.k1 = arg4;
        this.k2 = arg5;
        this.k3 = arg6;
        this.n = arg9;
        this.h = arg10;
        if(arg4 == 0) {
            throw new IllegalArgumentException("k1 must be > 0");
        }

        if(arg5 == 0) {
            if(arg6 != 0) {
                throw new IllegalArgumentException("k3 must be 0 if k2 == 0");
            }
        }
        else if(arg5 <= arg4) {
            throw new IllegalArgumentException("k2 must be > k1");
        }
        else if(arg6 <= arg5) {
            throw new IllegalArgumentException("k3 must be > k2");
        }

        this.a = this.fromBigInteger(arg7);
        this.b = this.fromBigInteger(arg8);
        this.infinity = new ECPoint$F2m(((ECCurve)this), ((ECFieldElement)v1), ((ECFieldElement)v1));
    }

    public ECCurve$F2m(int arg10, int arg11, int arg12, int arg13, BigInteger arg14, BigInteger arg15) {
        this(arg10, arg11, arg12, arg13, arg14, arg15, null, null);
    }

    public ECCurve$F2m(int arg10, int arg11, BigInteger arg12, BigInteger arg13) {
        this(arg10, arg11, 0, 0, arg12, arg13, null, null);
    }

    public ECPoint createPoint(BigInteger arg4, BigInteger arg5, boolean arg6) {
        return new ECPoint$F2m(((ECCurve)this), this.fromBigInteger(arg4), this.fromBigInteger(arg5), arg6);
    }

    protected ECPoint decompressPoint(int arg8, BigInteger arg9) {
        ECFieldElement v1_1;
        int v1 = 0;
        ECFieldElement v3 = this.fromBigInteger(arg9);
        if(v3.toBigInteger().equals(ECConstants.ZERO)) {
            v1_1 = this.b;
            int v0;
            for(v0 = 0; v0 < this.m - 1; ++v0) {
                v1_1 = v1_1.square();
            }
        }
        else {
            ECFieldElement v0_1 = this.solveQuadradicEquation(v3.add(this.a).add(this.b.multiply(v3.square().invert())));
            if(v0_1 == null) {
                throw new IllegalArgumentException("Invalid point compression");
            }
            else {
                if(v0_1.toBigInteger().testBit(0)) {
                    v1 = 1;
                }

                if(v1 != arg8) {
                    v0_1 = v0_1.add(this.fromBigInteger(ECConstants.ONE));
                }

                v1_1 = v3.multiply(v0_1);
            }
        }

        return new ECPoint$F2m(((ECCurve)this), v3, v1_1, true);
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if((((ECCurve$F2m)arg5)) != this) {
            if(!(arg5 instanceof ECCurve$F2m)) {
                v0 = false;
            }
            else {
                if(this.m == ((ECCurve$F2m)arg5).m && this.k1 == ((ECCurve$F2m)arg5).k1 && this.k2 == ((ECCurve$F2m)arg5).k2 && this.k3 == ((ECCurve$F2m)arg5).k3 && (this.a.equals(((ECCurve$F2m)arg5).a)) && (this.b.equals(((ECCurve$F2m)arg5).b))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public ECFieldElement fromBigInteger(BigInteger arg7) {
        return new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, arg7);
    }

    public int getFieldSize() {
        return this.m;
    }

    public BigInteger getH() {
        return this.h;
    }

    public ECPoint getInfinity() {
        return this.infinity;
    }

    public int getK1() {
        return this.k1;
    }

    public int getK2() {
        return this.k2;
    }

    public int getK3() {
        return this.k3;
    }

    public int getM() {
        return this.m;
    }

    byte getMu() {
        byte v0_1;
        __monitor_enter(this);
        try {
            if(this.mu == 0) {
                this.mu = Tnaf.getMu(this);
            }

            v0_1 = this.mu;
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
        return v0_1;
    }

    public BigInteger getN() {
        return this.n;
    }

    BigInteger[] getSi() {
        BigInteger[] v0_1;
        __monitor_enter(this);
        try {
            if(this.si == null) {
                this.si = Tnaf.getSi(this);
            }

            v0_1 = this.si;
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
        return v0_1;
    }

    public int hashCode() {
        return this.a.hashCode() ^ this.b.hashCode() ^ this.m ^ this.k1 ^ this.k2 ^ this.k3;
    }

    public boolean isKoblitz() {
        boolean v0;
        if(this.n == null || this.h == null) {
        label_21:
            v0 = false;
        }
        else {
            if(!this.a.toBigInteger().equals(ECConstants.ZERO) && !this.a.toBigInteger().equals(ECConstants.ONE)) {
                goto label_21;
            }

            if(!this.b.toBigInteger().equals(ECConstants.ONE)) {
                goto label_21;
            }

            v0 = true;
        }

        return v0;
    }

    public boolean isTrinomial() {
        boolean v0 = this.k2 != 0 || this.k3 != 0 ? false : true;
        return v0;
    }

    private ECFieldElement solveQuadradicEquation(ECFieldElement arg10) {
        ECFieldElement v0_1;
        ECFieldElement v4_1;
        ECFieldElement$F2m v0 = new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, ECConstants.ZERO);
        if(!arg10.toBigInteger().equals(ECConstants.ZERO)) {
            Random v7 = new Random();
            do {
                ECFieldElement$F2m v1 = new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, new BigInteger(this.m, v7));
                int v2 = 1;
                ECFieldElement v3 = arg10;
                ECFieldElement$F2m v4 = v0;
                while(v2 <= this.m - 1) {
                    v3 = v3.square();
                    v4_1 = v4_1.square().add(v3.multiply(((ECFieldElement)v1)));
                    v3 = v3.add(arg10);
                    ++v2;
                }

                if(!v3.toBigInteger().equals(ECConstants.ZERO)) {
                    v0_1 = null;
                }
                else {
                    if(v4_1.square().add(v4_1).toBigInteger().equals(ECConstants.ZERO)) {
                        continue;
                    }

                    break;
                }

                return v0_1;
            }
            while(true);

            v0 = ((ECFieldElement$F2m)v4_1);
        }

        return v0_1;
    }
}

