// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;

public class ECFieldElement$F2m extends ECFieldElement {
    public static final int GNB = 1;
    public static final int PPB = 3;
    public static final int TPB = 2;
    private int k1;
    private int k2;
    private int k3;
    private int m;
    private int representation;
    private int t;
    private IntArray x;

    public ECFieldElement$F2m(int arg3, int arg4, int arg5, int arg6, BigInteger arg7) {
        super();
        this.t = arg3 + 31 >> 5;
        this.x = new IntArray(arg7, this.t);
        if(arg5 == 0 && arg6 == 0) {
            this.representation = 2;
        }
        else if(arg5 >= arg6) {
            throw new IllegalArgumentException("k2 must be smaller than k3");
        }
        else if(arg5 <= 0) {
            throw new IllegalArgumentException("k2 must be larger than 0");
        }
        else {
            this.representation = 3;
        }

        if(arg7.signum() < 0) {
            throw new IllegalArgumentException("x value cannot be negative");
        }

        this.m = arg3;
        this.k1 = arg4;
        this.k2 = arg5;
        this.k3 = arg6;
    }

    private ECFieldElement$F2m(int arg2, int arg3, int arg4, int arg5, IntArray arg6) {
        super();
        this.t = arg2 + 31 >> 5;
        this.x = arg6;
        this.m = arg2;
        this.k1 = arg3;
        this.k2 = arg4;
        this.k3 = arg5;
        this.representation = arg4 != 0 || arg5 != 0 ? 3 : 2;
    }

    public ECFieldElement$F2m(int arg7, int arg8, BigInteger arg9) {
        this(arg7, arg8, 0, 0, arg9);
    }

    public ECFieldElement add(ECFieldElement arg7) {
        Object v5 = this.x.clone();
        ((IntArray)v5).addShifted(((ECFieldElement$F2m)arg7).x, 0);
        return new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, ((IntArray)v5));
    }

    public static void checkFieldElements(ECFieldElement arg2, ECFieldElement arg3) {
        if(((arg2 instanceof ECFieldElement$F2m)) && ((arg3 instanceof ECFieldElement$F2m))) {
            if(((ECFieldElement$F2m)arg2).m == ((ECFieldElement$F2m)arg3).m && ((ECFieldElement$F2m)arg2).k1 == ((ECFieldElement$F2m)arg3).k1 && ((ECFieldElement$F2m)arg2).k2 == ((ECFieldElement$F2m)arg3).k2 && ((ECFieldElement$F2m)arg2).k3 == ((ECFieldElement$F2m)arg3).k3) {
                if(((ECFieldElement$F2m)arg2).representation != ((ECFieldElement$F2m)arg3).representation) {
                    throw new IllegalArgumentException("One of the field elements are not elements has incorrect representation");
                }
                else {
                    return;
                }
            }

            throw new IllegalArgumentException("Field elements are not elements of the same field F2m");
        }

        throw new IllegalArgumentException("Field elements are not both instances of ECFieldElement.F2m");
    }

    public ECFieldElement divide(ECFieldElement arg2) {
        return this.multiply(arg2.invert());
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if((((ECFieldElement$F2m)arg5)) != this) {
            if(!(arg5 instanceof ECFieldElement$F2m)) {
                v0 = false;
            }
            else {
                if(this.m == ((ECFieldElement$F2m)arg5).m && this.k1 == ((ECFieldElement$F2m)arg5).k1 && this.k2 == ((ECFieldElement$F2m)arg5).k2 && this.k3 == ((ECFieldElement$F2m)arg5).k3 && this.representation == ((ECFieldElement$F2m)arg5).representation && (this.x.equals(((ECFieldElement$F2m)arg5).x))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public String getFieldName() {
        return "F2m";
    }

    public int getFieldSize() {
        return this.m;
    }

    public int getK1() {
        return this.k1;
    }

    public int getK2() {
        return this.k2;
    }

    public int getK3() {
        return this.k3;
    }

    public int getM() {
        return this.m;
    }

    public int getRepresentation() {
        return this.representation;
    }

    public int hashCode() {
        return this.x.hashCode() ^ this.m ^ this.k1 ^ this.k2 ^ this.k3;
    }

    public ECFieldElement invert() {
        Object v1_1;
        Object v0 = this.x.clone();
        IntArray v2 = new IntArray(this.t);
        v2.setBit(this.m);
        v2.setBit(0);
        v2.setBit(this.k1);
        if(this.representation == 3) {
            v2.setBit(this.k2);
            v2.setBit(this.k3);
        }

        IntArray v1 = new IntArray(this.t);
        v1.setBit(0);
        IntArray v5 = new IntArray(this.t);
        IntArray v7 = v1;
        v1 = v2;
        Object v2_1 = v0;
        IntArray v0_1 = v7;
        while(!((IntArray)v2_1).isZero()) {
            int v3 = ((IntArray)v2_1).bitLength() - v1.bitLength();
            if(v3 < 0) {
                v3 = -v3;
                v7 = v0_1;
                v0_1 = v5;
                v5 = v7;
                Object v8 = v2_1;
                v2 = v1;
                v1_1 = v8;
            }

            int v4 = v3 >> 5;
            v3 &= 31;
            v2.addShifted(((IntArray)v1_1).shiftLeft(v3), v4);
            v0_1.addShifted(v5.shiftLeft(v3), v4);
        }

        return new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, v5);
    }

    public ECFieldElement multiply(ECFieldElement arg7) {
        IntArray v5 = this.x.multiply(((ECFieldElement$F2m)arg7).x, this.m);
        v5.reduce(this.m, new int[]{this.k1, this.k2, this.k3});
        return new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, v5);
    }

    public ECFieldElement negate() {
        return this;
    }

    public ECFieldElement sqrt() {
        throw new RuntimeException("Not implemented");
    }

    public ECFieldElement square() {
        IntArray v5 = this.x.square(this.m);
        v5.reduce(this.m, new int[]{this.k1, this.k2, this.k3});
        return new ECFieldElement$F2m(this.m, this.k1, this.k2, this.k3, v5);
    }

    public ECFieldElement subtract(ECFieldElement arg2) {
        return this.add(arg2);
    }

    public BigInteger toBigInteger() {
        return this.x.toBigInteger();
    }
}

