// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;
import org.bouncycastle.asn1.x9.X9IntegerConverter;

public abstract class ECPoint {
    private static X9IntegerConverter converter;
    ECCurve curve;
    protected ECMultiplier multiplier;
    protected PreCompInfo preCompInfo;
    protected boolean withCompression;
    ECFieldElement x;
    ECFieldElement y;

    static {
        ECPoint.converter = new X9IntegerConverter();
    }

    protected ECPoint(ECCurve arg2, ECFieldElement arg3, ECFieldElement arg4) {
        super();
        this.multiplier = null;
        this.preCompInfo = null;
        this.curve = arg2;
        this.x = arg3;
        this.y = arg4;
    }

    static X9IntegerConverter access$000() {
        return ECPoint.converter;
    }

    public abstract ECPoint add(ECPoint arg1);

    void assertECMultiplier() {
        __monitor_enter(this);
        try {
            if(this.multiplier == null) {
                this.multiplier = new FpNafMultiplier();
            }
        }
        catch(Throwable v0) {
            __monitor_exit(this);
            throw v0;
        }

        __monitor_exit(this);
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if((((ECPoint)arg5)) != this) {
            if(!(arg5 instanceof ECPoint)) {
                v0 = false;
            }
            else if(this.isInfinity()) {
                v0 = ((ECPoint)arg5).isInfinity();
            }
            else {
                if((this.x.equals(((ECPoint)arg5).x)) && (this.y.equals(((ECPoint)arg5).y))) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public ECCurve getCurve() {
        return this.curve;
    }

    public byte[] getEncoded() {
        return this.getEncoded(this.withCompression);
    }

    public abstract byte[] getEncoded(boolean arg1);

    public ECFieldElement getX() {
        return this.x;
    }

    public ECFieldElement getY() {
        return this.y;
    }

    public int hashCode() {
        int v0 = this.isInfinity() ? 0 : this.x.hashCode() ^ this.y.hashCode();
        return v0;
    }

    public boolean isCompressed() {
        return this.withCompression;
    }

    public boolean isInfinity() {
        boolean v0 = this.x != null || this.y != null ? false : true;
        return v0;
    }

    public ECPoint multiply(BigInteger arg3) {
        if(arg3.signum() < 0) {
            throw new IllegalArgumentException("The multiplicator cannot be negative");
        }

        if(!this.isInfinity()) {
            if(arg3.signum() == 0) {
                this = this.curve.getInfinity();
            }
            else {
                this.assertECMultiplier();
                this = this.multiplier.multiply(this, arg3, this.preCompInfo);
            }
        }

        return this;
    }

    public abstract ECPoint negate();

    void setPreCompInfo(PreCompInfo arg1) {
        this.preCompInfo = arg1;
    }

    public abstract ECPoint subtract(ECPoint arg1);

    public abstract ECPoint twice();
}

