// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;
import org.bouncycastle.util.Arrays;

class IntArray {
    private int[] m_ints;

    public IntArray(BigInteger arg8, int arg9) {
        int v0 = 1;
        super();
        if(arg8.signum() == -1) {
            throw new IllegalArgumentException("Only positive Integers allowed");
        }

        if(arg8.equals(ECConstants.ZERO)) {
            this.m_ints = new int[]{0};
        }
        else {
            byte[] v6 = arg8.toByteArray();
            int v2 = v6.length;
            if(v6[0] == 0) {
                --v2;
            }
            else {
                v0 = 0;
            }

            int v3 = (v2 + 3) / 4;
            this.m_ints = v3 < arg9 ? new int[arg9] : new int[v3];
            --v3;
            int v5 = v2 % 4 + v0;
            if(v0 < v5) {
                v2 = v0;
                int v4;
                for(v4 = 0; v2 < v5; v4 |= v0) {
                    v4 <<= 8;
                    v0 = v6[v2];
                    if(v0 < 0) {
                        v0 += 256;
                    }

                    ++v2;
                }

                this.m_ints[v3] = v4;
                v5 = v3 - 1;
                v0 = v2;
            }
            else {
                v5 = v3;
            }

            while(v5 >= 0) {
                v2 = 0;
                for(v3 = 0; v2 < 4; v3 = v4) {
                    v4 = v3 << 8;
                    v3 = v0 + 1;
                    v0 = v6[v0];
                    if(v0 < 0) {
                        v0 += 256;
                    }

                    v4 |= v0;
                    ++v2;
                    v0 = v3;
                }

                this.m_ints[v5] = v3;
                --v5;
            }
        }
    }

    public IntArray(int arg2) {
        super();
        this.m_ints = new int[arg2];
    }

    public IntArray(BigInteger arg2) {
        this(arg2, 0);
    }

    public IntArray(int[] arg1) {
        super();
        this.m_ints = arg1;
    }

    public void addShifted(IntArray arg7, int arg8) {
        int v1 = arg7.getUsedLength();
        int v0 = v1 + arg8;
        if(v0 > this.m_ints.length) {
            this.m_ints = this.resizedInts(v0);
        }

        for(v0 = 0; v0 < v1; ++v0) {
            int v3 = v0 + arg8;
            this.m_ints[v3] ^= arg7.m_ints[v0];
        }
    }

    public int bitLength() {
        int v0 = this.getUsedLength();
        if(v0 == 0) {
            v0 = 0;
        }
        else {
            --v0;
            int v1 = this.m_ints[v0];
            v0 = (v0 << 5) + 1;
            if((-65536 & v1) != 0) {
                if((-16777216 & v1) != 0) {
                    v0 += 24;
                    v1 >>>= 24;
                }
                else {
                    v0 += 16;
                    v1 >>>= 16;
                }
            }
            else if(v1 > 255) {
                v0 += 8;
                v1 >>>= 8;
            }

            while(v1 != 1) {
                ++v0;
                v1 >>>= 1;
            }
        }

        return v0;
    }

    public Object clone() {
        return new IntArray(Arrays.clone(this.m_ints));
    }

    public boolean equals(Object arg6) {
        boolean v0 = false;
        if((arg6 instanceof IntArray)) {
            int v2 = this.getUsedLength();
            if(((IntArray)arg6).getUsedLength() == v2) {
                int v1 = 0;
                while(true) {
                    if(v1 >= v2) {
                        break;
                    }
                    else if(this.m_ints[v1] == ((IntArray)arg6).m_ints[v1]) {
                        ++v1;
                        continue;
                    }

                    return v0;
                }

                v0 = true;
            }
        }

        return v0;
    }

    public void flipBit(int arg5) {
        int v0 = arg5 >> 5;
        this.m_ints[v0] ^= 1 << (arg5 & 31);
    }

    public int getLength() {
        return this.m_ints.length;
    }

    public int getUsedLength() {
        int v0 = this.m_ints.length;
        if(v0 < 1) {
            v0 = 0;
        }
        else {
            if(this.m_ints[0] != 0) {
                do {
                    --v0;
                }
                while(this.m_ints[v0] == 0);

                return;
            }

            do {
                --v0;
                if(this.m_ints[v0] != 0) {
                    goto label_20;
                }
            }
            while(v0 > 0);

            return 0;
        label_20:
            ++v0;
        }

        return v0;
    }

    public int hashCode() {
        int v2 = this.getUsedLength();
        int v1 = 1;
        int v0;
        for(v0 = 0; v0 < v2; ++v0) {
            v1 = v1 * 31 + this.m_ints[v0];
        }

        return v1;
    }

    public boolean isZero() {
        boolean v0 = false;
        if(this.m_ints.length == 0 || this.m_ints[0] == 0 && this.getUsedLength() == 0) {
            v0 = true;
        }

        return v0;
    }

    public IntArray multiply(IntArray arg9, int arg10) {
        int v4 = arg10 + 31 >> 5;
        if(this.m_ints.length < v4) {
            this.m_ints = this.resizedInts(v4);
        }

        IntArray v5 = new IntArray(arg9.resizedInts(arg9.getLength() + 1));
        IntArray v6 = new IntArray(arg10 + arg10 + 31 >> 5);
        int v2 = 0;
        int v3 = 1;
        while(v2 < 32) {
            int v0;
            for(v0 = 0; v0 < v4; ++v0) {
                if((this.m_ints[v0] & v3) != 0) {
                    v6.addShifted(v5, v0);
                }
            }

            v3 <<= 1;
            v5.shiftLeft();
            ++v2;
        }

        return v6;
    }

    public void reduce(int arg5, int[] arg6) {
        int v1;
        for(v1 = arg5 + arg5 - 2; v1 >= arg5; --v1) {
            if(this.testBit(v1)) {
                int v2 = v1 - arg5;
                this.flipBit(v2);
                this.flipBit(v1);
                int v0 = arg6.length;
                while(true) {
                    --v0;
                    if(v0 >= 0) {
                        this.flipBit(arg6[v0] + v2);
                        continue;
                    }

                    break;
                }
            }
        }

        this.m_ints = this.resizedInts(arg5 + 31 >> 5);
    }

    private int[] resizedInts(int arg4) {
        int[] v1 = new int[arg4];
        int v0 = this.m_ints.length;
        if(v0 < arg4) {
            arg4 = v0;
        }

        System.arraycopy(this.m_ints, 0, v1, 0, arg4);
        return v1;
    }

    public void setBit(int arg5) {
        int v0 = arg5 >> 5;
        this.m_ints[v0] |= 1 << (arg5 & 31);
    }

    public IntArray shiftLeft(int arg8) {
        int v1 = this.getUsedLength();
        if(v1 != 0 && arg8 != 0) {
            if(arg8 > 31) {
                throw new IllegalArgumentException("shiftLeft() for max 31 bits , " + arg8 + "bit shift is not possible");
            }
            else {
                int[] v2 = new int[v1 + 1];
                int v3 = 32 - arg8;
                v2[0] = this.m_ints[0] << arg8;
                int v0;
                for(v0 = 1; v0 < v1; ++v0) {
                    v2[v0] = this.m_ints[v0] << arg8 | this.m_ints[v0 - 1] >>> v3;
                }

                v2[v1] = this.m_ints[v1 - 1] >>> v3;
                this = new IntArray(v2);
            }
        }

        return this;
    }

    public void shiftLeft() {
        int v0 = this.getUsedLength();
        if(v0 != 0) {
            if(this.m_ints[v0 - 1] < 0) {
                ++v0;
                if(v0 > this.m_ints.length) {
                    this.m_ints = this.resizedInts(this.m_ints.length + 1);
                }
            }

            int v3 = 0;
            int v4;
            for(v4 = 0; v3 < v0; v4 = v1) {
                int v1 = this.m_ints[v3] < 0 ? 1 : 0;
                this.m_ints[v3] <<= 1;
                if(v4 != 0) {
                    this.m_ints[v3] |= 1;
                }

                ++v3;
            }
        }
    }

    public IntArray square(int arg11) {
        int v9 = 4;
        int[] v4 = new int[]{0, 1, 4, 5, 16, 17, 20, 21, 64, 65, 68, 69, 80, 81, 84, 85};
        int v5 = arg11 + 31 >> 5;
        if(this.m_ints.length < v5) {
            this.m_ints = this.resizedInts(v5);
        }

        IntArray v6 = new IntArray(v5 + v5);
        int v3;
        for(v3 = 0; v3 < v5; ++v3) {
            int v0 = 0;
            int v2 = 0;
            while(v0 < v9) {
                v2 = v2 >>> 8 | v4[this.m_ints[v3] >>> v0 * 4 & 15] << 24;
                ++v0;
            }

            v6.m_ints[v3 + v3] = v2;
            int v7 = this.m_ints[v3] >>> 16;
            v0 = 0;
            v2 = 0;
            while(v0 < v9) {
                v2 = v2 >>> 8 | v4[v7 >>> v0 * 4 & 15] << 24;
                ++v0;
            }

            v6.m_ints[v3 + v3 + 1] = v2;
        }

        return v6;
    }

    public boolean testBit(int arg5) {
        boolean v0 = true;
        if((this.m_ints[arg5 >> 5] & 1 << (arg5 & 31)) == 0) {
            v0 = false;
        }

        return v0;
    }

    public BigInteger toBigInteger() {
        BigInteger v0;
        int v3 = 3;
        int v6 = this.getUsedLength();
        if(v6 == 0) {
            v0 = ECConstants.ZERO;
        }
        else {
            int v7 = this.m_ints[v6 - 1];
            byte[] v8 = new byte[4];
            int v5 = v3;
            int v0_1 = 0;
            int v2 = 0;
            while(v5 >= 0) {
                byte v9 = ((byte)(v7 >>> v5 * 8));
                if(v0_1 != 0 || v9 != 0) {
                    v8[v2] = v9;
                    ++v2;
                    v0_1 = 1;
                }

                --v5;
            }

            byte[] v7_1 = new byte[(v6 - 1) * 4 + v2];
            for(v0_1 = 0; v0_1 < v2; ++v0_1) {
                v7_1[v0_1] = v8[v0_1];
            }

            v5 = v6 - 2;
            for(v0_1 = v2; v5 >= 0; v0_1 = v2) {
                v2 = v0_1;
                v0_1 = v3;
                while(v0_1 >= 0) {
                    v7_1[v2] = ((byte)(this.m_ints[v5] >>> v0_1 * 8));
                    --v0_1;
                    ++v2;
                }

                --v5;
            }

            v0 = new BigInteger(1, v7_1);
        }

        return v0;
    }

    public String toString() {
        String v0_1;
        int v0 = this.getUsedLength();
        if(v0 == 0) {
            v0_1 = "0";
        }
        else {
            StringBuffer v3 = new StringBuffer(Integer.toBinaryString(this.m_ints[v0 - 1]));
            int v2;
            for(v2 = v0 - 2; v2 >= 0; --v2) {
                String v1 = Integer.toBinaryString(this.m_ints[v2]);
                for(v0 = v1.length(); v0 < 8; ++v0) {
                    v1 = "0" + v1;
                }

                v3.append(v1);
            }

            v0_1 = v3.toString();
        }

        return v0_1;
    }
}

