// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;

class SimpleBigDecimal {
    private final BigInteger bigInt;
    private final int scale;
    private static final long serialVersionUID = 1;

    public SimpleBigDecimal(BigInteger arg3, int arg4) {
        super();
        if(arg4 < 0) {
            throw new IllegalArgumentException("scale may not be negative");
        }

        this.bigInt = arg3;
        this.scale = arg4;
    }

    private SimpleBigDecimal(SimpleBigDecimal arg2) {
        super();
        this.bigInt = arg2.bigInt;
        this.scale = arg2.scale;
    }

    public SimpleBigDecimal add(BigInteger arg4) {
        return new SimpleBigDecimal(this.bigInt.add(arg4.shiftLeft(this.scale)), this.scale);
    }

    public SimpleBigDecimal add(SimpleBigDecimal arg4) {
        this.checkScale(arg4);
        return new SimpleBigDecimal(this.bigInt.add(arg4.bigInt), this.scale);
    }

    public SimpleBigDecimal adjustScale(int arg4) {
        if(arg4 < 0) {
            throw new IllegalArgumentException("scale may not be negative");
        }

        SimpleBigDecimal v0 = arg4 == this.scale ? new SimpleBigDecimal(this) : new SimpleBigDecimal(this.bigInt.shiftLeft(arg4 - this.scale), arg4);
        return v0;
    }

    private void checkScale(SimpleBigDecimal arg3) {
        if(this.scale != arg3.scale) {
            throw new IllegalArgumentException("Only SimpleBigDecimal of same scale allowed in arithmetic operations");
        }
    }

    public int compareTo(BigInteger arg3) {
        return this.bigInt.compareTo(arg3.shiftLeft(this.scale));
    }

    public int compareTo(SimpleBigDecimal arg3) {
        this.checkScale(arg3);
        return this.bigInt.compareTo(arg3.bigInt);
    }

    public SimpleBigDecimal divide(BigInteger arg4) {
        return new SimpleBigDecimal(this.bigInt.divide(arg4), this.scale);
    }

    public SimpleBigDecimal divide(SimpleBigDecimal arg4) {
        this.checkScale(arg4);
        return new SimpleBigDecimal(this.bigInt.shiftLeft(this.scale).divide(arg4.bigInt), this.scale);
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if(this != (((SimpleBigDecimal)arg5))) {
            if(!(arg5 instanceof SimpleBigDecimal)) {
                v0 = false;
            }
            else {
                if((this.bigInt.equals(((SimpleBigDecimal)arg5).bigInt)) && this.scale == ((SimpleBigDecimal)arg5).scale) {
                    return v0;
                }

                v0 = false;
            }
        }

        return v0;
    }

    public BigInteger floor() {
        return this.bigInt.shiftRight(this.scale);
    }

    public static SimpleBigDecimal getInstance(BigInteger arg2, int arg3) {
        return new SimpleBigDecimal(arg2.shiftLeft(arg3), arg3);
    }

    public int getScale() {
        return this.scale;
    }

    public int hashCode() {
        return this.bigInt.hashCode() ^ this.scale;
    }

    public int intValue() {
        return this.floor().intValue();
    }

    public long longValue() {
        return this.floor().longValue();
    }

    public SimpleBigDecimal multiply(BigInteger arg4) {
        return new SimpleBigDecimal(this.bigInt.multiply(arg4), this.scale);
    }

    public SimpleBigDecimal multiply(SimpleBigDecimal arg5) {
        this.checkScale(arg5);
        return new SimpleBigDecimal(this.bigInt.multiply(arg5.bigInt), this.scale + this.scale);
    }

    public SimpleBigDecimal negate() {
        return new SimpleBigDecimal(this.bigInt.negate(), this.scale);
    }

    public BigInteger round() {
        return this.add(new SimpleBigDecimal(ECConstants.ONE, 1).adjustScale(this.scale)).floor();
    }

    public SimpleBigDecimal shiftLeft(int arg4) {
        return new SimpleBigDecimal(this.bigInt.shiftLeft(arg4), this.scale);
    }

    public SimpleBigDecimal subtract(BigInteger arg4) {
        return new SimpleBigDecimal(this.bigInt.subtract(arg4.shiftLeft(this.scale)), this.scale);
    }

    public SimpleBigDecimal subtract(SimpleBigDecimal arg2) {
        return this.add(arg2.negate());
    }

    public String toString() {
        String v0;
        int v5 = -1;
        if(this.scale == 0) {
            v0 = this.bigInt.toString();
        }
        else {
            BigInteger v1 = this.floor();
            BigInteger v0_1 = this.bigInt.subtract(v1.shiftLeft(this.scale));
            if(this.bigInt.signum() == v5) {
                v0_1 = ECConstants.ONE.shiftLeft(this.scale).subtract(v0_1);
            }

            if(v1.signum() == v5 && !v0_1.equals(ECConstants.ZERO)) {
                v1 = v1.add(ECConstants.ONE);
            }

            String v1_1 = v1.toString();
            char[] v3 = new char[this.scale];
            String v4 = v0_1.toString(2);
            v5 = v4.length();
            int v6 = this.scale - v5;
            int v0_2;
            for(v0_2 = 0; v0_2 < v6; ++v0_2) {
                v3[v0_2] = '0';
            }

            for(v0_2 = 0; v0_2 < v5; ++v0_2) {
                v3[v6 + v0_2] = v4.charAt(v0_2);
            }

            v0 = new String(v3);
            StringBuffer v2 = new StringBuffer(v1_1);
            v2.append(".");
            v2.append(v0);
            v0 = v2.toString();
        }

        return v0;
    }
}

