// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.math.ec;

import java.math.BigInteger;

class Tnaf {
    private static final BigInteger MINUS_ONE = null;
    private static final BigInteger MINUS_THREE = null;
    private static final BigInteger MINUS_TWO = null;
    public static final byte POW_2_WIDTH = 16;
    public static final byte WIDTH = 4;
    public static final ZTauElement[] alpha0;
    public static final byte[][] alpha0Tnaf;
    public static final ZTauElement[] alpha1;
    public static final byte[][] alpha1Tnaf;

    static {
        Tnaf.MINUS_ONE = ECConstants.ONE.negate();
        Tnaf.MINUS_TWO = ECConstants.TWO.negate();
        Tnaf.MINUS_THREE = ECConstants.THREE.negate();
        Tnaf.alpha0 = new ZTauElement[]{null, new ZTauElement(ECConstants.ONE, ECConstants.ZERO), null, new ZTauElement(Tnaf.MINUS_THREE, Tnaf.MINUS_ONE), null, new ZTauElement(Tnaf.MINUS_ONE, Tnaf.MINUS_ONE), null, new ZTauElement(ECConstants.ONE, Tnaf.MINUS_ONE), null};
        Tnaf.alpha0Tnaf = new byte[][]{null, new byte[]{1}, null, new byte[]{-1, 0, 1}, null, new byte[]{1, 0, 1}, null, new byte[]{-1, 0, 0, 1}};
        Tnaf.alpha1 = new ZTauElement[]{null, new ZTauElement(ECConstants.ONE, ECConstants.ZERO), null, new ZTauElement(Tnaf.MINUS_THREE, ECConstants.ONE), null, new ZTauElement(Tnaf.MINUS_ONE, ECConstants.ONE), null, new ZTauElement(ECConstants.ONE, ECConstants.ONE), null};
        Tnaf.alpha1Tnaf = new byte[][]{null, new byte[]{1}, null, new byte[]{-1, 0, 1}, null, new byte[]{1, 0, 1}, null, new byte[]{-1, 0, 0, -1}};
    }

    Tnaf() {
        super();
    }

    public static SimpleBigDecimal approximateDivisionByN(BigInteger arg3, BigInteger arg4, BigInteger arg5, byte arg6, int arg7, int arg8) {
        int v1 = (arg7 + 5) / 2 + arg8;
        BigInteger v0 = arg4.multiply(arg3.shiftRight(arg7 - v1 - 2 + arg6));
        BigInteger v2 = v0.add(arg5.multiply(v0.shiftRight(arg7)));
        v0 = v2.shiftRight(v1 - arg8);
        if(v2.testBit(v1 - arg8 - 1)) {
            v0 = v0.add(ECConstants.ONE);
        }

        return new SimpleBigDecimal(v0, arg8);
    }

    public static BigInteger[] getLucas(byte arg7, int arg8, boolean arg9) {
        BigInteger v0;
        BigInteger v1;
        if(arg7 != 1 && arg7 != -1) {
            throw new IllegalArgumentException("mu must be 1 or -1");
        }

        if(arg9) {
            v1 = ECConstants.TWO;
            v0 = BigInteger.valueOf(((long)arg7));
        }
        else {
            v1 = ECConstants.ZERO;
            v0 = ECConstants.ONE;
        }

        int v2 = 1;
        BigInteger v4 = v1;
        for(v1 = v0; v2 < arg8; v1 = v6) {
            v0 = arg7 == 1 ? v1 : v1.negate();
            ++v2;
            BigInteger v6 = v0.subtract(v4.shiftLeft(1));
            v4 = v1;
        }

        return new BigInteger[]{v4, v1};
    }

    public static byte getMu(ECCurve$F2m arg2) {
        byte v0_1;
        BigInteger v0 = arg2.getA().toBigInteger();
        if(v0.equals(ECConstants.ZERO)) {
            v0_1 = -1;
        }
        else if(v0.equals(ECConstants.ONE)) {
            v0_1 = 1;
        }
        else {
            goto label_12;
        }

        return v0_1;
    label_12:
        throw new IllegalArgumentException("No Koblitz curve (ABC), TNAF multiplication not possible");
    }

    public static ECPoint$F2m[] getPreComp(ECPoint$F2m arg5, byte arg6) {
        ECPoint$F2m[] v2 = new ECPoint$F2m[16];
        v2[1] = arg5;
        byte[][] v0 = arg6 == 0 ? Tnaf.alpha0Tnaf : Tnaf.alpha1Tnaf;
        int v3 = v0.length;
        int v1;
        for(v1 = 3; v1 < v3; v1 += 2) {
            v2[v1] = Tnaf.multiplyFromTnaf(arg5, v0[v1]);
        }

        return v2;
    }

    public static BigInteger[] getSi(ECCurve$F2m arg8) {
        BigInteger v0_2;
        BigInteger v1_1;
        int v7 = 2;
        if(!arg8.isKoblitz()) {
            throw new IllegalArgumentException("si is defined for Koblitz curves only");
        }

        int v0 = arg8.getM();
        int v1 = arg8.getA().toBigInteger().intValue();
        byte v2 = arg8.getMu();
        int v3 = arg8.getH().intValue();
        BigInteger[] v0_1 = Tnaf.getLucas(v2, v0 + 3 - v1, false);
        if(v2 == 1) {
            v1_1 = ECConstants.ONE.subtract(v0_1[1]);
            v0_2 = ECConstants.ONE.subtract(v0_1[0]);
        }
        else if(v2 == -1) {
            v1_1 = ECConstants.ONE.add(v0_1[1]);
            v0_2 = ECConstants.ONE.add(v0_1[0]);
        }
        else {
            goto label_43;
        }

        BigInteger[] v2_1 = new BigInteger[v7];
        if(v3 == v7) {
            v2_1[0] = v1_1.shiftRight(1);
            v2_1[1] = v0_2.shiftRight(1).negate();
        }
        else if(v3 == 4) {
            v2_1[0] = v1_1.shiftRight(v7);
            v2_1[1] = v0_2.shiftRight(v7).negate();
        }
        else {
            goto label_55;
        }

        return v2_1;
    label_55:
        throw new IllegalArgumentException("h (Cofactor) must be 2 or 4");
    label_43:
        throw new IllegalArgumentException("mu must be 1 or -1");
    }

    public static BigInteger getTw(byte arg5, int arg6) {
        BigInteger v0;
        if(arg6 != 4) {
            BigInteger[] v0_1 = Tnaf.getLucas(arg5, arg6, false);
            BigInteger v1 = ECConstants.ZERO.setBit(arg6);
            v0 = ECConstants.TWO.multiply(v0_1[0]).multiply(v0_1[1].modInverse(v1)).mod(v1);
        }
        else if(arg5 == 1) {
            v0 = BigInteger.valueOf(6);
        }
        else {
            v0 = BigInteger.valueOf(10);
        }

        return v0;
    }

    public static ECPoint$F2m multiplyFromTnaf(ECPoint$F2m arg4, byte[] arg5) {
        ECPoint v0 = arg4.getCurve().getInfinity();
        int v1;
        for(v1 = arg5.length - 1; v1 >= 0; --v1) {
            ECPoint$F2m v0_1 = Tnaf.tau(((ECPoint$F2m)v0));
            if(arg5[v1] == 1) {
                v0_1 = v0_1.addSimple(arg4);
            }
            else if(arg5[v1] == -1) {
                v0_1 = v0_1.subtractSimple(arg4);
            }
        }

        return ((ECPoint$F2m)v0);
    }

    public static ECPoint$F2m multiplyRTnaf(ECPoint$F2m arg6, BigInteger arg7) {
        ECCurve v0 = arg6.getCurve();
        return Tnaf.multiplyTnaf(arg6, Tnaf.partModReduction(arg7, ((ECCurve$F2m)v0).getM(), ((byte)((ECCurve$F2m)v0).getA().toBigInteger().intValue()), ((ECCurve$F2m)v0).getSi(), ((ECCurve$F2m)v0).getMu(), 10));
    }

    public static ECPoint$F2m multiplyTnaf(ECPoint$F2m arg1, ZTauElement arg2) {
        return Tnaf.multiplyFromTnaf(arg1, Tnaf.tauAdicNaf(arg1.getCurve().getMu(), arg2));
    }

    public static BigInteger norm(byte arg5, ZTauElement arg6) {
        BigInteger v0 = arg6.u.multiply(arg6.u);
        BigInteger v1 = arg6.u.multiply(arg6.v);
        BigInteger v2 = arg6.v.multiply(arg6.v).shiftLeft(1);
        if(arg5 == 1) {
            v0 = v0.add(v1).add(v2);
        }
        else if(arg5 == -1) {
            v0 = v0.subtract(v1).add(v2);
        }
        else {
            goto label_20;
        }

        return v0;
    label_20:
        throw new IllegalArgumentException("mu must be 1 or -1");
    }

    public static SimpleBigDecimal norm(byte arg4, SimpleBigDecimal arg5, SimpleBigDecimal arg6) {
        SimpleBigDecimal v0 = arg5.multiply(arg5);
        SimpleBigDecimal v1 = arg5.multiply(arg6);
        SimpleBigDecimal v2 = arg6.multiply(arg6).shiftLeft(1);
        if(arg4 == 1) {
            v0 = v0.add(v1).add(v2);
        }
        else if(arg4 == -1) {
            v0 = v0.subtract(v1).add(v2);
        }
        else {
            goto label_14;
        }

        return v0;
    label_14:
        throw new IllegalArgumentException("mu must be 1 or -1");
    }

    public static ZTauElement partModReduction(BigInteger arg10, int arg11, byte arg12, BigInteger[] arg13, byte arg14, byte arg15) {
        BigInteger v6 = arg14 == 1 ? arg13[0].add(arg13[1]) : arg13[0].subtract(arg13[1]);
        BigInteger v2 = Tnaf.getLucas(arg14, arg11, true)[1];
        ZTauElement v0 = Tnaf.round(Tnaf.approximateDivisionByN(arg10, arg13[0], v2, arg12, arg11, arg15), Tnaf.approximateDivisionByN(arg10, arg13[1], v2, arg12, arg11, arg15), arg14);
        return new ZTauElement(arg10.subtract(v6.multiply(v0.u)).subtract(BigInteger.valueOf(2).multiply(arg13[1]).multiply(v0.v)), arg13[1].multiply(v0.u).subtract(arg13[0].multiply(v0.v)));
    }

    public static ZTauElement round(SimpleBigDecimal arg10, SimpleBigDecimal arg11, byte arg12) {
        byte v3_1;
        int v3 = 0;
        int v5 = -1;
        int v4 = 1;
        if(arg11.getScale() != arg10.getScale()) {
            throw new IllegalArgumentException("lambda0 and lambda1 do not have same scale");
        }

        if(arg12 != 1 && arg12 != v5) {
            throw new IllegalArgumentException("mu must be 1 or -1");
        }

        BigInteger v6 = arg10.round();
        BigInteger v7 = arg11.round();
        SimpleBigDecimal v1 = arg10.subtract(v6);
        SimpleBigDecimal v2 = arg11.subtract(v7);
        SimpleBigDecimal v0 = v1.add(v1);
        v0 = arg12 == 1 ? v0.add(v2) : v0.subtract(v2);
        SimpleBigDecimal v8 = v2.add(v2).add(v2);
        SimpleBigDecimal v9 = v8.add(v2);
        if(arg12 == 1) {
            v2 = v1.subtract(v8);
            v1 = v1.add(v9);
        }
        else {
            v2 = v1.add(v8);
            v1 = v1.subtract(v9);
        }

        if(v0.compareTo(ECConstants.ONE) >= 0) {
            if(v2.compareTo(Tnaf.MINUS_ONE) < 0) {
                v4 = 0;
                v3 = arg12;
            }
        }
        else if(v1.compareTo(ECConstants.TWO) >= 0) {
            v4 = 0;
            v3 = arg12;
        }
        else {
            v4 = 0;
        }

        if(v0.compareTo(Tnaf.MINUS_ONE) < 0) {
            if(v2.compareTo(ECConstants.ONE) >= 0) {
                v3_1 = ((byte)(-arg12));
            }
            else {
                v4 = v5;
            }
        }
        else if(v1.compareTo(Tnaf.MINUS_TWO) < 0) {
            v3_1 = ((byte)(-arg12));
        }

        return new ZTauElement(v6.add(BigInteger.valueOf(((long)v4))), v7.add(BigInteger.valueOf(((long)v3))));
    }

    public static ECPoint$F2m tau(ECPoint$F2m arg5) {
        if(!arg5.isInfinity()) {
            arg5 = new ECPoint$F2m(arg5.getCurve(), arg5.getX().square(), arg5.getY().square(), arg5.isCompressed());
        }

        return arg5;
    }

    public static byte[] tauAdicNaf(byte arg9, ZTauElement arg10) {
        BigInteger v5;
        if(arg9 != 1 && arg9 != -1) {
            throw new IllegalArgumentException("mu must be 1 or -1");
        }

        int v0 = Tnaf.norm(arg9, arg10).bitLength();
        if(v0 > 30) {
            v0 += 4;
        }
        else {
            v0 = 34;
        }

        byte[] v6 = new byte[v0];
        BigInteger v1 = arg10.u;
        BigInteger v0_1 = arg10.v;
        int v2 = 0;
        int v4;
        for(v4 = 0; true; ++v4) {
            if((v1.equals(ECConstants.ZERO)) && (v0_1.equals(ECConstants.ZERO))) {
                v0 = v2 + 1;
                byte[] v1_1 = new byte[v0];
                System.arraycopy(v6, 0, v1_1, 0, v0);
                return v1_1;
            }

            if(v1.testBit(0)) {
                v6[v4] = ((byte)ECConstants.TWO.subtract(v1.subtract(v0_1.shiftLeft(1)).mod(ECConstants.FOUR)).intValue());
                v1 = v6[v4] == 1 ? v1.clearBit(0) : v1.add(ECConstants.ONE);
                v5 = v1;
                v2 = v4;
            }
            else {
                v6[v4] = 0;
                v5 = v1;
            }

            v1 = v5.shiftRight(1);
            v1 = arg9 == 1 ? v0_1.add(v1) : v0_1.subtract(v1);
            v0_1 = v5.shiftRight(1).negate();
        }
    }

    public static byte[] tauAdicWNaf(byte arg9, ZTauElement arg10, byte arg11, BigInteger arg12, BigInteger arg13, ZTauElement[] arg14) {
        int v4_2;
        int v6;
        BigInteger v4;
        if(arg9 != 1 && arg9 != -1) {
            throw new IllegalArgumentException("mu must be 1 or -1");
        }

        int v0 = Tnaf.norm(arg9, arg10).bitLength();
        v0 = v0 > 30 ? v0 + 4 + arg11 : arg11 + 34;
        byte[] v7 = new byte[v0];
        BigInteger v8 = arg12.shiftRight(1);
        BigInteger v3 = arg10.u;
        BigInteger v2 = arg10.v;
        for(v0 = 0; true; ++v0) {
            if((v3.equals(ECConstants.ZERO)) && (v2.equals(ECConstants.ZERO))) {
                return v7;
            }

            if(v3.testBit(0)) {
                v4 = v3.add(v2.multiply(arg13)).mod(arg12);
                byte v4_1 = v4.compareTo(v8) >= 0 ? ((byte)v4.subtract(arg12).intValue()) : ((byte)v4.intValue());
                v7[v0] = v4_1;
                if(v4_1 < 0) {
                    v6 = ((byte)(-v4_1));
                    v4_2 = 0;
                }
                else {
                    v6 = v4_1;
                    v4_2 = 1;
                }

                if(v4_2 != 0) {
                    v3 = v3.subtract(arg14[v6].u);
                    v2 = v2.subtract(arg14[v6].v);
                }
                else {
                    v3 = v3.add(arg14[v6].u);
                    v2 = v2.add(arg14[v6].v);
                }

                v4 = v3;
            }
            else {
                v7[v0] = 0;
                v4 = v3;
            }

            v3 = arg9 == 1 ? v2.add(v4.shiftRight(1)) : v2.subtract(v4.shiftRight(1));
            v2 = v4.shiftRight(1).negate();
        }
    }
}

