// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchProviderException;
import java.security.PublicKey;
import java.security.Signature;
import java.security.cert.CertStore;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.CollectionCertStoreParameters;
import java.security.cert.X509Certificate;
import java.security.cert.X509Extension;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.bouncycastle.asn1.ASN1OutputStream;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.ocsp.BasicOCSPResponse;
import org.bouncycastle.asn1.ocsp.ResponseData;
import org.bouncycastle.asn1.ocsp.SingleResponse;
import org.bouncycastle.asn1.x509.X509Extensions;

public class BasicOCSPResp implements X509Extension {
    X509Certificate[] chain;
    ResponseData data;
    BasicOCSPResponse resp;

    public BasicOCSPResp(BasicOCSPResponse arg2) {
        super();
        this.chain = null;
        this.resp = arg2;
        this.data = arg2.getTbsResponseData();
    }

    public boolean equals(Object arg3) {
        boolean v0;
        if((((BasicOCSPResp)arg3)) == this) {
            v0 = true;
        }
        else if(!(arg3 instanceof BasicOCSPResp)) {
            v0 = false;
        }
        else {
            v0 = this.resp.equals(((BasicOCSPResp)arg3).resp);
        }

        return v0;
    }

    private List getCertList(String arg8) {
        CertificateFactory v4;
        ArrayList v1 = new ArrayList();
        ByteArrayOutputStream v2 = new ByteArrayOutputStream();
        ASN1OutputStream v3 = new ASN1OutputStream(((OutputStream)v2));
        try {
            v4 = OCSPUtil.createX509CertificateFactory(arg8);
        }
        catch(CertificateException v0) {
            throw new OCSPException("can\'t get certificate factory.", ((Exception)v0));
        }

        ASN1Sequence v0_1 = this.resp.getCerts();
        if(v0_1 != null) {
            Enumeration v5 = v0_1.getObjects();
            while(v5.hasMoreElements()) {
                try {
                    v3.writeObject(v5.nextElement());
                    ((List)v1).add(v4.generateCertificate(new ByteArrayInputStream(v2.toByteArray())));
                }
                catch(CertificateException v0) {
                    throw new OCSPException("can\'t re-encode certificate!", ((Exception)v0));
                }
                catch(IOException v0_2) {
                    throw new OCSPException("can\'t re-encode certificate!", ((Exception)v0_2));
                }

                v2.reset();
            }
        }

        return ((List)v1);
    }

    public CertStore getCertificates(String arg4, String arg5) {
        try {
            return OCSPUtil.createCertStoreInstance(arg4, new CollectionCertStoreParameters(this.getCertList(arg5)), arg5);
        }
        catch(InvalidAlgorithmParameterException v0) {
            throw new OCSPException("can\'t setup the CertStore", ((Exception)v0));
        }
    }

    public X509Certificate[] getCerts(String arg3) {
        List v0 = this.getCertList(arg3);
        return v0.toArray(new X509Certificate[v0.size()]);
    }

    public Set getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    public byte[] getEncoded() {
        return this.resp.getEncoded();
    }

    private Set getExtensionOIDs(boolean arg6) {
        HashSet v1 = new HashSet();
        X509Extensions v2 = this.getResponseExtensions();
        if(v2 != null) {
            Enumeration v3 = v2.oids();
            while(v3.hasMoreElements()) {
                Object v0 = v3.nextElement();
                if(arg6 != v2.getExtension(((DERObjectIdentifier)v0)).isCritical()) {
                    continue;
                }

                ((Set)v1).add(((DERObjectIdentifier)v0).getId());
            }
        }

        return ((Set)v1);
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_3;
        X509Extensions v0 = this.getResponseExtensions();
        if(v0 != null) {
            org.bouncycastle.asn1.x509.X509Extension v0_1 = v0.getExtension(new DERObjectIdentifier(arg5));
            if(v0_1 != null) {
                try {
                    v0_3 = v0_1.getValue().getEncoded("DER");
                }
                catch(Exception v0_2) {
                    throw new RuntimeException("error encoding " + v0_2.toString());
                }
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            v0_3 = null;
        }

        return v0_3;
    }

    public Set getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public Date getProducedAt() {
        try {
            return this.data.getProducedAt().getDate();
        }
        catch(ParseException v0) {
            throw new IllegalStateException("ParseException:" + v0.getMessage());
        }
    }

    public RespID getResponderId() {
        return new RespID(this.data.getResponderID());
    }

    public RespData getResponseData() {
        return new RespData(this.resp.getTbsResponseData());
    }

    public X509Extensions getResponseExtensions() {
        return X509Extensions.getInstance(this.data.getResponseExtensions());
    }

    public SingleResp[] getResponses() {
        ASN1Sequence v1 = this.data.getResponses();
        SingleResp[] v2 = new SingleResp[v1.size()];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = new SingleResp(SingleResponse.getInstance(v1.getObjectAt(v0)));
        }

        return v2;
    }

    public byte[] getSignature() {
        return this.resp.getSignature().getBytes();
    }

    public String getSignatureAlgName() {
        return OCSPUtil.getAlgorithmName(this.resp.getSignatureAlgorithm().getObjectId());
    }

    public String getSignatureAlgOID() {
        return this.resp.getSignatureAlgorithm().getObjectId().getId();
    }

    public byte[] getTBSResponseData() {
        try {
            return this.resp.getTbsResponseData().getEncoded();
        }
        catch(IOException v0) {
            throw new OCSPException("problem encoding tbsResponseData", ((Exception)v0));
        }
    }

    public int getVersion() {
        return this.data.getVersion().getValue().intValue() + 1;
    }

    public boolean hasUnsupportedCriticalExtension() {
        Set v0 = this.getCriticalExtensionOIDs();
        boolean v0_1 = v0 == null || (v0.isEmpty()) ? false : true;
        return v0_1;
    }

    public int hashCode() {
        return this.resp.hashCode();
    }

    public boolean verify(PublicKey arg5, String arg6) {
        try {
            Signature v0_2 = OCSPUtil.createSignatureInstance(this.getSignatureAlgName(), arg6);
            v0_2.initVerify(arg5);
            v0_2.update(this.resp.getTbsResponseData().getEncoded("DER"));
            return v0_2.verify(this.getSignature());
        }
        catch(Exception v0) {
            throw new OCSPException("exception processing sig: " + v0, v0);
        }
        catch(NoSuchProviderException v0_1) {
            throw v0_1;
        }
    }
}

