// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.io.IOException;
import java.security.GeneralSecurityException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Signature;
import java.security.cert.CertificateEncodingException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.ocsp.BasicOCSPResponse;
import org.bouncycastle.asn1.ocsp.ResponseData;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.X509CertificateStructure;
import org.bouncycastle.asn1.x509.X509Extensions;

public class BasicOCSPRespGenerator {
    private List list;
    private RespID responderID;
    private X509Extensions responseExtensions;

    public BasicOCSPRespGenerator(PublicKey arg2) {
        super();
        this.list = new ArrayList();
        this.responseExtensions = null;
        this.responderID = new RespID(arg2);
    }

    public BasicOCSPRespGenerator(RespID arg2) {
        super();
        this.list = new ArrayList();
        this.responseExtensions = null;
        this.responderID = arg2;
    }

    public void addResponse(CertificateID arg9, CertificateStatus arg10) {
        this.list.add(new BasicOCSPRespGenerator$ResponseObject(this, arg9, arg10, new Date(), null, null));
    }

    public void addResponse(CertificateID arg9, CertificateStatus arg10, Date arg11, Date arg12, X509Extensions arg13) {
        this.list.add(new BasicOCSPRespGenerator$ResponseObject(this, arg9, arg10, arg11, arg12, arg13));
    }

    public void addResponse(CertificateID arg9, CertificateStatus arg10, Date arg11, X509Extensions arg12) {
        this.list.add(new BasicOCSPRespGenerator$ResponseObject(this, arg9, arg10, new Date(), arg11, arg12));
    }

    public void addResponse(CertificateID arg9, CertificateStatus arg10, X509Extensions arg11) {
        this.list.add(new BasicOCSPRespGenerator$ResponseObject(this, arg9, arg10, new Date(), null, arg11));
    }

    public BasicOCSPResp generate(String arg8, PrivateKey arg9, X509Certificate[] arg10, Date arg11, String arg12) {
        return this.generate(arg8, arg9, arg10, arg11, arg12, null);
    }

    public BasicOCSPResp generate(String arg3, PrivateKey arg4, X509Certificate[] arg5, Date arg6, String arg7, SecureRandom arg8) {
        if(arg3 == null) {
            throw new IllegalArgumentException("no signing algorithm specified");
        }

        return this.generateResponse(arg3, arg4, arg5, arg6, arg7, arg8);
    }

    private BasicOCSPResp generateResponse(String arg8, PrivateKey arg9, X509Certificate[] arg10, Date arg11, String arg12, SecureRandom arg13) {
        DERBitString v3_1;
        Signature v0_3;
        DERObjectIdentifier v2;
        Iterator v1 = this.list.iterator();
        try {
            v2 = OCSPUtil.getAlgorithmOID(arg8);
        }
        catch(Exception v0) {
            throw new IllegalArgumentException("unknown signing algorithm specified");
        }

        ASN1EncodableVector v3 = new ASN1EncodableVector();
        while(v1.hasNext()) {
            try {
                v3.add(v1.next().toResponse());
                continue;
            }
            catch(Exception v0) {
                throw new OCSPException("exception creating Request", v0);
            }
        }

        ResponseData v4 = new ResponseData(this.responderID.toASN1Object(), new DERGeneralizedTime(arg11), new DERSequence(v3), this.responseExtensions);
        try {
            v0_3 = OCSPUtil.createSignatureInstance(arg8, arg12);
            if(arg13 != null) {
                v0_3.initSign(arg9, arg13);
            }
            else {
                v0_3.initSign(arg9);
            }
        }
        catch(GeneralSecurityException v0_1) {
            throw new OCSPException("exception creating signature: " + v0_1, ((Exception)v0_1));
        }
        catch(NoSuchProviderException v0_2) {
            throw v0_2;
        }

        try {
            v0_3.update(v4.getEncoded("DER"));
            v3_1 = new DERBitString(v0_3.sign());
        }
        catch(Exception v0) {
            throw new OCSPException("exception processing TBSRequest: " + v0, v0);
        }

        AlgorithmIdentifier v2_1 = OCSPUtil.getSigAlgID(v2);
        ASN1Sequence v0_4 = null;
        if(arg10 != null && arg10.length > 0) {
            ASN1EncodableVector v5 = new ASN1EncodableVector();
            int v1_1 = 0;
            try {
                while(v1_1 != arg10.length) {
                    v5.add(new X509CertificateStructure(ASN1Primitive.fromByteArray(arg10[v1_1].getEncoded())));
                    ++v1_1;
                }
            }
            catch(CertificateEncodingException v0_5) {
                throw new OCSPException("error encoding certs", ((Exception)v0_5));
            }
            catch(IOException v0_6) {
                throw new OCSPException("error processing certs", ((Exception)v0_6));
            }

            DERSequence v0_7 = new DERSequence(v5);
        }

        return new BasicOCSPResp(new BasicOCSPResponse(v4, v2_1, v3_1, v0_4));
    }

    public Iterator getSignatureAlgNames() {
        return OCSPUtil.getAlgNames();
    }

    public void setResponseExtensions(X509Extensions arg1) {
        this.responseExtensions = arg1;
    }
}

