// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.cert.X509Certificate;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.ocsp.CertID;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jce.PrincipalUtil;

public class CertificateID {
    public static final String HASH_SHA1 = "1.3.14.3.2.26";
    private final CertID id;

    public CertificateID(String arg2, X509Certificate arg3, BigInteger arg4) {
        this(arg2, arg3, arg4, "BC");
    }

    public CertificateID(String arg4, X509Certificate arg5, BigInteger arg6, String arg7) {
        super();
        this.id = CertificateID.createCertID(new AlgorithmIdentifier(new DERObjectIdentifier(arg4), DERNull.INSTANCE), arg5, new ASN1Integer(arg6), arg7);
    }

    public CertificateID(CertID arg3) {
        super();
        if(arg3 == null) {
            throw new IllegalArgumentException("\'id\' cannot be null");
        }

        this.id = arg3;
    }

    private static CertID createCertID(AlgorithmIdentifier arg4, X509Certificate arg5, ASN1Integer arg6, String arg7) {
        try {
            MessageDigest v0_1 = OCSPUtil.createDigestInstance(arg4.getAlgorithm().getId(), arg7);
            v0_1.update(PrincipalUtil.getSubjectX509Principal(arg5).getEncoded());
            DEROctetString v1 = new DEROctetString(v0_1.digest());
            v0_1.update(SubjectPublicKeyInfo.getInstance(new ASN1InputStream(arg5.getPublicKey().getEncoded()).readObject()).getPublicKeyData().getBytes());
            return new CertID(arg4, ((ASN1OctetString)v1), new DEROctetString(v0_1.digest()), arg6);
        }
        catch(Exception v0) {
            throw new OCSPException("problem creating ID: " + v0, v0);
        }
    }

    public static CertificateID deriveCertificateID(CertificateID arg6, BigInteger arg7) {
        return new CertificateID(new CertID(arg6.id.getHashAlgorithm(), arg6.id.getIssuerNameHash(), arg6.id.getIssuerKeyHash(), new ASN1Integer(arg7)));
    }

    public boolean equals(Object arg3) {
        boolean v0 = !(arg3 instanceof CertificateID) ? false : this.id.toASN1Primitive().equals(((CertificateID)arg3).id.toASN1Primitive());
        return v0;
    }

    public String getHashAlgOID() {
        return this.id.getHashAlgorithm().getObjectId().getId();
    }

    public byte[] getIssuerKeyHash() {
        return this.id.getIssuerKeyHash().getOctets();
    }

    public byte[] getIssuerNameHash() {
        return this.id.getIssuerNameHash().getOctets();
    }

    public BigInteger getSerialNumber() {
        return this.id.getSerialNumber().getValue();
    }

    public int hashCode() {
        return this.id.toASN1Primitive().hashCode();
    }

    public boolean matchesIssuer(X509Certificate arg3, String arg4) {
        return CertificateID.createCertID(this.id.getHashAlgorithm(), arg3, this.id.getSerialNumber(), arg4).equals(this.id);
    }

    public CertID toASN1Object() {
        return this.id;
    }
}

