// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchProviderException;
import java.security.PublicKey;
import java.security.Signature;
import java.security.cert.CertStore;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.CollectionCertStoreParameters;
import java.security.cert.X509Certificate;
import java.security.cert.X509Extension;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OutputStream;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ocsp.OCSPRequest;
import org.bouncycastle.asn1.ocsp.Request;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.X509Extensions;

public class OCSPReq implements X509Extension {
    private OCSPRequest req;

    public OCSPReq(InputStream arg2) {
        this(new ASN1InputStream(arg2));
    }

    private OCSPReq(ASN1InputStream arg5) {
        super();
        try {
            this.req = OCSPRequest.getInstance(arg5.readObject());
            return;
        }
        catch(ClassCastException v0) {
            throw new IOException("malformed request: " + v0.getMessage());
        }
        catch(IllegalArgumentException v0_1) {
            throw new IOException("malformed request: " + v0_1.getMessage());
        }
    }

    public OCSPReq(OCSPRequest arg1) {
        super();
        this.req = arg1;
    }

    public OCSPReq(byte[] arg2) {
        this(new ASN1InputStream(arg2));
    }

    private List getCertList(String arg8) {
        CertificateFactory v4;
        ArrayList v1 = new ArrayList();
        ByteArrayOutputStream v2 = new ByteArrayOutputStream();
        ASN1OutputStream v3 = new ASN1OutputStream(((OutputStream)v2));
        try {
            v4 = OCSPUtil.createX509CertificateFactory(arg8);
        }
        catch(CertificateException v0) {
            throw new OCSPException("can\'t get certificate factory.", ((Exception)v0));
        }

        ASN1Sequence v0_1 = this.req.getOptionalSignature().getCerts();
        if(v0_1 != null) {
            Enumeration v5 = v0_1.getObjects();
            while(v5.hasMoreElements()) {
                try {
                    v3.writeObject(v5.nextElement());
                    ((List)v1).add(v4.generateCertificate(new ByteArrayInputStream(v2.toByteArray())));
                }
                catch(CertificateException v0) {
                    throw new OCSPException("can\'t re-encode certificate!", ((Exception)v0));
                }
                catch(IOException v0_2) {
                    throw new OCSPException("can\'t re-encode certificate!", ((Exception)v0_2));
                }

                v2.reset();
            }
        }

        return ((List)v1);
    }

    public CertStore getCertificates(String arg4, String arg5) {
        CertStore v0;
        if(!this.isSigned()) {
            v0 = null;
        }
        else {
            try {
                v0 = OCSPUtil.createCertStoreInstance(arg4, new CollectionCertStoreParameters(this.getCertList(arg5)), arg5);
            }
            catch(InvalidAlgorithmParameterException v0_1) {
                throw new OCSPException("can\'t setup the CertStore", ((Exception)v0_1));
            }
        }

        return v0;
    }

    public X509Certificate[] getCerts(String arg3) {
        X509Certificate[] v0;
        if(!this.isSigned()) {
            v0 = null;
        }
        else {
            List v0_1 = this.getCertList(arg3);
            Object[] v0_2 = v0_1.toArray(new X509Certificate[v0_1.size()]);
        }

        return v0;
    }

    public Set getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    public byte[] getEncoded() {
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        new ASN1OutputStream(((OutputStream)v0)).writeObject(this.req);
        return v0.toByteArray();
    }

    private Set getExtensionOIDs(boolean arg6) {
        HashSet v1 = new HashSet();
        X509Extensions v2 = this.getRequestExtensions();
        if(v2 != null) {
            Enumeration v3 = v2.oids();
            while(v3.hasMoreElements()) {
                Object v0 = v3.nextElement();
                if(arg6 != v2.getExtension(((ASN1ObjectIdentifier)v0)).isCritical()) {
                    continue;
                }

                ((Set)v1).add(((ASN1ObjectIdentifier)v0).getId());
            }
        }

        return ((Set)v1);
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_3;
        X509Extensions v0 = this.getRequestExtensions();
        if(v0 != null) {
            org.bouncycastle.asn1.x509.X509Extension v0_1 = v0.getExtension(new ASN1ObjectIdentifier(arg5));
            if(v0_1 != null) {
                try {
                    v0_3 = v0_1.getValue().getEncoded("DER");
                }
                catch(Exception v0_2) {
                    throw new RuntimeException("error encoding " + v0_2.toString());
                }
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            v0_3 = null;
        }

        return v0_3;
    }

    public Set getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public X509Extensions getRequestExtensions() {
        return X509Extensions.getInstance(this.req.getTbsRequest().getRequestExtensions());
    }

    public Req[] getRequestList() {
        ASN1Sequence v1 = this.req.getTbsRequest().getRequestList();
        Req[] v2 = new Req[v1.size()];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = new Req(Request.getInstance(v1.getObjectAt(v0)));
        }

        return v2;
    }

    public GeneralName getRequestorName() {
        return GeneralName.getInstance(this.req.getTbsRequest().getRequestorName());
    }

    public byte[] getSignature() {
        byte[] v0 = !this.isSigned() ? null : this.req.getOptionalSignature().getSignature().getBytes();
        return v0;
    }

    public String getSignatureAlgOID() {
        String v0 = !this.isSigned() ? null : this.req.getOptionalSignature().getSignatureAlgorithm().getObjectId().getId();
        return v0;
    }

    public byte[] getTBSRequest() {
        try {
            return this.req.getTbsRequest().getEncoded();
        }
        catch(IOException v0) {
            throw new OCSPException("problem encoding tbsRequest", ((Exception)v0));
        }
    }

    public int getVersion() {
        return this.req.getTbsRequest().getVersion().getValue().intValue() + 1;
    }

    public boolean hasUnsupportedCriticalExtension() {
        Set v0 = this.getCriticalExtensionOIDs();
        boolean v0_1 = v0 == null || (v0.isEmpty()) ? false : true;
        return v0_1;
    }

    public boolean isSigned() {
        boolean v0 = this.req.getOptionalSignature() != null ? true : false;
        return v0;
    }

    public boolean verify(PublicKey arg5, String arg6) {
        if(!this.isSigned()) {
            throw new OCSPException("attempt to verify signature on unsigned object");
        }

        try {
            Signature v0_2 = OCSPUtil.createSignatureInstance(this.getSignatureAlgOID(), arg6);
            v0_2.initVerify(arg5);
            ByteArrayOutputStream v1 = new ByteArrayOutputStream();
            new ASN1OutputStream(((OutputStream)v1)).writeObject(this.req.getTbsRequest());
            v0_2.update(v1.toByteArray());
            return v0_2.verify(this.getSignature());
        }
        catch(Exception v0) {
            throw new OCSPException("exception processing sig: " + v0, v0);
        }
        catch(NoSuchProviderException v0_1) {
            throw v0_1;
        }
    }
}

