// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.security.GeneralSecurityException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.SecureRandom;
import java.security.Signature;
import java.security.cert.CertificateEncodingException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1OutputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERBitString;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.ocsp.OCSPRequest;
import org.bouncycastle.asn1.ocsp.TBSRequest;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.X509CertificateStructure;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.jce.X509Principal;

public class OCSPReqGenerator {
    private List list;
    private X509Extensions requestExtensions;
    private GeneralName requestorName;

    public OCSPReqGenerator() {
        super();
        this.list = new ArrayList();
        this.requestorName = null;
        this.requestExtensions = null;
    }

    public void addRequest(CertificateID arg4) {
        this.list.add(new OCSPReqGenerator$RequestObject(this, arg4, null));
    }

    public void addRequest(CertificateID arg3, X509Extensions arg4) {
        this.list.add(new OCSPReqGenerator$RequestObject(this, arg3, arg4));
    }

    public OCSPReq generate() {
        DERObjectIdentifier v1 = null;
        PrivateKey v2 = null;
        X509Certificate[] v3 = null;
        String v4 = null;
        SecureRandom v5 = null;
        OCSPReqGenerator v0 = this;
        try {
            return v0.generateRequest(v1, v2, v3, v4, v5);
        }
        catch(NoSuchProviderException v0_1) {
            throw new OCSPException("no provider! - " + v0_1, ((Exception)v0_1));
        }
    }

    public OCSPReq generate(String arg7, PrivateKey arg8, X509Certificate[] arg9, String arg10) {
        return this.generate(arg7, arg8, arg9, arg10, null);
    }

    public OCSPReq generate(String arg7, PrivateKey arg8, X509Certificate[] arg9, String arg10, SecureRandom arg11) {
        if(arg7 == null) {
            throw new IllegalArgumentException("no signing algorithm specified");
        }

        try {
            return this.generateRequest(OCSPUtil.getAlgorithmOID(arg7), arg8, arg9, arg10, arg11);
        }
        catch(IllegalArgumentException v0) {
            throw new IllegalArgumentException("unknown signing algorithm specified: " + arg7);
        }
    }

    private OCSPReq generateRequest(DERObjectIdentifier arg8, PrivateKey arg9, X509Certificate[] arg10, String arg11, SecureRandom arg12) {
        int v1_2;
        ASN1EncodableVector v5;
        DERBitString v2_1;
        Signature v0_4;
        Iterator v1 = this.list.iterator();
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        while(v1.hasNext()) {
            try {
                v2.add(v1.next().toRequest());
                continue;
            }
            catch(Exception v0) {
                throw new OCSPException("exception creating Request", v0);
            }
        }

        TBSRequest v3 = new TBSRequest(this.requestorName, new DERSequence(v2), this.requestExtensions);
        org.bouncycastle.asn1.ocsp.Signature v0_1 = null;
        if(arg8 != null) {
            if(this.requestorName == null) {
                throw new OCSPException("requestorName must be specified if request is signed.");
            }
            else {
                try {
                    v0_4 = OCSPUtil.createSignatureInstance(arg8.getId(), arg11);
                    if(arg12 != null) {
                        v0_4.initSign(arg9, arg12);
                    }
                    else {
                        v0_4.initSign(arg9);
                    }
                }
                catch(GeneralSecurityException v0_2) {
                    throw new OCSPException("exception creating signature: " + v0_2, ((Exception)v0_2));
                }
                catch(NoSuchProviderException v0_3) {
                    throw v0_3;
                }

                try {
                    ByteArrayOutputStream v1_1 = new ByteArrayOutputStream();
                    new ASN1OutputStream(((OutputStream)v1_1)).writeObject(((ASN1Encodable)v3));
                    v0_4.update(v1_1.toByteArray());
                    v2_1 = new DERBitString(v0_4.sign());
                }
                catch(Exception v0) {
                    throw new OCSPException("exception processing TBSRequest: " + v0, v0);
                }

                AlgorithmIdentifier v4 = new AlgorithmIdentifier(arg8, DERNull.INSTANCE);
                if(arg10 != null && arg10.length > 0) {
                    v5 = new ASN1EncodableVector();
                    v1_2 = 0;
                    goto label_53;
                }

                v0_1 = new org.bouncycastle.asn1.ocsp.Signature(v4, v2_1);
                goto label_102;
                try {
                label_53:
                    while(v1_2 != arg10.length) {
                        v5.add(new X509CertificateStructure(ASN1Primitive.fromByteArray(arg10[v1_2].getEncoded())));
                        ++v1_2;
                    }
                }
                catch(CertificateEncodingException v0_5) {
                    throw new OCSPException("error encoding certs", ((Exception)v0_5));
                }
                catch(IOException v0_6) {
                    throw new OCSPException("error processing certs", ((Exception)v0_6));
                }

                v0_1 = new org.bouncycastle.asn1.ocsp.Signature(v4, v2_1, new DERSequence(v5));
            }
        }

    label_102:
        return new OCSPReq(new OCSPRequest(v3, v0_1));
    }

    public Iterator getSignatureAlgNames() {
        return OCSPUtil.getAlgNames();
    }

    public void setRequestExtensions(X509Extensions arg1) {
        this.requestExtensions = arg1;
    }

    public void setRequestorName(X500Principal arg5) {
        try {
            this.requestorName = new GeneralName(4, new X509Principal(arg5.getEncoded()));
            return;
        }
        catch(IOException v0) {
            throw new IllegalArgumentException("cannot encode principal: " + v0);
        }
    }

    public void setRequestorName(GeneralName arg1) {
        this.requestorName = arg1;
    }
}

