// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.io.IOException;
import java.io.InputStream;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ocsp.BasicOCSPResponse;
import org.bouncycastle.asn1.ocsp.OCSPObjectIdentifiers;
import org.bouncycastle.asn1.ocsp.OCSPResponse;
import org.bouncycastle.asn1.ocsp.ResponseBytes;

public class OCSPResp {
    private OCSPResponse resp;

    public OCSPResp(InputStream arg2) {
        this(new ASN1InputStream(arg2));
    }

    private OCSPResp(ASN1InputStream arg5) {
        super();
        try {
            this.resp = OCSPResponse.getInstance(arg5.readObject());
            return;
        }
        catch(ClassCastException v0) {
            throw new IOException("malformed response: " + v0.getMessage());
        }
        catch(IllegalArgumentException v0_1) {
            throw new IOException("malformed response: " + v0_1.getMessage());
        }
    }

    public OCSPResp(OCSPResponse arg1) {
        super();
        this.resp = arg1;
    }

    public OCSPResp(byte[] arg2) {
        this(new ASN1InputStream(arg2));
    }

    public boolean equals(Object arg3) {
        boolean v0;
        if((((OCSPResp)arg3)) == this) {
            v0 = true;
        }
        else if(!(arg3 instanceof OCSPResp)) {
            v0 = false;
        }
        else {
            v0 = this.resp.equals(((OCSPResp)arg3).resp);
        }

        return v0;
    }

    public byte[] getEncoded() {
        return this.resp.getEncoded();
    }

    public Object getResponseObject() {
        Object v0_1;
        ResponseBytes v0 = this.resp.getResponseBytes();
        if(v0 == null) {
            v0_1 = null;
        }
        else if(v0.getResponseType().equals(OCSPObjectIdentifiers.id_pkix_ocsp_basic)) {
            try {
                BasicOCSPResp v0_3 = new BasicOCSPResp(BasicOCSPResponse.getInstance(ASN1Primitive.fromByteArray(v0.getResponse().getOctets())));
            }
            catch(Exception v0_2) {
                throw new OCSPException("problem decoding object: " + v0_2, v0_2);
            }
        }
        else {
            ASN1OctetString v0_4 = v0.getResponse();
        }

        return v0_1;
    }

    public int getStatus() {
        return this.resp.getResponseStatus().getValue().intValue();
    }

    public int hashCode() {
        return this.resp.hashCode();
    }
}

