// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.security.cert.X509Extension;
import java.text.ParseException;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Set;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.ocsp.ResponseData;
import org.bouncycastle.asn1.ocsp.SingleResponse;
import org.bouncycastle.asn1.x509.X509Extensions;

public class RespData implements X509Extension {
    ResponseData data;

    public RespData(ResponseData arg1) {
        super();
        this.data = arg1;
    }

    public Set getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    private Set getExtensionOIDs(boolean arg6) {
        HashSet v1 = new HashSet();
        X509Extensions v2 = this.getResponseExtensions();
        if(v2 != null) {
            Enumeration v3 = v2.oids();
            while(v3.hasMoreElements()) {
                Object v0 = v3.nextElement();
                if(arg6 != v2.getExtension(((DERObjectIdentifier)v0)).isCritical()) {
                    continue;
                }

                ((Set)v1).add(((DERObjectIdentifier)v0).getId());
            }
        }

        return ((Set)v1);
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_3;
        X509Extensions v0 = this.getResponseExtensions();
        if(v0 != null) {
            org.bouncycastle.asn1.x509.X509Extension v0_1 = v0.getExtension(new DERObjectIdentifier(arg5));
            if(v0_1 != null) {
                try {
                    v0_3 = v0_1.getValue().getEncoded("DER");
                }
                catch(Exception v0_2) {
                    throw new RuntimeException("error encoding " + v0_2.toString());
                }
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            v0_3 = null;
        }

        return v0_3;
    }

    public Set getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public Date getProducedAt() {
        try {
            return this.data.getProducedAt().getDate();
        }
        catch(ParseException v0) {
            throw new IllegalStateException("ParseException:" + v0.getMessage());
        }
    }

    public RespID getResponderId() {
        return new RespID(this.data.getResponderID());
    }

    public X509Extensions getResponseExtensions() {
        return X509Extensions.getInstance(this.data.getResponseExtensions());
    }

    public SingleResp[] getResponses() {
        ASN1Sequence v1 = this.data.getResponses();
        SingleResp[] v2 = new SingleResp[v1.size()];
        int v0;
        for(v0 = 0; v0 != v2.length; ++v0) {
            v2[v0] = new SingleResp(SingleResponse.getInstance(v1.getObjectAt(v0)));
        }

        return v2;
    }

    public int getVersion() {
        return this.data.getVersion().getValue().intValue() + 1;
    }

    public boolean hasUnsupportedCriticalExtension() {
        Set v0 = this.getCriticalExtensionOIDs();
        boolean v0_1 = v0 == null || (v0.isEmpty()) ? false : true;
        return v0_1;
    }
}

