// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.ocsp;

import java.security.cert.X509Extension;
import java.text.ParseException;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Set;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.ocsp.CertStatus;
import org.bouncycastle.asn1.ocsp.RevokedInfo;
import org.bouncycastle.asn1.ocsp.SingleResponse;
import org.bouncycastle.asn1.x509.X509Extensions;

public class SingleResp implements X509Extension {
    SingleResponse resp;

    public SingleResp(SingleResponse arg1) {
        super();
        this.resp = arg1;
    }

    public CertificateID getCertID() {
        return new CertificateID(this.resp.getCertID());
    }

    public Object getCertStatus() {
        UnknownStatus v0_2;
        CertStatus v1 = this.resp.getCertStatus();
        if(v1.getTagNo() == 0) {
            Object v0 = null;
        }
        else if(v1.getTagNo() == 1) {
            RevokedStatus v0_1 = new RevokedStatus(RevokedInfo.getInstance(v1.getStatus()));
        }
        else {
            v0_2 = new UnknownStatus();
        }

        return v0_2;
    }

    public Set getCriticalExtensionOIDs() {
        return this.getExtensionOIDs(true);
    }

    private Set getExtensionOIDs(boolean arg6) {
        HashSet v1 = new HashSet();
        X509Extensions v2 = this.getSingleExtensions();
        if(v2 != null) {
            Enumeration v3 = v2.oids();
            while(v3.hasMoreElements()) {
                Object v0 = v3.nextElement();
                if(arg6 != v2.getExtension(((DERObjectIdentifier)v0)).isCritical()) {
                    continue;
                }

                ((Set)v1).add(((DERObjectIdentifier)v0).getId());
            }
        }

        return ((Set)v1);
    }

    public byte[] getExtensionValue(String arg5) {
        byte[] v0_3;
        X509Extensions v0 = this.getSingleExtensions();
        if(v0 != null) {
            org.bouncycastle.asn1.x509.X509Extension v0_1 = v0.getExtension(new DERObjectIdentifier(arg5));
            if(v0_1 != null) {
                try {
                    v0_3 = v0_1.getValue().getEncoded("DER");
                }
                catch(Exception v0_2) {
                    throw new RuntimeException("error encoding " + v0_2.toString());
                }
            }
            else {
                goto label_21;
            }
        }
        else {
        label_21:
            v0_3 = null;
        }

        return v0_3;
    }

    public Date getNextUpdate() {
        Date v0;
        if(this.resp.getNextUpdate() == null) {
            v0 = null;
        }
        else {
            try {
                v0 = this.resp.getNextUpdate().getDate();
            }
            catch(ParseException v0_1) {
                throw new IllegalStateException("ParseException: " + v0_1.getMessage());
            }
        }

        return v0;
    }

    public Set getNonCriticalExtensionOIDs() {
        return this.getExtensionOIDs(false);
    }

    public X509Extensions getSingleExtensions() {
        return X509Extensions.getInstance(this.resp.getSingleExtensions());
    }

    public Date getThisUpdate() {
        try {
            return this.resp.getThisUpdate().getDate();
        }
        catch(ParseException v0) {
            throw new IllegalStateException("ParseException: " + v0.getMessage());
        }
    }

    public boolean hasUnsupportedCriticalExtension() {
        Set v0 = this.getCriticalExtensionOIDs();
        boolean v0_1 = v0 == null || (v0.isEmpty()) ? false : true;
        return v0_1;
    }
}

