// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import java.math.BigInteger;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.pqc.crypto.gmss.GMSSLeaf;
import org.bouncycastle.pqc.crypto.gmss.GMSSParameters;
import org.bouncycastle.pqc.crypto.gmss.GMSSRootCalc;
import org.bouncycastle.pqc.crypto.gmss.GMSSRootSig;
import org.bouncycastle.pqc.crypto.gmss.Treehash;

public class GMSSPrivateKey extends ASN1Object {
    private ASN1Primitive primitive;

    private GMSSPrivateKey(ASN1Sequence arg9) {
        ASN1Encodable v1_1;
        super();
        ASN1Encodable v0 = arg9.getObjectAt(0);
        int[] v2 = new int[((ASN1Sequence)v0).size()];
        int v1;
        for(v1 = 0; v1 < ((ASN1Sequence)v0).size(); ++v1) {
            v2[v1] = GMSSPrivateKey.checkBigIntegerInIntRange(((ASN1Sequence)v0).getObjectAt(v1));
        }

        v0 = arg9.getObjectAt(1);
        byte[][] v4 = new byte[((ASN1Sequence)v0).size()][];
        int v2_1;
        for(v2_1 = 0; v2_1 < v4.length; ++v2_1) {
            v4[v2_1] = ((ASN1Sequence)v0).getObjectAt(v2_1).getOctets();
        }

        v0 = arg9.getObjectAt(2);
        v4 = new byte[((ASN1Sequence)v0).size()][];
        for(v2_1 = 0; v2_1 < v4.length; ++v2_1) {
            v4[v2_1] = ((ASN1Sequence)v0).getObjectAt(v2_1).getOctets();
        }

        v0 = arg9.getObjectAt(3);
        byte[][][] v6 = new byte[((ASN1Sequence)v0).size()][][];
        int v4_1;
        for(v4_1 = 0; v4_1 < v6.length; ++v4_1) {
            v1_1 = ((ASN1Sequence)v0).getObjectAt(v4_1);
            v6[v4_1] = new byte[((ASN1Sequence)v1_1).size()][];
            int v5;
            for(v5 = 0; v5 < v6[v4_1].length; ++v5) {
                v6[v4_1][v5] = ((ASN1Sequence)v1_1).getObjectAt(v5).getOctets();
            }
        }

        v0 = arg9.getObjectAt(4);
        v6 = new byte[((ASN1Sequence)v0).size()][][];
        for(v4_1 = 0; v4_1 < v6.length; ++v4_1) {
            v1_1 = ((ASN1Sequence)v0).getObjectAt(v4_1);
            v6[v4_1] = new byte[((ASN1Sequence)v1_1).size()][];
            for(v5 = 0; v5 < v6[v4_1].length; ++v5) {
                v6[v4_1][v5] = ((ASN1Sequence)v1_1).getObjectAt(v5).getOctets();
            }
        }

        new Treehash[arg9.getObjectAt(5).size()][];
    }

    public GMSSPrivateKey(int[] arg25, byte[][] arg26, byte[][] arg27, byte[][][] arg28, byte[][][] arg29, Treehash[][] arg30, Treehash[][] arg31, Vector[] arg32, Vector[] arg33, Vector[][] arg34, Vector[][] arg35, byte[][][] arg36, GMSSLeaf[] arg37, GMSSLeaf[] arg38, GMSSLeaf[] arg39, int[] arg40, byte[][] arg41, GMSSRootCalc[] arg42, byte[][] arg43, GMSSRootSig[] arg44, GMSSParameters arg45, AlgorithmIdentifier arg46) {
        super();
        this.primitive = this.encode(arg25, arg26, arg27, arg28, arg29, arg36, arg30, arg31, arg32, arg33, arg34, arg35, arg37, arg38, arg39, arg40, arg41, arg42, arg43, arg44, arg45, new AlgorithmIdentifier[]{arg46});
    }

    private static int checkBigIntegerInIntRange(ASN1Encodable arg4) {
        BigInteger v0 = ((ASN1Integer)arg4).getValue();
        if(v0.compareTo(BigInteger.valueOf(2147483647)) <= 0 && v0.compareTo(BigInteger.valueOf(-2147483648)) >= 0) {
            return v0.intValue();
        }

        throw new IllegalArgumentException("BigInteger not in Range: " + v0.toString());
    }

    private ASN1Primitive encode(int[] arg21, byte[][] arg22, byte[][] arg23, byte[][][] arg24, byte[][][] arg25, byte[][][] arg26, Treehash[][] arg27, Treehash[][] arg28, Vector[] arg29, Vector[] arg30, Vector[][] arg31, Vector[][] arg32, GMSSLeaf[] arg33, GMSSLeaf[] arg34, GMSSLeaf[] arg35, int[] arg36, byte[][] arg37, GMSSRootCalc[] arg38, byte[][] arg39, GMSSRootSig[] arg40, GMSSParameters arg41, AlgorithmIdentifier[] arg42) {
        int[] v7_2;
        byte[][] v7_1;
        int v6_1;
        ASN1EncodableVector v8_1;
        int v10;
        int v7;
        ASN1EncodableVector v13 = new ASN1EncodableVector();
        ASN1EncodableVector v3 = new ASN1EncodableVector();
        int v2;
        for(v2 = 0; v2 < arg21.length; ++v2) {
            v3.add(new ASN1Integer(((long)arg21[v2])));
        }

        v13.add(new DERSequence(v3));
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg22.length; ++v2) {
            v3.add(new DEROctetString(arg22[v2]));
        }

        v13.add(new DERSequence(v3));
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg23.length; ++v2) {
            v3.add(new DEROctetString(arg23[v2]));
        }

        v13.add(new DERSequence(v3));
        v3 = new ASN1EncodableVector();
        ASN1EncodableVector v5 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg24.length; ++v2) {
            int v4;
            for(v4 = 0; v4 < arg24[v2].length; ++v4) {
                v3.add(new DEROctetString(arg24[v2][v4]));
            }

            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v5));
        v3 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg25.length; ++v2) {
            for(v4 = 0; v4 < arg25[v2].length; ++v4) {
                v3.add(new DEROctetString(arg25[v2][v4]));
            }

            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v5));
        ASN1EncodableVector v9 = new ASN1EncodableVector();
        ASN1EncodableVector v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        ASN1EncodableVector v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg27.length; ++v2) {
            v7 = 0;
            while(v7 < arg27[v2].length) {
                v5.add(new DERSequence(arg42[0]));
                v10 = arg27[v2][v7].getStatInt()[1];
                v4_1.add(new DEROctetString(arg27[v2][v7].getStatByte()[0]));
                v4_1.add(new DEROctetString(arg27[v2][v7].getStatByte()[1]));
                v4_1.add(new DEROctetString(arg27[v2][v7].getStatByte()[2]));
                int v8;
                for(v8 = 0; v8 < v10; ++v8) {
                    v4_1.add(new DEROctetString(arg27[v2][v7].getStatByte()[v8 + 3]));
                }

                v5.add(new DERSequence(v4_1));
                v8_1 = new ASN1EncodableVector();
                v3.add(new ASN1Integer(((long)arg27[v2][v7].getStatInt()[0])));
                v3.add(new ASN1Integer(((long)v10)));
                v3.add(new ASN1Integer(((long)arg27[v2][v7].getStatInt()[2])));
                v3.add(new ASN1Integer(((long)arg27[v2][v7].getStatInt()[3])));
                v3.add(new ASN1Integer(((long)arg27[v2][v7].getStatInt()[4])));
                v3.add(new ASN1Integer(((long)arg27[v2][v7].getStatInt()[5])));
                for(v4 = 0; v4 < v10; ++v4) {
                    v3.add(new ASN1Integer(((long)arg27[v2][v7].getStatInt()[v4 + 6])));
                }

                v5.add(new DERSequence(v3));
                v4_1 = new ASN1EncodableVector();
                v6.add(new DERSequence(v5));
                v5 = new ASN1EncodableVector();
                ++v7;
                v3 = v4_1;
                v4_1 = v8_1;
            }

            v9.add(new DERSequence(v6));
            v6 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v9));
        v9 = new ASN1EncodableVector();
        v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg28.length; ++v2) {
            v7 = 0;
            while(v7 < arg28[v2].length) {
                v5.add(new DERSequence(arg42[0]));
                v10 = arg28[v2][v7].getStatInt()[1];
                v4_1.add(new DEROctetString(arg28[v2][v7].getStatByte()[0]));
                v4_1.add(new DEROctetString(arg28[v2][v7].getStatByte()[1]));
                v4_1.add(new DEROctetString(arg28[v2][v7].getStatByte()[2]));
                for(v8 = 0; v8 < v10; ++v8) {
                    v4_1.add(new DEROctetString(arg28[v2][v7].getStatByte()[v8 + 3]));
                }

                v5.add(new DERSequence(v4_1));
                v8_1 = new ASN1EncodableVector();
                v3.add(new ASN1Integer(((long)arg28[v2][v7].getStatInt()[0])));
                v3.add(new ASN1Integer(((long)v10)));
                v3.add(new ASN1Integer(((long)arg28[v2][v7].getStatInt()[2])));
                v3.add(new ASN1Integer(((long)arg28[v2][v7].getStatInt()[3])));
                v3.add(new ASN1Integer(((long)arg28[v2][v7].getStatInt()[4])));
                v3.add(new ASN1Integer(((long)arg28[v2][v7].getStatInt()[5])));
                for(v4 = 0; v4 < v10; ++v4) {
                    v3.add(new ASN1Integer(((long)arg28[v2][v7].getStatInt()[v4 + 6])));
                }

                v5.add(new DERSequence(v3));
                v4_1 = new ASN1EncodableVector();
                v6.add(new DERSequence(v5));
                v5 = new ASN1EncodableVector();
                ++v7;
                v3 = v4_1;
                v4_1 = v8_1;
            }

            v9.add(new DERSequence(new DERSequence(v6)));
            v6 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v9));
        v3 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg26.length; ++v2) {
            for(v4 = 0; v4 < arg26[v2].length; ++v4) {
                v3.add(new DEROctetString(arg26[v2][v4]));
            }

            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v5));
        v3 = new ASN1EncodableVector();
        v6 = new ASN1EncodableVector();
        v4_1 = v3;
        int v3_1;
        for(v3_1 = 0; v3_1 < arg29.length; ++v3_1) {
            int v5_1;
            for(v5_1 = 0; v5_1 < arg29[v3_1].size(); ++v5_1) {
                v4_1.add(new DEROctetString(arg29[v3_1].elementAt(v5_1)));
            }

            v6.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v6));
        v3 = new ASN1EncodableVector();
        v6 = new ASN1EncodableVector();
        v4_1 = v3;
        for(v3_1 = 0; v3_1 < arg30.length; ++v3_1) {
            for(v5_1 = 0; v5_1 < arg30[v3_1].size(); ++v5_1) {
                v4_1.add(new DEROctetString(arg30[v3_1].elementAt(v5_1)));
            }

            v6.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v6));
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        v8_1 = new ASN1EncodableVector();
        ASN1EncodableVector v2_1 = v4_1;
        v4_1 = v3;
        v3_1 = 0;
        while(v3_1 < arg31.length) {
            v6_1 = 0;
            v5 = v2_1;
            while(v6_1 < arg31[v3_1].length) {
                for(v7 = 0; v7 < arg31[v3_1][v6_1].size(); ++v7) {
                    v5.add(new DEROctetString(arg31[v3_1][v6_1].elementAt(v7)));
                }

                v4_1.add(new DERSequence(v5));
                v5 = new ASN1EncodableVector();
                ++v6_1;
            }

            v8_1.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            ++v3_1;
            v2_1 = v5;
        }

        v13.add(new DERSequence(v8_1));
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        v8_1 = new ASN1EncodableVector();
        v2_1 = v4_1;
        v4_1 = v3;
        v3_1 = 0;
        while(v3_1 < arg32.length) {
            v6_1 = 0;
            v5 = v2_1;
            while(v6_1 < arg32[v3_1].length) {
                for(v7 = 0; v7 < arg32[v3_1][v6_1].size(); ++v7) {
                    v5.add(new DEROctetString(arg32[v3_1][v6_1].elementAt(v7)));
                }

                v4_1.add(new DERSequence(v5));
                v5 = new ASN1EncodableVector();
                ++v6_1;
            }

            v8_1.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            ++v3_1;
            v2_1 = v5;
        }

        v13.add(new DERSequence(v8_1));
        v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg33.length; ++v2) {
            v5.add(new DERSequence(arg42[0]));
            v7_1 = arg33[v2].getStatByte();
            v4_1.add(new DEROctetString(v7_1[0]));
            v4_1.add(new DEROctetString(v7_1[1]));
            v4_1.add(new DEROctetString(v7_1[2]));
            v4_1.add(new DEROctetString(v7_1[3]));
            v5.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            v7_2 = arg33[v2].getStatInt();
            v3.add(new ASN1Integer(((long)v7_2[0])));
            v3.add(new ASN1Integer(((long)v7_2[1])));
            v3.add(new ASN1Integer(((long)v7_2[2])));
            v3.add(new ASN1Integer(((long)v7_2[3])));
            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
            v6.add(new DERSequence(v5));
            v5 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v6));
        v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg34.length; ++v2) {
            v5.add(new DERSequence(arg42[0]));
            v7_1 = arg34[v2].getStatByte();
            v4_1.add(new DEROctetString(v7_1[0]));
            v4_1.add(new DEROctetString(v7_1[1]));
            v4_1.add(new DEROctetString(v7_1[2]));
            v4_1.add(new DEROctetString(v7_1[3]));
            v5.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            v7_2 = arg34[v2].getStatInt();
            v3.add(new ASN1Integer(((long)v7_2[0])));
            v3.add(new ASN1Integer(((long)v7_2[1])));
            v3.add(new ASN1Integer(((long)v7_2[2])));
            v3.add(new ASN1Integer(((long)v7_2[3])));
            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
            v6.add(new DERSequence(v5));
            v5 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v6));
        v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg35.length; ++v2) {
            v5.add(new DERSequence(arg42[0]));
            v7_1 = arg35[v2].getStatByte();
            v4_1.add(new DEROctetString(v7_1[0]));
            v4_1.add(new DEROctetString(v7_1[1]));
            v4_1.add(new DEROctetString(v7_1[2]));
            v4_1.add(new DEROctetString(v7_1[3]));
            v5.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            v7_2 = arg35[v2].getStatInt();
            v3.add(new ASN1Integer(((long)v7_2[0])));
            v3.add(new ASN1Integer(((long)v7_2[1])));
            v3.add(new ASN1Integer(((long)v7_2[2])));
            v3.add(new ASN1Integer(((long)v7_2[3])));
            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
            v6.add(new DERSequence(v5));
            v5 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v6));
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg36.length; ++v2) {
            v3.add(new ASN1Integer(((long)arg36[v2])));
        }

        v13.add(new DERSequence(v3));
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg37.length; ++v2) {
            v3.add(new DEROctetString(arg37[v2]));
        }

        v13.add(new DERSequence(v3));
        ASN1EncodableVector v14 = new ASN1EncodableVector();
        ASN1EncodableVector v7_3 = new ASN1EncodableVector();
        new ASN1EncodableVector();
        v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        v8_1 = v7_3;
        v3_1 = 0;
        v2_1 = new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        while(v3_1 < arg38.length) {
            v8_1.add(new DERSequence(arg42[0]));
            new ASN1EncodableVector();
            int v9_1 = arg38[v3_1].getStatInt()[0];
            v10 = arg38[v3_1].getStatInt()[7];
            v6.add(new DEROctetString(arg38[v3_1].getStatByte()[0]));
            for(v7 = 0; v7 < v9_1; ++v7) {
                v6.add(new DEROctetString(arg38[v3_1].getStatByte()[v7 + 1]));
            }

            for(v7 = 0; v7 < v10; ++v7) {
                v6.add(new DEROctetString(arg38[v3_1].getStatByte()[v9_1 + 1 + v7]));
            }

            v8_1.add(new DERSequence(v6));
            v7_3 = new ASN1EncodableVector();
            v5.add(new ASN1Integer(((long)v9_1)));
            v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[1])));
            v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[2])));
            v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[3])));
            v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[4])));
            v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[5])));
            v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[6])));
            v5.add(new ASN1Integer(((long)v10)));
            for(v6_1 = 0; v6_1 < v9_1; ++v6_1) {
                v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[v6_1 + 8])));
            }

            for(v6_1 = 0; v6_1 < v10; ++v6_1) {
                v5.add(new ASN1Integer(((long)arg38[v3_1].getStatInt()[v9_1 + 8 + v6_1])));
            }

            v8_1.add(new DERSequence(v5));
            v6 = new ASN1EncodableVector();
            ASN1EncodableVector v11 = new ASN1EncodableVector();
            ASN1EncodableVector v10_1 = new ASN1EncodableVector();
            v9 = new ASN1EncodableVector();
            if(arg38[v3_1].getTreehash() != null) {
                for(v5_1 = 0; v5_1 < arg38[v3_1].getTreehash().length; ++v5_1) {
                    v11.add(new DERSequence(arg42[0]));
                    int v15 = arg38[v3_1].getTreehash()[v5_1].getStatInt()[1];
                    v10_1.add(new DEROctetString(arg38[v3_1].getTreehash()[v5_1].getStatByte()[0]));
                    v10_1.add(new DEROctetString(arg38[v3_1].getTreehash()[v5_1].getStatByte()[1]));
                    v10_1.add(new DEROctetString(arg38[v3_1].getTreehash()[v5_1].getStatByte()[2]));
                    int v12;
                    for(v12 = 0; v12 < v15; ++v12) {
                        v10_1.add(new DEROctetString(arg38[v3_1].getTreehash()[v5_1].getStatByte()[v12 + 3]));
                    }

                    v11.add(new DERSequence(v10_1));
                    v10_1 = new ASN1EncodableVector();
                    v9.add(new ASN1Integer(((long)arg38[v3_1].getTreehash()[v5_1].getStatInt()[0])));
                    v9.add(new ASN1Integer(((long)v15)));
                    v9.add(new ASN1Integer(((long)arg38[v3_1].getTreehash()[v5_1].getStatInt()[2])));
                    v9.add(new ASN1Integer(((long)arg38[v3_1].getTreehash()[v5_1].getStatInt()[3])));
                    v9.add(new ASN1Integer(((long)arg38[v3_1].getTreehash()[v5_1].getStatInt()[4])));
                    v9.add(new ASN1Integer(((long)arg38[v3_1].getTreehash()[v5_1].getStatInt()[5])));
                    for(v12 = 0; v12 < v15; ++v12) {
                        v9.add(new ASN1Integer(((long)arg38[v3_1].getTreehash()[v5_1].getStatInt()[v12 + 6])));
                    }

                    v11.add(new DERSequence(v9));
                    v9 = new ASN1EncodableVector();
                    v2_1.add(new DERSequence(v11));
                    v11 = new ASN1EncodableVector();
                }
            }

            v8_1.add(new DERSequence(v2_1));
            v5 = new ASN1EncodableVector();
            v9 = new ASN1EncodableVector();
            if(arg38[v3_1].getRetain() != null) {
                v10_1 = v9;
                for(v9_1 = 0; v9_1 < arg38[v3_1].getRetain().length; ++v9_1) {
                    int v11_1;
                    for(v11_1 = 0; v11_1 < arg38[v3_1].getRetain()[v9_1].size(); ++v11_1) {
                        v10_1.add(new DEROctetString(arg38[v3_1].getRetain()[v9_1].elementAt(v11_1)));
                    }

                    v4_1.add(new DERSequence(v10_1));
                    v10_1 = new ASN1EncodableVector();
                }
            }

            v8_1.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            v14.add(new DERSequence(v8_1));
            v8_1 = new ASN1EncodableVector();
            ++v3_1;
            v2_1 = v5;
            v5 = v6;
            v6 = v7_3;
        }

        v13.add(new DERSequence(v14));
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg39.length; ++v2) {
            v3.add(new DEROctetString(arg39[v2]));
        }

        v13.add(new DERSequence(v3));
        v6 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg40.length; ++v2) {
            v5.add(new DERSequence(arg42[0]));
            new ASN1EncodableVector();
            v4_1.add(new DEROctetString(arg40[v2].getStatByte()[0]));
            v4_1.add(new DEROctetString(arg40[v2].getStatByte()[1]));
            v4_1.add(new DEROctetString(arg40[v2].getStatByte()[2]));
            v4_1.add(new DEROctetString(arg40[v2].getStatByte()[3]));
            v4_1.add(new DEROctetString(arg40[v2].getStatByte()[4]));
            v5.add(new DERSequence(v4_1));
            v4_1 = new ASN1EncodableVector();
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[0])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[1])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[2])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[3])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[4])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[5])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[6])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[7])));
            v3.add(new ASN1Integer(((long)arg40[v2].getStatInt()[8])));
            v5.add(new DERSequence(v3));
            v3 = new ASN1EncodableVector();
            v6.add(new DERSequence(v5));
            v5 = new ASN1EncodableVector();
        }

        v13.add(new DERSequence(v6));
        v3 = new ASN1EncodableVector();
        v4_1 = new ASN1EncodableVector();
        v5 = new ASN1EncodableVector();
        v6 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg41.getHeightOfTrees().length; ++v2) {
            v4_1.add(new ASN1Integer(((long)arg41.getHeightOfTrees()[v2])));
            v5.add(new ASN1Integer(((long)arg41.getWinternitzParameter()[v2])));
            v6.add(new ASN1Integer(((long)arg41.getK()[v2])));
        }

        v3.add(new ASN1Integer(((long)arg41.getNumOfLayers())));
        v3.add(new DERSequence(v4_1));
        v3.add(new DERSequence(v5));
        v3.add(new DERSequence(v6));
        v13.add(new DERSequence(v3));
        v3 = new ASN1EncodableVector();
        for(v2 = 0; v2 < arg42.length; ++v2) {
            v3.add(arg42[v2]);
        }

        v13.add(new DERSequence(v3));
        return new DERSequence(v13);
    }

    public ASN1Primitive toASN1Primitive() {
        return this.primitive;
    }
}

