// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.util.Arrays;

public class GMSSPublicKey extends ASN1Object {
    private byte[] publicKey;
    private ASN1Integer version;

    private GMSSPublicKey(ASN1Sequence arg4) {
        super();
        if(arg4.size() != 2) {
            throw new IllegalArgumentException("size of seq = " + arg4.size());
        }

        this.version = ASN1Integer.getInstance(arg4.getObjectAt(0));
        this.publicKey = ASN1OctetString.getInstance(arg4.getObjectAt(1)).getOctets();
    }

    public GMSSPublicKey(byte[] arg4) {
        super();
        this.version = new ASN1Integer(0);
        this.publicKey = arg4;
    }

    public static GMSSPublicKey getInstance(Object arg2) {
        GMSSPublicKey v2;
        if(!(arg2 instanceof GMSSPublicKey)) {
            if(arg2 != null) {
                v2 = new GMSSPublicKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public byte[] getPublicKey() {
        return Arrays.clone(this.publicKey);
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.version);
        v0.add(new DEROctetString(this.publicKey));
        return new DERSequence(v0);
    }
}

