// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;

public class McElieceCCA2PublicKey extends ASN1Object {
    private byte[] matrixG;
    private int n;
    private ASN1ObjectIdentifier oid;
    private int t;

    public McElieceCCA2PublicKey(ASN1ObjectIdentifier arg2, int arg3, int arg4, GF2Matrix arg5) {
        super();
        this.oid = arg2;
        this.n = arg3;
        this.t = arg4;
        this.matrixG = arg5.getEncoded();
    }

    private McElieceCCA2PublicKey(ASN1Sequence arg2) {
        super();
        this.oid = arg2.getObjectAt(0);
        this.n = arg2.getObjectAt(1).getValue().intValue();
        this.t = arg2.getObjectAt(2).getValue().intValue();
        this.matrixG = arg2.getObjectAt(3).getOctets();
    }

    public GF2Matrix getG() {
        return new GF2Matrix(this.matrixG);
    }

    public static McElieceCCA2PublicKey getInstance(Object arg2) {
        if(!(arg2 instanceof McElieceCCA2PublicKey)) {
            if(arg2 != null) {
                McElieceCCA2PublicKey v2 = new McElieceCCA2PublicKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public int getN() {
        return this.n;
    }

    public ASN1ObjectIdentifier getOID() {
        return this.oid;
    }

    public int getT() {
        return this.t;
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v0 = new ASN1EncodableVector();
        v0.add(this.oid);
        v0.add(new ASN1Integer(((long)this.n)));
        v0.add(new ASN1Integer(((long)this.t)));
        v0.add(new DEROctetString(this.matrixG));
        return new DERSequence(v0);
    }
}

