// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;

public class McEliecePrivateKey extends ASN1Object {
    private byte[] encField;
    private byte[] encGp;
    private byte[] encH;
    private byte[] encP1;
    private byte[] encP2;
    private byte[] encSInv;
    private byte[][] encqInv;
    private int k;
    private int n;
    private ASN1ObjectIdentifier oid;

    public McEliecePrivateKey(ASN1ObjectIdentifier arg4, int arg5, int arg6, GF2mField arg7, PolynomialGF2mSmallM arg8, GF2Matrix arg9, Permutation arg10, Permutation arg11, GF2Matrix arg12, PolynomialGF2mSmallM[] arg13) {
        super();
        this.oid = arg4;
        this.n = arg5;
        this.k = arg6;
        this.encField = arg7.getEncoded();
        this.encGp = arg8.getEncoded();
        this.encSInv = arg9.getEncoded();
        this.encP1 = arg10.getEncoded();
        this.encP2 = arg11.getEncoded();
        this.encH = arg12.getEncoded();
        this.encqInv = new byte[arg13.length][];
        int v0;
        for(v0 = 0; v0 != arg13.length; ++v0) {
            this.encqInv[v0] = arg13[v0].getEncoded();
        }
    }

    private McEliecePrivateKey(ASN1Sequence arg5) {
        super();
        this.oid = arg5.getObjectAt(0);
        this.n = arg5.getObjectAt(1).getValue().intValue();
        this.k = arg5.getObjectAt(2).getValue().intValue();
        this.encField = arg5.getObjectAt(3).getOctets();
        this.encGp = arg5.getObjectAt(4).getOctets();
        this.encSInv = arg5.getObjectAt(5).getOctets();
        this.encP1 = arg5.getObjectAt(6).getOctets();
        this.encP2 = arg5.getObjectAt(7).getOctets();
        this.encH = arg5.getObjectAt(8).getOctets();
        ASN1Encodable v0 = arg5.getObjectAt(9);
        this.encqInv = new byte[((ASN1Sequence)v0).size()][];
        int v2;
        for(v2 = 0; v2 < ((ASN1Sequence)v0).size(); ++v2) {
            this.encqInv[v2] = ((ASN1Sequence)v0).getObjectAt(v2).getOctets();
        }
    }

    public GF2mField getField() {
        return new GF2mField(this.encField);
    }

    public PolynomialGF2mSmallM getGoppaPoly() {
        return new PolynomialGF2mSmallM(this.getField(), this.encGp);
    }

    public GF2Matrix getH() {
        return new GF2Matrix(this.encH);
    }

    public static McEliecePrivateKey getInstance(Object arg2) {
        McEliecePrivateKey v2;
        if(!(arg2 instanceof McEliecePrivateKey)) {
            if(arg2 != null) {
                v2 = new McEliecePrivateKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public int getK() {
        return this.k;
    }

    public int getN() {
        return this.n;
    }

    public ASN1ObjectIdentifier getOID() {
        return this.oid;
    }

    public Permutation getP1() {
        return new Permutation(this.encP1);
    }

    public Permutation getP2() {
        return new Permutation(this.encP2);
    }

    public PolynomialGF2mSmallM[] getQInv() {
        PolynomialGF2mSmallM[] v1 = new PolynomialGF2mSmallM[this.encqInv.length];
        GF2mField v2 = this.getField();
        int v0;
        for(v0 = 0; v0 < this.encqInv.length; ++v0) {
            v1[v0] = new PolynomialGF2mSmallM(v2, this.encqInv[v0]);
        }

        return v1;
    }

    public GF2Matrix getSInv() {
        return new GF2Matrix(this.encSInv);
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        v1.add(this.oid);
        v1.add(new ASN1Integer(((long)this.n)));
        v1.add(new ASN1Integer(((long)this.k)));
        v1.add(new DEROctetString(this.encField));
        v1.add(new DEROctetString(this.encGp));
        v1.add(new DEROctetString(this.encSInv));
        v1.add(new DEROctetString(this.encP1));
        v1.add(new DEROctetString(this.encP2));
        v1.add(new DEROctetString(this.encH));
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < this.encqInv.length; ++v0) {
            v2.add(new DEROctetString(this.encqInv[v0]));
        }

        v1.add(new DERSequence(v2));
        return new DERSequence(v1);
    }
}

