// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import java.math.BigInteger;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.util.Arrays;

public class ParSet extends ASN1Object {
    private static final BigInteger ZERO;
    private int[] h;
    private int[] k;
    private int t;
    private int[] w;

    static {
        ParSet.ZERO = BigInteger.valueOf(0);
    }

    public ParSet(int arg1, int[] arg2, int[] arg3, int[] arg4) {
        super();
        this.t = arg1;
        this.h = arg2;
        this.w = arg3;
        this.k = arg4;
    }

    private ParSet(ASN1Sequence arg7) {
        super();
        if(arg7.size() != 4) {
            throw new IllegalArgumentException("sie of seqOfParams = " + arg7.size());
        }

        this.t = ParSet.checkBigIntegerInIntRangeAndPositive(arg7.getObjectAt(0).getValue());
        ASN1Encodable v0 = arg7.getObjectAt(1);
        ASN1Encodable v1 = arg7.getObjectAt(2);
        ASN1Encodable v2 = arg7.getObjectAt(3);
        if(((ASN1Sequence)v0).size() == this.t && ((ASN1Sequence)v1).size() == this.t && ((ASN1Sequence)v2).size() == this.t) {
            this.h = new int[((ASN1Sequence)v0).size()];
            this.w = new int[((ASN1Sequence)v1).size()];
            this.k = new int[((ASN1Sequence)v2).size()];
            int v4;
            for(v4 = 0; v4 < this.t; ++v4) {
                this.h[v4] = ParSet.checkBigIntegerInIntRangeAndPositive(((ASN1Sequence)v0).getObjectAt(v4).getValue());
                this.w[v4] = ParSet.checkBigIntegerInIntRangeAndPositive(((ASN1Sequence)v1).getObjectAt(v4).getValue());
                this.k[v4] = ParSet.checkBigIntegerInIntRangeAndPositive(((ASN1Sequence)v2).getObjectAt(v4).getValue());
            }

            return;
        }

        throw new IllegalArgumentException("invalid size of sequences");
    }

    private static int checkBigIntegerInIntRangeAndPositive(BigInteger arg3) {
        if(arg3.compareTo(BigInteger.valueOf(2147483647)) <= 0 && arg3.compareTo(ParSet.ZERO) > 0) {
            return arg3.intValue();
        }

        throw new IllegalArgumentException("BigInteger not in Range: " + arg3.toString());
    }

    public int[] getH() {
        return Arrays.clone(this.h);
    }

    public static ParSet getInstance(Object arg2) {
        ParSet v2;
        if(!(arg2 instanceof ParSet)) {
            if(arg2 != null) {
                v2 = new ParSet(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return v2;
    }

    public int[] getK() {
        return Arrays.clone(this.k);
    }

    public int getT() {
        return this.t;
    }

    public int[] getW() {
        return Arrays.clone(this.w);
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v1 = new ASN1EncodableVector();
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        ASN1EncodableVector v3 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < this.h.length; ++v0) {
            v1.add(new ASN1Integer(((long)this.h[v0])));
            v2.add(new ASN1Integer(((long)this.w[v0])));
            v3.add(new ASN1Integer(((long)this.k[v0])));
        }

        ASN1EncodableVector v0_1 = new ASN1EncodableVector();
        v0_1.add(new ASN1Integer(((long)this.t)));
        v0_1.add(new DERSequence(v1));
        v0_1.add(new DERSequence(v2));
        v0_1.add(new DERSequence(v3));
        return new DERSequence(v0_1);
    }
}

