// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.pqc.crypto.rainbow.Layer;
import org.bouncycastle.pqc.crypto.rainbow.util.RainbowUtil;

public class RainbowPrivateKey extends ASN1Object {
    private byte[] b1;
    private byte[] b2;
    private byte[][] invA1;
    private byte[][] invA2;
    private Layer[] layers;
    private ASN1ObjectIdentifier oid;
    private ASN1Integer version;
    private byte[] vi;

    private RainbowPrivateKey(ASN1Sequence arg14) {
        ASN1Encodable v3;
        super();
        if((arg14.getObjectAt(0) instanceof ASN1Integer)) {
            this.version = ASN1Integer.getInstance(arg14.getObjectAt(0));
        }
        else {
            this.oid = ASN1ObjectIdentifier.getInstance(arg14.getObjectAt(0));
        }

        ASN1Encodable v0 = arg14.getObjectAt(1);
        this.invA1 = new byte[((ASN1Sequence)v0).size()][];
        int v2;
        for(v2 = 0; v2 < ((ASN1Sequence)v0).size(); ++v2) {
            this.invA1[v2] = ((ASN1Sequence)v0).getObjectAt(v2).getOctets();
        }

        this.b1 = arg14.getObjectAt(2).getObjectAt(0).getOctets();
        v0 = arg14.getObjectAt(3);
        this.invA2 = new byte[((ASN1Sequence)v0).size()][];
        for(v2 = 0; v2 < ((ASN1Sequence)v0).size(); ++v2) {
            this.invA2[v2] = ((ASN1Sequence)v0).getObjectAt(v2).getOctets();
        }

        this.b2 = arg14.getObjectAt(4).getObjectAt(0).getOctets();
        this.vi = arg14.getObjectAt(5).getObjectAt(0).getOctets();
        v0 = arg14.getObjectAt(6);
        byte[][][][] v8 = new byte[((ASN1Sequence)v0).size()][][][];
        byte[][][][] v9 = new byte[((ASN1Sequence)v0).size()][][][];
        byte[][][] v10 = new byte[((ASN1Sequence)v0).size()][][];
        byte[][] v11 = new byte[((ASN1Sequence)v0).size()][];
        int v5;
        for(v5 = 0; v5 < ((ASN1Sequence)v0).size(); ++v5) {
            ASN1Encodable v1 = ((ASN1Sequence)v0).getObjectAt(v5);
            ASN1Encodable v2_1 = ((ASN1Sequence)v1).getObjectAt(0);
            v8[v5] = new byte[((ASN1Sequence)v2_1).size()][][];
            int v6;
            for(v6 = 0; v6 < ((ASN1Sequence)v2_1).size(); ++v6) {
                v3 = ((ASN1Sequence)v2_1).getObjectAt(v6);
                v8[v5][v6] = new byte[((ASN1Sequence)v3).size()][];
                int v7;
                for(v7 = 0; v7 < ((ASN1Sequence)v3).size(); ++v7) {
                    v8[v5][v6][v7] = ((ASN1Sequence)v3).getObjectAt(v7).getOctets();
                }
            }

            v2_1 = ((ASN1Sequence)v1).getObjectAt(1);
            v9[v5] = new byte[((ASN1Sequence)v2_1).size()][][];
            for(v6 = 0; v6 < ((ASN1Sequence)v2_1).size(); ++v6) {
                v3 = ((ASN1Sequence)v2_1).getObjectAt(v6);
                v9[v5][v6] = new byte[((ASN1Sequence)v3).size()][];
                for(v7 = 0; v7 < ((ASN1Sequence)v3).size(); ++v7) {
                    v9[v5][v6][v7] = ((ASN1Sequence)v3).getObjectAt(v7).getOctets();
                }
            }

            v2_1 = ((ASN1Sequence)v1).getObjectAt(2);
            v10[v5] = new byte[((ASN1Sequence)v2_1).size()][];
            int v4;
            for(v4 = 0; v4 < ((ASN1Sequence)v2_1).size(); ++v4) {
                v10[v5][v4] = ((ASN1Sequence)v2_1).getObjectAt(v4).getOctets();
            }

            v11[v5] = ((ASN1Sequence)v1).getObjectAt(3).getOctets();
        }

        int v12 = this.vi.length - 1;
        this.layers = new Layer[v12];
        for(v7 = 0; v7 < v12; ++v7) {
            this.layers[v7] = new Layer(this.vi[v7], this.vi[v7 + 1], RainbowUtil.convertArray(v8[v7]), RainbowUtil.convertArray(v9[v7]), RainbowUtil.convertArray(v10[v7]), RainbowUtil.convertArray(v11[v7]));
        }
    }

    public RainbowPrivateKey(short[][] arg4, short[] arg5, short[][] arg6, short[] arg7, int[] arg8, Layer[] arg9) {
        super();
        this.version = new ASN1Integer(1);
        this.invA1 = RainbowUtil.convertArray(arg4);
        this.b1 = RainbowUtil.convertArray(arg5);
        this.invA2 = RainbowUtil.convertArray(arg6);
        this.b2 = RainbowUtil.convertArray(arg7);
        this.vi = RainbowUtil.convertIntArray(arg8);
        this.layers = arg9;
    }

    public short[] getB1() {
        return RainbowUtil.convertArray(this.b1);
    }

    public short[] getB2() {
        return RainbowUtil.convertArray(this.b2);
    }

    public static RainbowPrivateKey getInstance(Object arg2) {
        if(!(arg2 instanceof RainbowPrivateKey)) {
            if(arg2 != null) {
                RainbowPrivateKey v2 = new RainbowPrivateKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public short[][] getInvA1() {
        return RainbowUtil.convertArray(this.invA1);
    }

    public short[][] getInvA2() {
        return RainbowUtil.convertArray(this.invA2);
    }

    public Layer[] getLayers() {
        return this.layers;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public int[] getVi() {
        return RainbowUtil.convertArraytoInt(this.vi);
    }

    public ASN1Primitive toASN1Primitive() {
        ASN1EncodableVector v9;
        ASN1EncodableVector v4 = new ASN1EncodableVector();
        if(this.version != null) {
            v4.add(this.version);
        }
        else {
            v4.add(this.oid);
        }

        ASN1EncodableVector v2 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < this.invA1.length; ++v0) {
            v2.add(new DEROctetString(this.invA1[v0]));
        }

        v4.add(new DERSequence(v2));
        ASN1EncodableVector v0_1 = new ASN1EncodableVector();
        v0_1.add(new DEROctetString(this.b1));
        v4.add(new DERSequence(v0_1));
        v2 = new ASN1EncodableVector();
        for(v0 = 0; v0 < this.invA2.length; ++v0) {
            v2.add(new DEROctetString(this.invA2[v0]));
        }

        v4.add(new DERSequence(v2));
        v0_1 = new ASN1EncodableVector();
        v0_1.add(new DEROctetString(this.b2));
        v4.add(new DERSequence(v0_1));
        v0_1 = new ASN1EncodableVector();
        v0_1.add(new DEROctetString(this.vi));
        v4.add(new DERSequence(v0_1));
        ASN1EncodableVector v5 = new ASN1EncodableVector();
        for(v0 = 0; v0 < this.layers.length; ++v0) {
            ASN1EncodableVector v6 = new ASN1EncodableVector();
            byte[][][] v7 = RainbowUtil.convertArray(this.layers[v0].getCoeffAlpha());
            ASN1EncodableVector v8 = new ASN1EncodableVector();
            int v2_1;
            for(v2_1 = 0; v2_1 < v7.length; ++v2_1) {
                v9 = new ASN1EncodableVector();
                int v3;
                for(v3 = 0; v3 < v7[v2_1].length; ++v3) {
                    v9.add(new DEROctetString(v7[v2_1][v3]));
                }

                v8.add(new DERSequence(v9));
            }

            v6.add(new DERSequence(v8));
            v7 = RainbowUtil.convertArray(this.layers[v0].getCoeffBeta());
            v8 = new ASN1EncodableVector();
            for(v2_1 = 0; v2_1 < v7.length; ++v2_1) {
                v9 = new ASN1EncodableVector();
                for(v3 = 0; v3 < v7[v2_1].length; ++v3) {
                    v9.add(new DEROctetString(v7[v2_1][v3]));
                }

                v8.add(new DERSequence(v9));
            }

            v6.add(new DERSequence(v8));
            byte[][] v3_1 = RainbowUtil.convertArray(this.layers[v0].getCoeffGamma());
            ASN1EncodableVector v7_1 = new ASN1EncodableVector();
            for(v2_1 = 0; v2_1 < v3_1.length; ++v2_1) {
                v7_1.add(new DEROctetString(v3_1[v2_1]));
            }

            v6.add(new DERSequence(v7_1));
            v6.add(new DEROctetString(RainbowUtil.convertArray(this.layers[v0].getCoeffEta())));
            v5.add(new DERSequence(v6));
        }

        v4.add(new DERSequence(v5));
        return new DERSequence(v4);
    }
}

