// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.asn1;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1OctetString;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.pqc.crypto.rainbow.util.RainbowUtil;

public class RainbowPublicKey extends ASN1Object {
    private byte[][] coeffQuadratic;
    private byte[] coeffScalar;
    private byte[][] coeffSingular;
    private ASN1Integer docLength;
    private ASN1ObjectIdentifier oid;
    private ASN1Integer version;

    public RainbowPublicKey(int arg4, short[][] arg5, short[][] arg6, short[] arg7) {
        super();
        this.version = new ASN1Integer(0);
        this.docLength = new ASN1Integer(((long)arg4));
        this.coeffQuadratic = RainbowUtil.convertArray(arg5);
        this.coeffSingular = RainbowUtil.convertArray(arg6);
        this.coeffScalar = RainbowUtil.convertArray(arg7);
    }

    private RainbowPublicKey(ASN1Sequence arg6) {
        super();
        if((arg6.getObjectAt(0) instanceof ASN1Integer)) {
            this.version = ASN1Integer.getInstance(arg6.getObjectAt(0));
        }
        else {
            this.oid = ASN1ObjectIdentifier.getInstance(arg6.getObjectAt(0));
        }

        this.docLength = ASN1Integer.getInstance(arg6.getObjectAt(1));
        ASN1Sequence v2 = ASN1Sequence.getInstance(arg6.getObjectAt(2));
        this.coeffQuadratic = new byte[v2.size()][];
        int v0;
        for(v0 = 0; v0 < v2.size(); ++v0) {
            this.coeffQuadratic[v0] = ASN1OctetString.getInstance(v2.getObjectAt(v0)).getOctets();
        }

        ASN1Encodable v0_1 = arg6.getObjectAt(3);
        this.coeffSingular = new byte[((ASN1Sequence)v0_1).size()][];
        int v2_1;
        for(v2_1 = 0; v2_1 < ((ASN1Sequence)v0_1).size(); ++v2_1) {
            this.coeffSingular[v2_1] = ASN1OctetString.getInstance(((ASN1Sequence)v0_1).getObjectAt(v2_1)).getOctets();
        }

        this.coeffScalar = ASN1OctetString.getInstance(arg6.getObjectAt(4).getObjectAt(0)).getOctets();
    }

    public short[][] getCoeffQuadratic() {
        return RainbowUtil.convertArray(this.coeffQuadratic);
    }

    public short[] getCoeffScalar() {
        return RainbowUtil.convertArray(this.coeffScalar);
    }

    public short[][] getCoeffSingular() {
        return RainbowUtil.convertArray(this.coeffSingular);
    }

    public int getDocLength() {
        return this.docLength.getValue().intValue();
    }

    public static RainbowPublicKey getInstance(Object arg2) {
        if(!(arg2 instanceof RainbowPublicKey)) {
            if(arg2 != null) {
                RainbowPublicKey v2 = new RainbowPublicKey(ASN1Sequence.getInstance(arg2));
            }
            else {
                arg2 = null;
            }
        }

        return arg2;
    }

    public ASN1Integer getVersion() {
        return this.version;
    }

    public ASN1Primitive toASN1Primitive() {
        int v1 = 0;
        ASN1EncodableVector v2 = new ASN1EncodableVector();
        if(this.version != null) {
            v2.add(this.version);
        }
        else {
            v2.add(this.oid);
        }

        v2.add(this.docLength);
        ASN1EncodableVector v3 = new ASN1EncodableVector();
        int v0;
        for(v0 = 0; v0 < this.coeffQuadratic.length; ++v0) {
            v3.add(new DEROctetString(this.coeffQuadratic[v0]));
        }

        v2.add(new DERSequence(v3));
        ASN1EncodableVector v0_1 = new ASN1EncodableVector();
        while(v1 < this.coeffSingular.length) {
            v0_1.add(new DEROctetString(this.coeffSingular[v1]));
            ++v1;
        }

        v2.add(new DERSequence(v0_1));
        v0_1 = new ASN1EncodableVector();
        v0_1.add(new DEROctetString(this.coeffScalar));
        v2.add(new DERSequence(v0_1));
        return new DERSequence(v2);
    }
}

