// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.Signer;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;

public class DigestingMessageSigner implements Signer {
    private boolean forSigning;
    private final Digest messDigest;
    private final MessageSigner messSigner;

    public DigestingMessageSigner(MessageSigner arg1, Digest arg2) {
        super();
        this.messSigner = arg1;
        this.messDigest = arg2;
    }

    public byte[] generateSignature() {
        if(!this.forSigning) {
            throw new IllegalStateException("RainbowDigestSigner not initialised for signature generation.");
        }

        byte[] v0 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.doFinal(v0, 0);
        return this.messSigner.generateSignature(v0);
    }

    public void init(boolean arg3, CipherParameters arg4) {
        this.forSigning = arg3;
        CipherParameters v0 = (arg4 instanceof ParametersWithRandom) ? arg4.getParameters() : arg4;
        if((arg3) && !((AsymmetricKeyParameter)v0).isPrivate()) {
            throw new IllegalArgumentException("Signing Requires Private Key.");
        }

        if(!arg3 && (((AsymmetricKeyParameter)v0).isPrivate())) {
            throw new IllegalArgumentException("Verification Requires Public Key.");
        }

        this.reset();
        this.messSigner.init(arg3, arg4);
    }

    public void reset() {
        this.messDigest.reset();
    }

    public void update(byte arg2) {
        this.messDigest.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.messDigest.update(arg2, arg3, arg4);
    }

    public boolean verify(byte[] arg4) {
        if(this.forSigning) {
            throw new IllegalStateException("RainbowDigestSigner not initialised for verification");
        }

        byte[] v0 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.doFinal(v0, 0);
        return this.messSigner.verifySignature(v0, arg4);
    }

    public boolean verifySignature(byte[] arg2) {
        return this.verify(arg2);
    }
}

