// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss;

import java.security.SecureRandom;
import java.util.Vector;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.pqc.crypto.gmss.util.GMSSRandom;
import org.bouncycastle.pqc.crypto.gmss.util.WinternitzOTSVerify;
import org.bouncycastle.pqc.crypto.gmss.util.WinternitzOTSignature;

public class GMSSKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private int[] K;
    public static final String OID = "1.3.6.1.4.1.8301.3.1.3.3";
    private byte[][] currentRootSigs;
    private byte[][] currentSeeds;
    private GMSSDigestProvider digestProvider;
    private GMSSParameters gmssPS;
    private GMSSKeyGenerationParameters gmssParams;
    private GMSSRandom gmssRandom;
    private int[] heightOfTrees;
    private boolean initialized;
    private int mdLength;
    private Digest messDigestTree;
    private byte[][] nextNextSeeds;
    private int numLayer;
    private int[] otsIndex;

    public GMSSKeyPairGenerator(GMSSDigestProvider arg3) {
        super();
        this.initialized = false;
        this.digestProvider = arg3;
        this.messDigestTree = arg3.get();
        this.mdLength = this.messDigestTree.getDigestSize();
        this.gmssRandom = new GMSSRandom(this.messDigestTree);
    }

    private AsymmetricCipherKeyPair genKeyPair() {
        int v17_1;
        if(!this.initialized) {
            this.initializeDefault();
        }

        byte[][][] v8 = new byte[this.numLayer][][];
        byte[][][] v9 = new byte[this.numLayer - 1][][];
        Treehash[][] v10 = new Treehash[this.numLayer][];
        Treehash[][] v11 = new Treehash[this.numLayer - 1][];
        Vector[] v12 = new Vector[this.numLayer];
        Vector[] v13 = new Vector[this.numLayer - 1];
        Vector[][] v14 = new Vector[this.numLayer][];
        Vector[][] v15 = new Vector[this.numLayer - 1][];
        int v6;
        for(v6 = 0; v6 < this.numLayer; ++v6) {
            v8[v6] = new byte[this.heightOfTrees[v6]][this.mdLength];
            v10[v6] = new Treehash[this.heightOfTrees[v6] - this.K[v6]];
            if(v6 > 0) {
                v9[v6 - 1] = new byte[this.heightOfTrees[v6]][this.mdLength];
                v11[v6 - 1] = new Treehash[this.heightOfTrees[v6] - this.K[v6]];
            }

            v12[v6] = new Vector();
            if(v6 > 0) {
                v13[v6 - 1] = new Vector();
            }
        }

        Object v5 = new byte[this.numLayer][this.mdLength];
        Object v16 = new byte[this.numLayer - 1][this.mdLength];
        Object v6_1 = new byte[this.numLayer][this.mdLength];
        int v7;
        for(v7 = 0; v7 < this.numLayer; ++v7) {
            System.arraycopy(this.currentSeeds[v7], 0, v6_1[v7], 0, this.mdLength);
        }

        this.currentRootSigs = new byte[this.numLayer - 1][this.mdLength];
        int v18;
        for(v18 = this.numLayer - 1; v18 >= 0; --v18) {
            GMSSRootCalc v7_1 = new GMSSRootCalc(this.heightOfTrees[v18], this.K[v18], this.digestProvider);
            try {
                if(v18 != this.numLayer - 1) {
                    goto label_202;
                }

                v7_1 = this.generateCurrentAuthpathAndRoot(null, v12[v18], v6_1[v18], v18);
                goto label_182;
            }
            catch(Exception v17) {
                goto label_214;
            }

        label_202:
            v17_1 = v18 + 1;
            try {
                v7_1 = this.generateCurrentAuthpathAndRoot(v5[v17_1], v12[v18], v6_1[v18], v18);
            }
            catch(Exception v17) {
            label_214:
                v17.printStackTrace();
            }

        label_182:
            for(v17_1 = 0; v17_1 < this.heightOfTrees[v18]; ++v17_1) {
                System.arraycopy(v7_1.getAuthPath()[v17_1], 0, v8[v18][v17_1], 0, this.mdLength);
            }

            v14[v18] = v7_1.getRetain();
            v10[v18] = v7_1.getTreehash();
            System.arraycopy(v7_1.getRoot(), 0, v5[v18], 0, this.mdLength);
        }

        for(v17_1 = this.numLayer - 2; v17_1 >= 0; --v17_1) {
            GMSSRootCalc v18_1 = this.generateNextAuthpathAndRoot(v13[v17_1], v6_1[v17_1 + 1], v17_1 + 1);
            for(v7 = 0; v7 < this.heightOfTrees[v17_1 + 1]; ++v7) {
                System.arraycopy(v18_1.getAuthPath()[v7], 0, v9[v17_1][v7], 0, this.mdLength);
            }

            v15[v17_1] = v18_1.getRetain();
            v11[v17_1] = v18_1.getTreehash();
            System.arraycopy(v18_1.getRoot(), 0, v16[v17_1], 0, this.mdLength);
            System.arraycopy(v6_1[v17_1 + 1], 0, this.nextNextSeeds[v17_1], 0, this.mdLength);
        }

        return new AsymmetricCipherKeyPair(new GMSSPublicKeyParameters(v5[0], this.gmssPS), new GMSSPrivateKeyParameters(this.currentSeeds, this.nextNextSeeds, v8, v9, v10, v11, v12, v13, v14, v15, ((byte[][])v16), this.currentRootSigs, this.gmssPS, this.digestProvider));
    }

    private GMSSRootCalc generateCurrentAuthpathAndRoot(byte[] arg10, Vector arg11, byte[] arg12, int arg13) {
        GMSSRootCalc v0_2;
        new byte[this.mdLength];
        new byte[this.mdLength];
        byte[] v0 = this.gmssRandom.nextSeed(arg12);
        GMSSRootCalc v4 = new GMSSRootCalc(this.heightOfTrees[arg13], this.K[arg13], this.digestProvider);
        v4.initialize(arg11);
        if(arg13 == this.numLayer - 1) {
            v0 = new WinternitzOTSignature(v0, this.digestProvider.get(), this.otsIndex[arg13]).getPublicKey();
        }
        else {
            this.currentRootSigs[arg13] = new WinternitzOTSignature(v0, this.digestProvider.get(), this.otsIndex[arg13]).getSignature(arg10);
            v0 = new WinternitzOTSVerify(this.digestProvider.get(), this.otsIndex[arg13]).Verify(arg10, this.currentRootSigs[arg13]);
        }

        v4.update(v0);
        int v3 = 3;
        int v2 = 0;
        int v0_1;
        for(v0_1 = 1; v0_1 < 1 << this.heightOfTrees[arg13]; ++v0_1) {
            if(v0_1 == v3 && v2 < this.heightOfTrees[arg13] - this.K[arg13]) {
                v4.initializeTreehashSeed(arg12, v2);
                v3 *= 2;
                ++v2;
            }

            v4.update(new WinternitzOTSignature(this.gmssRandom.nextSeed(arg12), this.digestProvider.get(), this.otsIndex[arg13]).getPublicKey());
        }

        if(v4.wasFinished()) {
            v0_2 = v4;
        }
        else {
            System.err.println("Baum noch nicht fertig konstruiert!!!");
            v0_2 = null;
        }

        return v0_2;
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        return this.genKeyPair();
    }

    private GMSSRootCalc generateNextAuthpathAndRoot(Vector arg9, byte[] arg10, int arg11) {
        GMSSRootCalc v0_1;
        int v0 = 0;
        new byte[this.numLayer];
        GMSSRootCalc v3 = new GMSSRootCalc(this.heightOfTrees[arg11], this.K[arg11], this.digestProvider);
        v3.initialize(arg9);
        int v2 = 3;
        int v1 = 0;
        while(v0 < 1 << this.heightOfTrees[arg11]) {
            if(v0 == v2 && v1 < this.heightOfTrees[arg11] - this.K[arg11]) {
                v3.initializeTreehashSeed(arg10, v1);
                v2 *= 2;
                ++v1;
            }

            v3.update(new WinternitzOTSignature(this.gmssRandom.nextSeed(arg10), this.digestProvider.get(), this.otsIndex[arg11]).getPublicKey());
            ++v0;
        }

        if(v3.wasFinished()) {
            v0_1 = v3;
        }
        else {
            System.err.println("N\uFFFDchster Baum noch nicht fertig konstruiert!!!");
            v0_1 = null;
        }

        return v0_1;
    }

    public void init(KeyGenerationParameters arg1) {
        this.initialize(arg1);
    }

    public void initialize(KeyGenerationParameters arg6) {
        this.gmssParams = ((GMSSKeyGenerationParameters)arg6);
        this.gmssPS = new GMSSParameters(this.gmssParams.getParameters().getNumOfLayers(), this.gmssParams.getParameters().getHeightOfTrees(), this.gmssParams.getParameters().getWinternitzParameter(), this.gmssParams.getParameters().getK());
        this.numLayer = this.gmssPS.getNumOfLayers();
        this.heightOfTrees = this.gmssPS.getHeightOfTrees();
        this.otsIndex = this.gmssPS.getWinternitzParameter();
        this.K = this.gmssPS.getK();
        this.currentSeeds = new byte[this.numLayer][this.mdLength];
        this.nextNextSeeds = new byte[this.numLayer - 1][this.mdLength];
        SecureRandom v1 = new SecureRandom();
        int v0;
        for(v0 = 0; v0 < this.numLayer; ++v0) {
            v1.nextBytes(this.currentSeeds[v0]);
            this.gmssRandom.nextSeed(this.currentSeeds[v0]);
        }

        this.initialized = true;
    }

    public void initialize(int arg8, SecureRandom arg9) {
        GMSSKeyGenerationParameters v0_1;
        int[] v1;
        int v0 = 10;
        int v6 = 4;
        int v4 = 2;
        if(arg8 <= v0) {
            v1 = new int[]{v0};
            v0_1 = new GMSSKeyGenerationParameters(arg9, new GMSSParameters(v1.length, v1, new int[]{3}, new int[]{v4}));
        }
        else if(arg8 <= 20) {
            v1 = new int[]{10, 10};
            v0_1 = new GMSSKeyGenerationParameters(arg9, new GMSSParameters(v1.length, v1, new int[]{5, 4}, new int[]{2, 2}));
        }
        else {
            v1 = new int[]{10, 10, 10, 10};
            v0_1 = new GMSSKeyGenerationParameters(arg9, new GMSSParameters(v1.length, v1, new int[]{9, 9, 9, 3}, new int[]{2, 2, 2, 2}));
        }

        this.initialize(((KeyGenerationParameters)v0_1));
    }

    private void initializeDefault() {
        int[] v0 = new int[]{10, 10, 10, 10};
        this.initialize(new GMSSKeyGenerationParameters(new SecureRandom(), new GMSSParameters(v0.length, v0, new int[]{3, 3, 3, 3}, new int[]{2, 2, 2, 2})));
    }
}

