// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss;

import org.bouncycastle.crypto.Digest;
import org.bouncycastle.pqc.crypto.gmss.util.GMSSRandom;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.encoders.Hex;

public class GMSSLeaf {
    private byte[] concHashs;
    private GMSSRandom gmssRandom;
    private int i;
    private int j;
    private int keysize;
    private byte[] leaf;
    private int mdsize;
    private Digest messDigestOTS;
    byte[] privateKeyOTS;
    private byte[] seed;
    private int steps;
    private int two_power_w;
    private int w;

    GMSSLeaf(Digest arg7, int arg8, int arg9) {
        super();
        this.w = arg8;
        this.messDigestOTS = arg7;
        this.gmssRandom = new GMSSRandom(this.messDigestOTS);
        this.mdsize = this.messDigestOTS.getDigestSize();
        int v0 = ((int)Math.ceil((((double)(this.mdsize << 3))) / (((double)arg8))));
        this.keysize = v0 + (((int)Math.ceil((((double)this.getLog((v0 << arg8) + 1))) / (((double)arg8)))));
        this.two_power_w = 1 << arg8;
        this.steps = ((int)Math.ceil((((double)(((1 << arg8) - 1) * this.keysize + 1 + this.keysize))) / (((double)arg9))));
        this.seed = new byte[this.mdsize];
        this.leaf = new byte[this.mdsize];
        this.privateKeyOTS = new byte[this.mdsize];
        this.concHashs = new byte[this.mdsize * this.keysize];
    }

    public GMSSLeaf(Digest arg7, int arg8, int arg9, byte[] arg10) {
        super();
        this.w = arg8;
        this.messDigestOTS = arg7;
        this.gmssRandom = new GMSSRandom(this.messDigestOTS);
        this.mdsize = this.messDigestOTS.getDigestSize();
        int v0 = ((int)Math.ceil((((double)(this.mdsize << 3))) / (((double)arg8))));
        this.keysize = v0 + (((int)Math.ceil((((double)this.getLog((v0 << arg8) + 1))) / (((double)arg8)))));
        this.two_power_w = 1 << arg8;
        this.steps = ((int)Math.ceil((((double)(((1 << arg8) - 1) * this.keysize + 1 + this.keysize))) / (((double)arg9))));
        this.seed = new byte[this.mdsize];
        this.leaf = new byte[this.mdsize];
        this.privateKeyOTS = new byte[this.mdsize];
        this.concHashs = new byte[this.mdsize * this.keysize];
        this.initLeafCalc(arg10);
    }

    public GMSSLeaf(Digest arg10, byte[][] arg11, int[] arg12) {
        super();
        this.i = arg12[0];
        this.j = arg12[1];
        this.steps = arg12[2];
        this.w = arg12[3];
        this.messDigestOTS = arg10;
        this.gmssRandom = new GMSSRandom(this.messDigestOTS);
        this.mdsize = this.messDigestOTS.getDigestSize();
        int v0 = ((int)Math.ceil((((double)(this.mdsize << 3))) / (((double)this.w))));
        this.keysize = v0 + (((int)Math.ceil((((double)this.getLog((v0 << this.w) + 1))) / (((double)this.w)))));
        this.two_power_w = 1 << this.w;
        this.privateKeyOTS = arg11[0];
        this.seed = arg11[1];
        this.concHashs = arg11[2];
        this.leaf = arg11[3];
    }

    private GMSSLeaf(GMSSLeaf arg2) {
        super();
        this.messDigestOTS = arg2.messDigestOTS;
        this.mdsize = arg2.mdsize;
        this.keysize = arg2.keysize;
        this.gmssRandom = arg2.gmssRandom;
        this.leaf = Arrays.clone(arg2.leaf);
        this.concHashs = Arrays.clone(arg2.concHashs);
        this.i = arg2.i;
        this.j = arg2.j;
        this.two_power_w = arg2.two_power_w;
        this.w = arg2.w;
        this.steps = arg2.steps;
        this.seed = Arrays.clone(arg2.seed);
        this.privateKeyOTS = Arrays.clone(arg2.privateKeyOTS);
    }

    public byte[] getLeaf() {
        return Arrays.clone(this.leaf);
    }

    private int getLog(int arg3) {
        int v1 = 1;
        int v0 = 2;
        while(v0 < arg3) {
            v0 <<= 1;
            ++v1;
        }

        return v1;
    }

    public byte[][] getStatByte() {
        byte[][] v0 = new byte[][]{new byte[this.mdsize], new byte[this.mdsize], new byte[this.mdsize * this.keysize], new byte[this.mdsize]};
        v0[0] = this.privateKeyOTS;
        v0[1] = this.seed;
        v0[2] = this.concHashs;
        v0[3] = this.leaf;
        return v0;
    }

    public int[] getStatInt() {
        return new int[]{this.i, this.j, this.steps, this.w};
    }

    void initLeafCalc(byte[] arg4) {
        this.i = 0;
        this.j = 0;
        byte[] v0 = new byte[this.mdsize];
        System.arraycopy(arg4, 0, v0, 0, this.seed.length);
        this.seed = this.gmssRandom.nextSeed(v0);
    }

    GMSSLeaf nextLeaf() {
        GMSSLeaf v0 = new GMSSLeaf(this);
        v0.updateLeafCalc();
        return v0;
    }

    public String toString() {
        int v5 = 4;
        String v2 = "";
        int v1;
        for(v1 = 0; v1 < v5; ++v1) {
            v2 = v2 + this.getStatInt()[v1] + " ";
        }

        String v1_1 = v2 + " " + this.mdsize + " " + this.keysize + " " + this.two_power_w + " ";
        byte[][] v2_1 = this.getStatByte();
        String v0 = v1_1;
        for(v1 = 0; v1 < v5; ++v1) {
            v0 = v2_1[v1] != null ? v0 + new String(Hex.encode(v2_1[v1])) + " " : v0 + "null ";
        }

        return v0;
    }

    private void updateLeafCalc() {
        byte[] v2 = new byte[this.messDigestOTS.getDigestSize()];
        int v0;
        for(v0 = 0; v0 < this.steps + 10000; ++v0) {
            if(this.i == this.keysize && this.j == this.two_power_w - 1) {
                this.messDigestOTS.update(this.concHashs, 0, this.concHashs.length);
                this.leaf = new byte[this.messDigestOTS.getDigestSize()];
                this.messDigestOTS.doFinal(this.leaf, 0);
                return;
            }

            if(this.i == 0 || this.j == this.two_power_w - 1) {
                ++this.i;
                this.j = 0;
                this.privateKeyOTS = this.gmssRandom.nextSeed(this.seed);
            }
            else {
                this.messDigestOTS.update(this.privateKeyOTS, 0, this.privateKeyOTS.length);
                this.privateKeyOTS = v2;
                this.messDigestOTS.doFinal(this.privateKeyOTS, 0);
                ++this.j;
                if(this.j == this.two_power_w - 1) {
                    System.arraycopy(this.privateKeyOTS, 0, this.concHashs, this.mdsize * (this.i - 1), this.mdsize);
                }
            }
        }

        throw new IllegalStateException("unable to updateLeaf in steps: " + this.steps + " " + this.i + " " + this.j);
    }
}

