// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss;

import java.util.Vector;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.pqc.crypto.gmss.util.GMSSRandom;
import org.bouncycastle.pqc.crypto.gmss.util.WinternitzOTSignature;
import org.bouncycastle.util.Arrays;

public class GMSSPrivateKeyParameters extends GMSSKeyParameters {
    private int[] K;
    private byte[][][] currentAuthPaths;
    private Vector[][] currentRetain;
    private byte[][] currentRootSig;
    private byte[][] currentSeeds;
    private Vector[] currentStack;
    private Treehash[][] currentTreehash;
    private GMSSDigestProvider digestProvider;
    private GMSSParameters gmssPS;
    private GMSSRandom gmssRandom;
    private int[] heightOfTrees;
    private int[] index;
    private byte[][][] keep;
    private int mdLength;
    private Digest messDigestTrees;
    private int[] minTreehash;
    private byte[][][] nextAuthPaths;
    private GMSSLeaf[] nextNextLeaf;
    private GMSSRootCalc[] nextNextRoot;
    private byte[][] nextNextSeeds;
    private Vector[][] nextRetain;
    private byte[][] nextRoot;
    private GMSSRootSig[] nextRootSig;
    private Vector[] nextStack;
    private Treehash[][] nextTreehash;
    private int numLayer;
    private int[] numLeafs;
    private int[] otsIndex;
    private GMSSLeaf[] upperLeaf;
    private GMSSLeaf[] upperTreehashLeaf;
    private boolean used;

    public GMSSPrivateKeyParameters(byte[][] arg24, byte[][] arg25, byte[][][] arg26, byte[][][] arg27, Treehash[][] arg28, Treehash[][] arg29, Vector[] arg30, Vector[] arg31, Vector[][] arg32, Vector[][] arg33, byte[][] arg34, byte[][] arg35, GMSSParameters arg36, GMSSDigestProvider arg37) {
        this(null, arg24, arg25, arg26, arg27, null, arg28, arg29, arg30, arg31, arg32, arg33, null, null, null, null, arg34, null, arg35, null, arg36, arg37);
    }

    private GMSSPrivateKeyParameters(GMSSPrivateKeyParameters arg3) {
        super(true, arg3.getParameters());
        this.used = false;
        this.index = Arrays.clone(arg3.index);
        this.currentSeeds = Arrays.clone(arg3.currentSeeds);
        this.nextNextSeeds = Arrays.clone(arg3.nextNextSeeds);
        this.currentAuthPaths = Arrays.clone(arg3.currentAuthPaths);
        this.nextAuthPaths = Arrays.clone(arg3.nextAuthPaths);
        this.currentTreehash = arg3.currentTreehash;
        this.nextTreehash = arg3.nextTreehash;
        this.currentStack = arg3.currentStack;
        this.nextStack = arg3.nextStack;
        this.currentRetain = arg3.currentRetain;
        this.nextRetain = arg3.nextRetain;
        this.keep = Arrays.clone(arg3.keep);
        this.nextNextLeaf = arg3.nextNextLeaf;
        this.upperLeaf = arg3.upperLeaf;
        this.upperTreehashLeaf = arg3.upperTreehashLeaf;
        this.minTreehash = arg3.minTreehash;
        this.gmssPS = arg3.gmssPS;
        this.nextRoot = Arrays.clone(arg3.nextRoot);
        this.nextNextRoot = arg3.nextNextRoot;
        this.currentRootSig = arg3.currentRootSig;
        this.nextRootSig = arg3.nextRootSig;
        this.digestProvider = arg3.digestProvider;
        this.heightOfTrees = arg3.heightOfTrees;
        this.otsIndex = arg3.otsIndex;
        this.K = arg3.K;
        this.numLayer = arg3.numLayer;
        this.messDigestTrees = arg3.messDigestTrees;
        this.mdLength = arg3.mdLength;
        this.gmssRandom = arg3.gmssRandom;
        this.numLeafs = arg3.numLeafs;
    }

    public GMSSPrivateKeyParameters(int[] arg11, byte[][] arg12, byte[][] arg13, byte[][][] arg14, byte[][][] arg15, byte[][][] arg16, Treehash[][] arg17, Treehash[][] arg18, Vector[] arg19, Vector[] arg20, Vector[][] arg21, Vector[][] arg22, GMSSLeaf[] arg23, GMSSLeaf[] arg24, GMSSLeaf[] arg25, int[] arg26, byte[][] arg27, GMSSRootCalc[] arg28, byte[][] arg29, GMSSRootSig[] arg30, GMSSParameters arg31, GMSSDigestProvider arg32) {
        super(true, arg31);
        this.used = false;
        this.messDigestTrees = arg32.get();
        this.mdLength = this.messDigestTrees.getDigestSize();
        this.gmssPS = arg31;
        this.otsIndex = arg31.getWinternitzParameter();
        this.K = arg31.getK();
        this.heightOfTrees = arg31.getHeightOfTrees();
        this.numLayer = this.gmssPS.getNumOfLayers();
        if(arg11 == null) {
            this.index = new int[this.numLayer];
            int v1;
            for(v1 = 0; v1 < this.numLayer; ++v1) {
                this.index[v1] = 0;
            }
        }
        else {
            this.index = arg11;
        }

        this.currentSeeds = arg12;
        this.nextNextSeeds = arg13;
        this.currentAuthPaths = arg14;
        this.nextAuthPaths = arg15;
        if(arg16 == null) {
            this.keep = new byte[this.numLayer][][];
            int v2;
            for(v2 = 0; v2 < this.numLayer; ++v2) {
                this.keep[v2] = new byte[((int)Math.floor(((double)(this.heightOfTrees[v2] / 2))))][this.mdLength];
            }
        }
        else {
            this.keep = arg16;
        }

        if(arg19 == null) {
            this.currentStack = new Vector[this.numLayer];
            for(v1 = 0; v1 < this.numLayer; ++v1) {
                this.currentStack[v1] = new Vector();
            }
        }
        else {
            this.currentStack = arg19;
        }

        if(arg20 == null) {
            this.nextStack = new Vector[this.numLayer - 1];
            for(v1 = 0; v1 < this.numLayer - 1; ++v1) {
                this.nextStack[v1] = new Vector();
            }
        }
        else {
            this.nextStack = arg20;
        }

        this.currentTreehash = arg17;
        this.nextTreehash = arg18;
        this.currentRetain = arg21;
        this.nextRetain = arg22;
        this.nextRoot = arg27;
        this.digestProvider = arg32;
        if(arg28 == null) {
            this.nextNextRoot = new GMSSRootCalc[this.numLayer - 1];
            for(v1 = 0; v1 < this.numLayer - 1; ++v1) {
                this.nextNextRoot[v1] = new GMSSRootCalc(this.heightOfTrees[v1 + 1], this.K[v1 + 1], this.digestProvider);
            }
        }
        else {
            this.nextNextRoot = arg28;
        }

        this.currentRootSig = arg29;
        this.numLeafs = new int[this.numLayer];
        for(v1 = 0; v1 < this.numLayer; ++v1) {
            this.numLeafs[v1] = 1 << this.heightOfTrees[v1];
        }

        this.gmssRandom = new GMSSRandom(this.messDigestTrees);
        if(this.numLayer <= 1) {
            this.nextNextLeaf = new GMSSLeaf[0];
            goto label_180;
        label_160:
            while(v1 < this.numLayer - 2) {
                this.nextNextLeaf[v1] = new GMSSLeaf(arg32.get(), this.otsIndex[v1 + 1], this.numLeafs[v1 + 2], this.nextNextSeeds[v1]);
                ++v1;
            }
        }
        else if(arg23 == null) {
            this.nextNextLeaf = new GMSSLeaf[this.numLayer - 2];
            v1 = 0;
            goto label_160;
        }
        else {
            this.nextNextLeaf = arg23;
        }

    label_180:
        if(arg24 == null) {
            this.upperLeaf = new GMSSLeaf[this.numLayer - 1];
            for(v1 = 0; v1 < this.numLayer - 1; ++v1) {
                this.upperLeaf[v1] = new GMSSLeaf(arg32.get(), this.otsIndex[v1], this.numLeafs[v1 + 1], this.currentSeeds[v1]);
            }
        }
        else {
            this.upperLeaf = arg24;
        }

        if(arg25 == null) {
            this.upperTreehashLeaf = new GMSSLeaf[this.numLayer - 1];
            for(v1 = 0; v1 < this.numLayer - 1; ++v1) {
                this.upperTreehashLeaf[v1] = new GMSSLeaf(arg32.get(), this.otsIndex[v1], this.numLeafs[v1 + 1]);
            }
        }
        else {
            this.upperTreehashLeaf = arg25;
        }

        if(arg26 == null) {
            this.minTreehash = new int[this.numLayer - 1];
            for(v1 = 0; v1 < this.numLayer - 1; ++v1) {
                this.minTreehash[v1] = -1;
            }
        }
        else {
            this.minTreehash = arg26;
        }

        byte[] v2_1 = new byte[this.mdLength];
        new byte[this.mdLength];
        if(arg30 == null) {
            this.nextRootSig = new GMSSRootSig[this.numLayer - 1];
            for(v1 = 0; v1 < this.numLayer - 1; ++v1) {
                System.arraycopy(arg12[v1], 0, v2_1, 0, this.mdLength);
                this.gmssRandom.nextSeed(v2_1);
                byte[] v3 = this.gmssRandom.nextSeed(v2_1);
                this.nextRootSig[v1] = new GMSSRootSig(arg32.get(), this.otsIndex[v1], this.heightOfTrees[v1 + 1]);
                this.nextRootSig[v1].initSign(v3, arg27[v1]);
            }
        }
        else {
            this.nextRootSig = arg30;
        }
    }

    private void computeAuthPaths(int arg13) {
        int v3 = this.index[arg13];
        int v4 = this.heightOfTrees[arg13];
        int v5 = this.K[arg13];
        int v0;
        for(v0 = 0; v0 < v4 - v5; ++v0) {
            this.currentTreehash[arg13][v0].updateNextSeed(this.gmssRandom);
        }

        int v6 = this.heightOfPhi(v3);
        new byte[this.mdLength];
        byte[] v0_1 = this.gmssRandom.nextSeed(this.currentSeeds[arg13]);
        int v7 = v3 >>> v6 + 1 & 1;
        byte[] v8 = new byte[this.mdLength];
        if(v6 < v4 - 1 && v7 == 0) {
            System.arraycopy(this.currentAuthPaths[arg13][v6], 0, v8, 0, this.mdLength);
        }

        new byte[this.mdLength];
        if(v6 == 0) {
            if(arg13 == this.numLayer - 1) {
                v0_1 = new WinternitzOTSignature(v0_1, this.digestProvider.get(), this.otsIndex[arg13]).getPublicKey();
            }
            else {
                byte[] v3_1 = new byte[this.mdLength];
                System.arraycopy(this.currentSeeds[arg13], 0, v3_1, 0, this.mdLength);
                this.gmssRandom.nextSeed(v3_1);
                v0_1 = this.upperLeaf[arg13].getLeaf();
                this.upperLeaf[arg13].initLeafCalc(v3_1);
            }

            System.arraycopy(v0_1, 0, this.currentAuthPaths[arg13][0], 0, this.mdLength);
        }
        else {
            v0_1 = new byte[this.mdLength << 1];
            System.arraycopy(this.currentAuthPaths[arg13][v6 - 1], 0, v0_1, 0, this.mdLength);
            System.arraycopy(this.keep[arg13][((int)Math.floor(((double)((v6 - 1) / 2))))], 0, v0_1, this.mdLength, this.mdLength);
            this.messDigestTrees.update(v0_1, 0, v0_1.length);
            this.currentAuthPaths[arg13][v6] = new byte[this.messDigestTrees.getDigestSize()];
            this.messDigestTrees.doFinal(this.currentAuthPaths[arg13][v6], 0);
            for(v0 = 0; v0 < v6; ++v0) {
                if(v0 < v4 - v5) {
                    if(this.currentTreehash[arg13][v0].wasFinished()) {
                        System.arraycopy(this.currentTreehash[arg13][v0].getFirstNode(), 0, this.currentAuthPaths[arg13][v0], 0, this.mdLength);
                        this.currentTreehash[arg13][v0].destroy();
                    }
                    else {
                        System.err.println("Treehash (" + arg13 + "," + v0 + ") not finished when needed in AuthPathComputation");
                    }
                }

                if(v0 < v4 - 1 && v0 >= v4 - v5 && this.currentRetain[arg13][v0 - (v4 - v5)].size() > 0) {
                    System.arraycopy(this.currentRetain[arg13][v0 - (v4 - v5)].lastElement(), 0, this.currentAuthPaths[arg13][v0], 0, this.mdLength);
                    this.currentRetain[arg13][v0 - (v4 - v5)].removeElementAt(this.currentRetain[arg13][v0 - (v4 - v5)].size() - 1);
                }

                if(v0 < v4 - v5 && (1 << v0) * 3 + v3 < this.numLeafs[arg13]) {
                    this.currentTreehash[arg13][v0].initialize();
                }
            }
        }

        if(v6 < v4 - 1 && v7 == 0) {
            System.arraycopy(v8, 0, this.keep[arg13][((int)Math.floor(((double)(v6 / 2))))], 0, this.mdLength);
        }

        if(arg13 == this.numLayer - 1) {
            for(v0 = 1; true; ++v0) {
                if(v0 > (v4 - v5) / 2) {
                    return;
                }

                int v1 = this.getMinTreehashIndex(arg13);
                if(v1 >= 0) {
                    try {
                        byte[] v2 = new byte[this.mdLength];
                        System.arraycopy(this.currentTreehash[arg13][v1].getSeedActive(), 0, v2, 0, this.mdLength);
                        this.currentTreehash[arg13][v1].update(this.gmssRandom, new WinternitzOTSignature(this.gmssRandom.nextSeed(v2), this.digestProvider.get(), this.otsIndex[arg13]).getPublicKey());
                    }
                    catch(Exception v1_1) {
                        System.out.println(v1_1);
                    }
                }
            }
        }

        this.minTreehash[arg13] = this.getMinTreehashIndex(arg13);
    }

    public byte[][][] getCurrentAuthPaths() {
        return Arrays.clone(this.currentAuthPaths);
    }

    public byte[][] getCurrentSeeds() {
        return Arrays.clone(this.currentSeeds);
    }

    public int getIndex(int arg2) {
        return this.index[arg2];
    }

    public int[] getIndex() {
        return this.index;
    }

    private int getMinTreehashIndex(int arg6) {
        int v2 = -1;
        int v0 = 0;
        int v1 = v2;
        while(v0 < this.heightOfTrees[arg6] - this.K[arg6]) {
            if((this.currentTreehash[arg6][v0].wasInitialized()) && !this.currentTreehash[arg6][v0].wasFinished()) {
                if(v1 == v2) {
                    v1 = v0;
                }
                else if(this.currentTreehash[arg6][v0].getLowestNodeHeight() < this.currentTreehash[arg6][v1].getLowestNodeHeight()) {
                    v1 = v0;
                }
            }

            ++v0;
        }

        return v1;
    }

    public GMSSDigestProvider getName() {
        return this.digestProvider;
    }

    public int getNumLeafs(int arg2) {
        return this.numLeafs[arg2];
    }

    public byte[] getSubtreeRootSig(int arg2) {
        return this.currentRootSig[arg2];
    }

    private int heightOfPhi(int arg4) {
        int v0;
        if(arg4 == 0) {
            v0 = -1;
        }
        else {
            int v1 = 0;
            v0 = 1;
            while(arg4 % v0 == 0) {
                v0 *= 2;
                ++v1;
            }

            v0 = v1 - 1;
        }

        return v0;
    }

    public boolean isUsed() {
        return this.used;
    }

    public void markUsed() {
        this.used = true;
    }

    private void nextKey(int arg3) {
        if(arg3 == this.numLayer - 1) {
            ++this.index[arg3];
        }

        if(this.index[arg3] != this.numLeafs[arg3]) {
            this.updateKey(arg3);
        }
        else if(this.numLayer != 1) {
            this.nextTree(arg3);
            this.index[arg3] = 0;
        }
    }

    public GMSSPrivateKeyParameters nextKey() {
        GMSSPrivateKeyParameters v0 = new GMSSPrivateKeyParameters(this);
        v0.nextKey(this.gmssPS.getNumOfLayers() - 1);
        return v0;
    }

    private void nextTree(int arg7) {
        byte[] v0_1;
        if(arg7 > 0) {
            int v1 = arg7 - 1;
            ++this.index[v1];
            int v0 = arg7;
            v1 = 1;
            do {
                --v0;
                if(this.index[v0] < this.numLeafs[v0]) {
                    v1 = 0;
                }

                if(v1 == 0) {
                    break;
                }
            }
            while(v0 > 0);

            if(v1 != 0) {
                return;
            }

            this.gmssRandom.nextSeed(this.currentSeeds[arg7]);
            this.nextRootSig[arg7 - 1].updateSign();
            if(arg7 > 1) {
                this.nextNextLeaf[arg7 - 2] = this.nextNextLeaf[arg7 - 2].nextLeaf();
            }

            this.upperLeaf[arg7 - 1] = this.upperLeaf[arg7 - 1].nextLeaf();
            if(this.minTreehash[arg7 - 1] >= 0) {
                this.upperTreehashLeaf[arg7 - 1] = this.upperTreehashLeaf[arg7 - 1].nextLeaf();
                v0_1 = this.upperTreehashLeaf[arg7 - 1].getLeaf();
                try {
                    this.currentTreehash[arg7 - 1][this.minTreehash[arg7 - 1]].update(this.gmssRandom, v0_1);
                    this.currentTreehash[arg7 - 1][this.minTreehash[arg7 - 1]].wasFinished();
                }
                catch(Exception v0_2) {
                    System.out.println(v0_2);
                }
            }

            this.updateNextNextAuthRoot(arg7);
            this.currentRootSig[arg7 - 1] = this.nextRootSig[arg7 - 1].getSig();
            for(v0 = 0; v0 < this.heightOfTrees[arg7] - this.K[arg7]; ++v0) {
                this.currentTreehash[arg7][v0] = this.nextTreehash[arg7 - 1][v0];
                this.nextTreehash[arg7 - 1][v0] = this.nextNextRoot[arg7 - 1].getTreehash()[v0];
            }

            for(v0 = 0; v0 < this.heightOfTrees[arg7]; ++v0) {
                System.arraycopy(this.nextAuthPaths[arg7 - 1][v0], 0, this.currentAuthPaths[arg7][v0], 0, this.mdLength);
                System.arraycopy(this.nextNextRoot[arg7 - 1].getAuthPath()[v0], 0, this.nextAuthPaths[arg7 - 1][v0], 0, this.mdLength);
            }

            for(v0 = 0; v0 < this.K[arg7] - 1; ++v0) {
                this.currentRetain[arg7][v0] = this.nextRetain[arg7 - 1][v0];
                this.nextRetain[arg7 - 1][v0] = this.nextNextRoot[arg7 - 1].getRetain()[v0];
            }

            this.currentStack[arg7] = this.nextStack[arg7 - 1];
            this.nextStack[arg7 - 1] = this.nextNextRoot[arg7 - 1].getStack();
            this.nextRoot[arg7 - 1] = this.nextNextRoot[arg7 - 1].getRoot();
            new byte[this.mdLength];
            v0_1 = new byte[this.mdLength];
            System.arraycopy(this.currentSeeds[arg7 - 1], 0, v0_1, 0, this.mdLength);
            this.gmssRandom.nextSeed(v0_1);
            this.gmssRandom.nextSeed(v0_1);
            this.nextRootSig[arg7 - 1].initSign(this.gmssRandom.nextSeed(v0_1), this.nextRoot[arg7 - 1]);
            this.nextKey(arg7 - 1);
        }
    }

    private void updateKey(int arg10) {
        this.computeAuthPaths(arg10);
        if(arg10 > 0) {
            if(arg10 > 1) {
                this.nextNextLeaf[arg10 - 2] = this.nextNextLeaf[arg10 - 2].nextLeaf();
            }

            this.upperLeaf[arg10 - 1] = this.upperLeaf[arg10 - 1].nextLeaf();
            int v1 = ((int)Math.floor((((double)(this.getNumLeafs(arg10) * 2))) / (((double)(this.heightOfTrees[arg10 - 1] - this.K[arg10 - 1])))));
            if(this.index[arg10] % v1 == 1) {
                if(this.index[arg10] > 1 && this.minTreehash[arg10 - 1] >= 0) {
                    byte[] v0 = this.upperTreehashLeaf[arg10 - 1].getLeaf();
                    try {
                        this.currentTreehash[arg10 - 1][this.minTreehash[arg10 - 1]].update(this.gmssRandom, v0);
                        this.currentTreehash[arg10 - 1][this.minTreehash[arg10 - 1]].wasFinished();
                    }
                    catch(Exception v0_1) {
                        System.out.println(v0_1);
                    }
                }

                this.minTreehash[arg10 - 1] = this.getMinTreehashIndex(arg10 - 1);
                if(this.minTreehash[arg10 - 1] < 0) {
                    goto label_100;
                }

                this.upperTreehashLeaf[arg10 - 1] = new GMSSLeaf(this.digestProvider.get(), this.otsIndex[arg10 - 1], v1, this.currentTreehash[arg10 - 1][this.minTreehash[arg10 - 1]].getSeedActive());
                this.upperTreehashLeaf[arg10 - 1] = this.upperTreehashLeaf[arg10 - 1].nextLeaf();
                goto label_100;
            }

            if(this.minTreehash[arg10 - 1] >= 0) {
                this.upperTreehashLeaf[arg10 - 1] = this.upperTreehashLeaf[arg10 - 1].nextLeaf();
            }

        label_100:
            this.nextRootSig[arg10 - 1].updateSign();
            if(this.index[arg10] == 1) {
                this.nextNextRoot[arg10 - 1].initialize(new Vector());
            }

            this.updateNextNextAuthRoot(arg10);
        }
    }

    private void updateNextNextAuthRoot(int arg5) {
        new byte[this.mdLength];
        byte[] v0 = this.gmssRandom.nextSeed(this.nextNextSeeds[arg5 - 1]);
        if(arg5 == this.numLayer - 1) {
            this.nextNextRoot[arg5 - 1].update(this.nextNextSeeds[arg5 - 1], new WinternitzOTSignature(v0, this.digestProvider.get(), this.otsIndex[arg5]).getPublicKey());
        }
        else {
            this.nextNextRoot[arg5 - 1].update(this.nextNextSeeds[arg5 - 1], this.nextNextLeaf[arg5 - 1].getLeaf());
            this.nextNextLeaf[arg5 - 1].initLeafCalc(this.nextNextSeeds[arg5 - 1]);
        }
    }
}

