// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss;

import java.util.Enumeration;
import java.util.Vector;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Integers;
import org.bouncycastle.util.encoders.Hex;

public class GMSSRootCalc {
    private byte[][] AuthPath;
    private int K;
    private GMSSDigestProvider digestProvider;
    private int heightOfNextSeed;
    private Vector heightOfNodes;
    private int heightOfTree;
    private int[] index;
    private int indexForNextSeed;
    private boolean isFinished;
    private boolean isInitialized;
    private int mdLength;
    private Digest messDigestTree;
    private Vector[] retain;
    private byte[] root;
    private Vector tailStack;
    private Treehash[] treehash;

    public GMSSRootCalc(int arg4, int arg5, GMSSDigestProvider arg6) {
        super();
        this.heightOfTree = arg4;
        this.digestProvider = arg6;
        this.messDigestTree = arg6.get();
        this.mdLength = this.messDigestTree.getDigestSize();
        this.K = arg5;
        this.index = new int[arg4];
        this.AuthPath = new byte[arg4][this.mdLength];
        this.root = new byte[this.mdLength];
        this.retain = new Vector[this.K - 1];
        int v0;
        for(v0 = 0; v0 < arg5 - 1; ++v0) {
            this.retain[v0] = new Vector();
        }
    }

    public GMSSRootCalc(Digest arg6, byte[][] arg7, int[] arg8, Treehash[] arg9, Vector[] arg10) {
        int v1 = 0;
        super();
        this.messDigestTree = this.digestProvider.get();
        this.digestProvider = this.digestProvider;
        this.heightOfTree = arg8[0];
        this.mdLength = arg8[1];
        this.K = arg8[2];
        this.indexForNextSeed = arg8[3];
        this.heightOfNextSeed = arg8[4];
        this.isFinished = arg8[5] == 1 ? true : false;
        this.isInitialized = arg8[6] == 1 ? true : false;
        int v2 = arg8[7];
        this.index = new int[this.heightOfTree];
        int v0;
        for(v0 = 0; v0 < this.heightOfTree; ++v0) {
            this.index[v0] = arg8[v0 + 8];
        }

        this.heightOfNodes = new Vector();
        for(v0 = 0; v0 < v2; ++v0) {
            this.heightOfNodes.addElement(Integers.valueOf(arg8[this.heightOfTree + 8 + v0]));
        }

        this.root = arg7[0];
        this.AuthPath = new byte[this.heightOfTree][this.mdLength];
        for(v0 = 0; v0 < this.heightOfTree; ++v0) {
            this.AuthPath[v0] = arg7[v0 + 1];
        }

        this.tailStack = new Vector();
        while(v1 < v2) {
            this.tailStack.addElement(arg7[this.heightOfTree + 1 + v1]);
            ++v1;
        }

        this.treehash = GMSSUtils.clone(arg9);
        this.retain = GMSSUtils.clone(arg10);
    }

    public byte[][] getAuthPath() {
        return GMSSUtils.clone(this.AuthPath);
    }

    public Vector[] getRetain() {
        return GMSSUtils.clone(this.retain);
    }

    public byte[] getRoot() {
        return Arrays.clone(this.root);
    }

    public Vector getStack() {
        Vector v0 = new Vector();
        Enumeration v1 = this.tailStack.elements();
        while(v1.hasMoreElements()) {
            v0.addElement(v1.nextElement());
        }

        return v0;
    }

    public byte[][] getStatByte() {
        int v2 = this.tailStack == null ? 0 : this.tailStack.size();
        Object v0 = new byte[this.heightOfTree + 1 + v2][64];
        v0[0] = this.root;
        int v3;
        for(v3 = 0; v3 < this.heightOfTree; ++v3) {
            v0[v3 + 1] = this.AuthPath[v3];
        }

        for(v3 = 0; v3 < v2; ++v3) {
            v0[this.heightOfTree + 1 + v3] = this.tailStack.elementAt(v3);
        }

        return ((byte[][])v0);
    }

    public int[] getStatInt() {
        int v7 = 6;
        int v6 = 5;
        int v1 = this.tailStack == null ? 0 : this.tailStack.size();
        int[] v3 = new int[this.heightOfTree + 8 + v1];
        v3[0] = this.heightOfTree;
        v3[1] = this.mdLength;
        v3[2] = this.K;
        v3[3] = this.indexForNextSeed;
        v3[4] = this.heightOfNextSeed;
        v3[v6] = this.isFinished ? 1 : 0;
        v3[v7] = this.isInitialized ? 1 : 0;
        v3[7] = v1;
        int v2;
        for(v2 = 0; v2 < this.heightOfTree; ++v2) {
            v3[v2 + 8] = this.index[v2];
        }

        for(v2 = 0; v2 < v1; ++v2) {
            v3[this.heightOfTree + 8 + v2] = this.heightOfNodes.elementAt(v2).intValue();
        }

        return v3;
    }

    public Treehash[] getTreehash() {
        return GMSSUtils.clone(this.treehash);
    }

    public void initialize(Vector arg6) {
        this.treehash = new Treehash[this.heightOfTree - this.K];
        int v0;
        for(v0 = 0; v0 < this.heightOfTree - this.K; ++v0) {
            this.treehash[v0] = new Treehash(arg6, v0, this.digestProvider.get());
        }

        this.index = new int[this.heightOfTree];
        this.AuthPath = new byte[this.heightOfTree][this.mdLength];
        this.root = new byte[this.mdLength];
        this.tailStack = new Vector();
        this.heightOfNodes = new Vector();
        this.isInitialized = true;
        this.isFinished = false;
        for(v0 = 0; v0 < this.heightOfTree; ++v0) {
            this.index[v0] = -1;
        }

        this.retain = new Vector[this.K - 1];
        for(v0 = 0; v0 < this.K - 1; ++v0) {
            this.retain[v0] = new Vector();
        }

        this.indexForNextSeed = 3;
        this.heightOfNextSeed = 0;
    }

    public void initializeTreehashSeed(byte[] arg2, int arg3) {
        this.treehash[arg3].initializeSeed(arg2);
    }

    public String toString() {
        int v1 = 0;
        String v2 = "";
        int v0 = this.tailStack == null ? 0 : this.tailStack.size();
        String v3 = v2;
        int v2_1;
        for(v2_1 = 0; v2_1 < this.heightOfTree + 8 + v0; ++v2_1) {
            v3 = v3 + this.getStatInt()[v2_1] + " ";
        }

        while(v1 < this.heightOfTree + 1 + v0) {
            v3 = v3 + new String(Hex.encode(this.getStatByte()[v1])) + " ";
            ++v1;
        }

        return v3 + "  " + this.digestProvider.get().getDigestSize();
    }

    public void update(byte[] arg10) {
        int v7 = 3;
        if(this.isFinished) {
            System.out.print("Too much updates for Tree!!");
        }
        else if(!this.isInitialized) {
            System.err.println("GMSSRootCalc not initialized!");
        }
        else {
            ++this.index[0];
            if(this.index[0] == 1) {
                System.arraycopy(arg10, 0, this.AuthPath[0], 0, this.mdLength);
            }
            else if(this.index[0] == v7 && this.heightOfTree > this.K) {
                this.treehash[0].setFirstNode(arg10);
            }

            if((this.index[0] - 3) % 2 == 0 && this.index[0] >= v7 && this.heightOfTree == this.K) {
                this.retain[0].insertElementAt(arg10, 0);
            }

            if(this.index[0] == 0) {
                this.tailStack.addElement(arg10);
                this.heightOfNodes.addElement(Integers.valueOf(0));
                return;
            }

            byte[] v0 = new byte[this.mdLength];
            byte[] v4 = new byte[this.mdLength << 1];
            System.arraycopy(arg10, 0, v0, 0, this.mdLength);
            int v1 = 0;
            byte[] v3 = v0;
            while(this.tailStack.size() > 0) {
                if(v1 != this.heightOfNodes.lastElement().intValue()) {
                    break;
                }

                System.arraycopy(this.tailStack.lastElement(), 0, v4, 0, this.mdLength);
                this.tailStack.removeElementAt(this.tailStack.size() - 1);
                this.heightOfNodes.removeElementAt(this.heightOfNodes.size() - 1);
                System.arraycopy(v3, 0, v4, this.mdLength, this.mdLength);
                this.messDigestTree.update(v4, 0, v4.length);
                v3 = new byte[this.messDigestTree.getDigestSize()];
                this.messDigestTree.doFinal(v3, 0);
                int v0_1 = v1 + 1;
                if(v0_1 < this.heightOfTree) {
                    ++this.index[v0_1];
                    if(this.index[v0_1] == 1) {
                        System.arraycopy(v3, 0, this.AuthPath[v0_1], 0, this.mdLength);
                    }

                    if(v0_1 >= this.heightOfTree - this.K) {
                        if(v0_1 == 0) {
                            System.out.println("M\uFFFD\uFFFD\uFFFDP");
                        }

                        if((this.index[v0_1] - 3) % 2 != 0) {
                            goto label_160;
                        }

                        if(this.index[v0_1] < v7) {
                            goto label_160;
                        }

                        this.retain[v0_1 - (this.heightOfTree - this.K)].insertElementAt(v3, 0);
                        v1 = v0_1;
                        continue;
                    }

                    if(this.index[v0_1] != v7) {
                        goto label_160;
                    }

                    this.treehash[v0_1].setFirstNode(v3);
                    v1 = v0_1;
                    continue;
                }

            label_160:
                v1 = v0_1;
            }

            this.tailStack.addElement(v3);
            this.heightOfNodes.addElement(Integers.valueOf(v1));
            if(v1 != this.heightOfTree) {
                return;
            }

            this.isFinished = true;
            this.isInitialized = false;
            this.root = this.tailStack.lastElement();
        }
    }

    public void update(byte[] arg4, byte[] arg5) {
        if(this.heightOfNextSeed < this.heightOfTree - this.K && this.indexForNextSeed - 2 == this.index[0]) {
            this.initializeTreehashSeed(arg4, this.heightOfNextSeed);
            ++this.heightOfNextSeed;
            this.indexForNextSeed *= 2;
        }

        this.update(arg5);
    }

    public boolean wasFinished() {
        return this.isFinished;
    }

    public boolean wasInitialized() {
        return this.isInitialized;
    }
}

