// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss;

import org.bouncycastle.crypto.Digest;
import org.bouncycastle.pqc.crypto.gmss.util.GMSSRandom;
import org.bouncycastle.util.encoders.Hex;

public class GMSSRootSig {
    private long big8;
    private int checksum;
    private int counter;
    private GMSSRandom gmssRandom;
    private byte[] hash;
    private int height;
    private int ii;
    private int k;
    private int keysize;
    private int mdsize;
    private Digest messDigestOTS;
    private int messagesize;
    private byte[] privateKeyOTS;
    private int r;
    private byte[] seed;
    private byte[] sign;
    private int steps;
    private int test;
    private long test8;
    private int w;

    public GMSSRootSig(Digest arg5, int arg6, int arg7) {
        super();
        this.messDigestOTS = arg5;
        this.gmssRandom = new GMSSRandom(this.messDigestOTS);
        this.mdsize = this.messDigestOTS.getDigestSize();
        this.w = arg6;
        this.height = arg7;
        this.k = (1 << arg6) - 1;
        this.messagesize = ((int)Math.ceil((((double)(this.mdsize << 3))) / (((double)arg6))));
    }

    public GMSSRootSig(Digest arg10, byte[][] arg11, int[] arg12) {
        super();
        this.messDigestOTS = arg10;
        this.gmssRandom = new GMSSRandom(this.messDigestOTS);
        this.counter = arg12[0];
        this.test = arg12[1];
        this.ii = arg12[2];
        this.r = arg12[3];
        this.steps = arg12[4];
        this.keysize = arg12[5];
        this.height = arg12[6];
        this.w = arg12[7];
        this.checksum = arg12[8];
        this.mdsize = this.messDigestOTS.getDigestSize();
        this.k = (1 << this.w) - 1;
        this.messagesize = ((int)Math.ceil((((double)(this.mdsize << 3))) / (((double)this.w))));
        this.privateKeyOTS = arg11[0];
        this.seed = arg11[1];
        this.hash = arg11[2];
        this.sign = arg11[3];
        this.test8 = (((long)(arg11[4][0] & 255))) | (((long)(arg11[4][1] & 255))) << 8 | (((long)(arg11[4][2] & 255))) << 16 | (((long)(arg11[4][3] & 255))) << 24 | (((long)(arg11[4][4] & 255))) << 32 | (((long)(arg11[4][5] & 255))) << 40 | (((long)(arg11[4][6] & 255))) << 48 | (((long)(arg11[4][7] & 255))) << 56;
        this.big8 = (((long)(arg11[4][8] & 255))) | (((long)(arg11[4][9] & 255))) << 8 | (((long)(arg11[4][10] & 255))) << 16 | (((long)(arg11[4][11] & 255))) << 24 | (((long)(arg11[4][12] & 255))) << 32 | (((long)(arg11[4][13] & 255))) << 40 | (((long)(arg11[4][14] & 255))) << 48 | (((long)(arg11[4][15] & 255))) << 56;
    }

    public int getLog(int arg3) {
        int v1 = 1;
        int v0 = 2;
        while(v0 < arg3) {
            v0 <<= 1;
            ++v1;
        }

        return v1;
    }

    public byte[] getSig() {
        return this.sign;
    }

    public byte[][] getStatByte() {
        Object v0 = new byte[5][this.mdsize];
        v0[0] = this.privateKeyOTS;
        v0[1] = this.seed;
        v0[2] = this.hash;
        v0[3] = this.sign;
        v0[4] = this.getStatLong();
        return ((byte[][])v0);
    }

    public int[] getStatInt() {
        return new int[]{this.counter, this.test, this.ii, this.r, this.steps, this.keysize, this.height, this.w, this.checksum};
    }

    public byte[] getStatLong() {
        return new byte[]{((byte)(((int)(this.test8 & 255)))), ((byte)(((int)(this.test8 >> 8 & 255)))), ((byte)(((int)(this.test8 >> 16 & 255)))), ((byte)(((int)(this.test8 >> 24 & 255)))), ((byte)(((int)(this.test8 >> 32 & 255)))), ((byte)(((int)(this.test8 >> 40 & 255)))), ((byte)(((int)(this.test8 >> 48 & 255)))), ((byte)(((int)(this.test8 >> 56 & 255)))), ((byte)(((int)(this.big8 & 255)))), ((byte)(((int)(this.big8 >> 8 & 255)))), ((byte)(((int)(this.big8 >> 16 & 255)))), ((byte)(((int)(this.big8 >> 24 & 255)))), ((byte)(((int)(this.big8 >> 32 & 255)))), ((byte)(((int)(this.big8 >> 40 & 255)))), ((byte)(((int)(this.big8 >> 48 & 255)))), ((byte)(((int)(this.big8 >> 56 & 255))))};
    }

    public void initSign(byte[] arg17, byte[] arg18) {
        int v13;
        int v10;
        long v3_1;
        int v6;
        int v7;
        int v4;
        int v3;
        int v5;
        this.hash = new byte[this.mdsize];
        this.messDigestOTS.update(arg18, 0, arg18.length);
        this.hash = new byte[this.messDigestOTS.getDigestSize()];
        this.messDigestOTS.doFinal(this.hash, 0);
        byte[] v8 = new byte[this.mdsize];
        System.arraycopy(this.hash, 0, v8, 0, this.mdsize);
        int v2 = 0;
        int v9 = this.getLog((this.messagesize << this.w) + 1);
        if(8 % this.w == 0) {
            v5 = 8 / this.w;
            int v1;
            for(v1 = 0; v1 < this.mdsize; ++v1) {
                v3 = 0;
                while(v3 < v5) {
                    v4 = (v8[v1] & this.k) + v2;
                    v8[v1] = ((byte)(v8[v1] >>> this.w));
                    ++v3;
                    v2 = v4;
                }
            }

            this.checksum = (this.messagesize << this.w) - v2;
            v3 = this.checksum;
            for(v1 = 0; v1 < v9; v1 += this.w) {
                v2 += this.k & v3;
                v3 >>>= this.w;
            }
        }
        else if(this.w < 8) {
            v7 = this.mdsize / this.w;
            v6 = 0;
            v5 = 0;
            v2 = 0;
            while(v6 < v7) {
                v3_1 = 0;
                for(v1 = 0; v1 < this.w; ++v1) {
                    v3_1 ^= ((long)((v8[v2] & 255) << (v1 << 3)));
                    ++v2;
                }

                for(v1 = 0; v1 < 8; ++v1) {
                    v5 += ((int)((((long)this.k)) & v3_1));
                    v3_1 >>>= this.w;
                }

                ++v6;
            }

            v10 = this.mdsize % this.w;
            v1 = 0;
            v13 = v2;
            long v2_1 = 0;
            v4 = v13;
            while(v1 < v10) {
                long v6_1 = (((long)((v8[v4] & 255) << (v1 << 3)))) ^ v2_1;
                ++v1;
                ++v4;
                v2_1 = v6_1;
            }

            v6 = v10 << 3;
            v1 = 0;
            v3_1 = v2_1;
            for(v2 = v5; v1 < v6; v2 = v5) {
                v5 = (((int)((((long)this.k)) & v3_1))) + v2;
                v2_1 = v3_1 >>> this.w;
                v1 += this.w;
                v3_1 = v2_1;
            }

            this.checksum = (this.messagesize << this.w) - v2;
            v3 = this.checksum;
            for(v1 = 0; v1 < v9; v1 += this.w) {
                v2 += this.k & v3;
                v3 >>>= this.w;
            }
        }
        else if(this.w < 57) {
            v1 = 0;
            while(v1 <= (this.mdsize << 3) - this.w) {
                v3 = v1 >>> 3;
                v7 = v1 % 8;
                v1 += this.w;
                v10 = v1 + 7 >>> 3;
                long v5_1 = 0;
                v4 = 0;
                while(v3 < v10) {
                    v5_1 ^= ((long)((v8[v3] & 255) << (v4 << 3)));
                    ++v4;
                    ++v3;
                }

                v2 = ((int)((v5_1 >>> v7 & (((long)this.k))) + (((long)v2))));
            }

            v3 = v1 >>> 3;
            if(v3 < this.mdsize) {
                v6 = v1 % 8;
                long v4_1 = 0;
                v13 = v3;
                v3 = 0;
                for(v1 = v13; v1 < this.mdsize; ++v1) {
                    v4_1 ^= ((long)((v8[v1] & 255) << (v3 << 3)));
                    ++v3;
                }

                v2 = ((int)((((long)v2)) + (v4_1 >>> v6 & (((long)this.k)))));
            }

            this.checksum = (this.messagesize << this.w) - v2;
            v3 = this.checksum;
            for(v1 = 0; v1 < v9; v1 += this.w) {
                v2 += this.k & v3;
                v3 >>>= this.w;
            }
        }

        this.keysize = this.messagesize + (((int)Math.ceil((((double)v9)) / (((double)this.w)))));
        this.steps = ((int)Math.ceil((((double)(this.keysize + v2))) / (((double)(1 << this.height)))));
        this.sign = new byte[this.keysize * this.mdsize];
        this.counter = 0;
        this.test = 0;
        this.ii = 0;
        this.test8 = 0;
        this.r = 0;
        this.privateKeyOTS = new byte[this.mdsize];
        this.seed = new byte[this.mdsize];
        System.arraycopy(arg17, 0, this.seed, 0, this.mdsize);
    }

    private void oneStep() {
        int v5 = 8;
        long v8 = 0;
        if(v5 % this.w == 0) {
            if(this.test == 0) {
                this.privateKeyOTS = this.gmssRandom.nextSeed(this.seed);
                if(this.ii < this.mdsize) {
                    this.test = this.hash[this.ii] & this.k;
                    this.hash[this.ii] = ((byte)(this.hash[this.ii] >>> this.w));
                }
                else {
                    this.test = this.checksum & this.k;
                    this.checksum >>>= this.w;
                }
            }
            else if(this.test > 0) {
                this.messDigestOTS.update(this.privateKeyOTS, 0, this.privateKeyOTS.length);
                this.privateKeyOTS = new byte[this.messDigestOTS.getDigestSize()];
                this.messDigestOTS.doFinal(this.privateKeyOTS, 0);
                --this.test;
            }

            if(this.test != 0) {
                return;
            }

            System.arraycopy(this.privateKeyOTS, 0, this.sign, this.counter * this.mdsize, this.mdsize);
            ++this.counter;
            if(this.counter % (v5 / this.w) != 0) {
                return;
            }

            ++this.ii;
        }
        else {
            if(this.w < v5) {
                if(this.test == 0) {
                    if(this.counter % 8 == 0 && this.ii < this.mdsize) {
                        this.big8 = v8;
                        if(this.counter < this.mdsize / this.w << 3) {
                            int v0;
                            for(v0 = 0; v0 < this.w; ++v0) {
                                this.big8 ^= ((long)((this.hash[this.ii] & 255) << (v0 << 3)));
                                ++this.ii;
                            }
                        }
                        else {
                            for(v0 = 0; v0 < this.mdsize % this.w; ++v0) {
                                this.big8 ^= ((long)((this.hash[this.ii] & 255) << (v0 << 3)));
                                ++this.ii;
                            }
                        }
                    }

                    if(this.counter == this.messagesize) {
                        this.big8 = ((long)this.checksum);
                    }

                    this.test = ((int)(this.big8 & (((long)this.k))));
                    this.privateKeyOTS = this.gmssRandom.nextSeed(this.seed);
                }
                else {
                    if(this.test <= 0) {
                        goto label_149;
                    }

                    this.messDigestOTS.update(this.privateKeyOTS, 0, this.privateKeyOTS.length);
                    this.privateKeyOTS = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(this.privateKeyOTS, 0);
                    --this.test;
                }

            label_149:
                if(this.test != 0) {
                    return;
                }

                System.arraycopy(this.privateKeyOTS, 0, this.sign, this.counter * this.mdsize, this.mdsize);
                this.big8 >>>= this.w;
                ++this.counter;
                return;
            }

            if(this.w >= 57) {
                return;
            }

            if(this.test8 == v8) {
                this.big8 = v8;
                this.ii = 0;
                int v3 = this.r % 8;
                int v2 = this.r >>> 3;
                if(v2 < this.mdsize) {
                    if(this.r <= (this.mdsize << 3) - this.w) {
                        this.r += this.w;
                        v0 = this.r + 7 >>> 3;
                    }
                    else {
                        v0 = this.mdsize;
                        this.r += this.w;
                    }

                    while(v2 < v0) {
                        this.big8 ^= ((long)((this.hash[v2] & 255) << (this.ii << 3)));
                        ++this.ii;
                        ++v2;
                    }

                    this.big8 >>>= v3;
                    this.test8 = this.big8 & (((long)this.k));
                }
                else {
                    this.test8 = ((long)(this.checksum & this.k));
                    this.checksum >>>= this.w;
                }

                this.privateKeyOTS = this.gmssRandom.nextSeed(this.seed);
            }
            else {
                if(this.test8 <= v8) {
                    goto label_244;
                }

                this.messDigestOTS.update(this.privateKeyOTS, 0, this.privateKeyOTS.length);
                this.privateKeyOTS = new byte[this.messDigestOTS.getDigestSize()];
                this.messDigestOTS.doFinal(this.privateKeyOTS, 0);
                --this.test8;
            }

        label_244:
            if(this.test8 != v8) {
                return;
            }

            System.arraycopy(this.privateKeyOTS, 0, this.sign, this.counter * this.mdsize, this.mdsize);
            ++this.counter;
        }
    }

    public String toString() {
        int v7 = 9;
        int v6 = 5;
        String v2 = "" + this.big8 + "  ";
        new int[v7];
        int[] v4 = this.getStatInt();
        new byte[v6][this.mdsize];
        byte[][] v5 = this.getStatByte();
        String v0 = v2;
        int v2_1 = 0;
        while(v2_1 < v7) {
            String v3 = v0 + v4[v2_1] + " ";
            ++v2_1;
            v0 = v3;
        }

        String v1 = v0;
        int v0_1;
        for(v0_1 = 0; v0_1 < v6; ++v0_1) {
            v1 = v1 + new String(Hex.encode(v5[v0_1])) + " ";
        }

        return v1;
    }

    public boolean updateSign() {
        boolean v1 = false;
        int v0;
        for(v0 = 0; v0 < this.steps; ++v0) {
            if(this.counter < this.keysize) {
                this.oneStep();
            }

            if(this.counter == this.keysize) {
                return true;
            }
        }

        return v1;
    }
}

