// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss;

import java.util.Vector;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.pqc.crypto.gmss.util.GMSSRandom;
import org.bouncycastle.util.Integers;
import org.bouncycastle.util.encoders.Hex;

public class Treehash {
    private byte[] firstNode;
    private int firstNodeHeight;
    private Vector heightOfNodes;
    private boolean isFinished;
    private boolean isInitialized;
    private int maxHeight;
    private Digest messDigestTree;
    private byte[] seedActive;
    private boolean seedInitialized;
    private byte[] seedNext;
    private int tailLength;
    private Vector tailStack;

    public Treehash(Vector arg3, int arg4, Digest arg5) {
        super();
        this.tailStack = arg3;
        this.maxHeight = arg4;
        this.firstNode = null;
        this.isInitialized = false;
        this.isFinished = false;
        this.seedInitialized = false;
        this.messDigestTree = arg5;
        this.seedNext = new byte[this.messDigestTree.getDigestSize()];
        this.seedActive = new byte[this.messDigestTree.getDigestSize()];
    }

    public Treehash(Digest arg7, byte[][] arg8, int[] arg9) {
        int v5 = 2;
        int v1 = 0;
        super();
        this.messDigestTree = arg7;
        this.maxHeight = arg9[0];
        this.tailLength = arg9[1];
        this.firstNodeHeight = arg9[v5];
        this.isFinished = arg9[3] == 1 ? true : false;
        this.isInitialized = arg9[4] == 1 ? true : false;
        this.seedInitialized = arg9[5] == 1 ? true : false;
        this.heightOfNodes = new Vector();
        int v0;
        for(v0 = 0; v0 < this.tailLength; ++v0) {
            this.heightOfNodes.addElement(Integers.valueOf(arg9[v0 + 6]));
        }

        this.firstNode = arg8[0];
        this.seedActive = arg8[1];
        this.seedNext = arg8[v5];
        this.tailStack = new Vector();
        while(v1 < this.tailLength) {
            this.tailStack.addElement(arg8[v1 + 3]);
            ++v1;
        }
    }

    public void destroy() {
        this.isInitialized = false;
        this.isFinished = false;
        this.firstNode = null;
        this.tailLength = 0;
        this.firstNodeHeight = -1;
    }

    public byte[] getFirstNode() {
        return this.firstNode;
    }

    public int getFirstNodeHeight() {
        int v0 = this.firstNode == null ? this.maxHeight : this.firstNodeHeight;
        return v0;
    }

    public int getLowestNodeHeight() {
        int v0;
        if(this.firstNode == null) {
            v0 = this.maxHeight;
        }
        else if(this.tailLength == 0) {
            v0 = this.firstNodeHeight;
        }
        else {
            v0 = Math.min(this.firstNodeHeight, this.heightOfNodes.lastElement().intValue());
        }

        return v0;
    }

    public byte[] getSeedActive() {
        return this.seedActive;
    }

    public byte[][] getStatByte() {
        Object v0 = new byte[this.tailLength + 3][this.messDigestTree.getDigestSize()];
        v0[0] = this.firstNode;
        v0[1] = this.seedActive;
        v0[2] = this.seedNext;
        int v2;
        for(v2 = 0; v2 < this.tailLength; ++v2) {
            v0[v2 + 3] = this.tailStack.elementAt(v2);
        }

        return ((byte[][])v0);
    }

    public int[] getStatInt() {
        int v7 = 5;
        int v6 = 4;
        int v5 = 3;
        int[] v2 = new int[this.tailLength + 6];
        v2[0] = this.maxHeight;
        v2[1] = this.tailLength;
        v2[2] = this.firstNodeHeight;
        v2[v5] = this.isFinished ? 1 : 0;
        v2[v6] = this.isInitialized ? 1 : 0;
        v2[v7] = this.seedInitialized ? 1 : 0;
        int v1;
        for(v1 = 0; v1 < this.tailLength; ++v1) {
            v2[v1 + 6] = this.heightOfNodes.elementAt(v1).intValue();
        }

        return v2;
    }

    public Vector getTailStack() {
        return this.tailStack;
    }

    public void initialize() {
        if(!this.seedInitialized) {
            System.err.println("Seed " + this.maxHeight + " not initialized");
        }
        else {
            this.heightOfNodes = new Vector();
            this.tailLength = 0;
            this.firstNode = null;
            this.firstNodeHeight = -1;
            this.isInitialized = true;
            System.arraycopy(this.seedNext, 0, this.seedActive, 0, this.messDigestTree.getDigestSize());
        }
    }

    public void initializeSeed(byte[] arg4) {
        System.arraycopy(arg4, 0, this.seedNext, 0, this.messDigestTree.getDigestSize());
        this.seedInitialized = true;
    }

    public void setFirstNode(byte[] arg2) {
        if(!this.isInitialized) {
            this.initialize();
        }

        this.firstNode = arg2;
        this.firstNodeHeight = this.maxHeight;
        this.isFinished = true;
    }

    public String toString() {
        int v1 = 0;
        String v2 = "Treehash    : ";
        int v0;
        for(v0 = 0; v0 < this.tailLength + 6; ++v0) {
            v2 = v2 + this.getStatInt()[v0] + " ";
        }

        while(v1 < this.tailLength + 3) {
            v2 = this.getStatByte()[v1] != null ? v2 + new String(Hex.encode(this.getStatByte()[v1])) + " " : v2 + "null ";
            ++v1;
        }

        return v2 + "  " + this.messDigestTree.getDigestSize();
    }

    public void update(GMSSRandom arg6, byte[] arg7) {
        byte[] v0;
        if(this.isFinished) {
            System.err.println("No more update possible for treehash instance!");
        }
        else if(!this.isInitialized) {
            System.err.println("Treehash instance not initialized before update");
        }
        else {
            new byte[this.messDigestTree.getDigestSize()];
            arg6.nextSeed(this.seedActive);
            if(this.firstNode == null) {
                this.firstNode = arg7;
                this.firstNodeHeight = 0;
            }
            else {
                int v1;
                for(v1 = 0; this.tailLength > 0; ++v1) {
                    if(v1 != this.heightOfNodes.lastElement().intValue()) {
                        break;
                    }

                    v0 = new byte[this.messDigestTree.getDigestSize() << 1];
                    System.arraycopy(this.tailStack.lastElement(), 0, v0, 0, this.messDigestTree.getDigestSize());
                    this.tailStack.removeElementAt(this.tailStack.size() - 1);
                    this.heightOfNodes.removeElementAt(this.heightOfNodes.size() - 1);
                    System.arraycopy(arg7, 0, v0, this.messDigestTree.getDigestSize(), this.messDigestTree.getDigestSize());
                    this.messDigestTree.update(v0, 0, v0.length);
                    arg7 = new byte[this.messDigestTree.getDigestSize()];
                    this.messDigestTree.doFinal(arg7, 0);
                    --this.tailLength;
                }

                this.tailStack.addElement(arg7);
                this.heightOfNodes.addElement(Integers.valueOf(v1));
                ++this.tailLength;
                if(this.heightOfNodes.lastElement().intValue() != this.firstNodeHeight) {
                    goto label_22;
                }

                v0 = new byte[this.messDigestTree.getDigestSize() << 1];
                System.arraycopy(this.firstNode, 0, v0, 0, this.messDigestTree.getDigestSize());
                System.arraycopy(this.tailStack.lastElement(), 0, v0, this.messDigestTree.getDigestSize(), this.messDigestTree.getDigestSize());
                this.tailStack.removeElementAt(this.tailStack.size() - 1);
                this.heightOfNodes.removeElementAt(this.heightOfNodes.size() - 1);
                this.messDigestTree.update(v0, 0, v0.length);
                this.firstNode = new byte[this.messDigestTree.getDigestSize()];
                this.messDigestTree.doFinal(this.firstNode, 0);
                ++this.firstNodeHeight;
                this.tailLength = 0;
            }

        label_22:
            if(this.firstNodeHeight != this.maxHeight) {
                return;
            }

            this.isFinished = true;
        }
    }

    public void updateNextSeed(GMSSRandom arg2) {
        arg2.nextSeed(this.seedNext);
    }

    public boolean wasFinished() {
        return this.isFinished;
    }

    public boolean wasInitialized() {
        return this.isInitialized;
    }
}

