// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.gmss.util;

import org.bouncycastle.crypto.Digest;

public class WinternitzOTSignature {
    private int checksumsize;
    private GMSSRandom gmssRandom;
    private int keysize;
    private int mdsize;
    private Digest messDigestOTS;
    private int messagesize;
    private byte[][] privateKeyOTS;
    private int w;

    public WinternitzOTSignature(byte[] arg7, Digest arg8, int arg9) {
        super();
        this.w = arg9;
        this.messDigestOTS = arg8;
        this.gmssRandom = new GMSSRandom(this.messDigestOTS);
        this.mdsize = this.messDigestOTS.getDigestSize();
        this.messagesize = ((int)Math.ceil((((double)(this.mdsize << 3))) / (((double)arg9))));
        this.checksumsize = this.getLog((this.messagesize << arg9) + 1);
        this.keysize = this.messagesize + (((int)Math.ceil((((double)this.checksumsize)) / (((double)arg9)))));
        this.privateKeyOTS = new byte[this.keysize][this.mdsize];
        byte[] v2 = new byte[this.mdsize];
        System.arraycopy(arg7, 0, v2, 0, v2.length);
        int v0;
        for(v0 = 0; v0 < this.keysize; ++v0) {
            this.privateKeyOTS[v0] = this.gmssRandom.nextSeed(v2);
        }
    }

    public int getLog(int arg3) {
        int v1 = 1;
        int v0 = 2;
        while(v0 < arg3) {
            v0 <<= 1;
            ++v1;
        }

        return v1;
    }

    public byte[][] getPrivateKey() {
        return this.privateKeyOTS;
    }

    public byte[] getPublicKey() {
        byte[] v4 = new byte[this.keysize * this.mdsize];
        new byte[this.mdsize];
        int v5 = 1 << this.w;
        int v0;
        for(v0 = 0; v0 < this.keysize; ++v0) {
            this.messDigestOTS.update(this.privateKeyOTS[v0], 0, this.privateKeyOTS[v0].length);
            byte[] v3 = new byte[this.messDigestOTS.getDigestSize()];
            this.messDigestOTS.doFinal(v3, 0);
            int v2;
            for(v2 = 2; v2 < v5; ++v2) {
                this.messDigestOTS.update(v3, 0, v3.length);
                v3 = new byte[this.messDigestOTS.getDigestSize()];
                this.messDigestOTS.doFinal(v3, 0);
            }

            System.arraycopy(v3, 0, v4, this.mdsize * v0, this.mdsize);
        }

        this.messDigestOTS.update(v4, 0, v4.length);
        byte[] v0_1 = new byte[this.messDigestOTS.getDigestSize()];
        this.messDigestOTS.doFinal(v0_1, 0);
        return v0_1;
    }

    public byte[] getSignature(byte[] arg25) {
        byte[] v4_1;
        long v8_2;
        byte[] v21;
        long v6_1;
        int v5_1;
        byte[] v8_1;
        int v16;
        int v15;
        int v10;
        int v8;
        int v9;
        byte[] v5;
        int v12;
        int v11;
        byte[] v13 = new byte[this.keysize * this.mdsize];
        new byte[this.mdsize];
        int v7 = 0;
        int v6 = 0;
        this.messDigestOTS.update(arg25, 0, arg25.length);
        byte[] v14 = new byte[this.messDigestOTS.getDigestSize()];
        this.messDigestOTS.doFinal(v14, 0);
        if(8 % this.w == 0) {
            v11 = 8 / this.w;
            v12 = (1 << this.w) - 1;
            v5 = new byte[this.mdsize];
            int v4;
            for(v4 = 0; v4 < v14.length; ++v4) {
                v9 = 0;
                while(v9 < v11) {
                    v8 = v14[v4] & v12;
                    v10 = v6 + v8;
                    System.arraycopy(this.privateKeyOTS[v7], 0, v5, 0, this.mdsize);
                    for(v6 = v8; v6 > 0; --v6) {
                        this.messDigestOTS.update(v5, 0, v5.length);
                        v5 = new byte[this.messDigestOTS.getDigestSize()];
                        this.messDigestOTS.doFinal(v5, 0);
                    }

                    System.arraycopy(v5, 0, v13, this.mdsize * v7, this.mdsize);
                    v14[v4] = ((byte)(v14[v4] >>> this.w));
                    ++v7;
                    ++v9;
                    v6 = v10;
                }
            }

            v6 = (this.messagesize << this.w) - v6;
            for(v4 = 0; v4 < this.checksumsize; v4 += this.w) {
                v8 = v6 & v12;
                System.arraycopy(this.privateKeyOTS[v7], 0, v5, 0, this.mdsize);
                while(v8 > 0) {
                    this.messDigestOTS.update(v5, 0, v5.length);
                    v5 = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(v5, 0);
                    --v8;
                }

                System.arraycopy(v5, 0, v13, this.mdsize * v7, this.mdsize);
                v6 >>>= this.w;
                ++v7;
            }
        }
        else if(this.w < 8) {
            v15 = this.mdsize / this.w;
            v16 = (1 << this.w) - 1;
            v8_1 = new byte[this.mdsize];
            v5_1 = 0;
            v12 = 0;
            v9 = 0;
            for(v10 = 0; v12 < v15; v10 = v11) {
                v6_1 = 0;
                for(v4 = 0; v4 < this.w; ++v4) {
                    v6_1 ^= ((long)((v14[v5_1] & 255) << (v4 << 3)));
                    ++v5_1;
                }

                v11 = v10;
                v10 = v9;
                v21 = v8_1;
                v8_2 = v6_1;
                v7 = 0;
                v4_1 = v21;
                while(v7 < 8) {
                    v6 = ((int)((((long)v16)) & v8_2));
                    v10 += v6;
                    System.arraycopy(this.privateKeyOTS[v11], 0, v4_1, 0, this.mdsize);
                    while(v6 > 0) {
                        this.messDigestOTS.update(v4_1, 0, v4_1.length);
                        v4_1 = new byte[this.messDigestOTS.getDigestSize()];
                        this.messDigestOTS.doFinal(v4_1, 0);
                        --v6;
                    }

                    System.arraycopy(v4_1, 0, v13, this.mdsize * v11, this.mdsize);
                    v8_2 >>>= this.w;
                    ++v11;
                    ++v7;
                }

                ++v12;
                v8_1 = v4_1;
                v9 = v10;
            }

            v15 = this.mdsize % this.w;
            v4 = 0;
            int v21_1 = v5_1;
            long v5_2 = 0;
            v7 = v21_1;
            while(v4 < v15) {
                long v11_1 = (((long)((v14[v7] & 255) << (v4 << 3)))) ^ v5_2;
                ++v4;
                ++v7;
                v5_2 = v11_1;
            }

            v11 = v15 << 3;
            v7 = v10;
            v10 = v9;
            v21 = v8_1;
            v8_2 = v5_2;
            v5 = v21;
            for(v6 = 0; v6 < v11; v6 = this.w + v6) {
                v4 = ((int)((((long)v16)) & v8_2));
                v10 += v4;
                System.arraycopy(this.privateKeyOTS[v7], 0, v5, 0, this.mdsize);
                while(v4 > 0) {
                    this.messDigestOTS.update(v5, 0, v5.length);
                    v5 = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(v5, 0);
                    --v4;
                }

                System.arraycopy(v5, 0, v13, this.mdsize * v7, this.mdsize);
                v8_2 >>>= this.w;
                ++v7;
            }

            v6 = (this.messagesize << this.w) - v10;
            for(v4 = 0; v4 < this.checksumsize; v4 += this.w) {
                v8 = v6 & v16;
                System.arraycopy(this.privateKeyOTS[v7], 0, v5, 0, this.mdsize);
                while(v8 > 0) {
                    this.messDigestOTS.update(v5, 0, v5.length);
                    v5 = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(v5, 0);
                    --v8;
                }

                System.arraycopy(v5, 0, v13, this.mdsize * v7, this.mdsize);
                v6 >>>= this.w;
                ++v7;
            }
        }
        else if(this.w < 57) {
            v12 = (this.mdsize << 3) - this.w;
            v15 = (1 << this.w) - 1;
            v8_1 = new byte[this.mdsize];
            v5_1 = 0;
            v9 = 0;
            v10 = 0;
            while(v5_1 <= v12) {
                v4 = v5_1 >>> 3;
                v16 = v5_1 % 8;
                v11 = v5_1 + this.w;
                int v17 = v11 + 7 >>> 3;
                v6_1 = 0;
                v5_1 = 0;
                while(v4 < v17) {
                    v6_1 ^= ((long)((v14[v4] & 255) << (v5_1 << 3)));
                    ++v5_1;
                    ++v4;
                }

                long v4_2 = v6_1 >>> v16 & (((long)v15));
                v9 = ((int)((((long)v9)) + v4_2));
                System.arraycopy(this.privateKeyOTS[v10], 0, v8_1, 0, this.mdsize);
                while(v4_2 > 0) {
                    this.messDigestOTS.update(v8_1, 0, v8_1.length);
                    v8_1 = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(v8_1, 0);
                    --v4_2;
                }

                System.arraycopy(v8_1, 0, v13, this.mdsize * v10, this.mdsize);
                ++v10;
                v5_1 = v11;
            }

            v4 = v5_1 >>> 3;
            if(v4 < this.mdsize) {
                v11 = v5_1 % 8;
                v6_1 = 0;
                v5_1 = 0;
                while(v4 < this.mdsize) {
                    v6_1 ^= ((long)((v14[v4] & 255) << (v5_1 << 3)));
                    ++v5_1;
                    ++v4;
                }

                v6_1 = (((long)v15)) & v6_1 >>> v11;
                v5_1 = ((int)((((long)v9)) + v6_1));
                System.arraycopy(this.privateKeyOTS[v10], 0, v8_1, 0, this.mdsize);
                v4_1 = v8_1;
                while(v6_1 > 0) {
                    this.messDigestOTS.update(v4_1, 0, v4_1.length);
                    v4_1 = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(v4_1, 0);
                    --v6_1;
                }

                System.arraycopy(v4_1, 0, v13, this.mdsize * v10, this.mdsize);
                v6 = v10 + 1;
            }
            else {
                v4_1 = v8_1;
                v5_1 = v9;
                v6 = v10;
            }

            v7 = (this.messagesize << this.w) - v5_1;
            v5 = v4_1;
            v4 = 0;
            int v22 = v7;
            v7 = v6;
            v6 = v22;
            while(v4 < this.checksumsize) {
                v8_2 = ((long)(v6 & v15));
                System.arraycopy(this.privateKeyOTS[v7], 0, v5, 0, this.mdsize);
                while(v8_2 > 0) {
                    this.messDigestOTS.update(v5, 0, v5.length);
                    v5 = new byte[this.messDigestOTS.getDigestSize()];
                    this.messDigestOTS.doFinal(v5, 0);
                    --v8_2;
                }

                System.arraycopy(v5, 0, v13, this.mdsize * v7, this.mdsize);
                v6 >>>= this.w;
                ++v7;
                v4 += this.w;
            }
        }

        return v13;
    }
}

