// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import java.math.BigInteger;
import org.bouncycastle.pqc.math.linearalgebra.BigIntUtils;
import org.bouncycastle.pqc.math.linearalgebra.GF2Vector;
import org.bouncycastle.pqc.math.linearalgebra.IntegerFunctions;

final class Conversions {
    private static final BigInteger ONE;
    private static final BigInteger ZERO;

    static {
        Conversions.ZERO = BigInteger.valueOf(0);
        Conversions.ONE = BigInteger.valueOf(1);
    }

    private Conversions() {
        super();
    }

    public static byte[] decode(int arg9, int arg10, GF2Vector arg11) {
        if(arg11.getLength() == arg9 && arg11.getHammingWeight() == arg10) {
            int[] v5 = arg11.getVecArray();
            BigInteger v2 = IntegerFunctions.binomial(arg9, arg10);
            BigInteger v1 = Conversions.ZERO;
            int v3 = 0;
            int v4 = arg9;
            int v0 = arg10;
            while(v3 < arg9) {
                v2 = v2.multiply(BigInteger.valueOf(((long)(v4 - v0)))).divide(BigInteger.valueOf(((long)v4)));
                --v4;
                if((v5[v3 >> 5] & 1 << (v3 & 31)) != 0) {
                    v1 = v1.add(v2);
                    --v0;
                    v2 = v4 == v0 ? Conversions.ONE : v2.multiply(BigInteger.valueOf(((long)(v0 + 1)))).divide(BigInteger.valueOf(((long)(v4 - v0))));
                }

                ++v3;
            }

            return BigIntUtils.toMinimalByteArray(v1);
        }

        throw new IllegalArgumentException("vector has wrong length or hamming weight");
    }

    public static GF2Vector encode(int arg8, int arg9, byte[] arg10) {
        if(arg8 < arg9) {
            throw new IllegalArgumentException("n < t");
        }

        BigInteger v2 = IntegerFunctions.binomial(arg8, arg9);
        BigInteger v1 = new BigInteger(1, arg10);
        if(v1.compareTo(v2) >= 0) {
            throw new IllegalArgumentException("Encoded number too large.");
        }

        GF2Vector v5 = new GF2Vector(arg8);
        int v3 = 0;
        int v4 = arg8;
        int v0 = arg9;
        while(v3 < arg8) {
            v2 = v2.multiply(BigInteger.valueOf(((long)(v4 - v0)))).divide(BigInteger.valueOf(((long)v4)));
            --v4;
            if(v2.compareTo(v1) <= 0) {
                v5.setBit(v3);
                v1 = v1.subtract(v2);
                --v0;
                v2 = v4 == v0 ? Conversions.ONE : v2.multiply(BigInteger.valueOf(((long)(v0 + 1)))).divide(BigInteger.valueOf(((long)(v4 - v0))));
            }

            ++v3;
        }

        return v5;
    }

    public static byte[] signConversion(int arg12, int arg13, byte[] arg14) {
        int v7;
        int v6;
        int v0 = 8;
        if(arg12 < arg13) {
            throw new IllegalArgumentException("n < t");
        }

        BigInteger v3 = IntegerFunctions.binomial(arg12, arg13);
        int v1 = v3.bitLength() - 1;
        int v2 = v1 >> 3;
        v1 &= 7;
        if(v1 == 0) {
            v6 = v0;
            v7 = v2 - 1;
        }
        else {
            v6 = v1;
            v7 = v2;
        }

        v2 = arg12 >> 3;
        v1 = arg12 & 7;
        if(v1 == 0) {
            v1 = v2 - 1;
        }
        else {
            v0 = v1;
            v1 = v2;
        }

        byte[] v8 = new byte[v1 + 1];
        if(arg14.length < v8.length) {
            System.arraycopy(arg14, 0, v8, 0, arg14.length);
            for(v0 = arg14.length; v0 < v8.length; ++v0) {
                v8[v0] = 0;
            }
        }
        else {
            System.arraycopy(arg14, 0, v8, 0, v1);
            v8[v1] = ((byte)((1 << v0) - 1 & arg14[v1]));
        }

        BigInteger v1_1 = Conversions.ZERO;
        v0 = arg13;
        int v5 = arg12;
        BigInteger v2_1 = v3;
        int v3_1;
        for(v3_1 = 0; v3_1 < arg12; ++v3_1) {
            v2_1 = v2_1.multiply(new BigInteger(Integer.toString(v5 - v0))).divide(new BigInteger(Integer.toString(v5)));
            --v5;
            if((((byte)(v8[v3_1 >>> 3] & 1 << (v3_1 & 7)))) != 0) {
                v1_1 = v1_1.add(v2_1);
                --v0;
                v2_1 = v5 == v0 ? Conversions.ONE : v2_1.multiply(new BigInteger(Integer.toString(v0 + 1))).divide(new BigInteger(Integer.toString(v5 - v0)));
            }
        }

        byte[] v2_2 = new byte[v7 + 1];
        byte[] v0_1 = v1_1.toByteArray();
        if(v0_1.length < v2_2.length) {
            System.arraycopy(v0_1, 0, v2_2, 0, v0_1.length);
            v0 = v0_1.length;
            goto label_90;
        }
        else {
            System.arraycopy(v0_1, 0, v2_2, 0, v7);
            v2_2[v7] = ((byte)(v0_1[v7] & (1 << v6) - 1));
            return v2_2;
        label_90:
            while(v0 < v2_2.length) {
                v2_2[v0] = 0;
                ++v0;
            }
        }

        return v2_2;
    }
}

