// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.GoppaCode;
import org.bouncycastle.pqc.math.linearalgebra.GoppaCode$MaMaPe;
import org.bouncycastle.pqc.math.linearalgebra.Matrix;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialRingGF2m;

public class McElieceCCA2KeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    public static final String OID = "1.3.6.1.4.1.8301.3.1.3.4.2";
    private int fieldPoly;
    private boolean initialized;
    private int m;
    private McElieceCCA2KeyGenerationParameters mcElieceCCA2Params;
    private int n;
    private SecureRandom random;
    private int t;

    public McElieceCCA2KeyPairGenerator() {
        super();
        this.initialized = false;
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        if(!this.initialized) {
            this.initializeDefault();
        }

        GF2mField v11 = new GF2mField(this.m, this.fieldPoly);
        PolynomialGF2mSmallM v6 = new PolynomialGF2mSmallM(v11, this.t, 'I', this.random);
        PolynomialGF2mSmallM[] v9 = new PolynomialRingGF2m(v11, v6).getSquareRootMatrix();
        GF2Matrix v8 = GoppaCode.createCanonicalCheckMatrix(v11, v6);
        GoppaCode$MaMaPe v0 = GoppaCode.computeSystematicForm(v8, this.random);
        GF2Matrix v1 = v0.getSecondMatrix();
        Permutation v7 = v0.getPermutation();
        Matrix v4 = v1.computeTranspose();
        return new AsymmetricCipherKeyPair(new McElieceCCA2PublicKeyParameters("1.3.6.1.4.1.8301.3.1.3.4.2", this.n, this.t, ((GF2Matrix)v4), this.mcElieceCCA2Params.getParameters()), new McElieceCCA2PrivateKeyParameters("1.3.6.1.4.1.8301.3.1.3.4.2", this.n, ((GF2Matrix)v4).getNumRows(), v11, v6, v7, v8, v9, this.mcElieceCCA2Params.getParameters()));
    }

    public void init(KeyGenerationParameters arg2) {
        this.mcElieceCCA2Params = ((McElieceCCA2KeyGenerationParameters)arg2);
        this.random = new SecureRandom();
        this.m = this.mcElieceCCA2Params.getParameters().getM();
        this.n = this.mcElieceCCA2Params.getParameters().getN();
        this.t = this.mcElieceCCA2Params.getParameters().getT();
        this.fieldPoly = this.mcElieceCCA2Params.getParameters().getFieldPoly();
        this.initialized = true;
    }

    private void initializeDefault() {
        this.init(new McElieceCCA2KeyGenerationParameters(new SecureRandom(), new McElieceCCA2Parameters()));
    }
}

