// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.prng.DigestRandomGenerator;
import org.bouncycastle.pqc.crypto.MessageEncryptor;
import org.bouncycastle.pqc.math.linearalgebra.ByteUtils;
import org.bouncycastle.pqc.math.linearalgebra.GF2Vector;

public class McElieceFujisakiCipher implements MessageEncryptor {
    private static final String DEFAULT_PRNG_NAME = "SHA1PRNG";
    public static final String OID = "1.3.6.1.4.1.8301.3.1.3.4.2.1";
    private int k;
    McElieceCCA2KeyParameters key;
    private Digest messDigest;
    private int n;
    private SecureRandom sr;
    private int t;

    public McElieceFujisakiCipher() {
        super();
    }

    public int getKeySize(McElieceCCA2KeyParameters arg3) {
        int v0;
        if((arg3 instanceof McElieceCCA2PublicKeyParameters)) {
            v0 = ((McElieceCCA2PublicKeyParameters)arg3).getN();
        }
        else if((arg3 instanceof McElieceCCA2PrivateKeyParameters)) {
            v0 = ((McElieceCCA2PrivateKeyParameters)arg3).getN();
        }
        else {
            goto label_8;
        }

        return v0;
    label_8:
        throw new IllegalArgumentException("unsupported type");
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((McElieceCCA2KeyParameters)arg3);
            this.initCipherDecrypt(this.key);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.sr = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
            this.initCipherEncrypt(this.key);
        }
        else {
            this.sr = new SecureRandom();
            this.key = ((McElieceCCA2KeyParameters)arg3);
            this.initCipherEncrypt(this.key);
        }
    }

    public void initCipherDecrypt(McElieceCCA2PrivateKeyParameters arg2) {
        this.messDigest = arg2.getParameters().getDigest();
        this.n = arg2.getN();
        this.t = arg2.getT();
    }

    private void initCipherEncrypt(McElieceCCA2PublicKeyParameters arg2) {
        SecureRandom v0 = this.sr != null ? this.sr : new SecureRandom();
        this.sr = v0;
        this.messDigest = arg2.getParameters().getDigest();
        this.n = arg2.getN();
        this.k = arg2.getK();
        this.t = arg2.getT();
    }

    public byte[] messageDecrypt(byte[] arg10) {
        int v0 = this.n + 7 >> 3;
        int v2 = arg10.length - v0;
        byte[][] v0_1 = ByteUtils.split(arg10, v0);
        byte[] v3 = v0_1[0];
        byte[] v4 = v0_1[1];
        GF2Vector[] v0_2 = McElieceCCA2Primitives.decryptionPrimitive(this.key, GF2Vector.OS2VP(this.n, v3));
        v3 = v0_2[0].getEncoded();
        GF2Vector v5 = v0_2[1];
        DigestRandomGenerator v0_3 = new DigestRandomGenerator(new SHA1Digest());
        v0_3.addSeedMaterial(v3);
        byte[] v6 = new byte[v2];
        v0_3.nextBytes(v6);
        for(v0 = 0; v0 < v2; ++v0) {
            v6[v0] = ((byte)(v6[v0] ^ v4[v0]));
        }

        byte[] v0_4 = ByteUtils.concatenate(v3, v6);
        byte[] v2_1 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.update(v0_4, 0, v0_4.length);
        this.messDigest.doFinal(v2_1, 0);
        if(!Conversions.encode(this.n, this.t, v2_1).equals(v5)) {
            throw new Exception("Bad Padding: invalid ciphertext");
        }

        return v6;
    }

    public byte[] messageEncrypt(byte[] arg7) {
        GF2Vector v2 = new GF2Vector(this.k, this.sr);
        byte[] v3 = v2.getEncoded();
        byte[] v0 = ByteUtils.concatenate(v3, arg7);
        this.messDigest.update(v0, 0, v0.length);
        v0 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.doFinal(v0, 0);
        byte[] v2_1 = McElieceCCA2Primitives.encryptionPrimitive(this.key, v2, Conversions.encode(this.n, this.t, v0)).getEncoded();
        DigestRandomGenerator v0_1 = new DigestRandomGenerator(new SHA1Digest());
        v0_1.addSeedMaterial(v3);
        v3 = new byte[arg7.length];
        v0_1.nextBytes(v3);
        int v0_2;
        for(v0_2 = 0; v0_2 < arg7.length; ++v0_2) {
            v3[v0_2] = ((byte)(v3[v0_2] ^ arg7[v0_2]));
        }

        return ByteUtils.concatenate(v2_1, v3);
    }
}

