// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.GoppaCode;
import org.bouncycastle.pqc.math.linearalgebra.GoppaCode$MaMaPe;
import org.bouncycastle.pqc.math.linearalgebra.Matrix;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialRingGF2m;

public class McElieceKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private static final String OID = "1.3.6.1.4.1.8301.3.1.3.4.1";
    private int fieldPoly;
    private boolean initialized;
    private int m;
    private McElieceKeyGenerationParameters mcElieceParams;
    private int n;
    private SecureRandom random;
    private int t;

    public McElieceKeyPairGenerator() {
        super();
        this.initialized = false;
    }

    private AsymmetricCipherKeyPair genKeyPair() {
        if(!this.initialized) {
            this.initializeDefault();
        }

        GF2mField v13 = new GF2mField(this.m, this.fieldPoly);
        PolynomialGF2mSmallM v6 = new PolynomialGF2mSmallM(v13, this.t, 'I', this.random);
        PolynomialGF2mSmallM[] v11 = new PolynomialRingGF2m(v13, v6).getSquareRootMatrix();
        GF2Matrix v10 = GoppaCode.createCanonicalCheckMatrix(v13, v6);
        GoppaCode$MaMaPe v0 = GoppaCode.computeSystematicForm(v10, this.random);
        GF2Matrix v1 = v0.getSecondMatrix();
        Permutation v8 = v0.getPermutation();
        Matrix v0_1 = v1.computeTranspose();
        v1 = ((GF2Matrix)v0_1).extendLeftCompactForm();
        int v14 = ((GF2Matrix)v0_1).getNumRows();
        GF2Matrix[] v7 = GF2Matrix.createRandomRegularMatrixAndItsInverse(v14, this.random);
        Permutation v9 = new Permutation(this.n, this.random);
        return new AsymmetricCipherKeyPair(new McEliecePublicKeyParameters("1.3.6.1.4.1.8301.3.1.3.4.1", this.n, this.t, v7[0].rightMultiply(((Matrix)v1)).rightMultiply(v9), this.mcElieceParams.getParameters()), new McEliecePrivateKeyParameters("1.3.6.1.4.1.8301.3.1.3.4.1", this.n, v14, v13, v6, v7[1], v8, v9, v10, v11, this.mcElieceParams.getParameters()));
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        return this.genKeyPair();
    }

    public void init(KeyGenerationParameters arg1) {
        this.initialize(arg1);
    }

    private void initialize(KeyGenerationParameters arg2) {
        this.mcElieceParams = ((McElieceKeyGenerationParameters)arg2);
        this.random = new SecureRandom();
        this.m = this.mcElieceParams.getParameters().getM();
        this.n = this.mcElieceParams.getParameters().getN();
        this.t = this.mcElieceParams.getParameters().getT();
        this.fieldPoly = this.mcElieceParams.getParameters().getFieldPoly();
        this.initialized = true;
    }

    private void initializeDefault() {
        this.initialize(new McElieceKeyGenerationParameters(new SecureRandom(), new McElieceParameters()));
    }
}

