// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.MessageEncryptor;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2Vector;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.GoppaCode;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;
import org.bouncycastle.pqc.math.linearalgebra.Vector;

public class McEliecePKCSCipher implements MessageEncryptor {
    public static final String OID = "1.3.6.1.4.1.8301.3.1.3.4.1";
    public int cipherTextSize;
    private int k;
    McElieceKeyParameters key;
    public int maxPlainTextSize;
    private int n;
    private SecureRandom sr;
    private int t;

    public McEliecePKCSCipher() {
        super();
    }

    private byte[] computeMessage(GF2Vector arg6) {
        byte[] v1 = arg6.getEncoded();
        int v0;
        for(v0 = v1.length - 1; v0 >= 0; --v0) {
            if(v1[v0] != 0) {
                break;
            }
        }

        if(v1[v0] != 1) {
            throw new Exception("Bad Padding: invalid ciphertext");
        }

        byte[] v2 = new byte[v0];
        System.arraycopy(v1, 0, v2, 0, v0);
        return v2;
    }

    private GF2Vector computeMessageRepresentative(byte[] arg5) {
        int v3 = this.maxPlainTextSize;
        int v0 = (this.k & 7) != 0 ? 1 : 0;
        byte[] v0_1 = new byte[v0 + v3];
        System.arraycopy(arg5, 0, v0_1, 0, arg5.length);
        v0_1[arg5.length] = 1;
        return GF2Vector.OS2VP(this.k, v0_1);
    }

    public int getKeySize(McElieceKeyParameters arg3) {
        int v0;
        if((arg3 instanceof McEliecePublicKeyParameters)) {
            v0 = ((McEliecePublicKeyParameters)arg3).getN();
        }
        else if((arg3 instanceof McEliecePrivateKeyParameters)) {
            v0 = ((McEliecePrivateKeyParameters)arg3).getN();
        }
        else {
            goto label_8;
        }

        return v0;
    label_8:
        throw new IllegalArgumentException("unsupported type");
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((McElieceKeyParameters)arg3);
            this.initCipherDecrypt(this.key);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.sr = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
            this.initCipherEncrypt(this.key);
        }
        else {
            this.sr = new SecureRandom();
            this.key = ((McElieceKeyParameters)arg3);
            this.initCipherEncrypt(this.key);
        }
    }

    public void initCipherDecrypt(McEliecePrivateKeyParameters arg2) {
        this.n = arg2.getN();
        this.k = arg2.getK();
        this.maxPlainTextSize = this.k >> 3;
        this.cipherTextSize = this.n >> 3;
    }

    public void initCipherEncrypt(McEliecePublicKeyParameters arg2) {
        SecureRandom v0 = this.sr != null ? this.sr : new SecureRandom();
        this.sr = v0;
        this.n = arg2.getN();
        this.k = arg2.getK();
        this.t = arg2.getT();
        this.cipherTextSize = this.n >> 3;
        this.maxPlainTextSize = this.k >> 3;
    }

    public byte[] messageDecrypt(byte[] arg10) {
        GF2Vector v1 = GF2Vector.OS2VP(this.n, arg10);
        McElieceKeyParameters v0 = this.key;
        GF2mField v2 = ((McEliecePrivateKeyParameters)v0).getField();
        PolynomialGF2mSmallM v3 = ((McEliecePrivateKeyParameters)v0).getGoppaPoly();
        GF2Matrix v4 = ((McEliecePrivateKeyParameters)v0).getSInv();
        Permutation v5 = ((McEliecePrivateKeyParameters)v0).getP1();
        Permutation v6 = ((McEliecePrivateKeyParameters)v0).getP2();
        GF2Matrix v7 = ((McEliecePrivateKeyParameters)v0).getH();
        PolynomialGF2mSmallM[] v8 = ((McEliecePrivateKeyParameters)v0).getQInv();
        v6 = v5.rightMultiply(v6);
        Vector v0_1 = v1.multiply(v6.computeInverse());
        v1 = GoppaCode.syndromeDecode(v7.rightMultiply(v0_1), v2, v3, v8);
        v0_1 = ((GF2Vector)v0_1).add(((Vector)v1)).multiply(v5);
        v1.multiply(v6);
        return this.computeMessage(v4.leftMultiply(((GF2Vector)v0_1).extractRightVector(this.k)));
    }

    public byte[] messageEncrypt(byte[] arg6) {
        return this.key.getG().leftMultiply(this.computeMessageRepresentative(arg6)).add(new GF2Vector(this.n, this.t, this.sr)).getEncoded();
    }
}

