// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.MessageEncryptor;

public class McEliecePKCSDigestCipher {
    private boolean forEncrypting;
    private final MessageEncryptor mcElieceCipher;
    private final Digest messDigest;

    public McEliecePKCSDigestCipher(MessageEncryptor arg1, Digest arg2) {
        super();
        this.mcElieceCipher = arg1;
        this.messDigest = arg2;
    }

    public void init(boolean arg3, CipherParameters arg4) {
        this.forEncrypting = arg3;
        CipherParameters v0 = (arg4 instanceof ParametersWithRandom) ? arg4.getParameters() : arg4;
        if((arg3) && (((AsymmetricKeyParameter)v0).isPrivate())) {
            throw new IllegalArgumentException("Encrypting Requires Public Key.");
        }

        if(!arg3 && !((AsymmetricKeyParameter)v0).isPrivate()) {
            throw new IllegalArgumentException("Decrypting Requires Private Key.");
        }

        this.reset();
        this.mcElieceCipher.init(arg3, arg4);
    }

    public byte[] messageDecrypt(byte[] arg3) {
        byte[] v0;
        if(this.forEncrypting) {
            throw new IllegalStateException("McEliecePKCSDigestCipher not initialised for decrypting.");
        }

        try {
            v0 = this.mcElieceCipher.messageDecrypt(arg3);
        }
        catch(Exception v1) {
            v1.printStackTrace();
        }

        return v0;
    }

    public byte[] messageEncrypt() {
        byte[] v0;
        if(!this.forEncrypting) {
            throw new IllegalStateException("McEliecePKCSDigestCipher not initialised for encrypting.");
        }

        byte[] v1 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.doFinal(v1, 0);
        try {
            v0 = this.mcElieceCipher.messageEncrypt(v1);
        }
        catch(Exception v1_1) {
            v1_1.printStackTrace();
        }

        return v0;
    }

    public void reset() {
        this.messDigest.reset();
    }

    public void update(byte arg2) {
        this.messDigest.update(arg2);
    }

    public void update(byte[] arg2, int arg3, int arg4) {
        this.messDigest.update(arg2, arg3, arg4);
    }
}

