// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.digests.SHA1Digest;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.crypto.prng.DigestRandomGenerator;
import org.bouncycastle.pqc.crypto.MessageEncryptor;
import org.bouncycastle.pqc.math.linearalgebra.ByteUtils;
import org.bouncycastle.pqc.math.linearalgebra.GF2Vector;

public class McEliecePointchevalCipher implements MessageEncryptor {
    public static final String OID = "1.3.6.1.4.1.8301.3.1.3.4.2.2";
    private int k;
    McElieceCCA2KeyParameters key;
    private Digest messDigest;
    private int n;
    private SecureRandom sr;
    private int t;

    public McEliecePointchevalCipher() {
        super();
    }

    protected int decryptOutputSize(int arg2) {
        return 0;
    }

    protected int encryptOutputSize(int arg2) {
        return 0;
    }

    public int getKeySize(McElieceCCA2KeyParameters arg3) {
        int v0;
        if((arg3 instanceof McElieceCCA2PublicKeyParameters)) {
            v0 = ((McElieceCCA2PublicKeyParameters)arg3).getN();
        }
        else if((arg3 instanceof McElieceCCA2PrivateKeyParameters)) {
            v0 = ((McElieceCCA2PrivateKeyParameters)arg3).getN();
        }
        else {
            goto label_8;
        }

        return v0;
    label_8:
        throw new IllegalArgumentException("unsupported type");
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((McElieceCCA2KeyParameters)arg3);
            this.initCipherDecrypt(this.key);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.sr = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
            this.initCipherEncrypt(this.key);
        }
        else {
            this.sr = new SecureRandom();
            this.key = ((McElieceCCA2KeyParameters)arg3);
            this.initCipherEncrypt(this.key);
        }
    }

    public void initCipherDecrypt(McElieceCCA2PrivateKeyParameters arg2) {
        this.messDigest = arg2.getParameters().getDigest();
        this.n = arg2.getN();
        this.k = arg2.getK();
        this.t = arg2.getT();
    }

    public void initCipherEncrypt(McElieceCCA2PublicKeyParameters arg2) {
        SecureRandom v0 = this.sr != null ? this.sr : new SecureRandom();
        this.sr = v0;
        this.messDigest = arg2.getParameters().getDigest();
        this.n = arg2.getN();
        this.k = arg2.getK();
        this.t = arg2.getT();
    }

    public byte[] messageDecrypt(byte[] arg9) {
        int v0 = this.n + 7 >> 3;
        int v2 = arg9.length - v0;
        byte[][] v0_1 = ByteUtils.split(arg9, v0);
        byte[] v3 = v0_1[0];
        byte[] v4 = v0_1[1];
        GF2Vector[] v0_2 = McElieceCCA2Primitives.decryptionPrimitive(this.key, GF2Vector.OS2VP(this.n, v3));
        v3 = v0_2[0].getEncoded();
        GF2Vector v5 = v0_2[1];
        DigestRandomGenerator v0_3 = new DigestRandomGenerator(new SHA1Digest());
        v0_3.addSeedMaterial(v3);
        v3 = new byte[v2];
        v0_3.nextBytes(v3);
        for(v0 = 0; v0 < v2; ++v0) {
            v3[v0] = ((byte)(v3[v0] ^ v4[v0]));
        }

        this.messDigest.update(v3, 0, v3.length);
        byte[] v0_4 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.doFinal(v0_4, 0);
        if(!Conversions.encode(this.n, this.t, v0_4).equals(v5)) {
            throw new Exception("Bad Padding: Invalid ciphertext.");
        }

        return ByteUtils.split(v3, v2 - (this.k >> 3))[0];
    }

    public byte[] messageEncrypt(byte[] arg9) {
        int v1 = 0;
        int v2 = this.k >> 3;
        byte[] v3 = new byte[v2];
        this.sr.nextBytes(v3);
        GF2Vector v4 = new GF2Vector(this.k, this.sr);
        byte[] v5 = v4.getEncoded();
        byte[] v0 = ByteUtils.concatenate(arg9, v3);
        this.messDigest.update(v0, 0, v0.length);
        v0 = new byte[this.messDigest.getDigestSize()];
        this.messDigest.doFinal(v0, 0);
        byte[] v4_1 = McElieceCCA2Primitives.encryptionPrimitive(this.key, v4, Conversions.encode(this.n, this.t, v0)).getEncoded();
        DigestRandomGenerator v0_1 = new DigestRandomGenerator(new SHA1Digest());
        v0_1.addSeedMaterial(v5);
        v5 = new byte[arg9.length + v2];
        v0_1.nextBytes(v5);
        int v0_2;
        for(v0_2 = 0; v0_2 < arg9.length; ++v0_2) {
            v5[v0_2] = ((byte)(v5[v0_2] ^ arg9[v0_2]));
        }

        while(v1 < v2) {
            v0_2 = arg9.length + v1;
            v5[v0_2] = ((byte)(v5[v0_2] ^ v3[v1]));
            ++v1;
        }

        return ByteUtils.concatenate(v4_1, v5);
    }
}

