// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.mceliece;

import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;

public class McEliecePrivateKeyParameters extends McElieceKeyParameters {
    private GF2mField field;
    private PolynomialGF2mSmallM goppaPoly;
    private GF2Matrix h;
    private int k;
    private int n;
    private String oid;
    private Permutation p1;
    private Permutation p2;
    private PolynomialGF2mSmallM[] qInv;
    private GF2Matrix sInv;

    public McEliecePrivateKeyParameters(String arg2, int arg3, int arg4, GF2mField arg5, PolynomialGF2mSmallM arg6, GF2Matrix arg7, Permutation arg8, Permutation arg9, GF2Matrix arg10, PolynomialGF2mSmallM[] arg11, McElieceParameters arg12) {
        super(true, arg12);
        this.oid = arg2;
        this.k = arg4;
        this.n = arg3;
        this.field = arg5;
        this.goppaPoly = arg6;
        this.sInv = arg7;
        this.p1 = arg8;
        this.p2 = arg9;
        this.h = arg10;
        this.qInv = arg11;
    }

    public McEliecePrivateKeyParameters(String arg7, int arg8, int arg9, byte[] arg10, byte[] arg11, byte[] arg12, byte[] arg13, byte[] arg14, byte[] arg15, byte[][] arg16, McElieceParameters arg17) {
        super(true, arg17);
        this.oid = arg7;
        this.n = arg8;
        this.k = arg9;
        this.field = new GF2mField(arg10);
        this.goppaPoly = new PolynomialGF2mSmallM(this.field, arg11);
        this.sInv = new GF2Matrix(arg12);
        this.p1 = new Permutation(arg13);
        this.p2 = new Permutation(arg14);
        this.h = new GF2Matrix(arg15);
        this.qInv = new PolynomialGF2mSmallM[arg16.length];
        int v1;
        for(v1 = 0; v1 < arg16.length; ++v1) {
            this.qInv[v1] = new PolynomialGF2mSmallM(this.field, arg16[v1]);
        }
    }

    public GF2mField getField() {
        return this.field;
    }

    public PolynomialGF2mSmallM getGoppaPoly() {
        return this.goppaPoly;
    }

    public GF2Matrix getH() {
        return this.h;
    }

    public int getK() {
        return this.k;
    }

    public int getN() {
        return this.n;
    }

    public String getOIDString() {
        return this.oid;
    }

    public Permutation getP1() {
        return this.p1;
    }

    public Permutation getP2() {
        return this.p2;
    }

    public PolynomialGF2mSmallM[] getQInv() {
        return this.qInv;
    }

    public GF2Matrix getSInv() {
        return this.sInv;
    }
}

