// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.rainbow;

import java.security.SecureRandom;
import org.bouncycastle.pqc.crypto.rainbow.util.GF2Field;
import org.bouncycastle.pqc.crypto.rainbow.util.RainbowUtil;
import org.bouncycastle.util.Arrays;

public class Layer {
    private short[][][] coeff_alpha;
    private short[][][] coeff_beta;
    private short[] coeff_eta;
    private short[][] coeff_gamma;
    private int oi;
    private int vi;
    private int viNext;

    public Layer(byte arg3, byte arg4, short[][][] arg5, short[][][] arg6, short[][] arg7, short[] arg8) {
        super();
        this.vi = arg3 & 255;
        this.viNext = arg4 & 255;
        this.oi = this.viNext - this.vi;
        this.coeff_alpha = arg5;
        this.coeff_beta = arg6;
        this.coeff_gamma = arg7;
        this.coeff_eta = arg8;
    }

    public Layer(int arg8, int arg9, SecureRandom arg10) {
        int v1 = 0;
        super();
        this.vi = arg8;
        this.viNext = arg9;
        this.oi = arg9 - arg8;
        this.coeff_alpha = new short[this.oi][this.oi][this.vi];
        this.coeff_beta = new short[this.oi][this.vi][this.vi];
        this.coeff_gamma = new short[this.oi][this.viNext];
        this.coeff_eta = new short[this.oi];
        int v4 = this.oi;
        int v3;
        for(v3 = 0; v3 < v4; ++v3) {
            int v0;
            for(v0 = 0; v0 < this.oi; ++v0) {
                int v2;
                for(v2 = 0; v2 < this.vi; ++v2) {
                    this.coeff_alpha[v3][v0][v2] = ((short)(arg10.nextInt() & 255));
                }
            }
        }

        for(v3 = 0; v3 < v4; ++v3) {
            for(v0 = 0; v0 < this.vi; ++v0) {
                for(v2 = 0; v2 < this.vi; ++v2) {
                    this.coeff_beta[v3][v0][v2] = ((short)(arg10.nextInt() & 255));
                }
            }
        }

        for(v2 = 0; v2 < v4; ++v2) {
            for(v0 = 0; v0 < this.viNext; ++v0) {
                this.coeff_gamma[v2][v0] = ((short)(arg10.nextInt() & 255));
            }
        }

        while(v1 < v4) {
            this.coeff_eta[v1] = ((short)(arg10.nextInt() & 255));
            ++v1;
        }
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof Layer)) && this.vi == ((Layer)arg4).getVi() && this.viNext == ((Layer)arg4).getViNext() && this.oi == ((Layer)arg4).getOi() && (RainbowUtil.equals(this.coeff_alpha, ((Layer)arg4).getCoeffAlpha())) && (RainbowUtil.equals(this.coeff_beta, ((Layer)arg4).getCoeffBeta())) && (RainbowUtil.equals(this.coeff_gamma, ((Layer)arg4).getCoeffGamma())) && (RainbowUtil.equals(this.coeff_eta, ((Layer)arg4).getCoeffEta()))) {
            v0 = true;
        }

        return v0;
    }

    public short[][][] getCoeffAlpha() {
        return this.coeff_alpha;
    }

    public short[][][] getCoeffBeta() {
        return this.coeff_beta;
    }

    public short[] getCoeffEta() {
        return this.coeff_eta;
    }

    public short[][] getCoeffGamma() {
        return this.coeff_gamma;
    }

    public int getOi() {
        return this.oi;
    }

    public int getVi() {
        return this.vi;
    }

    public int getViNext() {
        return this.viNext;
    }

    public int hashCode() {
        return (((((this.vi * 37 + this.viNext) * 37 + this.oi) * 37 + Arrays.hashCode(this.coeff_alpha)) * 37 + Arrays.hashCode(this.coeff_beta)) * 37 + Arrays.hashCode(this.coeff_gamma)) * 37 + Arrays.hashCode(this.coeff_eta);
    }

    public short[][] plugInVinegars(short[] arg11) {
        int v2 = 0;
        Object v0 = new short[this.oi][this.oi + 1];
        short[] v5 = new short[this.oi];
        int v1;
        for(v1 = 0; v1 < this.oi; ++v1) {
            int v3;
            for(v3 = 0; v3 < this.vi; ++v3) {
                int v4;
                for(v4 = 0; v4 < this.vi; ++v4) {
                    v5[v1] = GF2Field.addElem(v5[v1], GF2Field.multElem(GF2Field.multElem(this.coeff_beta[v1][v3][v4], arg11[v3]), arg11[v4]));
                }
            }
        }

        for(v1 = 0; v1 < this.oi; ++v1) {
            for(v3 = 0; v3 < this.oi; ++v3) {
                for(v4 = 0; v4 < this.vi; ++v4) {
                    v0[v1][v3] = GF2Field.addElem(v0[v1][v3], GF2Field.multElem(this.coeff_alpha[v1][v3][v4], arg11[v4]));
                }
            }
        }

        for(v1 = 0; v1 < this.oi; ++v1) {
            for(v3 = 0; v3 < this.vi; ++v3) {
                v5[v1] = GF2Field.addElem(v5[v1], GF2Field.multElem(this.coeff_gamma[v1][v3], arg11[v3]));
            }
        }

        for(v1 = 0; v1 < this.oi; ++v1) {
            for(v3 = this.vi; v3 < this.viNext; ++v3) {
                v0[v1][v3 - this.vi] = GF2Field.addElem(this.coeff_gamma[v1][v3], v0[v1][v3 - this.vi]);
            }
        }

        for(v1 = 0; v1 < this.oi; ++v1) {
            v5[v1] = GF2Field.addElem(v5[v1], this.coeff_eta[v1]);
        }

        while(v2 < this.oi) {
            v0[v2][this.oi] = v5[v2];
            ++v2;
        }

        return ((short[][])v0);
    }
}

