// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.rainbow;

import java.security.SecureRandom;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.AsymmetricCipherKeyPairGenerator;
import org.bouncycastle.crypto.KeyGenerationParameters;
import org.bouncycastle.pqc.crypto.rainbow.util.ComputeInField;
import org.bouncycastle.pqc.crypto.rainbow.util.GF2Field;

public class RainbowKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
    private short[][] A1;
    private short[][] A1inv;
    private short[][] A2;
    private short[][] A2inv;
    private short[] b1;
    private short[] b2;
    private boolean initialized;
    private Layer[] layers;
    private int numOfLayers;
    private short[][] pub_quadratic;
    private short[] pub_scalar;
    private short[][] pub_singular;
    private RainbowKeyGenerationParameters rainbowParams;
    private SecureRandom sr;
    private int[] vi;

    public RainbowKeyPairGenerator() {
        super();
        this.initialized = false;
    }

    private void compactPublicKey(short[][][] arg11) {
        int v5 = arg11.length;
        int v6 = arg11[0].length;
        this.pub_quadratic = new short[v5][(v6 + 1) * v6 / 2];
        int v4;
        for(v4 = 0; v4 < v5; ++v4) {
            int v1 = 0;
            int v0;
            for(v0 = 0; v1 < v6; v0 = v2) {
                int v2 = v0;
                for(v0 = v1; v0 < v6; ++v0) {
                    this.pub_quadratic[v4][v2] = v0 == v1 ? arg11[v4][v1][v0] : GF2Field.addElem(arg11[v4][v1][v0], arg11[v4][v0][v1]);
                    ++v2;
                }

                ++v1;
            }
        }
    }

    private void computePublicKey() {
        short[] v17;
        ComputeInField v8 = new ComputeInField();
        int v9 = this.vi[this.vi.length - 1] - this.vi[0];
        int v10 = this.vi[this.vi.length - 1];
        Object v2 = new short[v9][v10][v10];
        this.pub_singular = new short[v9][v10];
        this.pub_scalar = new short[v9];
        int v4 = 0;
        new short[v10];
        int v3;
        for(v3 = 0; v3 < this.layers.length; ++v3) {
            short[][][] v11 = this.layers[v3].getCoeffAlpha();
            short[][][] v12 = this.layers[v3].getCoeffBeta();
            short[][] v13 = this.layers[v3].getCoeffGamma();
            short[] v14 = this.layers[v3].getCoeffEta();
            int v15 = v11[0].length;
            int v16 = v12[0].length;
            int v7;
            for(v7 = 0; v7 < v15; ++v7) {
                int v6;
                for(v6 = 0; v6 < v15; ++v6) {
                    int v5;
                    for(v5 = 0; v5 < v16; ++v5) {
                        v17 = v8.multVect(v11[v7][v6][v5], this.A2[v6 + v16]);
                        v2[v4 + v7] = v8.addSquareMatrix(v2[v4 + v7], v8.multVects(v17, this.A2[v5]));
                        this.pub_singular[v4 + v7] = v8.addVect(v8.multVect(this.b2[v5], v17), this.pub_singular[v4 + v7]);
                        this.pub_singular[v4 + v7] = v8.addVect(v8.multVect(this.b2[v6 + v16], v8.multVect(v11[v7][v6][v5], this.A2[v5])), this.pub_singular[v4 + v7]);
                        this.pub_scalar[v4 + v7] = GF2Field.addElem(this.pub_scalar[v4 + v7], GF2Field.multElem(GF2Field.multElem(v11[v7][v6][v5], this.b2[v6 + v16]), this.b2[v5]));
                    }
                }

                for(v6 = 0; v6 < v16; ++v6) {
                    for(v5 = 0; v5 < v16; ++v5) {
                        v17 = v8.multVect(v12[v7][v6][v5], this.A2[v6]);
                        v2[v4 + v7] = v8.addSquareMatrix(v2[v4 + v7], v8.multVects(v17, this.A2[v5]));
                        this.pub_singular[v4 + v7] = v8.addVect(v8.multVect(this.b2[v5], v17), this.pub_singular[v4 + v7]);
                        this.pub_singular[v4 + v7] = v8.addVect(v8.multVect(this.b2[v6], v8.multVect(v12[v7][v6][v5], this.A2[v5])), this.pub_singular[v4 + v7]);
                        this.pub_scalar[v4 + v7] = GF2Field.addElem(this.pub_scalar[v4 + v7], GF2Field.multElem(GF2Field.multElem(v12[v7][v6][v5], this.b2[v6]), this.b2[v5]));
                    }
                }

                for(v5 = 0; v5 < v16 + v15; ++v5) {
                    this.pub_singular[v4 + v7] = v8.addVect(v8.multVect(v13[v7][v5], this.A2[v5]), this.pub_singular[v4 + v7]);
                    this.pub_scalar[v4 + v7] = GF2Field.addElem(this.pub_scalar[v4 + v7], GF2Field.multElem(v13[v7][v5], this.b2[v5]));
                }

                this.pub_scalar[v4 + v7] = GF2Field.addElem(this.pub_scalar[v4 + v7], v14[v7]);
            }

            v4 += v15;
        }

        Object v3_1 = new short[v9][v10][v10];
        Object v4_1 = new short[v9][v10];
        short[] v7_1 = new short[v9];
        for(v6 = 0; v6 < v9; ++v6) {
            for(v5 = 0; v5 < this.A1.length; ++v5) {
                v3_1[v6] = v8.addSquareMatrix(v3_1[v6], v8.multMatrix(this.A1[v6][v5], v2[v5]));
                v4_1[v6] = v8.addVect(v4_1[v6], v8.multVect(this.A1[v6][v5], this.pub_singular[v5]));
                v7_1[v6] = GF2Field.addElem(v7_1[v6], GF2Field.multElem(this.A1[v6][v5], this.pub_scalar[v5]));
            }

            v7_1[v6] = GF2Field.addElem(v7_1[v6], this.b1[v6]);
        }

        this.pub_singular = ((short[][])v4_1);
        this.pub_scalar = v7_1;
        this.compactPublicKey(((short[][][])v3_1));
    }

    public AsymmetricCipherKeyPair genKeyPair() {
        if(!this.initialized) {
            this.initializeDefault();
        }

        this.keygen();
        return new AsymmetricCipherKeyPair(new RainbowPublicKeyParameters(this.vi[this.vi.length - 1] - this.vi[0], this.pub_quadratic, this.pub_singular, this.pub_scalar), new RainbowPrivateKeyParameters(this.A1inv, this.b1, this.A2inv, this.b2, this.vi, this.layers));
    }

    private void generateF() {
        this.layers = new Layer[this.numOfLayers];
        int v0;
        for(v0 = 0; v0 < this.numOfLayers; ++v0) {
            this.layers[v0] = new Layer(this.vi[v0], this.vi[v0 + 1], this.sr);
        }
    }

    public AsymmetricCipherKeyPair generateKeyPair() {
        return this.genKeyPair();
    }

    private void generateL1() {
        int v3 = this.vi[this.vi.length - 1] - this.vi[0];
        this.A1 = new short[v3][v3];
        this.A1inv = null;
        ComputeInField v4 = new ComputeInField();
        while(this.A1inv == null) {
            int v2;
            for(v2 = 0; v2 < v3; ++v2) {
                int v0;
                for(v0 = 0; v0 < v3; ++v0) {
                    this.A1[v2][v0] = ((short)(this.sr.nextInt() & 255));
                }
            }

            this.A1inv = v4.inverse(this.A1);
        }

        this.b1 = new short[v3];
        for(v0 = 0; v0 < v3; ++v0) {
            this.b1[v0] = ((short)(this.sr.nextInt() & 255));
        }
    }

    private void generateL2() {
        int v3 = this.vi[this.vi.length - 1];
        this.A2 = new short[v3][v3];
        this.A2inv = null;
        ComputeInField v4 = new ComputeInField();
        while(this.A2inv == null) {
            int v2;
            for(v2 = 0; v2 < v3; ++v2) {
                int v0;
                for(v0 = 0; v0 < v3; ++v0) {
                    this.A2[v2][v0] = ((short)(this.sr.nextInt() & 255));
                }
            }

            this.A2inv = v4.inverse(this.A2);
        }

        this.b2 = new short[v3];
        for(v0 = 0; v0 < v3; ++v0) {
            this.b2[v0] = ((short)(this.sr.nextInt() & 255));
        }
    }

    public void init(KeyGenerationParameters arg1) {
        this.initialize(arg1);
    }

    public void initialize(KeyGenerationParameters arg2) {
        this.rainbowParams = ((RainbowKeyGenerationParameters)arg2);
        this.sr = new SecureRandom();
        this.vi = this.rainbowParams.getParameters().getVi();
        this.numOfLayers = this.rainbowParams.getParameters().getNumOfLayers();
        this.initialized = true;
    }

    private void initializeDefault() {
        this.initialize(new RainbowKeyGenerationParameters(new SecureRandom(), new RainbowParameters()));
    }

    private void keygen() {
        this.generateL1();
        this.generateL2();
        this.generateF();
        this.computePublicKey();
    }
}

