// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.rainbow;

import org.bouncycastle.crypto.CipherParameters;

public class RainbowParameters implements CipherParameters {
    private final int[] DEFAULT_VI;
    private int[] vi;

    public RainbowParameters() {
        super();
        this.DEFAULT_VI = new int[]{6, 12, 17, 22, 33};
        this.vi = this.DEFAULT_VI;
    }

    public RainbowParameters(int[] arg2) {
        super();
        this.DEFAULT_VI = new int[]{6, 12, 17, 22, 33};
        this.vi = arg2;
        try {
            this.checkParams();
        }
        catch(Exception v0) {
            v0.printStackTrace();
        }
    }

    private void checkParams() {
        if(this.vi == null) {
            throw new Exception("no layers defined.");
        }

        if(this.vi.length > 1) {
            int v0;
            for(v0 = 0; v0 < this.vi.length - 1; ++v0) {
                if(this.vi[v0] >= this.vi[v0 + 1]) {
                    throw new Exception("v[i] has to be smaller than v[i+1]");
                }
            }

            return;
        }

        throw new Exception("Rainbow needs at least 1 layer, such that v1 < v2.");
    }

    public int getDocLength() {
        return this.vi[this.vi.length - 1] - this.vi[0];
    }

    public int getNumOfLayers() {
        return this.vi.length - 1;
    }

    public int[] getVi() {
        return this.vi;
    }
}

