// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.crypto.rainbow;

import java.security.SecureRandom;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.MessageSigner;
import org.bouncycastle.pqc.crypto.rainbow.util.ComputeInField;
import org.bouncycastle.pqc.crypto.rainbow.util.GF2Field;

public class RainbowSigner implements MessageSigner {
    private ComputeInField cf;
    RainbowKeyParameters key;
    private SecureRandom random;
    int signableDocumentLength;
    private short[] x;

    public RainbowSigner() {
        super();
        this.cf = new ComputeInField();
    }

    public byte[] generateSignature(byte[] arg15) {
        Layer[] v5 = this.key.getLayers();
        int v6 = v5.length;
        this.x = new short[this.key.getInvA2().length];
        byte[] v7 = new byte[v5[v6 - 1].getViNext()];
        short[] v8 = this.makeMessageRepresentative(arg15);
        try {
        label_15:
            short[] v9 = this.initSign(v5, v8);
            int v4 = 0;
            int v0_1;
            for(v0_1 = 0; v4 < v6; v0_1 = v3) {
                short[] v10 = new short[v5[v4].getOi()];
                new short[v5[v4].getOi()];
                int v3 = v0_1;
                for(v0_1 = 0; v0_1 < v5[v4].getOi(); ++v0_1) {
                    v10[v0_1] = v9[v3];
                    ++v3;
                }

                v10 = this.cf.solveEquation(v5[v4].plugInVinegars(this.x), v10);
                if(v10 == null) {
                    throw new Exception("LES is not solveable!");
                }

                for(v0_1 = 0; v0_1 < v10.length; ++v0_1) {
                    this.x[v5[v4].getVi() + v0_1] = v10[v0_1];
                }

                ++v4;
            }

            short[] v3_1 = this.cf.multiplyMatrix(this.key.getInvA2(), this.cf.addVect(this.key.getB2(), this.x));
            for(v0_1 = 0; v0_1 < v7.length; ++v0_1) {
                v7[v0_1] = ((byte)v3_1[v0_1]);
            }
        }
        catch(Exception v0) {
            goto label_46;
        }

        v0_1 = 1;
        goto label_47;
    label_46:
        v0_1 = 0;
    label_47:
        if(v0_1 == 0) {
            goto label_15;
        }

        return v7;
    }

    public void init(boolean arg2, CipherParameters arg3) {
        if(!arg2) {
            this.key = ((RainbowKeyParameters)arg3);
        }
        else if((arg3 instanceof ParametersWithRandom)) {
            this.random = ((ParametersWithRandom)arg3).getRandom();
            this.key = ((ParametersWithRandom)arg3).getParameters();
        }
        else {
            this.random = new SecureRandom();
            this.key = ((RainbowKeyParameters)arg3);
        }

        this.signableDocumentLength = this.key.getDocLength();
    }

    private short[] initSign(Layer[] arg6, short[] arg7) {
        new short[arg7.length];
        short[] v2 = this.cf.multiplyMatrix(this.key.getInvA1(), this.cf.addVect(this.key.getB1(), arg7));
        int v0;
        for(v0 = 0; v0 < arg6[0].getVi(); ++v0) {
            this.x[v0] = ((short)this.random.nextInt());
            this.x[v0] = ((short)(this.x[v0] & 255));
        }

        return v2;
    }

    private short[] makeMessageRepresentative(byte[] arg5) {
        int v0 = 0;
        short[] v2 = new short[this.signableDocumentLength];
        int v1 = 0;
        do {
            if(v0 >= arg5.length) {
                return v2;
            }

            v2[v0] = ((short)arg5[v1]);
            v2[v0] = ((short)(v2[v0] & 255));
            ++v1;
            ++v0;
        }
        while(v0 < v2.length);

        return v2;
    }

    public boolean verifySignature(byte[] arg8, byte[] arg9) {
        boolean v1 = false;
        short[] v2 = new short[arg9.length];
        int v0;
        for(v0 = 0; v0 < arg9.length; ++v0) {
            v2[v0] = ((short)((((short)arg9[v0])) & 255));
        }

        short[] v4 = this.makeMessageRepresentative(arg8);
        short[] v5 = this.verifySignatureIntern(v2);
        if(v4.length == v5.length) {
            v0 = 0;
            boolean v2_1 = true;
            while(v0 < v4.length) {
                v2_1 = !v2_1 || v4[v0] != v5[v0] ? false : true;
                ++v0;
            }

            v1 = v2_1;
        }

        return v1;
    }

    private short[] verifySignatureIntern(short[] arg14) {
        short[][] v5 = this.key.getCoeffQuadratic();
        short[][] v6 = this.key.getCoeffSingular();
        short[] v7 = this.key.getCoeffScalar();
        short[] v8 = new short[v5.length];
        int v9 = v6[0].length;
        int v0;
        for(v0 = 0; v0 < v5.length; ++v0) {
            int v3 = 0;
            int v2;
            for(v2 = 0; v3 < v9; v2 = v4) {
                int v4 = v2;
                for(v2 = v3; v2 < v9; ++v2) {
                    v8[v0] = GF2Field.addElem(v8[v0], GF2Field.multElem(v5[v0][v4], GF2Field.multElem(arg14[v3], arg14[v2])));
                    ++v4;
                }

                v8[v0] = GF2Field.addElem(v8[v0], GF2Field.multElem(v6[v0][v3], arg14[v3]));
                ++v3;
            }

            v8[v0] = GF2Field.addElem(v8[v0], v7[v0]);
        }

        return v8;
    }
}

