// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider;

import java.security.AccessController;
import java.security.PrivateKey;
import java.security.Provider;
import java.security.PublicKey;
import java.util.HashMap;
import java.util.Map;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.config.ConfigurableProvider;
import org.bouncycastle.jcajce.provider.config.ProviderConfiguration;
import org.bouncycastle.jcajce.provider.util.AsymmetricKeyInfoConverter;

public class BouncyCastlePQCProvider extends Provider implements ConfigurableProvider {
    private static final String[] ALGORITHMS = null;
    private static final String ALGORITHM_PACKAGE = "org.bouncycastle.pqc.jcajce.provider.";
    public static final ProviderConfiguration CONFIGURATION;
    public static String PROVIDER_NAME;
    private static String info;
    private static final Map keyInfoConverters;

    static {
        BouncyCastlePQCProvider.info = "BouncyCastle Post-Quantum Security Provider v1.48";
        BouncyCastlePQCProvider.PROVIDER_NAME = "BCPQC";
        BouncyCastlePQCProvider.CONFIGURATION = null;
        BouncyCastlePQCProvider.keyInfoConverters = new HashMap();
        BouncyCastlePQCProvider.ALGORITHMS = new String[]{"Rainbow", "McEliece"};
    }

    public BouncyCastlePQCProvider() {
        super(BouncyCastlePQCProvider.PROVIDER_NAME, 1.48, BouncyCastlePQCProvider.info);
        AccessController.doPrivileged(new BouncyCastlePQCProvider$1(this));
    }

    static void access$000(BouncyCastlePQCProvider arg0) {
        arg0.setup();
    }

    public void addAlgorithm(String arg4, String arg5) {
        if(this.containsKey(arg4)) {
            throw new IllegalStateException("duplicate provider key (" + arg4 + ") found");
        }

        this.put(arg4, arg5);
    }

    public void addKeyInfoConverter(ASN1ObjectIdentifier arg2, AsymmetricKeyInfoConverter arg3) {
        BouncyCastlePQCProvider.keyInfoConverters.put(arg2, arg3);
    }

    public static PrivateKey getPrivateKey(PrivateKeyInfo arg2) {
        Object v0 = BouncyCastlePQCProvider.keyInfoConverters.get(arg2.getPrivateKeyAlgorithm().getAlgorithm());
        PrivateKey v0_1 = v0 == null ? null : ((AsymmetricKeyInfoConverter)v0).generatePrivate(arg2);
        return v0_1;
    }

    public static PublicKey getPublicKey(SubjectPublicKeyInfo arg2) {
        Object v0 = BouncyCastlePQCProvider.keyInfoConverters.get(arg2.getAlgorithm().getAlgorithm());
        PublicKey v0_1 = v0 == null ? null : ((AsymmetricKeyInfoConverter)v0).generatePublic(arg2);
        return v0_1;
    }

    public boolean hasAlgorithm(String arg3, String arg4) {
        boolean v0 = (this.containsKey(arg3 + "." + arg4)) || (this.containsKey("Alg.Alias." + arg3 + "." + arg4)) ? true : false;
        return v0;
    }

    private void loadAlgorithms(String arg6, String[] arg7) {
        int v1;
        for(v1 = 0; v1 != arg7.length; ++v1) {
            Class v0 = null;
            try {
                ClassLoader v2_1 = this.getClass().getClassLoader();
                if(v2_1 != null) {
                    v0 = v2_1.loadClass(arg6 + arg7[v1] + "$Mappings");
                    goto label_17;
                }

                v0 = Class.forName(arg6 + arg7[v1] + "$Mappings");
            }
            catch(ClassNotFoundException v2) {
            }

        label_17:
            if(v0 != null) {
                try {
                    v0.newInstance().configure(((ConfigurableProvider)this));
                }
                catch(Exception v0_1) {
                    throw new InternalError("cannot create instance of " + arg6 + arg7[v1] + "$Mappings : " + v0_1);
                }
            }
        }
    }

    public void setParameter(String arg3, Object arg4) {
        ProviderConfiguration v1 = BouncyCastlePQCProvider.CONFIGURATION;
        __monitor_enter(v1);
        try {
            __monitor_exit(v1);
            return;
        label_5:
            __monitor_exit(v1);
        }
        catch(Throwable v0) {
            goto label_5;
        }

        throw v0;
    }

    private void setup() {
        this.loadAlgorithms("org.bouncycastle.pqc.jcajce.provider.", BouncyCastlePQCProvider.ALGORITHMS);
    }
}

