// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.gmss;

import java.security.PublicKey;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.pqc.asn1.GMSSPublicKey;
import org.bouncycastle.pqc.asn1.PQCObjectIdentifiers;
import org.bouncycastle.pqc.asn1.ParSet;
import org.bouncycastle.pqc.crypto.gmss.GMSSParameters;
import org.bouncycastle.pqc.crypto.gmss.GMSSPublicKeyParameters;
import org.bouncycastle.pqc.jcajce.provider.util.KeyUtil;
import org.bouncycastle.pqc.jcajce.spec.GMSSPublicKeySpec;
import org.bouncycastle.util.encoders.Hex;

public class BCGMSSPublicKey implements PublicKey, CipherParameters {
    private GMSSParameters gmssParameterSet;
    private GMSSParameters gmssParams;
    private byte[] publicKeyBytes;
    private static final long serialVersionUID = 1;

    public BCGMSSPublicKey(GMSSPublicKeyParameters arg3) {
        this(arg3.getPublicKey(), arg3.getParameters());
    }

    public BCGMSSPublicKey(byte[] arg1, GMSSParameters arg2) {
        super();
        this.gmssParameterSet = arg2;
        this.publicKeyBytes = arg1;
    }

    protected BCGMSSPublicKey(GMSSPublicKeySpec arg3) {
        this(arg3.getPublicKey(), arg3.getParameters());
    }

    public String getAlgorithm() {
        return "GMSS";
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedSubjectPublicKeyInfo(new AlgorithmIdentifier(PQCObjectIdentifiers.gmss, new ParSet(this.gmssParameterSet.getNumOfLayers(), this.gmssParameterSet.getHeightOfTrees(), this.gmssParameterSet.getWinternitzParameter(), this.gmssParameterSet.getK()).toASN1Primitive()), new GMSSPublicKey(this.publicKeyBytes));
    }

    public String getFormat() {
        return "X.509";
    }

    public GMSSParameters getParameterSet() {
        return this.gmssParameterSet;
    }

    public byte[] getPublicKeyBytes() {
        return this.publicKeyBytes;
    }

    public String toString() {
        String v1 = "GMSS public key : " + new String(Hex.encode(this.publicKeyBytes)) + "\n" + "Height of Trees: \n";
        int v0;
        for(v0 = 0; v0 < this.gmssParameterSet.getHeightOfTrees().length; ++v0) {
            v1 = v1 + "Layer " + v0 + " : " + this.gmssParameterSet.getHeightOfTrees()[v0] + " WinternitzParameter: " + this.gmssParameterSet.getWinternitzParameter()[v0] + " K: " + this.gmssParameterSet.getK()[v0] + "\n";
        }

        return v1;
    }
}

