// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.io.IOException;
import java.security.PrivateKey;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.pqc.asn1.McElieceCCA2PrivateKey;
import org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2Parameters;
import org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2PrivateKeyParameters;
import org.bouncycastle.pqc.jcajce.spec.McElieceCCA2PrivateKeySpec;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;

public class BCMcElieceCCA2PrivateKey implements PrivateKey, CipherParameters {
    private GF2mField field;
    private PolynomialGF2mSmallM goppaPoly;
    private GF2Matrix h;
    private int k;
    private McElieceCCA2Parameters mcElieceCCA2Params;
    private int n;
    private String oid;
    private Permutation p;
    private PolynomialGF2mSmallM[] qInv;
    private static final long serialVersionUID = 1;

    public BCMcElieceCCA2PrivateKey(String arg1, int arg2, int arg3, GF2mField arg4, PolynomialGF2mSmallM arg5, Permutation arg6, GF2Matrix arg7, PolynomialGF2mSmallM[] arg8) {
        super();
        this.oid = arg1;
        this.n = arg2;
        this.k = arg3;
        this.field = arg4;
        this.goppaPoly = arg5;
        this.p = arg6;
        this.h = arg7;
        this.qInv = arg8;
    }

    public BCMcElieceCCA2PrivateKey(McElieceCCA2PrivateKeyParameters arg10) {
        this(arg10.getOIDString(), arg10.getN(), arg10.getK(), arg10.getField(), arg10.getGoppaPoly(), arg10.getP(), arg10.getH(), arg10.getQInv());
        this.mcElieceCCA2Params = arg10.getParameters();
    }

    public BCMcElieceCCA2PrivateKey(McElieceCCA2PrivateKeySpec arg10) {
        this(arg10.getOIDString(), arg10.getN(), arg10.getK(), arg10.getField(), arg10.getGoppaPoly(), arg10.getP(), arg10.getH(), arg10.getQInv());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof BCMcElieceCCA2PrivateKey)) && this.n == ((BCMcElieceCCA2PrivateKey)arg4).n && this.k == ((BCMcElieceCCA2PrivateKey)arg4).k && (this.field.equals(((BCMcElieceCCA2PrivateKey)arg4).field)) && (this.goppaPoly.equals(((BCMcElieceCCA2PrivateKey)arg4).goppaPoly)) && (this.p.equals(((BCMcElieceCCA2PrivateKey)arg4).p)) && (this.h.equals(((BCMcElieceCCA2PrivateKey)arg4).h))) {
            v0 = true;
        }

        return v0;
    }

    protected ASN1Primitive getAlgParams() {
        return null;
    }

    public String getAlgorithm() {
        return "McEliece";
    }

    public byte[] getEncoded() {
        byte[] v0_2;
        PrivateKeyInfo v2;
        byte[] v9 = null;
        McElieceCCA2PrivateKey v0 = new McElieceCCA2PrivateKey(new ASN1ObjectIdentifier(this.oid), this.n, this.k, this.field, this.goppaPoly, this.p, this.h, this.qInv);
        try {
            v2 = new PrivateKeyInfo(new AlgorithmIdentifier(this.getOID(), DERNull.INSTANCE), ((ASN1Encodable)v0));
        }
        catch(IOException v0_1) {
            v0_1.printStackTrace();
            v0_2 = v9;
            return v0_2;
        }

        try {
            v0_2 = v2.getEncoded();
        }
        catch(IOException v0_1) {
            v0_1.printStackTrace();
            v0_2 = v9;
        }

        return v0_2;
    }

    public GF2mField getField() {
        return this.field;
    }

    public String getFormat() {
        return null;
    }

    public PolynomialGF2mSmallM getGoppaPoly() {
        return this.goppaPoly;
    }

    public GF2Matrix getH() {
        return this.h;
    }

    public int getK() {
        return this.k;
    }

    public McElieceCCA2Parameters getMcElieceCCA2Parameters() {
        return this.mcElieceCCA2Params;
    }

    public int getN() {
        return this.n;
    }

    protected ASN1ObjectIdentifier getOID() {
        return new ASN1ObjectIdentifier("1.3.6.1.4.1.8301.3.1.3.4.2");
    }

    public String getOIDString() {
        return this.oid;
    }

    public Permutation getP() {
        return this.p;
    }

    public PolynomialGF2mSmallM[] getQInv() {
        return this.qInv;
    }

    public int getT() {
        return this.goppaPoly.getDegree();
    }

    public int hashCode() {
        return this.k + this.n + this.field.hashCode() + this.goppaPoly.hashCode() + this.p.hashCode() + this.h.hashCode();
    }

    public String toString() {
        return "" + " extension degree of the field      : " + this.n + "\n" + " dimension of the code              : " + this.k + "\n" + " irreducible Goppa polynomial       : " + this.goppaPoly + "\n";
    }
}

