// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.io.IOException;
import java.security.PublicKey;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.pqc.asn1.McElieceCCA2PublicKey;
import org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2Parameters;
import org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2PublicKeyParameters;
import org.bouncycastle.pqc.jcajce.spec.McElieceCCA2PublicKeySpec;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;

public class BCMcElieceCCA2PublicKey implements PublicKey, CipherParameters {
    private McElieceCCA2Parameters McElieceCCA2Params;
    private GF2Matrix g;
    private int n;
    private String oid;
    private static final long serialVersionUID = 1;
    private int t;

    public BCMcElieceCCA2PublicKey(String arg1, int arg2, int arg3, GF2Matrix arg4) {
        super();
        this.oid = arg1;
        this.n = arg2;
        this.t = arg3;
        this.g = arg4;
    }

    public BCMcElieceCCA2PublicKey(McElieceCCA2PublicKeyParameters arg5) {
        this(arg5.getOIDString(), arg5.getN(), arg5.getT(), arg5.getMatrixG());
        this.McElieceCCA2Params = arg5.getParameters();
    }

    public BCMcElieceCCA2PublicKey(McElieceCCA2PublicKeySpec arg5) {
        this(arg5.getOIDString(), arg5.getN(), arg5.getT(), arg5.getMatrixG());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof BCMcElieceCCA2PublicKey)) && this.n == ((BCMcElieceCCA2PublicKey)arg4).n && this.t == ((BCMcElieceCCA2PublicKey)arg4).t && (this.g.equals(((BCMcElieceCCA2PublicKey)arg4).g))) {
            v0 = true;
        }

        return v0;
    }

    protected ASN1Primitive getAlgParams() {
        return null;
    }

    public String getAlgorithm() {
        return "McEliece";
    }

    public byte[] getEncoded() {
        byte[] v0_2;
        McElieceCCA2PublicKey v0 = new McElieceCCA2PublicKey(new ASN1ObjectIdentifier(this.oid), this.n, this.t, this.g);
        AlgorithmIdentifier v1 = new AlgorithmIdentifier(this.getOID(), DERNull.INSTANCE);
        try {
            v0_2 = new SubjectPublicKeyInfo(v1, ((ASN1Encodable)v0)).getEncoded();
        }
        catch(IOException v0_1) {
            v0_2 = null;
        }

        return v0_2;
    }

    public String getFormat() {
        return null;
    }

    public GF2Matrix getG() {
        return this.g;
    }

    public int getK() {
        return this.g.getNumRows();
    }

    public McElieceCCA2Parameters getMcElieceCCA2Parameters() {
        return this.McElieceCCA2Params;
    }

    public int getN() {
        return this.n;
    }

    protected ASN1ObjectIdentifier getOID() {
        return new ASN1ObjectIdentifier("1.3.6.1.4.1.8301.3.1.3.4.2");
    }

    public String getOIDString() {
        return this.oid;
    }

    public int getT() {
        return this.t;
    }

    public int hashCode() {
        return this.n + this.t + this.g.hashCode();
    }

    public String toString() {
        return "McEliecePublicKey:\n" + " length of the code         : " + this.n + "\n" + " error correction capability: " + this.t + "\n" + " generator matrix           : " + this.g.toString();
    }
}

