// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.io.IOException;
import java.security.PrivateKey;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.pqc.asn1.McEliecePrivateKey;
import org.bouncycastle.pqc.crypto.mceliece.McElieceParameters;
import org.bouncycastle.pqc.crypto.mceliece.McEliecePrivateKeyParameters;
import org.bouncycastle.pqc.jcajce.spec.McEliecePrivateKeySpec;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;

public class BCMcEliecePrivateKey implements PrivateKey, CipherParameters {
    private GF2mField field;
    private PolynomialGF2mSmallM goppaPoly;
    private GF2Matrix h;
    private int k;
    private McElieceParameters mcElieceParams;
    private int n;
    private String oid;
    private Permutation p1;
    private Permutation p2;
    private PolynomialGF2mSmallM[] qInv;
    private GF2Matrix sInv;
    private static final long serialVersionUID = 1;

    public BCMcEliecePrivateKey(String arg1, int arg2, int arg3, GF2mField arg4, PolynomialGF2mSmallM arg5, GF2Matrix arg6, Permutation arg7, Permutation arg8, GF2Matrix arg9, PolynomialGF2mSmallM[] arg10) {
        super();
        this.oid = arg1;
        this.n = arg2;
        this.k = arg3;
        this.field = arg4;
        this.goppaPoly = arg5;
        this.sInv = arg6;
        this.p1 = arg7;
        this.p2 = arg8;
        this.h = arg9;
        this.qInv = arg10;
    }

    public BCMcEliecePrivateKey(McEliecePrivateKeyParameters arg12) {
        this(arg12.getOIDString(), arg12.getN(), arg12.getK(), arg12.getField(), arg12.getGoppaPoly(), arg12.getSInv(), arg12.getP1(), arg12.getP2(), arg12.getH(), arg12.getQInv());
        this.mcElieceParams = arg12.getParameters();
    }

    public BCMcEliecePrivateKey(McEliecePrivateKeySpec arg12) {
        this(arg12.getOIDString(), arg12.getN(), arg12.getK(), arg12.getField(), arg12.getGoppaPoly(), arg12.getSInv(), arg12.getP1(), arg12.getP2(), arg12.getH(), arg12.getQInv());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof BCMcEliecePrivateKey)) && this.n == ((BCMcEliecePrivateKey)arg4).n && this.k == ((BCMcEliecePrivateKey)arg4).k && (this.field.equals(((BCMcEliecePrivateKey)arg4).field)) && (this.goppaPoly.equals(((BCMcEliecePrivateKey)arg4).goppaPoly)) && (this.sInv.equals(((BCMcEliecePrivateKey)arg4).sInv)) && (this.p1.equals(((BCMcEliecePrivateKey)arg4).p1)) && (this.p2.equals(((BCMcEliecePrivateKey)arg4).p2)) && (this.h.equals(((BCMcEliecePrivateKey)arg4).h))) {
            v0 = true;
        }

        return v0;
    }

    protected ASN1Primitive getAlgParams() {
        return null;
    }

    public String getAlgorithm() {
        return "McEliece";
    }

    public byte[] getEncoded() {
        byte[] v0_2;
        PrivateKeyInfo v2;
        byte[] v11 = null;
        McEliecePrivateKey v0 = new McEliecePrivateKey(new ASN1ObjectIdentifier(this.oid), this.n, this.k, this.field, this.goppaPoly, this.sInv, this.p1, this.p2, this.h, this.qInv);
        try {
            v2 = new PrivateKeyInfo(new AlgorithmIdentifier(this.getOID(), DERNull.INSTANCE), ((ASN1Encodable)v0));
        }
        catch(IOException v0_1) {
            v0_1.printStackTrace();
            v0_2 = v11;
            return v0_2;
        }

        try {
            v0_2 = v2.getEncoded();
        }
        catch(IOException v0_1) {
            v0_1.printStackTrace();
            v0_2 = v11;
        }

        return v0_2;
    }

    public GF2mField getField() {
        return this.field;
    }

    public String getFormat() {
        return null;
    }

    public PolynomialGF2mSmallM getGoppaPoly() {
        return this.goppaPoly;
    }

    public GF2Matrix getH() {
        return this.h;
    }

    public int getK() {
        return this.k;
    }

    public McElieceParameters getMcElieceParameters() {
        return this.mcElieceParams;
    }

    public int getN() {
        return this.n;
    }

    protected ASN1ObjectIdentifier getOID() {
        return new ASN1ObjectIdentifier("1.3.6.1.4.1.8301.3.1.3.4.1");
    }

    public String getOIDString() {
        return this.oid;
    }

    public Permutation getP1() {
        return this.p1;
    }

    public Permutation getP2() {
        return this.p2;
    }

    public PolynomialGF2mSmallM[] getQInv() {
        return this.qInv;
    }

    public GF2Matrix getSInv() {
        return this.sInv;
    }

    public int hashCode() {
        return this.k + this.n + this.field.hashCode() + this.goppaPoly.hashCode() + this.sInv.hashCode() + this.p1.hashCode() + this.p2.hashCode() + this.h.hashCode();
    }

    public String toString() {
        return " length of the code          : " + this.n + "\n" + " dimension of the code       : " + this.k + "\n" + " irreducible Goppa polynomial: " + this.goppaPoly + "\n" + " (k x k)-matrix S^-1         : " + this.sInv + "\n" + " permutation P1              : " + this.p1 + "\n" + " permutation P2              : " + this.p2;
    }
}

