// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactorySpi;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.pqc.asn1.McEliecePrivateKey;
import org.bouncycastle.pqc.asn1.McEliecePublicKey;
import org.bouncycastle.pqc.jcajce.spec.McEliecePrivateKeySpec;
import org.bouncycastle.pqc.jcajce.spec.McEliecePublicKeySpec;

public class McElieceKeyFactorySpi extends KeyFactorySpi {
    public static final String OID = "1.3.6.1.4.1.8301.3.1.3.4.1";

    public McElieceKeyFactorySpi() {
        super();
    }

    protected PrivateKey engineGeneratePrivate(KeySpec arg2) {
        return null;
    }

    protected PublicKey engineGeneratePublic(KeySpec arg2) {
        return null;
    }

    protected KeySpec engineGetKeySpec(Key arg2, Class arg3) {
        return null;
    }

    protected Key engineTranslateKey(Key arg2) {
        return null;
    }

    public PrivateKey generatePrivate(KeySpec arg13) {
        PrivateKeyInfo v0_3;
        BCMcEliecePrivateKey v0;
        int v11 = 0;
        if((arg13 instanceof McEliecePrivateKeySpec)) {
            v0 = new BCMcEliecePrivateKey(((McEliecePrivateKeySpec)arg13));
        }
        else if((arg13 instanceof PKCS8EncodedKeySpec)) {
            byte[] v0_1 = ((PKCS8EncodedKeySpec)arg13).getEncoded();
            try {
                v0_3 = PrivateKeyInfo.getInstance(ASN1Primitive.fromByteArray(v0_1));
            }
            catch(IOException v0_2) {
                throw new InvalidKeySpecException("Unable to decode PKCS8EncodedKeySpec: " + v0_2);
            }

            try {
                ASN1Primitive v0_4 = v0_3.parsePrivateKey().toASN1Primitive();
                ((ASN1Sequence)v0_4).getObjectAt(0).toString();
                int v2 = ((ASN1Sequence)v0_4).getObjectAt(1).getValue().intValue();
                int v3 = ((ASN1Sequence)v0_4).getObjectAt(2).getValue().intValue();
                byte[] v4 = ((ASN1Sequence)v0_4).getObjectAt(3).getOctets();
                byte[] v5 = ((ASN1Sequence)v0_4).getObjectAt(4).getOctets();
                byte[] v6 = ((ASN1Sequence)v0_4).getObjectAt(5).getOctets();
                byte[] v7 = ((ASN1Sequence)v0_4).getObjectAt(6).getOctets();
                byte[] v8 = ((ASN1Sequence)v0_4).getObjectAt(7).getOctets();
                byte[] v9 = ((ASN1Sequence)v0_4).getObjectAt(8).getOctets();
                ASN1Encodable v0_5 = ((ASN1Sequence)v0_4).getObjectAt(9);
                byte[][] v10 = new byte[((ASN1Sequence)v0_5).size()][];
                while(v11 < ((ASN1Sequence)v0_5).size()) {
                    v10[v11] = ((ASN1Sequence)v0_5).getObjectAt(v11).getOctets();
                    ++v11;
                }

                v0 = new BCMcEliecePrivateKey(new McEliecePrivateKeySpec("1.3.6.1.4.1.8301.3.1.3.4.1", v2, v3, v4, v5, v6, v7, v8, v9, v10));
            }
            catch(IOException v0_2) {
                goto label_75;
            }
        }
        else {
            goto label_76;
        }

        return ((PrivateKey)v0);
    label_75:
        throw new InvalidKeySpecException("Unable to decode PKCS8EncodedKeySpec.");
    label_76:
        throw new InvalidKeySpecException("Unsupported key specification: " + arg13.getClass() + ".");
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg12) {
        try {
            McEliecePrivateKey v10 = McEliecePrivateKey.getInstance(arg12.parsePrivateKey().toASN1Primitive());
            return new BCMcEliecePrivateKey(v10.getOID().getId(), v10.getN(), v10.getK(), v10.getField(), v10.getGoppaPoly(), v10.getSInv(), v10.getP1(), v10.getP2(), v10.getH(), v10.getQInv());
        }
        catch(IOException v0) {
            throw new InvalidKeySpecException("Unable to decode PKCS8EncodedKeySpec");
        }
    }

    public PublicKey generatePublic(KeySpec arg7) {
        SubjectPublicKeyInfo v0_3;
        BCMcEliecePublicKey v0;
        if((arg7 instanceof McEliecePublicKeySpec)) {
            v0 = new BCMcEliecePublicKey(((McEliecePublicKeySpec)arg7));
        }
        else if((arg7 instanceof X509EncodedKeySpec)) {
            byte[] v0_1 = ((X509EncodedKeySpec)arg7).getEncoded();
            try {
                v0_3 = SubjectPublicKeyInfo.getInstance(ASN1Primitive.fromByteArray(v0_1));
            }
            catch(IOException v0_2) {
                throw new InvalidKeySpecException(v0_2.toString());
            }

            try {
                ASN1Primitive v0_4 = v0_3.parsePublicKey();
                ((ASN1Sequence)v0_4).getObjectAt(0).toString();
                v0 = new BCMcEliecePublicKey(new McEliecePublicKeySpec("1.3.6.1.4.1.8301.3.1.3.4.1", ((ASN1Sequence)v0_4).getObjectAt(2).getValue().intValue(), ((ASN1Sequence)v0_4).getObjectAt(1).getValue().intValue(), ((ASN1Sequence)v0_4).getObjectAt(3).getOctets()));
            }
            catch(IOException v0_2) {
                throw new InvalidKeySpecException("Unable to decode X509EncodedKeySpec: " + v0_2.getMessage());
            }
        }
        else {
            goto label_47;
        }

        return ((PublicKey)v0);
    label_47:
        throw new InvalidKeySpecException("Unsupported key specification: " + arg7.getClass() + ".");
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg6) {
        try {
            McEliecePublicKey v0_1 = McEliecePublicKey.getInstance(arg6.parsePublicKey());
            return new BCMcEliecePublicKey(v0_1.getOID().getId(), v0_1.getN(), v0_1.getT(), v0_1.getG());
        }
        catch(IOException v0) {
            throw new InvalidKeySpecException("Unable to decode X509EncodedKeySpec");
        }
    }

    public KeySpec getKeySpec(Key arg12, Class arg13) {
        X509EncodedKeySpec v0_2;
        if((arg12 instanceof BCMcEliecePrivateKey)) {
            if(PKCS8EncodedKeySpec.class.isAssignableFrom(arg13)) {
                PKCS8EncodedKeySpec v0 = new PKCS8EncodedKeySpec(arg12.getEncoded());
                goto label_8;
            }
            else if(McEliecePrivateKeySpec.class.isAssignableFrom(arg13)) {
                McEliecePrivateKeySpec v0_1 = new McEliecePrivateKeySpec("1.3.6.1.4.1.8301.3.1.3.4.1", ((BCMcEliecePrivateKey)arg12).getN(), ((BCMcEliecePrivateKey)arg12).getK(), ((BCMcEliecePrivateKey)arg12).getField(), ((BCMcEliecePrivateKey)arg12).getGoppaPoly(), ((BCMcEliecePrivateKey)arg12).getSInv(), ((BCMcEliecePrivateKey)arg12).getP1(), ((BCMcEliecePrivateKey)arg12).getP2(), ((BCMcEliecePrivateKey)arg12).getH(), ((BCMcEliecePrivateKey)arg12).getQInv());
                goto label_8;
            }
        }
        else if(!(arg12 instanceof BCMcEliecePublicKey)) {
            goto label_44;
        }
        else if(X509EncodedKeySpec.class.isAssignableFrom(arg13)) {
            v0_2 = new X509EncodedKeySpec(arg12.getEncoded());
            goto label_8;
        }
        else if(McEliecePublicKeySpec.class.isAssignableFrom(arg13)) {
            McEliecePublicKeySpec v0_3 = new McEliecePublicKeySpec("1.3.6.1.4.1.8301.3.1.3.4.1", ((BCMcEliecePublicKey)arg12).getN(), ((BCMcEliecePublicKey)arg12).getT(), ((BCMcEliecePublicKey)arg12).getG());
        label_8:
            return ((KeySpec)v0_2);
        }

        throw new InvalidKeySpecException("Unknown key specification: " + arg13 + ".");
    label_44:
        throw new InvalidKeySpecException("Unsupported key type: " + arg12.getClass() + ".");
    }

    public Key translateKey(Key arg3) {
        if(!(arg3 instanceof BCMcEliecePrivateKey) && !(arg3 instanceof BCMcEliecePublicKey)) {
            throw new InvalidKeyException("Unsupported key type.");
        }

        return arg3;
    }
}

