// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.io.ByteArrayOutputStream;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.BadPaddingException;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.mceliece.McElieceKobaraImaiCipher;
import org.bouncycastle.pqc.jcajce.provider.util.AsymmetricHybridCipher;

public class McElieceKobaraImaiCipherSpi extends AsymmetricHybridCipher implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    private ByteArrayOutputStream buf;
    private McElieceKobaraImaiCipher cipher;
    private Digest digest;

    public McElieceKobaraImaiCipherSpi() {
        super();
        this.buf = new ByteArrayOutputStream();
        this.buf = new ByteArrayOutputStream();
    }

    protected McElieceKobaraImaiCipherSpi(Digest arg2, McElieceKobaraImaiCipher arg3) {
        super();
        this.buf = new ByteArrayOutputStream();
        this.digest = arg2;
        this.cipher = arg3;
        this.buf = new ByteArrayOutputStream();
    }

    protected int decryptOutputSize(int arg2) {
        return 0;
    }

    public byte[] doFinal(byte[] arg3, int arg4, int arg5) {
        byte[] v0_1;
        this.update(arg3, arg4, arg5);
        if(this.opMode == 1) {
            try {
                v0_1 = this.cipher.messageEncrypt(this.pad());
                return v0_1;
            }
            catch(Exception v0) {
                v0.printStackTrace();
                return null;
            }
        }

        if(this.opMode == 2) {
            v0_1 = this.buf.toByteArray();
            this.buf.reset();
            try {
                return this.unpad(this.cipher.messageDecrypt(v0_1));
            }
            catch(Exception v0) {
                v0.printStackTrace();
            }
        }

        return null;
    }

    protected int encryptOutputSize(int arg2) {
        return 0;
    }

    public int getKeySize(Key arg3) {
        int v0;
        if((arg3 instanceof PublicKey)) {
            v0 = this.cipher.getKeySize(McElieceCCA2KeysToParams.generatePublicKeyParameter(((PublicKey)arg3)));
        }
        else if((arg3 instanceof PrivateKey)) {
            v0 = this.cipher.getKeySize(McElieceCCA2KeysToParams.generatePrivateKeyParameter(((PrivateKey)arg3)));
        }
        else {
            goto label_12;
        }

        return v0;
    label_12:
        throw new InvalidKeyException();
    }

    public String getName() {
        return "McElieceKobaraImaiCipher";
    }

    protected void initCipherDecrypt(Key arg4, AlgorithmParameterSpec arg5) {
        this.buf.reset();
        AsymmetricKeyParameter v0 = McElieceCCA2KeysToParams.generatePrivateKeyParameter(((PrivateKey)arg4));
        this.digest.reset();
        this.cipher.init(false, ((CipherParameters)v0));
    }

    protected void initCipherEncrypt(Key arg4, AlgorithmParameterSpec arg5, SecureRandom arg6) {
        this.buf.reset();
        ParametersWithRandom v1 = new ParametersWithRandom(McElieceCCA2KeysToParams.generatePublicKeyParameter(((PublicKey)arg4)), arg6);
        this.digest.reset();
        this.cipher.init(true, ((CipherParameters)v1));
    }

    public byte[] messageDecrypt() {
        byte[] v0;
        byte[] v1 = this.buf.toByteArray();
        this.buf.reset();
        try {
            v0 = this.unpad(this.cipher.messageDecrypt(v1));
        }
        catch(Exception v1_1) {
            v1_1.printStackTrace();
        }

        return v0;
    }

    public byte[] messageEncrypt() {
        byte[] v0;
        try {
            v0 = this.cipher.messageEncrypt(this.pad());
        }
        catch(Exception v1) {
            v1.printStackTrace();
        }

        return v0;
    }

    private byte[] pad() {
        this.buf.write(1);
        byte[] v0 = this.buf.toByteArray();
        this.buf.reset();
        return v0;
    }

    private byte[] unpad(byte[] arg5) {
        int v0;
        for(v0 = arg5.length - 1; v0 >= 0; --v0) {
            if(arg5[v0] != 0) {
                break;
            }
        }

        if(arg5[v0] != 1) {
            throw new BadPaddingException("invalid ciphertext");
        }

        byte[] v1 = new byte[v0];
        System.arraycopy(arg5, 0, v1, 0, v0);
        return v1;
    }

    public byte[] update(byte[] arg2, int arg3, int arg4) {
        this.buf.write(arg2, arg3, arg4);
        return new byte[0];
    }
}

