// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.mceliece.McElieceKeyParameters;
import org.bouncycastle.pqc.crypto.mceliece.McEliecePKCSCipher;
import org.bouncycastle.pqc.jcajce.provider.util.AsymmetricBlockCipher;

public class McEliecePKCSCipherSpi extends AsymmetricBlockCipher implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    private McEliecePKCSCipher cipher;
    private Digest digest;

    public McEliecePKCSCipherSpi(Digest arg1, McEliecePKCSCipher arg2) {
        super();
        this.digest = arg1;
        this.cipher = arg2;
    }

    public int getKeySize(Key arg3) {
        AsymmetricKeyParameter v0 = (arg3 instanceof PublicKey) ? McElieceKeysToParams.generatePublicKeyParameter(((PublicKey)arg3)) : McElieceKeysToParams.generatePrivateKeyParameter(((PrivateKey)arg3));
        return this.cipher.getKeySize(((McElieceKeyParameters)v0));
    }

    public String getName() {
        return "McEliecePKCS";
    }

    protected void initCipherDecrypt(Key arg4, AlgorithmParameterSpec arg5) {
        AsymmetricKeyParameter v0 = McElieceKeysToParams.generatePrivateKeyParameter(((PrivateKey)arg4));
        this.digest.reset();
        this.cipher.init(false, ((CipherParameters)v0));
        this.maxPlainTextSize = this.cipher.maxPlainTextSize;
        this.cipherTextSize = this.cipher.cipherTextSize;
    }

    protected void initCipherEncrypt(Key arg4, AlgorithmParameterSpec arg5, SecureRandom arg6) {
        ParametersWithRandom v1 = new ParametersWithRandom(McElieceKeysToParams.generatePublicKeyParameter(((PublicKey)arg4)), arg6);
        this.digest.reset();
        this.cipher.init(true, ((CipherParameters)v1));
        this.maxPlainTextSize = this.cipher.maxPlainTextSize;
        this.cipherTextSize = this.cipher.cipherTextSize;
    }

    protected byte[] messageDecrypt(byte[] arg3) {
        byte[] v0;
        try {
            v0 = this.cipher.messageDecrypt(arg3);
        }
        catch(Exception v1) {
            v1.printStackTrace();
        }

        return v0;
    }

    protected byte[] messageEncrypt(byte[] arg3) {
        byte[] v0;
        try {
            v0 = this.cipher.messageEncrypt(arg3);
        }
        catch(Exception v1) {
            v1.printStackTrace();
        }

        return v0;
    }
}

