// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.mceliece;

import java.io.ByteArrayOutputStream;
import java.security.Key;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.asn1.x509.X509ObjectIdentifiers;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2KeyParameters;
import org.bouncycastle.pqc.crypto.mceliece.McEliecePointchevalCipher;
import org.bouncycastle.pqc.jcajce.provider.util.AsymmetricHybridCipher;

public class McEliecePointchevalCipherSpi extends AsymmetricHybridCipher implements PKCSObjectIdentifiers, X509ObjectIdentifiers {
    private ByteArrayOutputStream buf;
    private McEliecePointchevalCipher cipher;
    private Digest digest;

    protected McEliecePointchevalCipherSpi(Digest arg2, McEliecePointchevalCipher arg3) {
        super();
        this.buf = new ByteArrayOutputStream();
        this.digest = arg2;
        this.cipher = arg3;
        this.buf = new ByteArrayOutputStream();
    }

    protected int decryptOutputSize(int arg2) {
        return 0;
    }

    public byte[] doFinal(byte[] arg4, int arg5, int arg6) {
        this.update(arg4, arg5, arg6);
        byte[] v0 = this.buf.toByteArray();
        this.buf.reset();
        if(this.opMode == 1) {
            try {
                return this.cipher.messageEncrypt(v0);
            }
            catch(Exception v0_1) {
                v0_1.printStackTrace();
                return null;
            }
        }

        if(this.opMode == 2) {
            try {
                return this.cipher.messageDecrypt(v0);
            }
            catch(Exception v0_1) {
                v0_1.printStackTrace();
            }
        }

        return null;
    }

    protected int encryptOutputSize(int arg2) {
        return 0;
    }

    public int getKeySize(Key arg3) {
        AsymmetricKeyParameter v0 = (arg3 instanceof PublicKey) ? McElieceCCA2KeysToParams.generatePublicKeyParameter(((PublicKey)arg3)) : McElieceCCA2KeysToParams.generatePrivateKeyParameter(((PrivateKey)arg3));
        return this.cipher.getKeySize(((McElieceCCA2KeyParameters)v0));
    }

    public String getName() {
        return "McEliecePointchevalCipher";
    }

    protected void initCipherDecrypt(Key arg4, AlgorithmParameterSpec arg5) {
        AsymmetricKeyParameter v0 = McElieceCCA2KeysToParams.generatePrivateKeyParameter(((PrivateKey)arg4));
        this.digest.reset();
        this.cipher.init(false, ((CipherParameters)v0));
    }

    protected void initCipherEncrypt(Key arg4, AlgorithmParameterSpec arg5, SecureRandom arg6) {
        ParametersWithRandom v1 = new ParametersWithRandom(McElieceCCA2KeysToParams.generatePublicKeyParameter(((PublicKey)arg4)), arg6);
        this.digest.reset();
        this.cipher.init(true, ((CipherParameters)v1));
    }

    public byte[] messageDecrypt(byte[] arg3) {
        byte[] v0;
        try {
            v0 = this.cipher.messageDecrypt(arg3);
        }
        catch(Exception v1) {
            v1.printStackTrace();
        }

        return v0;
    }

    public byte[] messageEncrypt(byte[] arg3) {
        byte[] v0;
        try {
            v0 = this.cipher.messageEncrypt(arg3);
        }
        catch(Exception v1) {
            v1.printStackTrace();
        }

        return v0;
    }

    public byte[] update(byte[] arg2, int arg3, int arg4) {
        this.buf.write(arg2, arg3, arg4);
        return new byte[0];
    }
}

