// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.rainbow;

import java.io.IOException;
import java.security.PrivateKey;
import java.util.Arrays;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.pqc.asn1.PQCObjectIdentifiers;
import org.bouncycastle.pqc.asn1.RainbowPrivateKey;
import org.bouncycastle.pqc.crypto.rainbow.Layer;
import org.bouncycastle.pqc.crypto.rainbow.RainbowPrivateKeyParameters;
import org.bouncycastle.pqc.crypto.rainbow.util.RainbowUtil;
import org.bouncycastle.pqc.jcajce.spec.RainbowPrivateKeySpec;

public class BCRainbowPrivateKey implements PrivateKey {
    private short[][] A1inv;
    private short[][] A2inv;
    private short[] b1;
    private short[] b2;
    private Layer[] layers;
    private static final long serialVersionUID = 1;
    private int[] vi;

    public BCRainbowPrivateKey(RainbowPrivateKeyParameters arg8) {
        this(arg8.getInvA1(), arg8.getB1(), arg8.getInvA2(), arg8.getB2(), arg8.getVi(), arg8.getLayers());
    }

    public BCRainbowPrivateKey(short[][] arg1, short[] arg2, short[][] arg3, short[] arg4, int[] arg5, Layer[] arg6) {
        super();
        this.A1inv = arg1;
        this.b1 = arg2;
        this.A2inv = arg3;
        this.b2 = arg4;
        this.vi = arg5;
        this.layers = arg6;
    }

    public BCRainbowPrivateKey(RainbowPrivateKeySpec arg8) {
        this(arg8.getInvA1(), arg8.getB1(), arg8.getInvA2(), arg8.getB2(), arg8.getVi(), arg8.getLayers());
    }

    public boolean equals(Object arg6) {
        int v1_1;
        boolean v0 = true;
        boolean v1 = false;
        if(arg6 != null && ((arg6 instanceof BCRainbowPrivateKey))) {
            int v2 = RainbowUtil.equals(this.A1inv, ((BCRainbowPrivateKey)arg6).getInvA1()) ? 1 : 0;
            v2 = v2 == 0 || !RainbowUtil.equals(this.A2inv, ((BCRainbowPrivateKey)arg6).getInvA2()) ? 0 : 1;
            v2 = v2 == 0 || !RainbowUtil.equals(this.b1, ((BCRainbowPrivateKey)arg6).getB1()) ? 0 : 1;
            v2 = v2 == 0 || !RainbowUtil.equals(this.b2, ((BCRainbowPrivateKey)arg6).getB2()) ? 0 : 1;
            if(v2 == 0 || !Arrays.equals(this.vi, ((BCRainbowPrivateKey)arg6).getVi())) {
                v0 = false;
            }

            if(this.layers.length != ((BCRainbowPrivateKey)arg6).getLayers().length) {
                goto label_5;
            }

            v1 = v0;
            int v0_1;
            for(v0_1 = this.layers.length - 1; v0_1 >= 0; --v0_1) {
                v1_1 = v1_1 & this.layers[v0_1].equals(((BCRainbowPrivateKey)arg6).getLayers()[v0_1]);
            }
        }

    label_5:
        return ((boolean)v1_1);
    }

    public final String getAlgorithm() {
        return "Rainbow";
    }

    public short[] getB1() {
        return this.b1;
    }

    public short[] getB2() {
        return this.b2;
    }

    public byte[] getEncoded() {
        byte[] v0_2;
        PrivateKeyInfo v2;
        byte[] v7 = null;
        RainbowPrivateKey v0 = new RainbowPrivateKey(this.A1inv, this.b1, this.A2inv, this.b2, this.vi, this.layers);
        try {
            v2 = new PrivateKeyInfo(new AlgorithmIdentifier(PQCObjectIdentifiers.rainbow, DERNull.INSTANCE), ((ASN1Encodable)v0));
        }
        catch(IOException v0_1) {
            v0_1.printStackTrace();
            v0_2 = v7;
            return v0_2;
        }

        try {
            v0_2 = v2.getEncoded();
        }
        catch(IOException v0_1) {
            v0_1.printStackTrace();
            v0_2 = v7;
        }

        return v0_2;
    }

    public String getFormat() {
        return "PKCS#8";
    }

    public short[][] getInvA1() {
        return this.A1inv;
    }

    public short[][] getInvA2() {
        return this.A2inv;
    }

    public Layer[] getLayers() {
        return this.layers;
    }

    public int[] getVi() {
        return this.vi;
    }

    public int hashCode() {
        int v1 = org.bouncycastle.util.Arrays.hashCode(this.vi) + ((((this.layers.length * 37 + org.bouncycastle.util.Arrays.hashCode(this.A1inv)) * 37 + org.bouncycastle.util.Arrays.hashCode(this.b1)) * 37 + org.bouncycastle.util.Arrays.hashCode(this.A2inv)) * 37 + org.bouncycastle.util.Arrays.hashCode(this.b2)) * 37;
        int v0;
        for(v0 = this.layers.length - 1; v0 >= 0; --v0) {
            v1 = v1 * 37 + this.layers[v0].hashCode();
        }

        return v1;
    }
}

