// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.rainbow;

import java.security.PublicKey;
import org.bouncycastle.asn1.DERNull;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.pqc.asn1.PQCObjectIdentifiers;
import org.bouncycastle.pqc.asn1.RainbowPublicKey;
import org.bouncycastle.pqc.crypto.rainbow.RainbowParameters;
import org.bouncycastle.pqc.crypto.rainbow.RainbowPublicKeyParameters;
import org.bouncycastle.pqc.crypto.rainbow.util.RainbowUtil;
import org.bouncycastle.pqc.jcajce.provider.util.KeyUtil;
import org.bouncycastle.pqc.jcajce.spec.RainbowPublicKeySpec;
import org.bouncycastle.util.Arrays;

public class BCRainbowPublicKey implements PublicKey {
    private short[][] coeffquadratic;
    private short[] coeffscalar;
    private short[][] coeffsingular;
    private int docLength;
    private RainbowParameters rainbowParams;
    private static final long serialVersionUID = 1;

    public BCRainbowPublicKey(int arg1, short[][] arg2, short[][] arg3, short[] arg4) {
        super();
        this.docLength = arg1;
        this.coeffquadratic = arg2;
        this.coeffsingular = arg3;
        this.coeffscalar = arg4;
    }

    public BCRainbowPublicKey(RainbowPublicKeyParameters arg5) {
        this(arg5.getDocLength(), arg5.getCoeffQuadratic(), arg5.getCoeffSingular(), arg5.getCoeffScalar());
    }

    public BCRainbowPublicKey(RainbowPublicKeySpec arg5) {
        this(arg5.getDocLength(), arg5.getCoeffQuadratic(), arg5.getCoeffSingular(), arg5.getCoeffScalar());
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof BCRainbowPublicKey)) && this.docLength == ((BCRainbowPublicKey)arg4).getDocLength() && (RainbowUtil.equals(this.coeffquadratic, ((BCRainbowPublicKey)arg4).getCoeffQuadratic())) && (RainbowUtil.equals(this.coeffsingular, ((BCRainbowPublicKey)arg4).getCoeffSingular())) && (RainbowUtil.equals(this.coeffscalar, ((BCRainbowPublicKey)arg4).getCoeffScalar()))) {
            v0 = true;
        }

        return v0;
    }

    public final String getAlgorithm() {
        return "Rainbow";
    }

    public short[][] getCoeffQuadratic() {
        return this.coeffquadratic;
    }

    public short[] getCoeffScalar() {
        return Arrays.clone(this.coeffscalar);
    }

    public short[][] getCoeffSingular() {
        short[][] v1 = new short[this.coeffsingular.length][];
        int v0;
        for(v0 = 0; v0 != this.coeffsingular.length; ++v0) {
            v1[v0] = Arrays.clone(this.coeffsingular[v0]);
        }

        return v1;
    }

    public int getDocLength() {
        return this.docLength;
    }

    public byte[] getEncoded() {
        return KeyUtil.getEncodedSubjectPublicKeyInfo(new AlgorithmIdentifier(PQCObjectIdentifiers.rainbow, DERNull.INSTANCE), new RainbowPublicKey(this.docLength, this.coeffquadratic, this.coeffsingular, this.coeffscalar));
    }

    public String getFormat() {
        return "X.509";
    }

    public int hashCode() {
        return ((this.docLength * 37 + Arrays.hashCode(this.coeffquadratic)) * 37 + Arrays.hashCode(this.coeffsingular)) * 37 + Arrays.hashCode(this.coeffscalar);
    }
}

