// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.rainbow;

import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactorySpi;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.pkcs.PrivateKeyInfo;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.jcajce.provider.util.AsymmetricKeyInfoConverter;
import org.bouncycastle.pqc.asn1.RainbowPrivateKey;
import org.bouncycastle.pqc.asn1.RainbowPublicKey;
import org.bouncycastle.pqc.jcajce.spec.RainbowPrivateKeySpec;
import org.bouncycastle.pqc.jcajce.spec.RainbowPublicKeySpec;

public class RainbowKeyFactorySpi extends KeyFactorySpi implements AsymmetricKeyInfoConverter {
    public RainbowKeyFactorySpi() {
        super();
    }

    public PrivateKey engineGeneratePrivate(KeySpec arg4) {
        BCRainbowPrivateKey v0;
        if((arg4 instanceof RainbowPrivateKeySpec)) {
            v0 = new BCRainbowPrivateKey(((RainbowPrivateKeySpec)arg4));
        }
        else if((arg4 instanceof PKCS8EncodedKeySpec)) {
            byte[] v0_1 = ((PKCS8EncodedKeySpec)arg4).getEncoded();
            try {
                PrivateKey v0_3 = this.generatePrivate(PrivateKeyInfo.getInstance(ASN1Primitive.fromByteArray(v0_1)));
            }
            catch(Exception v0_2) {
                throw new InvalidKeySpecException(v0_2.toString());
            }
        }
        else {
            goto label_17;
        }

        return ((PrivateKey)v0);
    label_17:
        throw new InvalidKeySpecException("Unsupported key specification: " + arg4.getClass() + ".");
    }

    public PublicKey engineGeneratePublic(KeySpec arg4) {
        PublicKey v0_3;
        if((arg4 instanceof RainbowPublicKeySpec)) {
            BCRainbowPublicKey v0 = new BCRainbowPublicKey(((RainbowPublicKeySpec)arg4));
        }
        else if((arg4 instanceof X509EncodedKeySpec)) {
            byte[] v0_1 = ((X509EncodedKeySpec)arg4).getEncoded();
            try {
                v0_3 = this.generatePublic(SubjectPublicKeyInfo.getInstance(v0_1));
            }
            catch(Exception v0_2) {
                throw new InvalidKeySpecException(v0_2.toString());
            }
        }
        else {
            goto label_16;
        }

        return v0_3;
    label_16:
        throw new InvalidKeySpecException("Unknown key specification: " + arg4 + ".");
    }

    public final KeySpec engineGetKeySpec(Key arg8, Class arg9) {
        RainbowPrivateKeySpec v0_1;
        if((arg8 instanceof BCRainbowPrivateKey)) {
            if(PKCS8EncodedKeySpec.class.isAssignableFrom(arg9)) {
                PKCS8EncodedKeySpec v0 = new PKCS8EncodedKeySpec(arg8.getEncoded());
                goto label_8;
            }
            else if(RainbowPrivateKeySpec.class.isAssignableFrom(arg9)) {
                v0_1 = new RainbowPrivateKeySpec(((BCRainbowPrivateKey)arg8).getInvA1(), ((BCRainbowPrivateKey)arg8).getB1(), ((BCRainbowPrivateKey)arg8).getInvA2(), ((BCRainbowPrivateKey)arg8).getB2(), ((BCRainbowPrivateKey)arg8).getVi(), ((BCRainbowPrivateKey)arg8).getLayers());
                goto label_8;
            }
        }
        else if(!(arg8 instanceof BCRainbowPublicKey)) {
            goto label_40;
        }
        else if(X509EncodedKeySpec.class.isAssignableFrom(arg9)) {
            X509EncodedKeySpec v0_2 = new X509EncodedKeySpec(arg8.getEncoded());
            goto label_8;
        }
        else if(RainbowPublicKeySpec.class.isAssignableFrom(arg9)) {
            RainbowPublicKeySpec v0_3 = new RainbowPublicKeySpec(((BCRainbowPublicKey)arg8).getDocLength(), ((BCRainbowPublicKey)arg8).getCoeffQuadratic(), ((BCRainbowPublicKey)arg8).getCoeffSingular(), ((BCRainbowPublicKey)arg8).getCoeffScalar());
        label_8:
            return ((KeySpec)v0_1);
        }

        throw new InvalidKeySpecException("Unknown key specification: " + arg9 + ".");
    label_40:
        throw new InvalidKeySpecException("Unsupported key type: " + arg8.getClass() + ".");
    }

    public final Key engineTranslateKey(Key arg3) {
        if(!(arg3 instanceof BCRainbowPrivateKey) && !(arg3 instanceof BCRainbowPublicKey)) {
            throw new InvalidKeyException("Unsupported key type");
        }

        return arg3;
    }

    public PrivateKey generatePrivate(PrivateKeyInfo arg8) {
        RainbowPrivateKey v6 = RainbowPrivateKey.getInstance(arg8.parsePrivateKey());
        return new BCRainbowPrivateKey(v6.getInvA1(), v6.getB1(), v6.getInvA2(), v6.getB2(), v6.getVi(), v6.getLayers());
    }

    public PublicKey generatePublic(SubjectPublicKeyInfo arg6) {
        RainbowPublicKey v0 = RainbowPublicKey.getInstance(arg6.parsePublicKey());
        return new BCRainbowPublicKey(v0.getDocLength(), v0.getCoeffQuadratic(), v0.getCoeffSingular(), v0.getCoeffScalar());
    }
}

