// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.rainbow;

import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.pqc.crypto.rainbow.RainbowKeyGenerationParameters;
import org.bouncycastle.pqc.crypto.rainbow.RainbowKeyPairGenerator;
import org.bouncycastle.pqc.crypto.rainbow.RainbowParameters;
import org.bouncycastle.pqc.jcajce.spec.RainbowParameterSpec;

public class RainbowKeyPairGeneratorSpi extends KeyPairGenerator {
    RainbowKeyPairGenerator engine;
    boolean initialised;
    RainbowKeyGenerationParameters param;
    SecureRandom random;
    int strength;

    public RainbowKeyPairGeneratorSpi() {
        super("Rainbow");
        this.engine = new RainbowKeyPairGenerator();
        this.strength = 1024;
        this.random = new SecureRandom();
        this.initialised = false;
    }

    public KeyPair generateKeyPair() {
        if(!this.initialised) {
            this.param = new RainbowKeyGenerationParameters(this.random, new RainbowParameters(new RainbowParameterSpec().getVi()));
            this.engine.init(this.param);
            this.initialised = true;
        }

        AsymmetricCipherKeyPair v1 = this.engine.generateKeyPair();
        return new KeyPair(new BCRainbowPublicKey(v1.getPublic()), new BCRainbowPrivateKey(v1.getPrivate()));
    }

    public void initialize(int arg1, SecureRandom arg2) {
        this.strength = arg1;
        this.random = arg2;
    }

    public void initialize(AlgorithmParameterSpec arg4, SecureRandom arg5) {
        if(!(arg4 instanceof RainbowParameterSpec)) {
            throw new InvalidAlgorithmParameterException("parameter object not a RainbowParameterSpec");
        }

        this.param = new RainbowKeyGenerationParameters(arg5, new RainbowParameters(((RainbowParameterSpec)arg4).getVi()));
        this.engine.init(this.param);
        this.initialised = true;
    }
}

