// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.rainbow;

import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.SignatureException;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.crypto.CipherParameters;
import org.bouncycastle.crypto.Digest;
import org.bouncycastle.crypto.params.AsymmetricKeyParameter;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.pqc.crypto.rainbow.RainbowSigner;

public class SignatureSpi extends java.security.SignatureSpi {
    private Digest digest;
    private SecureRandom random;
    private RainbowSigner signer;

    protected SignatureSpi(Digest arg1, RainbowSigner arg2) {
        super();
        this.digest = arg1;
        this.signer = arg2;
    }

    protected Object engineGetParameter(String arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineInitSign(PrivateKey arg4) {
        AsymmetricKeyParameter v0_1;
        AsymmetricKeyParameter v1 = RainbowKeysToParams.generatePrivateKeyParameter(arg4);
        if(this.random != null) {
            ParametersWithRandom v0 = new ParametersWithRandom(((CipherParameters)v1), this.random);
        }
        else {
            v0_1 = v1;
        }

        this.digest.reset();
        this.signer.init(true, ((CipherParameters)v0_1));
    }

    protected void engineInitSign(PrivateKey arg1, SecureRandom arg2) {
        this.random = arg2;
        this.engineInitSign(arg1);
    }

    protected void engineInitVerify(PublicKey arg4) {
        AsymmetricKeyParameter v0 = RainbowKeysToParams.generatePublicKeyParameter(arg4);
        this.digest.reset();
        this.signer.init(false, ((CipherParameters)v0));
    }

    protected void engineSetParameter(String arg3, Object arg4) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected void engineSetParameter(AlgorithmParameterSpec arg3) {
        throw new UnsupportedOperationException("engineSetParameter unsupported");
    }

    protected byte[] engineSign() {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        try {
            return this.signer.generateSignature(v0);
        }
        catch(Exception v0_1) {
            throw new SignatureException(v0_1.toString());
        }
    }

    protected void engineUpdate(byte arg2) {
        this.digest.update(arg2);
    }

    protected void engineUpdate(byte[] arg2, int arg3, int arg4) {
        this.digest.update(arg2, arg3, arg4);
    }

    protected boolean engineVerify(byte[] arg4) {
        byte[] v0 = new byte[this.digest.getDigestSize()];
        this.digest.doFinal(v0, 0);
        return this.signer.verifySignature(v0, arg4);
    }
}

