// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.util;

import java.io.ByteArrayOutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidParameterException;
import java.security.Key;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.ShortBufferException;

public abstract class AsymmetricBlockCipher extends CipherSpiExt {
    protected ByteArrayOutputStream buf;
    public int cipherTextSize;
    public int maxPlainTextSize;
    protected AlgorithmParameterSpec paramSpec;

    public AsymmetricBlockCipher() {
        super();
        this.buf = new ByteArrayOutputStream();
    }

    protected void checkLength(int arg5) {
        int v0 = this.buf.size() + arg5;
        if(this.opMode == 1) {
            if(v0 > this.maxPlainTextSize) {
                throw new IllegalBlockSizeException("The length of the plaintext (" + v0 + " bytes) is not supported by " + "the cipher (max. " + this.maxPlainTextSize + " bytes).");
            }
        }
        else if(this.opMode == 2 && v0 != this.cipherTextSize) {
            throw new IllegalBlockSizeException("Illegal ciphertext length (expected " + this.cipherTextSize + " bytes, was " + v0 + " bytes).");
        }
    }

    public final int doFinal(byte[] arg4, int arg5, int arg6, byte[] arg7, int arg8) {
        if(arg7.length < this.getOutputSize(arg6)) {
            throw new ShortBufferException("Output buffer too short.");
        }

        byte[] v0 = this.doFinal(arg4, arg5, arg6);
        System.arraycopy(v0, 0, arg7, arg8, v0.length);
        return v0.length;
    }

    public final byte[] doFinal(byte[] arg3, int arg4, int arg5) {
        this.checkLength(arg5);
        this.update(arg3, arg4, arg5);
        byte[] v0 = this.buf.toByteArray();
        this.buf.reset();
        switch(this.opMode) {
            case 1: {
                v0 = this.messageEncrypt(v0);
                break;
            }
            case 2: {
                v0 = this.messageDecrypt(v0);
                break;
            }
            default: {
                v0 = null;
                break;
            }
        }

        return v0;
    }

    public final int getBlockSize() {
        int v0 = this.opMode == 1 ? this.maxPlainTextSize : this.cipherTextSize;
        return v0;
    }

    public final byte[] getIV() {
        return null;
    }

    public final int getOutputSize(int arg3) {
        int v1 = arg3 + this.buf.size();
        int v0 = this.getBlockSize();
        if(v1 > v0) {
            v0 = 0;
        }

        return v0;
    }

    public final AlgorithmParameterSpec getParameters() {
        return this.paramSpec;
    }

    public abstract void initCipherDecrypt(Key arg1, AlgorithmParameterSpec arg2);

    public abstract void initCipherEncrypt(Key arg1, AlgorithmParameterSpec arg2, SecureRandom arg3);

    public final void initDecrypt(Key arg3) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.initDecrypt(arg3, v0);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidParameterException("This cipher needs algorithm parameters for initialization (cannot be null).");
        }
    }

    public final void initDecrypt(Key arg2, AlgorithmParameterSpec arg3) {
        this.opMode = 2;
        this.initCipherDecrypt(arg2, arg3);
    }

    public final void initEncrypt(Key arg3) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.initEncrypt(arg3, v0, new SecureRandom());
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidParameterException("This cipher needs algorithm parameters for initialization (cannot be null).");
        }
    }

    public final void initEncrypt(Key arg2, AlgorithmParameterSpec arg3, SecureRandom arg4) {
        this.opMode = 1;
        this.initCipherEncrypt(arg2, arg3, arg4);
    }

    public final void initEncrypt(Key arg3, SecureRandom arg4) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.initEncrypt(arg3, v0, arg4);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidParameterException("This cipher needs algorithm parameters for initialization (cannot be null).");
        }
    }

    public final void initEncrypt(Key arg2, AlgorithmParameterSpec arg3) {
        this.initEncrypt(arg2, arg3, new SecureRandom());
    }

    public abstract byte[] messageDecrypt(byte[] arg1);

    public abstract byte[] messageEncrypt(byte[] arg1);

    protected final void setMode(String arg1) {
    }

    protected final void setPadding(String arg1) {
    }

    public final byte[] update(byte[] arg2, int arg3, int arg4) {
        if(arg4 != 0) {
            this.buf.write(arg2, arg3, arg4);
        }

        return new byte[0];
    }

    public final int update(byte[] arg2, int arg3, int arg4, byte[] arg5, int arg6) {
        this.update(arg2, arg3, arg4);
        return 0;
    }
}

