// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.provider.util;

import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidParameterException;
import java.security.Key;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.ShortBufferException;

public abstract class AsymmetricHybridCipher extends CipherSpiExt {
    protected AlgorithmParameterSpec paramSpec;

    public AsymmetricHybridCipher() {
        super();
    }

    public abstract int decryptOutputSize(int arg1);

    public final int doFinal(byte[] arg4, int arg5, int arg6, byte[] arg7, int arg8) {
        if(arg7.length < this.getOutputSize(arg6)) {
            throw new ShortBufferException("Output buffer too short.");
        }

        byte[] v0 = this.doFinal(arg4, arg5, arg6);
        System.arraycopy(v0, 0, arg7, arg8, v0.length);
        return v0.length;
    }

    public abstract byte[] doFinal(byte[] arg1, int arg2, int arg3);

    public abstract int encryptOutputSize(int arg1);

    public final int getBlockSize() {
        return 0;
    }

    public final byte[] getIV() {
        return null;
    }

    public final int getOutputSize(int arg3) {
        int v0 = this.opMode == 1 ? this.encryptOutputSize(arg3) : this.decryptOutputSize(arg3);
        return v0;
    }

    public final AlgorithmParameterSpec getParameters() {
        return this.paramSpec;
    }

    public abstract void initCipherDecrypt(Key arg1, AlgorithmParameterSpec arg2);

    public abstract void initCipherEncrypt(Key arg1, AlgorithmParameterSpec arg2, SecureRandom arg3);

    public final void initDecrypt(Key arg3) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.initDecrypt(arg3, v0);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidParameterException("This cipher needs algorithm parameters for initialization (cannot be null).");
        }
    }

    public final void initDecrypt(Key arg2, AlgorithmParameterSpec arg3) {
        this.opMode = 2;
        this.initCipherDecrypt(arg2, arg3);
    }

    public final void initEncrypt(Key arg3) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.initEncrypt(arg3, v0, new SecureRandom());
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidParameterException("This cipher needs algorithm parameters for initialization (cannot be null).");
        }
    }

    public final void initEncrypt(Key arg2, AlgorithmParameterSpec arg3, SecureRandom arg4) {
        this.opMode = 1;
        this.initCipherEncrypt(arg2, arg3, arg4);
    }

    public final void initEncrypt(Key arg3, SecureRandom arg4) {
        AlgorithmParameterSpec v0 = null;
        try {
            this.initEncrypt(arg3, v0, arg4);
            return;
        }
        catch(InvalidAlgorithmParameterException v0_1) {
            throw new InvalidParameterException("This cipher needs algorithm parameters for initialization (cannot be null).");
        }
    }

    public final void initEncrypt(Key arg2, AlgorithmParameterSpec arg3) {
        this.initEncrypt(arg2, arg3, new SecureRandom());
    }

    protected final void setMode(String arg1) {
    }

    protected final void setPadding(String arg1) {
    }

    public final int update(byte[] arg4, int arg5, int arg6, byte[] arg7, int arg8) {
        if(arg7.length < this.getOutputSize(arg6)) {
            throw new ShortBufferException("output");
        }

        byte[] v0 = this.update(arg4, arg5, arg6);
        System.arraycopy(v0, 0, arg7, arg8, v0.length);
        return v0.length;
    }

    public abstract byte[] update(byte[] arg1, int arg2, int arg3);
}

