// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.spec;

import java.security.InvalidParameterException;
import java.security.spec.AlgorithmParameterSpec;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialRingGF2;

public class ECCKeyGenParameterSpec implements AlgorithmParameterSpec {
    public static final int DEFAULT_M = 11;
    public static final int DEFAULT_T = 50;
    private int fieldPoly;
    private int m;
    private int n;
    private int t;

    public ECCKeyGenParameterSpec() {
        this(11, 50);
    }

    public ECCKeyGenParameterSpec(int arg3, int arg4) {
        super();
        if(arg3 < 1) {
            throw new InvalidParameterException("m must be positive");
        }

        if(arg3 > 32) {
            throw new InvalidParameterException("m is too large");
        }

        this.m = arg3;
        this.n = 1 << arg3;
        if(arg4 < 0) {
            throw new InvalidParameterException("t must be positive");
        }

        if(arg4 > this.n) {
            throw new InvalidParameterException("t must be less than n = 2^m");
        }

        this.t = arg4;
        this.fieldPoly = PolynomialRingGF2.getIrreduciblePolynomial(arg3);
    }

    public ECCKeyGenParameterSpec(int arg3) {
        super();
        if(arg3 < 1) {
            throw new InvalidParameterException("key size must be positive");
        }

        this.m = 0;
        this.n = 1;
        while(this.n < arg3) {
            this.n <<= 1;
            ++this.m;
        }

        this.t = this.n >>> 1;
        this.t /= this.m;
        this.fieldPoly = PolynomialRingGF2.getIrreduciblePolynomial(this.m);
    }

    public ECCKeyGenParameterSpec(int arg3, int arg4, int arg5) {
        super();
        this.m = arg3;
        if(arg3 < 1) {
            throw new InvalidParameterException("m must be positive");
        }

        if(arg3 > 32) {
            throw new InvalidParameterException(" m is too large");
        }

        this.n = 1 << arg3;
        this.t = arg4;
        if(arg4 < 0) {
            throw new InvalidParameterException("t must be positive");
        }

        if(arg4 > this.n) {
            throw new InvalidParameterException("t must be less than n = 2^m");
        }

        if(PolynomialRingGF2.degree(arg5) == arg3 && (PolynomialRingGF2.isIrreducible(arg5))) {
            this.fieldPoly = arg5;
            return;
        }

        throw new InvalidParameterException("polynomial is not a field polynomial for GF(2^m)");
    }

    public int getFieldPoly() {
        return this.fieldPoly;
    }

    public int getM() {
        return this.m;
    }

    public int getN() {
        return this.n;
    }

    public int getT() {
        return this.t;
    }
}

