// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.spec;

import java.security.spec.KeySpec;
import java.util.Vector;
import org.bouncycastle.pqc.crypto.gmss.GMSSLeaf;
import org.bouncycastle.pqc.crypto.gmss.GMSSParameters;
import org.bouncycastle.pqc.crypto.gmss.GMSSRootCalc;
import org.bouncycastle.pqc.crypto.gmss.GMSSRootSig;
import org.bouncycastle.pqc.crypto.gmss.Treehash;
import org.bouncycastle.util.Arrays;

public class GMSSPrivateKeySpec implements KeySpec {
    private byte[][][] currentAuthPath;
    private Vector[][] currentRetain;
    private byte[][] currentRootSig;
    private byte[][] currentSeed;
    private Vector[] currentStack;
    private Treehash[][] currentTreehash;
    private GMSSParameters gmssPS;
    private int[] index;
    private byte[][][] keep;
    private int[] minTreehash;
    private byte[][][] nextAuthPath;
    private GMSSLeaf[] nextNextLeaf;
    private GMSSRootCalc[] nextNextRoot;
    private byte[][] nextNextSeed;
    private Vector[][] nextRetain;
    private byte[][] nextRoot;
    private GMSSRootSig[] nextRootSig;
    private Vector[] nextStack;
    private Treehash[][] nextTreehash;
    private GMSSLeaf[] upperLeaf;
    private GMSSLeaf[] upperTreehashLeaf;

    public GMSSPrivateKeySpec(int[] arg2, byte[][] arg3, byte[][] arg4, byte[][][] arg5, byte[][][] arg6, Treehash[][] arg7, Treehash[][] arg8, Vector[] arg9, Vector[] arg10, Vector[][] arg11, Vector[][] arg12, byte[][][] arg13, GMSSLeaf[] arg14, GMSSLeaf[] arg15, GMSSLeaf[] arg16, int[] arg17, byte[][] arg18, GMSSRootCalc[] arg19, byte[][] arg20, GMSSRootSig[] arg21, GMSSParameters arg22) {
        super();
        this.index = arg2;
        this.currentSeed = arg3;
        this.nextNextSeed = arg4;
        this.currentAuthPath = arg5;
        this.nextAuthPath = arg6;
        this.currentTreehash = arg7;
        this.nextTreehash = arg8;
        this.currentStack = arg9;
        this.nextStack = arg10;
        this.currentRetain = arg11;
        this.nextRetain = arg12;
        this.keep = arg13;
        this.nextNextLeaf = arg14;
        this.upperLeaf = arg15;
        this.upperTreehashLeaf = arg16;
        this.minTreehash = arg17;
        this.nextRoot = arg18;
        this.nextNextRoot = arg19;
        this.currentRootSig = arg20;
        this.nextRootSig = arg21;
        this.gmssPS = arg22;
    }

    private static Vector[] clone(Vector[] arg4) {
        Vector[] v0;
        if(arg4 == null) {
            v0 = null;
        }
        else {
            Vector[] v1 = new Vector[arg4.length];
            int v0_1;
            for(v0_1 = 0; v0_1 != arg4.length; ++v0_1) {
                v1[v0_1] = new Vector(arg4[v0_1]);
            }

            v0 = v1;
        }

        return v0;
    }

    private static GMSSLeaf[] clone(GMSSLeaf[] arg3) {
        GMSSLeaf[] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            v0 = new GMSSLeaf[arg3.length];
            System.arraycopy(arg3, 0, v0, 0, arg3.length);
        }

        return v0;
    }

    private static GMSSRootCalc[] clone(GMSSRootCalc[] arg3) {
        GMSSRootCalc[] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            v0 = new GMSSRootCalc[arg3.length];
            System.arraycopy(arg3, 0, v0, 0, arg3.length);
        }

        return v0;
    }

    private static GMSSRootSig[] clone(GMSSRootSig[] arg3) {
        GMSSRootSig[] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            v0 = new GMSSRootSig[arg3.length];
            System.arraycopy(arg3, 0, v0, 0, arg3.length);
        }

        return v0;
    }

    private static Treehash[] clone(Treehash[] arg3) {
        Treehash[] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            v0 = new Treehash[arg3.length];
            System.arraycopy(arg3, 0, v0, 0, arg3.length);
        }

        return v0;
    }

    private static byte[][] clone(byte[][] arg3) {
        byte[][] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            byte[][] v1 = new byte[arg3.length][];
            int v0_1;
            for(v0_1 = 0; v0_1 != arg3.length; ++v0_1) {
                v1[v0_1] = Arrays.clone(arg3[v0_1]);
            }

            v0 = v1;
        }

        return v0;
    }

    private static Vector[][] clone(Vector[][] arg3) {
        Vector[][] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            Vector[][] v1 = new Vector[arg3.length][];
            int v0_1;
            for(v0_1 = 0; v0_1 != arg3.length; ++v0_1) {
                v1[v0_1] = GMSSPrivateKeySpec.clone(arg3[v0_1]);
            }

            v0 = v1;
        }

        return v0;
    }

    private static Treehash[][] clone(Treehash[][] arg3) {
        Treehash[][] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            Treehash[][] v1 = new Treehash[arg3.length][];
            int v0_1;
            for(v0_1 = 0; v0_1 != arg3.length; ++v0_1) {
                v1[v0_1] = GMSSPrivateKeySpec.clone(arg3[v0_1]);
            }

            v0 = v1;
        }

        return v0;
    }

    private static byte[][][] clone(byte[][][] arg3) {
        byte[][][] v0;
        if(arg3 == null) {
            v0 = null;
        }
        else {
            byte[][][] v1 = new byte[arg3.length][][];
            int v0_1;
            for(v0_1 = 0; v0_1 != arg3.length; ++v0_1) {
                v1[v0_1] = GMSSPrivateKeySpec.clone(arg3[v0_1]);
            }

            v0 = v1;
        }

        return v0;
    }

    public byte[][][] getCurrentAuthPath() {
        return GMSSPrivateKeySpec.clone(this.currentAuthPath);
    }

    public Vector[][] getCurrentRetain() {
        return GMSSPrivateKeySpec.clone(this.currentRetain);
    }

    public byte[][] getCurrentRootSig() {
        return GMSSPrivateKeySpec.clone(this.currentRootSig);
    }

    public byte[][] getCurrentSeed() {
        return GMSSPrivateKeySpec.clone(this.currentSeed);
    }

    public Vector[] getCurrentStack() {
        return GMSSPrivateKeySpec.clone(this.currentStack);
    }

    public Treehash[][] getCurrentTreehash() {
        return GMSSPrivateKeySpec.clone(this.currentTreehash);
    }

    public GMSSParameters getGmssPS() {
        return this.gmssPS;
    }

    public int[] getIndex() {
        return Arrays.clone(this.index);
    }

    public byte[][][] getKeep() {
        return GMSSPrivateKeySpec.clone(this.keep);
    }

    public int[] getMinTreehash() {
        return Arrays.clone(this.minTreehash);
    }

    public byte[][][] getNextAuthPath() {
        return GMSSPrivateKeySpec.clone(this.nextAuthPath);
    }

    public GMSSLeaf[] getNextNextLeaf() {
        return GMSSPrivateKeySpec.clone(this.nextNextLeaf);
    }

    public GMSSRootCalc[] getNextNextRoot() {
        return GMSSPrivateKeySpec.clone(this.nextNextRoot);
    }

    public byte[][] getNextNextSeed() {
        return GMSSPrivateKeySpec.clone(this.nextNextSeed);
    }

    public Vector[][] getNextRetain() {
        return GMSSPrivateKeySpec.clone(this.nextRetain);
    }

    public byte[][] getNextRoot() {
        return GMSSPrivateKeySpec.clone(this.nextRoot);
    }

    public GMSSRootSig[] getNextRootSig() {
        return GMSSPrivateKeySpec.clone(this.nextRootSig);
    }

    public Vector[] getNextStack() {
        return GMSSPrivateKeySpec.clone(this.nextStack);
    }

    public Treehash[][] getNextTreehash() {
        return GMSSPrivateKeySpec.clone(this.nextTreehash);
    }

    public GMSSLeaf[] getUpperLeaf() {
        return GMSSPrivateKeySpec.clone(this.upperLeaf);
    }

    public GMSSLeaf[] getUpperTreehashLeaf() {
        return GMSSPrivateKeySpec.clone(this.upperTreehashLeaf);
    }
}

