// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.jcajce.spec;

import java.security.spec.KeySpec;
import org.bouncycastle.pqc.math.linearalgebra.GF2Matrix;
import org.bouncycastle.pqc.math.linearalgebra.GF2mField;
import org.bouncycastle.pqc.math.linearalgebra.Permutation;
import org.bouncycastle.pqc.math.linearalgebra.PolynomialGF2mSmallM;

public class McEliecePrivateKeySpec implements KeySpec {
    private GF2mField field;
    private PolynomialGF2mSmallM goppaPoly;
    private GF2Matrix h;
    private int k;
    private int n;
    private String oid;
    private Permutation p1;
    private Permutation p2;
    private PolynomialGF2mSmallM[] qInv;
    private GF2Matrix sInv;

    public McEliecePrivateKeySpec(String arg6, int arg7, int arg8, byte[] arg9, byte[] arg10, byte[] arg11, byte[] arg12, byte[] arg13, byte[] arg14, byte[][] arg15) {
        super();
        this.oid = arg6;
        this.n = arg7;
        this.k = arg8;
        this.field = new GF2mField(arg9);
        this.goppaPoly = new PolynomialGF2mSmallM(this.field, arg10);
        this.sInv = new GF2Matrix(arg11);
        this.p1 = new Permutation(arg12);
        this.p2 = new Permutation(arg13);
        this.h = new GF2Matrix(arg14);
        this.qInv = new PolynomialGF2mSmallM[arg15.length];
        int v0;
        for(v0 = 0; v0 < arg15.length; ++v0) {
            this.qInv[v0] = new PolynomialGF2mSmallM(this.field, arg15[v0]);
        }
    }

    public McEliecePrivateKeySpec(String arg1, int arg2, int arg3, GF2mField arg4, PolynomialGF2mSmallM arg5, GF2Matrix arg6, Permutation arg7, Permutation arg8, GF2Matrix arg9, PolynomialGF2mSmallM[] arg10) {
        super();
        this.oid = arg1;
        this.k = arg3;
        this.n = arg2;
        this.field = arg4;
        this.goppaPoly = arg5;
        this.sInv = arg6;
        this.p1 = arg7;
        this.p2 = arg8;
        this.h = arg9;
        this.qInv = arg10;
    }

    public GF2mField getField() {
        return this.field;
    }

    public PolynomialGF2mSmallM getGoppaPoly() {
        return this.goppaPoly;
    }

    public GF2Matrix getH() {
        return this.h;
    }

    public int getK() {
        return this.k;
    }

    public int getN() {
        return this.n;
    }

    public String getOIDString() {
        return this.oid;
    }

    public Permutation getP1() {
        return this.p1;
    }

    public Permutation getP2() {
        return this.p2;
    }

    public PolynomialGF2mSmallM[] getQInv() {
        return this.qInv;
    }

    public GF2Matrix getSInv() {
        return this.sInv;
    }
}

