// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.security.SecureRandom;

public class GF2Matrix extends Matrix {
    private int length;
    private int[][] matrix;

    public GF2Matrix(byte[] arg10) {
        super();
        if(arg10.length < 9) {
            throw new ArithmeticException("given array is not an encoded matrix over GF(2)");
        }

        this.numRows = LittleEndianConversions.OS2IP(arg10, 0);
        this.numColumns = LittleEndianConversions.OS2IP(arg10, 4);
        int v0 = (this.numColumns + 7 >>> 3) * this.numRows;
        if(this.numRows > 0 && v0 == arg10.length - 8) {
            this.length = this.numColumns + 31 >>> 5;
            this.matrix = new int[this.numRows][this.length];
            int v5 = this.numColumns >> 5;
            int v6 = this.numColumns & 31;
            int v2 = 8;
            for(v0 = 0; v0 < this.numRows; ++v0) {
                int v3 = 0;
                while(v3 < v5) {
                    this.matrix[v0][v3] = LittleEndianConversions.OS2IP(arg10, v2);
                    ++v3;
                    v2 += 4;
                }

                v3 = 0;
                while(v3 < v6) {
                    this.matrix[v0][v5] ^= (arg10[v2] & 255) << v3;
                    v3 += 8;
                    ++v2;
                }
            }

            return;
        }

        throw new ArithmeticException("given array is not an encoded matrix over GF(2)");
    }

    public GF2Matrix(GF2Matrix arg4) {
        super();
        this.numColumns = arg4.getNumColumns();
        this.numRows = arg4.getNumRows();
        this.length = arg4.length;
        this.matrix = new int[arg4.matrix.length][];
        int v0;
        for(v0 = 0; v0 < this.matrix.length; ++v0) {
            this.matrix[v0] = IntUtils.clone(arg4.matrix[v0]);
        }
    }

    public GF2Matrix(int arg2, char arg3) {
        this(arg2, arg3, new SecureRandom());
    }

    public GF2Matrix(int arg3, char arg4, SecureRandom arg5) {
        super();
        if(arg3 <= 0) {
            throw new ArithmeticException("Size of matrix is non-positive.");
        }

        switch(arg4) {
            case 73: {
                goto label_13;
            }
            case 76: {
                goto label_15;
            }
            case 82: {
                goto label_19;
            }
            case 85: {
                goto label_17;
            }
            case 90: {
                goto label_11;
            }
        }

        throw new ArithmeticException("Unknown matrix type.");
    label_19:
        this.assignRandomRegularMatrix(arg3, arg5);
        return;
    label_17:
        this.assignRandomUpperTriangularMatrix(arg3, arg5);
        return;
    label_11:
        this.assignZeroMatrix(arg3, arg3);
        return;
    label_15:
        this.assignRandomLowerTriangularMatrix(arg3, arg5);
        return;
    label_13:
        this.assignUnitMatrix(arg3);
    }

    private GF2Matrix(int arg3, int arg4) {
        super();
        if(arg4 > 0 && arg3 > 0) {
            this.assignZeroMatrix(arg3, arg4);
            return;
        }

        throw new ArithmeticException("size of matrix is non-positive");
    }

    public GF2Matrix(int arg6, int[][] arg7) {
        int v1 = 0;
        super();
        if(arg7[0].length != arg6 + 31 >> 5) {
            throw new ArithmeticException("Int array does not match given number of columns.");
        }

        this.numColumns = arg6;
        this.numRows = arg7.length;
        this.length = arg7[0].length;
        int v0 = arg6 & 31;
        v0 = v0 == 0 ? -1 : (1 << v0) - 1;
        while(v1 < this.numRows) {
            int[] v2 = arg7[v1];
            int v3 = this.length - 1;
            v2[v3] &= v0;
            ++v1;
        }

        this.matrix = arg7;
    }

    private static void addToRow(int[] arg3, int[] arg4, int arg5) {
        int v0;
        for(v0 = arg4.length - 1; v0 >= arg5; --v0) {
            arg4[v0] ^= arg3[v0];
        }
    }

    private void assignRandomLowerTriangularMatrix(int arg9, SecureRandom arg10) {
        this.numRows = arg9;
        this.numColumns = arg9;
        this.length = arg9 + 31 >>> 5;
        this.matrix = new int[this.numRows][this.length];
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v3 = v0 >>> 5;
            int v2 = v0 & 31;
            int v4 = 31 - v2;
            int v5 = 1 << v2;
            for(v2 = 0; v2 < v3; ++v2) {
                this.matrix[v0][v2] = arg10.nextInt();
            }

            this.matrix[v0][v3] = arg10.nextInt() >>> v4 | v5;
            for(v2 = v3 + 1; v2 < this.length; ++v2) {
                this.matrix[v0][v2] = 0;
            }
        }
    }

    private void assignRandomRegularMatrix(int arg8, SecureRandom arg9) {
        this.numRows = arg8;
        this.numColumns = arg8;
        this.length = arg8 + 31 >>> 5;
        this.matrix = new int[this.numRows][this.length];
        Matrix v0 = new GF2Matrix(arg8, 'L', arg9).rightMultiply(new GF2Matrix(arg8, 'U', arg9));
        int[] v3 = new Permutation(arg8, arg9).getVector();
        int v1;
        for(v1 = 0; v1 < arg8; ++v1) {
            System.arraycopy(((GF2Matrix)v0).matrix[v1], 0, this.matrix[v3[v1]], 0, this.length);
        }
    }

    private void assignRandomUpperTriangularMatrix(int arg10, SecureRandom arg11) {
        this.numRows = arg10;
        this.numColumns = arg10;
        this.length = arg10 + 31 >>> 5;
        this.matrix = new int[this.numRows][this.length];
        int v0 = arg10 & 31;
        v0 = v0 == 0 ? -1 : (1 << v0) - 1;
        int v1;
        for(v1 = 0; v1 < this.numRows; ++v1) {
            int v4 = v1 >>> 5;
            int v5 = v1 & 31;
            int v6 = 1 << v5;
            int v3;
            for(v3 = 0; v3 < v4; ++v3) {
                this.matrix[v1][v3] = 0;
            }

            this.matrix[v1][v4] = arg11.nextInt() << v5 | v6;
            for(v3 = v4 + 1; v3 < this.length; ++v3) {
                this.matrix[v1][v3] = arg11.nextInt();
            }

            int[] v3_1 = this.matrix[v1];
            v4 = this.length - 1;
            v3_1[v4] &= v0;
        }
    }

    private void assignUnitMatrix(int arg6) {
        int v1 = 0;
        this.numRows = arg6;
        this.numColumns = arg6;
        this.length = arg6 + 31 >>> 5;
        this.matrix = new int[this.numRows][this.length];
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v2;
            for(v2 = 0; v2 < this.length; ++v2) {
                this.matrix[v0][v2] = 0;
            }
        }

        while(v1 < this.numRows) {
            this.matrix[v1][v1 >>> 5] = 1 << (v1 & 31);
            ++v1;
        }
    }

    private void assignZeroMatrix(int arg5, int arg6) {
        this.numRows = arg5;
        this.numColumns = arg6;
        this.length = arg6 + 31 >>> 5;
        this.matrix = new int[this.numRows][this.length];
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v2;
            for(v2 = 0; v2 < this.length; ++v2) {
                this.matrix[v0][v2] = 0;
            }
        }
    }

    public Matrix computeInverse() {
        int v4;
        if(this.numRows != this.numColumns) {
            throw new ArithmeticException("Matrix is not invertible.");
        }

        Object v0 = new int[this.numRows][this.length];
        int v1;
        for(v1 = this.numRows - 1; v1 >= 0; --v1) {
            v0[v1] = IntUtils.clone(this.matrix[v1]);
        }

        Object v1_1 = new int[this.numRows][this.length];
        int v2;
        for(v2 = this.numRows - 1; v2 >= 0; --v2) {
            v1_1[v2][v2 >> 5] = 1 << (v2 & 31);
        }

        for(v2 = 0; v2 < this.numRows; ++v2) {
            int v7 = v2 >> 5;
            int v8 = 1 << (v2 & 31);
            if((v0[v2][v7] & v8) == 0) {
                v4 = v2 + 1;
                int v5 = 0;
                while(v4 < this.numRows) {
                    if((v0[v4][v7] & v8) != 0) {
                        GF2Matrix.swapRows(((int[][])v0), v2, v4);
                        GF2Matrix.swapRows(((int[][])v1_1), v2, v4);
                        v4 = this.numRows;
                        v5 = 1;
                    }

                    ++v4;
                }

                if(v5 != 0) {
                    goto label_67;
                }

                throw new ArithmeticException("Matrix is not invertible.");
            }

        label_67:
            for(v4 = this.numRows - 1; v4 >= 0; --v4) {
                if(v4 != v2 && (v0[v4][v7] & v8) != 0) {
                    GF2Matrix.addToRow(v0[v2], v0[v4], v7);
                    GF2Matrix.addToRow(v1_1[v2], v1_1[v4], 0);
                }
            }
        }

        return new GF2Matrix(this.numColumns, ((int[][])v1_1));
    }

    public Matrix computeTranspose() {
        Object v0 = new int[this.numColumns][this.numRows + 31 >>> 5];
        int v1;
        for(v1 = 0; v1 < this.numRows; ++v1) {
            int v3;
            for(v3 = 0; v3 < this.numColumns; ++v3) {
                int v5 = v1 >>> 5;
                int v6 = v1 & 31;
                if((this.matrix[v1][v3 >>> 5] >>> (v3 & 31) & 1) == 1) {
                    v0[v3][v5] |= 1 << v6;
                }
            }
        }

        return new GF2Matrix(this.numRows, ((int[][])v0));
    }

    public static GF2Matrix[] createRandomRegularMatrixAndItsInverse(int arg14, SecureRandom arg15) {
        int v10;
        GF2Matrix[] v4 = new GF2Matrix[2];
        int v5 = arg14 + 31 >> 5;
        GF2Matrix v3 = new GF2Matrix(arg14, 'L', arg15);
        GF2Matrix v6 = new GF2Matrix(arg14, 'U', arg15);
        Matrix v0 = v3.rightMultiply(((Matrix)v6));
        Permutation v7 = new Permutation(arg14, arg15);
        int[] v8 = v7.getVector();
        Object v1 = new int[arg14][v5];
        int v2;
        for(v2 = 0; v2 < arg14; ++v2) {
            System.arraycopy(((GF2Matrix)v0).matrix[v8[v2]], 0, v1[v2], 0, v5);
        }

        v4[0] = new GF2Matrix(arg14, ((int[][])v1));
        GF2Matrix v8_1 = new GF2Matrix(arg14, 'I');
        for(v2 = 0; v2 < arg14; ++v2) {
            int v9 = v2 >>> 5;
            v10 = 1 << (v2 & 31);
            int v1_1;
            for(v1_1 = v2 + 1; v1_1 < arg14; ++v1_1) {
                if((v3.matrix[v1_1][v9] & v10) != 0) {
                    int v0_1;
                    for(v0_1 = 0; v0_1 <= v9; ++v0_1) {
                        v8_1.matrix[v1_1][v0_1] ^= v8_1.matrix[v2][v0_1];
                    }
                }
            }
        }

        GF2Matrix v9_1 = new GF2Matrix(arg14, 'I');
        int v3_1;
        for(v3_1 = arg14 - 1; v3_1 >= 0; --v3_1) {
            v1_1 = v3_1 >>> 5;
            v10 = 1 << (v3_1 & 31);
            for(v2 = v3_1 - 1; v2 >= 0; --v2) {
                if((v6.matrix[v2][v1_1] & v10) != 0) {
                    for(v0_1 = v1_1; v0_1 < v5; ++v0_1) {
                        v9_1.matrix[v2][v0_1] ^= v9_1.matrix[v3_1][v0_1];
                    }
                }
            }
        }

        v4[1] = v9_1.rightMultiply(v8_1.rightMultiply(v7));
        return v4;
    }

    public boolean equals(Object arg5) {
        boolean v1 = false;
        if(((arg5 instanceof GF2Matrix)) && this.numRows == ((GF2Matrix)arg5).numRows && this.numColumns == ((GF2Matrix)arg5).numColumns && this.length == ((GF2Matrix)arg5).length) {
            int v0 = 0;
            while(true) {
                if(v0 >= this.numRows) {
                    break;
                }
                else if(IntUtils.equals(this.matrix[v0], ((GF2Matrix)arg5).matrix[v0])) {
                    ++v0;
                    continue;
                }

                return v1;
            }

            v1 = true;
        }

        return v1;
    }

    public GF2Matrix extendLeftCompactForm() {
        GF2Matrix v2 = new GF2Matrix(this.numRows, this.numColumns + this.numRows);
        int v1 = this.numColumns + (this.numRows - 1);
        int v0 = this.numRows - 1;
        while(v0 >= 0) {
            System.arraycopy(this.matrix[v0], 0, v2.matrix[v0], 0, this.length);
            int v4 = v1 >> 5;
            v2.matrix[v0][v4] |= 1 << (v1 & 31);
            --v0;
            --v1;
        }

        return v2;
    }

    public GF2Matrix extendRightCompactForm() {
        int v8;
        GF2Matrix v6 = new GF2Matrix(this.numRows, this.numRows + this.numColumns);
        int v3 = this.numRows >> 5;
        int v7 = this.numRows & 31;
        int v5;
        for(v5 = this.numRows - 1; v5 >= 0; --v5) {
            int v2 = v5 >> 5;
            v6.matrix[v5][v2] |= 1 << (v5 & 31);
            if(v7 != 0) {
                int v0 = 0;
                for(v2 = v3; v0 < this.length - 1; v2 = v4) {
                    v8 = this.matrix[v5][v0];
                    int v4 = v2 + 1;
                    v6.matrix[v5][v2] |= v8 << v7;
                    v6.matrix[v5][v4] |= v8 >>> 32 - v7;
                    ++v0;
                }

                v0 = this.matrix[v5][this.length - 1];
                v8 = v2 + 1;
                v6.matrix[v5][v2] |= v0 << v7;
                if(v8 < v6.length) {
                    v6.matrix[v5][v8] |= v0 >>> 32 - v7;
                }
            }
            else {
                System.arraycopy(this.matrix[v5], 0, v6.matrix[v5], v3, this.length);
            }
        }

        return v6;
    }

    public byte[] getEncoded() {
        byte[] v5 = new byte[(this.numColumns + 7 >>> 3) * this.numRows + 8];
        LittleEndianConversions.I2OSP(this.numRows, v5, 0);
        LittleEndianConversions.I2OSP(this.numColumns, v5, 4);
        int v6 = this.numColumns >>> 5;
        int v7 = this.numColumns & 31;
        int v2 = 8;
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v3 = 0;
            while(v3 < v6) {
                LittleEndianConversions.I2OSP(this.matrix[v0][v3], v5, v2);
                ++v3;
                v2 += 4;
            }

            v3 = 0;
            while(v3 < v7) {
                v5[v2] = ((byte)(this.matrix[v0][v6] >>> v3 & 255));
                v3 += 8;
                ++v2;
            }
        }

        return v5;
    }

    public double getHammingWeight() {
        double v5 = 0;
        double v3 = 0;
        int v10 = this.numColumns & 31;
        int v1 = v10 == 0 ? this.length : this.length - 1;
        int v2;
        for(v2 = 0; v2 < this.numRows; ++v2) {
            int v8 = 0;
            double v6 = v5;
            double v4 = v3;
            while(v8 < v1) {
                int v9 = this.matrix[v2][v8];
                int v3_1;
                for(v3_1 = 0; v3_1 < 32; ++v3_1) {
                    v6 += ((double)(v9 >>> v3_1 & 1));
                    ++v4;
                }

                ++v8;
            }

            int v11 = this.matrix[v2][this.length - 1];
            v3 = v4;
            v5 = v6;
            int v7 = 0;
            while(v7 < v10) {
                double v8_1 = (((double)(v11 >>> v7 & 1))) + v5;
                ++v7;
                ++v3;
                v5 = v8_1;
            }
        }

        return v5 / v3;
    }

    public int[][] getIntArray() {
        return this.matrix;
    }

    public GF2Matrix getLeftSubMatrix() {
        if(this.numColumns <= this.numRows) {
            throw new ArithmeticException("empty submatrix");
        }

        int v3 = this.numRows + 31 >> 5;
        Object v0 = new int[this.numRows][v3];
        int v1 = (1 << (this.numRows & 31)) - 1;
        if(v1 == 0) {
            v1 = -1;
        }

        int v2;
        for(v2 = this.numRows - 1; v2 >= 0; --v2) {
            System.arraycopy(this.matrix[v2], 0, v0[v2], 0, v3);
            int v5 = v3 - 1;
            v0[v2][v5] &= v1;
        }

        return new GF2Matrix(this.numRows, ((int[][])v0));
    }

    public int getLength() {
        return this.length;
    }

    public GF2Matrix getRightSubMatrix() {
        if(this.numColumns <= this.numRows) {
            throw new ArithmeticException("empty submatrix");
        }

        int v3 = this.numRows >> 5;
        int v6 = this.numRows & 31;
        GF2Matrix v7 = new GF2Matrix(this.numRows, this.numColumns - this.numRows);
        int v5;
        for(v5 = this.numRows - 1; v5 >= 0; --v5) {
            if(v6 != 0) {
                int v0 = 0;
                int v2;
                for(v2 = v3; v0 < v7.length - 1; v2 = v4) {
                    int v4 = v2 + 1;
                    v7.matrix[v5][v0] = this.matrix[v5][v2] >>> v6 | this.matrix[v5][v4] << 32 - v6;
                    ++v0;
                }

                int v9 = v2 + 1;
                v7.matrix[v5][v7.length - 1] = this.matrix[v5][v2] >>> v6;
                if(v9 < this.length) {
                    int[] v0_1 = v7.matrix[v5];
                    v2 = v7.length - 1;
                    v0_1[v2] |= this.matrix[v5][v9] << 32 - v6;
                }
            }
            else {
                System.arraycopy(this.matrix[v5], v3, v7.matrix[v5], 0, v7.length);
            }
        }

        return v7;
    }

    public int[] getRow(int arg2) {
        return this.matrix[arg2];
    }

    public int hashCode() {
        int v1 = this.length + (this.numRows * 31 + this.numColumns) * 31;
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            v1 = v1 * 31 + this.matrix[v0].hashCode();
        }

        return v1;
    }

    public boolean isZero() {
        boolean v1 = false;
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v2 = 0;
            while(true) {
                if(v2 >= this.length) {
                    break;
                }
                else if(this.matrix[v0][v2] == 0) {
                    ++v2;
                    continue;
                }

                return v1;
            }
        }

        return true;
    }

    public Vector leftMultiply(Vector arg13) {
        int v2;
        int v1 = 1;
        if(!(arg13 instanceof GF2Vector)) {
            throw new ArithmeticException("vector is not defined over GF(2)");
        }

        if(arg13.length != this.numRows) {
            throw new ArithmeticException("length mismatch");
        }

        int[] v6 = ((GF2Vector)arg13).getVecArray();
        int[] v7 = new int[this.length];
        int v8 = this.numRows >> 5;
        int v9 = 1 << (this.numRows & 31);
        int v5 = 0;
        int v0;
        for(v0 = 0; v5 < v8; v0 = v2) {
            v2 = v0;
            v0 = 1;
            do {
                if((v6[v5] & v0) != 0) {
                    int v3;
                    for(v3 = 0; v3 < this.length; ++v3) {
                        v7[v3] ^= this.matrix[v2][v3];
                    }
                }

                ++v2;
                v0 <<= 1;
            }
            while(v0 != 0);

            ++v5;
        }

        for(v2 = v0; v1 != v9; ++v2) {
            if((v6[v8] & v1) != 0) {
                for(v0 = 0; v0 < this.length; ++v0) {
                    v7[v0] ^= this.matrix[v2][v0];
                }
            }

            v1 <<= 1;
        }

        return new GF2Vector(v7, this.numColumns);
    }

    public Matrix leftMultiply(Permutation arg6) {
        int[] v1 = arg6.getVector();
        if(v1.length != this.numRows) {
            throw new ArithmeticException("length mismatch");
        }

        int[][] v2 = new int[this.numRows][];
        int v0;
        for(v0 = this.numRows - 1; v0 >= 0; --v0) {
            v2[v0] = IntUtils.clone(this.matrix[v1[v0]]);
        }

        return new GF2Matrix(this.numRows, v2);
    }

    public Vector leftMultiplyLeftCompactForm(Vector arg12) {
        int v2;
        if(!(arg12 instanceof GF2Vector)) {
            throw new ArithmeticException("vector is not defined over GF(2)");
        }

        if(arg12.length != this.numRows) {
            throw new ArithmeticException("length mismatch");
        }

        int[] v6 = ((GF2Vector)arg12).getVecArray();
        int[] v7 = new int[this.numRows + this.numColumns + 31 >>> 5];
        int v8 = this.numRows >>> 5;
        int v5 = 0;
        int v0;
        for(v0 = 0; v5 < v8; v0 = v2) {
            v2 = v0;
            v0 = 1;
            do {
                if((v6[v5] & v0) != 0) {
                    int v3;
                    for(v3 = 0; v3 < this.length; ++v3) {
                        v7[v3] ^= this.matrix[v2][v3];
                    }

                    v3 = this.numColumns + v2 >>> 5;
                    v7[v3] |= 1 << (this.numColumns + v2 & 31);
                }

                ++v2;
                v0 <<= 1;
            }
            while(v0 != 0);

            ++v5;
        }

        v5 = 1 << (this.numRows & 31);
        v2 = 1;
        v3 = v0;
        while(v2 != v5) {
            if((v6[v8] & v2) != 0) {
                for(v0 = 0; v0 < this.length; ++v0) {
                    v7[v0] ^= this.matrix[v3][v0];
                }

                v0 = this.numColumns + v3 >>> 5;
                v7[v0] |= 1 << (this.numColumns + v3 & 31);
            }

            ++v3;
            v2 <<= 1;
        }

        return new GF2Vector(v7, this.numRows + this.numColumns);
    }

    public Vector rightMultiply(Vector arg10) {
        if(!(arg10 instanceof GF2Vector)) {
            throw new ArithmeticException("vector is not defined over GF(2)");
        }

        if(arg10.length != this.numColumns) {
            throw new ArithmeticException("length mismatch");
        }

        int[] v5 = ((GF2Vector)arg10).getVecArray();
        int[] v6 = new int[this.numRows + 31 >>> 5];
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v2 = 0;
            int v3 = 0;
            while(v2 < this.length) {
                v3 ^= this.matrix[v0][v2] & v5[v2];
                ++v2;
            }

            v2 = 0;
            int v4 = 0;
            while(v2 < 32) {
                v4 ^= v3 >>> v2 & 1;
                ++v2;
            }

            if(v4 == 1) {
                v2 = v0 >>> 5;
                v6[v2] |= 1 << (v0 & 31);
            }
        }

        return new GF2Vector(v6, this.numRows);
    }

    public Matrix rightMultiply(Permutation arg12) {
        int[] v2 = arg12.getVector();
        if(v2.length != this.numColumns) {
            throw new ArithmeticException("length mismatch");
        }

        GF2Matrix v3 = new GF2Matrix(this.numRows, this.numColumns);
        int v1;
        for(v1 = this.numColumns - 1; v1 >= 0; --v1) {
            int v4 = v1 >>> 5;
            int v5 = v1 & 31;
            int v6 = v2[v1] >>> 5;
            int v7 = v2[v1] & 31;
            int v0;
            for(v0 = this.numRows - 1; v0 >= 0; --v0) {
                v3.matrix[v0][v4] |= (this.matrix[v0][v6] >>> v7 & 1) << v5;
            }
        }

        return ((Matrix)v3);
    }

    public Matrix rightMultiply(Matrix arg14) {
        int v5;
        if(!(arg14 instanceof GF2Matrix)) {
            throw new ArithmeticException("matrix is not defined over GF(2)");
        }

        if(arg14.numRows != this.numColumns) {
            throw new ArithmeticException("length mismatch");
        }

        Matrix v0 = arg14;
        GF2Matrix v7 = new GF2Matrix(this.numRows, arg14.numColumns);
        int v8 = this.numColumns & 31;
        int v1 = v8 == 0 ? this.length : this.length - 1;
        int v2;
        for(v2 = 0; v2 < this.numRows; ++v2) {
            int v4 = 0;
            int v6 = 0;
            while(v6 < v1) {
                int v9 = this.matrix[v2][v6];
                v5 = v4;
                for(v4 = 0; v4 < 32; ++v4) {
                    if((1 << v4 & v9) != 0) {
                        int v3;
                        for(v3 = 0; v3 < ((GF2Matrix)v0).length; ++v3) {
                            v7.matrix[v2][v3] ^= ((GF2Matrix)v0).matrix[v5][v3];
                        }
                    }

                    ++v5;
                }

                ++v6;
                v4 = v5;
            }

            v6 = this.matrix[v2][this.length - 1];
            v5 = v4;
            for(v4 = 0; v4 < v8; ++v4) {
                if((1 << v4 & v6) != 0) {
                    for(v3 = 0; v3 < ((GF2Matrix)v0).length; ++v3) {
                        v7.matrix[v2][v3] ^= ((GF2Matrix)v0).matrix[v5][v3];
                    }
                }

                ++v5;
            }
        }

        return ((Matrix)v7);
    }

    public Vector rightMultiplyRightCompactForm(Vector arg14) {
        int v5;
        int v6;
        int v3;
        if(!(arg14 instanceof GF2Vector)) {
            throw new ArithmeticException("vector is not defined over GF(2)");
        }

        if(arg14.length != this.numColumns + this.numRows) {
            throw new ArithmeticException("length mismatch");
        }

        int[] v7 = ((GF2Vector)arg14).getVecArray();
        int[] v8 = new int[this.numRows + 31 >>> 5];
        int v4 = this.numRows >> 5;
        int v9 = this.numRows & 31;
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v2 = v7[v0 >> 5] >>> (v0 & 31) & 1;
            if(v9 != 0) {
                v3 = v4;
                v6 = v2;
                v2 = 0;
                while(v2 < this.length - 1) {
                    v5 = v3 + 1;
                    v3 = (v7[v3] >>> v9 | v7[v5] << 32 - v9) & this.matrix[v0][v2] ^ v6;
                    ++v2;
                    v6 = v3;
                    v3 = v5;
                }

                v5 = v3 + 1;
                v2 = v7[v3] >>> v9;
                if(v5 < v7.length) {
                    v2 |= v7[v5] << 32 - v9;
                }

                v6 ^= v2 & this.matrix[v0][this.length - 1];
            }
            else {
                v3 = v4;
                v6 = v2;
                v2 = 0;
                while(v2 < this.length) {
                    int v10 = this.matrix[v0][v2];
                    ++v2;
                    v6 ^= v7[v3] & v10;
                    ++v3;
                }
            }

            v2 = 0;
            v3 = 0;
            while(v2 < 32) {
                v3 ^= v6 & 1;
                v6 >>>= 1;
                ++v2;
            }

            if(v3 == 1) {
                v2 = v0 >> 5;
                v8[v2] |= 1 << (v0 & 31);
            }
        }

        return new GF2Vector(v8, this.numRows);
    }

    private static void swapRows(int[][] arg2, int arg3, int arg4) {
        int[] v0 = arg2[arg3];
        arg2[arg3] = arg2[arg4];
        arg2[arg4] = v0;
    }

    public String toString() {
        char v11 = '1';
        char v10 = '0';
        char v9 = ' ';
        int v5 = this.numColumns & 31;
        int v0 = v5 == 0 ? this.length : this.length - 1;
        StringBuffer v6 = new StringBuffer();
        int v1;
        for(v1 = 0; v1 < this.numRows; ++v1) {
            v6.append(v1 + ": ");
            int v4;
            for(v4 = 0; v4 < v0; ++v4) {
                int v7 = this.matrix[v1][v4];
                int v3;
                for(v3 = 0; v3 < v9; ++v3) {
                    if((v7 >>> v3 & 1) == 0) {
                        v6.append(v10);
                    }
                    else {
                        v6.append(v11);
                    }
                }

                v6.append(v9);
            }

            v4 = this.matrix[v1][this.length - 1];
            for(v3 = 0; v3 < v5; ++v3) {
                if((v4 >>> v3 & 1) == 0) {
                    v6.append(v10);
                }
                else {
                    v6.append(v11);
                }
            }

            v6.append('\n');
        }

        return v6.toString();
    }
}

