// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.security.SecureRandom;

public class GF2Vector extends Vector {
    private int[] v;

    public GF2Vector(int arg3) {
        super();
        if(arg3 < 0) {
            throw new ArithmeticException("Negative length.");
        }

        this.length = arg3;
        this.v = new int[arg3 + 31 >> 5];
    }

    public GF2Vector(int arg6, SecureRandom arg7) {
        super();
        this.length = arg6;
        int v1 = arg6 + 31 >> 5;
        this.v = new int[v1];
        int v0;
        for(v0 = v1 - 1; v0 >= 0; --v0) {
            this.v[v0] = arg7.nextInt();
        }

        v0 = arg6 & 31;
        if(v0 != 0) {
            --v1;
            this.v[v1] &= (1 << v0) - 1;
        }
    }

    public GF2Vector(int arg5, int arg6, SecureRandom arg7) {
        int v0 = 0;
        super();
        if(arg6 > arg5) {
            throw new ArithmeticException("The hamming weight is greater than the length of vector.");
        }

        this.length = arg5;
        this.v = new int[arg5 + 31 >> 5];
        int[] v2 = new int[arg5];
        int v1;
        for(v1 = 0; v1 < arg5; ++v1) {
            v2[v1] = v1;
        }

        while(v0 < arg6) {
            v1 = RandUtils.nextInt(arg7, arg5);
            this.setBit(v2[v1]);
            --arg5;
            v2[v1] = v2[arg5];
            ++v0;
        }
    }

    protected GF2Vector(int[] arg1, int arg2) {
        super();
        this.v = arg1;
        this.length = arg2;
    }

    public GF2Vector(int arg6, int[] arg7) {
        super();
        if(arg6 < 0) {
            throw new ArithmeticException("negative length");
        }

        this.length = arg6;
        int v0 = arg6 + 31 >> 5;
        if(arg7.length != v0) {
            throw new ArithmeticException("length mismatch");
        }

        this.v = IntUtils.clone(arg7);
        int v1 = arg6 & 31;
        if(v1 != 0) {
            --v0;
            this.v[v0] &= (1 << v1) - 1;
        }
    }

    public GF2Vector(GF2Vector arg2) {
        super();
        this.length = arg2.length;
        this.v = IntUtils.clone(arg2.v);
    }

    public static GF2Vector OS2VP(int arg2, byte[] arg3) {
        if(arg2 < 0) {
            throw new ArithmeticException("negative length");
        }

        if(arg3.length > arg2 + 7 >> 3) {
            throw new ArithmeticException("length mismatch");
        }

        return new GF2Vector(arg2, LittleEndianConversions.toIntArray(arg3));
    }

    public Vector add(Vector arg5) {
        if(!(arg5 instanceof GF2Vector)) {
            throw new ArithmeticException("vector is not defined over GF(2)");
        }

        if(this.length != arg5.length) {
            throw new ArithmeticException("length mismatch");
        }

        int[] v1 = IntUtils.clone(((GF2Vector)arg5).v);
        int v0;
        for(v0 = v1.length - 1; v0 >= 0; --v0) {
            v1[v0] ^= this.v[v0];
        }

        return new GF2Vector(this.length, v1);
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof GF2Vector)) && this.length == ((GF2Vector)arg4).length && (IntUtils.equals(this.v, ((GF2Vector)arg4).v))) {
            v0 = true;
        }

        return v0;
    }

    public GF2Vector extractLeftVector(int arg7) {
        GF2Vector v0;
        if(arg7 > this.length) {
            throw new ArithmeticException("invalid length");
        }

        if(arg7 == this.length) {
            v0 = new GF2Vector(this);
        }
        else {
            v0 = new GF2Vector(arg7);
            int v1 = arg7 >> 5;
            int v2 = arg7 & 31;
            System.arraycopy(this.v, 0, v0.v, 0, v1);
            if(v2 != 0) {
                v0.v[v1] = (1 << v2) - 1 & this.v[v1];
            }
        }

        return v0;
    }

    public GF2Vector extractRightVector(int arg10) {
        GF2Vector v0;
        int v1 = 0;
        if(arg10 > this.length) {
            throw new ArithmeticException("invalid length");
        }

        if(arg10 == this.length) {
            v0 = new GF2Vector(this);
        }
        else {
            v0 = new GF2Vector(arg10);
            int v2 = this.length - arg10 >> 5;
            int v4 = this.length - arg10 & 31;
            int v5 = arg10 + 31 >> 5;
            if(v4 != 0) {
                while(v1 < v5 - 1) {
                    int v3 = v2 + 1;
                    v0.v[v1] = this.v[v2] >>> v4 | this.v[v3] << 32 - v4;
                    ++v1;
                    v2 = v3;
                }

                int v7 = v2 + 1;
                v0.v[v5 - 1] = this.v[v2] >>> v4;
                if(v7 >= this.v.length) {
                    return v0;
                }

                v2 = v5 - 1;
                v0.v[v2] |= this.v[v7] << 32 - v4;
                return v0;
            }

            System.arraycopy(this.v, v2, v0.v, 0, v5);
        }

        return v0;
    }

    public GF2Vector extractVector(int[] arg9) {
        int v1 = arg9.length;
        if(arg9[v1 - 1] > this.length) {
            throw new ArithmeticException("invalid index set");
        }

        GF2Vector v2 = new GF2Vector(v1);
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            if((this.v[arg9[v0] >> 5] & 1 << (arg9[v0] & 31)) != 0) {
                int v4 = v0 >> 5;
                v2.v[v4] |= 1 << (v0 & 31);
            }
        }

        return v2;
    }

    public int getBit(int arg4) {
        if(arg4 >= this.length) {
            throw new IndexOutOfBoundsException();
        }

        int v1 = arg4 & 31;
        return (this.v[arg4 >> 5] & 1 << v1) >>> v1;
    }

    public byte[] getEncoded() {
        return LittleEndianConversions.toByteArray(this.v, this.length + 7 >> 3);
    }

    public int getHammingWeight() {
        int v0 = 0;
        int v2 = 0;
        while(v0 < this.v.length) {
            int v4 = this.v[v0];
            int v3;
            for(v3 = 0; v3 < 32; ++v3) {
                if((v4 & 1) != 0) {
                    ++v2;
                }

                v4 >>>= 1;
            }

            ++v0;
        }

        return v2;
    }

    public int[] getVecArray() {
        return this.v;
    }

    public int hashCode() {
        return this.length * 31 + this.v.hashCode();
    }

    public boolean isZero() {
        boolean v0_1;
        int v0 = this.v.length - 1;
        while(true) {
            if(v0 < 0) {
                return true;
            }
            else if(this.v[v0] != 0) {
                v0_1 = false;
            }
            else {
                --v0;
                continue;
            }

            return v0_1;
        }

        return true;
    }

    public Vector multiply(Permutation arg9) {
        int[] v1 = arg9.getVector();
        if(this.length != v1.length) {
            throw new ArithmeticException("length mismatch");
        }

        GF2Vector v2 = new GF2Vector(this.length);
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            if((this.v[v1[v0] >> 5] & 1 << (v1[v0] & 31)) != 0) {
                int v4 = v0 >> 5;
                v2.v[v4] |= 1 << (v0 & 31);
            }
        }

        return ((Vector)v2);
    }

    public void setBit(int arg6) {
        if(arg6 >= this.length) {
            throw new IndexOutOfBoundsException();
        }

        int v1 = arg6 >> 5;
        this.v[v1] |= 1 << (arg6 & 31);
    }

    public GF2mVector toExtensionFieldVector(GF2mField arg9) {
        int v0 = arg9.getDegree();
        if(this.length % v0 != 0) {
            throw new ArithmeticException("conversion is impossible");
        }

        v0 = this.length / v0;
        int[] v3 = new int[v0];
        int v1 = 0;
        int v2;
        for(v2 = v0 - 1; v2 >= 0; --v2) {
            for(v0 = arg9.getDegree() - 1; v0 >= 0; --v0) {
                if((this.v[v1 >>> 5] >>> (v1 & 31) & 1) == 1) {
                    v3[v2] ^= 1 << v0;
                }

                ++v1;
            }
        }

        return new GF2mVector(arg9, v3);
    }

    public String toString() {
        StringBuffer v1 = new StringBuffer();
        int v0;
        for(v0 = 0; v0 < this.length; ++v0) {
            if(v0 != 0 && (v0 & 31) == 0) {
                v1.append(' ');
            }

            if((this.v[v0 >> 5] & 1 << (v0 & 31)) == 0) {
                v1.append('0');
            }
            else {
                v1.append('1');
            }
        }

        return v1.toString();
    }
}

