// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.security.SecureRandom;

public class GF2mField {
    private int degree;
    private int polynomial;

    public GF2mField(byte[] arg3) {
        super();
        this.degree = 0;
        if(arg3.length != 4) {
            throw new IllegalArgumentException("byte array is not an encoded finite field");
        }

        this.polynomial = LittleEndianConversions.OS2IP(arg3);
        if(!PolynomialRingGF2.isIrreducible(this.polynomial)) {
            throw new IllegalArgumentException("byte array is not an encoded finite field");
        }

        this.degree = PolynomialRingGF2.degree(this.polynomial);
    }

    public GF2mField(int arg3, int arg4) {
        super();
        this.degree = 0;
        if(arg3 != PolynomialRingGF2.degree(arg4)) {
            throw new IllegalArgumentException(" Error: the degree is not correct");
        }

        if(!PolynomialRingGF2.isIrreducible(arg4)) {
            throw new IllegalArgumentException(" Error: given polynomial is reducible");
        }

        this.degree = arg3;
        this.polynomial = arg4;
    }

    public GF2mField(int arg3) {
        super();
        this.degree = 0;
        if(arg3 >= 32) {
            throw new IllegalArgumentException(" Error: the degree of field is too large ");
        }

        if(arg3 < 1) {
            throw new IllegalArgumentException(" Error: the degree of field is non-positive ");
        }

        this.degree = arg3;
        this.polynomial = PolynomialRingGF2.getIrreduciblePolynomial(arg3);
    }

    public GF2mField(GF2mField arg2) {
        super();
        this.degree = 0;
        this.degree = arg2.degree;
        this.polynomial = arg2.polynomial;
    }

    public int add(int arg2, int arg3) {
        return arg2 ^ arg3;
    }

    public String elementToStr(int arg6) {
        String v0 = "";
        int v1;
        for(v1 = 0; v1 < this.degree; ++v1) {
            v0 = ((((byte)arg6)) & 1) == 0 ? "0" + v0 : "1" + v0;
            arg6 >>>= 1;
        }

        return v0;
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof GF2mField)) && this.degree == ((GF2mField)arg4).degree && this.polynomial == ((GF2mField)arg4).polynomial) {
            v0 = true;
        }

        return v0;
    }

    public int exp(int arg4, int arg5) {
        int v0;
        if(arg4 == 0) {
            v0 = 0;
        }
        else if(arg4 == 1) {
            v0 = 1;
        }
        else {
            if(arg5 < 0) {
                arg4 = this.inverse(arg4);
                arg5 = -arg5;
                v0 = 1;
            }
            else {
                v0 = 1;
            }

            while(arg5 != 0) {
                if((arg5 & 1) == 1) {
                    v0 = this.mult(v0, arg4);
                }

                arg4 = this.mult(arg4, arg4);
                arg5 >>>= 1;
            }
        }

        return v0;
    }

    public int getDegree() {
        return this.degree;
    }

    public byte[] getEncoded() {
        return LittleEndianConversions.I2OSP(this.polynomial);
    }

    public int getPolynomial() {
        return this.polynomial;
    }

    public int getRandomElement(SecureRandom arg3) {
        return RandUtils.nextInt(arg3, 1 << this.degree);
    }

    public int getRandomNonZeroElement() {
        return this.getRandomNonZeroElement(new SecureRandom());
    }

    public int getRandomNonZeroElement(SecureRandom arg5) {
        int v0 = 1;
        int v3 = 1048576;
        int v2 = 0;
        int v1 = RandUtils.nextInt(arg5, 1 << this.degree);
        while(v1 == 0) {
            if(v2 >= v3) {
                break;
            }

            v1 = RandUtils.nextInt(arg5, 1 << this.degree);
            ++v2;
        }

        if(v2 != v3) {
            v0 = v1;
        }

        return v0;
    }

    public int hashCode() {
        return this.polynomial;
    }

    public int inverse(int arg3) {
        return this.exp(arg3, (1 << this.degree) - 2);
    }

    public boolean isElementOfThisField(int arg5) {
        boolean v0 = true;
        if(this.degree != 31) {
            if(arg5 >= 0 && arg5 < 1 << this.degree) {
                return v0;
            }

            v0 = false;
        }
        else if(arg5 < 0) {
            v0 = false;
        }

        return v0;
    }

    public int mult(int arg2, int arg3) {
        return PolynomialRingGF2.modMultiply(arg2, arg3, this.polynomial);
    }

    private static String polyToString(int arg5) {
        String v0 = "";
        if(arg5 == 0) {
            v0 = "0";
        }
        else {
            if((((byte)(arg5 & 1))) == 1) {
                v0 = "1";
            }

            int v3 = arg5 >>> 1;
            int v1;
            for(v1 = 1; v3 != 0; ++v1) {
                if((((byte)(v3 & 1))) == 1) {
                    v0 = v0 + "+x^" + v1;
                }

                v3 >>>= 1;
            }
        }

        return v0;
    }

    public int sqRoot(int arg3) {
        int v0;
        for(v0 = 1; v0 < this.degree; ++v0) {
            arg3 = this.mult(arg3, arg3);
        }

        return arg3;
    }

    public String toString() {
        return "Finite Field GF(2^" + this.degree + ") = " + "GF(2)[X]/<" + GF2mField.polyToString(this.polynomial) + "> ";
    }
}

