// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

public class GF2mMatrix extends Matrix {
    protected GF2mField field;
    protected int[][] matrix;

    public GF2mMatrix(GF2mField arg10, byte[] arg11) {
        int v1;
        super();
        this.field = arg10;
        int v2 = 8;
        int v0 = 1;
        while(arg10.getDegree() > v2) {
            ++v0;
            v2 += 8;
        }

        if(arg11.length < 5) {
            throw new IllegalArgumentException(" Error: given array is not encoded matrix over GF(2^m)");
        }

        this.numRows = (arg11[1] & 255) << 8 ^ ((arg11[3] & 255) << 24 ^ (arg11[2] & 255) << 16) ^ arg11[0] & 255;
        v0 *= this.numRows;
        if(this.numRows > 0 && (arg11.length - 4) % v0 == 0) {
            this.numColumns = (arg11.length - 4) / v0;
            this.matrix = new int[this.numRows][this.numColumns];
            v1 = 4;
            v0 = 0;
        }
        else {
            throw new IllegalArgumentException(" Error: given array is not encoded matrix over GF(2^m)");
        }

        while(v0 < this.numRows) {
            int v4 = 0;
            while(v4 < this.numColumns) {
                int v5 = v1;
                v1 = 0;
                while(v1 < v2) {
                    this.matrix[v0][v4] ^= (arg11[v5] & 255) << v1;
                    v1 += 8;
                    ++v5;
                }

                if(!this.field.isElementOfThisField(this.matrix[v0][v4])) {
                    throw new IllegalArgumentException(" Error: given array is not encoded matrix over GF(2^m)");
                }

                ++v4;
                v1 = v5;
            }

            ++v0;
        }
    }

    protected GF2mMatrix(GF2mField arg2, int[][] arg3) {
        super();
        this.field = arg2;
        this.matrix = arg3;
        this.numRows = arg3.length;
        this.numColumns = arg3[0].length;
    }

    public GF2mMatrix(GF2mMatrix arg4) {
        super();
        this.numRows = arg4.numRows;
        this.numColumns = arg4.numColumns;
        this.field = arg4.field;
        this.matrix = new int[this.numRows][];
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            this.matrix[v0] = IntUtils.clone(arg4.matrix[v0]);
        }
    }

    private void addToRow(int[] arg5, int[] arg6) {
        int v0;
        for(v0 = arg6.length - 1; v0 >= 0; --v0) {
            arg6[v0] = this.field.add(arg5[v0], arg6[v0]);
        }
    }

    public Matrix computeInverse() {
        int v5;
        int v4;
        if(this.numRows != this.numColumns) {
            throw new ArithmeticException("Matrix is not invertible.");
        }

        Object v0 = new int[this.numRows][this.numRows];
        int v1;
        for(v1 = this.numRows - 1; v1 >= 0; --v1) {
            v0[v1] = IntUtils.clone(this.matrix[v1]);
        }

        Object v1_1 = new int[this.numRows][this.numRows];
        int v2;
        for(v2 = this.numRows - 1; v2 >= 0; --v2) {
            v1_1[v2][v2] = 1;
        }

        for(v2 = 0; v2 < this.numRows; ++v2) {
            if(v0[v2][v2] == 0) {
                v4 = v2 + 1;
                v5 = 0;
                while(v4 < this.numRows) {
                    if(v0[v4][v2] != 0) {
                        GF2mMatrix.swapColumns(((int[][])v0), v2, v4);
                        GF2mMatrix.swapColumns(((int[][])v1_1), v2, v4);
                        v4 = this.numRows;
                        v5 = 1;
                    }

                    ++v4;
                }

                if(v5 != 0) {
                    goto label_59;
                }

                throw new ArithmeticException("Matrix is not invertible.");
            }

        label_59:
            v4 = this.field.inverse(v0[v2][v2]);
            this.multRowWithElementThis(v0[v2], v4);
            this.multRowWithElementThis(v1_1[v2], v4);
            for(v4 = 0; v4 < this.numRows; ++v4) {
                if(v4 != v2) {
                    v5 = v0[v4][v2];
                    if(v5 != 0) {
                        int[] v7 = this.multRowWithElement(v0[v2], v5);
                        int[] v5_1 = this.multRowWithElement(v1_1[v2], v5);
                        this.addToRow(v7, v0[v4]);
                        this.addToRow(v5_1, v1_1[v4]);
                    }
                }
            }
        }

        return new GF2mMatrix(this.field, ((int[][])v1_1));
    }

    public boolean equals(Object arg6) {
        boolean v1 = false;
        if(arg6 != null && ((arg6 instanceof GF2mMatrix)) && (this.field.equals(((GF2mMatrix)arg6).field)) && ((GF2mMatrix)arg6).numRows == this.numColumns && ((GF2mMatrix)arg6).numColumns == this.numColumns) {
            int v0;
            for(v0 = 0; v0 < this.numRows; ++v0) {
                int v2 = 0;
                while(true) {
                    if(v2 >= this.numColumns) {
                        break;
                    }
                    else if(this.matrix[v0][v2] == ((GF2mMatrix)arg6).matrix[v0][v2]) {
                        ++v2;
                        continue;
                    }

                    return v1;
                }
            }

            v1 = true;
        }

        return v1;
    }

    public byte[] getEncoded() {
        int v2 = 8;
        int v0 = 1;
        while(this.field.getDegree() > v2) {
            ++v0;
            v2 += 8;
        }

        byte[] v7 = new byte[v0 * (this.numRows * this.numColumns) + 4];
        v7[0] = ((byte)(this.numRows & 255));
        v7[1] = ((byte)(this.numRows >>> 8 & 255));
        v7[2] = ((byte)(this.numRows >>> 16 & 255));
        v7[3] = ((byte)(this.numRows >>> 24 & 255));
        int v1 = 4;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v4 = 0;
            while(v4 < this.numColumns) {
                int v5 = v1;
                v1 = 0;
                while(v1 < v2) {
                    v7[v5] = ((byte)(this.matrix[v0][v4] >>> v1));
                    v1 += 8;
                    ++v5;
                }

                ++v4;
                v1 = v5;
            }
        }

        return v7;
    }

    public int hashCode() {
        int v2 = (this.field.hashCode() * 31 + this.numRows) * 31 + this.numColumns;
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v3 = 0;
            while(v3 < this.numColumns) {
                int v4 = this.matrix[v0][v3] + v2 * 31;
                ++v3;
                v2 = v4;
            }
        }

        return v2;
    }

    public boolean isZero() {
        boolean v1 = false;
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            int v2 = 0;
            while(true) {
                if(v2 >= this.numColumns) {
                    break;
                }
                else if(this.matrix[v0][v2] == 0) {
                    ++v2;
                    continue;
                }

                return v1;
            }
        }

        return true;
    }

    public Vector leftMultiply(Vector arg3) {
        throw new RuntimeException("Not implemented.");
    }

    private int[] multRowWithElement(int[] arg5, int arg6) {
        int[] v1 = new int[arg5.length];
        int v0;
        for(v0 = arg5.length - 1; v0 >= 0; --v0) {
            v1[v0] = this.field.mult(arg5[v0], arg6);
        }

        return v1;
    }

    private void multRowWithElementThis(int[] arg4, int arg5) {
        int v0;
        for(v0 = arg4.length - 1; v0 >= 0; --v0) {
            arg4[v0] = this.field.mult(arg4[v0], arg5);
        }
    }

    public Matrix rightMultiply(Matrix arg3) {
        throw new RuntimeException("Not implemented.");
    }

    public Matrix rightMultiply(Permutation arg3) {
        throw new RuntimeException("Not implemented.");
    }

    public Vector rightMultiply(Vector arg3) {
        throw new RuntimeException("Not implemented.");
    }

    private static void swapColumns(int[][] arg2, int arg3, int arg4) {
        int[] v0 = arg2[arg3];
        arg2[arg3] = arg2[arg4];
        arg2[arg4] = v0;
    }

    public String toString() {
        String v2 = this.numRows + " x " + this.numColumns + " Matrix over " + this.field.toString() + ": \n";
        int v0;
        for(v0 = 0; v0 < this.numRows; ++v0) {
            String v3 = v2;
            int v2_1;
            for(v2_1 = 0; v2_1 < this.numColumns; ++v2_1) {
                v3 = v3 + this.field.elementToStr(this.matrix[v0][v2_1]) + " : ";
            }

            v2 = v3 + "\n";
        }

        return v2;
    }
}

