// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

public class GF2mVector extends Vector {
    private GF2mField field;
    private int[] vector;

    public GF2mVector(GF2mField arg3, int[] arg4) {
        super();
        this.field = arg3;
        this.length = arg4.length;
        int v0;
        for(v0 = arg4.length - 1; v0 >= 0; --v0) {
            if(!arg3.isElementOfThisField(arg4[v0])) {
                throw new ArithmeticException("Element array is not specified over the given finite field.");
            }
        }

        this.vector = IntUtils.clone(arg4);
    }

    public GF2mVector(GF2mField arg9, byte[] arg10) {
        super();
        this.field = new GF2mField(arg9);
        int v1 = 8;
        int v0 = 1;
        while(arg9.getDegree() > v1) {
            ++v0;
            v1 += 8;
        }

        if(arg10.length % v0 != 0) {
            throw new IllegalArgumentException("Byte array is not an encoded vector over the given finite field.");
        }

        this.length = arg10.length / v0;
        this.vector = new int[this.length];
        v0 = 0;
        int v3 = 0;
        while(v0 < this.vector.length) {
            int v4 = 0;
            while(v4 < v1) {
                this.vector[v0] |= (arg10[v3] & 255) << v4;
                v4 += 8;
                ++v3;
            }

            if(!arg9.isElementOfThisField(this.vector[v0])) {
                throw new IllegalArgumentException("Byte array is not an encoded vector over the given finite field.");
            }

            ++v0;
        }
    }

    public GF2mVector(GF2mVector arg3) {
        super();
        this.field = new GF2mField(arg3.field);
        this.length = arg3.length;
        this.vector = IntUtils.clone(arg3.vector);
    }

    public Vector add(Vector arg3) {
        throw new RuntimeException("not implemented");
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(((arg4 instanceof GF2mVector)) && (this.field.equals(((GF2mVector)arg4).field))) {
            v0 = IntUtils.equals(this.vector, ((GF2mVector)arg4).vector);
        }

        return v0;
    }

    public byte[] getEncoded() {
        int v1 = 8;
        int v0 = 1;
        while(this.field.getDegree() > v1) {
            ++v0;
            v1 += 8;
        }

        byte[] v6 = new byte[v0 * this.vector.length];
        v0 = 0;
        int v3 = 0;
        while(v0 < this.vector.length) {
            int v4 = 0;
            while(v4 < v1) {
                v6[v3] = ((byte)(this.vector[v0] >>> v4));
                v4 += 8;
                ++v3;
            }

            ++v0;
        }

        return v6;
    }

    public GF2mField getField() {
        return this.field;
    }

    public int[] getIntArrayForm() {
        return IntUtils.clone(this.vector);
    }

    public int hashCode() {
        return this.field.hashCode() * 31 + this.vector.hashCode();
    }

    public boolean isZero() {
        boolean v0_1;
        int v0 = this.vector.length - 1;
        while(true) {
            if(v0 < 0) {
                return true;
            }
            else if(this.vector[v0] != 0) {
                v0_1 = false;
            }
            else {
                --v0;
                continue;
            }

            return v0_1;
        }

        return true;
    }

    public Vector multiply(Permutation arg6) {
        int[] v1 = arg6.getVector();
        if(this.length != v1.length) {
            throw new ArithmeticException("permutation size and vector size mismatch");
        }

        int[] v2 = new int[this.length];
        int v0;
        for(v0 = 0; v0 < v1.length; ++v0) {
            v2[v0] = this.vector[v1[v0]];
        }

        return new GF2mVector(this.field, v2);
    }

    public String toString() {
        StringBuffer v3 = new StringBuffer();
        int v0;
        for(v0 = 0; v0 < this.vector.length; ++v0) {
            int v2;
            for(v2 = 0; v2 < this.field.getDegree(); ++v2) {
                if((1 << (v2 & 31) & this.vector[v0]) != 0) {
                    v3.append('1');
                }
                else {
                    v3.append('0');
                }
            }

            v3.append(' ');
        }

        return v3.toString();
    }
}

