// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.util.Vector;

public abstract class GF2nField {
    protected GF2Polynomial fieldPolynomial;
    protected Vector fields;
    protected int mDegree;
    protected Vector matrices;

    public GF2nField() {
        super();
    }

    protected abstract void computeCOBMatrix(GF2nField arg1);

    protected abstract void computeFieldPolynomial();

    public final GF2nElement convert(GF2nElement arg6, GF2nField arg7) {
        Object v0;
        if(arg7 == this) {
            v0 = arg6.clone();
        }
        else if(this.fieldPolynomial.equals(arg7.fieldPolynomial)) {
            v0 = arg6.clone();
        }
        else if(this.mDegree != arg7.mDegree) {
            throw new RuntimeException("GF2nField.convert: B1 has a different degree and thus cannot be coverted to!");
        }
        else {
            int v0_1 = this.fields.indexOf(arg7);
            if(v0_1 == -1) {
                this.computeCOBMatrix(arg7);
                v0_1 = this.fields.indexOf(arg7);
            }

            v0 = this.matrices.elementAt(v0_1);
            Object v1 = arg6.clone();
            if((v1 instanceof GF2nONBElement)) {
                v1.reverseOrder();
            }

            GF2Polynomial v2 = new GF2Polynomial(this.mDegree, ((GF2nElement)v1).toFlexiBigInt());
            v2.expandN(this.mDegree);
            GF2Polynomial v3 = new GF2Polynomial(this.mDegree);
            int v1_1;
            for(v1_1 = 0; v1_1 < this.mDegree; ++v1_1) {
                if(v2.vectorMult(v0[v1_1])) {
                    v3.setBit(this.mDegree - 1 - v1_1);
                }
            }

            if((arg7 instanceof GF2nPolynomialField)) {
                GF2nPolynomialElement v0_2 = new GF2nPolynomialElement(((GF2nPolynomialField)arg7), v3);
                goto label_2;
            }

            if((arg7 instanceof GF2nONBField)) {
                GF2nONBElement v0_3 = new GF2nONBElement(((GF2nONBField)arg7), v3.toFlexiBigInt());
                v0_3.reverseOrder();
                goto label_2;
            }

            throw new RuntimeException("GF2nField.convert: B1 must be an instance of GF2nPolynomialField or GF2nONBField!");
        }

    label_2:
        return ((GF2nElement)v0);
    }

    public final boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof GF2nField)) && ((GF2nField)arg4).mDegree == this.mDegree && (this.fieldPolynomial.equals(((GF2nField)arg4).fieldPolynomial)) && (!(this instanceof GF2nPolynomialField) || ((arg4 instanceof GF2nPolynomialField))) && (!(this instanceof GF2nONBField) || ((arg4 instanceof GF2nONBField)))) {
            v0 = true;
        }

        return v0;
    }

    public final int getDegree() {
        return this.mDegree;
    }

    public final GF2Polynomial getFieldPolynomial() {
        if(this.fieldPolynomial == null) {
            this.computeFieldPolynomial();
        }

        return new GF2Polynomial(this.fieldPolynomial);
    }

    protected abstract GF2nElement getRandomRoot(GF2Polynomial arg1);

    public int hashCode() {
        return this.mDegree + this.fieldPolynomial.hashCode();
    }

    protected final GF2Polynomial[] invertMatrix(GF2Polynomial[] arg7) {
        int v1 = 0;
        GF2Polynomial[] v3 = new GF2Polynomial[arg7.length];
        GF2Polynomial[] v4 = new GF2Polynomial[arg7.length];
        int v0;
        for(v0 = 0; v0 < this.mDegree; ++v0) {
            try {
                v3[v0] = new GF2Polynomial(arg7[v0]);
                v4[v0] = new GF2Polynomial(this.mDegree);
                v4[v0].setBit(this.mDegree - 1 - v0);
            }
            catch(RuntimeException v2) {
                v2.printStackTrace();
            }
        }

        while(v1 < this.mDegree - 1) {
            for(v0 = v1; v0 < this.mDegree; ++v0) {
                if(v3[v0].testBit(this.mDegree - 1 - v1)) {
                    break;
                }
            }

            if(v0 >= this.mDegree) {
                throw new RuntimeException("GF2nField.invertMatrix: Matrix cannot be inverted!");
            }

            if(v1 != v0) {
                GF2Polynomial v2_1 = v3[v1];
                v3[v1] = v3[v0];
                v3[v0] = v2_1;
                v2_1 = v4[v1];
                v4[v1] = v4[v0];
                v4[v0] = v2_1;
            }

            for(v0 = v1 + 1; v0 < this.mDegree; ++v0) {
                if(v3[v0].testBit(this.mDegree - 1 - v1)) {
                    v3[v0].addToThis(v3[v1]);
                    v4[v0].addToThis(v4[v1]);
                }
            }

            ++v1;
        }

        for(v1 = this.mDegree - 1; v1 > 0; --v1) {
            for(v0 = v1 - 1; v0 >= 0; --v0) {
                if(v3[v0].testBit(this.mDegree - 1 - v1)) {
                    v3[v0].addToThis(v3[v1]);
                    v4[v0].addToThis(v4[v1]);
                }
            }
        }

        return v4;
    }
}

