// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.util.Random;
import java.util.Vector;

public class GF2nONBField extends GF2nField {
    private static final int MAXLONG = 64;
    private int mBit;
    private int mLength;
    int[][] mMult;
    private int mType;

    public GF2nONBField(int arg6) {
        int v2 = 3;
        int v4 = -1;
        super();
        if(arg6 < v2) {
            throw new IllegalArgumentException("k must be at least 3");
        }

        this.mDegree = arg6;
        this.mLength = this.mDegree / 64;
        this.mBit = this.mDegree & 63;
        if(this.mBit == 0) {
            this.mBit = 64;
        }
        else {
            ++this.mLength;
        }

        this.computeType();
        if(this.mType < v2) {
            this.mMult = new int[this.mDegree][2];
            int v0;
            for(v0 = 0; v0 < this.mDegree; ++v0) {
                this.mMult[v0][0] = v4;
                this.mMult[v0][1] = v4;
            }

            this.computeMultMatrix();
            this.computeFieldPolynomial();
            this.fields = new Vector();
            this.matrices = new Vector();
            return;
        }

        throw new RuntimeException("\nThe type of this field is " + this.mType);
    }

    protected void computeCOBMatrix(GF2nField arg8) {
        GF2nElement v0_1;
        if(this.mDegree != arg8.mDegree) {
            throw new IllegalArgumentException("GF2nField.computeCOBMatrix: B1 has a different degree and thus cannot be coverted to!");
        }

        GF2Polynomial[] v3 = new GF2Polynomial[this.mDegree];
        int v0;
        for(v0 = 0; v0 < this.mDegree; ++v0) {
            v3[v0] = new GF2Polynomial(this.mDegree);
        }

        do {
            v0_1 = arg8.getRandomRoot(this.fieldPolynomial);
        }
        while(v0_1.isZero());

        GF2nPolynomialElement[] v4 = new GF2nPolynomialElement[this.mDegree];
        v4[0] = v0_1.clone();
        for(v0 = 1; v0 < this.mDegree; ++v0) {
            v4[v0] = v4[v0 - 1].square();
        }

        for(v0 = 0; v0 < this.mDegree; ++v0) {
            int v2;
            for(v2 = 0; v2 < this.mDegree; ++v2) {
                if(v4[v0].testBit(v2)) {
                    v3[this.mDegree - v2 - 1].setBit(this.mDegree - v0 - 1);
                }
            }
        }

        this.fields.addElement(arg8);
        this.matrices.addElement(v3);
        arg8.fields.addElement(this);
        arg8.matrices.addElement(this.invertMatrix(v3));
    }

    protected void computeFieldPolynomial() {
        int v0 = 1;
        if(this.mType == 1) {
            this.fieldPolynomial = new GF2Polynomial(this.mDegree + 1, "ALL");
        }
        else if(this.mType == 2) {
            GF2Polynomial v2 = new GF2Polynomial(this.mDegree + 1, "ONE");
            GF2Polynomial v1 = new GF2Polynomial(this.mDegree + 1, "X");
            v1.addToThis(v2);
            GF2Polynomial v3 = v2;
            while(v0 < this.mDegree) {
                v2 = v1.shiftLeft();
                v2.addToThis(v3);
                ++v0;
                v3 = v1;
                v1 = v2;
            }

            this.fieldPolynomial = v1;
        }
    }

    private void computeMultMatrix() {
        int v0;
        int v11 = 2;
        int v10 = -1;
        if((this.mType & 7) == 0) {
            goto label_146;
        }

        int v7 = this.mType * this.mDegree + 1;
        int[] v8 = new int[v7];
        if(this.mType == 1) {
            v0 = 1;
        }
        else if(this.mType == v11) {
            v0 = v7 - 1;
        }
        else {
            v0 = this.elementOfOrder(this.mType, v7);
        }

        int v2 = 0;
        int v4 = 1;
        while(v2 < this.mType) {
            int v5 = 0;
            int v6 = v4;
            while(v5 < this.mDegree) {
                v8[v6] = v5;
                v6 = (v6 << 1) % v7;
                if(v6 < 0) {
                    v6 += v7;
                }

                ++v5;
            }

            v4 = v4 * v0 % v7;
            if(v4 < 0) {
                v4 += v7;
            }

            ++v2;
        }

        if(this.mType == 1) {
            for(v0 = 1; v0 < v7 - 1; ++v0) {
                if(this.mMult[v8[v0 + 1]][0] == v10) {
                    this.mMult[v8[v0 + 1]][0] = v8[v7 - v0];
                }
                else {
                    this.mMult[v8[v0 + 1]][1] = v8[v7 - v0];
                }
            }

            v2 = this.mDegree >> 1;
            for(v0 = 1; v0 <= v2; ++v0) {
                if(this.mMult[v0 - 1][0] == v10) {
                    this.mMult[v0 - 1][0] = v2 + v0 - 1;
                }
                else {
                    this.mMult[v0 - 1][1] = v2 + v0 - 1;
                }

                if(this.mMult[v2 + v0 - 1][0] == v10) {
                    this.mMult[v2 + v0 - 1][0] = v0 - 1;
                }
                else {
                    this.mMult[v2 + v0 - 1][1] = v0 - 1;
                }
            }
        }
        else {
            if(this.mType != v11) {
                goto label_142;
            }

            for(v0 = 1; v0 < v7 - 1; ++v0) {
                if(this.mMult[v8[v0 + 1]][0] == v10) {
                    this.mMult[v8[v0 + 1]][0] = v8[v7 - v0];
                }
                else {
                    this.mMult[v8[v0 + 1]][1] = v8[v7 - v0];
                }
            }
        }

        return;
    label_142:
        throw new RuntimeException("only type 1 or type 2 implemented");
    label_146:
        throw new RuntimeException("bisher nur fuer Gausssche Normalbasen implementiert");
    }

    private void computeType() {
        int v4 = 2;
        if((this.mDegree & 7) == 0) {
            throw new RuntimeException("The extension degree is divisible by 8!");
        }

        this.mType = 1;
        int v0 = 0;
        while(v0 != 1) {
            int v1 = this.mType * this.mDegree + 1;
            if(IntegerFunctions.isPrime(v1)) {
                v0 = IntegerFunctions.gcd(this.mType * this.mDegree / IntegerFunctions.order(v4, v1), this.mDegree);
            }

            ++this.mType;
        }

        --this.mType;
        if(this.mType == 1) {
            v0 = (this.mDegree << 1) + 1;
            if((IntegerFunctions.isPrime(v0)) && IntegerFunctions.gcd((this.mDegree << 1) / IntegerFunctions.order(v4, v0), this.mDegree) == 1) {
                ++this.mType;
            }
        }
    }

    private int elementOfOrder(int arg5, int arg6) {
        Random v2 = new Random();
        int v1;
        for(v1 = 0; v1 == 0; v1 += arg6 - 1) {
            v1 = v2.nextInt() % (arg6 - 1);
            if(v1 >= 0) {
                continue;
            }
        }

        int v0;
        for(v0 = IntegerFunctions.order(v1, arg6); true; v0 = IntegerFunctions.order(v1, arg6)) {
            if(v0 % arg5 == 0 && v0 != 0) {
                int v3 = arg5 / v0;
                v0 = 2;
                int v2_1 = v1;
                while(v0 <= v3) {
                    v2_1 *= v1;
                    ++v0;
                }

                return v2_1;
            }

            while(v1 == 0) {
                v1 = v2.nextInt() % (arg6 - 1);
                if(v1 >= 0) {
                    continue;
                }

                v1 += arg6 - 1;
            }
        }
    }

    int getONBBit() {
        return this.mBit;
    }

    int getONBLength() {
        return this.mLength;
    }

    protected GF2nElement getRandomRoot(GF2Polynomial arg7) {
        int v4_1;
        GF2nPolynomial v2 = new GF2nPolynomial(arg7, ((GF2nField)this));
        int v0 = v2.getDegree();
        GF2nPolynomial v3 = v2;
        while(v0 > 1) {
            do {
            label_6:
                GF2nONBElement v0_1 = new GF2nONBElement(this, new Random());
                GF2nPolynomial v4 = new GF2nPolynomial(2, GF2nONBElement.ZERO(this));
                v4.set(1, ((GF2nElement)v0_1));
                v2 = new GF2nPolynomial(v4);
                for(v0 = 1; v0 <= this.mDegree - 1; ++v0) {
                    v2 = v2.multiplyAndReduce(v2, v3).add(v4);
                }

                v2 = v2.gcd(v3);
                v0 = v2.getDegree();
                v4_1 = v3.getDegree();
                if(v0 == 0) {
                    goto label_6;
                }
            }
            while(v0 == v4_1);

            GF2nPolynomial v0_2 = v0 << 1 > v4_1 ? v3.quotient(v2) : new GF2nPolynomial(v2);
            v3 = v0_2;
            v0 = v0_2.getDegree();
        }

        return v3.at(0);
    }

    int[][] invMatrix(int[][] arg6) {
        int v2 = 0;
        new int[this.mDegree][this.mDegree];
        Object v0 = new int[this.mDegree][this.mDegree];
        int v1;
        for(v1 = 0; v1 < this.mDegree; ++v1) {
            v0[v1][v1] = 1;
        }

        while(v2 < this.mDegree) {
            int v0_1;
            for(v0_1 = v2; v0_1 < this.mDegree; ++v0_1) {
                arg6[this.mDegree - 1 - v2][v0_1] = arg6[v2][v2];
            }

            ++v2;
        }

        return null;
    }
}

