// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

public class GF2nPolynomial {
    private GF2nElement[] coeff;
    private int size;

    public GF2nPolynomial(GF2Polynomial arg4, GF2nField arg5) {
        super();
        this.size = arg5.getDegree() + 1;
        this.coeff = new GF2nElement[this.size];
        if((arg5 instanceof GF2nONBField)) {
            int v1;
            for(v1 = 0; v1 < this.size; ++v1) {
                this.coeff[v1] = arg4.testBit(v1) ? GF2nONBElement.ONE(arg5) : GF2nONBElement.ZERO(arg5);
            }
        }
        else {
            if(!(arg5 instanceof GF2nPolynomialField)) {
                goto label_46;
            }

            for(v1 = 0; v1 < this.size; ++v1) {
                this.coeff[v1] = arg4.testBit(v1) ? GF2nPolynomialElement.ONE(arg5) : GF2nPolynomialElement.ZERO(arg5);
            }
        }

        return;
    label_46:
        throw new IllegalArgumentException("PolynomialGF2n(Bitstring, GF2nField): B1 must be an instance of GF2nONBField or GF2nPolynomialField!");
    }

    public GF2nPolynomial(int arg4, GF2nElement arg5) {
        super();
        this.size = arg4;
        this.coeff = new GF2nElement[this.size];
        int v1;
        for(v1 = 0; v1 < this.size; ++v1) {
            this.coeff[v1] = arg5.clone();
        }
    }

    public GF2nPolynomial(GF2nPolynomial arg4) {
        super();
        this.coeff = new GF2nElement[arg4.size];
        this.size = arg4.size;
        int v1;
        for(v1 = 0; v1 < this.size; ++v1) {
            this.coeff[v1] = arg4.coeff[v1].clone();
        }
    }

    private GF2nPolynomial(int arg2) {
        super();
        this.size = arg2;
        this.coeff = new GF2nElement[this.size];
    }

    public final GF2nPolynomial add(GF2nPolynomial arg6) {
        GF2nPolynomial v0;
        GF2nPolynomial v2;
        if(this.size() >= arg6.size()) {
            v2 = new GF2nPolynomial(this.size());
            int v1;
            for(v1 = 0; v1 < arg6.size(); ++v1) {
                v2.coeff[v1] = this.coeff[v1].add(arg6.coeff[v1]);
            }

            while(v1 < this.size()) {
                v2.coeff[v1] = this.coeff[v1];
                ++v1;
            }

            v0 = v2;
        }
        else {
            v2 = new GF2nPolynomial(arg6.size());
            for(v1 = 0; v1 < this.size(); ++v1) {
                v2.coeff[v1] = this.coeff[v1].add(arg6.coeff[v1]);
            }

            while(v1 < arg6.size()) {
                v2.coeff[v1] = arg6.coeff[v1];
                ++v1;
            }

            v0 = v2;
        }

        return v0;
    }

    public final void assignZeroToElements() {
        int v0;
        for(v0 = 0; v0 < this.size; ++v0) {
            this.coeff[v0].assignZero();
        }
    }

    public final GF2nElement at(int arg2) {
        return this.coeff[arg2];
    }

    public final GF2nPolynomial[] divide(GF2nPolynomial arg10) {
        GF2nPolynomial[] v0_1;
        GF2nPolynomial[] v2 = new GF2nPolynomial[2];
        GF2nPolynomial v3 = new GF2nPolynomial(this);
        v3.shrink();
        int v5 = arg10.getDegree();
        GFElement v0 = arg10.coeff[v5].invert();
        if(v3.getDegree() < v5) {
            v2[0] = new GF2nPolynomial(this);
            v2[0].assignZeroToElements();
            v2[0].shrink();
            v2[1] = new GF2nPolynomial(this);
            v2[1].shrink();
            v0_1 = v2;
        }
        else {
            v2[0] = new GF2nPolynomial(this);
            v2[0].assignZeroToElements();
            GF2nPolynomial v4 = v3;
            int v3_1;
            for(v3_1 = v3.getDegree() - v5; v3_1 >= 0; v3_1 = v4.getDegree() - v5) {
                GFElement v1 = v4.coeff[v4.getDegree()].multiply(v0);
                GF2nPolynomial v6 = arg10.scalarMultiply(((GF2nElement)v1));
                v6.shiftThisLeft(v3_1);
                v4 = v4.add(v6);
                v4.shrink();
                v2[0].coeff[v3_1] = ((GF2nElement)v1).clone();
            }

            v2[1] = v4;
            v2[0].shrink();
            v0_1 = v2;
        }

        return v0_1;
    }

    public final void enlarge(int arg5) {
        if(arg5 > this.size) {
            GF2nElement[] v3 = new GF2nElement[arg5];
            System.arraycopy(this.coeff, 0, v3, 0, this.size);
            GF2nField v1 = this.coeff[0].getField();
            if((this.coeff[0] instanceof GF2nPolynomialElement)) {
                int v2;
                for(v2 = this.size; v2 < arg5; ++v2) {
                    v3[v2] = GF2nPolynomialElement.ZERO(v1);
                }
            }
            else if((this.coeff[0] instanceof GF2nONBElement)) {
                for(v2 = this.size; v2 < arg5; ++v2) {
                    v3[v2] = GF2nONBElement.ZERO(v1);
                }
            }

            this.size = arg5;
            this.coeff = v3;
        }
    }

    public final boolean equals(Object arg5) {
        boolean v1 = false;
        if(arg5 != null && ((arg5 instanceof GF2nPolynomial)) && this.getDegree() == ((GF2nPolynomial)arg5).getDegree()) {
            int v0 = 0;
            while(true) {
                if(v0 >= this.size) {
                    break;
                }
                else if(this.coeff[v0].equals(((GF2nPolynomial)arg5).coeff[v0])) {
                    ++v0;
                    continue;
                }

                return v1;
            }

            v1 = true;
        }

        return v1;
    }

    public final GF2nPolynomial gcd(GF2nPolynomial arg5) {
        GF2nPolynomial v1 = new GF2nPolynomial(this);
        GF2nPolynomial v0 = new GF2nPolynomial(arg5);
        v1.shrink();
        v0.shrink();
        while(!v0.isZero()) {
            GF2nPolynomial v3 = v1.remainder(v0);
            v1 = v0;
            v0 = v3;
        }

        return v1.scalarMultiply(v1.coeff[v1.getDegree()].invert());
    }

    public final int getDegree() {
        int v0 = this.size - 1;
        while(true) {
            if(v0 < 0) {
                return -1;
            }
            else if(this.coeff[v0].isZero()) {
                --v0;
                continue;
            }

            return v0;
        }

        return -1;
    }

    public int hashCode() {
        return this.getDegree() + this.coeff.hashCode();
    }

    public final boolean isZero() {
        boolean v1 = false;
        int v0;
        for(v0 = 0; v0 < this.size; ++v0) {
            if(this.coeff[v0] != null && !this.coeff[v0].isZero()) {
                return v1;
            }
        }

        return true;
    }

    public final GF2nPolynomial multiply(GF2nPolynomial arg10) {
        int v0 = this.size();
        if(v0 != arg10.size()) {
            throw new IllegalArgumentException("PolynomialGF2n.multiply: this and b must have the same size!");
        }

        GF2nPolynomial v4 = new GF2nPolynomial((v0 << 1) - 1);
        int v1;
        for(v1 = 0; v1 < this.size(); ++v1) {
            int v3;
            for(v3 = 0; v3 < arg10.size(); ++v3) {
                v4.coeff[v1 + v3] = v4.coeff[v1 + v3] == null ? this.coeff[v1].multiply(arg10.coeff[v3]) : v4.coeff[v1 + v3].add(this.coeff[v1].multiply(arg10.coeff[v3]));
            }
        }

        return v4;
    }

    public final GF2nPolynomial multiplyAndReduce(GF2nPolynomial arg2, GF2nPolynomial arg3) {
        return this.multiply(arg2).reduce(arg3);
    }

    public final GF2nPolynomial quotient(GF2nPolynomial arg3) {
        new GF2nPolynomial[2];
        return this.divide(arg3)[0];
    }

    public final GF2nPolynomial reduce(GF2nPolynomial arg2) {
        return this.remainder(arg2);
    }

    public final GF2nPolynomial remainder(GF2nPolynomial arg3) {
        new GF2nPolynomial[2];
        return this.divide(arg3)[1];
    }

    public final GF2nPolynomial scalarMultiply(GF2nElement arg5) {
        GF2nPolynomial v2 = new GF2nPolynomial(this.size());
        int v1;
        for(v1 = 0; v1 < this.size(); ++v1) {
            v2.coeff[v1] = this.coeff[v1].multiply(((GFElement)arg5));
        }

        return v2;
    }

    public final void set(int arg3, GF2nElement arg4) {
        if(!(arg4 instanceof GF2nPolynomialElement) && !(arg4 instanceof GF2nONBElement)) {
            throw new IllegalArgumentException("PolynomialGF2n.set f must be an instance of either GF2nPolynomialElement or GF2nONBElement!");
        }

        this.coeff[arg3] = arg4.clone();
    }

    public final GF2nPolynomial shiftLeft(int arg6) {
        GF2nPolynomial v0_1;
        int v0 = 0;
        if(arg6 <= 0) {
            v0_1 = new GF2nPolynomial(this);
        }
        else {
            GF2nPolynomial v1 = new GF2nPolynomial(this.size + arg6, this.coeff[0]);
            v1.assignZeroToElements();
            while(v0 < this.size) {
                v1.coeff[v0 + arg6] = this.coeff[v0];
                ++v0;
            }

            v0_1 = v1;
        }

        return v0_1;
    }

    public final void shiftThisLeft(int arg7) {
        int v2;
        if(arg7 > 0) {
            int v0 = this.size;
            GF2nField v1 = this.coeff[0].getField();
            this.enlarge(this.size + arg7);
            --v0;
            while(v0 >= 0) {
                this.coeff[v0 + arg7] = this.coeff[v0];
                --v0;
            }

            if((this.coeff[0] instanceof GF2nPolynomialElement)) {
                v2 = arg7 - 1;
                goto label_24;
            }
            else if((this.coeff[0] instanceof GF2nONBElement)) {
                v2 = arg7 - 1;
                while(true) {
                    if(v2 >= 0) {
                        this.coeff[v2] = GF2nONBElement.ZERO(v1);
                        --v2;
                        continue;
                    }

                    return;
                }

            label_24:
                while(v2 >= 0) {
                    this.coeff[v2] = GF2nPolynomialElement.ZERO(v1);
                    --v2;
                }
            }
        }
    }

    public final void shrink() {
        int v0;
        for(v0 = this.size - 1; this.coeff[v0].isZero(); --v0) {
            if(v0 <= 0) {
                break;
            }
        }

        ++v0;
        if(v0 < this.size) {
            GF2nElement[] v1 = new GF2nElement[v0];
            System.arraycopy(this.coeff, 0, v1, 0, v0);
            this.coeff = v1;
            this.size = v0;
        }
    }

    public final int size() {
        return this.size;
    }
}

