// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.math.BigInteger;
import java.util.Random;

public class GF2nPolynomialElement extends GF2nElement {
    private static final int[] bitMask;
    private GF2Polynomial polynomial;

    static {
        GF2nPolynomialElement.bitMask = new int[]{1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072, 262144, 524288, 1048576, 2097152, 4194304, 8388608, 16777216, 33554432, 67108864, 134217728, 268435456, 536870912, 1073741824, -2147483648, 0};
    }

    public GF2nPolynomialElement(GF2nPolynomialField arg3, GF2Polynomial arg4) {
        super();
        this.mField = ((GF2nField)arg3);
        this.mDegree = this.mField.getDegree();
        this.polynomial = new GF2Polynomial(arg4);
        this.polynomial.expandN(this.mDegree);
    }

    public GF2nPolynomialElement(GF2nPolynomialElement arg3) {
        super();
        this.mField = arg3.mField;
        this.mDegree = arg3.mDegree;
        this.polynomial = new GF2Polynomial(arg3.polynomial);
    }

    public GF2nPolynomialElement(GF2nPolynomialField arg3, Random arg4) {
        super();
        this.mField = ((GF2nField)arg3);
        this.mDegree = this.mField.getDegree();
        this.polynomial = new GF2Polynomial(this.mDegree);
        this.randomize(arg4);
    }

    public GF2nPolynomialElement(GF2nPolynomialField arg3, byte[] arg4) {
        super();
        this.mField = ((GF2nField)arg3);
        this.mDegree = this.mField.getDegree();
        this.polynomial = new GF2Polynomial(this.mDegree, arg4);
        this.polynomial.expandN(this.mDegree);
    }

    public GF2nPolynomialElement(GF2nPolynomialField arg3, int[] arg4) {
        super();
        this.mField = ((GF2nField)arg3);
        this.mDegree = this.mField.getDegree();
        this.polynomial = new GF2Polynomial(this.mDegree, arg4);
        this.polynomial.expandN(arg3.mDegree);
    }

    public static GF2nPolynomialElement ONE(GF2nPolynomialField arg5) {
        return new GF2nPolynomialElement(arg5, new GF2Polynomial(arg5.getDegree(), new int[]{1}));
    }

    public static GF2nPolynomialElement ZERO(GF2nPolynomialField arg2) {
        return new GF2nPolynomialElement(arg2, new GF2Polynomial(arg2.getDegree()));
    }

    public GFElement add(GFElement arg2) {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.addToThis(arg2);
        return ((GFElement)v0);
    }

    public void addToThis(GFElement arg3) {
        if(!(arg3 instanceof GF2nPolynomialElement)) {
            throw new RuntimeException();
        }

        if(!this.mField.equals(arg3.mField)) {
            throw new RuntimeException();
        }

        this.polynomial.addToThis(((GF2nPolynomialElement)arg3).polynomial);
    }

    void assignOne() {
        this.polynomial.assignOne();
    }

    void assignZero() {
        this.polynomial.assignZero();
    }

    public Object clone() {
        return new GF2nPolynomialElement(this);
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof GF2nPolynomialElement)) && (this.mField == ((GF2nPolynomialElement)arg4).mField || (this.mField.getFieldPolynomial().equals(((GF2nPolynomialElement)arg4).mField.getFieldPolynomial())))) {
            v0 = this.polynomial.equals(((GF2nPolynomialElement)arg4).polynomial);
        }

        return v0;
    }

    private GF2Polynomial getGF2Polynomial() {
        return new GF2Polynomial(this.polynomial);
    }

    private GF2nPolynomialElement halfTrace() {
        if((this.mDegree & 1) == 0) {
            throw new RuntimeException();
        }

        GF2nPolynomialElement v1 = new GF2nPolynomialElement(this);
        int v0;
        for(v0 = 1; v0 <= this.mDegree - 1 >> 1; ++v0) {
            v1.squareThis();
            v1.squareThis();
            v1.addToThis(((GFElement)this));
        }

        return v1;
    }

    public int hashCode() {
        return this.mField.hashCode() + this.polynomial.hashCode();
    }

    public GF2nElement increase() {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.increaseThis();
        return ((GF2nElement)v0);
    }

    public void increaseThis() {
        this.polynomial.increaseThis();
    }

    public GFElement invert() {
        return this.invertMAIA();
    }

    public GF2nPolynomialElement invertEEA() {
        if(this.isZero()) {
            throw new ArithmeticException();
        }

        GF2Polynomial v3 = new GF2Polynomial(this.mDegree + 32, "ONE");
        v3.reduceN();
        GF2Polynomial v2 = new GF2Polynomial(this.mDegree + 32);
        v2.reduceN();
        GF2Polynomial v1 = this.getGF2Polynomial();
        GF2Polynomial v0 = this.mField.getFieldPolynomial();
        v1.reduceN();
        while(!v1.isOne()) {
            v1.reduceN();
            v0.reduceN();
            int v4 = v1.getLength() - v0.getLength();
            if(v4 < 0) {
                v4 = -v4;
                v3.reduceN();
                GF2Polynomial v6 = v1;
                v1 = v0;
                v0 = v6;
                GF2Polynomial v7 = v3;
                v3 = v2;
                v2 = v7;
            }

            v1.shiftLeftAddThis(v0, v4);
            v3.shiftLeftAddThis(v2, v4);
        }

        v3.reduceN();
        return new GF2nPolynomialElement(this.mField, v3);
    }

    public GF2nPolynomialElement invertMAIA() {
        if(this.isZero()) {
            throw new ArithmeticException();
        }

        GF2Polynomial v3 = new GF2Polynomial(this.mDegree, "ONE");
        GF2Polynomial v2 = new GF2Polynomial(this.mDegree);
        GF2Polynomial v1 = this.getGF2Polynomial();
        GF2Polynomial v0 = this.mField.getFieldPolynomial();
        while(true) {
            if(!v1.testBit(0)) {
                v1.shiftRightThis();
                if(!v3.testBit(0)) {
                    v3.shiftRightThis();
                    continue;
                }

                v3.addToThis(this.mField.getFieldPolynomial());
                v3.shiftRightThis();
                continue;
            }

            if(v1.isOne()) {
                return new GF2nPolynomialElement(this.mField, v3);
            }

            v1.reduceN();
            v0.reduceN();
            if(v1.getLength() < v0.getLength()) {
                GF2Polynomial v7 = v1;
                v1 = v0;
                v0 = v7;
                GF2Polynomial v8 = v3;
                v3 = v2;
                v2 = v8;
            }

            v1.addToThis(v0);
            v3.addToThis(v2);
        }
    }

    public GF2nPolynomialElement invertSquare() {
        if(this.isZero()) {
            throw new ArithmeticException();
        }

        int v4 = this.mField.getDegree() - 1;
        GF2nPolynomialElement v5 = new GF2nPolynomialElement(this);
        v5.polynomial.expandN((this.mDegree << 1) + 32);
        v5.polynomial.reduceN();
        int v2 = 1;
        int v3 = IntegerFunctions.floorLog(v4) - 1;
        while(v3 >= 0) {
            GF2nPolynomialElement v6 = new GF2nPolynomialElement(v5);
            int v0;
            for(v0 = 1; v0 <= v2; ++v0) {
                v6.squareThisPreCalc();
            }

            v5.multiplyThisBy(((GFElement)v6));
            v0 = v2 << 1;
            if((GF2nPolynomialElement.bitMask[v3] & v4) != 0) {
                v5.squareThisPreCalc();
                v5.multiplyThisBy(((GFElement)this));
                ++v0;
            }

            --v3;
            v2 = v0;
        }

        v5.squareThisPreCalc();
        return v5;
    }

    public boolean isOne() {
        return this.polynomial.isOne();
    }

    public boolean isZero() {
        return this.polynomial.isZero();
    }

    public GFElement multiply(GFElement arg2) {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.multiplyThisBy(arg2);
        return ((GFElement)v0);
    }

    public void multiplyThisBy(GFElement arg3) {
        if(!(arg3 instanceof GF2nPolynomialElement)) {
            throw new RuntimeException();
        }

        if(!this.mField.equals(arg3.mField)) {
            throw new RuntimeException();
        }

        if(this.equals(arg3)) {
            this.squareThis();
        }
        else {
            this.polynomial = this.polynomial.multiply(((GF2nPolynomialElement)arg3).polynomial);
            this.reduceThis();
        }
    }

    public GF2nPolynomialElement power(int arg6) {
        GF2nPolynomialElement v0;
        if(arg6 == 1) {
            v0 = new GF2nPolynomialElement(this);
        }
        else {
            GF2nPolynomialElement v1 = GF2nPolynomialElement.ONE(this.mField);
            if(arg6 == 0) {
                v0 = v1;
            }
            else {
                GF2nPolynomialElement v2 = new GF2nPolynomialElement(this);
                v2.polynomial.expandN((v2.mDegree << 1) + 32);
                v2.polynomial.reduceN();
                int v0_1;
                for(v0_1 = 0; v0_1 < this.mDegree; ++v0_1) {
                    if((1 << v0_1 & arg6) != 0) {
                        v1.multiplyThisBy(((GFElement)v2));
                    }

                    v2.square();
                }

                v0 = v1;
            }
        }

        return v0;
    }

    private void randomize(Random arg3) {
        this.polynomial.expandN(this.mDegree);
        this.polynomial.randomize(arg3);
    }

    private void reducePentanomialBitwise(int[] arg7) {
        int v1 = this.mDegree - arg7[2];
        int v2 = this.mDegree - arg7[1];
        int v3 = this.mDegree - arg7[0];
        int v0;
        for(v0 = this.polynomial.getLength() - 1; v0 >= this.mDegree; --v0) {
            if(this.polynomial.testBit(v0)) {
                this.polynomial.xorBit(v0);
                this.polynomial.xorBit(v0 - v1);
                this.polynomial.xorBit(v0 - v2);
                this.polynomial.xorBit(v0 - v3);
                this.polynomial.xorBit(v0 - this.mDegree);
            }
        }

        this.polynomial.reduceN();
        this.polynomial.expandN(this.mDegree);
    }

    private void reduceThis() {
        int[] v0_2;
        int v0_1;
        int v3 = 32;
        if(this.polynomial.getLength() <= this.mDegree) {
            if(this.polynomial.getLength() >= this.mDegree) {
                return;
            }

            this.polynomial.expandN(this.mDegree);
        }
        else if(this.mField.isTrinomial()) {
            try {
                v0_1 = this.mField.getTc();
            }
            catch(RuntimeException v0) {
                throw new RuntimeException("GF2nPolynomialElement.reduce: the field polynomial is not a trinomial");
            }

            if(this.mDegree - v0_1 > v3 && this.polynomial.getLength() <= this.mDegree << 1) {
                this.polynomial.reduceTrinomial(this.mDegree, v0_1);
                return;
            }

            this.reduceTrinomialBitwise(v0_1);
        }
        else {
            if(this.mField.isPentanomial()) {
                try {
                    v0_2 = this.mField.getPc();
                }
                catch(RuntimeException v0) {
                    throw new RuntimeException("GF2nPolynomialElement.reduce: the field polynomial is not a pentanomial");
                }

                if(this.mDegree - v0_2[2] > v3 && this.polynomial.getLength() <= this.mDegree << 1) {
                    this.polynomial.reducePentanomial(this.mDegree, v0_2);
                    return;
                }

                this.reducePentanomialBitwise(v0_2);
                return;
            }

            this.polynomial = this.polynomial.remainder(this.mField.getFieldPolynomial());
            this.polynomial.expandN(this.mDegree);
        }
    }

    private void reduceTrinomialBitwise(int arg5) {
        int v1 = this.mDegree - arg5;
        int v0;
        for(v0 = this.polynomial.getLength() - 1; v0 >= this.mDegree; --v0) {
            if(this.polynomial.testBit(v0)) {
                this.polynomial.xorBit(v0);
                this.polynomial.xorBit(v0 - v1);
                this.polynomial.xorBit(v0 - this.mDegree);
            }
        }

        this.polynomial.reduceN();
        this.polynomial.expandN(this.mDegree);
    }

    public GF2nElement solveQuadraticEquation() {
        GF2nPolynomialElement v3;
        GF2nPolynomialElement v0;
        if(this.isZero()) {
            v0 = GF2nPolynomialElement.ZERO(this.mField);
        }
        else {
            if((this.mDegree & 1) == 1) {
                v0 = this.halfTrace();
                goto label_5;
            }

            do {
                GF2nPolynomialElement v4 = new GF2nPolynomialElement(this.mField, new Random());
                v3 = GF2nPolynomialElement.ZERO(this.mField);
                Object v0_1 = v4.clone();
                int v1;
                for(v1 = 1; v1 < this.mDegree; ++v1) {
                    v3.squareThis();
                    ((GF2nPolynomialElement)v0_1).squareThis();
                    v3.addToThis(((GF2nPolynomialElement)v0_1).multiply(((GFElement)this)));
                    ((GF2nPolynomialElement)v0_1).addToThis(((GFElement)v4));
                }
            }
            while(((GF2nPolynomialElement)v0_1).isZero());

            if(!this.equals(v3.square().add(((GFElement)v3)))) {
                throw new RuntimeException();
            }

            v0 = v3;
        }

    label_5:
        return ((GF2nElement)v0);
    }

    public GF2nElement square() {
        return this.squarePreCalc();
    }

    public GF2nPolynomialElement squareBitwise() {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.squareThisBitwise();
        v0.reduceThis();
        return v0;
    }

    public GF2nPolynomialElement squareMatrix() {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.squareThisMatrix();
        v0.reduceThis();
        return v0;
    }

    public GF2nPolynomialElement squarePreCalc() {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.squareThisPreCalc();
        v0.reduceThis();
        return v0;
    }

    public GF2nElement squareRoot() {
        GF2nPolynomialElement v0 = new GF2nPolynomialElement(this);
        v0.squareRootThis();
        return ((GF2nElement)v0);
    }

    public void squareRootThis() {
        this.polynomial.expandN((this.mDegree << 1) + 32);
        this.polynomial.reduceN();
        int v0;
        for(v0 = 0; v0 < this.mField.getDegree() - 1; ++v0) {
            this.squareThis();
        }
    }

    public void squareThis() {
        this.squareThisPreCalc();
    }

    public void squareThisBitwise() {
        this.polynomial.squareThisBitwise();
        this.reduceThis();
    }

    public void squareThisMatrix() {
        GF2Polynomial v2 = new GF2Polynomial(this.mDegree);
        int v1;
        for(v1 = 0; v1 < this.mDegree; ++v1) {
            if(this.polynomial.vectorMult(this.mField.squaringMatrix[this.mDegree - v1 - 1])) {
                v2.setBit(v1);
            }
        }

        this.polynomial = v2;
    }

    public void squareThisPreCalc() {
        this.polynomial.squareThisPreCalc();
        this.reduceThis();
    }

    boolean testBit(int arg2) {
        return this.polynomial.testBit(arg2);
    }

    public boolean testRightmostBit() {
        return this.polynomial.testBit(0);
    }

    public byte[] toByteArray() {
        return this.polynomial.toByteArray();
    }

    public BigInteger toFlexiBigInt() {
        return this.polynomial.toFlexiBigInt();
    }

    public String toString() {
        return this.polynomial.toString(16);
    }

    public String toString(int arg2) {
        return this.polynomial.toString(arg2);
    }

    public int trace() {
        int v1 = 1;
        GF2nPolynomialElement v2 = new GF2nPolynomialElement(this);
        int v0;
        for(v0 = 1; v0 < this.mDegree; ++v0) {
            v2.squareThis();
            v2.addToThis(((GFElement)this));
        }

        if(!v2.isOne()) {
            v1 = 0;
        }

        return v1;
    }
}

