// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.util.Random;
import java.util.Vector;

public class GF2nPolynomialField extends GF2nField {
    private boolean isPentanomial;
    private boolean isTrinomial;
    private int[] pc;
    GF2Polynomial[] squaringMatrix;
    private int tc;

    public GF2nPolynomialField(int arg3) {
        super();
        this.isTrinomial = false;
        this.isPentanomial = false;
        this.pc = new int[3];
        if(arg3 < 3) {
            throw new IllegalArgumentException("k must be at least 3");
        }

        this.mDegree = arg3;
        this.computeFieldPolynomial();
        this.computeSquaringMatrix();
        this.fields = new Vector();
        this.matrices = new Vector();
    }

    public GF2nPolynomialField(int arg8, GF2Polynomial arg9) {
        int v6 = 5;
        int v5 = 3;
        super();
        this.isTrinomial = false;
        this.isPentanomial = false;
        this.pc = new int[v5];
        if(arg8 < v5) {
            throw new IllegalArgumentException("degree must be at least 3");
        }

        if(arg9.getLength() != arg8 + 1) {
            throw new RuntimeException();
        }

        if(!arg9.isIrreducible()) {
            throw new RuntimeException();
        }

        this.mDegree = arg8;
        this.fieldPolynomial = arg9;
        this.computeSquaringMatrix();
        int v2 = 2;
        int v0;
        for(v0 = 1; v0 < this.fieldPolynomial.getLength() - 1; ++v0) {
            if(this.fieldPolynomial.testBit(v0)) {
                ++v2;
                if(v2 == v5) {
                    this.tc = v0;
                }

                if(v2 > v6) {
                    goto label_45;
                }

                this.pc[v2 - 3] = v0;
            }

        label_45:
        }

        if(v2 == v5) {
            this.isTrinomial = true;
        }

        if(v2 == v6) {
            this.isPentanomial = true;
        }

        this.fields = new Vector();
        this.matrices = new Vector();
    }

    public GF2nPolynomialField(int arg3, boolean arg4) {
        super();
        this.isTrinomial = false;
        this.isPentanomial = false;
        this.pc = new int[3];
        if(arg3 < 3) {
            throw new IllegalArgumentException("k must be at least 3");
        }

        this.mDegree = arg3;
        if(arg4) {
            this.computeFieldPolynomial();
        }
        else {
            this.computeFieldPolynomial2();
        }

        this.computeSquaringMatrix();
        this.fields = new Vector();
        this.matrices = new Vector();
    }

    protected void computeCOBMatrix(GF2nField arg8) {
        GF2nONBElement[] v2;
        GF2nElement v5;
        if(this.mDegree != arg8.mDegree) {
            throw new IllegalArgumentException("GF2nPolynomialField.computeCOBMatrix: B1 has a different degree and thus cannot be coverted to!");
        }

        if((arg8 instanceof GF2nONBField)) {
            arg8.computeCOBMatrix(((GF2nField)this));
        }
        else {
            GF2Polynomial[] v4 = new GF2Polynomial[this.mDegree];
            int v0;
            for(v0 = 0; v0 < this.mDegree; ++v0) {
                v4[v0] = new GF2Polynomial(this.mDegree);
            }

            do {
                v5 = arg8.getRandomRoot(this.fieldPolynomial);
            }
            while(v5.isZero());

            if((v5 instanceof GF2nONBElement)) {
                v2 = new GF2nONBElement[this.mDegree];
                v2[this.mDegree - 1] = GF2nONBElement.ONE(arg8);
            }
            else {
                GF2nPolynomialElement[] v2_1 = new GF2nPolynomialElement[this.mDegree];
                v2_1[this.mDegree - 1] = GF2nPolynomialElement.ONE(arg8);
            }

            v2[this.mDegree - 2] = v5;
            int v3;
            for(v3 = this.mDegree - 3; v3 >= 0; --v3) {
                v2[v3] = v2[v3 + 1].multiply(((GFElement)v5));
            }

            if((arg8 instanceof GF2nONBField)) {
                v0 = 0;
                goto label_61;
            }
            else {
                v0 = 0;
                while(true) {
                    if(v0 < this.mDegree) {
                        for(v3 = 0; v3 < this.mDegree; ++v3) {
                            if(v2[v0].testBit(v3)) {
                                v4[this.mDegree - v3 - 1].setBit(this.mDegree - v0 - 1);
                            }
                        }

                        ++v0;
                        continue;
                    }

                    goto label_105;
                }

            label_61:
                while(v0 < this.mDegree) {
                    for(v3 = 0; v3 < this.mDegree; ++v3) {
                        if(v2[v0].testBit(this.mDegree - v3 - 1)) {
                            v4[this.mDegree - v3 - 1].setBit(this.mDegree - v0 - 1);
                        }
                    }

                    ++v0;
                }
            }

        label_105:
            this.fields.addElement(arg8);
            this.matrices.addElement(v4);
            arg8.fields.addElement(this);
            arg8.matrices.addElement(this.invertMatrix(v4));
        }
    }

    protected void computeFieldPolynomial() {
        if(!this.testTrinomials() && !this.testPentanomials()) {
            this.testRandom();
        }
    }

    protected void computeFieldPolynomial2() {
        if(!this.testTrinomials() && !this.testPentanomials()) {
            this.testRandom();
        }
    }

    private void computeSquaringMatrix() {
        int v1 = 0;
        GF2Polynomial[] v3 = new GF2Polynomial[this.mDegree - 1];
        this.squaringMatrix = new GF2Polynomial[this.mDegree];
        int v0;
        for(v0 = 0; v0 < this.squaringMatrix.length; ++v0) {
            this.squaringMatrix[v0] = new GF2Polynomial(this.mDegree, "ZERO");
        }

        while(v1 < this.mDegree - 1) {
            v3[v1] = new GF2Polynomial(1, "ONE").shiftLeft(this.mDegree + v1).remainder(this.fieldPolynomial);
            ++v1;
        }

        for(v0 = 1; v0 <= Math.abs(this.mDegree >> 1); ++v0) {
            for(v1 = 1; v1 <= this.mDegree; ++v1) {
                if(v3[this.mDegree - (v0 << 1)].testBit(this.mDegree - v1)) {
                    this.squaringMatrix[v1 - 1].setBit(this.mDegree - v0);
                }
            }
        }

        for(v0 = Math.abs(this.mDegree >> 1) + 1; v0 <= this.mDegree; ++v0) {
            this.squaringMatrix[(v0 << 1) - this.mDegree - 1].setBit(this.mDegree - v0);
        }
    }

    public int[] getPc() {
        int v3 = 3;
        if(!this.isPentanomial) {
            throw new RuntimeException();
        }

        int[] v0 = new int[v3];
        System.arraycopy(this.pc, 0, v0, 0, v3);
        return v0;
    }

    protected GF2nElement getRandomRoot(GF2Polynomial arg7) {
        int v4_1;
        GF2nPolynomial v2 = new GF2nPolynomial(arg7, ((GF2nField)this));
        int v0 = v2.getDegree();
        GF2nPolynomial v3 = v2;
        while(v0 > 1) {
            do {
            label_6:
                GF2nPolynomialElement v0_1 = new GF2nPolynomialElement(this, new Random());
                GF2nPolynomial v4 = new GF2nPolynomial(2, GF2nPolynomialElement.ZERO(this));
                v4.set(1, ((GF2nElement)v0_1));
                v2 = new GF2nPolynomial(v4);
                for(v0 = 1; v0 <= this.mDegree - 1; ++v0) {
                    v2 = v2.multiplyAndReduce(v2, v3).add(v4);
                }

                v2 = v2.gcd(v3);
                v0 = v2.getDegree();
                v4_1 = v3.getDegree();
                if(v0 == 0) {
                    goto label_6;
                }
            }
            while(v0 == v4_1);

            GF2nPolynomial v0_2 = v0 << 1 > v4_1 ? v3.quotient(v2) : new GF2nPolynomial(v2);
            v3 = v0_2;
            v0 = v0_2.getDegree();
        }

        return v3.at(0);
    }

    public GF2Polynomial getSquaringVector(int arg3) {
        return new GF2Polynomial(this.squaringMatrix[arg3]);
    }

    public int getTc() {
        if(!this.isTrinomial) {
            throw new RuntimeException();
        }

        return this.tc;
    }

    public boolean isPentanomial() {
        return this.isPentanomial;
    }

    public boolean isTrinomial() {
        return this.isTrinomial;
    }

    private boolean testPentanomials() {
        this.fieldPolynomial = new GF2Polynomial(this.mDegree + 1);
        this.fieldPolynomial.setBit(0);
        this.fieldPolynomial.setBit(this.mDegree);
        boolean v0 = false;
        int v2 = 0;
        int v3;
        for(v3 = 1; v3 <= this.mDegree - 3; ++v3) {
            if(v0) {
                return v0;
            }

            this.fieldPolynomial.setBit(v3);
            int v5;
            for(v5 = v3 + 1; v5 <= this.mDegree - 2; ++v5) {
                if(v0) {
                    break;
                }

                this.fieldPolynomial.setBit(v5);
                int v6;
                for(v6 = v5 + 1; v6 <= this.mDegree - 1; ++v6) {
                    if(v0) {
                        break;
                    }

                    this.fieldPolynomial.setBit(v6);
                    int v8 = (this.mDegree & 1) != 0 ? 1 : 0;
                    int v7 = (v3 & 1) != 0 ? 1 : 0;
                    v8 |= v7;
                    v7 = (v5 & 1) != 0 ? 1 : 0;
                    v8 |= v7;
                    v7 = (v6 & 1) != 0 ? 1 : 0;
                    if((v7 | v8) != 0) {
                        v0 = this.fieldPolynomial.isIrreducible();
                        ++v2;
                        if(v0) {
                            this.isPentanomial = true;
                            this.pc[0] = v3;
                            this.pc[1] = v5;
                            this.pc[2] = v6;
                            return v0;
                        }
                    }

                    this.fieldPolynomial.resetBit(v6);
                }

                this.fieldPolynomial.resetBit(v5);
            }

            this.fieldPolynomial.resetBit(v3);
        }

        return v0;
    }

    private boolean testRandom() {
        this.fieldPolynomial = new GF2Polynomial(this.mDegree + 1);
        int v1 = 0;
        do {
            ++v1;
            this.fieldPolynomial.randomize();
            this.fieldPolynomial.setBit(this.mDegree);
            this.fieldPolynomial.setBit(0);
        }
        while(!this.fieldPolynomial.isIrreducible());

        return 1;
    }

    private boolean testTrinomials() {
        boolean v0 = false;
        this.fieldPolynomial = new GF2Polynomial(this.mDegree + 1);
        this.fieldPolynomial.setBit(0);
        this.fieldPolynomial.setBit(this.mDegree);
        int v1 = 0;
        int v2 = 1;
        while(v2 < this.mDegree) {
            if(v0) {
                return v0;
            }

            this.fieldPolynomial.setBit(v2);
            v0 = this.fieldPolynomial.isIrreducible();
            ++v1;
            if(v0) {
                this.isTrinomial = true;
                this.tc = v2;
            }
            else {
                this.fieldPolynomial.resetBit(v2);
                v0 = this.fieldPolynomial.isIrreducible();
                ++v2;
                continue;
            }

            return v0;
        }

        return v0;
    }
}

