// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;

public final class IntegerFunctions {
    private static final BigInteger FOUR = null;
    private static final BigInteger ONE = null;
    private static final int[] SMALL_PRIMES = null;
    private static final long SMALL_PRIME_PRODUCT = 152125131763605L;
    private static final BigInteger TWO;
    private static final BigInteger ZERO;
    private static final int[] jacobiTable;
    private static SecureRandom sr;

    static {
        IntegerFunctions.ZERO = BigInteger.valueOf(0);
        IntegerFunctions.ONE = BigInteger.valueOf(1);
        IntegerFunctions.TWO = BigInteger.valueOf(2);
        IntegerFunctions.FOUR = BigInteger.valueOf(4);
        IntegerFunctions.SMALL_PRIMES = new int[]{3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41};
        IntegerFunctions.sr = null;
        IntegerFunctions.jacobiTable = new int[]{0, 1, 0, -1, 0, -1, 0, 1};
    }

    private IntegerFunctions() {
        super();
    }

    public static BigInteger binomial(int arg4, int arg5) {
        BigInteger v0 = IntegerFunctions.ONE;
        if(arg4 != 0) {
            if(arg5 > arg4 >>> 1) {
                arg5 = arg4 - arg5;
            }

            int v1 = 1;
            while(v1 <= arg5) {
                BigInteger v2 = v0.multiply(BigInteger.valueOf(((long)(arg4 - (v1 - 1))))).divide(BigInteger.valueOf(((long)v1)));
                ++v1;
                v0 = v2;
            }
        }
        else if(arg5 != 0) {
            v0 = IntegerFunctions.ZERO;
        }

        return v0;
    }

    public static int bitCount(int arg2) {
        int v0 = 0;
        while(arg2 != 0) {
            v0 += arg2 & 1;
            arg2 >>>= 1;
        }

        return v0;
    }

    public static int ceilLog(int arg2) {
        int v1 = 0;
        int v0 = 1;
        while(v0 < arg2) {
            v0 <<= 1;
            ++v1;
        }

        return v1;
    }

    public static int ceilLog(BigInteger arg3) {
        int v1 = 0;
        BigInteger v0;
        for(v0 = IntegerFunctions.ONE; v0.compareTo(arg3) < 0; v0 = v0.shiftLeft(1)) {
            ++v1;
        }

        return v1;
    }

    public static int ceilLog256(int arg1) {
        int v0;
        if(arg1 == 0) {
            v0 = 1;
        }
        else {
            if(arg1 < 0) {
                arg1 = -arg1;
            }

            v0 = 0;
            while(arg1 > 0) {
                ++v0;
                arg1 >>>= 8;
            }
        }

        return v0;
    }

    public static int ceilLog256(long arg4) {
        int v0;
        long v2 = 0;
        if(arg4 == v2) {
            v0 = 1;
        }
        else {
            if(arg4 < v2) {
                arg4 = -arg4;
            }

            v0 = 0;
            while(arg4 > v2) {
                ++v0;
                arg4 >>>= 8;
            }
        }

        return v0;
    }

    public static BigInteger divideAndRound(BigInteger arg2, BigInteger arg3) {
        BigInteger v0;
        if(arg2.signum() < 0) {
            v0 = IntegerFunctions.divideAndRound(arg2.negate(), arg3).negate();
        }
        else if(arg3.signum() < 0) {
            v0 = IntegerFunctions.divideAndRound(arg2, arg3.negate()).negate();
        }
        else {
            v0 = arg2.shiftLeft(1).add(arg3).divide(arg3.shiftLeft(1));
        }

        return v0;
    }

    public static BigInteger[] divideAndRound(BigInteger[] arg3, BigInteger arg4) {
        BigInteger[] v1 = new BigInteger[arg3.length];
        int v0;
        for(v0 = 0; v0 < arg3.length; ++v0) {
            v1[v0] = IntegerFunctions.divideAndRound(arg3[v0], arg4);
        }

        return v1;
    }

    public static int[] extGCD(int arg6, int arg7) {
        BigInteger[] v0 = IntegerFunctions.extgcd(BigInteger.valueOf(((long)arg6)), BigInteger.valueOf(((long)arg7)));
        return new int[]{v0[0].intValue(), v0[1].intValue(), v0[2].intValue()};
    }

    public static BigInteger[] extgcd(BigInteger arg9, BigInteger arg10) {
        BigInteger v3;
        BigInteger v1;
        BigInteger v2 = IntegerFunctions.ONE;
        BigInteger v0 = IntegerFunctions.ZERO;
        if(arg10.signum() != 0) {
            v1 = arg9;
            v3 = v2;
            v2 = IntegerFunctions.ZERO;
            v0 = arg10;
            while(v0.signum() != 0) {
                BigInteger[] v1_1 = v1.divideAndRemainder(v0);
                BigInteger v4 = v1_1[0];
                BigInteger v7 = v1_1[1];
                v1 = v0;
                v0 = v7;
                BigInteger v8 = v3.subtract(v4.multiply(v2));
                v3 = v2;
                v2 = v8;
            }

            v0 = v1.subtract(arg9.multiply(v3)).divide(arg10);
        }
        else {
            v1 = arg9;
            v3 = v2;
        }

        return new BigInteger[]{v1, v3, v0};
    }

    public static float floatLog(float arg12) {
        double v4 = ((double)((arg12 - 1f) / (1f + arg12)));
        int v1 = 1;
        float v0 = ((float)v4);
        double v2 = v4;
        while(v2 > 0.001) {
            v1 += 2;
            v2 *= v4 * v4;
            v0 = ((float)((((double)v0)) + 1 / (((double)v1)) * v2));
        }

        return v0 * 2f;
    }

    public static float floatPow(float arg1, int arg2) {
        float v0 = 1f;
        while(arg2 > 0) {
            v0 *= arg1;
            --arg2;
        }

        return v0;
    }

    public static int floorLog(int arg4) {
        int v0;
        if(arg4 <= 0) {
            v0 = -1;
        }
        else {
            v0 = 0;
            int v1 = arg4 >>> 1;
            while(v1 > 0) {
                v1 >>>= 1;
                ++v0;
            }
        }

        return v0;
    }

    public static int floorLog(BigInteger arg3) {
        int v1 = -1;
        BigInteger v0;
        for(v0 = IntegerFunctions.ONE; v0.compareTo(arg3) <= 0; v0 = v0.shiftLeft(1)) {
            ++v1;
        }

        return v1;
    }

    public static int gcd(int arg3, int arg4) {
        return BigInteger.valueOf(((long)arg3)).gcd(BigInteger.valueOf(((long)arg4))).intValue();
    }

    public static float intRoot(int arg8, int arg9) {
        float v2 = ((float)(arg8 / arg9));
        float v1 = 0f;
        int v0 = 0;
        while((((double)Math.abs(v1 - v2))) > 0.0001) {
            float v3;
            for(v3 = IntegerFunctions.floatPow(v2, arg9); Float.isInfinite(v3); v3 = IntegerFunctions.floatPow(v3, arg9)) {
                v3 = (v2 + v1) / 2f;
                v2 = v3;
            }

            ++v0;
            float v7 = v2;
            v2 -= (v3 - (((float)arg8))) / ((((float)arg9)) * IntegerFunctions.floatPow(v2, arg9 - 1));
            v1 = v7;
        }

        return v2;
    }

    public static byte[] integerToOctets(BigInteger arg5) {
        byte[] v0 = arg5.abs().toByteArray();
        if((arg5.bitLength() & 7) == 0) {
            byte[] v1 = new byte[arg5.bitLength() >> 3];
            System.arraycopy(v0, 1, v1, 0, v1.length);
            v0 = v1;
        }

        return v0;
    }

    public static boolean isIncreasing(int[] arg4) {
        boolean v1 = true;
        int v0 = 1;
        while(v0 < arg4.length) {
            if(arg4[v0 - 1] >= arg4[v0]) {
                System.out.println("a[" + (v0 - 1) + "] = " + arg4[v0 - 1] + " >= " + arg4[v0] + " = a[" + v0 + "]");
                v1 = false;
            }
            else {
                ++v0;
                continue;
            }

            return v1;
        }

        return v1;
    }

    public static int isPower(int arg3, int arg4) {
        int v0 = -1;
        if(arg3 > 0) {
            int v1 = 0;
            while(true) {
                if(arg3 <= 1) {
                    break;
                }
                else if(arg3 % arg4 == 0) {
                    arg3 /= arg4;
                    ++v1;
                    continue;
                }

                return v0;
            }

            v0 = v1;
        }

        return v0;
    }

    public static boolean isPrime(int arg4) {
        int v0 = 2;
        boolean v1 = false;
        if(arg4 >= v0) {
            if(arg4 == v0) {
                v1 = true;
            }
            else if((arg4 & 1) != 0) {
                if(arg4 < 42) {
                    v0 = 0;
                    while(v0 < IntegerFunctions.SMALL_PRIMES.length) {
                        if(arg4 == IntegerFunctions.SMALL_PRIMES[v0]) {
                            return true;
                        }
                        else {
                            ++v0;
                            continue;
                        }
                    }
                }

                if(arg4 % 3 == 0) {
                    return v1;
                }

                if(arg4 % 5 == 0) {
                    return v1;
                }

                if(arg4 % 7 == 0) {
                    return v1;
                }

                if(arg4 % 11 == 0) {
                    return v1;
                }

                if(arg4 % 13 == 0) {
                    return v1;
                }

                if(arg4 % 17 == 0) {
                    return v1;
                }

                if(arg4 % 19 == 0) {
                    return v1;
                }

                if(arg4 % 23 == 0) {
                    return v1;
                }

                if(arg4 % 29 == 0) {
                    return v1;
                }

                if(arg4 % 31 == 0) {
                    return v1;
                }

                if(arg4 % 37 == 0) {
                    return v1;
                }

                if(arg4 % 41 == 0) {
                    return v1;
                }

                v1 = BigInteger.valueOf(((long)arg4)).isProbablePrime(20);
            }
        }

        return v1;
    }

    public static int jacobi(BigInteger arg7, BigInteger arg8) {
        BigInteger v6;
        int v5 = -1;
        int v0 = 1;
        int v1 = 0;
        long v2 = 1;
        if(arg8.equals(IntegerFunctions.ZERO)) {
            if(!arg7.abs().equals(IntegerFunctions.ONE)) {
                v0 = 0;
            }

            v1 = v0;
        }
        else {
            if(!arg7.testBit(0) && !arg8.testBit(0)) {
                return v1;
            }

            if(arg8.signum() == v5) {
                arg8 = arg8.negate();
                if(arg7.signum() == v5) {
                    v2 = -1;
                }
            }

            BigInteger v4 = IntegerFunctions.ZERO;
            while(!arg8.testBit(0)) {
                v4 = v4.add(IntegerFunctions.ONE);
                arg8 = arg8.divide(IntegerFunctions.TWO);
            }

            if(v4.testBit(0)) {
                v2 *= ((long)IntegerFunctions.jacobiTable[arg7.intValue() & 7]);
            }

            if(arg7.signum() < 0) {
                if(arg8.testBit(1)) {
                    v2 = -v2;
                }

                arg7 = arg7.negate();
            }

            while(arg7.signum() != 0) {
                v4 = IntegerFunctions.ZERO;
                while(!arg7.testBit(0)) {
                    v4 = v4.add(IntegerFunctions.ONE);
                    arg7 = arg7.divide(IntegerFunctions.TWO);
                }

                if(v4.testBit(0)) {
                    v2 *= ((long)IntegerFunctions.jacobiTable[arg8.intValue() & 7]);
                }

                if(arg7.compareTo(arg8) < 0) {
                    if((arg8.testBit(1)) && (arg7.testBit(1))) {
                        v2 = -v2;
                        v6 = arg7;
                        arg7 = arg8;
                        arg8 = v6;
                        goto label_75;
                    }

                    v6 = arg7;
                    arg7 = arg8;
                    arg8 = v6;
                }

            label_75:
                arg7 = arg7.subtract(arg8);
            }

            if(!arg8.equals(IntegerFunctions.ONE)) {
                return v1;
            }

            v1 = ((int)v2);
        }

        return v1;
    }

    public static BigInteger leastCommonMultiple(BigInteger[] arg5) {
        int v2 = arg5.length;
        BigInteger v1 = arg5[0];
        int v0;
        for(v0 = 1; v0 < v2; ++v0) {
            v1 = v1.multiply(arg5[v0]).divide(v1.gcd(arg5[v0]));
        }

        return v1;
    }

    public static int leastDiv(int arg3) {
        int v0;
        int v1 = arg3 < 0 ? -arg3 : arg3;
        if(v1 == 0) {
            v0 = 1;
        }
        else if((v1 & 1) == 0) {
            v0 = 2;
        }
        else {
            v0 = 3;
            while(true) {
                if(v0 > v1 / v0) {
                    break;
                }
                else if(v1 % v0 != 0) {
                    v0 += 2;
                    continue;
                }

                return v0;
            }

            v0 = v1;
        }

        return v0;
    }

    public static double log(double arg8) {
        double v6 = 2;
        double v0 = 1;
        if(arg8 <= 0 || arg8 >= v0) {
            int v4 = 0;
            double v2 = v0;
            v0 = arg8;
            while(v0 > v6) {
                v0 /= v6;
                ++v4;
                v2 *= v6;
            }

            v0 = IntegerFunctions.logBKM(arg8 / v2) + (((double)v4));
        }
        else {
            v0 = -IntegerFunctions.log(v0 / arg8);
        }

        return v0;
    }

    public static double log(long arg5) {
        int v0 = IntegerFunctions.floorLog(BigInteger.valueOf(arg5));
        return (((double)v0)) + IntegerFunctions.logBKM((((double)arg5)) / (((double)(((long)(1 << v0))))));
    }

    private static double logBKM(double arg14) {
        double[] v9 = new double[]{1, 0.584963, 0.321928, 0.169925, 0.087463, 0.044394, 0.022368, 0.011227, 0.005625, 0.002815, 0.001408, 0.000704, 0.000352, 0.000176, 0.000088, 0.000044, 0.000022, 0.000011, 0.000006, 0.000003, 0.000001, 0.000001, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        int v10 = 53;
        int v6 = 0;
        double v7 = 1;
        double v4 = 1;
        double v0 = 0;
        while(v6 < v10) {
            double v2 = v4 * v7 + v4;
            if(v2 <= arg14) {
                v0 += v9[v6];
            }
            else {
                v2 = v4;
            }

            v7 *= 0.5;
            ++v6;
            v4 = v2;
        }

        return v0;
    }

    public static void main(String[] arg2) {
        System.out.println("test");
        System.out.println(IntegerFunctions.floatLog(10f));
        System.out.println("test2");
    }

    public static int maxPower(int arg3) {
        int v0 = 0;
        if(arg3 != 0) {
            int v1 = 1;
            while((arg3 & v1) == 0) {
                v1 <<= 1;
                ++v0;
            }
        }

        return v0;
    }

    public static long mod(long arg4, long arg6) {
        long v0 = arg4 % arg6;
        if(v0 < 0) {
            v0 += arg6;
        }

        return v0;
    }

    public static int modInverse(int arg3, int arg4) {
        return BigInteger.valueOf(((long)arg3)).modInverse(BigInteger.valueOf(((long)arg4))).intValue();
    }

    public static long modInverse(long arg2, long arg4) {
        return BigInteger.valueOf(arg2).modInverse(BigInteger.valueOf(arg4)).longValue();
    }

    public static int modPow(int arg4, int arg5, int arg6) {
        int v0;
        if(arg6 <= 0 || arg6 * arg6 > 2147483647 || arg5 < 0) {
            v0 = 0;
        }
        else {
            int v2 = (arg4 % arg6 + arg6) % arg6;
            v0 = 1;
            while(arg5 > 0) {
                if((arg5 & 1) == 1) {
                    v0 = v0 * v2 % arg6;
                }

                v2 = v2 * v2 % arg6;
                arg5 >>>= 1;
            }
        }

        return v0;
    }

    public static BigInteger nextPrime(long arg13) {
        long v0_2;
        int v2;
        long v11;
        BigInteger v0_1;
        int v0 = 0;
        long v1 = 0;
        if(arg13 <= 1) {
            v0_1 = BigInteger.valueOf(2);
        }
        else if(arg13 == 2) {
            v0_1 = BigInteger.valueOf(3);
        }
        else {
            long v3 = 1 + arg13 + (1 & arg13);
            while(v3 <= arg13 << 1) {
                if(v0 != 0) {
                    break;
                }

                long v5;
                for(v5 = 3; v5 <= v3 >> 1; v5 += 2) {
                    if(v0 != 0) {
                        break;
                    }

                    if(v3 % v5 == 0) {
                        v0 = 1;
                    }
                }

                if(v0 != 0) {
                    v11 = v1;
                    v2 = 0;
                    v0_2 = v11;
                }
                else {
                    v2 = 1;
                    v0_2 = v3;
                }

                v3 += 2;
                v11 = v0_2;
                v0 = v2;
                v1 = v11;
            }

            v0_1 = BigInteger.valueOf(v1);
        }

        return v0_1;
    }

    public static BigInteger nextProbablePrime(BigInteger arg1) {
        return IntegerFunctions.nextProbablePrime(arg1, 20);
    }

    public static BigInteger nextProbablePrime(BigInteger arg7, int arg8) {
        BigInteger v0;
        long v5 = 0;
        if(arg7.signum() < 0 || arg7.signum() == 0 || (arg7.equals(IntegerFunctions.ONE))) {
            v0 = IntegerFunctions.TWO;
        }
        else {
            v0 = arg7.add(IntegerFunctions.ONE);
            if(!v0.testBit(0)) {
                v0 = v0.add(IntegerFunctions.ONE);
            }

            while(true) {
                if(v0.bitLength() > 6) {
                    long v1 = v0.remainder(BigInteger.valueOf(152125131763605L)).longValue();
                    if(v1 % 3 != v5 && v1 % 5 != v5 && v1 % 7 != v5 && v1 % 11 != v5 && v1 % 13 != v5 && v1 % 17 != v5 && v1 % 19 != v5 && v1 % 23 != v5 && v1 % 29 != v5 && v1 % 31 != v5 && v1 % 37 != v5 && v1 % 41 != v5) {
                        goto label_63;
                    }

                    v0 = v0.add(IntegerFunctions.TWO);
                    continue;
                }

            label_63:
                if(v0.bitLength() < 4) {
                    return v0;
                }

                if(v0.isProbablePrime(arg8)) {
                    return v0;
                }

                v0 = v0.add(IntegerFunctions.TWO);
            }
        }

        return v0;
    }

    public static int nextSmallerPrime(int arg6) {
        int v5 = 3;
        int v0 = 2;
        int v1 = 1;
        if(arg6 > v0) {
            if(arg6 == v5) {
                v1 = v0;
            }
            else {
                int v3;
                for(v3 = (arg6 & 1) == 0 ? arg6 - 1 : arg6 - 2; true; v3 += -2) {
                    v0 = v3 > v5 ? 1 : 0;
                    int v4 = !IntegerFunctions.isPrime(v3) ? 1 : 0;
                    if((v0 & v4) == 0) {
                        break;
                    }
                }

                v1 = v3;
            }
        }

        return v1;
    }

    public static BigInteger octetsToInteger(byte[] arg2) {
        return IntegerFunctions.octetsToInteger(arg2, 0, arg2.length);
    }

    public static BigInteger octetsToInteger(byte[] arg2, int arg3, int arg4) {
        byte[] v0 = new byte[arg4 + 1];
        v0[0] = 0;
        System.arraycopy(arg2, arg3, v0, 1, arg4);
        return new BigInteger(v0);
    }

    public static int order(int arg3, int arg4) {
        int v0 = arg3 % arg4;
        if(v0 == 0) {
            throw new IllegalArgumentException(arg3 + " is not an element of Z/(" + arg4 + "Z)^*; it is not meaningful to compute its order.");
        }

        int v1;
        for(v1 = 1; v0 != 1; ++v1) {
            v0 = v0 * arg3 % arg4;
            if(v0 < 0) {
                v0 += arg4;
            }
        }

        return v1;
    }

    public static boolean passesSmallPrimeTest(BigInteger arg5) {
        boolean v1 = false;
        int[] v2 = new int[]{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997, 1009, 1013, 1019, 1021, 1031, 1033, 1039, 1049, 1051, 1061, 1063, 1069, 1087, 1091, 1093, 1097, 1103, 1109, 1117, 1123, 1129, 1151, 1153, 1163, 1171, 1181, 1187, 1193, 1201, 1213, 1217, 1223, 1229, 1231, 1237, 1249, 1259, 1277, 1279, 1283, 1289, 1291, 1297, 1301, 1303, 1307, 1319, 1321, 1327, 1361, 1367, 1373, 1381, 1399, 1409, 1423, 1427, 1429, 1433, 1439, 1447, 1451, 1453, 1459, 1471, 1481, 1483, 1487, 1489, 1493, 1499};
        int v0 = 0;
        while(true) {
            if(v0 >= v2.length) {
                return true;
            }
            else if(!arg5.mod(BigInteger.valueOf(((long)v2[v0]))).equals(IntegerFunctions.ZERO)) {
                ++v0;
                continue;
            }

            return v1;
        }

        return true;
    }

    public static int pow(int arg3, int arg4) {
        int v0 = 1;
        while(arg4 > 0) {
            if((arg4 & 1) == 1) {
                v0 *= arg3;
            }

            arg3 *= arg3;
            arg4 >>>= 1;
        }

        return v0;
    }

    public static long pow(long arg4, int arg6) {
        long v0 = 1;
        while(arg6 > 0) {
            if((arg6 & 1) == 1) {
                v0 *= arg4;
            }

            arg4 *= arg4;
            arg6 >>>= 1;
        }

        return v0;
    }

    public static BigInteger randomize(BigInteger arg1) {
        if(IntegerFunctions.sr == null) {
            IntegerFunctions.sr = new SecureRandom();
        }

        return IntegerFunctions.randomize(arg1, IntegerFunctions.sr);
    }

    public static BigInteger randomize(BigInteger arg6, SecureRandom arg7) {
        BigInteger v0_1;
        SecureRandom v0;
        int v3 = arg6.bitLength();
        BigInteger v2 = BigInteger.valueOf(0);
        if(arg7 != null) {
            v0 = arg7;
        }
        else if(IntegerFunctions.sr != null) {
            v0 = IntegerFunctions.sr;
        }
        else {
            v0 = new SecureRandom();
        }

        BigInteger v1 = v2;
        int v2_1 = 0;
        while(true) {
            if(v2_1 < 20) {
                v1 = new BigInteger(v3, ((Random)v0));
                if(v1.compareTo(arg6) < 0) {
                    v0_1 = v1;
                }
                else {
                    ++v2_1;
                    continue;
                }
            }
            else {
                break;
            }

            return v0_1;
        }

        return v1.mod(arg6);
    }

    public static BigInteger reduceInto(BigInteger arg2, BigInteger arg3, BigInteger arg4) {
        return arg2.subtract(arg3).mod(arg4.subtract(arg3)).add(arg3);
    }

    public static BigInteger ressol(BigInteger arg14, BigInteger arg15) {
        if(arg14.compareTo(IntegerFunctions.ZERO) < 0) {
            arg14 = arg14.add(arg15);
        }

        if(arg14.equals(IntegerFunctions.ZERO)) {
            arg14 = IntegerFunctions.ZERO;
        }
        else if(!arg15.equals(IntegerFunctions.TWO)) {
            if((arg15.testBit(0)) && (arg15.testBit(1))) {
                if(IntegerFunctions.jacobi(arg14, arg15) == 1) {
                    return arg14.modPow(arg15.add(IntegerFunctions.ONE).shiftRight(2), arg15);
                }
                else {
                    throw new IllegalArgumentException("No quadratic residue: " + arg14 + ", " + arg15);
                }
            }

            BigInteger v2 = arg15.subtract(IntegerFunctions.ONE);
            long v0 = 0;
            while(!v2.testBit(0)) {
                ++v0;
                v2 = v2.shiftRight(1);
            }

            BigInteger v5 = v2.subtract(IntegerFunctions.ONE).shiftRight(1);
            v2 = arg14.modPow(v5, arg15);
            BigInteger v3 = v2.multiply(v2).remainder(arg15).multiply(arg14).remainder(arg15);
            BigInteger v4 = v2.multiply(arg14).remainder(arg15);
            if(v3.equals(IntegerFunctions.ONE)) {
                return v4;
            }

            for(v2 = IntegerFunctions.TWO; IntegerFunctions.jacobi(v2, arg15) == 1; v2 = v2.add(IntegerFunctions.ONE)) {
            }

            BigInteger v12 = v2.modPow(v5.multiply(IntegerFunctions.TWO).add(IntegerFunctions.ONE), arg15);
            v2 = v4;
            BigInteger v13 = v3;
            long v3_1 = v0;
            BigInteger v0_1 = v12;
            BigInteger v1 = v13;
            while(v1.compareTo(IntegerFunctions.ONE) == 1) {
                long v5_1 = 0;
                BigInteger v7 = v1;
                while(!v7.equals(IntegerFunctions.ONE)) {
                    v7 = v7.multiply(v7).mod(arg15);
                    ++v5_1;
                }

                long v8 = v3_1 - v5_1;
                if(v8 == 0) {
                    throw new IllegalArgumentException("No quadratic residue: " + arg14 + ", " + arg15);
                }

                v7 = IntegerFunctions.ONE;
                for(v3_1 = 0; v3_1 < v8 - 1; ++v3_1) {
                    v7 = v7.shiftLeft(1);
                }

                v0_1 = v0_1.modPow(v7, arg15);
                v2 = v2.multiply(v0_1).remainder(arg15);
                v0_1 = v0_1.multiply(v0_1).remainder(arg15);
                v1 = v1.multiply(v0_1).mod(arg15);
                v3_1 = v5_1;
            }

            arg14 = v2;
        }

        return arg14;
    }

    public static BigInteger squareRoot(BigInteger arg9) {
        BigInteger v3_1;
        int v2_1;
        BigInteger v8;
        if(arg9.compareTo(IntegerFunctions.ZERO) < 0) {
            throw new ArithmeticException("cannot extract root of negative number" + arg9 + ".");
        }

        int v3 = arg9.bitLength();
        BigInteger v2 = IntegerFunctions.ZERO;
        BigInteger v0 = IntegerFunctions.ZERO;
        if((v3 & 1) != 0) {
            v8 = v2.add(IntegerFunctions.ONE);
            v2_1 = v3 - 1;
            v3_1 = v8;
        }
        else {
            v8 = v2;
            v2_1 = v3;
            v3_1 = v8;
        }

        while(v2_1 > 0) {
            BigInteger v5 = v0.multiply(IntegerFunctions.FOUR);
            --v2_1;
            int v0_1 = arg9.testBit(v2_1) ? 2 : 0;
            int v4 = v2_1 - 1;
            v2_1 = arg9.testBit(v4) ? 1 : 0;
            v0 = v5.add(BigInteger.valueOf(((long)(v0_1 + v2_1))));
            v5 = v3_1.multiply(IntegerFunctions.FOUR).add(IntegerFunctions.ONE);
            v2 = v3_1.multiply(IntegerFunctions.TWO);
            if(v0.compareTo(v5) != -1) {
                v2 = v2.add(IntegerFunctions.ONE);
                v0 = v0.subtract(v5);
                v3_1 = v2;
                v2_1 = v4;
                continue;
            }

            v3_1 = v2;
            v2_1 = v4;
        }

        return v3_1;
    }
}

