// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.security.SecureRandom;

public class Permutation {
    private int[] perm;

    public Permutation(byte[] arg6) {
        int v0 = 0;
        super();
        if(arg6.length <= 4) {
            throw new IllegalArgumentException("invalid encoding");
        }

        int v1 = LittleEndianConversions.OS2IP(arg6, 0);
        int v2 = IntegerFunctions.ceilLog256(v1 - 1);
        if(arg6.length != v1 * v2 + 4) {
            throw new IllegalArgumentException("invalid encoding");
        }

        this.perm = new int[v1];
        while(v0 < v1) {
            this.perm[v0] = LittleEndianConversions.OS2IP(arg6, v0 * v2 + 4, v2);
            ++v0;
        }

        if(!this.isPermutation(this.perm)) {
            throw new IllegalArgumentException("invalid encoding");
        }
    }

    public Permutation(int arg7, SecureRandom arg8) {
        int v0 = 0;
        super();
        if(arg7 <= 0) {
            throw new IllegalArgumentException("invalid length");
        }

        this.perm = new int[arg7];
        int[] v2 = new int[arg7];
        int v1;
        for(v1 = 0; v1 < arg7; ++v1) {
            v2[v1] = v1;
        }

        v1 = arg7;
        while(v0 < arg7) {
            int v3 = RandUtils.nextInt(arg8, v1);
            --v1;
            this.perm[v0] = v2[v3];
            v2[v3] = v2[v1];
            ++v0;
        }
    }

    public Permutation(int arg3) {
        super();
        if(arg3 <= 0) {
            throw new IllegalArgumentException("invalid length");
        }

        this.perm = new int[arg3];
        int v0;
        for(v0 = arg3 - 1; v0 >= 0; --v0) {
            this.perm[v0] = v0;
        }
    }

    public Permutation(int[] arg3) {
        super();
        if(!this.isPermutation(arg3)) {
            throw new IllegalArgumentException("array is not a permutation vector");
        }

        this.perm = IntUtils.clone(arg3);
    }

    public Permutation computeInverse() {
        Permutation v1 = new Permutation(this.perm.length);
        int v0;
        for(v0 = this.perm.length - 1; v0 >= 0; --v0) {
            v1.perm[this.perm[v0]] = v0;
        }

        return v1;
    }

    public boolean equals(Object arg3) {
        boolean v0 = !(arg3 instanceof Permutation) ? false : IntUtils.equals(this.perm, ((Permutation)arg3).perm);
        return v0;
    }

    public byte[] getEncoded() {
        int v0 = 0;
        int v1 = this.perm.length;
        int v2 = IntegerFunctions.ceilLog256(v1 - 1);
        byte[] v3 = new byte[v1 * v2 + 4];
        LittleEndianConversions.I2OSP(v1, v3, 0);
        while(v0 < v1) {
            LittleEndianConversions.I2OSP(this.perm[v0], v3, v0 * v2 + 4, v2);
            ++v0;
        }

        return v3;
    }

    public int[] getVector() {
        return IntUtils.clone(this.perm);
    }

    public int hashCode() {
        return this.perm.hashCode();
    }

    private boolean isPermutation(int[] arg7) {
        boolean v0 = false;
        int v3 = arg7.length;
        boolean[] v4 = new boolean[v3];
        int v2 = 0;
        while(true) {
            if(v2 >= v3) {
                return true;
            }
            else if(arg7[v2] >= 0 && arg7[v2] < v3 && !v4[arg7[v2]]) {
                v4[arg7[v2]] = true;
                ++v2;
                continue;
            }

            return v0;
        }

        return true;
    }

    public Permutation rightMultiply(Permutation arg6) {
        if(arg6.perm.length != this.perm.length) {
            throw new IllegalArgumentException("length mismatch");
        }

        Permutation v1 = new Permutation(this.perm.length);
        int v0;
        for(v0 = this.perm.length - 1; v0 >= 0; --v0) {
            v1.perm[v0] = this.perm[arg6.perm[v0]];
        }

        return v1;
    }

    public String toString() {
        String v1 = "[" + this.perm[0];
        int v0;
        for(v0 = 1; v0 < this.perm.length; ++v0) {
            v1 = v1 + ", " + this.perm[v0];
        }

        return v1 + "]";
    }
}

