// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

import java.security.SecureRandom;

public class PolynomialGF2mSmallM {
    public static final char RANDOM_IRREDUCIBLE_POLYNOMIAL = 'I';
    private int[] coefficients;
    private int degree;
    private GF2mField field;

    public PolynomialGF2mSmallM(GF2mField arg10, byte[] arg11) {
        super();
        this.field = arg10;
        int v2 = 8;
        int v0 = 1;
        while(arg10.getDegree() > v2) {
            ++v0;
            v2 += 8;
        }

        if(arg11.length % v0 != 0) {
            throw new IllegalArgumentException(" Error: byte array is not encoded polynomial over given finite field GF2m");
        }

        this.coefficients = new int[arg11.length / v0];
        v0 = 0;
        int v4 = 0;
        while(v0 < this.coefficients.length) {
            int v5 = 0;
            while(v5 < v2) {
                this.coefficients[v0] ^= (arg11[v4] & 255) << v5;
                v5 += 8;
                ++v4;
            }

            if(!this.field.isElementOfThisField(this.coefficients[v0])) {
                throw new IllegalArgumentException(" Error: byte array is not encoded polynomial over given finite field GF2m");
            }

            ++v0;
        }

        if(this.coefficients.length != 1 && this.coefficients[this.coefficients.length - 1] == 0) {
            throw new IllegalArgumentException(" Error: byte array is not encoded polynomial over given finite field GF2m");
        }

        this.computeDegree();
    }

    public PolynomialGF2mSmallM(GF2mField arg4, int arg5, char arg6, SecureRandom arg7) {
        super();
        this.field = arg4;
        switch(arg6) {
            case 73: {
                goto label_14;
            }
        }

        throw new IllegalArgumentException(" Error: type " + arg6 + " is not defined for GF2smallmPolynomial");
    label_14:
        this.coefficients = this.createRandomIrreduciblePolynomial(arg5, arg7);
        this.computeDegree();
    }

    public PolynomialGF2mSmallM(GF2mVector arg3) {
        this(arg3.getField(), arg3.getIntArrayForm());
    }

    public PolynomialGF2mSmallM(GF2mField arg2) {
        super();
        this.field = arg2;
        this.degree = -1;
        this.coefficients = new int[1];
    }

    public PolynomialGF2mSmallM(GF2mField arg3, int arg4) {
        super();
        this.field = arg3;
        this.degree = arg4;
        this.coefficients = new int[arg4 + 1];
        this.coefficients[arg4] = 1;
    }

    public PolynomialGF2mSmallM(GF2mField arg2, int[] arg3) {
        super();
        this.field = arg2;
        this.coefficients = PolynomialGF2mSmallM.normalForm(arg3);
        this.computeDegree();
    }

    public PolynomialGF2mSmallM(PolynomialGF2mSmallM arg2) {
        super();
        this.field = arg2.field;
        this.degree = arg2.degree;
        this.coefficients = IntUtils.clone(arg2.coefficients);
    }

    public PolynomialGF2mSmallM add(PolynomialGF2mSmallM arg4) {
        return new PolynomialGF2mSmallM(this.field, this.add(this.coefficients, arg4.coefficients));
    }

    private int[] add(int[] arg6, int[] arg7) {
        int[] v0;
        if(arg6.length < arg7.length) {
            v0 = new int[arg7.length];
            System.arraycopy(arg7, 0, v0, 0, arg7.length);
        }
        else {
            v0 = new int[arg6.length];
            System.arraycopy(arg6, 0, v0, 0, arg6.length);
            arg6 = arg7;
        }

        int v1;
        for(v1 = arg6.length - 1; v1 >= 0; --v1) {
            v0[v1] = this.field.add(v0[v1], arg6[v1]);
        }

        return v0;
    }

    public PolynomialGF2mSmallM addMonomial(int arg4) {
        int[] v0 = new int[arg4 + 1];
        v0[arg4] = 1;
        return new PolynomialGF2mSmallM(this.field, this.add(this.coefficients, v0));
    }

    public void addToThis(PolynomialGF2mSmallM arg3) {
        this.coefficients = this.add(this.coefficients, arg3.coefficients);
        this.computeDegree();
    }

    private void computeDegree() {
        this.degree = this.coefficients.length - 1;
        while(this.degree >= 0) {
            if(this.coefficients[this.degree] != 0) {
                return;
            }

            --this.degree;
        }
    }

    private static int computeDegree(int[] arg2) {
        int v0;
        for(v0 = arg2.length - 1; v0 >= 0; --v0) {
            if(arg2[v0] != 0) {
                return v0;
            }
        }

        return v0;
    }

    private int[] createRandomIrreduciblePolynomial(int arg5, SecureRandom arg6) {
        int v0 = 1;
        int[] v1 = new int[arg5 + 1];
        v1[arg5] = 1;
        v1[0] = this.field.getRandomNonZeroElement(arg6);
        while(v0 < arg5) {
            v1[v0] = this.field.getRandomElement(arg6);
            ++v0;
        }

        while(!this.isIrreducible(v1)) {
            v0 = RandUtils.nextInt(arg6, arg5);
            if(v0 == 0) {
                v1[0] = this.field.getRandomNonZeroElement(arg6);
                continue;
            }

            v1[v0] = this.field.getRandomElement(arg6);
        }

        return v1;
    }

    private int[][] div(int[] arg9, int[] arg10) {
        int v0 = PolynomialGF2mSmallM.computeDegree(arg10);
        int v1 = PolynomialGF2mSmallM.computeDegree(arg9) + 1;
        if(v0 == -1) {
            throw new ArithmeticException("Division by zero.");
        }

        int[][] v2 = new int[][]{new int[1], new int[v1]};
        v1 = this.field.inverse(PolynomialGF2mSmallM.headCoefficient(arg10));
        v2[0][0] = 0;
        System.arraycopy(arg9, 0, v2[1], 0, v2[1].length);
        while(v0 <= PolynomialGF2mSmallM.computeDegree(v2[1])) {
            int[] v3 = new int[]{this.field.mult(PolynomialGF2mSmallM.headCoefficient(v2[1]), v1)};
            int[] v4 = this.multWithElement(arg10, v3[0]);
            int v5 = PolynomialGF2mSmallM.computeDegree(v2[1]) - v0;
            v4 = PolynomialGF2mSmallM.multWithMonomial(v4, v5);
            v2[0] = this.add(PolynomialGF2mSmallM.multWithMonomial(v3, v5), v2[0]);
            v2[1] = this.add(v4, v2[1]);
        }

        return v2;
    }

    public PolynomialGF2mSmallM[] div(PolynomialGF2mSmallM arg8) {
        int[][] v0 = this.div(this.coefficients, arg8.coefficients);
        return new PolynomialGF2mSmallM[]{new PolynomialGF2mSmallM(this.field, v0[0]), new PolynomialGF2mSmallM(this.field, v0[1])};
    }

    public boolean equals(Object arg4) {
        boolean v0 = false;
        if(arg4 != null && ((arg4 instanceof PolynomialGF2mSmallM)) && (this.field.equals(((PolynomialGF2mSmallM)arg4).field)) && this.degree == ((PolynomialGF2mSmallM)arg4).degree && (PolynomialGF2mSmallM.isEqual(this.coefficients, ((PolynomialGF2mSmallM)arg4).coefficients))) {
            v0 = true;
        }

        return v0;
    }

    public int evaluateAt(int arg4) {
        int v1 = this.coefficients[this.degree];
        int v0;
        for(v0 = this.degree - 1; v0 >= 0; --v0) {
            v1 = this.field.mult(v1, arg4) ^ this.coefficients[v0];
        }

        return v1;
    }

    private int[] gcd(int[] arg5, int[] arg6) {
        int v3 = -1;
        if(PolynomialGF2mSmallM.computeDegree(arg5) != v3) {
            while(PolynomialGF2mSmallM.computeDegree(arg6) != v3) {
                int[] v0 = this.mod(arg5, arg6);
                arg5 = new int[arg6.length];
                System.arraycopy(arg6, 0, arg5, 0, arg5.length);
                arg6 = new int[v0.length];
                System.arraycopy(v0, 0, arg6, 0, arg6.length);
            }

            arg6 = this.multWithElement(arg5, this.field.inverse(PolynomialGF2mSmallM.headCoefficient(arg5)));
        }

        return arg6;
    }

    public PolynomialGF2mSmallM gcd(PolynomialGF2mSmallM arg4) {
        return new PolynomialGF2mSmallM(this.field, this.gcd(this.coefficients, arg4.coefficients));
    }

    public int getCoefficient(int arg2) {
        int v0 = arg2 < 0 || arg2 > this.degree ? 0 : this.coefficients[arg2];
        return v0;
    }

    public int getDegree() {
        int v0 = this.coefficients.length - 1;
        if(this.coefficients[v0] == 0) {
            v0 = -1;
        }

        return v0;
    }

    public byte[] getEncoded() {
        int v1 = 8;
        int v0 = 1;
        while(this.field.getDegree() > v1) {
            ++v0;
            v1 += 8;
        }

        byte[] v6 = new byte[v0 * this.coefficients.length];
        v0 = 0;
        int v3 = 0;
        while(v0 < this.coefficients.length) {
            int v4 = 0;
            while(v4 < v1) {
                v6[v3] = ((byte)(this.coefficients[v0] >>> v4));
                v4 += 8;
                ++v3;
            }

            ++v0;
        }

        return v6;
    }

    public int getHeadCoefficient() {
        int v0 = this.degree == -1 ? 0 : this.coefficients[this.degree];
        return v0;
    }

    public int hashCode() {
        int v1 = this.field.hashCode();
        int v0;
        for(v0 = 0; v0 < this.coefficients.length; ++v0) {
            v1 = v1 * 31 + this.coefficients[v0];
        }

        return v1;
    }

    private static int headCoefficient(int[] arg2) {
        int v0 = PolynomialGF2mSmallM.computeDegree(arg2);
        return v0 == -1 ? 0 : arg2[v0];
    }

    private static boolean isEqual(int[] arg5, int[] arg6) {
        boolean v0 = false;
        int v2 = PolynomialGF2mSmallM.computeDegree(arg5);
        if(v2 == PolynomialGF2mSmallM.computeDegree(arg6)) {
            int v1 = 0;
            while(true) {
                if(v1 > v2) {
                    break;
                }
                else if(arg5[v1] == arg6[v1]) {
                    ++v1;
                    continue;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    private boolean isIrreducible(int[] arg8) {
        int v3 = 2;
        boolean v0 = false;
        if(arg8[0] != 0) {
            int v4 = PolynomialGF2mSmallM.computeDegree(arg8) >> 1;
            int[] v2 = new int[]{0, 1};
            int[] v5 = new int[]{0, 1};
            int v6 = this.field.getDegree();
            v3 = 0;
            while(true) {
                if(v3 < v4) {
                    int v1;
                    for(v1 = v6 - 1; v1 >= 0; --v1) {
                        v2 = this.modMultiply(v2, v2, arg8);
                    }

                    v2 = PolynomialGF2mSmallM.normalForm(v2);
                    if(PolynomialGF2mSmallM.computeDegree(this.gcd(this.add(v2, v5), arg8)) == 0) {
                        ++v3;
                        continue;
                    }
                }
                else {
                    break;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    private int[] mod(int[] arg6, int[] arg7) {
        int v1 = PolynomialGF2mSmallM.computeDegree(arg7);
        if(v1 == -1) {
            throw new ArithmeticException("Division by zero");
        }

        int[] v0 = new int[arg6.length];
        int v2 = this.field.inverse(PolynomialGF2mSmallM.headCoefficient(arg7));
        System.arraycopy(arg6, 0, v0, 0, v0.length);
        while(v1 <= PolynomialGF2mSmallM.computeDegree(v0)) {
            v0 = this.add(this.multWithElement(PolynomialGF2mSmallM.multWithMonomial(arg7, PolynomialGF2mSmallM.computeDegree(v0) - v1), this.field.mult(PolynomialGF2mSmallM.headCoefficient(v0), v2)), v0);
        }

        return v0;
    }

    public PolynomialGF2mSmallM mod(PolynomialGF2mSmallM arg4) {
        return new PolynomialGF2mSmallM(this.field, this.mod(this.coefficients, arg4.coefficients));
    }

    private int[] modDiv(int[] arg9, int[] arg10, int[] arg11) {
        int[] v3 = PolynomialGF2mSmallM.normalForm(arg11);
        int[] v2 = this.mod(arg10, arg11);
        int[] v1 = new int[]{0};
        int[] v0;
        for(v0 = this.mod(arg9, arg11); PolynomialGF2mSmallM.computeDegree(v2) != -1; v0 = PolynomialGF2mSmallM.normalForm(v4_1)) {
            int[][] v4 = this.div(v3, v2);
            v3 = PolynomialGF2mSmallM.normalForm(v2);
            v2 = PolynomialGF2mSmallM.normalForm(v4[1]);
            int[] v4_1 = this.add(v1, this.modMultiply(v4[0], v0, arg11));
            v1 = PolynomialGF2mSmallM.normalForm(v0);
        }

        return this.multWithElement(v1, this.field.inverse(PolynomialGF2mSmallM.headCoefficient(v3)));
    }

    public PolynomialGF2mSmallM modDiv(PolynomialGF2mSmallM arg4, PolynomialGF2mSmallM arg5) {
        return new PolynomialGF2mSmallM(this.field, this.modDiv(this.coefficients, arg4.coefficients, arg5.coefficients));
    }

    public PolynomialGF2mSmallM modInverse(PolynomialGF2mSmallM arg4) {
        return new PolynomialGF2mSmallM(this.field, this.modDiv(new int[]{1}, this.coefficients, arg4.coefficients));
    }

    private int[] modMultiply(int[] arg2, int[] arg3, int[] arg4) {
        return this.mod(this.multiply(arg2, arg3), arg4);
    }

    public PolynomialGF2mSmallM modMultiply(PolynomialGF2mSmallM arg4, PolynomialGF2mSmallM arg5) {
        return new PolynomialGF2mSmallM(this.field, this.modMultiply(this.coefficients, arg4.coefficients, arg5.coefficients));
    }

    public PolynomialGF2mSmallM[] modPolynomialToFracton(PolynomialGF2mSmallM arg12) {
        int v4 = arg12.degree >> 1;
        int[] v3 = PolynomialGF2mSmallM.normalForm(arg12.coefficients);
        int[] v2 = this.mod(this.coefficients, arg12.coefficients);
        int[] v1 = new int[]{0};
        int[] v0 = new int[]{1};
        while(PolynomialGF2mSmallM.computeDegree(v2) > v4) {
            int[][] v5 = this.div(v3, v2);
            v3 = v5[1];
            int[] v9 = this.add(v1, this.modMultiply(v5[0], v0, arg12.coefficients));
            v1 = v0;
            v0 = v9;
            int[] v10 = v3;
            v3 = v2;
            v2 = v10;
        }

        return new PolynomialGF2mSmallM[]{new PolynomialGF2mSmallM(this.field, v2), new PolynomialGF2mSmallM(this.field, v0)};
    }

    public PolynomialGF2mSmallM modSquareMatrix(PolynomialGF2mSmallM[] arg10) {
        int v3 = arg10.length;
        int[] v4 = new int[v3];
        int[] v5 = new int[v3];
        int v0;
        for(v0 = 0; v0 < this.coefficients.length; ++v0) {
            v5[v0] = this.field.mult(this.coefficients[v0], this.coefficients[v0]);
        }

        int v2;
        for(v2 = 0; v2 < v3; ++v2) {
            for(v0 = 0; v0 < v3; ++v0) {
                if(v2 < arg10[v0].coefficients.length) {
                    v4[v2] = this.field.add(v4[v2], this.field.mult(arg10[v0].coefficients[v2], v5[v0]));
                }
            }
        }

        return new PolynomialGF2mSmallM(this.field, v4);
    }

    public PolynomialGF2mSmallM modSquareRoot(PolynomialGF2mSmallM arg4) {
        int[] v1 = IntUtils.clone(this.coefficients);
        int[] v0;
        for(v0 = this.modMultiply(v1, v1, arg4.coefficients); !PolynomialGF2mSmallM.isEqual(v0, this.coefficients); v0 = this.modMultiply(v1, v1, arg4.coefficients)) {
            v1 = PolynomialGF2mSmallM.normalForm(v0);
        }

        return new PolynomialGF2mSmallM(this.field, v1);
    }

    public PolynomialGF2mSmallM modSquareRootMatrix(PolynomialGF2mSmallM[] arg9) {
        int v0 = 0;
        int v3 = arg9.length;
        int[] v4 = new int[v3];
        int v2;
        for(v2 = 0; v2 < v3; ++v2) {
            int v1;
            for(v1 = 0; v1 < v3; ++v1) {
                if(v2 < arg9[v1].coefficients.length && v1 < this.coefficients.length) {
                    v4[v2] = this.field.add(v4[v2], this.field.mult(arg9[v1].coefficients[v2], this.coefficients[v1]));
                }
            }
        }

        while(v0 < v3) {
            v4[v0] = this.field.sqRoot(v4[v0]);
            ++v0;
        }

        return new PolynomialGF2mSmallM(this.field, v4);
    }

    public void multThisWithElement(int arg3) {
        if(!this.field.isElementOfThisField(arg3)) {
            throw new ArithmeticException("Not an element of the finite field this polynomial is defined over.");
        }

        this.coefficients = this.multWithElement(this.coefficients, arg3);
        this.computeDegree();
    }

    public PolynomialGF2mSmallM multWithElement(int arg4) {
        if(!this.field.isElementOfThisField(arg4)) {
            throw new ArithmeticException("Not an element of the finite field this polynomial is defined over.");
        }

        return new PolynomialGF2mSmallM(this.field, this.multWithElement(this.coefficients, arg4));
    }

    private int[] multWithElement(int[] arg5, int arg6) {
        int[] v0;
        int v1 = PolynomialGF2mSmallM.computeDegree(arg5);
        if(v1 == -1 || arg6 == 0) {
            v0 = new int[1];
        }
        else if(arg6 == 1) {
            v0 = IntUtils.clone(arg5);
        }
        else {
            v0 = new int[v1 + 1];
            while(v1 >= 0) {
                v0[v1] = this.field.mult(arg5[v1], arg6);
                --v1;
            }
        }

        return v0;
    }

    public PolynomialGF2mSmallM multWithMonomial(int arg4) {
        return new PolynomialGF2mSmallM(this.field, PolynomialGF2mSmallM.multWithMonomial(this.coefficients, arg4));
    }

    private static int[] multWithMonomial(int[] arg3, int arg4) {
        int[] v0;
        int v1 = PolynomialGF2mSmallM.computeDegree(arg3);
        if(v1 == -1) {
            v0 = new int[1];
        }
        else {
            v0 = new int[v1 + arg4 + 1];
            System.arraycopy(arg3, 0, v0, arg4, v1 + 1);
        }

        return v0;
    }

    public PolynomialGF2mSmallM multiply(PolynomialGF2mSmallM arg4) {
        return new PolynomialGF2mSmallM(this.field, this.multiply(this.coefficients, arg4.coefficients));
    }

    private int[] multiply(int[] arg11, int[] arg12) {
        int[] v2_1;
        int[] v4;
        if(PolynomialGF2mSmallM.computeDegree(arg11) >= PolynomialGF2mSmallM.computeDegree(arg12)) {
            int[] v9 = arg12;
            arg12 = arg11;
            arg11 = v9;
        }

        int[] v0 = PolynomialGF2mSmallM.normalForm(arg12);
        int[] v1 = PolynomialGF2mSmallM.normalForm(arg11);
        if(v1.length == 1) {
            v0 = this.multWithElement(v0, v1[0]);
        }
        else {
            int v2 = v0.length;
            int v3 = v1.length;
            new int[v2 + v3 - 1];
            if(v3 != v2) {
                v4 = new int[v3];
                v2_1 = new int[v2 - v3];
                System.arraycopy(v0, 0, v4, 0, v4.length);
                System.arraycopy(v0, v3, v2_1, 0, v2_1.length);
                v0 = this.add(this.multiply(v4, v1), PolynomialGF2mSmallM.multWithMonomial(this.multiply(v2_1, v1), v3));
            }
            else {
                v3 = v2 + 1 >>> 1;
                v2 -= v3;
                v4 = new int[v3];
                int[] v5 = new int[v3];
                int[] v6 = new int[v2];
                v2_1 = new int[v2];
                System.arraycopy(v0, 0, v4, 0, v4.length);
                System.arraycopy(v0, v3, v6, 0, v6.length);
                System.arraycopy(v1, 0, v5, 0, v5.length);
                System.arraycopy(v1, v3, v2_1, 0, v2_1.length);
                v0 = this.add(v4, v6);
                v1 = this.add(v5, v2_1);
                v4 = this.multiply(v4, v5);
                v0 = this.multiply(v0, v1);
                v1 = this.multiply(v6, v2_1);
                v0 = this.add(PolynomialGF2mSmallM.multWithMonomial(this.add(this.add(this.add(v0, v4), v1), PolynomialGF2mSmallM.multWithMonomial(v1, v3)), v3), v4);
            }
        }

        return v0;
    }

    private static int[] normalForm(int[] arg4) {
        int[] v0;
        int v1 = PolynomialGF2mSmallM.computeDegree(arg4);
        if(v1 == -1) {
            v0 = new int[1];
        }
        else if(arg4.length == v1 + 1) {
            v0 = IntUtils.clone(arg4);
        }
        else {
            v0 = new int[v1 + 1];
            System.arraycopy(arg4, 0, v0, 0, v1 + 1);
        }

        return v0;
    }

    public String toString() {
        String v1 = " Polynomial over " + this.field.toString() + ": \n";
        int v0;
        for(v0 = 0; v0 < this.coefficients.length; ++v0) {
            v1 = v1 + this.field.elementToStr(this.coefficients[v0]) + "Y^" + v0 + "+";
        }

        return v1 + ";";
    }
}

