// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

public final class PolynomialRingGF2 {
    private PolynomialRingGF2() {
        super();
    }

    public static int add(int arg1, int arg2) {
        return arg1 ^ arg2;
    }

    public static int degree(int arg1) {
        int v0 = -1;
        while(arg1 != 0) {
            ++v0;
            arg1 >>>= 1;
        }

        return v0;
    }

    public static int degree(long arg3) {
        int v0 = 0;
        while(arg3 != 0) {
            ++v0;
            arg3 >>>= 1;
        }

        return v0 - 1;
    }

    public static int gcd(int arg1, int arg2) {
        while(arg2 != 0) {
            int v0 = PolynomialRingGF2.remainder(arg1, arg2);
            arg1 = arg2;
            arg2 = v0;
        }

        return arg1;
    }

    public static int getIrreduciblePolynomial(int arg4) {
        int v0 = 0;
        if(arg4 < 0) {
            System.err.println("The Degree is negative");
        }
        else if(arg4 > 31) {
            System.err.println("The Degree is more then 31");
        }
        else if(arg4 == 0) {
            v0 = 1;
        }
        else {
            int v3 = 1 << arg4 + 1;
            int v1 = (1 << arg4) + 1;
            while(v1 < v3) {
                if(PolynomialRingGF2.isIrreducible(v1)) {
                    v0 = v1;
                }
                else {
                    v1 += 2;
                    continue;
                }

                return v0;
            }
        }

        return v0;
    }

    public static boolean isIrreducible(int arg6) {
        boolean v0 = false;
        if(arg6 != 0) {
            int v4 = PolynomialRingGF2.degree(arg6) >>> 1;
            int v3 = 2;
            int v2 = 0;
            while(true) {
                if(v2 < v4) {
                    v3 = PolynomialRingGF2.modMultiply(v3, v3, arg6);
                    if(PolynomialRingGF2.gcd(v3 ^ 2, arg6) == 1) {
                        ++v2;
                        continue;
                    }
                }
                else {
                    break;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    public static int modMultiply(int arg6, int arg7, int arg8) {
        int v0 = 0;
        int v2 = PolynomialRingGF2.remainder(arg6, arg8);
        int v1 = PolynomialRingGF2.remainder(arg7, arg8);
        if(v1 != 0) {
            int v4 = 1 << PolynomialRingGF2.degree(arg8);
            int v3 = v2;
            v2 = v1;
            while(v3 != 0) {
                v1 = (((byte)(v3 & 1))) == 1 ? v0 ^ v2 : v0;
                v3 >>>= 1;
                v0 = v2 << 1;
                if(v0 >= v4) {
                    v0 ^= arg8;
                }

                v2 = v0;
                v0 = v1;
            }
        }

        return v0;
    }

    public static long multiply(int arg7, int arg8) {
        long v0 = 0;
        if(arg8 != 0) {
            long v2;
            for(v2 = (((long)arg8)) & 4294967295L; arg7 != 0; v2 <<= 1) {
                if((((byte)(arg7 & 1))) == 1) {
                    v0 ^= v2;
                }

                arg7 >>>= 1;
            }
        }

        return v0;
    }

    public static int remainder(int arg2, int arg3) {
        if(arg3 == 0) {
            System.err.println("Error: to be divided by 0");
            arg2 = 0;
        }
        else {
            while(PolynomialRingGF2.degree(arg2) >= PolynomialRingGF2.degree(arg3)) {
                arg2 ^= arg3 << PolynomialRingGF2.degree(arg2) - PolynomialRingGF2.degree(arg3);
            }
        }

        return arg2;
    }

    public static int rest(long arg6, int arg8) {
        int v0;
        if(arg8 == 0) {
            System.err.println("Error: to be divided by 0");
            v0 = 0;
        }
        else {
            long v0_1 = (((long)arg8)) & 4294967295L;
            while(arg6 >>> 32 != 0) {
                arg6 ^= v0_1 << PolynomialRingGF2.degree(arg6) - PolynomialRingGF2.degree(v0_1);
            }

            for(v0 = ((int)(-1 & arg6)); PolynomialRingGF2.degree(v0) >= PolynomialRingGF2.degree(arg8); v0 ^= arg8 << PolynomialRingGF2.degree(v0) - PolynomialRingGF2.degree(arg8)) {
            }
        }

        return v0;
    }
}

