// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.pqc.math.linearalgebra;

public class PolynomialRingGF2m {
    private GF2mField field;
    private PolynomialGF2mSmallM p;
    protected PolynomialGF2mSmallM[] sqMatrix;
    protected PolynomialGF2mSmallM[] sqRootMatrix;

    public PolynomialRingGF2m(GF2mField arg1, PolynomialGF2mSmallM arg2) {
        super();
        this.field = arg1;
        this.p = arg2;
        this.computeSquaringMatrix();
        this.computeSquareRootMatrix();
    }

    private void computeSquareRootMatrix() {
        int v2;
        int v1 = this.p.getDegree();
        PolynomialGF2mSmallM[] v5 = new PolynomialGF2mSmallM[v1];
        int v0;
        for(v0 = v1 - 1; v0 >= 0; --v0) {
            v5[v0] = new PolynomialGF2mSmallM(this.sqMatrix[v0]);
        }

        this.sqRootMatrix = new PolynomialGF2mSmallM[v1];
        for(v0 = v1 - 1; v0 >= 0; --v0) {
            this.sqRootMatrix[v0] = new PolynomialGF2mSmallM(this.field, v0);
        }

        int v4;
        for(v4 = 0; v4 < v1; ++v4) {
            if(v5[v4].getCoefficient(v4) == 0) {
                v0 = v4 + 1;
                v2 = 0;
                while(v0 < v1) {
                    if(v5[v0].getCoefficient(v4) != 0) {
                        v2 = 1;
                        PolynomialRingGF2m.swapColumns(v5, v4, v0);
                        PolynomialRingGF2m.swapColumns(this.sqRootMatrix, v4, v0);
                        v0 = v1;
                    }

                    ++v0;
                }

                if(v2 != 0) {
                    goto label_47;
                }

                throw new ArithmeticException("Squaring matrix is not invertible.");
            }

        label_47:
            v0 = this.field.inverse(v5[v4].getCoefficient(v4));
            v5[v4].multThisWithElement(v0);
            this.sqRootMatrix[v4].multThisWithElement(v0);
            for(v0 = 0; v0 < v1; ++v0) {
                if(v0 != v4) {
                    v2 = v5[v0].getCoefficient(v4);
                    if(v2 != 0) {
                        PolynomialGF2mSmallM v6 = v5[v4].multWithElement(v2);
                        PolynomialGF2mSmallM v2_1 = this.sqRootMatrix[v4].multWithElement(v2);
                        v5[v0].addToThis(v6);
                        this.sqRootMatrix[v0].addToThis(v2_1);
                    }
                }
            }
        }
    }

    private void computeSquaringMatrix() {
        int[] v2;
        int v1 = this.p.getDegree();
        this.sqMatrix = new PolynomialGF2mSmallM[v1];
        int v0;
        for(v0 = 0; v0 < v1 >> 1; ++v0) {
            v2 = new int[(v0 << 1) + 1];
            v2[v0 << 1] = 1;
            this.sqMatrix[v0] = new PolynomialGF2mSmallM(this.field, v2);
        }

        for(v0 = v1 >> 1; v0 < v1; ++v0) {
            v2 = new int[(v0 << 1) + 1];
            v2[v0 << 1] = 1;
            this.sqMatrix[v0] = new PolynomialGF2mSmallM(this.field, v2).mod(this.p);
        }
    }

    public PolynomialGF2mSmallM[] getSquareRootMatrix() {
        return this.sqRootMatrix;
    }

    public PolynomialGF2mSmallM[] getSquaringMatrix() {
        return this.sqMatrix;
    }

    private static void swapColumns(PolynomialGF2mSmallM[] arg2, int arg3, int arg4) {
        PolynomialGF2mSmallM v0 = arg2[arg3];
        arg2[arg3] = arg2[arg4];
        arg2[arg4] = v0;
    }
}

