// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.util.encoders;

import java.io.IOException;
import java.io.OutputStream;

public class Base64Encoder implements Encoder {
    protected final byte[] decodingTable;
    protected final byte[] encodingTable;
    protected byte padding;

    public Base64Encoder() {
        super();
        this.encodingTable = new byte[]{65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 47};
        this.padding = 61;
        this.decodingTable = new byte[128];
        this.initialiseDecodingTable();
    }

    public int decode(String arg10, OutputStream arg11) {
        int v5;
        for(v5 = arg10.length(); v5 > 0; --v5) {
            if(!this.ignore(arg10.charAt(v5 - 1))) {
                break;
            }
        }

        int v2 = v5 - 4;
        int v0 = this.nextI(arg10, 0, v2);
        int v6;
        for(v6 = 0; v0 < v2; v6 += 3) {
            int v3 = v0 + 1;
            v0 = this.decodingTable[arg10.charAt(v0)];
            int v1 = this.nextI(arg10, v3, v2);
            int v4 = v1 + 1;
            v1 = this.decodingTable[arg10.charAt(v1)];
            v3 = this.nextI(arg10, v4, v2);
            int v7 = v3 + 1;
            v3 = this.decodingTable[arg10.charAt(v3)];
            v4 = this.nextI(arg10, v7, v2);
            int v8 = v4 + 1;
            v4 = this.decodingTable[arg10.charAt(v4)];
            if((v0 | v1 | v3 | v4) < 0) {
                throw new IOException("invalid characters encountered in base64 data");
            }

            arg11.write(v0 << 2 | v1 >> 4);
            arg11.write(v1 << 4 | v3 >> 2);
            arg11.write(v3 << 6 | v4);
            v0 = this.nextI(arg10, v8, v2);
        }

        return this.decodeLastBlock(arg11, arg10.charAt(v5 - 4), arg10.charAt(v5 - 3), arg10.charAt(v5 - 2), arg10.charAt(v5 - 1)) + v6;
    }

    public int decode(byte[] arg10, int arg11, int arg12, OutputStream arg13) {
        int v5;
        for(v5 = arg11 + arg12; v5 > arg11; --v5) {
            if(!this.ignore(((char)arg10[v5 - 1]))) {
                break;
            }
        }

        int v2 = v5 - 4;
        int v0 = this.nextI(arg10, arg11, v2);
        int v6;
        for(v6 = 0; v0 < v2; v6 += 3) {
            int v3 = v0 + 1;
            v0 = this.decodingTable[arg10[v0]];
            int v1 = this.nextI(arg10, v3, v2);
            int v4 = v1 + 1;
            v1 = this.decodingTable[arg10[v1]];
            v3 = this.nextI(arg10, v4, v2);
            int v7 = v3 + 1;
            v3 = this.decodingTable[arg10[v3]];
            v4 = this.nextI(arg10, v7, v2);
            int v8 = v4 + 1;
            v4 = this.decodingTable[arg10[v4]];
            if((v0 | v1 | v3 | v4) < 0) {
                throw new IOException("invalid characters encountered in base64 data");
            }

            arg13.write(v0 << 2 | v1 >> 4);
            arg13.write(v1 << 4 | v3 >> 2);
            arg13.write(v3 << 6 | v4);
            v0 = this.nextI(arg10, v8, v2);
        }

        return this.decodeLastBlock(arg13, ((char)arg10[v5 - 4]), ((char)arg10[v5 - 3]), ((char)arg10[v5 - 2]), ((char)arg10[v5 - 1])) + v6;
    }

    private int decodeLastBlock(OutputStream arg6, char arg7, char arg8, char arg9, char arg10) {
        int v2;
        int v1;
        int v0;
        if(arg9 == this.padding) {
            v0 = this.decodingTable[arg7];
            v1 = this.decodingTable[arg8];
            if((v0 | v1) < 0) {
                throw new IOException("invalid characters encountered at end of base64 data");
            }
            else {
                arg6.write(v0 << 2 | v1 >> 4);
                v0 = 1;
            }
        }
        else if(arg10 == this.padding) {
            v0 = this.decodingTable[arg7];
            v1 = this.decodingTable[arg8];
            v2 = this.decodingTable[arg9];
            if((v0 | v1 | v2) < 0) {
                throw new IOException("invalid characters encountered at end of base64 data");
            }
            else {
                arg6.write(v0 << 2 | v1 >> 4);
                arg6.write(v1 << 4 | v2 >> 2);
                v0 = 2;
            }
        }
        else {
            v0 = this.decodingTable[arg7];
            v1 = this.decodingTable[arg8];
            v2 = this.decodingTable[arg9];
            int v3 = this.decodingTable[arg10];
            if((v0 | v1 | v2 | v3) < 0) {
                throw new IOException("invalid characters encountered at end of base64 data");
            }
            else {
                arg6.write(v0 << 2 | v1 >> 4);
                arg6.write(v1 << 4 | v2 >> 2);
                arg6.write(v2 << 6 | v3);
                v0 = 3;
            }
        }

        return v0;
    }

    public int encode(byte[] arg9, int arg10, int arg11, OutputStream arg12) {
        int v3;
        int v1 = arg11 % 3;
        int v2 = arg11 - v1;
        int v0;
        for(v0 = arg10; v0 < arg10 + v2; v0 += 3) {
            v3 = arg9[v0] & 255;
            int v4 = arg9[v0 + 1] & 255;
            int v5 = arg9[v0 + 2] & 255;
            arg12.write(this.encodingTable[v3 >>> 2 & 63]);
            arg12.write(this.encodingTable[(v3 << 4 | v4 >>> 4) & 63]);
            arg12.write(this.encodingTable[(v4 << 2 | v5 >>> 6) & 63]);
            arg12.write(this.encodingTable[v5 & 63]);
        }

        switch(v1) {
            case 1: {
                v0 = arg9[arg10 + v2] & 255;
                arg12.write(this.encodingTable[v0 >>> 2 & 63]);
                arg12.write(this.encodingTable[v0 << 4 & 63]);
                arg12.write(this.padding);
                arg12.write(this.padding);
                break;
            }
            case 2: {
                v0 = arg9[arg10 + v2] & 255;
                v3 = arg9[arg10 + v2 + 1] & 255;
                arg12.write(this.encodingTable[v0 >>> 2 & 63]);
                arg12.write(this.encodingTable[(v0 << 4 | v3 >>> 4) & 63]);
                arg12.write(this.encodingTable[v3 << 2 & 63]);
                arg12.write(this.padding);
                break;
            }
        }

        v2 = v2 / 3 * 4;
        v0 = v1 == 0 ? 0 : 4;
        return v0 + v2;
    }

    private boolean ignore(char arg2) {
        boolean v0 = arg2 == 10 || arg2 == 13 || arg2 == 9 || arg2 == 32 ? true : false;
        return v0;
    }

    protected void initialiseDecodingTable() {
        int v1 = 0;
        int v0;
        for(v0 = 0; v0 < this.decodingTable.length; ++v0) {
            this.decodingTable[v0] = -1;
        }

        while(v1 < this.encodingTable.length) {
            this.decodingTable[this.encodingTable[v1]] = ((byte)v1);
            ++v1;
        }
    }

    private int nextI(String arg2, int arg3, int arg4) {
        while(arg3 < arg4) {
            if(!this.ignore(arg2.charAt(arg3))) {
                return arg3;
            }

            ++arg3;
        }

        return arg3;
    }

    private int nextI(byte[] arg2, int arg3, int arg4) {
        while(arg3 < arg4) {
            if(!this.ignore(((char)arg2[arg3]))) {
                return arg3;
            }

            ++arg3;
        }

        return arg3;
    }
}

