// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.util.encoders;

import java.io.IOException;
import java.io.OutputStream;

public class HexEncoder implements Encoder {
    protected final byte[] decodingTable;
    protected final byte[] encodingTable;

    public HexEncoder() {
        super();
        this.encodingTable = new byte[]{48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 97, 98, 99, 100, 101, 102};
        this.decodingTable = new byte[128];
        this.initialiseDecodingTable();
    }

    public int decode(String arg7, OutputStream arg8) {
        int v0 = 0;
        int v3;
        for(v3 = arg7.length(); v3 > 0; --v3) {
            if(!HexEncoder.ignore(arg7.charAt(v3 - 1))) {
                break;
            }
        }

        int v2 = 0;
        while(v0 < v3) {
            int v1;
            for(v1 = v0; v1 < v3; ++v1) {
                if(!HexEncoder.ignore(arg7.charAt(v1))) {
                    break;
                }
            }

            v0 = v1 + 1;
            int v4 = this.decodingTable[arg7.charAt(v1)];
            while(v0 < v3) {
                if(!HexEncoder.ignore(arg7.charAt(v0))) {
                    break;
                }

                ++v0;
            }

            v1 = v0 + 1;
            v0 = this.decodingTable[arg7.charAt(v0)];
            if((v4 | v0) < 0) {
                throw new IOException("invalid characters encountered in Hex string");
            }

            arg8.write(v0 | v4 << 4);
            ++v2;
            v0 = v1;
        }

        return v2;
    }

    public int decode(byte[] arg6, int arg7, int arg8, OutputStream arg9) {
        int v3;
        for(v3 = arg7 + arg8; v3 > arg7; --v3) {
            if(!HexEncoder.ignore(((char)arg6[v3 - 1]))) {
                break;
            }
        }

        int v2 = 0;
        int v0;
        for(v0 = arg7; v0 < v3; v0 = arg7) {
            int v1;
            for(v1 = v0; v1 < v3; ++v1) {
                if(!HexEncoder.ignore(((char)arg6[v1]))) {
                    break;
                }
            }

            v0 = v1 + 1;
            v1 = this.decodingTable[arg6[v1]];
            while(v0 < v3) {
                if(!HexEncoder.ignore(((char)arg6[v0]))) {
                    break;
                }

                ++v0;
            }

            arg7 = v0 + 1;
            v0 = this.decodingTable[arg6[v0]];
            if((v1 | v0) < 0) {
                throw new IOException("invalid characters encountered in Hex data");
            }

            arg9.write(v0 | v1 << 4);
            ++v2;
        }

        return v2;
    }

    public int encode(byte[] arg5, int arg6, int arg7, OutputStream arg8) {
        int v0;
        for(v0 = arg6; v0 < arg6 + arg7; ++v0) {
            int v1 = arg5[v0] & 255;
            arg8.write(this.encodingTable[v1 >>> 4]);
            arg8.write(this.encodingTable[v1 & 15]);
        }

        return arg7 * 2;
    }

    private static boolean ignore(char arg1) {
        boolean v0 = arg1 == 10 || arg1 == 13 || arg1 == 9 || arg1 == 32 ? true : false;
        return v0;
    }

    protected void initialiseDecodingTable() {
        int v1 = 0;
        int v0;
        for(v0 = 0; v0 < this.decodingTable.length; ++v0) {
            this.decodingTable[v0] = -1;
        }

        while(v1 < this.encodingTable.length) {
            this.decodingTable[this.encodingTable[v1]] = ((byte)v1);
            ++v1;
        }

        this.decodingTable[65] = this.decodingTable[97];
        this.decodingTable[66] = this.decodingTable[98];
        this.decodingTable[67] = this.decodingTable[99];
        this.decodingTable[68] = this.decodingTable[100];
        this.decodingTable[69] = this.decodingTable[101];
        this.decodingTable[70] = this.decodingTable[102];
    }
}

