// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.util.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.security.SecureRandom;

public class FixedSecureRandom extends SecureRandom {
    private byte[] _data;
    private int _index;
    private int _intPad;

    public FixedSecureRandom(boolean arg3, byte[] arg4) {
        this(arg3, new byte[][]{arg4});
    }

    public FixedSecureRandom(boolean arg4, byte[][] arg5) {
        super();
        ByteArrayOutputStream v1 = new ByteArrayOutputStream();
        int v0 = 0;
        while(v0 != arg5.length) {
            try {
                v1.write(arg5[v0]);
                ++v0;
                continue;
            }
            catch(IOException v0_1) {
                throw new IllegalArgumentException("can\'t save value array.");
            }
        }

        this._data = v1.toByteArray();
        if(arg4) {
            this._intPad = this._data.length % 4;
        }
    }

    public FixedSecureRandom(byte[] arg3) {
        this(false, new byte[][]{arg3});
    }

    public FixedSecureRandom(byte[][] arg2) {
        this(false, arg2);
    }

    public boolean isExhausted() {
        boolean v0 = this._index == this._data.length ? true : false;
        return v0;
    }

    public void nextBytes(byte[] arg5) {
        System.arraycopy(this._data, this._index, arg5, 0, arg5.length);
        this._index += arg5.length;
    }

    public int nextInt() {
        int v0 = 0 | this.nextValue() << 24 | this.nextValue() << 16;
        if(this._intPad == 2) {
            --this._intPad;
        }
        else {
            v0 |= this.nextValue() << 8;
        }

        if(this._intPad == 1) {
            --this._intPad;
        }
        else {
            v0 |= this.nextValue();
        }

        return v0;
    }

    public long nextLong() {
        return 0 | (((long)this.nextValue())) << 56 | (((long)this.nextValue())) << 48 | (((long)this.nextValue())) << 40 | (((long)this.nextValue())) << 32 | (((long)this.nextValue())) << 24 | (((long)this.nextValue())) << 16 | (((long)this.nextValue())) << 8 | (((long)this.nextValue()));
    }

    private int nextValue() {
        byte[] v0 = this._data;
        int v1 = this._index;
        this._index = v1 + 1;
        return v0[v1] & 255;
    }
}

