// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.io.IOException;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.Principal;
import java.security.cert.CertSelector;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.List;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.Holder;
import org.bouncycastle.asn1.x509.IssuerSerial;
import org.bouncycastle.asn1.x509.ObjectDigestInfo;
import org.bouncycastle.asn1.x509.X509Name;
import org.bouncycastle.jce.PrincipalUtil;
import org.bouncycastle.jce.X509Principal;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.Selector;

public class AttributeCertificateHolder implements CertSelector, Selector {
    final Holder holder;

    public AttributeCertificateHolder(int arg6, String arg7, String arg8, byte[] arg9) {
        super();
        this.holder = new Holder(new ObjectDigestInfo(arg6, new ASN1ObjectIdentifier(arg8), new AlgorithmIdentifier(arg7), Arrays.clone(arg9)));
    }

    public AttributeCertificateHolder(X509Certificate arg6) {
        X509Principal v0_1;
        super();
        try {
            v0_1 = PrincipalUtil.getIssuerX509Principal(arg6);
        }
        catch(Exception v0) {
            throw new CertificateParsingException(v0.getMessage());
        }

        this.holder = new Holder(new IssuerSerial(this.generateGeneralNames(v0_1), new ASN1Integer(arg6.getSerialNumber())));
    }

    public AttributeCertificateHolder(X500Principal arg2) {
        this(X509Util.convertPrincipal(arg2));
    }

    public AttributeCertificateHolder(X509Principal arg3) {
        super();
        this.holder = new Holder(this.generateGeneralNames(arg3));
    }

    public AttributeCertificateHolder(X500Principal arg2, BigInteger arg3) {
        this(X509Util.convertPrincipal(arg2), arg3);
    }

    public AttributeCertificateHolder(X509Principal arg5, BigInteger arg6) {
        super();
        this.holder = new Holder(new IssuerSerial(GeneralNames.getInstance(new DERSequence(new GeneralName(((X509Name)arg5)))), new ASN1Integer(arg6)));
    }

    AttributeCertificateHolder(ASN1Sequence arg2) {
        super();
        this.holder = Holder.getInstance(arg2);
    }

    public Object clone() {
        return new AttributeCertificateHolder(this.holder.toASN1Object());
    }

    public boolean equals(Object arg3) {
        boolean v0;
        if((((AttributeCertificateHolder)arg3)) == this) {
            v0 = true;
        }
        else if(!(arg3 instanceof AttributeCertificateHolder)) {
            v0 = false;
        }
        else {
            v0 = this.holder.equals(((AttributeCertificateHolder)arg3).holder);
        }

        return v0;
    }

    private GeneralNames generateGeneralNames(X509Principal arg3) {
        return GeneralNames.getInstance(new DERSequence(new GeneralName(((X509Name)arg3))));
    }

    public String getDigestAlgorithm() {
        String v0 = this.holder.getObjectDigestInfo() != null ? this.holder.getObjectDigestInfo().getDigestAlgorithm().getObjectId().getId() : null;
        return v0;
    }

    public int getDigestedObjectType() {
        int v0 = this.holder.getObjectDigestInfo() != null ? this.holder.getObjectDigestInfo().getDigestedObjectType().getValue().intValue() : -1;
        return v0;
    }

    public Principal[] getEntityNames() {
        Principal[] v0 = this.holder.getEntityName() != null ? this.getPrincipals(this.holder.getEntityName()) : null;
        return v0;
    }

    public Principal[] getIssuer() {
        Principal[] v0 = this.holder.getBaseCertificateID() != null ? this.getPrincipals(this.holder.getBaseCertificateID().getIssuer()) : null;
        return v0;
    }

    private Object[] getNames(GeneralName[] arg5) {
        ArrayList v1 = new ArrayList(arg5.length);
        int v0;
        for(v0 = 0; v0 != arg5.length; ++v0) {
            if(arg5[v0].getTagNo() == 4) {
                try {
                    ((List)v1).add(new X500Principal(arg5[v0].getName().toASN1Primitive().getEncoded()));
                }
                catch(IOException v0_1) {
                    throw new RuntimeException("badly formed Name object");
                }
            }
        }

        return ((List)v1).toArray(new Object[((List)v1).size()]);
    }

    public byte[] getObjectDigest() {
        byte[] v0 = this.holder.getObjectDigestInfo() != null ? this.holder.getObjectDigestInfo().getObjectDigest().getBytes() : null;
        return v0;
    }

    public String getOtherObjectTypeID() {
        if(this.holder.getObjectDigestInfo() != null) {
            this.holder.getObjectDigestInfo().getOtherObjectTypeID().getId();
        }

        return null;
    }

    private Principal[] getPrincipals(GeneralNames arg5) {
        Object[] v1 = this.getNames(arg5.getNames());
        ArrayList v2 = new ArrayList();
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            if((v1[v0] instanceof Principal)) {
                ((List)v2).add(v1[v0]);
            }
        }

        return ((List)v2).toArray(new Principal[((List)v2).size()]);
    }

    public BigInteger getSerialNumber() {
        BigInteger v0 = this.holder.getBaseCertificateID() != null ? this.holder.getBaseCertificateID().getSerial().getValue() : null;
        return v0;
    }

    public int hashCode() {
        return this.holder.hashCode();
    }

    public boolean match(Object arg2) {
        boolean v0 = !(arg2 instanceof X509Certificate) ? false : this.match(((Certificate)arg2));
        return v0;
    }

    public boolean match(Certificate arg6) {
        MessageDigest v0_4;
        boolean v2 = false;
        if((arg6 instanceof X509Certificate)) {
            Certificate v0 = arg6;
            try {
                if(this.holder.getBaseCertificateID() != null) {
                    boolean v0_2 = !this.holder.getBaseCertificateID().getSerial().getValue().equals(((X509Certificate)v0).getSerialNumber()) || !this.matchesDN(PrincipalUtil.getIssuerX509Principal(((X509Certificate)v0)), this.holder.getBaseCertificateID().getIssuer()) ? false : true;
                    return v0_2;
                }

                if(this.holder.getEntityName() != null && (this.matchesDN(PrincipalUtil.getSubjectX509Principal(((X509Certificate)v0)), this.holder.getEntityName()))) {
                    return true;
                }

                if(this.holder.getObjectDigestInfo() == null) {
                    return v2;
                }

                try {
                    v0_4 = MessageDigest.getInstance(this.getDigestAlgorithm(), "BC");
                }
                catch(Exception v0_3) {
                    return v2;
                }
            }
            catch(CertificateEncodingException v0_1) {
                goto label_55;
            }

            try {
                switch(this.getDigestedObjectType()) {
                    case 0: {
                        v0_4.update(arg6.getPublicKey().getEncoded());
                        break;
                    }
                    case 1: {
                        v0_4.update(arg6.getEncoded());
                        break;
                    }
                }

                if(Arrays.areEqual(v0_4.digest(), this.getObjectDigest())) {
                }

            label_55:
            }
            catch(CertificateEncodingException v0_1) {
                goto label_55;
            }
        }

        return v2;
    }

    private boolean matchesDN(X509Principal arg7, GeneralNames arg8) {
        boolean v1 = false;
        GeneralName[] v2 = arg8.getNames();
        int v0 = 0;
        while(v0 != v2.length) {
            GeneralName v3 = v2[v0];
            if(v3.getTagNo() == 4) {
                try {
                    if(!new X509Principal(v3.getName().toASN1Primitive().getEncoded()).equals(arg7)) {
                        goto label_19;
                    }
                }
                catch(IOException v3_1) {
                    goto label_19;
                }

                v1 = true;
            }
            else {
            label_19:
                ++v0;
                continue;
            }

            return v1;
        }

        return v1;
    }
}

