// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.io.IOException;
import java.security.Principal;
import java.security.cert.CertSelector;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.List;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.AttCertIssuer;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.V2Form;
import org.bouncycastle.asn1.x509.X509Name;
import org.bouncycastle.jce.X509Principal;
import org.bouncycastle.util.Selector;

public class AttributeCertificateIssuer implements CertSelector, Selector {
    final ASN1Encodable form;

    public AttributeCertificateIssuer(X500Principal arg3) {
        this(new X509Principal(arg3.getEncoded()));
    }

    public AttributeCertificateIssuer(X509Principal arg4) {
        super();
        this.form = new V2Form(GeneralNames.getInstance(new DERSequence(new GeneralName(((X509Name)arg4)))));
    }

    public AttributeCertificateIssuer(AttCertIssuer arg2) {
        super();
        this.form = arg2.getIssuer();
    }

    public Object clone() {
        return new AttributeCertificateIssuer(AttCertIssuer.getInstance(this.form));
    }

    public boolean equals(Object arg3) {
        boolean v0;
        if((((AttributeCertificateIssuer)arg3)) == this) {
            v0 = true;
        }
        else if(!(arg3 instanceof AttributeCertificateIssuer)) {
            v0 = false;
        }
        else {
            v0 = this.form.equals(((AttributeCertificateIssuer)arg3).form);
        }

        return v0;
    }

    private Object[] getNames() {
        GeneralNames v0;
        if((this.form instanceof V2Form)) {
            v0 = this.form.getIssuerName();
        }
        else {
            ASN1Encodable v0_1 = this.form;
        }

        GeneralName[] v1 = v0.getNames();
        ArrayList v2 = new ArrayList(v1.length);
        int v0_2;
        for(v0_2 = 0; v0_2 != v1.length; ++v0_2) {
            if(v1[v0_2].getTagNo() == 4) {
                try {
                    ((List)v2).add(new X500Principal(v1[v0_2].getName().toASN1Primitive().getEncoded()));
                }
                catch(IOException v0_3) {
                    throw new RuntimeException("badly formed Name object");
                }
            }
        }

        return ((List)v2).toArray(new Object[((List)v2).size()]);
    }

    public Principal[] getPrincipals() {
        Object[] v1 = this.getNames();
        ArrayList v2 = new ArrayList();
        int v0;
        for(v0 = 0; v0 != v1.length; ++v0) {
            if((v1[v0] instanceof Principal)) {
                ((List)v2).add(v1[v0]);
            }
        }

        return ((List)v2).toArray(new Principal[((List)v2).size()]);
    }

    public int hashCode() {
        return this.form.hashCode();
    }

    public boolean match(Object arg2) {
        boolean v0 = !(arg2 instanceof X509Certificate) ? false : this.match(((Certificate)arg2));
        return v0;
    }

    public boolean match(Certificate arg6) {
        boolean v2 = false;
        if((arg6 instanceof X509Certificate)) {
            if((this.form instanceof V2Form)) {
                ASN1Encodable v0 = this.form;
                if(((V2Form)v0).getBaseCertificateID() != null) {
                    boolean v0_1 = !((V2Form)v0).getBaseCertificateID().getSerial().getValue().equals(((X509Certificate)arg6).getSerialNumber()) || !this.matchesDN(((X509Certificate)arg6).getIssuerX500Principal(), ((V2Form)v0).getBaseCertificateID().getIssuer()) ? false : true;
                    v2 = v0_1;
                }
                else {
                    if(!this.matchesDN(((X509Certificate)arg6).getSubjectX500Principal(), ((V2Form)v0).getIssuerName())) {
                        return v2;
                    }

                    v2 = true;
                }
            }
            else {
                if(!this.matchesDN(((X509Certificate)arg6).getSubjectX500Principal(), this.form)) {
                    return v2;
                }

                v2 = true;
            }
        }

        return v2;
    }

    private boolean matchesDN(X500Principal arg7, GeneralNames arg8) {
        boolean v1 = false;
        GeneralName[] v2 = arg8.getNames();
        int v0 = 0;
        while(v0 != v2.length) {
            GeneralName v3 = v2[v0];
            if(v3.getTagNo() == 4) {
                try {
                    if(!new X500Principal(v3.getName().toASN1Primitive().getEncoded()).equals(arg7)) {
                        goto label_19;
                    }
                }
                catch(IOException v3_1) {
                    goto label_19;
                }

                v1 = true;
            }
            else {
            label_19:
                ++v0;
                continue;
            }

            return v1;
        }

        return v1;
    }
}

