// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.security.InvalidParameterException;
import java.security.cert.PKIXBuilderParameters;
import java.security.cert.PKIXParameters;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import org.bouncycastle.util.Selector;

public class ExtendedPKIXBuilderParameters extends ExtendedPKIXParameters {
    private Set excludedCerts;
    private int maxPathLength;

    public ExtendedPKIXBuilderParameters(Set arg2, Selector arg3) {
        super(arg2);
        this.maxPathLength = 5;
        this.excludedCerts = Collections.EMPTY_SET;
        this.setTargetConstraints(arg3);
    }

    public Object clone() {
        ExtendedPKIXBuilderParameters v0_1;
        try {
            v0_1 = new ExtendedPKIXBuilderParameters(this.getTrustAnchors(), this.getTargetConstraints());
        }
        catch(Exception v0) {
            throw new RuntimeException(v0.getMessage());
        }

        v0_1.setParams(((PKIXParameters)this));
        return v0_1;
    }

    public Set getExcludedCerts() {
        return Collections.unmodifiableSet(this.excludedCerts);
    }

    public static ExtendedPKIXParameters getInstance(PKIXParameters arg3) {
        ExtendedPKIXBuilderParameters v1;
        try {
            v1 = new ExtendedPKIXBuilderParameters(arg3.getTrustAnchors(), X509CertStoreSelector.getInstance(arg3.getTargetCertConstraints()));
        }
        catch(Exception v0) {
            throw new RuntimeException(v0.getMessage());
        }

        v1.setParams(arg3);
        return ((ExtendedPKIXParameters)v1);
    }

    public int getMaxPathLength() {
        return this.maxPathLength;
    }

    public void setExcludedCerts(Set arg2) {
        if(arg2 == null) {
        }
        else {
            this.excludedCerts = new HashSet(((Collection)arg2));
        }
    }

    public void setMaxPathLength(int arg3) {
        if(arg3 < -1) {
            throw new InvalidParameterException("The maximum path length parameter can not be less than -1.");
        }

        this.maxPathLength = arg3;
    }

    protected void setParams(PKIXParameters arg3) {
        super.setParams(arg3);
        if((arg3 instanceof ExtendedPKIXBuilderParameters)) {
            this.maxPathLength = arg3.maxPathLength;
            this.excludedCerts = new HashSet(arg3.excludedCerts);
        }

        if((arg3 instanceof PKIXBuilderParameters)) {
            this.maxPathLength = ((PKIXBuilderParameters)arg3).getMaxPathLength();
        }
    }
}

