// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.security.cert.CertSelector;
import java.security.cert.PKIXParameters;
import java.security.cert.TrustAnchor;
import java.security.cert.X509CertSelector;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import org.bouncycastle.util.Selector;
import org.bouncycastle.util.Store;

public class ExtendedPKIXParameters extends PKIXParameters {
    public static final int CHAIN_VALIDITY_MODEL = 1;
    public static final int PKIX_VALIDITY_MODEL;
    private boolean additionalLocationsEnabled;
    private List additionalStores;
    private Set attrCertCheckers;
    private Set necessaryACAttributes;
    private Set prohibitedACAttributes;
    private Selector selector;
    private List stores;
    private Set trustedACIssuers;
    private boolean useDeltas;
    private int validityModel;

    public ExtendedPKIXParameters(Set arg2) {
        super(arg2);
        this.validityModel = 0;
        this.useDeltas = false;
        this.stores = new ArrayList();
        this.additionalStores = new ArrayList();
        this.trustedACIssuers = new HashSet();
        this.necessaryACAttributes = new HashSet();
        this.prohibitedACAttributes = new HashSet();
        this.attrCertCheckers = new HashSet();
    }

    public void addAddionalStore(Store arg1) {
        this.addAdditionalStore(arg1);
    }

    public void addAdditionalStore(Store arg2) {
        if(arg2 != null) {
            this.additionalStores.add(arg2);
        }
    }

    public void addStore(Store arg2) {
        if(arg2 != null) {
            this.stores.add(arg2);
        }
    }

    public Object clone() {
        ExtendedPKIXParameters v0_1;
        try {
            v0_1 = new ExtendedPKIXParameters(this.getTrustAnchors());
        }
        catch(Exception v0) {
            throw new RuntimeException(v0.getMessage());
        }

        v0_1.setParams(((PKIXParameters)this));
        return v0_1;
    }

    public List getAdditionalStores() {
        return Collections.unmodifiableList(this.additionalStores);
    }

    public Set getAttrCertCheckers() {
        return Collections.unmodifiableSet(this.attrCertCheckers);
    }

    public static ExtendedPKIXParameters getInstance(PKIXParameters arg2) {
        ExtendedPKIXParameters v0_1;
        try {
            v0_1 = new ExtendedPKIXParameters(arg2.getTrustAnchors());
        }
        catch(Exception v0) {
            throw new RuntimeException(v0.getMessage());
        }

        v0_1.setParams(arg2);
        return v0_1;
    }

    public Set getNecessaryACAttributes() {
        return Collections.unmodifiableSet(this.necessaryACAttributes);
    }

    public Set getProhibitedACAttributes() {
        return Collections.unmodifiableSet(this.prohibitedACAttributes);
    }

    public List getStores() {
        return Collections.unmodifiableList(new ArrayList(this.stores));
    }

    public Selector getTargetConstraints() {
        Selector v0_1;
        if(this.selector != null) {
            Object v0 = this.selector.clone();
        }
        else {
            v0_1 = null;
        }

        return v0_1;
    }

    public Set getTrustedACIssuers() {
        return Collections.unmodifiableSet(this.trustedACIssuers);
    }

    public int getValidityModel() {
        return this.validityModel;
    }

    public boolean isAdditionalLocationsEnabled() {
        return this.additionalLocationsEnabled;
    }

    public boolean isUseDeltasEnabled() {
        return this.useDeltas;
    }

    public void setAdditionalLocationsEnabled(boolean arg1) {
        this.additionalLocationsEnabled = arg1;
    }

    public void setAttrCertCheckers(Set arg4) {
        if(arg4 == null) {
            this.attrCertCheckers.clear();
        }
        else {
            Iterator v0 = arg4.iterator();
            do {
                if(v0.hasNext()) {
                    if((v0.next() instanceof PKIXAttrCertChecker)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_23;
                }
            }
            while(true);

            throw new ClassCastException("All elements of set must be of type " + PKIXAttrCertChecker.class.getName() + ".");
        label_23:
            this.attrCertCheckers.clear();
            this.attrCertCheckers.addAll(((Collection)arg4));
        }
    }

    public void setCertStores(List arg3) {
        if(arg3 != null) {
            Iterator v1 = arg3.iterator();
            while(v1.hasNext()) {
                this.addCertStore(v1.next());
            }
        }
    }

    public void setNecessaryACAttributes(Set arg3) {
        if(arg3 == null) {
            this.necessaryACAttributes.clear();
        }
        else {
            Iterator v0 = arg3.iterator();
            do {
                if(v0.hasNext()) {
                    if((v0.next() instanceof String)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_14;
                }
            }
            while(true);

            throw new ClassCastException("All elements of set must be of type String.");
        label_14:
            this.necessaryACAttributes.clear();
            this.necessaryACAttributes.addAll(((Collection)arg3));
        }
    }

    protected void setParams(PKIXParameters arg3) {
        Selector v0_1;
        this.setDate(arg3.getDate());
        this.setCertPathCheckers(arg3.getCertPathCheckers());
        this.setCertStores(arg3.getCertStores());
        this.setAnyPolicyInhibited(arg3.isAnyPolicyInhibited());
        this.setExplicitPolicyRequired(arg3.isExplicitPolicyRequired());
        this.setPolicyMappingInhibited(arg3.isPolicyMappingInhibited());
        this.setRevocationEnabled(arg3.isRevocationEnabled());
        this.setInitialPolicies(arg3.getInitialPolicies());
        this.setPolicyQualifiersRejected(arg3.getPolicyQualifiersRejected());
        this.setSigProvider(arg3.getSigProvider());
        this.setTargetCertConstraints(arg3.getTargetCertConstraints());
        try {
            this.setTrustAnchors(arg3.getTrustAnchors());
        }
        catch(Exception v0) {
            throw new RuntimeException(v0.getMessage());
        }

        if((arg3 instanceof ExtendedPKIXParameters)) {
            this.validityModel = ((ExtendedPKIXParameters)arg3).validityModel;
            this.useDeltas = ((ExtendedPKIXParameters)arg3).useDeltas;
            this.additionalLocationsEnabled = ((ExtendedPKIXParameters)arg3).additionalLocationsEnabled;
            if(((ExtendedPKIXParameters)arg3).selector == null) {
                v0_1 = null;
            }
            else {
                Object v0_2 = ((ExtendedPKIXParameters)arg3).selector.clone();
            }

            this.selector = v0_1;
            this.stores = new ArrayList(((ExtendedPKIXParameters)arg3).stores);
            this.additionalStores = new ArrayList(((ExtendedPKIXParameters)arg3).additionalStores);
            this.trustedACIssuers = new HashSet(((ExtendedPKIXParameters)arg3).trustedACIssuers);
            this.prohibitedACAttributes = new HashSet(((ExtendedPKIXParameters)arg3).prohibitedACAttributes);
            this.necessaryACAttributes = new HashSet(((ExtendedPKIXParameters)arg3).necessaryACAttributes);
            this.attrCertCheckers = new HashSet(((ExtendedPKIXParameters)arg3).attrCertCheckers);
        }
    }

    public void setProhibitedACAttributes(Set arg3) {
        if(arg3 == null) {
            this.prohibitedACAttributes.clear();
        }
        else {
            Iterator v0 = arg3.iterator();
            do {
                if(v0.hasNext()) {
                    if((v0.next() instanceof String)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_14;
                }
            }
            while(true);

            throw new ClassCastException("All elements of set must be of type String.");
        label_14:
            this.prohibitedACAttributes.clear();
            this.prohibitedACAttributes.addAll(((Collection)arg3));
        }
    }

    public void setStores(List arg3) {
        if(arg3 == null) {
            this.stores = new ArrayList();
        }
        else {
            Iterator v0 = arg3.iterator();
            do {
                if(v0.hasNext()) {
                    if((v0.next() instanceof Store)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_15;
                }
            }
            while(true);

            throw new ClassCastException("All elements of list must be of type org.bouncycastle.util.Store.");
        label_15:
            this.stores = new ArrayList(((Collection)arg3));
        }
    }

    public void setTargetCertConstraints(CertSelector arg2) {
        super.setTargetCertConstraints(arg2);
        this.selector = arg2 != null ? X509CertStoreSelector.getInstance(((X509CertSelector)arg2)) : null;
    }

    public void setTargetConstraints(Selector arg2) {
        this.selector = arg2 != null ? arg2.clone() : null;
    }

    public void setTrustedACIssuers(Set arg4) {
        if(arg4 == null) {
            this.trustedACIssuers.clear();
        }
        else {
            Iterator v0 = arg4.iterator();
            do {
                if(v0.hasNext()) {
                    if((v0.next() instanceof TrustAnchor)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_23;
                }
            }
            while(true);

            throw new ClassCastException("All elements of set must be of type " + TrustAnchor.class.getName() + ".");
        label_23:
            this.trustedACIssuers.clear();
            this.trustedACIssuers.addAll(((Collection)arg4));
        }
    }

    public void setUseDeltasEnabled(boolean arg1) {
        this.useDeltas = arg1;
    }

    public void setValidityModel(int arg1) {
        this.validityModel = arg1;
    }
}

