// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.math.BigInteger;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.URL;
import java.net.URLConnection;
import java.security.GeneralSecurityException;
import java.security.PublicKey;
import java.security.SignatureException;
import java.security.cert.CRL;
import java.security.cert.CertPath;
import java.security.cert.CertPathValidatorException;
import java.security.cert.Certificate;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateFactory;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.PKIXParameters;
import java.security.cert.PolicyNode;
import java.security.cert.TrustAnchor;
import java.security.cert.X509CRL;
import java.security.cert.X509CRLEntry;
import java.security.cert.X509CertSelector;
import java.security.cert.X509Certificate;
import java.security.cert.X509Extension;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Enumerated;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.ASN1TaggedObject;
import org.bouncycastle.asn1.DEREnumerated;
import org.bouncycastle.asn1.DERInteger;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.x509.AccessDescription;
import org.bouncycastle.asn1.x509.AlgorithmIdentifier;
import org.bouncycastle.asn1.x509.AuthorityInformationAccess;
import org.bouncycastle.asn1.x509.AuthorityKeyIdentifier;
import org.bouncycastle.asn1.x509.BasicConstraints;
import org.bouncycastle.asn1.x509.CRLDistPoint;
import org.bouncycastle.asn1.x509.DistributionPoint;
import org.bouncycastle.asn1.x509.DistributionPointName;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.GeneralSubtree;
import org.bouncycastle.asn1.x509.IssuingDistributionPoint;
import org.bouncycastle.asn1.x509.NameConstraints;
import org.bouncycastle.asn1.x509.PolicyInformation;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.asn1.x509.qualified.MonetaryValue;
import org.bouncycastle.asn1.x509.qualified.QCStatement;
import org.bouncycastle.i18n.ErrorBundle;
import org.bouncycastle.i18n.LocaleString;
import org.bouncycastle.i18n.filter.TrustedInput;
import org.bouncycastle.i18n.filter.UntrustedInput;
import org.bouncycastle.i18n.filter.UntrustedUrlInput;
import org.bouncycastle.jce.provider.AnnotatedException;
import org.bouncycastle.jce.provider.CertPathValidatorUtilities;
import org.bouncycastle.jce.provider.PKIXNameConstraintValidator;
import org.bouncycastle.jce.provider.PKIXNameConstraintValidatorException;
import org.bouncycastle.jce.provider.PKIXPolicyNode;
import org.bouncycastle.util.Integers;
import org.bouncycastle.x509.extension.X509ExtensionUtil;

public class PKIXCertPathReviewer extends CertPathValidatorUtilities {
    private static final String AUTH_INFO_ACCESS = null;
    private static final String CRL_DIST_POINTS = null;
    private static final String QC_STATEMENT = null;
    private static final String RESOURCE_NAME = "org.bouncycastle.x509.CertPathReviewerMessages";
    protected CertPath certPath;
    protected List certs;
    protected List[] errors;
    private boolean initialized;
    protected int n;
    protected List[] notifications;
    protected PKIXParameters pkixParams;
    protected PolicyNode policyTree;
    protected PublicKey subjectPublicKey;
    protected TrustAnchor trustAnchor;
    protected Date validDate;

    static {
        PKIXCertPathReviewer.QC_STATEMENT = X509Extensions.QCStatements.getId();
        PKIXCertPathReviewer.CRL_DIST_POINTS = X509Extensions.CRLDistributionPoints.getId();
        PKIXCertPathReviewer.AUTH_INFO_ACCESS = X509Extensions.AuthorityInfoAccess.getId();
    }

    public PKIXCertPathReviewer() {
        super();
    }

    public PKIXCertPathReviewer(CertPath arg1, PKIXParameters arg2) {
        super();
        this.init(arg1, arg2);
    }

    private String IPtoString(byte[] arg4) {
        String v0_1;
        try {
            v0_1 = InetAddress.getByAddress(arg4).getHostAddress();
        }
        catch(Exception v0) {
            StringBuffer v1 = new StringBuffer();
            int v0_2;
            for(v0_2 = 0; v0_2 != arg4.length; ++v0_2) {
                v1.append(Integer.toHexString(arg4[v0_2] & 255));
                v1.append(' ');
            }

            v0_1 = v1.toString();
        }

        return v0_1;
    }

    protected void addError(ErrorBundle arg3, int arg4) {
        if(arg4 >= -1 && arg4 < this.n) {
            this.errors[arg4 + 1].add(arg3);
            return;
        }

        throw new IndexOutOfBoundsException();
    }

    protected void addError(ErrorBundle arg3) {
        this.errors[0].add(arg3);
    }

    protected void addNotification(ErrorBundle arg3) {
        this.notifications[0].add(arg3);
    }

    protected void addNotification(ErrorBundle arg3, int arg4) {
        if(arg4 >= -1 && arg4 < this.n) {
            this.notifications[arg4 + 1].add(arg3);
            return;
        }

        throw new IndexOutOfBoundsException();
    }

    protected void checkCRLs(PKIXParameters arg15, X509Certificate arg16, Date arg17, X509Certificate arg18, PublicKey arg19, Vector arg20, int arg21) {
        int v1_10;
        ASN1Primitive v1_9;
        ASN1Primitive v4_3;
        ASN1Enumerated v5_2;
        X509CRL v3_1;
        Object v2_2;
        X509CRL v2_1;
        Iterator v5_1;
        Iterator v2;
        X509CRLStoreSelector v3 = new X509CRLStoreSelector();
        try {
            v3.addIssuerName(PKIXCertPathReviewer.getEncodedIssuerPrincipal(arg16).getEncoded());
        }
        catch(IOException v1) {
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlIssuerException"), ((Throwable)v1));
        }

        v3.setCertificateChecking(arg16);
        try {
            Set v1_2 = PKIXCertPathReviewer.CRL_UTIL.findCRLs(v3, arg15);
            v2 = ((Collection)v1_2).iterator();
            if(!((Collection)v1_2).isEmpty()) {
                goto label_50;
            }

            Iterator v4 = PKIXCertPathReviewer.CRL_UTIL.findCRLs(new X509CRLStoreSelector(), arg15).iterator();
            ArrayList v5 = new ArrayList();
            while(v4.hasNext()) {
                ((List)v5).add(v4.next().getIssuerX500Principal());
            }

            this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noCrlInCertstore", new Object[]{new UntrustedInput(v3.getIssuerNames()), new UntrustedInput(v5), Integers.valueOf(((List)v5).size())}), arg21);
        }
        catch(AnnotatedException v1_1) {
            this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlExtractionError", new Object[]{v1_1.getCause().getMessage(), v1_1.getCause(), v1_1.getCause().getClass().getName()}), arg21);
            v2 = new ArrayList().iterator();
        }

    label_50:
        Object v1_3 = null;
        while(true) {
            if(v2.hasNext()) {
                v1_3 = v2.next();
                if(((X509CRL)v1_3).getNextUpdate() != null && !arg15.getDate().before(((X509CRL)v1_3).getNextUpdate())) {
                    this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.localInvalidCRL", new Object[]{new TrustedInput(((X509CRL)v1_3).getThisUpdate()), new TrustedInput(((X509CRL)v1_3).getNextUpdate())}), arg21);
                    continue;
                }

                break;
            }
            else {
                goto label_516;
            }
        }

        this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.localValidCRL", new Object[]{new TrustedInput(((X509CRL)v1_3).getThisUpdate()), new TrustedInput(((X509CRL)v1_3).getNextUpdate())}), arg21);
        Object v4_1 = v1_3;
        X509CRL v1_4 = null;
        goto label_82;
    label_516:
        v4_1 = v1_3;
        v1_4 = null;
    label_82:
        if(v1_4 == null) {
            v5_1 = arg20.iterator();
            v2_1 = v1_4;
        }
        else {
            v2_2 = v4_1;
            v3_1 = v1_4;
            goto label_210;
        }

        while(v5_1.hasNext()) {
            try {
                v1_3 = v5_1.next();
                v3_1 = this.getCRL(((String)v1_3));
                if(v3_1 == null) {
                    continue;
                }

                if(!arg16.getIssuerX500Principal().equals(v3_1.getIssuerX500Principal())) {
                    this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.onlineCRLWrongCA", new Object[]{new UntrustedInput(v3_1.getIssuerX500Principal().getName()), new UntrustedInput(arg16.getIssuerX500Principal().getName()), new UntrustedUrlInput(v1_3)}), arg21);
                    continue;
                }

                if(v3_1.getNextUpdate() != null && !this.pkixParams.getDate().before(v3_1.getNextUpdate())) {
                    this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.onlineInvalidCRL", new Object[]{new TrustedInput(v3_1.getThisUpdate()), new TrustedInput(v3_1.getNextUpdate()), new UntrustedUrlInput(v1_3)}), arg21);
                    continue;
                }

                this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.onlineValidCRL", new Object[]{new TrustedInput(v3_1.getThisUpdate()), new TrustedInput(v3_1.getNextUpdate()), new UntrustedUrlInput(v1_3)}), arg21);
                X509CRL v13 = v3_1;
                int v3_2 = 1;
                v2_1 = v13;
                goto label_210;
            }
            catch(CertPathReviewerException v1_5) {
                this.addNotification(v1_5.getErrorMessage(), arg21);
                v2_1 = v2_1;
                continue;
            }
        }

        v3_1 = v2_1;
        v2_2 = v4_1;
    label_210:
        if((((X509CRL)v2_2)) != null) {
            if(arg18 != null) {
                boolean[] v1_6 = arg18.getKeyUsage();
                if(v1_6 != null) {
                    if(v1_6.length >= 7 && (v1_6[6])) {
                        goto label_250;
                    }

                    throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noCrlSigningPermited"));
                }
            }

        label_250:
            if(arg19 == null) {
                goto label_304;
            }

            try {
                ((X509CRL)v2_2).verify(arg19, "BC");
            }
            catch(Exception v1_7) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlVerifyFailed"), ((Throwable)v1_7));
            }

            X509CRLEntry v4_2 = ((X509CRL)v2_2).getRevokedCertificate(arg16.getSerialNumber());
            if(v4_2 != null) {
                String v1_8 = null;
                if(v4_2.hasExtensions()) {
                    try {
                        v5_2 = DEREnumerated.getInstance(PKIXCertPathReviewer.getExtensionValue(((X509Extension)v4_2), X509Extensions.ReasonCode.getId()));
                        if(v5_2 == null) {
                            goto label_269;
                        }
                    }
                    catch(AnnotatedException v1_1) {
                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlReasonExtError"), ((Throwable)v1_1));
                    }

                    v1_8 = PKIXCertPathReviewer.crlReasons[((DEREnumerated)v5_2).getValue().intValue()];
                }

            label_269:
                if(v1_8 == null) {
                    v1_8 = PKIXCertPathReviewer.crlReasons[7];
                }

                LocaleString v5_3 = new LocaleString("org.bouncycastle.x509.CertPathReviewerMessages", v1_8);
                if(!arg17.before(v4_2.getRevocationDate())) {
                    throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.certRevoked", new Object[]{new TrustedInput(v4_2.getRevocationDate()), v5_3}));
                }

                this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.revokedAfterValidation", new Object[]{new TrustedInput(v4_2.getRevocationDate()), v5_3}), arg21);
            }
            else {
                this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.notRevoked"), arg21);
            }

            if(((X509CRL)v2_2).getNextUpdate() != null && (((X509CRL)v2_2).getNextUpdate().before(this.pkixParams.getDate()))) {
                this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlUpdateAvailable", new Object[]{new TrustedInput(((X509CRL)v2_2).getNextUpdate())}), arg21);
            }

            try {
                v4_3 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v2_2), PKIXCertPathReviewer.ISSUING_DISTRIBUTION_POINT);
            }
            catch(AnnotatedException v1_1) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.distrPtExtError"));
            }

            try {
                v1_9 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v2_2), PKIXCertPathReviewer.DELTA_CRL_INDICATOR);
                if(v1_9 == null) {
                    goto label_452;
                }
            }
            catch(AnnotatedException v1_1) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.deltaCrlExtError"));
            }

            X509CRLStoreSelector v5_4 = new X509CRLStoreSelector();
            try {
                v5_4.addIssuerName(PKIXCertPathReviewer.getIssuerPrincipal(((X509CRL)v2_2)).getEncoded());
            }
            catch(IOException v1) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlIssuerException"), ((Throwable)v1));
            }

            v5_4.setMinCRLNumber(((DERInteger)v1_9).getPositiveValue());
            try {
                v5_4.setMaxCRLNumber(PKIXCertPathReviewer.getExtensionValue(((X509Extension)v2_2), PKIXCertPathReviewer.CRL_NUMBER).getPositiveValue().subtract(BigInteger.valueOf(1)));
            }
            catch(AnnotatedException v1_1) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlNbrExtError"), ((Throwable)v1_1));
            }

            try {
                v5_1 = PKIXCertPathReviewer.CRL_UTIL.findCRLs(v5_4, arg15).iterator();
            }
            catch(AnnotatedException v1_1) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlExtractionError"), ((Throwable)v1_1));
            }

            do {
                if(v5_1.hasNext()) {
                    v1_3 = v5_1.next();
                    try {
                        v1_9 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v1_3), PKIXCertPathReviewer.ISSUING_DISTRIBUTION_POINT);
                        if(v4_3 != null) {
                            goto label_448;
                        }
                    }
                    catch(AnnotatedException v1_1) {
                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.distrPtExtError"), ((Throwable)v1_1));
                    }

                    if(v1_9 != null) {
                        continue;
                    }

                    v1_10 = 1;
                    goto label_385;
                label_448:
                    if(!v4_3.equals(v1_9)) {
                        continue;
                    }

                    break;
                }
                else {
                    goto label_508;
                }
            }
            while(true);

            v1_10 = 1;
            goto label_385;
        label_508:
            v1_10 = 0;
        label_385:
            if(v1_10 == 0) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noBaseCRL"));
            }

        label_452:
            if(v4_3 == null) {
                goto label_499;
            }

            IssuingDistributionPoint v1_11 = IssuingDistributionPoint.getInstance(v4_3);
            try {
                BasicConstraints v2_3 = BasicConstraints.getInstance(PKIXCertPathReviewer.getExtensionValue(arg16, PKIXCertPathReviewer.BASIC_CONSTRAINTS));
            }
            catch(AnnotatedException v1_1) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlBCExtError"), ((Throwable)v1_1));
            }

            if((v1_11.onlyContainsUserCerts()) && v2_3 != null && (v2_3.isCA())) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlOnlyUserCert"));
            }

            if((v1_11.onlyContainsCACerts()) && (v2_3 == null || !v2_3.isCA())) {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlOnlyCaCert"));
            }

            if(!v1_11.onlyContainsAttributeCerts()) {
                goto label_499;
            }

            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlOnlyAttrCert"));
        label_304:
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlNoIssuerPublicKey"));
        }

    label_499:
        if(v3_1 == null) {
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noValidCrlFound"));
        }
    }

    private void checkCriticalExtensions() {
        List v4 = this.pkixParams.getCertPathCheckers();
        Iterator v2 = v4.iterator();
        try {
            while(true) {
                if(!v2.hasNext()) {
                    goto label_33;
                }

                v2.next().init(false);
            }
        }
        catch(CertPathReviewerException v1) {
        }
        catch(CertPathValidatorException v1_1) {
            try {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.certPathCheckerError", new Object[]{v1_1.getMessage(), v1_1, v1_1.getClass().getName()}), ((Throwable)v1_1));
            label_33:
                int v3 = this.certs.size() - 1;
            label_37:
                while(v3 >= 0) {
                    Object v2_1 = this.certs.get(v3);
                    Set v5 = ((X509Certificate)v2_1).getCriticalExtensionOIDs();
                    if(v5 != null && !v5.isEmpty()) {
                        v5.remove(PKIXCertPathReviewer.KEY_USAGE);
                        v5.remove(PKIXCertPathReviewer.CERTIFICATE_POLICIES);
                        v5.remove(PKIXCertPathReviewer.POLICY_MAPPINGS);
                        v5.remove(PKIXCertPathReviewer.INHIBIT_ANY_POLICY);
                        v5.remove(PKIXCertPathReviewer.ISSUING_DISTRIBUTION_POINT);
                        v5.remove(PKIXCertPathReviewer.DELTA_CRL_INDICATOR);
                        v5.remove(PKIXCertPathReviewer.POLICY_CONSTRAINTS);
                        v5.remove(PKIXCertPathReviewer.BASIC_CONSTRAINTS);
                        v5.remove(PKIXCertPathReviewer.SUBJECT_ALTERNATIVE_NAME);
                        v5.remove(PKIXCertPathReviewer.NAME_CONSTRAINTS);
                        if((v5.contains(PKIXCertPathReviewer.QC_STATEMENT)) && (this.processQcStatements(((X509Certificate)v2_1), v3))) {
                            v5.remove(PKIXCertPathReviewer.QC_STATEMENT);
                        }

                        Iterator v6 = v4.iterator();
                        while(true) {
                            if(!v6.hasNext()) {
                                goto label_103;
                            }

                            try {
                                v6.next().check(((Certificate)v2_1), ((Collection)v5));
                                continue;
                            }
                            catch(CertPathValidatorException v1_1) {
                                try {
                                    throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.criticalExtensionError", new Object[]{v1_1.getMessage(), v1_1, v1_1.getClass().getName()}), v1_1.getCause(), this.certPath, v3);
                                label_103:
                                    if(!v5.isEmpty()) {
                                        v2 = v5.iterator();
                                        while(v2.hasNext()) {
                                            this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.unknownCriticalExt", new Object[]{new DERObjectIdentifier(v2.next())}), v3);
                                        }
                                    }

                                label_46:
                                    --v3;
                                    goto label_37;
                                }
                                catch(CertPathReviewerException v1) {
                                label_31:
                                    this.addError(v1.getErrorMessage(), v1.getIndex());
                                    return;
                                }
                            }
                        }
                    }

                    goto label_46;
                }
            }
            catch(CertPathReviewerException v1) {
                goto label_31;
            }
        }
    }

    private void checkNameConstraints() {
        ASN1Primitive v1_3;
        X500Principal v5;
        Object v2;
        int v3;
        PKIXNameConstraintValidator v6 = new PKIXNameConstraintValidator();
        try {
            v3 = this.certs.size() - 1;
            while(true) {
            label_7:
                if(v3 <= 0) {
                    return;
                }

                v2 = this.certs.get(v3);
                if(!PKIXCertPathReviewer.isSelfIssued(((X509Certificate)v2))) {
                    v5 = PKIXCertPathReviewer.getSubjectPrincipal(((X509Certificate)v2));
                    ASN1InputStream v1_1 = new ASN1InputStream(new ByteArrayInputStream(v5.getEncoded()));
                    try {
                        v1_3 = v1_1.readObject();
                        try {
                            v6.checkPermittedDN(((ASN1Sequence)v1_3));
                            goto label_24;
                        }
                        catch(PKIXNameConstraintValidatorException v1_4) {
                            break;
                        }
                    }
                    catch(IOException v1_2) {
                        try {
                            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.ncSubjectNameError", new Object[]{new UntrustedInput(v5)}), ((Throwable)v1_2), this.certPath, v3);
                        }
                        catch(CertPathReviewerException v1) {
                            goto label_55;
                        }
                    }
                }

                goto label_113;
            }
        }
        catch(CertPathReviewerException v1) {
            goto label_55;
        }

        try {
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.notPermittedDN", new Object[]{new UntrustedInput(v5.getName())}), ((Throwable)v1_4), this.certPath, v3);
        }
        catch(CertPathReviewerException v1) {
            goto label_55;
        }

        try {
        label_24:
            v6.checkExcludedDN(((ASN1Sequence)v1_3));
        }
        catch(PKIXNameConstraintValidatorException v1_4) {
            try {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.excludedDN", new Object[]{new UntrustedInput(v5.getName())}), ((Throwable)v1_4), this.certPath, v3);
            }
            catch(CertPathReviewerException v1) {
                goto label_55;
            }
        }

        try {
            v1_3 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v2), PKIXCertPathReviewer.SUBJECT_ALTERNATIVE_NAME);
            if(v1_3 == null) {
                goto label_113;
            }
        }
        catch(AnnotatedException v1_5) {
            try {
                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.subjAltNameExtError"), ((Throwable)v1_5), this.certPath, v3);
            }
            catch(CertPathReviewerException v1) {
                goto label_55;
            }
        }

        int v5_1 = 0;
        try {
            while(true) {
                if(v5_1 < ((ASN1Sequence)v1_3).size()) {
                    GeneralName v7 = GeneralName.getInstance(((ASN1Sequence)v1_3).getObjectAt(v5_1));
                    try {
                        v6.checkPermitted(v7);
                        v6.checkExcluded(v7);
                        ++v5_1;
                        continue;
                    }
                    catch(PKIXNameConstraintValidatorException v1_4) {
                        try {
                            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.notPermittedEmail", new Object[]{new UntrustedInput(v7)}), ((Throwable)v1_4), this.certPath, v3);
                            try {
                            label_113:
                                v1_3 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v2), PKIXCertPathReviewer.NAME_CONSTRAINTS);
                                if(v1_3 == null) {
                                    break;
                                }
                            }
                            catch(AnnotatedException v1_5) {
                                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.ncExtError"), ((Throwable)v1_5), this.certPath, v3);
                            }

                            NameConstraints v1_6 = NameConstraints.getInstance(v1_3);
                            GeneralSubtree[] v2_1 = v1_6.getPermittedSubtrees();
                            if(v2_1 != null) {
                                v6.intersectPermittedSubtree(v2_1);
                            }

                            v2_1 = v1_6.getExcludedSubtrees();
                            if(v2_1 == null) {
                                break;
                            }

                            int v1_7;
                            for(v1_7 = 0; true; ++v1_7) {
                                if(v1_7 == v2_1.length) {
                                    goto label_138;
                                }

                                v6.addExcludedSubtree(v2_1[v1_7]);
                            }
                        }
                        catch(CertPathReviewerException v1) {
                            goto label_55;
                        }
                    }
                }

                goto label_113;
            }
        }
        catch(CertPathReviewerException v1) {
            goto label_55;
        }

    label_138:
        --v3;
        goto label_7;
    label_55:
        this.addError(v1.getErrorMessage(), v1.getIndex());
    }

    private void checkPathLength() {
        int v0_4;
        BasicConstraints v0_2;
        int v1 = this.n;
        int v2 = this.certs.size() - 1;
        int v4 = v1;
        v1 = 0;
        while(v2 > 0) {
            Object v0 = this.certs.get(v2);
            if(!PKIXCertPathReviewer.isSelfIssued(((X509Certificate)v0))) {
                if(v4 <= 0) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.pathLenghtExtended"));
                }

                int v5 = v4 - 1;
                v4 = v1 + 1;
                v1 = v5;
            }
            else {
                int v8 = v1;
                v1 = v4;
                v4 = v8;
            }

            try {
                v0_2 = BasicConstraints.getInstance(PKIXCertPathReviewer.getExtensionValue(((X509Extension)v0), PKIXCertPathReviewer.BASIC_CONSTRAINTS));
            }
            catch(AnnotatedException v0_1) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.processLengthConstError"), v2);
                v0_2 = null;
            }

            if(v0_2 != null) {
                BigInteger v0_3 = v0_2.getPathLenConstraint();
                if(v0_3 != null) {
                    v0_4 = v0_3.intValue();
                    if(v0_4 >= v1) {
                        goto label_55;
                    }
                }
                else {
                    goto label_55;
                }
            }
            else {
            label_55:
                v0_4 = v1;
            }

            --v2;
            v1 = v4;
            v4 = v0_4;
        }

        this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.totalPathLength", new Object[]{Integers.valueOf(v1)}));
    }

    private void checkPolicy() {
        PKIXPolicyNode v4_3;
        ASN1Primitive v2_9;
        ASN1Primitive v3_5;
        PKIXPolicyNode v7_3;
        HashSet v8_2;
        ArrayList v7_2;
        int v6_2;
        Iterator v5_5;
        Object v8;
        Object v2_7;
        Object v6_1;
        PolicyInformation v3_3;
        HashSet v17;
        Iterator v3_2;
        Set v5_3;
        HashSet v2_4;
        ASN1Primitive v11;
        Object v10_1;
        Set v6;
        PKIXPolicyNode v15;
        int v14;
        int v13;
        int v12;
        int v16;
        Set v19 = this.pkixParams.getInitialPolicies();
        ArrayList[] v20 = new ArrayList[this.n + 1];
        int v2;
        for(v2 = 0; v2 < v20.length; ++v2) {
            v20[v2] = new ArrayList();
        }

        HashSet v5 = new HashSet();
        ((Set)v5).add("2.5.29.32.0");
        PKIXPolicyNode v2_1 = new PKIXPolicyNode(new ArrayList(), 0, ((Set)v5), null, new HashSet(), "2.5.29.32.0", false);
        v20[0].add(v2_1);
        int v3 = this.pkixParams.isExplicitPolicyRequired() ? 0 : this.n + 1;
        int v4 = this.pkixParams.isAnyPolicyInhibited() ? 0 : this.n + 1;
        int v5_1 = this.pkixParams.isPolicyMappingInhibited() ? 0 : this.n + 1;
        Set v7 = null;
        X509Certificate v10 = null;
        try {
            v16 = this.certs.size() - 1;
            v12 = v5_1;
            v13 = v4;
            v14 = v3;
            v15 = v2_1;
            v6 = v7;
            while(true) {
            label_61:
                if(v16 < 0) {
                    goto label_486;
                }

                v4 = this.n - v16;
                v10_1 = this.certs.get(v16);
                try {
                    v11 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v10_1), PKIXCertPathReviewer.CERTIFICATE_POLICIES);
                    if(v11 == null) {
                        goto label_271;
                    }

                    break;
                }
                catch(AnnotatedException v2_3) {
                    try {
                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyExtError"), ((Throwable)v2_3), this.certPath, v16);
                    }
                    catch(CertPathReviewerException v2_2) {
                        goto label_103;
                    }
                }
            }
        }
        catch(CertPathReviewerException v2_2) {
            goto label_103;
        }

        if(v15 != null) {
            try {
                Enumeration v3_1 = ((ASN1Sequence)v11).getObjects();
                v2_4 = new HashSet();
                while(true) {
                    if(v3_1.hasMoreElements()) {
                        PolicyInformation v5_2 = PolicyInformation.getInstance(v3_1.nextElement());
                        ASN1ObjectIdentifier v7_1 = v5_2.getPolicyIdentifier();
                        ((Set)v2_4).add(((DERObjectIdentifier)v7_1).getId());
                        if(!"2.5.29.32.0".equals(((DERObjectIdentifier)v7_1).getId())) {
                            goto label_91;
                        }
                        else {
                            continue;
                            try {
                            label_91:
                                v5_3 = PKIXCertPathReviewer.getQualifierSet(v5_2.getPolicyQualifiers());
                                goto label_93;
                            }
                            catch(CertPathValidatorException v2_5) {
                                try {
                                    throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyQualifierError"), ((Throwable)v2_5), this.certPath, v16);
                                label_93:
                                    if(PKIXCertPathReviewer.processCertD1i(v4, v20, ((DERObjectIdentifier)v7_1), v5_3)) {
                                        continue;
                                    }

                                    PKIXCertPathReviewer.processCertD1ii(v4, v20, ((DERObjectIdentifier)v7_1), v5_3);
                                    continue;
                                label_139:
                                    if(v6 == null || (v6.contains("2.5.29.32.0"))) {
                                        v17 = v2_4;
                                        goto label_144;
                                    label_194:
                                        while(v3_2.hasNext()) {
                                            Object v5_4 = v3_2.next();
                                            if(!((Set)v2_4).contains(v5_4)) {
                                                continue;
                                            }

                                            v17.add(v5_4);
                                        }
                                    }
                                    else {
                                        v3_2 = v6.iterator();
                                        v17 = new HashSet();
                                        goto label_194;
                                    }

                                label_144:
                                    if(v13 > 0 || v4 < this.n && (PKIXCertPathReviewer.isSelfIssued(((X509Certificate)v10_1)))) {
                                        Enumeration v2_6 = ((ASN1Sequence)v11).getObjects();
                                        do {
                                            if(v2_6.hasMoreElements()) {
                                                v3_3 = PolicyInformation.getInstance(v2_6.nextElement());
                                                if(!"2.5.29.32.0".equals(v3_3.getPolicyIdentifier().getId())) {
                                                    continue;
                                                }

                                                break;
                                            }

                                            goto label_233;
                                        }
                                        while(true);

                                        try {
                                            v7 = PKIXCertPathReviewer.getQualifierSet(v3_3.getPolicyQualifiers());
                                            v2 = v4 - 1;
                                        }
                                        catch(CertPathValidatorException v2_5) {
                                            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyQualifierError"), ((Throwable)v2_5), this.certPath, v16);
                                        }

                                        ArrayList v21 = v20[v2];
                                        int v18 = 0;
                                        while(true) {
                                            if(v18 < ((List)v21).size()) {
                                                v6_1 = v21.get(v18);
                                                Iterator v22 = ((PKIXPolicyNode)v6_1).getExpectedPolicies().iterator();
                                                do {
                                                label_174:
                                                    if(v22.hasNext()) {
                                                        v2_7 = v22.next();
                                                        if((v2_7 instanceof String)) {
                                                            v8 = v2_7;
                                                        }
                                                        else {
                                                            if(!(v2_7 instanceof DERObjectIdentifier)) {
                                                                continue;
                                                            }

                                                            break;
                                                        }

                                                        goto label_180;
                                                    }
                                                    else {
                                                        goto label_230;
                                                    }
                                                }
                                                while(true);

                                                String v8_1 = ((DERObjectIdentifier)v2_7).getId();
                                            label_180:
                                                v3 = 0;
                                                v5_5 = ((PKIXPolicyNode)v6_1).getChildren();
                                                break;
                                            label_230:
                                                ++v18;
                                                continue;
                                            }

                                            goto label_233;
                                        }

                                        while(true) {
                                        label_182:
                                            if(!v5_5.hasNext()) {
                                                goto label_217;
                                            }

                                            if(((String)v8).equals(v5_5.next().getValidPolicy())) {
                                                v2 = 1;
                                            }
                                            else {
                                                goto label_734;
                                            }

                                            goto label_189;
                                        }
                                    }

                                    goto label_233;
                                }
                                catch(CertPathReviewerException v2_2) {
                                    goto label_103;
                                }
                            }
                        }
                    }
                    else {
                        goto label_139;
                    }

                    goto label_273;
                }
            }
            catch(CertPathReviewerException v2_2) {
                goto label_103;
            }

        label_734:
            v2 = v3;
            try {
            label_189:
                v3 = v2;
                goto label_182;
            label_217:
                if(v3 != 0) {
                    goto label_174;
                }

                v5 = new HashSet();
                ((Set)v5).add(v8);
                v2_1 = new PKIXPolicyNode(new ArrayList(), v4, ((Set)v5), ((PolicyNode)v6_1), v7, ((String)v8), false);
                ((PKIXPolicyNode)v6_1).addChild(v2_1);
                v20[v4].add(v2_1);
                goto label_174;
            label_233:
                v6_2 = v4 - 1;
                while(true) {
                label_235:
                    if(v6_2 < 0) {
                        goto label_257;
                    }

                    v7_2 = v20[v6_2];
                    v5_1 = 0;
                    PKIXPolicyNode v3_4;
                    for(v3_4 = v15; v5_1 < ((List)v7_2).size(); v3_4 = v2_1) {
                        v2_7 = ((List)v7_2).get(v5_1);
                        if(!((PKIXPolicyNode)v2_7).hasChildren()) {
                            v2_1 = PKIXCertPathReviewer.removePolicyNode(v3_4, v20, ((PKIXPolicyNode)v2_7));
                            if(v2_1 != null) {
                                goto label_253;
                            }

                            goto label_248;
                        }
                        else {
                            v2_1 = v3_4;
                        }

                    label_253:
                        ++v5_1;
                    }
                }
            }
            catch(CertPathReviewerException v2_2) {
                goto label_103;
            }

            v2_1 = v3_4;
            try {
            label_248:
                --v6_2;
                v15 = v2_1;
                goto label_235;
            label_257:
                Set v2_8 = ((X509Certificate)v10_1).getCriticalExtensionOIDs();
                if(v2_8 != null) {
                    boolean v5_6 = v2_8.contains(PKIXCertPathReviewer.CERTIFICATE_POLICIES);
                    ArrayList v6_3 = v20[v4];
                    for(v3 = 0; v3 < ((List)v6_3).size(); ++v3) {
                        ((List)v6_3).get(v3).setCritical(v5_6);
                    }
                }
            }
            catch(CertPathReviewerException v2_2) {
                goto label_103;
            }

            v8_2 = v17;
            v7_3 = v15;
        }
        else {
            try {
            label_271:
                v8_2 = ((HashSet)v6);
                v7_3 = v15;
            label_273:
                if(v11 == null) {
                    v7_3 = null;
                }

                if(v14 <= 0 && v7_3 == null) {
                    throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noValidPolicyTree"));
                }

                if(v4 != this.n) {
                    try {
                        v3_5 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v10_1), PKIXCertPathReviewer.POLICY_MAPPINGS);
                        if(v3_5 == null) {
                            goto label_343;
                        }
                    }
                    catch(AnnotatedException v2_3) {
                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyMapExtError"), ((Throwable)v2_3), this.certPath, v16);
                    }

                    v2_9 = v3_5;
                    int v9 = 0;
                    while(v9 < ((ASN1Sequence)v2_9).size()) {
                        ASN1Encodable v5_7 = ((ASN1Sequence)v2_9).getObjectAt(v9);
                        ASN1Encodable v6_4 = ((ASN1Sequence)v5_7).getObjectAt(0);
                        v5_7 = ((ASN1Sequence)v5_7).getObjectAt(1);
                        if("2.5.29.32.0".equals(((DERObjectIdentifier)v6_4).getId())) {
                            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.invalidPolicyMapping"), this.certPath, v16);
                        }
                        else if("2.5.29.32.0".equals(((DERObjectIdentifier)v5_7).getId())) {
                            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.invalidPolicyMapping"), this.certPath, v16);
                        }
                        else {
                            ++v9;
                            continue;
                        }

                        break;
                    }

                label_343:
                    if(v3_5 != null) {
                        HashMap v9_1 = new HashMap();
                        HashSet v11_1 = new HashSet();
                        for(v6_2 = 0; v6_2 < ((ASN1Sequence)v3_5).size(); ++v6_2) {
                            ASN1Encodable v2_10 = ((ASN1Sequence)v3_5).getObjectAt(v6_2);
                            String v5_8 = ((ASN1Sequence)v2_10).getObjectAt(0).getId();
                            String v15_1 = ((ASN1Sequence)v2_10).getObjectAt(1).getId();
                            if(!((Map)v9_1).containsKey(v5_8)) {
                                v2_4 = new HashSet();
                                ((Set)v2_4).add(v15_1);
                                ((Map)v9_1).put(v5_8, v2_4);
                                ((Set)v11_1).add(v5_8);
                            }
                            else {
                                ((Map)v9_1).get(v5_8).add(v15_1);
                            }
                        }

                        v5_5 = ((Set)v11_1).iterator();
                        v3_4 = v7_3;
                        while(true) {
                        label_374:
                            if(!v5_5.hasNext()) {
                                goto label_409;
                            }

                            v2_7 = v5_5.next();
                            if(v12 > 0) {
                                try {
                                    PKIXCertPathReviewer.prepareNextCertB1(v4, v20, ((String)v2_7), ((Map)v9_1), ((X509Certificate)v10_1));
                                    v2_1 = v3_4;
                                    goto label_381;
                                }
                                catch(CertPathValidatorException v2_5) {
                                }
                                catch(AnnotatedException v2_3) {
                                    try {
                                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyExtError"), ((Throwable)v2_3), this.certPath, v16);
                                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyQualifierError"), ((Throwable)v2_5), this.certPath, v16);
                                    label_405:
                                        if(v12 <= 0) {
                                            v2_1 = PKIXCertPathReviewer.prepareNextCertB2(v4, v20, ((String)v2_7), v3_4);
                                        }
                                        else {
                                            goto label_720;
                                        }

                                        goto label_381;
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }
                                }
                            }
                            else {
                                goto label_405;
                            }

                            goto label_381;
                        }
                    }
                    else {
                        goto label_722;
                    }

                    goto label_410;
                }
                else {
                    goto label_724;
                }
            }
            catch(CertPathReviewerException v2_2) {
                goto label_103;
            }
        }

        goto label_273;
    label_720:
        v2_1 = v3_4;
    label_381:
        v3_4 = v2_1;
        goto label_374;
    label_409:
        PKIXPolicyNode v6_5 = v3_4;
        goto label_410;
    label_722:
        v6_5 = v7_3;
        try {
        label_410:
            if(!PKIXCertPathReviewer.isSelfIssued(((X509Certificate)v10_1))) {
            }
            else {
                goto label_716;
            }
        }
        catch(CertPathReviewerException v2_2) {
            goto label_103;
        }

        v4 = v14 != 0 ? v14 - 1 : v14;
        v3 = v12 != 0 ? v12 - 1 : v12;
        if(v13 != 0) {
            v5_1 = v13 - 1;
            goto label_419;
        }

        v5_1 = v13;
        goto label_419;
    label_716:
        v3 = v12;
        v5_1 = v13;
        v4 = v14;
        try {
        label_419:
            v2_9 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v10_1), PKIXCertPathReviewer.POLICY_CONSTRAINTS);
            if(v2_9 != null) {
                Enumeration v7_4 = ((ASN1Sequence)v2_9).getObjects();
                while(true) {
                label_423:
                    if(v7_4.hasMoreElements()) {
                        v2_7 = v7_4.nextElement();
                        switch(((ASN1TaggedObject)v2_7).getTagNo()) {
                            case 0: {
                                try {
                                    v2 = DERInteger.getInstance(((ASN1TaggedObject)v2_7), false).getValue().intValue();
                                    if(v2 < v4) {
                                        int v23 = v3;
                                        v3 = v2;
                                        v2 = v23;
                                        goto label_430;
                                    }
                                    else {
                                    label_428:
                                        v2 = v3;
                                        v3 = v4;
                                    label_430:
                                        v4 = v3;
                                        v3 = v2;
                                        goto label_423;
                                    }
                                }
                                catch(CertPathReviewerException v2_2) {
                                }
                                catch(AnnotatedException v2_3) {
                                    try {
                                    label_450:
                                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyConstExtError"), this.certPath, v16);
                                        try {
                                        label_460:
                                            v2_9 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v10_1), PKIXCertPathReviewer.INHIBIT_ANY_POLICY);
                                            if(v2_9 != null) {
                                                v2 = ((DERInteger)v2_9).getValue().intValue();
                                                if(v2 >= v5_1) {
                                                    goto label_708;
                                                }
                                            }
                                            else {
                                                goto label_708;
                                            }

                                            goto label_466;
                                        }
                                        catch(AnnotatedException v2_3) {
                                            try {
                                                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyInhibitExtError"), this.certPath, v16);
                                            }
                                            catch(CertPathReviewerException v2_2) {
                                                goto label_103;
                                            }
                                        }
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }

                                label_708:
                                    v2 = v5_1;
                                label_466:
                                    PKIXPolicyNode v5_9 = v6_5;
                                    goto label_467;
                                label_724:
                                    v3 = v12;
                                    v2 = v13;
                                    v4 = v14;
                                    v5_9 = v7_3;
                                label_467:
                                    --v16;
                                    v12 = v3;
                                    v13 = v2;
                                    v14 = v4;
                                    v15 = v5_9;
                                    HashSet v6_6 = v8_2;
                                    goto label_61;
                                    try {
                                    label_486:
                                        if(!PKIXCertPathReviewer.isSelfIssued(((X509Certificate)v10_1))) {
                                        }
                                        else {
                                            goto label_706;
                                        }
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }

                                    if(v14 > 0) {
                                        v3 = v14 - 1;
                                    }
                                    else {
                                    label_706:
                                        v3 = v14;
                                    }

                                    try {
                                        v2_9 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v10_1), PKIXCertPathReviewer.POLICY_CONSTRAINTS);
                                        if(v2_9 != null) {
                                            Enumeration v4_1 = ((ASN1Sequence)v2_9).getObjects();
                                            while(true) {
                                            label_495:
                                                if(v4_1.hasMoreElements()) {
                                                    v2_7 = v4_1.nextElement();
                                                    switch(((ASN1TaggedObject)v2_7).getTagNo()) {
                                                        case 0: {
                                                            if(DERInteger.getInstance(((ASN1TaggedObject)v2_7), false).getValue().intValue() == 0) {
                                                                v2 = 0;
                                                            }
                                                            else {
                                                                goto label_500;
                                                            }

                                                            goto label_501;
                                                        }
                                                        default: {
                                                        label_500:
                                                            v2 = v3;
                                                            goto label_501;
                                                        }
                                                    }
                                                }

                                                goto label_521;
                                            }
                                        }

                                        goto label_521;
                                    }
                                    catch(AnnotatedException v2_3) {
                                        goto label_511;
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }

                                label_501:
                                    v3 = v2;
                                    goto label_495;
                                    try {
                                    label_511:
                                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.policyConstExtError"), this.certPath, v16);
                                    label_521:
                                        if(v15 == null) {
                                            if(this.pkixParams.isExplicitPolicyRequired()) {
                                                throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.explicitPolicy"), this.certPath, v16);
                                            }
                                            else {
                                                v2_1 = null;
                                            }
                                        }
                                        else if(PKIXCertPathReviewer.isAnyPolicy(v19)) {
                                            if(this.pkixParams.isExplicitPolicyRequired()) {
                                                if(((Set)v6_6).isEmpty()) {
                                                    throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.explicitPolicy"), this.certPath, v16);
                                                }
                                                else {
                                                    HashSet v7_5 = new HashSet();
                                                    for(v5_1 = 0; v5_1 < v20.length; ++v5_1) {
                                                        ArrayList v8_3 = v20[v5_1];
                                                        for(v4 = 0; v4 < ((List)v8_3).size(); ++v4) {
                                                            v2_7 = ((List)v8_3).get(v4);
                                                            if("2.5.29.32.0".equals(((PKIXPolicyNode)v2_7).getValidPolicy())) {
                                                                Iterator v2_11 = ((PKIXPolicyNode)v2_7).getChildren();
                                                                while(v2_11.hasNext()) {
                                                                    ((Set)v7_5).add(v2_11.next());
                                                                }
                                                            }
                                                        }
                                                    }

                                                    Iterator v4_2 = ((Set)v7_5).iterator();
                                                    while(v4_2.hasNext()) {
                                                        if(((Set)v6_6).contains(v4_2.next().getValidPolicy())) {
                                                            continue;
                                                        }
                                                    }

                                                    if(v15 == null) {
                                                        goto label_704;
                                                    }

                                                    v6_2 = this.n - 1;
                                                    v2_1 = v15;
                                                    while(true) {
                                                    label_607:
                                                        if(v6_2 < 0) {
                                                            goto label_537;
                                                        }

                                                        v7_2 = v20[v6_2];
                                                        v5_1 = 0;
                                                        v4_3 = v2_1;
                                                        while(true) {
                                                        label_612:
                                                            if(v5_1 >= ((List)v7_2).size()) {
                                                                goto label_623;
                                                            }

                                                            v2_7 = ((List)v7_2).get(v5_1);
                                                            if(!((PKIXPolicyNode)v2_7).hasChildren()) {
                                                                v2_1 = PKIXCertPathReviewer.removePolicyNode(v4_3, v20, ((PKIXPolicyNode)v2_7));
                                                            }
                                                            else {
                                                                goto label_702;
                                                            }

                                                            goto label_619;
                                                        }
                                                    }
                                                }
                                            }

                                            goto label_704;
                                        }
                                        else {
                                            goto label_627;
                                        }

                                        goto label_537;
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }

                                label_702:
                                    v2_1 = v4_3;
                                label_619:
                                    ++v5_1;
                                    v4_3 = v2_1;
                                    goto label_612;
                                label_623:
                                    --v6_2;
                                    v2_1 = v4_3;
                                    goto label_607;
                                label_704:
                                    v2_1 = v15;
                                    goto label_537;
                                    try {
                                    label_627:
                                        v6_6 = new HashSet();
                                        for(v5_1 = 0; v5_1 < v20.length; ++v5_1) {
                                            v7_2 = v20[v5_1];
                                            for(v4 = 0; v4 < ((List)v7_2).size(); ++v4) {
                                                v2_7 = ((List)v7_2).get(v4);
                                                if("2.5.29.32.0".equals(((PKIXPolicyNode)v2_7).getValidPolicy())) {
                                                    Iterator v8_4 = ((PKIXPolicyNode)v2_7).getChildren();
                                                    while(v8_4.hasNext()) {
                                                        v2_7 = v8_4.next();
                                                        if("2.5.29.32.0".equals(((PKIXPolicyNode)v2_7).getValidPolicy())) {
                                                            continue;
                                                        }

                                                        ((Set)v6_6).add(v2_7);
                                                    }
                                                }
                                            }
                                        }

                                        v5_5 = ((Set)v6_6).iterator();
                                        v4_3 = v15;
                                        while(true) {
                                        label_662:
                                            if(!v5_5.hasNext()) {
                                                goto label_673;
                                            }

                                            v2_7 = v5_5.next();
                                            if(!v19.contains(((PKIXPolicyNode)v2_7).getValidPolicy())) {
                                                v2_1 = PKIXCertPathReviewer.removePolicyNode(v4_3, v20, ((PKIXPolicyNode)v2_7));
                                            }
                                            else {
                                                break;
                                            }

                                            goto label_671;
                                        }
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }

                                    v2_1 = v4_3;
                                    try {
                                    label_671:
                                        v4_3 = v2_1;
                                        goto label_662;
                                    label_673:
                                        if(v4_3 != null) {
                                            v6_2 = this.n - 1;
                                            while(true) {
                                            label_678:
                                                if(v6_2 >= 0) {
                                                    v7_2 = v20[v6_2];
                                                    v5_1 = 0;
                                                    while(true) {
                                                    label_682:
                                                        if(v5_1 < ((List)v7_2).size()) {
                                                            v2_7 = ((List)v7_2).get(v5_1);
                                                            if(!((PKIXPolicyNode)v2_7).hasChildren()) {
                                                                v2_1 = PKIXCertPathReviewer.removePolicyNode(v4_3, v20, ((PKIXPolicyNode)v2_7));
                                                            }
                                                            else {
                                                                goto label_698;
                                                            }

                                                            goto label_689;
                                                        }
                                                        else {
                                                            goto label_693;
                                                        }
                                                    }
                                                }

                                                goto label_696;
                                            }
                                        }

                                        goto label_696;
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                        goto label_103;
                                    }

                                label_698:
                                    v2_1 = v4_3;
                                label_689:
                                    ++v5_1;
                                    v4_3 = v2_1;
                                    goto label_682;
                                label_693:
                                    --v6_2;
                                    goto label_678;
                                label_696:
                                    v2_1 = v4_3;
                                    try {
                                    label_537:
                                        if(v3 > 0) {
                                            return;
                                        }

                                        if(v2_1 != null) {
                                            return;
                                        }

                                        throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.invalidPolicy"));
                                    }
                                    catch(CertPathReviewerException v2_2) {
                                    label_103:
                                        this.addError(v2_2.getErrorMessage(), v2_2.getIndex());
                                        return;
                                    }
                                }
                            }
                            case 1: {
                                v2 = DERInteger.getInstance(((ASN1TaggedObject)v2_7), false).getValue().intValue();
                                if(v2 < v3) {
                                    v3 = v4;
                                    goto label_430;
                                }
                                else {
                                    goto label_428;
                                }
                            }
                            default: {
                            }
                        }
                    }

                    goto label_460;
                }
            }

            goto label_460;
        }
        catch(CertPathReviewerException v2_2) {
            goto label_103;
        }
        catch(AnnotatedException v2_3) {
            goto label_450;
        }
    }

    protected void checkRevocation(PKIXParameters arg9, X509Certificate arg10, Date arg11, X509Certificate arg12, PublicKey arg13, Vector arg14, Vector arg15, int arg16) {
        this.checkCRLs(arg9, arg10, arg11, arg12, arg13, arg14, arg16);
    }

    private void checkSignatures() {
        PublicKey v1_18;
        AlgorithmIdentifier v4_2;
        boolean[] v1_7;
        X500Principal v3_3;
        X500Principal v1_6;
        X509Certificate v11;
        PublicKey v3_2;
        X509Certificate v3_1;
        Object v2_1;
        Object v1_2;
        Object v3 = null;
        X500Principal v4 = null;
        this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.certPathValidDate", new Object[]{new TrustedInput(this.validDate), new TrustedInput(new Date())}));
        try {
            v1_2 = this.certs.get(this.certs.size() - 1);
            Collection v2 = this.getTrustAnchors(((X509Certificate)v1_2), this.pkixParams.getTrustAnchors());
            if(v2.size() > 1) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.conflictingTrustAnchors", new Object[]{Integers.valueOf(v2.size()), new UntrustedInput(((X509Certificate)v1_2).getIssuerX500Principal())}));
                v2_1 = v3;
                goto label_55;
            }

            if(v2.isEmpty()) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noTrustAnchorFound", new Object[]{new UntrustedInput(((X509Certificate)v1_2).getIssuerX500Principal()), Integers.valueOf(this.pkixParams.getTrustAnchors().size())}));
                v2_1 = v3;
                goto label_55;
            }

            v2_1 = v2.iterator().next();
        }
        catch(CertPathReviewerException v1) {
            goto label_519;
        }
        catch(Throwable v1_1) {
            goto label_192;
        }

        try {
            v3_1 = ((TrustAnchor)v2_1).getTrustedCert();
            goto label_166;
        }
        catch(Throwable v1_1) {
        }
        catch(CertPathReviewerException v1) {
        }
        catch(Throwable v1_1) {
            goto label_192;
            try {
            label_166:
                v3_2 = v3_1 != null ? ((TrustAnchor)v2_1).getTrustedCert().getPublicKey() : ((TrustAnchor)v2_1).getCAPublicKey();
            }
            catch(CertPathReviewerException v1) {
                goto label_183;
            }
            catch(Throwable v1_1) {
                goto label_516;
            }

            try {
                CertPathValidatorUtilities.verifyX509Certificate(((X509Certificate)v1_2), v3_2, this.pkixParams.getSigProvider());
                goto label_55;
            }
            catch(Throwable v1_1) {
            label_516:
                v3 = v2_1;
            }
            catch(CertPathReviewerException v1) {
            label_183:
                v3 = v2_1;
            label_184:
                this.addError(v1.getErrorMessage());
                v11 = v3_1;
                goto label_56;
            }
            catch(Exception v1_3) {
                goto label_55;
            }
            catch(SignatureException v1_4) {
                try {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.trustButInvalidCert"));
                    goto label_55;
                }
                catch(CertPathReviewerException v1) {
                    goto label_183;
                }
                catch(Throwable v1_1) {
                    goto label_516;
                }
            }
        }
        catch(CertPathReviewerException v1) {
        label_519:
            goto label_184;
        }

    label_192:
        this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.unknown", new Object[]{new UntrustedInput(v1_1.getMessage()), new UntrustedInput(v1_1)}));
        v11 = v3_1;
        goto label_56;
    label_55:
        Object v11_1 = v2_1;
    label_56:
        if((((X509Certificate)v11_1)) != null) {
            X509Certificate v2_2 = ((TrustAnchor)v11_1).getTrustedCert();
            if(v2_2 != null) {
                try {
                    v1_6 = PKIXCertPathReviewer.getSubjectPrincipal(v2_2);
                    goto label_60;
                label_211:
                    v1_6 = new X500Principal(((TrustAnchor)v11_1).getCAName());
                }
                catch(IllegalArgumentException v1_5) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.trustDNInvalid", new Object[]{new UntrustedInput(((TrustAnchor)v11_1).getCAName())}));
                    v3_3 = v4;
                    goto label_61;
                }
            }
            else {
                goto label_211;
            }

        label_60:
            v3_3 = v1_6;
        label_61:
            if(v2_2 == null) {
                goto label_73;
            }

            v1_7 = v2_2.getKeyUsage();
            if(v1_7 == null) {
                goto label_73;
            }

            if(v1_7[5]) {
                goto label_73;
            }

            this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.trustKeyUsage"));
        }
        else {
            v3_3 = v4;
        }

    label_73:
        PublicKey v2_3 = null;
        X509Certificate v1_8 = null;
        if((((X509Certificate)v11_1)) != null) {
            v1_8 = ((TrustAnchor)v11_1).getTrustedCert();
            v2_3 = v1_8 != null ? v1_8.getPublicKey() : ((TrustAnchor)v11_1).getCAPublicKey();
            try {
                v4_2 = PKIXCertPathReviewer.getAlgorithmIdentifier(v2_3);
                v4_2.getObjectId();
                v4_2.getParameters();
            }
            catch(CertPathValidatorException v4_1) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.trustPubKeyError"));
            }
        }

        int v9 = this.certs.size() - 1;
        X509Certificate v5 = v1_8;
        X500Principal v10 = v3_3;
        PublicKey v6;
        for(v6 = v2_3; v9 >= 0; v6 = v1_18) {
            int v12 = this.n - v9;
            v3 = this.certs.get(v9);
            if(v6 != null) {
                try {
                    CertPathValidatorUtilities.verifyX509Certificate(((X509Certificate)v3), v6, this.pkixParams.getSigProvider());
                }
                catch(GeneralSecurityException v1_9) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.signatureNotVerified", new Object[]{v1_9.getMessage(), v1_9, v1_9.getClass().getName()}), v9);
                }

                goto label_101;
            }

            if(PKIXCertPathReviewer.isSelfIssued(((X509Certificate)v3))) {
                try {
                    CertPathValidatorUtilities.verifyX509Certificate(((X509Certificate)v3), ((X509Certificate)v3).getPublicKey(), this.pkixParams.getSigProvider());
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.rootKeyIsValidButNotATrustAnchor"), v9);
                }
                catch(GeneralSecurityException v1_9) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.signatureNotVerified", new Object[]{v1_9.getMessage(), v1_9, v1_9.getClass().getName()}), v9);
                }

                goto label_101;
            }

            ErrorBundle v1_10 = new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.NoIssuerPublicKey");
            byte[] v2_4 = ((X509Certificate)v3).getExtensionValue(X509Extensions.AuthorityKeyIdentifier.getId());
            if(v2_4 != null) {
                try {
                    AuthorityKeyIdentifier v2_6 = AuthorityKeyIdentifier.getInstance(X509ExtensionUtil.fromExtensionValue(v2_4));
                    GeneralNames v4_3 = v2_6.getAuthorityCertIssuer();
                    if(v4_3 == null) {
                        goto label_338;
                    }

                    GeneralName v4_4 = v4_3.getNames()[0];
                    BigInteger v2_7 = v2_6.getAuthorityCertSerialNumber();
                    if(v2_7 == null) {
                        goto label_338;
                    }

                    v1_10.setExtraArguments(new Object[]{new LocaleString("org.bouncycastle.x509.CertPathReviewerMessages", "missingIssuer"), " \"", v4_4, "\" ", new LocaleString("org.bouncycastle.x509.CertPathReviewerMessages", "missingSerial"), " ", v2_7});
                }
                catch(IOException v2_5) {
                }
            }

        label_338:
            this.addError(v1_10, v9);
            try {
            label_101:
                ((X509Certificate)v3).checkValidity(this.validDate);
            }
            catch(CertificateExpiredException v1_11) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.certificateExpired", new Object[]{new TrustedInput(((X509Certificate)v3).getNotAfter())}), v9);
            }
            catch(CertificateNotYetValidException v1_12) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.certificateNotYetValid", new Object[]{new TrustedInput(((X509Certificate)v3).getNotBefore())}), v9);
            }

            if(this.pkixParams.isRevocationEnabled()) {
                CRLDistPoint v1_13 = null;
                try {
                    ASN1Primitive v2_9 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v3), PKIXCertPathReviewer.CRL_DIST_POINTS);
                    if(v2_9 == null) {
                        goto label_113;
                    }

                    v1_13 = CRLDistPoint.getInstance(v2_9);
                }
                catch(AnnotatedException v2_8) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlDistPtExtError"), v9);
                }

            label_113:
                AuthorityInformationAccess v2_10 = null;
                try {
                    ASN1Primitive v4_6 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)v3), PKIXCertPathReviewer.AUTH_INFO_ACCESS);
                    if(v4_6 == null) {
                        goto label_118;
                    }

                    v2_10 = AuthorityInformationAccess.getInstance(v4_6);
                }
                catch(AnnotatedException v4_5) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlAuthInfoAccError"), v9);
                }

            label_118:
                Vector v7 = this.getCRLDistUrls(v1_13);
                Vector v8 = this.getOCSPUrls(v2_10);
                Iterator v1_14 = v7.iterator();
                while(v1_14.hasNext()) {
                    this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.crlDistPoint", new Object[]{new UntrustedUrlInput(v1_14.next())}), v9);
                }

                v1_14 = v8.iterator();
                while(v1_14.hasNext()) {
                    this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.ocspLocation", new Object[]{new UntrustedUrlInput(v1_14.next())}), v9);
                }

                try {
                    this.checkRevocation(this.pkixParams, ((X509Certificate)v3), this.validDate, v5, v6, v7, v8, v9);
                }
                catch(CertPathReviewerException v1) {
                    this.addError(v1.getErrorMessage(), v9);
                }
            }

            if(v10 != null && !((X509Certificate)v3).getIssuerX500Principal().equals(v10)) {
                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.certWrongIssuer", new Object[]{v10.getName(), ((X509Certificate)v3).getIssuerX500Principal().getName()}), v9);
            }

            if(v12 != this.n) {
                if(v3 != null && ((X509Certificate)v3).getVersion() == 1) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noCACert"), v9);
                }

                try {
                    BasicConstraints v1_16 = BasicConstraints.getInstance(PKIXCertPathReviewer.getExtensionValue(((X509Extension)v3), PKIXCertPathReviewer.BASIC_CONSTRAINTS));
                    if(v1_16 != null) {
                        if(v1_16.isCA()) {
                            goto label_454;
                        }

                        this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noCACert"), v9);
                        goto label_454;
                    }

                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noBasicConstraints"), v9);
                }
                catch(AnnotatedException v1_15) {
                    this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.errorProcesingBC"), v9);
                }

            label_454:
                v1_7 = ((X509Certificate)v3).getKeyUsage();
                if(v1_7 == null) {
                    goto label_465;
                }

                if(v1_7[5]) {
                    goto label_465;
                }

                this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.noCertSign"), v9);
            }

        label_465:
            X500Principal v2_11 = ((X509Certificate)v3).getSubjectX500Principal();
            try {
                v1_18 = PKIXCertPathReviewer.getNextWorkingKey(this.certs, v9);
            }
            catch(CertPathValidatorException v1_17) {
                v1_18 = v6;
                goto label_499;
            }

            try {
                v4_2 = PKIXCertPathReviewer.getAlgorithmIdentifier(v1_18);
                v4_2.getObjectId();
                v4_2.getParameters();
                goto label_472;
            }
            catch(CertPathValidatorException v4_1) {
            }

        label_499:
            this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.pubKeyError"), v9);
        label_472:
            --v9;
            Object v5_1 = v3;
            v10 = v2_11;
        }

        this.trustAnchor = ((TrustAnchor)v11_1);
        this.subjectPublicKey = v6;
    }

    protected void doChecks() {
        if(!this.initialized) {
            throw new IllegalStateException("Object not initialized. Call init() first.");
        }

        if(this.notifications == null) {
            this.notifications = new List[this.n + 1];
            this.errors = new List[this.n + 1];
            int v0;
            for(v0 = 0; v0 < this.notifications.length; ++v0) {
                this.notifications[v0] = new ArrayList();
                this.errors[v0] = new ArrayList();
            }

            this.checkSignatures();
            this.checkNameConstraints();
            this.checkPathLength();
            this.checkPolicy();
            this.checkCriticalExtensions();
        }
    }

    private X509CRL getCRL(String arg9) {
        CRL v0_3;
        URLConnection v0_2;
        X509CRL v0 = null;
        try {
            URL v1 = new URL(arg9);
            if((v1.getProtocol().equals("http")) || (v1.getProtocol().equals("https"))) {
                v0_2 = v1.openConnection();
                ((HttpURLConnection)v0_2).setUseCaches(false);
                ((HttpURLConnection)v0_2).setDoInput(true);
                ((HttpURLConnection)v0_2).connect();
                if(((HttpURLConnection)v0_2).getResponseCode() == 200) {
                    v0_3 = CertificateFactory.getInstance("X.509", "BC").generateCRL(((HttpURLConnection)v0_2).getInputStream());
                }
                else {
                    goto label_28;
                }
            }

            return ((X509CRL)v0_3);
        label_28:
            throw new Exception(((HttpURLConnection)v0_2).getResponseMessage());
        }
        catch(Exception v0_1) {
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.loadCrlDistPointError", new Object[]{new UntrustedInput(arg9), v0_1.getMessage(), v0_1, v0_1.getClass().getName()}));
        }
    }

    protected Vector getCRLDistUrls(CRLDistPoint arg9) {
        Vector v4 = new Vector();
        if(arg9 != null) {
            DistributionPoint[] v5 = arg9.getDistributionPoints();
            int v1;
            for(v1 = 0; v1 < v5.length; ++v1) {
                DistributionPointName v0 = v5[v1].getDistributionPoint();
                if(v0.getType() == 0) {
                    GeneralName[] v6 = GeneralNames.getInstance(v0.getName()).getNames();
                    int v3;
                    for(v3 = 0; v3 < v6.length; ++v3) {
                        if(v6[v3].getTagNo() == 6) {
                            v4.add(v6[v3].getName().getString());
                        }
                    }
                }
            }
        }

        return v4;
    }

    public CertPath getCertPath() {
        return this.certPath;
    }

    public int getCertPathSize() {
        return this.n;
    }

    public List getErrors(int arg3) {
        this.doChecks();
        return this.errors[arg3 + 1];
    }

    public List[] getErrors() {
        this.doChecks();
        return this.errors;
    }

    public List getNotifications(int arg3) {
        this.doChecks();
        return this.notifications[arg3 + 1];
    }

    public List[] getNotifications() {
        this.doChecks();
        return this.notifications;
    }

    protected Vector getOCSPUrls(AuthorityInformationAccess arg7) {
        Vector v2 = new Vector();
        if(arg7 != null) {
            AccessDescription[] v3 = arg7.getAccessDescriptions();
            int v1;
            for(v1 = 0; v1 < v3.length; ++v1) {
                if(v3[v1].getAccessMethod().equals(AccessDescription.id_ad_ocsp)) {
                    GeneralName v0 = v3[v1].getAccessLocation();
                    if(v0.getTagNo() == 6) {
                        v2.add(v0.getName().getString());
                    }
                }
            }
        }

        return v2;
    }

    public PolicyNode getPolicyTree() {
        this.doChecks();
        return this.policyTree;
    }

    public PublicKey getSubjectPublicKey() {
        this.doChecks();
        return this.subjectPublicKey;
    }

    public TrustAnchor getTrustAnchor() {
        this.doChecks();
        return this.trustAnchor;
    }

    protected Collection getTrustAnchors(X509Certificate arg8, Set arg9) {
        ArrayList v1 = new ArrayList();
        Iterator v2 = arg9.iterator();
        X509CertSelector v3 = new X509CertSelector();
        try {
            v3.setSubject(PKIXCertPathReviewer.getEncodedIssuerPrincipal(arg8).getEncoded());
            byte[] v0_1 = arg8.getExtensionValue(X509Extensions.AuthorityKeyIdentifier.getId());
            if(v0_1 != null) {
                AuthorityKeyIdentifier v0_2 = AuthorityKeyIdentifier.getInstance(ASN1Primitive.fromByteArray(ASN1Primitive.fromByteArray(v0_1).getOctets()));
                v3.setSerialNumber(v0_2.getAuthorityCertSerialNumber());
                v0_1 = v0_2.getKeyIdentifier();
                if(v0_1 != null) {
                    v3.setSubjectKeyIdentifier(new DEROctetString(v0_1).getEncoded());
                }
            }
        }
        catch(IOException v0) {
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.trustAnchorIssuerError"));
        }

        while(v2.hasNext()) {
            Object v0_3 = v2.next();
            if(((TrustAnchor)v0_3).getTrustedCert() != null) {
                if(!v3.match(((TrustAnchor)v0_3).getTrustedCert())) {
                    continue;
                }

                ((Collection)v1).add(v0_3);
                continue;
            }

            if(((TrustAnchor)v0_3).getCAName() == null) {
                continue;
            }

            if(((TrustAnchor)v0_3).getCAPublicKey() == null) {
                continue;
            }

            if(!PKIXCertPathReviewer.getEncodedIssuerPrincipal(arg8).equals(new X500Principal(((TrustAnchor)v0_3).getCAName()))) {
                continue;
            }

            ((Collection)v1).add(v0_3);
        }

        return ((Collection)v1);
    }

    public void init(CertPath arg5, PKIXParameters arg6) {
        List[] v1 = null;
        if(this.initialized) {
            throw new IllegalStateException("object is already initialized!");
        }

        this.initialized = true;
        if(arg5 == null) {
            throw new NullPointerException("certPath was null");
        }

        this.certPath = arg5;
        this.certs = arg5.getCertificates();
        this.n = this.certs.size();
        if(this.certs.isEmpty()) {
            throw new CertPathReviewerException(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.emptyCertPath"));
        }

        this.pkixParams = arg6.clone();
        this.validDate = PKIXCertPathReviewer.getValidDate(this.pkixParams);
        this.notifications = v1;
        this.errors = v1;
        this.trustAnchor = ((TrustAnchor)v1);
        this.subjectPublicKey = ((PublicKey)v1);
        this.policyTree = ((PolicyNode)v1);
    }

    public boolean isValidCertPath() {
        boolean v1 = false;
        this.doChecks();
        int v0 = 0;
        while(true) {
            if(v0 >= this.errors.length) {
                return true;
            }
            else if(this.errors[v0].isEmpty()) {
                ++v0;
                continue;
            }

            return v1;
        }

        return true;
    }

    private boolean processQcStatements(X509Certificate arg14, int arg15) {
        boolean v0_2;
        try {
            ASN1Primitive v0_1 = PKIXCertPathReviewer.getExtensionValue(((X509Extension)arg14), PKIXCertPathReviewer.QC_STATEMENT);
            int v3 = 0;
            int v1 = 0;
            while(v3 < ((ASN1Sequence)v0_1).size()) {
                QCStatement v2 = QCStatement.getInstance(((ASN1Sequence)v0_1).getObjectAt(v3));
                if(QCStatement.id_etsi_qcs_QcCompliance.equals(v2.getStatementId())) {
                    this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.QcEuCompliance"), arg15);
                }
                else if(!QCStatement.id_qcs_pkixQCSyntax_v1.equals(v2.getStatementId())) {
                    if(QCStatement.id_etsi_qcs_QcSSCD.equals(v2.getStatementId())) {
                        this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.QcSSCD"), arg15);
                    }
                    else if(QCStatement.id_etsi_qcs_LimiteValue.equals(v2.getStatementId())) {
                        MonetaryValue v4 = MonetaryValue.getInstance(v2.getStatementInfo());
                        v4.getCurrency();
                        double v5 = v4.getAmount().doubleValue() * Math.pow(10, v4.getExponent().doubleValue());
                        ErrorBundle v2_1 = v4.getCurrency().isAlphabetic() ? new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.QcLimitValueAlpha", new Object[]{v4.getCurrency().getAlphabetic(), new TrustedInput(new Double(v5)), v4}) : new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.QcLimitValueNum", new Object[]{Integers.valueOf(v4.getCurrency().getNumeric()), new TrustedInput(new Double(v5)), v4});
                        this.addNotification(v2_1, arg15);
                    }
                    else {
                        this.addNotification(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.QcUnknownStatement", new Object[]{v2.getStatementId(), new UntrustedInput(v2)}), arg15);
                        v1 = 1;
                    }
                }

                ++v3;
            }
        }
        catch(AnnotatedException v0) {
            goto label_41;
        }

        if(v1 == 0) {
            v0_2 = true;
        }
        else {
            return false;
        label_41:
            this.addError(new ErrorBundle("org.bouncycastle.x509.CertPathReviewerMessages", "CertPathReviewer.QcStatementExtError"), arg15);
            v0_2 = false;
        }

        return v0_2;
    }
}

