// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.io.IOException;
import java.math.BigInteger;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.Target;
import org.bouncycastle.asn1.x509.TargetInformation;
import org.bouncycastle.asn1.x509.Targets;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.util.Selector;

public class X509AttributeCertStoreSelector implements Selector {
    private X509AttributeCertificate attributeCert;
    private Date attributeCertificateValid;
    private AttributeCertificateHolder holder;
    private AttributeCertificateIssuer issuer;
    private BigInteger serialNumber;
    private Collection targetGroups;
    private Collection targetNames;

    public X509AttributeCertStoreSelector() {
        super();
        this.targetNames = new HashSet();
        this.targetGroups = new HashSet();
    }

    public void addTargetGroup(GeneralName arg2) {
        this.targetGroups.add(arg2);
    }

    public void addTargetGroup(byte[] arg2) {
        this.addTargetGroup(GeneralName.getInstance(ASN1Primitive.fromByteArray(arg2)));
    }

    public void addTargetName(GeneralName arg2) {
        this.targetNames.add(arg2);
    }

    public void addTargetName(byte[] arg2) {
        this.addTargetName(GeneralName.getInstance(ASN1Primitive.fromByteArray(arg2)));
    }

    public Object clone() {
        X509AttributeCertStoreSelector v0 = new X509AttributeCertStoreSelector();
        v0.attributeCert = this.attributeCert;
        v0.attributeCertificateValid = this.getAttributeCertificateValid();
        v0.holder = this.holder;
        v0.issuer = this.issuer;
        v0.serialNumber = this.serialNumber;
        v0.targetGroups = this.getTargetGroups();
        v0.targetNames = this.getTargetNames();
        return v0;
    }

    private Set extractGeneralNames(Collection arg5) {
        HashSet v0_1;
        if(arg5 == null || (arg5.isEmpty())) {
            v0_1 = new HashSet();
        }
        else {
            HashSet v1 = new HashSet();
            Iterator v2 = arg5.iterator();
            while(v2.hasNext()) {
                Object v0 = v2.next();
                if((v0 instanceof GeneralName)) {
                    ((Set)v1).add(v0);
                }
                else {
                    ((Set)v1).add(GeneralName.getInstance(ASN1Primitive.fromByteArray(((byte[])v0))));
                }
            }

            v0_1 = v1;
        }

        return ((Set)v0_1);
    }

    public X509AttributeCertificate getAttributeCert() {
        return this.attributeCert;
    }

    public Date getAttributeCertificateValid() {
        Date v0 = this.attributeCertificateValid != null ? new Date(this.attributeCertificateValid.getTime()) : null;
        return v0;
    }

    public AttributeCertificateHolder getHolder() {
        return this.holder;
    }

    public AttributeCertificateIssuer getIssuer() {
        return this.issuer;
    }

    public BigInteger getSerialNumber() {
        return this.serialNumber;
    }

    public Collection getTargetGroups() {
        return Collections.unmodifiableCollection(this.targetGroups);
    }

    public Collection getTargetNames() {
        return Collections.unmodifiableCollection(this.targetNames);
    }

    public boolean match(Object arg10) {
        int v3;
        Target[] v6;
        int v2;
        int v0_6;
        TargetInformation v0_5;
        boolean v1 = false;
        if(((arg10 instanceof X509AttributeCertificate)) && (this.attributeCert == null || (this.attributeCert.equals(arg10))) && (this.serialNumber == null || (((X509AttributeCertificate)arg10).getSerialNumber().equals(this.serialNumber))) && (this.holder == null || (((X509AttributeCertificate)arg10).getHolder().equals(this.holder))) && (this.issuer == null || (((X509AttributeCertificate)arg10).getIssuer().equals(this.issuer)))) {
            if(this.attributeCertificateValid != null) {
                try {
                    ((X509AttributeCertificate)arg10).checkValidity(this.attributeCertificateValid);
                }
                catch(CertificateNotYetValidException v0) {
                    return v1;
                }
                catch(CertificateExpiredException v0_1) {
                    return v1;
                }
            }

            if(!this.targetNames.isEmpty() || !this.targetGroups.isEmpty()) {
                byte[] v0_2 = ((X509AttributeCertificate)arg10).getExtensionValue(X509Extensions.TargetInformation.getId());
                if(v0_2 != null) {
                    try {
                        v0_5 = TargetInformation.getInstance(new ASN1InputStream(DEROctetString.fromByteArray(v0_2).getOctets()).readObject());
                    }
                    catch(IllegalArgumentException v0_3) {
                        return v1;
                    }
                    catch(IOException v0_4) {
                        return v1;
                    }

                    Targets[] v5 = v0_5.getTargetsObjects();
                    if(!this.targetNames.isEmpty()) {
                        v0_6 = 0;
                        v2 = 0;
                        while(v0_6 < v5.length) {
                            v6 = v5[v0_6].getTargets();
                            v3 = 0;
                            while(v3 < v6.length) {
                                if(this.targetNames.contains(GeneralName.getInstance(v6[v3].getTargetName()))) {
                                    v2 = 1;
                                }
                                else {
                                    ++v3;
                                    continue;
                                }

                                break;
                            }

                            ++v0_6;
                        }

                        if(v2 == 0) {
                            return v1;
                        }
                    }

                    if(this.targetGroups.isEmpty()) {
                        goto label_97;
                    }

                    v0_6 = 0;
                    v2 = 0;
                    while(v0_6 < v5.length) {
                        v6 = v5[v0_6].getTargets();
                        v3 = 0;
                        while(v3 < v6.length) {
                            if(this.targetGroups.contains(GeneralName.getInstance(v6[v3].getTargetGroup()))) {
                                v2 = 1;
                            }
                            else {
                                ++v3;
                                continue;
                            }

                            break;
                        }

                        ++v0_6;
                    }

                    if(v2 == 0) {
                        return v1;
                    }
                }
            }

        label_97:
            v1 = true;
        }

        return v1;
    }

    public void setAttributeCert(X509AttributeCertificate arg1) {
        this.attributeCert = arg1;
    }

    public void setAttributeCertificateValid(Date arg4) {
        this.attributeCertificateValid = arg4 != null ? new Date(arg4.getTime()) : null;
    }

    public void setHolder(AttributeCertificateHolder arg1) {
        this.holder = arg1;
    }

    public void setIssuer(AttributeCertificateIssuer arg1) {
        this.issuer = arg1;
    }

    public void setSerialNumber(BigInteger arg1) {
        this.serialNumber = arg1;
    }

    public void setTargetGroups(Collection arg2) {
        this.targetGroups = this.extractGeneralNames(arg2);
    }

    public void setTargetNames(Collection arg2) {
        this.targetNames = this.extractGeneralNames(arg2);
    }
}

