// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509;

import java.io.IOException;
import java.security.cert.CertificateEncodingException;
import java.security.cert.X509Certificate;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.x509.Certificate;
import org.bouncycastle.asn1.x509.CertificatePair;
import org.bouncycastle.jce.provider.X509CertificateObject;

public class X509CertificatePair {
    private X509Certificate forward;
    private X509Certificate reverse;

    public X509CertificatePair(CertificatePair arg3) {
        super();
        if(arg3.getForward() != null) {
            this.forward = new X509CertificateObject(arg3.getForward());
        }

        if(arg3.getReverse() != null) {
            this.reverse = new X509CertificateObject(arg3.getReverse());
        }
    }

    public X509CertificatePair(X509Certificate arg1, X509Certificate arg2) {
        super();
        this.forward = arg1;
        this.reverse = arg2;
    }

    public boolean equals(Object arg6) {
        boolean v3;
        boolean v0;
        boolean v2 = true;
        boolean v1 = false;
        if(arg6 != null && ((arg6 instanceof X509CertificatePair))) {
            if(this.forward != null) {
                v0 = this.forward.equals(((X509CertificatePair)arg6).forward);
            }
            else if(((X509CertificatePair)arg6).forward != null) {
                v0 = false;
            }
            else {
                v0 = true;
            }

            if(this.reverse != null) {
                v3 = this.reverse.equals(((X509CertificatePair)arg6).reverse);
            }
            else if(((X509CertificatePair)arg6).reverse != null) {
                v3 = false;
            }
            else {
                v3 = true;
            }

            if(!v0 || !v3) {
                v2 = false;
            }

            v1 = v2;
        }

        return v1;
    }

    public byte[] getEncoded() {
        Certificate v1;
        Certificate v0 = null;
        try {
            if(this.forward != null) {
                v1 = Certificate.getInstance(new ASN1InputStream(this.forward.getEncoded()).readObject());
                if(v1 == null) {
                    throw new CertificateEncodingException("unable to get encoding for forward");
                }
            }
            else {
                goto label_19;
            }

            goto label_20;
        }
        catch(IOException v0_1) {
            goto label_37;
        }
        catch(IllegalArgumentException v0_2) {
            goto label_18;
        }

    label_19:
        v1 = v0;
        try {
        label_20:
            if(this.reverse != null) {
                v0 = Certificate.getInstance(new ASN1InputStream(this.reverse.getEncoded()).readObject());
                if(v0 == null) {
                    throw new CertificateEncodingException("unable to get encoding for reverse");
                }
            }

            return new CertificatePair(v1, v0).getEncoded("DER");
        }
        catch(IOException v0_1) {
        label_37:
            throw new ExtCertificateEncodingException(v0_1.toString(), ((Throwable)v0_1));
        }
        catch(IllegalArgumentException v0_2) {
        label_18:
            throw new ExtCertificateEncodingException(v0_2.toString(), ((Throwable)v0_2));
        }
    }

    public X509Certificate getForward() {
        return this.forward;
    }

    public X509Certificate getReverse() {
        return this.reverse;
    }

    public int hashCode() {
        int v0 = -1;
        if(this.forward != null) {
            v0 ^= this.forward.hashCode();
        }

        if(this.reverse != null) {
            v0 = v0 * 17 ^ this.reverse.hashCode();
        }

        return v0;
    }
}

