// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509.extension;

import java.security.InvalidKeyException;
import java.security.PublicKey;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.x509.AuthorityKeyIdentifier;
import org.bouncycastle.asn1.x509.Extension;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.SubjectPublicKeyInfo;
import org.bouncycastle.asn1.x509.X509Extension;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.jce.PrincipalUtil;

public class AuthorityKeyIdentifierStructure extends AuthorityKeyIdentifier {
    public AuthorityKeyIdentifierStructure(PublicKey arg2) {
        super(AuthorityKeyIdentifierStructure.fromKey(arg2));
    }

    public AuthorityKeyIdentifierStructure(X509Certificate arg2) {
        super(AuthorityKeyIdentifierStructure.fromCertificate(arg2));
    }

    public AuthorityKeyIdentifierStructure(Extension arg2) {
        super(arg2.getParsedValue());
    }

    public AuthorityKeyIdentifierStructure(X509Extension arg2) {
        super(arg2.getParsedValue());
    }

    public AuthorityKeyIdentifierStructure(byte[] arg2) {
        super(X509ExtensionUtil.fromExtensionValue(arg2));
    }

    private static ASN1Sequence fromCertificate(X509Certificate arg4) {
        ASN1Primitive v0_1;
        try {
            if(arg4.getVersion() != 3) {
                v0_1 = new AuthorityKeyIdentifier(new SubjectPublicKeyInfo(new ASN1InputStream(arg4.getPublicKey().getEncoded()).readObject()), new GeneralNames(new GeneralName(PrincipalUtil.getIssuerX509Principal(arg4))), arg4.getSerialNumber()).toASN1Object();
            }
            else {
                GeneralName v1 = new GeneralName(PrincipalUtil.getIssuerX509Principal(arg4));
                byte[] v0_2 = arg4.getExtensionValue(X509Extensions.SubjectKeyIdentifier.getId());
                v0_1 = v0_2 != null ? new AuthorityKeyIdentifier(X509ExtensionUtil.fromExtensionValue(v0_2).getOctets(), new GeneralNames(v1), arg4.getSerialNumber()).toASN1Object() : new AuthorityKeyIdentifier(new SubjectPublicKeyInfo(new ASN1InputStream(arg4.getPublicKey().getEncoded()).readObject()), new GeneralNames(v1), arg4.getSerialNumber()).toASN1Object();
            }

            return ((ASN1Sequence)v0_1);
        }
        catch(Exception v0) {
            throw new CertificateParsingException("Exception extracting certificate details: " + v0.toString());
        }
    }

    private static ASN1Sequence fromKey(PublicKey arg4) {
        try {
            return new AuthorityKeyIdentifier(new SubjectPublicKeyInfo(new ASN1InputStream(arg4.getEncoded()).readObject())).toASN1Object();
        }
        catch(Exception v0) {
            throw new InvalidKeyException("can\'t process key: " + v0);
        }
    }
}

