// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509.extension;

import java.io.IOException;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1Primitive;
import org.bouncycastle.asn1.DEROctetString;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.X509Extension;
import org.bouncycastle.util.Integers;

public class X509ExtensionUtil {
    public X509ExtensionUtil() {
        super();
    }

    public static ASN1Primitive fromExtensionValue(byte[] arg1) {
        return ASN1Primitive.fromByteArray(ASN1Primitive.fromByteArray(arg1).getOctets());
    }

    private static Collection getAlternativeNames(byte[] arg5) {
        Collection v0_3;
        if(arg5 == null) {
            List v0 = Collections.EMPTY_LIST;
        }
        else {
            try {
                ArrayList v1 = new ArrayList();
                Enumeration v2 = DERSequence.getInstance(X509ExtensionUtil.fromExtensionValue(arg5)).getObjects();
                while(v2.hasMoreElements()) {
                    GeneralName v0_2 = GeneralName.getInstance(v2.nextElement());
                    ArrayList v3 = new ArrayList();
                    ((List)v3).add(Integers.valueOf(v0_2.getTagNo()));
                    switch(v0_2.getTagNo()) {
                        case 4: {
                            goto label_39;
                        }
                        case 0: 
                        case 3: 
                        case 5: {
                            goto label_34;
                        }
                        case 1: 
                        case 2: 
                        case 6: {
                            goto label_44;
                        }
                        case 7: {
                            goto label_53;
                        }
                        case 8: {
                            goto label_48;
                        }
                    }

                    throw new IOException("Bad tag number: " + v0_2.getTagNo());
                label_53:
                    ((List)v3).add(DEROctetString.getInstance(v0_2.getName()).getOctets());
                    goto label_37;
                label_39:
                    ((List)v3).add(X500Name.getInstance(v0_2.getName()).toString());
                    goto label_37;
                label_34:
                    ((List)v3).add(v0_2.getName().toASN1Primitive());
                    goto label_37;
                label_48:
                    ((List)v3).add(ASN1ObjectIdentifier.getInstance(v0_2.getName()).getId());
                    goto label_37;
                label_44:
                    ((List)v3).add(v0_2.getName().getString());
                label_37:
                    ((Collection)v1).add(v3);
                }

                v0_3 = Collections.unmodifiableCollection(((Collection)v1));
            }
            catch(Exception v0_1) {
                goto label_33;
            }
        }

        return v0_3;
    label_33:
        throw new CertificateParsingException(v0_1.getMessage());
    }

    public static Collection getIssuerAlternativeNames(X509Certificate arg1) {
        return X509ExtensionUtil.getAlternativeNames(arg1.getExtensionValue(X509Extension.issuerAlternativeName.getId()));
    }

    public static Collection getSubjectAlternativeNames(X509Certificate arg1) {
        return X509ExtensionUtil.getAlternativeNames(arg1.getExtensionValue(X509Extension.subjectAlternativeName.getId()));
    }
}

