// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.bouncycastle.x509.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.security.Principal;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.sql.Date;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map$Entry;
import java.util.Properties;
import java.util.Set;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.security.auth.x500.X500Principal;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.x509.Certificate;
import org.bouncycastle.asn1.x509.CertificatePair;
import org.bouncycastle.jce.X509LDAPCertStoreParameters;
import org.bouncycastle.jce.provider.X509AttrCertParser;
import org.bouncycastle.jce.provider.X509CRLParser;
import org.bouncycastle.jce.provider.X509CertPairParser;
import org.bouncycastle.jce.provider.X509CertParser;
import org.bouncycastle.util.StoreException;
import org.bouncycastle.x509.X509AttributeCertStoreSelector;
import org.bouncycastle.x509.X509CRLStoreSelector;
import org.bouncycastle.x509.X509CertPairStoreSelector;
import org.bouncycastle.x509.X509CertStoreSelector;
import org.bouncycastle.x509.X509CertificatePair;

public class LDAPStoreHelper {
    private static String LDAP_PROVIDER = null;
    private static String REFERRALS_IGNORE = null;
    private static final String SEARCH_SECURITY_LEVEL = "none";
    private static final String URL_CONTEXT_PREFIX = "com.sun.jndi.url";
    private Map cacheMap;
    private static int cacheSize;
    private static long lifeTime;
    private X509LDAPCertStoreParameters params;

    static {
        LDAPStoreHelper.LDAP_PROVIDER = "com.sun.jndi.ldap.LdapCtxFactory";
        LDAPStoreHelper.REFERRALS_IGNORE = "ignore";
        LDAPStoreHelper.cacheSize = 32;
        LDAPStoreHelper.lifeTime = 60000;
    }

    public LDAPStoreHelper(X509LDAPCertStoreParameters arg3) {
        super();
        this.cacheMap = new HashMap(LDAPStoreHelper.cacheSize);
        this.params = arg3;
    }

    private void addToCache(String arg10, List arg11) {
        long v1;
        Object v0_2;
        Object v2;
        long v5;
        ArrayList v7;
        __monitor_enter(this);
        try {
            Date v0_1 = new Date(System.currentTimeMillis());
            v7 = new ArrayList();
            ((List)v7).add(v0_1);
            ((List)v7).add(arg11);
            if(this.cacheMap.containsKey(arg10)) {
                this.cacheMap.put(arg10, v7);
            }
            else {
                if(this.cacheMap.size() >= LDAPStoreHelper.cacheSize) {
                    Iterator v8 = this.cacheMap.entrySet().iterator();
                    v5 = v0_1.getTime();
                    v2 = null;
                    while(true) {
                    label_24:
                        if(v8.hasNext()) {
                            v0_2 = v8.next();
                            long v3 = ((Map$Entry)v0_2).getValue().get(0).getTime();
                            if(v3 < v5) {
                                v0_2 = ((Map$Entry)v0_2).getKey();
                                v1 = v3;
                            }
                            else {
                                goto label_45;
                            }

                            goto label_34;
                        }
                        else {
                            goto label_37;
                        }
                    }
                }

                goto label_39;
            }

            goto label_13;
        }
        catch(Throwable v0) {
            goto label_43;
        }

    label_45:
        v0_2 = v2;
        v1 = v5;
        try {
        label_34:
            v5 = v1;
            v2 = v0_2;
            goto label_24;
        label_37:
            this.cacheMap.remove(v2);
        label_39:
            this.cacheMap.put(arg10, v7);
        }
        catch(Throwable v0) {
        label_43:
            __monitor_exit(this);
            throw v0;
        }

    label_13:
        __monitor_exit(this);
    }

    private List attrCertSubjectSerialSearch(X509AttributeCertStoreSelector arg8, String[] arg9, String[] arg10, String[] arg11) {
        Principal[] v0;
        String v1 = null;
        ArrayList v3 = new ArrayList();
        HashSet v4 = new HashSet();
        if(arg8.getHolder() != null) {
            if(arg8.getHolder().getSerialNumber() != null) {
                ((Collection)v4).add(arg8.getHolder().getSerialNumber().toString());
            }

            if(arg8.getHolder().getEntityNames() == null) {
                goto label_88;
            }

            v0 = arg8.getHolder().getEntityNames();
        }
        else {
        label_88:
            v0 = ((Principal[])v1);
        }

        if(arg8.getAttributeCert() != null) {
            if(arg8.getAttributeCert().getHolder().getEntityNames() != null) {
                v0 = arg8.getAttributeCert().getHolder().getEntityNames();
            }

            ((Collection)v4).add(arg8.getAttributeCert().getSerialNumber().toString());
        }

        if(v0 != null) {
            v1 = (v0[0] instanceof X500Principal) ? v0[0].getName("RFC1779") : v0[0].getName();
        }

        if(arg8.getSerialNumber() != null) {
            ((Collection)v4).add(arg8.getSerialNumber().toString());
        }

        if(v1 != null) {
            int v0_1;
            for(v0_1 = 0; v0_1 < arg11.length; ++v0_1) {
                ((List)v3).addAll(this.search(arg10, "*" + this.parseDN(v1, arg11[v0_1]) + "*", arg9));
            }
        }

        if(((Collection)v4).size() > 0 && this.params.getSearchForSerialNumberIn() != null) {
            Iterator v2 = ((Collection)v4).iterator();
            while(v2.hasNext()) {
                ((List)v3).addAll(this.search(this.splitString(this.params.getSearchForSerialNumberIn()), v2.next(), arg9));
            }
        }

        if(((Collection)v4).size() == 0 && v1 == null) {
            ((List)v3).addAll(this.search(arg10, "*", arg9));
        }

        return ((List)v3);
    }

    private List cRLIssuerSearch(X509CRLStoreSelector arg9, String[] arg10, String[] arg11, String[] arg12) {
        ArrayList v3 = new ArrayList();
        String v2 = null;
        HashSet v4 = new HashSet();
        if(arg9.getIssuers() != null) {
            ((Collection)v4).addAll(arg9.getIssuers());
        }

        if(arg9.getCertificateChecking() != null) {
            ((Collection)v4).add(this.getCertificateIssuer(arg9.getCertificateChecking()));
        }

        if(arg9.getAttrCertificateChecking() != null) {
            Principal[] v5 = arg9.getAttrCertificateChecking().getIssuer().getPrincipals();
            int v0;
            for(v0 = 0; v0 < v5.length; ++v0) {
                if((v5[v0] instanceof X500Principal)) {
                    ((Collection)v4).add(v5[v0]);
                }
            }
        }

        Iterator v4_1 = ((Collection)v4).iterator();
        String v0_1;
        for(v0_1 = v2; v4_1.hasNext(); v0_1 = v2) {
            v2 = v4_1.next().getName("RFC1779");
            for(v0 = 0; v0 < arg12.length; ++v0) {
                ((List)v3).addAll(this.search(arg11, "*" + this.parseDN(v2, arg12[v0]) + "*", arg10));
            }
        }

        if(v0_1 == null) {
            ((List)v3).addAll(this.search(arg11, "*", arg10));
        }

        return ((List)v3);
    }

    private List certSubjectSerialSearch(X509CertStoreSelector arg8, String[] arg9, String[] arg10, String[] arg11) {
        String v2;
        ArrayList v3 = new ArrayList();
        String v0 = null;
        String v1 = this.getSubjectAsString(arg8);
        if(arg8.getSerialNumber() != null) {
            v0 = arg8.getSerialNumber().toString();
        }

        if(arg8.getCertificate() != null) {
            v2 = arg8.getCertificate().getSubjectX500Principal().getName("RFC1779");
            v1 = arg8.getCertificate().getSerialNumber().toString();
        }
        else {
            v2 = v1;
            v1 = v0;
        }

        if(v2 != null) {
            int v0_1;
            for(v0_1 = 0; v0_1 < arg11.length; ++v0_1) {
                ((List)v3).addAll(this.search(arg10, "*" + this.parseDN(v2, arg11[v0_1]) + "*", arg9));
            }
        }

        if(v1 != null && this.params.getSearchForSerialNumberIn() != null) {
            ((List)v3).addAll(this.search(this.splitString(this.params.getSearchForSerialNumberIn()), v1, arg9));
        }

        if(v1 == null && v2 == null) {
            ((List)v3).addAll(this.search(arg10, "*", arg9));
        }

        return ((List)v3);
    }

    private DirContext connectLDAP() {
        Properties v0 = new Properties();
        v0.setProperty("java.naming.factory.initial", LDAPStoreHelper.LDAP_PROVIDER);
        v0.setProperty("java.naming.batchsize", "0");
        v0.setProperty("java.naming.provider.url", this.params.getLdapURL());
        v0.setProperty("java.naming.factory.url.pkgs", "com.sun.jndi.url");
        v0.setProperty("java.naming.referral", LDAPStoreHelper.REFERRALS_IGNORE);
        v0.setProperty("java.naming.security.authentication", "none");
        return new InitialDirContext(((Hashtable)v0));
    }

    private Set createAttributeCertificates(List arg6, X509AttributeCertStoreSelector arg7) {
        HashSet v1 = new HashSet();
        Iterator v2 = arg6.iterator();
        X509AttrCertParser v3 = new X509AttrCertParser();
        while(v2.hasNext()) {
            try {
                v3.engineInit(new ByteArrayInputStream(v2.next()));
                Object v0_1 = v3.engineRead();
                if(!arg7.match(v0_1)) {
                    continue;
                }

                ((Set)v1).add(v0_1);
            }
            catch(StreamParsingException v0) {
            }
        }

        return ((Set)v1);
    }

    private Set createCRLs(List arg6, X509CRLStoreSelector arg7) {
        HashSet v1 = new HashSet();
        X509CRLParser v2 = new X509CRLParser();
        Iterator v3 = arg6.iterator();
        while(v3.hasNext()) {
            try {
                v2.engineInit(new ByteArrayInputStream(v3.next()));
                Object v0_1 = v2.engineRead();
                if(!arg7.match(v0_1)) {
                    continue;
                }

                ((Set)v1).add(v0_1);
            }
            catch(StreamParsingException v0) {
            }
        }

        return ((Set)v1);
    }

    private Set createCerts(List arg6, X509CertStoreSelector arg7) {
        HashSet v1 = new HashSet();
        Iterator v2 = arg6.iterator();
        X509CertParser v3 = new X509CertParser();
        while(v2.hasNext()) {
            try {
                v3.engineInit(new ByteArrayInputStream(v2.next()));
                Object v0_1 = v3.engineRead();
                if(!arg7.match(v0_1)) {
                    continue;
                }

                ((Set)v1).add(v0_1);
            }
            catch(Exception v0) {
            }
        }

        return ((Set)v1);
    }

    private Set createCrossCertificatePairs(List arg8, X509CertPairStoreSelector arg9) {
        int v0_3;
        Object v1_1;
        HashSet v4 = new HashSet();
        int v2;
        for(v2 = 0; v2 < arg8.size(); v2 = v0_3 + 1) {
            try {
                X509CertPairParser v1 = new X509CertPairParser();
                v1.engineInit(new ByteArrayInputStream(arg8.get(v2)));
                v1_1 = v1.engineRead();
                v0_3 = v2;
            }
            catch(IOException v0) {
            }
            catch(CertificateParsingException v0_1) {
            }
            catch(StreamParsingException v0_2) {
                try {
                    v0_3 = v2 + 1;
                    X509CertificatePair v1_2 = new X509CertificatePair(new CertificatePair(Certificate.getInstance(new ASN1InputStream(arg8.get(v2)).readObject()), Certificate.getInstance(new ASN1InputStream(arg8.get(v2 + 1)).readObject())));
                }
                catch(IOException v0) {
                    v0_3 = v2;
                    goto label_18;
                }
                catch(CertificateParsingException v0_1) {
                    v0_3 = v2;
                    goto label_18;
                }
            }

            try {
                if(!arg9.match(v1_1)) {
                    goto label_18;
                }

                ((Set)v4).add(v1_1);
            }
            catch(IOException v1_3) {
            }
            catch(CertificateParsingException v1_4) {
            }

        label_18:
        }

        return ((Set)v4);
    }

    private List crossCertificatePairSubjectSearch(X509CertPairStoreSelector arg7, String[] arg8, String[] arg9, String[] arg10) {
        ArrayList v2 = new ArrayList();
        String v0 = null;
        if(arg7.getForwardSelector() != null) {
            v0 = this.getSubjectAsString(arg7.getForwardSelector());
        }

        String v1 = arg7.getCertPair() == null || arg7.getCertPair().getForward() == null ? v0 : arg7.getCertPair().getForward().getSubjectX500Principal().getName("RFC1779");
        if(v1 != null) {
            int v0_1;
            for(v0_1 = 0; v0_1 < arg10.length; ++v0_1) {
                ((List)v2).addAll(this.search(arg9, "*" + this.parseDN(v1, arg10[v0_1]) + "*", arg8));
            }
        }

        if(v1 == null) {
            ((List)v2).addAll(this.search(arg9, "*", arg8));
        }

        return ((List)v2);
    }

    public Collection getAACertificates(X509AttributeCertStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getAACertificateAttribute());
        String[] v1 = this.splitString(this.params.getLdapAACertificateAttributeName());
        String[] v2 = this.splitString(this.params.getAACertificateSubjectAttributeName());
        Set v3 = this.createAttributeCertificates(this.attrCertSubjectSerialSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createAttributeCertificates(this.attrCertSubjectSerialSearch(new X509AttributeCertStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getAttributeAuthorityRevocationLists(X509CRLStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getAttributeAuthorityRevocationListAttribute());
        String[] v1 = this.splitString(this.params.getLdapAttributeAuthorityRevocationListAttributeName());
        String[] v2 = this.splitString(this.params.getAttributeAuthorityRevocationListIssuerAttributeName());
        Set v3 = this.createCRLs(this.cRLIssuerSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCRLs(this.cRLIssuerSearch(new X509CRLStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getAttributeCertificateAttributes(X509AttributeCertStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getAttributeCertificateAttributeAttribute());
        String[] v1 = this.splitString(this.params.getLdapAttributeCertificateAttributeAttributeName());
        String[] v2 = this.splitString(this.params.getAttributeCertificateAttributeSubjectAttributeName());
        Set v3 = this.createAttributeCertificates(this.attrCertSubjectSerialSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createAttributeCertificates(this.attrCertSubjectSerialSearch(new X509AttributeCertStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getAttributeCertificateRevocationLists(X509CRLStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getAttributeCertificateRevocationListAttribute());
        String[] v1 = this.splitString(this.params.getLdapAttributeCertificateRevocationListAttributeName());
        String[] v2 = this.splitString(this.params.getAttributeCertificateRevocationListIssuerAttributeName());
        Set v3 = this.createCRLs(this.cRLIssuerSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCRLs(this.cRLIssuerSearch(new X509CRLStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getAttributeDescriptorCertificates(X509AttributeCertStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getAttributeDescriptorCertificateAttribute());
        String[] v1 = this.splitString(this.params.getLdapAttributeDescriptorCertificateAttributeName());
        String[] v2 = this.splitString(this.params.getAttributeDescriptorCertificateSubjectAttributeName());
        Set v3 = this.createAttributeCertificates(this.attrCertSubjectSerialSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createAttributeCertificates(this.attrCertSubjectSerialSearch(new X509AttributeCertStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getAuthorityRevocationLists(X509CRLStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getAuthorityRevocationListAttribute());
        String[] v1 = this.splitString(this.params.getLdapAuthorityRevocationListAttributeName());
        String[] v2 = this.splitString(this.params.getAuthorityRevocationListIssuerAttributeName());
        Set v3 = this.createCRLs(this.cRLIssuerSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCRLs(this.cRLIssuerSearch(new X509CRLStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getCACertificates(X509CertStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getCACertificateAttribute());
        String[] v1 = this.splitString(this.params.getLdapCACertificateAttributeName());
        String[] v2 = this.splitString(this.params.getCACertificateSubjectAttributeName());
        Set v3 = this.createCerts(this.certSubjectSerialSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCerts(this.certSubjectSerialSearch(new X509CertStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    private X500Principal getCertificateIssuer(X509Certificate arg2) {
        return arg2.getIssuerX500Principal();
    }

    public Collection getCertificateRevocationLists(X509CRLStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getCertificateRevocationListAttribute());
        String[] v1 = this.splitString(this.params.getLdapCertificateRevocationListAttributeName());
        String[] v2 = this.splitString(this.params.getCertificateRevocationListIssuerAttributeName());
        Set v3 = this.createCRLs(this.cRLIssuerSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCRLs(this.cRLIssuerSearch(new X509CRLStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    public Collection getCrossCertificatePairs(X509CertPairStoreSelector arg7) {
        String[] v0 = this.splitString(this.params.getCrossCertificateAttribute());
        String[] v1 = this.splitString(this.params.getLdapCrossCertificateAttributeName());
        String[] v2 = this.splitString(this.params.getCrossCertificateSubjectAttributeName());
        Set v3 = this.createCrossCertificatePairs(this.crossCertificatePairSubjectSearch(arg7, v0, v1, v2), arg7);
        if(v3.size() == 0) {
            X509CertStoreSelector v4 = new X509CertStoreSelector();
            X509CertPairStoreSelector v5 = new X509CertPairStoreSelector();
            v5.setForwardSelector(v4);
            v5.setReverseSelector(v4);
            v3.addAll(this.createCrossCertificatePairs(this.crossCertificatePairSubjectSearch(v5, v0, v1, v2), arg7));
        }

        return ((Collection)v3);
    }

    public Collection getDeltaCertificateRevocationLists(X509CRLStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getDeltaRevocationListAttribute());
        String[] v1 = this.splitString(this.params.getLdapDeltaRevocationListAttributeName());
        String[] v2 = this.splitString(this.params.getDeltaRevocationListIssuerAttributeName());
        Set v3 = this.createCRLs(this.cRLIssuerSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCRLs(this.cRLIssuerSearch(new X509CRLStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    private List getFromCache(String arg10) {
        List v0_1;
        List v2 = null;
        Object v0 = this.cacheMap.get(arg10);
        long v3 = System.currentTimeMillis();
        if(v0 == null) {
            v0_1 = v2;
        }
        else if(((List)v0).get(0).getTime() < v3 - LDAPStoreHelper.lifeTime) {
            v0_1 = v2;
        }
        else {
            v0 = ((List)v0).get(1);
        }

        return v0_1;
    }

    private String getSubjectAsString(X509CertStoreSelector arg5) {
        String v0_2;
        try {
            byte[] v0_1 = arg5.getSubjectAsBytes();
            if(v0_1 != null) {
                v0_2 = new X500Principal(v0_1).getName("RFC1779");
            }
            else {
                return null;
            }

            return v0_2;
        }
        catch(IOException v0) {
            throw new StoreException("exception processing name: " + v0.getMessage(), ((Throwable)v0));
        }

        return null;
    }

    public Collection getUserCertificates(X509CertStoreSelector arg6) {
        String[] v0 = this.splitString(this.params.getUserCertificateAttribute());
        String[] v1 = this.splitString(this.params.getLdapUserCertificateAttributeName());
        String[] v2 = this.splitString(this.params.getUserCertificateSubjectAttributeName());
        Set v3 = this.createCerts(this.certSubjectSerialSearch(arg6, v0, v1, v2), arg6);
        if(v3.size() == 0) {
            v3.addAll(this.createCerts(this.certSubjectSerialSearch(new X509CertStoreSelector(), v0, v1, v2), arg6));
        }

        return ((Collection)v3);
    }

    private String parseDN(String arg9, String arg10) {
        String v0_1;
        int v7 = 44;
        int v4 = -1;
        int v0 = arg9.toLowerCase().indexOf(arg10.toLowerCase() + "=");
        if(v0 == v4) {
            v0_1 = "";
        }
        else {
            String v1 = arg9.substring(v0 + arg10.length());
            v0 = v1.indexOf(v7);
            if(v0 == v4) {
                v0 = v1.length();
            }

            while(v1.charAt(v0 - 1) == 92) {
                v0 = v1.indexOf(v7, v0 + 1);
                if(v0 != v4) {
                    continue;
                }

                v0 = v1.length();
            }

            v0_1 = v1.substring(0, v0);
            v0_1 = v0_1.substring(v0_1.indexOf(61) + 1);
            if(v0_1.charAt(0) == 32) {
                v0_1 = v0_1.substring(1);
            }

            if(v0_1.startsWith("\"")) {
                v0_1 = v0_1.substring(1);
            }

            if(!v0_1.endsWith("\"")) {
                return v0_1;
            }

            v0_1 = v0_1.substring(0, v0_1.length() - 1);
        }

        return v0_1;
    }

    private List search(String[] arg7, String arg8, String[] arg9) {
        DirContext v3_1;
        String v2;
        String v0;
        String v3 = null;
        int v1 = 0;
        if(arg7 == null) {
            v0 = v3;
        }
        else {
            v0 = "";
            if(arg8.equals("**")) {
                arg8 = "*";
            }

            v2 = v0;
            int v0_1;
            for(v0_1 = 0; v0_1 < arg7.length; ++v0_1) {
                v2 = v2 + "(" + arg7[v0_1] + "=" + arg8 + ")";
            }

            v0 = "(|" + v2 + ")";
        }

        v2 = "";
        while(v1 < arg9.length) {
            v2 = v2 + "(" + arg9[v1] + "=*)";
            ++v1;
        }

        String v1_1 = "(|" + v2 + ")";
        v2 = "(&" + v0 + "" + v1_1 + ")";
        if(v0 != null) {
            v1_1 = v2;
        }

        List v0_2 = this.getFromCache(v1_1);
        if(v0_2 != null) {
            goto label_74;
        }

        ArrayList v2_1 = new ArrayList();
        try {
            v3_1 = this.connectLDAP();
            SearchControls v0_5 = new SearchControls();
            v0_5.setSearchScope(2);
            v0_5.setCountLimit(0);
            v0_5.setReturningAttributes(arg9);
            NamingEnumeration v4 = v3_1.search(this.params.getBaseDN(), v1_1, v0_5);
        label_88:
            if(v4.hasMoreElements()) {
                NamingEnumeration v0_6 = v4.next().getAttributes().getAll().next().getAll();
                while(true) {
                    if(!v0_6.hasMore()) {
                        goto label_88;
                    }

                    ((List)v2_1).add(v0_6.next());
                }
            }

            this.addToCache(v1_1, ((List)v2_1));
            if(v3_1 == null) {
                goto label_103;
            }
        }
        catch(NamingException v0_3) {
            goto label_101;
        }
        catch(Throwable v0_4) {
            goto label_112;
        }

        try {
            v3_1.close();
        }
        catch(Exception v0_7) {
        }

        goto label_103;
    label_101:
        if(v3_1 != null) {
            try {
                v3_1.close();
            }
            catch(Exception v0_7) {
            }
        }

    label_103:
        ArrayList v0_8 = v2_1;
        goto label_74;
    label_112:
        if(v3_1 != null) {
            try {
                v3_1.close();
            }
            catch(Exception v1_2) {
            }
        }

        throw v0_4;
    label_74:
        return ((List)v0_8);
    }

    private String[] splitString(String arg2) {
        return arg2.split("\\s+");
    }
}

