// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.helper;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.nio.charset.IllegalCharsetNameException;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.parser.Parser;

public class DataUtil {
    private static final int bufferSize = 131072;
    private static final Pattern charsetPattern = null;
    static final String defaultCharset = "UTF-8";

    static {
        DataUtil.charsetPattern = Pattern.compile("(?i)\\bcharset=\\s*(?:\"|\')?([^\\s,;\"\']*)");
    }

    private DataUtil() {
        super();
    }

    static String getCharsetFromContentType(String arg4) {
        String v0 = null;
        if(arg4 != null) {
            Matcher v1 = DataUtil.charsetPattern.matcher(((CharSequence)arg4));
            if(!v1.find()) {
                return v0;
            }

            String v1_1 = v1.group(1).trim().replace("charset=", "");
            if(v1_1.isEmpty()) {
                return v0;
            }

            try {
                if(Charset.isSupported(v1_1)) {
                    return v1_1;
                }

                v1_1 = v1_1.toUpperCase(Locale.ENGLISH);
                if(!Charset.isSupported(v1_1)) {
                    return v0;
                }
            }
            catch(IllegalCharsetNameException v1_2) {
                return v0;
            }

            v0 = v1_1;
        }

        return v0;
    }

    public static Document load(File arg3, String arg4, String arg5) {
        Document v0_1;
        FileInputStream v1;
        FileInputStream v2 = null;
        try {
            v1 = new FileInputStream(arg3);
        }
        catch(Throwable v0) {
            v1 = v2;
            goto label_11;
        }

        try {
            v0_1 = DataUtil.parseByteData(DataUtil.readToByteBuffer(((InputStream)v1)), arg4, arg5, Parser.htmlParser());
            if(v1 == null) {
                return v0_1;
            }

            goto label_7;
        }
        catch(Throwable v0) {
        }

    label_11:
        if(v1 != null) {
            v1.close();
        }

        throw v0;
    label_7:
        v1.close();
        return v0_1;
    }

    public static Document load(InputStream arg2, String arg3, String arg4) {
        return DataUtil.parseByteData(DataUtil.readToByteBuffer(arg2), arg3, arg4, Parser.htmlParser());
    }

    public static Document load(InputStream arg1, String arg2, String arg3, Parser arg4) {
        return DataUtil.parseByteData(DataUtil.readToByteBuffer(arg1), arg2, arg3, arg4);
    }

    static Document parseByteData(ByteBuffer arg7, String arg8, String arg9, Parser arg10) {
        Document v0_2;
        String v0;
        String v1 = null;
        if(arg8 == null) {
            String v3 = Charset.forName("UTF-8").decode(arg7).toString();
            Document v2 = arg10.parseInput(v3, arg9);
            Element v4 = v2.select("meta[http-equiv=content-type], meta[charset]").first();
            if(v4 == null) {
                goto label_74;
            }

            if(v4.hasAttr("http-equiv")) {
                v0 = DataUtil.getCharsetFromContentType(v4.attr("content"));
                if(v0 != null) {
                    goto label_27;
                }

                if(!v4.hasAttr("charset")) {
                    goto label_27;
                }

                try {
                    if(!Charset.isSupported(v4.attr("charset"))) {
                        goto label_27;
                    }

                    v0 = v4.attr("charset");
                }
                catch(IllegalCharsetNameException v0_1) {
                    v0 = v1;
                }
            }
            else {
                v0 = v4.attr("charset");
            }

        label_27:
            if(v0 != null) {
                if(v0.length() == 0) {
                    goto label_74;
                }

                if(v0.equals("UTF-8")) {
                    goto label_74;
                }

                arg8 = v0.trim().replaceAll("[\"\']", "");
                arg7.rewind();
                String v6 = v1;
                v1 = Charset.forName(arg8).decode(arg7).toString();
                v0_2 = ((Document)v6);
            }
            else {
            label_74:
                v0_2 = v2;
                v1 = v3;
            }

            Document v6_1 = v0_2;
            v0 = v1;
            Document v1_1 = v6_1;
        }
        else {
            Validate.notEmpty(arg8, "Must set charset arg to character set of file to parse. Set to null to attempt to detect from HTML");
            v0 = Charset.forName(arg8).decode(arg7).toString();
        }

        if(v1 == null) {
            if(v0.length() > 0 && v0.charAt(0) == 65279) {
                v0 = v0.substring(1);
            }

            v0_2 = arg10.parseInput(v0, arg9);
            v0_2.outputSettings().charset(arg8);
        }
        else {
            v0_2 = ((Document)v1);
        }

        return v0_2;
    }

    static ByteBuffer readToByteBuffer(InputStream arg1) {
        return DataUtil.readToByteBuffer(arg1, 0);
    }

    static ByteBuffer readToByteBuffer(InputStream arg6, int arg7) {
        int v4 = 131072;
        int v1 = 1;
        boolean v0 = arg7 >= 0 ? true : false;
        Validate.isTrue(v0, "maxSize must be 0 (unlimited) or larger");
        if(arg7 <= 0) {
            v1 = 0;
        }

        byte[] v0_1 = new byte[v4];
        ByteArrayOutputStream v3 = new ByteArrayOutputStream(v4);
        while(true) {
            v4 = arg6.read(v0_1);
            if(v4 != -1) {
                if(v1 != 0) {
                    if(v4 > arg7) {
                        v3.write(v0_1, 0, arg7);
                        break;
                    }
                    else {
                        arg7 -= v4;
                    }
                }

                v3.write(v0_1, 0, v4);
                continue;
            }

            break;
        }

        return ByteBuffer.wrap(v3.toByteArray());
    }
}

