// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.nodes;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;
import org.jsoup.helper.StringUtil;
import org.jsoup.helper.Validate;
import org.jsoup.parser.Parser;
import org.jsoup.parser.Tag;
import org.jsoup.select.Collector;
import org.jsoup.select.Elements;
import org.jsoup.select.Evaluator$AllElements;
import org.jsoup.select.Evaluator$Attribute;
import org.jsoup.select.Evaluator$AttributeStarting;
import org.jsoup.select.Evaluator$AttributeWithValue;
import org.jsoup.select.Evaluator$AttributeWithValueContaining;
import org.jsoup.select.Evaluator$AttributeWithValueEnding;
import org.jsoup.select.Evaluator$AttributeWithValueMatching;
import org.jsoup.select.Evaluator$AttributeWithValueNot;
import org.jsoup.select.Evaluator$AttributeWithValueStarting;
import org.jsoup.select.Evaluator$Class;
import org.jsoup.select.Evaluator$ContainsOwnText;
import org.jsoup.select.Evaluator$ContainsText;
import org.jsoup.select.Evaluator$Id;
import org.jsoup.select.Evaluator$IndexEquals;
import org.jsoup.select.Evaluator$IndexGreaterThan;
import org.jsoup.select.Evaluator$IndexLessThan;
import org.jsoup.select.Evaluator$Matches;
import org.jsoup.select.Evaluator$MatchesOwn;
import org.jsoup.select.Evaluator$Tag;
import org.jsoup.select.NodeTraversor;
import org.jsoup.select.Selector;

public class Element extends Node {
    private Set classNames;
    private Tag tag;

    public Element(Tag arg2, String arg3) {
        this(arg2, arg3, new Attributes());
    }

    public Element(Tag arg1, String arg2, Attributes arg3) {
        super(arg2, arg3);
        Validate.notNull(arg1);
        this.tag = arg1;
    }

    static void access$000(StringBuilder arg0, TextNode arg1) {
        Element.appendNormalisedText(arg0, arg1);
    }

    static Tag access$100(Element arg1) {
        return arg1.tag;
    }

    private static void accumulateParents(Element arg3, Elements arg4) {
        Element v0 = arg3.parent();
        if(v0 != null && !v0.tagName().equals("#root")) {
            arg4.add(v0);
            Element.accumulateParents(v0, arg4);
        }
    }

    public Element addClass(String arg2) {
        Validate.notNull(arg2);
        Set v0 = this.classNames();
        v0.add(arg2);
        this.classNames(v0);
        return this;
    }

    public Element after(String arg2) {
        return super.after(arg2);
    }

    public Element after(Node arg2) {
        return super.after(arg2);
    }

    public Node after(String arg2) {
        return this.after(arg2);
    }

    public Node after(Node arg2) {
        return this.after(arg2);
    }

    public Element append(String arg3) {
        Validate.notNull(arg3);
        List v0 = Parser.parseFragment(arg3, this, this.baseUri());
        this.addChildren(v0.toArray(new Node[v0.size()]));
        return this;
    }

    public Element appendChild(Node arg3) {
        Validate.notNull(arg3);
        this.addChildren(new Node[]{arg3});
        return this;
    }

    public Element appendElement(String arg4) {
        Element v0 = new Element(Tag.valueOf(arg4), this.baseUri());
        this.appendChild(((Node)v0));
        return v0;
    }

    private static void appendNormalisedText(StringBuilder arg2, TextNode arg3) {
        String v0 = arg3.getWholeText();
        if(!Element.preserveWhitespace(arg3.parent())) {
            v0 = TextNode.normaliseWhitespace(v0);
            if(TextNode.lastCharIsWhitespace(arg2)) {
                v0 = TextNode.stripLeadingWhitespace(v0);
            }
        }

        arg2.append(v0);
    }

    public Element appendText(String arg3) {
        this.appendChild(new TextNode(arg3, this.baseUri()));
        return this;
    }

    private static void appendWhitespaceIfBr(Element arg2, StringBuilder arg3) {
        if((arg2.tag.getName().equals("br")) && !TextNode.lastCharIsWhitespace(arg3)) {
            arg3.append(" ");
        }
    }

    public Element attr(String arg1, String arg2) {
        super.attr(arg1, arg2);
        return this;
    }

    public Node attr(String arg2, String arg3) {
        return this.attr(arg2, arg3);
    }

    public Element before(String arg2) {
        return super.before(arg2);
    }

    public Element before(Node arg2) {
        return super.before(arg2);
    }

    public Node before(String arg2) {
        return this.before(arg2);
    }

    public Node before(Node arg2) {
        return this.before(arg2);
    }

    public Element child(int arg2) {
        return this.children().get(arg2);
    }

    public Elements children() {
        ArrayList v1 = new ArrayList();
        Iterator v2 = this.childNodes.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if(!(v0 instanceof Element)) {
                continue;
            }

            ((List)v1).add(v0);
        }

        return new Elements(((List)v1));
    }

    public String className() {
        return this.attr("class");
    }

    public Set classNames() {
        if(this.classNames == null) {
            this.classNames = new LinkedHashSet(Arrays.asList(this.className().split("\\s+")));
        }

        return this.classNames;
    }

    public Element classNames(Set arg4) {
        Validate.notNull(arg4);
        this.attributes.put("class", StringUtil.join(((Collection)arg4), " "));
        return this;
    }

    public Object clone() {
        return this.clone();
    }

    public Element clone() {
        Node v0 = super.clone();
        ((Element)v0).classNames = null;
        return ((Element)v0);
    }

    public Node clone() {
        return this.clone();
    }

    public String data() {
        StringBuilder v1 = new StringBuilder();
        Iterator v2 = this.childNodes.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if((v0 instanceof DataNode)) {
                v1.append(((DataNode)v0).getWholeData());
                continue;
            }

            if(!(v0 instanceof Element)) {
                continue;
            }

            v1.append(((Element)v0).data());
        }

        return v1.toString();
    }

    public List dataNodes() {
        ArrayList v1 = new ArrayList();
        Iterator v2 = this.childNodes.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if(!(v0 instanceof DataNode)) {
                continue;
            }

            ((List)v1).add(v0);
        }

        return Collections.unmodifiableList(((List)v1));
    }

    public Map dataset() {
        return this.attributes.dataset();
    }

    public Integer elementSiblingIndex() {
        Integer v0 = this.parent() == null ? Integer.valueOf(0) : Element.indexInList(this, this.parent().children());
        return v0;
    }

    public Element empty() {
        this.childNodes.clear();
        return this;
    }

    public boolean equals(Object arg2) {
        boolean v0 = this == (((Element)arg2)) ? true : false;
        return v0;
    }

    public Element firstElementSibling() {
        Object v0_1;
        Elements v0 = this.parent().children();
        if(((List)v0).size() > 1) {
            v0_1 = ((List)v0).get(0);
        }
        else {
            Element v0_2 = null;
        }

        return ((Element)v0_1);
    }

    public Elements getAllElements() {
        return Collector.collect(new Evaluator$AllElements(), this);
    }

    public Element getElementById(String arg3) {
        Validate.notEmpty(arg3);
        Elements v0 = Collector.collect(new Evaluator$Id(arg3), this);
        Element v0_1 = v0.size() > 0 ? v0.get(0) : null;
        return v0_1;
    }

    public Elements getElementsByAttribute(String arg3) {
        Validate.notEmpty(arg3);
        return Collector.collect(new Evaluator$Attribute(arg3.trim().toLowerCase()), this);
    }

    public Elements getElementsByAttributeStarting(String arg3) {
        Validate.notEmpty(arg3);
        return Collector.collect(new Evaluator$AttributeStarting(arg3.trim().toLowerCase()), this);
    }

    public Elements getElementsByAttributeValue(String arg2, String arg3) {
        return Collector.collect(new Evaluator$AttributeWithValue(arg2, arg3), this);
    }

    public Elements getElementsByAttributeValueContaining(String arg2, String arg3) {
        return Collector.collect(new Evaluator$AttributeWithValueContaining(arg2, arg3), this);
    }

    public Elements getElementsByAttributeValueEnding(String arg2, String arg3) {
        return Collector.collect(new Evaluator$AttributeWithValueEnding(arg2, arg3), this);
    }

    public Elements getElementsByAttributeValueMatching(String arg5, String arg6) {
        try {
            return this.getElementsByAttributeValueMatching(arg5, Pattern.compile(arg6));
        }
        catch(PatternSyntaxException v0) {
            throw new IllegalArgumentException("Pattern syntax error: " + arg6, ((Throwable)v0));
        }
    }

    public Elements getElementsByAttributeValueMatching(String arg2, Pattern arg3) {
        return Collector.collect(new Evaluator$AttributeWithValueMatching(arg2, arg3), this);
    }

    public Elements getElementsByAttributeValueNot(String arg2, String arg3) {
        return Collector.collect(new Evaluator$AttributeWithValueNot(arg2, arg3), this);
    }

    public Elements getElementsByAttributeValueStarting(String arg2, String arg3) {
        return Collector.collect(new Evaluator$AttributeWithValueStarting(arg2, arg3), this);
    }

    public Elements getElementsByClass(String arg2) {
        Validate.notEmpty(arg2);
        return Collector.collect(new Evaluator$Class(arg2), this);
    }

    public Elements getElementsByIndexEquals(int arg2) {
        return Collector.collect(new Evaluator$IndexEquals(arg2), this);
    }

    public Elements getElementsByIndexGreaterThan(int arg2) {
        return Collector.collect(new Evaluator$IndexGreaterThan(arg2), this);
    }

    public Elements getElementsByIndexLessThan(int arg2) {
        return Collector.collect(new Evaluator$IndexLessThan(arg2), this);
    }

    public Elements getElementsByTag(String arg3) {
        Validate.notEmpty(arg3);
        return Collector.collect(new Evaluator$Tag(arg3.toLowerCase().trim()), this);
    }

    public Elements getElementsContainingOwnText(String arg2) {
        return Collector.collect(new Evaluator$ContainsOwnText(arg2), this);
    }

    public Elements getElementsContainingText(String arg2) {
        return Collector.collect(new Evaluator$ContainsText(arg2), this);
    }

    public Elements getElementsMatchingOwnText(String arg5) {
        try {
            return this.getElementsMatchingOwnText(Pattern.compile(arg5));
        }
        catch(PatternSyntaxException v0) {
            throw new IllegalArgumentException("Pattern syntax error: " + arg5, ((Throwable)v0));
        }
    }

    public Elements getElementsMatchingOwnText(Pattern arg2) {
        return Collector.collect(new Evaluator$MatchesOwn(arg2), this);
    }

    public Elements getElementsMatchingText(String arg5) {
        try {
            return this.getElementsMatchingText(Pattern.compile(arg5));
        }
        catch(PatternSyntaxException v0) {
            throw new IllegalArgumentException("Pattern syntax error: " + arg5, ((Throwable)v0));
        }
    }

    public Elements getElementsMatchingText(Pattern arg2) {
        return Collector.collect(new Evaluator$Matches(arg2), this);
    }

    public boolean hasClass(String arg3) {
        Iterator v1 = this.classNames().iterator();
        do {
            if(v1.hasNext()) {
                if(!arg3.equalsIgnoreCase(v1.next())) {
                    continue;
                }

                break;
            }
            else {
                return false;
            }
        }
        while(true);

        boolean v0 = true;
        return v0;
    }

    public boolean hasText() {
        boolean v0_1;
        Iterator v2 = this.childNodes.iterator();
        do {
            if(v2.hasNext()) {
                Object v0 = v2.next();
                if((v0 instanceof TextNode)) {
                    if(((TextNode)v0).isBlank()) {
                        continue;
                    }

                    v0_1 = true;
                }
                else {
                    if(!(v0 instanceof Element)) {
                        continue;
                    }

                    if(!((Element)v0).hasText()) {
                        continue;
                    }

                    return true;
                }
            }
            else {
                return false;
            }

            return v0_1;
        }
        while(true);

        return true;
    }

    public int hashCode() {
        int v1 = super.hashCode() * 31;
        int v0 = this.tag != null ? this.tag.hashCode() : 0;
        return v0 + v1;
    }

    public String html() {
        StringBuilder v0 = new StringBuilder();
        this.html(v0);
        return v0.toString().trim();
    }

    private void html(StringBuilder arg3) {
        Iterator v1 = this.childNodes.iterator();
        while(v1.hasNext()) {
            v1.next().outerHtml(arg3);
        }
    }

    public Element html(String arg1) {
        this.empty();
        this.append(arg1);
        return this;
    }

    public String id() {
        String v0 = this.attr("id");
        if(v0 == null) {
            v0 = "";
        }

        return v0;
    }

    private static Integer indexInList(Element arg2, List arg3) {
        Integer v0;
        Validate.notNull(arg2);
        Validate.notNull(arg3);
        int v1 = 0;
        while(true) {
            if(v1 >= arg3.size()) {
                return null;
            }
            else if(arg3.get(v1).equals(arg2)) {
                v0 = Integer.valueOf(v1);
            }
            else {
                ++v1;
                continue;
            }

            return v0;
        }

        return null;
    }

    public Element insertChildren(int arg3, Collection arg4) {
        Validate.notNull(arg4, "Children collection to be inserted must not be null.");
        int v0 = this.childNodeSize();
        if(arg3 < 0) {
            arg3 += v0 + 1;
        }

        boolean v0_1 = arg3 < 0 || arg3 > v0 ? false : true;
        Validate.isTrue(v0_1, "Insert position out of bounds.");
        ArrayList v0_2 = new ArrayList(arg4);
        this.addChildren(arg3, v0_2.toArray(new Node[v0_2.size()]));
        return this;
    }

    public boolean isBlock() {
        return this.tag.isBlock();
    }

    public Element lastElementSibling() {
        Element v0_2;
        Elements v0 = this.parent().children();
        if(((List)v0).size() > 1) {
            Object v0_1 = ((List)v0).get(((List)v0).size() - 1);
        }
        else {
            v0_2 = null;
        }

        return v0_2;
    }

    public Element nextElementSibling() {
        Object v0_1;
        Element v0 = null;
        if(this.parentNode != null) {
            Elements v1 = this.parent().children();
            Integer v2 = Element.indexInList(this, ((List)v1));
            Validate.notNull(v2);
            if(((List)v1).size() > v2.intValue() + 1) {
                v0_1 = ((List)v1).get(v2.intValue() + 1);
            }
        }

        return ((Element)v0_1);
    }

    public String nodeName() {
        return this.tag.getName();
    }

    void outerHtmlHead(StringBuilder arg3, int arg4, Document$OutputSettings arg5) {
        if(arg3.length() > 0 && (arg5.prettyPrint()) && ((this.tag.formatAsBlock()) || this.parent() != null && (this.parent().tag().formatAsBlock()) || (arg5.outline()))) {
            this.indent(arg3, arg4, arg5);
        }

        arg3.append("<").append(this.tagName());
        this.attributes.html(arg3, arg5);
        if(!this.childNodes.isEmpty() || !this.tag.isSelfClosing()) {
            arg3.append(">");
        }
        else {
            arg3.append(" />");
        }
    }

    void outerHtmlTail(StringBuilder arg3, int arg4, Document$OutputSettings arg5) {
        if(!this.childNodes.isEmpty() || !this.tag.isSelfClosing()) {
            if((arg5.prettyPrint()) && !this.childNodes.isEmpty()) {
                if(!this.tag.formatAsBlock()) {
                    if(!arg5.outline()) {
                        goto label_29;
                    }
                    else if(this.childNodes.size() <= 1) {
                        if(this.childNodes.size() != 1) {
                        }
                        else if(!(this.childNodes.get(0) instanceof TextNode)) {
                            goto label_28;
                        }

                        goto label_29;
                    }
                }

            label_28:
                this.indent(arg3, arg4, arg5);
            }

        label_29:
            arg3.append("</").append(this.tagName()).append(">");
        }
    }

    private void ownText(StringBuilder arg4) {
        Iterator v1 = this.childNodes.iterator();
        while(v1.hasNext()) {
            Object v0 = v1.next();
            if((v0 instanceof TextNode)) {
                Element.appendNormalisedText(arg4, ((TextNode)v0));
                continue;
            }

            if(!(v0 instanceof Element)) {
                continue;
            }

            Element.appendWhitespaceIfBr(((Element)v0), arg4);
        }
    }

    public String ownText() {
        StringBuilder v0 = new StringBuilder();
        this.ownText(v0);
        return v0.toString().trim();
    }

    public final Element parent() {
        return this.parentNode;
    }

    public Node parent() {
        return this.parent();
    }

    public Elements parents() {
        Elements v0 = new Elements();
        Element.accumulateParents(this, v0);
        return v0;
    }

    public Element prepend(String arg4) {
        Validate.notNull(arg4);
        List v0 = Parser.parseFragment(arg4, this, this.baseUri());
        this.addChildren(0, v0.toArray(new Node[v0.size()]));
        return this;
    }

    public Element prependChild(Node arg3) {
        Validate.notNull(arg3);
        this.addChildren(0, new Node[]{arg3});
        return this;
    }

    public Element prependElement(String arg4) {
        Element v0 = new Element(Tag.valueOf(arg4), this.baseUri());
        this.prependChild(((Node)v0));
        return v0;
    }

    public Element prependText(String arg3) {
        this.prependChild(new TextNode(arg3, this.baseUri()));
        return this;
    }

    static boolean preserveWhitespace(Node arg2) {
        boolean v0 = false;
        if(arg2 != null && ((arg2 instanceof Element))) {
            if(!((Element)arg2).tag.preserveWhitespace()) {
                if(((Element)arg2).parent() == null) {
                }
                else if(((Element)arg2).parent().tag.preserveWhitespace()) {
                    goto label_13;
                }

                return v0;
            }

        label_13:
            v0 = true;
        }

        return v0;
    }

    public Element previousElementSibling() {
        Object v0_1;
        Element v0 = null;
        if(this.parentNode != null) {
            Elements v1 = this.parent().children();
            Integer v2 = Element.indexInList(this, ((List)v1));
            Validate.notNull(v2);
            if(v2.intValue() > 0) {
                v0_1 = ((List)v1).get(v2.intValue() - 1);
            }
        }

        return ((Element)v0_1);
    }

    public Element removeClass(String arg2) {
        Validate.notNull(arg2);
        Set v0 = this.classNames();
        v0.remove(arg2);
        this.classNames(v0);
        return this;
    }

    public Elements select(String arg2) {
        return Selector.select(arg2, this);
    }

    public Elements siblingElements() {
        Elements v0;
        if(this.parentNode == null) {
            v0 = new Elements(0);
        }
        else {
            v0 = this.parent().children();
            Elements v1 = new Elements(((List)v0).size() - 1);
            Iterator v2 = ((List)v0).iterator();
            while(v2.hasNext()) {
                Object v0_1 = v2.next();
                if((((Element)v0_1)) == this) {
                    continue;
                }

                v1.add(((Element)v0_1));
            }

            v0 = v1;
        }

        return v0;
    }

    public Tag tag() {
        return this.tag;
    }

    public String tagName() {
        return this.tag.getName();
    }

    public Element tagName(String arg2) {
        Validate.notEmpty(arg2, "Tag name must not be empty.");
        this.tag = Tag.valueOf(arg2);
        return this;
    }

    public String text() {
        StringBuilder v0 = new StringBuilder();
        new NodeTraversor(new Element$1(this, v0)).traverse(((Node)this));
        return v0.toString().trim();
    }

    public Element text(String arg3) {
        Validate.notNull(arg3);
        this.empty();
        this.appendChild(new TextNode(arg3, this.baseUri));
        return this;
    }

    public List textNodes() {
        ArrayList v1 = new ArrayList();
        Iterator v2 = this.childNodes.iterator();
        while(v2.hasNext()) {
            Object v0 = v2.next();
            if(!(v0 instanceof TextNode)) {
                continue;
            }

            ((List)v1).add(v0);
        }

        return Collections.unmodifiableList(((List)v1));
    }

    public String toString() {
        return this.outerHtml();
    }

    public Element toggleClass(String arg3) {
        Validate.notNull(arg3);
        Set v0 = this.classNames();
        if(v0.contains(arg3)) {
            v0.remove(arg3);
        }
        else {
            v0.add(arg3);
        }

        this.classNames(v0);
        return this;
    }

    public String val() {
        String v0 = this.tagName().equals("textarea") ? this.text() : this.attr("value");
        return v0;
    }

    public Element val(String arg3) {
        if(this.tagName().equals("textarea")) {
            this.text(arg3);
        }
        else {
            this.attr("value", arg3);
        }

        return this;
    }

    public Element wrap(String arg2) {
        return super.wrap(arg2);
    }

    public Node wrap(String arg2) {
        return this.wrap(arg2);
    }
}

