// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.nodes;

import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.CharsetEncoder;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map$Entry;
import java.util.MissingResourceException;
import java.util.Properties;
import java.util.regex.Pattern;
import org.jsoup.parser.Parser;

public class Entities {
    private static final Map base;
    private static final Map baseByVal;
    private static final Map full;
    private static final Map fullByVal;
    private static final Pattern strictUnescapePattern;
    private static final Pattern unescapePattern;
    private static final Object[][] xhtmlArray;
    private static final Map xhtmlByVal;

    static {
        Entities.unescapePattern = Pattern.compile("&(#(x|X)?([0-9a-fA-F]+)|[a-zA-Z]+\\d*);?");
        Entities.strictUnescapePattern = Pattern.compile("&(#(x|X)?([0-9a-fA-F]+)|[a-zA-Z]+\\d*);");
        Entities.xhtmlArray = new Object[][]{new Object[]{"quot", Integer.valueOf(34)}, new Object[]{"amp", Integer.valueOf(38)}, new Object[]{"apos", Integer.valueOf(39)}, new Object[]{"lt", Integer.valueOf(60)}, new Object[]{"gt", Integer.valueOf(62)}};
        Entities.xhtmlByVal = new HashMap();
        Entities.base = Entities.loadEntities("entities-base.properties");
        Entities.baseByVal = Entities.toCharacterKey(Entities.base);
        Entities.full = Entities.loadEntities("entities-full.properties");
        Entities.fullByVal = Entities.toCharacterKey(Entities.full);
        Object[][] v3 = Entities.xhtmlArray;
        int v4 = v3.length;
        int v1;
        for(v1 = 0; v1 < v4; ++v1) {
            Entities.xhtmlByVal.put(Character.valueOf(((char)v3[v1][1].intValue())), v3[v1][0]);
        }
    }

    private Entities() {
        super();
    }

    static Map access$000() {
        return Entities.xhtmlByVal;
    }

    static Map access$100() {
        return Entities.baseByVal;
    }

    static Map access$200() {
        return Entities.fullByVal;
    }

    static String escape(String arg2, Document$OutputSettings arg3) {
        return Entities.escape(arg2, arg3.encoder(), arg3.escapeMode());
    }

    static String escape(String arg8, CharsetEncoder arg9, Entities$EscapeMode arg10) {
        char v7 = ';';
        StringBuilder v2 = new StringBuilder(arg8.length() * 2);
        Map v3 = arg10.getMap();
        int v4 = arg8.length();
        int v1;
        for(v1 = 0; v1 < v4; v1 = Character.charCount(v5) + v1) {
            int v5 = arg8.codePointAt(v1);
            if(v5 < 65536) {
                char v0 = ((char)v5);
                if(v3.containsKey(Character.valueOf(v0))) {
                    v2.append('&').append(v3.get(Character.valueOf(v0))).append(v7);
                }
                else if(arg9.canEncode(v0)) {
                    v2.append(v0);
                }
                else {
                    v2.append("&#x").append(Integer.toHexString(v5)).append(v7);
                }
            }
            else {
                String v0_1 = new String(Character.toChars(v5));
                if(arg9.canEncode(((CharSequence)v0_1))) {
                    v2.append(v0_1);
                }
                else {
                    v2.append("&#x").append(Integer.toHexString(v5)).append(v7);
                }
            }
        }

        return v2.toString();
    }

    public static Character getCharacterByName(String arg1) {
        return Entities.full.get(arg1);
    }

    public static boolean isBaseNamedEntity(String arg1) {
        return Entities.base.containsKey(arg1);
    }

    public static boolean isNamedEntity(String arg1) {
        return Entities.full.containsKey(arg1);
    }

    private static Map loadEntities(String arg5) {
        Properties v0 = new Properties();
        HashMap v2 = new HashMap();
        try {
            InputStream v1 = Entities.class.getResourceAsStream(arg5);
            v0.load(v1);
            v1.close();
        }
        catch(IOException v0_1) {
            throw new MissingResourceException("Error loading entities resource: " + v0_1.getMessage(), "Entities", arg5);
        }

        Iterator v3 = v0.entrySet().iterator();
        while(v3.hasNext()) {
            Object v0_2 = v3.next();
            ((Map)v2).put(((Map$Entry)v0_2).getKey(), Character.valueOf(((char)Integer.parseInt(((Map$Entry)v0_2).getValue(), 16))));
        }

        return ((Map)v2);
    }

    private static Map toCharacterKey(Map arg5) {
        HashMap v2 = new HashMap();
        Iterator v3 = arg5.entrySet().iterator();
        while(v3.hasNext()) {
            Object v0 = v3.next();
            Object v1 = ((Map$Entry)v0).getValue();
            v0 = ((Map$Entry)v0).getKey();
            if(((Map)v2).containsKey(v1)) {
                if(!((String)v0).toLowerCase().equals(v0)) {
                    continue;
                }

                ((Map)v2).put(v1, v0);
                continue;
            }

            ((Map)v2).put(v1, v0);
        }

        return ((Map)v2);
    }

    static String unescape(String arg1, boolean arg2) {
        return Parser.unescapeEntities(arg1, arg2);
    }

    static String unescape(String arg1) {
        return Entities.unescape(arg1, false);
    }
}

