// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.nodes;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import org.jsoup.helper.StringUtil;
import org.jsoup.helper.Validate;
import org.jsoup.parser.Parser;
import org.jsoup.select.Elements;
import org.jsoup.select.NodeTraversor;
import org.jsoup.select.NodeVisitor;

public abstract class Node implements Cloneable {
    Attributes attributes;
    String baseUri;
    List childNodes;
    Node parentNode;
    int siblingIndex;

    protected Node() {
        super();
        this.childNodes = Collections.emptyList();
        this.attributes = null;
    }

    protected Node(String arg2) {
        this(arg2, new Attributes());
    }

    protected Node(String arg3, Attributes arg4) {
        super();
        Validate.notNull(arg3);
        Validate.notNull(arg4);
        this.childNodes = new ArrayList(4);
        this.baseUri = arg3.trim();
        this.attributes = arg4;
    }

    public String absUrl(String arg5) {
        URL v1_1;
        Validate.notEmpty(arg5);
        String v0 = this.attr(arg5);
        if(!this.hasAttr(arg5)) {
            return "";
        }

        try {
            v1_1 = new URL(this.baseUri);
            goto label_9;
        }
        catch(MalformedURLException v1) {
            try {
                return new URL(v0).toExternalForm();
            label_9:
                if(v0.startsWith("?")) {
                    v0 = v1_1.getPath() + v0;
                }

                v0 = new URL(v1_1, v0).toExternalForm();
            }
            catch(MalformedURLException v0_1) {
                v0 = "";
            }
        }

        return v0;
    }

    protected void addChildren(int arg4, Node[] arg5) {
        Validate.noNullElements(((Object[])arg5));
        int v0;
        for(v0 = arg5.length - 1; v0 >= 0; --v0) {
            Node v1 = arg5[v0];
            this.reparentChild(v1);
            this.childNodes.add(arg4, v1);
        }

        this.reindexChildren();
    }

    protected void addChildren(Node[] arg5) {
        int v1 = arg5.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            Node v2 = arg5[v0];
            this.reparentChild(v2);
            this.childNodes.add(v2);
            v2.setSiblingIndex(this.childNodes.size() - 1);
        }
    }

    private void addSiblingHtml(int arg4, String arg5) {
        Node v0;
        Validate.notNull(arg5);
        Validate.notNull(this.parentNode);
        if((this.parent() instanceof Element)) {
            v0 = this.parent();
        }
        else {
            Element v0_1 = null;
        }

        List v0_2 = Parser.parseFragment(arg5, ((Element)v0), this.baseUri());
        this.parentNode.addChildren(arg4, v0_2.toArray(new Node[v0_2.size()]));
    }

    public Node after(String arg2) {
        this.addSiblingHtml(this.siblingIndex() + 1, arg2);
        return this;
    }

    public Node after(Node arg5) {
        Validate.notNull(arg5);
        Validate.notNull(this.parentNode);
        this.parentNode.addChildren(this.siblingIndex() + 1, new Node[]{arg5});
        return this;
    }

    public String attr(String arg3) {
        String v0;
        Validate.notNull(arg3);
        if(this.attributes.hasKey(arg3)) {
            v0 = this.attributes.get(arg3);
        }
        else if(arg3.toLowerCase().startsWith("abs:")) {
            v0 = this.absUrl(arg3.substring("abs:".length()));
        }
        else {
            v0 = "";
        }

        return v0;
    }

    public Node attr(String arg2, String arg3) {
        this.attributes.put(arg2, arg3);
        return this;
    }

    public Attributes attributes() {
        return this.attributes;
    }

    public String baseUri() {
        return this.baseUri;
    }

    public Node before(String arg2) {
        this.addSiblingHtml(this.siblingIndex(), arg2);
        return this;
    }

    public Node before(Node arg5) {
        Validate.notNull(arg5);
        Validate.notNull(this.parentNode);
        this.parentNode.addChildren(this.siblingIndex(), new Node[]{arg5});
        return this;
    }

    public Node childNode(int arg2) {
        return this.childNodes.get(arg2);
    }

    public final int childNodeSize() {
        return this.childNodes.size();
    }

    public List childNodes() {
        return Collections.unmodifiableList(this.childNodes);
    }

    protected Node[] childNodesAsArray() {
        return this.childNodes.toArray(new Node[this.childNodeSize()]);
    }

    public List childNodesCopy() {
        ArrayList v1 = new ArrayList(this.childNodes.size());
        Iterator v2 = this.childNodes.iterator();
        while(v2.hasNext()) {
            ((List)v1).add(v2.next().clone());
        }

        return ((List)v1);
    }

    public Node clone() {
        Node v3 = this.doClone(null);
        LinkedList v4 = new LinkedList();
        v4.add(v3);
    label_5:
        if(!v4.isEmpty()) {
            Object v0 = v4.remove();
            int v2;
            for(v2 = 0; true; ++v2) {
                if(v2 >= ((Node)v0).childNodes.size()) {
                    goto label_5;
                }

                Node v1 = ((Node)v0).childNodes.get(v2).doClone(((Node)v0));
                ((Node)v0).childNodes.set(v2, v1);
                v4.add(v1);
            }
        }

        return v3;
    }

    public Object clone() {
        return this.clone();
    }

    protected Node doClone(Node arg5) {
        Object v0_1;
        try {
            v0_1 = super.clone();
            ((Node)v0_1).parentNode = arg5;
            if(arg5 != null) {
                goto label_29;
            }
        }
        catch(CloneNotSupportedException v0) {
            throw new RuntimeException(((Throwable)v0));
        }

        int v1 = 0;
        goto label_4;
    label_29:
        v1 = this.siblingIndex;
    label_4:
        ((Node)v0_1).siblingIndex = v1;
        Attributes v1_1 = this.attributes != null ? this.attributes.clone() : null;
        ((Node)v0_1).attributes = v1_1;
        ((Node)v0_1).baseUri = this.baseUri;
        ((Node)v0_1).childNodes = new ArrayList(this.childNodes.size());
        Iterator v2 = this.childNodes.iterator();
        while(v2.hasNext()) {
            ((Node)v0_1).childNodes.add(v2.next());
        }

        return ((Node)v0_1);
    }

    public boolean equals(Object arg2) {
        boolean v0 = this == (((Node)arg2)) ? true : false;
        return v0;
    }

    private Element getDeepChild(Element arg3) {
        Elements v0 = arg3.children();
        if(((List)v0).size() > 0) {
            arg3 = this.getDeepChild(((List)v0).get(0));
        }

        return arg3;
    }

    private Document$OutputSettings getOutputSettings() {
        Document$OutputSettings v0 = this.ownerDocument() != null ? this.ownerDocument().outputSettings() : new Document("").outputSettings();
        return v0;
    }

    public boolean hasAttr(String arg3) {
        boolean v0_1;
        Validate.notNull(arg3);
        if(arg3.startsWith("abs:")) {
            String v0 = arg3.substring("abs:".length());
            if(!this.attributes.hasKey(v0)) {
                goto label_16;
            }
            else if(!this.absUrl(v0).equals("")) {
                v0_1 = true;
            }
            else {
                goto label_16;
            }
        }
        else {
        label_16:
            v0_1 = this.attributes.hasKey(arg3);
        }

        return v0_1;
    }

    public int hashCode() {
        int v1 = 0;
        int v0 = this.parentNode != null ? this.parentNode.hashCode() : 0;
        v0 *= 31;
        if(this.attributes != null) {
            v1 = this.attributes.hashCode();
        }

        return v0 + v1;
    }

    protected void indent(StringBuilder arg3, int arg4, Document$OutputSettings arg5) {
        arg3.append("\n").append(StringUtil.padding(arg5.indentAmount() * arg4));
    }

    public Node nextSibling() {
        Node v0 = null;
        if(this.parentNode != null) {
            List v1 = this.parentNode.childNodes;
            Integer v2 = Integer.valueOf(this.siblingIndex());
            Validate.notNull(v2);
            if(v1.size() > v2.intValue() + 1) {
                Object v0_1 = v1.get(v2.intValue() + 1);
            }
        }

        return v0;
    }

    public abstract String nodeName();

    public String outerHtml() {
        StringBuilder v0 = new StringBuilder(128);
        this.outerHtml(v0);
        return v0.toString();
    }

    protected void outerHtml(StringBuilder arg4) {
        new NodeTraversor(new Node$OuterHtmlVisitor(arg4, this.getOutputSettings())).traverse(this);
    }

    abstract void outerHtmlHead(StringBuilder arg1, int arg2, Document$OutputSettings arg3);

    abstract void outerHtmlTail(StringBuilder arg1, int arg2, Document$OutputSettings arg3);

    public Document ownerDocument() {
        Document v1;
        if(!(this instanceof Document)) {
            if(this.parentNode == null) {
                this = null;
            }
            else {
                v1 = this.parentNode.ownerDocument();
            }
        }

        return ((Node)v1);
    }

    public Node parent() {
        return this.parentNode;
    }

    public final Node parentNode() {
        return this.parentNode;
    }

    public Node previousSibling() {
        Object v0_1;
        Node v0 = null;
        if(this.parentNode != null) {
            List v1 = this.parentNode.childNodes;
            Integer v2 = Integer.valueOf(this.siblingIndex());
            Validate.notNull(v2);
            if(v2.intValue() > 0) {
                v0_1 = v1.get(v2.intValue() - 1);
            }
        }

        return ((Node)v0_1);
    }

    private void reindexChildren() {
        int v1;
        for(v1 = 0; v1 < this.childNodes.size(); ++v1) {
            this.childNodes.get(v1).setSiblingIndex(v1);
        }
    }

    public void remove() {
        Validate.notNull(this.parentNode);
        this.parentNode.removeChild(this);
    }

    public Node removeAttr(String arg2) {
        Validate.notNull(arg2);
        this.attributes.remove(arg2);
        return this;
    }

    protected void removeChild(Node arg3) {
        boolean v0 = arg3.parentNode == this ? true : false;
        Validate.isTrue(v0);
        this.childNodes.remove(arg3.siblingIndex());
        this.reindexChildren();
        arg3.parentNode = null;
    }

    private void reparentChild(Node arg2) {
        if(arg2.parentNode != null) {
            arg2.parentNode.removeChild(arg2);
        }

        arg2.setParentNode(this);
    }

    protected void replaceChild(Node arg4, Node arg5) {
        boolean v0 = arg4.parentNode == this ? true : false;
        Validate.isTrue(v0);
        Validate.notNull(arg5);
        if(arg5.parentNode != null) {
            arg5.parentNode.removeChild(arg5);
        }

        Integer v0_1 = Integer.valueOf(arg4.siblingIndex());
        this.childNodes.set(v0_1.intValue(), arg5);
        arg5.parentNode = this;
        arg5.setSiblingIndex(v0_1.intValue());
        arg4.parentNode = null;
    }

    public void replaceWith(Node arg2) {
        Validate.notNull(arg2);
        Validate.notNull(this.parentNode);
        this.parentNode.replaceChild(this, arg2);
    }

    public void setBaseUri(String arg2) {
        Validate.notNull(arg2);
        this.traverse(new Node$1(this, arg2));
    }

    protected void setParentNode(Node arg2) {
        if(this.parentNode != null) {
            this.parentNode.removeChild(this);
        }

        this.parentNode = arg2;
    }

    protected void setSiblingIndex(int arg1) {
        this.siblingIndex = arg1;
    }

    public int siblingIndex() {
        return this.siblingIndex;
    }

    public List siblingNodes() {
        List v0;
        if(this.parentNode == null) {
            v0 = Collections.emptyList();
        }
        else {
            v0 = this.parentNode.childNodes;
            ArrayList v1 = new ArrayList(v0.size() - 1);
            Iterator v2 = v0.iterator();
            while(v2.hasNext()) {
                Object v0_1 = v2.next();
                if((((Node)v0_1)) == this) {
                    continue;
                }

                ((List)v1).add(v0_1);
            }

            ArrayList v0_2 = v1;
        }

        return v0;
    }

    public String toString() {
        return this.outerHtml();
    }

    public Node traverse(NodeVisitor arg2) {
        Validate.notNull(arg2);
        new NodeTraversor(arg2).traverse(this);
        return this;
    }

    public Node unwrap() {
        Object v0;
        Validate.notNull(this.parentNode);
        int v1 = this.siblingIndex;
        if(this.childNodes.size() > 0) {
            v0 = this.childNodes.get(0);
        }
        else {
            Node v0_1 = null;
        }

        this.parentNode.addChildren(v1, this.childNodesAsArray());
        this.remove();
        return ((Node)v0);
    }

    public Node wrap(String arg6) {
        Node v0;
        Element v1 = null;
        int v2 = 0;
        Validate.notEmpty(arg6);
        if((this.parent() instanceof Element)) {
            v0 = this.parent();
        }
        else {
            Element v0_1 = v1;
        }

        List v3 = Parser.parseFragment(arg6, ((Element)v0), this.baseUri());
        Object v0_2 = v3.get(0);
        if(v0_2 == null || !(v0_2 instanceof Element)) {
            this = ((Node)v1);
        }
        else {
            v1 = this.getDeepChild(((Element)v0_2));
            this.parentNode.replaceChild(this, ((Node)v0_2));
            v1.addChildren(new Node[]{this});
            if(v3.size() <= 0) {
                return this;
            }

            while(v2 < v3.size()) {
                Object v1_1 = v3.get(v2);
                ((Node)v1_1).parentNode.removeChild(((Node)v1_1));
                ((Element)v0_2).appendChild(((Node)v1_1));
                ++v2;
            }
        }

        return this;
    }
}

