// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.nodes;

import org.jsoup.helper.StringUtil;
import org.jsoup.helper.Validate;

public class TextNode extends Node {
    private static final String TEXT_KEY = "text";
    String text;

    public TextNode(String arg1, String arg2) {
        super();
        this.baseUri = arg2;
        this.text = arg1;
    }

    public String absUrl(String arg2) {
        this.ensureAttributes();
        return super.absUrl(arg2);
    }

    public String attr(String arg2) {
        this.ensureAttributes();
        return super.attr(arg2);
    }

    public Node attr(String arg2, String arg3) {
        this.ensureAttributes();
        return super.attr(arg2, arg3);
    }

    public Attributes attributes() {
        this.ensureAttributes();
        return super.attributes();
    }

    public static TextNode createFromEncoded(String arg2, String arg3) {
        return new TextNode(Entities.unescape(arg2), arg3);
    }

    private void ensureAttributes() {
        if(this.attributes == null) {
            this.attributes = new Attributes();
            this.attributes.put("text", this.text);
        }
    }

    public String getWholeText() {
        String v0 = this.attributes == null ? this.text : this.attributes.get("text");
        return v0;
    }

    public boolean hasAttr(String arg2) {
        this.ensureAttributes();
        return super.hasAttr(arg2);
    }

    public boolean isBlank() {
        return StringUtil.isBlank(this.getWholeText());
    }

    static boolean lastCharIsWhitespace(StringBuilder arg2) {
        boolean v0 = arg2.length() == 0 || arg2.charAt(arg2.length() - 1) != 32 ? false : true;
        return v0;
    }

    public String nodeName() {
        return "#text";
    }

    static String normaliseWhitespace(String arg1) {
        return StringUtil.normaliseWhitespace(arg1);
    }

    void outerHtmlHead(StringBuilder arg3, int arg4, Document$OutputSettings arg5) {
        String v1 = Entities.escape(this.getWholeText(), arg5);
        if((arg5.prettyPrint()) && ((this.parent() instanceof Element)) && !Element.preserveWhitespace(this.parent())) {
            v1 = TextNode.normaliseWhitespace(v1);
        }

        if(arg5.prettyPrint()) {
            if(this.siblingIndex() != 0 || !(this.parentNode instanceof Element) || !this.parentNode.tag().formatAsBlock() || (this.isBlank())) {
                if(!arg5.outline()) {
                }
                else if(this.siblingNodes().size() <= 0) {
                }
                else if(!this.isBlank()) {
                    goto label_32;
                }

                goto label_33;
            }

        label_32:
            this.indent(arg3, arg4, arg5);
        }

    label_33:
        arg3.append(v1);
    }

    void outerHtmlTail(StringBuilder arg1, int arg2, Document$OutputSettings arg3) {
    }

    public Node removeAttr(String arg2) {
        this.ensureAttributes();
        return super.removeAttr(arg2);
    }

    public TextNode splitText(int arg6) {
        boolean v0 = arg6 >= 0 ? true : false;
        Validate.isTrue(v0, "Split offset must be not be negative");
        v0 = arg6 < this.text.length() ? true : false;
        Validate.isTrue(v0, "Split offset must not be greater than current text length");
        String v0_1 = this.getWholeText().substring(0, arg6);
        String v3 = this.getWholeText().substring(arg6);
        this.text(v0_1);
        TextNode v0_2 = new TextNode(v3, this.baseUri());
        if(this.parent() != null) {
            this.parent().addChildren(this.siblingIndex() + 1, new Node[]{v0_2});
        }

        return v0_2;
    }

    static String stripLeadingWhitespace(String arg2) {
        return arg2.replaceFirst("^\\s+", "");
    }

    public String text() {
        return TextNode.normaliseWhitespace(this.getWholeText());
    }

    public TextNode text(String arg3) {
        this.text = arg3;
        if(this.attributes != null) {
            this.attributes.put("text", arg3);
        }

        return this;
    }

    public String toString() {
        return this.outerHtml();
    }
}

