// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.parser;

import java.util.Locale;
import org.jsoup.helper.Validate;

class CharacterReader {
    static final char EOF = '\uFFFF';
    private final char[] input;
    private final int length;
    private int mark;
    private int pos;

    CharacterReader(String arg2) {
        super();
        this.pos = 0;
        this.mark = 0;
        Validate.notNull(arg2);
        this.input = arg2.toCharArray();
        this.length = this.input.length;
    }

    void advance() {
        ++this.pos;
    }

    char consume() {
        char v0 = this.isEmpty() ? '\uFFFF' : this.input[this.pos];
        ++this.pos;
        return v0;
    }

    String consumeAsString() {
        char[] v1 = this.input;
        int v2 = this.pos;
        this.pos = v2 + 1;
        return new String(v1, v2, 1);
    }

    String consumeDigitSequence() {
        int v0 = this.pos;
        while(this.pos < this.length) {
            int v1 = this.input[this.pos];
            if(v1 < 48) {
                break;
            }

            if(v1 > 57) {
                break;
            }

            ++this.pos;
        }

        return new String(this.input, v0, this.pos - v0);
    }

    String consumeHexSequence() {
        int v0 = this.pos;
        while(this.pos < this.length) {
            int v1 = this.input[this.pos];
            if((v1 < 48 || v1 > 57) && (v1 < 65 || v1 > 70)) {
                if(v1 < 97) {
                    break;
                }

                if(v1 > 102) {
                    break;
                }
            }

            ++this.pos;
        }

        return new String(this.input, v0, this.pos - v0);
    }

    String consumeLetterSequence() {
        int v0 = this.pos;
        while(this.pos < this.length) {
            int v1 = this.input[this.pos];
            if(v1 < 65 || v1 > 90) {
                if(v1 < 97) {
                }
                else if(v1 <= 122) {
                    goto label_15;
                }

                break;
            }

        label_15:
            ++this.pos;
        }

        return new String(this.input, v0, this.pos - v0);
    }

    String consumeLetterThenDigitSequence() {
        int v1;
        int v0 = this.pos;
        while(this.pos < this.length) {
            v1 = this.input[this.pos];
            if(v1 < 65 || v1 > 90) {
                if(v1 < 97) {
                }
                else if(v1 <= 122) {
                    goto label_15;
                }

                break;
            }

        label_15:
            ++this.pos;
        }

        while(!this.isEmpty()) {
            v1 = this.input[this.pos];
            if(v1 < 48) {
                break;
            }

            if(v1 > 57) {
                break;
            }

            ++this.pos;
        }

        return new String(this.input, v0, this.pos - v0);
    }

    String consumeTo(char arg5) {
        String v0;
        int v1 = this.nextIndexOf(arg5);
        if(v1 != -1) {
            v0 = new String(this.input, this.pos, v1);
            this.pos = v1 + this.pos;
        }
        else {
            v0 = this.consumeToEnd();
        }

        return v0;
    }

    String consumeTo(String arg5) {
        String v0;
        int v1 = this.nextIndexOf(((CharSequence)arg5));
        if(v1 != -1) {
            v0 = new String(this.input, this.pos, v1);
            this.pos = v1 + this.pos;
        }
        else {
            v0 = this.consumeToEnd();
        }

        return v0;
    }

    String consumeToAny(char[] arg5) {
        int v1 = this.pos;
        while(this.pos < this.length) {
            int v0 = 0;
            while(true) {
                if(v0 >= arg5.length) {
                    break;
                }
                else if(this.input[this.pos] != arg5[v0]) {
                    ++v0;
                    continue;
                }

                goto label_12;
            }

            ++this.pos;
        }

    label_12:
        String v0_1 = this.pos > v1 ? new String(this.input, v1, this.pos - v1) : "";
        return v0_1;
    }

    String consumeToEnd() {
        String v0 = new String(this.input, this.pos, this.length - this.pos);
        this.pos = this.length;
        return v0;
    }

    boolean containsIgnoreCase(String arg4) {
        int v2 = -1;
        String v0 = arg4.toLowerCase(Locale.ENGLISH);
        String v1 = arg4.toUpperCase(Locale.ENGLISH);
        boolean v0_1 = this.nextIndexOf(((CharSequence)v0)) > v2 || this.nextIndexOf(((CharSequence)v1)) > v2 ? true : false;
        return v0_1;
    }

    char current() {
        char v0 = this.isEmpty() ? '\uFFFF' : this.input[this.pos];
        return v0;
    }

    boolean isEmpty() {
        boolean v0 = this.pos >= this.length ? true : false;
        return v0;
    }

    void mark() {
        this.mark = this.pos;
    }

    boolean matchConsume(String arg3) {
        boolean v0;
        if(this.matches(arg3)) {
            this.pos += arg3.length();
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    boolean matchConsumeIgnoreCase(String arg3) {
        boolean v0;
        if(this.matchesIgnoreCase(arg3)) {
            this.pos += arg3.length();
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    boolean matches(String arg7) {
        boolean v0 = false;
        int v2 = arg7.length();
        if(v2 <= this.length - this.pos) {
            int v1 = 0;
            while(true) {
                if(v1 >= v2) {
                    break;
                }
                else if(arg7.charAt(v1) == this.input[this.pos + v1]) {
                    ++v1;
                    continue;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    boolean matches(char arg3) {
        boolean v0 = (this.isEmpty()) || this.input[this.pos] != arg3 ? false : true;
        return v0;
    }

    boolean matchesAny(char[] arg6) {
        boolean v0 = false;
        if(!this.isEmpty()) {
            int v2 = this.input[this.pos];
            int v3 = arg6.length;
            int v1 = 0;
            while(v1 < v3) {
                if(arg6[v1] == v2) {
                    v0 = true;
                }
                else {
                    ++v1;
                    continue;
                }

                return v0;
            }
        }

        return v0;
    }

    boolean matchesDigit() {
        boolean v0 = false;
        if(!this.isEmpty()) {
            int v1 = this.input[this.pos];
            if(v1 >= 48 && v1 <= 57) {
                v0 = true;
            }
        }

        return v0;
    }

    boolean matchesIgnoreCase(String arg7) {
        boolean v0 = false;
        int v2 = arg7.length();
        if(v2 <= this.length - this.pos) {
            int v1 = 0;
            while(true) {
                if(v1 >= v2) {
                    break;
                }
                else if(Character.toUpperCase(arg7.charAt(v1)) == Character.toUpperCase(this.input[this.pos + v1])) {
                    ++v1;
                    continue;
                }

                return v0;
            }

            v0 = true;
        }

        return v0;
    }

    boolean matchesLetter() {
        boolean v0 = false;
        if(!this.isEmpty()) {
            int v1 = this.input[this.pos];
            if(v1 < 65 || v1 > 90) {
                if(v1 < 97) {
                }
                else if(v1 <= 122) {
                    goto label_15;
                }

                return v0;
            }

        label_15:
            v0 = true;
        }

        return v0;
    }

    int nextIndexOf(char arg3) {
        int v0 = this.pos;
        while(true) {
            if(v0 >= this.length) {
                return -1;
            }
            else if(arg3 == this.input[v0]) {
                v0 -= this.pos;
            }
            else {
                ++v0;
                continue;
            }

            return v0;
        }

        return -1;
    }

    int nextIndexOf(CharSequence arg8) {
        int v3 = arg8.charAt(0);
        int v0;
        for(v0 = this.pos; v0 < this.length; ++v0) {
            if(v3 != this.input[v0]) {
                do {
                    ++v0;
                    if(v0 < this.length && v3 != this.input[v0]) {
                        continue;
                    }

                    break;
                }
                while(true);
            }

            int v2 = v0 + 1;
            int v4 = arg8.length() + v2 - 1;
            if(v0 < this.length && v4 <= this.length) {
                int v1;
                for(v1 = 1; v2 < v4; ++v1) {
                    if(arg8.charAt(v1) != this.input[v2]) {
                        break;
                    }

                    ++v2;
                }

                if(v2 != v4) {
                    goto label_35;
                }

                return this.pos;
            }

        label_35:
        }

        return -1;
    }

    int pos() {
        return this.pos;
    }

    void rewindToMark() {
        this.pos = this.mark;
    }

    public String toString() {
        return new String(this.input, this.pos, this.length - this.pos);
    }

    void unconsume() {
        --this.pos;
    }
}

