// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.parser;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import org.jsoup.helper.DescendableLinkedList;
import org.jsoup.helper.StringUtil;
import org.jsoup.helper.Validate;
import org.jsoup.nodes.Comment;
import org.jsoup.nodes.DataNode;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.nodes.FormElement;
import org.jsoup.nodes.Node;
import org.jsoup.nodes.TextNode;
import org.jsoup.select.Elements;

class HtmlTreeBuilder extends TreeBuilder {
    private static final String[] TagSearchButton;
    private static final String[] TagSearchEndTags;
    private static final String[] TagSearchList;
    private static final String[] TagSearchSelectScope;
    private static final String[] TagSearchSpecial;
    private static final String[] TagSearchTableScope;
    private static final String[] TagsScriptStyle;
    public static final String[] TagsSearchInScope;
    private boolean baseUriSetFromDoc;
    private Element contextElement;
    private FormElement formElement;
    private DescendableLinkedList formattingElements;
    private boolean fosterInserts;
    private boolean fragmentParsing;
    private boolean framesetOk;
    private Element headElement;
    private HtmlTreeBuilderState originalState;
    private List pendingTableCharacters;
    private HtmlTreeBuilderState state;

    static {
        int v7 = 4;
        int v6 = 3;
        int v5 = 2;
        boolean v0 = !HtmlTreeBuilder.class.desiredAssertionStatus() ? true : false;
        HtmlTreeBuilder.$assertionsDisabled = v0;
        String[] v0_1 = new String[v5];
        v0_1[0] = "script";
        v0_1[1] = "style";
        HtmlTreeBuilder.TagsScriptStyle = v0_1;
        v0_1 = new String[8];
        v0_1[0] = "applet";
        v0_1[1] = "caption";
        v0_1[v5] = "html";
        v0_1[v6] = "table";
        v0_1[v7] = "td";
        v0_1[5] = "th";
        v0_1[6] = "marquee";
        v0_1[7] = "object";
        HtmlTreeBuilder.TagsSearchInScope = v0_1;
        v0_1 = new String[v5];
        v0_1[0] = "ol";
        v0_1[1] = "ul";
        HtmlTreeBuilder.TagSearchList = v0_1;
        HtmlTreeBuilder.TagSearchButton = new String[]{"button"};
        v0_1 = new String[v5];
        v0_1[0] = "html";
        v0_1[1] = "table";
        HtmlTreeBuilder.TagSearchTableScope = v0_1;
        v0_1 = new String[v5];
        v0_1[0] = "optgroup";
        v0_1[1] = "option";
        HtmlTreeBuilder.TagSearchSelectScope = v0_1;
        v0_1 = new String[8];
        v0_1[0] = "dd";
        v0_1[1] = "dt";
        v0_1[v5] = "li";
        v0_1[v6] = "option";
        v0_1[v7] = "optgroup";
        v0_1[5] = "p";
        v0_1[6] = "rp";
        v0_1[7] = "rt";
        HtmlTreeBuilder.TagSearchEndTags = v0_1;
        v0_1 = new String[79];
        v0_1[0] = "address";
        v0_1[1] = "applet";
        v0_1[v5] = "area";
        v0_1[v6] = "article";
        v0_1[v7] = "aside";
        v0_1[5] = "base";
        v0_1[6] = "basefont";
        v0_1[7] = "bgsound";
        v0_1[8] = "blockquote";
        v0_1[9] = "body";
        v0_1[10] = "br";
        v0_1[11] = "button";
        v0_1[12] = "caption";
        v0_1[13] = "center";
        v0_1[14] = "col";
        v0_1[15] = "colgroup";
        v0_1[16] = "command";
        v0_1[17] = "dd";
        v0_1[18] = "details";
        v0_1[19] = "dir";
        v0_1[20] = "div";
        v0_1[21] = "dl";
        v0_1[22] = "dt";
        v0_1[23] = "embed";
        v0_1[24] = "fieldset";
        v0_1[25] = "figcaption";
        v0_1[26] = "figure";
        v0_1[27] = "footer";
        v0_1[28] = "form";
        v0_1[29] = "frame";
        v0_1[30] = "frameset";
        v0_1[31] = "h1";
        v0_1[32] = "h2";
        v0_1[33] = "h3";
        v0_1[34] = "h4";
        v0_1[35] = "h5";
        v0_1[36] = "h6";
        v0_1[37] = "head";
        v0_1[38] = "header";
        v0_1[39] = "hgroup";
        v0_1[40] = "hr";
        v0_1[41] = "html";
        v0_1[42] = "iframe";
        v0_1[43] = "img";
        v0_1[44] = "input";
        v0_1[45] = "isindex";
        v0_1[46] = "li";
        v0_1[47] = "link";
        v0_1[48] = "listing";
        v0_1[49] = "marquee";
        v0_1[50] = "menu";
        v0_1[51] = "meta";
        v0_1[52] = "nav";
        v0_1[53] = "noembed";
        v0_1[54] = "noframes";
        v0_1[55] = "noscript";
        v0_1[56] = "object";
        v0_1[57] = "ol";
        v0_1[58] = "p";
        v0_1[59] = "param";
        v0_1[60] = "plaintext";
        v0_1[61] = "pre";
        v0_1[62] = "script";
        v0_1[63] = "section";
        v0_1[64] = "select";
        v0_1[65] = "style";
        v0_1[66] = "summary";
        v0_1[67] = "table";
        v0_1[68] = "tbody";
        v0_1[69] = "td";
        v0_1[70] = "textarea";
        v0_1[71] = "tfoot";
        v0_1[72] = "th";
        v0_1[73] = "thead";
        v0_1[74] = "title";
        v0_1[75] = "tr";
        v0_1[76] = "ul";
        v0_1[77] = "wbr";
        v0_1[78] = "xmp";
        HtmlTreeBuilder.TagSearchSpecial = v0_1;
    }

    HtmlTreeBuilder() {
        super();
        this.baseUriSetFromDoc = false;
        this.formattingElements = new DescendableLinkedList();
        this.pendingTableCharacters = new ArrayList();
        this.framesetOk = true;
        this.fosterInserts = false;
        this.fragmentParsing = false;
    }

    Element aboveOnStack(Element arg3) {
        if(!HtmlTreeBuilder.$assertionsDisabled && !this.onStack(arg3)) {
            throw new AssertionError();
        }

        Iterator v1 = this.stack.descendingIterator();
        do {
            if(v1.hasNext()) {
                if(v1.next() != arg3) {
                    continue;
                }

                break;
            }
            else {
                goto label_15;
            }
        }
        while(true);

        Object v0 = v1.next();
        goto label_14;
    label_15:
        Element v0_1 = null;
    label_14:
        return ((Element)v0);
    }

    void clearFormattingElementsToLastMarker() {
        do {
            if(this.formattingElements.isEmpty()) {
                return;
            }

            Object v0 = this.formattingElements.peekLast();
            this.formattingElements.removeLast();
        }
        while(v0 != null);
    }

    private void clearStackToContext(String[] arg4) {
        Iterator v1 = this.stack.descendingIterator();
        while(v1.hasNext()) {
            Object v0 = v1.next();
            if(StringUtil.in(((Element)v0).nodeName(), arg4)) {
                return;
            }

            if(((Element)v0).nodeName().equals("html")) {
                return;
            }

            v1.remove();
        }
    }

    void clearStackToTableBodyContext() {
        this.clearStackToContext(new String[]{"tbody", "tfoot", "thead"});
    }

    void clearStackToTableContext() {
        this.clearStackToContext(new String[]{"table"});
    }

    void clearStackToTableRowContext() {
        this.clearStackToContext(new String[]{"tr"});
    }

    void error(HtmlTreeBuilderState arg8) {
        if(this.errors.canAddError()) {
            this.errors.add(new ParseError(this.reader.pos(), "Unexpected token [%s] when in state [%s]", new Object[]{this.currentToken.tokenType(), arg8}));
        }
    }

    void framesetOk(boolean arg1) {
        this.framesetOk = arg1;
    }

    boolean framesetOk() {
        return this.framesetOk;
    }

    void generateImpliedEndTags() {
        this.generateImpliedEndTags(null);
    }

    void generateImpliedEndTags(String arg3) {
        while(arg3 != null) {
            if(this.currentElement().nodeName().equals(arg3)) {
                return;
            }

            if(!StringUtil.in(this.currentElement().nodeName(), HtmlTreeBuilder.TagSearchEndTags)) {
                return;
            }

            this.pop();
        }
    }

    Element getActiveFormattingElement(String arg4) {
        Element v0_1;
        Iterator v1 = this.formattingElements.descendingIterator();
        do {
            if(v1.hasNext()) {
                Object v0 = v1.next();
                if(v0 != null) {
                    if(!((Element)v0).nodeName().equals(arg4)) {
                        continue;
                    }

                    return v0_1;
                }
                else {
                    goto label_6;
                }
            }
            else {
                goto label_6;
            }

            return v0_1;
        }
        while(true);

        return v0_1;
    label_6:
        v0_1 = null;
        return v0_1;
    }

    String getBaseUri() {
        return this.baseUri;
    }

    Document getDocument() {
        return this.doc;
    }

    FormElement getFormElement() {
        return this.formElement;
    }

    Element getFromStack(String arg4) {
        Object v0;
        Iterator v1 = this.stack.descendingIterator();
        do {
            if(v1.hasNext()) {
                v0 = v1.next();
                if(!((Element)v0).nodeName().equals(arg4)) {
                    continue;
                }
            }
            else {
                break;
            }

            goto label_8;
        }
        while(true);

        Element v0_1 = null;
    label_8:
        return ((Element)v0);
    }

    Element getHeadElement() {
        return this.headElement;
    }

    List getPendingTableCharacters() {
        return this.pendingTableCharacters;
    }

    DescendableLinkedList getStack() {
        return this.stack;
    }

    boolean inButtonScope(String arg2) {
        return this.inScope(arg2, HtmlTreeBuilder.TagSearchButton);
    }

    boolean inListItemScope(String arg2) {
        return this.inScope(arg2, HtmlTreeBuilder.TagSearchList);
    }

    boolean inScope(String arg2, String[] arg3) {
        return this.inSpecificScope(arg2, HtmlTreeBuilder.TagsSearchInScope, arg3);
    }

    boolean inScope(String arg2) {
        return this.inScope(arg2, null);
    }

    boolean inScope(String[] arg3) {
        return this.inSpecificScope(arg3, HtmlTreeBuilder.TagsSearchInScope, null);
    }

    boolean inSelectScope(String arg5) {
        boolean v0_1;
        Iterator v2 = this.stack.descendingIterator();
        do {
            if(v2.hasNext()) {
                String v0 = v2.next().nodeName();
                if(v0.equals(arg5)) {
                    v0_1 = true;
                }
                else {
                    if(StringUtil.in(v0, HtmlTreeBuilder.TagSearchSelectScope)) {
                        continue;
                    }

                    return false;
                }
            }
            else {
                goto label_16;
            }

            return v0_1;
        }
        while(true);

        return false;
    label_16:
        Validate.fail("Should not be reachable");
        return false;
    }

    private boolean inSpecificScope(String arg3, String[] arg4, String[] arg5) {
        return this.inSpecificScope(new String[]{arg3}, arg4, arg5);
    }

    private boolean inSpecificScope(String[] arg5, String[] arg6, String[] arg7) {
        boolean v0_1;
        Iterator v2 = this.stack.descendingIterator();
        do {
            if(v2.hasNext()) {
                String v0 = v2.next().nodeName();
                if(StringUtil.in(v0, arg5)) {
                    v0_1 = true;
                }
                else if(StringUtil.in(v0, arg6)) {
                    v0_1 = false;
                }
                else {
                    if(arg7 == null) {
                        continue;
                    }

                    if(!StringUtil.in(v0, arg7)) {
                        continue;
                    }

                    return false;
                }
            }
            else {
                goto label_20;
            }

            return v0_1;
        }
        while(true);

        return false;
    label_20:
        Validate.fail("Should not be reachable");
        return false;
    }

    boolean inTableScope(String arg3) {
        return this.inSpecificScope(arg3, HtmlTreeBuilder.TagSearchTableScope, null);
    }

    Element insert(String arg4) {
        Element v0 = new Element(Tag.valueOf(arg4), this.baseUri);
        this.insert(v0);
        return v0;
    }

    void insert(Element arg2) {
        this.insertNode(((Node)arg2));
        this.stack.add(arg2);
    }

    Element insert(Token$StartTag arg5) {
        Element v0;
        if(arg5.isSelfClosing()) {
            v0 = this.insertEmpty(arg5);
            this.stack.add(v0);
            this.tokeniser.transition(TokeniserState.Data);
            this.tokeniser.emit(new Token$EndTag(v0.tagName()));
        }
        else {
            v0 = new Element(Tag.valueOf(arg5.name()), this.baseUri, arg5.attributes);
            this.insert(v0);
        }

        return v0;
    }

    void insert(Token$Character arg4) {
        DataNode v0;
        if(StringUtil.in(this.currentElement().tagName(), HtmlTreeBuilder.TagsScriptStyle)) {
            v0 = new DataNode(arg4.getData(), this.baseUri);
        }
        else {
            TextNode v0_1 = new TextNode(arg4.getData(), this.baseUri);
        }

        this.currentElement().appendChild(((Node)v0));
    }

    void insert(Token$Comment arg4) {
        this.insertNode(new Comment(arg4.getData(), this.baseUri));
    }

    Element insertEmpty(Token$StartTag arg5) {
        Tag v0 = Tag.valueOf(arg5.name());
        Element v1 = new Element(v0, this.baseUri, arg5.attributes);
        this.insertNode(((Node)v1));
        if(arg5.isSelfClosing()) {
            if(!v0.isKnownTag()) {
                v0.setSelfClosing();
                this.tokeniser.acknowledgeSelfClosingFlag();
            }
            else if(v0.isSelfClosing()) {
                this.tokeniser.acknowledgeSelfClosingFlag();
            }
        }

        return v1;
    }

    FormElement insertForm(Token$StartTag arg5, boolean arg6) {
        FormElement v1 = new FormElement(Tag.valueOf(arg5.name()), this.baseUri, arg5.attributes);
        this.setFormElement(v1);
        this.insertNode(((Node)v1));
        if(arg6) {
            this.stack.add(v1);
        }

        return v1;
    }

    void insertInFosterParent(Node arg5) {
        int v0;
        Element v1;
        Element v2 = this.getFromStack("table");
        if(v2 == null) {
            Object v1_1 = this.stack.get(0);
            v0 = 0;
        }
        else if(v2.parent() != null) {
            v1 = v2.parent();
            v0 = 1;
        }
        else {
            v1 = this.aboveOnStack(v2);
            v0 = 0;
        }

        if(v0 != 0) {
            Validate.notNull(v2);
            v2.before(arg5);
        }
        else {
            v1.appendChild(arg5);
        }
    }

    void insertMarkerToFormattingElements() {
        this.formattingElements.add(null);
    }

    private void insertNode(Node arg2) {
        if(this.stack.size() == 0) {
            this.doc.appendChild(arg2);
        }
        else if(this.isFosterInserts()) {
            this.insertInFosterParent(arg2);
        }
        else {
            this.currentElement().appendChild(arg2);
        }

        if(((arg2 instanceof Element)) && (arg2.tag().isFormListed()) && this.formElement != null) {
            this.formElement.addElement(((Element)arg2));
        }
    }

    void insertOnStackAfter(Element arg3, Element arg4) {
        int v1 = this.stack.lastIndexOf(arg3);
        boolean v0 = v1 != -1 ? true : false;
        Validate.isTrue(v0);
        this.stack.add(v1 + 1, arg4);
    }

    private boolean isElementInQueue(DescendableLinkedList arg3, Element arg4) {
        Iterator v1 = arg3.descendingIterator();
        do {
            if(v1.hasNext()) {
                if(v1.next() != arg4) {
                    continue;
                }

                break;
            }
            else {
                return false;
            }
        }
        while(true);

        boolean v0 = true;
        return v0;
    }

    boolean isFosterInserts() {
        return this.fosterInserts;
    }

    boolean isFragmentParsing() {
        return this.fragmentParsing;
    }

    boolean isInActiveFormattingElements(Element arg2) {
        return this.isElementInQueue(this.formattingElements, arg2);
    }

    private boolean isSameFormattingElement(Element arg3, Element arg4) {
        boolean v0 = !arg3.nodeName().equals(arg4.nodeName()) || !arg3.attributes().equals(arg4.attributes()) ? false : true;
        return v0;
    }

    boolean isSpecial(Element arg3) {
        return StringUtil.in(arg3.nodeName(), HtmlTreeBuilder.TagSearchSpecial);
    }

    void markInsertionMode() {
        this.originalState = this.state;
    }

    void maybeSetBaseUri(Element arg3) {
        if(!this.baseUriSetFromDoc) {
            String v0 = arg3.absUrl("href");
            if(v0.length() != 0) {
                this.baseUri = v0;
                this.baseUriSetFromDoc = true;
                this.doc.setBaseUri(v0);
            }
        }
    }

    void newPendingTableCharacters() {
        this.pendingTableCharacters = new ArrayList();
    }

    boolean onStack(Element arg2) {
        return this.isElementInQueue(this.stack, arg2);
    }

    HtmlTreeBuilderState originalState() {
        return this.originalState;
    }

    Document parse(String arg2, String arg3, ParseErrorList arg4) {
        this.state = HtmlTreeBuilderState.Initial;
        return super.parse(arg2, arg3, arg4);
    }

    List parseFragment(String arg7, Element arg8, String arg9, ParseErrorList arg10) {
        Object v0_3;
        int v5 = 2;
        this.state = HtmlTreeBuilderState.Initial;
        this.initialiseParse(arg7, arg9, arg10);
        this.contextElement = arg8;
        this.fragmentParsing = true;
        Element v0 = null;
        if(arg8 != null) {
            if(arg8.ownerDocument() != null) {
                this.doc.quirksMode(arg8.ownerDocument().quirksMode());
            }

            String v0_1 = arg8.tagName();
            String[] v1 = new String[v5];
            v1[0] = "title";
            v1[1] = "textarea";
            if(StringUtil.in(v0_1, v1)) {
                this.tokeniser.transition(TokeniserState.Rcdata);
            }
            else {
                v1 = new String[5];
                v1[0] = "iframe";
                v1[1] = "noembed";
                v1[v5] = "noframes";
                v1[3] = "style";
                v1[4] = "xmp";
                if(StringUtil.in(v0_1, v1)) {
                    this.tokeniser.transition(TokeniserState.Rawtext);
                }
                else if(v0_1.equals("script")) {
                    this.tokeniser.transition(TokeniserState.ScriptData);
                }
                else if(v0_1.equals("noscript")) {
                    this.tokeniser.transition(TokeniserState.Data);
                }
                else if(v0_1.equals("plaintext")) {
                    this.tokeniser.transition(TokeniserState.Data);
                }
                else {
                    this.tokeniser.transition(TokeniserState.Data);
                }
            }

            Element v1_1 = new Element(Tag.valueOf("html"), arg9);
            this.doc.appendChild(((Node)v1_1));
            this.stack.push(v1_1);
            this.resetInsertionMode();
            Elements v0_2 = arg8.parents();
            v0_2.add(0, arg8);
            Iterator v2 = v0_2.iterator();
            do {
                if(!v2.hasNext()) {
                    goto label_98;
                }

                v0_3 = v2.next();
            }
            while(!(v0_3 instanceof FormElement));

            this.formElement = ((FormElement)v0_3);
            v0 = v1_1;
            goto label_46;
        label_98:
            v0 = v1_1;
        }

    label_46:
        this.runParser();
        List v0_4 = arg8 != null ? v0.childNodes() : this.doc.childNodes();
        return v0_4;
    }

    Element pop() {
        if((this.stack.peekLast().nodeName().equals("td")) && !this.state.name().equals("InCell")) {
            Validate.isFalse(true, "pop td not in cell");
        }

        if(this.stack.peekLast().nodeName().equals("html")) {
            Validate.isFalse(true, "popping html!");
        }

        return this.stack.pollLast();
    }

    void popStackToBefore(String arg3) {
        Iterator v1 = this.stack.descendingIterator();
        while(v1.hasNext()) {
            if(v1.next().nodeName().equals(arg3)) {
                return;
            }

            v1.remove();
        }
    }

    void popStackToClose(String arg3) {
        Iterator v1 = this.stack.descendingIterator();
        while(v1.hasNext()) {
            if(v1.next().nodeName().equals(arg3)) {
                v1.remove();
            }
            else {
                v1.remove();
                continue;
            }

            return;
        }
    }

    void popStackToClose(String[] arg3) {
        Iterator v1 = this.stack.descendingIterator();
        while(v1.hasNext()) {
            if(StringUtil.in(v1.next().nodeName(), arg3)) {
                v1.remove();
            }
            else {
                v1.remove();
                continue;
            }

            return;
        }
    }

    protected boolean process(Token arg2) {
        this.currentToken = arg2;
        return this.state.process(arg2, this);
    }

    boolean process(Token arg2, HtmlTreeBuilderState arg3) {
        this.currentToken = arg2;
        return arg3.process(arg2, this);
    }

    void push(Element arg2) {
        this.stack.add(arg2);
    }

    void pushActiveFormattingElements(Element arg4) {
        Iterator v2 = this.formattingElements.descendingIterator();
        int v1;
        for(v1 = 0; v2.hasNext(); v1 = v0_1) {
            Object v0 = v2.next();
            if(v0 == null) {
                break;
            }

            int v0_1 = this.isSameFormattingElement(arg4, ((Element)v0)) ? v1 + 1 : v1;
            if(v0_1 == 3) {
                v2.remove();
                break;
            }
        }

        this.formattingElements.add(arg4);
    }

    void reconstructFormattingElements() {
        int v0_1;
        Object v1_1;
        int v7;
        int v2_1;
        Object v0;
        int v4 = this.formattingElements.size();
        if(v4 != 0 && this.formattingElements.getLast() != null && !this.onStack(this.formattingElements.getLast())) {
            int v1 = v4 - 1;
            Object v2 = this.formattingElements.getLast();
            while(true) {
                if(v1 != 0) {
                    --v1;
                    v0 = this.formattingElements.get(v1);
                    if(v0 == null) {
                        break;
                    }
                    else if(this.onStack(((Element)v0))) {
                        v2_1 = 0;
                        v7 = v1;
                        v1_1 = v0;
                        v0_1 = v7;
                    }
                    else {
                        v2 = v0;
                        continue;
                    }
                }
                else {
                    goto label_17;
                }

                goto label_22;
            }

            v2_1 = 0;
            v7 = v1;
            v1_1 = v0;
            v0_1 = v7;
            goto label_22;
        label_17:
            v0_1 = v1;
            v1_1 = v2;
            for(v2_1 = 1; true; v2_1 = 0) {
            label_22:
                if(v2_1 == 0) {
                    v1 = v0_1 + 1;
                    v7 = v1;
                    v1_1 = this.formattingElements.get(v1);
                    v0_1 = v7;
                }

                Validate.notNull(v1_1);
                Element v2_2 = this.insert(((Element)v1_1).nodeName());
                v2_2.attributes().addAll(((Element)v1_1).attributes());
                this.formattingElements.add(v0_1, v2_2);
                this.formattingElements.remove(v0_1 + 1);
                if(v0_1 == v4 - 1) {
                    return;
                }
            }
        }
    }

    void removeFromActiveFormattingElements(Element arg3) {
        Iterator v1 = this.formattingElements.descendingIterator();
        do {
            if(v1.hasNext()) {
                if(v1.next() != arg3) {
                    continue;
                }

                break;
            }

            return;
        }
        while(true);

        v1.remove();
    }

    boolean removeFromStack(Element arg3) {
        Iterator v1 = this.stack.descendingIterator();
        do {
            if(v1.hasNext()) {
                if(v1.next() != arg3) {
                    continue;
                }

                break;
            }
            else {
                return false;
            }
        }
        while(true);

        v1.remove();
        boolean v0 = true;
        return v0;
    }

    void replaceActiveFormattingElement(Element arg2, Element arg3) {
        this.replaceInQueue(this.formattingElements, arg2, arg3);
    }

    private void replaceInQueue(LinkedList arg3, Element arg4, Element arg5) {
        int v1 = arg3.lastIndexOf(arg4);
        boolean v0 = v1 != -1 ? true : false;
        Validate.isTrue(v0);
        arg3.remove(v1);
        arg3.add(v1, arg5);
    }

    void replaceOnStack(Element arg2, Element arg3) {
        this.replaceInQueue(this.stack, arg2, arg3);
    }

    void resetInsertionMode() {
        Object v1_2;
        int v0_1;
        Iterator v2 = this.stack.descendingIterator();
        int v1 = 0;
        while(true) {
            if(v2.hasNext()) {
                Object v0 = v2.next();
                if(!v2.hasNext()) {
                    v0_1 = 1;
                    Element v1_1 = this.contextElement;
                }
                else {
                    Object v4 = v0;
                    v0_1 = v1;
                    v1_2 = v4;
                }

                String v1_3 = ((Element)v1_2).nodeName();
                if("select".equals(v1_3)) {
                    this.transition(HtmlTreeBuilderState.InSelect);
                    return;
                }

                if(!"td".equals(v1_3)) {
                    if(("td".equals(v1_3)) && v0_1 == 0) {
                        goto label_28;
                    }

                    if("tr".equals(v1_3)) {
                        this.transition(HtmlTreeBuilderState.InRow);
                        return;
                    }

                    if(!"tbody".equals(v1_3) && !"thead".equals(v1_3) && !"tfoot".equals(v1_3)) {
                        if("caption".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.InCaption);
                            return;
                        }
                        else if("colgroup".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.InColumnGroup);
                            return;
                        }
                        else if("table".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.InTable);
                            return;
                        }
                        else if("head".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.InBody);
                            return;
                        }
                        else if("body".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.InBody);
                            return;
                        }
                        else if("frameset".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.InFrameset);
                            return;
                        }
                        else if("html".equals(v1_3)) {
                            this.transition(HtmlTreeBuilderState.BeforeHead);
                            return;
                        }
                        else if(v0_1 != 0) {
                            this.transition(HtmlTreeBuilderState.InBody);
                            return;
                        }
                        else {
                            v1 = v0_1;
                            continue;
                        }
                    }

                    break;
                }

                goto label_28;
            }

            return;
        }

        this.transition(HtmlTreeBuilderState.InTableBody);
        return;
    label_28:
        this.transition(HtmlTreeBuilderState.InCell);
    }

    void setFormElement(FormElement arg1) {
        this.formElement = arg1;
    }

    void setFosterInserts(boolean arg1) {
        this.fosterInserts = arg1;
    }

    void setHeadElement(Element arg1) {
        this.headElement = arg1;
    }

    void setPendingTableCharacters(List arg1) {
        this.pendingTableCharacters = arg1;
    }

    HtmlTreeBuilderState state() {
        return this.state;
    }

    public String toString() {
        return "TreeBuilder{currentToken=" + this.currentToken + ", state=" + this.state + ", currentElement=" + this.currentElement() + '}';
    }

    void transition(HtmlTreeBuilderState arg1) {
        this.state = arg1;
    }
}

