// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.parser;

import java.util.List;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.nodes.Node;

public class Parser {
    private static final int DEFAULT_MAX_ERRORS;
    private ParseErrorList errors;
    private int maxErrors;
    private TreeBuilder treeBuilder;

    public Parser(TreeBuilder arg2) {
        super();
        this.maxErrors = 0;
        this.treeBuilder = arg2;
    }

    public List getErrors() {
        return this.errors;
    }

    public TreeBuilder getTreeBuilder() {
        return this.treeBuilder;
    }

    public static Parser htmlParser() {
        return new Parser(new HtmlTreeBuilder());
    }

    public boolean isTrackErrors() {
        boolean v0 = this.maxErrors > 0 ? true : false;
        return v0;
    }

    public static Document parse(String arg2, String arg3) {
        return new HtmlTreeBuilder().parse(arg2, arg3, ParseErrorList.noTracking());
    }

    public static Document parseBodyFragment(String arg6, String arg7) {
        Document v2 = Document.createShell(arg7);
        Element v3 = v2.body();
        List v0 = Parser.parseFragment(arg6, v3, arg7);
        Object[] v0_1 = v0.toArray(new Node[v0.size()]);
        int v4 = v0_1.length;
        int v1;
        for(v1 = 0; v1 < v4; ++v1) {
            v3.appendChild(v0_1[v1]);
        }

        return v2;
    }

    public static Document parseBodyFragmentRelaxed(String arg1, String arg2) {
        return Parser.parse(arg1, arg2);
    }

    public static List parseFragment(String arg2, Element arg3, String arg4) {
        return new HtmlTreeBuilder().parseFragment(arg2, arg3, arg4, ParseErrorList.noTracking());
    }

    public Document parseInput(String arg3, String arg4) {
        ParseErrorList v0 = this.isTrackErrors() ? ParseErrorList.tracking(this.maxErrors) : ParseErrorList.noTracking();
        this.errors = v0;
        return this.treeBuilder.parse(arg3, arg4, this.errors);
    }

    public static List parseXmlFragment(String arg2, String arg3) {
        return new XmlTreeBuilder().parseFragment(arg2, arg3, ParseErrorList.noTracking());
    }

    public Parser setTrackErrors(int arg1) {
        this.maxErrors = arg1;
        return this;
    }

    public Parser setTreeBuilder(TreeBuilder arg1) {
        this.treeBuilder = arg1;
        return this;
    }

    public static String unescapeEntities(String arg3, boolean arg4) {
        return new Tokeniser(new CharacterReader(arg3), ParseErrorList.noTracking()).unescapeEntities(arg4);
    }

    public static Parser xmlParser() {
        return new Parser(new XmlTreeBuilder());
    }
}

