// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.parser;

import java.util.HashMap;
import java.util.Map;
import org.jsoup.helper.Validate;

public class Tag {
    private static final String[] blockTags;
    private boolean canContainBlock;
    private boolean canContainInline;
    private boolean empty;
    private static final String[] emptyTags;
    private boolean formList;
    private static final String[] formListedTags;
    private boolean formSubmit;
    private static final String[] formSubmitTags;
    private boolean formatAsBlock;
    private static final String[] formatAsInlineTags;
    private static final String[] inlineTags;
    private boolean isBlock;
    private boolean preserveWhitespace;
    private static final String[] preserveWhitespaceTags;
    private boolean selfClosing;
    private String tagName;
    private static final Map tags;

    static {
        Object v0_1;
        int v1 = 0;
        Tag.tags = new HashMap();
        Tag.blockTags = new String[]{"html", "head", "body", "frameset", "script", "noscript", "style", "meta", "link", "title", "frame", "noframes", "section", "nav", "aside", "hgroup", "header", "footer", "p", "h1", "h2", "h3", "h4", "h5", "h6", "ul", "ol", "pre", "div", "blockquote", "hr", "address", "figure", "figcaption", "form", "fieldset", "ins", "del", "s", "dl", "dt", "dd", "li", "table", "caption", "thead", "tfoot", "tbody", "colgroup", "col", "tr", "th", "td", "video", "audio", "canvas", "details", "menu", "plaintext"};
        Tag.inlineTags = new String[]{"object", "base", "font", "tt", "i", "b", "u", "big", "small", "em", "strong", "dfn", "code", "samp", "kbd", "var", "cite", "abbr", "time", "acronym", "mark", "ruby", "rt", "rp", "a", "img", "br", "wbr", "map", "q", "sub", "sup", "bdo", "iframe", "embed", "span", "input", "select", "textarea", "label", "button", "optgroup", "option", "legend", "datalist", "keygen", "output", "progress", "meter", "area", "param", "source", "track", "summary", "command", "device"};
        Tag.emptyTags = new String[]{"meta", "link", "base", "frame", "img", "br", "wbr", "embed", "hr", "input", "keygen", "col", "command", "device"};
        Tag.formatAsInlineTags = new String[]{"title", "a", "p", "h1", "h2", "h3", "h4", "h5", "h6", "pre", "address", "li", "th", "td", "script", "style", "ins", "del", "s"};
        Tag.preserveWhitespaceTags = new String[]{"pre", "plaintext", "title", "textarea"};
        Tag.formListedTags = new String[]{"button", "fieldset", "input", "keygen", "object", "output", "select", "textarea"};
        Tag.formSubmitTags = new String[]{"input", "keygen", "object", "select", "textarea"};
        String[] v2 = Tag.blockTags;
        int v3 = v2.length;
        int v0;
        for(v0 = 0; v0 < v3; ++v0) {
            Tag.register(new Tag(v2[v0]));
        }

        v2 = Tag.inlineTags;
        v3 = v2.length;
        for(v0 = 0; v0 < v3; ++v0) {
            Tag v5 = new Tag(v2[v0]);
            v5.isBlock = false;
            v5.canContainBlock = false;
            v5.formatAsBlock = false;
            Tag.register(v5);
        }

        String[] v3_1 = Tag.emptyTags;
        int v4 = v3_1.length;
        int v2_1;
        for(v2_1 = 0; v2_1 < v4; ++v2_1) {
            v0_1 = Tag.tags.get(v3_1[v2_1]);
            Validate.notNull(v0_1);
            ((Tag)v0_1).canContainBlock = false;
            ((Tag)v0_1).canContainInline = false;
            ((Tag)v0_1).empty = true;
        }

        v3_1 = Tag.formatAsInlineTags;
        v4 = v3_1.length;
        for(v2_1 = 0; v2_1 < v4; ++v2_1) {
            v0_1 = Tag.tags.get(v3_1[v2_1]);
            Validate.notNull(v0_1);
            ((Tag)v0_1).formatAsBlock = false;
        }

        v3_1 = Tag.preserveWhitespaceTags;
        v4 = v3_1.length;
        for(v2_1 = 0; v2_1 < v4; ++v2_1) {
            v0_1 = Tag.tags.get(v3_1[v2_1]);
            Validate.notNull(v0_1);
            ((Tag)v0_1).preserveWhitespace = true;
        }

        v3_1 = Tag.formListedTags;
        v4 = v3_1.length;
        for(v2_1 = 0; v2_1 < v4; ++v2_1) {
            v0_1 = Tag.tags.get(v3_1[v2_1]);
            Validate.notNull(v0_1);
            ((Tag)v0_1).formList = true;
        }

        v2 = Tag.formSubmitTags;
        v3 = v2.length;
        while(v1 < v3) {
            v0_1 = Tag.tags.get(v2[v1]);
            Validate.notNull(v0_1);
            ((Tag)v0_1).formSubmit = true;
            ++v1;
        }
    }

    private Tag(String arg3) {
        super();
        this.isBlock = true;
        this.formatAsBlock = true;
        this.canContainBlock = true;
        this.canContainInline = true;
        this.empty = false;
        this.selfClosing = false;
        this.preserveWhitespace = false;
        this.formList = false;
        this.formSubmit = false;
        this.tagName = arg3.toLowerCase();
    }

    public boolean canContainBlock() {
        return this.canContainBlock;
    }

    public boolean equals(Object arg5) {
        boolean v0 = true;
        if(this != (((Tag)arg5))) {
            if(!(arg5 instanceof Tag)) {
                v0 = false;
            }
            else if(this.canContainBlock != ((Tag)arg5).canContainBlock) {
                v0 = false;
            }
            else if(this.canContainInline != ((Tag)arg5).canContainInline) {
                v0 = false;
            }
            else if(this.empty != ((Tag)arg5).empty) {
                v0 = false;
            }
            else if(this.formatAsBlock != ((Tag)arg5).formatAsBlock) {
                v0 = false;
            }
            else if(this.isBlock != ((Tag)arg5).isBlock) {
                v0 = false;
            }
            else if(this.preserveWhitespace != ((Tag)arg5).preserveWhitespace) {
                v0 = false;
            }
            else if(this.selfClosing != ((Tag)arg5).selfClosing) {
                v0 = false;
            }
            else if(this.formList != ((Tag)arg5).formList) {
                v0 = false;
            }
            else if(this.formSubmit != ((Tag)arg5).formSubmit) {
                v0 = false;
            }
            else if(!this.tagName.equals(((Tag)arg5).tagName)) {
                v0 = false;
            }
        }

        return v0;
    }

    public boolean formatAsBlock() {
        return this.formatAsBlock;
    }

    public String getName() {
        return this.tagName;
    }

    public int hashCode() {
        int v1 = 1;
        int v3 = this.tagName.hashCode() * 31;
        int v0 = this.isBlock ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.formatAsBlock ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.canContainBlock ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.canContainInline ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.empty ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.selfClosing ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.preserveWhitespace ? 1 : 0;
        v3 = (v0 + v3) * 31;
        v0 = this.formList ? 1 : 0;
        v0 = (v0 + v3) * 31;
        if(!this.formSubmit) {
            v1 = 0;
        }

        return v0 + v1;
    }

    public boolean isBlock() {
        return this.isBlock;
    }

    public boolean isData() {
        boolean v0 = (this.canContainInline) || (this.isEmpty()) ? false : true;
        return v0;
    }

    public boolean isEmpty() {
        return this.empty;
    }

    public boolean isFormListed() {
        return this.formList;
    }

    public boolean isFormSubmittable() {
        return this.formSubmit;
    }

    public boolean isInline() {
        boolean v0 = !this.isBlock ? true : false;
        return v0;
    }

    public boolean isKnownTag() {
        return Tag.tags.containsKey(this.tagName);
    }

    public static boolean isKnownTag(String arg1) {
        return Tag.tags.containsKey(arg1);
    }

    public boolean isSelfClosing() {
        boolean v0 = (this.empty) || (this.selfClosing) ? true : false;
        return v0;
    }

    public boolean preserveWhitespace() {
        return this.preserveWhitespace;
    }

    private static void register(Tag arg2) {
        Tag.tags.put(arg2.tagName, arg2);
    }

    Tag setSelfClosing() {
        this.selfClosing = true;
        return this;
    }

    public String toString() {
        return this.tagName;
    }

    public static Tag valueOf(String arg2) {
        Tag v0_1;
        Validate.notNull(arg2);
        Object v0 = Tag.tags.get(arg2);
        if(v0 == null) {
            String v1 = arg2.trim().toLowerCase();
            Validate.notEmpty(v1);
            v0 = Tag.tags.get(v1);
            if(v0 == null) {
                v0_1 = new Tag(v1);
                v0_1.isBlock = false;
                v0_1.canContainBlock = true;
            }
        }

        return v0_1;
    }
}

