// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.parser;

import org.jsoup.helper.StringUtil;
import org.jsoup.helper.Validate;

public class TokenQueue {
    private static final char ESC = '\\';
    private int pos;
    private String queue;

    public TokenQueue(String arg2) {
        super();
        this.pos = 0;
        Validate.notNull(arg2);
        this.queue = arg2;
    }

    public void addFirst(Character arg2) {
        this.addFirst(arg2.toString());
    }

    public void addFirst(String arg4) {
        this.queue = arg4 + this.queue.substring(this.pos);
        this.pos = 0;
    }

    public void advance() {
        if(!this.isEmpty()) {
            ++this.pos;
        }
    }

    public String chompBalanced(char arg8, char arg9) {
        int v0 = 0;
        int v3 = -1;
        int v1 = 0;
        int v2 = v3;
        int v4 = v3;
        do {
            if(this.isEmpty()) {
                break;
            }

            Character v5 = Character.valueOf(this.consume());
            if(v0 == 0 || v0 != 92) {
                if(v5.equals(Character.valueOf(arg8))) {
                    ++v1;
                    if(v4 == v3) {
                        v4 = this.pos;
                    }
                }
                else if(v5.equals(Character.valueOf(arg9))) {
                    --v1;
                }
            }

            if(v1 > 0 && v0 != 0) {
                v2 = this.pos;
            }

            v0 = v5.charValue();
        }
        while(v1 > 0);

        String v0_1 = v2 >= 0 ? this.queue.substring(v4, v2) : "";
        return v0_1;
    }

    public String chompTo(String arg2) {
        String v0 = this.consumeTo(arg2);
        this.matchChomp(arg2);
        return v0;
    }

    public String chompToIgnoreCase(String arg2) {
        String v0 = this.consumeToIgnoreCase(arg2);
        this.matchChomp(arg2);
        return v0;
    }

    public char consume() {
        String v0 = this.queue;
        int v1 = this.pos;
        this.pos = v1 + 1;
        return v0.charAt(v1);
    }

    public void consume(String arg3) {
        if(!this.matches(arg3)) {
            throw new IllegalStateException("Queue did not match expected sequence");
        }

        int v0 = arg3.length();
        if(v0 > this.remainingLength()) {
            throw new IllegalStateException("Queue not long enough to consume sequence");
        }

        this.pos = v0 + this.pos;
    }

    public String consumeAttributeKey() {
        int v0 = this.pos;
        while(!this.isEmpty()) {
            if(!this.matchesWord() && !this.matchesAny(new char[]{'-', '_', ':'})) {
                break;
            }

            ++this.pos;
        }

        return this.queue.substring(v0, this.pos);
    }

    public String consumeCssIdentifier() {
        int v0 = this.pos;
        while(!this.isEmpty()) {
            if(!this.matchesWord() && !this.matchesAny(new char[]{'-', '_'})) {
                break;
            }

            ++this.pos;
        }

        return this.queue.substring(v0, this.pos);
    }

    public String consumeElementSelector() {
        int v0 = this.pos;
        while(!this.isEmpty()) {
            if(!this.matchesWord() && !this.matchesAny(new char[]{'|', '_', '-'})) {
                break;
            }

            ++this.pos;
        }

        return this.queue.substring(v0, this.pos);
    }

    public String consumeTagName() {
        int v0 = this.pos;
        while(!this.isEmpty()) {
            if(!this.matchesWord() && !this.matchesAny(new char[]{':', '_', '-'})) {
                break;
            }

            ++this.pos;
        }

        return this.queue.substring(v0, this.pos);
    }

    public String consumeTo(String arg4) {
        String v0_1;
        int v0 = this.queue.indexOf(arg4, this.pos);
        if(v0 != -1) {
            v0_1 = this.queue.substring(this.pos, v0);
            this.pos += v0_1.length();
        }
        else {
            v0_1 = this.remainder();
        }

        return v0_1;
    }

    public String consumeToAny(String[] arg4) {
        int v0 = this.pos;
        while(!this.isEmpty()) {
            if(this.matchesAny(arg4)) {
                break;
            }

            ++this.pos;
        }

        return this.queue.substring(v0, this.pos);
    }

    public String consumeToIgnoreCase(String arg6) {
        int v0 = this.pos;
        String v1 = arg6.substring(0, 1);
        boolean v2 = v1.toLowerCase().equals(v1.toUpperCase());
        while(!this.isEmpty()) {
            if(this.matches(arg6)) {
                break;
            }

            if(v2) {
                int v3 = this.queue.indexOf(v1, this.pos) - this.pos;
                if(v3 == 0) {
                    ++this.pos;
                }
                else if(v3 < 0) {
                    this.pos = this.queue.length();
                }
                else {
                    this.pos = v3 + this.pos;
                }
            }
            else {
                ++this.pos;
            }
        }

        return this.queue.substring(v0, this.pos);
    }

    public boolean consumeWhitespace() {
        boolean v0;
        for(v0 = false; this.matchesWhitespace(); v0 = true) {
            ++this.pos;
        }

        return v0;
    }

    public String consumeWord() {
        int v0 = this.pos;
        while(this.matchesWord()) {
            ++this.pos;
        }

        return this.queue.substring(v0, this.pos);
    }

    public boolean isEmpty() {
        boolean v0 = this.remainingLength() == 0 ? true : false;
        return v0;
    }

    public boolean matchChomp(String arg3) {
        boolean v0;
        if(this.matches(arg3)) {
            this.pos += arg3.length();
            v0 = true;
        }
        else {
            v0 = false;
        }

        return v0;
    }

    public boolean matches(String arg7) {
        return this.queue.regionMatches(true, this.pos, arg7, 0, arg7.length());
    }

    public boolean matchesAny(char[] arg7) {
        boolean v0 = false;
        if(!this.isEmpty()) {
            int v2 = arg7.length;
            int v1 = 0;
            while(v1 < v2) {
                if(this.queue.charAt(this.pos) == arg7[v1]) {
                    v0 = true;
                }
                else {
                    ++v1;
                    continue;
                }

                return v0;
            }
        }

        return v0;
    }

    public boolean matchesAny(String[] arg5) {
        boolean v0 = false;
        int v2 = arg5.length;
        int v1 = 0;
        while(v1 < v2) {
            if(this.matches(arg5[v1])) {
                v0 = true;
            }
            else {
                ++v1;
                continue;
            }

            return v0;
        }

        return v0;
    }

    public boolean matchesCS(String arg3) {
        return this.queue.startsWith(arg3, this.pos);
    }

    public boolean matchesStartTag() {
        boolean v0 = this.remainingLength() < 2 || this.queue.charAt(this.pos) != 60 || !Character.isLetter(this.queue.charAt(this.pos + 1)) ? false : true;
        return v0;
    }

    public boolean matchesWhitespace() {
        boolean v0 = (this.isEmpty()) || !StringUtil.isWhitespace(this.queue.charAt(this.pos)) ? false : true;
        return v0;
    }

    public boolean matchesWord() {
        boolean v0 = (this.isEmpty()) || !Character.isLetterOrDigit(this.queue.charAt(this.pos)) ? false : true;
        return v0;
    }

    public char peek() {
        char v0 = this.isEmpty() ? '\u0000' : this.queue.charAt(this.pos);
        return v0;
    }

    public String remainder() {
        String v0 = this.queue.substring(this.pos, this.queue.length());
        this.pos = this.queue.length();
        return v0;
    }

    private int remainingLength() {
        return this.queue.length() - this.pos;
    }

    public String toString() {
        return this.queue.substring(this.pos);
    }

    public static String unescape(String arg7) {
        int v6 = 92;
        int v0 = 0;
        StringBuilder v3 = new StringBuilder();
        char[] v4 = arg7.toCharArray();
        int v5 = v4.length;
        int v1;
        for(v1 = 0; v0 < v5; v1 = v2) {
            char v2 = v4[v0];
            if(v2 != v6) {
                v3.append(v2);
            }
            else if(v1 != 0 && v1 == v6) {
                v3.append(v2);
            }

            ++v0;
        }

        return v3.toString();
    }
}

