// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.parser;

import org.jsoup.helper.Validate;
import org.jsoup.nodes.Entities;

class Tokeniser {
    private StringBuilder charBuffer;
    Token$Comment commentPending;
    StringBuilder dataBuffer;
    Token$Doctype doctypePending;
    private Token emitPending;
    private ParseErrorList errors;
    private boolean isEmitPending;
    private Token$StartTag lastStartTag;
    private CharacterReader reader;
    static final char replacementChar = '\uFFFD';
    private boolean selfClosingFlagAcknowledged;
    private TokeniserState state;
    Token$Tag tagPending;

    Tokeniser(CharacterReader arg2, ParseErrorList arg3) {
        super();
        this.state = TokeniserState.Data;
        this.isEmitPending = false;
        this.charBuffer = new StringBuilder();
        this.selfClosingFlagAcknowledged = true;
        this.reader = arg2;
        this.errors = arg3;
    }

    void acknowledgeSelfClosingFlag() {
        this.selfClosingFlagAcknowledged = true;
    }

    void advanceTransition(TokeniserState arg2) {
        this.reader.advance();
        this.state = arg2;
    }

    String appropriateEndTagName() {
        return this.lastStartTag.tagName;
    }

    private void characterReferenceError(String arg7) {
        if(this.errors.canAddError()) {
            this.errors.add(new ParseError(this.reader.pos(), "Invalid character reference: %s", new Object[]{arg7}));
        }
    }

    char[] consumeCharacterReference(Character arg8, boolean arg9) {
        int v0_3;
        boolean v5;
        int v4 = -1;
        char[] v1 = null;
        if(this.reader.isEmpty()) {
            char[] v0 = v1;
            return v0;
        }

        if(arg8 != null && arg8.charValue() == this.reader.current()) {
            return v1;
        }

        if(this.reader.matchesAny(new char[]{'\t', '\n', '\r', '\f', ' ', '<', '&'})) {
            return v1;
        }

        this.reader.mark();
        if(this.reader.matchConsume("#")) {
            v5 = this.reader.matchConsumeIgnoreCase("X");
            String v0_1 = v5 ? this.reader.consumeHexSequence() : this.reader.consumeDigitSequence();
            if(v0_1.length() == 0) {
                this.characterReferenceError("numeric reference with no numerals");
                this.reader.rewindToMark();
                return v1;
            }

            if(!this.reader.matchConsume(";")) {
                this.characterReferenceError("missing semicolon");
            }

            int v1_1 = v5 ? 16 : 10;
            try {
                v0_3 = Integer.valueOf(v0_1, v1_1).intValue();
            }
            catch(NumberFormatException v0_2) {
                v0_3 = v4;
            }

            if(v0_3 != v4 && (v0_3 < 55296 || v0_3 > 57343) && v0_3 <= 1114111) {
                return Character.toChars(v0_3);
            }

            this.characterReferenceError("character outside of valid range");
            return new char[]{'\uFFFD'};
        }

        String v4_1 = this.reader.consumeLetterThenDigitSequence();
        v5 = this.reader.matches(';');
        if(!Entities.isBaseNamedEntity(v4_1)) {
            if((Entities.isNamedEntity(v4_1)) && (v5)) {
                goto label_86;
            }

            v0_3 = 0;
        }
        else {
        label_86:
            v0_3 = 1;
        }

        if(v0_3 == 0) {
            this.reader.rewindToMark();
            if(v5) {
                this.characterReferenceError(String.format("invalid named referenece \'%s\'", v4_1));
            }

            return v1;
        }

        if((arg9) && ((this.reader.matchesLetter()) || (this.reader.matchesDigit()) || (this.reader.matchesAny(new char[]{'=', '-', '_'})))) {
            this.reader.rewindToMark();
            return v1;
        }

        if(!this.reader.matchConsume(";")) {
            this.characterReferenceError("missing semicolon");
        }

        return new char[]{Entities.getCharacterByName(v4_1).charValue()};
    }

    void createCommentPending() {
        this.commentPending = new Token$Comment();
    }

    void createDoctypePending() {
        this.doctypePending = new Token$Doctype();
    }

    Token$Tag createTagPending(boolean arg2) {
        Token$StartTag v0;
        if(arg2) {
            v0 = new Token$StartTag();
        }
        else {
            Token$EndTag v0_1 = new Token$EndTag();
        }

        this.tagPending = ((Token$Tag)v0);
        return this.tagPending;
    }

    void createTempBuffer() {
        this.dataBuffer = new StringBuilder();
    }

    boolean currentNodeInHtmlNS() {
        return 1;
    }

    void emit(Token arg3) {
        Validate.isFalse(this.isEmitPending, "There is an unread token pending!");
        this.emitPending = arg3;
        this.isEmitPending = true;
        if(arg3.type == Token$TokenType.StartTag) {
            this.lastStartTag = ((Token$StartTag)arg3);
            if(((Token$StartTag)arg3).selfClosing) {
                this.selfClosingFlagAcknowledged = false;
            }
        }
        else if(arg3.type == Token$TokenType.EndTag && ((Token$EndTag)arg3).attributes != null) {
            this.error("Attributes incorrectly present on end tag");
        }
    }

    void emit(char arg2) {
        this.charBuffer.append(arg2);
    }

    void emit(String arg2) {
        this.charBuffer.append(arg2);
    }

    void emit(char[] arg2) {
        this.charBuffer.append(arg2);
    }

    void emitCommentPending() {
        this.emit(this.commentPending);
    }

    void emitDoctypePending() {
        this.emit(this.doctypePending);
    }

    void emitTagPending() {
        this.tagPending.finaliseTag();
        this.emit(this.tagPending);
    }

    void eofError(TokeniserState arg7) {
        if(this.errors.canAddError()) {
            this.errors.add(new ParseError(this.reader.pos(), "Unexpectedly reached end of file (EOF) in input state [%s]", new Object[]{arg7}));
        }
    }

    private void error(String arg4) {
        if(this.errors.canAddError()) {
            this.errors.add(new ParseError(this.reader.pos(), arg4));
        }
    }

    void error(TokeniserState arg8) {
        if(this.errors.canAddError()) {
            this.errors.add(new ParseError(this.reader.pos(), "Unexpected character \'%s\' in input state [%s]", new Object[]{Character.valueOf(this.reader.current()), arg8}));
        }
    }

    TokeniserState getState() {
        return this.state;
    }

    boolean isAppropriateEndTagToken() {
        boolean v0 = this.lastStartTag == null ? false : this.tagPending.tagName.equals(this.lastStartTag.tagName);
        return v0;
    }

    Token read() {
        Token$Character v0;
        if(!this.selfClosingFlagAcknowledged) {
            this.error("Self closing flag not acknowledged");
            this.selfClosingFlagAcknowledged = true;
        }

        while(!this.isEmitPending) {
            this.state.read(this, this.reader);
        }

        if(this.charBuffer.length() > 0) {
            String v1 = this.charBuffer.toString();
            this.charBuffer.delete(0, this.charBuffer.length());
            v0 = new Token$Character(v1);
        }
        else {
            this.isEmitPending = false;
            Token v0_1 = this.emitPending;
        }

        return ((Token)v0);
    }

    void transition(TokeniserState arg1) {
        this.state = arg1;
    }

    String unescapeEntities(boolean arg5) {
        char v3 = '&';
        StringBuilder v0 = new StringBuilder();
        while(!this.reader.isEmpty()) {
            v0.append(this.reader.consumeTo(v3));
            if(!this.reader.matches(v3)) {
                continue;
            }

            this.reader.consume();
            char[] v1 = this.consumeCharacterReference(null, arg5);
            if(v1 != null && v1.length != 0) {
                v0.append(v1);
                continue;
            }

            v0.append(v3);
        }

        return v0.toString();
    }
}

