// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.safety;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Map$Entry;
import java.util.Set;
import org.jsoup.helper.Validate;
import org.jsoup.nodes.Attribute;
import org.jsoup.nodes.Attributes;
import org.jsoup.nodes.Element;

public class Whitelist {
    private Map attributes;
    private Map enforcedAttributes;
    private boolean preserveRelativeLinks;
    private Map protocols;
    private Set tagNames;

    public Whitelist() {
        super();
        this.tagNames = new HashSet();
        this.attributes = new HashMap();
        this.enforcedAttributes = new HashMap();
        this.protocols = new HashMap();
        this.preserveRelativeLinks = false;
    }

    public Whitelist addAttributes(String arg6, String[] arg7) {
        int v1 = 0;
        Validate.notEmpty(arg6);
        Validate.notNull(arg7);
        boolean v0 = arg7.length > 0 ? true : false;
        Validate.isTrue(v0, "No attributes supplied.");
        Whitelist$TagName v0_1 = Whitelist$TagName.valueOf(arg6);
        if(!this.tagNames.contains(v0_1)) {
            this.tagNames.add(v0_1);
        }

        HashSet v2 = new HashSet();
        int v3 = arg7.length;
        while(v1 < v3) {
            String v4 = arg7[v1];
            Validate.notEmpty(v4);
            ((Set)v2).add(Whitelist$AttributeKey.valueOf(v4));
            ++v1;
        }

        if(this.attributes.containsKey(v0_1)) {
            this.attributes.get(v0_1).addAll(((Collection)v2));
        }
        else {
            this.attributes.put(v0_1, v2);
        }

        return this;
    }

    public Whitelist addEnforcedAttribute(String arg5, String arg6, String arg7) {
        Validate.notEmpty(arg5);
        Validate.notEmpty(arg6);
        Validate.notEmpty(arg7);
        Whitelist$TagName v0 = Whitelist$TagName.valueOf(arg5);
        if(!this.tagNames.contains(v0)) {
            this.tagNames.add(v0);
        }

        Whitelist$AttributeKey v1 = Whitelist$AttributeKey.valueOf(arg6);
        Whitelist$AttributeValue v2 = Whitelist$AttributeValue.valueOf(arg7);
        if(this.enforcedAttributes.containsKey(v0)) {
            this.enforcedAttributes.get(v0).put(v1, v2);
        }
        else {
            HashMap v3 = new HashMap();
            ((Map)v3).put(v1, v2);
            this.enforcedAttributes.put(v0, v3);
        }

        return this;
    }

    public Whitelist addProtocols(String arg5, String arg6, String[] arg7) {
        Object v0;
        Validate.notEmpty(arg5);
        Validate.notEmpty(arg6);
        Validate.notNull(arg7);
        Whitelist$TagName v1 = Whitelist$TagName.valueOf(arg5);
        Whitelist$AttributeKey v2 = Whitelist$AttributeKey.valueOf(arg6);
        if(this.protocols.containsKey(v1)) {
            v0 = this.protocols.get(v1);
        }
        else {
            HashMap v0_1 = new HashMap();
            this.protocols.put(v1, v0_1);
        }

        if(((Map)v0).containsKey(v2)) {
            v0 = ((Map)v0).get(v2);
        }
        else {
            HashSet v1_1 = new HashSet();
            ((Map)v0).put(v2, v1_1);
            HashSet v0_2 = v1_1;
        }

        int v2_1 = arg7.length;
        int v1_2;
        for(v1_2 = 0; v1_2 < v2_1; ++v1_2) {
            String v3 = arg7[v1_2];
            Validate.notEmpty(v3);
            ((Set)v0).add(Whitelist$Protocol.valueOf(v3));
        }

        return this;
    }

    public Whitelist addTags(String[] arg5) {
        Validate.notNull(arg5);
        int v1 = arg5.length;
        int v0;
        for(v0 = 0; v0 < v1; ++v0) {
            String v2 = arg5[v0];
            Validate.notEmpty(v2);
            this.tagNames.add(Whitelist$TagName.valueOf(v2));
        }

        return this;
    }

    public static Whitelist basic() {
        return new Whitelist().addTags(new String[]{"a", "b", "blockquote", "br", "cite", "code", "dd", "dl", "dt", "em", "i", "li", "ol", "p", "pre", "q", "small", "strike", "strong", "sub", "sup", "u", "ul"}).addAttributes("a", new String[]{"href"}).addAttributes("blockquote", new String[]{"cite"}).addAttributes("q", new String[]{"cite"}).addProtocols("a", "href", new String[]{"ftp", "http", "https", "mailto"}).addProtocols("blockquote", "cite", new String[]{"http", "https"}).addProtocols("cite", "cite", new String[]{"http", "https"}).addEnforcedAttribute("a", "rel", "nofollow");
    }

    public static Whitelist basicWithImages() {
        return Whitelist.basic().addTags(new String[]{"img"}).addAttributes("img", new String[]{"align", "alt", "height", "src", "title", "width"}).addProtocols("img", "src", new String[]{"http", "https"});
    }

    Attributes getEnforcedAttributes(String arg5) {
        Attributes v2 = new Attributes();
        Whitelist$TagName v0 = Whitelist$TagName.valueOf(arg5);
        if(this.enforcedAttributes.containsKey(v0)) {
            Iterator v3 = this.enforcedAttributes.get(v0).entrySet().iterator();
            while(v3.hasNext()) {
                Object v0_1 = v3.next();
                v2.put(((Map$Entry)v0_1).getKey().toString(), ((Map$Entry)v0_1).getValue().toString());
            }
        }

        return v2;
    }

    protected boolean isSafeAttribute(String arg6, Element arg7, Attribute arg8) {
        boolean v2 = true;
        Whitelist$TagName v3 = Whitelist$TagName.valueOf(arg6);
        Whitelist$AttributeKey v4 = Whitelist$AttributeKey.valueOf(arg8.getKey());
        if(!this.attributes.containsKey(v3) || !this.attributes.get(v3).contains(v4)) {
            if(!arg6.equals(":all") && (this.isSafeAttribute(":all", arg7, arg8))) {
                return v2;
            }

            v2 = false;
        }
        else if(this.protocols.containsKey(v3)) {
            Object v0 = this.protocols.get(v3);
            boolean v0_1 = !((Map)v0).containsKey(v4) || (this.testValidProtocol(arg7, arg8, ((Map)v0).get(v4))) ? true : false;
            v2 = v0_1;
        }

        return v2;
    }

    protected boolean isSafeTag(String arg3) {
        return this.tagNames.contains(Whitelist$TagName.valueOf(arg3));
    }

    public static Whitelist none() {
        return new Whitelist();
    }

    public Whitelist preserveRelativeLinks(boolean arg1) {
        this.preserveRelativeLinks = arg1;
        return this;
    }

    public static Whitelist relaxed() {
        return new Whitelist().addTags(new String[]{"a", "b", "blockquote", "br", "caption", "cite", "code", "col", "colgroup", "dd", "div", "dl", "dt", "em", "h1", "h2", "h3", "h4", "h5", "h6", "i", "img", "li", "ol", "p", "pre", "q", "small", "strike", "strong", "sub", "sup", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "u", "ul"}).addAttributes("a", new String[]{"href", "title"}).addAttributes("blockquote", new String[]{"cite"}).addAttributes("col", new String[]{"span", "width"}).addAttributes("colgroup", new String[]{"span", "width"}).addAttributes("img", new String[]{"align", "alt", "height", "src", "title", "width"}).addAttributes("ol", new String[]{"start", "type"}).addAttributes("q", new String[]{"cite"}).addAttributes("table", new String[]{"summary", "width"}).addAttributes("td", new String[]{"abbr", "axis", "colspan", "rowspan", "width"}).addAttributes("th", new String[]{"abbr", "axis", "colspan", "rowspan", "scope", "width"}).addAttributes("ul", new String[]{"type"}).addProtocols("a", "href", new String[]{"ftp", "http", "https", "mailto"}).addProtocols("blockquote", "cite", new String[]{"http", "https"}).addProtocols("cite", "cite", new String[]{"http", "https"}).addProtocols("img", "src", new String[]{"http", "https"}).addProtocols("q", "cite", new String[]{"http", "https"});
    }

    public static Whitelist simpleText() {
        return new Whitelist().addTags(new String[]{"b", "em", "i", "strong", "u"});
    }

    private boolean testValidProtocol(Element arg5, Attribute arg6, Set arg7) {
        String v0 = arg5.absUrl(arg6.getKey());
        String v1 = v0.length() == 0 ? arg6.getValue() : v0;
        if(!this.preserveRelativeLinks) {
            arg6.setValue(v1);
        }

        Iterator v2 = arg7.iterator();
        do {
            if(v2.hasNext()) {
                if(!v1.toLowerCase().startsWith(v2.next().toString() + ":")) {
                    continue;
                }

                break;
            }
            else {
                return false;
            }
        }
        while(true);

        boolean v0_1 = true;
        return v0_1;
    }
}

