// Decompiled by JEB v1.5.201411100 - http://www.android-decompiler.com

package org.jsoup.select;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.jsoup.helper.StringUtil;
import org.jsoup.helper.Validate;
import org.jsoup.parser.TokenQueue;

class QueryParser {
    private static final String[] AttributeEvals;
    private static final Pattern NTH_AB;
    private static final Pattern NTH_B;
    private static final String[] combinators;
    private List evals;
    private String query;
    private TokenQueue tq;

    static {
        QueryParser.combinators = new String[]{",", ">", "+", "~", " "};
        QueryParser.AttributeEvals = new String[]{"=", "!=", "^=", "$=", "*=", "~="};
        QueryParser.NTH_AB = Pattern.compile("((\\+|-)?(\\d+)?)n(\\s*(\\+|-)?\\s*\\d+)?", 2);
        QueryParser.NTH_B = Pattern.compile("(\\+|-)?(\\d+)");
    }

    private QueryParser(String arg2) {
        super();
        this.evals = new ArrayList();
        this.query = arg2;
        this.tq = new TokenQueue(arg2);
    }

    private void allElements() {
        this.evals.add(new Evaluator$AllElements());
    }

    private void byAttribute() {
        TokenQueue v0 = new TokenQueue(this.tq.chompBalanced('[', ']'));
        String v1 = v0.consumeToAny(QueryParser.AttributeEvals);
        Validate.notEmpty(v1);
        v0.consumeWhitespace();
        if(v0.isEmpty()) {
            if(v1.startsWith("^")) {
                this.evals.add(new Evaluator$AttributeStarting(v1.substring(1)));
            }
            else {
                this.evals.add(new Evaluator$Attribute(v1));
            }
        }
        else if(v0.matchChomp("=")) {
            this.evals.add(new Evaluator$AttributeWithValue(v1, v0.remainder()));
        }
        else if(v0.matchChomp("!=")) {
            this.evals.add(new Evaluator$AttributeWithValueNot(v1, v0.remainder()));
        }
        else if(v0.matchChomp("^=")) {
            this.evals.add(new Evaluator$AttributeWithValueStarting(v1, v0.remainder()));
        }
        else if(v0.matchChomp("$=")) {
            this.evals.add(new Evaluator$AttributeWithValueEnding(v1, v0.remainder()));
        }
        else if(v0.matchChomp("*=")) {
            this.evals.add(new Evaluator$AttributeWithValueContaining(v1, v0.remainder()));
        }
        else if(v0.matchChomp("~=")) {
            this.evals.add(new Evaluator$AttributeWithValueMatching(v1, Pattern.compile(v0.remainder())));
        }
        else {
            goto label_82;
        }

        return;
    label_82:
        throw new Selector$SelectorParseException("Could not parse attribute query \'%s\': unexpected token at \'%s\'", new Object[]{this.query, v0.remainder()});
    }

    private void byClass() {
        String v0 = this.tq.consumeCssIdentifier();
        Validate.notEmpty(v0);
        this.evals.add(new Evaluator$Class(v0.trim().toLowerCase()));
    }

    private void byId() {
        String v0 = this.tq.consumeCssIdentifier();
        Validate.notEmpty(v0);
        this.evals.add(new Evaluator$Id(v0));
    }

    private void byTag() {
        String v0 = this.tq.consumeElementSelector();
        Validate.notEmpty(v0);
        if(v0.contains("|")) {
            v0 = v0.replace("|", ":");
        }

        this.evals.add(new Evaluator$Tag(v0.trim().toLowerCase()));
    }

    private void combinator(char arg11) {
        CombiningEvaluator$And v3;
        Evaluator[] v7_1;
        CombiningEvaluator$And v1_1;
        Object v1;
        int v2;
        Object v0;
        int v8 = 44;
        int v7 = 2;
        this.tq.consumeWhitespace();
        Evaluator v6 = QueryParser.parse(this.consumeSubQuery());
        if(this.evals.size() == 1) {
            v0 = this.evals.get(0);
            if(((v0 instanceof CombiningEvaluator$Or)) && arg11 != v8) {
                v2 = 1;
                v1 = v0;
                Evaluator v0_1 = v0.rightMostEvaluator();
                goto label_22;
            }

            v2 = 0;
            v1 = v0;
        }
        else {
            CombiningEvaluator$And v0_2 = new CombiningEvaluator$And(this.evals);
            v2 = 0;
            v1_1 = v0_2;
        }

    label_22:
        this.evals.clear();
        if(arg11 == 62) {
            v7_1 = new Evaluator[v7];
            v7_1[0] = v6;
            v7_1[1] = new StructuralEvaluator$ImmediateParent(((Evaluator)v0));
            v3 = new CombiningEvaluator$And(v7_1);
        }
        else if(arg11 == 32) {
            v7_1 = new Evaluator[v7];
            v7_1[0] = v6;
            v7_1[1] = new StructuralEvaluator$Parent(((Evaluator)v0));
            v3 = new CombiningEvaluator$And(v7_1);
        }
        else if(arg11 == 43) {
            v7_1 = new Evaluator[v7];
            v7_1[0] = v6;
            v7_1[1] = new StructuralEvaluator$ImmediatePreviousSibling(((Evaluator)v0));
            v3 = new CombiningEvaluator$And(v7_1);
        }
        else if(arg11 == 126) {
            v7_1 = new Evaluator[v7];
            v7_1[0] = v6;
            v7_1[1] = new StructuralEvaluator$PreviousSibling(((Evaluator)v0));
            v3 = new CombiningEvaluator$And(v7_1);
        }
        else if(arg11 == v8) {
            if((v0 instanceof CombiningEvaluator$Or)) {
                ((CombiningEvaluator$Or)v0).add(v6);
            }
            else {
                CombiningEvaluator$Or v3_1 = new CombiningEvaluator$Or();
                v3_1.add(((Evaluator)v0));
                v3_1.add(v6);
                CombiningEvaluator$Or v0_3 = v3_1;
            }

            Object v3_2 = v0;
        }
        else {
            goto label_91;
        }

        if(v2 != 0) {
            v1.replaceRightMostEvaluator(((Evaluator)v3));
        }
        else {
            v1_1 = v3;
        }

        this.evals.add(v1);
        return;
    label_91:
        throw new Selector$SelectorParseException("Unknown combinator: " + arg11, new Object[0]);
    }

    private int consumeIndex() {
        String v0 = this.tq.chompTo(")").trim();
        Validate.isTrue(StringUtil.isNumeric(v0), "Index must be numeric");
        return Integer.parseInt(v0);
    }

    private String consumeSubQuery() {
        StringBuilder v0 = new StringBuilder();
        while(!this.tq.isEmpty()) {
            if(this.tq.matches("(")) {
                v0.append("(").append(this.tq.chompBalanced('(', ')')).append(")");
                continue;
            }
            else if(this.tq.matches("[")) {
                v0.append("[").append(this.tq.chompBalanced('[', ']')).append("]");
                continue;
            }
            else if(!this.tq.matchesAny(QueryParser.combinators)) {
                v0.append(this.tq.consume());
                continue;
            }

            break;
        }

        return v0.toString();
    }

    private void contains(boolean arg4) {
        TokenQueue v1 = this.tq;
        String v0 = arg4 ? ":containsOwn" : ":contains";
        v1.consume(v0);
        v0 = TokenQueue.unescape(this.tq.chompBalanced('(', ')'));
        Validate.notEmpty(v0, ":contains(text) query must not be empty");
        if(arg4) {
            this.evals.add(new Evaluator$ContainsOwnText(v0));
        }
        else {
            this.evals.add(new Evaluator$ContainsText(v0));
        }
    }

    private void cssNthChild(boolean arg10, boolean arg11) {
        int v7 = 4;
        int v2 = 2;
        int v0 = 1;
        int v1 = 0;
        String v3 = this.tq.chompTo(")").trim().toLowerCase();
        Matcher v4 = QueryParser.NTH_AB.matcher(((CharSequence)v3));
        Matcher v5 = QueryParser.NTH_B.matcher(((CharSequence)v3));
        if("odd".equals(v3)) {
            v1 = 1;
            v0 = v2;
        }
        else if("even".equals(v3)) {
            v0 = v2;
        }
        else if(v4.matches()) {
            if(v4.group(3) != null) {
                v0 = Integer.parseInt(v4.group(1).replaceFirst("^\\+", ""));
            }

            if(v4.group(v7) == null) {
                goto label_18;
            }

            v1 = Integer.parseInt(v4.group(v7).replaceFirst("^\\+", ""));
        }
        else {
            if(!v5.matches()) {
                goto label_59;
            }

            v0 = 0;
            v1 = Integer.parseInt(v5.group().replaceFirst("^\\+", ""));
        }

    label_18:
        if(arg11) {
            if(arg10) {
                this.evals.add(new Evaluator$IsNthLastOfType(v0, v1));
            }
            else {
                this.evals.add(new Evaluator$IsNthOfType(v0, v1));
            }
        }
        else if(arg10) {
            this.evals.add(new Evaluator$IsNthLastChild(v0, v1));
        }
        else {
            this.evals.add(new Evaluator$IsNthChild(v0, v1));
        }

        return;
    label_59:
        throw new Selector$SelectorParseException("Could not parse nth-index \'%s\': unexpected format", new Object[]{v3});
    }

    private void findElements() {
        if(this.tq.matchChomp("#")) {
            this.byId();
        }
        else if(this.tq.matchChomp(".")) {
            this.byClass();
        }
        else if(this.tq.matchesWord()) {
            this.byTag();
        }
        else if(this.tq.matches("[")) {
            this.byAttribute();
        }
        else if(this.tq.matchChomp("*")) {
            this.allElements();
        }
        else if(this.tq.matchChomp(":lt(")) {
            this.indexLessThan();
        }
        else if(this.tq.matchChomp(":gt(")) {
            this.indexGreaterThan();
        }
        else if(this.tq.matchChomp(":eq(")) {
            this.indexEquals();
        }
        else if(this.tq.matches(":has(")) {
            this.has();
        }
        else if(this.tq.matches(":contains(")) {
            this.contains(false);
        }
        else if(this.tq.matches(":containsOwn(")) {
            this.contains(true);
        }
        else if(this.tq.matches(":matches(")) {
            this.matches(false);
        }
        else if(this.tq.matches(":matchesOwn(")) {
            this.matches(true);
        }
        else if(this.tq.matches(":not(")) {
            this.not();
        }
        else if(this.tq.matchChomp(":nth-child(")) {
            this.cssNthChild(false, false);
        }
        else if(this.tq.matchChomp(":nth-last-child(")) {
            this.cssNthChild(true, false);
        }
        else if(this.tq.matchChomp(":nth-of-type(")) {
            this.cssNthChild(false, true);
        }
        else if(this.tq.matchChomp(":nth-last-of-type(")) {
            this.cssNthChild(true, true);
        }
        else if(this.tq.matchChomp(":first-child")) {
            this.evals.add(new Evaluator$IsFirstChild());
        }
        else if(this.tq.matchChomp(":last-child")) {
            this.evals.add(new Evaluator$IsLastChild());
        }
        else if(this.tq.matchChomp(":first-of-type")) {
            this.evals.add(new Evaluator$IsFirstOfType());
        }
        else if(this.tq.matchChomp(":last-of-type")) {
            this.evals.add(new Evaluator$IsLastOfType());
        }
        else if(this.tq.matchChomp(":only-child")) {
            this.evals.add(new Evaluator$IsOnlyChild());
        }
        else if(this.tq.matchChomp(":only-of-type")) {
            this.evals.add(new Evaluator$IsOnlyOfType());
        }
        else if(this.tq.matchChomp(":empty")) {
            this.evals.add(new Evaluator$IsEmpty());
        }
        else if(this.tq.matchChomp(":root")) {
            this.evals.add(new Evaluator$IsRoot());
        }
        else {
            goto label_181;
        }

        return;
    label_181:
        throw new Selector$SelectorParseException("Could not parse query \'%s\': unexpected token at \'%s\'", new Object[]{this.query, this.tq.remainder()});
    }

    private void has() {
        this.tq.consume(":has");
        String v0 = this.tq.chompBalanced('(', ')');
        Validate.notEmpty(v0, ":has(el) subselect must not be empty");
        this.evals.add(new StructuralEvaluator$Has(QueryParser.parse(v0)));
    }

    private void indexEquals() {
        this.evals.add(new Evaluator$IndexEquals(this.consumeIndex()));
    }

    private void indexGreaterThan() {
        this.evals.add(new Evaluator$IndexGreaterThan(this.consumeIndex()));
    }

    private void indexLessThan() {
        this.evals.add(new Evaluator$IndexLessThan(this.consumeIndex()));
    }

    private void matches(boolean arg4) {
        TokenQueue v1 = this.tq;
        String v0 = arg4 ? ":matchesOwn" : ":matches";
        v1.consume(v0);
        v0 = this.tq.chompBalanced('(', ')');
        Validate.notEmpty(v0, ":matches(regex) query must not be empty");
        if(arg4) {
            this.evals.add(new Evaluator$MatchesOwn(Pattern.compile(v0)));
        }
        else {
            this.evals.add(new Evaluator$Matches(Pattern.compile(v0)));
        }
    }

    private void not() {
        this.tq.consume(":not");
        String v0 = this.tq.chompBalanced('(', ')');
        Validate.notEmpty(v0, ":not(selector) subselect must not be empty");
        this.evals.add(new StructuralEvaluator$Not(QueryParser.parse(v0)));
    }

    public static Evaluator parse(String arg1) {
        return new QueryParser(arg1).parse();
    }

    Evaluator parse() {
        Object v0_1;
        this.tq.consumeWhitespace();
        if(this.tq.matchesAny(QueryParser.combinators)) {
            this.evals.add(new StructuralEvaluator$Root());
            this.combinator(this.tq.consume());
        }
        else {
            this.findElements();
        }

        while(!this.tq.isEmpty()) {
            boolean v0 = this.tq.consumeWhitespace();
            if(this.tq.matchesAny(QueryParser.combinators)) {
                this.combinator(this.tq.consume());
                continue;
            }

            if(v0) {
                this.combinator(' ');
                continue;
            }

            this.findElements();
        }

        if(this.evals.size() == 1) {
            v0_1 = this.evals.get(0);
        }
        else {
            CombiningEvaluator$And v0_2 = new CombiningEvaluator$And(this.evals);
        }

        return ((Evaluator)v0_1);
    }
}

